/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/charCode","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/base/common/arrays","vs/base/common/strings","vs/base/common/arraysFind","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/uint","vs/editor/common/core/lineRange","vs/base/common/map","vs/base/common/platform","vs/base/common/objects","vs/base/common/uri","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/diff/diff","vs/editor/common/core/characterClassifier","vs/editor/common/core/textLength","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/marshallingIds","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/base/common/hash","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/positionToOffset","vs/editor/common/core/textEdit","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/encodedTokenAttributes","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(x){for(var i=[],t=0,n=x.length;t<n;t++)i[t]=ie[x[t]];return i};const Je=this,Qe=typeof global=="object"?global:{};var Le;(function(x){x.global=Je;class i{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=i._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof x.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}x.Environment=i})(Le||(Le={}));var Le;(function(x){class i{constructor(h,N,m){this.type=h,this.detail=N,this.timestamp=m}}x.LoaderEvent=i;class t{constructor(h){this._events=[new i(1,"",h)]}record(h,N){this._events.push(new i(h,N,x.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}x.LoaderEventRecorder=t;class n{record(h,N){}getEvents(){return[]}}n.INSTANCE=new n,x.NullLoaderEventRecorder=n})(Le||(Le={}));var Le;(function(x){class i{static fileUriToFilePath(n,p){if(p=decodeURI(p).replace(/%23/g,"#"),n){if(/^file:\/\/\//.test(p))return p.substr(8);if(/^file:\/\//.test(p))return p.substr(5)}else if(/^file:\/\//.test(p))return p.substr(7);return p}static startsWith(n,p){return n.length>=p.length&&n.substr(0,p.length)===p}static endsWith(n,p){return n.length>=p.length&&n.substr(n.length-p.length)===p}static containsQueryString(n){return/^[^\#]*\?/gi.test(n)}static isAbsolutePath(n){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(n)}static forEachProperty(n,p){if(n){let h;for(h in n)n.hasOwnProperty(h)&&p(h,n[h])}}static isEmpty(n){let p=!0;return i.forEachProperty(n,()=>{p=!1}),p}static recursiveClone(n){if(!n||typeof n!="object"||n instanceof RegExp||!Array.isArray(n)&&Object.getPrototypeOf(n)!==Object.prototype)return n;let p=Array.isArray(n)?[]:{};return i.forEachProperty(n,(h,N)=>{N&&typeof N=="object"?p[h]=i.recursiveClone(N):p[h]=N}),p}static generateAnonymousModule(){return"===anonymous"+i.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(n){return i.startsWith(n,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=x.global.performance&&typeof x.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?x.global.performance.now():Date.now()}}i.NEXT_ANONYMOUS_ID=1,i.PERFORMANCE_NOW_PROBED=!1,i.HAS_PERFORMANCE_NOW=!1,x.Utilities=i})(Le||(Le={}));var Le;(function(x){function i(p){if(p instanceof Error)return p;const h=new Error(p.message||String(p)||"Unknown Error");return p.stack&&(h.stack=p.stack),h}x.ensureError=i;class t{static validateConfigurationOptions(h){function N(m){if(m.phase==="loading"){console.error('Loading "'+m.moduleId+'" failed'),console.error(m),console.error("Here are the modules that depend on it:"),console.error(m.neededBy);return}if(m.phase==="factory"){console.error('The factory function of "'+m.moduleId+'" has thrown an exception'),console.error(m),console.error("Here are the modules that depend on it:"),console.error(m.neededBy);return}}if(h=h||{},typeof h.baseUrl!="string"&&(h.baseUrl=""),typeof h.isBuild!="boolean"&&(h.isBuild=!1),typeof h.paths!="object"&&(h.paths={}),typeof h.config!="object"&&(h.config={}),typeof h.catchError>"u"&&(h.catchError=!1),typeof h.recordStats>"u"&&(h.recordStats=!1),typeof h.urlArgs!="string"&&(h.urlArgs=""),typeof h.onError!="function"&&(h.onError=N),Array.isArray(h.ignoreDuplicateModules)||(h.ignoreDuplicateModules=[]),h.baseUrl.length>0&&(x.Utilities.endsWith(h.baseUrl,"/")||(h.baseUrl+="/")),typeof h.cspNonce!="string"&&(h.cspNonce=""),typeof h.preferScriptTags>"u"&&(h.preferScriptTags=!1),h.nodeCachedData&&typeof h.nodeCachedData=="object"&&(typeof h.nodeCachedData.seed!="string"&&(h.nodeCachedData.seed="seed"),(typeof h.nodeCachedData.writeDelay!="number"||h.nodeCachedData.writeDelay<0)&&(h.nodeCachedData.writeDelay=1e3*7),!h.nodeCachedData.path||typeof h.nodeCachedData.path!="string")){const m=i(new Error("INVALID cached data configuration, 'path' MUST be set"));m.phase="configuration",h.onError(m),h.nodeCachedData=void 0}return h}static mergeConfigurationOptions(h=null,N=null){let m=x.Utilities.recursiveClone(N||{});return x.Utilities.forEachProperty(h,(a,u)=>{a==="ignoreDuplicateModules"&&typeof m.ignoreDuplicateModules<"u"?m.ignoreDuplicateModules=m.ignoreDuplicateModules.concat(u):a==="paths"&&typeof m.paths<"u"?x.Utilities.forEachProperty(u,(f,$)=>m.paths[f]=$):a==="config"&&typeof m.config<"u"?x.Utilities.forEachProperty(u,(f,$)=>m.config[f]=$):m[a]=x.Utilities.recursiveClone(u)}),t.validateConfigurationOptions(m)}}x.ConfigurationOptionsUtil=t;class n{constructor(h,N){if(this._env=h,this.options=t.mergeConfigurationOptions(N),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let m=this.options.nodeRequire.main.filename,a=Math.max(m.lastIndexOf("/"),m.lastIndexOf("\\"));this.options.baseUrl=m.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let h=0;h<this.options.ignoreDuplicateModules.length;h++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[h]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],x.Utilities.forEachProperty(this.options.paths,(h,N)=>{Array.isArray(N)?this.sortedPathsRules.push({from:h,to:N}):this.sortedPathsRules.push({from:h,to:[N]})}),this.sortedPathsRules.sort((h,N)=>N.from.length-h.from.length)}cloneAndMerge(h){return new n(this._env,t.mergeConfigurationOptions(h,this.options))}getOptionsLiteral(){return this.options}_applyPaths(h){let N;for(let m=0,a=this.sortedPathsRules.length;m<a;m++)if(N=this.sortedPathsRules[m],x.Utilities.startsWith(h,N.from)){let u=[];for(let f=0,$=N.to.length;f<$;f++)u.push(N.to[f]+h.substr(N.from.length));return u}return[h]}_addUrlArgsToUrl(h){return x.Utilities.containsQueryString(h)?h+"&"+this.options.urlArgs:h+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(h){return this.options.urlArgs?this._addUrlArgsToUrl(h):h}_addUrlArgsIfNecessaryToUrls(h){if(this.options.urlArgs)for(let N=0,m=h.length;N<m;N++)h[N]=this._addUrlArgsToUrl(h[N]);return h}moduleIdToPaths(h){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(h))return this.isBuild()?["empty:"]:["node|"+h];let N=h,m;if(!x.Utilities.endsWith(N,".js")&&!x.Utilities.isAbsolutePath(N)){m=this._applyPaths(N);for(let a=0,u=m.length;a<u;a++)this.isBuild()&&m[a]==="empty:"||(x.Utilities.isAbsolutePath(m[a])||(m[a]=this.options.baseUrl+m[a]),!x.Utilities.endsWith(m[a],".js")&&!x.Utilities.containsQueryString(m[a])&&(m[a]=m[a]+".js"))}else!x.Utilities.endsWith(N,".js")&&!x.Utilities.containsQueryString(N)&&(N=N+".js"),m=[N];return this._addUrlArgsIfNecessaryToUrls(m)}requireToUrl(h){let N=h;return x.Utilities.isAbsolutePath(N)||(N=this._applyPaths(N)[0],x.Utilities.isAbsolutePath(N)||(N=this.options.baseUrl+N)),this._addUrlArgsIfNecessaryToUrl(N)}isBuild(){return this.options.isBuild}shouldInvokeFactory(h){return!!(!this.options.isBuild||x.Utilities.isAnonymousModule(h)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[h])}isDuplicateMessageIgnoredFor(h){return this.ignoreDuplicateModulesMap.hasOwnProperty(h)}getConfigForModule(h){if(this.options.config)return this.options.config[h]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(h){this.options.onError(h)}}x.Configuration=n})(Le||(Le={}));var Le;(function(x){class i{constructor(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}load(u,f,$,g){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new p;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=u.getConfig().getOptionsLiteral();e?this._scriptLoader=new t:this._scriptLoader=new h(this._env)}else this._env.isNode?this._scriptLoader=new h(this._env):this._scriptLoader=new t;let d={callback:$,errorback:g};if(this._callbackMap.hasOwnProperty(f)){this._callbackMap[f].push(d);return}this._callbackMap[f]=[d],this._scriptLoader.load(u,f,()=>this.triggerCallback(f),e=>this.triggerErrorback(f,e))}triggerCallback(u){let f=this._callbackMap[u];delete this._callbackMap[u];for(let $=0;$<f.length;$++)f[$].callback()}triggerErrorback(u,f){let $=this._callbackMap[u];delete this._callbackMap[u];for(let g=0;g<$.length;g++)$[g].errorback(f)}}class t{attachListeners(u,f,$){let g=()=>{u.removeEventListener("load",d),u.removeEventListener("error",e)},d=w=>{g(),f()},e=w=>{g(),$(w)};u.addEventListener("load",d),u.addEventListener("error",e)}load(u,f,$,g){if(/^node\|/.test(f)){let d=u.getConfig().getOptionsLiteral(),e=N(u.getRecorder(),d.nodeRequire||x.global.nodeRequire),w=f.split("|"),L=null;try{L=e(w[1])}catch(A){g(A);return}u.enqueueDefineAnonymousModule([],()=>L),$()}else{let d=document.createElement("script");d.setAttribute("async","async"),d.setAttribute("type","text/javascript"),this.attachListeners(d,$,g);const{trustedTypesPolicy:e}=u.getConfig().getOptionsLiteral();e&&(f=e.createScriptURL(f)),d.setAttribute("src",f);const{cspNonce:w}=u.getConfig().getOptionsLiteral();w&&d.setAttribute("nonce",w),document.getElementsByTagName("head")[0].appendChild(d)}}}function n(a){const{trustedTypesPolicy:u}=a.getConfig().getOptionsLiteral();try{return(u?self.eval(u.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class p{constructor(){this._cachedCanUseEval=null}_canUseEval(u){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=n(u)),this._cachedCanUseEval}load(u,f,$,g){if(/^node\|/.test(f)){const d=u.getConfig().getOptionsLiteral(),e=N(u.getRecorder(),d.nodeRequire||x.global.nodeRequire),w=f.split("|");let L=null;try{L=e(w[1])}catch(A){g(A);return}u.enqueueDefineAnonymousModule([],function(){return L}),$()}else{const{trustedTypesPolicy:d}=u.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(f)&&f.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(u)){fetch(f).then(w=>{if(w.status!==200)throw new Error(w.statusText);return w.text()}).then(w=>{w=`${w}
//# sourceURL=${f}`,(d?self.eval(d.createScript("",w)):new Function(w)).call(self),$()}).then(void 0,g);return}try{d&&(f=d.createScriptURL(f)),importScripts(f),$()}catch(w){g(w)}}}}class h{constructor(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))}_initNodeRequire(u,f){const{nodeCachedData:$}=f.getConfig().getOptionsLiteral();if(!$||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const g=this,d=u("module");function e(w){const L=w.constructor;let A=function(E){try{return w.require(E)}finally{}};return A.resolve=function(E,R){return L._resolveFilename(E,w,!1,R)},A.resolve.paths=function(E){return L._resolveLookupPaths(E,w)},A.main=process.mainModule,A.extensions=L._extensions,A.cache=L._cache,A}d.prototype._compile=function(w,L){const A=d.wrap(w.replace(/^#!.*/,"")),v=f.getRecorder(),E=g._getCachedDataPath($,L),R={filename:L};let b;try{const T=g._fs.readFileSync(E);b=T.slice(0,16),R.cachedData=T.slice(16),v.record(60,E)}catch{v.record(61,E)}const o=new g._vm.Script(A,R),r=o.runInThisContext(R),l=g._path.dirname(L),c=e(this),M=[this.exports,c,this,L,l,process,Qe,Buffer],_=r.apply(this.exports,M);return g._handleCachedData(o,A,E,!R.cachedData,f),g._verifyCachedData(o,A,E,b,f),_}}load(u,f,$,g){const d=u.getConfig().getOptionsLiteral(),e=N(u.getRecorder(),d.nodeRequire||x.global.nodeRequire),w=d.nodeInstrumenter||function(A){return A};this._init(e),this._initNodeRequire(e,u);let L=u.getRecorder();if(/^node\|/.test(f)){let A=f.split("|"),v=null;try{v=e(A[1])}catch(E){g(E);return}u.enqueueDefineAnonymousModule([],()=>v),$()}else{f=x.Utilities.fileUriToFilePath(this._env.isWindows,f);const A=this._path.normalize(f),v=this._getElectronRendererScriptPathOrUri(A),E=!!d.nodeCachedData,R=E?this._getCachedDataPath(d.nodeCachedData,f):void 0;this._readSourceAndCachedData(A,R,L,(b,o,r,l)=>{if(b){g(b);return}let c;o.charCodeAt(0)===h._BOM?c=h._PREFIX+o.substring(1)+h._SUFFIX:c=h._PREFIX+o+h._SUFFIX,c=w(c,A);const M={filename:v,cachedData:r},_=this._createAndEvalScript(u,c,M,$,g);this._handleCachedData(_,c,R,E&&!r,u),this._verifyCachedData(_,c,R,l,u)})}}_createAndEvalScript(u,f,$,g,d){const e=u.getRecorder();e.record(31,$.filename);const w=new this._vm.Script(f,$),L=w.runInThisContext($),A=u.getGlobalAMDDefineFunc();let v=!1;const E=function(){return v=!0,A.apply(null,arguments)};return E.amd=A.amd,L.call(x.global,u.getGlobalAMDRequireFunc(),E,$.filename,this._path.dirname($.filename)),e.record(32,$.filename),v?g():d(new Error(`Didn't receive define call in ${$.filename}!`)),w}_getElectronRendererScriptPathOrUri(u){if(!this._env.isElectronRenderer)return u;let f=u.match(/^([a-z])\:(.*)/i);return f?`file:///${(f[1].toUpperCase()+":"+f[2]).replace(/\\/g,"/")}`:`file://${u}`}_getCachedDataPath(u,f){const $=this._crypto.createHash("md5").update(f,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),g=this._path.basename(f).replace(/\.js$/,"");return this._path.join(u.path,`${g}-${$}.code`)}_handleCachedData(u,f,$,g,d){u.cachedDataRejected?this._fs.unlink($,e=>{d.getRecorder().record(62,$),this._createAndWriteCachedData(u,f,$,d),e&&d.getConfig().onError(e)}):g&&this._createAndWriteCachedData(u,f,$,d)}_createAndWriteCachedData(u,f,$,g){let d=Math.ceil(g.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,w=0,L;const A=()=>{setTimeout(()=>{L||(L=this._crypto.createHash("md5").update(f,"utf8").digest());const v=u.createCachedData();if(!(v.length===0||v.length===e||w>=5)){if(v.length<e){A();return}e=v.length,this._fs.writeFile($,Buffer.concat([L,v]),E=>{E&&g.getConfig().onError(E),g.getRecorder().record(63,$),A()})}},d*Math.pow(4,w++))};A()}_readSourceAndCachedData(u,f,$,g){if(!f)this._fs.readFile(u,{encoding:"utf8"},g);else{let d,e,w,L=2;const A=v=>{v?g(v):--L===0&&g(void 0,d,e,w)};this._fs.readFile(u,{encoding:"utf8"},(v,E)=>{d=E,A(v)}),this._fs.readFile(f,(v,E)=>{!v&&E&&E.length>0?(w=E.slice(0,16),e=E.slice(16),$.record(60,f)):$.record(61,f),A()})}}_verifyCachedData(u,f,$,g,d){g&&(u.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(f,"utf8").digest();g.equals(e)||(d.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${$}' now, but a RESTART IS REQUIRED`)),this._fs.unlink($,w=>{w&&d.getConfig().onError(w)}))},Math.ceil(5e3*(1+Math.random()))))}}h._BOM=65279,h._PREFIX="(function (require, define, __filename, __dirname) { ",h._SUFFIX=`
});`;function N(a,u){if(u.__$__isRecorded)return u;const f=function(g){a.record(33,g);try{return u(g)}finally{a.record(34,g)}};return f.__$__isRecorded=!0,f}x.ensureRecordedNodeRequire=N;function m(a){return new i(a)}x.createScriptLoader=m})(Le||(Le={}));var Le;(function(x){class i{constructor(a){let u=a.lastIndexOf("/");u!==-1?this.fromModulePath=a.substr(0,u+1):this.fromModulePath=""}static _normalizeModuleId(a){let u=a,f;for(f=/\/\.\//;f.test(u);)u=u.replace(f,"/");for(u=u.replace(/^\.\//g,""),f=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;f.test(u);)u=u.replace(f,"/");return u=u.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),u}resolveModule(a){let u=a;return x.Utilities.isAbsolutePath(u)||(x.Utilities.startsWith(u,"./")||x.Utilities.startsWith(u,"../"))&&(u=i._normalizeModuleId(this.fromModulePath+u)),u}}i.ROOT=new i(""),x.ModuleIdResolver=i;class t{constructor(a,u,f,$,g,d){this.id=a,this.strId=u,this.dependencies=f,this._callback=$,this._errorback=g,this.moduleIdResolver=d,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,u){try{return{returnedValue:a.apply(x.global,u),producedError:null}}catch(f){return{returnedValue:null,producedError:f}}}static _invokeFactory(a,u,f,$){return a.shouldInvokeFactory(u)?a.shouldCatchError()?this._safeInvokeFunction(f,$):{returnedValue:f.apply(x.global,$),producedError:null}:{returnedValue:null,producedError:null}}complete(a,u,f,$){this._isComplete=!0;let g=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let d=t._invokeFactory(u,this.strId,this._callback,f);g=d.producedError,a.record(22,this.strId),!g&&typeof d.returnedValue<"u"&&(!this.exportsPassedIn||x.Utilities.isEmpty(this.exports))&&(this.exports=d.returnedValue)}else this.exports=this._callback;if(g){let d=x.ensureError(g);d.phase="factory",d.moduleId=this.strId,d.neededBy=$(this.id),this.error=d,u.onError(d)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}x.Module=t;class n{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let u=this._strModuleIdToIntModuleId.get(a);return typeof u>"u"&&(u=this._nextId++,this._strModuleIdToIntModuleId.set(a,u),this._intModuleIdToStrModuleId[u]=a),u}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class p{constructor(a){this.id=a}}p.EXPORTS=new p(0),p.MODULE=new p(1),p.REQUIRE=new p(2),x.RegularDependency=p;class h{constructor(a,u,f){this.id=a,this.pluginId=u,this.pluginParam=f}}x.PluginDependency=h;class N{constructor(a,u,f,$,g=0){this._env=a,this._scriptLoader=u,this._loaderAvailableTimestamp=g,this._defineFunc=f,this._requireFunc=$,this._moduleIdProvider=new n,this._config=new x.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new N(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,u){let f=d=>d.replace(/\\/g,"/"),$=f(a),g=u.split(/\n/);for(let d=0;d<g.length;d++){let e=g[d].match(/(.*):(\d+):(\d+)\)?$/);if(e){let w=e[1],L=e[2],A=e[3],v=Math.max(w.lastIndexOf(" ")+1,w.lastIndexOf("(")+1);if(w=w.substr(v),w=f(w),w===$){let E={line:parseInt(L,10),col:parseInt(A,10)};return E.line===1&&(E.col-=53),E}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],u=0;for(let f=0,$=this._modules2.length;f<$;f++){let g=this._modules2[f];if(!g)continue;let d=this._buildInfoPath[g.id]||null,e=this._buildInfoDefineStack[g.id]||null,w=this._buildInfoDependencies[g.id];a[u++]={id:g.strId,path:d,defineLocation:d&&e?N._findRelevantLocationInStack(d,e):null,dependencies:w,shim:null,exports:g.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new x.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=x.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,u){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let f=null;this._config.isBuild()&&(f=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:f,dependencies:a,callback:u}}defineModule(a,u,f,$,g,d=new i(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let w=new t(e,a,this._normalizeDependencies(u,d),f,$,d);this._modules2[e]=w,this._config.isBuild()&&(this._buildInfoDefineStack[e]=g,this._buildInfoDependencies[e]=(w.dependencies||[]).map(L=>this._moduleIdProvider.getStrModuleId(L.id))),this._resolve(w)}_normalizeDependency(a,u){if(a==="exports")return p.EXPORTS;if(a==="module")return p.MODULE;if(a==="require")return p.REQUIRE;let f=a.indexOf("!");if(f>=0){let $=u.resolveModule(a.substr(0,f)),g=u.resolveModule(a.substr(f+1)),d=this._moduleIdProvider.getModuleId($+"!"+g),e=this._moduleIdProvider.getModuleId($);return new h(d,e,g)}return new p(this._moduleIdProvider.getModuleId(u.resolveModule(a)))}_normalizeDependencies(a,u){let f=[],$=0;for(let g=0,d=a.length;g<d;g++)f[$++]=this._normalizeDependency(a[g],u);return f}_relativeRequire(a,u,f,$){if(typeof u=="string")return this.synchronousRequire(u,a);this.defineModule(x.Utilities.generateAnonymousModule(),u,f,$,null,a)}synchronousRequire(a,u=new i(a)){let f=this._normalizeDependency(a,u),$=this._modules2[f.id];if(!$)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!$.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if($.error)throw $.error;return $.exports}configure(a,u){let f=this._config.shouldRecordStats();u?this._config=new x.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!f&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let u=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),u.dependencies,u.callback,null,u.stack)}}_createLoadError(a,u){let f=this._moduleIdProvider.getStrModuleId(a),$=(this._inverseDependencies2[a]||[]).map(d=>this._moduleIdProvider.getStrModuleId(d));const g=x.ensureError(u);return g.phase="loading",g.moduleId=f,g.neededBy=$,g}_onLoadError(a,u){const f=this._createLoadError(a,u);this._modules2[a]||(this._modules2[a]=new t(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let $=[];for(let e=0,w=this._moduleIdProvider.getMaxModuleId();e<w;e++)$[e]=!1;let g=!1,d=[];for(d.push(a),$[a]=!0;d.length>0;){let e=d.shift(),w=this._modules2[e];w&&(g=w.onDependencyError(f)||g);let L=this._inverseDependencies2[e];if(L)for(let A=0,v=L.length;A<v;A++){let E=L[A];$[E]||(d.push(E),$[E]=!0)}}g||this._config.onError(f)}_hasDependencyPath(a,u){let f=this._modules2[a];if(!f)return!1;let $=[];for(let d=0,e=this._moduleIdProvider.getMaxModuleId();d<e;d++)$[d]=!1;let g=[];for(g.push(f),$[a]=!0;g.length>0;){let e=g.shift().dependencies;if(e)for(let w=0,L=e.length;w<L;w++){let A=e[w];if(A.id===u)return!0;let v=this._modules2[A.id];v&&!$[A.id]&&($[A.id]=!0,g.push(v))}}return!1}_findCyclePath(a,u,f){if(a===u||f===50)return[a];let $=this._modules2[a];if(!$)return null;let g=$.dependencies;if(g)for(let d=0,e=g.length;d<e;d++){let w=this._findCyclePath(g[d].id,u,f+1);if(w!==null)return w.push(a),w}return null}_createRequire(a){let u=(f,$,g)=>this._relativeRequire(a,f,$,g);return u.toUrl=f=>this._config.requireToUrl(a.resolveModule(f)),u.getStats=()=>this.getLoaderEvents(),u.hasDependencyCycle=()=>this._hasDependencyCycle,u.config=(f,$=!1)=>{this.configure(f,$)},u.__$__nodeRequire=x.global.nodeRequire,u}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let u=this._moduleIdProvider.getStrModuleId(a),f=this._config.moduleIdToPaths(u),$=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(u.indexOf("/")===-1||$.test(u))&&f.push("node|"+u);let g=-1,d=e=>{if(g++,g>=f.length)this._onLoadError(a,e);else{let w=f[g],L=this.getRecorder();if(this._config.isBuild()&&w==="empty:"){this._buildInfoPath[a]=w,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}L.record(10,w),this._scriptLoader.load(this,w,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=w),L.record(11,w),this._onLoad(a)},A=>{L.record(12,w),d(A)})}};d(null)}_loadPluginDependency(a,u){if(this._modules2[u.id]||this._knownModules2[u.id])return;this._knownModules2[u.id]=!0;let f=$=>{this.defineModule(this._moduleIdProvider.getStrModuleId(u.id),[],$,null,null)};f.error=$=>{this._config.onError(this._createLoadError(u.id,$))},a.load(u.pluginParam,this._createRequire(i.ROOT),f,this._config.getOptionsLiteral())}_resolve(a){let u=a.dependencies;if(u)for(let f=0,$=u.length;f<$;f++){let g=u[f];if(g===p.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(g===p.MODULE){a.unresolvedDependenciesCount--;continue}if(g===p.REQUIRE){a.unresolvedDependenciesCount--;continue}let d=this._modules2[g.id];if(d&&d.isComplete()){if(d.error){a.onDependencyError(d.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(g.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(g.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(g.id,a.id,0)||[];e.reverse(),e.push(g.id),console.warn(e.map(w=>this._moduleIdProvider.getStrModuleId(w)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[g.id]=this._inverseDependencies2[g.id]||[],this._inverseDependencies2[g.id].push(a.id),g instanceof h){let e=this._modules2[g.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,g);continue}let w=this._inversePluginDependencies2.get(g.pluginId);w||(w=[],this._inversePluginDependencies2.set(g.pluginId,w)),w.push(g),this._loadModule(g.pluginId);continue}this._loadModule(g.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let u=this.getRecorder();if(a.isComplete())return;let f=a.dependencies,$=[];if(f)for(let w=0,L=f.length;w<L;w++){let A=f[w];if(A===p.EXPORTS){$[w]=a.exports;continue}if(A===p.MODULE){$[w]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(A===p.REQUIRE){$[w]=this._createRequire(a.moduleIdResolver);continue}let v=this._modules2[A.id];if(v){$[w]=v.exports;continue}$[w]=null}const g=w=>(this._inverseDependencies2[w]||[]).map(L=>this._moduleIdProvider.getStrModuleId(L));a.complete(u,this._config,$,g);let d=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,d)for(let w=0,L=d.length;w<L;w++){let A=d[w],v=this._modules2[A];v.unresolvedDependenciesCount--,v.unresolvedDependenciesCount===0&&this._onModuleComplete(v)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let w=0,L=e.length;w<L;w++)this._loadPluginDependency(a.exports,e[w])}}}x.ModuleManager=N})(Le||(Le={}));var ne,Le;(function(x){const i=new x.Environment;let t=null;const n=function(m,a,u){typeof m!="string"&&(u=a,a=m,m=null),(typeof a!="object"||!Array.isArray(a))&&(u=a,a=null),a||(a=["require","exports","module"]),m?t.defineModule(m,a,u,null,null):t.enqueueDefineAnonymousModule(a,u)};n.amd={jQuery:!0};const p=function(m,a=!1){t.configure(m,a)},h=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){p(arguments[0]);return}if(typeof arguments[0]=="string")return t.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){t.defineModule(x.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};h.config=p,h.getConfig=function(){return t.getConfig().getOptionsLiteral()},h.reset=function(){t=t.reset()},h.getBuildInfo=function(){return t.getBuildInfo()},h.getStats=function(){return t.getLoaderEvents()},h.define=n;function N(){if(typeof x.global.require<"u"||typeof require<"u"){const m=x.global.require||require;if(typeof m=="function"&&typeof m.resolve=="function"){const a=x.ensureRecordedNodeRequire(t.getRecorder(),m);x.global.nodeRequire=a,h.nodeRequire=a,h.__$__nodeRequire=a}}i.isNode&&!i.isElectronRenderer&&!i.isElectronNodeIntegrationWebWorker?module.exports=h:(i.isElectronRenderer||(x.global.define=n),x.global.require=h)}x.init=N,(typeof x.global.define!="function"||!x.global.define.amd)&&(t=new x.ModuleManager(i,x.createScriptLoader(i),n,h,x.Utilities.getHighPerformanceTimestamp()),typeof x.global.require<"u"&&typeof x.global.require!="function"&&h.config(x.global.require),ne=function(){return n.apply(null,arguments)},ne.amd=n.amd,typeof doNotInitLoader>"u"&&N())})(Le||(Le={})),ne(ie[75],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.load=t;function t(m,a,u,f){if(f=f||{},(f["vs/css"]||{}).disabled){u({});return}const g=a.toUrl(m+".css");n(m,g,()=>{u({})},d=>{typeof u.error=="function"&&u.error("Could not find "+g+".")})}function n(m,a,u,f){if(p(m,a)){u();return}h(m,a,u,f)}function p(m,a){const u=window.document.getElementsByTagName("link");for(let f=0,$=u.length;f<$;f++){const g=u[f].getAttribute("data-name"),d=u[f].getAttribute("href");if(g===m||d===a)return!0}return!1}function h(m,a,u,f){const $=document.createElement("link");$.setAttribute("rel","stylesheet"),$.setAttribute("type","text/css"),$.setAttribute("data-name",m),N(m,$,u,f),$.setAttribute("href",a),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild($)}function N(m,a,u,f){const $=()=>{a.removeEventListener("load",g),a.removeEventListener("error",d)},g=e=>{$(),u()},d=e=>{$(),f(e)};a.addEventListener("load",g),a.addEventListener("error",d)}}),function(){const x=globalThis.MonacoEnvironment,i=x&&x.baseUrl?x.baseUrl:"../../../";function t(f,$){if(x?.createTrustedTypesPolicy)try{return x.createTrustedTypesPolicy(f,$)}catch(g){console.warn(g);return}try{return self.trustedTypes?.createPolicy(f,$)}catch(g){console.warn(g);return}}const n=t("amdLoader",{createScriptURL:f=>f,createScript:(f,...$)=>{const g=$.slice(0,-1).join(","),d=$.pop().toString();return`(function anonymous(${g}) { ${d}
})`}});function p(){try{return(n?globalThis.eval(n.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function h(){return new Promise((f,$)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return f();const g=i+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,globalThis.origin.length)!==globalThis.origin)&&p()){fetch(g).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${g}`,(n?globalThis.eval(n.createScript("",e)):new Function(e)).call(globalThis),f()}).then(void 0,$);return}n?importScripts(n.createScriptURL(g)):importScripts(g),f()})}function N(){require.config({baseUrl:i,catchError:!0,trustedTypesPolicy:n,amdModulesPattern:/^vs\//})}function m(f){h().then(()=>{N(),require([f],function($){setTimeout(function(){const g=$.create((d,e)=>{globalThis.postMessage(d,e)},null);for(globalThis.onmessage=d=>g.onmessage(d.data,d.ports);u.length>0;){const d=u.shift();g.onmessage(d.data,d.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&N();let a=!0;const u=[];globalThis.onmessage=f=>{if(!a){u.push(f);return}a=!1,m(f.data)}}(),ne(ie[9],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$lb=void 0,i.$eb=t,i.$fb=n,i.$gb=p,i.$hb=h,i.$ib=N,i.$jb=m,i.$kb=a,i.$mb=f,i.$nb=$,i.$ob=g,i.$pb=d,i.$qb=e;function t(w,L){const A=n(w,L);if(A!==-1)return w[A]}function n(w,L,A=w.length-1){for(let v=A;v>=0;v--){const E=w[v];if(L(E))return v}return-1}function p(w,L){const A=h(w,L);return A===-1?void 0:w[A]}function h(w,L,A=0,v=w.length){let E=A,R=v;for(;E<R;){const b=Math.floor((E+R)/2);L(w[b])?E=b+1:R=b}return E-1}function N(w,L){const A=m(w,L);return A===w.length?void 0:w[A]}function m(w,L,A=0,v=w.length){let E=A,R=v;for(;E<R;){const b=Math.floor((E+R)/2);L(w[b])?R=b:E=b+1}return E}function a(w,L,A=0,v=w.length){const E=m(w,L,A,v);return E===w.length?-1:E}class u{static{this.assertInvariants=!1}constructor(L){this.e=L,this.c=0}findLastMonotonous(L){if(u.assertInvariants){if(this.d){for(const v of this.e)if(this.d(v)&&!L(v))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=L}const A=h(this.e,L,this.c);return this.c=A+1,A===-1?void 0:this.e[A]}}i.$lb=u;function f(w,L){if(w.length===0)return;let A=w[0];for(let v=1;v<w.length;v++){const E=w[v];L(E,A)>0&&(A=E)}return A}function $(w,L){if(w.length===0)return;let A=w[0];for(let v=1;v<w.length;v++){const E=w[v];L(E,A)>=0&&(A=E)}return A}function g(w,L){return f(w,(A,v)=>-L(A,v))}function d(w,L){if(w.length===0)return-1;let A=0;for(let v=1;v<w.length;v++){const E=w[v];L(E,w[A])>0&&(A=v)}return A}function e(w,L){for(const A of w){const v=L(A);if(v!==void 0)return v}}}),ne(ie[4],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CharCode=void 0;var t;(function(n){n[n.Null=0]="Null",n[n.Backspace=8]="Backspace",n[n.Tab=9]="Tab",n[n.LineFeed=10]="LineFeed",n[n.CarriageReturn=13]="CarriageReturn",n[n.Space=32]="Space",n[n.ExclamationMark=33]="ExclamationMark",n[n.DoubleQuote=34]="DoubleQuote",n[n.Hash=35]="Hash",n[n.DollarSign=36]="DollarSign",n[n.PercentSign=37]="PercentSign",n[n.Ampersand=38]="Ampersand",n[n.SingleQuote=39]="SingleQuote",n[n.OpenParen=40]="OpenParen",n[n.CloseParen=41]="CloseParen",n[n.Asterisk=42]="Asterisk",n[n.Plus=43]="Plus",n[n.Comma=44]="Comma",n[n.Dash=45]="Dash",n[n.Period=46]="Period",n[n.Slash=47]="Slash",n[n.Digit0=48]="Digit0",n[n.Digit1=49]="Digit1",n[n.Digit2=50]="Digit2",n[n.Digit3=51]="Digit3",n[n.Digit4=52]="Digit4",n[n.Digit5=53]="Digit5",n[n.Digit6=54]="Digit6",n[n.Digit7=55]="Digit7",n[n.Digit8=56]="Digit8",n[n.Digit9=57]="Digit9",n[n.Colon=58]="Colon",n[n.Semicolon=59]="Semicolon",n[n.LessThan=60]="LessThan",n[n.Equals=61]="Equals",n[n.GreaterThan=62]="GreaterThan",n[n.QuestionMark=63]="QuestionMark",n[n.AtSign=64]="AtSign",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.OpenSquareBracket=91]="OpenSquareBracket",n[n.Backslash=92]="Backslash",n[n.CloseSquareBracket=93]="CloseSquareBracket",n[n.Caret=94]="Caret",n[n.Underline=95]="Underline",n[n.BackTick=96]="BackTick",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.OpenCurlyBrace=123]="OpenCurlyBrace",n[n.Pipe=124]="Pipe",n[n.CloseCurlyBrace=125]="CloseCurlyBrace",n[n.Tilde=126]="Tilde",n[n.NoBreakSpace=160]="NoBreakSpace",n[n.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",n[n.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",n[n.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",n[n.U_Combining_Tilde=771]="U_Combining_Tilde",n[n.U_Combining_Macron=772]="U_Combining_Macron",n[n.U_Combining_Overline=773]="U_Combining_Overline",n[n.U_Combining_Breve=774]="U_Combining_Breve",n[n.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",n[n.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",n[n.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",n[n.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",n[n.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",n[n.U_Combining_Caron=780]="U_Combining_Caron",n[n.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",n[n.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",n[n.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",n[n.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",n[n.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",n[n.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",n[n.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",n[n.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",n[n.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",n[n.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",n[n.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",n[n.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",n[n.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",n[n.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",n[n.U_Combining_Horn=795]="U_Combining_Horn",n[n.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",n[n.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",n[n.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",n[n.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",n[n.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",n[n.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",n[n.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",n[n.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",n[n.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",n[n.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",n[n.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",n[n.U_Combining_Cedilla=807]="U_Combining_Cedilla",n[n.U_Combining_Ogonek=808]="U_Combining_Ogonek",n[n.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",n[n.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",n[n.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",n[n.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",n[n.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",n[n.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",n[n.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",n[n.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",n[n.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",n[n.U_Combining_Low_Line=818]="U_Combining_Low_Line",n[n.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",n[n.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",n[n.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",n[n.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",n[n.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",n[n.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",n[n.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",n[n.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",n[n.U_Combining_Square_Below=827]="U_Combining_Square_Below",n[n.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",n[n.U_Combining_X_Above=829]="U_Combining_X_Above",n[n.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",n[n.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",n[n.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",n[n.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",n[n.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",n[n.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",n[n.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",n[n.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",n[n.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",n[n.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",n[n.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",n[n.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",n[n.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",n[n.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",n[n.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",n[n.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",n[n.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",n[n.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",n[n.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",n[n.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",n[n.U_Combining_Fermata=850]="U_Combining_Fermata",n[n.U_Combining_X_Below=851]="U_Combining_X_Below",n[n.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",n[n.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",n[n.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",n[n.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",n[n.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",n[n.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",n[n.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",n[n.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",n[n.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",n[n.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",n[n.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",n[n.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",n[n.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",n[n.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",n[n.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",n[n.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",n[n.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",n[n.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",n[n.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",n[n.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",n[n.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",n[n.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",n[n.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",n[n.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",n[n.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",n[n.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",n[n.LINE_SEPARATOR=8232]="LINE_SEPARATOR",n[n.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",n[n.NEXT_LINE=133]="NEXT_LINE",n[n.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",n[n.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",n[n.U_DIAERESIS=168]="U_DIAERESIS",n[n.U_MACRON=175]="U_MACRON",n[n.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",n[n.U_CEDILLA=184]="U_CEDILLA",n[n.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",n[n.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",n[n.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",n[n.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",n[n.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",n[n.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",n[n.U_BREVE=728]="U_BREVE",n[n.U_DOT_ABOVE=729]="U_DOT_ABOVE",n[n.U_RING_ABOVE=730]="U_RING_ABOVE",n[n.U_OGONEK=731]="U_OGONEK",n[n.U_SMALL_TILDE=732]="U_SMALL_TILDE",n[n.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",n[n.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",n[n.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",n[n.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",n[n.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",n[n.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",n[n.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",n[n.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",n[n.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",n[n.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",n[n.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",n[n.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",n[n.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",n[n.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",n[n.U_GREEK_TONOS=900]="U_GREEK_TONOS",n[n.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",n[n.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",n[n.U_GREEK_PSILI=8127]="U_GREEK_PSILI",n[n.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",n[n.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",n[n.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",n[n.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",n[n.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",n[n.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",n[n.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",n[n.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",n[n.U_GREEK_VARIA=8175]="U_GREEK_VARIA",n[n.U_GREEK_OXIA=8189]="U_GREEK_OXIA",n[n.U_GREEK_DASIA=8190]="U_GREEK_DASIA",n[n.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",n[n.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",n[n.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",n[n.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",n[n.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",n[n.U_OVERLINE=8254]="U_OVERLINE",n[n.UTF8_BOM=65279]="UTF8_BOM",n[n.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",n[n.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(t||(i.CharCode=t={}))}),ne(ie[37],re([0,1]),function(x,i){"use strict";var t;Object.defineProperty(i,"__esModule",{value:!0}),i.$g=void 0,i.$c=n,i.$d=p,i.$e=h,i.$f=N;function n(a,u){const f=Object.create(null);for(const $ of a){const g=u($);let d=f[g];d||(d=f[g]=[]),d.push($)}return f}function p(a,u){const f=[],$=[];for(const g of a)u.has(g)||f.push(g);for(const g of u)a.has(g)||$.push(g);return{removed:f,added:$}}function h(a,u){const f=[],$=[];for(const[g,d]of a)u.has(g)||f.push(d);for(const[g,d]of u)a.has(g)||$.push(d);return{removed:f,added:$}}function N(a,u){const f=new Set;for(const $ of u)a.has($)&&f.add($);return f}class m{static{t=Symbol.toStringTag}constructor(u,f){this.b=f,this.a=new Map,this[t]="SetWithKey";for(const $ of u)this.add($)}get size(){return this.a.size}add(u){const f=this.b(u);return this.a.set(f,u),this}delete(u){return this.a.delete(this.b(u))}has(u){return this.a.has(this.b(u))}*entries(){for(const u of this.a.values())yield[u,u]}keys(){return this.values()}*values(){for(const u of this.a.values())yield u}clear(){this.a.clear()}forEach(u,f){this.a.forEach($=>u.call(f,$,$,this))}[Symbol.iterator](){return this.values()}}i.$g=m}),ne(ie[38],re([0,1,4]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ou=i.$nu=i.$mu=i.$lu=void 0;function n(a,u){const f=Math.pow(10,u);return Math.round(a*f)/f}class p{constructor(u,f,$,g=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,f))|0,this.b=Math.min(255,Math.max(0,$))|0,this.a=n(Math.max(Math.min(1,g),0),3)}static equals(u,f){return u.r===f.r&&u.g===f.g&&u.b===f.b&&u.a===f.a}}i.$lu=p;class h{constructor(u,f,$,g){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=n(Math.max(Math.min(1,f),0),3),this.l=n(Math.max(Math.min(1,$),0),3),this.a=n(Math.max(Math.min(1,g),0),3)}static equals(u,f){return u.h===f.h&&u.s===f.s&&u.l===f.l&&u.a===f.a}static fromRGBA(u){const f=u.r/255,$=u.g/255,g=u.b/255,d=u.a,e=Math.max(f,$,g),w=Math.min(f,$,g);let L=0,A=0;const v=(w+e)/2,E=e-w;if(E>0){switch(A=Math.min(v<=.5?E/(2*v):E/(2-2*v),1),e){case f:L=($-g)/E+($<g?6:0);break;case $:L=(g-f)/E+2;break;case g:L=(f-$)/E+4;break}L*=60,L=Math.round(L)}return new h(L,A,v,d)}static i(u,f,$){return $<0&&($+=1),$>1&&($-=1),$<1/6?u+(f-u)*6*$:$<1/2?f:$<2/3?u+(f-u)*(2/3-$)*6:u}static toRGBA(u){const f=u.h/360,{s:$,l:g,a:d}=u;let e,w,L;if($===0)e=w=L=g;else{const A=g<.5?g*(1+$):g+$-g*$,v=2*g-A;e=h.i(v,A,f+1/3),w=h.i(v,A,f),L=h.i(v,A,f-1/3)}return new p(Math.round(e*255),Math.round(w*255),Math.round(L*255),d)}}i.$mu=h;class N{constructor(u,f,$,g){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=n(Math.max(Math.min(1,f),0),3),this.v=n(Math.max(Math.min(1,$),0),3),this.a=n(Math.max(Math.min(1,g),0),3)}static equals(u,f){return u.h===f.h&&u.s===f.s&&u.v===f.v&&u.a===f.a}static fromRGBA(u){const f=u.r/255,$=u.g/255,g=u.b/255,d=Math.max(f,$,g),e=Math.min(f,$,g),w=d-e,L=d===0?0:w/d;let A;return w===0?A=0:d===f?A=(($-g)/w%6+6)%6:d===$?A=(g-f)/w+2:A=(f-$)/w+4,new N(Math.round(A*60),L,d,u.a)}static toRGBA(u){const{h:f,s:$,v:g,a:d}=u,e=g*$,w=e*(1-Math.abs(f/60%2-1)),L=g-e;let[A,v,E]=[0,0,0];return f<60?(A=e,v=w):f<120?(A=w,v=e):f<180?(v=e,E=w):f<240?(v=w,E=e):f<300?(A=w,E=e):f<=360&&(A=e,E=w),A=Math.round((A+L)*255),v=Math.round((v+L)*255),E=Math.round((E+L)*255),new p(A,v,E,d)}}i.$nu=N;class m{static fromHex(u){return m.Format.CSS.parseHex(u)||m.red}static equals(u,f){return!u&&!f?!0:!u||!f?!1:u.equals(f)}get hsla(){return this.i?this.i:h.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:N.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof p)this.rgba=u;else if(u instanceof h)this.i=u,this.rgba=h.toRGBA(u);else if(u instanceof N)this.j=u,this.rgba=N.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&p.equals(this.rgba,u.rgba)&&h.equals(this.hsla,u.hsla)&&N.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=m.k(this.rgba.r),f=m.k(this.rgba.g),$=m.k(this.rgba.b),g=.2126*u+.7152*f+.0722*$;return n(g,4)}static k(u){const f=u/255;return f<=.03928?f/12.92:Math.pow((f+.055)/1.055,2.4)}getContrastRatio(u){const f=this.getRelativeLuminance(),$=u.getRelativeLuminance();return f>$?(f+.05)/($+.05):($+.05)/(f+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const f=this.getRelativeLuminance(),$=u.getRelativeLuminance();return f>$}isDarkerThan(u){const f=this.getRelativeLuminance(),$=u.getRelativeLuminance();return f<$}lighten(u){return new m(new h(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new m(new h(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:f,g:$,b:g,a:d}=this.rgba;return new m(new p(f,$,g,d*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new m(new p(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const f=u.rgba,$=this.rgba.a,g=f.a,d=$+g*(1-$);if(d<1e-6)return m.transparent;const e=this.rgba.r*$/d+f.r*g*(1-$)/d,w=this.rgba.g*$/d+f.g*g*(1-$)/d,L=this.rgba.b*$/d+f.b*g*(1-$)/d;return new m(new p(e,w,L,d))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:f,g:$,b:g,a:d}=this.rgba;return new m(new p(u.rgba.r-d*(u.rgba.r-f),u.rgba.g-d*(u.rgba.g-$),u.rgba.b-d*(u.rgba.b-g),1))}flatten(...u){const f=u.reduceRight(($,g)=>m.o(g,$));return m.o(this,f)}static o(u,f){const $=1-u.rgba.a;return new m(new p($*f.rgba.r+u.rgba.a*u.rgba.r,$*f.rgba.g+u.rgba.a*u.rgba.g,$*f.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this.u||(this.u=m.Format.CSS.format(this)),this.u}static getLighterColor(u,f,$){if(u.isLighterThan(f))return u;$=$||.5;const g=u.getRelativeLuminance(),d=f.getRelativeLuminance();return $=$*(d-g)/d,u.lighten($)}static getDarkerColor(u,f,$){if(u.isDarkerThan(f))return u;$=$||.5;const g=u.getRelativeLuminance(),d=f.getRelativeLuminance();return $=$*(g-d)/g,u.darken($)}static{this.white=new m(new p(255,255,255,1))}static{this.black=new m(new p(0,0,0,1))}static{this.red=new m(new p(255,0,0,1))}static{this.blue=new m(new p(0,0,255,1))}static{this.green=new m(new p(0,255,0,1))}static{this.cyan=new m(new p(0,255,255,1))}static{this.lightgrey=new m(new p(211,211,211,1))}static{this.transparent=new m(new p(0,0,0,0))}}i.$ou=m,function(a){let u;(function(f){let $;(function(g){function d(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:a.Format.CSS.formatRGBA(r)}g.formatRGB=d;function e(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}g.formatRGBA=e;function w(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:a.Format.CSS.formatHSLA(r)}g.formatHSL=w;function L(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}g.formatHSLA=L;function A(r){const l=r.toString(16);return l.length!==2?"0"+l:l}function v(r){return`#${A(r.rgba.r)}${A(r.rgba.g)}${A(r.rgba.b)}`}g.formatHex=v;function E(r,l=!1){return l&&r.rgba.a===1?a.Format.CSS.formatHex(r):`#${A(r.rgba.r)}${A(r.rgba.g)}${A(r.rgba.b)}${A(Math.round(r.rgba.a*255))}`}g.formatHexA=E;function R(r){return r.isOpaque()?a.Format.CSS.formatHex(r):a.Format.CSS.formatRGBA(r)}g.format=R;function b(r){const l=r.length;if(l===0||r.charCodeAt(0)!==t.CharCode.Hash)return null;if(l===7){const c=16*o(r.charCodeAt(1))+o(r.charCodeAt(2)),M=16*o(r.charCodeAt(3))+o(r.charCodeAt(4)),_=16*o(r.charCodeAt(5))+o(r.charCodeAt(6));return new a(new p(c,M,_,1))}if(l===9){const c=16*o(r.charCodeAt(1))+o(r.charCodeAt(2)),M=16*o(r.charCodeAt(3))+o(r.charCodeAt(4)),_=16*o(r.charCodeAt(5))+o(r.charCodeAt(6)),T=16*o(r.charCodeAt(7))+o(r.charCodeAt(8));return new a(new p(c,M,_,T/255))}if(l===4){const c=o(r.charCodeAt(1)),M=o(r.charCodeAt(2)),_=o(r.charCodeAt(3));return new a(new p(16*c+c,16*M+M,16*_+_))}if(l===5){const c=o(r.charCodeAt(1)),M=o(r.charCodeAt(2)),_=o(r.charCodeAt(3)),T=o(r.charCodeAt(4));return new a(new p(16*c+c,16*M+M,16*_+_,(16*T+T)/255))}return null}g.parseHex=b;function o(r){switch(r){case t.CharCode.Digit0:return 0;case t.CharCode.Digit1:return 1;case t.CharCode.Digit2:return 2;case t.CharCode.Digit3:return 3;case t.CharCode.Digit4:return 4;case t.CharCode.Digit5:return 5;case t.CharCode.Digit6:return 6;case t.CharCode.Digit7:return 7;case t.CharCode.Digit8:return 8;case t.CharCode.Digit9:return 9;case t.CharCode.a:return 10;case t.CharCode.A:return 10;case t.CharCode.b:return 11;case t.CharCode.B:return 11;case t.CharCode.c:return 12;case t.CharCode.C:return 12;case t.CharCode.d:return 13;case t.CharCode.D:return 13;case t.CharCode.e:return 14;case t.CharCode.E:return 14;case t.CharCode.f:return 15;case t.CharCode.F:return 15}return 0}})($=f.CSS||(f.CSS={}))})(u=a.Format||(a.Format={}))}(m||(i.$ou=m={}))}),ne(ie[39],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Rt=void 0;class t{constructor(p,h,N,m){this.originalStart=p,this.originalLength=h,this.modifiedStart=N,this.modifiedLength=m}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}i.$Rt=t}),ne(ie[5],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$bb=i.$ab=i.$_=i.$$=i.$0=i.$8=i.$4=i.$V=i.$U=void 0,i.setUnexpectedErrorHandler=n,i.$X=p,i.$Y=h,i.$Z=N,i.$1=m,i.$2=a,i.$3=f,i.$5=g,i.$6=d,i.$7=e,i.$9=L;class t{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?R.isErrorNoTelemetry(r)?new R(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(l=>{l(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}i.$U=t,i.$V=new t;function n(o){i.$V.setUnexpectedErrorHandler(o)}function p(o){if(!o||typeof o!="object")return!1;const r=o;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function h(o){f(o)||i.$V.onUnexpectedError(o)}function N(o){f(o)||i.$V.onUnexpectedExternalError(o)}function m(o){if(o instanceof Error){const{name:r,message:l}=o,c=o.stacktrace||o.stack;return{$isError:!0,name:r,message:l,stack:c,noTelemetry:R.isErrorNoTelemetry(o)}}return o}function a(o){let r;return o.noTelemetry?r=new R:(r=new Error,r.name=o.name),r.message=o.message,r.stack=o.stack,r}const u="Canceled";function f(o){return o instanceof $?!0:o instanceof Error&&o.name===u&&o.message===u}class $ extends Error{constructor(){super(u),this.name=this.message}}i.$4=$;function g(){const o=new Error(u);return o.name=o.message,o}function d(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function e(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class w extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}i.$8=w;function L(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class A extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}i.$0=A;class v extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}i.$$=v;class E extends Error{constructor(){super(...arguments),this.isExpected=!0}}i.$_=E;class R extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof R)return r;const l=new R;return l.message=r.message,l.stack=r.stack,l}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}i.$ab=R;class b extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}i.$bb=b}),ne(ie[7],re([0,1,5,9]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$_b=i.$$b=i.$0b=i.$8b=i.$7b=i.CompareResult=void 0,i.$rb=p,i.$sb=h,i.$tb=N,i.$ub=m,i.$vb=a,i.$wb=u,i.$xb=f,i.$yb=$,i.$zb=g,i.$Ab=d,i.$Bb=e,i.$Cb=w,i.$Db=L,i.top=A,i.$Fb=v,i.$Gb=R,i.$Hb=b,i.$Ib=o,i.$Jb=r,i.$Kb=l,i.$Lb=c,i.$Mb=M,i.$Nb=_,i.$Ob=T,i.$Pb=D,i.$Qb=j,i.$Rb=P,i.$Sb=I,i.$Tb=F,i.$Ub=y,i.$Vb=W,i.$Wb=B,i.$Xb=O,i.$Yb=X,i.$Zb=Y,i.$1b=z,i.$2b=Q,i.$3b=ee,i.$4b=k,i.$5b=oe,i.$6b=we,i.$9b=Ie,i.$ac=Be;function p(q,V=0){return q[q.length-(1+V)]}function h(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}function N(q,V,U=(J,C)=>J===C){if(q===V)return!0;if(!q||!V||q.length!==V.length)return!1;for(let J=0,C=q.length;J<C;J++)if(!U(q[J],V[J]))return!1;return!0}function m(q,V){const U=q.length-1;V<U&&(q[V]=q[U]),q.pop()}function a(q,V,U){return u(q.length,J=>U(q[J],V))}function u(q,V){let U=0,J=q-1;for(;U<=J;){const C=(U+J)/2|0,he=V(C);if(he<0)U=C+1;else if(he>0)J=C-1;else return C}return-(U+1)}function f(q,V,U){if(q=q|0,q>=V.length)throw new TypeError("invalid index");const J=V[Math.floor(V.length*Math.random())],C=[],he=[],de=[];for(const Ee of V){const ve=U(Ee,J);ve<0?C.push(Ee):ve>0?he.push(Ee):de.push(Ee)}return q<C.length?f(q,C,U):q<C.length+de.length?de[0]:f(q-(C.length+de.length),he,U)}function $(q,V){const U=[];let J;for(const C of q.slice(0).sort(V))!J||V(J[0],C)!==0?(J=[C],U.push(J)):J.push(C);return U}function*g(q,V){let U,J;for(const C of q)J!==void 0&&V(J,C)?U.push(C):(U&&(yield U),U=[C]),J=C;U&&(yield U)}function d(q,V){for(let U=0;U<=q.length;U++)V(U===0?void 0:q[U-1],U===q.length?void 0:q[U])}function e(q,V){for(let U=0;U<q.length;U++)V(U===0?void 0:q[U-1],q[U],U+1===q.length?void 0:q[U+1])}function w(q,V,U){const J=[];function C(Ee,ve,_e){if(ve===0&&_e.length===0)return;const se=J[J.length-1];se&&se.start+se.deleteCount===Ee?(se.deleteCount+=ve,se.toInsert.push(..._e)):J.push({start:Ee,deleteCount:ve,toInsert:_e})}let he=0,de=0;for(;;){if(he===q.length){C(he,0,V.slice(de));break}if(de===V.length){C(he,q.length-he,[]);break}const Ee=q[he],ve=V[de],_e=U(Ee,ve);_e===0?(he+=1,de+=1):_e<0?(C(he,1,[]),he+=1):_e>0&&(C(he,0,[ve]),de+=1)}return J}function L(q,V,U){const J=w(q,V,U),C=[],he=[];for(const de of J)C.push(...q.slice(de.start,de.start+de.deleteCount)),he.push(...de.toInsert);return{removed:C,added:he}}function A(q,V,U){if(U===0)return[];const J=q.slice(0,U).sort(V);return E(q,V,J,U,q.length),J}function v(q,V,U,J,C){return U===0?Promise.resolve([]):new Promise((he,de)=>{(async()=>{const Ee=q.length,ve=q.slice(0,U).sort(V);for(let _e=U,se=Math.min(U+J,Ee);_e<Ee;_e=se,se=Math.min(se+J,Ee)){if(_e>U&&await new Promise(te=>setTimeout(te)),C&&C.isCancellationRequested)throw new t.$4;E(q,V,ve,_e,se)}return ve})().then(he,de)})}function E(q,V,U,J,C){for(const he=U.length;J<C;J++){const de=q[J];if(V(de,U[he-1])<0){U.pop();const Ee=(0,n.$jb)(U,ve=>V(de,ve)<0);U.splice(Ee,0,de)}}}function R(q){return q.filter(V=>!!V)}function b(q){let V=0;for(let U=0;U<q.length;U++)q[U]&&(q[V]=q[U],V+=1);q.length=V}function o(q,V,U){q.splice(U,0,q.splice(V,1)[0])}function r(q){return!Array.isArray(q)||q.length===0}function l(q){return Array.isArray(q)&&q.length>0}function c(q,V=U=>U){const U=new Set;return q.filter(J=>{const C=V(J);return U.has(C)?!1:(U.add(C),!0)})}function M(q){const V=new Set;return U=>{const J=q(U);return V.has(J)?!1:(V.add(J),!0)}}function _(q,V){return q.length>0?q[0]:V}function T(q,V){return q.length>0?q[q.length-1]:V}function D(q,V,U=(J,C)=>J===C){let J=0;for(let C=0,he=Math.min(q.length,V.length);C<he&&U(q[C],V[C]);C++)J++;return J}function j(q,V){let U=typeof V=="number"?q:0;typeof V=="number"?U=q:(U=0,V=q);const J=[];if(U<=V)for(let C=U;C<V;C++)J.push(C);else for(let C=U;C>V;C--)J.push(C);return J}function P(q,V,U){return q.reduce((J,C)=>(J[V(C)]=U?U(C):C,J),Object.create(null))}function I(q,V){return q.push(V),()=>F(q,V)}function F(q,V){const U=q.indexOf(V);if(U>-1)return q.splice(U,1),V}function y(q,V,U){const J=q.slice(0,V),C=q.slice(V);return J.concat(U,C)}function W(q,V){let U;if(typeof V=="number"){let J=V;U=()=>{const C=Math.sin(J++)*179426549;return C-Math.floor(C)}}else U=Math.random;for(let J=q.length-1;J>0;J-=1){const C=Math.floor(U()*(J+1)),he=q[J];q[J]=q[C],q[C]=he}}function B(q,V){const U=q.indexOf(V);U>-1&&(q.splice(U,1),q.unshift(V))}function O(q,V){const U=q.indexOf(V);U>-1&&(q.splice(U,1),q.push(V))}function X(q,V){for(const U of V)q.push(U)}function Y(q,V){return Array.isArray(q)?q.map(V):V(q)}function z(q){return Array.isArray(q)?q:[q]}function Q(q){return q[Math.floor(Math.random()*q.length)]}function ee(q,V,U){const J=H(q,V),C=q.length,he=U.length;q.length=C+he;for(let de=C-1;de>=J;de--)q[de+he]=q[de];for(let de=0;de<he;de++)q[de+J]=U[de]}function k(q,V,U,J){const C=H(q,V);let he=q.splice(C,U);return he===void 0&&(he=[]),ee(q,C,J),he}function H(q,V){return V<0?Math.max(V+q.length,0):Math.min(V,q.length)}var fe;(function(q){function V(he){return he<0}q.isLessThan=V;function U(he){return he<=0}q.isLessThanOrEqual=U;function J(he){return he>0}q.isGreaterThan=J;function C(he){return he===0}q.isNeitherLessOrGreaterThan=C,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(fe||(i.CompareResult=fe={}));function oe(q,V){return(U,J)=>V(q(U),q(J))}function we(...q){return(V,U)=>{for(const J of q){const C=J(V,U);if(!fe.isNeitherLessOrGreaterThan(C))return C}return fe.neitherLessOrGreaterThan}}const s=(q,V)=>q-V;i.$7b=s;const Te=(q,V)=>(0,i.$7b)(q?1:0,V?1:0);i.$8b=Te;function Ie(q){return(V,U)=>-q(V,U)}class Ve{constructor(V){this.g=V,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(V){let U=this.c;for(;U<this.g.length&&V(this.g[U]);)U++;const J=U===this.c?null:this.g.slice(this.c,U);return this.c=U,J}takeFromEndWhile(V){let U=this.d;for(;U>=0&&V(this.g[U]);)U--;const J=U===this.d?null:this.g.slice(U+1,this.d+1);return this.d=U,J}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const V=this.g[this.c];return this.c++,V}removeLast(){const V=this.g[this.d];return this.d--,V}takeCount(V){const U=this.g.slice(this.c,this.c+V);return this.c+=V,U}}i.$0b=Ve;class je{static{this.empty=new je(V=>{})}constructor(V){this.iterate=V}forEach(V){this.iterate(U=>(V(U),!0))}toArray(){const V=[];return this.iterate(U=>(V.push(U),!0)),V}filter(V){return new je(U=>this.iterate(J=>V(J)?U(J):!0))}map(V){return new je(U=>this.iterate(J=>U(V(J))))}some(V){let U=!1;return this.iterate(J=>(U=V(J),!U)),U}findFirst(V){let U;return this.iterate(J=>V(J)?(U=J,!1):!0),U}findLast(V){let U;return this.iterate(J=>(V(J)&&(U=J),!0)),U}findLastMaxBy(V){let U,J=!0;return this.iterate(C=>((J||fe.isGreaterThan(V(C,U)))&&(J=!1,U=C),!0)),U}}i.$$b=je;class Ze{constructor(V){this.c=V}static createSortPermutation(V,U){const J=Array.from(V.keys()).sort((C,he)=>U(V[C],V[he]));return new Ze(J)}apply(V){return V.map((U,J)=>V[this.c[J]])}inverse(){const V=this.c.slice();for(let U=0;U<this.c.length;U++)V[this.c[U]]=U;return new Ze(V)}}i.$_b=Ze;async function Be(q,V){return(await Promise.all(q.map(async(J,C)=>({element:J,ok:await V(J,C)})))).find(J=>J.ok)?.element}}),ne(ie[11],re([0,1,5]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=n,i.$ed=p,i.$fd=h,i.$gd=N,i.$hd=m,i.$id=a;function n(u,f){if(!u)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}function p(u,f="Unreachable"){throw new Error(f)}function h(u,f="unexpected state"){if(!u)throw new t.$bb(`Assertion Failed: ${f}`)}function N(u){u||(0,t.$Y)(new t.$bb("Soft Assertion Failed"))}function m(u){if(!u()){debugger;u(),(0,t.$Y)(new t.$bb("Assertion Failed"))}}function a(u,f){let $=0;for(;$<u.length-1;){const g=u[$],d=u[$+1];if(!f(g,d))return!1;$++}return!0}}),ne(ie[22],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$cb=t;function t(n,p){const h=this;let N=!1,m;return function(){if(N)return m;if(N=!0,p)try{m=n.apply(h,arguments)}finally{p()}else m=n.apply(h,arguments);return m}}}),ne(ie[23],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Iterable=void 0;var t;(function(n){function p(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}n.is=p;const h=Object.freeze([]);function N(){return h}n.empty=N;function*m(r){yield r}n.single=m;function a(r){return p(r)?r:m(r)}n.wrap=a;function u(r){return r||h}n.from=u;function*f(r){for(let l=r.length-1;l>=0;l--)yield r[l]}n.reverse=f;function $(r){return!r||r[Symbol.iterator]().next().done===!0}n.isEmpty=$;function g(r){return r[Symbol.iterator]().next().value}n.first=g;function d(r,l){let c=0;for(const M of r)if(l(M,c++))return!0;return!1}n.some=d;function e(r,l){for(const c of r)if(l(c))return c}n.find=e;function*w(r,l){for(const c of r)l(c)&&(yield c)}n.filter=w;function*L(r,l){let c=0;for(const M of r)yield l(M,c++)}n.map=L;function*A(r,l){let c=0;for(const M of r)yield*l(M,c++)}n.flatMap=A;function*v(...r){for(const l of r)yield*l}n.concat=v;function E(r,l,c){let M=c;for(const _ of r)M=l(M,_);return M}n.reduce=E;function*R(r,l,c=r.length){for(l<0&&(l+=r.length),c<0?c+=r.length:c>r.length&&(c=r.length);l<c;l++)yield r[l]}n.slice=R;function b(r,l=Number.POSITIVE_INFINITY){const c=[];if(l===0)return[c,r];const M=r[Symbol.iterator]();for(let _=0;_<l;_++){const T=M.next();if(T.done)return[c,n.empty()];c.push(T.value)}return[c,{[Symbol.iterator](){return M}}]}n.consume=b;async function o(r){const l=[];for await(const c of r)l.push(c);return Promise.resolve(l)}n.asyncToArray=o})(t||(i.Iterable=t={}))}),ne(ie[40],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.KeyMod=i.KeyCodeUtils=i.$Xr=i.$Wr=i.$Vr=i.$Ur=i.$Tr=i.ScanCode=i.KeyCode=void 0,i.$Yr=d;var t;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(t||(i.KeyCode=t={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(n||(i.ScanCode=n={}));class p{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(w,L){this._keyCodeToStr[w]=L,this._strToKeyCode[L.toLowerCase()]=w}keyCodeToStr(w){return this._keyCodeToStr[w]}strToKeyCode(w){return this._strToKeyCode[w.toLowerCase()]||t.Unknown}}const h=new p,N=new p,m=new p;i.$Tr=new Array(230),i.$Ur={};const a=[],u=Object.create(null),f=Object.create(null);i.$Vr={lowerCaseToEnum:e=>f[e]||n.None,toEnum:e=>u[e]||n.None,toString:e=>a[e]||"None"},i.$Wr=[],i.$Xr=[];for(let e=0;e<=n.MAX_VALUE;e++)i.$Wr[e]=t.DependsOnKbLayout;for(let e=0;e<=t.MAX_VALUE;e++)i.$Xr[e]=n.DependsOnKbLayout;(function(){const e="",w=[[1,n.None,"None",t.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,n.Hyper,"Hyper",t.Unknown,e,0,e,e,e],[1,n.Super,"Super",t.Unknown,e,0,e,e,e],[1,n.Fn,"Fn",t.Unknown,e,0,e,e,e],[1,n.FnLock,"FnLock",t.Unknown,e,0,e,e,e],[1,n.Suspend,"Suspend",t.Unknown,e,0,e,e,e],[1,n.Resume,"Resume",t.Unknown,e,0,e,e,e],[1,n.Turbo,"Turbo",t.Unknown,e,0,e,e,e],[1,n.Sleep,"Sleep",t.Unknown,e,0,"VK_SLEEP",e,e],[1,n.WakeUp,"WakeUp",t.Unknown,e,0,e,e,e],[0,n.KeyA,"KeyA",t.KeyA,"A",65,"VK_A",e,e],[0,n.KeyB,"KeyB",t.KeyB,"B",66,"VK_B",e,e],[0,n.KeyC,"KeyC",t.KeyC,"C",67,"VK_C",e,e],[0,n.KeyD,"KeyD",t.KeyD,"D",68,"VK_D",e,e],[0,n.KeyE,"KeyE",t.KeyE,"E",69,"VK_E",e,e],[0,n.KeyF,"KeyF",t.KeyF,"F",70,"VK_F",e,e],[0,n.KeyG,"KeyG",t.KeyG,"G",71,"VK_G",e,e],[0,n.KeyH,"KeyH",t.KeyH,"H",72,"VK_H",e,e],[0,n.KeyI,"KeyI",t.KeyI,"I",73,"VK_I",e,e],[0,n.KeyJ,"KeyJ",t.KeyJ,"J",74,"VK_J",e,e],[0,n.KeyK,"KeyK",t.KeyK,"K",75,"VK_K",e,e],[0,n.KeyL,"KeyL",t.KeyL,"L",76,"VK_L",e,e],[0,n.KeyM,"KeyM",t.KeyM,"M",77,"VK_M",e,e],[0,n.KeyN,"KeyN",t.KeyN,"N",78,"VK_N",e,e],[0,n.KeyO,"KeyO",t.KeyO,"O",79,"VK_O",e,e],[0,n.KeyP,"KeyP",t.KeyP,"P",80,"VK_P",e,e],[0,n.KeyQ,"KeyQ",t.KeyQ,"Q",81,"VK_Q",e,e],[0,n.KeyR,"KeyR",t.KeyR,"R",82,"VK_R",e,e],[0,n.KeyS,"KeyS",t.KeyS,"S",83,"VK_S",e,e],[0,n.KeyT,"KeyT",t.KeyT,"T",84,"VK_T",e,e],[0,n.KeyU,"KeyU",t.KeyU,"U",85,"VK_U",e,e],[0,n.KeyV,"KeyV",t.KeyV,"V",86,"VK_V",e,e],[0,n.KeyW,"KeyW",t.KeyW,"W",87,"VK_W",e,e],[0,n.KeyX,"KeyX",t.KeyX,"X",88,"VK_X",e,e],[0,n.KeyY,"KeyY",t.KeyY,"Y",89,"VK_Y",e,e],[0,n.KeyZ,"KeyZ",t.KeyZ,"Z",90,"VK_Z",e,e],[0,n.Digit1,"Digit1",t.Digit1,"1",49,"VK_1",e,e],[0,n.Digit2,"Digit2",t.Digit2,"2",50,"VK_2",e,e],[0,n.Digit3,"Digit3",t.Digit3,"3",51,"VK_3",e,e],[0,n.Digit4,"Digit4",t.Digit4,"4",52,"VK_4",e,e],[0,n.Digit5,"Digit5",t.Digit5,"5",53,"VK_5",e,e],[0,n.Digit6,"Digit6",t.Digit6,"6",54,"VK_6",e,e],[0,n.Digit7,"Digit7",t.Digit7,"7",55,"VK_7",e,e],[0,n.Digit8,"Digit8",t.Digit8,"8",56,"VK_8",e,e],[0,n.Digit9,"Digit9",t.Digit9,"9",57,"VK_9",e,e],[0,n.Digit0,"Digit0",t.Digit0,"0",48,"VK_0",e,e],[1,n.Enter,"Enter",t.Enter,"Enter",13,"VK_RETURN",e,e],[1,n.Escape,"Escape",t.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,n.Backspace,"Backspace",t.Backspace,"Backspace",8,"VK_BACK",e,e],[1,n.Tab,"Tab",t.Tab,"Tab",9,"VK_TAB",e,e],[1,n.Space,"Space",t.Space,"Space",32,"VK_SPACE",e,e],[0,n.Minus,"Minus",t.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,n.Equal,"Equal",t.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,n.BracketLeft,"BracketLeft",t.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,n.BracketRight,"BracketRight",t.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,n.Backslash,"Backslash",t.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,n.IntlHash,"IntlHash",t.Unknown,e,0,e,e,e],[0,n.Semicolon,"Semicolon",t.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,n.Quote,"Quote",t.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,n.Backquote,"Backquote",t.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,n.Comma,"Comma",t.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,n.Period,"Period",t.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,n.Slash,"Slash",t.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,n.CapsLock,"CapsLock",t.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,n.F1,"F1",t.F1,"F1",112,"VK_F1",e,e],[1,n.F2,"F2",t.F2,"F2",113,"VK_F2",e,e],[1,n.F3,"F3",t.F3,"F3",114,"VK_F3",e,e],[1,n.F4,"F4",t.F4,"F4",115,"VK_F4",e,e],[1,n.F5,"F5",t.F5,"F5",116,"VK_F5",e,e],[1,n.F6,"F6",t.F6,"F6",117,"VK_F6",e,e],[1,n.F7,"F7",t.F7,"F7",118,"VK_F7",e,e],[1,n.F8,"F8",t.F8,"F8",119,"VK_F8",e,e],[1,n.F9,"F9",t.F9,"F9",120,"VK_F9",e,e],[1,n.F10,"F10",t.F10,"F10",121,"VK_F10",e,e],[1,n.F11,"F11",t.F11,"F11",122,"VK_F11",e,e],[1,n.F12,"F12",t.F12,"F12",123,"VK_F12",e,e],[1,n.PrintScreen,"PrintScreen",t.Unknown,e,0,e,e,e],[1,n.ScrollLock,"ScrollLock",t.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,n.Pause,"Pause",t.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,n.Insert,"Insert",t.Insert,"Insert",45,"VK_INSERT",e,e],[1,n.Home,"Home",t.Home,"Home",36,"VK_HOME",e,e],[1,n.PageUp,"PageUp",t.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,n.Delete,"Delete",t.Delete,"Delete",46,"VK_DELETE",e,e],[1,n.End,"End",t.End,"End",35,"VK_END",e,e],[1,n.PageDown,"PageDown",t.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,n.ArrowRight,"ArrowRight",t.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,n.ArrowLeft,"ArrowLeft",t.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,n.ArrowDown,"ArrowDown",t.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,n.ArrowUp,"ArrowUp",t.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,n.NumLock,"NumLock",t.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,n.NumpadDivide,"NumpadDivide",t.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,n.NumpadMultiply,"NumpadMultiply",t.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,n.NumpadSubtract,"NumpadSubtract",t.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,n.NumpadAdd,"NumpadAdd",t.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,n.NumpadEnter,"NumpadEnter",t.Enter,e,0,e,e,e],[1,n.Numpad1,"Numpad1",t.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,n.Numpad2,"Numpad2",t.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,n.Numpad3,"Numpad3",t.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,n.Numpad4,"Numpad4",t.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,n.Numpad5,"Numpad5",t.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,n.Numpad6,"Numpad6",t.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,n.Numpad7,"Numpad7",t.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,n.Numpad8,"Numpad8",t.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,n.Numpad9,"Numpad9",t.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,n.Numpad0,"Numpad0",t.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,n.NumpadDecimal,"NumpadDecimal",t.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,n.IntlBackslash,"IntlBackslash",t.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,n.ContextMenu,"ContextMenu",t.ContextMenu,"ContextMenu",93,e,e,e],[1,n.Power,"Power",t.Unknown,e,0,e,e,e],[1,n.NumpadEqual,"NumpadEqual",t.Unknown,e,0,e,e,e],[1,n.F13,"F13",t.F13,"F13",124,"VK_F13",e,e],[1,n.F14,"F14",t.F14,"F14",125,"VK_F14",e,e],[1,n.F15,"F15",t.F15,"F15",126,"VK_F15",e,e],[1,n.F16,"F16",t.F16,"F16",127,"VK_F16",e,e],[1,n.F17,"F17",t.F17,"F17",128,"VK_F17",e,e],[1,n.F18,"F18",t.F18,"F18",129,"VK_F18",e,e],[1,n.F19,"F19",t.F19,"F19",130,"VK_F19",e,e],[1,n.F20,"F20",t.F20,"F20",131,"VK_F20",e,e],[1,n.F21,"F21",t.F21,"F21",132,"VK_F21",e,e],[1,n.F22,"F22",t.F22,"F22",133,"VK_F22",e,e],[1,n.F23,"F23",t.F23,"F23",134,"VK_F23",e,e],[1,n.F24,"F24",t.F24,"F24",135,"VK_F24",e,e],[1,n.Open,"Open",t.Unknown,e,0,e,e,e],[1,n.Help,"Help",t.Unknown,e,0,e,e,e],[1,n.Select,"Select",t.Unknown,e,0,e,e,e],[1,n.Again,"Again",t.Unknown,e,0,e,e,e],[1,n.Undo,"Undo",t.Unknown,e,0,e,e,e],[1,n.Cut,"Cut",t.Unknown,e,0,e,e,e],[1,n.Copy,"Copy",t.Unknown,e,0,e,e,e],[1,n.Paste,"Paste",t.Unknown,e,0,e,e,e],[1,n.Find,"Find",t.Unknown,e,0,e,e,e],[1,n.AudioVolumeMute,"AudioVolumeMute",t.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,n.AudioVolumeUp,"AudioVolumeUp",t.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,n.AudioVolumeDown,"AudioVolumeDown",t.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,n.NumpadComma,"NumpadComma",t.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,n.IntlRo,"IntlRo",t.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,n.KanaMode,"KanaMode",t.Unknown,e,0,e,e,e],[0,n.IntlYen,"IntlYen",t.Unknown,e,0,e,e,e],[1,n.Convert,"Convert",t.Unknown,e,0,e,e,e],[1,n.NonConvert,"NonConvert",t.Unknown,e,0,e,e,e],[1,n.Lang1,"Lang1",t.Unknown,e,0,e,e,e],[1,n.Lang2,"Lang2",t.Unknown,e,0,e,e,e],[1,n.Lang3,"Lang3",t.Unknown,e,0,e,e,e],[1,n.Lang4,"Lang4",t.Unknown,e,0,e,e,e],[1,n.Lang5,"Lang5",t.Unknown,e,0,e,e,e],[1,n.Abort,"Abort",t.Unknown,e,0,e,e,e],[1,n.Props,"Props",t.Unknown,e,0,e,e,e],[1,n.NumpadParenLeft,"NumpadParenLeft",t.Unknown,e,0,e,e,e],[1,n.NumpadParenRight,"NumpadParenRight",t.Unknown,e,0,e,e,e],[1,n.NumpadBackspace,"NumpadBackspace",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryStore,"NumpadMemoryStore",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryRecall,"NumpadMemoryRecall",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryClear,"NumpadMemoryClear",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryAdd,"NumpadMemoryAdd",t.Unknown,e,0,e,e,e],[1,n.NumpadMemorySubtract,"NumpadMemorySubtract",t.Unknown,e,0,e,e,e],[1,n.NumpadClear,"NumpadClear",t.Clear,"Clear",12,"VK_CLEAR",e,e],[1,n.NumpadClearEntry,"NumpadClearEntry",t.Unknown,e,0,e,e,e],[1,n.None,e,t.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,n.None,e,t.Shift,"Shift",16,"VK_SHIFT",e,e],[1,n.None,e,t.Alt,"Alt",18,"VK_MENU",e,e],[1,n.None,e,t.Meta,"Meta",91,"VK_COMMAND",e,e],[1,n.ControlLeft,"ControlLeft",t.Ctrl,e,0,"VK_LCONTROL",e,e],[1,n.ShiftLeft,"ShiftLeft",t.Shift,e,0,"VK_LSHIFT",e,e],[1,n.AltLeft,"AltLeft",t.Alt,e,0,"VK_LMENU",e,e],[1,n.MetaLeft,"MetaLeft",t.Meta,e,0,"VK_LWIN",e,e],[1,n.ControlRight,"ControlRight",t.Ctrl,e,0,"VK_RCONTROL",e,e],[1,n.ShiftRight,"ShiftRight",t.Shift,e,0,"VK_RSHIFT",e,e],[1,n.AltRight,"AltRight",t.Alt,e,0,"VK_RMENU",e,e],[1,n.MetaRight,"MetaRight",t.Meta,e,0,"VK_RWIN",e,e],[1,n.BrightnessUp,"BrightnessUp",t.Unknown,e,0,e,e,e],[1,n.BrightnessDown,"BrightnessDown",t.Unknown,e,0,e,e,e],[1,n.MediaPlay,"MediaPlay",t.Unknown,e,0,e,e,e],[1,n.MediaRecord,"MediaRecord",t.Unknown,e,0,e,e,e],[1,n.MediaFastForward,"MediaFastForward",t.Unknown,e,0,e,e,e],[1,n.MediaRewind,"MediaRewind",t.Unknown,e,0,e,e,e],[1,n.MediaTrackNext,"MediaTrackNext",t.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,n.MediaTrackPrevious,"MediaTrackPrevious",t.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,n.MediaStop,"MediaStop",t.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,n.Eject,"Eject",t.Unknown,e,0,e,e,e],[1,n.MediaPlayPause,"MediaPlayPause",t.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,n.MediaSelect,"MediaSelect",t.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,n.LaunchMail,"LaunchMail",t.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,n.LaunchApp2,"LaunchApp2",t.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,n.LaunchApp1,"LaunchApp1",t.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,n.SelectTask,"SelectTask",t.Unknown,e,0,e,e,e],[1,n.LaunchScreenSaver,"LaunchScreenSaver",t.Unknown,e,0,e,e,e],[1,n.BrowserSearch,"BrowserSearch",t.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,n.BrowserHome,"BrowserHome",t.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,n.BrowserBack,"BrowserBack",t.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,n.BrowserForward,"BrowserForward",t.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,n.BrowserStop,"BrowserStop",t.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,n.BrowserRefresh,"BrowserRefresh",t.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,n.BrowserFavorites,"BrowserFavorites",t.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,n.ZoomToggle,"ZoomToggle",t.Unknown,e,0,e,e,e],[1,n.MailReply,"MailReply",t.Unknown,e,0,e,e,e],[1,n.MailForward,"MailForward",t.Unknown,e,0,e,e,e],[1,n.MailSend,"MailSend",t.Unknown,e,0,e,e,e],[1,n.None,e,t.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,n.None,e,t.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,n.None,e,t.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,n.None,e,t.Unknown,e,0,"VK_KANA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HANGUL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_JUNJA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_FINAL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HANJA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_KANJI",e,e],[1,n.None,e,t.Unknown,e,0,"VK_CONVERT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_NONCONVERT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ACCEPT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_MODECHANGE",e,e],[1,n.None,e,t.Unknown,e,0,"VK_SELECT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PRINT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EXECUTE",e,e],[1,n.None,e,t.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HELP",e,e],[1,n.None,e,t.Unknown,e,0,"VK_APPS",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PACKET",e,e],[1,n.None,e,t.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,n.None,e,t.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ATTN",e,e],[1,n.None,e,t.Unknown,e,0,"VK_CRSEL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EXSEL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EREOF",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PLAY",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ZOOM",e,e],[1,n.None,e,t.Unknown,e,0,"VK_NONAME",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PA1",e,e],[1,n.None,e,t.Unknown,e,0,"VK_OEM_CLEAR",e,e]],L=[],A=[];for(const v of w){const[E,R,b,o,r,l,c,M,_]=v;if(A[R]||(A[R]=!0,a[R]=b,u[b]=R,f[b.toLowerCase()]=R,E&&(i.$Wr[R]=o,o!==t.Unknown&&o!==t.Enter&&o!==t.Ctrl&&o!==t.Shift&&o!==t.Alt&&o!==t.Meta&&(i.$Xr[o]=R))),!L[o]){if(L[o]=!0,!r)throw new Error(`String representation missing for key code ${o} around scan code ${b}`);h.define(o,r),N.define(o,M||r),m.define(o,_||M||r)}l&&(i.$Tr[l]=o),c&&(i.$Ur[c]=o)}i.$Xr[t.Enter]=n.Enter})();var $;(function(e){function w(b){return h.keyCodeToStr(b)}e.toString=w;function L(b){return h.strToKeyCode(b)}e.fromString=L;function A(b){return N.keyCodeToStr(b)}e.toUserSettingsUS=A;function v(b){return m.keyCodeToStr(b)}e.toUserSettingsGeneral=v;function E(b){return N.strToKeyCode(b)||m.strToKeyCode(b)}e.fromUserSettings=E;function R(b){if(b>=t.Numpad0&&b<=t.NumpadDivide)return null;switch(b){case t.UpArrow:return"Up";case t.DownArrow:return"Down";case t.LeftArrow:return"Left";case t.RightArrow:return"Right"}return h.keyCodeToStr(b)}e.toElectronAccelerator=R})($||(i.KeyCodeUtils=$={}));var g;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(g||(i.KeyMod=g={}));function d(e,w){const L=(w&65535)<<16>>>0;return(e|L)>>>0}}),ne(ie[41],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$T=void 0;class t{constructor(p){this.d=p,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(p){this.c=p}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}i.$T=t}),ne(ie[24],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$5c=void 0;class t{static{this.Undefined=new t(void 0)}constructor(h){this.element=h,this.next=t.Undefined,this.prev=t.Undefined}}class n{constructor(){this.a=t.Undefined,this.b=t.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===t.Undefined}clear(){let h=this.a;for(;h!==t.Undefined;){const N=h.next;h.prev=t.Undefined,h.next=t.Undefined,h=N}this.a=t.Undefined,this.b=t.Undefined,this.c=0}unshift(h){return this.d(h,!1)}push(h){return this.d(h,!0)}d(h,N){const m=new t(h);if(this.a===t.Undefined)this.a=m,this.b=m;else if(N){const u=this.b;this.b=m,m.prev=u,u.next=m}else{const u=this.a;this.a=m,m.next=u,u.prev=m}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(m))}}shift(){if(this.a!==t.Undefined){const h=this.a.element;return this.e(this.a),h}}pop(){if(this.b!==t.Undefined){const h=this.b.element;return this.e(this.b),h}}e(h){if(h.prev!==t.Undefined&&h.next!==t.Undefined){const N=h.prev;N.next=h.next,h.next.prev=N}else h.prev===t.Undefined&&h.next===t.Undefined?(this.a=t.Undefined,this.b=t.Undefined):h.next===t.Undefined?(this.b=this.b.prev,this.b.next=t.Undefined):h.prev===t.Undefined&&(this.a=this.a.next,this.a.prev=t.Undefined);this.c-=1}*[Symbol.iterator](){let h=this.a;for(;h!==t.Undefined;)yield h.element,h=h.next}}i.$5c=n}),ne(ie[16],re([0,1]),function(x,i){"use strict";var t,n,p;Object.defineProperty(i,"__esModule",{value:!0}),i.$Hc=i.$Gc=i.$Fc=i.$Ec=i.$Dc=i.$Cc=i.Touch=i.$Bc=i.$Ac=void 0,i.$xc=h,i.$yc=N,i.$zc=m,i.$Ic=R;function h(b,o,r){let l=b.get(o);return l===void 0&&(l=r,b.set(o,l)),l}function N(b){const o=[];return b.forEach((r,l)=>{o.push(`${l} => ${r}`)}),`Map(${b.size}) {${o.join(", ")}}`}function m(b){const o=[];return b.forEach(r=>{o.push(r)}),`Set(${b.size}) {${o.join(", ")}}`}class a{constructor(o,r){this.uri=o,this.value=r}}function u(b){return Array.isArray(b)}class f{static{this.c=o=>o.toString()}constructor(o,r){if(this[t]="ResourceMap",o instanceof f)this.d=new Map(o.d),this.e=r??f.c;else if(u(o)){this.d=new Map,this.e=r??f.c;for(const[l,c]of o)this.set(l,c)}else this.d=new Map,this.e=o??f.c}set(o,r){return this.d.set(this.e(o),new a(o,r)),this}get(o){return this.d.get(this.e(o))?.value}has(o){return this.d.has(this.e(o))}get size(){return this.d.size}clear(){this.d.clear()}delete(o){return this.d.delete(this.e(o))}forEach(o,r){typeof r<"u"&&(o=o.bind(r));for(const[l,c]of this.d)o(c.value,c.uri,this)}*values(){for(const o of this.d.values())yield o.value}*keys(){for(const o of this.d.values())yield o.uri}*entries(){for(const o of this.d.values())yield[o.uri,o.value]}*[(t=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.d)yield[o.uri,o.value]}}i.$Ac=f;class ${constructor(o,r){this[n]="ResourceSet",!o||typeof o=="function"?this.c=new f(o):(this.c=new f(r),o.forEach(this.add,this))}get size(){return this.c.size}add(o){return this.c.set(o,o),this}clear(){this.c.clear()}delete(o){return this.c.delete(o)}forEach(o,r){this.c.forEach((l,c)=>o.call(r,c,c,this))}has(o){return this.c.has(o)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}i.$Bc=$;var g;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(g||(i.Touch=g={}));class d{constructor(){this[p]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(o){return this.c.has(o)}get(o,r=g.None){const l=this.c.get(o);if(l)return r!==g.None&&this.m(l,r),l.value}set(o,r,l=g.None){let c=this.c.get(o);if(c)c.value=r,l!==g.None&&this.m(c,l);else{switch(c={key:o,value:r,next:void 0,previous:void 0},l){case g.None:this.k(c);break;case g.AsOld:this.j(c);break;case g.AsNew:this.k(c);break;default:this.k(c);break}this.c.set(o,c),this.f++}return this}delete(o){return!!this.remove(o)}remove(o){const r=this.c.get(o);if(r)return this.c.delete(o),this.l(r),this.f--,r.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const o=this.d;return this.c.delete(o.key),this.l(o),this.f--,o.value}forEach(o,r){const l=this.g;let c=this.d;for(;c;){if(r?o.bind(r)(c.value,c.key,this):o(c.value,c.key,this),this.g!==l)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const o=this,r=this.g;let l=this.d;const c={[Symbol.iterator](){return c},next(){if(o.g!==r)throw new Error("LinkedMap got modified during iteration.");if(l){const M={value:l.key,done:!1};return l=l.next,M}else return{value:void 0,done:!0}}};return c}values(){const o=this,r=this.g;let l=this.d;const c={[Symbol.iterator](){return c},next(){if(o.g!==r)throw new Error("LinkedMap got modified during iteration.");if(l){const M={value:l.value,done:!1};return l=l.next,M}else return{value:void 0,done:!0}}};return c}entries(){const o=this,r=this.g;let l=this.d;const c={[Symbol.iterator](){return c},next(){if(o.g!==r)throw new Error("LinkedMap got modified during iteration.");if(l){const M={value:[l.key,l.value],done:!1};return l=l.next,M}else return{value:void 0,done:!0}}};return c}[(p=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(o){if(o>=this.size)return;if(o===0){this.clear();return}let r=this.d,l=this.size;for(;r&&l>o;)this.c.delete(r.key),r=r.next,l--;this.d=r,this.f=l,r&&(r.previous=void 0),this.g++}i(o){if(o>=this.size)return;if(o===0){this.clear();return}let r=this.e,l=this.size;for(;r&&l>o;)this.c.delete(r.key),r=r.previous,l--;this.e=r,this.f=l,r&&(r.next=void 0),this.g++}j(o){if(!this.d&&!this.e)this.e=o;else if(this.d)o.next=this.d,this.d.previous=o;else throw new Error("Invalid list");this.d=o,this.g++}k(o){if(!this.d&&!this.e)this.d=o;else if(this.e)o.previous=this.e,this.e.next=o;else throw new Error("Invalid list");this.e=o,this.g++}l(o){if(o===this.d&&o===this.e)this.d=void 0,this.e=void 0;else if(o===this.d){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.d=o.next}else if(o===this.e){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.e=o.previous}else{const r=o.next,l=o.previous;if(!r||!l)throw new Error("Invalid list");r.previous=l,l.next=r}o.next=void 0,o.previous=void 0,this.g++}m(o,r){if(!this.d||!this.e)throw new Error("Invalid list");if(!(r!==g.AsOld&&r!==g.AsNew)){if(r===g.AsOld){if(o===this.d)return;const l=o.next,c=o.previous;o===this.e?(c.next=void 0,this.e=c):(l.previous=c,c.next=l),o.previous=void 0,o.next=this.d,this.d.previous=o,this.d=o,this.g++}else if(r===g.AsNew){if(o===this.e)return;const l=o.next,c=o.previous;o===this.d?(l.previous=void 0,this.d=l):(l.previous=c,c.next=l),o.next=void 0,o.previous=this.e,this.e.next=o,this.e=o,this.g++}}}toJSON(){const o=[];return this.forEach((r,l)=>{o.push([l,r])}),o}fromJSON(o){this.clear();for(const[r,l]of o)this.set(r,l)}}i.$Cc=d;class e extends d{constructor(o,r=1){super(),this.n=o,this.o=Math.min(Math.max(0,r),1)}get limit(){return this.n}set limit(o){this.n=o,this.p()}get ratio(){return this.o}set ratio(o){this.o=Math.min(Math.max(0,o),1),this.p()}get(o,r=g.AsNew){return super.get(o,r)}peek(o){return super.get(o,g.None)}set(o,r){return super.set(o,r,g.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class w extends e{constructor(o,r=1){super(o,r)}q(o){this.h(o)}set(o,r){return super.set(o,r),this.p(),this}}i.$Dc=w;class L extends e{constructor(o,r=1){super(o,r)}q(o){this.i(o)}set(o,r){return this.n<=this.size&&!this.has(o)&&this.q(Math.round(this.n*this.o)-1),super.set(o,r),this}}i.$Ec=L;class A{constructor(){this.c=new Map}add(o){return this.c.set(o,(this.c.get(o)||0)+1),this}delete(o){let r=this.c.get(o)||0;return r===0?!1:(r--,r===0?this.c.delete(o):this.c.set(o,r),!0)}has(o){return this.c.has(o)}}i.$Fc=A;class v{constructor(o){if(this.c=new Map,this.d=new Map,o)for(const[r,l]of o)this.set(r,l)}clear(){this.c.clear(),this.d.clear()}set(o,r){this.c.set(o,r),this.d.set(r,o)}get(o){return this.c.get(o)}getKey(o){return this.d.get(o)}delete(o){const r=this.c.get(o);return r===void 0?!1:(this.c.delete(o),this.d.delete(r),!0)}forEach(o,r){this.c.forEach((l,c)=>{o.call(r,l,c,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}i.$Gc=v;class E{constructor(){this.c=new Map}add(o,r){let l=this.c.get(o);l||(l=new Set,this.c.set(o,l)),l.add(r)}delete(o,r){const l=this.c.get(o);l&&(l.delete(r),l.size===0&&this.c.delete(o))}forEach(o,r){const l=this.c.get(o);l&&l.forEach(r)}get(o){const r=this.c.get(o);return r||new Set}}i.$Hc=E;function R(b,o){if(b===o)return!0;if(b.size!==o.size)return!1;for(const[r,l]of b)if(!o.has(r)||o.get(r)!==l)return!1;for(const[r]of o)if(!b.has(r))return!1;return!0}}),ne(ie[12],re([0,1,7,37,16,22,23]),function(x,i,t,n,p,h,N){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$4c=i.$2c=i.$1c=i.$Zc=i.$Yc=i.$Xc=i.$Wc=i.$Vc=i.$Uc=i.$Tc=i.$Jc=void 0,i.$Kc=f,i.$Lc=$,i.$Mc=g,i.$Nc=w,i.$Oc=L,i.$Pc=A,i.$Qc=v,i.$Rc=E,i.$Sc=R,i.$3c=j;const m=!1;let a=null;class u{constructor(){this.b=new Map}static{this.a=0}c(F){let y=this.b.get(F);return y||(y={parent:null,source:null,isSingleton:!1,value:F,idx:u.a++},this.b.set(F,y)),y}trackDisposable(F){const y=this.c(F);y.source||(y.source=new Error().stack)}setParent(F,y){const W=this.c(F);W.parent=y}markAsDisposed(F){this.b.delete(F)}markAsSingleton(F){this.c(F).isSingleton=!0}f(F,y){const W=y.get(F);if(W)return W;const B=F.parent?this.f(this.c(F.parent),y):F;return y.set(F,B),B}getTrackedDisposables(){const F=new Map;return[...this.b.entries()].filter(([,W])=>W.source!==null&&!this.f(W,F).isSingleton).flatMap(([W])=>W)}computeLeakingDisposables(F=10,y){let W;if(y)W=y;else{const z=new Map,Q=[...this.b.values()].filter(k=>k.source!==null&&!this.f(k,z).isSingleton);if(Q.length===0)return;const ee=new Set(Q.map(k=>k.value));if(W=Q.filter(k=>!(k.parent&&ee.has(k.parent))),W.length===0)throw new Error("There are cyclic diposable chains!")}if(!W)return;function B(z){function Q(k,H){for(;k.length>0&&H.some(fe=>typeof fe=="string"?fe===k[0]:k[0].match(fe));)k.shift()}const ee=z.source.split(`
`).map(k=>k.trim().replace("at ","")).filter(k=>k!=="");return Q(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const O=new p.$Hc;for(const z of W){const Q=B(z);for(let ee=0;ee<=Q.length;ee++)O.add(Q.slice(0,ee).join(`
`),z)}W.sort((0,t.$5b)(z=>z.idx,t.$7b));let X="",Y=0;for(const z of W.slice(0,F)){Y++;const Q=B(z),ee=[];for(let k=0;k<Q.length;k++){let H=Q[k];H=`(shared with ${O.get(Q.slice(0,k+1).join(`
`)).size}/${W.length} leaks) at ${H}`;const oe=O.get(Q.slice(0,k).join(`
`)),we=(0,n.$c)([...oe].map(s=>B(s)[k]),s=>s);delete we[Q[k]];for(const[s,Te]of Object.entries(we))ee.unshift(`    - stacktraces of ${Te.length} other leaks continue with ${s}`);ee.unshift(H)}X+=`


==================== Leaking disposable ${Y}/${W.length}: ${z.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return W.length>F&&(X+=`


... and ${W.length-F} more leaking disposables

`),{leaks:W,details:X}}}i.$Jc=u;function f(I){a=I}if(m){const I="__is_disposable_tracked__";f(new class{trackDisposable(F){const y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{F[I]||console.log(y)},3e3)}setParent(F,y){if(F&&F!==o.None)try{F[I]=!0}catch{}}markAsDisposed(F){if(F&&F!==o.None)try{F[I]=!0}catch{}}markAsSingleton(F){}})}function $(I){return a?.trackDisposable(I),I}function g(I){a?.markAsDisposed(I)}function d(I,F){a?.setParent(I,F)}function e(I,F){if(a)for(const y of I)a.setParent(y,F)}function w(I){return a?.markAsSingleton(I),I}function L(I){return typeof I=="object"&&I!==null&&typeof I.dispose=="function"&&I.dispose.length===0}function A(I){if(N.Iterable.is(I)){const F=[];for(const y of I)if(y)try{y.dispose()}catch(W){F.push(W)}if(F.length===1)throw F[0];if(F.length>1)throw new AggregateError(F,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}function v(I){for(const F of I)L(F)&&F.dispose();return[]}function E(...I){const F=R(()=>A(I));return e(I,F),F}function R(I){const F=$({dispose:(0,h.$cb)(()=>{g(F),I()})});return F}class b{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,$(this)}dispose(){this.g||(g(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{A(this.f)}finally{this.f.clear()}}add(F){if(!F)return F;if(F===this)throw new Error("Cannot register a disposable on itself!");return d(F,this),this.g?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(F),F}delete(F){if(F){if(F===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(F),F.dispose()}}deleteAndLeak(F){F&&this.f.has(F)&&(this.f.delete(F),d(F,null))}}i.$Tc=b;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new b,$(this),d(this.q,this)}dispose(){g(this),this.q.dispose()}B(F){if(F===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(F)}}i.$Uc=o;class r{constructor(){this.b=!1,$(this)}get value(){return this.b?void 0:this.a}set value(F){this.b||F===this.a||(this.a?.dispose(),F&&d(F,this),this.a=F)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const F=this.a;return this.a=void 0,F&&d(F,null),F}}i.$Vc=r;class l{constructor(F){this.a=new r,this.b=!1,this.a.value=F}get value(){return this.a.value}set value(F){this.b||F===this.a.value||(this.a.value=F)}dispose(){this.b=!0,this.a.dispose()}}i.$Wc=l;class c{constructor(F){this.b=F,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}i.$Xc=c;class M{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,$(this)}set(F){let y=F;return this.unset=()=>y=void 0,this.isset=()=>y!==void 0,this.dispose=()=>{y&&(y(),y=void 0,g(this))},this}}i.$Yc=M;class _{constructor(){this.a=new Map}acquire(F,...y){let W=this.a.get(F);W||(W={counter:0,object:this.b(F,...y)},this.a.set(F,W));const{object:B}=W,O=(0,h.$cb)(()=>{--W.counter===0&&(this.c(F,W.object),this.a.delete(F))});return W.counter++,{object:B,dispose:O}}}i.$Zc=_;class T{constructor(F){this.a=F}async acquire(F,...y){const W=this.a.acquire(F,...y);try{return{object:await W.object,dispose:()=>W.dispose()}}catch(B){throw W.dispose(),B}}}i.$1c=T;class D{constructor(F){this.object=F}dispose(){}}i.$2c=D;function j(I){const F=new b;try{I(F)}finally{F.dispose()}}class P{constructor(){this.a=new Map,this.b=!1,$(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{A(this.a.values())}finally{this.a.clear()}}has(F){return this.a.has(F)}get size(){return this.a.size}get(F){return this.a.get(F)}set(F,y,W=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),W||this.a.get(F)?.dispose(),this.a.set(F,y)}deleteAndDispose(F){this.a.get(F)?.dispose(),this.a.delete(F)}deleteAndLeak(F){const y=this.a.get(F);return this.a.delete(F),y}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}i.$4c=P}),ne(ie[42],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MarshalledId=void 0;var t;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadInstance=8]="CommentThreadInstance",n[n.CommentThreadReply=9]="CommentThreadReply",n[n.CommentNode=10]="CommentNode",n[n.CommentThreadNode=11]="CommentThreadNode",n[n.TimelineActionContext=12]="TimelineActionContext",n[n.NotebookCellActionContext=13]="NotebookCellActionContext",n[n.NotebookActionContext=14]="NotebookActionContext",n[n.TerminalContext=15]="TerminalContext",n[n.TestItemContext=16]="TestItemContext",n[n.Date=17]="Date",n[n.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(t||(i.MarshalledId=t={}))}),ne(ie[17],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$J=i.$I=i.$H=i.$G=i.$F=i.OS=i.OperatingSystem=i.$C=i.$B=i.$A=i.$z=i.$y=i.Language=i.$x=i.$w=i.$v=i.$u=i.$t=i.$s=i.$r=i.$q=i.$p=i.$o=i.$n=i.$m=i.$l=i.$k=i.$j=i.Platform=i.$h=void 0,i.$i=o,i.$E=T,i.$K=D,i.$h="en";let t=!1,n=!1,p=!1,h=!1,N=!1,m=!1,a=!1,u=!1,f=!1,$=!1,g,d=i.$h,e=i.$h,w,L;const A=globalThis;let v;typeof A.vscode<"u"&&typeof A.vscode.process<"u"?v=A.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(v=process);const E=typeof v?.versions?.electron=="string",R=E&&v?.type==="renderer";if(typeof v=="object"){t=v.platform==="win32",n=v.platform==="darwin",p=v.platform==="linux",h=p&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,a=E,f=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=i.$h,d=i.$h;const j=v.env.VSCODE_NLS_CONFIG;if(j)try{const P=JSON.parse(j);g=P.userLocale,e=P.osLocale,d=P.resolvedLanguage||i.$h,w=P.languagePack?.translationsConfigFile}catch{}N=!0}else typeof navigator=="object"&&!R?(L=navigator.userAgent,t=L.indexOf("Windows")>=0,n=L.indexOf("Macintosh")>=0,u=(L.indexOf("Macintosh")>=0||L.indexOf("iPad")>=0||L.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,p=L.indexOf("Linux")>=0,$=L?.indexOf("Mobi")>=0,m=!0,d=globalThis._VSCODE_NLS_LANGUAGE||i.$h,g=navigator.language.toLowerCase(),e=g):console.error("Unable to resolve platform.");var b;(function(j){j[j.Web=0]="Web",j[j.Mac=1]="Mac",j[j.Linux=2]="Linux",j[j.Windows=3]="Windows"})(b||(i.Platform=b={}));function o(j){switch(j){case b.Web:return"Web";case b.Mac:return"Mac";case b.Linux:return"Linux";case b.Windows:return"Windows"}}let r=b.Web;n?r=b.Mac:t?r=b.Windows:p&&(r=b.Linux),i.$j=t,i.$k=n,i.$l=p,i.$m=h,i.$n=N,i.$o=a,i.$p=m,i.$q=m&&typeof A.importScripts=="function",i.$r=i.$q?A.origin:void 0,i.$s=u,i.$t=$,i.$u=f,i.$v=r,i.$w=L,i.$x=d;var l;(function(j){function P(){return i.$x}j.value=P;function I(){return i.$x.length===2?i.$x==="en":i.$x.length>=3?i.$x[0]==="e"&&i.$x[1]==="n"&&i.$x[2]==="-":!1}j.isDefaultVariant=I;function F(){return i.$x==="en"}j.isDefault=F})(l||(i.Language=l={})),i.$y=g,i.$z=e,i.$A=w,i.$B=typeof A.postMessage=="function"&&!A.importScripts,i.$C=(()=>{if(i.$B){const j=[];A.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let F=0,y=j.length;F<y;F++){const W=j[F];if(W.id===I.data.vscodeScheduleAsyncWork){j.splice(F,1),W.callback();return}}});let P=0;return I=>{const F=++P;j.push({id:F,callback:I}),A.postMessage({vscodeScheduleAsyncWork:F},"*")}}return j=>setTimeout(j)})();var c;(function(j){j[j.Windows=1]="Windows",j[j.Macintosh=2]="Macintosh",j[j.Linux=3]="Linux"})(c||(i.OperatingSystem=c={})),i.OS=n||u?c.Macintosh:t?c.Windows:c.Linux;let M=!0,_=!1;function T(){if(!_){_=!0;const j=new Uint8Array(2);j[0]=1,j[1]=2,M=new Uint16Array(j.buffer)[0]===513}return M}i.$F=!!(i.$w&&i.$w.indexOf("Chrome")>=0),i.$G=!!(i.$w&&i.$w.indexOf("Firefox")>=0),i.$H=!!(!i.$F&&i.$w&&i.$w.indexOf("Safari")>=0),i.$I=!!(i.$w&&i.$w.indexOf("Edg/")>=0),i.$J=!!(i.$w&&i.$w.indexOf("Android")>=0);function D(j){return parseFloat(j)>=20}}),ne(ie[43],re([0,1,17]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ec=i.$dc=i.env=i.cwd=void 0;let n;const p=globalThis.vscode;if(typeof p<"u"&&typeof p.process<"u"){const h=p.process;n={get platform(){return h.platform},get arch(){return h.arch},get env(){return h.env},cwd(){return h.cwd()}}}else typeof process<"u"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return t.$j?"win32":t.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};i.cwd=n.cwd,i.env=n.env,i.$dc=n.platform,i.$ec=n.arch});var Ke=this&&this.__createBinding||(Object.create?function(x,i,t,n){n===void 0&&(n=t);var p=Object.getOwnPropertyDescriptor(i,t);(!p||("get"in p?!i.__esModule:p.writable||p.configurable))&&(p={enumerable:!0,get:function(){return i[t]}}),Object.defineProperty(x,n,p)}:function(x,i,t,n){n===void 0&&(n=t),x[n]=i[t]}),Ce=this&&this.__setModuleDefault||(Object.create?function(x,i){Object.defineProperty(x,"default",{enumerable:!0,value:i})}:function(x,i){x.default=i}),Oe=this&&this.__importStar||function(x){if(x&&x.__esModule)return x;var i={};if(x!=null)for(var t in x)t!=="default"&&Object.prototype.hasOwnProperty.call(x,t)&&Ke(i,x,t);return Ce(i,x),i};ne(ie[44],re([0,1,43]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$tc=i.sep=i.$rc=i.$qc=i.$pc=i.$oc=i.$nc=i.$mc=i.$lc=i.$kc=i.$jc=i.$ic=i.$hc=i.$gc=i.$fc=void 0,t=Oe(t);const n=65,p=97,h=90,N=122,m=46,a=47,u=92,f=58,$=63;class g extends Error{constructor(l,c,M){let _;typeof c=="string"&&c.indexOf("not ")===0?(_="must not be",c=c.replace(/^not /,"")):_="must be";const T=l.indexOf(".")!==-1?"property":"argument";let D=`The "${l}" ${T} ${_} of type ${c}`;D+=`. Received type ${typeof M}`,super(D),this.code="ERR_INVALID_ARG_TYPE"}}function d(r,l){if(r===null||typeof r!="object")throw new g(l,"Object",r)}function e(r,l){if(typeof r!="string")throw new g(l,"string",r)}const w=t.$dc==="win32";function L(r){return r===a||r===u}function A(r){return r===a}function v(r){return r>=n&&r<=h||r>=p&&r<=N}function E(r,l,c,M){let _="",T=0,D=-1,j=0,P=0;for(let I=0;I<=r.length;++I){if(I<r.length)P=r.charCodeAt(I);else{if(M(P))break;P=a}if(M(P)){if(!(D===I-1||j===1))if(j===2){if(_.length<2||T!==2||_.charCodeAt(_.length-1)!==m||_.charCodeAt(_.length-2)!==m){if(_.length>2){const F=_.lastIndexOf(c);F===-1?(_="",T=0):(_=_.slice(0,F),T=_.length-1-_.lastIndexOf(c)),D=I,j=0;continue}else if(_.length!==0){_="",T=0,D=I,j=0;continue}}l&&(_+=_.length>0?`${c}..`:"..",T=2)}else _.length>0?_+=`${c}${r.slice(D+1,I)}`:_=r.slice(D+1,I),T=I-D-1;D=I,j=0}else P===m&&j!==-1?++j:j=-1}return _}function R(r){return r?`${r[0]==="."?"":"."}${r}`:""}function b(r,l){d(l,"pathObject");const c=l.dir||l.root,M=l.base||`${l.name||""}${R(l.ext)}`;return c?c===l.root?`${c}${M}`:`${c}${r}${M}`:M}i.$fc={resolve(...r){let l="",c="",M=!1;for(let _=r.length-1;_>=-1;_--){let T;if(_>=0){if(T=r[_],e(T,`paths[${_}]`),T.length===0)continue}else l.length===0?T=t.cwd():(T=t.env[`=${l}`]||t.cwd(),(T===void 0||T.slice(0,2).toLowerCase()!==l.toLowerCase()&&T.charCodeAt(2)===u)&&(T=`${l}\\`));const D=T.length;let j=0,P="",I=!1;const F=T.charCodeAt(0);if(D===1)L(F)&&(j=1,I=!0);else if(L(F))if(I=!0,L(T.charCodeAt(1))){let y=2,W=y;for(;y<D&&!L(T.charCodeAt(y));)y++;if(y<D&&y!==W){const B=T.slice(W,y);for(W=y;y<D&&L(T.charCodeAt(y));)y++;if(y<D&&y!==W){for(W=y;y<D&&!L(T.charCodeAt(y));)y++;(y===D||y!==W)&&(P=`\\\\${B}\\${T.slice(W,y)}`,j=y)}}}else j=1;else v(F)&&T.charCodeAt(1)===f&&(P=T.slice(0,2),j=2,D>2&&L(T.charCodeAt(2))&&(I=!0,j=3));if(P.length>0)if(l.length>0){if(P.toLowerCase()!==l.toLowerCase())continue}else l=P;if(M){if(l.length>0)break}else if(c=`${T.slice(j)}\\${c}`,M=I,I&&l.length>0)break}return c=E(c,!M,"\\",L),M?`${l}\\${c}`:`${l}${c}`||"."},normalize(r){e(r,"path");const l=r.length;if(l===0)return".";let c=0,M,_=!1;const T=r.charCodeAt(0);if(l===1)return A(T)?"\\":r;if(L(T))if(_=!0,L(r.charCodeAt(1))){let j=2,P=j;for(;j<l&&!L(r.charCodeAt(j));)j++;if(j<l&&j!==P){const I=r.slice(P,j);for(P=j;j<l&&L(r.charCodeAt(j));)j++;if(j<l&&j!==P){for(P=j;j<l&&!L(r.charCodeAt(j));)j++;if(j===l)return`\\\\${I}\\${r.slice(P)}\\`;j!==P&&(M=`\\\\${I}\\${r.slice(P,j)}`,c=j)}}}else c=1;else v(T)&&r.charCodeAt(1)===f&&(M=r.slice(0,2),c=2,l>2&&L(r.charCodeAt(2))&&(_=!0,c=3));let D=c<l?E(r.slice(c),!_,"\\",L):"";return D.length===0&&!_&&(D="."),D.length>0&&L(r.charCodeAt(l-1))&&(D+="\\"),M===void 0?_?`\\${D}`:D:_?`${M}\\${D}`:`${M}${D}`},isAbsolute(r){e(r,"path");const l=r.length;if(l===0)return!1;const c=r.charCodeAt(0);return L(c)||l>2&&v(c)&&r.charCodeAt(1)===f&&L(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let l,c;for(let T=0;T<r.length;++T){const D=r[T];e(D,"path"),D.length>0&&(l===void 0?l=c=D:l+=`\\${D}`)}if(l===void 0)return".";let M=!0,_=0;if(typeof c=="string"&&L(c.charCodeAt(0))){++_;const T=c.length;T>1&&L(c.charCodeAt(1))&&(++_,T>2&&(L(c.charCodeAt(2))?++_:M=!1))}if(M){for(;_<l.length&&L(l.charCodeAt(_));)_++;_>=2&&(l=`\\${l.slice(_)}`)}return i.$fc.normalize(l)},relative(r,l){if(e(r,"from"),e(l,"to"),r===l)return"";const c=i.$fc.resolve(r),M=i.$fc.resolve(l);if(c===M||(r=c.toLowerCase(),l=M.toLowerCase(),r===l))return"";let _=0;for(;_<r.length&&r.charCodeAt(_)===u;)_++;let T=r.length;for(;T-1>_&&r.charCodeAt(T-1)===u;)T--;const D=T-_;let j=0;for(;j<l.length&&l.charCodeAt(j)===u;)j++;let P=l.length;for(;P-1>j&&l.charCodeAt(P-1)===u;)P--;const I=P-j,F=D<I?D:I;let y=-1,W=0;for(;W<F;W++){const O=r.charCodeAt(_+W);if(O!==l.charCodeAt(j+W))break;O===u&&(y=W)}if(W!==F){if(y===-1)return M}else{if(I>F){if(l.charCodeAt(j+W)===u)return M.slice(j+W+1);if(W===2)return M.slice(j+W)}D>F&&(r.charCodeAt(_+W)===u?y=W:W===2&&(y=3)),y===-1&&(y=0)}let B="";for(W=_+y+1;W<=T;++W)(W===T||r.charCodeAt(W)===u)&&(B+=B.length===0?"..":"\\..");return j+=y,B.length>0?`${B}${M.slice(j,P)}`:(M.charCodeAt(j)===u&&++j,M.slice(j,P))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const l=i.$fc.resolve(r);if(l.length<=2)return r;if(l.charCodeAt(0)===u){if(l.charCodeAt(1)===u){const c=l.charCodeAt(2);if(c!==$&&c!==m)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(v(l.charCodeAt(0))&&l.charCodeAt(1)===f&&l.charCodeAt(2)===u)return`\\\\?\\${l}`;return r},dirname(r){e(r,"path");const l=r.length;if(l===0)return".";let c=-1,M=0;const _=r.charCodeAt(0);if(l===1)return L(_)?r:".";if(L(_)){if(c=M=1,L(r.charCodeAt(1))){let j=2,P=j;for(;j<l&&!L(r.charCodeAt(j));)j++;if(j<l&&j!==P){for(P=j;j<l&&L(r.charCodeAt(j));)j++;if(j<l&&j!==P){for(P=j;j<l&&!L(r.charCodeAt(j));)j++;if(j===l)return r;j!==P&&(c=M=j+1)}}}}else v(_)&&r.charCodeAt(1)===f&&(c=l>2&&L(r.charCodeAt(2))?3:2,M=c);let T=-1,D=!0;for(let j=l-1;j>=M;--j)if(L(r.charCodeAt(j))){if(!D){T=j;break}}else D=!1;if(T===-1){if(c===-1)return".";T=c}return r.slice(0,T)},basename(r,l){l!==void 0&&e(l,"suffix"),e(r,"path");let c=0,M=-1,_=!0,T;if(r.length>=2&&v(r.charCodeAt(0))&&r.charCodeAt(1)===f&&(c=2),l!==void 0&&l.length>0&&l.length<=r.length){if(l===r)return"";let D=l.length-1,j=-1;for(T=r.length-1;T>=c;--T){const P=r.charCodeAt(T);if(L(P)){if(!_){c=T+1;break}}else j===-1&&(_=!1,j=T+1),D>=0&&(P===l.charCodeAt(D)?--D===-1&&(M=T):(D=-1,M=j))}return c===M?M=j:M===-1&&(M=r.length),r.slice(c,M)}for(T=r.length-1;T>=c;--T)if(L(r.charCodeAt(T))){if(!_){c=T+1;break}}else M===-1&&(_=!1,M=T+1);return M===-1?"":r.slice(c,M)},extname(r){e(r,"path");let l=0,c=-1,M=0,_=-1,T=!0,D=0;r.length>=2&&r.charCodeAt(1)===f&&v(r.charCodeAt(0))&&(l=M=2);for(let j=r.length-1;j>=l;--j){const P=r.charCodeAt(j);if(L(P)){if(!T){M=j+1;break}continue}_===-1&&(T=!1,_=j+1),P===m?c===-1?c=j:D!==1&&(D=1):c!==-1&&(D=-1)}return c===-1||_===-1||D===0||D===1&&c===_-1&&c===M+1?"":r.slice(c,_)},format:b.bind(null,"\\"),parse(r){e(r,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return l;const c=r.length;let M=0,_=r.charCodeAt(0);if(c===1)return L(_)?(l.root=l.dir=r,l):(l.base=l.name=r,l);if(L(_)){if(M=1,L(r.charCodeAt(1))){let y=2,W=y;for(;y<c&&!L(r.charCodeAt(y));)y++;if(y<c&&y!==W){for(W=y;y<c&&L(r.charCodeAt(y));)y++;if(y<c&&y!==W){for(W=y;y<c&&!L(r.charCodeAt(y));)y++;y===c?M=y:y!==W&&(M=y+1)}}}}else if(v(_)&&r.charCodeAt(1)===f){if(c<=2)return l.root=l.dir=r,l;if(M=2,L(r.charCodeAt(2))){if(c===3)return l.root=l.dir=r,l;M=3}}M>0&&(l.root=r.slice(0,M));let T=-1,D=M,j=-1,P=!0,I=r.length-1,F=0;for(;I>=M;--I){if(_=r.charCodeAt(I),L(_)){if(!P){D=I+1;break}continue}j===-1&&(P=!1,j=I+1),_===m?T===-1?T=I:F!==1&&(F=1):T!==-1&&(F=-1)}return j!==-1&&(T===-1||F===0||F===1&&T===j-1&&T===D+1?l.base=l.name=r.slice(D,j):(l.name=r.slice(D,T),l.base=r.slice(D,j),l.ext=r.slice(T,j))),D>0&&D!==M?l.dir=r.slice(0,D-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(w){const r=/\\/g;return()=>{const l=t.cwd().replace(r,"/");return l.slice(l.indexOf("/"))}}return()=>t.cwd()})();i.$gc={resolve(...r){let l="",c=!1;for(let M=r.length-1;M>=-1&&!c;M--){const _=M>=0?r[M]:o();e(_,`paths[${M}]`),_.length!==0&&(l=`${_}/${l}`,c=_.charCodeAt(0)===a)}return l=E(l,!c,"/",A),c?`/${l}`:l.length>0?l:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const l=r.charCodeAt(0)===a,c=r.charCodeAt(r.length-1)===a;return r=E(r,!l,"/",A),r.length===0?l?"/":c?"./":".":(c&&(r+="/"),l?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===a},join(...r){if(r.length===0)return".";let l;for(let c=0;c<r.length;++c){const M=r[c];e(M,"path"),M.length>0&&(l===void 0?l=M:l+=`/${M}`)}return l===void 0?".":i.$gc.normalize(l)},relative(r,l){if(e(r,"from"),e(l,"to"),r===l||(r=i.$gc.resolve(r),l=i.$gc.resolve(l),r===l))return"";const c=1,M=r.length,_=M-c,T=1,D=l.length-T,j=_<D?_:D;let P=-1,I=0;for(;I<j;I++){const y=r.charCodeAt(c+I);if(y!==l.charCodeAt(T+I))break;y===a&&(P=I)}if(I===j)if(D>j){if(l.charCodeAt(T+I)===a)return l.slice(T+I+1);if(I===0)return l.slice(T+I)}else _>j&&(r.charCodeAt(c+I)===a?P=I:I===0&&(P=0));let F="";for(I=c+P+1;I<=M;++I)(I===M||r.charCodeAt(I)===a)&&(F+=F.length===0?"..":"/..");return`${F}${l.slice(T+P)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const l=r.charCodeAt(0)===a;let c=-1,M=!0;for(let _=r.length-1;_>=1;--_)if(r.charCodeAt(_)===a){if(!M){c=_;break}}else M=!1;return c===-1?l?"/":".":l&&c===1?"//":r.slice(0,c)},basename(r,l){l!==void 0&&e(l,"ext"),e(r,"path");let c=0,M=-1,_=!0,T;if(l!==void 0&&l.length>0&&l.length<=r.length){if(l===r)return"";let D=l.length-1,j=-1;for(T=r.length-1;T>=0;--T){const P=r.charCodeAt(T);if(P===a){if(!_){c=T+1;break}}else j===-1&&(_=!1,j=T+1),D>=0&&(P===l.charCodeAt(D)?--D===-1&&(M=T):(D=-1,M=j))}return c===M?M=j:M===-1&&(M=r.length),r.slice(c,M)}for(T=r.length-1;T>=0;--T)if(r.charCodeAt(T)===a){if(!_){c=T+1;break}}else M===-1&&(_=!1,M=T+1);return M===-1?"":r.slice(c,M)},extname(r){e(r,"path");let l=-1,c=0,M=-1,_=!0,T=0;for(let D=r.length-1;D>=0;--D){const j=r.charCodeAt(D);if(j===a){if(!_){c=D+1;break}continue}M===-1&&(_=!1,M=D+1),j===m?l===-1?l=D:T!==1&&(T=1):l!==-1&&(T=-1)}return l===-1||M===-1||T===0||T===1&&l===M-1&&l===c+1?"":r.slice(l,M)},format:b.bind(null,"/"),parse(r){e(r,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return l;const c=r.charCodeAt(0)===a;let M;c?(l.root="/",M=1):M=0;let _=-1,T=0,D=-1,j=!0,P=r.length-1,I=0;for(;P>=M;--P){const F=r.charCodeAt(P);if(F===a){if(!j){T=P+1;break}continue}D===-1&&(j=!1,D=P+1),F===m?_===-1?_=P:I!==1&&(I=1):_!==-1&&(I=-1)}if(D!==-1){const F=T===0&&c?1:T;_===-1||I===0||I===1&&_===D-1&&_===T+1?l.base=l.name=r.slice(F,D):(l.name=r.slice(F,_),l.base=r.slice(F,D),l.ext=r.slice(_,D))}return T>0?l.dir=r.slice(0,T-1):c&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},i.$gc.win32=i.$fc.win32=i.$fc,i.$gc.posix=i.$fc.posix=i.$gc,i.$hc=w?i.$fc.normalize:i.$gc.normalize,i.$ic=w?i.$fc.isAbsolute:i.$gc.isAbsolute,i.$jc=w?i.$fc.join:i.$gc.join,i.$kc=w?i.$fc.resolve:i.$gc.resolve,i.$lc=w?i.$fc.relative:i.$gc.relative,i.$mc=w?i.$fc.dirname:i.$gc.dirname,i.$nc=w?i.$fc.basename:i.$gc.basename,i.$oc=w?i.$fc.extname:i.$gc.extname,i.$pc=w?i.$fc.format:i.$gc.format,i.$qc=w?i.$fc.parse:i.$gc.parse,i.$rc=w?i.$fc.toNamespacedPath:i.$gc.toNamespacedPath,i.sep=w?i.$fc.sep:i.$gc.sep,i.$tc=w?i.$fc.delimiter:i.$gc.delimiter}),ne(ie[25],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$fe=void 0;const t=globalThis.performance&&typeof globalThis.performance.now=="function";class n{static create(h){return new n(h)}constructor(h){this.c=t&&h===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}i.$fe=n}),ne(ie[13],re([0,1,5,22,12,24,25]),function(x,i,t,n,p,h,N){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ve=i.$ue=i.$te=i.$se=i.$re=i.$qe=i.$pe=i.$oe=i.$ne=i.$me=i.$le=i.$ke=i.$je=i.$he=i.Event=void 0,i.$ie=d;const m=!1,a=!1,u=!1;var f;(function(B){B.None=()=>p.$Uc.None;function O(se){if(u){const{onDidAddListener:te}=se,le=w.create();let ue=0;se.onDidAddListener=()=>{++ue===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),le.print()),te?.()}}}function X(se,te){return s(se,()=>{},0,void 0,!0,void 0,te)}B.defer=X;function Y(se){return(te,le=null,ue)=>{let ce=!1,me;return me=se($e=>{if(!ce)return me?me.dispose():ce=!0,te.call(le,$e)},null,ue),ce&&me.dispose(),me}}B.once=Y;function z(se,te,le){return oe((ue,ce=null,me)=>se($e=>ue.call(ce,te($e)),null,me),le)}B.map=z;function Q(se,te,le){return oe((ue,ce=null,me)=>se($e=>{te($e),ue.call(ce,$e)},null,me),le)}B.forEach=Q;function ee(se,te,le){return oe((ue,ce=null,me)=>se($e=>te($e)&&ue.call(ce,$e),null,me),le)}B.filter=ee;function k(se){return se}B.signal=k;function H(...se){return(te,le=null,ue)=>{const ce=(0,p.$Rc)(...se.map(me=>me($e=>te.call(le,$e))));return we(ce,ue)}}B.any=H;function fe(se,te,le,ue){let ce=le;return z(se,me=>(ce=te(ce,me),ce),ue)}B.reduce=fe;function oe(se,te){let le;const ue={onWillAddFirstListener(){le=se(ce.fire,ce)},onDidRemoveLastListener(){le?.dispose()}};te||O(ue);const ce=new r(ue);return te?.add(ce),ce.event}function we(se,te){return te instanceof Array?te.push(se):te&&te.add(se),se}function s(se,te,le=100,ue=!1,ce=!1,me,$e){let Ne,Ae,Se,ge=0,Me;const He={leakWarningThreshold:me,onWillAddFirstListener(){Ne=se(ze=>{ge++,Ae=te(Ae,ze),ue&&!Se&&(xe.fire(Ae),Ae=void 0),Me=()=>{const Xe=Ae;Ae=void 0,Se=void 0,(!ue||ge>1)&&xe.fire(Xe),ge=0},typeof le=="number"?(clearTimeout(Se),Se=setTimeout(Me,le)):Se===void 0&&(Se=0,queueMicrotask(Me))})},onWillRemoveListener(){ce&&ge>0&&Me?.()},onDidRemoveLastListener(){Me=void 0,Ne.dispose()}};$e||O(He);const xe=new r(He);return $e?.add(xe),xe.event}B.debounce=s;function Te(se,te=0,le){return B.debounce(se,(ue,ce)=>ue?(ue.push(ce),ue):[ce],te,void 0,!0,void 0,le)}B.accumulate=Te;function Ie(se,te=(ue,ce)=>ue===ce,le){let ue=!0,ce;return ee(se,me=>{const $e=ue||!te(me,ce);return ue=!1,ce=me,$e},le)}B.latch=Ie;function Ve(se,te,le){return[B.filter(se,te,le),B.filter(se,ue=>!te(ue),le)]}B.split=Ve;function je(se,te=!1,le=[],ue){let ce=le.slice(),me=se(Ae=>{ce?ce.push(Ae):Ne.fire(Ae)});ue&&ue.add(me);const $e=()=>{ce?.forEach(Ae=>Ne.fire(Ae)),ce=null},Ne=new r({onWillAddFirstListener(){me||(me=se(Ae=>Ne.fire(Ae)),ue&&ue.add(me))},onDidAddFirstListener(){ce&&(te?setTimeout($e):$e())},onDidRemoveLastListener(){me&&me.dispose(),me=null}});return ue&&ue.add(Ne),Ne.event}B.buffer=je;function Ze(se,te){return(ue,ce,me)=>{const $e=te(new q);return se(function(Ne){const Ae=$e.evaluate(Ne);Ae!==Be&&ue.call(ce,Ae)},void 0,me)}}B.chain=Ze;const Be=Symbol("HaltChainable");class q{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(le=>(te(le),le)),this}filter(te){return this.f.push(le=>te(le)?le:Be),this}reduce(te,le){let ue=le;return this.f.push(ce=>(ue=te(ue,ce),ue)),this}latch(te=(le,ue)=>le===ue){let le=!0,ue;return this.f.push(ce=>{const me=le||!te(ce,ue);return le=!1,ue=ce,me?ce:Be}),this}evaluate(te){for(const le of this.f)if(te=le(te),te===Be)break;return te}}function V(se,te,le=ue=>ue){const ue=(...Ne)=>$e.fire(le(...Ne)),ce=()=>se.on(te,ue),me=()=>se.removeListener(te,ue),$e=new r({onWillAddFirstListener:ce,onDidRemoveLastListener:me});return $e.event}B.fromNodeEventEmitter=V;function U(se,te,le=ue=>ue){const ue=(...Ne)=>$e.fire(le(...Ne)),ce=()=>se.addEventListener(te,ue),me=()=>se.removeEventListener(te,ue),$e=new r({onWillAddFirstListener:ce,onDidRemoveLastListener:me});return $e.event}B.fromDOMEventEmitter=U;function J(se){return new Promise(te=>Y(se)(te))}B.toPromise=J;function C(se){const te=new r;return se.then(le=>{te.fire(le)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}B.fromPromise=C;function he(se,te){return se(le=>te.fire(le))}B.forward=he;function de(se,te,le){return te(le),se(ue=>te(ue))}B.runAndSubscribe=de;class Ee{constructor(te,le){this._observable=te,this.f=0,this.g=!1;const ue={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};le||O(ue),this.emitter=new r(ue),le&&le.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,le){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ve(se,te){return new Ee(se,te).emitter.event}B.fromObservable=ve;function _e(se){return(te,le,ue)=>{let ce=0,me=!1;const $e={beginUpdate(){ce++},endUpdate(){ce--,ce===0&&(se.reportChanges(),me&&(me=!1,te.call(le)))},handlePossibleChange(){},handleChange(){me=!0}};se.addObserver($e),se.reportChanges();const Ne={dispose(){se.removeObserver($e)}};return ue instanceof p.$Tc?ue.add(Ne):Array.isArray(ue)&&ue.push(Ne),Ne}}B.fromObservableLight=_e})(f||(i.Event=f={}));class ${static{this.all=new Set}static{this.f=0}constructor(O){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${O}_${$.f++}`,$.all.add(this)}start(O){this.g=new N.$fe,this.listenerCount=O}stop(){if(this.g){const O=this.g.elapsed();this.durations.push(O),this.elapsedOverall+=O,this.invocationCount+=1,this.g=void 0}}}i.$he=$;let g=-1;function d(B){const O=g;return g=B,{dispose(){g=O}}}class e{static{this.f=1}constructor(O,X,Y=(e.f++).toString(16).padStart(3,"0")){this.j=O,this.threshold=X,this.name=Y,this.h=0}dispose(){this.g?.clear()}check(O,X){const Y=this.threshold;if(Y<=0||X<Y)return;this.g||(this.g=new Map);const z=this.g.get(O.value)||0;if(this.g.set(O.value,z+1),this.h-=1,this.h<=0){this.h=Y*.5;const[Q,ee]=this.getMostFrequentStack(),k=`[${this.name}] potential listener LEAK detected, having ${X} listeners already. MOST frequent listener (${ee}):`;console.warn(k),console.warn(Q);const H=new L(k,Q);this.j(H)}return()=>{const Q=this.g.get(O.value)||0;this.g.set(O.value,Q-1)}}getMostFrequentStack(){if(!this.g)return;let O,X=0;for(const[Y,z]of this.g)(!O||X<z)&&(O=[Y,z],X=z);return O}}class w{static create(){const O=new Error;return new w(O.stack??"")}constructor(O){this.value=O}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class L extends Error{constructor(O,X){super(O),this.name="ListenerLeakError",this.stack=X}}i.$je=L;class A extends Error{constructor(O,X){super(O),this.name="ListenerRefusalError",this.stack=X}}i.$ke=A;let v=0;class E{constructor(O){this.value=O,this.id=v++}}const R=2,b=(B,O)=>{if(B instanceof E)O(B);else for(let X=0;X<B.length;X++){const Y=B[X];Y&&O(Y)}};let o;if(m){const B=[];setInterval(()=>{B.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(B.join(`
`)),B.length=0)},3e3),o=new FinalizationRegistry(O=>{typeof O=="string"&&B.push(O)})}class r{constructor(O){this.z=0,this.f=O,this.g=g>0||this.f?.leakWarningThreshold?new e(O?.onListenerError??t.$Y,this.f?.leakWarningThreshold??g):void 0,this.j=this.f?._profName?new $(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(a){const O=this.u;queueMicrotask(()=>{b(O,X=>X.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(O,X,Y)=>{if(this.g&&this.z>this.g.threshold**2){const H=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(H);const fe=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],oe=new A(`${H}. HINT: Stack shows most frequent listener (${fe[1]}-times)`,fe[0]);return(this.f?.onListenerError||t.$Y)(oe),p.$Uc.None}if(this.m)return p.$Uc.None;X&&(O=O.bind(X));const z=new E(O);let Q,ee;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(z.stack=w.create(),Q=this.g.check(z.stack,this.z+1)),a&&(z.stack=ee??w.create()),this.u?this.u instanceof E?(this.w??=new c,this.u=[this.u,z]):this.u.push(z):(this.f?.onWillAddFirstListener?.(this),this.u=z,this.f?.onDidAddFirstListener?.(this)),this.z++;const k=(0,p.$Sc)(()=>{o?.unregister(k),Q?.(),this.A(z)});if(Y instanceof p.$Tc?Y.add(k):Array.isArray(Y)&&Y.push(k),o){const H=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),fe=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(H);o.register(k,fe?.[2]??H,k)}return k},this.q}A(O){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const X=this.u,Y=X.indexOf(O);if(Y===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,X[Y]=void 0;const z=this.w.current===this;if(this.z*R<=X.length){let Q=0;for(let ee=0;ee<X.length;ee++)X[ee]?X[Q++]=X[ee]:z&&(this.w.end--,Q<this.w.i&&this.w.i--);X.length=Q}}B(O,X){if(!O)return;const Y=this.f?.onListenerError||t.$Y;if(!Y){O.value(X);return}try{O.value(X)}catch(z){Y(z)}}C(O){const X=O.current.u;for(;O.i<O.end;)this.B(X[O.i++],O.value);O.reset()}fire(O){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof E)this.B(this.u,O);else{const X=this.w;X.enqueue(this,O,this.u.length),this.C(X)}this.j?.stop()}hasListeners(){return this.z>0}}i.$le=r;const l=()=>new c;i.$me=l;class c{constructor(){this.i=-1,this.end=0}enqueue(O,X,Y){this.i=0,this.end=Y,this.current=O,this.value=X}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class M extends r{async fireAsync(O,X,Y){if(this.u)for(this.h||(this.h=new h.$5c),b(this.u,z=>this.h.push([z.value,O]));this.h.size>0&&!X.isCancellationRequested;){const[z,Q]=this.h.shift(),ee=[],k={...Q,token:X,waitUntil:H=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");Y&&(H=Y(H,z)),ee.push(H)}};try{z(k)}catch(H){(0,t.$Y)(H);continue}Object.freeze(ee),await Promise.allSettled(ee).then(H=>{for(const fe of H)fe.status==="rejected"&&(0,t.$Y)(fe.reason)})}}}i.$ne=M;class _ extends r{get isPaused(){return this.h!==0}constructor(O){super(O),this.h=0,this.s=new h.$5c,this.t=O?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const O=Array.from(this.s);this.s.clear(),super.fire(this.t(O))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(O){this.z&&(this.h!==0?this.s.push(O):super.fire(O))}}i.$oe=_;class T extends _{constructor(O){super(O),this.k=O.delay??100}fire(O){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(O)}}i.$pe=T;class D extends r{constructor(O){super(O),this.h=[],this.k=O?.merge}fire(O){this.hasListeners()&&(this.h.push(O),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(X=>super.fire(X)),this.h=[]}))}}i.$qe=D;class j{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(O){const X={event:O,listener:null};this.h.push(X),this.g&&this.m(X);const Y=()=>{this.g&&this.o(X);const z=this.h.indexOf(X);this.h.splice(z,1)};return(0,p.$Sc)((0,n.$cb)(Y))}j(){this.g=!0,this.h.forEach(O=>this.m(O))}k(){this.g=!1,this.h.forEach(O=>this.o(O))}m(O){O.listener=O.event(X=>this.f.fire(X))}o(O){O.listener?.dispose(),O.listener=null}dispose(){this.f.dispose();for(const O of this.h)O.listener?.dispose();this.h=[]}}i.$re=j;class P{constructor(O,X,Y,z){this.f=new p.$Tc;const Q=this.f.add(new j),ee=this.f.add(new p.$4c);function k(H){ee.set(H,Q.add(z(H)))}for(const H of O)k(H);this.f.add(X(H=>{k(H)})),this.f.add(Y(H=>{ee.deleteAndDispose(H)})),this.event=Q.event}dispose(){this.f.dispose()}}i.$se=P;class I{constructor(){this.f=[]}wrapEvent(O,X,Y){return(z,Q,ee)=>O(k=>{const H=this.f[this.f.length-1];if(!X){H?H.buffers.push(()=>z.call(Q,k)):z.call(Q,k);return}const fe=H;if(!fe){z.call(Q,X(Y,k));return}fe.items??=[],fe.items.push(k),fe.buffers.length===0&&H.buffers.push(()=>{fe.reducedResult??=Y?fe.items.reduce(X,Y):fe.items.reduce(X),z.call(Q,fe.reducedResult)})},void 0,ee)}bufferEvents(O){const X={buffers:new Array};this.f.push(X);const Y=O();return this.f.pop(),X.buffers.forEach(z=>z()),Y}}i.$te=I;class F{constructor(){this.f=!1,this.g=f.None,this.h=p.$Uc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(O){this.g=O,this.f&&(this.h.dispose(),this.h=O(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}i.$ue=F;class y{static const(O){return new W(O)}constructor(O){this.g=O,this.f=new r,this.onDidChange=this.f.event}get value(){return this.g}set value(O){O!==this.g&&(this.g=O,this.f.fire(void 0))}}i.$ve=y;class W{constructor(O){this.value=O,this.onDidChange=f.None}}}),ne(ie[26],re([0,1,13]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$we=i.CancellationToken=void 0,i.$xe=m;const n=Object.freeze(function(a,u){const f=setTimeout(a.bind(u),0);return{dispose(){clearTimeout(f)}}});var p;(function(a){function u(f){return f===a.None||f===a.Cancelled||f instanceof h?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}a.isCancellationToken=u,a.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:t.Event.None}),a.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(p||(i.CancellationToken=p={}));class h{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?n:(this.b||(this.b=new t.$le),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(u){this.f=void 0,this.g=void 0,this.g=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new h),this.f}cancel(){this.f?this.f instanceof h&&this.f.cancel():this.f=p.Cancelled}dispose(u=!1){u&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof h&&this.f.dispose():this.f=p.None}}i.$we=N;function m(a){const u=new N;return a.add({dispose(){u.cancel()}}),u.token}}),ne(ie[45],re([0,1,26]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$_e=i.$$e=i.$9e=void 0,i.$0e=p;class n{constructor(a){this.b=a,this.a=null}get(){if(this.a)return this.a;const a=new t.$we,u=this.b(a.token);return this.a={promise:u,dispose:()=>{this.a=null,a.cancel(),a.dispose()}},this.a}}i.$9e=n;function p(m){return m}class h{constructor(a,u){this.a=void 0,this.b=void 0,typeof a=="function"?(this.c=a,this.d=p):(this.c=u,this.d=a.getCacheKey)}get(a){const u=this.d(a);return this.b!==u&&(this.b=u,this.a=this.c(a)),this.a}}i.$$e=h;class N{get cachedValues(){return this.a}constructor(a,u){this.a=new Map,this.b=new Map,typeof a=="function"?(this.c=a,this.d=p):(this.c=u,this.d=a.getCacheKey)}get(a){const u=this.d(a);if(this.b.has(u))return this.b.get(u);const f=this.c(a);return this.a.set(a,f),this.b.set(u,f),f}}i.$_e=N}),ne(ie[27],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$eg=t,i.$fg=n,i.$gg=p,i.$hg=h,i.$ig=N,i.$jg=m,i.$kg=a,i.$lg=u,i.$mg=f,i.$ng=$,i.$og=g,i.$pg=d,i.$qg=e,i.$rg=L,i.$sg=A,i.$tg=v,i.$ug=E,i.$vg=R,i.$wg=b;function t(o){return typeof o=="string"}function n(o){return Array.isArray(o)&&o.every(r=>t(r))}function p(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function h(o){const r=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof r}function N(o){return typeof o=="number"&&!isNaN(o)}function m(o){return!!o&&typeof o[Symbol.iterator]=="function"}function a(o){return o===!0||o===!1}function u(o){return typeof o>"u"}function f(o){return!$(o)}function $(o){return u(o)||o===null}function g(o,r){if(!o)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function d(o){if($(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function e(...o){const r=[];for(let l=0;l<o.length;l++){const c=o[l];if($(c))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);r.push(c)}return r}const w=Object.prototype.hasOwnProperty;function L(o){if(!p(o))return!1;for(const r in o)if(w.call(o,r))return!1;return!0}function A(o){return typeof o=="function"}function v(...o){return o.length>0&&o.every(A)}function E(o,r){const l=Math.min(o.length,r.length);for(let c=0;c<l;c++)R(o[c],r[c])}function R(o,r){if(t(r)){if(typeof o!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(A(r)){try{if(o instanceof r)return}catch{}if(!$(o)&&o.constructor===r||r.length===1&&r.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function b(o){return o}}),ne(ie[28],re([0,1,27]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Zj=p,i.$1j=h;const n=Object.create(null);function p(N,m){if((0,t.$eg)(m)){const a=n[m];if(a===void 0)throw new Error(`${N} references an unknown codicon: ${m}`);m=a}return n[N]=m,{id:N}}function h(){return n}}),ne(ie[46],re([0,1,28]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$2j=void 0,i.$2j={add:(0,t.$Zj)("add",6e4),plus:(0,t.$Zj)("plus",6e4),gistNew:(0,t.$Zj)("gist-new",6e4),repoCreate:(0,t.$Zj)("repo-create",6e4),lightbulb:(0,t.$Zj)("lightbulb",60001),lightBulb:(0,t.$Zj)("light-bulb",60001),repo:(0,t.$Zj)("repo",60002),repoDelete:(0,t.$Zj)("repo-delete",60002),gistFork:(0,t.$Zj)("gist-fork",60003),repoForked:(0,t.$Zj)("repo-forked",60003),gitPullRequest:(0,t.$Zj)("git-pull-request",60004),gitPullRequestAbandoned:(0,t.$Zj)("git-pull-request-abandoned",60004),recordKeys:(0,t.$Zj)("record-keys",60005),keyboard:(0,t.$Zj)("keyboard",60005),tag:(0,t.$Zj)("tag",60006),gitPullRequestLabel:(0,t.$Zj)("git-pull-request-label",60006),tagAdd:(0,t.$Zj)("tag-add",60006),tagRemove:(0,t.$Zj)("tag-remove",60006),person:(0,t.$Zj)("person",60007),personFollow:(0,t.$Zj)("person-follow",60007),personOutline:(0,t.$Zj)("person-outline",60007),personFilled:(0,t.$Zj)("person-filled",60007),gitBranch:(0,t.$Zj)("git-branch",60008),gitBranchCreate:(0,t.$Zj)("git-branch-create",60008),gitBranchDelete:(0,t.$Zj)("git-branch-delete",60008),sourceControl:(0,t.$Zj)("source-control",60008),mirror:(0,t.$Zj)("mirror",60009),mirrorPublic:(0,t.$Zj)("mirror-public",60009),star:(0,t.$Zj)("star",60010),starAdd:(0,t.$Zj)("star-add",60010),starDelete:(0,t.$Zj)("star-delete",60010),starEmpty:(0,t.$Zj)("star-empty",60010),comment:(0,t.$Zj)("comment",60011),commentAdd:(0,t.$Zj)("comment-add",60011),alert:(0,t.$Zj)("alert",60012),warning:(0,t.$Zj)("warning",60012),search:(0,t.$Zj)("search",60013),searchSave:(0,t.$Zj)("search-save",60013),logOut:(0,t.$Zj)("log-out",60014),signOut:(0,t.$Zj)("sign-out",60014),logIn:(0,t.$Zj)("log-in",60015),signIn:(0,t.$Zj)("sign-in",60015),eye:(0,t.$Zj)("eye",60016),eyeUnwatch:(0,t.$Zj)("eye-unwatch",60016),eyeWatch:(0,t.$Zj)("eye-watch",60016),circleFilled:(0,t.$Zj)("circle-filled",60017),primitiveDot:(0,t.$Zj)("primitive-dot",60017),closeDirty:(0,t.$Zj)("close-dirty",60017),debugBreakpoint:(0,t.$Zj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,t.$Zj)("debug-breakpoint-disabled",60017),debugHint:(0,t.$Zj)("debug-hint",60017),terminalDecorationSuccess:(0,t.$Zj)("terminal-decoration-success",60017),primitiveSquare:(0,t.$Zj)("primitive-square",60018),edit:(0,t.$Zj)("edit",60019),pencil:(0,t.$Zj)("pencil",60019),info:(0,t.$Zj)("info",60020),issueOpened:(0,t.$Zj)("issue-opened",60020),gistPrivate:(0,t.$Zj)("gist-private",60021),gitForkPrivate:(0,t.$Zj)("git-fork-private",60021),lock:(0,t.$Zj)("lock",60021),mirrorPrivate:(0,t.$Zj)("mirror-private",60021),close:(0,t.$Zj)("close",60022),removeClose:(0,t.$Zj)("remove-close",60022),x:(0,t.$Zj)("x",60022),repoSync:(0,t.$Zj)("repo-sync",60023),sync:(0,t.$Zj)("sync",60023),clone:(0,t.$Zj)("clone",60024),desktopDownload:(0,t.$Zj)("desktop-download",60024),beaker:(0,t.$Zj)("beaker",60025),microscope:(0,t.$Zj)("microscope",60025),vm:(0,t.$Zj)("vm",60026),deviceDesktop:(0,t.$Zj)("device-desktop",60026),file:(0,t.$Zj)("file",60027),fileText:(0,t.$Zj)("file-text",60027),more:(0,t.$Zj)("more",60028),ellipsis:(0,t.$Zj)("ellipsis",60028),kebabHorizontal:(0,t.$Zj)("kebab-horizontal",60028),mailReply:(0,t.$Zj)("mail-reply",60029),reply:(0,t.$Zj)("reply",60029),organization:(0,t.$Zj)("organization",60030),organizationFilled:(0,t.$Zj)("organization-filled",60030),organizationOutline:(0,t.$Zj)("organization-outline",60030),newFile:(0,t.$Zj)("new-file",60031),fileAdd:(0,t.$Zj)("file-add",60031),newFolder:(0,t.$Zj)("new-folder",60032),fileDirectoryCreate:(0,t.$Zj)("file-directory-create",60032),trash:(0,t.$Zj)("trash",60033),trashcan:(0,t.$Zj)("trashcan",60033),history:(0,t.$Zj)("history",60034),clock:(0,t.$Zj)("clock",60034),folder:(0,t.$Zj)("folder",60035),fileDirectory:(0,t.$Zj)("file-directory",60035),symbolFolder:(0,t.$Zj)("symbol-folder",60035),logoGithub:(0,t.$Zj)("logo-github",60036),markGithub:(0,t.$Zj)("mark-github",60036),github:(0,t.$Zj)("github",60036),terminal:(0,t.$Zj)("terminal",60037),console:(0,t.$Zj)("console",60037),repl:(0,t.$Zj)("repl",60037),zap:(0,t.$Zj)("zap",60038),symbolEvent:(0,t.$Zj)("symbol-event",60038),error:(0,t.$Zj)("error",60039),stop:(0,t.$Zj)("stop",60039),variable:(0,t.$Zj)("variable",60040),symbolVariable:(0,t.$Zj)("symbol-variable",60040),array:(0,t.$Zj)("array",60042),symbolArray:(0,t.$Zj)("symbol-array",60042),symbolModule:(0,t.$Zj)("symbol-module",60043),symbolPackage:(0,t.$Zj)("symbol-package",60043),symbolNamespace:(0,t.$Zj)("symbol-namespace",60043),symbolObject:(0,t.$Zj)("symbol-object",60043),symbolMethod:(0,t.$Zj)("symbol-method",60044),symbolFunction:(0,t.$Zj)("symbol-function",60044),symbolConstructor:(0,t.$Zj)("symbol-constructor",60044),symbolBoolean:(0,t.$Zj)("symbol-boolean",60047),symbolNull:(0,t.$Zj)("symbol-null",60047),symbolNumeric:(0,t.$Zj)("symbol-numeric",60048),symbolNumber:(0,t.$Zj)("symbol-number",60048),symbolStructure:(0,t.$Zj)("symbol-structure",60049),symbolStruct:(0,t.$Zj)("symbol-struct",60049),symbolParameter:(0,t.$Zj)("symbol-parameter",60050),symbolTypeParameter:(0,t.$Zj)("symbol-type-parameter",60050),symbolKey:(0,t.$Zj)("symbol-key",60051),symbolText:(0,t.$Zj)("symbol-text",60051),symbolReference:(0,t.$Zj)("symbol-reference",60052),goToFile:(0,t.$Zj)("go-to-file",60052),symbolEnum:(0,t.$Zj)("symbol-enum",60053),symbolValue:(0,t.$Zj)("symbol-value",60053),symbolRuler:(0,t.$Zj)("symbol-ruler",60054),symbolUnit:(0,t.$Zj)("symbol-unit",60054),activateBreakpoints:(0,t.$Zj)("activate-breakpoints",60055),archive:(0,t.$Zj)("archive",60056),arrowBoth:(0,t.$Zj)("arrow-both",60057),arrowDown:(0,t.$Zj)("arrow-down",60058),arrowLeft:(0,t.$Zj)("arrow-left",60059),arrowRight:(0,t.$Zj)("arrow-right",60060),arrowSmallDown:(0,t.$Zj)("arrow-small-down",60061),arrowSmallLeft:(0,t.$Zj)("arrow-small-left",60062),arrowSmallRight:(0,t.$Zj)("arrow-small-right",60063),arrowSmallUp:(0,t.$Zj)("arrow-small-up",60064),arrowUp:(0,t.$Zj)("arrow-up",60065),bell:(0,t.$Zj)("bell",60066),bold:(0,t.$Zj)("bold",60067),book:(0,t.$Zj)("book",60068),bookmark:(0,t.$Zj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,t.$Zj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,t.$Zj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,t.$Zj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,t.$Zj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,t.$Zj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,t.$Zj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,t.$Zj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,t.$Zj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,t.$Zj)("debug-breakpoint-log-disabled",60075),briefcase:(0,t.$Zj)("briefcase",60076),broadcast:(0,t.$Zj)("broadcast",60077),browser:(0,t.$Zj)("browser",60078),bug:(0,t.$Zj)("bug",60079),calendar:(0,t.$Zj)("calendar",60080),caseSensitive:(0,t.$Zj)("case-sensitive",60081),check:(0,t.$Zj)("check",60082),checklist:(0,t.$Zj)("checklist",60083),chevronDown:(0,t.$Zj)("chevron-down",60084),chevronLeft:(0,t.$Zj)("chevron-left",60085),chevronRight:(0,t.$Zj)("chevron-right",60086),chevronUp:(0,t.$Zj)("chevron-up",60087),chromeClose:(0,t.$Zj)("chrome-close",60088),chromeMaximize:(0,t.$Zj)("chrome-maximize",60089),chromeMinimize:(0,t.$Zj)("chrome-minimize",60090),chromeRestore:(0,t.$Zj)("chrome-restore",60091),circleOutline:(0,t.$Zj)("circle-outline",60092),circle:(0,t.$Zj)("circle",60092),debugBreakpointUnverified:(0,t.$Zj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,t.$Zj)("terminal-decoration-incomplete",60092),circleSlash:(0,t.$Zj)("circle-slash",60093),circuitBoard:(0,t.$Zj)("circuit-board",60094),clearAll:(0,t.$Zj)("clear-all",60095),clippy:(0,t.$Zj)("clippy",60096),closeAll:(0,t.$Zj)("close-all",60097),cloudDownload:(0,t.$Zj)("cloud-download",60098),cloudUpload:(0,t.$Zj)("cloud-upload",60099),code:(0,t.$Zj)("code",60100),collapseAll:(0,t.$Zj)("collapse-all",60101),colorMode:(0,t.$Zj)("color-mode",60102),commentDiscussion:(0,t.$Zj)("comment-discussion",60103),creditCard:(0,t.$Zj)("credit-card",60105),dash:(0,t.$Zj)("dash",60108),dashboard:(0,t.$Zj)("dashboard",60109),database:(0,t.$Zj)("database",60110),debugContinue:(0,t.$Zj)("debug-continue",60111),debugDisconnect:(0,t.$Zj)("debug-disconnect",60112),debugPause:(0,t.$Zj)("debug-pause",60113),debugRestart:(0,t.$Zj)("debug-restart",60114),debugStart:(0,t.$Zj)("debug-start",60115),debugStepInto:(0,t.$Zj)("debug-step-into",60116),debugStepOut:(0,t.$Zj)("debug-step-out",60117),debugStepOver:(0,t.$Zj)("debug-step-over",60118),debugStop:(0,t.$Zj)("debug-stop",60119),debug:(0,t.$Zj)("debug",60120),deviceCameraVideo:(0,t.$Zj)("device-camera-video",60121),deviceCamera:(0,t.$Zj)("device-camera",60122),deviceMobile:(0,t.$Zj)("device-mobile",60123),diffAdded:(0,t.$Zj)("diff-added",60124),diffIgnored:(0,t.$Zj)("diff-ignored",60125),diffModified:(0,t.$Zj)("diff-modified",60126),diffRemoved:(0,t.$Zj)("diff-removed",60127),diffRenamed:(0,t.$Zj)("diff-renamed",60128),diff:(0,t.$Zj)("diff",60129),diffSidebyside:(0,t.$Zj)("diff-sidebyside",60129),discard:(0,t.$Zj)("discard",60130),editorLayout:(0,t.$Zj)("editor-layout",60131),emptyWindow:(0,t.$Zj)("empty-window",60132),exclude:(0,t.$Zj)("exclude",60133),extensions:(0,t.$Zj)("extensions",60134),eyeClosed:(0,t.$Zj)("eye-closed",60135),fileBinary:(0,t.$Zj)("file-binary",60136),fileCode:(0,t.$Zj)("file-code",60137),fileMedia:(0,t.$Zj)("file-media",60138),filePdf:(0,t.$Zj)("file-pdf",60139),fileSubmodule:(0,t.$Zj)("file-submodule",60140),fileSymlinkDirectory:(0,t.$Zj)("file-symlink-directory",60141),fileSymlinkFile:(0,t.$Zj)("file-symlink-file",60142),fileZip:(0,t.$Zj)("file-zip",60143),files:(0,t.$Zj)("files",60144),filter:(0,t.$Zj)("filter",60145),flame:(0,t.$Zj)("flame",60146),foldDown:(0,t.$Zj)("fold-down",60147),foldUp:(0,t.$Zj)("fold-up",60148),fold:(0,t.$Zj)("fold",60149),folderActive:(0,t.$Zj)("folder-active",60150),folderOpened:(0,t.$Zj)("folder-opened",60151),gear:(0,t.$Zj)("gear",60152),gift:(0,t.$Zj)("gift",60153),gistSecret:(0,t.$Zj)("gist-secret",60154),gist:(0,t.$Zj)("gist",60155),gitCommit:(0,t.$Zj)("git-commit",60156),gitCompare:(0,t.$Zj)("git-compare",60157),compareChanges:(0,t.$Zj)("compare-changes",60157),gitMerge:(0,t.$Zj)("git-merge",60158),githubAction:(0,t.$Zj)("github-action",60159),githubAlt:(0,t.$Zj)("github-alt",60160),globe:(0,t.$Zj)("globe",60161),grabber:(0,t.$Zj)("grabber",60162),graph:(0,t.$Zj)("graph",60163),gripper:(0,t.$Zj)("gripper",60164),heart:(0,t.$Zj)("heart",60165),home:(0,t.$Zj)("home",60166),horizontalRule:(0,t.$Zj)("horizontal-rule",60167),hubot:(0,t.$Zj)("hubot",60168),inbox:(0,t.$Zj)("inbox",60169),issueReopened:(0,t.$Zj)("issue-reopened",60171),issues:(0,t.$Zj)("issues",60172),italic:(0,t.$Zj)("italic",60173),jersey:(0,t.$Zj)("jersey",60174),json:(0,t.$Zj)("json",60175),kebabVertical:(0,t.$Zj)("kebab-vertical",60176),key:(0,t.$Zj)("key",60177),law:(0,t.$Zj)("law",60178),lightbulbAutofix:(0,t.$Zj)("lightbulb-autofix",60179),linkExternal:(0,t.$Zj)("link-external",60180),link:(0,t.$Zj)("link",60181),listOrdered:(0,t.$Zj)("list-ordered",60182),listUnordered:(0,t.$Zj)("list-unordered",60183),liveShare:(0,t.$Zj)("live-share",60184),loading:(0,t.$Zj)("loading",60185),location:(0,t.$Zj)("location",60186),mailRead:(0,t.$Zj)("mail-read",60187),mail:(0,t.$Zj)("mail",60188),markdown:(0,t.$Zj)("markdown",60189),megaphone:(0,t.$Zj)("megaphone",60190),mention:(0,t.$Zj)("mention",60191),milestone:(0,t.$Zj)("milestone",60192),gitPullRequestMilestone:(0,t.$Zj)("git-pull-request-milestone",60192),mortarBoard:(0,t.$Zj)("mortar-board",60193),move:(0,t.$Zj)("move",60194),multipleWindows:(0,t.$Zj)("multiple-windows",60195),mute:(0,t.$Zj)("mute",60196),noNewline:(0,t.$Zj)("no-newline",60197),note:(0,t.$Zj)("note",60198),octoface:(0,t.$Zj)("octoface",60199),openPreview:(0,t.$Zj)("open-preview",60200),package:(0,t.$Zj)("package",60201),paintcan:(0,t.$Zj)("paintcan",60202),pin:(0,t.$Zj)("pin",60203),play:(0,t.$Zj)("play",60204),run:(0,t.$Zj)("run",60204),plug:(0,t.$Zj)("plug",60205),preserveCase:(0,t.$Zj)("preserve-case",60206),preview:(0,t.$Zj)("preview",60207),project:(0,t.$Zj)("project",60208),pulse:(0,t.$Zj)("pulse",60209),question:(0,t.$Zj)("question",60210),quote:(0,t.$Zj)("quote",60211),radioTower:(0,t.$Zj)("radio-tower",60212),reactions:(0,t.$Zj)("reactions",60213),references:(0,t.$Zj)("references",60214),refresh:(0,t.$Zj)("refresh",60215),regex:(0,t.$Zj)("regex",60216),remoteExplorer:(0,t.$Zj)("remote-explorer",60217),remote:(0,t.$Zj)("remote",60218),remove:(0,t.$Zj)("remove",60219),replaceAll:(0,t.$Zj)("replace-all",60220),replace:(0,t.$Zj)("replace",60221),repoClone:(0,t.$Zj)("repo-clone",60222),repoForcePush:(0,t.$Zj)("repo-force-push",60223),repoPull:(0,t.$Zj)("repo-pull",60224),repoPush:(0,t.$Zj)("repo-push",60225),report:(0,t.$Zj)("report",60226),requestChanges:(0,t.$Zj)("request-changes",60227),rocket:(0,t.$Zj)("rocket",60228),rootFolderOpened:(0,t.$Zj)("root-folder-opened",60229),rootFolder:(0,t.$Zj)("root-folder",60230),rss:(0,t.$Zj)("rss",60231),ruby:(0,t.$Zj)("ruby",60232),saveAll:(0,t.$Zj)("save-all",60233),saveAs:(0,t.$Zj)("save-as",60234),save:(0,t.$Zj)("save",60235),screenFull:(0,t.$Zj)("screen-full",60236),screenNormal:(0,t.$Zj)("screen-normal",60237),searchStop:(0,t.$Zj)("search-stop",60238),server:(0,t.$Zj)("server",60240),settingsGear:(0,t.$Zj)("settings-gear",60241),settings:(0,t.$Zj)("settings",60242),shield:(0,t.$Zj)("shield",60243),smiley:(0,t.$Zj)("smiley",60244),sortPrecedence:(0,t.$Zj)("sort-precedence",60245),splitHorizontal:(0,t.$Zj)("split-horizontal",60246),splitVertical:(0,t.$Zj)("split-vertical",60247),squirrel:(0,t.$Zj)("squirrel",60248),starFull:(0,t.$Zj)("star-full",60249),starHalf:(0,t.$Zj)("star-half",60250),symbolClass:(0,t.$Zj)("symbol-class",60251),symbolColor:(0,t.$Zj)("symbol-color",60252),symbolConstant:(0,t.$Zj)("symbol-constant",60253),symbolEnumMember:(0,t.$Zj)("symbol-enum-member",60254),symbolField:(0,t.$Zj)("symbol-field",60255),symbolFile:(0,t.$Zj)("symbol-file",60256),symbolInterface:(0,t.$Zj)("symbol-interface",60257),symbolKeyword:(0,t.$Zj)("symbol-keyword",60258),symbolMisc:(0,t.$Zj)("symbol-misc",60259),symbolOperator:(0,t.$Zj)("symbol-operator",60260),symbolProperty:(0,t.$Zj)("symbol-property",60261),wrench:(0,t.$Zj)("wrench",60261),wrenchSubaction:(0,t.$Zj)("wrench-subaction",60261),symbolSnippet:(0,t.$Zj)("symbol-snippet",60262),tasklist:(0,t.$Zj)("tasklist",60263),telescope:(0,t.$Zj)("telescope",60264),textSize:(0,t.$Zj)("text-size",60265),threeBars:(0,t.$Zj)("three-bars",60266),thumbsdown:(0,t.$Zj)("thumbsdown",60267),thumbsup:(0,t.$Zj)("thumbsup",60268),tools:(0,t.$Zj)("tools",60269),triangleDown:(0,t.$Zj)("triangle-down",60270),triangleLeft:(0,t.$Zj)("triangle-left",60271),triangleRight:(0,t.$Zj)("triangle-right",60272),triangleUp:(0,t.$Zj)("triangle-up",60273),twitter:(0,t.$Zj)("twitter",60274),unfold:(0,t.$Zj)("unfold",60275),unlock:(0,t.$Zj)("unlock",60276),unmute:(0,t.$Zj)("unmute",60277),unverified:(0,t.$Zj)("unverified",60278),verified:(0,t.$Zj)("verified",60279),versions:(0,t.$Zj)("versions",60280),vmActive:(0,t.$Zj)("vm-active",60281),vmOutline:(0,t.$Zj)("vm-outline",60282),vmRunning:(0,t.$Zj)("vm-running",60283),watch:(0,t.$Zj)("watch",60284),whitespace:(0,t.$Zj)("whitespace",60285),wholeWord:(0,t.$Zj)("whole-word",60286),window:(0,t.$Zj)("window",60287),wordWrap:(0,t.$Zj)("word-wrap",60288),zoomIn:(0,t.$Zj)("zoom-in",60289),zoomOut:(0,t.$Zj)("zoom-out",60290),listFilter:(0,t.$Zj)("list-filter",60291),listFlat:(0,t.$Zj)("list-flat",60292),listSelection:(0,t.$Zj)("list-selection",60293),selection:(0,t.$Zj)("selection",60293),listTree:(0,t.$Zj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,t.$Zj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,t.$Zj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,t.$Zj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,t.$Zj)("debug-stackframe-active",60297),circleSmallFilled:(0,t.$Zj)("circle-small-filled",60298),debugStackframeDot:(0,t.$Zj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,t.$Zj)("terminal-decoration-mark",60298),debugStackframe:(0,t.$Zj)("debug-stackframe",60299),debugStackframeFocused:(0,t.$Zj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,t.$Zj)("debug-breakpoint-unsupported",60300),symbolString:(0,t.$Zj)("symbol-string",60301),debugReverseContinue:(0,t.$Zj)("debug-reverse-continue",60302),debugStepBack:(0,t.$Zj)("debug-step-back",60303),debugRestartFrame:(0,t.$Zj)("debug-restart-frame",60304),debugAlt:(0,t.$Zj)("debug-alt",60305),callIncoming:(0,t.$Zj)("call-incoming",60306),callOutgoing:(0,t.$Zj)("call-outgoing",60307),menu:(0,t.$Zj)("menu",60308),expandAll:(0,t.$Zj)("expand-all",60309),feedback:(0,t.$Zj)("feedback",60310),gitPullRequestReviewer:(0,t.$Zj)("git-pull-request-reviewer",60310),groupByRefType:(0,t.$Zj)("group-by-ref-type",60311),ungroupByRefType:(0,t.$Zj)("ungroup-by-ref-type",60312),account:(0,t.$Zj)("account",60313),gitPullRequestAssignee:(0,t.$Zj)("git-pull-request-assignee",60313),bellDot:(0,t.$Zj)("bell-dot",60314),debugConsole:(0,t.$Zj)("debug-console",60315),library:(0,t.$Zj)("library",60316),output:(0,t.$Zj)("output",60317),runAll:(0,t.$Zj)("run-all",60318),syncIgnored:(0,t.$Zj)("sync-ignored",60319),pinned:(0,t.$Zj)("pinned",60320),githubInverted:(0,t.$Zj)("github-inverted",60321),serverProcess:(0,t.$Zj)("server-process",60322),serverEnvironment:(0,t.$Zj)("server-environment",60323),pass:(0,t.$Zj)("pass",60324),issueClosed:(0,t.$Zj)("issue-closed",60324),stopCircle:(0,t.$Zj)("stop-circle",60325),playCircle:(0,t.$Zj)("play-circle",60326),record:(0,t.$Zj)("record",60327),debugAltSmall:(0,t.$Zj)("debug-alt-small",60328),vmConnect:(0,t.$Zj)("vm-connect",60329),cloud:(0,t.$Zj)("cloud",60330),merge:(0,t.$Zj)("merge",60331),export:(0,t.$Zj)("export",60332),graphLeft:(0,t.$Zj)("graph-left",60333),magnet:(0,t.$Zj)("magnet",60334),notebook:(0,t.$Zj)("notebook",60335),redo:(0,t.$Zj)("redo",60336),checkAll:(0,t.$Zj)("check-all",60337),pinnedDirty:(0,t.$Zj)("pinned-dirty",60338),passFilled:(0,t.$Zj)("pass-filled",60339),circleLargeFilled:(0,t.$Zj)("circle-large-filled",60340),circleLarge:(0,t.$Zj)("circle-large",60341),circleLargeOutline:(0,t.$Zj)("circle-large-outline",60341),combine:(0,t.$Zj)("combine",60342),gather:(0,t.$Zj)("gather",60342),table:(0,t.$Zj)("table",60343),variableGroup:(0,t.$Zj)("variable-group",60344),typeHierarchy:(0,t.$Zj)("type-hierarchy",60345),typeHierarchySub:(0,t.$Zj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,t.$Zj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,t.$Zj)("git-pull-request-create",60348),runAbove:(0,t.$Zj)("run-above",60349),runBelow:(0,t.$Zj)("run-below",60350),notebookTemplate:(0,t.$Zj)("notebook-template",60351),debugRerun:(0,t.$Zj)("debug-rerun",60352),workspaceTrusted:(0,t.$Zj)("workspace-trusted",60353),workspaceUntrusted:(0,t.$Zj)("workspace-untrusted",60354),workspaceUnknown:(0,t.$Zj)("workspace-unknown",60355),terminalCmd:(0,t.$Zj)("terminal-cmd",60356),terminalDebian:(0,t.$Zj)("terminal-debian",60357),terminalLinux:(0,t.$Zj)("terminal-linux",60358),terminalPowershell:(0,t.$Zj)("terminal-powershell",60359),terminalTmux:(0,t.$Zj)("terminal-tmux",60360),terminalUbuntu:(0,t.$Zj)("terminal-ubuntu",60361),terminalBash:(0,t.$Zj)("terminal-bash",60362),arrowSwap:(0,t.$Zj)("arrow-swap",60363),copy:(0,t.$Zj)("copy",60364),personAdd:(0,t.$Zj)("person-add",60365),filterFilled:(0,t.$Zj)("filter-filled",60366),wand:(0,t.$Zj)("wand",60367),debugLineByLine:(0,t.$Zj)("debug-line-by-line",60368),inspect:(0,t.$Zj)("inspect",60369),layers:(0,t.$Zj)("layers",60370),layersDot:(0,t.$Zj)("layers-dot",60371),layersActive:(0,t.$Zj)("layers-active",60372),compass:(0,t.$Zj)("compass",60373),compassDot:(0,t.$Zj)("compass-dot",60374),compassActive:(0,t.$Zj)("compass-active",60375),azure:(0,t.$Zj)("azure",60376),issueDraft:(0,t.$Zj)("issue-draft",60377),gitPullRequestClosed:(0,t.$Zj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,t.$Zj)("git-pull-request-draft",60379),debugAll:(0,t.$Zj)("debug-all",60380),debugCoverage:(0,t.$Zj)("debug-coverage",60381),runErrors:(0,t.$Zj)("run-errors",60382),folderLibrary:(0,t.$Zj)("folder-library",60383),debugContinueSmall:(0,t.$Zj)("debug-continue-small",60384),beakerStop:(0,t.$Zj)("beaker-stop",60385),graphLine:(0,t.$Zj)("graph-line",60386),graphScatter:(0,t.$Zj)("graph-scatter",60387),pieChart:(0,t.$Zj)("pie-chart",60388),bracket:(0,t.$Zj)("bracket",60175),bracketDot:(0,t.$Zj)("bracket-dot",60389),bracketError:(0,t.$Zj)("bracket-error",60390),lockSmall:(0,t.$Zj)("lock-small",60391),azureDevops:(0,t.$Zj)("azure-devops",60392),verifiedFilled:(0,t.$Zj)("verified-filled",60393),newline:(0,t.$Zj)("newline",60394),layout:(0,t.$Zj)("layout",60395),layoutActivitybarLeft:(0,t.$Zj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,t.$Zj)("layout-activitybar-right",60397),layoutPanelLeft:(0,t.$Zj)("layout-panel-left",60398),layoutPanelCenter:(0,t.$Zj)("layout-panel-center",60399),layoutPanelJustify:(0,t.$Zj)("layout-panel-justify",60400),layoutPanelRight:(0,t.$Zj)("layout-panel-right",60401),layoutPanel:(0,t.$Zj)("layout-panel",60402),layoutSidebarLeft:(0,t.$Zj)("layout-sidebar-left",60403),layoutSidebarRight:(0,t.$Zj)("layout-sidebar-right",60404),layoutStatusbar:(0,t.$Zj)("layout-statusbar",60405),layoutMenubar:(0,t.$Zj)("layout-menubar",60406),layoutCentered:(0,t.$Zj)("layout-centered",60407),target:(0,t.$Zj)("target",60408),indent:(0,t.$Zj)("indent",60409),recordSmall:(0,t.$Zj)("record-small",60410),errorSmall:(0,t.$Zj)("error-small",60411),terminalDecorationError:(0,t.$Zj)("terminal-decoration-error",60411),arrowCircleDown:(0,t.$Zj)("arrow-circle-down",60412),arrowCircleLeft:(0,t.$Zj)("arrow-circle-left",60413),arrowCircleRight:(0,t.$Zj)("arrow-circle-right",60414),arrowCircleUp:(0,t.$Zj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,t.$Zj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,t.$Zj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,t.$Zj)("layout-sidebar-left-off",60418),blank:(0,t.$Zj)("blank",60419),heartFilled:(0,t.$Zj)("heart-filled",60420),map:(0,t.$Zj)("map",60421),mapHorizontal:(0,t.$Zj)("map-horizontal",60421),foldHorizontal:(0,t.$Zj)("fold-horizontal",60421),mapFilled:(0,t.$Zj)("map-filled",60422),mapHorizontalFilled:(0,t.$Zj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,t.$Zj)("fold-horizontal-filled",60422),circleSmall:(0,t.$Zj)("circle-small",60423),bellSlash:(0,t.$Zj)("bell-slash",60424),bellSlashDot:(0,t.$Zj)("bell-slash-dot",60425),commentUnresolved:(0,t.$Zj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,t.$Zj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,t.$Zj)("git-pull-request-new-changes",60428),searchFuzzy:(0,t.$Zj)("search-fuzzy",60429),commentDraft:(0,t.$Zj)("comment-draft",60430),send:(0,t.$Zj)("send",60431),sparkle:(0,t.$Zj)("sparkle",60432),insert:(0,t.$Zj)("insert",60433),mic:(0,t.$Zj)("mic",60434),thumbsdownFilled:(0,t.$Zj)("thumbsdown-filled",60435),thumbsupFilled:(0,t.$Zj)("thumbsup-filled",60436),coffee:(0,t.$Zj)("coffee",60437),snake:(0,t.$Zj)("snake",60438),game:(0,t.$Zj)("game",60439),vr:(0,t.$Zj)("vr",60440),chip:(0,t.$Zj)("chip",60441),piano:(0,t.$Zj)("piano",60442),music:(0,t.$Zj)("music",60443),micFilled:(0,t.$Zj)("mic-filled",60444),repoFetch:(0,t.$Zj)("repo-fetch",60445),copilot:(0,t.$Zj)("copilot",60446),lightbulbSparkle:(0,t.$Zj)("lightbulb-sparkle",60447),robot:(0,t.$Zj)("robot",60448),sparkleFilled:(0,t.$Zj)("sparkle-filled",60449),diffSingle:(0,t.$Zj)("diff-single",60450),diffMultiple:(0,t.$Zj)("diff-multiple",60451),surroundWith:(0,t.$Zj)("surround-with",60452),share:(0,t.$Zj)("share",60453),gitStash:(0,t.$Zj)("git-stash",60454),gitStashApply:(0,t.$Zj)("git-stash-apply",60455),gitStashPop:(0,t.$Zj)("git-stash-pop",60456),vscode:(0,t.$Zj)("vscode",60457),vscodeInsiders:(0,t.$Zj)("vscode-insiders",60458),codeOss:(0,t.$Zj)("code-oss",60459),runCoverage:(0,t.$Zj)("run-coverage",60460),runAllCoverage:(0,t.$Zj)("run-all-coverage",60461),coverage:(0,t.$Zj)("coverage",60462),githubProject:(0,t.$Zj)("github-project",60463),mapVertical:(0,t.$Zj)("map-vertical",60464),foldVertical:(0,t.$Zj)("fold-vertical",60464),mapVerticalFilled:(0,t.$Zj)("map-vertical-filled",60465),foldVerticalFilled:(0,t.$Zj)("fold-vertical-filled",60465),goToSearch:(0,t.$Zj)("go-to-search",60466),percentage:(0,t.$Zj)("percentage",60467),sortPercentage:(0,t.$Zj)("sort-percentage",60467),attach:(0,t.$Zj)("attach",60468)}}),ne(ie[47],re([0,1,28,46]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$5j=i.$4j=void 0,i.$3j=p;function p(){return Object.values(i.$5j)}i.$4j={dialogError:(0,t.$Zj)("dialog-error","error"),dialogWarning:(0,t.$Zj)("dialog-warning","warning"),dialogInfo:(0,t.$Zj)("dialog-info","info"),dialogClose:(0,t.$Zj)("dialog-close","close"),treeItemExpanded:(0,t.$Zj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,t.$Zj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,t.$Zj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,t.$Zj)("tree-filter-clear","close"),treeItemLoading:(0,t.$Zj)("tree-item-loading","loading"),menuSelection:(0,t.$Zj)("menu-selection","check"),menuSubmenu:(0,t.$Zj)("menu-submenu","chevron-right"),menuBarMore:(0,t.$Zj)("menubar-more","more"),scrollbarButtonLeft:(0,t.$Zj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,t.$Zj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,t.$Zj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,t.$Zj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,t.$Zj)("toolbar-more","more"),quickInputBack:(0,t.$Zj)("quick-input-back","arrow-left"),dropDownButton:(0,t.$Zj)("drop-down-button",60084),symbolCustomColor:(0,t.$Zj)("symbol-customcolor",60252),exportIcon:(0,t.$Zj)("export",60332),workspaceUnspecified:(0,t.$Zj)("workspace-unspecified",60355),newLine:(0,t.$Zj)("newline",60394),thumbsDownFilled:(0,t.$Zj)("thumbsdown-filled",60435),thumbsUpFilled:(0,t.$Zj)("thumbsup-filled",60436),gitFetch:(0,t.$Zj)("git-fetch",60445),lightbulbSparkleAutofix:(0,t.$Zj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,t.$Zj)("debug-breakpoint-pending",60377)},i.$5j={...n.$2j,...i.$4j}}),ne(ie[18],re([0,1,27]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$eo=n,i.$fo=p,i.$go=N,i.$ho=a,i.$io=u,i.$jo=f,i.$ko=$,i.$lo=g,i.$mo=d,i.$no=e,i.$oo=w,i.$po=L,i.$qo=A;function n(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const E=Array.isArray(v)?[]:{};return Object.entries(v).forEach(([R,b])=>{E[R]=b&&typeof b=="object"?n(b):b}),E}function p(v){if(!v||typeof v!="object")return v;const E=[v];for(;E.length>0;){const R=E.shift();Object.freeze(R);for(const b in R)if(h.call(R,b)){const o=R[b];typeof o=="object"&&!Object.isFrozen(o)&&!(0,t.$hg)(o)&&E.push(o)}}return v}const h=Object.prototype.hasOwnProperty;function N(v,E){return m(v,E,new Set)}function m(v,E,R){if((0,t.$ng)(v))return v;const b=E(v);if(typeof b<"u")return b;if(Array.isArray(v)){const o=[];for(const r of v)o.push(m(r,E,R));return o}if((0,t.$gg)(v)){if(R.has(v))throw new Error("Cannot clone recursive data-structure");R.add(v);const o={};for(const r in v)h.call(v,r)&&(o[r]=m(v[r],E,R));return R.delete(v),o}return v}function a(v,E,R=!0){return(0,t.$gg)(v)?((0,t.$gg)(E)&&Object.keys(E).forEach(b=>{b in v?R&&((0,t.$gg)(v[b])&&(0,t.$gg)(E[b])?a(v[b],E[b],R):v[b]=E[b]):v[b]=E[b]}),v):E}function u(v,E){if(v===E)return!0;if(v==null||E===null||E===void 0||typeof v!=typeof E||typeof v!="object"||Array.isArray(v)!==Array.isArray(E))return!1;let R,b;if(Array.isArray(v)){if(v.length!==E.length)return!1;for(R=0;R<v.length;R++)if(!u(v[R],E[R]))return!1}else{const o=[];for(b in v)o.push(b);o.sort();const r=[];for(b in E)r.push(b);if(r.sort(),!u(o,r))return!1;for(R=0;R<o.length;R++)if(!u(v[o[R]],E[o[R]]))return!1}return!0}function f(v){const E=new Set;return JSON.stringify(v,(R,b)=>{if((0,t.$gg)(b)||Array.isArray(b)){if(E.has(b))return"[Circular]";E.add(b)}return typeof b=="bigint"?`[BigInt ${b.toString()}]`:b})}function $(v,E){const R=Object.create(null);return!v||!E||Object.keys(E).forEach(o=>{const r=v[o],l=E[o];u(r,l)||(R[o]=l)}),R}function g(v,E){const R=E.toLowerCase(),b=Object.keys(v).find(o=>o.toLowerCase()===R);return b?v[b]:v[E]}function d(v,E){const R=Object.create(null);for(const[b,o]of Object.entries(v))E(b,o)&&(R[b]=o);return R}function e(v){let E=[];for(;Object.prototype!==v;)E=E.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return E}function w(v){const E=[];for(const R of e(v))typeof v[R]=="function"&&E.push(R);return E}function L(v,E){const R=o=>function(){const r=Array.prototype.slice.call(arguments,0);return E(o,r)},b={};for(const o of v)b[o]=R(o);return b}function A(v,E){const R={};for(const[b,o]of Object.entries(v))R[b]=E(o,b);return R}}),ne(ie[14],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Constants=void 0,i.$af=n,i.$bf=p;var t;(function(h){h[h.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",h[h.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",h[h.MAX_UINT_8=255]="MAX_UINT_8",h[h.MAX_UINT_16=65535]="MAX_UINT_16",h[h.MAX_UINT_32=4294967295]="MAX_UINT_32",h[h.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(t||(i.Constants=t={}));function n(h){return h<0?0:h>t.MAX_UINT_8?t.MAX_UINT_8:h|0}function p(h){return h<0?0:h>t.MAX_UINT_32?t.MAX_UINT_32:h|0}}),ne(ie[8],re([0,1,45,4,41,14]),function(x,i,t,n,p,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$dg=i.$cg=i.$bg=i.GraphemeBreakType=i.$4f=i.$Vf=i.$Of=i.$Nf=void 0,i.$cf=N,i.$df=a,i.$ef=f,i.$ff=$,i.$gf=g,i.$hf=d,i.$if=e,i.$jf=w,i.$kf=L,i.$lf=A,i.$mf=v,i.$nf=E,i.$of=R,i.$pf=b,i.$qf=o,i.$rf=r,i.$sf=l,i.$tf=c,i.$uf=M,i.$vf=_,i.$wf=T,i.$xf=D,i.$yf=j,i.$zf=P,i.$Af=I,i.$Bf=F,i.$Cf=y,i.$Df=W,i.$Ef=B,i.$Ff=O,i.$Gf=X,i.$Hf=Y,i.$If=z,i.$Jf=Q,i.$Kf=ee,i.$Lf=k,i.$Mf=H,i.$Pf=s,i.$Qf=Te,i.$Rf=Ie,i.$Sf=Ve,i.$Tf=Be,i.$Uf=V,i.$Wf=U,i.$Xf=J,i.$Yf=C,i.$Zf=he,i.$1f=Ee,i.$2f=ve,i.$3f=se,i.$5f=te,i.$6f=le,i.$7f=ue,i.$8f=ce,i.$9f=me,i.$0f=$e,i.$$f=Ne,i.$_f=Ae,i.$ag=xe;function N(S){return!S||typeof S!="string"?!0:S.trim().length===0}const m=/{(\d+)}/g;function a(S,...Z){return Z.length===0?S:S.replace(m,function(G,K){const ae=parseInt(K,10);return isNaN(ae)||ae<0||ae>=Z.length?G:Z[ae]})}const u=/{([^}]+)}/g;function f(S,Z){return Object.keys(Z).length===0?S:S.replace(u,(G,K)=>Z[K]??G)}function $(S){return S.replace(/[<>"'&]/g,Z=>{switch(Z){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Z})}function g(S){return S.replace(/[<>&]/g,function(Z){switch(Z){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Z}})}function d(S){return S.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(S,Z){let G=0,K=S.indexOf(Z);for(;K!==-1;)G++,K=S.indexOf(Z,K+Z.length);return G}function w(S,Z,G="\u2026"){return S.length<=Z?S:`${S.substr(0,Z)}${G}`}function L(S,Z,G="\u2026"){if(S.length<=Z)return S;const K=Math.ceil(Z/2)-G.length/2,ae=Math.floor(Z/2)-G.length/2;return`${S.substr(0,K)}${G}${S.substr(S.length-ae)}`}function A(S,Z=" "){const G=v(S,Z);return E(G,Z)}function v(S,Z){if(!S||!Z)return S;const G=Z.length;if(G===0||S.length===0)return S;let K=0;for(;S.indexOf(Z,K)===K;)K=K+G;return S.substring(K)}function E(S,Z){if(!S||!Z)return S;const G=Z.length,K=S.length;if(G===0||K===0)return S;let ae=K,be=-1;for(;be=S.lastIndexOf(Z,ae-1),!(be===-1||be+G!==ae);){if(be===0)return"";ae=be}return S.substring(0,ae)}function R(S){return S.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function b(S){return S.replace(/\*/g,"")}function o(S,Z,G={}){if(!S)throw new Error("Cannot create regex from empty string");Z||(S=d(S)),G.wholeWord&&(/\B/.test(S.charAt(0))||(S="\\b"+S),/\B/.test(S.charAt(S.length-1))||(S=S+"\\b"));let K="";return G.global&&(K+="g"),G.matchCase||(K+="i"),G.multiline&&(K+="m"),G.unicode&&(K+="u"),new RegExp(S,K)}function r(S){return S.source==="^"||S.source==="^$"||S.source==="$"||S.source==="^\\s*$"?!1:!!(S.exec("")&&S.lastIndex===0)}function l(S){return S.split(/\r\n|\r|\n/)}function c(S){const Z=[],G=S.split(/(\r\n|\r|\n)/);for(let K=0;K<Math.ceil(G.length/2);K++)Z.push(G[2*K]+(G[2*K+1]??""));return Z}function M(S){for(let Z=0,G=S.length;Z<G;Z++){const K=S.charCodeAt(Z);if(K!==n.CharCode.Space&&K!==n.CharCode.Tab)return Z}return-1}function _(S,Z=0,G=S.length){for(let K=Z;K<G;K++){const ae=S.charCodeAt(K);if(ae!==n.CharCode.Space&&ae!==n.CharCode.Tab)return S.substring(Z,K)}return S.substring(Z,G)}function T(S,Z=S.length-1){for(let G=Z;G>=0;G--){const K=S.charCodeAt(G);if(K!==n.CharCode.Space&&K!==n.CharCode.Tab)return G}return-1}function D(S,Z,G){const K=[];let ae=0;for(const be of S.matchAll(Z)){if(K.push(S.slice(ae,be.index)),be.index===void 0)throw new Error("match.index should be defined");ae=be.index+be[0].length,K.push(G(be[0],...be.slice(1),be.index,S,be.groups))}return K.push(S.slice(ae)),Promise.all(K).then(be=>be.join(""))}function j(S,Z){return S<Z?-1:S>Z?1:0}function P(S,Z,G=0,K=S.length,ae=0,be=Z.length){for(;G<K&&ae<be;G++,ae++){const De=S.charCodeAt(G),Fe=Z.charCodeAt(ae);if(De<Fe)return-1;if(De>Fe)return 1}const Re=K-G,Pe=be-ae;return Re<Pe?-1:Re>Pe?1:0}function I(S,Z){return F(S,Z,0,S.length,0,Z.length)}function F(S,Z,G=0,K=S.length,ae=0,be=Z.length){for(;G<K&&ae<be;G++,ae++){let De=S.charCodeAt(G),Fe=Z.charCodeAt(ae);if(De===Fe)continue;if(De>=128||Fe>=128)return P(S.toLowerCase(),Z.toLowerCase(),G,K,ae,be);W(De)&&(De-=32),W(Fe)&&(Fe-=32);const pe=De-Fe;if(pe!==0)return pe}const Re=K-G,Pe=be-ae;return Re<Pe?-1:Re>Pe?1:0}function y(S){return S>=n.CharCode.Digit0&&S<=n.CharCode.Digit9}function W(S){return S>=n.CharCode.a&&S<=n.CharCode.z}function B(S){return S>=n.CharCode.A&&S<=n.CharCode.Z}function O(S,Z){return S.length===Z.length&&F(S,Z)===0}function X(S,Z){const G=Z.length;return Z.length>S.length?!1:F(S,Z,0,G)===0}function Y(S,Z){const G=Math.min(S.length,Z.length);let K;for(K=0;K<G;K++)if(S.charCodeAt(K)!==Z.charCodeAt(K))return K;return G}function z(S,Z){const G=Math.min(S.length,Z.length);let K;const ae=S.length-1,be=Z.length-1;for(K=0;K<G;K++)if(S.charCodeAt(ae-K)!==Z.charCodeAt(be-K))return K;return G}function Q(S){return 55296<=S&&S<=56319}function ee(S){return 56320<=S&&S<=57343}function k(S,Z){return(S-55296<<10)+(Z-56320)+65536}function H(S,Z,G){const K=S.charCodeAt(G);if(Q(K)&&G+1<Z){const ae=S.charCodeAt(G+1);if(ee(ae))return k(K,ae)}return K}function fe(S,Z){const G=S.charCodeAt(Z-1);if(ee(G)&&Z>1){const K=S.charCodeAt(Z-2);if(Q(K))return k(K,G)}return G}class oe{get offset(){return this.e}constructor(Z,G=0){this.c=Z,this.d=Z.length,this.e=G}setOffset(Z){this.e=Z}prevCodePoint(){const Z=fe(this.c,this.e);return this.e-=Z>=h.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Z}nextCodePoint(){const Z=H(this.c,this.d,this.e);return this.e+=Z>=h.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Z}eol(){return this.e>=this.d}}i.$Nf=oe;class we{get offset(){return this.c.offset}constructor(Z,G=0){this.c=new oe(Z,G)}nextGraphemeLength(){const Z=Me.getInstance(),G=this.c,K=G.offset;let ae=Z.getGraphemeBreakType(G.nextCodePoint());for(;!G.eol();){const be=G.offset,Re=Z.getGraphemeBreakType(G.nextCodePoint());if(Se(ae,Re)){G.setOffset(be);break}ae=Re}return G.offset-K}prevGraphemeLength(){const Z=Me.getInstance(),G=this.c,K=G.offset;let ae=Z.getGraphemeBreakType(G.prevCodePoint());for(;G.offset>0;){const be=G.offset,Re=Z.getGraphemeBreakType(G.prevCodePoint());if(Se(Re,ae)){G.setOffset(be);break}ae=Re}return K-G.offset}eol(){return this.c.eol()}}i.$Of=we;function s(S,Z){return new we(S,Z).nextGraphemeLength()}function Te(S,Z){return new we(S,Z).prevGraphemeLength()}function Ie(S,Z){Z>0&&ee(S.charCodeAt(Z))&&Z--;const G=Z+s(S,Z);return[G-Te(S,G),G]}function Ve(S){const Z=new we(S);let G=0;for(;!Z.eol();)G++,Z.nextGraphemeLength();return G}let je;function Ze(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Be(S){return je||(je=Ze()),je.test(S)}const q=/^[\t\n\r\x20-\x7E]*$/;function V(S){return q.test(S)}i.$Vf=/[\u2028\u2029]/;function U(S){return i.$Vf.test(S)}function J(S){return S>=11904&&S<=55215||S>=63744&&S<=64255||S>=65281&&S<=65374}function C(S){return S>=127462&&S<=127487||S===8986||S===8987||S===9200||S===9203||S>=9728&&S<=10175||S===11088||S===11093||S>=127744&&S<=128591||S>=128640&&S<=128764||S>=128992&&S<=129008||S>=129280&&S<=129535||S>=129648&&S<=129782}function he(S,Z,G=""){const K=S.trimStart();if(K.length<Z)return K;const ae=/\b/g;let be=0;for(;ae.test(K)&&!(K.length-ae.lastIndex<Z);)be=ae.lastIndex,ae.lastIndex+=1;return be===0?K:G+K.substring(be).trimStart()}const de=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Ee(S){let Z=0;for(const G of S.matchAll(de))Z!==G.index&&(yield{isCode:!1,str:S.substring(Z,G.index)}),yield{isCode:!0,str:G[0]},Z=G.index+G[0].length;Z!==S.length&&(yield{isCode:!1,str:S.substring(Z)})}function ve(S){return S&&(S=S.replace(de,"")),S}const _e=/\\\[.*?\\\]/g;function se(S){return ve(S).replace(_e,"")}i.$4f=String.fromCharCode(n.CharCode.UTF8_BOM);function te(S){return!!(S&&S.length>0&&S.charCodeAt(0)===n.CharCode.UTF8_BOM)}function le(S){return te(S)?S.substr(1):S}function ue(S,Z){if(!S||!Z||S.length<Z.length)return!1;const G=Z.length,K=S.toLowerCase();let ae=0,be=-1;for(;ae<G;){const Re=K.indexOf(Z[ae],be+1);if(Re<0)return!1;be=Re,ae++}return!0}function ce(S,Z=!1){return S?(Z&&(S=S.replace(/\\./g,"")),S.toLowerCase()!==S):!1}function me(S){return S.charAt(0).toUpperCase()+S.slice(1)}function $e(S,Z=1){if(Z===0)return"";let G=-1;do G=S.indexOf(`
`,G+1),Z--;while(Z>0&&G>=0);return G===-1?S:(S[G-1]==="\r"&&G--,S.substr(0,G))}function Ne(S){const Z=n.CharCode.Z-n.CharCode.A+1;return S=S%(2*Z),S<Z?String.fromCharCode(n.CharCode.a+S):String.fromCharCode(n.CharCode.A+S-Z)}function Ae(S){return Me.getInstance().getGraphemeBreakType(S)}function Se(S,Z){return S===ge.Other?Z!==ge.Extend&&Z!==ge.SpacingMark:S===ge.CR&&Z===ge.LF?!1:S===ge.Control||S===ge.CR||S===ge.LF||Z===ge.Control||Z===ge.CR||Z===ge.LF?!0:!(S===ge.L&&(Z===ge.L||Z===ge.V||Z===ge.LV||Z===ge.LVT)||(S===ge.LV||S===ge.V)&&(Z===ge.V||Z===ge.T)||(S===ge.LVT||S===ge.T)&&Z===ge.T||Z===ge.Extend||Z===ge.ZWJ||Z===ge.SpacingMark||S===ge.Prepend||S===ge.ZWJ&&Z===ge.Extended_Pictographic||S===ge.Regional_Indicator&&Z===ge.Regional_Indicator)}var ge;(function(S){S[S.Other=0]="Other",S[S.Prepend=1]="Prepend",S[S.CR=2]="CR",S[S.LF=3]="LF",S[S.Control=4]="Control",S[S.Extend=5]="Extend",S[S.Regional_Indicator=6]="Regional_Indicator",S[S.SpacingMark=7]="SpacingMark",S[S.L=8]="L",S[S.V=9]="V",S[S.T=10]="T",S[S.LV=11]="LV",S[S.LVT=12]="LVT",S[S.ZWJ=13]="ZWJ",S[S.Extended_Pictographic=14]="Extended_Pictographic"})(ge||(i.GraphemeBreakType=ge={}));class Me{static{this.c=null}static getInstance(){return Me.c||(Me.c=new Me),Me.c}constructor(){this.d=He()}getGraphemeBreakType(Z){if(Z<32)return Z===n.CharCode.LineFeed?ge.LF:Z===n.CharCode.CarriageReturn?ge.CR:ge.Control;if(Z<127)return ge.Other;const G=this.d,K=G.length/3;let ae=1;for(;ae<=K;)if(Z<G[3*ae])ae=2*ae;else if(Z>G[3*ae+1])ae=2*ae+1;else return G[3*ae+2];return ge.Other}}function He(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function xe(S,Z){if(S===0)return 0;const G=ze(S,Z);if(G!==void 0)return G;const K=new oe(Z,S);return K.prevCodePoint(),K.offset}function ze(S,Z){const G=new oe(Z,S);let K=G.prevCodePoint();for(;Xe(K)||K===We.emojiVariantSelector||K===We.enclosingKeyCap;){if(G.offset===0)return;K=G.prevCodePoint()}if(!C(K))return;let ae=G.offset;return ae>0&&G.prevCodePoint()===We.zwj&&(ae=G.offset),ae}function Xe(S){return 127995<=S&&S<=127999}var We;(function(S){S[S.zwj=8205]="zwj",S[S.emojiVariantSelector=65039]="emojiVariantSelector",S[S.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),i.$bg="\xA0";class qe{static{this.c=new p.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new t.$$e({getCacheKey:JSON.stringify},Z=>{function G(pe){const ye=new Map;for(let ke=0;ke<pe.length;ke+=2)ye.set(pe[ke],pe[ke+1]);return ye}function K(pe,ye){const ke=new Map(pe);for(const[Ge,Ye]of ye)ke.set(Ge,Ye);return ke}function ae(pe,ye){if(!pe)return ye;const ke=new Map;for(const[Ge,Ye]of pe)ye.has(Ge)&&ke.set(Ge,Ye);return ke}const be=this.c.value;let Re=Z.filter(pe=>!pe.startsWith("_")&&pe in be);Re.length===0&&(Re=["_default"]);let Pe;for(const pe of Re){const ye=G(be[pe]);Pe=ae(Pe,ye)}const De=G(be._common),Fe=K(De,Pe);return new qe(Fe)})}static getInstance(Z){return qe.d.get(Array.from(Z))}static{this.e=new p.$T(()=>Object.keys(qe.c.value).filter(Z=>!Z.startsWith("_")))}static getLocales(){return qe.e.value}constructor(Z){this.f=Z}isAmbiguous(Z){return this.f.has(Z)}containsAmbiguousCharacter(Z){for(let G=0;G<Z.length;G++){const K=Z.codePointAt(G);if(typeof K=="number"&&this.isAmbiguous(K))return!0}return!1}getPrimaryConfusable(Z){return this.f.get(Z)}getConfusableCodePoints(){return new Set(this.f.keys())}}i.$cg=qe;class Ue{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ue.c())),this.d}static isInvisibleCharacter(Z){return Ue.e().has(Z)}static containsInvisibleCharacter(Z){for(let G=0;G<Z.length;G++){const K=Z.codePointAt(G);if(typeof K=="number"&&Ue.isInvisibleCharacter(K))return!0}return!1}static get codePoints(){return Ue.e()}}i.$dg=Ue}),ne(ie[48],re([0,1,8]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$zj=i.$xj=void 0,i.$tj=n,i.$uj=p,i.$vj=h,i.$wj=m,i.$yj=w,t=Oe(t);function n(A){return p(A,0)}function p(A,v){switch(typeof A){case"object":return A===null?h(349,v):Array.isArray(A)?a(A,v):u(A,v);case"string":return m(A,v);case"boolean":return N(A,v);case"number":return h(A,v);case"undefined":return h(937,v);default:return h(617,v)}}function h(A,v){return(v<<5)-v+A|0}function N(A,v){return h(A?433:863,v)}function m(A,v){v=h(149417,v);for(let E=0,R=A.length;E<R;E++)v=h(A.charCodeAt(E),v);return v}function a(A,v){return v=h(104579,v),A.reduce((E,R)=>p(R,E),v)}function u(A,v){return v=h(181387,v),Object.keys(A).sort().reduce((E,R)=>(E=m(R,E),p(A[R],E)),v)}class f{constructor(){this.g=0}get value(){return this.g}hash(v){return this.g=p(v,this.g),this.g}}i.$xj=f;var $;(function(A){A[A.BLOCK_SIZE=64]="BLOCK_SIZE",A[A.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})($||($={}));function g(A,v,E=32){const R=E-v,b=~((1<<R)-1);return(A<<v|(b&A)>>>R)>>>0}function d(A,v=0,E=A.byteLength,R=0){for(let b=0;b<E;b++)A[v+b]=R}function e(A,v,E="0"){for(;A.length<v;)A=E+A;return A}function w(A,v=32){return A instanceof ArrayBuffer?Array.from(new Uint8Array(A)).map(E=>E.toString(16).padStart(2,"0")).join(""):e((A>>>0).toString(16),v/4)}class L{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array($.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(v){const E=v.length;if(E===0)return;const R=this.p;let b=this.r,o=this.u,r,l;for(o!==0?(r=o,l=-1,o=0):(r=v.charCodeAt(0),l=0);;){let c=r;if(t.$Jf(r))if(l+1<E){const M=v.charCodeAt(l+1);t.$Kf(M)?(l++,c=t.$Lf(r,M)):c=$.UNICODE_REPLACEMENT}else{o=r;break}else t.$Kf(r)&&(c=$.UNICODE_REPLACEMENT);if(b=this.w(R,b,c),l++,l<E)r=v.charCodeAt(l);else break}this.r=b,this.u=o}w(v,E,R){return R<128?v[E++]=R:R<2048?(v[E++]=192|(R&1984)>>>6,v[E++]=128|(R&63)>>>0):R<65536?(v[E++]=224|(R&61440)>>>12,v[E++]=128|(R&4032)>>>6,v[E++]=128|(R&63)>>>0):(v[E++]=240|(R&1835008)>>>18,v[E++]=128|(R&258048)>>>12,v[E++]=128|(R&4032)>>>6,v[E++]=128|(R&63)>>>0),E>=$.BLOCK_SIZE&&(this.y(),E-=$.BLOCK_SIZE,this.t+=$.BLOCK_SIZE,v[0]=v[$.BLOCK_SIZE+0],v[1]=v[$.BLOCK_SIZE+1],v[2]=v[$.BLOCK_SIZE+2]),E}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,$.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const v=8*this.t;this.q.setUint32(56,Math.floor(v/4294967296),!1),this.q.setUint32(60,v%4294967296,!1),this.y()}y(){const v=L.g,E=this.q;for(let T=0;T<64;T+=4)v.setUint32(T,E.getUint32(T,!1),!1);for(let T=64;T<320;T+=4)v.setUint32(T,g(v.getUint32(T-12,!1)^v.getUint32(T-32,!1)^v.getUint32(T-56,!1)^v.getUint32(T-64,!1),1),!1);let R=this.h,b=this.l,o=this.m,r=this.n,l=this.o,c,M,_;for(let T=0;T<80;T++)T<20?(c=b&o|~b&r,M=1518500249):T<40?(c=b^o^r,M=1859775393):T<60?(c=b&o|b&r|o&r,M=2400959708):(c=b^o^r,M=3395469782),_=g(R,5)+c+l+M+v.getUint32(T*4,!1)&4294967295,l=r,r=o,o=g(b,30),b=R,R=_;this.h=this.h+R&4294967295,this.l=this.l+b&4294967295,this.m=this.m+o&4294967295,this.n=this.n+r&4294967295,this.o=this.o+l&4294967295}}i.$zj=L}),ne(ie[29],re([0,1,39,48,14]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Ut=i.$St=void 0,i.$Tt=N;class h{constructor(d){this.a=d}getElements(){const d=this.a,e=new Int32Array(d.length);for(let w=0,L=d.length;w<L;w++)e[w]=d.charCodeAt(w);return e}}i.$St=h;function N(g,d,e){return new $(new h(g),new h(d)).ComputeDiff(e).changes}class m{static Assert(d,e){if(!d)throw new Error(e)}}class a{static Copy(d,e,w,L,A){for(let v=0;v<A;v++)w[L+v]=d[e+v]}static Copy2(d,e,w,L,A){for(let v=0;v<A;v++)w[L+v]=d[e+v]}}var u;(function(g){g[g.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class f{constructor(){this.a=[],this.b=p.Constants.MAX_SAFE_SMALL_INTEGER,this.c=p.Constants.MAX_SAFE_SMALL_INTEGER,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new t.$Rt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=p.Constants.MAX_SAFE_SMALL_INTEGER,this.c=p.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(d,e){this.b=Math.min(this.b,d),this.c=Math.min(this.c,e),this.d++}AddModifiedElement(d,e){this.b=Math.min(this.b,d),this.c=Math.min(this.c,e),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class ${constructor(d,e,w=null){this.a=w,this.b=d,this.c=e;const[L,A,v]=$.o(d),[E,R,b]=$.o(e);this.d=v&&b,this.e=L,this.f=A,this.g=E,this.h=R,this.k=[],this.m=[]}static n(d){return d.length>0&&typeof d[0]=="string"}static o(d){const e=d.getElements();if($.n(e)){const w=new Int32Array(e.length);for(let L=0,A=e.length;L<A;L++)w[L]=(0,n.$wj)(e[L],0);return[e,w,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}p(d,e){return this.f[d]!==this.h[e]?!1:this.d?this.e[d]===this.g[e]:!0}q(d,e){if(!this.p(d,e))return!1;const w=$.r(this.b,d),L=$.r(this.c,e);return w===L}static r(d,e){return typeof d.getStrictElement=="function"?d.getStrictElement(e):null}s(d,e){return this.f[d]!==this.f[e]?!1:this.d?this.e[d]===this.e[e]:!0}u(d,e){return this.h[d]!==this.h[e]?!1:this.d?this.g[d]===this.g[e]:!0}ComputeDiff(d){return this.v(0,this.f.length-1,0,this.h.length-1,d)}v(d,e,w,L,A){const v=[!1];let E=this.w(d,e,w,L,v);return A&&(E=this.z(E)),{quitEarly:v[0],changes:E}}w(d,e,w,L,A){for(A[0]=!1;d<=e&&w<=L&&this.p(d,w);)d++,w++;for(;e>=d&&L>=w&&this.p(e,L);)e--,L--;if(d>e||w>L){let r;return w<=L?(m.Assert(d===e+1,"originalStart should only be one more than originalEnd"),r=[new t.$Rt(d,0,w,L-w+1)]):d<=e?(m.Assert(w===L+1,"modifiedStart should only be one more than modifiedEnd"),r=[new t.$Rt(d,e-d+1,w,0)]):(m.Assert(d===e+1,"originalStart should only be one more than originalEnd"),m.Assert(w===L+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const v=[0],E=[0],R=this.y(d,e,w,L,v,E,A),b=v[0],o=E[0];if(R!==null)return R;if(!A[0]){const r=this.w(d,b,w,o,A);let l=[];return A[0]?l=[new t.$Rt(b+1,e-(b+1)+1,o+1,L-(o+1)+1)]:l=this.w(b+1,e,o+1,L,A),this.H(r,l)}return[new t.$Rt(d,e-d+1,w,L-w+1)]}x(d,e,w,L,A,v,E,R,b,o,r,l,c,M,_,T,D,j){let P=null,I=null,F=new f,y=e,W=w,B=c[0]-T[0]-L,O=p.Constants.MIN_SAFE_SMALL_INTEGER,X=this.k.length-1;do{const Y=B+d;Y===y||Y<W&&b[Y-1]<b[Y+1]?(r=b[Y+1],M=r-B-L,r<O&&F.MarkNextChange(),O=r,F.AddModifiedElement(r+1,M),B=Y+1-d):(r=b[Y-1]+1,M=r-B-L,r<O&&F.MarkNextChange(),O=r-1,F.AddOriginalElement(r,M+1),B=Y-1-d),X>=0&&(b=this.k[X],d=b[0],y=1,W=b.length-1)}while(--X>=-1);if(P=F.getReverseChanges(),j[0]){let Y=c[0]+1,z=T[0]+1;if(P!==null&&P.length>0){const Q=P[P.length-1];Y=Math.max(Y,Q.getOriginalEnd()),z=Math.max(z,Q.getModifiedEnd())}I=[new t.$Rt(Y,l-Y+1,z,_-z+1)]}else{F=new f,y=v,W=E,B=c[0]-T[0]-R,O=p.Constants.MAX_SAFE_SMALL_INTEGER,X=D?this.m.length-1:this.m.length-2;do{const Y=B+A;Y===y||Y<W&&o[Y-1]>=o[Y+1]?(r=o[Y+1]-1,M=r-B-R,r>O&&F.MarkNextChange(),O=r+1,F.AddOriginalElement(r+1,M+1),B=Y+1-A):(r=o[Y-1],M=r-B-R,r>O&&F.MarkNextChange(),O=r,F.AddModifiedElement(r+1,M+1),B=Y-1-A),X>=0&&(o=this.m[X],A=o[0],y=1,W=o.length-1)}while(--X>=-1);I=F.getChanges()}return this.H(P,I)}y(d,e,w,L,A,v,E){let R=0,b=0,o=0,r=0,l=0,c=0;d--,w--,A[0]=0,v[0]=0,this.k=[],this.m=[];const M=e-d+(L-w),_=M+1,T=new Int32Array(_),D=new Int32Array(_),j=L-w,P=e-d,I=d-w,F=e-L,W=(P-j)%2===0;T[j]=d,D[P]=e,E[0]=!1;for(let B=1;B<=M/2+1;B++){let O=0,X=0;o=this.J(j-B,B,j,_),r=this.J(j+B,B,j,_);for(let z=o;z<=r;z+=2){z===o||z<r&&T[z-1]<T[z+1]?R=T[z+1]:R=T[z-1]+1,b=R-(z-j)-I;const Q=R;for(;R<e&&b<L&&this.p(R+1,b+1);)R++,b++;if(T[z]=R,R+b>O+X&&(O=R,X=b),!W&&Math.abs(z-P)<=B-1&&R>=D[z])return A[0]=R,v[0]=b,Q<=D[z]&&u.MaxDifferencesHistory>0&&B<=u.MaxDifferencesHistory+1?this.x(j,o,r,I,P,l,c,F,T,D,R,e,A,b,L,v,W,E):null}const Y=(O-d+(X-w)-B)/2;if(this.a!==null&&!this.a(O,Y))return E[0]=!0,A[0]=O,v[0]=X,Y>0&&u.MaxDifferencesHistory>0&&B<=u.MaxDifferencesHistory+1?this.x(j,o,r,I,P,l,c,F,T,D,R,e,A,b,L,v,W,E):(d++,w++,[new t.$Rt(d,e-d+1,w,L-w+1)]);l=this.J(P-B,B,P,_),c=this.J(P+B,B,P,_);for(let z=l;z<=c;z+=2){z===l||z<c&&D[z-1]>=D[z+1]?R=D[z+1]-1:R=D[z-1],b=R-(z-P)-F;const Q=R;for(;R>d&&b>w&&this.p(R,b);)R--,b--;if(D[z]=R,W&&Math.abs(z-j)<=B&&R<=T[z])return A[0]=R,v[0]=b,Q>=T[z]&&u.MaxDifferencesHistory>0&&B<=u.MaxDifferencesHistory+1?this.x(j,o,r,I,P,l,c,F,T,D,R,e,A,b,L,v,W,E):null}if(B<=u.MaxDifferencesHistory){let z=new Int32Array(r-o+2);z[0]=j-o+1,a.Copy2(T,o,z,1,r-o+1),this.k.push(z),z=new Int32Array(c-l+2),z[0]=P-l+1,a.Copy2(D,l,z,1,c-l+1),this.m.push(z)}}return this.x(j,o,r,I,P,l,c,F,T,D,R,e,A,b,L,v,W,E)}z(d){for(let e=0;e<d.length;e++){const w=d[e],L=e<d.length-1?d[e+1].originalStart:this.f.length,A=e<d.length-1?d[e+1].modifiedStart:this.h.length,v=w.originalLength>0,E=w.modifiedLength>0;for(;w.originalStart+w.originalLength<L&&w.modifiedStart+w.modifiedLength<A&&(!v||this.s(w.originalStart,w.originalStart+w.originalLength))&&(!E||this.u(w.modifiedStart,w.modifiedStart+w.modifiedLength));){const b=this.q(w.originalStart,w.modifiedStart);if(this.q(w.originalStart+w.originalLength,w.modifiedStart+w.modifiedLength)&&!b)break;w.originalStart++,w.modifiedStart++}const R=[null];if(e<d.length-1&&this.I(d[e],d[e+1],R)){d[e]=R[0],d.splice(e+1,1),e--;continue}}for(let e=d.length-1;e>=0;e--){const w=d[e];let L=0,A=0;if(e>0){const r=d[e-1];L=r.originalStart+r.originalLength,A=r.modifiedStart+r.modifiedLength}const v=w.originalLength>0,E=w.modifiedLength>0;let R=0,b=this.G(w.originalStart,w.originalLength,w.modifiedStart,w.modifiedLength);for(let r=1;;r++){const l=w.originalStart-r,c=w.modifiedStart-r;if(l<L||c<A||v&&!this.s(l,l+w.originalLength)||E&&!this.u(c,c+w.modifiedLength))break;const _=(l===L&&c===A?5:0)+this.G(l,w.originalLength,c,w.modifiedLength);_>b&&(b=_,R=r)}w.originalStart-=R,w.modifiedStart-=R;const o=[null];if(e>0&&this.I(d[e-1],d[e],o)){d[e-1]=o[0],d.splice(e,1),e++;continue}}if(this.d)for(let e=1,w=d.length;e<w;e++){const L=d[e-1],A=d[e],v=A.originalStart-L.originalStart-L.originalLength,E=L.originalStart,R=A.originalStart+A.originalLength,b=R-E,o=L.modifiedStart,r=A.modifiedStart+A.modifiedLength,l=r-o;if(v<5&&b<20&&l<20){const c=this.A(E,b,o,l,v);if(c){const[M,_]=c;(M!==L.originalStart+L.originalLength||_!==L.modifiedStart+L.modifiedLength)&&(L.originalLength=M-L.originalStart,L.modifiedLength=_-L.modifiedStart,A.originalStart=M+v,A.modifiedStart=_+v,A.originalLength=R-A.originalStart,A.modifiedLength=r-A.modifiedStart)}}}return d}A(d,e,w,L,A){if(e<A||L<A)return null;const v=d+e-A+1,E=w+L-A+1;let R=0,b=0,o=0;for(let r=d;r<v;r++)for(let l=w;l<E;l++){const c=this.B(r,l,A);c>0&&c>R&&(R=c,b=r,o=l)}return R>0?[b,o]:null}B(d,e,w){let L=0;for(let A=0;A<w;A++){if(!this.p(d+A,e+A))return 0;L+=this.e[d+A].length}return L}C(d){return d<=0||d>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[d])}D(d,e){if(this.C(d)||this.C(d-1))return!0;if(e>0){const w=d+e;if(this.C(w-1)||this.C(w))return!0}return!1}E(d){return d<=0||d>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[d])}F(d,e){if(this.E(d)||this.E(d-1))return!0;if(e>0){const w=d+e;if(this.E(w-1)||this.E(w))return!0}return!1}G(d,e,w,L){const A=this.D(d,e)?1:0,v=this.F(w,L)?1:0;return A+v}H(d,e){const w=[];if(d.length===0||e.length===0)return e.length>0?e:d;if(this.I(d[d.length-1],e[0],w)){const L=new Array(d.length+e.length-1);return a.Copy(d,0,L,0,d.length-1),L[d.length-1]=w[0],a.Copy(e,1,L,d.length,e.length-1),L}else{const L=new Array(d.length+e.length);return a.Copy(d,0,L,0,d.length),a.Copy(e,0,L,d.length,e.length),L}}I(d,e,w){if(m.Assert(d.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),m.Assert(d.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),d.originalStart+d.originalLength>=e.originalStart||d.modifiedStart+d.modifiedLength>=e.modifiedStart){const L=d.originalStart;let A=d.originalLength;const v=d.modifiedStart;let E=d.modifiedLength;return d.originalStart+d.originalLength>=e.originalStart&&(A=e.originalStart+e.originalLength-d.originalStart),d.modifiedStart+d.modifiedLength>=e.modifiedStart&&(E=e.modifiedStart+e.modifiedLength-d.modifiedStart),w[0]=new t.$Rt(L,A,v,E),!0}else return w[0]=null,!1}J(d,e,w,L){if(d>=0&&d<L)return d;const A=w,v=L-w-1,E=e%2===0;if(d<0){const R=A%2===0;return E===R?0:1}else{const R=v%2===0;return E===R?L-1:L-2}}}i.$Ut=$}),ne(ie[19],re([0,1,4,42,44,17]),function(x,i,t,n,p,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.URI=void 0,i.$vc=L,i.$wc=o,p=Oe(p);const N=/^\w[\w\d+.-]*$/,m=/^\//,a=/^\/\//;function u(_,T){if(!_.scheme&&T)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${_.authority}", path: "${_.path}", query: "${_.query}", fragment: "${_.fragment}"}`);if(_.scheme&&!N.test(_.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(_.path){if(_.authority){if(!m.test(_.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(a.test(_.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(_,T){return!_&&!T?"file":_}function $(_,T){switch(_){case"https":case"http":case"file":T?T[0]!==d&&(T=d+T):T=d;break}return T}const g="",d="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{static isUri(T){return T instanceof w?!0:T?typeof T.authority=="string"&&typeof T.fragment=="string"&&typeof T.path=="string"&&typeof T.query=="string"&&typeof T.scheme=="string"&&typeof T.fsPath=="string"&&typeof T.with=="function"&&typeof T.toString=="function":!1}constructor(T,D,j,P,I,F=!1){typeof T=="object"?(this.scheme=T.scheme||g,this.authority=T.authority||g,this.path=T.path||g,this.query=T.query||g,this.fragment=T.fragment||g):(this.scheme=f(T,F),this.authority=D||g,this.path=$(this.scheme,j||g),this.query=P||g,this.fragment=I||g,u(this,F))}get fsPath(){return o(this,!1)}with(T){if(!T)return this;let{scheme:D,authority:j,path:P,query:I,fragment:F}=T;return D===void 0?D=this.scheme:D===null&&(D=g),j===void 0?j=this.authority:j===null&&(j=g),P===void 0?P=this.path:P===null&&(P=g),I===void 0?I=this.query:I===null&&(I=g),F===void 0?F=this.fragment:F===null&&(F=g),D===this.scheme&&j===this.authority&&P===this.path&&I===this.query&&F===this.fragment?this:new v(D,j,P,I,F)}static parse(T,D=!1){const j=e.exec(T);return j?new v(j[2]||g,M(j[4]||g),M(j[5]||g),M(j[7]||g),M(j[9]||g),D):new v(g,g,g,g,g)}static file(T){let D=g;if(h.$j&&(T=T.replace(/\\/g,d)),T[0]===d&&T[1]===d){const j=T.indexOf(d,2);j===-1?(D=T.substring(2),T=d):(D=T.substring(2,j),T=T.substring(j)||d)}return new v("file",D,T,g,g)}static from(T,D){return new v(T.scheme,T.authority,T.path,T.query,T.fragment,D)}static joinPath(T,...D){if(!T.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let j;return h.$j&&T.scheme==="file"?j=w.file(p.$fc.join(o(T,!0),...D)).path:j=p.$gc.join(T.path,...D),T.with({path:j})}toString(T=!1){return r(this,T)}toJSON(){return this}static revive(T){if(T){if(T instanceof w)return T;{const D=new v(T);return D._formatted=T.external??null,D._fsPath=T._sep===A?T.fsPath??null:null,D}}else return T}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}i.URI=w;function L(_){return!_||typeof _!="object"?!1:typeof _.scheme=="string"&&(typeof _.authority=="string"||typeof _.authority>"u")&&(typeof _.path=="string"||typeof _.path>"u")&&(typeof _.query=="string"||typeof _.query>"u")&&(typeof _.fragment=="string"||typeof _.fragment>"u")}const A=h.$j?1:void 0;class v extends w{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(T=!1){return T?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const T={$mid:n.MarshalledId.Uri};return this._fsPath&&(T.fsPath=this._fsPath,T._sep=A),this._formatted&&(T.external=this._formatted),this.path&&(T.path=this.path),this.scheme&&(T.scheme=this.scheme),this.authority&&(T.authority=this.authority),this.query&&(T.query=this.query),this.fragment&&(T.fragment=this.fragment),T}}const E={[t.CharCode.Colon]:"%3A",[t.CharCode.Slash]:"%2F",[t.CharCode.QuestionMark]:"%3F",[t.CharCode.Hash]:"%23",[t.CharCode.OpenSquareBracket]:"%5B",[t.CharCode.CloseSquareBracket]:"%5D",[t.CharCode.AtSign]:"%40",[t.CharCode.ExclamationMark]:"%21",[t.CharCode.DollarSign]:"%24",[t.CharCode.Ampersand]:"%26",[t.CharCode.SingleQuote]:"%27",[t.CharCode.OpenParen]:"%28",[t.CharCode.CloseParen]:"%29",[t.CharCode.Asterisk]:"%2A",[t.CharCode.Plus]:"%2B",[t.CharCode.Comma]:"%2C",[t.CharCode.Semicolon]:"%3B",[t.CharCode.Equals]:"%3D",[t.CharCode.Space]:"%20"};function R(_,T,D){let j,P=-1;for(let I=0;I<_.length;I++){const F=_.charCodeAt(I);if(F>=t.CharCode.a&&F<=t.CharCode.z||F>=t.CharCode.A&&F<=t.CharCode.Z||F>=t.CharCode.Digit0&&F<=t.CharCode.Digit9||F===t.CharCode.Dash||F===t.CharCode.Period||F===t.CharCode.Underline||F===t.CharCode.Tilde||T&&F===t.CharCode.Slash||D&&F===t.CharCode.OpenSquareBracket||D&&F===t.CharCode.CloseSquareBracket||D&&F===t.CharCode.Colon)P!==-1&&(j+=encodeURIComponent(_.substring(P,I)),P=-1),j!==void 0&&(j+=_.charAt(I));else{j===void 0&&(j=_.substr(0,I));const y=E[F];y!==void 0?(P!==-1&&(j+=encodeURIComponent(_.substring(P,I)),P=-1),j+=y):P===-1&&(P=I)}}return P!==-1&&(j+=encodeURIComponent(_.substring(P))),j!==void 0?j:_}function b(_){let T;for(let D=0;D<_.length;D++){const j=_.charCodeAt(D);j===t.CharCode.Hash||j===t.CharCode.QuestionMark?(T===void 0&&(T=_.substr(0,D)),T+=E[j]):T!==void 0&&(T+=_[D])}return T!==void 0?T:_}function o(_,T){let D;return _.authority&&_.path.length>1&&_.scheme==="file"?D=`//${_.authority}${_.path}`:_.path.charCodeAt(0)===t.CharCode.Slash&&(_.path.charCodeAt(1)>=t.CharCode.A&&_.path.charCodeAt(1)<=t.CharCode.Z||_.path.charCodeAt(1)>=t.CharCode.a&&_.path.charCodeAt(1)<=t.CharCode.z)&&_.path.charCodeAt(2)===t.CharCode.Colon?T?D=_.path.substr(1):D=_.path[1].toLowerCase()+_.path.substr(2):D=_.path,h.$j&&(D=D.replace(/\//g,"\\")),D}function r(_,T){const D=T?b:R;let j="",{scheme:P,authority:I,path:F,query:y,fragment:W}=_;if(P&&(j+=P,j+=":"),(I||P==="file")&&(j+=d,j+=d),I){let B=I.indexOf("@");if(B!==-1){const O=I.substr(0,B);I=I.substr(B+1),B=O.lastIndexOf(":"),B===-1?j+=D(O,!1,!1):(j+=D(O.substr(0,B),!1,!1),j+=":",j+=D(O.substr(B+1),!1,!0)),j+="@"}I=I.toLowerCase(),B=I.lastIndexOf(":"),B===-1?j+=D(I,!1,!0):(j+=D(I.substr(0,B),!1,!0),j+=I.substr(B))}if(F){if(F.length>=3&&F.charCodeAt(0)===t.CharCode.Slash&&F.charCodeAt(2)===t.CharCode.Colon){const B=F.charCodeAt(1);B>=t.CharCode.A&&B<=t.CharCode.Z&&(F=`/${String.fromCharCode(B+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===t.CharCode.Colon){const B=F.charCodeAt(0);B>=t.CharCode.A&&B<=t.CharCode.Z&&(F=`${String.fromCharCode(B+32)}:${F.substr(2)}`)}j+=D(F,!0,!1)}return y&&(j+="?",j+=D(y,!1,!1)),W&&(j+="#",j+=T?W:R(W,!1,!1)),j}function l(_){try{return decodeURIComponent(_)}catch{return _.length>3?_.substr(0,3)+l(_.substr(3)):_}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function M(_){return _.match(c)?_.replace(c,T=>l(T)):_}}),ne(ie[76],re([0,1,5,13,12,18,17,8]),function(x,i,t,n,p,h,N,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SimpleWorkerServer=i.SimpleWorkerClient=void 0,i.logOnceWebWorkerWarning=f,i.create=r,m=Oe(m);const a="$initialize";let u=!1;function f(l){N.$p&&(u||(u=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(l.message))}var $;(function(l){l[l.Request=0]="Request",l[l.Reply=1]="Reply",l[l.SubscribeEvent=2]="SubscribeEvent",l[l.Event=3]="Event",l[l.UnsubscribeEvent=4]="UnsubscribeEvent"})($||($={}));class g{constructor(c,M,_,T){this.vsWorker=c,this.req=M,this.method=_,this.args=T,this.type=$.Request}}class d{constructor(c,M,_,T){this.vsWorker=c,this.seq=M,this.res=_,this.err=T,this.type=$.Reply}}class e{constructor(c,M,_,T){this.vsWorker=c,this.req=M,this.eventName=_,this.arg=T,this.type=$.SubscribeEvent}}class w{constructor(c,M,_){this.vsWorker=c,this.req=M,this.event=_,this.type=$.Event}}class L{constructor(c,M){this.vsWorker=c,this.req=M,this.type=$.UnsubscribeEvent}}class A{constructor(c){this.a=-1,this.g=c,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(c){this.a=c}sendMessage(c,M){const _=String(++this.b);return new Promise((T,D)=>{this.c[_]={resolve:T,reject:D},this.o(new g(this.a,_,c,M))})}listen(c,M){let _=null;const T=new n.$le({onWillAddFirstListener:()=>{_=String(++this.b),this.d.set(_,T),this.o(new e(this.a,_,c,M))},onDidRemoveLastListener:()=>{this.d.delete(_),this.o(new L(this.a,_)),_=null}});return T.event}handleMessage(c){!c||!c.vsWorker||this.a!==-1&&c.vsWorker!==this.a||this.h(c)}h(c){switch(c.type){case $.Reply:return this.j(c);case $.Request:return this.k(c);case $.SubscribeEvent:return this.l(c);case $.Event:return this.m(c);case $.UnsubscribeEvent:return this.n(c)}}j(c){if(!this.c[c.seq]){console.warn("Got reply to unknown seq");return}const M=this.c[c.seq];if(delete this.c[c.seq],c.err){let _=c.err;c.err.$isError&&(_=new Error,_.name=c.err.name,_.message=c.err.message,_.stack=c.err.stack),M.reject(_);return}M.resolve(c.res)}k(c){const M=c.req;this.g.handleMessage(c.method,c.args).then(T=>{this.o(new d(this.a,M,T,void 0))},T=>{T.detail instanceof Error&&(T.detail=(0,t.$1)(T.detail)),this.o(new d(this.a,M,void 0,(0,t.$1)(T)))})}l(c){const M=c.req,_=this.g.handleEvent(c.eventName,c.arg)(T=>{this.o(new w(this.a,M,T))});this.f.set(M,_)}m(c){if(!this.d.has(c.req)){console.warn("Got event for unknown req");return}this.d.get(c.req).fire(c.event)}n(c){if(!this.f.has(c.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(c.req).dispose(),this.f.delete(c.req)}o(c){const M=[];if(c.type===$.Request)for(let _=0;_<c.args.length;_++)c.args[_]instanceof ArrayBuffer&&M.push(c.args[_]);else c.type===$.Reply&&c.res instanceof ArrayBuffer&&M.push(c.res);this.g.sendMessage(c,M)}}class v extends p.$Uc{constructor(c,M,_){super();let T=null;this.a=this.B(c.create("vs/base/common/worker/simpleWorker",y=>{this.c.handleMessage(y)},y=>{T?.(y)})),this.c=new A({sendMessage:(y,W)=>{this.a.postMessage(y,W)},handleMessage:(y,W)=>{if(typeof _[y]!="function")return Promise.reject(new Error("Missing method "+y+" on main thread host."));try{return Promise.resolve(_[y].apply(_,W))}catch(B){return Promise.reject(B)}},handleEvent:(y,W)=>{if(R(y)){const B=_[y].call(_,W);if(typeof B!="function")throw new Error(`Missing dynamic event ${y} on main thread host.`);return B}if(E(y)){const B=_[y];if(typeof B!="function")throw new Error(`Missing event ${y} on main thread host.`);return B}throw new Error(`Malformed event name ${y}`)}}),this.c.setWorkerId(this.a.getId());let D=null;const j=globalThis.require;typeof j<"u"&&typeof j.getConfig=="function"?D=j.getConfig():typeof globalThis.requirejs<"u"&&(D=globalThis.requirejs.s.contexts._.config);const P=(0,h.$oo)(_);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(D)),M,P]);const I=(y,W)=>this.g(y,W),F=(y,W)=>this.c.listen(y,W);this.f=new Promise((y,W)=>{T=W,this.b.then(B=>{y(b(B,I,F))},B=>{W(B),this.h("Worker failed to load "+M,B)})})}getProxyObject(){return this.f}g(c,M){return new Promise((_,T)=>{this.b.then(()=>{this.c.sendMessage(c,M).then(_,T)},T)})}h(c,M){console.error(c),console.info(M)}}i.SimpleWorkerClient=v;function E(l){return l[0]==="o"&&l[1]==="n"&&m.$Ef(l.charCodeAt(2))}function R(l){return/^onDynamic/.test(l)&&m.$Ef(l.charCodeAt(9))}function b(l,c,M){const _=j=>function(){const P=Array.prototype.slice.call(arguments,0);return c(j,P)},T=j=>function(P){return M(j,P)},D={};for(const j of l){if(R(j)){D[j]=T(j);continue}if(E(j)){D[j]=M(j,void 0);continue}D[j]=_(j)}return D}class o{constructor(c,M){this.a=M,this.b=null,this.c=new A({sendMessage:(_,T)=>{c(_,T)},handleMessage:(_,T)=>this.d(_,T),handleEvent:(_,T)=>this.f(_,T)})}onmessage(c){this.c.handleMessage(c)}d(c,M){if(c===a)return this.g(M[0],M[1],M[2],M[3]);if(!this.b||typeof this.b[c]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+c));try{return Promise.resolve(this.b[c].apply(this.b,M))}catch(_){return Promise.reject(_)}}f(c,M){if(!this.b)throw new Error("Missing requestHandler");if(R(c)){const _=this.b[c].call(this.b,M);if(typeof _!="function")throw new Error(`Missing dynamic event ${c} on request handler.`);return _}if(E(c)){const _=this.b[c];if(typeof _!="function")throw new Error(`Missing event ${c} on request handler.`);return _}throw new Error(`Malformed event name ${c}`)}g(c,M,_,T){this.c.setWorkerId(c);const P=b(T,(I,F)=>this.c.sendMessage(I,F),(I,F)=>this.c.listen(I,F));return this.a?(this.b=this.a(P),Promise.resolve((0,h.$oo)(this.b))):(M&&(typeof M.baseUrl<"u"&&delete M.baseUrl,typeof M.paths<"u"&&typeof M.paths.vs<"u"&&delete M.paths.vs,typeof M.trustedTypesPolicy<"u"&&delete M.trustedTypesPolicy,M.catchError=!0,globalThis.require.config(M)),new Promise((I,F)=>{(globalThis.require||x)([_],W=>{if(this.b=W.create(P),!this.b){F(new Error("No RequestHandler!"));return}I((0,h.$oo)(this.b))},F)}))}}i.SimpleWorkerServer=o;function r(l){return new o(l,null)}}),ne(ie[30],re([0,1,14]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$iu=i.$hu=void 0;class n{constructor(m){const a=(0,t.$af)(m);this.c=a,this.a=n.d(a),this.b=new Map}static d(m){const a=new Uint8Array(256);return a.fill(m),a}set(m,a){const u=(0,t.$af)(a);m>=0&&m<256?this.a[m]=u:this.b.set(m,u)}get(m){return m>=0&&m<256?this.a[m]:this.b.get(m)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}i.$hu=n;var p;(function(N){N[N.False=0]="False",N[N.True=1]="True"})(p||(p={}));class h{constructor(){this.a=new n(p.False)}add(m){this.a.set(m,p.True)}has(m){return this.a.get(m)===p.True}clear(){return this.a.clear()}}i.$iu=h}),ne(ie[6],re([0,1,5]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Wt=i.$Vt=void 0;class n{static addRange(N,m){let a=0;for(;a<m.length&&m[a].endExclusive<N.start;)a++;let u=a;for(;u<m.length&&m[u].start<=N.endExclusive;)u++;if(a===u)m.splice(a,0,N);else{const f=Math.min(N.start,m[a].start),$=Math.max(N.endExclusive,m[u-1].endExclusive);m.splice(a,u-a,new n(f,$))}}static tryCreate(N,m){if(!(N>m))return new n(N,m)}static ofLength(N){return new n(0,N)}static ofStartAndLength(N,m){return new n(N,N+m)}constructor(N,m){if(this.start=N,this.endExclusive=m,N>m)throw new t.$bb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(N){return new n(this.start+N,this.endExclusive+N)}deltaStart(N){return new n(this.start+N,this.endExclusive)}deltaEnd(N){return new n(this.start,this.endExclusive+N)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(N){return this.start===N.start&&this.endExclusive===N.endExclusive}containsRange(N){return this.start<=N.start&&N.endExclusive<=this.endExclusive}contains(N){return this.start<=N&&N<this.endExclusive}join(N){return new n(Math.min(this.start,N.start),Math.max(this.endExclusive,N.endExclusive))}intersect(N){const m=Math.max(this.start,N.start),a=Math.min(this.endExclusive,N.endExclusive);if(m<=a)return new n(m,a)}intersects(N){const m=Math.max(this.start,N.start),a=Math.min(this.endExclusive,N.endExclusive);return m<a}intersectsOrTouches(N){const m=Math.max(this.start,N.start),a=Math.min(this.endExclusive,N.endExclusive);return m<=a}isBefore(N){return this.endExclusive<=N.start}isAfter(N){return this.start>=N.endExclusive}slice(N){return N.slice(this.start,this.endExclusive)}substring(N){return N.substring(this.start,this.endExclusive)}clip(N){if(this.isEmpty)throw new t.$bb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,N))}clipCyclic(N){if(this.isEmpty)throw new t.$bb(`Invalid clipping range: ${this.toString()}`);return N<this.start?this.endExclusive-(this.start-N)%this.length:N>=this.endExclusive?this.start+(N-this.start)%this.length:N}map(N){const m=[];for(let a=this.start;a<this.endExclusive;a++)m.push(N(a));return m}forEach(N){for(let m=this.start;m<this.endExclusive;m++)N(m)}}i.$Vt=n;class p{constructor(){this.a=[]}addRange(N){let m=0;for(;m<this.a.length&&this.a[m].endExclusive<N.start;)m++;let a=m;for(;a<this.a.length&&this.a[a].start<=N.endExclusive;)a++;if(m===a)this.a.splice(m,0,N);else{const u=Math.min(N.start,this.a[m].start),f=Math.max(N.endExclusive,this.a[a-1].endExclusive);this.a.splice(m,a-m,new n(u,f))}}toString(){return this.a.map(N=>N.toString()).join(", ")}intersectsStrict(N){let m=0;for(;m<this.a.length&&this.a[m].endExclusive<=N.start;)m++;return m<this.a.length&&this.a[m].start<N.endExclusive}intersectWithRange(N){const m=new p;for(const a of this.a){const u=a.intersect(N);u&&m.addRange(u)}return m}intersectWithRangeLength(N){return this.intersectWithRange(N).length}get length(){return this.a.reduce((N,m)=>N+m.length,0)}}i.$Wt=p}),ne(ie[3],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Nt=void 0;class t{constructor(p,h){this.lineNumber=p,this.column=h}with(p=this.lineNumber,h=this.column){return p===this.lineNumber&&h===this.column?this:new t(p,h)}delta(p=0,h=0){return this.with(this.lineNumber+p,this.column+h)}equals(p){return t.equals(this,p)}static equals(p,h){return!p&&!h?!0:!!p&&!!h&&p.lineNumber===h.lineNumber&&p.column===h.column}isBefore(p){return t.isBefore(this,p)}static isBefore(p,h){return p.lineNumber<h.lineNumber?!0:h.lineNumber<p.lineNumber?!1:p.column<h.column}isBeforeOrEqual(p){return t.isBeforeOrEqual(this,p)}static isBeforeOrEqual(p,h){return p.lineNumber<h.lineNumber?!0:h.lineNumber<p.lineNumber?!1:p.column<=h.column}static compare(p,h){const N=p.lineNumber|0,m=h.lineNumber|0;if(N===m){const a=p.column|0,u=h.column|0;return a-u}return N-m}clone(){return new t(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(p){return new t(p.lineNumber,p.column)}static isIPosition(p){return p&&typeof p.lineNumber=="number"&&typeof p.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}i.$Nt=t}),ne(ie[2],re([0,1,3]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Ot=void 0;class n{constructor(h,N,m,a){h>m||h===m&&N>a?(this.startLineNumber=m,this.startColumn=a,this.endLineNumber=h,this.endColumn=N):(this.startLineNumber=h,this.startColumn=N,this.endLineNumber=m,this.endColumn=a)}isEmpty(){return n.isEmpty(this)}static isEmpty(h){return h.startLineNumber===h.endLineNumber&&h.startColumn===h.endColumn}containsPosition(h){return n.containsPosition(this,h)}static containsPosition(h,N){return!(N.lineNumber<h.startLineNumber||N.lineNumber>h.endLineNumber||N.lineNumber===h.startLineNumber&&N.column<h.startColumn||N.lineNumber===h.endLineNumber&&N.column>h.endColumn)}static strictContainsPosition(h,N){return!(N.lineNumber<h.startLineNumber||N.lineNumber>h.endLineNumber||N.lineNumber===h.startLineNumber&&N.column<=h.startColumn||N.lineNumber===h.endLineNumber&&N.column>=h.endColumn)}containsRange(h){return n.containsRange(this,h)}static containsRange(h,N){return!(N.startLineNumber<h.startLineNumber||N.endLineNumber<h.startLineNumber||N.startLineNumber>h.endLineNumber||N.endLineNumber>h.endLineNumber||N.startLineNumber===h.startLineNumber&&N.startColumn<h.startColumn||N.endLineNumber===h.endLineNumber&&N.endColumn>h.endColumn)}strictContainsRange(h){return n.strictContainsRange(this,h)}static strictContainsRange(h,N){return!(N.startLineNumber<h.startLineNumber||N.endLineNumber<h.startLineNumber||N.startLineNumber>h.endLineNumber||N.endLineNumber>h.endLineNumber||N.startLineNumber===h.startLineNumber&&N.startColumn<=h.startColumn||N.endLineNumber===h.endLineNumber&&N.endColumn>=h.endColumn)}plusRange(h){return n.plusRange(this,h)}static plusRange(h,N){let m,a,u,f;return N.startLineNumber<h.startLineNumber?(m=N.startLineNumber,a=N.startColumn):N.startLineNumber===h.startLineNumber?(m=N.startLineNumber,a=Math.min(N.startColumn,h.startColumn)):(m=h.startLineNumber,a=h.startColumn),N.endLineNumber>h.endLineNumber?(u=N.endLineNumber,f=N.endColumn):N.endLineNumber===h.endLineNumber?(u=N.endLineNumber,f=Math.max(N.endColumn,h.endColumn)):(u=h.endLineNumber,f=h.endColumn),new n(m,a,u,f)}intersectRanges(h){return n.intersectRanges(this,h)}static intersectRanges(h,N){let m=h.startLineNumber,a=h.startColumn,u=h.endLineNumber,f=h.endColumn;const $=N.startLineNumber,g=N.startColumn,d=N.endLineNumber,e=N.endColumn;return m<$?(m=$,a=g):m===$&&(a=Math.max(a,g)),u>d?(u=d,f=e):u===d&&(f=Math.min(f,e)),m>u||m===u&&a>f?null:new n(m,a,u,f)}equalsRange(h){return n.equalsRange(this,h)}static equalsRange(h,N){return!h&&!N?!0:!!h&&!!N&&h.startLineNumber===N.startLineNumber&&h.startColumn===N.startColumn&&h.endLineNumber===N.endLineNumber&&h.endColumn===N.endColumn}getEndPosition(){return n.getEndPosition(this)}static getEndPosition(h){return new t.$Nt(h.endLineNumber,h.endColumn)}getStartPosition(){return n.getStartPosition(this)}static getStartPosition(h){return new t.$Nt(h.startLineNumber,h.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(h,N){return new n(this.startLineNumber,this.startColumn,h,N)}setStartPosition(h,N){return new n(h,N,this.endLineNumber,this.endColumn)}collapseToStart(){return n.collapseToStart(this)}static collapseToStart(h){return new n(h.startLineNumber,h.startColumn,h.startLineNumber,h.startColumn)}collapseToEnd(){return n.collapseToEnd(this)}static collapseToEnd(h){return new n(h.endLineNumber,h.endColumn,h.endLineNumber,h.endColumn)}delta(h){return new n(this.startLineNumber+h,this.startColumn,this.endLineNumber+h,this.endColumn)}static fromPositions(h,N=h){return new n(h.lineNumber,h.column,N.lineNumber,N.column)}static lift(h){return h?new n(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):null}static isIRange(h){return h&&typeof h.startLineNumber=="number"&&typeof h.startColumn=="number"&&typeof h.endLineNumber=="number"&&typeof h.endColumn=="number"}static areIntersectingOrTouching(h,N){return!(h.endLineNumber<N.startLineNumber||h.endLineNumber===N.startLineNumber&&h.endColumn<N.startColumn||N.endLineNumber<h.startLineNumber||N.endLineNumber===h.startLineNumber&&N.endColumn<h.startColumn)}static areIntersecting(h,N){return!(h.endLineNumber<N.startLineNumber||h.endLineNumber===N.startLineNumber&&h.endColumn<=N.startColumn||N.endLineNumber<h.startLineNumber||N.endLineNumber===h.startLineNumber&&N.endColumn<=h.startColumn)}static compareRangesUsingStarts(h,N){if(h&&N){const u=h.startLineNumber|0,f=N.startLineNumber|0;if(u===f){const $=h.startColumn|0,g=N.startColumn|0;if($===g){const d=h.endLineNumber|0,e=N.endLineNumber|0;if(d===e){const w=h.endColumn|0,L=N.endColumn|0;return w-L}return d-e}return $-g}return u-f}return(h?1:0)-(N?1:0)}static compareRangesUsingEnds(h,N){return h.endLineNumber===N.endLineNumber?h.endColumn===N.endColumn?h.startLineNumber===N.startLineNumber?h.startColumn-N.startColumn:h.startLineNumber-N.startLineNumber:h.endColumn-N.endColumn:h.endLineNumber-N.endLineNumber}static spansMultipleLines(h){return h.endLineNumber>h.startLineNumber}toJSON(){return this}}i.$Ot=n}),ne(ie[49],re([0,1,2]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Pt=void 0;class n{static insert(h,N){return{range:new t.$Ot(h.lineNumber,h.column,h.lineNumber,h.column),text:N,forceMoveMarkers:!0}}static delete(h){return{range:h,text:null}}static replace(h,N){return{range:h,text:N}}static replaceMove(h,N){return{range:h,text:N,forceMoveMarkers:!0}}}i.$Pt=n}),ne(ie[15],re([0,1,5,6,2,9]),function(x,i,t,n,p,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Yt=i.$Xt=void 0;class N{static fromRange(u){return new N(u.startLineNumber,u.endLineNumber)}static fromRangeInclusive(u){return new N(u.startLineNumber,u.endLineNumber+1)}static subtract(u,f){return f?u.startLineNumber<f.startLineNumber&&f.endLineNumberExclusive<u.endLineNumberExclusive?[new N(u.startLineNumber,f.startLineNumber),new N(f.endLineNumberExclusive,u.endLineNumberExclusive)]:f.startLineNumber<=u.startLineNumber&&u.endLineNumberExclusive<=f.endLineNumberExclusive?[]:f.endLineNumberExclusive<u.endLineNumberExclusive?[new N(Math.max(f.endLineNumberExclusive,u.startLineNumber),u.endLineNumberExclusive)]:[new N(u.startLineNumber,Math.min(f.startLineNumber,u.endLineNumberExclusive))]:[u]}static joinMany(u){if(u.length===0)return[];let f=new m(u[0].slice());for(let $=1;$<u.length;$++)f=f.getUnion(new m(u[$].slice()));return f.ranges}static join(u){if(u.length===0)throw new t.$bb("lineRanges cannot be empty");let f=u[0].startLineNumber,$=u[0].endLineNumberExclusive;for(let g=1;g<u.length;g++)f=Math.min(f,u[g].startLineNumber),$=Math.max($,u[g].endLineNumberExclusive);return new N(f,$)}static ofLength(u,f){return new N(u,u+f)}static deserialize(u){return new N(u[0],u[1])}constructor(u,f){if(u>f)throw new t.$bb(`startLineNumber ${u} cannot be after endLineNumberExclusive ${f}`);this.startLineNumber=u,this.endLineNumberExclusive=f}contains(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(u){return new N(this.startLineNumber+u,this.endLineNumberExclusive+u)}deltaLength(u){return new N(this.startLineNumber,this.endLineNumberExclusive+u)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(u){return new N(Math.min(this.startLineNumber,u.startLineNumber),Math.max(this.endLineNumberExclusive,u.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(u){const f=Math.max(this.startLineNumber,u.startLineNumber),$=Math.min(this.endLineNumberExclusive,u.endLineNumberExclusive);if(f<=$)return new N(f,$)}intersectsStrict(u){return this.startLineNumber<u.endLineNumberExclusive&&u.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(u){return this.startLineNumber<=u.endLineNumberExclusive&&u.startLineNumber<=this.endLineNumberExclusive}equals(u){return this.startLineNumber===u.startLineNumber&&this.endLineNumberExclusive===u.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new p.$Ot(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new p.$Ot(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(u){const f=[];for(let $=this.startLineNumber;$<this.endLineNumberExclusive;$++)f.push(u($));return f}forEach(u){for(let f=this.startLineNumber;f<this.endLineNumberExclusive;f++)u(f)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}toOffsetRange(){return new n.$Vt(this.startLineNumber-1,this.endLineNumberExclusive-1)}}i.$Xt=N;class m{constructor(u=[]){this.c=u}get ranges(){return this.c}addRange(u){if(u.length===0)return;const f=(0,h.$jb)(this.c,g=>g.endLineNumberExclusive>=u.startLineNumber),$=(0,h.$hb)(this.c,g=>g.startLineNumber<=u.endLineNumberExclusive)+1;if(f===$)this.c.splice(f,0,u);else if(f===$-1){const g=this.c[f];this.c[f]=g.join(u)}else{const g=this.c[f].join(this.c[$-1]).join(u);this.c.splice(f,$-f,g)}}contains(u){const f=(0,h.$gb)(this.c,$=>$.startLineNumber<=u);return!!f&&f.endLineNumberExclusive>u}intersects(u){const f=(0,h.$gb)(this.c,$=>$.startLineNumber<u.endLineNumberExclusive);return!!f&&f.endLineNumberExclusive>u.startLineNumber}getUnion(u){if(this.c.length===0)return u;if(u.c.length===0)return this;const f=[];let $=0,g=0,d=null;for(;$<this.c.length||g<u.c.length;){let e=null;if($<this.c.length&&g<u.c.length){const w=this.c[$],L=u.c[g];w.startLineNumber<L.startLineNumber?(e=w,$++):(e=L,g++)}else $<this.c.length?(e=this.c[$],$++):(e=u.c[g],g++);d===null?d=e:d.endLineNumberExclusive>=e.startLineNumber?d=new N(d.startLineNumber,Math.max(d.endLineNumberExclusive,e.endLineNumberExclusive)):(f.push(d),d=e)}return d!==null&&f.push(d),new m(f)}subtractFrom(u){const f=(0,h.$jb)(this.c,e=>e.endLineNumberExclusive>=u.startLineNumber),$=(0,h.$hb)(this.c,e=>e.startLineNumber<=u.endLineNumberExclusive)+1;if(f===$)return new m([u]);const g=[];let d=u.startLineNumber;for(let e=f;e<$;e++){const w=this.c[e];w.startLineNumber>d&&g.push(new N(d,w.startLineNumber)),d=w.endLineNumberExclusive}return d<u.endLineNumberExclusive&&g.push(new N(d,u.endLineNumberExclusive)),new m(g)}toString(){return this.c.map(u=>u.toString()).join(", ")}getIntersection(u){const f=[];let $=0,g=0;for(;$<this.c.length&&g<u.c.length;){const d=this.c[$],e=u.c[g],w=d.intersect(e);w&&!w.isEmpty&&f.push(w),d.endLineNumberExclusive<e.endLineNumberExclusive?$++:g++}return new m(f)}getWithDelta(u){return new m(this.c.map(f=>f.delta(u)))}}i.$Yt=m}),ne(ie[50],re([0,1,3,2]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Qt=i.SelectionDirection=void 0;var p;(function(N){N[N.LTR=0]="LTR",N[N.RTL=1]="RTL"})(p||(i.SelectionDirection=p={}));class h extends n.$Ot{constructor(m,a,u,f){super(m,a,u,f),this.selectionStartLineNumber=m,this.selectionStartColumn=a,this.positionLineNumber=u,this.positionColumn=f}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return h.selectionsEqual(this,m)}static selectionsEqual(m,a){return m.selectionStartLineNumber===a.selectionStartLineNumber&&m.selectionStartColumn===a.selectionStartColumn&&m.positionLineNumber===a.positionLineNumber&&m.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?p.LTR:p.RTL}setEndPosition(m,a){return this.getDirection()===p.LTR?new h(this.startLineNumber,this.startColumn,m,a):new h(m,a,this.startLineNumber,this.startColumn)}getPosition(){return new t.$Nt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new t.$Nt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,a){return this.getDirection()===p.LTR?new h(m,a,this.endLineNumber,this.endColumn):new h(this.endLineNumber,this.endColumn,m,a)}static fromPositions(m,a=m){return new h(m.lineNumber,m.column,a.lineNumber,a.column)}static fromRange(m,a){return a===p.LTR?new h(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new h(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new h(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,a){if(m&&!a||!m&&a)return!1;if(!m&&!a)return!0;if(m.length!==a.length)return!1;for(let u=0,f=m.length;u<f;u++)if(!this.selectionsEqual(m[u],a[u]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,a,u,f,$){return $===p.LTR?new h(m,a,u,f):new h(u,f,m,a)}}i.$Qt=h}),ne(ie[31],re([0,1,3,2]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Zt=void 0;class p{static{this.zero=new p(0,0)}static lengthDiffNonNegative(N,m){return m.isLessThan(N)?p.zero:N.lineCount===m.lineCount?new p(0,m.columnCount-N.columnCount):new p(m.lineCount-N.lineCount,m.columnCount)}static betweenPositions(N,m){return N.lineNumber===m.lineNumber?new p(0,m.column-N.column):new p(m.lineNumber-N.lineNumber,m.column-1)}static ofRange(N){return p.betweenPositions(N.getStartPosition(),N.getEndPosition())}static ofText(N){let m=0,a=0;for(const u of N)u===`
`?(m++,a=0):a++;return new p(m,a)}constructor(N,m){this.lineCount=N,this.columnCount=m}isZero(){return this.lineCount===0&&this.columnCount===0}isLessThan(N){return this.lineCount!==N.lineCount?this.lineCount<N.lineCount:this.columnCount<N.columnCount}isGreaterThan(N){return this.lineCount!==N.lineCount?this.lineCount>N.lineCount:this.columnCount>N.columnCount}isGreaterThanOrEqualTo(N){return this.lineCount!==N.lineCount?this.lineCount>N.lineCount:this.columnCount>=N.columnCount}equals(N){return this.lineCount===N.lineCount&&this.columnCount===N.columnCount}compare(N){return this.lineCount!==N.lineCount?this.lineCount-N.lineCount:this.columnCount-N.columnCount}add(N){return N.lineCount===0?new p(this.lineCount,this.columnCount+N.columnCount):new p(this.lineCount+N.lineCount,N.columnCount)}createRange(N){return this.lineCount===0?new n.$Ot(N.lineNumber,N.column,N.lineNumber,N.column+this.columnCount):new n.$Ot(N.lineNumber,N.column,N.lineNumber+this.lineCount,this.columnCount+1)}toRange(){return new n.$Ot(1,1,this.lineCount+1,this.columnCount+1)}addToPosition(N){return this.lineCount===0?new t.$Nt(N.lineNumber,N.column+this.columnCount):new t.$Nt(N.lineNumber+this.lineCount,this.columnCount+1)}toString(){return`${this.lineCount},${this.columnCount}`}}i.$Zt=p}),ne(ie[51],re([0,1,9,6,3,2,31]),function(x,i,t,n,p,h,N){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$1t=void 0;class m{constructor(u){this.text=u,this.a=[],this.a.push(0);for(let f=0;f<u.length;f++)u.charAt(f)===`
`&&this.a.push(f+1)}getOffset(u){return this.a[u.lineNumber-1]+u.column-1}getOffsetRange(u){return new n.$Vt(this.getOffset(u.getStartPosition()),this.getOffset(u.getEndPosition()))}getPosition(u){const f=(0,t.$hb)(this.a,d=>d<=u),$=f+1,g=u-this.a[f]+1;return new p.$Nt($,g)}getRange(u){return h.$Ot.fromPositions(this.getPosition(u.start),this.getPosition(u.endExclusive))}getTextLength(u){return N.$Zt.ofRange(this.getRange(u))}get textLength(){const u=this.a.length-1;return new N.$Zt(u,this.text.length-this.a[u])}}i.$1t=m}),ne(ie[52],re([0,1,11,5,3,51,2,31]),function(x,i,t,n,p,h,N,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$7t=i.$6t=i.$5t=i.$4t=i.$3t=i.$2t=void 0;class a{static single(L,A){return new a([new u(L,A)])}constructor(L){this.edits=L,(0,t.$hd)(()=>(0,t.$id)(L,(A,v)=>A.range.getEndPosition().isBeforeOrEqual(v.range.getStartPosition())))}normalize(){const L=[];for(const A of this.edits)if(L.length>0&&L[L.length-1].range.getEndPosition().equals(A.range.getStartPosition())){const v=L[L.length-1];L[L.length-1]=new u(v.range.plusRange(A.range),v.text+A.text)}else A.isEmpty||L.push(A);return new a(L)}mapPosition(L){let A=0,v=0,E=0;for(const R of this.edits){const b=R.range.getStartPosition(),o=R.range.getEndPosition();if(L.isBeforeOrEqual(b))break;const r=m.$Zt.ofText(R.text);if(L.isBefore(o)){const l=new p.$Nt(b.lineNumber+A,b.column+(b.lineNumber+A===v?E:0)),c=r.addToPosition(l);return f(l,c)}A+=r.lineCount-(R.range.endLineNumber-R.range.startLineNumber),r.lineCount===0?o.lineNumber!==b.lineNumber?E+=r.columnCount-(o.column-1):E+=r.columnCount-(o.column-b.column):E=r.columnCount,v=o.lineNumber+A}return new p.$Nt(L.lineNumber+A,L.column+(L.lineNumber+A===v?E:0))}mapRange(L){function A(b){return b instanceof p.$Nt?b:b.getStartPosition()}function v(b){return b instanceof p.$Nt?b:b.getEndPosition()}const E=A(this.mapPosition(L.getStartPosition())),R=v(this.mapPosition(L.getEndPosition()));return f(E,R)}inverseMapPosition(L,A){return this.inverse(A).mapPosition(L)}inverseMapRange(L,A){return this.inverse(A).mapRange(L)}apply(L){let A="",v=new p.$Nt(1,1);for(const R of this.edits){const b=R.range,o=b.getStartPosition(),r=b.getEndPosition(),l=f(v,o);l.isEmpty()||(A+=L.getValueOfRange(l)),A+=R.text,v=r}const E=f(v,L.endPositionExclusive);return E.isEmpty()||(A+=L.getValueOfRange(E)),A}applyToString(L){const A=new e(L);return this.apply(A)}inverse(L){const A=this.getNewRanges();return new a(this.edits.map((v,E)=>new u(A[E],L.getValueOfRange(v.range))))}getNewRanges(){const L=[];let A=0,v=0,E=0;for(const R of this.edits){const b=m.$Zt.ofText(R.text),o=p.$Nt.lift({lineNumber:R.range.startLineNumber+v,column:R.range.startColumn+(R.range.startLineNumber===A?E:0)}),r=b.createRange(o);L.push(r),v=r.endLineNumber-R.range.endLineNumber,E=r.endColumn-R.range.endColumn,A=R.range.endLineNumber}return L}}i.$2t=a;class u{constructor(L,A){this.range=L,this.text=A}get isEmpty(){return this.range.isEmpty()&&this.text.length===0}static equals(L,A){return L.range.equalsRange(A.range)&&L.text===A.text}toSingleEditOperation(){return{range:this.range,text:this.text}}}i.$3t=u;function f(w,L){if(w.lineNumber===L.lineNumber&&w.column===Number.MAX_SAFE_INTEGER)return N.$Ot.fromPositions(L,L);if(!w.isBeforeOrEqual(L))throw new n.$bb("start must be before end");return new N.$Ot(w.lineNumber,w.column,L.lineNumber,L.column)}class ${get endPositionExclusive(){return this.length.addToPosition(new p.$Nt(1,1))}getValue(){return this.getValueOfRange(this.length.toRange())}}i.$4t=$;class g extends ${constructor(L,A){(0,t.$fd)(A>=1),super(),this.c=L,this.d=A}getValueOfRange(L){if(L.startLineNumber===L.endLineNumber)return this.c(L.startLineNumber).substring(L.startColumn-1,L.endColumn-1);let A=this.c(L.startLineNumber).substring(L.startColumn-1);for(let v=L.startLineNumber+1;v<L.endLineNumber;v++)A+=`
`+this.c(v);return A+=`
`+this.c(L.endLineNumber).substring(0,L.endColumn-1),A}get length(){const L=this.c(this.d);return new m.$Zt(this.d-1,L.length)}}i.$5t=g;class d extends g{constructor(L){super(A=>L[A-1],L.length)}}i.$6t=d;class e extends ${constructor(L){super(),this.value=L,this.c=new h.$1t(this.value)}getValueOfRange(L){return this.c.getOffsetRange(L).substring(this.value)}get length(){return this.c.textLength}}i.$7t=e}),ne(ie[53],re([0,1,4,16,30]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ju=i.WordCharacterClass=void 0,i.$ku=a;var h;(function(u){u[u.Regular=0]="Regular",u[u.Whitespace=1]="Whitespace",u[u.WordSeparator=2]="WordSeparator"})(h||(i.WordCharacterClass=h={}));class N extends p.$hu{constructor(f,$){super(h.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=$,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let g=0,d=f.length;g<d;g++)this.set(f.charCodeAt(g),h.WordSeparator);this.set(t.CharCode.Space,h.Whitespace),this.set(t.CharCode.Tab,h.Whitespace)}findPrevIntlWordBeforeOrAtOffset(f,$){let g=null;for(const d of this.h(f)){if(d.index>$)break;g=d}return g}findNextIntlWordAtOrAfterOffset(f,$){for(const g of this.h(f))if(!(g.index<$))return g;return null}h(f){return this.e?this.f===f?this.g:(this.f=f,this.g=this.j(this.e.segment(f)),this.g):[]}j(f){const $=[];for(const g of f)this.k(g)&&$.push(g);return $}k(f){return!!f.isWordLike}}i.$ju=N;const m=new n.$Dc(10);function a(u,f){const $=`${u}/${f.join(",")}`;let g=m.get($);return g||(g=new N(u,f),m.set($,g)),g}}),ne(ie[32],re([0,1,23,12,24]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$nt=i.$mt=void 0,i.$ot=N,i.$pt=a,i.$qt=u,i.$mt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function h($=""){let g="(-?\\d*\\.\\d\\w*)|([^";for(const d of i.$mt)$.indexOf(d)>=0||(g+="\\"+d);return g+="\\s]+)",new RegExp(g,"g")}i.$nt=h();function N($){let g=i.$nt;if($&&$ instanceof RegExp)if($.global)g=$;else{let d="g";$.ignoreCase&&(d+="i"),$.multiline&&(d+="m"),$.unicode&&(d+="u"),g=new RegExp($.source,d)}return g.lastIndex=0,g}const m=new p.$5c;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a($){const g=m.unshift($);return(0,n.$Sc)(g)}function u($,g,d,e,w){if(g=N(g),w||(w=t.Iterable.first(m)),d.length>w.maxLen){let R=$-w.maxLen/2;return R<0?R=0:e+=R,d=d.substring(R,$+w.maxLen/2),u($,g,d,e,w)}const L=Date.now(),A=$-1-e;let v=-1,E=null;for(let R=1;!(Date.now()-L>=w.timeBudget);R++){const b=A-w.windowSize*R;g.lastIndex=Math.max(0,b);const o=f(g,d,A,v);if(!o&&E||(E=o,b<=0))break;v=b}if(E){const R={word:E[0],startColumn:e+1+E.index,endColumn:e+1+E.index+E[0].length};return g.lastIndex=0,R}return null}function f($,g,d,e){let w;for(;w=$.exec(g);){const L=w.index||0;if(L<=d&&$.lastIndex>=d)return w;if(e>0&&L>e)return null}return null}}),ne(ie[10],re([0,1,7,5,6]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$P4=i.$O4=i.$N4=i.$M4=i.$L4=void 0;class h{static trivial($,g){return new h([new N(p.$Vt.ofLength($.length),p.$Vt.ofLength(g.length))],!1)}static trivialTimedOut($,g){return new h([new N(p.$Vt.ofLength($.length),p.$Vt.ofLength(g.length))],!0)}constructor($,g){this.diffs=$,this.hitTimeout=g}}i.$L4=h;class N{static invert($,g){const d=[];return(0,t.$Ab)($,(e,w)=>{d.push(N.fromOffsetPairs(e?e.getEndExclusives():m.zero,w?w.getStarts():new m(g,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+g)))}),d}static fromOffsetPairs($,g){return new N(new p.$Vt($.offset1,g.offset1),new p.$Vt($.offset2,g.offset2))}static assertSorted($){let g;for(const d of $){if(g&&!(g.seq1Range.endExclusive<=d.seq1Range.start&&g.seq2Range.endExclusive<=d.seq2Range.start))throw new n.$bb("Sequence diffs must be sorted");g=d}}constructor($,g){this.seq1Range=$,this.seq2Range=g}swap(){return new N(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join($){return new N(this.seq1Range.join($.seq1Range),this.seq2Range.join($.seq2Range))}delta($){return $===0?this:new N(this.seq1Range.delta($),this.seq2Range.delta($))}deltaStart($){return $===0?this:new N(this.seq1Range.deltaStart($),this.seq2Range.deltaStart($))}deltaEnd($){return $===0?this:new N(this.seq1Range.deltaEnd($),this.seq2Range.deltaEnd($))}intersectsOrTouches($){return this.seq1Range.intersectsOrTouches($.seq1Range)||this.seq2Range.intersectsOrTouches($.seq2Range)}intersect($){const g=this.seq1Range.intersect($.seq1Range),d=this.seq2Range.intersect($.seq2Range);if(!(!g||!d))return new N(g,d)}getStarts(){return new m(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new m(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}i.$M4=N;class m{static{this.zero=new m(0,0)}static{this.max=new m(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor($,g){this.offset1=$,this.offset2=g}toString(){return`${this.offset1} <-> ${this.offset2}`}delta($){return $===0?this:new m(this.offset1+$,this.offset2+$)}equals($){return this.offset1===$.offset1&&this.offset2===$.offset2}}i.$N4=m;class a{static{this.instance=new a}isValid(){return!0}}i.$O4=a;class u{constructor($){if(this.e=$,this.c=Date.now(),this.d=!0,$<=0)throw new n.$bb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}i.$P4=u}),ne(ie[33],re([0,1,6,10]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$U4=void 0;class p{compute(u,f,$=n.$O4.instance){if(u.length===0||f.length===0)return n.$L4.trivial(u,f);const g=u,d=f;function e(r,l){for(;r<g.length&&l<d.length&&g.getElement(r)===d.getElement(l);)r++,l++;return r}let w=0;const L=new N;L.set(0,e(0,0));const A=new m;A.set(0,L.get(0)===0?null:new h(null,0,0,L.get(0)));let v=0;e:for(;;){if(w++,!$.isValid())return n.$L4.trivialTimedOut(g,d);const r=-Math.min(w,d.length+w%2),l=Math.min(w,g.length+w%2);for(v=r;v<=l;v+=2){let c=0;const M=v===l?-1:L.get(v+1),_=v===r?-1:L.get(v-1)+1;c++;const T=Math.min(Math.max(M,_),g.length),D=T-v;if(c++,T>g.length||D>d.length)continue;const j=e(T,D);L.set(v,j);const P=T===M?A.get(v+1):A.get(v-1);if(A.set(v,j!==T?new h(P,T,D,j-T):P),L.get(v)===g.length&&L.get(v)-v===d.length)break e}}let E=A.get(v);const R=[];let b=g.length,o=d.length;for(;;){const r=E?E.x+E.length:0,l=E?E.y+E.length:0;if((r!==b||l!==o)&&R.push(new n.$M4(new t.$Vt(r,b),new t.$Vt(l,o))),!E)break;b=E.x,o=E.y,E=E.prev}return R.reverse(),new n.$L4(R,!1)}}i.$U4=p;class h{constructor(u,f,$,g){this.prev=u,this.x=f,this.y=$,this.length=g}}class N{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,f){if(u<0){if(u=-u-1,u>=this.b.length){const $=this.b;this.b=new Int32Array($.length*2),this.b.set($)}this.b[u]=f}else{if(u>=this.a.length){const $=this.a;this.a=new Int32Array($.length*2),this.a.set($)}this.a[u]=f}}}class m{constructor(){this.a=[],this.b=[]}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,f){u<0?(u=-u-1,this.b[u]=f):this.a[u]=f}}}),ne(ie[54],re([0,1,7,6,10]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Y4=h,i.$Z4=u,i.$14=f,i.$24=g,i.$34=d;function h(e,w,L){let A=L;return A=N(e,w,A),A=N(e,w,A),A=m(e,w,A),A}function N(e,w,L){if(L.length===0)return L;const A=[];A.push(L[0]);for(let E=1;E<L.length;E++){const R=A[A.length-1];let b=L[E];if(b.seq1Range.isEmpty||b.seq2Range.isEmpty){const o=b.seq1Range.start-R.seq1Range.endExclusive;let r;for(r=1;r<=o&&!(e.getElement(b.seq1Range.start-r)!==e.getElement(b.seq1Range.endExclusive-r)||w.getElement(b.seq2Range.start-r)!==w.getElement(b.seq2Range.endExclusive-r));r++);if(r--,r===o){A[A.length-1]=new p.$M4(new n.$Vt(R.seq1Range.start,b.seq1Range.endExclusive-o),new n.$Vt(R.seq2Range.start,b.seq2Range.endExclusive-o));continue}b=b.delta(-r)}A.push(b)}const v=[];for(let E=0;E<A.length-1;E++){const R=A[E+1];let b=A[E];if(b.seq1Range.isEmpty||b.seq2Range.isEmpty){const o=R.seq1Range.start-b.seq1Range.endExclusive;let r;for(r=0;r<o&&!(!e.isStronglyEqual(b.seq1Range.start+r,b.seq1Range.endExclusive+r)||!w.isStronglyEqual(b.seq2Range.start+r,b.seq2Range.endExclusive+r));r++);if(r===o){A[E+1]=new p.$M4(new n.$Vt(b.seq1Range.start+o,R.seq1Range.endExclusive),new n.$Vt(b.seq2Range.start+o,R.seq2Range.endExclusive));continue}r>0&&(b=b.delta(r))}v.push(b)}return A.length>0&&v.push(A[A.length-1]),v}function m(e,w,L){if(!e.getBoundaryScore||!w.getBoundaryScore)return L;for(let A=0;A<L.length;A++){const v=A>0?L[A-1]:void 0,E=L[A],R=A+1<L.length?L[A+1]:void 0,b=new n.$Vt(v?v.seq1Range.endExclusive+1:0,R?R.seq1Range.start-1:e.length),o=new n.$Vt(v?v.seq2Range.endExclusive+1:0,R?R.seq2Range.start-1:w.length);E.seq1Range.isEmpty?L[A]=a(E,e,w,b,o):E.seq2Range.isEmpty&&(L[A]=a(E.swap(),w,e,o,b).swap())}return L}function a(e,w,L,A,v){let R=1;for(;e.seq1Range.start-R>=A.start&&e.seq2Range.start-R>=v.start&&L.isStronglyEqual(e.seq2Range.start-R,e.seq2Range.endExclusive-R)&&R<100;)R++;R--;let b=0;for(;e.seq1Range.start+b<A.endExclusive&&e.seq2Range.endExclusive+b<v.endExclusive&&L.isStronglyEqual(e.seq2Range.start+b,e.seq2Range.endExclusive+b)&&b<100;)b++;if(R===0&&b===0)return e;let o=0,r=-1;for(let l=-R;l<=b;l++){const c=e.seq2Range.start+l,M=e.seq2Range.endExclusive+l,_=e.seq1Range.start+l,T=w.getBoundaryScore(_)+L.getBoundaryScore(c)+L.getBoundaryScore(M);T>r&&(r=T,o=l)}return e.delta(o)}function u(e,w,L){const A=[];for(const v of L){const E=A[A.length-1];if(!E){A.push(v);continue}v.seq1Range.start-E.seq1Range.endExclusive<=2||v.seq2Range.start-E.seq2Range.endExclusive<=2?A[A.length-1]=new p.$M4(E.seq1Range.join(v.seq1Range),E.seq2Range.join(v.seq2Range)):A.push(v)}return A}function f(e,w,L){const A=p.$M4.invert(L,e.length),v=[];let E=new p.$N4(0,0);function R(o,r){if(o.offset1<E.offset1||o.offset2<E.offset2)return;const l=e.findWordContaining(o.offset1),c=w.findWordContaining(o.offset2);if(!l||!c)return;let M=new p.$M4(l,c);const _=M.intersect(r);let T=_.seq1Range.length,D=_.seq2Range.length;for(;A.length>0;){const j=A[0];if(!(j.seq1Range.intersects(M.seq1Range)||j.seq2Range.intersects(M.seq2Range)))break;const I=e.findWordContaining(j.seq1Range.start),F=w.findWordContaining(j.seq2Range.start),y=new p.$M4(I,F),W=y.intersect(j);if(T+=W.seq1Range.length,D+=W.seq2Range.length,M=M.join(y),M.seq1Range.endExclusive>=j.seq1Range.endExclusive)A.shift();else break}T+D<(M.seq1Range.length+M.seq2Range.length)*2/3&&v.push(M),E=M.getEndExclusives()}for(;A.length>0;){const o=A.shift();o.seq1Range.isEmpty||(R(o.getStarts(),o),R(o.getEndExclusives().delta(-1),o))}return $(L,v)}function $(e,w){const L=[];for(;e.length>0||w.length>0;){const A=e[0],v=w[0];let E;A&&(!v||A.seq1Range.start<v.seq1Range.start)?E=e.shift():E=w.shift(),L.length>0&&L[L.length-1].seq1Range.endExclusive>=E.seq1Range.start?L[L.length-1]=L[L.length-1].join(E):L.push(E)}return L}function g(e,w,L){let A=L;if(A.length===0)return A;let v=0,E;do{E=!1;const R=[A[0]];for(let b=1;b<A.length;b++){let l=function(M,_){const T=new n.$Vt(r.seq1Range.endExclusive,o.seq1Range.start);return e.getText(T).replace(/\s/g,"").length<=4&&(M.seq1Range.length+M.seq2Range.length>5||_.seq1Range.length+_.seq2Range.length>5)};const o=A[b],r=R[R.length-1];l(r,o)?(E=!0,R[R.length-1]=R[R.length-1].join(o)):R.push(o)}A=R}while(v++<10&&E);return A}function d(e,w,L){let A=L;if(A.length===0)return A;let v=0,E;do{E=!1;const b=[A[0]];for(let o=1;o<A.length;o++){let c=function(_,T){const D=new n.$Vt(l.seq1Range.endExclusive,r.seq1Range.start);if(e.countLinesIn(D)>5||D.length>500)return!1;const P=e.getText(D).trim();if(P.length>20||P.split(/\r\n|\r|\n/).length>1)return!1;const I=e.countLinesIn(_.seq1Range),F=_.seq1Range.length,y=w.countLinesIn(_.seq2Range),W=_.seq2Range.length,B=e.countLinesIn(T.seq1Range),O=T.seq1Range.length,X=w.countLinesIn(T.seq2Range),Y=T.seq2Range.length,z=2*40+50;function Q(ee){return Math.min(ee,z)}return Math.pow(Math.pow(Q(I*40+F),1.5)+Math.pow(Q(y*40+W),1.5),1.5)+Math.pow(Math.pow(Q(B*40+O),1.5)+Math.pow(Q(X*40+Y),1.5),1.5)>(z**1.5)**1.5*1.3};const r=A[o],l=b[b.length-1];c(l,r)?(E=!0,b[b.length-1]=b[b.length-1].join(r)):b.push(r)}A=b}while(v++<10&&E);const R=[];return(0,t.$Bb)(A,(b,o,r)=>{let l=o;function c(P){return P.length>0&&P.trim().length<=3&&o.seq1Range.length+o.seq2Range.length>100}const M=e.extendToFullLines(o.seq1Range),_=e.getText(new n.$Vt(M.start,o.seq1Range.start));c(_)&&(l=l.deltaStart(-_.length));const T=e.getText(new n.$Vt(o.seq1Range.endExclusive,M.endExclusive));c(T)&&(l=l.deltaEnd(T.length));const D=p.$M4.fromOffsetPairs(b?b.getEndExclusives():p.$N4.zero,r?r.getStarts():p.$N4.max),j=l.intersect(D);R.length>0&&j.getStarts().equals(R[R.length-1].getEndExclusives())?R[R.length-1]=R[R.length-1].join(j):R.push(j)}),R}}),ne(ie[55],re([0,1,4]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$X4=void 0;class n{constructor(N,m){this.a=N,this.b=m}getElement(N){return this.a[N]}get length(){return this.a.length}getBoundaryScore(N){const m=N===0?0:p(this.b[N-1]),a=N===this.b.length?0:p(this.b[N]);return 1e3-(m+a)}getText(N){return this.b.slice(N.start,N.endExclusive).join(`
`)}isStronglyEqual(N,m){return this.b[N]===this.b[m]}}i.$X4=n;function p(h){let N=0;for(;N<h.length&&(h.charCodeAt(N)===t.CharCode.Space||h.charCodeAt(N)===t.CharCode.Tab);)N++;return N}}),ne(ie[20],re([0,1,4]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$S4=i.$Q4=void 0,i.$R4=p;class n{constructor(m,a){this.width=m,this.height=a,this.a=[],this.a=new Array(m*a)}get(m,a){return this.a[m+a*this.width]}set(m,a,u){this.a[m+a*this.width]=u}}i.$Q4=n;function p(N){return N===t.CharCode.Space||N===t.CharCode.Tab}class h{static{this.a=new Map}static b(m){let a=this.a.get(m);return a===void 0&&(a=this.a.size,this.a.set(m,a)),a}constructor(m,a,u){this.range=m,this.lines=a,this.source=u,this.d=[];let f=0;for(let $=m.startLineNumber-1;$<m.endLineNumberExclusive-1;$++){const g=a[$];for(let e=0;e<g.length;e++){f++;const w=g[e],L=h.b(w);this.d[L]=(this.d[L]||0)+1}f++;const d=h.b(`
`);this.d[d]=(this.d[d]||0)+1}this.c=f}computeSimilarity(m){let a=0;const u=Math.max(this.d.length,m.d.length);for(let f=0;f<u;f++)a+=Math.abs((this.d[f]??0)-(m.d[f]??0));return 1-a/(this.c+m.c)}}i.$S4=h}),ne(ie[56],re([0,1,6,10,20]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$T4=void 0;class h{compute(m,a,u=n.$O4.instance,f){if(m.length===0||a.length===0)return n.$L4.trivial(m,a);const $=new p.$Q4(m.length,a.length),g=new p.$Q4(m.length,a.length),d=new p.$Q4(m.length,a.length);for(let R=0;R<m.length;R++)for(let b=0;b<a.length;b++){if(!u.isValid())return n.$L4.trivialTimedOut(m,a);const o=R===0?0:$.get(R-1,b),r=b===0?0:$.get(R,b-1);let l;m.getElement(R)===a.getElement(b)?(R===0||b===0?l=0:l=$.get(R-1,b-1),R>0&&b>0&&g.get(R-1,b-1)===3&&(l+=d.get(R-1,b-1)),l+=f?f(R,b):1):l=-1;const c=Math.max(o,r,l);if(c===l){const M=R>0&&b>0?d.get(R-1,b-1):0;d.set(R,b,M+1),g.set(R,b,3)}else c===o?(d.set(R,b,0),g.set(R,b,1)):c===r&&(d.set(R,b,0),g.set(R,b,2));$.set(R,b,c)}const e=[];let w=m.length,L=a.length;function A(R,b){(R+1!==w||b+1!==L)&&e.push(new n.$M4(new t.$Vt(R+1,w),new t.$Vt(b+1,L))),w=R,L=b}let v=m.length-1,E=a.length-1;for(;v>=0&&E>=0;)g.get(v,E)===3?(A(v,E),v--,E--):g.get(v,E)===1?v--:E--;return A(-1,-1),e.reverse(),new n.$L4(e,!1)}}i.$T4=h}),ne(ie[34],re([0,1,9,4,6,3,2,20]),function(x,i,t,n,p,h,N,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$V4=void 0;class a{constructor(w,L,A){this.lines=w,this.g=L,this.considerWhitespaceChanges=A,this.b=[],this.c=[],this.d=[],this.f=[],this.c.push(0);for(let v=this.g.startLineNumber;v<=this.g.endLineNumber;v++){let E=w[v-1],R=0;v===this.g.startLineNumber&&this.g.startColumn>1&&(R=this.g.startColumn-1,E=E.substring(R)),this.d.push(R);let b=0;if(!A){const r=E.trimStart();b=E.length-r.length,E=r.trimEnd()}this.f.push(b);const o=v===this.g.endLineNumber?Math.min(this.g.endColumn-1-R-b,E.length):E.length;for(let r=0;r<o;r++)this.b.push(E.charCodeAt(r));v<this.g.endLineNumber&&(this.b.push(10),this.c.push(this.b.length))}}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new p.$Vt(0,this.length))}getText(w){return this.b.slice(w.start,w.endExclusive).map(L=>String.fromCharCode(L)).join("")}getElement(w){return this.b[w]}get length(){return this.b.length}getBoundaryScore(w){const L=d(w>0?this.b[w-1]:-1),A=d(w<this.b.length?this.b[w]:-1);if(L===f.LineBreakCR&&A===f.LineBreakLF)return 0;if(L===f.LineBreakLF)return 150;let v=0;return L!==A&&(v+=10,L===f.WordLower&&A===f.WordUpper&&(v+=1)),v+=g(L),v+=g(A),v}translateOffset(w,L="right"){const A=(0,t.$hb)(this.c,E=>E<=w),v=w-this.c[A];return new h.$Nt(this.g.startLineNumber+A,1+this.d[A]+v+(v===0&&L==="left"?0:this.f[A]))}translateRange(w){const L=this.translateOffset(w.start,"right"),A=this.translateOffset(w.endExclusive,"left");return A.isBefore(L)?N.$Ot.fromPositions(A,A):N.$Ot.fromPositions(L,A)}findWordContaining(w){if(w<0||w>=this.b.length||!u(this.b[w]))return;let L=w;for(;L>0&&u(this.b[L-1]);)L--;let A=w;for(;A<this.b.length&&u(this.b[A]);)A++;return new p.$Vt(L,A)}countLinesIn(w){return this.translateOffset(w.endExclusive).lineNumber-this.translateOffset(w.start).lineNumber}isStronglyEqual(w,L){return this.b[w]===this.b[L]}extendToFullLines(w){const L=(0,t.$gb)(this.c,v=>v<=w.start)??0,A=(0,t.$ib)(this.c,v=>w.endExclusive<=v)??this.b.length;return new p.$Vt(L,A)}}i.$V4=a;function u(e){return e>=n.CharCode.a&&e<=n.CharCode.z||e>=n.CharCode.A&&e<=n.CharCode.Z||e>=n.CharCode.Digit0&&e<=n.CharCode.Digit9}var f;(function(e){e[e.WordLower=0]="WordLower",e[e.WordUpper=1]="WordUpper",e[e.WordNumber=2]="WordNumber",e[e.End=3]="End",e[e.Other=4]="Other",e[e.Separator=5]="Separator",e[e.Space=6]="Space",e[e.LineBreakCR=7]="LineBreakCR",e[e.LineBreakLF=8]="LineBreakLF"})(f||(f={}));const $={[f.WordLower]:0,[f.WordUpper]:0,[f.WordNumber]:0,[f.End]:10,[f.Other]:2,[f.Separator]:30,[f.Space]:3,[f.LineBreakCR]:10,[f.LineBreakLF]:10};function g(e){return $[e]}function d(e){return e===n.CharCode.LineFeed?f.LineBreakLF:e===n.CharCode.CarriageReturn?f.LineBreakCR:(0,m.$R4)(e)?f.Space:e>=n.CharCode.a&&e<=n.CharCode.z?f.WordLower:e>=n.CharCode.A&&e<=n.CharCode.Z?f.WordUpper:e>=n.CharCode.Digit0&&e<=n.CharCode.Digit9?f.WordNumber:e===-1?f.End:e===n.CharCode.Comma||e===n.CharCode.Semicolon?f.Separator:f.Other}}),ne(ie[35],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$_t=i.$$t=void 0;class t{constructor(h,N,m){this.changes=h,this.moves=N,this.hitTimeout=m}}i.$$t=t;class n{constructor(h,N){this.lineRangeMapping=h,this.changes=N}flip(){return new n(this.lineRangeMapping.flip(),this.changes.map(h=>h.flip()))}}i.$_t=n}),ne(ie[21],re([0,1,5,15,3,2,52]),function(x,i,t,n,p,h,N){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$0t=i.$9t=i.$8t=void 0;class m{static inverse(d,e,w){const L=[];let A=1,v=1;for(const R of d){const b=new m(new n.$Xt(A,R.original.startLineNumber),new n.$Xt(v,R.modified.startLineNumber));b.modified.isEmpty||L.push(b),A=R.original.endLineNumberExclusive,v=R.modified.endLineNumberExclusive}const E=new m(new n.$Xt(A,e+1),new n.$Xt(v,w+1));return E.modified.isEmpty||L.push(E),L}static clip(d,e,w){const L=[];for(const A of d){const v=A.original.intersect(e),E=A.modified.intersect(w);v&&!v.isEmpty&&E&&!E.isEmpty&&L.push(new m(v,E))}return L}constructor(d,e){this.original=d,this.modified=e}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new m(this.modified,this.original)}join(d){return new m(this.original.join(d.original),this.modified.join(d.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}toRangeMapping(){const d=this.original.toInclusiveRange(),e=this.modified.toInclusiveRange();if(d&&e)return new $(d,e);if(this.original.startLineNumber===1||this.modified.startLineNumber===1){if(!(this.modified.startLineNumber===1&&this.original.startLineNumber===1))throw new t.$bb("not a valid diff");return new $(new h.$Ot(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new h.$Ot(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1))}else return new $(new h.$Ot(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),new h.$Ot(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER))}toRangeMapping2(d,e){if(u(this.original.endLineNumberExclusive,d)&&u(this.modified.endLineNumberExclusive,e))return new $(new h.$Ot(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new h.$Ot(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1));if(!this.original.isEmpty&&!this.modified.isEmpty)return new $(h.$Ot.fromPositions(new p.$Nt(this.original.startLineNumber,1),a(new p.$Nt(this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),d)),h.$Ot.fromPositions(new p.$Nt(this.modified.startLineNumber,1),a(new p.$Nt(this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),e)));if(this.original.startLineNumber>1&&this.modified.startLineNumber>1)return new $(h.$Ot.fromPositions(a(new p.$Nt(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER),d),a(new p.$Nt(this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),d)),h.$Ot.fromPositions(a(new p.$Nt(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER),e),a(new p.$Nt(this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),e)));throw new t.$bb}}i.$8t=m;function a(g,d){if(g.lineNumber<1)return new p.$Nt(1,1);if(g.lineNumber>d.length)return new p.$Nt(d.length,d[d.length-1].length+1);const e=d[g.lineNumber-1];return g.column>e.length+1?new p.$Nt(g.lineNumber,e.length+1):g}function u(g,d){return g>=1&&g<=d.length}class f extends m{static fromRangeMappings(d){const e=n.$Xt.join(d.map(L=>n.$Xt.fromRangeInclusive(L.originalRange))),w=n.$Xt.join(d.map(L=>n.$Xt.fromRangeInclusive(L.modifiedRange)));return new f(e,w,d)}constructor(d,e,w){super(d,e),this.innerChanges=w}flip(){return new f(this.modified,this.original,this.innerChanges?.map(d=>d.flip()))}withInnerChangesFromLineRanges(){return new f(this.original,this.modified,[this.toRangeMapping()])}}i.$9t=f;class ${static assertSorted(d){for(let e=1;e<d.length;e++){const w=d[e-1],L=d[e];if(!(w.originalRange.getEndPosition().isBeforeOrEqual(L.originalRange.getStartPosition())&&w.modifiedRange.getEndPosition().isBeforeOrEqual(L.modifiedRange.getStartPosition())))throw new t.$bb("Range mappings must be sorted")}}constructor(d,e){this.originalRange=d,this.modifiedRange=e}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new $(this.modifiedRange,this.originalRange)}toTextEdit(d){const e=d.getValueOfRange(this.modifiedRange);return new N.$3t(this.originalRange,e)}}i.$0t=$}),ne(ie[57],re([0,1,10,21,7,9,16,15,34,20,33,2]),function(x,i,t,n,p,h,N,m,a,u,f,$){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$W4=g;function g(E,R,b,o,r,l){let{moves:c,excludedChanges:M}=e(E,R,b,l);if(!l.isValid())return[];const _=E.filter(D=>!M.has(D)),T=w(_,o,r,R,b,l);return(0,p.$Yb)(c,T),c=A(c),c=c.filter(D=>{const j=D.original.toOffsetRange().slice(R).map(I=>I.trim());return j.join(`
`).length>=15&&d(j,I=>I.length>=2)>=2}),c=v(E,c),c}function d(E,R){let b=0;for(const o of E)R(o)&&b++;return b}function e(E,R,b,o){const r=[],l=E.filter(_=>_.modified.isEmpty&&_.original.length>=3).map(_=>new u.$S4(_.original,R,_)),c=new Set(E.filter(_=>_.original.isEmpty&&_.modified.length>=3).map(_=>new u.$S4(_.modified,b,_))),M=new Set;for(const _ of l){let T=-1,D;for(const j of c){const P=_.computeSimilarity(j);P>T&&(T=P,D=j)}if(T>.9&&D&&(c.delete(D),r.push(new n.$8t(_.range,D.range)),M.add(_.source),M.add(D.source)),!o.isValid())return{moves:r,excludedChanges:M}}return{moves:r,excludedChanges:M}}function w(E,R,b,o,r,l){const c=[],M=new N.$Hc;for(const P of E)for(let I=P.original.startLineNumber;I<P.original.endLineNumberExclusive-2;I++){const F=`${R[I-1]}:${R[I+1-1]}:${R[I+2-1]}`;M.add(F,{range:new m.$Xt(I,I+3)})}const _=[];E.sort((0,p.$5b)(P=>P.modified.startLineNumber,p.$7b));for(const P of E){let I=[];for(let F=P.modified.startLineNumber;F<P.modified.endLineNumberExclusive-2;F++){const y=`${b[F-1]}:${b[F+1-1]}:${b[F+2-1]}`,W=new m.$Xt(F,F+3),B=[];M.forEach(y,({range:O})=>{for(const Y of I)if(Y.originalLineRange.endLineNumberExclusive+1===O.endLineNumberExclusive&&Y.modifiedLineRange.endLineNumberExclusive+1===W.endLineNumberExclusive){Y.originalLineRange=new m.$Xt(Y.originalLineRange.startLineNumber,O.endLineNumberExclusive),Y.modifiedLineRange=new m.$Xt(Y.modifiedLineRange.startLineNumber,W.endLineNumberExclusive),B.push(Y);return}const X={modifiedLineRange:W,originalLineRange:O};_.push(X),B.push(X)}),I=B}if(!l.isValid())return[]}_.sort((0,p.$9b)((0,p.$5b)(P=>P.modifiedLineRange.length,p.$7b)));const T=new m.$Yt,D=new m.$Yt;for(const P of _){const I=P.modifiedLineRange.startLineNumber-P.originalLineRange.startLineNumber,F=T.subtractFrom(P.modifiedLineRange),y=D.subtractFrom(P.originalLineRange).getWithDelta(I),W=F.getIntersection(y);for(const B of W.ranges){if(B.length<3)continue;const O=B,X=B.delta(-I);c.push(new n.$8t(X,O)),T.addRange(O),D.addRange(X)}}c.sort((0,p.$5b)(P=>P.original.startLineNumber,p.$7b));const j=new h.$lb(E);for(let P=0;P<c.length;P++){const I=c[P],F=j.findLastMonotonous(Q=>Q.original.startLineNumber<=I.original.startLineNumber),y=(0,h.$gb)(E,Q=>Q.modified.startLineNumber<=I.modified.startLineNumber),W=Math.max(I.original.startLineNumber-F.original.startLineNumber,I.modified.startLineNumber-y.modified.startLineNumber),B=j.findLastMonotonous(Q=>Q.original.startLineNumber<I.original.endLineNumberExclusive),O=(0,h.$gb)(E,Q=>Q.modified.startLineNumber<I.modified.endLineNumberExclusive),X=Math.max(B.original.endLineNumberExclusive-I.original.endLineNumberExclusive,O.modified.endLineNumberExclusive-I.modified.endLineNumberExclusive);let Y;for(Y=0;Y<W;Y++){const Q=I.original.startLineNumber-Y-1,ee=I.modified.startLineNumber-Y-1;if(Q>o.length||ee>r.length||T.contains(ee)||D.contains(Q)||!L(o[Q-1],r[ee-1],l))break}Y>0&&(D.addRange(new m.$Xt(I.original.startLineNumber-Y,I.original.startLineNumber)),T.addRange(new m.$Xt(I.modified.startLineNumber-Y,I.modified.startLineNumber)));let z;for(z=0;z<X;z++){const Q=I.original.endLineNumberExclusive+z,ee=I.modified.endLineNumberExclusive+z;if(Q>o.length||ee>r.length||T.contains(ee)||D.contains(Q)||!L(o[Q-1],r[ee-1],l))break}z>0&&(D.addRange(new m.$Xt(I.original.endLineNumberExclusive,I.original.endLineNumberExclusive+z)),T.addRange(new m.$Xt(I.modified.endLineNumberExclusive,I.modified.endLineNumberExclusive+z))),(Y>0||z>0)&&(c[P]=new n.$8t(new m.$Xt(I.original.startLineNumber-Y,I.original.endLineNumberExclusive+z),new m.$Xt(I.modified.startLineNumber-Y,I.modified.endLineNumberExclusive+z)))}return c}function L(E,R,b){if(E.trim()===R.trim())return!0;if(E.length>300&&R.length>300)return!1;const r=new f.$U4().compute(new a.$V4([E],new $.$Ot(1,1,1,E.length),!1),new a.$V4([R],new $.$Ot(1,1,1,R.length),!1),b);let l=0;const c=t.$M4.invert(r.diffs,E.length);for(const D of c)D.seq1Range.forEach(j=>{(0,u.$R4)(E.charCodeAt(j))||l++});function M(D){let j=0;for(let P=0;P<E.length;P++)(0,u.$R4)(D.charCodeAt(P))||j++;return j}const _=M(E.length>R.length?E:R);return l/_>.6&&_>10}function A(E){if(E.length===0)return E;E.sort((0,p.$5b)(b=>b.original.startLineNumber,p.$7b));const R=[E[0]];for(let b=1;b<E.length;b++){const o=R[R.length-1],r=E[b],l=r.original.startLineNumber-o.original.endLineNumberExclusive,c=r.modified.startLineNumber-o.modified.endLineNumberExclusive;if(l>=0&&c>=0&&l+c<=2){R[R.length-1]=o.join(r);continue}R.push(r)}return R}function v(E,R){const b=new h.$lb(E);return R=R.filter(o=>{const r=b.findLastMonotonous(M=>M.original.startLineNumber<o.original.endLineNumberExclusive)||new n.$8t(new m.$Xt(1,1),new m.$Xt(1,1)),l=(0,h.$gb)(E,M=>M.modified.startLineNumber<o.modified.endLineNumberExclusive);return r!==l}),R}}),ne(ie[58],re([0,1,7,11,15,6,2,10,56,33,57,54,55,34,35,21]),function(x,i,t,n,p,h,N,m,a,u,f,$,g,d,e,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$44=void 0,i.$54=A,i.$64=v;class L{constructor(){this.e=new a.$T4,this.f=new u.$U4}computeDiff(b,o,r){if(b.length<=1&&(0,t.$tb)(b,o,(Q,ee)=>Q===ee))return new e.$$t([],[],!1);if(b.length===1&&b[0].length===0||o.length===1&&o[0].length===0)return new e.$$t([new w.$9t(new p.$Xt(1,b.length+1),new p.$Xt(1,o.length+1),[new w.$0t(new N.$Ot(1,1,b.length,b[b.length-1].length+1),new N.$Ot(1,1,o.length,o[o.length-1].length+1))])],[],!1);const l=r.maxComputationTimeMs===0?m.$O4.instance:new m.$P4(r.maxComputationTimeMs),c=!r.ignoreTrimWhitespace,M=new Map;function _(Q){let ee=M.get(Q);return ee===void 0&&(ee=M.size,M.set(Q,ee)),ee}const T=b.map(Q=>_(Q.trim())),D=o.map(Q=>_(Q.trim())),j=new g.$X4(T,b),P=new g.$X4(D,o),I=j.length+P.length<1700?this.e.compute(j,P,l,(Q,ee)=>b[Q]===o[ee]?o[ee].length===0?.1:1+Math.log(1+o[ee].length):.99):this.f.compute(j,P,l);let F=I.diffs,y=I.hitTimeout;F=(0,$.$Y4)(j,P,F),F=(0,$.$24)(j,P,F);const W=[],B=Q=>{if(c)for(let ee=0;ee<Q;ee++){const k=O+ee,H=X+ee;if(b[k]!==o[H]){const fe=this.j(b,o,new m.$M4(new h.$Vt(k,k+1),new h.$Vt(H,H+1)),l,c);for(const oe of fe.mappings)W.push(oe);fe.hitTimeout&&(y=!0)}}};let O=0,X=0;for(const Q of F){(0,n.$hd)(()=>Q.seq1Range.start-O===Q.seq2Range.start-X);const ee=Q.seq1Range.start-O;B(ee),O=Q.seq1Range.endExclusive,X=Q.seq2Range.endExclusive;const k=this.j(b,o,Q,l,c);k.hitTimeout&&(y=!0);for(const H of k.mappings)W.push(H)}B(b.length-O);const Y=A(W,b,o);let z=[];return r.computeMoves&&(z=this.h(Y,b,o,T,D,l,c)),(0,n.$hd)(()=>{function Q(k,H){if(k.lineNumber<1||k.lineNumber>H.length)return!1;const fe=H[k.lineNumber-1];return!(k.column<1||k.column>fe.length+1)}function ee(k,H){return!(k.startLineNumber<1||k.startLineNumber>H.length+1||k.endLineNumberExclusive<1||k.endLineNumberExclusive>H.length+1)}for(const k of Y){if(!k.innerChanges)return!1;for(const H of k.innerChanges)if(!(Q(H.modifiedRange.getStartPosition(),o)&&Q(H.modifiedRange.getEndPosition(),o)&&Q(H.originalRange.getStartPosition(),b)&&Q(H.originalRange.getEndPosition(),b)))return!1;if(!ee(k.modified,o)||!ee(k.original,b))return!1}return!0}),new e.$$t(Y,z,y)}h(b,o,r,l,c,M,_){return(0,f.$W4)(b,o,r,l,c,M).map(j=>{const P=this.j(o,r,new m.$M4(j.original.toOffsetRange(),j.modified.toOffsetRange()),M,_),I=A(P.mappings,o,r,!0);return new e.$_t(j,I)})}j(b,o,r,l,c){const _=E(r).toRangeMapping2(b,o),T=new d.$V4(b,_.originalRange,c),D=new d.$V4(o,_.modifiedRange,c),j=T.length+D.length<500?this.e.compute(T,D,l):this.f.compute(T,D,l),P=!1;let I=j.diffs;P&&m.$M4.assertSorted(I),I=(0,$.$Y4)(T,D,I),P&&m.$M4.assertSorted(I),I=(0,$.$14)(T,D,I),P&&m.$M4.assertSorted(I),I=(0,$.$Z4)(T,D,I),P&&m.$M4.assertSorted(I),I=(0,$.$34)(T,D,I),P&&m.$M4.assertSorted(I);const F=I.map(y=>new w.$0t(T.translateRange(y.seq1Range),D.translateRange(y.seq2Range)));return P&&w.$0t.assertSorted(F),{mappings:F,hitTimeout:j.hitTimeout}}}i.$44=L;function A(R,b,o,r=!1){const l=[];for(const c of(0,t.$zb)(R.map(M=>v(M,b,o)),(M,_)=>M.original.overlapOrTouch(_.original)||M.modified.overlapOrTouch(_.modified))){const M=c[0],_=c[c.length-1];l.push(new w.$9t(M.original.join(_.original),M.modified.join(_.modified),c.map(T=>T.innerChanges[0])))}return(0,n.$hd)(()=>!r&&l.length>0&&(l[0].modified.startLineNumber!==l[0].original.startLineNumber||o.length-l[l.length-1].modified.endLineNumberExclusive!==b.length-l[l.length-1].original.endLineNumberExclusive)?!1:(0,n.$id)(l,(c,M)=>M.original.startLineNumber-c.original.endLineNumberExclusive===M.modified.startLineNumber-c.modified.endLineNumberExclusive&&c.original.endLineNumberExclusive<M.original.startLineNumber&&c.modified.endLineNumberExclusive<M.modified.startLineNumber)),l}function v(R,b,o){let r=0,l=0;R.modifiedRange.endColumn===1&&R.originalRange.endColumn===1&&R.originalRange.startLineNumber+r<=R.originalRange.endLineNumber&&R.modifiedRange.startLineNumber+r<=R.modifiedRange.endLineNumber&&(l=-1),R.modifiedRange.startColumn-1>=o[R.modifiedRange.startLineNumber-1].length&&R.originalRange.startColumn-1>=b[R.originalRange.startLineNumber-1].length&&R.originalRange.startLineNumber<=R.originalRange.endLineNumber+l&&R.modifiedRange.startLineNumber<=R.modifiedRange.endLineNumber+l&&(r=1);const c=new p.$Xt(R.originalRange.startLineNumber+r,R.originalRange.endLineNumber+1+l),M=new p.$Xt(R.modifiedRange.startLineNumber+r,R.modifiedRange.endLineNumber+1+l);return new w.$9t(c,M,[R])}function E(R){return new w.$8t(new p.$Xt(R.seq1Range.start+1,R.seq1Range.endExclusive+1),new p.$Xt(R.seq2Range.start+1,R.seq2Range.endExclusive+1))}}),ne(ie[36],re([0,1,4,29,35,21,8,2,11,15]),function(x,i,t,n,p,h,N,m,a,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$bu=i.$au=void 0,N=Oe(N);const f=3;class ${computeDiff(r,l,c){const _=new v(r,l,{maxComputationTime:c.maxComputationTimeMs,shouldIgnoreTrimWhitespace:c.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),T=[];let D=null;for(const j of _.changes){let P;j.originalEndLineNumber===0?P=new u.$Xt(j.originalStartLineNumber+1,j.originalStartLineNumber+1):P=new u.$Xt(j.originalStartLineNumber,j.originalEndLineNumber+1);let I;j.modifiedEndLineNumber===0?I=new u.$Xt(j.modifiedStartLineNumber+1,j.modifiedStartLineNumber+1):I=new u.$Xt(j.modifiedStartLineNumber,j.modifiedEndLineNumber+1);let F=new h.$9t(P,I,j.charChanges?.map(y=>new h.$0t(new m.$Ot(y.originalStartLineNumber,y.originalStartColumn,y.originalEndLineNumber,y.originalEndColumn),new m.$Ot(y.modifiedStartLineNumber,y.modifiedStartColumn,y.modifiedEndLineNumber,y.modifiedEndColumn))));D&&(D.modified.endLineNumberExclusive===F.modified.startLineNumber||D.original.endLineNumberExclusive===F.original.startLineNumber)&&(F=new h.$9t(D.original.join(F.original),D.modified.join(F.modified),D.innerChanges&&F.innerChanges?D.innerChanges.concat(F.innerChanges):void 0),T.pop()),T.push(F),D=F}return(0,a.$hd)(()=>(0,a.$id)(T,(j,P)=>P.original.startLineNumber-j.original.endLineNumberExclusive===P.modified.startLineNumber-j.modified.endLineNumberExclusive&&j.original.endLineNumberExclusive<P.original.startLineNumber&&j.modified.endLineNumberExclusive<P.modified.startLineNumber)),new p.$$t(T,[],_.quitEarly)}}i.$au=$;function g(o,r,l,c){return new n.$Ut(o,r,l).ComputeDiff(c)}class d{constructor(r){const l=[],c=[];for(let M=0,_=r.length;M<_;M++)l[M]=E(r[M],1),c[M]=R(r[M],1);this.lines=r,this.a=l,this.b=c}getElements(){const r=[];for(let l=0,c=this.lines.length;l<c;l++)r[l]=this.lines[l].substring(this.a[l]-1,this.b[l]-1);return r}getStrictElement(r){return this.lines[r]}getStartLineNumber(r){return r+1}getEndLineNumber(r){return r+1}createCharSequence(r,l,c){const M=[],_=[],T=[];let D=0;for(let j=l;j<=c;j++){const P=this.lines[j],I=r?this.a[j]:1,F=r?this.b[j]:P.length+1;for(let y=I;y<F;y++)M[D]=P.charCodeAt(y-1),_[D]=j+1,T[D]=y,D++;!r&&j<c&&(M[D]=t.CharCode.LineFeed,_[D]=j+1,T[D]=P.length+1,D++)}return new e(M,_,T)}}class e{constructor(r,l,c){this.a=r,this.b=l,this.d=c}toString(){return"["+this.a.map((r,l)=>(r===t.CharCode.LineFeed?"\\n":String.fromCharCode(r))+`-(${this.b[l]},${this.d[l]})`).join(", ")+"]"}e(r,l){if(r<0||r>=l.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(r){return r>0&&r===this.b.length?this.getEndLineNumber(r-1):(this.e(r,this.b),this.b[r])}getEndLineNumber(r){return r===-1?this.getStartLineNumber(r+1):(this.e(r,this.b),this.a[r]===t.CharCode.LineFeed?this.b[r]+1:this.b[r])}getStartColumn(r){return r>0&&r===this.d.length?this.getEndColumn(r-1):(this.e(r,this.d),this.d[r])}getEndColumn(r){return r===-1?this.getStartColumn(r+1):(this.e(r,this.d),this.a[r]===t.CharCode.LineFeed?1:this.d[r]+1)}}class w{constructor(r,l,c,M,_,T,D,j){this.originalStartLineNumber=r,this.originalStartColumn=l,this.originalEndLineNumber=c,this.originalEndColumn=M,this.modifiedStartLineNumber=_,this.modifiedStartColumn=T,this.modifiedEndLineNumber=D,this.modifiedEndColumn=j}static createFromDiffChange(r,l,c){const M=l.getStartLineNumber(r.originalStart),_=l.getStartColumn(r.originalStart),T=l.getEndLineNumber(r.originalStart+r.originalLength-1),D=l.getEndColumn(r.originalStart+r.originalLength-1),j=c.getStartLineNumber(r.modifiedStart),P=c.getStartColumn(r.modifiedStart),I=c.getEndLineNumber(r.modifiedStart+r.modifiedLength-1),F=c.getEndColumn(r.modifiedStart+r.modifiedLength-1);return new w(M,_,T,D,j,P,I,F)}}function L(o){if(o.length<=1)return o;const r=[o[0]];let l=r[0];for(let c=1,M=o.length;c<M;c++){const _=o[c],T=_.originalStart-(l.originalStart+l.originalLength),D=_.modifiedStart-(l.modifiedStart+l.modifiedLength);Math.min(T,D)<f?(l.originalLength=_.originalStart+_.originalLength-l.originalStart,l.modifiedLength=_.modifiedStart+_.modifiedLength-l.modifiedStart):(r.push(_),l=_)}return r}class A{constructor(r,l,c,M,_){this.originalStartLineNumber=r,this.originalEndLineNumber=l,this.modifiedStartLineNumber=c,this.modifiedEndLineNumber=M,this.charChanges=_}static createFromDiffResult(r,l,c,M,_,T,D){let j,P,I,F,y;if(l.originalLength===0?(j=c.getStartLineNumber(l.originalStart)-1,P=0):(j=c.getStartLineNumber(l.originalStart),P=c.getEndLineNumber(l.originalStart+l.originalLength-1)),l.modifiedLength===0?(I=M.getStartLineNumber(l.modifiedStart)-1,F=0):(I=M.getStartLineNumber(l.modifiedStart),F=M.getEndLineNumber(l.modifiedStart+l.modifiedLength-1)),T&&l.originalLength>0&&l.originalLength<20&&l.modifiedLength>0&&l.modifiedLength<20&&_()){const W=c.createCharSequence(r,l.originalStart,l.originalStart+l.originalLength-1),B=M.createCharSequence(r,l.modifiedStart,l.modifiedStart+l.modifiedLength-1);if(W.getElements().length>0&&B.getElements().length>0){let O=g(W,B,_,!0).changes;D&&(O=L(O)),y=[];for(let X=0,Y=O.length;X<Y;X++)y.push(w.createFromDiffChange(O[X],W,B))}}return new A(j,P,I,F,y)}}class v{constructor(r,l,c){this.a=c.shouldComputeCharChanges,this.b=c.shouldPostProcessCharChanges,this.d=c.shouldIgnoreTrimWhitespace,this.e=c.shouldMakePrettyDiff,this.f=r,this.g=l,this.h=new d(r),this.j=new d(l),this.k=b(c.maxComputationTime),this.l=b(c.maxComputationTime===0?0:Math.min(c.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const r=g(this.h,this.j,this.k,this.e),l=r.changes,c=r.quitEarly;if(this.d){const D=[];for(let j=0,P=l.length;j<P;j++)D.push(A.createFromDiffResult(this.d,l[j],this.h,this.j,this.l,this.a,this.b));return{quitEarly:c,changes:D}}const M=[];let _=0,T=0;for(let D=-1,j=l.length;D<j;D++){const P=D+1<j?l[D+1]:null,I=P?P.originalStart:this.f.length,F=P?P.modifiedStart:this.g.length;for(;_<I&&T<F;){const y=this.f[_],W=this.g[T];if(y!==W){{let B=E(y,1),O=E(W,1);for(;B>1&&O>1;){const X=y.charCodeAt(B-2),Y=W.charCodeAt(O-2);if(X!==Y)break;B--,O--}(B>1||O>1)&&this.m(M,_+1,1,B,T+1,1,O)}{let B=R(y,1),O=R(W,1);const X=y.length+1,Y=W.length+1;for(;B<X&&O<Y;){const z=y.charCodeAt(B-1),Q=y.charCodeAt(O-1);if(z!==Q)break;B++,O++}(B<X||O<Y)&&this.m(M,_+1,B,X,T+1,O,Y)}}_++,T++}P&&(M.push(A.createFromDiffResult(this.d,P,this.h,this.j,this.l,this.a,this.b)),_+=P.originalLength,T+=P.modifiedLength)}return{quitEarly:c,changes:M}}m(r,l,c,M,_,T,D){if(this.n(r,l,c,M,_,T,D))return;let j;this.a&&(j=[new w(l,c,l,M,_,T,_,D)]),r.push(new A(l,l,_,_,j))}n(r,l,c,M,_,T,D){const j=r.length;if(j===0)return!1;const P=r[j-1];return P.originalEndLineNumber===0||P.modifiedEndLineNumber===0?!1:P.originalEndLineNumber===l&&P.modifiedEndLineNumber===_?(this.a&&P.charChanges&&P.charChanges.push(new w(l,c,l,M,_,T,_,D)),!0):P.originalEndLineNumber+1===l&&P.modifiedEndLineNumber+1===_?(P.originalEndLineNumber=l,P.modifiedEndLineNumber=_,this.a&&P.charChanges&&P.charChanges.push(new w(l,c,l,M,_,T,_,D)),!0):!1}}i.$bu=v;function E(o,r){const l=N.$uf(o);return l===-1?r:l+1}function R(o,r){const l=N.$wf(o);return l===-1?r:l+2}function b(o){if(o===0)return()=>!0;const r=Date.now();return()=>Date.now()-r<o}}),ne(ie[59],re([0,1,36,58]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$74=void 0,i.$74={getLegacy:()=>new t.$au,getDefault:()=>new n.$44}}),ne(ie[60],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$vu=i.MetadataConsts=i.StandardTokenType=i.ColorId=i.FontStyle=i.LanguageId=void 0;var t;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(t||(i.LanguageId=t={}));var n;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline",a[a.Strikethrough=8]="Strikethrough"})(n||(i.FontStyle=n={}));var p;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(p||(i.ColorId=p={}));var h;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=3]="RegEx"})(h||(i.StandardTokenType=h={}));var N;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",a[a.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",a[a.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",a[a.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(N||(i.MetadataConsts=N={}));class m{static getLanguageId(u){return(u&N.LANGUAGEID_MASK)>>>N.LANGUAGEID_OFFSET}static getTokenType(u){return(u&N.TOKEN_TYPE_MASK)>>>N.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(u){return(u&N.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(u){return(u&N.FONT_STYLE_MASK)>>>N.FONT_STYLE_OFFSET}static getForeground(u){return(u&N.FOREGROUND_MASK)>>>N.FOREGROUND_OFFSET}static getBackground(u){return(u&N.BACKGROUND_MASK)>>>N.BACKGROUND_OFFSET}static getClassNameFromMetadata(u){let $="mtk"+this.getForeground(u);const g=this.getFontStyle(u);return g&n.Italic&&($+=" mtki"),g&n.Bold&&($+=" mtkb"),g&n.Underline&&($+=" mtku"),g&n.Strikethrough&&($+=" mtks"),$}static getInlineStyleFromMetadata(u,f){const $=this.getForeground(u),g=this.getFontStyle(u);let d=`color: ${f[$]};`;g&n.Italic&&(d+="font-style: italic;"),g&n.Bold&&(d+="font-weight: bold;");let e="";return g&n.Underline&&(e+=" underline"),g&n.Strikethrough&&(e+=" line-through"),e&&(d+=`text-decoration:${e};`),d}static getPresentationFromMetadata(u){const f=this.getForeground(u),$=this.getFontStyle(u);return{foreground:f,italic:!!($&n.Italic),bold:!!($&n.Bold),underline:!!($&n.Underline),strikethrough:!!($&n.Strikethrough)}}}i.$vu=m}),ne(ie[61],re([0,1,38]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$84=$;function n(g){const d=[];for(const e of g){const w=Number(e);(w||w===0&&e.replace(/\s/g,"")!=="")&&d.push(w)}return d}function p(g,d,e,w){return{red:g/255,blue:e/255,green:d/255,alpha:w}}function h(g,d){const e=d.index,w=d[0].length;if(!e)return;const L=g.positionAt(e);return{startLineNumber:L.lineNumber,startColumn:L.column,endLineNumber:L.lineNumber,endColumn:L.column+w}}function N(g,d){if(!g)return;const e=t.$ou.Format.CSS.parseHex(d);if(e)return{range:g,color:p(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function m(g,d,e){if(!g||d.length!==1)return;const L=d[0].values(),A=n(L);return{range:g,color:p(A[0],A[1],A[2],e?A[3]:1)}}function a(g,d,e){if(!g||d.length!==1)return;const L=d[0].values(),A=n(L),v=new t.$ou(new t.$mu(A[0],A[1]/100,A[2]/100,e?A[3]:1));return{range:g,color:p(v.rgba.r,v.rgba.g,v.rgba.b,v.rgba.a)}}function u(g,d){return typeof g=="string"?[...g.matchAll(d)]:g.findMatches(d)}function f(g){const d=[],w=u(g,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(w.length>0)for(const L of w){const A=L.filter(b=>b!==void 0),v=A[1],E=A[2];if(!E)continue;let R;if(v==="rgb"){const b=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;R=m(h(g,L),u(E,b),!1)}else if(v==="rgba"){const b=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;R=m(h(g,L),u(E,b),!0)}else if(v==="hsl"){const b=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;R=a(h(g,L),u(E,b),!1)}else if(v==="hsla"){const b=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;R=a(h(g,L),u(E,b),!0)}else v==="#"&&(R=N(h(g,L),v+E));R&&d.push(R)}return d}function $(g){return!g||typeof g.getValue!="function"||typeof g.positionAt!="function"?[]:f(g)}}),ne(ie[62],re([0,1,4,30]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$G4=i.$F4=i.State=void 0,i.$H4=d;var p;(function(e){e[e.Invalid=0]="Invalid",e[e.Start=1]="Start",e[e.H=2]="H",e[e.HT=3]="HT",e[e.HTT=4]="HTT",e[e.HTTP=5]="HTTP",e[e.F=6]="F",e[e.FI=7]="FI",e[e.FIL=8]="FIL",e[e.BeforeColon=9]="BeforeColon",e[e.AfterColon=10]="AfterColon",e[e.AlmostThere=11]="AlmostThere",e[e.End=12]="End",e[e.Accept=13]="Accept",e[e.LastKnownState=14]="LastKnownState"})(p||(i.State=p={}));class h{constructor(w,L,A){const v=new Uint8Array(w*L);for(let E=0,R=w*L;E<R;E++)v[E]=A;this.a=v,this.rows=w,this.cols=L}get(w,L){return this.a[w*this.cols+L]}set(w,L,A){this.a[w*this.cols+L]=A}}class N{constructor(w){let L=0,A=p.Invalid;for(let E=0,R=w.length;E<R;E++){const[b,o,r]=w[E];o>L&&(L=o),b>A&&(A=b),r>A&&(A=r)}L++,A++;const v=new h(A,L,p.Invalid);for(let E=0,R=w.length;E<R;E++){const[b,o,r]=w[E];v.set(b,o,r)}this.a=v,this.b=L}nextState(w,L){return L<0||L>=this.b?p.Invalid:this.a.get(w,L)}}i.$F4=N;let m=null;function a(){return m===null&&(m=new N([[p.Start,t.CharCode.h,p.H],[p.Start,t.CharCode.H,p.H],[p.Start,t.CharCode.f,p.F],[p.Start,t.CharCode.F,p.F],[p.H,t.CharCode.t,p.HT],[p.H,t.CharCode.T,p.HT],[p.HT,t.CharCode.t,p.HTT],[p.HT,t.CharCode.T,p.HTT],[p.HTT,t.CharCode.p,p.HTTP],[p.HTT,t.CharCode.P,p.HTTP],[p.HTTP,t.CharCode.s,p.BeforeColon],[p.HTTP,t.CharCode.S,p.BeforeColon],[p.HTTP,t.CharCode.Colon,p.AfterColon],[p.F,t.CharCode.i,p.FI],[p.F,t.CharCode.I,p.FI],[p.FI,t.CharCode.l,p.FIL],[p.FI,t.CharCode.L,p.FIL],[p.FIL,t.CharCode.e,p.BeforeColon],[p.FIL,t.CharCode.E,p.BeforeColon],[p.BeforeColon,t.CharCode.Colon,p.AfterColon],[p.AfterColon,t.CharCode.Slash,p.AlmostThere],[p.AlmostThere,t.CharCode.Slash,p.End]])),m}var u;(function(e){e[e.None=0]="None",e[e.ForceTermination=1]="ForceTermination",e[e.CannotEndIn=2]="CannotEndIn"})(u||(u={}));let f=null;function $(){if(f===null){f=new n.$hu(u.None);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let L=0;L<e.length;L++)f.set(e.charCodeAt(L),u.ForceTermination);const w=".,;:";for(let L=0;L<w.length;L++)f.set(w.charCodeAt(L),u.CannotEndIn)}return f}class g{static a(w,L,A,v,E){let R=E-1;do{const b=L.charCodeAt(R);if(w.get(b)!==u.CannotEndIn)break;R--}while(R>v);if(v>0){const b=L.charCodeAt(v-1),o=L.charCodeAt(R);(b===t.CharCode.OpenParen&&o===t.CharCode.CloseParen||b===t.CharCode.OpenSquareBracket&&o===t.CharCode.CloseSquareBracket||b===t.CharCode.OpenCurlyBrace&&o===t.CharCode.CloseCurlyBrace)&&R--}return{range:{startLineNumber:A,startColumn:v+1,endLineNumber:A,endColumn:R+2},url:L.substring(v,R+1)}}static computeLinks(w,L=a()){const A=$(),v=[];for(let E=1,R=w.getLineCount();E<=R;E++){const b=w.getLineContent(E),o=b.length;let r=0,l=0,c=0,M=p.Start,_=!1,T=!1,D=!1,j=!1;for(;r<o;){let P=!1;const I=b.charCodeAt(r);if(M===p.Accept){let F;switch(I){case t.CharCode.OpenParen:_=!0,F=u.None;break;case t.CharCode.CloseParen:F=_?u.None:u.ForceTermination;break;case t.CharCode.OpenSquareBracket:D=!0,T=!0,F=u.None;break;case t.CharCode.CloseSquareBracket:D=!1,F=T?u.None:u.ForceTermination;break;case t.CharCode.OpenCurlyBrace:j=!0,F=u.None;break;case t.CharCode.CloseCurlyBrace:F=j?u.None:u.ForceTermination;break;case t.CharCode.SingleQuote:case t.CharCode.DoubleQuote:case t.CharCode.BackTick:c===I?F=u.ForceTermination:c===t.CharCode.SingleQuote||c===t.CharCode.DoubleQuote||c===t.CharCode.BackTick?F=u.None:F=u.ForceTermination;break;case t.CharCode.Asterisk:F=c===t.CharCode.Asterisk?u.ForceTermination:u.None;break;case t.CharCode.Pipe:F=c===t.CharCode.Pipe?u.ForceTermination:u.None;break;case t.CharCode.Space:F=D?u.None:u.ForceTermination;break;default:F=A.get(I)}F===u.ForceTermination&&(v.push(g.a(A,b,E,l,r)),P=!0)}else if(M===p.End){let F;I===t.CharCode.OpenSquareBracket?(T=!0,F=u.None):F=A.get(I),F===u.ForceTermination?P=!0:M=p.Accept}else M=L.nextState(M,I),M===p.Invalid&&(P=!0);P&&(M=p.Start,_=!1,T=!1,j=!1,l=r+1,c=I),r++}M===p.Accept&&v.push(g.a(A,b,E,l,o))}return v}}i.$G4=g;function d(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:g.computeLinks(e)}}),ne(ie[63],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$I4=void 0;class t{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new t}navigateValueSet(p,h,N,m,a){if(p&&h){const u=this.a(h,a);if(u)return{range:p,value:u}}if(N&&m){const u=this.a(m,a);if(u)return{range:N,value:u}}return null}a(p,h){const N=this.b(p,h);return N!==null?N:this.d(p,h)}b(p,h){const N=Math.pow(10,p.length-(p.lastIndexOf(".")+1));let m=Number(p);const a=parseFloat(p);return!isNaN(m)&&!isNaN(a)&&m===a?m===0&&!h?null:(m=Math.floor(m*N),m+=h?N:-N,String(m/N)):null}d(p,h){return this.e(this.c,p,h)}e(p,h,N){let m=null;for(let a=0,u=p.length;m===null&&a<u;a++)m=this.f(p[a],h,N);return m}f(p,h,N){let m=p.indexOf(h);return m>=0?(m+=N?1:-1,m<0?m=p.length-1:m%=p.length,p[m]):null}}i.$I4=t}),ne(ie[64],re([0,1,18]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$iw=i.$hw=i.$gw=i.ModelConstants=i.PositionAffinity=i.TrackedRangeStickiness=i.$ew=i.$dw=i.EndOfLineSequence=i.DefaultEndOfLine=i.EndOfLinePreference=i.InjectedTextCursorStops=i.MinimapSectionHeaderStyle=i.MinimapPosition=i.GlyphMarginLane=i.OverviewRulerLane=void 0,i.$fw=e,i.$jw=R;var n;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(n||(i.OverviewRulerLane=n={}));var p;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=3]="Right"})(p||(i.GlyphMarginLane=p={}));var h;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(h||(i.MinimapPosition=h={}));var N;(function(b){b[b.Normal=1]="Normal",b[b.Underlined=2]="Underlined"})(N||(i.MinimapSectionHeaderStyle=N={}));var m;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(m||(i.InjectedTextCursorStops=m={}));var a;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(a||(i.EndOfLinePreference=a={}));var u;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(u||(i.DefaultEndOfLine=u={}));var f;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(f||(i.EndOfLineSequence=f={}));class ${get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),o.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,o.indentSize|0),this.a=!1),this.insertSpaces=!!o.insertSpaces,this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=!!o.trimAutoWhitespace,this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.a===o.a&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,t.$io)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}i.$dw=$;class g{constructor(o,r){this._findMatchBrand=void 0,this.range=o,this.matches=r}}i.$ew=g;var d;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(d||(i.TrackedRangeStickiness=d={}));function e(b){return b&&typeof b.read=="function"}var w;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None",b[b.LeftOfInjectedText=3]="LeftOfInjectedText",b[b.RightOfInjectedText=4]="RightOfInjectedText"})(w||(i.PositionAffinity=w={}));var L;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(L||(i.ModelConstants=L={}));class A{constructor(o,r,l,c,M,_){this.identifier=o,this.range=r,this.text=l,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=M,this._isTracked=_}}i.$gw=A;class v{constructor(o,r,l){this.regex=o,this.wordSeparators=r,this.simpleSearch=l}}i.$hw=v;class E{constructor(o,r,l){this.reverseEdits=o,this.changes=r,this.trimAutoWhitespaceLineNumbers=l}}i.$iw=E;function R(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}}),ne(ie[65],re([0,1,7,14]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ow=i.$nw=i.$mw=void 0;class p{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,u){a=(0,n.$bf)(a);const f=this.a,$=this.b,g=u.length;return g===0?!1:(this.a=new Uint32Array(f.length+g),this.a.set(f.subarray(0,a),0),this.a.set(f.subarray(a),a+g),this.a.set(u,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set($.subarray(0,this.c[0]+1)),!0)}setValue(a,u){return a=(0,n.$bf)(a),u=(0,n.$bf)(u),this.a[a]===u?!1:(this.a[a]=u,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,u){a=(0,n.$bf)(a),u=(0,n.$bf)(u);const f=this.a,$=this.b;if(a>=f.length)return!1;const g=f.length-a;return u>=g&&(u=g),u===0?!1:(this.a=new Uint32Array(f.length-u),this.a.set(f.subarray(0,a),0),this.a.set(f.subarray(a+u),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set($.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,n.$bf)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let u=this.c[0]+1;u===0&&(this.b[0]=this.a[0],u++),a>=this.a.length&&(a=this.a.length-1);for(let f=u;f<=a;f++)this.b[f]=this.b[f-1]+this.a[f];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let u=0,f=this.a.length-1,$=0,g=0,d=0;for(;u<=f;)if($=u+(f-u)/2|0,g=this.b[$],d=g-this.a[$],a<d)f=$-1;else if(a>=g)u=$+1;else break;return new N($,a-d)}}i.$mw=p;class h{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const u=this.e[a],f=u>0?this.d[u-1]:0;return new N(u,a-f)}removeValues(a,u){this.a.splice(a,u),this.f(a)}insertValues(a,u){this.a=(0,t.$Ub)(this.a,a,u),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,u=this.a.length;a<u;a++){const f=this.a[a],$=a>0?this.d[a-1]:0;this.d[a]=$+f;for(let g=0;g<f;g++)this.e[$+g]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,u){this.a[a]!==u&&(this.a[a]=u,this.f(a))}}i.$nw=h;class N{constructor(a,u){this.index=a,this.remainder=u,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=u}}i.$ow=N}),ne(ie[66],re([0,1,8,3,65]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$pw=void 0;class h{constructor(m,a,u,f){this.d=m,this.f=a,this.g=u,this.h=f,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(m){m.eol&&m.eol!==this.g&&(this.g=m.eol,this.j=null);const a=m.changes;for(const u of a)this.o(u.range),this.p(new n.$Nt(u.range.startLineNumber,u.range.startColumn),u.text);this.h=m.versionId,this.k=null}l(){if(!this.j){const m=this.g.length,a=this.f.length,u=new Uint32Array(a);for(let f=0;f<a;f++)u[f]=this.f[f].length+m;this.j=new p.$mw(u)}}n(m,a){this.f[m]=a,this.j&&this.j.setValue(m,this.f[m].length+this.g.length)}o(m){if(m.startLineNumber===m.endLineNumber){if(m.startColumn===m.endColumn)return;this.n(m.startLineNumber-1,this.f[m.startLineNumber-1].substring(0,m.startColumn-1)+this.f[m.startLineNumber-1].substring(m.endColumn-1));return}this.n(m.startLineNumber-1,this.f[m.startLineNumber-1].substring(0,m.startColumn-1)+this.f[m.endLineNumber-1].substring(m.endColumn-1)),this.f.splice(m.startLineNumber,m.endLineNumber-m.startLineNumber),this.j&&this.j.removeValues(m.startLineNumber,m.endLineNumber-m.startLineNumber)}p(m,a){if(a.length===0)return;const u=(0,t.$sf)(a);if(u.length===1){this.n(m.lineNumber-1,this.f[m.lineNumber-1].substring(0,m.column-1)+u[0]+this.f[m.lineNumber-1].substring(m.column-1));return}u[u.length-1]+=this.f[m.lineNumber-1].substring(m.column-1),this.n(m.lineNumber-1,this.f[m.lineNumber-1].substring(0,m.column-1)+u[0]);const f=new Uint32Array(u.length-1);for(let $=1;$<u.length;$++)this.f.splice(m.lineNumber+$-1,0,u[$]),f[$-1]=u[$].length+this.g.length;this.j&&this.j.insertValues(m.lineNumber,f)}}i.$pw=h}),ne(ie[67],re([0,1,4,8,53,3,2,64]),function(x,i,t,n,p,h,N,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$pD=i.$nD=i.$kD=void 0,i.$lD=f,i.$mD=$,i.$oD=L,n=Oe(n);const a=999;class u{constructor(E,R,b,o){this.searchString=E,this.isRegex=R,this.matchCase=b,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let E;this.isRegex?E=f(this.searchString):E=this.searchString.indexOf(`
`)>=0;let R=null;try{R=n.$qf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:E,global:!0,unicode:!0})}catch{return null}if(!R)return null;let b=!this.isRegex&&!E;return b&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(b=this.matchCase),new m.$hw(R,this.wordSeparators?(0,p.$ku)(this.wordSeparators,[]):null,b?this.searchString:null)}}i.$kD=u;function f(v){if(!v||v.length===0)return!1;for(let E=0,R=v.length;E<R;E++){const b=v.charCodeAt(E);if(b===t.CharCode.LineFeed)return!0;if(b===t.CharCode.Backslash){if(E++,E>=R)break;const o=v.charCodeAt(E);if(o===t.CharCode.n||o===t.CharCode.r||o===t.CharCode.W)return!0}}return!1}function $(v,E,R){if(!R)return new m.$ew(v,null);const b=[];for(let o=0,r=E.length;o<r;o++)b[o]=E[o];return new m.$ew(v,b)}class g{constructor(E){const R=[];let b=0;for(let o=0,r=E.length;o<r;o++)E.charCodeAt(o)===t.CharCode.LineFeed&&(R[b++]=o);this.a=R}findLineFeedCountBeforeOffset(E){const R=this.a;let b=0,o=R.length-1;if(o===-1||E<=R[0])return 0;for(;b<o;){const r=b+((o-b)/2>>0);R[r]>=E?o=r-1:R[r+1]>=E?(b=r,o=r):b=r+1}return b+1}}class d{static findMatches(E,R,b,o,r){const l=R.parseSearchRequest();return l?l.regex.multiline?this.b(E,b,new A(l.wordSeparators,l.regex),o,r):this.c(E,b,l,o,r):[]}static a(E,R,b,o,r,l){let c,M=0;o?(M=o.findLineFeedCountBeforeOffset(r),c=R+r+M):c=R+r;let _;if(o){const P=o.findLineFeedCountBeforeOffset(r+l.length)-M;_=c+l.length+P}else _=c+l.length;const T=E.getPositionAt(c),D=E.getPositionAt(_);return new N.$Ot(T.lineNumber,T.column,D.lineNumber,D.column)}static b(E,R,b,o,r){const l=E.getOffsetAt(R.getStartPosition()),c=E.getValueInRange(R,m.EndOfLinePreference.LF),M=E.getEOL()===`\r
`?new g(c):null,_=[];let T=0,D;for(b.reset(0);D=b.next(c);)if(_[T++]=$(this.a(E,l,c,M,D.index,D[0]),D,o),T>=r)return _;return _}static c(E,R,b,o,r){const l=[];let c=0;if(R.startLineNumber===R.endLineNumber){const _=E.getLineContent(R.startLineNumber).substring(R.startColumn-1,R.endColumn-1);return c=this.d(b,_,R.startLineNumber,R.startColumn-1,c,l,o,r),l}const M=E.getLineContent(R.startLineNumber).substring(R.startColumn-1);c=this.d(b,M,R.startLineNumber,R.startColumn-1,c,l,o,r);for(let _=R.startLineNumber+1;_<R.endLineNumber&&c<r;_++)c=this.d(b,E.getLineContent(_),_,0,c,l,o,r);if(c<r){const _=E.getLineContent(R.endLineNumber).substring(0,R.endColumn-1);c=this.d(b,_,R.endLineNumber,0,c,l,o,r)}return l}static d(E,R,b,o,r,l,c,M){const _=E.wordSeparators;if(!c&&E.simpleSearch){const j=E.simpleSearch,P=j.length,I=R.length;let F=-P;for(;(F=R.indexOf(j,F+P))!==-1;)if((!_||L(_,R,I,F,P))&&(l[r++]=new m.$ew(new N.$Ot(b,F+1+o,b,F+1+P+o),null),r>=M))return r;return r}const T=new A(E.wordSeparators,E.regex);let D;T.reset(0);do if(D=T.next(R),D&&(l[r++]=$(new N.$Ot(b,D.index+1+o,b,D.index+1+D[0].length+o),D,c),r>=M))return r;while(D);return r}static findNextMatch(E,R,b,o){const r=R.parseSearchRequest();if(!r)return null;const l=new A(r.wordSeparators,r.regex);return r.regex.multiline?this.e(E,b,l,o):this.f(E,b,l,o)}static e(E,R,b,o){const r=new h.$Nt(R.lineNumber,1),l=E.getOffsetAt(r),c=E.getLineCount(),M=E.getValueInRange(new N.$Ot(r.lineNumber,r.column,c,E.getLineMaxColumn(c)),m.EndOfLinePreference.LF),_=E.getEOL()===`\r
`?new g(M):null;b.reset(R.column-1);const T=b.next(M);return T?$(this.a(E,l,M,_,T.index,T[0]),T,o):R.lineNumber!==1||R.column!==1?this.e(E,new h.$Nt(1,1),b,o):null}static f(E,R,b,o){const r=E.getLineCount(),l=R.lineNumber,c=E.getLineContent(l),M=this.g(b,c,l,R.column,o);if(M)return M;for(let _=1;_<=r;_++){const T=(l+_-1)%r,D=E.getLineContent(T+1),j=this.g(b,D,T+1,1,o);if(j)return j}return null}static g(E,R,b,o,r){E.reset(o-1);const l=E.next(R);return l?$(new N.$Ot(b,l.index+1,b,l.index+1+l[0].length),l,r):null}static findPreviousMatch(E,R,b,o){const r=R.parseSearchRequest();if(!r)return null;const l=new A(r.wordSeparators,r.regex);return r.regex.multiline?this.h(E,b,l,o):this.j(E,b,l,o)}static h(E,R,b,o){const r=this.b(E,new N.$Ot(1,1,R.lineNumber,R.column),b,o,10*a);if(r.length>0)return r[r.length-1];const l=E.getLineCount();return R.lineNumber!==l||R.column!==E.getLineMaxColumn(l)?this.h(E,new h.$Nt(l,E.getLineMaxColumn(l)),b,o):null}static j(E,R,b,o){const r=E.getLineCount(),l=R.lineNumber,c=E.getLineContent(l).substring(0,R.column-1),M=this.k(b,c,l,o);if(M)return M;for(let _=1;_<=r;_++){const T=(r+l-_-1)%r,D=E.getLineContent(T+1),j=this.k(b,D,T+1,o);if(j)return j}return null}static k(E,R,b,o){let r=null,l;for(E.reset(0);l=E.next(R);)r=$(new N.$Ot(b,l.index+1,b,l.index+1+l[0].length),l,o);return r}}i.$nD=d;function e(v,E,R,b,o){if(b===0)return!0;const r=E.charCodeAt(b-1);if(v.get(r)!==p.WordCharacterClass.Regular||r===t.CharCode.CarriageReturn||r===t.CharCode.LineFeed)return!0;if(o>0){const l=E.charCodeAt(b);if(v.get(l)!==p.WordCharacterClass.Regular)return!0}return!1}function w(v,E,R,b,o){if(b+o===R)return!0;const r=E.charCodeAt(b+o);if(v.get(r)!==p.WordCharacterClass.Regular||r===t.CharCode.CarriageReturn||r===t.CharCode.LineFeed)return!0;if(o>0){const l=E.charCodeAt(b+o-1);if(v.get(l)!==p.WordCharacterClass.Regular)return!0}return!1}function L(v,E,R,b,o){return e(v,E,R,b,o)&&w(v,E,R,b,o)}class A{constructor(E,R){this._wordSeparators=E,this.a=R,this.b=-1,this.c=0}reset(E){this.a.lastIndex=E,this.b=-1,this.c=0}next(E){const R=E.length;let b;do{if(this.b+this.c===R||(b=this.a.exec(E),!b))return null;const o=b.index,r=b[0].length;if(o===this.b&&r===this.c){if(r===0){n.$Mf(E,R,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=r,!this._wordSeparators||L(this._wordSeparators,E,R,o,r))return b}while(b);return null}}i.$pD=A}),ne(ie[68],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$94=p;const t=new RegExp("\\bMARK:\\s*(.*)$","d"),n=/^-+|-+$/g;function p(u,f){let $=[];if(f.findRegionSectionHeaders&&f.foldingRules?.markers){const g=h(u,f);$=$.concat(g)}if(f.findMarkSectionHeaders){const g=N(u);$=$.concat(g)}return $}function h(u,f){const $=[],g=u.getLineCount();for(let d=1;d<=g;d++){const e=u.getLineContent(d),w=e.match(f.foldingRules.markers.start);if(w){const L={startLineNumber:d,startColumn:w[0].length+1,endLineNumber:d,endColumn:e.length+1};if(L.endColumn>L.startColumn){const A={range:L,...a(e.substring(w[0].length)),shouldBeInComments:!1};(A.text||A.hasSeparatorLine)&&$.push(A)}}}return $}function N(u){const f=[],$=u.getLineCount();for(let g=1;g<=$;g++){const d=u.getLineContent(g);m(d,g,f)}return f}function m(u,f,$){t.lastIndex=0;const g=t.exec(u);if(g){const d=g.indices[1][0]+1,e=g.indices[1][1]+1,w={startLineNumber:f,startColumn:d,endLineNumber:f,endColumn:e};if(w.endColumn>w.startColumn){const L={range:w,...a(g[1]),shouldBeInComments:!0};(L.text||L.hasSeparatorLine)&&$.push(L)}}}function a(u){u=u.trim();const f=u.startsWith("-");return u=u.replace(n,""),{text:u,hasSeparatorLine:f}}}),ne(ie[69],re([0,1,2,67,8,11,32]),function(x,i,t,n,p,h,N){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UnicodeHighlighterReasonKind=i.$E4=void 0,p=Oe(p);class m{static computeUnicodeHighlights(e,w,L){const A=L?L.startLineNumber:1,v=L?L.endLineNumber:e.getLineCount(),E=new f(w),R=E.getCandidateCodePoints();let b;R==="allNonBasicAscii"?b=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):b=new RegExp(`${a(Array.from(R))}`,"g");const o=new n.$pD(null,b),r=[];let l=!1,c,M=0,_=0,T=0;e:for(let D=A,j=v;D<=j;D++){const P=e.getLineContent(D),I=P.length;o.reset(0);do if(c=o.next(P),c){let F=c.index,y=c.index+c[0].length;if(F>0){const X=P.charCodeAt(F-1);p.$Jf(X)&&F--}if(y+1<I){const X=P.charCodeAt(y-1);p.$Jf(X)&&y++}const W=P.substring(F,y);let B=(0,N.$qt)(F+1,N.$nt,P,0);B&&B.endColumn<=F+1&&(B=null);const O=E.shouldHighlightNonBasicASCII(W,B?B.word:null);if(O!==g.None){if(O===g.Ambiguous?M++:O===g.Invisible?_++:O===g.NonBasicASCII?T++:(0,h.$ed)(O),r.length>=1e3){l=!0;break e}r.push(new t.$Ot(D,F+1,D,y+1))}}while(c)}return{ranges:r,hasMore:l,ambiguousCharacterCount:M,invisibleCharacterCount:_,nonBasicAsciiCharacterCount:T}}static computeUnicodeHighlightReason(e,w){const L=new f(w);switch(L.shouldHighlightNonBasicASCII(e,null)){case g.None:return null;case g.Invisible:return{kind:u.Invisible};case g.Ambiguous:{const v=e.codePointAt(0),E=L.ambiguousCharacters.getPrimaryConfusable(v),R=p.$cg.getLocales().filter(b=>!p.$cg.getInstance(new Set([...w.allowedLocales,b])).isAmbiguous(v));return{kind:u.Ambiguous,confusableWith:String.fromCodePoint(E),notAmbiguousInLocales:R}}case g.NonBasicASCII:return{kind:u.NonBasicAscii}}}}i.$E4=m;function a(d,e){return`[${p.$hf(d.map(L=>String.fromCodePoint(L)).join(""))}]`}var u;(function(d){d[d.Ambiguous=0]="Ambiguous",d[d.Invisible=1]="Invisible",d[d.NonBasicAscii=2]="NonBasicAscii"})(u||(i.UnicodeHighlighterReasonKind=u={}));class f{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=p.$cg.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const w of p.$dg.codePoints)$(String.fromCodePoint(w))||e.add(w);if(this.b.ambiguousCharacters)for(const w of this.ambiguousCharacters.getConfusableCodePoints())e.add(w);for(const w of this.a)e.delete(w);return e}shouldHighlightNonBasicASCII(e,w){const L=e.codePointAt(0);if(this.a.has(L))return g.None;if(this.b.nonBasicASCII)return g.NonBasicASCII;let A=!1,v=!1;if(w)for(const E of w){const R=E.codePointAt(0),b=p.$Uf(E);A=A||b,!b&&!this.ambiguousCharacters.isAmbiguous(R)&&!p.$dg.isInvisibleCharacter(R)&&(v=!0)}return!A&&v?g.None:this.b.invisibleCharacters&&!$(e)&&p.$dg.isInvisibleCharacter(L)?g.Invisible:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(L)?g.Ambiguous:g.None}}function $(d){return d===" "||d===`
`||d==="	"}var g;(function(d){d[d.None=0]="None",d[d.NonBasicASCII=1]="NonBasicASCII",d[d.Invisible=2]="Invisible",d[d.Ambiguous=3]="Ambiguous"})(g||(g={}))}),ne(ie[70],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.WrappingIndent=i.TrackedRangeStickiness=i.TextEditorCursorStyle=i.TextEditorCursorBlinkingStyle=i.SymbolTag=i.SymbolKind=i.SignatureHelpTriggerKind=i.ShowLightbulbIconMode=i.SelectionDirection=i.ScrollbarVisibility=i.ScrollType=i.RenderMinimap=i.RenderLineNumbersType=i.PositionAffinity=i.PartialAcceptTriggerKind=i.OverviewRulerLane=i.OverlayWidgetPositionPreference=i.NewSymbolNameTriggerKind=i.NewSymbolNameTag=i.MouseTargetType=i.MinimapSectionHeaderStyle=i.MinimapPosition=i.MarkerTag=i.MarkerSeverity=i.KeyCode=i.InlineEditTriggerKind=i.InlineCompletionTriggerKind=i.InlayHintKind=i.InjectedTextCursorStops=i.IndentAction=i.HoverVerbosityAction=i.GlyphMarginLane=i.EndOfLineSequence=i.EndOfLinePreference=i.EditorOption=i.EditorAutoIndentStrategy=i.DocumentHighlightKind=i.DefaultEndOfLine=i.CursorChangeReason=i.ContentWidgetPositionPreference=i.CompletionTriggerKind=i.CompletionItemTag=i.CompletionItemKind=i.CompletionItemInsertTextRule=i.CodeActionTriggerType=i.AccessibilitySupport=void 0;var t;(function(s){s[s.Unknown=0]="Unknown",s[s.Disabled=1]="Disabled",s[s.Enabled=2]="Enabled"})(t||(i.AccessibilitySupport=t={}));var n;(function(s){s[s.Invoke=1]="Invoke",s[s.Auto=2]="Auto"})(n||(i.CodeActionTriggerType=n={}));var p;(function(s){s[s.None=0]="None",s[s.KeepWhitespace=1]="KeepWhitespace",s[s.InsertAsSnippet=4]="InsertAsSnippet"})(p||(i.CompletionItemInsertTextRule=p={}));var h;(function(s){s[s.Method=0]="Method",s[s.Function=1]="Function",s[s.Constructor=2]="Constructor",s[s.Field=3]="Field",s[s.Variable=4]="Variable",s[s.Class=5]="Class",s[s.Struct=6]="Struct",s[s.Interface=7]="Interface",s[s.Module=8]="Module",s[s.Property=9]="Property",s[s.Event=10]="Event",s[s.Operator=11]="Operator",s[s.Unit=12]="Unit",s[s.Value=13]="Value",s[s.Constant=14]="Constant",s[s.Enum=15]="Enum",s[s.EnumMember=16]="EnumMember",s[s.Keyword=17]="Keyword",s[s.Text=18]="Text",s[s.Color=19]="Color",s[s.File=20]="File",s[s.Reference=21]="Reference",s[s.Customcolor=22]="Customcolor",s[s.Folder=23]="Folder",s[s.TypeParameter=24]="TypeParameter",s[s.User=25]="User",s[s.Issue=26]="Issue",s[s.Snippet=27]="Snippet"})(h||(i.CompletionItemKind=h={}));var N;(function(s){s[s.Deprecated=1]="Deprecated"})(N||(i.CompletionItemTag=N={}));var m;(function(s){s[s.Invoke=0]="Invoke",s[s.TriggerCharacter=1]="TriggerCharacter",s[s.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m||(i.CompletionTriggerKind=m={}));var a;(function(s){s[s.EXACT=0]="EXACT",s[s.ABOVE=1]="ABOVE",s[s.BELOW=2]="BELOW"})(a||(i.ContentWidgetPositionPreference=a={}));var u;(function(s){s[s.NotSet=0]="NotSet",s[s.ContentFlush=1]="ContentFlush",s[s.RecoverFromMarkers=2]="RecoverFromMarkers",s[s.Explicit=3]="Explicit",s[s.Paste=4]="Paste",s[s.Undo=5]="Undo",s[s.Redo=6]="Redo"})(u||(i.CursorChangeReason=u={}));var f;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(f||(i.DefaultEndOfLine=f={}));var $;(function(s){s[s.Text=0]="Text",s[s.Read=1]="Read",s[s.Write=2]="Write"})($||(i.DocumentHighlightKind=$={}));var g;(function(s){s[s.None=0]="None",s[s.Keep=1]="Keep",s[s.Brackets=2]="Brackets",s[s.Advanced=3]="Advanced",s[s.Full=4]="Full"})(g||(i.EditorAutoIndentStrategy=g={}));var d;(function(s){s[s.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",s[s.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",s[s.accessibilitySupport=2]="accessibilitySupport",s[s.accessibilityPageSize=3]="accessibilityPageSize",s[s.ariaLabel=4]="ariaLabel",s[s.ariaRequired=5]="ariaRequired",s[s.autoClosingBrackets=6]="autoClosingBrackets",s[s.autoClosingComments=7]="autoClosingComments",s[s.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",s[s.autoClosingDelete=9]="autoClosingDelete",s[s.autoClosingOvertype=10]="autoClosingOvertype",s[s.autoClosingQuotes=11]="autoClosingQuotes",s[s.autoIndent=12]="autoIndent",s[s.automaticLayout=13]="automaticLayout",s[s.autoSurround=14]="autoSurround",s[s.bracketPairColorization=15]="bracketPairColorization",s[s.guides=16]="guides",s[s.codeLens=17]="codeLens",s[s.codeLensFontFamily=18]="codeLensFontFamily",s[s.codeLensFontSize=19]="codeLensFontSize",s[s.colorDecorators=20]="colorDecorators",s[s.colorDecoratorsLimit=21]="colorDecoratorsLimit",s[s.columnSelection=22]="columnSelection",s[s.comments=23]="comments",s[s.contextmenu=24]="contextmenu",s[s.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",s[s.cursorBlinking=26]="cursorBlinking",s[s.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",s[s.cursorStyle=28]="cursorStyle",s[s.cursorSurroundingLines=29]="cursorSurroundingLines",s[s.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",s[s.cursorWidth=31]="cursorWidth",s[s.disableLayerHinting=32]="disableLayerHinting",s[s.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",s[s.domReadOnly=34]="domReadOnly",s[s.dragAndDrop=35]="dragAndDrop",s[s.dropIntoEditor=36]="dropIntoEditor",s[s.emptySelectionClipboard=37]="emptySelectionClipboard",s[s.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",s[s.extraEditorClassName=39]="extraEditorClassName",s[s.fastScrollSensitivity=40]="fastScrollSensitivity",s[s.find=41]="find",s[s.fixedOverflowWidgets=42]="fixedOverflowWidgets",s[s.folding=43]="folding",s[s.foldingStrategy=44]="foldingStrategy",s[s.foldingHighlight=45]="foldingHighlight",s[s.foldingImportsByDefault=46]="foldingImportsByDefault",s[s.foldingMaximumRegions=47]="foldingMaximumRegions",s[s.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",s[s.fontFamily=49]="fontFamily",s[s.fontInfo=50]="fontInfo",s[s.fontLigatures=51]="fontLigatures",s[s.fontSize=52]="fontSize",s[s.fontWeight=53]="fontWeight",s[s.fontVariations=54]="fontVariations",s[s.formatOnPaste=55]="formatOnPaste",s[s.formatOnType=56]="formatOnType",s[s.glyphMargin=57]="glyphMargin",s[s.gotoLocation=58]="gotoLocation",s[s.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",s[s.hover=60]="hover",s[s.inDiffEditor=61]="inDiffEditor",s[s.inlineSuggest=62]="inlineSuggest",s[s.inlineEdit=63]="inlineEdit",s[s.letterSpacing=64]="letterSpacing",s[s.lightbulb=65]="lightbulb",s[s.lineDecorationsWidth=66]="lineDecorationsWidth",s[s.lineHeight=67]="lineHeight",s[s.lineNumbers=68]="lineNumbers",s[s.lineNumbersMinChars=69]="lineNumbersMinChars",s[s.linkedEditing=70]="linkedEditing",s[s.links=71]="links",s[s.matchBrackets=72]="matchBrackets",s[s.minimap=73]="minimap",s[s.mouseStyle=74]="mouseStyle",s[s.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",s[s.mouseWheelZoom=76]="mouseWheelZoom",s[s.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",s[s.multiCursorModifier=78]="multiCursorModifier",s[s.multiCursorPaste=79]="multiCursorPaste",s[s.multiCursorLimit=80]="multiCursorLimit",s[s.occurrencesHighlight=81]="occurrencesHighlight",s[s.overviewRulerBorder=82]="overviewRulerBorder",s[s.overviewRulerLanes=83]="overviewRulerLanes",s[s.padding=84]="padding",s[s.pasteAs=85]="pasteAs",s[s.parameterHints=86]="parameterHints",s[s.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",s[s.placeholder=88]="placeholder",s[s.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",s[s.quickSuggestions=90]="quickSuggestions",s[s.quickSuggestionsDelay=91]="quickSuggestionsDelay",s[s.readOnly=92]="readOnly",s[s.readOnlyMessage=93]="readOnlyMessage",s[s.renameOnType=94]="renameOnType",s[s.renderControlCharacters=95]="renderControlCharacters",s[s.renderFinalNewline=96]="renderFinalNewline",s[s.renderLineHighlight=97]="renderLineHighlight",s[s.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",s[s.renderValidationDecorations=99]="renderValidationDecorations",s[s.renderWhitespace=100]="renderWhitespace",s[s.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",s[s.roundedSelection=102]="roundedSelection",s[s.rulers=103]="rulers",s[s.scrollbar=104]="scrollbar",s[s.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",s[s.scrollBeyondLastLine=106]="scrollBeyondLastLine",s[s.scrollPredominantAxis=107]="scrollPredominantAxis",s[s.selectionClipboard=108]="selectionClipboard",s[s.selectionHighlight=109]="selectionHighlight",s[s.selectOnLineNumbers=110]="selectOnLineNumbers",s[s.showFoldingControls=111]="showFoldingControls",s[s.showUnused=112]="showUnused",s[s.snippetSuggestions=113]="snippetSuggestions",s[s.smartSelect=114]="smartSelect",s[s.smoothScrolling=115]="smoothScrolling",s[s.stickyScroll=116]="stickyScroll",s[s.stickyTabStops=117]="stickyTabStops",s[s.stopRenderingLineAfter=118]="stopRenderingLineAfter",s[s.suggest=119]="suggest",s[s.suggestFontSize=120]="suggestFontSize",s[s.suggestLineHeight=121]="suggestLineHeight",s[s.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",s[s.suggestSelection=123]="suggestSelection",s[s.tabCompletion=124]="tabCompletion",s[s.tabIndex=125]="tabIndex",s[s.unicodeHighlighting=126]="unicodeHighlighting",s[s.unusualLineTerminators=127]="unusualLineTerminators",s[s.useShadowDOM=128]="useShadowDOM",s[s.useTabStops=129]="useTabStops",s[s.wordBreak=130]="wordBreak",s[s.wordSegmenterLocales=131]="wordSegmenterLocales",s[s.wordSeparators=132]="wordSeparators",s[s.wordWrap=133]="wordWrap",s[s.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",s[s.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",s[s.wordWrapColumn=136]="wordWrapColumn",s[s.wordWrapOverride1=137]="wordWrapOverride1",s[s.wordWrapOverride2=138]="wordWrapOverride2",s[s.wrappingIndent=139]="wrappingIndent",s[s.wrappingStrategy=140]="wrappingStrategy",s[s.showDeprecated=141]="showDeprecated",s[s.inlayHints=142]="inlayHints",s[s.editorClassName=143]="editorClassName",s[s.pixelRatio=144]="pixelRatio",s[s.tabFocusMode=145]="tabFocusMode",s[s.layoutInfo=146]="layoutInfo",s[s.wrappingInfo=147]="wrappingInfo",s[s.defaultColorDecorators=148]="defaultColorDecorators",s[s.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",s[s.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(d||(i.EditorOption=d={}));var e;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(e||(i.EndOfLinePreference=e={}));var w;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(w||(i.EndOfLineSequence=w={}));var L;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(L||(i.GlyphMarginLane=L={}));var A;(function(s){s[s.Increase=0]="Increase",s[s.Decrease=1]="Decrease"})(A||(i.HoverVerbosityAction=A={}));var v;(function(s){s[s.None=0]="None",s[s.Indent=1]="Indent",s[s.IndentOutdent=2]="IndentOutdent",s[s.Outdent=3]="Outdent"})(v||(i.IndentAction=v={}));var E;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(E||(i.InjectedTextCursorStops=E={}));var R;(function(s){s[s.Type=1]="Type",s[s.Parameter=2]="Parameter"})(R||(i.InlayHintKind=R={}));var b;(function(s){s[s.Automatic=0]="Automatic",s[s.Explicit=1]="Explicit"})(b||(i.InlineCompletionTriggerKind=b={}));var o;(function(s){s[s.Invoke=0]="Invoke",s[s.Automatic=1]="Automatic"})(o||(i.InlineEditTriggerKind=o={}));var r;(function(s){s[s.DependsOnKbLayout=-1]="DependsOnKbLayout",s[s.Unknown=0]="Unknown",s[s.Backspace=1]="Backspace",s[s.Tab=2]="Tab",s[s.Enter=3]="Enter",s[s.Shift=4]="Shift",s[s.Ctrl=5]="Ctrl",s[s.Alt=6]="Alt",s[s.PauseBreak=7]="PauseBreak",s[s.CapsLock=8]="CapsLock",s[s.Escape=9]="Escape",s[s.Space=10]="Space",s[s.PageUp=11]="PageUp",s[s.PageDown=12]="PageDown",s[s.End=13]="End",s[s.Home=14]="Home",s[s.LeftArrow=15]="LeftArrow",s[s.UpArrow=16]="UpArrow",s[s.RightArrow=17]="RightArrow",s[s.DownArrow=18]="DownArrow",s[s.Insert=19]="Insert",s[s.Delete=20]="Delete",s[s.Digit0=21]="Digit0",s[s.Digit1=22]="Digit1",s[s.Digit2=23]="Digit2",s[s.Digit3=24]="Digit3",s[s.Digit4=25]="Digit4",s[s.Digit5=26]="Digit5",s[s.Digit6=27]="Digit6",s[s.Digit7=28]="Digit7",s[s.Digit8=29]="Digit8",s[s.Digit9=30]="Digit9",s[s.KeyA=31]="KeyA",s[s.KeyB=32]="KeyB",s[s.KeyC=33]="KeyC",s[s.KeyD=34]="KeyD",s[s.KeyE=35]="KeyE",s[s.KeyF=36]="KeyF",s[s.KeyG=37]="KeyG",s[s.KeyH=38]="KeyH",s[s.KeyI=39]="KeyI",s[s.KeyJ=40]="KeyJ",s[s.KeyK=41]="KeyK",s[s.KeyL=42]="KeyL",s[s.KeyM=43]="KeyM",s[s.KeyN=44]="KeyN",s[s.KeyO=45]="KeyO",s[s.KeyP=46]="KeyP",s[s.KeyQ=47]="KeyQ",s[s.KeyR=48]="KeyR",s[s.KeyS=49]="KeyS",s[s.KeyT=50]="KeyT",s[s.KeyU=51]="KeyU",s[s.KeyV=52]="KeyV",s[s.KeyW=53]="KeyW",s[s.KeyX=54]="KeyX",s[s.KeyY=55]="KeyY",s[s.KeyZ=56]="KeyZ",s[s.Meta=57]="Meta",s[s.ContextMenu=58]="ContextMenu",s[s.F1=59]="F1",s[s.F2=60]="F2",s[s.F3=61]="F3",s[s.F4=62]="F4",s[s.F5=63]="F5",s[s.F6=64]="F6",s[s.F7=65]="F7",s[s.F8=66]="F8",s[s.F9=67]="F9",s[s.F10=68]="F10",s[s.F11=69]="F11",s[s.F12=70]="F12",s[s.F13=71]="F13",s[s.F14=72]="F14",s[s.F15=73]="F15",s[s.F16=74]="F16",s[s.F17=75]="F17",s[s.F18=76]="F18",s[s.F19=77]="F19",s[s.F20=78]="F20",s[s.F21=79]="F21",s[s.F22=80]="F22",s[s.F23=81]="F23",s[s.F24=82]="F24",s[s.NumLock=83]="NumLock",s[s.ScrollLock=84]="ScrollLock",s[s.Semicolon=85]="Semicolon",s[s.Equal=86]="Equal",s[s.Comma=87]="Comma",s[s.Minus=88]="Minus",s[s.Period=89]="Period",s[s.Slash=90]="Slash",s[s.Backquote=91]="Backquote",s[s.BracketLeft=92]="BracketLeft",s[s.Backslash=93]="Backslash",s[s.BracketRight=94]="BracketRight",s[s.Quote=95]="Quote",s[s.OEM_8=96]="OEM_8",s[s.IntlBackslash=97]="IntlBackslash",s[s.Numpad0=98]="Numpad0",s[s.Numpad1=99]="Numpad1",s[s.Numpad2=100]="Numpad2",s[s.Numpad3=101]="Numpad3",s[s.Numpad4=102]="Numpad4",s[s.Numpad5=103]="Numpad5",s[s.Numpad6=104]="Numpad6",s[s.Numpad7=105]="Numpad7",s[s.Numpad8=106]="Numpad8",s[s.Numpad9=107]="Numpad9",s[s.NumpadMultiply=108]="NumpadMultiply",s[s.NumpadAdd=109]="NumpadAdd",s[s.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",s[s.NumpadSubtract=111]="NumpadSubtract",s[s.NumpadDecimal=112]="NumpadDecimal",s[s.NumpadDivide=113]="NumpadDivide",s[s.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",s[s.ABNT_C1=115]="ABNT_C1",s[s.ABNT_C2=116]="ABNT_C2",s[s.AudioVolumeMute=117]="AudioVolumeMute",s[s.AudioVolumeUp=118]="AudioVolumeUp",s[s.AudioVolumeDown=119]="AudioVolumeDown",s[s.BrowserSearch=120]="BrowserSearch",s[s.BrowserHome=121]="BrowserHome",s[s.BrowserBack=122]="BrowserBack",s[s.BrowserForward=123]="BrowserForward",s[s.MediaTrackNext=124]="MediaTrackNext",s[s.MediaTrackPrevious=125]="MediaTrackPrevious",s[s.MediaStop=126]="MediaStop",s[s.MediaPlayPause=127]="MediaPlayPause",s[s.LaunchMediaPlayer=128]="LaunchMediaPlayer",s[s.LaunchMail=129]="LaunchMail",s[s.LaunchApp2=130]="LaunchApp2",s[s.Clear=131]="Clear",s[s.MAX_VALUE=132]="MAX_VALUE"})(r||(i.KeyCode=r={}));var l;(function(s){s[s.Hint=1]="Hint",s[s.Info=2]="Info",s[s.Warning=4]="Warning",s[s.Error=8]="Error"})(l||(i.MarkerSeverity=l={}));var c;(function(s){s[s.Unnecessary=1]="Unnecessary",s[s.Deprecated=2]="Deprecated"})(c||(i.MarkerTag=c={}));var M;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(M||(i.MinimapPosition=M={}));var _;(function(s){s[s.Normal=1]="Normal",s[s.Underlined=2]="Underlined"})(_||(i.MinimapSectionHeaderStyle=_={}));var T;(function(s){s[s.UNKNOWN=0]="UNKNOWN",s[s.TEXTAREA=1]="TEXTAREA",s[s.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",s[s.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",s[s.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",s[s.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",s[s.CONTENT_TEXT=6]="CONTENT_TEXT",s[s.CONTENT_EMPTY=7]="CONTENT_EMPTY",s[s.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",s[s.CONTENT_WIDGET=9]="CONTENT_WIDGET",s[s.OVERVIEW_RULER=10]="OVERVIEW_RULER",s[s.SCROLLBAR=11]="SCROLLBAR",s[s.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",s[s.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(T||(i.MouseTargetType=T={}));var D;(function(s){s[s.AIGenerated=1]="AIGenerated"})(D||(i.NewSymbolNameTag=D={}));var j;(function(s){s[s.Invoke=0]="Invoke",s[s.Automatic=1]="Automatic"})(j||(i.NewSymbolNameTriggerKind=j={}));var P;(function(s){s[s.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",s[s.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",s[s.TOP_CENTER=2]="TOP_CENTER"})(P||(i.OverlayWidgetPositionPreference=P={}));var I;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(I||(i.OverviewRulerLane=I={}));var F;(function(s){s[s.Word=0]="Word",s[s.Line=1]="Line",s[s.Suggest=2]="Suggest"})(F||(i.PartialAcceptTriggerKind=F={}));var y;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(y||(i.PositionAffinity=y={}));var W;(function(s){s[s.Off=0]="Off",s[s.On=1]="On",s[s.Relative=2]="Relative",s[s.Interval=3]="Interval",s[s.Custom=4]="Custom"})(W||(i.RenderLineNumbersType=W={}));var B;(function(s){s[s.None=0]="None",s[s.Text=1]="Text",s[s.Blocks=2]="Blocks"})(B||(i.RenderMinimap=B={}));var O;(function(s){s[s.Smooth=0]="Smooth",s[s.Immediate=1]="Immediate"})(O||(i.ScrollType=O={}));var X;(function(s){s[s.Auto=1]="Auto",s[s.Hidden=2]="Hidden",s[s.Visible=3]="Visible"})(X||(i.ScrollbarVisibility=X={}));var Y;(function(s){s[s.LTR=0]="LTR",s[s.RTL=1]="RTL"})(Y||(i.SelectionDirection=Y={}));var z;(function(s){s.Off="off",s.OnCode="onCode",s.On="on"})(z||(i.ShowLightbulbIconMode=z={}));var Q;(function(s){s[s.Invoke=1]="Invoke",s[s.TriggerCharacter=2]="TriggerCharacter",s[s.ContentChange=3]="ContentChange"})(Q||(i.SignatureHelpTriggerKind=Q={}));var ee;(function(s){s[s.File=0]="File",s[s.Module=1]="Module",s[s.Namespace=2]="Namespace",s[s.Package=3]="Package",s[s.Class=4]="Class",s[s.Method=5]="Method",s[s.Property=6]="Property",s[s.Field=7]="Field",s[s.Constructor=8]="Constructor",s[s.Enum=9]="Enum",s[s.Interface=10]="Interface",s[s.Function=11]="Function",s[s.Variable=12]="Variable",s[s.Constant=13]="Constant",s[s.String=14]="String",s[s.Number=15]="Number",s[s.Boolean=16]="Boolean",s[s.Array=17]="Array",s[s.Object=18]="Object",s[s.Key=19]="Key",s[s.Null=20]="Null",s[s.EnumMember=21]="EnumMember",s[s.Struct=22]="Struct",s[s.Event=23]="Event",s[s.Operator=24]="Operator",s[s.TypeParameter=25]="TypeParameter"})(ee||(i.SymbolKind=ee={}));var k;(function(s){s[s.Deprecated=1]="Deprecated"})(k||(i.SymbolTag=k={}));var H;(function(s){s[s.Hidden=0]="Hidden",s[s.Blink=1]="Blink",s[s.Smooth=2]="Smooth",s[s.Phase=3]="Phase",s[s.Expand=4]="Expand",s[s.Solid=5]="Solid"})(H||(i.TextEditorCursorBlinkingStyle=H={}));var fe;(function(s){s[s.Line=1]="Line",s[s.Block=2]="Block",s[s.Underline=3]="Underline",s[s.LineThin=4]="LineThin",s[s.BlockOutline=5]="BlockOutline",s[s.UnderlineThin=6]="UnderlineThin"})(fe||(i.TextEditorCursorStyle=fe={}));var oe;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(oe||(i.TrackedRangeStickiness=oe={}));var we;(function(s){s[s.None=0]="None",s[s.Same=1]="Same",s[s.Indent=2]="Indent",s[s.DeepIndent=3]="DeepIndent"})(we||(i.WrappingIndent=we={}))}),ne(ie[71],re([0,1,13,12,60]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$yu=void 0;class h{constructor(){this.a=new Map,this.b=new Map,this.c=new t.$le,this.onDidChange=this.c.event,this.d=null}handleChange(a){this.c.fire({changedLanguages:a,changedColorMap:!1})}register(a,u){return this.a.set(a,u),this.handleChange([a]),(0,n.$Sc)(()=>{this.a.get(a)===u&&(this.a.delete(a),this.handleChange([a]))})}get(a){return this.a.get(a)||null}registerFactory(a,u){this.b.get(a)?.dispose();const f=new N(this,a,u);return this.b.set(a,f),(0,n.$Sc)(()=>{const $=this.b.get(a);!$||$!==f||(this.b.delete(a),$.dispose())})}async getOrCreate(a){const u=this.get(a);if(u)return u;const f=this.b.get(a);return!f||f.isResolved?null:(await f.resolve(),this.get(a))}isResolved(a){if(this.get(a))return!0;const f=this.b.get(a);return!!(!f||f.isResolved)}setColorMap(a){this.d=a,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>p.ColorId.DefaultBackground?this.d[p.ColorId.DefaultBackground]:null}}i.$yu=h;class N extends n.$Uc{get isResolved(){return this.c}constructor(a,u,f){super(),this.f=a,this.g=u,this.h=f,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const a=await this.h.tokenizationSupport;this.c=!0,a&&!this.a&&this.B(this.f.register(this.g,a))}}}),ne(ie[72],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localize=p,i.localize2=N;const t=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function n(m,a){let u;return a.length===0?u=m:u=m.replace(/\{(\d+)\}/g,(f,$)=>{const g=$[0],d=a[g];let e=f;return typeof d=="string"?e=d:(typeof d=="number"||typeof d=="boolean"||d===void 0||d===null)&&(e=String(d)),e}),t&&(u="\uFF3B"+u.replace(/[aouei]/g,"$&$&")+"\uFF3D"),u}function p(m,a,...u){return n(typeof m=="number"?h(m,a):a,u)}function h(m,a){const u=globalThis._VSCODE_NLS_MESSAGES?.[m];if(typeof u!="string"){if(typeof a=="string")return a;throw new Error(`!!! NLS MISSING: ${m} !!!`)}return u}function N(m,a,...u){let f;typeof m=="number"?f=h(m,a):f=a;const $=n(f,u);return{value:$,original:a===f?$:n(a,u)}}}),ne(ie[73],re([0,1,47,19,49,2,71,72]),function(x,i,t,n,p,h,N,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InlineEditTriggerKind=i.ExternalUriOpenerPriority=i.$Ru=i.$Qu=i.InlayHintKind=i.CommentState=i.CommentMode=i.CommentThreadApplicability=i.CommentThreadState=i.CommentThreadCollapsibleState=i.Command=i.NewSymbolNameTriggerKind=i.NewSymbolNameTag=i.$Pu=i.$Ou=i.SymbolKinds=i.SymbolTag=i.$Mu=i.SymbolKind=i.DocumentHighlightKind=i.SignatureHelpTriggerKind=i.DocumentPasteTriggerKind=i.CodeActionTriggerType=i.$Ku=i.InlineCompletionTriggerKind=i.CompletionTriggerKind=i.PartialAcceptTriggerKind=i.CompletionItemInsertTextRule=i.CompletionItemTag=i.CompletionItemKinds=i.CompletionItemKind=i.HoverVerbosityAction=i.$Ju=i.$Iu=i.$Hu=void 0,i.$Lu=l,i.$Nu=M;class a{constructor(H,fe,oe){this.offset=H,this.type=fe,this.language=oe,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}i.$Hu=a;class u{constructor(H,fe){this.tokens=H,this.endState=fe,this._tokenizationResultBrand=void 0}}i.$Iu=u;class f{constructor(H,fe){this.tokens=H,this.endState=fe,this._encodedTokenizationResultBrand=void 0}}i.$Ju=f;var $;(function(k){k[k.Increase=0]="Increase",k[k.Decrease=1]="Decrease"})($||(i.HoverVerbosityAction=$={}));var g;(function(k){k[k.Method=0]="Method",k[k.Function=1]="Function",k[k.Constructor=2]="Constructor",k[k.Field=3]="Field",k[k.Variable=4]="Variable",k[k.Class=5]="Class",k[k.Struct=6]="Struct",k[k.Interface=7]="Interface",k[k.Module=8]="Module",k[k.Property=9]="Property",k[k.Event=10]="Event",k[k.Operator=11]="Operator",k[k.Unit=12]="Unit",k[k.Value=13]="Value",k[k.Constant=14]="Constant",k[k.Enum=15]="Enum",k[k.EnumMember=16]="EnumMember",k[k.Keyword=17]="Keyword",k[k.Text=18]="Text",k[k.Color=19]="Color",k[k.File=20]="File",k[k.Reference=21]="Reference",k[k.Customcolor=22]="Customcolor",k[k.Folder=23]="Folder",k[k.TypeParameter=24]="TypeParameter",k[k.User=25]="User",k[k.Issue=26]="Issue",k[k.Snippet=27]="Snippet"})(g||(i.CompletionItemKind=g={}));var d;(function(k){const H=new Map;H.set(g.Method,t.$5j.symbolMethod),H.set(g.Function,t.$5j.symbolFunction),H.set(g.Constructor,t.$5j.symbolConstructor),H.set(g.Field,t.$5j.symbolField),H.set(g.Variable,t.$5j.symbolVariable),H.set(g.Class,t.$5j.symbolClass),H.set(g.Struct,t.$5j.symbolStruct),H.set(g.Interface,t.$5j.symbolInterface),H.set(g.Module,t.$5j.symbolModule),H.set(g.Property,t.$5j.symbolProperty),H.set(g.Event,t.$5j.symbolEvent),H.set(g.Operator,t.$5j.symbolOperator),H.set(g.Unit,t.$5j.symbolUnit),H.set(g.Value,t.$5j.symbolValue),H.set(g.Enum,t.$5j.symbolEnum),H.set(g.Constant,t.$5j.symbolConstant),H.set(g.Enum,t.$5j.symbolEnum),H.set(g.EnumMember,t.$5j.symbolEnumMember),H.set(g.Keyword,t.$5j.symbolKeyword),H.set(g.Snippet,t.$5j.symbolSnippet),H.set(g.Text,t.$5j.symbolText),H.set(g.Color,t.$5j.symbolColor),H.set(g.File,t.$5j.symbolFile),H.set(g.Reference,t.$5j.symbolReference),H.set(g.Customcolor,t.$5j.symbolCustomColor),H.set(g.Folder,t.$5j.symbolFolder),H.set(g.TypeParameter,t.$5j.symbolTypeParameter),H.set(g.User,t.$5j.account),H.set(g.Issue,t.$5j.issues);function fe(s){let Te=H.get(s);return Te||(console.info("No codicon found for CompletionItemKind "+s),Te=t.$5j.symbolProperty),Te}k.toIcon=fe;const oe=new Map;oe.set("method",g.Method),oe.set("function",g.Function),oe.set("constructor",g.Constructor),oe.set("field",g.Field),oe.set("variable",g.Variable),oe.set("class",g.Class),oe.set("struct",g.Struct),oe.set("interface",g.Interface),oe.set("module",g.Module),oe.set("property",g.Property),oe.set("event",g.Event),oe.set("operator",g.Operator),oe.set("unit",g.Unit),oe.set("value",g.Value),oe.set("constant",g.Constant),oe.set("enum",g.Enum),oe.set("enum-member",g.EnumMember),oe.set("enumMember",g.EnumMember),oe.set("keyword",g.Keyword),oe.set("snippet",g.Snippet),oe.set("text",g.Text),oe.set("color",g.Color),oe.set("file",g.File),oe.set("reference",g.Reference),oe.set("customcolor",g.Customcolor),oe.set("folder",g.Folder),oe.set("type-parameter",g.TypeParameter),oe.set("typeParameter",g.TypeParameter),oe.set("account",g.User),oe.set("issue",g.Issue);function we(s,Te){let Ie=oe.get(s);return typeof Ie>"u"&&!Te&&(Ie=g.Property),Ie}k.fromString=we})(d||(i.CompletionItemKinds=d={}));var e;(function(k){k[k.Deprecated=1]="Deprecated"})(e||(i.CompletionItemTag=e={}));var w;(function(k){k[k.None=0]="None",k[k.KeepWhitespace=1]="KeepWhitespace",k[k.InsertAsSnippet=4]="InsertAsSnippet"})(w||(i.CompletionItemInsertTextRule=w={}));var L;(function(k){k[k.Word=0]="Word",k[k.Line=1]="Line",k[k.Suggest=2]="Suggest"})(L||(i.PartialAcceptTriggerKind=L={}));var A;(function(k){k[k.Invoke=0]="Invoke",k[k.TriggerCharacter=1]="TriggerCharacter",k[k.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(A||(i.CompletionTriggerKind=A={}));var v;(function(k){k[k.Automatic=0]="Automatic",k[k.Explicit=1]="Explicit"})(v||(i.InlineCompletionTriggerKind=v={}));class E{constructor(H,fe,oe,we){this.range=H,this.text=fe,this.completionKind=oe,this.isSnippetText=we}equals(H){return h.$Ot.lift(this.range).equalsRange(H.range)&&this.text===H.text&&this.completionKind===H.completionKind&&this.isSnippetText===H.isSnippetText}}i.$Ku=E;var R;(function(k){k[k.Invoke=1]="Invoke",k[k.Auto=2]="Auto"})(R||(i.CodeActionTriggerType=R={}));var b;(function(k){k[k.Automatic=0]="Automatic",k[k.PasteAs=1]="PasteAs"})(b||(i.DocumentPasteTriggerKind=b={}));var o;(function(k){k[k.Invoke=1]="Invoke",k[k.TriggerCharacter=2]="TriggerCharacter",k[k.ContentChange=3]="ContentChange"})(o||(i.SignatureHelpTriggerKind=o={}));var r;(function(k){k[k.Text=0]="Text",k[k.Read=1]="Read",k[k.Write=2]="Write"})(r||(i.DocumentHighlightKind=r={}));function l(k){return k&&n.URI.isUri(k.uri)&&h.$Ot.isIRange(k.range)&&(h.$Ot.isIRange(k.originSelectionRange)||h.$Ot.isIRange(k.targetSelectionRange))}var c;(function(k){k[k.File=0]="File",k[k.Module=1]="Module",k[k.Namespace=2]="Namespace",k[k.Package=3]="Package",k[k.Class=4]="Class",k[k.Method=5]="Method",k[k.Property=6]="Property",k[k.Field=7]="Field",k[k.Constructor=8]="Constructor",k[k.Enum=9]="Enum",k[k.Interface=10]="Interface",k[k.Function=11]="Function",k[k.Variable=12]="Variable",k[k.Constant=13]="Constant",k[k.String=14]="String",k[k.Number=15]="Number",k[k.Boolean=16]="Boolean",k[k.Array=17]="Array",k[k.Object=18]="Object",k[k.Key=19]="Key",k[k.Null=20]="Null",k[k.EnumMember=21]="EnumMember",k[k.Struct=22]="Struct",k[k.Event=23]="Event",k[k.Operator=24]="Operator",k[k.TypeParameter=25]="TypeParameter"})(c||(i.SymbolKind=c={})),i.$Mu={[c.Array]:(0,m.localize)(12848,null),[c.Boolean]:(0,m.localize)(12849,null),[c.Class]:(0,m.localize)(12850,null),[c.Constant]:(0,m.localize)(12851,null),[c.Constructor]:(0,m.localize)(12852,null),[c.Enum]:(0,m.localize)(12853,null),[c.EnumMember]:(0,m.localize)(12854,null),[c.Event]:(0,m.localize)(12855,null),[c.Field]:(0,m.localize)(12856,null),[c.File]:(0,m.localize)(12857,null),[c.Function]:(0,m.localize)(12858,null),[c.Interface]:(0,m.localize)(12859,null),[c.Key]:(0,m.localize)(12860,null),[c.Method]:(0,m.localize)(12861,null),[c.Module]:(0,m.localize)(12862,null),[c.Namespace]:(0,m.localize)(12863,null),[c.Null]:(0,m.localize)(12864,null),[c.Number]:(0,m.localize)(12865,null),[c.Object]:(0,m.localize)(12866,null),[c.Operator]:(0,m.localize)(12867,null),[c.Package]:(0,m.localize)(12868,null),[c.Property]:(0,m.localize)(12869,null),[c.String]:(0,m.localize)(12870,null),[c.Struct]:(0,m.localize)(12871,null),[c.TypeParameter]:(0,m.localize)(12872,null),[c.Variable]:(0,m.localize)(12873,null)};function M(k,H){return(0,m.localize)(12874,null,k,i.$Mu[H])}var _;(function(k){k[k.Deprecated=1]="Deprecated"})(_||(i.SymbolTag=_={}));var T;(function(k){const H=new Map;H.set(c.File,t.$5j.symbolFile),H.set(c.Module,t.$5j.symbolModule),H.set(c.Namespace,t.$5j.symbolNamespace),H.set(c.Package,t.$5j.symbolPackage),H.set(c.Class,t.$5j.symbolClass),H.set(c.Method,t.$5j.symbolMethod),H.set(c.Property,t.$5j.symbolProperty),H.set(c.Field,t.$5j.symbolField),H.set(c.Constructor,t.$5j.symbolConstructor),H.set(c.Enum,t.$5j.symbolEnum),H.set(c.Interface,t.$5j.symbolInterface),H.set(c.Function,t.$5j.symbolFunction),H.set(c.Variable,t.$5j.symbolVariable),H.set(c.Constant,t.$5j.symbolConstant),H.set(c.String,t.$5j.symbolString),H.set(c.Number,t.$5j.symbolNumber),H.set(c.Boolean,t.$5j.symbolBoolean),H.set(c.Array,t.$5j.symbolArray),H.set(c.Object,t.$5j.symbolObject),H.set(c.Key,t.$5j.symbolKey),H.set(c.Null,t.$5j.symbolNull),H.set(c.EnumMember,t.$5j.symbolEnumMember),H.set(c.Struct,t.$5j.symbolStruct),H.set(c.Event,t.$5j.symbolEvent),H.set(c.Operator,t.$5j.symbolOperator),H.set(c.TypeParameter,t.$5j.symbolTypeParameter);function fe(oe){let we=H.get(oe);return we||(console.info("No codicon found for SymbolKind "+oe),we=t.$5j.symbolProperty),we}k.toIcon=fe})(T||(i.SymbolKinds=T={}));class D{static asEditOperation(H){return p.$Pt.replace(h.$Ot.lift(H.range),H.text)}}i.$Ou=D;class j{static{this.Comment=new j("comment")}static{this.Imports=new j("imports")}static{this.Region=new j("region")}static fromValue(H){switch(H){case"comment":return j.Comment;case"imports":return j.Imports;case"region":return j.Region}return new j(H)}constructor(H){this.value=H}}i.$Pu=j;var P;(function(k){k[k.AIGenerated=1]="AIGenerated"})(P||(i.NewSymbolNameTag=P={}));var I;(function(k){k[k.Invoke=0]="Invoke",k[k.Automatic=1]="Automatic"})(I||(i.NewSymbolNameTriggerKind=I={}));var F;(function(k){function H(fe){return!fe||typeof fe!="object"?!1:typeof fe.id=="string"&&typeof fe.title=="string"}k.is=H})(F||(i.Command=F={}));var y;(function(k){k[k.Collapsed=0]="Collapsed",k[k.Expanded=1]="Expanded"})(y||(i.CommentThreadCollapsibleState=y={}));var W;(function(k){k[k.Unresolved=0]="Unresolved",k[k.Resolved=1]="Resolved"})(W||(i.CommentThreadState=W={}));var B;(function(k){k[k.Current=0]="Current",k[k.Outdated=1]="Outdated"})(B||(i.CommentThreadApplicability=B={}));var O;(function(k){k[k.Editing=0]="Editing",k[k.Preview=1]="Preview"})(O||(i.CommentMode=O={}));var X;(function(k){k[k.Published=0]="Published",k[k.Draft=1]="Draft"})(X||(i.CommentState=X={}));var Y;(function(k){k[k.Type=1]="Type",k[k.Parameter=2]="Parameter"})(Y||(i.InlayHintKind=Y={}));class z{constructor(H){this.b=H,this.a=null}dispose(){this.a&&this.a.then(H=>{H&&H.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}i.$Qu=z,i.$Ru=new N.$yu;var Q;(function(k){k[k.None=0]="None",k[k.Option=1]="Option",k[k.Default=2]="Default",k[k.Preferred=3]="Preferred"})(Q||(i.ExternalUriOpenerPriority=Q={}));var ee;(function(k){k[k.Invoke=0]="Invoke",k[k.Automatic=1]="Automatic"})(ee||(i.InlineEditTriggerKind=ee={}))}),ne(ie[74],re([0,1,26,13,40,19,3,2,50,73,70]),function(x,i,t,n,p,h,N,m,a,u,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$J4=void 0,i.$K4=g,f=Oe(f);class ${static{this.CtrlCmd=p.KeyMod.CtrlCmd}static{this.Shift=p.KeyMod.Shift}static{this.Alt=p.KeyMod.Alt}static{this.WinCtrl=p.KeyMod.WinCtrl}static chord(e,w){return(0,p.$Yr)(e,w)}}i.$J4=$;function g(){return{editor:void 0,languages:void 0,CancellationTokenSource:t.$we,Emitter:n.$le,KeyCode:f.KeyCode,KeyMod:$,Position:N.$Nt,Range:m.$Ot,Selection:a.$Qt,SelectionDirection:f.SelectionDirection,MarkerSeverity:f.MarkerSeverity,MarkerTag:f.MarkerTag,Uri:h.URI,Token:u.$Hu}}}),ne(ie[77],re([0,1,29,19,3,2,66,32,62,63,74,25,69,36,59,18,5,61,68]),function(x,i,t,n,p,h,N,m,a,u,f,$,g,d,e,w,L,A,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.EditorSimpleWorker=void 0,i.create=b;class E extends N.$pw{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(r){const l=[];for(let c=0;c<this.f.length;c++){const M=this.f[c],_=this.offsetAt(new p.$Nt(c+1,1)),T=M.matchAll(r);for(const D of T)(D.index||D.index===0)&&(D.index=D.index+_),l.push(D)}return l}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(r){return this.f[r-1]}getWordAtPosition(r,l){const c=(0,m.$qt)(r.column,(0,m.$ot)(l),this.f[r.lineNumber-1],0);return c?new h.$Ot(r.lineNumber,c.startColumn,r.lineNumber,c.endColumn):null}getWordUntilPosition(r,l){const c=this.getWordAtPosition(r,l);return c?{word:this.f[r.lineNumber-1].substring(c.startColumn-1,r.column-1),startColumn:c.startColumn,endColumn:r.column}:{word:"",startColumn:r.column,endColumn:r.column}}words(r){const l=this.f,c=this.q.bind(this);let M=0,_="",T=0,D=[];return{*[Symbol.iterator](){for(;;)if(T<D.length){const j=_.substring(D[T].start,D[T].end);T+=1,yield j}else if(M<l.length)_=l[M],D=c(_,r),T=0,M+=1;else break}}}getLineWords(r,l){const c=this.f[r-1],M=this.q(c,l),_=[];for(const T of M)_.push({word:c.substring(T.start,T.end),startColumn:T.start+1,endColumn:T.end+1});return _}q(r,l){const c=[];let M;for(l.lastIndex=0;(M=l.exec(r))&&M[0].length!==0;)c.push({start:M.index,end:M.index+M[0].length});return c}getValueInRange(r){if(r=this.r(r),r.startLineNumber===r.endLineNumber)return this.f[r.startLineNumber-1].substring(r.startColumn-1,r.endColumn-1);const l=this.g,c=r.startLineNumber-1,M=r.endLineNumber-1,_=[];_.push(this.f[c].substring(r.startColumn-1));for(let T=c+1;T<M;T++)_.push(this.f[T]);return _.push(this.f[M].substring(0,r.endColumn-1)),_.join(l)}offsetAt(r){return r=this.s(r),this.l(),this.j.getPrefixSum(r.lineNumber-2)+(r.column-1)}positionAt(r){r=Math.floor(r),r=Math.max(0,r),this.l();const l=this.j.getIndexOf(r),c=this.f[l.index].length;return{lineNumber:1+l.index,column:1+Math.min(l.remainder,c)}}r(r){const l=this.s({lineNumber:r.startLineNumber,column:r.startColumn}),c=this.s({lineNumber:r.endLineNumber,column:r.endColumn});return l.lineNumber!==r.startLineNumber||l.column!==r.startColumn||c.lineNumber!==r.endLineNumber||c.column!==r.endColumn?{startLineNumber:l.lineNumber,startColumn:l.column,endLineNumber:c.lineNumber,endColumn:c.column}:r}s(r){if(!p.$Nt.isIPosition(r))throw new Error("bad position");let{lineNumber:l,column:c}=r,M=!1;if(l<1)l=1,c=1,M=!0;else if(l>this.f.length)l=this.f.length,c=this.f[l-1].length+1,M=!0;else{const _=this.f[l-1].length+1;c<1?(c=1,M=!0):c>_&&(c=_,M=!0)}return M?{lineNumber:l,column:c}:r}}class R{constructor(r,l){this.d=r,this.f=Object.create(null),this.g=l,this.h=null}dispose(){this.f=Object.create(null)}j(r){return this.f[r]}k(){const r=[];return Object.keys(this.f).forEach(l=>r.push(this.f[l])),r}acceptNewModel(r){this.f[r.url]=new E(n.URI.parse(r.url),r.lines,r.EOL,r.versionId)}acceptModelChanged(r,l){if(!this.f[r])return;this.f[r].onEvents(l)}acceptRemovedModel(r){this.f[r]&&delete this.f[r]}async computeUnicodeHighlights(r,l,c){const M=this.j(r);return M?g.$E4.computeUnicodeHighlights(M,l,c):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async findSectionHeaders(r,l){const c=this.j(r);return c?(0,v.$94)(c,l):[]}async computeDiff(r,l,c,M){const _=this.j(r),T=this.j(l);return!_||!T?null:R.l(_,T,c,M)}static l(r,l,c,M){const _=M==="advanced"?e.$74.getDefault():e.$74.getLegacy(),T=r.getLinesContent(),D=l.getLinesContent(),j=_.computeDiff(T,D,c),P=j.changes.length>0?!1:this.n(r,l);function I(F){return F.map(y=>[y.original.startLineNumber,y.original.endLineNumberExclusive,y.modified.startLineNumber,y.modified.endLineNumberExclusive,y.innerChanges?.map(W=>[W.originalRange.startLineNumber,W.originalRange.startColumn,W.originalRange.endLineNumber,W.originalRange.endColumn,W.modifiedRange.startLineNumber,W.modifiedRange.startColumn,W.modifiedRange.endLineNumber,W.modifiedRange.endColumn])])}return{identical:P,quitEarly:j.hitTimeout,changes:I(j.changes),moves:j.moves.map(F=>[F.lineRangeMapping.original.startLineNumber,F.lineRangeMapping.original.endLineNumberExclusive,F.lineRangeMapping.modified.startLineNumber,F.lineRangeMapping.modified.endLineNumberExclusive,I(F.changes)])}}static n(r,l){const c=r.getLineCount(),M=l.getLineCount();if(c!==M)return!1;for(let _=1;_<=c;_++){const T=r.getLineContent(_),D=l.getLineContent(_);if(T!==D)return!1}return!0}async computeDirtyDiff(r,l,c){const M=this.j(r),_=this.j(l);if(!M||!_)return null;const T=M.getLinesContent(),D=_.getLinesContent();return new d.$bu(T,D,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:c,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(r,l,c){const M=this.j(r);if(!M)return l;const _=[];let T;l=l.slice(0).sort((j,P)=>{if(j.range&&P.range)return h.$Ot.compareRangesUsingStarts(j.range,P.range);const I=j.range?0:1,F=P.range?0:1;return I-F});let D=0;for(let j=1;j<l.length;j++)h.$Ot.getEndPosition(l[D].range).equals(h.$Ot.getStartPosition(l[j].range))?(l[D].range=h.$Ot.fromPositions(h.$Ot.getStartPosition(l[D].range),h.$Ot.getEndPosition(l[j].range)),l[D].text+=l[j].text):(D++,l[D]=l[j]);l.length=D+1;for(let{range:j,text:P,eol:I}of l){if(typeof I=="number"&&(T=I),h.$Ot.isEmpty(j)&&!P)continue;const F=M.getValueInRange(j);if(P=P.replace(/\r\n|\n|\r/g,M.eol),F===P)continue;if(Math.max(P.length,F.length)>R.o){_.push({range:j,text:P});continue}const y=(0,t.$Tt)(F,P,c),W=M.offsetAt(h.$Ot.lift(j).getStartPosition());for(const B of y){const O=M.positionAt(W+B.originalStart),X=M.positionAt(W+B.originalStart+B.originalLength),Y={text:P.substr(B.modifiedStart,B.modifiedLength),range:{startLineNumber:O.lineNumber,startColumn:O.column,endLineNumber:X.lineNumber,endColumn:X.column}};M.getValueInRange(Y.range)!==Y.text&&_.push(Y)}}return typeof T=="number"&&_.push({eol:T,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),_}computeHumanReadableDiff(r,l,c){const M=this.j(r);if(!M)return l;const _=[];let T;l=l.slice(0).sort((D,j)=>{if(D.range&&j.range)return h.$Ot.compareRangesUsingStarts(D.range,j.range);const P=D.range?0:1,I=j.range?0:1;return P-I});for(let{range:D,text:j,eol:P}of l){let O=function(Y,z){return new p.$Nt(Y.lineNumber+z.lineNumber-1,z.lineNumber===1?Y.column+z.column-1:z.column)},X=function(Y,z){const Q=[];for(let ee=z.startLineNumber;ee<=z.endLineNumber;ee++){const k=Y[ee-1];ee===z.startLineNumber&&ee===z.endLineNumber?Q.push(k.substring(z.startColumn-1,z.endColumn-1)):ee===z.startLineNumber?Q.push(k.substring(z.startColumn-1)):ee===z.endLineNumber?Q.push(k.substring(0,z.endColumn-1)):Q.push(k)}return Q};if(typeof P=="number"&&(T=P),h.$Ot.isEmpty(D)&&!j)continue;const I=M.getValueInRange(D);if(j=j.replace(/\r\n|\n|\r/g,M.eol),I===j)continue;if(Math.max(j.length,I.length)>R.o){_.push({range:D,text:j});continue}const F=I.split(/\r\n|\n|\r/),y=j.split(/\r\n|\n|\r/),W=e.$74.getDefault().computeDiff(F,y,c),B=h.$Ot.lift(D).getStartPosition();for(const Y of W.changes)if(Y.innerChanges)for(const z of Y.innerChanges)_.push({range:h.$Ot.fromPositions(O(B,z.originalRange.getStartPosition()),O(B,z.originalRange.getEndPosition())),text:X(y,z.modifiedRange).join(M.eol)});else throw new L.$bb("The experimental diff algorithm always produces inner changes")}return typeof T=="number"&&_.push({eol:T,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),_}async computeLinks(r){const l=this.j(r);return l?(0,a.$H4)(l):null}async computeDefaultDocumentColors(r){const l=this.j(r);return l?(0,A.$84)(l):null}static{this.p=1e4}async textualSuggest(r,l,c,M){const _=new $.$fe,T=new RegExp(c,M),D=new Set;e:for(const j of r){const P=this.j(j);if(P){for(const I of P.words(T))if(!(I===l||!isNaN(Number(I)))&&(D.add(I),D.size>R.p))break e}}return{words:Array.from(D),duration:_.elapsed()}}async computeWordRanges(r,l,c,M){const _=this.j(r);if(!_)return Object.create(null);const T=new RegExp(c,M),D=Object.create(null);for(let j=l.startLineNumber;j<l.endLineNumber;j++){const P=_.getLineWords(j,T);for(const I of P){if(!isNaN(Number(I.word)))continue;let F=D[I.word];F||(F=[],D[I.word]=F),F.push({startLineNumber:j,startColumn:I.startColumn,endLineNumber:j,endColumn:I.endColumn})}}return D}async navigateValueSet(r,l,c,M,_){const T=this.j(r);if(!T)return null;const D=new RegExp(M,_);l.startColumn===l.endColumn&&(l={startLineNumber:l.startLineNumber,startColumn:l.startColumn,endLineNumber:l.endLineNumber,endColumn:l.endColumn+1});const j=T.getValueInRange(l),P=T.getWordAtPosition({lineNumber:l.startLineNumber,column:l.startColumn},D);if(!P)return null;const I=T.getValueInRange(P);return u.$I4.INSTANCE.navigateValueSet(l,j,P,I,c)}loadForeignModule(r,l,c){const M=(D,j)=>this.d.fhr(D,j),T={host:(0,w.$po)(c,M),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(T,l),Promise.resolve((0,w.$oo)(this.h))):new Promise((D,j)=>{x([r],P=>{this.h=P.create(T,l),D((0,w.$oo)(this.h))},j)})}fmr(r,l){if(!this.h||typeof this.h[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this.h[r].apply(this.h,l))}catch(c){return Promise.reject(c)}}}i.EditorSimpleWorker=R;function b(o){return new R(o,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,f.$K4)())})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/1d82f317af9c90b96a433fd6a599e4b1d31869a3/core/vs/base/worker/workerMain.js.map
