/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ce=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/platform/files/common/files","vs/base/common/errors","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/strings","fs","os","vs/platform/product/common/productService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/extpath","vs/base/common/uuid","vs/platform/state/node/state","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/process","vs/base/common/objects","vs/platform/environment/common/environment","vs/base/common/charCode","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/labels","child_process","vs/platform/request/common/request","vs/platform/update/common/update","vs/platform/window/common/window","vs/platform/window/electron-main/window","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/storage/common/storage","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminal","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/processes","vs/base/common/codicons","vs/base/common/severity","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/marshallingIds","crypto","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ports","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/native/electron-main/auth","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonSchema","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/uint","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/issue/electron-main/processMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","string_decoder","vs/base/common/jsonc","vs/code/electron-main/main"],le=function(x){for(var e=[],n=0,r=x.length;n<r;n++)e[n]=ce[x[n]];return e};define(ce[138],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=n,e.$fb=r,e.$gb=k,e.$hb=R,e.$ib=T,e.$jb=I,e.$kb=p,e.$mb=m,e.$nb=u,e.$ob=d,e.$pb=w,e.$qb=f;function n(g,v){const b=r(g,v);if(b!==-1)return g[b]}function r(g,v,b=g.length-1){for(let $=b;$>=0;$--){const P=g[$];if(v(P))return $}return-1}function k(g,v){const b=R(g,v);return b===-1?void 0:g[b]}function R(g,v,b=0,$=g.length){let P=b,E=$;for(;P<E;){const i=Math.floor((P+E)/2);v(g[i])?P=i+1:E=i}return P-1}function T(g,v){const b=I(g,v);return b===g.length?void 0:g[b]}function I(g,v,b=0,$=g.length){let P=b,E=$;for(;P<E;){const i=Math.floor((P+E)/2);v(g[i])?E=i:P=i+1}return P}function p(g,v,b=0,$=g.length){const P=I(g,v,b,$);return P===g.length?-1:P}class c{static{this.assertInvariants=!1}constructor(v){this.e=v,this.c=0}findLastMonotonous(v){if(c.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!v($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=v}const b=R(this.e,v,this.c);return this.c=b+1,b===-1?void 0:this.e[b]}}e.$lb=c;function m(g,v){if(g.length===0)return;let b=g[0];for(let $=1;$<g.length;$++){const P=g[$];v(P,b)>0&&(b=P)}return b}function u(g,v){if(g.length===0)return;let b=g[0];for(let $=1;$<g.length;$++){const P=g[$];v(P,b)>=0&&(b=P)}return b}function d(g,v){return m(g,(b,$)=>-v(b,$))}function w(g,v){if(g.length===0)return-1;let b=0;for(let $=1;$<g.length;$++){const P=g[$];v(P,g[b])>0&&(b=$)}return b}function f(g,v){for(const b of g){const $=v(b);if($!==void 0)return $}}}),define(ce[39],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var n;(function(r){r[r.Null=0]="Null",r[r.Backspace=8]="Backspace",r[r.Tab=9]="Tab",r[r.LineFeed=10]="LineFeed",r[r.CarriageReturn=13]="CarriageReturn",r[r.Space=32]="Space",r[r.ExclamationMark=33]="ExclamationMark",r[r.DoubleQuote=34]="DoubleQuote",r[r.Hash=35]="Hash",r[r.DollarSign=36]="DollarSign",r[r.PercentSign=37]="PercentSign",r[r.Ampersand=38]="Ampersand",r[r.SingleQuote=39]="SingleQuote",r[r.OpenParen=40]="OpenParen",r[r.CloseParen=41]="CloseParen",r[r.Asterisk=42]="Asterisk",r[r.Plus=43]="Plus",r[r.Comma=44]="Comma",r[r.Dash=45]="Dash",r[r.Period=46]="Period",r[r.Slash=47]="Slash",r[r.Digit0=48]="Digit0",r[r.Digit1=49]="Digit1",r[r.Digit2=50]="Digit2",r[r.Digit3=51]="Digit3",r[r.Digit4=52]="Digit4",r[r.Digit5=53]="Digit5",r[r.Digit6=54]="Digit6",r[r.Digit7=55]="Digit7",r[r.Digit8=56]="Digit8",r[r.Digit9=57]="Digit9",r[r.Colon=58]="Colon",r[r.Semicolon=59]="Semicolon",r[r.LessThan=60]="LessThan",r[r.Equals=61]="Equals",r[r.GreaterThan=62]="GreaterThan",r[r.QuestionMark=63]="QuestionMark",r[r.AtSign=64]="AtSign",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.OpenSquareBracket=91]="OpenSquareBracket",r[r.Backslash=92]="Backslash",r[r.CloseSquareBracket=93]="CloseSquareBracket",r[r.Caret=94]="Caret",r[r.Underline=95]="Underline",r[r.BackTick=96]="BackTick",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.OpenCurlyBrace=123]="OpenCurlyBrace",r[r.Pipe=124]="Pipe",r[r.CloseCurlyBrace=125]="CloseCurlyBrace",r[r.Tilde=126]="Tilde",r[r.NoBreakSpace=160]="NoBreakSpace",r[r.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",r[r.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",r[r.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",r[r.U_Combining_Tilde=771]="U_Combining_Tilde",r[r.U_Combining_Macron=772]="U_Combining_Macron",r[r.U_Combining_Overline=773]="U_Combining_Overline",r[r.U_Combining_Breve=774]="U_Combining_Breve",r[r.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",r[r.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",r[r.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",r[r.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",r[r.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",r[r.U_Combining_Caron=780]="U_Combining_Caron",r[r.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",r[r.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",r[r.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",r[r.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",r[r.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",r[r.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",r[r.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",r[r.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",r[r.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",r[r.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",r[r.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",r[r.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",r[r.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",r[r.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",r[r.U_Combining_Horn=795]="U_Combining_Horn",r[r.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",r[r.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",r[r.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",r[r.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",r[r.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",r[r.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",r[r.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",r[r.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",r[r.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",r[r.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",r[r.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",r[r.U_Combining_Cedilla=807]="U_Combining_Cedilla",r[r.U_Combining_Ogonek=808]="U_Combining_Ogonek",r[r.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",r[r.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",r[r.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",r[r.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",r[r.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",r[r.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",r[r.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",r[r.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",r[r.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",r[r.U_Combining_Low_Line=818]="U_Combining_Low_Line",r[r.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",r[r.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",r[r.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",r[r.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",r[r.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",r[r.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",r[r.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",r[r.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",r[r.U_Combining_Square_Below=827]="U_Combining_Square_Below",r[r.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",r[r.U_Combining_X_Above=829]="U_Combining_X_Above",r[r.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",r[r.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",r[r.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",r[r.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",r[r.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",r[r.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",r[r.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",r[r.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",r[r.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",r[r.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",r[r.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",r[r.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",r[r.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",r[r.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",r[r.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",r[r.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",r[r.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",r[r.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",r[r.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",r[r.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",r[r.U_Combining_Fermata=850]="U_Combining_Fermata",r[r.U_Combining_X_Below=851]="U_Combining_X_Below",r[r.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",r[r.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",r[r.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",r[r.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",r[r.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",r[r.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",r[r.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",r[r.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",r[r.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",r[r.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",r[r.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",r[r.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",r[r.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",r[r.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",r[r.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",r[r.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",r[r.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",r[r.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",r[r.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",r[r.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",r[r.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",r[r.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",r[r.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",r[r.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",r[r.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",r[r.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",r[r.LINE_SEPARATOR=8232]="LINE_SEPARATOR",r[r.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",r[r.NEXT_LINE=133]="NEXT_LINE",r[r.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",r[r.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",r[r.U_DIAERESIS=168]="U_DIAERESIS",r[r.U_MACRON=175]="U_MACRON",r[r.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",r[r.U_CEDILLA=184]="U_CEDILLA",r[r.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",r[r.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",r[r.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",r[r.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",r[r.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",r[r.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",r[r.U_BREVE=728]="U_BREVE",r[r.U_DOT_ABOVE=729]="U_DOT_ABOVE",r[r.U_RING_ABOVE=730]="U_RING_ABOVE",r[r.U_OGONEK=731]="U_OGONEK",r[r.U_SMALL_TILDE=732]="U_SMALL_TILDE",r[r.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",r[r.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",r[r.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",r[r.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",r[r.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",r[r.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",r[r.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",r[r.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",r[r.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",r[r.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",r[r.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",r[r.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",r[r.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",r[r.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",r[r.U_GREEK_TONOS=900]="U_GREEK_TONOS",r[r.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",r[r.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",r[r.U_GREEK_PSILI=8127]="U_GREEK_PSILI",r[r.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",r[r.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",r[r.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",r[r.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",r[r.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",r[r.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",r[r.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",r[r.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",r[r.U_GREEK_VARIA=8175]="U_GREEK_VARIA",r[r.U_GREEK_OXIA=8189]="U_GREEK_OXIA",r[r.U_GREEK_DASIA=8190]="U_GREEK_DASIA",r[r.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",r[r.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",r[r.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",r[r.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",r[r.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",r[r.U_OVERLINE=8254]="U_OVERLINE",r[r.UTF8_BOM=65279]="UTF8_BOM",r[r.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",r[r.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(n||(e.CharCode=n={}))}),define(ce[139],le([0,1]),function(x,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=r,e.$d=k,e.$e=R,e.$f=T;function r(p,c){const m=Object.create(null);for(const u of p){const d=c(u);let w=m[d];w||(w=m[d]=[]),w.push(u)}return m}function k(p,c){const m=[],u=[];for(const d of p)c.has(d)||m.push(d);for(const d of c)p.has(d)||u.push(d);return{removed:m,added:u}}function R(p,c){const m=[],u=[];for(const[d,w]of p)c.has(d)||m.push(w);for(const[d,w]of c)p.has(d)||u.push(w);return{removed:m,added:u}}function T(p,c){const m=new Set;for(const u of c)p.has(u)&&m.add(u);return m}class I{static{n=Symbol.toStringTag}constructor(c,m){this.b=m,this.a=new Map,this[n]="SetWithKey";for(const u of c)this.add(u)}get size(){return this.a.size}add(c){const m=this.b(c);return this.a.set(m,c),this}delete(c){return this.a.delete(this.b(c))}has(c){return this.a.has(this.b(c))}*entries(){for(const c of this.a.values())yield[c,c]}keys(){return this.values()}*values(){for(const c of this.a.values())yield c}clear(){this.a.clear()}forEach(c,m){this.a.forEach(u=>c.call(m,u,u,this))}[Symbol.iterator](){return this.values()}}e.$g=I}),define(ce[140],le([0,1,39]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=e.$nu=e.$mu=e.$lu=void 0;function r(p,c){const m=Math.pow(10,c);return Math.round(p*m)/m}class k{constructor(c,m,u,d=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,u))|0,this.a=r(Math.max(Math.min(1,d),0),3)}static equals(c,m){return c.r===m.r&&c.g===m.g&&c.b===m.b&&c.a===m.a}}e.$lu=k;class R{constructor(c,m,u,d){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=r(Math.max(Math.min(1,m),0),3),this.l=r(Math.max(Math.min(1,u),0),3),this.a=r(Math.max(Math.min(1,d),0),3)}static equals(c,m){return c.h===m.h&&c.s===m.s&&c.l===m.l&&c.a===m.a}static fromRGBA(c){const m=c.r/255,u=c.g/255,d=c.b/255,w=c.a,f=Math.max(m,u,d),g=Math.min(m,u,d);let v=0,b=0;const $=(g+f)/2,P=f-g;if(P>0){switch(b=Math.min($<=.5?P/(2*$):P/(2-2*$),1),f){case m:v=(u-d)/P+(u<d?6:0);break;case u:v=(d-m)/P+2;break;case d:v=(m-u)/P+4;break}v*=60,v=Math.round(v)}return new R(v,b,$,w)}static i(c,m,u){return u<0&&(u+=1),u>1&&(u-=1),u<1/6?c+(m-c)*6*u:u<1/2?m:u<2/3?c+(m-c)*(2/3-u)*6:c}static toRGBA(c){const m=c.h/360,{s:u,l:d,a:w}=c;let f,g,v;if(u===0)f=g=v=d;else{const b=d<.5?d*(1+u):d+u-d*u,$=2*d-b;f=R.i($,b,m+1/3),g=R.i($,b,m),v=R.i($,b,m-1/3)}return new k(Math.round(f*255),Math.round(g*255),Math.round(v*255),w)}}e.$mu=R;class T{constructor(c,m,u,d){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=r(Math.max(Math.min(1,m),0),3),this.v=r(Math.max(Math.min(1,u),0),3),this.a=r(Math.max(Math.min(1,d),0),3)}static equals(c,m){return c.h===m.h&&c.s===m.s&&c.v===m.v&&c.a===m.a}static fromRGBA(c){const m=c.r/255,u=c.g/255,d=c.b/255,w=Math.max(m,u,d),f=Math.min(m,u,d),g=w-f,v=w===0?0:g/w;let b;return g===0?b=0:w===m?b=((u-d)/g%6+6)%6:w===u?b=(d-m)/g+2:b=(m-u)/g+4,new T(Math.round(b*60),v,w,c.a)}static toRGBA(c){const{h:m,s:u,v:d,a:w}=c,f=d*u,g=f*(1-Math.abs(m/60%2-1)),v=d-f;let[b,$,P]=[0,0,0];return m<60?(b=f,$=g):m<120?(b=g,$=f):m<180?($=f,P=g):m<240?($=g,P=f):m<300?(b=g,P=f):m<=360&&(b=f,P=g),b=Math.round((b+v)*255),$=Math.round(($+v)*255),P=Math.round((P+v)*255),new k(b,$,P,w)}}e.$nu=T;class I{static fromHex(c){return I.Format.CSS.parseHex(c)||I.red}static equals(c,m){return!c&&!m?!0:!c||!m?!1:c.equals(m)}get hsla(){return this.i?this.i:R.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:T.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof k)this.rgba=c;else if(c instanceof R)this.i=c,this.rgba=R.toRGBA(c);else if(c instanceof T)this.j=c,this.rgba=T.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&k.equals(this.rgba,c.rgba)&&R.equals(this.hsla,c.hsla)&&T.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=I.k(this.rgba.r),m=I.k(this.rgba.g),u=I.k(this.rgba.b),d=.2126*c+.7152*m+.0722*u;return r(d,4)}static k(c){const m=c/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(c){const m=this.getRelativeLuminance(),u=c.getRelativeLuminance();return m>u?(m+.05)/(u+.05):(u+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const m=this.getRelativeLuminance(),u=c.getRelativeLuminance();return m>u}isDarkerThan(c){const m=this.getRelativeLuminance(),u=c.getRelativeLuminance();return m<u}lighten(c){return new I(new R(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new I(new R(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:m,g:u,b:d,a:w}=this.rgba;return new I(new k(m,u,d,w*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new I(new k(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const m=c.rgba,u=this.rgba.a,d=m.a,w=u+d*(1-u);if(w<1e-6)return I.transparent;const f=this.rgba.r*u/w+m.r*d*(1-u)/w,g=this.rgba.g*u/w+m.g*d*(1-u)/w,v=this.rgba.b*u/w+m.b*d*(1-u)/w;return new I(new k(f,g,v,w))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:m,g:u,b:d,a:w}=this.rgba;return new I(new k(c.rgba.r-w*(c.rgba.r-m),c.rgba.g-w*(c.rgba.g-u),c.rgba.b-w*(c.rgba.b-d),1))}flatten(...c){const m=c.reduceRight((u,d)=>I.o(d,u));return I.o(this,m)}static o(c,m){const u=1-c.rgba.a;return new I(new k(u*m.rgba.r+c.rgba.a*c.rgba.r,u*m.rgba.g+c.rgba.a*c.rgba.g,u*m.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this.u||(this.u=I.Format.CSS.format(this)),this.u}static getLighterColor(c,m,u){if(c.isLighterThan(m))return c;u=u||.5;const d=c.getRelativeLuminance(),w=m.getRelativeLuminance();return u=u*(w-d)/w,c.lighten(u)}static getDarkerColor(c,m,u){if(c.isDarkerThan(m))return c;u=u||.5;const d=c.getRelativeLuminance(),w=m.getRelativeLuminance();return u=u*(d-w)/d,c.darken(u)}static{this.white=new I(new k(255,255,255,1))}static{this.black=new I(new k(0,0,0,1))}static{this.red=new I(new k(255,0,0,1))}static{this.blue=new I(new k(0,0,255,1))}static{this.green=new I(new k(0,255,0,1))}static{this.cyan=new I(new k(0,255,255,1))}static{this.lightgrey=new I(new k(211,211,211,1))}static{this.transparent=new I(new k(0,0,0,0))}}e.$ou=I,function(p){let c;(function(m){let u;(function(d){function w(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:p.Format.CSS.formatRGBA(t)}d.formatRGB=w;function f(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}d.formatRGBA=f;function g(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:p.Format.CSS.formatHSLA(t)}d.formatHSL=g;function v(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}d.formatHSLA=v;function b(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function $(t){return`#${b(t.rgba.r)}${b(t.rgba.g)}${b(t.rgba.b)}`}d.formatHex=$;function P(t,o=!1){return o&&t.rgba.a===1?p.Format.CSS.formatHex(t):`#${b(t.rgba.r)}${b(t.rgba.g)}${b(t.rgba.b)}${b(Math.round(t.rgba.a*255))}`}d.formatHexA=P;function E(t){return t.isOpaque()?p.Format.CSS.formatHex(t):p.Format.CSS.formatRGBA(t)}d.format=E;function i(t){const o=t.length;if(o===0||t.charCodeAt(0)!==n.CharCode.Hash)return null;if(o===7){const s=16*h(t.charCodeAt(1))+h(t.charCodeAt(2)),a=16*h(t.charCodeAt(3))+h(t.charCodeAt(4)),l=16*h(t.charCodeAt(5))+h(t.charCodeAt(6));return new p(new k(s,a,l,1))}if(o===9){const s=16*h(t.charCodeAt(1))+h(t.charCodeAt(2)),a=16*h(t.charCodeAt(3))+h(t.charCodeAt(4)),l=16*h(t.charCodeAt(5))+h(t.charCodeAt(6)),S=16*h(t.charCodeAt(7))+h(t.charCodeAt(8));return new p(new k(s,a,l,S/255))}if(o===4){const s=h(t.charCodeAt(1)),a=h(t.charCodeAt(2)),l=h(t.charCodeAt(3));return new p(new k(16*s+s,16*a+a,16*l+l))}if(o===5){const s=h(t.charCodeAt(1)),a=h(t.charCodeAt(2)),l=h(t.charCodeAt(3)),S=h(t.charCodeAt(4));return new p(new k(16*s+s,16*a+a,16*l+l,(16*S+S)/255))}return null}d.parseHex=i;function h(t){switch(t){case n.CharCode.Digit0:return 0;case n.CharCode.Digit1:return 1;case n.CharCode.Digit2:return 2;case n.CharCode.Digit3:return 3;case n.CharCode.Digit4:return 4;case n.CharCode.Digit5:return 5;case n.CharCode.Digit6:return 6;case n.CharCode.Digit7:return 7;case n.CharCode.Digit8:return 8;case n.CharCode.Digit9:return 9;case n.CharCode.a:return 10;case n.CharCode.A:return 10;case n.CharCode.b:return 11;case n.CharCode.B:return 11;case n.CharCode.c:return 12;case n.CharCode.C:return 12;case n.CharCode.d:return 13;case n.CharCode.D:return 13;case n.CharCode.e:return 14;case n.CharCode.E:return 14;case n.CharCode.f:return 15;case n.CharCode.F:return 15}return 0}})(u=m.CSS||(m.CSS={}))})(c=p.Format||(p.Format={}))}(I||(e.$ou=I={}))}),define(ce[54],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=r,e.$$h=k,e.$_h=R;function n(T){return(I,p,c)=>{let m=null,u=null;if(typeof c.value=="function"?(m="value",u=c.value):typeof c.get=="function"&&(m="get",u=c.get),!u)throw new Error("not supported");c[m]=T(u,p)}}function r(T,I,p){let c=null,m=null;if(typeof p.value=="function"?(c="value",m=p.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(c="get",m=p.get),!m)throw new Error("not supported");const u=`$memoize$${I}`;p[c]=function(...d){return this.hasOwnProperty(u)||Object.defineProperty(this,u,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,d)}),this[u]}}function k(T,I,p){return n((c,m)=>{const u=`$debounce$${m}`,d=`$debounce$result$${m}`;return function(...w){this[d]||(this[d]=p?p():void 0),clearTimeout(this[u]),I&&(this[d]=I(this[d],...w),w=[this[d]]),this[u]=setTimeout(()=>{c.apply(this,w),this[d]=p?p():void 0},T)}})}function R(T,I,p){return n((c,m)=>{const u=`$throttle$timer$${m}`,d=`$throttle$result$${m}`,w=`$throttle$lastRun$${m}`,f=`$throttle$pending$${m}`;return function(...g){if(this[d]||(this[d]=p?p():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),I&&(this[d]=I(this[d],...g)),this[f])return;const v=this[w]+T;v<=Date.now()?(this[w]=Date.now(),c.apply(this,[this[d]]),this[d]=p?p():void 0):(this[f]=!0,this[u]=setTimeout(()=>{this[f]=!1,this[w]=Date.now(),c.apply(this,[this[d]]),this[d]=p?p():void 0},v-Date.now()))}})}}),define(ce[15],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=r,e.$X=k,e.$Y=R,e.$Z=T,e.$1=I,e.$2=p,e.$3=m,e.$5=d,e.$6=w,e.$7=f,e.$9=v;class n{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?E.isErrorNoTelemetry(t)?new E(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=n,e.$V=new n;function r(h){e.$V.setUnexpectedErrorHandler(h)}function k(h){if(!h||typeof h!="object")return!1;const t=h;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(h){m(h)||e.$V.onUnexpectedError(h)}function T(h){m(h)||e.$V.onUnexpectedExternalError(h)}function I(h){if(h instanceof Error){const{name:t,message:o}=h,s=h.stacktrace||h.stack;return{$isError:!0,name:t,message:o,stack:s,noTelemetry:E.isErrorNoTelemetry(h)}}return h}function p(h){let t;return h.noTelemetry?t=new E:(t=new Error,t.name=h.name),t.message=h.message,t.stack=h.stack,t}const c="Canceled";function m(h){return h instanceof u?!0:h instanceof Error&&h.name===c&&h.message===c}class u extends Error{constructor(){super(c),this.name=this.message}}e.$4=u;function d(){const h=new Error(c);return h.name=h.message,h}function w(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}function f(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}class g extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=g;function v(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}class b extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$0=b;class $ extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$$=$;class P extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=P;class E extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof E)return t;const o=new E;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$ab=E;class i extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,i.prototype)}}e.$bb=i}),define(ce[21],le([0,1,15,138]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=k,e.$sb=R,e.$tb=T,e.$ub=I,e.$vb=p,e.$wb=c,e.$xb=m,e.$yb=u,e.$zb=d,e.$Ab=w,e.$Bb=f,e.$Cb=g,e.$Db=v,e.top=b,e.$Fb=$,e.$Gb=E,e.$Hb=i,e.$Ib=h,e.$Jb=t,e.$Kb=o,e.$Lb=s,e.$Mb=a,e.$Nb=l,e.$Ob=S,e.$Pb=y,e.$Qb=A,e.$Rb=L,e.$Sb=D,e.$Tb=O,e.$Ub=M,e.$Vb=Z,e.$Wb=q,e.$Xb=K,e.$Yb=de,e.$Zb=H,e.$1b=Y,e.$2b=B,e.$3b=Q,e.$4b=W,e.$5b=X,e.$6b=oe,e.$9b=re,e.$ac=_;function k(z,ie=0){return z[z.length-(1+ie)]}function R(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}function T(z,ie,G=(U,te)=>U===te){if(z===ie)return!0;if(!z||!ie||z.length!==ie.length)return!1;for(let U=0,te=z.length;U<te;U++)if(!G(z[U],ie[U]))return!1;return!0}function I(z,ie){const G=z.length-1;ie<G&&(z[ie]=z[G]),z.pop()}function p(z,ie,G){return c(z.length,U=>G(z[U],ie))}function c(z,ie){let G=0,U=z-1;for(;G<=U;){const te=(G+U)/2|0,he=ie(te);if(he<0)G=te+1;else if(he>0)U=te-1;else return te}return-(G+1)}function m(z,ie,G){if(z=z|0,z>=ie.length)throw new TypeError("invalid index");const U=ie[Math.floor(ie.length*Math.random())],te=[],he=[],me=[];for(const we of ie){const Ie=G(we,U);Ie<0?te.push(we):Ie>0?he.push(we):me.push(we)}return z<te.length?m(z,te,G):z<te.length+me.length?me[0]:m(z-(te.length+me.length),he,G)}function u(z,ie){const G=[];let U;for(const te of z.slice(0).sort(ie))!U||ie(U[0],te)!==0?(U=[te],G.push(U)):U.push(te);return G}function*d(z,ie){let G,U;for(const te of z)U!==void 0&&ie(U,te)?G.push(te):(G&&(yield G),G=[te]),U=te;G&&(yield G)}function w(z,ie){for(let G=0;G<=z.length;G++)ie(G===0?void 0:z[G-1],G===z.length?void 0:z[G])}function f(z,ie){for(let G=0;G<z.length;G++)ie(G===0?void 0:z[G-1],z[G],G+1===z.length?void 0:z[G+1])}function g(z,ie,G){const U=[];function te(we,Ie,Ce){if(Ie===0&&Ce.length===0)return;const Ae=U[U.length-1];Ae&&Ae.start+Ae.deleteCount===we?(Ae.deleteCount+=Ie,Ae.toInsert.push(...Ce)):U.push({start:we,deleteCount:Ie,toInsert:Ce})}let he=0,me=0;for(;;){if(he===z.length){te(he,0,ie.slice(me));break}if(me===ie.length){te(he,z.length-he,[]);break}const we=z[he],Ie=ie[me],Ce=G(we,Ie);Ce===0?(he+=1,me+=1):Ce<0?(te(he,1,[]),he+=1):Ce>0&&(te(he,0,[Ie]),me+=1)}return U}function v(z,ie,G){const U=g(z,ie,G),te=[],he=[];for(const me of U)te.push(...z.slice(me.start,me.start+me.deleteCount)),he.push(...me.toInsert);return{removed:te,added:he}}function b(z,ie,G){if(G===0)return[];const U=z.slice(0,G).sort(ie);return P(z,ie,U,G,z.length),U}function $(z,ie,G,U,te){return G===0?Promise.resolve([]):new Promise((he,me)=>{(async()=>{const we=z.length,Ie=z.slice(0,G).sort(ie);for(let Ce=G,Ae=Math.min(G+U,we);Ce<we;Ce=Ae,Ae=Math.min(Ae+U,we)){if(Ce>G&&await new Promise(ve=>setTimeout(ve)),te&&te.isCancellationRequested)throw new n.$4;P(z,ie,Ie,Ce,Ae)}return Ie})().then(he,me)})}function P(z,ie,G,U,te){for(const he=G.length;U<te;U++){const me=z[U];if(ie(me,G[he-1])<0){G.pop();const we=(0,r.$jb)(G,Ie=>ie(me,Ie)<0);G.splice(we,0,me)}}}function E(z){return z.filter(ie=>!!ie)}function i(z){let ie=0;for(let G=0;G<z.length;G++)z[G]&&(z[ie]=z[G],ie+=1);z.length=ie}function h(z,ie,G){z.splice(G,0,z.splice(ie,1)[0])}function t(z){return!Array.isArray(z)||z.length===0}function o(z){return Array.isArray(z)&&z.length>0}function s(z,ie=G=>G){const G=new Set;return z.filter(U=>{const te=ie(U);return G.has(te)?!1:(G.add(te),!0)})}function a(z){const ie=new Set;return G=>{const U=z(G);return ie.has(U)?!1:(ie.add(U),!0)}}function l(z,ie){return z.length>0?z[0]:ie}function S(z,ie){return z.length>0?z[z.length-1]:ie}function y(z,ie,G=(U,te)=>U===te){let U=0;for(let te=0,he=Math.min(z.length,ie.length);te<he&&G(z[te],ie[te]);te++)U++;return U}function A(z,ie){let G=typeof ie=="number"?z:0;typeof ie=="number"?G=z:(G=0,ie=z);const U=[];if(G<=ie)for(let te=G;te<ie;te++)U.push(te);else for(let te=G;te>ie;te--)U.push(te);return U}function L(z,ie,G){return z.reduce((U,te)=>(U[ie(te)]=G?G(te):te,U),Object.create(null))}function D(z,ie){return z.push(ie),()=>O(z,ie)}function O(z,ie){const G=z.indexOf(ie);if(G>-1)return z.splice(G,1),ie}function M(z,ie,G){const U=z.slice(0,ie),te=z.slice(ie);return U.concat(G,te)}function Z(z,ie){let G;if(typeof ie=="number"){let U=ie;G=()=>{const te=Math.sin(U++)*179426549;return te-Math.floor(te)}}else G=Math.random;for(let U=z.length-1;U>0;U-=1){const te=Math.floor(G()*(U+1)),he=z[U];z[U]=z[te],z[te]=he}}function q(z,ie){const G=z.indexOf(ie);G>-1&&(z.splice(G,1),z.unshift(ie))}function K(z,ie){const G=z.indexOf(ie);G>-1&&(z.splice(G,1),z.push(ie))}function de(z,ie){for(const G of ie)z.push(G)}function H(z,ie){return Array.isArray(z)?z.map(ie):ie(z)}function Y(z){return Array.isArray(z)?z:[z]}function B(z){return z[Math.floor(Math.random()*z.length)]}function Q(z,ie,G){const U=j(z,ie),te=z.length,he=G.length;z.length=te+he;for(let me=te-1;me>=U;me--)z[me+he]=z[me];for(let me=0;me<he;me++)z[me+U]=G[me]}function W(z,ie,G,U){const te=j(z,ie);let he=z.splice(te,G);return he===void 0&&(he=[]),Q(z,te,U),he}function j(z,ie){return ie<0?Math.max(ie+z.length,0):Math.min(ie,z.length)}var C;(function(z){function ie(he){return he<0}z.isLessThan=ie;function G(he){return he<=0}z.isLessThanOrEqual=G;function U(he){return he>0}z.isGreaterThan=U;function te(he){return he===0}z.isNeitherLessOrGreaterThan=te,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(C||(e.CompareResult=C={}));function X(z,ie){return(G,U)=>ie(z(G),z(U))}function oe(...z){return(ie,G)=>{for(const U of z){const te=U(ie,G);if(!C.isNeitherLessOrGreaterThan(te))return te}return C.neitherLessOrGreaterThan}}const V=(z,ie)=>z-ie;e.$7b=V;const ue=(z,ie)=>(0,e.$7b)(z?1:0,ie?1:0);e.$8b=ue;function re(z){return(ie,G)=>-z(ie,G)}class J{constructor(ie){this.g=ie,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ie){let G=this.c;for(;G<this.g.length&&ie(this.g[G]);)G++;const U=G===this.c?null:this.g.slice(this.c,G);return this.c=G,U}takeFromEndWhile(ie){let G=this.d;for(;G>=0&&ie(this.g[G]);)G--;const U=G===this.d?null:this.g.slice(G+1,this.d+1);return this.d=G,U}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ie=this.g[this.c];return this.c++,ie}removeLast(){const ie=this.g[this.d];return this.d--,ie}takeCount(ie){const G=this.g.slice(this.c,this.c+ie);return this.c+=ie,G}}e.$0b=J;class F{static{this.empty=new F(ie=>{})}constructor(ie){this.iterate=ie}forEach(ie){this.iterate(G=>(ie(G),!0))}toArray(){const ie=[];return this.iterate(G=>(ie.push(G),!0)),ie}filter(ie){return new F(G=>this.iterate(U=>ie(U)?G(U):!0))}map(ie){return new F(G=>this.iterate(U=>G(ie(U))))}some(ie){let G=!1;return this.iterate(U=>(G=ie(U),!G)),G}findFirst(ie){let G;return this.iterate(U=>ie(U)?(G=U,!1):!0),G}findLast(ie){let G;return this.iterate(U=>(ie(U)&&(G=U),!0)),G}findLastMaxBy(ie){let G,U=!0;return this.iterate(te=>((U||C.isGreaterThan(ie(te,G)))&&(U=!1,G=te),!0)),G}}e.$$b=F;class N{constructor(ie){this.c=ie}static createSortPermutation(ie,G){const U=Array.from(ie.keys()).sort((te,he)=>G(ie[te],ie[he]));return new N(U)}apply(ie){return ie.map((G,U)=>ie[this.c[U]])}inverse(){const ie=this.c.slice();for(let G=0;G<this.c.length;G++)ie[this.c[G]]=G;return new N(ie)}}e.$_b=N;async function _(z,ie){return(await Promise.all(z.map(async(U,te)=>({element:U,ok:await ie(U,te)})))).find(U=>U.ok)?.element}}),define(ce[141],le([0,1,15]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=r,e.$ed=k,e.$fd=R,e.$gd=T,e.$hd=I,e.$id=p;function r(c,m){if(!c)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}function k(c,m="Unreachable"){throw new Error(m)}function R(c,m="unexpected state"){if(!c)throw new n.$bb(`Assertion Failed: ${m}`)}function T(c){c||(0,n.$Y)(new n.$bb("Soft Assertion Failed"))}function I(c){if(!c()){debugger;c(),(0,n.$Y)(new n.$bb("Assertion Failed"))}}function p(c,m){let u=0;for(;u<c.length-1;){const d=c[u],w=c[u+1];if(!m(d,w))return!1;u++}return!0}}),define(ce[89],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=n;function n(r,k){const R=this;let T=!1,I;return function(){if(T)return I;if(T=!0,k)try{I=r.apply(R,arguments)}finally{k()}else I=r.apply(R,arguments);return I}}}),define(ce[77],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(r){function k(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}r.is=k;const R=Object.freeze([]);function T(){return R}r.empty=T;function*I(t){yield t}r.single=I;function p(t){return k(t)?t:I(t)}r.wrap=p;function c(t){return t||R}r.from=c;function*m(t){for(let o=t.length-1;o>=0;o--)yield t[o]}r.reverse=m;function u(t){return!t||t[Symbol.iterator]().next().done===!0}r.isEmpty=u;function d(t){return t[Symbol.iterator]().next().value}r.first=d;function w(t,o){let s=0;for(const a of t)if(o(a,s++))return!0;return!1}r.some=w;function f(t,o){for(const s of t)if(o(s))return s}r.find=f;function*g(t,o){for(const s of t)o(s)&&(yield s)}r.filter=g;function*v(t,o){let s=0;for(const a of t)yield o(a,s++)}r.map=v;function*b(t,o){let s=0;for(const a of t)yield*o(a,s++)}r.flatMap=b;function*$(...t){for(const o of t)yield*o}r.concat=$;function P(t,o,s){let a=s;for(const l of t)a=o(a,l);return a}r.reduce=P;function*E(t,o,s=t.length){for(o<0&&(o+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);o<s;o++)yield t[o]}r.slice=E;function i(t,o=Number.POSITIVE_INFINITY){const s=[];if(o===0)return[s,t];const a=t[Symbol.iterator]();for(let l=0;l<o;l++){const S=a.next();if(S.done)return[s,r.empty()];s.push(S.value)}return[s,{[Symbol.iterator](){return a}}]}r.consume=i;async function h(t){const o=[];for await(const s of t)o.push(s);return Promise.resolve(o)}r.asyncToArray=h})(n||(e.Iterable=n={}))}),define(ce[43],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Wn=T,e.$Xn=u,e.$Yn=d,e.$Zn=w,e.$1n=f,e.$2n=g,e.$3n=v,e.$4n=b,e.$5n=$,e.$6n=P,e.$7n=E;var n;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var r;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(r||(e.SyntaxKind=r={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function T(i,h=!1){let t=0;const o=i.length;let s="",a=0,l=r.Unknown,S=n.None;function y(q){let K=0,de=0;for(;K<q;){const H=i.charCodeAt(t);if(H>=m._0&&H<=m._9)de=de*16+H-m._0;else if(H>=m.A&&H<=m.F)de=de*16+H-m.A+10;else if(H>=m.a&&H<=m.f)de=de*16+H-m.a+10;else break;t++,K++}return K<q&&(de=-1),de}function A(q){t=q,s="",a=0,l=r.Unknown,S=n.None}function L(){const q=t;if(i.charCodeAt(t)===m._0)t++;else for(t++;t<i.length&&c(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===m.dot)if(t++,t<i.length&&c(i.charCodeAt(t)))for(t++;t<i.length&&c(i.charCodeAt(t));)t++;else return S=n.UnexpectedEndOfNumber,i.substring(q,t);let K=t;if(t<i.length&&(i.charCodeAt(t)===m.E||i.charCodeAt(t)===m.e))if(t++,(t<i.length&&i.charCodeAt(t)===m.plus||i.charCodeAt(t)===m.minus)&&t++,t<i.length&&c(i.charCodeAt(t))){for(t++;t<i.length&&c(i.charCodeAt(t));)t++;K=t}else S=n.UnexpectedEndOfNumber;return i.substring(q,K)}function D(){let q="",K=t;for(;;){if(t>=o){q+=i.substring(K,t),S=n.UnexpectedEndOfString;break}const de=i.charCodeAt(t);if(de===m.doubleQuote){q+=i.substring(K,t),t++;break}if(de===m.backslash){if(q+=i.substring(K,t),t++,t>=o){S=n.UnexpectedEndOfString;break}switch(i.charCodeAt(t++)){case m.doubleQuote:q+='"';break;case m.backslash:q+="\\";break;case m.slash:q+="/";break;case m.b:q+="\b";break;case m.f:q+="\f";break;case m.n:q+=`
`;break;case m.r:q+="\r";break;case m.t:q+="	";break;case m.u:{const Y=y(4);Y>=0?q+=String.fromCharCode(Y):S=n.InvalidUnicode;break}default:S=n.InvalidEscapeCharacter}K=t;continue}if(de>=0&&de<=31)if(p(de)){q+=i.substring(K,t),S=n.UnexpectedEndOfString;break}else S=n.InvalidCharacter;t++}return q}function O(){if(s="",S=n.None,a=t,t>=o)return a=o,l=r.EOF;let q=i.charCodeAt(t);if(I(q)){do t++,s+=String.fromCharCode(q),q=i.charCodeAt(t);while(I(q));return l=r.Trivia}if(p(q))return t++,s+=String.fromCharCode(q),q===m.carriageReturn&&i.charCodeAt(t)===m.lineFeed&&(t++,s+=`
`),l=r.LineBreakTrivia;switch(q){case m.openBrace:return t++,l=r.OpenBraceToken;case m.closeBrace:return t++,l=r.CloseBraceToken;case m.openBracket:return t++,l=r.OpenBracketToken;case m.closeBracket:return t++,l=r.CloseBracketToken;case m.colon:return t++,l=r.ColonToken;case m.comma:return t++,l=r.CommaToken;case m.doubleQuote:return t++,s=D(),l=r.StringLiteral;case m.slash:{const K=t-1;if(i.charCodeAt(t+1)===m.slash){for(t+=2;t<o&&!p(i.charCodeAt(t));)t++;return s=i.substring(K,t),l=r.LineCommentTrivia}if(i.charCodeAt(t+1)===m.asterisk){t+=2;const de=o-1;let H=!1;for(;t<de;){if(i.charCodeAt(t)===m.asterisk&&i.charCodeAt(t+1)===m.slash){t+=2,H=!0;break}t++}return H||(t++,S=n.UnexpectedEndOfComment),s=i.substring(K,t),l=r.BlockCommentTrivia}return s+=String.fromCharCode(q),t++,l=r.Unknown}case m.minus:if(s+=String.fromCharCode(q),t++,t===o||!c(i.charCodeAt(t)))return l=r.Unknown;case m._0:case m._1:case m._2:case m._3:case m._4:case m._5:case m._6:case m._7:case m._8:case m._9:return s+=L(),l=r.NumericLiteral;default:for(;t<o&&M(q);)t++,q=i.charCodeAt(t);if(a!==t){switch(s=i.substring(a,t),s){case"true":return l=r.TrueKeyword;case"false":return l=r.FalseKeyword;case"null":return l=r.NullKeyword}return l=r.Unknown}return s+=String.fromCharCode(q),t++,l=r.Unknown}}function M(q){if(I(q)||p(q))return!1;switch(q){case m.closeBrace:case m.closeBracket:case m.openBrace:case m.openBracket:case m.doubleQuote:case m.colon:case m.comma:case m.slash:return!1}return!0}function Z(){let q;do q=O();while(q>=r.LineCommentTrivia&&q<=r.Trivia);return q}return{setPosition:A,getPosition:()=>t,scan:h?Z:O,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>t-a,getTokenError:()=>S}}function I(i){return i===m.space||i===m.tab||i===m.verticalTab||i===m.formFeed||i===m.nonBreakingSpace||i===m.ogham||i>=m.enQuad&&i<=m.zeroWidthSpace||i===m.narrowNoBreakSpace||i===m.mathematicalSpace||i===m.ideographicSpace||i===m.byteOrderMark}function p(i){return i===m.lineFeed||i===m.carriageReturn||i===m.lineSeparator||i===m.paragraphSeparator}function c(i){return i>=m._0&&i<=m._9}var m;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(m||(m={}));function u(i,h){const t=[],o=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function S(y,A,L,D){a.value=y,a.offset=A,a.length=L,a.type=D,a.colonOffset=void 0,s=a}try{P(i,{onObjectBegin:(y,A)=>{if(h<=y)throw o;s=void 0,l=h>y,t.push("")},onObjectProperty:(y,A,L)=>{if(h<A||(S(y,A,L,"property"),t[t.length-1]=y,h<=A+L))throw o},onObjectEnd:(y,A)=>{if(h<=y)throw o;s=void 0,t.pop()},onArrayBegin:(y,A)=>{if(h<=y)throw o;s=void 0,t.push(0)},onArrayEnd:(y,A)=>{if(h<=y)throw o;s=void 0,t.pop()},onLiteralValue:(y,A,L)=>{if(h<A||(S(y,A,L,E(y)),h<=A+L))throw o},onSeparator:(y,A,L)=>{if(h<=A)throw o;if(y===":"&&s&&s.type==="property")s.colonOffset=A,l=!1,s=void 0;else if(y===","){const D=t[t.length-1];typeof D=="number"?t[t.length-1]=D+1:(l=!0,t[t.length-1]=""),s=void 0}}})}catch(y){if(y!==o)throw y}return{path:t,previousNode:s,isAtPropertyKey:l,matches:y=>{let A=0;for(let L=0;A<y.length&&L<t.length;L++)if(y[A]===t[L]||y[A]==="*")A++;else if(y[A]!=="**")return!1;return A===y.length}}}function d(i,h=[],t=R.DEFAULT){let o=null,s=[];const a=[];function l(y){Array.isArray(s)?s.push(y):o!==null&&(s[o]=y)}return P(i,{onObjectBegin:()=>{const y={};l(y),a.push(s),s=y,o=null},onObjectProperty:y=>{o=y},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const y=[];l(y),a.push(s),s=y,o=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:l,onError:(y,A,L)=>{h.push({error:y,offset:A,length:L})}},t),s[0]}function w(i,h=[],t=R.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(y){o.type==="property"&&(o.length=y-o.offset,o=o.parent)}function a(y){return o.children.push(y),y}P(i,{onObjectBegin:y=>{o=a({type:"object",offset:y,length:-1,parent:o,children:[]})},onObjectProperty:(y,A,L)=>{o=a({type:"property",offset:A,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:y,offset:A,length:L,parent:o})},onObjectEnd:(y,A)=>{o.length=y+A-o.offset,o=o.parent,s(y+A)},onArrayBegin:(y,A)=>{o=a({type:"array",offset:y,length:-1,parent:o,children:[]})},onArrayEnd:(y,A)=>{o.length=y+A-o.offset,o=o.parent,s(y+A)},onLiteralValue:(y,A,L)=>{a({type:E(y),offset:A,length:L,parent:o,value:y}),s(A+L)},onSeparator:(y,A,L)=>{o.type==="property"&&(y===":"?o.colonOffset=A:y===","&&s(A))},onError:(y,A,L)=>{h.push({error:y,offset:A,length:L})}},t);const S=o.children[0];return S&&delete S.parent,S}function f(i,h){if(!i)return;let t=i;for(const o of h)if(typeof o=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const a of t.children)if(Array.isArray(a.children)&&a.children[0].value===o){t=a.children[1],s=!0;break}if(!s)return}else{const s=o;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}function g(i){if(!i.parent||!i.parent.children)return[];const h=g(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;h.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&h.push(t)}return h}function v(i){switch(i.type){case"array":return i.children.map(v);case"object":{const h=Object.create(null);for(const t of i.children){const o=t.children[1];o&&(h[t.children[0].value]=v(o))}return h}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function b(i,h,t=!1){return h>=i.offset&&h<i.offset+i.length||t&&h===i.offset+i.length}function $(i,h,t=!1){if(b(i,h,t)){const o=i.children;if(Array.isArray(o))for(let s=0;s<o.length&&o[s].offset<=h;s++){const a=$(o[s],h,t);if(a)return a}return i}}function P(i,h,t=R.DEFAULT){const o=T(i,!1);function s(X){return X?()=>X(o.getTokenOffset(),o.getTokenLength()):()=>!0}function a(X){return X?oe=>X(oe,o.getTokenOffset(),o.getTokenLength()):()=>!0}const l=s(h.onObjectBegin),S=a(h.onObjectProperty),y=s(h.onObjectEnd),A=s(h.onArrayBegin),L=s(h.onArrayEnd),D=a(h.onLiteralValue),O=a(h.onSeparator),M=s(h.onComment),Z=a(h.onError),q=t&&t.disallowComments,K=t&&t.allowTrailingComma;function de(){for(;;){const X=o.scan();switch(o.getTokenError()){case n.InvalidUnicode:H(k.InvalidUnicode);break;case n.InvalidEscapeCharacter:H(k.InvalidEscapeCharacter);break;case n.UnexpectedEndOfNumber:H(k.UnexpectedEndOfNumber);break;case n.UnexpectedEndOfComment:q||H(k.UnexpectedEndOfComment);break;case n.UnexpectedEndOfString:H(k.UnexpectedEndOfString);break;case n.InvalidCharacter:H(k.InvalidCharacter);break}switch(X){case r.LineCommentTrivia:case r.BlockCommentTrivia:q?H(k.InvalidCommentToken):M();break;case r.Unknown:H(k.InvalidSymbol);break;case r.Trivia:case r.LineBreakTrivia:break;default:return X}}}function H(X,oe=[],V=[]){if(Z(X),oe.length+V.length>0){let ue=o.getToken();for(;ue!==r.EOF;){if(oe.indexOf(ue)!==-1){de();break}else if(V.indexOf(ue)!==-1)break;ue=de()}}}function Y(X){const oe=o.getTokenValue();return X?D(oe):S(oe),de(),!0}function B(){switch(o.getToken()){case r.NumericLiteral:{let X=0;try{X=JSON.parse(o.getTokenValue()),typeof X!="number"&&(H(k.InvalidNumberFormat),X=0)}catch{H(k.InvalidNumberFormat)}D(X);break}case r.NullKeyword:D(null);break;case r.TrueKeyword:D(!0);break;case r.FalseKeyword:D(!1);break;default:return!1}return de(),!0}function Q(){return o.getToken()!==r.StringLiteral?(H(k.PropertyNameExpected,[],[r.CloseBraceToken,r.CommaToken]),!1):(Y(!1),o.getToken()===r.ColonToken?(O(":"),de(),C()||H(k.ValueExpected,[],[r.CloseBraceToken,r.CommaToken])):H(k.ColonExpected,[],[r.CloseBraceToken,r.CommaToken]),!0)}function W(){l(),de();let X=!1;for(;o.getToken()!==r.CloseBraceToken&&o.getToken()!==r.EOF;){if(o.getToken()===r.CommaToken){if(X||H(k.ValueExpected,[],[]),O(","),de(),o.getToken()===r.CloseBraceToken&&K)break}else X&&H(k.CommaExpected,[],[]);Q()||H(k.ValueExpected,[],[r.CloseBraceToken,r.CommaToken]),X=!0}return y(),o.getToken()!==r.CloseBraceToken?H(k.CloseBraceExpected,[r.CloseBraceToken],[]):de(),!0}function j(){A(),de();let X=!1;for(;o.getToken()!==r.CloseBracketToken&&o.getToken()!==r.EOF;){if(o.getToken()===r.CommaToken){if(X||H(k.ValueExpected,[],[]),O(","),de(),o.getToken()===r.CloseBracketToken&&K)break}else X&&H(k.CommaExpected,[],[]);C()||H(k.ValueExpected,[],[r.CloseBracketToken,r.CommaToken]),X=!0}return L(),o.getToken()!==r.CloseBracketToken?H(k.CloseBracketExpected,[r.CloseBracketToken],[]):de(),!0}function C(){switch(o.getToken()){case r.OpenBracketToken:return j();case r.OpenBraceToken:return W();case r.StringLiteral:return Y(!0);default:return B()}}return de(),o.getToken()===r.EOF?t.allowEmptyContent?!0:(H(k.ValueExpected,[],[]),!1):C()?(o.getToken()!==r.EOF&&H(k.EndOfFileExpected,[],[]),!0):(H(k.ValueExpected,[],[]),!1)}function E(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(ce[142],le([0,1,43]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=r,e.$9n=k,e.$0n=I,e.$$n=p;function r(c,m,u){let d,w,f,g,v;if(m){for(g=m.offset,v=g+m.length,f=g;f>0&&!p(c,f-1);)f--;let S=v;for(;S<c.length&&!p(c,S);)S++;w=c.substring(f,S),d=T(w,u)}else w=c,d=0,f=0,g=0,v=c.length;const b=I(u,c);let $=!1,P=0,E;u.insertSpaces?E=R(" ",u.tabSize||4):E="	";const i=(0,n.$Wn)(w,!1);let h=!1;function t(){return b+R(E,d+P)}function o(){let S=i.scan();for($=!1;S===n.SyntaxKind.Trivia||S===n.SyntaxKind.LineBreakTrivia;)$=$||S===n.SyntaxKind.LineBreakTrivia,S=i.scan();return h=S===n.SyntaxKind.Unknown||i.getTokenError()!==n.ScanError.None,S}const s=[];function a(S,y,A){!h&&y<v&&A>g&&c.substring(y,A)!==S&&s.push({offset:y,length:A-y,content:S})}let l=o();if(l!==n.SyntaxKind.EOF){const S=i.getTokenOffset()+f,y=R(E,d);a(y,f,S)}for(;l!==n.SyntaxKind.EOF;){let S=i.getTokenOffset()+i.getTokenLength()+f,y=o(),A="";for(;!$&&(y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia);){const D=i.getTokenOffset()+f;a(" ",S,D),S=i.getTokenOffset()+i.getTokenLength()+f,A=y===n.SyntaxKind.LineCommentTrivia?t():"",y=o()}if(y===n.SyntaxKind.CloseBraceToken)l!==n.SyntaxKind.OpenBraceToken&&(P--,A=t());else if(y===n.SyntaxKind.CloseBracketToken)l!==n.SyntaxKind.OpenBracketToken&&(P--,A=t());else{switch(l){case n.SyntaxKind.OpenBracketToken:case n.SyntaxKind.OpenBraceToken:P++,A=t();break;case n.SyntaxKind.CommaToken:case n.SyntaxKind.LineCommentTrivia:A=t();break;case n.SyntaxKind.BlockCommentTrivia:$?A=t():A=" ";break;case n.SyntaxKind.ColonToken:A=" ";break;case n.SyntaxKind.StringLiteral:if(y===n.SyntaxKind.ColonToken){A="";break}case n.SyntaxKind.NullKeyword:case n.SyntaxKind.TrueKeyword:case n.SyntaxKind.FalseKeyword:case n.SyntaxKind.NumericLiteral:case n.SyntaxKind.CloseBraceToken:case n.SyntaxKind.CloseBracketToken:y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia?A=" ":y!==n.SyntaxKind.CommaToken&&y!==n.SyntaxKind.EOF&&(h=!0);break;case n.SyntaxKind.Unknown:h=!0;break}$&&(y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia)&&(A=t())}const L=i.getTokenOffset()+f;a(A,S,L),l=y}return s}function k(c,m){const u=JSON.stringify(c,void 0,m.insertSpaces?m.tabSize||4:"	");return m.eol!==void 0?u.replace(/\r\n|\r|\n/g,m.eol):u}function R(c,m){let u="";for(let d=0;d<m;d++)u+=c;return u}function T(c,m){let u=0,d=0;const w=m.tabSize||4;for(;u<c.length;){const f=c.charAt(u);if(f===" ")d++;else if(f==="	")d+=w;else break;u++}return Math.floor(d/w)}function I(c,m){for(let u=0;u<m.length;u++){const d=m.charAt(u);if(d==="\r")return u+1<m.length&&m.charAt(u+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return c&&c.eol||`
`}function p(c,m){return`\r
`.indexOf(c.charAt(m))!==-1}}),define(ce[107],le([0,1,43,142]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=k,e.$ao=R,e.$bo=T,e.$co=I,e.$do=p;function k(c,m,u){return R(c,m,void 0,u)}function R(c,m,u,d,w){const f=m.slice(),g=[],v=(0,n.$Zn)(c,g);let b,$;for(;f.length>0&&($=f.pop(),b=(0,n.$1n)(v,f),b===void 0&&u!==void 0);)typeof $=="string"?u={[$]:u}:u=[u];if(b)if(b.type==="object"&&typeof $=="string"&&Array.isArray(b.children)){const P=(0,n.$1n)(b,[$]);if(P!==void 0)if(u===void 0){if(!P.parent)throw new Error("Malformed AST");const E=b.children.indexOf(P.parent);let i,h=P.parent.offset+P.parent.length;if(E>0){const t=b.children[E-1];i=t.offset+t.length}else i=b.offset+1,b.children.length>1&&(h=b.children[1].offset);return T(c,{offset:i,length:h-i,content:""},d)}else return T(c,{offset:P.offset,length:P.length,content:JSON.stringify(u)},d);else{if(u===void 0)return[];const E=`${JSON.stringify($)}: ${JSON.stringify(u)}`,i=w?w(b.children.map(t=>t.children[0].value)):b.children.length;let h;if(i>0){const t=b.children[i-1];h={offset:t.offset+t.length,length:0,content:","+E}}else b.children.length===0?h={offset:b.offset+1,length:0,content:E}:h={offset:b.offset+1,length:0,content:E+","};return T(c,h,d)}}else if(b.type==="array"&&typeof $=="number"&&Array.isArray(b.children))if(u!==void 0){const P=`${JSON.stringify(u)}`;let E;if(b.children.length===0||$===0)E={offset:b.offset+1,length:0,content:b.children.length===0?P:P+","};else{const i=$===-1||$>b.children.length?b.children.length:$,h=b.children[i-1];E={offset:h.offset+h.length,length:0,content:","+P}}return T(c,E,d)}else{const P=$,E=b.children[P];let i;if(b.children.length===1)i={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===P){const h=b.children[P-1],t=h.offset+h.length,o=b.offset+b.length;i={offset:t,length:o-2-t,content:""}}else i={offset:E.offset,length:b.children[P+1].offset-E.offset,content:""};return T(c,i,d)}else throw new Error(`Can not add ${typeof $!="number"?"index":"property"} to parent of type ${b.type}`);else return u===void 0?[]:T(c,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(u)},d)}function T(c,m,u){let d=I(c,m),w=m.offset,f=m.offset+m.content.length;if(m.length===0||m.content.length===0){for(;w>0&&!(0,r.$$n)(d,w-1);)w--;for(;f<d.length&&!(0,r.$$n)(d,f);)f++}const g=(0,r.$8n)(d,{offset:w,length:f-w},u);for(let b=g.length-1;b>=0;b--){const $=g[b];d=I(d,$),w=Math.min(w,$.offset),f=Math.max(f,$.offset+$.length),f+=$.content.length-$.length}const v=c.length-(d.length-f)-w;return[{offset:w,length:v,content:d.substring(w,f)}]}function I(c,m){return c.substring(0,m.offset)+m.content+c.substring(m.offset+m.length)}function p(c,m){const u=m.slice(0).sort((w,f)=>{const g=w.offset-f.offset;return g===0?w.length-f.length:g});let d=c.length;for(let w=u.length-1;w>=0;w--){const f=u[w];if(f.offset+f.length<=d)c=I(c,f);else throw new Error("Overlapping edit");d=f.offset}return c}}),define(ce[143],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=n;function n(R){let T=!1;const I=new Map,p=new Map;if(k(R,g=>{if(R===g)return!0;const v=JSON.stringify(g);if(v.length<30)return!0;const b=I.get(v);if(!b){const $={schemas:[g]};return I.set(v,$),p.set(g,$),!0}return b.schemas.push(g),p.set(g,b),T=!0,!1}),I.clear(),!T)return JSON.stringify(R);let m="$defs";for(;R.hasOwnProperty(m);)m+="_";const u=[];function d(g){return JSON.stringify(g,(v,b)=>{if(b!==g){const $=p.get(b);if($&&$.schemas.length>1)return $.id||($.id=`_${u.length}`,u.push($.schemas[0])),{$ref:`#/${m}/${$.id}`}}return b})}const w=d(R),f=[];for(let g=0;g<u.length;g++)f.push(`"_${g}":${d(u[g])}`);return f.length?`${w.substring(0,w.length-1)},"${m}":{${f.join(",")}}}`:w}function r(R){return typeof R=="object"&&R!==null}function k(R,T){if(!R||typeof R!="object")return;const I=(...w)=>{for(const f of w)r(f)&&u.push(f)},p=(...w)=>{for(const f of w)if(r(f))for(const g in f){const v=f[g];r(v)&&u.push(v)}},c=(...w)=>{for(const f of w)if(Array.isArray(f))for(const g of f)r(g)&&u.push(g)},m=w=>{if(Array.isArray(w))for(const f of w)r(f)&&u.push(f);else r(w)&&u.push(w)},u=[R];let d=u.pop();for(;d;)T(d)&&(I(d.additionalItems,d.additionalProperties,d.not,d.contains,d.propertyNames,d.if,d.then,d.else,d.unevaluatedItems,d.unevaluatedProperties),p(d.definitions,d.$defs,d.properties,d.patternProperties,d.dependencies,d.dependentSchemas),c(d.anyOf,d.allOf,d.oneOf,d.prefixItems),m(d.items)),d=u.pop()}}),function(){function x(){const e=/("[^"\\]*(?:\\.[^"\\]*)*")|('[^'\\]*(?:\\.[^'\\]*)*')|(\/\*[^\/\*]*(?:(?:\*|\/)[^\/\*]*)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))|(,\s*[}\]])/g;function n(k){return k.replace(e,function(R,T,I,p,c,m){if(p)return"";if(c){const u=c.length;return c[u-1]===`
`?c[u-2]==="\r"?`\r
`:`
`:""}else return m?R.substring(1):R})}function r(k){const R=n(k);try{return JSON.parse(R)}catch{const I=R.replace(/,\s*([}\]])/g,"$1");return JSON.parse(I)}}return{stripComments:n,parse:r}}typeof define=="function"?define("vs/base/common/jsonc",[],function(){return x()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=x():console.trace("jsonc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ce[65],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class n{constructor(k){this.d=k,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=n}),define(ce[108],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(R){this.element=R,this.next=n.Undefined,this.prev=n.Undefined}}class r{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let R=this.a;for(;R!==n.Undefined;){const T=R.next;R.prev=n.Undefined,R.next=n.Undefined,R=T}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,T){const I=new n(R);if(this.a===n.Undefined)this.a=I,this.b=I;else if(T){const c=this.b;this.b=I,I.prev=c,c.next=I}else{const c=this.a;this.a=I,I.next=c,c.prev=I}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(I))}}shift(){if(this.a!==n.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==n.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==n.Undefined&&R.next!==n.Undefined){const T=R.prev;T.next=R.next,R.next.prev=T}else R.prev===n.Undefined&&R.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):R.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):R.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==n.Undefined;)yield R.element,R=R.next}}e.$5c=r}),define(ce[31],le([0,1]),function(x,e){"use strict";var n,r,k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=R,e.$yc=T,e.$zc=I,e.$Ic=E;function R(i,h,t){let o=i.get(h);return o===void 0&&(o=t,i.set(h,o)),o}function T(i){const h=[];return i.forEach((t,o)=>{h.push(`${o} => ${t}`)}),`Map(${i.size}) {${h.join(", ")}}`}function I(i){const h=[];return i.forEach(t=>{h.push(t)}),`Set(${i.size}) {${h.join(", ")}}`}class p{constructor(h,t){this.uri=h,this.value=t}}function c(i){return Array.isArray(i)}class m{static{this.c=h=>h.toString()}constructor(h,t){if(this[n]="ResourceMap",h instanceof m)this.d=new Map(h.d),this.e=t??m.c;else if(c(h)){this.d=new Map,this.e=t??m.c;for(const[o,s]of h)this.set(o,s)}else this.d=new Map,this.e=h??m.c}set(h,t){return this.d.set(this.e(h),new p(h,t)),this}get(h){return this.d.get(this.e(h))?.value}has(h){return this.d.has(this.e(h))}get size(){return this.d.size}clear(){this.d.clear()}delete(h){return this.d.delete(this.e(h))}forEach(h,t){typeof t<"u"&&(h=h.bind(t));for(const[o,s]of this.d)h(s.value,s.uri,this)}*values(){for(const h of this.d.values())yield h.value}*keys(){for(const h of this.d.values())yield h.uri}*entries(){for(const h of this.d.values())yield[h.uri,h.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.d)yield[h.uri,h.value]}}e.$Ac=m;class u{constructor(h,t){this[r]="ResourceSet",!h||typeof h=="function"?this.c=new m(h):(this.c=new m(t),h.forEach(this.add,this))}get size(){return this.c.size}add(h){return this.c.set(h,h),this}clear(){this.c.clear()}delete(h){return this.c.delete(h)}forEach(h,t){this.c.forEach((o,s)=>h.call(t,s,s,this))}has(h){return this.c.has(h)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=u;var d;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(d||(e.Touch=d={}));class w{constructor(){this[k]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(h){return this.c.has(h)}get(h,t=d.None){const o=this.c.get(h);if(o)return t!==d.None&&this.m(o,t),o.value}set(h,t,o=d.None){let s=this.c.get(h);if(s)s.value=t,o!==d.None&&this.m(s,o);else{switch(s={key:h,value:t,next:void 0,previous:void 0},o){case d.None:this.k(s);break;case d.AsOld:this.j(s);break;case d.AsNew:this.k(s);break;default:this.k(s);break}this.c.set(h,s),this.f++}return this}delete(h){return!!this.remove(h)}remove(h){const t=this.c.get(h);if(t)return this.c.delete(h),this.l(t),this.f--,t.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const h=this.d;return this.c.delete(h.key),this.l(h),this.f--,h.value}forEach(h,t){const o=this.g;let s=this.d;for(;s;){if(t?h.bind(t)(s.value,s.key,this):h(s.value,s.key,this),this.g!==o)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const h=this,t=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(h.g!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:o.key,done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return s}values(){const h=this,t=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(h.g!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:o.value,done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return s}entries(){const h=this,t=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(h.g!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:[o.key,o.value],done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return s}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(h){if(h>=this.size)return;if(h===0){this.clear();return}let t=this.d,o=this.size;for(;t&&o>h;)this.c.delete(t.key),t=t.next,o--;this.d=t,this.f=o,t&&(t.previous=void 0),this.g++}i(h){if(h>=this.size)return;if(h===0){this.clear();return}let t=this.e,o=this.size;for(;t&&o>h;)this.c.delete(t.key),t=t.previous,o--;this.e=t,this.f=o,t&&(t.next=void 0),this.g++}j(h){if(!this.d&&!this.e)this.e=h;else if(this.d)h.next=this.d,this.d.previous=h;else throw new Error("Invalid list");this.d=h,this.g++}k(h){if(!this.d&&!this.e)this.d=h;else if(this.e)h.previous=this.e,this.e.next=h;else throw new Error("Invalid list");this.e=h,this.g++}l(h){if(h===this.d&&h===this.e)this.d=void 0,this.e=void 0;else if(h===this.d){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.d=h.next}else if(h===this.e){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.e=h.previous}else{const t=h.next,o=h.previous;if(!t||!o)throw new Error("Invalid list");t.previous=o,o.next=t}h.next=void 0,h.previous=void 0,this.g++}m(h,t){if(!this.d||!this.e)throw new Error("Invalid list");if(!(t!==d.AsOld&&t!==d.AsNew)){if(t===d.AsOld){if(h===this.d)return;const o=h.next,s=h.previous;h===this.e?(s.next=void 0,this.e=s):(o.previous=s,s.next=o),h.previous=void 0,h.next=this.d,this.d.previous=h,this.d=h,this.g++}else if(t===d.AsNew){if(h===this.e)return;const o=h.next,s=h.previous;h===this.d?(o.previous=void 0,this.d=o):(o.previous=s,s.next=o),h.next=void 0,h.previous=this.e,this.e.next=h,this.e=h,this.g++}}}toJSON(){const h=[];return this.forEach((t,o)=>{h.push([o,t])}),h}fromJSON(h){this.clear();for(const[t,o]of h)this.set(t,o)}}e.$Cc=w;class f extends w{constructor(h,t=1){super(),this.n=h,this.o=Math.min(Math.max(0,t),1)}get limit(){return this.n}set limit(h){this.n=h,this.p()}get ratio(){return this.o}set ratio(h){this.o=Math.min(Math.max(0,h),1),this.p()}get(h,t=d.AsNew){return super.get(h,t)}peek(h){return super.get(h,d.None)}set(h,t){return super.set(h,t,d.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class g extends f{constructor(h,t=1){super(h,t)}q(h){this.h(h)}set(h,t){return super.set(h,t),this.p(),this}}e.$Dc=g;class v extends f{constructor(h,t=1){super(h,t)}q(h){this.i(h)}set(h,t){return this.n<=this.size&&!this.has(h)&&this.q(Math.round(this.n*this.o)-1),super.set(h,t),this}}e.$Ec=v;class b{constructor(){this.c=new Map}add(h){return this.c.set(h,(this.c.get(h)||0)+1),this}delete(h){let t=this.c.get(h)||0;return t===0?!1:(t--,t===0?this.c.delete(h):this.c.set(h,t),!0)}has(h){return this.c.has(h)}}e.$Fc=b;class ${constructor(h){if(this.c=new Map,this.d=new Map,h)for(const[t,o]of h)this.set(t,o)}clear(){this.c.clear(),this.d.clear()}set(h,t){this.c.set(h,t),this.d.set(t,h)}get(h){return this.c.get(h)}getKey(h){return this.d.get(h)}delete(h){const t=this.c.get(h);return t===void 0?!1:(this.c.delete(h),this.d.delete(t),!0)}forEach(h,t){this.c.forEach((o,s)=>{h.call(t,o,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=$;class P{constructor(){this.c=new Map}add(h,t){let o=this.c.get(h);o||(o=new Set,this.c.set(h,o)),o.add(t)}delete(h,t){const o=this.c.get(h);o&&(o.delete(t),o.size===0&&this.c.delete(h))}forEach(h,t){const o=this.c.get(h);o&&o.forEach(t)}get(h){const t=this.c.get(h);return t||new Set}}e.$Hc=P;function E(i,h){if(i===h)return!0;if(i.size!==h.size)return!1;for(const[t,o]of i)if(!h.has(t)||h.get(t)!==o)return!1;for(const[t]of h)if(!i.has(t))return!1;return!0}}),define(ce[2],le([0,1,21,139,31,89,77]),function(x,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=m,e.$Lc=u,e.$Mc=d,e.$Nc=g,e.$Oc=v,e.$Pc=b,e.$Qc=$,e.$Rc=P,e.$Sc=E,e.$3c=A;const I=!1;let p=null;class c{constructor(){this.b=new Map}static{this.a=0}c(O){let M=this.b.get(O);return M||(M={parent:null,source:null,isSingleton:!1,value:O,idx:c.a++},this.b.set(O,M)),M}trackDisposable(O){const M=this.c(O);M.source||(M.source=new Error().stack)}setParent(O,M){const Z=this.c(O);Z.parent=M}markAsDisposed(O){this.b.delete(O)}markAsSingleton(O){this.c(O).isSingleton=!0}f(O,M){const Z=M.get(O);if(Z)return Z;const q=O.parent?this.f(this.c(O.parent),M):O;return M.set(O,q),q}getTrackedDisposables(){const O=new Map;return[...this.b.entries()].filter(([,Z])=>Z.source!==null&&!this.f(Z,O).isSingleton).flatMap(([Z])=>Z)}computeLeakingDisposables(O=10,M){let Z;if(M)Z=M;else{const Y=new Map,B=[...this.b.values()].filter(W=>W.source!==null&&!this.f(W,Y).isSingleton);if(B.length===0)return;const Q=new Set(B.map(W=>W.value));if(Z=B.filter(W=>!(W.parent&&Q.has(W.parent))),Z.length===0)throw new Error("There are cyclic diposable chains!")}if(!Z)return;function q(Y){function B(W,j){for(;W.length>0&&j.some(C=>typeof C=="string"?C===W[0]:W[0].match(C));)W.shift()}const Q=Y.source.split(`
`).map(W=>W.trim().replace("at ","")).filter(W=>W!=="");return B(Q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Q.reverse()}const K=new k.$Hc;for(const Y of Z){const B=q(Y);for(let Q=0;Q<=B.length;Q++)K.add(B.slice(0,Q).join(`
`),Y)}Z.sort((0,n.$5b)(Y=>Y.idx,n.$7b));let de="",H=0;for(const Y of Z.slice(0,O)){H++;const B=q(Y),Q=[];for(let W=0;W<B.length;W++){let j=B[W];j=`(shared with ${K.get(B.slice(0,W+1).join(`
`)).size}/${Z.length} leaks) at ${j}`;const X=K.get(B.slice(0,W).join(`
`)),oe=(0,r.$c)([...X].map(V=>q(V)[W]),V=>V);delete oe[B[W]];for(const[V,ue]of Object.entries(oe))Q.unshift(`    - stacktraces of ${ue.length} other leaks continue with ${V}`);Q.unshift(j)}de+=`


==================== Leaking disposable ${H}/${Z.length}: ${Y.value.constructor.name} ====================
${Q.join(`
`)}
============================================================

`}return Z.length>O&&(de+=`


... and ${Z.length-O} more leaking disposables

`),{leaks:Z,details:de}}}e.$Jc=c;function m(D){p=D}if(I){const D="__is_disposable_tracked__";m(new class{trackDisposable(O){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{O[D]||console.log(M)},3e3)}setParent(O,M){if(O&&O!==h.None)try{O[D]=!0}catch{}}markAsDisposed(O){if(O&&O!==h.None)try{O[D]=!0}catch{}}markAsSingleton(O){}})}function u(D){return p?.trackDisposable(D),D}function d(D){p?.markAsDisposed(D)}function w(D,O){p?.setParent(D,O)}function f(D,O){if(p)for(const M of D)p.setParent(M,O)}function g(D){return p?.markAsSingleton(D),D}function v(D){return typeof D=="object"&&D!==null&&typeof D.dispose=="function"&&D.dispose.length===0}function b(D){if(T.Iterable.is(D)){const O=[];for(const M of D)if(M)try{M.dispose()}catch(Z){O.push(Z)}if(O.length===1)throw O[0];if(O.length>1)throw new AggregateError(O,"Encountered errors while disposing of store");return Array.isArray(D)?[]:D}else if(D)return D.dispose(),D}function $(D){for(const O of D)v(O)&&O.dispose();return[]}function P(...D){const O=E(()=>b(D));return f(D,O),O}function E(D){const O=u({dispose:(0,R.$cb)(()=>{d(O),D()})});return O}class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,u(this)}dispose(){this.g||(d(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{b(this.f)}finally{this.f.clear()}}add(O){if(!O)return O;if(O===this)throw new Error("Cannot register a disposable on itself!");return w(O,this),this.g?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(O),O}delete(O){if(O){if(O===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(O),O.dispose()}}deleteAndLeak(O){O&&this.f.has(O)&&(this.f.delete(O),w(O,null))}}e.$Tc=i;class h{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new i,u(this),w(this.q,this)}dispose(){d(this),this.q.dispose()}B(O){if(O===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(O)}}e.$Uc=h;class t{constructor(){this.b=!1,u(this)}get value(){return this.b?void 0:this.a}set value(O){this.b||O===this.a||(this.a?.dispose(),O&&w(O,this),this.a=O)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const O=this.a;return this.a=void 0,O&&w(O,null),O}}e.$Vc=t;class o{constructor(O){this.a=new t,this.b=!1,this.a.value=O}get value(){return this.a.value}set value(O){this.b||O===this.a.value||(this.a.value=O)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=o;class s{constructor(O){this.b=O,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=s;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,u(this)}set(O){let M=O;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,d(this))},this}}e.$Yc=a;class l{constructor(){this.a=new Map}acquire(O,...M){let Z=this.a.get(O);Z||(Z={counter:0,object:this.b(O,...M)},this.a.set(O,Z));const{object:q}=Z,K=(0,R.$cb)(()=>{--Z.counter===0&&(this.c(O,Z.object),this.a.delete(O))});return Z.counter++,{object:q,dispose:K}}}e.$Zc=l;class S{constructor(O){this.a=O}async acquire(O,...M){const Z=this.a.acquire(O,...M);try{return{object:await Z.object,dispose:()=>Z.dispose()}}catch(q){throw Z.dispose(),q}}}e.$1c=S;class y{constructor(O){this.object=O}dispose(){}}e.$2c=y;function A(D){const O=new i;try{D(O)}finally{O.dispose()}}class L{constructor(){this.a=new Map,this.b=!1,u(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{b(this.a.values())}finally{this.a.clear()}}has(O){return this.a.has(O)}get size(){return this.a.size}get(O){return this.a.get(O)}set(O,M,Z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Z||this.a.get(O)?.dispose(),this.a.set(O,M)}deleteAndDispose(O){this.a.get(O)?.dispose(),this.a.delete(O)}deleteAndLeak(O){const M=this.a.get(O);return this.a.delete(O),M}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=L}),define(ce[90],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var n;(function(r){r[r.Uri=1]="Uri",r[r.Regexp=2]="Regexp",r[r.ScmResource=3]="ScmResource",r[r.ScmResourceGroup=4]="ScmResourceGroup",r[r.ScmProvider=5]="ScmProvider",r[r.CommentController=6]="CommentController",r[r.CommentThread=7]="CommentThread",r[r.CommentThreadInstance=8]="CommentThreadInstance",r[r.CommentThreadReply=9]="CommentThreadReply",r[r.CommentNode=10]="CommentNode",r[r.CommentThreadNode=11]="CommentThreadNode",r[r.TimelineActionContext=12]="TimelineActionContext",r[r.NotebookCellActionContext=13]="NotebookCellActionContext",r[r.NotebookActionContext=14]="NotebookActionContext",r[r.TerminalContext=15]="TerminalContext",r[r.TestItemContext=16]="TestItemContext",r[r.Date=17]="Date",r[r.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(n||(e.MarshalledId=n={}))}),define(ce[78],le([0,1,31]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=void 0,e.$nm=k,e.$om=T;const r=new n.$Dc(1e4);function k(c){return p(c,"NFC",r)}const R=new n.$Dc(1e4);function T(c){return p(c,"NFD",R)}const I=/[^\u0000-\u0080]/;function p(c,m,u){if(!c)return c;const d=u.get(c);if(d)return d;let w;return I.test(c)?w=c.normalize(m):w=c,u.set(c,w),w}e.$pm=function(){const c=/[\u0300-\u036f]/g;return function(m){return T(m).replace(c,"")}}()}),define(ce[144],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=void 0,e.$Lm=n,e.rot=r,e.$Qm=I;function n(p,c,m){return Math.min(Math.max(p,c),m)}function r(p,c){return(c+p%c)%c}class k{constructor(){this.a=0}getNext(){return this.a++}}e.$Nm=k;class R{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Om=R;class T{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const m=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Pm=T;function I(p,c,m,u,d,w,f,g){const v=f-m,b=g-u,$=d-m,P=w-u,E=p-m,i=c-u,h=v*v+b*b,t=v*$+b*P,o=v*E+b*i,s=$*$+P*P,a=$*E+P*i,l=1/(h*s-t*t),S=(s*o-t*a)*l,y=(h*a-t*o)*l;return S>=0&&y>=0&&S+y<1}}),function(){function x(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function T(p){R.push(p,Date.now())}function I(){const p=[];for(let c=0;c<R.length;c+=2)p.push({name:R[c],startTime:R[c+1]});return p}return{mark:T,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))R.push({name:T.name,startTime:Math.round(k+T.startTime)});return R}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function n(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=n(r))}(),define(ce[3],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=h,e.$E=S,e.$K=y,e.$h="en";let n=!1,r=!1,k=!1,R=!1,T=!1,I=!1,p=!1,c=!1,m=!1,u=!1,d,w=e.$h,f=e.$h,g,v;const b=globalThis;let $;typeof b.vscode<"u"&&typeof b.vscode.process<"u"?$=b.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&($=process);const P=typeof $?.versions?.electron=="string",E=P&&$?.type==="renderer";if(typeof $=="object"){n=$.platform==="win32",r=$.platform==="darwin",k=$.platform==="linux",R=k&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,p=P,m=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.$h,w=e.$h;const A=$.env.VSCODE_NLS_CONFIG;if(A)try{const L=JSON.parse(A);d=L.userLocale,f=L.osLocale,w=L.resolvedLanguage||e.$h,g=L.languagePack?.translationsConfigFile}catch{}T=!0}else typeof navigator=="object"&&!E?(v=navigator.userAgent,n=v.indexOf("Windows")>=0,r=v.indexOf("Macintosh")>=0,c=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=v.indexOf("Linux")>=0,u=v?.indexOf("Mobi")>=0,I=!0,w=globalThis._VSCODE_NLS_LANGUAGE||e.$h,d=navigator.language.toLowerCase(),f=d):console.error("Unable to resolve platform.");var i;(function(A){A[A.Web=0]="Web",A[A.Mac=1]="Mac",A[A.Linux=2]="Linux",A[A.Windows=3]="Windows"})(i||(e.Platform=i={}));function h(A){switch(A){case i.Web:return"Web";case i.Mac:return"Mac";case i.Linux:return"Linux";case i.Windows:return"Windows"}}let t=i.Web;r?t=i.Mac:n?t=i.Windows:k&&(t=i.Linux),e.$j=n,e.$k=r,e.$l=k,e.$m=R,e.$n=T,e.$o=p,e.$p=I,e.$q=I&&typeof b.importScripts=="function",e.$r=e.$q?b.origin:void 0,e.$s=c,e.$t=u,e.$u=m,e.$v=t,e.$w=v,e.$x=w;var o;(function(A){function L(){return e.$x}A.value=L;function D(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}A.isDefaultVariant=D;function O(){return e.$x==="en"}A.isDefault=O})(o||(e.Language=o={})),e.$y=d,e.$z=f,e.$A=g,e.$B=typeof b.postMessage=="function"&&!b.importScripts,e.$C=(()=>{if(e.$B){const A=[];b.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let O=0,M=A.length;O<M;O++){const Z=A[O];if(Z.id===D.data.vscodeScheduleAsyncWork){A.splice(O,1),Z.callback();return}}});let L=0;return D=>{const O=++L;A.push({id:O,callback:D}),b.postMessage({vscodeScheduleAsyncWork:O},"*")}}return A=>setTimeout(A)})();var s;(function(A){A[A.Windows=1]="Windows",A[A.Macintosh=2]="Macintosh",A[A.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=r||c?s.Macintosh:n?s.Windows:s.Linux;let a=!0,l=!1;function S(){if(!l){l=!0;const A=new Uint8Array(2);A[0]=1,A[1]=2,a=new Uint16Array(A.buffer)[0]===513}return a}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function y(A){return parseFloat(A)>=20}}),define(ce[36],le([0,1,3]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let r;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.process<"u"){const R=k.process;r={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return n.$j?"win32":n.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.$dc=r.platform,e.$ec=r.arch});var Rt=this&&this.__createBinding||(Object.create?function(x,e,n,r){r===void 0&&(r=n);var k=Object.getOwnPropertyDescriptor(e,n);(!k||("get"in k?!e.__esModule:k.writable||k.configurable))&&(k={enumerable:!0,get:function(){return e[n]}}),Object.defineProperty(x,r,k)}:function(x,e,n,r){r===void 0&&(r=n),x[r]=e[n]}),Dt=this&&this.__setModuleDefault||(Object.create?function(x,e){Object.defineProperty(x,"default",{enumerable:!0,value:e})}:function(x,e){x.default=e}),Pe=this&&this.__importStar||function(x){if(x&&x.__esModule)return x;var e={};if(x!=null)for(var n in x)n!=="default"&&Object.prototype.hasOwnProperty.call(x,n)&&Rt(e,x,n);return Dt(e,x),e};define(ce[9],le([0,1,36]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0,n=Pe(n);const r=65,k=97,R=90,T=122,I=46,p=47,c=92,m=58,u=63;class d extends Error{constructor(o,s,a){let l;typeof s=="string"&&s.indexOf("not ")===0?(l="must not be",s=s.replace(/^not /,"")):l="must be";const S=o.indexOf(".")!==-1?"property":"argument";let y=`The "${o}" ${S} ${l} of type ${s}`;y+=`. Received type ${typeof a}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function w(t,o){if(t===null||typeof t!="object")throw new d(o,"Object",t)}function f(t,o){if(typeof t!="string")throw new d(o,"string",t)}const g=n.$dc==="win32";function v(t){return t===p||t===c}function b(t){return t===p}function $(t){return t>=r&&t<=R||t>=k&&t<=T}function P(t,o,s,a){let l="",S=0,y=-1,A=0,L=0;for(let D=0;D<=t.length;++D){if(D<t.length)L=t.charCodeAt(D);else{if(a(L))break;L=p}if(a(L)){if(!(y===D-1||A===1))if(A===2){if(l.length<2||S!==2||l.charCodeAt(l.length-1)!==I||l.charCodeAt(l.length-2)!==I){if(l.length>2){const O=l.lastIndexOf(s);O===-1?(l="",S=0):(l=l.slice(0,O),S=l.length-1-l.lastIndexOf(s)),y=D,A=0;continue}else if(l.length!==0){l="",S=0,y=D,A=0;continue}}o&&(l+=l.length>0?`${s}..`:"..",S=2)}else l.length>0?l+=`${s}${t.slice(y+1,D)}`:l=t.slice(y+1,D),S=D-y-1;y=D,A=0}else L===I&&A!==-1?++A:A=-1}return l}function E(t){return t?`${t[0]==="."?"":"."}${t}`:""}function i(t,o){w(o,"pathObject");const s=o.dir||o.root,a=o.base||`${o.name||""}${E(o.ext)}`;return s?s===o.root?`${s}${a}`:`${s}${t}${a}`:a}e.$fc={resolve(...t){let o="",s="",a=!1;for(let l=t.length-1;l>=-1;l--){let S;if(l>=0){if(S=t[l],f(S,`paths[${l}]`),S.length===0)continue}else o.length===0?S=n.cwd():(S=n.env[`=${o}`]||n.cwd(),(S===void 0||S.slice(0,2).toLowerCase()!==o.toLowerCase()&&S.charCodeAt(2)===c)&&(S=`${o}\\`));const y=S.length;let A=0,L="",D=!1;const O=S.charCodeAt(0);if(y===1)v(O)&&(A=1,D=!0);else if(v(O))if(D=!0,v(S.charCodeAt(1))){let M=2,Z=M;for(;M<y&&!v(S.charCodeAt(M));)M++;if(M<y&&M!==Z){const q=S.slice(Z,M);for(Z=M;M<y&&v(S.charCodeAt(M));)M++;if(M<y&&M!==Z){for(Z=M;M<y&&!v(S.charCodeAt(M));)M++;(M===y||M!==Z)&&(L=`\\\\${q}\\${S.slice(Z,M)}`,A=M)}}}else A=1;else $(O)&&S.charCodeAt(1)===m&&(L=S.slice(0,2),A=2,y>2&&v(S.charCodeAt(2))&&(D=!0,A=3));if(L.length>0)if(o.length>0){if(L.toLowerCase()!==o.toLowerCase())continue}else o=L;if(a){if(o.length>0)break}else if(s=`${S.slice(A)}\\${s}`,a=D,D&&o.length>0)break}return s=P(s,!a,"\\",v),a?`${o}\\${s}`:`${o}${s}`||"."},normalize(t){f(t,"path");const o=t.length;if(o===0)return".";let s=0,a,l=!1;const S=t.charCodeAt(0);if(o===1)return b(S)?"\\":t;if(v(S))if(l=!0,v(t.charCodeAt(1))){let A=2,L=A;for(;A<o&&!v(t.charCodeAt(A));)A++;if(A<o&&A!==L){const D=t.slice(L,A);for(L=A;A<o&&v(t.charCodeAt(A));)A++;if(A<o&&A!==L){for(L=A;A<o&&!v(t.charCodeAt(A));)A++;if(A===o)return`\\\\${D}\\${t.slice(L)}\\`;A!==L&&(a=`\\\\${D}\\${t.slice(L,A)}`,s=A)}}}else s=1;else $(S)&&t.charCodeAt(1)===m&&(a=t.slice(0,2),s=2,o>2&&v(t.charCodeAt(2))&&(l=!0,s=3));let y=s<o?P(t.slice(s),!l,"\\",v):"";return y.length===0&&!l&&(y="."),y.length>0&&v(t.charCodeAt(o-1))&&(y+="\\"),a===void 0?l?`\\${y}`:y:l?`${a}\\${y}`:`${a}${y}`},isAbsolute(t){f(t,"path");const o=t.length;if(o===0)return!1;const s=t.charCodeAt(0);return v(s)||o>2&&$(s)&&t.charCodeAt(1)===m&&v(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,s;for(let S=0;S<t.length;++S){const y=t[S];f(y,"path"),y.length>0&&(o===void 0?o=s=y:o+=`\\${y}`)}if(o===void 0)return".";let a=!0,l=0;if(typeof s=="string"&&v(s.charCodeAt(0))){++l;const S=s.length;S>1&&v(s.charCodeAt(1))&&(++l,S>2&&(v(s.charCodeAt(2))?++l:a=!1))}if(a){for(;l<o.length&&v(o.charCodeAt(l));)l++;l>=2&&(o=`\\${o.slice(l)}`)}return e.$fc.normalize(o)},relative(t,o){if(f(t,"from"),f(o,"to"),t===o)return"";const s=e.$fc.resolve(t),a=e.$fc.resolve(o);if(s===a||(t=s.toLowerCase(),o=a.toLowerCase(),t===o))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===c;)l++;let S=t.length;for(;S-1>l&&t.charCodeAt(S-1)===c;)S--;const y=S-l;let A=0;for(;A<o.length&&o.charCodeAt(A)===c;)A++;let L=o.length;for(;L-1>A&&o.charCodeAt(L-1)===c;)L--;const D=L-A,O=y<D?y:D;let M=-1,Z=0;for(;Z<O;Z++){const K=t.charCodeAt(l+Z);if(K!==o.charCodeAt(A+Z))break;K===c&&(M=Z)}if(Z!==O){if(M===-1)return a}else{if(D>O){if(o.charCodeAt(A+Z)===c)return a.slice(A+Z+1);if(Z===2)return a.slice(A+Z)}y>O&&(t.charCodeAt(l+Z)===c?M=Z:Z===2&&(M=3)),M===-1&&(M=0)}let q="";for(Z=l+M+1;Z<=S;++Z)(Z===S||t.charCodeAt(Z)===c)&&(q+=q.length===0?"..":"\\..");return A+=M,q.length>0?`${q}${a.slice(A,L)}`:(a.charCodeAt(A)===c&&++A,a.slice(A,L))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$fc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===c){if(o.charCodeAt(1)===c){const s=o.charCodeAt(2);if(s!==u&&s!==I)return`\\\\?\\UNC\\${o.slice(2)}`}}else if($(o.charCodeAt(0))&&o.charCodeAt(1)===m&&o.charCodeAt(2)===c)return`\\\\?\\${o}`;return t},dirname(t){f(t,"path");const o=t.length;if(o===0)return".";let s=-1,a=0;const l=t.charCodeAt(0);if(o===1)return v(l)?t:".";if(v(l)){if(s=a=1,v(t.charCodeAt(1))){let A=2,L=A;for(;A<o&&!v(t.charCodeAt(A));)A++;if(A<o&&A!==L){for(L=A;A<o&&v(t.charCodeAt(A));)A++;if(A<o&&A!==L){for(L=A;A<o&&!v(t.charCodeAt(A));)A++;if(A===o)return t;A!==L&&(s=a=A+1)}}}}else $(l)&&t.charCodeAt(1)===m&&(s=o>2&&v(t.charCodeAt(2))?3:2,a=s);let S=-1,y=!0;for(let A=o-1;A>=a;--A)if(v(t.charCodeAt(A))){if(!y){S=A;break}}else y=!1;if(S===-1){if(s===-1)return".";S=s}return t.slice(0,S)},basename(t,o){o!==void 0&&f(o,"suffix"),f(t,"path");let s=0,a=-1,l=!0,S;if(t.length>=2&&$(t.charCodeAt(0))&&t.charCodeAt(1)===m&&(s=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let y=o.length-1,A=-1;for(S=t.length-1;S>=s;--S){const L=t.charCodeAt(S);if(v(L)){if(!l){s=S+1;break}}else A===-1&&(l=!1,A=S+1),y>=0&&(L===o.charCodeAt(y)?--y===-1&&(a=S):(y=-1,a=A))}return s===a?a=A:a===-1&&(a=t.length),t.slice(s,a)}for(S=t.length-1;S>=s;--S)if(v(t.charCodeAt(S))){if(!l){s=S+1;break}}else a===-1&&(l=!1,a=S+1);return a===-1?"":t.slice(s,a)},extname(t){f(t,"path");let o=0,s=-1,a=0,l=-1,S=!0,y=0;t.length>=2&&t.charCodeAt(1)===m&&$(t.charCodeAt(0))&&(o=a=2);for(let A=t.length-1;A>=o;--A){const L=t.charCodeAt(A);if(v(L)){if(!S){a=A+1;break}continue}l===-1&&(S=!1,l=A+1),L===I?s===-1?s=A:y!==1&&(y=1):s!==-1&&(y=-1)}return s===-1||l===-1||y===0||y===1&&s===l-1&&s===a+1?"":t.slice(s,l)},format:i.bind(null,"\\"),parse(t){f(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.length;let a=0,l=t.charCodeAt(0);if(s===1)return v(l)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(v(l)){if(a=1,v(t.charCodeAt(1))){let M=2,Z=M;for(;M<s&&!v(t.charCodeAt(M));)M++;if(M<s&&M!==Z){for(Z=M;M<s&&v(t.charCodeAt(M));)M++;if(M<s&&M!==Z){for(Z=M;M<s&&!v(t.charCodeAt(M));)M++;M===s?a=M:M!==Z&&(a=M+1)}}}}else if($(l)&&t.charCodeAt(1)===m){if(s<=2)return o.root=o.dir=t,o;if(a=2,v(t.charCodeAt(2))){if(s===3)return o.root=o.dir=t,o;a=3}}a>0&&(o.root=t.slice(0,a));let S=-1,y=a,A=-1,L=!0,D=t.length-1,O=0;for(;D>=a;--D){if(l=t.charCodeAt(D),v(l)){if(!L){y=D+1;break}continue}A===-1&&(L=!1,A=D+1),l===I?S===-1?S=D:O!==1&&(O=1):S!==-1&&(O=-1)}return A!==-1&&(S===-1||O===0||O===1&&S===A-1&&S===y+1?o.base=o.name=t.slice(y,A):(o.name=t.slice(y,S),o.base=t.slice(y,A),o.ext=t.slice(S,A))),y>0&&y!==a?o.dir=t.slice(0,y-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(g){const t=/\\/g;return()=>{const o=n.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>n.cwd()})();e.$gc={resolve(...t){let o="",s=!1;for(let a=t.length-1;a>=-1&&!s;a--){const l=a>=0?t[a]:h();f(l,`paths[${a}]`),l.length!==0&&(o=`${l}/${o}`,s=l.charCodeAt(0)===p)}return o=P(o,!s,"/",b),s?`/${o}`:o.length>0?o:"."},normalize(t){if(f(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===p,s=t.charCodeAt(t.length-1)===p;return t=P(t,!o,"/",b),t.length===0?o?"/":s?"./":".":(s&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return f(t,"path"),t.length>0&&t.charCodeAt(0)===p},join(...t){if(t.length===0)return".";let o;for(let s=0;s<t.length;++s){const a=t[s];f(a,"path"),a.length>0&&(o===void 0?o=a:o+=`/${a}`)}return o===void 0?".":e.$gc.normalize(o)},relative(t,o){if(f(t,"from"),f(o,"to"),t===o||(t=e.$gc.resolve(t),o=e.$gc.resolve(o),t===o))return"";const s=1,a=t.length,l=a-s,S=1,y=o.length-S,A=l<y?l:y;let L=-1,D=0;for(;D<A;D++){const M=t.charCodeAt(s+D);if(M!==o.charCodeAt(S+D))break;M===p&&(L=D)}if(D===A)if(y>A){if(o.charCodeAt(S+D)===p)return o.slice(S+D+1);if(D===0)return o.slice(S+D)}else l>A&&(t.charCodeAt(s+D)===p?L=D:D===0&&(L=0));let O="";for(D=s+L+1;D<=a;++D)(D===a||t.charCodeAt(D)===p)&&(O+=O.length===0?"..":"/..");return`${O}${o.slice(S+L)}`},toNamespacedPath(t){return t},dirname(t){if(f(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===p;let s=-1,a=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===p){if(!a){s=l;break}}else a=!1;return s===-1?o?"/":".":o&&s===1?"//":t.slice(0,s)},basename(t,o){o!==void 0&&f(o,"ext"),f(t,"path");let s=0,a=-1,l=!0,S;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let y=o.length-1,A=-1;for(S=t.length-1;S>=0;--S){const L=t.charCodeAt(S);if(L===p){if(!l){s=S+1;break}}else A===-1&&(l=!1,A=S+1),y>=0&&(L===o.charCodeAt(y)?--y===-1&&(a=S):(y=-1,a=A))}return s===a?a=A:a===-1&&(a=t.length),t.slice(s,a)}for(S=t.length-1;S>=0;--S)if(t.charCodeAt(S)===p){if(!l){s=S+1;break}}else a===-1&&(l=!1,a=S+1);return a===-1?"":t.slice(s,a)},extname(t){f(t,"path");let o=-1,s=0,a=-1,l=!0,S=0;for(let y=t.length-1;y>=0;--y){const A=t.charCodeAt(y);if(A===p){if(!l){s=y+1;break}continue}a===-1&&(l=!1,a=y+1),A===I?o===-1?o=y:S!==1&&(S=1):o!==-1&&(S=-1)}return o===-1||a===-1||S===0||S===1&&o===a-1&&o===s+1?"":t.slice(o,a)},format:i.bind(null,"/"),parse(t){f(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.charCodeAt(0)===p;let a;s?(o.root="/",a=1):a=0;let l=-1,S=0,y=-1,A=!0,L=t.length-1,D=0;for(;L>=a;--L){const O=t.charCodeAt(L);if(O===p){if(!A){S=L+1;break}continue}y===-1&&(A=!1,y=L+1),O===I?l===-1?l=L:D!==1&&(D=1):l!==-1&&(D=-1)}if(y!==-1){const O=S===0&&s?1:S;l===-1||D===0||D===1&&l===y-1&&l===S+1?o.base=o.name=t.slice(O,y):(o.name=t.slice(O,l),o.base=t.slice(O,y),o.ext=t.slice(l,y))}return S>0?o.dir=t.slice(0,S-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=g?e.$fc.normalize:e.$gc.normalize,e.$ic=g?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=g?e.$fc.join:e.$gc.join,e.$kc=g?e.$fc.resolve:e.$gc.resolve,e.$lc=g?e.$fc.relative:e.$gc.relative,e.$mc=g?e.$fc.dirname:e.$gc.dirname,e.$nc=g?e.$fc.basename:e.$gc.basename,e.$oc=g?e.$fc.extname:e.$gc.extname,e.$pc=g?e.$fc.format:e.$gc.format,e.$qc=g?e.$fc.parse:e.$gc.parse,e.$rc=g?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=g?e.$fc.sep:e.$gc.sep,e.$tc=g?e.$fc.delimiter:e.$gc.delimiter}),define(ce[79],le([0,1,3]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$lm=R,e.$mm=T;var r;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(r||(e.Source=r={}));var k;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function R(I,...p){const c=p.reduce((d,w)=>(d[w]=!0,d),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(d=>!c[d]).forEach(d=>{for(let w=0;w<m.length;w++)if(d.search(m[w])!==-1){delete I[d];break}})}function T(I){I&&(delete I.DEBUG,n.$l&&delete I.LD_PRELOAD)}}),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var r in n)(typeof exports=="object"?exports:x)[r]=n[r]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function n(r){if(e[r])return e[r].exports;var k=e[r]={i:r,l:!1,exports:{}};return x[r].call(k.exports,k,k.exports,n),k.l=!0,k.exports}return n.m=x,n.c=e,n.d=function(r,k,R){n.o(r,k)||Object.defineProperty(r,k,{enumerable:!0,get:R})},n.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},n.t=function(r,k){if(1&k&&(r=n(r)),8&k||4&k&&typeof r=="object"&&r&&r.__esModule)return r;var R=Object.create(null);if(n.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:r}),2&k&&typeof r!="string")for(var T in r)n.d(R,T,function(I){return r[I]}.bind(null,T));return R},n.n=function(r){var k=r&&r.__esModule?function(){return r.default}:function(){return r};return n.d(k,"a",k),k},n.o=function(r,k){return Object.prototype.hasOwnProperty.call(r,k)},n.p="",n(n.s=0)}([function(x,e,n){(function(r){var k;e=x.exports=ue,k=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],p=e.src=[],c=0,m=c++;p[m]="0|[1-9]\\d*";var u=c++;p[u]="[0-9]+";var d=c++;p[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=c++;p[w]="("+p[m]+")\\.("+p[m]+")\\.("+p[m]+")";var f=c++;p[f]="("+p[u]+")\\.("+p[u]+")\\.("+p[u]+")";var g=c++;p[g]="(?:"+p[m]+"|"+p[d]+")";var v=c++;p[v]="(?:"+p[u]+"|"+p[d]+")";var b=c++;p[b]="(?:-("+p[g]+"(?:\\."+p[g]+")*))";var $=c++;p[$]="(?:-?("+p[v]+"(?:\\."+p[v]+")*))";var P=c++;p[P]="[0-9A-Za-z-]+";var E=c++;p[E]="(?:\\+("+p[P]+"(?:\\."+p[P]+")*))";var i=c++,h="v?"+p[w]+p[b]+"?"+p[E]+"?";p[i]="^"+h+"$";var t="[v=\\s]*"+p[f]+p[$]+"?"+p[E]+"?",o=c++;p[o]="^"+t+"$";var s=c++;p[s]="((?:<|>)?=?)";var a=c++;p[a]=p[u]+"|x|X|\\*";var l=c++;p[l]=p[m]+"|x|X|\\*";var S=c++;p[S]="[v=\\s]*("+p[l]+")(?:\\.("+p[l]+")(?:\\.("+p[l]+")(?:"+p[b]+")?"+p[E]+"?)?)?";var y=c++;p[y]="[v=\\s]*("+p[a]+")(?:\\.("+p[a]+")(?:\\.("+p[a]+")(?:"+p[$]+")?"+p[E]+"?)?)?";var A=c++;p[A]="^"+p[s]+"\\s*"+p[S]+"$";var L=c++;p[L]="^"+p[s]+"\\s*"+p[y]+"$";var D=c++;p[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=c++;p[O]="(?:~>?)";var M=c++;p[M]="(\\s*)"+p[O]+"\\s+",I[M]=new RegExp(p[M],"g");var Z=c++;p[Z]="^"+p[O]+p[S]+"$";var q=c++;p[q]="^"+p[O]+p[y]+"$";var K=c++;p[K]="(?:\\^)";var de=c++;p[de]="(\\s*)"+p[K]+"\\s+",I[de]=new RegExp(p[de],"g");var H=c++;p[H]="^"+p[K]+p[S]+"$";var Y=c++;p[Y]="^"+p[K]+p[y]+"$";var B=c++;p[B]="^"+p[s]+"\\s*("+t+")$|^$";var Q=c++;p[Q]="^"+p[s]+"\\s*("+h+")$|^$";var W=c++;p[W]="(\\s*)"+p[s]+"\\s*("+t+"|"+p[S]+")",I[W]=new RegExp(p[W],"g");var j=c++;p[j]="^\\s*("+p[S]+")\\s+-\\s+("+p[S]+")\\s*$";var C=c++;p[C]="^\\s*("+p[y]+")\\s+-\\s+("+p[y]+")\\s*$";var X=c++;p[X]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)k(oe,p[oe]),I[oe]||(I[oe]=new RegExp(p[oe]));function V(ee,ae){if(ee instanceof ue)return ee;if(typeof ee!="string"||ee.length>R||!(ae?I[o]:I[i]).test(ee))return null;try{return new ue(ee,ae)}catch{return null}}function ue(ee,ae){if(ee instanceof ue){if(ee.loose===ae)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ue))return new ue(ee,ae);k("SemVer",ee,ae),this.loose=ae;var fe=ee.trim().match(ae?I[o]:I[i]);if(!fe)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Re=+be;if(Re>=0&&Re<T)return Re}return be}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=V,e.valid=function(ee,ae){var fe=V(ee,ae);return fe?fe.version:null},e.clean=function(ee,ae){var fe=V(ee.trim().replace(/^[=v]+/,""),ae);return fe?fe.version:null},e.SemVer=ue,ue.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ue.prototype.toString=function(){return this.version},ue.prototype.compare=function(ee){return k("SemVer.compare",this.version,this.loose,ee),ee instanceof ue||(ee=new ue(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},ue.prototype.compareMain=function(ee){return ee instanceof ue||(ee=new ue(ee,this.loose)),J(this.major,ee.major)||J(this.minor,ee.minor)||J(this.patch,ee.patch)},ue.prototype.comparePre=function(ee){if(ee instanceof ue||(ee=new ue(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var ae=0;do{var fe=this.prerelease[ae],be=ee.prerelease[ae];if(k("prerelease compare",ae,fe,be),fe===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(fe===void 0)return-1;if(fe!==be)return J(fe,be)}while(++ae)},ue.prototype.inc=function(ee,ae){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,ae,fe,be){typeof fe=="string"&&(be=fe,fe=void 0);try{return new ue(ee,fe).inc(ae,be).version}catch{return null}},e.diff=function(ee,ae){if(z(ee,ae))return null;var fe=V(ee),be=V(ae);if(fe.prerelease.length||be.prerelease.length){for(var Re in fe)if((Re==="major"||Re==="minor"||Re==="patch")&&fe[Re]!==be[Re])return"pre"+Re;return"prerelease"}for(var Re in fe)if((Re==="major"||Re==="minor"||Re==="patch")&&fe[Re]!==be[Re])return Re},e.compareIdentifiers=J;var re=/^[0-9]+$/;function J(ee,ae){var fe=re.test(ee),be=re.test(ae);return fe&&be&&(ee=+ee,ae=+ae),fe&&!be?-1:be&&!fe?1:ee<ae?-1:ee>ae?1:0}function F(ee,ae,fe){return new ue(ee,fe).compare(new ue(ae,fe))}function N(ee,ae,fe){return F(ee,ae,fe)>0}function _(ee,ae,fe){return F(ee,ae,fe)<0}function z(ee,ae,fe){return F(ee,ae,fe)===0}function ie(ee,ae,fe){return F(ee,ae,fe)!==0}function G(ee,ae,fe){return F(ee,ae,fe)>=0}function U(ee,ae,fe){return F(ee,ae,fe)<=0}function te(ee,ae,fe,be){var Re;switch(ae){case"===":typeof ee=="object"&&(ee=ee.version),typeof fe=="object"&&(fe=fe.version),Re=ee===fe;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof fe=="object"&&(fe=fe.version),Re=ee!==fe;break;case"":case"=":case"==":Re=z(ee,fe,be);break;case"!=":Re=ie(ee,fe,be);break;case">":Re=N(ee,fe,be);break;case">=":Re=G(ee,fe,be);break;case"<":Re=_(ee,fe,be);break;case"<=":Re=U(ee,fe,be);break;default:throw new TypeError("Invalid operator: "+ae)}return Re}function he(ee,ae){if(ee instanceof he){if(ee.loose===ae)return ee;ee=ee.value}if(!(this instanceof he))return new he(ee,ae);k("comparator",ee,ae),this.loose=ae,this.parse(ee),this.semver===me?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(ee,ae){return J(ae,ee)},e.major=function(ee,ae){return new ue(ee,ae).major},e.minor=function(ee,ae){return new ue(ee,ae).minor},e.patch=function(ee,ae){return new ue(ee,ae).patch},e.compare=F,e.compareLoose=function(ee,ae){return F(ee,ae,!0)},e.rcompare=function(ee,ae,fe){return F(ae,ee,fe)},e.sort=function(ee,ae){return ee.sort(function(fe,be){return e.compare(fe,be,ae)})},e.rsort=function(ee,ae){return ee.sort(function(fe,be){return e.rcompare(fe,be,ae)})},e.gt=N,e.lt=_,e.eq=z,e.neq=ie,e.gte=G,e.lte=U,e.cmp=te,e.Comparator=he;var me={};function we(ee,ae){if(ee instanceof we)return ee.loose===ae?ee:new we(ee.raw,ae);if(ee instanceof he)return new we(ee.value,ae);if(!(this instanceof we))return new we(ee,ae);if(this.loose=ae,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Ie(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Ce(ee,ae,fe,be,Re,Fe,Me,De,Ue,Ge,Qe,qe,Xe){return((ae=Ie(fe)?"":Ie(be)?">="+fe+".0.0":Ie(Re)?">="+fe+"."+be+".0":">="+ae)+" "+(De=Ie(Ue)?"":Ie(Ge)?"<"+(+Ue+1)+".0.0":Ie(Qe)?"<"+Ue+"."+(+Ge+1)+".0":qe?"<="+Ue+"."+Ge+"."+Qe+"-"+qe:"<="+De)).trim()}function Ae(ee,ae){for(var fe=0;fe<ee.length;fe++)if(!ee[fe].test(ae))return!1;if(ae.prerelease.length){for(fe=0;fe<ee.length;fe++)if(k(ee[fe].semver),ee[fe].semver!==me&&ee[fe].semver.prerelease.length>0){var be=ee[fe].semver;if(be.major===ae.major&&be.minor===ae.minor&&be.patch===ae.patch)return!0}return!1}return!0}function ve(ee,ae,fe){try{ae=new we(ae,fe)}catch{return!1}return ae.test(ee)}function $e(ee,ae,fe,be){var Re,Fe,Me,De,Ue;switch(ee=new ue(ee,be),ae=new we(ae,be),fe){case">":Re=N,Fe=U,Me=_,De=">",Ue=">=";break;case"<":Re=_,Fe=G,Me=N,De="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(ee,ae,be))return!1;for(var Ge=0;Ge<ae.set.length;++Ge){var Qe=ae.set[Ge],qe=null,Xe=null;if(Qe.forEach(function(Je){Je.semver===me&&(Je=new he(">=0.0.0")),qe=qe||Je,Xe=Xe||Je,Re(Je.semver,qe.semver,be)?qe=Je:Me(Je.semver,Xe.semver,be)&&(Xe=Je)}),qe.operator===De||qe.operator===Ue||(!Xe.operator||Xe.operator===De)&&Fe(ee,Xe.semver)||Xe.operator===Ue&&Me(ee,Xe.semver))return!1}return!0}he.prototype.parse=function(ee){var ae=this.loose?I[B]:I[Q],fe=ee.match(ae);if(!fe)throw new TypeError("Invalid comparator: "+ee);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new ue(fe[2],this.loose):this.semver=me},he.prototype.toString=function(){return this.value},he.prototype.test=function(ee){return k("Comparator.test",ee,this.loose),this.semver===me||(typeof ee=="string"&&(ee=new ue(ee,this.loose)),te(ee,this.operator,this.semver,this.loose))},he.prototype.intersects=function(ee,ae){if(!(ee instanceof he))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new we(ee.value,ae),ve(this.value,fe,ae);if(ee.operator==="")return fe=new we(this.value,ae),ve(ee.semver,fe,ae);var be=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),Fe=this.semver.version===ee.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),De=te(this.semver,"<",ee.semver,ae)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),Ue=te(this.semver,">",ee.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return be||Re||Fe&&Me||De||Ue},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(ee){var ae=this.loose;ee=ee.trim(),k("range",ee,ae);var fe=ae?I[C]:I[j];ee=ee.replace(fe,Ce),k("hyphen replace",ee),ee=ee.replace(I[W],"$1$2$3"),k("comparator trim",ee,I[W]),ee=(ee=(ee=ee.replace(I[M],"$1~")).replace(I[de],"$1^")).split(/\s+/).join(" ");var be=ae?I[B]:I[Q],Re=ee.split(" ").map(function(Fe){return function(Me,De){return k("comp",Me),Me=function(Ue,Ge){return Ue.trim().split(/\s+/).map(function(Qe){return function(qe,Xe){k("caret",qe,Xe);var Je=Xe?I[Y]:I[H];return qe.replace(Je,function(Ye,We,ne,ge,pe){var ye;return k("caret",qe,Ye,We,ne,ge,pe),Ie(We)?ye="":Ie(ne)?ye=">="+We+".0.0 <"+(+We+1)+".0.0":Ie(ge)?ye=We==="0"?">="+We+"."+ne+".0 <"+We+"."+(+ne+1)+".0":">="+We+"."+ne+".0 <"+(+We+1)+".0.0":pe?(k("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=We==="0"?ne==="0"?">="+We+"."+ne+"."+ge+pe+" <"+We+"."+ne+"."+(+ge+1):">="+We+"."+ne+"."+ge+pe+" <"+We+"."+(+ne+1)+".0":">="+We+"."+ne+"."+ge+pe+" <"+(+We+1)+".0.0"):(k("no pr"),ye=We==="0"?ne==="0"?">="+We+"."+ne+"."+ge+" <"+We+"."+ne+"."+(+ge+1):">="+We+"."+ne+"."+ge+" <"+We+"."+(+ne+1)+".0":">="+We+"."+ne+"."+ge+" <"+(+We+1)+".0.0"),k("caret return",ye),ye})}(Qe,Ge)}).join(" ")}(Me,De),k("caret",Me),Me=function(Ue,Ge){return Ue.trim().split(/\s+/).map(function(Qe){return function(qe,Xe){var Je=Xe?I[q]:I[Z];return qe.replace(Je,function(Ye,We,ne,ge,pe){var ye;return k("tilde",qe,Ye,We,ne,ge,pe),Ie(We)?ye="":Ie(ne)?ye=">="+We+".0.0 <"+(+We+1)+".0.0":Ie(ge)?ye=">="+We+"."+ne+".0 <"+We+"."+(+ne+1)+".0":pe?(k("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=">="+We+"."+ne+"."+ge+pe+" <"+We+"."+(+ne+1)+".0"):ye=">="+We+"."+ne+"."+ge+" <"+We+"."+(+ne+1)+".0",k("tilde return",ye),ye})}(Qe,Ge)}).join(" ")}(Me,De),k("tildes",Me),Me=function(Ue,Ge){return k("replaceXRanges",Ue,Ge),Ue.split(/\s+/).map(function(Qe){return function(qe,Xe){qe=qe.trim();var Je=Xe?I[L]:I[A];return qe.replace(Je,function(Ye,We,ne,ge,pe,ye){k("xRange",qe,Ye,We,ne,ge,pe,ye);var je=Ie(ne),Be=je||Ie(ge),_e=Be||Ie(pe);return We==="="&&_e&&(We=""),je?Ye=We===">"||We==="<"?"<0.0.0":"*":We&&_e?(Be&&(ge=0),_e&&(pe=0),We===">"?(We=">=",Be?(ne=+ne+1,ge=0,pe=0):_e&&(ge=+ge+1,pe=0)):We==="<="&&(We="<",Be?ne=+ne+1:ge=+ge+1),Ye=We+ne+"."+ge+"."+pe):Be?Ye=">="+ne+".0.0 <"+(+ne+1)+".0.0":_e&&(Ye=">="+ne+"."+ge+".0 <"+ne+"."+(+ge+1)+".0"),k("xRange return",Ye),Ye})}(Qe,Ge)}).join(" ")}(Me,De),k("xrange",Me),Me=function(Ue,Ge){return k("replaceStars",Ue,Ge),Ue.trim().replace(I[X],"")}(Me,De),k("stars",Me),Me}(Fe,ae)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Fe){return!!Fe.match(be)})),Re=Re.map(function(Fe){return new he(Fe,ae)})},we.prototype.intersects=function(ee,ae){if(!(ee instanceof we))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(be){return ee.set.some(function(Re){return Re.every(function(Fe){return be.intersects(Fe,ae)})})})})},e.toComparators=function(ee,ae){return new we(ee,ae).set.map(function(fe){return fe.map(function(be){return be.value}).join(" ").trim().split(" ")})},we.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new ue(ee,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Ae(this.set[ae],ee))return!0;return!1},e.satisfies=ve,e.maxSatisfying=function(ee,ae,fe){var be=null,Re=null;try{var Fe=new we(ae,fe)}catch{return null}return ee.forEach(function(Me){Fe.test(Me)&&(be&&Re.compare(Me)!==-1||(Re=new ue(be=Me,fe)))}),be},e.minSatisfying=function(ee,ae,fe){var be=null,Re=null;try{var Fe=new we(ae,fe)}catch{return null}return ee.forEach(function(Me){Fe.test(Me)&&(be&&Re.compare(Me)!==1||(Re=new ue(be=Me,fe)))}),be},e.validRange=function(ee,ae){try{return new we(ee,ae).range||"*"}catch{return null}},e.ltr=function(ee,ae,fe){return $e(ee,ae,"<",fe)},e.gtr=function(ee,ae,fe){return $e(ee,ae,">",fe)},e.outside=$e,e.prerelease=function(ee,ae){var fe=V(ee,ae);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(ee,ae,fe){return ee=new we(ee,fe),ae=new we(ae,fe),ee.intersects(ae)},e.coerce=function(ee){if(ee instanceof ue)return ee;if(typeof ee!="string")return null;var ae=ee.match(I[D]);return ae==null?null:V((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,n(1))},function(x,e){var n,r,k=x.exports={};function R(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function I(v){if(n===setTimeout)return setTimeout(v,0);if((n===R||!n)&&setTimeout)return n=setTimeout,setTimeout(v,0);try{return n(v,0)}catch{try{return n.call(null,v,0)}catch{return n.call(this,v,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:R}catch{n=R}try{r=typeof clearTimeout=="function"?clearTimeout:T}catch{r=T}})();var p,c=[],m=!1,u=-1;function d(){m&&p&&(m=!1,p.length?c=p.concat(c):u=-1,c.length&&w())}function w(){if(!m){var v=I(d);m=!0;for(var b=c.length;b;){for(p=c,c=[];++u<b;)p&&p[u].run();u=-1,b=c.length}p=null,m=!1,function($){if(r===clearTimeout)return clearTimeout($);if((r===T||!r)&&clearTimeout)return r=clearTimeout,clearTimeout($);try{r($)}catch{try{return r.call(null,$)}catch{return r.call(this,$)}}}(v)}}function f(v,b){this.fun=v,this.array=b}function g(){}k.nextTick=function(v){var b=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)b[$-1]=arguments[$];c.push(new f(v,b)),c.length!==1||m||I(w)},f.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=g,k.addListener=g,k.once=g,k.off=g,k.removeListener=g,k.removeAllListeners=g,k.emit=g,k.prependListener=g,k.prependOnceListener=g,k.listeners=function(v){return[]},k.binding=function(v){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(v){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ce[145],le([0,1]),function(x,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0;class r{constructor(I,p,c){this.level=I,this.key=p,this.value=c,this.forward=[]}}const k=void 0;class R{constructor(I,p=2**16){this.comparator=I,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(p)|0),this.e=new r(this.c,k,k)}get size(){return this.f}clear(){this.e=new r(this.c,k,k),this.f=0}has(I){return!!R.g(this,I,this.comparator)}get(I){return R.g(this,I,this.comparator)?.value}set(I,p){return R.h(this,I,p,this.comparator)&&(this.f+=1),this}delete(I){const p=R.k(this,I,this.comparator);return p&&(this.f-=1),p}forEach(I,p){let c=this.e.forward[0];for(;c;)I.call(p,c.value,c.key,this),c=c.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",p=this.e.forward[0];for(;p;)I+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return I}static g(I,p,c){let m=I.e;for(let u=I.d-1;u>=0;u--)for(;m.forward[u]&&c(m.forward[u].key,p)<0;)m=m.forward[u];if(m=m.forward[0],m&&c(m.key,p)===0)return m}static h(I,p,c,m){const u=[];let d=I.e;for(let w=I.d-1;w>=0;w--){for(;d.forward[w]&&m(d.forward[w].key,p)<0;)d=d.forward[w];u[w]=d}if(d=d.forward[0],d&&m(d.key,p)===0)return d.value=c,!1;{const w=R.j(I);if(w>I.d){for(let f=I.d;f<w;f++)u[f]=I.e;I.d=w}d=new r(w,p,c);for(let f=0;f<w;f++)d.forward[f]=u[f].forward[f],u[f].forward[f]=d;return!0}}static j(I,p=.5){let c=1;for(;Math.random()<p&&c<I.c;)c+=1;return c}static k(I,p,c){const m=[];let u=I.e;for(let d=I.d-1;d>=0;d--){for(;u.forward[d]&&c(u.forward[d].key,p)<0;)u=u.forward[d];m[d]=u}if(u=u.forward[0],!u||c(u.key,p)!==0)return!1;for(let d=0;d<I.d&&m[d].forward[d]===u;d++)m[d].forward[d]=u.forward[d];for(;I.d>0&&I.e.forward[I.d-1]===k;)I.d-=1;return!0}}e.$Ts=R}),define(ce[66],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class r{static create(R){return new r(R)}constructor(R){this.c=n&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$fe=r}),define(ce[4],le([0,1,15,89,2,108,66]),function(x,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$he=e.Event=void 0,e.$ie=w;const I=!1,p=!1,c=!1;var m;(function(q){q.None=()=>k.$Uc.None;function K(Ae){if(c){const{onDidAddListener:ve}=Ae,$e=g.create();let ee=0;Ae.onDidAddListener=()=>{++ee===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),ve?.()}}}function de(Ae,ve){return V(Ae,()=>{},0,void 0,!0,void 0,ve)}q.defer=de;function H(Ae){return(ve,$e=null,ee)=>{let ae=!1,fe;return fe=Ae(be=>{if(!ae)return fe?fe.dispose():ae=!0,ve.call($e,be)},null,ee),ae&&fe.dispose(),fe}}q.once=H;function Y(Ae,ve,$e){return X((ee,ae=null,fe)=>Ae(be=>ee.call(ae,ve(be)),null,fe),$e)}q.map=Y;function B(Ae,ve,$e){return X((ee,ae=null,fe)=>Ae(be=>{ve(be),ee.call(ae,be)},null,fe),$e)}q.forEach=B;function Q(Ae,ve,$e){return X((ee,ae=null,fe)=>Ae(be=>ve(be)&&ee.call(ae,be),null,fe),$e)}q.filter=Q;function W(Ae){return Ae}q.signal=W;function j(...Ae){return(ve,$e=null,ee)=>{const ae=(0,k.$Rc)(...Ae.map(fe=>fe(be=>ve.call($e,be))));return oe(ae,ee)}}q.any=j;function C(Ae,ve,$e,ee){let ae=$e;return Y(Ae,fe=>(ae=ve(ae,fe),ae),ee)}q.reduce=C;function X(Ae,ve){let $e;const ee={onWillAddFirstListener(){$e=Ae(ae.fire,ae)},onDidRemoveLastListener(){$e?.dispose()}};ve||K(ee);const ae=new t(ee);return ve?.add(ae),ae.event}function oe(Ae,ve){return ve instanceof Array?ve.push(Ae):ve&&ve.add(Ae),Ae}function V(Ae,ve,$e=100,ee=!1,ae=!1,fe,be){let Re,Fe,Me,De=0,Ue;const Ge={leakWarningThreshold:fe,onWillAddFirstListener(){Re=Ae(qe=>{De++,Fe=ve(Fe,qe),ee&&!Me&&(Qe.fire(Fe),Fe=void 0),Ue=()=>{const Xe=Fe;Fe=void 0,Me=void 0,(!ee||De>1)&&Qe.fire(Xe),De=0},typeof $e=="number"?(clearTimeout(Me),Me=setTimeout(Ue,$e)):Me===void 0&&(Me=0,queueMicrotask(Ue))})},onWillRemoveListener(){ae&&De>0&&Ue?.()},onDidRemoveLastListener(){Ue=void 0,Re.dispose()}};be||K(Ge);const Qe=new t(Ge);return be?.add(Qe),Qe.event}q.debounce=V;function ue(Ae,ve=0,$e){return q.debounce(Ae,(ee,ae)=>ee?(ee.push(ae),ee):[ae],ve,void 0,!0,void 0,$e)}q.accumulate=ue;function re(Ae,ve=(ee,ae)=>ee===ae,$e){let ee=!0,ae;return Q(Ae,fe=>{const be=ee||!ve(fe,ae);return ee=!1,ae=fe,be},$e)}q.latch=re;function J(Ae,ve,$e){return[q.filter(Ae,ve,$e),q.filter(Ae,ee=>!ve(ee),$e)]}q.split=J;function F(Ae,ve=!1,$e=[],ee){let ae=$e.slice(),fe=Ae(Fe=>{ae?ae.push(Fe):Re.fire(Fe)});ee&&ee.add(fe);const be=()=>{ae?.forEach(Fe=>Re.fire(Fe)),ae=null},Re=new t({onWillAddFirstListener(){fe||(fe=Ae(Fe=>Re.fire(Fe)),ee&&ee.add(fe))},onDidAddFirstListener(){ae&&(ve?setTimeout(be):be())},onDidRemoveLastListener(){fe&&fe.dispose(),fe=null}});return ee&&ee.add(Re),Re.event}q.buffer=F;function N(Ae,ve){return(ee,ae,fe)=>{const be=ve(new z);return Ae(function(Re){const Fe=be.evaluate(Re);Fe!==_&&ee.call(ae,Fe)},void 0,fe)}}q.chain=N;const _=Symbol("HaltChainable");class z{constructor(){this.f=[]}map(ve){return this.f.push(ve),this}forEach(ve){return this.f.push($e=>(ve($e),$e)),this}filter(ve){return this.f.push($e=>ve($e)?$e:_),this}reduce(ve,$e){let ee=$e;return this.f.push(ae=>(ee=ve(ee,ae),ee)),this}latch(ve=($e,ee)=>$e===ee){let $e=!0,ee;return this.f.push(ae=>{const fe=$e||!ve(ae,ee);return $e=!1,ee=ae,fe?ae:_}),this}evaluate(ve){for(const $e of this.f)if(ve=$e(ve),ve===_)break;return ve}}function ie(Ae,ve,$e=ee=>ee){const ee=(...Re)=>be.fire($e(...Re)),ae=()=>Ae.on(ve,ee),fe=()=>Ae.removeListener(ve,ee),be=new t({onWillAddFirstListener:ae,onDidRemoveLastListener:fe});return be.event}q.fromNodeEventEmitter=ie;function G(Ae,ve,$e=ee=>ee){const ee=(...Re)=>be.fire($e(...Re)),ae=()=>Ae.addEventListener(ve,ee),fe=()=>Ae.removeEventListener(ve,ee),be=new t({onWillAddFirstListener:ae,onDidRemoveLastListener:fe});return be.event}q.fromDOMEventEmitter=G;function U(Ae){return new Promise(ve=>H(Ae)(ve))}q.toPromise=U;function te(Ae){const ve=new t;return Ae.then($e=>{ve.fire($e)},()=>{ve.fire(void 0)}).finally(()=>{ve.dispose()}),ve.event}q.fromPromise=te;function he(Ae,ve){return Ae($e=>ve.fire($e))}q.forward=he;function me(Ae,ve,$e){return ve($e),Ae(ee=>ve(ee))}q.runAndSubscribe=me;class we{constructor(ve,$e){this._observable=ve,this.f=0,this.g=!1;const ee={onWillAddFirstListener:()=>{ve.addObserver(this)},onDidRemoveLastListener:()=>{ve.removeObserver(this)}};$e||K(ee),this.emitter=new t(ee),$e&&$e.add(this.emitter)}beginUpdate(ve){this.f++}handlePossibleChange(ve){}handleChange(ve,$e){this.g=!0}endUpdate(ve){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ie(Ae,ve){return new we(Ae,ve).emitter.event}q.fromObservable=Ie;function Ce(Ae){return(ve,$e,ee)=>{let ae=0,fe=!1;const be={beginUpdate(){ae++},endUpdate(){ae--,ae===0&&(Ae.reportChanges(),fe&&(fe=!1,ve.call($e)))},handlePossibleChange(){},handleChange(){fe=!0}};Ae.addObserver(be),Ae.reportChanges();const Re={dispose(){Ae.removeObserver(be)}};return ee instanceof k.$Tc?ee.add(Re):Array.isArray(ee)&&ee.push(Re),Re}}q.fromObservableLight=Ce})(m||(e.Event=m={}));class u{static{this.all=new Set}static{this.f=0}constructor(K){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${K}_${u.f++}`,u.all.add(this)}start(K){this.g=new T.$fe,this.listenerCount=K}stop(){if(this.g){const K=this.g.elapsed();this.durations.push(K),this.elapsedOverall+=K,this.invocationCount+=1,this.g=void 0}}}e.$he=u;let d=-1;function w(q){const K=d;return d=q,{dispose(){d=K}}}class f{static{this.f=1}constructor(K,de,H=(f.f++).toString(16).padStart(3,"0")){this.j=K,this.threshold=de,this.name=H,this.h=0}dispose(){this.g?.clear()}check(K,de){const H=this.threshold;if(H<=0||de<H)return;this.g||(this.g=new Map);const Y=this.g.get(K.value)||0;if(this.g.set(K.value,Y+1),this.h-=1,this.h<=0){this.h=H*.5;const[B,Q]=this.getMostFrequentStack(),W=`[${this.name}] potential listener LEAK detected, having ${de} listeners already. MOST frequent listener (${Q}):`;console.warn(W),console.warn(B);const j=new v(W,B);this.j(j)}return()=>{const B=this.g.get(K.value)||0;this.g.set(K.value,B-1)}}getMostFrequentStack(){if(!this.g)return;let K,de=0;for(const[H,Y]of this.g)(!K||de<Y)&&(K=[H,Y],de=Y);return K}}class g{static create(){const K=new Error;return new g(K.stack??"")}constructor(K){this.value=K}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v extends Error{constructor(K,de){super(K),this.name="ListenerLeakError",this.stack=de}}e.$je=v;class b extends Error{constructor(K,de){super(K),this.name="ListenerRefusalError",this.stack=de}}e.$ke=b;let $=0;class P{constructor(K){this.value=K,this.id=$++}}const E=2,i=(q,K)=>{if(q instanceof P)K(q);else for(let de=0;de<q.length;de++){const H=q[de];H&&K(H)}};let h;if(I){const q=[];setInterval(()=>{q.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(q.join(`
`)),q.length=0)},3e3),h=new FinalizationRegistry(K=>{typeof K=="string"&&q.push(K)})}class t{constructor(K){this.z=0,this.f=K,this.g=d>0||this.f?.leakWarningThreshold?new f(K?.onListenerError??n.$Y,this.f?.leakWarningThreshold??d):void 0,this.j=this.f?._profName?new u(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(p){const K=this.u;queueMicrotask(()=>{i(K,de=>de.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(K,de,H)=>{if(this.g&&this.z>this.g.threshold**2){const j=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(j);const C=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],X=new b(`${j}. HINT: Stack shows most frequent listener (${C[1]}-times)`,C[0]);return(this.f?.onListenerError||n.$Y)(X),k.$Uc.None}if(this.m)return k.$Uc.None;de&&(K=K.bind(de));const Y=new P(K);let B,Q;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(Y.stack=g.create(),B=this.g.check(Y.stack,this.z+1)),p&&(Y.stack=Q??g.create()),this.u?this.u instanceof P?(this.w??=new s,this.u=[this.u,Y]):this.u.push(Y):(this.f?.onWillAddFirstListener?.(this),this.u=Y,this.f?.onDidAddFirstListener?.(this)),this.z++;const W=(0,k.$Sc)(()=>{h?.unregister(W),B?.(),this.A(Y)});if(H instanceof k.$Tc?H.add(W):Array.isArray(H)&&H.push(W),h){const j=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),C=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(j);h.register(W,C?.[2]??j,W)}return W},this.q}A(K){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const de=this.u,H=de.indexOf(K);if(H===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,de[H]=void 0;const Y=this.w.current===this;if(this.z*E<=de.length){let B=0;for(let Q=0;Q<de.length;Q++)de[Q]?de[B++]=de[Q]:Y&&(this.w.end--,B<this.w.i&&this.w.i--);de.length=B}}B(K,de){if(!K)return;const H=this.f?.onListenerError||n.$Y;if(!H){K.value(de);return}try{K.value(de)}catch(Y){H(Y)}}C(K){const de=K.current.u;for(;K.i<K.end;)this.B(de[K.i++],K.value);K.reset()}fire(K){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof P)this.B(this.u,K);else{const de=this.w;de.enqueue(this,K,this.u.length),this.C(de)}this.j?.stop()}hasListeners(){return this.z>0}}e.$le=t;const o=()=>new s;e.$me=o;class s{constructor(){this.i=-1,this.end=0}enqueue(K,de,H){this.i=0,this.end=H,this.current=K,this.value=de}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class a extends t{async fireAsync(K,de,H){if(this.u)for(this.h||(this.h=new R.$5c),i(this.u,Y=>this.h.push([Y.value,K]));this.h.size>0&&!de.isCancellationRequested;){const[Y,B]=this.h.shift(),Q=[],W={...B,token:de,waitUntil:j=>{if(Object.isFrozen(Q))throw new Error("waitUntil can NOT be called asynchronous");H&&(j=H(j,Y)),Q.push(j)}};try{Y(W)}catch(j){(0,n.$Y)(j);continue}Object.freeze(Q),await Promise.allSettled(Q).then(j=>{for(const C of j)C.status==="rejected"&&(0,n.$Y)(C.reason)})}}}e.$ne=a;class l extends t{get isPaused(){return this.h!==0}constructor(K){super(K),this.h=0,this.s=new R.$5c,this.t=K?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const K=Array.from(this.s);this.s.clear(),super.fire(this.t(K))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(K){this.z&&(this.h!==0?this.s.push(K):super.fire(K))}}e.$oe=l;class S extends l{constructor(K){super(K),this.k=K.delay??100}fire(K){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(K)}}e.$pe=S;class y extends t{constructor(K){super(K),this.h=[],this.k=K?.merge}fire(K){this.hasListeners()&&(this.h.push(K),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(de=>super.fire(de)),this.h=[]}))}}e.$qe=y;class A{constructor(){this.g=!1,this.h=[],this.f=new t({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(K){const de={event:K,listener:null};this.h.push(de),this.g&&this.m(de);const H=()=>{this.g&&this.o(de);const Y=this.h.indexOf(de);this.h.splice(Y,1)};return(0,k.$Sc)((0,r.$cb)(H))}j(){this.g=!0,this.h.forEach(K=>this.m(K))}k(){this.g=!1,this.h.forEach(K=>this.o(K))}m(K){K.listener=K.event(de=>this.f.fire(de))}o(K){K.listener?.dispose(),K.listener=null}dispose(){this.f.dispose();for(const K of this.h)K.listener?.dispose();this.h=[]}}e.$re=A;class L{constructor(K,de,H,Y){this.f=new k.$Tc;const B=this.f.add(new A),Q=this.f.add(new k.$4c);function W(j){Q.set(j,B.add(Y(j)))}for(const j of K)W(j);this.f.add(de(j=>{W(j)})),this.f.add(H(j=>{Q.deleteAndDispose(j)})),this.event=B.event}dispose(){this.f.dispose()}}e.$se=L;class D{constructor(){this.f=[]}wrapEvent(K,de,H){return(Y,B,Q)=>K(W=>{const j=this.f[this.f.length-1];if(!de){j?j.buffers.push(()=>Y.call(B,W)):Y.call(B,W);return}const C=j;if(!C){Y.call(B,de(H,W));return}C.items??=[],C.items.push(W),C.buffers.length===0&&j.buffers.push(()=>{C.reducedResult??=H?C.items.reduce(de,H):C.items.reduce(de),Y.call(B,C.reducedResult)})},void 0,Q)}bufferEvents(K){const de={buffers:new Array};this.f.push(de);const H=K();return this.f.pop(),de.buffers.forEach(Y=>Y()),H}}e.$te=D;class O{constructor(){this.f=!1,this.g=m.None,this.h=k.$Uc.None,this.j=new t({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(K){this.g=K,this.f&&(this.h.dispose(),this.h=K(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ue=O;class M{static const(K){return new Z(K)}constructor(K){this.g=K,this.f=new t,this.onDidChange=this.f.event}get value(){return this.g}set value(K){K!==this.g&&(this.g=K,this.f.fire(void 0))}}e.$ve=M;class Z{constructor(K){this.value=K,this.onDidChange=m.None}}}),define(ce[22],le([0,1,4]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.CancellationToken=void 0,e.$xe=I;const r=Object.freeze(function(p,c){const m=setTimeout(p.bind(c),0);return{dispose(){clearTimeout(m)}}});var k;(function(p){function c(m){return m===p.None||m===p.Cancelled||m instanceof R?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}p.isCancellationToken=c,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(k||(e.CancellationToken=k={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?r:(this.b||(this.b=new n.$le),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=k.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=k.None}}e.$we=T;function I(p){const c=new T;return p.add({dispose(){c.cancel()}}),c.token}}),define(ce[146],le([0,1,22]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_e=e.$$e=e.$9e=void 0,e.$0e=k;class r{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new n.$we,c=this.b(p.token);return this.a={promise:c,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$9e=r;function k(I){return I}class R{constructor(p,c){this.a=void 0,this.b=void 0,typeof p=="function"?(this.c=p,this.d=k):(this.c=c,this.d=p.getCacheKey)}get(p){const c=this.d(p);return this.b!==c&&(this.b=c,this.a=this.c(p)),this.a}}e.$$e=R;class T{get cachedValues(){return this.a}constructor(p,c){this.a=new Map,this.b=new Map,typeof p=="function"?(this.c=p,this.d=k):(this.c=c,this.d=p.getCacheKey)}get(p){const c=this.d(p);if(this.b.has(c))return this.b.get(c);const m=this.c(p);return this.a.set(p,m),this.b.set(c,m),m}}e.$_e=T}),define(ce[67],le([0,1,15,2]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=k,e.$ze=R,e.$Ae=T,e.$Be=I,e.$Ce=c,e.$De=m,e.$Ee=u,e.$Fe=d,e.$Ge=w,e.$He=f,e.$Ie=g,e.$Je=v,e.$Ke=b,e.$Le=$,e.$Me=P;function k(E){const i=E;return i?typeof i.read=="function":!1}function R(E){const i=E;return i?[i.on,i.pause,i.resume,i.destroy].every(h=>typeof h=="function"):!1}function T(E){const i=E;return i?R(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function I(E,i){return new p(E,i)}class p{constructor(i,h){this.e=i,this.f=h,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(h=>this.d.push(h))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(h=>h(i))}h(i){this.c.error.length===0?(0,n.$Y)(i):this.c.error.slice(0).forEach(h=>h(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,h){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(h),this.resume();break;case"end":this.c.end.push(h),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(h),this.a.flowing&&this.k();break}}removeListener(i,h){if(this.a.destroyed)return;let t;switch(i){case"data":t=this.c.data;break;case"end":t=this.c.end;break;case"error":t=this.c.error;break}if(t){const o=t.indexOf(h);o>=0&&t.splice(o,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const h=[...this.d];this.d.length=0,h.forEach(t=>t())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(E,i){const h=[];let t;for(;(t=E.read())!==null;)h.push(t);return i(h)}function m(E,i,h){const t=[];let o;for(;(o=E.read())!==null&&t.length<h;)t.push(o);return o===null&&t.length>0?i(t):{read:()=>{if(t.length>0)return t.shift();if(typeof o<"u"){const s=o;return o=void 0,s}return E.read()}}}function u(E,i){return new Promise((h,t)=>{const o=[];d(E,{onData:s=>{i&&o.push(s)},onError:s=>{i?t(s):h(void 0)},onEnd:()=>{h(i?i(o):void 0)}})})}function d(E,i,h){E.on("error",t=>{h?.isCancellationRequested||i.onError(t)}),E.on("end",()=>{h?.isCancellationRequested||i.onEnd()}),E.on("data",t=>{h?.isCancellationRequested||i.onData(t)})}function w(E,i){return new Promise((h,t)=>{const o=new r.$Tc,s=[],a=y=>{if(s.push(y),s.length>i)return o.dispose(),E.pause(),h({stream:E,buffer:s,ended:!1})},l=y=>(o.dispose(),t(y)),S=()=>(o.dispose(),h({stream:E,buffer:s,ended:!0}));o.add((0,r.$Sc)(()=>E.removeListener("error",l))),E.on("error",l),o.add((0,r.$Sc)(()=>E.removeListener("end",S))),E.on("end",S),o.add((0,r.$Sc)(()=>E.removeListener("data",a))),E.on("data",a)})}function f(E,i){const h=I(i);return h.end(E),h}function g(){const E=I(()=>{throw new Error("not supported")});return E.end(),E}function v(E){let i=!1;return{read:()=>i?null:(i=!0,E)}}function b(E,i,h){const t=I(h);return d(E,{onData:o=>t.write(i.data(o)),onError:o=>t.error(i.error?i.error(o):o),onEnd:()=>t.end()}),t}function $(E,i,h){let t=!1;return{read:()=>{const o=i.read();return t?o:(t=!0,o!==null?h([E,o]):E)}}}function P(E,i,h){let t=!1;const o=I(h);return d(i,{onData:s=>t?o.write(s):(t=!0,o.write(h([E,s]))),onError:s=>o.error(s),onEnd:()=>{t||(t=!0,o.write(E)),o.end()}}),o}}),define(ce[17],le([0,1,65,67]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=void 0,e.$Oe=c,e.$Pe=m,e.$Qe=u,e.$Re=d,e.$Se=w,e.$Te=f,e.$Ue=g,e.$Ve=v,e.$We=b,e.$Xe=$,e.$Ye=P,e.$Ze=E,e.$1e=i,e.$2e=h,e.$3e=t,e.$4e=o,e.$5e=s,e.$6e=a,e.$7e=l,e.$8e=A,r=Pe(r);const k=typeof Buffer<"u",R=new n.$T(()=>new Uint8Array(256));let T,I;class p{static alloc(D){return k?new p(Buffer.allocUnsafe(D)):new p(new Uint8Array(D))}static wrap(D){return k&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new p(D)}static fromString(D,O){return!(O?.dontUseNodeBuffer||!1)&&k?new p(Buffer.from(D)):(T||(T=new TextEncoder),new p(T.encode(D)))}static fromByteArray(D){const O=p.alloc(D.length);for(let M=0,Z=D.length;M<Z;M++)O.buffer[M]=D[M];return O}static concat(D,O){if(typeof O>"u"){O=0;for(let q=0,K=D.length;q<K;q++)O+=D[q].byteLength}const M=p.alloc(O);let Z=0;for(let q=0,K=D.length;q<K;q++){const de=D[q];M.set(de,Z),Z+=de.byteLength}return M}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=p.alloc(this.byteLength);return D.set(this),D}toString(){return k?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(D,O){return new p(this.buffer.subarray(D,O))}set(D,O){if(D instanceof p)this.buffer.set(D.buffer,O);else if(D instanceof Uint8Array)this.buffer.set(D,O);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),O);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return d(this.buffer,D)}writeUInt32BE(D,O){w(this.buffer,D,O)}readUInt32LE(D){return f(this.buffer,D)}writeUInt32LE(D,O){g(this.buffer,D,O)}readUInt8(D){return v(this.buffer,D)}writeUInt8(D,O){b(this.buffer,D,O)}indexOf(D,O=0){return c(this.buffer,D instanceof p?D.buffer:D,O)}}e.$Ne=p;function c(L,D,O=0){const M=D.byteLength,Z=L.byteLength;if(M===0)return 0;if(M===1)return L.indexOf(D[0]);if(M>Z-O)return-1;const q=R.value;q.fill(D.length);for(let Y=0;Y<D.length;Y++)q[D[Y]]=D.length-Y-1;let K=O+D.length-1,de=K,H=-1;for(;K<Z;)if(L[K]===D[de]){if(de===0){H=K;break}K--,de--}else K+=Math.max(D.length-de,q[L[K]]),de=D.length-1;return H}function m(L,D){return L[D+0]<<0>>>0|L[D+1]<<8>>>0}function u(L,D,O){L[O+0]=D&255,D=D>>>8,L[O+1]=D&255}function d(L,D){return L[D]*2**24+L[D+1]*2**16+L[D+2]*2**8+L[D+3]}function w(L,D,O){L[O+3]=D,D=D>>>8,L[O+2]=D,D=D>>>8,L[O+1]=D,D=D>>>8,L[O]=D}function f(L,D){return L[D+0]<<0>>>0|L[D+1]<<8>>>0|L[D+2]<<16>>>0|L[D+3]<<24>>>0}function g(L,D,O){L[O+0]=D&255,D=D>>>8,L[O+1]=D&255,D=D>>>8,L[O+2]=D&255,D=D>>>8,L[O+3]=D&255}function v(L,D){return L[D]}function b(L,D,O){L[O]=D}function $(L){return r.$Ce(L,D=>p.concat(D))}function P(L){return r.$Je(L)}function E(L){return r.$Ee(L,D=>p.concat(D))}async function i(L){return L.ended?p.concat(L.buffer):p.concat([...L.buffer,await E(L.stream)])}function h(L){return r.$He(L,D=>p.concat(D))}function t(L){return r.$Ke(L,{data:D=>typeof D=="string"?p.fromString(D):p.wrap(D)},D=>p.concat(D))}function o(L){return r.$Be(D=>p.concat(D),L)}function s(L,D){return r.$Le(L,D,O=>p.concat(O))}function a(L,D){return r.$Me(L,D,O=>p.concat(O))}function l(L){let D=0,O=0,M=0;const Z=new Uint8Array(Math.floor(L.length/4*3)),q=de=>{switch(O){case 3:Z[M++]=D|de,O=0;break;case 2:Z[M++]=D|de>>>2,D=de<<6,O=3;break;case 1:Z[M++]=D|de>>>4,D=de<<4,O=2;break;default:D=de<<2,O=1}};for(let de=0;de<L.length;de++){const H=L.charCodeAt(de);if(H>=65&&H<=90)q(H-65);else if(H>=97&&H<=122)q(H-97+26);else if(H>=48&&H<=57)q(H-48+52);else if(H===43||H===45)q(62);else if(H===47||H===95)q(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${L[de]}`)}}const K=M;for(;O>0;)q(0);return p.wrap(Z).slice(0,K)}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function A({buffer:L},D=!0,O=!1){const M=O?y:S;let Z="";const q=L.byteLength%3;let K=0;for(;K<L.byteLength-q;K+=3){const de=L[K+0],H=L[K+1],Y=L[K+2];Z+=M[de>>>2],Z+=M[(de<<4|H>>>4)&63],Z+=M[(H<<2|Y>>>6)&63],Z+=M[Y&63]}if(q===1){const de=L[K+0];Z+=M[de>>>2],Z+=M[de<<4&63],D&&(Z+="==")}else if(q===2){const de=L[K+0],H=L[K+1];Z+=M[de>>>2],Z+=M[(de<<4|H>>>4)&63],Z+=M[H<<2&63],D&&(Z+="=")}return Z}}),define(ce[147],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0,e.$ge=Symbol("MicrotaskDelay")}),define(ce[11],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=n,e.$fg=r,e.$gg=k,e.$hg=R,e.$ig=T,e.$jg=I,e.$kg=p,e.$lg=c,e.$mg=m,e.$ng=u,e.$og=d,e.$pg=w,e.$qg=f,e.$rg=v,e.$sg=b,e.$tg=$,e.$ug=P,e.$vg=E,e.$wg=i;function n(h){return typeof h=="string"}function r(h){return Array.isArray(h)&&h.every(t=>n(t))}function k(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}function R(h){const t=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof t}function T(h){return typeof h=="number"&&!isNaN(h)}function I(h){return!!h&&typeof h[Symbol.iterator]=="function"}function p(h){return h===!0||h===!1}function c(h){return typeof h>"u"}function m(h){return!u(h)}function u(h){return c(h)||h===null}function d(h,t){if(!h)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function w(h){if(u(h))throw new Error("Assertion Failed: argument is undefined or null");return h}function f(...h){const t=[];for(let o=0;o<h.length;o++){const s=h[o];if(u(s))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(s)}return t}const g=Object.prototype.hasOwnProperty;function v(h){if(!k(h))return!1;for(const t in h)if(g.call(h,t))return!1;return!0}function b(h){return typeof h=="function"}function $(...h){return h.length>0&&h.every(b)}function P(h,t){const o=Math.min(h.length,t.length);for(let s=0;s<o;s++)E(h[s],t[s])}function E(h,t){if(n(t)){if(typeof h!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(b(t)){try{if(h instanceof t)return}catch{}if(!u(h)&&h.constructor===t||t.length===1&&t.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function i(h){return h}}),define(ce[109],le([0,1,11]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=k,e.$1j=R;const r=Object.create(null);function k(T,I){if((0,n.$eg)(I)){const p=r[I];if(p===void 0)throw new Error(`${T} references an unknown codicon: ${I}`);I=p}return r[T]=I,{id:T}}function R(){return r}}),define(ce[148],le([0,1,109]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=void 0,e.$2j={add:(0,n.$Zj)("add",6e4),plus:(0,n.$Zj)("plus",6e4),gistNew:(0,n.$Zj)("gist-new",6e4),repoCreate:(0,n.$Zj)("repo-create",6e4),lightbulb:(0,n.$Zj)("lightbulb",60001),lightBulb:(0,n.$Zj)("light-bulb",60001),repo:(0,n.$Zj)("repo",60002),repoDelete:(0,n.$Zj)("repo-delete",60002),gistFork:(0,n.$Zj)("gist-fork",60003),repoForked:(0,n.$Zj)("repo-forked",60003),gitPullRequest:(0,n.$Zj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Zj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Zj)("record-keys",60005),keyboard:(0,n.$Zj)("keyboard",60005),tag:(0,n.$Zj)("tag",60006),gitPullRequestLabel:(0,n.$Zj)("git-pull-request-label",60006),tagAdd:(0,n.$Zj)("tag-add",60006),tagRemove:(0,n.$Zj)("tag-remove",60006),person:(0,n.$Zj)("person",60007),personFollow:(0,n.$Zj)("person-follow",60007),personOutline:(0,n.$Zj)("person-outline",60007),personFilled:(0,n.$Zj)("person-filled",60007),gitBranch:(0,n.$Zj)("git-branch",60008),gitBranchCreate:(0,n.$Zj)("git-branch-create",60008),gitBranchDelete:(0,n.$Zj)("git-branch-delete",60008),sourceControl:(0,n.$Zj)("source-control",60008),mirror:(0,n.$Zj)("mirror",60009),mirrorPublic:(0,n.$Zj)("mirror-public",60009),star:(0,n.$Zj)("star",60010),starAdd:(0,n.$Zj)("star-add",60010),starDelete:(0,n.$Zj)("star-delete",60010),starEmpty:(0,n.$Zj)("star-empty",60010),comment:(0,n.$Zj)("comment",60011),commentAdd:(0,n.$Zj)("comment-add",60011),alert:(0,n.$Zj)("alert",60012),warning:(0,n.$Zj)("warning",60012),search:(0,n.$Zj)("search",60013),searchSave:(0,n.$Zj)("search-save",60013),logOut:(0,n.$Zj)("log-out",60014),signOut:(0,n.$Zj)("sign-out",60014),logIn:(0,n.$Zj)("log-in",60015),signIn:(0,n.$Zj)("sign-in",60015),eye:(0,n.$Zj)("eye",60016),eyeUnwatch:(0,n.$Zj)("eye-unwatch",60016),eyeWatch:(0,n.$Zj)("eye-watch",60016),circleFilled:(0,n.$Zj)("circle-filled",60017),primitiveDot:(0,n.$Zj)("primitive-dot",60017),closeDirty:(0,n.$Zj)("close-dirty",60017),debugBreakpoint:(0,n.$Zj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Zj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Zj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Zj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Zj)("primitive-square",60018),edit:(0,n.$Zj)("edit",60019),pencil:(0,n.$Zj)("pencil",60019),info:(0,n.$Zj)("info",60020),issueOpened:(0,n.$Zj)("issue-opened",60020),gistPrivate:(0,n.$Zj)("gist-private",60021),gitForkPrivate:(0,n.$Zj)("git-fork-private",60021),lock:(0,n.$Zj)("lock",60021),mirrorPrivate:(0,n.$Zj)("mirror-private",60021),close:(0,n.$Zj)("close",60022),removeClose:(0,n.$Zj)("remove-close",60022),x:(0,n.$Zj)("x",60022),repoSync:(0,n.$Zj)("repo-sync",60023),sync:(0,n.$Zj)("sync",60023),clone:(0,n.$Zj)("clone",60024),desktopDownload:(0,n.$Zj)("desktop-download",60024),beaker:(0,n.$Zj)("beaker",60025),microscope:(0,n.$Zj)("microscope",60025),vm:(0,n.$Zj)("vm",60026),deviceDesktop:(0,n.$Zj)("device-desktop",60026),file:(0,n.$Zj)("file",60027),fileText:(0,n.$Zj)("file-text",60027),more:(0,n.$Zj)("more",60028),ellipsis:(0,n.$Zj)("ellipsis",60028),kebabHorizontal:(0,n.$Zj)("kebab-horizontal",60028),mailReply:(0,n.$Zj)("mail-reply",60029),reply:(0,n.$Zj)("reply",60029),organization:(0,n.$Zj)("organization",60030),organizationFilled:(0,n.$Zj)("organization-filled",60030),organizationOutline:(0,n.$Zj)("organization-outline",60030),newFile:(0,n.$Zj)("new-file",60031),fileAdd:(0,n.$Zj)("file-add",60031),newFolder:(0,n.$Zj)("new-folder",60032),fileDirectoryCreate:(0,n.$Zj)("file-directory-create",60032),trash:(0,n.$Zj)("trash",60033),trashcan:(0,n.$Zj)("trashcan",60033),history:(0,n.$Zj)("history",60034),clock:(0,n.$Zj)("clock",60034),folder:(0,n.$Zj)("folder",60035),fileDirectory:(0,n.$Zj)("file-directory",60035),symbolFolder:(0,n.$Zj)("symbol-folder",60035),logoGithub:(0,n.$Zj)("logo-github",60036),markGithub:(0,n.$Zj)("mark-github",60036),github:(0,n.$Zj)("github",60036),terminal:(0,n.$Zj)("terminal",60037),console:(0,n.$Zj)("console",60037),repl:(0,n.$Zj)("repl",60037),zap:(0,n.$Zj)("zap",60038),symbolEvent:(0,n.$Zj)("symbol-event",60038),error:(0,n.$Zj)("error",60039),stop:(0,n.$Zj)("stop",60039),variable:(0,n.$Zj)("variable",60040),symbolVariable:(0,n.$Zj)("symbol-variable",60040),array:(0,n.$Zj)("array",60042),symbolArray:(0,n.$Zj)("symbol-array",60042),symbolModule:(0,n.$Zj)("symbol-module",60043),symbolPackage:(0,n.$Zj)("symbol-package",60043),symbolNamespace:(0,n.$Zj)("symbol-namespace",60043),symbolObject:(0,n.$Zj)("symbol-object",60043),symbolMethod:(0,n.$Zj)("symbol-method",60044),symbolFunction:(0,n.$Zj)("symbol-function",60044),symbolConstructor:(0,n.$Zj)("symbol-constructor",60044),symbolBoolean:(0,n.$Zj)("symbol-boolean",60047),symbolNull:(0,n.$Zj)("symbol-null",60047),symbolNumeric:(0,n.$Zj)("symbol-numeric",60048),symbolNumber:(0,n.$Zj)("symbol-number",60048),symbolStructure:(0,n.$Zj)("symbol-structure",60049),symbolStruct:(0,n.$Zj)("symbol-struct",60049),symbolParameter:(0,n.$Zj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Zj)("symbol-type-parameter",60050),symbolKey:(0,n.$Zj)("symbol-key",60051),symbolText:(0,n.$Zj)("symbol-text",60051),symbolReference:(0,n.$Zj)("symbol-reference",60052),goToFile:(0,n.$Zj)("go-to-file",60052),symbolEnum:(0,n.$Zj)("symbol-enum",60053),symbolValue:(0,n.$Zj)("symbol-value",60053),symbolRuler:(0,n.$Zj)("symbol-ruler",60054),symbolUnit:(0,n.$Zj)("symbol-unit",60054),activateBreakpoints:(0,n.$Zj)("activate-breakpoints",60055),archive:(0,n.$Zj)("archive",60056),arrowBoth:(0,n.$Zj)("arrow-both",60057),arrowDown:(0,n.$Zj)("arrow-down",60058),arrowLeft:(0,n.$Zj)("arrow-left",60059),arrowRight:(0,n.$Zj)("arrow-right",60060),arrowSmallDown:(0,n.$Zj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Zj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Zj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Zj)("arrow-small-up",60064),arrowUp:(0,n.$Zj)("arrow-up",60065),bell:(0,n.$Zj)("bell",60066),bold:(0,n.$Zj)("bold",60067),book:(0,n.$Zj)("book",60068),bookmark:(0,n.$Zj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Zj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Zj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Zj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Zj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Zj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Zj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Zj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Zj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Zj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Zj)("briefcase",60076),broadcast:(0,n.$Zj)("broadcast",60077),browser:(0,n.$Zj)("browser",60078),bug:(0,n.$Zj)("bug",60079),calendar:(0,n.$Zj)("calendar",60080),caseSensitive:(0,n.$Zj)("case-sensitive",60081),check:(0,n.$Zj)("check",60082),checklist:(0,n.$Zj)("checklist",60083),chevronDown:(0,n.$Zj)("chevron-down",60084),chevronLeft:(0,n.$Zj)("chevron-left",60085),chevronRight:(0,n.$Zj)("chevron-right",60086),chevronUp:(0,n.$Zj)("chevron-up",60087),chromeClose:(0,n.$Zj)("chrome-close",60088),chromeMaximize:(0,n.$Zj)("chrome-maximize",60089),chromeMinimize:(0,n.$Zj)("chrome-minimize",60090),chromeRestore:(0,n.$Zj)("chrome-restore",60091),circleOutline:(0,n.$Zj)("circle-outline",60092),circle:(0,n.$Zj)("circle",60092),debugBreakpointUnverified:(0,n.$Zj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Zj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Zj)("circle-slash",60093),circuitBoard:(0,n.$Zj)("circuit-board",60094),clearAll:(0,n.$Zj)("clear-all",60095),clippy:(0,n.$Zj)("clippy",60096),closeAll:(0,n.$Zj)("close-all",60097),cloudDownload:(0,n.$Zj)("cloud-download",60098),cloudUpload:(0,n.$Zj)("cloud-upload",60099),code:(0,n.$Zj)("code",60100),collapseAll:(0,n.$Zj)("collapse-all",60101),colorMode:(0,n.$Zj)("color-mode",60102),commentDiscussion:(0,n.$Zj)("comment-discussion",60103),creditCard:(0,n.$Zj)("credit-card",60105),dash:(0,n.$Zj)("dash",60108),dashboard:(0,n.$Zj)("dashboard",60109),database:(0,n.$Zj)("database",60110),debugContinue:(0,n.$Zj)("debug-continue",60111),debugDisconnect:(0,n.$Zj)("debug-disconnect",60112),debugPause:(0,n.$Zj)("debug-pause",60113),debugRestart:(0,n.$Zj)("debug-restart",60114),debugStart:(0,n.$Zj)("debug-start",60115),debugStepInto:(0,n.$Zj)("debug-step-into",60116),debugStepOut:(0,n.$Zj)("debug-step-out",60117),debugStepOver:(0,n.$Zj)("debug-step-over",60118),debugStop:(0,n.$Zj)("debug-stop",60119),debug:(0,n.$Zj)("debug",60120),deviceCameraVideo:(0,n.$Zj)("device-camera-video",60121),deviceCamera:(0,n.$Zj)("device-camera",60122),deviceMobile:(0,n.$Zj)("device-mobile",60123),diffAdded:(0,n.$Zj)("diff-added",60124),diffIgnored:(0,n.$Zj)("diff-ignored",60125),diffModified:(0,n.$Zj)("diff-modified",60126),diffRemoved:(0,n.$Zj)("diff-removed",60127),diffRenamed:(0,n.$Zj)("diff-renamed",60128),diff:(0,n.$Zj)("diff",60129),diffSidebyside:(0,n.$Zj)("diff-sidebyside",60129),discard:(0,n.$Zj)("discard",60130),editorLayout:(0,n.$Zj)("editor-layout",60131),emptyWindow:(0,n.$Zj)("empty-window",60132),exclude:(0,n.$Zj)("exclude",60133),extensions:(0,n.$Zj)("extensions",60134),eyeClosed:(0,n.$Zj)("eye-closed",60135),fileBinary:(0,n.$Zj)("file-binary",60136),fileCode:(0,n.$Zj)("file-code",60137),fileMedia:(0,n.$Zj)("file-media",60138),filePdf:(0,n.$Zj)("file-pdf",60139),fileSubmodule:(0,n.$Zj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Zj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Zj)("file-symlink-file",60142),fileZip:(0,n.$Zj)("file-zip",60143),files:(0,n.$Zj)("files",60144),filter:(0,n.$Zj)("filter",60145),flame:(0,n.$Zj)("flame",60146),foldDown:(0,n.$Zj)("fold-down",60147),foldUp:(0,n.$Zj)("fold-up",60148),fold:(0,n.$Zj)("fold",60149),folderActive:(0,n.$Zj)("folder-active",60150),folderOpened:(0,n.$Zj)("folder-opened",60151),gear:(0,n.$Zj)("gear",60152),gift:(0,n.$Zj)("gift",60153),gistSecret:(0,n.$Zj)("gist-secret",60154),gist:(0,n.$Zj)("gist",60155),gitCommit:(0,n.$Zj)("git-commit",60156),gitCompare:(0,n.$Zj)("git-compare",60157),compareChanges:(0,n.$Zj)("compare-changes",60157),gitMerge:(0,n.$Zj)("git-merge",60158),githubAction:(0,n.$Zj)("github-action",60159),githubAlt:(0,n.$Zj)("github-alt",60160),globe:(0,n.$Zj)("globe",60161),grabber:(0,n.$Zj)("grabber",60162),graph:(0,n.$Zj)("graph",60163),gripper:(0,n.$Zj)("gripper",60164),heart:(0,n.$Zj)("heart",60165),home:(0,n.$Zj)("home",60166),horizontalRule:(0,n.$Zj)("horizontal-rule",60167),hubot:(0,n.$Zj)("hubot",60168),inbox:(0,n.$Zj)("inbox",60169),issueReopened:(0,n.$Zj)("issue-reopened",60171),issues:(0,n.$Zj)("issues",60172),italic:(0,n.$Zj)("italic",60173),jersey:(0,n.$Zj)("jersey",60174),json:(0,n.$Zj)("json",60175),kebabVertical:(0,n.$Zj)("kebab-vertical",60176),key:(0,n.$Zj)("key",60177),law:(0,n.$Zj)("law",60178),lightbulbAutofix:(0,n.$Zj)("lightbulb-autofix",60179),linkExternal:(0,n.$Zj)("link-external",60180),link:(0,n.$Zj)("link",60181),listOrdered:(0,n.$Zj)("list-ordered",60182),listUnordered:(0,n.$Zj)("list-unordered",60183),liveShare:(0,n.$Zj)("live-share",60184),loading:(0,n.$Zj)("loading",60185),location:(0,n.$Zj)("location",60186),mailRead:(0,n.$Zj)("mail-read",60187),mail:(0,n.$Zj)("mail",60188),markdown:(0,n.$Zj)("markdown",60189),megaphone:(0,n.$Zj)("megaphone",60190),mention:(0,n.$Zj)("mention",60191),milestone:(0,n.$Zj)("milestone",60192),gitPullRequestMilestone:(0,n.$Zj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Zj)("mortar-board",60193),move:(0,n.$Zj)("move",60194),multipleWindows:(0,n.$Zj)("multiple-windows",60195),mute:(0,n.$Zj)("mute",60196),noNewline:(0,n.$Zj)("no-newline",60197),note:(0,n.$Zj)("note",60198),octoface:(0,n.$Zj)("octoface",60199),openPreview:(0,n.$Zj)("open-preview",60200),package:(0,n.$Zj)("package",60201),paintcan:(0,n.$Zj)("paintcan",60202),pin:(0,n.$Zj)("pin",60203),play:(0,n.$Zj)("play",60204),run:(0,n.$Zj)("run",60204),plug:(0,n.$Zj)("plug",60205),preserveCase:(0,n.$Zj)("preserve-case",60206),preview:(0,n.$Zj)("preview",60207),project:(0,n.$Zj)("project",60208),pulse:(0,n.$Zj)("pulse",60209),question:(0,n.$Zj)("question",60210),quote:(0,n.$Zj)("quote",60211),radioTower:(0,n.$Zj)("radio-tower",60212),reactions:(0,n.$Zj)("reactions",60213),references:(0,n.$Zj)("references",60214),refresh:(0,n.$Zj)("refresh",60215),regex:(0,n.$Zj)("regex",60216),remoteExplorer:(0,n.$Zj)("remote-explorer",60217),remote:(0,n.$Zj)("remote",60218),remove:(0,n.$Zj)("remove",60219),replaceAll:(0,n.$Zj)("replace-all",60220),replace:(0,n.$Zj)("replace",60221),repoClone:(0,n.$Zj)("repo-clone",60222),repoForcePush:(0,n.$Zj)("repo-force-push",60223),repoPull:(0,n.$Zj)("repo-pull",60224),repoPush:(0,n.$Zj)("repo-push",60225),report:(0,n.$Zj)("report",60226),requestChanges:(0,n.$Zj)("request-changes",60227),rocket:(0,n.$Zj)("rocket",60228),rootFolderOpened:(0,n.$Zj)("root-folder-opened",60229),rootFolder:(0,n.$Zj)("root-folder",60230),rss:(0,n.$Zj)("rss",60231),ruby:(0,n.$Zj)("ruby",60232),saveAll:(0,n.$Zj)("save-all",60233),saveAs:(0,n.$Zj)("save-as",60234),save:(0,n.$Zj)("save",60235),screenFull:(0,n.$Zj)("screen-full",60236),screenNormal:(0,n.$Zj)("screen-normal",60237),searchStop:(0,n.$Zj)("search-stop",60238),server:(0,n.$Zj)("server",60240),settingsGear:(0,n.$Zj)("settings-gear",60241),settings:(0,n.$Zj)("settings",60242),shield:(0,n.$Zj)("shield",60243),smiley:(0,n.$Zj)("smiley",60244),sortPrecedence:(0,n.$Zj)("sort-precedence",60245),splitHorizontal:(0,n.$Zj)("split-horizontal",60246),splitVertical:(0,n.$Zj)("split-vertical",60247),squirrel:(0,n.$Zj)("squirrel",60248),starFull:(0,n.$Zj)("star-full",60249),starHalf:(0,n.$Zj)("star-half",60250),symbolClass:(0,n.$Zj)("symbol-class",60251),symbolColor:(0,n.$Zj)("symbol-color",60252),symbolConstant:(0,n.$Zj)("symbol-constant",60253),symbolEnumMember:(0,n.$Zj)("symbol-enum-member",60254),symbolField:(0,n.$Zj)("symbol-field",60255),symbolFile:(0,n.$Zj)("symbol-file",60256),symbolInterface:(0,n.$Zj)("symbol-interface",60257),symbolKeyword:(0,n.$Zj)("symbol-keyword",60258),symbolMisc:(0,n.$Zj)("symbol-misc",60259),symbolOperator:(0,n.$Zj)("symbol-operator",60260),symbolProperty:(0,n.$Zj)("symbol-property",60261),wrench:(0,n.$Zj)("wrench",60261),wrenchSubaction:(0,n.$Zj)("wrench-subaction",60261),symbolSnippet:(0,n.$Zj)("symbol-snippet",60262),tasklist:(0,n.$Zj)("tasklist",60263),telescope:(0,n.$Zj)("telescope",60264),textSize:(0,n.$Zj)("text-size",60265),threeBars:(0,n.$Zj)("three-bars",60266),thumbsdown:(0,n.$Zj)("thumbsdown",60267),thumbsup:(0,n.$Zj)("thumbsup",60268),tools:(0,n.$Zj)("tools",60269),triangleDown:(0,n.$Zj)("triangle-down",60270),triangleLeft:(0,n.$Zj)("triangle-left",60271),triangleRight:(0,n.$Zj)("triangle-right",60272),triangleUp:(0,n.$Zj)("triangle-up",60273),twitter:(0,n.$Zj)("twitter",60274),unfold:(0,n.$Zj)("unfold",60275),unlock:(0,n.$Zj)("unlock",60276),unmute:(0,n.$Zj)("unmute",60277),unverified:(0,n.$Zj)("unverified",60278),verified:(0,n.$Zj)("verified",60279),versions:(0,n.$Zj)("versions",60280),vmActive:(0,n.$Zj)("vm-active",60281),vmOutline:(0,n.$Zj)("vm-outline",60282),vmRunning:(0,n.$Zj)("vm-running",60283),watch:(0,n.$Zj)("watch",60284),whitespace:(0,n.$Zj)("whitespace",60285),wholeWord:(0,n.$Zj)("whole-word",60286),window:(0,n.$Zj)("window",60287),wordWrap:(0,n.$Zj)("word-wrap",60288),zoomIn:(0,n.$Zj)("zoom-in",60289),zoomOut:(0,n.$Zj)("zoom-out",60290),listFilter:(0,n.$Zj)("list-filter",60291),listFlat:(0,n.$Zj)("list-flat",60292),listSelection:(0,n.$Zj)("list-selection",60293),selection:(0,n.$Zj)("selection",60293),listTree:(0,n.$Zj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Zj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Zj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Zj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Zj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Zj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Zj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Zj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Zj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Zj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Zj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Zj)("symbol-string",60301),debugReverseContinue:(0,n.$Zj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Zj)("debug-step-back",60303),debugRestartFrame:(0,n.$Zj)("debug-restart-frame",60304),debugAlt:(0,n.$Zj)("debug-alt",60305),callIncoming:(0,n.$Zj)("call-incoming",60306),callOutgoing:(0,n.$Zj)("call-outgoing",60307),menu:(0,n.$Zj)("menu",60308),expandAll:(0,n.$Zj)("expand-all",60309),feedback:(0,n.$Zj)("feedback",60310),gitPullRequestReviewer:(0,n.$Zj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Zj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Zj)("ungroup-by-ref-type",60312),account:(0,n.$Zj)("account",60313),gitPullRequestAssignee:(0,n.$Zj)("git-pull-request-assignee",60313),bellDot:(0,n.$Zj)("bell-dot",60314),debugConsole:(0,n.$Zj)("debug-console",60315),library:(0,n.$Zj)("library",60316),output:(0,n.$Zj)("output",60317),runAll:(0,n.$Zj)("run-all",60318),syncIgnored:(0,n.$Zj)("sync-ignored",60319),pinned:(0,n.$Zj)("pinned",60320),githubInverted:(0,n.$Zj)("github-inverted",60321),serverProcess:(0,n.$Zj)("server-process",60322),serverEnvironment:(0,n.$Zj)("server-environment",60323),pass:(0,n.$Zj)("pass",60324),issueClosed:(0,n.$Zj)("issue-closed",60324),stopCircle:(0,n.$Zj)("stop-circle",60325),playCircle:(0,n.$Zj)("play-circle",60326),record:(0,n.$Zj)("record",60327),debugAltSmall:(0,n.$Zj)("debug-alt-small",60328),vmConnect:(0,n.$Zj)("vm-connect",60329),cloud:(0,n.$Zj)("cloud",60330),merge:(0,n.$Zj)("merge",60331),export:(0,n.$Zj)("export",60332),graphLeft:(0,n.$Zj)("graph-left",60333),magnet:(0,n.$Zj)("magnet",60334),notebook:(0,n.$Zj)("notebook",60335),redo:(0,n.$Zj)("redo",60336),checkAll:(0,n.$Zj)("check-all",60337),pinnedDirty:(0,n.$Zj)("pinned-dirty",60338),passFilled:(0,n.$Zj)("pass-filled",60339),circleLargeFilled:(0,n.$Zj)("circle-large-filled",60340),circleLarge:(0,n.$Zj)("circle-large",60341),circleLargeOutline:(0,n.$Zj)("circle-large-outline",60341),combine:(0,n.$Zj)("combine",60342),gather:(0,n.$Zj)("gather",60342),table:(0,n.$Zj)("table",60343),variableGroup:(0,n.$Zj)("variable-group",60344),typeHierarchy:(0,n.$Zj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Zj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Zj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Zj)("git-pull-request-create",60348),runAbove:(0,n.$Zj)("run-above",60349),runBelow:(0,n.$Zj)("run-below",60350),notebookTemplate:(0,n.$Zj)("notebook-template",60351),debugRerun:(0,n.$Zj)("debug-rerun",60352),workspaceTrusted:(0,n.$Zj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Zj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Zj)("workspace-unknown",60355),terminalCmd:(0,n.$Zj)("terminal-cmd",60356),terminalDebian:(0,n.$Zj)("terminal-debian",60357),terminalLinux:(0,n.$Zj)("terminal-linux",60358),terminalPowershell:(0,n.$Zj)("terminal-powershell",60359),terminalTmux:(0,n.$Zj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Zj)("terminal-ubuntu",60361),terminalBash:(0,n.$Zj)("terminal-bash",60362),arrowSwap:(0,n.$Zj)("arrow-swap",60363),copy:(0,n.$Zj)("copy",60364),personAdd:(0,n.$Zj)("person-add",60365),filterFilled:(0,n.$Zj)("filter-filled",60366),wand:(0,n.$Zj)("wand",60367),debugLineByLine:(0,n.$Zj)("debug-line-by-line",60368),inspect:(0,n.$Zj)("inspect",60369),layers:(0,n.$Zj)("layers",60370),layersDot:(0,n.$Zj)("layers-dot",60371),layersActive:(0,n.$Zj)("layers-active",60372),compass:(0,n.$Zj)("compass",60373),compassDot:(0,n.$Zj)("compass-dot",60374),compassActive:(0,n.$Zj)("compass-active",60375),azure:(0,n.$Zj)("azure",60376),issueDraft:(0,n.$Zj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Zj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Zj)("git-pull-request-draft",60379),debugAll:(0,n.$Zj)("debug-all",60380),debugCoverage:(0,n.$Zj)("debug-coverage",60381),runErrors:(0,n.$Zj)("run-errors",60382),folderLibrary:(0,n.$Zj)("folder-library",60383),debugContinueSmall:(0,n.$Zj)("debug-continue-small",60384),beakerStop:(0,n.$Zj)("beaker-stop",60385),graphLine:(0,n.$Zj)("graph-line",60386),graphScatter:(0,n.$Zj)("graph-scatter",60387),pieChart:(0,n.$Zj)("pie-chart",60388),bracket:(0,n.$Zj)("bracket",60175),bracketDot:(0,n.$Zj)("bracket-dot",60389),bracketError:(0,n.$Zj)("bracket-error",60390),lockSmall:(0,n.$Zj)("lock-small",60391),azureDevops:(0,n.$Zj)("azure-devops",60392),verifiedFilled:(0,n.$Zj)("verified-filled",60393),newline:(0,n.$Zj)("newline",60394),layout:(0,n.$Zj)("layout",60395),layoutActivitybarLeft:(0,n.$Zj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Zj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Zj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Zj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Zj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Zj)("layout-panel-right",60401),layoutPanel:(0,n.$Zj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Zj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Zj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Zj)("layout-statusbar",60405),layoutMenubar:(0,n.$Zj)("layout-menubar",60406),layoutCentered:(0,n.$Zj)("layout-centered",60407),target:(0,n.$Zj)("target",60408),indent:(0,n.$Zj)("indent",60409),recordSmall:(0,n.$Zj)("record-small",60410),errorSmall:(0,n.$Zj)("error-small",60411),terminalDecorationError:(0,n.$Zj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Zj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Zj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Zj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Zj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Zj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Zj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Zj)("layout-sidebar-left-off",60418),blank:(0,n.$Zj)("blank",60419),heartFilled:(0,n.$Zj)("heart-filled",60420),map:(0,n.$Zj)("map",60421),mapHorizontal:(0,n.$Zj)("map-horizontal",60421),foldHorizontal:(0,n.$Zj)("fold-horizontal",60421),mapFilled:(0,n.$Zj)("map-filled",60422),mapHorizontalFilled:(0,n.$Zj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$Zj)("fold-horizontal-filled",60422),circleSmall:(0,n.$Zj)("circle-small",60423),bellSlash:(0,n.$Zj)("bell-slash",60424),bellSlashDot:(0,n.$Zj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Zj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Zj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Zj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Zj)("search-fuzzy",60429),commentDraft:(0,n.$Zj)("comment-draft",60430),send:(0,n.$Zj)("send",60431),sparkle:(0,n.$Zj)("sparkle",60432),insert:(0,n.$Zj)("insert",60433),mic:(0,n.$Zj)("mic",60434),thumbsdownFilled:(0,n.$Zj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Zj)("thumbsup-filled",60436),coffee:(0,n.$Zj)("coffee",60437),snake:(0,n.$Zj)("snake",60438),game:(0,n.$Zj)("game",60439),vr:(0,n.$Zj)("vr",60440),chip:(0,n.$Zj)("chip",60441),piano:(0,n.$Zj)("piano",60442),music:(0,n.$Zj)("music",60443),micFilled:(0,n.$Zj)("mic-filled",60444),repoFetch:(0,n.$Zj)("repo-fetch",60445),copilot:(0,n.$Zj)("copilot",60446),lightbulbSparkle:(0,n.$Zj)("lightbulb-sparkle",60447),robot:(0,n.$Zj)("robot",60448),sparkleFilled:(0,n.$Zj)("sparkle-filled",60449),diffSingle:(0,n.$Zj)("diff-single",60450),diffMultiple:(0,n.$Zj)("diff-multiple",60451),surroundWith:(0,n.$Zj)("surround-with",60452),share:(0,n.$Zj)("share",60453),gitStash:(0,n.$Zj)("git-stash",60454),gitStashApply:(0,n.$Zj)("git-stash-apply",60455),gitStashPop:(0,n.$Zj)("git-stash-pop",60456),vscode:(0,n.$Zj)("vscode",60457),vscodeInsiders:(0,n.$Zj)("vscode-insiders",60458),codeOss:(0,n.$Zj)("code-oss",60459),runCoverage:(0,n.$Zj)("run-coverage",60460),runAllCoverage:(0,n.$Zj)("run-all-coverage",60461),coverage:(0,n.$Zj)("coverage",60462),githubProject:(0,n.$Zj)("github-project",60463),mapVertical:(0,n.$Zj)("map-vertical",60464),foldVertical:(0,n.$Zj)("fold-vertical",60464),mapVerticalFilled:(0,n.$Zj)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$Zj)("fold-vertical-filled",60465),goToSearch:(0,n.$Zj)("go-to-search",60466),percentage:(0,n.$Zj)("percentage",60467),sortPercentage:(0,n.$Zj)("sort-percentage",60467),attach:(0,n.$Zj)("attach",60468)}}),define(ce[80],le([0,1,109,148]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=void 0,e.$3j=k;function k(){return Object.values(e.$5j)}e.$4j={dialogError:(0,n.$Zj)("dialog-error","error"),dialogWarning:(0,n.$Zj)("dialog-warning","warning"),dialogInfo:(0,n.$Zj)("dialog-info","info"),dialogClose:(0,n.$Zj)("dialog-close","close"),treeItemExpanded:(0,n.$Zj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Zj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Zj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Zj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Zj)("tree-item-loading","loading"),menuSelection:(0,n.$Zj)("menu-selection","check"),menuSubmenu:(0,n.$Zj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Zj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Zj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Zj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Zj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Zj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Zj)("toolbar-more","more"),quickInputBack:(0,n.$Zj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Zj)("drop-down-button",60084),symbolCustomColor:(0,n.$Zj)("symbol-customcolor",60252),exportIcon:(0,n.$Zj)("export",60332),workspaceUnspecified:(0,n.$Zj)("workspace-unspecified",60355),newLine:(0,n.$Zj)("newline",60394),thumbsDownFilled:(0,n.$Zj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Zj)("thumbsup-filled",60436),gitFetch:(0,n.$Zj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Zj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Zj)("debug-breakpoint-pending",60377)},e.$5j={...r.$2j,...e.$4j}}),define(ce[37],le([0,1,11]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=r,e.$fo=k,e.$go=T,e.$ho=p,e.$io=c,e.$jo=m,e.$ko=u,e.$lo=d,e.$mo=w,e.$no=f,e.$oo=g,e.$po=v,e.$qo=b;function r($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const P=Array.isArray($)?[]:{};return Object.entries($).forEach(([E,i])=>{P[E]=i&&typeof i=="object"?r(i):i}),P}function k($){if(!$||typeof $!="object")return $;const P=[$];for(;P.length>0;){const E=P.shift();Object.freeze(E);for(const i in E)if(R.call(E,i)){const h=E[i];typeof h=="object"&&!Object.isFrozen(h)&&!(0,n.$hg)(h)&&P.push(h)}}return $}const R=Object.prototype.hasOwnProperty;function T($,P){return I($,P,new Set)}function I($,P,E){if((0,n.$ng)($))return $;const i=P($);if(typeof i<"u")return i;if(Array.isArray($)){const h=[];for(const t of $)h.push(I(t,P,E));return h}if((0,n.$gg)($)){if(E.has($))throw new Error("Cannot clone recursive data-structure");E.add($);const h={};for(const t in $)R.call($,t)&&(h[t]=I($[t],P,E));return E.delete($),h}return $}function p($,P,E=!0){return(0,n.$gg)($)?((0,n.$gg)(P)&&Object.keys(P).forEach(i=>{i in $?E&&((0,n.$gg)($[i])&&(0,n.$gg)(P[i])?p($[i],P[i],E):$[i]=P[i]):$[i]=P[i]}),$):P}function c($,P){if($===P)return!0;if($==null||P===null||P===void 0||typeof $!=typeof P||typeof $!="object"||Array.isArray($)!==Array.isArray(P))return!1;let E,i;if(Array.isArray($)){if($.length!==P.length)return!1;for(E=0;E<$.length;E++)if(!c($[E],P[E]))return!1}else{const h=[];for(i in $)h.push(i);h.sort();const t=[];for(i in P)t.push(i);if(t.sort(),!c(h,t))return!1;for(E=0;E<h.length;E++)if(!c($[h[E]],P[h[E]]))return!1}return!0}function m($){const P=new Set;return JSON.stringify($,(E,i)=>{if((0,n.$gg)(i)||Array.isArray(i)){if(P.has(i))return"[Circular]";P.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function u($,P){const E=Object.create(null);return!$||!P||Object.keys(P).forEach(h=>{const t=$[h],o=P[h];c(t,o)||(E[h]=o)}),E}function d($,P){const E=P.toLowerCase(),i=Object.keys($).find(h=>h.toLowerCase()===E);return i?$[i]:$[P]}function w($,P){const E=Object.create(null);for(const[i,h]of Object.entries($))P(i,h)&&(E[i]=h);return E}function f($){let P=[];for(;Object.prototype!==$;)P=P.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return P}function g($){const P=[];for(const E of f($))typeof $[E]=="function"&&P.push(E);return P}function v($,P){const E=h=>function(){const t=Array.prototype.slice.call(arguments,0);return P(h,t)},i={};for(const h of $)i[h]=E(h);return i}function b($,P){const E={};for(const[i,h]of Object.entries($))E[i]=P(h,i);return E}}),define(ce[110],le([0,1,80]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$6j=k;var r;(function(T){function I(p){return p&&typeof p=="object"&&typeof p.id=="string"}T.isThemeColor=I})(r||(e.ThemeColor=r={}));function k(T){return{id:T}}var R;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function p($){const P=I.exec($.id);if(!P)return p(n.$5j.error);const[,E,i]=P,h=["codicon","codicon-"+E];return i&&h.push("codicon-modifier-"+i.substring(1)),h}T.asClassNameArray=p;function c($){return p($).join(" ")}T.asClassName=c;function m($){return"."+p($).join(".")}T.asCSSSelector=m;function u($){return $&&typeof $=="object"&&typeof $.id=="string"&&(typeof $.color>"u"||r.isThemeColor($.color))}T.isThemeIcon=u;const d=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function w($){const P=d.exec($);if(!P)return;const[,E]=P;return{id:E}}T.fromString=w;function f($){return{id:$}}T.fromId=f;function g($,P){let E=$.id;const i=E.lastIndexOf("~");return i!==-1&&(E=E.substring(0,i)),P&&(E=`${E}~${P}`),{id:E}}T.modify=g;function v($){const P=$.id.lastIndexOf("~");if(P!==-1)return $.id.substring(P+1)}T.getModifier=v;function b($,P){return $.id===P.id&&$.color?.id===P.color?.id}T.isEqual=b})(R||(e.ThemeIcon=R={}))}),define(ce[149],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$af=r,e.$bf=k;var n;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(n||(e.Constants=n={}));function r(R){return R<0?0:R>n.MAX_UINT_8?n.MAX_UINT_8:R|0}function k(R){return R<0?0:R>n.MAX_UINT_32?n.MAX_UINT_32:R|0}}),define(ce[25],le([0,1,146,39,65,149]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.GraphemeBreakType=e.$4f=e.$Vf=e.$Of=e.$Nf=void 0,e.$cf=T,e.$df=p,e.$ef=m,e.$ff=u,e.$gf=d,e.$hf=w,e.$if=f,e.$jf=g,e.$kf=v,e.$lf=b,e.$mf=$,e.$nf=P,e.$of=E,e.$pf=i,e.$qf=h,e.$rf=t,e.$sf=o,e.$tf=s,e.$uf=a,e.$vf=l,e.$wf=S,e.$xf=y,e.$yf=A,e.$zf=L,e.$Af=D,e.$Bf=O,e.$Cf=M,e.$Df=Z,e.$Ef=q,e.$Ff=K,e.$Gf=de,e.$Hf=H,e.$If=Y,e.$Jf=B,e.$Kf=Q,e.$Lf=W,e.$Mf=j,e.$Pf=V,e.$Qf=ue,e.$Rf=re,e.$Sf=J,e.$Tf=_,e.$Uf=ie,e.$Wf=G,e.$Xf=U,e.$Yf=te,e.$Zf=he,e.$1f=we,e.$2f=Ie,e.$3f=Ae,e.$5f=ve,e.$6f=$e,e.$7f=ee,e.$8f=ae,e.$9f=fe,e.$0f=be,e.$$f=Re,e.$_f=Fe,e.$ag=Qe;function T(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}const I=/{(\d+)}/g;function p(ne,...ge){return ge.length===0?ne:ne.replace(I,function(pe,ye){const je=parseInt(ye,10);return isNaN(je)||je<0||je>=ge.length?pe:ge[je]})}const c=/{([^}]+)}/g;function m(ne,ge){return Object.keys(ge).length===0?ne:ne.replace(c,(pe,ye)=>ge[ye]??pe)}function u(ne){return ne.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function d(ne){return ne.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function w(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function f(ne,ge){let pe=0,ye=ne.indexOf(ge);for(;ye!==-1;)pe++,ye=ne.indexOf(ge,ye+ge.length);return pe}function g(ne,ge,pe="\u2026"){return ne.length<=ge?ne:`${ne.substr(0,ge)}${pe}`}function v(ne,ge,pe="\u2026"){if(ne.length<=ge)return ne;const ye=Math.ceil(ge/2)-pe.length/2,je=Math.floor(ge/2)-pe.length/2;return`${ne.substr(0,ye)}${pe}${ne.substr(ne.length-je)}`}function b(ne,ge=" "){const pe=$(ne,ge);return P(pe,ge)}function $(ne,ge){if(!ne||!ge)return ne;const pe=ge.length;if(pe===0||ne.length===0)return ne;let ye=0;for(;ne.indexOf(ge,ye)===ye;)ye=ye+pe;return ne.substring(ye)}function P(ne,ge){if(!ne||!ge)return ne;const pe=ge.length,ye=ne.length;if(pe===0||ye===0)return ne;let je=ye,Be=-1;for(;Be=ne.lastIndexOf(ge,je-1),!(Be===-1||Be+pe!==je);){if(Be===0)return"";je=Be}return ne.substring(0,je)}function E(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(ne){return ne.replace(/\*/g,"")}function h(ne,ge,pe={}){if(!ne)throw new Error("Cannot create regex from empty string");ge||(ne=w(ne)),pe.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let ye="";return pe.global&&(ye+="g"),pe.matchCase||(ye+="i"),pe.multiline&&(ye+="m"),pe.unicode&&(ye+="u"),new RegExp(ne,ye)}function t(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}function o(ne){return ne.split(/\r\n|\r|\n/)}function s(ne){const ge=[],pe=ne.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(pe.length/2);ye++)ge.push(pe[2*ye]+(pe[2*ye+1]??""));return ge}function a(ne){for(let ge=0,pe=ne.length;ge<pe;ge++){const ye=ne.charCodeAt(ge);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return ge}return-1}function l(ne,ge=0,pe=ne.length){for(let ye=ge;ye<pe;ye++){const je=ne.charCodeAt(ye);if(je!==r.CharCode.Space&&je!==r.CharCode.Tab)return ne.substring(ge,ye)}return ne.substring(ge,pe)}function S(ne,ge=ne.length-1){for(let pe=ge;pe>=0;pe--){const ye=ne.charCodeAt(pe);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return pe}return-1}function y(ne,ge,pe){const ye=[];let je=0;for(const Be of ne.matchAll(ge)){if(ye.push(ne.slice(je,Be.index)),Be.index===void 0)throw new Error("match.index should be defined");je=Be.index+Be[0].length,ye.push(pe(Be[0],...Be.slice(1),Be.index,ne,Be.groups))}return ye.push(ne.slice(je)),Promise.all(ye).then(Be=>Be.join(""))}function A(ne,ge){return ne<ge?-1:ne>ge?1:0}function L(ne,ge,pe=0,ye=ne.length,je=0,Be=ge.length){for(;pe<ye&&je<Be;pe++,je++){const rt=ne.charCodeAt(pe),at=ge.charCodeAt(je);if(rt<at)return-1;if(rt>at)return 1}const _e=ye-pe,lt=Be-je;return _e<lt?-1:_e>lt?1:0}function D(ne,ge){return O(ne,ge,0,ne.length,0,ge.length)}function O(ne,ge,pe=0,ye=ne.length,je=0,Be=ge.length){for(;pe<ye&&je<Be;pe++,je++){let rt=ne.charCodeAt(pe),at=ge.charCodeAt(je);if(rt===at)continue;if(rt>=128||at>=128)return L(ne.toLowerCase(),ge.toLowerCase(),pe,ye,je,Be);Z(rt)&&(rt-=32),Z(at)&&(at-=32);const tt=rt-at;if(tt!==0)return tt}const _e=ye-pe,lt=Be-je;return _e<lt?-1:_e>lt?1:0}function M(ne){return ne>=r.CharCode.Digit0&&ne<=r.CharCode.Digit9}function Z(ne){return ne>=r.CharCode.a&&ne<=r.CharCode.z}function q(ne){return ne>=r.CharCode.A&&ne<=r.CharCode.Z}function K(ne,ge){return ne.length===ge.length&&O(ne,ge)===0}function de(ne,ge){const pe=ge.length;return ge.length>ne.length?!1:O(ne,ge,0,pe)===0}function H(ne,ge){const pe=Math.min(ne.length,ge.length);let ye;for(ye=0;ye<pe;ye++)if(ne.charCodeAt(ye)!==ge.charCodeAt(ye))return ye;return pe}function Y(ne,ge){const pe=Math.min(ne.length,ge.length);let ye;const je=ne.length-1,Be=ge.length-1;for(ye=0;ye<pe;ye++)if(ne.charCodeAt(je-ye)!==ge.charCodeAt(Be-ye))return ye;return pe}function B(ne){return 55296<=ne&&ne<=56319}function Q(ne){return 56320<=ne&&ne<=57343}function W(ne,ge){return(ne-55296<<10)+(ge-56320)+65536}function j(ne,ge,pe){const ye=ne.charCodeAt(pe);if(B(ye)&&pe+1<ge){const je=ne.charCodeAt(pe+1);if(Q(je))return W(ye,je)}return ye}function C(ne,ge){const pe=ne.charCodeAt(ge-1);if(Q(pe)&&ge>1){const ye=ne.charCodeAt(ge-2);if(B(ye))return W(ye,pe)}return pe}class X{get offset(){return this.e}constructor(ge,pe=0){this.c=ge,this.d=ge.length,this.e=pe}setOffset(ge){this.e=ge}prevCodePoint(){const ge=C(this.c,this.e);return this.e-=ge>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=j(this.c,this.d,this.e);return this.e+=ge>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Nf=X;class oe{get offset(){return this.c.offset}constructor(ge,pe=0){this.c=new X(ge,pe)}nextGraphemeLength(){const ge=Ue.getInstance(),pe=this.c,ye=pe.offset;let je=ge.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Be=pe.offset,_e=ge.getGraphemeBreakType(pe.nextCodePoint());if(Me(je,_e)){pe.setOffset(Be);break}je=_e}return pe.offset-ye}prevGraphemeLength(){const ge=Ue.getInstance(),pe=this.c,ye=pe.offset;let je=ge.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Be=pe.offset,_e=ge.getGraphemeBreakType(pe.prevCodePoint());if(Me(_e,je)){pe.setOffset(Be);break}je=_e}return ye-pe.offset}eol(){return this.c.eol()}}e.$Of=oe;function V(ne,ge){return new oe(ne,ge).nextGraphemeLength()}function ue(ne,ge){return new oe(ne,ge).prevGraphemeLength()}function re(ne,ge){ge>0&&Q(ne.charCodeAt(ge))&&ge--;const pe=ge+V(ne,ge);return[pe-ue(ne,pe),pe]}function J(ne){const ge=new oe(ne);let pe=0;for(;!ge.eol();)pe++,ge.nextGraphemeLength();return pe}let F;function N(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _(ne){return F||(F=N()),F.test(ne)}const z=/^[\t\n\r\x20-\x7E]*$/;function ie(ne){return z.test(ne)}e.$Vf=/[\u2028\u2029]/;function G(ne){return e.$Vf.test(ne)}function U(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}function te(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}function he(ne,ge,pe=""){const ye=ne.trimStart();if(ye.length<ge)return ye;const je=/\b/g;let Be=0;for(;je.test(ye)&&!(ye.length-je.lastIndex<ge);)Be=je.lastIndex,je.lastIndex+=1;return Be===0?ye:pe+ye.substring(Be).trimStart()}const me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(ne){let ge=0;for(const pe of ne.matchAll(me))ge!==pe.index&&(yield{isCode:!1,str:ne.substring(ge,pe.index)}),yield{isCode:!0,str:pe[0]},ge=pe.index+pe[0].length;ge!==ne.length&&(yield{isCode:!1,str:ne.substring(ge)})}function Ie(ne){return ne&&(ne=ne.replace(me,"")),ne}const Ce=/\\\[.*?\\\]/g;function Ae(ne){return Ie(ne).replace(Ce,"")}e.$4f=String.fromCharCode(r.CharCode.UTF8_BOM);function ve(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===r.CharCode.UTF8_BOM)}function $e(ne){return ve(ne)?ne.substr(1):ne}function ee(ne,ge){if(!ne||!ge||ne.length<ge.length)return!1;const pe=ge.length,ye=ne.toLowerCase();let je=0,Be=-1;for(;je<pe;){const _e=ye.indexOf(ge[je],Be+1);if(_e<0)return!1;Be=_e,je++}return!0}function ae(ne,ge=!1){return ne?(ge&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}function fe(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}function be(ne,ge=1){if(ge===0)return"";let pe=-1;do pe=ne.indexOf(`
`,pe+1),ge--;while(ge>0&&pe>=0);return pe===-1?ne:(ne[pe-1]==="\r"&&pe--,ne.substr(0,pe))}function Re(ne){const ge=r.CharCode.Z-r.CharCode.A+1;return ne=ne%(2*ge),ne<ge?String.fromCharCode(r.CharCode.a+ne):String.fromCharCode(r.CharCode.A+ne-ge)}function Fe(ne){return Ue.getInstance().getGraphemeBreakType(ne)}function Me(ne,ge){return ne===De.Other?ge!==De.Extend&&ge!==De.SpacingMark:ne===De.CR&&ge===De.LF?!1:ne===De.Control||ne===De.CR||ne===De.LF||ge===De.Control||ge===De.CR||ge===De.LF?!0:!(ne===De.L&&(ge===De.L||ge===De.V||ge===De.LV||ge===De.LVT)||(ne===De.LV||ne===De.V)&&(ge===De.V||ge===De.T)||(ne===De.LVT||ne===De.T)&&ge===De.T||ge===De.Extend||ge===De.ZWJ||ge===De.SpacingMark||ne===De.Prepend||ne===De.ZWJ&&ge===De.Extended_Pictographic||ne===De.Regional_Indicator&&ge===De.Regional_Indicator)}var De;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(De||(e.GraphemeBreakType=De={}));class Ue{static{this.c=null}static getInstance(){return Ue.c||(Ue.c=new Ue),Ue.c}constructor(){this.d=Ge()}getGraphemeBreakType(ge){if(ge<32)return ge===r.CharCode.LineFeed?De.LF:ge===r.CharCode.CarriageReturn?De.CR:De.Control;if(ge<127)return De.Other;const pe=this.d,ye=pe.length/3;let je=1;for(;je<=ye;)if(ge<pe[3*je])je=2*je;else if(ge>pe[3*je+1])je=2*je+1;else return pe[3*je+2];return De.Other}}function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Qe(ne,ge){if(ne===0)return 0;const pe=qe(ne,ge);if(pe!==void 0)return pe;const ye=new X(ge,ne);return ye.prevCodePoint(),ye.offset}function qe(ne,ge){const pe=new X(ge,ne);let ye=pe.prevCodePoint();for(;Xe(ye)||ye===Je.emojiVariantSelector||ye===Je.enclosingKeyCap;){if(pe.offset===0)return;ye=pe.prevCodePoint()}if(!te(ye))return;let je=pe.offset;return je>0&&pe.prevCodePoint()===Je.zwj&&(je=pe.offset),je}function Xe(ne){return 127995<=ne&&ne<=127999}var Je;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Je||(Je={})),e.$bg="\xA0";class Ye{static{this.c=new k.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$$e({getCacheKey:JSON.stringify},ge=>{function pe(tt){const ut=new Map;for(let ct=0;ct<tt.length;ct+=2)ut.set(tt[ct],tt[ct+1]);return ut}function ye(tt,ut){const ct=new Map(tt);for(const[ft,gt]of ut)ct.set(ft,gt);return ct}function je(tt,ut){if(!tt)return ut;const ct=new Map;for(const[ft,gt]of tt)ut.has(ft)&&ct.set(ft,gt);return ct}const Be=this.c.value;let _e=ge.filter(tt=>!tt.startsWith("_")&&tt in Be);_e.length===0&&(_e=["_default"]);let lt;for(const tt of _e){const ut=pe(Be[tt]);lt=je(lt,ut)}const rt=pe(Be._common),at=ye(rt,lt);return new Ye(at)})}static getInstance(ge){return Ye.d.get(Array.from(ge))}static{this.e=new k.$T(()=>Object.keys(Ye.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Ye.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$cg=Ye;class We{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(We.c())),this.d}static isInvisibleCharacter(ge){return We.e().has(ge)}static containsInvisibleCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&We.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return We.e()}}e.$dg=We}),define(ce[32],le([0,1,39,9,3,25,11]),function(x,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=I,e.$yg=p,e.$zg=c,e.$Ag=m,e.$Bg=u,e.$Cg=g,e.$Dg=v,e.$Eg=b,e.$Fg=$,e.$Gg=P,e.$Hg=E,e.$Ig=i,e.$Jg=h,e.$Kg=t,e.$Lg=o,e.$Mg=s,e.$Ng=S;function I(y){return y===n.CharCode.Slash||y===n.CharCode.Backslash}function p(y){return y.replace(/[\\/]/g,r.$gc.sep)}function c(y){return y.indexOf("/")===-1&&(y=p(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function m(y,A=r.$gc.sep){if(!y)return"";const L=y.length,D=y.charCodeAt(0);if(I(D)){if(I(y.charCodeAt(1))&&!I(y.charCodeAt(2))){let M=3;const Z=M;for(;M<L&&!I(y.charCodeAt(M));M++);if(Z!==M&&!I(y.charCodeAt(M+1))){for(M+=1;M<L;M++)if(I(y.charCodeAt(M)))return y.slice(0,M+1).replace(/[\\/]/g,A)}}return A}else if($(D)&&y.charCodeAt(1)===n.CharCode.Colon)return I(y.charCodeAt(2))?y.slice(0,2)+A:y.slice(0,2);let O=y.indexOf("://");if(O!==-1){for(O+=3;O<L;O++)if(I(y.charCodeAt(O)))return y.slice(0,O+1)}return""}function u(y){if(!k.$j||!y||y.length<5)return!1;let A=y.charCodeAt(0);if(A!==n.CharCode.Backslash||(A=y.charCodeAt(1),A!==n.CharCode.Backslash))return!1;let L=2;const D=L;for(;L<y.length&&(A=y.charCodeAt(L),A!==n.CharCode.Backslash);L++);return!(D===L||(A=y.charCodeAt(L+1),isNaN(A)||A===n.CharCode.Backslash))}const d=/[\\/:\*\?"<>\|]/g,w=/[/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(y,A=k.$j){const L=A?d:w;return!(!y||y.length===0||/^\s+$/.test(y)||(L.lastIndex=0,L.test(y))||A&&f.test(y)||y==="."||y===".."||A&&y[y.length-1]==="."||A&&y.length!==y.trim().length||y.length>255)}function v(y,A,L){const D=y===A;return!L||D?D:!y||!A?!1:(0,R.$Ff)(y,A)}function b(y,A,L,D=r.sep){if(y===A)return!0;if(!y||!A||A.length>y.length)return!1;if(L){if(!(0,R.$Gf)(y,A))return!1;if(A.length===y.length)return!0;let M=A.length;return A.charAt(A.length-1)===D&&M--,y.charAt(M)===D}return A.charAt(A.length-1)!==D&&(A+=D),y.indexOf(A)===0}function $(y){return y>=n.CharCode.A&&y<=n.CharCode.Z||y>=n.CharCode.a&&y<=n.CharCode.z}function P(y,A){return k.$j&&y.endsWith(":")&&(y+=r.sep),(0,r.$ic)(y)||(y=(0,r.$jc)(A,y)),y=(0,r.$hc)(y),E(y)}function E(y){return k.$j?(y=(0,R.$nf)(y,r.sep),y.endsWith(":")&&(y+=r.sep)):(y=(0,R.$nf)(y,r.sep),y||(y=r.sep)),y}function i(y){const A=(0,r.$hc)(y);return k.$j?y.length>3?!1:h(A)&&(y.length===2||A.charCodeAt(2)===n.CharCode.Backslash):A===r.$gc.sep}function h(y,A=k.$j){return A?$(y.charCodeAt(0))&&y.charCodeAt(1)===n.CharCode.Colon:!1}function t(y,A=k.$j){return h(y,A)?y[0]:void 0}function o(y,A,L){return A.length>y.length?-1:y===A?0:(L&&(y=y.toLowerCase(),A=A.toLowerCase()),y.indexOf(A))}function s(y){const A=y.split(":");let L,D,O;for(const M of A){const Z=Number(M);(0,T.$ig)(Z)?D===void 0?D=Z:O===void 0&&(O=Z):L=L?[L,M].join(":"):M}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:D!==void 0?D:void 0,column:O!==void 0?O:D!==void 0?1:void 0}}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(y,A,L=8){let D="";for(let M=0;M<L;M++){let Z;M===0&&k.$j&&!A&&(L===3||L===4)?Z=l:Z=a,D+=Z.charAt(Math.floor(Math.random()*Z.length))}let O;return A?O=`${A}-${D}`:O=D,y?(0,r.$jc)(y,O):O}}),define(ce[46],le([0,1,25]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$xj=void 0,e.$tj=r,e.$uj=k,e.$vj=R,e.$wj=I,e.$yj=g,n=Pe(n);function r(b){return k(b,0)}function k(b,$){switch(typeof b){case"object":return b===null?R(349,$):Array.isArray(b)?p(b,$):c(b,$);case"string":return I(b,$);case"boolean":return T(b,$);case"number":return R(b,$);case"undefined":return R(937,$);default:return R(617,$)}}function R(b,$){return($<<5)-$+b|0}function T(b,$){return R(b?433:863,$)}function I(b,$){$=R(149417,$);for(let P=0,E=b.length;P<E;P++)$=R(b.charCodeAt(P),$);return $}function p(b,$){return $=R(104579,$),b.reduce((P,E)=>k(E,P),$)}function c(b,$){return $=R(181387,$),Object.keys(b).sort().reduce((P,E)=>(P=I(E,P),k(b[E],P)),$)}class m{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=k($,this.g),this.g}}e.$xj=m;var u;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(u||(u={}));function d(b,$,P=32){const E=P-$,i=~((1<<E)-1);return(b<<$|(i&b)>>>E)>>>0}function w(b,$=0,P=b.byteLength,E=0){for(let i=0;i<P;i++)b[$+i]=E}function f(b,$,P="0"){for(;b.length<$;)b=P+b;return b}function g(b,$=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(P=>P.toString(16).padStart(2,"0")).join(""):f((b>>>0).toString(16),$/4)}class v{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(u.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const P=$.length;if(P===0)return;const E=this.p;let i=this.r,h=this.u,t,o;for(h!==0?(t=h,o=-1,h=0):(t=$.charCodeAt(0),o=0);;){let s=t;if(n.$Jf(t))if(o+1<P){const a=$.charCodeAt(o+1);n.$Kf(a)?(o++,s=n.$Lf(t,a)):s=u.UNICODE_REPLACEMENT}else{h=t;break}else n.$Kf(t)&&(s=u.UNICODE_REPLACEMENT);if(i=this.w(E,i,s),o++,o<P)t=$.charCodeAt(o);else break}this.r=i,this.u=h}w($,P,E){return E<128?$[P++]=E:E<2048?($[P++]=192|(E&1984)>>>6,$[P++]=128|(E&63)>>>0):E<65536?($[P++]=224|(E&61440)>>>12,$[P++]=128|(E&4032)>>>6,$[P++]=128|(E&63)>>>0):($[P++]=240|(E&1835008)>>>18,$[P++]=128|(E&258048)>>>12,$[P++]=128|(E&4032)>>>6,$[P++]=128|(E&63)>>>0),P>=u.BLOCK_SIZE&&(this.y(),P-=u.BLOCK_SIZE,this.t+=u.BLOCK_SIZE,$[0]=$[u.BLOCK_SIZE+0],$[1]=$[u.BLOCK_SIZE+1],$[2]=$[u.BLOCK_SIZE+2]),P}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,u.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),g(this.h)+g(this.l)+g(this.m)+g(this.n)+g(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=v.g,P=this.q;for(let S=0;S<64;S+=4)$.setUint32(S,P.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)$.setUint32(S,d($.getUint32(S-12,!1)^$.getUint32(S-32,!1)^$.getUint32(S-56,!1)^$.getUint32(S-64,!1),1),!1);let E=this.h,i=this.l,h=this.m,t=this.n,o=this.o,s,a,l;for(let S=0;S<80;S++)S<20?(s=i&h|~i&t,a=1518500249):S<40?(s=i^h^t,a=1859775393):S<60?(s=i&h|i&t|h&t,a=2400959708):(s=i^h^t,a=3395469782),l=d(E,5)+s+o+a+$.getUint32(S*4,!1)&4294967295,o=t,t=h,h=d(i,30),i=E,E=l;this.h=this.h+E&4294967295,this.l=this.l+i&4294967295,this.m=this.m+h&4294967295,this.n=this.n+t&4294967295,this.o=this.o+o&4294967295}}e.$zj=v}),define(ce[81],le([0,1,25]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),n=Pe(n);var r;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(r||(r={})),function(k){const R="error",T="warning",I="warn",p="info",c="ignore";function m(d){return d?n.$Ff(R,d)?k.Error:n.$Ff(T,d)||n.$Ff(I,d)?k.Warning:n.$Ff(p,d)?k.Info:k.Ignore:k.Ignore}k.fromValue=m;function u(d){switch(d){case k.Error:return R;case k.Warning:return T;case k.Info:return p;default:return c}}k.toString=u}(r||(r={})),e.default=r}),define(ce[60],le([0,1,21,39,25]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class R{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const g=f.charCodeAt(0),v=this.b.charCodeAt(this.c);return g-v}value(){return this.b[this.c]}}e.$Hi=R;class T{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===r.CharCode.Period)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,k.$zf)(f,this.b,0,f.length,this.c,this.d):(0,k.$Bf)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=T;class I{constructor(f=!0,g=!0){this.f=f,this.g=g}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let g=f.length-1;g>=0;g--,this.c--){const v=this.b.charCodeAt(g);if(!(v===r.CharCode.Slash||this.f&&v===r.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===r.CharCode.Slash||this.f&&g===r.CharCode.Backslash)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,k.$zf)(f,this.b,0,f.length,this.d,this.e):(0,k.$Bf)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=I;var p;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(p||(p={}));class c{constructor(f,g){this.f=f,this.g=g,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new I(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(p.Path)),this.g(f)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===p.Scheme)return(0,k.$Af)(f,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,k.$Af)(f,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(f);if(this.d[this.e]===p.Query)return(0,k.$yf)(f,this.c.query);if(this.d[this.e]===p.Fragment)return(0,k.$yf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Ki=c;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var u;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(u||(u={}));class d{static forUris(f=()=>!1,g=()=>!1){return new d(new c(f,g))}static forPaths(f=!1){return new d(new I(void 0,!f))}static forStrings(){return new d(new R)}static forConfigKeys(){return new d(new T)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,g){if(g){const v=g.slice(0);(0,n.$Vb)(v);for(const b of v)this.set(b,f)}else{const v=f.slice(0);(0,n.$Vb)(v);for(const b of v)this.set(b[0],b[1])}}set(f,g){const v=this.b.reset(f);let b;this.c||(this.c=new m,this.c.segment=v.value());const $=[];for(b=this.c;;){const E=v.cmp(b.segment);if(E>0)b.left||(b.left=new m,b.left.segment=v.value()),$.push([u.Left,b]),b=b.left;else if(E<0)b.right||(b.right=new m,b.right.segment=v.value()),$.push([u.Right,b]),b=b.right;else if(v.hasNext())v.next(),b.mid||(b.mid=new m,b.mid.segment=v.value()),$.push([u.Mid,b]),b=b.mid;else break}const P=b.value;b.value=g,b.key=f;for(let E=$.length-1;E>=0;E--){const i=$[E][1];i.updateHeight();const h=i.balanceFactor();if(h<-1||h>1){const t=$[E][0],o=$[E+1][0];if(t===u.Right&&o===u.Right)$[E][1]=i.rotateLeft();else if(t===u.Left&&o===u.Left)$[E][1]=i.rotateRight();else if(t===u.Right&&o===u.Left)i.right=$[E+1][1]=$[E+1][1].rotateRight(),$[E][1]=i.rotateLeft();else if(t===u.Left&&o===u.Right)i.left=$[E+1][1]=$[E+1][1].rotateLeft(),$[E][1]=i.rotateRight();else throw new Error;if(E>0)switch($[E-1][0]){case u.Left:$[E-1][1].left=$[E][1];break;case u.Right:$[E-1][1].right=$[E][1];break;case u.Mid:$[E-1][1].mid=$[E][1];break}else this.c=$[0][1]}}return P}get(f){return this.d(f)?.value}d(f){const g=this.b.reset(f);let v=this.c;for(;v;){const b=g.cmp(v.segment);if(b>0)v=v.left;else if(b<0)v=v.right;else if(g.hasNext())g.next(),v=v.mid;else break}return v}has(f){const g=this.d(f);return!(g?.value===void 0&&g?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,g){const v=this.b.reset(f),b=[];let $=this.c;for(;$;){const P=v.cmp($.segment);if(P>0)b.push([u.Left,$]),$=$.left;else if(P<0)b.push([u.Right,$]),$=$.right;else if(v.hasNext())v.next(),b.push([u.Mid,$]),$=$.mid;else break}if($){if(g?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const P=this.f($.right);if(P.key){const{key:E,value:i,segment:h}=P;this.e(P.key,!1),$.key=E,$.value=i,$.segment=h}}else{const P=$.left??$.right;if(b.length>0){const[E,i]=b[b.length-1];switch(E){case u.Left:i.left=P;break;case u.Mid:i.mid=P;break;case u.Right:i.right=P;break}}else this.c=P}for(let P=b.length-1;P>=0;P--){const E=b[P][1];E.updateHeight();const i=E.balanceFactor();if(i>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),b[P][1]=E.rotateLeft()):i<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),b[P][1]=E.rotateRight()),P>0)switch(b[P-1][0]){case u.Left:b[P-1][1].left=b[P][1];break;case u.Right:b[P-1][1].right=b[P][1];break;case u.Mid:b[P-1][1].mid=b[P][1];break}else this.c=b[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const g=this.b.reset(f);let v=this.c,b;for(;v;){const $=g.cmp(v.segment);if($>0)v=v.left;else if($<0)v=v.right;else if(g.hasNext())g.next(),b=v.value||b,v=v.mid;else break}return v&&v.value||b}findSuperstr(f){return this.g(f,!1)}g(f,g){const v=this.b.reset(f);let b=this.c;for(;b;){const $=v.cmp(b.segment);if($>0)b=b.left;else if($<0)b=b.right;else if(v.hasNext())v.next(),b=b.mid;else return b.mid?this.h(b.mid):g?b.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[g,v]of this)f(v,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const g=[];return this.j(f,g),g[Symbol.iterator]()}j(f,g){f&&(f.left&&this.j(f.left,g),f.value&&g.push([f.key,f.value]),f.mid&&this.j(f.mid,g),f.right&&this.j(f.right,g))}_isBalanced(){const f=g=>{if(!g)return!0;const v=g.balanceFactor();return v<-1||v>1?!1:f(g.left)&&f(g.right)};return f(this.c)}}e.$Li=d}),define(ce[7],le([0,1,39,90,9,3]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=v,e.$wc=h,k=Pe(k);const T=/^\w[\w\d+.-]*$/,I=/^\//,p=/^\/\//;function c(l,S){if(!l.scheme&&S)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!T.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!I.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(l,S){return!l&&!S?"file":l}function u(l,S){switch(l){case"https":case"http":case"file":S?S[0]!==w&&(S=w+S):S=w;break}return S}const d="",w="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(S){return S instanceof g?!0:S?typeof S.authority=="string"&&typeof S.fragment=="string"&&typeof S.path=="string"&&typeof S.query=="string"&&typeof S.scheme=="string"&&typeof S.fsPath=="string"&&typeof S.with=="function"&&typeof S.toString=="function":!1}constructor(S,y,A,L,D,O=!1){typeof S=="object"?(this.scheme=S.scheme||d,this.authority=S.authority||d,this.path=S.path||d,this.query=S.query||d,this.fragment=S.fragment||d):(this.scheme=m(S,O),this.authority=y||d,this.path=u(this.scheme,A||d),this.query=L||d,this.fragment=D||d,c(this,O))}get fsPath(){return h(this,!1)}with(S){if(!S)return this;let{scheme:y,authority:A,path:L,query:D,fragment:O}=S;return y===void 0?y=this.scheme:y===null&&(y=d),A===void 0?A=this.authority:A===null&&(A=d),L===void 0?L=this.path:L===null&&(L=d),D===void 0?D=this.query:D===null&&(D=d),O===void 0?O=this.fragment:O===null&&(O=d),y===this.scheme&&A===this.authority&&L===this.path&&D===this.query&&O===this.fragment?this:new $(y,A,L,D,O)}static parse(S,y=!1){const A=f.exec(S);return A?new $(A[2]||d,a(A[4]||d),a(A[5]||d),a(A[7]||d),a(A[9]||d),y):new $(d,d,d,d,d)}static file(S){let y=d;if(R.$j&&(S=S.replace(/\\/g,w)),S[0]===w&&S[1]===w){const A=S.indexOf(w,2);A===-1?(y=S.substring(2),S=w):(y=S.substring(2,A),S=S.substring(A)||w)}return new $("file",y,S,d,d)}static from(S,y){return new $(S.scheme,S.authority,S.path,S.query,S.fragment,y)}static joinPath(S,...y){if(!S.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let A;return R.$j&&S.scheme==="file"?A=g.file(k.$fc.join(h(S,!0),...y)).path:A=k.$gc.join(S.path,...y),S.with({path:A})}toString(S=!1){return t(this,S)}toJSON(){return this}static revive(S){if(S){if(S instanceof g)return S;{const y=new $(S);return y._formatted=S.external??null,y._fsPath=S._sep===b?S.fsPath??null:null,y}}else return S}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=g;function v(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}const b=R.$j?1:void 0;class $ extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(S=!1){return S?t(this,!0):(this._formatted||(this._formatted=t(this,!1)),this._formatted)}toJSON(){const S={$mid:r.MarshalledId.Uri};return this._fsPath&&(S.fsPath=this._fsPath,S._sep=b),this._formatted&&(S.external=this._formatted),this.path&&(S.path=this.path),this.scheme&&(S.scheme=this.scheme),this.authority&&(S.authority=this.authority),this.query&&(S.query=this.query),this.fragment&&(S.fragment=this.fragment),S}}const P={[n.CharCode.Colon]:"%3A",[n.CharCode.Slash]:"%2F",[n.CharCode.QuestionMark]:"%3F",[n.CharCode.Hash]:"%23",[n.CharCode.OpenSquareBracket]:"%5B",[n.CharCode.CloseSquareBracket]:"%5D",[n.CharCode.AtSign]:"%40",[n.CharCode.ExclamationMark]:"%21",[n.CharCode.DollarSign]:"%24",[n.CharCode.Ampersand]:"%26",[n.CharCode.SingleQuote]:"%27",[n.CharCode.OpenParen]:"%28",[n.CharCode.CloseParen]:"%29",[n.CharCode.Asterisk]:"%2A",[n.CharCode.Plus]:"%2B",[n.CharCode.Comma]:"%2C",[n.CharCode.Semicolon]:"%3B",[n.CharCode.Equals]:"%3D",[n.CharCode.Space]:"%20"};function E(l,S,y){let A,L=-1;for(let D=0;D<l.length;D++){const O=l.charCodeAt(D);if(O>=n.CharCode.a&&O<=n.CharCode.z||O>=n.CharCode.A&&O<=n.CharCode.Z||O>=n.CharCode.Digit0&&O<=n.CharCode.Digit9||O===n.CharCode.Dash||O===n.CharCode.Period||O===n.CharCode.Underline||O===n.CharCode.Tilde||S&&O===n.CharCode.Slash||y&&O===n.CharCode.OpenSquareBracket||y&&O===n.CharCode.CloseSquareBracket||y&&O===n.CharCode.Colon)L!==-1&&(A+=encodeURIComponent(l.substring(L,D)),L=-1),A!==void 0&&(A+=l.charAt(D));else{A===void 0&&(A=l.substr(0,D));const M=P[O];M!==void 0?(L!==-1&&(A+=encodeURIComponent(l.substring(L,D)),L=-1),A+=M):L===-1&&(L=D)}}return L!==-1&&(A+=encodeURIComponent(l.substring(L))),A!==void 0?A:l}function i(l){let S;for(let y=0;y<l.length;y++){const A=l.charCodeAt(y);A===n.CharCode.Hash||A===n.CharCode.QuestionMark?(S===void 0&&(S=l.substr(0,y)),S+=P[A]):S!==void 0&&(S+=l[y])}return S!==void 0?S:l}function h(l,S){let y;return l.authority&&l.path.length>1&&l.scheme==="file"?y=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===n.CharCode.Slash&&(l.path.charCodeAt(1)>=n.CharCode.A&&l.path.charCodeAt(1)<=n.CharCode.Z||l.path.charCodeAt(1)>=n.CharCode.a&&l.path.charCodeAt(1)<=n.CharCode.z)&&l.path.charCodeAt(2)===n.CharCode.Colon?S?y=l.path.substr(1):y=l.path[1].toLowerCase()+l.path.substr(2):y=l.path,R.$j&&(y=y.replace(/\//g,"\\")),y}function t(l,S){const y=S?i:E;let A="",{scheme:L,authority:D,path:O,query:M,fragment:Z}=l;if(L&&(A+=L,A+=":"),(D||L==="file")&&(A+=w,A+=w),D){let q=D.indexOf("@");if(q!==-1){const K=D.substr(0,q);D=D.substr(q+1),q=K.lastIndexOf(":"),q===-1?A+=y(K,!1,!1):(A+=y(K.substr(0,q),!1,!1),A+=":",A+=y(K.substr(q+1),!1,!0)),A+="@"}D=D.toLowerCase(),q=D.lastIndexOf(":"),q===-1?A+=y(D,!1,!0):(A+=y(D.substr(0,q),!1,!0),A+=D.substr(q))}if(O){if(O.length>=3&&O.charCodeAt(0)===n.CharCode.Slash&&O.charCodeAt(2)===n.CharCode.Colon){const q=O.charCodeAt(1);q>=n.CharCode.A&&q<=n.CharCode.Z&&(O=`/${String.fromCharCode(q+32)}:${O.substr(3)}`)}else if(O.length>=2&&O.charCodeAt(1)===n.CharCode.Colon){const q=O.charCodeAt(0);q>=n.CharCode.A&&q<=n.CharCode.Z&&(O=`${String.fromCharCode(q+32)}:${O.substr(2)}`)}A+=y(O,!0,!1)}return M&&(A+="?",A+=y(M,!1,!1)),Z&&(A+="#",A+=S?Z:E(Z,!1,!1)),A}function o(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+o(l.substr(3)):l}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(l){return l.match(s)?l.replace(s,S=>o(S)):l}}),define(ce[150],le([0,1,7]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=r,e.$er=k,e.$fr=R,e.log=I;function r(c){const m=c;return m&&typeof m.type=="string"&&typeof m.severity=="string"}function k(c){const m=[];let u;try{const d=JSON.parse(c.arguments),w=d[d.length-1];w&&w.__$stack&&(d.pop(),u=w.__$stack),m.push(...d)}catch{m.push("Unable to log remote console arguments",c.arguments)}return{args:m,stack:u}}function R(c){if(typeof c!="string")return R(k(c).stack);const m=c;if(m){const u=T(m),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(u||"");if(d&&d.length===4)return{uri:n.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}function T(c){if(!c)return c;const m=c.indexOf(`
`);return m===-1?c:c.substring(0,m)}function I(c,m){const{args:u,stack:d}=k(c),w=typeof u[0]=="string"&&u.length===1;let f=T(d);f&&(f=`(${f.trim()})`);let g=[];if(typeof u[0]=="string"?f&&w?g=[`%c[${m}] %c${u[0]} %c${f}`,p("blue"),p(""),p("grey")]:g=[`%c[${m}] %c${u[0]}`,p("blue"),p(""),...u.slice(1)]:g=[`%c[${m}]%`,p("blue"),...u],f&&!w&&g.push(f),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,g)}function p(c){return`color: ${c}`}}),define(ce[82],le([0,1,17,7,90]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=R,e.$bi=T,e.$ci=p;function R(c){return JSON.stringify(c,I)}function T(c){let m=JSON.parse(c);return m=p(m),m}function I(c,m){return m instanceof RegExp?{$mid:k.MarshalledId.Regexp,source:m.source,flags:m.flags}:m}function p(c,m=0){if(!c||m>200)return c;if(typeof c=="object"){switch(c.$mid){case k.MarshalledId.Uri:return r.URI.revive(c);case k.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case k.MarshalledId.Date:return new Date(c.source)}if(c instanceof n.$Ne||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let u=0;u<c.length;++u)c[u]=p(c[u],m+1);else for(const u in c)Object.hasOwnProperty.call(c,u)&&(c[u]=p(c[u],m+1))}return c}}),define(ce[12],le([0,1,15,3,25,7,9]),function(x,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=p,e.$Pg=c,e.$Tg=u,n=Pe(n),r=Pe(r),T=Pe(T);var I;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",f.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting"})(I||(e.Schemas=I={}));function p(f,g){return R.URI.isUri(f)?(0,k.$Ff)(f.scheme,g):(0,k.$Gf)(f,g+":")}function c(f,...g){return g.some(v=>p(f,v))}e.$Qg="vscode-tkn",e.$Rg="tkn";class m{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g,v){this.f=u(g,v)}getServerRootPath(){return this.f}get g(){return T.$gc.join(this.f,I.vscodeRemoteResource)}set(g,v,b){this.a[g]=v,this.b[g]=b}setConnectionToken(g,v){this.c[g]=v}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)try{return this.e(g)}catch(i){return n.$Y(i),g}const v=g.authority;let b=this.a[v];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const $=this.b[v],P=this.c[v];let E=`path=${encodeURIComponent(g.path)}`;return typeof P=="string"&&(E+=`&${e.$Rg}=${encodeURIComponent(P)}`),R.URI.from({scheme:r.$p?this.d:I.vscodeRemoteResource,authority:`${b}:${$}`,path:this.g,query:E})}}e.$Sg=new m;function u(f,g){return T.$gc.join(g??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class d{static{this.a=e.$Yg}asBrowserUri(g){const v=this.b(g,x);return this.uriToBrowserUri(v)}uriToBrowserUri(g){return g.scheme===I.vscodeRemote?e.$Sg.rewrite(g):g.scheme===I.file&&(r.$n||r.$r===`${I.vscodeFileResource}://${d.a}`)?g.with({scheme:I.vscodeFileResource,authority:g.authority||d.a,query:null,fragment:null}):g}asFileUri(g){const v=this.b(g,x);return this.uriToFileUri(v)}uriToFileUri(g){return g.scheme===I.vscodeFileResource?g.with({scheme:I.file,authority:g.authority!==d.a?g.authority:null,query:null,fragment:null}):g}b(g,v){return R.URI.isUri(g)?g:R.URI.parse(v.toUrl(g))}}e.$Zg=new d;var w;(function(f){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(g.get("3"));const v="vscode-coi";function b(P){let E;typeof P=="string"?E=new URL(P).searchParams:P instanceof URL?E=P.searchParams:R.URI.isUri(P)&&(E=new URL(P.toString(!0)).searchParams);const i=E?.get(v);if(i)return g.get(i)}f.getHeadersFromQuery=b;function $(P,E,i){if(!globalThis.crossOriginIsolated)return;const h=E&&i?"3":i?"2":"1";P instanceof URLSearchParams?P.set(v,h):P[v]=h}f.addSearchParam=$})(w||(e.COI=w={}))}),define(ce[18],le([0,1,39,32,12,9,3,25,7]),function(x,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=c,e.$ph=u,e.$qh=w,r=Pe(r),R=Pe(R);function c(f){return(0,p.$wc)(f,!0)}class m{constructor(g){this.a=g}compare(g,v,b=!1){return g===v?0:(0,I.$yf)(this.getComparisonKey(g,b),this.getComparisonKey(v,b))}isEqual(g,v,b=!1){return g===v?!0:!g||!v?!1:this.getComparisonKey(g,b)===this.getComparisonKey(v,b)}getComparisonKey(g,v=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,v,b=!1){if(g.scheme===v.scheme){if(g.scheme===k.Schemas.file)return r.$Eg(c(g),c(v),this.a(g))&&g.query===v.query&&(b||g.fragment===v.fragment);if((0,e.$lh)(g.authority,v.authority))return r.$Eg(g.path,v.path,this.a(g),"/")&&g.query===v.query&&(b||g.fragment===v.fragment)}return!1}joinPath(g,...v){return p.URI.joinPath(g,...v)}basenameOrAuthority(g){return(0,e.$dh)(g)||g.authority}basename(g){return R.$gc.basename(g.path)}extname(g){return R.$gc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let v;return g.scheme===k.Schemas.file?v=p.URI.file(R.$mc(c(g))).path:(v=R.$gc.dirname(g.path),g.authority&&v.length&&v.charCodeAt(0)!==n.CharCode.Slash&&(console.error(`dirname("${g.toString})) resulted in a relative path`),v="/")),g.with({path:v})}normalizePath(g){if(!g.path.length)return g;let v;return g.scheme===k.Schemas.file?v=p.URI.file(R.$hc(c(g))).path:v=R.$gc.normalize(g.path),g.with({path:v})}relativePath(g,v){if(g.scheme!==v.scheme||!(0,e.$lh)(g.authority,v.authority))return;if(g.scheme===k.Schemas.file){const P=R.$lc(c(g),c(v));return T.$j?r.$yg(P):P}let b=g.path||"/";const $=v.path||"/";if(this.a(g)){let P=0;for(const E=Math.min(b.length,$.length);P<E&&!(b.charCodeAt(P)!==$.charCodeAt(P)&&b.charAt(P).toLowerCase()!==$.charAt(P).toLowerCase());P++);b=$.substr(0,P)+b.substr(P)}return R.$gc.relative(b,$)}resolvePath(g,v){if(g.scheme===k.Schemas.file){const b=p.URI.file(R.$kc(c(g),v));return g.with({authority:b.authority,path:b.path})}return v=r.$zg(v),g.with({path:R.$gc.resolve(g.path,v)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,v){return g===v||g!==void 0&&v!==void 0&&(0,I.$Ff)(g,v)}hasTrailingPathSeparator(g,v=R.sep){if(g.scheme===k.Schemas.file){const b=c(g);return b.length>r.$Ag(b).length&&b[b.length-1]===v}else{const b=g.path;return b.length>1&&b.charCodeAt(b.length-1)===n.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,v=R.sep){return(0,e.$mh)(g,v)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,v=R.sep){let b=!1;if(g.scheme===k.Schemas.file){const $=c(g);b=$!==void 0&&$.length===r.$Ag($).length&&$[$.length-1]===v}else{v="/";const $=g.path;b=$.length===1&&$.charCodeAt($.length-1)===n.CharCode.Slash}return!b&&!(0,e.$mh)(g,v)?g.with({path:g.path+"/"}):g}}e.$8g=m,e.$9g=new m(()=>!1),e.$0g=new m(f=>f.scheme===k.Schemas.file?!T.$l:!0),e.$$g=new m(f=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function u(f,g){const v=[];for(let b=0;b<f.length;b++){const $=g(f[b]);f.some((P,E)=>E===b?!1:(0,e.$ah)($,g(P)))||v.push(f[b])}return v}var d;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function g(v){const b=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(E=>{const[i,h]=E.split(":");i&&h&&b.set(i,h)});const P=v.path.substring(0,v.path.indexOf(";"));return P&&b.set(f.META_DATA_MIME,P),b}f.parseMetaData=g})(d||(e.DataUri=d={}));function w(f,g,v){if(g){let b=f.path;return b&&b[0]!==R.$gc.sep&&(b=R.$gc.sep+b),f.with({scheme:v,authority:g,path:b})}return f.with({scheme:v})}}),define(ce[8],le([0,1,22,15,4,2,18,3,147,65]),function(x,e,n,r,k,R,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=m,e.$sh=u,e.$th=d,e.$uh=w,e.$vh=f,e.$wh=g,e.$xh=v,e.$yh=b,e.$Gh=l,e.$Hh=S,e.$Ih=y,e.$Jh=A,e.$Kh=L,e.$Zh=j,e.$8h=z;function m(G){return!!G&&typeof G.then=="function"}function u(G){const U=new n.$we,te=G(U.token),he=new Promise((me,we)=>{const Ie=U.token.onCancellationRequested(()=>{Ie.dispose(),we(new r.$4)});Promise.resolve(te).then(Ce=>{Ie.dispose(),U.dispose(),me(Ce)},Ce=>{Ie.dispose(),U.dispose(),we(Ce)})});return new class{cancel(){U.cancel(),U.dispose()}then(me,we){return he.then(me,we)}catch(me){return this.then(void 0,me)}finally(me){return he.finally(me)}}}function d(G,U,te){return new Promise((he,me)=>{const we=U.onCancellationRequested(()=>{we.dispose(),he(te)});G.then(he,me).finally(()=>we.dispose())})}function w(G,U){return new Promise((te,he)=>{const me=U.onCancellationRequested(()=>{me.dispose(),he(new r.$4)});G.then(te,he).finally(()=>me.dispose())})}async function f(G){let U=-1;const te=G.map((he,me)=>he.then(we=>(U=me,we)));try{return await Promise.race(te)}finally{G.forEach((he,me)=>{me!==U&&he.cancel()})}}function g(G,U,te){let he;const me=setTimeout(()=>{he?.(void 0),te?.()},U);return Promise.race([G.finally(()=>clearTimeout(me)),new Promise(we=>he=we)])}function v(G){return new Promise((U,te)=>{const he=G();m(he)?he.then(U,te):U(he)})}function b(){let G,U;return{promise:new Promise((he,me)=>{G=he,U=me}),resolve:G,reject:U}}class ${constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(U){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=U,!this.b){const te=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(te,te).then(he)})}return new Promise((te,he)=>{this.b.then(te,he)})}return this.a=U(),new Promise((te,he)=>{this.a.then(me=>{this.a=null,te(me)},me=>{this.a=null,he(me)})})}dispose(){this.f=!0}}e.$zh=$;class P{constructor(){this.a=Promise.resolve(null)}queue(U){return this.a=this.a.then(()=>U(),()=>U())}}e.$Ah=P;class E{constructor(){this.a=new Map}queue(U,te){const me=(this.a.get(U)??Promise.resolve()).catch(()=>{}).then(te).finally(()=>{this.a.get(U)===me&&this.a.delete(U)});return this.a.set(U,me),me}}e.$Bh=E;const i=(G,U)=>{let te=!0;const he=setTimeout(()=>{te=!1,U()},G);return{isTriggered:()=>te,dispose:()=>{clearTimeout(he),te=!1}}},h=G=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,G())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};class t{constructor(U){this.defaultDelay=U,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(U,te=this.defaultDelay){this.g=U,this.h(),this.b||(this.b=new Promise((me,we)=>{this.d=me,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=te===p.$ge?h(he):i(te,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new r.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=t;class o{constructor(U){this.a=new t(U),this.b=new $}trigger(U,te){return this.a.trigger(()=>this.b.queue(U),te)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=o;class s{constructor(){this.a=!1,this.b=new Promise((U,te)=>{this.d=U})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=s;class a extends s{constructor(U){super(),this.f=setTimeout(()=>this.open(),U)}open(){clearTimeout(this.f),super.open()}}e.$Fh=a;function l(G,U){return U?new Promise((te,he)=>{const me=setTimeout(()=>{we.dispose(),te()},G),we=U.onCancellationRequested(()=>{clearTimeout(me),we.dispose(),he(new r.$4)})}):u(te=>l(G,te))}function S(G,U=0,te){const he=setTimeout(()=>{G(),te&&me.dispose()},U),me=(0,R.$Sc)(()=>{clearTimeout(he),te?.deleteAndLeak(me)});return te?.add(me),me}function y(G){const U=[];let te=0;const he=G.length;function me(){return te<he?G[te++]():null}function we(Ie){Ie!=null&&U.push(Ie);const Ce=me();return Ce?Ce.then(we):Promise.resolve(U)}return Promise.resolve(null).then(we)}function A(G,U=he=>!!he,te=null){let he=0;const me=G.length,we=()=>{if(he>=me)return Promise.resolve(te);const Ie=G[he++];return Promise.resolve(Ie()).then(Ae=>U(Ae)?Promise.resolve(Ae):we())};return we()}function L(G,U=he=>!!he,te=null){if(G.length===0)return Promise.resolve(te);let he=G.length;const me=()=>{he=-1;for(const we of G)we.cancel?.()};return new Promise((we,Ie)=>{for(const Ce of G)Ce.then(Ae=>{--he>=0&&U(Ae)?(me(),we(Ae)):he===0&&we(te)}).catch(Ae=>{--he>=0&&(me(),Ie(Ae))})})}class D{constructor(U){this.a=0,this.b=!1,this.f=U,this.g=[],this.d=0,this.h=new k.$le}whenIdle(){return this.size>0?k.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(U){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((te,he)=>{this.g.push({factory:U,c:te,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const U=this.g.shift();this.d++;const te=U.factory();te.then(U.c,U.e),te.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=D;class O extends D{constructor(){super(1)}}e.$Mh=O;class M{constructor(){this.a=new C,this.b=0}queue(U){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,U())):this.a.run(this.b++,U())}}e.$Nh=M;class Z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const U=new V;return this.b.add(U),U.p}g(){for(const[,U]of this.a)if(U.size>0)return!1;return!0}queueSize(U,te=T.$9g){const he=te.getComparisonKey(U);return this.a.get(he)?.size??0}queueFor(U,te,he=T.$9g){const me=he.getComparisonKey(U);let we=this.a.get(me);if(!we){we=new O;const Ie=this.f++,Ce=k.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(Ie),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$4c),this.d.set(Ie,Ce),this.a.set(me,we)}return we.queue(te)}h(){this.g()&&this.j()}j(){for(const U of this.b)U.complete();this.b.clear()}dispose(){for(const[,U]of this.a)U.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=Z;class q{constructor(U,te){this.b=!1,this.a=-1,typeof U=="function"&&typeof te=="number"&&this.setIfNotSet(U,te)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(U,te){if(this.b)throw new r.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,U()},te)}setIfNotSet(U,te){if(this.b)throw new r.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,U()},te))}}e.$Ph=q;class K{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(U,te,he=globalThis){if(this.f)throw new r.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const me=he.setInterval(()=>{U()},te);this.d=(0,R.$Sc)(()=>{he.clearInterval(me),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=K;class de{constructor(U,te){this.b=-1,this.a=U,this.d=te,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(U=this.d){this.cancel(),this.b=setTimeout(this.f,U)}get delay(){return this.d}set delay(U){this.d=U}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=de;class H{constructor(U,te){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.a=U,this.b=te,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(U=this.b){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(U/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=H;class Y extends de{constructor(U,te){super(U,te),this.j=[]}work(U){this.j.push(U),this.isScheduled()||this.schedule()}h(){const U=this.j;this.j=[],this.a?.(U)}dispose(){this.j=[],super.dispose()}}e.$Th=Y;class B extends R.$Uc{constructor(U,te){super(),this.g=U,this.h=te,this.a=[],this.b=this.B(new R.$Vc),this.f=!1}get pending(){return this.a.length}work(U){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+U.length>this.g.maxBufferedWork)return!1}else if(this.pending+U.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const te of U)this.a.push(te);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new de(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=B,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(G,U)=>{(0,I.$C)(()=>{if(te)return;const he=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let te=!1;return{dispose(){te||(te=!0)}}}:e.$Wh=(G,U,te)=>{const he=G.requestIdleCallback(U,typeof te=="number"?{timeout:te}:void 0);let me=!1;return{dispose(){me||(me=!0,G.cancelIdleCallback(he))}}},e.$Vh=G=>(0,e.$Wh)(globalThis,G)}();class Q{constructor(U,te){this.g=!1,this.d=()=>{try{this.j=te()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Wh)(U,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=Q;class W extends Q{constructor(U){super(globalThis,U)}}e.$Yh=W;async function j(G,U,te){let he;for(let me=0;me<te;me++)try{return await G()}catch(we){he=we,await l(U)}throw he}class C{isRunning(U){return typeof U=="number"?this.a?.taskId===U:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(U,te,he){return this.a={taskId:U,cancel:()=>he?.(),promise:te},te.then(()=>this.d(U),()=>this.d(U)),te}d(U){this.a&&U===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const U=this.b;this.b=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}queue(U){if(this.b)this.b.run=U;else{const{promise:te,resolve:he,reject:me}=b();this.b={run:U,promise:te,promiseResolve:he,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=C;class X{constructor(U,te=()=>Date.now()){this.d=U,this.f=te,this.a=0,this.b=0}increment(){const U=this.f();return U-this.a>this.d&&(this.a=U,this.b=0),this.b++,this.b}}e.$2h=X;var oe;(function(G){G[G.Resolved=0]="Resolved",G[G.Rejected=1]="Rejected"})(oe||(oe={}));class V{get isRejected(){return this.d?.outcome===oe.Rejected}get isResolved(){return this.d?.outcome===oe.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===oe.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((U,te)=>{this.a=U,this.b=te})}complete(U){return new Promise(te=>{this.a(U),this.d={outcome:oe.Resolved,value:U},te()})}error(U){return new Promise(te=>{this.b(U),this.d={outcome:oe.Rejected,value:U},te()})}cancel(){return this.error(new r.$4)}}e.$3h=V;var ue;(function(G){async function U(he){let me;const we=await Promise.all(he.map(Ie=>Ie.then(Ce=>Ce,Ce=>{me||(me=Ce)})));if(typeof me<"u")throw me;return we}G.settled=U;function te(he){return new Promise(async(me,we)=>{try{await he(me,we)}catch(Ie){we(Ie)}})}G.withAsyncBody=te})(ue||(e.Promises=ue={}));class re{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(U){this.a=void 0,this.b=void 0,this.d=!1,this.promise=U.then(te=>(this.a=te,this.d=!0,te),te=>{throw this.b=te,this.d=!0,te})}requireValue(){if(!this.d)throw new r.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=re;class J{constructor(U){this.b=U,this.a=new c.$T(()=>new re(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=J;var F;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(F||(F={}));class N{static fromArray(U){return new N(te=>{te.emitMany(U)})}static fromPromise(U){return new N(async te=>{te.emitMany(await U)})}static fromPromises(U){return new N(async te=>{await Promise.all(U.map(async he=>te.emitOne(await he)))})}static merge(U){return new N(async te=>{await Promise.all(U.map(async he=>{for await(const me of he)te.emitOne(me)}))})}static{this.EMPTY=N.fromArray([])}constructor(U,te){this.a=F.Initial,this.b=[],this.d=null,this.f=te,this.g=new k.$le,queueMicrotask(async()=>{const he={emitOne:me=>this.h(me),emitMany:me=>this.j(me),reject:me=>this.l(me)};try{await Promise.resolve(U(he)),this.k()}catch(me){this.l(me)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this.a===F.DoneError)throw this.d;if(U<this.b.length)return{done:!1,value:this.b[U++]};if(this.a===F.DoneOK)return{done:!0,value:void 0};await k.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(U,te){return new N(async he=>{for await(const me of U)he.emitOne(te(me))})}map(U){return N.map(this,U)}static filter(U,te){return new N(async he=>{for await(const me of U)te(me)&&he.emitOne(me)})}filter(U){return N.filter(this,U)}static coalesce(U){return N.filter(U,te=>!!te)}coalesce(){return N.coalesce(this)}static async toPromise(U){const te=[];for await(const he of U)te.push(he);return te}toPromise(){return N.toPromise(this)}h(U){this.a===F.Initial&&(this.b.push(U),this.g.fire())}j(U){this.a===F.Initial&&(this.b=this.b.concat(U),this.g.fire())}k(){this.a===F.Initial&&(this.a=F.DoneOK,this.g.fire())}l(U){this.a===F.Initial&&(this.a=F.DoneError,this.d=U,this.g.fire())}}e.$6h=N;class _ extends N{constructor(U,te){super(te),this.m=U}cancel(){this.m.cancel()}}e.$7h=_;function z(G){const U=new n.$we,te=G(U.token);return new _(U,async he=>{const me=U.token.onCancellationRequested(()=>{me.dispose(),U.dispose(),he.reject(new r.$4)});try{for await(const we of te){if(U.token.isCancellationRequested)return;he.emitOne(we)}me.dispose(),U.dispose()}catch(we){me.dispose(),U.dispose(),he.reject(we)}})}class ie{constructor(U){this.a=new V,this.b=new N(me=>{if(te){me.reject(te);return}return he&&me.emitMany(he),this.d=we=>me.reject(we),this.f=we=>me.emitOne(we),this.a.p},U);let te,he;this.f=me=>{he||(he=[]),he.push(me)},this.d=me=>{te||(te=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(U){this.d(U),this.a.complete()}emitOne(U){this.f(U)}}e.$9h=ie}),define(ce[111],le([0,1,21,8,39,32,31,9,3,25]),function(x,e,n,r,k,R,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$vk=m,e.$yk=g,e.$zk=M,e.$Ak=Z,e.$Bk=q,e.$Ck=K,e.$Dk=de,e.$Ek=Q;function m(){return Object.create(null)}e.$wk="**",e.$xk="/";const u="[/\\\\]",d="[^/\\\\]",w=/\//g;function f(W,j){switch(W){case 0:return"";case 1:return`${d}*?`;default:return`(?:${u}|${d}+${u}${j?`|${u}${d}+`:""})*?`}}function g(W,j){if(!W)return[];const C=[];let X=!1,oe=!1,V="";for(const ue of W){switch(ue){case j:if(!X&&!oe){C.push(V),V="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}V+=ue}return V&&C.push(V),C}function v(W){if(!W)return"";let j="";const C=g(W,e.$xk);if(C.every(X=>X===e.$wk))j=".*";else{let X=!1;C.forEach((oe,V)=>{if(oe===e.$wk){if(X)return;j+=f(2,V===C.length-1)}else{let ue=!1,re="",J=!1,F="";for(const N of oe){if(N!=="}"&&ue){re+=N;continue}if(J&&(N!=="]"||!F)){let _;N==="-"?_=N:(N==="^"||N==="!")&&!F?_="^":N===e.$xk?_="":_=(0,c.$hf)(N),F+=_;continue}switch(N){case"{":ue=!0;continue;case"[":J=!0;continue;case"}":{const z=`(?:${g(re,",").map(ie=>v(ie)).join("|")})`;j+=z,ue=!1,re="";break}case"]":{j+="["+F+"]",J=!1,F="";break}case"?":j+=d;continue;case"*":j+=f(1);continue;default:j+=(0,c.$hf)(N)}}V<C.length-1&&(C[V+1]!==e.$wk||V+2<C.length)&&(j+=u)}X=oe===e.$wk})}return j}const b=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,E=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,i=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.$Dc(1e4),o=function(){return!1},s=function(){return null};function a(W,j){if(!W)return s;let C;typeof W!="string"?C=W.pattern:C=W,C=C.trim();const X=`${C}_${!!j.trimForExclusions}`;let oe=t.get(X);if(oe)return l(oe,W);let V;return b.test(C)?oe=y(C.substr(4),C):(V=$.exec(S(C,j)))?oe=A(V[1],C):(j.trimForExclusions?E:P).test(C)?oe=L(C,j):(V=i.exec(S(C,j)))?oe=D(V[1].substr(1),C,!0):(V=h.exec(S(C,j)))?oe=D(V[1],C,!1):oe=O(C),t.set(X,oe),l(oe,W)}function l(W,j){if(typeof j=="string")return W;const C=function(X,oe){return(0,R.$Eg)(X,j.base,!p.$l)?W((0,c.$mf)(X.substr(j.base.length),I.sep),oe):null};return C.allBasenames=W.allBasenames,C.allPaths=W.allPaths,C.basenames=W.basenames,C.patterns=W.patterns,C}function S(W,j){return j.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function y(W,j){return function(C,X){return typeof C=="string"&&C.endsWith(W)?j:null}}function A(W,j){const C=`/${W}`,X=`\\${W}`,oe=function(ue,re){return typeof ue!="string"?null:re?re===W?j:null:ue===W||ue.endsWith(C)||ue.endsWith(X)?j:null},V=[W];return oe.basenames=V,oe.patterns=[j],oe.allBasenames=V,oe}function L(W,j){const C=B(W.slice(1,-1).split(",").map(re=>a(re,j)).filter(re=>re!==s),W),X=C.length;if(!X)return s;if(X===1)return C[0];const oe=function(re,J){for(let F=0,N=C.length;F<N;F++)if(C[F](re,J))return W;return null},V=C.find(re=>!!re.allBasenames);V&&(oe.allBasenames=V.allBasenames);const ue=C.reduce((re,J)=>J.allPaths?re.concat(J.allPaths):re,[]);return ue.length&&(oe.allPaths=ue),oe}function D(W,j,C){const X=I.sep===I.$gc.sep,oe=X?W:W.replace(w,I.sep),V=I.sep+oe,ue=I.$gc.sep+W;let re;return C?re=function(J,F){return typeof J=="string"&&(J===oe||J.endsWith(V)||!X&&(J===W||J.endsWith(ue)))?j:null}:re=function(J,F){return typeof J=="string"&&(J===oe||!X&&J===W)?j:null},re.allPaths=[(C?"*/":"./")+W],re}function O(W){try{const j=new RegExp(`^${v(W)}$`);return function(C){return j.lastIndex=0,typeof C=="string"&&j.test(C)?W:null}}catch{return s}}function M(W,j,C){return!W||typeof j!="string"?!1:Z(W)(j,void 0,C)}function Z(W,j={}){if(!W)return o;if(typeof W=="string"||q(W)){const C=a(W,j);if(C===s)return o;const X=function(oe,V){return!!C(oe,V)};return C.allBasenames&&(X.allBasenames=C.allBasenames),C.allPaths&&(X.allPaths=C.allPaths),X}return H(W,j)}function q(W){const j=W;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}function K(W){return W.allBasenames||[]}function de(W){return W.allPaths||[]}function H(W,j){const C=B(Object.getOwnPropertyNames(W).map(re=>Y(re,W[re],j)).filter(re=>re!==s)),X=C.length;if(!X)return s;if(!C.some(re=>!!re.requiresSiblings)){if(X===1)return C[0];const re=function(N,_){let z;for(let ie=0,G=C.length;ie<G;ie++){const U=C[ie](N,_);if(typeof U=="string")return U;(0,r.$rh)(U)&&(z||(z=[]),z.push(U))}return z?(async()=>{for(const ie of z){const G=await ie;if(typeof G=="string")return G}return null})():null},J=C.find(N=>!!N.allBasenames);J&&(re.allBasenames=J.allBasenames);const F=C.reduce((N,_)=>_.allPaths?N.concat(_.allPaths):N,[]);return F.length&&(re.allPaths=F),re}const oe=function(re,J,F){let N,_;for(let z=0,ie=C.length;z<ie;z++){const G=C[z];G.requiresSiblings&&F&&(J||(J=(0,I.$nc)(re)),N||(N=J.substr(0,J.length-(0,I.$oc)(re).length)));const U=G(re,J,N,F);if(typeof U=="string")return U;(0,r.$rh)(U)&&(_||(_=[]),_.push(U))}return _?(async()=>{for(const z of _){const ie=await z;if(typeof ie=="string")return ie}return null})():null},V=C.find(re=>!!re.allBasenames);V&&(oe.allBasenames=V.allBasenames);const ue=C.reduce((re,J)=>J.allPaths?re.concat(J.allPaths):re,[]);return ue.length&&(oe.allPaths=ue),oe}function Y(W,j,C){if(j===!1)return s;const X=a(W,C);if(X===s)return s;if(typeof j=="boolean")return X;if(j){const oe=j.when;if(typeof oe=="string"){const V=(ue,re,J,F)=>{if(!F||!X(ue,re))return null;const N=oe.replace("$(basename)",()=>J),_=F(N);return(0,r.$rh)(_)?_.then(z=>z?W:null):_?W:null};return V.requiresSiblings=!0,V}}return X}function B(W,j){const C=W.filter(re=>!!re.basenames);if(C.length<2)return W;const X=C.reduce((re,J)=>{const F=J.basenames;return F?re.concat(F):re},[]);let oe;if(j){oe=[];for(let re=0,J=X.length;re<J;re++)oe.push(j)}else oe=C.reduce((re,J)=>{const F=J.patterns;return F?re.concat(F):re},[]);const V=function(re,J){if(typeof re!="string")return null;if(!J){let N;for(N=re.length;N>0;N--){const _=re.charCodeAt(N-1);if(_===k.CharCode.Slash||_===k.CharCode.Backslash)break}J=re.substr(N)}const F=X.indexOf(J);return F!==-1?oe[F]:null};V.basenames=X,V.patterns=oe,V.allBasenames=X;const ue=W.filter(re=>!re.basenames);return ue.push(V),ue}function Q(W,j){return(0,n.$tb)(W,j,(C,X)=>typeof C=="string"&&typeof X=="string"?C===X:typeof C!="string"&&typeof X!="string"?C.base===X.base&&C.pattern===X.pattern:!1)}}),define(ce[47],le([0,1,21,32,9,3,18,25]),function(x,e,n,r,k,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zw=p,e.$1w=m,e.$2w=d,e.$3w=w,e.$4w=b,e.$5w=P,e.$6w=E,e.$7w=i,e.$8w=h,e.$9w=t;function p(s,a){const{os:l,tildify:S,relative:y}=a;if(y){const D=c(s,y,l);if(typeof D=="string")return D}let A=s.fsPath;if(l===R.OperatingSystem.Windows&&!R.$j?A=A.replace(/\//g,"\\"):l!==R.OperatingSystem.Windows&&R.$j&&(A=A.replace(/\\/g,"/")),l!==R.OperatingSystem.Windows&&S?.userHome){const D=S.userHome.fsPath;let O;s.scheme!==S.userHome.scheme&&s.path[0]===k.$gc.sep&&s.path[1]!==k.$gc.sep?O=S.userHome.with({path:s.path}).fsPath:O=A,A=d(O,D,l)}return(l===R.OperatingSystem.Windows?k.$fc:k.$gc).normalize(m(A,l===R.OperatingSystem.Windows))}function c(s,a,l){const S=l===R.OperatingSystem.Windows?k.$fc:k.$gc,y=l===R.OperatingSystem.Linux?T.$9g:T.$$g,A=a.getWorkspace(),L=(0,n.$Nb)(A.folders);if(!L)return;s.scheme!==L.uri.scheme&&s.path[0]===k.$gc.sep&&s.path[1]!==k.$gc.sep&&(s=L.uri.with({path:s.path}));const D=a.getWorkspaceFolder(s);if(!D)return;let O;if(y.isEqual(D.uri,s)?O="":O=y.relativePath(D.uri,s)??"",O&&(O=S.normalize(O)),A.folders.length>1&&!a.noPrefix){const M=D.name?D.name:y.basenameOrAuthority(D.uri);O=O?`${M} \u2022 ${O}`:M}return O}function m(s,a=R.$j){return(0,r.$Jg)(s,a)?s.charAt(0).toUpperCase()+s.slice(1):s}let u=Object.create(null);function d(s,a,l=R.OS){if(l===R.OperatingSystem.Windows||!s||!a)return s;let S=u.original===a?u.normalized:void 0;S||(S=a,R.$j&&(S=(0,r.$yg)(S)),S=`${(0,I.$nf)(S,k.$gc.sep)}${k.$gc.sep}`,u={original:a,normalized:S});let y=s;return R.$j&&(y=(0,r.$yg)(y)),(l===R.OperatingSystem.Linux?y.startsWith(S):(0,I.$Gf)(y,S))?`~/${y.substr(S.length)}`:s}function w(s,a){return s.replace(/^~($|\/|\\)/,`${a}$1`)}const f="\u2026",g="\\\\",v="~";function b(s,a=k.sep){const l=new Array(s.length);let S=!1;for(let y=0;y<s.length;y++){const A=s[y];if(A===""){l[y]=`.${a}`;continue}if(!A){l[y]=A;continue}S=!0;let L="",D=A;D.indexOf(g)===0?(L=D.substr(0,D.indexOf(g)+g.length),D=D.substr(D.indexOf(g)+g.length)):D.indexOf(a)===0?(L=D.substr(0,D.indexOf(a)+a.length),D=D.substr(D.indexOf(a)+a.length)):D.indexOf(v)===0&&(L=D.substr(0,D.indexOf(v)+v.length),D=D.substr(D.indexOf(v)+v.length));const O=D.split(a);for(let M=1;S&&M<=O.length;M++)for(let Z=O.length-M;S&&Z>=0;Z--){S=!1;let q=O.slice(Z,Z+M).join(a);for(let K=0;!S&&K<s.length;K++)if(K!==y&&s[K]&&s[K].indexOf(q)>-1){const de=Z+M===O.length,H=Z>0&&s[K].indexOf(a)>-1?a+q:q,Y=s[K].endsWith(H);S=!de||Y}if(!S){let K="";(O[0].endsWith(":")||L!=="")&&(Z===1&&(Z=0,M++,q=O[0]+a+q),Z>0&&(K=O[0]+a),K=L+K),Z>0&&(K=K+f+a),K=K+q,Z+M<O.length&&(K=K+a+f),l[y]=K}}S&&(l[y]=A)}return l}var $;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})($||($={}));function P(s,a=Object.create(null)){const l=[];let S=!1,y="";for(const A of s)if(A==="$"||S&&A==="{")y&&l.push({value:y,type:$.TEXT}),y="",S=!0;else if(A==="}"&&S){const L=a[y];if(typeof L=="string")L.length&&l.push({value:L,type:$.VARIABLE});else if(L){const D=l[l.length-1];(!D||D.type!==$.SEPARATOR)&&l.push({value:L.label,type:$.SEPARATOR})}y="",S=!1}else y+=A;return y&&!S&&l.push({value:y,type:$.TEXT}),l.filter((A,L)=>{if(A.type===$.SEPARATOR){const D=l[L-1],O=l[L+1];return[D,O].every(M=>M&&(M.type===$.VARIABLE||M.type===$.TEXT)&&M.value.length>0)}return!0}).map(A=>A.value).join("")}function E(s,a){return R.$k||a?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$k?"&":"&&"):s.replace(/&&|&/g,l=>l==="&"?"&&":"&")}function i(s,a){return R.$k||a?s.replace(/\(&&\w\)|&&/g,""):R.$j?s.replace(/&&|&/g,l=>l==="&"?"&&":"&"):s.replace(/&&/g,"_")}function h(s){return s.replace(/&/g,"&&")}function t(s){if(s.endsWith("]")){const a=s.lastIndexOf(" [",s.length-2);if(a!==-1){const l=o(s.substring(0,a)),S=s.substring(a);return{name:l.name+S,parentPath:l.parentPath}}}return o(s)}function o(s){const a=s.indexOf("/")!==-1?k.$gc:k.$fc,l=a.basename(s),S=a.dirname(s);return l.length?{name:l,parentPath:S}:{name:S,parentPath:""}}}),define(ce[151],le([0,1,17,90,7]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=void 0,e.$On=p,e.$Pn=m,e.$Qn=u;function R(d){return d.toJSON()}class T{constructor(w){this.a=w}transformIncoming(w){const f=this.a.transformIncoming(w);return f===w?w:R(k.URI.from(f))}transformOutgoing(w){const f=this.a.transformOutgoing(w);return f===w?w:R(k.URI.from(f))}transformOutgoingURI(w){const f=this.a.transformOutgoing(w);return f===w?w:k.URI.from(f)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$Mn=T,e.$Nn=new class{transformIncoming(d){return d}transformOutgoing(d){return d}transformOutgoingURI(d){return d}transformOutgoingScheme(d){return d}};function I(d,w,f){if(!d||f>200)return null;if(typeof d=="object"){if(d instanceof k.URI)return w.transformOutgoing(d);for(const g in d)if(Object.hasOwnProperty.call(d,g)){const v=I(d[g],w,f+1);v!==null&&(d[g]=v)}}return null}function p(d,w){const f=I(d,w,0);return f===null?d:f}function c(d,w,f,g){if(!d||g>200)return null;if(typeof d=="object"){if(d.$mid===r.MarshalledId.Uri)return f?k.URI.revive(w.transformIncoming(d)):w.transformIncoming(d);if(d instanceof n.$Ne)return null;for(const v in d)if(Object.hasOwnProperty.call(d,v)){const b=c(d[v],w,f,g+1);b!==null&&(d[v]=b)}}return null}function m(d,w){const f=c(d,w,!1,0);return f===null?d:f}function u(d,w){const f=c(d,w,!0,0);return f===null?d:f}}),define(ce[33],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=r;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(k){return n.test(k)}e.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(I){for(let p=0;p<I.length;p++)I[p]=Math.floor(Math.random()*256);return I};const R=new Uint8Array(16),T=[];for(let I=0;I<256;I++)T.push(I.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let p=0,c="";return c+=T[R[p++]],c+=T[R[p++]],c+=T[R[p++]],c+=T[R[p++]],c+="-",c+=T[R[p++]],c+=T[R[p++]],c+="-",c+=T[R[p++]],c+=T[R[p++]],c+="-",c+=T[R[p++]],c+=T[R[p++]],c+="-",c+=T[R[p++]],c+=T[R[p++]],c+=T[R[p++]],c+=T[R[p++]],c+=T[R[p++]],c+=T[R[p++]],c}}()}),define(ce[152],le([0,1,91,26,89]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PX=R,n=Pe(n),r=Pe(r);async function R(T,I){if(await new Promise((m,u)=>{const d=r.createReadStream(T),w=n.createHash("sha256");d.pipe(w);const f=(0,k.$cb)((g,v)=>{d.removeAllListeners(),w.removeAllListeners(),g?u(g):m(v)});d.once("error",f),d.once("end",f),w.once("error",f),w.once("data",g=>f(void 0,g.toString("hex")))})!==I)throw new Error("Hash mismatch")}}),define(ce[153],le([0,1,27]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=R;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(T){const I=T.replace(/\-/g,":").toLowerCase();return!r.has(I)}function R(){const T=(0,n.networkInterfaces)();for(const I in T){const p=T[I];if(p){for(const{mac:c}of p)if(k(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ce[92],le([0,1,27,60,33,153,3]),function(x,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=void 0,e.$Tn=p,e.$Un=u,e.$Vn=d,k=Pe(k),e.$Sn=new class{c(w){return this.a||(this.a=r.$Li.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,f=0;const g=(0,n.networkInterfaces)();for(const v in g){const b=g[v];if(b)for(const{mac:$,internal:P}of b)P||(f+=1,this.c($.toUpperCase())&&(w+=1))}this.b=f>0?w/f:0}return this.b}};let I;async function p(w){return I||(I=(async()=>await c(w)||k.$2g())()),I}async function c(w){try{const f=await new Promise((v,b)=>{x(["crypto"],v,b)}).then(Pe),g=(0,R.$Rn)();return f.createHash("sha256").update(g,"utf8").digest("hex")}catch(f){w(f);return}}const m="Software\\Microsoft\\SQMClient";async function u(w){if(T.$j){const f=await new Promise((g,v)=>{x(["@vscode/windows-registry"],g,v)}).then(Pe);try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",m,"MachineId")||""}catch(g){return w(g),""}}return""}async function d(w){try{return await(await new Promise((v,b)=>{x(["@vscode/deviceid"],v,b)}).then(Pe)).getDeviceId()}catch(f){return w(f),""}}}),define(ce[23],le([0,1,26,27,154,8,32,78,9,3,18,7]),function(x,e,n,r,k,R,T,I,p,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=v,e.readdirSync=P,e.whenDeleted=h,e.configureFlushOnWrite=l,e.writeFileSync=y,n=Pe(n);var d;(function(H){H[H.UNLINK=0]="UNLINK",H[H.MOVE=1]="MOVE"})(d||(e.RimRafMode=d={}));async function w(H,Y=d.UNLINK,B){if((0,T.$Ig)(H))throw new Error("rimraf - will refuse to recursively delete root");return Y===d.UNLINK?g(H):f(H,B)}async function f(H,Y=(0,T.$Ng)((0,r.tmpdir)())){try{try{await n.promises.rename(H,Y)}catch(B){return B.code==="ENOENT"?void 0:g(H)}g(Y).catch(B=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function g(H){return n.promises.rm(H,{recursive:!0,force:!0,maxRetries:3})}function v(H){if((0,T.$Ig)(H))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(H,{recursive:!0,force:!0,maxRetries:3})}async function b(H,Y){return E(await(Y?$(H):n.promises.readdir(H)))}async function $(H){try{return await n.promises.readdir(H,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const Y=[],B=await b(H);for(const Q of B){let W=!1,j=!1,C=!1;try{const X=await n.promises.lstat((0,p.$jc)(H,Q));W=X.isFile(),j=X.isDirectory(),C=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}Y.push({name:Q,isFile:()=>W,isDirectory:()=>j,isSymbolicLink:()=>C})}return Y}function P(H){return E(n.readdirSync(H))}function E(H){return H.map(Y=>typeof Y=="string"?c.$k?(0,I.$nm)(Y):Y:(Y.name=c.$k?(0,I.$nm)(Y.name):Y.name,Y))}async function i(H){const Y=await b(H),B=[];for(const Q of Y)await t.existsDirectory((0,p.$jc)(H,Q))&&B.push(Q);return B}function h(H,Y=1e3){return new Promise(B=>{let Q=!1;const W=setInterval(()=>{Q||(Q=!0,n.access(H,j=>{Q=!1,j&&(clearInterval(W),B(void 0))}))},Y)})}var t;(function(H){async function Y(W){let j;try{if(j=await n.promises.lstat(W),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await n.promises.stat(W),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(C){if(C.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(c.$j&&C.code==="EACCES")try{return{stat:await n.promises.stat(await n.promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw X}throw C}}H.stat=Y;async function B(W){try{const{stat:j,symbolicLink:C}=await H.stat(W);return j.isFile()&&C?.dangling!==!0}catch{}return!1}H.existsFile=B;async function Q(W){try{const{stat:j,symbolicLink:C}=await H.stat(W);return j.isDirectory()&&C?.dangling!==!0}catch{}return!1}H.existsDirectory=Q})(t||(e.SymlinkSupport=t={}));const o=new R.$Oh;function s(H,Y,B){return o.queueFor(u.URI.file(H),()=>{const Q=A(B);return new Promise((W,j)=>S(H,Y,Q,C=>C?j(C):W()))},m.$0g)}let a=!0;function l(H){a=H}function S(H,Y,B,Q){if(!a)return n.writeFile(H,Y,{mode:B.mode,flag:B.flag},Q);n.open(H,B.flag,B.mode,(W,j)=>{if(W)return Q(W);n.writeFile(j,Y,C=>{if(C)return n.close(j,()=>Q(C));n.fdatasync(j,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),l(!1)),n.close(j,oe=>Q(oe))))})})}function y(H,Y,B){const Q=A(B);if(!a)return n.writeFileSync(H,Y,{mode:Q.mode,flag:Q.flag});const W=n.openSync(H,Q.flag,Q.mode);try{n.writeFileSync(W,Y);try{n.fdatasyncSync(W)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),l(!1)}}finally{n.closeSync(W)}}function A(H){return H?{mode:typeof H.mode=="number"?H.mode:438,flag:typeof H.flag=="string"?H.flag:"w"}:{mode:438,flag:"w"}}async function L(H,Y,B=6e4){if(H!==Y)try{c.$j&&typeof B=="number"?await D(H,Y,Date.now(),B):await n.promises.rename(H,Y)}catch(Q){if(H.toLowerCase()!==Y.toLowerCase()&&Q.code==="EXDEV"||H.endsWith("."))await O(H,Y,{preserveSymlinks:!1}),await w(H,d.MOVE);else throw Q}}async function D(H,Y,B,Q,W=0){try{return await n.promises.rename(H,Y)}catch(j){if(j.code!=="EACCES"&&j.code!=="EPERM"&&j.code!=="EBUSY")throw j;if(Date.now()-B>=Q)throw console.error(`[node.js fs] rename failed after ${W} retries with error: ${j}`),j;if(W===0){let C=!1;try{const{stat:X}=await t.stat(Y);X.isFile()||(C=!0)}catch{}if(C)throw j}return await(0,R.$Gh)(Math.min(100,W*10)),D(H,Y,B,Q,W+1)}}async function O(H,Y,B){return Z(H,Y,{root:{source:H,target:Y},options:B,handledSourcePaths:new Set})}const M=511;async function Z(H,Y,B){if(B.handledSourcePaths.has(H))return;B.handledSourcePaths.add(H);const{stat:Q,symbolicLink:W}=await t.stat(H);if(W){if(B.options.preserveSymlinks)try{return await de(H,Y,B)}catch{}if(W.dangling)return}return Q.isDirectory()?q(H,Y,Q.mode&M,B):K(H,Y,Q.mode&M)}async function q(H,Y,B,Q){await n.promises.mkdir(Y,{recursive:!0,mode:B});const W=await b(H);for(const j of W)await Z((0,p.$jc)(H,j),(0,p.$jc)(Y,j),Q)}async function K(H,Y,B){await n.promises.copyFile(H,Y),await n.promises.chmod(Y,B)}async function de(H,Y,B){let Q=await n.promises.readlink(H);(0,T.$Eg)(Q,B.root.source,!c.$l)&&(Q=(0,p.$jc)(B.root.target,Q.substr(B.root.source.length+1))),await n.promises.symlink(Q,Y)}e.Promises=new class{get read(){return(H,Y,B,Q,W)=>new Promise((j,C)=>{n.read(H,Y,B,Q,W,(X,oe,V)=>X?C(X):j({bytesRead:oe,buffer:V}))})}get write(){return(H,Y,B,Q,W)=>new Promise((j,C)=>{n.write(H,Y,B,Q,W,(X,oe,V)=>X?C(X):j({bytesWritten:oe,buffer:V}))})}get fdatasync(){return(0,k.promisify)(n.fdatasync)}get open(){return(0,k.promisify)(n.open)}get close(){return(0,k.promisify)(n.close)}get realpath(){return(0,k.promisify)(n.realpath)}async exists(H){try{return await n.promises.access(H),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return i}get writeFile(){return s}get rm(){return w}get rename(){return L}get copy(){return O}}}),define(ce[112],le([0,1,26,9,3,25,23]),function(x,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=I,e.$mr=p,e.$nr=c,e.$or=m,n=Pe(n);function I(d){if(k.$l)return d;const w=(0,r.$mc)(d);if(d===w)return d;const f=((0,r.$nc)(d)||d).toLowerCase();try{const v=(0,T.readdirSync)(w).filter(b=>b.toLowerCase()===f);if(v.length===1){const b=I(w);if(b)return(0,r.$jc)(b,v[0])}else if(v.length>1){const b=v.indexOf(f);if(b>=0){const $=I(w);if($)return(0,r.$jc)($,v[b])}}}catch{}return null}async function p(d,w){if(k.$l)return d;const f=(0,r.$mc)(d);if(d===f)return d;const g=((0,r.$nc)(d)||d).toLowerCase();try{if(w?.isCancellationRequested)return null;const b=(await T.Promises.readdir(f)).filter($=>$.toLowerCase()===g);if(b.length===1){const $=await p(f,w);if($)return(0,r.$jc)($,b[0])}else if(b.length>1){const $=b.indexOf(g);if($>=0){const P=await p(f,w);if(P)return(0,r.$jc)(P,b[$])}}}catch{}return null}async function c(d){try{return await T.Promises.realpath(d)}catch{const f=u(d);return await n.promises.access(f,n.constants.R_OK),f}}function m(d){try{return n.realpathSync(d)}catch{const f=u(d);return n.accessSync(f,n.constants.R_OK),f}}function u(d){return(0,R.$nf)((0,r.$hc)(d),r.sep)}}),define(ce[113],le([0,1,93]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=r,e.$6g=R,n=Pe(n);function r(I,p,c,m=1){let u=!1;return new Promise(d=>{const w=setTimeout(()=>{if(!u)return u=!0,d(0)},c);k(I,p,m,f=>{if(!u)return u=!0,clearTimeout(w),d(f)})})}function k(I,p,c,m){if(p===0)return m(0);const u=new n.Socket;u.once("connect",()=>(T(u),k(I+c,p-1,c,m))),u.once("data",()=>{}),u.once("error",d=>(T(u),d.code!=="ECONNREFUSED"?k(I+c,p-1,c,m):m(I))),u.connect(I,"127.0.0.1")}e.$5g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(I,p,c,m="127.0.0.1"){let u=!1,d,w=1;const f=n.createServer({pauseOnConnect:!0});function g(v,b){u||(u=!0,f.removeAllListeners(),f.close(),d&&clearTimeout(d),b(v))}return new Promise(v=>{d=setTimeout(()=>{g(0,v)},c),f.on("listening",()=>{g(I,v)}),f.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&w<p?(I++,w++,f.listen(I,m)):g(0,v)}),f.on("close",()=>{g(0,v)}),f.listen(I,m)})}function T(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(p){console.error(p)}}}),define(ce[114],le([0,1,27,9,23]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=$,e.$xm=P,n=Pe(n),r=Pe(r),k=Pe(k);const R=/^\d+$/,T=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var p;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(p||(p={}));let c;switch(process.arch){case"ia32":c=p.x86;break;case"arm":case"arm64":c=p.ARM;break;default:c=p.x64;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?p.ARM:p.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=p.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=p.x86:m=p.x64;class u{constructor(i,h,t){this.exePath=i,this.displayName=h,this.a=t}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:E=!1}={}){return E?c===p.x64?process.env["ProgramFiles(x86)"]||null:m===p.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:E=!1,findPreview:i=!1}={}){const h=d({useAlternateBitness:E});if(!h)return null;const t=r.$jc(h,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(t))return null;let o=-1,s=null;for(const S of await k.Promises.readdir(t)){let y=-1;if(i){const L=S.indexOf("-");if(L<0)continue;const D=S.substring(0,L);if(!R.test(D)||S.substring(L+1)!=="preview")continue;y=parseInt(D,10)}else{if(!R.test(S))continue;y=parseInt(S,10)}if(y<=o)continue;const A=r.$jc(t,S,"pwsh.exe");await k.SymlinkSupport.existsFile(A)&&(s=A,o=y)}if(!s)return null;const a=h.includes("x86")?" (x86)":"",l=i?" Preview":"";return new u(s,`PowerShell${l}${a}`,!0)}async function f({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const i=r.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:h,pwshMsixName:t}=E?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const o of await k.Promises.readdir(i))if(h.test(o)){const s=r.$jc(i,o,"pwsh.exe");return new u(s,t)}return null}function g(){const E=r.$jc(n.homedir(),".dotnet","tools","pwsh.exe");return new u(E,".NET Core PowerShell Global Tool")}function v(){const E=r.$jc(process.env.windir,c===p.x86&&m!==p.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new u(E,"Windows PowerShell",!0)}async function*b(){let E=await w();E&&(yield E),E=await w({useAlternateBitness:!0}),E&&(yield E),E=await f(),E&&(yield E),E=g(),E&&(yield E),E=await w({findPreview:!0}),E&&(yield E),E=await f({findPreview:!0}),E&&(yield E),E=await w({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=v(),E&&(yield E)}async function*$(){for await(const E of b())await E.exists()&&(yield E)}async function P(){for await(const E of $())return E;return null}}),define(ce[94],le([0,1,26,9,3,36,79,11,23]),function(x,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$ym=c,e.$zm=m,r=Pe(r),k=Pe(k),R=Pe(R),I=Pe(I),p=Pe(p),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function c(d=R.env){return d.comspec||"cmd.exe"}function m(d){let w=[],f=!1;const g=function(v){if(f){w.push(v);return}(!d.send(v,$=>{if($&&console.error($),f=!1,w.length>0){const P=w.slice(0);w=[],P.forEach(E=>g(E))}})||k.$j)&&(f=!0)};return{send:g}}var u;(function(d){async function w(f,g,v){if(r.$ic(f))return f;if(g===void 0&&(g=R.cwd()),r.$mc(f)!=="."||(v===void 0&&I.$eg(R.env.PATH)&&(v=R.env.PATH.split(r.$tc)),v===void 0||v.length===0))return r.$jc(g,f);async function $(P){if(await p.Promises.exists(P)){let E;try{E=await n.promises.stat(P)}catch(i){i.message.startsWith("EACCES")&&(E=await n.promises.lstat(P))}return E?!E.isDirectory():!1}return!1}for(const P of v){let E;if(r.$ic(P)?E=r.$jc(P,f):E=r.$jc(g,P,f),await $(E))return E;let i=E+".com";if(await $(i)||(i=E+".exe",await $(i)))return i}return r.$jc(g,f)}d.findExecutable=w})(u||(e.win32=u={}))}),define(ce[115],le([0,1,48,12]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=k;function k(T){return new Promise((I,p)=>{let c;const m=new Map;function u(w,f,g,v,b){const $=m.get(f);if(w===T||$){const P={name:d(g),cmd:g,pid:w,ppid:f,load:v,mem:b};m.set(w,P),w===T&&(c=P),$&&($.children||($.children=[]),$.children.push(P),$.children.length>1&&($.children=$.children.sort((E,i)=>E.pid-i.pid)))}}function d(w){const f=/--utility-sub-type=network/i,g=/--crashes-directory/i,v=/\\pipe\\winpty-control/i,b=/conhost\.exe.+--headless/i,$=/--type=([a-zA-Z-]+)/;if(g.exec(w))return"electron-crash-reporter";if(v.exec(w))return"winpty-agent";if(b.exec(w))return"conpty-agent";let P=$.exec(w);if(P&&P.length===2)return P[1]==="renderer"?"window":P[1]==="utility"?f.exec(w)?"utility-network-service":"utility-process":P[1]==="extensionHost"?"extension-host":P[1];const E=/[a-zA-Z-]+\.js/g;let i="";do P=E.exec(w),P&&(i+=P+" ");while(P);return i&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron-nodejs (${i})`:w}if(process.platform==="win32"){const w=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substring(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substring(5):f;new Promise((f,g)=>{x(["@vscode/windows-process-tree"],f,g)}).then(Pe).then(f=>{f.getProcessList(T,g=>{if(!g){p(new Error(`Root process ${T} not found`));return}f.getProcessCpuUsage(g,v=>{const b=new Map;v.forEach($=>{const P=w($.commandLine||"");b.set($.pid,{name:d(P),cmd:P,pid:$.pid,ppid:$.ppid,load:$.cpu||0,mem:$.memory||0})}),c=b.get(T),c?(b.forEach($=>{const P=b.get($.ppid);P&&(P.children||(P.children=[]),P.children.push($))}),b.forEach($=>{$.children&&($.children=$.children.sort((P,E)=>P.pid-E.pid))}),I(c)):p(new Error(`Root process ${T} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let w=function(){let f=[c];const g=[];for(;f.length;){const b=f.shift();b&&(g.push(b.pid),b.children&&(f=f.concat(b.children)))}let v=JSON.stringify(r.$Zg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);v+=" "+g.join(" "),(0,n.exec)(v,{},(b,$,P)=>{if(b||P)p(b||new Error(P.toString()));else{const E=$.toString().split(`
`);for(let i=0;i<g.length;i++){const h=m.get(g[i]);h.load=parseFloat(E[i])}if(!c){p(new Error(`Root process ${T} not found`));return}I(c)}})};(0,n.exec)("which ps",{},(f,g,v)=>{if(f||v)if(process.platform!=="linux")p(f||new Error(v.toString()));else{const b=JSON.stringify(r.$Zg.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(b,{},($,P,E)=>{$||E?p($||new Error(E.toString())):(R(P,u),w())})}else{const b=g.toString().trim();(0,n.exec)(`${b} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(P,E,i)=>{P||i&&!i.includes("screen size is bogus")?p(P||new Error(i.toString())):(R(E,u),process.platform==="linux"?w():c?I(c):p(new Error(`Root process ${T} not found`)))})}})}})}function R(T,I){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=T.toString().split(`
`);for(const m of c){const u=p.exec(m.trim());u&&u.length===6&&I(parseInt(u[1]),parseInt(u[2]),u[5],parseFloat(u[3]),parseFloat(u[4]))}}}),define(ce[116],le([0,1,27,3,114,94]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=T,r=Pe(r),R=Pe(R);async function T(u,d){return u===r.OperatingSystem.Windows?r.$j?m():R.$ym(d):p(u,d)}let I=null;function p(u,d){if(r.$l&&u===r.OperatingSystem.Macintosh||r.$k&&u===r.OperatingSystem.Linux)return"/bin/bash";if(!I){let w;if(r.$j)w="/bin/bash";else{if(w=d.SHELL,!w)try{w=(0,n.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}I=w}return I}let c=null;async function m(){return c||(c=(await(0,k.$xm)()).exePath),c}}),function(){function x(){function e(){return process.uncHostAllowlist}function n(p){const c=new Set;if(Array.isArray(p))for(const m of p)typeof m=="string"&&c.add(m);return Array.from(c)}function r(){const p=e();return p?Array.from(p):[]}function k(p){if(process.platform!=="win32")return;const c=e();if(c)if(typeof p=="string")c.add(p.toLowerCase());else for(const m of n(p))k(m)}function R(p){if(typeof p!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let m;for(const u of c){if(p.indexOf(u)!==0)continue;const w=p.indexOf("\\",u.length);if(w===-1)continue;const f=p.substring(u.length,w);if(f){m=f;break}}return m}function T(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:r,addUNCHostToAllowlist:k,getUNCHost:R,disableUNCAccessRestrictions:T,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return x()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=x():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ce[155],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VX=e.$UX=void 0,e.$UX="vscode:contextmenu",e.$VX="vscode:onCloseContextMenu"});var Se=this&&this.__decorate||function(x,e,n,r){var k=arguments.length,R=k<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,n):r,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(x,e,n,r);else for(var I=x.length-1;I>=0;I--)(T=x[I])&&(R=(k<3?T(R):k>3?T(e,n,R):T(e,n))||R);return k>3&&R&&Object.defineProperty(e,n,R),R};define(ce[44],le([0,1,21,8,17,22,54,15,4,2,82,25,11]),function(x,e,n,r,k,R,T,I,p,c,m,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.ProxyChannel=e.$ni=e.$ki=e.$ji=e.$ii=e.RequestInitiator=e.$hi=e.$ei=e.$di=void 0,e.$fi=l,e.$gi=S,e.$li=M,e.$mi=Z,u=Pe(u);var w;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(w||(w={}));function f(W){switch(W){case w.Promise:return"req";case w.PromiseCancel:return"cancel";case w.EventListen:return"subscribe";case w.EventDispose:return"unsubscribe"}}var g;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(g||(g={}));function v(W){switch(W){case g.Initialize:return"init";case g.PromiseSuccess:return"reply:";case g.PromiseError:case g.PromiseErrorObj:return"replyErr:";case g.EventFire:return"event:"}}var b;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(b||(b={}));function $(W){let j=0;for(let C=0;;C+=7){const X=W.read(1);if(j|=(X.buffer[0]&127)<<C,!(X.buffer[0]&128))return j}}const P=o(0);function E(W,j){if(j===0){W.write(P);return}let C=0;for(let oe=j;oe!==0;oe=oe>>>7)C++;const X=k.$Ne.alloc(C);for(let oe=0;j!==0;oe++)X.buffer[oe]=j&127,j=j>>>7,j>0&&(X.buffer[oe]|=128);W.write(X)}class i{constructor(j){this.b=j,this.a=0}read(j){const C=this.b.slice(this.a,this.a+j);return this.a+=C.byteLength,C}}e.$di=i;class h{constructor(){this.a=[]}get buffer(){return k.$Ne.concat(this.a)}write(j){this.a.push(j)}}e.$ei=h;var t;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(t||(t={}));function o(W){const j=k.$Ne.alloc(1);return j.writeUInt8(W,0),j}const s={Undefined:o(t.Undefined),String:o(t.String),Buffer:o(t.Buffer),VSBuffer:o(t.VSBuffer),Array:o(t.Array),Object:o(t.Object),Uint:o(t.Int)},a=typeof Buffer<"u";function l(W,j){if(typeof j>"u")W.write(s.Undefined);else if(typeof j=="string"){const C=k.$Ne.fromString(j);W.write(s.String),E(W,C.byteLength),W.write(C)}else if(a&&Buffer.isBuffer(j)){const C=k.$Ne.wrap(j);W.write(s.Buffer),E(W,C.byteLength),W.write(C)}else if(j instanceof k.$Ne)W.write(s.VSBuffer),E(W,j.byteLength),W.write(j);else if(Array.isArray(j)){W.write(s.Array),E(W,j.length);for(const C of j)l(W,C)}else if(typeof j=="number"&&(j|0)===j)W.write(s.Uint),E(W,j);else{const C=k.$Ne.fromString(JSON.stringify(j));W.write(s.Object),E(W,C.byteLength),W.write(C)}}function S(W){switch(W.read(1).readUInt8(0)){case t.Undefined:return;case t.String:return W.read($(W)).toString();case t.Buffer:return W.read($(W)).buffer;case t.VSBuffer:return W.read($(W));case t.Array:{const C=$(W),X=[];for(let oe=0;oe<C;oe++)X.push(S(W));return X}case t.Object:return JSON.parse(W.read($(W)).toString());case t.Int:return $(W)}}class y{constructor(j,C,X=null,oe=1e3){this.h=j,this.j=C,this.k=X,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(V=>this.q(V)),this.m({type:g.Initialize})}registerChannel(j,C){this.b.set(j,C),setTimeout(()=>this.w(j),0)}m(j){switch(j.type){case g.Initialize:{const C=this.o([j.type]);this.k?.logOutgoing(C,0,A.OtherSide,v(j.type));return}case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:{const C=this.o([j.type,j.id],j.data);this.k?.logOutgoing(C,j.id,A.OtherSide,v(j.type),j.data);return}}}o(j,C=void 0){const X=new h;return l(X,j),l(X,C),this.p(X.buffer)}p(j){try{return this.h.send(j),j.byteLength}catch{return 0}}q(j){const C=new i(j),X=S(C),oe=S(C),V=X[0];switch(V){case w.Promise:return this.k?.logIncoming(j.byteLength,X[1],A.OtherSide,`${f(V)}: ${X[2]}.${X[3]}`,oe),this.s({type:V,id:X[1],channelName:X[2],name:X[3],arg:oe});case w.EventListen:return this.k?.logIncoming(j.byteLength,X[1],A.OtherSide,`${f(V)}: ${X[2]}.${X[3]}`,oe),this.t({type:V,id:X[1],channelName:X[2],name:X[3],arg:oe});case w.PromiseCancel:return this.k?.logIncoming(j.byteLength,X[1],A.OtherSide,`${f(V)}`),this.u({type:V,id:X[1]});case w.EventDispose:return this.k?.logIncoming(j.byteLength,X[1],A.OtherSide,`${f(V)}`),this.u({type:V,id:X[1]})}}s(j){const C=this.b.get(j.channelName);if(!C){this.v(j);return}const X=new R.$we;let oe;try{oe=C.call(this.j,j.name,j.arg,X.token)}catch(re){oe=Promise.reject(re)}const V=j.id;oe.then(re=>{this.m({id:V,data:re,type:g.PromiseSuccess})},re=>{re instanceof Error?this.m({id:V,data:{message:re.message,name:re.name,stack:re.stack?re.stack.split(`
`):void 0},type:g.PromiseError}):this.m({id:V,data:re,type:g.PromiseErrorObj})}).finally(()=>{ue.dispose(),this.d.delete(j.id)});const ue=(0,c.$Sc)(()=>X.cancel());this.d.set(j.id,ue)}t(j){const C=this.b.get(j.channelName);if(!C){this.v(j);return}const X=j.id,V=C.listen(this.j,j.name,j.arg)(ue=>this.m({id:X,data:ue,type:g.EventFire}));this.d.set(j.id,V)}u(j){const C=this.d.get(j.id);C&&(C.dispose(),this.d.delete(j.id))}v(j){let C=this.g.get(j.channelName);C||(C=[],this.g.set(j.channelName,C));const X=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===w.Promise&&this.m({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.l}ms`,stack:void 0},type:g.PromiseError})},this.l);C.push({request:j,timeoutTimer:X})}w(j){const C=this.g.get(j);if(C){for(const X of C)switch(clearTimeout(X.timeoutTimer),X.request.type){case w.Promise:this.s(X.request);break;case w.EventListen:this.t(X.request);break}this.g.delete(j)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$hi=y;var A;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(A||(e.RequestInitiator=A={}));class L{constructor(j,C=null){this.l=j,this.a=!1,this.b=b.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$le,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=C}getChannel(j){const C=this;return{call(X,oe,V){return C.a?Promise.reject(new I.$4):C.m(j,X,oe,V)},listen(X,oe){return C.a?p.Event.None:C.o(j,X,oe)}}}m(j,C,X,oe=R.CancellationToken.None){const V=this.g++,ue=w.Promise,re={id:V,type:ue,channelName:j,name:C,arg:X};if(oe.isCancellationRequested)return Promise.reject(new I.$4);let J;return new Promise((N,_)=>{if(oe.isCancellationRequested)return _(new I.$4);const z=()=>{const te=he=>{switch(he.type){case g.PromiseSuccess:this.f.delete(V),N(he.data);break;case g.PromiseError:{this.f.delete(V);const me=new Error(he.data.message);me.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,me.name=he.data.name,_(me);break}case g.PromiseErrorObj:this.f.delete(V),_(he.data);break}};this.f.set(V,te),this.p(re)};let ie=null;this.b===b.Idle?z():(ie=(0,r.$sh)(te=>this.u()),ie.then(()=>{ie=null,z()}));const G=()=>{ie?(ie.cancel(),ie=null):this.p({id:V,type:w.PromiseCancel}),_(new I.$4)},U=oe.onCancellationRequested(G);J=(0,c.$Rc)((0,c.$Sc)(G),U),this.d.add(J)}).finally(()=>{J.dispose(),this.d.delete(J)})}o(j,C,X){const oe=this.g++,V=w.EventListen,ue={id:oe,type:V,channelName:j,name:C,arg:X};let re=null;const J=new p.$le({onWillAddFirstListener:()=>{re=(0,r.$sh)(N=>this.u()),re.then(()=>{re=null,this.d.add(J),this.p(ue)})},onDidRemoveLastListener:()=>{re?(re.cancel(),re=null):(this.d.delete(J),this.p({id:oe,type:w.EventDispose}))}}),F=N=>J.fire(N.data);return this.f.set(oe,F),J.event}p(j){switch(j.type){case w.Promise:case w.EventListen:{const C=this.q([j.type,j.id,j.channelName,j.name],j.arg);this.j?.logOutgoing(C,j.id,A.LocalSide,`${f(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case w.PromiseCancel:case w.EventDispose:{const C=this.q([j.type,j.id]);this.j?.logOutgoing(C,j.id,A.LocalSide,f(j.type));return}}}q(j,C=void 0){const X=new h;return l(X,j),l(X,C),this.r(X.buffer)}r(j){try{return this.l.send(j),j.byteLength}catch{return 0}}s(j){const C=new i(j),X=S(C),oe=S(C),V=X[0];switch(V){case g.Initialize:return this.j?.logIncoming(j.byteLength,0,A.LocalSide,v(V)),this.t({type:X[0]});case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:return this.j?.logIncoming(j.byteLength,X[1],A.LocalSide,v(V),oe),this.t({type:X[0],id:X[1],data:oe})}}t(j){if(j.type===g.Initialize){this.b=b.Idle,this.k.fire();return}this.f.get(j.id)?.(j)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$ii=L,Se([T.$0h],L.prototype,"onDidInitializePromise",null);class D{get connections(){const j=[];return this.f.forEach(C=>j.push(C)),j}constructor(j,C,X){this.a=new Map,this.f=new Set,this.g=new p.$le,this.onDidAddConnection=this.g.event,this.h=new p.$le,this.onDidRemoveConnection=this.h.event,this.j=new c.$Tc,this.j.add(j(({protocol:oe,onDidClientDisconnect:V})=>{const ue=p.Event.once(oe.onMessage);this.j.add(ue(re=>{const J=new i(re),F=S(J),N=new y(oe,F,C,X),_=new L(oe,C);this.a.forEach((ie,G)=>N.registerChannel(G,ie));const z={channelServer:N,channelClient:_,ctx:F};this.f.add(z),this.g.fire(z),this.j.add(V(()=>{N.dispose(),_.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(j,C){const X=this;return{call(oe,V,ue){let re;if((0,d.$sg)(C)){const F=(0,n.$2b)(X.connections.filter(C));re=F?Promise.resolve(F):p.Event.toPromise(p.Event.filter(X.onDidAddConnection,C))}else re=C.routeCall(X,oe,V);const J=re.then(F=>F.channelClient.getChannel(j));return M(J).call(oe,V,ue)},listen(oe,V){if((0,d.$sg)(C))return X.k(j,C,oe,V);const ue=C.routeEvent(X,oe,V).then(re=>re.channelClient.getChannel(j));return M(ue).listen(oe,V)}}}k(j,C,X,oe){const V=this;let ue;const re=new p.$le({onWillAddFirstListener:()=>{ue=new c.$Tc;const J=new p.$re,F=new Map,N=z=>{const G=z.channelClient.getChannel(j).listen(X,oe),U=J.add(G);F.set(z,U)},_=z=>{const ie=F.get(z);ie&&(ie.dispose(),F.delete(z))};V.connections.filter(C).forEach(N),p.Event.filter(V.onDidAddConnection,C)(N,void 0,ue),V.onDidRemoveConnection(_,void 0,ue),J.event(re.fire,re,ue),ue.add(J)},onDidRemoveLastListener:()=>{ue?.dispose(),ue=void 0}});return re.event}registerChannel(j,C){this.a.set(j,C);for(const X of this.f)X.channelServer.registerChannel(j,C)}dispose(){this.j.dispose();for(const j of this.f)j.channelClient.dispose(),j.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ji=D;class O{constructor(j,C,X=null){const oe=new h;l(oe,C),j.send(oe.buffer),this.a=new L(j,X),this.d=new y(j,C,X)}getChannel(j){return this.a.getChannel(j)}registerChannel(j,C){this.d.registerChannel(j,C)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ki=O;function M(W){return{call(j,C,X){return W.then(oe=>oe.call(j,C,X))},listen(j,C){const X=new p.$ue;return W.then(oe=>X.input=oe.listen(j,C)),X.event}}}function Z(W){let j=!1;return{call(C,X,oe){return j?W.call(C,X,oe):(0,r.$Gh)(0).then(()=>j=!0).then(()=>W.call(C,X,oe))},listen(C,X){if(j)return W.listen(C,X);const oe=new p.$ue;return(0,r.$Gh)(0).then(()=>j=!0).then(()=>oe.input=W.listen(C,X)),oe.event}}}class q{constructor(j){this.a=j}routeCall(j){return this.b(j)}routeEvent(j){return this.b(j)}async b(j){for(const C of j.connections)if(await Promise.resolve(this.a(C.ctx)))return Promise.resolve(C);return await p.Event.toPromise(j.onDidAddConnection),await this.b(j)}}e.$ni=q;var K;(function(W){function j(V,ue,re){const J=V,F=re&&re.disableMarshalling,N=new Map;for(const _ in J)X(_)&&N.set(_,p.Event.buffer(J[_],!0,void 0,ue));return new class{listen(_,z,ie){const G=N.get(z);if(G)return G;const U=J[z];if(typeof U=="function"){if(oe(z))return U.call(J,ie);if(X(z))return N.set(z,p.Event.buffer(J[z],!0,void 0,ue)),N.get(z)}throw new I.$ab(`Event not found: ${z}`)}call(_,z,ie){const G=J[z];if(typeof G=="function"){if(!F&&Array.isArray(ie))for(let te=0;te<ie.length;te++)ie[te]=(0,m.$ci)(ie[te]);let U=G.apply(J,ie);return U instanceof Promise||(U=Promise.resolve(U)),U}throw new I.$ab(`Method not found: ${z}`)}}}W.fromService=j;function C(V,ue){const re=ue&&ue.disableMarshalling;return new Proxy({},{get(J,F){if(typeof F=="string")return ue?.properties?.has(F)?ue.properties.get(F):oe(F)?function(N){return V.listen(F,N)}:X(F)?V.listen(F):async function(...N){let _;ue&&!(0,d.$ng)(ue.context)?_=[ue.context,...N]:_=N;const z=await V.call(F,_);return re?z:(0,m.$ci)(z)};throw new I.$ab(`Property not found: ${String(F)}`)}})}W.toService=C;function X(V){return V[0]==="o"&&V[1]==="n"&&u.$Ef(V.charCodeAt(2))}function oe(V){return/^onDynamic/.test(V)&&u.$Ef(V.charCodeAt(9))}})(K||(e.ProxyChannel=K={}));const de=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const j=W.toString();if(j!=="[object Object]")return j}return W}function Y(W){return Array.isArray(W)?W.map(H):H(W)}function B(W,j,C,X,oe,V,ue){ue=Y(ue);const re=de[oe],J=re[X%re.length];let F=[`%c[${W}]%c[${String(j).padStart(7," ")}]%c[len: ${String(C).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${J}`];/\($/.test(V)?(F=F.concat(ue),F.push(")")):F.push(ue),console.log.apply(console,F)}class Q{constructor(j,C){this.d=j,this.f=C,this.a=0,this.b=0}logOutgoing(j,C,X,oe,V){this.b+=j,B(this.d,this.b,j,C,X,oe,V)}logIncoming(j,C,X,oe,V){this.a+=j,B(this.f,this.a,j,C,X,oe,V)}}e.$oi=Q}),define(ce[156],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3X=void 0;class n{constructor(k,R){this.a=k,this.onMessage=R}send(k){try{this.a.send("vscode:message",k.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$3X=n}),define(ce[157],le([0,1,17,4,44]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1X=e.$ZX=void 0;class R{constructor(p){this.a=p,this.onMessage=r.Event.fromDOMEventEmitter(this.a,"message",c=>c.data?n.$Ne.wrap(c.data):n.$Ne.alloc(0)),p.start()}send(p){this.a.postMessage(p.buffer)}disconnect(){this.a.close()}}e.$ZX=R;class T extends k.$ki{constructor(p,c){const m=new R(p);super(m,c),this.b=m}dispose(){this.b.disconnect(),super.dispose()}}e.$1X=T}),define(ce[117],le([0,1,17,4,2,44]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.ProtocolConstants=e.$pi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var I;(function(s){s.enableDiagnostics=!1,s.records=[];const a=new WeakMap;let l=0;function S(A,L){if(!a.has(A)){const D=String(++l);a.set(A,D)}return a.get(A)}function y(A,L,D,O){if(!s.enableDiagnostics)return;const M=S(A,L);if(O instanceof n.$Ne||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const Z=n.$Ne.alloc(O.byteLength);Z.set(O),s.records.push({timestamp:Date.now(),id:M,label:L,type:D,buff:Z})}else s.records.push({timestamp:Date.now(),id:M,label:L,type:D,data:O})}s.traceSocketEvent=y})(I||(e.SocketDiagnostics=I={}));var p;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let c=null;function m(){return c||(c=n.$Ne.alloc(0)),c}class u{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,l){if(a===0)return m();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const L=this.a[0];return l&&(this.a.shift(),this.b-=a),L}if(this.a[0].byteLength>a){const L=this.a[0].slice(0,a);return l&&(this.a[0]=this.a[0].slice(a),this.b-=a),L}const S=n.$Ne.alloc(a);let y=0,A=0;for(;a>0;){const L=this.a[A];if(L.byteLength>a){const D=L.slice(0,a);S.set(D,y),y+=a,l&&(this.a[A]=L.slice(a),this.b-=a),a-=a}else S.set(L,y),y+=L.byteLength,l?(this.a.shift(),this.b-=L.byteLength):A++,a-=L.byteLength}return S}}e.$pi=u;var d;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(d||(d={}));function w(s){switch(s){case d.None:return"None";case d.Regular:return"Regular";case d.Control:return"Control";case d.Ack:return"Ack";case d.Disconnect:return"Disconnect";case d.ReplayRequest:return"ReplayRequest";case d.Pause:return"PauseWriting";case d.Resume:return"ResumeWriting";case d.KeepAlive:return"KeepAlive"}}var f;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(f||(e.ProtocolConstants=f={}));class g{constructor(a,l,S,y){this.type=a,this.id=l,this.ack=S,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends k.$Uc{constructor(a){super(),this.f=this.B(new r.$le),this.onMessage=this.f.event,this.g={readHead:!0,readLen:f.HeaderLength,messageType:d.None,id:0,ack:0},this.a=a,this.b=!1,this.c=new u,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:w(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const S=this.g.messageType,y=this.g.id,A=this.g.ack;if(this.g.readHead=!0,this.g.readLen=f.HeaderLength,this.g.messageType=d.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,l),this.f.fire(new g(S,y,A,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class b{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=n.$Ne.alloc(f.HeaderLength);l.writeUInt8(a.type,0),l.writeUInt32BE(a.id,1),l.writeUInt32BE(a.ack,5),l.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:w(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,a.data),this.j(l,a.data)}g(a,l){const S=this.f===0;return this.d.push(a,l),this.f+=a.byteLength+l.byteLength,S}h(){const a=n.$Ne.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,l){this.g(a,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:a.byteLength}),this.c.write(a)}}class $ extends k.$Uc{constructor(a){super(),this.f=new r.$le,this.onMessage=this.f.event,this.g=new r.$le,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new b(this.a)),this.c=this.B(new v(this.a)),this.B(this.c.onMessage(l=>{l.type===d.Regular&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new g(d.Regular,0,0,a))}}e.$qi=$;class P extends R.$ki{static fromSocket(a,l){return new P(new $(a),l)}get onDidDispose(){return this.b.onDidDispose}constructor(a,l,S=null){super(a,l,S),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$ri=P;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new r.$le({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$si=E;class i{constructor(a){this.data=a,this.next=null}}class h{constructor(){this.a=null,this.b=null}length(){let a=0,l=this.a;for(;l;)l=l.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let l=0,S=this.a;for(;S;)a[l++]=S.data,S=S.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const l=new i(a);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class t{static{this.a=10}static{this.b=null}static getInstance(){return t.b||(t.b=new t),t.b}constructor(){this.c=[];const a=Date.now();for(let l=0;l<t.a;l++)this.c[l]=a-1e3*l;setInterval(()=>{for(let l=t.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),l=(1+t.a)*1e3;let S=0;for(let y=0;y<t.a;y++)a-this.c[y]<=l&&S++;return 1-S/t.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.d-this.f}constructor(a){this.v=new E,this.onControlMessage=this.v.event,this.w=new E,this.onMessage=this.w.event,this.x=new E,this.onDidDispose=this.x.event,this.y=new E,this.onSocketClose=this.y.event,this.z=new E,this.onSocketTimeout=this.z.event,this.t=a.loadEstimator??t.getInstance(),this.u=a.sendKeepAlive??!0,this.a=!1,this.c=new h,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new k.$Tc,this.p=a.socket,this.q=this.s.add(new b(this.p)),this.r=this.s.add(new v(this.p)),this.s.add(this.r.onMessage(l=>this.A(l))),this.s.add(this.p.onClose(l=>this.y.fire(l))),a.initialChunk&&this.r.acceptChunk(a.initialChunk),this.u?this.m=setInterval(()=>{this.E()},f.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const a=new g(d.Disconnect,0,0,m());this.q.write(a),this.q.flush()}}sendPause(){const a=new g(d.Pause,0,0,m());this.q.write(a)}sendResume(){const a=new g(d.Resume,0,0,m());this.q.write(a)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(a,l){this.a=!0,this.s.dispose(),this.s=new k.$Tc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=a,this.q=this.s.add(new b(this.p)),this.r=this.s.add(new v(this.p)),this.s.add(this.r.onMessage(S=>this.A(S))),this.s.add(this.p.onClose(S=>this.y.fire(S))),this.r.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.j=this.h;const a=new g(d.Ack,0,this.j,m());this.q.write(a);const l=this.c.toArray();for(let S=0,y=l.length;S<y;S++)this.q.write(l[S]);this.C()}acceptDisconnect(){this.x.fire()}A(a){if(a.ack>this.f){this.f=a.ack;do{const l=this.c.peek();if(l&&l.id<=a.ack)this.c.pop();else break}while(!0)}switch(a.type){case d.None:break;case d.Regular:{if(a.id>this.h)if(a.id!==this.h+1){const l=Date.now();l-this.n>1e4&&(this.n=l,this.q.write(new g(d.ReplayRequest,0,0,m())))}else this.h=a.id,this.k=Date.now(),this.B(),this.w.fire(a.data);break}case d.Control:{this.v.fire(a.data);break}case d.Ack:break;case d.Disconnect:{this.x.fire();break}case d.ReplayRequest:{const l=this.c.toArray();for(let S=0,y=l.length;S<y;S++)this.q.write(l[S]);this.C();break}case d.Pause:{this.q.pause();break}case d.Resume:{this.q.resume();break}case d.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(a){const l=++this.d;this.j=this.h;const S=new g(d.Regular,l,this.j,a);this.c.push(S),this.a||(this.q.write(S),this.C())}sendControl(a){const l=new g(d.Control,0,0,a);this.q.write(l)}B(){if(this.h<=this.j||this.l)return;const a=Date.now()-this.k;if(a>=f.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},f.AcknowledgeTime-a+5)}C(){if(this.d<=this.f||this.g||this.a)return;const a=this.c.peek(),l=Date.now()-a.writtenTime,S=Date.now()-this.r.lastReadTime,y=Date.now()-this.o;if(l>=f.TimeoutTime&&S>=f.TimeoutTime&&y>=f.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:S});return}const A=Math.max(f.TimeoutTime-l,f.TimeoutTime-S,f.TimeoutTime-y,500);this.g=setTimeout(()=>{this.g=null,this.C()},A)}D(){if(this.h<=this.j)return;this.j=this.h;const a=new g(d.Ack,0,this.j,m());this.q.write(a)}E(){this.j=this.h;const a=new g(d.KeepAlive,0,this.j,m());this.q.write(a)}}e.$ti=o});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[35],le([0,1,13,15,12]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WX=void 0,n=Ve(n);class R{constructor(){this.a=new WeakMap}on(I,p){const c=(m,...u)=>{this.b(I,m)&&p(m,...u)};return this.a.set(p,c),n.default.ipcMain.on(I,c),this}once(I,p){return n.default.ipcMain.once(I,(c,...m)=>{this.b(I,c)&&p(c,...m)}),this}handle(I,p){return n.default.ipcMain.handle(I,(c,...m)=>this.b(I,c)?p(c,...m):Promise.reject(`Invalid channel '${I}' or sender for ipcMain.handle() usage.`)),this}removeHandler(I){return n.default.ipcMain.removeHandler(I),this}removeListener(I,p){const c=this.a.get(p);return c&&(n.default.ipcMain.removeListener(I,c),this.a.delete(p)),this}b(I,p){if(!I||!I.startsWith("vscode:"))return(0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because the channel is unknown.`),!1;const c=p.senderFrame,m=c.url;if(!m||m==="about:blank")return!0;let u="unknown";try{u=new URL(m).host}catch{return(0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because of a malformed URL '${m}'.`),!1}return u!==k.$Yg?((0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because of a bad origin of '${u}'.`),!1):c.parent!==null?((0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because sender of origin '${u}' is not a main frame.`),!1):!0}}e.$WX=new R}),define(ce[158],le([0,1,13,35,155]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XX=R;function R(){r.$WX.on(k.$UX,(I,p,c,m,u)=>{const d=T(I,m,c);d.popup({x:u?u.x:void 0,y:u?u.y:void 0,positioningItem:u?u.positioningItem:void 0,callback:()=>{d&&I.sender.send(k.$VX,p)}})})}function T(I,p,c){const m=new n.Menu;return c.forEach(u=>{let d;u.type==="separator"?d=new n.MenuItem({type:u.type}):Array.isArray(u.submenu)?d=new n.MenuItem({submenu:T(I,p,u.submenu),label:u.label}):d=new n.MenuItem({label:u.label,type:u.type,accelerator:u.accelerator,checked:u.checked,enabled:u.enabled,visible:u.visible,click:(w,f,g)=>I.sender.send(p,u.id,g)}),m.append(d)}),m}}),define(ce[159],le([0,1,35,17,4,2,44,156]),function(x,e,n,r,k,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4X=void 0;function p(m,u){const d=k.Event.fromNodeEventEmitter(n.$WX,u,(f,g)=>({event:f,message:g})),w=k.Event.filter(d,({event:f})=>f.sender.id===m);return k.Event.map(w,({message:f})=>f&&r.$Ne.wrap(f))}class c extends T.$ji{static{this.b=new Map}static d(){const u=k.Event.fromNodeEventEmitter(n.$WX,"vscode:hello",({sender:d})=>d);return k.Event.map(u,d=>{const w=d.id;c.b.get(w)?.dispose();const g=new k.$le;c.b.set(w,(0,R.$Sc)(()=>g.fire()));const v=p(w,"vscode:message"),b=k.Event.any(k.Event.signal(p(w,"vscode:disconnect")),g.event);return{protocol:new I.$3X(d,v),onDidClientDisconnect:b}})}constructor(){super(c.d())}}e.$4X=c}),define(ce[118],le([0,1,35,4,33,157]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5X=void 0,e.$6X=I;class T extends R.$1X{constructor(c,m){super({addEventListener:(u,d)=>c.addListener(u,d),removeEventListener:(u,d)=>c.removeListener(u,d),postMessage:u=>c.postMessage(u),start:()=>c.start(),close:()=>c.close()},m)}}e.$5X=T;async function I(p){if(p.isDestroyed()||p.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,k.$2g)();p.webContents.send("vscode:createMessageChannel",c);const m=r.Event.fromNodeEventEmitter(n.$WX,"vscode:createMessageChannelResult",(d,w)=>({nonce:w,port:d.ports[0]})),{port:u}=await r.Event.toPromise(r.Event.once(r.Event.filter(m,d=>d.nonce===c)));return u}}),define(ce[160],le([0,1,48,8,17,22,150,15,4,2,37,94,79,44]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=e.$hr=void 0,I=Pe(I);class f extends w.$hi{constructor(b){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",$=>k.$Ne.wrap(Buffer.from($,"base64")))},b),process.once("disconnect",()=>this.dispose())}}e.$hr=f;class g{constructor(b,$){this.i=b,this.j=$,this.c=new Set,this.g=new Map,this.h=new p.$le,this.onDidProcessExit=this.h.event;const P=$&&$.timeout?$.timeout:6e4;this.b=new r.$Ch(P),this.d=null,this.f=null}getChannel(b){const $=this;return{call(P,E,i){return $.k(b,P,E,i)},listen(P,E){return $.l(b,P,E)}}}k(b,$,P,E=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(I.$5());this.b.cancel();const i=this.n(b),h=(0,r.$sh)(s=>i.call($,P,s)),t=E.onCancellationRequested(()=>h.cancel()),o=(0,c.$Sc)(()=>h.cancel());return this.c.add(o),h.finally(()=>{t.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),h}l(b,$,P){if(!this.b)return p.Event.None;this.b.cancel();let E;const i=new p.$le({onWillAddFirstListener:()=>{E=this.n(b).listen($,P)(i.fire,i),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const b=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,m.$eo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,d.$mm)($.env),this.d=(0,n.fork)(this.i,b,$);const P=new p.$le,i=p.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,T.$dr)(l)){(0,T.log)(l,`IPC Library: ${this.j.serverName}`);return}P.fire(k.$Ne.wrap(Buffer.from(l,"base64")))}),h=this.j.useQueue?(0,u.$zm)(this.d):this.d,t=l=>this.d&&this.d.connected&&h.send(l.buffer.toString("base64")),o=P.event,s={send:t,onMessage:o};this.f=new w.$ii(s);const a=()=>this.o();process.once("exit",a),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,S)=>{process.removeListener("exit",a),i.dispose(),this.c.forEach(y=>(0,c.$Pc)(y)),this.c.clear(),l!==0&&S!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+S),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:S})})}return this.f}n(b){let $=this.g.get(b);return $||($=this.m.getChannel(b),this.g.set(b,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$ir=g}),define(ce[119],le([0,1,8,4,2,82,11]),function(x,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=e.StorageState=e.StorageHint=void 0,e.$dq=p;var I;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function p(d){const w=d;return w?.changed instanceof Map||w?.deleted instanceof Set}var c;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(c||(e.StorageState=c={}));class m extends k.$Uc{static{this.a=100}constructor(w,f=Object.create(null)){super(),this.r=w,this.s=f,this.b=this.B(new r.$oe),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new n.$Dh(m.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((f,g)=>this.w(g,f)),w.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(w,f){if(this.c===c.Closed)return;let g=!1;(0,T.$ng)(f)?g=this.f.delete(w):this.f.get(w)!==f&&(this.f.set(w,f),g=!0),g&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,f){const g=this.f.get(w);return(0,T.$ng)(g)?f:g}getBoolean(w,f){const g=this.get(w);return(0,T.$ng)(g)?f:g==="true"}getNumber(w,f){const g=this.get(w);return(0,T.$ng)(g)?f:parseInt(g,10)}getObject(w,f){const g=this.get(w);return(0,T.$ng)(g)?f:(0,R.$bi)(g)}async set(w,f,g=!1){if(this.c===c.Closed)return;if((0,T.$ng)(f))return this.delete(w,g);const v=(0,T.$gg)(f)||Array.isArray(f)?(0,R.$ai)(f):String(f);if(this.f.get(w)!==v)return this.f.set(w,v),this.j.set(w,v),this.h.delete(w),this.b.fire({key:w,external:g}),this.D()}async delete(w,f=!1){if(!(this.c===c.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:f}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===c.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$eq=m;class u{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((f,g)=>this.a.set(g,f)),w.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$fq=u}),define(ce[161],le([0,1,26,8,4,31,9,23]),function(x,e,n,r,k,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pY=void 0,n=Pe(n);class p{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return k.Event.None}static{this.a=2e3}static{this.b=256}constructor(u,d=Object.create(null)){this.g=u,this.h=d,this.c=(0,T.$nc)(this.g),this.d=new c(this.h.logging),this.f=this.n(this.g)}async getItems(){const u=await this.f,d=new Map;return(await this.s(u,"SELECT * FROM ItemTable")).forEach(f=>d.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${d.size} rows`),d}async updateItems(u){const d=await this.f;return this.j(d,u)}j(u,d){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${d.insert?(0,R.$yc)(d.insert):"0"}), delete(${d.delete?(0,R.$zc)(d.delete):"0"})`),this.t(u,()=>{const w=d.insert,f=d.delete;if(w&&w.size>0){const g=[];g.push([]);let v=0;w.forEach((b,$)=>{let P=g[v];P.length>p.b&&(v++,P=[],g.push(P)),P.push($,b)}),g.forEach(b=>{this.u(u,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,$=>$.run(b),()=>{const $=[];let P=0;return w.forEach((E,i)=>{$.push(i),P+=E.length}),`Keys: ${$.join(", ")} Length: ${P}`})})}if(f&&f.size){const g=[];g.push([]);let v=0;f.forEach(b=>{let $=g[v];$.length>p.b&&(v++,$=[],g.push($)),$.push(b)}),g.forEach(b=>{this.u(u,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,$=>$.run(b),()=>{const $=[];return f.forEach(P=>{$.push(P)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const u=await this.f;return this.q(u,"VACUUM")}async close(u){this.d.trace(`[storage ${this.c}] close()`);const d=await this.f;return this.k(d,u)}k(u,d){return new Promise((w,f)=>{u.db.close(g=>(g&&this.o(u,`[storage ${this.c}] close(): ${g}`),this.g===p.IN_MEMORY_PATH?w():!u.isErroneous&&!u.isInMemory?this.l().then(w,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),w())):typeof d=="function"?n.promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const b=()=>this.k(v,void 0);return this.j(v,{insert:d()}).then(()=>b(),$=>(b(),Promise.reject($)))})).then(w,f):f(g||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const u=this.m(this.g);return I.Promises.copy(this.g,u,{preserveSymlinks:!1})}m(u){return`${u}.backup`}async checkIntegrity(u){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${u})`);const d=await this.f,w=await this.r(d,u?"PRAGMA integrity_check":"PRAGMA quick_check"),f=u?w.integrity_check:w.quick_check;return d.isErroneous?`${f} (last error: ${d.lastError})`:d.isInMemory?`${f} (in-memory!)`:f}async n(u,d=!0){this.d.trace(`[storage ${this.c}] open(${u}, retryOnBusy: ${d})`);try{return await this.p(u)}catch(w){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${w}`),w.code==="SQLITE_BUSY"&&d)return await(0,r.$Gh)(p.a),this.n(u,!1);try{await n.promises.unlink(u);try{await I.Promises.rename(this.m(u),u,!1)}catch{}return await this.p(u)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(p.IN_MEMORY_PATH)}}}o(u,d){u.isErroneous=!0,u.lastError=d,this.d.error(d)}p(u){return new Promise((d,w)=>{new Promise((f,g)=>{x(["@vscode/sqlite3"],f,g)}).then(Pe).then(f=>{const g=this.d.isTracing?f.verbose().Database:f.Database,v={db:new g(u,b=>b?v.db&&b.code!=="SQLITE_CANTOPEN"?v.db.close(()=>w(b)):w(b):this.q(v,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>d(v),$=>v.db.close(()=>w($)))),isInMemory:u===p.IN_MEMORY_PATH};v.db.on("error",b=>this.o(v,`[storage ${this.c}] Error (event): ${b}`)),this.d.isTracing&&v.db.on("trace",b=>this.d.trace(`[storage ${this.c}] Trace (event): ${b}`))},w)})}q(u,d){return new Promise((w,f)=>{u.db.exec(d,g=>g?(this.o(u,`[storage ${this.c}] exec(): ${g}`),f(g)):w())})}r(u,d){return new Promise((w,f)=>{u.db.get(d,(g,v)=>g?(this.o(u,`[storage ${this.c}] get(): ${g}`),f(g)):w(v))})}s(u,d){return new Promise((w,f)=>{u.db.all(d,(g,v)=>g?(this.o(u,`[storage ${this.c}] all(): ${g}`),f(g)):w(v))})}t(u,d){return new Promise((w,f)=>{u.db.serialize(()=>{u.db.run("BEGIN TRANSACTION"),d(),u.db.run("END TRANSACTION",g=>g?(this.o(u,`[storage ${this.c}] transaction(): ${g}`),f(g)):w())})})}u(u,d,w,f){const g=u.db.prepare(d),v=b=>{this.o(u,`[storage ${this.c}] prepare(): ${b} (${d}). Details: ${f()}`)};g.on("error",v),w(g),g.finalize(b=>{b&&v(b),g.removeListener("error",v)})}}e.$pY=p;class c{static{this.a="VSCODE_TRACE_STORAGE"}constructor(u){u&&typeof u.logTrace=="function"&&process.env[c.a]&&(this.b=u.logTrace),u&&typeof u.logError=="function"&&(this.c=u.logError)}get isTracing(){return!!this.b}trace(u){this.b?.(u)}error(u){this.c?.(u)}}}),define(ce[10],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=k,e.localize2=T;const n=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function r(I,p){let c;return p.length===0?c=I:c=I.replace(/\{(\d+)\}/g,(m,u)=>{const d=u[0],w=p[d];let f=m;return typeof w=="string"?f=w:(typeof w=="number"||typeof w=="boolean"||w===void 0||w===null)&&(f=String(w)),f}),n&&(c="\uFF3B"+c.replace(/[aouei]/g,"$&$&")+"\uFF3D"),c}function k(I,p,...c){return r(typeof I=="number"?R(I,p):p,c)}function R(I,p){const c=globalThis._VSCODE_NLS_MESSAGES?.[I];if(typeof c!="string"){if(typeof p=="string")return p;throw new Error(`!!! NLS MISSING: ${I} !!!`)}return c}function T(I,p,...c){let m;typeof I=="number"?m=R(I,p):m=p;const u=r(m,c);return{value:u,original:p===m?u:r(p,c)}}}),define(ce[162],le([0,1,10]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=c,e.$3m=m,e.$4m=u;const r=60,k=r*60,R=k*24,T=R*7,I=R*30,p=R*365;function c(d,w,f,g){typeof d!="number"&&(d=d.getTime());const v=Math.round((new Date().getTime()-d)/1e3);if(v<-30)return(0,n.localize)(12987,null,c(new Date().getTime()+v*1e3,!1));if(!g&&v<30)return(0,n.localize)(12988,null);let b;return v<r?(b=v,w?b===1?f?(0,n.localize)(12989,null,b):(0,n.localize)(12990,null,b):f?(0,n.localize)(12991,null,b):(0,n.localize)(12992,null,b):b===1?f?(0,n.localize)(12993,null,b):(0,n.localize)(12994,null,b):f?(0,n.localize)(12995,null,b):(0,n.localize)(12996,null,b)):v<k?(b=Math.floor(v/r),w?b===1?f?(0,n.localize)(12997,null,b):(0,n.localize)(12998,null,b):f?(0,n.localize)(12999,null,b):(0,n.localize)(13e3,null,b):b===1?f?(0,n.localize)(13001,null,b):(0,n.localize)(13002,null,b):f?(0,n.localize)(13003,null,b):(0,n.localize)(13004,null,b)):v<R?(b=Math.floor(v/k),w?b===1?f?(0,n.localize)(13005,null,b):(0,n.localize)(13006,null,b):f?(0,n.localize)(13007,null,b):(0,n.localize)(13008,null,b):b===1?f?(0,n.localize)(13009,null,b):(0,n.localize)(13010,null,b):f?(0,n.localize)(13011,null,b):(0,n.localize)(13012,null,b)):v<T?(b=Math.floor(v/R),w?b===1?(0,n.localize)(13013,null,b):(0,n.localize)(13014,null,b):b===1?(0,n.localize)(13015,null,b):(0,n.localize)(13016,null,b)):v<I?(b=Math.floor(v/T),w?b===1?f?(0,n.localize)(13017,null,b):(0,n.localize)(13018,null,b):f?(0,n.localize)(13019,null,b):(0,n.localize)(13020,null,b):b===1?f?(0,n.localize)(13021,null,b):(0,n.localize)(13022,null,b):f?(0,n.localize)(13023,null,b):(0,n.localize)(13024,null,b)):v<p?(b=Math.floor(v/I),w?b===1?f?(0,n.localize)(13025,null,b):(0,n.localize)(13026,null,b):f?(0,n.localize)(13027,null,b):(0,n.localize)(13028,null,b):b===1?f?(0,n.localize)(13029,null,b):(0,n.localize)(13030,null,b):f?(0,n.localize)(13031,null,b):(0,n.localize)(13032,null,b)):(b=Math.floor(v/p),w?b===1?f?(0,n.localize)(13033,null,b):(0,n.localize)(13034,null,b):f?(0,n.localize)(13035,null,b):(0,n.localize)(13036,null,b):b===1?f?(0,n.localize)(13037,null,b):(0,n.localize)(13038,null,b):f?(0,n.localize)(13039,null,b):(0,n.localize)(13040,null,b))}function m(d,w){const f=Math.abs(d/1e3);return f<1?w?(0,n.localize)(13041,null,d):(0,n.localize)(13042,null,d):f<r?w?(0,n.localize)(13043,null,Math.round(d)/1e3):(0,n.localize)(13044,null,Math.round(d)/1e3):f<k?w?(0,n.localize)(13045,null,Math.round(d/(1e3*r))):(0,n.localize)(13046,null,Math.round(d/(1e3*r))):f<R?w?(0,n.localize)(13047,null,Math.round(d/(1e3*k))):(0,n.localize)(13048,null,Math.round(d/(1e3*k))):(0,n.localize)(13049,null,Math.round(d/(1e3*R)))}function u(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ce[55],le([0,1,21,11,10]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=p,e.$rj=c,e.$sj=m,n=Pe(n),r=Pe(r),k=Pe(k);function R(u,d){return d&&(u.stack||u.stacktrace)?k.localize(12981,null,I(u),T(u.stack)||T(u.stacktrace)):I(u)}function T(u){return Array.isArray(u)?u.join(`
`):u}function I(u){return u.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof u.code=="string"&&typeof u.errno=="number"&&typeof u.syscall=="string"?k.localize(12982,null,u.message):u.message||k.localize(12983,null)}function p(u=null,d=!1){if(!u)return k.localize(12984,null);if(Array.isArray(u)){const w=n.$Gb(u),f=p(w[0],d);return w.length>1?k.localize(12985,null,f,w.length):f}if(r.$eg(u))return u;if(u.detail){const w=u.detail;if(w.error)return R(w.error,d);if(w.exception)return R(w.exception,d)}return u.stack?R(u,d):u.message?u.message:k.localize(12986,null)}function c(u){const d=u;return d instanceof Error&&Array.isArray(d.actions)}function m(u,d){let w;return typeof u=="string"?w=new Error(u):w=u,w.actions=d,w}}),define(ce[163],le([0,1,10,43]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=k;function k(R){switch(R){case r.ParseErrorCode.InvalidSymbol:return(0,n.localize)(12972,null);case r.ParseErrorCode.InvalidNumberFormat:return(0,n.localize)(12973,null);case r.ParseErrorCode.PropertyNameExpected:return(0,n.localize)(12974,null);case r.ParseErrorCode.ValueExpected:return(0,n.localize)(12975,null);case r.ParseErrorCode.ColonExpected:return(0,n.localize)(12976,null);case r.ParseErrorCode.CommaExpected:return(0,n.localize)(12977,null);case r.ParseErrorCode.CloseBraceExpected:return(0,n.localize)(12978,null);case r.ParseErrorCode.CloseBracketExpected:return(0,n.localize)(12979,null);case r.ParseErrorCode.EndOfFileExpected:return(0,n.localize)(12980,null);default:return""}}}),define(ce[164],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cib=n,e.$dib=r;function n(k){return k&&k.hasOwnProperty("folderUri")}function r(k){return k&&k.hasOwnProperty("workspace")}}),define(ce[165],le([0,1,7]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=r,e.$Pfc=k,e.$Qfc=R;function r(T){return typeof T?.backupFolder=="string"}function k(T){let I=[];try{Array.isArray(T.workspaces)&&(I=T.workspaces.map(p=>({workspace:{id:p.id,configPath:n.URI.parse(p.configURIPath)},remoteAuthority:p.remoteAuthority})))}catch{}return I}function R(T){let I=[];try{Array.isArray(T.folders)&&(I=T.folders.map(p=>({folderUri:n.URI.parse(p.folderUri),remoteAuthority:p.remoteAuthority})))}catch{}return I}}),define(ce[166],le([0,1,39,15,10]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.TokenType=void 0;var R;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(R||(e.TokenType=R={}));function T(...m){switch(m.length){case 1:return(0,k.localize)(11585,null,m[0]);case 2:return(0,k.localize)(11586,null,m[0],m[1]);case 3:return(0,k.localize)(11587,null,m[0],m[1],m[2]);default:return}}const I=(0,k.localize)(11588,null),p=(0,k.localize)(11589,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(u){switch(u.type){case R.LParen:return"(";case R.RParen:return")";case R.Neg:return"!";case R.Eq:return u.isTripleEq?"===":"==";case R.NotEq:return u.isTripleEq?"!==":"!=";case R.Lt:return"<";case R.LtEq:return"<=";case R.Gt:return">=";case R.GtEq:return">=";case R.RegexOp:return"=~";case R.RegexStr:return u.lexeme;case R.True:return"true";case R.False:return"false";case R.In:return"in";case R.Not:return"not";case R.And:return"&&";case R.Or:return"||";case R.Str:return u.lexeme;case R.QuotedStr:return u.lexeme;case R.Error:return u.lexeme;case R.EOF:return"EOF";default:throw(0,r.$7)(`unhandled token type: ${JSON.stringify(u)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(u=>u.charCodeAt(0)))}static{this.b=new Map([["not",R.Not],["in",R.In],["false",R.False],["true",R.True]])}get errors(){return this.g}reset(u){return this.c=u,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case n.CharCode.OpenParen:this.k(R.LParen);break;case n.CharCode.CloseParen:this.k(R.RParen);break;case n.CharCode.ExclamationMark:if(this.h(n.CharCode.Equals)){const d=this.h(n.CharCode.Equals);this.f.push({type:R.NotEq,offset:this.d,isTripleEq:d})}else this.k(R.Neg);break;case n.CharCode.SingleQuote:this.o();break;case n.CharCode.Slash:this.q();break;case n.CharCode.Equals:if(this.h(n.CharCode.Equals)){const d=this.h(n.CharCode.Equals);this.f.push({type:R.Eq,offset:this.d,isTripleEq:d})}else this.h(n.CharCode.Tilde)?this.k(R.RegexOp):this.l(T("==","=~"));break;case n.CharCode.LessThan:this.k(this.h(n.CharCode.Equals)?R.LtEq:R.Lt);break;case n.CharCode.GreaterThan:this.k(this.h(n.CharCode.Equals)?R.GtEq:R.Gt);break;case n.CharCode.Ampersand:this.h(n.CharCode.Ampersand)?this.k(R.And):this.l(T("&&"));break;case n.CharCode.Pipe:this.h(n.CharCode.Pipe)?this.k(R.Or):this.l(T("||"));break;case n.CharCode.Space:case n.CharCode.CarriageReturn:case n.CharCode.Tab:case n.CharCode.LineFeed:case n.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(R.EOF),Array.from(this.f)}h(u){return this.r()||this.c.charCodeAt(this.e)!==u?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?n.CharCode.Null:this.c.charCodeAt(this.e)}k(u){this.f.push({type:u,offset:this.d})}l(u){const d=this.d,w=this.c.substring(this.d,this.e),f={type:R.Error,offset:this.d,lexeme:w};this.g.push({offset:d,lexeme:w,additionalInfo:u}),this.f.push(f)}n(){this.m.lastIndex=this.d;const u=this.m.exec(this.c);if(u){this.e=this.d+u[0].length;const d=this.c.substring(this.d,this.e),w=c.b.get(d);w?this.k(w):this.f.push({type:R.Str,lexeme:d,offset:this.d})}}o(){for(;this.j()!==n.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:R.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let u=this.e,d=!1,w=!1;for(;;){if(u>=this.c.length){this.e=u,this.l(p);return}const g=this.c.charCodeAt(u);if(d)d=!1;else if(g===n.CharCode.Slash&&!w){u++;break}else g===n.CharCode.OpenSquareBracket?w=!0:g===n.CharCode.Backslash?d=!0:g===n.CharCode.CloseSquareBracket&&(w=!1);u++}for(;u<this.c.length&&c.a.has(this.c.charCodeAt(u));)u++;this.e=u;const f=this.c.substring(this.d,this.e);this.f.push({type:R.RegexStr,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Aj=c}),define(ce[167],le([0,1,4,2]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=void 0;class k{constructor(){this.a=new n.$le,this.b=new n.$le,this.c=new n.$le,this.d=new n.$le}static{this.ChannelName="extensionhostdebugservice"}call(I,p,c){switch(p){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(I,p,c){switch(p){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Zo=k;class R extends r.$Uc{constructor(I){super(),this.b=I}reload(I){this.b.call("reload",[I])}get onReload(){return this.b.listen("reload")}close(I){this.b.call("close",[I])}get onClose(){return this.b.listen("close")}attachSession(I,p,c){this.b.call("attach",[I,p,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(I,p){this.b.call("terminate",[I,p])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(I,p){return this.b.call("openExtensionDevelopmentHostWindow",[I,p])}}e.$1o=R}),define(ce[168],le([0,1,162,54,12,9,36,18,7]),function(x,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=void 0,e.$7m=m,e.$8m=u,e.$5m=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,R.$mc)(k.$Zg.asFileUri("").fsPath)}get userHome(){return p.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return p.URI.file((0,R.$jc)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.b.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,I.$gh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$gh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,n.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.$jc)(this.userDataPath,"logs",w)}return p.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$gh)(p.URI.file((0,R.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$gh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$gh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$gh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=T.env.VSCODE_PORTABLE;return w?p.URI.file((0,R.$jc)(w,"argv.json")):(0,I.$gh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,R.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,R.$kc)(w):(0,R.$hc)((0,R.$jc)(k.$Zg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?p.URI.file((0,R.$kc)(w)):p.URI.file((0,R.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,R.$kc)(w);const f=T.env.VSCODE_EXTENSIONS;if(f)return f;const g=T.env.VSCODE_PORTABLE;return g?(0,R.$jc)(g,"extensions"):(0,I.$gh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(f=>/^[^:/?#]+?:\/\//.test(f)?p.URI.parse(f):p.URI.file((0,R.$hc)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?p.URI.parse(w):p.URI.file((0,R.$hc)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.$5m.test(w))}get extensionLogLevel(){const w=[];for(const f of this.args.log||[]){const g=e.$5m.exec(f);g&&g[1]&&g[2]&&w.push([g[1],g[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,I.$gh)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=T.env.VSCODE_PORTABLE;return w?p.URI.file((0,R.$jc)(w,"policy.json")):(0,I.$gh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,f,g){this.a=w,this.b=f,this.c=g,this.editSessionId=this.args.editSessionId}}e.$6m=c,Se([r.$0h],c.prototype,"appRoot",null),Se([r.$0h],c.prototype,"userHome",null),Se([r.$0h],c.prototype,"userDataPath",null),Se([r.$0h],c.prototype,"appSettingsHome",null),Se([r.$0h],c.prototype,"tmpDir",null),Se([r.$0h],c.prototype,"cacheHome",null),Se([r.$0h],c.prototype,"stateResource",null),Se([r.$0h],c.prototype,"userRoamingDataHome",null),Se([r.$0h],c.prototype,"userDataSyncHome",null),Se([r.$0h],c.prototype,"sync",null),Se([r.$0h],c.prototype,"machineSettingsResource",null),Se([r.$0h],c.prototype,"workspaceStorageHome",null),Se([r.$0h],c.prototype,"localHistoryHome",null),Se([r.$0h],c.prototype,"keyboardLayoutResource",null),Se([r.$0h],c.prototype,"argvResource",null),Se([r.$0h],c.prototype,"isExtensionDevelopment",null),Se([r.$0h],c.prototype,"untitledWorkspacesHome",null),Se([r.$0h],c.prototype,"builtinExtensionsPath",null),Se([r.$0h],c.prototype,"extensionsPath",null),Se([r.$0h],c.prototype,"extensionDevelopmentLocationURI",null),Se([r.$0h],c.prototype,"extensionDevelopmentKind",null),Se([r.$0h],c.prototype,"extensionTestsLocationURI",null),Se([r.$0h],c.prototype,"debugExtensionHost",null),Se([r.$0h],c.prototype,"logLevel",null),Se([r.$0h],c.prototype,"extensionLogLevel",null),Se([r.$0h],c.prototype,"serviceMachineIdResource",null),Se([r.$0h],c.prototype,"disableTelemetry",null),Se([r.$0h],c.prototype,"disableWorkspaceTrust",null),Se([r.$0h],c.prototype,"useInMemorySecretStorage",null),Se([r.$0h],c.prototype,"policyFile",null);function m(d,w){return u(d["inspect-extensions"],d["inspect-brk-extensions"],5870,w,d.debugId,d.extensionEnvironment)}function u(d,w,f,g,v,b){const P=Number(w||d)||(g?null:f),E=P?!!w:!1;let i;if(b)try{i=JSON.parse(b)}catch{}return{port:P,break:E,debugId:v,env:i}}});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[120],le([0,1,280,3,10]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=void 0,e.$Dm=I,e.$Em=c,e.$Fm=w,e.$Gm=f,n=Ve(n);const R={o:(0,k.localize)(11522,null),e:(0,k.localize)(11523,null),t:(0,k.localize)(11524,null)};e.$Bm=["tunnel","serve-web"],e.$Cm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(11525,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(11526,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(11527,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(11528,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(11529,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(11530,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(11531,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(11532,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(11533,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(11534,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11535,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,k.localize)(11536,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(11537,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(11538,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(11539,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(11540,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,k.localize)(11541,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(11542,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(11543,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(11544,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(11545,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(11546,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(11547,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,k.localize)(11548,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,k.localize)(11549,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(11550,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(11551,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(11552,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(11553,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(11554,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(11555,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(11556,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,k.localize)(11557,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(11558,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,k.localize)(11559,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(11560,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(g,v,b=T){const $=g.find(l=>l.length>0&&l[0]!=="-"),P={},E=["_"],i=[],h={};let t;for(const l in v){const S=v[l];S.type==="subcommand"?l===$&&(t=S):(S.alias&&(P[l]=S.alias),S.type==="string"||S.type==="string[]"?(E.push(l),S.deprecates&&E.push(...S.deprecates)):S.type==="boolean"&&(i.push(l),S.deprecates&&i.push(...S.deprecates)),S.global&&(h[l]=S))}if(t&&$){const l=h;for(const L in t.options)l[L]=t.options[L];const S=g.filter(L=>L!==$),y=b.getSubcommandReporter?b.getSubcommandReporter($):void 0,A=I(S,l,y);return{[$]:A,_:[]}}const o=(0,n.default)(g,{string:E,boolean:i,alias:P}),s={},a=o;s._=o._.map(l=>String(l)).filter(l=>l.length>0),delete a._;for(const l in v){const S=v[l];if(S.type==="subcommand")continue;S.alias&&delete a[S.alias];let y=a[l];if(S.deprecates)for(const A of S.deprecates)a.hasOwnProperty(A)&&(y||(y=a[A],y&&b.onDeprecatedOption(A,S.deprecationMessage||(0,k.localize)(11561,null,l))),delete a[A]);if(typeof y<"u"){if(S.type==="string[]"){if(Array.isArray(y)||(y=[y]),!S.allowEmptyValue){const A=y.filter(L=>L.length>0);A.length!==y.length&&(b.onEmptyValue(l),y=A.length>0?A:void 0)}}else S.type==="string"&&(Array.isArray(y)?(y=y.pop(),b.onMultipleValues(l,y)):!y&&!S.allowEmptyValue&&(b.onEmptyValue(l),y=void 0));s[l]=y,S.deprecationMessage&&b.onDeprecatedOption(l,S.deprecationMessage)}delete a[l]}for(const l in a)b.onUnknownOption(l);return s}function p(g,v){let b="";return v.args&&(Array.isArray(v.args)?b=` <${v.args.join("> <")}>`:b=` <${v.args}>`),v.alias?`-${v.alias} --${g}${b}`:`--${g}${b}`}function c(g,v){const b=[];for(const $ in g){const P=g[$],E=p($,P);b.push([E,P.description])}return m(b,v)}function m(g,v){const $=g.reduce((i,h)=>Math.max(i,h[0].length),12)+2+1;if(v-$<25)return g.reduce((i,h)=>i.concat([`  ${h[0]}`,`      ${h[1]}`]),[]);const P=v-$-1,E=[];for(const i of g){const h=i[0],t=d(i[1],P),o=u($-h.length-2);E.push("  "+h+o+t[0]);for(let s=1;s<t.length;s++)E.push(u($)+t[s])}return E}function u(g){return" ".repeat(g)}function d(g,v){const b=[];for(;g.length;){const $=g.length<v?g.length:g.lastIndexOf(" ",v),P=g.slice(0,$).trim();g=g.slice($),b.push(P)}return b}function w(g,v,b,$,P){const E=process.stdout.isTTY&&process.stdout.columns||80,i=P?.noInputFiles!==!0?`[${(0,k.localize)(11562,null)}...]`:"",h=[`${g} ${b}`];h.push(""),h.push(`${(0,k.localize)(11563,null)}: ${v} [${(0,k.localize)(11564,null)}]${i}`),h.push(""),P?.noPipe!==!0&&(r.$j?h.push((0,k.localize)(11565,null,v)):h.push((0,k.localize)(11566,null,v)),h.push(""));const t={},o=[];for(const s in $){const a=$[s];if(a.type==="subcommand")a.description&&o.push({command:s,description:a.description});else if(a.description&&a.cat){let l=t[a.cat];l||(t[a.cat]=l={}),l[s]=a}}for(const s in t){const a=s,l=t[a];l&&(h.push(R[a]),h.push(...c(l,E)),h.push(""))}return o.length&&(h.push((0,k.localize)(11567,null)),h.push(...m(o.map(s=>[s.command,s.description]),E)),h.push("")),h.join(`
`)}function f(g,v){return`${g||(0,k.localize)(11568,null)}
${v||(0,k.localize)(11569,null)}
${process.arch}`}});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[68],le([0,1,281,10,120]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=I,e.$Im=p,e.$Jm=c,e.$Km=m,n=Ve(n);function R(u,d){const w=(P,E)=>{console.warn((0,r.localize)(11516,null,P,E))},f=P=>{console.warn((0,r.localize)(11517,null,P))},g=(P,E)=>{console.warn((0,r.localize)(11518,null,P,E))},v=P=>({onUnknownOption:E=>{k.$Bm.includes(P)||console.warn((0,r.localize)(11519,null,E,P))},onMultipleValues:w,onEmptyValue:f,onDeprecatedOption:g,getSubcommandReporter:k.$Bm.includes(P)?v:void 0}),b={onUnknownOption:P=>{console.warn((0,r.localize)(11520,null,P))},onMultipleValues:w,onEmptyValue:f,onDeprecatedOption:g,getSubcommandReporter:v},$=(0,k.$Dm)(u,k.$Cm,d?b:void 0);return $.goto&&$._.forEach(P=>(0,n.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(P),(0,r.localize)(11521,null))),$}function T(u){const d=u.findIndex(w=>!/^-/.test(w));if(d>-1)return[...u.slice(0,d),...u.slice(d+1)]}function I(u){let[,...d]=u;process.env.VSCODE_DEV&&(d=T(d)||[]);const w=!m(process.env);return R(d,w)}function p(u){let[,,...d]=u;return process.env.VSCODE_DEV&&(d=T(d)||[]),R(d,!0)}function c(u,...d){const w=u.indexOf("--");return w===-1?u.push(...d):u.splice(w,0,...d),u}function m(u){return u.VSCODE_CLI==="1"}}),function(){function x(e,n,r){function k(T,I){const p=R(T,I),c=[p];return e.isAbsolute(p)||c.unshift(r),e.resolve(...c)}function R(T,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,I);const m=T["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const u=process.env.USERPROFILE;if(typeof u!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(u,"AppData","Roaming")}break;case"darwin":c=e.join(n.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,I)}return{getUserDataPath:k}}if(typeof define=="function")define(ce[169],le([121,27,36]),function(e,n,r){return x(e,n,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=x(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ce[95],le([0,1,27,168,169]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$0m=T,e.$$m=I;class R extends r.$6m{constructor(c,m){super(c,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,k.getUserDataPath)(c,m.nameShort)},m)}}e.$9m=R;function T(p,c){return(0,r.$8m)(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,c,p.extensionEnvironment)}function I(p,c){return(0,r.$8m)(p["inspect-sharedprocess"],p["inspect-brk-sharedprocess"],5879,c,p.extensionEnvironment)}}),define(ce[170],le([0,1,26,27,32]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=R;function R(T){const I=(0,k.$Ng)((0,r.tmpdir)());try{return(0,n.writeFileSync)(I,""),T&&console.log(`Marker file for --wait created: ${I}`),I}catch(p){T&&console.error(`Failed to create marker file for --wait: ${p}`);return}}}),define(ce[171],le([0,1,11,10]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=k;function k(T,I,p,c){try{R(T,I,p,c)}catch(m){T.error(m?.message??m)}return I}function R(T,I,p,c){const m=(u,d,w)=>{const f=u[d];if((0,n.$eg)(f)){const g=f,v=g.length;if(v>1&&g[0]==="%"&&g[v-1]==="%"){const b=g.substr(1,v-2);let $=p[b];$===void 0&&c&&($=c[b]);const P=typeof $=="string"?$:$?.message,E=c?.[b],i=typeof E=="string"?E:E?.message;if(!P){i||T.warn(`[${I.name}]: ${(0,r.localize)(11468,null,b)}`);return}if(w&&(d==="title"||d==="category")&&i&&i!==P){const h={value:P,original:i};u[d]=h}else u[d]=P}}else if((0,n.$gg)(f))for(const g in f)f.hasOwnProperty(g)&&(g==="commands"?m(f,g,!0):m(f,g,w));else if(Array.isArray(f))for(let g=0;g<f.length;g++)m(f,g,w)};for(const u in I)I.hasOwnProperty(u)&&m(I,u)}}),define(ce[172],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const n={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(n)}),define(ce[83],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class n{constructor(k,R=[],T=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=T}}e.$Ci=n}),define(ce[173],le([0,1,83]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Rs=R,e.$Ss=T;const r=[];var k;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function R(I,p,c){p instanceof n.$Ci||(p=new n.$Ci(p,[],!!c)),r.push([I,p])}function T(){return r}}),define(ce[174],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=void 0;class n{constructor(R,T){this.key=R,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$ur=n;class r{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const T of this.a.values())T.outgoing.size===0&&R.push(T);return R}insertEdge(R,T){const I=this.lookupOrInsertNode(R),p=this.lookupOrInsertNode(T);I.outgoing.set(p.key,p),p.incoming.set(I.key,I)}removeNode(R){const T=this.b(R);this.a.delete(T);for(const I of this.a.values())I.outgoing.delete(T),I.incoming.delete(T)}lookupOrInsertNode(R){const T=this.b(R);let I=this.a.get(T);return I||(I=new n(T,R),this.a.set(T,I)),I}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[T,I]of this.a)R.push(`${T}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,T]of this.a){const I=new Set([R]),p=this.c(T,I);if(p)return p}}c(R,T){for(const[I,p]of R.outgoing){if(T.has(I))return[...T,I].join(" -> ");T.add(I);const c=this.c(p,T);if(c)return c;T.delete(I)}}}e.$vr=r}),define(ce[6],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=k,e.$Gi=R;var n;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function I(p){return p[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=I})(n||(e._util=n={})),e.$Ei=k("instantiationService");function r(T,I,p){I[n.DI_TARGET]===I?I[n.DI_DEPENDENCIES].push({id:T,index:p}):(I[n.DI_DEPENDENCIES]=[{id:T,index:p}],I[n.DI_TARGET]=I)}function k(T){if(n.serviceIds.has(T))return n.serviceIds.get(T);const I=function(p,c,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(I,p,m)};return I.toString=()=>T,n.serviceIds.set(T,I),I}function R(T){return T}}),define(ce[84],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=void 0,e.$Jgc=(0,n.$Fi)("auxiliaryWindowsMainService")}),define(ce[69],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=void 0,e.$Rfc=(0,n.$Fi)("backupMainService")}),define(ce[16],le([0,1,11,7,6]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$_i=void 0,e.$aj=R,e.$bj=T,e.$cj=p,e.$dj=c,e.$ej=m,e.$fj=u,e.$gj=d,e.$hj=f,e.$ij=g,e.$jj=v,n=Pe(n),e.$_i=(0,k.$Fi)("configurationService");function R(b){return b&&typeof b=="object"&&(!b.overrideIdentifier||typeof b.overrideIdentifier=="string")&&(!b.resource||b.resource instanceof r.URI)}function T(b){return b&&typeof b=="object"&&(!b.overrideIdentifiers||Array.isArray(b.overrideIdentifiers))&&!b.overrideIdentifier&&(!b.resource||b.resource instanceof r.URI)}var I;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.USER=2]="USER",b[b.USER_LOCAL=3]="USER_LOCAL",b[b.USER_REMOTE=4]="USER_REMOTE",b[b.WORKSPACE=5]="WORKSPACE",b[b.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",b[b.DEFAULT=7]="DEFAULT",b[b.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function p(b){switch(b){case I.APPLICATION:return"APPLICATION";case I.USER:return"USER";case I.USER_LOCAL:return"USER_LOCAL";case I.USER_REMOTE:return"USER_REMOTE";case I.WORKSPACE:return"WORKSPACE";case I.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case I.DEFAULT:return"DEFAULT";case I.MEMORY:return"MEMORY"}}function c(b){return b.applicationValue!==void 0||b.userValue!==void 0||b.userLocalValue!==void 0||b.userRemoteValue!==void 0||b.workspaceValue!==void 0||b.workspaceFolderValue!==void 0}function m(b,$){const P=Object.create(null);for(const E in b)u(P,E,b[E],$);return P}function u(b,$,P,E){const i=$.split("."),h=i.pop();let t=b;for(let o=0;o<i.length;o++){const s=i[o];let a=t[s];switch(typeof a){case"undefined":a=t[s]=Object.create(null);break;case"object":if(a===null){E(`Ignoring ${$} as ${i.slice(0,o+1).join(".")} is null`);return}break;default:E(`Ignoring ${$} as ${i.slice(0,o+1).join(".")} is ${JSON.stringify(a)}`);return}t=a}if(typeof t=="object"&&t!==null)try{t[h]=P}catch{E(`Ignoring ${$} as ${i.join(".")} is ${JSON.stringify(t)}`)}else E(`Ignoring ${$} as ${i.join(".")} is ${JSON.stringify(t)}`)}function d(b,$){const P=$.split(".");w(b,P)}function w(b,$){const P=$.shift();if($.length===0){delete b[P];return}if(Object.keys(b).indexOf(P)!==-1){const E=b[P];typeof E=="object"&&!Array.isArray(E)&&(w(E,$),Object.keys(E).length===0&&delete b[P])}}function f(b,$,P){function E(t,o){let s=t;for(const a of o){if(typeof s!="object"||s===null)return;s=s[a]}return s}const i=$.split("."),h=E(b,i);return typeof h>"u"?P:h}function g(b,$,P){Object.keys($).forEach(E=>{E!=="__proto__"&&(E in b?n.$gg(b[E])&&n.$gg($[E])?g(b[E],$[E],P):P&&(b[E]=$[E]):b[E]=$[E])})}function v(b){return b.replace(/[\[\]]/g,"")}}),define(ce[122],le([0,1,39,3,25,166,6,10,15]),function(x,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Dj=e.$Cj=e.ContextKeyExprType=void 0,e.$Bj=m,e.$Ej=o,e.$Fj=s,e.$Yj=V;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",r.$k),c.set("isLinux",r.$l),c.set("isWindows",r.$j),c.set("isWeb",r.$p),c.set("isMacNative",r.$k&&!r.$p),c.set("isEdge",r.$I),c.set("isFirefox",r.$G),c.set("isChrome",r.$F),c.set("isSafari",r.$H);function m(J,F){if(c.get(J)!==void 0)throw(0,p.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(J,F)}const u=Object.prototype.hasOwnProperty;var d;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(d||(e.ContextKeyExprType=d={}));const w={regexParsingWithErrorRecovery:!0},f=(0,I.localize)(11599,null),g=(0,I.localize)(11600,null),v=(0,I.localize)(11601,null),b=(0,I.localize)(11602,null),$=(0,I.localize)(11603,null),P=(0,I.localize)(11604,null),E=(0,I.localize)(11605,null),i=(0,I.localize)(11606,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(F=w){this.k=F,this.d=new R.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(F){if(F===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(F).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const _=this.D(),z=_.type===R.TokenType.Str?P:void 0;throw this.h.push({message:$,offset:_.offset,lexeme:R.$Aj.getLexeme(_),additionalInfo:z}),h.c}return N}catch(N){if(N!==h.c)throw N;return}}l(){return this.m()}m(){const F=[this.o()];for(;this.y(R.TokenType.Or);){const N=this.o();F.push(N)}return F.length===1?F[0]:t.or(...F)}o(){const F=[this.s()];for(;this.y(R.TokenType.And);){const N=this.s();F.push(N)}return F.length===1?F[0]:t.and(...F)}s(){if(this.y(R.TokenType.Neg)){const F=this.D();switch(F.type){case R.TokenType.True:return this.z(),l.INSTANCE;case R.TokenType.False:return this.z(),S.INSTANCE;case R.TokenType.LParen:{this.z();const N=this.l();return this.A(R.TokenType.RParen,b),N?.negate()}case R.TokenType.Str:return this.z(),M.create(F.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",F)}}return this.t()}t(){const F=this.D();switch(F.type){case R.TokenType.True:return this.z(),t.true();case R.TokenType.False:return this.z(),t.false();case R.TokenType.LParen:{this.z();const N=this.l();return this.A(R.TokenType.RParen,b),N}case R.TokenType.Str:{const N=F.lexeme;if(this.z(),this.y(R.TokenType.RegexOp)){const z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),z.type!==R.TokenType.RegexStr)throw this.B("REGEX",z);const ie=z.lexeme,G=ie.lastIndexOf("/"),U=G===ie.length-1?void 0:this.w(ie.substring(G+1));let te;try{te=new RegExp(ie.substring(1,G),U)}catch{throw this.B("REGEX",z)}return Y.create(N,te)}switch(z.type){case R.TokenType.RegexStr:case R.TokenType.Error:{const ie=[z.lexeme];this.z();let G=this.D(),U=0;for(let Ie=0;Ie<z.lexeme.length;Ie++)z.lexeme.charCodeAt(Ie)===n.CharCode.OpenParen?U++:z.lexeme.charCodeAt(Ie)===n.CharCode.CloseParen&&U--;for(;!this.E()&&G.type!==R.TokenType.And&&G.type!==R.TokenType.Or;){switch(G.type){case R.TokenType.LParen:U++;break;case R.TokenType.RParen:U--;break;case R.TokenType.RegexStr:case R.TokenType.QuotedStr:for(let Ie=0;Ie<G.lexeme.length;Ie++)G.lexeme.charCodeAt(Ie)===n.CharCode.OpenParen?U++:z.lexeme.charCodeAt(Ie)===n.CharCode.CloseParen&&U--}if(U<0)break;ie.push(R.$Aj.getLexeme(G)),this.z(),G=this.D()}const te=ie.join(""),he=te.lastIndexOf("/"),me=he===te.length-1?void 0:this.w(te.substring(he+1));let we;try{we=new RegExp(te.substring(1,he),me)}catch{throw this.B("REGEX",z)}return t.regex(N,we)}case R.TokenType.QuotedStr:{const ie=z.lexeme;this.z();let G=null;if(!(0,k.$cf)(ie)){const U=ie.indexOf("/"),te=ie.lastIndexOf("/");if(U!==te&&U>=0){const he=ie.slice(U+1,te),me=ie[te+1]==="i"?"i":"";try{G=new RegExp(he,me)}catch{throw this.B("REGEX",z)}}}if(G===null)throw this.B("REGEX",z);return Y.create(N,G)}default:throw this.B("REGEX",this.D())}}if(this.y(R.TokenType.Not)){this.A(R.TokenType.In,v);const z=this.u();return t.notIn(N,z)}switch(this.D().type){case R.TokenType.Eq:{this.z();const z=this.u();if(this.x().type===R.TokenType.QuotedStr)return t.equals(N,z);switch(z){case"true":return t.has(N);case"false":return t.not(N);default:return t.equals(N,z)}}case R.TokenType.NotEq:{this.z();const z=this.u();if(this.x().type===R.TokenType.QuotedStr)return t.notEquals(N,z);switch(z){case"true":return t.not(N);case"false":return t.has(N);default:return t.notEquals(N,z)}}case R.TokenType.Lt:return this.z(),de.create(N,this.u());case R.TokenType.LtEq:return this.z(),H.create(N,this.u());case R.TokenType.Gt:return this.z(),q.create(N,this.u());case R.TokenType.GtEq:return this.z(),K.create(N,this.u());case R.TokenType.In:return this.z(),t.in(N,this.u());default:return t.has(N)}}case R.TokenType.EOF:throw this.h.push({message:E,offset:F.offset,lexeme:"",additionalInfo:i}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const F=this.D();switch(F.type){case R.TokenType.Str:case R.TokenType.QuotedStr:return this.z(),F.lexeme;case R.TokenType.True:return this.z(),"true";case R.TokenType.False:return this.z(),"false";case R.TokenType.In:return this.z(),"in";default:return""}}w(F){return F.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(F){return this.C(F)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(F,N){if(this.C(F))return this.z();throw this.B(N,this.D())}B(F,N,_){const z=(0,I.localize)(11607,null,F,R.$Aj.getLexeme(N)),ie=N.offset,G=R.$Aj.getLexeme(N);return this.h.push({message:z,offset:ie,lexeme:G,additionalInfo:_}),h.c}C(F){return this.D().type===F}D(){return this.f[this.g]}E(){return this.D().type===R.TokenType.EOF}}e.$Cj=h;class t{static false(){return l.INSTANCE}static true(){return S.INSTANCE}static has(F){return y.create(F)}static equals(F,N){return A.create(F,N)}static notEquals(F,N){return O.create(F,N)}static regex(F,N){return Y.create(F,N)}static in(F,N){return L.create(F,N)}static notIn(F,N){return D.create(F,N)}static not(F){return M.create(F)}static and(...F){return W.create(F,null,!0)}static or(...F){return j.create(F,null,!0)}static greater(F,N){return q.create(F,N)}static greaterEquals(F,N){return K.create(F,N)}static smaller(F,N){return de.create(F,N)}static smallerEquals(F,N){return H.create(F,N)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(F){return F==null?void 0:this.c.parse(F)}}e.$Dj=t;function o(J){const F=new h({regexParsingWithErrorRecovery:!1});return J.map(N=>(F.parse(N),F.lexingErrors.length>0?F.lexingErrors.map(_=>({errorMessage:_.additionalInfo?(0,I.localize)(11608,null,_.additionalInfo):(0,I.localize)(11609,null),offset:_.offset,length:_.lexeme.length})):F.parsingErrors.length>0?F.parsingErrors.map(_=>({errorMessage:_.additionalInfo?`${_.message}. ${_.additionalInfo}`:_.message,offset:_.offset,length:_.lexeme.length})):[]))}function s(J,F){const N=J?J.substituteConstants():void 0,_=F?F.substituteConstants():void 0;return!N&&!_?!0:!N||!_?!1:N.equals(_)}function a(J,F){return J.cmp(F)}class l{static{this.INSTANCE=new l}constructor(){this.type=d.False}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return S.INSTANCE}}e.$Gj=l;class S{static{this.INSTANCE=new S}constructor(){this.type=d.True}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return l.INSTANCE}}e.$Hj=S;class y{static create(F,N=null){const _=c.get(F);return typeof _=="boolean"?_?S.INSTANCE:l.INSTANCE:new y(F,N)}constructor(F,N){this.key=F,this.c=N,this.type=d.Defined}cmp(F){return F.type!==this.type?this.type-F.type:X(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=c.get(this.key);return typeof F=="boolean"?F?S.INSTANCE:l.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Ij=y;class A{static create(F,N,_=null){if(typeof N=="boolean")return N?y.create(F,_):M.create(F,_);const z=c.get(F);return typeof z=="boolean"?N===(z?"true":"false")?S.INSTANCE:l.INSTANCE:new A(F,N,_)}constructor(F,N,_){this.c=F,this.d=N,this.f=_,this.type=d.Equals}cmp(F){return F.type!==this.type?this.type-F.type:oe(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=c.get(this.c);if(typeof F=="boolean"){const N=F?"true":"false";return this.d===N?S.INSTANCE:l.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Jj=A;class L{static create(F,N){return new L(F,N)}constructor(F,N){this.d=F,this.f=N,this.type=d.In,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:oe(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const N=F.getValue(this.f),_=F.getValue(this.d);return Array.isArray(N)?N.includes(_):typeof _=="string"&&typeof N=="object"&&N!==null?u.call(N,_):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$Kj=L;class D{static create(F,N){return new D(F,N)}constructor(F,N){this.d=F,this.f=N,this.type=d.NotIn,this.c=L.create(F,N)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Lj=D;class O{static create(F,N,_=null){if(typeof N=="boolean")return N?M.create(F,_):y.create(F,_);const z=c.get(F);return typeof z=="boolean"?N===(z?"true":"false")?l.INSTANCE:S.INSTANCE:new O(F,N,_)}constructor(F,N,_){this.c=F,this.d=N,this.f=_,this.type=d.NotEquals}cmp(F){return F.type!==this.type?this.type-F.type:oe(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=c.get(this.c);if(typeof F=="boolean"){const N=F?"true":"false";return this.d===N?l.INSTANCE:S.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Mj=O;class M{static create(F,N=null){const _=c.get(F);return typeof _=="boolean"?_?l.INSTANCE:S.INSTANCE:new M(F,N)}constructor(F,N){this.c=F,this.d=N,this.type=d.Not}cmp(F){return F.type!==this.type?this.type-F.type:X(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=c.get(this.c);return typeof F=="boolean"?F?l.INSTANCE:S.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Nj=M;function Z(J,F){if(typeof J=="string"){const N=parseFloat(J);isNaN(N)||(J=N)}return typeof J=="string"||typeof J=="number"?F(J):l.INSTANCE}class q{static create(F,N,_=null){return Z(N,z=>new q(F,z,_))}constructor(F,N,_){this.c=F,this.d=N,this.f=_,this.type=d.Greater}cmp(F){return F.type!==this.type?this.type-F.type:oe(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.$Oj=q;class K{static create(F,N,_=null){return Z(N,z=>new K(F,z,_))}constructor(F,N,_){this.c=F,this.d=N,this.f=_,this.type=d.GreaterEquals}cmp(F){return F.type!==this.type?this.type-F.type:oe(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=de.create(this.c,this.d,this)),this.f}}e.$Pj=K;class de{static create(F,N,_=null){return Z(N,z=>new de(F,z,_))}constructor(F,N,_){this.c=F,this.d=N,this.f=_,this.type=d.Smaller}cmp(F){return F.type!==this.type?this.type-F.type:oe(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Qj=de;class H{static create(F,N,_=null){return Z(N,z=>new H(F,z,_))}constructor(F,N,_){this.c=F,this.d=N,this.f=_,this.type=d.SmallerEquals}cmp(F){return F.type!==this.type?this.type-F.type:oe(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Rj=H;class Y{static create(F,N){return new Y(F,N)}constructor(F,N){this.d=F,this.f=N,this.type=d.Regex,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const N=this.f?this.f.source:"",_=F.f?F.f.source:"";return N<_?-1:N>_?1:0}equals(F){if(F.type===this.type){const N=this.f?this.f.source:"",_=F.f?F.f.source:"";return this.d===F.d&&N===_}return!1}substituteConstants(){return this}evaluate(F){const N=F.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$Sj=Y;class B{static create(F){return new B(F)}constructor(F){this.c=F,this.type=d.NotRegex}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(F){return new B(this.c.map(F))}negate(){return this.c}}e.$Tj=B;function Q(J){let F=null;for(let N=0,_=J.length;N<_;N++){const z=J[N].substituteConstants();if(J[N]!==z&&F===null){F=[];for(let ie=0;ie<N;ie++)F[ie]=J[ie]}F!==null&&(F[N]=z)}return F===null?J:F}class W{static create(F,N,_){return W.d(F,N,_)}constructor(F,N){this.expr=F,this.c=N,this.type=d.And}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let N=0,_=this.expr.length;N<_;N++){const z=a(this.expr[N],F.expr[N]);if(z!==0)return z}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].equals(F.expr[N]))return!1;return!0}return!1}substituteConstants(){const F=Q(this.expr);return F===this.expr?this:W.create(F,this.c,!1)}evaluate(F){for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].evaluate(F))return!1;return!0}static d(F,N,_){const z=[];let ie=!1;for(const G of F)if(G){if(G.type===d.True){ie=!0;continue}if(G.type===d.False)return l.INSTANCE;if(G.type===d.And){z.push(...G.expr);continue}z.push(G)}if(z.length===0&&ie)return S.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(a);for(let G=1;G<z.length;G++)z[G-1].equals(z[G])&&(z.splice(G,1),G--);if(z.length===1)return z[0];for(;z.length>1;){const G=z[z.length-1];if(G.type!==d.Or)break;z.pop();const U=z.pop(),te=z.length===0,he=j.create(G.expr.map(me=>W.create([me,U],null,_)),null,te);he&&(z.push(he),z.sort(a))}if(z.length===1)return z[0];if(_){for(let G=0;G<z.length;G++)for(let U=G+1;U<z.length;U++)if(z[G].negate().equals(z[U]))return l.INSTANCE;if(z.length===1)return z[0]}return new W(z,N)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const N of this.expr)F.push(...N.keys());return F}map(F){return new W(this.expr.map(N=>N.map(F)),null)}negate(){if(!this.c){const F=[];for(const N of this.expr)F.push(N.negate());this.c=j.create(F,this,!0)}return this.c}}e.$Uj=W;class j{static create(F,N,_){return j.d(F,N,_)}constructor(F,N){this.expr=F,this.c=N,this.type=d.Or}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let N=0,_=this.expr.length;N<_;N++){const z=a(this.expr[N],F.expr[N]);if(z!==0)return z}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].equals(F.expr[N]))return!1;return!0}return!1}substituteConstants(){const F=Q(this.expr);return F===this.expr?this:j.create(F,this.c,!1)}evaluate(F){for(let N=0,_=this.expr.length;N<_;N++)if(this.expr[N].evaluate(F))return!0;return!1}static d(F,N,_){let z=[],ie=!1;if(F){for(let G=0,U=F.length;G<U;G++){const te=F[G];if(te){if(te.type===d.False){ie=!0;continue}if(te.type===d.True)return S.INSTANCE;if(te.type===d.Or){z=z.concat(te.expr);continue}z.push(te)}}if(z.length===0&&ie)return l.INSTANCE;z.sort(a)}if(z.length!==0){if(z.length===1)return z[0];for(let G=1;G<z.length;G++)z[G-1].equals(z[G])&&(z.splice(G,1),G--);if(z.length===1)return z[0];if(_){for(let G=0;G<z.length;G++)for(let U=G+1;U<z.length;U++)if(z[G].negate().equals(z[U]))return S.INSTANCE;if(z.length===1)return z[0]}return new j(z,N)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const N of this.expr)F.push(...N.keys());return F}map(F){return new j(this.expr.map(N=>N.map(F)),null)}negate(){if(!this.c){const F=[];for(const N of this.expr)F.push(N.negate());for(;F.length>1;){const N=F.shift(),_=F.shift(),z=[];for(const ie of re(N))for(const G of re(_))z.push(W.create([ie,G],null,!1));F.unshift(j.create(z,null,!1))}this.c=j.create(F,this,!0)}return this.c}}e.$Vj=j;class C extends y{static{this.d=[]}static all(){return C.d.values()}constructor(F,N,_){super(F,null),this.f=N,typeof _=="object"?C.d.push({..._,key:F}):_!==!0&&C.d.push({key:F,description:_,type:N!=null?typeof N:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return A.create(this.key,F)}notEqualsTo(F){return O.create(this.key,F)}}e.$Wj=C,e.$Xj=(0,T.$Fi)("contextKeyService");function X(J,F){return J<F?-1:J>F?1:0}function oe(J,F,N,_){return J<N?-1:J>N?1:F<_?-1:F>_?1:0}function V(J,F){if(J.type===d.False||F.type===d.True)return!0;if(J.type===d.Or)return F.type===d.Or?ue(J.expr,F.expr):!1;if(F.type===d.Or){for(const N of F.expr)if(V(J,N))return!0;return!1}if(J.type===d.And){if(F.type===d.And)return ue(F.expr,J.expr);for(const N of J.expr)if(V(N,F))return!0;return!1}return J.equals(F)}function ue(J,F){let N=0,_=0;for(;N<J.length&&_<F.length;){const z=J[N].cmp(F[_]);if(z<0)return!1;z===0&&N++,_++}return N===J.length}function re(J){return J.type===d.Or?J.expr:[J]}}),define(ce[96],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Tm=e.ID=void 0,e.$Um=r,e.ID="diagnosticsService",e.$Tm=(0,n.$Fi)(e.ID);function r(R){return!!R.hostName&&!!R.errorMessage}class k{async getPerformanceInfo(T,I){return{}}async getSystemInfo(T,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,I){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.$Vm=k});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[123],le([0,1,18,81,10,6,47,3,37]),function(x,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$_w=e.$$w=e.$0w=void 0,e.$ax=w,e.$bx=f,r=Ve(r),e.$0w=(0,R.$Fi)("dialogService");var c;(function(g){g[g.Confirmation=1]="Confirmation",g[g.Prompt=2]="Prompt",g[g.Input=3]="Input"})(c||(c={}));class m{a(v){return this.d(v,c.Confirmation)}b(v){return this.d(v,c.Prompt)}c(v){return this.d(v,c.Input)}d(v,b){const $=[];switch(b){case c.Confirmation:{const P=v;P.primaryButton?$.push(P.primaryButton):$.push((0,k.localize)(11576,null)),P.cancelButton?$.push(P.cancelButton):$.push((0,k.localize)(11577,null));break}case c.Prompt:{const P=v;Array.isArray(P.buttons)&&P.buttons.length>0&&$.push(...P.buttons.map(E=>E.label)),P.cancelButton&&(P.cancelButton===!0?$.push((0,k.localize)(11578,null)):typeof P.cancelButton=="string"?$.push(P.cancelButton):P.cancelButton.label?$.push(P.cancelButton.label):$.push((0,k.localize)(11579,null))),$.length===0&&$.push((0,k.localize)(11580,null));break}case c.Input:{const P=v;P.primaryButton?$.push(P.primaryButton):$.push((0,k.localize)(11581,null)),P.cancelButton?$.push(P.cancelButton):$.push((0,k.localize)(11582,null));break}}return $}e(v){if(typeof v=="string")return v;if(typeof v=="number")return v===r.default.Info?"info":v===r.default.Error?"error":v===r.default.Warning?"warning":"none"}f(v,b,$){const P=[...v.buttons??[]];v.cancelButton&&typeof v.cancelButton!="string"&&typeof v.cancelButton!="boolean"&&P.push(v.cancelButton);let E=P[b]?.run({checkboxChecked:$});return E instanceof Promise||(E=Promise.resolve(E)),{result:E,checkboxChecked:$}}}e.$$w=m,e.$_w=(0,R.$Fi)("fileDialogService");var u;(function(g){g[g.SAVE=0]="SAVE",g[g.DONT_SAVE=1]="DONT_SAVE",g[g.CANCEL=2]="CANCEL"})(u||(e.ConfirmResult=u={}));const d=10;function w(g){const v=[];return v.push(...g.slice(0,d).map(b=>typeof b=="string"?b:(0,n.$dh)(b))),g.length>d&&(g.length-d===1?v.push((0,k.localize)(11583,null)):v.push((0,k.localize)(11584,null,g.length-d))),v.push(""),v.join(`
`)}function f(g,v){const b=(0,p.$eo)(g);let $=(b.buttons??[]).map(h=>(0,T.$7w)(h)),P=(g.buttons||[]).map((h,t)=>t),E=0,i=b.cancelId??$.length-1;if($.length>1){const h=typeof i=="number"?$[i]:void 0;if(I.$l||I.$k){if(typeof h=="string"&&$.length>1&&i!==1){$.splice(i,1),$.splice(1,0,h);const t=P[i];P.splice(i,1),P.splice(1,0,t),i=1}I.$l&&$.length>1&&($=$.reverse(),P=P.reverse(),E=$.length-1,typeof h=="string"&&(i=E-1))}else if(I.$j&&typeof h=="string"&&$.length>1&&i!==$.length-1){$.splice(i,1),$.push(h);const t=P[i];P.splice(i,1),P.push(t),i=$.length-1}}return b.buttons=$,b.defaultId=E,b.cancelId=i,b.noLink=!0,b.title=b.title||v.nameLong,{options:b,buttonIndeces:P}}}),define(ce[97],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$FY=e.$EY=void 0,e.$GY=R,e.$HY=T,e.$EY=(0,n.$Fi)("encryptionService"),e.$FY=(0,n.$Fi)("encryptionMainService");var r;(function(I){I.kwallet="kwallet",I.kwallet5="kwallet5",I.gnomeLibsecret="gnome-libsecret",I.basic="basic"})(r||(e.PasswordStoreCLIOption=r={}));var k;(function(I){I.unknown="unknown",I.basicText="basic_text",I.gnomeAny="gnome_any",I.gnomeLibsecret="gnome_libsecret",I.gnomeKeyring="gnome_keyring",I.kwallet="kwallet",I.kwallet5="kwallet5",I.kwallet6="kwallet6",I.dplib="dpapi",I.keychainAccess="keychain_access"})(k||(e.KnownStorageProvider=k={}));function R(I){return I===k.kwallet||I===k.kwallet5||I===k.kwallet6}function T(I){return I===k.gnomeAny||I===k.gnomeLibsecret||I===k.gnomeKeyring}}),define(ce[38],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=void 0,e.$Mi=(0,n.$Fi)("environmentService"),e.$Ni=(0,n.$Gi)(e.$Mi)}),define(ce[175],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=e.$ygc=void 0,e.$ygc=(0,n.$Fi)("extensionHostStarter"),e.$zgc="extensionHostStarter"}),define(ce[176],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M0b=e.$L0b=void 0,e.$L0b=(0,n.$Fi)("externalTerminal"),e.$M0b="Terminal.app"}),define(ce[177],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=void 0,e.$Bgc=(0,n.$Fi)("externalTerminal")}),define(ce[178],le([0,1,48,54,12,9,3,79,23,94,10,176]),function(x,e,n,r,k,R,T,I,p,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=e.$Dgc=e.$Cgc=void 0,n=Pe(n),R=Pe(R),T=Pe(T),p=Pe(p),c=Pe(c),m=Pe(m);const d=m.localize(11426,null);class w{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends w{static{this.b="cmd.exe"}openTerminal(i,h){return this.spawnTerminal(n,i,c.$ym(),h)}spawnTerminal(i,h,t,o){const s=h.windowsExec||f.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const a=R.$nc(s,".exe").toLowerCase();if(a==="cmder")return i.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return s.indexOf(" ")>=0&&l.push(s),l.push(s),a==="wt"&&l.push("-d ."),new Promise((S,y)=>{const A=b(process),L=i.spawn(t,l,{cwd:o,env:A,detached:!0});L.on("error",y),L.on("exit",()=>S())})}async runInTerminal(i,h,t,o,s){const a="windowsExec"in s&&s.windowsExec?s.windowsExec:f.getDefaultTerminalWindows(),l=await f.f();return new Promise((S,y)=>{const A=`"${h} - ${d}"`,L=`"${t.join('" "')}" & pause`,D=Object.assign({},b(process),o);Object.keys(D).filter(K=>D[K]===null).forEach(K=>delete D[K]);const O={cwd:h,env:D,windowsVerbatimArguments:!0};let M,Z;R.$nc(a,".exe")==="wt"?(M=a,Z=["-d",".",f.b,"/c",L]):l?(M=l,Z=["-d",".",a,"/c",L]):(M=f.b,Z=["/c","start",A,"/wait",a,"/c",`"${L}"`]),n.spawn(M,Z,O).on("error",K=>{y($(K))}),S(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const i=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${i?"Sysnative":"System32"}\\cmd.exe`}return f.d}static async f(){try{const i=await c.win32.findExecutable("wt");return await p.Promises.exists(i)?i:void 0}catch{return}}}e.$Cgc=f,Se([r.$0h],f,"f",null);class g extends w{static{this.b="/usr/bin/osascript"}openTerminal(i,h){return this.spawnTerminal(n,i,h)}runInTerminal(i,h,t,o,s){const a=s.osxExec||u.$M0b;return new Promise((l,S)=>{if(a===u.$M0b||a==="iTerm.app"){const y=a===u.$M0b?"TerminalHelper":"iTermHelper",L=[k.$Zg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",i||d,"-w",h];for(const M of t)L.push("-a"),L.push(M);if(o){const M=Object.assign({},b(process),o);for(const Z in M){const q=M[Z];q===null?(L.push("-u"),L.push(Z)):(L.push("-e"),L.push(`${Z}=${q}`))}}let D="";const O=n.spawn(g.b,L);O.on("error",M=>{S($(M))}),O.stderr.on("data",M=>{D+=M.toString()}),O.on("exit",M=>{if(M===0)l(void 0);else if(D){const Z=D.split(`
`,1);S(new Error(Z[0]))}else S(new Error(m.localize(11427,null,y,M)))})}else S(new Error(m.localize(11428,null,a)))})}spawnTerminal(i,h,t){const o=h.osxExec||u.$M0b;return new Promise((s,a)=>{const l=["-a",o];t&&l.push(t);const S=b(process),y=i.spawn("/usr/bin/open",l,{cwd:t,env:S});y.on("error",a),y.on("exit",()=>s())})}}e.$Dgc=g;class v extends w{static{this.b=m.localize(11429,null)}openTerminal(i,h){return this.spawnTerminal(n,i,h)}runInTerminal(i,h,t,o,s){const a=s.linuxExec?Promise.resolve(s.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((l,S)=>{const y=[];a.then(A=>{A.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const L=`${P(t)}; echo; read -p "${v.b}" -n1;`;y.push(`''${L}''`);const D=Object.assign({},b(process),o);Object.keys(D).filter(q=>D[q]===null).forEach(q=>delete D[q]);const O={cwd:h,env:D};let M="";const Z=n.spawn(A,y,O);Z.on("error",q=>{S($(q))}),Z.stderr.on("data",q=>{M+=q.toString()}),Z.on("exit",q=>{if(q===0)l(void 0);else if(M){const K=M.split(`
`,1);S(new Error(K[0]))}else S(new Error(m.localize(11430,null,A,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!T.$l)v.d=Promise.resolve("xterm");else{const i=await p.Promises.exists("/etc/debian_version");v.d=new Promise(h=>{i?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm")})}return v.d}spawnTerminal(i,h,t){const o=h.linuxExec?Promise.resolve(h.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{o.then(l=>{const S=b(process),y=i.spawn(l,[],{cwd:t,env:S});y.on("error",a),y.on("exit",()=>s())})})}}e.$Egc=v;function b(E){const i={...E.env};return(0,I.$lm)(i),i}function $(E){return"errno"in E&&E.errno==="ENOENT"&&"path"in E&&typeof E.path=="string"?new Error(m.localize(11431,null,E.path)):E}function P(E){let i="";for(const h of E)h.indexOf(" ")>=0?i+='"'+h+'"':i+=h,i+=" ";return i}}),define(ce[14],le([0,1,60,9,25,11,7,10,6,3,12,65]),function(x,e,n,r,k,R,T,I,p,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Fl=e.FileKind=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.FileOperationResult=e.$xl=e.$wl=e.$vl=e.$tl=e.FileChangeType=e.$sl=e.FileOperation=e.$ml=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$al=void 0,e.$bl=d,e.$cl=v,e.$dl=$,e.$el=P,e.$fl=E,e.$gl=i,e.$hl=h,e.$il=t,e.$jl=o,e.$kl=s,e.$ll=a,e.$nl=y,e.$ol=A,e.$pl=L,e.$ql=D,e.$rl=O,e.$ul=de,e.$Gl=j,e.$Hl=C,e.$Jl=oe,e.$al=(0,p.$Fi)("fileService");function d(V){return V.create===!0}var w;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var f;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var g;(function(V){V[V.UPDATED=2]="UPDATED",V[V.ADDED=4]="ADDED",V[V.DELETED=8]="DELETED"})(g||(e.FileChangeFilter=g={}));function v(V){const ue=V;return!!ue&&typeof ue.onDidChange=="function"}var b;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function $(V){return!!(V.capabilities&b.FileReadWrite)}function P(V){return!!(V.capabilities&b.FileFolderCopy)}function E(V){return!!(V.capabilities&b.FileClone)}function i(V){return!!(V.capabilities&b.FileOpenReadWriteClose)}function h(V){return!!(V.capabilities&b.FileReadStream)}function t(V){return $(V)?!!(V.capabilities&b.FileAtomicRead):!1}function o(V){return $(V)?!!(V.capabilities&b.FileAtomicWrite):!1}function s(V){return!!(V.capabilities&b.FileAtomicDelete)}function a(V){return!!(V.capabilities&b.Readonly)}var l;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class S extends Error{static create(ue,re){const J=new S(ue.toString(),re);return L(J,re),J}constructor(ue,re){super(ue),this.code=re}}e.$ml=S;function y(V,ue){return S.create(V,ue)}function A(V){return V||y((0,I.localize)(11385,null),l.Unknown)}function L(V,ue){return V.name=ue?`${ue} (FileSystemError)`:"FileSystemError",V}function D(V){if(!V)return l.Unknown;if(V instanceof S)return V.code;const ue=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!ue)return l.Unknown;switch(ue[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}function O(V){if(V instanceof H)return V.fileOperationResult;switch(D(V)){case l.FileNotFound:return Q.FILE_NOT_FOUND;case l.FileIsADirectory:return Q.FILE_IS_DIRECTORY;case l.FileNotADirectory:return Q.FILE_NOT_DIRECTORY;case l.FileWriteLocked:return Q.FILE_WRITE_LOCKED;case l.NoPermissions:return Q.FILE_PERMISSION_DENIED;case l.FileExists:return Q.FILE_MOVE_CONFLICT;case l.FileTooLarge:return Q.FILE_TOO_LARGE;default:return Q.FILE_OTHER_ERROR}}var M;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class Z{constructor(ue,re,J){this.resource=ue,this.operation=re,this.target=J}isOperation(ue){return this.operation===ue}}e.$sl=Z;var q;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(q||(e.FileChangeType=q={}));class K{static{this.a=null}constructor(ue,re){this.c=re,this.b=void 0,this.d=new u.$T(()=>{const J=n.$Li.forUris(()=>this.c);return J.fill(this.rawAdded.map(F=>[F,!0])),J}),this.f=new u.$T(()=>{const J=n.$Li.forUris(()=>this.c);return J.fill(this.rawUpdated.map(F=>[F,!0])),J}),this.g=new u.$T(()=>{const J=n.$Li.forUris(()=>this.c);return J.fill(this.rawDeleted.map(F=>[F,!0])),J}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const J of ue){switch(J.type){case q.ADDED:this.rawAdded.push(J.resource);break;case q.UPDATED:this.rawUpdated.push(J.resource);break;case q.DELETED:this.rawDeleted.push(J.resource);break}this.b!==K.a&&(typeof J.cId=="number"?this.b===void 0?this.b=J.cId:this.b!==J.cId&&(this.b=K.a):this.b!==void 0&&(this.b=K.a))}}contains(ue,...re){return this.h(ue,{includeChildren:!1},...re)}affects(ue,...re){return this.h(ue,{includeChildren:!0},...re)}h(ue,re,...J){if(!ue)return!1;const F=J.length>0;return!!((!F||J.includes(q.ADDED))&&(this.d.value.get(ue)||re.includeChildren&&this.d.value.findSuperstr(ue))||(!F||J.includes(q.UPDATED))&&(this.f.value.get(ue)||re.includeChildren&&this.f.value.findSuperstr(ue))||(!F||J.includes(q.DELETED))&&(this.g.value.findSubstr(ue)||re.includeChildren&&this.g.value.findSuperstr(ue)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ue){return this.b===ue}hasCorrelation(){return typeof this.b=="number"}}e.$tl=K;function de(V,ue,re){return!V||!ue||V===ue||ue.length>V.length?!1:(ue.charAt(ue.length-1)!==r.sep&&(ue+=r.sep),re?(0,k.$Gf)(V,ue):V.indexOf(ue)===0)}class H extends Error{constructor(ue,re,J){super(ue),this.fileOperationResult=re,this.options=J}}e.$vl=H;class Y extends H{constructor(ue,re,J,F){super(ue,re,F),this.fileOperationResult=re,this.size=J}}e.$wl=Y;class B extends H{constructor(ue,re,J){super(ue,Q.FILE_NOT_MODIFIED_SINCE,J),this.stat=re}}e.$xl=B;var Q;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Q||(e.FileOperationResult=Q={})),e.$yl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$zl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Al="files.associations",e.$Bl="files.exclude",e.$Cl="files.readonlyInclude",e.$Dl="files.readonlyExclude",e.$El="files.readonlyFromPermissions";var W;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(W||(e.FileKind=W={})),e.$Fl="";function j(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}async function C(V,ue){if(!ue.hasProvider(T.URI.from({scheme:V.scheme})))return new Promise(re=>{const J=ue.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===V.scheme&&F.added&&(J.dispose(),re())})})}class X{static{this.KB=1024}static{this.MB=X.KB*X.KB}static{this.GB=X.MB*X.KB}static{this.TB=X.GB*X.KB}static formatSize(ue){return(0,R.$ig)(ue)||(ue=0),ue<X.KB?(0,I.localize)(11386,null,ue.toFixed(0)):ue<X.MB?(0,I.localize)(11387,null,(ue/X.KB).toFixed(2)):ue<X.GB?(0,I.localize)(11388,null,(ue/X.MB).toFixed(2)):ue<X.TB?(0,I.localize)(11389,null,(ue/X.GB).toFixed(2)):(0,I.localize)(11390,null,(ue/X.TB).toFixed(2))}}e.$Il=X;function oe(V){const ue=typeof V=="string"||V?.scheme===m.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===m.Schemas.file?1024*X.MB:ue?10*X.MB:c.$p?50*X.MB:1024*X.MB}}),define(ce[124],le([0,1,17,15,10,14]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=T;async function T(m,u,d,w,f,g){let v;try{await I(m,u,d,w,f,g)}catch(b){v=b}finally{v&&f.errorTransformer&&(v=f.errorTransformer(v)),typeof v<"u"&&d.error(v),d.end()}}async function I(m,u,d,w,f,g){p(g);const v=await m.open(u,{create:!1});try{p(g);let b=0,$=0,P=f&&typeof f.length=="number"?f.length:void 0,E=n.$Ne.alloc(Math.min(f.bufferSize,typeof P=="number"?P:f.bufferSize)),i=f&&typeof f.position=="number"?f.position:0,h=0;do $=await m.read(v,i,E.buffer,h,E.byteLength-h),i+=$,h+=$,b+=$,typeof P=="number"&&(P-=$),h===E.byteLength&&(await d.write(w(E)),E=n.$Ne.alloc(Math.min(f.bufferSize,typeof P=="number"?P:f.bufferSize)),h=0);while($>0&&(typeof P!="number"||P>0)&&p(g)&&c(b,f));if(h>0){let t=h;typeof P=="number"&&(t=Math.min(h,P)),d.write(w(E.slice(0,t)))}}catch(b){throw(0,R.$ol)(b)}finally{await m.close(v)}}function p(m){if(m.isCancellationRequested)throw(0,r.$5)();return!0}function c(m,u){if(typeof u?.limits?.size=="number"&&m>u.limits.size)throw(0,R.$nl)((0,k.localize)(11384,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ce[61],le([0,1,111,2,9,3,7,14]),function(x,e,n,r,k,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=e.$6q=void 0,e.$4q=p,e.$5q=c,e.$9q=w,e.$0q=f,e.$$q=g,e.$_q=v,e.$ar=$,e.$br=P;function p(E){return typeof E.correlationId=="number"}function c(E){return E.recursive===!0}class m extends r.$Uc{static{this.a=5}constructor(i,h,t,o){super(),this.h=i,this.j=h,this.m=t,this.n=o,this.c=this.B(new r.$Vc),this.f=void 0,this.g=0}s(){const i=new r.$Tc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(h=>this.h(h))),i.add(this.b.onDidLogMessage(h=>this.j(h))),i.add(this.b.onDidError(h=>this.t(h.error,h.request)))}t(i,h){this.u(i,h)?this.g<m.a&&this.f?(this.y(`restarting watcher after unexpected error: ${i}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${i}`):this.y(i)}u(i,h){return!(!this.n.restartOnError||h||i.indexOf("No space left on device")!==-1||i.indexOf("EMFILE")!==-1)}w(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}y(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}z(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$6q=m;class u extends m{constructor(i,h,t){super(i,h,t,{type:"node.js",restartOnError:!1})}}e.$7q=u;class d extends m{constructor(i,h,t){super(i,h,t,{type:"universal",restartOnError:!0})}}e.$8q=d;function w(E){return E.map(i=>({type:i.type,resource:T.URI.revive(i.resource),cId:i.cId}))}function f(E){const i=new b;for(const h of E)i.processEvent(h);return i.coalesce()}function g(E,i){return typeof i=="string"&&!i.startsWith(n.$wk)&&!(0,k.$ic)(i)?{base:E,pattern:i}:i}function v(E,i){const h=[];for(const t of i)h.push((0,n.$Ak)(g(E,t)));return h}class b{constructor(){this.a=new Set,this.b=new Map}c(i){return R.$l?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const h=this.b.get(this.c(i));let t=!1;if(h){const o=h.type,s=i.type;h.resource.fsPath!==i.resource.fsPath&&(i.type===I.FileChangeType.DELETED||i.type===I.FileChangeType.ADDED)?t=!0:o===I.FileChangeType.ADDED&&s===I.FileChangeType.DELETED?(this.b.delete(this.c(i)),this.a.delete(h)):o===I.FileChangeType.DELETED&&s===I.FileChangeType.ADDED?h.type=I.FileChangeType.UPDATED:o===I.FileChangeType.ADDED&&s===I.FileChangeType.UPDATED||(h.type=s)}else t=!0;t&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],h=[];return Array.from(this.a).filter(t=>t.type!==I.FileChangeType.DELETED?(i.push(t),!1):!0).sort((t,o)=>t.resource.fsPath.length-o.resource.fsPath.length).filter(t=>h.some(o=>(0,I.$ul)(t.resource.fsPath,o,!R.$l))?!1:(h.push(t.resource.fsPath),!0)).concat(i)}}function $(E,i){if(typeof i=="number")switch(E.type){case I.FileChangeType.ADDED:return(i&I.FileChangeFilter.ADDED)===0;case I.FileChangeType.DELETED:return(i&I.FileChangeFilter.DELETED)===0;case I.FileChangeType.UPDATED:return(i&I.FileChangeFilter.UPDATED)===0}return!1}function P(E){if(typeof E=="number"){const i=[];return E&I.FileChangeFilter.ADDED&&i.push("Added"),E&I.FileChangeFilter.DELETED&&i.push("Deleted"),E&I.FileChangeFilter.UPDATED&&i.push("Updated"),i.length===0?"<all>":`[${i.join(", ")}]`}return"<none>"}}),define(ce[179],le([0,1,17,55,15,4,2,67,33,14,61]),function(x,e,n,r,k,R,T,I,p,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tR=e.$sR=void 0,e.$sR="localFilesystem";class u extends T.$Uc{constructor(w,f){super(),this.a=w,this.b=f,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.$le),this.onDidChangeFile=this.f.event,this.g=this.B(new R.$le),this.onDidWatchError=this.g.event,this.h=(0,p.$2g)(),this.j()}get capabilities(){return this.c||(this.c=c.FileSystemProviderCapabilities.FileReadWrite|c.FileSystemProviderCapabilities.FileOpenReadWriteClose|c.FileSystemProviderCapabilities.FileReadStream|c.FileSystemProviderCapabilities.FileFolderCopy|c.FileSystemProviderCapabilities.FileWriteUnlock|c.FileSystemProviderCapabilities.FileAtomicRead|c.FileSystemProviderCapabilities.FileAtomicWrite|c.FileSystemProviderCapabilities.FileAtomicDelete|c.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=c.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=c.FileSystemProviderCapabilities.Trash)),this.c}stat(w){return this.a.call("stat",[w])}readdir(w){return this.a.call("readdir",[w])}async readFile(w,f){const{buffer:g}=await this.a.call("readFile",[w,f]);return g}readFileStream(w,f,g){const v=(0,I.$Be)($=>n.$Ne.concat($.map(P=>n.$Ne.wrap(P))).buffer),b=new T.$Tc;return b.add(this.a.listen("readFileStream",[w,f])($=>{if($ instanceof n.$Ne)v.write($.buffer);else{if($==="end")v.end();else{let P;if($ instanceof Error)P=$;else{const E=$;P=(0,c.$nl)(E.message??(0,r.$qj)(E),E.code??c.FileSystemProviderErrorCode.Unknown)}v.error(P),v.end()}b.dispose()}})),b.add(g.onCancellationRequested(()=>{v.error((0,k.$5)()),v.end(),b.dispose()})),v}writeFile(w,f,g){return this.a.call("writeFile",[w,n.$Ne.wrap(f),g])}open(w,f){return this.a.call("open",[w,f])}close(w){return this.a.call("close",[w])}async read(w,f,g,v,b){const[$,P]=await this.a.call("read",[w,f,b]);return g.set($.buffer.slice(0,P),v),P}write(w,f,g,v,b){return this.a.call("write",[w,f,n.$Ne.wrap(g),v,b])}mkdir(w){return this.a.call("mkdir",[w])}delete(w,f){return this.a.call("delete",[w,f])}rename(w,f,g){return this.a.call("rename",[w,f,g])}copy(w,f,g){return this.a.call("copy",[w,f,g])}cloneFile(w,f){return this.a.call("cloneFile",[w,f])}j(){this.B(this.a.listen("fileChange",[this.h])(w=>{if(Array.isArray(w)){const f=w;this.f.fire((0,m.$9q)(f))}else{const f=w;this.g.fire(f)}}))}watch(w,f){const g=(0,p.$2g)();return this.a.call("watch",[this.h,g,w,f]),(0,T.$Sc)(()=>this.a.call("unwatch",[this.h,g]))}}e.$tR=u}),define(ce[180],le([0,1,26,2,61,4,14,7,8]),function(x,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class c extends r.$Uc{constructor(){super(),this.a=this.B(new R.$le),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$le),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$le),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new r.$4c),this.m=new Set,this.n=this.B(new p.$Dh(this.y())),this.r=5007,this.s=new p.$3h,this.R=!1,this.B(this.f(u=>this.t(u)))}t(u){this.u(u)&&this.z(u)}u(u){return(0,k.$4q)(u)}async watch(u){this.s.isSettled||this.s.complete(),this.s=new p.$3h;try{this.h.clear(),this.g.clear();for(const d of u)this.u(d)?this.h.set(d.correlationId,d):this.g.add(d);for(const[d]of this.j)this.h.has(d)||(this.j.deleteAndDispose(d),this.m.delete(d));return await this.w(!1)}finally{this.s.complete()}}w(u){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(d=>!this.j.has(d.correlationId))]),u?this.y():0)}y(){return 800}isSuspended(u){return typeof u.correlationId!="number"?!1:this.m.has(u.correlationId)?"polling":this.j.has(u.correlationId)}async z(u){if(this.j.has(u.correlationId))return;const d=new r.$Tc;this.j.set(u.correlationId,d),await this.s.p,!d.isDisposed&&(this.D(u,d),this.w(!0))}C(u){this.j.deleteAndDispose(u.correlationId),this.m.delete(u.correlationId),this.w(!1)}D(u,d){this.F(u,d)?(this.P(`reusing an existing recursive watcher to monitor ${u.path}`),this.m.delete(u.correlationId)):(this.G(u,d),this.m.add(u.correlationId))}F(u,d){const w=this.O?.subscribe(u.path,(f,g)=>{d.isDisposed||(f?this.D(u,d):g?.type===T.FileChangeType.ADDED&&this.H(u))});return w?(d.add(w),!0):!1}G(u,d){let w=!1;const f=(g,v)=>{if(d.isDisposed)return;const b=this.I(g),$=this.I(v),P=w;w=b,!b&&($||P)&&this.H(u)};this.P(`starting fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,n.watchFile)(u.path,{persistent:!1,interval:this.r},f)}catch(g){this.Q(`fs.watchFile() failed with error ${g} on path ${u.path} (correlationId: ${u.correlationId})`)}d.add((0,r.$Sc)(()=>{this.P(`stopping fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,n.unwatchFile)(u.path,f)}catch(g){this.Q(`fs.unwatchFile() failed with error ${g} on path ${u.path} (correlationId: ${u.correlationId})`)}}))}H(u){this.P(`detected ${u.path} exists again, resuming watcher (correlationId: ${u.correlationId})`);const d={resource:I.URI.file(u.path),type:T.FileChangeType.ADDED,cId:u.correlationId};this.a.fire([d]),this.J(d,u),this.C(u)}I(u){return u.ctimeMs===0&&u.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(u,d){if(this.R){const w=` >> normalized ${u.type===T.FileChangeType.ADDED?"[ADDED]":u.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`;this.L(w,d)}}L(u,d){this.R&&this.P(`${u}${typeof d.correlationId=="number"?` <${d.correlationId}> `:""}`)}M(u){return`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, filter: ${(0,k.$br)(u.filter)}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`}async setVerboseLogging(u){this.R=u}}e.$kr=c}),define(ce[181],le([0,1,26,8,22,32,2,78,9,3,18,7,112,23,14,61]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0,e.$qr=b;class v extends T.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(P,E,i,h,t,o){super(),this.s=P,this.t=E,this.u=i,this.w=h,this.y=t,this.z=o,this.c=this.B(new r.$Uh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new r.$Th(s=>this.M(s),v.b)),this.g=(0,g.$_q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,g.$_q)(this.s.path,this.s.includes):void 0,this.j=(0,g.$4q)(this.s)?this.s.filter:void 0,this.m=new k.$we,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const P=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const E=await n.promises.stat(P);if(this.m.token.isCancellationRequested)return;this.B(await this.G(P,E.isDirectory()))}catch(P){P.code!=="ENOENT"?this.O(P):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${P})`),this.D()}}D(){this.r=!0,this.w?.()}async F(P){let E=P.path;try{E=await w.Promises.realpath(P.path),P.path===E&&(E=await(0,d.$mr)(P.path,this.m.token)??P.path),P.path!==E&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${P.path}, real: ${E})`)}catch{}return E}async G(P,E){const i=new T.$Tc;return this.H(P,E,i)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(P,E,i)),i}H(P,E,i){if(E)return!1;const h=u.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(o,s)=>{if(!i.isDisposed)if(o){const a=await this.G(P,E);i.isDisposed?a.dispose():i.add(a)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:h,type:s.type,cId:this.s.correlationId},!0)});return t?(i.add(t),!0):!1}async I(P,E,i){if(c.$k&&(0,R.$Eg)(P,"/Volumes/",!0)){this.O(`Refusing to watch ${P} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const h=new k.$we(this.m.token);i.add((0,T.$Sc)(()=>h.dispose(!0)));const t=new T.$Tc;i.add(t);try{const o=u.URI.file(this.s.path),s=(0,p.$nc)(P),a=(0,n.watch)(P);t.add((0,T.$Sc)(()=>{a.removeAllListeners(),a.close()})),this.Q(`Started watching: '${P}'`);const l=new Set;if(E)try{for(const y of await w.Promises.readdir(P))l.add(y)}catch(y){this.O(y)}if(h.token.isCancellationRequested)return;const S=new Map;t.add((0,T.$Sc)(()=>{for(const[,y]of S)y.dispose();S.clear()})),a.on("error",(y,A)=>{h.token.isCancellationRequested||(this.O(`Failed to watch ${P} for changes using fs.watch() (${y}, ${A})`),this.D())}),a.on("change",(y,A)=>{if(h.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${y}"] ${A}`);let L="";if(A&&(L=A.toString(),c.$k&&(L=(0,I.$nm)(L))),!(!L||y!=="change"&&y!=="rename"))if(E)if(y==="rename"){S.get(L)?.dispose();const D=setTimeout(async()=>{if(S.delete(L),L===s&&!await w.Promises.exists(P)){this.J(o);return}if(h.token.isCancellationRequested)return;const O=await this.N((0,p.$jc)(P,L));if(h.token.isCancellationRequested)return;let M;O?l.has(L)?M=f.FileChangeType.UPDATED:(M=f.FileChangeType.ADDED,l.add(L)):(l.delete(L),M=f.FileChangeType.DELETED),this.L({resource:(0,m.$gh)(o,L),type:M,cId:this.s.correlationId})},v.a);S.set(L,(0,T.$Sc)(()=>clearTimeout(D)))}else{let D;l.has(L)?D=f.FileChangeType.UPDATED:(D=f.FileChangeType.ADDED,l.add(L)),this.L({resource:(0,m.$gh)(o,L),type:D,cId:this.s.correlationId})}else if(y==="rename"||L!==s){const D=setTimeout(async()=>{const O=await w.Promises.exists(P);h.token.isCancellationRequested||(O?(this.L({resource:o,type:f.FileChangeType.UPDATED,cId:this.s.correlationId},!0),t.add(await this.G(P,!1))):this.J(o))},v.a);t.clear(),t.add((0,T.$Sc)(()=>clearTimeout(D)))}else this.L({resource:o,type:f.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(o){h.token.isCancellationRequested||this.O(`Failed to watch ${P} for changes using fs.watch() (${o.toString()})`),this.D()}}J(P){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:P,type:f.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(P,E=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${P.type===f.FileChangeType.ADDED?"[ADDED]":P.type===f.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${P.resource.fsPath}`),!E&&this.g.some(i=>i(P.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${P.resource.fsPath}`):!E&&this.h&&this.h.length>0&&!this.h.some(i=>i(P.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${P.resource.fsPath}`):this.f.work(P))}M(P){const E=(0,g.$0q)(P),i=[];for(const t of E){if((0,g.$ar)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}i.push(t)}if(i.length===0)return;if(this.z)for(const t of i)this.R(` >> normalized ${t.type===f.FileChangeType.ADDED?"[ADDED]":t.type===f.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(i)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(P){if(c.$l)return w.Promises.exists(P);try{const E=(0,p.$nc)(P);return(await w.Promises.readdir((0,p.$mc)(P))).some(h=>h===E)}catch(E){return this.Q(E),!1}}setVerboseLogging(P){this.z=P}O(P){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${P}`})}P(P){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${P}`})}Q(P){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${P}`})}R(P){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${P}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$pr=v;async function b($,P,E,i,h=512){const t=await w.Promises.open($,"r"),o=Buffer.allocUnsafe(h),s=new k.$we(i);let a,l=!1;const S={path:$,excludes:[],recursive:!1},y=new v(S,void 0,A=>{(async()=>{for(const{type:L}of A)if(L===f.FileChangeType.UPDATED){if(l)return;l=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:D}=await w.Promises.read(t,o,0,h,null);if(!D||s.token.isCancellationRequested)break;P(o.slice(0,D))}}catch(D){a=new Error(D),s.dispose(!0)}finally{l=!1}}})()});return await y.ready,E(),new Promise((A,L)=>{s.token.onCancellationRequested(async()=>{y.dispose();try{await w.Promises.close(t)}catch(D){a=new Error(D)}a?L(a):A()})})}}),define(ce[182],le([0,1,4,111,180,3,181,32]),function(x,e,n,r,k,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class p extends k.$kr{constructor(m){super(),this.O=m,this.onDidError=n.Event.None,this.watchers=new Set}async N(m){m=this.Z(m);const u=[],d=new Set(Array.from(this.watchers));for(const w of m){const f=this.W(w);f&&(0,r.$Ek)(f.request.excludes,w.excludes)&&(0,r.$Ek)(f.request.includes,w.includes)?d.delete(f):u.push(w)}u.length&&this.P(`Request to start watching: ${u.map(w=>this.M(w)).join(",")}`),d.size&&this.P(`Request to stop watching: ${Array.from(d).map(w=>this.M(w.request)).join(",")}`);for(const w of d)this.Y(w);for(const w of u)this.X(w)}W(m){for(const u of this.watchers)if(typeof m.correlationId=="number"||typeof u.request.correlationId=="number"){if(u.request.correlationId===m.correlationId)return u}else if((0,I.$Dg)(u.request.path,m.path,!R.$l))return u}X(m){const u=new T.$pr(m,this.O,w=>this.a.fire(w),()=>this.c.fire(m),w=>this.b.fire(w),this.R),d={request:m,instance:u};this.watchers.add(d)}async stop(){await super.stop();for(const m of this.watchers)this.Y(m)}Y(m){this.P("stopping file watcher",m),this.watchers.delete(m),m.instance.dispose()}Z(m){const u=new Map;for(const d of m){const w=R.$l?d.path:d.path.toLowerCase();let f=u.get(d.correlationId);f||(f=new Map,u.set(d.correlationId,f)),f.has(w)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(d)}`),f.set(w,d)}return Array.from(u.values()).map(d=>Array.from(d.values())).flat()}async setVerboseLogging(m){super.setVerboseLogging(m);for(const u of this.watchers)u.instance.setVerboseLogging(m)}P(m,u){this.R&&this.b.fire({type:"trace",message:this.bb(m,u)})}Q(m){this.b.fire({type:"warn",message:this.bb(m)})}bb(m,u){return u?`[File Watcher (node.js)] ${m} (${this.M(u.request)})`:`[File Watcher (node.js)] ${m}`}}e.$rr=p}),define(ce[183],le([0,1,61,182]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;class k extends n.$7q{constructor(T,I,p){super(T,I,p),this.s()}r(T){return T.add(new r.$rr(void 0))}}e.$sr=k}),define(ce[184],le([0,1,12,44,160,61]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;class T extends R.$8q{constructor(p,c,m){super(p,c,m),this.s()}r(p){const c=p.add(new k.$ir(n.$Zg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(c.onDidProcessExit(({code:m,signal:u})=>this.t(`terminated by itself with code ${m}, signal: ${u} (ETERM)`))),r.ProxyChannel.toService((0,r.$mi)(c.getChannel("watcher")))}}e.$jr=T}),define(ce[98],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class n{constructor(...k){this.a=new Map;for(const[R,T]of k)this.set(R,T)}set(k,R){const T=this.a.get(k);return this.a.set(k,R),T}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.$Di=n}),define(ce[185],le([0,1,8,15,2,83,174,6,98,108]),function(x,e,n,r,k,R,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=void 0;const m=!1;class u extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class d{constructor(v=new p.$Di,b=!1,$,P=m){this.i=v,this.j=b,this.k=$,this.l=P,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$Ei,this),this._globalGraph=P?$?._globalGraph??new T.$vr(E=>E):void 0}dispose(){if(!this.f){this.f=!0,(0,k.$Pc)(this.h),this.h.clear();for(const v of this.g)(0,k.$Oc)(v)&&v.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(v,b){this.m();const $=this,P=new class extends d{dispose(){$.h.delete(P),super.dispose()}}(v,this.j,this,this.l);return this.h.add(P),b?.add(P),P}invokeFunction(v,...b){this.m();const $=f.traceInvocation(this.l,v);let P=!1;try{return v({get:i=>{if(P)throw(0,r.$7)("service accessor is only valid during the invocation of its target method");const h=this.s(i,$);if(!h)throw new Error(`[invokeFunction] unknown service '${i}'`);return h}},...b)}finally{P=!0,$.stop()}}createInstance(v,...b){this.m();let $,P;return v instanceof R.$Ci?($=f.traceCreation(this.l,v.ctor),P=this.o(v.ctor,v.staticArguments.concat(b),$)):($=f.traceCreation(this.l,v),P=this.o(v,b,$)),$.stop(),P}o(v,b=[],$){const P=I._util.getServiceDependencies(v).sort((h,t)=>h.index-t.index),E=[];for(const h of P){const t=this.s(h.id,$);t||this.y(`[createInstance] ${v.name} depends on UNKNOWN service ${h.id}.`,!1),E.push(t)}const i=P.length>0?P[0].index:b.length;if(b.length!==i){console.trace(`[createInstance] First service dependency of ${v.name} at position ${i+1} conflicts with ${b.length} static arguments`);const h=i-b.length;h>0?b=b.concat(new Array(h)):b=b.slice(0,i)}return Reflect.construct(v,b.concat(E))}q(v,b){if(this.i.get(v)instanceof R.$Ci)this.i.set(v,b);else if(this.k)this.k.q(v,b);else throw new Error("illegalState - setting UNKNOWN service instance")}r(v){const b=this.i.get(v);return!b&&this.k?this.k.r(v):b}s(v,b){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(v));const $=this.r(v);return $ instanceof R.$Ci?this.u(v,$,b.branch(v,!0)):(b.branch(v,!1),$)}u(v,b,$){if(this.t.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this.t.add(v);try{return this.v(v,b,$)}finally{this.t.delete(v)}}v(v,b,$){const P=new T.$vr(t=>t.id.toString());let E=0;const i=[{id:v,desc:b,_trace:$}],h=new Set;for(;i.length;){const t=i.pop();if(!h.has(String(t.id))){if(h.add(String(t.id)),P.lookupOrInsertNode(t),E++>1e3)throw new u(P);for(const o of I._util.getServiceDependencies(t.desc.ctor)){const s=this.r(o.id);if(s||this.y(`[createInstance] ${v} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),s instanceof R.$Ci){const a={id:o.id,desc:s,_trace:t._trace.branch(o.id,!0)};P.insertEdge(t,a),i.push(a)}}}}for(;;){const t=P.roots();if(t.length===0){if(!P.isEmpty())throw new u(P);break}for(const{data:o}of t){if(this.r(o.id)instanceof R.$Ci){const a=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,a)}P.removeNode(o)}}return this.r(v)}w(v,b,$=[],P,E){if(this.i.get(v)instanceof R.$Ci)return this.x(v,b,$,P,E,this.g);if(this.k)return this.k.w(v,b,$,P,E);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}x(v,b,$=[],P,E,i){if(P){const h=new d(void 0,this.j,this,this.l);h.c=String(v);const t=new Map,o=new n.$Yh(()=>{const s=h.o(b,$,E);for(const[a,l]of t){const S=s[a];if(typeof S=="function")for(const y of l)y.disposable=S.apply(s,y.listener)}return t.clear(),i.add(s),s});return new Proxy(Object.create(null),{get(s,a){if(!o.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let y=t.get(a);return y||(y=new c.$5c,t.set(a,y)),(L,D,O)=>{if(o.isInitialized)return o.value[a](L,D,O);{const M={listener:[L,D,O],disposable:void 0},Z=y.push(M);return(0,k.$Sc)(()=>{Z(),M.disposable?.dispose()})}}}if(a in s)return s[a];const l=o.value;let S=l[a];return typeof S!="function"||(S=S.bind(l),s[a]=S),S},set(s,a,l){return o.value[a]=l,!0},getPrototypeOf(s){return b.prototype}})}else{const h=this.o(b,$,E);return i.add(h),h}}y(v,b){if(b&&console.warn(v),this.j)throw new Error(v)}}e.$wr=d;var w;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(w||(w={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(w.None,null)}stop(){}branch(){return this}}}static traceInvocation(v,b){return v?new f(w.Invocation,b.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(v,b){return v?new f(w.Creation,b.name):f.c}static{this.f=0}constructor(v,b){this.type=v,this.name=b,this.g=Date.now(),this.h=[]}branch(v,b){const $=new f(w.Branch,v.toString());return this.h.push([v,b,$]),$}stop(){const v=Date.now()-this.g;f.f+=v;let b=!1;function $(E,i){const h=[],t=new Array(E+1).join("	");for(const[o,s,a]of i.h)if(s&&a){b=!0,h.push(`${t}CREATES -> ${o}`);const l=$(E+1,a);l&&h.push(l)}else h.push(`${t}uses -> ${o}`);return h.join(`
`)}const P=[`${this.type===w.Creation?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(v>2||b)&&f.all.add(P.join(`
`))}}e.$xr=f}),define(ce[186],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gac=e.$fac=e.IssueSource=e.OldIssueType=void 0;var r;(function(R){R[R.Bug=0]="Bug",R[R.PerformanceIssue=1]="PerformanceIssue",R[R.FeatureRequest=2]="FeatureRequest"})(r||(e.OldIssueType=r={}));var k;(function(R){R.VSCode="vscode",R.Extension="extension",R.Marketplace="marketplace"})(k||(e.IssueSource=k={})),e.$fac=(0,n.$Fi)("issueService"),e.$gac=(0,n.$Fi)("processService")}),define(ce[5],le([0,1,10,55,4,46,2,31,3,18,11,7,122,6]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$dk=e.LogLevel=e.$bk=e.$ak=void 0,e.$ck=g,e.log=b,e.$ok=S,e.$pk=y,e.$qk=A,e.$rk=L,n=Pe(n),e.$ak=(0,w.$Fi)("logService"),e.$bk=(0,w.$Fi)("loggerService");function f(){return new Date().toISOString()}function g(D){return(0,m.$ig)(D)}var v;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$dk=v.Info;function b(D,O,M){switch(O){case v.Trace:D.trace(M);break;case v.Debug:D.debug(M);break;case v.Info:D.info(M);break;case v.Warning:D.warn(M);break;case v.Error:D.error(M);break;case v.Off:break;default:throw new Error(`Invalid log level ${O}`)}}function $(D,O=!1){let M="";for(let Z=0;Z<D.length;Z++){let q=D[Z];if(q instanceof Error&&(q=(0,r.$qj)(q,O)),typeof q=="object")try{q=JSON.stringify(q)}catch{}M+=(Z>0?" ":"")+q}return M}class P extends T.$Uc{constructor(){super(...arguments),this.b=e.$dk,this.c=this.B(new k.$le),this.onDidChangeLogLevel=this.c.event}setLevel(O){this.b!==O&&(this.b=O,this.c.fire(this.b))}getLevel(){return this.b}f(O){return this.b!==v.Off&&this.b<=O}}e.$fk=P;class E extends P{constructor(O){super(),this.h=O}f(O){return this.h||super.f(O)}trace(O,...M){this.f(v.Trace)&&this.g(v.Trace,$([O,...M],!0))}debug(O,...M){this.f(v.Debug)&&this.g(v.Debug,$([O,...M]))}info(O,...M){this.f(v.Info)&&this.g(v.Info,$([O,...M]))}warn(O,...M){this.f(v.Warning)&&this.g(v.Warning,$([O,...M]))}error(O,...M){if(this.f(v.Error))if(O instanceof Error){const Z=Array.prototype.slice.call(arguments);Z[0]=O.stack,this.g(v.Error,$(Z))}else this.g(v.Error,$([O,...M]))}flush(){}}e.$gk=E;class i extends P{constructor(O=e.$dk){super(),this.setLevel(O),this.g=!p.$j}trace(O,...M){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,O,...M):console.log(`[main ${f()}]`,O,...M))}debug(O,...M){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,O,...M):console.log(`[main ${f()}]`,O,...M))}info(O,...M){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,O,...M):console.log(`[main ${f()}]`,O,...M))}warn(O,...M){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,O,...M):console.warn(`[main ${f()}]`,O,...M))}error(O,...M){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,O,...M):console.error(`[main ${f()}]`,O,...M))}flush(){}}e.$hk=i;class h extends P{constructor(O=e.$dk,M=!0){super(),this.g=M,this.setLevel(O)}trace(O,...M){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",O,...M):console.log(O,...M))}debug(O,...M){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",O,...M):console.log(O,...M))}info(O,...M){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",O,...M):console.log(O,...M))}warn(O,...M){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",O,...M):console.log(O,...M))}error(O,...M){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",O,...M):console.error(O,...M))}flush(){}}e.$ik=h;class t extends P{constructor(O,M=e.$dk){super(),this.g=O,this.setLevel(M)}trace(O,...M){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(O),...M])}debug(O,...M){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(O),...M])}info(O,...M){this.f(v.Info)&&this.g.log(v.Info,[this.h(O),...M])}warn(O,...M){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(O),...M])}error(O,...M){this.f(v.Error)&&this.g.log(v.Error,[this.h(O),...M])}h(O){return typeof O=="string"?O:(0,r.$qj)(O,this.f(v.Trace))}flush(){}}e.$jk=t;class o extends P{constructor(O){super(),this.g=O,O.length&&this.setLevel(O[0].getLevel())}setLevel(O){for(const M of this.g)M.setLevel(O);super.setLevel(O)}trace(O,...M){for(const Z of this.g)Z.trace(O,...M)}debug(O,...M){for(const Z of this.g)Z.debug(O,...M)}info(O,...M){for(const Z of this.g)Z.info(O,...M)}warn(O,...M){for(const Z of this.g)Z.warn(O,...M)}error(O,...M){for(const Z of this.g)Z.error(O,...M)}flush(){for(const O of this.g)O.flush()}dispose(){for(const O of this.g)O.dispose();super.dispose()}}e.$kk=o;class s extends T.$Uc{constructor(O,M,Z){if(super(),this.h=O,this.j=M,this.b=new I.$Ac,this.c=this.B(new k.$le),this.onDidChangeLoggers=this.c.event,this.f=this.B(new k.$le),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new k.$le),this.onDidChangeVisibility=this.g.event,Z)for(const q of Z)this.b.set(q.resource,{logger:void 0,info:q})}m(O){return(0,m.$eg)(O)?[...this.b.values()].find(M=>M.info.id===O):this.b.get(O)}getLogger(O){return this.m(O)?.logger}createLogger(O,M){const Z=this.n(O),q=(0,m.$eg)(O)?O:M?.id??(0,R.$tj)(Z.toString()).toString(16);let K=this.b.get(Z)?.logger;const de=M?.logLevel==="always"?v.Trace:M?.logLevel;K||(K=this.s(Z,de??this.getLogLevel(Z)??this.h,{...M,id:q}));const H={logger:K,info:{resource:Z,id:q,logLevel:de,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(H.info),this.b.set(Z,H),K}n(O){return(0,m.$eg)(O)?(0,c.$gh)(this.j,`${O}.log`):O}setLogLevel(O,M){if(u.URI.isUri(O)){const Z=O,q=M,K=this.b.get(Z);K&&q!==K.info.logLevel&&(K.info.logLevel=q===this.h?void 0:q,K.logger?.setLevel(q),this.b.set(K.info.resource,K),this.f.fire([Z,q]))}else{this.h=O;for(const[Z,q]of this.b.entries())this.b.get(Z)?.info.logLevel===void 0&&q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(O,M){const Z=this.m(O);Z&&M!==!Z.info.hidden&&(Z.info.hidden=!M,this.b.set(Z.info.resource,Z),this.g.fire([Z.info.resource,M]))}getLogLevel(O){let M;return O&&(M=this.b.get(O)?.info.logLevel),M??this.h}registerLogger(O){const M=this.b.get(O.resource);M?M.info.hidden!==O.hidden&&this.setVisibility(O.resource,!O.hidden):(this.b.set(O.resource,{info:O,logger:void 0}),this.c.fire({added:[O],removed:[]}))}deregisterLogger(O){const M=this.b.get(O);M&&(M.logger&&M.logger.dispose(),this.b.delete(O),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const O of this.b.values())yield O.info}getRegisteredLogger(O){return this.b.get(O)?.info}dispose(){this.b.forEach(O=>O.logger?.dispose()),this.b.clear(),super.dispose()}}e.$lk=s;class a{constructor(){this.onDidChangeLogLevel=new k.$le().event}setLevel(O){}getLevel(){return v.Info}trace(O,...M){}debug(O,...M){}info(O,...M){}warn(O,...M){}error(O,...M){}critical(O,...M){}dispose(){}flush(){}}e.$mk=a;class l extends a{}e.$nk=l;function S(D){if(D.verbose)return v.Trace;if(typeof D.logLevel=="string"){const O=L(D.logLevel.toLowerCase());if(O!==void 0)return O}return e.$dk}function y(D){switch(D){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}function A(D){switch(D){case v.Trace:return{original:"Trace",value:n.localize(11318,null)};case v.Debug:return{original:"Debug",value:n.localize(11319,null)};case v.Info:return{original:"Info",value:n.localize(11320,null)};case v.Warning:return{original:"Warning",value:n.localize(11321,null)};case v.Error:return{original:"Error",value:n.localize(11322,null)};case v.Off:return{original:"Off",value:n.localize(11323,null)}}}function L(D){switch(D){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$sk=new d.$Wj("logLevel",y(v.Info))});var se=this&&this.__param||function(x,e){return function(n,r){e(n,r,x)}};define(ce[187],le([0,1,13,3,97,5]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;const T=n.safeStorage;let I=class{constructor(c){this.a=c,n.app.commandLine.getSwitchValue("password-store")===k.PasswordStoreCLIOption.basic&&(this.a.trace("[EncryptionMainService] setting usePlainTextEncryption to true..."),T.setUsePlainTextEncryption?.(!0),this.a.trace("[EncryptionMainService] set usePlainTextEncryption to true"))}async encrypt(c){this.a.trace("[EncryptionMainService] Encrypting value...");try{const m=JSON.stringify(T.encryptString(c));return this.a.trace("[EncryptionMainService] Encrypted value."),m}catch(m){throw this.a.error(m),m}}async decrypt(c){let m;try{if(m=JSON.parse(c),!m.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${c}`);const u=Buffer.from(m.data);this.a.trace("[EncryptionMainService] Decrypting value...");const d=T.decryptString(u);return this.a.trace("[EncryptionMainService] Decrypted value."),d}catch(u){throw this.a.error(u),u}}isEncryptionAvailable(){this.a.trace("[EncryptionMainService] Checking if encryption is available...");const c=T.isEncryptionAvailable();return this.a.trace("[EncryptionMainService] Encryption is available: ",c),Promise.resolve(c)}getKeyStorageProvider(){if(r.$j)return Promise.resolve(k.KnownStorageProvider.dplib);if(r.$k)return Promise.resolve(k.KnownStorageProvider.keychainAccess);if(T.getSelectedStorageBackend)try{this.a.trace("[EncryptionMainService] Getting selected storage backend...");const c=T.getSelectedStorageBackend();return this.a.trace("[EncryptionMainService] Selected storage backend: ",c),Promise.resolve(c)}catch(c){this.a.error(c)}return Promise.resolve(k.KnownStorageProvider.unknown)}async setUsePlainTextEncryption(){if(r.$j)throw new Error("Setting plain text encryption is not supported on Windows.");if(r.$k)throw new Error("Setting plain text encryption is not supported on macOS.");if(!T.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");this.a.trace("[EncryptionMainService] Setting usePlainTextEncryption to true..."),T.setUsePlainTextEncryption(!0),this.a.trace("[EncryptionMainService] Set usePlainTextEncryption to true")}};e.$xgc=I,e.$xgc=I=Se([se(0,R.$ak)],I)}),define(ce[188],le([0,1,21,8,15,4,32,2,9,61,5]),function(x,e,n,r,k,R,T,I,p,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;class u extends I.$Uc{constructor(w,f){super(),this.a=w,this.b=f,this.c=this.B(new R.$le),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$le),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new r.$Dh(0)),this.w=[],this.y=this.B(new r.$Dh(0))}watch(w,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(w,f):this.z(w,f)}n(w,f){const g={path:this.J(w),excludes:f.excludes,includes:f.includes,recursive:f.recursive,filter:f.filter,correlationId:f.correlationId},v=(0,n.$Sb)(this.j,g);return this.r(),(0,I.$Sc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,k.$Y)(w))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,c.$9q)(f)),f=>this.G(f),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const f of this.j)(0,c.$5q)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const f of this.j)(0,c.$5q)(f)&&w.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,f){const g={path:this.J(w),excludes:f.excludes,includes:f.includes,recursive:!1,filter:f.filter,correlationId:f.correlationId},v=(0,n.$Sb)(this.w,g);return this.C(),(0,I.$Sc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,k.$Y)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,c.$9q)(w)),w=>this.G(w),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.H(w)}H(w){this.a[w.type](w.message)}I(w){return(0,p.$hc)(w.fsPath)}J(w){const f=this.I(w);return(0,T.$Hg)(f)}}e.$cr=u}),define(ce[189],le([0,1,21,8,17,22,4,46,77,2,60,12,70,18,67,10,14,124,5,15]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b,$,P){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;let i=class extends c.$Uc{static{E=this}constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new T.$le),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.$le),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.$le),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new T.$le),this.onDidRunOperation=this.r.event,this.X=this.B(new T.$le),this.Y=this.B(new T.$le),this.onDidFilesChange=this.Y.event,this.Z=this.B(new T.$le),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new r.$Oh)}registerProvider(t,o){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${t}`);const s=new c.$Tc;return this.h.set(t,o),this.c.fire({added:!0,scheme:t,provider:o}),s.add(o.onDidChangeFile(a=>{const l=new v.$tl(a,!this.S(o));this.X.fire(l),l.hasCorrelation()||this.Y.fire(l)})),typeof o.onDidWatchError=="function"&&s.add(o.onDidWatchError(a=>this.Z.fire(new Error(a)))),s.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:t}))),(0,c.$Sc)(()=>{this.c.fire({added:!1,scheme:t,provider:o}),this.h.delete(t),(0,c.$Pc)(s)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const o=[];this.f.fire({scheme:t,join(s){o.push(s)}}),!this.h.has(t)&&await r.Promises.settled(o)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,o){const s=this.h.get(t.scheme);return!!(s&&s.capabilities&o)}listCapabilities(){return p.Iterable.map(this.h,([t,o])=>({scheme:t,capabilities:o.capabilities}))}async j(t){if(!(0,w.$kh)(t))throw new v.$vl((0,g.localize)(11391,null,this.sb(t)),v.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(t.scheme);const o=this.h.get(t.scheme);if(!o){const s=new P.$ab;throw s.message=(0,g.localize)(11392,null,t.toString()),s}return o}async m(t){const o=await this.j(t);if((0,v.$gl)(o)||(0,v.$dl)(o)||(0,v.$hl)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const o=await this.j(t);if((0,v.$gl)(o)||(0,v.$dl)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,o){try{return await this.s(t,o)}catch(s){throw(0,v.$ql)(s)===v.FileSystemProviderErrorCode.FileNotFound?new v.$vl((0,g.localize)(11393,null,this.sb(t)),v.FileOperationResult.FILE_NOT_FOUND):(0,v.$ol)(s)}}async s(t,o){const s=await this.j(t),a=this.S(s),l=o?.resolveTo,S=o?.resolveSingleChildDescendants,y=o?.resolveMetadata,A=await s.stat(t);let L;return this.t(s,t,A,void 0,!!y,(D,O)=>(L||(L=m.$Li.forUris(()=>!a),L.set(t,!0),l&&L.fill(!0,l)),L.get(D.resource)||L.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&S?O===1:!1))}async t(t,o,s,a,l,S){const{providerExtUri:y}=this.R(t),A={resource:o,name:y.basename(o),isFile:(s.type&v.FileType.File)!==0,isDirectory:(s.type&v.FileType.Directory)!==0,isSymbolicLink:(s.type&v.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&v.FilePermission.Readonly)||!!(t.capabilities&v.FileSystemProviderCapabilities.Readonly),locked:!!((s.permissions??0)&v.FilePermission.Locked),etag:(0,v.$Gl)({mtime:s.mtime,size:s.size}),children:void 0};if(A.isDirectory&&S(A,a)){try{const L=await t.readdir(o),D=await r.Promises.settled(L.map(async([O,M])=>{try{const Z=y.joinPath(o,O),q=l?await t.stat(Z):{type:M};return await this.t(t,Z,q,L.length,l,S)}catch(Z){return this.b.trace(Z),null}}));A.children=(0,n.$Gb)(D)}catch(L){this.b.trace(L),A.children=[]}return A}return A}async resolveAll(t){return r.Promises.settled(t.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(t){const o=await this.j(t),s=await o.stat(t);return this.t(o,t,s,void 0,!0,()=>!1)}async exists(t){const o=await this.j(t);try{return!!await o.stat(t)}catch{return!1}}async canCreateFile(t,o){try{await this.u(t,o)}catch(s){return s}return!0}async u(t,o){if(!o?.overwrite&&await this.exists(t))throw new v.$vl((0,g.localize)(11394,null,this.sb(t)),v.FileOperationResult.FILE_MODIFIED_SINCE,o)}async createFile(t,o=k.$Ne.fromString(""),s){await this.u(t,s);const a=await this.writeFile(t,o);return this.r.fire(new v.$sl(t,v.FileOperation.CREATE,a)),a}async writeFile(t,o,s){const a=this.qb(await this.n(t),t),{providerExtUri:l}=this.R(a);let S=s;if((0,v.$jl)(a)&&!S?.atomic){const y=a.enforceAtomicWriteFile?.(t);y&&(S={...s,atomic:y})}try{await this.w(a,t,S)||await this.U(a,l.dirname(t));let A;if((0,v.$dl)(a)&&!(o instanceof k.$Ne))if((0,f.$ze)(o)){const L=await(0,f.$Ge)(o,3);L.ended?A=k.$Ne.concat(L.buffer):A=L}else A=(0,f.$De)(o,L=>k.$Ne.concat(L),3);else A=o;!(0,v.$gl)(a)||(0,v.$dl)(a)&&A instanceof k.$Ne||(0,v.$dl)(a)&&(0,v.$jl)(a)&&S?.atomic?await this.hb(a,t,S,A):await this.db(a,t,S,A instanceof k.$Ne?(0,k.$Ye)(A):A),this.r.fire(new v.$sl(t,v.FileOperation.WRITE))}catch(y){throw new v.$vl((0,g.localize)(11395,null,this.sb(t),(0,v.$ol)(y).toString()),(0,v.$rl)(y),S)}return this.resolve(t,{resolveMetadata:!0})}async w(t,o,s){const a=!!s?.unlock;if(a&&!(t.capabilities&v.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,g.localize)(11396,null,this.sb(o)));if(!!s?.atomic){if(!(t.capabilities&v.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,g.localize)(11397,null,this.sb(o)));if(!(t.capabilities&v.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,g.localize)(11398,null,this.sb(o)));if(a)throw new Error((0,g.localize)(11399,null,this.sb(o)))}let S;try{S=await t.stat(o)}catch{return}if(S.type&v.FileType.Directory)throw new v.$vl((0,g.localize)(11400,null,this.sb(o)),v.FileOperationResult.FILE_IS_DIRECTORY,s);if(this.rb(o,S),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==v.$Fl&&typeof S.mtime=="number"&&typeof S.size=="number"&&s.mtime<S.mtime&&s.etag!==(0,v.$Gl)({mtime:s.mtime,size:S.size}))throw new v.$vl((0,g.localize)(11401,null),v.FileOperationResult.FILE_MODIFIED_SINCE,s);return S}async readFile(t,o,s){const a=await this.m(t);return o?.atomic?this.z(a,t,o,s):this.C(a,t,o,s)}async z(t,o,s,a){return new Promise((l,S)=>{this.cb.queueFor(o,async()=>{try{const y=await this.C(t,o,s,a);l(y)}catch(y){S(y)}},this.R(t).providerExtUri)})}async C(t,o,s,a){const l=await this.D(t,o,{...s,preferUnbuffered:!0},a);return{...l,value:await(0,k.$Ze)(l.value)}}async readFileStream(t,o,s){const a=await this.m(t);return this.D(a,t,o,s)}async D(t,o,s,a){const l=new R.$we(a);let S=s;(0,v.$il)(t)&&t.enforceAtomicReadFile?.(o)&&(S={...s,atomic:!0});const y=this.J(o,S).then(L=>L,L=>{throw l.dispose(!0),L});let A;try{return typeof S?.etag=="string"&&S.etag!==v.$Fl&&await y,S?.atomic&&(0,v.$il)(t)||!((0,v.$gl)(t)||(0,v.$hl)(t))||(0,v.$dl)(t)&&S?.preferUnbuffered?A=this.I(t,o,S):(0,v.$hl)(t)?A=this.G(t,o,l.token,S):A=this.H(t,o,l.token,S),A.on("end",()=>l.dispose()),A.on("error",()=>l.dispose()),{...await y,value:A}}catch(L){throw A&&await(0,f.$Ee)(A),this.F(L,o,S)}}F(t,o,s){const a=(0,g.localize)(11402,null,this.sb(o),(0,v.$ol)(t).toString());return t instanceof v.$xl?new v.$xl(a,t.stat,s):t instanceof v.$wl?new v.$wl(a,t.fileOperationResult,t.size,t.options):new v.$vl(a,(0,v.$rl)(t),s)}G(t,o,s,a=Object.create(null)){const l=t.readFileStream(o,a,s);return(0,f.$Ke)(l,{data:S=>S instanceof k.$Ne?S:k.$Ne.wrap(S),error:S=>this.F(S,o,a)},S=>k.$Ne.concat(S))}H(t,o,s,a=Object.create(null)){const l=(0,k.$4e)();return(0,b.$2q)(t,o,l,S=>S,{...a,bufferSize:this.a,errorTransformer:S=>this.F(S,o,a)},s),l}I(t,o,s){const a=(0,f.$Be)(l=>k.$Ne.concat(l));return(async()=>{try{let l;s?.atomic&&(0,v.$il)(t)?l=await t.readFile(o,{atomic:!0}):l=await t.readFile(o),typeof s?.position=="number"&&(l=l.slice(s.position)),typeof s?.length=="number"&&(l=l.slice(0,s.length)),this.L(o,l.byteLength,s),a.end(k.$Ne.wrap(l))}catch(l){a.error(l),a.end()}})(),a}async J(t,o){const s=await this.resolve(t,{resolveMetadata:!0});if(s.isDirectory)throw new v.$vl((0,g.localize)(11403,null,this.sb(t)),v.FileOperationResult.FILE_IS_DIRECTORY,o);if(typeof o?.etag=="string"&&o.etag!==v.$Fl&&o.etag===s.etag)throw new v.$xl((0,g.localize)(11404,null),s,o);return this.L(t,s.size,o),s}L(t,o,s){if(typeof s?.limits?.size=="number"&&o>s.limits.size)throw new v.$wl((0,g.localize)(11405,null,this.sb(t)),v.FileOperationResult.FILE_TOO_LARGE,o,s)}async canMove(t,o,s){return this.M(t,o,"move",s)}async canCopy(t,o,s){return this.M(t,o,"copy",s)}async M(t,o,s,a){if(t.toString()!==o.toString())try{const l=s==="move"?this.qb(await this.n(t),t):await this.m(t),S=this.qb(await this.n(o),o);await this.Q(l,t,S,o,s,a)}catch(l){return l}return!0}async move(t,o,s){const a=this.qb(await this.n(t),t),l=this.qb(await this.n(o),o),S=await this.N(a,t,l,o,"move",!!s),y=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new v.$sl(t,S==="move"?v.FileOperation.MOVE:v.FileOperation.COPY,y)),y}async copy(t,o,s){const a=await this.m(t),l=this.qb(await this.n(o),o),S=await this.N(a,t,l,o,"copy",!!s),y=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new v.$sl(t,S==="copy"?v.FileOperation.COPY:v.FileOperation.MOVE,y)),y}async N(t,o,s,a,l,S){if(o.toString()===a.toString())return l;const{exists:y,isSameResourceWithDifferentPathCase:A}=await this.Q(t,o,s,a,l,S);if(y&&!A&&S&&await this.del(a,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(a)),l==="copy"){if(t===s&&(0,v.$el)(t))await t.copy(o,a,{overwrite:S});else{const L=await this.resolve(o);L.isDirectory?await this.P(t,L,s,a):await this.O(t,o,s,a)}return l}else return t===s?(await t.rename(o,a,{overwrite:S}),l):(await this.N(t,o,s,a,"copy",S),await this.del(o,{recursive:!0}),"copy")}async O(t,o,s,a){if((0,v.$gl)(t)&&(0,v.$gl)(s))return this.jb(t,o,s,a);if((0,v.$gl)(t)&&(0,v.$dl)(s))return this.pb(t,o,s,a);if((0,v.$dl)(t)&&(0,v.$gl)(s))return this.nb(t,o,s,a);if((0,v.$dl)(t)&&(0,v.$dl)(s))return this.lb(t,o,s,a)}async P(t,o,s,a){await s.mkdir(a),Array.isArray(o.children)&&await r.Promises.settled(o.children.map(async l=>{const S=this.R(s).providerExtUri.joinPath(a,l.name);return l.isDirectory?this.P(t,await this.resolve(l.resource),s,S):this.O(t,l.resource,s,S)}))}async Q(t,o,s,a,l,S){let y=!1;if(t===s){const{providerExtUri:L,isPathCaseSensitive:D}=this.R(t);if(D||(y=L.isEqual(o,a)),y&&l==="copy")throw new Error((0,g.localize)(11406,null,this.sb(o),this.sb(a)));if(!y&&L.isEqualOrParent(a,o))throw new Error((0,g.localize)(11407,null,this.sb(o),this.sb(a)))}const A=await this.exists(a);if(A&&!y){if(!S)throw new v.$vl((0,g.localize)(11408,null,this.sb(o),this.sb(a)),v.FileOperationResult.FILE_MOVE_CONFLICT);if(t===s){const{providerExtUri:L}=this.R(t);if(L.isEqualOrParent(o,a))throw new Error((0,g.localize)(11409,null,this.sb(o),this.sb(a)))}}return{exists:A,isSameResourceWithDifferentPathCase:y}}R(t){const o=this.S(t);return{providerExtUri:o?w.$9g:w.$$g,isPathCaseSensitive:o}}S(t){return!!(t.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(t){const o=this.qb(await this.j(t),t);await this.U(o,t);const s=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new v.$sl(t,v.FileOperation.CREATE,s)),s}async U(t,o){const s=[],{providerExtUri:a}=this.R(t);for(;!a.isEqual(o,a.dirname(o));)try{if(!((await t.stat(o)).type&v.FileType.Directory))throw new Error((0,g.localize)(11410,null,this.sb(o)));break}catch(l){if((0,v.$ql)(l)!==v.FileSystemProviderErrorCode.FileNotFound)throw l;s.push(a.basename(o)),o=a.dirname(o)}for(let l=s.length-1;l>=0;l--){o=a.joinPath(o,s[l]);try{await t.mkdir(o)}catch(S){if((0,v.$ql)(S)!==v.FileSystemProviderErrorCode.FileExists)throw S}}}async canDelete(t,o){try{await this.W(t,o)}catch(s){return s}return!0}async W(t,o){const s=this.qb(await this.j(t),t),a=!!o?.useTrash;if(a&&!(s.capabilities&v.FileSystemProviderCapabilities.Trash))throw new Error((0,g.localize)(11411,null,this.sb(t)));const l=o?.atomic;if(l&&!(s.capabilities&v.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,g.localize)(11412,null,this.sb(t)));if(a&&l)throw new Error((0,g.localize)(11413,null,this.sb(t)));let S;try{S=await s.stat(t)}catch{}if(S)this.rb(t,S);else throw new v.$vl((0,g.localize)(11414,null,this.sb(t)),v.FileOperationResult.FILE_NOT_FOUND);if(!!!o?.recursive){const A=await this.resolve(t);if(A.isDirectory&&Array.isArray(A.children)&&A.children.length>0)throw new Error((0,g.localize)(11415,null,this.sb(t)))}return s}async del(t,o){const s=await this.W(t,o);let a=o;if((0,v.$kl)(s)&&!a?.atomic){const A=s.enforceAtomicDelete?.(t);A&&(a={...o,atomic:A})}const l=!!a?.useTrash,S=!!a?.recursive,y=a?.atomic??!1;await s.delete(t,{recursive:S,useTrash:l,atomic:y}),this.r.fire(new v.$sl(t,v.FileOperation.DELETE))}async cloneFile(t,o){const s=await this.j(t),a=this.qb(await this.n(o),o);if(!(s===a&&this.R(s).providerExtUri.isEqual(t,o)))return s===a&&(0,v.$fl)(s)?s.cloneFile(t,o):(await this.U(a,this.R(a).providerExtUri.dirname(o)),s===a&&(0,v.$el)(s)?this.cb.queueFor(t,()=>s.copy(t,o,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(t,()=>this.O(s,t,a,o),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(t,o){return this.watch(t,{...o,correlationId:E.ab++})}watch(t,o={recursive:!1,excludes:[]}){const s=new c.$Tc;let a=!1,l=()=>{a=!0};s.add((0,c.$Sc)(()=>l())),(async()=>{try{const y=await this.bb(t,o);a?(0,c.$Pc)(y):l=()=>(0,c.$Pc)(y)}catch(y){this.b.error(y)}})();const S=o.correlationId;if(typeof S=="number"){const y=s.add(new T.$le);return s.add(this.X.event(L=>{L.correlates(S)&&y.fire(L)})),{onDidChange:y.event,dispose:()=>s.dispose()}}return s}async bb(t,o){const s=await this.j(t),a=(0,I.$tj)([this.R(s).providerExtUri.getComparisonKey(t),o]);let l=this.$.get(a);return l||(l={count:0,disposable:s.watch(t,o)},this.$.set(a,l)),l.count+=1,(0,c.$Sc)(()=>{l&&(l.count--,l.count===0&&((0,c.$Pc)(l.disposable),this.$.delete(a)))})}dispose(){super.dispose();for(const[,t]of this.$)(0,c.$Pc)(t.disposable);this.$.clear()}async db(t,o,s,a){return this.cb.queueFor(o,async()=>{const l=await t.open(o,{create:!0,unlock:s?.unlock??!1});try{(0,f.$ze)(a)||(0,f.$Ae)(a)?await this.eb(t,l,a):await this.fb(t,l,a)}catch(S){throw(0,v.$ol)(S)}finally{await t.close(l)}},this.R(t).providerExtUri)}async eb(t,o,s){let a=0,l;if((0,f.$Ae)(s)){if(s.buffer.length>0){const S=k.$Ne.concat(s.buffer);await this.gb(t,o,S,S.byteLength,a,0),a+=S.byteLength}if(s.ended)return;l=s.stream}else l=s;return new Promise((S,y)=>{(0,f.$Fe)(l,{onData:async A=>{l.pause();try{await this.gb(t,o,A,A.byteLength,a,0)}catch(L){return y(L)}a+=A.byteLength,setTimeout(()=>l.resume())},onError:A=>y(A),onEnd:()=>S()})})}async fb(t,o,s){let a=0,l;for(;(l=s.read())!==null;)await this.gb(t,o,l,l.byteLength,a,0),a+=l.byteLength}async gb(t,o,s,a,l,S){let y=0;for(;y<a;){const A=await t.write(o,l+y,s.buffer,S+y,a-y);y+=A}}async hb(t,o,s,a){return this.cb.queueFor(o,()=>this.ib(t,o,s,a),this.R(t).providerExtUri)}async ib(t,o,s,a){let l;a instanceof k.$Ne?l=a:(0,f.$ze)(a)?l=await(0,k.$Ze)(a):(0,f.$Ae)(a)?l=await(0,k.$1e)(a):l=(0,k.$Xe)(a),await t.writeFile(o,l.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(t,o,s,a){return this.cb.queueFor(a,()=>this.kb(t,o,s,a),this.R(s).providerExtUri)}async kb(t,o,s,a){let l,S;try{l=await t.open(o,{create:!1}),S=await s.open(a,{create:!0,unlock:!1});const y=k.$Ne.alloc(this.a);let A=0,L=0,D=0;do D=await t.read(l,A,y.buffer,L,y.byteLength-L),await this.gb(s,S,y,D,A,L),A+=D,L+=D,L===y.byteLength&&(L=0);while(D>0)}catch(y){throw(0,v.$ol)(y)}finally{await r.Promises.settled([typeof l=="number"?t.close(l):Promise.resolve(),typeof S=="number"?s.close(S):Promise.resolve()])}}async lb(t,o,s,a){return this.cb.queueFor(a,()=>this.mb(t,o,s,a),this.R(s).providerExtUri)}async mb(t,o,s,a){return s.writeFile(a,await t.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(t,o,s,a){return this.cb.queueFor(a,()=>this.ob(t,o,s,a),this.R(s).providerExtUri)}async ob(t,o,s,a){const l=await s.open(a,{create:!0,unlock:!1});try{const S=await t.readFile(o);await this.gb(s,l,k.$Ne.wrap(S),S.byteLength,0,0)}catch(S){throw(0,v.$ol)(S)}finally{await s.close(l)}}async pb(t,o,s,a){const l=await(0,k.$Ze)(this.H(t,o,R.CancellationToken.None));await this.hb(s,a,void 0,l)}qb(t,o){if(t.capabilities&v.FileSystemProviderCapabilities.Readonly)throw new v.$vl((0,g.localize)(11416,null,this.sb(o)),v.FileOperationResult.FILE_PERMISSION_DENIED);return t}rb(t,o){if((o.permissions??0)&v.FilePermission.Readonly)throw new v.$vl((0,g.localize)(11417,null,this.sb(t)),v.FileOperationResult.FILE_PERMISSION_DENIED)}sb(t){return t.scheme===u.Schemas.file?t.fsPath:t.toString(!0)}};e.$3q=i,e.$3q=i=E=Se([se(0,$.$ak)],i)}),define(ce[99],le([0,1,26,8,31,17,4,32,2,9,3,18,67,23,10,14,124,188,184,183]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=void 0;class E extends b.$cr{static{this.L=!1}constructor(h,t){super(h,t),this.onDidChangeCapabilities=T.Event.None,this.P=new k.$Ac(o=>u.$0g.getComparisonKey(o)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=g.FileSystemProviderCapabilities.FileReadWrite|g.FileSystemProviderCapabilities.FileOpenReadWriteClose|g.FileSystemProviderCapabilities.FileReadStream|g.FileSystemProviderCapabilities.FileFolderCopy|g.FileSystemProviderCapabilities.FileWriteUnlock|g.FileSystemProviderCapabilities.FileAtomicRead|g.FileSystemProviderCapabilities.FileAtomicWrite|g.FileSystemProviderCapabilities.FileAtomicDelete|g.FileSystemProviderCapabilities.FileClone,m.$l&&(this.M|=g.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(h){try{const{stat:t,symbolicLink:o}=await w.SymlinkSupport.stat(this.I(h));return{type:this.O(t,o),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:g.FilePermission.Locked}}catch(t){throw this.hb(t)}}async N(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const t=await w.Promises.readdir(this.I(h),{withFileTypes:!0}),o=[];return await Promise.all(t.map(async s=>{try{let a;s.isSymbolicLink()?a=(await this.stat((0,u.$gh)(h,s.name))).type:a=this.O(s),o.push([s.name,a])}catch(a){this.a.trace(a)}})),o}catch(t){throw this.hb(t)}}O(h,t){let o;return t?.dangling?o=g.FileType.Unknown:h.isFile()?o=g.FileType.File:h.isDirectory()?o=g.FileType.Directory:o=g.FileType.Unknown,t&&(o|=g.FileType.SymbolicLink),o}async Q(h){const t=this.I(h);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let o;for(;o=this.P.get(h);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await o.wait();const s=new r.$Eh;return this.P.set(h,s),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,p.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.P.get(h)===s&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.P.delete(h)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),s.open()})}async readFile(h,t){let o;try{t?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(h)})`),o=await this.Q(h));const s=this.I(h);return await n.promises.readFile(s)}catch(s){throw this.hb(s)}finally{o?.dispose()}}R(h){E.L&&this.a.trace(h)}readFileStream(h,t,o){const s=(0,d.$Be)(a=>R.$Ne.concat(a.map(l=>R.$Ne.wrap(l))).buffer);return(0,v.$2q)(this,h,s,a=>a.buffer,{...t,bufferSize:256*1024},o),s}async writeFile(h,t,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.S(h)?this.U(h,(0,u.$gh)((0,u.$fh)(h),`${(0,u.$dh)(h)}${o.atomic.postfix}`),t,o):this.W(h,t,o)}async S(h){try{const t=this.I(h),{symbolicLink:o}=await w.SymlinkSupport.stat(t);if(o)return!1}catch{}return!0}async U(h,t,o,s){const a=new p.$Tc;try{a.add(await this.Q(h)),a.add(await this.Q(t)),await this.W(t,o,s,!0);try{await this.rename(t,h,{overwrite:!0})}catch(l){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}finally{a.dispose()}}async W(h,t,o,s){let a;try{const l=this.I(h);if(!o.create||!o.overwrite){if(await w.Promises.exists(l)){if(!o.overwrite)throw(0,g.$nl)((0,f.localize)(11375,null),g.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,g.$nl)((0,f.localize)(11376,null),g.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(h,{create:!0,unlock:o.unlock},s),await this.write(a,0,t,0,t.byteLength)}catch(l){throw await this.ib(h,l)}finally{typeof a=="number"&&await this.close(a)}}static{this.$=!0}static configureFlushOnWrite(h){E.$=h}async open(h,t,o){const s=this.I(h);let a;(0,g.$bl)(t)&&!o&&(a=await this.Q(h));let l;try{if((0,g.$bl)(t)&&t.unlock)try{const{stat:y}=await w.SymlinkSupport.stat(s);y.mode&128||await n.promises.chmod(s,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let S;if((0,g.$bl)(t)){if(m.$j)try{await n.promises.truncate(s,0),S="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}S||(S="w")}else S="r";l=await w.Promises.open(s,S)}catch(S){throw a?.dispose(),(0,g.$bl)(t)?await this.ib(h,S):this.hb(S)}if(this.X.set(l,0),(0,g.$bl)(t)&&this.Z.set(l,h),a){const S=this.Y.get(l);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${s})`),this.Y.set(l,a),S&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${s})`),S.dispose())}return l}async close(h){const t=this.Y.get(h);try{if(this.X.delete(h),this.Z.delete(h)&&E.$)try{await w.Promises.fdatasync(h)}catch(o){E.configureFlushOnWrite(!1),this.a.error(o)}return await w.Promises.close(h)}catch(o){throw this.hb(o)}finally{t&&(this.Y.get(h)===t&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.Y.delete(h)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),t.dispose())}}async read(h,t,o,s,a){const l=this.ab(h,t);let S=null;try{S=(await w.Promises.read(h,o,s,a,l)).bytesRead}catch(y){throw this.hb(y)}finally{this.bb(h,l,S)}return S}ab(h,t){return t===this.X.get(h)?null:t}bb(h,t,o){const s=this.X.get(h);typeof s=="number"&&(typeof t=="number"||(typeof o=="number"?this.X.set(h,s+o):this.X.delete(h)))}async write(h,t,o,s,a){return(0,r.$Zh)(()=>this.cb(h,t,o,s,a),100,3)}async cb(h,t,o,s,a){const l=this.ab(h,t);let S=null;try{S=(await w.Promises.write(h,o,s,a,l)).bytesWritten}catch(y){throw await this.ib(this.Z.get(h),y)}finally{this.bb(h,l,S)}return S}async mkdir(h){try{await n.promises.mkdir(this.I(h))}catch(t){throw this.hb(t)}}async delete(h,t){try{const o=this.I(h);if(t.recursive){let s;t?.atomic!==!1&&t.atomic.postfix&&(s=(0,c.$jc)((0,c.$mc)(o),`${(0,c.$nc)(o)}${t.atomic.postfix}`)),await w.Promises.rm(o,w.RimRafMode.MOVE,s)}else try{await n.promises.unlink(o)}catch(s){if(s.code==="EPERM"||s.code==="EISDIR"){let a=!1;try{const{stat:l,symbolicLink:S}=await w.SymlinkSupport.stat(o);a=l.isDirectory()&&!S}catch{}if(a)await n.promises.rmdir(o);else throw s}else throw s}}catch(o){throw this.hb(o)}}async rename(h,t,o){const s=this.I(h),a=this.I(t);if(s!==a)try{await this.db(h,t,"move",o.overwrite),await w.Promises.rename(s,a)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,f.localize)(11377,null,(0,c.$nc)(s),(0,c.$nc)((0,c.$mc)(a)),l.toString()))),this.hb(l)}}async copy(h,t,o){const s=this.I(h),a=this.I(t);if(s!==a)try{await this.db(h,t,"copy",o.overwrite),await w.Promises.copy(s,a,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,f.localize)(11378,null,(0,c.$nc)(s),(0,c.$nc)((0,c.$mc)(a)),l.toString()))),this.hb(l)}}async db(h,t,o,s){const a=this.I(h),l=this.I(t);let S=!1;if(!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive)||(S=(0,I.$Dg)(a,l,!0)),S){if(o==="copy")throw(0,g.$nl)((0,f.localize)(11379,null),g.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const A=await this.N(h);if(!A)throw(0,g.$nl)((0,f.localize)(11380,null),g.FileSystemProviderErrorCode.FileNotFound);const L=await this.N(t);if(L){if(!s)throw(0,g.$nl)((0,f.localize)(11381,null),g.FileSystemProviderErrorCode.FileExists);A.type&g.FileType.File&&L.type&g.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,t){return this.eb(h,t,!1)}async eb(h,t,o){const s=this.I(h),a=this.I(t),l=!!(this.capabilities&g.FileSystemProviderCapabilities.PathCaseSensitive);if((0,I.$Dg)(s,a,!l))return;const S=new p.$Tc;try{S.add(await this.Q(h)),S.add(await this.Q(t)),o&&await n.promises.mkdir((0,c.$mc)(a),{recursive:!0}),await n.promises.copyFile(s,a)}catch(y){if(y.code==="ENOENT"&&!o)return this.eb(h,t,!0);throw this.hb(y)}finally{S.dispose()}}t(h,t,o){return new $.$jr(s=>h(s),s=>t(s),o)}F(h,t,o){return new P.$sr(s=>h(s),s=>t(s),o)}hb(h){if(h instanceof g.$ml)return h;let t=h,o;switch(h.code){case"ENOENT":o=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=g.FileSystemProviderErrorCode.Unknown;break;default:o=g.FileSystemProviderErrorCode.Unknown}return(0,g.$nl)(t,o)}async ib(h,t){let o=this.hb(t);if(h&&o.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await w.SymlinkSupport.stat(this.I(h));s.mode&128||(o=(0,g.$nl)(t,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.a.trace(s)}return o}}e.$tr=E}),define(ce[190],le([0,1,4,99,2,17,67,22]),function(x,e,n,r,k,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=e.$4s=void 0;class p extends k.$Uc{constructor(u,d){super(),this.a=u,this.b=d,this.F=new Map,this.G=new Map}call(u,d,w){const f=this.c(u);switch(d){case"stat":return this.g(f,w[0]);case"readdir":return this.h(f,w[0]);case"open":return this.r(f,w[0],w[1]);case"close":return this.s(w[0]);case"read":return this.t(w[0],w[1],w[2]);case"readFile":return this.j(f,w[0],w[1]);case"write":return this.u(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.n(f,w[0],w[1],w[2]);case"rename":return this.z(f,w[0],w[1],w[2]);case"copy":return this.C(f,w[0],w[1],w[2]);case"cloneFile":return this.D(f,w[0],w[1]);case"mkdir":return this.w(f,w[0]);case"delete":return this.y(f,w[0],w[1]);case"watch":return this.I(f,w[0],w[1],w[2],w[3]);case"unwatch":return this.J(w[0],w[1])}throw new Error(`IPC Command ${d} not found`)}listen(u,d,w){const f=this.c(u);switch(d){case"fileChange":return this.H(f,w[0]);case"readFileStream":return this.m(f,w[0],w[1])}throw new Error(`Unknown event ${d}`)}g(u,d){const w=this.f(u,d,!0);return this.a.stat(w)}h(u,d){const w=this.f(u,d);return this.a.readdir(w)}async j(u,d,w){const f=this.f(u,d,!0),g=await this.a.readFile(f,w);return R.$Ne.wrap(g)}m(u,d,w){const f=this.f(u,d,!0),g=new I.$we,v=new n.$le({onDidRemoveLastListener:()=>{g.cancel()}}),b=this.a.readFileStream(f,w,g.token);return(0,T.$Fe)(b,{onData:$=>v.fire(R.$Ne.wrap($)),onError:$=>v.fire($),onEnd:()=>{v.fire("end"),v.dispose(),g.dispose()}}),v.event}n(u,d,w,f){const g=this.f(u,d);return this.a.writeFile(g,w.buffer,f)}r(u,d,w){const f=this.f(u,d,!0);return this.a.open(f,w)}s(u){return this.a.close(u)}async t(u,d,w){const f=R.$Ne.alloc(w),v=await this.a.read(u,d,f.buffer,0,w);return[f,v]}u(u,d,w,f,g){return this.a.write(u,d,w.buffer,f,g)}w(u,d){const w=this.f(u,d);return this.a.mkdir(w)}y(u,d,w){const f=this.f(u,d);return this.a.delete(f,w)}z(u,d,w,f){const g=this.f(u,d),v=this.f(u,w);return this.a.rename(g,v,f)}C(u,d,w,f){const g=this.f(u,d),v=this.f(u,w);return this.a.copy(g,v,f)}D(u,d,w){const f=this.f(u,d),g=this.f(u,w);return this.a.cloneFile(f,g)}H(u,d){const w=new n.$le({onWillAddFirstListener:()=>{this.F.set(d,this.L(u,w))},onDidRemoveLastListener:()=>{(0,k.$Pc)(this.F.get(d)),this.F.delete(d)}});return w.event}async I(u,d,w,f,g){const v=this.F.get(d);if(v){const b=this.f(u,f),$=v.watch(w,b,g);this.G.set(d+w,$)}}async J(u,d){const w=u+d,f=this.G.get(w);f&&((0,k.$Pc)(f),this.G.delete(w))}dispose(){super.dispose();for(const[,u]of this.G)u.dispose();this.G.clear();for(const[,u]of this.F)u.dispose();this.F.clear()}}e.$4s=p;class c extends k.$Uc{constructor(u,d,w,f){super(),this.c=u,this.f=w,this.g=f,this.a=new Map,this.b=this.B(new r.$tr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(d)}h(u){const d=this.B(new n.$le);this.B(d.event(w=>{u.fire(w.map(f=>({resource:this.c.transformOutgoingURI(f.resource),type:f.type,cId:f.cId})))})),this.B(this.b.onDidChangeFile(w=>d.fire(w))),this.B(this.b.onDidWatchError(w=>u.fire(w)))}j(u){}m(u){}watch(u,d,w){const f=this.m(this.g);return Array.isArray(f)&&(w.excludes=[...w.excludes,...f]),this.a.set(u,this.b.watch(d,w)),(0,k.$Sc)(()=>{(0,k.$Pc)(this.a.get(u)),this.a.delete(u)})}dispose(){for(const[,u]of this.a)u.dispose();this.a.clear(),super.dispose()}}e.$5s=c}),define(ce[191],le([0,1,13,10,3,7,14,9,190,151,55]),function(x,e,n,r,k,R,T,I,p,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0;class u extends p.$4s{constructor(f,g,v){super(f,g),this.M=v}c(f){return c.$Nn}f(f,g){return R.URI.revive(g)}async y(f,g,v){if(!v.useTrash)return super.y(f,g,v);const b=this.f(f,g),$=(0,I.$hc)(b.fsPath);try{await n.shell.trashItem($)}catch(P){throw(0,T.$nl)(k.$j?(0,r.localize)(11382,null,(0,I.$nc)($),(0,m.$qj)(P)):(0,r.localize)(11383,null,(0,I.$nc)($),(0,m.$qj)(P)),T.FileSystemProviderErrorCode.Unknown)}}L(f,g){return new d(f,g,this.b,this.M)}}e.$Fgc=u;class d extends p.$5s{watch(f,g,v){if(v.recursive)throw(0,T.$nl)("Recursive file watching is not supported from main process for performance reasons.",T.FileSystemProviderErrorCode.Unavailable);return super.watch(f,g,v)}}}),define(ce[192],le([0,1,5]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=void 0;class r extends n.$gk{constructor(R=n.$dk){super(),this.m=[],this.n=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(T=>{this.n?.setLevel(T)}))}set logger(R){this.n=R;for(const{level:T,message:I}of this.m)(0,n.log)(R,T,I);this.m=[]}g(R,T){this.n?(0,n.log)(this.n,R,T):this.getLevel()<=R&&this.m.push({level:R,message:T})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$kdc=r}),define(ce[193],le([0,1,7,4,5,2]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=e.$us=e.$ts=void 0;class T extends k.$lk{constructor(u,d,w,f,g){super(d,w,f),this.r=u,this.t=g,this.B(g.listen("onDidChangeLogLevel",u)(v=>{(0,k.$ck)(v)?super.setLogLevel(v):super.setLogLevel(n.URI.revive(v[0]),v[1])})),this.B(g.listen("onDidChangeVisibility",u)(([v,b])=>super.setVisibility(n.URI.revive(v),b))),this.B(g.listen("onDidChangeLoggers",u)(({added:v,removed:b})=>{for(const $ of v)super.registerLogger({...$,resource:n.URI.revive($.resource)});for(const $ of b)super.deregisterLogger($.resource)}))}createConsoleMainLogger(){return new k.$jk({log:(u,d)=>{this.t.call("consoleLog",[u,d])}})}registerLogger(u){super.registerLogger(u),this.t.call("registerLogger",[u,this.r])}deregisterLogger(u){super.deregisterLogger(u),this.t.call("deregisterLogger",[u,this.r])}setLogLevel(u,d){super.setLogLevel(u,d),this.t.call("setLogLevel",[u,d])}setVisibility(u,d){super.setVisibility(u,d),this.t.call("setVisibility",[this.n(u),d])}s(u,d,w){return new I(this.t,u,d,w,this.r)}static setLogLevel(u,d,w){return u.call("setLogLevel",[d,w])}}e.$ts=T;class I extends k.$gk{constructor(u,d,w,f,g){super(f?.logLevel==="always"),this.r=u,this.s=d,this.m=!1,this.n=[],this.setLevel(w),this.r.call("createLogger",[d,f,g]).then(()=>{this.u(this.n),this.m=!0})}g(u,d){const w=[[u,d]];this.m?this.u(w):this.n.push(...w)}u(u){this.r.call("log",[this.s,u])}}class p{constructor(u,d){this.a=u,this.b=d}listen(u,d){const w=this.b(u);switch(d){case"onDidChangeLoggers":return r.Event.map(this.a.onDidChangeLoggers,f=>({added:[...f.added].map(g=>this.c(g,w)),removed:[...f.removed].map(g=>this.c(g,w))}));case"onDidChangeVisibility":return r.Event.map(this.a.onDidChangeVisibility,f=>[w.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return r.Event.map(this.a.onDidChangeLogLevel,f=>(0,k.$ck)(f)?f:[w.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${d}`)}async call(u,d,w){const f=this.b(u);switch(d){case"setLogLevel":return(0,k.$ck)(w[0])?this.a.setLogLevel(w[0]):this.a.setLogLevel(n.URI.revive(f.transformIncoming(w[0][0])),w[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(g=>this.c(g,f)))}throw new Error(`Call not found: ${d}`)}c(u,d){return{...u,resource:d.transformOutgoingURI(u.resource)}}}e.$us=p;class c extends R.$Uc{constructor(u,d){super(),d.call("setLogLevel",[u.getLogLevel()]),this.B(u.onDidChangeLogLevel(w=>d.call("setLogLevel",[w]))),d.call("getRegisteredLoggers").then(w=>{for(const f of w)u.registerLogger({...f,resource:n.URI.revive(f.resource)})}),this.B(d.listen("onDidChangeVisibility")(([w,f])=>u.setVisibility(n.URI.revive(w),f))),this.B(d.listen("onDidChangeLoggers")(({added:w,removed:f})=>{for(const g of w)u.registerLogger({...g,resource:n.URI.revive(g.resource)});for(const g of f)u.deregisterLogger(g.resource)}))}}e.$vs=c}),define(ce[194],le([0,1,2,5]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KR=void 0;class k extends n.$Uc{constructor(T,I=[]){super(),this.a=new r.$kk([T,...I]),this.B(T.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...I){this.a.trace(T,...I)}debug(T,...I){this.a.debug(T,...I)}info(T,...I){this.a.info(T,...I)}warn(T,...I){this.a.warn(T,...I)}error(T,...I){this.a.error(T,...I)}flush(){this.a.flush()}}e.$KR=k}),define(ce[195],le([0,1,31,7,5]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0;class R{constructor(I){this.b=I,this.a=new n.$Ac}listen(I,p,c){switch(p){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${p}`)}async call(I,p,c){switch(p){case"createLogger":this.c(r.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(r.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,k.$ck)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(r.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(r.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:r.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(r.URI.revive(c[0]))}throw new Error(`Call not found: ${p}`)}c(I,p,c){this.a.set(I,this.b.createLogger(I,p,c))}d(I,p){let c=console.log;switch(I){case k.LogLevel.Error:c=console.error;break;case k.LogLevel.Warning:c=console.warn;break;case k.LogLevel.Info:c=console.info;break}c.call(console,...p)}e(I,p){const c=this.a.get(I);if(!c)throw new Error("Create the logger before logging");for(const[m,u]of p)(0,k.log)(c,m,u)}}e.$Dhc=R}),define(ce[196],le([0,1,14,5]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zR=void 0;var k;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(k||(k={}));async function R(c,m,u,d,w){try{const f=await new Promise((v,b)=>{x(["@vscode/spdlog"],v,b)}).then(Pe);f.setFlushOn(k.Trace);const g=await f.createAsyncRotatingLogger(c,m,u,d);return w?g.clearFormatters():g.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),g}catch(f){console.error(f)}return null}function T(c,m,u){switch(m){case r.LogLevel.Trace:c.trace(u);break;case r.LogLevel.Debug:c.debug(u);break;case r.LogLevel.Info:c.info(u);break;case r.LogLevel.Warning:c.warn(u);break;case r.LogLevel.Error:c.error(u);break;case r.LogLevel.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function I(c,m){switch(m){case r.LogLevel.Trace:c.setLevel(k.Trace);break;case r.LogLevel.Debug:c.setLevel(k.Debug);break;case r.LogLevel.Info:c.setLevel(k.Info);break;case r.LogLevel.Warning:c.setLevel(k.Warning);break;case r.LogLevel.Error:c.setLevel(k.Error);break;case r.LogLevel.Off:c.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class p extends r.$gk{constructor(m,u,d,w,f){super(),this.m=[],this.setLevel(f),this.n=this.s(m,u,d,w),this.B(this.onDidChangeLogLevel(g=>{this.r&&I(this.r,g)}))}async s(m,u,d,w){const f=d?6:1,g=30/f*n.$Il.MB,v=await R(m,u,g,f,w);if(v){this.r=v,I(this.r,this.getLevel());for(const{level:b,message:$}of this.m)T(this.r,b,$);this.m=[]}}g(m,u){this.r?T(this.r,m,u):this.getLevel()<=m&&this.m.push({level:m,message:u})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$zR=p}),define(ce[197],le([0,1,33,5,196]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AR=void 0;class R extends r.$lk{s(I,p,c){return new k.$zR((0,n.$2g)(),I.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,p)}}e.$AR=R}),define(ce[71],le([0,1,31,4,6,5,197]),function(x,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=e.$_fc=void 0,e.$_fc=(0,k.$Gi)(R.$bk);class I extends T.$AR{constructor(){super(...arguments),this.u=new n.$Ac}createLogger(c,m,u){u!==void 0&&this.u.set(this.n(c),u);try{return super.createLogger(c,m)}catch(d){throw this.u.delete(this.n(c)),d}}registerLogger(c,m){m!==void 0&&this.u.set(c.resource,m),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const m=[];for(const u of super.getRegisteredLoggers())c===this.u.get(u.resource)&&m.push(u);return m}getOnDidChangeLogLevelEvent(c){return r.Event.filter(this.onDidChangeLogLevel,m=>(0,R.$ck)(m)||this.w(m[0],c))}getOnDidChangeVisibilityEvent(c){return r.Event.filter(this.onDidChangeVisibility,([m])=>this.w(m,c))}getOnDidChangeLoggersEvent(c){return r.Event.filter(r.Event.map(this.onDidChangeLoggers,m=>({added:[...m.added].filter(d=>this.w(d.resource,c)),removed:[...m.removed].filter(d=>this.w(d.resource,c))})),m=>m.added.length>0||m.removed.length>0)}deregisterLoggers(c){for(const[m,u]of this.u)u===c&&this.deregisterLogger(m)}w(c,m){const u=this.u.get(c);return u===void 0||u===m}dispose(){super.dispose(),this.u.clear()}}e.$agc=I}),define(ce[198],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=n,e.$Ugc=r,e.$Vgc=k,e.$Wgc=R;function n(T){return T.submenu!==void 0}function r(T){return T.id==="vscode.menubar.separator"}function k(T){return T.uri!==void 0}function R(T){return!n(T)&&!r(T)&&!k(T)}}),define(ce[40],le([0,1,4,77,2,6]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=e.$to=void 0,e.$to=(0,R.$Fi)("policy");class T extends k.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$le),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const m=Object.keys(this.f).length;return this.f={...c,...this.f},m!==Object.keys(this.f).length&&await this.j(c),r.Iterable.reduce(this.g.entries(),(u,[d,w])=>({...u,[d]:w}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return r.Iterable.reduce(Object.entries(this.f),(c,[m,u])=>({...c,[m]:{definition:u,value:this.g.get(m)}}),{})}}e.$uo=T;class I{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$vo=I}),define(ce[199],le([0,1,8,4,77,11,14,5,40]),function(x,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=void 0;function c(u,d){const w=[];for(const f of new Set(k.Iterable.concat(u.keys(),d.keys())))u.get(f)!==d.get(f)&&w.push(f);return w}let m=class extends p.$uo{constructor(d,w,f){super(),this.m=d,this.n=w,this.s=f,this.c=this.B(new n.$Dh(500));const g=r.Event.filter(w.onDidFilesChange,v=>v.affects(d));this.B(w.watch(d)),this.B(g(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const w=await this.n.readFile(this.m),f=JSON.parse(w.value.toString());if(!(0,R.$gg)(f))throw new Error("Policy file isn't a JSON object");for(const g of Object.keys(f))this.f[g]&&d.set(g,f[g])}catch(w){w.fileOperationResult!==T.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",w)}return d}async w(){const d=await this.u(),w=c(this.g,d);this.g=d,w.length>0&&this.h.fire(w)}};e.$Whc=m,e.$Whc=m=Se([se(1,T.$al),se(2,I.$ak)],m)}),define(ce[200],le([0,1,4,2,40]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=e.$shc=void 0;class R{constructor(p){this.b=p,this.a=new r.$Tc}listen(p,c){switch(c){case"onDidChange":return n.Event.map(this.b.onDidChange,m=>m.reduce((u,d)=>({...u,[d]:this.b.getPolicyValue(d)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(p,c,m){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(m)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$shc=R;class T extends k.$uo{constructor(p,c){super(),this.a=c;for(const m in p){const{definition:u,value:d}=p[m];this.f[m]=u,d!==void 0&&this.g.set(m,d)}this.a.listen("onDidChange")(m=>{for(const u in m){const d=m[u];d===null?this.g.delete(u):this.g.set(u,d)}this.h.fire(Object.keys(m))})}async j(p){const c=await this.a.call("updatePolicyDefinitions",p);for(const m in c)this.g.set(m,c[m])}}e.$thc=T}),define(ce[201],le([0,1,40,8,2,5]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0;let T=class extends n.$uo{constructor(p,c){super(),this.m=p,this.n=c,this.a=new r.$zh,this.b=this.B(new k.$Vc)}async j(p){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(p).length} policy definitions`);const{createWatcher:c}=await new Promise((m,u)=>{x(["@vscode/policy-watcher"],m,u)}).then(Pe);await this.a.queue(()=>new Promise((m,u)=>{try{this.b.value=c(this.n,p,d=>{this.t(d),m()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),u(d)}}))}t(p){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(p)}`);for(const c in p){const m=p[c];m===void 0?this.g.delete(c):this.g.set(c,m)}this.h.fire(Object.keys(p))}};e.$Vhc=T,e.$Vhc=T=Se([se(0,R.$ak)],T)}),define(ce[72],le([0,1,36]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.context<"u"){const R=k.context.configuration();if(R)r=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:R.version})}}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(ce[28],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$tk=(0,n.$Fi)("productService"),e.$uk="vscode://schemas/vscode-product"}),define(ce[202],le([0,1,8,5]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=void 0;let k=class{constructor(T,I,p){this.a=T,this.b=I,this.c=p}async inspect(T){await this.d();const I=this.a.webContents.debugger;await I.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$Gh)(T);const p=await I.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),p.profile}async d(){const T=this.a.webContents.debugger;T.attach(),await T.sendCommand("Profiler.enable")}async e(){const T=this.a.webContents.debugger;await T.sendCommand("Profiler.disable"),T.detach()}};e.$Igc=k,e.$Igc=k=Se([se(2,r.$ak)],k)}),define(ce[73],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=void 0,e.$Ufc=(0,n.$Fi)("protocolMainService")}),define(ce[45],le([0,1,141,11]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,n=Pe(n),r=Pe(r);class k{constructor(){this.a=new Map}add(T,I){n.ok(r.$eg(T)),n.ok(r.$gg(I)),n.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,I)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$ro=new k}),define(ce[203],le([0,1,4,143,45]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0,k=Pe(k),e.$so={JSONContribution:"base.contributions.json"};function R(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class T{constructor(){this.b=new n.$le,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,m){this.a[R(c)]=m,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(c){const m=this.a[c];return m?(0,r.$8j)(m):void 0}hasSchemaContent(c){return!!this.a[c]}}const I=new T;k.$ro.add(e.$so.JSONContribution,I)}),define(ce[56],le([0,1,21,4,11,10,16,203,45]),function(x,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.ConfigurationScope=e.$wo=e.EditPresentationTypes=void 0,e.$Ho=g,e.$Io=v,e.$Jo=b,e.$Ko=P,e.$Lo=E,e.$Mo=i,e.$No=h,k=Pe(k),R=Pe(R);var c;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$wo={Configuration:"base.contributions.configuration"};var m;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m||(e.ConfigurationScope=m={})),e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do="vscode://schemas/settings/resourceLanguage",e.$Eo="vscode://schemas/settings/configurationDefaults";const u=p.$ro.as(I.$so.JSONContribution);class d{constructor(){this.a=[],this.i=new Set,this.j=new r.$le,this.onDidSchemaChange=this.j.event,this.k=new r.$le,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:R.localize(11611,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},u.registerSchema(e.$Do,this.h),this.z()}registerConfiguration(o,s=!0){this.registerConfigurations([o],s)}registerConfigurations(o,s=!0){const a=new Set;this.r(o,s,a),u.registerSchema(e.$Do,this.h),this.j.fire(),this.k.fire({properties:a})}deregisterConfigurations(o){const s=new Set;this.s(o,s),u.registerSchema(e.$Do,this.h),this.j.fire(),this.k.fire({properties:s})}updateConfigurations({add:o,remove:s}){const a=new Set;this.s(s,a),this.r(o,!1,a),u.registerSchema(e.$Do,this.h),this.j.fire(),this.k.fire({properties:a})}registerDefaultConfigurations(o){const s=new Set;this.l(o,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:!0})}l(o,s){this.a.push(...o);const a=[];for(const{overrides:l,source:S}of o)for(const y in l){s.add(y);const A=this.b.get(y)??this.b.set(y,{configurationDefaultOverrides:[]}).get(y),L=l[y];if(A.configurationDefaultOverrides.push({value:L,source:S}),e.$Go.test(y)){const D=this.o(y,L,S,A.configurationDefaultOverrideValue);if(!D)continue;A.configurationDefaultOverrideValue=D,this.n(y,D,S),a.push(...g(y))}else{const D=this.p(y,L,S,A.configurationDefaultOverrideValue);if(!D)continue;A.configurationDefaultOverrideValue=D;const O=this.e[y];O&&(this.A(y,O),this.w(y,O))}}this.q(a)}deregisterDefaultConfigurations(o){const s=new Set;this.m(o,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:!0})}m(o,s){for(const a of o){const l=this.a.indexOf(a);l!==-1&&this.a.splice(l,1)}for(const{overrides:a,source:l}of o)for(const S in a){const y=this.b.get(S);if(!y)continue;const A=y.configurationDefaultOverrides.findIndex(L=>l?L.source?.id===l.id:L.value===a[S]);if(A!==-1){if(y.configurationDefaultOverrides.splice(A,1),y.configurationDefaultOverrides.length===0&&this.b.delete(S),e.$Go.test(S)){let L;for(const D of y.configurationDefaultOverrides)L=this.o(S,D.value,D.source,L);L&&!k.$rg(L.value)?(y.configurationDefaultOverrideValue=L,this.n(S,L,l)):(this.b.delete(S),delete this.e[S],delete this.c.properties[S])}else{let L;for(const O of y.configurationDefaultOverrides)L=this.p(S,O.value,O.source,L);y.configurationDefaultOverrideValue=L;const D=this.e[S];D&&(this.A(S,D),this.w(S,D))}s.add(S)}}this.y()}n(o,s,a){const l={type:"object",default:s.value,description:R.localize(11612,null,(0,T.$jj)(o)),$ref:e.$Do,defaultDefaultValue:s.value,source:a,defaultValueSource:a};this.e[o]=l,this.c.properties[o]=l}o(o,s,a,l){const S=l?.value||{},y=l?.source??new Map;if(!(y instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const A of Object.keys(s)){const L=s[A];if(k.$gg(L)&&(k.$lg(S[A])||k.$gg(S[A]))){if(S[A]={...S[A]??{},...L},a)for(const O in L)y.set(`${A}.${O}`,a)}else S[A]=L,a?y.set(A,a):y.delete(A)}return{value:S,source:y}}p(o,s,a,l){const S=this.e[o],y=l?.value??S?.defaultDefaultValue;let A=a;if(k.$gg(s)&&(S!==void 0&&S.type==="object"||S===void 0&&(k.$lg(y)||k.$gg(y)))){if(A=l?.source??new Map,!(A instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const D in s)a&&A.set(`${o}.${D}`,a);s={...k.$gg(y)?y:{},...s}}return{value:s,source:A}}deltaConfiguration(o){let s=!1;const a=new Set;o.removedDefaults&&(this.m(o.removedDefaults,a),s=!0),o.addedDefaults&&(this.l(o.addedDefaults,a),s=!0),o.removedConfigurations&&this.s(o.removedConfigurations,a),o.addedConfigurations&&this.r(o.addedConfigurations,!1,a),this.j.fire(),this.k.fire({properties:a,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...o){this.j.fire()}registerOverrideIdentifiers(o){this.q(o),this.j.fire()}q(o){for(const s of o)this.i.add(s);this.y()}r(o,s,a){o.forEach(l=>{this.u(l,s,l.extensionInfo,l.restrictedProperties,void 0,a),this.d.push(l),this.v(l)})}s(o,s){const a=l=>{if(l.properties)for(const S in l.properties){s.add(S);const y=this.e[S];y?.policy?.name&&this.f.delete(y.policy.name),delete this.e[S],this.x(S,l.properties[S])}l.allOf?.forEach(S=>a(S))};for(const l of o){a(l);const S=this.d.indexOf(l);S!==-1&&this.d.splice(S,1)}}u(o,s=!0,a,l,S=m.WINDOW,y){S=k.$ng(o.scope)?S:o.scope;const A=o.properties;if(A)for(const D in A){const O=A[D];if(s&&P(D,O)){delete A[D];continue}if(O.source=a,O.defaultDefaultValue=A[D].default,this.A(D,O),e.$Go.test(D)?O.scope=void 0:(O.scope=k.$ng(O.scope)?S:O.scope,O.restricted=k.$ng(O.restricted)?!!l?.includes(D):O.restricted),A[D].hasOwnProperty("included")&&!A[D].included){this.g[D]=A[D],delete A[D];continue}else this.e[D]=A[D],A[D].policy?.name&&this.f.set(A[D].policy.name,D);!A[D].deprecationMessage&&A[D].markdownDeprecationMessage&&(A[D].deprecationMessage=A[D].markdownDeprecationMessage),y.add(D)}const L=o.allOf;if(L)for(const D of L)this.u(D,s,a,l,S,y)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const o=new Map;for(const[s,a]of this.b)a.configurationDefaultOverrideValue&&o.set(s,a.configurationDefaultOverrideValue);return o}v(o){const s=a=>{const l=a.properties;if(l)for(const y in l)this.w(y,l[y]);a.allOf?.forEach(s)};s(o)}w(o,s){switch(e.$xo.properties[o]=s,s.scope){case m.APPLICATION:e.$yo.properties[o]=s;break;case m.MACHINE:e.$zo.properties[o]=s;break;case m.MACHINE_OVERRIDABLE:e.$Ao.properties[o]=s;break;case m.WINDOW:e.$Bo.properties[o]=s;break;case m.RESOURCE:e.$Co.properties[o]=s;break;case m.LANGUAGE_OVERRIDABLE:e.$Co.properties[o]=s,this.h.properties[o]=s;break}}x(o,s){switch(delete e.$xo.properties[o],s.scope){case m.APPLICATION:delete e.$yo.properties[o];break;case m.MACHINE:delete e.$zo.properties[o];break;case m.MACHINE_OVERRIDABLE:delete e.$Ao.properties[o];break;case m.WINDOW:delete e.$Bo.properties[o];break;case m.RESOURCE:case m.LANGUAGE_OVERRIDABLE:delete e.$Co.properties[o],delete this.h.properties[o];break}}y(){for(const o of this.i.values()){const s=`[${o}]`,a={type:"object",description:R.localize(11613,null),errorMessage:R.localize(11614,null),$ref:e.$Do};this.A(s,a),e.$xo.properties[s]=a,e.$yo.properties[s]=a,e.$zo.properties[s]=a,e.$Ao.properties[s]=a,e.$Bo.properties[s]=a,e.$Co.properties[s]=a}}z(){const o={type:"object",description:R.localize(11615,null),errorMessage:R.localize(11616,null),$ref:e.$Do};e.$xo.patternProperties[e.$Fo]=o,e.$yo.patternProperties[e.$Fo]=o,e.$zo.patternProperties[e.$Fo]=o,e.$Ao.patternProperties[e.$Fo]=o,e.$Bo.patternProperties[e.$Fo]=o,e.$Co.patternProperties[e.$Fo]=o,this.j.fire()}A(o,s){const a=this.b.get(o)?.configurationDefaultOverrideValue;let l,S;a&&(!s.disallowConfigurationDefault||!a.source)&&(l=a.value,S=a.source),k.$lg(l)&&(l=s.defaultDefaultValue,S=void 0),k.$lg(l)&&(l=b(s.type)),s.default=l,s.defaultValueSource=S}}const w="\\[([^\\]]+)\\]",f=new RegExp(w,"g");e.$Fo=`^(${w})+$`,e.$Go=new RegExp(e.$Fo);function g(t){const o=[];if(e.$Go.test(t)){let s=f.exec(t);for(;s?.length;){const a=s[1].trim();a&&o.push(a),s=f.exec(t)}}return(0,n.$Lb)(o)}function v(t){return t.reduce((o,s)=>`${o}[${s}]`,"")}function b(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const $=new d;p.$ro.add(e.$wo.Configuration,$);function P(t,o){return t.trim()?e.$Go.test(t)?R.localize(11618,null,t):$.getConfigurationProperties()[t]!==void 0?R.localize(11619,null,t):o.policy?.name&&$.getPolicyConfigurations().get(o.policy?.name)!==void 0?R.localize(11620,null,t,o.policy?.name,$.getPolicyConfigurations().get(o.policy?.name)):null:R.localize(11617,null)}function E(){const t=[],o=$.getConfigurationProperties();for(const s of Object.keys(o))t.push([s,o[s].scope]);return t.push(["launch",m.RESOURCE]),t.push(["task",m.RESOURCE]),t}function i(t){const o={};for(const s of t){const a=s.properties;if(k.$gg(a))for(const l in a)o[l]=a[l];s.allOf&&Object.assign(o,i(s.allOf))}return o}function h(t){switch(t){case"application":return m.APPLICATION;case"machine":return m.MACHINE;case"resource":return m.RESOURCE;case"machine-overridable":return m.MACHINE_OVERRIDABLE;case"language-overridable":return m.LANGUAGE_OVERRIDABLE;default:return m.WINDOW}}}),define(ce[125],le([0,1,21,4,43,2,31,37,11,7,16,56,14,45]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0,e.$So=E,n=Pe(n),k=Pe(k),I=Pe(I),p=Pe(p);function f(o){return Object.isFrozen(o)?o:I.$fo(o)}class g{static createEmptyModel(s){return new g({},[],[],void 0,s)}constructor(s,a,l,S,y){this.b=s,this.c=a,this.d=l,this.raw=S,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(a=>{if(a instanceof g)return a;const l=new v("",this.f);return l.parseRaw(a),l.configurationModel});this.g=s.reduce((a,l)=>l===a?l:a.merge(l),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,m.$hj)(this.contents,s):this.contents}inspect(s,a){const l=this;return{get value(){return f(l.rawConfiguration.getValue(s))},get override(){return a?f(l.rawConfiguration.getOverrideValue(s,a)):void 0},get merged(){return f(a?l.rawConfiguration.override(a).getValue(s):l.rawConfiguration.getValue(s))},get overrides(){const S=[];for(const{contents:y,identifiers:A,keys:L}of l.rawConfiguration.overrides){const D=new g(y,L,[],void 0,l.f).getValue(s);D!==void 0&&S.push({identifiers:A,value:D})}return S.length?f(S):void 0}}}getOverrideValue(s,a){const l=this.j(a);return l?s?(0,m.$hj)(l,s):l:void 0}getKeysForOverrideIdentifier(s){const a=[];for(const l of this.overrides)l.identifiers.includes(s)&&a.push(...l.keys);return n.$Lb(a)}getAllOverrideIdentifiers(){const s=[];for(const a of this.overrides)s.push(...a.identifiers);return n.$Lb(s)}override(s){let a=this.a.get(s);return a||(a=this.h(s),this.a.set(s,a)),a}merge(...s){const a=I.$eo(this.contents),l=I.$eo(this.overrides),S=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const A of s)if(y.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.i(a,A.contents);for(const L of A.overrides){const[D]=l.filter(O=>n.$tb(O.identifiers,L.identifiers));D?(this.i(D.contents,L.contents),D.keys.push(...L.keys),D.keys=n.$Lb(D.keys)):l.push(I.$eo(L))}for(const L of A.keys)S.indexOf(L)===-1&&S.push(L)}return new g(a,S,l,y.every(A=>A instanceof g)?void 0:y,this.f)}h(s){const a=this.j(s);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const l={};for(const S of n.$Lb([...Object.keys(this.contents),...Object.keys(a)])){let y=this.contents[S];const A=a[S];A&&(typeof y=="object"&&typeof A=="object"?(y=I.$eo(y),this.i(y,A)):y=A),l[S]=y}return new g(l,this.keys,this.overrides,void 0,this.f)}i(s,a){for(const l of Object.keys(a)){if(l in s&&p.$gg(s[l])&&p.$gg(a[l])){this.i(s[l],a[l]);continue}s[l]=I.$eo(a[l])}}j(s){let a=null,l=null;const S=y=>{y&&(l?this.i(l,y):l=I.$eo(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===s?a=y.contents:y.identifiers.includes(s)&&S(y.contents);return S(a),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,a){this.k(s,a,!0)}setValue(s,a){this.k(s,a,!1)}removeValue(s){const a=this.keys.indexOf(s);a!==-1&&(this.keys.splice(a,1),(0,m.$gj)(this.contents,s),u.$Go.test(s)&&this.overrides.splice(this.overrides.findIndex(l=>n.$tb(l.identifiers,(0,u.$Ho)(s))),1))}k(s,a,l){if((0,m.$fj)(this.contents,s,a,S=>this.f.error(S)),l=l||this.keys.indexOf(s)===-1,l&&this.keys.push(s),u.$Go.test(s)){const S=(0,u.$Ho)(s),y={identifiers:S,keys:Object.keys(this.contents[s]),contents:(0,m.$ej)(this.contents[s],L=>this.f.error(L))},A=this.overrides.findIndex(L=>n.$tb(L.identifiers,S));A!==-1?this.overrides[A]=y:this.overrides.push(y)}}}e.$Oo=g;class v{constructor(s,a){this.f=s,this.g=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||g.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,a){if(!p.$ng(s)){const l=this.h(s);this.parseRaw(l,a)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,a){this.a=s;const{contents:l,keys:S,overrides:y,restricted:A,hasExcludedProperties:L}=this.i(s,a);this.b=new g(l,S,y,L?[s]:void 0,this.g),this.c=A||[]}h(s){let a={},l=null,S=[];const y=[],A=[];function L(O){Array.isArray(S)?S.push(O):l!==null&&(S[l]=O)}const D={onObjectBegin:()=>{const O={};L(O),y.push(S),S=O,l=null},onObjectProperty:O=>{l=O},onObjectEnd:()=>{S=y.pop()},onArrayBegin:()=>{const O=[];L(O),y.push(S),S=O,l=null},onArrayEnd:()=>{S=y.pop()},onLiteralValue:L,onError:(O,M,Z)=>{A.push({error:O,offset:M,length:Z})}};if(s)try{k.$6n(s,D),a=S[0]||{}}catch(O){this.g.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return a}i(s,a){const l=w.$ro.as(u.$wo.Configuration).getConfigurationProperties(),S=this.j(s,l,!0,a);s=S.raw;const y=(0,m.$ej)(s,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`)),A=Object.keys(s),L=this.l(s,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:y,keys:A,overrides:L,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(s,a,l,S){let y=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:y};const A={},L=[];for(const D in s)if(u.$Go.test(D)&&l){const O=this.j(s[D],a,!1,S);A[D]=O.raw,y=y||O.hasExcludedProperties,L.push(...O.restricted)}else{const O=a[D],M=O?typeof O.scope<"u"?O.scope:u.ConfigurationScope.WINDOW:void 0;O?.restricted&&L.push(D),!S.exclude?.includes(D)&&(S.include?.includes(D)||(M===void 0||S.scopes===void 0||S.scopes.includes(M))&&!(S.skipRestricted&&O?.restricted))?A[D]=s[D]:y=!0}return{raw:A,restricted:L,hasExcludedProperties:y}}l(s,a){const l=[];for(const S of Object.keys(s))if(u.$Go.test(S)){const y={};for(const A in s[S])y[A]=s[S][A];l.push({identifiers:(0,u.$Ho)(S),keys:Object.keys(y),contents:(0,m.$ej)(y,a)})}return l}}e.$Po=v;class b extends R.$Uc{constructor(s,a,l,S,y){super(),this.c=s,this.f=a,this.g=S,this.h=y,this.b=this.B(new r.$le),this.onDidChange=this.b.event,this.a=new v(this.c.toString(),y),this.B(this.g.watch(l.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(r.Event.any(r.Event.filter(this.g.onDidFilesChange,A=>A.contains(this.c)),r.Event.filter(this.g.onDidRunOperation,A=>(A.isOperation(d.FileOperation.CREATE)||A.isOperation(d.FileOperation.COPY)||A.isOperation(d.FileOperation.DELETE)||A.isOperation(d.FileOperation.WRITE))&&l.isEqual(A.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return g.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Qo=b;class ${constructor(s,a,l,S,y,A,L,D,O,M,Z,q,K){this.a=s,this.b=a,this.c=l,this.overrideIdentifiers=S,this.d=y,this.f=A,this.g=L,this.h=D,this.i=O,this.j=M,this.k=Z,this.l=q,this.m=K}get value(){return f(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class P{constructor(s,a,l,S,y,A,L,D,O,M){this.j=s,this.l=a,this.m=l,this.n=S,this.p=y,this.q=A,this.r=L,this.s=D,this.t=O,this.u=M,this.h=null,this.i=new T.$Ac,this.v=null}getValue(s,a,l){return this.w(s,a,l).getValue(s)}updateValue(s,a,l={}){let S;l.resource?(S=this.t.get(l.resource),S||(S=g.createEmptyModel(this.u),this.t.set(l.resource,S))):S=this.s,a===void 0?S.removeValue(s):S.setValue(s,a),l.resource||(this.h=null)}inspect(s,a,l){const S=this.w(s,a,l),y=this.A(a.resource,l),A=a.resource?this.t.get(a.resource)||this.s:this.s,L=new Set;for(const D of S.overrides)for(const O of D.identifiers)S.getOverrideValue(s,O)!==void 0&&L.add(O);return new $(s,a,S.getValue(s),L.size?[...L]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.q:void 0,y||void 0,A)}keys(s){const a=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,a){this.r.set(s,a),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,a){const l=[];if(!a){const{added:S,updated:y,removed:A}=h(this.j,s);a=[...S,...y,...A]}for(const S of a)for(const y of(0,u.$Ho)(S)){const A=this.j.getKeysForOverrideIdentifier(y),L=s.getKeysForOverrideIdentifier(y),D=[...L.filter(O=>A.indexOf(O)===-1),...A.filter(O=>L.indexOf(O)===-1),...A.filter(O=>!I.$io(this.j.override(y).getValue(O),s.override(y).getValue(O)))];l.push([y,D])}return this.updateDefaultConfiguration(s),{keys:a,overrides:l}}compareAndUpdatePolicyConfiguration(s){const{added:a,updated:l,removed:S}=h(this.l,s),y=[...a,...l,...S];return y.length&&this.updatePolicyConfiguration(s),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:a,updated:l,removed:S,overrides:y}=h(this.applicationConfiguration,s),A=[...a,...l,...S];return A.length&&this.updateApplicationConfiguration(s),{keys:A,overrides:y}}compareAndUpdateLocalUserConfiguration(s){const{added:a,updated:l,removed:S,overrides:y}=h(this.localUserConfiguration,s),A=[...a,...l,...S];return A.length&&this.updateLocalUserConfiguration(s),{keys:A,overrides:y}}compareAndUpdateRemoteUserConfiguration(s){const{added:a,updated:l,removed:S,overrides:y}=h(this.remoteUserConfiguration,s),A=[...a,...l,...S];return A.length&&this.updateRemoteUserConfiguration(s),{keys:A,overrides:y}}compareAndUpdateWorkspaceConfiguration(s){const{added:a,updated:l,removed:S,overrides:y}=h(this.workspaceConfiguration,s),A=[...a,...l,...S];return A.length&&this.updateWorkspaceConfiguration(s),{keys:A,overrides:y}}compareAndUpdateFolderConfiguration(s,a){const l=this.folderConfigurations.get(s),{added:S,updated:y,removed:A,overrides:L}=h(l,a),D=[...S,...y,...A];return(D.length||!l)&&this.updateFolderConfiguration(s,a),{keys:D,overrides:L}}compareAndDeleteFolderConfiguration(s){const a=this.folderConfigurations.get(s);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:l,updated:S,removed:y,overrides:A}=h(a,void 0);return{keys:[...l,...S,...y],overrides:A}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,a,l){let S=this.x(a,l);return a.overrideIdentifier&&(S=S.override(a.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(S=S.merge(this.l)),S}x({resource:s},a){let l=this.y();if(a&&s){const S=a.getFolder(s);S&&(l=this.z(S.uri)||l);const y=this.t.get(s);y&&(l=l.merge(y))}return l}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let a=this.i.get(s);if(!a){const l=this.y(),S=this.r.get(s);S?(a=l.merge(S),this.i.set(s,a)):a=l}return a}A(s,a){if(a&&s){const l=a.getFolder(s);if(l)return this.r.get(l.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,a)=>{const{contents:l,overrides:S,keys:y}=this.r.get(a);return s.push([a,{contents:l,overrides:S,keys:y}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(a=>s.add(a)),this.userConfiguration.keys.forEach(a=>s.add(a)),this.q.keys.forEach(a=>s.add(a)),this.r.forEach(a=>a.keys.forEach(l=>s.add(l))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.q.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.r.forEach(a=>a.getAllOverrideIdentifiers().forEach(l=>s.add(l))),[...s.values()]}D(s){const a=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.q.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.r.forEach(l=>l.getKeysForOverrideIdentifier(s).forEach(S=>a.add(S))),[...a.values()]}static parse(s,a){const l=this.E(s.defaults,a),S=this.E(s.policy,a),y=this.E(s.application,a),A=this.E(s.user,a),L=this.E(s.workspace,a),D=s.folders.reduce((O,M)=>(O.set(c.URI.revive(M[0]),this.E(M[1],a)),O),new T.$Ac);return new P(l,S,y,A,g.createEmptyModel(a),L,D,g.createEmptyModel(a),new T.$Ac,a)}static E(s,a){return new g(s.contents,s.keys,s.overrides,void 0,a)}}e.$Ro=P;function E(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,a=new Map;for(const S of o)S.keys.forEach(y=>s.add(y)),S.overrides.forEach(([y,A])=>{const L=(0,T.$xc)(a,y,new Set);A.forEach(D=>L.add(D))});const l=[];return a.forEach((S,y)=>l.push([y,[...S.values()]])),{keys:[...s.values()],overrides:l}}class i{constructor(s,a,l,S,y){this.change=s,this.f=a,this.g=l,this.h=S,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const A of s.keys)this.affectedKeys.add(A);for(const[,A]of s.overrides)for(const L of A)this.affectedKeys.add(L);this.d=this.a;for(const A of this.affectedKeys)this.d+=A+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=P.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,a){const l=this.a+s,S=this.d.indexOf(l);if(S<0)return!1;const y=S+l.length;if(y>=this.d.length)return!1;const A=this.d.charCodeAt(y);if(A!==this.b&&A!==this.c)return!1;if(a){const L=this.previousConfiguration?this.previousConfiguration.getValue(s,a,this.f?.workspace):void 0,D=this.g.getValue(s,a,this.h);return!I.$io(L,D)}return!0}}e.$To=i;function h(o,s){const{added:a,removed:l,updated:S}=t(s?.rawConfiguration,o?.rawConfiguration),y=[],A=o?.getAllOverrideIdentifiers()||[],L=s?.getAllOverrideIdentifiers()||[];if(s){const D=L.filter(O=>!A.includes(O));for(const O of D)y.push([O,s.getKeysForOverrideIdentifier(O)])}if(o){const D=A.filter(O=>!L.includes(O));for(const O of D)y.push([O,o.getKeysForOverrideIdentifier(O)])}if(s&&o){for(const D of A)if(L.includes(D)){const O=t({contents:o.getOverrideValue(void 0,D)||{},keys:o.getKeysForOverrideIdentifier(D)},{contents:s.getOverrideValue(void 0,D)||{},keys:s.getKeysForOverrideIdentifier(D)});y.push([D,[...O.added,...O.removed,...O.updated]])}}return{added:a,removed:l,updated:S,overrides:y}}function t(o,s){const a=o?s?o.keys.filter(y=>s.keys.indexOf(y)===-1):[...o.keys]:[],l=s?o?s.keys.filter(y=>o.keys.indexOf(y)===-1):[...s.keys]:[],S=[];if(o&&s){for(const y of s.keys)if(o.keys.indexOf(y)!==-1){const A=(0,m.$hj)(s.contents,y),L=(0,m.$hj)(o.contents,y);I.$io(A,L)||S.push(y)}}return{added:a,removed:l,updated:S}}}),define(ce[204],le([0,1,21,4,2,37,11,125,56,5,40,45]),function(x,e,n,r,k,R,T,I,p,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=void 0;class d extends k.$Uc{get configurationModel(){return this.b}constructor(v){super(),this.c=v,this.a=this.B(new r.$le),this.onDidChangeConfiguration=this.a.event,this.b=I.$Oo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(u.$ro.as(p.$wo.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:b})=>this.f(Array.from(v),b))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(v,b){this.j(v,u.$ro.as(p.$wo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:v})}g(){return{}}h(){this.b=I.$Oo.createEmptyModel(this.c);const v=u.$ro.as(p.$wo.Configuration).getConfigurationProperties();this.j(Object.keys(v),v)}j(v,b){const $=this.g();for(const P of v){const E=$[P],i=b[P];E!==void 0?this.b.setValue(P,E):i?this.b.setValue(P,i.default):this.b.removeValue(P)}}}e.$Uo=d;class w{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=I.$Oo.createEmptyModel(new c.$nk)}async initialize(){return this.configurationModel}}e.$Vo=w;let f=class extends k.$Uc{get configurationModel(){return this.b}constructor(v,b,$){super(),this.c=v,this.f=b,this.g=$,this.a=this.B(new r.$le),this.onDidChangeConfiguration=this.a.event,this.b=I.$Oo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(v=>this.j(v))),this.B(this.c.onDidChangeConfiguration(async({properties:v})=>this.m(await this.h(v),!0))),this.b}async h(v){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",v);const b={},$=[],P=u.$ro.as(p.$wo.Configuration).getConfigurationProperties();for(const E of v){const i=P[E];if(!i){$.push(E);continue}if(i.policy){if(i.type!=="string"&&i.type!=="number"){this.g.warn(`Policy ${i.policy.name} has unsupported type ${i.type}`);continue}$.push(E),b[i.policy.name]={type:i.type}}}return(0,T.$rg)(b)||await this.f.updatePolicyDefinitions(b),$}j(v){this.g.trace("PolicyConfiguration#onDidChangePolicies",v);const b=u.$ro.as(p.$wo.Configuration).getPolicyConfigurations(),$=(0,n.$Gb)(v.map(P=>b.get(P)));this.m($,!0)}m(v,b){this.g.trace("PolicyConfiguration#update",v);const $=u.$ro.as(p.$wo.Configuration).getConfigurationProperties(),P=[],E=this.b.isEmpty();for(const i of v){const h=$[i]?.policy?.name;if(h){const t=this.f.getPolicyValue(h);(E?t!==void 0:!(0,R.$io)(this.b.getValue(i),t))&&P.push([i,t])}else this.b.getValue(i)!==void 0&&P.push([i,void 0])}if(P.length){this.g.trace("PolicyConfiguration#changed",P);const i=this.b;this.b=I.$Oo.createEmptyModel(this.g);for(const h of i.keys)this.b.setValue(h,i.getValue(h));for(const[h,t]of P)t===void 0?this.b.removeValue(h):this.b.setValue(h,t);b&&this.a.fire(this.b)}}};e.$Wo=f,e.$Wo=f=Se([se(1,m.$to),se(2,c.$ak)],f)}),define(ce[205],le([0,1,21,8,17,4,43,107,2,31,37,3,18,16,125,56,204,14,40]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=void 0;class P extends p.$Uc{constructor(h,t,o,s){super(),this.m=h,this.n=s,this.h=this.B(new R.$le),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.$Uo(s)),this.c=o instanceof $.$vo?new v.$Vo:this.B(new v.$Wo(this.b,o,s)),this.f=this.B(new f.$Qo(this.m,{},d.$0g,t,s)),this.a=new f.$Ro(this.b.configurationModel,this.c.configurationModel,f.$Oo.createEmptyModel(s),f.$Oo.createEmptyModel(s),f.$Oo.createEmptyModel(s),f.$Oo.createEmptyModel(s),new c.$Ac,f.$Oo.createEmptyModel(s),new c.$Ac,s),this.j=new E(h,t,this),this.g=this.B(new r.$Rh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:a,properties:l})=>this.s(a,l))),this.B(this.c.onDidChangeConfiguration(a=>this.t(a))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,t,o]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new f.$Ro(h,t,f.$Oo.createEmptyModel(this.n),o,f.$Oo.createEmptyModel(this.n),f.$Oo.createEmptyModel(this.n),new c.$Ac,f.$Oo.createEmptyModel(this.n),new c.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(h,t){const o=typeof h=="string"?h:void 0,s=(0,w.$aj)(h)?h:(0,w.$aj)(t)?t:{};return this.a.getValue(o,s,void 0)}async updateValue(h,t,o,s,a){const l=(0,w.$bj)(o)?o:(0,w.$aj)(o)?{resource:o.resource,overrideIdentifiers:o.overrideIdentifier?[o.overrideIdentifier]:void 0}:void 0,S=l?s:o;if(S!==void 0&&S!==w.ConfigurationTarget.USER_LOCAL&&S!==w.ConfigurationTarget.USER)throw new Error(`Unable to write ${h} to target ${S}.`);l?.overrideIdentifiers&&(l.overrideIdentifiers=(0,n.$Lb)(l.overrideIdentifiers),l.overrideIdentifiers=l.overrideIdentifiers.length?l.overrideIdentifiers:void 0);const y=this.inspect(h,{resource:l?.resource,overrideIdentifier:l?.overrideIdentifiers?l.overrideIdentifiers[0]:void 0});if(y.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,m.$io)(t,y.defaultValue)&&(t=void 0),l?.overrideIdentifiers?.length&&l.overrideIdentifiers.length>1){const L=l.overrideIdentifiers.sort(),D=this.a.localUserConfiguration.overrides.find(O=>(0,n.$tb)([...O.identifiers].sort(),L));D&&(l.overrideIdentifiers=D.identifiers)}const A=l?.overrideIdentifiers?.length?[(0,g.$Io)(l.overrideIdentifiers),h]:[h];await this.j.write(A,t),await this.reloadConfiguration()}inspect(h,t={}){return this.a.inspect(h,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.r(h)}r(h){const t=this.a.toData(),o=this.a.compareAndUpdateLocalUserConfiguration(h);this.u(o,t,w.ConfigurationTarget.USER)}s(h,t){const o=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(h,t);this.u(s,o,w.ConfigurationTarget.DEFAULT)}t(h){const t=this.a.toData(),o=this.a.compareAndUpdatePolicyConfiguration(h);this.u(o,t,w.ConfigurationTarget.DEFAULT)}u(h,t,o){const s=new f.$To(h,{data:t},this.a,void 0,this.n);s.source=o,this.h.fire(s)}}e.$Xo=P;class E{constructor(h,t,o){this.b=h,this.c=t,this.d=o,this.a=new r.$Mh}write(h,t){return this.a.queue(()=>this.e(h,t))}async e(h,t){let o;try{o=(await this.c.readFile(this.b)).value.toString()}catch(l){if(l.fileOperationResult===b.FileOperationResult.FILE_NOT_FOUND)o="{}";else throw l}const s=[];if((0,T.$Yn)(o,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const a=this.f(o,h,t);o=(0,I.$do)(o,a),await this.c.writeFile(this.b,k.$Ne.fromString(o))}f(h,t,o){const{tabSize:s,insertSpaces:a,eol:l}=this.h;if(!t.length){const S=JSON.stringify(o,null,a?" ".repeat(s):"	");return[{content:S,length:S.length,offset:0}]}return(0,I.$ao)(h,t,o,{tabSize:s,insertSpaces:a,eol:l})}get h(){if(!this.g){let h=u.OS===u.OperatingSystem.Linux||u.OS===u.OperatingSystem.Macintosh?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(h=t),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ce[206],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=e.$Jhc=e.$Ihc=void 0,e.$Ihc="request",e.$Jhc="remoteResourceHandler";class n{async routeCall(k,R,T){if(R!==e.$Ihc)throw new Error(`Call not found: ${R}`);const I=T[0];if(I?.authority){const p=k.connections.find(c=>c.ctx===I.authority);if(p)return p}throw new Error("Caller not found")}routeEvent(k,R){throw new Error(`Event not found: ${R}`)}}e.$Khc=n}),define(ce[207],le([0,1,15,6]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.RemoteAuthorityResolverErrorCode=e.$Tl=e.$Sl=e.RemoteConnectionType=e.$Rl=void 0,e.$Vl=c,e.$Rl=(0,r.$Fi)("remoteAuthorityResolverService");var k;(function(m){m[m.WebSocket=0]="WebSocket",m[m.Managed=1]="Managed"})(k||(e.RemoteConnectionType=k={}));class R{constructor(u){this.id=u,this.type=k.Managed}toString(){return`Managed(${this.id})`}}e.$Sl=R;class T{constructor(u,d){this.host=u,this.port=d,this.type=k.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Tl=T;var I;(function(m){m.Unknown="Unknown",m.NotAvailable="NotAvailable",m.TemporarilyNotAvailable="TemporarilyNotAvailable",m.NoResolverFound="NoResolverFound",m.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class p extends n.$ab{static isNotAvailable(u){return u instanceof p&&u._code===I.NotAvailable}static isTemporarilyNotAvailable(u){return u instanceof p&&u._code===I.TemporarilyNotAvailable}static isNoResolverFound(u){return u instanceof p&&u._code===I.NoResolverFound}static isInvalidAuthority(u){return u instanceof p&&u._code===I.InvalidAuthority}static isHandled(u){return u instanceof p&&u.isHandled}constructor(u,d=I.Unknown,w){super(u),this._message=u,this._code=d,this._detail=w,this.isHandled=d===I.NotAvailable&&w===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Ul=p;function c(m){const u=m.indexOf("+");return u===-1?m:m.substring(0,u)}}),define(ce[208],le([0,1,8,17,22,15,4,2,12,70,66,33,117,207]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$1l=y,e.$2l=A,e.$3l=D,c=Pe(c);const f=30*1e3;var g;(function(re){re[re.Management=1]="Management",re[re.ExtensionHost=2]="ExtensionHost",re[re.Tunnel=3]="Tunnel"})(g||(e.ConnectionType=g={}));function v(re){switch(re){case g.Management:return"Management";case g.ExtensionHost:return"ExtensionHost";case g.Tunnel:return"Tunnel"}}function b(re){const J=new k.$we;return setTimeout(()=>J.cancel(),re),J.token}function $(re,J){if(re.isCancellationRequested||J.isCancellationRequested)return k.CancellationToken.Cancelled;const F=new k.$we;return re.onCancellationRequested(()=>F.cancel()),J.onCancellationRequested(()=>F.cancel()),F.token}class P{get didTimeout(){return this.c==="timedout"}constructor(J){this.c="pending",this.d=new I.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$yh)(),J.isCancellationRequested?this.h():this.d.add(J.onCancellationRequested(()=>this.h()))}registerDisposable(J){this.c==="pending"?this.d.add(J):J.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const J=new Error("Time limit reached");return J.code="ETIMEDOUT",J.syscall="connect",J}resolve(J){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(J))}reject(J){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(J))}}function E(re,J){const F=new P(J);return F.registerDisposable(re.onControlMessage(N=>{const _=JSON.parse(N.toString()),z=j(_);z?F.reject(z):F.resolve(_)})),F.promise}function i(re,J,F,N,_,z,ie,G){const U=new P(G),te=m.$fe.create(!1);return re.info(`Creating a socket (${ie})...`),c.mark(`code/willCreateSocket/${z}`),J.connect(F,N,_,ie).then(he=>{U.didTimeout?(c.mark(`code/didCreateSocketError/${z}`),re.info(`Creating a socket (${ie}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(c.mark(`code/didCreateSocketOK/${z}`),re.info(`Creating a socket (${ie}) was successful after ${te.elapsed()} ms.`),U.resolve(he))},he=>{c.mark(`code/didCreateSocketError/${z}`),re.info(`Creating a socket (${ie}) returned an error after ${te.elapsed()} ms.`),re.error(he),U.reject(he)}),U.promise}function h(re,J){const F=new P(J);return re.then(N=>{F.didTimeout||F.resolve(N)},N=>{F.didTimeout||F.reject(N)}),F.promise}async function t(re,J,F,N){const _=V(re,J);re.logService.trace(`${_} 1/6. invoking socketFactory.connect().`);let z;try{z=await i(re.logService,re.remoteSocketFactoryService,re.connectTo,p.$Sg.getServerRootPath(),`reconnectionToken=${re.reconnectionToken}&reconnection=${re.reconnectionProtocol?"true":"false"}`,v(J),`renderer-${v(J)}-${re.reconnectionToken}`,N)}catch(he){throw re.logService.error(`${_} socketFactory.connect() failed or timed out. Error:`),re.logService.error(he),he}re.logService.trace(`${_} 2/6. socketFactory.connect() was successful.`);let ie,G;re.reconnectionProtocol?(re.reconnectionProtocol.beginAcceptReconnection(z,null),ie=re.reconnectionProtocol,G=!1):(ie=new d.$ti({socket:z}),G=!0),re.logService.trace(`${_} 3/6. sending AuthRequest control message.`);const U=await h(re.signService.createNewMessage((0,u.$2g)()),N),te={type:"auth",auth:re.connectionToken||"00000000000000000000",data:U.data};ie.sendControl(r.$Ne.fromString(JSON.stringify(te)));try{const he=await E(ie,$(N,b(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(re.logService.trace(`${_} 4/6. received SignRequest control message.`),!await h(re.signService.validate(U,he.signedData),N)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const we=await h(re.signService.sign(he.data),N),Ie={type:"connectionType",commit:re.commit,signedData:we,desiredConnectionType:J};return F&&(Ie.args=F),re.logService.trace(`${_} 5/6. sending ConnectionTypeRequest control message.`),ie.sendControl(r.$Ne.fromString(JSON.stringify(Ie))),{protocol:ie,ownsProtocol:G}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(re.logService.error(`${_} the handshake timed out. Error:`),re.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(re.logService.error(`${_} received error control message when negotiating connection. Error:`),re.logService.error(he)),G&&W(ie),he}}async function o(re,J,F,N){const _=Date.now(),z=V(re,J),{protocol:ie,ownsProtocol:G}=await t(re,J,F,N),U=new P(N);return U.registerDisposable(ie.onControlMessage(te=>{const he=JSON.parse(te.toString()),me=j(he);me?(re.logService.error(`${z} received error control message when negotiating connection. Error:`),re.logService.error(me),G&&W(ie),U.reject(me)):(re.reconnectionProtocol?.endAcceptReconnection(),re.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${ue(_)}!`),U.resolve({protocol:ie,firstMessage:he}))})),U.promise}async function s(re,J){const{protocol:F}=await o(re,g.Management,void 0,J);return{protocol:F}}async function a(re,J,F){const{protocol:N,firstMessage:_}=await o(re,g.ExtensionHost,J,F),z=_&&_.debugPort;return{protocol:N,debugPort:z}}async function l(re,J,F){const N=Date.now(),_=V(re,g.Tunnel),{protocol:z}=await t(re,g.Tunnel,J,F);return re.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${ue(N)}!`),z}async function S(re,J,F){const{connectTo:N,connectionToken:_}=await re.addressProvider.getAddress();return{commit:re.commit,quality:re.quality,connectTo:N,connectionToken:_,reconnectionToken:J,reconnectionProtocol:F,remoteSocketFactoryService:re.remoteSocketFactoryService,signService:re.signService,logService:re.logService}}async function y(re,J,F){return L(re,async N=>{const{protocol:_}=await s(N,k.CancellationToken.None);return new B(re,J,F,N.reconnectionToken,_)})}async function A(re,J){return L(re,async F=>{const{protocol:N,debugPort:_}=await a(F,J,k.CancellationToken.None);return new Q(re,J,F.reconnectionToken,N,_)})}async function L(re,J){for(let N=1;;N++)try{const _=(0,u.$2g)(),z=await S(re,_,null);return await J(z)}catch(_){if(N<5)re.logService.error(`[remote-connection][attempt ${N}] An error occurred in initial connection! Will retry... Error:`),re.logService.error(_);else throw re.logService.error(`[remote-connection][attempt ${N}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),re.logService.error(_),Y.triggerPermanentFailure(0,0,w.$Ul.isHandled(_)),_}}async function D(re,J,F){const N=await S(re,(0,u.$2g)(),null);return await l(N,{host:J,port:F},k.CancellationToken.None)}function O(re){return(0,n.$sh)(J=>new Promise((F,N)=>{const _=setTimeout(F,re*1e3);J.onCancellationRequested(()=>{clearTimeout(_),F()})}))}var M;(function(re){re[re.ConnectionLost=0]="ConnectionLost",re[re.ReconnectionWait=1]="ReconnectionWait",re[re.ReconnectionRunning=2]="ReconnectionRunning",re[re.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",re[re.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class Z{constructor(J,F){this.reconnectionToken=J,this.millisSinceLastIncomingData=F,this.type=M.ConnectionLost}}e.$4l=Z;class q{constructor(J,F,N,_){this.reconnectionToken=J,this.millisSinceLastIncomingData=F,this.durationSeconds=N,this.c=_,this.type=M.ReconnectionWait}skipWait(){this.c.cancel()}}e.$5l=q;class K{constructor(J,F,N){this.reconnectionToken=J,this.millisSinceLastIncomingData=F,this.attempt=N,this.type=M.ReconnectionRunning}}e.$6l=K;class de{constructor(J,F,N){this.reconnectionToken=J,this.millisSinceLastIncomingData=F,this.attempt=N,this.type=M.ConnectionGain}}e.$7l=de;class H{constructor(J,F,N,_){this.reconnectionToken=J,this.millisSinceLastIncomingData=F,this.attempt=N,this.handled=_,this.type=M.ReconnectionPermanentFailure}}e.$8l=H;class Y extends I.$Uc{static triggerPermanentFailure(J,F,N){this._permanentFailure=!0,this.f=J,this.g=F,this.h=N,this.j.forEach(_=>_.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(J=>J.y())}static debugPauseSocketWriting(){this.j.forEach(J=>J.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||Y._permanentFailure}constructor(J,F,N,_,z){super(),this.t=J,this.u=F,this.reconnectionToken=N,this.protocol=_,this.w=z,this.m=this.B(new T.$le),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new de(this.reconnectionToken,0,0)),this.B(_.onSocketClose(ie=>{const G=oe(this.t,this.reconnectionToken,!0);ie?ie.type===d.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${G} received socket close event (hadError: ${ie.hadError}).`),ie.error&&this.u.logService.error(ie.error)):(this.u.logService.info(`${G} received socket close event (wasClean: ${ie.wasClean}, code: ${ie.code}, reason: ${ie.reason}).`),ie.event&&this.u.logService.error(ie.event)):this.u.logService.info(`${G} received socket close event.`),this.y()})),this.B(_.onSocketTimeout(ie=>{const G=oe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${G} received socket timeout event (unacknowledgedMsgCount: ${ie.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ie.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ie.timeSinceLastReceivedSomeData}).`),this.y()})),Y.j.push(this),this.B((0,I.$Sc)(()=>{const ie=Y.j.indexOf(this);ie>=0&&Y.j.splice(ie,1)})),this.n&&this.D(Y.f,Y.g,Y.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const J=oe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${J} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new Z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let N=-1;do{N++;const _=N<F.length?F[N]:F[F.length-1];try{if(_>0){const ie=O(_);this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_,ie)),this.u.logService.info(`${J} waiting for ${_} seconds before reconnecting...`);try{await ie}catch{}}if(this.n){this.u.logService.error(`${J} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1)),this.u.logService.info(`${J} resolving connection...`);const z=await S(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${J} connecting to ${z.connectTo}...`),await this.G(z,b(f)),this.u.logService.info(`${J} reconnected!`),this.m.fire(new de(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${J} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(N>360){this.u.logService.error(`${J} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(w.$Ul.isTemporarilyNotAvailable(z)){this.u.logService.info(`${J} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this.u.logService.info(`${J} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((0,R.$3)(z)){this.u.logService.info(`${J} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if(z instanceof w.$Ul){this.u.logService.error(`${J} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,w.$Ul.isHandled(z));break}this.u.logService.error(`${J} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}}while(!this.n&&!this.s)}C(J,F,N){this.w?Y.triggerPermanentFailure(J,F,N):this.D(J,F,N)}D(J,F,N){this.m.fire(new H(this.reconnectionToken,J,F,N)),W(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$9l=Y;class B extends Y{constructor(J,F,N,_,z){super(g.Management,J,_,z,!0),this.client=this.B(new d.$ri(z,{remoteAuthority:F,clientId:N},J.ipcLogger))}async G(J,F){await s(J,F)}}e.$0l=B;class Q extends Y{constructor(J,F,N,_,z){super(g.ExtensionHost,J,N,_,!1),this.H=F,this.debugPort=z}async G(J,F){await a(J,this.H,F)}}e.$$l=Q;function W(re){try{re.acceptDisconnect();const J=re.getSocket();re.dispose(),J.dispose()}catch(J){(0,R.$Y)(J)}}function j(re){if(re&&re.type==="error"){const J=new Error(`Connection error: ${re.reason}`);return J.code="VSCODE_CONNECTION_ERROR",J}return null}function C(re,J){for(;re.length<J;)re+=" ";return re}function X(re,J){return`[remote-connection][${C(v(re),13)}][${J.substr(0,5)}\u2026]`}function oe(re,J,F){return`${X(re,J)}[${F?"reconnect":"initial"}]`}function V(re,J){return`${oe(J,re.reconnectionToken,!!re.reconnectionProtocol)}[${re.connectTo}]`}function ue(re){return`${Date.now()-re} ms`}}),define(ce[74],le([0,1,12]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=r,e.$in=k,e.$jn=R,e.$kn=T;function r(p){return p.scheme===n.Schemas.vscodeRemote?p.authority:void 0}function k(p){if(!p)return;const c=p.indexOf("+");return c<0?p:p.substr(0,c)}function R(p){const{host:c,port:m}=I(p);if(typeof m>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:m}}function T(p,c){let{host:m,port:u}=I(p);return typeof u>"u"&&(u=c),{host:m,port:u}}function I(p){const c=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const m=p.match(/^(\[[0-9a-z:]+\])$/);if(m)return{host:m[1],port:void 0};const u=p.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:p,port:void 0}}}),define(ce[85],le([0,1,25,6,74]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$tn=e.$sn=e.$rn=e.TargetPlatform=e.ExtensionType=e.$qn=e.$on=e.$nn=e.$mn=e.$ln=void 0,e.$pn=R,e.$un=u,e.$vn=d,e.$wn=w,e.$xn=f,e.$yn=g,e.$zn=v,n=Pe(n),e.$ln="extensions.user.cache",e.$mn="extensions.builtin.cache",e.$nn="undefined_publisher",e.$on=["ui","workspace","web"];function R(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$qn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(T||(e.ExtensionType=T={}));var I;(function(b){b.WIN32_X64="win32-x64",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class p{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,P){if(typeof $>"u"||$===null)return typeof P>"u"||P===null;if(typeof P>"u"||P===null)return!1;if(typeof $=="string"||typeof P=="string"){const E=typeof $=="string"?$:$.value,i=typeof P=="string"?P:P.value;return n.$Ff(E,i)}return $._lower===P._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$rn=p;class c{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const P of $)this.add(P)}add($){this.c.add(p.toKey($))}delete($){return this.c.delete(p.toKey($))}has($){return this.c.has(p.toKey($))}}e.$sn=c;class m{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(p.toKey($))}get($){return this.c.get(p.toKey($))}has($){return this.c.has(p.toKey($))}set($,P){this.c.set(p.toKey($),P)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$tn=m;function u(b){return d(b)}function d(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}function w(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}function f(b,$){if($){const P=`onResolveRemoteAuthority:${(0,k.$in)($)}`;return!!b.activationEvents?.includes(P)}return!1}function g(b){return b.map($=>{const[P,E]=$.split("@");return{proposalName:P,version:E?parseInt(E):void 0}})}function v(b){return b.map($=>$.split("@")[0])}e.$An=(0,r.$Fi)("IBuiltinExtensionsScannerService")}),define(ce[126],le([0,1,3,10,85,6]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.ExtensionManagementErrorCode=e.$mp=e.ExtensionGalleryErrorCode=e.$lp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=void 0,e.$fp=I,e.$gp=p,e.$hp=c,e.$ip=m,e.$jp=u,e.$kp=d,e.$$o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$_o=new RegExp(e.$$o),e.$ap="__web_extension",e.$bp="skipWalkthrough",e.$cp="extensionInstallSource",e.$dp="dependecyOrPackExtensionInstall",e.$ep="clientTargetPlatform";var T;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function I(i){switch(i){case k.TargetPlatform.WIN32_X64:return"Windows 64 bit";case k.TargetPlatform.WIN32_ARM64:return"Windows ARM";case k.TargetPlatform.LINUX_X64:return"Linux 64 bit";case k.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case k.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case k.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case k.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case k.TargetPlatform.DARWIN_X64:return"Mac";case k.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case k.TargetPlatform.WEB:return"Web";case k.TargetPlatform.UNIVERSAL:return k.TargetPlatform.UNIVERSAL;case k.TargetPlatform.UNKNOWN:return k.TargetPlatform.UNKNOWN;case k.TargetPlatform.UNDEFINED:return k.TargetPlatform.UNDEFINED}}function p(i){switch(i){case k.TargetPlatform.WIN32_X64:return k.TargetPlatform.WIN32_X64;case k.TargetPlatform.WIN32_ARM64:return k.TargetPlatform.WIN32_ARM64;case k.TargetPlatform.LINUX_X64:return k.TargetPlatform.LINUX_X64;case k.TargetPlatform.LINUX_ARM64:return k.TargetPlatform.LINUX_ARM64;case k.TargetPlatform.LINUX_ARMHF:return k.TargetPlatform.LINUX_ARMHF;case k.TargetPlatform.ALPINE_X64:return k.TargetPlatform.ALPINE_X64;case k.TargetPlatform.ALPINE_ARM64:return k.TargetPlatform.ALPINE_ARM64;case k.TargetPlatform.DARWIN_X64:return k.TargetPlatform.DARWIN_X64;case k.TargetPlatform.DARWIN_ARM64:return k.TargetPlatform.DARWIN_ARM64;case k.TargetPlatform.WEB:return k.TargetPlatform.WEB;case k.TargetPlatform.UNIVERSAL:return k.TargetPlatform.UNIVERSAL;default:return k.TargetPlatform.UNKNOWN}}function c(i,h){switch(i){case n.Platform.Windows:return h==="x64"?k.TargetPlatform.WIN32_X64:h==="arm64"?k.TargetPlatform.WIN32_ARM64:k.TargetPlatform.UNKNOWN;case n.Platform.Linux:return h==="x64"?k.TargetPlatform.LINUX_X64:h==="arm64"?k.TargetPlatform.LINUX_ARM64:h==="arm"?k.TargetPlatform.LINUX_ARMHF:k.TargetPlatform.UNKNOWN;case"alpine":return h==="x64"?k.TargetPlatform.ALPINE_X64:h==="arm64"?k.TargetPlatform.ALPINE_ARM64:k.TargetPlatform.UNKNOWN;case n.Platform.Mac:return h==="x64"?k.TargetPlatform.DARWIN_X64:h==="arm64"?k.TargetPlatform.DARWIN_ARM64:k.TargetPlatform.UNKNOWN;case n.Platform.Web:return k.TargetPlatform.WEB}}function m(i,h){return h===k.TargetPlatform.WEB&&!i.includes(k.TargetPlatform.WEB)}function u(i,h,t){return m(h,t)?!1:i===k.TargetPlatform.UNDEFINED||i===k.TargetPlatform.UNIVERSAL?!0:i===k.TargetPlatform.UNKNOWN?!1:i===t}function d(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var w;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var f;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(f||(e.SortOrder=f={}));var g;(function(i){i.Install="install",i.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var v;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$lp=(0,R.$Fi)("extensionGalleryService");var b;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(b||(e.ExtensionGalleryErrorCode=b={}));class $ extends Error{constructor(h,t){super(h),this.code=t,this.name=t}}e.$mp=$;var P;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleApi="IncompatibleApi",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(P||(e.ExtensionManagementErrorCode=P={}));class E extends Error{constructor(h,t){super(h),this.code=t,this.name=t}}e.$np=E,e.$op=(0,R.$Fi)("extensionManagementService"),e.$pp="extensionsIdentifiers/disabled",e.$qp="extensionsIdentifiers/enabled",e.$rp=(0,R.$Fi)("IGlobalExtensionEnablementService"),e.$sp=(0,R.$Fi)("IExtensionTipsService"),e.$tp=(0,r.localize2)(11501,"Extensions"),e.$up=(0,r.localize2)(11502,"Preferences")});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[209],le([0,1,18,81,10,210,85,172]),function(x,e,n,r,k,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=m,e.$1p=u,e.$2p=d,e.$3p=w,e.$4p=f,e.$5p=g,e.$6p=v,e.$7p=b,r=Ve(r),k=Pe(k),R=Pe(R);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,c=/^-(\d{4})(\d{2})(\d{2})$/;function m(E){return E=E.trim(),E==="*"||p.test(E)}function u(E){if(!m(E))return null;if(E=E.trim(),E==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=E.match(p);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function d(E){if(!E)return null;const i=E.majorBase,h=E.majorMustEqual,t=E.minorBase;let o=E.minorMustEqual;const s=E.patchBase;let a=E.patchMustEqual;E.hasCaret&&(i===0||(o=!1),a=!1);let l=0;if(E.preRelease){const S=c.exec(E.preRelease);if(S){const[,y,A,L]=S;l=Date.UTC(Number(y),Number(A)-1,Number(L))}}return{majorBase:i,majorMustEqual:h,minorBase:t,minorMustEqual:o,patchBase:s,patchMustEqual:a,isMinimum:E.hasGreaterEquals,notBefore:l}}function w(E,i,h){let t;typeof E=="string"?t=d(u(E)):t=E;let o;i instanceof Date?o=i.getTime():typeof i=="string"&&(o=new Date(i).getTime());let s;if(typeof h=="string"?s=d(u(h)):s=h,!t||!s)return!1;const a=t.majorBase,l=t.minorBase,S=t.patchBase;let y=s.majorBase,A=s.minorBase,L=s.patchBase;const D=s.notBefore;let O=s.majorMustEqual,M=s.minorMustEqual,Z=s.patchMustEqual;return s.isMinimum?a>y?!0:a<y?!1:l>A?!0:l<A||o&&o<D?!1:S>=L:(a===1&&y===0&&(!O||!M||!Z)&&(y=1,A=0,L=0,O=!0,M=!1,Z=!1),a<y?!1:a>y?!O:l<A?!1:l>A?!M:S<L?!1:S>L?!Z:!(o&&o<D))}function f(E,i,h,t,o,s){const a=[];if(typeof t.publisher<"u"&&typeof t.publisher!="string")return a.push([r.default.Error,k.localize(11432,null)]),a;if(typeof t.name!="string")return a.push([r.default.Error,k.localize(11433,null,"name")]),a;if(typeof t.version!="string")return a.push([r.default.Error,k.localize(11434,null,"version")]),a;if(!t.engines)return a.push([r.default.Error,k.localize(11435,null,"engines")]),a;if(typeof t.engines.vscode!="string")return a.push([r.default.Error,k.localize(11436,null,"engines.vscode")]),a;if(typeof t.extensionDependencies<"u"&&!P(t.extensionDependencies))return a.push([r.default.Error,k.localize(11437,null,"extensionDependencies")]),a;if(typeof t.activationEvents<"u"){if(!P(t.activationEvents))return a.push([r.default.Error,k.localize(11438,null,"activationEvents")]),a;if(typeof t.main>"u"&&typeof t.browser>"u")return a.push([r.default.Error,k.localize(11439,null,"activationEvents","main","browser")]),a}if(typeof t.extensionKind<"u"&&typeof t.main>"u"&&a.push([r.default.Warning,k.localize(11440,null,"extensionKind")]),typeof t.main<"u"){if(typeof t.main!="string")return a.push([r.default.Error,k.localize(11441,null,"main")]),a;{const y=(0,n.$gh)(h,t.main);(0,n.$ah)(y,h)||a.push([r.default.Warning,k.localize(11442,null,y.path,h.path)])}}if(typeof t.browser<"u"){if(typeof t.browser!="string")return a.push([r.default.Error,k.localize(11443,null,"browser")]),a;{const y=(0,n.$gh)(h,t.browser);(0,n.$ah)(y,h)||a.push([r.default.Warning,k.localize(11444,null,y.path,h.path)])}}if(!R.valid(t.version))return a.push([r.default.Error,k.localize(11445,null)]),a;const l=[];if(!g(E,i,t,o,l))for(const y of l)a.push([r.default.Error,y]);if(s&&t.enabledApiProposals?.length){const y=[];if(!b([...t.enabledApiProposals],y))for(const A of y)a.push([r.default.Error,A])}return a}function g(E,i,h,t,o){return t||typeof h.main>"u"&&typeof h.browser>"u"?!0:$(E,i,h.engines.vscode,o)}function v(E,i,h){return E==="*"||$(i,h,E)}function b(E,i){if(E.length===0)return!0;const h=Array.isArray(i)?i:void 0,t=(h?void 0:i)??I.allApiProposals,o=[],s=(0,T.$yn)(E);for(const{proposalName:a,version:l}of s){const S=t[a];S&&l&&S.version!==l&&o.push(k.localize(11446,null,a))}return h?.push(...o),o.length===0}function $(E,i,h,t=[]){const o=d(u(h));if(!o)return t.push(k.localize(11447,null,h)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return t.push(k.localize(11448,null,h)),!1}else if(!o.majorMustEqual)return t.push(k.localize(11449,null,h)),!1;return w(E,i,o)?!0:(t.push(k.localize(11450,null,E,h)),!1)}function P(E){if(!Array.isArray(E))return!1;for(let i=0,h=E.length;i<h;i++)if(typeof E[i]!="string")return!1;return!0}}),define(ce[211],le([0,1,2,6]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=void 0,e.$Wl=(0,r.$Fi)("remoteSocketFactoryService");class k{constructor(){this.a={}}register(T,I){return this.a[T]??=[],this.a[T].push(I),(0,n.$Sc)(()=>{const p=this.a[T]?.indexOf(I);typeof p=="number"&&p>=0&&this.a[T]?.splice(p,1)})}b(T){return(this.a[T.type]||[]).find(p=>p.supports(T))}connect(T,I,p,c){const m=this.b(T);if(!m)throw new Error(`No socket factory found for ${T}`);return m.connect(T,I,p,c)}}e.$Xl=k}),define(ce[212],le([0,1,26,27,48,121]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=I,n=Pe(n),r=Pe(r),k=Pe(k),R=Pe(R);let T;async function I(w=!1){return(T===void 0||w)&&(T=p()),T}async function p(){const w=c();if(w===void 0)return!1;if(w>=22e3){const f=u();if(f)return new Promise(g=>{k.execFile(f,["--status"],v=>g(!v))})}else{const f=d();if(f)try{if((await n.promises.stat(f)).isFile())return!0}catch{}}return!1}function c(){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(r.release());if(w)return parseInt(w[3])}function m(w){const f=process.env.SystemRoot;if(f){const g=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(f,g?"Sysnative":"System32",w)}}function u(){return m("wsl.exe")}function d(){return m("lxss\\LxssManager.dll")}}),define(ce[49],le([0,1,17,15,2,10,56,6,5,45]),function(x,e,n,r,k,R,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=void 0,e.$0p=d,e.$$p=w,e.$_p=f,e.$aq=g,e.$bq=v,e.$cq=b,e.$8p=(0,I.$Fi)("requestService");class m{constructor(i){this.b=i}toJSON(){if(!this.a){const i=Object.create(null);for(const h in this.b)h.toLowerCase()==="authorization"||h.toLowerCase()==="proxy-authorization"?i[h]="*****":i[h]=this.b[h];this.a=i}return this.a}}class u extends k.$Uc{constructor(i){super(),this.b=0,this.a=i.createLogger("network",{name:(0,R.localize)(11219,null),when:p.$sk.isEqualTo((0,p.$pk)(p.LogLevel.Trace)).serialize()})}async c(i,h,t){const o=`${i} #${++this.b}: ${h.url}`;this.a.trace(`${o} - begin`,h.type,new m(h.headers??{}));try{const s=await t();return this.a.trace(`${o} - end`,h.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${o} - error`,h.type,(0,r.$9)(s)),s}}}e.$9p=u;function d(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}function w(E){return E.res.statusCode===204}async function f(E){return w(E)?null:(await(0,n.$Ze)(E.stream)).toString()}async function g(E){if(!d(E))throw new Error("Server returned "+E.res.statusCode);return f(E)}async function v(E){if(!d(E))throw new Error("Server returned "+E.res.statusCode);if(w(E))return null;const h=(await(0,n.$Ze)(E.stream)).toString();try{return JSON.parse(h)}catch(t){throw t.message+=`:
`+h,t}}function b(E){P(E)}let $;function P(E){const i=c.$ro.as(T.$wo.Configuration),h=$;$={id:"http",order:15,title:(0,R.localize)(11220,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(11221,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(11222,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(11223,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,R.localize)(11224,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(11225,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(11226,null),(0,R.localize)(11227,null),(0,R.localize)(11228,null),(0,R.localize)(11229,null)],default:"override",description:(0,R.localize)(11230,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11231,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(11232,null),restricted:!0}}},i.updateConfigurations({add:[$],remove:h?[h]:[]})}P(T.ConfigurationScope.APPLICATION)}),define(ce[213],le([0,1,17,22]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=e.$cs=void 0;class k{constructor(I){this.a=I}listen(I,p){throw new Error("Invalid listen")}call(I,p,c,m=r.CancellationToken.None){switch(p){case"request":return this.a.request(c[0],m).then(async({res:u,stream:d})=>{const w=await(0,n.$Ze)(d);return[{statusCode:u.statusCode,headers:u.headers},w]});case"resolveProxy":return this.a.resolveProxy(c[0]);case"lookupAuthorization":return this.a.lookupAuthorization(c[0]);case"lookupKerberosAuthorization":return this.a.lookupKerberosAuthorization(c[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$cs=k;class R{constructor(I){this.a=I}async request(I,p){const[c,m]=await this.a.call("request",[I],p);return{res:c,stream:(0,n.$2e)(m)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async lookupAuthorization(I){return this.a.call("lookupAuthorization",[I])}async lookupKerberosAuthorization(I){return this.a.call("lookupKerberosAuthorization",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$ds=R}),define(ce[214],le([0,1,215,11]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=R;function k(T,I){return T.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:T.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function R(T,I,p={}){const c=(0,n.parse)(T),m=p.proxyUrl||k(c,I);if(!m)return null;const u=(0,n.parse)(m);if(!/^https?:$/.test(u.protocol||""))return null;const d={host:u.hostname||"",port:(u.port?+u.port:0)||(u.protocol==="https"?443:80),auth:u.auth,rejectUnauthorized:(0,r.$kg)(p.strictSSL)?p.strictSSL:!0};if(c.protocol==="http:"){const w=await new Promise((f,g)=>{x(["http-proxy-agent"],f,g)}).then(Pe);return new w.HttpProxyAgent(m,d)}else{const w=await new Promise((f,g)=>{x(["https-proxy-agent"],f,g)}).then(Pe);return new w.HttpsProxyAgent(m,d)}}}),define(ce[216],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=e.$4gc=e.$3gc=void 0,e.$3gc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$4gc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$5gc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ce[100],le([0,1,48,9,10,22,55,15,3,33,116,68,8,144]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=g;let f;async function g(b,$,P,E){return P["force-disable-user-env"]?($.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.$j?($.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,u.$Km)(E)&&!P["force-user-env"]?($.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,u.$Km)(E)?$.trace("resolveShellEnv(): running (--force-user-env)"):$.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=d.Promises.withAsyncBody(async(i,h)=>{const t=new R.$we;let o=1e4;const s=b.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(o=(0,w.$Lm)(s,1,120)*1e3);const a=setTimeout(()=>{t.dispose(!0),h(new Error((0,k.localize)(11216,null)))},o);try{i(await v($,t.token))}catch(l){!(0,I.$3)(l)&&!t.token.isCancellationRequested?h(new Error((0,k.localize)(11217,null,(0,T.$qj)(l)))):i({})}finally{clearTimeout(a),t.dispose()}})),f)}async function v(b,$){const P=process.env.ELECTRON_RUN_AS_NODE;b.trace("getUnixShellEnvironment#runAsNode",P);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;b.trace("getUnixShellEnvironment#noAttach",E);const i=(0,c.$2g)().replace(/-/g,"").substr(0,12),h=new RegExp(i+"({.*})"+i),t={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};b.trace("getUnixShellEnvironment#env",t);const o=await(0,m.$Am)(p.OS,t);return b.trace("getUnixShellEnvironment#shell",o),new Promise((s,a)=>{if($.isCancellationRequested)return a(new I.$4);const l=(0,r.$nc)(o);let S,y;const A="";/^pwsh(-preview)?$/.test(l)?(S=`& '${process.execPath}' ${A} -p '''${i}'' + JSON.stringify(process.env) + ''${i}'''`,y=["-Login","-Command"]):l==="nu"?(S=`^'${process.execPath}' ${A} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,y=["-i","-l","-c"]):l==="xonsh"?(S=`import os, json; print("${i}", json.dumps(dict(os.environ)), "${i}")`,y=["-i","-l","-c"]):(S=`'${process.execPath}' ${A} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,l==="tcsh"||l==="csh"?y=["-ic"]:y=["-i","-l","-c"]),b.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),S);const L=(0,n.spawn)(o,[...y,S],{detached:!0,stdio:["ignore","pipe","pipe"],env:t});$.onCancellationRequested(()=>(L.kill(),a(new I.$4))),L.on("error",M=>{b.error("getUnixShellEnvironment#errorChildProcess",(0,T.$qj)(M)),a(M)});const D=[];L.stdout.on("data",M=>D.push(M));const O=[];L.stderr.on("data",M=>O.push(M)),L.on("close",(M,Z)=>{const q=Buffer.concat(D).toString("utf8");b.trace("getUnixShellEnvironment#raw",q);const K=Buffer.concat(O).toString("utf8");if(K.trim()&&b.trace("getUnixShellEnvironment#stderr",K),M||Z)return a(new Error((0,k.localize)(11218,null,M,Z)));const de=h.exec(q),H=de?de[1]:"{}";try{const Y=JSON.parse(H);P?Y.ELECTRON_RUN_AS_NODE=P:delete Y.ELECTRON_RUN_AS_NODE,E?Y.ELECTRON_NO_ATTACH_CONSOLE=E:delete Y.ELECTRON_NO_ATTACH_CONSOLE,delete Y.VSCODE_RESOLVING_ENVIRONMENT,delete Y.XDG_RUNTIME_DIR,b.trace("getUnixShellEnvironment#result",Y),s(Y)}catch(Y){b.error("getUnixShellEnvironment#errorCaught",(0,T.$qj)(Y)),a(Y)}})})}}),define(ce[217],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(k){try{const R=await this.c();if(R){const T=String(n.a++);return this.b.set(T,R),{id:T,data:R.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const T=this.b.get(k.id);if(!T)return!1;this.b.delete(k.id);try{return T.validate(R)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(k){try{return await this.d(k)}catch{}return k}}e.$Mcc=n}),define(ce[101],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.$Yl=void 0,e.$Yl="signService",e.$Zl=(0,n.$Fi)(e.$Yl)}),define(ce[218],le([0,1,217]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;class r extends n.$Mcc{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(T=>new T.signer().sign(R))}h(){return new Promise((R,T)=>x(["vsda"],R,T))}}e.$Uhc=r}),define(ce[34],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CR=e.$BR=void 0,e.$BR=(0,n.$Fi)("stateReadService"),e.$CR=(0,n.$Fi)("stateService")}),define(ce[127],le([0,1,8,17,2,11,38,14,5]),function(x,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FR=e.$ER=e.$DR=e.SaveStrategy=void 0;var c;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class m extends k.$Uc{constructor(f,g,v,b){super(),this.h=f,this.j=g,this.m=v,this.n=b,this.a=Object.create(null),this.b="",this.c=this.B(new n.$Dh(this.j===c.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(f){f.fileOperationResult!==I.FileOperationResult.FILE_NOT_FOUND&&this.m.error(f)}}getItem(f,g){const v=this.a[f];return(0,R.$ng)(v)?g:v}setItem(f,g){this.setItems([{key:f,data:g}])}setItems(f){let g=!1;for(const{key:v,data:b}of f)this.a[v]!==b&&((0,R.$ng)(b)?(0,R.$lg)(this.a[v])||(this.a[v]=void 0,g=!0):(this.a[v]=b,g=!0));g&&this.s()}removeItem(f){(0,R.$lg)(this.a[f])||(this.a[f]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const f=JSON.stringify(this.a,null,4);if(f!==this.b)try{await this.n.writeFile(this.h,r.$Ne.fromString(f),{atomic:{postfix:".vsctmp"}}),this.b=f}catch(g){this.m.error(g)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$DR=m;let u=class extends k.$Uc{constructor(f,g,v,b){super(),this.a=this.B(new m(g.stateResource,f,v,b))}async init(){await this.a.init()}getItem(f,g){return this.a.getItem(f,g)}};e.$ER=u,e.$ER=u=Se([se(1,T.$Mi),se(2,p.$ak),se(3,I.$al)],u);class d extends u{setItem(f,g){this.a.setItem(f,g)}setItems(f){this.a.setItems(f)}removeItem(f){this.a.removeItem(f)}close(){return this.a.close()}}e.$FR=d}),define(ce[128],le([0,1,3,36,33]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=T,e.$wp=I;function R(p){if(n.$v===n.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function T(p,c,m,u,d,w,f,g,v,b){const $=Object.create(null);$["common.machineId"]=w,$["common.sqmId"]=f,$["common.devDeviceId"]=g,$.sessionID=(0,k.$2g)()+Date.now(),$.commitHash=u,$.version=d,$["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,n.$i)(n.$v),$["common.nodePlatform"]=r.$dc,$["common.nodeArch"]=m,$["common.product"]=b||"desktop",v&&($["common.msftInternal"]=v);let P=0;const E=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-E,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),n.$m&&($["common.snap"]="true");const i=R(c);return i&&($["common.platformDetail"]=i),$}function I(p){const c=r.env.USERDNSDOMAIN;if(!c)return!1;const m=c.toLowerCase();return p.some(u=>m===u)}}),define(ce[24],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=void 0,e.$_l=(0,n.$Fi)("telemetryService"),e.$am=(0,n.$Fi)("customEndpointTelemetryService"),e.$bm="telemetry.currentSessionDate",e.$cm="telemetry.firstSessionDate",e.$dm="telemetry.lastSessionDate",e.$em="telemetry.machineId",e.$fm="telemetry.sqmId",e.$gm="telemetry.devDeviceId",e.$hm="telemetry",e.$im="telemetry.telemetryLevel",e.$jm="telemetry.enableCrashReporter",e.$km="telemetry.enableTelemetry";var r;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(r||(e.TelemetryLevel=r={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(ce[219],le([0,1,26,27,8,43,12,9,3,66,7,92,23,115,96,14,28,24]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=void 0,e.$Ys=P,e.$Zs=i,e.$1s=h,n=Pe(n),r=Pe(r);const $=new Map;async function P(o,s){const a=`${o}::${s.join(":")}`,l=$.get(a);if(l)return l;const S=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],y=new Map,A=new Map,L=2e4;function D(M,Z,q,K){const de=Z.substring(M.length+1);return k.Promises.withAsyncBody(async H=>{let Y;K.readdirCount++;try{Y=await d.Promises.readdir(Z,{withFileTypes:!0})}catch{H();return}if(K.count>=L){K.count+=Y.length,K.maxReached=!0,H();return}let B=Y.length;if(B===0){H();return}let Q=Y;K.count+Y.length>L&&(K.maxReached=!0,B=L-K.count,Q=Y.slice(0,B)),K.count+=Y.length;for(const W of Q)if(W.isDirectory()){if(q.includes(W.name)||await D(M,(0,I.$jc)(Z,W.name),q,K),--B===0){H();return}}else{const j=W.name.lastIndexOf(".");if(j>=0){const C=W.name.substring(j+1);C&&y.set(C,(y.get(C)??0)+1)}for(const C of S)C.relativePathPattern?.test(de)!==!1&&C.filePattern.test(W.name)&&A.set(C.tag,(A.get(C.tag)??0)+1);if(--B===0){H();return}}})}const O=k.Promises.withAsyncBody(async M=>{const Z={count:0,maxReached:!1,readdirCount:0},q=new c.$fe(!0);await D(o,o,s,Z);const K=await h(o);M({configFiles:E(A),fileTypes:E(y),fileCount:Z.count,maxFilesReached:Z.maxReached,launchConfigFiles:K,totalScanTime:q.elapsed(),totalReaddirCount:Z.readdirCount})});return $.set(a,O),O}function E(o){return Array.from(o.entries(),([s,a])=>({name:s,count:a})).sort((s,a)=>a.count-s.count)}function i(){const o={os:`${r.type()} ${r.arch()} ${r.release()}`,memory:`${(r.totalmem()/g.$Il.GB).toFixed(2)}GB (${(r.freemem()/g.$Il.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(u.$Sn.value()*100)}%`},s=r.cpus();return s&&s.length>0&&(o.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),o}async function h(o){try{const s=new Map,a=(0,I.$jc)(o,".vscode","launch.json"),l=await n.promises.readFile(a),S=[],y=(0,R.$Yn)(l.toString(),S);if(S.length)return console.log(`Unable to parse ${a}`),[];if((0,R.$7n)(y)==="object"&&y.configurations)for(const A of y.configurations){const L=A.type;L&&(s.has(L)?s.set(L,s.get(L)+1):s.set(L,1))}return E(s)}catch{return[]}}let t=class{constructor(s,a){this.c=s,this.d=a}f(s){const a=[];return a.push(`OS Version:       ${s.os}`),a.push(`CPUs:             ${s.cpus}`),a.push(`Memory (System):  ${s.memory}`),a.push(`VM:               ${s.vmHint}`),a.join(`
`)}g(s){const a=[];a.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),a.push(`OS Version:       ${r.type()} ${r.arch()} ${r.release()}`);const l=r.cpus();return l&&l.length>0&&a.push(`CPUs:             ${l[0].model} (${l.length} x ${l[0].speed})`),a.push(`Memory (System):  ${(r.totalmem()/g.$Il.GB).toFixed(2)}GB (${(r.freemem()/g.$Il.GB).toFixed(2)}GB free)`),p.$j||a.push(`Load (avg):       ${r.loadavg().map(S=>Math.round(S)).join(", ")}`),a.push(`VM:               ${Math.round(u.$Sn.value()*100)}%`),a.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${s.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.j(s.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(s,a){return Promise.all([(0,w.$Xs)(s.mainPID),this.k(s)]).then(async l=>{let[S,y]=l,A=this.m(s,S);return a.forEach(L=>{if((0,f.$Um)(L))A+=`
${L.errorMessage}`,y+=`
${L.errorMessage}`;else if(A+=`

Remote: ${L.hostName}`,L.processes&&(A+=`
${this.m(s,L.processes)}`),L.workspaceMetadata){y+=`
|  Remote: ${L.hostName}`;for(const D of Object.keys(L.workspaceMetadata)){const O=L.workspaceMetadata[D];let M=`${O.fileCount} files`;O.maxFilesReached&&(M=`more than ${M}`),y+=`|    Folder (${D}): ${M}`,y+=this.h(O)}}}),{processInfo:A,workspaceInfo:y}})}async getSystemInfo(s,a){const{memory:l,vmHint:S,os:y,cpus:A}=i(),L={os:y,memory:l,cpus:A,vmHint:S,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:a};return p.$j||(L.load=`${r.loadavg().map(D=>Math.round(D)).join(", ")}`),p.$l&&(L.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(L)}async getDiagnostics(s,a){const l=[];return(0,w.$Xs)(s.mainPID).then(async S=>(l.push(""),l.push(this.g(s)),l.push(""),l.push(this.m(s,S)),s.windows.some(y=>y.folderURIs&&y.folderURIs.length>0&&!y.remoteAuthority)&&(l.push(""),l.push("Workspace Stats: "),l.push(await this.k(s))),a.forEach(y=>{if((0,f.$Um)(y))l.push(`
${y.errorMessage}`);else if(l.push(`

`),l.push(`Remote:           ${y.hostName}`),l.push(this.f(y.machineInfo)),y.processes&&l.push(this.m(s,y.processes)),y.workspaceMetadata)for(const A of Object.keys(y.workspaceMetadata)){const L=y.workspaceMetadata[A];let D=`${L.fileCount} files`;L.maxFilesReached&&(D=`more than ${D}`),l.push(`Folder (${A}): ${D}`),l.push(this.h(L))}}),l.push(""),l.push(""),l.join(`
`)))}h(s){const a=[];let S=0;const y=(O,M)=>{const Z=` ${O}(${M})`;S+Z.length>60?(a.push(A),A="|                 ",S=A.length):S+=Z.length,A+=Z};let A="|      File types:";const L=10,D=s.fileTypes.length>L?L:s.fileTypes.length;for(let O=0;O<D;O++){const M=s.fileTypes[O];y(M.name,M.count)}if(a.push(A),s.configFiles.length>=0&&(A="|      Conf files:",S=0,s.configFiles.forEach(O=>{y(O.name,O.count)}),a.push(A)),s.launchConfigFiles.length>0){let O="|      Launch Configs:";s.launchConfigFiles.forEach(M=>{const Z=M.count>1?` ${M.name}(${M.count})`:` ${M.name}`;O+=Z}),a.push(O)}return a.join(`
`)}j(s){const a=Math.max(...Object.keys(s).map(l=>l.length));return Object.keys(s).map(l=>`${l}:  ${" ".repeat(a-l.length)}  ${s[l]}`).join(`
                  `)}k(s){const a=[],l=[];return s.windows.forEach(S=>{S.folderURIs.length===0||S.remoteAuthority||(a.push(`|  Window (${S.title})`),S.folderURIs.forEach(y=>{const A=m.URI.revive(y);if(A.scheme===T.Schemas.file){const L=A.fsPath;l.push(P(L,["node_modules",".git"]).then(D=>{let O=`${D.fileCount} files`;D.maxFilesReached&&(O=`more than ${O}`),a.push(`|    Folder (${(0,I.$nc)(L)}): ${O}`),a.push(this.h(D))}).catch(D=>{a.push(`|      Error: Unable to collect workspace stats for folder ${L} (${D.toString()})`)}))}else a.push(`|    Folder (${A.toString()}): Workspace stats not available.`)}))}),Promise.all(l).then(S=>a.join(`
`)).catch(S=>`Unable to collect workspace stats: ${S}`)}m(s,a){const l=new Map;s.windows.forEach(y=>l.set(y.pid,`window [${y.id}] (${y.title})`)),s.pidToNames.forEach(({pid:y,name:A})=>l.set(y,A));const S=[];return S.push("CPU %	Mem MB	   PID	Process"),a&&this.n(s.mainPID,l,S,a,0),S.join(`
`)}n(s,a,l,S,y){const A=y===0;let L;A?L=S.pid===s?`${this.d.applicationName} main`:"remote agent":a.has(S.pid)?L=a.get(S.pid):L=`${"  ".repeat(y)} ${S.name}`;const D=process.platform==="win32"?S.mem:r.totalmem()*(S.mem/100);l.push(`${S.load.toFixed(0).padStart(5," ")}	${(D/g.$Il.MB).toFixed(0).padStart(6," ")}	${S.pid.toFixed(0).padStart(6," ")}	${L}`),Array.isArray(S.children)&&S.children.forEach(O=>this.n(s,a,l,O,y+1))}async getWorkspaceFileExtensions(s){const a=new Set;for(const{uri:l}of s.folders){const S=m.URI.revive(l);if(S.scheme!==T.Schemas.file)continue;const y=S.fsPath;try{(await P(y,["node_modules",".git"])).fileTypes.forEach(L=>a.add(L.name))}catch{}}return{extensions:[...a]}}async reportWorkspaceStats(s){for(const{uri:a}of s.folders){const l=m.URI.revive(a);if(l.scheme!==T.Schemas.file)continue;const S=l.fsPath;try{const y=await P(S,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),y.fileTypes.forEach(A=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:A.name,count:A.count})}),y.launchConfigFiles.forEach(A=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:A.name,count:A.count})}),y.configFiles.forEach(A=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:A.name,count:A.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:y.totalScanTime,reachedLimit:y.maxFilesReached,fileCount:y.fileCount,readdirCount:y.totalReaddirCount})}catch{}}}};e.$2s=t,e.$2s=t=Se([se(0,b.$_l),se(1,v.$tk)],t)}),define(ce[220],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=e.$8gc=void 0;class n{constructor(R){this.b=R}listen(R,T){throw new Error(`Event not found: ${T}`)}call(R,T,{eventName:I,data:p}){return this.b.forEach(c=>c.log(I,p)),Promise.resolve(null)}}e.$8gc=n;class r{constructor(R){this.b=R}log(R,T){return this.b.call("log",{eventName:R,data:T}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$9gc=r}),define(ce[57],le([0,1,37,11,74,128,24]),function(x,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=void 0,e.$Ep=m,e.$Fp=u,e.$Gp=d,e.$Hp=w,e.$Ip=g,e.$Jp=b,e.$Kp=$,e.$Lp=i;class I{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$xp=I;class p{constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$yp=p,e.$zp=new p;class c{async publicLog(t,o,s){}async publicLogError(t,o,s){}}e.$Ap=c,e.$Bp="telemetry",e.$Cp="extensionTelemetryLog",e.$Dp={log:()=>null,flush:()=>Promise.resolve(null)};function m(h,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!h.enableTelemetry)}function u(h,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||h.enableTelemetry&&h.aiConfig?.ariaKey)}function d(h){const t=h.getValue(T.$im),o=h.getValue(T.$jm);if(h.getValue(T.$km)===!1||o===!1)return T.TelemetryLevel.NONE;switch(t??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function w(h){const t={},o={},s={};v(h,s);for(let a in s){a=a.length>150?a.substr(a.length-149):a;const l=s[a];typeof l=="number"?o[a]=l:typeof l=="boolean"?o[a]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${l.length}`),t[a]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(t[a]=l)}return{properties:t,measurements:o}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function g(h){if(!h)return"none";const t=(0,k.$in)(h);return f.has(t)?t:"other"}function v(h,t,o=0,s){if(h)for(const a of Object.getOwnPropertyNames(h)){const l=h[a],S=s?s+a:a;Array.isArray(l)?t[S]=(0,n.$jo)(l):l instanceof Date?t[S]=l.toISOString():(0,r.$gg)(l)?o<2?v(l,t,o+1,S+"."):t[S]=(0,n.$jo)(l):t[S]=l}}function b(h,t){const o=h.msftInternalDomains||[],s=t.getValue("telemetry.internalTesting");return(0,R.$wp)(o)||s}function $(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}function P(h,t){if(!h||!h.includes("/")&&!h.includes("\\"))return h;let o=h;const s=[];for(const y of t)for(;;){const A=y.exec(h);if(!A)break;s.push([A.index,y.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(o="";;){const y=l.exec(h);if(!y)break;const A=s.some(([L,D])=>y.index<D&&L<l.lastIndex);!a.test(y[0])&&!A&&(o+=h.substring(S,y.index)+"<REDACTED: user-file-path>",S=l.lastIndex)}return S<h.length&&(o+=h.substr(S)),o}function E(h){if(!h)return h;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of t)if(o.regex.test(h))return`<REDACTED: ${o.label}>`;return h}function i(h,t){return(0,n.$go)(h,o=>{if(o instanceof I||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let s=o.replaceAll("%20"," ");s=P(s,t);for(const a of t)s=s.replace(a,"");return s=E(s),s}})}}),define(ce[129],le([0,1,25,126,85,3,7,15,36,57]),function(x,e,n,r,k,R,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Np=void 0,e.$Mp=m,e.$Op=f,e.$Pp=g,e.$Qp=v,e.$Rp=b,e.$Sp=$,e.$Tp=P,e.$Up=E,e.$Wp=i,e.$Xp=t;function m(o,s){return o.uuid&&s.uuid?o.uuid===s.uuid:o.id===s.id?!0:(0,n.$Af)(o.id,s.id)===0}const u=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(s){const a=s.manifest?s.manifest.version:s.version,l=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new d(s.identifier,a,l)}static parse(s){const a=u.exec(s);return a&&a[1]&&a[2]?new d({id:a[1]},a[2],a[4]||void 0):null}constructor(s,a,l=k.TargetPlatform.UNDEFINED){this.identifier=s,this.version=a,this.targetPlatform=l,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==k.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof d?m(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$Np=d;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(o){const s=w.exec(o);return s&&s[1]?[v(s[1]),s[2]]:[v(o),void 0]}function g(o,s){return`${o}.${s}`}function v(o){return o.toLowerCase()}function b(o,s){return v(g(o??k.$nn,s))}function $(o,s){const a=[],l=S=>{for(const y of a)if(y.some(A=>m(s(A),s(S))))return y;return null};for(const S of o){const y=l(S);y?y.push(S):a.push([S])}return a}function P(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}function E(o){return{id:new c.$xp(o.identifier.id),name:new c.$xp(o.name),version:o.version,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Vp=new k.$rn("pprice.better-merge");function i(o,s){const a=[],l=s.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const S=l.shift();if(S&&a.every(y=>!m(y.identifier,{id:S}))){const y=o.filter(A=>m(A.identifier,{id:S}));y.length===1&&(a.push(y[0]),l.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}async function h(o,s){if(!R.$l)return!1;let a;try{a=(await o.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await o.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){s.debug("Error while getting the os-release file.",(0,I.$9)(S))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function t(o,s){const a=await h(o,s),l=(0,r.$hp)(a?"alpine":R.$v,p.$ec);return s.debug("ComputeTargetPlatform:",l),l}});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[221],le([0,1,2,37,3,25,10,16,56,72,28,45,24,57]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=void 0,c=Ve(c);let f=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(b,$,P){this.k=$,this.l=P,this.d={},this.i=new n.$Tc,this.j=[],this.b=b.appenders,this.c=b.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=b.piiPaths||[],this.g=d.TelemetryLevel.USAGE,this.h=!!b.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,R.$hf)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.$hf)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(d.$im)||E.affectsConfiguration(d.$km)||E.affectsConfiguration(d.$jm))&&this.m()}))}setExperimentProperty(b,$){this.d[b]=$}m(){let b=(0,w.$Gp)(this.k);const $=this.l.enabledTelemetryLevels;if($){this.h=this.sendErrorTelemetry?$.error:!1;const P=$.usage?d.TelemetryLevel.USAGE:$.error?d.TelemetryLevel.ERROR:d.TelemetryLevel.NONE;b=Math.min(b,P)}this.g=b}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(b,$,P){this.g<$||(P=(0,r.$ho)(P,this.d),P=(0,w.$Lp)(P,this.j),P=(0,r.$ho)(P,this.c),this.b.forEach(E=>E.log(b,P)))}publicLog(b,$){this.n(b,d.TelemetryLevel.USAGE,$)}publicLog2(b,$){this.publicLog(b,$)}publicLogError(b,$){this.h&&this.n(b,d.TelemetryLevel.ERROR,$)}publicLogError2(b,$){this.publicLogError(b,$)}};e.$hs=f,e.$hs=f=Se([se(1,I.$_i),se(2,m.$tk)],f);function g(){const v=(0,T.localize)(11197,null,c.default.nameLong),b=c.default.privacyStatementUrl?(0,T.localize)(11199,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,T.localize)(11198,null,"https://aka.ms/vscode-telemetry"),$=k.$p?"":(0,T.localize)(11200,null),P=(0,T.localize)(11201,null),E=(0,T.localize)(11202,null),i=(0,T.localize)(11203,null),h=(0,T.localize)(11204,null),t=`
|       | ${P} | ${E} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,T.localize)(11205,null);return`
${v} ${b} ${$}

&nbsp;

${h}
${t}

&nbsp;

${o}
`}u.$ro.as(p.$wo.Configuration).registerConfiguration({id:d.$hm,order:1,type:"object",title:(0,T.localize)(11206,null),properties:{[d.$im]:{type:"string",enum:[d.TelemetryConfiguration.ON,d.TelemetryConfiguration.ERROR,d.TelemetryConfiguration.CRASH,d.TelemetryConfiguration.OFF],enumDescriptions:[(0,T.localize)(11207,null),(0,T.localize)(11208,null),(0,T.localize)(11209,null),(0,T.localize)(11210,null)],markdownDescription:g(),default:d.TelemetryConfiguration.ON,restricted:!0,scope:p.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),u.$ro.as(p.$wo.Configuration).registerConfiguration({id:d.$hm,order:110,type:"object",title:(0,T.localize)(11211,null),properties:{[d.$km]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,T.localize)(11213,null,c.default.nameLong,c.default.privacyStatementUrl):(0,T.localize)(11212,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(11214,null,`\`#${d.$im}#\``),scope:p.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(ce[222],le([0,1,3,92,24]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=R,e.$yhc=T,e.$zhc=I;async function R(p,c){let m=p.getItem(k.$em);return(typeof m!="string"||n.$k&&m==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(m=await(0,r.$Tn)(c.error.bind(c))),m}async function T(p,c){let m=p.getItem(k.$fm);return typeof m!="string"&&(m=await(0,r.$Un)(c.error.bind(c))),m}async function I(p,c){let m=p.getItem(k.$gm);return typeof m!="string"&&(m=await(0,r.$Vn)(c.error.bind(c))),m}}),define(ce[223],le([0,1,24,222]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=k,e.$Bhc=R,e.$Chc=T;async function k(I,p){const c=await(0,r.$xhc)(I,p);return I.setItem(n.$em,c),c}async function R(I,p){const c=await(0,r.$yhc)(I,p);return I.setItem(n.$fm,c),c}async function T(I,p){const c=await(0,r.$zhc)(I,p);return I.setItem(n.$gm,c),c}}),define(ce[130],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(r){r[r.Replace=1]="Replace",r[r.Append=2]="Append",r[r.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(ce[224],le([0,1,3,130]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=void 0;const k=new Map([[r.EnvironmentVariableMutatorType.Append,"APPEND"],[r.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[r.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class R{constructor(m){this.collections=m,this.a=new Map,this.b=new Map,m.forEach((u,d)=>{this.d(u,d);const w=u.map.entries();let f=w.next();for(;!f.done;){const g=f.value[1],v=f.value[0];let b=this.a.get(v);if(b||(b=[],this.a.set(v,b)),b.length>0&&b[0].type===r.EnvironmentVariableMutatorType.Replace){f=w.next();continue}const $={extensionIdentifier:d,value:g.value,type:g.type,scope:g.scope,variable:g.variable,options:g.options};$.scope||delete $.scope,b.unshift($),f=w.next()}})}async applyToProcessEnvironment(m,u,d){let w;n.$j&&(w={},Object.keys(m).forEach(f=>w[f.toLowerCase()]=f));for(const[f,g]of this.getVariableMap(u)){const v=n.$j&&w[f.toLowerCase()]||f;for(const b of g){const $=d?await d(b.value):b.value;if(b.options?.applyAtProcessCreation??!0)switch(b.type){case r.EnvironmentVariableMutatorType.Append:m[v]=(m[v]||"")+$;break;case r.EnvironmentVariableMutatorType.Prepend:m[v]=$+(m[v]||"");break;case r.EnvironmentVariableMutatorType.Replace:m[v]=$;break}if(b.options?.applyAtShellIntegration??!1){const P=`VSCODE_ENV_${k.get(b.type)}`;m[P]=(m[P]?m[P]+":":"")+f+"="+this.c($)}}}}c(m){return m.replaceAll(":","\\x3a")}diff(m,u){const d=new Map,w=new Map,f=new Map;if(m.getVariableMap(u).forEach((g,v)=>{const b=this.getVariableMap(u).get(v),$=I(g,b);$&&d.set(v,$)}),this.getVariableMap(u).forEach((g,v)=>{const b=m.getVariableMap(u).get(v),$=I(g,b);$&&f.set(v,$)}),this.getVariableMap(u).forEach((g,v)=>{const b=m.getVariableMap(u).get(v),$=p(g,b);$&&w.set(v,$)}),!(d.size===0&&w.size===0&&f.size===0))return{added:d,changed:w,removed:f}}getVariableMap(m){const u=new Map;for(const d of this.a.values()){const w=d.filter(f=>T(f,m));w.length>0&&u.set(w[0].variable,w)}return u}getDescriptionMap(m){const u=new Map;for(const d of this.b.values()){const w=d.filter(f=>T(f,m,!0));for(const f of w)u.set(f.extensionIdentifier,f.description)}return u}d(m,u){if(!m.descriptionMap)return;const d=m.descriptionMap.entries();let w=d.next();for(;!w.done;){const f=w.value[1],g=w.value[0];let v=this.b.get(g);v||(v=[],this.b.set(g,v));const b={extensionIdentifier:u,scope:f.scope,description:f.description};b.scope||delete b.scope,v.push(b),w=d.next()}}}e.$Ls=R;function T(c,m,u=!1){return c.scope?!!(c.scope.workspaceFolder&&m?.workspaceFolder&&c.scope.workspaceFolder.index===m.workspaceFolder.index):u?m===c.scope:!0}function I(c,m){if(!m)return c;const u=new Set;m.forEach(w=>u.add(w.extensionIdentifier));const d=[];return c.forEach(w=>{u.has(w.extensionIdentifier)||d.push(w)}),d.length===0?void 0:d}function p(c,m){if(!m)return;const u=new Map;m.forEach(w=>u.set(w.extensionIdentifier,w));const d=[];return c.forEach(w=>{const f=u.get(w.extensionIdentifier);f&&(w.type!==f.type||w.value!==f.value||w.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index)&&d.push(f)}),d.length===0?void 0:d}}),define(ce[225],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=n,e.$Gs=r,e.$Hs=k,e.$Is=R,e.$Js=T,e.$Ks=I;function n(p){return[...p.entries()]}function r(p){return p?[...p.entries()]:[]}function k(p){return new Map(p)}function R(p){return new Map(p??[])}function T(p){return Array.from(p.entries()).map(c=>[c[0],n(c[1].map),r(c[1].descriptionMap)])}function I(p){return new Map(p.map(c=>[c[0],{map:k(c[1]),descriptionMap:R(c[2])}]))}}),define(ce[226],le([0,1,8,22,4,2,5]),function(x,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=void 0;let I=class extends R.$Uc{constructor(c,m){super(),this.h=m,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new k.$le),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,R.$Sc)(()=>{for(const u of this.f.values())(0,R.$Pc)(u)}))}createRequest(c){return new Promise((m,u)=>{const d=++this.a;this.c.set(d,m),this.g.fire({requestId:d,...c});const w=new r.$we;(0,n.$Gh)(this.b,w.token).then(()=>u(`Request ${d} timed out (${this.b}ms)`)),this.f.set(d,[(0,R.$Sc)(()=>w.cancel())])})}acceptReply(c,m){const u=this.c.get(c);u?(this.c.delete(c),(0,R.$Pc)(this.f.get(c)||[]),this.f.delete(c),u(m)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$ws=I,e.$ws=I=Se([se(1,T.$ak)],I)}),define(ce[75],le([0,1,6,122,45]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=e.$rs=e.$qs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ps=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$os=void 0,e.$os=new r.$Wj("terminalTabFocusMode",!1,!0);var R;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var T;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(T||(e.TerminalSettingId=T={}));var I;(function(i){i.PowerShell="pwsh",i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh",i.Python="python"})(I||(e.PosixShellType=I={}));var p;(function(i){i.CommandPrompt="cmd",i.PowerShell="pwsh",i.Wsl="wsl",i.GitBash="gitbash",i.Python="python"})(p||(e.WindowsShellType=p={}));var c;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var m;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(m||(e.TerminalIpcChannels=m={}));var u;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(u||(e.ProcessPropertyType=u={})),e.$ps=(0,n.$Fi)("ptyService");var d;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(d||(e.HeartbeatConstants=d={}));var w;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(w||(e.TerminalLocation=w={}));var f;(function(i){i.TerminalView="view",i.Editor="editor"})(f||(e.TerminalLocationString=f={}));var g;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(g||(e.LocalReconnectConstants=g={}));var v;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(v||(e.FlowControlConstants=v={}));var b;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(b||(e.ProfileSource=b={}));var $;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})($||(e.ShellIntegrationStatus=$={}));var P;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(P||(e.TerminalExitReason=P={})),e.$qs={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(h){const t=this.b(h.remoteAuthority);if(this.a.has(t))throw new Error(`A terminal backend with remote authority '${t}' was already registered.`);this.a.set(t,h)}getTerminalBackend(h){return this.a.get(this.b(h))}b(h){return h?.toLowerCase()??""}}k.$ro.add(e.$qs.Backend,new E),e.$rs=(0,n.$Fi)("localPtyService"),e.$ss=(0,n.$Fi)("terminalLogService")}),define(ce[227],le([0,1,80,7,10,110]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=T,e.$ys=c,e.$zs=m,e.$As=u;function T(d,w){const f=[{name:null,description:(0,k.localize)(11164,null)}];return f.push(...d.map(g=>({name:g.profileName,description:I(g)}))),w&&f.push(...w.map(g=>({name:g.title,description:p(g)}))),{values:f.map(g=>g.name),markdownDescriptions:f.map(g=>g.description)}}function I(d){let w=`$(${R.ThemeIcon.isThemeIcon(d.icon)?d.icon.id:d.icon?d.icon:n.$5j.terminal.id}) ${d.profileName}
- path: ${d.path}`;return d.args&&(typeof d.args=="string"?w+=`
- args: "${d.args}"`:w+=`
- args: [${d.args.length===0?"":`'${d.args.join("','")}'`}]`),d.overrideName!==void 0&&(w+=`
- overrideName: ${d.overrideName}`),d.color&&(w+=`
- color: ${d.color}`),d.env&&(w+=`
- env: ${JSON.stringify(d.env)}`),w}function p(d){return`$(${R.ThemeIcon.isThemeIcon(d.icon)?d.icon.id:d.icon?d.icon:n.$5j.terminal.id}) ${d.title}
- extensionIdentifier: ${d.extensionIdentifier}`}function c(d,w){if(!d&&!w)return!0;if(typeof d=="string"&&typeof w=="string")return d===w;if(Array.isArray(d)&&Array.isArray(w)){if(d.length!==w.length)return!1;for(let f=0;f<d.length;f++)if(d[f]!==w[f])return!1;return!0}return!1}function m(d,w){if(!d&&!w)return!0;if(!d||!w)return!1;if(R.ThemeIcon.isThemeIcon(d)&&R.ThemeIcon.isThemeIcon(w))return d.id===w.id&&d.color===w.color;if(typeof d=="object"&&"light"in d&&"dark"in d&&typeof w=="object"&&"light"in w&&"dark"in w){const f=d,g=w;if((r.URI.isUri(f.light)||u(f.light))&&(r.URI.isUri(f.dark)||u(f.dark))&&(r.URI.isUri(g.light)||u(g.light))&&(r.URI.isUri(g.dark)||u(g.dark)))return f.light.path===g.light.path&&f.dark.path===g.dark.path}if(r.URI.isUri(d)&&r.URI.isUri(w)||u(d)||u(w)){const f=d,g=w;return f.path===g.path&&f.scheme===g.scheme}return!1}function u(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}}),define(ce[228],le([0,1,80,3,10,56,45,75,227]),function(x,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=e.$Bs=void 0,e.$Ds=f,e.$Es=v,e.$Bs={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Cs={type:"string",enum:Array.from((0,n.$3j)(),b=>b.id),markdownEnumDescriptions:Array.from((0,n.$3j)(),b=>`$(${b.id})`)};const c={args:{description:(0,k.localize)(11165,null),type:"array",items:{type:"string"}},overrideName:{description:(0,k.localize)(11166,null),type:"boolean"},icon:{description:(0,k.localize)(11167,null),...e.$Cs},color:{description:(0,k.localize)(11168,null),...e.$Bs},env:{markdownDescription:(0,k.localize)(11169,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},m={type:"object",required:["path"],properties:{path:{description:(0,k.localize)(11170,null),type:["string","array"],items:{type:"string"}},...c}},u={type:"object",required:["path"],properties:{path:{description:(0,k.localize)(11171,null),type:["string"],items:{type:"string"}},...c}};function d(b){const $=b===r.Platform.Linux?"linux":b===r.Platform.Mac?"osx":"windows";return(0,k.localize)(11172,null,(0,r.$i)(b),'```json\n"terminal.integrated.profile.'+$+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,k.localize)(11173,null),type:"object",properties:{[I.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,k.localize)(11174,null),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,k.localize)(11175,null),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,k.localize)(11176,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:d(r.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,k.localize)(11177,null),enum:["PowerShell","Git Bash"]},...c}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(11178,null),type:"string"},id:{description:(0,k.localize)(11179,null),type:"string"},title:{description:(0,k.localize)(11180,null),type:"string"},...c}},{type:"null"},m]}},[I.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:d(r.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(11181,null),type:"string"},id:{description:(0,k.localize)(11182,null),type:"string"},title:{description:(0,k.localize)(11183,null),type:"string"},...c}},{type:"null"},m]}},[I.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:d(r.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(11184,null),type:"string"},id:{description:(0,k.localize)(11185,null),type:"string"},title:{description:(0,k.localize)(11186,null),type:"string"},...c}},{type:"null"},m]}},[I.TerminalSettingId.UseWslProfiles]:{description:(0,k.localize)(11187,null),type:"boolean",default:!0},[I.TerminalSettingId.InheritEnv]:{scope:R.ConfigurationScope.APPLICATION,description:(0,k.localize)(11188,null),type:"boolean",default:!0},[I.TerminalSettingId.PersistentSessionScrollback]:{scope:R.ConfigurationScope.APPLICATION,markdownDescription:(0,k.localize)(11189,null),type:"number",default:100},[I.TerminalSettingId.ShowLinkHover]:{scope:R.ConfigurationScope.APPLICATION,description:(0,k.localize)(11190,null),type:"boolean",default:!0},[I.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,k.localize)(11191,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){T.$ro.as(R.$wo.Configuration).registerConfiguration(w),v()}let g;function v(b,$){const P=T.$ro.as(R.$wo.Configuration);let E;b&&(E=(0,p.$xs)(b?.profiles,$));const i=g;g={id:"terminal",order:100,title:(0,k.localize)(11192,null),type:"object",properties:{[I.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,k.localize)(11193,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Linux?E?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Linux?E?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,k.localize)(11194,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Macintosh?E?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Macintosh?E?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,k.localize)(11195,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Windows?E?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Windows?E?.markdownDescriptions:void 0}}},P.updateConfigurations({add:[g],remove:i?[i]:[]})}}),define(ce[229],le([0,1,27,12,37,9,3,36,25,11,23,130,225,224]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=f,e.$Ns=g,e.$Os=v,n=Pe(n),R=Pe(R),I=Pe(I),m=Pe(m);function f(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let S=0;return l&&l.length===4&&(S=parseInt(l[3])),S}async function g(l,S,y,A=I.env,L=m.Promises.exists){if(R.$ic(l))return await L(l)?l:void 0;if(S===void 0&&(S=I.cwd()),R.$mc(l)!=="."){const Z=R.$jc(S,l);return await L(Z)?Z:void 0}const O=(0,k.$lo)(A,"PATH");if(y===void 0&&(0,c.$eg)(O)&&(y=O.split(R.$tc)),y===void 0||y.length===0){const Z=R.$jc(S,l);return await L(Z)?Z:void 0}for(const Z of y){let q;if(R.$ic(Z)?q=R.$jc(Z,l):q=R.$jc(S,Z,l),await L(q))return q;if(T.$j){let K=q+".com";if(await L(K)||(K=q+".exe",await L(K)))return K}}const M=R.$jc(S,l);return await L(M)?M:void 0}function v(l,S,y,A,L){const D=T.$j&&(!S.windowsEnableConpty||f()<18309);if(!S.shellIntegration.enabled||!l.executable||l.isFeatureTerminal&&!l.forceShellIntegration||l.ignoreShellIntegration||D)return;const O=l.args,M=I.$dc==="win32"?R.$nc(l.executable).toLowerCase():R.$nc(l.executable),Z=R.$mc(r.$Zg.asFileUri("").fsPath);let q;const K={VSCODE_INJECTION:"1"};if(S.shellIntegration.nonce&&(K.VSCODE_NONCE=S.shellIntegration.nonce),T.$j){if(M==="pwsh.exe"||M==="powershell.exe")return!O||s(O)?q=P.get($.WindowsPwsh):o(O)&&(q=P.get($.WindowsPwshLogin)),q?(q=[...q],q[q.length-1]=(0,p.$df)(q[q.length-1],Z,""),K.VSCODE_STABLE=L.quality==="stable"?"1":"0",S.shellIntegration.suggestEnabled&&(K.VSCODE_SUGGEST="1"),{newArgs:q,envMixin:K}):void 0;if(M==="bash.exe")return!O||O.length===0?q=P.get($.Bash):a(O)&&(K.VSCODE_SHELL_LOGIN="1",b(S,K),q=P.get($.Bash)),q?(q=[...q],q[q.length-1]=(0,p.$df)(q[q.length-1],Z),K.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:q,envMixin:K}):void 0;A.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}switch(M){case"bash":return!O||O.length===0?q=P.get($.Bash):a(O)&&(K.VSCODE_SHELL_LOGIN="1",b(S,K),q=P.get($.Bash)),q?(q=[...q],q[q.length-1]=(0,p.$df)(q[q.length-1],Z),K.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:q,envMixin:K}):void 0;case"fish":{const de=y?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",H=R.$jc(Z,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return K.XDG_DATA_DIRS=`${de}:${H}`,b(S,K),{newArgs:void 0,envMixin:K}}case"pwsh":return!O||s(O)?q=P.get($.Pwsh):o(O)&&(q=P.get($.PwshLogin)),q?(S.shellIntegration.suggestEnabled&&(K.VSCODE_SUGGEST="1"),q=[...q],q[q.length-1]=(0,p.$df)(q[q.length-1],Z,""),K.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:q,envMixin:K}):void 0;case"zsh":{if(!O||O.length===0?q=P.get($.Zsh):a(O)?(q=P.get($.ZshLogin),b(S,K)):(O===P.get($.Zsh)||O===P.get($.ZshLogin))&&(q=O),!q)return;q=[...q],q[q.length-1]=(0,p.$df)(q[q.length-1],Z);let de;try{de=n.userInfo().username}catch{de="unknown"}const H=R.$jc(n.tmpdir(),`${de}-${L.applicationName}-zsh`);K.ZDOTDIR=H;const Y=y?.ZDOTDIR??n.homedir()??"~";K.USER_ZDOTDIR=Y;const B=[];return B.push({source:R.$jc(Z,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:R.$jc(H,".zshrc")}),B.push({source:R.$jc(Z,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:R.$jc(H,".zprofile")}),B.push({source:R.$jc(Z,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:R.$jc(H,".zshenv")}),B.push({source:R.$jc(Z,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:R.$jc(H,".zlogin")}),{newArgs:q,envMixin:K,filesToCopy:B}}}A.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}function b(l,S){if(T.$k&&l.environmentVariableCollections){const y=(0,d.$Ks)(l.environmentVariableCollections),L=new w.$Ls(y).getVariableMap({workspaceFolder:l.workspaceFolder}).get("PATH"),D=[];if(L)for(const O of L)O.type===u.EnvironmentVariableMutatorType.Prepend&&D.push(O.value);D.length>0&&(S.VSCODE_PATH_PREFIX=D.join(""))}}var $;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})($||($={}));const P=new Map;P.set($.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),P.set($.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),P.set($.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),P.set($.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),P.set($.Zsh,["-i"]),P.set($.ZshLogin,["-il"]),P.set($.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],i=["--login","-l"],h=["-i","--interactive"],t=["-nol","-nologo"];function o(l){return typeof l=="string"?E.includes(l.toLowerCase()):l.length===1&&E.includes(l[0].toLowerCase())||l.length===2&&(E.includes(l[0].toLowerCase())||E.includes(l[1].toLowerCase()))&&(t.includes(l[0].toLowerCase())||t.includes(l[1].toLowerCase()))}function s(l){return typeof l=="string"?t.includes(l.toLowerCase()):l.length===0||l?.length===1&&t.includes(l[0].toLowerCase())}function a(l){return typeof l!="string"&&(l=l.filter(S=>!h.includes(S.toLowerCase()))),l==="string"&&i.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&i.includes(l[0].toLowerCase())}}),define(ce[230],le([0,1,26,48,80,9,3,11,23,114,75,229,121]),function(x,e,n,r,k,R,T,I,p,c,m,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=v,n=Pe(n),r=Pe(r),p=Pe(p);var w;(function(y){y.UnixShellsPath="/etc/shells"})(w||(w={}));let f,g=!0;function v(y,A,L,D,O=process.env,M,Z,q,K){return M=M||{existsFile:p.SymlinkSupport.existsFile,readFile:n.promises.readFile},T.$j?b(L,M,O,Z,D.getValue(m.TerminalSettingId.UseWslProfiles)!==!1,y&&typeof y=="object"?{...y}:D.getValue(m.TerminalSettingId.ProfilesWindows),typeof A=="string"?A:D.getValue(m.TerminalSettingId.DefaultProfileWindows),K,q):a(M,Z,L,y&&typeof y=="object"?{...y}:D.getValue(T.$l?m.TerminalSettingId.ProfilesLinux:m.TerminalSettingId.ProfilesMacOs),typeof A=="string"?A:D.getValue(T.$l?m.TerminalSettingId.DefaultProfileLinux:m.TerminalSettingId.DefaultProfileMacOs),K,q,O)}async function b(y,A,L,D,O,M,Z,q,K){const de=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),H=`${process.env.windir}\\${de?"Sysnative":"System32"}`;let Y=!1;(0,u.$Ms)()>=16299&&(Y=!0),await i(q);const B=new Map;if(y){B.set("PowerShell",{source:m.ProfileSource.Pwsh,icon:k.$5j.terminalPowershell,isAutoDetected:!0}),B.set("Windows PowerShell",{path:`${H}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:k.$5j.terminalPowershell,isAutoDetected:!0}),B.set("Git Bash",{source:m.ProfileSource.GitBash,isAutoDetected:!0}),B.set("Command Prompt",{path:`${H}\\cmd.exe`,icon:k.$5j.terminalCmd,isAutoDetected:!0}),B.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),B.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:k.$5j.terminalBash,isAutoDetected:!0});const W=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;B.set("Cmder",{path:`${H}\\cmd.exe`,args:["/K",W],requiresPath:process.env.CMDER_ROOT?W:{path:W,isUnsafe:!0},isAutoDetected:!0})}l(M,B);const Q=await $(B.entries(),Z,A,L,D,K);if(y&&O)try{const W=await o(`${H}\\${Y?"wsl":"bash"}.exe`,Z);for(const j of W)(!M||!(j.profileName in M))&&Q.push(j)}catch{g&&(D?.trace("WSL is not installed, so could not detect WSL profiles"),g=!1)}return Q}async function $(y,A,L,D=process.env,O,M){const Z=[];for(const[q,K]of y)Z.push(P(q,K,A,L,D,O,M));return(await Promise.all(Z)).filter(q=>!!q)}async function P(y,A,L,D,O=process.env,M,Z){if(A===null)return;let q,K,de;if("source"in A&&!("path"in A)){const Q=f?.get(A.source);if(!Q)return;q=Q.paths,K=A.args||Q.args,A.icon?de=E(A.icon):Q.icon&&(de=Q.icon)}else q=Array.isArray(A.path)?A.path:[A.path],K=T.$j||Array.isArray(A.args)?A.args:void 0,de=E(A.icon);let H;if(Z){const Q=q.map(j=>typeof j=="string"?j:j.path),W=await Z(Q);H=new Array(q.length);for(let j=0;j<q.length;j++)typeof q[j]=="string"?H[j]=W[j]:H[j]={path:W[j],isUnsafe:!0}}else H=q.slice();let Y;if(A.requiresPath){let Q;if((0,I.$eg)(A.requiresPath)?Q=A.requiresPath:(Q=A.requiresPath.path,A.requiresPath.isUnsafe&&(Y=Q)),!await D.existsFile(Q))return}const B=await S(y,L,H,D,O,K,A.env,A.overrideName,A.isAutoDetected,Y);if(!B){M?.debug("Terminal profile not validated",y,q);return}return B.isAutoDetected=A.isAutoDetected,B.icon=de,B.color=A.color,B}function E(y){return typeof y=="string"?{id:y}:y}async function i(y){if(f&&!y)return;const[A,L]=await Promise.all([h(),y||t()]);f=new Map,f.set(m.ProfileSource.GitBash,{profileName:"Git Bash",paths:A,args:["--login","-i"]}),f.set(m.ProfileSource.Pwsh,{profileName:"PowerShell",paths:L,icon:k.$5j.terminalPowershell})}async function h(){const y=new Set,A=await(0,u.$Ns)("git.exe");if(A){const O=(0,d.dirname)(A);y.add((0,d.resolve)(O,"../.."))}function L(O,M){M&&O.add(M)}L(y,process.env.ProgramW6432),L(y,process.env.ProgramFiles),L(y,process.env["ProgramFiles(X86)"]),L(y,`${process.env.LocalAppData}\\Program`);const D=[];for(const O of y)D.push(`${O}\\Git\\bin\\bash.exe`,`${O}\\Git\\usr\\bin\\bash.exe`,`${O}\\usr\\bin\\bash.exe`);return D.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),D.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),D}async function t(){const y=[];for await(const A of(0,c.$wm)())y.push(A.exePath);return y}async function o(y,A){const L=[],D=await new Promise((Z,q)=>{r.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(K,de)=>{if(K)return q("Problem occurred when getting wsl distros");Z(de)})});if(!D)return[];const O=new RegExp(/[\r?\n]/),M=D.split(O).filter(Z=>Z.trim().length>0&&Z!=="");for(const Z of M){if(Z===""||Z.startsWith("docker-desktop"))continue;const q=`${Z} (WSL)`,K={profileName:q,path:y,args:["-d",`${Z}`],isDefault:q===A,icon:s(Z),isAutoDetected:!1};L.push(K)}return L}function s(y){return y.includes("Ubuntu")?k.$5j.terminalUbuntu:y.includes("Debian")?k.$5j.terminalDebian:k.$5j.terminalLinux}async function a(y,A,L,D,O,M,Z,q){const K=new Map;if(L&&await y.existsFile(w.UnixShellsPath)){const de=(await y.readFile(w.UnixShellsPath)).toString(),H=(M||de.split(`
`)).map(B=>{const Q=B.indexOf("#");return Q===-1?B:B.substring(0,Q)}).filter(B=>B.trim().length>0),Y=new Map;for(const B of H){let Q=(0,R.$nc)(B),W=Y.get(Q)||0;W++,W>1&&(Q=`${Q} (${W})`),Y.set(Q,W),K.set(Q,{path:B,isAutoDetected:!0})}}return l(D,K),await $(K.entries(),O,y,q,A,Z)}function l(y,A){if(y)for(const[L,D]of Object.entries(y))D===null||typeof D!="object"||!("path"in D)&&!("source"in D)?A.delete(L):(D.icon=D.icon||A.get(L)?.icon,A.set(L,D))}async function S(y,A,L,D,O,M,Z,q,K,de){if(L.length===0)return Promise.resolve(void 0);const H=L.shift();if(H==="")return S(y,A,L,D,O,M,Z,q,K);const Y=typeof H!="string"&&H.isUnsafe,B=typeof H=="string"?H:H.path,Q={profileName:y,path:B,args:M,env:Z,overrideName:q,isAutoDetected:K,isDefault:y===A,isUnsafePath:Y,requiresUnsafePath:de};if((0,R.$nc)(B)===B){const j=O.PATH?O.PATH.split(R.$tc):void 0,C=await(0,u.$Ns)(B,void 0,j,void 0,D.existsFile);return C?(Q.path=C,Q.isFromPath=!0,Q):S(y,A,L,D,O,M)}return await D.existsFile((0,R.$hc)(B))?Q:S(y,A,L,D,O,M,Z,q,K)}}),define(ce[231],le([0,1,4,2,3,44,16,5,193,100,226,75,228,230,116,66]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0;var v;(function($){$[$.MaxRestarts=5]="MaxRestarts"})(v||(v={}));let b=class extends r.$Uc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(P,E,i,h){super(),this.M=P,this.N=E,this.O=i,this.P=h,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$le),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$le),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$le),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$le),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$le),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$le),this.onProcessData=this.D.event,this.F=this.B(new n.$le),this.onProcessReady=this.F.event,this.G=this.B(new n.$le),this.onProcessReplay=this.G.event,this.H=this.B(new n.$le),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$le),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$le),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$le),this.onProcessExit=this.L.event,(0,d.$Ds)(),this.B(this.M),this.B((0,r.$Sc)(()=>this.W())),this.j=this.B(new m.$ws(void 0,this.O)),this.B(this.j.onCreateRequest(this.C.fire,this.C)),this.M.onRequestConnection&&this.B(n.Event.once(this.M.onRequestConnection)(()=>this.h())),this.M.onWillShutdown&&this.B(this.M.onWillShutdown(()=>this.m=!0))}get Q(){return this.N.getValue(u.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(k.$j)return process.env;try{return await(0,c.$Rm)(this.N,this.O,{_:[]},process.env)}catch(P){return this.O.error("ptyHost was unable to resolve shell environment",P),{}}}U(){const P=this.M.start(),E=P.client;this.O.getLevel()===I.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),R.ProxyChannel.toService(E.getChannel(u.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(P.onDidProcessExit(t=>{this.u.fire(t.code),!this.m&&!this.q.isDisposed&&(this.n<=v.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${t.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${t.code}, giving up`))}));const h=R.ProxyChannel.toService(E.getChannel(u.TerminalIpcChannels.PtyHost));return this.B(h.onProcessData(t=>this.D.fire(t))),this.B(h.onProcessReady(t=>this.F.fire(t))),this.B(h.onProcessExit(t=>this.L.fire(t))),this.B(h.onDidChangeProperty(t=>this.J.fire(t))),this.B(h.onProcessReplay(t=>this.G.fire(t))),this.B(h.onProcessOrphanQuestion(t=>this.H.fire(t))),this.B(h.onDidRequestDetach(t=>this.I.fire(t))),this.B(new p.$vs(this.P,E.getChannel(u.TerminalIpcChannels.Logger))),this.a=P,this.b=h,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async t=>{t.affectsConfiguration(u.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[P,h]}async createProcess(P,E,i,h,t,o,s,a,l,S,y){const A=setTimeout(()=>this.$(),u.HeartbeatConstants.CreateProcessTimeout),L=await this.f.createProcess(P,E,i,h,t,o,s,a,l,S,y);return clearTimeout(A),L}updateTitle(P,E,i){return this.f.updateTitle(P,E,i)}updateIcon(P,E,i,h){return this.f.updateIcon(P,E,i,h)}attachToProcess(P){return this.f.attachToProcess(P)}detachFromProcess(P,E){return this.f.detachFromProcess(P,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(P){return this.f.start(P)}shutdown(P,E){return this.f.shutdown(P,E)}input(P,E){return this.f.input(P,E)}processBinary(P,E){return this.f.processBinary(P,E)}resize(P,E,i){return this.f.resize(P,E,i)}clearBuffer(P){return this.f.clearBuffer(P)}acknowledgeDataEvent(P,E){return this.f.acknowledgeDataEvent(P,E)}setUnicodeVersion(P,E){return this.f.setUnicodeVersion(P,E)}getInitialCwd(P){return this.f.getInitialCwd(P)}getCwd(P){return this.f.getCwd(P)}async getLatency(){const P=new g.$fe,E=await this.f.getLatency();return P.stop(),[{label:"ptyhostservice<->ptyhost",latency:P.elapsed()},...E]}orphanQuestionReply(P){return this.f.orphanQuestionReply(P)}installAutoReply(P,E){return this.f.installAutoReply(P,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(P){return this.f.uninstallAutoReply(P)}getDefaultSystemShell(P){return this.g?.getDefaultSystemShell(P)??(0,f.$Am)(P??k.OS,process.env)}async getProfiles(P,E,i,h=!1){const t=await this.S();return(0,w.$Ps)(E,i,h,this.N,t,void 0,this.O,this.bb.bind(this,P))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(P,E){return this.f.getWslPath(P,E)}getRevivedPtyNewId(P,E){return this.f.getRevivedPtyNewId(P,E)}setTerminalLayoutInfo(P){return this.f.setTerminalLayoutInfo(P)}async getTerminalLayoutInfo(P){return this.g?.getTerminalLayoutInfo(P)}async requestDetachInstance(P,E){return this.f.requestDetachInstance(P,E)}async acceptDetachInstanceReply(P,E){return this.f.acceptDetachInstanceReply(P,E)}async freePortKillProcess(P){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(P)}async serializeTerminalState(P){return this.f.serializeTerminalState(P)}async reviveTerminalProcesses(P,E,i){return this.f.reviveTerminalProcesses(P,E,i)}async refreshProperty(P,E){return this.f.refreshProperty(P,E)}async updateProperty(P,E,i){return this.f.updateProperty(P,E,i)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(P){this.ab(),this.s=setTimeout(()=>this.Y(),P?u.HeartbeatConstants.ConnectingBeatInterval:u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier+u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${u.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(P,E){return this.j.createRequest({workspaceId:P,originalText:E})}async acceptPtyHostResolvedVariables(P,E){this.j.acceptReply(P,E)}};e.$Qs=b,e.$Qs=b=Se([se(1,T.$_i),se(2,I.$ak),se(3,I.$bk)],b)});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[76],le([0,1,13,4,2,3,16,6,34]),function(x,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wfc=e.$Vfc=void 0,n=Ve(n);const c="#FFFFFF",m="#1E1E1E",u="#000000",d="#FFFFFF",w="theme",f="themeBackground",g="windowSplash";var v;(function($){$.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",$.SYSTEM_COLOR_THEME="window.systemColorTheme"})(v||(v={})),e.$Vfc=(0,I.$Fi)("themeMainService");let b=class extends k.$Uc{constructor(P,E){super(),this.b=P,this.c=E,this.a=this.B(new r.$le),this.onDidChangeColorScheme=this.a.event,R.$l||this.B(this.c.onDidChangeConfiguration(i=>{(i.affectsConfiguration(v.SYSTEM_COLOR_THEME)||i.affectsConfiguration(v.DETECT_COLOR_SCHEME))&&this.f()})),this.f(),this.B(r.Event.fromNodeEventEmitter(n.default.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){if(R.$l||this.c.getValue(v.DETECT_COLOR_SCHEME))n.default.nativeTheme.themeSource="system";else switch(this.c.getValue(v.SYSTEM_COLOR_THEME)){case"dark":n.default.nativeTheme.themeSource="dark";break;case"light":n.default.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.default.nativeTheme.themeSource="light";break;case"vs-dark":n.default.nativeTheme.themeSource="dark";break;default:n.default.nativeTheme.themeSource="system"}break;default:n.default.nativeTheme.themeSource="system";break}}getColorScheme(){if(R.$j){if(n.default.nativeTheme.shouldUseHighContrastColors)return{dark:n.default.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.$k){if(n.default.nativeTheme.shouldUseInvertedColorScheme||n.default.nativeTheme.shouldUseHighContrastColors)return{dark:n.default.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.$l&&n.default.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.default.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const P=this.getColorScheme();if(P.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return P.dark?u:d;let E=this.b.getItem(f,null);if(!E)switch(this.g()){case"vs":E=c;break;case"hc-black":E=u;break;case"hc-light":E=d;break;default:E=m}return R.$k&&E.toUpperCase()===m&&(E="#171717"),E}g(){switch(this.b.getItem(w,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(P,E){this.b.setItems([{key:w,data:E.baseTheme},{key:f,data:E.colorInfo.background},{key:g,data:E}]),typeof P=="number"&&this.h(P,E),this.f()}h(P,E){for(const i of n.default.BrowserWindow.getAllWindows())if(i.id===P){i.setBackgroundColor(E.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(g)}};e.$Wfc=b,e.$Wfc=b=Se([se(0,p.$CR),se(1,T.$_i)],b)}),define(ce[131],le([0,1,4,2,3,7,16,6,5]),function(x,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pw=e.$Ow=e.$Lw=e.$Jw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Fw=e.$Ew=void 0,e.$Gw=u,e.$Hw=w,e.$Iw=f,e.$Kw=g,e.$Mw=v,e.$Nw=b,e.$Ew=(0,I.$Fi)("tunnelService"),e.$Fw=(0,I.$Fi)("sharedTunnelsService");var c;(function(E){E.Http="http",E.Https="https"})(c||(e.TunnelProtocol=c={}));var m;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(m||(e.TunnelPrivacyId=m={}));function u(E){return!!E.forwardPort}var d;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function w(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(i)return{address:i[1],port:+i[2]}}function f(E){if(E.scheme!=="http"&&E.scheme!=="https"||!E.query)return;const i=E.query.split("&");for(const h of i){const t=h.split("=")[1];if(/^https?:/.exec(t)){const o=w(R.URI.parse(t));if(o)return o}}}e.$Jw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function g(E){return e.$Jw.indexOf(E)>=0}e.$Lw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(E){return e.$Lw.indexOf(E)>=0}function b(E,i,h,t){if(h===k.OperatingSystem.Windows)return!1;if(h===k.OperatingSystem.Macintosh&&v(i)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(t);if(o?.length===4&&parseInt(o[1])>=18)return!1}return E<1024}class ${constructor(i,h,t){this.remoteAddress=i,this.localAddress=h,this.b=t,this.a=new n.$le,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Ow=$;let P=class extends r.$Uc{constructor(i,h){super(),this.r=i,this.s=h,this.a=new n.$le,this.onTunnelOpened=this.a.event,this.b=new n.$le,this.onTunnelClosed=this.b.event,this.c=new n.$le,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const i=this.s.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.g=i,i?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.h=i.elevation,this.m=i.privacyOptions,this.j=i.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const i=[],h=Array.from(this.f.values());for(const t of h){const o=Array.from(t.values());for(const s of o){const a=await s.value;a&&typeof a!="string"&&i.push(a)}}return i}async dispose(){super.dispose();for(const i of this.f.values()){for(const{value:h}of i.values())await h.then(t=>typeof t!="string"?t?.dispose():void 0);i.clear()}this.f.clear()}setEnvironmentTunnel(i,h,t,o,s){this.z(i,h,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:h,localAddress:t,privacy:o,protocol:s,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,h){(v(i)||g(i))&&(i=e.$Jw[0]);const t=this.D(i,h);if(t)return++t.refcount,t.value}openTunnel(i,h,t,o,s,a=!1,l,S){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${t} on local port ${s}.`);const y=this.g??i;if(!y)return;if(h||(h="localhost"),o||(o=this.t),this.g&&this.n.has(t)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const A=this.F(y,h,t,o,s,a,l,S);return A?A.then(L=>{if(L){if(typeof L=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(h,t),L}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(h,t);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const D=this.w(L);return(L.tunnelRemoteHost!==h||L.tunnelRemotePort!==t)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&L.privacy!==l&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(D),D}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),A)}w(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const h=this.f.get(i.tunnelRemoteHost);if(h){const t=h.get(i.tunnelRemotePort);t&&(t.refcount--,await this.y(i.tunnelRemoteHost,i.tunnelRemotePort,t))}}}}async y(i,h,t){if(t.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${h}.`);const o=t.value.then(async s=>{s&&typeof s!="string"&&(await s.dispose(!0),this.b.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this.f.has(i)&&this.f.get(i).delete(h),o}}async closeTunnel(i,h){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${h} `);const t=this.f.get(i);if(t&&t.has(h)){const o=t.get(h);o.refcount=0,await this.y(i,h,o)}}z(i,h,t){this.f.has(i)||this.f.set(i,new Map),this.f.get(i).set(h,{refcount:1,value:t})}async C(i,h){const t=this.f.get(i);if(t){const o=t.get(h),s=o?await o.value:void 0;(!s||typeof s=="string")&&t.delete(h),t.size===0&&this.f.delete(i)}}D(i,h){const t=[i];g(i)?(t.push(...e.$Jw),t.push(...e.$Lw)):v(i)&&t.push(...e.$Lw);const o=t.map(s=>this.f.get(s));for(const s of o){const a=s?.get(h);if(a)return a}}canTunnel(i){return!!w(i)}G(i,h,t,o,s,a,l){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${t} on local port ${o}.`);const S=t;this.n.add(S);const y=o===void 0?t:o,A={elevationRequired:s?this.isPortPrivileged(y):!1},L={remoteAddress:{host:h,port:t},localAddressPort:o,privacy:a,public:a?a!==m.Private:void 0,protocol:l},D=i.forwardPort(L,A);return D?(this.z(h,t,D),D.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(S)})):this.n.delete(S),D}};e.$Pw=P,e.$Pw=P=Se([se(0,p.$ak),se(1,T.$_i)],P)}),define(ce[50],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VY=e.$UY=e.DisablementReason=e.UpdateType=e.StateType=void 0;var r;(function(T){T.Uninitialized="uninitialized",T.Idle="idle",T.Disabled="disabled",T.CheckingForUpdates="checking for updates",T.AvailableForDownload="available for download",T.Downloading="downloading",T.Downloaded="downloaded",T.Updating="updating",T.Ready="ready"})(r||(e.StateType=r={}));var k;(function(T){T[T.Setup=0]="Setup",T[T.Archive=1]="Archive",T[T.Snap=2]="Snap"})(k||(e.UpdateType=k={}));var R;(function(T){T[T.NotBuilt=0]="NotBuilt",T[T.DisabledByEnvironment=1]="DisabledByEnvironment",T[T.ManuallyDisabled=2]="ManuallyDisabled",T[T.MissingConfiguration=3]="MissingConfiguration",T[T.InvalidConfiguration=4]="InvalidConfiguration",T[T.RunningAsAdmin=5]="RunningAsAdmin"})(R||(e.DisablementReason=R={})),e.$UY={Uninitialized:{type:r.Uninitialized},Disabled:T=>({type:r.Disabled,reason:T}),Idle:(T,I)=>({type:r.Idle,updateType:T,error:I}),CheckingForUpdates:T=>({type:r.CheckingForUpdates,explicit:T}),AvailableForDownload:T=>({type:r.AvailableForDownload,update:T}),Downloading:{type:r.Downloading},Downloaded:T=>({type:r.Downloaded,update:T}),Updating:T=>({type:r.Updating,update:T}),Ready:T=>({type:r.Ready,update:T})},e.$VY=(0,n.$Fi)("updateService")}),define(ce[232],le([0,1,3,10,56,45]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.$ro.as(k.$wo.Configuration).registerConfiguration({id:"update",order:15,title:(0,r.localize)(11078,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:k.ConfigurationScope.APPLICATION,description:(0,r.localize)(11079,null),tags:["usesOnlineServices"],enumDescriptions:[(0,r.localize)(11080,null),(0,r.localize)(11081,null),(0,r.localize)(11082,null),(0,r.localize)(11083,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:k.ConfigurationScope.APPLICATION,description:(0,r.localize)(11084,null),deprecationMessage:(0,r.localize)(11085,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:k.ConfigurationScope.APPLICATION,title:(0,r.localize)(11086,null),description:(0,r.localize)(11087,null),included:n.$j&&!n.$p},"update.showReleaseNotes":{type:"boolean",default:!0,scope:k.ConfigurationScope.APPLICATION,description:(0,r.localize)(11088,null),tags:["usesOnlineServices"]}}})}),define(ce[233],le([0,1,4,50]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=e.$0gc=void 0;class k{constructor(I){this.a=I}listen(I,p){switch(p){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${p}`)}call(I,p,c){switch(p){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${p}`)}}e.$0gc=k;class R{get state(){return this.b}set state(I){this.b=I,this.a.fire(I)}constructor(I){this.c=I,this.a=new n.$le,this.onStateChange=this.a.event,this.b=r.$UY.Uninitialized,this.c.listen("onStateChange")(p=>this.state=p),this.c.call("_getInitialState").then(p=>this.state=p)}checkForUpdates(I){return this.c.call("checkForUpdates",I)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(I){return this.c.call("_applySpecificUpdate",I)}}e.$$gc=R}),define(ce[41],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=void 0,e.$Kl=(0,n.$Fi)("IUriIdentityService")}),define(ce[234],le([0,1,41,173,14,18,145,4,2]),function(x,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0;class c{static{this._clock=0}constructor(d){this.uri=d,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let m=class{constructor(d){this.g=d,this.c=new p.$Tc,this.f=2**16;const w=new Map,f=g=>{let v=w.get(g.scheme);return v===void 0&&(v=d.hasProvider(g)&&!this.g.hasCapability(g,k.FileSystemProviderCapabilities.PathCaseSensitive),w.set(g.scheme,v)),v};this.c.add(I.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(g=>{w.delete(g.scheme)})),this.extUri=new R.$8g(f),this.d=new T.$Ts((g,v)=>this.extUri.compare(g,v,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,R.$hh)(d));const w=this.d.get(d);return w?w.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new c(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((f,g)=>f[1].time<g[1].time?1:f[1].time>g[1].time?-1:0);c._clock=0,this.d.clear();const w=this.f*.5;for(let f=0;f<w;f++)this.d.set(d[f][0],d[f][1].touch())}};e.$Us=m,e.$Us=m=Se([se(0,k.$al)],m),(0,r.$Rs)(n.$Kl,m,r.InstantiationType.Delayed)}),define(ce[132],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LY=void 0,e.$LY=(0,n.$Fi)("urlService")}),define(ce[235],le([0,1,7]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=e.$ghc=e.$fhc=void 0;class r{constructor(I){this.a=I}listen(I,p){throw new Error(`Event not found: ${p}`)}call(I,p,c){switch(p){case"handleURL":return this.a.handleURL(n.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${p}`)}}e.$fhc=r;class k{constructor(I){this.a=I}handleURL(I,p){return this.a.call("handleURL",[I.toJSON(),p])}}e.$ghc=k;class R{constructor(I,p){this.a=I,this.b=p}async routeCall(I,p,c,m){if(p!=="handleURL")throw new Error(`Call not found: ${p}`);if(Array.isArray(c)&&c.length>0){const u=n.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",u.toString(!0)),u.query){const d=/\bwindowId=(\d+)/.exec(u.query);if(d){const w=d[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${w}"`,u.toString(!0));const f=new RegExp(`window:${w}`),g=I.connections.find(v=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",v.ctx),f.test(v.ctx)));if(g)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",u.toString(!0)),g;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",u.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",u.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(I,p,c,m)}routeEvent(I,p){throw new Error(`Event not found: ${p}`)}}e.$hhc=R}),define(ce[236],le([0,1,8,2,7,28]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NY=e.$MY=void 0;class T extends r.$Uc{constructor(){super(...arguments),this.a=new Set}open(c,m){const u=[...this.a.values()];return(0,n.$Jh)(u.map(d=>()=>d.handleURL(c,m)),void 0,!1).then(d=>d||!1)}registerHandler(c){return this.a.add(c),(0,r.$Sc)(()=>this.a.delete(c))}}e.$MY=T;let I=class extends T{constructor(c){super(),this.b=c}create(c){let{authority:m,path:u,query:d,fragment:w}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return m&&u&&u.indexOf("/")!==0&&(u=`/${u}`),k.URI.from({scheme:this.b.urlProtocol,authority:m,path:u,query:d,fragment:w})}};e.$NY=I,e.$NY=I=Se([se(0,R.$tk)],I)}),define(ce[237],le([0,1,13,8,4,2,3,7]),function(x,e,n,r,k,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=void 0;class p extends R.$Uc{constructor(m,u,d,w,f,g){if(super(),this.c=u,this.f=g,this.a=[],this.b=0,m&&(g.trace("ElectronURLListener initialUrisToHandle:",m.map($=>$.originalUrl)),this.a=m),T.$j){const $=w.isBuilt?[]:[`"${w.appRoot}"`];$.push("--open-url","--"),n.app.setAsDefaultProtocolClient(f.urlProtocol,process.execPath,$)}const v=k.Event.map(k.Event.fromNodeEventEmitter(n.app,"open-url",($,P)=>({event:$,url:P})),({event:$,url:P})=>($.preventDefault(),P));this.B(v($=>{const P=this.g($);P&&this.c.open(P,{originalUrl:$})})),d.getWindows().filter($=>$.isReady).length>0?(g.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(g.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(k.Event.once(d.onDidSignalReadyWindow)(()=>this.h())))}g(m){try{return I.URI.parse(m)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const m=[];for(const u of this.a)await this.c.open(u.uri,{originalUrl:u.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",u.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",u.originalUrl),m.push(u));m.length!==0&&(this.a=m,(0,r.$Hh)(()=>this.h(),500,this.q))}}e.$ihc=p}),define(ce[238],le([0,1,4,2,14,60,31]),function(x,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=void 0;class I extends r.$Uc{constructor(c,m,u,d,w,f){super(),this.f=c,this.g=m,this.h=u,this.j=d,this.m=w,this.n=f,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$le),this.onDidChangeFile=this.a.event,this.b=R.$Li.forUris(()=>!(this.capabilities&k.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new T.$Bc(g=>this.m.extUri.getComparisonKey(this.t(g))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(g=>this.s(g)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,m){return this.g.open(this.t(c),m)}close(c){return this.g.close(c)}read(c,m,u,d,w){return this.g.read(c,m,u,d,w)}write(c,m,u,d,w){return this.g.write(c,m,u,d,w)}watch(c,m){this.b.set(c,c);const u=this.g.watch(this.t(c),m);return(0,r.$Sc)(()=>{this.b.delete(c),u.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,m,u){return this.g.rename(this.t(c),this.t(m),u)}readFile(c,m){return this.g.readFile(this.t(c),m)}readFileStream(c,m,u){return this.g.readFileStream(this.t(c),m,u)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,m,u){return this.g.writeFile(this.t(c),m,u)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,m){return this.g.delete(this.t(c),m)}copy(c,m,u){if((0,k.$el)(this.g))return this.g.copy(this.t(c),this.t(m),u);throw new Error("copy not supported")}cloneFile(c,m){if((0,k.$fl)(this.g))return this.g.cloneFile(this.t(c),this.t(m));throw new Error("clone not supported")}s(c){const m=[];for(const u of c){if(u.resource.scheme!==this.f)continue;const d=this.u(u.resource);this.b.findSubstr(d)&&m.push({resource:d,type:u.type,cId:u.cId})}m.length&&(this.n.debug("User data changed"),this.a.fire(m))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$Xhc=I}),define(ce[239],le([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=void 0,e.$Ehc="utilityProcessWorker"}),define(ce[240],le([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=void 0,e.$jhc=(0,n.$Fi)("webviewManagerService")}),define(ce[241],le([0,1,13,2,12,7]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=void 0;class T extends r.$Uc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const p=this.b.bind(this);n.protocol.registerFileProtocol(k.Schemas.vscodeWebview,p)}b(p,c){try{const m=R.URI.parse(p.url),u=T.a.get(m.path);if(typeof u=="string"){const d=`vs/workbench/contrib/webview/browser/pre/${u}`,w=k.$Zg.asFileUri(d);return c({path:w.fsPath,headers:{...k.COI.getHeadersFromQuery(p.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$khc=T}),define(ce[51],le([0,1,3]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eE=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$8D=void 0,e.$9D=r,e.$0D=k,e.$$D=R,e.$_D=T,e.$aE=I,e.$bE=u,e.$cE=d,e.$dE=w,e.$fE=f,e.$gE=g,e.$hE=v,e.$8D={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function r(b){return typeof b.parentId=="number"}function k(b){return!!b.workspaceUri}function R(b){return!!b.folderUri}function T(b){return!!b.fileUri}function I(b){const $=d(b),P=b.getValue("window.menuBarVisibility");return P==="default"||$&&P==="compact"||n.$k&&n.$n?"classic":P}var p;(function(b){b.TITLE_BAR_STYLE="window.titleBarStyle",b.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(p||(e.TitleBarSetting=p={}));var c;(function(b){b.NATIVE="native",b.CUSTOM="custom"})(c||(e.TitlebarStyle=c={}));var m;(function(b){b.AUTO="auto",b.WINDOWED="windowed",b.NEVER="never"})(m||(e.CustomTitleBarVisibility=m={}));function u(b,$){return!0}function d(b,$){return $||($=w(b)),$===c.NATIVE}function w(b){if(n.$p)return c.CUSTOM;const $=b.getValue("window");if($){if(n.$k&&$.nativeTabs===!0||n.$k&&$.nativeFullScreen===!1)return c.NATIVE;const i=$.titleBarStyle;if(i===c.NATIVE||i===c.CUSTOM)return i}return n.$l?c.NATIVE:c.CUSTOM}e.$eE=35;function f(b){return!(!n.$j||n.$p||d(b))}function g(b){const $=b.getValue("window");return!$||typeof $.nativeFullScreen!="boolean"||$.nativeTabs?!0:$.nativeFullScreen!==!1}function v(b=0){return Math.pow(1.2,b)}});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[52],le([0,1,13]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$Nfc=e.$Mfc=e.UnloadReason=e.LoadReason=void 0,n=Ve(n);var r;(function(c){c[c.INITIAL=1]="INITIAL",c[c.LOAD=2]="LOAD",c[c.RELOAD=3]="RELOAD"})(r||(e.LoadReason=r={}));var k;(function(c){c[c.CLOSE=1]="CLOSE",c[c.QUIT=2]="QUIT",c[c.RELOAD=3]="RELOAD",c[c.LOAD=4]="LOAD"})(k||(e.UnloadReason=k={}));const R=function(c=I.Normal){return{width:1024,height:768,mode:c}};e.$Mfc=R;const T=function(){const u=n.default.screen.getPrimaryDisplay().workArea,d=Math.max(u.x+u.width/2-800/2,0),w=Math.max(u.y+u.height/2-600/2,0);return{x:d,y:w,width:800,height:600,mode:I.Normal}};e.$Nfc=T;var I;(function(c){c[c.Maximized=0]="Maximized",c[c.Normal=1]="Normal",c[c.Minimized=2]="Minimized",c[c.Fullscreen=3]="Fullscreen",c[c.Custom=4]="Custom"})(I||(e.WindowMode=I={}));var p;(function(c){c[c.UNRESPONSIVE=1]="UNRESPONSIVE",c[c.PROCESS_GONE=2]="PROCESS_GONE",c[c.LOAD=3]="LOAD"})(p||(e.WindowError=p={}))}),define(ce[242],le([0,1,8,4,2]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=void 0;class R extends k.$Uc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:p,getActiveWindowId:c}){super(),this.a=this.B(new k.$Tc),r.Event.latch(r.Event.any(I,p))(this.f,this,this.a),this.b=(0,n.$sh)(()=>c()),(async()=>{try{const u=await this.b;this.c=typeof this.c=="number"?this.c:u}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$qhc=R}),define(ce[30],le([0,1,10,9,60,18,7,6,12]),function(x,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$5i=e.$4i=e.$3i=e.$2i=e.$Zi=e.$Yi=e.WorkbenchState=e.$Si=e.$Ri=e.$Oi=void 0,e.$Pi=c,e.$Qi=m,e.$Ti=u,e.$Ui=d,e.$Vi=w,e.$Wi=g,e.$Xi=v,e.$1i=P,e.$6i=E,e.$7i=i,e.$9i=h,e.$0i=t,e.$$i=o,e.$Oi=(0,I.$Fi)("contextService");function c(s){const a=s;return typeof a?.id=="string"&&T.URI.isUri(a.uri)}function m(s){return typeof s?.id=="string"&&!c(s)&&!d(s)}e.$Ri={id:"ext-dev"},e.$Si={id:"empty-window"};function u(s,a){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,r.$nc)(s)}:a?e.$Ri:e.$Si;const l=s;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}function d(s){const a=s;return typeof a?.id=="string"&&T.URI.isUri(a.configPath)}function w(s){const a=s;if(a?.uri)return{id:a.id,uri:T.URI.revive(a.uri)};const l=s;if(l?.configPath)return{id:l.id,configPath:T.URI.revive(l.configPath)};if(s?.id)return{id:s.id}}var f;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function g(s){const a=s;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}function v(s){const a=s;return!!(a&&typeof a=="object"&&T.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}class b{constructor(a,l,S,y,A){this.h=a,this.j=S,this.k=y,this.l=A,this.c=k.$Li.forUris(this.l,()=>!0),this.folders=l}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=k.$Li.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Yi=b;class ${constructor(a,l){this.raw=l,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,R.$gh)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Zi=$;function P(s){return new $({uri:s,index:0,name:(0,R.$ch)(s)},{uri:s.toString()})}e.$2i="code-workspace",e.$3i=`.${e.$2i}`,e.$4i=[{name:(0,n.localize)(11030,null),extensions:[e.$2i]}],e.$5i="workspace.json";function E(s,a){return R.$0g.isEqualOrParent(s,a.untitledWorkspacesHome)}function i(s){let a;return T.URI.isUri(s)?a=s:a=s.configuration,a?.scheme===p.Schemas.tmp}e.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function h(s){return s.id===e.$8i}function t(s,a){return!E(s,a)&&!i(s)}function o(s){return(typeof s=="string"?(0,r.$oc)(s):(0,R.$eh)(s))===e.$3i}});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[53],le([0,1,13,8,46,47,2,78,3,23,10,123,6,5,28,30]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tfc=e.$Sfc=void 0,n=Ve(n),e.$Sfc=(0,d.$Fi)("dialogMainService");let v=class{constructor($,P){this.d=$,this.e=P,this.a=new Map,this.b=new Map,this.c=new r.$Mh}pickFileFolder($,P){return this.f({...$,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(11571,null)},P)}pickFolder($,P){return this.f({...$,pickFolders:!0,title:(0,m.localize)(11572,null)},P)}pickFile($,P){return this.f({...$,pickFiles:!0,title:(0,m.localize)(11573,null)},P)}pickWorkspace($,P){const E=(0,m.localize)(11574,null),i=(0,R.$7w)((0,m.localize)(11575,null)),h=g.$4i;return this.f({...$,pickFiles:!0,title:E,filters:h,buttonLabel:i},P)}async f($,P){const E={title:$.title,buttonLabel:$.buttonLabel,filters:$.filters,defaultPath:$.defaultPath};(typeof $.pickFiles=="boolean"||typeof $.pickFolders=="boolean")&&(E.properties=void 0,$.pickFiles&&$.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",$.pickFolders?"openDirectory":"openFile","createDirectory"]),p.$k&&E.properties.push("treatPackageAsDirectory");const i=await this.showOpenDialog(E,(P||n.default.BrowserWindow.getFocusedWindow())??void 0);if(i&&i.filePaths&&i.filePaths.length>0)return i.filePaths}g($){if($){let P=this.b.get($.id);return P||(P=new r.$Mh,this.b.set($.id,P)),P}else return this.c}showMessageBox($,P){return this.g(P).queue(async()=>{const{options:E,buttonIndeces:i}=(0,u.$bx)($,this.e);let h;return P?h=await n.default.dialog.showMessageBox(P,E):h=await n.default.dialog.showMessageBox(E),{response:i[h.response],checkboxChecked:h.checkboxChecked}})}async showSaveDialog($,P){const E=this.j($,P);if(!E)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePath:""};try{return await this.g(P).queue(async()=>{let i;return P?i=await n.default.dialog.showSaveDialog(P,$):i=await n.default.dialog.showSaveDialog($),i.filePath=this.h(i.filePath),i})}finally{(0,T.$Pc)(E)}}h($){return $&&p.$k&&($=(0,I.$nm)($)),$}i($){return $.map(P=>this.h(P))}async showOpenDialog($,P){$.defaultPath&&(await c.Promises.exists($.defaultPath)||($.defaultPath=void 0));const E=this.j($,P);if(!E)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(P).queue(async()=>{let i;return P?i=await n.default.dialog.showOpenDialog(P,$):i=await n.default.dialog.showOpenDialog($),i.filePaths=this.i(i.filePaths),i})}finally{(0,T.$Pc)(E)}}j($,P){if(!P)return T.$Uc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",$);let E=this.a.get(P.id);E||(E=new Set,this.a.set(P.id,E));const i=(0,k.$tj)($);if(!E.has(i))return this.d.trace("[DialogMainService]: new file dialog lock created",$),E.add(i),(0,T.$Sc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",$),E?.delete(i),E?.size===0&&this.a.delete(P.id)})}};e.$Tfc=v,e.$Tfc=v=Se([se(0,w.$ak),se(1,f.$tk)],v)}),define(ce[243],le([0,1,4,2,82,30]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=void 0;class T extends r.$Uc{static{this.a=100}constructor(p,c){super(),this.f=p,this.g=c,this.b=this.B(new n.$le),this.c=new Map,this.h(c.applicationStorage,this.b)}h(p,c){this.B(n.Event.debounce(p.onDidChangeStorage,(m,u)=>(m?m.push(u):m=[u],m),T.a)(m=>{m.length&&c.fire(this.j(m,p))}))}j(p,c){const m=new Map,u=new Set;return p.forEach(d=>{const w=c.get(d.key);typeof w=="string"?m.set(d.key,w):u.add(d.key)}),{changed:Array.from(m.entries()),deleted:Array.from(u.values())}}listen(p,c,m){switch(c){case"onDidChangeStorage":{const u=m.profile?(0,k.$ci)(m.profile):void 0;if(!u)return this.b.event;let d=this.c.get(u.id);return d||(d=this.B(new n.$le),this.h(this.g.profileStorage(u),d),this.c.set(u.id,d)),d.event}}throw new Error(`Event not found: ${c}`)}async call(p,c,m){const u=m.profile?(0,k.$ci)(m.profile):void 0,d=(0,R.$Vi)(m.workspace),w=await this.m(u,d);switch(c){case"getItems":return Array.from(w.items.entries());case"updateItems":{const f=m;if(f.insert)for(const[g,v]of f.insert)w.set(g,v);f.delete?.forEach(g=>w.delete(g));break}case"optimize":return w.optimize();case"isUsed":{const f=m.payload;if(typeof f=="string")return this.g.isUsed(f)}default:throw new Error(`Call not found: ${c}`)}}async m(p,c){let m;c?m=this.g.workspaceStorage(c):p?m=this.g.profileStorage(p):m=this.g.applicationStorage;try{await m.init()}catch(u){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":p?"profile":"application"} storage due to ${u}`)}return m}}e.$7gc=T}),define(ce[42],le([0,1,46,4,2,18,7,10,38,14,6,5,30,31,41,8,33,25,11]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.$Ml=e.ProfileResourceType=void 0,e.$Ll=E,e.$Nl=i,e.$Ol=h;var P;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(P||(e.ProfileResourceType=P={}));function E(s){const a=s;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&T.URI.isUri(a.location)&&T.URI.isUri(a.globalStorageHome)&&T.URI.isUri(a.settingsResource)&&T.URI.isUri(a.keybindingsResource)&&T.URI.isUri(a.tasksResource)&&T.URI.isUri(a.snippetsHome)&&T.URI.isUri(a.extensionsResource))}e.$Ml=(0,m.$Fi)("IUserDataProfilesService");function i(s,a){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:T.URI.revive(s.location).with({scheme:a}),globalStorageHome:T.URI.revive(s.globalStorageHome).with({scheme:a}),settingsResource:T.URI.revive(s.settingsResource).with({scheme:a}),keybindingsResource:T.URI.revive(s.keybindingsResource).with({scheme:a}),tasksResource:T.URI.revive(s.tasksResource).with({scheme:a}),snippetsHome:T.URI.revive(s.snippetsHome).with({scheme:a}),extensionsResource:T.URI.revive(s.extensionsResource).with({scheme:a}),cacheHome:T.URI.revive(s.cacheHome).with({scheme:a}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function h(s,a,l,S,y,A){return{id:s,name:a,location:l,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:A&&y?.useDefaultFlags?.globalState?A.globalStorageHome:(0,R.$gh)(l,"globalStorage"),settingsResource:A&&y?.useDefaultFlags?.settings?A.settingsResource:(0,R.$gh)(l,"settings.json"),keybindingsResource:A&&y?.useDefaultFlags?.keybindings?A.keybindingsResource:(0,R.$gh)(l,"keybindings.json"),tasksResource:A&&y?.useDefaultFlags?.tasks?A.tasksResource:(0,R.$gh)(l,"tasks.json"),snippetsHome:A&&y?.useDefaultFlags?.snippets?A.snippetsHome:(0,R.$gh)(l,"snippets"),extensionsResource:A&&y?.useDefaultFlags?.extensions?A.extensionsResource:(0,R.$gh)(l,"extensions.json"),cacheHome:(0,R.$gh)(S,s),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let t=class extends k.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,l,S,y){super(),this.t=a,this.u=l,this.w=S,this.y=y,this.f=!0,this.h=this.B(new r.$le),this.onDidChangeProfiles=this.h.event,this.j=this.B(new r.$le),this.onWillCreateProfile=this.j.event,this.m=this.B(new r.$le),this.onWillRemoveProfile=this.m.event,this.n=this.B(new r.$le),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new w.$Ac,workspaces:new w.$Ac,emptyWindows:new Map},this.profilesHome=(0,R.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),l=[a];if(this.f)try{for(const A of this.O()){if(!A.name||!(0,$.$eg)(A.name)||!A.location){this.y.warn("Skipping the invalid stored profile",A.location||A.name);continue}l.push(h((0,R.$dh)(A.location),A.name,A.location,this.g,{shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags},a))}}catch(A){this.y.error(A)}const S=new w.$Ac,y=new Map;if(l.length)try{const A=this.Q();if(A.workspaces)for(const[L,D]of Object.entries(A.workspaces)){const O=T.URI.parse(L),M=l.find(Z=>Z.id===D);M&&S.set(O,M)}if(A.emptyWindows)for(const[L,D]of Object.entries(A.emptyWindows)){const O=l.find(M=>M.id===D);O&&y.set(L,O)}}catch(A){this.y.error(A)}this.z={profiles:l,workspaces:S,emptyWindows:y}}return this.z}D(){const a=h("__default__profile__",(0,I.localize)(11077,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const l="Temp",S=new RegExp(`${(0,b.$hf)(l)}\\s(\\d+)`);let y=0;for(const L of this.profiles){const D=S.exec(L.name),O=D?parseInt(D[1]):0;y=O>y?O:y}const A=`${l} ${y+1}`;return this.createProfile((0,n.$tj)((0,v.$2g)()).toString(16),A,{transient:!0},a)}async createNamedProfile(a,l,S){return this.createProfile((0,n.$tj)((0,v.$2g)()).toString(16),a,l,S)}async createProfile(a,l,S,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const A=await this.F(a,l,S);return y&&await this.setProfileForWorkspace(y,A),A}async F(a,l,S){if(!(0,$.$eg)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(l);return y||(y=(async()=>{try{if(this.profiles.find(O=>O.name===l||O.id===a))throw new Error(`Profile with ${l} name already exists`);const L=h(a,l,(0,R.$gh)(this.profilesHome,a),this.g,S,this.defaultProfile);await this.u.createFolder(L.location);const D=[];return this.j.fire({profile:L,join(O){D.push(O)}}),await g.Promises.settled(D),this.I([L],[],[]),L}finally{this.r.delete(l)}})(),this.r.set(l,y)),y}async updateProfile(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(y=>y.id===a.id);if(!S)throw new Error(`Profile '${a.name}' does not exist`);return S=h(S.id,l.name??S.name,S.location,this.g,{shortName:l.shortName??S.shortName,icon:l.icon===null?void 0:l.icon??S.icon,transient:l.transient??S.isTransient,useDefaultFlags:l.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(y=>y.id===a.id);if(!l)throw new Error(`Profile '${a.name}' does not exist`);const S=[];this.m.fire({profile:l,join(y){S.push(y)}});try{await Promise.allSettled(S)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(y){(0,c.$rl)(y)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(y=>y.id===l.id);if(!S)throw new Error(`Profile '${l.name}' does not exist`);this.L(a,S)}unsetWorkspace(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,l)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(l=>l.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(a.map(l=>this.removeProfile(l)))}getProfileForWorkspace(a){const l=this.G(a),S=T.URI.isUri(l)?this.C.workspaces.get(l):this.C.emptyWindows.get(l);return S||((0,d.$Pi)(a)?this.s.folders.get(a.uri):(0,d.$Ui)(a)?this.s.workspaces.get(a.configPath):this.s.emptyWindows.get(a.id))}G(a){return(0,d.$Pi)(a)?a.uri:(0,d.$Ui)(a)?a.configPath:a.id}H(a){return!!([...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.s.folders.values()].some(l=>this.w.extUri.isEqual(l.location,a.location)))}I(a,l,S){const y=[...this.profiles,...a],A=[],L=this.s.profiles;this.s.profiles=[];for(let D of y){if(D.isDefault||l.some(M=>D.id===M.id))continue;D=S.find(M=>D.id===M.id)??D;const O=L.find(M=>D.id===M.id);if(D.isTransient)this.s.profiles.push(D);else{if(O){for(const[M,Z]of this.s.emptyWindows.entries())if(D.id===Z.id){this.L({id:M},D);break}for(const[M,Z]of this.s.workspaces.entries())if(D.id===Z.id){this.L({id:"",configPath:M},D);break}for(const[M,Z]of this.s.folders.entries())if(D.id===Z.id){this.L({id:"",uri:M},D);break}}A.push({location:D.location,name:D.name,shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags})}}this.P(A),this.z=void 0,this.J(a,l,S)}J(a,l,S){this.h.fire({added:a,removed:l,updated:S,all:this.profiles})}L(a,l,S){if(S=l?.isTransient?!0:S,S)(0,d.$Pi)(a)?(this.s.folders.delete(a.uri),l&&this.s.folders.set(a.uri,l)):(0,d.$Ui)(a)?(this.s.workspaces.delete(a.configPath),l&&this.s.workspaces.set(a.configPath,l)):(this.s.emptyWindows.delete(a.id),l&&this.s.emptyWindows.set(a.id,l));else{this.L(a,void 0,!0);const y=this.G(a);T.URI.isUri(y)?(this.C.workspaces.delete(y),l&&this.C.workspaces.set(y,l)):(this.C.emptyWindows.delete(y),l&&this.C.emptyWindows.set(y,l)),this.M()}}M(){const a={};for(const[S,y]of this.C.workspaces.entries())a[S.toString()]=y.id;const l={};for(const[S,y]of this.C.emptyWindows.entries())l[S.toString()]=y.id;this.R({workspaces:a,emptyWindows:l}),this.z=void 0}N(a){const l={},S=this.D();if(a.workspaces)for(const[A,L]of Object.entries(a.workspaces)){const D=T.URI.parse(L);l[A]=this.w.extUri.isEqual(D,S.location)?S.id:this.w.extUri.basename(D)}const y={};if(a.emptyWindows)for(const[A,L]of Object.entries(a.emptyWindows)){const D=T.URI.parse(L);y[A]=this.w.extUri.isEqual(D,S.location)?S.id:this.w.extUri.basename(D)}return{workspaces:l,emptyWindows:y}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$Pl=t,e.$Pl=t=Se([se(0,p.$Mi),se(1,c.$al),se(2,f.$Kl),se(3,u.$ak)],t);class o extends t{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$Ql=o}),define(ce[86],le([0,1,8,17,2,4,31,7,126,129,14,6,5,42,41,11,15,24]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=e.$Iq=e.ExtensionsProfileScanningErrorCode=void 0;var $;(function(t){t.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",t.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})($||(e.ExtensionsProfileScanningErrorCode=$={}));class P extends Error{constructor(o,s){super(o),this.code=s}}e.$Iq=P,e.$Jq=(0,u.$Fi)("IExtensionsProfileScannerService");let E=class extends k.$Uc{constructor(o,s,a,l,S,y){super(),this.j=o,this.m=s,this.n=a,this.r=l,this.s=S,this.t=y,this.b=this.B(new R.$le),this.onAddExtensions=this.b.event,this.c=this.B(new R.$le),this.onDidAddExtensions=this.c.event,this.f=this.B(new R.$le),this.onRemoveExtensions=this.f.event,this.g=this.B(new R.$le),this.onDidRemoveExtensions=this.g.event,this.h=new T.$Ac}scanProfileExtensions(o,s){return this.u(o,void 0,s)}async addExtensionsToProfile(o,s,a){const l=[],S=[];try{return await this.u(s,y=>{const A=[];if(a)A.push(...y);else for(const L of y)o.some(([D])=>(0,c.$Mp)(D.identifier,L.identifier)&&D.manifest.version!==L.version)?l.push(L):A.push(L);for(const[L,D]of o){const O=A.findIndex(Z=>(0,c.$Mp)(Z.identifier,L.identifier)&&Z.version===L.manifest.version),M={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:D};O===-1?(S.push(M),A.push(M)):A.splice(O,1,M)}return S.length&&this.b.fire({extensions:S,profileLocation:s}),l.length&&this.f.fire({extensions:l,profileLocation:s}),A}),S.length&&this.c.fire({extensions:S,profileLocation:s}),l.length&&this.g.fire({extensions:l,profileLocation:s}),S}catch(y){throw S.length&&this.c.fire({extensions:S,error:y,profileLocation:s}),l.length&&this.g.fire({extensions:l,error:y,profileLocation:s}),y}}async updateMetadata(o,s){const a=[];return await this.u(s,l=>{const S=[];for(const y of l){const A=o.find(([L])=>(0,c.$Mp)(L.identifier,y.identifier)&&L.manifest.version===y.version);A&&(y.metadata={...y.metadata,...A[1]},a.push(y)),S.push(y)}return S}),a}async removeExtensionFromProfile(o,s){const a=[];try{await this.u(s,l=>{const S=[];for(const y of l)(0,c.$Mp)(y.identifier,o.identifier)?a.push(y):S.push(y);return a.length&&this.f.fire({extensions:a,profileLocation:s}),S}),a.length&&this.g.fire({extensions:a,profileLocation:s})}catch(l){throw a.length&&this.g.fire({extensions:a,error:l,profileLocation:s}),l}}async u(o,s,a){return this.F(o).queue(async()=>{let l=[],S;try{const y=await this.m.readFile(o);S=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,m.$rl)(y)!==m.FileOperationResult.FILE_NOT_FOUND)throw y;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(S=await this.D()),!S&&a?.bailOutWhenFileNotFound)throw new P((0,v.$9)(y),$.ERROR_PROFILE_NOT_FOUND)}if(S){Array.isArray(S)||this.w(o);let y=!1;for(const A of S){i(A)||this.w(o);let L;if((0,g.$eg)(A.relativeLocation)&&A.relativeLocation)L=this.z(A.relativeLocation);else if((0,g.$eg)(A.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${A.location}`);continue}else{L=I.URI.revive(A.location);const D=this.y(L);D&&(y=!0,A.relativeLocation=D)}(0,g.$lg)(A.metadata?.hasPreReleaseVersion)&&A.metadata?.preRelease&&(y=!0,A.metadata.hasPreReleaseVersion=!0),l.push({identifier:A.identifier,location:L,version:A.version,metadata:A.metadata})}y&&await this.m.writeFile(o,r.$Ne.fromString(JSON.stringify(S)))}if(s){l=s(l);const y=l.map(A=>({identifier:A.identifier,version:A.version,location:A.location.toJSON(),relativeLocation:this.y(A.location),metadata:A.metadata}));await this.m.writeFile(o,r.$Ne.fromString(JSON.stringify(y)))}return l})}w(o){const s=new P(`Invalid extensions content in ${o.toString()}`,$.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let a;try{a=(await this.m.readFile(o)).value.toString()}catch(S){if((0,m.$rl)(S)===m.FileOperationResult.FILE_NOT_FOUND)return;throw S}this.t.info("Migrating extensions from old default profile location",o.toString());let l;try{const S=JSON.parse(a);Array.isArray(S)&&S.every(y=>i(y))?l=S:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",S)}catch(S){this.t.error(S)}if(l)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,r.$Ne.fromString(JSON.stringify(l)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(S){if((0,m.$rl)(S)===m.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw S}try{await this.m.del(o)}catch(S){(0,m.$rl)(S)!==m.FileOperationResult.FILE_NOT_FOUND&&this.t.error(S)}try{await this.m.del(s)}catch(S){(0,m.$rl)(S)!==m.FileOperationResult.FILE_NOT_FOUND&&this.t.error(S)}return l})()),this.C}F(o){let s=this.h.get(o);return s||(s=new n.$Mh,this.h.set(o,s)),s}};e.$Kq=E,e.$Kq=E=Se([se(1,m.$al),se(2,w.$Ml),se(3,f.$Kl),se(4,b.$_l),se(5,d.$ak)],E);function i(t){return(0,g.$gg)(t)&&(0,p.$kp)(t.identifier)&&(h(t.location)||(0,g.$eg)(t.location)&&t.location)&&((0,g.$lg)(t.relativeLocation)||(0,g.$eg)(t.relativeLocation))&&t.version&&(0,g.$eg)(t.version)}function h(t){return t?(0,g.$eg)(t.path)&&(0,g.$eg)(t.scheme):!1}});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[133],le([0,1,21,8,37,17,15,43,163,2,12,9,3,18,210,81,11,7,10,38,129,85,209,14,6,5,28,4,82,86,42,41,171]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b,$,P,E,i,h,t,o,s,a,l,S,y,A,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Pq=e.$Oq=e.$Nq=e.Translations=void 0,e.$Qq=de,k=Pe(k),u=Pe(u),d=Pe(d),f=Pe(f),g=Ve(g);var O;(function(Y){function B(Q,W){if(Q===W)return!0;const j=Object.keys(Q),C=new Set;for(const X of Object.keys(W))C.add(X);if(j.length!==C.size)return!1;for(const X of j){if(Q[X]!==W[X])return!1;C.delete(X)}return C.size===0}Y.equals=B})(O||(e.Translations=O={})),e.$Nq=(0,o.$Fi)("IExtensionsScannerService");let M=class extends c.$Uc{constructor(B,Q,W,j,C,X,oe,V,ue,re,J,F){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=Q,this.r=W,this.s=j,this.t=C,this.u=X,this.w=oe,this.y=V,this.z=ue,this.C=re,this.D=J,this.F=F,this.g=this.B(new l.$le),this.onDidChangeCache=this.g.event,this.h=(0,w.$gh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(K,this.s,this.h)),this.m=this.B(this.F.createInstance(K,this.s,this.h)),this.n=this.B(this.F.createInstance(q,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(i.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(i.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,E.$Xp)(this.w,this.y)),this.G}async scanAllExtensions(B,Q,W){const[j,C]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(Q)]),X=W?await this.scanExtensionsUnderDevelopment(B,[...j,...C]):[];return this.L(j,C,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const Q=[];Q.push(this.M(!!B.useCache,B.language)),Q.push(this.N(B.language,!!B.checkControlFile));const[W,j]=await Promise.all(Q);return this.J([...W,...j],i.ExtensionType.System,B,!1)}async scanUserExtensions(B){const Q=B.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const W=this.D.extUri.isEqual(B.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,j=await this.P(Q,!!B.profileLocation,i.ExtensionType.User,!B.includeUninstalled,B.language,!0,W,B.productVersion??this.R()),C=B.useCache&&!j.devMode&&j.excludeObsolete?this.m:this.n;let X;try{X=await C.scanExtensions(j)}catch(oe){if(oe instanceof y.$Iq&&oe.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),X=await C.scanExtensions(j);else throw oe}return X=await this.J(X,i.ExtensionType.User,B,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(B,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const W=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(j=>j.scheme===m.Schemas.file).map(async j=>{const C=await this.P(j,!1,i.ExtensionType.User,!0,B.language,!1,void 0,B.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(C)).map(oe=>(oe.type=Q.find(V=>(0,E.$Mp)(V.identifier,oe.identifier))?.type??oe.type,this.n.validate(oe,C)))}))).flat();return this.J(W,"development",B,!0)}return[]}async scanExistingExtension(B,Q,W){const j=await this.P(B,!1,Q,!0,W.language,!0,void 0,W.productVersion??this.R()),C=await this.n.scanExtension(j);return!C||!W.includeInvalid&&!C.isValid?null:C}async scanOneOrMultipleExtensions(B,Q,W){const j=await this.P(B,!1,Q,!0,W.language,!0,void 0,W.productVersion??this.R()),C=await this.n.scanOneOrMultipleExtensions(j);return this.J(C,Q,W,!0)}async scanMultipleExtensions(B,Q,W){const j=[];return await Promise.all(B.map(async C=>{const X=await this.scanOneOrMultipleExtensions(C,Q,W);j.push(...X)})),this.J(j,Q,W,!0)}async scanMetadata(B){const Q=(0,w.$gh)(B,"package.json"),W=(await this.w.readFile(Q)).value.toString();return JSON.parse(W).__metadata}async updateMetadata(B,Q){const W=(0,w.$gh)(B,"package.json"),j=(await this.w.readFile(W)).value.toString(),C=JSON.parse(j);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,C.__metadata={...C.__metadata,...Q},await this.w.writeFile((0,w.$gh)(B,"package.json"),R.$Ne.fromString(JSON.stringify(C,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof y.$Iq&&B.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw B}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.u.addExtensionsToProfile(B.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,R.$Ne.fromString(JSON.stringify([])))}catch(Q){(0,t.$rl)(Q)!==t.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.$9)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.y.error(B)}finally{this.H=void 0}})()),this.H}async J(B,Q,W,j){return W.includeAllVersions||(B=this.L(Q===i.ExtensionType.System?B:void 0,Q===i.ExtensionType.User?B:void 0,Q==="development"?B:void 0,await this.getTargetPlatform(),j)),W.includeInvalid||(B=B.filter(C=>C.isValid)),B.sort((C,X)=>{const oe=u.$nc(C.location.fsPath),V=u.$nc(X.location.fsPath);return oe<V?-1:oe>V?1:0})}L(B,Q,W,j,C){const X=(V,ue,re)=>{if(V.isValid&&!ue.isValid)return!1;if(V.isValid===ue.isValid){if(C&&f.gt(V.manifest.version,ue.manifest.version))return this.y.debug(`Skipping extension ${ue.location.path} with lower version ${ue.manifest.version} in favour of ${V.location.path} with version ${V.manifest.version}`),!1;if(f.eq(V.manifest.version,ue.manifest.version)){if(V.type===i.ExtensionType.System)return this.y.debug(`Skipping extension ${ue.location.path} in favour of system extension ${V.location.path} with same version`),!1;if(V.targetPlatform===j)return this.y.debug(`Skipping extension ${ue.location.path} from different target platform ${ue.targetPlatform}`),!1}}return re?this.y.warn(`Overwriting user extension ${V.location.path} with ${ue.location.path}.`):this.y.debug(`Overwriting user extension ${V.location.path} with ${ue.location.path}.`),!0},oe=new i.$tn;return B?.forEach(V=>{const ue=oe.get(V.identifier.id);(!ue||X(ue,V,!1))&&oe.set(V.identifier.id,V)}),Q?.forEach(V=>{const ue=oe.get(V.identifier.id);if(!ue&&B&&V.type===i.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${V.location.path}.`);return}(!ue||X(ue,V,!1))&&oe.set(V.identifier.id,V)}),W?.forEach(V=>{const ue=oe.get(V.identifier.id);(!ue||X(ue,V,!0))&&oe.set(V.identifier.id,V),oe.set(V.identifier.id,V)}),[...oe.values()]}async M(B,Q){this.y.trace("Started scanning system extensions");const W=await this.P(this.systemExtensionsLocation,!1,i.ExtensionType.System,!0,Q,!0,void 0,this.R()),C=await(B&&!W.devMode?this.j:this.n).scanExtensions(W);return this.y.trace("Scanned system extensions:",C.length),C}async N(B,Q){const W=this.z.isBuilt?[]:this.C.builtInExtensions;if(!W?.length)return[];this.y.trace("Started scanning dev system extensions");const j=Q?await this.O():{},C=[],X=b.URI.file(u.$hc(u.$jc(m.$Zg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const V of W){const ue=j[V.name]||"marketplace";switch(ue){case"disabled":break;case"marketplace":C.push((0,w.$gh)(X,V.name));break;default:C.push(b.URI.file(ue));break}}const oe=await Promise.all(C.map(async V=>this.n.scanExtension(await this.P(V,!1,i.ExtensionType.System,!0,B,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",oe.length),(0,n.$Gb)(oe)}async O(){try{const B=await this.w.readFile(this.r);return JSON.parse(B.value.toString())}catch{return{}}}async P(B,Q,W,j,C,X,oe,V){const ue=await this.f(C??d.$x),re=await this.Q(B),J=Q&&!this.D.extUri.isEqual(B,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,F=J?await this.Q(J):void 0;return new Z(B,re,J,F,Q,oe,W,j,X,V.version,V.date,this.C.commit,!this.z.isBuilt,C,ue)}async Q(B){try{const Q=await this.w.stat(B);if(typeof Q.mtime=="number")return Q.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Oq=M,e.$Oq=M=Se([se(4,A.$Ml),se(5,y.$Jq),se(6,t.$al),se(7,s.$ak),se(8,P.$Mi),se(9,a.$tk),se(10,L.$Kl),se(11,o.$Ei)],M);class Z{constructor(B,Q,W,j,C,X,oe,V,ue,re,J,F,N,_,z){this.location=B,this.mtime=Q,this.applicationExtensionslocation=W,this.applicationExtensionslocationMtime=j,this.profile=C,this.profileScanOptions=X,this.type=oe,this.excludeObsolete=V,this.validate=ue,this.productVersion=re,this.productDate=J,this.productCommit=F,this.devMode=N,this.language=_,this.translations=z}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,Q){return(0,w.$_g)(B.location,Q.location)&&B.mtime===Q.mtime&&(0,w.$_g)(B.applicationExtensionslocation,Q.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&B.profile===Q.profile&&k.$io(B.profileScanOptions,Q.profileScanOptions)&&B.type===Q.type&&B.excludeObsolete===Q.excludeObsolete&&B.validate===Q.validate&&B.productVersion===Q.productVersion&&B.productDate===Q.productDate&&B.productCommit===Q.productCommit&&B.devMode===Q.devMode&&B.language===Q.language&&O.equals(B.translations,Q.translations)}}e.$Pq=Z;let q=class extends c.$Uc{constructor(B,Q,W,j,C,X,oe){super(),this.g=B,this.h=Q,this.j=W,this.m=j,this.n=X,this.r=oe,this.f=C.extensionsEnabledWithApiProposalVersion?.map(V=>V.toLowerCase())??[]}async scanExtensions(B){const Q=B.profile?await this.t(B):await this.s(B);let W={};if(B.excludeObsolete&&B.type===i.ExtensionType.User)try{const j=(await this.m.readFile(this.g)).value.toString();W=JSON.parse(j)}catch{}return(0,v.$rg)(W)?Q:Q.filter(j=>!W[E.$Np.create(j).toString()])}async s(B){const Q=await this.m.resolve(B.location);if(!Q.children?.length)return[];const W=await Promise.all(Q.children.map(async j=>{if(!j.isDirectory||B.type===i.ExtensionType.User&&(0,w.$dh)(j.resource).indexOf(".")===0)return null;const C=new Z(j.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(C)}));return(0,n.$Gb)(W).sort((j,C)=>j.location.path<C.location.path?-1:1)}async t(B){let Q=await this.u(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.j.extUri.isEqual(B.location,B.applicationExtensionslocation)){Q=Q.filter(j=>!j.metadata?.isApplicationScoped);const W=await this.u(B.applicationExtensionslocation,j=>!!j.metadata?.isBuiltin||!!j.metadata?.isApplicationScoped,B);Q.push(...W)}return Q}async u(B,Q,W){const j=await this.h.scanProfileExtensions(B,W.profileScanOptions);if(!j.length)return[];const C=await Promise.all(j.map(async X=>{if(Q(X)){const oe=new Z(X.location,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(oe,X.metadata)}return null}));return(0,n.$Gb)(C)}async scanOneOrMultipleExtensions(B){try{if(await this.m.exists((0,w.$gh)(B.location,"package.json"))){const Q=await this.scanExtension(B);return Q?[Q]:[]}else return await this.scanExtensions(B)}catch(Q){return this.r.error(`Error scanning extensions at ${B.location.path}:`,(0,T.$9)(Q)),[]}}async scanExtension(B,Q){try{let W=await this.w(B.location);if(W){W.publisher||(W.publisher=i.$nn),Q=Q??W.__metadata,delete W.__metadata;const j=(0,E.$Rp)(W.publisher,W.name),C=Q?.id?{id:j,uuid:Q.id}:{id:j},X=Q?.isSystem?i.ExtensionType.System:B.type,oe=X===i.ExtensionType.System||!!Q?.isBuiltin;W=await this.y(B.location,W,Z.createNlsConfiguration(B));let V={type:X,identifier:C,manifest:W,location:B.location,isBuiltin:oe,targetPlatform:Q?.targetPlatform??i.TargetPlatform.UNDEFINED,publisherDisplayName:Q?.publisherDisplayName,metadata:Q,isValid:!0,validations:[]};return B.validate&&(V=this.validate(V,B)),W.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(j.toLowerCase()))&&(W.originalEnabledApiProposals=W.enabledApiProposals,W.enabledApiProposals=(0,i.$zn)([...W.enabledApiProposals])),V}}catch(W){B.type!==i.ExtensionType.System&&this.r.error(W)}return null}validate(B,Q){let W=!0;const j=this.n.isBuilt&&this.f.includes(B.identifier.id.toLowerCase()),C=(0,h.$4p)(Q.productVersion,Q.productDate,Q.location,B.manifest,B.isBuiltin,j);for(const[X,oe]of C)X===g.default.Error&&(W=!1,this.r.error(this.F(Q.location,oe)));return B.isValid=W,B.validations=C,B}async w(B){const Q=(0,w.$gh)(B,"package.json");let W;try{W=(await this.m.readFile(Q)).value.toString()}catch(C){return(0,t.$rl)(C)!==t.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(B,(0,$.localize)(11461,null,Q.path,C.message))),null}let j;try{j=JSON.parse(W)}catch{const X=[];(0,I.$Yn)(W,X);for(const oe of X)this.r.error(this.F(B,(0,$.localize)(11462,null,Q.path,oe.offset,oe.length,(0,p.$Lq)(oe.error))));return null}return(0,I.$7n)(j)!=="object"?(this.r.error(this.F(B,(0,$.localize)(11463,null,Q.path))),null):j}async y(B,Q,W){const j=await this.z(B,Q,W);if(j)try{const C=[],X=await this.C(j.default,C);if(C.length>0)return C.forEach(V=>{this.r.error(this.F(B,(0,$.localize)(11464,null,j.default?.path,(0,p.$Lq)(V.error))))}),Q;if((0,I.$7n)(j)!=="object")return this.r.error(this.F(B,(0,$.localize)(11465,null,j.default?.path))),Q;const oe=j.values||Object.create(null);return(0,D.$Mq)(this.r,Q,oe,X)}catch{}return Q}async z(B,Q,W){const j=(0,w.$gh)(B,"package.nls.json"),C=(ue,re)=>{re.forEach(J=>{this.r.error(this.F(B,(0,$.localize)(11466,null,ue?.path,(0,p.$Lq)(J.error))))})},X=ue=>{this.r.error(this.F(B,(0,$.localize)(11467,null,ue?.path)))},oe=`${Q.publisher}.${Q.name}`,V=W.translations[oe];if(V)try{const ue=b.URI.file(V),re=(await this.m.readFile(ue)).value.toString(),J=[],F=(0,I.$Yn)(re,J);return J.length>0?(C(ue,J),{values:void 0,default:j}):(0,I.$7n)(F)!=="object"?(X(ue),{values:void 0,default:j}):{values:F.contents?F.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.m.exists(j))return;let re;try{re=await this.D(B,W)}catch{return}if(!re.localized)return{values:void 0,default:re.original};try{const J=(await this.m.readFile(re.localized)).value.toString(),F=[],N=(0,I.$Yn)(J,F);return F.length>0?(C(re.localized,F),{values:void 0,default:re.original}):(0,I.$7n)(N)!=="object"?(X(re.localized),{values:void 0,default:re.original}):{values:N,default:re.original}}catch{return{values:void 0,default:re.original}}}}async C(B,Q){if(B)try{const W=(await this.m.readFile(B)).value.toString();return(0,I.$Yn)(W,Q)}catch{}}D(B,Q){return new Promise((W,j)=>{const C=X=>{const oe=(0,w.$gh)(B,`package.nls.${X}.json`);this.m.exists(oe).then(V=>{V&&W({localized:oe,original:(0,w.$gh)(B,"package.nls.json")});const ue=X.lastIndexOf("-");ue===-1?W({localized:(0,w.$gh)(B,"package.nls.json"),original:null}):(X=X.substring(0,ue),C(X))})};if(Q.devMode||Q.pseudo||!Q.language)return W({localized:(0,w.$gh)(B,"package.nls.json"),original:null});C(Q.language)})}F(B,Q){return`[${B.path}]: ${Q}`}};q=Se([se(1,y.$Jq),se(2,L.$Kl),se(3,t.$al),se(4,a.$tk),se(5,P.$Mi),se(6,s.$ak)],q);let K=class extends q{constructor(B,Q,W,j,C,X,oe,V,ue){super(Q,j,C,X,oe,V,ue),this.J=B,this.L=W,this.H=this.B(new r.$Dh(3e3)),this.I=this.B(new l.$le),this.onDidChangeCache=this.I.event}async scanExtensions(B){const Q=this.P(B),W=await this.M(Q);if(this.G=B,W&&W.input&&Z.equals(W.input,this.G))return this.r.debug("Using cached extensions scan result",B.type===i.ExtensionType.System?"system":"user",B.location.toString()),this.H.trigger(()=>this.O()),W.result.map(C=>(C.location=b.URI.revive(C.location),C));const j=await super.scanExtensions(B);return await this.N(Q,{input:B,result:j}),j}async M(B){try{const Q=await this.m.readFile(B),W=JSON.parse(Q.value.toString());return{result:W.result,input:(0,S.$ci)(W.input)}}catch(Q){this.r.debug("Error while reading the extension cache file:",B.path,(0,T.$9)(Q))}return null}async N(B,Q){try{await this.m.writeFile(B,R.$Ne.fromString(JSON.stringify(Q)))}catch(W){this.r.debug("Error while writing the extension cache file:",B.path,(0,T.$9)(W))}}async O(){if(!this.G)return;const B=this.P(this.G),Q=await this.M(B);if(!Q)return;const W=Q.result,j=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!k.$io(j,W))try{this.r.info("Invalidating Cache",W,j),await this.m.del(B),this.I.fire()}catch(C){this.r.error(C)}}P(B){const Q=this.Q(B);return this.j.extUri.joinPath(Q.cacheHome,B.type===i.ExtensionType.System?i.$mn:i.$ln)}Q(B){return B.type===i.ExtensionType.System?this.L.defaultProfile:B.profile?this.j.extUri.isEqual(B.location,this.J.extensionsResource)?this.J:this.L.profiles.find(Q=>this.j.extUri.isEqual(B.location,Q.extensionsResource))??this.J:this.L.defaultProfile}};K=Se([se(2,A.$Ml),se(3,y.$Jq),se(4,L.$Kl),se(5,t.$al),se(6,a.$tk),se(7,P.$Mi),se(8,s.$ak)],K);function de(Y,B){const Q=(0,E.$Pp)(Y.manifest.publisher,Y.manifest.name);return{id:Q,identifier:new i.$rn(Q),isBuiltin:Y.type===i.ExtensionType.System,isUserBuiltin:Y.type===i.ExtensionType.User&&Y.isBuiltin,isUnderDevelopment:B,extensionLocation:Y.location,uuid:Y.identifier.uuid,targetPlatform:Y.targetPlatform,publisherDisplayName:Y.publisherDisplayName,...Y.manifest}}class H extends M{constructor(B,Q,W,j,C,X,oe,V,ue,re,J,F){super(B,Q,(0,w.$gh)(W,".vscode-oss-dev","extensions","control.json"),j,C,X,oe,V,ue,re,J,F),this.S=(async()=>{if(d.$A)try{const N=await this.w.readFile(b.URI.file(d.$A));return JSON.parse(N.value.toString())}catch{}return Object.create(null)})()}f(B){return this.S}}e.$Rq=H}),define(ce[244],le([0,1,5,42,41,24,86,14,38,7]),function(x,e,n,r,k,R,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JR=void 0;let m=class extends T.$Kq{constructor(d,w,f,g,v,b){super(c.URI.file(d.extensionsPath),w,f,g,v,b)}};e.$JR=m,e.$JR=m=Se([se(0,p.$Ni),se(1,I.$al),se(2,r.$Ml),se(3,k.$Kl),se(4,R.$_l),se(5,n.$ak)],m)}),define(ce[245],le([0,1,7,38,86,133,14,6,5,28,41,42]),function(x,e,n,r,k,R,T,I,p,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=void 0;let d=class extends R.$Rq{constructor(f,g,v,b,$,P,E,i){super(n.URI.file($.builtinExtensionsPath),n.URI.file($.extensionsPath),$.userHome,f.defaultProfile,f,g,v,b,$,P,E,i)}};e.$uhc=d,e.$uhc=d=Se([se(0,u.$Ml),se(1,k.$Jq),se(2,T.$al),se(3,p.$ak),se(4,r.$Ni),se(5,c.$tk),se(6,m.$Kl),se(7,I.$Ei)],d)}),define(ce[246],le([0,1,13,2,12,9,3,60,7,33,35,38,5,42]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=void 0;let f=class extends r.$Uc{constructor(v,b,$){super(),this.c=v,this.f=$,this.a=I.$Li.forPaths(!T.$l),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(v.appRoot),this.addValidFileRoot(v.extensionsPath),this.addValidFileRoot(b.defaultProfile.globalStorageHome.with({scheme:k.Schemas.file}).fsPath),this.addValidFileRoot(v.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:v}=n.session;v.protocol.registerFileProtocol(k.Schemas.vscodeFileResource,(b,$)=>this.j(b,$)),v.protocol.interceptFileProtocol(k.Schemas.file,(b,$)=>this.h(b,$)),this.B((0,r.$Sc)(()=>{v.protocol.unregisterProtocol(k.Schemas.vscodeFileResource),v.protocol.uninterceptProtocol(k.Schemas.file)}))}addValidFileRoot(v){const b=(0,R.$hc)(v);return this.a.get(b)?r.$Uc.None:(this.a.set(b,!0),(0,r.$Sc)(()=>this.a.delete(b)))}h(v,b){const $=p.URI.parse(v.url);return this.f.error(`Refused to load resource ${$.fsPath} from ${k.Schemas.file}: protocol (original URL: ${v.url})`),b({error:-3})}j(v,b){const $=this.m(v);let P;return this.c.crossOriginIsolated&&((0,R.$nc)($)==="workbench.html"||(0,R.$nc)($)==="workbench-dev.html"?P=k.COI.CoopAndCoep:P=k.COI.getHeadersFromQuery(v.url)),this.a.findSubstr($)?b({path:$,headers:P}):this.b.has((0,R.$oc)($).toLowerCase())?b({path:$}):(this.f.error(`${k.Schemas.vscodeFileResource}: Refused to load resource ${$} from ${k.Schemas.vscodeFileResource}: protocol (original URL: ${v.url})`),b({error:-3}))}m(v){const b=p.URI.parse(v.url),$=k.$Zg.uriToFileUri(b);return(0,R.$hc)($.fsPath)}createIPCObjectUrl(){let v;const b=p.URI.from({scheme:"vscode",path:(0,c.$2g)()}),$=b.toString(),P=async()=>v;return m.$WX.handle($,P),this.f.trace(`IPC Object URL: Registered new channel ${$}.`),{resource:b,update:E=>v=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${$}.`),m.$WX.removeHandler($)}}}};e.$Ohc=f,e.$Ohc=f=Se([se(0,u.$Ni),se(1,w.$Ml),se(2,d.$ak)],f)}),define(ce[62],le([0,1,8,4,2,70,11,119,6,42]),function(x,e,n,r,k,R,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$kq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$iq=e.$hq=e.$gq=void 0,e.$jq=w,e.$lq=g,e.$nq=b,e.$gq="__$__isNewStorageMarker",e.$hq="__$__targetStorageMarker",e.$iq=(0,p.$Fi)("storageService");var m;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(m||(e.WillSaveStateReason=m={}));var u;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(u||(e.StorageScope=u={}));var d;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function w($){const P=$.get(e.$hq);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}class f extends k.$Uc{static{this.a=60*1e3}constructor(P={flushInterval:f.a}){super(),this.m=P,this.b=this.B(new r.$oe),this.c=this.B(new r.$oe),this.onDidChangeTarget=this.c.event,this.f=this.B(new r.$le),this.onWillSaveState=this.f.event,this.h=this.B(new n.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new k.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(P,E,i){return r.Event.filter(this.b.event,h=>h.scope===P&&(E===void 0||h.key===E),i)}n(){this.j.value=(0,n.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,k.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(P,E){const{key:i,external:h}=E;if(i===e.$hq){switch(P){case u.APPLICATION:this.H=void 0;break;case u.PROFILE:this.F=void 0;break;case u.WORKSPACE:this.C=void 0;break}this.c.fire({scope:P})}else this.b.fire({scope:P,key:i,target:this.J(P)[i],external:h})}w(P){this.f.fire({reason:P})}get(P,E,i){return this.P(E)?.get(P,i)}getBoolean(P,E,i){return this.P(E)?.getBoolean(P,i)}getNumber(P,E,i){return this.P(E)?.getNumber(P,i)}getObject(P,E,i){return this.P(E)?.getObject(P,i)}storeAll(P,E){this.y(()=>{for(const i of P)this.store(i.key,i.value,i.scope,i.target,E)})}store(P,E,i,h,t=!1){if((0,T.$ng)(E)){this.remove(P,i,t);return}this.y(()=>{this.z(P,i,h),this.P(i)?.set(P,E,t)})}remove(P,E,i=!1){this.y(()=>{this.z(P,E,void 0),this.P(E)?.delete(P,i)})}y(P){this.b.pause(),this.c.pause();try{P()}finally{this.b.resume(),this.c.resume()}}keys(P,E){const i=[],h=this.J(P);for(const t of Object.keys(h))h[t]===E&&i.push(t);return i}z(P,E,i,h=!1){const t=this.J(E);typeof i=="number"?t[P]!==i&&(t[P]=i,this.P(E)?.set(e.$hq,JSON.stringify(t),h)):typeof t[P]=="number"&&(delete t[P],this.P(E)?.set(e.$hq,JSON.stringify(t),h))}get D(){return this.C||(this.C=this.L(u.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(u.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(u.APPLICATION)),this.H}J(P){switch(P){case u.APPLICATION:return this.I;case u.PROFILE:return this.G;default:return this.D}}L(P){const E=this.P(P);return E?w(E):Object.create(null)}isNew(P){return this.getBoolean(e.$gq,P)===!0}async flush(P=m.NONE){this.f.fire({reason:P});const E=this.P(u.APPLICATION),i=this.P(u.PROFILE),h=this.P(u.WORKSPACE);switch(P){case m.NONE:await n.Promises.settled([E?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await n.Promises.settled([E?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve()]);break}}async log(){const P=this.P(u.APPLICATION)?.items??new Map,E=this.P(u.PROFILE)?.items??new Map,i=this.P(u.WORKSPACE)?.items??new Map;return b(P,E,i,this.Q(u.APPLICATION)??"",this.Q(u.PROFILE)??"",this.Q(u.WORKSPACE)??"")}async optimize(P){return await this.flush(),this.P(P)?.optimize()}async switch(P,E){return this.w(m.NONE),(0,c.$Ll)(P)?this.R(P,E):this.S(P,E)}M(P,E){return!(P.id===E.id||g(E)&&g(P))}N(P,E,i){this.y(()=>{const h=new Set;for(const[t,o]of P)h.add(t),E.get(t)!==o&&this.u(i,{key:t,external:!0});for(const[t]of E.items)h.has(t)||this.u(i,{key:t,external:!0})})}}e.$kq=f;function g($){return $.isDefault||!!$.useDefaultFlags?.globalState}class v extends f{constructor(){super(),this.U=this.B(new I.$eq(new I.$fq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$eq(new I.$fq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$eq(new I.$fq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(P=>this.u(u.WORKSPACE,P))),this.B(this.W.onDidChangeStorage(P=>this.u(u.PROFILE,P))),this.B(this.U.onDidChangeStorage(P=>this.u(u.APPLICATION,P)))}P(P){switch(P){case u.APPLICATION:return this.U;case u.PROFILE:return this.W;default:return this.X}}Q(P){switch(P){case u.APPLICATION:return"inMemory (application)";case u.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(P){return!1}}e.$mq=v;async function b($,P,E,i,h,t){const o=O=>{try{return JSON.parse(O)}catch{return O}},s=new Map,a=new Map;$.forEach((O,M)=>{s.set(M,O),a.set(M,o(O))});const l=new Map,S=new Map;P.forEach((O,M)=>{l.set(M,O),S.set(M,o(O))});const y=new Map,A=new Map;E.forEach((O,M)=>{y.set(M,O),A.set(M,o(O))}),console.group(i!==h?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const L=[];if(s.forEach((O,M)=>{L.push({key:M,value:O})}),console.table(L),console.groupEnd(),console.log(a),i!==h){console.group(`Storage: Profile (path: ${h}, profile specific)`);const O=[];l.forEach((M,Z)=>{O.push({key:Z,value:M})}),console.table(O),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${t})`);const D=[];y.forEach((O,M)=>{D.push({key:M,value:O})}),console.table(D),console.groupEnd(),console.log(A)}}),define(ce[247],le([0,1,17,33,62]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=R;async function R(T,I,p){let c=p&&p.get("storage.serviceMachineId",k.StorageScope.APPLICATION)||null;if(c)return c;try{const u=(await I.readFile(T.serviceMachineIdResource)).value.toString();c=(0,r.$1g)(u)?u:null}catch{c=null}if(!c){c=(0,r.$2g)();try{await I.writeFile(T.serviceMachineIdResource,n.$Ne.fromString(c))}catch{}}return p?.store("storage.serviceMachineId",c,k.StorageScope.APPLICATION,k.StorageTarget.MACHINE),c}}),define(ce[248],le([0,1,247,24,57]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=R;async function R(T,I,p,c,m,u,d){const w={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${I.nameShort})`};if((0,k.$Ep)(I,p)&&(0,k.$Gp)(c)===r.TelemetryLevel.USAGE){const f=await(0,n.$oq)(p,m,u);w["X-Market-User-Id"]=f,w["VSCode-SessionId"]=d.machineId||f}return w}}),define(ce[249],le([0,1,26,21,8,4,2,9,66,7,23,119,161,5,62,24,30,12]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=e.$igc=e.$hgc=e.$ggc=void 0,n=Pe(n);class $ extends T.$Uc{static{this.a=2e3}get storage(){return this.f}constructor(s,a){super(),this.m=s,this.n=a,this.b=this.B(new R.$le),this.onDidChangeStorage=this.b.event,this.c=this.B(new R.$le),this.onDidCloseStorage=this.c.event,this.f=this.B(new u.$eq(new u.$fq,{hint:u.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new k.$3h,this.whenInit=this.h.p,this.j=u.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===u.StorageState.None)try{const s=this.B(await this.t());this.f.dispose(),this.f=s,this.B(s.onDidChangeStorage(l=>this.b.fire(l))),await this.s(s);const a=s.getBoolean(f.$gq);a===void 0?s.set(f.$gq,!0):a&&s.set(f.$gq,!1)}catch(s){this.m.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.j=u.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===w.LogLevel.Trace?s=>this.m.trace(s):void 0,logError:s=>this.m.error(s)}}s(s){return s.init()}get items(){return this.f.items}get(s,a){return this.f.get(s,a)}set(s,a){return this.f.set(s,a)}delete(s){return this.f.delete(s)}optimize(){return this.f.optimize()}async close(){const s=new p.$fe(!1);await this.w(),s.stop(),s.elapsed()>$.a&&await this.u(s),this.c.fire()}async u(s){if(this.path)try{const a=(0,r.top)(Array.from(this.f.items.entries()).map(([S,y])=>({key:S,length:y.length})),(S,y)=>y.length-S.length,5).map(S=>`${S.key}:${S.length}`).join(", "),l=(await this.n.stat(c.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${l}b, Large Keys: ${a}`)}catch(a){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",a)}}async w(){this.g&&await this.g,this.j=u.StorageState.Closed,await this.f.close()}}class P extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,I.$jc)(this.z.globalStorageHome.with({scheme:b.Schemas.file}).fsPath,P.y)}constructor(s,a,l,S){super(l,S),this.z=s,this.C=a}async t(){return new u.$eq(new d.$pY(this.path??d.$pY.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:u.StorageHint.STORAGE_IN_MEMORY})}}class E extends P{constructor(s,a,l,S){super(s,a,l,S)}}e.$ggc=E;class i extends P{constructor(s,a,l,S){super(a.defaultProfile,s,l,S)}async s(s){await super.s(s),this.G(s)}G(s){s.get(g.$cm,void 0)===void 0&&s.set(g.$cm,new Date().toUTCString());const l=s.get(g.$bm,void 0),S=new Date().toUTCString();s.set(g.$dm,typeof l>"u"?null:l),s.set(g.$bm,S)}}e.$hgc=i;class h extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,I.$jc)(this.F.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.C.id,h.y)}constructor(s,a,l,S,y){super(l,y),this.C=s,this.D=a,this.F=S}async t(){const{storageFilePath:s,wasCreated:a}=await this.H();return new u.$eq(new d.$pY(s,{logging:this.r()}),{hint:this.D.useInMemoryStorage?u.StorageHint.STORAGE_IN_MEMORY:a?u.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:d.$pY.IN_MEMORY_PATH,wasCreated:!0};const s=(0,I.$jc)(this.F.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.C.id),a=(0,I.$jc)(s,h.y);return await m.Promises.exists(s)?{storageFilePath:a,wasCreated:!1}:(await n.promises.mkdir(s,{recursive:!0}),this.I(s),{storageFilePath:a,wasCreated:!0})}async I(s){let a;if((0,v.$Pi)(this.C)?a={folder:this.C.uri.toString()}:(0,v.$Ui)(this.C)&&(a={workspace:this.C.configPath.toString()}),a)try{const l=(0,I.$jc)(s,h.z);await m.Promises.exists(l)||await m.Promises.writeFile(l,JSON.stringify(a,void 0,2))}catch(l){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.$igc=h;class t extends ${get path(){}async t(){return new u.$eq(new u.$fq,{hint:u.StorageHint.STORAGE_IN_MEMORY})}}e.$jgc=t}),define(ce[250],le([0,1,4,2,62]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=void 0;class R extends r.$Uc{constructor(I,p,c){super(),this.b=I,this.c=p,this.f=c;const m=this.B(new r.$Vc);this.a=this.B(new n.$le({onWillAddFirstListener:()=>m.value=this.g(),onDidRemoveLastListener:()=>m.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new r.$Tc;return I.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(p,c)=>(p?p.push(c.key):p=[c.key],p),100)(p=>this.h(p))),I.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(p,c)=>{p||(p=new Map);let m=p.get(c.profile.id);return m||p.set(c.profile.id,m={profile:c.profile,keys:[],storage:c.storage}),m.keys.push(c.key),p},100)(p=>this.j(p))),I}h(I){const p=I.includes(k.$hq)?[this.c.defaultProfile]:[],c=[];if(I=I.filter(m=>m!==k.$hq),I.length){const m=(0,k.$jq)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:I.map(u=>({key:u,scope:k.StorageScope.PROFILE,target:m[u]}))})}this.m(p,c)}j(I){const p=[],c=new Map;for(const[m,u]of I.entries()){u.keys.includes(k.$hq)&&p.push(u.profile);const d=u.keys.filter(w=>w!==k.$hq);if(d.length){const w=(0,k.$jq)(u.storage.storage);c.set(m,{profile:u.profile,changes:d.map(f=>({key:f,scope:k.StorageScope.PROFILE,target:w[f]}))})}}this.m(p,[...c.values()])}m(I,p){(I.length||p.length)&&this.a.fire({valueChanges:p,targetChanges:I})}listen(I,p,c){switch(p){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${p}`)}async call(I,p){throw new Error(`Call not found: ${p}`)}}e.$whc=R}),define(ce[251],le([0,1,7,38,14,5,34,41,42,11,127]),function(x,e,n,r,k,R,T,I,p,c,m){"use strict";var u,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$IR=e.$HR=e.$GR=void 0;let w=class extends p.$Pl{static{u=this}static{this.a="profileAssociationsMigration"}constructor(b,$,P,E,i){super(P,E,$,i),this.U=b,this.W=P}O(){return this.U.getItem(u.b,[]).map($=>({...$,location:(0,c.$eg)($.location)?this.w.extUri.joinPath(this.profilesHome,$.location):n.URI.revive($.location)}))}Q(){const b=this.U.getItem(u.c,{});return this.U.getItem(u.a,!1)?b:this.N(b)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$GR=w,e.$GR=w=u=Se([se(0,T.$BR),se(1,I.$Kl),se(2,r.$Ni),se(3,k.$al),se(4,R.$ak)],w);let f=d=class extends w{constructor(b,$,P,E,i){super(b,$,P,E,i),this.$=b}P(b){b.length?this.$.setItem(d.b,b.map($=>({...$,location:this.w.extUri.basename($.location)}))):this.$.removeItem(d.b)}O(){const b=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(b),this.$.setItem("userDataProfilesMigration",!0)),b}R(b){b.emptyWindows||b.workspaces?this.$.setItem(d.c,b):this.$.removeItem(d.c)}Q(){const b="workspaceAndProfileInfo",$=this.$.getItem(b,void 0);if($){this.$.removeItem(b);const E=$.reduce((i,{workspace:h,profile:t})=>(i[n.URI.revive(h).toString()]=n.URI.revive(t).toString(),i),{});this.$.setItem(d.c,{workspaces:E})}const P=super.Q();return this.$.getItem(d.a,!1)||(this.R(P),this.$.setItem(d.a,!0)),P}};e.$HR=f,e.$HR=f=d=Se([se(0,T.$CR),se(1,I.$Kl),se(2,r.$Ni),se(3,k.$al),se(4,R.$ak)],f);let g=class extends f{constructor(b,$,P,E){super(new m.$FR(m.SaveStrategy.IMMEDIATE,$,E,P),b,$,P,E)}async init(){return await this.$.init(),super.init()}};e.$IR=g,e.$IR=g=Se([se(0,I.$Kl),se(1,r.$Ni),se(2,k.$al),se(3,R.$ak)],g)}),define(ce[58],le([0,1,38,14,6,5,41,42,251,34]),function(x,e,n,r,k,R,T,I,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=e.$1fc=void 0,e.$1fc=(0,k.$Gi)(I.$Ml);let m=class extends p.$HR{constructor(d,w,f,g,v){super(d,w,f,g,v)}getAssociatedEmptyWindows(){const d=[];for(const w of this.C.emptyWindows.keys())d.push({id:w});return d}};e.$2fc=m,e.$2fc=m=Se([se(0,c.$CR),se(1,T.$Kl),se(2,n.$Ni),se(3,r.$al),se(4,R.$ak)],m)}),define(ce[134],le([0,1,18,7,30]),function(x,e,n,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=R,e.$4fc=T,e.$5fc=I;async function R(p,c,m){for(const d of p){const w=d.openedWorkspace;if((0,k.$Ui)(w)){const f=await m(w);if(f){if(f.folders.some(g=>n.$0g.isEqualOrParent(c,g.uri)))return d}else if(n.$0g.isEqualOrParent(c,w.configPath))return d}}const u=p.filter(d=>(0,k.$Pi)(d.openedWorkspace)&&n.$0g.isEqualOrParent(c,d.openedWorkspace.uri));if(u.length)return u.sort((d,w)=>-(d.openedWorkspace.uri.path.length-w.openedWorkspace.uri.path.length))[0]}function T(p,c){for(const m of p)if((0,k.$Ui)(m.openedWorkspace)&&n.$0g.isEqual(m.openedWorkspace.configPath,c)||(0,k.$Pi)(m.openedWorkspace)&&n.$0g.isEqual(m.openedWorkspace.uri,c))return m}function I(p,c){const m=u=>c.some(d=>n.$0g.isEqual(r.URI.file(d),r.URI.file(u)));for(const u of p)if(u.config?.extensionDevelopmentPath?.some(d=>m(d)))return u}}),define(ce[102],le([0,1,32,43,107,47,12,9,3,18,7,6,74,30]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eib=void 0,e.$fib=f,e.$gib=g,e.$hib=v,e.$iib=b,e.$jib=E,e.$kib=h,e.$lib=t,e.$mib=S,e.$nib=y,r=Pe(r),k=Pe(k),e.$eib=(0,u.$Fi)("workspacesService");function f(A){return A.hasOwnProperty("workspace")}function g(A){return A.hasOwnProperty("folderUri")}function v(A){return A.hasOwnProperty("fileUri")}function b(A){return $(A)||P(A)}function $(A){const L=A;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function P(A){const L=A;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function E(A,L,D,O,M){if(A.scheme!==O.scheme)return{name:D,uri:A.toString(!0)};let Z=L?void 0:M.relativePath(O,A);if(Z!==void 0)Z.length===0?Z=".":p.$j&&(Z=i(Z));else if(A.scheme===T.Schemas.file)Z=A.fsPath,p.$j&&(Z=i(Z));else if(M.isEqualAuthority(A.authority,O.authority))Z=A.path;else return{name:D,uri:A.toString(!0)};return{name:D,path:Z}}function i(A){return A=(0,R.$1w)(A),(0,n.$Bg)(A)||(A=(0,n.$yg)(A)),A}function h(A,L,D){const O=[],M=new Set,Z=D.dirname(L);for(const q of A){let K;if($(q))q.path&&(K=D.resolvePath(Z,q.path));else if(P(q))try{K=m.URI.parse(q.uri),K.path[0]!==I.$gc.sep&&(K=K.with({path:I.$gc.sep+K.path}))}catch(de){console.warn(de)}if(K){const de=D.getComparisonKey(K);if(!M.has(de)){M.add(de);const H=q.name||D.basenameOrAuthority(K);O.push(new w.$Zi({uri:K,name:H,index:O.length},q))}}}return O}function t(A,L,D,O,M){const Z=o(L,A),q=M.dirname(L),K=M.dirname(O),de=[];for(const Q of Z.folders){const W=$(Q)?M.resolvePath(q,Q.path):m.URI.parse(Q.uri);let j;D?j=!1:j=!$(Q)||(0,I.$ic)(Q.path),de.push(E(W,j,Q.name,K,M))}const H={insertSpaces:!1,tabSize:4,eol:p.$l||p.$k?`
`:`\r
`},Y=k.$ao(A,["folders"],de,H);let B=k.$do(A,Y);return(0,c.$lh)(Z.remoteAuthority,(0,d.$hn)(O))&&(B=k.$do(B,k.$_n(B,["remoteAuthority"],H))),B}function o(A,L){const D=r.$Yn(L);if(D&&Array.isArray(D.folders))D.folders=D.folders.filter(O=>b(O));else throw new Error(`${A} looks like an invalid workspace file.`);return D}function s(A){return A.workspace&&typeof A.workspace=="object"&&typeof A.workspace.id=="string"&&typeof A.workspace.configPath=="string"}function a(A){return typeof A.folderUri=="string"}function l(A){return typeof A.fileUri=="string"}function S(A,L){const D={workspaces:[],files:[]};if(A){const O=function(Z,q){for(let K=0;K<Z.length;K++)try{q(Z[K],K)}catch(de){L.warn(`Error restoring recent entry ${JSON.stringify(Z[K])}: ${de.toString()}. Skip entry.`)}},M=A;Array.isArray(M.entries)&&O(M.entries,Z=>{const q=Z.label,K=Z.remoteAuthority;s(Z)?D.workspaces.push({label:q,remoteAuthority:K,workspace:{id:Z.workspace.id,configPath:m.URI.parse(Z.workspace.configPath)}}):a(Z)?D.workspaces.push({label:q,remoteAuthority:K,folderUri:m.URI.parse(Z.folderUri)}):l(Z)&&D.files.push({label:q,remoteAuthority:K,fileUri:m.URI.parse(Z.fileUri)})})}return D}function y(A){const L={entries:[]};for(const D of A.workspaces)g(D)?L.entries.push({folderUri:D.folderUri.toString(),label:D.label,remoteAuthority:D.remoteAuthority}):L.entries.push({workspace:{id:D.workspace.id,configPath:D.workspace.configPath.toString()},label:D.label,remoteAuthority:D.remoteAuthority});for(const D of A.files)L.entries.push({fileUri:D.fileUri.toString(),label:D.label,remoteAuthority:D.remoteAuthority});return L}}),define(ce[103],le([0,1,91,12,3,18]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0,e.$7fc=T,e.$8fc=I,e.$9fc=p,e.$6fc=128/4;function T(c){function m(){let u=c.scheme===r.Schemas.file?(0,R.$7g)(c):c.toString();return k.$l||(u=u.toLowerCase()),(0,n.createHash)("md5").update(u).digest("hex")}return{id:m(),configPath:c}}function I(c,m){function u(){if(c.scheme!==r.Schemas.file)return(0,n.createHash)("md5").update(c.toString()).digest("hex");if(!m)return;let w;return k.$l?w=m.ino:k.$k?w=m.birthtime.getTime():k.$j&&(typeof m.birthtimeMs=="number"?w=Math.floor(m.birthtimeMs):w=m.birthtime.getTime()),(0,n.createHash)("md5").update(c.fsPath).update(w?String(w):"").digest("hex")}const d=u();if(typeof d=="string")return{id:d,uri:c}}function p(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ce[104],le([0,1,91,93,27,252,17,15,4,2,9,3,33,44,117]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$wi=e.$vi=e.$ui=void 0,e.$xi=s,e.$yi=a,e.$Ai=y,e.$Bi=A;const g=3e4;class v{traceSocketEvent(D,O){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,D,O)}constructor(D,O=""){this.f=!0,this.debugLabel=O,this.socket=D,this.traceSocketEvent(f.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=Z=>{if(this.traceSocketEvent(f.SocketDiagnosticsEventType.Error,{code:Z?.code,message:Z?.message}),Z){if(Z.code==="EPIPE")return;(0,I.$Y)(Z)}},this.socket.on("error",this.a);let M;this.b=Z=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.Close,{hadError:Z}),this.f=!1,M&&clearTimeout(M)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,M=setTimeout(()=>D.destroy(),g)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(D){const O=M=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.Read,M),D(T.$Ne.wrap(M))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(D){const O=M=>{D({type:f.SocketCloseEventType.NodeSocketCloseEvent,hadError:M,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(D){const O=()=>{D()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(D){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(f.SocketDiagnosticsEventType.Write,D),this.socket.write(D.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,I.$Y)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,I.$Y)(O)}}end(){this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((D,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainEnd),D();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainEnd),D()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$ui=v;var b;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(b||(b={}));var $;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})($||($={}));class P extends c.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(D,O){this.socket.traceSocketEvent(D,O)}constructor(D,O,M,Z){super(),this.f=this.B(new p.$le),this.g=this.B(new p.$le),this.h=!1,this.j={state:$.PeekHeader,readLen:b.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=D,this.traceSocketEvent(f.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:M?.byteLength||0,recordInflateBytes:Z}),this.a=this.B(new E(this,O,M,Z,this.f,(q,K)=>this.m(q,K))),this.B(this.a.onError(q=>{console.error(q),(0,I.$Y)(q),this.g.fire({type:f.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:q})})),this.b=new f.$pi,this.B(this.socket.onData(q=>this.n(q))),this.B(this.socket.onClose(async q=>{this.a.isProcessingReadQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(q)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(D){return this.f.event(D)}onClose(D){return this.g.event(D)}onEnd(D){return this.socket.onEnd(D)}write(D){let O=0;for(;O<D.byteLength;)this.a.writeMessage(D.slice(O,Math.min(O+b.MaxWebSocketMessageLength,D.byteLength)),{compressed:!0,opcode:2}),O+=b.MaxWebSocketMessageLength}m(D,{compressed:O,opcode:M}){if(this.h)return;this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,D);let Z=b.MinHeaderByteSize;D.byteLength<126?Z+=0:D.byteLength<2**16?Z+=2:Z+=8;const q=T.$Ne.alloc(Z),K=O?64:0,de=M&15;if(q.writeUInt8(128|K|de,0),D.byteLength<126)q.writeUInt8(D.byteLength,1);else if(D.byteLength<2**16){q.writeUInt8(126,1);let H=1;q.writeUInt8(D.byteLength>>>8&255,++H),q.writeUInt8(D.byteLength>>>0&255,++H)}else{q.writeUInt8(127,1);let H=1;q.writeUInt8(0,++H),q.writeUInt8(0,++H),q.writeUInt8(0,++H),q.writeUInt8(0,++H),q.writeUInt8(D.byteLength>>>24&255,++H),q.writeUInt8(D.byteLength>>>16&255,++H),q.writeUInt8(D.byteLength>>>8&255,++H),q.writeUInt8(D.byteLength>>>0&255,++H)}this.socket.write(T.$Ne.concat([q,D]))}end(){this.h=!0,this.socket.end()}n(D){if(D.byteLength!==0){for(this.b.acceptChunk(D);this.b.byteLength>=this.j.readLen;)if(this.j.state===$.PeekHeader){const O=this.b.peek(this.j.readLen),M=O.readUInt8(0),Z=(M&128)>>>7,q=(M&64)>>>6,K=M&15,de=O.readUInt8(1),H=(de&128)>>>7,Y=de&127;this.j.state=$.ReadHeader,this.j.readLen=b.MinHeaderByteSize+(H?4:0)+(Y===126?2:0)+(Y===127?8:0),this.j.fin=Z,this.j.firstFrameOfMessage&&(this.j.compressed=!!q),this.j.firstFrameOfMessage=!!Z,this.j.mask=0,this.j.opcode=K,this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===$.ReadHeader){const O=this.b.read(this.j.readLen),M=O.readUInt8(1),Z=(M&128)>>>7;let q=M&127,K=1;q===126?q=O.readUInt8(++K)*2**8+O.readUInt8(++K):q===127&&(q=O.readUInt8(++K)*0+O.readUInt8(++K)*0+O.readUInt8(++K)*0+O.readUInt8(++K)*0+O.readUInt8(++K)*2**24+O.readUInt8(++K)*2**16+O.readUInt8(++K)*2**8+O.readUInt8(++K));let de=0;Z&&(de=O.readUInt8(++K)*2**24+O.readUInt8(++K)*2**16+O.readUInt8(++K)*2**8+O.readUInt8(++K)),this.j.state=$.ReadBody,this.j.readLen=q,this.j.mask=de,this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===$.ReadBody){const O=this.b.read(this.j.readLen);this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,O),t(O,this.j.mask),this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,O),this.j.state=$.PeekHeader,this.j.readLen=b.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(O,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(O,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$vi=P;class E extends c.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Ne.alloc(0)}constructor(D,O,M,Z,q,K){super(),this.n=D,this.r=q,this.s=K,this.a=this.B(new p.$le),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new p.$le),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new p.$le),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,O?(this.b=this.B(new i(this.n,Z,M,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(de=>this.a.fire(de))),this.B(this.f.onError(de=>this.a.fire(de)))):(this.b=null,this.f=null)}writeMessage(D,O){this.g.push({data:D,options:O}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:D,options:O}=this.g.shift();if(this.f&&O.compressed){const M=await this.w(this.f,D);this.s(M,O)}else this.s(D,{...O,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(D,O){return new Promise((M,Z)=>{D.write(O),D.flush(q=>M(q))})}acceptFrame(D,O,M){this.h.push({data:D,isCompressed:O,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const D=this.h.shift();if(this.b&&D.isCompressed){const O=await this.C(this.b,D.data,D.isLastFrameOfMessage);this.r.fire(O)}else this.r.fire(D.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(D,O,M){return new Promise((Z,q)=>{D.write(O),M&&D.write(T.$Ne.fromByteArray([0,0,255,255])),D.flush(K=>Z(K))})}}class i extends c.$Uc{get recordedInflateBytes(){return this.j?T.$Ne.concat(this.f):T.$Ne.alloc(0)}constructor(D,O,M,Z){super(),this.h=D,this.j=O,this.a=this.B(new p.$le),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(Z),this.b.on("error",q=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateError,{message:q?.message,code:q?.code}),this.a.fire(q)}),this.b.on("data",q=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateData,q),this.g.push(T.$Ne.wrap(q))}),M&&(this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateInitialWrite,M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(D){this.j&&this.f.push(D.clone()),this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateWrite,D),this.b.write(D.buffer)}flush(D){this.b.flush(()=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateFlushFired);const O=T.$Ne.concat(this.g);this.g.length=0,D(O)})}}class h extends c.$Uc{constructor(D,O){super(),this.g=D,this.a=this.B(new p.$le),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateError,{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateData,M),this.f.push(T.$Ne.wrap(M))})}write(D){this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateWrite,D.buffer),this.b.write(D.buffer)}flush(D){this.b.flush(2,()=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateFlushFired);let O=T.$Ne.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),D(O)})}}function t(L,D){if(D===0)return;const O=L.byteLength>>>2;for(let H=0;H<O;H++){const Y=L.readUInt32BE(H*4);L.writeUInt32BE(Y^D,H*4)}const M=O*4,Z=L.byteLength-M,q=D>>>24&255,K=D>>>16&255,de=D>>>8&255;Z>=1&&L.writeUInt8(L.readUInt8(M)^q,M),Z>=2&&L.writeUInt8(L.readUInt8(M+1)^K,M+1),Z>=3&&L.writeUInt8(L.readUInt8(M+2)^de,M+2)}e.$wi=process.env.XDG_RUNTIME_DIR;const o={[u.Platform.Linux]:107,[u.Platform.Mac]:103};function s(){const L=(0,d.$2g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const D=process.platform!=="darwin"&&e.$wi?e.$wi:(0,k.tmpdir)(),O=(0,m.$jc)(D,`vscode-ipc-${L}.sock`);return l(O),O}function a(L,D,O){const Z=(0,n.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${Z}-${O}-${D}-sock`;const q=O.substr(0,4),K=D.substr(0,6);let de;return process.platform!=="darwin"&&e.$wi&&!process.env.VSCODE_PORTABLE?de=(0,m.$jc)(e.$wi,`vscode-${Z}-${q}-${K}.sock`):de=(0,m.$jc)(L,`${q}-${K}.sock`),l(de),de}function l(L){const D=o[u.$v];typeof D=="number"&&L.length>=D&&console.warn(`WARNING: IPC handle "${L}" is longer than ${D} chars, try a shorter --user-data-dir`)}class S extends w.$ji{static b(D){const O=p.Event.fromNodeEventEmitter(D,"connection");return p.Event.map(O,M=>({protocol:new f.$qi(new v(M,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(M,"close"))}))}constructor(D){super(S.b(D)),this.d=D}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$zi=S;function y(L){return new Promise((D,O)=>{const M=(0,r.createServer)();M.on("error",O),M.listen(L,()=>{M.removeListener("error",O),D(new S(M))})})}function A(L,D){return new Promise((O,M)=>{const Z=(0,r.createConnection)(L,()=>{Z.removeListener("error",M),O(f.$ri.fromSocket(new v(Z,`ipc-client${D}`),D))});Z.once("error",M)})}}),define(ce[20],le([0,1,54,9,3,104,38,95,6]),function(x,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=e.$Kfc=void 0,e.$Kfc=(0,p.$Gi)(T.$Mi);class c extends I.$9m{constructor(){super(...arguments),this.d={}}get backupHome(){return(0,r.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,R.$yi)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,r.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(k.$l){for(const u in process.env)if(u.endsWith("_VSCODE_SNAP_ORIG")){const d=u.slice(0,-17);if(this.d[d])continue;process.env[d]&&(this.d[d]=process.env[d]),process.env[u]?process.env[d]=process.env[u]:delete process.env[d]}}}restoreSnapExportedVariables(){if(k.$l)for(const u in this.d)process.env[u]=this.d[u],delete this.d[u]}}e.$Lfc=c,Se([n.$0h],c.prototype,"backupHome",null),Se([n.$0h],c.prototype,"mainIPCHandle",null),Se([n.$0h],c.prototype,"mainLockfile",null),Se([n.$0h],c.prototype,"disableUpdates",null),Se([n.$0h],c.prototype,"crossOriginIsolated",null),Se([n.$0h],c.prototype,"codeCachePath",null),Se([n.$0h],c.prototype,"useCodeCache",null)}),define(ce[253],le([0,1,91,32,12,9,3,18,23,165,16,20,34,14,5,164,30,103]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;let P=class{static{$=this}static{this.a="backupWorkspaces"}constructor(i,h,t,o){this.j=i,this.k=h,this.l=t,this.m=o,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=I.$0g,this.i={isEqual:(s,a)=>(0,r.$Dg)(s,a,!T.$l)}}async initialize(){const i=this.m.getItem($.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(i.emptyWindows),this.d=await this.u((0,c.$Pfc)(i)),this.e=await this.v((0,c.$Qfc)(i)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==w.$zl.OFF}q(){return this.s()===w.$zl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||w.$zl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(i,h){this.d.some(o=>i.workspace.id===o.workspace.id)||(this.d.push(i),this.C());const t=(0,R.$jc)(this.c,i.workspace.id);return h?this.t(t,h).then(()=>t):t}async t(i,h){if(await p.Promises.exists(i)&&await this.z(i),await p.Promises.exists(h))try{await p.Promises.rename(h,i,!1)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(i){return this.e.some(h=>this.h.isEqual(i.folderUri,h.folderUri))||(this.e.push(i),this.C()),(0,R.$jc)(this.c,this.D(i))}registerEmptyWindowBackup(i){return this.g.some(h=>!!h.backupFolder&&this.i.isEqual(h.backupFolder,i.backupFolder))||(this.g.push(i),this.C()),(0,R.$jc)(this.c,i.backupFolder)}async u(i){if(!Array.isArray(i))return[];const h=new Set,t=[];for(const o of i){const s=o.workspace;if(!(0,v.$Ui)(s))return[];if(!h.has(s.id)){h.add(s.id);const a=(0,R.$jc)(this.c,s.id);await this.B(a)?s.configPath.scheme!==k.Schemas.file||await p.Promises.exists(s.configPath.fsPath)?t.push(o):await this.z(a):await this.x(a)}}return t}async v(i){if(!Array.isArray(i))return[];const h=[],t=new Set;for(const o of i){const s=o.folderUri,a=this.h.getComparisonKey(s);if(!t.has(a)){t.add(a);const l=(0,R.$jc)(this.c,this.D(o));await this.B(l)?s.scheme!==k.Schemas.file||await p.Promises.exists(s.fsPath)?h.push(o):await this.z(l):await this.x(l)}}return h}async w(i){if(!Array.isArray(i))return[];const h=[],t=new Set;for(const o of i){const s=o.backupFolder;if(typeof s!="string")return[];if(!t.has(s)){t.add(s);const a=(0,R.$jc)(this.c,s);await this.B(a)?h.push(o):await this.x(a)}}return h}async x(i){try{await p.Promises.rm(i,p.RimRafMode.MOVE)}catch(h){this.l.error(`Backup: Could not delete stale backup: ${h.toString()}`)}}y(){let i=(0,b.$9fc)();for(;this.g.some(h=>!!h.backupFolder&&this.i.isEqual(h.backupFolder,i.id));)i=(0,b.$9fc)();return{backupFolder:i.id}}async z(i){const h=this.y(),t=(0,R.$jc)(this.c,h.backupFolder);try{await p.Promises.rename(i,t,!1)}catch(o){return this.l.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.g.push(h),!0}async getDirtyWorkspaces(){const i=[];for(const h of this.d)await this.A(h)&&i.push(h);for(const h of this.e)await this.A(h)&&i.push(h);return i}A(i){let h;return(0,c.$Ofc)(i)?h=(0,R.$jc)(this.c,i.backupFolder):(0,g.$cib)(i)?h=(0,R.$jc)(this.c,this.D(i)):h=(0,R.$jc)(this.c,i.workspace.id),this.B(h)}async B(i){try{const h=await p.Promises.readdir(i);for(const t of h)try{if((await p.Promises.readdir((0,R.$jc)(i,t))).length>0)return!0}catch{}}catch{}return!1}C(){const i={workspaces:this.d.map(({workspace:h,remoteAuthority:t})=>{const o={id:h.id,configURIPath:h.configPath.toString()};return t&&(o.remoteAuthority=t),o}),folders:this.e.map(({folderUri:h,remoteAuthority:t})=>{const o={folderUri:h.toString()};return t&&(o.remoteAuthority=t),o}),emptyWindows:this.g.map(({backupFolder:h,remoteAuthority:t})=>{const o={backupFolder:h};return t&&(o.remoteAuthority=t),o})};this.m.setItem($.a,i)}D(i){const h=i.folderUri;let t;return h.scheme===k.Schemas.file?t=T.$l?h.fsPath:h.fsPath.toLowerCase():t=h.toString().toLowerCase(),(0,n.createHash)("md5").update(t).digest("hex")}};e.$qgc=P,e.$qgc=P=$=Se([se(0,u.$Kfc),se(1,m.$_i),se(2,f.$ak),se(3,d.$CR)],P)});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[19],le([0,1,13,35,8,4,2,3,36,11,6,5,34,52,20]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=e.LifecycleMainPhase=e.ShutdownReason=e.$egc=void 0,n=Ve(n),e.$egc=(0,m.$Fi)("lifecycleMainService");var v;(function(P){P[P.QUIT=1]="QUIT",P[P.KILL=2]="KILL"})(v||(e.ShutdownReason=v={}));var b;(function(P){P[P.Starting=1]="Starting",P[P.Ready=2]="Ready",P[P.AfterWindowOpen=3]="AfterWindowOpen",P[P.Eventually=4]="Eventually"})(b||(e.LifecycleMainPhase=b={}));let $=class extends T.$Uc{static{g=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(E,i,h){super(),this.F=E,this.G=i,this.H=h,this.c=this.B(new R.$le),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.$le),this.onWillShutdown=this.f.event,this.g=this.B(new R.$le),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.$le),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=b.Starting,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(b.Ready).then(()=>this.J())}I(){this.m=!!this.G.getItem(g.b),this.m&&this.G.removeItem(g.b)}J(){const E=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),I.$k&&this.t===0&&this.L(v.QUIT))};n.default.app.addListener("before-quit",E);const i=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!I.$k)&&n.default.app.quit()};n.default.app.addListener("window-all-closed",i),n.default.app.once("will-quit",h=>{this.S("Lifecycle#app.on(will-quit) - begin"),h.preventDefault(),this.L(v.QUIT).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.default.app.removeListener("before-quit",E),n.default.app.removeListener("window-all-closed",i),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.default.app.quit()})})}L(E){if(this.y)return this.y;const i=this.F;this.S("Lifecycle#onWillShutdown.fire()");const h=[];return this.f.fire({reason:E,join(t,o){i.trace(`Lifecycle#onWillShutdown - begin '${t}'`),h.push(o.finally(()=>{i.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await k.Promises.settled(h)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(E){if(E<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===E)return;this.S(`lifecycle (main): phase changed (value: ${E})`),this.n=E;const i=this.C.get(this.n);i&&(i.open(),this.C.delete(this.n))}async when(E){if(E<=this.n)return;let i=this.C.get(E);i||(i=new k.$Eh,this.C.set(E,i)),await i.wait()}registerWindow(E){const i=new T.$Tc;this.t++,i.add(E.onWillLoad(t=>this.g.fire({window:E,workspace:t.workspace,reason:t.reason})));const h=(0,c.$pg)(E.win);i.add(R.Event.fromNodeEventEmitter(h,"close")(t=>{const o=E.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${E.id}`),t.preventDefault(),this.unload(E,w.UnloadReason.CLOSE).then(s=>{if(s){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(E),E.close()})})),i.add(R.Event.fromNodeEventEmitter(h,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${E.id}`),this.t--,i.dispose(),this.t===0&&(!I.$k||this.j)&&this.L(v.QUIT)}))}registerAuxWindow(E){const i=(0,c.$pg)(E.win),h=new T.$Tc;h.add(R.Event.fromNodeEventEmitter(i,"close")(t=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${E.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),t.preventDefault())})),h.add(R.Event.fromNodeEventEmitter(i,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${E.id}`),h.dispose()}))}async reload(E,i){await this.unload(E,w.UnloadReason.RELOAD)||E.reload(i)}unload(E,i){const h=this.z.get(E.id);if(h)return h;const t=this.M(E,i).finally(()=>{this.z.delete(E.id)});return this.z.set(E.id,t),t}async M(E,i){if(!E.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${E.id}`);const h=this.j?w.UnloadReason.QUIT:i,t=await this.P(E,h);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${E.id})`),this.N(t)):(await this.Q(E,h),!1)}N(E){return E?(this.O(!0),this.j=!1,!0):!1}O(E){this.w&&(this.w(E),this.w=void 0,this.u=void 0)}P(E,i){return new Promise(h=>{const t=this.s++,o=`vscode:ok${t}`,s=`vscode:cancel${t}`;r.$WX.once(o,()=>{h(!1)}),r.$WX.once(s,()=>{h(!0)}),E.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:s,reason:i})})}Q(E,i){return new Promise(h=>{const o=`vscode:reply${this.s++}`;r.$WX.once(o,()=>h()),E.send("vscode:onWillUnload",{replyChannel:o,reason:i})})}quit(E){return this.R(E).then(i=>{if(!i&&E)try{if(I.$j){const h=(0,p.cwd)();h!==process.cwd()&&process.chdir(h)}}catch(h){this.F.error(h)}return i})}R(E){return this.S(`Lifecycle#quit() - begin (willRestart: ${E})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(E&&this.G.setItem(g.b,!0),this.u=new Promise(i=>{this.w=i,this.S("Lifecycle#quit() - calling app.quit()"),n.default.app.quit()}),this.u)}S(E){this.H.args["enable-smoke-test-driver"]?this.F.info(E):this.F.trace(E)}setRelaunchHandler(E){this.D=E}async relaunch(E){this.S("Lifecycle#relaunch()");const i=process.argv.slice(1);if(E?.addArgs&&i.push(...E.addArgs),E?.removeArgs)for(const o of E.removeArgs){const s=i.indexOf(o);s>=0&&i.splice(s,1)}const h=()=>{this.D?.handleRelaunch(E)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.default.app.relaunch({args:i}))};n.default.app.once("quit",h),await this.quit(!0)&&n.default.app.removeListener("quit",h)}async kill(E){this.S("Lifecycle#kill()"),await this.L(v.KILL),await Promise.race([(0,k.$Gh)(1e3),(async()=>{for(const i of n.default.BrowserWindow.getAllWindows())if(i&&!i.isDestroyed()){let h;i.webContents&&!i.webContents.isDestroyed()?h=new Promise(t=>i.once("closed",t)):h=Promise.resolve(),i.destroy(),await h}})()]),n.default.app.exit(E)}};e.$fgc=$,e.$fgc=$=g=Se([se(0,u.$ak),se(1,d.$CR),se(2,f.$Kfc)],$)}),define(ce[254],le([0,1,3,4,2,6,19]),function(x,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=e.$Ogc=void 0,n=Pe(n),e.$Ogc=(0,R.$Fi)("keyboardLayoutMainService");let I=class extends k.$Uc{constructor(m){super(),this.a=this.B(new r.$le),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,m.when(T.LifecycleMainPhase.AfterWindowOpen).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const m=await new Promise((u,d)=>{x(["native-keymap"],u,d)}).then(Pe);this.c=p(m),n.$u||m.onDidChangeKeyboardLayout(()=>{this.c=p(m),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$Pgc=I,e.$Pgc=I=Se([se(0,T.$egc)],I);function p(c){const m=c.getKeyMap(),u=c.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:u}}}),define(ce[255],le([0,1,215,8,17,15,11,16,38,100,5,49,214,252]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=void 0,e.$gs=v;let f=class extends u.$9p{constructor($,P,E,i){super(i),this.m=$,this.n=P,this.r=E,this.s(),this.B($.onDidChangeConfiguration(h=>{h.affectsConfiguration("http")&&this.s()}))}s(){const $=this.m.getValue("http");this.f=$?.proxy,this.g=!!$?.proxyStrictSSL,this.h=$?.proxyAuthorization}async request($,P){const{f:E,g:i}=this;let h;try{h=await(0,c.$Rm)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,R.$9)(s)))}const t={...process.env,...h},o=$.agent?$.agent:await(0,d.$es)($.url||"",t,{proxyUrl:E,strictSSL:i});return $.agent=o,$.strictSSL=i,this.h&&($.headers={...$.headers||{},"Proxy-Authorization":this.h}),this.c($.isChromiumNetwork?"electron":"node",$,()=>v($,P))}async resolveProxy($){}async lookupAuthorization($){}async lookupKerberosAuthorization($){try{const P=await new Promise((o,s)=>{x(["kerberos"],o,s)}).then(Pe),E=new URL($),i=this.m.getValue("http.proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${E.hostname}`:`HTTP@${E.hostname}`);return this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication lookup",`proxyURL:${E}`,`spn:${i}`),"Negotiate "+await(await P.initializeClient(i)).step("")}catch(P){this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication failed",P);return}}async loadCertificates(){return(await new Promise((P,E)=>{x(["@vscode/proxy-agent"],P,E)}).then(Pe)).loadSystemCertificates({log:this.r})}};e.$fs=f,e.$fs=f=Se([se(0,I.$_i),se(1,p.$Ni),se(2,m.$ak),se(3,m.$bk)],f);async function g(b){return((0,n.parse)(b.url).protocol==="https:"?await new Promise((E,i)=>{x(["https"],E,i)}).then(Pe):await new Promise((E,i)=>{x(["http"],E,i)}).then(Pe)).request}async function v(b,$){return r.Promises.withAsyncBody(async(P,E)=>{const i=(0,n.parse)(b.url),h=b.getRawRequest?b.getRawRequest(b):await g(b),t={hostname:i.hostname,port:i.port?parseInt(i.port):i.protocol==="https:"?443:80,protocol:i.protocol,path:i.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,T.$kg)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(t.auth=b.user+":"+b.password);const o=h(t,s=>{const a=(0,T.$ig)(b.followRedirects)?b.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&a>0&&s.headers.location)v({...b,url:s.headers.location,followRedirects:a-1},$).then(P,E);else{let l=s;!b.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(l=s.pipe((0,w.createGunzip)())),P({res:s,stream:(0,k.$3e)(l)})}});o.on("error",E),b.timeout&&o.setTimeout(b.timeout),b.isChromiumNetwork&&o.removeHeader("Content-Length"),b.data&&typeof b.data=="string"&&o.write(b.data),o.end(),$.onCancellationRequested(()=>{o.abort(),E(new R.$4)})})}}),define(ce[256],le([0,1,13,255]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=void 0;function k(T){return n.net.request}class R extends r.$fs{request(I,p){return super.request({...I||{},getRawRequest:k,isChromiumNetwork:!0},p)}}e.$Thc=R}),define(ce[87],le([0,1,7,4,2,38,14,6,19,5,62,249,42,58,41,12]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=e.$mgc=e.$lgc=e.$kgc=void 0,e.$kgc=(0,I.$Fi)("storageMainService");let v=class extends k.$Uc{constructor(P,E,i,h,t,o){super(),this.c=P,this.f=E,this.g=i,this.h=h,this.j=t,this.m=o,this.a=void 0,this.b=this.B(new r.$le),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(p.LifecycleMainPhase.AfterWindowOpen),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(P=>{P.window.profile&&this.profileStorage(P.window.profile).init(),P.workspace&&this.workspaceStorage(P.workspace).init()})),this.B(this.h.onWillShutdown(P=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=P.reason,P.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.t)P.join("profileStorage",E.close());for(const[,E]of this.w)P.join("workspaceStorage",E.close())})),this.B(this.g.onWillCreateProfile(P=>{P.join((async()=>{await this.j.exists(P.profile.globalStorageHome)||await this.j.createFolder(P.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(P=>{const E=this.t.get(P.profile.id);E&&P.join(E.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const P=new u.$hgc(this.n(),this.g,this.c,this.j);return this.B(r.Event.once(P.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),P}profileStorage(P){if((0,m.$lq)(P))return this.applicationStorage;let E=this.t.get(P.id);if(!E){this.c.trace(`StorageMainService: creating profile storage (${P.name})`),E=this.B(this.u(P)),this.t.set(P.id,E);const i=this.B(E.onDidChangeStorage(h=>this.b.fire({...h,storage:E,profile:P})));this.B(r.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${P.name})`),this.t.delete(P.id),i.dispose()}))}return E}u(P){return this.a===p.ShutdownReason.KILL?new u.$jgc(this.c,this.j):new u.$ggc(P,this.n(),this.c,this.j)}workspaceStorage(P){let E=this.w.get(P.id);return E||(this.c.trace(`StorageMainService: creating workspace storage (${P.id})`),E=this.B(this.y(P)),this.w.set(P.id,E),this.B(r.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${P.id})`),this.w.delete(P.id)}))),E}y(P){return this.a===p.ShutdownReason.KILL?new u.$jgc(this.c,this.j):new u.$igc(P,this.n(),this.c,this.f,this.j)}isUsed(P){const E=n.URI.file(P);for(const i of[this.applicationStorage,...this.t.values(),...this.w.values()])if(i.path&&this.m.extUri.isEqualOrParent(n.URI.file(i.path),E))return!0;return!1}};e.$lgc=v,e.$lgc=v=Se([se(0,c.$ak),se(1,R.$Mi),se(2,w.$1fc),se(3,p.$egc),se(4,T.$al),se(5,f.$Kl)],v),e.$mgc=(0,I.$Fi)("applicationStorageMainService");let b=class extends m.$kq{constructor(P,E){super(),this.s=P,this.U=E,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(P){if(P===m.StorageScope.APPLICATION)return this.U.applicationStorage.storage}Q(P){if(P===m.StorageScope.APPLICATION)return this.s.defaultProfile.globalStorageHome.with({scheme:g.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$ngc=b,e.$ngc=b=Se([se(0,d.$Ml),se(1,e.$kgc)],b)}),define(ce[257],le([0,1,93,27,113,104,8,2,3,16,5,28,208,211,101,131,17]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=e.$Rhc=e.$Qhc=e.$Phc=void 0,n=Pe(n),r=Pe(r);async function b(h,t,o,s,a){let l;for(let S=3;S&&(l?.dispose(),l=await new $(h,t,o,s,a).waitForReady(),!(a&&k.$5g[a]||!k.$5g[l.tunnelLocalPort]));S--);return l}class $ extends I.$Uc{constructor(t,o,s,a,l){super(),this.m=o,this.n=l,this.privacy=g.TunnelPrivacyId.Private,this.j=new Map,this.a=t,this.b=n.createServer(),this.c=new T.$Eh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=S=>this.r(S),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(o=>{o()})}async waitForReady(){const t=this.n??this.tunnelRemotePort,o=(0,g.$Mw)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,k.$6g)(t,2,1e3,o),a=null;return this.b.listen(s,this.m),await this.c.wait(),a=this.b.address(),a||(s=0,this.b.listen(s,this.m),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async r(t){t.pause();const o=(0,g.$Kw)(this.tunnelRemoteHost)||(0,g.$Mw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,d.$3l)(this.a,o,this.tunnelRemotePort),a=s.getSocket(),l=s.readEntireBuffer();s.dispose(),l.byteLength>0&&t.write(l.buffer),t.on("end",()=>{t.localAddress&&this.j.delete(t.localAddress),a.end()}),t.on("close",()=>a.end()),t.on("error",()=>{t.localAddress&&this.j.delete(t.localAddress),a instanceof R.$ui?a.socket.destroy():a.end()}),a instanceof R.$ui?this.t(t,a):this.s(t,a),t.localAddress&&this.j.set(t.localAddress,()=>{t.end(),a.end()})}s(t,o){o.onClose(()=>t.destroy()),o.onEnd(()=>t.end()),o.onData(s=>t.write(s.buffer)),t.on("data",s=>o.write(v.$Ne.wrap(s))),t.resume()}t(t,o){const s=o.socket;s.on("end",()=>t.end()),s.on("close",()=>t.end()),s.on("error",()=>{t.destroy()}),s.pipe(t),t.pipe(s)}}e.$Phc=$;let P=class extends g.$Pw{constructor(t,o,s,a,l){super(o,l),this.H=t,this.I=s,this.J=a}isPortPrivileged(t){return(0,g.$Nw)(t,this.t,p.OS,r.release())}F(t,o,s,a,l,S,y,A){const L=this.D(o,s);if(L)return++L.refcount,L.value;if((0,g.$Gw)(t))return this.G(t,o,s,l,S,y,A);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${s} on local port ${l}.`);const D={commit:this.J.commit,quality:this.J.quality,addressProvider:t,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},O=b(D,a,o,s,l);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(o,s,O),O}}};e.$Qhc=P,e.$Qhc=P=Se([se(0,w.$Wl),se(1,m.$ak),se(2,f.$Zl),se(3,u.$tk),se(4,c.$_i)],P);let E=class extends P{constructor(t,o,s,a,l){super(t,o,s,a,l)}};e.$Rhc=E,e.$Rhc=E=Se([se(0,w.$Wl),se(1,m.$ak),se(2,f.$Zl),se(3,u.$tk),se(4,c.$_i)],E);let i=class extends I.$Uc{constructor(t,o,s,a,l){super(),this.b=t,this.c=o,this.f=s,this.g=a,this.h=l,this.a=new Map}async openTunnel(t,o,s,a,l,S,y,A,L){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${a} on local port ${S}.`),!this.a.has(t)){const D=new E(this.b,this.c,this.g,this.f,this.h);this.B(D),this.a.set(t,D),D.onTunnelClosed(async()=>{(await D.tunnels).length===0&&(D.dispose(),this.a.delete(t))})}return this.a.get(t).openTunnel(o,s,a,l,S,y,A,L)}};e.$Shc=i,e.$Shc=i=Se([se(0,w.$Wl),se(1,m.$ak),se(2,u.$tk),se(3,f.$Zl),se(4,c.$_i)],i)}),define(ce[105],le([0,1,8,22,4,16,20,19,5,28,49,50]),function(x,e,n,r,k,R,T,I,p,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=void 0,e.$_gc=d;function d(f,g,v){return`${v.updateUrl}/api/update/${f}/${g}/${v.commit}`}let w=class{get state(){return this.b}d(g){this.j.info("update#setState",g.type),this.b=g,this.c.fire(g)}constructor(g,v,b,$,P,E){this.f=g,this.g=v,this.h=b,this.i=$,this.j=P,this.k=E,this.b=u.$UY.Uninitialized,this.c=new k.$le,this.onStateChange=this.c.event,g.when(I.LifecycleMainPhase.AfterWindowOpen).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(u.$UY.Disabled(u.DisablementReason.NotBuilt));return}if(this.h.disableUpdates){this.d(u.$UY.Disabled(u.DisablementReason.DisabledByEnvironment)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(u.$UY.Disabled(u.DisablementReason.MissingConfiguration)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const g=this.g.getValue("update.mode"),v=this.m(g);if(!v){this.d(u.$UY.Disabled(u.DisablementReason.ManuallyDisabled)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(v),!this.a){this.d(u.$UY.Disabled(u.DisablementReason.InvalidConfiguration)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const b=new URL(this.a);b.searchParams.set("prss","true"),this.a=b.toString()}if(this.d(u.$UY.Idle(this.q())),g==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,b=>this.j.error(b))}m(g){return g==="none"?void 0:this.k.quality}n(g=60*60*1e3){return(0,n.$Gh)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(g){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===u.StateType.Idle&&this.t(g)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===u.StateType.AvailableForDownload&&await this.o(this.state)}async o(g){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type===u.StateType.Downloaded&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==u.StateType.Ready||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(g=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},r.CancellationToken.None)).res.statusCode===204}catch(v){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(v);return}}async _applySpecificUpdate(g){}q(){return u.UpdateType.Archive}r(){}};e.$ahc=w,e.$ahc=w=Se([se(0,I.$egc),se(1,R.$_i),se(2,T.$Kfc),se(3,m.$8p),se(4,p.$ak),se(5,c.$tk)],w)}),define(ce[258],le([0,1,13,54,4,46,2,16,20,19,5,28,49,24,50,105]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0,n=Pe(n);let v=class extends g.$ahc{get v(){return k.Event.fromNodeEventEmitter(n.autoUpdater,"error",($,P)=>P)}get w(){return k.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return k.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get y(){return k.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",($,P,E,i)=>({version:E,productVersion:E,timestamp:i}))}constructor($,P,E,i,h,t,o){super($,P,i,h,t,o),this.z=E,this.u=new T.$Tc,$.setRelaunchHandler(this)}handleRelaunch($){return $?.addArgs||$?.removeArgs||this.state.type!==f.StateType.Ready?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B($){this.z.publicLog2("update:error",{messageHash:String((0,R.$tj)(String($)))}),this.j.error("UpdateService error:",$);const P=this.state.type===f.StateType.CheckingForUpdates&&this.state.explicit?$:void 0;this.d(f.$UY.Idle(f.UpdateType.Archive,P))}s($){let P;this.k.darwinUniversalAssetId?P=this.k.darwinUniversalAssetId:P=process.arch==="x64"?"darwin":"darwin-arm64";const E=(0,g.$_gc)(P,$,this.k);try{n.autoUpdater.setFeedURL({url:E})}catch(i){this.j.error("Failed to set update feed URL",i);return}return E}t($){this.d(f.$UY.CheckingForUpdates($)),n.autoUpdater.checkForUpdates()}E(){this.state.type===f.StateType.CheckingForUpdates&&this.d(f.$UY.Downloading)}F($){this.state.type===f.StateType.Downloading&&(this.d(f.$UY.Downloaded($)),this.z.publicLog2("update:downloaded",{version:$.version}),this.d(f.$UY.Ready($)))}G(){this.state.type===f.StateType.CheckingForUpdates&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$UY.Idle(f.UpdateType.Archive)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$bhc=v,Se([r.$0h],v.prototype,"v",null),Se([r.$0h],v.prototype,"w",null),Se([r.$0h],v.prototype,"x",null),Se([r.$0h],v.prototype,"y",null),e.$bhc=v=Se([se(0,c.$egc),se(1,I.$_i),se(2,w.$_l),se(3,p.$Kfc),se(4,d.$8p),se(5,m.$ak),se(6,u.$tk)],v)}),define(ce[259],le([0,1,48,26,8,4,9,20,19,5,24,50]),function(x,e,n,r,k,R,T,I,p,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0,T=Pe(T);let d=class{get state(){return this.a}d(g){this.g.info("update#setState",g.type),this.a=g,this.b.fire(g)}constructor(g,v,b){if(this.f=g,this.g=b,this.a=u.$UY.Uninitialized,this.b=new R.$le,this.onStateChange=this.b.event,v.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(u.$UY.Idle(this.k())),this.h(30*1e3).then(void 0,$=>this.g.error($))}h(g=60*60*1e3){return(0,k.$Gh)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(g){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===u.StateType.Idle&&this.m(g)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===u.StateType.AvailableForDownload&&await this.i(this.state)}i(g){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type===u.StateType.Downloaded&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==u.StateType.Ready||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(g=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return u.UpdateType.Snap}l(){}async _applySpecificUpdate(g){}};d=Se([se(0,p.$egc),se(1,I.$Kfc),se(2,c.$ak)],d);let w=class extends d{constructor(g,v,b,$,P,E){super(b,$,P),this.o=g,this.p=v,this.q=E;const i=(0,r.watch)(T.$mc(this.o)),h=R.Event.fromNodeEventEmitter(i,"change",(a,l)=>l),t=R.Event.filter(h,a=>a==="current"),s=R.Event.debounce(t,(a,l)=>l,2e3)(()=>this.checkForUpdates(!1));b.onWillShutdown(()=>{s.dispose(),i.close()})}m(){this.d(u.$UY.CheckingForUpdates(!1)),this.u().then(g=>{g?this.d(u.$UY.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(u.$UY.Idle(u.UpdateType.Snap)))},g=>{this.g.error(g),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(u.$UY.Idle(u.UpdateType.Snap,g.message||g))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+T.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const g=await new Promise((b,$)=>(0,r.realpath)(`${T.$mc(this.o)}/current`,(P,E)=>P?$(P):b(E))),v=T.$nc(g);return this.p!==v}isLatestVersion(){return this.u().then(void 0,g=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$dhc=w,e.$dhc=w=Se([se(2,p.$egc),se(3,I.$Kfc),se(4,c.$ak),se(5,m.$_l)],w)});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[29],le([0,1,13,140,9,3,16,20,6,28,76,51,52]),function(x,e,n,r,k,R,T,I,p,c,m,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$Xfc=void 0,e.$Yfc=f,e.$Zfc=g,n=Ve(n),e.$Xfc=(0,p.$Fi)("windowsMainService");var w;(function(b){b[b.CLI=0]="CLI",b[b.DOCK=1]="DOCK",b[b.MENU=2]="MENU",b[b.DIALOG=3]="DIALOG",b[b.DESKTOP=4]="DESKTOP",b[b.API=5]="API"})(w||(e.OpenContext=w={}));function f(b,$,P){const E=b.get(m.$Vfc),i=b.get(c.$tk),h=b.get(T.$_i),t=b.get(I.$Kfc),o=h.getValue("window"),s={backgroundColor:E.getBackgroundColor(),minWidth:u.$8D.WIDTH,minHeight:u.$8D.HEIGHT,title:i.nameLong,show:$.mode!==d.WindowMode.Maximized&&$.mode!==d.WindowMode.Fullscreen,x:$.x,y:$.y,width:$.width,height:$.height,webPreferences:{...P,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,u.$hE)($.zoomLevel??o?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(R.$l?s.icon=(0,k.$jc)(t.appRoot,"resources/linux/code.png"):R.$j&&!t.isBuilt&&(s.icon=(0,k.$jc)(t.appRoot,"resources/win32/code_150x150.png")),R.$k&&(s.acceptFirstMouse=!0,o?.clickThroughInactive===!1&&(s.acceptFirstMouse=!1)),R.$k&&!(0,u.$gE)(h)&&(s.fullscreenable=!1),R.$k&&o?.nativeTabs===!0&&(s.tabbingIdentifier=i.nameShort),!(0,u.$cE)(h)&&$.mode!==d.WindowMode.Custom&&(s.titleBarStyle="hidden",R.$k||(s.frame=!1),(0,u.$fE)(h))){const S=E.getWindowSplash()?.colorInfo.titleBarBackground??E.getBackgroundColor(),y=r.$ou.fromHex(S).isDarker()?"#FFFFFF":"#000000";s.titleBarOverlay={height:29,color:S,symbolColor:y}}return s}function g(b){let $,P=Number.MIN_VALUE;for(const E of b)E.lastFocusTime>P&&(P=E.lastFocusTime,$=E);return $}var v;(function(b){function $(E,i,h=n.default.screen.getAllDisplays()){if(E.trace(`window#validateWindowState: validating window state on ${h.length} display(s)`,i),typeof i.x!="number"||typeof i.y!="number"||typeof i.width!="number"||typeof i.height!="number"){E.trace("window#validateWindowState: unexpected type of state values");return}if(i.width<=0||i.height<=0){E.trace("window#validateWindowState: unexpected negative values");return}if(h.length===1){const s=P(h[0]);if(E.trace("window#validateWindowState: single monitor working area",s),s){let a=function(){!i||typeof i.x!="number"||typeof i.y!="number"||!s||(i.x<s.x&&(i.x=s.x),i.y<s.y&&(i.y=s.y))};a(),i.width>s.width&&(i.width=s.width),i.height>s.height&&(i.height=s.height),i.x>s.x+s.width-128&&(i.x=s.x+s.width-i.width),i.y>s.y+s.height-128&&(i.y=s.y+s.height-i.height),a()}return i}if(i.display&&i.mode===d.WindowMode.Fullscreen){const s=h.find(a=>a.id===i.display);if(s&&typeof s.bounds?.x=="number"&&typeof s.bounds?.y=="number"){E.trace("window#validateWindowState: restoring fullscreen to previous display");const a=(0,d.$Mfc)(d.WindowMode.Fullscreen);return a.x=s.bounds.x,a.y=s.bounds.y,a}}let t,o;try{t=n.default.screen.getDisplayMatching({x:i.x,y:i.y,width:i.width,height:i.height}),o=P(t),E.trace("window#validateWindowState: multi-monitor working area",o)}catch(s){E.error("window#validateWindowState: error finding display for window state",s)}if(t&&o&&i.x+i.width>o.x&&i.y+i.height>o.y&&i.x<o.x+o.width&&i.y<o.y+o.height)return i;E.trace("window#validateWindowState: state is outside of the multi-monitor working area")}b.validateWindowState=$;function P(E){if(E.workArea.width>0&&E.workArea.height>0)return E.workArea;if(E.bounds.width>0&&E.bounds.height>0)return E.bounds}})(v||(e.WindowStateValidator=v={}))}),define(ce[260],le([0,1,93,167,120,29]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;class T extends r.$Zo{constructor(p){super(),this.f=p}call(p,c,m){return c==="openExtensionDevelopmentHostWindow"?this.g(m[0],m[1]):super.call(p,c,m)}async g(p,c){const m=(0,k.$Dm)(p,k.$Cm);m.debugRenderer=c;const u=m.extensionDevelopmentPath;if(!u)return{success:!1};const[d]=await this.f.openExtensionDevelopmentHostWindow(u,{context:R.OpenContext.API,cli:m,forceProfile:m.profile,forceTempProfile:m["profile-temp"]});if(!c)return{success:!0};const w=d.win;if(!w)return{success:!0};const f=w.webContents.debugger;let g=f.isAttached()?1/0:0;const v=(0,n.createServer)(b=>{g++===0&&f.attach();let $=!1;const P=h=>{$||b.write(JSON.stringify(h)+"\0")},E=(h,t,o,s)=>P({method:t,params:o,sessionId:s});w.on("close",()=>{f.removeListener("message",E),b.end(),$=!0}),f.addListener("message",E);let i=Buffer.alloc(0);b.on("data",h=>{i=Buffer.concat([i,h]);for(let t=i.indexOf(0);t!==-1;t=i.indexOf(0)){let o;try{const s=i.slice(0,t).toString("utf8");i=i.slice(t+1),o=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}f.sendCommand(o.method,o.params,o.sessionId).then(s=>P({id:o.id,sessionId:o.sessionId,result:s})).catch(s=>P({id:o.id,sessionId:o.sessionId,error:{code:0,message:s.message}}))}}),b.on("error",h=>{console.error("error on cdp pipe:",h)}),b.on("close",()=>{$=!0,--g===0&&f.detach()})});return await new Promise(b=>v.listen(0,b)),w.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.$rgc=T}),define(ce[261],le([0,1,13,21,3,7,23,16,68,6,5,132,29]),function(x,e,n,r,k,R,T,I,p,c,m,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=e.$Rgc=e.ID=void 0,e.ID="launchMainService",e.$Rgc=(0,c.$Fi)(e.ID);let w=class{constructor(g,v,b,$){this.a=g,this.b=v,this.c=b,this.d=$}async start(g,v){this.a.trace("Received data from other instance: ",g,v),k.$k&&n.app.focus({steal:!0});const b=this.e(g);if(b.length){let $=Promise.resolve();if(this.b.getWindowCount()===0){const P=(0,r.$Nb)(await this.b.openEmptyWindow({context:d.OpenContext.DESKTOP}));P&&($=P.ready())}$.then(()=>{for(const{uri:P,originalUrl:E}of b)this.c.open(P,{originalUrl:E})})}else return this.f(g,v)}e(g){return g["open-url"]&&g._urls&&g._urls.length>0?(0,r.$Gb)(g._urls.map(v=>{try{return{uri:R.URI.parse(v),originalUrl:v}}catch{return null}})):[]}async f(g,v){const b=(0,p.$Km)(v)?d.OpenContext.CLI:d.OpenContext.DESKTOP;let $=[];const P=g.wait&&g.waitMarkerFilePath?R.URI.file(g.waitMarkerFilePath):void 0,E=g.remote||void 0,i={context:b,cli:g,userEnv:g["preserve-env"]||b===d.OpenContext.CLI?v:void 0,waitMarkerFileURI:P,remoteAuthority:E,forceProfile:g.profile,forceTempProfile:g["profile-temp"]};if(g.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(g.extensionDevelopmentPath,i);else if(!g._.length&&!g["folder-uri"]&&!g["file-uri"]){let h=!1;if(g["new-window"]||i.forceProfile||i.forceTempProfile)h=!0;else if(g["reuse-window"])h=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":h=!0;break;case"off":h=!1;break;default:h=!k.$k}if(h)$=await this.b.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const t=this.b.getLastActiveWindow();t?(this.b.openExistingWindow(t,i),$=[t]):$=await this.b.open({...i,forceEmpty:!0})}}else $=await this.b.open({...i,forceNewWindow:g["new-window"],preferNewWindow:!g["reuse-window"]&&!g.wait,forceReuseWindow:g["reuse-window"],diffMode:g.diff,mergeMode:g.merge,addMode:g.add,noRecentEntry:!!g["skip-add-to-recently-opened"],gotoLineMode:g.goto});if(P&&$.length===1&&$[0])return Promise.race([$[0].whenClosedOrLoaded,(0,T.whenDeleted)(P.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$Sgc=w,e.$Sgc=w=Se([se(0,m.$ak),se(1,d.$Xfc),se(2,u.$LY),se(3,I.$_i)],w)}),define(ce[135],le([0,1,13,22,4,46,2,7,33,16,97,20,6,5,62,87,29]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=e.$ogc=void 0,e.$ogc=(0,d.$Fi)("proxyAuthService");let b=class extends T.$Uc{constructor(P,E,i,h,t,o){super(),this.h=P,this.m=E,this.n=i,this.r=h,this.s=t,this.t=o,this.a="proxy-credentials://",this.b=new Map,this.c=void 0,this.f=new Set,this.g=new Map,this.u()}u(){const P=k.Event.fromNodeEventEmitter(n.app,"login",(E,i,h,t,o)=>({event:E,authInfo:{...t,attempt:h.firstAuthAttempt?1:2},callback:o}));this.B(P(this.w,this))}async lookupAuthorization(P){return this.w({authInfo:P})}async w({event:P,authInfo:E,callback:i}){if(!E.isProxy)return;P?.preventDefault();const h=String((0,R.$tj)({scheme:E.scheme,host:E.host,port:E.port}));let t,o=this.b.get(h);if(o)this.h.trace("auth#onLogin (proxy) - pending proxy handling found"),t=await o;else{this.h.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),o=this.y(E,h),this.b.set(h,o);try{t=await o}finally{this.b.delete(h)}}return i?.(t?.username,t?.password),t}async y(P,E){this.h.trace("auth#resolveProxyCredentials (proxy) - enter");try{const i=await this.z(P,E);if(i)return this.h.trace("auth#resolveProxyCredentials (proxy) - got credentials"),i;this.h.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.h.trace("auth#resolveProxyCredentials (proxy) - exit")}}async z(P,E){if(this.h.trace("auth#doResolveProxyCredentials - enter",P),this.t.extensionTestsLocationURI){const l=this.s.getValue("integration-test.http.proxyAuth");if(l){const S=l.indexOf(":");return S!==-1?{username:l.substring(0,S),password:l.substring(S+1)}:{username:l,password:""}}return}const i=(this.s.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;if(i?.indexOf("@")!==-1){const l=I.URI.parse(i),S=l.authority.indexOf("@");if(S!==-1){if(P.attempt>1){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - ignoring previously used config/envvar credentials");return}this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found config/envvar credentials to use");const y=l.authority.substring(0,S),A=y.indexOf(":");return A!==-1?{username:y.substring(0,A),password:y.substring(A+1)}:{username:y,password:""}}}const h=P.attempt===1&&this.g.get(E);if(h){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found session credentials to use");const{username:l,password:S}=h;return{username:l,password:S}}let t,o;try{const l=this.r.get(this.a+E,f.StorageScope.APPLICATION);if(l){const S=JSON.parse(await this.n.decrypt(l));t=S.username,o=S.password}}catch(l){this.h.error(l)}if(P.attempt===1&&typeof t=="string"&&typeof o=="string")return this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.g.set(E,{username:t,password:o}),{username:t,password:o};const s=this.c,a=this.c=(async()=>{await s;const l=await this.C(P,E,t,o);return this.c===a&&(this.c=void 0),l})();return a}async C(P,E,i,h){if(this.f.has(E)){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - login dialog was cancelled before, not showing again");return}const t=this.m.getFocusedWindow()||this.m.getLastActiveWindow();if(!t){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.h.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${t.id} to handle proxy login`);const o=this.g.get(E),s={authInfo:P,username:o?.username??i,password:o?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,p.$2g)()}`};t.sendWhenReady("vscode:openProxyAuthenticationDialog",r.CancellationToken.None,s);const a=await new Promise(l=>{const S=async(y,A,L)=>{if(A===s.replyChannel)if(this.h.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${t.id}`),t.win?.webContents.off("ipc-message",S),L){const D={username:L.username,password:L.password};try{if(L.remember){const O=await this.n.encrypt(JSON.stringify(D));this.r.store(this.a+E,O,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}else this.r.remove(this.a+E,f.StorageScope.APPLICATION)}catch(O){this.h.error(O)}l({username:D.username,password:D.password})}else this.f.add(E),l(void 0)};t.win?.webContents.on("ipc-message",S)});return this.g.set(E,a),a}};e.$pgc=b,e.$pgc=b=Se([se(0,w.$ak),se(1,v.$Xfc),se(2,m.$FY),se(3,g.$mgc),se(4,c.$_i),se(5,u.$Kfc)],b)}),define(ce[262],le([0,1,2,19,52,58,30,8,29]),function(x,e,n,r,k,R,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=void 0;let c=class extends n.$Uc{constructor(u,d,w){super(),this.a=d,this.b=w,this.B(u.onWillLoadWindow(f=>{f.reason===k.LoadReason.LOAD&&this.c(f.window)})),this.B(u.onBeforeCloseWindow(f=>this.c(f))),this.B(new I.$Rh(()=>this.g(),30*1e3)).schedule()}async c(u){const d=this.f(u),w=this.a.getProfileForWorkspace(d);w?.isTransient&&(this.a.unsetWorkspace(d,w.isTransient),w.isTransient&&await this.a.cleanUpTransientProfiles())}f(u){return u.openedWorkspace??(0,T.$Ti)(u.backupPath,u.isExtensionDevelopmentHost)}g(){const u=this.a.getAssociatedEmptyWindows();if(u.length===0)return;const d=this.b.getWindows().map(w=>this.f(w));for(const w of u)d.some(f=>f.id===w.id)||this.a.unsetWorkspace(w,!1)}};e.$vhc=c,e.$vhc=c=Se([se(0,r.$egc),se(1,R.$1fc),se(2,p.$Xfc)],c)});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[63],le([0,1,13,2,4,5,282,8,12,29,81,24,19,79,37,3,106,11]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=e.$sgc=void 0,m=Ve(m);function P(h){return typeof h.responseWindowId=="number"}let E=class extends r.$Uc{static{$=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from($.b.values())}constructor(t,o,s){super(),this.w=t,this.y=o,this.z=s,this.c=String(++$.a),this.f=this.B(new k.$le),this.onStdout=this.f.event,this.g=this.B(new k.$le),this.onStderr=this.g.event,this.h=this.B(new k.$le),this.onMessage=this.h.event,this.j=this.B(new k.$le),this.onSpawn=this.j.event,this.m=this.B(new k.$le),this.onExit=this.m.event,this.n=this.B(new k.$le),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0,this.u=!1}C(t,o){let s;switch(this.t?.correlationId?s=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:s=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,o){case m.default.Error:this.w.error(s);break;case m.default.Warning:this.w.warn(s);break;case m.default.Info:this.w.trace(s);break}}D(){return this.r?(this.C("Cannot start utility process because it is already running...",m.default.Error),!1):!0}start(t){const o=this.F(t);return o&&t.payload&&this.postMessage(t.payload)&&this.C("payload sent via postMessage()",m.default.Info),o}F(t){if(!this.D())return!1;this.t=t;const o=`${this.t.type}-${this.c}`,s=p.$Zg.asFileUri("bootstrap-fork.js").fsPath,a=this.t.args??[],l=this.t.execArgv??[],S=this.t.allowLoadingUnsignedLibraries,y=this.t.forceAllocationsToV8Sandbox,A=this.t.respondToAuthRequestsFromMainProcess,L="pipe",D=this.G(t);return this.C("creating new...",m.default.Info),this.r=n.utilityProcess.fork(s,a,(0,b.$wg)({serviceName:o,env:D,execArgv:l,allowLoadingUnsignedLibraries:S,forceAllocationsToV8Sandbox:y,respondToAuthRequestsFromMainProcess:A,stdio:L})),this.H(this.r,this.t,o),!0}G(t){const o=t.env?{...t.env}:{...(0,f.$eo)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,g.$j&&((0,v.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,v.getUNCHostAllowlist)().join("\\")),(0,w.$mm)(o);for(const s of Object.keys(o))o[s]=String(o[s]);return o}H(t,o,s){if(t.stdout){const a=new T.StringDecoder("utf-8");this.B(k.Event.fromNodeEventEmitter(t.stdout,"data")(l=>this.f.fire(typeof l=="string"?l:a.write(l))))}if(t.stderr){const a=new T.StringDecoder("utf-8");this.B(k.Event.fromNodeEventEmitter(t.stderr,"data")(l=>this.g.fire(typeof l=="string"?l:a.write(l))))}this.B(k.Event.fromNodeEventEmitter(t,"message")(a=>this.h.fire(a))),this.B(k.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&$.b.set(t.pid,{pid:t.pid,name:P(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.C("successfully created",m.default.Info),this.j.fire(t.pid)})),this.B(k.Event.fromNodeEventEmitter(t,"exit")(a=>{const l=this.I(a)?0:a;this.C(`received exit event with code ${l}`,m.default.Info),this.m.fire({pid:this.s,code:l,signal:"unknown"}),this.J()})),this.B(k.Event.fromNodeEventEmitter(n.app,"child-process-gone",(a,l)=>({event:a,details:l}))(({details:a})=>{a.type==="Utility"&&a.name===s&&!this.I(a.exitCode)&&(this.C(`crashed with code ${a.exitCode} and reason '${a.reason}'`,m.default.Error),this.y.publicLog2("utilityprocesscrash",{type:o.type,reason:a.reason,code:a.exitCode}),this.n.fire({pid:this.s,code:a.exitCode,reason:a.reason}),this.J())}))}once(t,o){const s=this.B(this.h.event(a=>{a===t&&(s.dispose(),o())}))}postMessage(t,o){return this.r?(this.r.postMessage(t,o),!0):!1}connect(t){const{port1:o,port2:s}=new n.MessageChannelMain;return this.postMessage(t,[s]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.C("enabling inspect port",m.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.C("attempting to kill the process...",m.default.Info),this.r.kill()?(this.C("successfully killed the process",m.default.Info),this.u=!0,this.J()):this.C("unable to kill the process",m.default.Warning)}I(t){return t===0?!0:this.u&&t===15}J(){typeof this.s=="number"&&$.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.C("waiting to exit...",m.default.Info),await Promise.race([k.Event.toPromise(this.onExit),(0,I.$Gh)(t)]),this.r&&(this.C(`did not exit within ${t}ms, will kill it now...`,m.default.Info),this.kill()))}};e.$sgc=E,e.$sgc=E=$=Se([se(0,R.$ak),se(1,u.$_l),se(2,d.$egc)],E);let i=class extends E{constructor(t,o,s,a){super(t,s,a),this.L=o}start(t){const o=this.L.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.C("Refusing to start utility process because requesting window cannot be found or is destroyed...",m.default.Error),!0;if(!super.F(t))return!1;this.M(o.win,t);const a=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[a]),!0}M(t,o){o.windowLifecycleBound&&(this.B(k.Event.filter(this.z.onWillLoadWindow,s=>s.window.win===t)(()=>this.kill())),this.B(k.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$tgc=i,e.$tgc=i=Se([se(0,R.$ak),se(1,c.$Xfc),se(2,u.$_l),se(3,d.$egc)],i)}),define(ce[263],le([0,1,8,15,4,2,19,5,24,63,29]),function(x,e,n,r,k,R,T,I,p,c,m){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=void 0;let d=class extends R.$Uc{static{u=this}static{this.a=0}constructor(f,g,v,b){super(),this.f=f,this.g=g,this.h=v,this.j=b,this.b=new Map,this.c=!1,this.B(this.g.onWillShutdown($=>{this.c=!0,$.join("extHostStarter",this._waitForAllExit(6e3))}))}dispose(){super.dispose()}m(f){const g=this.b.get(f);if(!g)throw new Error("Unknown extension host!");return g}onDynamicStdout(f){return this.m(f).onStdout}onDynamicStderr(f){return this.m(f).onStderr}onDynamicMessage(f){return this.m(f).onMessage}onDynamicExit(f){return this.m(f).onExit}async createExtensionHost(){if(this.c)throw(0,r.$5)();const f=String(++u.a),g=new c.$tgc(this.f,this.h,this.j,this.g);this.b.set(f,g);const v=g.onExit(({pid:b,code:$,signal:P})=>{v.dispose(),this.f.info(`Extension host with pid ${b} exited with code: ${$}, signal: ${P}.`),setTimeout(()=>{g.dispose(),this.b.delete(f)}),setTimeout(()=>{try{process.kill(b,0),this.f.error(`Extension host with pid ${b} still exists, forcefully killing it...`),process.kill(b)}catch{}},1e3)});return{id:f}}async start(f,g){if(this.c)throw(0,r.$5)();const v=this.m(f);return v.start({...g,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:g.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,respondToAuthRequestsFromMainProcess:!0,correlationId:f}),{pid:await k.Event.toPromise(v.onSpawn)}}async enableInspectPort(f){if(this.c)throw(0,r.$5)();const g=this.b.get(f);return g?g.enableInspectPort():!1}async kill(f){if(this.c)throw(0,r.$5)();const g=this.b.get(f);g&&g.kill()}async _killAllNow(){for(const[,f]of this.b)f.kill()}async _waitForAllExit(f){const g=[];for(const[,v]of this.b)g.push(v.waitForExit(f));return n.Promises.settled(g).then(()=>{})}};e.$Agc=d,e.$Agc=d=u=Se([se(0,I.$ak),se(1,T.$egc),se(2,m.$Xfc),se(3,p.$_l)],d)}),define(ce[264],le([0,1,35,8,2,20,19,5,42,40,71,63,57,95,11,216,4]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=void 0;let b=class extends k.$Uc{constructor(P,E,i,h,t,o,s,a,l){super(),this.g=P,this.h=E,this.j=i,this.m=h,this.n=t,this.r=o,this.s=s,this.t=a,this.u=l,this.a=new r.$Eh,this.b=void 0,this.c=void 0,this.f=this.B(new v.$le),this.onDidCrash=this.f.event,this.C=void 0,this.D=void 0,this.w()}w(){n.$WX.on(g.$4gc.request,(P,E)=>this.y(P,E,g.$4gc.response)),n.$WX.on(g.$5gc.request,(P,E)=>this.y(P,E,g.$5gc.response)),this.B(this.r.onWillShutdown(()=>this.z()))}async y(P,E,i){this.s.trace(`[SharedProcess] onWindowConnection for: ${i}`),this.a.isOpen()||this.a.open(),await this.whenReady();const h=await this.connect(i);if(P.sender.isDestroyed())return h.close();P.sender.postMessage(i,E,[h])}z(){this.s.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(g.$3gc.exit),this.b=void 0}whenReady(){return this.C||(this.C=(async()=>{await this.F;const P=new r.$3h;this.b?.once(g.$3gc.initDone,()=>P.complete()),await P.p,this.c?.dispose(),this.s.trace("[SharedProcess] Overall ready")})()),this.C}get F(){return this.D||(this.D=(async()=>{await this.a.wait(),this.G();const P=new r.$3h;this.b?.once(g.$3gc.ipcReady,()=>P.complete()),await P.p,this.s.trace("[SharedProcess] IPC ready")})()),this.D}G(){this.b=this.B(new u.$sgc(this.s,d.$zp,this.r)),this.c=this.b.onMessage(i=>{typeof i.warning=="string"?this.s.warn(i.warning):typeof i.error=="string"&&this.s.error(i.error)});const P=(0,w.$$m)(this.m.args,this.m.isBuilt);let E;P.port&&(E=["--nolazy"],P.break?E.push(`--inspect-brk=${P.port}`):E.push(`--inspect=${P.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.H(),execArgv:E}),this.B(this.b.onCrash(()=>this.f.fire()))}H(){return{machineId:this.g,sqmId:this.h,devDeviceId:this.j,codeCachePath:this.m.codeCachePath,profiles:{home:this.n.profilesHome,all:this.n.profiles},args:this.m.args,logLevel:this.t.getLogLevel(),loggers:this.t.getRegisteredLoggers(),policiesData:this.u.serialize()}}async connect(P){return await this.F,(0,f.$pg)(this.b).connect(P)}};e.$6gc=b,e.$6gc=b=Se([se(3,R.$Kfc),se(4,p.$Ml),se(5,T.$egc),se(6,I.$ak),se(7,m.$_fc),se(8,c.$to)],b)}),define(ce[265],le([0,1,20,95,19,5,57,75,63,118,35,2,4,37,16,12]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=void 0;let v=class extends u.$Uc{constructor($,P,E,i,h){super(),this.f=$,this.g=P,this.h=E,this.j=i,this.m=h,this.a=void 0,this.b=new d.$le,this.onRequestConnection=this.b.event,this.c=new d.$le,this.onWillShutdown=this.c.event,this.B(this.j.onWillShutdown(()=>this.c.fire())),m.$WX.on("vscode:createPtyHostMessageChannel",(t,o)=>this.r(t,o)),this.B((0,u.$Sc)(()=>{m.$WX.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new p.$sgc(this.m,T.$zp,this.j);const $=(0,r.$0m)(this.h.args,this.h.isBuilt),P=$.port?["--nolazy",`--inspect${$.break?"-brk":""}=${$.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:P,args:["--logsPath",this.h.logsHome.with({scheme:g.Schemas.file}).fsPath],env:this.n()});const E=this.a.connect(),i=new c.$5X(E,"ptyHost"),h=new u.$Tc;return h.add(i),h.add((0,u.$Sc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:i,store:h,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const $={...(0,w.$eo)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},P=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostLatency);P&&typeof P=="number"&&($.VSCODE_LATENCY=String(P));const E=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostStartupDelay);return E&&typeof E=="number"&&($.VSCODE_STARTUP_DELAY=String(E)),this.h.restoreSnapExportedVariables(),$}r($,P){this.b.fire();const E=this.a.connect();if($.sender.isDestroyed()){E.close();return}$.sender.postMessage("vscode:createPtyHostMessageChannelResult",P,[E])}};e.$Hhc=v,e.$Hhc=v=Se([se(1,f.$_i),se(2,n.$Kfc),se(3,k.$egc),se(4,R.$ak)],v)}),define(ce[266],le([0,1,2,6,5,29,63,24,46,4,8,19]),function(x,e,n,r,k,R,T,I,p,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=e.$Fhc=void 0,e.$Fhc=(0,r.$Fi)("utilityProcessWorker");let d=class extends n.$Uc{constructor(g,v,b,$){super(),this.b=g,this.c=v,this.f=b,this.g=$,this.a=new Map}async createWorker(g){const v=`window: ${g.reply.windowId}, moduleId: ${g.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${v})`);const b=this.h(g);this.a.has(b)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${v})`),this.disposeWorker(g));const $=new w(this.b,this.c,this.f,this.g,g);if(!$.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(b,$);const P=new m.$3h;return c.Event.once($.onDidTerminate)(E=>{E.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.a.delete(b),P.complete({reason:E})}),P.p}h(g){return(0,p.$tj)({moduleId:g.process.moduleId,windowId:g.reply.windowId})}async disposeWorker(g){const v=this.h(g),b=this.a.get(v);b&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${g.reply.windowId}, moduleId: ${g.process.moduleId})`),b.kill(),b.dispose(),this.a.delete(v))}};e.$Ghc=d,e.$Ghc=d=Se([se(0,k.$ak),se(1,R.$Xfc),se(2,I.$_l),se(3,u.$egc)],d);let w=class extends n.$Uc{constructor(g,v,b,$,P){super(),this.c=g,this.f=v,this.g=b,this.h=$,this.j=P,this.a=this.B(new c.$le),this.onDidTerminate=this.a.event,this.b=this.B(new T.$tgc(this.c,this.f,this.g,this.h)),this.m()}m(){this.B(this.b.onExit(g=>this.a.fire({code:g.code,signal:g.signal}))),this.B(this.b.onCrash(g=>this.a.fire({code:g.code,signal:"ECRASH"})))}spawn(){const v=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:v,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};w=Se([se(0,k.$ak),se(1,R.$Xfc),se(2,I.$_l),se(3,u.$egc)],w)}),define(ce[267],le([0,1,13,4,2,241,29]),function(x,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=void 0;let I=class extends k.$Uc{constructor(c){super(),this.b=c,this.a=this.B(new r.$le),this.onFoundInFrame=this.a.event,this.B(new R.$khc)}async setIgnoreMenuShortcuts(c,m){let u;if(typeof c.windowId=="number"){const{windowId:d}=c,w=this.b.getWindowById(d);if(!w?.win)throw new Error(`Invalid windowId: ${d}`);u=w.win.webContents}else{const{webContentsId:d}=c;if(u=n.webContents.fromId(d),!u)throw new Error(`Invalid webContentsId: ${d}`)}u.isDestroyed()||u.setIgnoreMenuShortcuts(m)}async findInFrame(c,m,u,d){const f=this.c(c,m);if(typeof f.findInFrame=="function"){f.findInFrame(u,{findNext:d.findNext,forward:d.forward});const g=(v,b)=>{b.finalUpdate&&(this.a.fire(b),f.removeListener("found-in-frame",g))};f.on("found-in-frame",g)}}async stopFindInFrame(c,m,u){const w=this.c(c,m);typeof w.stopFindInFrame=="function"&&w.stopFindInFrame(u.keepSelection?"keepSelection":"clearSelection")}c(c,m){const u=this.b.getWindowById(c.windowId);if(!u?.win)throw new Error(`Invalid windowId: ${c}`);const d=u.win.webContents.mainFrame.framesInSubtree.find(w=>w.name===m);if(!d)throw new Error(`Unknown frame: ${m}`);return d}};e.$lhc=I,e.$lhc=I=Se([se(0,T.$Xfc)],I)});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[268],le([0,1,13,2,3,18,7,16,19,5,34,29,52,30]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=void 0,e.$nhc=v,e.$ohc=$,n=Ve(n);let g=class extends r.$Uc{static{f=this}static{this.a="windowsState"}get state(){return this.b}constructor(i,h,t,o,s){super(),this.g=i,this.h=h,this.j=t,this.m=o,this.n=s,this.b=v(this.h.getItem(f.a)),this.c=void 0,this.f=!1,this.r()}r(){n.default.app.on("browser-window-blur",()=>{this.f||this.t()}),this.B(this.j.onBeforeCloseWindow(i=>this.u(i))),this.B(this.j.onBeforeShutdown(()=>this.s())),this.B(this.g.onDidChangeWindowsCount(i=>{i.newCount-i.oldCount>0&&(this.c=void 0)})),this.B(this.g.onDidDestroyWindow(i=>this.u(i)))}s(){this.f=!0,this.t()}t(){const i=new Set,h={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!h.lastActiveWindow){let s=this.g.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.g.getWindows().find(a=>!a.isExtensionDevelopmentHost)),s&&(h.lastActiveWindow=this.w(s),h.lastActiveWindow.uiState.mode===d.WindowMode.Fullscreen&&i.add(h.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);t&&(h.lastPluginDevelopmentHostWindow=this.w(t),h.lastPluginDevelopmentHostWindow.uiState.mode===d.WindowMode.Fullscreen&&(i.has(h.lastPluginDevelopmentHostWindow.uiState.display)?k.$k&&!t.win?.isSimpleFullScreen()&&(h.lastPluginDevelopmentHostWindow.uiState.mode=d.WindowMode.Normal):i.add(h.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(h.openedWindows=this.g.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>{const a=this.w(s);return a.uiState.mode===d.WindowMode.Fullscreen&&(i.has(a.uiState.display)?k.$k&&a.windowId!==h.lastActiveWindow?.windowId&&!s.win?.isSimpleFullScreen()&&(a.uiState.mode=d.WindowMode.Normal):i.add(a.uiState.display)),a}));const o=$(h);this.h.setItem(f.a,o),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",o)}u(i){if(this.j.quitRequested)return;const h=this.w(i);i.isExtensionDevelopmentHost&&!i.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=h:!i.isExtensionDevelopmentHost&&i.openedWorkspace&&this.b.openedWindows.forEach(t=>{const o=(0,w.$Ui)(i.openedWorkspace)&&t.workspace?.id===i.openedWorkspace.id,s=(0,w.$Pi)(i.openedWorkspace)&&t.folderUri&&R.$0g.isEqual(t.folderUri,i.openedWorkspace.uri);(o||s)&&(t.uiState=h.uiState)}),this.g.getWindowCount()===1&&(this.c=h)}w(i){return{windowId:i.id,workspace:(0,w.$Ui)(i.openedWorkspace)?i.openedWorkspace:void 0,folderUri:(0,w.$Pi)(i.openedWorkspace)?i.openedWorkspace.uri:void 0,backupPath:i.backupPath,remoteAuthority:i.remoteAuthority,uiState:i.serializeWindowState()}}getNewWindowState(i){const h=this.z(i),t=this.n.getValue("window");if(h.mode===d.WindowMode.Fullscreen){let o;h.hasDefaultState?o=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):o=!!(this.j.wasRestarted||t?.restoreFullscreen),o||(h.mode=d.WindowMode.Normal)}return h}z(i){const h=this.g.getLastActiveWindow();if(!i.extensionTestsPath){if(i.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const S=i.workspace;if((0,w.$Ui)(S)){const A=this.state.openedWindows.filter(L=>L.workspace&&L.workspace.id===S.id).map(L=>L.uiState);if(A.length)return A[0]}if((0,w.$Pi)(S)){const A=this.state.openedWindows.filter(L=>L.folderUri&&R.$0g.isEqual(L.folderUri,S.uri)).map(L=>L.uiState);if(A.length)return A[0]}else if(i.backupPath){const A=this.state.openedWindows.filter(L=>L.backupPath===i.backupPath).map(L=>L.uiState);if(A.length)return A[0]}const y=this.c||this.state.lastActiveWindow;if(!h&&y)return y.uiState}let t;const o=n.default.screen.getAllDisplays();if(o.length===1)t=o[0];else{if(k.$k){const S=n.default.screen.getCursorScreenPoint();t=n.default.screen.getDisplayNearestPoint(S)}!t&&h&&(t=n.default.screen.getDisplayMatching(h.getBounds())),t||(t=n.default.screen.getPrimaryDisplay()||o[0])}let s=(0,d.$Mfc)();s.x=Math.round(t.bounds.x+t.bounds.width/2-s.width/2),s.y=Math.round(t.bounds.y+t.bounds.height/2-s.height/2);const a=this.n.getValue("window");let l=!0;if(a?.newWindowDimensions){if(a.newWindowDimensions==="maximized")s.mode=d.WindowMode.Maximized,l=!1;else if(a.newWindowDimensions==="fullscreen")s.mode=d.WindowMode.Fullscreen,l=!1;else if((a.newWindowDimensions==="inherit"||a.newWindowDimensions==="offset")&&h){const S=h.serializeWindowState();S.mode===d.WindowMode.Fullscreen?s.mode=d.WindowMode.Fullscreen:s={...S,zoomLevel:void 0},l=s.mode!==d.WindowMode.Fullscreen&&a.newWindowDimensions==="offset"}}return l&&(s=this.C(s)),s.hasDefaultState=!0,s}C(i){if(this.g.getWindows().length===0)return i;i.x=typeof i.x=="number"?i.x:0,i.y=typeof i.y=="number"?i.y:0;const h=this.g.getWindows().map(t=>t.getBounds());for(;h.some(t=>t.x===i.x||t.y===i.y);)i.x+=30,i.y+=30;return i}};e.$mhc=g,e.$mhc=g=f=Se([se(0,u.$Xfc),se(1,m.$CR),se(2,p.$egc),se(3,c.$ak),se(4,I.$_i)],g);function v(E){const i={openedWindows:[]},h=E||{openedWindows:[]};return h.lastActiveWindow&&(i.lastActiveWindow=b(h.lastActiveWindow)),h.lastPluginDevelopmentHostWindow&&(i.lastPluginDevelopmentHostWindow=b(h.lastPluginDevelopmentHostWindow)),Array.isArray(h.openedWindows)&&(i.openedWindows=h.openedWindows.map(t=>b(t))),i}function b(E){const i={uiState:E.uiState};return E.backupPath&&(i.backupPath=E.backupPath),E.remoteAuthority&&(i.remoteAuthority=E.remoteAuthority),E.folder&&(i.folderUri=T.URI.parse(E.folder)),E.workspaceIdentifier&&(i.workspace={id:E.workspaceIdentifier.id,configPath:T.URI.parse(E.workspaceIdentifier.configURIPath)}),i}function $(E){return{lastActiveWindow:E.lastActiveWindow&&P(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&P(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(i=>P(i))}}function P(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[59],le([0,1,26,13,4,43,2,12,9,18,23,10,69,53,20,6,5,58,134,30,102,103]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b,$,P,E,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=e.$0fc=void 0,n=Pe(n),r=Ve(r),e.$0fc=(0,g.$Fi)("workspacesManagementMainService");let h=class extends T.$Uc{constructor(o,s,a,l,S){super(),this.g=o,this.h=s,this.j=a,this.m=l,this.n=S,this.a=this.B(new k.$le),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new k.$le),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await m.Promises.readdir(this.c.with({scheme:I.Schemas.file}).fsPath)).map(s=>(0,c.$gh)(this.c,s,P.$5i));for(const s of o){const a=(0,i.$7fc)(s),l=await this.resolveLocalWorkspace(s);l?this.f.push({workspace:a,remoteAuthority:l.remoteAuthority}):await this.deleteUntitledWorkspace(a)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,s=>n.promises.readFile(s,"utf8"))}r(o,s){if(this.s(o)&&o.scheme===I.Schemas.file)try{const a=s(o.fsPath);return a instanceof Promise?a.then(l=>this.t(o,l),l=>{}):this.t(o,a)}catch{return}}s(o){return(0,P.$6i)(o,this.g)||(0,P.$$i)(o)}t(o,s){try{const a=this.u(o,s),l=(0,i.$7fc)(o);return{id:l.id,configPath:l.configPath,folders:(0,E.$kib)(a.folders,l.configPath,c.$0g),remoteAuthority:a.remoteAuthority,transient:a.transient}}catch(a){this.h.warn(a.toString())}}u(o,s){const a=(0,R.$Yn)(s);if(a&&Array.isArray(a.folders))a.folders=a.folders.filter(l=>(0,E.$iib)(l));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return a}async createUntitledWorkspace(o,s){const{workspace:a,storedWorkspace:l}=this.w(o,s),S=a.configPath.fsPath;return await n.promises.mkdir((0,p.$mc)(S),{recursive:!0}),await m.Promises.writeFile(S,JSON.stringify(l,null,"	")),this.f.push({workspace:a,remoteAuthority:s}),a}w(o=[],s){const a=(Date.now()+Math.round(Math.random()*1e3)).toString(),l=(0,c.$gh)(this.c,a),S=(0,c.$gh)(l,P.$5i),y=[];for(const A of o)y.push((0,E.$jib)(A.uri,!0,A.name,l,c.$0g));return{workspace:(0,i.$7fc)(S),storedWorkspace:{folders:y,remoteAuthority:s}}}async getWorkspaceIdentifier(o){return(0,i.$7fc)(o)}isUntitledWorkspace(o){return(0,P.$6i)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const s=(0,c.$7g)(o.configPath);try{await m.Promises.rm((0,p.$mc)(s));const a=(0,p.$jc)(this.g.workspaceStorageHome.with({scheme:I.Schemas.file}).fsPath,o.id);await m.Promises.exists(a)&&await m.Promises.writeFile((0,p.$jc)(a,"obsolete"),""),this.f=this.f.filter(l=>l.workspace.id!==o.id)}catch(a){this.h.warn(`Unable to delete untitled workspace ${s} (${a}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,s,a){if(!o||!o.win||!o.isReady||!await this.z(o,s,a))return;const S=await this.C(o,(0,i.$7fc)(a));if(S)return this.b.fire({window:o,workspace:S.workspace}),S}async z(o,s,a){return a?(0,P.$Ui)(o.openedWorkspace)&&c.$0g.isEqual(o.openedWorkspace.configPath,a)?!1:(0,$.$4fc)(s,a)?(await this.n.showMessageBox({type:"info",buttons:[(0,u.localize)(11017,null)],message:(0,u.localize)(11018,null,(0,c.$dh)(a)),detail:(0,u.localize)(11019,null)},r.default.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,s){if(!o.config)return;o.focus();let a;return o.config.extensionDevelopmentPath||(o.config.backupPath?a=await this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority},o.config.backupPath):a=this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority})),(0,P.$Ui)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=s,o.config.backupPath=a,{workspace:s,backupPath:a}}};e.$$fc=h,e.$$fc=h=Se([se(0,f.$Kfc),se(1,v.$ak),se(2,b.$1fc),se(3,d.$Rfc),se(4,w.$Sfc)],h)}),define(ce[136],le([0,1,13,35,22,6,29,30,59,11,5,63]),function(x,e,n,r,k,R,T,I,p,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=e.$vgc=e.ID=void 0,e.ID="diagnosticsMainService",e.$vgc=(0,R.$Fi)(e.ID);let d=class{constructor(f,g,v){this.a=f,this.b=g,this.c=v}async getRemoteDiagnostics(f){const g=this.a.getWindows();return(await Promise.all(g.map(async b=>{const $=b.remoteAuthority;if(!$)return;const P=`vscode:getDiagnosticInfoResponse${b.id}`,E={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?await this.f(b):void 0};return new Promise(i=>{b.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:P,args:E}),r.$WX.once(P,(h,t)=>{t||i({hostName:$,errorMessage:`Unable to resolve connection to '${$}'.`}),i(t)}),setTimeout(()=>{i({hostName:$,errorMessage:`Connection to '${$}' could not be established`})},5e3)})}))).filter(b=>!!b)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const f=[];for(const v of n.BrowserWindow.getAllWindows()){const b=this.a.getWindowById(v.id);b?f.push(await this.d(b)):f.push(this.e(v))}const g=[];for(const{pid:v,name:b}of u.$sgc.getAll())g.push({pid:v,name:b});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,pidToNames:g,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(f){const g=await this.f(f),v=(0,c.$pg)(f.win);return this.e(v,g,f.remoteAuthority)}e(f,g=[],v){return{id:f.id,pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:g,remoteAuthority:v}}async f(f){const g=[],v=f.openedWorkspace;if((0,I.$Pi)(v))g.push(v.uri);else if((0,I.$Ui)(v)){const b=await this.b.resolveLocalWorkspace(v.configPath);b&&b.folders.forEach(P=>{g.push(P.uri)})}return g}};e.$wgc=d,e.$wgc=d=Se([se(0,T.$Xfc),se(1,p.$0fc),se(2,m.$ak)],d)}),define(ce[64],le([0,1,26,48,13,27,154,54,4,2,12,9,3,7,112,92,23,113,10,53,20,6,19,5,28,76,29,30,59,17,212,202,84,15,16,135,49]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b,$,P,E,i,h,t,o,s,a,l,S,y,A,L,D,O,M,Z,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=e.$Kgc=void 0,n=Pe(n),e.$Kgc=(0,i.$Fi)("nativeHostMainService");let K=class extends c.$Uc{constructor(H,Y,B,Q,W,j,C,X,oe,V,ue,re){super(),this.a=H,this.b=Y,this.c=B,this.f=Q,this.g=W,this.h=j,this.j=C,this.m=X,this.n=oe,this.r=V,this.s=ue,this.t=re,this.onDidOpenMainWindow=p.Event.map(this.a.onDidOpenWindow,J=>J.id),this.onDidTriggerWindowSystemContextMenu=p.Event.any(p.Event.map(this.a.onDidTriggerSystemContextMenu,({window:J,x:F,y:N})=>({windowId:J.id,x:F,y:N})),p.Event.map(this.b.onDidTriggerSystemContextMenu,({window:J,x:F,y:N})=>({windowId:J.id,x:F,y:N}))),this.onDidMaximizeWindow=p.Event.any(p.Event.map(this.a.onDidMaximizeWindow,J=>J.id),p.Event.map(this.b.onDidMaximizeWindow,J=>J.id)),this.onDidUnmaximizeWindow=p.Event.any(p.Event.map(this.a.onDidUnmaximizeWindow,J=>J.id),p.Event.map(this.b.onDidUnmaximizeWindow,J=>J.id)),this.onDidChangeWindowFullScreen=p.Event.any(p.Event.map(this.a.onDidChangeFullScreen,J=>({windowId:J.window.id,fullscreen:J.fullscreen})),p.Event.map(this.b.onDidChangeFullScreen,J=>({windowId:J.window.id,fullscreen:J.fullscreen}))),this.onDidBlurMainWindow=p.Event.filter(p.Event.fromNodeEventEmitter(k.app,"browser-window-blur",(J,F)=>F.id),J=>!!this.a.getWindowById(J)),this.onDidFocusMainWindow=p.Event.any(p.Event.map(p.Event.filter(p.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),J=>!!J),J=>J.id),p.Event.filter(p.Event.fromNodeEventEmitter(k.app,"browser-window-focus",(J,F)=>F.id),J=>!!this.a.getWindowById(J))),this.onDidBlurMainOrAuxiliaryWindow=p.Event.any(this.onDidBlurMainWindow,p.Event.map(p.Event.filter(p.Event.fromNodeEventEmitter(k.app,"browser-window-blur",(J,F)=>this.b.getWindowByWebContents(F.webContents)),J=>!!J),J=>J.id)),this.onDidFocusMainOrAuxiliaryWindow=p.Event.any(this.onDidFocusMainWindow,p.Event.map(p.Event.filter(p.Event.fromNodeEventEmitter(k.app,"browser-window-focus",(J,F)=>this.b.getWindowByWebContents(F.webContents)),J=>!!J),J=>J.id)),this.onDidResumeOS=p.Event.fromNodeEventEmitter(k.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.u=this.B(new p.$le),this.onDidChangePassword=this.u.event,this.onDidChangeDisplay=p.Event.debounce(p.Event.any(p.Event.filter(p.Event.fromNodeEventEmitter(k.screen,"display-metrics-changed",(J,F,N)=>N),J=>!(Array.isArray(J)&&J.length===1&&J[0]==="workArea")),p.Event.fromNodeEventEmitter(k.screen,"display-added"),p.Event.fromNodeEventEmitter(k.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(H,Y){const B=this.a.getWindows().map(W=>({id:W.id,workspace:W.openedWorkspace??(0,l.$Ti)(W.backupPath,W.isExtensionDevelopmentHost),title:W.win?.getTitle()??"",filename:W.getRepresentedFilename(),dirty:W.isDocumentEdited()})),Q=[];return Y.includeAuxiliaryWindows&&Q.push(...this.b.getWindows().map(W=>({id:W.id,parentId:W.parentId,title:W.win?.getTitle()??"",filename:W.getRepresentedFilename()}))),[...B,...Q]}async getWindowCount(H){return this.a.getWindowCount()}async getActiveWindowId(H){const Y=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(Y)return Y.id}openWindow(H,Y,B){return Array.isArray(Y)?this.w(H,Y,B):this.z(H,Y)}async w(H,Y,B=Object.create(null)){Y.length>0&&await this.a.open({context:a.OpenContext.API,contextWindowId:H,urisToOpen:Y,cli:this.g.args,forceNewWindow:B.forceNewWindow,forceReuseWindow:B.forceReuseWindow,preferNewWindow:B.preferNewWindow,diffMode:B.diffMode,mergeMode:B.mergeMode,addMode:B.addMode,gotoLineMode:B.gotoLineMode,noRecentEntry:B.noRecentEntry,waitMarkerFileURI:B.waitMarkerFileURI,remoteAuthority:B.remoteAuthority||void 0,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile})}async z(H,Y){await this.a.openEmptyWindow({context:a.OpenContext.API,contextWindowId:H},Y)}async isFullScreen(H,Y){return this.H(Y?.targetWindowId,H)?.isFullScreen??!1}async toggleFullScreen(H,Y){this.H(Y?.targetWindowId,H)?.toggleFullScreen()}async handleTitleDoubleClick(H,Y){this.H(Y?.targetWindowId,H)?.handleTitleDoubleClick()}async getCursorScreenPoint(H){const Y=k.screen.getCursorScreenPoint(),B=k.screen.getDisplayNearestPoint(Y);return{point:Y,display:B.bounds}}async isMaximized(H,Y){return this.H(Y?.targetWindowId,H)?.win?.isMaximized()??!1}async maximizeWindow(H,Y){this.H(Y?.targetWindowId,H)?.win?.maximize()}async unmaximizeWindow(H,Y){this.H(Y?.targetWindowId,H)?.win?.unmaximize()}async minimizeWindow(H,Y){this.H(Y?.targetWindowId,H)?.win?.minimize()}async moveWindowTop(H,Y){this.H(Y?.targetWindowId,H)?.win?.moveTop()}async positionWindow(H,Y,B){const Q=this.H(B?.targetWindowId,H);if(Q?.win){if(Q.win.isFullScreen()){const W=p.Event.toPromise(p.Event.once(p.Event.fromNodeEventEmitter(Q.win,"leave-full-screen")));Q.win.setFullScreen(!1),await W}Q.win.setBounds(Y)}}async updateWindowControls(H,Y){this.H(Y?.targetWindowId,H)?.updateWindowControls(Y)}async focusWindow(H,Y){this.H(Y?.targetWindowId,H)?.focus({force:Y?.force??!1})}async setMinimumSize(H,Y,B){const Q=this.I(H);if(Q?.win){const[W,j]=Q.win.getSize(),[C,X]=Q.win.getMinimumSize(),[oe,V]=[Y??C,B??X],[ue,re]=[Math.max(W,oe),Math.max(j,V)];(C!==oe||X!==V)&&Q.win.setMinimumSize(oe,V),(W!==ue||j!==re)&&Q.win.setSize(ue,re)}}async saveWindowSplash(H,Y){this.m.saveWindowSplash(H,Y)}async installShellCommand(H){const{source:Y,target:B}=await this.C();try{const{symbolicLink:Q}=await v.SymlinkSupport.stat(Y);if(Q&&!Q.dangling){const W=await(0,f.$nr)(Y);if(B===W)return}await n.promises.unlink(Y)}catch(Q){if(Q.code!=="ENOENT")throw Q}try{await n.promises.symlink(B,Y)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="ENOENT")throw Q;const{response:W}=await this.showMessageBox(H,{type:"info",message:(0,$.localize)(11270,null,this.j.nameShort),buttons:[(0,$.localize)(11271,null),(0,$.localize)(11272,null)]});if(W===1)throw new O.$4;try{const j=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${B}' '${Y}'\\" with administrator privileges"`;await(0,T.promisify)(r.exec)(j)}catch{throw new Error((0,$.localize)(11273,null,Y))}}}async uninstallShellCommand(H){const{source:Y}=await this.C();try{await n.promises.unlink(Y)}catch(B){switch(B.code){case"EACCES":{const{response:Q}=await this.showMessageBox(H,{type:"info",message:(0,$.localize)(11274,null,this.j.nameShort),buttons:[(0,$.localize)(11275,null),(0,$.localize)(11276,null)]});if(Q===1)throw new O.$4;try{const W=`osascript -e "do shell script \\"rm '${Y}'\\" with administrator privileges"`;await(0,T.promisify)(r.exec)(W)}catch{throw new Error((0,$.localize)(11277,null,Y))}break}case"ENOENT":break;default:throw B}}}async C(){const H=(0,u.$kc)(this.g.appRoot,"bin","code"),Y=`/usr/local/bin/${this.j.applicationName}`;if(!await v.Promises.exists(H))throw new Error((0,$.localize)(11278,null,H));return{source:Y,target:H}}async showMessageBox(H,Y){const B=this.H(Y?.targetWindowId,H);return this.c.showMessageBox(Y,B?.win??void 0)}async showSaveDialog(H,Y){const B=this.H(Y?.targetWindowId,H);return this.c.showSaveDialog(Y,B?.win??void 0)}async showOpenDialog(H,Y){const B=this.H(Y?.targetWindowId,H);return this.c.showOpenDialog(Y,B?.win??void 0)}async pickFileFolderAndOpen(H,Y){const B=await this.c.pickFileFolder(Y);B&&await this.D(await Promise.all(B.map(async Q=>await v.SymlinkSupport.existsDirectory(Q)?{folderUri:w.URI.file(Q)}:{fileUri:w.URI.file(Q)})),Y,H)}async pickFolderAndOpen(H,Y){const B=await this.c.pickFolder(Y);B&&await this.D(B.map(Q=>({folderUri:w.URI.file(Q)})),Y,H)}async pickFileAndOpen(H,Y){const B=await this.c.pickFile(Y);B&&await this.D(B.map(Q=>({fileUri:w.URI.file(Q)})),Y,H)}async pickWorkspaceAndOpen(H,Y){const B=await this.c.pickWorkspace(Y);B&&await this.D(B.map(Q=>({workspaceUri:w.URI.file(Q)})),Y,H)}async D(H,Y,B){await this.a.open({context:a.OpenContext.DIALOG,contextWindowId:B,cli:this.g.args,urisToOpen:H,forceNewWindow:Y.forceNewWindow})}async showItemInFolder(H,Y){k.shell.showItemInFolder(Y)}async setRepresentedFilename(H,Y,B){this.H(B?.targetWindowId,H)?.setRepresentedFilename(Y)}async setDocumentEdited(H,Y,B){this.H(B?.targetWindowId,H)?.setDocumentEdited(Y)}async openExternal(H,Y,B){this.g.unsetSnapExportedVariables();try{(0,m.$Pg)(Y,m.Schemas.http,m.Schemas.https)?this.F(Y,B):k.shell.openExternal(Y)}finally{this.g.restoreSnapExportedVariables()}return!0}async F(H,Y){const B=Y??this.r.getValue("workbench.externalBrowser");if(!B)return k.shell.openExternal(H);if((B.includes(u.$gc.sep)||B.includes(u.$fc.sep))&&!await v.Promises.exists(B))return this.h.error(`Configured external browser path does not exist: ${B}`),k.shell.openExternal(H);try{const{default:Q}=await new Promise((W,j)=>{x(["open"],W,j)}).then(Pe);await Q(H,{app:{name:Object.hasOwn(Q.apps,B)?Q.apps[B]:B}})}catch(Q){return this.h.error(`Unable to open external URL '${H}' using browser '${B}' due to ${Q}.`),k.shell.openExternal(H)}}moveItemToTrash(H,Y){return k.shell.trashItem(Y)}async isAdmin(){let H;return d.$j?H=(await new Promise((Y,B)=>{x(["native-is-elevated"],Y,B)}).then(Pe)).default():H=process.getuid?.()===0,H}async writeElevated(H,Y,B,Q){const W=await new Promise((j,C)=>{x(["@vscode/sudo-prompt"],j,C)}).then(Pe);return new Promise((j,C)=>{const X=[`"${this.G}"`];Q?.unlock&&X.push("--file-chmod"),X.push("--file-write",`"${Y.fsPath}"`,`"${B.fsPath}"`);const oe={name:this.j.nameLong.replace("-",""),icns:d.$k&&this.g.isBuilt?(0,u.$jc)((0,u.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};W.exec(X.join(" "),oe,(V,ue,re)=>{ue&&this.h.trace(`[sudo-prompt] received stdout: ${ue}`),re&&this.h.trace(`[sudo-prompt] received stderr: ${re}`),V?C(V):j(void 0)})})}async isRunningUnderARM64Translation(){return d.$l||d.$j?!1:k.app.runningUnderARM64Translation}get G(){return d.$j?this.g.isBuilt?(0,u.$jc)((0,u.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,u.$jc)(this.g.appRoot,"scripts","code-cli.bat"):d.$l?this.g.isBuilt?(0,u.$jc)((0,u.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,u.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,u.$jc)(this.g.appRoot,"bin","code"):(0,u.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,R.totalmem)(),freemem:(0,R.freemem)(),loadavg:(0,R.loadavg)()}}async getOSProperties(){return{arch:(0,R.arch)(),platform:(0,R.platform)(),release:(0,R.release)(),type:(0,R.type)(),cpus:(0,R.cpus)()}}async getOSVirtualMachineHint(){return g.$Sn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return d.$j&&(0,A.$Hgc)()}async getProcessId(H){return this.H(void 0,H)?.win?.webContents.getOSProcessId()}async killProcess(H,Y,B){process.kill(Y,B)}async readClipboardText(H,Y){return k.clipboard.readText(Y)}async writeClipboardText(H,Y,B){return k.clipboard.writeText(Y,B)}async readClipboardFindText(H){return k.clipboard.readFindText()}async writeClipboardFindText(H,Y){return k.clipboard.writeFindText(Y)}async writeClipboardBuffer(H,Y,B,Q){return k.clipboard.writeBuffer(Y,Buffer.from(B.buffer),Q)}async readClipboardBuffer(H,Y){return y.$Ne.wrap(k.clipboard.readBuffer(Y))}async hasClipboard(H,Y,B){return k.clipboard.has(Y,B)}async newWindowTab(){await this.a.open({context:a.OpenContext.API,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){k.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){k.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){k.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){k.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){k.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(H,Y){this.I(H)?.updateTouchBar(Y)}async notifyReady(H){this.I(H)?.setReady()}async relaunch(H,Y){return this.f.relaunch(Y)}async reload(H,Y){const B=this.I(H);if(B){if((0,l.$Ui)(B.openedWorkspace)){const Q=B.openedWorkspace.configPath;if(Q.scheme===m.Schemas.file&&(await this.n.resolveLocalWorkspace(Q))?.transient)return this.openWindow(B.id,{forceReuseWindow:!0})}return this.f.reload(B,Y?.disableExtensions!==void 0?{_:[],"disable-extensions":Y.disableExtensions}:void 0)}}async closeWindow(H,Y){return this.H(Y?.targetWindowId,H)?.win?.close()}async quit(H){const Y=this.a.getLastActiveWindow();Y?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&Y.win?Y.win.close():this.f.quit()}async exit(H,Y){await this.f.kill(Y)}async resolveProxy(H,Y){if(this.g.extensionTestsLocationURI){const W=this.r.getValue("integration-test.http.proxy");if(W)return W}return this.I(H)?.win?.webContents?.session?.resolveProxy(Y)}async lookupAuthorization(H,Y){return this.t.lookupAuthorization(Y)}async lookupKerberosAuthorization(H,Y){return this.s.lookupKerberosAuthorization(Y)}async loadCertificates(H){return this.s.loadCertificates()}findFreePort(H,Y,B,Q,W=1){return(0,b.$4g)(Y,B,Q,W)}async openDevTools(H,Y){this.H(Y?.targetWindowId,H)?.win?.webContents.openDevTools(Y?.mode?{mode:Y.mode,activate:Y.activate}:void 0)}async toggleDevTools(H,Y){this.H(Y?.targetWindowId,H)?.win?.webContents.toggleDevTools()}async profileRenderer(H,Y,B){const Q=this.I(H);if(!Q||!Q.win)throw new Error;return await new L.$Igc(Q.win,Y,this.h).inspect(B)}async windowsGetStringRegKey(H,Y,B,Q){if(!d.$j)return;const W=await new Promise((j,C)=>{x(["@vscode/windows-registry"],j,C)}).then(Pe);try{return W.GetStringRegKey(Y,B,Q)}catch{return}}H(H,Y){return this.I(H)??this.J(H)??this.I(Y)}I(H){if(typeof H=="number")return this.a.getWindowById(H)}J(H){if(typeof H!="number")return;const Y=k.webContents.fromId(H);if(Y)return this.b.getWindowByWebContents(Y)}};e.$Lgc=K,Se([I.$0h],K.prototype,"G",null),e.$Lgc=K=Se([se(0,a.$Xfc),se(1,D.$Jgc),se(2,P.$Sfc),se(3,h.$egc),se(4,E.$Kfc),se(5,t.$ak),se(6,o.$tk),se(7,s.$Vfc),se(8,S.$0fc),se(9,M.$_i),se(10,q.$8p),se(11,Z.$ogc)],K)});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[269],le([0,1,13,27,8,22,2,12,3,35,10,53,20,5,64,72,73,51,29]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b,$){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0,g=Ve(g);let E=class{static{P=this}static{this.a="#1E1E1E"}constructor(h,t,o,s,a,l,S){this.d=h,this.e=t,this.f=o,this.g=s,this.h=a,this.i=l,this.j=S,this.b=null,this.c=null}async openReporter(h){if(this.b)this.b&&this.k(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const t=new T.$Tc,o=t.add(this.i.createIPCObjectUrl()),s=this.m(this.c,700,800);this.b=this.l(s,o,{backgroundColor:h.styles.backgroundColor,title:(0,m.localize)(11367,null),zoomLevel:h.zoomLevel,alwaysOnTop:!1},"issue-reporter"),o.update({appRoot:this.e.appRoot,windowId:this.b.id,userEnv:this.d,data:h,disableExtensions:!!this.e.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:g.default,nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE}}),this.b.loadURL(I.$Zg.asBrowserUri(`vs/workbench/contrib/issue/electron-sandbox/issueReporter${this.e.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,t.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,t.dispose())})}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.h.reload(this.c.id,{disableExtensions:!0})}catch(h){this.f.error(h)}}async $showConfirmCloseDialog(){if(this.b){const{response:h}=await this.g.showMessageBox({type:"warning",message:(0,m.localize)(11368,null),buttons:[(0,m.localize)(11369,null),(0,m.localize)(11370,null)]},this.b);h===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:h}=await this.g.showMessageBox({type:"warning",message:(0,m.localize)(11371,null),buttons:[(0,m.localize)(11372,null),(0,m.localize)(11373,null)]},this.b);return h===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const h=this.j.getWindowById(this.c.id);if(!h)throw new Error("Window not found");return h}async $sendReporterMenu(h,t){const o=this.issueReporterWindowCheck(),s="vscode:triggerReporterMenu",a=new R.$we;return o.sendWhenReady(s,a.token,{replyChannel:s,extensionId:h,extensionName:t}),await(0,k.$wh)(new Promise(S=>c.$WX.once(`vscode:triggerReporterMenuResponse:${h}`,(y,A)=>S(A))),5e3,()=>{this.f.error(`Error: Extension ${h} timed out waiting for menu response`),a.cancel()})}async $closeReporter(){this.b?.close()}k(h){h.isMinimized()&&h.restore(),h.focus()}l(h,t,o,s){const a=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:h.width,height:h.height,minWidth:300,minHeight:200,x:h.x,y:h.y,title:o.title,backgroundColor:o.backgroundColor||P.a,webPreferences:{preload:I.$Zg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`],v8CacheOptions:this.e.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,b.$hE)(o.zoomLevel),sandbox:!0},alwaysOnTop:o.alwaysOnTop,experimentalDarkMode:!0});return a.setMenuBarVisibility(!1),a}m(h,t,o){let s;const a=n.screen.getAllDisplays();if(a.length===1)s=a[0];else{if(p.$k){const y=n.screen.getCursorScreenPoint();s=n.screen.getDisplayNearestPoint(y)}!s&&h&&(s=n.screen.getDisplayMatching(h.getBounds())),s||(s=n.screen.getPrimaryDisplay()||a[0])}const l=s.bounds,S={width:t,height:o,x:l.x+l.width/2-t/2,y:l.y+l.height/2-o/2};return l.width>0&&l.height>0&&(S.x<l.x&&(S.x=l.x),S.y<l.y&&(S.y=l.y),S.x>l.x+l.width&&(S.x=l.x),S.y>l.y+l.height&&(S.y=l.y),S.width>l.width&&(S.width=l.width),S.height>l.height&&(S.height=l.height)),S}};e.$Mgc=E,e.$Mgc=E=P=Se([se(1,d.$Kfc),se(2,w.$ak),se(3,u.$Sfc),se(4,f.$Kgc),se(5,v.$Ufc),se(6,$.$Xfc)],E)});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[270],le([0,1,13,32,2,12,3,115,35,10,96,136,53,20,5,64,72,28,73,34,63,51]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b,$,P,E,i){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=void 0,v=Ve(v);const t="issue.processExplorerWindowState";let o=class{static{h=this}static{this.a="#1E1E1E"}constructor(l,S,y,A,L,D,O,M,Z,q){this.d=l,this.f=S,this.g=y,this.h=A,this.i=L,this.j=D,this.k=O,this.l=M,this.m=Z,this.n=q,this.b=null,this.c=null,this.o()}o(){p.$WX.on("vscode:listProcesses",async l=>{const S=[];try{S.push({name:(0,c.localize)(11362,null),rootProcess:await(0,I.$Xs)(process.pid)}),(await this.i.getRemoteDiagnostics({includeProcesses:!0})).forEach(A=>{(0,m.$Um)(A)?S.push({name:A.hostName,rootProcess:A}):A.processes&&S.push({name:A.hostName,rootProcess:A.processes})})}catch(y){this.g.error(`Listing processes failed: ${y}`)}this.s(l,"vscode:listProcessesResponse",S)}),p.$WX.on("vscode:workbenchCommand",(l,S)=>{const{id:y,from:A,args:L}=S;let D;switch(A){case"processExplorer":D=this.c;break;default:throw new Error(`Unexpected command source: ${A}`)}D?.webContents.send("vscode:runAction",{id:y,from:A,args:L})}),p.$WX.on("vscode:closeProcessExplorer",l=>{this.b?.close()}),p.$WX.on("vscode:pidToNameRequest",async l=>{const S=await this.i.getMainDiagnostics(),y=[];for(const A of S.windows)y.push([A.pid,`window [${A.id}] (${A.title})`]);for(const{pid:A,name:L}of E.$sgc.getAll())y.push([A,L]);this.s(l,"vscode:pidToNameResponse",y)})}async openProcessExplorer(l){if(!this.b&&(this.c=n.BrowserWindow.getFocusedWindow(),this.c)){const S=new k.$Tc,y=S.add(this.l.createIPCObjectUrl()),A=this.n.getItem(t,void 0),L=s(A)?A:this.q(this.c,800,500);this.b=this.r(L,y,{backgroundColor:l.styles.backgroundColor,title:(0,c.localize)(11363,null),zoomLevel:l.zoomLevel,alwaysOnTop:!0},"process-explorer"),y.update({appRoot:this.f.appRoot,windowId:this.b.id,userEnv:this.d,data:l,product:v.default,nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE}}),this.b.loadURL(R.$Zg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.f.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,S.dispose()}),this.c.on("close",()=>{this.b&&(this.b.close(),this.b=null,S.dispose())});const D=()=>{if(!this.b)return;const O=this.b.getSize(),M=this.b.getPosition();if(!O||!M)return;const Z={width:O[0],height:O[1],x:M[0],y:M[1]};this.n.setItem(t,Z)};this.b.on("moved",D),this.b.on("resized",D)}this.b&&this.p(this.b)}p(l){l.isMinimized()&&l.restore(),l.focus()}q(l,S,y){let A;const L=n.screen.getAllDisplays();if(L.length===1)A=L[0];else{if(T.$k){const M=n.screen.getCursorScreenPoint();A=n.screen.getDisplayNearestPoint(M)}!A&&l&&(A=n.screen.getDisplayMatching(l.getBounds())),A||(A=n.screen.getPrimaryDisplay()||L[0])}const D=A.bounds,O={width:S,height:y,x:D.x+D.width/2-S/2,y:D.y+D.height/2-y/2};return D.width>0&&D.height>0&&(O.x<D.x&&(O.x=D.x),O.y<D.y&&(O.y=D.y),O.x>D.x+D.width&&(O.x=D.x),O.y>D.y+D.height&&(O.y=D.y),O.width>D.width&&(O.width=D.width),O.height>D.height&&(O.height=D.height)),O}async stopTracing(){if(!this.f.args.trace)return;const l=await n.contentTracing.stopRecording(`${(0,r.$Ng)(this.f.userHome.fsPath,this.m.applicationName)}.trace.txt`);await this.j.showMessageBox({type:"info",message:(0,c.localize)(11364,null),detail:(0,c.localize)(11365,null,l),buttons:[(0,c.localize)(11366,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.k.showItemInFolder(void 0,l)}async getSystemStatus(){const[l,S]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.h.getDiagnostics(l,S)}async $getSystemInfo(){const[l,S]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.h.getSystemInfo(l,S)}async $getPerformanceInfo(){try{const[l,S]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.h.getPerformanceInfo(l,S)}catch(l){throw this.g.warn("issueService#getPerformanceInfo ",l.message),l}}r(l,S,y,A){const L=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:l.width,height:l.height,minWidth:300,minHeight:200,x:l.x,y:l.y,title:y.title,backgroundColor:y.backgroundColor||h.a,webPreferences:{preload:R.$Zg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${S.resource.toString()}`],v8CacheOptions:this.f.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.$hE)(y.zoomLevel),sandbox:!0},alwaysOnTop:y.alwaysOnTop,experimentalDarkMode:!0});return L.setMenuBarVisibility(!1),L}s(l,S,...y){l.sender.isDestroyed()||l.sender.send(S,...y)}async closeProcessExplorer(){this.b?.close()}};e.$Ngc=o,e.$Ngc=o=h=Se([se(1,w.$Kfc),se(2,f.$ak),se(3,m.$Tm),se(4,u.$vgc),se(5,d.$Sfc),se(6,g.$Kgc),se(7,$.$Ufc),se(8,b.$tk),se(9,P.$CR)],o);function s(a){return typeof a!="object"||a===null?!1:"x"in a&&"y"in a&&"width"in a&&"height"in a}}),define(ce[271],le([0,1,22,16,20,19,5,64,28,49,24,50,105]),function(x,e,n,r,k,R,T,I,p,c,m,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;let w=class extends d.$ahc{constructor(g,v,b,$,P,E,i,h){super(g,v,$,P,E,h),this.e=b,this.u=i}s(g){return(0,d.$_gc)(`linux-${process.arch}`,g,this.k)}t(g){this.a&&(this.d(u.$UY.CheckingForUpdates(g)),this.i.request({url:this.a},n.CancellationToken.None).then(c.$bq).then(v=>{!v||!v.url||!v.version||!v.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!g}),this.d(u.$UY.Idle(u.UpdateType.Archive))):this.d(u.$UY.AvailableForDownload(v))}).then(void 0,v=>{this.j.error(v);const b=g?v.message||v:void 0;this.d(u.$UY.Idle(u.UpdateType.Archive,b))}))}async o(g){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):g.update.url&&this.u.openExternal(void 0,g.update.url),this.d(u.$UY.Idle(u.UpdateType.Archive))}};e.$chc=w,e.$chc=w=Se([se(0,R.$egc),se(1,r.$_i),se(2,m.$_l),se(3,k.$Kfc),se(4,c.$8p),se(5,T.$ak),se(6,I.$Kgc),se(7,p.$tk)],w)}),define(ce[272],le([0,1,48,26,27,8,22,54,46,9,7,152,23,16,20,14,19,5,64,28,49,24,50,105]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b,$,P,E,i,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0,r=Pe(r),c=Pe(c),d=Pe(d);async function o(S,y=1e3){for(;!S();)await(0,R.$Gh)(y)}let s;function a(){return typeof s>"u"&&(s=r.existsSync(c.$jc(c.$mc(process.execPath),"unins000.exe"))?h.UpdateType.Setup:h.UpdateType.Archive),s}let l=class extends t.$ahc{get cachePath(){const y=c.$jc((0,k.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return r.promises.mkdir(y,{recursive:!0}).then(()=>y)}constructor(y,A,L,D,O,M,Z,q,K){super(y,A,D,O,M,K),this.u=L,this.v=Z,this.w=q,y.setRelaunchHandler(this)}handleRelaunch(y){return y?.addArgs||y?.removeArgs||this.state.type!==h.StateType.Ready||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(h.$UY.Disabled(h.DisablementReason.RunningAsAdmin)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(y){let A=`win32-${process.arch}`;return a()===h.UpdateType.Archive?A+="-archive":this.k.target==="user"&&(A+="-user"),(0,t.$_gc)(A,y,this.k)}t(y){this.a&&(this.d(h.$UY.CheckingForUpdates(y)),this.i.request({url:this.a},T.CancellationToken.None).then(E.$bq).then(A=>{const L=a();return!A||!A.url||!A.version||!A.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!y}),this.d(h.$UY.Idle(L)),Promise.resolve(null)):L===h.UpdateType.Archive?(this.d(h.$UY.AvailableForDownload(A)),Promise.resolve(null)):(this.d(h.$UY.Downloading),this.C(A.version).then(()=>this.B(A.version).then(D=>d.Promises.exists(D).then(O=>{if(O)return Promise.resolve(D);const M=`${D}.tmp`;return this.i.request({url:A.url},T.CancellationToken.None).then(Z=>this.v.writeFile(m.URI.file(M),Z.stream)).then(A.sha256hash?()=>(0,u.$PX)(M,A.sha256hash):()=>{}).then(()=>d.Promises.rename(M,D,!1)).then(()=>D)})).then(D=>{this.e={packagePath:D},this.d(h.$UY.Downloaded(A)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(h.$UY.Ready(A))})))}).then(void 0,A=>{this.u.publicLog2("update:error",{messageHash:String((0,p.$tj)(String(A)))}),this.j.error(A);const L=y?A.message||A:void 0;this.d(h.$UY.Idle(a(),L))}))}async o(y){y.update.url&&this.w.openExternal(void 0,y.update.url),this.d(h.$UY.Idle(a()))}async B(y){const A=await this.cachePath;return c.$jc(A,`CodeSetup-${this.k.quality}-${y}.exe`)}async C(y=null){const A=y?M=>!new RegExp(`${this.k.quality}-${y}\\.exe$`).test(M):()=>!0,L=await this.cachePath,O=(await d.Promises.readdir(L)).filter(A).map(async M=>{try{await r.promises.unlink(c.$jc(L,M))}catch{}});await Promise.all(O)}async p(){if(this.state.type!==h.StateType.Downloaded||!this.e)return Promise.resolve(void 0);const y=this.state.update;this.d(h.$UY.Updating(y));const A=await this.cachePath;this.e.updateFilePath=c.$jc(A,`CodeSetup-${this.k.quality}-${y.version}.flag`),await d.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(h.$UY.Idle(a()))});const D=`${this.k.win32MutexName}-ready`,O=await new Promise((M,Z)=>{x(["@vscode/windows-mutex"],M,Z)}).then(Pe);o(()=>O.isActive(D)).then(()=>this.d(h.$UY.Ready(y)))}r(){this.state.type!==h.StateType.Ready||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?r.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return a()}async _applySpecificUpdate(y){if(this.state.type!==h.StateType.Idle)return;const A=this.g.getValue("update.enableWindowsBackgroundUpdates"),L={version:"unknown",productVersion:"unknown"};this.d(h.$UY.Downloading),this.e={packagePath:y},this.d(h.$UY.Downloaded(L)),A?this.k.target==="user"&&this.p():this.d(h.$UY.Ready(L))}};e.$ehc=l,Se([I.$0h],l.prototype,"cachePath",null),e.$ehc=l=Se([se(0,v.$egc),se(1,w.$_i),se(2,i.$_l),se(3,f.$Kfc),se(4,E.$8p),se(5,b.$ak),se(6,g.$al),se(7,$.$Kgc),se(8,P.$tk)],l)});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[137],le([0,1,13,8,22,55,4,2,12,70,3,7,10,27,69,16,53,20,68,14,19,5,28,73,248,87,24,110,76,51,29,30,59,52,40,34,58,71,21,6]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b,$,P,E,i,h,t,o,s,a,l,S,y,A,L,D,O,M,Z,q,K,de,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=e.$bgc=void 0,n=Ve(n);var Y;(function(W){W[W.NONE=0]="NONE",W[W.NAVIGATING=1]="NAVIGATING",W[W.READY=2]="READY"})(Y||(Y={}));class B extends I.$Uc{get lastFocusTime(){return this.j}get win(){return this.m}n(j){this.m=j,this.B(T.Event.fromNodeEventEmitter(j,"maximize")(()=>this.b.fire())),this.B(T.Event.fromNodeEventEmitter(j,"unmaximize")(()=>this.c.fire())),this.B(T.Event.fromNodeEventEmitter(j,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(T.Event.fromNodeEventEmitter(j,"focus")(()=>{this.j=Date.now()})),this.B(T.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(T.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const C=!(0,y.$cE)(this.r);if(m.$k&&C&&j.setSheetOffset((0,m.$K)((0,w.release)())?28:22),C&&(m.$j&&(0,y.$fE)(this.r)||m.$k)){const X=this.s.getItem(B.D);X?this.updateWindowControls({height:X}):this.updateWindowControls({height:y.$eE})}m.$j&&C&&j.hookWindowMessage(278,()=>{const[oe,V]=j.getPosition(),ue=n.default.screen.getCursorScreenPoint(),re=ue.x-oe,J=ue.y-V;return!(re>30&&J>=0&&J<=Math.max(j.getBounds().height*.15,35))||(j.setEnabled(!1),j.setEnabled(!0),this.f.fire({x:re,y:J})),0}),this.t.args["open-devtools"]===!0&&j.webContents.openDevTools(),m.$k&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(j,C,X,oe){super(),this.r=j,this.s=C,this.t=X,this.u=oe,this.a=this.B(new T.$le),this.onDidClose=this.a.event,this.b=this.B(new T.$le),this.onDidMaximize=this.b.event,this.c=this.B(new T.$le),this.onDidUnmaximize=this.c.event,this.f=this.B(new T.$le),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new T.$le),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new T.$le),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,y.$fE)(this.r),this.G=void 0,this.H=void 0}w(j,C=n.default.screen.getAllDisplays().length>0){const X=this.r.getValue("window"),oe=m.$k&&X?.nativeTabs===!0;(m.$k||m.$j)&&C&&(!oe||n.default.BrowserWindow.getAllWindows().length===1)&&[j.width,j.height,j.x,j.y].every(V=>typeof V=="number")&&this.m?.setBounds({width:j.width,height:j.height,x:j.x,y:j.y}),(j.mode===O.WindowMode.Maximized||j.mode===O.WindowMode.Fullscreen)&&(this.m?.maximize(),j.mode===O.WindowMode.Fullscreen&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(j){m.$k?this.win?.setRepresentedFilename(j):this.z=j}getRepresentedFilename(){return m.$k?this.win?.getRepresentedFilename():this.z}setDocumentEdited(j){m.$k&&this.win?.setDocumentEdited(j),this.C=j}isDocumentEdited(){return m.$k?!!this.win?.isDocumentEdited():!!this.C}focus(j){m.$k&&j?.force&&n.default.app.focus({steal:!0});const C=this.win;C&&(C.isMinimized()&&C.restore(),C.focus())}handleTitleDoubleClick(){const j=this.win;if(j)if(m.$k)switch(n.default.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":j.minimize();break;case"None":break;case"Maximize":default:j.isMaximized()?j.unmaximize():j.maximize()}else j.isMaximized()?j.unmaximize():j.maximize()}static{this.D="windowControlHeight"}updateWindowControls(j){const C=this.win;if(C){if(j.height&&this.s.setItem(Q.D,j.height),m.$j&&this.F)C.setTitleBarOverlay({color:j.backgroundColor?.trim()===""?void 0:j.backgroundColor,symbolColor:j.foregroundColor?.trim()===""?void 0:j.foregroundColor,height:j.height?j.height-1:void 0});else if(m.$k&&j.height!==void 0){const X=(j.height-15)/2;X?C.setWindowButtonPosition({x:X,y:X}):C.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(j,C){(0,y.$gE)(this.r)?this.J(j,C):this.M(j)}get isFullScreen(){if(m.$k&&typeof this.G=="boolean")return this.G;const j=this.win,C=j?.isFullScreen(),X=j?.isSimpleFullScreen();return!!(C||X)}J(j,C){const X=this.win;X?.isSimpleFullScreen()&&X?.setSimpleFullScreen(!1),this.L(j,C)}L(j,C){if(m.$k){this.G=j;const oe=this.H=new r.$3h;(async()=>{const V=await Promise.race([oe.p,(0,r.$Gh)(1e4).then(()=>!1)]);this.H===oe&&(this.G=void 0,this.H=void 0,!V&&j&&C&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(j)}M(j){const C=this.win;C?.isFullScreen()&&this.L(!1,!1),C?.setSimpleFullScreen(j),C?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$bgc=B;let Q=class extends B{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const j=this.hb.profiles.find(C=>C.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&j?j:this.hb.getProfileForWorkspace(this.config.workspace??(0,L.$Ti)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(j,C,X,oe,V,ue,re,J,F,N,_,z,ie,G,U,te,he,me,we,Ie,Ce){super(N,Ie,oe,C),this.fb=X,this.gb=V,this.hb=ue,this.ib=re,this.jb=J,this.kb=F,this.lb=_,this.mb=z,this.nb=ie,this.ob=G,this.pb=U,this.qb=te,this.rb=he,this.sb=me,this.tb=we,this.N=this.B(new T.$le),this.onWillLoad=this.N.event,this.O=this.B(new T.$le),this.onDidSignalReady=this.O.event,this.P=this.B(new T.$le),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=Y.NONE;{const[Ae,ve]=this.Eb(j.state);this.U=Ae,this.u.trace("window#ctor: using window state",Ae);const $e=Ce.invokeFunction(A.$Yfc,this.U,{preload:p.$Zg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,c.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.default.BrowserWindow($e),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m),this.w(this.U,ve),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=Y.READY;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(j=>{if(this.isReady)return j(this);this.X.push(j)})}get isReady(){return this.ub===Y.READY}get whenClosedOrLoaded(){return new Promise(j=>{function C(){X.dispose(),oe.dispose(),j()}const X=this.onDidClose(()=>C()),oe=this.onWillLoad(()=>C())})}vb(){this.B(T.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(O.WindowError.UNRESPONSIVE))),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(C,X)=>X)(C=>this.yb(O.WindowError.PROCESS_GONE,{...C}))),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(C,X,oe)=>({exitCode:X,reason:oe}))(({exitCode:C,reason:X})=>this.yb(O.WindowError.LOAD,{reason:X,exitCode:C}))),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(C=>C.preventDefault())),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(C=>this.Bb(C))),this.B(this.mb.onDidDeleteUntitledWorkspace(C=>this.Ab(C)));const j=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:j},async(C,X)=>{const oe=await this.xb();X({cancel:!1,requestHeaders:Object.assign(C.requestHeaders,oe)})})}xb(){return this.wb||(this.wb=(0,o.$pq)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(j,C){switch(j){case O.WindowError.PROCESS_GONE:this.u.error(`CodeWindow: renderer process gone (reason: ${C?.reason||"<unknown>"}, code: ${C?.exitCode||"<unknown>"})`);break;case O.WindowError.UNRESPONSIVE:this.u.error("CodeWindow: detected unresponsive");break;case O.WindowError.LOAD:this.u.error(`CodeWindow: failed to load (reason: ${C?.reason||"<unknown>"}, code: ${C?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:j,reason:C?.reason,code:C?.exitCode}),j){case O.WindowError.UNRESPONSIVE:case O.WindowError.PROCESS_GONE:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(j===O.WindowError.UNRESPONSIVE){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:X,checkboxChecked:oe}=await this.pb.showMessageBox({type:"warning",buttons:[(0,d.localize)(11042,null),(0,d.localize)(11043,null),(0,d.localize)(11044,null)],message:(0,d.localize)(11045,null),detail:(0,d.localize)(11046,null),checkboxLabel:this.S?.workspace?(0,d.localize)(11047,null):void 0},this.m);if(X!==2){const V=X===0;await this.zb(V,oe)}}else if(j===O.WindowError.PROCESS_GONE){let X;C?X=(0,d.localize)(11049,null,C.reason,C.exitCode??"<unknown>"):X=(0,d.localize)(11048,null);const{response:oe,checkboxChecked:V}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,d.localize)(11050,null):(0,d.localize)(11051,null),(0,d.localize)(11052,null)],message:X,detail:this.S?.workspace?(0,d.localize)(11053,null):(0,d.localize)(11054,null),checkboxLabel:this.S?.workspace?(0,d.localize)(11055,null):void 0},this.m),ue=oe===0;await this.zb(ue,V)}break}}async zb(j,C){const X=this.S?.workspace;if(C&&X)try{const oe=this.kb.workspaceStorage(X);await oe.init(),oe.delete("memento/workbench.parts.editor"),await oe.close()}catch(oe){this.u.error(oe)}this.P.fire();try{if(j&&this.S){let oe,V;(0,L.$Pi)(X)?oe={folderUri:X.uri}:(0,L.$Ui)(X)?oe={workspaceUri:X.configPath}:V=!0,(0,de.$Nb)(await this.tb.open({context:A.OpenContext.API,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:oe?[oe]:void 0,forceEmpty:V,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(j){this.S?.workspace?.id===j.id&&(this.S.workspace=void 0)}Bb(j){if(!j||j.affectsConfiguration("window.menuBarVisibility")){const C=this.Gb();C!==this.W&&(this.W=C,this.Hb(C))}if(!j||j.affectsConfiguration("http.proxy")||j.affectsConfiguration("http.noProxy")){let C=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;if(C?.indexOf("@")!==-1){const oe=u.URI.parse(C),V=oe.authority.indexOf("@");V!==-1&&(C=oe.with({authority:oe.authority.substring(V+1)}).toString())}C?.endsWith("/")&&(C=C.substr(0,C.length-1));const X=(this.r.getValue("http.noProxy")||[]).map(oe=>oe.trim()).join(",")||(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((C||"").indexOf("@")===-1&&(C!==this.Z||X!==this.$)){this.Z=C,this.$=X;const oe=C||"",V=X?`${X},<local>`:"<local>";this.u.trace(`Setting proxy to '${oe}', bypassing '${V}'`),this.m.webContents.session.setProxy({proxyRules:oe,proxyBypassRules:V,pacScript:""}),n.default.app.setProxy({proxyRules:oe,proxyBypassRules:V,pacScript:""})}}}addTabbedWindow(j){m.$k&&j.win&&this.m.addTabbedWindow(j.win)}load(j,C=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!C.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),C.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(j,C),this.ub===Y.NONE?this.S=j:this.db=j,this.ub=Y.NAVIGATING,this.m.loadURL(p.$Zg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const X=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new r.$Rh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:j.workspace,reason:C.isReload?O.LoadReason.RELOAD:X?O.LoadReason.LOAD:O.LoadReason.INITIAL})}Cb(j,C){const X=(this.S??this.db)?.userEnv;if(X){const oe=(0,$.$Km)(X)&&!(0,$.$Km)(j.userEnv),V=this.isExtensionDevelopmentHost;(oe||V)&&(j.userEnv={...X,...j.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(j.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),C.disableExtensions!==void 0&&(j["disable-extensions"]=C.disableExtensions),j.fullscreen=this.isFullScreen,j.maximized=this.m.isMaximized(),j.partsSplash=this.lb.getWindowSplash(),j.zoomLevel=this.Jb(),j.isCustomZoomLevel=typeof this.ab=="number",j.isCustomZoomLevel&&j.partsSplash&&(j.partsSplash.zoomLevel=j.zoomLevel),(0,c.mark)("code/willOpenNewWindow"),j.perfMarks=(0,c.getMarks)(),this.bb.update(j)}async reload(j){const C=Object.assign({},this.S);C.workspace=await this.Db(C),delete C.filesToOpenOrCreate,delete C.filesToDiff,delete C.filesToMerge,delete C.filesToWait,this.isExtensionDevelopmentHost&&j&&(C.verbose=j.verbose,C.debugId=j.debugId,C.extensionEnvironment=j.extensionEnvironment,C["inspect-extensions"]=j["inspect-extensions"],C["inspect-brk-extensions"]=j["inspect-brk-extensions"],C["extensions-dir"]=j["extensions-dir"]),C.accessibilitySupport=n.default.app.isAccessibilitySupportEnabled(),C.isInitialStartup=!1,C.policiesData=this.gb.serialize(),C.continueOn=this.t.continueOn,C.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},C.logLevel=this.fb.getLogLevel(),C.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(C,{isReload:!0,disableExtensions:j?.["disable-extensions"]})}async Db(j){if((0,L.$Ui)(j.workspace)){const C=j.workspace.configPath;if(C.scheme===p.Schemas.file&&!await this.ib.exists(C))return}else if((0,L.$Pi)(j.workspace)){const C=j.workspace.uri;if(C.scheme===p.Schemas.file&&!await this.ib.exists(C))return}return j.workspace}serializeWindowState(){if(!this.m)return(0,O.$Mfc)();if(this.isFullScreen){let X;try{X=n.default.screen.getDisplayMatching(this.getBounds())}catch{}const oe=(0,O.$Mfc)();return{mode:O.WindowMode.Fullscreen,display:X?X.id:void 0,width:this.U.width||oe.width,height:this.U.height||oe.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const j=Object.create(null);let C;if(!m.$k&&this.m.isMaximized()?C=O.WindowMode.Maximized:C=O.WindowMode.Normal,C===O.WindowMode.Maximized?j.mode=O.WindowMode.Maximized:j.mode=O.WindowMode.Normal,C===O.WindowMode.Normal||C===O.WindowMode.Maximized){let X;C===O.WindowMode.Normal?X=this.getBounds():X=this.m.getNormalBounds(),j.x=X.x,j.y=X.y,j.width=X.width,j.height=X.height}return j.zoomLevel=this.ab,j}Eb(j){(0,c.mark)("code/willRestoreCodeWindowState");let C=!1;if(j){this.ab=j.zoomLevel;try{const X=n.default.screen.getAllDisplays();C=X.length>1,j=A.WindowStateValidator.validateWindowState(this.u,j,X)}catch(X){this.u.warn(`Unexpected error validating window state: ${X}
${X.stack}`)}}return(0,c.mark)("code/didRestoreCodeWindowState"),[j||(0,O.$Mfc)(),C]}getBounds(){const[j,C]=this.m.getPosition(),[X,oe]=this.m.getSize();return{x:j,y:C,width:X,height:oe}}I(j,C){super.I(j,C),this.sendWhenReady(j?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let j=(0,y.$aE)(this.r);return["visible","toggle","hidden"].indexOf(j)<0&&(j="classic"),j}Hb(j,C=!0){m.$k||(j==="toggle"&&C&&this.send("vscode:showInfoMessage",(0,d.localize)(11056,null)),j==="hidden"?setTimeout(()=>{this.Ib(j)}):this.Ib(j))}Ib(j){const C=this.isFullScreen;switch(j){case"classic":this.m.setMenuBarVisibility(!C),this.m.autoHideMenuBar=C;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(j){this.ab=j}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(j,C,...X){this.isReady?this.send(j,...X):this.ready().then(()=>{C.isCancellationRequested||this.send(j,...X)})}send(j,...C){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${j}' for window that is destroyed`);return}try{this.m.webContents.send(j,...C)}catch(X){this.u.warn(`Error sending IPC message to channel '${j}' of window ${this.Q}: ${(0,R.$qj)(X)}`)}}}updateTouchBar(j){m.$k&&this.Y.forEach((C,X)=>{const oe=j[X];C.segments=this.Mb(oe)})}Kb(){if(m.$k){for(let j=0;j<10;j++){const C=this.Lb();this.Y.push(C)}this.m.setTouchBar(new n.default.TouchBar({items:this.Y}))}}Lb(j=[]){const C=this.Mb(j),X=new n.default.TouchBar.TouchBarSegmentedControl({segments:C,mode:"buttons",segmentStyle:"automatic",change:oe=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:X.segments[oe].id,from:"touchbar"})}});return X}Mb(j=[]){return j.map(X=>{let oe;X.icon&&!l.ThemeIcon.isThemeIcon(X.icon)&&X.icon?.dark?.scheme===p.Schemas.file&&(oe=n.default.nativeImage.createFromPath(u.URI.revive(X.icon.dark).fsPath),oe.isEmpty()&&(oe=void 0));let V;return typeof X.title=="string"?V=X.title:V=X.title.value,{id:X.id,label:oe?void 0:V,icon:oe}})}matches(j){return this.m?.webContents.id===j.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$cgc=Q,e.$cgc=Q=Se([se(1,i.$ak),se(2,K.$_fc),se(3,b.$Kfc),se(4,M.$to),se(5,q.$1fc),se(6,P.$al),se(7,s.$mgc),se(8,s.$kgc),se(9,g.$_i),se(10,S.$Vfc),se(11,D.$0fc),se(12,f.$Rfc),se(13,a.$_l),se(14,v.$Sfc),se(15,E.$egc),se(16,h.$tk),se(17,t.$Ufc),se(18,A.$Xfc),se(19,Z.$CR),se(20,H.$Ei)],Q)}),define(ce[273],le([0,1,13,3,16,20,19,5,34,51,52,137]),function(x,e,n,r,k,R,T,I,p,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0;let d=class extends u.$bgc{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(f,g,v,b,$,P){super(b,$,g,v),this.O=f,this.P=P,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow(f){this.q.isDisposed||this.O.isDestroyed()||(this.Q(),f&&!this.N&&(this.N=!0,this.w({x:f.x,y:f.y,width:f.width,height:f.height,mode:f.show===!1?m.WindowMode.Maximized:m.WindowMode.Normal})))}Q(){if(this.m)return;const f=n.BrowserWindow.fromWebContents(this.O);f&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(f),f.setMenu(null),(r.$j||r.$l)&&(0,c.$cE)(this.r)&&f.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches(f){return this.O.id===f.id}};e.$dgc=d,e.$dgc=d=Se([se(1,R.$Kfc),se(2,I.$ak),se(3,k.$_i),se(4,p.$CR),se(5,T.$egc)],d)}),define(ce[274],le([0,1,13,4,2,12,35,273,6,5,52,29]),function(x,e,n,r,k,R,T,I,p,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;let d=class extends k.$Uc{constructor(f,g){super(),this.h=f,this.j=g,this.a=this.B(new r.$le),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new r.$le),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new r.$le),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new r.$le),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(f,g)=>{const v=this.getWindowByWebContents(g.webContents);if(v)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),v.tryClaimWindow();else{const b=new k.$Tc;b.add(r.Event.fromNodeEventEmitter(g.webContents,"did-create-window",($,P)=>({browserWindow:$,details:P}))(({browserWindow:$,details:P})=>{const E=this.getWindowByWebContents($.webContents);E&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),E.tryClaimWindow(P.options))})),b.add(r.Event.fromNodeEventEmitter(g,"closed")(()=>b.dispose()))}}),T.$WX.handle("vscode:registerAuxiliaryWindow",async(f,g)=>{const v=this.getWindowByWebContents(f.sender);return v&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),v.parentId=g),f.sender.id})}createWindow(f){return this.h.invokeFunction(u.$Yfc,this.n(f),{preload:R.$Zg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(f){const g={},v=f.features.split(",");for(const $ of v){const[P,E]=$.split("=");switch(P){case"width":g.width=parseInt(E,10);break;case"height":g.height=parseInt(E,10);break;case"left":g.x=parseInt(E,10);break;case"top":g.y=parseInt(E,10);break;case"window-maximized":g.mode=m.WindowMode.Maximized;break;case"window-fullscreen":g.mode=m.WindowMode.Fullscreen;break;case"titlebar":g.mode=m.WindowMode.Custom;break}}const b=u.WindowStateValidator.validateWindowState(this.j,g)??(0,m.$Nfc)();return this.j.trace("[aux window] using window state",b),b}registerWindow(f){const g=new k.$Tc,v=this.h.createInstance(I.$dgc,f);this.g.set(v.id,v),g.add((0,k.$Sc)(()=>this.g.delete(v.id))),g.add(v.onDidMaximize(()=>this.a.fire(v))),g.add(v.onDidUnmaximize(()=>this.b.fire(v))),g.add(v.onDidEnterFullScreen(()=>this.c.fire({window:v,fullscreen:!0}))),g.add(v.onDidLeaveFullScreen(()=>this.c.fire({window:v,fullscreen:!1}))),g.add(v.onDidTriggerSystemContextMenu(({x:b,y:$})=>this.f.fire({window:v,x:b,y:$}))),r.Event.once(v.onDidClose)(()=>g.dispose())}getWindowByWebContents(f){const g=this.g.get(f.id);return g?.matches(f)?g:void 0}getFocusedWindow(){const f=n.BrowserWindow.getFocusedWindow();if(f)return this.getWindowByWebContents(f.webContents)}getLastActiveWindow(){return(0,u.$Zfc)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$Lhc=d,e.$Lhc=d=Se([se(0,p.$Ei),se(1,c.$ak)],d)}),define(ce[88],le([0,1,13,21,8,4,47,2,12,3,18,7,23,10,6,19,5,62,87,102,30,59,31,53]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b,$,P,E,i,h,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=e.$Xgc=void 0,e.$Xgc=(0,f.$Fi)("workspacesHistoryMainService");let s=class extends I.$Uc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(l,S,y,A,L){super(),this.f=l,this.g=S,this.h=y,this.j=A,this.m=L,this.c=this.B(new R.$le),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new k.$Dh(800)),this.n()}n(){this.h.when(g.LifecycleMainPhase.Eventually).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(l=>this.addRecentlyOpened([{workspace:l.workspace,remoteAuthority:l.window.remoteAuthority}])))}async addRecentlyOpened(l){let S=[],y=[];for(const L of l)if((0,P.$fib)(L))!this.g.isUntitledWorkspace(L.workspace)&&!this.w(S,L.workspace)&&S.push(L);else if((0,P.$gib)(L))this.y(S,L.folderUri)||S.push(L);else{const D=this.z(y,L.fileUri),O=L.fileUri.scheme===p.Schemas.file&&o.G.indexOf((0,m.$dh)(L.fileUri))>=0;!D&&!O&&(y.push(L),c.$j&&L.fileUri.scheme===p.Schemas.file&&n.app.addRecentDocument(L.fileUri.fsPath))}const A=await this.r({workspaces:S,files:y});S=A.workspaces,y=A.files,S.length>o.a&&(S.length=o.a),y.length>o.a&&(y.length=o.a),await this.t({workspaces:S,files:y}),this.c.fire(),c.$k&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(l){const S=D=>{const O=this.u(D);for(const M of l)if(m.$0g.isEqual(M,O))return!1;return!0},y=await this.getRecentlyOpened(),A=y.workspaces.filter(S),L=y.files.filter(S);(A.length!==y.workspaces.length||L.length!==y.files.length)&&(await this.t({files:L,workspaces:A}),this.c.fire(),c.$k&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(l){if(l?.confirm){const{response:S}=await this.m.showMessageBox({type:"warning",buttons:[(0,w.localize)(11020,null),(0,w.localize)(11021,null)],message:(0,w.localize)(11022,null),detail:(0,w.localize)(11023,null),cancelId:1});if(S!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(l){const S=new h.$Ac(L=>m.$0g.getComparisonKey(L));if(l?.workspaces)for(const L of l.workspaces)S.set(this.u(L),L);const y=new h.$Ac(L=>m.$0g.getComparisonKey(L));if(l?.files)for(const L of l.files)y.set(this.u(L),L);const A=await this.s();for(const L of A.workspaces){const D=S.get(this.u(L));D?D.label=D.label??L.label:S.set(this.u(L),L)}for(const L of A.files){const D=y.get(this.u(L));D?D.label=D.label??L.label:y.set(this.u(L),L)}return{workspaces:[...S.values()],files:[...y.values()]}}async s(){await this.j.whenReady;let l;const S=this.j.get(o.b,b.StorageScope.APPLICATION);if(typeof S=="string")try{l=JSON.parse(S)}catch(y){this.f.error("Unexpected error parsing opened paths list",y)}return(0,P.$mib)(l,this.f)}async t(l){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,P.$nib)(l)),b.StorageScope.APPLICATION,b.StorageTarget.MACHINE)}u(l){return(0,P.$gib)(l)?l.folderUri:(0,P.$hib)(l)?l.fileUri:l.workspace.configPath}w(l,S){return!!l.find(y=>(0,P.$fib)(y)&&y.workspace.id===S.id)}y(l,S){return!!l.find(y=>(0,P.$gib)(y)&&m.$0g.isEqual(y.folderUri,S))}z(l,S){return!!l.find(y=>m.$0g.isEqual(y.fileUri,S))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async I(){c.$j&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!c.$j)return;const l=[];if(l.push({type:"tasks",items:[{type:"task",title:(0,w.localize)(11024,null),description:(0,w.localize)(11025,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const S=[];for(const L of n.app.getJumpListSettings().removedItems){const D=L.args;if(D){const O=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(D);O&&S.push(u.URI.parse(O[2]))}}await this.removeRecentlyOpened(S);let y=!1;const A=(0,r.$Gb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(L=>{const D=(0,P.$fib)(L)?L.workspace:L.folderUri,{title:O,description:M}=this.L(D,L.label);let Z;return u.URI.isUri(D)?Z=`--folder-uri "${D.toString()}"`:(y=!0,Z=`--file-uri "${D.configPath.toString()}"`),{type:"task",title:O.substr(0,255),description:M.substr(0,255),program:process.execPath,args:Z,iconPath:"explorer.exe",iconIndex:0}}));A.length>0&&l.push({type:"custom",name:y?(0,w.localize)(11026,null):(0,w.localize)(11027,null),items:A})}l.push({type:"recent"});try{const S=n.app.setJumpList(l);S&&S!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${S}`)}catch(S){this.f.warn("updateWindowsJumpList#setJumpList",S)}}L(l,S){if(S)return{title:(0,T.$9w)(S).name,description:S};if(u.URI.isUri(l))return{title:(0,m.$dh)(l),description:this.M(l)};if(this.g.isUntitledWorkspace(l))return{title:(0,w.localize)(11028,null),description:""};let y=(0,m.$dh)(l.configPath);return y.endsWith(E.$2i)&&(y=y.substr(0,y.length-E.$2i.length-1)),{title:(0,w.localize)(11029,null,y),description:this.M(l.configPath)}}M(l){return l.scheme==="file"?(0,T.$1w)(l.fsPath):l.toString()}async N(){if(!c.$k)return;n.app.clearRecentDocuments();const l=await this.getRecentlyOpened(),S=[];let y=0;for(let L=0;L<l.workspaces.length&&y<o.C;L++){const D=this.u(l.workspaces[L]);if(D.scheme===p.Schemas.file){const O=(0,m.$7g)(D);await d.Promises.exists(O)&&(S.push(O),y++)}}const A=[];for(let L=0;L<l.files.length&&y<o.D;L++){const D=this.u(l.files[L]);if(D.scheme===p.Schemas.file){const O=(0,m.$7g)(D);if(o.G.includes((0,m.$dh)(D))||S.includes(O))continue;await d.Promises.exists(O)&&(A.push(O),y++)}}A.reverse().forEach(L=>n.app.addRecentDocument(L)),S.reverse().forEach(L=>n.app.addRecentDocument(L))}};e.$Ygc=s,e.$Ygc=s=o=Se([se(0,v.$ak),se(1,i.$0fc),se(2,g.$egc),se(3,$.$mgc),se(4,t.$Sfc)],s)}),define(ce[275],le([0,1,13,8,22,47,3,7,10,84,16,20,19,5,198,64,28,34,24,50,51,29,88,2]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b,$,P,E,i,h,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=void 0,p=Pe(p);const s="menu";let a=class extends t.$Uc{static{o=this}static{this.a="lastKnownMenubarData"}constructor(y,A,L,D,O,M,Z,q,K,de,H,Y){super(),this.t=y,this.u=A,this.w=L,this.y=D,this.z=O,this.C=M,this.D=Z,this.F=q,this.G=K,this.H=de,this.I=H,this.J=Y,this.s=Object.create(null),this.h=new r.$Rh(()=>this.R(),0),this.j=new r.$Rh(()=>{this.m=[]},1e4),this.n=Object.create(null),this.r=Object.create(null),(T.$k||(0,E.$cE)(A))&&this.L(),this.M(),this.f=!1,this.g=!1,this.m=[],this.W(),this.N()}L(){const y=this.D.getItem(o.a);y&&(y.menus&&(this.n=y.menus),y.keybindings&&(this.r=y.keybindings))}M(){this.s["workbench.action.files.newUntitledFile"]=(M,Z,q)=>{this.lb({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.w.openEmptyWindow({context:i.OpenContext.MENU,contextWindowId:Z?.id})},this.s["workbench.action.newWindow"]=(M,Z,q)=>this.w.openEmptyWindow({context:i.OpenContext.MENU,contextWindowId:Z?.id}),this.s["workbench.action.files.openFileFolder"]=(M,Z,q)=>this.H.pickFileFolderAndOpen(void 0,{forceNewWindow:this.eb(q),telemetryExtraData:{from:s}}),this.s["workbench.action.files.openFolder"]=(M,Z,q)=>this.H.pickFolderAndOpen(void 0,{forceNewWindow:this.eb(q),telemetryExtraData:{from:s}}),this.s["workbench.action.openWorkspace"]=(M,Z,q)=>this.H.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.eb(q),telemetryExtraData:{from:s}}),this.s["workbench.action.clearRecentFiles"]=()=>this.C.clearRecentlyOpened({confirm:!0});const y=this.I.youTubeUrl;y&&(this.s["workbench.action.openYouTubeUrl"]=()=>this.ob(y,"openYouTubeUrl"));const A=this.I.requestFeatureUrl;A&&(this.s["workbench.action.openRequestFeatureUrl"]=()=>this.ob(A,"openUserVoiceUrl"));const L=this.I.reportIssueUrl;L&&(this.s["workbench.action.openIssueReporter"]=()=>this.ob(L,"openReportIssues"));const D=this.I.licenseUrl;D&&(this.s["workbench.action.openLicenseUrl"]=()=>{if(T.$x){const M=D.indexOf("?")>0?"&":"?";this.ob(`${D}${M}lang=${T.$x}`,"openLicenseUrl")}else this.ob(D,"openLicenseUrl")});const O=this.I.privacyStatementUrl;O&&D&&(this.s["workbench.action.openPrivacyStatementUrl"]=()=>{this.ob(O,"openPrivacyStatement")})}N(){this.B(this.F.onWillShutdown(()=>this.b=!0)),this.B(this.w.onDidChangeWindowsCount(y=>this.S(y))),this.B(this.H.onDidBlurMainWindow(()=>this.U())),this.B(this.H.onDidFocusMainWindow(()=>this.U()))}get O(){const y=this.u.getValue("window.enableMenuBarMnemonics");return typeof y!="boolean"?!0:y}get P(){if(!T.$k)return!1;const y=this.u.getValue("window.nativeTabs");return typeof y!="boolean"?!1:y}updateMenu(y,A){this.n=y.menus,this.r=y.keybindings,this.D.setItem(o.a,y),this.Q()}Q(){this.h.schedule()}R(){this.b||setTimeout(()=>{this.b||this.W()},10)}S(y){T.$k&&(y.oldCount===0&&y.newCount>0||y.oldCount>0&&y.newCount===0)&&(this.f=y.newCount===0,this.Q())}U(){if(!T.$k)return;const y=n.BrowserWindow.getFocusedWindow();this.g=!y||!!this.J.getWindowByWebContents(y.webContents),this.Q()}W(){const y=n.Menu.getApplicationMenu();if(y&&this.m.push(y),Object.keys(this.n).length===0){this.X(T.$k?new n.Menu:null);return}const A=new n.Menu;let L;if(T.$k){const O=new n.Menu;L=new n.MenuItem({label:this.I.nameShort,submenu:O}),this.Y(O),A.append(L)}if(T.$k&&!this.c){this.c=!0;const O=new n.Menu;O.append(new n.MenuItem({label:this.qb(p.localize(11279,null)),click:()=>this.w.openEmptyWindow({context:i.OpenContext.DOCK})})),n.app.dock.setMenu(O)}if(this.$("File")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11280,null)),submenu:O});this.bb(O,"File"),A.append(M)}if(this.$("Edit")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11281,null)),submenu:O});this.bb(O,"Edit"),A.append(M)}if(this.$("Selection")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11282,null)),submenu:O});this.bb(O,"Selection"),A.append(M)}if(this.$("View")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11283,null)),submenu:O});this.bb(O,"View"),A.append(M)}if(this.$("Go")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11284,null)),submenu:O});this.bb(O,"Go"),A.append(M)}if(this.$("Run")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11285,null)),submenu:O});this.bb(O,"Run"),A.append(M)}if(this.$("Terminal")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11286,null)),submenu:O});this.bb(O,"Terminal"),A.append(M)}let D;if(this.$("Window")){const O=new n.Menu;D=new n.MenuItem({label:this.qb(p.localize(11287,null)),submenu:O,role:"window"}),this.hb(O)}if(D&&A.append(D),this.$("Help")){const O=new n.Menu,M=new n.MenuItem({label:this.qb(p.localize(11288,null)),submenu:O,role:"help"});this.bb(O,"Help"),A.append(M)}A.items&&A.items.length>0?this.X(A):this.X(null),this.j.schedule()}X(y){if(n.Menu.setApplicationMenu(y),y)for(const A of this.J.getWindows())A.win?.setMenu(null)}Y(y){const A=this.jb(p.localize(11289,null,this.I.nameLong),"workbench.action.showAboutDialog"),L=this.ib();let D;if(this.$("Preferences")){const Y=new n.Menu;this.bb(Y,"Preferences"),D=new n.MenuItem({label:this.qb(p.localize(11290,null)),submenu:Y})}const O=new n.Menu,M=new n.MenuItem({label:p.localize(11291,null),role:"services",submenu:O}),Z=new n.MenuItem({label:p.localize(11292,null,this.I.nameLong),role:"hide",accelerator:"Command+H"}),q=new n.MenuItem({label:p.localize(11293,null),role:"hideOthers",accelerator:"Command+Alt+H"}),K=new n.MenuItem({label:p.localize(11294,null),role:"unhide"}),de=new n.MenuItem(this.nb("workbench.action.quit",{label:p.localize(11295,null,this.I.nameLong),click:async(Y,B,Q)=>{const W=this.w.getLastActiveWindow();(this.w.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||W?.win?.isMinimized())&&await this.Z(Q)&&this.H.quit(void 0)}})),H=[A];H.push(...L),D&&H.push(l(),D),H.push(l(),M,l(),Z,q,K,l(),de),H.forEach(Y=>y.append(Y))}async Z(y){if(this.w.getWindowCount()===0)return!0;const A=this.u.getValue("window.confirmBeforeClose");if(A==="always"||A==="keyboardOnly"&&this.fb(y)){const{response:L}=await this.H.showMessageBox(this.w.getFocusedWindow()?.id,{type:"question",buttons:[p.localize(11296,null),p.localize(11297,null)],message:p.localize(11298,null)});return L===0}return!0}$(y){if(!T.$k&&!(0,E.$cE)(this.u))return!1;switch(y){case"File":case"Help":if(T.$k)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n&&!!this.n[y];case"Window":if(T.$k)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n;default:return this.w.getWindowCount()>0&&!!this.n&&!!this.n[y]}}ab(y,A){A.forEach(L=>{if((0,f.$Ugc)(L))y.append(l());else if((0,f.$Tgc)(L)){const D=new n.Menu,O=new n.MenuItem({label:this.qb(L.label),submenu:D});this.ab(D,L.submenu.items),y.append(O)}else(0,f.$Vgc)(L)?y.append(this.db(L)):(0,f.$Wgc)(L)&&(L.id==="workbench.action.showAboutDialog"&&this.cb(y),T.$k?this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g?this.s[L.id]?y.append(new n.MenuItem(this.nb(L.id,{label:this.qb(L.label),click:this.s[L.id]}))):y.append(this.jb(L.label,L.id,!1,L.checked)):y.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)):y.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)))})}bb(y,A){this.n&&this.n[A]&&this.ab(y,this.n[A].items)}cb(y){const A=this.ib();A.length&&(A.forEach(L=>y.append(L)),y.append(l()))}db(y){const A=I.URI.revive(y.uri),L=y.id,D=L==="openRecentFile"?{fileUri:A}:L==="openRecentWorkspace"?{workspaceUri:A}:{folderUri:A};return new n.MenuItem(this.nb(L,{label:y.label,click:async(O,M,Z)=>{const q=this.eb(Z);(await this.w.open({context:i.OpenContext.MENU,cli:this.y.args,urisToOpen:[D],forceNewWindow:q,gotoLineMode:!1,remoteAuthority:y.remoteAuthority})).length>0||await this.C.removeRecentlyOpened([A])}},!1))}eb(y){return!!(y&&(!T.$k&&(y.ctrlKey||y.shiftKey)||T.$k&&(y.metaKey||y.altKey)))}fb(y){return!!(y.triggeredByAccelerator||y.altKey||y.ctrlKey||y.metaKey||y.shiftKey)}gb(y,A,L){const D={label:this.qb(y),role:L,enabled:!0};return new n.MenuItem(this.mb(A,D))}hb(y){const A=new n.MenuItem({label:p.localize(11299,null),role:"minimize",accelerator:"Command+M",enabled:this.w.getWindowCount()>0}),L=new n.MenuItem({label:p.localize(11300,null),role:"zoom",enabled:this.w.getWindowCount()>0}),D=new n.MenuItem({label:p.localize(11301,null),role:"front",enabled:this.w.getWindowCount()>0}),O=this.jb(p.localize(11302,null),"workbench.action.switchWindow"),M=[];this.P&&(M.push(l()),M.push(this.jb(p.localize(11303,null),"workbench.action.newWindowTab")),M.push(this.gb(p.localize(11304,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.gb(p.localize(11305,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.gb(p.localize(11306,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.gb(p.localize(11307,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[A,L,l(),O,...M,l(),D].forEach(Z=>y.append(Z))}ib(){switch(this.t.state.type){case P.StateType.Idle:return[new n.MenuItem({label:this.qb(p.localize(11308,null)),click:()=>setTimeout(()=>{this.pb("CheckForUpdate"),this.t.checkForUpdates(!0)},0)})];case P.StateType.CheckingForUpdates:return[new n.MenuItem({label:p.localize(11309,null),enabled:!1})];case P.StateType.AvailableForDownload:return[new n.MenuItem({label:this.qb(p.localize(11310,null)),click:()=>{this.t.downloadUpdate()}})];case P.StateType.Downloading:return[new n.MenuItem({label:p.localize(11311,null),enabled:!1})];case P.StateType.Downloaded:return T.$k?[]:[new n.MenuItem({label:this.qb(p.localize(11312,null)),click:()=>{this.pb("InstallUpdate"),this.t.applyUpdate()}})];case P.StateType.Updating:return[new n.MenuItem({label:p.localize(11313,null),enabled:!1})];case P.StateType.Ready:return[new n.MenuItem({label:this.qb(p.localize(11314,null)),click:()=>{this.pb("RestartToUpdate"),this.t.quitAndInstall()}})];default:return[]}}jb(y,A,L,D){const O=this.qb(y),M=typeof A=="function"?A:(H,Y,B)=>{const Q=H?H.userSettingsLabel:null;let W=A;Array.isArray(A)&&(W=this.eb(B)?A[1]:A[0]),Q&&B.triggeredByAccelerator?this.lb({type:"keybinding",userSettingsLabel:Q}):this.lb({type:"commandId",commandId:W})},Z=typeof L=="boolean"?L:this.w.getWindowCount()>0,q=typeof D=="boolean"?D:!1,K={label:O,click:M,enabled:Z};q&&(K.type="checkbox",K.checked=q);let de;return typeof A=="string"?de=A:Array.isArray(A)&&(de=A[0]),T.$k&&(de==="editor.action.clipboardCutAction"?K.role="cut":de==="editor.action.clipboardCopyAction"?K.role="copy":de==="editor.action.clipboardPasteAction"&&(K.role="paste"),de==="undo"?K.click=this.kb(M,{inDevTools:H=>H.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):de==="redo"?K.click=this.kb(M,{inDevTools:H=>H.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):de==="editor.action.selectAll"&&(K.click=this.kb(M,{inDevTools:H=>H.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.mb(de,K))}kb(y,A){return(L,D,O)=>{const M=n.BrowserWindow.getFocusedWindow();if(!M)return A.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return A.inDevTools(M.webContents.devToolsWebContents);y(L,D||M,O)}}lb(y){let A=n.BrowserWindow.getFocusedWindow();if(A){const D=this.J.getWindowByWebContents(A.webContents);D&&(A=this.w.getWindowById(D.parentId)?.win??null)}if(!A){const D=this.w.getLastActiveWindow();D?.win?.isMinimized()&&(A=D.win)}const L=A?this.w.getWindowById(A.id):void 0;if(L){if(this.G.trace("menubar#runActionInRenderer",y),T.$k&&!this.y.isBuilt&&!L.isReady&&(y.type==="commandId"&&y.commandId==="workbench.action.toggleDevTools"||y.type!=="commandId"&&y.userSettingsLabel==="alt+cmd+i"))return!1;if(y.type==="commandId"){const D={id:y.commandId,from:"menu"};L.sendWhenReady("vscode:runAction",k.CancellationToken.None,D)}else{const D={userSettingsLabel:y.userSettingsLabel};L.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,D)}return!0}else return this.G.trace("menubar#runActionInRenderer: no active window found",y),!1}mb(y,A){const L=typeof y=="string"?this.r[y]:void 0;if(L?.label){if(L.isNative!==!1)A.accelerator=L.label,A.userSettingsLabel=L.userSettingsLabel;else if(typeof A.label=="string"){const D=A.label.indexOf("[");D>=0?A.label=`${A.label.substr(0,D)} [${L.label}]`:A.label=`${A.label} [${L.label}]`}}else A.accelerator=void 0;return A}nb(y,A,L=!A.accelerator){L&&(A=this.mb(y,A));const D=A.click;return A.click=(O,M,Z)=>{this.pb(y),D?.(O,M,Z)},A}ob(y,A){this.H.openExternal(void 0,y),this.pb(A)}pb(y){this.z.publicLog2("workbenchActionExecuted",{id:y,from:s})}qb(y){return(0,R.$6w)(y,!this.O)}};e.$Zgc=a,e.$Zgc=a=o=Se([se(0,P.$VY),se(1,m.$_i),se(2,i.$Xfc),se(3,u.$Kfc),se(4,$.$_l),se(5,h.$Xgc),se(6,b.$CR),se(7,d.$egc),se(8,w.$ak),se(9,g.$Kgc),se(10,v.$tk),se(11,c.$Jgc)],a);function l(){return new n.MenuItem({type:"separator"})}}),define(ce[276],le([0,1,6,19,5,275,2]),function(x,e,n,r,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=e.$1gc=void 0,e.$1gc=(0,n.$Fi)("menubarMainService");let I=class extends T.$Uc{constructor(c,m,u){super(),this.b=c,this.c=m,this.f=u,this.a=this.g()}async g(){return await this.c.when(r.LifecycleMainPhase.AfterWindowOpen),this.B(this.b.createInstance(R.$Zgc))}async updateMenubar(c,m){this.f.trace("menubarService#updateMenubar",c),(await this.a).updateMenu(m,c)}};e.$2gc=I,e.$2gc=I=Se([se(0,n.$Ei),se(1,r.$egc),se(2,k.$ak)],I)});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[277],le([0,1,26,13,106,27,21,22,39,4,32,47,2,12,9,70,3,36,18,11,7,10,69,16,53,20,14,6,19,5,72,73,74,34,51,137,29,134,268,30,103,88,59,52,76,40,58,71,84]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b,$,P,E,i,h,t,o,s,a,l,S,y,A,L,D,O,M,Z,q,K,de,H,Y,B,Q,W,j,C,X,oe,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=void 0,n=Pe(n),A=Ve(A);function ue(F){return(0,H.$Ui)(F?.workspace)}function re(F){return(0,H.$Pi)(F?.workspace)}let J=class extends d.$Uc{constructor(N,_,z,ie,G,U,te,he,me,we,Ie,Ce,Ae,ve,$e,ee,ae,fe,be,Re,Fe){super(),this.s=N,this.t=_,this.u=z,this.w=ie,this.z=G,this.C=U,this.D=te,this.F=he,this.G=me,this.H=we,this.I=Ie,this.J=Ce,this.L=Ae,this.M=ve,this.N=$e,this.O=ee,this.P=ae,this.Q=fe,this.R=be,this.S=Re,this.U=Fe,this.a=this.B(new c.$le),this.onDidOpenWindow=this.a.event,this.b=this.B(new c.$le),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new c.$le),this.onDidDestroyWindow=this.c.event,this.f=this.B(new c.$le),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new c.$le),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new c.$le),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new c.$le),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new c.$le),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new de.$mhc(this,this.D,this.I,this.z,this.L)),this.W()}W(){this.B(this.N.onDidEnterWorkspace(N=>this.b.fire(N.window))),this.B(this.onDidSignalReadyWindow(N=>{if(N.config?.extensionDevelopmentPath||N.config?.extensionTestsPath){const _=new d.$Tc;if(_.add(c.Event.any(N.onDidClose,N.onDidDestroy)(()=>_.dispose())),N.config.extensionDevelopmentPath)for(const z of N.config.extensionDevelopmentPath)_.add(this.R.addValidFileRoot(z));N.config.extensionTestsPath&&_.add(this.R.addValidFileRoot(N.config.extensionTestsPath))}}))}openEmptyWindow(N,_){const z=this.G.args,ie=_?.remoteAuthority||void 0,G=!0,U=_?.forceReuseWindow,te=!U;return this.open({...N,cli:z,forceEmpty:G,forceNewWindow:te,forceReuseWindow:U,remoteAuthority:ie,forceTempProfile:_?.forceTempProfile,forceProfile:_?.forceProfile})}openExistingWindow(N,_){N.focus(),this.X(_,[N])}async open(N){this.z.trace("windowsManager#open"),N.addMode&&(N.initialStartup||!this.getLastActiveWindow())&&(N.addMode=!1);const _=[],z=[],ie=[],G=[],U=[];let te,he=0;const me=await this.db(N);this.z.trace("windowsManager#open pathsToOpen",me);for(const ve of me)re(ve)?N.addMode?_.push(ve):z.push(ve):ue(ve)?ie.push(ve):ve.fileUri?(te||(te={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ve.remoteAuthority}),te.filesToOpenOrCreate.push(ve)):ve.backupPath?U.push({backupFolder:(0,f.$nc)(ve.backupPath),remoteAuthority:ve.remoteAuthority}):he++;N.diffMode&&te&&te.filesToOpenOrCreate.length>=2&&(te.filesToDiff=te.filesToOpenOrCreate.slice(0,2),te.filesToOpenOrCreate=[]),N.mergeMode&&te&&te.filesToOpenOrCreate.length===4&&(te.filesToMerge=te.filesToOpenOrCreate.slice(0,4),te.filesToOpenOrCreate=[],te.filesToDiff=[]),te&&N.waitMarkerFileURI&&(te.filesToWait={paths:(0,T.$Gb)([...te.filesToDiff,te.filesToMerge[3],...te.filesToOpenOrCreate]),waitMarkerFileUri:N.waitMarkerFileURI}),N.initialStartup?(G.push(...this.N.getUntitledWorkspaces()),ie.push(...G),U.push(...this.J.getEmptyWindowBackups())):U.length=0;const{windows:we,filesOpenedInWindow:Ie}=await this.Y(N,ie,z,U,he,te,_);if(this.z.trace(`windowsManager#open used window count ${we.length} (workspacesToOpen: ${ie.length}, foldersToOpen: ${z.length}, emptyToRestore: ${U.length}, emptyToOpen: ${he})`),we.length>1)if(Ie)Ie.focus();else{const ve=this.r.state.lastActiveWindow&&!N.forceEmpty&&!N.cli._.length&&!N.cli["file-uri"]&&!N.cli["folder-uri"]&&!(N.urisToOpen&&N.urisToOpen.length);let $e=!0,ee=!0;if(ve){const ae=we.filter(fe=>this.r.state.lastActiveWindow&&fe.backupPath===this.r.state.lastActiveWindow.backupPath);ae.length&&(ae[0].focus(),$e=!1,ee=!1)}if($e)for(let ae=we.length-1;ae>=0;ae--){const fe=we[ae];if(!(fe.openedWorkspace&&G.some(be=>fe.openedWorkspace&&be.workspace.id===fe.openedWorkspace.id)||fe.backupPath&&U.some(be=>fe.backupPath&&be.backupFolder===(0,f.$nc)(fe.backupPath)))){fe.focus(),ee=!1;break}}ee&&we[we.length-1].focus()}const Ce=te&&te.filesToDiff.length>0,Ae=te&&te.filesToMerge.length>0;if(!we.some(ve=>ve.isExtensionDevelopmentHost)&&!Ce&&!Ae&&!N.noRecentEntry){const ve=[];for(const $e of me)ue($e)&&!$e.transient?ve.push({label:$e.label,workspace:$e.workspace,remoteAuthority:$e.remoteAuthority}):re($e)?ve.push({label:$e.label,folderUri:$e.workspace.uri,remoteAuthority:$e.remoteAuthority}):$e.fileUri&&ve.push({label:$e.label,fileUri:$e.fileUri,remoteAuthority:$e.remoteAuthority});this.M.addRecentlyOpened(ve)}return this.X(N,we),we}X(N,_){const z=N.waitMarkerFileURI;N.context===q.OpenContext.CLI&&z&&_.length===1&&_[0]&&(async()=>{await _[0].whenClosedOrLoaded;try{await this.Q.del(z)}catch{}})()}async Y(N,_,z,ie,G,U,te){const he=[];let me;function we(ae,fe){he.push(ae),fe&&(me=ae,U=void 0)}let{openFolderInNewWindow:Ie,openFilesInNewWindow:Ce}=this.pb(N);if(!N.initialStartup&&te.length>0){const ae=te[0].remoteAuthority,fe=this.vb(ae);fe&&we(this.ab(fe,te.map(be=>be.workspace.uri)))}const Ae=z.length+_.length+ie.length;if(U&&Ae===0){const ae=U.filesToOpenOrCreate[0]||U.filesToDiff[0]||U.filesToMerge[3],fe=this.getWindows().filter(Re=>U&&(0,$.$lh)(Re.remoteAuthority,U.remoteAuthority));let be;ae?.fileUri&&!Ce&&((N.context===q.OpenContext.DESKTOP||N.context===q.OpenContext.CLI||N.context===q.OpenContext.DOCK)&&(be=await(0,K.$3fc)(fe,ae.fileUri,async Re=>Re.configPath.scheme===w.Schemas.file?this.N.resolveLocalWorkspace(Re.configPath):void 0)),be||(be=this.wb(fe))),be?(0,H.$Ui)(be.openedWorkspace)?_.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,H.$Pi)(be.openedWorkspace)?z.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):we(this.Z(N,be,U),!0):we(await this.qb({userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,filesToOpen:U,forceNewWindow:!0,remoteAuthority:U.remoteAuthority,forceNewTabbedWindow:N.forceNewTabbedWindow,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile}),!0)}const ve=(0,T.$Lb)(_,ae=>ae.workspace.id);if(ve.length>0){const ae=(0,T.$Gb)(ve.map(fe=>(0,K.$4fc)(this.getWindows(),fe.workspace.configPath)));if(ae.length>0){const fe=ae[0],be=(0,$.$lh)(U?.remoteAuthority,fe.remoteAuthority)?U:void 0;we(this.Z(N,fe,be),!!be),Ie=!0}for(const fe of ve){if(ae.some(Fe=>Fe.openedWorkspace&&Fe.openedWorkspace.id===fe.workspace.id))continue;const be=fe.remoteAuthority,Re=(0,$.$lh)(U?.remoteAuthority,be)?U:void 0;we(await this.cb(N,fe,Ie,Re),!!Re),Ie=!0}}const $e=(0,T.$Lb)(z,ae=>$.$0g.getComparisonKey(ae.workspace.uri));if($e.length>0){const ae=(0,T.$Gb)($e.map(fe=>(0,K.$4fc)(this.getWindows(),fe.workspace.uri)));if(ae.length>0){const fe=ae[0],be=(0,$.$lh)(U?.remoteAuthority,fe.remoteAuthority)?U:void 0;we(this.Z(N,fe,be),!!be),Ie=!0}for(const fe of $e){if(ae.some(Fe=>(0,H.$Pi)(Fe.openedWorkspace)&&$.$0g.isEqual(Fe.openedWorkspace.uri,fe.workspace.uri)))continue;const be=fe.remoteAuthority,Re=(0,$.$lh)(U?.remoteAuthority,be)?U:void 0;we(await this.cb(N,fe,Ie,Re),!!Re),Ie=!0}}const ee=(0,T.$Lb)(ie,ae=>ae.backupFolder);if(ee.length>0)for(const ae of ee){const fe=ae.remoteAuthority,be=(0,$.$lh)(U?.remoteAuthority,fe)?U:void 0;we(await this.bb(N,!0,fe,be,ae),!!be),Ie=!0}if(he.length===0||U){U&&!G&&G++;const ae=U?U.remoteAuthority:N.remoteAuthority;for(let fe=0;fe<G;fe++)we(await this.bb(N,Ie,ae,U),!!U),Ie=!0}return{windows:(0,T.$Lb)(he),filesOpenedInWindow:me}}Z(N,_,z){this.z.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:z}),this.$(_);const ie={filesToOpenOrCreate:z?.filesToOpenOrCreate,filesToDiff:z?.filesToDiff,filesToMerge:z?.filesToMerge,filesToWait:z?.filesToWait,termProgram:N?.userEnv?.TERM_PROGRAM};return _.sendWhenReady("vscode:openFiles",I.CancellationToken.None,ie),_}$(N){let _=N;const z=r.BrowserWindow.getFocusedWindow();if(z&&z.id!==N.id){const ie=this.U.getWindowByWebContents(z.webContents);ie&&ie.parentId===N.id&&(_=ie)}_.focus()}ab(N,_){this.z.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:_}),N.focus();const z={foldersToAdd:_};return N.sendWhenReady("vscode:addFolders",I.CancellationToken.None,z),N}bb(N,_,z,ie,G){this.z.trace("windowsManager#doOpenEmpty",{restore:!!G,remoteAuthority:z,filesToOpen:ie,forceNewWindow:_});let U;return!_&&typeof N.contextWindowId=="number"&&(U=this.getWindowById(N.contextWindowId)),this.qb({userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,remoteAuthority:z,forceNewWindow:_,forceNewTabbedWindow:N.forceNewTabbedWindow,filesToOpen:ie,windowToUse:U,emptyWindowBackupInfo:G,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile})}cb(N,_,z,ie,G){return this.z.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:_,filesToOpen:ie}),!z&&!G&&typeof N.contextWindowId=="number"&&(G=this.getWindowById(N.contextWindowId)),this.qb({workspace:_.workspace,userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,remoteAuthority:_.remoteAuthority,forceNewWindow:z,forceNewTabbedWindow:N.forceNewTabbedWindow,filesToOpen:ie,windowToUse:G,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile})}async db(N){let _,z=!1,ie=!1;if(N.urisToOpen&&N.urisToOpen.length>0?(_=await this.eb(N),z=!0):N.forceEmpty?_=[Object.create(null)]:N.cli._.length||N.cli["folder-uri"]||N.cli["file-uri"]?(_=await this.fb(N.cli),_.length===0&&_.push(Object.create(null)),z=!0):(_=await this.hb(),_.length===0&&_.push(Object.create(null)),ie=!0),!N.addMode&&z){const G=_.filter(U=>re(U));if(G.length>1){const U=G[0].remoteAuthority;if(G.every(te=>(0,$.$lh)(te.remoteAuthority,U))){const te=await this.N.createUntitledWorkspace(G.map(he=>({uri:he.workspace.uri})));_.push({workspace:te,remoteAuthority:U}),_=_.filter(he=>!re(he))}}}if(N.initialStartup&&!ie&&this.L.getValue("window")?.restoreWindows==="preserve"){const G=await this.hb();_.unshift(...G.filter(U=>ue(U)||re(U)||U.backupPath))}return _}async eb(N){const _={gotoLineMode:N.gotoLineMode,remoteAuthority:N.remoteAuthority},z=await Promise.all((0,T.$Gb)(N.urisToOpen||[]).map(async ie=>{const G=await this.jb(ie,_);if(G)return G.label=ie.label,G;const U=this.lb(ie);this.P.showMessageBox({type:"info",buttons:[(0,i.localize)(11031,null)],message:U.scheme===w.Schemas.file?(0,i.localize)(11032,null):(0,i.localize)(11033,null),detail:U.scheme===w.Schemas.file?(0,i.localize)(11034,null,(0,u.$Zw)(U,{os:v.OS,tildify:this.G})):(0,i.localize)(11035,null,U.toString(!0))},r.BrowserWindow.getFocusedWindow()??void 0)}));return(0,T.$Gb)(z)}async fb(N){const _=[],z={ignoreFileNotFound:!0,gotoLineMode:N.goto,remoteAuthority:N.remote||void 0,forceOpenWorkspaceAsFile:N.diff&&N._.length===2||N.merge&&N._.length===4},ie=N["folder-uri"];if(ie){const te=await Promise.all(ie.map(he=>{const me=this.gb(he);if(me)return this.jb({folderUri:me},z)}));_.push(...(0,T.$Gb)(te))}const G=N["file-uri"];if(G){const te=await Promise.all(G.map(he=>{const me=this.gb(he);if(me)return this.jb((0,H.$$i)(he)?{workspaceUri:me}:{fileUri:me},z)}));_.push(...(0,T.$Gb)(te))}const U=await Promise.all(N._.map(te=>z.remoteAuthority?this.ob(te,z):this.mb(te,z)));return _.push(...(0,T.$Gb)(U)),_}gb(N){try{const _=E.URI.parse(N);if(!_.scheme){this.z.error(`Invalid URI input string, scheme missing: ${N}`);return}return _.path?_:_.with({path:"/"})}catch(_){this.z.error(`Invalid URI input string: ${N}, ${_.message}`)}}async hb(){const N=this.ib();switch(N){case"none":return[];case"one":case"all":case"preserve":case"folders":{const _=[];N!=="one"&&_.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&_.push(this.r.state.lastActiveWindow);const z=await Promise.all(_.map(async ie=>{if(ie.workspace){const G=await this.jb({workspaceUri:ie.workspace.configPath},{remoteAuthority:ie.remoteAuthority,rejectTransientWorkspaces:!0});if(ue(G))return G}else if(ie.folderUri){const G=await this.jb({folderUri:ie.folderUri},{remoteAuthority:ie.remoteAuthority});if(re(G))return G}else if(N!=="folders"&&ie.backupPath)return{backupPath:ie.backupPath,remoteAuthority:ie.remoteAuthority}}));return(0,T.$Gb)(z)}}}ib(){let N;return this.I.wasRestarted?N="all":(N=this.L.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(N)||(N="all")),N}async jb(N,_=Object.create(null)){const z=this.lb(N);return z.scheme===w.Schemas.file?((0,M.$_D)(N)&&(_={..._,forceOpenWorkspaceAsFile:!0}),this.mb(z.fsPath,_)):this.kb(N,_)}kb(N,_){let z=this.lb(N);const ie=(0,D.$hn)(z)||_.remoteAuthority;if(z=(0,$.$nh)((0,$.$hh)(z)),(0,M.$_D)(N)){if(_.gotoLineMode){const{path:G,line:U,column:te}=(0,m.$Mg)(z.path);return{fileUri:z.with({path:G}),options:{selection:U?{startLineNumber:U,startColumn:te||1}:void 0},remoteAuthority:ie}}return{fileUri:z,remoteAuthority:ie}}else if((0,M.$0D)(N))return{workspace:(0,Y.$7fc)(z),remoteAuthority:ie};return{workspace:(0,Y.$8fc)(z),remoteAuthority:ie}}lb(N){return(0,M.$0D)(N)?N.workspaceUri:(0,M.$$D)(N)?N.folderUri:N.fileUri}async mb(N,_,z){let ie,G;_.gotoLineMode&&({path:N,line:ie,column:G}=(0,m.$Mg)(N)),N=(0,m.$Gg)((0,f.$hc)(N),(0,b.cwd)());try{const U=await n.promises.stat(N);if(U.isFile()){if(!_.forceOpenWorkspaceAsFile){const te=await this.N.resolveLocalWorkspace(E.URI.file(N));if(te)return te.transient&&_.rejectTransientWorkspaces?void 0:{workspace:{id:te.id,configPath:te.configPath},type:a.FileType.File,exists:!0,remoteAuthority:te.remoteAuthority,transient:te.transient}}return{fileUri:E.URI.file(N),type:a.FileType.File,exists:!0,options:{selection:ie?{startLineNumber:ie,startColumn:G||1}:void 0}}}else{if(U.isDirectory())return{workspace:(0,Y.$8fc)(E.URI.file(N),U),type:a.FileType.Directory,exists:!0};if(!v.$j&&N==="/dev/null")return{fileUri:E.URI.file(N),type:a.FileType.File,exists:!0}}}catch(U){if(U.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!z)return this.nb(N,_);const te=E.URI.file(N);if(this.M.removeRecentlyOpened([te]),_.ignoreFileNotFound)return{fileUri:te,type:a.FileType.File,exists:!1}}}async nb(N,_){const z=E.URI.file(N),{response:ie,checkboxChecked:G}=await this.P.showMessageBox({type:"warning",buttons:[(0,i.localize)(11036,null),(0,i.localize)(11037,null),(0,i.localize)(11038,null)],message:(0,i.localize)(11039,null,z.authority),detail:(0,i.localize)(11040,null,(0,u.$Zw)(z,{os:v.OS,tildify:this.G})),checkboxLabel:(0,i.localize)(11041,null,z.authority),cancelId:1});if(ie===0){if((0,k.addUNCHostToAllowlist)(z.authority),G){const U={channel:"vscode:configureAllowedUNCHost",args:z.authority};this.sendToFocused(U.channel,U.args),this.sendToOpeningWindow(U.channel,U.args)}return this.mb(N,_,!0)}if(ie===2)return r.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.nb(N,_)}ob(N,_){const z=N.charCodeAt(0),ie=_.remoteAuthority;let G,U;_.gotoLineMode&&({path:N,line:G,column:U}=(0,m.$Mg)(N)),z!==p.CharCode.Slash&&((0,m.$Fg)(z)&&N.charCodeAt(N.charCodeAt(1))===p.CharCode.Colon&&(N=(0,m.$yg)(N)),N=`/${N}`);const te=E.URI.from({scheme:w.Schemas.vscodeRemote,authority:ie,path:N});if(N.charCodeAt(N.length-1)!==p.CharCode.Slash){if((0,H.$$i)(N))return _.forceOpenWorkspaceAsFile?{fileUri:te,options:{selection:G?{startLineNumber:G,startColumn:U||1}:void 0},remoteAuthority:_.remoteAuthority}:{workspace:(0,Y.$7fc)(te),remoteAuthority:ie};if(_.gotoLineMode||f.$gc.basename(N).indexOf(".")!==-1)return{fileUri:te,options:{selection:G?{startLineNumber:G,startColumn:U||1}:void 0},remoteAuthority:ie}}return{workspace:(0,Y.$8fc)(te),remoteAuthority:ie}}pb(N){const _=this.L.getValue("window"),z=_?.openFoldersInNewWindow||"default",ie=_?.openFilesInNewWindow||"off";let G=(N.preferNewWindow||N.forceNewWindow)&&!N.forceReuseWindow;!N.forceNewWindow&&!N.forceReuseWindow&&(z==="on"||z==="off")&&(G=z==="on");let U=!1;return N.forceNewWindow||N.forceReuseWindow?U=!!N.forceNewWindow&&!N.forceReuseWindow:(v.$k?N.context===q.OpenContext.DOCK&&(U=!0):N.context!==q.OpenContext.DIALOG&&N.context!==q.OpenContext.MENU&&!(N.userEnv&&N.userEnv.TERM_PROGRAM==="vscode")&&(U=!0),!N.cli.extensionDevelopmentPath&&(ie==="on"||ie==="off")&&(U=ie==="on")),{openFolderInNewWindow:!!G,openFilesInNewWindow:U}}async openExtensionDevelopmentHostWindow(N,_){const z=(0,K.$5fc)(this.getWindows(),N);if(z)return this.I.reload(z,_.cli),z.focus(),[z];let ie=_.cli["folder-uri"]||[],G=_.cli["file-uri"]||[],U=_.cli._;if(!U.length&&!ie.length&&!G.length&&!_.cli.extensionTestsPath){const me=this.r.state.lastPluginDevelopmentHostWindow,we=me?.workspace??me?.folderUri;we&&(E.URI.isUri(we)?we.scheme===w.Schemas.file?U=[we.fsPath]:ie=[we.toString()]:we.configPath.scheme===w.Schemas.file?U=[(0,$.$7g)(we.configPath)]:G=[we.configPath.toString()])}let te=_.remoteAuthority;for(const me of N)if(me.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const we=E.URI.parse(me),Ie=(0,D.$hn)(we);Ie&&(te?(0,$.$lh)(Ie,te)||this.z.error("more than one extension development path authority"):te=Ie)}U=U.filter(me=>{const we=E.URI.file(me);return(0,K.$4fc)(this.getWindows(),we)?!1:(0,$.$lh)((0,D.$hn)(we),te)}),ie=ie.filter(me=>{const we=this.gb(me);return we&&(0,K.$4fc)(this.getWindows(),we)?!1:we?(0,$.$lh)((0,D.$hn)(we),te):!1}),G=G.filter(me=>{const we=this.gb(me);return we&&(0,K.$4fc)(this.getWindows(),we)?!1:we?(0,$.$lh)((0,D.$hn)(we),te):!1}),_.cli._=U,_.cli["folder-uri"]=ie,_.cli["file-uri"]=G;const he={context:_.context,cli:_.cli,forceNewWindow:!0,forceEmpty:!U.length&&!ie.length&&!G.length,userEnv:_.userEnv,noRecentEntry:!0,waitMarkerFileURI:_.waitMarkerFileURI,remoteAuthority:te,forceProfile:_.forceProfile,forceTempProfile:_.forceTempProfile};return this.open(he)}async qb(N){const _=this.L.getValue("window"),z=this.getLastActiveWindow(),G=(_?.newWindowProfile?this.H.profiles.find(he=>he.name===_.newWindowProfile):void 0)??z?.profile??this.H.defaultProfile;let U;!N.forceNewWindow&&!N.forceNewTabbedWindow&&(U=N.windowToUse||z,U&&U.focus());const te={...this.G.args,...N.cli,machineId:this.s,sqmId:this.t,devDeviceId:this.u,windowId:-1,mainPid:process.pid,appRoot:this.G.appRoot,execPath:process.execPath,codeCachePath:this.G.codeCachePath,backupPath:N.emptyWindowBackupInfo?(0,f.$jc)(this.G.backupHome,N.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.H.profilesHome,all:this.H.profiles,profile:G},homeDir:this.G.userHome.with({scheme:w.Schemas.file}).fsPath,tmpDir:this.G.tmpDir.with({scheme:w.Schemas.file}).fsPath,userDataDir:this.G.userDataPath,remoteAuthority:N.remoteAuthority,workspace:N.workspace,userEnv:{...this.w,...N.userEnv},nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE},filesToOpenOrCreate:N.filesToOpen?.filesToOpenOrCreate,filesToDiff:N.filesToOpen?.filesToDiff,filesToMerge:N.filesToOpen?.filesToMerge,filesToWait:N.filesToOpen?.filesToWait,logLevel:this.C.getLogLevel(),loggers:{window:[],global:this.C.getRegisteredLoggers()},logsPath:this.G.logsHome.with({scheme:w.Schemas.file}).fsPath,product:A.default,isInitialStartup:N.initialStartup,perfMarks:(0,g.getMarks)(),os:{release:(0,R.release)(),hostname:(0,R.hostname)(),arch:(0,R.arch)()},autoDetectHighContrast:_?.autoDetectHighContrast??!0,autoDetectColorScheme:_?.autoDetectColorScheme??!1,accessibilitySupport:r.app.accessibilitySupportEnabled,colorScheme:this.S.getColorScheme(),policiesData:this.F.serialize(),continueOn:this.G.continueOn};if(U){const he=U.config;!te.extensionDevelopmentPath&&he?.extensionDevelopmentPath&&(te.extensionDevelopmentPath=he.extensionDevelopmentPath,te.extensionDevelopmentKind=he.extensionDevelopmentKind,te["enable-proposed-api"]=he["enable-proposed-api"],te.verbose=he.verbose,te["inspect-extensions"]=he["inspect-extensions"],te["inspect-brk-extensions"]=he["inspect-brk-extensions"],te.debugId=he.debugId,te.extensionEnvironment=he.extensionEnvironment,te["extensions-dir"]=he["extensions-dir"],te["disable-extensions"]=he["disable-extensions"]),te.loggers={global:te.loggers.global,window:he?.loggers.window??te.loggers.window}}else{const he=this.r.getNewWindowState(te);(0,g.mark)("code/willCreateCodeWindow");const me=U=this.O.createInstance(Z.$cgc,{state:he,extensionDevelopmentPath:te.extensionDevelopmentPath,isExtensionTestHost:!!te.extensionTestsPath});(0,g.mark)("code/didCreateCodeWindow"),N.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(me),this.n.set(me.id,me),this.a.fire(me),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const we=new d.$Tc;we.add(me.onDidSignalReady(()=>this.b.fire(me))),we.add(c.Event.once(me.onDidClose)(()=>this.tb(me,we))),we.add(c.Event.once(me.onDidDestroy)(()=>this.ub(me))),we.add(me.onDidMaximize(()=>this.g.fire(me))),we.add(me.onDidUnmaximize(()=>this.h.fire(me))),we.add(me.onDidEnterFullScreen(()=>this.j.fire({window:me,fullscreen:!0}))),we.add(me.onDidLeaveFullScreen(()=>this.j.fire({window:me,fullscreen:!1}))),we.add(me.onDidTriggerSystemContextMenu(({x:Ce,y:Ae})=>this.m.fire({window:me,x:Ce,y:Ae})));const Ie=(0,P.$pg)(me.win?.webContents);Ie.removeAllListeners("devtools-reload-page"),we.add(c.Event.fromNodeEventEmitter(Ie,"devtools-reload-page")(()=>this.I.reload(me))),this.I.registerWindow(me)}return te.windowId=U.id,U.isReady?this.I.unload(U,W.UnloadReason.LOAD).then(async he=>{he||await this.rb(U,te,N,G)}):await this.rb(U,te,N,G),U}async rb(N,_,z,ie){if(_.extensionDevelopmentPath||((0,H.$Ui)(_.workspace)?_.backupPath=this.J.registerWorkspaceBackup({workspace:_.workspace,remoteAuthority:_.remoteAuthority}):(0,H.$Pi)(_.workspace)?_.backupPath=this.J.registerFolderBackup({folderUri:_.workspace.uri,remoteAuthority:_.remoteAuthority}):_.backupPath=this.J.registerEmptyWindowBackup({backupFolder:z.emptyWindowBackupInfo?.backupFolder??(0,Y.$9fc)().id,remoteAuthority:_.remoteAuthority})),this.H.isEnabled()){const G=_.workspace??(0,H.$Ti)(_.backupPath,!1),U=this.sb(z,G,ie),te=U instanceof Promise?await U:U;_.profiles.profile=te,_.extensionDevelopmentPath||await this.H.setProfileForWorkspace(G,te)}N.load(_)}sb(N,_,z){return N.forceProfile?this.H.profiles.find(ie=>ie.name===N.forceProfile)??this.H.createNamedProfile(N.forceProfile):N.forceTempProfile?this.H.createTransientProfile():this.H.getProfileForWorkspace(_)??z}tb(N,_){this.n.delete(N.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),_.dispose()}ub(N){this.n.delete(N.id),this.c.fire(N)}getFocusedWindow(){const N=r.BrowserWindow.getFocusedWindow();if(N)return this.getWindowById(N.id)}getLastActiveWindow(){return this.wb(this.getWindows())}vb(N){return this.wb(this.getWindows().filter(_=>(0,$.$lh)(_.remoteAuthority,N)))}wb(N){return(0,q.$Zfc)(N)}sendToFocused(N,..._){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(N,I.CancellationToken.None,..._)}sendToOpeningWindow(N,..._){this.B(c.Event.once(this.onDidSignalReadyWindow)(z=>{z.sendWhenReady(N,I.CancellationToken.None,..._)}))}sendToAll(N,_,z){for(const ie of this.getWindows())z&&z.indexOf(ie.id)>=0||ie.sendWhenReady(N,I.CancellationToken.None,_)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(N){return this.n.get(N)}getWindowByWebContents(N){const _=r.BrowserWindow.fromWebContents(N);if(!_)return;const z=this.getWindowById(_.id);return z?.matches(N)?z:void 0}};e.$phc=J,e.$phc=J=Se([se(4,y.$ak),se(5,oe.$_fc),se(6,O.$CR),se(7,C.$to),se(8,s.$Kfc),se(9,X.$1fc),se(10,S.$egc),se(11,h.$Rfc),se(12,t.$_i),se(13,B.$Xgc),se(14,Q.$0fc),se(15,l.$Ei),se(16,o.$Sfc),se(17,a.$al),se(18,L.$Ufc),se(19,j.$Vfc),se(20,V.$Jgc)],J)}),define(ce[278],le([0,1,69,29,88,59]),function(x,e,n,r,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=void 0;let T=class{constructor(p,c,m,u){this.a=p,this.b=c,this.c=m,this.d=u,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(p,c){const m=this.b.getWindowById(p);if(m)return this.a.enterWorkspace(m,this.b.getWindows(),c)}createUntitledWorkspace(p,c,m){return this.a.createUntitledWorkspace(c,m)}deleteUntitledWorkspace(p,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(p,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(p){return this.c.getRecentlyOpened()}addRecentlyOpened(p,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(p,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(p){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$rhc=T,e.$rhc=T=Se([se(0,R.$0fc),se(1,r.$Xfc),se(2,k.$Xgc),se(3,n.$Rfc)],T)}),define(ce[279],le([0,1,13,106,35,27,17,55,15,4,283,47,2,12,9,3,11,7,33,158,44,159,118,135,10,69,253,16,260,96,136,53,97,187,20,68,100,175,263,177,178,179,14,191,99,83,6,98,186,269,270,254,261,19,5,276,64,28,74,264,101,34,243,87,128,24,220,221,57,50,233,258,271,259,272,132,235,236,237,240,267,51,29,277,242,30,102,88,278,59,40,200,58,213,49,86,133,245,262,250,8,223,244,195,71,266,239,21,75,265,231,206,65,84,274,78]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b,$,P,E,i,h,t,o,s,a,l,S,y,A,L,D,O,M,Z,q,K,de,H,Y,B,Q,W,j,C,X,oe,V,ue,re,J,F,N,_,z,ie,G,U,te,he,me,we,Ie,Ce,Ae,ve,$e,ee,ae,fe,be,Re,Fe,Me,De,Ue,Ge,Qe,qe,Xe,Je,Ye,We,ne,ge,pe,ye,je,Be,_e,lt,rt,at,tt,ut,ct,ft,gt,Ot,mt,$t,Tt,Lt,jt,pt,Mt,Et,dt,Ft,Nt,wt,Ct,St,Wt,kt){"use strict";var bt;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;let yt=class extends d.$Uc{static{bt=this}static{this.a={[w.Schemas.file]:"security.promptForLocalFileProtocolHandling",[w.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Oe,Te,Le,Ee,ke,He,xe,Ke,Ne,Ze,ze,et){super(),this.g=Oe,this.h=Te,this.j=Le,this.m=Ee,this.n=ke,this.s=He,this.t=xe,this.u=Ke,this.w=Ne,this.y=Ze,this.z=ze,this.C=et,this.D(),this.F()}D(){const Oe=Ne=>Ne?.startsWith(`${w.Schemas.vscodeWebview}://`),Te=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((Ne,Ze,ze,et)=>Oe(et.requestingUrl)?ze(Te.has(Ze)):ze(!1)),n.session.defaultSession.setPermissionCheckHandler((Ne,Ze,ze,et)=>Oe(et.requestingUrl)?Te.has(Ze):!1);const Le=new Set([w.Schemas.file,w.Schemas.vscodeFileResource,w.Schemas.vscodeRemoteResource,w.Schemas.vscodeManagedRemoteResource,"devtools"]),Ee=Ne=>{for(let Ze=Ne;Ze;Ze=Ze.parent)if(Ze.url.startsWith(`${w.Schemas.vscodeWebview}://`))return!0;return!1},ke=Ne=>Ne.resourceType==="xhr"||Ee(Ne.frame),He=Ne=>{const Ze=Ne.frame;if(!Ze||!this.b)return!1;const ze=n.BrowserWindow.getAllWindows();for(const et of ze)if(Ze.processId===et.webContents.mainFrame.processId)return!0;return!1},xe=(Ne,Ze)=>{if(Ne.path!=="/index.html")return!0;const ze=Ze.frame;if(!ze||!this.b)return!1;for(const et of this.b.getWindows())if(et.win&&ze.processId===et.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((Ne,Ze)=>{const ze=b.URI.parse(Ne.url);return ze.scheme===w.Schemas.vscodeWebview&&!xe(ze,Ne)?(this.m.error("Blocked vscode-webview request",Ne.url),Ze({cancel:!0})):ze.scheme===w.Schemas.vscodeFileResource&&!He(Ne)?(this.m.error("Blocked vscode-file request",Ne.url),Ze({cancel:!0})):ze.path.endsWith(".svg")&&!Le.has(ze.scheme)?Ze({cancel:!ke(Ne)}):Ze({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Ne,Ze)=>{const ze=Ne.responseHeaders,et=ze["content-type"]||ze["Content-Type"];if(et&&Array.isArray(et)){const it=b.URI.parse(Ne.url);if(it.path.endsWith(".svg")&&Le.has(it.scheme))return ze["Content-Type"]=["image/svg+xml"],Ze({cancel:!1,responseHeaders:ze});if(!it.path.endsWith(w.Schemas.vscodeRemoteResource)&&et.some(ot=>ot.toLowerCase().includes("image/svg")))return Ze({cancel:!ke(Ne)})}return Ze({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Ne,Ze)=>{if(Ne.url.startsWith("https://vscode.download.prss.microsoft.com/")){const ze=Ne.responseHeaders??Object.create(null);if(ze["Access-Control-Allow-Origin"]===void 0)return ze["Access-Control-Allow-Origin"]=["*"],Ze({cancel:!1,responseHeaders:ze})}return Ze({cancel:!1})});const Ke=n.session.defaultSession;typeof Ke.setCodeCachePath=="function"&&this.s.codeCachePath&&Ke.setCodeCachePath((0,f.$jc)(this.s.codeCachePath,"chrome")),g.$j&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,r.disableUNCAccessRestrictions)():(0,r.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,p.setUnexpectedErrorHandler)(Le=>this.G(Le)),process.on("uncaughtException",Le=>{(0,p.$X)(Le)||(0,p.$Y)(Le)}),process.on("unhandledRejection",Le=>(0,p.$Y)(Le)),c.Event.once(this.t.onWillShutdown)(()=>this.dispose()),(0,P.$XX)(),n.app.on("accessibility-support-changed",(Le,Ee)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",Ee)}),n.app.on("activate",async(Le,Ee)=>{this.m.trace("app#activate"),Ee||await this.b?.openEmptyWindow({context:Ye.OpenContext.DOCK})}),n.app.on("web-contents-created",(Le,Ee)=>{Ee?.opener?.url.startsWith(`${w.Schemas.vscodeFileResource}://${w.$Yg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(Ee)),Ee.on("will-navigate",ke=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),Ee.setWindowOpenHandler(ke=>ke.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(ke)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${ke.url}}`),this.f?.openExternal(void 0,ke.url),{action:"deny"}))});let Oe=[],Te;n.app.on("open-file",(Le,Ee)=>{Ee=(0,kt.$nm)(Ee),this.m.trace("app#open-file: ",Ee),Le.preventDefault(),Oe.push((0,ge.$$i)(Ee)?{workspaceUri:b.URI.file(Ee)}:{fileUri:b.URI.file(Ee)}),Te!==void 0&&(clearTimeout(Te),Te=void 0),Te=setTimeout(async()=>{await this.b?.open({context:Ye.OpenContext.DOCK,cli:this.s.args,urisToOpen:Oe,gotoLineMode:!1,preferNewWindow:!0}),Oe=[],Te=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:Ye.OpenContext.DESKTOP})}),k.$WX.handle("vscode:fetchShellEnv",Le=>{const Ee=this.b?.getWindowByWebContents(Le.sender);let ke,He;return Ee?.config?(ke=Ee.config,He={...process.env,...Ee.config.userEnv}):(ke=this.s.args,He=process.env),this.W(ke,He,!1)}),k.$WX.on("vscode:toggleDevTools",Le=>Le.sender.toggleDevTools()),k.$WX.on("vscode:openDevTools",Le=>Le.sender.openDevTools()),k.$WX.on("vscode:reloadWindow",Le=>Le.sender.reload()),k.$WX.handle("vscode:notifyZoomLevel",async(Le,Ee)=>{const ke=this.b?.getWindowByWebContents(Le.sender);ke&&ke.notifyZoomLevel(Ee)})}G(Oe){if(Oe){const Te={message:`[uncaught exception in main]: ${Oe.message}`,stack:Oe.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Te))}this.m.error(`[uncaught exception in main]: ${Oe}`),Oe.stack&&this.m.error(Oe.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Oe=this.z.win32AppUserModelId;g.$j&&Oe&&n.app.setAppUserModelId(Oe);try{g.$k&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ze){this.m.error(ze)}const Te=new i.$4X;c.Event.once(this.t.onWillShutdown)(ze=>{ze.reason===N.ShutdownReason.KILL&&Te.dispose()}),this.m.trace("Resolving machine identifier...");const[Le,Ee,ke]=await Promise.all([(0,$t.$Ahc)(this.w,this.m),(0,$t.$Bhc)(this.w,this.m),(0,$t.$Chc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Le}`);const{sharedProcessReady:He,sharedProcessClient:xe}=this.O(Le,Ee,ke),Ke=await this.P(Le,Ee,ke,He);Ke.invokeFunction(ze=>ze.get(t.$ogc)),this.B(Ke.createInstance(gt.$vhc)),Ke.invokeFunction(ze=>this.Q(ze,Te,xe));const Ne=await Ke.invokeFunction(ze=>this.H(ze,Te));this.I(Te),this.t.phase=N.LifecycleMainPhase.Ready,await Ke.invokeFunction(ze=>this.R(ze,Ne)),this.t.phase=N.LifecycleMainPhase.AfterWindowOpen,this.S(),this.B(new mt.$Rh(()=>{this.B((0,mt.$Vh)(()=>this.t.phase=N.LifecycleMainPhase.Eventually,2500))},2500)).schedule()}async H(Oe,Te){const Le=this.b=Oe.get(Ye.$Xfc),Ee=Oe.get(De.$LY),ke=this.f=Oe.get(ie.$Kgc),He=Oe.get(L.$Sfc),xe=this;Ee.registerHandler({async handleURL(it,ot){return xe.N(Le,He,Ee,it,ot)}});const Ke=this.B(new ne.$qhc({onDidOpenMainWindow:ke.onDidOpenMainWindow,onDidFocusMainWindow:ke.onDidFocusMainWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),Ne=new E.$ni(it=>Ke.getActiveClientId().then(ot=>it===ot)),Ze=new Ue.$hhc(Ne,this.m),ze=Te.getChannel("urlHandler",Ze);Ee.registerHandler(new Ue.$ghc(ze));const et=await this.J(Le,He);return this.B(new Qe.$ihc(et?.urls,Ee,Le,this.s,this.z,this.m)),et}I(Oe){const Te=()=>({statusCode:404,data:"Not found"}),Le=new Ct.$T(()=>Oe.getChannel(wt.$Jhc,new wt.$Khc));n.protocol.registerBufferProtocol(w.Schemas.vscodeManagedRemoteResource,(Ee,ke)=>{const He=b.URI.parse(Ee.url);if(!He.authority.startsWith("window:"))return ke(Te());Le.value.call(wt.$Ihc,[He]).then(xe=>ke({...xe,data:Buffer.from(xe.body,"base64")}),xe=>{this.m.warn("error dispatching remote resource call",xe),ke({statusCode:500,data:String(xe)})})})}async J(Oe,Te){const Le=this.s.args["open-url"]?this.s.args._urls||[]:[];Le.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Le);const Ee=global.getOpenUrls()||[];if(Ee.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ee),Le.length+Ee.length===0)return;const ke=[...Le,...Ee].map(Ke=>{try{return{uri:b.URI.parse(Ke),originalUrl:Ke}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ke);return}}),He=[],xe=[];for(const Ke of ke){if(!Ke)continue;const Ne=this.M(Ke.uri);if(Ne)if(await this.L(Ne,Oe,Te)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ke.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ke.uri.toString(!0),Ne),He.push(Ne);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ke.uri.toString(!0)),xe.push(Ke)}return{urls:xe,openables:He}}async L(Oe,Te,Le){let Ee,ke;if((0,Je.$0D)(Oe)?(Ee=Oe.workspaceUri,ke=(0,o.localize)(12941,null,Ee.scheme===w.Schemas.file?(0,u.$Zw)(Ee,{os:g.OS,tildify:this.s}):Ee.toString(!0),this.z.nameShort)):(0,Je.$$D)(Oe)?(Ee=Oe.folderUri,ke=(0,o.localize)(12942,null,Ee.scheme===w.Schemas.file?(0,u.$Zw)(Ee,{os:g.OS,tildify:this.s}):Ee.toString(!0),this.z.nameShort)):(Ee=Oe.fileUri,ke=(0,o.localize)(12943,null,Ee.scheme===w.Schemas.file?(0,u.$Zw)(Ee,{os:g.OS,tildify:this.s}):Ee.toString(!0),this.z.nameShort)),Ee.scheme!==w.Schemas.file&&Ee.scheme!==w.Schemas.vscodeRemote||this.u.getValue(bt.a[Ee.scheme])===!1)return!1;const{response:xe,checkboxChecked:Ke}=await Le.showMessageBox({type:"warning",buttons:[(0,o.localize)(12944,null),(0,o.localize)(12945,null)],message:ke,detail:(0,o.localize)(12946,null),checkboxLabel:Ee.scheme===w.Schemas.file?(0,o.localize)(12947,null):(0,o.localize)(12948,null),cancelId:1});if(xe!==0)return!0;if(Ke){const Ne={channel:"vscode:disablePromptForProtocolHandling",args:Ee.scheme===w.Schemas.file?"local":"remote"};Te.sendToFocused(Ne.channel,Ne.args),Te.sendToOpeningWindow(Ne.channel,Ne.args)}return!1}M(Oe){if(Oe.path){if(Oe.authority===w.Schemas.file){const Te=b.URI.file(Oe.fsPath);return(0,ge.$$i)(Te)?{workspaceUri:Te}:{fileUri:Te}}else if(Oe.authority===w.Schemas.vscodeRemote){const Te=Oe.path.indexOf(f.$gc.sep,1);if(Te!==-1){const Le=Oe.path.substring(1,Te),Ee=Oe.path.substring(Te);let ke=Oe.query;const He=new URLSearchParams(Oe.query);He.get("windowId")==="_blank"&&(He.delete("windowId"),ke=He.toString());const xe=b.URI.from({scheme:w.Schemas.vscodeRemote,authority:Le,path:Ee,query:ke,fragment:Oe.fragment});return(0,ge.$$i)(Ee)?{workspaceUri:xe}:/:[\d]+$/.test(Ee)?{fileUri:xe}:{folderUri:xe}}}}}async N(Oe,Te,Le,Ee,ke){this.m.trace("app#handleProtocolUrl():",Ee.toString(!0),ke),Ee.scheme===this.z.urlProtocol&&Ee.path==="workspace"&&(Ee=Ee.with({authority:"file",path:b.URI.parse(Ee.query).path,query:""}));let He=!1;const xe=new URLSearchParams(Ee.query);xe.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Ee.toString(!0)),xe.delete("windowId"),Ee=Ee.with({query:xe.toString()}),He=!0):g.$k&&Oe.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Ee.toString(!0)),He=!0);const Ke=xe.get("continueOn");Ke!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Ee.toString(!0)),xe.delete("continueOn"),Ee=Ee.with({query:xe.toString()}),this.s.continueOn=Ke??void 0);const Ne=this.M(Ee);return Ne?await this.L(Ne,Oe,Te)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",Ee.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Ne,Ee.toString(!0)),(0,Et.$Nb)(await Oe.open({context:Ye.OpenContext.API,cli:{...this.s.args},urisToOpen:[Ne],forceNewWindow:He,gotoLineMode:!0}))?.focus(),!0):He?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Ee.toString(!0)),await(0,Et.$Nb)(await Oe.open({context:Ye.OpenContext.API,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,U.$hn)(Ee)}))?.ready(),Le.open(Ee,ke)):(this.m.trace("app#handleProtocolUrl(): not handled",Ee.toString(!0),ke),!1)}O(Oe,Te,Le){const Ee=this.B(this.j.createInstance(te.$6gc,Oe,Te,Le));this.B(Ee.onDidCrash(()=>this.b?.sendToFocused("vscode:reportSharedProcessCrash")));const ke=(async()=>{this.m.trace("Main->SharedProcess#connect");const xe=await Ee.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new h.$5X(xe,"main")})();return{sharedProcessReady:(async()=>(await Ee.whenReady(),ke))(),sharedProcessClient:ke}}async P(Oe,Te,Le,Ee){const ke=new oe.$Di;switch(process.platform){case"win32":ke.set(ae.$VY,new C.$Ci(Me.$ehc));break;case"linux":g.$m?ke.set(ae.$VY,new C.$Ci(Fe.$dhc,[process.env.SNAP,process.env.SNAP_REVISION])):ke.set(ae.$VY,new C.$Ci(Re.$chc));break;case"darwin":ke.set(ae.$VY,new C.$Ci(be.$bhc));break}ke.set(Ye.$Xfc,new C.$Ci(We.$phc,[Oe,Te,Le,this.h],!1)),ke.set(St.$Jgc,new C.$Ci(Wt.$Lhc,void 0,!1));const He=new L.$Tfc(this.m,this.z);ke.set(L.$Sfc,He),ke.set(F.$Rgc,new C.$Ci(F.$Sgc,void 0,!1)),ke.set(A.$vgc,new C.$Ci(A.$wgc,void 0,!1)),ke.set(y.$Tm,E.ProxyChannel.toService((0,E.$li)(Ee.then(ze=>ze.getChannel("diagnostics"))))),ke.set(V.$fac,new C.$Ci(ue.$Mgc,[this.h])),ke.set(V.$gac,new C.$Ci(re.$Ngc,[this.h])),ke.set(D.$FY,new C.$Ci(O.$xgc)),ke.set(J.$Ogc,new C.$Ci(J.$Pgc)),ke.set(ie.$Kgc,new C.$Ci(ie.$Lgc,void 0,!1)),ke.set(qe.$jhc,new C.$Ci(Xe.$lhc)),ke.set(z.$1gc,new C.$Ci(z.$2gc)),ke.set(K.$ygc,new C.$Ci(de.$Agc)),ke.set(Ie.$kgc,new C.$Ci(Ie.$lgc)),ke.set(Ie.$mgc,new C.$Ci(Ie.$ngc));const xe=new Ft.$Hhc({graceTime:dt.LocalReconnectConstants.GraceTime,shortGraceTime:dt.LocalReconnectConstants.ShortGraceTime,scrollback:this.u.getValue(dt.TerminalSettingId.PersistentSessionScrollback)??100},this.u,this.s,this.t,this.m),Ke=new Nt.$Qs(xe,this.u,this.m,this.n);ke.set(dt.$rs,Ke),g.$j?ke.set(H.$Bgc,new C.$Ci(Y.$Cgc)):g.$k?ke.set(H.$Bgc,new C.$Ci(Y.$Dgc)):g.$l&&ke.set(H.$Bgc,new C.$Ci(Y.$Egc));const Ne=new a.$qgc(this.s,this.u,this.m,this.w);ke.set(s.$Rfc,Ne);const Ze=new Be.$$fc(this.s,this.m,this.C,Ne,He);if(ke.set(Be.$0fc,Ze),ke.set(pe.$eib,new C.$Ci(je.$rhc,void 0,!1)),ke.set(ye.$Xgc,new C.$Ci(ye.$Ygc,void 0,!1)),ke.set(De.$LY,new C.$Ci(Ge.$NY,void 0,!1)),(0,ee.$Ep)(this.z,this.s)){const ze=(0,ee.$Jp)(this.z,this.u),et=(0,E.$li)(Ee.then(vt=>vt.getChannel("telemetryAppender"))),it=new ve.$9gc(et),ot=(0,Ce.$vp)((0,R.release)(),(0,R.hostname)(),process.arch,this.z.commit,this.z.version,Oe,Te,Le,ze),nt=(0,ee.$Kp)(this.s),ht={appenders:[it],commonProperties:ot,piiPaths:nt,sendErrorTelemetry:!0};ke.set(Ae.$_l,new C.$Ci($e.$hs,[ht],!1))}else ke.set(Ae.$_l,ee.$zp);return ke.set(ut.$Jq,new C.$Ci(Tt.$JR,void 0,!0)),ke.set(ct.$Nq,new C.$Ci(ft.$uhc,void 0,!0)),ke.set(pt.$Fhc,new C.$Ci(pt.$Ghc,void 0,!0)),ke.set(t.$ogc,new C.$Ci(t.$pgc)),await mt.Promises.settled([Ne.initialize(),Ze.initialize()]),this.j.createChild(ke)}Q(Oe,Te,Le){const Ee=this.B(new d.$Tc),ke=E.ProxyChannel.fromService(Oe.get(F.$Rgc),Ee,{disableMarshalling:!0});this.g.registerChannel("launch",ke);const He=E.ProxyChannel.fromService(Oe.get(A.$vgc),Ee,{disableMarshalling:!0});this.g.registerChannel("diagnostics",He);const xe=Ee.add(new lt.$shc(Oe.get(_e.$to)));Te.registerChannel("policy",xe),Le.then(st=>st.registerChannel("policy",xe));const Ke=this.y.getProvider(w.Schemas.file);(0,v.$og)(Ke instanceof j.$tr);const Ne=Ee.add(new W.$Fgc(Ke,this.m,this.s));Te.registerChannel(B.$sR,Ne),Le.then(st=>st.registerChannel(B.$sR,Ne));const Ze=E.ProxyChannel.fromService(Oe.get(rt.$1fc),Ee);Te.registerChannel("userDataProfiles",Ze),Le.then(st=>st.registerChannel("userDataProfiles",Ze));const ze=new at.$cs(Oe.get(tt.$8p));Le.then(st=>st.registerChannel("request",ze));const et=new fe.$0gc(Oe.get(ae.$VY));Te.registerChannel("update",et);const it=E.ProxyChannel.fromService(Oe.get(V.$fac),Ee);Te.registerChannel("issue",it);const ot=E.ProxyChannel.fromService(Oe.get(V.$gac),Ee);Te.registerChannel("process",ot);const nt=E.ProxyChannel.fromService(Oe.get(D.$FY),Ee);Te.registerChannel("encryption",nt);const ht=E.ProxyChannel.fromService(Oe.get(he.$Zl),Ee);Te.registerChannel("sign",ht);const vt=E.ProxyChannel.fromService(Oe.get(J.$Ogc),Ee);Te.registerChannel("keyboardLayout",vt),this.f=Oe.get(ie.$Kgc);const Pt=E.ProxyChannel.fromService(this.f,Ee);Te.registerChannel("nativeHost",Pt),Le.then(st=>st.registerChannel("nativeHost",Pt));const Ut=E.ProxyChannel.fromService(Oe.get(pe.$eib),Ee);Te.registerChannel("workspaces",Ut);const Bt=E.ProxyChannel.fromService(Oe.get(z.$1gc),Ee);Te.registerChannel("menubar",Bt);const zt=E.ProxyChannel.fromService(Oe.get(De.$LY),Ee);Te.registerChannel("url",zt);const qt=E.ProxyChannel.fromService(Oe.get(qe.$jhc),Ee);Te.registerChannel("webview",qt);const It=Ee.add(new we.$7gc(this.m,Oe.get(Ie.$kgc)));Te.registerChannel("storage",It),Le.then(st=>st.registerChannel("storage",It));const Ht=Ee.add(new Ot.$whc(Oe.get(Ie.$kgc),Oe.get(rt.$1fc),this.m));Le.then(st=>st.registerChannel("profileStorageListener",Ht));const Zt=E.ProxyChannel.fromService(Oe.get(dt.$rs),Ee);Te.registerChannel(dt.TerminalIpcChannels.LocalPty,Zt);const xt=E.ProxyChannel.fromService(Oe.get(H.$Bgc),Ee);Te.registerChannel("externalTerminal",xt);const At=new Lt.$Dhc(Oe.get(jt.$_fc));Te.registerChannel("logger",At),Le.then(st=>st.registerChannel("logger",At));const Vt=new S.$rgc(Oe.get(Ye.$Xfc));Te.registerChannel("extensionhostdebugservice",Vt);const Gt=E.ProxyChannel.fromService(Oe.get(K.$ygc),Ee);Te.registerChannel(K.$zgc,Gt);const Kt=E.ProxyChannel.fromService(Oe.get(pt.$Fhc),Ee);Te.registerChannel(Mt.$Ehc,Kt)}async R(Oe,Te){const Le=this.b=Oe.get(Ye.$Xfc);this.c=Oe.get(St.$Jgc);const Ee=(0,Z.$Km)(process.env)?Ye.OpenContext.CLI:Ye.OpenContext.DESKTOP,ke=this.s.args;if(Te){if(Te.openables.length>0)return Le.open({context:Ee,cli:ke,urisToOpen:Te.openables,gotoLineMode:!0,initialStartup:!0});if(Te.urls.length>0)for(const nt of Te.urls){const ht=new URLSearchParams(nt.uri.query);if(ht.get("windowId")==="_blank")return ht.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:ht.toString()}),Le.open({context:Ee,cli:ke,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const He=global.macOpenFiles,xe=ke._.length,Ke=!!ke["folder-uri"],Ne=!!ke["file-uri"],Ze=ke["skip-add-to-recently-opened"]===!0,ze=ke.wait&&ke.waitMarkerFilePath?b.URI.file(ke.waitMarkerFilePath):void 0,et=ke.remote||void 0,it=ke.profile,ot=ke["profile-temp"];if(!xe&&!Ke&&!Ne){if(ke["new-window"]||it||ot)return Le.open({context:Ee,cli:ke,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ze,waitMarkerFileURI:ze,initialStartup:!0,remoteAuthority:et,forceProfile:it,forceTempProfile:ot});if(He.length)return Le.open({context:Ye.OpenContext.DOCK,cli:ke,urisToOpen:He.map(nt=>(nt=(0,kt.$nm)(nt),(0,ge.$$i)(nt)?{workspaceUri:b.URI.file(nt)}:{fileUri:b.URI.file(nt)})),noRecentEntry:Ze,waitMarkerFileURI:ze,initialStartup:!0})}return Le.open({context:Ee,cli:ke,forceNewWindow:ke["new-window"],diffMode:ke.diff,mergeMode:ke.merge,noRecentEntry:Ze,waitMarkerFileURI:ze,gotoLineMode:ke.goto,initialStartup:!0,remoteAuthority:et,forceProfile:it,forceTempProfile:ot})}S(){this.U(),n.protocol.registerHttpProtocol(w.Schemas.vscodeRemoteResource,(Oe,Te)=>{Te({url:Oe.url.replace(/^vscode-remote-resource:/,"http:"),method:Oe.method})}),this.W(this.s.args,process.env,!0),this.X(),g.$k&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async U(){const Oe=this.z.win32MutexName;if(g.$j&&Oe)try{const Te=await new Promise((Ee,ke)=>{x(["@vscode/windows-mutex"],Ee,ke)}).then(Pe),Le=new Te.Mutex(Oe);c.Event.once(this.t.onWillShutdown)(()=>Le.release())}catch(Te){this.m.error(Te)}}async W(Oe,Te,Le){try{return await(0,q.$Rm)(this.u,this.m,Oe,Te)}catch(Ee){const ke=(0,I.$qj)(Ee);Le?this.b?.sendToFocused("vscode:showResolveShellEnvError",ke):this.m.error(ke)}return{}}async X(){try{const Te=(await this.y.readFile(this.s.argvResource)).value.toString(),Le=(0,m.parse)(Te),ke=(0,ee.$Gp)(this.u)>=Ae.TelemetryLevel.CRASH;if(Le["enable-crash-reporter"]===void 0){const He=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${ke},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,$.$2g)()}"`,"}"],xe=Te.substring(0,Te.length-2).concat(`,
`,He.join(`
`));await this.y.writeFile(this.s.argvResource,T.$Ne.fromString(xe))}else{const He=Te.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${ke},`);He!==Te&&await this.y.writeFile(this.s.argvResource,T.$Ne.fromString(He))}}catch(Oe){this.m.error(Oe),this.b?.sendToFocused("vscode:showArgvParseWarning")}}};e.$Mhc=yt,e.$Mhc=yt=bt=Se([se(2,X.$Ei),se(3,_.$ak),se(4,_.$bk),se(5,M.$Kfc),se(6,N.$egc),se(7,l.$_i),se(8,me.$CR),se(9,Q.$al),se(10,G.$tk),se(11,rt.$1fc)],yt)});var Ve=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(ce[284],le([0,1,13,26,7,21,8,55,15,32,4,47,12,9,70,3,36,25,23,44,104,279,10,16,205,219,20,68,170,14,189,99,83,185,98,19,192,5,72,28,73,246,131,257,49,256,101,218,34,57,76,58,40,201,199,2,41,234,71,194,123,127,238,106,232]),function(x,e,n,r,k,R,T,I,p,c,m,u,d,w,f,g,v,b,$,P,E,i,h,t,o,s,a,l,S,y,A,L,D,O,M,Z,q,K,de,H,Y,B,Q,W,j,C,X,oe,V,ue,re,J,F,N,_,z,ie,G,U,te,he,me,we,Ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),de=Ve(de);class Ce{main(){try{this.a()}catch($e){console.error($e.message),n.app.exit(1)}}async a(){(0,p.setUnexpectedErrorHandler)(De=>console.error(De));const[$e,ee,ae,fe,be,Re,Fe,Me]=this.b();try{try{await this.d(ae,Me,fe,be,Fe)}catch(De){throw this.g(ae,Fe,De),De}await $e.invokeFunction(async De=>{const Ue=De.get(K.$ak),Ge=De.get(Z.$egc),Qe=De.get(y.$al),qe=De.get(K.$bk),Xe=await this.f(Ue,ae,Ge,$e,Fe,!0);return $.Promises.writeFile(ae.mainLockfile,String(process.pid)).catch(Je=>{Ue.warn(`app#startup(): Error writing main lockfile: ${Je.stack}`)}),Re.logger=qe.createLogger("main",{name:(0,h.localize)(12932,null)}),m.Event.once(Ge.onWillShutdown)(Je=>{Qe.dispose(),fe.dispose(),Je.join("instanceLockfile",r.promises.unlink(ae.mainLockfile).catch(()=>{}))}),$e.createInstance(i.$Mhc,Xe,ee).startup()})}catch(De){$e.invokeFunction(this.j,De)}}b(){const $e=new M.$Di,ee=new z.$Tc;process.once("exit",()=>ee.dispose());const ae={_serviceBrand:void 0,...de.default};$e.set(H.$tk,ae);const fe=new a.$Lfc(this.k(),ae),be=this.c(fe);$e.set(a.$Kfc,fe);const Re=new U.$agc((0,K.$ok)(fe),fe.logsHome);$e.set(U.$_fc,Re);const Fe=new q.$kdc(Re.getLogLevel()),Me=ee.add(new te.$KR(Fe,[new K.$hk(Re.getLogLevel())]));$e.set(K.$ak,Me);const De=new A.$3q(Me);$e.set(y.$al,De);const Ue=new L.$tr(Me);De.registerProvider(d.Schemas.file,Ue);const Ge=new G.$Us(De);$e.set(ie.$Kl,Ge);const Qe=new me.$FR(me.SaveStrategy.DELAYED,fe,Me,De);$e.set(V.$BR,Qe),$e.set(V.$CR,Qe);const qe=new J.$2fc(Qe,Ge,fe,De,Me);$e.set(J.$1fc,qe),De.registerProvider(d.Schemas.vscodeUserData,new we.$Xhc(d.Schemas.file,Ue,d.Schemas.vscodeUserData,qe,Ge,Me));const Xe=g.$j&&ae.win32RegValueName?ee.add(new N.$Vhc(Me,ae.win32RegValueName)):fe.policyFile?ee.add(new _.$Whc(fe.policyFile,De,Me)):new F.$vo;$e.set(F.$to,Xe);const Je=new o.$Xo(qe.defaultProfile.settingsResource,De,Xe,Me);return $e.set(t.$_i,Je),$e.set(Z.$egc,new D.$Ci(Z.$fgc,void 0,!1)),$e.set(j.$8p,new D.$Ci(C.$Thc,void 0,!0)),$e.set(re.$Vfc,new D.$Ci(re.$Wfc)),$e.set(X.$Zl,new D.$Ci(oe.$Uhc,void 0,!1)),$e.set(Q.$Ew,new D.$Ci(W.$Rhc)),$e.set(Y.$Ufc,new B.$Ohc(fe,qe,Me)),[new O.$wr($e,!0),be,fe,Je,Qe,Fe,ae,qe]}c($e){const ee={VSCODE_IPC_HOOK:$e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ae=>{const fe=process.env[ae];typeof fe=="string"&&(ee[ae]=fe)}),Object.assign(process.env,ee),ee}async d($e,ee,ae,fe,be){await T.Promises.settled([Promise.all([this.e($e.extensionsPath),$e.codeCachePath,$e.logsHome.with({scheme:d.Schemas.file}).fsPath,ee.defaultProfile.globalStorageHome.with({scheme:d.Schemas.file}).fsPath,$e.workspaceStorageHome.with({scheme:d.Schemas.file}).fsPath,$e.localHistoryHome.with({scheme:d.Schemas.file}).fsPath,$e.backupHome].map(Re=>Re?r.promises.mkdir(Re,{recursive:!0}):void 0)),fe.init(),ae.initialize()]),ee.init()}e($e){if(g.$j){const ee=(0,Ie.getUNCHost)($e);ee&&(0,Ie.addUNCHostToAllowlist)(ee)}return $e}async f($e,ee,ae,fe,be,Re){let Fe;try{(0,f.mark)("code/willStartMainServer"),Fe=await(0,E.$Ai)(ee.mainIPCHandle),(0,f.mark)("code/didStartMainServer"),m.Event.once(ae.onWillShutdown)(()=>Fe.dispose())}catch(Me){if(Me.code!=="EADDRINUSE")throw this.g(ee,be,Me),Me;let De;try{De=await(0,E.$Bi)(ee.mainIPCHandle,"main")}catch(qe){if(!Re||g.$j||qe.code!=="ECONNREFUSED")throw qe.code==="EPERM"&&this.h((0,h.localize)(12933,null,be.nameShort),(0,h.localize)(12934,null),be),qe;try{(0,r.unlinkSync)(ee.mainIPCHandle)}catch(Xe){throw $e.warn("Could not delete obsolete instance handle",Xe),Xe}return this.f($e,ee,ae,fe,be,!1)}if(ee.extensionTestsLocationURI&&!ee.debugExtensionHost.break){const qe=`Running extension tests from the command line is currently only supported if no other instance of ${be.nameShort} is running.`;throw $e.error(qe),De.dispose(),new Error(qe)}let Ue;!ee.args.wait&&!ee.args.status&&(Ue=setTimeout(()=>{this.h((0,h.localize)(12935,null,be.nameShort),(0,h.localize)(12936,null),be)},1e4));const Ge=P.ProxyChannel.toService(De.getChannel("launch"),{disableMarshalling:!0}),Qe=P.ProxyChannel.toService(De.getChannel("diagnostics"),{disableMarshalling:!0});if(ee.args.status)return fe.invokeFunction(async()=>{const qe=new s.$2s(ue.$zp,be),Xe=await Qe.getMainDiagnostics(),Je=await Qe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ye=await qe.getDiagnostics(Xe,Je);throw console.log(Ye),new p.$_});throw g.$j&&await this.i(Ge,$e),$e.trace("Sending env to running instance..."),await Ge.start(ee.args,process.env),De.dispose(),Ue&&clearTimeout(Ue),new p.$_("Sent env to running instance. Terminating...")}if(ee.args.status)throw console.log((0,h.localize)(12937,null,be.nameShort)),new p.$_("Terminating...");return process.env.VSCODE_PID=String(process.pid),Fe}g($e,ee,ae){if(ae.code==="EACCES"||ae.code==="EPERM"){const fe=(0,R.$Gb)([$e.userDataPath,$e.extensionsPath,E.$wi]).map(be=>(0,u.$Zw)(k.URI.file(be),{os:g.OS,tildify:$e}));this.h((0,h.localize)(12938,null),(0,h.localize)(12939,null,(0,I.$qj)(ae),fe.join(`
`)),ee)}}h($e,ee,ae){n.dialog.showMessageBoxSync((0,he.$bx)({type:"warning",buttons:[(0,h.localize)(12940,null)],message:$e,detail:ee},ae).options)}async i($e,ee){if(g.$j){const ae=await $e.getMainProcessId();ee.trace("Sending some foreground love to the running instance:",ae);try{(await new Promise((fe,be)=>{x(["windows-foreground-love"],fe,be)}).then(Pe)).allowSetForegroundWindow(ae)}catch(fe){ee.error(fe)}}}j($e,ee){const ae=$e.get(K.$ak),fe=$e.get(Z.$egc);let be=0;ee&&(ee.isExpected?ee.message&&ae.trace(ee.message):(be=1,ee.stack?ae.error(ee.stack):ae.error(`Startup error: ${ee.toString()}`))),fe.kill(be)}k(){const $e=this.l((0,l.$Hm)(process.argv));if($e.wait&&!$e.waitMarkerFilePath){const ee=(0,S.$Nhc)($e.verbose);ee&&((0,l.$Jm)(process.argv,"--waitMarkerFilePath",ee),$e.waitMarkerFilePath=ee)}return $e}l($e){if($e["open-url"]&&($e._urls=$e._,$e._=[]),!$e.remote){const ee=this.m($e._,$e.goto);$e._=ee}return $e}m($e,ee){const ae=(0,v.cwd)(),fe=$e.map(Fe=>{let Me=String(Fe),De;ee&&(De=(0,c.$Mg)(Me),Me=De.path),Me&&(Me=this.n(ae,Me));const Ue=(0,c.$Gg)(Me,ae),Ge=(0,w.$nc)(Ue);return Ge&&!(0,c.$Cg)(Ge)?null:ee&&De?(De.path=Ue,this.o(De)):Ue}),be=g.$j||g.$k,Re=(0,R.$Lb)(fe,Fe=>Fe&&be?Fe.toLowerCase():Fe||"");return(0,R.$Gb)(Re)}n($e,ee){return g.$j&&(ee=(0,b.$nf)(ee,'"')),ee=(0,b.$lf)((0,b.$lf)(ee," "),"	"),g.$j&&(ee=(0,w.$kc)($e,ee),ee=(0,b.$nf)(ee,".")),ee}o($e){const ee=[$e.path];return typeof $e.line=="number"&&ee.push(String($e.line)),typeof $e.column=="number"&&ee.push(String($e.column)),ee.join(":")}}new Ce().main()})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/1d82f317af9c90b96a433fd6a599e4b1d31869a3/core/vs/code/electron-main/main.js.map
