/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/platform","vs/base/common/path","vs/base/common/strings","vs/base/common/extpath","vs/base/common/uri","vs/base/common/charCode","vs/base/common/async","fs","vs/base/common/errors","vs/base/common/lifecycle","vs/base/common/cancellation","vs/base/common/arrays","vs/base/common/lazy","vs/base/common/map","vs/base/common/process","vs/base/common/event","vs/base/common/network","vs/base/common/resources","vs/base/node/pfs","os","vs/nls","vs/base/common/functional","vs/base/common/normalization","vs/base/common/types","vs/platform/environment/node/argv","vs/platform/instantiation/common/instantiation","vs/platform/files/common/files","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/ports","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ports","vs/base/node/terminalEncoding","child_process","vs/platform/environment/node/argvHelper","vs/platform/environment/node/stdin","vs/platform/environment/node/wait","vs/platform/files/common/watcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/product/common/product","vs/platform/profiling/common/profiling","util","net","minimist","assert","vs/code/node/cli","vs/base/node/unc"],Ee=function(oe){for(var e=[],a=0,t=oe.length;a<t;a++)e[a]=be[oe[a]];return e};define(be[29],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=a,e.$fb=t,e.$gb=R,e.$hb=p,e.$ib=J,e.$jb=O,e.$kb=L,e.$mb=j,e.$nb=q,e.$ob=I,e.$pb=W,e.$qb=f;function a(r,u){const g=t(r,u);if(g!==-1)return r[g]}function t(r,u,g=r.length-1){for(let y=g;y>=0;y--){const v=r[y];if(u(v))return y}return-1}function R(r,u){const g=p(r,u);return g===-1?void 0:r[g]}function p(r,u,g=0,y=r.length){let v=g,k=y;for(;v<k;){const w=Math.floor((v+k)/2);u(r[w])?v=w+1:k=w}return v-1}function J(r,u){const g=O(r,u);return g===r.length?void 0:r[g]}function O(r,u,g=0,y=r.length){let v=g,k=y;for(;v<k;){const w=Math.floor((v+k)/2);u(r[w])?k=w:v=w+1}return v}function L(r,u,g=0,y=r.length){const v=O(r,u,g,y);return v===r.length?-1:v}class T{static{this.assertInvariants=!1}constructor(u){this.e=u,this.c=0}findLastMonotonous(u){if(T.assertInvariants){if(this.d){for(const y of this.e)if(this.d(y)&&!u(y))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=u}const g=p(this.e,u,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}e.$lb=T;function j(r,u){if(r.length===0)return;let g=r[0];for(let y=1;y<r.length;y++){const v=r[y];u(v,g)>0&&(g=v)}return g}function q(r,u){if(r.length===0)return;let g=r[0];for(let y=1;y<r.length;y++){const v=r[y];u(v,g)>=0&&(g=v)}return g}function I(r,u){return j(r,(g,y)=>-u(g,y))}function W(r,u){if(r.length===0)return-1;let g=0;for(let y=1;y<r.length;y++){const v=r[y];u(v,r[g])>0&&(g=y)}return g}function f(r,u){for(const g of r){const y=u(g);if(y!==void 0)return y}}}),define(be[7],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var a;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(a||(e.CharCode=a={}))}),define(be[30],Ee([0,1]),function(oe,e){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=t,e.$d=R,e.$e=p,e.$f=J;function t(L,T){const j=Object.create(null);for(const q of L){const I=T(q);let W=j[I];W||(W=j[I]=[]),W.push(q)}return j}function R(L,T){const j=[],q=[];for(const I of L)T.has(I)||j.push(I);for(const I of T)L.has(I)||q.push(I);return{removed:j,added:q}}function p(L,T){const j=[],q=[];for(const[I,W]of L)T.has(I)||j.push(W);for(const[I,W]of T)L.has(I)||q.push(W);return{removed:j,added:q}}function J(L,T){const j=new Set;for(const q of T)L.has(q)&&j.add(q);return j}class O{static{a=Symbol.toStringTag}constructor(T,j){this.b=j,this.a=new Map,this[a]="SetWithKey";for(const q of T)this.add(q)}get size(){return this.a.size}add(T){const j=this.b(T);return this.a.set(j,T),this}delete(T){return this.a.delete(this.b(T))}has(T){return this.a.has(this.b(T))}*entries(){for(const T of this.a.values())yield[T,T]}keys(){return this.values()}*values(){for(const T of this.a.values())yield T}clear(){this.a.clear()}forEach(T,j){this.a.forEach(q=>T.call(j,q,q,this))}[Symbol.iterator](){return this.values()}}e.$g=O}),define(be[10],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=t,e.$X=R,e.$Y=p,e.$Z=J,e.$1=O,e.$2=L,e.$3=j,e.$5=I,e.$6=W,e.$7=f,e.$9=u;class a{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?k.isErrorNoTelemetry(n)?new k(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(s=>{s(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$U=a,e.$V=new a;function t(i){e.$V.setUnexpectedErrorHandler(i)}function R(i){if(!i||typeof i!="object")return!1;const n=i;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function p(i){j(i)||e.$V.onUnexpectedError(i)}function J(i){j(i)||e.$V.onUnexpectedExternalError(i)}function O(i){if(i instanceof Error){const{name:n,message:s}=i,m=i.stacktrace||i.stack;return{$isError:!0,name:n,message:s,stack:m,noTelemetry:k.isErrorNoTelemetry(i)}}return i}function L(i){let n;return i.noTelemetry?n=new k:(n=new Error,n.name=i.name),n.message=i.message,n.stack=i.stack,n}const T="Canceled";function j(i){return i instanceof q?!0:i instanceof Error&&i.name===T&&i.message===T}class q extends Error{constructor(){super(T),this.name=this.message}}e.$4=q;function I(){const i=new Error(T);return i.name=i.message,i}function W(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function f(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class r extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=r;function u(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class g extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$0=g;class y extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$$=y;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=v;class k extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof k)return n;const s=new k;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$ab=k;class w extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,w.prototype)}}e.$bb=w}),define(be[13],Ee([0,1,10,29]),function(oe,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=R,e.$sb=p,e.$tb=J,e.$ub=O,e.$vb=L,e.$wb=T,e.$xb=j,e.$yb=q,e.$zb=I,e.$Ab=W,e.$Bb=f,e.$Cb=r,e.$Db=u,e.top=g,e.$Fb=y,e.$Gb=k,e.$Hb=w,e.$Ib=i,e.$Jb=n,e.$Kb=s,e.$Lb=m,e.$Mb=P,e.$Nb=h,e.$Ob=$,e.$Pb=l,e.$Qb=o,e.$Rb=U,e.$Sb=D,e.$Tb=b,e.$Ub=G,e.$Vb=x,e.$Wb=Z,e.$Xb=H,e.$Yb=ce,e.$Zb=F,e.$1b=X,e.$2b=C,e.$3b=ee,e.$4b=M,e.$5b=te,e.$6b=ue,e.$9b=se,e.$ac=De;function R(N,B=0){return N[N.length-(1+B)]}function p(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}function J(N,B,_=(c,A)=>c===A){if(N===B)return!0;if(!N||!B||N.length!==B.length)return!1;for(let c=0,A=N.length;c<A;c++)if(!_(N[c],B[c]))return!1;return!0}function O(N,B){const _=N.length-1;B<_&&(N[B]=N[_]),N.pop()}function L(N,B,_){return T(N.length,c=>_(N[c],B))}function T(N,B){let _=0,c=N-1;for(;_<=c;){const A=(_+c)/2|0,K=B(A);if(K<0)_=A+1;else if(K>0)c=A-1;else return A}return-(_+1)}function j(N,B,_){if(N=N|0,N>=B.length)throw new TypeError("invalid index");const c=B[Math.floor(B.length*Math.random())],A=[],K=[],Q=[];for(const ge of B){const ve=_(ge,c);ve<0?A.push(ge):ve>0?K.push(ge):Q.push(ge)}return N<A.length?j(N,A,_):N<A.length+Q.length?Q[0]:j(N-(A.length+Q.length),K,_)}function q(N,B){const _=[];let c;for(const A of N.slice(0).sort(B))!c||B(c[0],A)!==0?(c=[A],_.push(c)):c.push(A);return _}function*I(N,B){let _,c;for(const A of N)c!==void 0&&B(c,A)?_.push(A):(_&&(yield _),_=[A]),c=A;_&&(yield _)}function W(N,B){for(let _=0;_<=N.length;_++)B(_===0?void 0:N[_-1],_===N.length?void 0:N[_])}function f(N,B){for(let _=0;_<N.length;_++)B(_===0?void 0:N[_-1],N[_],_+1===N.length?void 0:N[_+1])}function r(N,B,_){const c=[];function A(ge,ve,Re){if(ve===0&&Re.length===0)return;const fe=c[c.length-1];fe&&fe.start+fe.deleteCount===ge?(fe.deleteCount+=ve,fe.toInsert.push(...Re)):c.push({start:ge,deleteCount:ve,toInsert:Re})}let K=0,Q=0;for(;;){if(K===N.length){A(K,0,B.slice(Q));break}if(Q===B.length){A(K,N.length-K,[]);break}const ge=N[K],ve=B[Q],Re=_(ge,ve);Re===0?(K+=1,Q+=1):Re<0?(A(K,1,[]),K+=1):Re>0&&(A(K,0,[ve]),Q+=1)}return c}function u(N,B,_){const c=r(N,B,_),A=[],K=[];for(const Q of c)A.push(...N.slice(Q.start,Q.start+Q.deleteCount)),K.push(...Q.toInsert);return{removed:A,added:K}}function g(N,B,_){if(_===0)return[];const c=N.slice(0,_).sort(B);return v(N,B,c,_,N.length),c}function y(N,B,_,c,A){return _===0?Promise.resolve([]):new Promise((K,Q)=>{(async()=>{const ge=N.length,ve=N.slice(0,_).sort(B);for(let Re=_,fe=Math.min(_+c,ge);Re<ge;Re=fe,fe=Math.min(fe+c,ge)){if(Re>_&&await new Promise(le=>setTimeout(le)),A&&A.isCancellationRequested)throw new a.$4;v(N,B,ve,Re,fe)}return ve})().then(K,Q)})}function v(N,B,_,c,A){for(const K=_.length;c<A;c++){const Q=N[c];if(B(Q,_[K-1])<0){_.pop();const ge=(0,t.$jb)(_,ve=>B(Q,ve)<0);_.splice(ge,0,Q)}}}function k(N){return N.filter(B=>!!B)}function w(N){let B=0;for(let _=0;_<N.length;_++)N[_]&&(N[B]=N[_],B+=1);N.length=B}function i(N,B,_){N.splice(_,0,N.splice(B,1)[0])}function n(N){return!Array.isArray(N)||N.length===0}function s(N){return Array.isArray(N)&&N.length>0}function m(N,B=_=>_){const _=new Set;return N.filter(c=>{const A=B(c);return _.has(A)?!1:(_.add(A),!0)})}function P(N){const B=new Set;return _=>{const c=N(_);return B.has(c)?!1:(B.add(c),!0)}}function h(N,B){return N.length>0?N[0]:B}function $(N,B){return N.length>0?N[N.length-1]:B}function l(N,B,_=(c,A)=>c===A){let c=0;for(let A=0,K=Math.min(N.length,B.length);A<K&&_(N[A],B[A]);A++)c++;return c}function o(N,B){let _=typeof B=="number"?N:0;typeof B=="number"?_=N:(_=0,B=N);const c=[];if(_<=B)for(let A=_;A<B;A++)c.push(A);else for(let A=_;A>B;A--)c.push(A);return c}function U(N,B,_){return N.reduce((c,A)=>(c[B(A)]=_?_(A):A,c),Object.create(null))}function D(N,B){return N.push(B),()=>b(N,B)}function b(N,B){const _=N.indexOf(B);if(_>-1)return N.splice(_,1),B}function G(N,B,_){const c=N.slice(0,B),A=N.slice(B);return c.concat(_,A)}function x(N,B){let _;if(typeof B=="number"){let c=B;_=()=>{const A=Math.sin(c++)*179426549;return A-Math.floor(A)}}else _=Math.random;for(let c=N.length-1;c>0;c-=1){const A=Math.floor(_()*(c+1)),K=N[c];N[c]=N[A],N[A]=K}}function Z(N,B){const _=N.indexOf(B);_>-1&&(N.splice(_,1),N.unshift(B))}function H(N,B){const _=N.indexOf(B);_>-1&&(N.splice(_,1),N.push(B))}function ce(N,B){for(const _ of B)N.push(_)}function F(N,B){return Array.isArray(N)?N.map(B):B(N)}function X(N){return Array.isArray(N)?N:[N]}function C(N){return N[Math.floor(Math.random()*N.length)]}function ee(N,B,_){const c=z(N,B),A=N.length,K=_.length;N.length=A+K;for(let Q=A-1;Q>=c;Q--)N[Q+K]=N[Q];for(let Q=0;Q<K;Q++)N[Q+c]=_[Q]}function M(N,B,_,c){const A=z(N,B);let K=N.splice(A,_);return K===void 0&&(K=[]),ee(N,A,c),K}function z(N,B){return B<0?Math.max(B+N.length,0):Math.min(B,N.length)}var V;(function(N){function B(K){return K<0}N.isLessThan=B;function _(K){return K<=0}N.isLessThanOrEqual=_;function c(K){return K>0}N.isGreaterThan=c;function A(K){return K===0}N.isNeitherLessOrGreaterThan=A,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function te(N,B){return(_,c)=>B(N(_),N(c))}function ue(...N){return(B,_)=>{for(const c of N){const A=c(B,_);if(!V.isNeitherLessOrGreaterThan(A))return A}return V.neitherLessOrGreaterThan}}const E=(N,B)=>N-B;e.$7b=E;const ne=(N,B)=>(0,e.$7b)(N?1:0,B?1:0);e.$8b=ne;function se(N){return(B,_)=>-N(B,_)}class re{constructor(B){this.g=B,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(B){let _=this.c;for(;_<this.g.length&&B(this.g[_]);)_++;const c=_===this.c?null:this.g.slice(this.c,_);return this.c=_,c}takeFromEndWhile(B){let _=this.d;for(;_>=0&&B(this.g[_]);)_--;const c=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,c}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const B=this.g[this.c];return this.c++,B}removeLast(){const B=this.g[this.d];return this.d--,B}takeCount(B){const _=this.g.slice(this.c,this.c+B);return this.c+=B,_}}e.$0b=re;class ae{static{this.empty=new ae(B=>{})}constructor(B){this.iterate=B}forEach(B){this.iterate(_=>(B(_),!0))}toArray(){const B=[];return this.iterate(_=>(B.push(_),!0)),B}filter(B){return new ae(_=>this.iterate(c=>B(c)?_(c):!0))}map(B){return new ae(_=>this.iterate(c=>_(B(c))))}some(B){let _=!1;return this.iterate(c=>(_=B(c),!_)),_}findFirst(B){let _;return this.iterate(c=>B(c)?(_=c,!1):!0),_}findLast(B){let _;return this.iterate(c=>(B(c)&&(_=c),!0)),_}findLastMaxBy(B){let _,c=!0;return this.iterate(A=>((c||V.isGreaterThan(B(A,_)))&&(c=!1,_=A),!0)),_}}e.$$b=ae;class de{constructor(B){this.c=B}static createSortPermutation(B,_){const c=Array.from(B.keys()).sort((A,K)=>_(B[A],B[K]));return new de(c)}apply(B){return B.map((_,c)=>B[this.c[c]])}inverse(){const B=this.c.slice();for(let _=0;_<this.c.length;_++)B[this.c[_]]=_;return new de(B)}}e.$_b=de;async function De(N,B){return(await Promise.all(N.map(async(c,A)=>({element:c,ok:await B(c,A)})))).find(c=>c.ok)?.element}}),define(be[23],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=a;function a(t,R){const p=this;let J=!1,O;return function(){if(J)return O;if(J=!0,R)try{O=t.apply(p,arguments)}finally{R()}else O=t.apply(p,arguments);return O}}}),define(be[31],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(t){function R(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}t.is=R;const p=Object.freeze([]);function J(){return p}t.empty=J;function*O(n){yield n}t.single=O;function L(n){return R(n)?n:O(n)}t.wrap=L;function T(n){return n||p}t.from=T;function*j(n){for(let s=n.length-1;s>=0;s--)yield n[s]}t.reverse=j;function q(n){return!n||n[Symbol.iterator]().next().done===!0}t.isEmpty=q;function I(n){return n[Symbol.iterator]().next().value}t.first=I;function W(n,s){let m=0;for(const P of n)if(s(P,m++))return!0;return!1}t.some=W;function f(n,s){for(const m of n)if(s(m))return m}t.find=f;function*r(n,s){for(const m of n)s(m)&&(yield m)}t.filter=r;function*u(n,s){let m=0;for(const P of n)yield s(P,m++)}t.map=u;function*g(n,s){let m=0;for(const P of n)yield*s(P,m++)}t.flatMap=g;function*y(...n){for(const s of n)yield*s}t.concat=y;function v(n,s,m){let P=m;for(const h of n)P=s(P,h);return P}t.reduce=v;function*k(n,s,m=n.length){for(s<0&&(s+=n.length),m<0?m+=n.length:m>n.length&&(m=n.length);s<m;s++)yield n[s]}t.slice=k;function w(n,s=Number.POSITIVE_INFINITY){const m=[];if(s===0)return[m,n];const P=n[Symbol.iterator]();for(let h=0;h<s;h++){const $=P.next();if($.done)return[m,t.empty()];m.push($.value)}return[m,{[Symbol.iterator](){return P}}]}t.consume=w;async function i(n){const s=[];for await(const m of n)s.push(m);return Promise.resolve(s)}t.asyncToArray=i})(a||(e.Iterable=a={}))}),define(be[14],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class a{constructor(R){this.d=R,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(R){this.c=R}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=a}),define(be[32],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class a{static{this.Undefined=new a(void 0)}constructor(p){this.element=p,this.next=a.Undefined,this.prev=a.Undefined}}class t{constructor(){this.a=a.Undefined,this.b=a.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===a.Undefined}clear(){let p=this.a;for(;p!==a.Undefined;){const J=p.next;p.prev=a.Undefined,p.next=a.Undefined,p=J}this.a=a.Undefined,this.b=a.Undefined,this.c=0}unshift(p){return this.d(p,!1)}push(p){return this.d(p,!0)}d(p,J){const O=new a(p);if(this.a===a.Undefined)this.a=O,this.b=O;else if(J){const T=this.b;this.b=O,O.prev=T,T.next=O}else{const T=this.a;this.a=O,O.next=T,T.prev=O}this.c+=1;let L=!1;return()=>{L||(L=!0,this.e(O))}}shift(){if(this.a!==a.Undefined){const p=this.a.element;return this.e(this.a),p}}pop(){if(this.b!==a.Undefined){const p=this.b.element;return this.e(this.b),p}}e(p){if(p.prev!==a.Undefined&&p.next!==a.Undefined){const J=p.prev;J.next=p.next,p.next.prev=J}else p.prev===a.Undefined&&p.next===a.Undefined?(this.a=a.Undefined,this.b=a.Undefined):p.next===a.Undefined?(this.b=this.b.prev,this.b.next=a.Undefined):p.prev===a.Undefined&&(this.a=this.a.next,this.a.prev=a.Undefined);this.c-=1}*[Symbol.iterator](){let p=this.a;for(;p!==a.Undefined;)yield p.element,p=p.next}}e.$5c=t}),define(be[15],Ee([0,1]),function(oe,e){"use strict";var a,t,R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=p,e.$yc=J,e.$zc=O,e.$Ic=k;function p(w,i,n){let s=w.get(i);return s===void 0&&(s=n,w.set(i,s)),s}function J(w){const i=[];return w.forEach((n,s)=>{i.push(`${s} => ${n}`)}),`Map(${w.size}) {${i.join(", ")}}`}function O(w){const i=[];return w.forEach(n=>{i.push(n)}),`Set(${w.size}) {${i.join(", ")}}`}class L{constructor(i,n){this.uri=i,this.value=n}}function T(w){return Array.isArray(w)}class j{static{this.c=i=>i.toString()}constructor(i,n){if(this[a]="ResourceMap",i instanceof j)this.d=new Map(i.d),this.e=n??j.c;else if(T(i)){this.d=new Map,this.e=n??j.c;for(const[s,m]of i)this.set(s,m)}else this.d=new Map,this.e=i??j.c}set(i,n){return this.d.set(this.e(i),new L(i,n)),this}get(i){return this.d.get(this.e(i))?.value}has(i){return this.d.has(this.e(i))}get size(){return this.d.size}clear(){this.d.clear()}delete(i){return this.d.delete(this.e(i))}forEach(i,n){typeof n<"u"&&(i=i.bind(n));for(const[s,m]of this.d)i(m.value,m.uri,this)}*values(){for(const i of this.d.values())yield i.value}*keys(){for(const i of this.d.values())yield i.uri}*entries(){for(const i of this.d.values())yield[i.uri,i.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.d)yield[i.uri,i.value]}}e.$Ac=j;class q{constructor(i,n){this[t]="ResourceSet",!i||typeof i=="function"?this.c=new j(i):(this.c=new j(n),i.forEach(this.add,this))}get size(){return this.c.size}add(i){return this.c.set(i,i),this}clear(){this.c.clear()}delete(i){return this.c.delete(i)}forEach(i,n){this.c.forEach((s,m)=>i.call(n,m,m,this))}has(i){return this.c.has(i)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=q;var I;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(I||(e.Touch=I={}));class W{constructor(){this[R]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(i){return this.c.has(i)}get(i,n=I.None){const s=this.c.get(i);if(s)return n!==I.None&&this.m(s,n),s.value}set(i,n,s=I.None){let m=this.c.get(i);if(m)m.value=n,s!==I.None&&this.m(m,s);else{switch(m={key:i,value:n,next:void 0,previous:void 0},s){case I.None:this.k(m);break;case I.AsOld:this.j(m);break;case I.AsNew:this.k(m);break;default:this.k(m);break}this.c.set(i,m),this.f++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this.c.get(i);if(n)return this.c.delete(i),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const i=this.d;return this.c.delete(i.key),this.l(i),this.f--,i.value}forEach(i,n){const s=this.g;let m=this.d;for(;m;){if(n?i.bind(n)(m.value,m.key,this):i(m.value,m.key,this),this.g!==s)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const i=this,n=this.g;let s=this.d;const m={[Symbol.iterator](){return m},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const P={value:s.key,done:!1};return s=s.next,P}else return{value:void 0,done:!0}}};return m}values(){const i=this,n=this.g;let s=this.d;const m={[Symbol.iterator](){return m},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const P={value:s.value,done:!1};return s=s.next,P}else return{value:void 0,done:!0}}};return m}entries(){const i=this,n=this.g;let s=this.d;const m={[Symbol.iterator](){return m},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const P={value:[s.key,s.value],done:!1};return s=s.next,P}else return{value:void 0,done:!0}}};return m}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this.d,s=this.size;for(;n&&s>i;)this.c.delete(n.key),n=n.next,s--;this.d=n,this.f=s,n&&(n.previous=void 0),this.g++}i(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this.e,s=this.size;for(;n&&s>i;)this.c.delete(n.key),n=n.previous,s--;this.e=n,this.f=s,n&&(n.next=void 0),this.g++}j(i){if(!this.d&&!this.e)this.e=i;else if(this.d)i.next=this.d,this.d.previous=i;else throw new Error("Invalid list");this.d=i,this.g++}k(i){if(!this.d&&!this.e)this.d=i;else if(this.e)i.previous=this.e,this.e.next=i;else throw new Error("Invalid list");this.e=i,this.g++}l(i){if(i===this.d&&i===this.e)this.d=void 0,this.e=void 0;else if(i===this.d){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.d=i.next}else if(i===this.e){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.e=i.previous}else{const n=i.next,s=i.previous;if(!n||!s)throw new Error("Invalid list");n.previous=s,s.next=n}i.next=void 0,i.previous=void 0,this.g++}m(i,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==I.AsOld&&n!==I.AsNew)){if(n===I.AsOld){if(i===this.d)return;const s=i.next,m=i.previous;i===this.e?(m.next=void 0,this.e=m):(s.previous=m,m.next=s),i.previous=void 0,i.next=this.d,this.d.previous=i,this.d=i,this.g++}else if(n===I.AsNew){if(i===this.e)return;const s=i.next,m=i.previous;i===this.d?(s.previous=void 0,this.d=s):(s.previous=m,m.next=s),i.next=void 0,i.previous=this.e,this.e.next=i,this.e=i,this.g++}}}toJSON(){const i=[];return this.forEach((n,s)=>{i.push([s,n])}),i}fromJSON(i){this.clear();for(const[n,s]of i)this.set(n,s)}}e.$Cc=W;class f extends W{constructor(i,n=1){super(),this.n=i,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(i){this.n=i,this.p()}get ratio(){return this.o}set ratio(i){this.o=Math.min(Math.max(0,i),1),this.p()}get(i,n=I.AsNew){return super.get(i,n)}peek(i){return super.get(i,I.None)}set(i,n){return super.set(i,n,I.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class r extends f{constructor(i,n=1){super(i,n)}q(i){this.h(i)}set(i,n){return super.set(i,n),this.p(),this}}e.$Dc=r;class u extends f{constructor(i,n=1){super(i,n)}q(i){this.i(i)}set(i,n){return this.n<=this.size&&!this.has(i)&&this.q(Math.round(this.n*this.o)-1),super.set(i,n),this}}e.$Ec=u;class g{constructor(){this.c=new Map}add(i){return this.c.set(i,(this.c.get(i)||0)+1),this}delete(i){let n=this.c.get(i)||0;return n===0?!1:(n--,n===0?this.c.delete(i):this.c.set(i,n),!0)}has(i){return this.c.has(i)}}e.$Fc=g;class y{constructor(i){if(this.c=new Map,this.d=new Map,i)for(const[n,s]of i)this.set(n,s)}clear(){this.c.clear(),this.d.clear()}set(i,n){this.c.set(i,n),this.d.set(n,i)}get(i){return this.c.get(i)}getKey(i){return this.d.get(i)}delete(i){const n=this.c.get(i);return n===void 0?!1:(this.c.delete(i),this.d.delete(n),!0)}forEach(i,n){this.c.forEach((s,m)=>{i.call(n,s,m,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=y;class v{constructor(){this.c=new Map}add(i,n){let s=this.c.get(i);s||(s=new Set,this.c.set(i,s)),s.add(n)}delete(i,n){const s=this.c.get(i);s&&(s.delete(n),s.size===0&&this.c.delete(i))}forEach(i,n){const s=this.c.get(i);s&&s.forEach(n)}get(i){const n=this.c.get(i);return n||new Set}}e.$Hc=v;function k(w,i){if(w===i)return!0;if(w.size!==i.size)return!1;for(const[n,s]of w)if(!i.has(n)||i.get(n)!==s)return!1;for(const[n]of i)if(!w.has(n))return!1;return!0}}),define(be[11],Ee([0,1,13,30,15,23,31]),function(oe,e,a,t,R,p,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=j,e.$Lc=q,e.$Mc=I,e.$Nc=r,e.$Oc=u,e.$Pc=g,e.$Qc=y,e.$Rc=v,e.$Sc=k,e.$3c=o;const O=!1;let L=null;class T{constructor(){this.b=new Map}static{this.a=0}c(b){let G=this.b.get(b);return G||(G={parent:null,source:null,isSingleton:!1,value:b,idx:T.a++},this.b.set(b,G)),G}trackDisposable(b){const G=this.c(b);G.source||(G.source=new Error().stack)}setParent(b,G){const x=this.c(b);x.parent=G}markAsDisposed(b){this.b.delete(b)}markAsSingleton(b){this.c(b).isSingleton=!0}f(b,G){const x=G.get(b);if(x)return x;const Z=b.parent?this.f(this.c(b.parent),G):b;return G.set(b,Z),Z}getTrackedDisposables(){const b=new Map;return[...this.b.entries()].filter(([,x])=>x.source!==null&&!this.f(x,b).isSingleton).flatMap(([x])=>x)}computeLeakingDisposables(b=10,G){let x;if(G)x=G;else{const X=new Map,C=[...this.b.values()].filter(M=>M.source!==null&&!this.f(M,X).isSingleton);if(C.length===0)return;const ee=new Set(C.map(M=>M.value));if(x=C.filter(M=>!(M.parent&&ee.has(M.parent))),x.length===0)throw new Error("There are cyclic diposable chains!")}if(!x)return;function Z(X){function C(M,z){for(;M.length>0&&z.some(V=>typeof V=="string"?V===M[0]:M[0].match(V));)M.shift()}const ee=X.source.split(`
`).map(M=>M.trim().replace("at ","")).filter(M=>M!=="");return C(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const H=new R.$Hc;for(const X of x){const C=Z(X);for(let ee=0;ee<=C.length;ee++)H.add(C.slice(0,ee).join(`
`),X)}x.sort((0,a.$5b)(X=>X.idx,a.$7b));let ce="",F=0;for(const X of x.slice(0,b)){F++;const C=Z(X),ee=[];for(let M=0;M<C.length;M++){let z=C[M];z=`(shared with ${H.get(C.slice(0,M+1).join(`
`)).size}/${x.length} leaks) at ${z}`;const te=H.get(C.slice(0,M).join(`
`)),ue=(0,t.$c)([...te].map(E=>Z(E)[M]),E=>E);delete ue[C[M]];for(const[E,ne]of Object.entries(ue))ee.unshift(`    - stacktraces of ${ne.length} other leaks continue with ${E}`);ee.unshift(z)}ce+=`


==================== Leaking disposable ${F}/${x.length}: ${X.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return x.length>b&&(ce+=`


... and ${x.length-b} more leaking disposables

`),{leaks:x,details:ce}}}e.$Jc=T;function j(D){L=D}if(O){const D="__is_disposable_tracked__";j(new class{trackDisposable(b){const G=new Error("Potentially leaked disposable").stack;setTimeout(()=>{b[D]||console.log(G)},3e3)}setParent(b,G){if(b&&b!==i.None)try{b[D]=!0}catch{}}markAsDisposed(b){if(b&&b!==i.None)try{b[D]=!0}catch{}}markAsSingleton(b){}})}function q(D){return L?.trackDisposable(D),D}function I(D){L?.markAsDisposed(D)}function W(D,b){L?.setParent(D,b)}function f(D,b){if(L)for(const G of D)L.setParent(G,b)}function r(D){return L?.markAsSingleton(D),D}function u(D){return typeof D=="object"&&D!==null&&typeof D.dispose=="function"&&D.dispose.length===0}function g(D){if(J.Iterable.is(D)){const b=[];for(const G of D)if(G)try{G.dispose()}catch(x){b.push(x)}if(b.length===1)throw b[0];if(b.length>1)throw new AggregateError(b,"Encountered errors while disposing of store");return Array.isArray(D)?[]:D}else if(D)return D.dispose(),D}function y(D){for(const b of D)u(b)&&b.dispose();return[]}function v(...D){const b=k(()=>g(D));return f(D,b),b}function k(D){const b=q({dispose:(0,p.$cb)(()=>{I(b),D()})});return b}class w{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,q(this)}dispose(){this.g||(I(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(b){if(!b)return b;if(b===this)throw new Error("Cannot register a disposable on itself!");return W(b,this),this.g?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(b),b}delete(b){if(b){if(b===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(b),b.dispose()}}deleteAndLeak(b){b&&this.f.has(b)&&(this.f.delete(b),W(b,null))}}e.$Tc=w;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new w,q(this),W(this.q,this)}dispose(){I(this),this.q.dispose()}B(b){if(b===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(b)}}e.$Uc=i;class n{constructor(){this.b=!1,q(this)}get value(){return this.b?void 0:this.a}set value(b){this.b||b===this.a||(this.a?.dispose(),b&&W(b,this),this.a=b)}clear(){this.value=void 0}dispose(){this.b=!0,I(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const b=this.a;return this.a=void 0,b&&W(b,null),b}}e.$Vc=n;class s{constructor(b){this.a=new n,this.b=!1,this.a.value=b}get value(){return this.a.value}set value(b){this.b||b===this.a.value||(this.a.value=b)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=s;class m{constructor(b){this.b=b,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=m;class P{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,q(this)}set(b){let G=b;return this.unset=()=>G=void 0,this.isset=()=>G!==void 0,this.dispose=()=>{G&&(G(),G=void 0,I(this))},this}}e.$Yc=P;class h{constructor(){this.a=new Map}acquire(b,...G){let x=this.a.get(b);x||(x={counter:0,object:this.b(b,...G)},this.a.set(b,x));const{object:Z}=x,H=(0,p.$cb)(()=>{--x.counter===0&&(this.c(b,x.object),this.a.delete(b))});return x.counter++,{object:Z,dispose:H}}}e.$Zc=h;class ${constructor(b){this.a=b}async acquire(b,...G){const x=this.a.acquire(b,...G);try{return{object:await x.object,dispose:()=>x.dispose()}}catch(Z){throw x.dispose(),Z}}}e.$1c=$;class l{constructor(b){this.object=b}dispose(){}}e.$2c=l;function o(D){const b=new w;try{D(b)}finally{b.dispose()}}class U{constructor(){this.a=new Map,this.b=!1,q(this)}dispose(){I(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(b){return this.a.has(b)}get size(){return this.a.size}get(b){return this.a.get(b)}set(b,G,x=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),x||this.a.get(b)?.dispose(),this.a.set(b,G)}deleteAndDispose(b){this.a.get(b)?.dispose(),this.a.delete(b)}deleteAndLeak(b){const G=this.a.get(b);return this.a.delete(b),G}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=U}),define(be[33],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var a;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(a||(e.MarshalledId=a={}))}),define(be[24],Ee([0,1,15]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=void 0,e.$nm=R,e.$om=J;const t=new a.$Dc(1e4);function R(T){return L(T,"NFC",t)}const p=new a.$Dc(1e4);function J(T){return L(T,"NFD",p)}const O=/[^\u0000-\u0080]/;function L(T,j,q){if(!T)return T;const I=q.get(T);if(I)return I;let W;return O.test(T)?W=T.normalize(j):W=T,q.set(T,W),W}e.$pm=function(){const T=/[\u0300-\u036f]/g;return function(j){return J(j).replace(T,"")}}()}),define(be[2],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=i,e.$E=$,e.$K=l,e.$h="en";let a=!1,t=!1,R=!1,p=!1,J=!1,O=!1,L=!1,T=!1,j=!1,q=!1,I,W=e.$h,f=e.$h,r,u;const g=globalThis;let y;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?y=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(y=process);const v=typeof y?.versions?.electron=="string",k=v&&y?.type==="renderer";if(typeof y=="object"){a=y.platform==="win32",t=y.platform==="darwin",R=y.platform==="linux",p=R&&!!y.env.SNAP&&!!y.env.SNAP_REVISION,L=v,j=!!y.env.CI||!!y.env.BUILD_ARTIFACTSTAGINGDIRECTORY,I=e.$h,W=e.$h;const o=y.env.VSCODE_NLS_CONFIG;if(o)try{const U=JSON.parse(o);I=U.userLocale,f=U.osLocale,W=U.resolvedLanguage||e.$h,r=U.languagePack?.translationsConfigFile}catch{}J=!0}else typeof navigator=="object"&&!k?(u=navigator.userAgent,a=u.indexOf("Windows")>=0,t=u.indexOf("Macintosh")>=0,T=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=u.indexOf("Linux")>=0,q=u?.indexOf("Mobi")>=0,O=!0,W=globalThis._VSCODE_NLS_LANGUAGE||e.$h,I=navigator.language.toLowerCase(),f=I):console.error("Unable to resolve platform.");var w;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(w||(e.Platform=w={}));function i(o){switch(o){case w.Web:return"Web";case w.Mac:return"Mac";case w.Linux:return"Linux";case w.Windows:return"Windows"}}let n=w.Web;t?n=w.Mac:a?n=w.Windows:R&&(n=w.Linux),e.$j=a,e.$k=t,e.$l=R,e.$m=p,e.$n=J,e.$o=L,e.$p=O,e.$q=O&&typeof g.importScripts=="function",e.$r=e.$q?g.origin:void 0,e.$s=T,e.$t=q,e.$u=j,e.$v=n,e.$w=u,e.$x=W;var s;(function(o){function U(){return e.$x}o.value=U;function D(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}o.isDefaultVariant=D;function b(){return e.$x==="en"}o.isDefault=b})(s||(e.Language=s={})),e.$y=I,e.$z=f,e.$A=r,e.$B=typeof g.postMessage=="function"&&!g.importScripts,e.$C=(()=>{if(e.$B){const o=[];g.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let b=0,G=o.length;b<G;b++){const x=o[b];if(x.id===D.data.vscodeScheduleAsyncWork){o.splice(b,1),x.callback();return}}});let U=0;return D=>{const b=++U;o.push({id:b,callback:D}),g.postMessage({vscodeScheduleAsyncWork:b},"*")}}return o=>setTimeout(o)})();var m;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(m||(e.OperatingSystem=m={})),e.OS=t||T?m.Macintosh:a?m.Windows:m.Linux;let P=!0,h=!1;function $(){if(!h){h=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,P=new Uint16Array(o.buffer)[0]===513}return P}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function l(o){return parseFloat(o)>=20}}),define(be[34],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FX=a;function a(){return 1025+Math.floor(64510*Math.random())}}),define(be[16],Ee([0,1,2]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let t;const R=globalThis.vscode;if(typeof R<"u"&&typeof R.process<"u"){const p=R.process;t={get platform(){return p.platform},get arch(){return p.arch},get env(){return p.env},cwd(){return p.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return a.$j?"win32":a.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.$dc=t.platform,e.$ec=t.arch});var Je=this&&this.__createBinding||(Object.create?function(oe,e,a,t){t===void 0&&(t=a);var R=Object.getOwnPropertyDescriptor(e,a);(!R||("get"in R?!e.__esModule:R.writable||R.configurable))&&(R={enumerable:!0,get:function(){return e[a]}}),Object.defineProperty(oe,t,R)}:function(oe,e,a,t){t===void 0&&(t=a),oe[t]=e[a]}),Qe=this&&this.__setModuleDefault||(Object.create?function(oe,e){Object.defineProperty(oe,"default",{enumerable:!0,value:e})}:function(oe,e){oe.default=e}),pe=this&&this.__importStar||function(oe){if(oe&&oe.__esModule)return oe;var e={};if(oe!=null)for(var a in oe)a!=="default"&&Object.prototype.hasOwnProperty.call(oe,a)&&Je(e,oe,a);return Qe(e,oe),e};define(be[3],Ee([0,1,16]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0,a=pe(a);const t=65,R=97,p=90,J=122,O=46,L=47,T=92,j=58,q=63;class I extends Error{constructor(s,m,P){let h;typeof m=="string"&&m.indexOf("not ")===0?(h="must not be",m=m.replace(/^not /,"")):h="must be";const $=s.indexOf(".")!==-1?"property":"argument";let l=`The "${s}" ${$} ${h} of type ${m}`;l+=`. Received type ${typeof P}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function W(n,s){if(n===null||typeof n!="object")throw new I(s,"Object",n)}function f(n,s){if(typeof n!="string")throw new I(s,"string",n)}const r=a.$dc==="win32";function u(n){return n===L||n===T}function g(n){return n===L}function y(n){return n>=t&&n<=p||n>=R&&n<=J}function v(n,s,m,P){let h="",$=0,l=-1,o=0,U=0;for(let D=0;D<=n.length;++D){if(D<n.length)U=n.charCodeAt(D);else{if(P(U))break;U=L}if(P(U)){if(!(l===D-1||o===1))if(o===2){if(h.length<2||$!==2||h.charCodeAt(h.length-1)!==O||h.charCodeAt(h.length-2)!==O){if(h.length>2){const b=h.lastIndexOf(m);b===-1?(h="",$=0):(h=h.slice(0,b),$=h.length-1-h.lastIndexOf(m)),l=D,o=0;continue}else if(h.length!==0){h="",$=0,l=D,o=0;continue}}s&&(h+=h.length>0?`${m}..`:"..",$=2)}else h.length>0?h+=`${m}${n.slice(l+1,D)}`:h=n.slice(l+1,D),$=D-l-1;l=D,o=0}else U===O&&o!==-1?++o:o=-1}return h}function k(n){return n?`${n[0]==="."?"":"."}${n}`:""}function w(n,s){W(s,"pathObject");const m=s.dir||s.root,P=s.base||`${s.name||""}${k(s.ext)}`;return m?m===s.root?`${m}${P}`:`${m}${n}${P}`:P}e.$fc={resolve(...n){let s="",m="",P=!1;for(let h=n.length-1;h>=-1;h--){let $;if(h>=0){if($=n[h],f($,`paths[${h}]`),$.length===0)continue}else s.length===0?$=a.cwd():($=a.env[`=${s}`]||a.cwd(),($===void 0||$.slice(0,2).toLowerCase()!==s.toLowerCase()&&$.charCodeAt(2)===T)&&($=`${s}\\`));const l=$.length;let o=0,U="",D=!1;const b=$.charCodeAt(0);if(l===1)u(b)&&(o=1,D=!0);else if(u(b))if(D=!0,u($.charCodeAt(1))){let G=2,x=G;for(;G<l&&!u($.charCodeAt(G));)G++;if(G<l&&G!==x){const Z=$.slice(x,G);for(x=G;G<l&&u($.charCodeAt(G));)G++;if(G<l&&G!==x){for(x=G;G<l&&!u($.charCodeAt(G));)G++;(G===l||G!==x)&&(U=`\\\\${Z}\\${$.slice(x,G)}`,o=G)}}}else o=1;else y(b)&&$.charCodeAt(1)===j&&(U=$.slice(0,2),o=2,l>2&&u($.charCodeAt(2))&&(D=!0,o=3));if(U.length>0)if(s.length>0){if(U.toLowerCase()!==s.toLowerCase())continue}else s=U;if(P){if(s.length>0)break}else if(m=`${$.slice(o)}\\${m}`,P=D,D&&s.length>0)break}return m=v(m,!P,"\\",u),P?`${s}\\${m}`:`${s}${m}`||"."},normalize(n){f(n,"path");const s=n.length;if(s===0)return".";let m=0,P,h=!1;const $=n.charCodeAt(0);if(s===1)return g($)?"\\":n;if(u($))if(h=!0,u(n.charCodeAt(1))){let o=2,U=o;for(;o<s&&!u(n.charCodeAt(o));)o++;if(o<s&&o!==U){const D=n.slice(U,o);for(U=o;o<s&&u(n.charCodeAt(o));)o++;if(o<s&&o!==U){for(U=o;o<s&&!u(n.charCodeAt(o));)o++;if(o===s)return`\\\\${D}\\${n.slice(U)}\\`;o!==U&&(P=`\\\\${D}\\${n.slice(U,o)}`,m=o)}}}else m=1;else y($)&&n.charCodeAt(1)===j&&(P=n.slice(0,2),m=2,s>2&&u(n.charCodeAt(2))&&(h=!0,m=3));let l=m<s?v(n.slice(m),!h,"\\",u):"";return l.length===0&&!h&&(l="."),l.length>0&&u(n.charCodeAt(s-1))&&(l+="\\"),P===void 0?h?`\\${l}`:l:h?`${P}\\${l}`:`${P}${l}`},isAbsolute(n){f(n,"path");const s=n.length;if(s===0)return!1;const m=n.charCodeAt(0);return u(m)||s>2&&y(m)&&n.charCodeAt(1)===j&&u(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,m;for(let $=0;$<n.length;++$){const l=n[$];f(l,"path"),l.length>0&&(s===void 0?s=m=l:s+=`\\${l}`)}if(s===void 0)return".";let P=!0,h=0;if(typeof m=="string"&&u(m.charCodeAt(0))){++h;const $=m.length;$>1&&u(m.charCodeAt(1))&&(++h,$>2&&(u(m.charCodeAt(2))?++h:P=!1))}if(P){for(;h<s.length&&u(s.charCodeAt(h));)h++;h>=2&&(s=`\\${s.slice(h)}`)}return e.$fc.normalize(s)},relative(n,s){if(f(n,"from"),f(s,"to"),n===s)return"";const m=e.$fc.resolve(n),P=e.$fc.resolve(s);if(m===P||(n=m.toLowerCase(),s=P.toLowerCase(),n===s))return"";let h=0;for(;h<n.length&&n.charCodeAt(h)===T;)h++;let $=n.length;for(;$-1>h&&n.charCodeAt($-1)===T;)$--;const l=$-h;let o=0;for(;o<s.length&&s.charCodeAt(o)===T;)o++;let U=s.length;for(;U-1>o&&s.charCodeAt(U-1)===T;)U--;const D=U-o,b=l<D?l:D;let G=-1,x=0;for(;x<b;x++){const H=n.charCodeAt(h+x);if(H!==s.charCodeAt(o+x))break;H===T&&(G=x)}if(x!==b){if(G===-1)return P}else{if(D>b){if(s.charCodeAt(o+x)===T)return P.slice(o+x+1);if(x===2)return P.slice(o+x)}l>b&&(n.charCodeAt(h+x)===T?G=x:x===2&&(G=3)),G===-1&&(G=0)}let Z="";for(x=h+G+1;x<=$;++x)(x===$||n.charCodeAt(x)===T)&&(Z+=Z.length===0?"..":"\\..");return o+=G,Z.length>0?`${Z}${P.slice(o,U)}`:(P.charCodeAt(o)===T&&++o,P.slice(o,U))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=e.$fc.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===T){if(s.charCodeAt(1)===T){const m=s.charCodeAt(2);if(m!==q&&m!==O)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(y(s.charCodeAt(0))&&s.charCodeAt(1)===j&&s.charCodeAt(2)===T)return`\\\\?\\${s}`;return n},dirname(n){f(n,"path");const s=n.length;if(s===0)return".";let m=-1,P=0;const h=n.charCodeAt(0);if(s===1)return u(h)?n:".";if(u(h)){if(m=P=1,u(n.charCodeAt(1))){let o=2,U=o;for(;o<s&&!u(n.charCodeAt(o));)o++;if(o<s&&o!==U){for(U=o;o<s&&u(n.charCodeAt(o));)o++;if(o<s&&o!==U){for(U=o;o<s&&!u(n.charCodeAt(o));)o++;if(o===s)return n;o!==U&&(m=P=o+1)}}}}else y(h)&&n.charCodeAt(1)===j&&(m=s>2&&u(n.charCodeAt(2))?3:2,P=m);let $=-1,l=!0;for(let o=s-1;o>=P;--o)if(u(n.charCodeAt(o))){if(!l){$=o;break}}else l=!1;if($===-1){if(m===-1)return".";$=m}return n.slice(0,$)},basename(n,s){s!==void 0&&f(s,"suffix"),f(n,"path");let m=0,P=-1,h=!0,$;if(n.length>=2&&y(n.charCodeAt(0))&&n.charCodeAt(1)===j&&(m=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let l=s.length-1,o=-1;for($=n.length-1;$>=m;--$){const U=n.charCodeAt($);if(u(U)){if(!h){m=$+1;break}}else o===-1&&(h=!1,o=$+1),l>=0&&(U===s.charCodeAt(l)?--l===-1&&(P=$):(l=-1,P=o))}return m===P?P=o:P===-1&&(P=n.length),n.slice(m,P)}for($=n.length-1;$>=m;--$)if(u(n.charCodeAt($))){if(!h){m=$+1;break}}else P===-1&&(h=!1,P=$+1);return P===-1?"":n.slice(m,P)},extname(n){f(n,"path");let s=0,m=-1,P=0,h=-1,$=!0,l=0;n.length>=2&&n.charCodeAt(1)===j&&y(n.charCodeAt(0))&&(s=P=2);for(let o=n.length-1;o>=s;--o){const U=n.charCodeAt(o);if(u(U)){if(!$){P=o+1;break}continue}h===-1&&($=!1,h=o+1),U===O?m===-1?m=o:l!==1&&(l=1):m!==-1&&(l=-1)}return m===-1||h===-1||l===0||l===1&&m===h-1&&m===P+1?"":n.slice(m,h)},format:w.bind(null,"\\"),parse(n){f(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const m=n.length;let P=0,h=n.charCodeAt(0);if(m===1)return u(h)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if(u(h)){if(P=1,u(n.charCodeAt(1))){let G=2,x=G;for(;G<m&&!u(n.charCodeAt(G));)G++;if(G<m&&G!==x){for(x=G;G<m&&u(n.charCodeAt(G));)G++;if(G<m&&G!==x){for(x=G;G<m&&!u(n.charCodeAt(G));)G++;G===m?P=G:G!==x&&(P=G+1)}}}}else if(y(h)&&n.charCodeAt(1)===j){if(m<=2)return s.root=s.dir=n,s;if(P=2,u(n.charCodeAt(2))){if(m===3)return s.root=s.dir=n,s;P=3}}P>0&&(s.root=n.slice(0,P));let $=-1,l=P,o=-1,U=!0,D=n.length-1,b=0;for(;D>=P;--D){if(h=n.charCodeAt(D),u(h)){if(!U){l=D+1;break}continue}o===-1&&(U=!1,o=D+1),h===O?$===-1?$=D:b!==1&&(b=1):$!==-1&&(b=-1)}return o!==-1&&($===-1||b===0||b===1&&$===o-1&&$===l+1?s.base=s.name=n.slice(l,o):(s.name=n.slice(l,$),s.base=n.slice(l,o),s.ext=n.slice($,o))),l>0&&l!==P?s.dir=n.slice(0,l-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(r){const n=/\\/g;return()=>{const s=a.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>a.cwd()})();e.$gc={resolve(...n){let s="",m=!1;for(let P=n.length-1;P>=-1&&!m;P--){const h=P>=0?n[P]:i();f(h,`paths[${P}]`),h.length!==0&&(s=`${h}/${s}`,m=h.charCodeAt(0)===L)}return s=v(s,!m,"/",g),m?`/${s}`:s.length>0?s:"."},normalize(n){if(f(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===L,m=n.charCodeAt(n.length-1)===L;return n=v(n,!s,"/",g),n.length===0?s?"/":m?"./":".":(m&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return f(n,"path"),n.length>0&&n.charCodeAt(0)===L},join(...n){if(n.length===0)return".";let s;for(let m=0;m<n.length;++m){const P=n[m];f(P,"path"),P.length>0&&(s===void 0?s=P:s+=`/${P}`)}return s===void 0?".":e.$gc.normalize(s)},relative(n,s){if(f(n,"from"),f(s,"to"),n===s||(n=e.$gc.resolve(n),s=e.$gc.resolve(s),n===s))return"";const m=1,P=n.length,h=P-m,$=1,l=s.length-$,o=h<l?h:l;let U=-1,D=0;for(;D<o;D++){const G=n.charCodeAt(m+D);if(G!==s.charCodeAt($+D))break;G===L&&(U=D)}if(D===o)if(l>o){if(s.charCodeAt($+D)===L)return s.slice($+D+1);if(D===0)return s.slice($+D)}else h>o&&(n.charCodeAt(m+D)===L?U=D:D===0&&(U=0));let b="";for(D=m+U+1;D<=P;++D)(D===P||n.charCodeAt(D)===L)&&(b+=b.length===0?"..":"/..");return`${b}${s.slice($+U)}`},toNamespacedPath(n){return n},dirname(n){if(f(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===L;let m=-1,P=!0;for(let h=n.length-1;h>=1;--h)if(n.charCodeAt(h)===L){if(!P){m=h;break}}else P=!1;return m===-1?s?"/":".":s&&m===1?"//":n.slice(0,m)},basename(n,s){s!==void 0&&f(s,"ext"),f(n,"path");let m=0,P=-1,h=!0,$;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let l=s.length-1,o=-1;for($=n.length-1;$>=0;--$){const U=n.charCodeAt($);if(U===L){if(!h){m=$+1;break}}else o===-1&&(h=!1,o=$+1),l>=0&&(U===s.charCodeAt(l)?--l===-1&&(P=$):(l=-1,P=o))}return m===P?P=o:P===-1&&(P=n.length),n.slice(m,P)}for($=n.length-1;$>=0;--$)if(n.charCodeAt($)===L){if(!h){m=$+1;break}}else P===-1&&(h=!1,P=$+1);return P===-1?"":n.slice(m,P)},extname(n){f(n,"path");let s=-1,m=0,P=-1,h=!0,$=0;for(let l=n.length-1;l>=0;--l){const o=n.charCodeAt(l);if(o===L){if(!h){m=l+1;break}continue}P===-1&&(h=!1,P=l+1),o===O?s===-1?s=l:$!==1&&($=1):s!==-1&&($=-1)}return s===-1||P===-1||$===0||$===1&&s===P-1&&s===m+1?"":n.slice(s,P)},format:w.bind(null,"/"),parse(n){f(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const m=n.charCodeAt(0)===L;let P;m?(s.root="/",P=1):P=0;let h=-1,$=0,l=-1,o=!0,U=n.length-1,D=0;for(;U>=P;--U){const b=n.charCodeAt(U);if(b===L){if(!o){$=U+1;break}continue}l===-1&&(o=!1,l=U+1),b===O?h===-1?h=U:D!==1&&(D=1):h!==-1&&(D=-1)}if(l!==-1){const b=$===0&&m?1:$;h===-1||D===0||D===1&&h===l-1&&h===$+1?s.base=s.name=n.slice(b,l):(s.name=n.slice(b,h),s.base=n.slice(b,l),s.ext=n.slice(h,l))}return $>0?s.dir=n.slice(0,$-1):m&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=r?e.$fc.normalize:e.$gc.normalize,e.$ic=r?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=r?e.$fc.join:e.$gc.join,e.$kc=r?e.$fc.resolve:e.$gc.resolve,e.$lc=r?e.$fc.relative:e.$gc.relative,e.$mc=r?e.$fc.dirname:e.$gc.dirname,e.$nc=r?e.$fc.basename:e.$gc.basename,e.$oc=r?e.$fc.extname:e.$gc.extname,e.$pc=r?e.$fc.format:e.$gc.format,e.$qc=r?e.$fc.parse:e.$gc.parse,e.$rc=r?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=r?e.$fc.sep:e.$gc.sep,e.$tc=r?e.$fc.delimiter:e.$gc.delimiter}),define(be[35],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=void 0;const a=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(p){return new t(p)}constructor(p){this.c=a&&p===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$fe=t}),define(be[17],Ee([0,1,10,23,11,32,35]),function(oe,e,a,t,R,p,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$he=e.Event=void 0,e.$ie=W;const O=!1,L=!1,T=!1;var j;(function(Z){Z.None=()=>R.$Uc.None;function H(fe){if(T){const{onDidAddListener:le}=fe,$e=r.create();let he=0;fe.onDidAddListener=()=>{++he===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),le?.()}}}function ce(fe,le){return E(fe,()=>{},0,void 0,!0,void 0,le)}Z.defer=ce;function F(fe){return(le,$e=null,he)=>{let _e=!1,ye;return ye=fe(Le=>{if(!_e)return ye?ye.dispose():_e=!0,le.call($e,Le)},null,he),_e&&ye.dispose(),ye}}Z.once=F;function X(fe,le,$e){return te((he,_e=null,ye)=>fe(Le=>he.call(_e,le(Le)),null,ye),$e)}Z.map=X;function C(fe,le,$e){return te((he,_e=null,ye)=>fe(Le=>{le(Le),he.call(_e,Le)},null,ye),$e)}Z.forEach=C;function ee(fe,le,$e){return te((he,_e=null,ye)=>fe(Le=>le(Le)&&he.call(_e,Le),null,ye),$e)}Z.filter=ee;function M(fe){return fe}Z.signal=M;function z(...fe){return(le,$e=null,he)=>{const _e=(0,R.$Rc)(...fe.map(ye=>ye(Le=>le.call($e,Le))));return ue(_e,he)}}Z.any=z;function V(fe,le,$e,he){let _e=$e;return X(fe,ye=>(_e=le(_e,ye),_e),he)}Z.reduce=V;function te(fe,le){let $e;const he={onWillAddFirstListener(){$e=fe(_e.fire,_e)},onDidRemoveLastListener(){$e?.dispose()}};le||H(he);const _e=new n(he);return le?.add(_e),_e.event}function ue(fe,le){return le instanceof Array?le.push(fe):le&&le.add(fe),fe}function E(fe,le,$e=100,he=!1,_e=!1,ye,Le){let Te,Oe,ke,we=0,Se;const He={leakWarningThreshold:ye,onWillAddFirstListener(){Te=fe(Ke=>{we++,Oe=le(Oe,Ke),he&&!ke&&(je.fire(Oe),Oe=void 0),Se=()=>{const Xe=Oe;Oe=void 0,ke=void 0,(!he||we>1)&&je.fire(Xe),we=0},typeof $e=="number"?(clearTimeout(ke),ke=setTimeout(Se,$e)):ke===void 0&&(ke=0,queueMicrotask(Se))})},onWillRemoveListener(){_e&&we>0&&Se?.()},onDidRemoveLastListener(){Se=void 0,Te.dispose()}};Le||H(He);const je=new n(He);return Le?.add(je),je.event}Z.debounce=E;function ne(fe,le=0,$e){return Z.debounce(fe,(he,_e)=>he?(he.push(_e),he):[_e],le,void 0,!0,void 0,$e)}Z.accumulate=ne;function se(fe,le=(he,_e)=>he===_e,$e){let he=!0,_e;return ee(fe,ye=>{const Le=he||!le(ye,_e);return he=!1,_e=ye,Le},$e)}Z.latch=se;function re(fe,le,$e){return[Z.filter(fe,le,$e),Z.filter(fe,he=>!le(he),$e)]}Z.split=re;function ae(fe,le=!1,$e=[],he){let _e=$e.slice(),ye=fe(Oe=>{_e?_e.push(Oe):Te.fire(Oe)});he&&he.add(ye);const Le=()=>{_e?.forEach(Oe=>Te.fire(Oe)),_e=null},Te=new n({onWillAddFirstListener(){ye||(ye=fe(Oe=>Te.fire(Oe)),he&&he.add(ye))},onDidAddFirstListener(){_e&&(le?setTimeout(Le):Le())},onDidRemoveLastListener(){ye&&ye.dispose(),ye=null}});return he&&he.add(Te),Te.event}Z.buffer=ae;function de(fe,le){return(he,_e,ye)=>{const Le=le(new N);return fe(function(Te){const Oe=Le.evaluate(Te);Oe!==De&&he.call(_e,Oe)},void 0,ye)}}Z.chain=de;const De=Symbol("HaltChainable");class N{constructor(){this.f=[]}map(le){return this.f.push(le),this}forEach(le){return this.f.push($e=>(le($e),$e)),this}filter(le){return this.f.push($e=>le($e)?$e:De),this}reduce(le,$e){let he=$e;return this.f.push(_e=>(he=le(he,_e),he)),this}latch(le=($e,he)=>$e===he){let $e=!0,he;return this.f.push(_e=>{const ye=$e||!le(_e,he);return $e=!1,he=_e,ye?_e:De}),this}evaluate(le){for(const $e of this.f)if(le=$e(le),le===De)break;return le}}function B(fe,le,$e=he=>he){const he=(...Te)=>Le.fire($e(...Te)),_e=()=>fe.on(le,he),ye=()=>fe.removeListener(le,he),Le=new n({onWillAddFirstListener:_e,onDidRemoveLastListener:ye});return Le.event}Z.fromNodeEventEmitter=B;function _(fe,le,$e=he=>he){const he=(...Te)=>Le.fire($e(...Te)),_e=()=>fe.addEventListener(le,he),ye=()=>fe.removeEventListener(le,he),Le=new n({onWillAddFirstListener:_e,onDidRemoveLastListener:ye});return Le.event}Z.fromDOMEventEmitter=_;function c(fe){return new Promise(le=>F(fe)(le))}Z.toPromise=c;function A(fe){const le=new n;return fe.then($e=>{le.fire($e)},()=>{le.fire(void 0)}).finally(()=>{le.dispose()}),le.event}Z.fromPromise=A;function K(fe,le){return fe($e=>le.fire($e))}Z.forward=K;function Q(fe,le,$e){return le($e),fe(he=>le(he))}Z.runAndSubscribe=Q;class ge{constructor(le,$e){this._observable=le,this.f=0,this.g=!1;const he={onWillAddFirstListener:()=>{le.addObserver(this)},onDidRemoveLastListener:()=>{le.removeObserver(this)}};$e||H(he),this.emitter=new n(he),$e&&$e.add(this.emitter)}beginUpdate(le){this.f++}handlePossibleChange(le){}handleChange(le,$e){this.g=!0}endUpdate(le){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ve(fe,le){return new ge(fe,le).emitter.event}Z.fromObservable=ve;function Re(fe){return(le,$e,he)=>{let _e=0,ye=!1;const Le={beginUpdate(){_e++},endUpdate(){_e--,_e===0&&(fe.reportChanges(),ye&&(ye=!1,le.call($e)))},handlePossibleChange(){},handleChange(){ye=!0}};fe.addObserver(Le),fe.reportChanges();const Te={dispose(){fe.removeObserver(Le)}};return he instanceof R.$Tc?he.add(Te):Array.isArray(he)&&he.push(Te),Te}}Z.fromObservableLight=Re})(j||(e.Event=j={}));class q{static{this.all=new Set}static{this.f=0}constructor(H){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${H}_${q.f++}`,q.all.add(this)}start(H){this.g=new J.$fe,this.listenerCount=H}stop(){if(this.g){const H=this.g.elapsed();this.durations.push(H),this.elapsedOverall+=H,this.invocationCount+=1,this.g=void 0}}}e.$he=q;let I=-1;function W(Z){const H=I;return I=Z,{dispose(){I=H}}}class f{static{this.f=1}constructor(H,ce,F=(f.f++).toString(16).padStart(3,"0")){this.j=H,this.threshold=ce,this.name=F,this.h=0}dispose(){this.g?.clear()}check(H,ce){const F=this.threshold;if(F<=0||ce<F)return;this.g||(this.g=new Map);const X=this.g.get(H.value)||0;if(this.g.set(H.value,X+1),this.h-=1,this.h<=0){this.h=F*.5;const[C,ee]=this.getMostFrequentStack(),M=`[${this.name}] potential listener LEAK detected, having ${ce} listeners already. MOST frequent listener (${ee}):`;console.warn(M),console.warn(C);const z=new u(M,C);this.j(z)}return()=>{const C=this.g.get(H.value)||0;this.g.set(H.value,C-1)}}getMostFrequentStack(){if(!this.g)return;let H,ce=0;for(const[F,X]of this.g)(!H||ce<X)&&(H=[F,X],ce=X);return H}}class r{static create(){const H=new Error;return new r(H.stack??"")}constructor(H){this.value=H}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class u extends Error{constructor(H,ce){super(H),this.name="ListenerLeakError",this.stack=ce}}e.$je=u;class g extends Error{constructor(H,ce){super(H),this.name="ListenerRefusalError",this.stack=ce}}e.$ke=g;let y=0;class v{constructor(H){this.value=H,this.id=y++}}const k=2,w=(Z,H)=>{if(Z instanceof v)H(Z);else for(let ce=0;ce<Z.length;ce++){const F=Z[ce];F&&H(F)}};let i;if(O){const Z=[];setInterval(()=>{Z.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(Z.join(`
`)),Z.length=0)},3e3),i=new FinalizationRegistry(H=>{typeof H=="string"&&Z.push(H)})}class n{constructor(H){this.z=0,this.f=H,this.g=I>0||this.f?.leakWarningThreshold?new f(H?.onListenerError??a.$Y,this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new q(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(L){const H=this.u;queueMicrotask(()=>{w(H,ce=>ce.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(H,ce,F)=>{if(this.g&&this.z>this.g.threshold**2){const z=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(z);const V=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],te=new g(`${z}. HINT: Stack shows most frequent listener (${V[1]}-times)`,V[0]);return(this.f?.onListenerError||a.$Y)(te),R.$Uc.None}if(this.m)return R.$Uc.None;ce&&(H=H.bind(ce));const X=new v(H);let C,ee;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(X.stack=r.create(),C=this.g.check(X.stack,this.z+1)),L&&(X.stack=ee??r.create()),this.u?this.u instanceof v?(this.w??=new m,this.u=[this.u,X]):this.u.push(X):(this.f?.onWillAddFirstListener?.(this),this.u=X,this.f?.onDidAddFirstListener?.(this)),this.z++;const M=(0,R.$Sc)(()=>{i?.unregister(M),C?.(),this.A(X)});if(F instanceof R.$Tc?F.add(M):Array.isArray(F)&&F.push(M),i){const z=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),V=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(z);i.register(M,V?.[2]??z,M)}return M},this.q}A(H){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const ce=this.u,F=ce.indexOf(H);if(F===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,ce[F]=void 0;const X=this.w.current===this;if(this.z*k<=ce.length){let C=0;for(let ee=0;ee<ce.length;ee++)ce[ee]?ce[C++]=ce[ee]:X&&(this.w.end--,C<this.w.i&&this.w.i--);ce.length=C}}B(H,ce){if(!H)return;const F=this.f?.onListenerError||a.$Y;if(!F){H.value(ce);return}try{H.value(ce)}catch(X){F(X)}}C(H){const ce=H.current.u;for(;H.i<H.end;)this.B(ce[H.i++],H.value);H.reset()}fire(H){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof v)this.B(this.u,H);else{const ce=this.w;ce.enqueue(this,H,this.u.length),this.C(ce)}this.j?.stop()}hasListeners(){return this.z>0}}e.$le=n;const s=()=>new m;e.$me=s;class m{constructor(){this.i=-1,this.end=0}enqueue(H,ce,F){this.i=0,this.end=F,this.current=H,this.value=ce}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class P extends n{async fireAsync(H,ce,F){if(this.u)for(this.h||(this.h=new p.$5c),w(this.u,X=>this.h.push([X.value,H]));this.h.size>0&&!ce.isCancellationRequested;){const[X,C]=this.h.shift(),ee=[],M={...C,token:ce,waitUntil:z=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");F&&(z=F(z,X)),ee.push(z)}};try{X(M)}catch(z){(0,a.$Y)(z);continue}Object.freeze(ee),await Promise.allSettled(ee).then(z=>{for(const V of z)V.status==="rejected"&&(0,a.$Y)(V.reason)})}}}e.$ne=P;class h extends n{get isPaused(){return this.h!==0}constructor(H){super(H),this.h=0,this.s=new p.$5c,this.t=H?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const H=Array.from(this.s);this.s.clear(),super.fire(this.t(H))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(H){this.z&&(this.h!==0?this.s.push(H):super.fire(H))}}e.$oe=h;class $ extends h{constructor(H){super(H),this.k=H.delay??100}fire(H){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(H)}}e.$pe=$;class l extends n{constructor(H){super(H),this.h=[],this.k=H?.merge}fire(H){this.hasListeners()&&(this.h.push(H),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(ce=>super.fire(ce)),this.h=[]}))}}e.$qe=l;class o{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(H){const ce={event:H,listener:null};this.h.push(ce),this.g&&this.m(ce);const F=()=>{this.g&&this.o(ce);const X=this.h.indexOf(ce);this.h.splice(X,1)};return(0,R.$Sc)((0,t.$cb)(F))}j(){this.g=!0,this.h.forEach(H=>this.m(H))}k(){this.g=!1,this.h.forEach(H=>this.o(H))}m(H){H.listener=H.event(ce=>this.f.fire(ce))}o(H){H.listener?.dispose(),H.listener=null}dispose(){this.f.dispose();for(const H of this.h)H.listener?.dispose();this.h=[]}}e.$re=o;class U{constructor(H,ce,F,X){this.f=new R.$Tc;const C=this.f.add(new o),ee=this.f.add(new R.$4c);function M(z){ee.set(z,C.add(X(z)))}for(const z of H)M(z);this.f.add(ce(z=>{M(z)})),this.f.add(F(z=>{ee.deleteAndDispose(z)})),this.event=C.event}dispose(){this.f.dispose()}}e.$se=U;class D{constructor(){this.f=[]}wrapEvent(H,ce,F){return(X,C,ee)=>H(M=>{const z=this.f[this.f.length-1];if(!ce){z?z.buffers.push(()=>X.call(C,M)):X.call(C,M);return}const V=z;if(!V){X.call(C,ce(F,M));return}V.items??=[],V.items.push(M),V.buffers.length===0&&z.buffers.push(()=>{V.reducedResult??=F?V.items.reduce(ce,F):V.items.reduce(ce),X.call(C,V.reducedResult)})},void 0,ee)}bufferEvents(H){const ce={buffers:new Array};this.f.push(ce);const F=H();return this.f.pop(),ce.buffers.forEach(X=>X()),F}}e.$te=D;class b{constructor(){this.f=!1,this.g=j.None,this.h=R.$Uc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(H){this.g=H,this.f&&(this.h.dispose(),this.h=H(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ue=b;class G{static const(H){return new x(H)}constructor(H){this.g=H,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(H){H!==this.g&&(this.g=H,this.f.fire(void 0))}}e.$ve=G;class x{constructor(H){this.value=H,this.onDidChange=j.None}}}),define(be[12],Ee([0,1,17]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.CancellationToken=void 0,e.$xe=O;const t=Object.freeze(function(L,T){const j=setTimeout(L.bind(T),0);return{dispose(){clearTimeout(j)}}});var R;(function(L){function T(j){return j===L.None||j===L.Cancelled||j instanceof p?!0:!j||typeof j!="object"?!1:typeof j.isCancellationRequested=="boolean"&&typeof j.onCancellationRequested=="function"}L.isCancellationToken=T,L.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),L.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(R||(e.CancellationToken=R={}));class p{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new a.$le),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class J{constructor(T){this.f=void 0,this.g=void 0,this.g=T&&T.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new p),this.f}cancel(){this.f?this.f instanceof p&&this.f.cancel():this.f=R.Cancelled}dispose(T=!1){T&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof p&&this.f.dispose():this.f=R.None}}e.$we=J;function O(L){const T=new J;return L.add({dispose(){T.cancel()}}),T.token}}),define(be[36],Ee([0,1,12]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_e=e.$$e=e.$9e=void 0,e.$0e=R;class t{constructor(L){this.b=L,this.a=null}get(){if(this.a)return this.a;const L=new a.$we,T=this.b(L.token);return this.a={promise:T,dispose:()=>{this.a=null,L.cancel(),L.dispose()}},this.a}}e.$9e=t;function R(O){return O}class p{constructor(L,T){this.a=void 0,this.b=void 0,typeof L=="function"?(this.c=L,this.d=R):(this.c=T,this.d=L.getCacheKey)}get(L){const T=this.d(L);return this.b!==T&&(this.b=T,this.a=this.c(L)),this.a}}e.$$e=p;class J{get cachedValues(){return this.a}constructor(L,T){this.a=new Map,this.b=new Map,typeof L=="function"?(this.c=L,this.d=R):(this.c=T,this.d=L.getCacheKey)}get(L){const T=this.d(L);if(this.b.has(T))return this.b.get(T);const j=this.c(L);return this.a.set(L,j),this.b.set(T,j),j}}e.$_e=J}),define(be[37],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0,e.$ge=Symbol("MicrotaskDelay")}),define(be[25],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=a,e.$fg=t,e.$gg=R,e.$hg=p,e.$ig=J,e.$jg=O,e.$kg=L,e.$lg=T,e.$mg=j,e.$ng=q,e.$og=I,e.$pg=W,e.$qg=f,e.$rg=u,e.$sg=g,e.$tg=y,e.$ug=v,e.$vg=k,e.$wg=w;function a(i){return typeof i=="string"}function t(i){return Array.isArray(i)&&i.every(n=>a(n))}function R(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function p(i){const n=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof n}function J(i){return typeof i=="number"&&!isNaN(i)}function O(i){return!!i&&typeof i[Symbol.iterator]=="function"}function L(i){return i===!0||i===!1}function T(i){return typeof i>"u"}function j(i){return!q(i)}function q(i){return T(i)||i===null}function I(i,n){if(!i)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function W(i){if(q(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function f(...i){const n=[];for(let s=0;s<i.length;s++){const m=i[s];if(q(m))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(m)}return n}const r=Object.prototype.hasOwnProperty;function u(i){if(!R(i))return!1;for(const n in i)if(r.call(i,n))return!1;return!0}function g(i){return typeof i=="function"}function y(...i){return i.length>0&&i.every(g)}function v(i,n){const s=Math.min(i.length,n.length);for(let m=0;m<s;m++)k(i[m],n[m])}function k(i,n){if(a(n)){if(typeof i!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(g(n)){try{if(i instanceof n)return}catch{}if(!q(i)&&i.constructor===n||n.length===1&&n.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function w(i){return i}}),define(be[38],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$af=t,e.$bf=R;var a;(function(p){p[p.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",p[p.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",p[p.MAX_UINT_8=255]="MAX_UINT_8",p[p.MAX_UINT_16=65535]="MAX_UINT_16",p[p.MAX_UINT_32=4294967295]="MAX_UINT_32",p[p.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a||(e.Constants=a={}));function t(p){return p<0?0:p>a.MAX_UINT_8?a.MAX_UINT_8:p|0}function R(p){return p<0?0:p>a.MAX_UINT_32?a.MAX_UINT_32:p|0}}),define(be[4],Ee([0,1,36,7,14,38]),function(oe,e,a,t,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.GraphemeBreakType=e.$4f=e.$Vf=e.$Of=e.$Nf=void 0,e.$cf=J,e.$df=L,e.$ef=j,e.$ff=q,e.$gf=I,e.$hf=W,e.$if=f,e.$jf=r,e.$kf=u,e.$lf=g,e.$mf=y,e.$nf=v,e.$of=k,e.$pf=w,e.$qf=i,e.$rf=n,e.$sf=s,e.$tf=m,e.$uf=P,e.$vf=h,e.$wf=$,e.$xf=l,e.$yf=o,e.$zf=U,e.$Af=D,e.$Bf=b,e.$Cf=G,e.$Df=x,e.$Ef=Z,e.$Ff=H,e.$Gf=ce,e.$Hf=F,e.$If=X,e.$Jf=C,e.$Kf=ee,e.$Lf=M,e.$Mf=z,e.$Pf=E,e.$Qf=ne,e.$Rf=se,e.$Sf=re,e.$Tf=De,e.$Uf=B,e.$Wf=_,e.$Xf=c,e.$Yf=A,e.$Zf=K,e.$1f=ge,e.$2f=ve,e.$3f=fe,e.$5f=le,e.$6f=$e,e.$7f=he,e.$8f=_e,e.$9f=ye,e.$0f=Le,e.$$f=Te,e.$_f=Oe,e.$ag=je;function J(d){return!d||typeof d!="string"?!0:d.trim().length===0}const O=/{(\d+)}/g;function L(d,...S){return S.length===0?d:d.replace(O,function(Y,ie){const me=parseInt(ie,10);return isNaN(me)||me<0||me>=S.length?Y:S[me]})}const T=/{([^}]+)}/g;function j(d,S){return Object.keys(S).length===0?d:d.replace(T,(Y,ie)=>S[ie]??Y)}function q(d){return d.replace(/[<>"'&]/g,S=>{switch(S){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return S})}function I(d){return d.replace(/[<>&]/g,function(S){switch(S){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return S}})}function W(d){return d.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function f(d,S){let Y=0,ie=d.indexOf(S);for(;ie!==-1;)Y++,ie=d.indexOf(S,ie+S.length);return Y}function r(d,S,Y="\u2026"){return d.length<=S?d:`${d.substr(0,S)}${Y}`}function u(d,S,Y="\u2026"){if(d.length<=S)return d;const ie=Math.ceil(S/2)-Y.length/2,me=Math.floor(S/2)-Y.length/2;return`${d.substr(0,ie)}${Y}${d.substr(d.length-me)}`}function g(d,S=" "){const Y=y(d,S);return v(Y,S)}function y(d,S){if(!d||!S)return d;const Y=S.length;if(Y===0||d.length===0)return d;let ie=0;for(;d.indexOf(S,ie)===ie;)ie=ie+Y;return d.substring(ie)}function v(d,S){if(!d||!S)return d;const Y=S.length,ie=d.length;if(Y===0||ie===0)return d;let me=ie,Ae=-1;for(;Ae=d.lastIndexOf(S,me-1),!(Ae===-1||Ae+Y!==me);){if(Ae===0)return"";me=Ae}return d.substring(0,me)}function k(d){return d.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function w(d){return d.replace(/\*/g,"")}function i(d,S,Y={}){if(!d)throw new Error("Cannot create regex from empty string");S||(d=W(d)),Y.wholeWord&&(/\B/.test(d.charAt(0))||(d="\\b"+d),/\B/.test(d.charAt(d.length-1))||(d=d+"\\b"));let ie="";return Y.global&&(ie+="g"),Y.matchCase||(ie+="i"),Y.multiline&&(ie+="m"),Y.unicode&&(ie+="u"),new RegExp(d,ie)}function n(d){return d.source==="^"||d.source==="^$"||d.source==="$"||d.source==="^\\s*$"?!1:!!(d.exec("")&&d.lastIndex===0)}function s(d){return d.split(/\r\n|\r|\n/)}function m(d){const S=[],Y=d.split(/(\r\n|\r|\n)/);for(let ie=0;ie<Math.ceil(Y.length/2);ie++)S.push(Y[2*ie]+(Y[2*ie+1]??""));return S}function P(d){for(let S=0,Y=d.length;S<Y;S++){const ie=d.charCodeAt(S);if(ie!==t.CharCode.Space&&ie!==t.CharCode.Tab)return S}return-1}function h(d,S=0,Y=d.length){for(let ie=S;ie<Y;ie++){const me=d.charCodeAt(ie);if(me!==t.CharCode.Space&&me!==t.CharCode.Tab)return d.substring(S,ie)}return d.substring(S,Y)}function $(d,S=d.length-1){for(let Y=S;Y>=0;Y--){const ie=d.charCodeAt(Y);if(ie!==t.CharCode.Space&&ie!==t.CharCode.Tab)return Y}return-1}function l(d,S,Y){const ie=[];let me=0;for(const Ae of d.matchAll(S)){if(ie.push(d.slice(me,Ae.index)),Ae.index===void 0)throw new Error("match.index should be defined");me=Ae.index+Ae[0].length,ie.push(Y(Ae[0],...Ae.slice(1),Ae.index,d,Ae.groups))}return ie.push(d.slice(me)),Promise.all(ie).then(Ae=>Ae.join(""))}function o(d,S){return d<S?-1:d>S?1:0}function U(d,S,Y=0,ie=d.length,me=0,Ae=S.length){for(;Y<ie&&me<Ae;Y++,me++){const Ne=d.charCodeAt(Y),Pe=S.charCodeAt(me);if(Ne<Pe)return-1;if(Ne>Pe)return 1}const Ue=ie-Y,Me=Ae-me;return Ue<Me?-1:Ue>Me?1:0}function D(d,S){return b(d,S,0,d.length,0,S.length)}function b(d,S,Y=0,ie=d.length,me=0,Ae=S.length){for(;Y<ie&&me<Ae;Y++,me++){let Ne=d.charCodeAt(Y),Pe=S.charCodeAt(me);if(Ne===Pe)continue;if(Ne>=128||Pe>=128)return U(d.toLowerCase(),S.toLowerCase(),Y,ie,me,Ae);x(Ne)&&(Ne-=32),x(Pe)&&(Pe-=32);const Ie=Ne-Pe;if(Ie!==0)return Ie}const Ue=ie-Y,Me=Ae-me;return Ue<Me?-1:Ue>Me?1:0}function G(d){return d>=t.CharCode.Digit0&&d<=t.CharCode.Digit9}function x(d){return d>=t.CharCode.a&&d<=t.CharCode.z}function Z(d){return d>=t.CharCode.A&&d<=t.CharCode.Z}function H(d,S){return d.length===S.length&&b(d,S)===0}function ce(d,S){const Y=S.length;return S.length>d.length?!1:b(d,S,0,Y)===0}function F(d,S){const Y=Math.min(d.length,S.length);let ie;for(ie=0;ie<Y;ie++)if(d.charCodeAt(ie)!==S.charCodeAt(ie))return ie;return Y}function X(d,S){const Y=Math.min(d.length,S.length);let ie;const me=d.length-1,Ae=S.length-1;for(ie=0;ie<Y;ie++)if(d.charCodeAt(me-ie)!==S.charCodeAt(Ae-ie))return ie;return Y}function C(d){return 55296<=d&&d<=56319}function ee(d){return 56320<=d&&d<=57343}function M(d,S){return(d-55296<<10)+(S-56320)+65536}function z(d,S,Y){const ie=d.charCodeAt(Y);if(C(ie)&&Y+1<S){const me=d.charCodeAt(Y+1);if(ee(me))return M(ie,me)}return ie}function V(d,S){const Y=d.charCodeAt(S-1);if(ee(Y)&&S>1){const ie=d.charCodeAt(S-2);if(C(ie))return M(ie,Y)}return Y}class te{get offset(){return this.e}constructor(S,Y=0){this.c=S,this.d=S.length,this.e=Y}setOffset(S){this.e=S}prevCodePoint(){const S=V(this.c,this.e);return this.e-=S>=p.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,S}nextCodePoint(){const S=z(this.c,this.d,this.e);return this.e+=S>=p.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,S}eol(){return this.e>=this.d}}e.$Nf=te;class ue{get offset(){return this.c.offset}constructor(S,Y=0){this.c=new te(S,Y)}nextGraphemeLength(){const S=Se.getInstance(),Y=this.c,ie=Y.offset;let me=S.getGraphemeBreakType(Y.nextCodePoint());for(;!Y.eol();){const Ae=Y.offset,Ue=S.getGraphemeBreakType(Y.nextCodePoint());if(ke(me,Ue)){Y.setOffset(Ae);break}me=Ue}return Y.offset-ie}prevGraphemeLength(){const S=Se.getInstance(),Y=this.c,ie=Y.offset;let me=S.getGraphemeBreakType(Y.prevCodePoint());for(;Y.offset>0;){const Ae=Y.offset,Ue=S.getGraphemeBreakType(Y.prevCodePoint());if(ke(Ue,me)){Y.setOffset(Ae);break}me=Ue}return ie-Y.offset}eol(){return this.c.eol()}}e.$Of=ue;function E(d,S){return new ue(d,S).nextGraphemeLength()}function ne(d,S){return new ue(d,S).prevGraphemeLength()}function se(d,S){S>0&&ee(d.charCodeAt(S))&&S--;const Y=S+E(d,S);return[Y-ne(d,Y),Y]}function re(d){const S=new ue(d);let Y=0;for(;!S.eol();)Y++,S.nextGraphemeLength();return Y}let ae;function de(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function De(d){return ae||(ae=de()),ae.test(d)}const N=/^[\t\n\r\x20-\x7E]*$/;function B(d){return N.test(d)}e.$Vf=/[\u2028\u2029]/;function _(d){return e.$Vf.test(d)}function c(d){return d>=11904&&d<=55215||d>=63744&&d<=64255||d>=65281&&d<=65374}function A(d){return d>=127462&&d<=127487||d===8986||d===8987||d===9200||d===9203||d>=9728&&d<=10175||d===11088||d===11093||d>=127744&&d<=128591||d>=128640&&d<=128764||d>=128992&&d<=129008||d>=129280&&d<=129535||d>=129648&&d<=129782}function K(d,S,Y=""){const ie=d.trimStart();if(ie.length<S)return ie;const me=/\b/g;let Ae=0;for(;me.test(ie)&&!(ie.length-me.lastIndex<S);)Ae=me.lastIndex,me.lastIndex+=1;return Ae===0?ie:Y+ie.substring(Ae).trimStart()}const Q=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ge(d){let S=0;for(const Y of d.matchAll(Q))S!==Y.index&&(yield{isCode:!1,str:d.substring(S,Y.index)}),yield{isCode:!0,str:Y[0]},S=Y.index+Y[0].length;S!==d.length&&(yield{isCode:!1,str:d.substring(S)})}function ve(d){return d&&(d=d.replace(Q,"")),d}const Re=/\\\[.*?\\\]/g;function fe(d){return ve(d).replace(Re,"")}e.$4f=String.fromCharCode(t.CharCode.UTF8_BOM);function le(d){return!!(d&&d.length>0&&d.charCodeAt(0)===t.CharCode.UTF8_BOM)}function $e(d){return le(d)?d.substr(1):d}function he(d,S){if(!d||!S||d.length<S.length)return!1;const Y=S.length,ie=d.toLowerCase();let me=0,Ae=-1;for(;me<Y;){const Ue=ie.indexOf(S[me],Ae+1);if(Ue<0)return!1;Ae=Ue,me++}return!0}function _e(d,S=!1){return d?(S&&(d=d.replace(/\\./g,"")),d.toLowerCase()!==d):!1}function ye(d){return d.charAt(0).toUpperCase()+d.slice(1)}function Le(d,S=1){if(S===0)return"";let Y=-1;do Y=d.indexOf(`
`,Y+1),S--;while(S>0&&Y>=0);return Y===-1?d:(d[Y-1]==="\r"&&Y--,d.substr(0,Y))}function Te(d){const S=t.CharCode.Z-t.CharCode.A+1;return d=d%(2*S),d<S?String.fromCharCode(t.CharCode.a+d):String.fromCharCode(t.CharCode.A+d-S)}function Oe(d){return Se.getInstance().getGraphemeBreakType(d)}function ke(d,S){return d===we.Other?S!==we.Extend&&S!==we.SpacingMark:d===we.CR&&S===we.LF?!1:d===we.Control||d===we.CR||d===we.LF||S===we.Control||S===we.CR||S===we.LF?!0:!(d===we.L&&(S===we.L||S===we.V||S===we.LV||S===we.LVT)||(d===we.LV||d===we.V)&&(S===we.V||S===we.T)||(d===we.LVT||d===we.T)&&S===we.T||S===we.Extend||S===we.ZWJ||S===we.SpacingMark||d===we.Prepend||d===we.ZWJ&&S===we.Extended_Pictographic||d===we.Regional_Indicator&&S===we.Regional_Indicator)}var we;(function(d){d[d.Other=0]="Other",d[d.Prepend=1]="Prepend",d[d.CR=2]="CR",d[d.LF=3]="LF",d[d.Control=4]="Control",d[d.Extend=5]="Extend",d[d.Regional_Indicator=6]="Regional_Indicator",d[d.SpacingMark=7]="SpacingMark",d[d.L=8]="L",d[d.V=9]="V",d[d.T=10]="T",d[d.LV=11]="LV",d[d.LVT=12]="LVT",d[d.ZWJ=13]="ZWJ",d[d.Extended_Pictographic=14]="Extended_Pictographic"})(we||(e.GraphemeBreakType=we={}));class Se{static{this.c=null}static getInstance(){return Se.c||(Se.c=new Se),Se.c}constructor(){this.d=He()}getGraphemeBreakType(S){if(S<32)return S===t.CharCode.LineFeed?we.LF:S===t.CharCode.CarriageReturn?we.CR:we.Control;if(S<127)return we.Other;const Y=this.d,ie=Y.length/3;let me=1;for(;me<=ie;)if(S<Y[3*me])me=2*me;else if(S>Y[3*me+1])me=2*me+1;else return Y[3*me+2];return we.Other}}function He(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(d,S){if(d===0)return 0;const Y=Ke(d,S);if(Y!==void 0)return Y;const ie=new te(S,d);return ie.prevCodePoint(),ie.offset}function Ke(d,S){const Y=new te(S,d);let ie=Y.prevCodePoint();for(;Xe(ie)||ie===Ge.emojiVariantSelector||ie===Ge.enclosingKeyCap;){if(Y.offset===0)return;ie=Y.prevCodePoint()}if(!A(ie))return;let me=Y.offset;return me>0&&Y.prevCodePoint()===Ge.zwj&&(me=Y.offset),me}function Xe(d){return 127995<=d&&d<=127999}var Ge;(function(d){d[d.zwj=8205]="zwj",d[d.emojiVariantSelector=65039]="emojiVariantSelector",d[d.enclosingKeyCap=8419]="enclosingKeyCap"})(Ge||(Ge={})),e.$bg="\xA0";class qe{static{this.c=new R.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new a.$$e({getCacheKey:JSON.stringify},S=>{function Y(Ie){const Be=new Map;for(let Fe=0;Fe<Ie.length;Fe+=2)Be.set(Ie[Fe],Ie[Fe+1]);return Be}function ie(Ie,Be){const Fe=new Map(Ie);for(const[Ve,Ye]of Be)Fe.set(Ve,Ye);return Fe}function me(Ie,Be){if(!Ie)return Be;const Fe=new Map;for(const[Ve,Ye]of Ie)Be.has(Ve)&&Fe.set(Ve,Ye);return Fe}const Ae=this.c.value;let Ue=S.filter(Ie=>!Ie.startsWith("_")&&Ie in Ae);Ue.length===0&&(Ue=["_default"]);let Me;for(const Ie of Ue){const Be=Y(Ae[Ie]);Me=me(Me,Be)}const Ne=Y(Ae._common),Pe=ie(Ne,Me);return new qe(Pe)})}static getInstance(S){return qe.d.get(Array.from(S))}static{this.e=new R.$T(()=>Object.keys(qe.c.value).filter(S=>!S.startsWith("_")))}static getLocales(){return qe.e.value}constructor(S){this.f=S}isAmbiguous(S){return this.f.has(S)}containsAmbiguousCharacter(S){for(let Y=0;Y<S.length;Y++){const ie=S.codePointAt(Y);if(typeof ie=="number"&&this.isAmbiguous(ie))return!0}return!1}getPrimaryConfusable(S){return this.f.get(S)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$cg=qe;class We{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(We.c())),this.d}static isInvisibleCharacter(S){return We.e().has(S)}static containsInvisibleCharacter(S){for(let Y=0;Y<S.length;Y++){const ie=S.codePointAt(Y);if(typeof ie=="number"&&We.isInvisibleCharacter(ie))return!0}return!1}static get codePoints(){return We.e()}}e.$dg=We}),define(be[5],Ee([0,1,7,3,2,4,25]),function(oe,e,a,t,R,p,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=O,e.$yg=L,e.$zg=T,e.$Ag=j,e.$Bg=q,e.$Cg=r,e.$Dg=u,e.$Eg=g,e.$Fg=y,e.$Gg=v,e.$Hg=k,e.$Ig=w,e.$Jg=i,e.$Kg=n,e.$Lg=s,e.$Mg=m,e.$Ng=$;function O(l){return l===a.CharCode.Slash||l===a.CharCode.Backslash}function L(l){return l.replace(/[\\/]/g,t.$gc.sep)}function T(l){return l.indexOf("/")===-1&&(l=L(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}function j(l,o=t.$gc.sep){if(!l)return"";const U=l.length,D=l.charCodeAt(0);if(O(D)){if(O(l.charCodeAt(1))&&!O(l.charCodeAt(2))){let G=3;const x=G;for(;G<U&&!O(l.charCodeAt(G));G++);if(x!==G&&!O(l.charCodeAt(G+1))){for(G+=1;G<U;G++)if(O(l.charCodeAt(G)))return l.slice(0,G+1).replace(/[\\/]/g,o)}}return o}else if(y(D)&&l.charCodeAt(1)===a.CharCode.Colon)return O(l.charCodeAt(2))?l.slice(0,2)+o:l.slice(0,2);let b=l.indexOf("://");if(b!==-1){for(b+=3;b<U;b++)if(O(l.charCodeAt(b)))return l.slice(0,b+1)}return""}function q(l){if(!R.$j||!l||l.length<5)return!1;let o=l.charCodeAt(0);if(o!==a.CharCode.Backslash||(o=l.charCodeAt(1),o!==a.CharCode.Backslash))return!1;let U=2;const D=U;for(;U<l.length&&(o=l.charCodeAt(U),o!==a.CharCode.Backslash);U++);return!(D===U||(o=l.charCodeAt(U+1),isNaN(o)||o===a.CharCode.Backslash))}const I=/[\\/:\*\?"<>\|]/g,W=/[/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(l,o=R.$j){const U=o?I:W;return!(!l||l.length===0||/^\s+$/.test(l)||(U.lastIndex=0,U.test(l))||o&&f.test(l)||l==="."||l===".."||o&&l[l.length-1]==="."||o&&l.length!==l.trim().length||l.length>255)}function u(l,o,U){const D=l===o;return!U||D?D:!l||!o?!1:(0,p.$Ff)(l,o)}function g(l,o,U,D=t.sep){if(l===o)return!0;if(!l||!o||o.length>l.length)return!1;if(U){if(!(0,p.$Gf)(l,o))return!1;if(o.length===l.length)return!0;let G=o.length;return o.charAt(o.length-1)===D&&G--,l.charAt(G)===D}return o.charAt(o.length-1)!==D&&(o+=D),l.indexOf(o)===0}function y(l){return l>=a.CharCode.A&&l<=a.CharCode.Z||l>=a.CharCode.a&&l<=a.CharCode.z}function v(l,o){return R.$j&&l.endsWith(":")&&(l+=t.sep),(0,t.$ic)(l)||(l=(0,t.$jc)(o,l)),l=(0,t.$hc)(l),k(l)}function k(l){return R.$j?(l=(0,p.$nf)(l,t.sep),l.endsWith(":")&&(l+=t.sep)):(l=(0,p.$nf)(l,t.sep),l||(l=t.sep)),l}function w(l){const o=(0,t.$hc)(l);return R.$j?l.length>3?!1:i(o)&&(l.length===2||o.charCodeAt(2)===a.CharCode.Backslash):o===t.$gc.sep}function i(l,o=R.$j){return o?y(l.charCodeAt(0))&&l.charCodeAt(1)===a.CharCode.Colon:!1}function n(l,o=R.$j){return i(l,o)?l[0]:void 0}function s(l,o,U){return o.length>l.length?-1:l===o?0:(U&&(l=l.toLowerCase(),o=o.toLowerCase()),l.indexOf(o))}function m(l){const o=l.split(":");let U,D,b;for(const G of o){const x=Number(G);(0,J.$ig)(x)?D===void 0?D=x:b===void 0&&(b=x):U=U?[U,G].join(":"):G}if(!U)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:U,line:D!==void 0?D:void 0,column:b!==void 0?b:D!==void 0?1:void 0}}const P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function $(l,o,U=8){let D="";for(let G=0;G<U;G++){let x;G===0&&R.$j&&!o&&(U===3||U===4)?x=h:x=P,D+=x.charAt(Math.floor(Math.random()*x.length))}let b;return o?b=`${o}-${D}`:b=D,l?(0,t.$jc)(l,b):b}}),define(be[39],Ee([0,1,13,7,4]),function(oe,e,a,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class p{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const r=f.charCodeAt(0),u=this.b.charCodeAt(this.c);return r-u}value(){return this.b[this.c]}}e.$Hi=p;class J{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===t.CharCode.Period)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,R.$zf)(f,this.b,0,f.length,this.c,this.d):(0,R.$Bf)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=J;class O{constructor(f=!0,r=!0){this.f=f,this.g=r}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let r=f.length-1;r>=0;r--,this.c--){const u=this.b.charCodeAt(r);if(!(u===t.CharCode.Slash||this.f&&u===t.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===t.CharCode.Slash||this.f&&r===t.CharCode.Backslash)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,R.$zf)(f,this.b,0,f.length,this.d,this.e):(0,R.$Bf)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=O;var L;(function(W){W[W.Scheme=1]="Scheme",W[W.Authority=2]="Authority",W[W.Path=3]="Path",W[W.Query=4]="Query",W[W.Fragment=5]="Fragment"})(L||(L={}));class T{constructor(f,r){this.f=f,this.g=r,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(L.Scheme),this.c.authority&&this.d.push(L.Authority),this.c.path&&(this.b=new O(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(L.Path)),this.g(f)||(this.c.query&&this.d.push(L.Query),this.c.fragment&&this.d.push(L.Fragment)),this.e=0,this}next(){return this.d[this.e]===L.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===L.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===L.Scheme)return(0,R.$Af)(f,this.c.scheme);if(this.d[this.e]===L.Authority)return(0,R.$Af)(f,this.c.authority);if(this.d[this.e]===L.Path)return this.b.cmp(f);if(this.d[this.e]===L.Query)return(0,R.$yf)(f,this.c.query);if(this.d[this.e]===L.Fragment)return(0,R.$yf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===L.Scheme)return this.c.scheme;if(this.d[this.e]===L.Authority)return this.c.authority;if(this.d[this.e]===L.Path)return this.b.value();if(this.d[this.e]===L.Query)return this.c.query;if(this.d[this.e]===L.Fragment)return this.c.fragment;throw new Error}}e.$Ki=T;class j{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var q;(function(W){W[W.Left=-1]="Left",W[W.Mid=0]="Mid",W[W.Right=1]="Right"})(q||(q={}));class I{static forUris(f=()=>!1,r=()=>!1){return new I(new T(f,r))}static forPaths(f=!1){return new I(new O(void 0,!f))}static forStrings(){return new I(new p)}static forConfigKeys(){return new I(new J)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,r){if(r){const u=r.slice(0);(0,a.$Vb)(u);for(const g of u)this.set(g,f)}else{const u=f.slice(0);(0,a.$Vb)(u);for(const g of u)this.set(g[0],g[1])}}set(f,r){const u=this.b.reset(f);let g;this.c||(this.c=new j,this.c.segment=u.value());const y=[];for(g=this.c;;){const k=u.cmp(g.segment);if(k>0)g.left||(g.left=new j,g.left.segment=u.value()),y.push([q.Left,g]),g=g.left;else if(k<0)g.right||(g.right=new j,g.right.segment=u.value()),y.push([q.Right,g]),g=g.right;else if(u.hasNext())u.next(),g.mid||(g.mid=new j,g.mid.segment=u.value()),y.push([q.Mid,g]),g=g.mid;else break}const v=g.value;g.value=r,g.key=f;for(let k=y.length-1;k>=0;k--){const w=y[k][1];w.updateHeight();const i=w.balanceFactor();if(i<-1||i>1){const n=y[k][0],s=y[k+1][0];if(n===q.Right&&s===q.Right)y[k][1]=w.rotateLeft();else if(n===q.Left&&s===q.Left)y[k][1]=w.rotateRight();else if(n===q.Right&&s===q.Left)w.right=y[k+1][1]=y[k+1][1].rotateRight(),y[k][1]=w.rotateLeft();else if(n===q.Left&&s===q.Right)w.left=y[k+1][1]=y[k+1][1].rotateLeft(),y[k][1]=w.rotateRight();else throw new Error;if(k>0)switch(y[k-1][0]){case q.Left:y[k-1][1].left=y[k][1];break;case q.Right:y[k-1][1].right=y[k][1];break;case q.Mid:y[k-1][1].mid=y[k][1];break}else this.c=y[0][1]}}return v}get(f){return this.d(f)?.value}d(f){const r=this.b.reset(f);let u=this.c;for(;u;){const g=r.cmp(u.segment);if(g>0)u=u.left;else if(g<0)u=u.right;else if(r.hasNext())r.next(),u=u.mid;else break}return u}has(f){const r=this.d(f);return!(r?.value===void 0&&r?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,r){const u=this.b.reset(f),g=[];let y=this.c;for(;y;){const v=u.cmp(y.segment);if(v>0)g.push([q.Left,y]),y=y.left;else if(v<0)g.push([q.Right,y]),y=y.right;else if(u.hasNext())u.next(),g.push([q.Mid,y]),y=y.mid;else break}if(y){if(r?(y.left=void 0,y.mid=void 0,y.right=void 0,y.height=1):(y.key=void 0,y.value=void 0),!y.mid&&!y.value)if(y.left&&y.right){const v=this.f(y.right);if(v.key){const{key:k,value:w,segment:i}=v;this.e(v.key,!1),y.key=k,y.value=w,y.segment=i}}else{const v=y.left??y.right;if(g.length>0){const[k,w]=g[g.length-1];switch(k){case q.Left:w.left=v;break;case q.Mid:w.mid=v;break;case q.Right:w.right=v;break}}else this.c=v}for(let v=g.length-1;v>=0;v--){const k=g[v][1];k.updateHeight();const w=k.balanceFactor();if(w>1?(k.right.balanceFactor()>=0||(k.right=k.right.rotateRight()),g[v][1]=k.rotateLeft()):w<-1&&(k.left.balanceFactor()<=0||(k.left=k.left.rotateLeft()),g[v][1]=k.rotateRight()),v>0)switch(g[v-1][0]){case q.Left:g[v-1][1].left=g[v][1];break;case q.Right:g[v-1][1].right=g[v][1];break;case q.Mid:g[v-1][1].mid=g[v][1];break}else this.c=g[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const r=this.b.reset(f);let u=this.c,g;for(;u;){const y=r.cmp(u.segment);if(y>0)u=u.left;else if(y<0)u=u.right;else if(r.hasNext())r.next(),g=u.value||g,u=u.mid;else break}return u&&u.value||g}findSuperstr(f){return this.g(f,!1)}g(f,r){const u=this.b.reset(f);let g=this.c;for(;g;){const y=u.cmp(g.segment);if(y>0)g=g.left;else if(y<0)g=g.right;else if(u.hasNext())u.next(),g=g.mid;else return g.mid?this.h(g.mid):r?g.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[r,u]of this)f(u,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const r=[];return this.j(f,r),r[Symbol.iterator]()}j(f,r){f&&(f.left&&this.j(f.left,r),f.value&&r.push([f.key,f.value]),f.mid&&this.j(f.mid,r),f.right&&this.j(f.right,r))}_isBalanced(){const f=r=>{if(!r)return!0;const u=r.balanceFactor();return u<-1||u>1?!1:f(r.left)&&f(r.right)};return f(this.c)}}e.$Li=I}),define(be[6],Ee([0,1,7,33,3,2]),function(oe,e,a,t,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=u,e.$wc=i,R=pe(R);const J=/^\w[\w\d+.-]*$/,O=/^\//,L=/^\/\//;function T(h,$){if(!h.scheme&&$)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!J.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!O.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function j(h,$){return!h&&!$?"file":h}function q(h,$){switch(h){case"https":case"http":case"file":$?$[0]!==W&&($=W+$):$=W;break}return $}const I="",W="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class r{static isUri($){return $ instanceof r?!0:$?typeof $.authority=="string"&&typeof $.fragment=="string"&&typeof $.path=="string"&&typeof $.query=="string"&&typeof $.scheme=="string"&&typeof $.fsPath=="string"&&typeof $.with=="function"&&typeof $.toString=="function":!1}constructor($,l,o,U,D,b=!1){typeof $=="object"?(this.scheme=$.scheme||I,this.authority=$.authority||I,this.path=$.path||I,this.query=$.query||I,this.fragment=$.fragment||I):(this.scheme=j($,b),this.authority=l||I,this.path=q(this.scheme,o||I),this.query=U||I,this.fragment=D||I,T(this,b))}get fsPath(){return i(this,!1)}with($){if(!$)return this;let{scheme:l,authority:o,path:U,query:D,fragment:b}=$;return l===void 0?l=this.scheme:l===null&&(l=I),o===void 0?o=this.authority:o===null&&(o=I),U===void 0?U=this.path:U===null&&(U=I),D===void 0?D=this.query:D===null&&(D=I),b===void 0?b=this.fragment:b===null&&(b=I),l===this.scheme&&o===this.authority&&U===this.path&&D===this.query&&b===this.fragment?this:new y(l,o,U,D,b)}static parse($,l=!1){const o=f.exec($);return o?new y(o[2]||I,P(o[4]||I),P(o[5]||I),P(o[7]||I),P(o[9]||I),l):new y(I,I,I,I,I)}static file($){let l=I;if(p.$j&&($=$.replace(/\\/g,W)),$[0]===W&&$[1]===W){const o=$.indexOf(W,2);o===-1?(l=$.substring(2),$=W):(l=$.substring(2,o),$=$.substring(o)||W)}return new y("file",l,$,I,I)}static from($,l){return new y($.scheme,$.authority,$.path,$.query,$.fragment,l)}static joinPath($,...l){if(!$.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return p.$j&&$.scheme==="file"?o=r.file(R.$fc.join(i($,!0),...l)).path:o=R.$gc.join($.path,...l),$.with({path:o})}toString($=!1){return n(this,$)}toJSON(){return this}static revive($){if($){if($ instanceof r)return $;{const l=new y($);return l._formatted=$.external??null,l._fsPath=$._sep===g?$.fsPath??null:null,l}}else return $}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=r;function u(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}const g=p.$j?1:void 0;class y extends r{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString($=!1){return $?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const $={$mid:t.MarshalledId.Uri};return this._fsPath&&($.fsPath=this._fsPath,$._sep=g),this._formatted&&($.external=this._formatted),this.path&&($.path=this.path),this.scheme&&($.scheme=this.scheme),this.authority&&($.authority=this.authority),this.query&&($.query=this.query),this.fragment&&($.fragment=this.fragment),$}}const v={[a.CharCode.Colon]:"%3A",[a.CharCode.Slash]:"%2F",[a.CharCode.QuestionMark]:"%3F",[a.CharCode.Hash]:"%23",[a.CharCode.OpenSquareBracket]:"%5B",[a.CharCode.CloseSquareBracket]:"%5D",[a.CharCode.AtSign]:"%40",[a.CharCode.ExclamationMark]:"%21",[a.CharCode.DollarSign]:"%24",[a.CharCode.Ampersand]:"%26",[a.CharCode.SingleQuote]:"%27",[a.CharCode.OpenParen]:"%28",[a.CharCode.CloseParen]:"%29",[a.CharCode.Asterisk]:"%2A",[a.CharCode.Plus]:"%2B",[a.CharCode.Comma]:"%2C",[a.CharCode.Semicolon]:"%3B",[a.CharCode.Equals]:"%3D",[a.CharCode.Space]:"%20"};function k(h,$,l){let o,U=-1;for(let D=0;D<h.length;D++){const b=h.charCodeAt(D);if(b>=a.CharCode.a&&b<=a.CharCode.z||b>=a.CharCode.A&&b<=a.CharCode.Z||b>=a.CharCode.Digit0&&b<=a.CharCode.Digit9||b===a.CharCode.Dash||b===a.CharCode.Period||b===a.CharCode.Underline||b===a.CharCode.Tilde||$&&b===a.CharCode.Slash||l&&b===a.CharCode.OpenSquareBracket||l&&b===a.CharCode.CloseSquareBracket||l&&b===a.CharCode.Colon)U!==-1&&(o+=encodeURIComponent(h.substring(U,D)),U=-1),o!==void 0&&(o+=h.charAt(D));else{o===void 0&&(o=h.substr(0,D));const G=v[b];G!==void 0?(U!==-1&&(o+=encodeURIComponent(h.substring(U,D)),U=-1),o+=G):U===-1&&(U=D)}}return U!==-1&&(o+=encodeURIComponent(h.substring(U))),o!==void 0?o:h}function w(h){let $;for(let l=0;l<h.length;l++){const o=h.charCodeAt(l);o===a.CharCode.Hash||o===a.CharCode.QuestionMark?($===void 0&&($=h.substr(0,l)),$+=v[o]):$!==void 0&&($+=h[l])}return $!==void 0?$:h}function i(h,$){let l;return h.authority&&h.path.length>1&&h.scheme==="file"?l=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===a.CharCode.Slash&&(h.path.charCodeAt(1)>=a.CharCode.A&&h.path.charCodeAt(1)<=a.CharCode.Z||h.path.charCodeAt(1)>=a.CharCode.a&&h.path.charCodeAt(1)<=a.CharCode.z)&&h.path.charCodeAt(2)===a.CharCode.Colon?$?l=h.path.substr(1):l=h.path[1].toLowerCase()+h.path.substr(2):l=h.path,p.$j&&(l=l.replace(/\//g,"\\")),l}function n(h,$){const l=$?w:k;let o="",{scheme:U,authority:D,path:b,query:G,fragment:x}=h;if(U&&(o+=U,o+=":"),(D||U==="file")&&(o+=W,o+=W),D){let Z=D.indexOf("@");if(Z!==-1){const H=D.substr(0,Z);D=D.substr(Z+1),Z=H.lastIndexOf(":"),Z===-1?o+=l(H,!1,!1):(o+=l(H.substr(0,Z),!1,!1),o+=":",o+=l(H.substr(Z+1),!1,!0)),o+="@"}D=D.toLowerCase(),Z=D.lastIndexOf(":"),Z===-1?o+=l(D,!1,!0):(o+=l(D.substr(0,Z),!1,!0),o+=D.substr(Z))}if(b){if(b.length>=3&&b.charCodeAt(0)===a.CharCode.Slash&&b.charCodeAt(2)===a.CharCode.Colon){const Z=b.charCodeAt(1);Z>=a.CharCode.A&&Z<=a.CharCode.Z&&(b=`/${String.fromCharCode(Z+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===a.CharCode.Colon){const Z=b.charCodeAt(0);Z>=a.CharCode.A&&Z<=a.CharCode.Z&&(b=`${String.fromCharCode(Z+32)}:${b.substr(2)}`)}o+=l(b,!0,!1)}return G&&(o+="?",o+=l(G,!1,!1)),x&&(o+="#",o+=$?x:k(x,!1,!1)),o}function s(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+s(h.substr(3)):h}}const m=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function P(h){return h.match(m)?h.replace(m,$=>s($)):h}}),define(be[18],Ee([0,1,10,2,4,6,3]),function(oe,e,a,t,R,p,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=L,e.$Pg=T,e.$Tg=q,a=pe(a),t=pe(t),J=pe(J);var O;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",f.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting"})(O||(e.Schemas=O={}));function L(f,r){return p.URI.isUri(f)?(0,R.$Ff)(f.scheme,r):(0,R.$Gf)(f,r+":")}function T(f,...r){return r.some(u=>L(f,u))}e.$Qg="vscode-tkn",e.$Rg="tkn";class j{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,u){this.f=q(r,u)}getServerRootPath(){return this.f}get g(){return J.$gc.join(this.f,O.vscodeRemoteResource)}set(r,u,g){this.a[r]=u,this.b[r]=g}setConnectionToken(r,u){this.c[r]=u}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(w){return a.$Y(w),r}const u=r.authority;let g=this.a[u];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const y=this.b[u],v=this.c[u];let k=`path=${encodeURIComponent(r.path)}`;return typeof v=="string"&&(k+=`&${e.$Rg}=${encodeURIComponent(v)}`),p.URI.from({scheme:t.$p?this.d:O.vscodeRemoteResource,authority:`${g}:${y}`,path:this.g,query:k})}}e.$Sg=new j;function q(f,r){return J.$gc.join(r??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class I{static{this.a=e.$Yg}asBrowserUri(r){const u=this.b(r,oe);return this.uriToBrowserUri(u)}uriToBrowserUri(r){return r.scheme===O.vscodeRemote?e.$Sg.rewrite(r):r.scheme===O.file&&(t.$n||t.$r===`${O.vscodeFileResource}://${I.a}`)?r.with({scheme:O.vscodeFileResource,authority:r.authority||I.a,query:null,fragment:null}):r}asFileUri(r){const u=this.b(r,oe);return this.uriToFileUri(u)}uriToFileUri(r){return r.scheme===O.vscodeFileResource?r.with({scheme:O.file,authority:r.authority!==I.a?r.authority:null,query:null,fragment:null}):r}b(r,u){return p.URI.isUri(r)?r:p.URI.parse(u.toUrl(r))}}e.$Zg=new I;var W;(function(f){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(r.get("3"));const u="vscode-coi";function g(v){let k;typeof v=="string"?k=new URL(v).searchParams:v instanceof URL?k=v.searchParams:p.URI.isUri(v)&&(k=new URL(v.toString(!0)).searchParams);const w=k?.get(u);if(w)return r.get(w)}f.getHeadersFromQuery=g;function y(v,k,w){if(!globalThis.crossOriginIsolated)return;const i=k&&w?"3":w?"2":"1";v instanceof URLSearchParams?v.set(u,i):v[u]=i}f.addSearchParam=y})(W||(e.COI=W={}))}),define(be[19],Ee([0,1,7,5,18,3,2,4,6]),function(oe,e,a,t,R,p,J,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=T,e.$ph=q,e.$qh=W,t=pe(t),p=pe(p);function T(f){return(0,L.$wc)(f,!0)}class j{constructor(r){this.a=r}compare(r,u,g=!1){return r===u?0:(0,O.$yf)(this.getComparisonKey(r,g),this.getComparisonKey(u,g))}isEqual(r,u,g=!1){return r===u?!0:!r||!u?!1:this.getComparisonKey(r,g)===this.getComparisonKey(u,g)}getComparisonKey(r,u=!1){return r.with({path:this.a(r)?r.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(r){return this.a(r)}isEqualOrParent(r,u,g=!1){if(r.scheme===u.scheme){if(r.scheme===R.Schemas.file)return t.$Eg(T(r),T(u),this.a(r))&&r.query===u.query&&(g||r.fragment===u.fragment);if((0,e.$lh)(r.authority,u.authority))return t.$Eg(r.path,u.path,this.a(r),"/")&&r.query===u.query&&(g||r.fragment===u.fragment)}return!1}joinPath(r,...u){return L.URI.joinPath(r,...u)}basenameOrAuthority(r){return(0,e.$dh)(r)||r.authority}basename(r){return p.$gc.basename(r.path)}extname(r){return p.$gc.extname(r.path)}dirname(r){if(r.path.length===0)return r;let u;return r.scheme===R.Schemas.file?u=L.URI.file(p.$mc(T(r))).path:(u=p.$gc.dirname(r.path),r.authority&&u.length&&u.charCodeAt(0)!==a.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),u="/")),r.with({path:u})}normalizePath(r){if(!r.path.length)return r;let u;return r.scheme===R.Schemas.file?u=L.URI.file(p.$hc(T(r))).path:u=p.$gc.normalize(r.path),r.with({path:u})}relativePath(r,u){if(r.scheme!==u.scheme||!(0,e.$lh)(r.authority,u.authority))return;if(r.scheme===R.Schemas.file){const v=p.$lc(T(r),T(u));return J.$j?t.$yg(v):v}let g=r.path||"/";const y=u.path||"/";if(this.a(r)){let v=0;for(const k=Math.min(g.length,y.length);v<k&&!(g.charCodeAt(v)!==y.charCodeAt(v)&&g.charAt(v).toLowerCase()!==y.charAt(v).toLowerCase());v++);g=y.substr(0,v)+g.substr(v)}return p.$gc.relative(g,y)}resolvePath(r,u){if(r.scheme===R.Schemas.file){const g=L.URI.file(p.$kc(T(r),u));return r.with({authority:g.authority,path:g.path})}return u=t.$zg(u),r.with({path:p.$gc.resolve(r.path,u)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,u){return r===u||r!==void 0&&u!==void 0&&(0,O.$Ff)(r,u)}hasTrailingPathSeparator(r,u=p.sep){if(r.scheme===R.Schemas.file){const g=T(r);return g.length>t.$Ag(g).length&&g[g.length-1]===u}else{const g=r.path;return g.length>1&&g.charCodeAt(g.length-1)===a.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,u=p.sep){return(0,e.$mh)(r,u)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,u=p.sep){let g=!1;if(r.scheme===R.Schemas.file){const y=T(r);g=y!==void 0&&y.length===t.$Ag(y).length&&y[y.length-1]===u}else{u="/";const y=r.path;g=y.length===1&&y.charCodeAt(y.length-1)===a.CharCode.Slash}return!g&&!(0,e.$mh)(r,u)?r.with({path:r.path+"/"}):r}}e.$8g=j,e.$9g=new j(()=>!1),e.$0g=new j(f=>f.scheme===R.Schemas.file?!J.$l:!0),e.$$g=new j(f=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function q(f,r){const u=[];for(let g=0;g<f.length;g++){const y=r(f[g]);f.some((v,k)=>k===g?!1:(0,e.$ah)(y,r(v)))||u.push(f[g])}return u}var I;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function r(u){const g=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(k=>{const[w,i]=k.split(":");w&&i&&g.set(w,i)});const v=u.path.substring(0,u.path.indexOf(";"));return v&&g.set(f.META_DATA_MIME,v),g}f.parseMetaData=r})(I||(e.DataUri=I={}));function W(f,r,u){if(r){let g=f.path;return g&&g[0]!==p.$gc.sep&&(g=p.$gc.sep+g),f.with({scheme:u,authority:r,path:g})}return f.with({scheme:u})}}),define(be[8],Ee([0,1,12,10,17,11,19,2,37,14]),function(oe,e,a,t,R,p,J,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=j,e.$sh=q,e.$th=I,e.$uh=W,e.$vh=f,e.$wh=r,e.$xh=u,e.$yh=g,e.$Gh=h,e.$Hh=$,e.$Ih=l,e.$Jh=o,e.$Kh=U,e.$Zh=z,e.$8h=N;function j(_){return!!_&&typeof _.then=="function"}function q(_){const c=new a.$we,A=_(c.token),K=new Promise((Q,ge)=>{const ve=c.token.onCancellationRequested(()=>{ve.dispose(),ge(new t.$4)});Promise.resolve(A).then(Re=>{ve.dispose(),c.dispose(),Q(Re)},Re=>{ve.dispose(),c.dispose(),ge(Re)})});return new class{cancel(){c.cancel(),c.dispose()}then(Q,ge){return K.then(Q,ge)}catch(Q){return this.then(void 0,Q)}finally(Q){return K.finally(Q)}}}function I(_,c,A){return new Promise((K,Q)=>{const ge=c.onCancellationRequested(()=>{ge.dispose(),K(A)});_.then(K,Q).finally(()=>ge.dispose())})}function W(_,c){return new Promise((A,K)=>{const Q=c.onCancellationRequested(()=>{Q.dispose(),K(new t.$4)});_.then(A,K).finally(()=>Q.dispose())})}async function f(_){let c=-1;const A=_.map((K,Q)=>K.then(ge=>(c=Q,ge)));try{return await Promise.race(A)}finally{_.forEach((K,Q)=>{Q!==c&&K.cancel()})}}function r(_,c,A){let K;const Q=setTimeout(()=>{K?.(void 0),A?.()},c);return Promise.race([_.finally(()=>clearTimeout(Q)),new Promise(ge=>K=ge)])}function u(_){return new Promise((c,A)=>{const K=_();j(K)?K.then(c,A):c(K)})}function g(){let _,c;return{promise:new Promise((K,Q)=>{_=K,c=Q}),resolve:_,reject:c}}class y{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(c){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=c,!this.b){const A=()=>{if(this.b=null,this.f)return;const K=this.queue(this.d);return this.d=null,K};this.b=new Promise(K=>{this.a.then(A,A).then(K)})}return new Promise((A,K)=>{this.b.then(A,K)})}return this.a=c(),new Promise((A,K)=>{this.a.then(Q=>{this.a=null,A(Q)},Q=>{this.a=null,K(Q)})})}dispose(){this.f=!0}}e.$zh=y;class v{constructor(){this.a=Promise.resolve(null)}queue(c){return this.a=this.a.then(()=>c(),()=>c())}}e.$Ah=v;class k{constructor(){this.a=new Map}queue(c,A){const Q=(this.a.get(c)??Promise.resolve()).catch(()=>{}).then(A).finally(()=>{this.a.get(c)===Q&&this.a.delete(c)});return this.a.set(c,Q),Q}}e.$Bh=k;const w=(_,c)=>{let A=!0;const K=setTimeout(()=>{A=!1,c()},_);return{isTriggered:()=>A,dispose:()=>{clearTimeout(K),A=!1}}},i=_=>{let c=!0;return queueMicrotask(()=>{c&&(c=!1,_())}),{isTriggered:()=>c,dispose:()=>{c=!1}}};class n{constructor(c){this.defaultDelay=c,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(c,A=this.defaultDelay){this.g=c,this.h(),this.b||(this.b=new Promise((Q,ge)=>{this.d=Q,this.f=ge}).then(()=>{if(this.b=null,this.d=null,this.g){const Q=this.g;return this.g=null,Q()}}));const K=()=>{this.a=null,this.d?.(null)};return this.a=A===L.$ge?i(K):w(A,K),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=n;class s{constructor(c){this.a=new n(c),this.b=new y}trigger(c,A){return this.a.trigger(()=>this.b.queue(c),A)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=s;class m{constructor(){this.a=!1,this.b=new Promise((c,A)=>{this.d=c})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=m;class P extends m{constructor(c){super(),this.f=setTimeout(()=>this.open(),c)}open(){clearTimeout(this.f),super.open()}}e.$Fh=P;function h(_,c){return c?new Promise((A,K)=>{const Q=setTimeout(()=>{ge.dispose(),A()},_),ge=c.onCancellationRequested(()=>{clearTimeout(Q),ge.dispose(),K(new t.$4)})}):q(A=>h(_,A))}function $(_,c=0,A){const K=setTimeout(()=>{_(),A&&Q.dispose()},c),Q=(0,p.$Sc)(()=>{clearTimeout(K),A?.deleteAndLeak(Q)});return A?.add(Q),Q}function l(_){const c=[];let A=0;const K=_.length;function Q(){return A<K?_[A++]():null}function ge(ve){ve!=null&&c.push(ve);const Re=Q();return Re?Re.then(ge):Promise.resolve(c)}return Promise.resolve(null).then(ge)}function o(_,c=K=>!!K,A=null){let K=0;const Q=_.length,ge=()=>{if(K>=Q)return Promise.resolve(A);const ve=_[K++];return Promise.resolve(ve()).then(fe=>c(fe)?Promise.resolve(fe):ge())};return ge()}function U(_,c=K=>!!K,A=null){if(_.length===0)return Promise.resolve(A);let K=_.length;const Q=()=>{K=-1;for(const ge of _)ge.cancel?.()};return new Promise((ge,ve)=>{for(const Re of _)Re.then(fe=>{--K>=0&&c(fe)?(Q(),ge(fe)):K===0&&ge(A)}).catch(fe=>{--K>=0&&(Q(),ve(fe))})})}class D{constructor(c){this.a=0,this.b=!1,this.f=c,this.g=[],this.d=0,this.h=new R.$le}whenIdle(){return this.size>0?R.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(c){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((A,K)=>{this.g.push({factory:c,c:A,e:K}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const c=this.g.shift();this.d++;const A=c.factory();A.then(c.c,c.e),A.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=D;class b extends D{constructor(){super(1)}}e.$Mh=b;class G{constructor(){this.a=new V,this.b=0}queue(c){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,c())):this.a.run(this.b++,c())}}e.$Nh=G;class x{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const c=new E;return this.b.add(c),c.p}g(){for(const[,c]of this.a)if(c.size>0)return!1;return!0}queueSize(c,A=J.$9g){const K=A.getComparisonKey(c);return this.a.get(K)?.size??0}queueFor(c,A,K=J.$9g){const Q=K.getComparisonKey(c);let ge=this.a.get(Q);if(!ge){ge=new b;const ve=this.f++,Re=R.Event.once(ge.onDrained)(()=>{ge?.dispose(),this.a.delete(Q),this.h(),this.d?.deleteAndDispose(ve),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new p.$4c),this.d.set(ve,Re),this.a.set(Q,ge)}return ge.queue(A)}h(){this.g()&&this.j()}j(){for(const c of this.b)c.complete();this.b.clear()}dispose(){for(const[,c]of this.a)c.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=x;class Z{constructor(c,A){this.b=!1,this.a=-1,typeof c=="function"&&typeof A=="number"&&this.setIfNotSet(c,A)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(c,A){if(this.b)throw new t.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,c()},A)}setIfNotSet(c,A){if(this.b)throw new t.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,c()},A))}}e.$Ph=Z;class H{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(c,A,K=globalThis){if(this.f)throw new t.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const Q=K.setInterval(()=>{c()},A);this.d=(0,p.$Sc)(()=>{K.clearInterval(Q),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=H;class ce{constructor(c,A){this.b=-1,this.a=c,this.d=A,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(c=this.d){this.cancel(),this.b=setTimeout(this.f,c)}get delay(){return this.d}set delay(c){this.d=c}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=ce;class F{constructor(c,A){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.a=c,this.b=A,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(c=this.b){c%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${c}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(c/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=F;class X extends ce{constructor(c,A){super(c,A),this.j=[]}work(c){this.j.push(c),this.isScheduled()||this.schedule()}h(){const c=this.j;this.j=[],this.a?.(c)}dispose(){this.j=[],super.dispose()}}e.$Th=X;class C extends p.$Uc{constructor(c,A){super(),this.g=c,this.h=A,this.a=[],this.b=this.B(new p.$Vc),this.f=!1}get pending(){return this.a.length}work(c){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+c.length>this.g.maxBufferedWork)return!1}else if(this.pending+c.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const A of c)this.a.push(A);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ce(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=C,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(_,c)=>{(0,O.$C)(()=>{if(A)return;const K=Date.now()+15;c(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,K-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.$Wh=(_,c,A)=>{const K=_.requestIdleCallback(c,typeof A=="number"?{timeout:A}:void 0);let Q=!1;return{dispose(){Q||(Q=!0,_.cancelIdleCallback(K))}}},e.$Vh=_=>(0,e.$Wh)(globalThis,_)}();class ee{constructor(c,A){this.g=!1,this.d=()=>{try{this.j=A()}catch(K){this.l=K}finally{this.g=!0}},this.f=(0,e.$Wh)(c,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=ee;class M extends ee{constructor(c){super(globalThis,c)}}e.$Yh=M;async function z(_,c,A){let K;for(let Q=0;Q<A;Q++)try{return await _()}catch(ge){K=ge,await h(c)}throw K}class V{isRunning(c){return typeof c=="number"?this.a?.taskId===c:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(c,A,K){return this.a={taskId:c,cancel:()=>K?.(),promise:A},A.then(()=>this.d(c),()=>this.d(c)),A}d(c){this.a&&c===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const c=this.b;this.b=void 0,c.run().then(c.promiseResolve,c.promiseReject)}}queue(c){if(this.b)this.b.run=c;else{const{promise:A,resolve:K,reject:Q}=g();this.b={run:c,promise:A,promiseResolve:K,promiseReject:Q}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=V;class te{constructor(c,A=()=>Date.now()){this.d=c,this.f=A,this.a=0,this.b=0}increment(){const c=this.f();return c-this.a>this.d&&(this.a=c,this.b=0),this.b++,this.b}}e.$2h=te;var ue;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(ue||(ue={}));class E{get isRejected(){return this.d?.outcome===ue.Rejected}get isResolved(){return this.d?.outcome===ue.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ue.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((c,A)=>{this.a=c,this.b=A})}complete(c){return new Promise(A=>{this.a(c),this.d={outcome:ue.Resolved,value:c},A()})}error(c){return new Promise(A=>{this.b(c),this.d={outcome:ue.Rejected,value:c},A()})}cancel(){return this.error(new t.$4)}}e.$3h=E;var ne;(function(_){async function c(K){let Q;const ge=await Promise.all(K.map(ve=>ve.then(Re=>Re,Re=>{Q||(Q=Re)})));if(typeof Q<"u")throw Q;return ge}_.settled=c;function A(K){return new Promise(async(Q,ge)=>{try{await K(Q,ge)}catch(ve){ge(ve)}})}_.withAsyncBody=A})(ne||(e.Promises=ne={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(c){this.a=void 0,this.b=void 0,this.d=!1,this.promise=c.then(A=>(this.a=A,this.d=!0,A),A=>{throw this.b=A,this.d=!0,A})}requireValue(){if(!this.d)throw new t.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=se;class re{constructor(c){this.b=c,this.a=new T.$T(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=re;var ae;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(ae||(ae={}));class de{static fromArray(c){return new de(A=>{A.emitMany(c)})}static fromPromise(c){return new de(async A=>{A.emitMany(await c)})}static fromPromises(c){return new de(async A=>{await Promise.all(c.map(async K=>A.emitOne(await K)))})}static merge(c){return new de(async A=>{await Promise.all(c.map(async K=>{for await(const Q of K)A.emitOne(Q)}))})}static{this.EMPTY=de.fromArray([])}constructor(c,A){this.a=ae.Initial,this.b=[],this.d=null,this.f=A,this.g=new R.$le,queueMicrotask(async()=>{const K={emitOne:Q=>this.h(Q),emitMany:Q=>this.j(Q),reject:Q=>this.l(Q)};try{await Promise.resolve(c(K)),this.k()}catch(Q){this.l(Q)}finally{K.emitOne=void 0,K.emitMany=void 0,K.reject=void 0}})}[Symbol.asyncIterator](){let c=0;return{next:async()=>{do{if(this.a===ae.DoneError)throw this.d;if(c<this.b.length)return{done:!1,value:this.b[c++]};if(this.a===ae.DoneOK)return{done:!0,value:void 0};await R.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(c,A){return new de(async K=>{for await(const Q of c)K.emitOne(A(Q))})}map(c){return de.map(this,c)}static filter(c,A){return new de(async K=>{for await(const Q of c)A(Q)&&K.emitOne(Q)})}filter(c){return de.filter(this,c)}static coalesce(c){return de.filter(c,A=>!!A)}coalesce(){return de.coalesce(this)}static async toPromise(c){const A=[];for await(const K of c)A.push(K);return A}toPromise(){return de.toPromise(this)}h(c){this.a===ae.Initial&&(this.b.push(c),this.g.fire())}j(c){this.a===ae.Initial&&(this.b=this.b.concat(c),this.g.fire())}k(){this.a===ae.Initial&&(this.a=ae.DoneOK,this.g.fire())}l(c){this.a===ae.Initial&&(this.a=ae.DoneError,this.d=c,this.g.fire())}}e.$6h=de;class De extends de{constructor(c,A){super(A),this.m=c}cancel(){this.m.cancel()}}e.$7h=De;function N(_){const c=new a.$we,A=_(c.token);return new De(c,async K=>{const Q=c.token.onCancellationRequested(()=>{Q.dispose(),c.dispose(),K.reject(new t.$4)});try{for await(const ge of A){if(c.token.isCancellationRequested)return;K.emitOne(ge)}Q.dispose(),c.dispose()}catch(ge){Q.dispose(),c.dispose(),K.reject(ge)}})}class B{constructor(c){this.a=new E,this.b=new de(Q=>{if(A){Q.reject(A);return}return K&&Q.emitMany(K),this.d=ge=>Q.reject(ge),this.f=ge=>Q.emitOne(ge),this.a.p},c);let A,K;this.f=Q=>{K||(K=[]),K.push(Q)},this.d=Q=>{A||(A=Q)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(c){this.d(c),this.a.complete()}emitOne(c){this.f(c)}}e.$9h=B}),define(be[40],Ee([0,1,13,8,7,5,15,3,2,4]),function(oe,e,a,t,R,p,J,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$vk=j,e.$yk=r,e.$zk=G,e.$Ak=x,e.$Bk=Z,e.$Ck=H,e.$Dk=ce,e.$Ek=ee;function j(){return Object.create(null)}e.$wk="**",e.$xk="/";const q="[/\\\\]",I="[^/\\\\]",W=/\//g;function f(M,z){switch(M){case 0:return"";case 1:return`${I}*?`;default:return`(?:${q}|${I}+${q}${z?`|${q}${I}+`:""})*?`}}function r(M,z){if(!M)return[];const V=[];let te=!1,ue=!1,E="";for(const ne of M){switch(ne){case z:if(!te&&!ue){V.push(E),E="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}E+=ne}return E&&V.push(E),V}function u(M){if(!M)return"";let z="";const V=r(M,e.$xk);if(V.every(te=>te===e.$wk))z=".*";else{let te=!1;V.forEach((ue,E)=>{if(ue===e.$wk){if(te)return;z+=f(2,E===V.length-1)}else{let ne=!1,se="",re=!1,ae="";for(const de of ue){if(de!=="}"&&ne){se+=de;continue}if(re&&(de!=="]"||!ae)){let De;de==="-"?De=de:(de==="^"||de==="!")&&!ae?De="^":de===e.$xk?De="":De=(0,T.$hf)(de),ae+=De;continue}switch(de){case"{":ne=!0;continue;case"[":re=!0;continue;case"}":{const N=`(?:${r(se,",").map(B=>u(B)).join("|")})`;z+=N,ne=!1,se="";break}case"]":{z+="["+ae+"]",re=!1,ae="";break}case"?":z+=I;continue;case"*":z+=f(1);continue;default:z+=(0,T.$hf)(de)}}E<V.length-1&&(V[E+1]!==e.$wk||E+2<V.length)&&(z+=q)}te=ue===e.$wk})}return z}const g=/^\*\*\/\*\.[\w\.-]+$/,y=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,k=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new J.$Dc(1e4),s=function(){return!1},m=function(){return null};function P(M,z){if(!M)return m;let V;typeof M!="string"?V=M.pattern:V=M,V=V.trim();const te=`${V}_${!!z.trimForExclusions}`;let ue=n.get(te);if(ue)return h(ue,M);let E;return g.test(V)?ue=l(V.substr(4),V):(E=y.exec($(V,z)))?ue=o(E[1],V):(z.trimForExclusions?k:v).test(V)?ue=U(V,z):(E=w.exec($(V,z)))?ue=D(E[1].substr(1),V,!0):(E=i.exec($(V,z)))?ue=D(E[1],V,!1):ue=b(V),n.set(te,ue),h(ue,M)}function h(M,z){if(typeof z=="string")return M;const V=function(te,ue){return(0,p.$Eg)(te,z.base,!L.$l)?M((0,T.$mf)(te.substr(z.base.length),O.sep),ue):null};return V.allBasenames=M.allBasenames,V.allPaths=M.allPaths,V.basenames=M.basenames,V.patterns=M.patterns,V}function $(M,z){return z.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function l(M,z){return function(V,te){return typeof V=="string"&&V.endsWith(M)?z:null}}function o(M,z){const V=`/${M}`,te=`\\${M}`,ue=function(ne,se){return typeof ne!="string"?null:se?se===M?z:null:ne===M||ne.endsWith(V)||ne.endsWith(te)?z:null},E=[M];return ue.basenames=E,ue.patterns=[z],ue.allBasenames=E,ue}function U(M,z){const V=C(M.slice(1,-1).split(",").map(se=>P(se,z)).filter(se=>se!==m),M),te=V.length;if(!te)return m;if(te===1)return V[0];const ue=function(se,re){for(let ae=0,de=V.length;ae<de;ae++)if(V[ae](se,re))return M;return null},E=V.find(se=>!!se.allBasenames);E&&(ue.allBasenames=E.allBasenames);const ne=V.reduce((se,re)=>re.allPaths?se.concat(re.allPaths):se,[]);return ne.length&&(ue.allPaths=ne),ue}function D(M,z,V){const te=O.sep===O.$gc.sep,ue=te?M:M.replace(W,O.sep),E=O.sep+ue,ne=O.$gc.sep+M;let se;return V?se=function(re,ae){return typeof re=="string"&&(re===ue||re.endsWith(E)||!te&&(re===M||re.endsWith(ne)))?z:null}:se=function(re,ae){return typeof re=="string"&&(re===ue||!te&&re===M)?z:null},se.allPaths=[(V?"*/":"./")+M],se}function b(M){try{const z=new RegExp(`^${u(M)}$`);return function(V){return z.lastIndex=0,typeof V=="string"&&z.test(V)?M:null}}catch{return m}}function G(M,z,V){return!M||typeof z!="string"?!1:x(M)(z,void 0,V)}function x(M,z={}){if(!M)return s;if(typeof M=="string"||Z(M)){const V=P(M,z);if(V===m)return s;const te=function(ue,E){return!!V(ue,E)};return V.allBasenames&&(te.allBasenames=V.allBasenames),V.allPaths&&(te.allPaths=V.allPaths),te}return F(M,z)}function Z(M){const z=M;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}function H(M){return M.allBasenames||[]}function ce(M){return M.allPaths||[]}function F(M,z){const V=C(Object.getOwnPropertyNames(M).map(se=>X(se,M[se],z)).filter(se=>se!==m)),te=V.length;if(!te)return m;if(!V.some(se=>!!se.requiresSiblings)){if(te===1)return V[0];const se=function(de,De){let N;for(let B=0,_=V.length;B<_;B++){const c=V[B](de,De);if(typeof c=="string")return c;(0,t.$rh)(c)&&(N||(N=[]),N.push(c))}return N?(async()=>{for(const B of N){const _=await B;if(typeof _=="string")return _}return null})():null},re=V.find(de=>!!de.allBasenames);re&&(se.allBasenames=re.allBasenames);const ae=V.reduce((de,De)=>De.allPaths?de.concat(De.allPaths):de,[]);return ae.length&&(se.allPaths=ae),se}const ue=function(se,re,ae){let de,De;for(let N=0,B=V.length;N<B;N++){const _=V[N];_.requiresSiblings&&ae&&(re||(re=(0,O.$nc)(se)),de||(de=re.substr(0,re.length-(0,O.$oc)(se).length)));const c=_(se,re,de,ae);if(typeof c=="string")return c;(0,t.$rh)(c)&&(De||(De=[]),De.push(c))}return De?(async()=>{for(const N of De){const B=await N;if(typeof B=="string")return B}return null})():null},E=V.find(se=>!!se.allBasenames);E&&(ue.allBasenames=E.allBasenames);const ne=V.reduce((se,re)=>re.allPaths?se.concat(re.allPaths):se,[]);return ne.length&&(ue.allPaths=ne),ue}function X(M,z,V){if(z===!1)return m;const te=P(M,V);if(te===m)return m;if(typeof z=="boolean")return te;if(z){const ue=z.when;if(typeof ue=="string"){const E=(ne,se,re,ae)=>{if(!ae||!te(ne,se))return null;const de=ue.replace("$(basename)",()=>re),De=ae(de);return(0,t.$rh)(De)?De.then(N=>N?M:null):De?M:null};return E.requiresSiblings=!0,E}}return te}function C(M,z){const V=M.filter(se=>!!se.basenames);if(V.length<2)return M;const te=V.reduce((se,re)=>{const ae=re.basenames;return ae?se.concat(ae):se},[]);let ue;if(z){ue=[];for(let se=0,re=te.length;se<re;se++)ue.push(z)}else ue=V.reduce((se,re)=>{const ae=re.patterns;return ae?se.concat(ae):se},[]);const E=function(se,re){if(typeof se!="string")return null;if(!re){let de;for(de=se.length;de>0;de--){const De=se.charCodeAt(de-1);if(De===R.CharCode.Slash||De===R.CharCode.Backslash)break}re=se.substr(de)}const ae=te.indexOf(re);return ae!==-1?ue[ae]:null};E.basenames=te,E.patterns=ue,E.allBasenames=te;const ne=M.filter(se=>!se.basenames);return ne.push(E),ne}function ee(M,z){return(0,a.$tb)(M,z,(V,te)=>typeof V=="string"&&typeof te=="string"?V===te:typeof V!="string"&&typeof te!="string"?V.base===te.base&&V.pattern===te.pattern:!1)}}),define(be[20],Ee([0,1,9,21,52,8,5,24,3,2,19,6]),function(oe,e,a,t,R,p,J,O,L,T,j,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=u,e.readdirSync=v,e.whenDeleted=i,e.configureFlushOnWrite=h,e.writeFileSync=l,a=pe(a);var I;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(I||(e.RimRafMode=I={}));async function W(F,X=I.UNLINK,C){if((0,J.$Ig)(F))throw new Error("rimraf - will refuse to recursively delete root");return X===I.UNLINK?r(F):f(F,C)}async function f(F,X=(0,J.$Ng)((0,t.tmpdir)())){try{try{await a.promises.rename(F,X)}catch(C){return C.code==="ENOENT"?void 0:r(F)}r(X).catch(C=>{})}catch(C){if(C.code!=="ENOENT")throw C}}async function r(F){return a.promises.rm(F,{recursive:!0,force:!0,maxRetries:3})}function u(F){if((0,J.$Ig)(F))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}async function g(F,X){return k(await(X?y(F):a.promises.readdir(F)))}async function y(F){try{return await a.promises.readdir(F,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const X=[],C=await g(F);for(const ee of C){let M=!1,z=!1,V=!1;try{const te=await a.promises.lstat((0,L.$jc)(F,ee));M=te.isFile(),z=te.isDirectory(),V=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}X.push({name:ee,isFile:()=>M,isDirectory:()=>z,isSymbolicLink:()=>V})}return X}function v(F){return k(a.readdirSync(F))}function k(F){return F.map(X=>typeof X=="string"?T.$k?(0,O.$nm)(X):X:(X.name=T.$k?(0,O.$nm)(X.name):X.name,X))}async function w(F){const X=await g(F),C=[];for(const ee of X)await n.existsDirectory((0,L.$jc)(F,ee))&&C.push(ee);return C}function i(F,X=1e3){return new Promise(C=>{let ee=!1;const M=setInterval(()=>{ee||(ee=!0,a.access(F,z=>{ee=!1,z&&(clearInterval(M),C(void 0))}))},X)})}var n;(function(F){async function X(M){let z;try{if(z=await a.promises.lstat(M),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await a.promises.stat(M),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(T.$j&&V.code==="EACCES")try{return{stat:await a.promises.stat(await a.promises.readlink(M)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw te}throw V}}F.stat=X;async function C(M){try{const{stat:z,symbolicLink:V}=await F.stat(M);return z.isFile()&&V?.dangling!==!0}catch{}return!1}F.existsFile=C;async function ee(M){try{const{stat:z,symbolicLink:V}=await F.stat(M);return z.isDirectory()&&V?.dangling!==!0}catch{}return!1}F.existsDirectory=ee})(n||(e.SymlinkSupport=n={}));const s=new p.$Oh;function m(F,X,C){return s.queueFor(q.URI.file(F),()=>{const ee=o(C);return new Promise((M,z)=>$(F,X,ee,V=>V?z(V):M()))},j.$0g)}let P=!0;function h(F){P=F}function $(F,X,C,ee){if(!P)return a.writeFile(F,X,{mode:C.mode,flag:C.flag},ee);a.open(F,C.flag,C.mode,(M,z)=>{if(M)return ee(M);a.writeFile(z,X,V=>{if(V)return a.close(z,()=>ee(V));a.fdatasync(z,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),h(!1)),a.close(z,ue=>ee(ue))))})})}function l(F,X,C){const ee=o(C);if(!P)return a.writeFileSync(F,X,{mode:ee.mode,flag:ee.flag});const M=a.openSync(F,ee.flag,ee.mode);try{a.writeFileSync(M,X);try{a.fdatasyncSync(M)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),h(!1)}}finally{a.closeSync(M)}}function o(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function U(F,X,C=6e4){if(F!==X)try{T.$j&&typeof C=="number"?await D(F,X,Date.now(),C):await a.promises.rename(F,X)}catch(ee){if(F.toLowerCase()!==X.toLowerCase()&&ee.code==="EXDEV"||F.endsWith("."))await b(F,X,{preserveSymlinks:!1}),await W(F,I.MOVE);else throw ee}}async function D(F,X,C,ee,M=0){try{return await a.promises.rename(F,X)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-C>=ee)throw console.error(`[node.js fs] rename failed after ${M} retries with error: ${z}`),z;if(M===0){let V=!1;try{const{stat:te}=await n.stat(X);te.isFile()||(V=!0)}catch{}if(V)throw z}return await(0,p.$Gh)(Math.min(100,M*10)),D(F,X,C,ee,M+1)}}async function b(F,X,C){return x(F,X,{root:{source:F,target:X},options:C,handledSourcePaths:new Set})}const G=511;async function x(F,X,C){if(C.handledSourcePaths.has(F))return;C.handledSourcePaths.add(F);const{stat:ee,symbolicLink:M}=await n.stat(F);if(M){if(C.options.preserveSymlinks)try{return await ce(F,X,C)}catch{}if(M.dangling)return}return ee.isDirectory()?Z(F,X,ee.mode&G,C):H(F,X,ee.mode&G)}async function Z(F,X,C,ee){await a.promises.mkdir(X,{recursive:!0,mode:C});const M=await g(F);for(const z of M)await x((0,L.$jc)(F,z),(0,L.$jc)(X,z),ee)}async function H(F,X,C){await a.promises.copyFile(F,X),await a.promises.chmod(X,C)}async function ce(F,X,C){let ee=await a.promises.readlink(F);(0,J.$Eg)(ee,C.root.source,!T.$l)&&(ee=(0,L.$jc)(C.root.target,ee.substr(C.root.source.length+1))),await a.promises.symlink(ee,X)}e.Promises=new class{get read(){return(F,X,C,ee,M)=>new Promise((z,V)=>{a.read(F,X,C,ee,M,(te,ue,E)=>te?V(te):z({bytesRead:ue,buffer:E}))})}get write(){return(F,X,C,ee,M)=>new Promise((z,V)=>{a.write(F,X,C,ee,M,(te,ue,E)=>te?V(te):z({bytesWritten:ue,buffer:E}))})}get fdatasync(){return(0,R.promisify)(a.fdatasync)}get open(){return(0,R.promisify)(a.open)}get close(){return(0,R.promisify)(a.close)}get realpath(){return(0,R.promisify)(a.realpath)}async exists(F){try{return await a.promises.access(F),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return w}get writeFile(){return m}get rm(){return W}get rename(){return U}get copy(){return b}}}),define(be[41],Ee([0,1,9,3,2,4,20]),function(oe,e,a,t,R,p,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=O,e.$mr=L,e.$nr=T,e.$or=j,a=pe(a);function O(I){if(R.$l)return I;const W=(0,t.$mc)(I);if(I===W)return I;const f=((0,t.$nc)(I)||I).toLowerCase();try{const u=(0,J.readdirSync)(W).filter(g=>g.toLowerCase()===f);if(u.length===1){const g=O(W);if(g)return(0,t.$jc)(g,u[0])}else if(u.length>1){const g=u.indexOf(f);if(g>=0){const y=O(W);if(y)return(0,t.$jc)(y,u[g])}}}catch{}return null}async function L(I,W){if(R.$l)return I;const f=(0,t.$mc)(I);if(I===f)return I;const r=((0,t.$nc)(I)||I).toLowerCase();try{if(W?.isCancellationRequested)return null;const g=(await J.Promises.readdir(f)).filter(y=>y.toLowerCase()===r);if(g.length===1){const y=await L(f,W);if(y)return(0,t.$jc)(y,g[0])}else if(g.length>1){const y=g.indexOf(r);if(y>=0){const v=await L(f,W);if(v)return(0,t.$jc)(v,g[y])}}}catch{}return null}async function T(I){try{return await J.Promises.realpath(I)}catch{const f=q(I);return await a.promises.access(f,a.constants.R_OK),f}}function j(I){try{return a.realpathSync(I)}catch{const f=q(I);return a.accessSync(f,a.constants.R_OK),f}}function q(I){return(0,p.$nf)((0,t.$hc)(I),t.sep)}}),define(be[42],Ee([0,1,53]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=t,e.$6g=p,a=pe(a);function t(O,L,T,j=1){let q=!1;return new Promise(I=>{const W=setTimeout(()=>{if(!q)return q=!0,I(0)},T);R(O,L,j,f=>{if(!q)return q=!0,clearTimeout(W),I(f)})})}function R(O,L,T,j){if(L===0)return j(0);const q=new a.Socket;q.once("connect",()=>(J(q),R(O+T,L-1,T,j))),q.once("data",()=>{}),q.once("error",I=>(J(q),I.code!=="ECONNREFUSED"?R(O+T,L-1,T,j):j(O))),q.connect(O,"127.0.0.1")}e.$5g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function p(O,L,T,j="127.0.0.1"){let q=!1,I,W=1;const f=a.createServer({pauseOnConnect:!0});function r(u,g){q||(q=!0,f.removeAllListeners(),f.close(),I&&clearTimeout(I),g(u))}return new Promise(u=>{I=setTimeout(()=>{r(0,u)},T),f.on("listening",()=>{r(O,u)}),f.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&W<L?(O++,W++,f.listen(O,j)):r(0,u)}),f.on("close",()=>{r(0,u)}),f.listen(O,j)})}function J(O){try{O.removeAllListeners("connect"),O.removeAllListeners("error"),O.end(),O.destroy(),O.unref()}catch(L){console.error(L)}}}),define(be[43],Ee([0,1,44,2]),function(oe,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TX=L;const R={437:"cp437",850:"cp850",852:"cp852",855:"cp855",857:"cp857",860:"cp860",861:"cp861",863:"cp863",865:"cp865",866:"cp866",869:"cp869",936:"cp936",1252:"cp1252"};function p(T){const j=T.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return J[j]||j}const J={ibm866:"cp866",big5:"cp950"},O="utf8";async function L(T){let j;const q=process.env.VSCODE_CLI_ENCODING;q?(T&&console.log(`Found VSCODE_CLI_ENCODING variable: ${q}`),j=Promise.resolve(q)):t.$j?j=new Promise(W=>{T&&console.log('Running "chcp" to detect terminal encoding...'),(0,a.exec)("chcp",(f,r,u)=>{if(r){T&&console.log(`Output from "chcp" command is: ${r}`);const g=Object.keys(R);for(const y of g)if(r.indexOf(y)>=0)return W(R[y])}return W(void 0)})}):j=new Promise(W=>{T&&console.log('Running "locale charmap" to detect terminal encoding...'),(0,a.exec)("locale charmap",(f,r,u)=>W(r))});const I=await j;return T&&console.log(`Detected raw terminal encoding: ${I}`),!I||I.toLowerCase()==="utf-8"||I.toLowerCase()===O?O:p(I)}}),function(){function oe(){function e(){return process.uncHostAllowlist}function a(L){const T=new Set;if(Array.isArray(L))for(const j of L)typeof j=="string"&&T.add(j);return Array.from(T)}function t(){const L=e();return L?Array.from(L):[]}function R(L){if(process.platform!=="win32")return;const T=e();if(T)if(typeof L=="string")T.add(L.toLowerCase());else for(const j of a(L))R(j)}function p(L){if(typeof L!="string")return;const T=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let j;for(const q of T){if(L.indexOf(q)!==0)continue;const W=L.indexOf("\\",q.length);if(W===-1)continue;const f=L.substring(q.length,W);if(f){j=f;break}}return j}function J(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function O(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:t,addUNCHostToAllowlist:R,getUNCHost:p,disableUNCAccessRestrictions:J,isUNCAccessRestrictionsDisabled:O}}typeof define=="function"?define("vs/base/node/unc",[],function(){return oe()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=oe():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(be[22],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=R,e.localize2=J;const a=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function t(O,L){let T;return L.length===0?T=O:T=O.replace(/\{(\d+)\}/g,(j,q)=>{const I=q[0],W=L[I];let f=j;return typeof W=="string"?f=W:(typeof W=="number"||typeof W=="boolean"||W===void 0||W===null)&&(f=String(W)),f}),a&&(T="\uFF3B"+T.replace(/[aouei]/g,"$&$&")+"\uFF3D"),T}function R(O,L,...T){return t(typeof O=="number"?p(O,L):L,T)}function p(O,L){const T=globalThis._VSCODE_NLS_MESSAGES?.[O];if(typeof T!="string"){if(typeof L=="string")return L;throw new Error(`!!! NLS MISSING: ${O} !!!`)}return T}function J(O,L,...T){let j;typeof O=="number"?j=p(O,L):j=L;const q=t(j,T);return{value:q,original:L===j?q:t(L,T)}}});var ze=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(be[26],Ee([0,1,54,2,22]),function(oe,e,a,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=void 0,e.$Dm=O,e.$Em=T,e.$Fm=W,e.$Gm=f,a=ze(a);const p={o:(0,R.localize)(11522,null),e:(0,R.localize)(11523,null),t:(0,R.localize)(11524,null)};e.$Bm=["tunnel","serve-web"],e.$Cm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,R.localize)(11525,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,R.localize)(11526,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(11527,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,R.localize)(11528,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(11529,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(11530,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(11531,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(11532,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(11533,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(11534,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(11535,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,R.localize)(11536,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11537,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,R.localize)(11538,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(11539,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(11540,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,R.localize)(11541,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,R.localize)(11542,null)},"pre-release":{type:"boolean",cat:"e",description:(0,R.localize)(11543,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,R.localize)(11544,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(11545,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,R.localize)(11546,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(11547,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,R.localize)(11548,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,R.localize)(11549,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(11550,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(11551,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,R.localize)(11552,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,R.localize)(11553,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(11554,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,R.localize)(11555,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,R.localize)(11556,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,R.localize)(11557,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(11558,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,R.localize)(11559,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(11560,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const J={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function O(r,u,g=J){const y=r.find(h=>h.length>0&&h[0]!=="-"),v={},k=["_"],w=[],i={};let n;for(const h in u){const $=u[h];$.type==="subcommand"?h===y&&(n=$):($.alias&&(v[h]=$.alias),$.type==="string"||$.type==="string[]"?(k.push(h),$.deprecates&&k.push(...$.deprecates)):$.type==="boolean"&&(w.push(h),$.deprecates&&w.push(...$.deprecates)),$.global&&(i[h]=$))}if(n&&y){const h=i;for(const U in n.options)h[U]=n.options[U];const $=r.filter(U=>U!==y),l=g.getSubcommandReporter?g.getSubcommandReporter(y):void 0,o=O($,h,l);return{[y]:o,_:[]}}const s=(0,a.default)(r,{string:k,boolean:w,alias:v}),m={},P=s;m._=s._.map(h=>String(h)).filter(h=>h.length>0),delete P._;for(const h in u){const $=u[h];if($.type==="subcommand")continue;$.alias&&delete P[$.alias];let l=P[h];if($.deprecates)for(const o of $.deprecates)P.hasOwnProperty(o)&&(l||(l=P[o],l&&g.onDeprecatedOption(o,$.deprecationMessage||(0,R.localize)(11561,null,h))),delete P[o]);if(typeof l<"u"){if($.type==="string[]"){if(Array.isArray(l)||(l=[l]),!$.allowEmptyValue){const o=l.filter(U=>U.length>0);o.length!==l.length&&(g.onEmptyValue(h),l=o.length>0?o:void 0)}}else $.type==="string"&&(Array.isArray(l)?(l=l.pop(),g.onMultipleValues(h,l)):!l&&!$.allowEmptyValue&&(g.onEmptyValue(h),l=void 0));m[h]=l,$.deprecationMessage&&g.onDeprecatedOption(h,$.deprecationMessage)}delete P[h]}for(const h in P)g.onUnknownOption(h);return m}function L(r,u){let g="";return u.args&&(Array.isArray(u.args)?g=` <${u.args.join("> <")}>`:g=` <${u.args}>`),u.alias?`-${u.alias} --${r}${g}`:`--${r}${g}`}function T(r,u){const g=[];for(const y in r){const v=r[y],k=L(y,v);g.push([k,v.description])}return j(g,u)}function j(r,u){const y=r.reduce((w,i)=>Math.max(w,i[0].length),12)+2+1;if(u-y<25)return r.reduce((w,i)=>w.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const v=u-y-1,k=[];for(const w of r){const i=w[0],n=I(w[1],v),s=q(y-i.length-2);k.push("  "+i+s+n[0]);for(let m=1;m<n.length;m++)k.push(q(y)+n[m])}return k}function q(r){return" ".repeat(r)}function I(r,u){const g=[];for(;r.length;){const y=r.length<u?r.length:r.lastIndexOf(" ",u),v=r.slice(0,y).trim();r=r.slice(y),g.push(v)}return g}function W(r,u,g,y,v){const k=process.stdout.isTTY&&process.stdout.columns||80,w=v?.noInputFiles!==!0?`[${(0,R.localize)(11562,null)}...]`:"",i=[`${r} ${g}`];i.push(""),i.push(`${(0,R.localize)(11563,null)}: ${u} [${(0,R.localize)(11564,null)}]${w}`),i.push(""),v?.noPipe!==!0&&(t.$j?i.push((0,R.localize)(11565,null,u)):i.push((0,R.localize)(11566,null,u)),i.push(""));const n={},s=[];for(const m in y){const P=y[m];if(P.type==="subcommand")P.description&&s.push({command:m,description:P.description});else if(P.description&&P.cat){let h=n[P.cat];h||(n[P.cat]=h={}),h[m]=P}}for(const m in n){const P=m,h=n[P];h&&(i.push(p[P]),i.push(...T(h,k)),i.push(""))}return s.length&&(i.push((0,R.localize)(11567,null)),i.push(...j(s.map(m=>[m.command,m.description]),k)),i.push("")),i.join(`
`)}function f(r,u){return`${r||(0,R.localize)(11568,null)}
${u||(0,R.localize)(11569,null)}
${process.arch}`}});var ze=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(be[45],Ee([0,1,55,22,26]),function(oe,e,a,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=O,e.$Im=L,e.$Jm=T,e.$Km=j,a=ze(a);function p(q,I){const W=(v,k)=>{console.warn((0,t.localize)(11516,null,v,k))},f=v=>{console.warn((0,t.localize)(11517,null,v))},r=(v,k)=>{console.warn((0,t.localize)(11518,null,v,k))},u=v=>({onUnknownOption:k=>{R.$Bm.includes(v)||console.warn((0,t.localize)(11519,null,k,v))},onMultipleValues:W,onEmptyValue:f,onDeprecatedOption:r,getSubcommandReporter:R.$Bm.includes(v)?u:void 0}),g={onUnknownOption:v=>{console.warn((0,t.localize)(11520,null,v))},onMultipleValues:W,onEmptyValue:f,onDeprecatedOption:r,getSubcommandReporter:u},y=(0,R.$Dm)(q,R.$Cm,I?g:void 0);return y.goto&&y._.forEach(v=>(0,a.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(v),(0,t.localize)(11521,null))),y}function J(q){const I=q.findIndex(W=>!/^-/.test(W));if(I>-1)return[...q.slice(0,I),...q.slice(I+1)]}function O(q){let[,...I]=q;process.env.VSCODE_DEV&&(I=J(I)||[]);const W=!j(process.env);return p(I,W)}function L(q){let[,,...I]=q;return process.env.VSCODE_DEV&&(I=J(I)||[]),p(I,!0)}function T(q,...I){const W=q.indexOf("--");return W===-1?q.push(...I):q.splice(W,0,...I),q}function j(q){return q.VSCODE_CLI==="1"}}),define(be[46],Ee([0,1,9,21,8,5,43]),function(oe,e,a,t,R,p,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=O,e.$0hc=L,e.$$hc=T,e.$_hc=j,a=pe(a);function O(){try{return!process.stdin.isTTY}catch{}return!1}function L(q){return new Promise(I=>{const W=()=>I(!0);setTimeout(()=>{process.stdin.removeListener("data",W),I(!1)},q),process.stdin.once("data",W)})}function T(){return(0,p.$Ng)((0,t.tmpdir)(),"code-stdin",3)}async function j(q,I,W){let[f,r]=await Promise.all([(0,J.$TX)(I),new Promise((y,v)=>{oe(["@vscode/iconv-lite-umd"],y,v)}).then(pe),a.promises.appendFile(q,"")]);r.encodingExists(f)||(console.log(`Unsupported terminal encoding: ${f}, falling back to UTF-8.`),f="utf8");const u=new R.$Mh,g=r.getDecoder(f);process.stdin.on("data",y=>{const v=g.write(y);u.queue(()=>a.promises.appendFile(q,v))}),process.stdin.on("end",()=>{const y=g.end();u.queue(async()=>{try{typeof y=="string"&&await a.promises.appendFile(q,y)}finally{W?.()}})})}}),define(be[47],Ee([0,1,9,21,5]),function(oe,e,a,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=p;function p(J){const O=(0,R.$Ng)((0,t.tmpdir)());try{return(0,a.writeFileSync)(O,""),J&&console.log(`Marker file for --wait created: ${O}`),O}catch(L){J&&console.error(`Failed to create marker file for --wait: ${L}`);return}}}),define(be[27],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=R,e.$Gi=p;var a;(function(J){J.serviceIds=new Map,J.DI_TARGET="$di$target",J.DI_DEPENDENCIES="$di$dependencies";function O(L){return L[J.DI_DEPENDENCIES]||[]}J.getServiceDependencies=O})(a||(e._util=a={})),e.$Ei=R("instantiationService");function t(J,O,L){O[a.DI_TARGET]===O?O[a.DI_DEPENDENCIES].push({id:J,index:L}):(O[a.DI_DEPENDENCIES]=[{id:J,index:L}],O[a.DI_TARGET]=O)}function R(J){if(a.serviceIds.has(J))return a.serviceIds.get(J);const O=function(L,T,j){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(O,L,j)};return O.toString=()=>J,a.serviceIds.set(J,O),O}function p(J){return J}}),define(be[28],Ee([0,1,39,3,4,25,6,22,27,2,18,14]),function(oe,e,a,t,R,p,J,O,L,T,j,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Fl=e.FileKind=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.FileOperationResult=e.$xl=e.$wl=e.$vl=e.$tl=e.FileChangeType=e.$sl=e.FileOperation=e.$ml=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$al=void 0,e.$bl=I,e.$cl=u,e.$dl=y,e.$el=v,e.$fl=k,e.$gl=w,e.$hl=i,e.$il=n,e.$jl=s,e.$kl=m,e.$ll=P,e.$nl=l,e.$ol=o,e.$pl=U,e.$ql=D,e.$rl=b,e.$ul=ce,e.$Gl=z,e.$Hl=V,e.$Jl=ue,e.$al=(0,L.$Fi)("fileService");function I(E){return E.create===!0}var W;(function(E){E[E.Unknown=0]="Unknown",E[E.File=1]="File",E[E.Directory=2]="Directory",E[E.SymbolicLink=64]="SymbolicLink"})(W||(e.FileType=W={}));var f;(function(E){E[E.Readonly=1]="Readonly",E[E.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var r;(function(E){E[E.UPDATED=2]="UPDATED",E[E.ADDED=4]="ADDED",E[E.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function u(E){const ne=E;return!!ne&&typeof ne.onDidChange=="function"}var g;(function(E){E[E.None=0]="None",E[E.FileReadWrite=2]="FileReadWrite",E[E.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",E[E.FileReadStream=16]="FileReadStream",E[E.FileFolderCopy=8]="FileFolderCopy",E[E.PathCaseSensitive=1024]="PathCaseSensitive",E[E.Readonly=2048]="Readonly",E[E.Trash=4096]="Trash",E[E.FileWriteUnlock=8192]="FileWriteUnlock",E[E.FileAtomicRead=16384]="FileAtomicRead",E[E.FileAtomicWrite=32768]="FileAtomicWrite",E[E.FileAtomicDelete=65536]="FileAtomicDelete",E[E.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function y(E){return!!(E.capabilities&g.FileReadWrite)}function v(E){return!!(E.capabilities&g.FileFolderCopy)}function k(E){return!!(E.capabilities&g.FileClone)}function w(E){return!!(E.capabilities&g.FileOpenReadWriteClose)}function i(E){return!!(E.capabilities&g.FileReadStream)}function n(E){return y(E)?!!(E.capabilities&g.FileAtomicRead):!1}function s(E){return y(E)?!!(E.capabilities&g.FileAtomicWrite):!1}function m(E){return!!(E.capabilities&g.FileAtomicDelete)}function P(E){return!!(E.capabilities&g.Readonly)}var h;(function(E){E.FileExists="EntryExists",E.FileNotFound="EntryNotFound",E.FileNotADirectory="EntryNotADirectory",E.FileIsADirectory="EntryIsADirectory",E.FileExceedsStorageQuota="EntryExceedsStorageQuota",E.FileTooLarge="EntryTooLarge",E.FileWriteLocked="EntryWriteLocked",E.NoPermissions="NoPermissions",E.Unavailable="Unavailable",E.Unknown="Unknown"})(h||(e.FileSystemProviderErrorCode=h={}));class $ extends Error{static create(ne,se){const re=new $(ne.toString(),se);return U(re,se),re}constructor(ne,se){super(ne),this.code=se}}e.$ml=$;function l(E,ne){return $.create(E,ne)}function o(E){return E||l((0,O.localize)(11385,null),h.Unknown)}function U(E,ne){return E.name=ne?`${ne} (FileSystemError)`:"FileSystemError",E}function D(E){if(!E)return h.Unknown;if(E instanceof $)return E.code;const ne=/^(.+) \(FileSystemError\)$/.exec(E.name);if(!ne)return h.Unknown;switch(ne[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}function b(E){if(E instanceof F)return E.fileOperationResult;switch(D(E)){case h.FileNotFound:return ee.FILE_NOT_FOUND;case h.FileIsADirectory:return ee.FILE_IS_DIRECTORY;case h.FileNotADirectory:return ee.FILE_NOT_DIRECTORY;case h.FileWriteLocked:return ee.FILE_WRITE_LOCKED;case h.NoPermissions:return ee.FILE_PERMISSION_DENIED;case h.FileExists:return ee.FILE_MOVE_CONFLICT;case h.FileTooLarge:return ee.FILE_TOO_LARGE;default:return ee.FILE_OTHER_ERROR}}var G;(function(E){E[E.CREATE=0]="CREATE",E[E.DELETE=1]="DELETE",E[E.MOVE=2]="MOVE",E[E.COPY=3]="COPY",E[E.WRITE=4]="WRITE"})(G||(e.FileOperation=G={}));class x{constructor(ne,se,re){this.resource=ne,this.operation=se,this.target=re}isOperation(ne){return this.operation===ne}}e.$sl=x;var Z;(function(E){E[E.UPDATED=0]="UPDATED",E[E.ADDED=1]="ADDED",E[E.DELETED=2]="DELETED"})(Z||(e.FileChangeType=Z={}));class H{static{this.a=null}constructor(ne,se){this.c=se,this.b=void 0,this.d=new q.$T(()=>{const re=a.$Li.forUris(()=>this.c);return re.fill(this.rawAdded.map(ae=>[ae,!0])),re}),this.f=new q.$T(()=>{const re=a.$Li.forUris(()=>this.c);return re.fill(this.rawUpdated.map(ae=>[ae,!0])),re}),this.g=new q.$T(()=>{const re=a.$Li.forUris(()=>this.c);return re.fill(this.rawDeleted.map(ae=>[ae,!0])),re}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const re of ne){switch(re.type){case Z.ADDED:this.rawAdded.push(re.resource);break;case Z.UPDATED:this.rawUpdated.push(re.resource);break;case Z.DELETED:this.rawDeleted.push(re.resource);break}this.b!==H.a&&(typeof re.cId=="number"?this.b===void 0?this.b=re.cId:this.b!==re.cId&&(this.b=H.a):this.b!==void 0&&(this.b=H.a))}}contains(ne,...se){return this.h(ne,{includeChildren:!1},...se)}affects(ne,...se){return this.h(ne,{includeChildren:!0},...se)}h(ne,se,...re){if(!ne)return!1;const ae=re.length>0;return!!((!ae||re.includes(Z.ADDED))&&(this.d.value.get(ne)||se.includeChildren&&this.d.value.findSuperstr(ne))||(!ae||re.includes(Z.UPDATED))&&(this.f.value.get(ne)||se.includeChildren&&this.f.value.findSuperstr(ne))||(!ae||re.includes(Z.DELETED))&&(this.g.value.findSubstr(ne)||se.includeChildren&&this.g.value.findSuperstr(ne)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ne){return this.b===ne}hasCorrelation(){return typeof this.b=="number"}}e.$tl=H;function ce(E,ne,se){return!E||!ne||E===ne||ne.length>E.length?!1:(ne.charAt(ne.length-1)!==t.sep&&(ne+=t.sep),se?(0,R.$Gf)(E,ne):E.indexOf(ne)===0)}class F extends Error{constructor(ne,se,re){super(ne),this.fileOperationResult=se,this.options=re}}e.$vl=F;class X extends F{constructor(ne,se,re,ae){super(ne,se,ae),this.fileOperationResult=se,this.size=re}}e.$wl=X;class C extends F{constructor(ne,se,re){super(ne,ee.FILE_NOT_MODIFIED_SINCE,re),this.stat=se}}e.$xl=C;var ee;(function(E){E[E.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",E[E.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",E[E.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",E[E.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",E[E.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",E[E.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",E[E.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",E[E.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",E[E.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",E[E.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",E[E.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ee||(e.FileOperationResult=ee={})),e.$yl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$zl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Al="files.associations",e.$Bl="files.exclude",e.$Cl="files.readonlyInclude",e.$Dl="files.readonlyExclude",e.$El="files.readonlyFromPermissions";var M;(function(E){E[E.FILE=0]="FILE",E[E.FOLDER=1]="FOLDER",E[E.ROOT_FOLDER=2]="ROOT_FOLDER"})(M||(e.FileKind=M={})),e.$Fl="";function z(E){if(!(typeof E.size!="number"||typeof E.mtime!="number"))return E.mtime.toString(29)+E.size.toString(31)}async function V(E,ne){if(!ne.hasProvider(J.URI.from({scheme:E.scheme})))return new Promise(se=>{const re=ne.onDidChangeFileSystemProviderRegistrations(ae=>{ae.scheme===E.scheme&&ae.added&&(re.dispose(),se())})})}class te{static{this.KB=1024}static{this.MB=te.KB*te.KB}static{this.GB=te.MB*te.KB}static{this.TB=te.GB*te.KB}static formatSize(ne){return(0,p.$ig)(ne)||(ne=0),ne<te.KB?(0,O.localize)(11386,null,ne.toFixed(0)):ne<te.MB?(0,O.localize)(11387,null,(ne/te.KB).toFixed(2)):ne<te.GB?(0,O.localize)(11388,null,(ne/te.MB).toFixed(2)):ne<te.TB?(0,O.localize)(11389,null,(ne/te.GB).toFixed(2)):(0,O.localize)(11390,null,(ne/te.TB).toFixed(2))}}e.$Il=te;function ue(E){const ne=typeof E=="string"||E?.scheme===j.Schemas.vscodeRemote;return typeof E!="string"&&E?.scheme===j.Schemas.file?1024*te.MB:ne?10*te.MB:T.$p?50*te.MB:1024*te.MB}}),define(be[48],Ee([0,1,40,11,3,2,6,28]),function(oe,e,a,t,R,p,J,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=e.$6q=void 0,e.$4q=L,e.$5q=T,e.$9q=W,e.$0q=f,e.$$q=r,e.$_q=u,e.$ar=y,e.$br=v;function L(k){return typeof k.correlationId=="number"}function T(k){return k.recursive===!0}class j extends t.$Uc{static{this.a=5}constructor(w,i,n,s){super(),this.h=w,this.j=i,this.m=n,this.n=s,this.c=this.B(new t.$Vc),this.f=void 0,this.g=0}s(){const w=new t.$Tc;this.c.value=w,this.b=this.r(w),this.b.setVerboseLogging(this.m),w.add(this.b.onDidChangeFile(i=>this.h(i))),w.add(this.b.onDidLogMessage(i=>this.j(i))),w.add(this.b.onDidError(i=>this.t(i.error,i.request)))}t(w,i){this.u(w,i)?this.g<j.a&&this.f?(this.y(`restarting watcher after unexpected error: ${w}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${w}`):this.y(w)}u(w,i){return!(!this.n.restartOnError||i||w.indexOf("No space left on device")!==-1||w.indexOf("EMFILE")!==-1)}w(w){this.g++,this.s(),this.watch(w)}async watch(w){this.f=w,await this.b?.watch(w)}async setVerboseLogging(w){this.m=w,await this.b?.setVerboseLogging(w)}y(w){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${w}`})}z(w){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${w}`})}dispose(){return this.b=void 0,super.dispose()}}e.$6q=j;class q extends j{constructor(w,i,n){super(w,i,n,{type:"node.js",restartOnError:!1})}}e.$7q=q;class I extends j{constructor(w,i,n){super(w,i,n,{type:"universal",restartOnError:!0})}}e.$8q=I;function W(k){return k.map(w=>({type:w.type,resource:J.URI.revive(w.resource),cId:w.cId}))}function f(k){const w=new g;for(const i of k)w.processEvent(i);return w.coalesce()}function r(k,w){return typeof w=="string"&&!w.startsWith(a.$wk)&&!(0,R.$ic)(w)?{base:k,pattern:w}:w}function u(k,w){const i=[];for(const n of w)i.push((0,a.$Ak)(r(k,n)));return i}class g{constructor(){this.a=new Set,this.b=new Map}c(w){return p.$l?w.resource.fsPath:w.resource.fsPath.toLowerCase()}processEvent(w){const i=this.b.get(this.c(w));let n=!1;if(i){const s=i.type,m=w.type;i.resource.fsPath!==w.resource.fsPath&&(w.type===O.FileChangeType.DELETED||w.type===O.FileChangeType.ADDED)?n=!0:s===O.FileChangeType.ADDED&&m===O.FileChangeType.DELETED?(this.b.delete(this.c(w)),this.a.delete(i)):s===O.FileChangeType.DELETED&&m===O.FileChangeType.ADDED?i.type=O.FileChangeType.UPDATED:s===O.FileChangeType.ADDED&&m===O.FileChangeType.UPDATED||(i.type=m)}else n=!0;n&&(this.a.add(w),this.b.set(this.c(w),w))}coalesce(){const w=[],i=[];return Array.from(this.a).filter(n=>n.type!==O.FileChangeType.DELETED?(w.push(n),!1):!0).sort((n,s)=>n.resource.fsPath.length-s.resource.fsPath.length).filter(n=>i.some(s=>(0,O.$ul)(n.resource.fsPath,s,!p.$l))?!1:(i.push(n.resource.fsPath),!0)).concat(w)}}function y(k,w){if(typeof w=="number")switch(k.type){case O.FileChangeType.ADDED:return(w&O.FileChangeFilter.ADDED)===0;case O.FileChangeType.DELETED:return(w&O.FileChangeFilter.DELETED)===0;case O.FileChangeType.UPDATED:return(w&O.FileChangeFilter.UPDATED)===0}return!1}function v(k){if(typeof k=="number"){const w=[];return k&O.FileChangeFilter.ADDED&&w.push("Added"),k&O.FileChangeFilter.DELETED&&w.push("Deleted"),k&O.FileChangeFilter.UPDATED&&w.push("Updated"),w.length===0?"<all>":`[${w.join(", ")}]`}return"<none>"}}),define(be[49],Ee([0,1,9,8,12,5,11,24,3,2,19,6,41,20,28,48]),function(oe,e,a,t,R,p,J,O,L,T,j,q,I,W,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0,e.$qr=g;class u extends J.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(v,k,w,i,n,s){super(),this.s=v,this.t=k,this.u=w,this.w=i,this.y=n,this.z=s,this.c=this.B(new t.$Uh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},m=>this.u(m))),this.f=this.B(new t.$Th(m=>this.M(m),u.b)),this.g=(0,r.$_q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,r.$_q)(this.s.path,this.s.includes):void 0,this.j=(0,r.$4q)(this.s)?this.s.filter:void 0,this.m=new R.$we,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const v=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const k=await a.promises.stat(v);if(this.m.token.isCancellationRequested)return;this.B(await this.G(v,k.isDirectory()))}catch(v){v.code!=="ENOENT"?this.O(v):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${v})`),this.D()}}D(){this.r=!0,this.w?.()}async F(v){let k=v.path;try{k=await W.Promises.realpath(v.path),v.path===k&&(k=await(0,I.$mr)(v.path,this.m.token)??v.path),v.path!==k&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${k})`)}catch{}return k}async G(v,k){const w=new J.$Tc;return this.H(v,k,w)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(v,k,w)),w}H(v,k,w){if(k)return!1;const i=q.URI.file(this.s.path),n=this.t?.subscribe(this.s.path,async(s,m)=>{if(!w.isDisposed)if(s){const P=await this.G(v,k);w.isDisposed?P.dispose():w.add(P)}else m&&(typeof m.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:i,type:m.type,cId:this.s.correlationId},!0)});return n?(w.add(n),!0):!1}async I(v,k,w){if(T.$k&&(0,p.$Eg)(v,"/Volumes/",!0)){this.O(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const i=new R.$we(this.m.token);w.add((0,J.$Sc)(()=>i.dispose(!0)));const n=new J.$Tc;w.add(n);try{const s=q.URI.file(this.s.path),m=(0,L.$nc)(v),P=(0,a.watch)(v);n.add((0,J.$Sc)(()=>{P.removeAllListeners(),P.close()})),this.Q(`Started watching: '${v}'`);const h=new Set;if(k)try{for(const l of await W.Promises.readdir(v))h.add(l)}catch(l){this.O(l)}if(i.token.isCancellationRequested)return;const $=new Map;n.add((0,J.$Sc)(()=>{for(const[,l]of $)l.dispose();$.clear()})),P.on("error",(l,o)=>{i.token.isCancellationRequested||(this.O(`Failed to watch ${v} for changes using fs.watch() (${l}, ${o})`),this.D())}),P.on("change",(l,o)=>{if(i.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${l}"] ${o}`);let U="";if(o&&(U=o.toString(),T.$k&&(U=(0,O.$nm)(U))),!(!U||l!=="change"&&l!=="rename"))if(k)if(l==="rename"){$.get(U)?.dispose();const D=setTimeout(async()=>{if($.delete(U),U===m&&!await W.Promises.exists(v)){this.J(s);return}if(i.token.isCancellationRequested)return;const b=await this.N((0,L.$jc)(v,U));if(i.token.isCancellationRequested)return;let G;b?h.has(U)?G=f.FileChangeType.UPDATED:(G=f.FileChangeType.ADDED,h.add(U)):(h.delete(U),G=f.FileChangeType.DELETED),this.L({resource:(0,j.$gh)(s,U),type:G,cId:this.s.correlationId})},u.a);$.set(U,(0,J.$Sc)(()=>clearTimeout(D)))}else{let D;h.has(U)?D=f.FileChangeType.UPDATED:(D=f.FileChangeType.ADDED,h.add(U)),this.L({resource:(0,j.$gh)(s,U),type:D,cId:this.s.correlationId})}else if(l==="rename"||U!==m){const D=setTimeout(async()=>{const b=await W.Promises.exists(v);i.token.isCancellationRequested||(b?(this.L({resource:s,type:f.FileChangeType.UPDATED,cId:this.s.correlationId},!0),n.add(await this.G(v,!1))):this.J(s))},u.a);n.clear(),n.add((0,J.$Sc)(()=>clearTimeout(D)))}else this.L({resource:s,type:f.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(s){i.token.isCancellationRequested||this.O(`Failed to watch ${v} for changes using fs.watch() (${s.toString()})`),this.D()}}J(v){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:v,type:f.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(v,k=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${v.type===f.FileChangeType.ADDED?"[ADDED]":v.type===f.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${v.resource.fsPath}`),!k&&this.g.some(w=>w(v.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${v.resource.fsPath}`):!k&&this.h&&this.h.length>0&&!this.h.some(w=>w(v.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${v.resource.fsPath}`):this.f.work(v))}M(v){const k=(0,r.$0q)(v),w=[];for(const n of k){if((0,r.$ar)(n,this.j)){this.z&&this.R(` >> ignored (filtered) ${n.resource.fsPath}`);continue}w.push(n)}if(w.length===0)return;if(this.z)for(const n of w)this.R(` >> normalized ${n.type===f.FileChangeType.ADDED?"[ADDED]":n.type===f.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`);this.c.work(w)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${w[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${w.length}, most recent change: ${w[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(v){if(T.$l)return W.Promises.exists(v);try{const k=(0,L.$nc)(v);return(await W.Promises.readdir((0,L.$mc)(v))).some(i=>i===k)}catch(k){return this.Q(k),!1}}setVerboseLogging(v){this.z=v}O(v){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}P(v){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}Q(v){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}R(v){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${v}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$pr=u;async function g(y,v,k,w,i=512){const n=await W.Promises.open(y,"r"),s=Buffer.allocUnsafe(i),m=new R.$we(w);let P,h=!1;const $={path:y,excludes:[],recursive:!1},l=new u($,void 0,o=>{(async()=>{for(const{type:U}of o)if(U===f.FileChangeType.UPDATED){if(h)return;h=!0;try{for(;!m.token.isCancellationRequested;){const{bytesRead:D}=await W.Promises.read(n,s,0,i,null);if(!D||m.token.isCancellationRequested)break;v(s.slice(0,D))}}catch(D){P=new Error(D),m.dispose(!0)}finally{h=!1}}})()});return await l.ready,k(),new Promise((o,U)=>{m.token.onCancellationRequested(async()=>{l.dispose();try{await W.Promises.close(n)}catch(D){P=new Error(D)}P?U(P):o()})})}}),define(be[50],Ee([0,1,16]),function(oe,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let t;const R=globalThis.vscode;if(typeof R<"u"&&typeof R.context<"u"){const p=R.context.configuration();if(p)t=p.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(t=globalThis._VSCODE_PRODUCT_JSON,a.env.VSCODE_DEV&&Object.assign(t,{nameShort:`${t.nameShort} Dev`,nameLong:`${t.nameLong} Dev`,dataFolderName:`${t.dataFolderName}-dev`,serverDataFolderName:t.serverDataFolderName?`${t.serverDataFolderName}-dev`:void 0}),!t.version){const p=globalThis._VSCODE_PACKAGE_JSON;Object.assign(t,{version:p.version})}}else t={},Object.keys(t).length===0&&Object.assign(t,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=t}),define(be[51],Ee([0,1,3,27]),function(oe,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$ZG=void 0,e.$ZG=(0,t.$Fi)("IV8InspectProfilingService");var R;(function(p){function J(L){return!!(L.samples&&L.timeDeltas)}p.isValidProfile=J;function O(L,T="noAbsolutePaths"){for(const j of L.nodes)j.callFrame&&j.callFrame.url&&((0,a.$ic)(j.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(j.callFrame.url))&&(j.callFrame.url=(0,a.$jc)(T,(0,a.$nc)(j.callFrame.url)));return L}p.rewriteAbsolutePaths=O})(R||(e.Utils=R={}))});var ze=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(be[56],Ee([0,1,44,9,21,17,3,2,34,20,42,49,26,45,46,47,50,12,5,51,18,16,57,6,8]),function(oe,e,a,t,R,p,J,O,L,T,j,q,I,W,f,r,u,g,y,v,k,w,i,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=P,u=ze(u);function m(l){return!!l["install-source"]||!!l["list-extensions"]||!!l["install-extension"]||!!l["uninstall-extension"]||!!l["update-extensions"]||!!l["locate-extension"]||!!l.telemetry}async function P(l){let o;try{o=(0,W.$Im)(l)}catch(U){console.error(U.message);return}for(const U of I.$Bm)if(o[U]){if(!u.default.tunnelApplicationName){console.error(`'${U}' command not supported in ${u.default.applicationName}`);return}const D={...process.env};delete D.ELECTRON_RUN_AS_NODE;const b=l.slice(l.indexOf(U)+1);return new Promise((G,x)=>{let Z;const H=["ignore","pipe","pipe"];if(process.env.VSCODE_DEV)Z=(0,a.spawn)("cargo",["run","--",U,...b],{cwd:(0,J.$jc)(h(),"cli"),stdio:H,env:D});else{const ce=process.platform==="darwin"?(0,J.$jc)((0,J.$mc)((0,J.$mc)(process.execPath)),"Resources","app"):(0,J.$mc)(process.execPath),F=(0,J.$jc)(ce,"bin",`${u.default.tunnelApplicationName}${O.$j?".exe":""}`);Z=(0,a.spawn)(F,[U,...b],{cwd:(0,w.cwd)(),stdio:H,env:D})}Z.stdout.pipe(process.stdout),Z.stderr.pipe(process.stderr),Z.on("exit",G),Z.on("error",x)})}if(o.help){const U=`${u.default.applicationName}${O.$j?".exe":""}`;console.log((0,I.$Fm)(u.default.nameLong,U,u.default.version,I.$Cm))}else if(o.version)console.log((0,I.$Gm)(u.default.version,u.default.commit));else if(o["locate-shell-integration-path"]){let U;switch(o["locate-shell-integration-path"]){case"bash":U="shellIntegration-bash.sh";break;case"pwsh":U="shellIntegration.ps1";break;case"zsh":U="shellIntegration-rc.zsh";break;case"fish":U="fish_xdg_data/fish/vendor_conf.d/shellIntegration.fish";break;default:throw new Error("Error using --locate-shell-integration-path: Invalid shell type")}console.log((0,J.$jc)(h(),"out","vs","workbench","contrib","terminal","browser","media",U))}else if(m(o)){await(await new Promise((D,b)=>{oe(["vs/code/node/cliProcessMain"],D,b)}).then(pe)).main(o);return}else if(o["file-write"]){const U=o._[0],D=o._[1];if(O.$j)for(const b of[U,D])(0,y.$Bg)(b)&&(0,i.addUNCHostToAllowlist)(n.URI.file(b).authority);if(!U||!D||U===D||!(0,J.$ic)(U)||!(0,J.$ic)(D)||!(0,t.existsSync)(U)||!(0,t.statSync)(U).isFile()||!(0,t.existsSync)(D)||!(0,t.statSync)(D).isFile())throw new Error("Using --file-write with invalid arguments.");try{let b=0,G=!1;o["file-chmod"]&&(b=(0,t.statSync)(D).mode,b&128||((0,t.chmodSync)(D,b|128),G=!0));const x=(0,t.readFileSync)(U);O.$j?((0,t.truncateSync)(D,0),(0,T.writeFileSync)(D,x,{flag:"r+"})):(0,T.writeFileSync)(D,x),G&&(0,t.chmodSync)(D,b)}catch(b){throw b.message=`Error using --file-write: ${b.message}`,b}}else{const U={...process.env,ELECTRON_NO_ATTACH_CONSOLE:"1"};delete U.ELECTRON_RUN_AS_NODE;const D=[];o.verbose&&(U.ELECTRON_ENABLE_LOGGING="1"),(o.verbose||o.status)&&D.push(async F=>{F.stdout?.on("data",X=>console.log(X.toString("utf8").trim())),F.stderr?.on("data",X=>console.log(X.toString("utf8").trim())),await p.Event.toPromise(p.Event.fromNodeEventEmitter(F,"exit"))});const b=o._.some(F=>F==="-");b&&(o._=o._.filter(F=>F!=="-"),l=l.filter(F=>F!=="-"));let G;if((0,f.$9hc)())if(b){G=(0,f.$$hc)();try{const F=new s.$3h;await(0,f.$_hc)(G,!!o.verbose,()=>F.complete()),o.wait||D.push(()=>F.p),(0,W.$Jm)(l,G),(0,W.$Jm)(l,"--skip-add-to-recently-opened"),console.log(`Reading from stdin via: ${G}`)}catch(F){console.log(`Failed to create file to read via stdin: ${F.toString()}`),G=void 0}}else D.push(F=>(0,f.$0hc)(1e3).then(X=>{X&&(O.$j?console.log(`Run with '${u.default.applicationName} -' to read output from another program (e.g. 'echo Hello World | ${u.default.applicationName} -').`):console.log(`Run with '${u.default.applicationName} -' to read from stdin (e.g. 'ps aux | grep code | ${u.default.applicationName} -').`))}));const x=O.$k&&(0,R.release)()>"20.0.0";let Z;if(o.wait&&(Z=(0,r.$Nhc)(o.verbose),Z&&(0,W.$Jm)(l,"--waitMarkerFilePath",Z),D.push(async F=>{let X;x?X=new Promise(C=>{F.on("exit",(ee,M)=>{(ee!==0||M)&&C()})}):X=p.Event.toPromise(p.Event.fromNodeEventEmitter(F,"exit"));try{await Promise.race([(0,T.whenDeleted)(Z),p.Event.toPromise(p.Event.fromNodeEventEmitter(F,"error")),X])}finally{G&&(0,t.unlinkSync)(G)}})),o["prof-startup"]){const F="127.0.0.1",X=await(0,j.$4g)((0,L.$FX)(),10,3e3),C=await(0,j.$4g)(X+1,10,3e3),ee=await(0,j.$4g)(C+1,10,3e3);if(X*C*ee===0)throw new Error("Failed to find free ports for profiler. Make sure to shutdown all instances of the editor first.");const M=(0,y.$Ng)((0,R.homedir)(),"prof");(0,W.$Jm)(l,`--inspect-brk=${F}:${X}`),(0,W.$Jm)(l,`--remote-debugging-port=${F}:${C}`),(0,W.$Jm)(l,`--inspect-brk-extensions=${F}:${ee}`),(0,W.$Jm)(l,"--prof-startup-prefix",M),(0,W.$Jm)(l,"--no-cached-data"),(0,T.writeFileSync)(M,l.slice(-6).join("|")),D.push(async z=>{class V{static async start(ue,E,ne){const se=await new Promise((ae,de)=>{oe(["v8-inspect-profiler"],ae,de)}).then(pe);let re;try{re=await se.startProfiling({...ne,host:F})}catch{console.error(`FAILED to start profiling for '${ue}' on port '${ne.port}'`)}return{async stop(){if(!re)return;let ae="";const de=await re.stop();process.env.VSCODE_DEV||(de.profile=v.Utils.rewriteAbsolutePaths(de.profile,"piiRemoved"),ae=".txt"),(0,T.writeFileSync)(`${E}.${ue}.cpuprofile${ae}`,JSON.stringify(de.profile,void 0,4))}}}}try{const te=V.start("main",M,{port:X}),ue=V.start("extHost",M,{port:ee,tries:300}),E=V.start("renderer",M,{port:C,tries:200,target:function(ae){return ae.filter(de=>de.webSocketDebuggerUrl?de.type==="page"?de.url.indexOf("workbench/workbench.html")>0||de.url.indexOf("workbench/workbench-dev.html")>0:!0:!1)[0]}}),ne=await te,se=await ue,re=await E;await(0,T.whenDeleted)(M),await ne.stop(),await re.stop(),await se.stop(),(0,T.writeFileSync)(M,"")}catch{console.error("Failed to profile startup. Make sure to quit Code first.")}})}const H={detached:!0,env:U};o.verbose||(H.stdio="ignore");let ce;if(!x)!o.verbose&&o.status&&(H.stdio=["ignore","pipe","ignore"]),ce=(0,a.spawn)(process.execPath,l.slice(2),H);else{const F=["-n","-g"];if(F.push("-a",process.execPath),o.verbose||o.status){F.push("--wait-apps");for(const X of o.verbose?["stdout","stderr"]:["stdout"]){const C=(0,y.$Ng)((0,R.tmpdir)(),`code-${X}`);(0,T.writeFileSync)(C,""),F.push(`--${X}`,C),D.push(async ee=>{try{const M=X==="stdout"?process.stdout:process.stderr,z=new g.$we;ee.on("close",()=>{setTimeout(()=>z.dispose(!0),200)}),await(0,q.$qr)(C,V=>M.write(V),()=>{},z.token)}finally{(0,t.unlinkSync)(C)}})}}for(const X in U)X!=="_"&&(F.push("--env"),F.push(`${X}=${U[X]}`));if(F.push("--args",...l.slice(2)),U.VSCODE_DEV){const X=".",C=F.indexOf(X);C!==-1&&(F[C]=(0,J.$kc)(X))}ce=(0,a.spawn)("open",F,{...H,env:{}})}return Promise.all(D.map(F=>F(ce)))}}function h(){return(0,J.$mc)(k.$Zg.asFileUri("").fsPath)}function $(l){setTimeout(()=>process.exit(l),0)}P(process.argv).then(()=>$(0)).then(null,l=>{console.error(l.message||l.stack||l),$(1)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/1d82f317af9c90b96a433fd6a599e4b1d31869a3/core/vs/code/node/cli.js.map
