/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var he=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/platform/storage/common/storage","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/map","vs/base/common/uuid","fs","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/process","os","vs/base/common/charCode","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/externalServices/common/serviceMachineId","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/marshallingIds","vs/base/common/marshalling","net","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/common/date","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationModels","vs/platform/languagePacks/common/languagePacks","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/processes","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/jsonSchema","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/common/console","vs/amdX","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/osDisplayProtocolInfo","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/ports","vs/base/node/processes","vs/base/node/ps","vs/base/parts/sandbox/node/electronTypes","vs/base/parts/ipc/node/ipc.mp","vs/base/common/jsonErrorMessages","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ue=function(ae){for(var e=[],R=0,a=ae.length;R<a;R++)e[R]=he[ae[R]];return e};define(he[128],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.LoaderEventType=e.$R=void 0,e.$R=!1;var R;(function(C){C[C.LoaderAvailable=1]="LoaderAvailable",C[C.BeginLoadingScript=10]="BeginLoadingScript",C[C.EndLoadingScriptOK=11]="EndLoadingScriptOK",C[C.EndLoadingScriptError=12]="EndLoadingScriptError",C[C.BeginInvokeFactory=21]="BeginInvokeFactory",C[C.EndInvokeFactory=22]="EndInvokeFactory",C[C.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",C[C.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",C[C.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",C[C.NodeEndNativeRequire=34]="NodeEndNativeRequire",C[C.CachedDataFound=60]="CachedDataFound",C[C.CachedDataMissed=61]="CachedDataMissed",C[C.CachedDataRejected=62]="CachedDataRejected",C[C.CachedDataCreated=63]="CachedDataCreated"})(R||(e.LoaderEventType=R={}));class a{static get(){const A=new Map,T=new Map,k=new Map,O=new Map;function b(l,m){l.has(m.detail)||l.set(m.detail,-m.timestamp)}function I(l,m){const E=l.get(m.detail);E&&(E>=0||l.set(m.detail,E+m.timestamp))}let $=[];typeof ae=="function"&&typeof ae.getStats=="function"&&($=ae.getStats().slice(0).sort((l,m)=>l.timestamp-m.timestamp));for(const l of $)switch(l.type){case R.BeginLoadingScript:b(A,l);break;case R.EndLoadingScriptOK:case R.EndLoadingScriptError:I(A,l);break;case R.BeginInvokeFactory:b(T,l);break;case R.EndInvokeFactory:I(T,l);break;case R.NodeBeginNativeRequire:b(k,l);break;case R.NodeEndNativeRequire:I(k,l);break;case R.NodeBeginEvaluatingScript:b(O,l);break;case R.NodeEndEvaluatingScript:I(O,l);break}let d=0;k.forEach(l=>d+=l);function g(l){const m=[];return l.forEach((E,f)=>m.push([f,E])),m}return{amdLoad:g(A),amdInvoke:g(T),nodeRequire:g(k),nodeEval:g(O),nodeRequireTotal:d}}static toMarkdownTable(A,T){let k="";const O=[];return A.forEach((b,I)=>{O[I]=b.length}),T.forEach(b=>{b.forEach((I,$)=>{typeof I>"u"&&(I=b[$]="-");const d=I.toString().length;O[$]=Math.max(d,O[$])})}),A.forEach((b,I)=>{k+=`| ${b+" ".repeat(O[I]-b.toString().length)} `}),k+=`|
`,A.forEach((b,I)=>{k+=`| ${"-".repeat(O[I])} `}),k+=`|
`,T.forEach(b=>{b.forEach((I,$)=>{typeof I<"u"&&(k+=`| ${I+" ".repeat(O[$]-I.toString().length)} `)}),k+=`|
`}),k}}e.$S=a}),define(he[129],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=R,e.$fb=a,e.$gb=C,e.$hb=A,e.$ib=T,e.$jb=k,e.$kb=O,e.$mb=I,e.$nb=$,e.$ob=d,e.$pb=g,e.$qb=l;function R(m,E){const f=a(m,E);if(f!==-1)return m[f]}function a(m,E,f=m.length-1){for(let w=f;w>=0;w--){const P=m[w];if(E(P))return w}return-1}function C(m,E){const f=A(m,E);return f===-1?void 0:m[f]}function A(m,E,f=0,w=m.length){let P=f,p=w;for(;P<p;){const c=Math.floor((P+p)/2);E(m[c])?P=c+1:p=c}return P-1}function T(m,E){const f=k(m,E);return f===m.length?void 0:m[f]}function k(m,E,f=0,w=m.length){let P=f,p=w;for(;P<p;){const c=Math.floor((P+p)/2);E(m[c])?p=c:P=c+1}return P}function O(m,E,f=0,w=m.length){const P=k(m,E,f,w);return P===m.length?-1:P}class b{static{this.assertInvariants=!1}constructor(E){this.e=E,this.c=0}findLastMonotonous(E){if(b.assertInvariants){if(this.d){for(const w of this.e)if(this.d(w)&&!E(w))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=E}const f=A(this.e,E,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}e.$lb=b;function I(m,E){if(m.length===0)return;let f=m[0];for(let w=1;w<m.length;w++){const P=m[w];E(P,f)>0&&(f=P)}return f}function $(m,E){if(m.length===0)return;let f=m[0];for(let w=1;w<m.length;w++){const P=m[w];E(P,f)>=0&&(f=P)}return f}function d(m,E){return I(m,(f,w)=>-E(f,w))}function g(m,E){if(m.length===0)return-1;let f=0;for(let w=1;w<m.length;w++){const P=m[w];E(P,m[f])>0&&(f=w)}return f}function l(m,E){for(const f of m){const w=E(f);if(w!==void 0)return w}}}),define(he[39],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var R;(function(a){a[a.Null=0]="Null",a[a.Backspace=8]="Backspace",a[a.Tab=9]="Tab",a[a.LineFeed=10]="LineFeed",a[a.CarriageReturn=13]="CarriageReturn",a[a.Space=32]="Space",a[a.ExclamationMark=33]="ExclamationMark",a[a.DoubleQuote=34]="DoubleQuote",a[a.Hash=35]="Hash",a[a.DollarSign=36]="DollarSign",a[a.PercentSign=37]="PercentSign",a[a.Ampersand=38]="Ampersand",a[a.SingleQuote=39]="SingleQuote",a[a.OpenParen=40]="OpenParen",a[a.CloseParen=41]="CloseParen",a[a.Asterisk=42]="Asterisk",a[a.Plus=43]="Plus",a[a.Comma=44]="Comma",a[a.Dash=45]="Dash",a[a.Period=46]="Period",a[a.Slash=47]="Slash",a[a.Digit0=48]="Digit0",a[a.Digit1=49]="Digit1",a[a.Digit2=50]="Digit2",a[a.Digit3=51]="Digit3",a[a.Digit4=52]="Digit4",a[a.Digit5=53]="Digit5",a[a.Digit6=54]="Digit6",a[a.Digit7=55]="Digit7",a[a.Digit8=56]="Digit8",a[a.Digit9=57]="Digit9",a[a.Colon=58]="Colon",a[a.Semicolon=59]="Semicolon",a[a.LessThan=60]="LessThan",a[a.Equals=61]="Equals",a[a.GreaterThan=62]="GreaterThan",a[a.QuestionMark=63]="QuestionMark",a[a.AtSign=64]="AtSign",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.OpenSquareBracket=91]="OpenSquareBracket",a[a.Backslash=92]="Backslash",a[a.CloseSquareBracket=93]="CloseSquareBracket",a[a.Caret=94]="Caret",a[a.Underline=95]="Underline",a[a.BackTick=96]="BackTick",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.OpenCurlyBrace=123]="OpenCurlyBrace",a[a.Pipe=124]="Pipe",a[a.CloseCurlyBrace=125]="CloseCurlyBrace",a[a.Tilde=126]="Tilde",a[a.NoBreakSpace=160]="NoBreakSpace",a[a.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",a[a.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",a[a.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",a[a.U_Combining_Tilde=771]="U_Combining_Tilde",a[a.U_Combining_Macron=772]="U_Combining_Macron",a[a.U_Combining_Overline=773]="U_Combining_Overline",a[a.U_Combining_Breve=774]="U_Combining_Breve",a[a.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",a[a.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",a[a.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",a[a.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",a[a.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",a[a.U_Combining_Caron=780]="U_Combining_Caron",a[a.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",a[a.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",a[a.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",a[a.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",a[a.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",a[a.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",a[a.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",a[a.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",a[a.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",a[a.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",a[a.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",a[a.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",a[a.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",a[a.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",a[a.U_Combining_Horn=795]="U_Combining_Horn",a[a.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",a[a.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",a[a.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",a[a.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",a[a.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",a[a.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",a[a.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",a[a.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",a[a.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",a[a.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",a[a.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",a[a.U_Combining_Cedilla=807]="U_Combining_Cedilla",a[a.U_Combining_Ogonek=808]="U_Combining_Ogonek",a[a.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",a[a.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",a[a.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",a[a.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",a[a.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",a[a.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",a[a.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",a[a.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",a[a.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",a[a.U_Combining_Low_Line=818]="U_Combining_Low_Line",a[a.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",a[a.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",a[a.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",a[a.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",a[a.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",a[a.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",a[a.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",a[a.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",a[a.U_Combining_Square_Below=827]="U_Combining_Square_Below",a[a.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",a[a.U_Combining_X_Above=829]="U_Combining_X_Above",a[a.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",a[a.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",a[a.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",a[a.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",a[a.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",a[a.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",a[a.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",a[a.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",a[a.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",a[a.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",a[a.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",a[a.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",a[a.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",a[a.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",a[a.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",a[a.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",a[a.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",a[a.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",a[a.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",a[a.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",a[a.U_Combining_Fermata=850]="U_Combining_Fermata",a[a.U_Combining_X_Below=851]="U_Combining_X_Below",a[a.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",a[a.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",a[a.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",a[a.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",a[a.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",a[a.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",a[a.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",a[a.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",a[a.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",a[a.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",a[a.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",a[a.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",a[a.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",a[a.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",a[a.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",a[a.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",a[a.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",a[a.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",a[a.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",a[a.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",a[a.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",a[a.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",a[a.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",a[a.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",a[a.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",a[a.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",a[a.LINE_SEPARATOR=8232]="LINE_SEPARATOR",a[a.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",a[a.NEXT_LINE=133]="NEXT_LINE",a[a.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",a[a.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",a[a.U_DIAERESIS=168]="U_DIAERESIS",a[a.U_MACRON=175]="U_MACRON",a[a.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",a[a.U_CEDILLA=184]="U_CEDILLA",a[a.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",a[a.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",a[a.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",a[a.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",a[a.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",a[a.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",a[a.U_BREVE=728]="U_BREVE",a[a.U_DOT_ABOVE=729]="U_DOT_ABOVE",a[a.U_RING_ABOVE=730]="U_RING_ABOVE",a[a.U_OGONEK=731]="U_OGONEK",a[a.U_SMALL_TILDE=732]="U_SMALL_TILDE",a[a.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",a[a.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",a[a.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",a[a.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",a[a.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",a[a.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",a[a.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",a[a.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",a[a.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",a[a.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",a[a.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",a[a.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",a[a.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",a[a.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",a[a.U_GREEK_TONOS=900]="U_GREEK_TONOS",a[a.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",a[a.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",a[a.U_GREEK_PSILI=8127]="U_GREEK_PSILI",a[a.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",a[a.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",a[a.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",a[a.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",a[a.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",a[a.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",a[a.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",a[a.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",a[a.U_GREEK_VARIA=8175]="U_GREEK_VARIA",a[a.U_GREEK_OXIA=8189]="U_GREEK_OXIA",a[a.U_GREEK_DASIA=8190]="U_GREEK_DASIA",a[a.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",a[a.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",a[a.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",a[a.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",a[a.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",a[a.U_OVERLINE=8254]="U_OVERLINE",a[a.UTF8_BOM=65279]="UTF8_BOM",a[a.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",a[a.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(R||(e.CharCode=R={}))}),define(he[130],ue([0,1]),function(ae,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=a,e.$d=C,e.$e=A,e.$f=T;function a(O,b){const I=Object.create(null);for(const $ of O){const d=b($);let g=I[d];g||(g=I[d]=[]),g.push($)}return I}function C(O,b){const I=[],$=[];for(const d of O)b.has(d)||I.push(d);for(const d of b)O.has(d)||$.push(d);return{removed:I,added:$}}function A(O,b){const I=[],$=[];for(const[d,g]of O)b.has(d)||I.push(g);for(const[d,g]of b)O.has(d)||$.push(g);return{removed:I,added:$}}function T(O,b){const I=new Set;for(const $ of b)O.has($)&&I.add($);return I}class k{static{R=Symbol.toStringTag}constructor(b,I){this.b=I,this.a=new Map,this[R]="SetWithKey";for(const $ of b)this.add($)}get size(){return this.a.size}add(b){const I=this.b(b);return this.a.set(I,b),this}delete(b){return this.a.delete(this.b(b))}has(b){return this.a.has(this.b(b))}*entries(){for(const b of this.a.values())yield[b,b]}keys(){return this.values()}*values(){for(const b of this.a.values())yield b}clear(){this.a.clear()}forEach(b,I){this.a.forEach($=>b.call(I,$,$,this))}[Symbol.iterator](){return this.values()}}e.$g=k}),define(he[87],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=a,e.$$h=C,e.$_h=A;function R(T){return(k,O,b)=>{let I=null,$=null;if(typeof b.value=="function"?(I="value",$=b.value):typeof b.get=="function"&&(I="get",$=b.get),!$)throw new Error("not supported");b[I]=T($,O)}}function a(T,k,O){let b=null,I=null;if(typeof O.value=="function"?(b="value",I=O.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof O.get=="function"&&(b="get",I=O.get),!I)throw new Error("not supported");const $=`$memoize$${k}`;O[b]=function(...d){return this.hasOwnProperty($)||Object.defineProperty(this,$,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,d)}),this[$]}}function C(T,k,O){return R((b,I)=>{const $=`$debounce$${I}`,d=`$debounce$result$${I}`;return function(...g){this[d]||(this[d]=O?O():void 0),clearTimeout(this[$]),k&&(this[d]=k(this[d],...g),g=[this[d]]),this[$]=setTimeout(()=>{b.apply(this,g),this[d]=O?O():void 0},T)}})}function A(T,k,O){return R((b,I)=>{const $=`$throttle$timer$${I}`,d=`$throttle$result$${I}`,g=`$throttle$lastRun$${I}`,l=`$throttle$pending$${I}`;return function(...m){if(this[d]||(this[d]=O?O():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),k&&(this[d]=k(this[d],...m)),this[l])return;const E=this[g]+T;E<=Date.now()?(this[g]=Date.now(),b.apply(this,[this[d]]),this[d]=O?O():void 0):(this[l]=!0,this[$]=setTimeout(()=>{this[l]=!1,this[g]=Date.now(),b.apply(this,[this[d]]),this[d]=O?O():void 0},E-Date.now()))}})}}),define(he[8],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=a,e.$X=C,e.$Y=A,e.$Z=T,e.$1=k,e.$2=O,e.$3=I,e.$5=d,e.$6=g,e.$7=l,e.$9=E;class R{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?p.isErrorNoTelemetry(i)?new p(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(n=>{n(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$U=R,e.$V=new R;function a(h){e.$V.setUnexpectedErrorHandler(h)}function C(h){if(!h||typeof h!="object")return!1;const i=h;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function A(h){I(h)||e.$V.onUnexpectedError(h)}function T(h){I(h)||e.$V.onUnexpectedExternalError(h)}function k(h){if(h instanceof Error){const{name:i,message:n}=h,t=h.stacktrace||h.stack;return{$isError:!0,name:i,message:n,stack:t,noTelemetry:p.isErrorNoTelemetry(h)}}return h}function O(h){let i;return h.noTelemetry?i=new p:(i=new Error,i.name=h.name),i.message=h.message,i.stack=h.stack,i}const b="Canceled";function I(h){return h instanceof $?!0:h instanceof Error&&h.name===b&&h.message===b}class $ extends Error{constructor(){super(b),this.name=this.message}}e.$4=$;function d(){const h=new Error(b);return h.name=h.message,h}function g(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}function l(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}class m extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=m;function E(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}class f extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$0=f;class w extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$$=w;class P extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=P;class p extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof p)return i;const n=new p;return n.message=i.message,n.stack=i.stack,n}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$ab=p;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.$bb=c}),define(he[17],ue([0,1,8,129]),function(ae,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=C,e.$sb=A,e.$tb=T,e.$ub=k,e.$vb=O,e.$wb=b,e.$xb=I,e.$yb=$,e.$zb=d,e.$Ab=g,e.$Bb=l,e.$Cb=m,e.$Db=E,e.top=f,e.$Fb=w,e.$Gb=p,e.$Hb=c,e.$Ib=h,e.$Jb=i,e.$Kb=n,e.$Lb=t,e.$Mb=s,e.$Nb=r,e.$Ob=o,e.$Pb=u,e.$Qb=y,e.$Rb=N,e.$Sb=S,e.$Tb=v,e.$Ub=L,e.$Vb=U,e.$Wb=F,e.$Xb=M,e.$Yb=K,e.$Zb=V,e.$1b=x,e.$2b=H,e.$3b=te,e.$4b=B,e.$5b=ne,e.$6b=le,e.$9b=X,e.$ac=oe;function C(j,W=0){return j[j.length-(1+W)]}function A(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}function T(j,W,G=(J,ie)=>J===ie){if(j===W)return!0;if(!j||!W||j.length!==W.length)return!1;for(let J=0,ie=j.length;J<ie;J++)if(!G(j[J],W[J]))return!1;return!0}function k(j,W){const G=j.length-1;W<G&&(j[W]=j[G]),j.pop()}function O(j,W,G){return b(j.length,J=>G(j[J],W))}function b(j,W){let G=0,J=j-1;for(;G<=J;){const ie=(G+J)/2|0,ce=W(ie);if(ce<0)G=ie+1;else if(ce>0)J=ie-1;else return ie}return-(G+1)}function I(j,W,G){if(j=j|0,j>=W.length)throw new TypeError("invalid index");const J=W[Math.floor(W.length*Math.random())],ie=[],ce=[],ge=[];for(const pe of W){const Ee=G(pe,J);Ee<0?ie.push(pe):Ee>0?ce.push(pe):ge.push(pe)}return j<ie.length?I(j,ie,G):j<ie.length+ge.length?ge[0]:I(j-(ie.length+ge.length),ce,G)}function $(j,W){const G=[];let J;for(const ie of j.slice(0).sort(W))!J||W(J[0],ie)!==0?(J=[ie],G.push(J)):J.push(ie);return G}function*d(j,W){let G,J;for(const ie of j)J!==void 0&&W(J,ie)?G.push(ie):(G&&(yield G),G=[ie]),J=ie;G&&(yield G)}function g(j,W){for(let G=0;G<=j.length;G++)W(G===0?void 0:j[G-1],G===j.length?void 0:j[G])}function l(j,W){for(let G=0;G<j.length;G++)W(G===0?void 0:j[G-1],j[G],G+1===j.length?void 0:j[G+1])}function m(j,W,G){const J=[];function ie(pe,Ee,Pe){if(Ee===0&&Pe.length===0)return;const be=J[J.length-1];be&&be.start+be.deleteCount===pe?(be.deleteCount+=Ee,be.toInsert.push(...Pe)):J.push({start:pe,deleteCount:Ee,toInsert:Pe})}let ce=0,ge=0;for(;;){if(ce===j.length){ie(ce,0,W.slice(ge));break}if(ge===W.length){ie(ce,j.length-ce,[]);break}const pe=j[ce],Ee=W[ge],Pe=G(pe,Ee);Pe===0?(ce+=1,ge+=1):Pe<0?(ie(ce,1,[]),ce+=1):Pe>0&&(ie(ce,0,[Ee]),ge+=1)}return J}function E(j,W,G){const J=m(j,W,G),ie=[],ce=[];for(const ge of J)ie.push(...j.slice(ge.start,ge.start+ge.deleteCount)),ce.push(...ge.toInsert);return{removed:ie,added:ce}}function f(j,W,G){if(G===0)return[];const J=j.slice(0,G).sort(W);return P(j,W,J,G,j.length),J}function w(j,W,G,J,ie){return G===0?Promise.resolve([]):new Promise((ce,ge)=>{(async()=>{const pe=j.length,Ee=j.slice(0,G).sort(W);for(let Pe=G,be=Math.min(G+J,pe);Pe<pe;Pe=be,be=Math.min(be+J,pe)){if(Pe>G&&await new Promise(we=>setTimeout(we)),ie&&ie.isCancellationRequested)throw new R.$4;P(j,W,Ee,Pe,be)}return Ee})().then(ce,ge)})}function P(j,W,G,J,ie){for(const ce=G.length;J<ie;J++){const ge=j[J];if(W(ge,G[ce-1])<0){G.pop();const pe=(0,a.$jb)(G,Ee=>W(ge,Ee)<0);G.splice(pe,0,ge)}}}function p(j){return j.filter(W=>!!W)}function c(j){let W=0;for(let G=0;G<j.length;G++)j[G]&&(j[W]=j[G],W+=1);j.length=W}function h(j,W,G){j.splice(G,0,j.splice(W,1)[0])}function i(j){return!Array.isArray(j)||j.length===0}function n(j){return Array.isArray(j)&&j.length>0}function t(j,W=G=>G){const G=new Set;return j.filter(J=>{const ie=W(J);return G.has(ie)?!1:(G.add(ie),!0)})}function s(j){const W=new Set;return G=>{const J=j(G);return W.has(J)?!1:(W.add(J),!0)}}function r(j,W){return j.length>0?j[0]:W}function o(j,W){return j.length>0?j[j.length-1]:W}function u(j,W,G=(J,ie)=>J===ie){let J=0;for(let ie=0,ce=Math.min(j.length,W.length);ie<ce&&G(j[ie],W[ie]);ie++)J++;return J}function y(j,W){let G=typeof W=="number"?j:0;typeof W=="number"?G=j:(G=0,W=j);const J=[];if(G<=W)for(let ie=G;ie<W;ie++)J.push(ie);else for(let ie=G;ie>W;ie--)J.push(ie);return J}function N(j,W,G){return j.reduce((J,ie)=>(J[W(ie)]=G?G(ie):ie,J),Object.create(null))}function S(j,W){return j.push(W),()=>v(j,W)}function v(j,W){const G=j.indexOf(W);if(G>-1)return j.splice(G,1),W}function L(j,W,G){const J=j.slice(0,W),ie=j.slice(W);return J.concat(G,ie)}function U(j,W){let G;if(typeof W=="number"){let J=W;G=()=>{const ie=Math.sin(J++)*179426549;return ie-Math.floor(ie)}}else G=Math.random;for(let J=j.length-1;J>0;J-=1){const ie=Math.floor(G()*(J+1)),ce=j[J];j[J]=j[ie],j[ie]=ce}}function F(j,W){const G=j.indexOf(W);G>-1&&(j.splice(G,1),j.unshift(W))}function M(j,W){const G=j.indexOf(W);G>-1&&(j.splice(G,1),j.push(W))}function K(j,W){for(const G of W)j.push(G)}function V(j,W){return Array.isArray(j)?j.map(W):W(j)}function x(j){return Array.isArray(j)?j:[j]}function H(j){return j[Math.floor(Math.random()*j.length)]}function te(j,W,G){const J=z(j,W),ie=j.length,ce=G.length;j.length=ie+ce;for(let ge=ie-1;ge>=J;ge--)j[ge+ce]=j[ge];for(let ge=0;ge<ce;ge++)j[ge+J]=G[ge]}function B(j,W,G,J){const ie=z(j,W);let ce=j.splice(ie,G);return ce===void 0&&(ce=[]),te(j,ie,J),ce}function z(j,W){return W<0?Math.max(W+j.length,0):Math.min(W,j.length)}var _;(function(j){function W(ce){return ce<0}j.isLessThan=W;function G(ce){return ce<=0}j.isLessThanOrEqual=G;function J(ce){return ce>0}j.isGreaterThan=J;function ie(ce){return ce===0}j.isNeitherLessOrGreaterThan=ie,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(_||(e.CompareResult=_={}));function ne(j,W){return(G,J)=>W(j(G),j(J))}function le(...j){return(W,G)=>{for(const J of j){const ie=J(W,G);if(!_.isNeitherLessOrGreaterThan(ie))return ie}return _.neitherLessOrGreaterThan}}const ee=(j,W)=>j-W;e.$7b=ee;const Q=(j,W)=>(0,e.$7b)(j?1:0,W?1:0);e.$8b=Q;function X(j){return(W,G)=>-j(W,G)}class q{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let G=this.c;for(;G<this.g.length&&W(this.g[G]);)G++;const J=G===this.c?null:this.g.slice(this.c,G);return this.c=G,J}takeFromEndWhile(W){let G=this.d;for(;G>=0&&W(this.g[G]);)G--;const J=G===this.d?null:this.g.slice(G+1,this.d+1);return this.d=G,J}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const G=this.g.slice(this.c,this.c+W);return this.c+=W,G}}e.$0b=q;class D{static{this.empty=new D(W=>{})}constructor(W){this.iterate=W}forEach(W){this.iterate(G=>(W(G),!0))}toArray(){const W=[];return this.iterate(G=>(W.push(G),!0)),W}filter(W){return new D(G=>this.iterate(J=>W(J)?G(J):!0))}map(W){return new D(G=>this.iterate(J=>G(W(J))))}some(W){let G=!1;return this.iterate(J=>(G=W(J),!G)),G}findFirst(W){let G;return this.iterate(J=>W(J)?(G=J,!1):!0),G}findLast(W){let G;return this.iterate(J=>(W(J)&&(G=J),!0)),G}findLastMaxBy(W){let G,J=!0;return this.iterate(ie=>((J||_.isGreaterThan(W(ie,G)))&&(J=!1,G=ie),!0)),G}}e.$$b=D;class Y{constructor(W){this.c=W}static createSortPermutation(W,G){const J=Array.from(W.keys()).sort((ie,ce)=>G(W[ie],W[ce]));return new Y(J)}apply(W){return W.map((G,J)=>W[this.c[J]])}inverse(){const W=this.c.slice();for(let G=0;G<this.c.length;G++)W[this.c[G]]=G;return new Y(W)}}e.$_b=Y;async function oe(j,W){return(await Promise.all(j.map(async(J,ie)=>({element:J,ok:await W(J,ie)})))).find(J=>J.ok)?.element}}),define(he[131],ue([0,1,8]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=a,e.$ed=C,e.$fd=A,e.$gd=T,e.$hd=k,e.$id=O;function a(b,I){if(!b)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function C(b,I="Unreachable"){throw new Error(I)}function A(b,I="unexpected state"){if(!b)throw new R.$bb(`Assertion Failed: ${I}`)}function T(b){b||(0,R.$Y)(new R.$bb("Soft Assertion Failed"))}function k(b){if(!b()){debugger;b(),(0,R.$Y)(new R.$bb("Assertion Failed"))}}function O(b,I){let $=0;for(;$<b.length-1;){const d=b[$],g=b[$+1];if(!I(d,g))return!1;$++}return!0}}),define(he[88],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=R;function R(a,C){const A=this;let T=!1,k;return function(){if(T)return k;if(T=!0,C)try{k=a.apply(A,arguments)}finally{C()}else k=a.apply(A,arguments);return k}}}),define(he[63],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(a){function C(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}a.is=C;const A=Object.freeze([]);function T(){return A}a.empty=T;function*k(i){yield i}a.single=k;function O(i){return C(i)?i:k(i)}a.wrap=O;function b(i){return i||A}a.from=b;function*I(i){for(let n=i.length-1;n>=0;n--)yield i[n]}a.reverse=I;function $(i){return!i||i[Symbol.iterator]().next().done===!0}a.isEmpty=$;function d(i){return i[Symbol.iterator]().next().value}a.first=d;function g(i,n){let t=0;for(const s of i)if(n(s,t++))return!0;return!1}a.some=g;function l(i,n){for(const t of i)if(n(t))return t}a.find=l;function*m(i,n){for(const t of i)n(t)&&(yield t)}a.filter=m;function*E(i,n){let t=0;for(const s of i)yield n(s,t++)}a.map=E;function*f(i,n){let t=0;for(const s of i)yield*n(s,t++)}a.flatMap=f;function*w(...i){for(const n of i)yield*n}a.concat=w;function P(i,n,t){let s=t;for(const r of i)s=n(s,r);return s}a.reduce=P;function*p(i,n,t=i.length){for(n<0&&(n+=i.length),t<0?t+=i.length:t>i.length&&(t=i.length);n<t;n++)yield i[n]}a.slice=p;function c(i,n=Number.POSITIVE_INFINITY){const t=[];if(n===0)return[t,i];const s=i[Symbol.iterator]();for(let r=0;r<n;r++){const o=s.next();if(o.done)return[t,a.empty()];t.push(o.value)}return[t,{[Symbol.iterator](){return s}}]}a.consume=c;async function h(i){const n=[];for await(const t of i)n.push(t);return Promise.resolve(n)}a.asyncToArray=h})(R||(e.Iterable=R={}))}),define(he[36],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Wn=T,e.$Xn=$,e.$Yn=d,e.$Zn=g,e.$1n=l,e.$2n=m,e.$3n=E,e.$4n=f,e.$5n=w,e.$6n=P,e.$7n=p;var R;(function(c){c[c.None=0]="None",c[c.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=2]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",c[c.InvalidUnicode=4]="InvalidUnicode",c[c.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",c[c.InvalidCharacter=6]="InvalidCharacter"})(R||(e.ScanError=R={}));var a;(function(c){c[c.OpenBraceToken=1]="OpenBraceToken",c[c.CloseBraceToken=2]="CloseBraceToken",c[c.OpenBracketToken=3]="OpenBracketToken",c[c.CloseBracketToken=4]="CloseBracketToken",c[c.CommaToken=5]="CommaToken",c[c.ColonToken=6]="ColonToken",c[c.NullKeyword=7]="NullKeyword",c[c.TrueKeyword=8]="TrueKeyword",c[c.FalseKeyword=9]="FalseKeyword",c[c.StringLiteral=10]="StringLiteral",c[c.NumericLiteral=11]="NumericLiteral",c[c.LineCommentTrivia=12]="LineCommentTrivia",c[c.BlockCommentTrivia=13]="BlockCommentTrivia",c[c.LineBreakTrivia=14]="LineBreakTrivia",c[c.Trivia=15]="Trivia",c[c.Unknown=16]="Unknown",c[c.EOF=17]="EOF"})(a||(e.SyntaxKind=a={}));var C;(function(c){c[c.InvalidSymbol=1]="InvalidSymbol",c[c.InvalidNumberFormat=2]="InvalidNumberFormat",c[c.PropertyNameExpected=3]="PropertyNameExpected",c[c.ValueExpected=4]="ValueExpected",c[c.ColonExpected=5]="ColonExpected",c[c.CommaExpected=6]="CommaExpected",c[c.CloseBraceExpected=7]="CloseBraceExpected",c[c.CloseBracketExpected=8]="CloseBracketExpected",c[c.EndOfFileExpected=9]="EndOfFileExpected",c[c.InvalidCommentToken=10]="InvalidCommentToken",c[c.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=12]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",c[c.InvalidUnicode=14]="InvalidUnicode",c[c.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",c[c.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var A;(function(c){c.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function T(c,h=!1){let i=0;const n=c.length;let t="",s=0,r=a.Unknown,o=R.None;function u(F){let M=0,K=0;for(;M<F;){const V=c.charCodeAt(i);if(V>=I._0&&V<=I._9)K=K*16+V-I._0;else if(V>=I.A&&V<=I.F)K=K*16+V-I.A+10;else if(V>=I.a&&V<=I.f)K=K*16+V-I.a+10;else break;i++,M++}return M<F&&(K=-1),K}function y(F){i=F,t="",s=0,r=a.Unknown,o=R.None}function N(){const F=i;if(c.charCodeAt(i)===I._0)i++;else for(i++;i<c.length&&b(c.charCodeAt(i));)i++;if(i<c.length&&c.charCodeAt(i)===I.dot)if(i++,i<c.length&&b(c.charCodeAt(i)))for(i++;i<c.length&&b(c.charCodeAt(i));)i++;else return o=R.UnexpectedEndOfNumber,c.substring(F,i);let M=i;if(i<c.length&&(c.charCodeAt(i)===I.E||c.charCodeAt(i)===I.e))if(i++,(i<c.length&&c.charCodeAt(i)===I.plus||c.charCodeAt(i)===I.minus)&&i++,i<c.length&&b(c.charCodeAt(i))){for(i++;i<c.length&&b(c.charCodeAt(i));)i++;M=i}else o=R.UnexpectedEndOfNumber;return c.substring(F,M)}function S(){let F="",M=i;for(;;){if(i>=n){F+=c.substring(M,i),o=R.UnexpectedEndOfString;break}const K=c.charCodeAt(i);if(K===I.doubleQuote){F+=c.substring(M,i),i++;break}if(K===I.backslash){if(F+=c.substring(M,i),i++,i>=n){o=R.UnexpectedEndOfString;break}switch(c.charCodeAt(i++)){case I.doubleQuote:F+='"';break;case I.backslash:F+="\\";break;case I.slash:F+="/";break;case I.b:F+="\b";break;case I.f:F+="\f";break;case I.n:F+=`
`;break;case I.r:F+="\r";break;case I.t:F+="	";break;case I.u:{const x=u(4);x>=0?F+=String.fromCharCode(x):o=R.InvalidUnicode;break}default:o=R.InvalidEscapeCharacter}M=i;continue}if(K>=0&&K<=31)if(O(K)){F+=c.substring(M,i),o=R.UnexpectedEndOfString;break}else o=R.InvalidCharacter;i++}return F}function v(){if(t="",o=R.None,s=i,i>=n)return s=n,r=a.EOF;let F=c.charCodeAt(i);if(k(F)){do i++,t+=String.fromCharCode(F),F=c.charCodeAt(i);while(k(F));return r=a.Trivia}if(O(F))return i++,t+=String.fromCharCode(F),F===I.carriageReturn&&c.charCodeAt(i)===I.lineFeed&&(i++,t+=`
`),r=a.LineBreakTrivia;switch(F){case I.openBrace:return i++,r=a.OpenBraceToken;case I.closeBrace:return i++,r=a.CloseBraceToken;case I.openBracket:return i++,r=a.OpenBracketToken;case I.closeBracket:return i++,r=a.CloseBracketToken;case I.colon:return i++,r=a.ColonToken;case I.comma:return i++,r=a.CommaToken;case I.doubleQuote:return i++,t=S(),r=a.StringLiteral;case I.slash:{const M=i-1;if(c.charCodeAt(i+1)===I.slash){for(i+=2;i<n&&!O(c.charCodeAt(i));)i++;return t=c.substring(M,i),r=a.LineCommentTrivia}if(c.charCodeAt(i+1)===I.asterisk){i+=2;const K=n-1;let V=!1;for(;i<K;){if(c.charCodeAt(i)===I.asterisk&&c.charCodeAt(i+1)===I.slash){i+=2,V=!0;break}i++}return V||(i++,o=R.UnexpectedEndOfComment),t=c.substring(M,i),r=a.BlockCommentTrivia}return t+=String.fromCharCode(F),i++,r=a.Unknown}case I.minus:if(t+=String.fromCharCode(F),i++,i===n||!b(c.charCodeAt(i)))return r=a.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return t+=N(),r=a.NumericLiteral;default:for(;i<n&&L(F);)i++,F=c.charCodeAt(i);if(s!==i){switch(t=c.substring(s,i),t){case"true":return r=a.TrueKeyword;case"false":return r=a.FalseKeyword;case"null":return r=a.NullKeyword}return r=a.Unknown}return t+=String.fromCharCode(F),i++,r=a.Unknown}}function L(F){if(k(F)||O(F))return!1;switch(F){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function U(){let F;do F=v();while(F>=a.LineCommentTrivia&&F<=a.Trivia);return F}return{setPosition:y,getPosition:()=>i,scan:h?U:v,getToken:()=>r,getTokenValue:()=>t,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>o}}function k(c){return c===I.space||c===I.tab||c===I.verticalTab||c===I.formFeed||c===I.nonBreakingSpace||c===I.ogham||c>=I.enQuad&&c<=I.zeroWidthSpace||c===I.narrowNoBreakSpace||c===I.mathematicalSpace||c===I.ideographicSpace||c===I.byteOrderMark}function O(c){return c===I.lineFeed||c===I.carriageReturn||c===I.lineSeparator||c===I.paragraphSeparator}function b(c){return c>=I._0&&c<=I._9}var I;(function(c){c[c.nullCharacter=0]="nullCharacter",c[c.maxAsciiCharacter=127]="maxAsciiCharacter",c[c.lineFeed=10]="lineFeed",c[c.carriageReturn=13]="carriageReturn",c[c.lineSeparator=8232]="lineSeparator",c[c.paragraphSeparator=8233]="paragraphSeparator",c[c.nextLine=133]="nextLine",c[c.space=32]="space",c[c.nonBreakingSpace=160]="nonBreakingSpace",c[c.enQuad=8192]="enQuad",c[c.emQuad=8193]="emQuad",c[c.enSpace=8194]="enSpace",c[c.emSpace=8195]="emSpace",c[c.threePerEmSpace=8196]="threePerEmSpace",c[c.fourPerEmSpace=8197]="fourPerEmSpace",c[c.sixPerEmSpace=8198]="sixPerEmSpace",c[c.figureSpace=8199]="figureSpace",c[c.punctuationSpace=8200]="punctuationSpace",c[c.thinSpace=8201]="thinSpace",c[c.hairSpace=8202]="hairSpace",c[c.zeroWidthSpace=8203]="zeroWidthSpace",c[c.narrowNoBreakSpace=8239]="narrowNoBreakSpace",c[c.ideographicSpace=12288]="ideographicSpace",c[c.mathematicalSpace=8287]="mathematicalSpace",c[c.ogham=5760]="ogham",c[c._=95]="_",c[c.$=36]="$",c[c._0=48]="_0",c[c._1=49]="_1",c[c._2=50]="_2",c[c._3=51]="_3",c[c._4=52]="_4",c[c._5=53]="_5",c[c._6=54]="_6",c[c._7=55]="_7",c[c._8=56]="_8",c[c._9=57]="_9",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.ampersand=38]="ampersand",c[c.asterisk=42]="asterisk",c[c.at=64]="at",c[c.backslash=92]="backslash",c[c.bar=124]="bar",c[c.caret=94]="caret",c[c.closeBrace=125]="closeBrace",c[c.closeBracket=93]="closeBracket",c[c.closeParen=41]="closeParen",c[c.colon=58]="colon",c[c.comma=44]="comma",c[c.dot=46]="dot",c[c.doubleQuote=34]="doubleQuote",c[c.equals=61]="equals",c[c.exclamation=33]="exclamation",c[c.greaterThan=62]="greaterThan",c[c.lessThan=60]="lessThan",c[c.minus=45]="minus",c[c.openBrace=123]="openBrace",c[c.openBracket=91]="openBracket",c[c.openParen=40]="openParen",c[c.percent=37]="percent",c[c.plus=43]="plus",c[c.question=63]="question",c[c.semicolon=59]="semicolon",c[c.singleQuote=39]="singleQuote",c[c.slash=47]="slash",c[c.tilde=126]="tilde",c[c.backspace=8]="backspace",c[c.formFeed=12]="formFeed",c[c.byteOrderMark=65279]="byteOrderMark",c[c.tab=9]="tab",c[c.verticalTab=11]="verticalTab"})(I||(I={}));function $(c,h){const i=[],n=new Object;let t;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function o(u,y,N,S){s.value=u,s.offset=y,s.length=N,s.type=S,s.colonOffset=void 0,t=s}try{P(c,{onObjectBegin:(u,y)=>{if(h<=u)throw n;t=void 0,r=h>u,i.push("")},onObjectProperty:(u,y,N)=>{if(h<y||(o(u,y,N,"property"),i[i.length-1]=u,h<=y+N))throw n},onObjectEnd:(u,y)=>{if(h<=u)throw n;t=void 0,i.pop()},onArrayBegin:(u,y)=>{if(h<=u)throw n;t=void 0,i.push(0)},onArrayEnd:(u,y)=>{if(h<=u)throw n;t=void 0,i.pop()},onLiteralValue:(u,y,N)=>{if(h<y||(o(u,y,N,p(u)),h<=y+N))throw n},onSeparator:(u,y,N)=>{if(h<=y)throw n;if(u===":"&&t&&t.type==="property")t.colonOffset=y,r=!1,t=void 0;else if(u===","){const S=i[i.length-1];typeof S=="number"?i[i.length-1]=S+1:(r=!0,i[i.length-1]=""),t=void 0}}})}catch(u){if(u!==n)throw u}return{path:i,previousNode:t,isAtPropertyKey:r,matches:u=>{let y=0;for(let N=0;y<u.length&&N<i.length;N++)if(u[y]===i[N]||u[y]==="*")y++;else if(u[y]!=="**")return!1;return y===u.length}}}function d(c,h=[],i=A.DEFAULT){let n=null,t=[];const s=[];function r(u){Array.isArray(t)?t.push(u):n!==null&&(t[n]=u)}return P(c,{onObjectBegin:()=>{const u={};r(u),s.push(t),t=u,n=null},onObjectProperty:u=>{n=u},onObjectEnd:()=>{t=s.pop()},onArrayBegin:()=>{const u=[];r(u),s.push(t),t=u,n=null},onArrayEnd:()=>{t=s.pop()},onLiteralValue:r,onError:(u,y,N)=>{h.push({error:u,offset:y,length:N})}},i),t[0]}function g(c,h=[],i=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(u){n.type==="property"&&(n.length=u-n.offset,n=n.parent)}function s(u){return n.children.push(u),u}P(c,{onObjectBegin:u=>{n=s({type:"object",offset:u,length:-1,parent:n,children:[]})},onObjectProperty:(u,y,N)=>{n=s({type:"property",offset:y,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:u,offset:y,length:N,parent:n})},onObjectEnd:(u,y)=>{n.length=u+y-n.offset,n=n.parent,t(u+y)},onArrayBegin:(u,y)=>{n=s({type:"array",offset:u,length:-1,parent:n,children:[]})},onArrayEnd:(u,y)=>{n.length=u+y-n.offset,n=n.parent,t(u+y)},onLiteralValue:(u,y,N)=>{s({type:p(u),offset:y,length:N,parent:n,value:u}),t(y+N)},onSeparator:(u,y,N)=>{n.type==="property"&&(u===":"?n.colonOffset=y:u===","&&t(y))},onError:(u,y,N)=>{h.push({error:u,offset:y,length:N})}},i);const o=n.children[0];return o&&delete o.parent,o}function l(c,h){if(!c)return;let i=c;for(const n of h)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let t=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===n){i=s.children[1],t=!0;break}if(!t)return}else{const t=n;if(i.type!=="array"||t<0||!Array.isArray(i.children)||t>=i.children.length)return;i=i.children[t]}return i}function m(c){if(!c.parent||!c.parent.children)return[];const h=m(c.parent);if(c.parent.type==="property"){const i=c.parent.children[0].value;h.push(i)}else if(c.parent.type==="array"){const i=c.parent.children.indexOf(c);i!==-1&&h.push(i)}return h}function E(c){switch(c.type){case"array":return c.children.map(E);case"object":{const h=Object.create(null);for(const i of c.children){const n=i.children[1];n&&(h[i.children[0].value]=E(n))}return h}case"null":case"string":case"number":case"boolean":return c.value;default:return}}function f(c,h,i=!1){return h>=c.offset&&h<c.offset+c.length||i&&h===c.offset+c.length}function w(c,h,i=!1){if(f(c,h,i)){const n=c.children;if(Array.isArray(n))for(let t=0;t<n.length&&n[t].offset<=h;t++){const s=w(n[t],h,i);if(s)return s}return c}}function P(c,h,i=A.DEFAULT){const n=T(c,!1);function t(ne){return ne?()=>ne(n.getTokenOffset(),n.getTokenLength()):()=>!0}function s(ne){return ne?le=>ne(le,n.getTokenOffset(),n.getTokenLength()):()=>!0}const r=t(h.onObjectBegin),o=s(h.onObjectProperty),u=t(h.onObjectEnd),y=t(h.onArrayBegin),N=t(h.onArrayEnd),S=s(h.onLiteralValue),v=s(h.onSeparator),L=t(h.onComment),U=s(h.onError),F=i&&i.disallowComments,M=i&&i.allowTrailingComma;function K(){for(;;){const ne=n.scan();switch(n.getTokenError()){case R.InvalidUnicode:V(C.InvalidUnicode);break;case R.InvalidEscapeCharacter:V(C.InvalidEscapeCharacter);break;case R.UnexpectedEndOfNumber:V(C.UnexpectedEndOfNumber);break;case R.UnexpectedEndOfComment:F||V(C.UnexpectedEndOfComment);break;case R.UnexpectedEndOfString:V(C.UnexpectedEndOfString);break;case R.InvalidCharacter:V(C.InvalidCharacter);break}switch(ne){case a.LineCommentTrivia:case a.BlockCommentTrivia:F?V(C.InvalidCommentToken):L();break;case a.Unknown:V(C.InvalidSymbol);break;case a.Trivia:case a.LineBreakTrivia:break;default:return ne}}}function V(ne,le=[],ee=[]){if(U(ne),le.length+ee.length>0){let Q=n.getToken();for(;Q!==a.EOF;){if(le.indexOf(Q)!==-1){K();break}else if(ee.indexOf(Q)!==-1)break;Q=K()}}}function x(ne){const le=n.getTokenValue();return ne?S(le):o(le),K(),!0}function H(){switch(n.getToken()){case a.NumericLiteral:{let ne=0;try{ne=JSON.parse(n.getTokenValue()),typeof ne!="number"&&(V(C.InvalidNumberFormat),ne=0)}catch{V(C.InvalidNumberFormat)}S(ne);break}case a.NullKeyword:S(null);break;case a.TrueKeyword:S(!0);break;case a.FalseKeyword:S(!1);break;default:return!1}return K(),!0}function te(){return n.getToken()!==a.StringLiteral?(V(C.PropertyNameExpected,[],[a.CloseBraceToken,a.CommaToken]),!1):(x(!1),n.getToken()===a.ColonToken?(v(":"),K(),_()||V(C.ValueExpected,[],[a.CloseBraceToken,a.CommaToken])):V(C.ColonExpected,[],[a.CloseBraceToken,a.CommaToken]),!0)}function B(){r(),K();let ne=!1;for(;n.getToken()!==a.CloseBraceToken&&n.getToken()!==a.EOF;){if(n.getToken()===a.CommaToken){if(ne||V(C.ValueExpected,[],[]),v(","),K(),n.getToken()===a.CloseBraceToken&&M)break}else ne&&V(C.CommaExpected,[],[]);te()||V(C.ValueExpected,[],[a.CloseBraceToken,a.CommaToken]),ne=!0}return u(),n.getToken()!==a.CloseBraceToken?V(C.CloseBraceExpected,[a.CloseBraceToken],[]):K(),!0}function z(){y(),K();let ne=!1;for(;n.getToken()!==a.CloseBracketToken&&n.getToken()!==a.EOF;){if(n.getToken()===a.CommaToken){if(ne||V(C.ValueExpected,[],[]),v(","),K(),n.getToken()===a.CloseBracketToken&&M)break}else ne&&V(C.CommaExpected,[],[]);_()||V(C.ValueExpected,[],[a.CloseBracketToken,a.CommaToken]),ne=!0}return N(),n.getToken()!==a.CloseBracketToken?V(C.CloseBracketExpected,[a.CloseBracketToken],[]):K(),!0}function _(){switch(n.getToken()){case a.OpenBracketToken:return z();case a.OpenBraceToken:return B();case a.StringLiteral:return x(!0);default:return H()}}return K(),n.getToken()===a.EOF?i.allowEmptyContent?!0:(V(C.ValueExpected,[],[]),!1):_()?(n.getToken()!==a.EOF&&V(C.EndOfFileExpected,[],[]),!0):(V(C.ValueExpected,[],[]),!1)}function p(c){switch(typeof c){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(c){if(Array.isArray(c))return"array"}else return"null";return"object"}default:return"null"}}}),define(he[45],ue([0,1,36]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=a,e.$9n=C,e.$0n=k,e.$$n=O;function a(b,I,$){let d,g,l,m,E;if(I){for(m=I.offset,E=m+I.length,l=m;l>0&&!O(b,l-1);)l--;let o=E;for(;o<b.length&&!O(b,o);)o++;g=b.substring(l,o),d=T(g,$)}else g=b,d=0,l=0,m=0,E=b.length;const f=k($,b);let w=!1,P=0,p;$.insertSpaces?p=A(" ",$.tabSize||4):p="	";const c=(0,R.$Wn)(g,!1);let h=!1;function i(){return f+A(p,d+P)}function n(){let o=c.scan();for(w=!1;o===R.SyntaxKind.Trivia||o===R.SyntaxKind.LineBreakTrivia;)w=w||o===R.SyntaxKind.LineBreakTrivia,o=c.scan();return h=o===R.SyntaxKind.Unknown||c.getTokenError()!==R.ScanError.None,o}const t=[];function s(o,u,y){!h&&u<E&&y>m&&b.substring(u,y)!==o&&t.push({offset:u,length:y-u,content:o})}let r=n();if(r!==R.SyntaxKind.EOF){const o=c.getTokenOffset()+l,u=A(p,d);s(u,l,o)}for(;r!==R.SyntaxKind.EOF;){let o=c.getTokenOffset()+c.getTokenLength()+l,u=n(),y="";for(;!w&&(u===R.SyntaxKind.LineCommentTrivia||u===R.SyntaxKind.BlockCommentTrivia);){const S=c.getTokenOffset()+l;s(" ",o,S),o=c.getTokenOffset()+c.getTokenLength()+l,y=u===R.SyntaxKind.LineCommentTrivia?i():"",u=n()}if(u===R.SyntaxKind.CloseBraceToken)r!==R.SyntaxKind.OpenBraceToken&&(P--,y=i());else if(u===R.SyntaxKind.CloseBracketToken)r!==R.SyntaxKind.OpenBracketToken&&(P--,y=i());else{switch(r){case R.SyntaxKind.OpenBracketToken:case R.SyntaxKind.OpenBraceToken:P++,y=i();break;case R.SyntaxKind.CommaToken:case R.SyntaxKind.LineCommentTrivia:y=i();break;case R.SyntaxKind.BlockCommentTrivia:w?y=i():y=" ";break;case R.SyntaxKind.ColonToken:y=" ";break;case R.SyntaxKind.StringLiteral:if(u===R.SyntaxKind.ColonToken){y="";break}case R.SyntaxKind.NullKeyword:case R.SyntaxKind.TrueKeyword:case R.SyntaxKind.FalseKeyword:case R.SyntaxKind.NumericLiteral:case R.SyntaxKind.CloseBraceToken:case R.SyntaxKind.CloseBracketToken:u===R.SyntaxKind.LineCommentTrivia||u===R.SyntaxKind.BlockCommentTrivia?y=" ":u!==R.SyntaxKind.CommaToken&&u!==R.SyntaxKind.EOF&&(h=!0);break;case R.SyntaxKind.Unknown:h=!0;break}w&&(u===R.SyntaxKind.LineCommentTrivia||u===R.SyntaxKind.BlockCommentTrivia)&&(y=i())}const N=c.getTokenOffset()+l;s(y,o,N),r=u}return t}function C(b,I){const $=JSON.stringify(b,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?$.replace(/\r\n|\r|\n/g,I.eol):$}function A(b,I){let $="";for(let d=0;d<I;d++)$+=b;return $}function T(b,I){let $=0,d=0;const g=I.tabSize||4;for(;$<b.length;){const l=b.charAt($);if(l===" ")d++;else if(l==="	")d+=g;else break;$++}return Math.floor(d/g)}function k(b,I){for(let $=0;$<I.length;$++){const d=I.charAt($);if(d==="\r")return $+1<I.length&&I.charAt($+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return b&&b.eol||`
`}function O(b,I){return`\r
`.indexOf(b.charAt(I))!==-1}}),define(he[64],ue([0,1,36,45]),function(ae,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=C,e.$ao=A,e.$bo=T,e.$co=k,e.$do=O;function C(b,I,$){return A(b,I,void 0,$)}function A(b,I,$,d,g){const l=I.slice(),m=[],E=(0,R.$Zn)(b,m);let f,w;for(;l.length>0&&(w=l.pop(),f=(0,R.$1n)(E,l),f===void 0&&$!==void 0);)typeof w=="string"?$={[w]:$}:$=[$];if(f)if(f.type==="object"&&typeof w=="string"&&Array.isArray(f.children)){const P=(0,R.$1n)(f,[w]);if(P!==void 0)if($===void 0){if(!P.parent)throw new Error("Malformed AST");const p=f.children.indexOf(P.parent);let c,h=P.parent.offset+P.parent.length;if(p>0){const i=f.children[p-1];c=i.offset+i.length}else c=f.offset+1,f.children.length>1&&(h=f.children[1].offset);return T(b,{offset:c,length:h-c,content:""},d)}else return T(b,{offset:P.offset,length:P.length,content:JSON.stringify($)},d);else{if($===void 0)return[];const p=`${JSON.stringify(w)}: ${JSON.stringify($)}`,c=g?g(f.children.map(i=>i.children[0].value)):f.children.length;let h;if(c>0){const i=f.children[c-1];h={offset:i.offset+i.length,length:0,content:","+p}}else f.children.length===0?h={offset:f.offset+1,length:0,content:p}:h={offset:f.offset+1,length:0,content:p+","};return T(b,h,d)}}else if(f.type==="array"&&typeof w=="number"&&Array.isArray(f.children))if($!==void 0){const P=`${JSON.stringify($)}`;let p;if(f.children.length===0||w===0)p={offset:f.offset+1,length:0,content:f.children.length===0?P:P+","};else{const c=w===-1||w>f.children.length?f.children.length:w,h=f.children[c-1];p={offset:h.offset+h.length,length:0,content:","+P}}return T(b,p,d)}else{const P=w,p=f.children[P];let c;if(f.children.length===1)c={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===P){const h=f.children[P-1],i=h.offset+h.length,n=f.offset+f.length;c={offset:i,length:n-2-i,content:""}}else c={offset:p.offset,length:f.children[P+1].offset-p.offset,content:""};return T(b,c,d)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${f.type}`);else return $===void 0?[]:T(b,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify($)},d)}function T(b,I,$){let d=k(b,I),g=I.offset,l=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;g>0&&!(0,a.$$n)(d,g-1);)g--;for(;l<d.length&&!(0,a.$$n)(d,l);)l++}const m=(0,a.$8n)(d,{offset:g,length:l-g},$);for(let f=m.length-1;f>=0;f--){const w=m[f];d=k(d,w),g=Math.min(g,w.offset),l=Math.max(l,w.offset+w.length),l+=w.content.length-w.length}const E=b.length-(d.length-l)-g;return[{offset:g,length:E,content:d.substring(g,l)}]}function k(b,I){return b.substring(0,I.offset)+I.content+b.substring(I.offset+I.length)}function O(b,I){const $=I.slice(0).sort((g,l)=>{const m=g.offset-l.offset;return m===0?g.length-l.length:m});let d=b.length;for(let g=$.length-1;g>=0;g--){const l=$[g];if(l.offset+l.length<=d)b=k(b,l);else throw new Error("Overlapping edit");d=l.offset}return b}}),define(he[132],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=R;function R(A){let T=!1;const k=new Map,O=new Map;if(C(A,m=>{if(A===m)return!0;const E=JSON.stringify(m);if(E.length<30)return!0;const f=k.get(E);if(!f){const w={schemas:[m]};return k.set(E,w),O.set(m,w),!0}return f.schemas.push(m),O.set(m,f),T=!0,!1}),k.clear(),!T)return JSON.stringify(A);let I="$defs";for(;A.hasOwnProperty(I);)I+="_";const $=[];function d(m){return JSON.stringify(m,(E,f)=>{if(f!==m){const w=O.get(f);if(w&&w.schemas.length>1)return w.id||(w.id=`_${$.length}`,$.push(w.schemas[0])),{$ref:`#/${I}/${w.id}`}}return f})}const g=d(A),l=[];for(let m=0;m<$.length;m++)l.push(`"_${m}":${d($[m])}`);return l.length?`${g.substring(0,g.length-1)},"${I}":{${l.join(",")}}}`:g}function a(A){return typeof A=="object"&&A!==null}function C(A,T){if(!A||typeof A!="object")return;const k=(...g)=>{for(const l of g)a(l)&&$.push(l)},O=(...g)=>{for(const l of g)if(a(l))for(const m in l){const E=l[m];a(E)&&$.push(E)}},b=(...g)=>{for(const l of g)if(Array.isArray(l))for(const m of l)a(m)&&$.push(m)},I=g=>{if(Array.isArray(g))for(const l of g)a(l)&&$.push(l);else a(g)&&$.push(g)},$=[A];let d=$.pop();for(;d;)T(d)&&(k(d.additionalItems,d.additionalProperties,d.not,d.contains,d.propertyNames,d.if,d.then,d.else,d.unevaluatedItems,d.unevaluatedProperties),O(d.definitions,d.$defs,d.properties,d.patternProperties,d.dependencies,d.dependentSchemas),b(d.anyOf,d.allOf,d.oneOf,d.prefixItems),I(d.items)),d=$.pop()}}),define(he[53],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class R{constructor(C){this.d=C,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(C){this.c=C}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=R}),define(he[89],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class R{static{this.Undefined=new R(void 0)}constructor(A){this.element=A,this.next=R.Undefined,this.prev=R.Undefined}}class a{constructor(){this.a=R.Undefined,this.b=R.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===R.Undefined}clear(){let A=this.a;for(;A!==R.Undefined;){const T=A.next;A.prev=R.Undefined,A.next=R.Undefined,A=T}this.a=R.Undefined,this.b=R.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,T){const k=new R(A);if(this.a===R.Undefined)this.a=k,this.b=k;else if(T){const b=this.b;this.b=k,k.prev=b,b.next=k}else{const b=this.a;this.a=k,k.next=b,b.prev=k}this.c+=1;let O=!1;return()=>{O||(O=!0,this.e(k))}}shift(){if(this.a!==R.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==R.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==R.Undefined&&A.next!==R.Undefined){const T=A.prev;T.next=A.next,A.next.prev=T}else A.prev===R.Undefined&&A.next===R.Undefined?(this.a=R.Undefined,this.b=R.Undefined):A.next===R.Undefined?(this.b=this.b.prev,this.b.next=R.Undefined):A.prev===R.Undefined&&(this.a=this.a.next,this.a.prev=R.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==R.Undefined;)yield A.element,A=A.next}}e.$5c=a}),define(he[31],ue([0,1]),function(ae,e){"use strict";var R,a,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=A,e.$yc=T,e.$zc=k,e.$Ic=p;function A(c,h,i){let n=c.get(h);return n===void 0&&(n=i,c.set(h,n)),n}function T(c){const h=[];return c.forEach((i,n)=>{h.push(`${n} => ${i}`)}),`Map(${c.size}) {${h.join(", ")}}`}function k(c){const h=[];return c.forEach(i=>{h.push(i)}),`Set(${c.size}) {${h.join(", ")}}`}class O{constructor(h,i){this.uri=h,this.value=i}}function b(c){return Array.isArray(c)}class I{static{this.c=h=>h.toString()}constructor(h,i){if(this[R]="ResourceMap",h instanceof I)this.d=new Map(h.d),this.e=i??I.c;else if(b(h)){this.d=new Map,this.e=i??I.c;for(const[n,t]of h)this.set(n,t)}else this.d=new Map,this.e=h??I.c}set(h,i){return this.d.set(this.e(h),new O(h,i)),this}get(h){return this.d.get(this.e(h))?.value}has(h){return this.d.has(this.e(h))}get size(){return this.d.size}clear(){this.d.clear()}delete(h){return this.d.delete(this.e(h))}forEach(h,i){typeof i<"u"&&(h=h.bind(i));for(const[n,t]of this.d)h(t.value,t.uri,this)}*values(){for(const h of this.d.values())yield h.value}*keys(){for(const h of this.d.values())yield h.uri}*entries(){for(const h of this.d.values())yield[h.uri,h.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.d)yield[h.uri,h.value]}}e.$Ac=I;class ${constructor(h,i){this[a]="ResourceSet",!h||typeof h=="function"?this.c=new I(h):(this.c=new I(i),h.forEach(this.add,this))}get size(){return this.c.size}add(h){return this.c.set(h,h),this}clear(){this.c.clear()}delete(h){return this.c.delete(h)}forEach(h,i){this.c.forEach((n,t)=>h.call(i,t,t,this))}has(h){return this.c.has(h)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(a=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=$;var d;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(d||(e.Touch=d={}));class g{constructor(){this[C]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(h){return this.c.has(h)}get(h,i=d.None){const n=this.c.get(h);if(n)return i!==d.None&&this.m(n,i),n.value}set(h,i,n=d.None){let t=this.c.get(h);if(t)t.value=i,n!==d.None&&this.m(t,n);else{switch(t={key:h,value:i,next:void 0,previous:void 0},n){case d.None:this.k(t);break;case d.AsOld:this.j(t);break;case d.AsNew:this.k(t);break;default:this.k(t);break}this.c.set(h,t),this.f++}return this}delete(h){return!!this.remove(h)}remove(h){const i=this.c.get(h);if(i)return this.c.delete(h),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const h=this.d;return this.c.delete(h.key),this.l(h),this.f--,h.value}forEach(h,i){const n=this.g;let t=this.d;for(;t;){if(i?h.bind(i)(t.value,t.key,this):h(t.value,t.key,this),this.g!==n)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const h=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:n.key,done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}values(){const h=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:n.value,done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}entries(){const h=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:[n.key,n.value],done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(h){if(h>=this.size)return;if(h===0){this.clear();return}let i=this.d,n=this.size;for(;i&&n>h;)this.c.delete(i.key),i=i.next,n--;this.d=i,this.f=n,i&&(i.previous=void 0),this.g++}i(h){if(h>=this.size)return;if(h===0){this.clear();return}let i=this.e,n=this.size;for(;i&&n>h;)this.c.delete(i.key),i=i.previous,n--;this.e=i,this.f=n,i&&(i.next=void 0),this.g++}j(h){if(!this.d&&!this.e)this.e=h;else if(this.d)h.next=this.d,this.d.previous=h;else throw new Error("Invalid list");this.d=h,this.g++}k(h){if(!this.d&&!this.e)this.d=h;else if(this.e)h.previous=this.e,this.e.next=h;else throw new Error("Invalid list");this.e=h,this.g++}l(h){if(h===this.d&&h===this.e)this.d=void 0,this.e=void 0;else if(h===this.d){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.d=h.next}else if(h===this.e){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.e=h.previous}else{const i=h.next,n=h.previous;if(!i||!n)throw new Error("Invalid list");i.previous=n,n.next=i}h.next=void 0,h.previous=void 0,this.g++}m(h,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==d.AsOld&&i!==d.AsNew)){if(i===d.AsOld){if(h===this.d)return;const n=h.next,t=h.previous;h===this.e?(t.next=void 0,this.e=t):(n.previous=t,t.next=n),h.previous=void 0,h.next=this.d,this.d.previous=h,this.d=h,this.g++}else if(i===d.AsNew){if(h===this.e)return;const n=h.next,t=h.previous;h===this.d?(n.previous=void 0,this.d=n):(n.previous=t,t.next=n),h.next=void 0,h.previous=this.e,this.e.next=h,this.e=h,this.g++}}}toJSON(){const h=[];return this.forEach((i,n)=>{h.push([n,i])}),h}fromJSON(h){this.clear();for(const[i,n]of h)this.set(i,n)}}e.$Cc=g;class l extends g{constructor(h,i=1){super(),this.n=h,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(h){this.n=h,this.p()}get ratio(){return this.o}set ratio(h){this.o=Math.min(Math.max(0,h),1),this.p()}get(h,i=d.AsNew){return super.get(h,i)}peek(h){return super.get(h,d.None)}set(h,i){return super.set(h,i,d.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class m extends l{constructor(h,i=1){super(h,i)}q(h){this.h(h)}set(h,i){return super.set(h,i),this.p(),this}}e.$Dc=m;class E extends l{constructor(h,i=1){super(h,i)}q(h){this.i(h)}set(h,i){return this.n<=this.size&&!this.has(h)&&this.q(Math.round(this.n*this.o)-1),super.set(h,i),this}}e.$Ec=E;class f{constructor(){this.c=new Map}add(h){return this.c.set(h,(this.c.get(h)||0)+1),this}delete(h){let i=this.c.get(h)||0;return i===0?!1:(i--,i===0?this.c.delete(h):this.c.set(h,i),!0)}has(h){return this.c.has(h)}}e.$Fc=f;class w{constructor(h){if(this.c=new Map,this.d=new Map,h)for(const[i,n]of h)this.set(i,n)}clear(){this.c.clear(),this.d.clear()}set(h,i){this.c.set(h,i),this.d.set(i,h)}get(h){return this.c.get(h)}getKey(h){return this.d.get(h)}delete(h){const i=this.c.get(h);return i===void 0?!1:(this.c.delete(h),this.d.delete(i),!0)}forEach(h,i){this.c.forEach((n,t)=>{h.call(i,n,t,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=w;class P{constructor(){this.c=new Map}add(h,i){let n=this.c.get(h);n||(n=new Set,this.c.set(h,n)),n.add(i)}delete(h,i){const n=this.c.get(h);n&&(n.delete(i),n.size===0&&this.c.delete(h))}forEach(h,i){const n=this.c.get(h);n&&n.forEach(i)}get(h){const i=this.c.get(h);return i||new Set}}e.$Hc=P;function p(c,h){if(c===h)return!0;if(c.size!==h.size)return!1;for(const[i,n]of c)if(!h.has(i)||h.get(i)!==n)return!1;for(const[i]of h)if(!c.has(i))return!1;return!0}}),define(he[2],ue([0,1,17,130,31,88,63]),function(ae,e,R,a,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=I,e.$Lc=$,e.$Mc=d,e.$Nc=m,e.$Oc=E,e.$Pc=f,e.$Qc=w,e.$Rc=P,e.$Sc=p,e.$3c=y;const k=!1;let O=null;class b{constructor(){this.b=new Map}static{this.a=0}c(v){let L=this.b.get(v);return L||(L={parent:null,source:null,isSingleton:!1,value:v,idx:b.a++},this.b.set(v,L)),L}trackDisposable(v){const L=this.c(v);L.source||(L.source=new Error().stack)}setParent(v,L){const U=this.c(v);U.parent=L}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,L){const U=L.get(v);if(U)return U;const F=v.parent?this.f(this.c(v.parent),L):v;return L.set(v,F),F}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,v).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(v=10,L){let U;if(L)U=L;else{const x=new Map,H=[...this.b.values()].filter(B=>B.source!==null&&!this.f(B,x).isSingleton);if(H.length===0)return;const te=new Set(H.map(B=>B.value));if(U=H.filter(B=>!(B.parent&&te.has(B.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function F(x){function H(B,z){for(;B.length>0&&z.some(_=>typeof _=="string"?_===B[0]:B[0].match(_));)B.shift()}const te=x.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return H(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const M=new C.$Hc;for(const x of U){const H=F(x);for(let te=0;te<=H.length;te++)M.add(H.slice(0,te).join(`
`),x)}U.sort((0,R.$5b)(x=>x.idx,R.$7b));let K="",V=0;for(const x of U.slice(0,v)){V++;const H=F(x),te=[];for(let B=0;B<H.length;B++){let z=H[B];z=`(shared with ${M.get(H.slice(0,B+1).join(`
`)).size}/${U.length} leaks) at ${z}`;const ne=M.get(H.slice(0,B).join(`
`)),le=(0,a.$c)([...ne].map(ee=>F(ee)[B]),ee=>ee);delete le[H[B]];for(const[ee,Q]of Object.entries(le))te.unshift(`    - stacktraces of ${Q.length} other leaks continue with ${ee}`);te.unshift(z)}K+=`


==================== Leaking disposable ${V}/${U.length}: ${x.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return U.length>v&&(K+=`


... and ${U.length-v} more leaking disposables

`),{leaks:U,details:K}}}e.$Jc=b;function I(S){O=S}if(k){const S="__is_disposable_tracked__";I(new class{trackDisposable(v){const L=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[S]||console.log(L)},3e3)}setParent(v,L){if(v&&v!==h.None)try{v[S]=!0}catch{}}markAsDisposed(v){if(v&&v!==h.None)try{v[S]=!0}catch{}}markAsSingleton(v){}})}function $(S){return O?.trackDisposable(S),S}function d(S){O?.markAsDisposed(S)}function g(S,v){O?.setParent(S,v)}function l(S,v){if(O)for(const L of S)O.setParent(L,v)}function m(S){return O?.markAsSingleton(S),S}function E(S){return typeof S=="object"&&S!==null&&typeof S.dispose=="function"&&S.dispose.length===0}function f(S){if(T.Iterable.is(S)){const v=[];for(const L of S)if(L)try{L.dispose()}catch(U){v.push(U)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}function w(S){for(const v of S)E(v)&&v.dispose();return[]}function P(...S){const v=p(()=>f(S));return l(S,v),v}function p(S){const v=$({dispose:(0,A.$cb)(()=>{d(v),S()})});return v}class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,$(this)}dispose(){this.g||(d(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return g(v,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),g(v,null))}}e.$Tc=c;class h{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,$(this),g(this.q,this)}dispose(){d(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Uc=h;class i{constructor(){this.b=!1,$(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&g(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&g(v,null),v}}e.$Vc=i;class n{constructor(v){this.a=new i,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=n;class t{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=t;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,$(this)}set(v){let L=v;return this.unset=()=>L=void 0,this.isset=()=>L!==void 0,this.dispose=()=>{L&&(L(),L=void 0,d(this))},this}}e.$Yc=s;class r{constructor(){this.a=new Map}acquire(v,...L){let U=this.a.get(v);U||(U={counter:0,object:this.b(v,...L)},this.a.set(v,U));const{object:F}=U,M=(0,A.$cb)(()=>{--U.counter===0&&(this.c(v,U.object),this.a.delete(v))});return U.counter++,{object:F,dispose:M}}}e.$Zc=r;class o{constructor(v){this.a=v}async acquire(v,...L){const U=this.a.acquire(v,...L);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(F){throw U.dispose(),F}}}e.$1c=o;class u{constructor(v){this.object=v}dispose(){}}e.$2c=u;function y(S){const v=new c;try{S(v)}finally{v.dispose()}}class N{constructor(){this.a=new Map,this.b=!1,$(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,L,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(v)?.dispose(),this.a.set(v,L)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const L=this.a.get(v);return this.a.delete(v),L}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=N}),define(he[65],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var R;(function(a){a[a.Uri=1]="Uri",a[a.Regexp=2]="Regexp",a[a.ScmResource=3]="ScmResource",a[a.ScmResourceGroup=4]="ScmResourceGroup",a[a.ScmProvider=5]="ScmProvider",a[a.CommentController=6]="CommentController",a[a.CommentThread=7]="CommentThread",a[a.CommentThreadInstance=8]="CommentThreadInstance",a[a.CommentThreadReply=9]="CommentThreadReply",a[a.CommentNode=10]="CommentNode",a[a.CommentThreadNode=11]="CommentThreadNode",a[a.TimelineActionContext=12]="TimelineActionContext",a[a.NotebookCellActionContext=13]="NotebookCellActionContext",a[a.NotebookActionContext=14]="NotebookActionContext",a[a.TerminalContext=15]="TerminalContext",a[a.TestItemContext=16]="TestItemContext",a[a.Date=17]="Date",a[a.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(R||(e.MarshalledId=R={}))}),define(he[90],ue([0,1,31]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=void 0,e.$nm=C,e.$om=T;const a=new R.$Dc(1e4);function C(b){return O(b,"NFC",a)}const A=new R.$Dc(1e4);function T(b){return O(b,"NFD",A)}const k=/[^\u0000-\u0080]/;function O(b,I,$){if(!b)return b;const d=$.get(b);if(d)return d;let g;return k.test(b)?g=b.normalize(I):g=b,$.set(b,g),g}e.$pm=function(){const b=/[\u0300-\u036f]/g;return function(I){return T(I).replace(b,"")}}()}),function(){function ae(C){const A=[];typeof C=="number"&&A.push("code/timeOrigin",C);function T(O){A.push(O,Date.now())}function k(){const O=[];for(let b=0;b<A.length;b+=2)O.push({name:A[b],startTime:A[b+1]});return O}return{mark:T,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ae():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(C+T.startTime)});return A}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ae(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),ae()}function R(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var a;typeof global=="object"?a=global:typeof self=="object"?a=self:a={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(a)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(a):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),a.perf=R(a))}(),define(he[5],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=h,e.$E=o,e.$K=u,e.$h="en";let R=!1,a=!1,C=!1,A=!1,T=!1,k=!1,O=!1,b=!1,I=!1,$=!1,d,g=e.$h,l=e.$h,m,E;const f=globalThis;let w;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?w=f.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(w=process);const P=typeof w?.versions?.electron=="string",p=P&&w?.type==="renderer";if(typeof w=="object"){R=w.platform==="win32",a=w.platform==="darwin",C=w.platform==="linux",A=C&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,O=P,I=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.$h,g=e.$h;const y=w.env.VSCODE_NLS_CONFIG;if(y)try{const N=JSON.parse(y);d=N.userLocale,l=N.osLocale,g=N.resolvedLanguage||e.$h,m=N.languagePack?.translationsConfigFile}catch{}T=!0}else typeof navigator=="object"&&!p?(E=navigator.userAgent,R=E.indexOf("Windows")>=0,a=E.indexOf("Macintosh")>=0,b=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=E.indexOf("Linux")>=0,$=E?.indexOf("Mobi")>=0,k=!0,g=globalThis._VSCODE_NLS_LANGUAGE||e.$h,d=navigator.language.toLowerCase(),l=d):console.error("Unable to resolve platform.");var c;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(c||(e.Platform=c={}));function h(y){switch(y){case c.Web:return"Web";case c.Mac:return"Mac";case c.Linux:return"Linux";case c.Windows:return"Windows"}}let i=c.Web;a?i=c.Mac:R?i=c.Windows:C&&(i=c.Linux),e.$j=R,e.$k=a,e.$l=C,e.$m=A,e.$n=T,e.$o=O,e.$p=k,e.$q=k&&typeof f.importScripts=="function",e.$r=e.$q?f.origin:void 0,e.$s=b,e.$t=$,e.$u=I,e.$v=i,e.$w=E,e.$x=g;var n;(function(y){function N(){return e.$x}y.value=N;function S(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}y.isDefaultVariant=S;function v(){return e.$x==="en"}y.isDefault=v})(n||(e.Language=n={})),e.$y=d,e.$z=l,e.$A=m,e.$B=typeof f.postMessage=="function"&&!f.importScripts,e.$C=(()=>{if(e.$B){const y=[];f.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let v=0,L=y.length;v<L;v++){const U=y[v];if(U.id===S.data.vscodeScheduleAsyncWork){y.splice(v,1),U.callback();return}}});let N=0;return S=>{const v=++N;y.push({id:v,callback:S}),f.postMessage({vscodeScheduleAsyncWork:v},"*")}}return y=>setTimeout(y)})();var t;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=a||b?t.Macintosh:R?t.Windows:t.Linux;let s=!0,r=!1;function o(){if(!r){r=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,s=new Uint16Array(y.buffer)[0]===513}return s}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function u(y){return parseFloat(y)>=20}}),define(he[37],ue([0,1,5]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let a;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.process<"u"){const A=C.process;a={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?a={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:a={get platform(){return R.$j?"win32":R.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=a.cwd,e.env=a.env,e.$dc=a.platform,e.$ec=a.arch}),define(he[133],ue([0,1,37]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vX=T;var a;(function(k){k.UNKNOWN="UNKNOWN",k.CINNAMON="CINNAMON",k.DEEPIN="DEEPIN",k.GNOME="GNOME",k.KDE3="KDE3",k.KDE4="KDE4",k.KDE5="KDE5",k.KDE6="KDE6",k.PANTHEON="PANTHEON",k.UNITY="UNITY",k.XFCE="XFCE",k.UKUI="UKUI",k.LXQT="LXQT"})(a||(a={}));const C="XDG_CURRENT_DESKTOP",A="KDE_SESSION_VERSION";function T(){const k=R.env[C];if(k){const b=k.split(":").map(I=>I.trim()).filter(I=>I.length>0);for(const I of b)switch(I){case"Unity":{const $=R.env.DESKTOP_SESSION;return $&&$.includes("gnome-fallback")?a.GNOME:a.UNITY}case"Deepin":return a.DEEPIN;case"GNOME":return a.GNOME;case"X-Cinnamon":return a.CINNAMON;case"KDE":{const $=R.env[A];return $==="5"?a.KDE5:$==="6"?a.KDE6:a.KDE4}case"Pantheon":return a.PANTHEON;case"XFCE":return a.XFCE;case"UKUI":return a.UKUI;case"LXQt":return a.LXQT}}const O=R.env.DESKTOP_SESSION;if(O)switch(O){case"deepin":return a.DEEPIN;case"gnome":case"mate":return a.GNOME;case"kde4":case"kde-plasma":return a.KDE4;case"kde":return A in R.env?a.KDE4:a.KDE3;case"xfce":case"xubuntu":return a.XFCE;case"ukui":return a.UKUI}return"GNOME_DESKTOP_SESSION_ID"in R.env?a.GNOME:"KDE_FULL_SESSION"in R.env?A in R.env?a.KDE4:a.KDE3:a.UNKNOWN}});var kt=this&&this.__createBinding||(Object.create?function(ae,e,R,a){a===void 0&&(a=R);var C=Object.getOwnPropertyDescriptor(e,R);(!C||("get"in C?!e.__esModule:C.writable||C.configurable))&&(C={enumerable:!0,get:function(){return e[R]}}),Object.defineProperty(ae,a,C)}:function(ae,e,R,a){a===void 0&&(a=R),ae[a]=e[R]}),At=this&&this.__setModuleDefault||(Object.create?function(ae,e){Object.defineProperty(ae,"default",{enumerable:!0,value:e})}:function(ae,e){ae.default=e}),Oe=this&&this.__importStar||function(ae){if(ae&&ae.__esModule)return ae;var e={};if(ae!=null)for(var R in ae)R!=="default"&&Object.prototype.hasOwnProperty.call(ae,R)&&kt(e,ae,R);return At(e,ae),e};define(he[13],ue([0,1,37]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0,R=Oe(R);const a=65,C=97,A=90,T=122,k=46,O=47,b=92,I=58,$=63;class d extends Error{constructor(n,t,s){let r;typeof t=="string"&&t.indexOf("not ")===0?(r="must not be",t=t.replace(/^not /,"")):r="must be";const o=n.indexOf(".")!==-1?"property":"argument";let u=`The "${n}" ${o} ${r} of type ${t}`;u+=`. Received type ${typeof s}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function g(i,n){if(i===null||typeof i!="object")throw new d(n,"Object",i)}function l(i,n){if(typeof i!="string")throw new d(n,"string",i)}const m=R.$dc==="win32";function E(i){return i===O||i===b}function f(i){return i===O}function w(i){return i>=a&&i<=A||i>=C&&i<=T}function P(i,n,t,s){let r="",o=0,u=-1,y=0,N=0;for(let S=0;S<=i.length;++S){if(S<i.length)N=i.charCodeAt(S);else{if(s(N))break;N=O}if(s(N)){if(!(u===S-1||y===1))if(y===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==k||r.charCodeAt(r.length-2)!==k){if(r.length>2){const v=r.lastIndexOf(t);v===-1?(r="",o=0):(r=r.slice(0,v),o=r.length-1-r.lastIndexOf(t)),u=S,y=0;continue}else if(r.length!==0){r="",o=0,u=S,y=0;continue}}n&&(r+=r.length>0?`${t}..`:"..",o=2)}else r.length>0?r+=`${t}${i.slice(u+1,S)}`:r=i.slice(u+1,S),o=S-u-1;u=S,y=0}else N===k&&y!==-1?++y:y=-1}return r}function p(i){return i?`${i[0]==="."?"":"."}${i}`:""}function c(i,n){g(n,"pathObject");const t=n.dir||n.root,s=n.base||`${n.name||""}${p(n.ext)}`;return t?t===n.root?`${t}${s}`:`${t}${i}${s}`:s}e.$fc={resolve(...i){let n="",t="",s=!1;for(let r=i.length-1;r>=-1;r--){let o;if(r>=0){if(o=i[r],l(o,`paths[${r}]`),o.length===0)continue}else n.length===0?o=R.cwd():(o=R.env[`=${n}`]||R.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==n.toLowerCase()&&o.charCodeAt(2)===b)&&(o=`${n}\\`));const u=o.length;let y=0,N="",S=!1;const v=o.charCodeAt(0);if(u===1)E(v)&&(y=1,S=!0);else if(E(v))if(S=!0,E(o.charCodeAt(1))){let L=2,U=L;for(;L<u&&!E(o.charCodeAt(L));)L++;if(L<u&&L!==U){const F=o.slice(U,L);for(U=L;L<u&&E(o.charCodeAt(L));)L++;if(L<u&&L!==U){for(U=L;L<u&&!E(o.charCodeAt(L));)L++;(L===u||L!==U)&&(N=`\\\\${F}\\${o.slice(U,L)}`,y=L)}}}else y=1;else w(v)&&o.charCodeAt(1)===I&&(N=o.slice(0,2),y=2,u>2&&E(o.charCodeAt(2))&&(S=!0,y=3));if(N.length>0)if(n.length>0){if(N.toLowerCase()!==n.toLowerCase())continue}else n=N;if(s){if(n.length>0)break}else if(t=`${o.slice(y)}\\${t}`,s=S,S&&n.length>0)break}return t=P(t,!s,"\\",E),s?`${n}\\${t}`:`${n}${t}`||"."},normalize(i){l(i,"path");const n=i.length;if(n===0)return".";let t=0,s,r=!1;const o=i.charCodeAt(0);if(n===1)return f(o)?"\\":i;if(E(o))if(r=!0,E(i.charCodeAt(1))){let y=2,N=y;for(;y<n&&!E(i.charCodeAt(y));)y++;if(y<n&&y!==N){const S=i.slice(N,y);for(N=y;y<n&&E(i.charCodeAt(y));)y++;if(y<n&&y!==N){for(N=y;y<n&&!E(i.charCodeAt(y));)y++;if(y===n)return`\\\\${S}\\${i.slice(N)}\\`;y!==N&&(s=`\\\\${S}\\${i.slice(N,y)}`,t=y)}}}else t=1;else w(o)&&i.charCodeAt(1)===I&&(s=i.slice(0,2),t=2,n>2&&E(i.charCodeAt(2))&&(r=!0,t=3));let u=t<n?P(i.slice(t),!r,"\\",E):"";return u.length===0&&!r&&(u="."),u.length>0&&E(i.charCodeAt(n-1))&&(u+="\\"),s===void 0?r?`\\${u}`:u:r?`${s}\\${u}`:`${s}${u}`},isAbsolute(i){l(i,"path");const n=i.length;if(n===0)return!1;const t=i.charCodeAt(0);return E(t)||n>2&&w(t)&&i.charCodeAt(1)===I&&E(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let n,t;for(let o=0;o<i.length;++o){const u=i[o];l(u,"path"),u.length>0&&(n===void 0?n=t=u:n+=`\\${u}`)}if(n===void 0)return".";let s=!0,r=0;if(typeof t=="string"&&E(t.charCodeAt(0))){++r;const o=t.length;o>1&&E(t.charCodeAt(1))&&(++r,o>2&&(E(t.charCodeAt(2))?++r:s=!1))}if(s){for(;r<n.length&&E(n.charCodeAt(r));)r++;r>=2&&(n=`\\${n.slice(r)}`)}return e.$fc.normalize(n)},relative(i,n){if(l(i,"from"),l(n,"to"),i===n)return"";const t=e.$fc.resolve(i),s=e.$fc.resolve(n);if(t===s||(i=t.toLowerCase(),n=s.toLowerCase(),i===n))return"";let r=0;for(;r<i.length&&i.charCodeAt(r)===b;)r++;let o=i.length;for(;o-1>r&&i.charCodeAt(o-1)===b;)o--;const u=o-r;let y=0;for(;y<n.length&&n.charCodeAt(y)===b;)y++;let N=n.length;for(;N-1>y&&n.charCodeAt(N-1)===b;)N--;const S=N-y,v=u<S?u:S;let L=-1,U=0;for(;U<v;U++){const M=i.charCodeAt(r+U);if(M!==n.charCodeAt(y+U))break;M===b&&(L=U)}if(U!==v){if(L===-1)return s}else{if(S>v){if(n.charCodeAt(y+U)===b)return s.slice(y+U+1);if(U===2)return s.slice(y+U)}u>v&&(i.charCodeAt(r+U)===b?L=U:U===2&&(L=3)),L===-1&&(L=0)}let F="";for(U=r+L+1;U<=o;++U)(U===o||i.charCodeAt(U)===b)&&(F+=F.length===0?"..":"\\..");return y+=L,F.length>0?`${F}${s.slice(y,N)}`:(s.charCodeAt(y)===b&&++y,s.slice(y,N))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const n=e.$fc.resolve(i);if(n.length<=2)return i;if(n.charCodeAt(0)===b){if(n.charCodeAt(1)===b){const t=n.charCodeAt(2);if(t!==$&&t!==k)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(w(n.charCodeAt(0))&&n.charCodeAt(1)===I&&n.charCodeAt(2)===b)return`\\\\?\\${n}`;return i},dirname(i){l(i,"path");const n=i.length;if(n===0)return".";let t=-1,s=0;const r=i.charCodeAt(0);if(n===1)return E(r)?i:".";if(E(r)){if(t=s=1,E(i.charCodeAt(1))){let y=2,N=y;for(;y<n&&!E(i.charCodeAt(y));)y++;if(y<n&&y!==N){for(N=y;y<n&&E(i.charCodeAt(y));)y++;if(y<n&&y!==N){for(N=y;y<n&&!E(i.charCodeAt(y));)y++;if(y===n)return i;y!==N&&(t=s=y+1)}}}}else w(r)&&i.charCodeAt(1)===I&&(t=n>2&&E(i.charCodeAt(2))?3:2,s=t);let o=-1,u=!0;for(let y=n-1;y>=s;--y)if(E(i.charCodeAt(y))){if(!u){o=y;break}}else u=!1;if(o===-1){if(t===-1)return".";o=t}return i.slice(0,o)},basename(i,n){n!==void 0&&l(n,"suffix"),l(i,"path");let t=0,s=-1,r=!0,o;if(i.length>=2&&w(i.charCodeAt(0))&&i.charCodeAt(1)===I&&(t=2),n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let u=n.length-1,y=-1;for(o=i.length-1;o>=t;--o){const N=i.charCodeAt(o);if(E(N)){if(!r){t=o+1;break}}else y===-1&&(r=!1,y=o+1),u>=0&&(N===n.charCodeAt(u)?--u===-1&&(s=o):(u=-1,s=y))}return t===s?s=y:s===-1&&(s=i.length),i.slice(t,s)}for(o=i.length-1;o>=t;--o)if(E(i.charCodeAt(o))){if(!r){t=o+1;break}}else s===-1&&(r=!1,s=o+1);return s===-1?"":i.slice(t,s)},extname(i){l(i,"path");let n=0,t=-1,s=0,r=-1,o=!0,u=0;i.length>=2&&i.charCodeAt(1)===I&&w(i.charCodeAt(0))&&(n=s=2);for(let y=i.length-1;y>=n;--y){const N=i.charCodeAt(y);if(E(N)){if(!o){s=y+1;break}continue}r===-1&&(o=!1,r=y+1),N===k?t===-1?t=y:u!==1&&(u=1):t!==-1&&(u=-1)}return t===-1||r===-1||u===0||u===1&&t===r-1&&t===s+1?"":i.slice(t,r)},format:c.bind(null,"\\"),parse(i){l(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const t=i.length;let s=0,r=i.charCodeAt(0);if(t===1)return E(r)?(n.root=n.dir=i,n):(n.base=n.name=i,n);if(E(r)){if(s=1,E(i.charCodeAt(1))){let L=2,U=L;for(;L<t&&!E(i.charCodeAt(L));)L++;if(L<t&&L!==U){for(U=L;L<t&&E(i.charCodeAt(L));)L++;if(L<t&&L!==U){for(U=L;L<t&&!E(i.charCodeAt(L));)L++;L===t?s=L:L!==U&&(s=L+1)}}}}else if(w(r)&&i.charCodeAt(1)===I){if(t<=2)return n.root=n.dir=i,n;if(s=2,E(i.charCodeAt(2))){if(t===3)return n.root=n.dir=i,n;s=3}}s>0&&(n.root=i.slice(0,s));let o=-1,u=s,y=-1,N=!0,S=i.length-1,v=0;for(;S>=s;--S){if(r=i.charCodeAt(S),E(r)){if(!N){u=S+1;break}continue}y===-1&&(N=!1,y=S+1),r===k?o===-1?o=S:v!==1&&(v=1):o!==-1&&(v=-1)}return y!==-1&&(o===-1||v===0||v===1&&o===y-1&&o===u+1?n.base=n.name=i.slice(u,y):(n.name=i.slice(u,o),n.base=i.slice(u,y),n.ext=i.slice(o,y))),u>0&&u!==s?n.dir=i.slice(0,u-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(m){const i=/\\/g;return()=>{const n=R.cwd().replace(i,"/");return n.slice(n.indexOf("/"))}}return()=>R.cwd()})();e.$gc={resolve(...i){let n="",t=!1;for(let s=i.length-1;s>=-1&&!t;s--){const r=s>=0?i[s]:h();l(r,`paths[${s}]`),r.length!==0&&(n=`${r}/${n}`,t=r.charCodeAt(0)===O)}return n=P(n,!t,"/",f),t?`/${n}`:n.length>0?n:"."},normalize(i){if(l(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===O,t=i.charCodeAt(i.length-1)===O;return i=P(i,!n,"/",f),i.length===0?n?"/":t?"./":".":(t&&(i+="/"),n?`/${i}`:i)},isAbsolute(i){return l(i,"path"),i.length>0&&i.charCodeAt(0)===O},join(...i){if(i.length===0)return".";let n;for(let t=0;t<i.length;++t){const s=i[t];l(s,"path"),s.length>0&&(n===void 0?n=s:n+=`/${s}`)}return n===void 0?".":e.$gc.normalize(n)},relative(i,n){if(l(i,"from"),l(n,"to"),i===n||(i=e.$gc.resolve(i),n=e.$gc.resolve(n),i===n))return"";const t=1,s=i.length,r=s-t,o=1,u=n.length-o,y=r<u?r:u;let N=-1,S=0;for(;S<y;S++){const L=i.charCodeAt(t+S);if(L!==n.charCodeAt(o+S))break;L===O&&(N=S)}if(S===y)if(u>y){if(n.charCodeAt(o+S)===O)return n.slice(o+S+1);if(S===0)return n.slice(o+S)}else r>y&&(i.charCodeAt(t+S)===O?N=S:S===0&&(N=0));let v="";for(S=t+N+1;S<=s;++S)(S===s||i.charCodeAt(S)===O)&&(v+=v.length===0?"..":"/..");return`${v}${n.slice(o+N)}`},toNamespacedPath(i){return i},dirname(i){if(l(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===O;let t=-1,s=!0;for(let r=i.length-1;r>=1;--r)if(i.charCodeAt(r)===O){if(!s){t=r;break}}else s=!1;return t===-1?n?"/":".":n&&t===1?"//":i.slice(0,t)},basename(i,n){n!==void 0&&l(n,"ext"),l(i,"path");let t=0,s=-1,r=!0,o;if(n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let u=n.length-1,y=-1;for(o=i.length-1;o>=0;--o){const N=i.charCodeAt(o);if(N===O){if(!r){t=o+1;break}}else y===-1&&(r=!1,y=o+1),u>=0&&(N===n.charCodeAt(u)?--u===-1&&(s=o):(u=-1,s=y))}return t===s?s=y:s===-1&&(s=i.length),i.slice(t,s)}for(o=i.length-1;o>=0;--o)if(i.charCodeAt(o)===O){if(!r){t=o+1;break}}else s===-1&&(r=!1,s=o+1);return s===-1?"":i.slice(t,s)},extname(i){l(i,"path");let n=-1,t=0,s=-1,r=!0,o=0;for(let u=i.length-1;u>=0;--u){const y=i.charCodeAt(u);if(y===O){if(!r){t=u+1;break}continue}s===-1&&(r=!1,s=u+1),y===k?n===-1?n=u:o!==1&&(o=1):n!==-1&&(o=-1)}return n===-1||s===-1||o===0||o===1&&n===s-1&&n===t+1?"":i.slice(n,s)},format:c.bind(null,"/"),parse(i){l(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const t=i.charCodeAt(0)===O;let s;t?(n.root="/",s=1):s=0;let r=-1,o=0,u=-1,y=!0,N=i.length-1,S=0;for(;N>=s;--N){const v=i.charCodeAt(N);if(v===O){if(!y){o=N+1;break}continue}u===-1&&(y=!1,u=N+1),v===k?r===-1?r=N:S!==1&&(S=1):r!==-1&&(S=-1)}if(u!==-1){const v=o===0&&t?1:o;r===-1||S===0||S===1&&r===u-1&&r===o+1?n.base=n.name=i.slice(v,u):(n.name=i.slice(v,r),n.base=i.slice(v,u),n.ext=i.slice(r,u))}return o>0?n.dir=i.slice(0,o-1):t&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=m?e.$fc.normalize:e.$gc.normalize,e.$ic=m?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=m?e.$fc.join:e.$gc.join,e.$kc=m?e.$fc.resolve:e.$gc.resolve,e.$lc=m?e.$fc.relative:e.$gc.relative,e.$mc=m?e.$fc.dirname:e.$gc.dirname,e.$nc=m?e.$fc.basename:e.$gc.basename,e.$oc=m?e.$fc.extname:e.$gc.extname,e.$pc=m?e.$fc.format:e.$gc.format,e.$qc=m?e.$fc.parse:e.$gc.parse,e.$rc=m?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=m?e.$fc.sep:e.$gc.sep,e.$tc=m?e.$fc.delimiter:e.$gc.delimiter}),define(he[134],ue([0,1,13]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$s=void 0,e.$_s=A,e.$at=T,e.$bt=k,e.$ct=b,e.$$s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const a={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(I){const $=(0,R.$oc)(I),d=a[$.toLowerCase()];return d!==void 0?d:T(I)}function T(I){const $=(0,R.$oc)(I);return C[$.toLowerCase()]}function k(I){for(const $ in C)if(C[$]===I)return $}const O=/^(.+)\/(.+?)(;.+)?$/;function b(I,$){const d=O.exec(I);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:$?void 0:I}}),define(he[91],ue([0,1,5]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$lm=A,e.$mm=T;var a;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(a||(e.Source=a={}));var C;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(C||(e.TerminateResponseCode=C={}));function A(k,...O){const b=O.reduce((d,g)=>(d[g]=!0,d),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(d=>!b[d]).forEach(d=>{for(let g=0;g<I.length;g++)if(d.search(I[g])!==-1){delete k[d];break}})}function T(k){k&&(delete k.DEBUG,R.$l&&delete k.LD_PRELOAD)}}),function(ae,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var a in R)(typeof exports=="object"?exports:ae)[a]=R[a]}}(typeof self<"u"?self:this,function(){return function(ae){var e={};function R(a){if(e[a])return e[a].exports;var C=e[a]={i:a,l:!1,exports:{}};return ae[a].call(C.exports,C,C.exports,R),C.l=!0,C.exports}return R.m=ae,R.c=e,R.d=function(a,C,A){R.o(a,C)||Object.defineProperty(a,C,{enumerable:!0,get:A})},R.r=function(a){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(a,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(a,"__esModule",{value:!0})},R.t=function(a,C){if(1&C&&(a=R(a)),8&C||4&C&&typeof a=="object"&&a&&a.__esModule)return a;var A=Object.create(null);if(R.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:a}),2&C&&typeof a!="string")for(var T in a)R.d(A,T,function(k){return a[k]}.bind(null,T));return A},R.n=function(a){var C=a&&a.__esModule?function(){return a.default}:function(){return a};return R.d(C,"a",C),C},R.o=function(a,C){return Object.prototype.hasOwnProperty.call(a,C)},R.p="",R(R.s=0)}([function(ae,e,R){(function(a){var C;e=ae.exports=Q,C=typeof a=="object"&&a.env&&a.env.NODE_DEBUG&&/\bsemver\b/i.test(a.env.NODE_DEBUG)?function(){var re=Array.prototype.slice.call(arguments,0);re.unshift("SEMVER"),console.log.apply(console,re)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],O=e.src=[],b=0,I=b++;O[I]="0|[1-9]\\d*";var $=b++;O[$]="[0-9]+";var d=b++;O[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=b++;O[g]="("+O[I]+")\\.("+O[I]+")\\.("+O[I]+")";var l=b++;O[l]="("+O[$]+")\\.("+O[$]+")\\.("+O[$]+")";var m=b++;O[m]="(?:"+O[I]+"|"+O[d]+")";var E=b++;O[E]="(?:"+O[$]+"|"+O[d]+")";var f=b++;O[f]="(?:-("+O[m]+"(?:\\."+O[m]+")*))";var w=b++;O[w]="(?:-?("+O[E]+"(?:\\."+O[E]+")*))";var P=b++;O[P]="[0-9A-Za-z-]+";var p=b++;O[p]="(?:\\+("+O[P]+"(?:\\."+O[P]+")*))";var c=b++,h="v?"+O[g]+O[f]+"?"+O[p]+"?";O[c]="^"+h+"$";var i="[v=\\s]*"+O[l]+O[w]+"?"+O[p]+"?",n=b++;O[n]="^"+i+"$";var t=b++;O[t]="((?:<|>)?=?)";var s=b++;O[s]=O[$]+"|x|X|\\*";var r=b++;O[r]=O[I]+"|x|X|\\*";var o=b++;O[o]="[v=\\s]*("+O[r]+")(?:\\.("+O[r]+")(?:\\.("+O[r]+")(?:"+O[f]+")?"+O[p]+"?)?)?";var u=b++;O[u]="[v=\\s]*("+O[s]+")(?:\\.("+O[s]+")(?:\\.("+O[s]+")(?:"+O[w]+")?"+O[p]+"?)?)?";var y=b++;O[y]="^"+O[t]+"\\s*"+O[o]+"$";var N=b++;O[N]="^"+O[t]+"\\s*"+O[u]+"$";var S=b++;O[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=b++;O[v]="(?:~>?)";var L=b++;O[L]="(\\s*)"+O[v]+"\\s+",k[L]=new RegExp(O[L],"g");var U=b++;O[U]="^"+O[v]+O[o]+"$";var F=b++;O[F]="^"+O[v]+O[u]+"$";var M=b++;O[M]="(?:\\^)";var K=b++;O[K]="(\\s*)"+O[M]+"\\s+",k[K]=new RegExp(O[K],"g");var V=b++;O[V]="^"+O[M]+O[o]+"$";var x=b++;O[x]="^"+O[M]+O[u]+"$";var H=b++;O[H]="^"+O[t]+"\\s*("+i+")$|^$";var te=b++;O[te]="^"+O[t]+"\\s*("+h+")$|^$";var B=b++;O[B]="(\\s*)"+O[t]+"\\s*("+i+"|"+O[o]+")",k[B]=new RegExp(O[B],"g");var z=b++;O[z]="^\\s*("+O[o]+")\\s+-\\s+("+O[o]+")\\s*$";var _=b++;O[_]="^\\s*("+O[u]+")\\s+-\\s+("+O[u]+")\\s*$";var ne=b++;O[ne]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)C(le,O[le]),k[le]||(k[le]=new RegExp(O[le]));function ee(re,de){if(re instanceof Q)return re;if(typeof re!="string"||re.length>A||!(de?k[n]:k[c]).test(re))return null;try{return new Q(re,de)}catch{return null}}function Q(re,de){if(re instanceof Q){if(re.loose===de)return re;re=re.version}else if(typeof re!="string")throw new TypeError("Invalid Version: "+re);if(re.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof Q))return new Q(re,de);C("SemVer",re,de),this.loose=de;var me=re.trim().match(de?k[n]:k[c]);if(!me)throw new TypeError("Invalid Version: "+re);if(this.raw=re,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Re){if(/^[0-9]+$/.test(Re)){var ke=+Re;if(ke>=0&&ke<T)return ke}return Re}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=ee,e.valid=function(re,de){var me=ee(re,de);return me?me.version:null},e.clean=function(re,de){var me=ee(re.trim().replace(/^[=v]+/,""),de);return me?me.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(re){return C("SemVer.compare",this.version,this.loose,re),re instanceof Q||(re=new Q(re,this.loose)),this.compareMain(re)||this.comparePre(re)},Q.prototype.compareMain=function(re){return re instanceof Q||(re=new Q(re,this.loose)),q(this.major,re.major)||q(this.minor,re.minor)||q(this.patch,re.patch)},Q.prototype.comparePre=function(re){if(re instanceof Q||(re=new Q(re,this.loose)),this.prerelease.length&&!re.prerelease.length)return-1;if(!this.prerelease.length&&re.prerelease.length)return 1;if(!this.prerelease.length&&!re.prerelease.length)return 0;var de=0;do{var me=this.prerelease[de],Re=re.prerelease[de];if(C("prerelease compare",de,me,Re),me===void 0&&Re===void 0)return 0;if(Re===void 0)return 1;if(me===void 0)return-1;if(me!==Re)return q(me,Re)}while(++de)},Q.prototype.inc=function(re,de){switch(re){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+re)}return this.format(),this.raw=this.version,this},e.inc=function(re,de,me,Re){typeof me=="string"&&(Re=me,me=void 0);try{return new Q(re,me).inc(de,Re).version}catch{return null}},e.diff=function(re,de){if(j(re,de))return null;var me=ee(re),Re=ee(de);if(me.prerelease.length||Re.prerelease.length){for(var ke in me)if((ke==="major"||ke==="minor"||ke==="patch")&&me[ke]!==Re[ke])return"pre"+ke;return"prerelease"}for(var ke in me)if((ke==="major"||ke==="minor"||ke==="patch")&&me[ke]!==Re[ke])return ke},e.compareIdentifiers=q;var X=/^[0-9]+$/;function q(re,de){var me=X.test(re),Re=X.test(de);return me&&Re&&(re=+re,de=+de),me&&!Re?-1:Re&&!me?1:re<de?-1:re>de?1:0}function D(re,de,me){return new Q(re,me).compare(new Q(de,me))}function Y(re,de,me){return D(re,de,me)>0}function oe(re,de,me){return D(re,de,me)<0}function j(re,de,me){return D(re,de,me)===0}function W(re,de,me){return D(re,de,me)!==0}function G(re,de,me){return D(re,de,me)>=0}function J(re,de,me){return D(re,de,me)<=0}function ie(re,de,me,Re){var ke;switch(de){case"===":typeof re=="object"&&(re=re.version),typeof me=="object"&&(me=me.version),ke=re===me;break;case"!==":typeof re=="object"&&(re=re.version),typeof me=="object"&&(me=me.version),ke=re!==me;break;case"":case"=":case"==":ke=j(re,me,Re);break;case"!=":ke=W(re,me,Re);break;case">":ke=Y(re,me,Re);break;case">=":ke=G(re,me,Re);break;case"<":ke=oe(re,me,Re);break;case"<=":ke=J(re,me,Re);break;default:throw new TypeError("Invalid operator: "+de)}return ke}function ce(re,de){if(re instanceof ce){if(re.loose===de)return re;re=re.value}if(!(this instanceof ce))return new ce(re,de);C("comparator",re,de),this.loose=de,this.parse(re),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(re,de){return q(de,re)},e.major=function(re,de){return new Q(re,de).major},e.minor=function(re,de){return new Q(re,de).minor},e.patch=function(re,de){return new Q(re,de).patch},e.compare=D,e.compareLoose=function(re,de){return D(re,de,!0)},e.rcompare=function(re,de,me){return D(de,re,me)},e.sort=function(re,de){return re.sort(function(me,Re){return e.compare(me,Re,de)})},e.rsort=function(re,de){return re.sort(function(me,Re){return e.rcompare(me,Re,de)})},e.gt=Y,e.lt=oe,e.eq=j,e.neq=W,e.gte=G,e.lte=J,e.cmp=ie,e.Comparator=ce;var ge={};function pe(re,de){if(re instanceof pe)return re.loose===de?re:new pe(re.raw,de);if(re instanceof ce)return new pe(re.value,de);if(!(this instanceof pe))return new pe(re,de);if(this.loose=de,this.raw=re,this.set=re.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+re);this.format()}function Ee(re){return!re||re.toLowerCase()==="x"||re==="*"}function Pe(re,de,me,Re,ke,De,Te,Ne,Ue,Be,Ve,Me,qe){return((de=Ee(me)?"":Ee(Re)?">="+me+".0.0":Ee(ke)?">="+me+"."+Re+".0":">="+de)+" "+(Ne=Ee(Ue)?"":Ee(Be)?"<"+(+Ue+1)+".0.0":Ee(Ve)?"<"+Ue+"."+(+Be+1)+".0":Me?"<="+Ue+"."+Be+"."+Ve+"-"+Me:"<="+Ne)).trim()}function be(re,de){for(var me=0;me<re.length;me++)if(!re[me].test(de))return!1;if(de.prerelease.length){for(me=0;me<re.length;me++)if(C(re[me].semver),re[me].semver!==ge&&re[me].semver.prerelease.length>0){var Re=re[me].semver;if(Re.major===de.major&&Re.minor===de.minor&&Re.patch===de.patch)return!0}return!1}return!0}function we(re,de,me){try{de=new pe(de,me)}catch{return!1}return de.test(re)}function Se(re,de,me,Re){var ke,De,Te,Ne,Ue;switch(re=new Q(re,Re),de=new pe(de,Re),me){case">":ke=Y,De=J,Te=oe,Ne=">",Ue=">=";break;case"<":ke=oe,De=G,Te=Y,Ne="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(re,de,Re))return!1;for(var Be=0;Be<de.set.length;++Be){var Ve=de.set[Be],Me=null,qe=null;if(Ve.forEach(function(ze){ze.semver===ge&&(ze=new ce(">=0.0.0")),Me=Me||ze,qe=qe||ze,ke(ze.semver,Me.semver,Re)?Me=ze:Te(ze.semver,qe.semver,Re)&&(qe=ze)}),Me.operator===Ne||Me.operator===Ue||(!qe.operator||qe.operator===Ne)&&De(re,qe.semver)||qe.operator===Ue&&Te(re,qe.semver))return!1}return!0}ce.prototype.parse=function(re){var de=this.loose?k[H]:k[te],me=re.match(de);if(!me)throw new TypeError("Invalid comparator: "+re);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new Q(me[2],this.loose):this.semver=ge},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(re){return C("Comparator.test",re,this.loose),this.semver===ge||(typeof re=="string"&&(re=new Q(re,this.loose)),ie(re,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(re,de){if(!(re instanceof ce))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new pe(re.value,de),we(this.value,me,de);if(re.operator==="")return me=new pe(this.value,de),we(re.semver,me,de);var Re=!(this.operator!==">="&&this.operator!==">"||re.operator!==">="&&re.operator!==">"),ke=!(this.operator!=="<="&&this.operator!=="<"||re.operator!=="<="&&re.operator!=="<"),De=this.semver.version===re.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||re.operator!==">="&&re.operator!=="<="),Ne=ie(this.semver,"<",re.semver,de)&&(this.operator===">="||this.operator===">")&&(re.operator==="<="||re.operator==="<"),Ue=ie(this.semver,">",re.semver,de)&&(this.operator==="<="||this.operator==="<")&&(re.operator===">="||re.operator===">");return Re||ke||De&&Te||Ne||Ue},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(re){return re.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(re){var de=this.loose;re=re.trim(),C("range",re,de);var me=de?k[_]:k[z];re=re.replace(me,Pe),C("hyphen replace",re),re=re.replace(k[B],"$1$2$3"),C("comparator trim",re,k[B]),re=(re=(re=re.replace(k[L],"$1~")).replace(k[K],"$1^")).split(/\s+/).join(" ");var Re=de?k[H]:k[te],ke=re.split(" ").map(function(De){return function(Te,Ne){return C("comp",Te),Te=function(Ue,Be){return Ue.trim().split(/\s+/).map(function(Ve){return function(Me,qe){C("caret",Me,qe);var ze=qe?k[x]:k[V];return Me.replace(ze,function(We,Ce,se,fe,$e){var ye;return C("caret",Me,We,Ce,se,fe,$e),Ee(Ce)?ye="":Ee(se)?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Ee(fe)?ye=Ce==="0"?">="+Ce+"."+se+".0 <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+".0 <"+(+Ce+1)+".0.0":$e?(C("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=Ce==="0"?se==="0"?">="+Ce+"."+se+"."+fe+$e+" <"+Ce+"."+se+"."+(+fe+1):">="+Ce+"."+se+"."+fe+$e+" <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+"."+fe+$e+" <"+(+Ce+1)+".0.0"):(C("no pr"),ye=Ce==="0"?se==="0"?">="+Ce+"."+se+"."+fe+" <"+Ce+"."+se+"."+(+fe+1):">="+Ce+"."+se+"."+fe+" <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+"."+fe+" <"+(+Ce+1)+".0.0"),C("caret return",ye),ye})}(Ve,Be)}).join(" ")}(Te,Ne),C("caret",Te),Te=function(Ue,Be){return Ue.trim().split(/\s+/).map(function(Ve){return function(Me,qe){var ze=qe?k[F]:k[U];return Me.replace(ze,function(We,Ce,se,fe,$e){var ye;return C("tilde",Me,We,Ce,se,fe,$e),Ee(Ce)?ye="":Ee(se)?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Ee(fe)?ye=">="+Ce+"."+se+".0 <"+Ce+"."+(+se+1)+".0":$e?(C("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=">="+Ce+"."+se+"."+fe+$e+" <"+Ce+"."+(+se+1)+".0"):ye=">="+Ce+"."+se+"."+fe+" <"+Ce+"."+(+se+1)+".0",C("tilde return",ye),ye})}(Ve,Be)}).join(" ")}(Te,Ne),C("tildes",Te),Te=function(Ue,Be){return C("replaceXRanges",Ue,Be),Ue.split(/\s+/).map(function(Ve){return function(Me,qe){Me=Me.trim();var ze=qe?k[N]:k[y];return Me.replace(ze,function(We,Ce,se,fe,$e,ye){C("xRange",Me,We,Ce,se,fe,$e,ye);var Ae=Ee(se),Le=Ae||Ee(fe),je=Le||Ee($e);return Ce==="="&&je&&(Ce=""),Ae?We=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&je?(Le&&(fe=0),je&&($e=0),Ce===">"?(Ce=">=",Le?(se=+se+1,fe=0,$e=0):je&&(fe=+fe+1,$e=0)):Ce==="<="&&(Ce="<",Le?se=+se+1:fe=+fe+1),We=Ce+se+"."+fe+"."+$e):Le?We=">="+se+".0.0 <"+(+se+1)+".0.0":je&&(We=">="+se+"."+fe+".0 <"+se+"."+(+fe+1)+".0"),C("xRange return",We),We})}(Ve,Be)}).join(" ")}(Te,Ne),C("xrange",Te),Te=function(Ue,Be){return C("replaceStars",Ue,Be),Ue.trim().replace(k[ne],"")}(Te,Ne),C("stars",Te),Te}(De,de)}).join(" ").split(/\s+/);return this.loose&&(ke=ke.filter(function(De){return!!De.match(Re)})),ke=ke.map(function(De){return new ce(De,de)})},pe.prototype.intersects=function(re,de){if(!(re instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Re){return re.set.some(function(ke){return ke.every(function(De){return Re.intersects(De,de)})})})})},e.toComparators=function(re,de){return new pe(re,de).set.map(function(me){return me.map(function(Re){return Re.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(re){if(!re)return!1;typeof re=="string"&&(re=new Q(re,this.loose));for(var de=0;de<this.set.length;de++)if(be(this.set[de],re))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(re,de,me){var Re=null,ke=null;try{var De=new pe(de,me)}catch{return null}return re.forEach(function(Te){De.test(Te)&&(Re&&ke.compare(Te)!==-1||(ke=new Q(Re=Te,me)))}),Re},e.minSatisfying=function(re,de,me){var Re=null,ke=null;try{var De=new pe(de,me)}catch{return null}return re.forEach(function(Te){De.test(Te)&&(Re&&ke.compare(Te)!==1||(ke=new Q(Re=Te,me)))}),Re},e.validRange=function(re,de){try{return new pe(re,de).range||"*"}catch{return null}},e.ltr=function(re,de,me){return Se(re,de,"<",me)},e.gtr=function(re,de,me){return Se(re,de,">",me)},e.outside=Se,e.prerelease=function(re,de){var me=ee(re,de);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(re,de,me){return re=new pe(re,me),de=new pe(de,me),re.intersects(de)},e.coerce=function(re){if(re instanceof Q)return re;if(typeof re!="string")return null;var de=re.match(k[S]);return de==null?null:ee((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,R(1))},function(ae,e){var R,a,C=ae.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function k(E){if(R===setTimeout)return setTimeout(E,0);if((R===A||!R)&&setTimeout)return R=setTimeout,setTimeout(E,0);try{return R(E,0)}catch{try{return R.call(null,E,0)}catch{return R.call(this,E,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:A}catch{R=A}try{a=typeof clearTimeout=="function"?clearTimeout:T}catch{a=T}})();var O,b=[],I=!1,$=-1;function d(){I&&O&&(I=!1,O.length?b=O.concat(b):$=-1,b.length&&g())}function g(){if(!I){var E=k(d);I=!0;for(var f=b.length;f;){for(O=b,b=[];++$<f;)O&&O[$].run();$=-1,f=b.length}O=null,I=!1,function(w){if(a===clearTimeout)return clearTimeout(w);if((a===T||!a)&&clearTimeout)return a=clearTimeout,clearTimeout(w);try{a(w)}catch{try{return a.call(null,w)}catch{return a.call(this,w)}}}(E)}}function l(E,f){this.fun=E,this.array=f}function m(){}C.nextTick=function(E){var f=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)f[w-1]=arguments[w];b.push(new l(E,f)),b.length!==1||I||k(g)},l.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=m,C.addListener=m,C.once=m,C.off=m,C.removeListener=m,C.removeAllListeners=m,C.emit=m,C.prependListener=m,C.prependOnceListener=m,C.listeners=function(E){return[]},C.binding=function(E){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(E){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(he[135],ue([0,1]),function(ae,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0;class a{constructor(k,O,b){this.level=k,this.key=O,this.value=b,this.forward=[]}}const C=void 0;class A{constructor(k,O=2**16){this.comparator=k,this[R]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(O)|0),this.e=new a(this.c,C,C)}get size(){return this.f}clear(){this.e=new a(this.c,C,C),this.f=0}has(k){return!!A.g(this,k,this.comparator)}get(k){return A.g(this,k,this.comparator)?.value}set(k,O){return A.h(this,k,O,this.comparator)&&(this.f+=1),this}delete(k){const O=A.k(this,k,this.comparator);return O&&(this.f-=1),O}forEach(k,O){let b=this.e.forward[0];for(;b;)k.call(O,b.value,b.key,this),b=b.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",O=this.e.forward[0];for(;O;)k+=`node(${O.key}, ${O.value}, lvl:${O.level})`,O=O.forward[0];return k}static g(k,O,b){let I=k.e;for(let $=k.d-1;$>=0;$--)for(;I.forward[$]&&b(I.forward[$].key,O)<0;)I=I.forward[$];if(I=I.forward[0],I&&b(I.key,O)===0)return I}static h(k,O,b,I){const $=[];let d=k.e;for(let g=k.d-1;g>=0;g--){for(;d.forward[g]&&I(d.forward[g].key,O)<0;)d=d.forward[g];$[g]=d}if(d=d.forward[0],d&&I(d.key,O)===0)return d.value=b,!1;{const g=A.j(k);if(g>k.d){for(let l=k.d;l<g;l++)$[l]=k.e;k.d=g}d=new a(g,O,b);for(let l=0;l<g;l++)d.forward[l]=$[l].forward[l],$[l].forward[l]=d;return!0}}static j(k,O=.5){let b=1;for(;Math.random()<O&&b<k.c;)b+=1;return b}static k(k,O,b){const I=[];let $=k.e;for(let d=k.d-1;d>=0;d--){for(;$.forward[d]&&b($.forward[d].key,O)<0;)$=$.forward[d];I[d]=$}if($=$.forward[0],!$||b($.key,O)!==0)return!1;for(let d=0;d<k.d&&I[d].forward[d]===$;d++)I[d].forward[d]=$.forward[d];for(;k.d>0&&k.e.forward[k.d-1]===C;)k.d-=1;return!0}}e.$Ts=A}),define(he[54],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=void 0;const R=globalThis.performance&&typeof globalThis.performance.now=="function";class a{static create(A){return new a(A)}constructor(A){this.c=R&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$fe=a}),define(he[3],ue([0,1,8,88,2,89,54]),function(ae,e,R,a,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$he=e.Event=void 0,e.$ie=g;const k=!1,O=!1,b=!1;var I;(function(F){F.None=()=>C.$Uc.None;function M(be){if(b){const{onDidAddListener:we}=be,Se=m.create();let re=0;be.onDidAddListener=()=>{++re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Se.print()),we?.()}}}function K(be,we){return ee(be,()=>{},0,void 0,!0,void 0,we)}F.defer=K;function V(be){return(we,Se=null,re)=>{let de=!1,me;return me=be(Re=>{if(!de)return me?me.dispose():de=!0,we.call(Se,Re)},null,re),de&&me.dispose(),me}}F.once=V;function x(be,we,Se){return ne((re,de=null,me)=>be(Re=>re.call(de,we(Re)),null,me),Se)}F.map=x;function H(be,we,Se){return ne((re,de=null,me)=>be(Re=>{we(Re),re.call(de,Re)},null,me),Se)}F.forEach=H;function te(be,we,Se){return ne((re,de=null,me)=>be(Re=>we(Re)&&re.call(de,Re),null,me),Se)}F.filter=te;function B(be){return be}F.signal=B;function z(...be){return(we,Se=null,re)=>{const de=(0,C.$Rc)(...be.map(me=>me(Re=>we.call(Se,Re))));return le(de,re)}}F.any=z;function _(be,we,Se,re){let de=Se;return x(be,me=>(de=we(de,me),de),re)}F.reduce=_;function ne(be,we){let Se;const re={onWillAddFirstListener(){Se=be(de.fire,de)},onDidRemoveLastListener(){Se?.dispose()}};we||M(re);const de=new i(re);return we?.add(de),de.event}function le(be,we){return we instanceof Array?we.push(be):we&&we.add(be),be}function ee(be,we,Se=100,re=!1,de=!1,me,Re){let ke,De,Te,Ne=0,Ue;const Be={leakWarningThreshold:me,onWillAddFirstListener(){ke=be(Me=>{Ne++,De=we(De,Me),re&&!Te&&(Ve.fire(De),De=void 0),Ue=()=>{const qe=De;De=void 0,Te=void 0,(!re||Ne>1)&&Ve.fire(qe),Ne=0},typeof Se=="number"?(clearTimeout(Te),Te=setTimeout(Ue,Se)):Te===void 0&&(Te=0,queueMicrotask(Ue))})},onWillRemoveListener(){de&&Ne>0&&Ue?.()},onDidRemoveLastListener(){Ue=void 0,ke.dispose()}};Re||M(Be);const Ve=new i(Be);return Re?.add(Ve),Ve.event}F.debounce=ee;function Q(be,we=0,Se){return F.debounce(be,(re,de)=>re?(re.push(de),re):[de],we,void 0,!0,void 0,Se)}F.accumulate=Q;function X(be,we=(re,de)=>re===de,Se){let re=!0,de;return te(be,me=>{const Re=re||!we(me,de);return re=!1,de=me,Re},Se)}F.latch=X;function q(be,we,Se){return[F.filter(be,we,Se),F.filter(be,re=>!we(re),Se)]}F.split=q;function D(be,we=!1,Se=[],re){let de=Se.slice(),me=be(De=>{de?de.push(De):ke.fire(De)});re&&re.add(me);const Re=()=>{de?.forEach(De=>ke.fire(De)),de=null},ke=new i({onWillAddFirstListener(){me||(me=be(De=>ke.fire(De)),re&&re.add(me))},onDidAddFirstListener(){de&&(we?setTimeout(Re):Re())},onDidRemoveLastListener(){me&&me.dispose(),me=null}});return re&&re.add(ke),ke.event}F.buffer=D;function Y(be,we){return(re,de,me)=>{const Re=we(new j);return be(function(ke){const De=Re.evaluate(ke);De!==oe&&re.call(de,De)},void 0,me)}}F.chain=Y;const oe=Symbol("HaltChainable");class j{constructor(){this.f=[]}map(we){return this.f.push(we),this}forEach(we){return this.f.push(Se=>(we(Se),Se)),this}filter(we){return this.f.push(Se=>we(Se)?Se:oe),this}reduce(we,Se){let re=Se;return this.f.push(de=>(re=we(re,de),re)),this}latch(we=(Se,re)=>Se===re){let Se=!0,re;return this.f.push(de=>{const me=Se||!we(de,re);return Se=!1,re=de,me?de:oe}),this}evaluate(we){for(const Se of this.f)if(we=Se(we),we===oe)break;return we}}function W(be,we,Se=re=>re){const re=(...ke)=>Re.fire(Se(...ke)),de=()=>be.on(we,re),me=()=>be.removeListener(we,re),Re=new i({onWillAddFirstListener:de,onDidRemoveLastListener:me});return Re.event}F.fromNodeEventEmitter=W;function G(be,we,Se=re=>re){const re=(...ke)=>Re.fire(Se(...ke)),de=()=>be.addEventListener(we,re),me=()=>be.removeEventListener(we,re),Re=new i({onWillAddFirstListener:de,onDidRemoveLastListener:me});return Re.event}F.fromDOMEventEmitter=G;function J(be){return new Promise(we=>V(be)(we))}F.toPromise=J;function ie(be){const we=new i;return be.then(Se=>{we.fire(Se)},()=>{we.fire(void 0)}).finally(()=>{we.dispose()}),we.event}F.fromPromise=ie;function ce(be,we){return be(Se=>we.fire(Se))}F.forward=ce;function ge(be,we,Se){return we(Se),be(re=>we(re))}F.runAndSubscribe=ge;class pe{constructor(we,Se){this._observable=we,this.f=0,this.g=!1;const re={onWillAddFirstListener:()=>{we.addObserver(this)},onDidRemoveLastListener:()=>{we.removeObserver(this)}};Se||M(re),this.emitter=new i(re),Se&&Se.add(this.emitter)}beginUpdate(we){this.f++}handlePossibleChange(we){}handleChange(we,Se){this.g=!0}endUpdate(we){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ee(be,we){return new pe(be,we).emitter.event}F.fromObservable=Ee;function Pe(be){return(we,Se,re)=>{let de=0,me=!1;const Re={beginUpdate(){de++},endUpdate(){de--,de===0&&(be.reportChanges(),me&&(me=!1,we.call(Se)))},handlePossibleChange(){},handleChange(){me=!0}};be.addObserver(Re),be.reportChanges();const ke={dispose(){be.removeObserver(Re)}};return re instanceof C.$Tc?re.add(ke):Array.isArray(re)&&re.push(ke),ke}}F.fromObservableLight=Pe})(I||(e.Event=I={}));class ${static{this.all=new Set}static{this.f=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${$.f++}`,$.all.add(this)}start(M){this.g=new T.$fe,this.listenerCount=M}stop(){if(this.g){const M=this.g.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this.g=void 0}}}e.$he=$;let d=-1;function g(F){const M=d;return d=F,{dispose(){d=M}}}class l{static{this.f=1}constructor(M,K,V=(l.f++).toString(16).padStart(3,"0")){this.j=M,this.threshold=K,this.name=V,this.h=0}dispose(){this.g?.clear()}check(M,K){const V=this.threshold;if(V<=0||K<V)return;this.g||(this.g=new Map);const x=this.g.get(M.value)||0;if(this.g.set(M.value,x+1),this.h-=1,this.h<=0){this.h=V*.5;const[H,te]=this.getMostFrequentStack(),B=`[${this.name}] potential listener LEAK detected, having ${K} listeners already. MOST frequent listener (${te}):`;console.warn(B),console.warn(H);const z=new E(B,H);this.j(z)}return()=>{const H=this.g.get(M.value)||0;this.g.set(M.value,H-1)}}getMostFrequentStack(){if(!this.g)return;let M,K=0;for(const[V,x]of this.g)(!M||K<x)&&(M=[V,x],K=x);return M}}class m{static create(){const M=new Error;return new m(M.stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E extends Error{constructor(M,K){super(M),this.name="ListenerLeakError",this.stack=K}}e.$je=E;class f extends Error{constructor(M,K){super(M),this.name="ListenerRefusalError",this.stack=K}}e.$ke=f;let w=0;class P{constructor(M){this.value=M,this.id=w++}}const p=2,c=(F,M)=>{if(F instanceof P)M(F);else for(let K=0;K<F.length;K++){const V=F[K];V&&M(V)}};let h;if(k){const F=[];setInterval(()=>{F.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(F.join(`
`)),F.length=0)},3e3),h=new FinalizationRegistry(M=>{typeof M=="string"&&F.push(M)})}class i{constructor(M){this.z=0,this.f=M,this.g=d>0||this.f?.leakWarningThreshold?new l(M?.onListenerError??R.$Y,this.f?.leakWarningThreshold??d):void 0,this.j=this.f?._profName?new $(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(O){const M=this.u;queueMicrotask(()=>{c(M,K=>K.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(M,K,V)=>{if(this.g&&this.z>this.g.threshold**2){const z=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(z);const _=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ne=new f(`${z}. HINT: Stack shows most frequent listener (${_[1]}-times)`,_[0]);return(this.f?.onListenerError||R.$Y)(ne),C.$Uc.None}if(this.m)return C.$Uc.None;K&&(M=M.bind(K));const x=new P(M);let H,te;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(x.stack=m.create(),H=this.g.check(x.stack,this.z+1)),O&&(x.stack=te??m.create()),this.u?this.u instanceof P?(this.w??=new t,this.u=[this.u,x]):this.u.push(x):(this.f?.onWillAddFirstListener?.(this),this.u=x,this.f?.onDidAddFirstListener?.(this)),this.z++;const B=(0,C.$Sc)(()=>{h?.unregister(B),H?.(),this.A(x)});if(V instanceof C.$Tc?V.add(B):Array.isArray(V)&&V.push(B),h){const z=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),_=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(z);h.register(B,_?.[2]??z,B)}return B},this.q}A(M){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const K=this.u,V=K.indexOf(M);if(V===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,K[V]=void 0;const x=this.w.current===this;if(this.z*p<=K.length){let H=0;for(let te=0;te<K.length;te++)K[te]?K[H++]=K[te]:x&&(this.w.end--,H<this.w.i&&this.w.i--);K.length=H}}B(M,K){if(!M)return;const V=this.f?.onListenerError||R.$Y;if(!V){M.value(K);return}try{M.value(K)}catch(x){V(x)}}C(M){const K=M.current.u;for(;M.i<M.end;)this.B(K[M.i++],M.value);M.reset()}fire(M){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof P)this.B(this.u,M);else{const K=this.w;K.enqueue(this,M,this.u.length),this.C(K)}this.j?.stop()}hasListeners(){return this.z>0}}e.$le=i;const n=()=>new t;e.$me=n;class t{constructor(){this.i=-1,this.end=0}enqueue(M,K,V){this.i=0,this.end=V,this.current=M,this.value=K}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends i{async fireAsync(M,K,V){if(this.u)for(this.h||(this.h=new A.$5c),c(this.u,x=>this.h.push([x.value,M]));this.h.size>0&&!K.isCancellationRequested;){const[x,H]=this.h.shift(),te=[],B={...H,token:K,waitUntil:z=>{if(Object.isFrozen(te))throw new Error("waitUntil can NOT be called asynchronous");V&&(z=V(z,x)),te.push(z)}};try{x(B)}catch(z){(0,R.$Y)(z);continue}Object.freeze(te),await Promise.allSettled(te).then(z=>{for(const _ of z)_.status==="rejected"&&(0,R.$Y)(_.reason)})}}}e.$ne=s;class r extends i{get isPaused(){return this.h!==0}constructor(M){super(M),this.h=0,this.s=new A.$5c,this.t=M?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const M=Array.from(this.s);this.s.clear(),super.fire(this.t(M))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(M){this.z&&(this.h!==0?this.s.push(M):super.fire(M))}}e.$oe=r;class o extends r{constructor(M){super(M),this.k=M.delay??100}fire(M){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(M)}}e.$pe=o;class u extends i{constructor(M){super(M),this.h=[],this.k=M?.merge}fire(M){this.hasListeners()&&(this.h.push(M),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(K=>super.fire(K)),this.h=[]}))}}e.$qe=u;class y{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(M){const K={event:M,listener:null};this.h.push(K),this.g&&this.m(K);const V=()=>{this.g&&this.o(K);const x=this.h.indexOf(K);this.h.splice(x,1)};return(0,C.$Sc)((0,a.$cb)(V))}j(){this.g=!0,this.h.forEach(M=>this.m(M))}k(){this.g=!1,this.h.forEach(M=>this.o(M))}m(M){M.listener=M.event(K=>this.f.fire(K))}o(M){M.listener?.dispose(),M.listener=null}dispose(){this.f.dispose();for(const M of this.h)M.listener?.dispose();this.h=[]}}e.$re=y;class N{constructor(M,K,V,x){this.f=new C.$Tc;const H=this.f.add(new y),te=this.f.add(new C.$4c);function B(z){te.set(z,H.add(x(z)))}for(const z of M)B(z);this.f.add(K(z=>{B(z)})),this.f.add(V(z=>{te.deleteAndDispose(z)})),this.event=H.event}dispose(){this.f.dispose()}}e.$se=N;class S{constructor(){this.f=[]}wrapEvent(M,K,V){return(x,H,te)=>M(B=>{const z=this.f[this.f.length-1];if(!K){z?z.buffers.push(()=>x.call(H,B)):x.call(H,B);return}const _=z;if(!_){x.call(H,K(V,B));return}_.items??=[],_.items.push(B),_.buffers.length===0&&z.buffers.push(()=>{_.reducedResult??=V?_.items.reduce(K,V):_.items.reduce(K),x.call(H,_.reducedResult)})},void 0,te)}bufferEvents(M){const K={buffers:new Array};this.f.push(K);const V=M();return this.f.pop(),K.buffers.forEach(x=>x()),V}}e.$te=S;class v{constructor(){this.f=!1,this.g=I.None,this.h=C.$Uc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(M){this.g=M,this.f&&(this.h.dispose(),this.h=M(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ue=v;class L{static const(M){return new U(M)}constructor(M){this.g=M,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(M){M!==this.g&&(this.g=M,this.f.fire(void 0))}}e.$ve=L;class U{constructor(M){this.value=M,this.onDidChange=I.None}}}),define(he[25],ue([0,1,3]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.CancellationToken=void 0,e.$xe=k;const a=Object.freeze(function(O,b){const I=setTimeout(O.bind(b),0);return{dispose(){clearTimeout(I)}}});var C;(function(O){function b(I){return I===O.None||I===O.Cancelled||I instanceof A?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}O.isCancellationToken=b,O.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),O.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:a})})(C||(e.CancellationToken=C={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?a:(this.b||(this.b=new R.$le),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(b){this.f=void 0,this.g=void 0,this.g=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=C.Cancelled}dispose(b=!1){b&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=C.None}}e.$we=T;function k(O){const b=new T;return O.add({dispose(){b.cancel()}}),b.token}}),define(he[136],ue([0,1,25]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_e=e.$$e=e.$9e=void 0,e.$0e=C;class a{constructor(O){this.b=O,this.a=null}get(){if(this.a)return this.a;const O=new R.$we,b=this.b(O.token);return this.a={promise:b,dispose:()=>{this.a=null,O.cancel(),O.dispose()}},this.a}}e.$9e=a;function C(k){return k}class A{constructor(O,b){this.a=void 0,this.b=void 0,typeof O=="function"?(this.c=O,this.d=C):(this.c=b,this.d=O.getCacheKey)}get(O){const b=this.d(O);return this.b!==b&&(this.b=b,this.a=this.c(O)),this.a}}e.$$e=A;class T{get cachedValues(){return this.a}constructor(O,b){this.a=new Map,this.b=new Map,typeof O=="function"?(this.c=O,this.d=C):(this.c=b,this.d=O.getCacheKey)}get(O){const b=this.d(O);if(this.b.has(b))return this.b.get(b);const I=this.c(O);return this.a.set(O,I),this.b.set(b,I),I}}e.$_e=T}),define(he[50],ue([0,1,8,2]),function(ae,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=C,e.$ze=A,e.$Ae=T,e.$Be=k,e.$Ce=b,e.$De=I,e.$Ee=$,e.$Fe=d,e.$Ge=g,e.$He=l,e.$Ie=m,e.$Je=E,e.$Ke=f,e.$Le=w,e.$Me=P;function C(p){const c=p;return c?typeof c.read=="function":!1}function A(p){const c=p;return c?[c.on,c.pause,c.resume,c.destroy].every(h=>typeof h=="function"):!1}function T(p){const c=p;return c?A(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}function k(p,c){return new O(p,c)}class O{constructor(c,h){this.e=c,this.f=h,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(h=>this.d.push(h))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(h=>h(c))}h(c){this.c.error.length===0?(0,R.$Y)(c):this.c.error.slice(0).forEach(h=>h(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,h){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(h),this.resume();break;case"end":this.c.end.push(h),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(h),this.a.flowing&&this.k();break}}removeListener(c,h){if(this.a.destroyed)return;let i;switch(c){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const n=i.indexOf(h);n>=0&&i.splice(n,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const h=[...this.d];this.d.length=0,h.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(p,c){const h=[];let i;for(;(i=p.read())!==null;)h.push(i);return c(h)}function I(p,c,h){const i=[];let n;for(;(n=p.read())!==null&&i.length<h;)i.push(n);return n===null&&i.length>0?c(i):{read:()=>{if(i.length>0)return i.shift();if(typeof n<"u"){const t=n;return n=void 0,t}return p.read()}}}function $(p,c){return new Promise((h,i)=>{const n=[];d(p,{onData:t=>{c&&n.push(t)},onError:t=>{c?i(t):h(void 0)},onEnd:()=>{h(c?c(n):void 0)}})})}function d(p,c,h){p.on("error",i=>{h?.isCancellationRequested||c.onError(i)}),p.on("end",()=>{h?.isCancellationRequested||c.onEnd()}),p.on("data",i=>{h?.isCancellationRequested||c.onData(i)})}function g(p,c){return new Promise((h,i)=>{const n=new a.$Tc,t=[],s=u=>{if(t.push(u),t.length>c)return n.dispose(),p.pause(),h({stream:p,buffer:t,ended:!1})},r=u=>(n.dispose(),i(u)),o=()=>(n.dispose(),h({stream:p,buffer:t,ended:!0}));n.add((0,a.$Sc)(()=>p.removeListener("error",r))),p.on("error",r),n.add((0,a.$Sc)(()=>p.removeListener("end",o))),p.on("end",o),n.add((0,a.$Sc)(()=>p.removeListener("data",s))),p.on("data",s)})}function l(p,c){const h=k(c);return h.end(p),h}function m(){const p=k(()=>{throw new Error("not supported")});return p.end(),p}function E(p){let c=!1;return{read:()=>c?null:(c=!0,p)}}function f(p,c,h){const i=k(h);return d(p,{onData:n=>i.write(c.data(n)),onError:n=>i.error(c.error?c.error(n):n),onEnd:()=>i.end()}),i}function w(p,c,h){let i=!1;return{read:()=>{const n=c.read();return i?n:(i=!0,n!==null?h([p,n]):p)}}}function P(p,c,h){let i=!1;const n=k(h);return d(c,{onData:t=>i?n.write(t):(i=!0,n.write(h([p,t]))),onError:t=>n.error(t),onEnd:()=>{i||(i=!0,n.write(p)),n.end()}}),n}}),define(he[14],ue([0,1,53,50]),function(ae,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=void 0,e.$Oe=b,e.$Pe=I,e.$Qe=$,e.$Re=d,e.$Se=g,e.$Te=l,e.$Ue=m,e.$Ve=E,e.$We=f,e.$Xe=w,e.$Ye=P,e.$Ze=p,e.$1e=c,e.$2e=h,e.$3e=i,e.$4e=n,e.$5e=t,e.$6e=s,e.$7e=r,e.$8e=y,a=Oe(a);const C=typeof Buffer<"u",A=new R.$T(()=>new Uint8Array(256));let T,k;class O{static alloc(S){return C?new O(Buffer.allocUnsafe(S)):new O(new Uint8Array(S))}static wrap(S){return C&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new O(S)}static fromString(S,v){return!(v?.dontUseNodeBuffer||!1)&&C?new O(Buffer.from(S)):(T||(T=new TextEncoder),new O(T.encode(S)))}static fromByteArray(S){const v=O.alloc(S.length);for(let L=0,U=S.length;L<U;L++)v.buffer[L]=S[L];return v}static concat(S,v){if(typeof v>"u"){v=0;for(let F=0,M=S.length;F<M;F++)v+=S[F].byteLength}const L=O.alloc(v);let U=0;for(let F=0,M=S.length;F<M;F++){const K=S[F];L.set(K,U),U+=K.byteLength}return L}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=O.alloc(this.byteLength);return S.set(this),S}toString(){return C?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(S,v){return new O(this.buffer.subarray(S,v))}set(S,v){if(S instanceof O)this.buffer.set(S.buffer,v);else if(S instanceof Uint8Array)this.buffer.set(S,v);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),v);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return d(this.buffer,S)}writeUInt32BE(S,v){g(this.buffer,S,v)}readUInt32LE(S){return l(this.buffer,S)}writeUInt32LE(S,v){m(this.buffer,S,v)}readUInt8(S){return E(this.buffer,S)}writeUInt8(S,v){f(this.buffer,S,v)}indexOf(S,v=0){return b(this.buffer,S instanceof O?S.buffer:S,v)}}e.$Ne=O;function b(N,S,v=0){const L=S.byteLength,U=N.byteLength;if(L===0)return 0;if(L===1)return N.indexOf(S[0]);if(L>U-v)return-1;const F=A.value;F.fill(S.length);for(let x=0;x<S.length;x++)F[S[x]]=S.length-x-1;let M=v+S.length-1,K=M,V=-1;for(;M<U;)if(N[M]===S[K]){if(K===0){V=M;break}M--,K--}else M+=Math.max(S.length-K,F[N[M]]),K=S.length-1;return V}function I(N,S){return N[S+0]<<0>>>0|N[S+1]<<8>>>0}function $(N,S,v){N[v+0]=S&255,S=S>>>8,N[v+1]=S&255}function d(N,S){return N[S]*2**24+N[S+1]*2**16+N[S+2]*2**8+N[S+3]}function g(N,S,v){N[v+3]=S,S=S>>>8,N[v+2]=S,S=S>>>8,N[v+1]=S,S=S>>>8,N[v]=S}function l(N,S){return N[S+0]<<0>>>0|N[S+1]<<8>>>0|N[S+2]<<16>>>0|N[S+3]<<24>>>0}function m(N,S,v){N[v+0]=S&255,S=S>>>8,N[v+1]=S&255,S=S>>>8,N[v+2]=S&255,S=S>>>8,N[v+3]=S&255}function E(N,S){return N[S]}function f(N,S,v){N[v]=S}function w(N){return a.$Ce(N,S=>O.concat(S))}function P(N){return a.$Je(N)}function p(N){return a.$Ee(N,S=>O.concat(S))}async function c(N){return N.ended?O.concat(N.buffer):O.concat([...N.buffer,await p(N.stream)])}function h(N){return a.$He(N,S=>O.concat(S))}function i(N){return a.$Ke(N,{data:S=>typeof S=="string"?O.fromString(S):O.wrap(S)},S=>O.concat(S))}function n(N){return a.$Be(S=>O.concat(S),N)}function t(N,S){return a.$Le(N,S,v=>O.concat(v))}function s(N,S){return a.$Me(N,S,v=>O.concat(v))}function r(N){let S=0,v=0,L=0;const U=new Uint8Array(Math.floor(N.length/4*3)),F=K=>{switch(v){case 3:U[L++]=S|K,v=0;break;case 2:U[L++]=S|K>>>2,S=K<<6,v=3;break;case 1:U[L++]=S|K>>>4,S=K<<4,v=2;break;default:S=K<<2,v=1}};for(let K=0;K<N.length;K++){const V=N.charCodeAt(K);if(V>=65&&V<=90)F(V-65);else if(V>=97&&V<=122)F(V-97+26);else if(V>=48&&V<=57)F(V-48+52);else if(V===43||V===45)F(62);else if(V===47||V===95)F(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${N[K]}`)}}const M=L;for(;v>0;)F(0);return O.wrap(U).slice(0,M)}const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:N},S=!0,v=!1){const L=v?u:o;let U="";const F=N.byteLength%3;let M=0;for(;M<N.byteLength-F;M+=3){const K=N[M+0],V=N[M+1],x=N[M+2];U+=L[K>>>2],U+=L[(K<<4|V>>>4)&63],U+=L[(V<<2|x>>>6)&63],U+=L[x&63]}if(F===1){const K=N[M+0];U+=L[K>>>2],U+=L[K<<4&63],S&&(U+="==")}else if(F===2){const K=N[M+0],V=N[M+1];U+=L[K>>>2],U+=L[(K<<4|V>>>4)&63],U+=L[V<<2&63],S&&(U+="=")}return U}}),define(he[137],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0,e.$ge=Symbol("MicrotaskDelay")}),define(he[12],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=R,e.$fg=a,e.$gg=C,e.$hg=A,e.$ig=T,e.$jg=k,e.$kg=O,e.$lg=b,e.$mg=I,e.$ng=$,e.$og=d,e.$pg=g,e.$qg=l,e.$rg=E,e.$sg=f,e.$tg=w,e.$ug=P,e.$vg=p,e.$wg=c;function R(h){return typeof h=="string"}function a(h){return Array.isArray(h)&&h.every(i=>R(i))}function C(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}function A(h){const i=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof i}function T(h){return typeof h=="number"&&!isNaN(h)}function k(h){return!!h&&typeof h[Symbol.iterator]=="function"}function O(h){return h===!0||h===!1}function b(h){return typeof h>"u"}function I(h){return!$(h)}function $(h){return b(h)||h===null}function d(h,i){if(!h)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function g(h){if($(h))throw new Error("Assertion Failed: argument is undefined or null");return h}function l(...h){const i=[];for(let n=0;n<h.length;n++){const t=h[n];if($(t))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(t)}return i}const m=Object.prototype.hasOwnProperty;function E(h){if(!C(h))return!1;for(const i in h)if(m.call(h,i))return!1;return!0}function f(h){return typeof h=="function"}function w(...h){return h.length>0&&h.every(f)}function P(h,i){const n=Math.min(h.length,i.length);for(let t=0;t<n;t++)p(h[t],i[t])}function p(h,i){if(R(i)){if(typeof h!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(f(i)){try{if(h instanceof i)return}catch{}if(!$(h)&&h.constructor===i||i.length===1&&i.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function c(h){return h}}),define(he[29],ue([0,1,12]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=a,e.$fo=C,e.$go=T,e.$ho=O,e.$io=b,e.$jo=I,e.$ko=$,e.$lo=d,e.$mo=g,e.$no=l,e.$oo=m,e.$po=E,e.$qo=f;function a(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const P=Array.isArray(w)?[]:{};return Object.entries(w).forEach(([p,c])=>{P[p]=c&&typeof c=="object"?a(c):c}),P}function C(w){if(!w||typeof w!="object")return w;const P=[w];for(;P.length>0;){const p=P.shift();Object.freeze(p);for(const c in p)if(A.call(p,c)){const h=p[c];typeof h=="object"&&!Object.isFrozen(h)&&!(0,R.$hg)(h)&&P.push(h)}}return w}const A=Object.prototype.hasOwnProperty;function T(w,P){return k(w,P,new Set)}function k(w,P,p){if((0,R.$ng)(w))return w;const c=P(w);if(typeof c<"u")return c;if(Array.isArray(w)){const h=[];for(const i of w)h.push(k(i,P,p));return h}if((0,R.$gg)(w)){if(p.has(w))throw new Error("Cannot clone recursive data-structure");p.add(w);const h={};for(const i in w)A.call(w,i)&&(h[i]=k(w[i],P,p));return p.delete(w),h}return w}function O(w,P,p=!0){return(0,R.$gg)(w)?((0,R.$gg)(P)&&Object.keys(P).forEach(c=>{c in w?p&&((0,R.$gg)(w[c])&&(0,R.$gg)(P[c])?O(w[c],P[c],p):w[c]=P[c]):w[c]=P[c]}),w):P}function b(w,P){if(w===P)return!0;if(w==null||P===null||P===void 0||typeof w!=typeof P||typeof w!="object"||Array.isArray(w)!==Array.isArray(P))return!1;let p,c;if(Array.isArray(w)){if(w.length!==P.length)return!1;for(p=0;p<w.length;p++)if(!b(w[p],P[p]))return!1}else{const h=[];for(c in w)h.push(c);h.sort();const i=[];for(c in P)i.push(c);if(i.sort(),!b(h,i))return!1;for(p=0;p<h.length;p++)if(!b(w[h[p]],P[h[p]]))return!1}return!0}function I(w){const P=new Set;return JSON.stringify(w,(p,c)=>{if((0,R.$gg)(c)||Array.isArray(c)){if(P.has(c))return"[Circular]";P.add(c)}return typeof c=="bigint"?`[BigInt ${c.toString()}]`:c})}function $(w,P){const p=Object.create(null);return!w||!P||Object.keys(P).forEach(h=>{const i=w[h],n=P[h];b(i,n)||(p[h]=n)}),p}function d(w,P){const p=P.toLowerCase(),c=Object.keys(w).find(h=>h.toLowerCase()===p);return c?w[c]:w[P]}function g(w,P){const p=Object.create(null);for(const[c,h]of Object.entries(w))P(c,h)&&(p[c]=h);return p}function l(w){let P=[];for(;Object.prototype!==w;)P=P.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return P}function m(w){const P=[];for(const p of l(w))typeof w[p]=="function"&&P.push(p);return P}function E(w,P){const p=h=>function(){const i=Array.prototype.slice.call(arguments,0);return P(h,i)},c={};for(const h of w)c[h]=p(h);return c}function f(w,P){const p={};for(const[c,h]of Object.entries(w))p[c]=P(h,c);return p}}),define(he[138],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$af=a,e.$bf=C;var R;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(R||(e.Constants=R={}));function a(A){return A<0?0:A>R.MAX_UINT_8?R.MAX_UINT_8:A|0}function C(A){return A<0?0:A>R.MAX_UINT_32?R.MAX_UINT_32:A|0}}),define(he[26],ue([0,1,136,39,53,138]),function(ae,e,R,a,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.GraphemeBreakType=e.$4f=e.$Vf=e.$Of=e.$Nf=void 0,e.$cf=T,e.$df=O,e.$ef=I,e.$ff=$,e.$gf=d,e.$hf=g,e.$if=l,e.$jf=m,e.$kf=E,e.$lf=f,e.$mf=w,e.$nf=P,e.$of=p,e.$pf=c,e.$qf=h,e.$rf=i,e.$sf=n,e.$tf=t,e.$uf=s,e.$vf=r,e.$wf=o,e.$xf=u,e.$yf=y,e.$zf=N,e.$Af=S,e.$Bf=v,e.$Cf=L,e.$Df=U,e.$Ef=F,e.$Ff=M,e.$Gf=K,e.$Hf=V,e.$If=x,e.$Jf=H,e.$Kf=te,e.$Lf=B,e.$Mf=z,e.$Pf=ee,e.$Qf=Q,e.$Rf=X,e.$Sf=q,e.$Tf=oe,e.$Uf=W,e.$Wf=G,e.$Xf=J,e.$Yf=ie,e.$Zf=ce,e.$1f=pe,e.$2f=Ee,e.$3f=be,e.$5f=we,e.$6f=Se,e.$7f=re,e.$8f=de,e.$9f=me,e.$0f=Re,e.$$f=ke,e.$_f=De,e.$ag=Ve;function T(se){return!se||typeof se!="string"?!0:se.trim().length===0}const k=/{(\d+)}/g;function O(se,...fe){return fe.length===0?se:se.replace(k,function($e,ye){const Ae=parseInt(ye,10);return isNaN(Ae)||Ae<0||Ae>=fe.length?$e:fe[Ae]})}const b=/{([^}]+)}/g;function I(se,fe){return Object.keys(fe).length===0?se:se.replace(b,($e,ye)=>fe[ye]??$e)}function $(se){return se.replace(/[<>"'&]/g,fe=>{switch(fe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return fe})}function d(se){return se.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}function g(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(se,fe){let $e=0,ye=se.indexOf(fe);for(;ye!==-1;)$e++,ye=se.indexOf(fe,ye+fe.length);return $e}function m(se,fe,$e="\u2026"){return se.length<=fe?se:`${se.substr(0,fe)}${$e}`}function E(se,fe,$e="\u2026"){if(se.length<=fe)return se;const ye=Math.ceil(fe/2)-$e.length/2,Ae=Math.floor(fe/2)-$e.length/2;return`${se.substr(0,ye)}${$e}${se.substr(se.length-Ae)}`}function f(se,fe=" "){const $e=w(se,fe);return P($e,fe)}function w(se,fe){if(!se||!fe)return se;const $e=fe.length;if($e===0||se.length===0)return se;let ye=0;for(;se.indexOf(fe,ye)===ye;)ye=ye+$e;return se.substring(ye)}function P(se,fe){if(!se||!fe)return se;const $e=fe.length,ye=se.length;if($e===0||ye===0)return se;let Ae=ye,Le=-1;for(;Le=se.lastIndexOf(fe,Ae-1),!(Le===-1||Le+$e!==Ae);){if(Le===0)return"";Ae=Le}return se.substring(0,Ae)}function p(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function c(se){return se.replace(/\*/g,"")}function h(se,fe,$e={}){if(!se)throw new Error("Cannot create regex from empty string");fe||(se=g(se)),$e.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let ye="";return $e.global&&(ye+="g"),$e.matchCase||(ye+="i"),$e.multiline&&(ye+="m"),$e.unicode&&(ye+="u"),new RegExp(se,ye)}function i(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}function n(se){return se.split(/\r\n|\r|\n/)}function t(se){const fe=[],$e=se.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil($e.length/2);ye++)fe.push($e[2*ye]+($e[2*ye+1]??""));return fe}function s(se){for(let fe=0,$e=se.length;fe<$e;fe++){const ye=se.charCodeAt(fe);if(ye!==a.CharCode.Space&&ye!==a.CharCode.Tab)return fe}return-1}function r(se,fe=0,$e=se.length){for(let ye=fe;ye<$e;ye++){const Ae=se.charCodeAt(ye);if(Ae!==a.CharCode.Space&&Ae!==a.CharCode.Tab)return se.substring(fe,ye)}return se.substring(fe,$e)}function o(se,fe=se.length-1){for(let $e=fe;$e>=0;$e--){const ye=se.charCodeAt($e);if(ye!==a.CharCode.Space&&ye!==a.CharCode.Tab)return $e}return-1}function u(se,fe,$e){const ye=[];let Ae=0;for(const Le of se.matchAll(fe)){if(ye.push(se.slice(Ae,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");Ae=Le.index+Le[0].length,ye.push($e(Le[0],...Le.slice(1),Le.index,se,Le.groups))}return ye.push(se.slice(Ae)),Promise.all(ye).then(Le=>Le.join(""))}function y(se,fe){return se<fe?-1:se>fe?1:0}function N(se,fe,$e=0,ye=se.length,Ae=0,Le=fe.length){for(;$e<ye&&Ae<Le;$e++,Ae++){const Je=se.charCodeAt($e),Ye=fe.charCodeAt(Ae);if(Je<Ye)return-1;if(Je>Ye)return 1}const je=ye-$e,xe=Le-Ae;return je<xe?-1:je>xe?1:0}function S(se,fe){return v(se,fe,0,se.length,0,fe.length)}function v(se,fe,$e=0,ye=se.length,Ae=0,Le=fe.length){for(;$e<ye&&Ae<Le;$e++,Ae++){let Je=se.charCodeAt($e),Ye=fe.charCodeAt(Ae);if(Je===Ye)continue;if(Je>=128||Ye>=128)return N(se.toLowerCase(),fe.toLowerCase(),$e,ye,Ae,Le);U(Je)&&(Je-=32),U(Ye)&&(Ye-=32);const Ge=Je-Ye;if(Ge!==0)return Ge}const je=ye-$e,xe=Le-Ae;return je<xe?-1:je>xe?1:0}function L(se){return se>=a.CharCode.Digit0&&se<=a.CharCode.Digit9}function U(se){return se>=a.CharCode.a&&se<=a.CharCode.z}function F(se){return se>=a.CharCode.A&&se<=a.CharCode.Z}function M(se,fe){return se.length===fe.length&&v(se,fe)===0}function K(se,fe){const $e=fe.length;return fe.length>se.length?!1:v(se,fe,0,$e)===0}function V(se,fe){const $e=Math.min(se.length,fe.length);let ye;for(ye=0;ye<$e;ye++)if(se.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return $e}function x(se,fe){const $e=Math.min(se.length,fe.length);let ye;const Ae=se.length-1,Le=fe.length-1;for(ye=0;ye<$e;ye++)if(se.charCodeAt(Ae-ye)!==fe.charCodeAt(Le-ye))return ye;return $e}function H(se){return 55296<=se&&se<=56319}function te(se){return 56320<=se&&se<=57343}function B(se,fe){return(se-55296<<10)+(fe-56320)+65536}function z(se,fe,$e){const ye=se.charCodeAt($e);if(H(ye)&&$e+1<fe){const Ae=se.charCodeAt($e+1);if(te(Ae))return B(ye,Ae)}return ye}function _(se,fe){const $e=se.charCodeAt(fe-1);if(te($e)&&fe>1){const ye=se.charCodeAt(fe-2);if(H(ye))return B(ye,$e)}return $e}class ne{get offset(){return this.e}constructor(fe,$e=0){this.c=fe,this.d=fe.length,this.e=$e}setOffset(fe){this.e=fe}prevCodePoint(){const fe=_(this.c,this.e);return this.e-=fe>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}nextCodePoint(){const fe=z(this.c,this.d,this.e);return this.e+=fe>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}eol(){return this.e>=this.d}}e.$Nf=ne;class le{get offset(){return this.c.offset}constructor(fe,$e=0){this.c=new ne(fe,$e)}nextGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Ae=fe.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Le=$e.offset,je=fe.getGraphemeBreakType($e.nextCodePoint());if(Te(Ae,je)){$e.setOffset(Le);break}Ae=je}return $e.offset-ye}prevGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Ae=fe.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Le=$e.offset,je=fe.getGraphemeBreakType($e.prevCodePoint());if(Te(je,Ae)){$e.setOffset(Le);break}Ae=je}return ye-$e.offset}eol(){return this.c.eol()}}e.$Of=le;function ee(se,fe){return new le(se,fe).nextGraphemeLength()}function Q(se,fe){return new le(se,fe).prevGraphemeLength()}function X(se,fe){fe>0&&te(se.charCodeAt(fe))&&fe--;const $e=fe+ee(se,fe);return[$e-Q(se,$e),$e]}function q(se){const fe=new le(se);let $e=0;for(;!fe.eol();)$e++,fe.nextGraphemeLength();return $e}let D;function Y(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(se){return D||(D=Y()),D.test(se)}const j=/^[\t\n\r\x20-\x7E]*$/;function W(se){return j.test(se)}e.$Vf=/[\u2028\u2029]/;function G(se){return e.$Vf.test(se)}function J(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}function ie(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}function ce(se,fe,$e=""){const ye=se.trimStart();if(ye.length<fe)return ye;const Ae=/\b/g;let Le=0;for(;Ae.test(ye)&&!(ye.length-Ae.lastIndex<fe);)Le=Ae.lastIndex,Ae.lastIndex+=1;return Le===0?ye:$e+ye.substring(Le).trimStart()}const ge=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*pe(se){let fe=0;for(const $e of se.matchAll(ge))fe!==$e.index&&(yield{isCode:!1,str:se.substring(fe,$e.index)}),yield{isCode:!0,str:$e[0]},fe=$e.index+$e[0].length;fe!==se.length&&(yield{isCode:!1,str:se.substring(fe)})}function Ee(se){return se&&(se=se.replace(ge,"")),se}const Pe=/\\\[.*?\\\]/g;function be(se){return Ee(se).replace(Pe,"")}e.$4f=String.fromCharCode(a.CharCode.UTF8_BOM);function we(se){return!!(se&&se.length>0&&se.charCodeAt(0)===a.CharCode.UTF8_BOM)}function Se(se){return we(se)?se.substr(1):se}function re(se,fe){if(!se||!fe||se.length<fe.length)return!1;const $e=fe.length,ye=se.toLowerCase();let Ae=0,Le=-1;for(;Ae<$e;){const je=ye.indexOf(fe[Ae],Le+1);if(je<0)return!1;Le=je,Ae++}return!0}function de(se,fe=!1){return se?(fe&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}function me(se){return se.charAt(0).toUpperCase()+se.slice(1)}function Re(se,fe=1){if(fe===0)return"";let $e=-1;do $e=se.indexOf(`
`,$e+1),fe--;while(fe>0&&$e>=0);return $e===-1?se:(se[$e-1]==="\r"&&$e--,se.substr(0,$e))}function ke(se){const fe=a.CharCode.Z-a.CharCode.A+1;return se=se%(2*fe),se<fe?String.fromCharCode(a.CharCode.a+se):String.fromCharCode(a.CharCode.A+se-fe)}function De(se){return Ue.getInstance().getGraphemeBreakType(se)}function Te(se,fe){return se===Ne.Other?fe!==Ne.Extend&&fe!==Ne.SpacingMark:se===Ne.CR&&fe===Ne.LF?!1:se===Ne.Control||se===Ne.CR||se===Ne.LF||fe===Ne.Control||fe===Ne.CR||fe===Ne.LF?!0:!(se===Ne.L&&(fe===Ne.L||fe===Ne.V||fe===Ne.LV||fe===Ne.LVT)||(se===Ne.LV||se===Ne.V)&&(fe===Ne.V||fe===Ne.T)||(se===Ne.LVT||se===Ne.T)&&fe===Ne.T||fe===Ne.Extend||fe===Ne.ZWJ||fe===Ne.SpacingMark||se===Ne.Prepend||se===Ne.ZWJ&&fe===Ne.Extended_Pictographic||se===Ne.Regional_Indicator&&fe===Ne.Regional_Indicator)}var Ne;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(Ne||(e.GraphemeBreakType=Ne={}));class Ue{static{this.c=null}static getInstance(){return Ue.c||(Ue.c=new Ue),Ue.c}constructor(){this.d=Be()}getGraphemeBreakType(fe){if(fe<32)return fe===a.CharCode.LineFeed?Ne.LF:fe===a.CharCode.CarriageReturn?Ne.CR:Ne.Control;if(fe<127)return Ne.Other;const $e=this.d,ye=$e.length/3;let Ae=1;for(;Ae<=ye;)if(fe<$e[3*Ae])Ae=2*Ae;else if(fe>$e[3*Ae+1])Ae=2*Ae+1;else return $e[3*Ae+2];return Ne.Other}}function Be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(se,fe){if(se===0)return 0;const $e=Me(se,fe);if($e!==void 0)return $e;const ye=new ne(fe,se);return ye.prevCodePoint(),ye.offset}function Me(se,fe){const $e=new ne(fe,se);let ye=$e.prevCodePoint();for(;qe(ye)||ye===ze.emojiVariantSelector||ye===ze.enclosingKeyCap;){if($e.offset===0)return;ye=$e.prevCodePoint()}if(!ie(ye))return;let Ae=$e.offset;return Ae>0&&$e.prevCodePoint()===ze.zwj&&(Ae=$e.offset),Ae}function qe(se){return 127995<=se&&se<=127999}var ze;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.$bg="\xA0";class We{static{this.c=new C.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new R.$$e({getCacheKey:JSON.stringify},fe=>{function $e(Ge){const _e=new Map;for(let Qe=0;Qe<Ge.length;Qe+=2)_e.set(Ge[Qe],Ge[Qe+1]);return _e}function ye(Ge,_e){const Qe=new Map(Ge);for(const[nt,at]of _e)Qe.set(nt,at);return Qe}function Ae(Ge,_e){if(!Ge)return _e;const Qe=new Map;for(const[nt,at]of Ge)_e.has(nt)&&Qe.set(nt,at);return Qe}const Le=this.c.value;let je=fe.filter(Ge=>!Ge.startsWith("_")&&Ge in Le);je.length===0&&(je=["_default"]);let xe;for(const Ge of je){const _e=$e(Le[Ge]);xe=Ae(xe,_e)}const Je=$e(Le._common),Ye=ye(Je,xe);return new We(Ye)})}static getInstance(fe){return We.d.get(Array.from(fe))}static{this.e=new C.$T(()=>Object.keys(We.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return We.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}containsAmbiguousCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$cg=We;class Ce{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ce.c())),this.d}static isInvisibleCharacter(fe){return Ce.e().has(fe)}static containsInvisibleCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&Ce.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Ce.e()}}e.$dg=Ce}),define(he[41],ue([0,1,39,13,5,26,12]),function(ae,e,R,a,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=k,e.$yg=O,e.$zg=b,e.$Ag=I,e.$Bg=$,e.$Cg=m,e.$Dg=E,e.$Eg=f,e.$Fg=w,e.$Gg=P,e.$Hg=p,e.$Ig=c,e.$Jg=h,e.$Kg=i,e.$Lg=n,e.$Mg=t,e.$Ng=o;function k(u){return u===R.CharCode.Slash||u===R.CharCode.Backslash}function O(u){return u.replace(/[\\/]/g,a.$gc.sep)}function b(u){return u.indexOf("/")===-1&&(u=O(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}function I(u,y=a.$gc.sep){if(!u)return"";const N=u.length,S=u.charCodeAt(0);if(k(S)){if(k(u.charCodeAt(1))&&!k(u.charCodeAt(2))){let L=3;const U=L;for(;L<N&&!k(u.charCodeAt(L));L++);if(U!==L&&!k(u.charCodeAt(L+1))){for(L+=1;L<N;L++)if(k(u.charCodeAt(L)))return u.slice(0,L+1).replace(/[\\/]/g,y)}}return y}else if(w(S)&&u.charCodeAt(1)===R.CharCode.Colon)return k(u.charCodeAt(2))?u.slice(0,2)+y:u.slice(0,2);let v=u.indexOf("://");if(v!==-1){for(v+=3;v<N;v++)if(k(u.charCodeAt(v)))return u.slice(0,v+1)}return""}function $(u){if(!C.$j||!u||u.length<5)return!1;let y=u.charCodeAt(0);if(y!==R.CharCode.Backslash||(y=u.charCodeAt(1),y!==R.CharCode.Backslash))return!1;let N=2;const S=N;for(;N<u.length&&(y=u.charCodeAt(N),y!==R.CharCode.Backslash);N++);return!(S===N||(y=u.charCodeAt(N+1),isNaN(y)||y===R.CharCode.Backslash))}const d=/[\\/:\*\?"<>\|]/g,g=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(u,y=C.$j){const N=y?d:g;return!(!u||u.length===0||/^\s+$/.test(u)||(N.lastIndex=0,N.test(u))||y&&l.test(u)||u==="."||u===".."||y&&u[u.length-1]==="."||y&&u.length!==u.trim().length||u.length>255)}function E(u,y,N){const S=u===y;return!N||S?S:!u||!y?!1:(0,A.$Ff)(u,y)}function f(u,y,N,S=a.sep){if(u===y)return!0;if(!u||!y||y.length>u.length)return!1;if(N){if(!(0,A.$Gf)(u,y))return!1;if(y.length===u.length)return!0;let L=y.length;return y.charAt(y.length-1)===S&&L--,u.charAt(L)===S}return y.charAt(y.length-1)!==S&&(y+=S),u.indexOf(y)===0}function w(u){return u>=R.CharCode.A&&u<=R.CharCode.Z||u>=R.CharCode.a&&u<=R.CharCode.z}function P(u,y){return C.$j&&u.endsWith(":")&&(u+=a.sep),(0,a.$ic)(u)||(u=(0,a.$jc)(y,u)),u=(0,a.$hc)(u),p(u)}function p(u){return C.$j?(u=(0,A.$nf)(u,a.sep),u.endsWith(":")&&(u+=a.sep)):(u=(0,A.$nf)(u,a.sep),u||(u=a.sep)),u}function c(u){const y=(0,a.$hc)(u);return C.$j?u.length>3?!1:h(y)&&(u.length===2||y.charCodeAt(2)===R.CharCode.Backslash):y===a.$gc.sep}function h(u,y=C.$j){return y?w(u.charCodeAt(0))&&u.charCodeAt(1)===R.CharCode.Colon:!1}function i(u,y=C.$j){return h(u,y)?u[0]:void 0}function n(u,y,N){return y.length>u.length?-1:u===y?0:(N&&(u=u.toLowerCase(),y=y.toLowerCase()),u.indexOf(y))}function t(u){const y=u.split(":");let N,S,v;for(const L of y){const U=Number(L);(0,T.$ig)(U)?S===void 0?S=U:v===void 0&&(v=U):N=N?[N,L].join(":"):L}if(!N)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:N,line:S!==void 0?S:void 0,column:v!==void 0?v:S!==void 0?1:void 0}}const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",r="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(u,y,N=8){let S="";for(let L=0;L<N;L++){let U;L===0&&C.$j&&!y&&(N===3||N===4)?U=r:U=s,S+=U.charAt(Math.floor(Math.random()*U.length))}let v;return y?v=`${y}-${S}`:v=S,u?(0,a.$jc)(u,v):v}}),define(he[55],ue([0,1,26]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$xj=void 0,e.$tj=a,e.$uj=C,e.$vj=A,e.$wj=k,e.$yj=m,R=Oe(R);function a(f){return C(f,0)}function C(f,w){switch(typeof f){case"object":return f===null?A(349,w):Array.isArray(f)?O(f,w):b(f,w);case"string":return k(f,w);case"boolean":return T(f,w);case"number":return A(f,w);case"undefined":return A(937,w);default:return A(617,w)}}function A(f,w){return(w<<5)-w+f|0}function T(f,w){return A(f?433:863,w)}function k(f,w){w=A(149417,w);for(let P=0,p=f.length;P<p;P++)w=A(f.charCodeAt(P),w);return w}function O(f,w){return w=A(104579,w),f.reduce((P,p)=>C(p,P),w)}function b(f,w){return w=A(181387,w),Object.keys(f).sort().reduce((P,p)=>(P=k(p,P),C(f[p],P)),w)}class I{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=C(w,this.g),this.g}}e.$xj=I;var $;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})($||($={}));function d(f,w,P=32){const p=P-w,c=~((1<<p)-1);return(f<<w|(c&f)>>>p)>>>0}function g(f,w=0,P=f.byteLength,p=0){for(let c=0;c<P;c++)f[w+c]=p}function l(f,w,P="0"){for(;f.length<w;)f=P+f;return f}function m(f,w=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(P=>P.toString(16).padStart(2,"0")).join(""):l((f>>>0).toString(16),w/4)}class E{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array($.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const P=w.length;if(P===0)return;const p=this.p;let c=this.r,h=this.u,i,n;for(h!==0?(i=h,n=-1,h=0):(i=w.charCodeAt(0),n=0);;){let t=i;if(R.$Jf(i))if(n+1<P){const s=w.charCodeAt(n+1);R.$Kf(s)?(n++,t=R.$Lf(i,s)):t=$.UNICODE_REPLACEMENT}else{h=i;break}else R.$Kf(i)&&(t=$.UNICODE_REPLACEMENT);if(c=this.w(p,c,t),n++,n<P)i=w.charCodeAt(n);else break}this.r=c,this.u=h}w(w,P,p){return p<128?w[P++]=p:p<2048?(w[P++]=192|(p&1984)>>>6,w[P++]=128|(p&63)>>>0):p<65536?(w[P++]=224|(p&61440)>>>12,w[P++]=128|(p&4032)>>>6,w[P++]=128|(p&63)>>>0):(w[P++]=240|(p&1835008)>>>18,w[P++]=128|(p&258048)>>>12,w[P++]=128|(p&4032)>>>6,w[P++]=128|(p&63)>>>0),P>=$.BLOCK_SIZE&&(this.y(),P-=$.BLOCK_SIZE,this.t+=$.BLOCK_SIZE,w[0]=w[$.BLOCK_SIZE+0],w[1]=w[$.BLOCK_SIZE+1],w[2]=w[$.BLOCK_SIZE+2]),P}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,$.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=E.g,P=this.q;for(let o=0;o<64;o+=4)w.setUint32(o,P.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)w.setUint32(o,d(w.getUint32(o-12,!1)^w.getUint32(o-32,!1)^w.getUint32(o-56,!1)^w.getUint32(o-64,!1),1),!1);let p=this.h,c=this.l,h=this.m,i=this.n,n=this.o,t,s,r;for(let o=0;o<80;o++)o<20?(t=c&h|~c&i,s=1518500249):o<40?(t=c^h^i,s=1859775393):o<60?(t=c&h|c&i|h&i,s=2400959708):(t=c^h^i,s=3395469782),r=d(p,5)+t+n+s+w.getUint32(o*4,!1)&4294967295,n=i,i=h,h=d(c,30),c=p,p=r;this.h=this.h+p&4294967295,this.l=this.l+c&4294967295,this.m=this.m+h&4294967295,this.n=this.n+i&4294967295,this.o=this.o+n&4294967295}}e.$zj=E}),define(he[92],ue([0,1,26]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R=Oe(R);var a;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(a||(a={})),function(C){const A="error",T="warning",k="warn",O="info",b="ignore";function I(d){return d?R.$Ff(A,d)?C.Error:R.$Ff(T,d)||R.$Ff(k,d)?C.Warning:R.$Ff(O,d)?C.Info:C.Ignore:C.Ignore}C.fromValue=I;function $(d){switch(d){case C.Error:return A;case C.Warning:return T;case C.Info:return O;default:return b}}C.toString=$}(a||(a={})),e.default=a}),define(he[51],ue([0,1,17,39,26]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class A{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const m=l.charCodeAt(0),E=this.b.charCodeAt(this.c);return m-E}value(){return this.b[this.c]}}e.$Hi=A;class T{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===a.CharCode.Period)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,C.$zf)(l,this.b,0,l.length,this.c,this.d):(0,C.$Bf)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=T;class k{constructor(l=!0,m=!0){this.f=l,this.g=m}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let m=l.length-1;m>=0;m--,this.c--){const E=this.b.charCodeAt(m);if(!(E===a.CharCode.Slash||this.f&&E===a.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===a.CharCode.Slash||this.f&&m===a.CharCode.Backslash)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,C.$zf)(l,this.b,0,l.length,this.d,this.e):(0,C.$Bf)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=k;var O;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(O||(O={}));class b{constructor(l,m){this.f=l,this.g=m,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(O.Scheme),this.c.authority&&this.d.push(O.Authority),this.c.path&&(this.b=new k(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(O.Path)),this.g(l)||(this.c.query&&this.d.push(O.Query),this.c.fragment&&this.d.push(O.Fragment)),this.e=0,this}next(){return this.d[this.e]===O.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===O.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===O.Scheme)return(0,C.$Af)(l,this.c.scheme);if(this.d[this.e]===O.Authority)return(0,C.$Af)(l,this.c.authority);if(this.d[this.e]===O.Path)return this.b.cmp(l);if(this.d[this.e]===O.Query)return(0,C.$yf)(l,this.c.query);if(this.d[this.e]===O.Fragment)return(0,C.$yf)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===O.Scheme)return this.c.scheme;if(this.d[this.e]===O.Authority)return this.c.authority;if(this.d[this.e]===O.Path)return this.b.value();if(this.d[this.e]===O.Query)return this.c.query;if(this.d[this.e]===O.Fragment)return this.c.fragment;throw new Error}}e.$Ki=b;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var $;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})($||($={}));class d{static forUris(l=()=>!1,m=()=>!1){return new d(new b(l,m))}static forPaths(l=!1){return new d(new k(void 0,!l))}static forStrings(){return new d(new A)}static forConfigKeys(){return new d(new T)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,m){if(m){const E=m.slice(0);(0,R.$Vb)(E);for(const f of E)this.set(f,l)}else{const E=l.slice(0);(0,R.$Vb)(E);for(const f of E)this.set(f[0],f[1])}}set(l,m){const E=this.b.reset(l);let f;this.c||(this.c=new I,this.c.segment=E.value());const w=[];for(f=this.c;;){const p=E.cmp(f.segment);if(p>0)f.left||(f.left=new I,f.left.segment=E.value()),w.push([$.Left,f]),f=f.left;else if(p<0)f.right||(f.right=new I,f.right.segment=E.value()),w.push([$.Right,f]),f=f.right;else if(E.hasNext())E.next(),f.mid||(f.mid=new I,f.mid.segment=E.value()),w.push([$.Mid,f]),f=f.mid;else break}const P=f.value;f.value=m,f.key=l;for(let p=w.length-1;p>=0;p--){const c=w[p][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const i=w[p][0],n=w[p+1][0];if(i===$.Right&&n===$.Right)w[p][1]=c.rotateLeft();else if(i===$.Left&&n===$.Left)w[p][1]=c.rotateRight();else if(i===$.Right&&n===$.Left)c.right=w[p+1][1]=w[p+1][1].rotateRight(),w[p][1]=c.rotateLeft();else if(i===$.Left&&n===$.Right)c.left=w[p+1][1]=w[p+1][1].rotateLeft(),w[p][1]=c.rotateRight();else throw new Error;if(p>0)switch(w[p-1][0]){case $.Left:w[p-1][1].left=w[p][1];break;case $.Right:w[p-1][1].right=w[p][1];break;case $.Mid:w[p-1][1].mid=w[p][1];break}else this.c=w[0][1]}}return P}get(l){return this.d(l)?.value}d(l){const m=this.b.reset(l);let E=this.c;for(;E;){const f=m.cmp(E.segment);if(f>0)E=E.left;else if(f<0)E=E.right;else if(m.hasNext())m.next(),E=E.mid;else break}return E}has(l){const m=this.d(l);return!(m?.value===void 0&&m?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,m){const E=this.b.reset(l),f=[];let w=this.c;for(;w;){const P=E.cmp(w.segment);if(P>0)f.push([$.Left,w]),w=w.left;else if(P<0)f.push([$.Right,w]),w=w.right;else if(E.hasNext())E.next(),f.push([$.Mid,w]),w=w.mid;else break}if(w){if(m?(w.left=void 0,w.mid=void 0,w.right=void 0,w.height=1):(w.key=void 0,w.value=void 0),!w.mid&&!w.value)if(w.left&&w.right){const P=this.f(w.right);if(P.key){const{key:p,value:c,segment:h}=P;this.e(P.key,!1),w.key=p,w.value=c,w.segment=h}}else{const P=w.left??w.right;if(f.length>0){const[p,c]=f[f.length-1];switch(p){case $.Left:c.left=P;break;case $.Mid:c.mid=P;break;case $.Right:c.right=P;break}}else this.c=P}for(let P=f.length-1;P>=0;P--){const p=f[P][1];p.updateHeight();const c=p.balanceFactor();if(c>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),f[P][1]=p.rotateLeft()):c<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),f[P][1]=p.rotateRight()),P>0)switch(f[P-1][0]){case $.Left:f[P-1][1].left=f[P][1];break;case $.Right:f[P-1][1].right=f[P][1];break;case $.Mid:f[P-1][1].mid=f[P][1];break}else this.c=f[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const m=this.b.reset(l);let E=this.c,f;for(;E;){const w=m.cmp(E.segment);if(w>0)E=E.left;else if(w<0)E=E.right;else if(m.hasNext())m.next(),f=E.value||f,E=E.mid;else break}return E&&E.value||f}findSuperstr(l){return this.g(l,!1)}g(l,m){const E=this.b.reset(l);let f=this.c;for(;f;){const w=E.cmp(f.segment);if(w>0)f=f.left;else if(w<0)f=f.right;else if(E.hasNext())E.next(),f=f.mid;else return f.mid?this.h(f.mid):m?f.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[m,E]of this)l(E,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const m=[];return this.j(l,m),m[Symbol.iterator]()}j(l,m){l&&(l.left&&this.j(l.left,m),l.value&&m.push([l.key,l.value]),l.mid&&this.j(l.mid,m),l.right&&this.j(l.right,m))}_isBalanced(){const l=m=>{if(!m)return!0;const E=m.balanceFactor();return E<-1||E>1?!1:l(m.left)&&l(m.right)};return l(this.c)}}e.$Li=d}),define(he[9],ue([0,1,39,65,13,5]),function(ae,e,R,a,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=E,e.$wc=h,C=Oe(C);const T=/^\w[\w\d+.-]*$/,k=/^\//,O=/^\/\//;function b(r,o){if(!r.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!T.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!k.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(r,o){return!r&&!o?"file":r}function $(r,o){switch(r){case"https":case"http":case"file":o?o[0]!==g&&(o=g+o):o=g;break}return o}const d="",g="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(o){return o instanceof m?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,u,y,N,S,v=!1){typeof o=="object"?(this.scheme=o.scheme||d,this.authority=o.authority||d,this.path=o.path||d,this.query=o.query||d,this.fragment=o.fragment||d):(this.scheme=I(o,v),this.authority=u||d,this.path=$(this.scheme,y||d),this.query=N||d,this.fragment=S||d,b(this,v))}get fsPath(){return h(this,!1)}with(o){if(!o)return this;let{scheme:u,authority:y,path:N,query:S,fragment:v}=o;return u===void 0?u=this.scheme:u===null&&(u=d),y===void 0?y=this.authority:y===null&&(y=d),N===void 0?N=this.path:N===null&&(N=d),S===void 0?S=this.query:S===null&&(S=d),v===void 0?v=this.fragment:v===null&&(v=d),u===this.scheme&&y===this.authority&&N===this.path&&S===this.query&&v===this.fragment?this:new w(u,y,N,S,v)}static parse(o,u=!1){const y=l.exec(o);return y?new w(y[2]||d,s(y[4]||d),s(y[5]||d),s(y[7]||d),s(y[9]||d),u):new w(d,d,d,d,d)}static file(o){let u=d;if(A.$j&&(o=o.replace(/\\/g,g)),o[0]===g&&o[1]===g){const y=o.indexOf(g,2);y===-1?(u=o.substring(2),o=g):(u=o.substring(2,y),o=o.substring(y)||g)}return new w("file",u,o,d,d)}static from(o,u){return new w(o.scheme,o.authority,o.path,o.query,o.fragment,u)}static joinPath(o,...u){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return A.$j&&o.scheme==="file"?y=m.file(C.$fc.join(h(o,!0),...u)).path:y=C.$gc.join(o.path,...u),o.with({path:y})}toString(o=!1){return i(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof m)return o;{const u=new w(o);return u._formatted=o.external??null,u._fsPath=o._sep===f?o.fsPath??null:null,u}}else return o}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=m;function E(r){return!r||typeof r!="object"?!1:typeof r.scheme=="string"&&(typeof r.authority=="string"||typeof r.authority>"u")&&(typeof r.path=="string"||typeof r.path>"u")&&(typeof r.query=="string"||typeof r.query>"u")&&(typeof r.fragment=="string"||typeof r.fragment>"u")}const f=A.$j?1:void 0;class w extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(o=!1){return o?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const o={$mid:a.MarshalledId.Uri};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=f),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const P={[R.CharCode.Colon]:"%3A",[R.CharCode.Slash]:"%2F",[R.CharCode.QuestionMark]:"%3F",[R.CharCode.Hash]:"%23",[R.CharCode.OpenSquareBracket]:"%5B",[R.CharCode.CloseSquareBracket]:"%5D",[R.CharCode.AtSign]:"%40",[R.CharCode.ExclamationMark]:"%21",[R.CharCode.DollarSign]:"%24",[R.CharCode.Ampersand]:"%26",[R.CharCode.SingleQuote]:"%27",[R.CharCode.OpenParen]:"%28",[R.CharCode.CloseParen]:"%29",[R.CharCode.Asterisk]:"%2A",[R.CharCode.Plus]:"%2B",[R.CharCode.Comma]:"%2C",[R.CharCode.Semicolon]:"%3B",[R.CharCode.Equals]:"%3D",[R.CharCode.Space]:"%20"};function p(r,o,u){let y,N=-1;for(let S=0;S<r.length;S++){const v=r.charCodeAt(S);if(v>=R.CharCode.a&&v<=R.CharCode.z||v>=R.CharCode.A&&v<=R.CharCode.Z||v>=R.CharCode.Digit0&&v<=R.CharCode.Digit9||v===R.CharCode.Dash||v===R.CharCode.Period||v===R.CharCode.Underline||v===R.CharCode.Tilde||o&&v===R.CharCode.Slash||u&&v===R.CharCode.OpenSquareBracket||u&&v===R.CharCode.CloseSquareBracket||u&&v===R.CharCode.Colon)N!==-1&&(y+=encodeURIComponent(r.substring(N,S)),N=-1),y!==void 0&&(y+=r.charAt(S));else{y===void 0&&(y=r.substr(0,S));const L=P[v];L!==void 0?(N!==-1&&(y+=encodeURIComponent(r.substring(N,S)),N=-1),y+=L):N===-1&&(N=S)}}return N!==-1&&(y+=encodeURIComponent(r.substring(N))),y!==void 0?y:r}function c(r){let o;for(let u=0;u<r.length;u++){const y=r.charCodeAt(u);y===R.CharCode.Hash||y===R.CharCode.QuestionMark?(o===void 0&&(o=r.substr(0,u)),o+=P[y]):o!==void 0&&(o+=r[u])}return o!==void 0?o:r}function h(r,o){let u;return r.authority&&r.path.length>1&&r.scheme==="file"?u=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===R.CharCode.Slash&&(r.path.charCodeAt(1)>=R.CharCode.A&&r.path.charCodeAt(1)<=R.CharCode.Z||r.path.charCodeAt(1)>=R.CharCode.a&&r.path.charCodeAt(1)<=R.CharCode.z)&&r.path.charCodeAt(2)===R.CharCode.Colon?o?u=r.path.substr(1):u=r.path[1].toLowerCase()+r.path.substr(2):u=r.path,A.$j&&(u=u.replace(/\//g,"\\")),u}function i(r,o){const u=o?c:p;let y="",{scheme:N,authority:S,path:v,query:L,fragment:U}=r;if(N&&(y+=N,y+=":"),(S||N==="file")&&(y+=g,y+=g),S){let F=S.indexOf("@");if(F!==-1){const M=S.substr(0,F);S=S.substr(F+1),F=M.lastIndexOf(":"),F===-1?y+=u(M,!1,!1):(y+=u(M.substr(0,F),!1,!1),y+=":",y+=u(M.substr(F+1),!1,!0)),y+="@"}S=S.toLowerCase(),F=S.lastIndexOf(":"),F===-1?y+=u(S,!1,!0):(y+=u(S.substr(0,F),!1,!0),y+=S.substr(F))}if(v){if(v.length>=3&&v.charCodeAt(0)===R.CharCode.Slash&&v.charCodeAt(2)===R.CharCode.Colon){const F=v.charCodeAt(1);F>=R.CharCode.A&&F<=R.CharCode.Z&&(v=`/${String.fromCharCode(F+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===R.CharCode.Colon){const F=v.charCodeAt(0);F>=R.CharCode.A&&F<=R.CharCode.Z&&(v=`${String.fromCharCode(F+32)}:${v.substr(2)}`)}y+=u(v,!0,!1)}return L&&(y+="?",y+=u(L,!1,!1)),U&&(y+="#",y+=o?U:p(U,!1,!1)),y}function n(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+n(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,o=>n(o)):r}}),define(he[139],ue([0,1,9]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=a,e.$er=C,e.$fr=A,e.log=k;function a(b){const I=b;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function C(b){const I=[];let $;try{const d=JSON.parse(b.arguments),g=d[d.length-1];g&&g.__$stack&&(d.pop(),$=g.__$stack),I.push(...d)}catch{I.push("Unable to log remote console arguments",b.arguments)}return{args:I,stack:$}}function A(b){if(typeof b!="string")return A(C(b).stack);const I=b;if(I){const $=T(I),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec($||"");if(d&&d.length===4)return{uri:R.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}function T(b){if(!b)return b;const I=b.indexOf(`
`);return I===-1?b:b.substring(0,I)}function k(b,I){const{args:$,stack:d}=C(b),g=typeof $[0]=="string"&&$.length===1;let l=T(d);l&&(l=`(${l.trim()})`);let m=[];if(typeof $[0]=="string"?l&&g?m=[`%c[${I}] %c${$[0]} %c${l}`,O("blue"),O(""),O("grey")]:m=[`%c[${I}] %c${$[0]}`,O("blue"),O(""),...$.slice(1)]:m=[`%c[${I}]%`,O("blue"),...$],l&&!g&&m.push(l),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,m)}function O(b){return`color: ${b}`}}),define(he[66],ue([0,1,14,9,65]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=A,e.$bi=T,e.$ci=O;function A(b){return JSON.stringify(b,k)}function T(b){let I=JSON.parse(b);return I=O(I),I}function k(b,I){return I instanceof RegExp?{$mid:C.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function O(b,I=0){if(!b||I>200)return b;if(typeof b=="object"){switch(b.$mid){case C.MarshalledId.Uri:return a.URI.revive(b);case C.MarshalledId.Regexp:return new RegExp(b.source,b.flags);case C.MarshalledId.Date:return new Date(b.source)}if(b instanceof R.$Ne||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let $=0;$<b.length;++$)b[$]=O(b[$],I+1);else for(const $ in b)Object.hasOwnProperty.call(b,$)&&(b[$]=O(b[$],I+1))}return b}}),define(he[22],ue([0,1,8,5,26,9,13]),function(ae,e,R,a,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=O,e.$Pg=b,e.$Tg=$,R=Oe(R),a=Oe(a),T=Oe(T);var k;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting"})(k||(e.Schemas=k={}));function O(l,m){return A.URI.isUri(l)?(0,C.$Ff)(l.scheme,m):(0,C.$Gf)(l,m+":")}function b(l,...m){return m.some(E=>O(l,E))}e.$Qg="vscode-tkn",e.$Rg="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m,E){this.f=$(m,E)}getServerRootPath(){return this.f}get g(){return T.$gc.join(this.f,k.vscodeRemoteResource)}set(m,E,f){this.a[m]=E,this.b[m]=f}setConnectionToken(m,E){this.c[m]=E}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)try{return this.e(m)}catch(c){return R.$Y(c),m}const E=m.authority;let f=this.a[E];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const w=this.b[E],P=this.c[E];let p=`path=${encodeURIComponent(m.path)}`;return typeof P=="string"&&(p+=`&${e.$Rg}=${encodeURIComponent(P)}`),A.URI.from({scheme:a.$p?this.d:k.vscodeRemoteResource,authority:`${f}:${w}`,path:this.g,query:p})}}e.$Sg=new I;function $(l,m){return T.$gc.join(m??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class d{static{this.a=e.$Yg}asBrowserUri(m){const E=this.b(m,ae);return this.uriToBrowserUri(E)}uriToBrowserUri(m){return m.scheme===k.vscodeRemote?e.$Sg.rewrite(m):m.scheme===k.file&&(a.$n||a.$r===`${k.vscodeFileResource}://${d.a}`)?m.with({scheme:k.vscodeFileResource,authority:m.authority||d.a,query:null,fragment:null}):m}asFileUri(m){const E=this.b(m,ae);return this.uriToFileUri(E)}uriToFileUri(m){return m.scheme===k.vscodeFileResource?m.with({scheme:k.file,authority:m.authority!==d.a?m.authority:null,query:null,fragment:null}):m}b(m,E){return A.URI.isUri(m)?m:A.URI.parse(E.toUrl(m))}}e.$Zg=new d;var g;(function(l){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(m.get("3"));const E="vscode-coi";function f(P){let p;typeof P=="string"?p=new URL(P).searchParams:P instanceof URL?p=P.searchParams:A.URI.isUri(P)&&(p=new URL(P.toString(!0)).searchParams);const c=p?.get(E);if(c)return m.get(c)}l.getHeadersFromQuery=f;function w(P,p,c){if(!globalThis.crossOriginIsolated)return;const h=p&&c?"3":c?"2":"1";P instanceof URLSearchParams?P.set(E,h):P[E]=h}l.addSearchParam=w})(g||(e.COI=g={}))}),define(he[140],ue([0,1,128,22,5,12,9]),function(ae,e,R,a,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CE=$,e.$DE=d,C=Oe(C);class k{constructor(l,m,E){this.id=l,this.dependencies=m,this.callback=E}}class O{static{this.INSTANCE=new O}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(l,m,E)=>{typeof l!="string"&&(E=m,m=l,l=null),(typeof m!="object"||!Array.isArray(m))&&(E=m,m=null),this.c.push(new k(l,m,E))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){if(l.startsWith(window.location.origin)||l.startsWith("vscode-file://vscode-app"))return l;throw new Error(`[trusted_script_src] Invalid script url: ${l}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){return l}})))}async load(l){this.g();const m=await(this.a?this.i(l):this.b?this.h(l):this.j(l));if(!m)throw new Error(`Did not receive a define call from script ${l}`);if(Array.isArray(m.dependencies)&&m.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${l}. The dependencies are: ${m.dependencies.join(", ")}`);return typeof m.callback=="function"?m.callback([]):m.callback}h(l){return new Promise((m,E)=>{const f=document.createElement("script");f.setAttribute("async","async"),f.setAttribute("type","text/javascript");const w=()=>{f.removeEventListener("load",P),f.removeEventListener("error",p)},P=c=>{w(),m(this.c.pop())},p=c=>{w(),E(c)};f.addEventListener("load",P),f.addEventListener("error",p),this.f&&(l=this.f.createScriptURL(l)),f.setAttribute("src",l),window.document.getElementsByTagName("head")[0].appendChild(f)})}i(l){return new Promise((m,E)=>{try{this.f&&(l=this.f.createScriptURL(l)),importScripts(l),m(this.c.pop())}catch(f){E(f)}})}async j(l){try{const m=globalThis._VSCODE_NODE_MODULES.fs,E=globalThis._VSCODE_NODE_MODULES.vm,f=globalThis._VSCODE_NODE_MODULES.module,w=T.URI.parse(l).fsPath,P=m.readFileSync(w).toString(),p=f.wrap(P.replace(/^#!.*/,""));return new E.Script(p).runInThisContext().apply(),this.c.pop()}catch(m){throw m}}}const b=new Map;let I={};typeof globalThis.require=="object"&&(I=globalThis.require.paths??{});async function $(g,l,m){if(R.$R){m===void 0&&(m=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),I[g]&&(g=I[g]);const E=l?`${g}/${l}`:g;if(b.has(E))return b.get(E);let f;if(/^\w[\w\d+.-]*:\/\//.test(E))f=E;else{const c=`${m&&!C.$p?a.$Wg:a.$Vg}/${E}`;f=a.$Zg.asBrowserUri(c).toString(!0)}const w=O.INSTANCE.load(f);return b.set(E,w),w}else return await new Promise((E,f)=>{ae([g],E,f)}).then(Oe)}function d(g,l){(0,A.$og)(R.$R);const f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit&&!C.$p,w=`${g}/${l}`,p=`${f?a.$Wg:a.$Vg}/${w}`;return a.$Zg.asBrowserUri(p).toString(!0)}}),define(he[20],ue([0,1,39,41,22,13,5,26,9]),function(ae,e,R,a,C,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=b,e.$ph=$,e.$qh=g,a=Oe(a),A=Oe(A);function b(l){return(0,O.$wc)(l,!0)}class I{constructor(m){this.a=m}compare(m,E,f=!1){return m===E?0:(0,k.$yf)(this.getComparisonKey(m,f),this.getComparisonKey(E,f))}isEqual(m,E,f=!1){return m===E?!0:!m||!E?!1:this.getComparisonKey(m,f)===this.getComparisonKey(E,f)}getComparisonKey(m,E=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,E,f=!1){if(m.scheme===E.scheme){if(m.scheme===C.Schemas.file)return a.$Eg(b(m),b(E),this.a(m))&&m.query===E.query&&(f||m.fragment===E.fragment);if((0,e.$lh)(m.authority,E.authority))return a.$Eg(m.path,E.path,this.a(m),"/")&&m.query===E.query&&(f||m.fragment===E.fragment)}return!1}joinPath(m,...E){return O.URI.joinPath(m,...E)}basenameOrAuthority(m){return(0,e.$dh)(m)||m.authority}basename(m){return A.$gc.basename(m.path)}extname(m){return A.$gc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let E;return m.scheme===C.Schemas.file?E=O.URI.file(A.$mc(b(m))).path:(E=A.$gc.dirname(m.path),m.authority&&E.length&&E.charCodeAt(0)!==R.CharCode.Slash&&(console.error(`dirname("${m.toString})) resulted in a relative path`),E="/")),m.with({path:E})}normalizePath(m){if(!m.path.length)return m;let E;return m.scheme===C.Schemas.file?E=O.URI.file(A.$hc(b(m))).path:E=A.$gc.normalize(m.path),m.with({path:E})}relativePath(m,E){if(m.scheme!==E.scheme||!(0,e.$lh)(m.authority,E.authority))return;if(m.scheme===C.Schemas.file){const P=A.$lc(b(m),b(E));return T.$j?a.$yg(P):P}let f=m.path||"/";const w=E.path||"/";if(this.a(m)){let P=0;for(const p=Math.min(f.length,w.length);P<p&&!(f.charCodeAt(P)!==w.charCodeAt(P)&&f.charAt(P).toLowerCase()!==w.charAt(P).toLowerCase());P++);f=w.substr(0,P)+f.substr(P)}return A.$gc.relative(f,w)}resolvePath(m,E){if(m.scheme===C.Schemas.file){const f=O.URI.file(A.$kc(b(m),E));return m.with({authority:f.authority,path:f.path})}return E=a.$zg(E),m.with({path:A.$gc.resolve(m.path,E)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,E){return m===E||m!==void 0&&E!==void 0&&(0,k.$Ff)(m,E)}hasTrailingPathSeparator(m,E=A.sep){if(m.scheme===C.Schemas.file){const f=b(m);return f.length>a.$Ag(f).length&&f[f.length-1]===E}else{const f=m.path;return f.length>1&&f.charCodeAt(f.length-1)===R.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,E=A.sep){return(0,e.$mh)(m,E)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,E=A.sep){let f=!1;if(m.scheme===C.Schemas.file){const w=b(m);f=w!==void 0&&w.length===a.$Ag(w).length&&w[w.length-1]===E}else{E="/";const w=m.path;f=w.length===1&&w.charCodeAt(w.length-1)===R.CharCode.Slash}return!f&&!(0,e.$mh)(m,E)?m.with({path:m.path+"/"}):m}}e.$8g=I,e.$9g=new I(()=>!1),e.$0g=new I(l=>l.scheme===C.Schemas.file?!T.$l:!0),e.$$g=new I(l=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function $(l,m){const E=[];for(let f=0;f<l.length;f++){const w=m(l[f]);l.some((P,p)=>p===f?!1:(0,e.$ah)(w,m(P)))||E.push(l[f])}return E}var d;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function m(E){const f=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(p=>{const[c,h]=p.split(":");c&&h&&f.set(c,h)});const P=E.path.substring(0,E.path.indexOf(";"));return P&&f.set(l.META_DATA_MIME,P),f}l.parseMetaData=m})(d||(e.DataUri=d={}));function g(l,m,E){if(m){let f=l.path;return f&&f[0]!==A.$gc.sep&&(f=A.$gc.sep+f),l.with({scheme:E,authority:m,path:f})}return l.with({scheme:E})}}),define(he[6],ue([0,1,25,8,3,2,20,5,137,53]),function(ae,e,R,a,C,A,T,k,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=I,e.$sh=$,e.$th=d,e.$uh=g,e.$vh=l,e.$wh=m,e.$xh=E,e.$yh=f,e.$Gh=r,e.$Hh=o,e.$Ih=u,e.$Jh=y,e.$Kh=N,e.$Zh=z,e.$8h=j;function I(G){return!!G&&typeof G.then=="function"}function $(G){const J=new R.$we,ie=G(J.token),ce=new Promise((ge,pe)=>{const Ee=J.token.onCancellationRequested(()=>{Ee.dispose(),pe(new a.$4)});Promise.resolve(ie).then(Pe=>{Ee.dispose(),J.dispose(),ge(Pe)},Pe=>{Ee.dispose(),J.dispose(),pe(Pe)})});return new class{cancel(){J.cancel(),J.dispose()}then(ge,pe){return ce.then(ge,pe)}catch(ge){return this.then(void 0,ge)}finally(ge){return ce.finally(ge)}}}function d(G,J,ie){return new Promise((ce,ge)=>{const pe=J.onCancellationRequested(()=>{pe.dispose(),ce(ie)});G.then(ce,ge).finally(()=>pe.dispose())})}function g(G,J){return new Promise((ie,ce)=>{const ge=J.onCancellationRequested(()=>{ge.dispose(),ce(new a.$4)});G.then(ie,ce).finally(()=>ge.dispose())})}async function l(G){let J=-1;const ie=G.map((ce,ge)=>ce.then(pe=>(J=ge,pe)));try{return await Promise.race(ie)}finally{G.forEach((ce,ge)=>{ge!==J&&ce.cancel()})}}function m(G,J,ie){let ce;const ge=setTimeout(()=>{ce?.(void 0),ie?.()},J);return Promise.race([G.finally(()=>clearTimeout(ge)),new Promise(pe=>ce=pe)])}function E(G){return new Promise((J,ie)=>{const ce=G();I(ce)?ce.then(J,ie):J(ce)})}function f(){let G,J;return{promise:new Promise((ce,ge)=>{G=ce,J=ge}),resolve:G,reject:J}}class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const ie=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(ie,ie).then(ce)})}return new Promise((ie,ce)=>{this.b.then(ie,ce)})}return this.a=J(),new Promise((ie,ce)=>{this.a.then(ge=>{this.a=null,ie(ge)},ge=>{this.a=null,ce(ge)})})}dispose(){this.f=!0}}e.$zh=w;class P{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$Ah=P;class p{constructor(){this.a=new Map}queue(J,ie){const ge=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(J)===ge&&this.a.delete(J)});return this.a.set(J,ge),ge}}e.$Bh=p;const c=(G,J)=>{let ie=!0;const ce=setTimeout(()=>{ie=!1,J()},G);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(ce),ie=!1}}},h=G=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,G())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class i{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,ie=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((ge,pe)=>{this.d=ge,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const ge=this.g;return this.g=null,ge()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=ie===O.$ge?h(ce):c(ie,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new a.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=i;class n{constructor(J){this.a=new i(J),this.b=new w}trigger(J,ie){return this.a.trigger(()=>this.b.queue(J),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=n;class t{constructor(){this.a=!1,this.b=new Promise((J,ie)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=t;class s extends t{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$Fh=s;function r(G,J){return J?new Promise((ie,ce)=>{const ge=setTimeout(()=>{pe.dispose(),ie()},G),pe=J.onCancellationRequested(()=>{clearTimeout(ge),pe.dispose(),ce(new a.$4)})}):$(ie=>r(G,ie))}function o(G,J=0,ie){const ce=setTimeout(()=>{G(),ie&&ge.dispose()},J),ge=(0,A.$Sc)(()=>{clearTimeout(ce),ie?.deleteAndLeak(ge)});return ie?.add(ge),ge}function u(G){const J=[];let ie=0;const ce=G.length;function ge(){return ie<ce?G[ie++]():null}function pe(Ee){Ee!=null&&J.push(Ee);const Pe=ge();return Pe?Pe.then(pe):Promise.resolve(J)}return Promise.resolve(null).then(pe)}function y(G,J=ce=>!!ce,ie=null){let ce=0;const ge=G.length,pe=()=>{if(ce>=ge)return Promise.resolve(ie);const Ee=G[ce++];return Promise.resolve(Ee()).then(be=>J(be)?Promise.resolve(be):pe())};return pe()}function N(G,J=ce=>!!ce,ie=null){if(G.length===0)return Promise.resolve(ie);let ce=G.length;const ge=()=>{ce=-1;for(const pe of G)pe.cancel?.()};return new Promise((pe,Ee)=>{for(const Pe of G)Pe.then(be=>{--ce>=0&&J(be)?(ge(),pe(be)):ce===0&&pe(ie)}).catch(be=>{--ce>=0&&(ge(),Ee(be))})})}class S{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new C.$le}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ie,ce)=>{this.g.push({factory:J,c:ie,e:ce}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const ie=J.factory();ie.then(J.c,J.e),ie.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=S;class v extends S{constructor(){super(1)}}e.$Mh=v;class L{constructor(){this.a=new _,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$Nh=L;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new ee;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,ie=T.$9g){const ce=ie.getComparisonKey(J);return this.a.get(ce)?.size??0}queueFor(J,ie,ce=T.$9g){const ge=ce.getComparisonKey(J);let pe=this.a.get(ge);if(!pe){pe=new v;const Ee=this.f++,Pe=C.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose(Ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$4c),this.d.set(Ee,Pe),this.a.set(ge,pe)}return pe.queue(ie)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=U;class F{constructor(J,ie){this.b=!1,this.a=-1,typeof J=="function"&&typeof ie=="number"&&this.setIfNotSet(J,ie)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,ie){if(this.b)throw new a.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},ie)}setIfNotSet(J,ie){if(this.b)throw new a.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},ie))}}e.$Ph=F;class M{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,ie,ce=globalThis){if(this.f)throw new a.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ge=ce.setInterval(()=>{J()},ie);this.d=(0,A.$Sc)(()=>{ce.clearInterval(ge),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=M;class K{constructor(J,ie){this.b=-1,this.a=J,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=K;class V{constructor(J,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=J,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=V;class x extends K{constructor(J,ie){super(J,ie),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$Th=x;class H extends A.$Uc{constructor(J,ie){super(),this.g=J,this.h=ie,this.a=[],this.b=this.B(new A.$Vc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of J)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=H,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(G,J)=>{(0,k.$C)(()=>{if(ie)return;const ce=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$Wh=(G,J,ie)=>{const ce=G.requestIdleCallback(J,typeof ie=="number"?{timeout:ie}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,G.cancelIdleCallback(ce))}}},e.$Vh=G=>(0,e.$Wh)(globalThis,G)}();class te{constructor(J,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$Wh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=te;class B extends te{constructor(J){super(globalThis,J)}}e.$Yh=B;async function z(G,J,ie){let ce;for(let ge=0;ge<ie;ge++)try{return await G()}catch(pe){ce=pe,await r(J)}throw ce}class _{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,ie,ce){return this.a={taskId:J,cancel:()=>ce?.(),promise:ie},ie.then(()=>this.d(J),()=>this.d(J)),ie}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:ie,resolve:ce,reject:ge}=f();this.b={run:J,promise:ie,promiseResolve:ce,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=_;class ne{constructor(J,ie=()=>Date.now()){this.d=J,this.f=ie,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$2h=ne;var le;(function(G){G[G.Resolved=0]="Resolved",G[G.Rejected=1]="Rejected"})(le||(le={}));class ee{get isRejected(){return this.d?.outcome===le.Rejected}get isResolved(){return this.d?.outcome===le.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===le.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((J,ie)=>{this.a=J,this.b=ie})}complete(J){return new Promise(ie=>{this.a(J),this.d={outcome:le.Resolved,value:J},ie()})}error(J){return new Promise(ie=>{this.b(J),this.d={outcome:le.Rejected,value:J},ie()})}cancel(){return this.error(new a.$4)}}e.$3h=ee;var Q;(function(G){async function J(ce){let ge;const pe=await Promise.all(ce.map(Ee=>Ee.then(Pe=>Pe,Pe=>{ge||(ge=Pe)})));if(typeof ge<"u")throw ge;return pe}G.settled=J;function ie(ce){return new Promise(async(ge,pe)=>{try{await ce(ge,pe)}catch(Ee){pe(Ee)}})}G.withAsyncBody=ie})(Q||(e.Promises=Q={}));class X{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new a.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=X;class q{constructor(J){this.b=J,this.a=new b.$T(()=>new X(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=q;var D;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(D||(D={}));class Y{static fromArray(J){return new Y(ie=>{ie.emitMany(J)})}static fromPromise(J){return new Y(async ie=>{ie.emitMany(await J)})}static fromPromises(J){return new Y(async ie=>{await Promise.all(J.map(async ce=>ie.emitOne(await ce)))})}static merge(J){return new Y(async ie=>{await Promise.all(J.map(async ce=>{for await(const ge of ce)ie.emitOne(ge)}))})}static{this.EMPTY=Y.fromArray([])}constructor(J,ie){this.a=D.Initial,this.b=[],this.d=null,this.f=ie,this.g=new C.$le,queueMicrotask(async()=>{const ce={emitOne:ge=>this.h(ge),emitMany:ge=>this.j(ge),reject:ge=>this.l(ge)};try{await Promise.resolve(J(ce)),this.k()}catch(ge){this.l(ge)}finally{ce.emitOne=void 0,ce.emitMany=void 0,ce.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===D.DoneError)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===D.DoneOK)return{done:!0,value:void 0};await C.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(J,ie){return new Y(async ce=>{for await(const ge of J)ce.emitOne(ie(ge))})}map(J){return Y.map(this,J)}static filter(J,ie){return new Y(async ce=>{for await(const ge of J)ie(ge)&&ce.emitOne(ge)})}filter(J){return Y.filter(this,J)}static coalesce(J){return Y.filter(J,ie=>!!ie)}coalesce(){return Y.coalesce(this)}static async toPromise(J){const ie=[];for await(const ce of J)ie.push(ce);return ie}toPromise(){return Y.toPromise(this)}h(J){this.a===D.Initial&&(this.b.push(J),this.g.fire())}j(J){this.a===D.Initial&&(this.b=this.b.concat(J),this.g.fire())}k(){this.a===D.Initial&&(this.a=D.DoneOK,this.g.fire())}l(J){this.a===D.Initial&&(this.a=D.DoneError,this.d=J,this.g.fire())}}e.$6h=Y;class oe extends Y{constructor(J,ie){super(ie),this.m=J}cancel(){this.m.cancel()}}e.$7h=oe;function j(G){const J=new R.$we,ie=G(J.token);return new oe(J,async ce=>{const ge=J.token.onCancellationRequested(()=>{ge.dispose(),J.dispose(),ce.reject(new a.$4)});try{for await(const pe of ie){if(J.token.isCancellationRequested)return;ce.emitOne(pe)}ge.dispose(),J.dispose()}catch(pe){ge.dispose(),J.dispose(),ce.reject(pe)}})}class W{constructor(J){this.a=new ee,this.b=new Y(ge=>{if(ie){ge.reject(ie);return}return ce&&ge.emitMany(ce),this.d=pe=>ge.reject(pe),this.f=pe=>ge.emitOne(pe),this.a.p},J);let ie,ce;this.f=ge=>{ce||(ce=[]),ce.push(ge)},this.d=ge=>{ie||(ie=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$9h=W}),define(he[93],ue([0,1,17,6,39,41,31,13,5,26]),function(ae,e,R,a,C,A,T,k,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$vk=I,e.$yk=m,e.$zk=L,e.$Ak=U,e.$Bk=F,e.$Ck=M,e.$Dk=K,e.$Ek=te;function I(){return Object.create(null)}e.$wk="**",e.$xk="/";const $="[/\\\\]",d="[^/\\\\]",g=/\//g;function l(B,z){switch(B){case 0:return"";case 1:return`${d}*?`;default:return`(?:${$}|${d}+${$}${z?`|${$}${d}+`:""})*?`}}function m(B,z){if(!B)return[];const _=[];let ne=!1,le=!1,ee="";for(const Q of B){switch(Q){case z:if(!ne&&!le){_.push(ee),ee="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":le=!0;break;case"]":le=!1;break}ee+=Q}return ee&&_.push(ee),_}function E(B){if(!B)return"";let z="";const _=m(B,e.$xk);if(_.every(ne=>ne===e.$wk))z=".*";else{let ne=!1;_.forEach((le,ee)=>{if(le===e.$wk){if(ne)return;z+=l(2,ee===_.length-1)}else{let Q=!1,X="",q=!1,D="";for(const Y of le){if(Y!=="}"&&Q){X+=Y;continue}if(q&&(Y!=="]"||!D)){let oe;Y==="-"?oe=Y:(Y==="^"||Y==="!")&&!D?oe="^":Y===e.$xk?oe="":oe=(0,b.$hf)(Y),D+=oe;continue}switch(Y){case"{":Q=!0;continue;case"[":q=!0;continue;case"}":{const j=`(?:${m(X,",").map(W=>E(W)).join("|")})`;z+=j,Q=!1,X="";break}case"]":{z+="["+D+"]",q=!1,D="";break}case"?":z+=d;continue;case"*":z+=l(1);continue;default:z+=(0,b.$hf)(Y)}}ee<_.length-1&&(_[ee+1]!==e.$wk||ee+2<_.length)&&(z+=$)}ne=le===e.$wk})}return z}const f=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new T.$Dc(1e4),n=function(){return!1},t=function(){return null};function s(B,z){if(!B)return t;let _;typeof B!="string"?_=B.pattern:_=B,_=_.trim();const ne=`${_}_${!!z.trimForExclusions}`;let le=i.get(ne);if(le)return r(le,B);let ee;return f.test(_)?le=u(_.substr(4),_):(ee=w.exec(o(_,z)))?le=y(ee[1],_):(z.trimForExclusions?p:P).test(_)?le=N(_,z):(ee=c.exec(o(_,z)))?le=S(ee[1].substr(1),_,!0):(ee=h.exec(o(_,z)))?le=S(ee[1],_,!1):le=v(_),i.set(ne,le),r(le,B)}function r(B,z){if(typeof z=="string")return B;const _=function(ne,le){return(0,A.$Eg)(ne,z.base,!O.$l)?B((0,b.$mf)(ne.substr(z.base.length),k.sep),le):null};return _.allBasenames=B.allBasenames,_.allPaths=B.allPaths,_.basenames=B.basenames,_.patterns=B.patterns,_}function o(B,z){return z.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function u(B,z){return function(_,ne){return typeof _=="string"&&_.endsWith(B)?z:null}}function y(B,z){const _=`/${B}`,ne=`\\${B}`,le=function(Q,X){return typeof Q!="string"?null:X?X===B?z:null:Q===B||Q.endsWith(_)||Q.endsWith(ne)?z:null},ee=[B];return le.basenames=ee,le.patterns=[z],le.allBasenames=ee,le}function N(B,z){const _=H(B.slice(1,-1).split(",").map(X=>s(X,z)).filter(X=>X!==t),B),ne=_.length;if(!ne)return t;if(ne===1)return _[0];const le=function(X,q){for(let D=0,Y=_.length;D<Y;D++)if(_[D](X,q))return B;return null},ee=_.find(X=>!!X.allBasenames);ee&&(le.allBasenames=ee.allBasenames);const Q=_.reduce((X,q)=>q.allPaths?X.concat(q.allPaths):X,[]);return Q.length&&(le.allPaths=Q),le}function S(B,z,_){const ne=k.sep===k.$gc.sep,le=ne?B:B.replace(g,k.sep),ee=k.sep+le,Q=k.$gc.sep+B;let X;return _?X=function(q,D){return typeof q=="string"&&(q===le||q.endsWith(ee)||!ne&&(q===B||q.endsWith(Q)))?z:null}:X=function(q,D){return typeof q=="string"&&(q===le||!ne&&q===B)?z:null},X.allPaths=[(_?"*/":"./")+B],X}function v(B){try{const z=new RegExp(`^${E(B)}$`);return function(_){return z.lastIndex=0,typeof _=="string"&&z.test(_)?B:null}}catch{return t}}function L(B,z,_){return!B||typeof z!="string"?!1:U(B)(z,void 0,_)}function U(B,z={}){if(!B)return n;if(typeof B=="string"||F(B)){const _=s(B,z);if(_===t)return n;const ne=function(le,ee){return!!_(le,ee)};return _.allBasenames&&(ne.allBasenames=_.allBasenames),_.allPaths&&(ne.allPaths=_.allPaths),ne}return V(B,z)}function F(B){const z=B;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}function M(B){return B.allBasenames||[]}function K(B){return B.allPaths||[]}function V(B,z){const _=H(Object.getOwnPropertyNames(B).map(X=>x(X,B[X],z)).filter(X=>X!==t)),ne=_.length;if(!ne)return t;if(!_.some(X=>!!X.requiresSiblings)){if(ne===1)return _[0];const X=function(Y,oe){let j;for(let W=0,G=_.length;W<G;W++){const J=_[W](Y,oe);if(typeof J=="string")return J;(0,a.$rh)(J)&&(j||(j=[]),j.push(J))}return j?(async()=>{for(const W of j){const G=await W;if(typeof G=="string")return G}return null})():null},q=_.find(Y=>!!Y.allBasenames);q&&(X.allBasenames=q.allBasenames);const D=_.reduce((Y,oe)=>oe.allPaths?Y.concat(oe.allPaths):Y,[]);return D.length&&(X.allPaths=D),X}const le=function(X,q,D){let Y,oe;for(let j=0,W=_.length;j<W;j++){const G=_[j];G.requiresSiblings&&D&&(q||(q=(0,k.$nc)(X)),Y||(Y=q.substr(0,q.length-(0,k.$oc)(X).length)));const J=G(X,q,Y,D);if(typeof J=="string")return J;(0,a.$rh)(J)&&(oe||(oe=[]),oe.push(J))}return oe?(async()=>{for(const j of oe){const W=await j;if(typeof W=="string")return W}return null})():null},ee=_.find(X=>!!X.allBasenames);ee&&(le.allBasenames=ee.allBasenames);const Q=_.reduce((X,q)=>q.allPaths?X.concat(q.allPaths):X,[]);return Q.length&&(le.allPaths=Q),le}function x(B,z,_){if(z===!1)return t;const ne=s(B,_);if(ne===t)return t;if(typeof z=="boolean")return ne;if(z){const le=z.when;if(typeof le=="string"){const ee=(Q,X,q,D)=>{if(!D||!ne(Q,X))return null;const Y=le.replace("$(basename)",()=>q),oe=D(Y);return(0,a.$rh)(oe)?oe.then(j=>j?B:null):oe?B:null};return ee.requiresSiblings=!0,ee}}return ne}function H(B,z){const _=B.filter(X=>!!X.basenames);if(_.length<2)return B;const ne=_.reduce((X,q)=>{const D=q.basenames;return D?X.concat(D):X},[]);let le;if(z){le=[];for(let X=0,q=ne.length;X<q;X++)le.push(z)}else le=_.reduce((X,q)=>{const D=q.patterns;return D?X.concat(D):X},[]);const ee=function(X,q){if(typeof X!="string")return null;if(!q){let Y;for(Y=X.length;Y>0;Y--){const oe=X.charCodeAt(Y-1);if(oe===C.CharCode.Slash||oe===C.CharCode.Backslash)break}q=X.substr(Y)}const D=ne.indexOf(q);return D!==-1?le[D]:null};ee.basenames=ne,ee.patterns=le,ee.allBasenames=ne;const Q=B.filter(X=>!X.basenames);return Q.push(ee),Q}function te(B,z){return(0,R.$tb)(B,z,(_,ne)=>typeof _=="string"&&typeof ne=="string"?_===ne:typeof _!="string"&&typeof ne!="string"?_.base===ne.base&&_.pattern===ne.pattern:!1)}}),define(he[94],ue([0,1,14,65,9]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=void 0,e.$On=O,e.$Pn=I,e.$Qn=$;function A(d){return d.toJSON()}class T{constructor(g){this.a=g}transformIncoming(g){const l=this.a.transformIncoming(g);return l===g?g:A(C.URI.from(l))}transformOutgoing(g){const l=this.a.transformOutgoing(g);return l===g?g:A(C.URI.from(l))}transformOutgoingURI(g){const l=this.a.transformOutgoing(g);return l===g?g:C.URI.from(l)}transformOutgoingScheme(g){return this.a.transformOutgoingScheme(g)}}e.$Mn=T,e.$Nn=new class{transformIncoming(d){return d}transformOutgoing(d){return d}transformOutgoingURI(d){return d}transformOutgoingScheme(d){return d}};function k(d,g,l){if(!d||l>200)return null;if(typeof d=="object"){if(d instanceof C.URI)return g.transformOutgoing(d);for(const m in d)if(Object.hasOwnProperty.call(d,m)){const E=k(d[m],g,l+1);E!==null&&(d[m]=E)}}return null}function O(d,g){const l=k(d,g,0);return l===null?d:l}function b(d,g,l,m){if(!d||m>200)return null;if(typeof d=="object"){if(d.$mid===a.MarshalledId.Uri)return l?C.URI.revive(g.transformIncoming(d)):g.transformIncoming(d);if(d instanceof R.$Ne)return null;for(const E in d)if(Object.hasOwnProperty.call(d,E)){const f=b(d[E],g,l,m+1);f!==null&&(d[E]=f)}}return null}function I(d,g){const l=b(d,g,!1,0);return l===null?d:l}function $(d,g){const l=b(d,g,!0,0);return l===null?d:l}}),define(he[32],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=a;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function a(C){return R.test(C)}e.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(k){for(let O=0;O<k.length;O++)k[O]=Math.floor(Math.random()*256);return k};const A=new Uint8Array(16),T=[];for(let k=0;k<256;k++)T.push(k.toString(16).padStart(2,"0"));return function(){C(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let O=0,b="";return b+=T[A[O++]],b+=T[A[O++]],b+=T[A[O++]],b+=T[A[O++]],b+="-",b+=T[A[O++]],b+=T[A[O++]],b+="-",b+=T[A[O++]],b+=T[A[O++]],b+="-",b+=T[A[O++]],b+=T[A[O++]],b+="-",b+=T[A[O++]],b+=T[A[O++]],b+=T[A[O++]],b+=T[A[O++]],b+=T[A[O++]],b+=T[A[O++]],b}}()}),define(he[141],ue([0,1,38]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=A;const a=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function C(T){const k=T.replace(/\-/g,":").toLowerCase();return!a.has(k)}function A(){const T=(0,R.networkInterfaces)();for(const k in T){const O=T[k];if(O){for(const{mac:b}of O)if(C(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(he[142],ue([0,1,38,51,32,141,5]),function(ae,e,R,a,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=void 0,e.$Tn=O,e.$Un=$,e.$Vn=d,C=Oe(C),e.$Sn=new class{c(g){return this.a||(this.a=a.$Li.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(g)}value(){if(this.b===void 0){let g=0,l=0;const m=(0,R.networkInterfaces)();for(const E in m){const f=m[E];if(f)for(const{mac:w,internal:P}of f)P||(l+=1,this.c(w.toUpperCase())&&(g+=1))}this.b=l>0?g/l:0}return this.b}};let k;async function O(g){return k||(k=(async()=>await b(g)||C.$2g())()),k}async function b(g){try{const l=await new Promise((E,f)=>{ae(["crypto"],E,f)}).then(Oe),m=(0,A.$Rn)();return l.createHash("sha256").update(m,"utf8").digest("hex")}catch(l){g(l);return}}const I="Software\\Microsoft\\SQMClient";async function $(g){if(T.$j){const l=await new Promise((m,E)=>{ae(["@vscode/windows-registry"],m,E)}).then(Oe);try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",I,"MachineId")||""}catch(m){return g(m),""}}return""}async function d(g){try{return await(await new Promise((E,f)=>{ae(["@vscode/deviceid"],E,f)}).then(Oe)).getDeviceId()}catch(l){return g(l),""}}}),define(he[143],ue([0,1,240,14]),function(ae,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QX=void 0;class C extends R.Transform{constructor(T){if(super(),typeof T=="number")this.b=T,this.c=1;else{const k=Buffer.isBuffer(T)?T:Buffer.from(T);this.b=k.length===1?k[0]:k,this.c=k.length}}_transform(T,k,O){this.a?this.a=Buffer.concat([this.a,T]):this.a=T;let b=0;for(;b<this.a.length;){const I=typeof this.b=="number"?this.a.indexOf(this.b,b):(0,a.$Oe)(this.a,this.b,b);if(I===-1)break;this.push(this.a.slice(b,I+this.c)),b=I+this.c}this.a=b===this.a.length?void 0:this.a.slice(b),O()}_flush(T){this.a&&this.push(this.a),T()}}e.$QX=C}),define(he[144],ue([0,1,33,13,37]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RX=b,e.$SX=I;const A="XDG_SESSION_TYPE",T="WAYLAND_DISPLAY",k="XDG_RUNTIME_DIR";var O;(function($){$.Wayland="wayland",$.XWayland="xwayland",$.X11="x11",$.Unknown="unknown"})(O||(O={}));async function b($){const d=C.env[A];if(d)return d===O.Wayland||d===O.X11?d:O.Unknown;if(C.env[T]){const l=C.env[k];if(l){const m=(0,a.$jc)(l,"wayland-0");try{return await R.promises.access(m,R.constants.R_OK),O.Wayland}catch(E){return $(E),O.Unknown}}else return O.Unknown}else return O.X11}function I($,d){if(d)switch(d){case"auto":return $;case"x11":return $===O.Wayland?O.XWayland:O.X11;case"wayland":return O.Wayland;default:return O.Unknown}else return $===O.Wayland?O.XWayland:O.X11}}),define(he[145],ue([0,1,33,241,5]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=A,C=Oe(C);async function A(T){if(C.$k||C.$j)return;let k;for(const O of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{k=await R.promises.open(O,R.constants.R_OK);break}catch{}if(!k){T("Unable to retrieve release information from known identifier paths.");return}try{const O=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),b={id:"unknown"};for await(const I of(0,a.createInterface)({input:k.createReadStream(),crlfDelay:1/0})){if(!I.includes("="))continue;const $=I.split("=")[0].toUpperCase().trim();if(O.has($)){const d=I.split("=")[1].replace(/"/g,"").toLowerCase().trim();$==="ID"||$==="DISTRIB_ID"?b.id=d:$==="ID_LIKE"?b.id_like=d:($==="VERSION_ID"||$==="DISTRIB_RELEASE")&&(b.version_id=d)}}return b}catch(O){T(O)}}}),define(he[30],ue([0,1,33,38,242,6,41,90,13,5,20,9]),function(ae,e,R,a,C,A,T,k,O,b,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=E,e.readdirSync=P,e.whenDeleted=h,e.configureFlushOnWrite=r,e.writeFileSync=u,R=Oe(R);var d;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(d||(e.RimRafMode=d={}));async function g(V,x=d.UNLINK,H){if((0,T.$Ig)(V))throw new Error("rimraf - will refuse to recursively delete root");return x===d.UNLINK?m(V):l(V,H)}async function l(V,x=(0,T.$Ng)((0,a.tmpdir)())){try{try{await R.promises.rename(V,x)}catch(H){return H.code==="ENOENT"?void 0:m(V)}m(x).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function m(V){return R.promises.rm(V,{recursive:!0,force:!0,maxRetries:3})}function E(V){if((0,T.$Ig)(V))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}async function f(V,x){return p(await(x?w(V):R.promises.readdir(V)))}async function w(V){try{return await R.promises.readdir(V,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const x=[],H=await f(V);for(const te of H){let B=!1,z=!1,_=!1;try{const ne=await R.promises.lstat((0,O.$jc)(V,te));B=ne.isFile(),z=ne.isDirectory(),_=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}x.push({name:te,isFile:()=>B,isDirectory:()=>z,isSymbolicLink:()=>_})}return x}function P(V){return p(R.readdirSync(V))}function p(V){return V.map(x=>typeof x=="string"?b.$k?(0,k.$nm)(x):x:(x.name=b.$k?(0,k.$nm)(x.name):x.name,x))}async function c(V){const x=await f(V),H=[];for(const te of x)await i.existsDirectory((0,O.$jc)(V,te))&&H.push(te);return H}function h(V,x=1e3){return new Promise(H=>{let te=!1;const B=setInterval(()=>{te||(te=!0,R.access(V,z=>{te=!1,z&&(clearInterval(B),H(void 0))}))},x)})}var i;(function(V){async function x(B){let z;try{if(z=await R.promises.lstat(B),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await R.promises.stat(B),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(b.$j&&_.code==="EACCES")try{return{stat:await R.promises.stat(await R.promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw ne}throw _}}V.stat=x;async function H(B){try{const{stat:z,symbolicLink:_}=await V.stat(B);return z.isFile()&&_?.dangling!==!0}catch{}return!1}V.existsFile=H;async function te(B){try{const{stat:z,symbolicLink:_}=await V.stat(B);return z.isDirectory()&&_?.dangling!==!0}catch{}return!1}V.existsDirectory=te})(i||(e.SymlinkSupport=i={}));const n=new A.$Oh;function t(V,x,H){return n.queueFor($.URI.file(V),()=>{const te=y(H);return new Promise((B,z)=>o(V,x,te,_=>_?z(_):B()))},I.$0g)}let s=!0;function r(V){s=V}function o(V,x,H,te){if(!s)return R.writeFile(V,x,{mode:H.mode,flag:H.flag},te);R.open(V,H.flag,H.mode,(B,z)=>{if(B)return te(B);R.writeFile(z,x,_=>{if(_)return R.close(z,()=>te(_));R.fdatasync(z,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),r(!1)),R.close(z,le=>te(le))))})})}function u(V,x,H){const te=y(H);if(!s)return R.writeFileSync(V,x,{mode:te.mode,flag:te.flag});const B=R.openSync(V,te.flag,te.mode);try{R.writeFileSync(B,x);try{R.fdatasyncSync(B)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),r(!1)}}finally{R.closeSync(B)}}function y(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function N(V,x,H=6e4){if(V!==x)try{b.$j&&typeof H=="number"?await S(V,x,Date.now(),H):await R.promises.rename(V,x)}catch(te){if(V.toLowerCase()!==x.toLowerCase()&&te.code==="EXDEV"||V.endsWith("."))await v(V,x,{preserveSymlinks:!1}),await g(V,d.MOVE);else throw te}}async function S(V,x,H,te,B=0){try{return await R.promises.rename(V,x)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-H>=te)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${z}`),z;if(B===0){let _=!1;try{const{stat:ne}=await i.stat(x);ne.isFile()||(_=!0)}catch{}if(_)throw z}return await(0,A.$Gh)(Math.min(100,B*10)),S(V,x,H,te,B+1)}}async function v(V,x,H){return U(V,x,{root:{source:V,target:x},options:H,handledSourcePaths:new Set})}const L=511;async function U(V,x,H){if(H.handledSourcePaths.has(V))return;H.handledSourcePaths.add(V);const{stat:te,symbolicLink:B}=await i.stat(V);if(B){if(H.options.preserveSymlinks)try{return await K(V,x,H)}catch{}if(B.dangling)return}return te.isDirectory()?F(V,x,te.mode&L,H):M(V,x,te.mode&L)}async function F(V,x,H,te){await R.promises.mkdir(x,{recursive:!0,mode:H});const B=await f(V);for(const z of B)await U((0,O.$jc)(V,z),(0,O.$jc)(x,z),te)}async function M(V,x,H){await R.promises.copyFile(V,x),await R.promises.chmod(x,H)}async function K(V,x,H){let te=await R.promises.readlink(V);(0,T.$Eg)(te,H.root.source,!b.$l)&&(te=(0,O.$jc)(H.root.target,te.substr(H.root.source.length+1))),await R.promises.symlink(te,x)}e.Promises=new class{get read(){return(V,x,H,te,B)=>new Promise((z,_)=>{R.read(V,x,H,te,B,(ne,le,ee)=>ne?_(ne):z({bytesRead:le,buffer:ee}))})}get write(){return(V,x,H,te,B)=>new Promise((z,_)=>{R.write(V,x,H,te,B,(ne,le,ee)=>ne?_(ne):z({bytesWritten:le,buffer:ee}))})}get fdatasync(){return(0,C.promisify)(R.fdatasync)}get open(){return(0,C.promisify)(R.open)}get close(){return(0,C.promisify)(R.close)}get realpath(){return(0,C.promisify)(R.realpath)}async exists(V){try{return await R.promises.access(V),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return c}get writeFile(){return t}get rm(){return g}get rename(){return N}get copy(){return v}}}),define(he[146],ue([0,1,33,13,5,26,30]),function(ae,e,R,a,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=k,e.$mr=O,e.$nr=b,e.$or=I,R=Oe(R);function k(d){if(C.$l)return d;const g=(0,a.$mc)(d);if(d===g)return d;const l=((0,a.$nc)(d)||d).toLowerCase();try{const E=(0,T.readdirSync)(g).filter(f=>f.toLowerCase()===l);if(E.length===1){const f=k(g);if(f)return(0,a.$jc)(f,E[0])}else if(E.length>1){const f=E.indexOf(l);if(f>=0){const w=k(g);if(w)return(0,a.$jc)(w,E[f])}}}catch{}return null}async function O(d,g){if(C.$l)return d;const l=(0,a.$mc)(d);if(d===l)return d;const m=((0,a.$nc)(d)||d).toLowerCase();try{if(g?.isCancellationRequested)return null;const f=(await T.Promises.readdir(l)).filter(w=>w.toLowerCase()===m);if(f.length===1){const w=await O(l,g);if(w)return(0,a.$jc)(w,f[0])}else if(f.length>1){const w=f.indexOf(m);if(w>=0){const P=await O(l,g);if(P)return(0,a.$jc)(P,f[w])}}}catch{}return null}async function b(d){try{return await T.Promises.realpath(d)}catch{const l=$(d);return await R.promises.access(l,R.constants.R_OK),l}}function I(d){try{return R.realpathSync(d)}catch{const l=$(d);return R.accessSync(l,R.constants.R_OK),l}}function $(d){return(0,A.$nf)((0,a.$hc)(d),a.sep)}}),define(he[147],ue([0,1,67]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=a,e.$6g=A,R=Oe(R);function a(k,O,b,I=1){let $=!1;return new Promise(d=>{const g=setTimeout(()=>{if(!$)return $=!0,d(0)},b);C(k,O,I,l=>{if(!$)return $=!0,clearTimeout(g),d(l)})})}function C(k,O,b,I){if(O===0)return I(0);const $=new R.Socket;$.once("connect",()=>(T($),C(k+b,O-1,b,I))),$.once("data",()=>{}),$.once("error",d=>(T($),d.code!=="ECONNREFUSED"?C(k+b,O-1,b,I):I(k))),$.connect(k,"127.0.0.1")}e.$5g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(k,O,b,I="127.0.0.1"){let $=!1,d,g=1;const l=R.createServer({pauseOnConnect:!0});function m(E,f){$||($=!0,l.removeAllListeners(),l.close(),d&&clearTimeout(d),f(E))}return new Promise(E=>{d=setTimeout(()=>{m(0,E)},b),l.on("listening",()=>{m(k,E)}),l.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&g<O?(k++,g++,l.listen(k,I)):m(0,E)}),l.on("close",()=>{m(0,E)}),l.listen(k,I)})}function T(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(O){console.error(O)}}}),define(he[148],ue([0,1,33,13,5,37,91,12,30]),function(ae,e,R,a,C,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$ym=b,e.$zm=I,a=Oe(a),C=Oe(C),A=Oe(A),k=Oe(k),O=Oe(O),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function b(d=A.env){return d.comspec||"cmd.exe"}function I(d){let g=[],l=!1;const m=function(E){if(l){g.push(E);return}(!d.send(E,w=>{if(w&&console.error(w),l=!1,g.length>0){const P=g.slice(0);g=[],P.forEach(p=>m(p))}})||C.$j)&&(l=!0)};return{send:m}}var $;(function(d){async function g(l,m,E){if(a.$ic(l))return l;if(m===void 0&&(m=A.cwd()),a.$mc(l)!=="."||(E===void 0&&k.$eg(A.env.PATH)&&(E=A.env.PATH.split(a.$tc)),E===void 0||E.length===0))return a.$jc(m,l);async function w(P){if(await O.Promises.exists(P)){let p;try{p=await R.promises.stat(P)}catch(c){c.message.startsWith("EACCES")&&(p=await R.promises.lstat(P))}return p?!p.isDirectory():!1}return!1}for(const P of E){let p;if(a.$ic(P)?p=a.$jc(P,l):p=a.$jc(m,P,l),await w(p))return p;let c=p+".com";if(await w(c)||(c=p+".exe",await w(c)))return c}return a.$jc(m,l)}d.findExecutable=g})($||(e.win32=$={}))}),define(he[149],ue([0,1,68,22]),function(ae,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=C;function C(T){return new Promise((k,O)=>{let b;const I=new Map;function $(g,l,m,E,f){const w=I.get(l);if(g===T||w){const P={name:d(m),cmd:m,pid:g,ppid:l,load:E,mem:f};I.set(g,P),g===T&&(b=P),w&&(w.children||(w.children=[]),w.children.push(P),w.children.length>1&&(w.children=w.children.sort((p,c)=>p.pid-c.pid)))}}function d(g){const l=/--utility-sub-type=network/i,m=/--crashes-directory/i,E=/\\pipe\\winpty-control/i,f=/conhost\.exe.+--headless/i,w=/--type=([a-zA-Z-]+)/;if(m.exec(g))return"electron-crash-reporter";if(E.exec(g))return"winpty-agent";if(f.exec(g))return"conpty-agent";let P=w.exec(g);if(P&&P.length===2)return P[1]==="renderer"?"window":P[1]==="utility"?l.exec(g)?"utility-network-service":"utility-process":P[1]==="extensionHost"?"extension-host":P[1];const p=/[a-zA-Z-]+\.js/g;let c="";do P=p.exec(g),P&&(c+=P+" ");while(P);return c&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron-nodejs (${c})`:g}if(process.platform==="win32"){const g=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,m)=>{ae(["@vscode/windows-process-tree"],l,m)}).then(Oe).then(l=>{l.getProcessList(T,m=>{if(!m){O(new Error(`Root process ${T} not found`));return}l.getProcessCpuUsage(m,E=>{const f=new Map;E.forEach(w=>{const P=g(w.commandLine||"");f.set(w.pid,{name:d(P),cmd:P,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),b=f.get(T),b?(f.forEach(w=>{const P=f.get(w.ppid);P&&(P.children||(P.children=[]),P.children.push(w))}),f.forEach(w=>{w.children&&(w.children=w.children.sort((P,p)=>P.pid-p.pid))}),k(b)):O(new Error(`Root process ${T} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let g=function(){let l=[b];const m=[];for(;l.length;){const f=l.shift();f&&(m.push(f.pid),f.children&&(l=l.concat(f.children)))}let E=JSON.stringify(a.$Zg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);E+=" "+m.join(" "),(0,R.exec)(E,{},(f,w,P)=>{if(f||P)O(f||new Error(P.toString()));else{const p=w.toString().split(`
`);for(let c=0;c<m.length;c++){const h=I.get(m[c]);h.load=parseFloat(p[c])}if(!b){O(new Error(`Root process ${T} not found`));return}k(b)}})};(0,R.exec)("which ps",{},(l,m,E)=>{if(l||E)if(process.platform!=="linux")O(l||new Error(E.toString()));else{const f=JSON.stringify(a.$Zg.asFileUri("vs/base/node/ps.sh").fsPath);(0,R.exec)(f,{},(w,P,p)=>{w||p?O(w||new Error(p.toString())):(A(P,$),g())})}else{const f=m.toString().trim();(0,R.exec)(`${f} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(P,p,c)=>{P||c&&!c.includes("screen size is bogus")?O(P||new Error(c.toString())):(A(p,$),process.platform==="linux"?g():b?k(b):O(new Error(`Root process ${T} not found`)))})}})}})}function A(T,k){const O=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=T.toString().split(`
`);for(const I of b){const $=O.exec(I.trim());$&&$.length===6&&k(parseInt($[1]),parseInt($[2]),$[5],parseFloat($[3]),parseFloat($[4]))}}});var ve=this&&this.__decorate||function(ae,e,R,a){var C=arguments.length,A=C<3?e:a===null?a=Object.getOwnPropertyDescriptor(e,R):a,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ae,e,R,a);else for(var k=ae.length-1;k>=0;k--)(T=ae[k])&&(A=(C<3?T(A):C>3?T(e,R,A):T(e,R))||A);return C>3&&A&&Object.defineProperty(e,R,A),A};define(he[42],ue([0,1,17,6,14,25,87,8,3,2,66,26,12]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.ProxyChannel=e.$ni=e.$ki=e.$ji=e.$ii=e.RequestInitiator=e.$hi=e.$ei=e.$di=void 0,e.$fi=r,e.$gi=o,e.$li=L,e.$mi=U,$=Oe($);var g;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(g||(g={}));function l(B){switch(B){case g.Promise:return"req";case g.PromiseCancel:return"cancel";case g.EventListen:return"subscribe";case g.EventDispose:return"unsubscribe"}}var m;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(m||(m={}));function E(B){switch(B){case m.Initialize:return"init";case m.PromiseSuccess:return"reply:";case m.PromiseError:case m.PromiseErrorObj:return"replyErr:";case m.EventFire:return"event:"}}var f;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(f||(f={}));function w(B){let z=0;for(let _=0;;_+=7){const ne=B.read(1);if(z|=(ne.buffer[0]&127)<<_,!(ne.buffer[0]&128))return z}}const P=n(0);function p(B,z){if(z===0){B.write(P);return}let _=0;for(let le=z;le!==0;le=le>>>7)_++;const ne=C.$Ne.alloc(_);for(let le=0;z!==0;le++)ne.buffer[le]=z&127,z=z>>>7,z>0&&(ne.buffer[le]|=128);B.write(ne)}class c{constructor(z){this.b=z,this.a=0}read(z){const _=this.b.slice(this.a,this.a+z);return this.a+=_.byteLength,_}}e.$di=c;class h{constructor(){this.a=[]}get buffer(){return C.$Ne.concat(this.a)}write(z){this.a.push(z)}}e.$ei=h;var i;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(i||(i={}));function n(B){const z=C.$Ne.alloc(1);return z.writeUInt8(B,0),z}const t={Undefined:n(i.Undefined),String:n(i.String),Buffer:n(i.Buffer),VSBuffer:n(i.VSBuffer),Array:n(i.Array),Object:n(i.Object),Uint:n(i.Int)},s=typeof Buffer<"u";function r(B,z){if(typeof z>"u")B.write(t.Undefined);else if(typeof z=="string"){const _=C.$Ne.fromString(z);B.write(t.String),p(B,_.byteLength),B.write(_)}else if(s&&Buffer.isBuffer(z)){const _=C.$Ne.wrap(z);B.write(t.Buffer),p(B,_.byteLength),B.write(_)}else if(z instanceof C.$Ne)B.write(t.VSBuffer),p(B,z.byteLength),B.write(z);else if(Array.isArray(z)){B.write(t.Array),p(B,z.length);for(const _ of z)r(B,_)}else if(typeof z=="number"&&(z|0)===z)B.write(t.Uint),p(B,z);else{const _=C.$Ne.fromString(JSON.stringify(z));B.write(t.Object),p(B,_.byteLength),B.write(_)}}function o(B){switch(B.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return B.read(w(B)).toString();case i.Buffer:return B.read(w(B)).buffer;case i.VSBuffer:return B.read(w(B));case i.Array:{const _=w(B),ne=[];for(let le=0;le<_;le++)ne.push(o(B));return ne}case i.Object:return JSON.parse(B.read(w(B)).toString());case i.Int:return w(B)}}class u{constructor(z,_,ne=null,le=1e3){this.h=z,this.j=_,this.k=ne,this.l=le,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ee=>this.q(ee)),this.m({type:m.Initialize})}registerChannel(z,_){this.b.set(z,_),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case m.Initialize:{const _=this.o([z.type]);this.k?.logOutgoing(_,0,y.OtherSide,E(z.type));return}case m.PromiseSuccess:case m.PromiseError:case m.EventFire:case m.PromiseErrorObj:{const _=this.o([z.type,z.id],z.data);this.k?.logOutgoing(_,z.id,y.OtherSide,E(z.type),z.data);return}}}o(z,_=void 0){const ne=new h;return r(ne,z),r(ne,_),this.p(ne.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const _=new c(z),ne=o(_),le=o(_),ee=ne[0];switch(ee){case g.Promise:return this.k?.logIncoming(z.byteLength,ne[1],y.OtherSide,`${l(ee)}: ${ne[2]}.${ne[3]}`,le),this.s({type:ee,id:ne[1],channelName:ne[2],name:ne[3],arg:le});case g.EventListen:return this.k?.logIncoming(z.byteLength,ne[1],y.OtherSide,`${l(ee)}: ${ne[2]}.${ne[3]}`,le),this.t({type:ee,id:ne[1],channelName:ne[2],name:ne[3],arg:le});case g.PromiseCancel:return this.k?.logIncoming(z.byteLength,ne[1],y.OtherSide,`${l(ee)}`),this.u({type:ee,id:ne[1]});case g.EventDispose:return this.k?.logIncoming(z.byteLength,ne[1],y.OtherSide,`${l(ee)}`),this.u({type:ee,id:ne[1]})}}s(z){const _=this.b.get(z.channelName);if(!_){this.v(z);return}const ne=new A.$we;let le;try{le=_.call(this.j,z.name,z.arg,ne.token)}catch(X){le=Promise.reject(X)}const ee=z.id;le.then(X=>{this.m({id:ee,data:X,type:m.PromiseSuccess})},X=>{X instanceof Error?this.m({id:ee,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split(`
`):void 0},type:m.PromiseError}):this.m({id:ee,data:X,type:m.PromiseErrorObj})}).finally(()=>{Q.dispose(),this.d.delete(z.id)});const Q=(0,b.$Sc)(()=>ne.cancel());this.d.set(z.id,Q)}t(z){const _=this.b.get(z.channelName);if(!_){this.v(z);return}const ne=z.id,ee=_.listen(this.j,z.name,z.arg)(Q=>this.m({id:ne,data:Q,type:m.EventFire}));this.d.set(z.id,ee)}u(z){const _=this.d.get(z.id);_&&(_.dispose(),this.d.delete(z.id))}v(z){let _=this.g.get(z.channelName);_||(_=[],this.g.set(z.channelName,_));const ne=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===g.Promise&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:m.PromiseError})},this.l);_.push({request:z,timeoutTimer:ne})}w(z){const _=this.g.get(z);if(_){for(const ne of _)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case g.Promise:this.s(ne.request);break;case g.EventListen:this.t(ne.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$Pc)(this.d.values()),this.d.clear()}}e.$hi=u;var y;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class N{constructor(z,_=null){this.l=z,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new O.$le,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=_}getChannel(z){const _=this;return{call(ne,le,ee){return _.a?Promise.reject(new k.$4):_.m(z,ne,le,ee)},listen(ne,le){return _.a?O.Event.None:_.o(z,ne,le)}}}m(z,_,ne,le=A.CancellationToken.None){const ee=this.g++,Q=g.Promise,X={id:ee,type:Q,channelName:z,name:_,arg:ne};if(le.isCancellationRequested)return Promise.reject(new k.$4);let q;return new Promise((Y,oe)=>{if(le.isCancellationRequested)return oe(new k.$4);const j=()=>{const ie=ce=>{switch(ce.type){case m.PromiseSuccess:this.f.delete(ee),Y(ce.data);break;case m.PromiseError:{this.f.delete(ee);const ge=new Error(ce.data.message);ge.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,ge.name=ce.data.name,oe(ge);break}case m.PromiseErrorObj:this.f.delete(ee),oe(ce.data);break}};this.f.set(ee,ie),this.p(X)};let W=null;this.b===f.Idle?j():(W=(0,a.$sh)(ie=>this.u()),W.then(()=>{W=null,j()}));const G=()=>{W?(W.cancel(),W=null):this.p({id:ee,type:g.PromiseCancel}),oe(new k.$4)},J=le.onCancellationRequested(G);q=(0,b.$Rc)((0,b.$Sc)(G),J),this.d.add(q)}).finally(()=>{q.dispose(),this.d.delete(q)})}o(z,_,ne){const le=this.g++,ee=g.EventListen,Q={id:le,type:ee,channelName:z,name:_,arg:ne};let X=null;const q=new O.$le({onWillAddFirstListener:()=>{X=(0,a.$sh)(Y=>this.u()),X.then(()=>{X=null,this.d.add(q),this.p(Q)})},onDidRemoveLastListener:()=>{X?(X.cancel(),X=null):(this.d.delete(q),this.p({id:le,type:g.EventDispose}))}}),D=Y=>q.fire(Y.data);return this.f.set(le,D),q.event}p(z){switch(z.type){case g.Promise:case g.EventListen:{const _=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(_,z.id,y.LocalSide,`${l(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case g.PromiseCancel:case g.EventDispose:{const _=this.q([z.type,z.id]);this.j?.logOutgoing(_,z.id,y.LocalSide,l(z.type));return}}}q(z,_=void 0){const ne=new h;return r(ne,z),r(ne,_),this.r(ne.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const _=new c(z),ne=o(_),le=o(_),ee=ne[0];switch(ee){case m.Initialize:return this.j?.logIncoming(z.byteLength,0,y.LocalSide,E(ee)),this.t({type:ne[0]});case m.PromiseSuccess:case m.PromiseError:case m.EventFire:case m.PromiseErrorObj:return this.j?.logIncoming(z.byteLength,ne[1],y.LocalSide,E(ee),le),this.t({type:ne[0],id:ne[1],data:le})}}t(z){if(z.type===m.Initialize){this.b=f.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return O.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$Pc)(this.d.values()),this.d.clear()}}e.$ii=N,ve([T.$0h],N.prototype,"onDidInitializePromise",null);class S{get connections(){const z=[];return this.f.forEach(_=>z.push(_)),z}constructor(z,_,ne){this.a=new Map,this.f=new Set,this.g=new O.$le,this.onDidAddConnection=this.g.event,this.h=new O.$le,this.onDidRemoveConnection=this.h.event,this.j=new b.$Tc,this.j.add(z(({protocol:le,onDidClientDisconnect:ee})=>{const Q=O.Event.once(le.onMessage);this.j.add(Q(X=>{const q=new c(X),D=o(q),Y=new u(le,D,_,ne),oe=new N(le,_);this.a.forEach((W,G)=>Y.registerChannel(G,W));const j={channelServer:Y,channelClient:oe,ctx:D};this.f.add(j),this.g.fire(j),this.j.add(ee(()=>{Y.dispose(),oe.dispose(),this.f.delete(j),this.h.fire(j)}))}))}))}getChannel(z,_){const ne=this;return{call(le,ee,Q){let X;if((0,d.$sg)(_)){const D=(0,R.$2b)(ne.connections.filter(_));X=D?Promise.resolve(D):O.Event.toPromise(O.Event.filter(ne.onDidAddConnection,_))}else X=_.routeCall(ne,le,ee);const q=X.then(D=>D.channelClient.getChannel(z));return L(q).call(le,ee,Q)},listen(le,ee){if((0,d.$sg)(_))return ne.k(z,_,le,ee);const Q=_.routeEvent(ne,le,ee).then(X=>X.channelClient.getChannel(z));return L(Q).listen(le,ee)}}}k(z,_,ne,le){const ee=this;let Q;const X=new O.$le({onWillAddFirstListener:()=>{Q=new b.$Tc;const q=new O.$re,D=new Map,Y=j=>{const G=j.channelClient.getChannel(z).listen(ne,le),J=q.add(G);D.set(j,J)},oe=j=>{const W=D.get(j);W&&(W.dispose(),D.delete(j))};ee.connections.filter(_).forEach(Y),O.Event.filter(ee.onDidAddConnection,_)(Y,void 0,Q),ee.onDidRemoveConnection(oe,void 0,Q),q.event(X.fire,X,Q),Q.add(q)},onDidRemoveLastListener:()=>{Q?.dispose(),Q=void 0}});return X.event}registerChannel(z,_){this.a.set(z,_);for(const ne of this.f)ne.channelServer.registerChannel(z,_)}dispose(){this.j.dispose();for(const z of this.f)z.channelClient.dispose(),z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ji=S;class v{constructor(z,_,ne=null){const le=new h;r(le,_),z.send(le.buffer),this.a=new N(z,ne),this.d=new u(z,_,ne)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,_){this.d.registerChannel(z,_)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ki=v;function L(B){return{call(z,_,ne){return B.then(le=>le.call(z,_,ne))},listen(z,_){const ne=new O.$ue;return B.then(le=>ne.input=le.listen(z,_)),ne.event}}}function U(B){let z=!1;return{call(_,ne,le){return z?B.call(_,ne,le):(0,a.$Gh)(0).then(()=>z=!0).then(()=>B.call(_,ne,le))},listen(_,ne){if(z)return B.listen(_,ne);const le=new O.$ue;return(0,a.$Gh)(0).then(()=>z=!0).then(()=>le.input=B.listen(_,ne)),le.event}}}class F{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const _ of z.connections)if(await Promise.resolve(this.a(_.ctx)))return Promise.resolve(_);return await O.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.$ni=F;var M;(function(B){function z(ee,Q,X){const q=ee,D=X&&X.disableMarshalling,Y=new Map;for(const oe in q)ne(oe)&&Y.set(oe,O.Event.buffer(q[oe],!0,void 0,Q));return new class{listen(oe,j,W){const G=Y.get(j);if(G)return G;const J=q[j];if(typeof J=="function"){if(le(j))return J.call(q,W);if(ne(j))return Y.set(j,O.Event.buffer(q[j],!0,void 0,Q)),Y.get(j)}throw new k.$ab(`Event not found: ${j}`)}call(oe,j,W){const G=q[j];if(typeof G=="function"){if(!D&&Array.isArray(W))for(let ie=0;ie<W.length;ie++)W[ie]=(0,I.$ci)(W[ie]);let J=G.apply(q,W);return J instanceof Promise||(J=Promise.resolve(J)),J}throw new k.$ab(`Method not found: ${j}`)}}}B.fromService=z;function _(ee,Q){const X=Q&&Q.disableMarshalling;return new Proxy({},{get(q,D){if(typeof D=="string")return Q?.properties?.has(D)?Q.properties.get(D):le(D)?function(Y){return ee.listen(D,Y)}:ne(D)?ee.listen(D):async function(...Y){let oe;Q&&!(0,d.$ng)(Q.context)?oe=[Q.context,...Y]:oe=Y;const j=await ee.call(D,oe);return X?j:(0,I.$ci)(j)};throw new k.$ab(`Property not found: ${String(D)}`)}})}B.toService=_;function ne(ee){return ee[0]==="o"&&ee[1]==="n"&&$.$Ef(ee.charCodeAt(2))}function le(ee){return/^onDynamic/.test(ee)&&$.$Ef(ee.charCodeAt(9))}})(M||(e.ProxyChannel=M={}));const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const z=B.toString();if(z!=="[object Object]")return z}return B}function x(B){return Array.isArray(B)?B.map(V):V(B)}function H(B,z,_,ne,le,ee,Q){Q=x(Q);const X=K[le],q=X[ne%X.length];let D=[`%c[${B}]%c[${String(z).padStart(7," ")}]%c[len: ${String(_).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${q}`];/\($/.test(ee)?(D=D.concat(Q),D.push(")")):D.push(Q),console.log.apply(console,D)}class te{constructor(z,_){this.d=z,this.f=_,this.a=0,this.b=0}logOutgoing(z,_,ne,le,ee){this.b+=z,H(this.d,this.b,z,_,ne,le,ee)}logIncoming(z,_,ne,le,ee){this.a+=z,H(this.f,this.a,z,_,ne,le,ee)}}e.$oi=te}),define(he[69],ue([0,1,14,3,2,42]),function(ae,e,R,a,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.ProtocolConstants=e.$pi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var k;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let r=0;function o(y,N){if(!s.has(y)){const S=String(++r);s.set(y,S)}return s.get(y)}function u(y,N,S,v){if(!t.enableDiagnostics)return;const L=o(y,N);if(v instanceof R.$Ne||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const U=R.$Ne.alloc(v.byteLength);U.set(v),t.records.push({timestamp:Date.now(),id:L,label:N,type:S,buff:U})}else t.records.push({timestamp:Date.now(),id:L,label:N,type:S,data:v})}t.traceSocketEvent=u})(k||(e.SocketDiagnostics=k={}));var O;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(O||(e.SocketCloseEventType=O={}));let b=null;function I(){return b||(b=R.$Ne.alloc(0)),b}class ${get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,r){if(s===0)return I();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const N=this.a[0];return r&&(this.a.shift(),this.b-=s),N}if(this.a[0].byteLength>s){const N=this.a[0].slice(0,s);return r&&(this.a[0]=this.a[0].slice(s),this.b-=s),N}const o=R.$Ne.alloc(s);let u=0,y=0;for(;s>0;){const N=this.a[y];if(N.byteLength>s){const S=N.slice(0,s);o.set(S,u),u+=s,r&&(this.a[y]=N.slice(s),this.b-=s),s-=s}else o.set(N,u),u+=N.byteLength,r?(this.a.shift(),this.b-=N.byteLength):y++,s-=N.byteLength}return o}}e.$pi=$;var d;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(d||(d={}));function g(t){switch(t){case d.None:return"None";case d.Regular:return"Regular";case d.Control:return"Control";case d.Ack:return"Ack";case d.Disconnect:return"Disconnect";case d.ReplayRequest:return"ReplayRequest";case d.Pause:return"PauseWriting";case d.Resume:return"ResumeWriting";case d.KeepAlive:return"KeepAlive"}}var l;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(l||(e.ProtocolConstants=l={}));class m{constructor(s,r,o,u){this.type=s,this.id=r,this.ack=o,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends C.$Uc{constructor(s){super(),this.f=this.B(new a.$le),this.onMessage=this.f.event,this.g={readHead:!0,readLen:l.HeaderLength,messageType:d.None,id:0,ack:0},this.a=s,this.b=!1,this.c=new $,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:g(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,u=this.g.id,y=this.g.ack;if(this.g.readHead=!0,this.g.readLen=l.HeaderLength,this.g.messageType=d.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,r),this.f.fire(new m(o,u,y,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=R.$Ne.alloc(l.HeaderLength);r.writeUInt8(s.type,0),r.writeUInt32BE(s.id,1),r.writeUInt32BE(s.ack,5),r.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:g(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,s.data),this.j(r,s.data)}g(s,r){const o=this.f===0;return this.d.push(s,r),this.f+=s.byteLength+r.byteLength,o}h(){const s=R.$Ne.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,r){this.g(s,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:s.byteLength}),this.c.write(s)}}class w extends C.$Uc{constructor(s){super(),this.f=new a.$le,this.onMessage=this.f.event,this.g=new a.$le,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new f(this.a)),this.c=this.B(new E(this.a)),this.B(this.c.onMessage(r=>{r.type===d.Regular&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new m(d.Regular,0,0,s))}}e.$qi=w;class P extends A.$ki{static fromSocket(s,r){return new P(new w(s),r)}get onDidDispose(){return this.b.onDidDispose}constructor(s,r,o=null){super(s,r,o),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$ri=P;class p{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new a.$le({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$si=p;class c{constructor(s){this.data=s,this.next=null}}class h{constructor(){this.a=null,this.b=null}length(){let s=0,r=this.a;for(;r;)r=r.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let r=0,o=this.a;for(;o;)s[r++]=o.data,o=o.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const r=new c(s);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const s=Date.now();for(let r=0;r<i.a;r++)this.c[r]=s-1e3*r;setInterval(()=>{for(let r=i.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),r=(1+i.a)*1e3;let o=0;for(let u=0;u<i.a;u++)s-this.c[u]<=r&&o++;return 1-o/i.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.d-this.f}constructor(s){this.v=new p,this.onControlMessage=this.v.event,this.w=new p,this.onMessage=this.w.event,this.x=new p,this.onDidDispose=this.x.event,this.y=new p,this.onSocketClose=this.y.event,this.z=new p,this.onSocketTimeout=this.z.event,this.t=s.loadEstimator??i.getInstance(),this.u=s.sendKeepAlive??!0,this.a=!1,this.c=new h,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new C.$Tc,this.p=s.socket,this.q=this.s.add(new f(this.p)),this.r=this.s.add(new E(this.p)),this.s.add(this.r.onMessage(r=>this.A(r))),this.s.add(this.p.onClose(r=>this.y.fire(r))),s.initialChunk&&this.r.acceptChunk(s.initialChunk),this.u?this.m=setInterval(()=>{this.E()},l.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const s=new m(d.Disconnect,0,0,I());this.q.write(s),this.q.flush()}}sendPause(){const s=new m(d.Pause,0,0,I());this.q.write(s)}sendResume(){const s=new m(d.Resume,0,0,I());this.q.write(s)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(s,r){this.a=!0,this.s.dispose(),this.s=new C.$Tc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=s,this.q=this.s.add(new f(this.p)),this.r=this.s.add(new E(this.p)),this.s.add(this.r.onMessage(o=>this.A(o))),this.s.add(this.p.onClose(o=>this.y.fire(o))),this.r.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.j=this.h;const s=new m(d.Ack,0,this.j,I());this.q.write(s);const r=this.c.toArray();for(let o=0,u=r.length;o<u;o++)this.q.write(r[o]);this.C()}acceptDisconnect(){this.x.fire()}A(s){if(s.ack>this.f){this.f=s.ack;do{const r=this.c.peek();if(r&&r.id<=s.ack)this.c.pop();else break}while(!0)}switch(s.type){case d.None:break;case d.Regular:{if(s.id>this.h)if(s.id!==this.h+1){const r=Date.now();r-this.n>1e4&&(this.n=r,this.q.write(new m(d.ReplayRequest,0,0,I())))}else this.h=s.id,this.k=Date.now(),this.B(),this.w.fire(s.data);break}case d.Control:{this.v.fire(s.data);break}case d.Ack:break;case d.Disconnect:{this.x.fire();break}case d.ReplayRequest:{const r=this.c.toArray();for(let o=0,u=r.length;o<u;o++)this.q.write(r[o]);this.C();break}case d.Pause:{this.q.pause();break}case d.Resume:{this.q.resume();break}case d.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(s){const r=++this.d;this.j=this.h;const o=new m(d.Regular,r,this.j,s);this.c.push(o),this.a||(this.q.write(o),this.C())}sendControl(s){const r=new m(d.Control,0,0,s);this.q.write(r)}B(){if(this.h<=this.j||this.l)return;const s=Date.now()-this.k;if(s>=l.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},l.AcknowledgeTime-s+5)}C(){if(this.d<=this.f||this.g||this.a)return;const s=this.c.peek(),r=Date.now()-s.writtenTime,o=Date.now()-this.r.lastReadTime,u=Date.now()-this.o;if(r>=l.TimeoutTime&&o>=l.TimeoutTime&&u>=l.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:o});return}const y=Math.max(l.TimeoutTime-r,l.TimeoutTime-o,l.TimeoutTime-u,500);this.g=setTimeout(()=>{this.g=null,this.C()},y)}D(){if(this.h<=this.j)return;this.j=this.h;const s=new m(d.Ack,0,this.j,I());this.q.write(s)}E(){this.j=this.h;const s=new m(d.KeepAlive,0,this.j,I());this.q.write(s)}}e.$ti=n}),define(he[95],ue([0,1,68,6,14,25,139,8,3,2,29,148,91,42]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=e.$hr=void 0,k=Oe(k);class l extends g.$hi{constructor(f){super({send:w=>{try{process.send?.(w.buffer.toString("base64"))}catch{}},onMessage:O.Event.fromNodeEventEmitter(process,"message",w=>C.$Ne.wrap(Buffer.from(w,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$hr=l;class m{constructor(f,w){this.i=f,this.j=w,this.c=new Set,this.g=new Map,this.h=new O.$le,this.onDidProcessExit=this.h.event;const P=w&&w.timeout?w.timeout:6e4;this.b=new a.$Ch(P),this.d=null,this.f=null}getChannel(f){const w=this;return{call(P,p,c){return w.k(f,P,p,c)},listen(P,p){return w.l(f,P,p)}}}k(f,w,P,p=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(k.$5());this.b.cancel();const c=this.n(f),h=(0,a.$sh)(t=>c.call(w,P,t)),i=p.onCancellationRequested(()=>h.cancel()),n=(0,b.$Sc)(()=>h.cancel());return this.c.add(n),h.finally(()=>{i.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),h}l(f,w,P){if(!this.b)return O.Event.None;this.b.cancel();let p;const c=new O.$le({onWillAddFirstListener:()=>{p=this.n(f).listen(w,P)(c.fire,c),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],w=Object.create(null);w.env={...(0,I.$eo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(w.env={...w.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(w.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,d.$mm)(w.env),this.d=(0,R.fork)(this.i,f,w);const P=new O.$le,c=O.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,T.$dr)(r)){(0,T.log)(r,`IPC Library: ${this.j.serverName}`);return}P.fire(C.$Ne.wrap(Buffer.from(r,"base64")))}),h=this.j.useQueue?(0,$.$zm)(this.d):this.d,i=r=>this.d&&this.d.connected&&h.send(r.buffer.toString("base64")),n=P.event,t={send:i,onMessage:n};this.f=new g.$ii(t);const s=()=>this.o();process.once("exit",s),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,o)=>{process.removeListener("exit",s),c.dispose(),this.c.forEach(u=>(0,b.$Pc)(u)),this.c.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:o})})}return this.f}n(f){let w=this.g.get(f);return w||(w=this.m.getChannel(f),this.g.set(f,w)),w}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$ir=m}),define(he[150],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9X=R;function R(a){return!!a.parentPort}}),define(he[151],ue([0,1,150,14,42,3,12,17]),function(ae,e,R,a,C,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0X=void 0,e.$$X=I;class O{constructor(d){this.a=d,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",g=>g.data?a.$Ne.wrap(g.data):a.$Ne.alloc(0)),d.start()}send(d){this.a.postMessage(d.buffer)}disconnect(){this.a.close()}}class b extends C.$ji{static b(d){(0,T.$og)((0,R.$9X)(process),"Electron Utility Process");const g=new A.$le;return process.parentPort.on("message",l=>{if(d?.handledClientConnection(l))return;const m=(0,k.$Nb)(l.ports);m&&g.fire(m)}),A.Event.map(g.event,l=>({protocol:new O(l),onDidClientDisconnect:A.Event.fromNodeEventEmitter(l,"close")}))}constructor(d){super(b.b(d))}}e.$0X=b;function I($,d,g){const l=m=>{m.data===d&&($.removeListener("message",l),g())};$.on("message",l)}}),define(he[70],ue([0,1,6,3,2,66,12]),function(ae,e,R,a,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=e.StorageState=e.StorageHint=void 0,e.$dq=O;var k;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k||(e.StorageHint=k={}));function O(d){const g=d;return g?.changed instanceof Map||g?.deleted instanceof Set}var b;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(b||(e.StorageState=b={}));class I extends C.$Uc{static{this.a=100}constructor(g,l=Object.create(null)){super(),this.r=g,this.s=l,this.b=this.B(new a.$oe),this.onDidChangeStorage=this.b.event,this.c=b.None,this.f=new Map,this.g=this.B(new R.$Dh(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(g=>this.u(g)))}u(g){this.b.pause();try{g.changed?.forEach((l,m)=>this.w(m,l)),g.deleted?.forEach(l=>this.w(l,void 0))}finally{this.b.resume()}}w(g,l){if(this.c===b.Closed)return;let m=!1;(0,T.$ng)(l)?m=this.f.delete(g):this.f.get(g)!==l&&(this.f.set(g,l),m=!0),m&&this.b.fire({key:g,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===b.None&&(this.c=b.Initialized,this.s.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(g,l){const m=this.f.get(g);return(0,T.$ng)(m)?l:m}getBoolean(g,l){const m=this.get(g);return(0,T.$ng)(m)?l:m==="true"}getNumber(g,l){const m=this.get(g);return(0,T.$ng)(m)?l:parseInt(m,10)}getObject(g,l){const m=this.get(g);return(0,T.$ng)(m)?l:(0,A.$bi)(m)}async set(g,l,m=!1){if(this.c===b.Closed)return;if((0,T.$ng)(l))return this.delete(g,m);const E=(0,T.$gg)(l)||Array.isArray(l)?(0,A.$ai)(l):String(l);if(this.f.get(g)!==E)return this.f.set(g,E),this.j.set(g,E),this.h.delete(g),this.b.fire({key:g,external:m}),this.D()}async delete(g,l=!1){if(!(this.c===b.Closed||!this.f.delete(g)))return this.h.has(g)||this.h.add(g),this.j.delete(g),this.b.fire({key:g,external:l}),this.D()}async optimize(){if(this.c!==b.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=b.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const g={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(g).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(g){if(!(this.c===b.Closed||this.m))return this.D(g)}async D(g){return this.s.hint===k.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),g)}async whenFlushed(){if(this.z)return new Promise(g=>this.n.push(g))}isInMemory(){return this.s.hint===k.STORAGE_IN_MEMORY}}e.$eq=I;class ${constructor(){this.onDidChangeItemsExternal=a.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(g){g.insert?.forEach((l,m)=>this.a.set(m,l)),g.delete?.forEach(l=>this.a.delete(l))}async optimize(){}async close(){}}e.$fq=$}),define(he[11],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=C,e.localize2=T;const R=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function a(k,O){let b;return O.length===0?b=k:b=k.replace(/\{(\d+)\}/g,(I,$)=>{const d=$[0],g=O[d];let l=I;return typeof g=="string"?l=g:(typeof g=="number"||typeof g=="boolean"||g===void 0||g===null)&&(l=String(g)),l}),R&&(b="\uFF3B"+b.replace(/[aouei]/g,"$&$&")+"\uFF3D"),b}function C(k,O,...b){return a(typeof k=="number"?A(k,O):O,b)}function A(k,O){const b=globalThis._VSCODE_NLS_MESSAGES?.[k];if(typeof b!="string"){if(typeof O=="string")return O;throw new Error(`!!! NLS MISSING: ${k} !!!`)}return b}function T(k,O,...b){let I;typeof k=="number"?I=A(k,O):I=O;const $=a(I,b);return{value:$,original:O===I?$:a(O,b)}}}),define(he[71],ue([0,1,11]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=b,e.$3m=I,e.$4m=$;const a=60,C=a*60,A=C*24,T=A*7,k=A*30,O=A*365;function b(d,g,l,m){typeof d!="number"&&(d=d.getTime());const E=Math.round((new Date().getTime()-d)/1e3);if(E<-30)return(0,R.localize)(12987,null,b(new Date().getTime()+E*1e3,!1));if(!m&&E<30)return(0,R.localize)(12988,null);let f;return E<a?(f=E,g?f===1?l?(0,R.localize)(12989,null,f):(0,R.localize)(12990,null,f):l?(0,R.localize)(12991,null,f):(0,R.localize)(12992,null,f):f===1?l?(0,R.localize)(12993,null,f):(0,R.localize)(12994,null,f):l?(0,R.localize)(12995,null,f):(0,R.localize)(12996,null,f)):E<C?(f=Math.floor(E/a),g?f===1?l?(0,R.localize)(12997,null,f):(0,R.localize)(12998,null,f):l?(0,R.localize)(12999,null,f):(0,R.localize)(13e3,null,f):f===1?l?(0,R.localize)(13001,null,f):(0,R.localize)(13002,null,f):l?(0,R.localize)(13003,null,f):(0,R.localize)(13004,null,f)):E<A?(f=Math.floor(E/C),g?f===1?l?(0,R.localize)(13005,null,f):(0,R.localize)(13006,null,f):l?(0,R.localize)(13007,null,f):(0,R.localize)(13008,null,f):f===1?l?(0,R.localize)(13009,null,f):(0,R.localize)(13010,null,f):l?(0,R.localize)(13011,null,f):(0,R.localize)(13012,null,f)):E<T?(f=Math.floor(E/A),g?f===1?(0,R.localize)(13013,null,f):(0,R.localize)(13014,null,f):f===1?(0,R.localize)(13015,null,f):(0,R.localize)(13016,null,f)):E<k?(f=Math.floor(E/T),g?f===1?l?(0,R.localize)(13017,null,f):(0,R.localize)(13018,null,f):l?(0,R.localize)(13019,null,f):(0,R.localize)(13020,null,f):f===1?l?(0,R.localize)(13021,null,f):(0,R.localize)(13022,null,f):l?(0,R.localize)(13023,null,f):(0,R.localize)(13024,null,f)):E<O?(f=Math.floor(E/k),g?f===1?l?(0,R.localize)(13025,null,f):(0,R.localize)(13026,null,f):l?(0,R.localize)(13027,null,f):(0,R.localize)(13028,null,f):f===1?l?(0,R.localize)(13029,null,f):(0,R.localize)(13030,null,f):l?(0,R.localize)(13031,null,f):(0,R.localize)(13032,null,f)):(f=Math.floor(E/O),g?f===1?l?(0,R.localize)(13033,null,f):(0,R.localize)(13034,null,f):l?(0,R.localize)(13035,null,f):(0,R.localize)(13036,null,f):f===1?l?(0,R.localize)(13037,null,f):(0,R.localize)(13038,null,f):l?(0,R.localize)(13039,null,f):(0,R.localize)(13040,null,f))}function I(d,g){const l=Math.abs(d/1e3);return l<1?g?(0,R.localize)(13041,null,d):(0,R.localize)(13042,null,d):l<a?g?(0,R.localize)(13043,null,Math.round(d)/1e3):(0,R.localize)(13044,null,Math.round(d)/1e3):l<C?g?(0,R.localize)(13045,null,Math.round(d/(1e3*a))):(0,R.localize)(13046,null,Math.round(d/(1e3*a))):l<A?g?(0,R.localize)(13047,null,Math.round(d/(1e3*C))):(0,R.localize)(13048,null,Math.round(d/(1e3*C))):(0,R.localize)(13049,null,Math.round(d/(1e3*A)))}function $(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(he[43],ue([0,1,17,12,11]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=O,e.$rj=b,e.$sj=I,R=Oe(R),a=Oe(a),C=Oe(C);function A($,d){return d&&($.stack||$.stacktrace)?C.localize(12981,null,k($),T($.stack)||T($.stacktrace)):k($)}function T($){return Array.isArray($)?$.join(`
`):$}function k($){return $.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${$.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof $.code=="string"&&typeof $.errno=="number"&&typeof $.syscall=="string"?C.localize(12982,null,$.message):$.message||C.localize(12983,null)}function O($=null,d=!1){if(!$)return C.localize(12984,null);if(Array.isArray($)){const g=R.$Gb($),l=O(g[0],d);return g.length>1?C.localize(12985,null,l,g.length):l}if(a.$eg($))return $;if($.detail){const g=$.detail;if(g.error)return A(g.error,d);if(g.exception)return A(g.exception,d)}return $.stack?A($,d):$.message?$.message:C.localize(12986,null)}function b($){const d=$;return d instanceof Error&&Array.isArray(d.actions)}function I($,d){let g;return typeof $=="string"?g=new Error($):g=$,g.actions=d,g}}),define(he[152],ue([0,1,11,36]),function(ae,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=C;function C(A){switch(A){case a.ParseErrorCode.InvalidSymbol:return(0,R.localize)(12972,null);case a.ParseErrorCode.InvalidNumberFormat:return(0,R.localize)(12973,null);case a.ParseErrorCode.PropertyNameExpected:return(0,R.localize)(12974,null);case a.ParseErrorCode.ValueExpected:return(0,R.localize)(12975,null);case a.ParseErrorCode.ColonExpected:return(0,R.localize)(12976,null);case a.ParseErrorCode.CommaExpected:return(0,R.localize)(12977,null);case a.ParseErrorCode.CloseBraceExpected:return(0,R.localize)(12978,null);case a.ParseErrorCode.CloseBracketExpected:return(0,R.localize)(12979,null);case a.ParseErrorCode.EndOfFileExpected:return(0,R.localize)(12980,null);default:return""}}}),define(he[72],ue([0,1,33,6,13,12,30,11]),function(ae,e,R,a,C,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$Aq=void 0,e.zip=E,e.$Dq=f,e.$Eq=P,C=Oe(C),k=Oe(k),e.$Aq="end of central directory record signature not found";const O=new RegExp(e.$Aq);class b extends Error{constructor(c,h){let i=h.message;switch(c){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=c,this.cause=h}}e.$Bq=b;function I(p){const c=p.externalFileAttributes>>16||33188;return[448,56,7].map(h=>c&h).reduce((h,i)=>h+i,c&61440)}function $(p){if(p instanceof b)return p;let c;return O.test(p.message)&&(c="CorruptZip"),new b(c,p)}function d(p,c,h,i,n,t){const s=C.$mc(c),r=C.$jc(i,s);if(!r.startsWith(i))return Promise.reject(new Error(k.localize(12949,null,c)));const o=C.$jc(i,c);let u;return t.onCancellationRequested(()=>{u?.destroy()}),Promise.resolve(R.promises.mkdir(r,{recursive:!0})).then(()=>new Promise((y,N)=>{if(!t.isCancellationRequested)try{u=(0,R.createWriteStream)(o,{mode:h}),u.once("close",()=>y()),u.once("error",N),p.once("error",N),p.pipe(u)}catch(S){N(S)}}))}function g(p,c,h,i){let n=(0,a.$sh)(()=>Promise.resolve()),t=0;const s=i.onCancellationRequested(()=>{n.cancel(),p.close()});return new Promise((r,o)=>{const u=new a.$Ah,y=N=>{N.isCancellationRequested||(t++,p.readEntry())};p.once("error",o),p.once("close",()=>n.then(()=>{i.isCancellationRequested||p.entryCount===t?r():o(new b("Incomplete",new Error(k.localize(12950,null,t,p.entryCount))))},o)),p.readEntry(),p.on("entry",N=>{if(i.isCancellationRequested)return;if(!h.sourcePathRegex.test(N.fileName)){y(i);return}const S=N.fileName.replace(h.sourcePathRegex,"");if(/\/$/.test(S)){const U=C.$jc(c,S);n=(0,a.$sh)(F=>R.promises.mkdir(U,{recursive:!0}).then(()=>y(F)).then(void 0,o));return}const v=m(p,N),L=I(N);n=(0,a.$sh)(U=>u.queue(()=>v.then(F=>d(F,S,L,c,h,U).then(()=>y(U)))).then(null,o))})}).finally(()=>s.dispose())}async function l(p,c=!1){const{open:h}=await new Promise((i,n)=>{ae(["yauzl"],i,n)}).then(Oe);return new Promise((i,n)=>{h(p,c?{lazyEntries:!0}:void 0,(t,s)=>{t?n($(t)):i((0,A.$pg)(s))})})}function m(p,c){return new Promise((h,i)=>{p.openReadStream(c,(n,t)=>{n?i($(n)):h((0,A.$pg)(t))})})}async function E(p,c){const{ZipFile:h}=await new Promise((i,n)=>{ae(["yazl"],i,n)}).then(Oe);return new Promise((i,n)=>{const t=new h;c.forEach(r=>{r.contents?t.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&t.addFile(r.localPath,r.path)}),t.end();const s=(0,R.createWriteStream)(p);t.outputStream.pipe(s),t.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>i(p))})}function f(p,c,h={},i){const n=new RegExp(h.sourcePath?`^${h.sourcePath}`:"");let t=l(p,!0);return h.overwrite&&(t=t.then(s=>T.Promises.rm(c).then(()=>s))),t.then(s=>g(s,c,{sourcePathRegex:n},i))}function w(p,c){return l(p).then(h=>new Promise((i,n)=>{h.on("entry",t=>{t.fileName===c&&m(h,t).then(s=>i(s),s=>n(s))}),h.once("close",()=>n(new Error(k.localize(12951,null,c))))}))}function P(p,c){return w(p,c).then(h=>new Promise((i,n)=>{const t=[];h.once("error",n),h.on("data",s=>t.push(s)),h.on("end",()=>i(Buffer.concat(t)))}))}}),define(he[153],ue([0,1,39,8,11]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.TokenType=void 0;var A;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(A||(e.TokenType=A={}));function T(...I){switch(I.length){case 1:return(0,C.localize)(11585,null,I[0]);case 2:return(0,C.localize)(11586,null,I[0],I[1]);case 3:return(0,C.localize)(11587,null,I[0],I[1],I[2]);default:return}}const k=(0,C.localize)(11588,null),O=(0,C.localize)(11589,null);class b{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme($){switch($.type){case A.LParen:return"(";case A.RParen:return")";case A.Neg:return"!";case A.Eq:return $.isTripleEq?"===":"==";case A.NotEq:return $.isTripleEq?"!==":"!=";case A.Lt:return"<";case A.LtEq:return"<=";case A.Gt:return">=";case A.GtEq:return">=";case A.RegexOp:return"=~";case A.RegexStr:return $.lexeme;case A.True:return"true";case A.False:return"false";case A.In:return"in";case A.Not:return"not";case A.And:return"&&";case A.Or:return"||";case A.Str:return $.lexeme;case A.QuotedStr:return $.lexeme;case A.Error:return $.lexeme;case A.EOF:return"EOF";default:throw(0,a.$7)(`unhandled token type: ${JSON.stringify($)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map($=>$.charCodeAt(0)))}static{this.b=new Map([["not",A.Not],["in",A.In],["false",A.False],["true",A.True]])}get errors(){return this.g}reset($){return this.c=$,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case R.CharCode.OpenParen:this.k(A.LParen);break;case R.CharCode.CloseParen:this.k(A.RParen);break;case R.CharCode.ExclamationMark:if(this.h(R.CharCode.Equals)){const d=this.h(R.CharCode.Equals);this.f.push({type:A.NotEq,offset:this.d,isTripleEq:d})}else this.k(A.Neg);break;case R.CharCode.SingleQuote:this.o();break;case R.CharCode.Slash:this.q();break;case R.CharCode.Equals:if(this.h(R.CharCode.Equals)){const d=this.h(R.CharCode.Equals);this.f.push({type:A.Eq,offset:this.d,isTripleEq:d})}else this.h(R.CharCode.Tilde)?this.k(A.RegexOp):this.l(T("==","=~"));break;case R.CharCode.LessThan:this.k(this.h(R.CharCode.Equals)?A.LtEq:A.Lt);break;case R.CharCode.GreaterThan:this.k(this.h(R.CharCode.Equals)?A.GtEq:A.Gt);break;case R.CharCode.Ampersand:this.h(R.CharCode.Ampersand)?this.k(A.And):this.l(T("&&"));break;case R.CharCode.Pipe:this.h(R.CharCode.Pipe)?this.k(A.Or):this.l(T("||"));break;case R.CharCode.Space:case R.CharCode.CarriageReturn:case R.CharCode.Tab:case R.CharCode.LineFeed:case R.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(A.EOF),Array.from(this.f)}h($){return this.r()||this.c.charCodeAt(this.e)!==$?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?R.CharCode.Null:this.c.charCodeAt(this.e)}k($){this.f.push({type:$,offset:this.d})}l($){const d=this.d,g=this.c.substring(this.d,this.e),l={type:A.Error,offset:this.d,lexeme:g};this.g.push({offset:d,lexeme:g,additionalInfo:$}),this.f.push(l)}n(){this.m.lastIndex=this.d;const $=this.m.exec(this.c);if($){this.e=this.d+$[0].length;const d=this.c.substring(this.d,this.e),g=b.b.get(d);g?this.k(g):this.f.push({type:A.Str,lexeme:d,offset:this.d})}}o(){for(;this.j()!==R.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(k);return}this.i(),this.f.push({type:A.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let $=this.e,d=!1,g=!1;for(;;){if($>=this.c.length){this.e=$,this.l(O);return}const m=this.c.charCodeAt($);if(d)d=!1;else if(m===R.CharCode.Slash&&!g){$++;break}else m===R.CharCode.OpenSquareBracket?g=!0:m===R.CharCode.Backslash?d=!0:m===R.CharCode.CloseSquareBracket&&(g=!1);$++}for(;$<this.c.length&&b.a.has(this.c.charCodeAt($));)$++;this.e=$;const l=this.c.substring(this.d,this.e);this.f.push({type:A.RegexStr,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Aj=b}),define(he[154],ue([0,1,71,87,22,13,37,20,9]),function(ae,e,R,a,C,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=void 0,e.$7m=I,e.$8m=$,e.$5m=/^([^.]+\..+)[:=](.+)$/;class b{get appRoot(){return(0,A.$mc)(C.$Zg.asFileUri("").fsPath)}get userHome(){return O.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return O.URI.file((0,A.$jc)(this.userDataPath,"User"))}get tmpDir(){return O.URI.file(this.b.tmpDir)}get cacheHome(){return O.URI.file(this.userDataPath)}get stateResource(){return(0,k.$gh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:C.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,k.$gh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const g=(0,R.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$jc)(this.userDataPath,"logs",g)}return O.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.$gh)(O.URI.file((0,A.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.$gh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.$gh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.$gh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=T.env.VSCODE_PORTABLE;return g?O.URI.file((0,A.$jc)(g,"argv.json")):(0,k.$gh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return O.URI.file((0,A.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,A.$kc)(g):(0,A.$hc)((0,A.$jc)(C.$Zg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?O.URI.file((0,A.$kc)(g)):O.URI.file((0,A.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,A.$kc)(g);const l=T.env.VSCODE_EXTENSIONS;if(l)return l;const m=T.env.VSCODE_PORTABLE;return m?(0,A.$jc)(m,"extensions"):(0,k.$gh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(l=>/^[^:/?#]+?:\/\//.test(l)?O.URI.parse(l):O.URI.file((0,A.$hc)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?O.URI.parse(g):O.URI.file((0,A.$hc)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.$5m.test(g))}get extensionLogLevel(){const g=[];for(const l of this.args.log||[]){const m=e.$5m.exec(l);m&&m[1]&&m[2]&&g.push([m[1],m[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,k.$gh)(O.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=T.env.VSCODE_PORTABLE;return g?O.URI.file((0,A.$jc)(g,"policy.json")):(0,k.$gh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this.a}constructor(g,l,m){this.a=g,this.b=l,this.c=m,this.editSessionId=this.args.editSessionId}}e.$6m=b,ve([a.$0h],b.prototype,"appRoot",null),ve([a.$0h],b.prototype,"userHome",null),ve([a.$0h],b.prototype,"userDataPath",null),ve([a.$0h],b.prototype,"appSettingsHome",null),ve([a.$0h],b.prototype,"tmpDir",null),ve([a.$0h],b.prototype,"cacheHome",null),ve([a.$0h],b.prototype,"stateResource",null),ve([a.$0h],b.prototype,"userRoamingDataHome",null),ve([a.$0h],b.prototype,"userDataSyncHome",null),ve([a.$0h],b.prototype,"sync",null),ve([a.$0h],b.prototype,"machineSettingsResource",null),ve([a.$0h],b.prototype,"workspaceStorageHome",null),ve([a.$0h],b.prototype,"localHistoryHome",null),ve([a.$0h],b.prototype,"keyboardLayoutResource",null),ve([a.$0h],b.prototype,"argvResource",null),ve([a.$0h],b.prototype,"isExtensionDevelopment",null),ve([a.$0h],b.prototype,"untitledWorkspacesHome",null),ve([a.$0h],b.prototype,"builtinExtensionsPath",null),ve([a.$0h],b.prototype,"extensionsPath",null),ve([a.$0h],b.prototype,"extensionDevelopmentLocationURI",null),ve([a.$0h],b.prototype,"extensionDevelopmentKind",null),ve([a.$0h],b.prototype,"extensionTestsLocationURI",null),ve([a.$0h],b.prototype,"debugExtensionHost",null),ve([a.$0h],b.prototype,"logLevel",null),ve([a.$0h],b.prototype,"extensionLogLevel",null),ve([a.$0h],b.prototype,"serviceMachineIdResource",null),ve([a.$0h],b.prototype,"disableTelemetry",null),ve([a.$0h],b.prototype,"disableWorkspaceTrust",null),ve([a.$0h],b.prototype,"useInMemorySecretStorage",null),ve([a.$0h],b.prototype,"policyFile",null);function I(d,g){return $(d["inspect-extensions"],d["inspect-brk-extensions"],5870,g,d.debugId,d.extensionEnvironment)}function $(d,g,l,m,E,f){const P=Number(g||d)||(m?null:l),p=P?!!g:!1;let c;if(f)try{c=JSON.parse(f)}catch{}return{port:P,break:p,debugId:E,env:c}}}),function(){function ae(e,R,a){function C(T,k){const O=A(T,k),b=[O];return e.isAbsolute(O)||b.unshift(a),e.resolve(...b)}function A(T,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const O=process.env.VSCODE_PORTABLE;if(O)return e.join(O,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,k);const I=T["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const $=process.env.USERPROFILE;if(typeof $!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join($,"AppData","Roaming")}break;case"darwin":b=e.join(R.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,k)}return{getUserDataPath:C}}if(typeof define=="function")define(he[155],ue([243,38,37]),function(e,R,a){return ae(e,R,a.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),R=require("os");module.exports=ae(e,R,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(he[156],ue([0,1,38,154,155]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$0m=T,e.$$m=k;class A extends a.$6m{constructor(b,I){super(b,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,C.getUserDataPath)(b,I.nameShort)},I)}}e.$9m=A;function T(O,b){return(0,a.$8m)(O["inspect-ptyhost"],O["inspect-brk-ptyhost"],5877,b,O.extensionEnvironment)}function k(O,b){return(0,a.$8m)(O["inspect-sharedprocess"],O["inspect-brk-sharedprocess"],5879,b,O.extensionEnvironment)}}),define(he[157],ue([0,1,12,11]),function(ae,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=C;function C(T,k,O,b){try{A(T,k,O,b)}catch(I){T.error(I?.message??I)}return k}function A(T,k,O,b){const I=($,d,g)=>{const l=$[d];if((0,R.$eg)(l)){const m=l,E=m.length;if(E>1&&m[0]==="%"&&m[E-1]==="%"){const f=m.substr(1,E-2);let w=O[f];w===void 0&&b&&(w=b[f]);const P=typeof w=="string"?w:w?.message,p=b?.[f],c=typeof p=="string"?p:p?.message;if(!P){c||T.warn(`[${k.name}]: ${(0,a.localize)(11468,null,f)}`);return}if(g&&(d==="title"||d==="category")&&c&&c!==P){const h={value:P,original:c};$[d]=h}else $[d]=P}}else if((0,R.$gg)(l))for(const m in l)l.hasOwnProperty(m)&&(m==="commands"?I(l,m,!0):I(l,m,g));else if(Array.isArray(l))for(let m=0;m<l.length;m++)I(l,m,g)};for(const $ in k)k.hasOwnProperty($)&&I(k,$)}}),define(he[158],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jic=e.$Iic=void 0;class R{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.a.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$Iic=R;class a{constructor(A){this.a=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,k){switch(T){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(k[0])}throw new Error(`Call not found: ${T}`)}}e.$Jic=a}),define(he[159],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const R={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(R)}),define(he[73],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class R{constructor(C,A=[],T=!1){this.ctor=C,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.$Ci=R}),define(he[160],ue([0,1,73]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Rs=A,e.$Ss=T;const a=[];var C;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function A(k,O,b){O instanceof R.$Ci||(O=new R.$Ci(O,[],!!b)),a.push([k,O])}function T(){return a}}),define(he[161],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=void 0;class R{constructor(A,T){this.key=A,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$ur=R;class a{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const T of this.a.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const k=this.lookupOrInsertNode(A),O=this.lookupOrInsertNode(T);k.outgoing.set(O.key,O),O.incoming.set(k.key,k)}removeNode(A){const T=this.b(A);this.a.delete(T);for(const k of this.a.values())k.outgoing.delete(T),k.incoming.delete(T)}lookupOrInsertNode(A){const T=this.b(A);let k=this.a.get(T);return k||(k=new R(T,A),this.a.set(T,k)),k}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[T,k]of this.a)A.push(`${T}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,T]of this.a){const k=new Set([A]),O=this.c(T,k);if(O)return O}}c(A,T){for(const[k,O]of A.outgoing){if(T.has(k))return[...T,k].join(" -> ");T.add(k);const b=this.c(O,T);if(b)return b;T.delete(k)}}}e.$vr=a}),define(he[4],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=C,e.$Gi=A;var R;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function k(O){return O[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=k})(R||(e._util=R={})),e.$Ei=C("instantiationService");function a(T,k,O){k[R.DI_TARGET]===k?k[R.DI_DEPENDENCIES].push({id:T,index:O}):(k[R.DI_DEPENDENCIES]=[{id:T,index:O}],k[R.DI_TARGET]=k)}function C(T){if(R.serviceIds.has(T))return R.serviceIds.get(T);const k=function(O,b,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");a(k,O,I)};return k.toString=()=>T,R.serviceIds.set(T,k),k}function A(T){return T}}),define(he[162],ue([0,1,4]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iic=void 0,e.$iic=(0,R.$Fi)("checksumService")}),define(he[21],ue([0,1,12,9,4]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$_i=void 0,e.$aj=A,e.$bj=T,e.$cj=O,e.$dj=b,e.$ej=I,e.$fj=$,e.$gj=d,e.$hj=l,e.$ij=m,e.$jj=E,R=Oe(R),e.$_i=(0,C.$Fi)("configurationService");function A(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof a.URI)}function T(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof a.URI)}var k;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(k||(e.ConfigurationTarget=k={}));function O(f){switch(f){case k.APPLICATION:return"APPLICATION";case k.USER:return"USER";case k.USER_LOCAL:return"USER_LOCAL";case k.USER_REMOTE:return"USER_REMOTE";case k.WORKSPACE:return"WORKSPACE";case k.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case k.DEFAULT:return"DEFAULT";case k.MEMORY:return"MEMORY"}}function b(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function I(f,w){const P=Object.create(null);for(const p in f)$(P,p,f[p],w);return P}function $(f,w,P,p){const c=w.split("."),h=c.pop();let i=f;for(let n=0;n<c.length;n++){const t=c[n];let s=i[t];switch(typeof s){case"undefined":s=i[t]=Object.create(null);break;case"object":if(s===null){p(`Ignoring ${w} as ${c.slice(0,n+1).join(".")} is null`);return}break;default:p(`Ignoring ${w} as ${c.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}i=s}if(typeof i=="object"&&i!==null)try{i[h]=P}catch{p(`Ignoring ${w} as ${c.join(".")} is ${JSON.stringify(i)}`)}else p(`Ignoring ${w} as ${c.join(".")} is ${JSON.stringify(i)}`)}function d(f,w){const P=w.split(".");g(f,P)}function g(f,w){const P=w.shift();if(w.length===0){delete f[P];return}if(Object.keys(f).indexOf(P)!==-1){const p=f[P];typeof p=="object"&&!Array.isArray(p)&&(g(p,w),Object.keys(p).length===0&&delete f[P])}}function l(f,w,P){function p(i,n){let t=i;for(const s of n){if(typeof t!="object"||t===null)return;t=t[s]}return t}const c=w.split("."),h=p(f,c);return typeof h>"u"?P:h}function m(f,w,P){Object.keys(w).forEach(p=>{p!=="__proto__"&&(p in f?R.$gg(f[p])&&R.$gg(w[p])?m(f[p],w[p],P):P&&(f[p]=w[p]):f[p]=w[p])})}function E(f){return f.replace(/[\[\]]/g,"")}}),define(he[96],ue([0,1,39,5,26,153,4,11,8]),function(ae,e,R,a,C,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Dj=e.$Cj=e.ContextKeyExprType=void 0,e.$Bj=I,e.$Ej=n,e.$Fj=t,e.$Yj=ee;const b=new Map;b.set("false",!1),b.set("true",!0),b.set("isMac",a.$k),b.set("isLinux",a.$l),b.set("isWindows",a.$j),b.set("isWeb",a.$p),b.set("isMacNative",a.$k&&!a.$p),b.set("isEdge",a.$I),b.set("isFirefox",a.$G),b.set("isChrome",a.$F),b.set("isSafari",a.$H);function I(q,D){if(b.get(q)!==void 0)throw(0,O.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");b.set(q,D)}const $=Object.prototype.hasOwnProperty;var d;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(d||(e.ContextKeyExprType=d={}));const g={regexParsingWithErrorRecovery:!0},l=(0,k.localize)(11599,null),m=(0,k.localize)(11600,null),E=(0,k.localize)(11601,null),f=(0,k.localize)(11602,null),w=(0,k.localize)(11603,null),P=(0,k.localize)(11604,null),p=(0,k.localize)(11605,null),c=(0,k.localize)(11606,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(D=g){this.k=D,this.d=new A.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(D){if(D===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(D).scan(),this.g=0,this.h=[];try{const Y=this.l();if(!this.E()){const oe=this.D(),j=oe.type===A.TokenType.Str?P:void 0;throw this.h.push({message:w,offset:oe.offset,lexeme:A.$Aj.getLexeme(oe),additionalInfo:j}),h.c}return Y}catch(Y){if(Y!==h.c)throw Y;return}}l(){return this.m()}m(){const D=[this.o()];for(;this.y(A.TokenType.Or);){const Y=this.o();D.push(Y)}return D.length===1?D[0]:i.or(...D)}o(){const D=[this.s()];for(;this.y(A.TokenType.And);){const Y=this.s();D.push(Y)}return D.length===1?D[0]:i.and(...D)}s(){if(this.y(A.TokenType.Neg)){const D=this.D();switch(D.type){case A.TokenType.True:return this.z(),r.INSTANCE;case A.TokenType.False:return this.z(),o.INSTANCE;case A.TokenType.LParen:{this.z();const Y=this.l();return this.A(A.TokenType.RParen,f),Y?.negate()}case A.TokenType.Str:return this.z(),L.create(D.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",D)}}return this.t()}t(){const D=this.D();switch(D.type){case A.TokenType.True:return this.z(),i.true();case A.TokenType.False:return this.z(),i.false();case A.TokenType.LParen:{this.z();const Y=this.l();return this.A(A.TokenType.RParen,f),Y}case A.TokenType.Str:{const Y=D.lexeme;if(this.z(),this.y(A.TokenType.RegexOp)){const j=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),j.type!==A.TokenType.RegexStr)throw this.B("REGEX",j);const W=j.lexeme,G=W.lastIndexOf("/"),J=G===W.length-1?void 0:this.w(W.substring(G+1));let ie;try{ie=new RegExp(W.substring(1,G),J)}catch{throw this.B("REGEX",j)}return x.create(Y,ie)}switch(j.type){case A.TokenType.RegexStr:case A.TokenType.Error:{const W=[j.lexeme];this.z();let G=this.D(),J=0;for(let Ee=0;Ee<j.lexeme.length;Ee++)j.lexeme.charCodeAt(Ee)===R.CharCode.OpenParen?J++:j.lexeme.charCodeAt(Ee)===R.CharCode.CloseParen&&J--;for(;!this.E()&&G.type!==A.TokenType.And&&G.type!==A.TokenType.Or;){switch(G.type){case A.TokenType.LParen:J++;break;case A.TokenType.RParen:J--;break;case A.TokenType.RegexStr:case A.TokenType.QuotedStr:for(let Ee=0;Ee<G.lexeme.length;Ee++)G.lexeme.charCodeAt(Ee)===R.CharCode.OpenParen?J++:j.lexeme.charCodeAt(Ee)===R.CharCode.CloseParen&&J--}if(J<0)break;W.push(A.$Aj.getLexeme(G)),this.z(),G=this.D()}const ie=W.join(""),ce=ie.lastIndexOf("/"),ge=ce===ie.length-1?void 0:this.w(ie.substring(ce+1));let pe;try{pe=new RegExp(ie.substring(1,ce),ge)}catch{throw this.B("REGEX",j)}return i.regex(Y,pe)}case A.TokenType.QuotedStr:{const W=j.lexeme;this.z();let G=null;if(!(0,C.$cf)(W)){const J=W.indexOf("/"),ie=W.lastIndexOf("/");if(J!==ie&&J>=0){const ce=W.slice(J+1,ie),ge=W[ie+1]==="i"?"i":"";try{G=new RegExp(ce,ge)}catch{throw this.B("REGEX",j)}}}if(G===null)throw this.B("REGEX",j);return x.create(Y,G)}default:throw this.B("REGEX",this.D())}}if(this.y(A.TokenType.Not)){this.A(A.TokenType.In,E);const j=this.u();return i.notIn(Y,j)}switch(this.D().type){case A.TokenType.Eq:{this.z();const j=this.u();if(this.x().type===A.TokenType.QuotedStr)return i.equals(Y,j);switch(j){case"true":return i.has(Y);case"false":return i.not(Y);default:return i.equals(Y,j)}}case A.TokenType.NotEq:{this.z();const j=this.u();if(this.x().type===A.TokenType.QuotedStr)return i.notEquals(Y,j);switch(j){case"true":return i.not(Y);case"false":return i.has(Y);default:return i.notEquals(Y,j)}}case A.TokenType.Lt:return this.z(),K.create(Y,this.u());case A.TokenType.LtEq:return this.z(),V.create(Y,this.u());case A.TokenType.Gt:return this.z(),F.create(Y,this.u());case A.TokenType.GtEq:return this.z(),M.create(Y,this.u());case A.TokenType.In:return this.z(),i.in(Y,this.u());default:return i.has(Y)}}case A.TokenType.EOF:throw this.h.push({message:p,offset:D.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const D=this.D();switch(D.type){case A.TokenType.Str:case A.TokenType.QuotedStr:return this.z(),D.lexeme;case A.TokenType.True:return this.z(),"true";case A.TokenType.False:return this.z(),"false";case A.TokenType.In:return this.z(),"in";default:return""}}w(D){return D.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(D){return this.C(D)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(D,Y){if(this.C(D))return this.z();throw this.B(Y,this.D())}B(D,Y,oe){const j=(0,k.localize)(11607,null,D,A.$Aj.getLexeme(Y)),W=Y.offset,G=A.$Aj.getLexeme(Y);return this.h.push({message:j,offset:W,lexeme:G,additionalInfo:oe}),h.c}C(D){return this.D().type===D}D(){return this.f[this.g]}E(){return this.D().type===A.TokenType.EOF}}e.$Cj=h;class i{static false(){return r.INSTANCE}static true(){return o.INSTANCE}static has(D){return u.create(D)}static equals(D,Y){return y.create(D,Y)}static notEquals(D,Y){return v.create(D,Y)}static regex(D,Y){return x.create(D,Y)}static in(D,Y){return N.create(D,Y)}static notIn(D,Y){return S.create(D,Y)}static not(D){return L.create(D)}static and(...D){return B.create(D,null,!0)}static or(...D){return z.create(D,null,!0)}static greater(D,Y){return F.create(D,Y)}static greaterEquals(D,Y){return M.create(D,Y)}static smaller(D,Y){return K.create(D,Y)}static smallerEquals(D,Y){return V.create(D,Y)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(D){return D==null?void 0:this.c.parse(D)}}e.$Dj=i;function n(q){const D=new h({regexParsingWithErrorRecovery:!1});return q.map(Y=>(D.parse(Y),D.lexingErrors.length>0?D.lexingErrors.map(oe=>({errorMessage:oe.additionalInfo?(0,k.localize)(11608,null,oe.additionalInfo):(0,k.localize)(11609,null),offset:oe.offset,length:oe.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(oe=>({errorMessage:oe.additionalInfo?`${oe.message}. ${oe.additionalInfo}`:oe.message,offset:oe.offset,length:oe.lexeme.length})):[]))}function t(q,D){const Y=q?q.substituteConstants():void 0,oe=D?D.substituteConstants():void 0;return!Y&&!oe?!0:!Y||!oe?!1:Y.equals(oe)}function s(q,D){return q.cmp(D)}class r{static{this.INSTANCE=new r}constructor(){this.type=d.False}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return o.INSTANCE}}e.$Gj=r;class o{static{this.INSTANCE=new o}constructor(){this.type=d.True}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return r.INSTANCE}}e.$Hj=o;class u{static create(D,Y=null){const oe=b.get(D);return typeof oe=="boolean"?oe?o.INSTANCE:r.INSTANCE:new u(D,Y)}constructor(D,Y){this.key=D,this.c=Y,this.type=d.Defined}cmp(D){return D.type!==this.type?this.type-D.type:ne(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=b.get(this.key);return typeof D=="boolean"?D?o.INSTANCE:r.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Ij=u;class y{static create(D,Y,oe=null){if(typeof Y=="boolean")return Y?u.create(D,oe):L.create(D,oe);const j=b.get(D);return typeof j=="boolean"?Y===(j?"true":"false")?o.INSTANCE:r.INSTANCE:new y(D,Y,oe)}constructor(D,Y,oe){this.c=D,this.d=Y,this.f=oe,this.type=d.Equals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=b.get(this.c);if(typeof D=="boolean"){const Y=D?"true":"false";return this.d===Y?o.INSTANCE:r.INSTANCE}return this}evaluate(D){return D.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(D){return D.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Jj=y;class N{static create(D,Y){return new N(D,Y)}constructor(D,Y){this.d=D,this.f=Y,this.type=d.In,this.c=null}cmp(D){return D.type!==this.type?this.type-D.type:le(this.d,this.f,D.d,D.f)}equals(D){return D.type===this.type?this.d===D.d&&this.f===D.f:!1}substituteConstants(){return this}evaluate(D){const Y=D.getValue(this.f),oe=D.getValue(this.d);return Array.isArray(Y)?Y.includes(oe):typeof oe=="string"&&typeof Y=="object"&&Y!==null?$.call(Y,oe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(D){return D.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$Kj=N;class S{static create(D,Y){return new S(D,Y)}constructor(D,Y){this.d=D,this.f=Y,this.type=d.NotIn,this.c=N.create(D,Y)}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(D){return D.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Lj=S;class v{static create(D,Y,oe=null){if(typeof Y=="boolean")return Y?L.create(D,oe):u.create(D,oe);const j=b.get(D);return typeof j=="boolean"?Y===(j?"true":"false")?r.INSTANCE:o.INSTANCE:new v(D,Y,oe)}constructor(D,Y,oe){this.c=D,this.d=Y,this.f=oe,this.type=d.NotEquals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=b.get(this.c);if(typeof D=="boolean"){const Y=D?"true":"false";return this.d===Y?r.INSTANCE:o.INSTANCE}return this}evaluate(D){return D.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(D){return D.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Mj=v;class L{static create(D,Y=null){const oe=b.get(D);return typeof oe=="boolean"?oe?r.INSTANCE:o.INSTANCE:new L(D,Y)}constructor(D,Y){this.c=D,this.d=Y,this.type=d.Not}cmp(D){return D.type!==this.type?this.type-D.type:ne(this.c,D.c)}equals(D){return D.type===this.type?this.c===D.c:!1}substituteConstants(){const D=b.get(this.c);return typeof D=="boolean"?D?r.INSTANCE:o.INSTANCE:this}evaluate(D){return!D.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(D){return D.mapNot(this.c)}negate(){return this.d||(this.d=u.create(this.c,this)),this.d}}e.$Nj=L;function U(q,D){if(typeof q=="string"){const Y=parseFloat(q);isNaN(Y)||(q=Y)}return typeof q=="string"||typeof q=="number"?D(q):r.INSTANCE}class F{static create(D,Y,oe=null){return U(Y,j=>new F(D,j,oe))}constructor(D,Y,oe){this.c=D,this.d=Y,this.f=oe,this.type=d.Greater}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Oj=F;class M{static create(D,Y,oe=null){return U(Y,j=>new M(D,j,oe))}constructor(D,Y,oe){this.c=D,this.d=Y,this.f=oe,this.type=d.GreaterEquals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Pj=M;class K{static create(D,Y,oe=null){return U(Y,j=>new K(D,j,oe))}constructor(D,Y,oe){this.c=D,this.d=Y,this.f=oe,this.type=d.Smaller}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Qj=K;class V{static create(D,Y,oe=null){return U(Y,j=>new V(D,j,oe))}constructor(D,Y,oe){this.c=D,this.d=Y,this.f=oe,this.type=d.SmallerEquals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Rj=V;class x{static create(D,Y){return new x(D,Y)}constructor(D,Y){this.d=D,this.f=Y,this.type=d.Regex,this.c=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.d<D.d)return-1;if(this.d>D.d)return 1;const Y=this.f?this.f.source:"",oe=D.f?D.f.source:"";return Y<oe?-1:Y>oe?1:0}equals(D){if(D.type===this.type){const Y=this.f?this.f.source:"",oe=D.f?D.f.source:"";return this.d===D.d&&Y===oe}return!1}substituteConstants(){return this}evaluate(D){const Y=D.getValue(this.d);return this.f?this.f.test(Y):!1}serialize(){const D=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${D}`}keys(){return[this.d]}map(D){return D.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=H.create(this)),this.c}}e.$Sj=x;class H{static create(D){return new H(D)}constructor(D){this.c=D,this.type=d.NotRegex}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(D){return new H(this.c.map(D))}negate(){return this.c}}e.$Tj=H;function te(q){let D=null;for(let Y=0,oe=q.length;Y<oe;Y++){const j=q[Y].substituteConstants();if(q[Y]!==j&&D===null){D=[];for(let W=0;W<Y;W++)D[W]=q[W]}D!==null&&(D[Y]=j)}return D===null?q:D}class B{static create(D,Y,oe){return B.d(D,Y,oe)}constructor(D,Y){this.expr=D,this.c=Y,this.type=d.And}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let Y=0,oe=this.expr.length;Y<oe;Y++){const j=s(this.expr[Y],D.expr[Y]);if(j!==0)return j}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let Y=0,oe=this.expr.length;Y<oe;Y++)if(!this.expr[Y].equals(D.expr[Y]))return!1;return!0}return!1}substituteConstants(){const D=te(this.expr);return D===this.expr?this:B.create(D,this.c,!1)}evaluate(D){for(let Y=0,oe=this.expr.length;Y<oe;Y++)if(!this.expr[Y].evaluate(D))return!1;return!0}static d(D,Y,oe){const j=[];let W=!1;for(const G of D)if(G){if(G.type===d.True){W=!0;continue}if(G.type===d.False)return r.INSTANCE;if(G.type===d.And){j.push(...G.expr);continue}j.push(G)}if(j.length===0&&W)return o.INSTANCE;if(j.length!==0){if(j.length===1)return j[0];j.sort(s);for(let G=1;G<j.length;G++)j[G-1].equals(j[G])&&(j.splice(G,1),G--);if(j.length===1)return j[0];for(;j.length>1;){const G=j[j.length-1];if(G.type!==d.Or)break;j.pop();const J=j.pop(),ie=j.length===0,ce=z.create(G.expr.map(ge=>B.create([ge,J],null,oe)),null,ie);ce&&(j.push(ce),j.sort(s))}if(j.length===1)return j[0];if(oe){for(let G=0;G<j.length;G++)for(let J=G+1;J<j.length;J++)if(j[G].negate().equals(j[J]))return r.INSTANCE;if(j.length===1)return j[0]}return new B(j,Y)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const Y of this.expr)D.push(...Y.keys());return D}map(D){return new B(this.expr.map(Y=>Y.map(D)),null)}negate(){if(!this.c){const D=[];for(const Y of this.expr)D.push(Y.negate());this.c=z.create(D,this,!0)}return this.c}}e.$Uj=B;class z{static create(D,Y,oe){return z.d(D,Y,oe)}constructor(D,Y){this.expr=D,this.c=Y,this.type=d.Or}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let Y=0,oe=this.expr.length;Y<oe;Y++){const j=s(this.expr[Y],D.expr[Y]);if(j!==0)return j}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let Y=0,oe=this.expr.length;Y<oe;Y++)if(!this.expr[Y].equals(D.expr[Y]))return!1;return!0}return!1}substituteConstants(){const D=te(this.expr);return D===this.expr?this:z.create(D,this.c,!1)}evaluate(D){for(let Y=0,oe=this.expr.length;Y<oe;Y++)if(this.expr[Y].evaluate(D))return!0;return!1}static d(D,Y,oe){let j=[],W=!1;if(D){for(let G=0,J=D.length;G<J;G++){const ie=D[G];if(ie){if(ie.type===d.False){W=!0;continue}if(ie.type===d.True)return o.INSTANCE;if(ie.type===d.Or){j=j.concat(ie.expr);continue}j.push(ie)}}if(j.length===0&&W)return r.INSTANCE;j.sort(s)}if(j.length!==0){if(j.length===1)return j[0];for(let G=1;G<j.length;G++)j[G-1].equals(j[G])&&(j.splice(G,1),G--);if(j.length===1)return j[0];if(oe){for(let G=0;G<j.length;G++)for(let J=G+1;J<j.length;J++)if(j[G].negate().equals(j[J]))return o.INSTANCE;if(j.length===1)return j[0]}return new z(j,Y)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const Y of this.expr)D.push(...Y.keys());return D}map(D){return new z(this.expr.map(Y=>Y.map(D)),null)}negate(){if(!this.c){const D=[];for(const Y of this.expr)D.push(Y.negate());for(;D.length>1;){const Y=D.shift(),oe=D.shift(),j=[];for(const W of X(Y))for(const G of X(oe))j.push(B.create([W,G],null,!1));D.unshift(z.create(j,null,!1))}this.c=z.create(D,this,!0)}return this.c}}e.$Vj=z;class _ extends u{static{this.d=[]}static all(){return _.d.values()}constructor(D,Y,oe){super(D,null),this.f=Y,typeof oe=="object"?_.d.push({...oe,key:D}):oe!==!0&&_.d.push({key:D,description:oe,type:Y!=null?typeof Y:void 0})}bindTo(D){return D.createKey(this.key,this.f)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return y.create(this.key,D)}notEqualsTo(D){return v.create(this.key,D)}}e.$Wj=_,e.$Xj=(0,T.$Fi)("contextKeyService");function ne(q,D){return q<D?-1:q>D?1:0}function le(q,D,Y,oe){return q<Y?-1:q>Y?1:D<oe?-1:D>oe?1:0}function ee(q,D){if(q.type===d.False||D.type===d.True)return!0;if(q.type===d.Or)return D.type===d.Or?Q(q.expr,D.expr):!1;if(D.type===d.Or){for(const Y of D.expr)if(ee(q,Y))return!0;return!1}if(q.type===d.And){if(D.type===d.And)return Q(D.expr,q.expr);for(const Y of q.expr)if(ee(Y,D))return!0;return!1}return q.equals(D)}function Q(q,D){let Y=0,oe=0;for(;Y<q.length&&oe<D.length;){const j=q[Y].cmp(D[oe]);if(j<0)return!1;j===0&&Y++,oe++}return Y===q.length}function X(q){return q.type===d.Or?q.expr:[q]}}),define(he[97],ue([0,1,4]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Tm=e.ID=void 0,e.$Um=a,e.ID="diagnosticsService",e.$Tm=(0,R.$Fi)(e.ID);function a(A){return!!A.hostName&&!!A.errorMessage}class C{async getPerformanceInfo(T,k){return{}}async getSystemInfo(T,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,k){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.$Vm=C}),define(he[98],ue([0,1,4]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=void 0,e.$2o=(0,R.$Fi)("downloadService")}),define(he[15],ue([0,1,4]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=void 0,e.$Mi=(0,R.$Fi)("environmentService"),e.$Ni=(0,R.$Gi)(e.$Mi)}),define(he[74],ue([0,1,4]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B7b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$A7b=C;var a;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(a||(e.RecommendationSource=a={}));function C(T){switch(T){case a.FILE:return"file";case a.WORKSPACE:return"workspace";case a.EXE:return"exe"}}var A;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.$B7b=(0,R.$Fi)("IExtensionRecommendationNotificationService")}),define(he[7],ue([0,1,51,13,26,12,9,11,4,5,22,53]),function(ae,e,R,a,C,A,T,k,O,b,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Fl=e.FileKind=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.FileOperationResult=e.$xl=e.$wl=e.$vl=e.$tl=e.FileChangeType=e.$sl=e.FileOperation=e.$ml=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$al=void 0,e.$bl=d,e.$cl=E,e.$dl=w,e.$el=P,e.$fl=p,e.$gl=c,e.$hl=h,e.$il=i,e.$jl=n,e.$kl=t,e.$ll=s,e.$nl=u,e.$ol=y,e.$pl=N,e.$ql=S,e.$rl=v,e.$ul=K,e.$Gl=z,e.$Hl=_,e.$Jl=le,e.$al=(0,O.$Fi)("fileService");function d(ee){return ee.create===!0}var g;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(g||(e.FileType=g={}));var l;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var m;(function(ee){ee[ee.UPDATED=2]="UPDATED",ee[ee.ADDED=4]="ADDED",ee[ee.DELETED=8]="DELETED"})(m||(e.FileChangeFilter=m={}));function E(ee){const Q=ee;return!!Q&&typeof Q.onDidChange=="function"}var f;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function w(ee){return!!(ee.capabilities&f.FileReadWrite)}function P(ee){return!!(ee.capabilities&f.FileFolderCopy)}function p(ee){return!!(ee.capabilities&f.FileClone)}function c(ee){return!!(ee.capabilities&f.FileOpenReadWriteClose)}function h(ee){return!!(ee.capabilities&f.FileReadStream)}function i(ee){return w(ee)?!!(ee.capabilities&f.FileAtomicRead):!1}function n(ee){return w(ee)?!!(ee.capabilities&f.FileAtomicWrite):!1}function t(ee){return!!(ee.capabilities&f.FileAtomicDelete)}function s(ee){return!!(ee.capabilities&f.Readonly)}var r;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class o extends Error{static create(Q,X){const q=new o(Q.toString(),X);return N(q,X),q}constructor(Q,X){super(Q),this.code=X}}e.$ml=o;function u(ee,Q){return o.create(ee,Q)}function y(ee){return ee||u((0,k.localize)(11385,null),r.Unknown)}function N(ee,Q){return ee.name=Q?`${Q} (FileSystemError)`:"FileSystemError",ee}function S(ee){if(!ee)return r.Unknown;if(ee instanceof o)return ee.code;const Q=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!Q)return r.Unknown;switch(Q[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}function v(ee){if(ee instanceof V)return ee.fileOperationResult;switch(S(ee)){case r.FileNotFound:return te.FILE_NOT_FOUND;case r.FileIsADirectory:return te.FILE_IS_DIRECTORY;case r.FileNotADirectory:return te.FILE_NOT_DIRECTORY;case r.FileWriteLocked:return te.FILE_WRITE_LOCKED;case r.NoPermissions:return te.FILE_PERMISSION_DENIED;case r.FileExists:return te.FILE_MOVE_CONFLICT;case r.FileTooLarge:return te.FILE_TOO_LARGE;default:return te.FILE_OTHER_ERROR}}var L;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class U{constructor(Q,X,q){this.resource=Q,this.operation=X,this.target=q}isOperation(Q){return this.operation===Q}}e.$sl=U;var F;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class M{static{this.a=null}constructor(Q,X){this.c=X,this.b=void 0,this.d=new $.$T(()=>{const q=R.$Li.forUris(()=>this.c);return q.fill(this.rawAdded.map(D=>[D,!0])),q}),this.f=new $.$T(()=>{const q=R.$Li.forUris(()=>this.c);return q.fill(this.rawUpdated.map(D=>[D,!0])),q}),this.g=new $.$T(()=>{const q=R.$Li.forUris(()=>this.c);return q.fill(this.rawDeleted.map(D=>[D,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of Q){switch(q.type){case F.ADDED:this.rawAdded.push(q.resource);break;case F.UPDATED:this.rawUpdated.push(q.resource);break;case F.DELETED:this.rawDeleted.push(q.resource);break}this.b!==M.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(Q,...X){return this.h(Q,{includeChildren:!1},...X)}affects(Q,...X){return this.h(Q,{includeChildren:!0},...X)}h(Q,X,...q){if(!Q)return!1;const D=q.length>0;return!!((!D||q.includes(F.ADDED))&&(this.d.value.get(Q)||X.includeChildren&&this.d.value.findSuperstr(Q))||(!D||q.includes(F.UPDATED))&&(this.f.value.get(Q)||X.includeChildren&&this.f.value.findSuperstr(Q))||(!D||q.includes(F.DELETED))&&(this.g.value.findSubstr(Q)||X.includeChildren&&this.g.value.findSuperstr(Q)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Q){return this.b===Q}hasCorrelation(){return typeof this.b=="number"}}e.$tl=M;function K(ee,Q,X){return!ee||!Q||ee===Q||Q.length>ee.length?!1:(Q.charAt(Q.length-1)!==a.sep&&(Q+=a.sep),X?(0,C.$Gf)(ee,Q):ee.indexOf(Q)===0)}class V extends Error{constructor(Q,X,q){super(Q),this.fileOperationResult=X,this.options=q}}e.$vl=V;class x extends V{constructor(Q,X,q,D){super(Q,X,D),this.fileOperationResult=X,this.size=q}}e.$wl=x;class H extends V{constructor(Q,X,q){super(Q,te.FILE_NOT_MODIFIED_SINCE,q),this.stat=X}}e.$xl=H;var te;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(te||(e.FileOperationResult=te={})),e.$yl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$zl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Al="files.associations",e.$Bl="files.exclude",e.$Cl="files.readonlyInclude",e.$Dl="files.readonlyExclude",e.$El="files.readonlyFromPermissions";var B;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(B||(e.FileKind=B={})),e.$Fl="";function z(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}async function _(ee,Q){if(!Q.hasProvider(T.URI.from({scheme:ee.scheme})))return new Promise(X=>{const q=Q.onDidChangeFileSystemProviderRegistrations(D=>{D.scheme===ee.scheme&&D.added&&(q.dispose(),X())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(Q){return(0,A.$ig)(Q)||(Q=0),Q<ne.KB?(0,k.localize)(11386,null,Q.toFixed(0)):Q<ne.MB?(0,k.localize)(11387,null,(Q/ne.KB).toFixed(2)):Q<ne.GB?(0,k.localize)(11388,null,(Q/ne.MB).toFixed(2)):Q<ne.TB?(0,k.localize)(11389,null,(Q/ne.GB).toFixed(2)):(0,k.localize)(11390,null,(Q/ne.TB).toFixed(2))}}e.$Il=ne;function le(ee){const Q=typeof ee=="string"||ee?.scheme===I.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===I.Schemas.file?1024*ne.MB:Q?10*ne.MB:b.$p?50*ne.MB:1024*ne.MB}});var Z=this&&this.__param||function(ae,e){return function(R,a){e(R,a,ae)}};define(he[163],ue([0,1,75,50,7]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=void 0;let A=class{constructor(k){this.a=k}async checksum(k){const O=(await this.a.readFileStream(k)).value;return new Promise((b,I)=>{const $=(0,R.createHash)("sha256");(0,a.$Fe)(O,{onData:d=>$.update(d.buffer),onError:d=>I(d),onEnd:()=>b($.digest("base64").replace(/=+$/,""))})})}};e.$jic=A,e.$jic=A=ve([Z(0,C.$al)],A)}),define(he[99],ue([0,1,14,8,11,7]),function(ae,e,R,a,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=T;async function T(I,$,d,g,l,m){let E;try{await k(I,$,d,g,l,m)}catch(f){E=f}finally{E&&l.errorTransformer&&(E=l.errorTransformer(E)),typeof E<"u"&&d.error(E),d.end()}}async function k(I,$,d,g,l,m){O(m);const E=await I.open($,{create:!1});try{O(m);let f=0,w=0,P=l&&typeof l.length=="number"?l.length:void 0,p=R.$Ne.alloc(Math.min(l.bufferSize,typeof P=="number"?P:l.bufferSize)),c=l&&typeof l.position=="number"?l.position:0,h=0;do w=await I.read(E,c,p.buffer,h,p.byteLength-h),c+=w,h+=w,f+=w,typeof P=="number"&&(P-=w),h===p.byteLength&&(await d.write(g(p)),p=R.$Ne.alloc(Math.min(l.bufferSize,typeof P=="number"?P:l.bufferSize)),h=0);while(w>0&&(typeof P!="number"||P>0)&&O(m)&&b(f,l));if(h>0){let i=h;typeof P=="number"&&(i=Math.min(h,P)),d.write(g(p.slice(0,i)))}}catch(f){throw(0,A.$ol)(f)}finally{await I.close(E)}}function O(I){if(I.isCancellationRequested)throw(0,a.$5)();return!0}function b(I,$){if(typeof $?.limits?.size=="number"&&I>$.limits.size)throw(0,A.$nl)((0,C.localize)(11384,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(he[46],ue([0,1,93,2,13,5,9,7]),function(ae,e,R,a,C,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=e.$6q=void 0,e.$4q=O,e.$5q=b,e.$9q=g,e.$0q=l,e.$$q=m,e.$_q=E,e.$ar=w,e.$br=P;function O(p){return typeof p.correlationId=="number"}function b(p){return p.recursive===!0}class I extends a.$Uc{static{this.a=5}constructor(c,h,i,n){super(),this.h=c,this.j=h,this.m=i,this.n=n,this.c=this.B(new a.$Vc),this.f=void 0,this.g=0}s(){const c=new a.$Tc;this.c.value=c,this.b=this.r(c),this.b.setVerboseLogging(this.m),c.add(this.b.onDidChangeFile(h=>this.h(h))),c.add(this.b.onDidLogMessage(h=>this.j(h))),c.add(this.b.onDidError(h=>this.t(h.error,h.request)))}t(c,h){this.u(c,h)?this.g<I.a&&this.f?(this.y(`restarting watcher after unexpected error: ${c}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${c}`):this.y(c)}u(c,h){return!(!this.n.restartOnError||h||c.indexOf("No space left on device")!==-1||c.indexOf("EMFILE")!==-1)}w(c){this.g++,this.s(),this.watch(c)}async watch(c){this.f=c,await this.b?.watch(c)}async setVerboseLogging(c){this.m=c,await this.b?.setVerboseLogging(c)}y(c){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${c}`})}z(c){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${c}`})}dispose(){return this.b=void 0,super.dispose()}}e.$6q=I;class $ extends I{constructor(c,h,i){super(c,h,i,{type:"node.js",restartOnError:!1})}}e.$7q=$;class d extends I{constructor(c,h,i){super(c,h,i,{type:"universal",restartOnError:!0})}}e.$8q=d;function g(p){return p.map(c=>({type:c.type,resource:T.URI.revive(c.resource),cId:c.cId}))}function l(p){const c=new f;for(const h of p)c.processEvent(h);return c.coalesce()}function m(p,c){return typeof c=="string"&&!c.startsWith(R.$wk)&&!(0,C.$ic)(c)?{base:p,pattern:c}:c}function E(p,c){const h=[];for(const i of c)h.push((0,R.$Ak)(m(p,i)));return h}class f{constructor(){this.a=new Set,this.b=new Map}c(c){return A.$l?c.resource.fsPath:c.resource.fsPath.toLowerCase()}processEvent(c){const h=this.b.get(this.c(c));let i=!1;if(h){const n=h.type,t=c.type;h.resource.fsPath!==c.resource.fsPath&&(c.type===k.FileChangeType.DELETED||c.type===k.FileChangeType.ADDED)?i=!0:n===k.FileChangeType.ADDED&&t===k.FileChangeType.DELETED?(this.b.delete(this.c(c)),this.a.delete(h)):n===k.FileChangeType.DELETED&&t===k.FileChangeType.ADDED?h.type=k.FileChangeType.UPDATED:n===k.FileChangeType.ADDED&&t===k.FileChangeType.UPDATED||(h.type=t)}else i=!0;i&&(this.a.add(c),this.b.set(this.c(c),c))}coalesce(){const c=[],h=[];return Array.from(this.a).filter(i=>i.type!==k.FileChangeType.DELETED?(c.push(i),!1):!0).sort((i,n)=>i.resource.fsPath.length-n.resource.fsPath.length).filter(i=>h.some(n=>(0,k.$ul)(i.resource.fsPath,n,!A.$l))?!1:(h.push(i.resource.fsPath),!0)).concat(c)}}function w(p,c){if(typeof c=="number")switch(p.type){case k.FileChangeType.ADDED:return(c&k.FileChangeFilter.ADDED)===0;case k.FileChangeType.DELETED:return(c&k.FileChangeFilter.DELETED)===0;case k.FileChangeType.UPDATED:return(c&k.FileChangeFilter.UPDATED)===0}return!1}function P(p){if(typeof p=="number"){const c=[];return p&k.FileChangeFilter.ADDED&&c.push("Added"),p&k.FileChangeFilter.DELETED&&c.push("Deleted"),p&k.FileChangeFilter.UPDATED&&c.push("Updated"),c.length===0?"<all>":`[${c.join(", ")}]`}return"<none>"}}),define(he[164],ue([0,1,14,43,8,3,2,50,32,7,46]),function(ae,e,R,a,C,A,T,k,O,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tR=e.$sR=void 0,e.$sR="localFilesystem";class $ extends T.$Uc{constructor(g,l){super(),this.a=g,this.b=l,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$le),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$le),this.onDidWatchError=this.g.event,this.h=(0,O.$2g)(),this.j()}get capabilities(){return this.c||(this.c=b.FileSystemProviderCapabilities.FileReadWrite|b.FileSystemProviderCapabilities.FileOpenReadWriteClose|b.FileSystemProviderCapabilities.FileReadStream|b.FileSystemProviderCapabilities.FileFolderCopy|b.FileSystemProviderCapabilities.FileWriteUnlock|b.FileSystemProviderCapabilities.FileAtomicRead|b.FileSystemProviderCapabilities.FileAtomicWrite|b.FileSystemProviderCapabilities.FileAtomicDelete|b.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=b.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=b.FileSystemProviderCapabilities.Trash)),this.c}stat(g){return this.a.call("stat",[g])}readdir(g){return this.a.call("readdir",[g])}async readFile(g,l){const{buffer:m}=await this.a.call("readFile",[g,l]);return m}readFileStream(g,l,m){const E=(0,k.$Be)(w=>R.$Ne.concat(w.map(P=>R.$Ne.wrap(P))).buffer),f=new T.$Tc;return f.add(this.a.listen("readFileStream",[g,l])(w=>{if(w instanceof R.$Ne)E.write(w.buffer);else{if(w==="end")E.end();else{let P;if(w instanceof Error)P=w;else{const p=w;P=(0,b.$nl)(p.message??(0,a.$qj)(p),p.code??b.FileSystemProviderErrorCode.Unknown)}E.error(P),E.end()}f.dispose()}})),f.add(m.onCancellationRequested(()=>{E.error((0,C.$5)()),E.end(),f.dispose()})),E}writeFile(g,l,m){return this.a.call("writeFile",[g,R.$Ne.wrap(l),m])}open(g,l){return this.a.call("open",[g,l])}close(g){return this.a.call("close",[g])}async read(g,l,m,E,f){const[w,P]=await this.a.call("read",[g,l,f]);return m.set(w.buffer.slice(0,P),E),P}write(g,l,m,E,f){return this.a.call("write",[g,l,R.$Ne.wrap(m),E,f])}mkdir(g){return this.a.call("mkdir",[g])}delete(g,l){return this.a.call("delete",[g,l])}rename(g,l,m){return this.a.call("rename",[g,l,m])}copy(g,l,m){return this.a.call("copy",[g,l,m])}cloneFile(g,l){return this.a.call("cloneFile",[g,l])}j(){this.B(this.a.listen("fileChange",[this.h])(g=>{if(Array.isArray(g)){const l=g;this.f.fire((0,I.$9q)(l))}else{const l=g;this.g.fire(l)}}))}watch(g,l){const m=(0,O.$2g)();return this.a.call("watch",[this.h,m,g,l]),(0,T.$Sc)(()=>this.a.call("unwatch",[this.h,m]))}}e.$tR=$}),define(he[165],ue([0,1,33,2,46,3,7,9,6]),function(ae,e,R,a,C,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class b extends a.$Uc{constructor(){super(),this.a=this.B(new A.$le),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$le),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$le),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new a.$4c),this.m=new Set,this.n=this.B(new O.$Dh(this.y())),this.r=5007,this.s=new O.$3h,this.R=!1,this.B(this.f($=>this.t($)))}t($){this.u($)&&this.z($)}u($){return(0,C.$4q)($)}async watch($){this.s.isSettled||this.s.complete(),this.s=new O.$3h;try{this.h.clear(),this.g.clear();for(const d of $)this.u(d)?this.h.set(d.correlationId,d):this.g.add(d);for(const[d]of this.j)this.h.has(d)||(this.j.deleteAndDispose(d),this.m.delete(d));return await this.w(!1)}finally{this.s.complete()}}w($){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(d=>!this.j.has(d.correlationId))]),$?this.y():0)}y(){return 800}isSuspended($){return typeof $.correlationId!="number"?!1:this.m.has($.correlationId)?"polling":this.j.has($.correlationId)}async z($){if(this.j.has($.correlationId))return;const d=new a.$Tc;this.j.set($.correlationId,d),await this.s.p,!d.isDisposed&&(this.D($,d),this.w(!0))}C($){this.j.deleteAndDispose($.correlationId),this.m.delete($.correlationId),this.w(!1)}D($,d){this.F($,d)?(this.P(`reusing an existing recursive watcher to monitor ${$.path}`),this.m.delete($.correlationId)):(this.G($,d),this.m.add($.correlationId))}F($,d){const g=this.O?.subscribe($.path,(l,m)=>{d.isDisposed||(l?this.D($,d):m?.type===T.FileChangeType.ADDED&&this.H($))});return g?(d.add(g),!0):!1}G($,d){let g=!1;const l=(m,E)=>{if(d.isDisposed)return;const f=this.I(m),w=this.I(E),P=g;g=f,!f&&(w||P)&&this.H($)};this.P(`starting fs.watchFile() on ${$.path} (correlationId: ${$.correlationId})`);try{(0,R.watchFile)($.path,{persistent:!1,interval:this.r},l)}catch(m){this.Q(`fs.watchFile() failed with error ${m} on path ${$.path} (correlationId: ${$.correlationId})`)}d.add((0,a.$Sc)(()=>{this.P(`stopping fs.watchFile() on ${$.path} (correlationId: ${$.correlationId})`);try{(0,R.unwatchFile)($.path,l)}catch(m){this.Q(`fs.unwatchFile() failed with error ${m} on path ${$.path} (correlationId: ${$.correlationId})`)}}))}H($){this.P(`detected ${$.path} exists again, resuming watcher (correlationId: ${$.correlationId})`);const d={resource:k.URI.file($.path),type:T.FileChangeType.ADDED,cId:$.correlationId};this.a.fire([d]),this.J(d,$),this.C($)}I($){return $.ctimeMs===0&&$.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J($,d){if(this.R){const g=` >> normalized ${$.type===T.FileChangeType.ADDED?"[ADDED]":$.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${$.resource.fsPath}`;this.L(g,d)}}L($,d){this.R&&this.P(`${$}${typeof d.correlationId=="number"?` <${d.correlationId}> `:""}`)}M($){return`${$.path} (excludes: ${$.excludes.length>0?$.excludes:"<none>"}, includes: ${$.includes&&$.includes.length>0?JSON.stringify($.includes):"<all>"}, filter: ${(0,C.$br)($.filter)}, correlationId: ${typeof $.correlationId=="number"?$.correlationId:"<none>"})`}async setVerboseLogging($){this.R=$}}e.$kr=b}),define(he[166],ue([0,1,33,6,25,41,2,90,13,5,20,9,146,30,7,46]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0,e.$qr=f;class E extends T.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(P,p,c,h,i,n){super(),this.s=P,this.t=p,this.u=c,this.w=h,this.y=i,this.z=n,this.c=this.B(new a.$Uh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.u(t))),this.f=this.B(new a.$Th(t=>this.M(t),E.b)),this.g=(0,m.$_q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,m.$_q)(this.s.path,this.s.includes):void 0,this.j=(0,m.$4q)(this.s)?this.s.filter:void 0,this.m=new C.$we,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const P=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const p=await R.promises.stat(P);if(this.m.token.isCancellationRequested)return;this.B(await this.G(P,p.isDirectory()))}catch(P){P.code!=="ENOENT"?this.O(P):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${P})`),this.D()}}D(){this.r=!0,this.w?.()}async F(P){let p=P.path;try{p=await g.Promises.realpath(P.path),P.path===p&&(p=await(0,d.$mr)(P.path,this.m.token)??P.path),P.path!==p&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${P.path}, real: ${p})`)}catch{}return p}async G(P,p){const c=new T.$Tc;return this.H(P,p,c)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(P,p,c)),c}H(P,p,c){if(p)return!1;const h=$.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(n,t)=>{if(!c.isDisposed)if(n){const s=await this.G(P,p);c.isDisposed?s.dispose():c.add(s)}else t&&(typeof t.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:h,type:t.type,cId:this.s.correlationId},!0)});return i?(c.add(i),!0):!1}async I(P,p,c){if(b.$k&&(0,A.$Eg)(P,"/Volumes/",!0)){this.O(`Refusing to watch ${P} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const h=new C.$we(this.m.token);c.add((0,T.$Sc)(()=>h.dispose(!0)));const i=new T.$Tc;c.add(i);try{const n=$.URI.file(this.s.path),t=(0,O.$nc)(P),s=(0,R.watch)(P);i.add((0,T.$Sc)(()=>{s.removeAllListeners(),s.close()})),this.Q(`Started watching: '${P}'`);const r=new Set;if(p)try{for(const u of await g.Promises.readdir(P))r.add(u)}catch(u){this.O(u)}if(h.token.isCancellationRequested)return;const o=new Map;i.add((0,T.$Sc)(()=>{for(const[,u]of o)u.dispose();o.clear()})),s.on("error",(u,y)=>{h.token.isCancellationRequested||(this.O(`Failed to watch ${P} for changes using fs.watch() (${u}, ${y})`),this.D())}),s.on("change",(u,y)=>{if(h.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${u}"] ${y}`);let N="";if(y&&(N=y.toString(),b.$k&&(N=(0,k.$nm)(N))),!(!N||u!=="change"&&u!=="rename"))if(p)if(u==="rename"){o.get(N)?.dispose();const S=setTimeout(async()=>{if(o.delete(N),N===t&&!await g.Promises.exists(P)){this.J(n);return}if(h.token.isCancellationRequested)return;const v=await this.N((0,O.$jc)(P,N));if(h.token.isCancellationRequested)return;let L;v?r.has(N)?L=l.FileChangeType.UPDATED:(L=l.FileChangeType.ADDED,r.add(N)):(r.delete(N),L=l.FileChangeType.DELETED),this.L({resource:(0,I.$gh)(n,N),type:L,cId:this.s.correlationId})},E.a);o.set(N,(0,T.$Sc)(()=>clearTimeout(S)))}else{let S;r.has(N)?S=l.FileChangeType.UPDATED:(S=l.FileChangeType.ADDED,r.add(N)),this.L({resource:(0,I.$gh)(n,N),type:S,cId:this.s.correlationId})}else if(u==="rename"||N!==t){const S=setTimeout(async()=>{const v=await g.Promises.exists(P);h.token.isCancellationRequested||(v?(this.L({resource:n,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(P,!1))):this.J(n))},E.a);i.clear(),i.add((0,T.$Sc)(()=>clearTimeout(S)))}else this.L({resource:n,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(n){h.token.isCancellationRequested||this.O(`Failed to watch ${P} for changes using fs.watch() (${n.toString()})`),this.D()}}J(P){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:P,type:l.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(P,p=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${P.type===l.FileChangeType.ADDED?"[ADDED]":P.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${P.resource.fsPath}`),!p&&this.g.some(c=>c(P.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${P.resource.fsPath}`):!p&&this.h&&this.h.length>0&&!this.h.some(c=>c(P.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${P.resource.fsPath}`):this.f.work(P))}M(P){const p=(0,m.$0q)(P),c=[];for(const i of p){if((0,m.$ar)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}c.push(i)}if(c.length===0)return;if(this.z)for(const i of c)this.R(` >> normalized ${i.type===l.FileChangeType.ADDED?"[ADDED]":i.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(c)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(P){if(b.$l)return g.Promises.exists(P);try{const p=(0,O.$nc)(P);return(await g.Promises.readdir((0,O.$mc)(P))).some(h=>h===p)}catch(p){return this.Q(p),!1}}setVerboseLogging(P){this.z=P}O(P){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${P}`})}P(P){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${P}`})}Q(P){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${P}`})}R(P){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${P}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$pr=E;async function f(w,P,p,c,h=512){const i=await g.Promises.open(w,"r"),n=Buffer.allocUnsafe(h),t=new C.$we(c);let s,r=!1;const o={path:w,excludes:[],recursive:!1},u=new E(o,void 0,y=>{(async()=>{for(const{type:N}of y)if(N===l.FileChangeType.UPDATED){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:S}=await g.Promises.read(i,n,0,h,null);if(!S||t.token.isCancellationRequested)break;P(n.slice(0,S))}}catch(S){s=new Error(S),t.dispose(!0)}finally{r=!1}}})()});return await u.ready,p(),new Promise((y,N)=>{t.token.onCancellationRequested(async()=>{u.dispose();try{await g.Promises.close(i)}catch(S){s=new Error(S)}s?N(s):y()})})}}),define(he[167],ue([0,1,3,93,165,5,166,41]),function(ae,e,R,a,C,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class O extends C.$kr{constructor(I){super(),this.O=I,this.onDidError=R.Event.None,this.watchers=new Set}async N(I){I=this.Z(I);const $=[],d=new Set(Array.from(this.watchers));for(const g of I){const l=this.W(g);l&&(0,a.$Ek)(l.request.excludes,g.excludes)&&(0,a.$Ek)(l.request.includes,g.includes)?d.delete(l):$.push(g)}$.length&&this.P(`Request to start watching: ${$.map(g=>this.M(g)).join(",")}`),d.size&&this.P(`Request to stop watching: ${Array.from(d).map(g=>this.M(g.request)).join(",")}`);for(const g of d)this.Y(g);for(const g of $)this.X(g)}W(I){for(const $ of this.watchers)if(typeof I.correlationId=="number"||typeof $.request.correlationId=="number"){if($.request.correlationId===I.correlationId)return $}else if((0,k.$Dg)($.request.path,I.path,!A.$l))return $}X(I){const $=new T.$pr(I,this.O,g=>this.a.fire(g),()=>this.c.fire(I),g=>this.b.fire(g),this.R),d={request:I,instance:$};this.watchers.add(d)}async stop(){await super.stop();for(const I of this.watchers)this.Y(I)}Y(I){this.P("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}Z(I){const $=new Map;for(const d of I){const g=A.$l?d.path:d.path.toLowerCase();let l=$.get(d.correlationId);l||(l=new Map,$.set(d.correlationId,l)),l.has(g)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(d)}`),l.set(g,d)}return Array.from($.values()).map(d=>Array.from(d.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const $ of this.watchers)$.instance.setVerboseLogging(I)}P(I,$){this.R&&this.b.fire({type:"trace",message:this.bb(I,$)})}Q(I){this.b.fire({type:"warn",message:this.bb(I)})}bb(I,$){return $?`[File Watcher (node.js)] ${I} (${this.M($.request)})`:`[File Watcher (node.js)] ${I}`}}e.$rr=O}),define(he[168],ue([0,1,46,167]),function(ae,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;class C extends R.$7q{constructor(T,k,O){super(T,k,O),this.s()}r(T){return T.add(new a.$rr(void 0))}}e.$sr=C}),define(he[169],ue([0,1,22,42,95,46]),function(ae,e,R,a,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;class T extends A.$8q{constructor(O,b,I){super(O,b,I),this.s()}r(O){const b=O.add(new C.$ir(R.$Zg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return O.add(b.onDidProcessExit(({code:I,signal:$})=>this.t(`terminated by itself with code ${I}, signal: ${$} (ETERM)`))),a.ProxyChannel.toService((0,a.$mi)(b.getChannel("watcher")))}}e.$jr=T}),define(he[76],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class R{constructor(...C){this.a=new Map;for(const[A,T]of C)this.set(A,T)}set(C,A){const T=this.a.get(C);return this.a.set(C,A),T}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Di=R}),define(he[170],ue([0,1,6,8,2,73,161,4,76,89]),function(ae,e,R,a,C,A,T,k,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=void 0;const I=!1;class $ extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class d{constructor(E=new O.$Di,f=!1,w,P=I){this.i=E,this.j=f,this.k=w,this.l=P,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(k.$Ei,this),this._globalGraph=P?w?._globalGraph??new T.$vr(p=>p):void 0}dispose(){if(!this.f){this.f=!0,(0,C.$Pc)(this.h),this.h.clear();for(const E of this.g)(0,C.$Oc)(E)&&E.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(E,f){this.m();const w=this,P=new class extends d{dispose(){w.h.delete(P),super.dispose()}}(E,this.j,this,this.l);return this.h.add(P),f?.add(P),P}invokeFunction(E,...f){this.m();const w=l.traceInvocation(this.l,E);let P=!1;try{return E({get:c=>{if(P)throw(0,a.$7)("service accessor is only valid during the invocation of its target method");const h=this.s(c,w);if(!h)throw new Error(`[invokeFunction] unknown service '${c}'`);return h}},...f)}finally{P=!0,w.stop()}}createInstance(E,...f){this.m();let w,P;return E instanceof A.$Ci?(w=l.traceCreation(this.l,E.ctor),P=this.o(E.ctor,E.staticArguments.concat(f),w)):(w=l.traceCreation(this.l,E),P=this.o(E,f,w)),w.stop(),P}o(E,f=[],w){const P=k._util.getServiceDependencies(E).sort((h,i)=>h.index-i.index),p=[];for(const h of P){const i=this.s(h.id,w);i||this.y(`[createInstance] ${E.name} depends on UNKNOWN service ${h.id}.`,!1),p.push(i)}const c=P.length>0?P[0].index:f.length;if(f.length!==c){console.trace(`[createInstance] First service dependency of ${E.name} at position ${c+1} conflicts with ${f.length} static arguments`);const h=c-f.length;h>0?f=f.concat(new Array(h)):f=f.slice(0,c)}return Reflect.construct(E,f.concat(p))}q(E,f){if(this.i.get(E)instanceof A.$Ci)this.i.set(E,f);else if(this.k)this.k.q(E,f);else throw new Error("illegalState - setting UNKNOWN service instance")}r(E){const f=this.i.get(E);return!f&&this.k?this.k.r(E):f}s(E,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(E));const w=this.r(E);return w instanceof A.$Ci?this.u(E,w,f.branch(E,!0)):(f.branch(E,!1),w)}u(E,f,w){if(this.t.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this.t.add(E);try{return this.v(E,f,w)}finally{this.t.delete(E)}}v(E,f,w){const P=new T.$vr(i=>i.id.toString());let p=0;const c=[{id:E,desc:f,_trace:w}],h=new Set;for(;c.length;){const i=c.pop();if(!h.has(String(i.id))){if(h.add(String(i.id)),P.lookupOrInsertNode(i),p++>1e3)throw new $(P);for(const n of k._util.getServiceDependencies(i.desc.ctor)){const t=this.r(n.id);if(t||this.y(`[createInstance] ${E} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(n.id)),t instanceof A.$Ci){const s={id:n.id,desc:t,_trace:i._trace.branch(n.id,!0)};P.insertEdge(i,s),c.push(s)}}}}for(;;){const i=P.roots();if(i.length===0){if(!P.isEmpty())throw new $(P);break}for(const{data:n}of i){if(this.r(n.id)instanceof A.$Ci){const s=this.w(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.q(n.id,s)}P.removeNode(n)}}return this.r(E)}w(E,f,w=[],P,p){if(this.i.get(E)instanceof A.$Ci)return this.x(E,f,w,P,p,this.g);if(this.k)return this.k.w(E,f,w,P,p);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}x(E,f,w=[],P,p,c){if(P){const h=new d(void 0,this.j,this,this.l);h.c=String(E);const i=new Map,n=new R.$Yh(()=>{const t=h.o(f,w,p);for(const[s,r]of i){const o=t[s];if(typeof o=="function")for(const u of r)u.disposable=o.apply(t,u.listener)}return i.clear(),c.add(t),t});return new Proxy(Object.create(null),{get(t,s){if(!n.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let u=i.get(s);return u||(u=new b.$5c,i.set(s,u)),(N,S,v)=>{if(n.isInitialized)return n.value[s](N,S,v);{const L={listener:[N,S,v],disposable:void 0},U=u.push(L);return(0,C.$Sc)(()=>{U(),L.disposable?.dispose()})}}}if(s in t)return t[s];const r=n.value;let o=r[s];return typeof o!="function"||(o=o.bind(r),t[s]=o),o},set(t,s,r){return n.value[s]=r,!0},getPrototypeOf(t){return f.prototype}})}else{const h=this.o(f,w,p);return c.add(h),h}}y(E,f){if(f&&console.warn(E),this.j)throw new Error(E)}}e.$wr=d;var g;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(g||(g={}));class l{static{this.all=new Set}static{this.c=new class extends l{constructor(){super(g.None,null)}stop(){}branch(){return this}}}static traceInvocation(E,f){return E?new l(g.Invocation,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):l.c}static traceCreation(E,f){return E?new l(g.Creation,f.name):l.c}static{this.f=0}constructor(E,f){this.type=E,this.name=f,this.g=Date.now(),this.h=[]}branch(E,f){const w=new l(g.Branch,E.toString());return this.h.push([E,f,w]),w}stop(){const E=Date.now()-this.g;l.f+=E;let f=!1;function w(p,c){const h=[],i=new Array(p+1).join("	");for(const[n,t,s]of c.h)if(t&&s){f=!0,h.push(`${i}CREATES -> ${n}`);const r=w(p+1,s);r&&h.push(r)}else h.push(`${i}uses -> ${n}`);return h.join(`
`)}const P=[`${this.type===g.Creation?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${l.f.toFixed(2)}ms)`];(E>2||f)&&l.all.add(P.join(`
`))}}e.$xr=l}),define(he[56],ue([0,1,4]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=e.$Yhc=void 0,e.$Yhc=(0,R.$Fi)("mainProcessService");class a{constructor(A,T){this.a=A,this.b=T}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,T){this.a.registerChannel(A,T)}}e.$Zhc=a}),define(he[10],ue([0,1,11,43,3,55,2,31,5,20,12,9,96,4]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$dk=e.LogLevel=e.$bk=e.$ak=void 0,e.$ck=m,e.log=f,e.$ok=o,e.$pk=u,e.$qk=y,e.$rk=N,R=Oe(R),e.$ak=(0,g.$Fi)("logService"),e.$bk=(0,g.$Fi)("loggerService");function l(){return new Date().toISOString()}function m(S){return(0,I.$ig)(S)}var E;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(E||(e.LogLevel=E={})),e.$dk=E.Info;function f(S,v,L){switch(v){case E.Trace:S.trace(L);break;case E.Debug:S.debug(L);break;case E.Info:S.info(L);break;case E.Warning:S.warn(L);break;case E.Error:S.error(L);break;case E.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function w(S,v=!1){let L="";for(let U=0;U<S.length;U++){let F=S[U];if(F instanceof Error&&(F=(0,a.$qj)(F,v)),typeof F=="object")try{F=JSON.stringify(F)}catch{}L+=(U>0?" ":"")+F}return L}class P extends T.$Uc{constructor(){super(...arguments),this.b=e.$dk,this.c=this.B(new C.$le),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==E.Off&&this.b<=v}}e.$fk=P;class p extends P{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...L){this.f(E.Trace)&&this.g(E.Trace,w([v,...L],!0))}debug(v,...L){this.f(E.Debug)&&this.g(E.Debug,w([v,...L]))}info(v,...L){this.f(E.Info)&&this.g(E.Info,w([v,...L]))}warn(v,...L){this.f(E.Warning)&&this.g(E.Warning,w([v,...L]))}error(v,...L){if(this.f(E.Error))if(v instanceof Error){const U=Array.prototype.slice.call(arguments);U[0]=v.stack,this.g(E.Error,w(U))}else this.g(E.Error,w([v,...L]))}flush(){}}e.$gk=p;class c extends P{constructor(v=e.$dk){super(),this.setLevel(v),this.g=!O.$j}trace(v,...L){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...L):console.log(`[main ${l()}]`,v,...L))}debug(v,...L){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...L):console.log(`[main ${l()}]`,v,...L))}info(v,...L){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...L):console.log(`[main ${l()}]`,v,...L))}warn(v,...L){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,v,...L):console.warn(`[main ${l()}]`,v,...L))}error(v,...L){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,v,...L):console.error(`[main ${l()}]`,v,...L))}flush(){}}e.$hk=c;class h extends P{constructor(v=e.$dk,L=!0){super(),this.g=L,this.setLevel(v)}trace(v,...L){this.f(E.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...L):console.log(v,...L))}debug(v,...L){this.f(E.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...L):console.log(v,...L))}info(v,...L){this.f(E.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...L):console.log(v,...L))}warn(v,...L){this.f(E.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...L):console.log(v,...L))}error(v,...L){this.f(E.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...L):console.error(v,...L))}flush(){}}e.$ik=h;class i extends P{constructor(v,L=e.$dk){super(),this.g=v,this.setLevel(L)}trace(v,...L){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(v),...L])}debug(v,...L){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(v),...L])}info(v,...L){this.f(E.Info)&&this.g.log(E.Info,[this.h(v),...L])}warn(v,...L){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(v),...L])}error(v,...L){this.f(E.Error)&&this.g.log(E.Error,[this.h(v),...L])}h(v){return typeof v=="string"?v:(0,a.$qj)(v,this.f(E.Trace))}flush(){}}e.$jk=i;class n extends P{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const L of this.g)L.setLevel(v);super.setLevel(v)}trace(v,...L){for(const U of this.g)U.trace(v,...L)}debug(v,...L){for(const U of this.g)U.debug(v,...L)}info(v,...L){for(const U of this.g)U.info(v,...L)}warn(v,...L){for(const U of this.g)U.warn(v,...L)}error(v,...L){for(const U of this.g)U.error(v,...L)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$kk=n;class t extends T.$Uc{constructor(v,L,U){if(super(),this.h=v,this.j=L,this.b=new k.$Ac,this.c=this.B(new C.$le),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$le),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$le),this.onDidChangeVisibility=this.g.event,U)for(const F of U)this.b.set(F.resource,{logger:void 0,info:F})}m(v){return(0,I.$eg)(v)?[...this.b.values()].find(L=>L.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,L){const U=this.n(v),F=(0,I.$eg)(v)?v:L?.id??(0,A.$tj)(U.toString()).toString(16);let M=this.b.get(U)?.logger;const K=L?.logLevel==="always"?E.Trace:L?.logLevel;M||(M=this.s(U,K??this.getLogLevel(U)??this.h,{...L,id:F}));const V={logger:M,info:{resource:U,id:F,logLevel:K,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(V.info),this.b.set(U,V),M}n(v){return(0,I.$eg)(v)?(0,b.$gh)(this.j,`${v}.log`):v}setLogLevel(v,L){if($.URI.isUri(v)){const U=v,F=L,M=this.b.get(U);M&&F!==M.info.logLevel&&(M.info.logLevel=F===this.h?void 0:F,M.logger?.setLevel(F),this.b.set(M.info.resource,M),this.f.fire([U,F]))}else{this.h=v;for(const[U,F]of this.b.entries())this.b.get(U)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,L){const U=this.m(v);U&&L!==!U.info.hidden&&(U.info.hidden=!L,this.b.set(U.info.resource,U),this.g.fire([U.info.resource,L]))}getLogLevel(v){let L;return v&&(L=this.b.get(v)?.info.logLevel),L??this.h}registerLogger(v){const L=this.b.get(v.resource);L?L.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const L=this.b.get(v);L&&(L.logger&&L.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$lk=t;class s{constructor(){this.onDidChangeLogLevel=new C.$le().event}setLevel(v){}getLevel(){return E.Info}trace(v,...L){}debug(v,...L){}info(v,...L){}warn(v,...L){}error(v,...L){}critical(v,...L){}dispose(){}flush(){}}e.$mk=s;class r extends s{}e.$nk=r;function o(S){if(S.verbose)return E.Trace;if(typeof S.logLevel=="string"){const v=N(S.logLevel.toLowerCase());if(v!==void 0)return v}return e.$dk}function u(S){switch(S){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}function y(S){switch(S){case E.Trace:return{original:"Trace",value:R.localize(11318,null)};case E.Debug:return{original:"Debug",value:R.localize(11319,null)};case E.Info:return{original:"Info",value:R.localize(11320,null)};case E.Warning:return{original:"Warning",value:R.localize(11321,null)};case E.Error:return{original:"Error",value:R.localize(11322,null)};case E.Off:return{original:"Off",value:R.localize(11323,null)}}}function N(S){switch(S){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.$sk=new d.$Wj("logLevel",u(E.Info))}),define(he[171],ue([0,1,6,8,2,22,13,20,30,15,10]),function(ae,e,R,a,C,A,T,k,O,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gic=void 0;let $=class extends C.$Uc{constructor(g,l){super(),this.a=g,this.b=l,this.B(new R.$Rh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const g=(0,k.$dh)(this.a.logsHome),l=(0,k.$fh)(this.a.logsHome.with({scheme:A.Schemas.file})).fsPath,f=(await O.Promises.readdir(l)).filter(P=>/^\d{8}T\d{6}$/.test(P)).sort().filter(P=>P!==g),w=f.slice(0,Math.max(0,f.length-9));w.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${w.join(", ")}'`),await Promise.all(w.map(P=>O.Promises.rm((0,T.$jc)(l,P)))))}catch(g){(0,a.$Y)(g)}}};e.$gic=$,e.$gic=$=ve([Z(0,b.$Mi),Z(1,I.$ak)],$)}),define(he[172],ue([0,1,17,6,8,3,41,2,13,46,10]),function(ae,e,R,a,C,A,T,k,O,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;class $ extends k.$Uc{constructor(g,l){super(),this.a=g,this.b=l,this.c=this.B(new A.$le),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$le),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new a.$Dh(0)),this.w=[],this.y=this.B(new a.$Dh(0))}watch(g,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(g,l):this.z(g,l)}n(g,l){const m={path:this.J(g),excludes:l.excludes,includes:l.includes,recursive:l.recursive,filter:l.filter,correlationId:l.correlationId},E=(0,R.$Sb)(this.j,m);return this.r(),(0,k.$Sc)(()=>{E(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(g=>(0,C.$Y)(g))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,b.$9q)(l)),l=>this.G(l),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const l of this.j)(0,b.$5q)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const l of this.j)(0,b.$5q)(l)&&g.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(g,l){const m={path:this.J(g),excludes:l.excludes,includes:l.includes,recursive:!1,filter:l.filter,correlationId:l.correlationId},E=(0,R.$Sb)(this.w,m);return this.C(),(0,k.$Sc)(()=>{E(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(g=>(0,C.$Y)(g))}D(){return this.u||(this.u=this.B(this.F(g=>this.c.fire((0,b.$9q)(g)),g=>this.G(g),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)}))),this.u.watch(this.w)}G(g){g.type==="error"&&this.g.fire(g.message),this.H(g)}H(g){this.a[g.type](g.message)}I(g){return(0,O.$hc)(g.fsPath)}J(g){const l=this.I(g);return(0,T.$Hg)(l)}}e.$cr=$}),define(he[173],ue([0,1,17,6,14,25,3,55,63,2,51,22,100,20,50,11,7,99,10,8]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f,w,P){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;let c=class extends b.$Uc{static{p=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new T.$le),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.$le),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.$le),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new T.$le),this.onDidRunOperation=this.r.event,this.X=this.B(new T.$le),this.Y=this.B(new T.$le),this.onDidFilesChange=this.Y.event,this.Z=this.B(new T.$le),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new a.$Oh)}registerProvider(i,n){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${i}`);const t=new b.$Tc;return this.h.set(i,n),this.c.fire({added:!0,scheme:i,provider:n}),t.add(n.onDidChangeFile(s=>{const r=new E.$tl(s,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&t.add(n.onDidWatchError(s=>this.Z.fire(new Error(s)))),t.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:i}))),(0,b.$Sc)(()=>{this.c.fire({added:!1,scheme:i,provider:n}),this.h.delete(i),(0,b.$Pc)(t)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const n=[];this.f.fire({scheme:i,join(t){n.push(t)}}),!this.h.has(i)&&await a.Promises.settled(n)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,n){const t=this.h.get(i.scheme);return!!(t&&t.capabilities&n)}listCapabilities(){return O.Iterable.map(this.h,([i,n])=>({scheme:i,capabilities:n.capabilities}))}async j(i){if(!(0,g.$kh)(i))throw new E.$vl((0,m.localize)(11391,null,this.sb(i)),E.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const n=this.h.get(i.scheme);if(!n){const t=new P.$ab;throw t.message=(0,m.localize)(11392,null,i.toString()),t}return n}async m(i){const n=await this.j(i);if((0,E.$gl)(n)||(0,E.$dl)(n)||(0,E.$hl)(n))return n;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const n=await this.j(i);if((0,E.$gl)(n)||(0,E.$dl)(n))return n;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,n){try{return await this.s(i,n)}catch(t){throw(0,E.$ql)(t)===E.FileSystemProviderErrorCode.FileNotFound?new E.$vl((0,m.localize)(11393,null,this.sb(i)),E.FileOperationResult.FILE_NOT_FOUND):(0,E.$ol)(t)}}async s(i,n){const t=await this.j(i),s=this.S(t),r=n?.resolveTo,o=n?.resolveSingleChildDescendants,u=n?.resolveMetadata,y=await t.stat(i);let N;return this.t(t,i,y,void 0,!!u,(S,v)=>(N||(N=I.$Li.forUris(()=>!s),N.set(i,!0),r&&N.fill(!0,r)),N.get(S.resource)||N.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&o?v===1:!1))}async t(i,n,t,s,r,o){const{providerExtUri:u}=this.R(i),y={resource:n,name:u.basename(n),isFile:(t.type&E.FileType.File)!==0,isDirectory:(t.type&E.FileType.Directory)!==0,isSymbolicLink:(t.type&E.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&E.FilePermission.Readonly)||!!(i.capabilities&E.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&E.FilePermission.Locked),etag:(0,E.$Gl)({mtime:t.mtime,size:t.size}),children:void 0};if(y.isDirectory&&o(y,s)){try{const N=await i.readdir(n),S=await a.Promises.settled(N.map(async([v,L])=>{try{const U=u.joinPath(n,v),F=r?await i.stat(U):{type:L};return await this.t(i,U,F,N.length,r,o)}catch(U){return this.b.trace(U),null}}));y.children=(0,R.$Gb)(S)}catch(N){this.b.trace(N),y.children=[]}return y}return y}async resolveAll(i){return a.Promises.settled(i.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(i){const n=await this.j(i),t=await n.stat(i);return this.t(n,i,t,void 0,!0,()=>!1)}async exists(i){const n=await this.j(i);try{return!!await n.stat(i)}catch{return!1}}async canCreateFile(i,n){try{await this.u(i,n)}catch(t){return t}return!0}async u(i,n){if(!n?.overwrite&&await this.exists(i))throw new E.$vl((0,m.localize)(11394,null,this.sb(i)),E.FileOperationResult.FILE_MODIFIED_SINCE,n)}async createFile(i,n=C.$Ne.fromString(""),t){await this.u(i,t);const s=await this.writeFile(i,n);return this.r.fire(new E.$sl(i,E.FileOperation.CREATE,s)),s}async writeFile(i,n,t){const s=this.qb(await this.n(i),i),{providerExtUri:r}=this.R(s);let o=t;if((0,E.$jl)(s)&&!o?.atomic){const u=s.enforceAtomicWriteFile?.(i);u&&(o={...t,atomic:u})}try{await this.w(s,i,o)||await this.U(s,r.dirname(i));let y;if((0,E.$dl)(s)&&!(n instanceof C.$Ne))if((0,l.$ze)(n)){const N=await(0,l.$Ge)(n,3);N.ended?y=C.$Ne.concat(N.buffer):y=N}else y=(0,l.$De)(n,N=>C.$Ne.concat(N),3);else y=n;!(0,E.$gl)(s)||(0,E.$dl)(s)&&y instanceof C.$Ne||(0,E.$dl)(s)&&(0,E.$jl)(s)&&o?.atomic?await this.hb(s,i,o,y):await this.db(s,i,o,y instanceof C.$Ne?(0,C.$Ye)(y):y),this.r.fire(new E.$sl(i,E.FileOperation.WRITE))}catch(u){throw new E.$vl((0,m.localize)(11395,null,this.sb(i),(0,E.$ol)(u).toString()),(0,E.$rl)(u),o)}return this.resolve(i,{resolveMetadata:!0})}async w(i,n,t){const s=!!t?.unlock;if(s&&!(i.capabilities&E.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,m.localize)(11396,null,this.sb(n)));if(!!t?.atomic){if(!(i.capabilities&E.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,m.localize)(11397,null,this.sb(n)));if(!(i.capabilities&E.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,m.localize)(11398,null,this.sb(n)));if(s)throw new Error((0,m.localize)(11399,null,this.sb(n)))}let o;try{o=await i.stat(n)}catch{return}if(o.type&E.FileType.Directory)throw new E.$vl((0,m.localize)(11400,null,this.sb(n)),E.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.rb(n,o),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==E.$Fl&&typeof o.mtime=="number"&&typeof o.size=="number"&&t.mtime<o.mtime&&t.etag!==(0,E.$Gl)({mtime:t.mtime,size:o.size}))throw new E.$vl((0,m.localize)(11401,null),E.FileOperationResult.FILE_MODIFIED_SINCE,t);return o}async readFile(i,n,t){const s=await this.m(i);return n?.atomic?this.z(s,i,n,t):this.C(s,i,n,t)}async z(i,n,t,s){return new Promise((r,o)=>{this.cb.queueFor(n,async()=>{try{const u=await this.C(i,n,t,s);r(u)}catch(u){o(u)}},this.R(i).providerExtUri)})}async C(i,n,t,s){const r=await this.D(i,n,{...t,preferUnbuffered:!0},s);return{...r,value:await(0,C.$Ze)(r.value)}}async readFileStream(i,n,t){const s=await this.m(i);return this.D(s,i,n,t)}async D(i,n,t,s){const r=new A.$we(s);let o=t;(0,E.$il)(i)&&i.enforceAtomicReadFile?.(n)&&(o={...t,atomic:!0});const u=this.J(n,o).then(N=>N,N=>{throw r.dispose(!0),N});let y;try{return typeof o?.etag=="string"&&o.etag!==E.$Fl&&await u,o?.atomic&&(0,E.$il)(i)||!((0,E.$gl)(i)||(0,E.$hl)(i))||(0,E.$dl)(i)&&o?.preferUnbuffered?y=this.I(i,n,o):(0,E.$hl)(i)?y=this.G(i,n,r.token,o):y=this.H(i,n,r.token,o),y.on("end",()=>r.dispose()),y.on("error",()=>r.dispose()),{...await u,value:y}}catch(N){throw y&&await(0,l.$Ee)(y),this.F(N,n,o)}}F(i,n,t){const s=(0,m.localize)(11402,null,this.sb(n),(0,E.$ol)(i).toString());return i instanceof E.$xl?new E.$xl(s,i.stat,t):i instanceof E.$wl?new E.$wl(s,i.fileOperationResult,i.size,i.options):new E.$vl(s,(0,E.$rl)(i),t)}G(i,n,t,s=Object.create(null)){const r=i.readFileStream(n,s,t);return(0,l.$Ke)(r,{data:o=>o instanceof C.$Ne?o:C.$Ne.wrap(o),error:o=>this.F(o,n,s)},o=>C.$Ne.concat(o))}H(i,n,t,s=Object.create(null)){const r=(0,C.$4e)();return(0,f.$2q)(i,n,r,o=>o,{...s,bufferSize:this.a,errorTransformer:o=>this.F(o,n,s)},t),r}I(i,n,t){const s=(0,l.$Be)(r=>C.$Ne.concat(r));return(async()=>{try{let r;t?.atomic&&(0,E.$il)(i)?r=await i.readFile(n,{atomic:!0}):r=await i.readFile(n),typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.L(n,r.byteLength,t),s.end(C.$Ne.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async J(i,n){const t=await this.resolve(i,{resolveMetadata:!0});if(t.isDirectory)throw new E.$vl((0,m.localize)(11403,null,this.sb(i)),E.FileOperationResult.FILE_IS_DIRECTORY,n);if(typeof n?.etag=="string"&&n.etag!==E.$Fl&&n.etag===t.etag)throw new E.$xl((0,m.localize)(11404,null),t,n);return this.L(i,t.size,n),t}L(i,n,t){if(typeof t?.limits?.size=="number"&&n>t.limits.size)throw new E.$wl((0,m.localize)(11405,null,this.sb(i)),E.FileOperationResult.FILE_TOO_LARGE,n,t)}async canMove(i,n,t){return this.M(i,n,"move",t)}async canCopy(i,n,t){return this.M(i,n,"copy",t)}async M(i,n,t,s){if(i.toString()!==n.toString())try{const r=t==="move"?this.qb(await this.n(i),i):await this.m(i),o=this.qb(await this.n(n),n);await this.Q(r,i,o,n,t,s)}catch(r){return r}return!0}async move(i,n,t){const s=this.qb(await this.n(i),i),r=this.qb(await this.n(n),n),o=await this.N(s,i,r,n,"move",!!t),u=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new E.$sl(i,o==="move"?E.FileOperation.MOVE:E.FileOperation.COPY,u)),u}async copy(i,n,t){const s=await this.m(i),r=this.qb(await this.n(n),n),o=await this.N(s,i,r,n,"copy",!!t),u=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new E.$sl(i,o==="copy"?E.FileOperation.COPY:E.FileOperation.MOVE,u)),u}async N(i,n,t,s,r,o){if(n.toString()===s.toString())return r;const{exists:u,isSameResourceWithDifferentPathCase:y}=await this.Q(i,n,t,s,r,o);if(u&&!y&&o&&await this.del(s,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(s)),r==="copy"){if(i===t&&(0,E.$el)(i))await i.copy(n,s,{overwrite:o});else{const N=await this.resolve(n);N.isDirectory?await this.P(i,N,t,s):await this.O(i,n,t,s)}return r}else return i===t?(await i.rename(n,s,{overwrite:o}),r):(await this.N(i,n,t,s,"copy",o),await this.del(n,{recursive:!0}),"copy")}async O(i,n,t,s){if((0,E.$gl)(i)&&(0,E.$gl)(t))return this.jb(i,n,t,s);if((0,E.$gl)(i)&&(0,E.$dl)(t))return this.pb(i,n,t,s);if((0,E.$dl)(i)&&(0,E.$gl)(t))return this.nb(i,n,t,s);if((0,E.$dl)(i)&&(0,E.$dl)(t))return this.lb(i,n,t,s)}async P(i,n,t,s){await t.mkdir(s),Array.isArray(n.children)&&await a.Promises.settled(n.children.map(async r=>{const o=this.R(t).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.P(i,await this.resolve(r.resource),t,o):this.O(i,r.resource,t,o)}))}async Q(i,n,t,s,r,o){let u=!1;if(i===t){const{providerExtUri:N,isPathCaseSensitive:S}=this.R(i);if(S||(u=N.isEqual(n,s)),u&&r==="copy")throw new Error((0,m.localize)(11406,null,this.sb(n),this.sb(s)));if(!u&&N.isEqualOrParent(s,n))throw new Error((0,m.localize)(11407,null,this.sb(n),this.sb(s)))}const y=await this.exists(s);if(y&&!u){if(!o)throw new E.$vl((0,m.localize)(11408,null,this.sb(n),this.sb(s)),E.FileOperationResult.FILE_MOVE_CONFLICT);if(i===t){const{providerExtUri:N}=this.R(i);if(N.isEqualOrParent(n,s))throw new Error((0,m.localize)(11409,null,this.sb(n),this.sb(s)))}}return{exists:y,isSameResourceWithDifferentPathCase:u}}R(i){const n=this.S(i);return{providerExtUri:n?g.$9g:g.$$g,isPathCaseSensitive:n}}S(i){return!!(i.capabilities&E.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const n=this.qb(await this.j(i),i);await this.U(n,i);const t=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new E.$sl(i,E.FileOperation.CREATE,t)),t}async U(i,n){const t=[],{providerExtUri:s}=this.R(i);for(;!s.isEqual(n,s.dirname(n));)try{if(!((await i.stat(n)).type&E.FileType.Directory))throw new Error((0,m.localize)(11410,null,this.sb(n)));break}catch(r){if((0,E.$ql)(r)!==E.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(s.basename(n)),n=s.dirname(n)}for(let r=t.length-1;r>=0;r--){n=s.joinPath(n,t[r]);try{await i.mkdir(n)}catch(o){if((0,E.$ql)(o)!==E.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(i,n){try{await this.W(i,n)}catch(t){return t}return!0}async W(i,n){const t=this.qb(await this.j(i),i),s=!!n?.useTrash;if(s&&!(t.capabilities&E.FileSystemProviderCapabilities.Trash))throw new Error((0,m.localize)(11411,null,this.sb(i)));const r=n?.atomic;if(r&&!(t.capabilities&E.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,m.localize)(11412,null,this.sb(i)));if(s&&r)throw new Error((0,m.localize)(11413,null,this.sb(i)));let o;try{o=await t.stat(i)}catch{}if(o)this.rb(i,o);else throw new E.$vl((0,m.localize)(11414,null,this.sb(i)),E.FileOperationResult.FILE_NOT_FOUND);if(!!!n?.recursive){const y=await this.resolve(i);if(y.isDirectory&&Array.isArray(y.children)&&y.children.length>0)throw new Error((0,m.localize)(11415,null,this.sb(i)))}return t}async del(i,n){const t=await this.W(i,n);let s=n;if((0,E.$kl)(t)&&!s?.atomic){const y=t.enforceAtomicDelete?.(i);y&&(s={...n,atomic:y})}const r=!!s?.useTrash,o=!!s?.recursive,u=s?.atomic??!1;await t.delete(i,{recursive:o,useTrash:r,atomic:u}),this.r.fire(new E.$sl(i,E.FileOperation.DELETE))}async cloneFile(i,n){const t=await this.j(i),s=this.qb(await this.n(n),n);if(!(t===s&&this.R(t).providerExtUri.isEqual(i,n)))return t===s&&(0,E.$fl)(t)?t.cloneFile(i,n):(await this.U(s,this.R(s).providerExtUri.dirname(n)),t===s&&(0,E.$el)(t)?this.cb.queueFor(i,()=>t.copy(i,n,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(i,()=>this.O(t,i,s,n),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(i,n){return this.watch(i,{...n,correlationId:p.ab++})}watch(i,n={recursive:!1,excludes:[]}){const t=new b.$Tc;let s=!1,r=()=>{s=!0};t.add((0,b.$Sc)(()=>r())),(async()=>{try{const u=await this.bb(i,n);s?(0,b.$Pc)(u):r=()=>(0,b.$Pc)(u)}catch(u){this.b.error(u)}})();const o=n.correlationId;if(typeof o=="number"){const u=t.add(new T.$le);return t.add(this.X.event(N=>{N.correlates(o)&&u.fire(N)})),{onDidChange:u.event,dispose:()=>t.dispose()}}return t}async bb(i,n){const t=await this.j(i),s=(0,k.$tj)([this.R(t).providerExtUri.getComparisonKey(i),n]);let r=this.$.get(s);return r||(r={count:0,disposable:t.watch(i,n)},this.$.set(s,r)),r.count+=1,(0,b.$Sc)(()=>{r&&(r.count--,r.count===0&&((0,b.$Pc)(r.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,b.$Pc)(i.disposable);this.$.clear()}async db(i,n,t,s){return this.cb.queueFor(n,async()=>{const r=await i.open(n,{create:!0,unlock:t?.unlock??!1});try{(0,l.$ze)(s)||(0,l.$Ae)(s)?await this.eb(i,r,s):await this.fb(i,r,s)}catch(o){throw(0,E.$ol)(o)}finally{await i.close(r)}},this.R(i).providerExtUri)}async eb(i,n,t){let s=0,r;if((0,l.$Ae)(t)){if(t.buffer.length>0){const o=C.$Ne.concat(t.buffer);await this.gb(i,n,o,o.byteLength,s,0),s+=o.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((o,u)=>{(0,l.$Fe)(r,{onData:async y=>{r.pause();try{await this.gb(i,n,y,y.byteLength,s,0)}catch(N){return u(N)}s+=y.byteLength,setTimeout(()=>r.resume())},onError:y=>u(y),onEnd:()=>o()})})}async fb(i,n,t){let s=0,r;for(;(r=t.read())!==null;)await this.gb(i,n,r,r.byteLength,s,0),s+=r.byteLength}async gb(i,n,t,s,r,o){let u=0;for(;u<s;){const y=await i.write(n,r+u,t.buffer,o+u,s-u);u+=y}}async hb(i,n,t,s){return this.cb.queueFor(n,()=>this.ib(i,n,t,s),this.R(i).providerExtUri)}async ib(i,n,t,s){let r;s instanceof C.$Ne?r=s:(0,l.$ze)(s)?r=await(0,C.$Ze)(s):(0,l.$Ae)(s)?r=await(0,C.$1e)(s):r=(0,C.$Xe)(s),await i.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(i,n,t,s){return this.cb.queueFor(s,()=>this.kb(i,n,t,s),this.R(t).providerExtUri)}async kb(i,n,t,s){let r,o;try{r=await i.open(n,{create:!1}),o=await t.open(s,{create:!0,unlock:!1});const u=C.$Ne.alloc(this.a);let y=0,N=0,S=0;do S=await i.read(r,y,u.buffer,N,u.byteLength-N),await this.gb(t,o,u,S,y,N),y+=S,N+=S,N===u.byteLength&&(N=0);while(S>0)}catch(u){throw(0,E.$ol)(u)}finally{await a.Promises.settled([typeof r=="number"?i.close(r):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async lb(i,n,t,s){return this.cb.queueFor(s,()=>this.mb(i,n,t,s),this.R(t).providerExtUri)}async mb(i,n,t,s){return t.writeFile(s,await i.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,n,t,s){return this.cb.queueFor(s,()=>this.ob(i,n,t,s),this.R(t).providerExtUri)}async ob(i,n,t,s){const r=await t.open(s,{create:!0,unlock:!1});try{const o=await i.readFile(n);await this.gb(t,r,C.$Ne.wrap(o),o.byteLength,0,0)}catch(o){throw(0,E.$ol)(o)}finally{await t.close(r)}}async pb(i,n,t,s){const r=await(0,C.$Ze)(this.H(i,n,A.CancellationToken.None));await this.hb(t,s,void 0,r)}qb(i,n){if(i.capabilities&E.FileSystemProviderCapabilities.Readonly)throw new E.$vl((0,m.localize)(11416,null,this.sb(n)),E.FileOperationResult.FILE_PERMISSION_DENIED);return i}rb(i,n){if((n.permissions??0)&E.FilePermission.Readonly)throw new E.$vl((0,m.localize)(11417,null,this.sb(i)),E.FileOperationResult.FILE_PERMISSION_DENIED)}sb(i){return i.scheme===$.Schemas.file?i.fsPath:i.toString(!0)}};e.$3q=c,e.$3q=c=p=ve([Z(0,w.$ak)],c)}),define(he[174],ue([0,1,33,6,31,14,3,41,2,13,5,20,50,30,11,7,99,172,169,168]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=void 0;class p extends f.$cr{static{this.L=!1}constructor(h,i){super(h,i),this.onDidChangeCapabilities=T.Event.None,this.P=new C.$Ac(n=>$.$0g.getComparisonKey(n)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=m.FileSystemProviderCapabilities.FileReadWrite|m.FileSystemProviderCapabilities.FileOpenReadWriteClose|m.FileSystemProviderCapabilities.FileReadStream|m.FileSystemProviderCapabilities.FileFolderCopy|m.FileSystemProviderCapabilities.FileWriteUnlock|m.FileSystemProviderCapabilities.FileAtomicRead|m.FileSystemProviderCapabilities.FileAtomicWrite|m.FileSystemProviderCapabilities.FileAtomicDelete|m.FileSystemProviderCapabilities.FileClone,I.$l&&(this.M|=m.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(h){try{const{stat:i,symbolicLink:n}=await g.SymlinkSupport.stat(this.I(h));return{type:this.O(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:m.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const i=await g.Promises.readdir(this.I(h),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async t=>{try{let s;t.isSymbolicLink()?s=(await this.stat((0,$.$gh)(h,t.name))).type:s=this.O(t),n.push([t.name,s])}catch(s){this.a.trace(s)}})),n}catch(i){throw this.hb(i)}}O(h,i){let n;return i?.dangling?n=m.FileType.Unknown:h.isFile()?n=m.FileType.File:h.isDirectory()?n=m.FileType.Directory:n=m.FileType.Unknown,i&&(n|=m.FileType.SymbolicLink),n}async Q(h){const i=this.I(h);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.P.get(h);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const t=new a.$Eh;return this.P.set(h,t),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,O.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(h)===t&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(h)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),t.open()})}async readFile(h,i){let n;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(h)})`),n=await this.Q(h));const t=this.I(h);return await R.promises.readFile(t)}catch(t){throw this.hb(t)}finally{n?.dispose()}}R(h){p.L&&this.a.trace(h)}readFileStream(h,i,n){const t=(0,d.$Be)(s=>A.$Ne.concat(s.map(r=>A.$Ne.wrap(r))).buffer);return(0,E.$2q)(this,h,t,s=>s.buffer,{...i,bufferSize:256*1024},n),t}async writeFile(h,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.S(h)?this.U(h,(0,$.$gh)((0,$.$fh)(h),`${(0,$.$dh)(h)}${n.atomic.postfix}`),i,n):this.W(h,i,n)}async S(h){try{const i=this.I(h),{symbolicLink:n}=await g.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async U(h,i,n,t){const s=new O.$Tc;try{s.add(await this.Q(h)),s.add(await this.Q(i)),await this.W(i,n,t,!0);try{await this.rename(i,h,{overwrite:!0})}catch(r){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}finally{s.dispose()}}async W(h,i,n,t){let s;try{const r=this.I(h);if(!n.create||!n.overwrite){if(await g.Promises.exists(r)){if(!n.overwrite)throw(0,m.$nl)((0,l.localize)(11375,null),m.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,m.$nl)((0,l.localize)(11376,null),m.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(h,{create:!0,unlock:n.unlock},t),await this.write(s,0,i,0,i.byteLength)}catch(r){throw await this.ib(h,r)}finally{typeof s=="number"&&await this.close(s)}}static{this.$=!0}static configureFlushOnWrite(h){p.$=h}async open(h,i,n){const t=this.I(h);let s;(0,m.$bl)(i)&&!n&&(s=await this.Q(h));let r;try{if((0,m.$bl)(i)&&i.unlock)try{const{stat:u}=await g.SymlinkSupport.stat(t);u.mode&128||await R.promises.chmod(t,u.mode|128)}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}let o;if((0,m.$bl)(i)){if(I.$j)try{await R.promises.truncate(t,0),o="r+"}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}o||(o="w")}else o="r";r=await g.Promises.open(t,o)}catch(o){throw s?.dispose(),(0,m.$bl)(i)?await this.ib(h,o):this.hb(o)}if(this.X.set(r,0),(0,m.$bl)(i)&&this.Z.set(r,h),s){const o=this.Y.get(r);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${r} (${t})`),this.Y.set(r,s),o&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${r} (${t})`),o.dispose())}return r}async close(h){const i=this.Y.get(h);try{if(this.X.delete(h),this.Z.delete(h)&&p.$)try{await g.Promises.fdatasync(h)}catch(n){p.configureFlushOnWrite(!1),this.a.error(n)}return await g.Promises.close(h)}catch(n){throw this.hb(n)}finally{i&&(this.Y.get(h)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.Y.delete(h)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),i.dispose())}}async read(h,i,n,t,s){const r=this.ab(h,i);let o=null;try{o=(await g.Promises.read(h,n,t,s,r)).bytesRead}catch(u){throw this.hb(u)}finally{this.bb(h,r,o)}return o}ab(h,i){return i===this.X.get(h)?null:i}bb(h,i,n){const t=this.X.get(h);typeof t=="number"&&(typeof i=="number"||(typeof n=="number"?this.X.set(h,t+n):this.X.delete(h)))}async write(h,i,n,t,s){return(0,a.$Zh)(()=>this.cb(h,i,n,t,s),100,3)}async cb(h,i,n,t,s){const r=this.ab(h,i);let o=null;try{o=(await g.Promises.write(h,n,t,s,r)).bytesWritten}catch(u){throw await this.ib(this.Z.get(h),u)}finally{this.bb(h,r,o)}return o}async mkdir(h){try{await R.promises.mkdir(this.I(h))}catch(i){throw this.hb(i)}}async delete(h,i){try{const n=this.I(h);if(i.recursive){let t;i?.atomic!==!1&&i.atomic.postfix&&(t=(0,b.$jc)((0,b.$mc)(n),`${(0,b.$nc)(n)}${i.atomic.postfix}`)),await g.Promises.rm(n,g.RimRafMode.MOVE,t)}else try{await R.promises.unlink(n)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let s=!1;try{const{stat:r,symbolicLink:o}=await g.SymlinkSupport.stat(n);s=r.isDirectory()&&!o}catch{}if(s)await R.promises.rmdir(n);else throw t}else throw t}}catch(n){throw this.hb(n)}}async rename(h,i,n){const t=this.I(h),s=this.I(i);if(t!==s)try{await this.db(h,i,"move",n.overwrite),await g.Promises.rename(t,s)}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(11377,null,(0,b.$nc)(t),(0,b.$nc)((0,b.$mc)(s)),r.toString()))),this.hb(r)}}async copy(h,i,n){const t=this.I(h),s=this.I(i);if(t!==s)try{await this.db(h,i,"copy",n.overwrite),await g.Promises.copy(t,s,{preserveSymlinks:!0})}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(11378,null,(0,b.$nc)(t),(0,b.$nc)((0,b.$mc)(s)),r.toString()))),this.hb(r)}}async db(h,i,n,t){const s=this.I(h),r=this.I(i);let o=!1;if(!!(this.capabilities&m.FileSystemProviderCapabilities.PathCaseSensitive)||(o=(0,k.$Dg)(s,r,!0)),o){if(n==="copy")throw(0,m.$nl)((0,l.localize)(11379,null),m.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const y=await this.N(h);if(!y)throw(0,m.$nl)((0,l.localize)(11380,null),m.FileSystemProviderErrorCode.FileNotFound);const N=await this.N(i);if(N){if(!t)throw(0,m.$nl)((0,l.localize)(11381,null),m.FileSystemProviderErrorCode.FileExists);y.type&m.FileType.File&&N.type&m.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,i){return this.eb(h,i,!1)}async eb(h,i,n){const t=this.I(h),s=this.I(i),r=!!(this.capabilities&m.FileSystemProviderCapabilities.PathCaseSensitive);if((0,k.$Dg)(t,s,!r))return;const o=new O.$Tc;try{o.add(await this.Q(h)),o.add(await this.Q(i)),n&&await R.promises.mkdir((0,b.$mc)(s),{recursive:!0}),await R.promises.copyFile(t,s)}catch(u){if(u.code==="ENOENT"&&!n)return this.eb(h,i,!0);throw this.hb(u)}finally{o.dispose()}}t(h,i,n){return new w.$jr(t=>h(t),t=>i(t),n)}F(h,i,n){return new P.$sr(t=>h(t),t=>i(t),n)}hb(h){if(h instanceof m.$ml)return h;let i=h,n;switch(h.code){case"ENOENT":n=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=m.FileSystemProviderErrorCode.Unknown;break;default:n=m.FileSystemProviderErrorCode.Unknown}return(0,m.$nl)(i,n)}async ib(h,i){let n=this.hb(i);if(h&&n.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await g.SymlinkSupport.stat(this.I(h));t.mode&128||(n=(0,m.$nl)(i,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.a.trace(t)}return n}}e.$tr=p}),define(he[101],ue([0,1,3,2,4,10]),function(ae,e,R,a,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=e.$Fic=void 0,e.$Fic=(0,C.$Fi)("sharedProcessLifecycleService");let T=class extends a.$Uc{constructor(O){super(),this.b=O,this.a=this.B(new R.$le),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Gic=T,e.$Gic=T=ve([Z(0,A.$ak)],T)}),define(he[175],ue([0,1,9,3,10,2]),function(ae,e,R,a,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=e.$us=e.$ts=void 0;class T extends C.$lk{constructor($,d,g,l,m){super(d,g,l),this.r=$,this.t=m,this.B(m.listen("onDidChangeLogLevel",$)(E=>{(0,C.$ck)(E)?super.setLogLevel(E):super.setLogLevel(R.URI.revive(E[0]),E[1])})),this.B(m.listen("onDidChangeVisibility",$)(([E,f])=>super.setVisibility(R.URI.revive(E),f))),this.B(m.listen("onDidChangeLoggers",$)(({added:E,removed:f})=>{for(const w of E)super.registerLogger({...w,resource:R.URI.revive(w.resource)});for(const w of f)super.deregisterLogger(w.resource)}))}createConsoleMainLogger(){return new C.$jk({log:($,d)=>{this.t.call("consoleLog",[$,d])}})}registerLogger($){super.registerLogger($),this.t.call("registerLogger",[$,this.r])}deregisterLogger($){super.deregisterLogger($),this.t.call("deregisterLogger",[$,this.r])}setLogLevel($,d){super.setLogLevel($,d),this.t.call("setLogLevel",[$,d])}setVisibility($,d){super.setVisibility($,d),this.t.call("setVisibility",[this.n($),d])}s($,d,g){return new k(this.t,$,d,g,this.r)}static setLogLevel($,d,g){return $.call("setLogLevel",[d,g])}}e.$ts=T;class k extends C.$gk{constructor($,d,g,l,m){super(l?.logLevel==="always"),this.r=$,this.s=d,this.m=!1,this.n=[],this.setLevel(g),this.r.call("createLogger",[d,l,m]).then(()=>{this.u(this.n),this.m=!0})}g($,d){const g=[[$,d]];this.m?this.u(g):this.n.push(...g)}u($){this.r.call("log",[this.s,$])}}class O{constructor($,d){this.a=$,this.b=d}listen($,d){const g=this.b($);switch(d){case"onDidChangeLoggers":return a.Event.map(this.a.onDidChangeLoggers,l=>({added:[...l.added].map(m=>this.c(m,g)),removed:[...l.removed].map(m=>this.c(m,g))}));case"onDidChangeVisibility":return a.Event.map(this.a.onDidChangeVisibility,l=>[g.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return a.Event.map(this.a.onDidChangeLogLevel,l=>(0,C.$ck)(l)?l:[g.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${d}`)}async call($,d,g){const l=this.b($);switch(d){case"setLogLevel":return(0,C.$ck)(g[0])?this.a.setLogLevel(g[0]):this.a.setLogLevel(R.URI.revive(l.transformIncoming(g[0][0])),g[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,l)))}throw new Error(`Call not found: ${d}`)}c($,d){return{...$,resource:d.transformOutgoingURI($.resource)}}}e.$us=O;class b extends A.$Uc{constructor($,d){super(),d.call("setLogLevel",[$.getLogLevel()]),this.B($.onDidChangeLogLevel(g=>d.call("setLogLevel",[g]))),d.call("getRegisteredLoggers").then(g=>{for(const l of g)$.registerLogger({...l,resource:R.URI.revive(l.resource)})}),this.B(d.listen("onDidChangeVisibility")(([g,l])=>$.setVisibility(R.URI.revive(g),l))),this.B(d.listen("onDidChangeLoggers")(({added:g,removed:l})=>{for(const m of g)$.registerLogger({...m,resource:R.URI.revive(m.resource)});for(const m of l)$.deregisterLogger(m.resource)}))}}e.$vs=b}),define(he[176],ue([0,1,2,10]),function(ae,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KR=void 0;class C extends R.$Uc{constructor(T,k=[]){super(),this.a=new a.$kk([T,...k]),this.B(T.onDidChangeLogLevel(O=>this.setLevel(O)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...k){this.a.trace(T,...k)}debug(T,...k){this.a.debug(T,...k)}info(T,...k){this.a.info(T,...k)}warn(T,...k){this.a.warn(T,...k)}error(T,...k){this.a.error(T,...k)}flush(){this.a.flush()}}e.$KR=C}),define(he[57],ue([0,1,4]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=void 0,e.$Ggc=(0,R.$Fi)("nativeHostService")}),define(he[177],ue([0,1,42,56]),function(ae,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=void 0;let C=class{constructor(T,k){return this.windowId=T,R.ProxyChannel.toService(k.getChannel("nativeHost"),{context:T,properties:(()=>{const O=new Map;return O.set("windowId",T),O})()})}};e.$2hc=C,e.$2hc=C=ve([Z(1,a.$Yhc)],C)}),define(he[58],ue([0,1,3,63,2,4]),function(ae,e,R,a,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=e.$to=void 0,e.$to=(0,A.$Fi)("policy");class T extends C.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new R.$le),this.onDidChange=this.h.event}async updatePolicyDefinitions(b){const I=Object.keys(this.f).length;return this.f={...b,...this.f},I!==Object.keys(this.f).length&&await this.j(b),a.Iterable.reduce(this.g.entries(),($,[d,g])=>({...$,[d]:g}),{})}getPolicyValue(b){return this.g.get(b)}serialize(){return a.Iterable.reduce(Object.entries(this.f),(b,[I,$])=>({...b,[I]:{definition:$,value:this.g.get(I)}}),{})}}e.$uo=T;class k{constructor(){this.onDidChange=R.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$vo=k}),define(he[178],ue([0,1,3,2,58]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=e.$shc=void 0;class A{constructor(O){this.b=O,this.a=new a.$Tc}listen(O,b){switch(b){case"onDidChange":return R.Event.map(this.b.onDidChange,I=>I.reduce(($,d)=>({...$,[d]:this.b.getPolicyValue(d)??null}),{}),this.a)}throw new Error(`Event not found: ${b}`)}call(O,b,I){switch(b){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(I)}throw new Error(`Call not found: ${b}`)}dispose(){this.a.dispose()}}e.$shc=A;class T extends C.$uo{constructor(O,b){super(),this.a=b;for(const I in O){const{definition:$,value:d}=O[I];this.f[I]=$,d!==void 0&&this.g.set(I,d)}this.a.listen("onDidChange")(I=>{for(const $ in I){const d=I[$];d===null?this.g.delete($):this.g.set($,d)}this.h.fire(Object.keys(I))})}async j(O){const b=await this.a.call("updatePolicyDefinitions",O);for(const I in b)this.g.set(I,b[I])}}e.$thc=T}),define(he[102],ue([0,1,37]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let a;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.context<"u"){const A=C.context.configuration();if(A)a=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(a=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(a,{nameShort:`${a.nameShort} Dev`,nameLong:`${a.nameLong} Dev`,dataFolderName:`${a.dataFolderName}-dev`,serverDataFolderName:a.serverDataFolderName?`${a.serverDataFolderName}-dev`:void 0}),!a.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(a,{version:A.version})}}else a={},Object.keys(a).length===0&&Object.assign(a,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=a}),define(he[23],ue([0,1,4]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$tk=(0,R.$Fi)("productService"),e.$uk="vscode://schemas/vscode-product"}),define(he[179],ue([0,1,33,6,8,2,13,30,10,23]),function(ae,e,R,a,C,A,T,k,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=void 0,R=Oe(R);let I=class extends A.$Uc{constructor(d,g,l){super(),this.b=g,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,d&&this.B(new a.$Rh(()=>{this.f(d)},3e4)).schedule()}async f(d){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),l=(0,T.$mc)(d),m=(0,T.$nc)(d),E=await k.Promises.readdir(l);await Promise.all(E.map(async f=>{if(f===m)return;const w=(0,T.$jc)(l,f),P=await R.promises.stat(w);if(P.isDirectory()&&g-P.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${f}.`),k.Promises.rm(w)}))}catch(g){(0,C.$Y)(g)}}};e.$dic=I,e.$dic=I=ve([Z(1,b.$tk),Z(2,O.$ak)],I)}),define(he[180],ue([0,1,33,6,8,2,13,30,15,10,23]),function(ae,e,R,a,C,A,T,k,O,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=void 0,R=Oe(R);let $=class extends A.$Uc{constructor(g,l,m){super(),this.b=g,this.c=l,this.f=m,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new a.$Rh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),l=JSON.parse(await R.promises.readFile((0,T.$jc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const P of Object.keys(l)){const p=l[P];g[`${p.hash}.${P}`]=!0}const m=(0,T.$jc)(this.b.userDataPath,"clp");if(!await k.Promises.exists(m))return;const f=await k.Promises.readdir(m);for(const P of f){if(g[P]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${P}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${P}`),await k.Promises.rm((0,T.$jc)(m,P))}const w=Date.now();for(const P of Object.keys(g)){const p=(0,T.$jc)(m,P),c=await k.Promises.readdir(p);for(const h of c){if(h==="tcf.json")continue;const i=(0,T.$jc)(p,h),n=await R.promises.stat(i);n.isDirectory()&&w-n.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.$jc)(P,h)}`),await k.Promises.rm(i))}}}catch(g){(0,C.$Y)(g)}}};e.$eic=$,e.$eic=$=ve([Z(0,O.$Ni),Z(1,b.$ak),Z(2,I.$tk)],$)}),define(he[181],ue([0,1,13,4]),function(ae,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$ZG=void 0,e.$ZG=(0,a.$Fi)("IV8InspectProfilingService");var C;(function(A){function T(O){return!!(O.samples&&O.timeDeltas)}A.isValidProfile=T;function k(O,b="noAbsolutePaths"){for(const I of O.nodes)I.callFrame&&I.callFrame.url&&((0,R.$ic)(I.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(I.callFrame.url))&&(I.callFrame.url=(0,R.$jc)(b,(0,R.$nc)(I.callFrame.url)));return O}A.rewriteAbsolutePaths=k})(C||(e.Utils=C={}))}),define(he[182],ue([0,1,32]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vic=void 0;class a{constructor(){this.a=new Map}async startProfiling(A){const k=await(await new Promise((b,I)=>{ae(["v8-inspect-profiler"],b,I)}).then(Oe)).startProfiling({host:A.host,port:A.port,checkForPaused:!0}),O=(0,R.$2g)();return this.a.set(O,k),O}async stopProfiling(A){const T=this.a.get(A);if(!T)throw new Error(`UNKNOWN session '${A}'`);const k=await T.stop();return this.a.delete(A),k.profile}}e.$vic=a}),define(he[44],ue([0,1,131,12]),function(ae,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,R=Oe(R),a=Oe(a);class C{constructor(){this.a=new Map}add(T,k){R.ok(a.$eg(T)),R.ok(a.$gg(k)),R.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,k)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$ro=new C}),define(he[103],ue([0,1,3,132,44]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0,C=Oe(C),e.$so={JSONContribution:"base.contributions.json"};function A(O){return O.length>0&&O.charAt(O.length-1)==="#"?O.substring(0,O.length-1):O}class T{constructor(){this.b=new R.$le,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,I){this.a[A(b)]=I,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(b){const I=this.a[b];return I?(0,a.$8j)(I):void 0}hasSchemaContent(b){return!!this.a[b]}}const k=new T;C.$ro.add(e.$so.JSONContribution,k)}),define(he[47],ue([0,1,17,3,12,11,21,103,44]),function(ae,e,R,a,C,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.ConfigurationScope=e.$wo=e.EditPresentationTypes=void 0,e.$Ho=m,e.$Io=E,e.$Jo=f,e.$Ko=P,e.$Lo=p,e.$Mo=c,e.$No=h,C=Oe(C),A=Oe(A);var b;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$wo={Configuration:"base.contributions.configuration"};var I;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do="vscode://schemas/settings/resourceLanguage",e.$Eo="vscode://schemas/settings/configurationDefaults";const $=O.$ro.as(k.$so.JSONContribution);class d{constructor(){this.a=[],this.i=new Set,this.j=new a.$le,this.onDidSchemaChange=this.j.event,this.k=new a.$le,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:A.localize(11611,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},$.registerSchema(e.$Do,this.h),this.z()}registerConfiguration(n,t=!0){this.registerConfigurations([n],t)}registerConfigurations(n,t=!0){const s=new Set;this.r(n,t,s),$.registerSchema(e.$Do,this.h),this.j.fire(),this.k.fire({properties:s})}deregisterConfigurations(n){const t=new Set;this.s(n,t),$.registerSchema(e.$Do,this.h),this.j.fire(),this.k.fire({properties:t})}updateConfigurations({add:n,remove:t}){const s=new Set;this.s(t,s),this.r(n,!1,s),$.registerSchema(e.$Do,this.h),this.j.fire(),this.k.fire({properties:s})}registerDefaultConfigurations(n){const t=new Set;this.l(n,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}l(n,t){this.a.push(...n);const s=[];for(const{overrides:r,source:o}of n)for(const u in r){t.add(u);const y=this.b.get(u)??this.b.set(u,{configurationDefaultOverrides:[]}).get(u),N=r[u];if(y.configurationDefaultOverrides.push({value:N,source:o}),e.$Go.test(u)){const S=this.o(u,N,o,y.configurationDefaultOverrideValue);if(!S)continue;y.configurationDefaultOverrideValue=S,this.n(u,S,o),s.push(...m(u))}else{const S=this.p(u,N,o,y.configurationDefaultOverrideValue);if(!S)continue;y.configurationDefaultOverrideValue=S;const v=this.e[u];v&&(this.A(u,v),this.w(u,v))}}this.q(s)}deregisterDefaultConfigurations(n){const t=new Set;this.m(n,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}m(n,t){for(const s of n){const r=this.a.indexOf(s);r!==-1&&this.a.splice(r,1)}for(const{overrides:s,source:r}of n)for(const o in s){const u=this.b.get(o);if(!u)continue;const y=u.configurationDefaultOverrides.findIndex(N=>r?N.source?.id===r.id:N.value===s[o]);if(y!==-1){if(u.configurationDefaultOverrides.splice(y,1),u.configurationDefaultOverrides.length===0&&this.b.delete(o),e.$Go.test(o)){let N;for(const S of u.configurationDefaultOverrides)N=this.o(o,S.value,S.source,N);N&&!C.$rg(N.value)?(u.configurationDefaultOverrideValue=N,this.n(o,N,r)):(this.b.delete(o),delete this.e[o],delete this.c.properties[o])}else{let N;for(const v of u.configurationDefaultOverrides)N=this.p(o,v.value,v.source,N);u.configurationDefaultOverrideValue=N;const S=this.e[o];S&&(this.A(o,S),this.w(o,S))}t.add(o)}}this.y()}n(n,t,s){const r={type:"object",default:t.value,description:A.localize(11612,null,(0,T.$jj)(n)),$ref:e.$Do,defaultDefaultValue:t.value,source:s,defaultValueSource:s};this.e[n]=r,this.c.properties[n]=r}o(n,t,s,r){const o=r?.value||{},u=r?.source??new Map;if(!(u instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const y of Object.keys(t)){const N=t[y];if(C.$gg(N)&&(C.$lg(o[y])||C.$gg(o[y]))){if(o[y]={...o[y]??{},...N},s)for(const v in N)u.set(`${y}.${v}`,s)}else o[y]=N,s?u.set(y,s):u.delete(y)}return{value:o,source:u}}p(n,t,s,r){const o=this.e[n],u=r?.value??o?.defaultDefaultValue;let y=s;if(C.$gg(t)&&(o!==void 0&&o.type==="object"||o===void 0&&(C.$lg(u)||C.$gg(u)))){if(y=r?.source??new Map,!(y instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const S in t)s&&y.set(`${n}.${S}`,s);t={...C.$gg(u)?u:{},...t}}return{value:t,source:y}}deltaConfiguration(n){let t=!1;const s=new Set;n.removedDefaults&&(this.m(n.removedDefaults,s),t=!0),n.addedDefaults&&(this.l(n.addedDefaults,s),t=!0),n.removedConfigurations&&this.s(n.removedConfigurations,s),n.addedConfigurations&&this.r(n.addedConfigurations,!1,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...n){this.j.fire()}registerOverrideIdentifiers(n){this.q(n),this.j.fire()}q(n){for(const t of n)this.i.add(t);this.y()}r(n,t,s){n.forEach(r=>{this.u(r,t,r.extensionInfo,r.restrictedProperties,void 0,s),this.d.push(r),this.v(r)})}s(n,t){const s=r=>{if(r.properties)for(const o in r.properties){t.add(o);const u=this.e[o];u?.policy?.name&&this.f.delete(u.policy.name),delete this.e[o],this.x(o,r.properties[o])}r.allOf?.forEach(o=>s(o))};for(const r of n){s(r);const o=this.d.indexOf(r);o!==-1&&this.d.splice(o,1)}}u(n,t=!0,s,r,o=I.WINDOW,u){o=C.$ng(n.scope)?o:n.scope;const y=n.properties;if(y)for(const S in y){const v=y[S];if(t&&P(S,v)){delete y[S];continue}if(v.source=s,v.defaultDefaultValue=y[S].default,this.A(S,v),e.$Go.test(S)?v.scope=void 0:(v.scope=C.$ng(v.scope)?o:v.scope,v.restricted=C.$ng(v.restricted)?!!r?.includes(S):v.restricted),y[S].hasOwnProperty("included")&&!y[S].included){this.g[S]=y[S],delete y[S];continue}else this.e[S]=y[S],y[S].policy?.name&&this.f.set(y[S].policy.name,S);!y[S].deprecationMessage&&y[S].markdownDeprecationMessage&&(y[S].deprecationMessage=y[S].markdownDeprecationMessage),u.add(S)}const N=n.allOf;if(N)for(const S of N)this.u(S,t,s,r,o,u)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const n=new Map;for(const[t,s]of this.b)s.configurationDefaultOverrideValue&&n.set(t,s.configurationDefaultOverrideValue);return n}v(n){const t=s=>{const r=s.properties;if(r)for(const u in r)this.w(u,r[u]);s.allOf?.forEach(t)};t(n)}w(n,t){switch(e.$xo.properties[n]=t,t.scope){case I.APPLICATION:e.$yo.properties[n]=t;break;case I.MACHINE:e.$zo.properties[n]=t;break;case I.MACHINE_OVERRIDABLE:e.$Ao.properties[n]=t;break;case I.WINDOW:e.$Bo.properties[n]=t;break;case I.RESOURCE:e.$Co.properties[n]=t;break;case I.LANGUAGE_OVERRIDABLE:e.$Co.properties[n]=t,this.h.properties[n]=t;break}}x(n,t){switch(delete e.$xo.properties[n],t.scope){case I.APPLICATION:delete e.$yo.properties[n];break;case I.MACHINE:delete e.$zo.properties[n];break;case I.MACHINE_OVERRIDABLE:delete e.$Ao.properties[n];break;case I.WINDOW:delete e.$Bo.properties[n];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$Co.properties[n],delete this.h.properties[n];break}}y(){for(const n of this.i.values()){const t=`[${n}]`,s={type:"object",description:A.localize(11613,null),errorMessage:A.localize(11614,null),$ref:e.$Do};this.A(t,s),e.$xo.properties[t]=s,e.$yo.properties[t]=s,e.$zo.properties[t]=s,e.$Ao.properties[t]=s,e.$Bo.properties[t]=s,e.$Co.properties[t]=s}}z(){const n={type:"object",description:A.localize(11615,null),errorMessage:A.localize(11616,null),$ref:e.$Do};e.$xo.patternProperties[e.$Fo]=n,e.$yo.patternProperties[e.$Fo]=n,e.$zo.patternProperties[e.$Fo]=n,e.$Ao.patternProperties[e.$Fo]=n,e.$Bo.patternProperties[e.$Fo]=n,e.$Co.patternProperties[e.$Fo]=n,this.j.fire()}A(n,t){const s=this.b.get(n)?.configurationDefaultOverrideValue;let r,o;s&&(!t.disallowConfigurationDefault||!s.source)&&(r=s.value,o=s.source),C.$lg(r)&&(r=t.defaultDefaultValue,o=void 0),C.$lg(r)&&(r=f(t.type)),t.default=r,t.defaultValueSource=o}}const g="\\[([^\\]]+)\\]",l=new RegExp(g,"g");e.$Fo=`^(${g})+$`,e.$Go=new RegExp(e.$Fo);function m(i){const n=[];if(e.$Go.test(i)){let t=l.exec(i);for(;t?.length;){const s=t[1].trim();s&&n.push(s),t=l.exec(i)}}return(0,R.$Lb)(n)}function E(i){return i.reduce((n,t)=>`${n}[${t}]`,"")}function f(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const w=new d;O.$ro.add(e.$wo.Configuration,w);function P(i,n){return i.trim()?e.$Go.test(i)?A.localize(11618,null,i):w.getConfigurationProperties()[i]!==void 0?A.localize(11619,null,i):n.policy?.name&&w.getPolicyConfigurations().get(n.policy?.name)!==void 0?A.localize(11620,null,i,n.policy?.name,w.getPolicyConfigurations().get(n.policy?.name)):null:A.localize(11617,null)}function p(){const i=[],n=w.getConfigurationProperties();for(const t of Object.keys(n))i.push([t,n[t].scope]);return i.push(["launch",I.RESOURCE]),i.push(["task",I.RESOURCE]),i}function c(i){const n={};for(const t of i){const s=t.properties;if(C.$gg(s))for(const r in s)n[r]=s[r];t.allOf&&Object.assign(n,c(t.allOf))}return n}function h(i){switch(i){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(he[77],ue([0,1,17,3,36,2,31,29,12,9,21,47,7,44]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0,e.$So=p,R=Oe(R),C=Oe(C),k=Oe(k),O=Oe(O);function l(n){return Object.isFrozen(n)?n:k.$fo(n)}class m{static createEmptyModel(t){return new m({},[],[],void 0,t)}constructor(t,s,r,o,u){this.b=t,this.c=s,this.d=r,this.raw=o,this.f=u,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(s=>{if(s instanceof m)return s;const r=new E("",this.f);return r.parseRaw(s),r.configurationModel});this.g=t.reduce((s,r)=>r===s?r:s.merge(r),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,I.$hj)(this.contents,t):this.contents}inspect(t,s){const r=this;return{get value(){return l(r.rawConfiguration.getValue(t))},get override(){return s?l(r.rawConfiguration.getOverrideValue(t,s)):void 0},get merged(){return l(s?r.rawConfiguration.override(s).getValue(t):r.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:u,identifiers:y,keys:N}of r.rawConfiguration.overrides){const S=new m(u,N,[],void 0,r.f).getValue(t);S!==void 0&&o.push({identifiers:y,value:S})}return o.length?l(o):void 0}}}getOverrideValue(t,s){const r=this.j(s);return r?t?(0,I.$hj)(r,t):r:void 0}getKeysForOverrideIdentifier(t){const s=[];for(const r of this.overrides)r.identifiers.includes(t)&&s.push(...r.keys);return R.$Lb(s)}getAllOverrideIdentifiers(){const t=[];for(const s of this.overrides)t.push(...s.identifiers);return R.$Lb(t)}override(t){let s=this.a.get(t);return s||(s=this.h(t),this.a.set(t,s)),s}merge(...t){const s=k.$eo(this.contents),r=k.$eo(this.overrides),o=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const y of t)if(u.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.i(s,y.contents);for(const N of y.overrides){const[S]=r.filter(v=>R.$tb(v.identifiers,N.identifiers));S?(this.i(S.contents,N.contents),S.keys.push(...N.keys),S.keys=R.$Lb(S.keys)):r.push(k.$eo(N))}for(const N of y.keys)o.indexOf(N)===-1&&o.push(N)}return new m(s,o,r,u.every(y=>y instanceof m)?void 0:u,this.f)}h(t){const s=this.j(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const r={};for(const o of R.$Lb([...Object.keys(this.contents),...Object.keys(s)])){let u=this.contents[o];const y=s[o];y&&(typeof u=="object"&&typeof y=="object"?(u=k.$eo(u),this.i(u,y)):u=y),r[o]=u}return new m(r,this.keys,this.overrides,void 0,this.f)}i(t,s){for(const r of Object.keys(s)){if(r in t&&O.$gg(t[r])&&O.$gg(s[r])){this.i(t[r],s[r]);continue}t[r]=k.$eo(s[r])}}j(t){let s=null,r=null;const o=u=>{u&&(r?this.i(r,u):r=k.$eo(u))};for(const u of this.overrides)u.identifiers.length===1&&u.identifiers[0]===t?s=u.contents:u.identifiers.includes(t)&&o(u.contents);return o(s),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,s){this.k(t,s,!0)}setValue(t,s){this.k(t,s,!1)}removeValue(t){const s=this.keys.indexOf(t);s!==-1&&(this.keys.splice(s,1),(0,I.$gj)(this.contents,t),$.$Go.test(t)&&this.overrides.splice(this.overrides.findIndex(r=>R.$tb(r.identifiers,(0,$.$Ho)(t))),1))}k(t,s,r){if((0,I.$fj)(this.contents,t,s,o=>this.f.error(o)),r=r||this.keys.indexOf(t)===-1,r&&this.keys.push(t),$.$Go.test(t)){const o=(0,$.$Ho)(t),u={identifiers:o,keys:Object.keys(this.contents[t]),contents:(0,I.$ej)(this.contents[t],N=>this.f.error(N))},y=this.overrides.findIndex(N=>R.$tb(N.identifiers,o));y!==-1?this.overrides[y]=u:this.overrides.push(u)}}}e.$Oo=m;class E{constructor(t,s){this.f=t,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||m.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,s){if(!O.$ng(t)){const r=this.h(t);this.parseRaw(r,s)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,s){this.a=t;const{contents:r,keys:o,overrides:u,restricted:y,hasExcludedProperties:N}=this.i(t,s);this.b=new m(r,o,u,N?[t]:void 0,this.g),this.c=y||[]}h(t){let s={},r=null,o=[];const u=[],y=[];function N(v){Array.isArray(o)?o.push(v):r!==null&&(o[r]=v)}const S={onObjectBegin:()=>{const v={};N(v),u.push(o),o=v,r=null},onObjectProperty:v=>{r=v},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const v=[];N(v),u.push(o),o=v,r=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:N,onError:(v,L,U)=>{y.push({error:v,offset:L,length:U})}};if(t)try{C.$6n(t,S),s=o[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return s}i(t,s){const r=g.$ro.as($.$wo.Configuration).getConfigurationProperties(),o=this.j(t,r,!0,s);t=o.raw;const u=(0,I.$ej)(t,S=>this.g.error(`Conflict in settings file ${this.f}: ${S}`)),y=Object.keys(t),N=this.l(t,S=>this.g.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:u,keys:y,overrides:N,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(t,s,r,o){let u=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:u};const y={},N=[];for(const S in t)if($.$Go.test(S)&&r){const v=this.j(t[S],s,!1,o);y[S]=v.raw,u=u||v.hasExcludedProperties,N.push(...v.restricted)}else{const v=s[S],L=v?typeof v.scope<"u"?v.scope:$.ConfigurationScope.WINDOW:void 0;v?.restricted&&N.push(S),!o.exclude?.includes(S)&&(o.include?.includes(S)||(L===void 0||o.scopes===void 0||o.scopes.includes(L))&&!(o.skipRestricted&&v?.restricted))?y[S]=t[S]:u=!0}return{raw:y,restricted:N,hasExcludedProperties:u}}l(t,s){const r=[];for(const o of Object.keys(t))if($.$Go.test(o)){const u={};for(const y in t[o])u[y]=t[o][y];r.push({identifiers:(0,$.$Ho)(o),keys:Object.keys(u),contents:(0,I.$ej)(u,s)})}return r}}e.$Po=E;class f extends A.$Uc{constructor(t,s,r,o,u){super(),this.c=t,this.f=s,this.g=o,this.h=u,this.b=this.B(new a.$le),this.onDidChange=this.b.event,this.a=new E(this.c.toString(),u),this.B(this.g.watch(r.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(a.Event.any(a.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),a.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(d.FileOperation.CREATE)||y.isOperation(d.FileOperation.COPY)||y.isOperation(d.FileOperation.DELETE)||y.isOperation(d.FileOperation.WRITE))&&r.isEqual(y.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return m.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Qo=f;class w{constructor(t,s,r,o,u,y,N,S,v,L,U,F,M){this.a=t,this.b=s,this.c=r,this.overrideIdentifiers=o,this.d=u,this.f=y,this.g=N,this.h=S,this.i=v,this.j=L,this.k=U,this.l=F,this.m=M}get value(){return l(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class P{constructor(t,s,r,o,u,y,N,S,v,L){this.j=t,this.l=s,this.m=r,this.n=o,this.p=u,this.q=y,this.r=N,this.s=S,this.t=v,this.u=L,this.h=null,this.i=new T.$Ac,this.v=null}getValue(t,s,r){return this.w(t,s,r).getValue(t)}updateValue(t,s,r={}){let o;r.resource?(o=this.t.get(r.resource),o||(o=m.createEmptyModel(this.u),this.t.set(r.resource,o))):o=this.s,s===void 0?o.removeValue(t):o.setValue(t,s),r.resource||(this.h=null)}inspect(t,s,r){const o=this.w(t,s,r),u=this.A(s.resource,r),y=s.resource?this.t.get(s.resource)||this.s:this.s,N=new Set;for(const S of o.overrides)for(const v of S.identifiers)o.getOverrideValue(t,v)!==void 0&&N.add(v);return new w(t,s,o.getValue(t),N.size?[...N]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.q:void 0,u||void 0,y)}keys(t){const s=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,s){this.r.set(t,s),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=[];if(!s){const{added:o,updated:u,removed:y}=h(this.j,t);s=[...o,...u,...y]}for(const o of s)for(const u of(0,$.$Ho)(o)){const y=this.j.getKeysForOverrideIdentifier(u),N=t.getKeysForOverrideIdentifier(u),S=[...N.filter(v=>y.indexOf(v)===-1),...y.filter(v=>N.indexOf(v)===-1),...y.filter(v=>!k.$io(this.j.override(u).getValue(v),t.override(u).getValue(v)))];r.push([u,S])}return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdatePolicyConfiguration(t){const{added:s,updated:r,removed:o}=h(this.l,t),u=[...s,...r,...o];return u.length&&this.updatePolicyConfiguration(t),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:s,updated:r,removed:o,overrides:u}=h(this.applicationConfiguration,t),y=[...s,...r,...o];return y.length&&this.updateApplicationConfiguration(t),{keys:y,overrides:u}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:o,overrides:u}=h(this.localUserConfiguration,t),y=[...s,...r,...o];return y.length&&this.updateLocalUserConfiguration(t),{keys:y,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:o,overrides:u}=h(this.remoteUserConfiguration,t),y=[...s,...r,...o];return y.length&&this.updateRemoteUserConfiguration(t),{keys:y,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:o,overrides:u}=h(this.workspaceConfiguration,t),y=[...s,...r,...o];return y.length&&this.updateWorkspaceConfiguration(t),{keys:y,overrides:u}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:o,updated:u,removed:y,overrides:N}=h(r,s),S=[...o,...u,...y];return(S.length||!r)&&this.updateFolderConfiguration(t,s),{keys:S,overrides:N}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:o,removed:u,overrides:y}=h(s,void 0);return{keys:[...r,...o,...u],overrides:y}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,s,r){let o=this.x(s,r);return s.overrideIdentifier&&(o=o.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(o=o.merge(this.l)),o}x({resource:t},s){let r=this.y();if(s&&t){const o=s.getFolder(t);o&&(r=this.z(o.uri)||r);const u=this.t.get(t);u&&(r=r.merge(u))}return r}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let s=this.i.get(t);if(!s){const r=this.y(),o=this.r.get(t);o?(s=r.merge(o),this.i.set(t,s)):s=r}return s}A(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this.r.get(r.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,s)=>{const{contents:r,overrides:o,keys:u}=this.r.get(s);return t.push([s,{contents:r,overrides:o,keys:u}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(s=>t.add(s)),this.userConfiguration.keys.forEach(s=>t.add(s)),this.q.keys.forEach(s=>t.add(s)),this.r.forEach(s=>s.keys.forEach(r=>t.add(r))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(r=>t.add(r))),[...t.values()]}D(t){const s=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.q.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.r.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o))),[...s.values()]}static parse(t,s){const r=this.E(t.defaults,s),o=this.E(t.policy,s),u=this.E(t.application,s),y=this.E(t.user,s),N=this.E(t.workspace,s),S=t.folders.reduce((v,L)=>(v.set(b.URI.revive(L[0]),this.E(L[1],s)),v),new T.$Ac);return new P(r,o,u,y,m.createEmptyModel(s),N,S,m.createEmptyModel(s),new T.$Ac,s)}static E(t,s){return new m(t.contents,t.keys,t.overrides,void 0,s)}}e.$Ro=P;function p(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const t=new Set,s=new Map;for(const o of n)o.keys.forEach(u=>t.add(u)),o.overrides.forEach(([u,y])=>{const N=(0,T.$xc)(s,u,new Set);y.forEach(S=>N.add(S))});const r=[];return s.forEach((o,u)=>r.push([u,[...o.values()]])),{keys:[...t.values()],overrides:r}}class c{constructor(t,s,r,o,u){this.change=t,this.f=s,this.g=r,this.h=o,this.i=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const y of t.keys)this.affectedKeys.add(y);for(const[,y]of t.overrides)for(const N of y)this.affectedKeys.add(N);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=P.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,s){const r=this.a+t,o=this.d.indexOf(r);if(o<0)return!1;const u=o+r.length;if(u>=this.d.length)return!1;const y=this.d.charCodeAt(u);if(y!==this.b&&y!==this.c)return!1;if(s){const N=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.f?.workspace):void 0,S=this.g.getValue(t,s,this.h);return!k.$io(N,S)}return!0}}e.$To=c;function h(n,t){const{added:s,removed:r,updated:o}=i(t?.rawConfiguration,n?.rawConfiguration),u=[],y=n?.getAllOverrideIdentifiers()||[],N=t?.getAllOverrideIdentifiers()||[];if(t){const S=N.filter(v=>!y.includes(v));for(const v of S)u.push([v,t.getKeysForOverrideIdentifier(v)])}if(n){const S=y.filter(v=>!N.includes(v));for(const v of S)u.push([v,n.getKeysForOverrideIdentifier(v)])}if(t&&n){for(const S of y)if(N.includes(S)){const v=i({contents:n.getOverrideValue(void 0,S)||{},keys:n.getKeysForOverrideIdentifier(S)},{contents:t.getOverrideValue(void 0,S)||{},keys:t.getKeysForOverrideIdentifier(S)});u.push([S,[...v.added,...v.removed,...v.updated]])}}return{added:s,removed:r,updated:o,overrides:u}}function i(n,t){const s=n?t?n.keys.filter(u=>t.keys.indexOf(u)===-1):[...n.keys]:[],r=t?n?t.keys.filter(u=>n.keys.indexOf(u)===-1):[...t.keys]:[],o=[];if(n&&t){for(const u of t.keys)if(n.keys.indexOf(u)!==-1){const y=(0,I.$hj)(t.contents,u),N=(0,I.$hj)(n.contents,u);k.$io(y,N)||o.push(u)}}return{added:s,removed:r,updated:o}}}),define(he[183],ue([0,1,17,3,2,29,12,77,47,10,58,44]),function(ae,e,R,a,C,A,T,k,O,b,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=void 0;class d extends C.$Uc{get configurationModel(){return this.b}constructor(E){super(),this.c=E,this.a=this.B(new a.$le),this.onDidChangeConfiguration=this.a.event,this.b=k.$Oo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B($.$ro.as(O.$wo.Configuration).onDidUpdateConfiguration(({properties:E,defaultsOverrides:f})=>this.f(Array.from(E),f))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(E,f){this.j(E,$.$ro.as(O.$wo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:E})}g(){return{}}h(){this.b=k.$Oo.createEmptyModel(this.c);const E=$.$ro.as(O.$wo.Configuration).getConfigurationProperties();this.j(Object.keys(E),E)}j(E,f){const w=this.g();for(const P of E){const p=w[P],c=f[P];p!==void 0?this.b.setValue(P,p):c?this.b.setValue(P,c.default):this.b.removeValue(P)}}}e.$Uo=d;class g{constructor(){this.onDidChangeConfiguration=a.Event.None,this.configurationModel=k.$Oo.createEmptyModel(new b.$nk)}async initialize(){return this.configurationModel}}e.$Vo=g;let l=class extends C.$Uc{get configurationModel(){return this.b}constructor(E,f,w){super(),this.c=E,this.f=f,this.g=w,this.a=this.B(new a.$le),this.onDidChangeConfiguration=this.a.event,this.b=k.$Oo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(E=>this.j(E))),this.B(this.c.onDidChangeConfiguration(async({properties:E})=>this.m(await this.h(E),!0))),this.b}async h(E){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",E);const f={},w=[],P=$.$ro.as(O.$wo.Configuration).getConfigurationProperties();for(const p of E){const c=P[p];if(!c){w.push(p);continue}if(c.policy){if(c.type!=="string"&&c.type!=="number"){this.g.warn(`Policy ${c.policy.name} has unsupported type ${c.type}`);continue}w.push(p),f[c.policy.name]={type:c.type}}}return(0,T.$rg)(f)||await this.f.updatePolicyDefinitions(f),w}j(E){this.g.trace("PolicyConfiguration#onDidChangePolicies",E);const f=$.$ro.as(O.$wo.Configuration).getPolicyConfigurations(),w=(0,R.$Gb)(E.map(P=>f.get(P)));this.m(w,!0)}m(E,f){this.g.trace("PolicyConfiguration#update",E);const w=$.$ro.as(O.$wo.Configuration).getConfigurationProperties(),P=[],p=this.b.isEmpty();for(const c of E){const h=w[c]?.policy?.name;if(h){const i=this.f.getPolicyValue(h);(p?i!==void 0:!(0,A.$io)(this.b.getValue(c),i))&&P.push([c,i])}else this.b.getValue(c)!==void 0&&P.push([c,void 0])}if(P.length){this.g.trace("PolicyConfiguration#changed",P);const c=this.b;this.b=k.$Oo.createEmptyModel(this.g);for(const h of c.keys)this.b.setValue(h,c.getValue(h));for(const[h,i]of P)i===void 0?this.b.removeValue(h):this.b.setValue(h,i);f&&this.a.fire(this.b)}}};e.$Wo=l,e.$Wo=l=ve([Z(1,I.$to),Z(2,b.$ak)],l)}),define(he[184],ue([0,1,17,6,14,3,36,64,2,31,29,5,20,21,77,47,183,7,58]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=void 0;class P extends O.$Uc{constructor(h,i,n,t){super(),this.m=h,this.n=t,this.h=this.B(new A.$le),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new E.$Uo(t)),this.c=n instanceof w.$vo?new E.$Vo:this.B(new E.$Wo(this.b,n,t)),this.f=this.B(new l.$Qo(this.m,{},d.$0g,i,t)),this.a=new l.$Ro(this.b.configurationModel,this.c.configurationModel,l.$Oo.createEmptyModel(t),l.$Oo.createEmptyModel(t),l.$Oo.createEmptyModel(t),l.$Oo.createEmptyModel(t),new b.$Ac,l.$Oo.createEmptyModel(t),new b.$Ac,t),this.j=new p(h,i,this),this.g=this.B(new a.$Rh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:r})=>this.s(s,r))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,i,n]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new l.$Ro(h,i,l.$Oo.createEmptyModel(this.n),n,l.$Oo.createEmptyModel(this.n),l.$Oo.createEmptyModel(this.n),new b.$Ac,l.$Oo.createEmptyModel(this.n),new b.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(h,i){const n=typeof h=="string"?h:void 0,t=(0,g.$aj)(h)?h:(0,g.$aj)(i)?i:{};return this.a.getValue(n,t,void 0)}async updateValue(h,i,n,t,s){const r=(0,g.$bj)(n)?n:(0,g.$aj)(n)?{resource:n.resource,overrideIdentifiers:n.overrideIdentifier?[n.overrideIdentifier]:void 0}:void 0,o=r?t:n;if(o!==void 0&&o!==g.ConfigurationTarget.USER_LOCAL&&o!==g.ConfigurationTarget.USER)throw new Error(`Unable to write ${h} to target ${o}.`);r?.overrideIdentifiers&&(r.overrideIdentifiers=(0,R.$Lb)(r.overrideIdentifiers),r.overrideIdentifiers=r.overrideIdentifiers.length?r.overrideIdentifiers:void 0);const u=this.inspect(h,{resource:r?.resource,overrideIdentifier:r?.overrideIdentifiers?r.overrideIdentifiers[0]:void 0});if(u.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,I.$io)(i,u.defaultValue)&&(i=void 0),r?.overrideIdentifiers?.length&&r.overrideIdentifiers.length>1){const N=r.overrideIdentifiers.sort(),S=this.a.localUserConfiguration.overrides.find(v=>(0,R.$tb)([...v.identifiers].sort(),N));S&&(r.overrideIdentifiers=S.identifiers)}const y=r?.overrideIdentifiers?.length?[(0,m.$Io)(r.overrideIdentifiers),h]:[h];await this.j.write(y,i),await this.reloadConfiguration()}inspect(h,i={}){return this.a.inspect(h,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.r(h)}r(h){const i=this.a.toData(),n=this.a.compareAndUpdateLocalUserConfiguration(h);this.u(n,i,g.ConfigurationTarget.USER)}s(h,i){const n=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(h,i);this.u(t,n,g.ConfigurationTarget.DEFAULT)}t(h){const i=this.a.toData(),n=this.a.compareAndUpdatePolicyConfiguration(h);this.u(n,i,g.ConfigurationTarget.DEFAULT)}u(h,i,n){const t=new l.$To(h,{data:i},this.a,void 0,this.n);t.source=n,this.h.fire(t)}}e.$Xo=P;class p{constructor(h,i,n){this.b=h,this.c=i,this.d=n,this.a=new a.$Mh}write(h,i){return this.a.queue(()=>this.e(h,i))}async e(h,i){let n;try{n=(await this.c.readFile(this.b)).value.toString()}catch(r){if(r.fileOperationResult===f.FileOperationResult.FILE_NOT_FOUND)n="{}";else throw r}const t=[];if((0,T.$Yn)(n,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(n,h,i);n=(0,k.$do)(n,s),await this.c.writeFile(this.b,C.$Ne.fromString(n))}f(h,i,n){const{tabSize:t,insertSpaces:s,eol:r}=this.h;if(!i.length){const o=JSON.stringify(n,null,s?" ".repeat(t):"	");return[{content:o,length:o.length,offset:0}]}return(0,k.$ao)(h,i,n,{tabSize:t,insertSpaces:s,eol:r})}get h(){if(!this.g){let h=$.OS===$.OperatingSystem.Linux||$.OS===$.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(h=i),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(he[185],ue([0,1,14,3,2,69]),function(ae,e,R,a,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fxb=e.$Dxb=e.$Cxb=void 0,e.$Exb=k;const T=(b,I,$)=>{const d=new Uint8Array(16);for(let m=0;m<16;m++)d[m]=Math.round(Math.random()*256);const g=(0,R.$8e)(R.$Ne.wrap(d));return[`GET ws://localhost${b}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`].join(`\r
`)+`\r
\r
`};e.$Cxb=T,e.$Dxb=R.$Ne.fromString(`\r
\r
`);async function k(b,I,$,d,g){b.write(R.$Ne.fromString((0,e.$Cxb)(I,$,d)));const l=new C.$Tc;try{return await new Promise((m,E)=>{let f;l.add(b.onData(w=>{f?f=R.$Ne.concat([f,w],f.byteLength+w.byteLength):f=w;const P=f.indexOf(e.$Dxb);if(P===-1)return;m(b),b.pauseData();const p=f.slice(P+e.$Dxb.byteLength);p.byteLength&&g.onData.fire(p)})),l.add(b.onClose(w=>E(w??new Error("socket closed")))),l.add(b.onEnd(()=>E(new Error("socket ended"))))})}catch(m){throw b.dispose(),m}finally{l.dispose()}}class O extends C.$Uc{constructor(I,$){super(),this.g=I,this.a=this.B(new a.$oe),this.onData=(...d)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...d)),this.b=this.B(new a.$le),this.onDidDispose=this.b.event,this.f=!1,this.B($.onData),this.B($.onData.event(d=>this.a.fire(d))),this.onClose=this.B($.onClose).event,this.onEnd=this.B($.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(I,$){A.SocketDiagnostics.traceSocketEvent(this,this.g,I,$)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Fxb=O}),define(he[104],ue([0,1,8,4]),function(ae,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.RemoteAuthorityResolverErrorCode=e.$Tl=e.$Sl=e.RemoteConnectionType=e.$Rl=void 0,e.$Vl=b,e.$Rl=(0,a.$Fi)("remoteAuthorityResolverService");var C;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class A{constructor($){this.id=$,this.type=C.Managed}toString(){return`Managed(${this.id})`}}e.$Sl=A;class T{constructor($,d){this.host=$,this.port=d,this.type=C.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Tl=T;var k;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(k||(e.RemoteAuthorityResolverErrorCode=k={}));class O extends R.$ab{static isNotAvailable($){return $ instanceof O&&$._code===k.NotAvailable}static isTemporarilyNotAvailable($){return $ instanceof O&&$._code===k.TemporarilyNotAvailable}static isNoResolverFound($){return $ instanceof O&&$._code===k.NoResolverFound}static isInvalidAuthority($){return $ instanceof O&&$._code===k.InvalidAuthority}static isHandled($){return $ instanceof O&&$.isHandled}constructor($,d=k.Unknown,g){super($),this._message=$,this._code=d,this._detail=g,this.isHandled=d===k.NotAvailable&&g===!0,Object.setPrototypeOf(this,O.prototype)}}e.$Ul=O;function b(I){const $=I.indexOf("+");return $===-1?I:I.substring(0,$)}}),define(he[186],ue([0,1,6,14,25,8,3,2,22,100,54,32,69,104]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$1l=u,e.$2l=y,e.$3l=S,b=Oe(b);const l=30*1e3;var m;(function(X){X[X.Management=1]="Management",X[X.ExtensionHost=2]="ExtensionHost",X[X.Tunnel=3]="Tunnel"})(m||(e.ConnectionType=m={}));function E(X){switch(X){case m.Management:return"Management";case m.ExtensionHost:return"ExtensionHost";case m.Tunnel:return"Tunnel"}}function f(X){const q=new C.$we;return setTimeout(()=>q.cancel(),X),q.token}function w(X,q){if(X.isCancellationRequested||q.isCancellationRequested)return C.CancellationToken.Cancelled;const D=new C.$we;return X.onCancellationRequested(()=>D.cancel()),q.onCancellationRequested(()=>D.cancel()),D.token}class P{get didTimeout(){return this.c==="timedout"}constructor(q){this.c="pending",this.d=new k.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,R.$yh)(),q.isCancellationRequested?this.h():this.d.add(q.onCancellationRequested(()=>this.h()))}registerDisposable(q){this.c==="pending"?this.d.add(q):q.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const q=new Error("Time limit reached");return q.code="ETIMEDOUT",q.syscall="connect",q}resolve(q){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(q))}reject(q){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(q))}}function p(X,q){const D=new P(q);return D.registerDisposable(X.onControlMessage(Y=>{const oe=JSON.parse(Y.toString()),j=z(oe);j?D.reject(j):D.resolve(oe)})),D.promise}function c(X,q,D,Y,oe,j,W,G){const J=new P(G),ie=I.$fe.create(!1);return X.info(`Creating a socket (${W})...`),b.mark(`code/willCreateSocket/${j}`),q.connect(D,Y,oe,W).then(ce=>{J.didTimeout?(b.mark(`code/didCreateSocketError/${j}`),X.info(`Creating a socket (${W}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),ce?.dispose()):(b.mark(`code/didCreateSocketOK/${j}`),X.info(`Creating a socket (${W}) was successful after ${ie.elapsed()} ms.`),J.resolve(ce))},ce=>{b.mark(`code/didCreateSocketError/${j}`),X.info(`Creating a socket (${W}) returned an error after ${ie.elapsed()} ms.`),X.error(ce),J.reject(ce)}),J.promise}function h(X,q){const D=new P(q);return X.then(Y=>{D.didTimeout||D.resolve(Y)},Y=>{D.didTimeout||D.reject(Y)}),D.promise}async function i(X,q,D,Y){const oe=ee(X,q);X.logService.trace(`${oe} 1/6. invoking socketFactory.connect().`);let j;try{j=await c(X.logService,X.remoteSocketFactoryService,X.connectTo,O.$Sg.getServerRootPath(),`reconnectionToken=${X.reconnectionToken}&reconnection=${X.reconnectionProtocol?"true":"false"}`,E(q),`renderer-${E(q)}-${X.reconnectionToken}`,Y)}catch(ce){throw X.logService.error(`${oe} socketFactory.connect() failed or timed out. Error:`),X.logService.error(ce),ce}X.logService.trace(`${oe} 2/6. socketFactory.connect() was successful.`);let W,G;X.reconnectionProtocol?(X.reconnectionProtocol.beginAcceptReconnection(j,null),W=X.reconnectionProtocol,G=!1):(W=new d.$ti({socket:j}),G=!0),X.logService.trace(`${oe} 3/6. sending AuthRequest control message.`);const J=await h(X.signService.createNewMessage((0,$.$2g)()),Y),ie={type:"auth",auth:X.connectionToken||"00000000000000000000",data:J.data};W.sendControl(a.$Ne.fromString(JSON.stringify(ie)));try{const ce=await p(W,w(Y,f(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(X.logService.trace(`${oe} 4/6. received SignRequest control message.`),!await h(X.signService.validate(J,ce.signedData),Y)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const pe=await h(X.signService.sign(ce.data),Y),Ee={type:"connectionType",commit:X.commit,signedData:pe,desiredConnectionType:q};return D&&(Ee.args=D),X.logService.trace(`${oe} 5/6. sending ConnectionTypeRequest control message.`),W.sendControl(a.$Ne.fromString(JSON.stringify(Ee))),{protocol:W,ownsProtocol:G}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(X.logService.error(`${oe} the handshake timed out. Error:`),X.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(X.logService.error(`${oe} received error control message when negotiating connection. Error:`),X.logService.error(ce)),G&&B(W),ce}}async function n(X,q,D,Y){const oe=Date.now(),j=ee(X,q),{protocol:W,ownsProtocol:G}=await i(X,q,D,Y),J=new P(Y);return J.registerDisposable(W.onControlMessage(ie=>{const ce=JSON.parse(ie.toString()),ge=z(ce);ge?(X.logService.error(`${j} received error control message when negotiating connection. Error:`),X.logService.error(ge),G&&B(W),J.reject(ge)):(X.reconnectionProtocol?.endAcceptReconnection(),X.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${Q(oe)}!`),J.resolve({protocol:W,firstMessage:ce}))})),J.promise}async function t(X,q){const{protocol:D}=await n(X,m.Management,void 0,q);return{protocol:D}}async function s(X,q,D){const{protocol:Y,firstMessage:oe}=await n(X,m.ExtensionHost,q,D),j=oe&&oe.debugPort;return{protocol:Y,debugPort:j}}async function r(X,q,D){const Y=Date.now(),oe=ee(X,m.Tunnel),{protocol:j}=await i(X,m.Tunnel,q,D);return X.logService.trace(`${oe} 6/6. handshake finished, connection is up and running after ${Q(Y)}!`),j}async function o(X,q,D){const{connectTo:Y,connectionToken:oe}=await X.addressProvider.getAddress();return{commit:X.commit,quality:X.quality,connectTo:Y,connectionToken:oe,reconnectionToken:q,reconnectionProtocol:D,remoteSocketFactoryService:X.remoteSocketFactoryService,signService:X.signService,logService:X.logService}}async function u(X,q,D){return N(X,async Y=>{const{protocol:oe}=await t(Y,C.CancellationToken.None);return new H(X,q,D,Y.reconnectionToken,oe)})}async function y(X,q){return N(X,async D=>{const{protocol:Y,debugPort:oe}=await s(D,q,C.CancellationToken.None);return new te(X,q,D.reconnectionToken,Y,oe)})}async function N(X,q){for(let Y=1;;Y++)try{const oe=(0,$.$2g)(),j=await o(X,oe,null);return await q(j)}catch(oe){if(Y<5)X.logService.error(`[remote-connection][attempt ${Y}] An error occurred in initial connection! Will retry... Error:`),X.logService.error(oe);else throw X.logService.error(`[remote-connection][attempt ${Y}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),X.logService.error(oe),x.triggerPermanentFailure(0,0,g.$Ul.isHandled(oe)),oe}}async function S(X,q,D){const Y=await o(X,(0,$.$2g)(),null);return await r(Y,{host:q,port:D},C.CancellationToken.None)}function v(X){return(0,R.$sh)(q=>new Promise((D,Y)=>{const oe=setTimeout(D,X*1e3);q.onCancellationRequested(()=>{clearTimeout(oe),D()})}))}var L;(function(X){X[X.ConnectionLost=0]="ConnectionLost",X[X.ReconnectionWait=1]="ReconnectionWait",X[X.ReconnectionRunning=2]="ReconnectionRunning",X[X.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",X[X.ConnectionGain=4]="ConnectionGain"})(L||(e.PersistentConnectionEventType=L={}));class U{constructor(q,D){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.type=L.ConnectionLost}}e.$4l=U;class F{constructor(q,D,Y,oe){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.durationSeconds=Y,this.c=oe,this.type=L.ReconnectionWait}skipWait(){this.c.cancel()}}e.$5l=F;class M{constructor(q,D,Y){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.attempt=Y,this.type=L.ReconnectionRunning}}e.$6l=M;class K{constructor(q,D,Y){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.attempt=Y,this.type=L.ConnectionGain}}e.$7l=K;class V{constructor(q,D,Y,oe){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.attempt=Y,this.handled=oe,this.type=L.ReconnectionPermanentFailure}}e.$8l=V;class x extends k.$Uc{static triggerPermanentFailure(q,D,Y){this._permanentFailure=!0,this.f=q,this.g=D,this.h=Y,this.j.forEach(oe=>oe.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(q=>q.y())}static debugPauseSocketWriting(){this.j.forEach(q=>q.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(q,D,Y,oe,j){super(),this.t=q,this.u=D,this.reconnectionToken=Y,this.protocol=oe,this.w=j,this.m=this.B(new T.$le),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new K(this.reconnectionToken,0,0)),this.B(oe.onSocketClose(W=>{const G=le(this.t,this.reconnectionToken,!0);W?W.type===d.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${G} received socket close event (hadError: ${W.hadError}).`),W.error&&this.u.logService.error(W.error)):(this.u.logService.info(`${G} received socket close event (wasClean: ${W.wasClean}, code: ${W.code}, reason: ${W.reason}).`),W.event&&this.u.logService.error(W.event)):this.u.logService.info(`${G} received socket close event.`),this.y()})),this.B(oe.onSocketTimeout(W=>{const G=le(this.t,this.reconnectionToken,!0);this.u.logService.info(`${G} received socket timeout event (unacknowledgedMsgCount: ${W.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${W.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${W.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,k.$Sc)(()=>{const W=x.j.indexOf(this);W>=0&&x.j.splice(W,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const q=le(this.t,this.reconnectionToken,!0);this.u.logService.info(`${q} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const D=[0,5,5,10,10,10,10,10,30];let Y=-1;do{Y++;const oe=Y<D.length?D[Y]:D[D.length-1];try{if(oe>0){const W=v(oe);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),oe,W)),this.u.logService.info(`${q} waiting for ${oe} seconds before reconnecting...`);try{await W}catch{}}if(this.n){this.u.logService.error(`${q} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y+1)),this.u.logService.info(`${q} resolving connection...`);const j=await o(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${q} connecting to ${j.connectTo}...`),await this.G(j,f(l)),this.u.logService.info(`${q} reconnected!`),this.m.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y+1));break}catch(j){if(j.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(j),this.C(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}if(Y>360){this.u.logService.error(`${q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(j),this.C(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}if(g.$Ul.isTemporarilyNotAvailable(j)){this.u.logService.info(`${q} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(j);continue}if((j.code==="ETIMEDOUT"||j.code==="ENETUNREACH"||j.code==="ECONNREFUSED"||j.code==="ECONNRESET")&&j.syscall==="connect"){this.u.logService.info(`${q} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(j);continue}if((0,A.$3)(j)){this.u.logService.info(`${q} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(j);continue}if(j instanceof g.$Ul){this.u.logService.error(`${q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(j),this.C(this.protocol.getMillisSinceLastIncomingData(),Y+1,g.$Ul.isHandled(j));break}this.u.logService.error(`${q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(j),this.C(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}}while(!this.n&&!this.s)}C(q,D,Y){this.w?x.triggerPermanentFailure(q,D,Y):this.D(q,D,Y)}D(q,D,Y){this.m.fire(new V(this.reconnectionToken,q,D,Y)),B(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$9l=x;class H extends x{constructor(q,D,Y,oe,j){super(m.Management,q,oe,j,!0),this.client=this.B(new d.$ri(j,{remoteAuthority:D,clientId:Y},q.ipcLogger))}async G(q,D){await t(q,D)}}e.$0l=H;class te extends x{constructor(q,D,Y,oe,j){super(m.ExtensionHost,q,Y,oe,!1),this.H=D,this.debugPort=j}async G(q,D){await s(q,this.H,D)}}e.$$l=te;function B(X){try{X.acceptDisconnect();const q=X.getSocket();X.dispose(),q.dispose()}catch(q){(0,A.$Y)(q)}}function z(X){if(X&&X.type==="error"){const q=new Error(`Connection error: ${X.reason}`);return q.code="VSCODE_CONNECTION_ERROR",q}return null}function _(X,q){for(;X.length<q;)X+=" ";return X}function ne(X,q){return`[remote-connection][${_(E(X),13)}][${q.substr(0,5)}\u2026]`}function le(X,q,D){return`${ne(X,q)}[${D?"reconnect":"initial"}]`}function ee(X,q){return`${le(q,X.reconnectionToken,!!X.reconnectionProtocol)}[${X.connectTo}]`}function Q(X){return`${Date.now()-X} ms`}}),define(he[105],ue([0,1,22]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=a,e.$in=C,e.$jn=A,e.$kn=T;function a(O){return O.scheme===R.Schemas.vscodeRemote?O.authority:void 0}function C(O){if(!O)return;const b=O.indexOf("+");return b<0?O:O.substr(0,b)}function A(O){const{host:b,port:I}=k(O);if(typeof I>"u")throw new Error(`Invalid remote authority: ${O}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:b,port:I}}function T(O,b){let{host:I,port:$}=k(O);return typeof $>"u"&&($=b),{host:I,port:$}}function k(O){const b=O.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const I=O.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const $=O.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:O,port:void 0}}}),define(he[34],ue([0,1,26,4,105]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$tn=e.$sn=e.$rn=e.TargetPlatform=e.ExtensionType=e.$qn=e.$on=e.$nn=e.$mn=e.$ln=void 0,e.$pn=A,e.$un=$,e.$vn=d,e.$wn=g,e.$xn=l,e.$yn=m,e.$zn=E,R=Oe(R),e.$ln="extensions.user.cache",e.$mn="extensions.builtin.cache",e.$nn="undefined_publisher",e.$on=["ui","workspace","web"];function A(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$qn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(T||(e.ExtensionType=T={}));var k;(function(f){f.WIN32_X64="win32-x64",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(k||(e.TargetPlatform=k={}));class O{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,P){if(typeof w>"u"||w===null)return typeof P>"u"||P===null;if(typeof P>"u"||P===null)return!1;if(typeof w=="string"||typeof P=="string"){const p=typeof w=="string"?w:w.value,c=typeof P=="string"?P:P.value;return R.$Ff(p,c)}return w._lower===P._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$rn=O;class b{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const P of w)this.add(P)}add(w){this.c.add(O.toKey(w))}delete(w){return this.c.delete(O.toKey(w))}has(w){return this.c.has(O.toKey(w))}}e.$sn=b;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(O.toKey(w))}get(w){return this.c.get(O.toKey(w))}has(w){return this.c.has(O.toKey(w))}set(w,P){this.c.set(O.toKey(w),P)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$tn=I;function $(f){return d(f)}function d(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}function g(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}function l(f,w){if(w){const P=`onResolveRemoteAuthority:${(0,C.$in)(w)}`;return!!f.activationEvents?.includes(P)}return!1}function m(f){return f.map(w=>{const[P,p]=w.split("@");return{proposalName:P,version:p?parseInt(p):void 0}})}function E(f){return f.map(w=>w.split("@")[0])}e.$An=(0,a.$Fi)("IBuiltinExtensionsScannerService")}),define(he[27],ue([0,1,5,11,34,4]),function(ae,e,R,a,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.ExtensionManagementErrorCode=e.$mp=e.ExtensionGalleryErrorCode=e.$lp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=void 0,e.$fp=k,e.$gp=O,e.$hp=b,e.$ip=I,e.$jp=$,e.$kp=d,e.$$o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$_o=new RegExp(e.$$o),e.$ap="__web_extension",e.$bp="skipWalkthrough",e.$cp="extensionInstallSource",e.$dp="dependecyOrPackExtensionInstall",e.$ep="clientTargetPlatform";var T;(function(c){c.COMMAND="command",c.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function k(c){switch(c){case C.TargetPlatform.WIN32_X64:return"Windows 64 bit";case C.TargetPlatform.WIN32_ARM64:return"Windows ARM";case C.TargetPlatform.LINUX_X64:return"Linux 64 bit";case C.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case C.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case C.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case C.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case C.TargetPlatform.DARWIN_X64:return"Mac";case C.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case C.TargetPlatform.WEB:return"Web";case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;case C.TargetPlatform.UNKNOWN:return C.TargetPlatform.UNKNOWN;case C.TargetPlatform.UNDEFINED:return C.TargetPlatform.UNDEFINED}}function O(c){switch(c){case C.TargetPlatform.WIN32_X64:return C.TargetPlatform.WIN32_X64;case C.TargetPlatform.WIN32_ARM64:return C.TargetPlatform.WIN32_ARM64;case C.TargetPlatform.LINUX_X64:return C.TargetPlatform.LINUX_X64;case C.TargetPlatform.LINUX_ARM64:return C.TargetPlatform.LINUX_ARM64;case C.TargetPlatform.LINUX_ARMHF:return C.TargetPlatform.LINUX_ARMHF;case C.TargetPlatform.ALPINE_X64:return C.TargetPlatform.ALPINE_X64;case C.TargetPlatform.ALPINE_ARM64:return C.TargetPlatform.ALPINE_ARM64;case C.TargetPlatform.DARWIN_X64:return C.TargetPlatform.DARWIN_X64;case C.TargetPlatform.DARWIN_ARM64:return C.TargetPlatform.DARWIN_ARM64;case C.TargetPlatform.WEB:return C.TargetPlatform.WEB;case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;default:return C.TargetPlatform.UNKNOWN}}function b(c,h){switch(c){case R.Platform.Windows:return h==="x64"?C.TargetPlatform.WIN32_X64:h==="arm64"?C.TargetPlatform.WIN32_ARM64:C.TargetPlatform.UNKNOWN;case R.Platform.Linux:return h==="x64"?C.TargetPlatform.LINUX_X64:h==="arm64"?C.TargetPlatform.LINUX_ARM64:h==="arm"?C.TargetPlatform.LINUX_ARMHF:C.TargetPlatform.UNKNOWN;case"alpine":return h==="x64"?C.TargetPlatform.ALPINE_X64:h==="arm64"?C.TargetPlatform.ALPINE_ARM64:C.TargetPlatform.UNKNOWN;case R.Platform.Mac:return h==="x64"?C.TargetPlatform.DARWIN_X64:h==="arm64"?C.TargetPlatform.DARWIN_ARM64:C.TargetPlatform.UNKNOWN;case R.Platform.Web:return C.TargetPlatform.WEB}}function I(c,h){return h===C.TargetPlatform.WEB&&!c.includes(C.TargetPlatform.WEB)}function $(c,h,i){return I(h,i)?!1:c===C.TargetPlatform.UNDEFINED||c===C.TargetPlatform.UNIVERSAL?!0:c===C.TargetPlatform.UNKNOWN?!1:c===i}function d(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}var g;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(g||(e.SortBy=g={}));var l;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(l||(e.SortOrder=l={}));var m;(function(c){c.Install="install",c.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var E;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$lp=(0,A.$Fi)("extensionGalleryService");var f;(function(c){c.Timeout="Timeout",c.Cancelled="Cancelled",c.Failed="Failed",c.DownloadFailedWriting="DownloadFailedWriting"})(f||(e.ExtensionGalleryErrorCode=f={}));class w extends Error{constructor(h,i){super(h),this.code=i,this.name=i}}e.$mp=w;var P;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleApi="IncompatibleApi",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.DownloadSignature="DownloadSignature",c.DownloadFailedWriting="DownloadFailedWriting",c.UpdateMetadata="UpdateMetadata",c.Extract="Extract",c.Scanning="Scanning",c.ScanningExtension="ScanningExtension",c.ReadUninstalled="ReadUninstalled",c.UnsetUninstalled="UnsetUninstalled",c.Delete="Delete",c.Rename="Rename",c.IntializeDefaultProfile="IntializeDefaultProfile",c.AddToProfile="AddToProfile",c.InstalledExtensionNotFound="InstalledExtensionNotFound",c.PostInstall="PostInstall",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.NotAllowed="NotAllowed",c.Gallery="Gallery",c.Cancelled="Cancelled",c.Unknown="Unknown",c.Internal="Internal"})(P||(e.ExtensionManagementErrorCode=P={}));class p extends Error{constructor(h,i){super(h),this.code=i,this.name=i}}e.$np=p,e.$op=(0,A.$Fi)("extensionManagementService"),e.$pp="extensionsIdentifiers/disabled",e.$qp="extensionsIdentifiers/enabled",e.$rp=(0,A.$Fi)("IGlobalExtensionEnablementService"),e.$sp=(0,A.$Fi)("IExtensionTipsService"),e.$tp=(0,a.localize2)(11501,"Extensions"),e.$up=(0,a.localize2)(11502,"Preferences")}),define(he[187],ue([0,1,3,2,29,9,94,27]),function(ae,e,R,a,C,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=void 0;function O(E,f){return E?A.URI.revive(f?f.transformIncoming(E):E):void 0}function b(E,f){return f?f.transformOutgoingURI(E):E}function I(E,f){f=f||T.$Nn;const w=E.manifest;return{...(0,T.$Qn)({...E,manifest:void 0},f),manifest:w}}function $(E,f){return E?.profileLocation?(0,T.$Qn)(E,f??T.$Nn):E}function d(E,f){return f?(0,C.$go)(E,w=>w instanceof A.URI?f.transformOutgoingURI(w):void 0):E}class g{constructor(f,w){this.a=f,this.b=w,this.onInstallExtension=R.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(f.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=R.Event.buffer(f.onDidUpdateExtensionMetadata,!0)}listen(f,w){const P=this.b(f);switch(w){case"onInstallExtension":return R.Event.map(this.onInstallExtension,p=>({...p,profileLocation:p.profileLocation?b(p.profileLocation,P):p.profileLocation}));case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,p=>p.map(c=>({...c,local:c.local?d(c.local,P):c.local,profileLocation:c.profileLocation?b(c.profileLocation,P):c.profileLocation})));case"onUninstallExtension":return R.Event.map(this.onUninstallExtension,p=>({...p,profileLocation:p.profileLocation?b(p.profileLocation,P):p.profileLocation}));case"onDidUninstallExtension":return R.Event.map(this.onDidUninstallExtension,p=>({...p,profileLocation:p.profileLocation?b(p.profileLocation,P):p.profileLocation}));case"onDidUpdateExtensionMetadata":return R.Event.map(this.onDidUpdateExtensionMetadata,p=>({local:d(p.local,P),profileLocation:b(p.profileLocation,P)}))}throw new Error("Invalid listen")}async call(f,w,P){const p=this.b(f);switch(w){case"zip":{const c=I(P[0],p),h=await this.a.zip(c);return b(h,p)}case"install":return this.a.install(O(P[0],p),$(P[1],p));case"installFromLocation":return this.a.installFromLocation(O(P[0],p),O(P[1],p));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(P[0],O(P[1],p),O(P[2],p));case"getManifest":return this.a.getManifest(O(P[0],p));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(P[0]);case"installFromGallery":return this.a.installFromGallery(P[0],$(P[1],p));case"installGalleryExtensions":{const c=P[0];return this.a.installGalleryExtensions(c.map(({extension:h,options:i})=>({extension:h,options:$(i,p)??{}})))}case"uninstall":return this.a.uninstall(I(P[0],p),$(P[1],p));case"uninstallExtensions":{const c=P[0];return this.a.uninstallExtensions(c.map(({extension:h,options:i})=>({extension:I(h,p),options:$(i,p)})))}case"reinstallFromGallery":return this.a.reinstallFromGallery(I(P[0],p));case"getInstalled":return(await this.a.getInstalled(P[0],O(P[1],p),P[2])).map(h=>d(h,p));case"toggleAppliationScope":{const c=await this.a.toggleAppliationScope(I(P[0],p),O(P[1],p));return d(c,p)}case"copyExtensions":return this.a.copyExtensions(O(P[0],p),O(P[1],p));case"updateMetadata":{const c=await this.a.updateMetadata(I(P[0],p),P[1],O(P[2],p));return d(c,p)}case"resetPinnedStateForAllUserExtensions":return this.a.resetPinnedStateForAllUserExtensions(P[0]);case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(P[0],P[1],P[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$xq=g;class l extends a.$Uc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(f){super(),this.m=f,this.c=this.B(new R.$le),this.f=this.B(new R.$le),this.g=this.B(new R.$le),this.h=this.B(new R.$le),this.j=this.B(new R.$le),this.B(this.m.listen("onInstallExtension")(w=>this.n(this.c,{...w,source:this.r(w.source)?A.URI.revive(w.source):w.source,profileLocation:A.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(w=>this.n(this.f,w.map(P=>({...P,local:P.local?I(P.local,null):P.local,source:this.r(P.source)?A.URI.revive(P.source):P.source,profileLocation:A.URI.revive(P.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(w=>this.n(this.g,{...w,profileLocation:A.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(w=>this.n(this.h,{...w,profileLocation:A.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(w=>this.n(this.j,{profileLocation:A.URI.revive(w.profileLocation),local:I(w.local,null)})))}n(f,w){f.fire(w)}r(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(f){const w=await this.getTargetPlatform();return f.allTargetPlatforms.some(P=>(0,k.$jp)(P,f.allTargetPlatforms,w))}zip(f){return Promise.resolve(this.m.call("zip",[f]).then(w=>A.URI.revive(w)))}install(f,w){return Promise.resolve(this.m.call("install",[f,w])).then(P=>I(P,null))}installFromLocation(f,w){return Promise.resolve(this.m.call("installFromLocation",[f,w])).then(P=>I(P,null))}async installExtensionsFromProfile(f,w,P){return(await this.m.call("installExtensionsFromProfile",[f,w,P])).map(c=>I(c,null))}getManifest(f){return Promise.resolve(this.m.call("getManifest",[f]))}installFromGallery(f,w){return Promise.resolve(this.m.call("installFromGallery",[f,w])).then(P=>I(P,null))}async installGalleryExtensions(f){return(await this.m.call("installGalleryExtensions",[f])).map(P=>({...P,local:P.local?I(P.local,null):P.local,source:this.r(P.source)?A.URI.revive(P.source):P.source,profileLocation:A.URI.revive(P.profileLocation)}))}uninstall(f,w){if(f.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[f,w]))}uninstallExtensions(f){if(f.some(w=>w.extension.isWorkspaceScoped))throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstallExtensions",[f]))}reinstallFromGallery(f){return Promise.resolve(this.m.call("reinstallFromGallery",[f])).then(w=>I(w,null))}getInstalled(f=null,w,P){return Promise.resolve(this.m.call("getInstalled",[f,w,P])).then(p=>p.map(c=>I(c,null)))}updateMetadata(f,w,P){return Promise.resolve(this.m.call("updateMetadata",[f,w,P])).then(p=>I(p,null))}resetPinnedStateForAllUserExtensions(f){return this.m.call("resetPinnedStateForAllUserExtensions",[f])}toggleAppliationScope(f,w){return this.m.call("toggleAppliationScope",[f,w]).then(P=>I(P,null))}copyExtensions(f,w){return this.m.call("copyExtensions",[f,w])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(f,w,P){const p=await this.m.call("download",[f,w,P]);return A.URI.revive(p)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$yq=l;class m{constructor(f){this.a=f}listen(f,w){throw new Error("Invalid listen")}call(f,w,P){switch(w){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(P[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$zq=m}),define(he[188],ue([0,1,2,34,7]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=void 0;class A extends R.$Uc{constructor(k,O,b,I,$){super(),this.a=k,this.b=O,this.c=b,this.f=$,this.B(I.onDidInstallExtensions(d=>this.g(d))),this.B(I.onDidUninstallExtension(d=>this.h(d)))}g(k){for(const O of k)O.local&&this.invalidate(O.profileLocation)}h(k){k.error||this.invalidate(k.profileLocation)}async invalidate(k){if(k)for(const O of this.a.profiles)this.c.extUri.isEqual(O.extensionsResource,k)&&await this.j(O);else await this.j(this.a.defaultProfile)}async j(k){try{await this.b.del(this.c.extUri.joinPath(k.cacheHome,a.$ln))}catch(O){(0,C.$rl)(O)!==C.FileOperationResult.FILE_NOT_FOUND&&this.f.error(O)}}}e.$Wq=A});var it=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(he[59],ue([0,1,20,92,11,60,34,159]),function(ae,e,R,a,C,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=I,e.$1p=$,e.$2p=d,e.$3p=g,e.$4p=l,e.$5p=m,e.$6p=E,e.$7p=f,a=it(a),C=Oe(C),A=Oe(A);const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function I(p){return p=p.trim(),p==="*"||O.test(p)}function $(p){if(!I(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=p.match(O);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}function d(p){if(!p)return null;const c=p.majorBase,h=p.majorMustEqual,i=p.minorBase;let n=p.minorMustEqual;const t=p.patchBase;let s=p.patchMustEqual;p.hasCaret&&(c===0||(n=!1),s=!1);let r=0;if(p.preRelease){const o=b.exec(p.preRelease);if(o){const[,u,y,N]=o;r=Date.UTC(Number(u),Number(y)-1,Number(N))}}return{majorBase:c,majorMustEqual:h,minorBase:i,minorMustEqual:n,patchBase:t,patchMustEqual:s,isMinimum:p.hasGreaterEquals,notBefore:r}}function g(p,c,h){let i;typeof p=="string"?i=d($(p)):i=p;let n;c instanceof Date?n=c.getTime():typeof c=="string"&&(n=new Date(c).getTime());let t;if(typeof h=="string"?t=d($(h)):t=h,!i||!t)return!1;const s=i.majorBase,r=i.minorBase,o=i.patchBase;let u=t.majorBase,y=t.minorBase,N=t.patchBase;const S=t.notBefore;let v=t.majorMustEqual,L=t.minorMustEqual,U=t.patchMustEqual;return t.isMinimum?s>u?!0:s<u?!1:r>y?!0:r<y||n&&n<S?!1:o>=N:(s===1&&u===0&&(!v||!L||!U)&&(u=1,y=0,N=0,v=!0,L=!1,U=!1),s<u?!1:s>u?!v:r<y?!1:r>y?!L:o<N?!1:o>N?!U:!(n&&n<S))}function l(p,c,h,i,n,t){const s=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return s.push([a.default.Error,C.localize(11432,null)]),s;if(typeof i.name!="string")return s.push([a.default.Error,C.localize(11433,null,"name")]),s;if(typeof i.version!="string")return s.push([a.default.Error,C.localize(11434,null,"version")]),s;if(!i.engines)return s.push([a.default.Error,C.localize(11435,null,"engines")]),s;if(typeof i.engines.vscode!="string")return s.push([a.default.Error,C.localize(11436,null,"engines.vscode")]),s;if(typeof i.extensionDependencies<"u"&&!P(i.extensionDependencies))return s.push([a.default.Error,C.localize(11437,null,"extensionDependencies")]),s;if(typeof i.activationEvents<"u"){if(!P(i.activationEvents))return s.push([a.default.Error,C.localize(11438,null,"activationEvents")]),s;if(typeof i.main>"u"&&typeof i.browser>"u")return s.push([a.default.Error,C.localize(11439,null,"activationEvents","main","browser")]),s}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&s.push([a.default.Warning,C.localize(11440,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return s.push([a.default.Error,C.localize(11441,null,"main")]),s;{const u=(0,R.$gh)(h,i.main);(0,R.$ah)(u,h)||s.push([a.default.Warning,C.localize(11442,null,u.path,h.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return s.push([a.default.Error,C.localize(11443,null,"browser")]),s;{const u=(0,R.$gh)(h,i.browser);(0,R.$ah)(u,h)||s.push([a.default.Warning,C.localize(11444,null,u.path,h.path)])}}if(!A.valid(i.version))return s.push([a.default.Error,C.localize(11445,null)]),s;const r=[];if(!m(p,c,i,n,r))for(const u of r)s.push([a.default.Error,u]);if(t&&i.enabledApiProposals?.length){const u=[];if(!f([...i.enabledApiProposals],u))for(const y of u)s.push([a.default.Error,y])}return s}function m(p,c,h,i,n){return i||typeof h.main>"u"&&typeof h.browser>"u"?!0:w(p,c,h.engines.vscode,n)}function E(p,c,h){return p==="*"||w(c,h,p)}function f(p,c){if(p.length===0)return!0;const h=Array.isArray(c)?c:void 0,i=(h?void 0:c)??k.allApiProposals,n=[],t=(0,T.$yn)(p);for(const{proposalName:s,version:r}of t){const o=i[s];o&&r&&o.version!==r&&n.push(C.localize(11446,null,s))}return h?.push(...n),n.length===0}function w(p,c,h,i=[]){const n=d($(h));if(!n)return i.push(C.localize(11447,null,h)),!1;if(n.majorBase===0){if(!n.majorMustEqual||!n.minorMustEqual)return i.push(C.localize(11448,null,h)),!1}else if(!n.majorMustEqual)return i.push(C.localize(11449,null,h)),!1;return g(p,c,n)?!0:(i.push(C.localize(11450,null,p,h)),!1)}function P(p){if(!Array.isArray(p))return!1;for(let c=0,h=p.length;c<h;c++)if(typeof p[c]!="string")return!1;return!0}}),define(he[78],ue([0,1,25,2,5,11,27,4]),function(ae,e,R,a,C,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=e.$_r=void 0,e.$$r=O;function O(I){return I.tags.find($=>$.startsWith("lp-"))?.split("lp-")[1]}e.$_r=(0,k.$Fi)("languagePackService");let b=class extends a.$Uc{constructor($){super(),this.c=$}async getAvailableLanguages(){const $=new R.$we;setTimeout(()=>$.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},$.token)}catch{return[]}const l=d.firstPage.filter(m=>m.properties.localizedLanguages?.length&&m.tags.some(E=>E.startsWith("lp-"))).map(m=>{const E=m.properties.localizedLanguages?.[0],f=O(m);return{...this.f(f,E,m),extensionId:m.identifier.id,galleryExtension:m}});return l.push(this.f("en","English")),l}f($,d,g){const l=d??$;let m;if(l!==$&&(m=`(${$})`),$.toLowerCase()===C.$x.toLowerCase()&&(m??="",m+=(0,A.localize)(11354,null)),g?.installCount){m??="";const E=g.installCount;let f;E>1e6?f=`${Math.floor(E/1e5)/10}M`:E>1e3?f=`${Math.floor(E/1e3)}K`:f=String(E),m+=` $(cloud-download) ${f}`}return{id:$,label:l,description:m}}};e.$as=b,e.$as=b=ve([Z(0,T.$lp)],b)}),define(he[189],ue([0,1,2,78]),function(ae,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fic=void 0;let C=class extends R.$Uc{constructor(T){super(),this.a=T,this.b()}b(){this.a.update()}};e.$fic=C,e.$fic=C=ve([Z(0,a.$_r)],C)}),define(he[106],ue([0,1,2,4]),function(ae,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=void 0,e.$Wl=(0,a.$Fi)("remoteSocketFactoryService");class C{constructor(){this.a={}}register(T,k){return this.a[T]??=[],this.a[T].push(k),(0,R.$Sc)(()=>{const O=this.a[T]?.indexOf(k);typeof O=="number"&&O>=0&&this.a[T]?.splice(O,1)})}b(T){return(this.a[T.type]||[]).find(O=>O.supports(T))}connect(T,k,O,b){const I=this.b(T);if(!I)throw new Error(`No socket factory found for ${T}`);return I.connect(T,k,O,b)}}e.$Xl=C}),define(he[190],ue([0,1,4]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tic=e.$sic=void 0,e.$sic=(0,R.$Fi)("sharedProcessTunnelService"),e.$tic="sharedProcessTunnel"}),define(he[107],ue([0,1,4,11]),function(ae,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dic=e.$Cic=e.$Bic=e.$Aic=e.$zic=e.TunnelStates=e.$yic=e.$xic=void 0,e.$xic=(0,R.$Fi)("IRemoteTunnelService"),e.$yic={active:!1};var C;(function(A){A.disconnected=T=>({type:"disconnected",onTokenFailed:T}),A.connected=(T,k)=>({type:"connected",info:T,serviceInstallFailed:k}),A.connecting=T=>({type:"connecting",progress:T}),A.uninitialized={type:"uninitialized"}})(C||(e.TunnelStates=C={})),e.$zic="remote.tunnels.access",e.$Aic=e.$zic+".hostNameOverride",e.$Bic=e.$zic+".preventSleep",e.$Cic="remoteTunnelService",e.$Dic=(0,a.localize)(11238,null)}),define(he[61],ue([0,1,14,8,2,11,47,4,10,44]),function(ae,e,R,a,C,A,T,k,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=void 0,e.$0p=d,e.$$p=g,e.$_p=l,e.$aq=m,e.$bq=E,e.$cq=f,e.$8p=(0,k.$Fi)("requestService");class I{constructor(c){this.b=c}toJSON(){if(!this.a){const c=Object.create(null);for(const h in this.b)h.toLowerCase()==="authorization"||h.toLowerCase()==="proxy-authorization"?c[h]="*****":c[h]=this.b[h];this.a=c}return this.a}}class $ extends C.$Uc{constructor(c){super(),this.b=0,this.a=c.createLogger("network",{name:(0,A.localize)(11219,null),when:O.$sk.isEqualTo((0,O.$pk)(O.LogLevel.Trace)).serialize()})}async c(c,h,i){const n=`${c} #${++this.b}: ${h.url}`;this.a.trace(`${n} - begin`,h.type,new I(h.headers??{}));try{const t=await i();return this.a.trace(`${n} - end`,h.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${n} - error`,h.type,(0,a.$9)(t)),t}}}e.$9p=$;function d(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}function g(p){return p.res.statusCode===204}async function l(p){return g(p)?null:(await(0,R.$Ze)(p.stream)).toString()}async function m(p){if(!d(p))throw new Error("Server returned "+p.res.statusCode);return l(p)}async function E(p){if(!d(p))throw new Error("Server returned "+p.res.statusCode);if(g(p))return null;const h=(await(0,R.$Ze)(p.stream)).toString();try{return JSON.parse(h)}catch(i){throw i.message+=`:
`+h,i}}function f(p){P(p)}let w;function P(p){const c=b.$ro.as(T.$wo.Configuration),h=w;w={id:"http",order:15,title:(0,A.localize)(11220,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(11221,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(11222,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(11223,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,A.localize)(11224,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(11225,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(11226,null),(0,A.localize)(11227,null),(0,A.localize)(11228,null),(0,A.localize)(11229,null)],default:"override",description:(0,A.localize)(11230,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11231,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(11232,null),restricted:!0}}},c.updateConfigurations({add:[w],remove:h?[h]:[]})}P(T.ConfigurationScope.APPLICATION)}),define(he[191],ue([0,1,25,22,7,61]),function(ae,e,R,a,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZR=void 0;let T=class{constructor(O,b){this.a=O,this.b=b}async download(O,b,I=R.CancellationToken.None){if(O.scheme===a.Schemas.file||O.scheme===a.Schemas.vscodeRemote){await this.b.copy(O,b);return}const $={type:"GET",url:O.toString(!0)},d=await this.a.request($,I);if(d.res.statusCode===200)await this.b.writeFile(b,d.stream);else{const g=await(0,A.$aq)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${g}`)}}};e.$ZR=T,e.$ZR=T=ve([Z(0,A.$8p),Z(1,C.$al)],T)}),define(he[192],ue([0,1,14,25]),function(ae,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=e.$cs=void 0;class C{constructor(k){this.a=k}listen(k,O){throw new Error("Invalid listen")}call(k,O,b,I=a.CancellationToken.None){switch(O){case"request":return this.a.request(b[0],I).then(async({res:$,stream:d})=>{const g=await(0,R.$Ze)(d);return[{statusCode:$.statusCode,headers:$.headers},g]});case"resolveProxy":return this.a.resolveProxy(b[0]);case"lookupAuthorization":return this.a.lookupAuthorization(b[0]);case"lookupKerberosAuthorization":return this.a.lookupKerberosAuthorization(b[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$cs=C;class A{constructor(k){this.a=k}async request(k,O){const[b,I]=await this.a.call("request",[k],O);return{res:b,stream:(0,R.$2e)(I)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}async lookupAuthorization(k){return this.a.call("lookupAuthorization",[k])}async lookupKerberosAuthorization(k){return this.a.call("lookupKerberosAuthorization",[k])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$ds=A}),define(he[193],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=e.$4gc=e.$3gc=void 0,e.$3gc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$4gc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$5gc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(he[194],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;class R{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(C){try{const A=await this.c();if(A){const T=String(R.a++);return this.b.set(T,A),{id:T,data:A.createNewMessage(C)}}}catch{}return{id:"",data:C}}async validate(C,A){if(!C.id)return!0;const T=this.b.get(C.id);if(!T)return!1;this.b.delete(C.id);try{return T.validate(A)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(C){try{return await this.d(C)}catch{}return C}}e.$Mcc=R}),define(he[108],ue([0,1,4]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.$Yl=void 0,e.$Yl="signService",e.$Zl=(0,R.$Fi)(e.$Yl)}),define(he[195],ue([0,1,194]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;class a extends R.$Mcc{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(T=>new T.signer().sign(A))}h(){return new Promise((A,T)=>ae(["vsda"],A,T))}}e.$Uhc=a}),define(he[79],ue([0,1,3,2]),function(ae,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bNb=e.$aNb=e.$_Mb=e.$$Mb=void 0;class C extends a.$Uc{constructor($,d,g){super(),this.a=$,this.b=d,this.c=g}async getItems(){const $={profile:this.b,workspace:this.c},d=await this.a.call("getItems",$);return new Map(d)}updateItems($){const d={profile:this.b,workspace:this.c};return $.insert&&(d.insert=Array.from($.insert.entries())),$.delete&&(d.delete=Array.from($.delete.values())),this.a.call("updateItems",d)}optimize(){const $={profile:this.b,workspace:this.c};return this.a.call("optimize",$)}}class A extends C{constructor($,d){super($,d,void 0),this.f=this.B(new R.$le),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})($=>this.h($)))}h($){(Array.isArray($.changed)||Array.isArray($.deleted))&&this.f.fire({changed:$.changed?new Map($.changed):void 0,deleted:$.deleted?new Set($.deleted):void 0})}}class T extends A{constructor($){super($,void 0)}async close(){this.dispose()}}e.$$Mb=T;class k extends A{constructor($,d){super($,d)}async close(){this.dispose()}}e.$_Mb=k;class O extends C{constructor($,d){super($,void 0,d),this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.$aNb=O;class b{constructor($){this.a=$}isUsed($){const d={payload:$,profile:void 0,workspace:void 0};return this.a.call("isUsed",d)}}e.$bNb=b}),define(he[109],ue([0,1,5,37,32]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=T,e.$wp=k;function A(O){if(R.$v===R.Platform.Linux&&/^penguin(\.|$)/i.test(O))return"chromebook"}function T(O,b,I,$,d,g,l,m,E,f){const w=Object.create(null);w["common.machineId"]=g,w["common.sqmId"]=l,w["common.devDeviceId"]=m,w.sessionID=(0,C.$2g)()+Date.now(),w.commitHash=$,w.version=d,w["common.platformVersion"]=(O||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,R.$i)(R.$v),w["common.nodePlatform"]=a.$dc,w["common.nodeArch"]=I,w["common.product"]=f||"desktop",E&&(w["common.msftInternal"]=E);let P=0;const p=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),R.$m&&(w["common.snap"]="true");const c=A(b);return c&&(w["common.platformDetail"]=c),w}function k(O){const b=a.env.USERDNSDOMAIN;if(!b)return!1;const I=b.toLowerCase();return O.some($=>I===$)}}),define(he[18],ue([0,1,4]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=void 0,e.$_l=(0,R.$Fi)("telemetryService"),e.$am=(0,R.$Fi)("customEndpointTelemetryService"),e.$bm="telemetry.currentSessionDate",e.$cm="telemetry.firstSessionDate",e.$dm="telemetry.lastSessionDate",e.$em="telemetry.machineId",e.$fm="telemetry.sqmId",e.$gm="telemetry.devDeviceId",e.$hm="telemetry",e.$im="telemetry.telemetryLevel",e.$jm="telemetry.enableCrashReporter",e.$km="telemetry.enableTelemetry";var a;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(a||(e.TelemetryLevel=a={}));var C;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(he[196],ue([0,1,33,38,6,36,22,13,5,54,9,142,30,149,97,7,23,18]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=void 0,e.$Ys=P,e.$Zs=c,e.$1s=h,R=Oe(R),a=Oe(a);const w=new Map;async function P(n,t){const s=`${n}::${t.join(":")}`,r=w.get(s);if(r)return r;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,y=new Map,N=2e4;function S(L,U,F,M){const K=U.substring(L.length+1);return C.Promises.withAsyncBody(async V=>{let x;M.readdirCount++;try{x=await d.Promises.readdir(U,{withFileTypes:!0})}catch{V();return}if(M.count>=N){M.count+=x.length,M.maxReached=!0,V();return}let H=x.length;if(H===0){V();return}let te=x;M.count+x.length>N&&(M.maxReached=!0,H=N-M.count,te=x.slice(0,H)),M.count+=x.length;for(const B of te)if(B.isDirectory()){if(F.includes(B.name)||await S(L,(0,k.$jc)(U,B.name),F,M),--H===0){V();return}}else{const z=B.name.lastIndexOf(".");if(z>=0){const _=B.name.substring(z+1);_&&u.set(_,(u.get(_)??0)+1)}for(const _ of o)_.relativePathPattern?.test(K)!==!1&&_.filePattern.test(B.name)&&y.set(_.tag,(y.get(_.tag)??0)+1);if(--H===0){V();return}}})}const v=C.Promises.withAsyncBody(async L=>{const U={count:0,maxReached:!1,readdirCount:0},F=new b.$fe(!0);await S(n,n,t,U);const M=await h(n);L({configFiles:p(y),fileTypes:p(u),fileCount:U.count,maxFilesReached:U.maxReached,launchConfigFiles:M,totalScanTime:F.elapsed(),totalReaddirCount:U.readdirCount})});return w.set(s,v),v}function p(n){return Array.from(n.entries(),([t,s])=>({name:t,count:s})).sort((t,s)=>s.count-t.count)}function c(){const n={os:`${a.type()} ${a.arch()} ${a.release()}`,memory:`${(a.totalmem()/m.$Il.GB).toFixed(2)}GB (${(a.freemem()/m.$Il.GB).toFixed(2)}GB free)`,vmHint:`${Math.round($.$Sn.value()*100)}%`},t=a.cpus();return t&&t.length>0&&(n.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),n}async function h(n){try{const t=new Map,s=(0,k.$jc)(n,".vscode","launch.json"),r=await R.promises.readFile(s),o=[],u=(0,A.$Yn)(r.toString(),o);if(o.length)return console.log(`Unable to parse ${s}`),[];if((0,A.$7n)(u)==="object"&&u.configurations)for(const y of u.configurations){const N=y.type;N&&(t.has(N)?t.set(N,t.get(N)+1):t.set(N,1))}return p(t)}catch{return[]}}let i=class{constructor(t,s){this.c=t,this.d=s}f(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}g(t){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${a.type()} ${a.arch()} ${a.release()}`);const r=a.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(a.totalmem()/m.$Il.GB).toFixed(2)}GB (${(a.freemem()/m.$Il.GB).toFixed(2)}GB free)`),O.$j||s.push(`Load (avg):       ${a.loadavg().map(o=>Math.round(o)).join(", ")}`),s.push(`VM:               ${Math.round($.$Sn.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([(0,g.$Xs)(t.mainPID),this.k(t)]).then(async r=>{let[o,u]=r,y=this.m(t,o);return s.forEach(N=>{if((0,l.$Um)(N))y+=`
${N.errorMessage}`,u+=`
${N.errorMessage}`;else if(y+=`

Remote: ${N.hostName}`,N.processes&&(y+=`
${this.m(t,N.processes)}`),N.workspaceMetadata){u+=`
|  Remote: ${N.hostName}`;for(const S of Object.keys(N.workspaceMetadata)){const v=N.workspaceMetadata[S];let L=`${v.fileCount} files`;v.maxFilesReached&&(L=`more than ${L}`),u+=`|    Folder (${S}): ${L}`,u+=this.h(v)}}}),{processInfo:y,workspaceInfo:u}})}async getSystemInfo(t,s){const{memory:r,vmHint:o,os:u,cpus:y}=c(),N={os:u,memory:r,cpus:y,vmHint:o,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return O.$j||(N.load=`${a.loadavg().map(S=>Math.round(S)).join(", ")}`),O.$l&&(N.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(N)}async getDiagnostics(t,s){const r=[];return(0,g.$Xs)(t.mainPID).then(async o=>(r.push(""),r.push(this.g(t)),r.push(""),r.push(this.m(t,o)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.k(t))),s.forEach(u=>{if((0,l.$Um)(u))r.push(`
${u.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${u.hostName}`),r.push(this.f(u.machineInfo)),u.processes&&r.push(this.m(t,u.processes)),u.workspaceMetadata)for(const y of Object.keys(u.workspaceMetadata)){const N=u.workspaceMetadata[y];let S=`${N.fileCount} files`;N.maxFilesReached&&(S=`more than ${S}`),r.push(`Folder (${y}): ${S}`),r.push(this.h(N))}}),r.push(""),r.push(""),r.join(`
`)))}h(t){const s=[];let o=0;const u=(v,L)=>{const U=` ${v}(${L})`;o+U.length>60?(s.push(y),y="|                 ",o=y.length):o+=U.length,y+=U};let y="|      File types:";const N=10,S=t.fileTypes.length>N?N:t.fileTypes.length;for(let v=0;v<S;v++){const L=t.fileTypes[v];u(L.name,L.count)}if(s.push(y),t.configFiles.length>=0&&(y="|      Conf files:",o=0,t.configFiles.forEach(v=>{u(v.name,v.count)}),s.push(y)),t.launchConfigFiles.length>0){let v="|      Launch Configs:";t.launchConfigFiles.forEach(L=>{const U=L.count>1?` ${L.name}(${L.count})`:` ${L.name}`;v+=U}),s.push(v)}return s.join(`
`)}j(t){const s=Math.max(...Object.keys(t).map(r=>r.length));return Object.keys(t).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${t[r]}`).join(`
                  `)}k(t){const s=[],r=[];return t.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(s.push(`|  Window (${o.title})`),o.folderURIs.forEach(u=>{const y=I.URI.revive(u);if(y.scheme===T.Schemas.file){const N=y.fsPath;r.push(P(N,["node_modules",".git"]).then(S=>{let v=`${S.fileCount} files`;S.maxFilesReached&&(v=`more than ${v}`),s.push(`|    Folder (${(0,k.$nc)(N)}): ${v}`),s.push(this.h(S))}).catch(S=>{s.push(`|      Error: Unable to collect workspace stats for folder ${N} (${S.toString()})`)}))}else s.push(`|    Folder (${y.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(o=>s.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(t,s){const r=new Map;t.windows.forEach(u=>r.set(u.pid,`window [${u.id}] (${u.title})`)),t.pidToNames.forEach(({pid:u,name:y})=>r.set(u,y));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),s&&this.n(t.mainPID,r,o,s,0),o.join(`
`)}n(t,s,r,o,u){const y=u===0;let N;y?N=o.pid===t?`${this.d.applicationName} main`:"remote agent":s.has(o.pid)?N=s.get(o.pid):N=`${"  ".repeat(u)} ${o.name}`;const S=process.platform==="win32"?o.mem:a.totalmem()*(o.mem/100);r.push(`${o.load.toFixed(0).padStart(5," ")}	${(S/m.$Il.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${N}`),Array.isArray(o.children)&&o.children.forEach(v=>this.n(t,s,r,v,u+1))}async getWorkspaceFileExtensions(t){const s=new Set;for(const{uri:r}of t.folders){const o=I.URI.revive(r);if(o.scheme!==T.Schemas.file)continue;const u=o.fsPath;try{(await P(u,["node_modules",".git"])).fileTypes.forEach(N=>s.add(N.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const r=I.URI.revive(s);if(r.scheme!==T.Schemas.file)continue;const o=r.fsPath;try{const u=await P(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(y=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),u.launchConfigFiles.forEach(y=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),u.configFiles.forEach(y=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:u.totalScanTime,reachedLimit:u.maxFilesReached,fileCount:u.fileCount,readdirCount:u.totalReaddirCount})}catch{}}}};e.$2s=i,e.$2s=i=ve([Z(0,f.$_l),Z(1,E.$tk)],i)}),define(he[110],ue([0,1,8,4,10,18]),function(ae,e,R,a,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=e.$uq=e.ExtensionSignatureVerificationCode=e.$tq=void 0,e.$tq=(0,a.$Fi)("IExtensionSignatureVerificationService");var T;(function(b){b.Success="Success",b.RequiredArgumentMissing="RequiredArgumentMissing",b.InvalidArgument="InvalidArgument",b.PackageIsUnreadable="PackageIsUnreadable",b.UnhandledException="UnhandledException",b.SignatureManifestIsMissing="SignatureManifestIsMissing",b.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",b.SignatureIsMissing="SignatureIsMissing",b.SignatureIsUnreadable="SignatureIsUnreadable",b.CertificateIsUnreadable="CertificateIsUnreadable",b.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",b.FileAlreadyExists="FileAlreadyExists",b.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",b.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",b.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",b.SignatureIsInvalid="SignatureIsInvalid",b.SignatureManifestIsInvalid="SignatureManifestIsInvalid",b.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",b.EntryIsMissing="EntryIsMissing",b.EntryIsTampered="EntryIsTampered",b.Untrusted="Untrusted",b.CertificateRevoked="CertificateRevoked",b.SignatureIsNotValid="SignatureIsNotValid",b.UnknownError="UnknownError",b.PackageIsInvalidZip="PackageIsInvalidZip",b.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(T||(e.ExtensionSignatureVerificationCode=T={}));class k extends Error{constructor(I){super(I),this.code=I}}e.$uq=k;let O=class{constructor(I,$){this.b=I,this.c=$}d(){return this.a||(this.a=new Promise((I,$)=>ae(["@vscode/vsce-sign"],async d=>I(d),$))),this.a}async verify(I,$,d,g){let l;const m=I.identifier.id;try{l=await this.d()}catch(P){return this.b.error("Could not load vsce-sign module",(0,R.$9)(P)),this.b.info(`Extension signature verification is not done: ${m}`),!1}const E=new Date().getTime();let f;try{this.b.trace(`Verifying extension signature for ${m}...`),f=await l.verify($,d,this.b.getLevel()===C.LogLevel.Trace)}catch(P){f={code:T.UnknownError,didExecute:!1,output:(0,R.$9)(P)}}const w=new Date().getTime()-E;if(this.b.info(`Extension signature verification result for ${m}: ${f.code}. Executed: ${f.didExecute}. Duration: ${w}ms.`),this.b.trace(`Extension signature verification output for ${m}:
${f.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:m,extensionVersion:I.version,code:f.code,internalCode:f.internalCode,duration:w,didExecute:f.didExecute,clientTargetPlatform:g}),f.code===T.Success)return!0;throw new k(f.code)}};e.$vq=O,e.$vq=O=ve([Z(0,C.$ak),Z(1,A.$_l)],O)}),define(he[111],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=e.$8gc=void 0;class R{constructor(A){this.b=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,{eventName:k,data:O}){return this.b.forEach(b=>b.log(k,O)),Promise.resolve(null)}}e.$8gc=R;class a{constructor(A){this.b=A}log(A,T){return this.b.call("log",{eventName:A,data:T}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$9gc=a}),define(he[48],ue([0,1,29,12,105,109,18]),function(ae,e,R,a,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=void 0,e.$Ep=I,e.$Fp=$,e.$Gp=d,e.$Hp=g,e.$Ip=m,e.$Jp=f,e.$Kp=w,e.$Lp=c;class k{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$xp=k;class O{constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$yp=O,e.$zp=new O;class b{async publicLog(i,n,t){}async publicLogError(i,n,t){}}e.$Ap=b,e.$Bp="telemetry",e.$Cp="extensionTelemetryLog",e.$Dp={log:()=>null,flush:()=>Promise.resolve(null)};function I(h,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!h.enableTelemetry)}function $(h,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||h.enableTelemetry&&h.aiConfig?.ariaKey)}function d(h){const i=h.getValue(T.$im),n=h.getValue(T.$jm);if(h.getValue(T.$km)===!1||n===!1)return T.TelemetryLevel.NONE;switch(i??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function g(h){const i={},n={},t={};E(h,t);for(let s in t){s=s.length>150?s.substr(s.length-149):s;const r=t[s];typeof r=="number"?n[s]=r:typeof r=="boolean"?n[s]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${r.length}`),i[s]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(i[s]=r)}return{properties:i,measurements:n}}const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function m(h){if(!h)return"none";const i=(0,C.$in)(h);return l.has(i)?i:"other"}function E(h,i,n=0,t){if(h)for(const s of Object.getOwnPropertyNames(h)){const r=h[s],o=t?t+s:s;Array.isArray(r)?i[o]=(0,R.$jo)(r):r instanceof Date?i[o]=r.toISOString():(0,a.$gg)(r)?n<2?E(r,i,n+1,o+"."):i[o]=(0,R.$jo)(r):i[o]=r}}function f(h,i){const n=h.msftInternalDomains||[],t=i.getValue("telemetry.internalTesting");return(0,A.$wp)(n)||t}function w(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}function P(h,i){if(!h||!h.includes("/")&&!h.includes("\\"))return h;let n=h;const t=[];for(const u of i)for(;;){const y=u.exec(h);if(!y)break;t.push([y.index,u.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(n="";;){const u=r.exec(h);if(!u)break;const y=t.some(([N,S])=>u.index<S&&N<r.lastIndex);!s.test(u[0])&&!y&&(n+=h.substring(o,u.index)+"<REDACTED: user-file-path>",o=r.lastIndex)}return o<h.length&&(n+=h.substr(o)),n}function p(h){if(!h)return h;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of i)if(n.regex.test(h))return`<REDACTED: ${n.label}>`;return h}function c(h,i){return(0,R.$go)(h,n=>{if(n instanceof k||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let t=n.replaceAll("%20"," ");t=P(t,i);for(const s of i)t=t.replace(s,"");return t=p(t),t}})}}),define(he[35],ue([0,1,26,27,34,5,9,8,37,48]),function(ae,e,R,a,C,A,T,k,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Np=void 0,e.$Mp=I,e.$Op=l,e.$Pp=m,e.$Qp=E,e.$Rp=f,e.$Sp=w,e.$Tp=P,e.$Up=p,e.$Wp=c,e.$Xp=i;function I(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,R.$Af)(n.id,t.id)===0}const $=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(t){const s=t.manifest?t.manifest.version:t.version,r=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new d(t.identifier,s,r)}static parse(t){const s=$.exec(t);return s&&s[1]&&s[2]?new d({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,r=C.TargetPlatform.UNDEFINED){this.identifier=t,this.version=s,this.targetPlatform=r,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==C.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof d?I(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Np=d;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function l(n){const t=g.exec(n);return t&&t[1]?[E(t[1]),t[2]]:[E(n),void 0]}function m(n,t){return`${n}.${t}`}function E(n){return n.toLowerCase()}function f(n,t){return E(m(n??C.$nn,t))}function w(n,t){const s=[],r=o=>{for(const u of s)if(u.some(y=>I(t(y),t(o))))return u;return null};for(const o of n){const u=r(o);u?u.push(o):s.push([o])}return s}function P(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function p(n){return{id:new b.$xp(n.identifier.id),name:new b.$xp(n.name),version:n.version,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Vp=new C.$rn("pprice.better-merge");function c(n,t){const s=[],r=t.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const o=r.shift();if(o&&s.every(u=>!I(u.identifier,{id:o}))){const u=n.filter(y=>I(y.identifier,{id:o}));u.length===1&&(s.push(u[0]),r.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function h(n,t){if(!A.$l)return!1;let s;try{s=(await n.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await n.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){t.debug("Error while getting the os-release file.",(0,k.$9)(o))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(n,t){const s=await h(n,t),r=(0,a.$hp)(s?"alpine":A.$v,O.$ec);return t.debug("ComputeTargetPlatform:",r),r}}),define(he[197],ue([0,1,25,27,35,34]),function(ae,e,R,a,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T7b=T;async function T(k,O,b,I,$){try{const d=await k.getExtensionsControlManifest();if(!d.deprecated)return;const g=await k.getInstalled(A.ExtensionType.User);for(const[l,m]of Object.entries(d.deprecated)){if(!m?.extension)continue;const{id:E,autoMigrate:f,preRelease:w}=m.extension;if(!f)continue;const P=g.find(c=>(0,C.$Mp)(c.identifier,{id:l}));if(!P)continue;const p=(await O.getExtensions([{id:E,preRelease:w}],{targetPlatform:await k.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!p){$.info(`Skipping migrating '${P.identifier.id}' extension because, the comaptible target '${E}' extension is not found`);continue}try{$.info(`Migrating '${P.identifier.id}' extension to '${E}' extension...`);const c=!I.getDisabledExtensions().some(i=>(0,C.$Mp)(i,P.identifier));await k.uninstall(P),$.info(`Uninstalled the unsupported extension '${P.identifier.id}'`);let h=g.find(i=>(0,C.$Mp)(i.identifier,{id:E}));(!h||!h.isPreReleaseVersion&&c)&&(h=await k.installFromGallery(p,{installPreReleaseVersion:!0,isMachineScoped:P.isMachineScoped,operation:a.InstallOperation.Migrate}),$.info(`Installed the pre-release extension '${h.identifier.id}'`),c||(await I.disableExtension(h.identifier),$.info(`Disabled the pre-release extension '${h.identifier.id}' because the unsupported extension '${P.identifier.id}' is disabled`)),f.storage&&(b.addToMigrationList((0,C.$Pp)(P.manifest.publisher,P.manifest.name),(0,C.$Pp)(h.manifest.publisher,h.manifest.name)),$.info("Added pre-release extension to the storage migration list"))),$.info(`Migrated '${P.identifier.id}' extension to '${E}' extension.`)}catch(c){$.error(c)}}}catch(d){$.error(d)}}}),define(he[198],ue([0,1,8,3,2,31,35,34,7]),function(ae,e,R,a,C,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=void 0;class b extends C.$Uc{constructor($,d,g,l,m,E,f){super(),this.f=$,this.g=d,this.h=g,this.j=l,this.m=m,this.n=E,this.r=f,this.a=this.B(new a.$le),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new C.$4c),this.s().then(null,w=>f.error("Error while initializing Extensions Watcher",(0,R.$9)(w)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles($=>this.u($.added))),this.B(this.j.onAddExtensions($=>this.w($))),this.B(this.j.onDidAddExtensions($=>this.y($))),this.B(this.j.onRemoveExtensions($=>this.z($))),this.B(this.j.onDidRemoveExtensions($=>this.C($))),this.B(this.n.onDidFilesChange($=>this.D($)))}async u($){try{$.length&&await Promise.all($.map(d=>(this.c.set(d.id,(0,C.$Rc)(this.n.watch(this.m.extUri.dirname(d.extensionsResource)),this.n.watch(d.extensionsResource))),this.G(d.extensionsResource))))}catch(d){throw this.r.error(d),d}}async w($){for(const d of $.extensions)this.I(this.L(d.identifier,d.version),$.profileLocation)}async y($){for(const d of $.extensions){const g=this.L(d.identifier,d.version);$.error?this.J(g,$.profileLocation):this.I(g,$.profileLocation)}}async z($){for(const d of $.extensions)this.J(this.L(d.identifier,d.version),$.profileLocation)}async C($){const d=[],g=[];for(const l of $.extensions){const m=this.L(l.identifier,l.version);$.error?this.I(m,$.profileLocation):(this.J(m,$.profileLocation),this.b.has(m)||(this.r.debug("Extension is removed from all profiles",l.identifier.id,l.version),g.push(this.f.scanInstalledExtensionAtLocation(l.location).then(E=>{E?d.push(E):this.r.info("Extension not found at the location",l.location.toString())},E=>this.r.error(E)))))}try{await Promise.all(g),d.length&&await this.H(d)}catch(l){this.r.error(l)}}D($){for(const d of this.h.profiles)$.contains(d.extensionsResource,O.FileChangeType.UPDATED,O.FileChangeType.ADDED)&&this.F(d.extensionsResource)}async F($){const d=[],g=[],l=await this.j.scanProfileExtensions($),m=new Set,E=new Set;for(const[f,w]of this.b)w.has($)&&E.add(f);for(const f of l){const w=this.L(f.identifier,f.version);m.add(w),E.has(w)||(d.push(f.identifier),this.I(w,$))}for(const f of E)if(!m.has(f)){const w=this.M(f);w&&(g.push(w.identifier),this.J(f,$))}(d.length||g.length)&&this.a.fire({added:d.length?{extensions:d,profileLocation:$}:void 0,removed:g.length?{extensions:g,profileLocation:$}:void 0})}async G($){const d=await this.j.scanProfileExtensions($);for(const g of d)this.I(this.L(g.identifier,g.version),$)}async H($){$||($=(await this.f.scanAllUserInstalledExtensions()).filter(g=>!this.b.has(this.L(g.identifier,g.manifest.version)))),$.length&&await this.f.markAsUninstalled(...$)}I($,d){let g=this.b.get($);g||this.b.set($,g=new A.$Bc(l=>this.m.extUri.getComparisonKey(l))),g.add(d)}J($,d){const g=this.b.get($);g&&g.delete(d),g?.size||this.b.delete($)}L($,d){return`${k.$rn.toKey($.id)}@${d}`}M($){const[d,g]=(0,T.$Op)($);return g?{identifier:{id:d},version:g}:void 0}}e.$Xq=b}),define(he[199],ue([0,1,33,75,17,6,2,22,13,30,15,27,35,10,78,9]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=void 0,R=Oe(R);let E=class extends l.$as{constructor(p,c,h,i){super(h),this.h=p,this.j=i,this.g=this.B(new f(c,i)),this.h.registerParticipant({postInstall:async n=>this.m(n),postUninstall:async n=>this.n(n)})}async getBuiltInExtensionTranslationsUri(p,c){const i=(await this.g.getLanguagePacks())[c];if(!i){this.j.warn(`No language pack found for ${c}`);return}const n=i.translations[p];return n?m.URI.file(n):void 0}async getInstalledLanguages(){const p=await this.g.getLanguagePacks(),c=Object.keys(p).map(h=>{const i=p[h];return{...this.f(h,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return c.push(this.f("en","English")),c.sort((h,i)=>h.label.localeCompare(i.label)),c}async m(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",p.identifier.id),await this.update())}async n(p){const c=await this.g.getLanguagePacks();Object.keys(c).some(h=>c[h]&&c[h].extensions.some(i=>(0,d.$Mp)(i.extensionIdentifier,p.identifier)))&&(this.j.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,c]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),h=await this.g.update(c);return!(0,C.$tb)(Object.keys(p),Object.keys(h))}};e.$bs=E,e.$bs=E=ve([Z(0,$.$op),Z(1,I.$Ni),Z(2,$.$lp),Z(3,g.$ak)],E);let f=class extends T.$Uc{constructor(p,c){super(),this.j=c,this.c={},this.f=(0,O.$jc)(p.userDataPath,"languagepacks.json"),this.g=new A.$Mh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(p){return this.s(c=>{Object.keys(c).forEach(h=>delete c[h]),this.m(c,...p)}).then(()=>this.c)}m(p,...c){for(const h of c)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.n(p,h);Object.keys(p).forEach(h=>this.r(p[h]))}n(p,c){const h=c.identifier,i=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const n of i)if(c.location.scheme===k.Schemas.file&&w(n)){let t=p[n.languageId];t||(t={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},p[n.languageId]=t);const s=t.extensions.filter(r=>(0,d.$Mp)(r.extensionIdentifier,h))[0];s?s.version=c.manifest.version:t.extensions.push({extensionIdentifier:h,version:c.manifest.version});for(const r of n.translations)t.translations[r.id]=(0,O.$jc)(c.location.fsPath,r.path)}}r(p){if(p){const c=(0,a.createHash)("md5");for(const h of p.extensions)c.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);p.hash=c.digest("hex")}}s(p=()=>null){return this.g.queue(()=>{let c=null;return R.promises.readFile(this.f,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch{return{}}}).then(h=>(c=p(h),h)).then(h=>{for(const n of Object.keys(h))h[n]||delete h[n];this.c=h,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),b.Promises.writeFile(this.f,i)}).then(()=>c,h=>this.j.error(h))})}};f=ve([Z(0,I.$Ni),Z(1,g.$ak)],f);function w(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const p of P.translations)if(typeof p.id!="string"||typeof p.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}}),define(he[200],ue([0,1,140,8,29,48]),function(ae,e,R,a,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xR=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0",k="https://mobile.events.data.microsoft.com/ping";async function O(I,$,d){const g=await(0,R.$CE)("@microsoft/1ds-core-js","dist/ms.core.js"),l=await(0,R.$CE)("@microsoft/1ds-post-js","dist/ms.post.js"),m=new g.AppInsightsCore,E=new l.PostChannel,f={instrumentationKey:I,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[E]]};if(d){f.extensionConfig={};const w={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};f.extensionConfig[E.identifier]=w}return m.initialize(f,[]),m.addTelemetryInitializer(w=>{w.ext=w.ext??{},w.ext.web=w.ext.web??{},w.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',$&&(w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),m}class b{constructor($,d,g,l,m){this.e=$,this.f=d,this.g=g,this.h=m,this.c=T,this.d=k,this.g||(this.g={}),typeof l=="function"?this.a=l():this.a=l,this.b=null}i($){if(this.a){if(typeof this.a!="string"){$(this.a);return}this.b||(this.b=O(this.a,this.e,this.h)),this.b.then(d=>{$(d)},d=>{(0,a.$Y)(d),console.error(d)})}}log($,d){if(!this.a)return;d=(0,C.$ho)(d,this.g),d=(0,A.$Hp)(d);const g=this.f+"/"+$;try{this.i(l=>{l.pluginVersionString=d?.properties.version??"Unknown",l.track({name:g,baseData:{name:g,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise($=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,$(void 0)})})}):Promise.resolve(void 0)}}e.$xR=b}),define(he[112],ue([0,1,2,11,15,10,23,48]),function(ae,e,R,a,C,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;let O=class extends R.$Uc{constructor(I,$,d,g,l=""){super(),this.b=l;const m=$.getLogger(k.$Bp);if(m)this.a=this.B(m);else{const f=(0,k.$Fp)(g,d)?" (Not Sent)":"",w=()=>(0,k.$Ep)(g,d)&&I.getLevel()===A.LogLevel.Trace;this.a=this.B($.createLogger(k.$Bp,{name:(0,a.localize)(11215,null,f),hidden:!w()})),this.B(I.onDidChangeLogLevel(()=>$.setVisibility(k.$Bp,w()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(I,$){this.a.trace(`${this.b}telemetry/${I}`,(0,k.$Hp)($))}};e.$jec=O,e.$jec=O=ve([Z(0,A.$ak),Z(1,A.$bk),Z(2,C.$Mi),Z(3,T.$tk)],O)});var it=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(he[113],ue([0,1,2,29,5,26,11,21,47,102,23,44,18,48]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=void 0,b=it(b);let l=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,w,P){this.k=w,this.l=P,this.d={},this.i=new R.$Tc,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=d.TelemetryLevel.USAGE,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,A.$hf)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$hf)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(d.$im)||p.affectsConfiguration(d.$km)||p.affectsConfiguration(d.$jm))&&this.m()}))}setExperimentProperty(f,w){this.d[f]=w}m(){let f=(0,g.$Gp)(this.k);const w=this.l.enabledTelemetryLevels;if(w){this.h=this.sendErrorTelemetry?w.error:!1;const P=w.usage?d.TelemetryLevel.USAGE:w.error?d.TelemetryLevel.ERROR:d.TelemetryLevel.NONE;f=Math.min(f,P)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,w,P){this.g<w||(P=(0,a.$ho)(P,this.d),P=(0,g.$Lp)(P,this.j),P=(0,a.$ho)(P,this.c),this.b.forEach(p=>p.log(f,P)))}publicLog(f,w){this.n(f,d.TelemetryLevel.USAGE,w)}publicLog2(f,w){this.publicLog(f,w)}publicLogError(f,w){this.h&&this.n(f,d.TelemetryLevel.ERROR,w)}publicLogError2(f,w){this.publicLogError(f,w)}};e.$hs=l,e.$hs=l=ve([Z(1,k.$_i),Z(2,I.$tk)],l);function m(){const E=(0,T.localize)(11197,null,b.default.nameLong),f=b.default.privacyStatementUrl?(0,T.localize)(11199,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,T.localize)(11198,null,"https://aka.ms/vscode-telemetry"),w=C.$p?"":(0,T.localize)(11200,null),P=(0,T.localize)(11201,null),p=(0,T.localize)(11202,null),c=(0,T.localize)(11203,null),h=(0,T.localize)(11204,null),i=`
|       | ${P} | ${p} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,T.localize)(11205,null);return`
${E} ${f} ${w}

&nbsp;

${h}
${i}

&nbsp;

${n}
`}$.$ro.as(O.$wo.Configuration).registerConfiguration({id:d.$hm,order:1,type:"object",title:(0,T.localize)(11206,null),properties:{[d.$im]:{type:"string",enum:[d.TelemetryConfiguration.ON,d.TelemetryConfiguration.ERROR,d.TelemetryConfiguration.CRASH,d.TelemetryConfiguration.OFF],enumDescriptions:[(0,T.localize)(11207,null),(0,T.localize)(11208,null),(0,T.localize)(11209,null),(0,T.localize)(11210,null)],markdownDescription:m(),default:d.TelemetryConfiguration.ON,restricted:!0,scope:O.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),$.$ro.as(O.$wo.Configuration).registerConfiguration({id:d.$hm,order:110,type:"object",title:(0,T.localize)(11211,null),properties:{[d.$km]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,T.localize)(11213,null,b.default.nameLong,b.default.privacyStatementUrl):(0,T.localize)(11212,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(11214,null,`\`#${d.$im}#\``),scope:O.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(he[201],ue([0,1,14,25,244,200]),function(ae,e,R,a,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yR=void 0,C=Oe(C);async function T(I,$){const d=await $.request(I,a.CancellationToken.None),g=(await(0,R.$Ze)(d.stream)).toString(),l=d.res.statusCode??200;return{headers:d.res.headers,statusCode:l,responseData:g}}async function k(I){const $={method:I.type,headers:I.headers};return new Promise((g,l)=>{const m=C.request(I.url??"",$,E=>{E.on("data",function(f){g({headers:E.headers,statusCode:E.statusCode??200,responseData:f.toString()})}),E.on("error",function(f){l(f)})});m.write(I.data,E=>{E&&l(E)}),m.end()})}async function O(I,$,d){const g=typeof $.data=="string"?$.data:new TextDecoder().decode($.data),l={type:"POST",headers:{...$.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength($.data).toString()},url:$.urlString,data:g};try{const m=I?await T(l,I):await k(l);d(m.statusCode,m.headers,m.responseData)}catch{d(0,{})}}class b extends A.$xR{constructor($,d,g,l,m){const E={sendPOST:(f,w)=>{O($,f,w)}};super(d,g,l,m,E)}}e.$yR=b}),define(he[202],ue([0,1,22,95,21,15,10,23,18,111,112,113]),function(ae,e,R,a,C,A,T,k,O,b,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=void 0;let d=class{constructor(l,m,E,f,w,P){this.b=l,this.c=m,this.d=E,this.e=f,this.f=w,this.g=P,this.a=new Map}h(l){if(!this.a.has(l.id)){const m=Object.create(null);m["common.vscodemachineid"]=this.c.machineId,m["common.vscodesessionid"]=this.c.sessionId;const E=[l.id,JSON.stringify(m),l.aiKey],w=new a.$ir(R.$Zg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:E,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),P=[new b.$9gc(w),new I.$jec(this.d,this.e,this.f,this.g,`[${l.id}] `)];this.a.set(l.id,new $.$hs({appenders:P,sendErrorTelemetry:l.sendErrorTelemetry},this.b,this.g))}return this.a.get(l.id)}publicLog(l,m,E){this.h(l).publicLog(m,E)}publicLogError(l,m,E){this.h(l).publicLogError(m,E)}};e.$kic=d,e.$kic=d=ve([Z(0,C.$_i),Z(1,O.$_l),Z(2,T.$ak),Z(3,T.$bk),Z(4,A.$Mi),Z(5,k.$tk)],d)}),define(he[80],ue([0,1,3,2,5,9,21,4,10]),function(ae,e,R,a,C,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pw=e.$Ow=e.$Lw=e.$Jw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Fw=e.$Ew=void 0,e.$Gw=$,e.$Hw=g,e.$Iw=l,e.$Kw=m,e.$Mw=E,e.$Nw=f,e.$Ew=(0,k.$Fi)("tunnelService"),e.$Fw=(0,k.$Fi)("sharedTunnelsService");var b;(function(p){p.Http="http",p.Https="https"})(b||(e.TunnelProtocol=b={}));var I;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(I||(e.TunnelPrivacyId=I={}));function $(p){return!!p.forwardPort}var d;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function g(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(c)return{address:c[1],port:+c[2]}}function l(p){if(p.scheme!=="http"&&p.scheme!=="https"||!p.query)return;const c=p.query.split("&");for(const h of c){const i=h.split("=")[1];if(/^https?:/.exec(i)){const n=g(A.URI.parse(i));if(n)return n}}}e.$Jw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function m(p){return e.$Jw.indexOf(p)>=0}e.$Lw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(p){return e.$Lw.indexOf(p)>=0}function f(p,c,h,i){if(h===C.OperatingSystem.Windows)return!1;if(h===C.OperatingSystem.Macintosh&&E(c)){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(n?.length===4&&parseInt(n[1])>=18)return!1}return p<1024}class w{constructor(c,h,i){this.remoteAddress=c,this.localAddress=h,this.b=i,this.a=new R.$le,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Ow=w;let P=class extends a.$Uc{constructor(c,h){super(),this.r=c,this.s=h,this.a=new R.$le,this.onTunnelOpened=this.a.event,this.b=new R.$le,this.onTunnelClosed=this.b.event,this.c=new R.$le,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const c=this.s.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.g=c,c?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.h=c.elevation,this.m=c.privacyOptions,this.j=c.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const c=[],h=Array.from(this.f.values());for(const i of h){const n=Array.from(i.values());for(const t of n){const s=await t.value;s&&typeof s!="string"&&c.push(s)}}return c}async dispose(){super.dispose();for(const c of this.f.values()){for(const{value:h}of c.values())await h.then(i=>typeof i!="string"?i?.dispose():void 0);c.clear()}this.f.clear()}setEnvironmentTunnel(c,h,i,n,t){this.z(c,h,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:h,localAddress:i,privacy:n,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,h){(E(c)||m(c))&&(c=e.$Jw[0]);const i=this.D(c,h);if(i)return++i.refcount,i.value}openTunnel(c,h,i,n,t,s=!1,r,o){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${i} on local port ${t}.`);const u=this.g??c;if(!u)return;if(h||(h="localhost"),n||(n=this.t),this.g&&this.n.has(i)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.F(u,h,i,n,t,s,r,o);return y?y.then(N=>{if(N){if(typeof N=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(h,i),N}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(h,i);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.w(N);return(N.tunnelRemoteHost!==h||N.tunnelRemotePort!==i)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&N.privacy!==r&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}w(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const h=this.f.get(c.tunnelRemoteHost);if(h){const i=h.get(c.tunnelRemotePort);i&&(i.refcount--,await this.y(c.tunnelRemoteHost,c.tunnelRemotePort,i))}}}}async y(c,h,i){if(i.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${h}.`);const n=i.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this.b.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this.f.has(c)&&this.f.get(c).delete(h),n}}async closeTunnel(c,h){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${h} `);const i=this.f.get(c);if(i&&i.has(h)){const n=i.get(h);n.refcount=0,await this.y(c,h,n)}}z(c,h,i){this.f.has(c)||this.f.set(c,new Map),this.f.get(c).set(h,{refcount:1,value:i})}async C(c,h){const i=this.f.get(c);if(i){const n=i.get(h),t=n?await n.value:void 0;(!t||typeof t=="string")&&i.delete(h),i.size===0&&this.f.delete(c)}}D(c,h){const i=[c];m(c)?(i.push(...e.$Jw),i.push(...e.$Lw)):E(c)&&i.push(...e.$Lw);const n=i.map(t=>this.f.get(t));for(const t of n){const s=t?.get(h);if(s)return s}}canTunnel(c){return!!g(c)}G(c,h,i,n,t,s,r){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${i} on local port ${n}.`);const o=i;this.n.add(o);const u=n===void 0?i:n,y={elevationRequired:t?this.isPortPrivileged(u):!1},N={remoteAddress:{host:h,port:i},localAddressPort:n,privacy:s,public:s?s!==I.Private:void 0,protocol:r},S=c.forwardPort(N,y);return S?(this.z(h,i,S),S.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(o)})):this.n.delete(o),S}};e.$Pw=P,e.$Pw=P=ve([Z(0,O.$ak),Z(1,T.$_i)],P)}),define(he[203],ue([0,1,10,80,2,8,6]),function(ae,e,R,a,C,A,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=void 0;class O extends C.$Uc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new T.$3h),this.b.p)}setAddress($){this.a=$,this.b&&(this.b.complete($),this.b=null)}setTunnel($){this.B($)}}let b=class extends C.$Uc{static{k=this}static{this.a=0}constructor($,d){super(),this.f=$,this.g=d,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach($=>$.dispose())}async createTunnel(){return{id:String(++k.a)}}async startTunnel($,d,g,l,m,E,f){const w=new O,P=await Promise.resolve(this.f.openTunnel($,w,g,l,m,E,f));if(!P||typeof P=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${g}:${l} (remote).`),w.dispose(),new Error("Could not create tunnel");if(this.c.has(d))throw this.c.delete(d),w.dispose(),await P.dispose(),(0,A.$5)();return w.setTunnel(P),this.b.set(d,w),this.g.info(`[SharedProcessTunnelService] Created tunnel ${d}: ${P.localAddress} (local) to ${g}:${l} (remote).`),{tunnelLocalPort:P.tunnelLocalPort,localAddress:P.localAddress}}async setAddress($,d){const g=this.b.get($);g&&g.setAddress(d)}async destroyTunnel($){const d=this.b.get($);if(d){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${$}.`),this.b.delete($),await d.dispose();return}this.c.add($)}};e.$uic=b,e.$uic=b=k=ve([Z(0,a.$Fw),Z(1,R.$ak)],b)}),define(he[28],ue([0,1,4]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=void 0,e.$Kl=(0,R.$Fi)("IUriIdentityService")}),define(he[204],ue([0,1,28,160,7,20,135,3,2]),function(ae,e,R,a,C,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0;class b{static{this._clock=0}constructor(d){this.uri=d,this.time=b._clock++}touch(){return this.time=b._clock++,this}}let I=class{constructor(d){this.g=d,this.c=new O.$Tc,this.f=2**16;const g=new Map,l=m=>{let E=g.get(m.scheme);return E===void 0&&(E=d.hasProvider(m)&&!this.g.hasCapability(m,C.FileSystemProviderCapabilities.PathCaseSensitive),g.set(m.scheme,E)),E};this.c.add(k.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(m=>{g.delete(m.scheme)})),this.extUri=new A.$8g(l),this.d=new T.$Ts((m,E)=>this.extUri.compare(m,E,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,A.$hh)(d));const g=this.d.get(d);return g?g.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new b(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((l,m)=>l[1].time<m[1].time?1:l[1].time>m[1].time?-1:0);b._clock=0,this.d.clear();const g=this.f*.5;for(let l=0;l<g;l++)this.d.set(d[l][0],d[l][1].touch())}};e.$Us=I,e.$Us=I=ve([Z(0,C.$al)],I),(0,a.$Rs)(R.$Kl,I,a.InstantiationType.Delayed)}),define(he[205],ue([0,1,3,2,7,51,31]),function(ae,e,R,a,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=void 0;class k extends a.$Uc{constructor(b,I,$,d,g,l){super(),this.f=b,this.g=I,this.h=$,this.j=d,this.m=g,this.n=l,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new R.$le),this.onDidChangeFile=this.a.event,this.b=A.$Li.forUris(()=>!(this.capabilities&C.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new T.$Bc(m=>this.m.extUri.getComparisonKey(this.t(m))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(m=>this.s(m)))}r(){this.c.clear();for(const b of this.j.profiles)this.c.add(b.settingsResource),this.c.add(b.keybindingsResource),this.c.add(b.tasksResource),this.c.add(b.extensionsResource)}open(b,I){return this.g.open(this.t(b),I)}close(b){return this.g.close(b)}read(b,I,$,d,g){return this.g.read(b,I,$,d,g)}write(b,I,$,d,g){return this.g.write(b,I,$,d,g)}watch(b,I){this.b.set(b,b);const $=this.g.watch(this.t(b),I);return(0,a.$Sc)(()=>{this.b.delete(b),$.dispose()})}stat(b){return this.g.stat(this.t(b))}mkdir(b){return this.g.mkdir(this.t(b))}rename(b,I,$){return this.g.rename(this.t(b),this.t(I),$)}readFile(b,I){return this.g.readFile(this.t(b),I)}readFileStream(b,I,$){return this.g.readFileStream(this.t(b),I,$)}readdir(b){return this.g.readdir(this.t(b))}enforceAtomicReadFile(b){return this.c.has(b)}writeFile(b,I,$){return this.g.writeFile(this.t(b),I,$)}enforceAtomicWriteFile(b){return this.c.has(b)?{postfix:".vsctmp"}:!1}delete(b,I){return this.g.delete(this.t(b),I)}copy(b,I,$){if((0,C.$el)(this.g))return this.g.copy(this.t(b),this.t(I),$);throw new Error("copy not supported")}cloneFile(b,I){if((0,C.$fl)(this.g))return this.g.cloneFile(this.t(b),this.t(I));throw new Error("clone not supported")}s(b){const I=[];for(const $ of b){if($.resource.scheme!==this.f)continue;const d=this.u($.resource);this.b.findSubstr(d)&&I.push({resource:d,type:$.type,cId:$.cId})}I.length&&(this.n.debug("User data changed"),this.a.fire(I))}t(b){return b.with({scheme:this.f})}u(b){return b.with({scheme:this.h})}}e.$Xhc=k}),define(he[81],ue([0,1,64]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=a,e.$QMb=C,e.$RMb=A;function a(T,k,O,b){const I=(0,R.$ao)(T,k,O,b)[0];return I&&(T=T.substring(0,I.offset)+I.content+T.substring(I.offset+I.length)),T}function C(T,k,O){let b=O;for(;b>=0;){if(T.charAt(b)===k.charAt(k.length-1)&&k.length===1)return b+1;if(b--,k.length===2&&b>=0&&T.charAt(b)===k.charAt(0))return b+2}return 0}function A(T,k,O){let b=O;for(;b>=0;)if(T.charAt(b)===k.charAt(k.length-1)&&k.length===1||(b++,k.length===2&&b>=0&&T.charAt(b)===k.charAt(1)))return b;return T.length-1}}),define(he[206],ue([0,1,29,60,12]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=A,a=Oe(a);function A(g,l,m,E,f,w){const P=[],p=[],c=[];if(!l){const M=g.filter(({identifier:K})=>f.every(V=>V.toLowerCase()!==K.id.toLowerCase()));return{local:{added:P,removed:p,updated:c},remote:M.length>0?{added:M,updated:[],removed:[],all:M}:null}}g=g.map($),l=l.map($),m=m?m.map($):null;const h=new Map,i=M=>{M.uuid&&h.set(M.id.toLowerCase(),M.uuid)};g.forEach(({identifier:M})=>i(M)),l.forEach(({identifier:M})=>i(M)),m?.forEach(({identifier:M})=>i(M)),E?.forEach(({identifier:M})=>i(M)),w?.forEach(M=>i(M));const n=M=>{const K=M.identifier.uuid||h.get(M.identifier.id.toLowerCase());return K?`uuid:${K}`:`id:${M.identifier.id.toLowerCase()}`},t=(M,K)=>(M.set(n(K),K),M),s=g.reduce(t,new Map),r=l.reduce(t,new Map),o=l.reduce((M,K)=>t(M,(0,R.$eo)(K)),new Map),u=m?m.reduce(t,new Map):null,y=E.reduce(t,new Map),N=f.reduce((M,K)=>{const V=h.get(K.toLowerCase());return M.add(V?`uuid:${V}`:`id:${K.toLowerCase()}`)},new Set),S=w?w.reduce((M,{id:K,uuid:V})=>(V=V??h.get(K.toLowerCase()),M.add(V?`uuid:${V}`:`id:${K.toLowerCase()}`)),new Set):null,v=T(s,r,N,!1);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const M=T(u,s,N,!1),K=T(u,r,N,!0),V=(x,H,te,B)=>{let z,_,ne;return H.installed?(z=B.pinned,ne=B.preRelease,z&&(_=B.version)):(z=te.pinned,ne=te.preRelease,z&&(_=te.version)),z===void 0&&(z=H.pinned,z&&(_=H.version)),ne===void 0&&(ne=H.preRelease),{...B,installed:H.installed||te.installed,pinned:z,preRelease:ne,version:_??(te.version&&(!H.installed||a.gt(te.version,H.version))?te.version:H.version),state:O(H,te,u?.get(x))}};for(const x of K.removed.values()){const H=s.get(x);if(!H)continue;const te=(0,C.$pg)(u?.get(x)),B=S&&!S.has(x)&&te.installed;H.installed&&B?p.push(H.identifier):o.set(x,H)}for(const x of K.added.values()){const H=(0,C.$pg)(r.get(x)),te=s.get(x);if(te){if(v.updated.has(x)){const B=V(x,te,H,H);k(te,H,!1,!1)||c.push(d(B,x)),o.set(x,B)}}else H.installed&&P.push(d(H,x))}for(const x of K.updated.values()){const H=(0,C.$pg)(r.get(x)),te=(0,C.$pg)(u?.get(x)),B=s.get(x);if(B)if(S&&!S.has(x)&&te.installed&&B.installed&&!H.installed)p.push(B.identifier);else{const _=V(x,B,H,H);c.push(d(_,x)),o.set(x,_)}else H.installed&&P.push(d(H,x))}for(const x of M.added.values())K.added.has(x)||o.set(x,(0,C.$pg)(s.get(x)));for(const x of M.updated.values()){if(K.removed.has(x)||K.updated.has(x))continue;const H=(0,C.$pg)(s.get(x)),te=(0,C.$pg)(r.get(x));o.set(x,V(x,H,te,H))}for(const x of M.removed.values())K.updated.has(x)||K.removed.has(x)||y.has(x)||(0,C.$pg)(r.get(x)).installed&&S&&(S.has(x)||!(0,C.$pg)(u?.get(x)).installed||o.delete(x))}const L=[],U=T(r,o,new Set,!0),F=U.added.size>0||U.updated.size>0||U.removed.size>0;return F&&o.forEach((M,K)=>L.push(d(M,K))),{local:{added:P,removed:p,updated:c},remote:F?{added:[...U.added].map(M=>o.get(M)),updated:[...U.updated].map(M=>o.get(M)),removed:[...U.removed].map(M=>r.get(M)),all:L}:null}}function T(g,l,m,E){const f=g?[...g.keys()].filter(h=>!m.has(h)):[],w=[...l.keys()].filter(h=>!m.has(h)),P=w.filter(h=>!f.includes(h)).reduce((h,i)=>(h.add(i),h),new Set),p=f.filter(h=>!w.includes(h)).reduce((h,i)=>(h.add(i),h),new Set),c=new Set;for(const h of f){if(p.has(h))continue;const i=g.get(h),n=l.get(h);(!n||!k(i,n,E,!0))&&c.add(h)}return{added:P,removed:p,updated:c}}function k(g,l,m,E){return!(g.disabled!==l.disabled||!!g.isApplicationScoped!=!!l.isApplicationScoped||E&&g.installed!==l.installed||g.installed&&l.installed&&(g.preRelease!==l.preRelease||g.pinned!==l.pinned||l.pinned&&g.version!==l.version)||!I(g.state,l.state)||m&&g.version!==l.version)}function O(g,l,m){const E=g.state,f=l.state,w=m?.state;if(!l.version||E&&a.gt(g.version,l.version))return E;if(f&&a.gt(l.version,g.version)||!E)return f;if(!f)return E;const P=(0,R.$eo)(E),p=w?b(w,f):{added:Object.keys(f).reduce((h,i)=>(h.add(i),h),new Set),removed:new Set,updated:new Set},c=w?b(w,E):{added:Object.keys(E).reduce((h,i)=>(h.add(i),h),new Set),removed:new Set,updated:new Set};for(const h of[...p.added.values(),...p.updated.values()])P[h]=f[h];for(const h of p.removed.values())c.updated.has(h)||delete P[h];return P}function b(g,l){const m=Object.keys(g),E=Object.keys(l),f=E.filter(p=>!m.includes(p)).reduce((p,c)=>(p.add(c),p),new Set),w=m.filter(p=>!E.includes(p)).reduce((p,c)=>(p.add(c),p),new Set),P=new Set;for(const p of m){if(w.has(p))continue;const c=g[p],h=l[p];(0,R.$io)(c,h)||P.add(p)}return{added:f,removed:w,updated:P}}function I(g={},l={}){const{added:m,removed:E,updated:f}=b(g,l);return m.size===0&&E.size===0&&f.size===0}function $(g){return{...g,disabled:!!g.disabled,installed:!!g.installed}}function d(g,l){const m={...g,identifier:{id:g.identifier.id,uuid:l.startsWith("uuid:")?l.substring(5):void 0},preRelease:!!g.preRelease,pinned:!!g.pinned};return g.disabled||delete m.disabled,g.installed||delete m.installed,g.state||delete m.state,g.isApplicationScoped||delete m.isApplicationScoped,m}}),define(he[114],ue([0,1,17,21,4]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Ob=e.$7Ob=void 0,e.$7Ob=(0,C.$Fi)("IIgnoredExtensionsManagementService");let A=class{constructor(k){this.a=k}hasToNeverSyncExtension(k){return this.b().includes(k.toLowerCase())}hasToAlwaysSyncExtension(k){return this.b().includes(`-${k.toLowerCase()}`)}updateIgnoredExtensions(k,O){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return b=b.filter(I=>I!==k&&I!==`-${k}`),O&&b.push(k.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,a.ConfigurationTarget.USER)}updateSynchronizedExtensions(k,O){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return b=b.filter(I=>I!==k&&I!==`-${k}`),O&&b.push(`-${k.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,a.ConfigurationTarget.USER)}getIgnoredExtensions(k){const O=k.filter(d=>d.isMachineScoped).map(d=>d.identifier.id.toLowerCase()),b=this.b().map(d=>d.toLowerCase()),I=[],$=[];if(Array.isArray(b))for(const d of b)d.startsWith("-")?$.push(d.substring(1)):I.push(d);return(0,R.$Lb)([...O,...I].filter(d=>!$.includes(d)))}b(){let k=this.a.inspect("settingsSync.ignoredExtensions").userValue;return k!==void 0||(k=this.a.inspect("sync.ignoredExtensions").userValue,k!==void 0)?k:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(O=>O.toLowerCase())}};e.$8Ob=A,e.$8Ob=A=ve([Z(0,a.$_i)],A)}),define(he[207],ue([0,1,17,36,29,96,81]),function(ae,e,R,a,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=O,C=Oe(C),T=Oe(T);function k(p){return(0,a.$Yn)(p)||[]}async function O(p,c,h,i,n){const t=k(p),s=k(c),r=h?k(h):null,o=[...t,...s,...r||[]].map(V=>V.key),u=await n.resolveUserBindings(o),y=I(t,s,r,u);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:p,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:p,hasChanges:!0,hasConflicts:!1};const N=d(t),S=d(s),v=r?d(r):null,L=l(N,S,u),U=v?l(v,N,u):{added:[...N.keys()].reduce((V,x)=>(V.add(x),V),new Set),removed:new Set,updated:new Set},F=v?l(v,S,u):{added:[...S.keys()].reduce((V,x)=>(V.add(x),V),new Set),removed:new Set,updated:new Set},M=b(L,U,F);let K=p;for(const V of M.removed.values())M.conflicts.has(V)||(K=w(K,V,i));for(const V of M.added.values()){if(M.conflicts.has(V))continue;const x=S.get(V);if(x.some(H=>H.command!==`-${V}`&&y.conflicts.has(u[H.key]))){M.conflicts.add(V);continue}K=f(K,x,i)}for(const V of M.updated.values()){if(M.conflicts.has(V))continue;const x=S.get(V);if(x.some(H=>H.command!==`-${V}`&&y.conflicts.has(u[H.key]))){M.conflicts.add(V);continue}K=P(K,V,x,i)}return{mergeContent:K,hasChanges:!0,hasConflicts:M.conflicts.size>0}}function b(p,c,h){const i=new Set,n=new Set,t=new Set,s=new Set;for(const r of c.removed.values())h.updated.has(r)&&s.add(r);for(const r of h.removed.values())s.has(r)||(c.updated.has(r)?s.add(r):n.add(r));for(const r of c.added.values())s.has(r)||h.added.has(r)&&p.updated.has(r)&&s.add(r);for(const r of h.added.values())s.has(r)||(c.added.has(r)?p.updated.has(r)&&s.add(r):i.add(r));for(const r of c.updated.values())s.has(r)||h.updated.has(r)&&p.updated.has(r)&&s.add(r);for(const r of h.updated.values())s.has(r)||(c.updated.has(r)?p.updated.has(r)&&s.add(r):t.add(r));return{added:i,removed:n,updated:t,conflicts:s}}function I(p,c,h,i){const n=new Set,t=$(p,i),s=$(c,i),r=h?$(h,i):null,o=g(t,s);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const u=r?g(r,t):{added:[...t.keys()].reduce((U,F)=>(U.add(F),U),new Set),removed:new Set,updated:new Set};if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const y=r?g(r,s):{added:[...s.keys()].reduce((U,F)=>(U.add(F),U),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:N,removed:S,updated:v,conflicts:L}=b(o,u,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:N,removed:S,updated:v,conflicts:L}}function $(p,c){const h=new Map;for(const i of p){const n=c[i.key];let t=h.get(n);t||(t=[],h.set(n,t)),t.push(i)}return h}function d(p){const c=new Map;for(const h of p){const i=h.command[0]==="-"?h.command.substring(1):h.command;let n=c.get(i);n||(n=[],c.set(i,n)),n.push(h)}return c}function g(p,c){const h=[...p.keys()],i=[...c.keys()],n=i.filter(r=>!h.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),t=h.filter(r=>!i.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),s=new Set;for(const r of h){if(t.has(r))continue;const o=p.get(r).map(y=>({...y,key:r})),u=c.get(r).map(y=>({...y,key:r}));(0,R.$tb)(o,u,(y,N)=>E(y,N))||s.add(r)}return{added:n,removed:t,updated:s}}function l(p,c,h){const i=[...p.keys()],n=[...c.keys()],t=n.filter(o=>!i.includes(o)).reduce((o,u)=>(o.add(u),o),new Set),s=i.filter(o=>!n.includes(o)).reduce((o,u)=>(o.add(u),o),new Set),r=new Set;for(const o of i){if(s.has(o))continue;const u=p.get(o).map(N=>({...N,key:h[N.key]})),y=c.get(o).map(N=>({...N,key:h[N.key]}));m(u,y)||r.add(o)}return{added:t,removed:s,updated:r}}function m(p,c){return!(!(0,R.$tb)(p.filter(({command:h})=>h[0]!=="-"),c.filter(({command:h})=>h[0]!=="-"),(h,i)=>E(h,i))||!(0,R.$tb)(p.filter(({command:h})=>h[0]==="-"),c.filter(({command:h})=>h[0]==="-"),(h,i)=>E(h,i)))}function E(p,c){if(p.command!==c.command||p.key!==c.key)return!1;const h=A.$Dj.deserialize(p.when),i=A.$Dj.deserialize(c.when);return!(h&&!i||!h&&i||h&&i&&!h.equals(i)||!C.$io(p.args,c.args))}function f(p,c,h){for(const i of c)p=T.edit(p,[-1],i,h);return p}function w(p,c,h){const i=k(p);for(let n=i.length-1;n>=0;n--)(i[n].command===c||i[n].command===`-${c}`)&&(p=T.edit(p,[n],void 0,h));return p}function P(p,c,h,i){const n=k(p),t=n.findIndex(s=>s.command===c||s.command===`-${c}`);for(let s=n.length-1;s>=0;s--)(n[s].command===c||n[s].command===`-${c}`)&&(p=T.edit(p,[s],void 0,i));for(let s=h.length-1;s>=0;s--)p=T.edit(p,[t],h[s],i);return p}}),define(he[208],ue([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=R,e.$bdc=C;function R(A,T,k){const O={},b={},I=new Set;if(!T)return{local:{added:O,updated:b,removed:[...I.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const $=a(A,T);if($.added.size===0&&$.removed.size===0&&$.updated.size===0)return{local:{added:O,updated:b,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const d=a(k,A),g=a(k,T),l={},m={},E=new Set,f=new Set;for(const w of d.removed.values())g.updated.has(w)?O[w]=T[w]:E.add(w);for(const w of g.removed.values())f.has(w)||(d.updated.has(w)?f.add(w):I.add(w));for(const w of d.updated.values())f.has(w)||(g.updated.has(w)?$.updated.has(w)&&f.add(w):m[w]=A[w]);for(const w of g.updated.values())f.has(w)||(d.updated.has(w)?$.updated.has(w)&&f.add(w):A[w]!==void 0&&(b[w]=T[w]));for(const w of d.added.values())f.has(w)||(g.added.has(w)?$.updated.has(w)&&f.add(w):l[w]=A[w]);for(const w of g.added.values())f.has(w)||(d.added.has(w)?$.updated.has(w)&&f.add(w):O[w]=T[w]);return{local:{added:O,removed:[...I.values()],updated:b},remote:{added:l,removed:[...E.values()],updated:m},conflicts:[...f.values()]}}function a(A,T){const k=A?Object.keys(A):[],O=T?Object.keys(T):[],b=O.filter(d=>!k.includes(d)).reduce((d,g)=>(d.add(g),d),new Set),I=k.filter(d=>!O.includes(d)).reduce((d,g)=>(d.add(g),d),new Set),$=new Set;for(const d of k){if(I.has(d))continue;const g=A[d],l=T[d];g!==l&&$.add(d)}return{added:b,removed:I,updated:$}}function C(A,T){const{added:k,removed:O,updated:b}=a(A,T);return k.size===0&&O.size===0&&b.size===0}}),define(he[209],ue([0,1,29]),function(ae,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=a;function a(A,T,k,O){const b={added:[],removed:[],updated:[]};let I={added:[],removed:[],updated:[]};if(!T){const d=A.filter(({id:g})=>!O.includes(g));return d.length?I.added=d:I=null,{local:b,remote:I}}const $=C(A,T,O);if($.added.length>0||$.removed.length>0||$.updated.length>0){const d=C(k,A,O),g=C(k,T,O);for(const l of g.removed){const m=A.find(E=>E.id===l);m&&b.removed.push(m)}for(const l of g.added){const m=T.find(E=>E.id===l);d.added.includes(l)?$.updated.includes(l)&&b.updated.push(m):b.added.push(m)}for(const l of g.updated)b.updated.push(T.find(m=>m.id===l));for(const l of d.added)g.added.includes(l)||I.added.push(A.find(m=>m.id===l));for(const l of d.updated)g.removed.includes(l)||g.updated.includes(l)||I.updated.push(A.find(m=>m.id===l));for(const l of d.removed){const m=T.find(E=>E.id===l);m&&I.removed.push(m)}}return I.added.length===0&&I.removed.length===0&&I.updated.length===0&&(I=null),{local:b,remote:I}}function C(A,T,k){A=A?A.filter(({id:g})=>!k.includes(g)):[],T=T.filter(({id:g})=>!k.includes(g));const O=A.map(({id:g})=>g),b=T.map(({id:g})=>g),I=b.filter(g=>!O.includes(g)),$=O.filter(g=>!b.includes(g)),d=[];for(const{id:g,name:l,shortName:m,icon:E,useDefaultFlags:f}of A){if($.includes(g))continue;const w=T.find(P=>P.id===g);(!w||w.name!==l||w.shortName!==m||w.icon!==E||!(0,R.$io)(w.useDefaultFlags,f))&&d.push(g)}return{added:I,removed:$,updated:d}}}),define(he[24],ue([0,1,17,12,11,47,27,4,103,44]),function(ae,e,R,a,C,A,T,k,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0nb=e.$9nb=e.$8nb=e.$7nb=e.$6nb=e.$5nb=e.$4nb=e.$3nb=e.$2nb=e.$Znb=e.MergeState=e.Change=e.SyncStatus=e.$Ynb=e.$Xnb=e.$Wnb=e.UserDataSyncErrorCode=e.$Unb=e.$Tnb=e.$Snb=e.$Rnb=e.$Qnb=e.$Nnb=e.SyncResource=e.$Knb=e.$Jnb=void 0,e.$Gnb=I,e.$Hnb=$,e.$Inb=d,e.$Lnb=l,e.$Mnb=m,e.$Onb=f,e.$Pnb=w,e.$Vnb=P,e.$1nb=r;function I(){const o=b.$ro.as(A.$wo.Configuration).getConfigurationProperties();return Object.keys(o).filter(u=>!!o[u].disallowSyncIgnore)}function $(o=!1){const u=b.$ro.as(A.$wo.Configuration).getConfigurationProperties(),y=g(u,o),N=I();return(0,R.$Lb)([...y,...N])}function d(o){if(!o.contributes?.configuration)return[];const u=Array.isArray(o.contributes.configuration)?o.contributes.configuration:[o.contributes.configuration];if(!u.length)return[];const y=(0,A.$Mo)(u);return g(y,!1)}function g(o,u){const y=new Set;for(const N in o){if(u&&o[N].source)continue;const S=(0,a.$eg)(o[N].scope)?(0,A.$No)(o[N].scope):o[N].scope;(o[N].ignoreSync||S===A.ConfigurationScope.MACHINE||S===A.ConfigurationScope.MACHINE_OVERRIDABLE)&&y.add(N)}return[...y.values()]}e.$Jnb="settingsSync",e.$Knb="settingsSync.keybindingsPerPlatform";function l(){const o="vscode://schemas/ignoredSettings",u=b.$ro.as(A.$wo.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,C.localize)(11060,null),type:"object",properties:{[e.$Knb]:{type:"boolean",description:(0,C.localize)(11061,null),default:!0,scope:A.ConfigurationScope.APPLICATION,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,C.localize)(11062,null),items:[{type:"string",pattern:T.$$o,errorMessage:(0,C.localize)(11063,null)}],default:[],scope:A.ConfigurationScope.APPLICATION,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,C.localize)(11064,null),default:[],scope:A.ConfigurationScope.APPLICATION,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const y=b.$ro.as(O.$so.JSONContribution),N=()=>{const S=I(),v=$(),L=Object.keys(A.$xo.properties).filter(M=>!v.includes(M)),U=v.filter(M=>!S.includes(M)),F={items:{type:"string",enum:[...L,...U.map(M=>`-${M}`)]}};y.registerSchema(o,F)};return u.onDidUpdateConfiguration(()=>N())}function m(o){return o&&(0,a.$gg)(o)&&(0,a.$eg)(o.id)&&Array.isArray(o.scopes)}var E;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Tasks="tasks",o.Extensions="extensions",o.GlobalState="globalState",o.Profiles="profiles",o.WorkspaceState="workspaceState"})(E||(e.SyncResource=E={})),e.$Nnb=[E.Settings,E.Keybindings,E.Snippets,E.Tasks,E.Extensions,E.GlobalState,E.Profiles];function f(o,...u){return o?[o,...u]:u}function w(o,u,y,N){return N.joinPath(y.userDataSyncHome,...f(o,u,`lastSync${u}.json`))}e.$Qnb=(0,k.$Fi)("IUserDataSyncStoreManagementService"),e.$Rnb=(0,k.$Fi)("IUserDataSyncStoreService"),e.$Snb=(0,k.$Fi)("IUserDataSyncLocalStoreService"),e.$Tnb="x-operation-id",e.$Unb="X-Execution-Id";function P(o){const u={};return u[e.$Unb]=o,u}var p;(function(o){o.Unauthorized="Unauthorized",o.Forbidden="Forbidden",o.NotFound="NotFound",o.MethodNotFound="MethodNotFound",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoCollection="NoCollection",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyProfiles="LocalTooManyProfiles",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.Unknown="Unknown"})(p||(e.UserDataSyncErrorCode=p={}));class c extends Error{constructor(u,y,N,S){super(u),this.code=y,this.resource=N,this.operationId=S,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Wnb=c;class h extends c{constructor(u,y,N,S,v){super(u,N,void 0,v),this.url=y,this.serverCode=S}}e.$Xnb=h;class i extends c{constructor(u,y){super(u,y)}}e.$Ynb=i,function(o){function u(y){if(y instanceof o)return y;const N=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(y.name);if(N&&N[1]){const S=N[2]==="unknown"?void 0:N[2],v=N[3]==="unknown"?void 0:N[3];return new o(y.message,N[1],S,v)}return new o(y.message,p.Unknown)}o.toUserDataSyncError=u}(c||(e.$Wnb=c={}));var n;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(n||(e.SyncStatus=n={}));var t;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(t||(e.Change=t={}));var s;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(s||(e.MergeState=s={})),e.$Znb="sync.store.url.type";function r(o){return`sync.enable.${o}`}e.$2nb=(0,k.$Fi)("IUserDataSyncEnablementService"),e.$3nb=(0,k.$Fi)("IUserDataSyncService"),e.$4nb=(0,k.$Fi)("IUserDataSyncResourceProviderService"),e.$5nb=(0,k.$Fi)("IUserDataAutoSyncService"),e.$6nb=(0,k.$Fi)("IUserDataSyncUtilService"),e.$7nb=(0,k.$Fi)("IUserDataSyncLogService"),e.$8nb="userDataSync",e.$9nb="vscode-userdata-sync",e.$0nb="preview"}),define(he[210],ue([0,1,29,24]),function(ae,e,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mOb=C,R=Oe(R);function C(T,k,O,b,I){if(!k)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const $=A(T,k);if($.added.size===0&&$.removed.size===0&&$.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const d=O?A(O,k):{added:Object.keys(k).reduce((w,P)=>(w.add(P),w),new Set),removed:new Set,updated:new Set},g=O?A(O,T):{added:Object.keys(T).reduce((w,P)=>(w.add(P),w),new Set),removed:new Set,updated:new Set},l={added:{},removed:[],updated:{}},m=R.$eo(k),E=!O;for(const w of g.added.values())w!==a.$Znb&&E&&d.added.has(w)||(m[w]=T[w]);for(const w of g.updated.values())m[w]=T[w];for(const w of g.removed.values())b.unregistered.includes(w)||delete m[w];for(const w of d.added.values()){const P=k[w];if(b.machine.includes(w)){I.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(O&&g.added.has(w))continue;const p=T[w];p&&p.value===P.value||w===a.$Znb&&E&&g.added.has(w)||(p?l.updated[w]=P:l.added[w]=P)}for(const w of d.updated.values()){const P=k[w];if(b.machine.includes(w)){I.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(g.updated.has(w)||g.removed.has(w))continue;const p=T[w];p&&p.value===P.value||(l.updated[w]=P)}for(const w of d.removed.values()){if(b.machine.includes(w)){I.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}g.updated.has(w)||g.removed.has(w)||l.removed.push(w)}const f=A(k,m);return{local:l,remote:{added:[...f.added],updated:[...f.updated],removed:[...f.removed],all:f.added.size===0&&f.removed.size===0&&f.updated.size===0?null:m}}}function A(T,k){const O=Object.keys(T),b=Object.keys(k),I=b.filter(g=>!O.includes(g)).reduce((g,l)=>(g.add(l),g),new Set),$=O.filter(g=>!b.includes(g)).reduce((g,l)=>(g.add(l),g),new Set),d=new Set;for(const g of O){if($.has(g))continue;const l=T[g],m=k[g];R.$io(l,m)||d.add(g)}return{added:I,removed:$,updated:d}}}),define(he[211],ue([0,1,17,36,64,45,29,81,24]),function(ae,e,R,a,C,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SMb=b,e.$TMb=d,e.$UMb=g,e.$VMb=l,e.$WMb=E,e.$XMb=w,T=Oe(T),k=Oe(k);function b(o,u,y){let N=[];y?N=$(y):N=I(u);const S=[],v=[...(0,O.$Gnb)()];if(Array.isArray(N))for(const L of N)L.startsWith("-")?v.push(L.substring(1)):S.push(L);return(0,R.$Lb)([...o,...S].filter(L=>!v.includes(L)))}function I(o){let u=o.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=o.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:o.getValue("settingsSync.ignoredSettings")||[]}function $(o){const u=(0,a.$Yn)(o);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function d(o,u){const y=(0,a.$Yn)(o)||{};let N="{}";for(const S of Object.keys(y)){const v=(0,C.$ao)(N,[S],y[S],u);N=(0,C.$do)(N,v)}return N}function g(o,u,y,N){if(y.length){const S=r(u),v=(0,a.$Yn)(u)||{},L=(0,a.$Yn)(o);if(!L)return o;const U=[];for(const F of y){const M=v[F],K=L[F];M===void 0?o=k.edit(o,[F],void 0,N):K!==void 0?o=k.edit(o,[F],M,N):U.push(h(F,S))}U.sort((F,M)=>F.startOffset-M.startOffset),U.forEach(F=>o=w(F.setting.key,u,o,N))}return o}function l(o,u,y,N,S,v){const L=g(o,u,N,v),U=y!==L,F=y!==u;if(!U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:L,hasConflicts:!1};if(F&&!U)return{conflictsSettings:[],localContent:g(u,o,N,v),remoteContent:null,hasConflicts:!1};if(y===null&&E(o)){const D=m(o,u,N)?null:g(u,o,N,v);return{conflictsSettings:[],localContent:D,remoteContent:null,hasConflicts:!1}}let M=o,K=u;const V=(0,a.$Yn)(o),x=(0,a.$Yn)(u),H=y?(0,a.$Yn)(y):null,te=N.reduce((D,Y)=>(D.add(Y),D),new Set),B=f(V,x,te),z=f(H,V,te),_=f(H,x,te),ne=new Map,le=new Set,ee=D=>{le.add(D);const Y=S.filter(({key:oe})=>oe===D)[0];Y?(M=k.edit(M,[D],Y.value,v),K=k.edit(K,[D],Y.value,v)):ne.set(D,{key:D,localValue:V[D],remoteValue:x[D]})};for(const D of z.removed.values())_.updated.has(D)?ee(D):K=k.edit(K,[D],void 0,v);for(const D of _.removed.values())le.has(D)||(z.updated.has(D)?ee(D):M=k.edit(M,[D],void 0,v));for(const D of z.updated.values())le.has(D)||(_.updated.has(D)?B.updated.has(D)&&ee(D):K=k.edit(K,[D],V[D],v));for(const D of _.updated.values())le.has(D)||(z.updated.has(D)?B.updated.has(D)&&ee(D):M=k.edit(M,[D],x[D],v));for(const D of z.added.values())le.has(D)||(_.added.has(D)?B.updated.has(D)&&ee(D):K=w(D,M,K,v));for(const D of _.added.values())le.has(D)||(z.added.has(D)?B.updated.has(D)&&ee(D):M=w(D,K,M,v));const Q=ne.size>0||!m(M,K,N),X=Q||!m(M,o,[]),q=Q||!m(K,u,[]);return{localContent:X?M:null,remoteContent:q?K:null,conflictsSettings:[...ne.values()],hasConflicts:Q}}function m(o,u,y){if(o===u)return!0;const N=(0,a.$Yn)(o),S=(0,a.$Yn)(u),v=y.reduce((F,M)=>(F.add(M),F),new Set),L=r(o).filter(F=>!(F.setting&&v.has(F.setting.key))),U=r(u).filter(F=>!(F.setting&&v.has(F.setting.key)));if(L.length!==U.length)return!1;for(let F=0;F<L.length;F++){const M=L[F],K=U[F];if(M.setting&&K.setting){if(M.setting.key!==K.setting.key||!T.$io(N[M.setting.key],S[M.setting.key]))return!1}else if(!M.setting&&!K.setting){if(M.value!==K.value)return!1}else return!1}return!0}function E(o){return o?r(o).length===0:!0}function f(o,u,y){const N=o?Object.keys(o).filter(F=>!y.has(F)):[],S=Object.keys(u).filter(F=>!y.has(F)),v=S.filter(F=>!N.includes(F)).reduce((F,M)=>(F.add(M),F),new Set),L=N.filter(F=>!S.includes(F)).reduce((F,M)=>(F.add(M),F),new Set),U=new Set;if(o)for(const F of N){if(L.has(F))continue;const M=o[F],K=u[F];T.$io(M,K)||U.add(F)}return{added:v,removed:L,updated:U}}function w(o,u,y,N){const S=(0,a.$Yn)(u),v=r(u),L=r(y),U=P(o,v,L);return p(y,o,S[o],U,L,N)}function P(o,u,y){const N=u.findIndex(v=>v.setting?.key===o),S=u[N-1];if(S){if(S.setting){const L=h(S.setting.key,y);if(L)return{index:y.indexOf(L),insertAfter:!0}}else{const L=i(N,u);if(L){const U=h(L.setting.key,y);if(U){const F=n(y.indexOf(U),y),M=t(u,L,u[N]);if(F){const K=t(y,U,F),V=s(M,K);return V?{index:y.indexOf(V),insertAfter:!0}:{index:y.indexOf(F),insertAfter:!1}}else{const K=t(y,U,y[y.length-1]),V=s(M,K);return V?{index:y.indexOf(V),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const v=u[N+1];if(v)if(v.setting){const L=h(v.setting.key,y);if(L)return{index:y.indexOf(L),insertAfter:!1}}else{const L=n(N,u);if(L){const U=h(L.setting.key,y);if(U){const F=i(y.indexOf(U),y),M=t(u,u[N],L);if(F){const K=t(y,F,U),V=s(M.reverse(),K.reverse());return V?{index:y.indexOf(V),insertAfter:!1}:{index:y.indexOf(F),insertAfter:!0}}else{const K=t(y,y[0],U),V=s(M.reverse(),K.reverse());return V?{index:y.indexOf(V),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function p(o,u,y,N,S,v){let L;return N.index===-1?L=(0,C.$ao)(o,[u],y,v):L=c(o,u,y,N,S,v).map(U=>(0,C.$bo)(o,U,v)[0]),(0,C.$do)(o,L)}function c(o,u,y,N,S,v){const L=`${JSON.stringify(u)}: ${JSON.stringify(y)}`,U=(0,A.$0n)(v,o),F=S[N.index];if(N.insertAfter){const M=[];if(F.setting)M.push({offset:F.endOffset,length:0,content:","+L});else{const K=n(N.index,S),V=i(N.index,S),x=V?.setting?.commaOffset;V&&x===void 0&&M.push({offset:V.endOffset,length:0,content:","});const H=x!==void 0&&x>F.endOffset;M.push({offset:H?x+1:F.endOffset,length:0,content:K?U+L+",":U+L})}return M}else{if(F.setting)return[{offset:F.startOffset,length:0,content:L+","}];const M=(S[N.index-1]&&!S[N.index-1].setting?U:"")+L+(n(N.index,S)?",":"")+U;return[{offset:F.startOffset,length:0,content:M}]}}function h(o,u){return u.filter(y=>y.setting?.key===o)[0]}function i(o,u){for(let y=o-1;y>=0;y--)if(u[y].setting)return u[y]}function n(o,u){for(let y=o+1;y<u.length;y++)if(u[y].setting)return u[y]}function t(o,u,y){const N=o.indexOf(u),S=o.indexOf(y);return o.filter((v,L)=>N<L&&L<S)}function s(o,u){if(o.length&&u.length){let y=0;for(;y<u.length&&y<o.length;y++)if(o[y].value!==u[y].value)return u[y-1];return u[y-1]}}function r(o){const u=[];let y=-1,N,S;const v={onObjectBegin:L=>{y++},onObjectProperty:(L,U,F)=>{y===0&&(N=U,S=L)},onObjectEnd:(L,U)=>{y--,y===0&&u.push({startOffset:N,endOffset:L+U,value:o.substring(N,L+U),setting:{key:S,commaOffset:void 0}})},onArrayBegin:(L,U)=>{y++},onArrayEnd:(L,U)=>{y--,y===0&&u.push({startOffset:N,endOffset:L+U,value:o.substring(N,L+U),setting:{key:S,commaOffset:void 0}})},onLiteralValue:(L,U,F)=>{y===0&&u.push({startOffset:N,endOffset:U+F,value:o.substring(N,U+F),setting:{key:S,commaOffset:void 0}})},onSeparator:(L,U,F)=>{if(y===0&&L===","){let M=u.length-1;for(;M>=0&&!u[M].setting;M--);const K=u[M];K&&u.splice(M,1,{startOffset:K.startOffset,endOffset:K.endOffset,value:K.value,setting:{key:K.setting.key,commaOffset:U}})}},onComment:(L,U)=>{y===0&&u.push({startOffset:L,endOffset:L+U,value:o.substring(L,L+U)})}};return(0,a.$6n)(o,v),u}}),define(he[82],ue([0,1,3,2,4,24]),function(ae,e,R,a,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DMb=e.$CMb=void 0,e.$CMb=(0,C.$Fi)("IUserDataSyncAccountService");let T=class extends a.$Uc{get account(){return this.a}constructor(O,b){super(),this.g=O,this.h=b,this.b=this.B(new R.$le),this.onDidChangeAccount=this.b.event,this.c=this.B(new R.$le),this.onTokenFailed=this.c.event,this.f=!1,this.B(O.onTokenFailed(I=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,I),this.updateAccount(void 0),I===A.UserDataSyncErrorCode.Forbidden?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(O.onTokenSucceed(()=>this.f=!1))}async updateAccount(O){(O&&this.a?O.token!==this.a.token||O.authenticationProviderId!==this.a.authenticationProviderId:O!==this.a)&&(this.a=O,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(O))}};e.$DMb=T,e.$DMb=T=ve([Z(0,A.$Rnb),Z(1,A.$7nb)],T)}),define(he[212],ue([0,1,20,11,15,10,24]),function(ae,e,R,a,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Ob=void 0;let k=class extends A.$fk{constructor(b,I){super(),this.g=this.B(b.createLogger((0,R.$gh)(I.logsHome,`${T.$8nb}.log`),{id:T.$8nb,name:(0,a.localize)(11059,null)}))}trace(b,...I){this.g.trace(b,...I)}debug(b,...I){this.g.debug(b,...I)}info(b,...I){this.g.info(b,...I)}warn(b,...I){this.g.warn(b,...I)}error(b,...I){this.g.error(b,...I)}flush(){this.g.flush()}};e.$9Ob=k,e.$9Ob=k=ve([Z(0,A.$bk),Z(1,C.$Mi)],k)}),define(he[213],ue([0,1,6,3,2]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=void 0;class A extends C.$Uc{constructor({onDidOpenMainWindow:k,onDidFocusMainWindow:O,getActiveWindowId:b}){super(),this.a=this.B(new C.$Tc),a.Event.latch(a.Event.any(k,O))(this.f,this,this.a),this.b=(0,R.$sh)(()=>b()),(async()=>{try{const $=await this.b;this.c=typeof this.c=="number"?this.c:$}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$qhc=A}),define(he[115],ue([0,1,11,13,51,20,9,4,22]),function(ae,e,R,a,C,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$5i=e.$4i=e.$3i=e.$2i=e.$Zi=e.$Yi=e.WorkbenchState=e.$Si=e.$Ri=e.$Oi=void 0,e.$Pi=b,e.$Qi=I,e.$Ti=$,e.$Ui=d,e.$Vi=g,e.$Wi=m,e.$Xi=E,e.$1i=P,e.$6i=p,e.$7i=c,e.$9i=h,e.$0i=i,e.$$i=n,e.$Oi=(0,k.$Fi)("contextService");function b(t){const s=t;return typeof s?.id=="string"&&T.URI.isUri(s.uri)}function I(t){return typeof t?.id=="string"&&!b(t)&&!d(t)}e.$Ri={id:"ext-dev"},e.$Si={id:"empty-window"};function $(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,a.$nc)(t)}:s?e.$Ri:e.$Si;const r=t;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function d(t){const s=t;return typeof s?.id=="string"&&T.URI.isUri(s.configPath)}function g(t){const s=t;if(s?.uri)return{id:s.id,uri:T.URI.revive(s.uri)};const r=t;if(r?.configPath)return{id:r.id,configPath:T.URI.revive(r.configPath)};if(t?.id)return{id:t.id}}var l;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(l||(e.WorkbenchState=l={}));function m(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function E(t){const s=t;return!!(s&&typeof s=="object"&&T.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class f{constructor(s,r,o,u,y){this.h=s,this.j=o,this.k=u,this.l=y,this.c=C.$Li.forUris(this.l,()=>!0),this.folders=r}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=C.$Li.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Yi=f;class w{constructor(s,r){this.raw=r,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.$gh)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Zi=w;function P(t){return new w({uri:t,index:0,name:(0,A.$ch)(t)},{uri:t.toString()})}e.$2i="code-workspace",e.$3i=`.${e.$2i}`,e.$4i=[{name:(0,R.localize)(11030,null),extensions:[e.$2i]}],e.$5i="workspace.json";function p(t,s){return A.$0g.isEqualOrParent(t,s.untitledWorkspacesHome)}function c(t){let s;return T.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===O.Schemas.tmp}e.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function h(t){return t.id===e.$8i}function i(t,s){return!p(t,s)&&!c(t)}function n(t){return(typeof t=="string"?(0,a.$oc)(t):(0,A.$eh)(t))===e.$3i}}),define(he[19],ue([0,1,55,3,2,20,9,11,15,7,4,10,115,31,28,6,32,26,12]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.$Ml=e.ProfileResourceType=void 0,e.$Ll=p,e.$Nl=c,e.$Ol=h;var P;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(P||(e.ProfileResourceType=P={}));function p(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&T.URI.isUri(s.location)&&T.URI.isUri(s.globalStorageHome)&&T.URI.isUri(s.settingsResource)&&T.URI.isUri(s.keybindingsResource)&&T.URI.isUri(s.tasksResource)&&T.URI.isUri(s.snippetsHome)&&T.URI.isUri(s.extensionsResource))}e.$Ml=(0,I.$Fi)("IUserDataProfilesService");function c(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:T.URI.revive(t.location).with({scheme:s}),globalStorageHome:T.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:T.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:T.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:T.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:T.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:T.URI.revive(t.extensionsResource).with({scheme:s}),cacheHome:T.URI.revive(t.cacheHome).with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function h(t,s,r,o,u,y){return{id:t,name:s,location:r,isDefault:!1,shortName:u?.shortName,icon:u?.icon,globalStorageHome:y&&u?.useDefaultFlags?.globalState?y.globalStorageHome:(0,A.$gh)(r,"globalStorage"),settingsResource:y&&u?.useDefaultFlags?.settings?y.settingsResource:(0,A.$gh)(r,"settings.json"),keybindingsResource:y&&u?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,A.$gh)(r,"keybindings.json"),tasksResource:y&&u?.useDefaultFlags?.tasks?y.tasksResource:(0,A.$gh)(r,"tasks.json"),snippetsHome:y&&u?.useDefaultFlags?.snippets?y.snippetsHome:(0,A.$gh)(r,"snippets"),extensionsResource:y&&u?.useDefaultFlags?.extensions?y.extensionsResource:(0,A.$gh)(r,"extensions.json"),cacheHome:(0,A.$gh)(o,t),useDefaultFlags:u?.useDefaultFlags,isTransient:u?.transient}}let i=class extends C.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,r,o,u){super(),this.t=s,this.u=r,this.w=o,this.y=u,this.f=!0,this.h=this.B(new a.$le),this.onDidChangeProfiles=this.h.event,this.j=this.B(new a.$le),this.onWillCreateProfile=this.j.event,this.m=this.B(new a.$le),this.onWillRemoveProfile=this.m.event,this.n=this.B(new a.$le),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new g.$Ac,workspaces:new g.$Ac,emptyWindows:new Map},this.profilesHome=(0,A.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),r=[s];if(this.f)try{for(const y of this.O()){if(!y.name||!(0,w.$eg)(y.name)||!y.location){this.y.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(h((0,A.$dh)(y.location),y.name,y.location,this.g,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},s))}}catch(y){this.y.error(y)}const o=new g.$Ac,u=new Map;if(r.length)try{const y=this.Q();if(y.workspaces)for(const[N,S]of Object.entries(y.workspaces)){const v=T.URI.parse(N),L=r.find(U=>U.id===S);L&&o.set(v,L)}if(y.emptyWindows)for(const[N,S]of Object.entries(y.emptyWindows)){const v=r.find(L=>L.id===S);v&&u.set(N,v)}}catch(y){this.y.error(y)}this.z={profiles:r,workspaces:o,emptyWindows:u}}return this.z}D(){const s=h("__default__profile__",(0,k.localize)(11077,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const r="Temp",o=new RegExp(`${(0,f.$hf)(r)}\\s(\\d+)`);let u=0;for(const N of this.profiles){const S=o.exec(N.name),v=S?parseInt(S[1]):0;u=v>u?v:u}const y=`${r} ${u+1}`;return this.createProfile((0,R.$tj)((0,E.$2g)()).toString(16),y,{transient:!0},s)}async createNamedProfile(s,r,o){return this.createProfile((0,R.$tj)((0,E.$2g)()).toString(16),s,r,o)}async createProfile(s,r,o,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.F(s,r,o);return u&&await this.setProfileForWorkspace(u,y),y}async F(s,r,o){if(!(0,w.$eg)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let u=this.r.get(r);return u||(u=(async()=>{try{if(this.profiles.find(v=>v.name===r||v.id===s))throw new Error(`Profile with ${r} name already exists`);const N=h(s,r,(0,A.$gh)(this.profilesHome,s),this.g,o,this.defaultProfile);await this.u.createFolder(N.location);const S=[];return this.j.fire({profile:N,join(v){S.push(v)}}),await m.Promises.settled(S),this.I([N],[],[]),N}finally{this.r.delete(r)}})(),this.r.set(r,u)),u}async updateProfile(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(u=>u.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);return o=h(o.id,r.name??o.name,o.location,this.g,{shortName:r.shortName??o.shortName,icon:r.icon===null?void 0:r.icon??o.icon,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags},this.defaultProfile),this.I([],[],[o]),o}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(u=>u.id===s.id);if(!r)throw new Error(`Profile '${s.name}' does not exist`);const o=[];this.m.fire({profile:r,join(u){o.push(u)}});try{await Promise.allSettled(o)}catch(u){this.y.error(u)}for(const u of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(u)?.id&&this.C.emptyWindows.delete(u);for(const u of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(u)?.id&&this.C.workspaces.delete(u);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(u){(0,b.$rl)(u)!==b.FileOperationResult.FILE_NOT_FOUND&&this.y.error(u)}}async setProfileForWorkspace(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(u=>u.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.L(s,o)}unsetWorkspace(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,r)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.w.extUri.isEqual(o.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(s.map(r=>this.removeProfile(r)))}getProfileForWorkspace(s){const r=this.G(s),o=T.URI.isUri(r)?this.C.workspaces.get(r):this.C.emptyWindows.get(r);return o||((0,d.$Pi)(s)?this.s.folders.get(s.uri):(0,d.$Ui)(s)?this.s.workspaces.get(s.configPath):this.s.emptyWindows.get(s.id))}G(s){return(0,d.$Pi)(s)?s.uri:(0,d.$Ui)(s)?s.configPath:s.id}H(s){return!!([...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.folders.values()].some(r=>this.w.extUri.isEqual(r.location,s.location)))}I(s,r,o){const u=[...this.profiles,...s],y=[],N=this.s.profiles;this.s.profiles=[];for(let S of u){if(S.isDefault||r.some(L=>S.id===L.id))continue;S=o.find(L=>S.id===L.id)??S;const v=N.find(L=>S.id===L.id);if(S.isTransient)this.s.profiles.push(S);else{if(v){for(const[L,U]of this.s.emptyWindows.entries())if(S.id===U.id){this.L({id:L},S);break}for(const[L,U]of this.s.workspaces.entries())if(S.id===U.id){this.L({id:"",configPath:L},S);break}for(const[L,U]of this.s.folders.entries())if(S.id===U.id){this.L({id:"",uri:L},S);break}}y.push({location:S.location,name:S.name,shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags})}}this.P(y),this.z=void 0,this.J(s,r,o)}J(s,r,o){this.h.fire({added:s,removed:r,updated:o,all:this.profiles})}L(s,r,o){if(o=r?.isTransient?!0:o,o)(0,d.$Pi)(s)?(this.s.folders.delete(s.uri),r&&this.s.folders.set(s.uri,r)):(0,d.$Ui)(s)?(this.s.workspaces.delete(s.configPath),r&&this.s.workspaces.set(s.configPath,r)):(this.s.emptyWindows.delete(s.id),r&&this.s.emptyWindows.set(s.id,r));else{this.L(s,void 0,!0);const u=this.G(s);T.URI.isUri(u)?(this.C.workspaces.delete(u),r&&this.C.workspaces.set(u,r)):(this.C.emptyWindows.delete(u),r&&this.C.emptyWindows.set(u,r)),this.M()}}M(){const s={};for(const[o,u]of this.C.workspaces.entries())s[o.toString()]=u.id;const r={};for(const[o,u]of this.C.emptyWindows.entries())r[o.toString()]=u.id;this.R({workspaces:s,emptyWindows:r}),this.z=void 0}N(s){const r={},o=this.D();if(s.workspaces)for(const[y,N]of Object.entries(s.workspaces)){const S=T.URI.parse(N);r[y]=this.w.extUri.isEqual(S,o.location)?o.id:this.w.extUri.basename(S)}const u={};if(s.emptyWindows)for(const[y,N]of Object.entries(s.emptyWindows)){const S=T.URI.parse(N);u[y]=this.w.extUri.isEqual(S,o.location)?o.id:this.w.extUri.basename(S)}return{workspaces:r,emptyWindows:u}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Pl=i,e.$Pl=i=ve([Z(0,O.$Mi),Z(1,b.$al),Z(2,l.$Kl),Z(3,$.$ak)],i);class n extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Ql=n}),define(he[214],ue([0,1,6,2,19]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=void 0;let A=class extends a.$Uc{constructor(k){super(),this.B(new R.$Rh(()=>{k.cleanUp()},10*1e3)).schedule()}};e.$wic=A,e.$wic=A=ve([Z(0,C.$Ml)],A)}),define(he[83],ue([0,1,17,6,25,8,3,2,31,5,12,9,11,27,35,34,59,10,23,18,28,19]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f,w,P,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Fq=void 0,e.$Gq=i,d=Oe(d);let h=class extends k.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(r,o,u,y,N,S){super(),this.z=r,this.C=o,this.D=u,this.F=y,this.G=N,this.H=S,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new T.$le),this.s=this.B(new T.$le),this.t=this.B(new T.$le),this.u=this.B(new T.$le),this.w=this.B(new T.$le),this.y=[],this.B((0,k.$Sc)(()=>{this.j.forEach(({task:v})=>v.cancel()),this.m.forEach(v=>v.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(r){const o=await this.getTargetPlatform();return r.allTargetPlatforms.some(u=>(0,g.$jp)(u,r.allTargetPlatforms,o))}async installFromGallery(r,o={}){try{const y=(await this.installGalleryExtensions([{extension:r,options:o}])).find(({identifier:N})=>(0,l.$Mp)(N,r.identifier));if(y?.local)return y?.local;throw y?.error?y.error:new g.$np(`Unknown error while installing extension ${r.identifier.id}`,g.ExtensionManagementErrorCode.Unknown)}catch(u){throw i(u)}}async installGalleryExtensions(r){if(!this.z.isEnabled())throw new g.$np(d.localize(11503,null),g.ExtensionManagementErrorCode.NotAllowed);const o=[],u=[];return await Promise.allSettled(r.map(async({extension:y,options:N})=>{try{const S=await this.N(y,!!N?.installGivenVersion,!!N?.installPreReleaseVersion,N.productVersion??{version:this.G.version,date:this.G.date});u.push({...S,options:N})}catch(S){o.push({identifier:y.identifier,operation:g.InstallOperation.Install,source:y,error:S,profileLocation:N.profileLocation??this.W()})}})),u.length&&o.push(...await this.I(u)),o}async uninstall(r,o){return this.F.trace("ExtensionManagementService#uninstall",r.identifier.id),this.uninstallExtensions([{extension:r,options:o}])}async toggleAppliationScope(r,o){if((0,m.$un)(r.manifest)||r.isBuiltin)return r;if(r.isApplicationScoped){let u=await this.updateMetadata(r,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(u=await this.Z(r,this.H.defaultProfile.extensionsResource,o));for(const y of this.H.profiles){const N=(await this.getInstalled(m.ExtensionType.User,y.extensionsResource)).find(S=>(0,l.$Mp)(S.identifier,r.identifier));N?this.w.fire({local:N,profileLocation:y.extensionsResource}):this.u.fire({identifier:r.identifier,profileLocation:y.extensionsResource})}return u}else{const u=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(r,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.Z(r,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:u.identifier,operation:g.InstallOperation.Install,local:u,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),u}}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.g||r-this.h>1e3*60*5)&&(this.g=this.U(),this.h=r),this.g}registerParticipant(r){this.y.push(r)}async resetPinnedStateForAllUserExtensions(r){try{await this.L(this.H.profiles.map(async o=>{const u=await this.getInstalled(m.ExtensionType.User,o.extensionsResource);await this.L(u.map(async y=>{y.pinned!==r&&await this.updateMetadata(y,{pinned:r},o.extensionsResource)}))}))}catch(o){throw this.F.error("Error while resetting pinned state for all user extensions",(0,A.$9)(o)),o}}async I(r){const o=new Map,u=new Map,y=[],N=(v,L)=>`${l.$Np.create(v).toString()}-${L.toString()}`,S=(v,L,U,F)=>{const M=this.X(v,L,U),K=`${(0,l.$Rp)(v.publisher,v.name)}-${U.profileLocation.toString()}`;u.set(K,{task:M,root:F}),this.n.fire({identifier:M.identifier,source:L,profileLocation:U.profileLocation}),this.F.info("Installing extension:",M.identifier.id,U),$.URI.isUri(L)||this.j.set(N(L,U.profileLocation),{task:M,waitingTasks:[]})};try{for(const{manifest:v,extension:L,options:U}of r){const F=U.isApplicationScoped||U.isBuiltin||(0,m.$un)(v),M={...U,installOnlyNewlyAddedFromExtensionPack:U.installOnlyNewlyAddedFromExtensionPack??!$.URI.isUri(L),isApplicationScoped:F,profileLocation:F?this.H.defaultProfile.extensionsResource:U.profileLocation??this.W(),productVersion:U.productVersion??{version:this.G.version,date:this.G.date}},K=$.URI.isUri(L)?void 0:this.j.get(N(L,M.profileLocation));K?(this.F.info("Extension is already requested to install",K.task.identifier.id,M.profileLocation.toString()),y.push(K.task.waitUntilTaskIsFinished())):S(v,L,M,void 0)}return await Promise.all([...u.values()].map(async({task:v})=>{if(v.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",v.identifier.id);else try{const L=await this.M(v.identifier,v.manifest,!!v.options.installOnlyNewlyAddedFromExtensionPack,!!v.options.installPreReleaseVersion,v.options.profileLocation,v.options.productVersion),U=await this.getInstalled(void 0,v.options.profileLocation,v.options.productVersion),F={...v.options,context:{...v.options.context,[g.$dp]:!0}};for(const{gallery:M,manifest:K}of(0,R.$Lb)(L,({gallery:V})=>V.identifier.id)){if(u.has(`${M.identifier.id.toLowerCase()}-${F.profileLocation.toString()}`))continue;const V=this.j.get(N(M,F.profileLocation));if(V){if(this.J(v,V.task)){const x=V.task.identifier;this.F.info("Waiting for already requested installing extension",x.id,v.identifier.id,F.profileLocation.toString()),V.waitingTasks.push(v),y.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,H=>H.some(te=>(0,l.$Mp)(te.identifier,x)))).then(H=>{if(this.F.info("Finished waiting for already requested installing extension",x.id,v.identifier.id,F.profileLocation.toString()),!H.find(B=>(0,l.$Mp)(B.identifier,x))?.local)throw new Error(`Extension ${x.id} is not installed`)}))}}else U.some(({identifier:x})=>(0,l.$Mp)(x,M.identifier))||S(K,M,F,v)}}catch(L){if($.URI.isUri(v.source))(0,R.$Kb)(v.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",v.identifier.id,L.message),(0,R.$Kb)(v.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",v.identifier.id,L.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",v.identifier.id),L}})),await this.L([...u.entries()].map(async([v,{task:L}])=>{const U=new Date().getTime();let F;try{F=await L.run(),await this.L(this.y.map(M=>M.postInstall(F,L.source,L.options,C.CancellationToken.None)),g.ExtensionManagementErrorCode.PostInstall)}catch(M){const K=i(M);throw $.URI.isUri(L.source)||n(this.C,L.operation===g.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Up)(L.source),error:K,source:L.options.context?.[g.$cp]}),o.set(v,{error:K,identifier:L.identifier,operation:L.operation,source:L.source,context:L.options.context,profileLocation:L.options.profileLocation,applicationScoped:L.options.isApplicationScoped}),this.F.error("Error while installing the extension",L.identifier.id,(0,A.$9)(K),L.options.profileLocation.toString()),K}if(!$.URI.isUri(L.source)){const M=L.operation===g.InstallOperation.Update,K=M?void 0:(new Date().getTime()-L.source.lastUpdated)/1e3;if(n(this.C,M?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Up)(L.source),verificationStatus:L.verificationStatus,duration:new Date().getTime()-U,durationSinceUpdate:K,source:L.options.context?.[g.$cp]}),b.$p&&L.operation!==g.InstallOperation.Update)try{await this.z.reportStatistic(F.manifest.publisher,F.manifest.name,F.manifest.version,g.StatisticType.Install)}catch{}}o.set(v,{local:F,identifier:L.identifier,operation:L.operation,source:L.source,context:L.options.context,profileLocation:L.options.profileLocation,applicationScoped:F.isApplicationScoped})})),y.length&&await this.L(y),[...o.values()]}catch(v){const L=(M,K,V)=>{const x=[];M.manifest.extensionDependencies?.length&&x.push(...M.manifest.extensionDependencies),M.manifest.extensionPack?.length&&x.push(...M.manifest.extensionPack);for(const H of x){if(V.includes(H.toLowerCase()))continue;V.push(H.toLowerCase());const te=o.get(`${H.toLowerCase()}-${K.toString()}`);te?.local&&(V=L(te.local,K,V))}return V},U=M=>({identifier:M.identifier,operation:g.InstallOperation.Install,source:M.source,context:M.options.context,profileLocation:M.options.profileLocation,error:v}),F=[];for(const[M,{task:K,root:V}]of u){const x=o.get(M);x?x.local&&V&&!o.get(`${V.identifier.id.toLowerCase()}-${K.options.profileLocation.toString()}`)?.local&&(F.push(this.Y(x.local,{versionOnly:!0,profileLocation:K.options.profileLocation})),o.set(M,U(K))):(K.cancel(),o.set(M,U(K)))}for(const[M,{task:K}]of u){const V=o.get(M);if(!V?.local||K.options.donotIncludePackAndDependencies)continue;L(V.local,K.options.profileLocation,[V.local.identifier.id.toLowerCase()]).slice(1).some(H=>u.has(`${H.toLowerCase()}-${K.options.profileLocation.toString()}`)&&!o.get(`${H.toLowerCase()}-${K.options.profileLocation.toString()}`)?.local)&&(F.push(this.Y(V.local,{versionOnly:!0,profileLocation:K.options.profileLocation})),o.set(M,U(K)))}throw F.length&&await Promise.allSettled(F.map(async M=>{try{await M.run(),this.F.info("Rollback: Uninstalled extension",M.extension.identifier.id)}catch(K){this.F.warn("Rollback: Error while uninstalling extension",M.extension.identifier.id,(0,A.$9)(K))}})),v}finally{for(const{task:v}of u.values())v.source&&!$.URI.isUri(v.source)&&this.j.delete(N(v.source,v.options.profileLocation));if(o.size){const v=[...o.values()];for(const L of v)L.local&&this.F.info("Extension installed successfully:",L.identifier.id,L.profileLocation.toString());this.s.fire(v)}}}J(r,o){for(const[,{task:u,waitingTasks:y}]of this.j.entries())if(u===r&&(y.includes(o)||y.some(N=>this.J(N,o)))||u===o&&y[0]&&!this.J(r,y[0]))return!1;return!0}async L(r,o){const u=[],y=[],N=await Promise.allSettled(r);for(const v of N)v.status==="fulfilled"?u.push(v.value):y.push(i(v.reason,o));if(!y.length)return u;if(y.length===1)throw y[0];let S=new g.$np("",g.ExtensionManagementErrorCode.Unknown);for(const v of y)S=new g.$np(S.message?`${S.message}, ${v.message}`:v.message,v.code!==g.ExtensionManagementErrorCode.Unknown&&v.code!==g.ExtensionManagementErrorCode.Internal?v.code:S.code);throw S}async M(r,o,u,y,N,S){if(!this.z.isEnabled())return[];const v=await this.getInstalled(void 0,N,S),L=[],U=[],F=async(M,K)=>{L.push(M);const V=K.extensionDependencies||[],x=[...V];if(K.extensionPack){const H=u?v.find(te=>(0,l.$Mp)(te.identifier,M)):void 0;for(const te of K.extensionPack)H&&H.manifest.extensionPack&&H.manifest.extensionPack.some(B=>(0,l.$Mp)({id:B},{id:te}))||x.every(B=>!(0,l.$Mp)({id:B},{id:te}))&&x.push(te)}if(x.length){const H=x.filter(te=>L.every(B=>!(0,l.$Mp)(B,{id:te})));if(H.length){const te=await this.z.getExtensions(H.map(B=>({id:B,preRelease:y})),C.CancellationToken.None);for(const B of te){if(L.find(ne=>(0,l.$Mp)(ne,B.identifier)))continue;const z=V.some(ne=>(0,l.$Mp)({id:ne},B.identifier));let _;try{_=await this.N(B,!1,y,S)}catch(ne){if(z)throw ne;this.F.info("Skipping the packed extension as it cannot be installed",B.identifier.id,(0,A.$9)(ne));continue}U.push({gallery:_.extension,manifest:_.manifest}),await F(_.extension.identifier,_.manifest)}}}};return await F(r,o),U}async N(r,o,u,y){let N;const S=await this.getExtensionsControlManifest();if(S.malicious.some(U=>(0,l.$Mp)(r.identifier,U)))throw new g.$np(d.localize(11504,null,r.identifier.id),g.ExtensionManagementErrorCode.Malicious);const v=S.deprecated[r.identifier.id.toLowerCase()];if(v?.extension?.autoMigrate){if(this.F.info(`The '${r.identifier.id}' extension is deprecated, fetching the compatible '${v.extension.id}' extension instead.`),N=(await this.z.getExtensions([{id:v.extension.id,preRelease:v.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:y},C.CancellationToken.None))[0],!N)throw new g.$np(d.localize(11505,null,r.identifier.id,v.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(r)){const U=await this.getTargetPlatform();throw new g.$np(d.localize(11506,null,r.identifier.id,this.G.nameLong,(0,g.$fp)(U)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(N=await this.O(r,o,u,y),!N){const U=[];throw(0,E.$7p)(r.properties.enabledApiProposals??[],U)?!u&&r.properties.isPreReleaseVersion&&(await this.z.getExtensions([r.identifier],C.CancellationToken.None))[0]?new g.$np(d.localize(11508,null,r.displayName??r.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.$np(d.localize(11509,null,r.identifier.id,this.G.nameLong,this.G.version),g.ExtensionManagementErrorCode.Incompatible):new g.$np(d.localize(11507,null,r.displayName??r.identifier.id,U[0]),g.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",N.identifier.id);const L=await this.z.getManifest(N,C.CancellationToken.None);if(L===null)throw new g.$np(`Missing manifest for extension ${N.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(L.version!==N.version)throw new g.$np(`Cannot install '${N.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:N,manifest:L}}async O(r,o,u,y){const N=await this.getTargetPlatform();let S=null;return!o&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==u&&(S=(await this.z.getExtensions([{...r.identifier,preRelease:u}],{targetPlatform:N,compatible:!0,productVersion:y},C.CancellationToken.None))[0]||null),!S&&await this.z.isExtensionCompatible(r,u,N,y)&&(S=r),S||(o?S=(await this.z.getExtensions([{...r.identifier,version:r.version}],{targetPlatform:N,compatible:!0,productVersion:y},C.CancellationToken.None))[0]||null:S=await this.z.getCompatibleExtension(r,u,N,y)),S}async uninstallExtensions(r){const o=(U,F)=>`${U.identifier.id.toLowerCase()}${F.versionOnly?`-${U.manifest.version}`:""}@${F.profileLocation.toString()}`,u=(U,F)=>{const M=this.Y(U,F);return this.m.set(o(M.extension,F),M),this.F.info("Uninstalling extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,F.profileLocation.toString()),this.t.fire({identifier:U.identifier,profileLocation:F.profileLocation,applicationScoped:U.isApplicationScoped}),M},y=(U,F,M)=>{M?this.F.error("Failed to uninstall extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,F.profileLocation.toString(),M.message):this.F.info("Successfully uninstalled extension from the profile",`${U.identifier.id}@${U.manifest.version}`,F.profileLocation.toString()),n(this.C,"extensionGallery:uninstall",{extensionData:(0,l.$Tp)(U),error:M}),this.u.fire({identifier:U.identifier,error:M?.code,profileLocation:F.profileLocation,applicationScoped:U.isApplicationScoped})},N=[],S=[],v=[],L=new O.$Ac;for(const{extension:U,options:F}of r){const M={...F,profileLocation:U.isApplicationScoped?this.H.defaultProfile.extensionsResource:F?.profileLocation??this.W()},K=this.m.get(o(U,M));K?(this.F.info("Extensions is already requested to uninstall",U.identifier.id),v.push(K.waitUntilTaskIsFinished())):N.push(u(U,M))}try{for(const U of N.slice(0)){let F=L.get(U.options.profileLocation);if(F||L.set(U.options.profileLocation,F=await this.getInstalled(m.ExtensionType.User,U.options.profileLocation)),U.options.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${U.extension.identifier.id}@${U.extension.manifest.version}`);else{const M=this.R(U.extension,F);for(const K of M)this.m.has(o(K,U.options))?this.F.info("Extensions is already requested to uninstall",K.identifier.id):N.push(u(K,U.options))}U.options.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${U.extension.identifier.id}@${U.extension.manifest.version}`):this.P(N.map(M=>M.extension),F,U.extension)}await this.L(N.map(async U=>{try{if(await U.run(),await this.L(this.y.map(F=>F.postUninstall(U.extension,U.options,C.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,g.StatisticType.Uninstall)}catch{}}catch(F){const M=i(F);throw y(U.extension,U.options,M),M}finally{S.push(U)}})),v.length&&await this.L(v);for(const U of N)y(U.extension,U.options)}catch(U){const F=i(U);for(const M of N){try{M.cancel()}catch{}S.includes(M)||y(M.extension,M.options,F)}throw F}finally{for(const U of N)this.m.delete(o(U.extension,U.options))||this.F.warn("Uninstallation task is not found in the cache",U.extension.identifier.id)}}P(r,o,u){for(const y of r){const N=this.S(y,o);if(N.length){const S=N.filter(v=>!r.some(L=>(0,l.$Mp)(L.identifier,v.identifier)));if(S.length)throw new Error(this.Q(y,S,u))}}}Q(r,o,u){return u===r?o.length===1?d.localize(11510,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?d.localize(11511,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):d.localize(11512,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?d.localize(11513,null,u.manifest.displayName||u.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?d.localize(11514,null,u.manifest.displayName||u.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):d.localize(11515,null,u.manifest.displayName||u.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}R(r,o,u=[]){if(u.indexOf(r)!==-1)return[];u.push(r);const y=r.manifest.extensionPack?r.manifest.extensionPack:[];if(y.length){const N=o.filter(v=>!v.isBuiltin&&y.some(L=>(0,l.$Mp)({id:L},v.identifier))),S=[];for(const v of N)S.push(...this.R(v,o,u));return[...N,...S]}return[]}S(r,o){return o.filter(u=>u.manifest.extensionDependencies&&u.manifest.extensionDependencies.some(y=>(0,l.$Mp)({id:y},r.identifier)))}async U(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(r){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,A.$9)(r)),{malicious:[],deprecated:{},search:[]}}}};e.$Fq=h,e.$Fq=h=ve([Z(0,g.$lp),Z(1,P.$_l),Z(2,p.$Kl),Z(3,f.$ak),Z(4,w.$tk),Z(5,c.$Ml)],h);function i(s,r){if(s instanceof g.$np)return s;let o;return s instanceof g.$mp?o=new g.$np(s.message,s.code===g.ExtensionGalleryErrorCode.DownloadFailedWriting?g.ExtensionManagementErrorCode.DownloadFailedWriting:g.ExtensionManagementErrorCode.Gallery):o=new g.$np(s.message,(0,A.$3)(s)?g.ExtensionManagementErrorCode.Cancelled:r??g.ExtensionManagementErrorCode.Internal),o.stack=s.stack,o}function n(s,r,{extensionData:o,verificationStatus:u,duration:y,error:N,source:S,durationSinceUpdate:v}){let L,U;(0,I.$mg)(u)&&(u===!0?u="Verified":(u===!1||(L=g.ExtensionManagementErrorCode.Signature,U=u),u="Unverified")),N&&(L=N.code,N.code===g.ExtensionManagementErrorCode.Signature&&(U=N.message)),s.publicLog(r,{...o,verificationStatus:u,success:!N,duration:y,errorcode:L,errorcodeDetail:U,durationSinceUpdate:v,source:S})}class t{constructor(){this.d=new a.$Eh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,a.$sh)(r=>this.h(r))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,a.$sh)(r=>new Promise((o,u)=>{const y=r.onCancellationRequested(()=>{y.dispose(),u(new A.$4)})})),this.d.open()),this.g.cancel()}}e.$Hq=t}),define(he[52],ue([0,1,6,14,2,3,31,9,27,35,7,4,10,19,28,12,8,18]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=e.$Iq=e.ExtensionsProfileScanningErrorCode=void 0;var w;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(w||(e.ExtensionsProfileScanningErrorCode=w={}));class P extends Error{constructor(n,t){super(n),this.code=t}}e.$Iq=P,e.$Jq=(0,$.$Fi)("IExtensionsProfileScannerService");let p=class extends C.$Uc{constructor(n,t,s,r,o,u){super(),this.j=n,this.m=t,this.n=s,this.r=r,this.s=o,this.t=u,this.b=this.B(new A.$le),this.onAddExtensions=this.b.event,this.c=this.B(new A.$le),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$le),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$le),this.onDidRemoveExtensions=this.g.event,this.h=new T.$Ac}scanProfileExtensions(n,t){return this.u(n,void 0,t)}async addExtensionsToProfile(n,t,s){const r=[],o=[];try{return await this.u(t,u=>{const y=[];if(s)y.push(...u);else for(const N of u)n.some(([S])=>(0,b.$Mp)(S.identifier,N.identifier)&&S.manifest.version!==N.version)?r.push(N):y.push(N);for(const[N,S]of n){const v=y.findIndex(U=>(0,b.$Mp)(U.identifier,N.identifier)&&U.version===N.manifest.version),L={identifier:N.identifier,version:N.manifest.version,location:N.location,metadata:S};v===-1?(o.push(L),y.push(L)):y.splice(v,1,L)}return o.length&&this.b.fire({extensions:o,profileLocation:t}),r.length&&this.f.fire({extensions:r,profileLocation:t}),y}),o.length&&this.c.fire({extensions:o,profileLocation:t}),r.length&&this.g.fire({extensions:r,profileLocation:t}),o}catch(u){throw o.length&&this.c.fire({extensions:o,error:u,profileLocation:t}),r.length&&this.g.fire({extensions:r,error:u,profileLocation:t}),u}}async updateMetadata(n,t){const s=[];return await this.u(t,r=>{const o=[];for(const u of r){const y=n.find(([N])=>(0,b.$Mp)(N.identifier,u.identifier)&&N.manifest.version===u.version);y&&(u.metadata={...u.metadata,...y[1]},s.push(u)),o.push(u)}return o}),s}async removeExtensionFromProfile(n,t){const s=[];try{await this.u(t,r=>{const o=[];for(const u of r)(0,b.$Mp)(u.identifier,n.identifier)?s.push(u):o.push(u);return s.length&&this.f.fire({extensions:s,profileLocation:t}),o}),s.length&&this.g.fire({extensions:s,profileLocation:t})}catch(r){throw s.length&&this.g.fire({extensions:s,error:r,profileLocation:t}),r}}async u(n,t,s){return this.F(n).queue(async()=>{let r=[],o;try{const u=await this.m.readFile(n);o=JSON.parse(u.value.toString().trim()||"[]")}catch(u){if((0,I.$rl)(u)!==I.FileOperationResult.FILE_NOT_FOUND)throw u;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(o=await this.D()),!o&&s?.bailOutWhenFileNotFound)throw new P((0,E.$9)(u),w.ERROR_PROFILE_NOT_FOUND)}if(o){Array.isArray(o)||this.w(n);let u=!1;for(const y of o){c(y)||this.w(n);let N;if((0,m.$eg)(y.relativeLocation)&&y.relativeLocation)N=this.z(y.relativeLocation);else if((0,m.$eg)(y.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${y.location}`);continue}else{N=k.URI.revive(y.location);const S=this.y(N);S&&(u=!0,y.relativeLocation=S)}(0,m.$lg)(y.metadata?.hasPreReleaseVersion)&&y.metadata?.preRelease&&(u=!0,y.metadata.hasPreReleaseVersion=!0),r.push({identifier:y.identifier,location:N,version:y.version,metadata:y.metadata})}u&&await this.m.writeFile(n,a.$Ne.fromString(JSON.stringify(o)))}if(t){r=t(r);const u=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.y(y.location),metadata:y.metadata}));await this.m.writeFile(n,a.$Ne.fromString(JSON.stringify(u)))}return r})}w(n){const t=new P(`Invalid extensions content in ${n.toString()}`,w.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(n)).value.toString()}catch(o){if((0,I.$rl)(o)===I.FileOperationResult.FILE_NOT_FOUND)return;throw o}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const o=JSON.parse(s);Array.isArray(o)&&o.every(u=>c(u))?r=o:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.t.error(o)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,a.$Ne.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(o){if((0,I.$rl)(o)===I.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw o}try{await this.m.del(n)}catch(o){(0,I.$rl)(o)!==I.FileOperationResult.FILE_NOT_FOUND&&this.t.error(o)}try{await this.m.del(t)}catch(o){(0,I.$rl)(o)!==I.FileOperationResult.FILE_NOT_FOUND&&this.t.error(o)}return r})()),this.C}F(n){let t=this.h.get(n);return t||(t=new R.$Mh,this.h.set(n,t)),t}};e.$Kq=p,e.$Kq=p=ve([Z(1,I.$al),Z(2,g.$Ml),Z(3,l.$Kl),Z(4,f.$_l),Z(5,d.$ak)],p);function c(i){return(0,m.$gg)(i)&&(0,O.$kp)(i.identifier)&&(h(i.location)||(0,m.$eg)(i.location)&&i.location)&&((0,m.$lg)(i.relativeLocation)||(0,m.$eg)(i.relativeLocation))&&i.version&&(0,m.$eg)(i.version)}function h(i){return i?(0,m.$eg)(i.path)&&(0,m.$eg)(i.scheme):!1}});var it=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(he[84],ue([0,1,17,6,29,14,8,36,152,2,22,13,5,20,60,92,12,9,11,15,35,34,59,7,4,10,23,3,66,52,19,28,157]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f,w,P,p,c,h,i,n,t,s,r,o,u,y,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Pq=e.$Oq=e.$Nq=e.Translations=void 0,e.$Qq=K,C=Oe(C),$=Oe($),d=Oe(d),l=Oe(l),m=it(m);var v;(function(x){function H(te,B){if(te===B)return!0;const z=Object.keys(te),_=new Set;for(const ne of Object.keys(B))_.add(ne);if(z.length!==_.size)return!1;for(const ne of z){if(te[ne]!==B[ne])return!1;_.delete(ne)}return _.size===0}x.equals=H})(v||(e.Translations=v={})),e.$Nq=(0,n.$Fi)("IExtensionsScannerService");let L=class extends b.$Uc{constructor(H,te,B,z,_,ne,le,ee,Q,X,q,D){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=te,this.r=B,this.s=z,this.t=_,this.u=ne,this.w=le,this.y=ee,this.z=Q,this.C=X,this.D=q,this.F=D,this.g=this.B(new r.$le),this.onDidChangeCache=this.g.event,this.h=(0,g.$gh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(M,this.s,this.h)),this.m=this.B(this.F.createInstance(M,this.s,this.h)),this.n=this.B(this.F.createInstance(F,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(c.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(c.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,p.$Xp)(this.w,this.y)),this.G}async scanAllExtensions(H,te,B){const[z,_]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(te)]),ne=B?await this.scanExtensionsUnderDevelopment(H,[...z,..._]):[];return this.L(z,_,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const te=[];te.push(this.M(!!H.useCache,H.language)),te.push(this.N(H.language,!!H.checkControlFile));const[B,z]=await Promise.all(te);return this.J([...B,...z],c.ExtensionType.System,H,!1)}async scanUserExtensions(H){const te=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",te);const B=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.P(te,!!H.profileLocation,c.ExtensionType.User,!H.includeUninstalled,H.language,!0,B,H.productVersion??this.R()),_=H.useCache&&!z.devMode&&z.excludeObsolete?this.m:this.n;let ne;try{ne=await _.scanExtensions(z)}catch(le){if(le instanceof u.$Iq&&le.code===u.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),ne=await _.scanExtensions(z);else throw le}return ne=await this.J(ne,c.ExtensionType.User,H,!0),this.y.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(H,te){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(z=>z.scheme===I.Schemas.file).map(async z=>{const _=await this.P(z,!1,c.ExtensionType.User,!0,H.language,!1,void 0,H.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(_)).map(le=>(le.type=te.find(ee=>(0,p.$Mp)(ee.identifier,le.identifier))?.type??le.type,this.n.validate(le,_)))}))).flat();return this.J(B,"development",H,!0)}return[]}async scanExistingExtension(H,te,B){const z=await this.P(H,!1,te,!0,B.language,!0,void 0,B.productVersion??this.R()),_=await this.n.scanExtension(z);return!_||!B.includeInvalid&&!_.isValid?null:_}async scanOneOrMultipleExtensions(H,te,B){const z=await this.P(H,!1,te,!0,B.language,!0,void 0,B.productVersion??this.R()),_=await this.n.scanOneOrMultipleExtensions(z);return this.J(_,te,B,!0)}async scanMultipleExtensions(H,te,B){const z=[];return await Promise.all(H.map(async _=>{const ne=await this.scanOneOrMultipleExtensions(_,te,B);z.push(...ne)})),this.J(z,te,B,!0)}async scanMetadata(H){const te=(0,g.$gh)(H,"package.json"),B=(await this.w.readFile(te)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(H,te){const B=(0,g.$gh)(H,"package.json"),z=(await this.w.readFile(B)).value.toString(),_=JSON.parse(z);te.isMachineScoped===!1&&delete te.isMachineScoped,te.isBuiltin===!1&&delete te.isBuiltin,_.__metadata={..._.__metadata,...te},await this.w.writeFile((0,g.$gh)(H,"package.json"),A.$Ne.fromString(JSON.stringify(_,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof u.$Iq&&H.code===u.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(te=>[te,te.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$Ne.fromString(JSON.stringify([])))}catch(te){(0,i.$rl)(te)!==i.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.$9)(te))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,te,B,z){return B.includeAllVersions||(H=this.L(te===c.ExtensionType.System?H:void 0,te===c.ExtensionType.User?H:void 0,te==="development"?H:void 0,await this.getTargetPlatform(),z)),B.includeInvalid||(H=H.filter(_=>_.isValid)),H.sort((_,ne)=>{const le=$.$nc(_.location.fsPath),ee=$.$nc(ne.location.fsPath);return le<ee?-1:le>ee?1:0})}L(H,te,B,z,_){const ne=(ee,Q,X)=>{if(ee.isValid&&!Q.isValid)return!1;if(ee.isValid===Q.isValid){if(_&&l.gt(ee.manifest.version,Q.manifest.version))return this.y.debug(`Skipping extension ${Q.location.path} with lower version ${Q.manifest.version} in favour of ${ee.location.path} with version ${ee.manifest.version}`),!1;if(l.eq(ee.manifest.version,Q.manifest.version)){if(ee.type===c.ExtensionType.System)return this.y.debug(`Skipping extension ${Q.location.path} in favour of system extension ${ee.location.path} with same version`),!1;if(ee.targetPlatform===z)return this.y.debug(`Skipping extension ${Q.location.path} from different target platform ${Q.targetPlatform}`),!1}}return X?this.y.warn(`Overwriting user extension ${ee.location.path} with ${Q.location.path}.`):this.y.debug(`Overwriting user extension ${ee.location.path} with ${Q.location.path}.`),!0},le=new c.$tn;return H?.forEach(ee=>{const Q=le.get(ee.identifier.id);(!Q||ne(Q,ee,!1))&&le.set(ee.identifier.id,ee)}),te?.forEach(ee=>{const Q=le.get(ee.identifier.id);if(!Q&&H&&ee.type===c.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${ee.location.path}.`);return}(!Q||ne(Q,ee,!1))&&le.set(ee.identifier.id,ee)}),B?.forEach(ee=>{const Q=le.get(ee.identifier.id);(!Q||ne(Q,ee,!0))&&le.set(ee.identifier.id,ee),le.set(ee.identifier.id,ee)}),[...le.values()]}async M(H,te){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,c.ExtensionType.System,!0,te,!0,void 0,this.R()),_=await(H&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",_.length),_}async N(H,te){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const z=te?await this.O():{},_=[],ne=f.URI.file($.$hc($.$jc(I.$Zg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ee of B){const Q=z[ee.name]||"marketplace";switch(Q){case"disabled":break;case"marketplace":_.push((0,g.$gh)(ne,ee.name));break;default:_.push(f.URI.file(Q));break}}const le=await Promise.all(_.map(async ee=>this.n.scanExtension(await this.P(ee,!1,c.ExtensionType.System,!0,H,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",le.length),(0,R.$Gb)(le)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,te,B,z,_,ne,le,ee){const Q=await this.f(_??d.$x),X=await this.Q(H),q=te&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,D=q?await this.Q(q):void 0;return new U(H,X,q,D,te,le,B,z,ne,ee.version,ee.date,this.C.commit,!this.z.isBuilt,_,Q)}async Q(H){try{const te=await this.w.stat(H);if(typeof te.mtime=="number")return te.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Oq=L,e.$Oq=L=ve([Z(4,y.$Ml),Z(5,u.$Jq),Z(6,i.$al),Z(7,t.$ak),Z(8,P.$Mi),Z(9,s.$tk),Z(10,N.$Kl),Z(11,n.$Ei)],L);class U{constructor(H,te,B,z,_,ne,le,ee,Q,X,q,D,Y,oe,j){this.location=H,this.mtime=te,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=z,this.profile=_,this.profileScanOptions=ne,this.type=le,this.excludeObsolete=ee,this.validate=Q,this.productVersion=X,this.productDate=q,this.productCommit=D,this.devMode=Y,this.language=oe,this.translations=j}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,te){return(0,g.$_g)(H.location,te.location)&&H.mtime===te.mtime&&(0,g.$_g)(H.applicationExtensionslocation,te.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===te.applicationExtensionslocationMtime&&H.profile===te.profile&&C.$io(H.profileScanOptions,te.profileScanOptions)&&H.type===te.type&&H.excludeObsolete===te.excludeObsolete&&H.validate===te.validate&&H.productVersion===te.productVersion&&H.productDate===te.productDate&&H.productCommit===te.productCommit&&H.devMode===te.devMode&&H.language===te.language&&v.equals(H.translations,te.translations)}}e.$Pq=U;let F=class extends b.$Uc{constructor(H,te,B,z,_,ne,le){super(),this.g=H,this.h=te,this.j=B,this.m=z,this.n=ne,this.r=le,this.f=_.extensionsEnabledWithApiProposalVersion?.map(ee=>ee.toLowerCase())??[]}async scanExtensions(H){const te=H.profile?await this.t(H):await this.s(H);let B={};if(H.excludeObsolete&&H.type===c.ExtensionType.User)try{const z=(await this.m.readFile(this.g)).value.toString();B=JSON.parse(z)}catch{}return(0,E.$rg)(B)?te:te.filter(z=>!B[p.$Np.create(z).toString()])}async s(H){const te=await this.m.resolve(H.location);if(!te.children?.length)return[];const B=await Promise.all(te.children.map(async z=>{if(!z.isDirectory||H.type===c.ExtensionType.User&&(0,g.$dh)(z.resource).indexOf(".")===0)return null;const _=new U(z.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(_)}));return(0,R.$Gb)(B).sort((z,_)=>z.location.path<_.location.path?-1:1)}async t(H){let te=await this.u(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.j.extUri.isEqual(H.location,H.applicationExtensionslocation)){te=te.filter(z=>!z.metadata?.isApplicationScoped);const B=await this.u(H.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,H);te.push(...B)}return te}async u(H,te,B){const z=await this.h.scanProfileExtensions(H,B.profileScanOptions);if(!z.length)return[];const _=await Promise.all(z.map(async ne=>{if(te(ne)){const le=new U(ne.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(le,ne.metadata)}return null}));return(0,R.$Gb)(_)}async scanOneOrMultipleExtensions(H){try{if(await this.m.exists((0,g.$gh)(H.location,"package.json"))){const te=await this.scanExtension(H);return te?[te]:[]}else return await this.scanExtensions(H)}catch(te){return this.r.error(`Error scanning extensions at ${H.location.path}:`,(0,T.$9)(te)),[]}}async scanExtension(H,te){try{let B=await this.w(H.location);if(B){B.publisher||(B.publisher=c.$nn),te=te??B.__metadata,delete B.__metadata;const z=(0,p.$Rp)(B.publisher,B.name),_=te?.id?{id:z,uuid:te.id}:{id:z},ne=te?.isSystem?c.ExtensionType.System:H.type,le=ne===c.ExtensionType.System||!!te?.isBuiltin;B=await this.y(H.location,B,U.createNlsConfiguration(H));let ee={type:ne,identifier:_,manifest:B,location:H.location,isBuiltin:le,targetPlatform:te?.targetPlatform??c.TargetPlatform.UNDEFINED,publisherDisplayName:te?.publisherDisplayName,metadata:te,isValid:!0,validations:[]};return H.validate&&(ee=this.validate(ee,H)),B.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(z.toLowerCase()))&&(B.originalEnabledApiProposals=B.enabledApiProposals,B.enabledApiProposals=(0,c.$zn)([...B.enabledApiProposals])),ee}}catch(B){H.type!==c.ExtensionType.System&&this.r.error(B)}return null}validate(H,te){let B=!0;const z=this.n.isBuilt&&this.f.includes(H.identifier.id.toLowerCase()),_=(0,h.$4p)(te.productVersion,te.productDate,te.location,H.manifest,H.isBuiltin,z);for(const[ne,le]of _)ne===m.default.Error&&(B=!1,this.r.error(this.F(te.location,le)));return H.isValid=B,H.validations=_,H}async w(H){const te=(0,g.$gh)(H,"package.json");let B;try{B=(await this.m.readFile(te)).value.toString()}catch(_){return(0,i.$rl)(_)!==i.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(H,(0,w.localize)(11461,null,te.path,_.message))),null}let z;try{z=JSON.parse(B)}catch{const ne=[];(0,k.$Yn)(B,ne);for(const le of ne)this.r.error(this.F(H,(0,w.localize)(11462,null,te.path,le.offset,le.length,(0,O.$Lq)(le.error))));return null}return(0,k.$7n)(z)!=="object"?(this.r.error(this.F(H,(0,w.localize)(11463,null,te.path))),null):z}async y(H,te,B){const z=await this.z(H,te,B);if(z)try{const _=[],ne=await this.C(z.default,_);if(_.length>0)return _.forEach(ee=>{this.r.error(this.F(H,(0,w.localize)(11464,null,z.default?.path,(0,O.$Lq)(ee.error))))}),te;if((0,k.$7n)(z)!=="object")return this.r.error(this.F(H,(0,w.localize)(11465,null,z.default?.path))),te;const le=z.values||Object.create(null);return(0,S.$Mq)(this.r,te,le,ne)}catch{}return te}async z(H,te,B){const z=(0,g.$gh)(H,"package.nls.json"),_=(Q,X)=>{X.forEach(q=>{this.r.error(this.F(H,(0,w.localize)(11466,null,Q?.path,(0,O.$Lq)(q.error))))})},ne=Q=>{this.r.error(this.F(H,(0,w.localize)(11467,null,Q?.path)))},le=`${te.publisher}.${te.name}`,ee=B.translations[le];if(ee)try{const Q=f.URI.file(ee),X=(await this.m.readFile(Q)).value.toString(),q=[],D=(0,k.$Yn)(X,q);return q.length>0?(_(Q,q),{values:void 0,default:z}):(0,k.$7n)(D)!=="object"?(ne(Q),{values:void 0,default:z}):{values:D.contents?D.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.m.exists(z))return;let X;try{X=await this.D(H,B)}catch{return}if(!X.localized)return{values:void 0,default:X.original};try{const q=(await this.m.readFile(X.localized)).value.toString(),D=[],Y=(0,k.$Yn)(q,D);return D.length>0?(_(X.localized,D),{values:void 0,default:X.original}):(0,k.$7n)(Y)!=="object"?(ne(X.localized),{values:void 0,default:X.original}):{values:Y,default:X.original}}catch{return{values:void 0,default:X.original}}}}async C(H,te){if(H)try{const B=(await this.m.readFile(H)).value.toString();return(0,k.$Yn)(B,te)}catch{}}D(H,te){return new Promise((B,z)=>{const _=ne=>{const le=(0,g.$gh)(H,`package.nls.${ne}.json`);this.m.exists(le).then(ee=>{ee&&B({localized:le,original:(0,g.$gh)(H,"package.nls.json")});const Q=ne.lastIndexOf("-");Q===-1?B({localized:(0,g.$gh)(H,"package.nls.json"),original:null}):(ne=ne.substring(0,Q),_(ne))})};if(te.devMode||te.pseudo||!te.language)return B({localized:(0,g.$gh)(H,"package.nls.json"),original:null});_(te.language)})}F(H,te){return`[${H.path}]: ${te}`}};F=ve([Z(1,u.$Jq),Z(2,N.$Kl),Z(3,i.$al),Z(4,s.$tk),Z(5,P.$Mi),Z(6,t.$ak)],F);let M=class extends F{constructor(H,te,B,z,_,ne,le,ee,Q){super(te,z,_,ne,le,ee,Q),this.J=H,this.L=B,this.H=this.B(new a.$Dh(3e3)),this.I=this.B(new r.$le),this.onDidChangeCache=this.I.event}async scanExtensions(H){const te=this.P(H),B=await this.M(te);if(this.G=H,B&&B.input&&U.equals(B.input,this.G))return this.r.debug("Using cached extensions scan result",H.type===c.ExtensionType.System?"system":"user",H.location.toString()),this.H.trigger(()=>this.O()),B.result.map(_=>(_.location=f.URI.revive(_.location),_));const z=await super.scanExtensions(H);return await this.N(te,{input:H,result:z}),z}async M(H){try{const te=await this.m.readFile(H),B=JSON.parse(te.value.toString());return{result:B.result,input:(0,o.$ci)(B.input)}}catch(te){this.r.debug("Error while reading the extension cache file:",H.path,(0,T.$9)(te))}return null}async N(H,te){try{await this.m.writeFile(H,A.$Ne.fromString(JSON.stringify(te)))}catch(B){this.r.debug("Error while writing the extension cache file:",H.path,(0,T.$9)(B))}}async O(){if(!this.G)return;const H=this.P(this.G),te=await this.M(H);if(!te)return;const B=te.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!C.$io(z,B))try{this.r.info("Invalidating Cache",B,z),await this.m.del(H),this.I.fire()}catch(_){this.r.error(_)}}P(H){const te=this.Q(H);return this.j.extUri.joinPath(te.cacheHome,H.type===c.ExtensionType.System?c.$mn:c.$ln)}Q(H){return H.type===c.ExtensionType.System?this.L.defaultProfile:H.profile?this.j.extUri.isEqual(H.location,this.J.extensionsResource)?this.J:this.L.profiles.find(te=>this.j.extUri.isEqual(H.location,te.extensionsResource))??this.J:this.L.defaultProfile}};M=ve([Z(2,y.$Ml),Z(3,u.$Jq),Z(4,N.$Kl),Z(5,i.$al),Z(6,s.$tk),Z(7,P.$Mi),Z(8,t.$ak)],M);function K(x,H){const te=(0,p.$Pp)(x.manifest.publisher,x.manifest.name);return{id:te,identifier:new c.$rn(te),isBuiltin:x.type===c.ExtensionType.System,isUserBuiltin:x.type===c.ExtensionType.User&&x.isBuiltin,isUnderDevelopment:H,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,publisherDisplayName:x.publisherDisplayName,...x.manifest}}class V extends L{constructor(H,te,B,z,_,ne,le,ee,Q,X,q,D){super(H,te,(0,g.$gh)(B,".vscode-oss-dev","extensions","control.json"),z,_,ne,le,ee,Q,X,q,D),this.S=(async()=>{if(d.$A)try{const Y=await this.w.readFile(f.URI.file(d.$A));return JSON.parse(Y.value.toString())}catch{}return Object.create(null)})()}f(H){return this.S}}e.$Rq=V}),define(he[215],ue([0,1,68,6,43,3,2,22,13,30,10,19]),function(ae,e,R,a,C,A,T,k,O,b,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;let d=class extends T.$Uc{constructor(l,m){super(),this.b=l,this.f=m,this.a=new a.$Lh(5)}async postUninstall(l){const m=this.g(l,"uninstall");m&&(this.f.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(m.script,"uninstall",m.args,!0,l),this.f.info("Finished running post uninstall script",l.identifier.id,l.manifest.version)}catch(E){this.f.error("Failed to run post uninstall script",l.identifier.id,l.manifest.version),this.f.error(E)}}));try{await b.Promises.rm(this.m(l))}catch(E){this.f.error("Error while removing extension storage path",l.identifier.id),this.f.error(E)}}g(l,m){const E=`vscode:${m}`;if(l.location.scheme===k.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[E]=="string"){const f=l.manifest.scripts[E].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(l.identifier.id,l.manifest.version,`${E} should be a node script`),null):{script:(0,O.$jc)(l.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(l,m,E,f,w){return new Promise((P,p)=>{const c=this.j(l,m,E,w);let h;const i=n=>{h&&(clearTimeout(h),h=null),n?p(n):P(void 0)};c.on("error",n=>{i((0,C.$qj)(n)||"Unknown")}),c.on("exit",(n,t)=>{i(n?`post-${m} process exited with code ${n}`:void 0)}),f&&(h=setTimeout(()=>{h=null,c.kill(),p("timed out")},5e3))})}j(l,m,E,f){const w={silent:!0,execArgv:void 0},P=(0,R.fork)(l,[`--type=extension-post-${m}`,...E],w);P.stdout.setEncoding("utf8"),P.stderr.setEncoding("utf8");const p=A.Event.fromNodeEventEmitter(P.stdout,"data"),c=A.Event.fromNodeEventEmitter(P.stderr,"data");this.B(p(n=>this.f.info(f.identifier.id,f.manifest.version,`post-${m}`,n))),this.B(c(n=>this.f.error(f.identifier.id,f.manifest.version,`post-${m}`,n)));const h=A.Event.any(A.Event.map(p,n=>({data:`%c${n}`,format:[""]}),this.q),A.Event.map(c,n=>({data:`%c${n}`,format:["color: red"]}),this.q));return A.Event.debounce(h,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(n=>{console.group(f.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),P}m(l){return(0,O.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};e.$Vq=d,e.$Vq=d=ve([Z(0,$.$Ml),Z(1,I.$ak)],d)}),define(he[116],ue([0,1,72,11,83,27]),function(ae,e,R,a,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=T,e.$Tq=k;function T(O){let b=A.ExtensionManagementErrorCode.Extract;return O instanceof R.$Bq&&(O.type==="CorruptZip"?b=A.ExtensionManagementErrorCode.CorruptZip:O.type==="Incomplete"&&(b=A.ExtensionManagementErrorCode.IncompleteZip)),(0,C.$Gq)(O,b)}async function k(O){let b;try{b=await(0,R.$Eq)(O,"extension/package.json")}catch(I){throw T(I)}try{return JSON.parse(b.toString("utf8"))}catch{throw new A.$np((0,a.localize)(11451,null),A.ExtensionManagementErrorCode.Invalid)}}}),define(he[216],ue([0,1,6,8,2,22,20,60,12,32,30,72,21,15,83,27,35,116,110,7,10,18]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f,w,P,p,c){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0,k=Oe(k);let i=class extends C.$Uc{static{h=this}static{this.c=".sigzip"}constructor(t,s,r,o,u,y,N){super(),this.h=s,this.j=r,this.m=o,this.n=u,this.r=y,this.t=N,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,s,r,o){await this.g;const u=await this.w(t,s);let y=!1;if(r&&this.u(t)){let N;try{N=await this.y(t)}catch(S){try{await this.delete(u)}catch(v){this.t.error(v)}throw S}try{y=await this.n.verify(t,u.fsPath,N.fsPath,o)}catch(S){if(y=S.code,y===w.ExtensionSignatureVerificationCode.PackageIsInvalidZip||y===w.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(u)}catch(v){this.t.error(v)}throw new m.$np($.$Aq,m.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(N)}catch(S){this.t.error(S)}}}return{location:u,verificationStatus:y}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const s=this.m.getValue("extensions.verifySignature");return(0,O.$kg)(s)?s:!0}async w(t,s){try{const r=(0,T.$gh)(this.extensionsDownloadDir,this.G(t)),o=await this.C(t,"vsix",async()=>{await this.z(t,r,u=>this.j.download(t,u,s));try{await this.D(r.fsPath,"extension/package.json")}catch(u){try{await this.h.del(r)}catch(y){this.t.warn(`Error while deleting: ${r.path}`,(0,a.$9)(y))}throw u}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:o}),r}catch(r){throw(0,l.$Gq)(r,m.ExtensionManagementErrorCode.Download)}}async y(t){try{const s=(0,T.$gh)(this.extensionsDownloadDir,`.${(0,b.$2g)()}`),r=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,s);try{await this.D(s.fsPath,".signature.p7s")}catch(o){try{await this.h.del(s)}catch(u){this.t.warn(`Error while deleting: ${s.path}`,(0,a.$9)(u))}throw o}},2);return r>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:r}),s}catch(s){throw(0,l.$Gq)(s,m.ExtensionManagementErrorCode.DownloadSignature)}}async z(t,s,r){if(await this.h.exists(s))return;if(s.scheme!==A.Schemas.file){await r(s);return}const o=(0,T.$gh)(this.extensionsDownloadDir,`.${(0,b.$2g)()}`);try{await r(o)}catch(u){try{await this.h.del(o)}catch{}throw u}try{await I.Promises.rename(o.fsPath,s.fsPath,2*60*1e3)}catch(u){try{await this.h.del(o)}catch{}let y=!1;try{y=await this.h.exists(s)}catch{}if(y)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.t.info(`Rename failed because of ${(0,a.$9)(u)}. Deleted the file from downloaded location`,o.path),u}}async C(t,s,r,o){let u=1;for(;;)try{return await r(),u}catch(y){if(u++>o)throw y;this.t.warn(`Failed downloading ${s}. ${(0,a.$9)(y)}. Retry again...`,t.identifier.id)}}async D(t,s){try{await(0,$.$Eq)(t,s)}catch(r){throw(0,f.$Sq)(r)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],r=[],o=[];for(const N of t.children)if(N.name.endsWith(h.c))o.push(N.resource);else{const S=E.$Np.parse(N.name);S&&r.push([S,N])}const u=(0,E.$Sp)(r,([N])=>N),y=[];for(const N of u)N.sort((S,v)=>k.rcompare(S[0].version,v[0].version)),s.push(...N.slice(1).map(S=>S[1].resource)),y.push(N[0][1]);y.sort((N,S)=>N.mtime-S.mtime),s.push(...y.slice(0,Math.max(0,y.length-this.f)).map(N=>N.resource)),s.push(...o),await R.Promises.settled(s.map(N=>(this.t.trace("Deleting from cache",N.path),this.h.del(N))))}}catch(t){this.t.error(t)}}G(t){return this.f?E.$Np.create(t).toString().toLowerCase():(0,b.$2g)()}};e.$Uq=i,e.$Uq=i=h=ve([Z(0,g.$Ni),Z(1,P.$al),Z(2,m.$lp),Z(3,d.$_i),Z(4,w.$tq),Z(5,c.$_l),Z(6,p.$ak)],i)}),define(he[117],ue([0,1,33,6,14,25,43,8,3,55,2,31,22,13,20,60,12,9,32,30,72,11,98,15,83,27,35,52,84,216,215,116,188,198,34,59,7,4,10,23,18,28,19]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f,w,P,p,c,h,i,n,t,s,r,o,u,y,N,S,v,L,U,F,M,K,V,x,H,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=e.$Yq=void 0,R=Oe(R),g=Oe(g),m=Oe(m),P=Oe(P),c=Oe(c),e.$Yq=(0,M.$Gi)(t.$op);const B=".vsctmp";let z=class extends n.$Fq{constructor(Q,X,q,D,Y,oe,j,W,G,J,ie,ce){super(Q,X,ie,q,J,ce),this.db=Y,this.eb=oe,this.fb=j,this.gb=W,this.hb=G,this.cb=new Map,this.sb=new $.$Bc;const ge=this.B(W.createInstance(y.$Vq));this.$=this.B(W.createInstance(_,Ee=>ge.postUninstall(Ee))),this.ab=this.B(new S.$Wq(ce,G,ie,this,this.F)),this.bb=this.B(W.createInstance(u.$Uq));const pe=this.B(new v.$Xq(this,this.db,ce,oe,ie,G,q));this.B(pe.onDidChangeExtensionsByAnotherSource(Ee=>this.rb(Ee))),this.tb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$Xp)(this.hb,this.F)),this.ib}async zip(Q){this.F.trace("ExtensionManagementService#zip",Q.identifier.id);const X=await this.qb(Q),q=await(0,p.zip)((0,l.$gh)(this.bb.extensionsDownloadDir,(0,w.$2g)()).fsPath,X);return f.URI.file(q)}async getManifest(Q){const{location:X,cleanup:q}=await this.kb(Q),D=g.$kc(X.fsPath);try{return await(0,N.$Tq)(D)}finally{await q()}}getInstalled(Q,X=this.H.defaultProfile.extensionsResource,q={version:this.G.version,date:this.G.date}){return this.$.scanExtensions(Q??null,X,q)}scanAllUserInstalledExtensions(){return this.$.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(Q){return this.$.scanUserExtensionAtLocation(Q)}async install(Q,X={}){this.F.trace("ExtensionManagementService#install",Q.toString());const{location:q,cleanup:D}=await this.kb(Q);try{const Y=await(0,N.$Tq)(g.$kc(q.fsPath)),oe=(0,s.$Rp)(Y.publisher,Y.name);if(Y.engines&&Y.engines.vscode&&!(0,U.$6p)(Y.engines.vscode,this.G.version,this.G.date))throw new Error(c.localize(11452,null,oe,this.G.version));const W=(await this.I([{manifest:Y,extension:q,options:X}])).find(({identifier:G})=>(0,s.$Mp)(G,{id:oe}));if(W?.local)return W.local;throw W?.error?W.error:(0,n.$Gq)(new Error(`Unknown error while installing extension ${oe}`))}finally{await D()}}async installFromLocation(Q,X){this.F.trace("ExtensionManagementService#installFromLocation",Q.toString());const q=await this.$.scanUserExtensionAtLocation(Q);if(!q||!q.manifest.name||!q.manifest.version)throw new Error(`Cannot find a valid extension from the location ${Q.toString()}`);return await this.vb([[q,{source:"resource"}]],X),this.F.info("Successfully installed extension",q.identifier.id,X.toString()),q}async installExtensionsFromProfile(Q,X,q){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",Q,X.toString(),q.toString());const D=(await this.getInstalled(L.ExtensionType.User,X)).filter(Y=>Q.some(oe=>(0,s.$Mp)(oe,Y.identifier)));if(D.length){const Y=await Promise.all(D.map(oe=>this.$.scanMetadata(oe,X)));await this.vb(D.map((oe,j)=>[oe,Y[j]]),q),this.F.info("Successfully installed extensions",D.map(oe=>oe.identifier.id),q.toString())}return D}async updateMetadata(Q,X,q){return this.F.trace("ExtensionManagementService#updateMetadata",Q.identifier.id),X.isPreReleaseVersion&&(X.preRelease=!0,X.hasPreReleaseVersion=!0),X.isMachineScoped===!1&&(X.isMachineScoped=void 0),X.isBuiltin===!1&&(X.isBuiltin=void 0),X.pinned===!1&&(X.pinned=void 0),Q=await this.$.updateMetadata(Q,X,q),this.ab.invalidate(q),this.w.fire({local:Q,profileLocation:q}),Q}async reinstallFromGallery(Q){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",Q.identifier.id),!this.z.isEnabled())throw new Error(c.localize(11453,null));const X=await this.getTargetPlatform(),[q]=await this.z.getExtensions([{...Q.identifier,preRelease:Q.preRelease}],{targetPlatform:X,compatible:!0},A.CancellationToken.None);if(!q)throw new Error(c.localize(11454,null));await this.$.setUninstalled(Q);try{await this.$.removeUninstalledExtension(Q)}catch(D){throw new Error(c.localize(11455,null,(0,T.$qj)(D)))}return this.installFromGallery(q)}Z(Q,X,q,D){return this.$.copyExtension(Q,X,q,D)}copyExtensions(Q,X){return this.$.copyExtensions(Q,X,{version:this.G.version,date:this.G.date})}markAsUninstalled(...Q){return this.$.setUninstalled(...Q)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.$.cleanUp()}catch(Q){this.F.error(Q)}}async download(Q,X,q){const{location:D}=await this.bb.download(Q,X,!q);return D}async kb(Q){if(Q.scheme===d.Schemas.file)return{location:Q,async cleanup(){}};this.F.trace("Downloading extension from",Q.toString());const X=(0,l.$gh)(this.bb.extensionsDownloadDir,(0,w.$2g)());return await this.fb.download(Q,X),this.F.info("Downloaded extension to",X.toString()),{location:X,cleanup:async()=>{try{await this.hb.del(X)}catch(D){this.F.error(D)}}}}W(){return this.H.defaultProfile.extensionsResource}X(Q,X,q){const D=X instanceof f.URI?new s.$Np({id:(0,s.$Rp)(Q.publisher,Q.name)},Q.version):s.$Np.create(X);return this.gb.createInstance(ne,D,Q,X,q,(Y,oe)=>{if(X instanceof f.URI)return this.pb(D,X,q,oe);let j=this.cb.get(D.toString());return j||(this.cb.set(D.toString(),j=this.ob(D,X,Y,q,oe)),j.finally(()=>this.cb.delete(D.toString()))),j},this.$)}Y(Q,X){return new le(Q,X,this.eb)}async ob(Q,X,q,D,Y){const{verificationStatus:oe,location:j}=await this.bb.download(X,q,!D.donotVerifySignature,D.context?.[t.$ep]);try{if(Y.isCancellationRequested)throw new k.$4;const W=await(0,N.$Tq)(j.fsPath);if(!new s.$Np(X.identifier,X.version).equals(new s.$Np({id:(0,s.$Rp)(W.publisher,W.name)},W.version)))throw new t.$np(c.localize(11456,null,X.identifier.id),t.ExtensionManagementErrorCode.Invalid);return{local:await this.$.extractUserExtension(Q,j.fsPath,{id:X.identifier.uuid,publisherId:X.publisherId,publisherDisplayName:X.publisherDisplayName,targetPlatform:X.properties.targetPlatform,isApplicationScoped:D.isApplicationScoped,isMachineScoped:D.isMachineScoped,isBuiltin:D.isBuiltin,isPreReleaseVersion:X.properties.isPreReleaseVersion,hasPreReleaseVersion:X.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:D.installGivenVersion?!0:!!D.pinned,preRelease:(0,E.$kg)(D.preRelease)?D.preRelease:D.installPreReleaseVersion||X.properties.isPreReleaseVersion,source:"gallery"},!1,Y),verificationStatus:oe}}catch(W){try{await this.bb.delete(j)}catch(G){this.F.warn("Error while deleting the downloaded file",j.toString(),(0,k.$9)(G))}throw(0,n.$Gq)(W)}}async pb(Q,X,q,D){return{local:await this.$.extractUserExtension(Q,g.$kc(X.fsPath),{isApplicationScoped:q.isApplicationScoped,isMachineScoped:q.isMachineScoped,isBuiltin:q.isBuiltin,installedTimestamp:Date.now(),pinned:q.installGivenVersion?!0:!!q.pinned,source:"vsix"},q.keepExisting??!0,D)}}async qb(Q){const X=async D=>{let Y=await P.Promises.readdir(D);Y=Y.map(W=>g.$jc(D,W));const oe=await Promise.all(Y.map(W=>R.promises.stat(W)));let j=Promise.resolve([]);return oe.forEach((W,G)=>{const J=Y[G];W.isFile()&&(j=j.then(ie=>[...ie,J])),W.isDirectory()&&(j=j.then(ie=>X(J).then(ce=>[...ie,...ce])))}),j};return(await X(Q.location.fsPath)).map(D=>({path:`extension/${g.$lc(Q.location.fsPath,D)}`,localPath:D}))}async rb({added:Q,removed:X}){if(X){const q=Q&&this.D.extUri.isEqual(X.profileLocation,Q.profileLocation)?X.extensions.filter(D=>Q.extensions.every(Y=>!(0,s.$Mp)(Y,D))):X.extensions;for(const D of q)this.F.info("Extensions removed from another source",D.id,X.profileLocation.toString()),this.u.fire({identifier:D,profileLocation:X.profileLocation})}if(Q){const D=(await this.getInstalled(L.ExtensionType.User,Q.profileLocation)).filter(Y=>Q.extensions.some(oe=>(0,s.$Mp)(oe,Y.identifier)));this.s.fire(D.map(Y=>(this.F.info("Extensions added from another source",Y.identifier.id,Q.profileLocation.toString()),{identifier:Y.identifier,local:Y,profileLocation:Q.profileLocation,operation:t.InstallOperation.None})))}}async tb(){this.B(this.$.onExtract(X=>this.sb.add(X)));const Q=await this.hb.resolve(this.db.userExtensionsLocation);for(const X of Q.children??[])X.isDirectory&&this.sb.add(X.resource);this.B(this.hb.watch(this.db.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(X=>this.ub(X)))}async ub(Q){if(!Q.affects(this.db.userExtensionsLocation,F.FileChangeType.ADDED))return;const X=[];for(const q of Q.rawAdded){if(this.sb.has(q)||!this.D.extUri.isEqual(this.D.extUri.dirname(q),this.db.userExtensionsLocation)||this.D.extUri.isEqual(q,this.D.extUri.joinPath(this.db.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(q).startsWith(".")||!(await this.hb.stat(q)).isDirectory)continue;const D=await this.$.scanUserExtensionAtLocation(q);D&&D.installedTimestamp===void 0&&(this.sb.add(q),X.push(D))}X.length&&(await this.vb(X.map(q=>[q,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",X.map(q=>q.identifier.id)))}async vb(Q,X){const q=Q.map(D=>D[0]);await this.wb(q),await this.eb.addExtensionsToProfile(Q,X),this.s.fire(q.map(D=>({local:D,identifier:D.identifier,operation:t.InstallOperation.None,profileLocation:X})))}async wb(Q){const X=await this.$.getUninstalledExtensions();for(const q of Q){const D=s.$Np.create(q);X[D.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",D.id),await this.$.setInstalled(D),this.F.info("Removed the extension from uninstalled list:",D.id))}}};e.$Zq=z,e.$Zq=z=ve([Z(0,t.$lp),Z(1,x.$_l),Z(2,K.$ak),Z(3,i.$Ni),Z(4,o.$Nq),Z(5,r.$Jq),Z(6,h.$2o),Z(7,M.$Ei),Z(8,F.$al),Z(9,V.$tk),Z(10,H.$Kl),Z(11,te.$Ml)],z);let _=class extends I.$Uc{constructor(Q,X,q,D,Y,oe,j){super(),this.n=Q,this.s=X,this.t=q,this.u=D,this.w=Y,this.y=oe,this.z=j,this.h=this.B(new O.$le),this.onExtract=this.h.event,this.j=new $.$Ac,this.m=new $.$Ac,this.c=(0,l.$gh)(this.t.userExtensionsLocation,".obsolete"),this.g=new a.$Mh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(Q,X,q){try{const D={includeInvalid:!0,profileLocation:X,productVersion:q};let Y=[];if(Q===null||Q===L.ExtensionType.System){let oe=this.j.get(X);oe||(oe=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},D,!1).finally(()=>this.j.delete(X)),this.j.set(X,oe)),Y.push(...await oe)}else if(Q===L.ExtensionType.User){let oe=this.m.get(X);oe||(oe=this.t.scanUserExtensions(D).finally(()=>this.m.delete(X)),this.m.set(X,oe)),Y.push(...await oe)}return Y=Q!==null?Y.filter(oe=>oe.type===Q):Y,await Promise.all(Y.map(oe=>this.H(oe)))}catch(D){throw(0,n.$Gq)(D,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(Q){try{const X=await this.t.scanUserExtensions({includeAllVersions:!Q,includeInvalid:!0});return await Promise.all(X.map(q=>this.H(q)))}catch(X){throw(0,n.$Gq)(X,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(Q){try{const X=await this.t.scanExistingExtension(Q,L.ExtensionType.User,{includeInvalid:!0});if(X)return await this.H(X)}catch(X){this.z.error(X)}return null}async extractUserExtension(Q,X,q,D,Y){const oe=Q.toString(),j=f.URI.file(g.$jc(this.t.userExtensionsLocation.fsPath,`.${(0,w.$2g)()}`)),W=f.URI.file(g.$jc(this.t.userExtensionsLocation.fsPath,oe));if(await this.s.exists(W)){if(!D)try{return await this.scanLocalExtension(W,L.ExtensionType.User)}catch(G){this.z.warn(`Error while scanning the existing extension at ${W.path}. Deleting the existing extension and extracting it.`,(0,k.$9)(G))}try{await this.D(Q.id,W,"removeExisting")}catch{throw new t.$np(c.localize(11457,null,W.fsPath,Q.id),t.ExtensionManagementErrorCode.Delete)}}try{if(Y.isCancellationRequested)throw new k.$4;try{this.z.trace(`Started extracting the extension from ${X} to ${W.fsPath}`),await(0,p.$Dq)(X,j.fsPath,{sourcePath:"extension",overwrite:!0},Y),this.z.info(`Extracted extension to ${W}:`,Q.id)}catch(G){throw(0,N.$Sq)(G)}try{await this.t.updateMetadata(j,q)}catch(G){throw this.y.publicLog2("extension:extract",{extensionId:Q.id,code:`${(0,F.$rl)(G)}`}),(0,n.$Gq)(G,t.ExtensionManagementErrorCode.UpdateMetadata)}if(Y.isCancellationRequested)throw new k.$4;try{this.z.trace(`Started renaming the extension from ${j.fsPath} to ${W.fsPath}`),await this.G(j.fsPath,W.fsPath),this.z.info("Renamed to",W.fsPath)}catch(G){if(G.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",Q.id);try{await this.s.del(j,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,k.$9)(G)}. Deleted from extracted location`,j),G}this.h.fire(W)}catch(G){try{await this.s.del(j,{recursive:!0})}catch{}throw G}return this.scanLocalExtension(W,L.ExtensionType.User)}async scanMetadata(Q,X){return X?(await this.C(Q,X))?.metadata:this.t.scanMetadata(Q.location)}async C(Q,X){return(await this.u.scanProfileExtensions(X)).find(D=>(0,s.$Mp)(D.identifier,Q.identifier))}async updateMetadata(Q,X,q){try{q?await this.u.updateMetadata([[Q,X]],q):await this.t.updateMetadata(Q.location,X)}catch(D){throw this.y.publicLog2("extension:extract",{extensionId:Q.identifier.id,code:`${(0,F.$rl)(D)}`,isProfile:!!q}),(0,n.$Gq)(D,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(Q.location,Q.type,q)}async getUninstalledExtensions(){try{return await this.F()}catch(Q){throw(0,n.$Gq)(Q,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...Q){const X=Q.map(q=>s.$Np.create(q));await this.F(q=>X.forEach(D=>{q[D.toString()]=!0,this.z.info("Marked extension as uninstalled",D.toString())}))}async setInstalled(Q){try{await this.F(X=>delete X[Q.toString()])}catch(X){throw(0,n.$Gq)(X,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(Q,X){if(this.w.extUri.isEqualOrParent(Q.location,this.t.userExtensionsLocation))return this.D(Q.identifier.id,Q.location,X)}async removeUninstalledExtension(Q){await this.removeExtension(Q,"uninstalled"),await this.F(X=>delete X[s.$Np.create(Q).toString()])}async copyExtension(Q,X,q,D){const Y=await this.C(Q,X),oe=await this.C(Q,q);if(D={...Y?.metadata,...D},oe)if(this.w.extUri.isEqual(oe.location,Q.location))await this.u.updateMetadata([[Q,{...oe.metadata,...D}]],q);else{const j=await this.scanLocalExtension(oe.location,Q.type,q);await this.u.removeExtensionFromProfile(j,q),await this.u.addExtensionsToProfile([[Q,{...oe.metadata,...D}]],q)}else await this.u.addExtensionsToProfile([[Q,D]],q);return this.scanLocalExtension(Q.location,Q.type,q)}async copyExtensions(Q,X,q){const D=await this.scanExtensions(L.ExtensionType.User,Q,q),Y=await Promise.all(D.filter(oe=>!oe.isApplicationScoped).map(async oe=>[oe,await this.scanMetadata(oe,Q)]));await this.u.addExtensionsToProfile(Y,X)}async D(Q,X,q){this.z.trace(`Deleting ${q} extension from disk`,Q,X.fsPath);const D=this.w.extUri.joinPath(this.w.extUri.dirname(X),`${this.w.extUri.basename(X)}.${(0,b.$tj)((0,w.$2g)()).toString(16)}${B}`);await this.G(X.fsPath,D.fsPath),await this.s.del(D,{recursive:!0}),this.z.info(`Deleted ${q} extension from disk`,Q,X.fsPath)}F(Q){return this.g.queue(async()=>{let X;try{X=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(D){if((0,F.$rl)(D)!==F.FileOperationResult.FILE_NOT_FOUND)throw D}let q={};if(X)try{q=JSON.parse(X)}catch{}return Q&&(Q(q),Object.keys(q).length?await this.s.writeFile(this.c,C.$Ne.fromString(JSON.stringify(q))):await this.s.del(this.c)),q})}async G(Q,X){try{await P.Promises.rename(Q,X,2*60*1e3)}catch(q){throw(0,n.$Gq)(q,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(Q,X,q){try{if(q){const Y=(await this.t.scanUserExtensions({profileLocation:q})).find(oe=>this.w.extUri.isEqual(oe.location,Q));if(Y)return await this.H(Y)}else{const D=await this.t.scanExistingExtension(Q,X,{includeInvalid:!0});if(D)return await this.H(D)}throw new t.$np(c.localize(11458,null,Q.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(D){throw(0,n.$Gq)(D,t.ExtensionManagementErrorCode.ScanningExtension)}}async H(Q){const X=await this.s.resolve(Q.location);let q,D;return X.children&&(q=X.children.find(({name:Y})=>/^readme(\.txt|\.md|)$/i.test(Y))?.resource,D=X.children.find(({name:Y})=>/^changelog(\.txt|\.md|)$/i.test(Y))?.resource),{identifier:Q.identifier,type:Q.type,isBuiltin:Q.isBuiltin||!!Q.metadata?.isBuiltin,location:Q.location,manifest:Q.manifest,targetPlatform:Q.targetPlatform,validations:Q.validations,isValid:Q.isValid,readmeUrl:q,changelogUrl:D,publisherDisplayName:Q.metadata?.publisherDisplayName,publisherId:Q.metadata?.publisherId||null,isApplicationScoped:!!Q.metadata?.isApplicationScoped,isMachineScoped:!!Q.metadata?.isMachineScoped,isPreReleaseVersion:!!Q.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!Q.metadata?.hasPreReleaseVersion,preRelease:!!Q.metadata?.preRelease,installedTimestamp:Q.metadata?.installedTimestamp,updated:!!Q.metadata?.updated,pinned:!!Q.metadata?.pinned,isWorkspaceScoped:!1,source:Q.metadata?.source??(Q.identifier.uuid?"gallery":"vsix")}}async I(){const Q=await this.getUninstalledExtensions();if(Object.keys(Q).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(Q));const X=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),q=new Set;for(const Y of X)Q[s.$Np.create(Y).toString()]||q.add(Y.identifier.id.toLowerCase());try{const Y=(0,s.$Sp)(X,oe=>oe.identifier);await a.Promises.settled(Y.map(async oe=>{const j=oe.sort((W,G)=>m.rcompare(W.manifest.version,G.manifest.version))[0];q.has(j.identifier.id.toLowerCase())||await this.n(await this.H(j))}))}catch(Y){this.z.error(Y)}const D=X.filter(Y=>Y.metadata&&Q[s.$Np.create(Y).toString()]);await Promise.allSettled(D.map(Y=>this.removeUninstalledExtension(Y)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let Q;try{Q=await this.s.resolve(this.t.userExtensionsLocation)}catch(X){(0,F.$rl)(X)!==F.FileOperationResult.FILE_NOT_FOUND&&this.z.error(X);return}if(Q?.children)try{await Promise.allSettled(Q.children.map(async X=>{if(!(!X.isDirectory||!X.name.endsWith(B))){this.z.trace("Deleting the temporarily deleted folder",X.resource.toString());try{await this.s.del(X.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",X.resource.toString())}catch(q){(0,F.$rl)(q)!==F.FileOperationResult.FILE_NOT_FOUND&&this.z.error(q)}}}))}catch{}}};e.$1q=_,e.$1q=_=ve([Z(1,F.$al),Z(2,o.$Nq),Z(3,r.$Jq),Z(4,H.$Kl),Z(5,x.$_l),Z(6,K.$ak)],_);let ne=class extends n.$Hq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(Q,X,q,D,Y,oe,j,W,G,J,ie,ce){super(),this.l=Q,this.manifest=X,this.source=q,this.options=D,this.m=Y,this.n=oe,this.o=j,this.p=W,this.q=G,this.s=J,this.t=ie,this.u=ce,this.j=t.InstallOperation.Install,this.identifier=this.l.identifier}async h(Q){const q=(await this.n.scanExtensions(L.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(j=>(0,s.$Mp)(j.identifier,this.identifier));q&&(this.j=t.InstallOperation.Update);const D={isApplicationScoped:this.options.isApplicationScoped||q?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||q?.isMachineScoped,isBuiltin:this.options.isBuiltin||q?.isBuiltin,isSystem:q?.type===L.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??q?.pinned,source:this.source instanceof f.URI?"vsix":"gallery"};let Y;if(this.source instanceof f.URI){if(q&&this.l.equals(new s.$Np(q.identifier,q.manifest.version)))try{await this.n.removeExtension(q,"existing")}catch{throw new Error(c.localize(11459,null,this.manifest.displayName||this.manifest.name))}const j=await this.w(this.l);if(j)try{await this.n.removeExtension(j,"existing")}catch{throw new Error(c.localize(11460,null,this.manifest.displayName||this.manifest.name))}}else{if(D.id=this.source.identifier.uuid,D.publisherId=this.source.publisherId,D.publisherDisplayName=this.source.publisherDisplayName,D.targetPlatform=this.source.properties.targetPlatform,D.updated=!!q,D.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,D.hasPreReleaseVersion=q?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,D.preRelease=(0,E.$kg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||q?.preRelease,q&&q.type!==L.ExtensionType.System&&q.manifest.version===this.source.version)return this.n.updateMetadata(q,D,this.options.profileLocation);Y=await this.w(this.l)}if(Q.isCancellationRequested)throw(0,n.$Gq)(new k.$4);if(!Y){const j=await this.m(this.operation,Q);Y=j.local,this.k=j.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(j){throw(0,n.$Gq)(j,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(Q.isCancellationRequested)throw(0,n.$Gq)(new k.$4);try{await this.t.addExtensionsToProfile([[Y,D]],this.options.profileLocation,!Y.isValid)}catch(j){throw(0,n.$Gq)(j,t.ExtensionManagementErrorCode.AddToProfile)}const oe=await this.n.scanLocalExtension(Y.location,L.ExtensionType.User,this.options.profileLocation);if(!oe)throw new t.$np("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof f.URI&&this.x(Y,Q),oe}async w(Q){return(await this.n.getUninstalledExtensions())[Q.toString()]?(this.u.trace("Removing the extension from uninstalled list:",Q.id),await this.n.setInstalled(Q),this.u.info("Removed the extension from uninstalled list:",Q.id),(await this.n.scanAllUserExtensions(!0)).find(D=>s.$Np.create(D).equals(Q))):void 0}async x(Q,X){try{let[q]=await this.p.getExtensions([{id:Q.identifier.id,version:Q.manifest.version}],X);if(q||([q]=await this.p.getExtensions([{id:Q.identifier.id}],X)),q){const D={id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId,isPreReleaseVersion:q.properties.isPreReleaseVersion,hasPreReleaseVersion:Q.hasPreReleaseVersion||q.properties.isPreReleaseVersion,preRelease:q.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(Q,D,this.options.profileLocation)}}catch{}}};ne=ve([Z(6,H.$Kl),Z(7,t.$lp),Z(8,te.$Ml),Z(9,o.$Nq),Z(10,r.$Jq),Z(11,K.$ak)],ne);class le extends n.$Hq{constructor(Q,X,q){super(),this.extension=Q,this.options=X,this.j=q}async h(Q){await this.j.removeExtensionFromProfile(this.extension,this.options.profileLocation)}}}),define(he[217],ue([0,1,10,19,28,18,52,7,15,9]),function(ae,e,R,a,C,A,T,k,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JR=void 0;let I=class extends T.$Kq{constructor(d,g,l,m,E,f){super(b.URI.file(d.extensionsPath),g,l,m,E,f)}};e.$JR=I,e.$JR=I=ve([Z(0,O.$Ni),Z(1,k.$al),Z(2,a.$Ml),Z(3,C.$Kl),Z(4,A.$_l),Z(5,R.$ak)],I)}),define(he[218],ue([0,1,9,15,52,84,7,4,10,23,28,19]),function(ae,e,R,a,C,A,T,k,O,b,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=void 0;let d=class extends A.$Rq{constructor(l,m,E,f,w,P,p,c){super(R.URI.file(w.builtinExtensionsPath),R.URI.file(w.extensionsPath),w.userHome,l.defaultProfile,l,m,E,f,w,P,p,c)}};e.$uhc=d,e.$uhc=d=ve([Z(0,$.$Ml),Z(1,C.$Jq),Z(2,T.$al),Z(3,O.$ak),Z(4,a.$Ni),Z(5,b.$tk),Z(6,I.$Kl),Z(7,k.$Ei)],d)}),define(he[16],ue([0,1,6,3,2,100,12,70,4,19]),function(ae,e,R,a,C,A,T,k,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$kq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$iq=e.$hq=e.$gq=void 0,e.$jq=g,e.$lq=m,e.$nq=f,e.$gq="__$__isNewStorageMarker",e.$hq="__$__targetStorageMarker",e.$iq=(0,O.$Fi)("storageService");var I;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var $;(function(w){w[w.APPLICATION=-1]="APPLICATION",w[w.PROFILE=0]="PROFILE",w[w.WORKSPACE=1]="WORKSPACE"})($||(e.StorageScope=$={}));var d;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function g(w){const P=w.get(e.$hq);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}class l extends C.$Uc{static{this.a=60*1e3}constructor(P={flushInterval:l.a}){super(),this.m=P,this.b=this.B(new a.$oe),this.c=this.B(new a.$oe),this.onDidChangeTarget=this.c.event,this.f=this.B(new a.$le),this.onWillSaveState=this.f.event,this.h=this.B(new R.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new C.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(P,p,c){return a.Event.filter(this.b.event,h=>h.scope===P&&(p===void 0||h.key===p),c)}n(){this.j.value=(0,R.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,C.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(P,p){const{key:c,external:h}=p;if(c===e.$hq){switch(P){case $.APPLICATION:this.H=void 0;break;case $.PROFILE:this.F=void 0;break;case $.WORKSPACE:this.C=void 0;break}this.c.fire({scope:P})}else this.b.fire({scope:P,key:c,target:this.J(P)[c],external:h})}w(P){this.f.fire({reason:P})}get(P,p,c){return this.P(p)?.get(P,c)}getBoolean(P,p,c){return this.P(p)?.getBoolean(P,c)}getNumber(P,p,c){return this.P(p)?.getNumber(P,c)}getObject(P,p,c){return this.P(p)?.getObject(P,c)}storeAll(P,p){this.y(()=>{for(const c of P)this.store(c.key,c.value,c.scope,c.target,p)})}store(P,p,c,h,i=!1){if((0,T.$ng)(p)){this.remove(P,c,i);return}this.y(()=>{this.z(P,c,h),this.P(c)?.set(P,p,i)})}remove(P,p,c=!1){this.y(()=>{this.z(P,p,void 0),this.P(p)?.delete(P,c)})}y(P){this.b.pause(),this.c.pause();try{P()}finally{this.b.resume(),this.c.resume()}}keys(P,p){const c=[],h=this.J(P);for(const i of Object.keys(h))h[i]===p&&c.push(i);return c}z(P,p,c,h=!1){const i=this.J(p);typeof c=="number"?i[P]!==c&&(i[P]=c,this.P(p)?.set(e.$hq,JSON.stringify(i),h)):typeof i[P]=="number"&&(delete i[P],this.P(p)?.set(e.$hq,JSON.stringify(i),h))}get D(){return this.C||(this.C=this.L($.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L($.PROFILE)),this.F}get I(){return this.H||(this.H=this.L($.APPLICATION)),this.H}J(P){switch(P){case $.APPLICATION:return this.I;case $.PROFILE:return this.G;default:return this.D}}L(P){const p=this.P(P);return p?g(p):Object.create(null)}isNew(P){return this.getBoolean(e.$gq,P)===!0}async flush(P=I.NONE){this.f.fire({reason:P});const p=this.P($.APPLICATION),c=this.P($.PROFILE),h=this.P($.WORKSPACE);switch(P){case I.NONE:await R.Promises.settled([p?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await R.Promises.settled([p?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve()]);break}}async log(){const P=this.P($.APPLICATION)?.items??new Map,p=this.P($.PROFILE)?.items??new Map,c=this.P($.WORKSPACE)?.items??new Map;return f(P,p,c,this.Q($.APPLICATION)??"",this.Q($.PROFILE)??"",this.Q($.WORKSPACE)??"")}async optimize(P){return await this.flush(),this.P(P)?.optimize()}async switch(P,p){return this.w(I.NONE),(0,b.$Ll)(P)?this.R(P,p):this.S(P,p)}M(P,p){return!(P.id===p.id||m(p)&&m(P))}N(P,p,c){this.y(()=>{const h=new Set;for(const[i,n]of P)h.add(i),p.get(i)!==n&&this.u(c,{key:i,external:!0});for(const[i]of p.items)h.has(i)||this.u(c,{key:i,external:!0})})}}e.$kq=l;function m(w){return w.isDefault||!!w.useDefaultFlags?.globalState}class E extends l{constructor(){super(),this.U=this.B(new k.$eq(new k.$fq,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new k.$eq(new k.$fq,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new k.$eq(new k.$fq,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(P=>this.u($.WORKSPACE,P))),this.B(this.W.onDidChangeStorage(P=>this.u($.PROFILE,P))),this.B(this.U.onDidChangeStorage(P=>this.u($.APPLICATION,P)))}P(P){switch(P){case $.APPLICATION:return this.U;case $.PROFILE:return this.W;default:return this.X}}Q(P){switch(P){case $.APPLICATION:return"inMemory (application)";case $.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(P){return!1}}e.$mq=E;async function f(w,P,p,c,h,i){const n=v=>{try{return JSON.parse(v)}catch{return v}},t=new Map,s=new Map;w.forEach((v,L)=>{t.set(L,v),s.set(L,n(v))});const r=new Map,o=new Map;P.forEach((v,L)=>{r.set(L,v),o.set(L,n(v))});const u=new Map,y=new Map;p.forEach((v,L)=>{u.set(L,v),y.set(L,n(v))}),console.group(c!==h?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const N=[];if(t.forEach((v,L)=>{N.push({key:L,value:v})}),console.table(N),console.groupEnd(),console.log(s),c!==h){console.group(`Storage: Profile (path: ${h}, profile specific)`);const v=[];r.forEach((L,U)=>{v.push({key:U,value:L})}),console.table(v),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${i})`);const S=[];u.forEach((v,L)=>{S.push({key:L,value:v})}),console.table(S),console.groupEnd(),console.log(y)}}),define(he[118],ue([0,1,3,2,12,27,35,16]),function(ae,e,R,a,C,A,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BMb=e.$AMb=void 0;let O=class extends a.$Uc{constructor($,d){super(),this.a=new R.$le,this.onDidChangeEnablement=this.a.event,this.b=this.B(new b($)),this.B(this.b.onDidChange(g=>this.a.fire({extensions:g,source:"storage"}))),this.B(d.onDidInstallExtensions(g=>g.forEach(({local:l,operation:m})=>{l&&m===A.InstallOperation.Migrate&&this.f(l.identifier)})))}async enableExtension($,d){return this.f($)?(this.a.fire({extensions:[$],source:d}),!0):!1}async disableExtension($,d){return this.c($)?(this.a.fire({extensions:[$],source:d}),!0):!1}getDisabledExtensions(){return this.h(A.$pp)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c($){const d=this.getDisabledExtensions();return d.every(g=>!(0,T.$Mp)(g,$))?(d.push($),this.g(d),!0):!1}f($){const d=this.getDisabledExtensions();for(let g=0;g<d.length;g++){const l=d[g];if((0,T.$Mp)(l,$))return d.splice(g,1),this.g(d),!0}return!1}g($){this.j(A.$pp,$)}h($){return this.b.get($,k.StorageScope.PROFILE)}j($,d){this.b.set($,d,k.StorageScope.PROFILE)}};e.$AMb=O,e.$AMb=O=ve([Z(0,k.$iq),Z(1,A.$op)],O);class b extends a.$Uc{constructor($){super(),this.c=$,this.a=Object.create(null),this.b=this.B(new R.$le),this.onDidChange=this.b.event,this.B($.onDidChangeValue(k.StorageScope.PROFILE,void 0,this.B(new a.$Tc))(d=>this.f(d)))}get($,d){let g;return d===k.StorageScope.PROFILE?((0,C.$ng)(this.a[$])&&(this.a[$]=this.g($,d)),g=this.a[$]):g=this.g($,d),JSON.parse(g)}set($,d,g){const l=JSON.stringify(d.map(({id:E,uuid:f})=>({id:E,uuid:f})));this.g($,g)!==l&&(g===k.StorageScope.PROFILE&&(d.length?this.a[$]=l:delete this.a[$]),this.h($,d.length?l:void 0,g))}f($){if(!(0,C.$ng)(this.a[$.key])&&this.g($.key,$.scope)!==this.a[$.key]){const g=this.get($.key,$.scope);delete this.a[$.key];const l=this.get($.key,$.scope),m=g.filter(f=>!l.some(w=>(0,T.$Mp)(f,w))),E=l.filter(f=>!g.some(w=>(0,T.$Mp)(w,f)));(m.length||E.length)&&this.b.fire([...m,...E])}}g($,d){return this.c.get($,d,"[]")}h($,d,g){d?this.c.store($,d,g,k.StorageTarget.MACHINE):this.c.remove($,g)}}e.$BMb=b}),define(he[85],ue([0,1,4,3,2,16,35,23,17,10,12]),function(ae,e,R,a,C,A,T,k,O,b,I){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$rw=e.$qw=void 0,e.$qw=(0,R.$Fi)("IExtensionStorageService");const d=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let g=class extends C.$Uc{static{$=this}static{this.a=512*1024}static b(m){return`extensionKeys/${(0,T.$Qp)(m.id)}@${m.version}`}static c(m){const E=d.exec(m);if(E&&E[1])return{id:E[1],version:E[2]}}static async removeOutdatedExtensionVersions(m,E){const f=await m.getInstalled(),w=[];for(const[P,p]of $.f(E)){const c=f.find(h=>(0,T.$Mp)(h.identifier,{id:P}))?.manifest.version;for(const h of p)c!==h&&w.push($.b({id:P,version:h}))}for(const P of w)E.remove(P,A.StorageScope.PROFILE)}static f(m){const E=new Map,f=m.keys(A.StorageScope.PROFILE,A.StorageTarget.MACHINE);for(const w of f){const P=$.c(w);if(P){let p=E.get(P.id.toLowerCase());p||E.set(P.id.toLowerCase(),p=[]),p.push(P.version)}}return E}constructor(m,E,f){super(),this.j=m,this.m=E,this.n=f,this.g=this.B(new a.$le),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=$.f(m),this.B(this.j.onDidChangeValue(A.StorageScope.PROFILE,void 0,this.B(new C.$Tc))(w=>this.r(w)))}r(m){if(this.h.has(m.key.toLowerCase())){this.g.fire();return}const E=$.c(m.key);if(E){if(this.j.get(m.key,A.StorageScope.PROFILE)===void 0)this.h.delete(E.id.toLowerCase());else{let f=this.h.get(E.id.toLowerCase());f||this.h.set(E.id.toLowerCase(),f=[]),f.push(E.version),this.g.fire()}return}}s(m){if((0,I.$eg)(m))return m;const E=m.manifest?m.manifest.publisher:m.publisher,f=m.manifest?m.manifest.name:m.name;return(0,T.$Pp)(E,f)}getExtensionState(m,E){const f=this.s(m),w=this.getExtensionStateRaw(m,E);if(w)try{return JSON.parse(w)}catch(P){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${E}): ${P}`)}}getExtensionStateRaw(m,E){const f=this.s(m),w=this.j.get(f,E?A.StorageScope.PROFILE:A.StorageScope.WORKSPACE);return w&&w?.length>$.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${f}, global: ${E}): ${w.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),w}setExtensionState(m,E,f){const w=this.s(m);E===void 0?this.j.remove(w,f?A.StorageScope.PROFILE:A.StorageScope.WORKSPACE):this.j.store(w,JSON.stringify(E),f?A.StorageScope.PROFILE:A.StorageScope.WORKSPACE,A.StorageTarget.MACHINE)}setKeysForSync(m,E){this.j.store($.b(m),JSON.stringify(E),A.StorageScope.PROFILE,A.StorageTarget.MACHINE)}getKeysForSync(m){const E=this.m.extensionSyncedKeys?.[m.id.toLowerCase()],f=this.j.get($.b(m),A.StorageScope.PROFILE),w=f?JSON.parse(f):void 0;return w&&E?(0,O.$Lb)([...w,...E]):w||E}addToMigrationList(m,E){if(m!==E){const f=this.t.filter(w=>!w.includes(m)&&!w.includes(E));f.push([m,E]),this.t=f}}getSourceExtensionToMigrate(m){const E=this.t.find(([,f])=>m===f);return E?E[0]:void 0}get t(){const m=this.j.get("extensionStorage.migrationList",A.StorageScope.APPLICATION,"[]");try{const E=JSON.parse(m);if(Array.isArray(E))return E}catch{}return[]}set t(m){m.length?this.j.store("extensionStorage.migrationList",JSON.stringify(m),A.StorageScope.APPLICATION,A.StorageTarget.MACHINE):this.j.remove("extensionStorage.migrationList",A.StorageScope.APPLICATION)}};e.$rw=g,e.$rw=g=$=ve([Z(0,A.$iq),Z(1,k.$tk),Z(2,b.$ak)],g)}),define(he[219],ue([0,1,2,27,85,197,117,10,16]),function(ae,e,R,a,C,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=void 0;let b=class extends R.$Uc{constructor($,d,g,l,m,E){super(),$.cleanUp(),(0,A.$T7b)($,d,g,l,E),C.$rw.removeOutdatedExtensionVersions($,m)}};e.$Eic=b,e.$Eic=b=ve([Z(0,T.$Yq),Z(1,a.$lp),Z(2,C.$qw),Z(3,a.$rp),Z(4,O.$iq),Z(5,k.$ak)],b)}),define(he[220],ue([0,1,17,2,20,9,7,23,6,3,13,5,37,35,74,34,16]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=e.$Vec=void 0;let f=class extends a.$Uc{constructor(h,i){super(),this.b=h,this.c=i,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,n])=>this.a.set(n.configPath,n))}getConfigBasedTips(h){return this.f(h)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(h){const i=[];for(const[n,t]of this.a)if(!(t.configScheme&&t.configScheme!==h.scheme))try{const s=(await this.b.readFile((0,C.$gh)(h,n))).value.toString();for(const[r,o]of Object.entries(t.recommendations))(!o.contentPattern||new RegExp(o.contentPattern,"mig").test(s))&&i.push({extensionId:r,extensionName:o.name,configName:t.configName,important:!!o.important,isExtensionPack:!!o.isExtensionPack,whenNotInstalled:o.whenNotInstalled})}catch{}return i}};e.$Vec=f,e.$Vec=f=ve([Z(0,T.$al),Z(1,k.$tk)],f);const w="extensionTips/promptedExecutableTips",P="extensionTips/lastPromptedMediumImpExeTime";class p extends f{constructor(h,i,n,t,s,r,o,u){super(o,u),this.r=h,this.s=i,this.t=n,this.u=t,this.w=s,this.z=r,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,u.exeBasedExtensionTips&&Object.entries(u.exeBasedExtensionTips).forEach(([y,N])=>{const S=[],v=[],L=[];Object.entries(N.recommendations).forEach(([U,F])=>{F.important?N.important?S.push({extensionId:U,extensionName:F.name,isExtensionPack:!!F.isExtensionPack}):v.push({extensionId:U,extensionName:F.name,isExtensionPack:!!F.isExtensionPack}):L.push({extensionId:U,extensionName:F.name,isExtensionPack:!!F.isExtensionPack})}),S.length&&this.g.set(y,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:S}),v.length&&this.h.set(y,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:v}),L.length&&this.j.set(y,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:L})}),(0,O.$Hh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const h=await this.O(this.g),i=await this.O(this.h);return[...h,...i]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const h=await this.O(this.g),i=await this.O(this.h),n=await this.u.getInstalled();this.m=this.D(h,n),this.n=this.D(i,n)}D(h,i){const n=new Map;h.forEach(u=>n.set(u.extensionId.toLowerCase(),u));const{installed:t,uninstalled:s}=this.N([...n.keys()],i);for(const u of t){const y=n.get(u);y&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:u,exeName:y.exeName})}for(const u of s){const y=n.get(u);y&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:u,exeName:y.exeName})}const r=this.L(),o=new Map;for(const u of s){const y=n.get(u);if(y&&(!r[y.exeName]||!r[y.exeName].includes(y.extensionId))){let N=o.get(y.exeName);N||(N=[],o.set(y.exeName,N)),N.push(y)}}return o}F(){if(this.m.size===0)return;const[h,i]=[...this.m.entries()][0];this.H(i).then(n=>{switch(n){case l.RecommendationsNotificationResult.Accepted:this.M(i[0].exeName,i);break;case l.RecommendationsNotificationResult.Ignored:this.m.delete(h);break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const t=b.Event.once(b.Event.latch(b.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(t(()=>this.F()));break}case l.RecommendationsNotificationResult.TooMany:{const t=this.B(new a.$Vc);t.value=(0,O.$Hh)(()=>{t.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const h=this.I(),i=Date.now()-h,n=7*24*60*60*1e3;if(i<n){const r=this.B(new a.$Vc);r.value=(0,O.$Hh)(()=>{r.dispose(),this.G()},n-i);return}const[t,s]=[...this.n.entries()][0];this.H(s).then(r=>{switch(r){case l.RecommendationsNotificationResult.Accepted:{this.J(Date.now()),this.n.delete(t),this.M(s[0].exeName,s);const o=this.B(new a.$Vc);o.value=(0,O.$Hh)(()=>{o.dispose(),this.G()},n);break}case l.RecommendationsNotificationResult.Ignored:this.n.delete(t),this.G();break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const o=b.Event.once(b.Event.latch(b.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(o(()=>this.G()));break}case l.RecommendationsNotificationResult.TooMany:{const o=this.B(new a.$Vc);o.value=(0,O.$Hh)(()=>{o.dispose(),this.G()},60*60*1e3);break}}})}async H(h){const i=await this.u.getInstalled(m.ExtensionType.User),n=h.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(s=>i.every(r=>!(0,g.$Mp)(r.identifier,{id:s})))).map(({extensionId:t})=>t.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:n,source:l.RecommendationSource.EXE,name:h[0].exeFriendlyName,searchValue:`@exe:"${h[0].exeName}"`})}I(){let h=this.w.getNumber(P,E.StorageScope.APPLICATION);return h||(h=Date.now(),this.J(h)),h}J(h){this.w.store(P,h,E.StorageScope.APPLICATION,E.StorageTarget.MACHINE)}L(){return JSON.parse(this.w.get(w,E.StorageScope.APPLICATION,"{}"))}M(h,i){const n=this.L();n[h]=i.map(({extensionId:t})=>t.toLowerCase()),this.w.store(w,JSON.stringify(n),E.StorageScope.APPLICATION,E.StorageTarget.USER)}N(h,i){const n=[],t=[],s=i.reduce((r,o)=>(r.add(o.identifier.id.toLowerCase()),r),new Set);return h.forEach(r=>{s.has(r.toLowerCase())?n.push(r):t.push(r)}),{installed:n,uninstalled:t}}async O(h){const i=[],n=new Map;for(const t of h.keys()){const s=h.get(t);if(!s||!(0,R.$Kb)(s.recommendations))continue;const r=[];$.$j?s.windowsPath&&r.push(s.windowsPath.replace("%USERPROFILE%",()=>d.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>d.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>d.env.ProgramFiles).replace("%APPDATA%",()=>d.env.APPDATA).replace("%WINDIR%",()=>d.env.WINDIR)):(r.push((0,I.$jc)("/usr/local/bin",t)),r.push((0,I.$jc)("/usr/bin",t)),r.push((0,I.$jc)(this.r.fsPath,t)));for(const o of r){let u=n.get(o);if(u===void 0&&(u=await this.b.exists(A.URI.file(o)),n.set(o,u)),u)for(const{extensionId:y,extensionName:N,isExtensionPack:S,whenNotInstalled:v}of s.recommendations)i.push({extensionId:y,extensionName:N,isExtensionPack:S,exeName:t,exeFriendlyName:s.exeFriendlyName,windowsPath:s.windowsPath,whenNotInstalled:v})}}return i}}e.$Wec=p}),define(he[221],ue([0,1,27,7,23,15,74,57,16,18,220]),function(ae,e,R,a,C,A,T,k,O,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=void 0;let $=class extends I.$Wec{constructor(g,l,m,E,f,w,P,p){super(g.userHome,f,l,m,E,w,P,p)}};e.$Lic=$,e.$Lic=$=ve([Z(0,A.$Ni),Z(1,b.$_l),Z(2,R.$op),Z(3,O.$iq),Z(4,k.$Ggc),Z(5,T.$B7b),Z(6,a.$al),Z(7,C.$tk)],$)}),define(he[49],ue([0,1,14,32,16]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=A;async function A(T,k,O){let b=O&&O.get("storage.serviceMachineId",C.StorageScope.APPLICATION)||null;if(b)return b;try{const $=(await k.readFile(T.serviceMachineIdResource)).value.toString();b=(0,a.$1g)($)?$:null}catch{b=null}if(!b){b=(0,a.$2g)();try{await k.writeFile(T.serviceMachineIdResource,R.$Ne.fromString(b))}catch{}}return O?.store("storage.serviceMachineId",b,C.StorageScope.APPLICATION,C.StorageTarget.MACHINE),b}}),define(he[222],ue([0,1,49,18,48]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=A;async function A(T,k,O,b,I,$,d){const g={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${k.nameShort})`};if((0,C.$Ep)(k,O)&&(0,C.$Gp)(b)===a.TelemetryLevel.USAGE){const l=await(0,R.$oq)(O,I,$);g["X-Market-User-Id"]=l,g["VSCode-SessionId"]=d.machineId||l}return g}}),define(he[223],ue([0,1,17,25,8,5,37,12,9,21,15,27,35,34,59,7,10,23,61,222,16,18,54]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f,w,P,p,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=void 0,e.$qq=Q;const i=A.$p?g.TargetPlatform.WEB:(0,$.$hp)(A.$v,T.$ec),n="X-Market-Search-Activity-Id";var t;(function(j){j[j.None=0]="None",j[j.IncludeVersions=1]="IncludeVersions",j[j.IncludeFiles=2]="IncludeFiles",j[j.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",j[j.IncludeSharedAccounts=8]="IncludeSharedAccounts",j[j.IncludeVersionProperties=16]="IncludeVersionProperties",j[j.ExcludeNonValidated=32]="ExcludeNonValidated",j[j.IncludeInstallationTargets=64]="IncludeInstallationTargets",j[j.IncludeAssetUri=128]="IncludeAssetUri",j[j.IncludeStatistics=256]="IncludeStatistics",j[j.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",j[j.Unpublished=4096]="Unpublished",j[j.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function s(...j){return String(j.reduce((W,G)=>W|G,0))}var r;(function(j){j[j.Tag=1]="Tag",j[j.ExtensionId=4]="ExtensionId",j[j.Category=5]="Category",j[j.ExtensionName=7]="ExtensionName",j[j.Target=8]="Target",j[j.Featured=9]="Featured",j[j.SearchText=10]="SearchText",j[j.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},u={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support",ExecutesCode:"Microsoft.VisualStudio.Code.ExecutesCode"},N={pageNumber:1,pageSize:10,sortBy:$.SortBy.NoneOrRelevance,sortOrder:$.SortOrder.Default,flags:t.None,criteria:[],assetTypes:[]};class S{constructor(W=N){this.d=W}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(W,G=this.d.pageSize){return new S({...this.d,pageNumber:W,pageSize:G})}withFilter(W,...G){const J=[...this.d.criteria,...G.length?G.map(ie=>({filterType:W,value:ie})):[{filterType:W}]];return new S({...this.d,criteria:J})}withSortBy(W){return new S({...this.d,sortBy:W})}withSortOrder(W){return new S({...this.d,sortOrder:W})}withFlags(...W){return new S({...this.d,flags:W.reduce((G,J)=>G|J,0)})}withAssetTypes(...W){return new S({...this.d,assetTypes:W})}withSource(W){return new S({...this.d,source:W})}get raw(){const{criteria:W,pageNumber:G,pageSize:J,sortBy:ie,sortOrder:ce,flags:ge,assetTypes:pe}=this.d;return{filters:[{criteria:W,pageNumber:G,pageSize:J,sortBy:ie,sortOrder:ce}],assetTypes:pe,flags:ge}}get searchText(){const W=this.d.criteria.filter(G=>G.filterType===r.SearchText)[0];return W&&W.value?W.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(W=>String(W.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function v(j,W){const G=(j||[]).filter(J=>J.statisticName===W)[0];return G?G.value:0}function L(j){const W="Microsoft.VisualStudio.Code.Translation.";return j.files.filter(J=>J.assetType.indexOf(W)===0).reduce((J,ie)=>{const ce=M(j,ie.assetType);return ce&&J.push([ie.assetType.substring(W.length),ce]),J},[])}function U(j){if(j.properties){const W=j.properties.filter(ie=>ie.key===o.Repository),G=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),J=W.filter(ie=>G.test(ie.value))[0];return J?{uri:J.value,fallbackUri:J.value}:null}return M(j,o.Repository)}function F(j){return{uri:`${j.fallbackAssetUri}/${o.VSIX}?redirect=true${j.targetPlatform?`&targetPlatform=${j.targetPlatform}`:""}`,fallbackUri:`${j.fallbackAssetUri}/${o.VSIX}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`}}function M(j,W){return j.files.filter(J=>J.assetType===W)[0]?{uri:`${j.assetUri}/${W}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`,fallbackUri:`${j.fallbackAssetUri}/${W}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`}:null}function K(j,W){const G=j.properties?j.properties.filter(ie=>ie.key===W):[],J=G.length>0&&G[0].value;return J?J.split(",").map(ie=>(0,d.$Qp)(ie)):[]}function V(j){const W=j.properties?j.properties.filter(G=>G.key===u.Engine):[];return W.length>0&&W[0].value||""}function x(j){const W=j.properties?j.properties.filter(G=>G.key===u.PreRelease):[];return W.length>0&&W[0].value==="true"}function H(j){const W=j.properties?j.properties.filter(G=>G.key===u.ExecutesCode):[];return W.length>0?W[0].value==="true":void 0}function te(j){const W=j.properties?j.properties.filter(J=>J.key===u.EnabledApiProposals):[],G=W.length>0&&W[0].value||"";return G?G.split(","):[]}function B(j){const W=j.properties?j.properties.filter(J=>J.key===u.LocalizedLanguages):[],G=W.length>0&&W[0].value||"";return G?G.split(","):[]}function z(j){return j.properties?.find(W=>W.key===u.SponsorLink)?.value}function _(j){return j.properties?.find(W=>W.key===u.SupportLink)?.value}function ne(j){return j.indexOf("preview")!==-1}function le(j){return j.targetPlatform?(0,$.$gp)(j.targetPlatform):g.TargetPlatform.UNDEFINED}function ee(j){const W=(0,R.$Lb)(j.versions.map(le)),G=!!j.tags?.includes($.$ap),J=W.indexOf(g.TargetPlatform.WEB);return G?J===-1&&W.push(g.TargetPlatform.WEB):J!==-1&&W.splice(J,1),W}function Q(j,W){for(let G=0;G<j.length;G++){const J=j[G];if(J.version===j[G-1]?.version){let ie=G;if(le(J)===W)for(;ie>0&&j[ie-1].version===J.version;)ie--;ie!==G&&(j.splice(G,1),j.splice(ie,0,J))}}return j}function X(j,W,G){j.telemetryData={index:W,querySource:G,queryActivityId:j.queryContext?.[n]}}function q(j,W,G,J){const ie=j.versions[0],ce={manifest:M(W,o.Manifest),readme:M(W,o.Details),changelog:M(W,o.Changelog),license:M(W,o.License),repository:U(W),download:F(W),icon:M(W,o.Icon),signature:M(W,o.Signature),coreTranslations:L(W)};return{type:"gallery",identifier:{id:(0,d.$Rp)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},name:j.extensionName,version:W.version,displayName:j.displayName,publisherId:j.publisher.publisherId,publisher:j.publisher.publisherName,publisherDisplayName:j.publisher.displayName,publisherDomain:j.publisher.domain?{link:j.publisher.domain,verified:!!j.publisher.isDomainVerified}:void 0,publisherSponsorLink:z(ie),description:j.shortDescription??"",installCount:v(j.statistics,"install"),rating:v(j.statistics,"averagerating"),ratingCount:v(j.statistics,"ratingcount"),categories:j.categories||[],tags:j.tags||[],releaseDate:Date.parse(j.releaseDate),lastUpdated:Date.parse(j.lastUpdated),allTargetPlatforms:G,assets:ce,properties:{dependencies:K(W,u.Dependency),extensionPack:K(W,u.ExtensionPack),engine:V(W),enabledApiProposals:te(W),localizedLanguages:B(W),targetPlatform:le(W),isPreReleaseVersion:x(W),executesCode:H(W)},hasPreReleaseVersion:x(ie),hasReleaseVersion:!0,preview:ne(j.flags),isSigned:!!ce.signature,queryContext:J,supportLink:_(ie)}}let D=class{constructor(W,G,J,ie,ce,ge,pe,Ee){this.l=G,this.n=J,this.o=ie,this.q=ce,this.u=ge,this.w=pe,this.x=Ee;const Pe=pe.extensionsGallery,be=Pe?.servicePPEUrl&&Ee.getValue("_extensionsGallery.enablePPE");this.d=be?Pe.servicePPEUrl:Pe?.serviceUrl,this.g=be?void 0:Pe?.searchUrl,this.h=Pe?.controlUrl,this.k=pe.extensionsEnabledWithApiProposalVersion?.map(we=>we.toLowerCase())??[],this.j=(0,P.$pq)(pe.version,pe,this.o,this.x,this.u,W,this.q)}y(W=""){return`${this.d}${W}`}isEnabled(){return!!this.d}async getExtensions(W,G,J){const ie=a.CancellationToken.isCancellationToken(G)?{}:G,ce=a.CancellationToken.isCancellationToken(G)?G:J,ge=[],pe=[],Ee=[],Pe=[];let be=!0;for(const re of W){re.uuid?pe.push(re.uuid):ge.push(re.id);const de=!!(re.version||re.preRelease);Ee.push({id:re.id,uuid:re.uuid,includePreRelease:de}),re.version&&Pe.push({id:re.id,uuid:re.uuid,version:re.version}),be=be&&!!re.hasPreRelease&&!de}if(!pe.length&&!ge.length)return[];let we=new S().withPage(1,W.length);pe.length&&(we=we.withFilter(r.ExtensionId,...pe)),ge.length&&(we=we.withFilter(r.ExtensionName,...ge)),(ie.queryAllVersions||be)&&(we=we.withFlags(we.flags,t.IncludeVersions)),ie.source&&(we=we.withSource(ie.source));const{extensions:Se}=await this.B(we,{targetPlatform:ie.targetPlatform??i,includePreRelease:Ee,versions:Pe,compatible:!!ie.compatible,productVersion:ie.productVersion??{version:this.w.version,date:this.w.date}},ce);return ie.source&&Se.forEach((re,de)=>X(re,de,ie.source)),Se}async getCompatibleExtension(W,G,J,ie={version:this.w.version,date:this.w.date}){if((0,$.$ip)(W.allTargetPlatforms,J))return null;if(await this.isExtensionCompatible(W,G,J))return W;const ce=new S().withFlags(t.IncludeVersions).withPage(1,1).withFilter(r.ExtensionId,W.identifier.uuid),{extensions:ge}=await this.B(ce,{targetPlatform:J,compatible:!0,includePreRelease:G,productVersion:ie},a.CancellationToken.None);return ge[0]||null}async isExtensionCompatible(W,G,J,ie={version:this.w.version,date:this.w.date}){if(!(0,$.$jp)(W.properties.targetPlatform,W.allTargetPlatforms,J)||!G&&W.properties.isPreReleaseVersion)return!1;let ce=W.properties.engine;if(!ce){const ge=await this.getManifest(W,a.CancellationToken.None);if(!ge)throw new Error("Manifest was not found");ce=ge.engines.vscode}return!(!(0,l.$6p)(ce,ie.version,ie.date)||!this.z(W.identifier,W.properties.enabledApiProposals))}z(W,G){return!G||!this.k.includes(W.id.toLowerCase())?!0:(0,l.$7p)(G)}async A(W,G,J,ie,ce,ge,pe={version:this.w.version,date:this.w.date}){if(!(0,$.$jp)(le(G),ce,ge)||J!=="any"&&x(G)!==(J==="prerelease"))return!1;if(ie)try{const Ee=await this.G(W,G);if(!(0,l.$6p)(Ee,pe.version,pe.date))return!1}catch(Ee){return this.n.error(`Error while getting the engine for the version ${G.version}.`,(0,C.$9)(Ee)),!1}return!0}async query(W,G){let J=W.text||"";const ie=W.pageSize??50;let ce=new S().withPage(1,ie);J?(J=J.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(be,we,Se)=>(ce=ce.withFilter(r.Category,Se||we),"")),J=J.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(be,we,Se)=>(ce=ce.withFilter(r.Tag,Se||we),"")),J=J.replace(/\bfeatured(\s+|\b|$)/g,()=>(ce=ce.withFilter(r.Featured),"")),J=J.trim(),J&&(J=J.length<200?J:J.substring(0,200),ce=ce.withFilter(r.SearchText,J)),ce=ce.withSortBy($.SortBy.NoneOrRelevance)):W.ids?ce=ce.withFilter(r.ExtensionId,...W.ids):W.names?ce=ce.withFilter(r.ExtensionName,...W.names):ce=ce.withSortBy($.SortBy.InstallCount),typeof W.sortBy=="number"&&(ce=ce.withSortBy(W.sortBy)),typeof W.sortOrder=="number"&&(ce=ce.withSortOrder(W.sortOrder)),W.source&&(ce=ce.withSource(W.source));const ge=async(be,we)=>{const{extensions:Se,total:re}=await this.B(be,{targetPlatform:i,compatible:!1,includePreRelease:!!W.includePreRelease,productVersion:W.productVersion??{version:this.w.version,date:this.w.date}},we);return Se.forEach((de,me)=>X(de,(be.pageNumber-1)*be.pageSize+me,W.source)),{extensions:Se,total:re}},{extensions:pe,total:Ee}=await ge(ce,G),Pe=async(be,we)=>{if(we.isCancellationRequested)throw new C.$4;const{extensions:Se}=await ge(ce.withPage(be+1),we);return Se};return{firstPage:pe,total:Ee,pageSize:ce.pageSize,getPage:Pe}}async B(W,G,J){const ie=W.flags;W.flags&t.IncludeLatestVersionOnly&&W.flags&t.IncludeVersions&&(W=W.withFlags(W.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(W.flags&t.IncludeLatestVersionOnly)&&!(W.flags&t.IncludeVersions)&&(W=W.withFlags(W.flags,t.IncludeLatestVersionOnly)),G.versions?.length&&(W=W.withFlags(W.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),W=W.withFlags(W.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:ce,total:ge,context:pe}=await this.D(W,J);if(!(W.flags&t.IncludeLatestVersionOnly)){const we=[];for(const Se of ce){const re=await this.C(Se,G,pe);re&&we.push(re)}return{extensions:we,total:ge}}const Pe=[],be=new Map;for(let we=0;we<ce.length;we++){const Se=ce[we],re={id:(0,d.$Rp)(Se.publisher.publisherName,Se.extensionName),uuid:Se.extensionId},de=(0,k.$kg)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(Re=>(0,d.$Mp)(Re,re))?.includePreRelease;if(G.compatible&&(0,$.$ip)(ee(Se),G.targetPlatform))continue;const me=await this.C(Se,G,pe);!me||me.properties.isPreReleaseVersion&&(!de||!me.hasReleaseVersion)||!me.properties.isPreReleaseVersion&&me.properties.targetPlatform!==G.targetPlatform&&me.hasPreReleaseVersion?be.set(Se.extensionId,we):Pe.push([we,me])}if(be.size){const we=new h.$fe,Se=new S().withFlags(ie&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,be.size).withFilter(r.ExtensionId,...be.keys()),{extensions:re}=await this.B(Se,G,J);this.q.publicLog2("galleryService:additionalQuery",{duration:we.elapsed(),count:be.size});for(const de of re){const me=be.get(de.identifier.uuid);Pe.push([me,de])}}return{extensions:Pe.sort((we,Se)=>we[0]-Se[0]).map(([,we])=>we),total:ge}}async C(W,G,J){const ie={id:(0,d.$Rp)(W.publisher.publisherName,W.extensionName),uuid:W.extensionId},ce=G.versions?.find(Pe=>(0,d.$Mp)(Pe,ie))?.version,ge=(0,k.$kg)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(Pe=>(0,d.$Mp)(Pe,ie))?.includePreRelease,pe=ee(W),Ee=Q(W.versions,G.targetPlatform);if(G.compatible&&(0,$.$ip)(pe,G.targetPlatform))return null;for(let Pe=0;Pe<Ee.length;Pe++){const be=Ee[Pe];if(!(ce&&be.version!==ce)){if(await this.A(ie.id,be,ge?"any":"release",G.compatible,pe,G.targetPlatform,G.productVersion))return G.compatible&&!this.z(ie,te(be))?null:q(W,be,pe,J);if(ce&&be.version===ce)return null}}return ce||G.compatible?null:q(W,W.versions[0],pe)}async D(W,G){if(!this.isEnabled())throw new Error("No extension gallery service configured.");W=W.withFlags(W.flags,t.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,s(t.Unpublished));const J=await this.j,ie=JSON.stringify(W.raw),ce={...J,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ie.length)},ge=new h.$fe;let pe,Ee,Pe=0;try{if(pe=await this.l.request({type:"POST",url:this.g&&W.criteria.some(we=>we.filterType===r.SearchText)?this.g:this.y("/extensionquery"),data:ie,headers:ce},G),pe.res.statusCode&&pe.res.statusCode>=400&&pe.res.statusCode<500)return{galleryExtensions:[],total:Pe};const be=await(0,w.$bq)(pe);if(be){const we=be.results[0],Se=we.extensions,re=we.resultMetadata&&we.resultMetadata.filter(de=>de.metadataType==="ResultCount")[0];return Pe=re&&re.metadataItems.filter(de=>de.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:Pe,context:pe.res.headers.activityid?{[n]:pe.res.headers.activityid}:{}}}return{galleryExtensions:[],total:Pe}}catch(be){if((0,C.$3)(be))throw Ee=$.ExtensionGalleryErrorCode.Cancelled,be;{const we=(0,C.$9)(be);throw Ee=we.startsWith("XHR timeout")?$.ExtensionGalleryErrorCode.Timeout:$.ExtensionGalleryErrorCode.Failed,new $.$mp(we,Ee)}}finally{this.q.publicLog2("galleryService:query",{...W.telemetryData,requestBodySize:String(ie.length),duration:ge.elapsed(),success:!!pe&&(0,w.$0p)(pe),responseBodySize:pe?.res.headers["Content-Length"],statusCode:pe?String(pe.res.statusCode):void 0,errorCode:Ee,count:String(Pe)})}}async reportStatistic(W,G,J,ie){if(!this.isEnabled())return;const ce=A.$p?this.y(`/itemName/${W}.${G}/version/${J}/statType/${ie===$.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${W}/extensions/${G}/${J}/stats?statType=${ie}`),ge=A.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ee={...await this.j,Accept:ge};try{await this.l.request({type:"POST",url:ce,headers:Ee},a.CancellationToken.None)}catch{}}async download(W,G,J){this.n.trace("ExtensionGalleryService#download",W.identifier.id);const ie=(0,d.$Up)(W),ce=new Date().getTime(),ge=J===$.InstallOperation.Install?"install":J===$.InstallOperation.Update?"update":"",pe=ge?{uri:`${W.assets.download.uri}${O.URI.parse(W.assets.download.uri).query?"&":"?"}${ge}=true`,fallbackUri:`${W.assets.download.fallbackUri}${O.URI.parse(W.assets.download.fallbackUri).query?"&":"?"}${ge}=true`}:W.assets.download,Ee=W.queryContext?.[n]?{[n]:W.queryContext[n]}:void 0,Pe=await this.F(W.identifier.id,pe,o.VSIX,Ee?{headers:Ee}:void 0);try{await this.u.writeFile(G,Pe.stream)}catch(be){try{await this.u.del(G)}catch(we){this.n.warn(`Error while deleting the file ${G.toString()}`,(0,C.$9)(we))}throw new $.$mp((0,C.$9)(be),$.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...ie,duration:new Date().getTime()-ce})}async downloadSignatureArchive(W,G){if(!W.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",W.identifier.id);const J=await this.F(W.identifier.id,W.assets.signature,o.Signature);try{await this.u.writeFile(G,J.stream)}catch(ie){try{await this.u.del(G)}catch(ce){this.n.warn(`Error while deleting the file ${G.toString()}`,(0,C.$9)(ce))}throw new $.$mp((0,C.$9)(ie),$.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(W,G){if(W.assets.readme){const J=await this.F(W.identifier.id,W.assets.readme,o.Details,{},G);return await(0,w.$aq)(J)||""}return""}async getManifest(W,G){if(W.assets.manifest){const J=await this.F(W.identifier.id,W.assets.manifest,o.Manifest,{},G),ie=await(0,w.$aq)(J);return ie?JSON.parse(ie):null}return null}async E(W,G,J){const ie=M(G,o.Manifest);if(!ie)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},ge=await this.F(W,ie,o.Manifest,{headers:ce});return await(0,w.$bq)(ge)}async getCoreTranslation(W,G){const J=W.assets.coreTranslations.filter(ie=>ie[0]===G.toUpperCase())[0];if(J){const ie=await this.F(W.identifier.id,J[1],J[0]),ce=await(0,w.$aq)(ie);return ce?JSON.parse(ce):null}return null}async getChangelog(W,G){if(W.assets.changelog){const J=await this.F(W.identifier.id,W.assets.changelog,o.Changelog,{},G);return await(0,w.$aq)(J)||""}return""}async getAllCompatibleVersions(W,G,J){let ie=new S().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);W.uuid?ie=ie.withFilter(r.ExtensionId,W.uuid):ie=ie.withFilter(r.ExtensionName,W.id);const{galleryExtensions:ce}=await this.D(ie,a.CancellationToken.None);if(!ce.length)return[];const ge=ee(ce[0]);if((0,$.$ip)(ge,J))return[];const pe=[];await Promise.all(ce[0].versions.map(async be=>{try{await this.A(W.id,be,G?"any":"release",!0,ge,J)&&this.z(W,te(be))&&pe.push(be)}catch{}}));const Ee=[],Pe=new Set;for(const be of Q(pe,J))Pe.has(be.version)||(Pe.add(be.version),Ee.push({version:be.version,date:be.lastUpdated,isPreReleaseVersion:x(be)}));return Ee}async F(W,G,J,ie={},ce=a.CancellationToken.None){const ge=await this.j,pe={type:"GET"},Ee={...ge,...ie.headers||{}};ie={...ie,...pe,headers:Ee};const Pe=G.uri,be=G.fallbackUri,we={...ie,url:Pe};try{const Se=await this.l.request(we,ce);if(Se.res.statusCode===200)return Se;const re=await(0,w.$aq)(Se);throw new Error(`Expected 200, got back ${Se.res.statusCode} instead.

${re}`)}catch(Se){if((0,C.$3)(Se))throw Se;const re=(0,C.$9)(Se);this.q.publicLog2("galleryService:cdnFallback",{extension:W,assetType:J,message:re});const de={...ie,url:be};return this.l.request(de,ce)}}async G(W,G){let J=V(G);if(!J){this.q.publicLog2("galleryService:engineFallback",{extension:W,version:G.version});const ie=await this.E(W,G,a.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");J=ie.engines.vscode}return J}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const W=await this.l.request({type:"GET",url:this.h},a.CancellationToken.None);if(W.res.statusCode!==200)throw new Error("Could not get extensions report.");const G=await(0,w.$bq)(W),J=[],ie={},ce=[],ge=[];if(G){for(const pe of G.malicious)J.push({id:pe});if(G.migrateToPreRelease)for(const[pe,Ee]of Object.entries(G.migrateToPreRelease))(!Ee.engine||(0,l.$6p)(Ee.engine,this.w.version,this.w.date))&&(ie[pe.toLowerCase()]={disallowInstall:!0,extension:{id:Ee.id,displayName:Ee.displayName,autoMigrate:{storage:!!Ee.migrateStorage},preRelease:!0}});if(G.deprecated)for(const[pe,Ee]of Object.entries(G.deprecated))Ee&&(ie[pe.toLowerCase()]=(0,k.$kg)(Ee)?{}:Ee);if(G.search)for(const pe of G.search)ce.push(pe);if(Array.isArray(G.extensionsEnabledWithPreRelease))for(const pe of G.extensionsEnabledWithPreRelease)ge.push(pe.toLowerCase())}return{malicious:J,deprecated:ie,search:ce,extensionsEnabledWithPreRelease:ge}}};D=ve([Z(1,w.$8p),Z(2,E.$ak),Z(3,I.$Mi),Z(4,c.$_l),Z(5,m.$al),Z(6,f.$tk),Z(7,b.$_i)],D);let Y=class extends D{constructor(W,G,J,ie,ce,ge,pe,Ee){super(W,G,J,ie,ce,ge,pe,Ee)}};e.$rq=Y,e.$rq=Y=ve([Z(0,p.$iq),Z(1,w.$8p),Z(2,E.$ak),Z(3,I.$Mi),Z(4,c.$_l),Z(5,m.$al),Z(6,f.$tk),Z(7,b.$_i)],Y);let oe=class extends D{constructor(W,G,J,ie,ce,ge,pe){super(void 0,W,G,J,ie,ce,ge,pe)}};e.$sq=oe,e.$sq=oe=ve([Z(0,w.$8p),Z(1,E.$ak),Z(2,I.$Mi),Z(3,c.$_l),Z(4,m.$al),Z(5,f.$tk),Z(6,b.$_i)],oe)}),define(he[224],ue([0,1,107,3,18,15,2,10,13,68,23,5,6,101,21,11,38,16,12,143,20]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f,w,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=void 0;const c=[R.$Aic,R.$Bic],h="remoteTunnelSession",i="remoteTunnelIsService";let n=class extends T.$Uc{constructor(o,u,y,N,S,v,L){super(),this.y=o,this.z=u,this.C=y,this.D=v,this.F=L,this.f=new a.$le,this.onDidTokenFailed=this.f.event,this.g=new a.$le,this.onDidChangeTunnelStatus=this.g.event,this.h=new a.$le,this.onDidChangeMode=this.h.event,this.n=R.$yic,this.w=!1,this.I=(U,F)=>{F?this.j.error(U):this.j.info(U)},this.j=this.B(N.createLogger((0,p.$gh)(y.logsHome,`${R.$Cic}.log`),{id:R.$Cic,name:R.$Dic})),this.t=new d.$Ch(100),this.B(this.j.onDidChangeLogLevel(U=>this.j.info("Log level changed to "+(0,k.$pk)(U)))),this.B(S.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(v.onDidChangeConfiguration(U=>{c.some(F=>U.affectsConfiguration(F))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=R.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(o){this.s=o,this.g.fire(o)}H(o){s(this.n,o)||(this.n=o,this.S(o),this.h.fire(this.n),o.active?(this.j.info(`Session updated: ${o.session.accountLabel} (${o.session.providerId}) (service=${o.asService})`),o.session.token&&this.j.info(`Session token updated: ${o.session.accountLabel} (${o.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(o){if(this.w)return this.s;this.w=!0,this.H(o);try{await this.t.trigger(()=>this.L())}catch(u){this.j.error(u)}return this.s}J(){if(!this.u){let o;$.$k?o=this.C.appRoot:o=(0,O.$mc)((0,O.$mc)(this.C.appRoot)),this.u=(0,O.$jc)(o,"bin",`${this.z.tunnelApplicationName}${$.$j?".exe":""}`)}return this.u}async startTunnel(o){if(s(this.n,o)&&this.s.type!=="disconnected")return this.s;this.H(o);try{await this.t.trigger(()=>this.L())}catch(u){this.j.error(u)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const o=this.n.asService;this.H(R.$yic);try{o&&this.O("uninstallService",["service","uninstall"])}catch(u){this.j.error(u)}}try{await this.O("stop",["kill"])}catch(o){this.j.error(o)}this.G(R.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let o="",u=!1;const y=(F,M)=>{M?this.j.error(F):o+=F,!this.C.isBuilt&&F.startsWith("   Compiling")&&this.G(R.TunnelStates.connecting((0,m.localize)(11233,null)))},N=this.O("status",["status"],y);this.r=N;try{if(await N,this.r!==N)return;let F;try{F=JSON.parse(o.trim().split(`
`).find(M=>M.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(o.trim())}`),this.G(R.TunnelStates.disconnected());return}if(u=F.service_installed,this.j.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this.n.active){this.G(R.TunnelStates.disconnected());return}}catch(F){this.j.error(F),this.G(R.TunnelStates.disconnected());return}finally{this.r===N&&(this.r=void 0)}const S=this.n.active?this.n.session:void 0;if(S&&S.token){const F=S.token;this.G(R.TunnelStates.connecting((0,m.localize)(11234,null,S.accountLabel,S.providerId)));const M=(V,x)=>{V=V.replaceAll(F,"*".repeat(4)),y(V,x)},K=this.O("login",["user","login","--provider",S.providerId,"--log",(0,k.$pk)(this.j.getLevel())],M,{VSCODE_CLI_ACCESS_TOKEN:F});this.r=K;try{if(await K,this.r!==K)return}catch(V){this.j.error(V),this.r=void 0,this.f.fire(S),this.G(R.TunnelStates.disconnected(S));return}}const v=this.Q();v?this.G(R.TunnelStates.connecting((0,m.localize)(11235,null,v))):this.G(R.TunnelStates.connecting((0,m.localize)(11236,null)));const L=["--accept-server-license-terms","--log",(0,k.$pk)(this.j.getLevel())];v?L.push("--name",v):L.push("--random-name");let U=!1;return this.n.active&&this.n.asService&&!u&&(U=await this.M(L)===!1),this.N(S,L,U)}async M(o){let u;try{u=await this.O("serviceInstall",["service","install",...o])}catch(y){this.j.error(y),u=1}if(u!==0){const y=(0,m.localize)(11237,null);return this.j.warn(y),this.G(R.TunnelStates.connecting(y)),!1}return!0}async N(o,u,y){u.push("--parent-process-id",String(process.pid)),this.P()&&u.push("--no-sleep");let N=!1;const S=this.O("tunnel",u,(v,L)=>{L?this.j.error(v):this.j.info(v),v.includes("Connected to an existing tunnel process")&&(N=!0);const U=v.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(U){const F={link:U[1],domain:U[2],tunnelName:U[4],isAttached:N};this.G(R.TunnelStates.connected(F,y))}else v.match(/error refreshing token/)&&(S.cancel(),this.f.fire(o),this.G(R.TunnelStates.disconnected(o)))});this.r=S,S.finally(()=>{S===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=R.$yic,this.G(R.TunnelStates.disconnected()))})}O(o,u,y=this.I,N){return(0,d.$sh)(S=>new Promise((v,L)=>{S.isCancellationRequested&&v(-1);let U;const F=["ignore","pipe","pipe"];if(S.onCancellationRequested(()=>{U&&(this.j.info(`${o} terminating(${U.pid})`),U.kill())}),!this.C.isBuilt)y(`Building tunnel CLI from sources and run
`,!1),y(`${o} Spawning: cargo run -- tunnel ${u.join(" ")}
`,!1),U=(0,b.spawn)("cargo",["run","--","tunnel",...u],{cwd:(0,O.$jc)(this.C.appRoot,"cli"),stdio:F,env:{...process.env,RUST_BACKTRACE:"1",...N}});else{y(`Running tunnel CLI
`,!1);const M=this.J();y(`${o} Spawning: ${M} tunnel ${u.join(" ")}
`,!1),U=(0,b.spawn)(M,["tunnel",...u],{cwd:(0,E.homedir)(),stdio:F,env:{...process.env,...N}})}U.stdout.pipe(new P.$QX(`
`)).on("data",M=>{if(U){const K=M.toString();y(K,!1)}}),U.stderr.pipe(new P.$QX(`
`)).on("data",M=>{if(U){const K=M.toString();y(K,!0)}}),U.on("exit",M=>{U&&(y(`${o} exit(${U.pid}): + ${M} `,!1),U=void 0,v(M||0))}),U.on("error",M=>{U&&(y(`${o} error(${U.pid}): + ${M} `,!0),U=void 0,L())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(R.$Bic)}Q(){let o=this.D.getValue(R.$Aic)||(0,E.hostname)();return o=o.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),o||void 0}R(){try{const o=this.F.get(h,f.StorageScope.APPLICATION),u=this.F.getBoolean(i,f.StorageScope.APPLICATION,!1);if(o){const y=JSON.parse(o);if(y&&(0,w.$eg)(y.accountLabel)&&(0,w.$eg)(y.sessionId)&&(0,w.$eg)(y.providerId))return{active:!0,session:y,asService:u};this.j.error("Problems restoring session from storage, invalid format",y)}}catch(o){this.j.error("Problems restoring session from storage",o)}return R.$yic}S(o){if(o.active){const u={providerId:o.session.providerId,sessionId:o.session.sessionId,accountLabel:o.session.accountLabel};this.F.store(h,JSON.stringify(u),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),this.F.store(i,o.asService,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}else this.F.remove(h,f.StorageScope.APPLICATION),this.F.remove(i,f.StorageScope.APPLICATION)}};e.$Hic=n,e.$Hic=n=ve([Z(0,C.$_l),Z(1,I.$tk),Z(2,A.$Ni),Z(3,k.$bk),Z(4,g.$Fic),Z(5,l.$_i),Z(6,f.$iq)],n);function t(r,o){return r&&o?r.sessionId===o.sessionId&&r.providerId===o.providerId&&r.token===o.token:r===o}const s=(r,o)=>r.active!==o.active?!1:r.active&&o.active?r.asService===o.asService&&t(r.session,o.session):!0}),define(he[225],ue([0,1,6,2,22,20,70,16,79,19]),function(ae,e,R,a,C,A,T,k,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mic=void 0;class I extends k.$kq{constructor(d,g,l,m){super(),this.bb=d,this.cb=g,this.db=l,this.eb=m,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new a.$Tc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new a.$Tc),this.ab=this.hb(this.bb)}fb(){const d=this.B(new O.$$Mb(this.db.getChannel("storage"))),g=this.B(new T.$eq(d));return this.B(g.onDidChangeStorage(l=>this.u(k.StorageScope.APPLICATION,l))),g}gb(d){this.X.clear(),this.W=d;let g;if((0,k.$lq)(d))g=this.U;else{const l=this.X.add(new O.$_Mb(this.db.getChannel("storage"),d));g=this.X.add(new T.$eq(l))}return this.X.add(g.onDidChangeStorage(l=>this.u(k.StorageScope.PROFILE,l))),g}hb(d){this.$.clear(),this.Z=d?.id;let g;if(d){const l=this.$.add(new O.$aNb(this.db.getChannel("storage"),d));g=this.$.add(new T.$eq(l)),this.$.add(g.onDidChangeStorage(m=>this.u(k.StorageScope.WORKSPACE,m)))}return g}async O(){await R.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(d){switch(d){case k.StorageScope.APPLICATION:return this.U;case k.StorageScope.PROFILE:return this.Y;default:return this.ab}}Q(d){switch(d){case k.StorageScope.APPLICATION:return this.s.globalStorageHome.with({scheme:C.Schemas.file}).fsPath;case k.StorageScope.PROFILE:return this.W?.globalStorageHome.with({scheme:C.Schemas.file}).fsPath;default:return this.Z?`${(0,A.$gh)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:C.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(k.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(d){if(!this.M(this.W,d))return;const g=this.Y,l=g.items;g!==this.U&&await g.close(),this.Y=this.gb(d),await this.Y.init(),this.N(l,this.Y,k.StorageScope.PROFILE)}async S(d,g){const l=this.ab,m=l?.items??new Map;await l?.close(),this.ab=this.hb(d),await this.ab.init(),this.N(m,this.ab,k.StorageScope.WORKSPACE)}hasScope(d){return(0,b.$Ll)(d)?this.W.id===d.id:this.Z===d.id}}e.$Mic=I}),define(he[226],ue([0,1,3,2,19,94]),function(ae,e,R,a,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RR=e.$QR=void 0;class T{constructor(b,I){this.a=b,this.b=I}listen(b,I){const $=this.b(b);switch(I){case"onDidChangeProfiles":return R.Event.map(this.a.onDidChangeProfiles,d=>({all:d.all.map(g=>(0,A.$On)({...g},$)),added:d.added.map(g=>(0,A.$On)({...g},$)),removed:d.removed.map(g=>(0,A.$On)({...g},$)),updated:d.updated.map(g=>(0,A.$On)({...g},$))}))}throw new Error(`Invalid listen ${I}`)}async call(b,I,$){const d=this.b(b);switch(I){case"createProfile":{const g=await this.a.createProfile($[0],$[1],$[2]);return(0,A.$On)({...g},d)}case"updateProfile":{let g=(0,C.$Nl)((0,A.$Pn)($[0],d),this.a.profilesHome.scheme);return g=await this.a.updateProfile(g,$[1]),(0,A.$On)({...g},d)}case"removeProfile":{const g=(0,C.$Nl)((0,A.$Pn)($[0],d),this.a.profilesHome.scheme);return this.a.removeProfile(g)}}throw new Error(`Invalid call ${I}`)}}e.$QR=T;class k extends a.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(b,I,$){super(),this.profilesHome=I,this.f=$,this.a=[],this.b=this.B(new R.$le),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=b.map(d=>(0,C.$Nl)(d,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(d=>{const g=d.added.map(E=>(0,C.$Nl)(E,this.profilesHome.scheme)),l=d.removed.map(E=>(0,C.$Nl)(E,this.profilesHome.scheme)),m=d.updated.map(E=>(0,C.$Nl)(E,this.profilesHome.scheme));this.a=d.all.map(E=>(0,C.$Nl)(E,this.profilesHome.scheme)),this.b.fire({added:g,removed:l,updated:m,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(b){this.c=b}isEnabled(){return this.c}async createNamedProfile(b,I,$){const d=await this.f.call("createNamedProfile",[b,I,$]);return(0,C.$Nl)(d,this.profilesHome.scheme)}async createProfile(b,I,$,d){const g=await this.f.call("createProfile",[b,I,$,d]);return(0,C.$Nl)(g,this.profilesHome.scheme)}async createTransientProfile(b){const I=await this.f.call("createTransientProfile",[b]);return(0,C.$Nl)(I,this.profilesHome.scheme)}async setProfileForWorkspace(b,I){await this.f.call("setProfileForWorkspace",[b,I])}removeProfile(b){return this.f.call("removeProfile",[b])}async updateProfile(b,I){const $=await this.f.call("updateProfile",[b,I]);return(0,C.$Nl)($,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$RR=k}),define(he[62],ue([0,1,2,70,4,16,3,79,19]),function(ae,e,R,a,C,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eNb=e.$dNb=e.$cNb=void 0,e.$cNb=(0,C.$Fi)("IUserDataProfileStorageService");let b=class extends R.$Uc{constructor(g,l){super(),this.b=l,g&&(this.a=this.B(new R.$4c))}async readStorageData(g){return this.withProfileScopedStorageService(g,async l=>this.c(l))}async updateStorageData(g,l,m){return this.withProfileScopedStorageService(g,async E=>this.f(E,l,m))}async withProfileScopedStorageService(g,l){if(this.b.hasScope(g))return l(this.b);let m=this.a?.get(g.id);if(!m){m=new $(this.g(g)),this.a?.set(g.id,m);try{await m.initialize()}catch(E){throw this.a?.has(g.id)?this.a.deleteAndDispose(g.id):m.dispose(),E}}try{const E=await l(m);return await m.flush(),E}finally{this.a?.has(g.id)||m.dispose()}}c(g){const l=new Map,m=E=>{for(const f of g.keys(A.StorageScope.PROFILE,E))l.set(f,{value:g.get(f,A.StorageScope.PROFILE),target:E})};return m(A.StorageTarget.USER),m(A.StorageTarget.MACHINE),l}f(g,l,m){g.storeAll(Array.from(l.entries()).map(([E,f])=>({key:E,value:f,scope:A.StorageScope.PROFILE,target:m})),!0)}};e.$dNb=b,e.$dNb=b=ve([Z(1,A.$iq)],b);class I extends b{constructor(g,l,m,E,f){super(g,E),this.j=l;const w=l.getChannel("profileStorageListener"),P=this.B(new R.$Vc);this.h=this.B(new T.$le({onWillAddFirstListener:()=>{P.value=w.listen("onDidChange")(p=>{f.trace("profile storage changes",p),this.h.fire({targetChanges:p.targetChanges.map(c=>(0,O.$Nl)(c,m.profilesHome.scheme)),valueChanges:p.valueChanges.map(c=>({...c,profile:(0,O.$Nl)(c.profile,m.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>P.value=void 0})),this.onDidChange=this.h.event}async g(g){const l=this.j.getChannel("storage");return(0,A.$lq)(g)?new k.$$Mb(l):new k.$_Mb(l,g)}}e.$eNb=I;class $ extends A.$kq{constructor(g){super({flushInterval:100}),this.U=g}async O(){const g=await this.U,l=new a.$eq(g);return this.B(l.onDidChangeStorage(m=>{this.u(A.StorageScope.PROFILE,m)})),this.B((0,R.$Sc)(()=>{l.close(),l.dispose(),(0,R.$Oc)(g)&&g.dispose()})),this.s=l,this.s.init()}P(g){return g===A.StorageScope.PROFILE?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(he[227],ue([0,1,16,10,19,56,62]),function(ae,e,R,a,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ric=void 0;let k=class extends T.$eNb{constructor(b,I,$,d){super(!0,b,I,$,d)}};e.$ric=k,e.$ric=k=ve([Z(0,A.$Yhc),Z(1,C.$Ml),Z(2,R.$iq),Z(3,a.$ak)],k)}),define(he[40],ue([0,1,17,6,14,25,3,36,2,26,12,11,21,15,7,10,49,16,18,28,24,19]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f,w,P,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lOb=e.$kOb=e.$jOb=e.$iOb=void 0,e.$fOb=h,e.$gOb=i,e.$hOb=n;function h(u){return!!(u&&u.ref!==void 0&&typeof u.ref=="string"&&u.ref!==""&&u.syncData!==void 0&&(u.syncData===null||i(u.syncData)))}function i(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}function n(u,y){return`${(0,b.$9f)(u)}${y.isDefault?"":` (${y.name})`}`}let t=class extends O.$Uc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(y,N,S,v,L,U,F,M,K,V,x,H){super(),this.syncResource=y,this.collection=N,this.G=S,this.H=v,this.I=L,this.J=U,this.L=F,this.M=M,this.N=K,this.O=V,this.P=x,this.c=null,this.m=p.SyncStatus.Idle,this.n=this.B(new T.$le),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new T.$le),this.onDidChangeConflicts=this.t.event,this.u=this.B(new a.$Dh(50)),this.w=this.B(new T.$le),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(y.syncResource,y.profile),this.h=H.extUri,this.f=this.h.joinPath(v.userDataSyncHome,...(0,p.$Onb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource)),this.g=this.h.joinPath(this.f,p.$0nb),this.y=(0,p.$Pnb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource,v,this.h),this.j=(0,E.$oq)(v,S,L)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status===p.SyncStatus.HasConflicts){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const y=await this.c;this.c=null;const N=await this.Y(y.remoteUserData,y.lastSyncUserData,!0,this.ob());this.S(N)}else{this.O.trace(`${this.D}: Checking for local changes...`);const y=await this.getLastSyncUserData();(y?await this.ub(y):!0)&&this.w.fire()}}S(y){this.m!==y&&(this.m=y,this.n.fire(y))}async sync(y,N={}){await this.U(y,!0,this.ob(),N)}async preview(y,N,S={}){return this.U(y,!1,N,S)}async apply(y,N={}){try{this.F={...N};const S=await this.ab(y);return this.S(S),this.c}finally{this.F={}}}async U(y,N,S,v){try{if(this.F={...v},this.status===p.SyncStatus.HasConflicts)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status===p.SyncStatus.Syncing)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S(p.SyncStatus.Syncing);let L=p.SyncStatus.Idle;try{const U=await this.getLastSyncUserData(),F=await this.X(y,U);return L=await this.Y(F,U,N,S),L===p.SyncStatus.HasConflicts?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):L===p.SyncStatus.Idle&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(L)}}finally{this.F={}}}async replace(y){const N=this.kb(y);if(!N)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S(p.SyncStatus.Syncing);const S=await this.getLastSyncUserData(),v=await this.X(null,S),L=await this.W(v),U=await this.qb({ref:v.ref,syncData:N},S,L,this.ob(),A.CancellationToken.None),F=[];for(const M of U){const K=await this.sb(M,M.remoteResource,void 0,A.CancellationToken.None),{remoteChange:V}=await this.sb(M,M.previewResource,M.remoteContent,A.CancellationToken.None);F.push([M,{...K,remoteChange:V!==p.Change.None?V:p.Change.Modified}])}await this.tb(v,S,F,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S(p.SyncStatus.Idle)}return!0}async W(y){const N=await this.j;return!!y.syncData?.machineId&&y.syncData.machineId===N}async X(y,N){if(N){const S=y?y[this.resource]:void 0;if(N.ref===S||S===void 0&&N.syncData===null)return N}return this.getRemoteUserData(N)}async Y(y,N,S,v){if(y.syncData&&y.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new p.$Wnb((0,$.localize)(11075,null,this.resource,this.pb,y.syncData.version),p.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.Z(y,N,S,v)}catch(L){if(L instanceof p.$Wnb)switch(L.code){case p.UserDataSyncErrorCode.LocalPreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(y,N,S,v);case p.UserDataSyncErrorCode.Conflict:case p.UserDataSyncErrorCode.PreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),y=await this.getRemoteUserData(null),N=await this.getLastSyncUserData(),this.Y(y,N,S,v)}throw L}}async Z(y,N,S,v){try{const L=await this.W(y),U=!L&&N===null&&this.gb()!==void 0,F=S&&!U;this.c||(this.c=(0,a.$sh)(K=>this.eb(y,N,L,F,v,K)));let M=await this.c;if(S&&U){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const K of M.resourcePreviews)M=await this.accept(K.remoteResource)||M}return this.cb(M.resourcePreviews),M.resourcePreviews.some(({mergeState:K})=>K===p.MergeState.Conflict)?p.SyncStatus.HasConflicts:S?await this.ab(!1):p.SyncStatus.Syncing}catch(L){throw this.c=null,L}}async merge(y){return await this.$(y,async N=>{const S=await this.rb(N,A.CancellationToken.None);await this.G.writeFile(N.previewResource,C.$Ne.fromString(S?.content||""));const v=S&&!S.hasConflicts?await this.sb(N,N.previewResource,void 0,A.CancellationToken.None):void 0;return N.acceptResult=v,N.mergeState=S.hasConflicts?p.MergeState.Conflict:v?p.MergeState.Accepted:p.MergeState.Preview,N.localChange=v?v.localChange:S.localChange,N.remoteChange=v?v.remoteChange:S.remoteChange,N}),this.c}async accept(y,N){return await this.$(y,async S=>{const v=await this.sb(S,y,N,A.CancellationToken.None);return S.acceptResult=v,S.mergeState=p.MergeState.Accepted,S.localChange=v.localChange,S.remoteChange=v.remoteChange,S}),this.c}async discard(y){return await this.$(y,async N=>{const S=await this.rb(N,A.CancellationToken.None);return await this.G.writeFile(N.previewResource,C.$Ne.fromString(S.content||"")),N.acceptResult=void 0,N.mergeState=p.MergeState.Preview,N.localChange=S.localChange,N.remoteChange=S.remoteChange,N}),this.c}async $(y,N){if(!this.c)return;let S=await this.c;const v=S.resourcePreviews.findIndex(({localResource:L,remoteResource:U,previewResource:F})=>this.h.isEqual(L,y)||this.h.isEqual(U,y)||this.h.isEqual(F,y));v!==-1&&(this.c=(0,a.$sh)(async L=>{const U=[...S.resourcePreviews];return U[v]=await N(U[v]),{...S,resourcePreviews:U}}),S=await this.c,this.cb(S.resourcePreviews),S.resourcePreviews.some(({mergeState:L})=>L===p.MergeState.Conflict)?this.S(p.SyncStatus.HasConflicts):this.S(p.SyncStatus.Syncing))}async ab(y){if(!this.c)return p.SyncStatus.Idle;const N=await this.c;return N.resourcePreviews.some(({mergeState:S})=>S===p.MergeState.Conflict)?p.SyncStatus.HasConflicts:N.resourcePreviews.some(({mergeState:S})=>S!==p.MergeState.Accepted)?p.SyncStatus.Syncing:(await this.tb(N.remoteUserData,N.lastSyncUserData,N.resourcePreviews.map(S=>[S,S.acceptResult]),y),this.c=null,await this.bb(),p.SyncStatus.Idle)}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(y){const N=y.filter(({mergeState:S})=>S===p.MergeState.Conflict);(0,R.$tb)(this.s,N,(S,v)=>this.h.isEqual(S.previewResource,v.previewResource))||(this.s=N,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const y=await this.getLastSyncUserData();return!!y&&y.syncData!==null}async db(y){const N=this.c?await this.c:null;if(N)for(const S of N.resourcePreviews){if(this.h.isEqual(S.acceptedResource,y))return S.acceptResult?S.acceptResult.content:null;if(this.h.isEqual(S.remoteResource,y))return S.remoteContent;if(this.h.isEqual(S.localResource,y))return S.localContent;if(this.h.isEqual(S.baseResource,y))return S.baseContent}return null}async resetLocal(){this.I.remove(this.z,f.StorageScope.APPLICATION);try{await this.G.del(this.y)}catch(y){(0,l.$rl)(y)!==l.FileOperationResult.FILE_NOT_FOUND&&this.O.error(y)}}async eb(y,N,S,v,L,U){const F=await this.qb(y,N,S,L,U),M=[];for(const K of F){const V=K.previewResource.with({scheme:p.$9nb,authority:"accepted"});if(K.localChange===p.Change.None&&K.remoteChange===p.Change.None)M.push({...K,acceptedResource:V,acceptResult:{content:null,localChange:p.Change.None,remoteChange:p.Change.None},mergeState:p.MergeState.Accepted});else{const x=v?await this.rb(K,U):void 0;if(U.isCancellationRequested)break;await this.G.writeFile(K.previewResource,C.$Ne.fromString(x?.content||""));const H=x&&!x.hasConflicts?await this.sb(K,K.previewResource,void 0,U):void 0;M.push({...K,acceptResult:H,mergeState:x?.hasConflicts?p.MergeState.Conflict:H?p.MergeState.Accepted:p.MergeState.Preview,localChange:H?H.localChange:x?x.localChange:K.localChange,remoteChange:H?H.remoteChange:x?x.remoteChange:K.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:y,lastSyncUserData:N,resourcePreviews:M,isLastSyncFromCurrentMachine:S}}async getLastSyncUserData(){let y=this.gb();if(y||(y=await this.jb()),!y)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const N=JSON.parse(y),S=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!N.version&&!!S&&N.version!==S,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${N.version} is not compatible with current sync state version ${S}.`),await this.resetLocal(),null;let v,L=1;for(;v===void 0&&L++<6;)try{const U=await this.hb();U&&(U.ref===N.ref?v=U.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(U){if(U instanceof l.$vl&&U.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(U instanceof p.$Wnb)throw U;this.O.error(U,L)}}if(v===void 0)try{const U=await this.J.resolveResourceContent(this.resource,N.ref,this.collection,this.F);v=U===null?null:this.kb(U),await this.ib({ref:N.ref,syncData:v})}catch(U){if(U instanceof p.$Wnb&&U.code===p.UserDataSyncErrorCode.NotFound)this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw U}return v===void 0?null:{...N,syncData:v}}async fb(y,N={}){if(N.ref||N.version)throw new Error("Cannot have core properties as additional");const S=this.M.getResourceSyncStateVersion(this.resource),v={ref:y.ref,version:S,...N};this.I.store(this.z,JSON.stringify(v),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.ib(y)}gb(){return this.I.get(this.z,f.StorageScope.APPLICATION)}async hb(){const y=(await this.G.readFile(this.y)).value.toString();try{const N=y?JSON.parse(y):void 0;if(h(N))return N}catch(N){this.O.error(N)}}async ib(y){await this.G.writeFile(this.y,C.$Ne.fromString(JSON.stringify(y)))}async jb(){try{const y=await this.G.readFile(this.y),N=JSON.parse(y.value.toString());await this.G.del(this.y),N.ref&&N.content!==void 0?(this.I.store(this.z,JSON.stringify({...N,content:void 0}),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.ib({ref:N.ref,syncData:N.content===null?null:JSON.parse(N.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,N)}catch(y){y instanceof l.$vl&&y.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(y)}return this.I.get(this.z,f.StorageScope.APPLICATION)}async getRemoteUserData(y){const{ref:N,content:S}=await this.lb(y);let v=null;return S!==null&&(v=this.kb(S)),{ref:N,syncData:v}}kb(y){try{const N=JSON.parse(y);if(i(N))return N}catch(N){this.O.error(N)}throw new p.$Wnb((0,$.localize)(11076,null),p.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async lb(y){const N=y?{ref:y.ref,content:y.syncData?JSON.stringify(y.syncData):null}:null;return this.J.readResource(this.resource,N,this.collection,this.F)}async mb(y,N){const S=await this.j,v={version:this.pb,machineId:S,content:y};try{return N=await this.J.writeResource(this.resource,JSON.stringify(v),N,this.collection,this.F),{ref:N,syncData:v}}catch(L){throw L instanceof p.$Wnb&&L.code===p.UserDataSyncErrorCode.TooLarge&&(L=new p.$Wnb(L.message,L.code,this.resource)),L}}async nb(y){const N={version:this.pb,content:y};return this.L.writeResource(this.resource,JSON.stringify(N),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!==p.SyncStatus.Idle&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S(p.SyncStatus.Idle),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(p.$Jnb)}};e.$iOb=t,e.$iOb=t=ve([Z(2,l.$al),Z(3,g.$Mi),Z(4,f.$iq),Z(5,p.$Rnb),Z(6,p.$Snb),Z(7,p.$2nb),Z(8,w.$_l),Z(9,p.$7nb),Z(10,d.$_i),Z(11,P.$Kl)],t);let s=class extends t{constructor(y,N,S,v,L,U,F,M,K,V,x,H,te){super(N,S,v,L,U,F,M,K,V,x,H,te),this.r=y,this.B(this.G.watch(this.h.dirname(y))),this.B(this.G.onDidFilesChange(B=>this.yb(B)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(y,N,S){try{N?await this.G.writeFile(this.r,C.$Ne.fromString(y),S?void 0:N):await this.G.createFile(this.r,C.$Ne.fromString(y),{overwrite:S})}catch(v){throw v instanceof l.$vl&&v.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND||v instanceof l.$vl&&v.fileOperationResult===l.FileOperationResult.FILE_MODIFIED_SINCE?new p.$Wnb(v.message,p.UserDataSyncErrorCode.LocalPreconditionFailed):v}}async xb(){try{await this.G.del(this.r)}catch(y){if(!(y instanceof l.$vl&&y.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND))throw y}}yb(y){y.contains(this.r)&&this.Q()}};e.$jOb=s,e.$jOb=s=ve([Z(3,l.$al),Z(4,g.$Mi),Z(5,f.$iq),Z(6,p.$Rnb),Z(7,p.$Snb),Z(8,p.$2nb),Z(9,w.$_l),Z(10,p.$7nb),Z(11,d.$_i),Z(12,P.$Kl)],s);let r=class extends s{constructor(y,N,S,v,L,U,F,M,K,V,x,H,te,B){super(y,N,S,v,L,U,F,M,K,V,x,te,B),this.zb=H,this.Bb=void 0}Ab(y,N){const S=[],v=(0,k.$Yn)(y,S,{allowEmptyContent:!0,allowTrailingComma:!0});return S.length>0||!(0,I.$lg)(v)&&N!==Array.isArray(v)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$kOb=r,e.$kOb=r=ve([Z(3,l.$al),Z(4,g.$Mi),Z(5,f.$iq),Z(6,p.$Rnb),Z(7,p.$Snb),Z(8,p.$2nb),Z(9,w.$_l),Z(10,p.$7nb),Z(11,p.$6nb),Z(12,d.$_i),Z(13,P.$Kl)],r);let o=class{constructor(y,N,S,v,L,U,F){this.resource=y,this.g=N,this.h=S,this.j=v,this.k=L,this.l=U,this.d=F.extUri,this.f=(0,p.$Pnb)(void 0,this.resource,S,this.d)}async initialize({ref:y,content:N}){if(!N){this.j.info("Remote content does not exist.",this.resource);return}const S=this.m(N);if(S)try{await this.o({ref:y,syncData:S})}catch(v){this.j.error(v)}}m(y){try{const N=JSON.parse(y);if(i(N))return N}catch(N){this.j.error(N)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(y,N={}){if(N.ref||N.version)throw new Error("Cannot have core properties as additional");const S={ref:y.ref,version:void 0,...N};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(S),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.k.writeFile(this.f,C.$Ne.fromString(JSON.stringify(y)))}};e.$lOb=o,e.$lOb=o=ve([Z(1,c.$Ml),Z(2,g.$Mi),Z(3,m.$ak),Z(4,l.$al),Z(5,f.$iq),Z(6,P.$Kl)],o)}),define(he[119],ue([0,1,6,25,8,3,45,2,26,21,15,118,27,35,85,34,7,4,76,10,16,18,28,19,40,206,114,24,62]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f,w,P,p,c,h,i,n,t,s,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=e.$4cc=e.$3cc=void 0,e.$1cc=y,e.$2cc=N;async function u(U,F){const M=JSON.parse(U.content);if(U.version===1||U.version===2){const K=(await F.getInstalled(m.ExtensionType.System)).filter(V=>V.isBuiltin);for(const V of M)U.version===1&&(V.enabled===!1&&(V.disabled=!0),delete V.enabled),U.version===2&&K.every(x=>!(0,g.$Mp)(x.identifier,V.identifier))&&(V.installed=!0)}return M}function y(U){return JSON.parse(U.content)}function N(U,F){return U.sort((M,K)=>!M.identifier.uuid&&K.identifier.uuid?-1:M.identifier.uuid&&!K.identifier.uuid?1:(0,O.$yf)(M.identifier.id,K.identifier.id)),F?(0,T.$9n)(U,{}):JSON.stringify(U)}let S=class extends n.$iOb{constructor(F,M,K,V,x,H,te,B,z,_,ne,le,ee,Q,X,q,D){super({syncResource:r.SyncResource.Extensions,profile:F},M,V,K,x,H,te,le,ee,_,ne,X),this.Cb=B,this.Db=z,this.Eb=D,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$9nb,authority:"base"}),this.yb=this.wb.with({scheme:r.$9nb,authority:"local"}),this.zb=this.wb.with({scheme:r.$9nb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$9nb,authority:"accepted"}),this.Bb=this.Eb.createInstance(v),this.B(A.Event.any(A.Event.filter(this.Cb.onDidInstallExtensions,Y=>Y.some(({local:oe})=>!!oe)),A.Event.filter(this.Cb.onDidUninstallExtension,Y=>!Y.error),A.Event.filter(q.onDidChange,Y=>Y.valueChanges.some(({profile:oe,changes:j})=>this.syncResource.profile.id===oe.id&&j.some(W=>W.key===d.$pp))),Q.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(F,M){const K=F.syncData?await u(F.syncData,this.Cb):null,V=M?.skippedExtensions??[],x=M?.builtinExtensions??null,H=M?.syncData?await u(M.syncData,this.Cb):null,{localExtensions:te,ignoredExtensions:B}=await this.Bb.getLocalExtensions(this.syncResource.profile);K?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:_}=(0,t.$Zcc)(te,K,H,V,B,x),ne={local:z,remote:_,content:this.Hb(te,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:_!==null?r.Change.Modified:r.Change.None},le=this.Ob(te,!1);return[{skippedExtensions:V,builtinExtensions:x,baseResource:this.xb,baseContent:H?this.Ob(H,!1):le,localResource:this.yb,localContent:le,localExtensions:te,remoteResource:this.zb,remoteExtensions:K,remoteContent:K?this.Ob(K,!1):null,previewResource:this.wb,previewResult:ne,localChange:ne.localChange,remoteChange:ne.remoteChange,acceptedResource:this.Ab}]}async ub(F){const M=F.syncData?await u(F.syncData,this.Cb):null,{localExtensions:K,ignoredExtensions:V}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,t.$Zcc)(K,M,M,F.skippedExtensions||[],V,F.builtinExtensions||[]);return x!==null}Hb(F,M,K,V){const x=[...M,...K],H=new Set,te=B=>{H.add(B.id.toLowerCase()),B.uuid&&H.add(B.uuid)};x.forEach(({identifier:B})=>te(B)),V.forEach(te);for(const B of F)H.has(B.identifier.id.toLowerCase())||B.identifier.uuid&&H.has(B.identifier.uuid)||x.push(B);return this.Ob(x,!1)}async rb(F,M){return{...F.previewResult,hasConflicts:!1}}async sb(F,M,K,V){if(this.h.isEqual(M,this.yb))return this.Kb(F);if(this.h.isEqual(M,this.zb))return this.Lb(F);if(this.h.isEqual(M,this.wb))return F.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async Kb(F){const M=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),K=this.Db.getIgnoredExtensions(M),V=(0,t.$Zcc)(F.localExtensions,null,null,F.skippedExtensions,K,F.builtinExtensions),{local:x,remote:H}=V;return{content:F.localContent,local:x,remote:H,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:H!==null?r.Change.Modified:r.Change.None}}async Lb(F){const M=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),K=this.Db.getIgnoredExtensions(M),V=F.remoteContent?JSON.parse(F.remoteContent):null;if(V!==null){const x=(0,t.$Zcc)(F.localExtensions,V,F.localExtensions,[],K,F.builtinExtensions),{local:H,remote:te}=x;return{content:F.remoteContent,local:H,remote:te,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:te!==null?r.Change.Modified:r.Change.None}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:r.Change.None,remoteChange:r.Change.None}}async tb(F,M,K,V){let{skippedExtensions:x,builtinExtensions:H,localExtensions:te}=K[0][0];const{local:B,remote:z,localChange:_,remoteChange:ne}=K[0][1];if(_===r.Change.None&&ne===r.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),_!==r.Change.None&&(await this.nb(JSON.stringify(te)),x=await this.Bb.updateLocalExtensions(B.added,B.removed,B.updated,x,this.syncResource.profile)),z){this.O.trace(`${this.D}: Updating remote extensions...`);const le=JSON.stringify(z.all);F=await this.mb(le,V?null:F.ref),this.O.info(`${this.D}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(ee=>ee.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(ee=>ee.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(ee=>ee.identifier.id))}.`:""}`)}M?.ref!==F.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(te,H),await this.fb(F,{skippedExtensions:x,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(le=>le.identifier.id))}.`:""}`))}Nb(F,M){const K=new Set,V=[];for(const x of F)K.add(x.identifier.id.toLowerCase()),x.installed||V.push(x.identifier);if(M)for(const x of M)K.has(x.id.toLowerCase())||V.push(x);return V}async resolveContent(F){if(this.h.isEqual(this.zb,F)||this.h.isEqual(this.xb,F)||this.h.isEqual(this.yb,F)||this.h.isEqual(this.Ab,F)){const M=await this.db(F);return M&&this.Ob(JSON.parse(M),!0)}return null}Ob(F,M){return N(F,M)}async hasLocalData(){try{const{localExtensions:F}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(F.some(M=>M.installed||M.disabled))return!0}catch{}return!1}};e.$3cc=S,e.$3cc=S=ve([Z(2,I.$Mi),Z(3,E.$al),Z(4,p.$iq),Z(5,r.$Rnb),Z(6,r.$Snb),Z(7,d.$op),Z(8,s.$7Ob),Z(9,r.$7nb),Z(10,b.$_i),Z(11,r.$2nb),Z(12,c.$_l),Z(13,l.$qw),Z(14,h.$Kl),Z(15,o.$cNb),Z(16,f.$Ei)],S);let v=class{constructor(F,M,K,V,x,H){this.a=F,this.b=M,this.c=K,this.d=V,this.f=x,this.g=H}async getLocalExtensions(F){const M=await this.a.getInstalled(void 0,F.extensionsResource),K=this.d.getIgnoredExtensions(M);return{localExtensions:await this.j(F,async(x,H)=>{const te=x.getDisabledExtensions();return M.map(B=>{const{identifier:z,isBuiltin:_,manifest:ne,preRelease:le,pinned:ee,isApplicationScoped:Q}=B,X={identifier:z,preRelease:le,version:ne.version,pinned:!!ee};Q&&!(0,m.$un)(ne)&&(X.isApplicationScoped=Q),te.some(q=>(0,g.$Mp)(q,z))&&(X.disabled=!0),_||(X.installed=!0);try{const q=H.getKeysForSync({id:z.id,version:ne.version});if(q){const D=H.getExtensionState(B,!0)||{};X.state=Object.keys(D).reduce((Y,oe)=>(q.includes(oe)&&(Y[oe]=D[oe]),Y),{})}}catch(q){this.g.info(`${(0,n.$hOb)(r.SyncResource.Extensions,F)}: Error while parsing extension state`,(0,C.$9)(q))}return X})}),ignoredExtensions:K}}async updateLocalExtensions(F,M,K,V,x){const H=(0,n.$hOb)(r.SyncResource.Extensions,x),te=[],B=new Map,z=[],_=[],ne=await this.a.getInstalled(void 0,x.extensionsResource);if((F.length||K.length)&&await this.j(x,async(Q,X)=>{await R.Promises.settled([...F,...K].map(async q=>{const D=ne.find(j=>(0,g.$Mp)(j.identifier,q.identifier));if(D&&D.isBuiltin){q.state&&D.manifest.version===q.version&&this.h(q.state,D,D.manifest.version,X),Q.getDisabledExtensions().some(W=>(0,g.$Mp)(W,q.identifier))!==!!q.disabled&&(q.disabled?(this.g.trace(`${H}: Disabling extension...`,q.identifier.id),await Q.disableExtension(q.identifier),this.g.info(`${H}: Disabled extension`,q.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,q.identifier.id),await Q.enableExtension(q.identifier),this.g.info(`${H}: Enabled extension`,q.identifier.id))),z.push(q.identifier);return}const Y=q.pinned?q.version:void 0,oe=(await this.c.getExtensions([{...q.identifier,version:Y,preRelease:Y?void 0:q.preRelease}],a.CancellationToken.None))[0];if(q.state&&(D?D.manifest.version===q.version:oe)&&this.h(q.state,D||oe,D?.manifest.version,X),oe)try{Q.getDisabledExtensions().some(W=>(0,g.$Mp)(W,q.identifier))!==!!q.disabled&&(q.disabled?(this.g.trace(`${H}: Disabling extension...`,q.identifier.id,oe.version),await Q.disableExtension(oe.identifier),this.g.info(`${H}: Disabled extension`,q.identifier.id,oe.version)):(this.g.trace(`${H}: Enabling extension...`,q.identifier.id,oe.version),await Q.enableExtension(oe.identifier),this.g.info(`${H}: Enabled extension`,q.identifier.id,oe.version))),(!D||D.preRelease!==q.preRelease||D.pinned!==q.pinned||Y&&D.manifest.version!==Y)&&(await this.a.canInstall(oe)?(te.push({extension:oe,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:q.pinned&&!!q.version,pinned:q.pinned,installPreReleaseVersion:q.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:q.isApplicationScoped,context:{[d.$bp]:!0,[d.$cp]:d.ExtensionInstallSource.SETTINGS_SYNC}}}),B.set(oe.identifier.id.toLowerCase(),q)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,oe.displayName||oe.identifier.id),_.push(q)))}catch(j){_.push(q),this.g.error(j),this.g.info(`${H}: Skipped synchronizing extension`,oe.displayName||oe.identifier.id)}else _.push(q),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,q.identifier.id)}))}),M.length){const Q=ne.filter(({identifier:X,isBuiltin:q})=>!q&&M.some(D=>(0,g.$Mp)(X,D)));await R.Promises.settled(Q.map(async X=>{this.g.trace(`${H}: Uninstalling local extension...`,X.identifier.id),await this.a.uninstall(X,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,X.identifier.id),z.push(X.identifier)}))}const le=await this.a.installGalleryExtensions(te);for(const{identifier:Q,local:X,error:q,source:D}of le){const Y=D;if(X)this.g.info(`${H}: Installed extension.`,Q.id,Y.version),z.push(Q);else{const oe=B.get(Q.id.toLowerCase());oe&&(_.push(oe),this.g.info(`${H}: Skipped synchronizing extension`,Y.displayName||Y.identifier.id)),q instanceof d.$np&&[d.ExtensionManagementErrorCode.Incompatible,d.ExtensionManagementErrorCode.IncompatibleApi,d.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(q.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,Y.displayName||Y.identifier.id):q&&this.g.error(q)}}const ee=[];for(const Q of V)z.some(X=>(0,g.$Mp)(X,Q.identifier))||ee.push(Q);for(const Q of _)ee.some(X=>(0,g.$Mp)(X.identifier,Q.identifier))||ee.push(Q);return ee}h(F,M,K,V){const x=V.getExtensionState(M,!0)||{},H=K?V.getKeysForSync({id:M.identifier.id,version:K}):void 0;H?H.forEach(te=>{x[te]=F[te]}):Object.keys(F).forEach(te=>x[te]=F[te]),V.setExtensionState(M,x,!0)}async j(F,M){return this.b.withProfileScopedStorageService(F,async K=>{const V=new k.$Tc,x=V.add(this.f.createChild(new w.$Di([p.$iq,K]))),H=V.add(x.createInstance($.$AMb)),te=V.add(x.createInstance(l.$rw));try{return await M(H,te)}finally{V.dispose()}})}};e.$4cc=v,e.$4cc=v=ve([Z(0,d.$op),Z(1,o.$cNb),Z(2,d.$lp),Z(3,s.$7Ob),Z(4,f.$Ei),Z(5,r.$7nb)],v);let L=class extends n.$lOb{constructor(F,M,K,V,x,H,te,B){super(r.SyncResource.Extensions,V,x,H,K,te,B),this.p=F,this.q=M}async t(F){return F.syncData?await u(F.syncData,this.p):null}u(F,M){const K=[],V=[],x=[];for(const H of F){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const te=M.find(B=>(0,g.$Mp)(B.identifier,H.identifier));te?(K.push(te),H.disabled&&x.push(H.identifier)):H.installed&&(V.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&x.push(H.identifier))}return{installedExtensions:K,newExtensions:V,disabledExtensions:x,remoteExtensions:F}}};e.$5cc=L,e.$5cc=L=ve([Z(0,d.$op),Z(1,s.$7Ob),Z(2,E.$al),Z(3,i.$Ml),Z(4,I.$Mi),Z(5,P.$ak),Z(6,p.$iq),Z(7,h.$Kl)],L)}),define(he[120],ue([0,1,14,8,3,36,45,5,32,21,15,7,10,49,16,18,28,40,81,210,24,19,62,4]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f,w,P,p,c,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rOb=e.$qOb=e.$pOb=e.$oOb=void 0,e.$nOb=s;const n="globalState.argv.",t=["locale"];function s(S,v){const L=S.storage?Object.keys(S.storage).sort():[],U={};return L.forEach(F=>U[F]=S.storage[F]),S.storage=U,v?(0,T.$9n)(S,{}):JSON.stringify(S)}const r=1;let o=class extends f.$iOb{constructor(v,L,U,F,M,K,V,x,H,te,B,z,_,ne){super({syncResource:p.SyncResource.GlobalState,profile:v},L,F,x,z,M,K,H,te,V,B,_),this.Bb=U,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:p.$9nb,authority:"base"}),this.xb=this.vb.with({scheme:p.$9nb,authority:"local"}),this.yb=this.vb.with({scheme:p.$9nb,authority:"remote"}),this.zb=this.vb.with({scheme:p.$9nb,authority:"accepted"}),this.Ab=ne.createInstance(u),this.B(F.watch(this.h.dirname(this.H.argvResource))),this.B(C.Event.any(C.Event.filter(F.onDidFilesChange,le=>le.contains(this.H.argvResource)),C.Event.filter(U.onDidChange,le=>!!(le.targetChanges.some(ee=>this.syncResource.profile.id===ee.id)||le.valueChanges.some(({profile:ee,changes:Q})=>this.syncResource.profile.id===ee.id&&Q.some(X=>X.target===l.StorageTarget.USER)))))(()=>this.Q()))}async qb(v,L,U){const F=v.syncData?JSON.parse(v.syncData.content):null;L=L===null&&U?v:L;const M=L&&L.syncData?JSON.parse(L.syncData.content):null,K=await this.Ab.getLocalGlobalState(this.syncResource.profile);F?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const V=await this.Jb(M),{local:x,remote:H}=(0,P.$mOb)(K.storage,F?F.storage:null,M?M.storage:null,V,this.O),te={content:null,local:x,remote:H,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?p.Change.Modified:p.Change.None,remoteChange:H.all!==null?p.Change.Modified:p.Change.None},B=s(K,!1);return[{baseResource:this.wb,baseContent:M?s(M,!1):B,localResource:this.xb,localContent:B,localUserData:K,remoteResource:this.yb,remoteContent:F?s(F,!1):null,previewResource:this.vb,previewResult:te,localChange:te.localChange,remoteChange:te.remoteChange,acceptedResource:this.zb,storageKeys:V}]}async ub(v){const L=v.syncData?JSON.parse(v.syncData.content):null;if(L===null)return!0;const U=await this.Ab.getLocalGlobalState(this.syncResource.profile),F=await this.Jb(L),{remote:M}=(0,P.$mOb)(U.storage,L.storage,L.storage,F,this.O);return M.all!==null}async rb(v,L){return{...v.previewResult,hasConflicts:!1}}async sb(v,L,U,F){if(this.h.isEqual(L,this.xb))return this.Gb(v);if(this.h.isEqual(L,this.yb))return this.Hb(v);if(this.h.isEqual(L,this.vb))return v.previewResult;throw new Error(`Invalid Resource: ${L.toString()}`)}async Gb(v){return{content:v.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(v.localUserData.storage),removed:[],updated:[],all:v.localUserData.storage},localChange:p.Change.None,remoteChange:p.Change.Modified}}async Hb(v){if(v.remoteContent!==null){const L=JSON.parse(v.remoteContent),{local:U,remote:F}=(0,P.$mOb)(v.localUserData.storage,L.storage,null,v.storageKeys,this.O);return{content:v.remoteContent,local:U,remote:F,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?p.Change.Modified:p.Change.None,remoteChange:F!==null?p.Change.Modified:p.Change.None}}else return{content:v.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:p.Change.None,remoteChange:p.Change.None}}async tb(v,L,U,F){const{localUserData:M}=U[0][0],{local:K,remote:V,localChange:x,remoteChange:H}=U[0][1];if(x===p.Change.None&&H===p.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==p.Change.None&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(M)),await this.Ab.writeLocalGlobalState(K,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==p.Change.None){this.O.trace(`${this.D}: Updating remote ui state...`);const te=JSON.stringify({storage:V.all});v=await this.mb(te,F?null:v.ref),this.O.info(`${this.D}: Updated remote ui state.${V.added.length?` Added: ${V.added}.`:""}${V.updated.length?` Updated: ${V.updated}.`:""}${V.removed.length?` Removed: ${V.removed}.`:""}`)}L?.ref!==v.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(v),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(v){if(this.h.isEqual(this.yb,v)||this.h.isEqual(this.wb,v)||this.h.isEqual(this.xb,v)||this.h.isEqual(this.zb,v)){const L=await this.db(v);return L&&s(JSON.parse(L),!0)}return null}async hasLocalData(){try{const{storage:v}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(v).length>1||v[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(v){const L=await this.Bb.readStorageData(this.syncResource.profile),U=[],F=[];for(const[V,x]of L)x.target===l.StorageTarget.USER?U.push(V):x.target===l.StorageTarget.MACHINE&&F.push(V);const M=[...U,...F],K=v?.storage?Object.keys(v.storage).filter(V=>!V.startsWith(n)&&!M.includes(V)&&L.get(V)!==void 0):[];if(!k.$p){const V=[...p.$Nnb.map(x=>(0,p.$1nb)(x)),p.$Znb];K.push(...V),F.push(...V)}return{user:U,machine:F,unregistered:K}}};e.$oOb=o,e.$oOb=o=ve([Z(2,h.$cNb),Z(3,$.$al),Z(4,p.$Rnb),Z(5,p.$Snb),Z(6,p.$7nb),Z(7,I.$Mi),Z(8,p.$2nb),Z(9,m.$_l),Z(10,b.$_i),Z(11,l.$iq),Z(12,E.$Kl),Z(13,i.$Ei)],o);let u=class{constructor(v,L,U,F){this.a=v,this.b=L,this.c=U,this.d=F}async getLocalGlobalState(v){const L={};if(v.isDefault){const F=await this.f(),M=(0,A.$Yn)(F);for(const K of t)M[K]!==void 0&&(L[`${n}${K}`]={version:1,value:M[K]})}const U=await this.c.readStorageData(v);for(const[F,M]of U)M.value&&M.target===l.StorageTarget.USER&&(L[F]={version:1,value:M.value});return{storage:L}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const v=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),v.value.toString()}catch(v){this.d.debug((0,a.$9)(v))}return"{}"}async writeLocalGlobalState({added:v,removed:L,updated:U},F){const M=(0,f.$hOb)(p.SyncResource.GlobalState,F),K={},V=new Map,x=await this.c.readStorageData(F),H=(te,B)=>{for(const z of te){if(z.startsWith(n)){K[z.substring(n.length)]=B?B[z].value:void 0;continue}if(B){const _=B[z];_.value!==x.get(z)?.value&&V.set(z,_.value)}else x.get(z)!==void 0&&V.set(z,void 0)}};if(H(Object.keys(v),v),H(Object.keys(U),U),H(L),Object.keys(K).length){this.d.trace(`${M}: Updating locale...`);const te=await this.f();let B=te;for(const z of Object.keys(K))B=(0,w.edit)(B,[z],K[z],{});te!==B&&(this.d.trace(`${M}: Updating locale...`),await this.a.writeFile(this.b.argvResource,R.$Ne.fromString(B)),this.d.info(`${M}: Updated locale.`)),this.d.info(`${M}: Updated locale`)}V.size&&(this.d.trace(`${M}: Updating global state...`),await this.c.updateStorageData(F,V,l.StorageTarget.USER),this.d.info(`${M}: Updated global state`,[...V.keys()]))}};e.$pOb=u,e.$pOb=u=ve([Z(0,$.$al),Z(1,I.$Mi),Z(2,h.$cNb),Z(3,p.$7nb)],u);let y=class extends f.$lOb{constructor(v,L,U,F,M,K){super(p.SyncResource.GlobalState,U,F,M,L,v,K)}async o(v){const L=v.syncData?JSON.parse(v.syncData.content):null;if(!L){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const U={},F={};for(const M of Object.keys(L.storage))M.startsWith(n)?U[M.substring(n.length)]=L.storage[M].value:this.l.get(M,l.StorageScope.PROFILE)===void 0&&(F[M]=L.storage[M].value);if(Object.keys(U).length){let M="{}";try{M=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const K of Object.keys(U))M=(0,w.edit)(M,[K],U[K],{});await this.k.writeFile(this.h.argvResource,R.$Ne.fromString(M))}if(Object.keys(F).length){const M=[];for(const K of Object.keys(F))M.push({key:K,value:F[K],scope:l.StorageScope.PROFILE,target:l.StorageTarget.USER});this.l.storeAll(M,!0)}}};e.$qOb=y,e.$qOb=y=ve([Z(0,l.$iq),Z(1,$.$al),Z(2,c.$Ml),Z(3,I.$Mi),Z(4,p.$7nb),Z(5,E.$Kl)],y);let N=class{constructor(v,L,U,F,M){this.a=v,this.b=L,this.c=U,this.d=F,this.f=M}getSyncStoreType(v){return this.h(v)?.storage[p.$Znb]?.value}async sync(v){const L=(0,p.$Vnb)((0,O.$2g)());try{return await this.g(v,L)}catch(U){if(U instanceof p.$Wnb)switch(U.code){case p.UserDataSyncErrorCode.PreconditionFailed:return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(v,L)}throw U}}async g(v,L){const U=await this.a.readResource(p.SyncResource.GlobalState,null,void 0,L),F=this.h(U)||{storage:{}};F.storage[p.$Znb]={value:v,version:r};const M=await(0,g.$oq)(this.c,this.d,this.b),K={version:r,machineId:M,content:s(F,!1)};await this.a.writeResource(p.SyncResource.GlobalState,JSON.stringify(K),U.ref,void 0,L)}h({content:v}){if(!v)return null;const L=JSON.parse(v);if((0,f.$gOb)(L))return L?JSON.parse(L.content):null;throw new Error("Invalid remote data")}};e.$rOb=N,e.$rOb=N=ve([Z(1,l.$iq),Z(2,I.$Mi),Z(3,$.$al),Z(4,d.$ak)],N)}),define(he[121],ue([0,1,17,14,3,36,5,12,11,21,15,7,16,18,28,19,40,207,24]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=e.$8cc=void 0,e.$7cc=P;function P(h,i,n){try{const t=JSON.parse(h);if(!i)return(0,k.$lg)(t.all)?null:t.all;switch(T.OS){case T.OperatingSystem.Macintosh:return(0,k.$lg)(t.mac)?null:t.mac;case T.OperatingSystem.Linux:return(0,k.$lg)(t.linux)?null:t.linux;case T.OperatingSystem.Windows:return(0,k.$lg)(t.windows)?null:t.windows}}catch(t){return n.error(t),null}}let p=class extends E.$kOb{constructor(i,n,t,s,r,o,u,y,N,S,v,L,U){super(i.keybindingsResource,{syncResource:w.SyncResource.Keybindings,profile:i},n,y,N,S,t,s,u,L,r,v,o,U),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:w.$9nb,authority:"base"}),this.Gb=this.Eb.with({scheme:w.$9nb,authority:"local"}),this.Hb=this.Eb.with({scheme:w.$9nb,authority:"remote"}),this.Ib=this.Eb.with({scheme:w.$9nb,authority:"accepted"}),this.B(C.Event.filter(o.onDidChangeConfiguration,F=>F.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(i,n,t,s){const r=i.syncData?P(i.syncData.content,s.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&t?i:n;const o=n?this.Ob(n):null,u=await this.vb(),y=await this.Cb();let N=null,S=!1,v=!1,L=!1;if(r){let M=u?u.value.toString():"[]";if(M=M||"[]",this.Ab(M,!0))throw new w.$Wnb((0,O.localize)(11073,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!o||o!==M||o!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const K=await(0,f.$6cc)(M,r,o,y,this.zb);K.hasChanges&&(N=K.mergeContent,L=K.hasConflicts,S=L||K.mergeContent!==M,v=L||K.mergeContent!==r)}}else u&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),N=u.value.toString(),v=!0);const U={content:L?o:N,localChange:S?u?w.Change.Modified:w.Change.Added:w.Change.None,remoteChange:v?w.Change.Modified:w.Change.None,hasConflicts:L},F=u?u.value.toString():null;return[{fileContent:u,baseResource:this.Fb,baseContent:o,localResource:this.Gb,localContent:F,localChange:U.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:U.remoteChange,previewResource:this.Eb,previewResult:U,acceptedResource:this.Ib}]}async ub(i){const n=this.Ob(i);if(n===null)return!0;const t=await this.vb(),s=t?t.value.toString():"",r=await this.Cb(),o=await(0,f.$6cc)(s||"[]",n,n,r,this.zb);return o.hasConflicts||o.mergeContent!==n}async rb(i,n){return i.previewResult}async sb(i,n,t,s){if(this.h.isEqual(n,this.Gb))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:w.Change.None,remoteChange:w.Change.Modified};if(this.h.isEqual(n,this.Hb))return{content:i.remoteContent,localChange:w.Change.Modified,remoteChange:w.Change.None};if(this.h.isEqual(n,this.Eb))return t===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:t,localChange:w.Change.Modified,remoteChange:w.Change.Modified};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(i,n,t,s){const{fileContent:r}=t[0][0];let{content:o,localChange:u,remoteChange:y}=t[0][1];if(u===w.Change.None&&y===w.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.Ab(o,!0)))throw new w.$Wnb((0,O.localize)(11074,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(u!==w.Change.None&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(o||"[]",r,s),this.O.info(`${this.D}: Updated local keybindings`)),y!==w.Change.None){this.O.trace(`${this.D}: Updating remote keybindings...`);const N=this.Pb(o||"[]",i.syncData?.content);i=await this.mb(N,s?null:i.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(i,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.vb();if(i){const n=(0,A.$Yn)(i.value.toString());if((0,R.$Kb)(n))return!0}}catch(i){if(i.fileOperationResult!==$.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.Hb,i)||this.h.isEqual(this.Fb,i)||this.h.isEqual(this.Gb,i)||this.h.isEqual(this.Ib,i)?this.db(i):null}Ob(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.Qb()?null:P(i.syncData.content,this.Qb(),this.O)}Pb(i,n){let t={};try{t=JSON.parse(n||"{}")}catch(s){this.O.error(s)}switch(this.Qb()?delete t.all:t.all=i,T.OS){case T.OperatingSystem.Macintosh:t.mac=i;break;case T.OperatingSystem.Linux:t.linux=i;break;case T.OperatingSystem.Windows:t.windows=i;break}return JSON.stringify(t)}Qb(){return!!this.P.getValue(w.$Knb)}};e.$8cc=p,e.$8cc=p=ve([Z(2,w.$Rnb),Z(3,w.$Snb),Z(4,w.$7nb),Z(5,b.$_i),Z(6,w.$2nb),Z(7,$.$al),Z(8,I.$Mi),Z(9,d.$iq),Z(10,w.$6nb),Z(11,g.$_l),Z(12,l.$Kl)],p);let c=class extends E.$lOb{constructor(i,n,t,s,r,o){super(w.SyncResource.Keybindings,n,t,s,i,r,o)}async o(i){const n=i.syncData?this.p(i.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,a.$Ne.fromString(n)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,A.$Yn)(i.value.toString());return!(0,R.$Kb)(n)}catch(i){return i.fileOperationResult===$.FileOperationResult.FILE_NOT_FOUND}}p(i){try{return P(i,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$9cc=c,e.$9cc=c=ve([Z(0,$.$al),Z(1,m.$Ml),Z(2,I.$Mi),Z(3,w.$7nb),Z(4,d.$iq),Z(5,l.$Kl)],c)}),define(he[122],ue([0,1,17,14,3,11,21,77,15,27,34,7,16,18,28,19,40,211,24]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=e.$$cc=void 0,e.$0cc=p;function P(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function p(i){const n=JSON.parse(i);return P(n)?n:{settings:i}}let c=class extends E.$kOb{constructor(n,t,s,r,o,u,y,N,S,v,L,U,F,M){super(n.settingsResource,{syncResource:w.SyncResource.Settings,profile:n},t,s,r,o,u,y,L,U,N,S,v,M),this.Eb=n,this.Fb=F,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:w.$9nb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$9nb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$9nb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$9nb,authority:"accepted"}),this.Pb=void 0,this.Qb=void 0,this.Rb=void 0}async getRemoteUserDataSyncConfiguration(n){const t=await this.getLastSyncUserData(),s=await this.X(n,t),r=this.Mb(s),o=new k.$Po(w.$Jnb,this.O);return r?.settings&&o.parse(r.settings),o.configurationModel.getValue(w.$Jnb)||{}}async qb(n,t,s){const r=await this.vb(),o=await this.Cb(),u=this.Mb(n);t=t===null&&s?n:t;const y=t?this.Mb(t):null,N=await this.Sb();let S=null,v=!1,L=!1,U=!1;if(u){let V=r?r.value.toString().trim():"{}";V=V||"{}",this.Vb(V),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const x=(0,f.$VMb)(V,u.settings,y?y.settings:null,N,[],o);S=x.localContent||x.remoteContent,v=x.localContent!==null,L=x.remoteContent!==null,U=x.hasConflicts}else r&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),S=r.value.toString().trim()||"{}",this.Vb(S),L=!0);const F=r?r.value.toString():null,M=y?.settings??null,K={content:U?M:S,localChange:v?w.Change.Modified:w.Change.None,remoteChange:L?w.Change.Modified:w.Change.None,hasConflicts:U};return[{fileContent:r,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:F,localChange:K.localChange,remoteResource:this.remoteResource,remoteContent:u?u.settings:null,remoteChange:K.remoteChange,previewResource:this.previewResource,previewResult:K,acceptedResource:this.acceptedResource}]}async ub(n){const t=this.Mb(n);if(t===null)return!0;const s=await this.vb(),r=s?s.value.toString().trim():"",o=await this.Sb(),u=await this.Cb();return(0,f.$VMb)(r||"{}",t.settings,t.settings,o,[],u).remoteContent!==null}async rb(n,t){const s=await this.Cb(),r=await this.Sb();return{...n.previewResult,content:n.previewResult.content?(0,f.$UMb)(n.previewResult.content,"{}",r,s):null}}async sb(n,t,s,r){const o=await this.Cb(),u=await this.Sb();if(this.h.isEqual(t,this.localResource))return{content:n.fileContent?(0,f.$UMb)(n.fileContent.value.toString(),"{}",u,o):null,localChange:w.Change.None,remoteChange:w.Change.Modified};if(this.h.isEqual(t,this.remoteResource))return{content:n.remoteContent!==null?(0,f.$UMb)(n.remoteContent,n.fileContent?n.fileContent.value.toString():"{}",u,o):null,localChange:w.Change.Modified,remoteChange:w.Change.None};if(this.h.isEqual(t,this.previewResource))return s===void 0?{content:n.previewResult.content,localChange:n.previewResult.localChange,remoteChange:n.previewResult.remoteChange}:{content:s!==null?(0,f.$UMb)(s,n.fileContent?n.fileContent.value.toString():"{}",u,o):null,localChange:w.Change.Modified,remoteChange:w.Change.Modified};throw new Error(`Invalid Resource: ${t.toString()}`)}async tb(n,t,s,r){const{fileContent:o}=s[0][0];let{content:u,localChange:y,remoteChange:N}=s[0][1];if(y===w.Change.None&&N===w.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),u=u?u.trim():"{}",u=u||"{}",this.Vb(u),y!==w.Change.None&&(this.O.trace(`${this.D}: Updating local settings...`),o&&await this.nb(JSON.stringify(this.Ob(o.value.toString()))),await this.wb(u,o,r),await this.P.reloadConfiguration(T.ConfigurationTarget.USER_LOCAL),this.O.info(`${this.D}: Updated local settings`)),N!==w.Change.None){const S=await this.Cb(),v=this.Mb(n),L=await this.Sb(u);u=(0,f.$UMb)(u,v?v.settings:"{}",L,S),this.O.trace(`${this.D}: Updating remote settings...`),n=await this.mb(JSON.stringify(this.Ob(u)),r?null:n.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}t?.ref!==n.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(n),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const n=await this.vb();if(n)return!(0,f.$WMb)(n.value.toString())}catch(n){if(n.fileOperationResult!==$.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(n){return this.h.isEqual(this.remoteResource,n)||this.h.isEqual(this.localResource,n)||this.h.isEqual(this.acceptedResource,n)||this.h.isEqual(this.baseResource,n)?this.db(n):null}async db(n){let t=await super.db(n);if(t){const s=await this.Cb(),r=await this.Sb();t=(0,f.$UMb)(t,"{}",r,s)}return t}Mb(n){return n.syncData?this.Nb(n.syncData.content):null}Nb(n){try{return p(n)}catch(t){this.O.error(t)}return null}Ob(n){return{settings:n}}async Sb(n){if(this.Pb||(this.Pb=this.zb.resolveDefaultCoreIgnoredSettings()),this.Qb||(this.Qb=this.Tb()),!this.Rb){this.Rb=this.Ub();const s=this.B(C.Event.any(C.Event.filter(this.Fb.onDidInstallExtensions,r=>r.some(({local:o})=>!!o)),C.Event.filter(this.Fb.onDidUninstallExtension,r=>!r.error))(()=>{s.dispose(),this.Rb=void 0}))}const t=(await Promise.all([this.Pb,this.Qb,this.Rb])).flat();return(0,f.$SMb)(t,this.P,n)}async Tb(){const n=await this.Fb.getInstalled(I.ExtensionType.System);return(0,R.$Lb)(n.map(t=>(0,w.$Inb)(t.manifest)).flat())}async Ub(){const n=await this.Fb.getInstalled(I.ExtensionType.User,this.Eb.extensionsResource);return(0,R.$Lb)(n.map(t=>(0,w.$Inb)(t.manifest)).flat())}Vb(n){if(this.Ab(n,!1))throw new w.$Wnb((0,A.localize)(11072,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}};e.$$cc=c,e.$$cc=c=ve([Z(2,$.$al),Z(3,O.$Mi),Z(4,d.$iq),Z(5,w.$Rnb),Z(6,w.$Snb),Z(7,w.$7nb),Z(8,w.$6nb),Z(9,T.$_i),Z(10,w.$2nb),Z(11,g.$_l),Z(12,b.$op),Z(13,l.$Kl)],c);let h=class extends E.$lOb{constructor(n,t,s,r,o,u){super(w.SyncResource.Settings,t,s,r,n,o,u)}async o(n){const t=n.syncData?this.p(n.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,a.$Ne.fromString(t.settings)),await this.n(n)}async i(){try{const n=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,f.$WMb)(n.value.toString().trim())}catch(n){return n.fileOperationResult===$.FileOperationResult.FILE_NOT_FOUND}}p(n){try{return p(n)}catch(t){this.j.error(t)}return null}};e.$_cc=h,e.$_cc=h=ve([Z(0,$.$al),Z(1,m.$Ml),Z(2,O.$Mi),Z(3,w.$7nb),Z(4,d.$iq),Z(5,l.$Kl)],h)}),define(he[123],ue([0,1,14,3,29,21,15,7,16,18,28,19,40,208,24]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=e.$ddc=void 0,e.$cdc=m;function m(w){return JSON.parse(w.content)}let E=class extends d.$iOb{constructor(P,p,c,h,i,n,t,s,r,o,u,y){super({syncResource:l.SyncResource.Snippets,profile:P},p,h,c,i,n,t,o,u,s,r,y),this.pb=1,this.vb=P.snippetsHome,this.B(this.G.watch(c.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(a.Event.filter(this.G.onDidFilesChange,N=>N.affects(this.vb))(()=>this.Q()))}async qb(P,p,c){const h=await this.Hb(),i=this.Gb(h),n=P.syncData?this.Fb(P.syncData):null;p=p===null&&c?P:p;const t=p&&p.syncData?this.Fb(p.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,g.$adc)(i,n,t);return this.Bb(s,h,n||{},t||{})}async ub(P){const p=P.syncData?this.Fb(P.syncData):null;if(p===null)return!0;const c=await this.Hb(),h=this.Gb(c),i=(0,g.$adc)(h,p,p);return Object.keys(i.remote.added).length>0||Object.keys(i.remote.updated).length>0||i.remote.removed.length>0||i.conflicts.length>0}async rb(P,p){return P.previewResult}async sb(P,p,c,h){if(this.h.isEqualOrParent(p,this.g.with({scheme:l.$9nb,authority:"local"})))return{content:P.fileContent?P.fileContent.value.toString():null,localChange:l.Change.None,remoteChange:P.fileContent?P.remoteContent!==null?l.Change.Modified:l.Change.Added:l.Change.Deleted};if(this.h.isEqualOrParent(p,this.g.with({scheme:l.$9nb,authority:"remote"})))return{content:P.remoteContent,localChange:P.remoteContent!==null?P.fileContent?l.Change.Modified:l.Change.Added:l.Change.Deleted,remoteChange:l.Change.None};if(this.h.isEqualOrParent(p,this.g))return c===void 0?{content:P.previewResult.content,localChange:P.previewResult.localChange,remoteChange:P.previewResult.remoteChange}:{content:c,localChange:c===null?P.fileContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified,remoteChange:c===null?P.remoteContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified};throw new Error(`Invalid Resource: ${p.toString()}`)}async tb(P,p,c,h){const i=c.map(([n,t])=>({...n,acceptResult:t}));i.every(({localChange:n,remoteChange:t})=>n===l.Change.None&&t===l.Change.None)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),i.some(({localChange:n})=>n!==l.Change.None)&&(await this.Cb(i),await this.Db(i,h)),i.some(({remoteChange:n})=>n!==l.Change.None)&&(P=await this.Eb(i,P,h)),p?.ref!==P.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(P),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of i)try{await this.G.del(n)}catch{}}Bb(P,p,c,h){const i=new Map;for(const n of Object.keys(P.local.added)){const t={content:P.local.added[n],hasConflicts:!1,localChange:l.Change.Added,remoteChange:l.Change.None};i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"remote"}),remoteContent:c[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"accepted"})})}for(const n of Object.keys(P.local.updated)){const t={content:P.local.updated[n],hasConflicts:!1,localChange:l.Change.Modified,remoteChange:l.Change.None},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"local"}),fileContent:p[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"remote"}),remoteContent:c[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"accepted"})})}for(const n of P.local.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.Deleted,remoteChange:l.Change.None},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"local"}),fileContent:p[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"accepted"})})}for(const n of Object.keys(P.remote.added)){const t={content:P.remote.added[n],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Added},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"local"}),fileContent:p[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"accepted"})})}for(const n of Object.keys(P.remote.updated)){const t={content:P.remote.updated[n],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Modified},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"local"}),fileContent:p[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"remote"}),remoteContent:c[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"accepted"})})}for(const n of P.remote.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Deleted};i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"remote"}),remoteContent:c[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"accepted"})})}for(const n of P.conflicts){const t={content:h[n]??null,hasConflicts:!0,localChange:p[n]?l.Change.Modified:l.Change.Added,remoteChange:c[n]?l.Change.Modified:l.Change.Added},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"local"}),fileContent:p[n]||null,localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"remote"}),remoteContent:c[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"accepted"})})}for(const n of Object.keys(p))if(!i.has(n)){const t={content:p[n]?p[n].value.toString():null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.None},s=p[n]?p[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"local"}),fileContent:p[n]||null,localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"remote"}),remoteContent:c[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$9nb,authority:"accepted"})})}return[...i.values()]}async resolveContent(P){return this.h.isEqualOrParent(P,this.g.with({scheme:l.$9nb,authority:"remote"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$9nb,authority:"local"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$9nb,authority:"base"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$9nb,authority:"accepted"}))?this.db(P):null}async hasLocalData(){try{const P=await this.Hb();if(Object.keys(P).length)return!0}catch{}return!1}async Cb(P){const p={};for(const c of P)c.fileContent&&(p[this.h.basename(c.localResource)]=c.fileContent);await this.nb(JSON.stringify(this.Gb(p)))}async Db(P,p){for(const{fileContent:c,acceptResult:h,localResource:i,remoteResource:n,localChange:t}of P)if(t!==l.Change.None){const s=n?this.h.basename(n):this.h.basename(i),r=this.h.joinPath(this.vb,s);t===l.Change.Deleted?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):t===l.Change.Added?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,R.$Ne.fromString(h.content),{overwrite:p}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,R.$Ne.fromString(h.content),p?void 0:c),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(P,p,c){const h=p.syncData?this.Fb(p.syncData):{},i=(0,C.$eo)(h);for(const{acceptResult:n,localResource:t,remoteResource:s,remoteChange:r}of P)if(r!==l.Change.None){const o=t?this.h.basename(t):this.h.basename(s);r===l.Change.Deleted?delete i[o]:i[o]=n.content}return(0,g.$bdc)(h,i)||(this.O.trace(`${this.D}: Updating remote snippets...`),p=await this.mb(JSON.stringify(i),c?null:p.ref),this.O.info(`${this.D}: Updated remote snippets`)),p}Fb(P){return m(P)}Gb(P){const p={};for(const c of Object.keys(P))p[c]=P[c].value.toString();return p}async Hb(){const P={};let p;try{p=await this.G.resolve(this.vb)}catch(c){if(c instanceof k.$vl&&c.fileOperationResult===k.FileOperationResult.FILE_NOT_FOUND)return P;throw c}for(const c of p.children||[]){const h=c.resource,i=this.h.extname(h);if(i===".json"||i===".code-snippets"){const n=this.h.relativePath(this.vb,h),t=await this.G.readFile(h);P[n]=t}}return P}};e.$ddc=E,e.$ddc=E=ve([Z(2,T.$Mi),Z(3,k.$al),Z(4,O.$iq),Z(5,l.$Rnb),Z(6,l.$Snb),Z(7,l.$7nb),Z(8,A.$_i),Z(9,l.$2nb),Z(10,b.$_l),Z(11,I.$Kl)],E);let f=class extends d.$lOb{constructor(P,p,c,h,i,n){super(l.SyncResource.Snippets,p,c,h,P,i,n)}async o(P){const p=P.syncData?JSON.parse(P.syncData.content):null;if(!p){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const h of Object.keys(p)){const i=p[h];if(i){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,h);await this.k.createFile(n,R.$Ne.fromString(i)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(P)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(P){return P.fileOperationResult===k.FileOperationResult.FILE_NOT_FOUND}}};e.$edc=f,e.$edc=f=ve([Z(0,k.$al),Z(1,$.$Ml),Z(2,T.$Mi),Z(3,l.$7nb),Z(4,O.$iq),Z(5,I.$Kl)],f)}),define(he[124],ue([0,1,14,21,15,7,16,18,28,19,40,24]),function(ae,e,R,a,C,A,T,k,O,b,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=e.$gdc=void 0,e.$fdc=d;function d(E,f){try{return JSON.parse(E).tasks??null}catch(w){return f.error(w),null}}let g=class extends I.$jOb{constructor(f,w,P,p,c,h,i,n,t,s,r,o){super(f.tasksResource,{syncResource:$.SyncResource.Tasks,profile:f},w,n,t,s,P,p,i,r,c,h,o),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:$.$9nb,authority:"base"}),this.Cb=this.Ab.with({scheme:$.$9nb,authority:"local"}),this.Db=this.Ab.with({scheme:$.$9nb,authority:"remote"}),this.Eb=this.Ab.with({scheme:$.$9nb,authority:"accepted"})}async qb(f,w,P,p){const c=f.syncData?d(f.syncData.content,this.O):null;w=w===null&&P?f:w;const h=w?.syncData?d(w.syncData.content,this.O):null,i=await this.vb();let n=null,t=!1,s=!1,r=!1;if(f.syncData){const y=i?i.value.toString():null;if(!h||h!==y||h!==c){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const N=m(y,c,h);n=N.content,r=N.hasConflicts,t=N.hasLocalChanged,s=N.hasRemoteChanged}}else i&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=i.value.toString(),s=!0);const o={content:r?h:n,localChange:t?i?$.Change.Modified:$.Change.Added:$.Change.None,remoteChange:s?$.Change.Modified:$.Change.None,hasConflicts:r},u=i?i.value.toString():null;return[{fileContent:i,baseResource:this.Bb,baseContent:h,localResource:this.Cb,localContent:u,localChange:o.localChange,remoteResource:this.Db,remoteContent:c,remoteChange:o.remoteChange,previewResource:this.Ab,previewResult:o,acceptedResource:this.Eb}]}async ub(f){const w=f?.syncData?d(f.syncData.content,this.O):null;if(w===null)return!0;const P=await this.vb(),p=P?P.value.toString():null,c=m(p,w,w);return c.hasLocalChanged||c.hasRemoteChanged}async rb(f,w){return f.previewResult}async sb(f,w,P,p){if(this.h.isEqual(w,this.Cb))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:$.Change.None,remoteChange:$.Change.Modified};if(this.h.isEqual(w,this.Db))return{content:f.remoteContent,localChange:$.Change.Modified,remoteChange:$.Change.None};if(this.h.isEqual(w,this.Ab))return P===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:P,localChange:$.Change.Modified,remoteChange:$.Change.Modified};throw new Error(`Invalid Resource: ${w.toString()}`)}async tb(f,w,P,p){const{fileContent:c}=P[0][0],{content:h,localChange:i,remoteChange:n}=P[0][1];if(i===$.Change.None&&n===$.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),i!==$.Change.None&&(this.O.trace(`${this.D}: Updating local tasks...`),c&&await this.nb(JSON.stringify(this.Kb(c.value.toString()))),h?await this.wb(h,c,p):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==$.Change.None){this.O.trace(`${this.D}: Updating remote tasks...`);const t=JSON.stringify(this.Kb(h));f=await this.mb(t,p?null:f.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}w?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(f){return this.h.isEqual(this.Db,f)||this.h.isEqual(this.Bb,f)||this.h.isEqual(this.Cb,f)||this.h.isEqual(this.Eb,f)?this.db(f):null}Kb(f){return f?{tasks:f}:{}}};e.$gdc=g,e.$gdc=g=ve([Z(2,$.$Rnb),Z(3,$.$Snb),Z(4,$.$7nb),Z(5,a.$_i),Z(6,$.$2nb),Z(7,A.$al),Z(8,C.$Mi),Z(9,T.$iq),Z(10,k.$_l),Z(11,O.$Kl)],g);let l=class extends I.$lOb{constructor(f,w,P,p,c,h){super($.SyncResource.Tasks,w,P,p,f,c,h),this.c=this.g.defaultProfile.tasksResource}async o(f){const w=f.syncData?d(f.syncData.content,this.j):null;if(!w){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,R.$Ne.fromString(w)),await this.n(f)}async p(){return this.k.exists(this.c)}};e.$hdc=l,e.$hdc=l=ve([Z(0,A.$al),Z(1,b.$Ml),Z(2,C.$Mi),Z(3,$.$7nb),Z(4,T.$iq),Z(5,O.$Kl)],l);function m(E,f,w){if(E===null&&f===null&&w===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(E===f)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const P=w!==E,p=w!==f;return!P&&!p?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:P&&!p?{content:E,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:p&&!P?{content:f,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:E,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(he[125],ue([0,1,45,21,15,7,16,18,28,19,40,209,24]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=void 0,e.$2ec=l,e.$3ec=m;let g=class extends I.$iOb{constructor(f,w,P,p,c,h,i,n,t,s,r,o,u){super({syncResource:d.SyncResource.Profiles,profile:f},w,p,c,h,i,n,r,o,t,s,u),this.vb=P,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:d.$9nb,authority:"base"}),this.localResource=this.previewResource.with({scheme:d.$9nb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.$9nb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.$9nb,authority:"accepted"}),this.B(P.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const f=await this.getLastSyncUserData();return f?.syncData?m(f.syncData):null}async getRemoteSyncedProfiles(f){const w=await this.getLastSyncUserData(),P=await this.X(f,w);return P?.syncData?m(P.syncData):null}async qb(f,w,P){if(!this.vb.isEnabled())throw new d.$Wnb("Cannot sync profiles because they are disabled",d.UserDataSyncErrorCode.LocalError);const p=f.syncData?m(f.syncData):null,c=w?.syncData?m(w.syncData):null,h=this.Db(),{local:i,remote:n}=(0,$.$Zec)(h,p,c,[]),t={local:i,remote:n,content:c?this.Eb(c):null,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?d.Change.Modified:d.Change.None,remoteChange:n!==null?d.Change.Modified:d.Change.None},s=l(h,!1);return[{baseResource:this.baseResource,baseContent:c?this.Eb(c):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:p?this.Eb(p):null,remoteProfiles:p,previewResource:this.previewResource,previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.acceptedResource}]}async ub(f){const w=f?.syncData?m(f.syncData):null,P=this.Db(),{remote:p}=(0,$.$Zec)(P,w,w,[]);return!!p?.added.length||!!p?.removed.length||!!p?.updated.length}async rb(f,w){return{...f.previewResult,hasConflicts:!1}}async sb(f,w,P,p){if(this.h.isEqual(w,this.localResource))return this.Ab(f);if(this.h.isEqual(w,this.remoteResource))return this.Bb(f);if(this.h.isEqual(w,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${w.toString()}`)}async Ab(f){const w=this.Db(),P=(0,$.$Zec)(w,null,null,[]),{local:p,remote:c}=P;return{content:f.localContent,local:p,remote:c,localChange:p.added.length>0||p.removed.length>0||p.updated.length>0?d.Change.Modified:d.Change.None,remoteChange:c!==null?d.Change.Modified:d.Change.None}}async Bb(f){const w=f.remoteContent?JSON.parse(f.remoteContent):null,P=[],p=[];for(const c of this.Db()){const h=w?.find(i=>i.id===c.id);h&&(P.push({id:c.id,name:c.name,collection:h.collection}),p.push(c))}if(w!==null){const c=(0,$.$Zec)(p,w,P,[]),{local:h,remote:i}=c;return{content:f.remoteContent,local:h,remote:i,localChange:h.added.length>0||h.removed.length>0||h.updated.length>0?d.Change.Modified:d.Change.None,remoteChange:i!==null?d.Change.Modified:d.Change.None}}else return{content:f.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:d.Change.None,remoteChange:d.Change.None}}async tb(f,w,P,p){const{local:c,remote:h,localChange:i,remoteChange:n}=P[0][1];i===d.Change.None&&n===d.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const t=P[0][0].remoteProfiles||[];if(t.length+(h?.added.length??0)-(h?.removed.length??0)>20)throw new d.$Wnb("Too many profiles to sync. Please remove some profiles and try again.",d.UserDataSyncErrorCode.LocalTooManyProfiles);if(i!==d.Change.None&&(await this.nb(l(this.Db(),!1)),await Promise.all(c.removed.map(async s=>{this.O.trace(`${this.D}: Removing '${s.name}' profile...`),await this.vb.removeProfile(s),this.O.info(`${this.D}: Removed profile '${s.name}'.`)})),await Promise.all(c.added.map(async s=>{this.O.trace(`${this.D}: Creating '${s.name}' profile...`),await this.vb.createProfile(s.id,s.name,{shortName:s.shortName,icon:s.icon,useDefaultFlags:s.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${s.name}'.`)})),await Promise.all(c.updated.map(async s=>{const r=this.vb.profiles.find(o=>o.id===s.id);r?(this.O.trace(`${this.D}: Updating '${s.name}' profile...`),await this.vb.updateProfile(r,{name:s.name,shortName:s.shortName,icon:s.icon,useDefaultFlags:s.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${s.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${s.id}' to update.`)}))),n!==d.Change.None){this.O.trace(`${this.D}: Updating remote profiles...`);const s=[],r=t.length+(h?.added.length??0)<=20;if(r)for(const o of h?.added||[]){const u=await this.J.createCollection(this.F);s.push(u),t.push({id:o.id,name:o.name,collection:u,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const o of h?.removed||[])t.splice(t.findIndex(({id:u})=>o.id===u),1);for(const o of h?.updated||[]){const u=t.find(({id:y})=>o.id===y);u&&t.splice(t.indexOf(u),1,{...u,id:o.id,name:o.name,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}try{f=await this.updateRemoteProfiles(t,p?null:f.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&h?.added.length?` Added: ${JSON.stringify(h.added.map(o=>o.name))}.`:""}${h?.updated.length?` Updated: ${JSON.stringify(h.updated.map(o=>o.name))}.`:""}${h?.removed.length?` Removed: ${JSON.stringify(h.removed.map(o=>o.name))}.`:""}`)}catch(o){if(s.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const u of s)await this.J.deleteCollection(u,this.F)}throw o}for(const o of h?.removed||[])await this.J.deleteCollection(o.collection,this.F)}w?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(f,w){return this.mb(this.Eb(f),w)}async hasLocalData(){return this.Db().length>0}async resolveContent(f){if(this.h.isEqual(this.remoteResource,f)||this.h.isEqual(this.baseResource,f)||this.h.isEqual(this.localResource,f)||this.h.isEqual(this.acceptedResource,f)){const w=await this.db(f);return w&&(0,R.$9n)(JSON.parse(w),{})}return null}Db(){return this.vb.profiles.filter(f=>!f.isDefault&&!f.isTransient)}Eb(f){return JSON.stringify([...f].sort((w,P)=>w.name.localeCompare(P.name)))}};e.$1ec=g,e.$1ec=g=ve([Z(2,b.$Ml),Z(3,A.$al),Z(4,C.$Mi),Z(5,T.$iq),Z(6,d.$Rnb),Z(7,d.$Snb),Z(8,d.$7nb),Z(9,a.$_i),Z(10,d.$2nb),Z(11,k.$_l),Z(12,O.$Kl)],g);function l(E,f){const w=[...E].sort((P,p)=>P.name.localeCompare(p.name)).map(P=>({id:P.id,name:P.name}));return f?(0,R.$9n)(w,{}):JSON.stringify(w)}function m(E){return JSON.parse(E.content)}}),define(he[228],ue([0,1,3,2,5,15,16,18,24]),function(ae,e,R,a,C,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=void 0;const b="sync.enable";let I=class extends a.$Uc{constructor(d,g,l,m){super(),this.c=d,this.f=g,this.g=l,this.h=m,this.a=new R.$le,this.onDidChangeEnablement=this.a.event,this.b=new R.$le,this.onDidChangeResourceEnablement=this.b.event,this.B(d.onDidChangeValue(T.StorageScope.APPLICATION,void 0,this.B(new a.$Tc))(E=>this.m(E)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(b,T.StorageScope.APPLICATION,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(d){d&&!this.canToggleEnablement()||(this.f.publicLog2(b,{enabled:d}),this.c.store(b,d,T.StorageScope.APPLICATION,T.StorageTarget.MACHINE))}isResourceEnabled(d){return this.c.getBoolean((0,O.$1nb)(d),T.StorageScope.APPLICATION,!0)}setResourceEnablement(d,g){if(this.isResourceEnabled(d)!==g){const l=(0,O.$1nb)(d);this.j(l,g)}}getResourceSyncStateVersion(d){}j(d,g){this.c.store(d,g,T.StorageScope.APPLICATION,C.$p?T.StorageTarget.USER:T.StorageTarget.MACHINE)}m(d){if(b===d.key){this.a.fire(this.isEnabled());return}const g=O.$Nnb.filter(l=>(0,O.$1nb)(l)===d.key)[0];if(g){this.b.fire([g,this.isResourceEnabled(g)]);return}}};e.$Nec=I,e.$Nec=I=ve([Z(0,T.$iq),Z(1,k.$_l),Z(2,A.$Mi),Z(3,O.$Qnb)],I)}),define(he[229],ue([0,1,6,14,71,2,20,21,15,7,19,24]),function(ae,e,R,a,C,A,T,k,O,b,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=void 0;let d=class extends A.$Uc{constructor(l,m,E,f,w){super(),this.a=l,this.b=m,this.c=E,this.f=f,this.g=w,this.h()}async h(){for(const m of this.g.profiles)for(const E of $.$Nnb)try{await this.m(this.j(E,m.isDefault?void 0:m.id))}catch(f){this.f.error(f)}let l;try{l=await this.b.resolve(this.a.userDataSyncHome)}catch(m){(0,b.$rl)(m)!==b.FileOperationResult.FILE_NOT_FOUND&&this.f.error(m);return}if(l.children){for(const m of l.children)if(m.isDirectory&&!$.$Nnb.includes(m.name)&&!this.g.profiles.some(E=>E.id===m.name))try{this.f.info("Deleting non existing profile from backup",m.resource.path),await this.b.del(m.resource,{recursive:!0})}catch(E){this.f.error(E)}}}async getAllResourceRefs(l,m,E){const f=this.j(l,m,E);try{const w=await this.b.resolve(f);if(w.children)return w.children.filter(p=>p.isFile&&!p.name.startsWith("lastSync")).sort().reverse().map(p=>({ref:p.name,created:this.n(p)}))}catch(w){if((0,b.$rl)(w)!==b.FileOperationResult.FILE_NOT_FOUND)throw w}return[]}async resolveResourceContent(l,m,E,f){const w=this.j(l,E,f),P=(0,T.$gh)(w,m);try{return(await this.b.readFile(P)).value.toString()}catch(p){return this.f.error(p),null}}async writeResource(l,m,E,f,w){const P=this.j(l,f,w),p=(0,T.$gh)(P,`${(0,C.$4m)(E).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(p,a.$Ne.fromString(m))}catch(c){this.f.error(c)}}j(l,m,E=this.a.userDataSyncHome){return(0,T.$gh)(E,...m?[m,l]:[l])}async m(l){try{try{if(!await this.b.exists(l))return}catch{return}const m=await this.b.resolve(l);if(m.children){const E=m.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort(),f=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let w=E.filter(p=>Date.now()-this.n(p)>f);const P=E.length-w.length;P<10&&(w=w.slice(10-P)),await R.Promises.settled(w.map(async p=>{this.f.info("Deleting from backup",p.resource.path),await this.b.del(p.resource)}))}}catch(m){this.f.error(m)}}n(l){return new Date(parseInt(l.name.substring(0,4)),parseInt(l.name.substring(4,6))-1,parseInt(l.name.substring(6,8)),parseInt(l.name.substring(9,11)),parseInt(l.name.substring(11,13)),parseInt(l.name.substring(13,15))).getTime()}};e.$Yec=d,e.$Yec=d=ve([Z(0,O.$Mi),Z(1,b.$al),Z(2,k.$_i),Z(3,$.$7nb),Z(4,I.$Ml)],d)}),define(he[86],ue([0,1,3,2,5,26,11,15,7,4,23,49,16,24]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fnb=e.$Dnb=void 0,e.$Enb=c,e.$Dnb=(0,b.$Fi)("IUserDataSyncMachinesService");const m="sync.currentMachineName",E="Safari",f="Chrome",w="Edge",P="Firefox",p="Android";function c(n){switch(n){case E:case f:case w:case P:case p:case(0,C.$i)(C.Platform.Web):return!0}return!1}function h(){return C.$H?E:C.$F?f:C.$I?w:C.$G?P:C.$J?p:(0,C.$i)(C.$p?C.Platform.Web:C.$v)}let i=class extends a.$Uc{static{l=this}static{this.a=1}static{this.b="machines"}constructor(t,s,r,o,u,y){super(),this.h=r,this.j=o,this.m=u,this.n=y,this.c=this.B(new R.$le),this.onDidChange=this.c.event,this.g=null,this.f=(0,$.$oq)(t,s,r)}async getMachines(t){const s=await this.f;return(await this.s(t)).machines.map(o=>({...o,isCurrent:o.id===s}))}async addCurrentMachine(t){const s=await this.f,r=await this.s(t);r.machines.some(({id:o})=>o===s)||(r.machines.push({id:s,name:this.r(r.machines),platform:h()}),await this.t(r))}async removeCurrentMachine(t){const s=await this.f,r=await this.s(t),o=r.machines.filter(({id:u})=>u!==s);o.length!==r.machines.length&&(r.machines=o,await this.t(r))}async renameMachine(t,s,r){const o=await this.s(r),u=o.machines.find(({id:y})=>y===t);if(u){u.name=s,await this.t(o);const y=await this.f;t===y&&this.h.store(m,s,d.StorageScope.APPLICATION,d.StorageTarget.MACHINE)}}async setEnablements(t){const s=await this.s();for(const[r,o]of t){const u=s.machines.find(y=>y.id===r);u&&(u.disabled=o?void 0:!0)}await this.t(s)}r(t){const s=this.h.get(m,d.StorageScope.APPLICATION);if(s)return s;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${h()} (${this.n.nameShort})`,o=new RegExp(`${(0,A.$hf)(r)}\\s#(\\d+)`);let u=0;for(const y of t){const N=o.exec(y.name),S=N?parseInt(N[1]):0;u=S>u?S:u}return`${r} #${u+1}`}async s(t){this.g=await this.u(t);const s=this.w(this.g);if(s.version!==l.a)throw new Error((0,T.localize)(11058,null,this.n.nameLong));return s}async t(t){const s=JSON.stringify(t),r=await this.j.writeResource(l.b,s,this.g?.ref||null);this.g={ref:r,content:s},this.c.fire()}async u(t){if(this.g){const s=t&&t.latest?t.latest[l.b]:void 0;if(this.g.ref===s)return this.g;if(s===void 0&&this.g.content===null)return this.g}return this.j.readResource(l.b,this.g)}w(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(s){this.m.error(s)}return{version:l.a,machines:[]}}};e.$Fnb=i,e.$Fnb=i=l=ve([Z(0,k.$Mi),Z(1,O.$al),Z(2,d.$iq),Z(3,g.$Rnb),Z(4,g.$7nb),Z(5,I.$tk)],i)}),define(he[230],ue([0,1,6,71,43,8,3,2,5,20,9,11,23,16,18,24,82,86]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=void 0;const w="sync.disableMachineEventually",P="sync.sessionId",p="sync.storeUrl",c="sync.productQuality";let h=class extends k.$Uc{get n(){const t=this.H.get(p,g.StorageScope.APPLICATION);return t?I.URI.parse(t):void 0}set n(t){t?this.H.store(p,t.toString(),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE):this.H.remove(p,g.StorageScope.APPLICATION)}get s(){return this.H.get(c,g.StorageScope.APPLICATION)}set s(t){t?this.H.store(c,t,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE):this.H.remove(c,g.StorageScope.APPLICATION)}constructor(t,s,r,o,u,y,N,S,v,L){super(),this.u=s,this.w=r,this.y=o,this.z=u,this.C=y,this.D=N,this.F=S,this.G=v,this.H=L,this.a=this.B(new k.$Vc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new T.$le),this.onError=this.h.event,this.S=[],this.f=this.B(new R.$Dh(this.U())),this.j=this.n,this.n=s.userDataSyncStore?.url,this.r=this.s,this.s=t.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(s.onDidChangeUserDataSyncStore(()=>{(0,b.$_g)(this.n,s.userDataSyncStore?.url)||(this.j=this.n,this.n=s.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(N.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(u.onDidChangeLocal(U=>this.triggerSync([U],!1,!1))),this.B(T.Event.filter(this.y.onDidChangeResourceEnablement,([,U])=>U)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:t,message:s}=this.L();t?this.a.value===void 0&&(this.a.value=new i(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.C.info(s),this.a.clear()):s&&this.y.isEnabled()&&this.C.info(s))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,a.$4m)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(t,s,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(P,g.StorageScope.APPLICATION),t?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(o){if(this.C.error(o),s)this.M(!1);else throw o}}M(t){this.y.isEnabled()!==t&&(this.y.setEnablement(t),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(t){if(!t){this.b=0;return}const s=m.$Wnb.toUserDataSyncError(t);s instanceof m.$Ynb&&this.F.publicLog2("autosync/error",{code:s.code,service:this.u.userDataSyncStore.url.toString()}),s.code===m.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):s.code===m.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code===m.UserDataSyncErrorCode.LocalTooManyRequests?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):s.code===m.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code===m.UserDataSyncErrorCode.MethodNotFound?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code===m.UserDataSyncErrorCode.UpgradeRequired||s.code===m.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code===m.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code===m.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code===m.UserDataSyncErrorCode.ServiceChanged||s.code===m.UserDataSyncErrorCode.DefaultServiceChanged?O.$p&&s.code===m.UserDataSyncErrorCode.DefaultServiceChanged&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(s),this.b++),this.h.fire(s)}async P(){this.H.store(w,!0,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),await(0,R.$Gh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(w,g.StorageScope.APPLICATION,!1)}R(){this.H.remove(w,g.StorageScope.APPLICATION)}async triggerSync(t,s,r){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...t),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const o=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:o}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$5ec=h,e.$5ec=h=ve([Z(0,d.$tk),Z(1,m.$Qnb),Z(2,m.$Rnb),Z(3,m.$2nb),Z(4,m.$3nb),Z(5,m.$7nb),Z(6,E.$CMb),Z(7,l.$_l),Z(8,f.$Dnb),Z(9,g.$iq)],h);class i extends k.$Uc{static{this.a="Interval"}constructor(t,s,r,o,u,y,N,S,v){super(),this.m=t,this.n=s,this.r=r,this.s=o,this.u=u,this.w=y,this.y=N,this.z=S,this.C=v,this.b=this.B(new k.$Vc),this.c=this.B(new T.$le),this.onDidStartSync=this.c.event,this.f=this.B(new T.$le),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,k.$Sc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(i.a,!1)}D(){this.b.value=(0,R.$Hh)(()=>{this.sync(i.a,!1),this.b.value=void 0},this.n)}sync(t,s){const r=(0,R.$sh)(async o=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(u){if((0,A.$3)(u))return}return this.H(t,s,o)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,b.$_g)(this.m,this.r.userDataSyncStore?.url)}async G(){const t=await this.r.getPreviousUserDataSyncStore(),s=this.r.userDataSyncStore;return!!s&&!!t&&(!(0,b.$_g)(s.defaultUrl,t.defaultUrl)||!(0,b.$_g)(s.insidersUrl,t.insidersUrl)||!(0,b.$_g)(s.stableUrl,t.stableUrl))}async H(t,s,r){this.y.info(`Auto Sync: Triggered by ${t}`),this.c.fire();let o;try{await this.I(s,r)}catch(u){if(this.y.error(u),o=u,m.$Wnb.toUserDataSyncError(u).code===m.UserDataSyncErrorCode.MethodNotFound)try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(s,r),o=void 0}catch(y){this.y.error(y),o=y}}this.f.fire(o)}async I(t,s){if(this.h=await this.u.createSyncTask(this.g,t),s.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new m.$Ynb((0,$.localize)(11065,null),m.UserDataSyncErrorCode.DefaultServiceChanged):new m.$Ynb((0,$.localize)(11066,null),m.UserDataSyncErrorCode.ServiceChanged):new m.$Ynb((0,$.localize)(11067,null),m.UserDataSyncErrorCode.TurnedOff);const r=this.C.get(P,g.StorageScope.APPLICATION);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new m.$Ynb((0,$.localize)(11068,null),m.UserDataSyncErrorCode.DefaultServiceChanged):new m.$Ynb((0,$.localize)(11069,null),m.UserDataSyncErrorCode.ServiceChanged):new m.$Ynb((0,$.localize)(11070,null),m.UserDataSyncErrorCode.SessionExpired);const o=await this.w.getMachines(this.g||void 0);if(s.isCancellationRequested)return;const u=o.find(N=>N.isCurrent);if(u?.disabled)throw new m.$Ynb((0,$.localize)(11071,null),m.UserDataSyncErrorCode.TurnedOff);const y=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-y}),this.g===null)try{this.g=await this.s.manifest(null)}catch(N){throw new m.$Ynb((0,C.$qj)(N),N instanceof m.$Wnb?N.code:m.UserDataSyncErrorCode.Unknown)}this.g&&this.g.session!==r&&this.C.store(P,this.g.session,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),!s.isCancellationRequested&&(u||await this.w.addCurrentMachine(this.g||void 0))}register(t){return super.B(t)}}}),define(he[231],ue([0,1,9,11,15,7,49,16,28,24,19,40,123,122,121,21,124,119,120,4,125,45,26]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f,w,P,p,c,h){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=void 0;let n=class{static{i=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(s,r,o,u,y,N,S,v,L,U){this.e=s,this.f=r,this.g=o,this.h=y,this.i=N,this.j=S,this.k=v,this.l=L,this.n=U,this.d=u.extUri}async getRemoteSyncedProfiles(){const s=await this.e.readResource(b.SyncResource.Profiles,null,void 0);if(s.content){const r=this.L(s.content,b.SyncResource.Profiles);return(0,p.$3ec)(r)}return[]}async getLocalSyncedProfiles(s){const r=await this.f.getAllResourceRefs(b.SyncResource.Profiles,void 0,s);if(r.length){const o=await this.f.resolveResourceContent(b.SyncResource.Profiles,r[0].ref,void 0,s);if(o){const u=this.L(o,b.SyncResource.Profiles);return(0,p.$3ec)(u)}}return[]}async getLocalSyncedMachines(s){const r=await this.f.getAllResourceRefs("machines",void 0,s);if(r.length){const o=await this.f.resolveResourceContent("machines",r[0].ref,void 0,s);if(o)return JSON.parse(o).machines.map(y=>({...y,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(s,r){return(await this.e.getAllResourceRefs(s,r?.collection)).map(({created:u,ref:y})=>({created:u,uri:this.J({remote:!0,syncResource:s,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:y,node:void 0})}))}async getLocalSyncResourceHandles(s,r,o){return(await this.f.getAllResourceRefs(s,r?.collection,o)).map(({created:y,ref:N})=>({created:y,uri:this.J({remote:!1,syncResource:s,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:N,node:void 0,location:o})}))}resolveUserDataSyncResource({uri:s}){const r=this.K(s),o=r?this.k.profiles.find(u=>u.id===r.profile):void 0;return r&&o?{profile:o,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:s}){const r=this.K(s);if(!r)return[];const o=this.k.profiles.find(u=>u.id===r.profile);switch(r.syncResource){case b.SyncResource.Settings:return this.s(s,o);case b.SyncResource.Keybindings:return this.u(s,o);case b.SyncResource.Tasks:return this.w(s,o);case b.SyncResource.Snippets:return this.y(s,o);case b.SyncResource.GlobalState:return this.D(s,o);case b.SyncResource.Extensions:return this.A(s,o);case b.SyncResource.Profiles:return this.G(s,o);case b.SyncResource.WorkspaceState:return[]}}async getMachineId({uri:s}){const r=this.K(s);if(r){if(r.remote){if(r.ref){const{content:o}=await this.M(r.syncResource,r.ref,r.collection);if(o)return this.L(o,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const o=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(o)return this.L(o,r.syncResource)?.machineId}return}return(0,T.$oq)(this.h,this.j,this.i)}}async resolveContent(s){const r=this.K(s);if(!r||r.node===i.a)return null;if(r.ref){const o=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&o?this.q(r.syncResource,o,r.node):o}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(s,r,o,u,y){if(s){const{content:N}=await this.M(r,u,o);return N}return this.f.resolveResourceContent(r,u,o,y)}q(s,r,o){const u=this.L(r,s);switch(s){case b.SyncResource.Settings:return this.t(u,o);case b.SyncResource.Keybindings:return this.v(u,o);case b.SyncResource.Tasks:return this.x(u,o);case b.SyncResource.Snippets:return this.z(u,o);case b.SyncResource.GlobalState:return this.E(u,o);case b.SyncResource.Extensions:return this.B(u,o);case b.SyncResource.Profiles:return this.H(u,o);case b.SyncResource.WorkspaceState:return null}}async r(s,r){const o=this.k.profiles.find(u=>u.id===r);if(!o)return null;switch(s){case b.SyncResource.GlobalState:return this.F(o);case b.SyncResource.Extensions:return this.C(o);case b.SyncResource.Profiles:return this.I(o);case b.SyncResource.Settings:return null;case b.SyncResource.Keybindings:return null;case b.SyncResource.Tasks:return null;case b.SyncResource.Snippets:return null;case b.SyncResource.WorkspaceState:return null}}s(s,r){const o=this.d.joinPath(s,"settings.json"),u=r?r.settingsResource:this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}t(s,r){switch(r){case"settings.json":return(0,g.$0cc)(s.content).settings}return null}u(s,r){const o=this.d.joinPath(s,"keybindings.json"),u=r?r.keybindingsResource:this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}v(s,r){switch(r){case"keybindings.json":return(0,l.$7cc)(s.content,!!this.l.getValue(b.$Knb),this.g)}return null}w(s,r){const o=this.d.joinPath(s,"tasks.json"),u=r?r.tasksResource:this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}x(s,r){switch(r){case"tasks.json":return(0,E.$fdc)(s.content,this.g)}return null}async y(s,r){const o=await this.resolveContent(s);if(o){const u=this.L(o,b.SyncResource.Snippets);if(u){const y=(0,d.$cdc)(u),N=[];for(const S of Object.keys(y)){const v=this.d.joinPath(s,S),L=r?this.d.joinPath(r.snippetsHome,S):this.d.joinPath(s,i.a);N.push({resource:v,comparableResource:L})}return N}}return[]}z(s,r){return(0,d.$cdc)(s)[r]||null}A(s,r){const o=this.d.joinPath(s,"extensions.json"),u=r?this.J({remote:!1,syncResource:b.SyncResource.Extensions,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}B(s,r){switch(r){case"extensions.json":return(0,f.$2cc)((0,f.$1cc)(s),!0)}return null}async C(s){const{localExtensions:r}=await this.n.createInstance(f.$4cc).getLocalExtensions(s);return(0,f.$2cc)(r,!0)}D(s,r){const o=this.d.joinPath(s,"globalState.json"),u=r?this.J({remote:!1,syncResource:b.SyncResource.GlobalState,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}E(s,r){switch(r){case"globalState.json":return(0,w.$nOb)(JSON.parse(s.content),!0)}return null}async F(s){const r=await this.n.createInstance(w.$pOb).getLocalGlobalState(s);return(0,w.$nOb)(r,!0)}G(s,r){const o=this.d.joinPath(s,"profiles.json"),u=this.J({remote:!1,syncResource:b.SyncResource.Profiles,profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:u}]}H(s,r){switch(r){case"profiles.json":return(0,c.$9n)(JSON.parse(s.content),{})}return null}async I(s){return(0,p.$2ec)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(s){const r=s.remote?i.b:i.c,o=[];return s.location&&(o.push(`scheme:${s.location.scheme}`),o.push(`authority:${s.location.authority}`),o.push((0,h.$lf)(s.location.path,"/"))),o.push(`syncResource:${s.syncResource}`),o.push(`profile:${s.profile}`),s.collection&&o.push(`collection:${s.collection}`),s.ref&&o.push(`ref:${s.ref}`),s.node&&o.push(s.node),this.d.joinPath(R.URI.from({scheme:b.$9nb,authority:r,path:"/",query:s.location?.query,fragment:s.location?.fragment}),...o)}K(s){if(s.scheme!==b.$9nb)return;const r=[];for(;s.path!=="/";)r.unshift(this.d.basename(s)),s=this.d.dirname(s);if(r.length<2)return;const o=s.authority===i.b;let u,y;const N=[];let S,v,L,U,F;for(;r.length;){const M=r.shift();M.startsWith("scheme:")?u=M.substring(7):M.startsWith("authority:")?y=M.substring(10):M.startsWith("syncResource:")?S=M.substring(13):M.startsWith("profile:")?v=M.substring(8):M.startsWith("collection:")?L=M.substring(11):M.startsWith("ref:")?U=M.substring(4):S?F=M:N.push(M)}return{remote:o,syncResource:S,profile:v,collection:L,ref:U,node:F,location:u&&y!==void 0?this.d.joinPath(R.URI.from({scheme:u,authority:y,query:s.query,fragment:s.fragment,path:"/"}),...N):void 0}}L(s,r){try{const o=JSON.parse(s);if((0,$.$gOb)(o))return o}catch(o){this.g.error(o)}throw new b.$Wnb((0,a.localize)(11057,null),b.UserDataSyncErrorCode.IncompatibleRemoteContent,r)}async M(s,r,o){const u=await this.e.resolveResourceContent(s,r,o);return{ref:r,content:u}}};e.$Ifc=n,e.$Ifc=n=i=ve([Z(0,b.$Rnb),Z(1,b.$Snb),Z(2,b.$7nb),Z(3,O.$Kl),Z(4,C.$Mi),Z(5,k.$iq),Z(6,A.$al),Z(7,I.$Ml),Z(8,m.$_i),Z(9,P.$Ei)],n)}),define(he[232],ue([0,1,17,6,25,43,3,2,20,12,32,21,27,7,4,16,18,19,119,120,121,122,123,124,125,24]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f,w,P,p,c,h,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=void 0;const s="sync.lastSyncTime";let r=class extends k.$Uc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(S,v,L,U,F,M,K,V,x,H,te){super(),this.C=S,this.D=v,this.F=L,this.G=U,this.H=F,this.I=M,this.J=K,this.L=V,this.M=x,this.N=H,this.O=te,this.f=t.SyncStatus.Uninitialized,this.g=this.B(new T.$le),this.onDidChangeStatus=this.g.event,this.h=this.B(new T.$le),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new T.$le),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new T.$le),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new T.$le),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new T.$le),this.onDidResetLocal=this.w.event,this.y=this.B(new T.$le),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=L.userDataSyncStore?t.SyncStatus.Idle:t.SyncStatus.Uninitialized,this.t=this.J.getNumber(s,m.StorageScope.APPLICATION,void 0),this.B((0,k.$Sc)(()=>this.cb())),this.B(new a.$Rh(()=>this.W(),5*1e3)).schedule()}async createSyncTask(S,v){this.db(),this.H.info("Sync started.");const L=new Date().getTime(),U=(0,I.$2g)();try{const V=(0,t.$Vnb)(U);v&&(V["Cache-Control"]="no-cache"),S=await this.D.manifest(S,V)}catch(V){const x=t.$Wnb.toUserDataSyncError(V);throw y(x,U,this.F,this.I),x}const F=!1,M=this;let K;return{manifest:S,async run(){if(F)throw new Error("Can run a task only once");K=(0,a.$sh)(V=>M.P(S,!1,U,V)),await K.finally(()=>K=void 0),M.H.info(`Sync done. Took ${new Date().getTime()-L}ms`),M.ab()},stop(){return K?.cancel(),M.U()}}}async createManualSyncTask(){if(this.db(),this.L.isEnabled())throw new t.$Wnb("Cannot start manual sync when sync is enabled",t.UserDataSyncErrorCode.LocalError);this.H.info("Sync started.");const S=new Date().getTime(),v=(0,I.$2g)(),L=(0,t.$Vnb)(v);let U;try{U=await this.D.manifest(null,L)}catch(K){const V=t.$Wnb.toUserDataSyncError(K);throw y(V,v,this.F,this.I),V}await this.resetLocal();const F=this,M=new C.$we;return{id:v,async merge(){return F.P(U,!0,v,M.token)},async apply(){try{try{await F.R(U,v,M.token)}catch(K){if(t.$Wnb.toUserDataSyncError(K).code===t.UserDataSyncErrorCode.MethodNotFound)F.H.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.H.info("Applying manual sync again..."),await F.R(U,v,M.token);else throw K}}catch(K){throw F.H.error(K),K}F.H.info(`Sync done. Took ${new Date().getTime()-S}ms`),F.ab()},async stop(){M.cancel(),await F.U(),await F.resetLocal()}}}async P(S,v,L,U){this.n=[];try{this.status!==t.SyncStatus.HasConflicts&&this.Z(t.SyncStatus.Syncing);const F=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(F,S,v,L,U));const M=F.enabled.find(K=>K.resource===t.SyncResource.Profiles);if(M){const K=await M.getLastSyncedProfiles()||[];if(U.isCancellationRequested)return;await this.Q(K,S,v,L,U)}}finally{this.status!==t.SyncStatus.HasConflicts&&this.Z(t.SyncStatus.Idle),this.r.fire(this.n)}}async Q(S,v,L,U,F){for(const M of S){if(F.isCancellationRequested)return;const K=this.M.profiles.find(x=>x.id===M.id);if(!K){this.H.error(`Profile with id:${M.id} and name: ${M.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",M.name);const V=this.getOrCreateActiveProfileSynchronizer(K,M);this.n.push(...await this.S(V,v,L,U,F))}for(const[M,K]of this.z.entries())this.M.profiles.some(V=>V.id===K[0].profile.id)||(await K[0].resetLocal(),K[1].dispose(),this.z.delete(M))}async R(S,v,L){const U=this.bb();for(const x of U){if(L.isCancellationRequested)return;await x.apply(v,L)}const F=U.find(x=>x.profile.isDefault);if(!F)return;const M=F.enabled.find(x=>x.resource===t.SyncResource.Profiles);if(!M)return;const V=(await M.getRemoteSyncedProfiles(S?.latest??null)||[]).filter(x=>U.every(H=>H.profile.id!==x.id));V.length&&await this.Q(V,S,!1,v,L)}async S(S,v,L,U,F){return(await S.sync(v,L,U,F)).map(([K,V])=>({profile:S.profile,syncResource:K,error:V}))}async U(){this.status!==t.SyncStatus.Idle&&await Promise.allSettled(this.bb().map(S=>S.stop()))}async resolveContent(S){const v=await this.N.resolveContent(S);if(v)return v;for(const L of this.bb())for(const U of L.enabled){const F=await U.resolveContent(S);if(F)return F}return null}async replace(S){this.db();const v=this.N.resolveUserDataSyncResource(S);if(!v)return;const L=await this.resolveContent(S.uri);L&&await this.X(v.profile,async U=>{if(v.syncResource===U.resource)return await U.replace(L),!0})}async accept(S,v,L,U){this.db(),await this.X(S.profile,async F=>{if(S.syncResource===F.resource)return await F.accept(v,L),U&&await F.apply((0,b.$kg)(U)?!1:U.force,(0,t.$Vnb)((0,I.$2g)())),!0})}async hasLocalData(){return!!await this.X(this.M.defaultProfile,async v=>{if(v.resource!==t.SyncResource.GlobalState&&await v.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.X(this.M.defaultProfile,async v=>{if(await v.hasPreviouslySynced())return!0})}async reset(){this.db(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.db();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(S){this.H.error(S)}this.y.fire()}async resetLocal(){this.db(),this.t=void 0,this.J.remove(s,m.StorageScope.APPLICATION);for(const[S]of this.z.values())try{await S.resetLocal()}catch(v){this.H.error(v)}this.cb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async W(){const S=this.J.keys(m.StorageScope.APPLICATION,m.StorageTarget.MACHINE),v=[];for(const U of S){if(!U.endsWith(".lastSyncUserData"))continue;const F=U.split(".");F.length===3&&v.push([U,F[0]])}if(!v.length)return;const L=new k.$Tc;try{let U=this.z.get(this.M.defaultProfile.id)?.[0];U||(U=L.add(this.G.createInstance(o,this.M.defaultProfile,void 0)));const F=U.enabled.find(V=>V.resource===t.SyncResource.Profiles);if(!F)return;const K=(await F.getLastSyncedProfiles())?.map(V=>V.collection)??[];for(const[V,x]of v)K.includes(x)||(this.H.info(`Removing last sync state for stale profile: ${x}`),this.J.remove(V,m.StorageScope.APPLICATION))}finally{L.dispose()}}async cleanUpRemoteData(){const S=await this.N.getRemoteSyncedProfiles(),v=S.map(M=>M.collection),L=await this.D.getAllCollections(),U=L.filter(M=>!v.includes(M));U.length&&(this.H.info(`Deleting ${U.length} redundant collections on server`),await Promise.allSettled(U.map(M=>this.D.deleteCollection(M))),this.H.info("Deleted redundant collections on server"));const F=S.filter(M=>L.includes(M.collection));if(F.length!==S.length){const M=this.G.createInstance(n.$1ec,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await M.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await M.updateRemoteProfiles(F,null),this.H.info("Updated remote profiles on server")}finally{M.dispose()}}}async saveRemoteActivityData(S){this.db();const v=await this.D.getActivityData();await this.C.writeFile(S,v)}async extractActivityData(S,v){const L=(await this.C.readFile(S)).value.toString(),U=JSON.parse(L);if(U.resources)for(const F in U.resources)for(const M of U.resources[F])await this.O.writeResource(F,M.content,new Date(M.created*1e3),void 0,v);if(U.collections)for(const F in U.collections)for(const M in U.collections[F].resources)for(const K of U.collections[F].resources?.[M]??[])await this.O.writeResource(M,K.content,new Date(K.created*1e3),F,v)}async X(S,v){const L=new k.$Tc;try{const U=this.z.get(S.id);if(U){const x=await this.Y(U[0],v,L);return(0,b.$lg)(x)?null:x}if(S.isDefault){const x=L.add(this.G.createInstance(o,S,void 0)),H=await this.Y(x,v,L);return(0,b.$lg)(H)?null:H}if(this.M.isEnabled())return null;const F=L.add(this.G.createInstance(n.$1ec,S,void 0)),M=await this.D.manifest(null),V=(await F.getRemoteSyncedProfiles(M?.latest??null)||[]).find(x=>x.id===S.id);if(V){const x=L.add(this.G.createInstance(o,S,V.collection)),H=await this.Y(x,v,L);return(0,b.$lg)(H)?null:H}return null}finally{L.dispose()}}async Y(S,v,L){const U=[...S.enabled,...S.disabled.reduce((F,M)=>(M!==t.SyncResource.WorkspaceState&&F.push(L.add(S.createSynchronizer(M))),F),[])];for(const F of U){const M=await v(F);if(!(0,b.$lg)(M))return M}}Z(S){const v=this.f;this.f!==S&&(this.f=S,this.g.fire(S),v===t.SyncStatus.HasConflicts&&this.ab())}$(){const S=this.bb().map(v=>v.conflicts).flat();(0,R.$tb)(this.j,S,(v,L)=>v.profile.id===L.profile.id&&v.syncResource===L.syncResource&&(0,R.$tb)(v.conflicts,L.conflicts,(U,F)=>(0,O.$_g)(U.previewResource,F.previewResource)))||(this.j=S,this.m.fire(S))}ab(){this.status===t.SyncStatus.Idle&&(this.t=new Date().getTime(),this.J.store(s,this.t,m.StorageScope.APPLICATION,m.StorageTarget.MACHINE),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(S,v){let L=this.z.get(S.id);if(L&&L[0].collection!==v?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),L[1].dispose(),L=void 0,this.z.delete(S.id)),!L){const U=new k.$Tc,F=U.add(this.G.createInstance(o,S,v?.collection));U.add(F.onDidChangeStatus(M=>this.Z(M))),U.add(F.onDidChangeConflicts(M=>this.$())),U.add(F.onDidChangeLocal(M=>this.h.fire(M))),this.z.set(S.id,L=[F,U])}return L[0]}bb(){const S=[];for(const[v]of this.z.values())S.push(v);return S}cb(){this.z.forEach(([,S])=>S.dispose()),this.z.clear()}db(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$4ec=r,e.$4ec=r=ve([Z(0,g.$al),Z(1,t.$Rnb),Z(2,t.$Qnb),Z(3,l.$Ei),Z(4,t.$7nb),Z(5,E.$_l),Z(6,m.$iq),Z(7,t.$2nb),Z(8,f.$Ml),Z(9,t.$4nb),Z(10,t.$Snb)],r);let o=class extends k.$Uc{get enabled(){return this.f.sort((S,v)=>S[1]-v[1]).map(([S])=>S)}get disabled(){return t.$Nnb.filter(S=>!this.r.isResourceEnabled(S))}get status(){return this.g}get conflicts(){return this.m}constructor(S,v,L,U,F,M,K,V,x,H){super(),this.profile=S,this.collection=v,this.r=L,this.t=U,this.u=F,this.w=M,this.y=K,this.z=V,this.C=x,this.D=H,this.f=[],this.g=t.SyncStatus.Idle,this.h=this.B(new T.$le),this.onDidChangeStatus=this.h.event,this.j=this.B(new T.$le),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new T.$le),this.onDidChangeConflicts=this.n.event,this.B(L.onDidChangeResourceEnablement(([te,B])=>this.F(te,B))),this.B((0,k.$Sc)(()=>this.f.splice(0,this.f.length).forEach(([,,te])=>te.dispose())));for(const te of t.$Nnb)L.isResourceEnabled(te)&&this.G(te)}F(S,v){v?this.G(S):this.H(S)}G(S){if(this.f.some(([F])=>F.resource===S))return;if(S===t.SyncResource.Extensions&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(S===t.SyncResource.Profiles&&(!this.profile.isDefault||!this.C.isEnabled())||S===t.SyncResource.WorkspaceState)return;if(S!==t.SyncResource.Profiles&&this.profile.useDefaultFlags?.[S]){this.z.debug(`Skipping syncing ${S} in ${this.profile.name} because it is already synced by default profile`);return}const v=new k.$Tc,L=v.add(this.createSynchronizer(S));v.add(L.onDidChangeStatus(()=>this.L())),v.add(L.onDidChangeConflicts(()=>this.M())),v.add(L.onDidChangeLocal(()=>this.j.fire(S)));const U=this.N(S);this.f.push([L,U,v])}H(S){const v=this.f.findIndex(([L])=>L.resource===S);if(v!==-1){const[[L,,U]]=this.f.splice(v,1);U.dispose(),this.L(),L.stop().then(null,F=>this.z.error(F))}}createSynchronizer(S){switch(S){case t.SyncResource.Settings:return this.t.createInstance(c.$$cc,this.profile,this.collection);case t.SyncResource.Keybindings:return this.t.createInstance(p.$8cc,this.profile,this.collection);case t.SyncResource.Snippets:return this.t.createInstance(h.$ddc,this.profile,this.collection);case t.SyncResource.Tasks:return this.t.createInstance(i.$gdc,this.profile,this.collection);case t.SyncResource.GlobalState:return this.t.createInstance(P.$oOb,this.profile,this.collection);case t.SyncResource.Extensions:return this.t.createInstance(w.$3cc,this.profile,this.collection);case t.SyncResource.Profiles:return this.t.createInstance(n.$1ec,this.profile,this.collection)}}async sync(S,v,L,U){if(U.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const M=[],K=(0,t.$Vnb)(L),V=(this.collection?S?.collections?.[this.collection]?.latest:S?.latest)??null,x=v?await this.I(V):{};for(const H of F){if(U.isCancellationRequested)return[];if(!this.r.isResourceEnabled(H.resource))return[];try{if(v){const te=await H.preview(V,x,K);if(te)for(const B of te.resourcePreviews)(B.localChange!==t.Change.None||B.remoteChange!==t.Change.None)&&B.mergeState===t.MergeState.Preview&&await H.merge(B.previewResource)}else await H.sync(V,K)}catch(te){const B=t.$Wnb.toUserDataSyncError(te);if(y(B,L,this.w,this.y),u(te))throw B;this.z.error(te),this.z.error(`${H.resource}: ${(0,A.$qj)(te)}`),M.push([H.resource,B])}}return M}finally{this.L()}}async apply(S,v){const L=(0,t.$Vnb)(S);for(const U of this.enabled){if(v.isCancellationRequested)return;try{await U.apply(!1,L)}catch(F){const M=t.$Wnb.toUserDataSyncError(F);if(y(M,S,this.w,this.y),u(F))throw M;this.z.error(F),this.z.error(`${U.resource}: ${(0,A.$qj)(F)}`)}}}async stop(){for(const S of this.enabled)try{S.status!==t.SyncStatus.Idle&&await S.stop()}catch(v){this.z.error(v)}}async resetLocal(){for(const S of this.enabled)try{await S.resetLocal()}catch(v){this.z.error(`${S.resource}: ${(0,A.$qj)(v)}`),this.z.error(v)}}async I(S){if(!this.profile.isDefault)return{};const v=this.D.getValue(t.$Jnb),L=this.enabled.find(U=>U instanceof c.$$cc);if(L){const U=await L.getRemoteUserDataSyncConfiguration(S);return{...v,...U}}return v}J(S){this.g!==S&&(this.g=S,this.h.fire(S))}L(){return this.M(),this.enabled.some(S=>S.status===t.SyncStatus.HasConflicts)?this.J(t.SyncStatus.HasConflicts):this.enabled.some(S=>S.status===t.SyncStatus.Syncing)?this.J(t.SyncStatus.Syncing):this.J(t.SyncStatus.Idle)}M(){const S=this.enabled.filter(v=>v.status===t.SyncStatus.HasConflicts).filter(v=>v.conflicts.conflicts.length>0).map(v=>v.conflicts);(0,R.$tb)(this.m,S,(v,L)=>v.syncResource===L.syncResource&&(0,R.$tb)(v.conflicts,L.conflicts,(U,F)=>(0,O.$_g)(U.previewResource,F.previewResource)))||(this.m=S,this.n.fire(S))}N(S){switch(S){case t.SyncResource.Settings:return 0;case t.SyncResource.Keybindings:return 1;case t.SyncResource.Snippets:return 2;case t.SyncResource.Tasks:return 3;case t.SyncResource.GlobalState:return 4;case t.SyncResource.Extensions:return 5;case t.SyncResource.Profiles:return 6;case t.SyncResource.WorkspaceState:return 7}}};o=ve([Z(2,t.$2nb),Z(3,l.$Ei),Z(4,d.$lp),Z(5,t.$Qnb),Z(6,E.$_l),Z(7,t.$7nb),Z(8,f.$Ml),Z(9,$.$_i)],o);function u(N){if(N instanceof t.$Wnb)switch(N.code){case t.UserDataSyncErrorCode.MethodNotFound:case t.UserDataSyncErrorCode.TooLarge:case t.UserDataSyncErrorCode.TooManyRequests:case t.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case t.UserDataSyncErrorCode.LocalTooManyRequests:case t.UserDataSyncErrorCode.LocalTooManyProfiles:case t.UserDataSyncErrorCode.Gone:case t.UserDataSyncErrorCode.UpgradeRequired:case t.UserDataSyncErrorCode.IncompatibleRemoteContent:case t.UserDataSyncErrorCode.IncompatibleLocalContent:return!0}return!1}function y(N,S,v,L){L.publicLog2("sync/error",{code:N.code,serverCode:N instanceof t.$Xnb?String(N.serverCode):void 0,url:N instanceof t.$Xnb?N.url:void 0,resource:N.resource,executionId:S,service:v.userDataSyncStore.url.toString()})}}),define(he[233],ue([0,1,3,2,9,19,24]),function(ae,e,R,a,C,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qic=e.$pic=void 0;function k(d,g){return{...d,profile:(0,A.$Nl)(d.profile,g.profilesHome.scheme)}}function O(d){return{created:d.created,uri:C.URI.revive(d.uri)}}class b{constructor(g,l,m){this.c=g,this.d=l,this.f=m,this.a=new Map,this.b=new R.$le}listen(g,l){switch(l){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${l}`)}async call(g,l,m){try{return await this.g(g,l,m)}catch(E){throw this.f.error(E),E}}async g(g,l,m){switch(l){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(C.URI.revive(m[0]));case"accept":return this.c.accept(k(m[0],this.d),C.URI.revive(m[1]),m[2],m[3]);case"replace":return this.c.replace(O(m[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(C.URI.revive(m[0]));case"extractActivityData":return this.c.extractActivityData(C.URI.revive(m[0]),C.URI.revive(m[1]));case"createManualSyncTask":return this.i()}if(l.startsWith("manualSync/")){const E=l.substring(11),f=m[0],w=this.h(f);switch(m=m.slice(1),E){case"merge":return w.merge();case"apply":return w.apply().then(()=>this.a.delete(this.j(w.id)));case"stop":return w.stop().finally(()=>this.a.delete(this.j(w.id)))}}throw new Error("Invalid call")}h(g){const l=this.a.get(this.j(g));if(!l)throw new Error(`Manual sync taks not found: ${g}`);return l}async i(){const g=await this.c.createManualSyncTask();return this.a.set(this.j(g.id),g),g.id}j(g){return`manualSyncTask-${g}`}}e.$pic=b;let I=class extends a.$Uc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(g,l){super(),this.n=l,this.b=T.SyncStatus.Uninitialized,this.c=this.B(new R.$le),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new R.$le),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new R.$le),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new R.$le),this.onSyncErrors=this.m.event,this.a={call(m,E,f){return g.call(m,E,f).then(null,w=>{throw T.$Wnb.toUserDataSyncError(w)})},listen(m,E){return g.listen(m,E)}},this.a.call("_getInitialData").then(([m,E,f])=>{this.s(m),this.t(E),f&&this.u(f),this.B(this.a.listen("onDidChangeStatus")(w=>this.s(w))),this.B(this.a.listen("onDidChangeLastSyncTime")(w=>this.u(w)))}),this.B(this.a.listen("onDidChangeConflicts")(m=>this.t(m))),this.B(this.a.listen("onSyncErrors")(m=>this.m.fire(m.map(E=>({...E,error:T.$Wnb.toUserDataSyncError(E.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const g=await this.a.call("createManualSyncTask"),l=this;return new $(g,{async call(E,f,w){return l.a.call(`manualSync/${E}`,[g,...Array.isArray(f)?f:[f]],w)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(g,l,m,E){return this.a.call("accept",[g,l,m,E])}resolveContent(g){return this.a.call("resolveContent",[g])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(g){return this.a.call("replace",[g])}saveRemoteActivityData(g){return this.a.call("getRemoteActivityData",[g])}extractActivityData(g,l){return this.a.call("extractActivityData",[g,l])}async s(g){this.b=g,this.c.fire(g)}async t(g){this.f=g.map(l=>({syncResource:l.syncResource,profile:(0,A.$Nl)(l.profile,this.n.profilesHome.scheme),conflicts:l.conflicts.map(m=>({...m,baseResource:C.URI.revive(m.baseResource),localResource:C.URI.revive(m.localResource),remoteResource:C.URI.revive(m.remoteResource),previewResource:C.URI.revive(m.previewResource)}))})),this.g.fire(this.f)}u(g){this.h!==g&&(this.h=g,this.j.fire(g))}};e.$qic=I,e.$qic=I=ve([Z(1,A.$Ml)],I);class $ extends a.$Uc{constructor(g,l){super(),this.id=g,this.a=l}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(he[126],ue([0,1,6,25,8,3,2,134,5,20,12,9,32,21,15,7,23,61,49,16,24]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f,w,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eOb=e.$dOb=e.$cOb=e.$bOb=e.$aOb=void 0;const c="configurationSync.store",h="sync.previous.store",i="sync.donot-make-requests-until",n="sync.user-session-id",t="sync.machine-session-id",s=100,r=1e3*60*5;let o=class extends T.$Uc{get userDataSyncStore(){return this.b}get c(){return this.h.get(p.$Znb,P.StorageScope.APPLICATION)}set c(L){this.h.store(p.$Znb,L,P.StorageScope.APPLICATION,O.$p?P.StorageTarget.USER:P.StorageTarget.MACHINE)}constructor(L,U,F){super(),this.f=L,this.g=U,this.h=F,this.a=this.B(new A.$le),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const M=this.B(new T.$Tc);this.B(A.Event.filter(F.onDidChangeValue(P.StorageScope.APPLICATION,p.$Znb,M),()=>this.c!==this.userDataSyncStore?.type,M)(()=>this.j()))}j(){this.b=this.m(this.f[c]),this.a.fire()}m(L){if(L&&(L=O.$p&&L.web?{...L,...L.web}:L,(0,I.$eg)(L.url)&&(0,I.$gg)(L.authenticationProviders)&&Object.keys(L.authenticationProviders).every(U=>Array.isArray(L.authenticationProviders[U].scopes)))){const U=L,F=!!U.canSwitch,M=U.url===U.insidersUrl?"insiders":"stable",K=(F?this.c:void 0)||M,V=K==="insiders"?U.insidersUrl:K==="stable"?U.stableUrl:U.url;return{url:$.URI.parse(V),type:K,defaultType:M,defaultUrl:$.URI.parse(U.url),stableUrl:$.URI.parse(U.stableUrl),insidersUrl:$.URI.parse(U.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(U.authenticationProviders).reduce((x,H)=>(x.push({id:H,scopes:U.authenticationProviders[H].scopes}),x),[])}}}};e.$aOb=o,e.$aOb=o=ve([Z(0,E.$tk),Z(1,g.$_i),Z(2,P.$iq)],o);let u=class extends o{constructor(L,U,F){super(L,U,F);const M=this.h.get(h,P.StorageScope.APPLICATION);M&&(this.n=JSON.parse(M));const K=this.f[c];K?this.h.store(h,JSON.stringify(K),P.StorageScope.APPLICATION,P.StorageTarget.MACHINE):this.h.remove(h,P.StorageScope.APPLICATION)}async switch(L){L!==this.c&&(this.c=L,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$bOb=u,e.$bOb=u=ve([Z(0,E.$tk),Z(1,g.$_i),Z(2,P.$iq)],u);let y=class extends T.$Uc{get donotMakeRequestsUntil(){return this.j}constructor(L,U,F,M,K,V,x){super(),this.n=F,this.r=M,this.s=x,this.g=this.B(new A.$le),this.onTokenFailed=this.g.event,this.h=this.B(new A.$le),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new A.$le),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(L),this.c=(0,w.$oq)(K,V,x).then(H=>{const te={"X-Client-Name":`${U.applicationName}${O.$p?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(te["X-Client-Commit"]=U.commit),te}),this.f=new S(s,r,this.n,this.r),this.u(),this.B((0,T.$Sc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(L,U){this.b={token:L,type:U}}t(L){this.a=L?(0,b.$gh)(L,"v1"):void 0}u(){const L=this.s.getNumber(i,P.StorageScope.APPLICATION);L&&Date.now()<L&&this.y(new Date(L))}y(L){this.j?.getTime()!==L?.getTime()&&(this.j=L,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(i,this.j.getTime(),P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),this.w=(0,R.$sh)(U=>(0,R.$Gh)(this.j.getTime()-Date.now(),U).then(()=>this.y(void 0))),this.w.then(null,U=>null)):this.s.remove(i,P.StorageScope.APPLICATION),this.m.fire())}async getAllCollections(L={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,b.$gh)(this.a,"collection").toString();L={...L},L["Content-Type"]="application/json";const F=await this.D(U,{type:"GET",headers:L},[],a.CancellationToken.None);return(await(0,f.$bq)(F))?.map(({id:M})=>M)||[]}async createCollection(L={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,b.$gh)(this.a,"collection").toString();L={...L},L["Content-Type"]=k.$$s.text;const F=await this.D(U,{type:"POST",headers:L},[],a.CancellationToken.None),M=await(0,f.$aq)(F);if(!M)throw new p.$Xnb("Server did not return the collection id",U,p.UserDataSyncErrorCode.NoCollection,F.res.statusCode,F.res.headers[p.$Tnb]);return M}async deleteCollection(L,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=L?(0,b.$gh)(this.a,"collection",L).toString():(0,b.$gh)(this.a,"collection").toString();U={...U},await this.D(F,{type:"DELETE",headers:U},[],a.CancellationToken.None)}async getAllResourceRefs(L,U){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.z(this.a,U,L),M={},K=await this.D(F.toString(),{type:"GET",headers:M},[],a.CancellationToken.None);return(await(0,f.$bq)(K)||[]).map(({url:x,created:H})=>({ref:(0,b.$ih)(F,F.with({path:x})),created:H*1e3}))}async resolveResourceContent(L,U,F,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=(0,b.$gh)(this.z(this.a,F,L),U).toString();M={...M},M["Cache-Control"]="no-cache";const V=await this.D(K,{type:"GET",headers:M},[],a.CancellationToken.None);return await(0,f.$aq)(V)}async deleteResource(L,U,F){if(!this.a)throw new Error("No settings sync store url configured.");const M=U!==null?(0,b.$gh)(this.z(this.a,F,L),U).toString():this.z(this.a,F,L).toString(),K={};await this.D(M,{type:"DELETE",headers:K},[],a.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const L=(0,b.$gh)(this.a,"resource").toString(),U={"Content-Type":k.$$s.text};await this.D(L,{type:"DELETE",headers:U},[],a.CancellationToken.None)}async readResource(L,U,F,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=(0,b.$gh)(this.z(this.a,F,L),"latest").toString();M={...M},M["Cache-Control"]="no-cache",U&&(M["If-None-Match"]=U.ref);const V=await this.D(K,{type:"GET",headers:M},[304],a.CancellationToken.None);let x=null;if(V.res.statusCode===304&&(x=U),x===null){const H=V.res.headers.etag;if(!H)throw new p.$Xnb("Server did not return the ref",K,p.UserDataSyncErrorCode.NoRef,V.res.statusCode,V.res.headers[p.$Tnb]);const te=await(0,f.$aq)(V);if(!te&&V.res.statusCode===304)throw new p.$Xnb("Empty response",K,p.UserDataSyncErrorCode.EmptyResponse,V.res.statusCode,V.res.headers[p.$Tnb]);x={ref:H,content:te}}return x}async writeResource(L,U,F,M,K={}){if(!this.a)throw new Error("No settings sync store url configured.");const V=this.z(this.a,M,L).toString();K={...K},K["Content-Type"]=k.$$s.text,F&&(K["If-Match"]=F);const x=await this.D(V,{type:"POST",data:U,headers:K},[],a.CancellationToken.None),H=x.res.headers.etag;if(!H)throw new p.$Xnb("Server did not return the ref",V,p.UserDataSyncErrorCode.NoRef,x.res.statusCode,x.res.headers[p.$Tnb]);return H}async manifest(L,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,b.$gh)(this.a,"manifest").toString();U={...U},U["Content-Type"]="application/json",L&&(U["If-None-Match"]=L.ref);const M=await this.D(F,{type:"GET",headers:U},[304],a.CancellationToken.None);let K=null;if(M.res.statusCode===304&&(K=L),!K){const x=M.res.headers.etag;if(!x)throw new p.$Xnb("Server did not return the ref",F,p.UserDataSyncErrorCode.NoRef,M.res.statusCode,M.res.headers[p.$Tnb]);const H=await(0,f.$aq)(M);if(!H&&M.res.statusCode===304)throw new p.$Xnb("Empty response",F,p.UserDataSyncErrorCode.EmptyResponse,M.res.statusCode,M.res.headers[p.$Tnb]);H&&(K={...JSON.parse(H),ref:x})}const V=this.s.get(n,P.StorageScope.APPLICATION);return V&&K&&V!==K.session&&this.C(),K===null&&V&&this.C(),K&&this.s.store(n,K.session,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),K}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const L=(0,b.$gh)(this.a,"download").toString(),U={},F=await this.D(L,{type:"GET",headers:U},[],a.CancellationToken.None);if(!(0,f.$0p)(F))throw new p.$Xnb("Server returned "+F.res.statusCode,L,p.UserDataSyncErrorCode.EmptyResponse,F.res.statusCode,F.res.headers[p.$Tnb]);if((0,f.$$p)(F))throw new p.$Xnb("Empty response",L,p.UserDataSyncErrorCode.EmptyResponse,F.res.statusCode,F.res.headers[p.$Tnb]);return F.stream}z(L,U,F){return U?(0,b.$gh)(L,"collection",U,"resource",F):(0,b.$gh)(L,"resource",F)}C(){this.s.remove(n,P.StorageScope.APPLICATION),this.s.remove(t,P.StorageScope.APPLICATION)}async D(L,U,F,M){if(!this.b)throw new p.$Xnb("No Auth Token Available",L,p.UserDataSyncErrorCode.Unauthorized,void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new p.$Xnb(`${U.type} request '${L}' failed because of too many requests (429).`,L,p.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0,void 0);this.y(void 0);const K=await this.c;U.headers={...U.headers||{},...K,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(U.headers),this.r.trace("Sending request to server",{url:L,type:U.type,headers:{...U.headers,authorization:void 0}});let V;try{V=await this.f.request(L,U,M)}catch(z){if(!(z instanceof p.$Xnb)){let _=p.UserDataSyncErrorCode.RequestFailed;const ne=(0,C.$9)(z).toLowerCase();ne.includes("xhr timeout")?_=p.UserDataSyncErrorCode.RequestTimeout:ne.includes("protocol")&&ne.includes("not supported")?_=p.UserDataSyncErrorCode.RequestProtocolNotSupported:ne.includes("request path contains unescaped characters")?_=p.UserDataSyncErrorCode.RequestPathNotEscaped:ne.includes("headers must be an object")?_=p.UserDataSyncErrorCode.RequestHeadersNotObject:(0,C.$3)(z)&&(_=p.UserDataSyncErrorCode.RequestCanceled),z=new p.$Xnb(`Connection refused for the request '${L}'.`,L,_,void 0,void 0)}throw this.r.info("Request failed",L),z}const x=V.res.headers[p.$Tnb],H={url:L,status:V.res.statusCode,"execution-id":U.headers[p.$Unb],"operation-id":x},te=(0,f.$0p)(V)||V.res.statusCode&&F.includes(V.res.statusCode);let B="";if(te?this.r.trace("Request succeeded",H):(B=await(0,f.$_p)(V)||"",this.r.info("Request failed",H,B)),V.res.statusCode===401||V.res.statusCode===403){if(this.b=void 0,V.res.statusCode===401)throw this.g.fire(p.UserDataSyncErrorCode.Unauthorized),new p.$Xnb(`${U.type} request '${L}' failed because of Unauthorized (401).`,L,p.UserDataSyncErrorCode.Unauthorized,V.res.statusCode,x);if(V.res.statusCode===403)throw this.g.fire(p.UserDataSyncErrorCode.Forbidden),new p.$Xnb(`${U.type} request '${L}' failed because the access is forbidden (403).`,L,p.UserDataSyncErrorCode.Forbidden,V.res.statusCode,x)}if(this.h.fire(),V.res.statusCode===404)throw new p.$Xnb(`${U.type} request '${L}' failed because the requested resource is not found (404).`,L,p.UserDataSyncErrorCode.NotFound,V.res.statusCode,x);if(V.res.statusCode===405)throw new p.$Xnb(`${U.type} request '${L}' failed because the requested endpoint is not found (405). ${B}`,L,p.UserDataSyncErrorCode.MethodNotFound,V.res.statusCode,x);if(V.res.statusCode===409)throw new p.$Xnb(`${U.type} request '${L}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,L,p.UserDataSyncErrorCode.Conflict,V.res.statusCode,x);if(V.res.statusCode===410)throw new p.$Xnb(`${U.type} request '${L}' failed because the requested resource is not longer available (410).`,L,p.UserDataSyncErrorCode.Gone,V.res.statusCode,x);if(V.res.statusCode===412)throw new p.$Xnb(`${U.type} request '${L}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,L,p.UserDataSyncErrorCode.PreconditionFailed,V.res.statusCode,x);if(V.res.statusCode===413)throw new p.$Xnb(`${U.type} request '${L}' failed because of too large payload (413).`,L,p.UserDataSyncErrorCode.TooLarge,V.res.statusCode,x);if(V.res.statusCode===426)throw new p.$Xnb(`${U.type} request '${L}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,L,p.UserDataSyncErrorCode.UpgradeRequired,V.res.statusCode,x);if(V.res.statusCode===429){const z=V.res.headers["retry-after"];throw z?(this.y(new Date(Date.now()+parseInt(z)*1e3)),new p.$Xnb(`${U.type} request '${L}' failed because of too many requests (429).`,L,p.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,V.res.statusCode,x)):new p.$Xnb(`${U.type} request '${L}' failed because of too many requests (429).`,L,p.UserDataSyncErrorCode.TooManyRequests,V.res.statusCode,x)}if(!te)throw new p.$Xnb("Server returned "+V.res.statusCode,L,p.UserDataSyncErrorCode.Unknown,V.res.statusCode,x);return V}F(L){let U=this.s.get(t,P.StorageScope.APPLICATION);U===void 0&&(U=(0,d.$2g)(),this.s.store(t,U,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE)),L["X-Machine-Session-Id"]=U;const F=this.s.get(n,P.StorageScope.APPLICATION);F!==void 0&&(L["X-User-Session-Id"]=F)}};e.$cOb=y,e.$cOb=y=ve([Z(1,E.$tk),Z(2,f.$8p),Z(3,p.$7nb),Z(4,l.$Mi),Z(5,m.$al),Z(6,P.$iq)],y);let N=class extends y{constructor(L,U,F,M,K,V,x){super(L.userDataSyncStore?.url,U,F,M,K,V,x),this.B(L.onDidChangeUserDataSyncStore(()=>this.t(L.userDataSyncStore?.url)))}};e.$dOb=N,e.$dOb=N=ve([Z(0,p.$Qnb),Z(1,E.$tk),Z(2,f.$8p),Z(3,p.$7nb),Z(4,l.$Mi),Z(5,m.$al),Z(6,P.$iq)],N);class S{constructor(L,U,F,M){this.c=L,this.d=U,this.f=F,this.g=M,this.a=[],this.b=void 0}request(L,U,F){if(this.h()&&this.i(),U.url=L,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new p.$Xnb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,L,p.UserDataSyncErrorCode.LocalTooManyRequests,void 0,void 0);return this.b=this.b||new Date,this.a.push(L),this.f.request(U,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$eOb=S}),define(he[234],ue([0,1,3,2,9,21,23,16,126]),function(ae,e,R,a,C,A,T,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=e.$nic=e.$mic=e.$lic=void 0;class b{constructor(l){this.a=l}listen(l,m){switch(m){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${m}`)}call(l,m,E){switch(m){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(E)}throw new Error("Invalid call")}}e.$lic=b;class I extends a.$Uc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(l){super(),this.c=l,this.b=this.B(new R.$le),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(m=>{this.a=m,this.B(this.c.listen("onDidChangeAccount")(E=>{this.a=E,this.b.fire(E)}))})}updateAccount(l){return this.c.call("updateAccount",l)}}e.$mic=I;class ${constructor(l){this.a=l}listen(l,m){switch(m){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${m}`)}call(l,m,E){switch(m){case"switch":return this.a.switch(E[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$nic=$;let d=class extends O.$aOb{constructor(l,m,E,f){super(m,E,f),this.n=l,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(l){return this.n.call("switch",[l])}async getPreviousUserDataSyncStore(){const l=await this.n.call("getPreviousUserDataSyncStore");return this.r(l)}r(l){return{url:C.URI.revive(l.url),type:l.type,defaultUrl:C.URI.revive(l.defaultUrl),insidersUrl:C.URI.revive(l.insidersUrl),stableUrl:C.URI.revive(l.stableUrl),canSwitch:l.canSwitch,authenticationProviders:l.authenticationProviders}}};e.$oic=d,e.$oic=d=ve([Z(1,T.$tk),Z(2,A.$_i),Z(3,k.$iq)],d)}),define(he[235],ue([0,1,3,57,23,16,18,230,24,82,86]),function(ae,e,R,a,C,A,T,k,O,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=void 0;let $=class extends k.$5ec{constructor(g,l,m,E,f,w,P,p,c,h,i){super(g,l,m,E,f,P,p,c,h,i),this.B(R.Event.debounce(R.Event.any(R.Event.map(w.onDidFocusMainWindow,()=>"windowFocus"),R.Event.map(w.onDidOpenMainWindow,()=>"windowOpen")),(n,t)=>n?[...n,t]:[t],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$Kic=$,e.$Kic=$=ve([Z(0,C.$tk),Z(1,O.$Qnb),Z(2,O.$Rnb),Z(3,O.$2nb),Z(4,O.$3nb),Z(5,a.$Ggc),Z(6,O.$7nb),Z(7,b.$CMb),Z(8,T.$_l),Z(9,I.$Dnb),Z(10,A.$iq)],$)}),define(he[236],ue([0,1,75,22,5,20]),function(ae,e,R,a,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0,e.$7fc=T,e.$8fc=k,e.$9fc=O,e.$6fc=128/4;function T(b){function I(){let $=b.scheme===a.Schemas.file?(0,A.$7g)(b):b.toString();return C.$l||($=$.toLowerCase()),(0,R.createHash)("md5").update($).digest("hex")}return{id:I(),configPath:b}}function k(b,I){function $(){if(b.scheme!==a.Schemas.file)return(0,R.createHash)("md5").update(b.toString()).digest("hex");if(!I)return;let g;return C.$l?g=I.ino:C.$k?g=I.birthtime.getTime():C.$j&&(typeof I.birthtimeMs=="number"?g=Math.floor(I.birthtimeMs):g=I.birthtime.getTime()),(0,R.createHash)("md5").update(b.fsPath).update(g?String(g):"").digest("hex")}const d=$();if(typeof d=="string")return{id:d,uri:b}}function O(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(he[237],ue([0,1,6,8,2,13,30,15,10,79,115,236,57,56,22]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hic=void 0;let m=class extends C.$Uc{constructor(f,w,P,p){super(),this.a=f,this.b=w,this.c=P,this.f=p,this.B(new R.$Rh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const f=this.a.workspaceStorageHome.with({scheme:l.Schemas.file}).fsPath,w=await T.Promises.readdir(f),P=new b.$bNb(this.f.getChannel("storage"));await Promise.all(w.map(async p=>{const c=(0,A.$jc)(f,p);p.length===$.$6fc||p===I.$Ri.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===p)||await P.isUsed(c)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${p} as it seems to be an unused empty workspace.`),await T.Promises.rm(c))}))}catch(f){(0,a.$Y)(f)}}};e.$hic=m,e.$hic=m=ve([Z(0,k.$Ni),Z(1,O.$ak),Z(2,d.$Ggc),Z(3,g.$Yhc)],m)}),define(he[127],ue([0,1,75,67,38,245,14,8,3,2,13,5,32,42,69]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$wi=e.$vi=e.$ui=void 0,e.$xi=t,e.$yi=s,e.$Ai=u,e.$Bi=y;const m=3e4;class E{traceSocketEvent(S,v){l.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,S,v)}constructor(S,v=""){this.f=!0,this.debugLabel=v,this.socket=S,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=U=>{if(this.traceSocketEvent(l.SocketDiagnosticsEventType.Error,{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,k.$Y)(U)}},this.socket.on("error",this.a);let L;this.b=U=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Close,{hadError:U}),this.f=!1,L&&clearTimeout(L)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,L=setTimeout(()=>S.destroy(),m)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(S){const v=L=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Read,L),S(T.$Ne.wrap(L))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(S){const v=L=>{S({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:L,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(S){const v=()=>{S()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(S){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(l.SocketDiagnosticsEventType.Write,S),this.socket.write(S.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,k.$Y)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,k.$Y)(v)}}end(){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((S,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),S();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),S()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$ui=E;var f;(function(N){N[N.MinHeaderByteSize=2]="MinHeaderByteSize",N[N.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var w;(function(N){N[N.PeekHeader=1]="PeekHeader",N[N.ReadHeader=2]="ReadHeader",N[N.ReadBody=3]="ReadBody",N[N.Fin=4]="Fin"})(w||(w={}));class P extends b.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(S,v){this.socket.traceSocketEvent(S,v)}constructor(S,v,L,U){super(),this.f=this.B(new O.$le),this.g=this.B(new O.$le),this.h=!1,this.j={state:w.PeekHeader,readLen:f.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=S,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:L?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new p(this,v,L,U,this.f,(F,M)=>this.m(F,M))),this.B(this.a.onError(F=>{console.error(F),(0,k.$Y)(F),this.g.fire({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:F})})),this.b=new l.$pi,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await O.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this.f.event(S)}onClose(S){return this.g.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){let v=0;for(;v<S.byteLength;)this.a.writeMessage(S.slice(v,Math.min(v+f.MaxWebSocketMessageLength,S.byteLength)),{compressed:!0,opcode:2}),v+=f.MaxWebSocketMessageLength}m(S,{compressed:v,opcode:L}){if(this.h)return;this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,S);let U=f.MinHeaderByteSize;S.byteLength<126?U+=0:S.byteLength<2**16?U+=2:U+=8;const F=T.$Ne.alloc(U),M=v?64:0,K=L&15;if(F.writeUInt8(128|M|K,0),S.byteLength<126)F.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){F.writeUInt8(126,1);let V=1;F.writeUInt8(S.byteLength>>>8&255,++V),F.writeUInt8(S.byteLength>>>0&255,++V)}else{F.writeUInt8(127,1);let V=1;F.writeUInt8(0,++V),F.writeUInt8(0,++V),F.writeUInt8(0,++V),F.writeUInt8(0,++V),F.writeUInt8(S.byteLength>>>24&255,++V),F.writeUInt8(S.byteLength>>>16&255,++V),F.writeUInt8(S.byteLength>>>8&255,++V),F.writeUInt8(S.byteLength>>>0&255,++V)}this.socket.write(T.$Ne.concat([F,S]))}end(){this.h=!0,this.socket.end()}n(S){if(S.byteLength!==0){for(this.b.acceptChunk(S);this.b.byteLength>=this.j.readLen;)if(this.j.state===w.PeekHeader){const v=this.b.peek(this.j.readLen),L=v.readUInt8(0),U=(L&128)>>>7,F=(L&64)>>>6,M=L&15,K=v.readUInt8(1),V=(K&128)>>>7,x=K&127;this.j.state=w.ReadHeader,this.j.readLen=f.MinHeaderByteSize+(V?4:0)+(x===126?2:0)+(x===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===w.ReadHeader){const v=this.b.read(this.j.readLen),L=v.readUInt8(1),U=(L&128)>>>7;let F=L&127,M=1;F===126?F=v.readUInt8(++M)*2**8+v.readUInt8(++M):F===127&&(F=v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M));let K=0;U&&(K=v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M)),this.j.state=w.ReadBody,this.j.readLen=F,this.j.mask=K,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===w.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),i(v,this.j.mask),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=w.PeekHeader,this.j.readLen=f.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await O.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$vi=P;class p extends b.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Ne.alloc(0)}constructor(S,v,L,U,F,M){super(),this.n=S,this.r=F,this.s=M,this.a=this.B(new O.$le),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new O.$le),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new O.$le),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new c(this.n,U,L,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(K=>this.a.fire(K))),this.B(this.f.onError(K=>this.a.fire(K)))):(this.b=null,this.f=null)}writeMessage(S,v){this.g.push({data:S,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:S,options:v}=this.g.shift();if(this.f&&v.compressed){const L=await this.w(this.f,S);this.s(L,v)}else this.s(S,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(S,v){return new Promise((L,U)=>{S.write(v),S.flush(F=>L(F))})}acceptFrame(S,v,L){this.h.push({data:S,isCompressed:v,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const S=this.h.shift();if(this.b&&S.isCompressed){const v=await this.C(this.b,S.data,S.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(S.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(S,v,L){return new Promise((U,F)=>{S.write(v),L&&S.write(T.$Ne.fromByteArray([0,0,255,255])),S.flush(M=>U(M))})}}class c extends b.$Uc{get recordedInflateBytes(){return this.j?T.$Ne.concat(this.f):T.$Ne.alloc(0)}constructor(S,v,L,U){super(),this.h=S,this.j=v,this.a=this.B(new O.$le),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(U),this.b.on("error",F=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateError,{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateData,F),this.g.push(T.$Ne.wrap(F))}),L&&(this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialWrite,L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(S){this.j&&this.f.push(S.clone()),this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateWrite,S),this.b.write(S.buffer)}flush(S){this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=T.$Ne.concat(this.g);this.g.length=0,S(v)})}}class h extends b.$Uc{constructor(S,v){super(),this.g=S,this.a=this.B(new O.$le),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateError,{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateData,L),this.f.push(T.$Ne.wrap(L))})}write(S){this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateWrite,S.buffer),this.b.write(S.buffer)}flush(S){this.b.flush(2,()=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=T.$Ne.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),S(v)})}}function i(N,S){if(S===0)return;const v=N.byteLength>>>2;for(let V=0;V<v;V++){const x=N.readUInt32BE(V*4);N.writeUInt32BE(x^S,V*4)}const L=v*4,U=N.byteLength-L,F=S>>>24&255,M=S>>>16&255,K=S>>>8&255;U>=1&&N.writeUInt8(N.readUInt8(L)^F,L),U>=2&&N.writeUInt8(N.readUInt8(L+1)^M,L+1),U>=3&&N.writeUInt8(N.readUInt8(L+2)^K,L+2)}e.$wi=process.env.XDG_RUNTIME_DIR;const n={[$.Platform.Linux]:107,[$.Platform.Mac]:103};function t(){const N=(0,d.$2g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${N}-sock`;const S=process.platform!=="darwin"&&e.$wi?e.$wi:(0,C.tmpdir)(),v=(0,I.$jc)(S,`vscode-ipc-${N}.sock`);return r(v),v}function s(N,S,v){const U=(0,R.createHash)("sha256").update(N).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${v}-${S}-sock`;const F=v.substr(0,4),M=S.substr(0,6);let K;return process.platform!=="darwin"&&e.$wi&&!process.env.VSCODE_PORTABLE?K=(0,I.$jc)(e.$wi,`vscode-${U}-${F}-${M}.sock`):K=(0,I.$jc)(N,`${F}-${M}.sock`),r(K),K}function r(N){const S=n[$.$v];typeof S=="number"&&N.length>=S&&console.warn(`WARNING: IPC handle "${N}" is longer than ${S} chars, try a shorter --user-data-dir`)}class o extends g.$ji{static b(S){const v=O.Event.fromNodeEventEmitter(S,"connection");return O.Event.map(v,L=>({protocol:new l.$qi(new E(L,"ipc-server-connection")),onDidClientDisconnect:O.Event.once(O.Event.fromNodeEventEmitter(L,"close"))}))}constructor(S){super(o.b(S)),this.d=S}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$zi=o;function u(N){return new Promise((S,v)=>{const L=(0,a.createServer)();L.on("error",v),L.listen(N,()=>{L.removeListener("error",v),S(new o(L))})})}function y(N,S){return new Promise((v,L)=>{const U=(0,a.createConnection)(N,()=>{U.removeListener("error",L),v(l.$ri.fromSocket(new E(U,`ipc-client${S}`),S))});U.once("error",L)})}}),define(he[238],ue([0,1,67,127,185]),function(ae,e,R,a,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=void 0,R=Oe(R),e.$Nic=new class{supports(A){return!0}connect({host:A,port:T},k,O,b){return new Promise((I,$)=>{const d=R.createConnection({host:A,port:T},()=>{d.removeListener("error",$),d.write((0,C.$Cxb)(k,O,b));const g=l=>{l.toString().indexOf(`\r
\r
`)>=0&&(d.off("data",g),I(new a.$ui(d,b)))};d.on("data",g)});d.setNoDelay(!0),d.once("error",$)})}}}),define(he[239],ue([0,1,67,38,147,127,6,2,5,21,10,23,186,106,108,80,14]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=e.$Rhc=e.$Qhc=e.$Phc=void 0,R=Oe(R),a=Oe(a);async function f(h,i,n,t,s){let r;for(let o=3;o&&(r?.dispose(),r=await new w(h,i,n,t,s).waitForReady(),!(s&&C.$5g[s]||!C.$5g[r.tunnelLocalPort]));o--);return r}class w extends k.$Uc{constructor(i,n,t,s,r){super(),this.m=n,this.n=r,this.privacy=m.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=R.createServer(),this.c=new T.$Eh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.r(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,n=(0,m.$Mw)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,C.$6g)(i,2,1e3,n),s=null;return this.b.listen(t,this.m),await this.c.wait(),s=this.b.address(),s||(t=0,this.b.listen(t,this.m),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async r(i){i.pause();const n=(0,m.$Kw)(this.tunnelRemoteHost)||(0,m.$Mw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,d.$3l)(this.a,n,this.tunnelRemotePort),s=t.getSocket(),r=t.readEntireBuffer();t.dispose(),r.byteLength>0&&i.write(r.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),s.end()}),i.on("close",()=>s.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),s instanceof A.$ui?s.socket.destroy():s.end()}),s instanceof A.$ui?this.t(i,s):this.s(i,s),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),s.end()})}s(i,n){n.onClose(()=>i.destroy()),n.onEnd(()=>i.end()),n.onData(t=>i.write(t.buffer)),i.on("data",t=>n.write(E.$Ne.wrap(t))),i.resume()}t(i,n){const t=n.socket;t.on("end",()=>i.end()),t.on("close",()=>i.end()),t.on("error",()=>{i.destroy()}),t.pipe(i),i.pipe(t)}}e.$Phc=w;let P=class extends m.$Pw{constructor(i,n,t,s,r){super(n,r),this.H=i,this.I=t,this.J=s}isPortPrivileged(i){return(0,m.$Nw)(i,this.t,O.OS,a.release())}F(i,n,t,s,r,o,u,y){const N=this.D(n,t);if(N)return++N.refcount,N.value;if((0,m.$Gw)(i))return this.G(i,n,t,r,o,u,y);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${t} on local port ${r}.`);const S={commit:this.J.commit,quality:this.J.quality,addressProvider:i,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=f(S,s,n,t,r);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(n,t,v),v}}};e.$Qhc=P,e.$Qhc=P=ve([Z(0,g.$Wl),Z(1,I.$ak),Z(2,l.$Zl),Z(3,$.$tk),Z(4,b.$_i)],P);let p=class extends P{constructor(i,n,t,s,r){super(i,n,t,s,r)}};e.$Rhc=p,e.$Rhc=p=ve([Z(0,g.$Wl),Z(1,I.$ak),Z(2,l.$Zl),Z(3,$.$tk),Z(4,b.$_i)],p);let c=class extends k.$Uc{constructor(i,n,t,s,r){super(),this.b=i,this.c=n,this.f=t,this.g=s,this.h=r,this.a=new Map}async openTunnel(i,n,t,s,r,o,u,y,N){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${s} on local port ${o}.`),!this.a.has(i)){const S=new p(this.b,this.c,this.g,this.f,this.h);this.B(S),this.a.set(i,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(n,t,s,r,o,u,y,N)}};e.$Shc=c,e.$Shc=c=ve([Z(0,g.$Wl),Z(1,I.$ak),Z(2,$.$tk),Z(3,l.$Zl),Z(4,b.$_i)],c)});var it=this&&this.__importDefault||function(ae){return ae&&ae.__esModule?ae:{default:ae}};define(he[246],ue([0,1,38,43,8,2,22,9,17,3,42,151,179,180,189,171,237,162,163,21,184,97,196,98,191,15,118,223,27,110,187,117,74,7,173,174,73,4,170,76,78,199,10,175,102,23,61,16,109,18,111,112,113,48,202,85,114,24,82,229,234,212,86,228,232,233,126,62,227,213,108,195,80,239,190,203,28,204,5,205,164,182,181,84,218,19,52,178,58,226,201,214,107,231,219,11,176,101,224,217,192,158,57,177,235,221,56,225,106,104,238,156,193,145,133,144]),function(ae,e,R,a,C,A,T,k,O,b,I,$,d,g,l,m,E,f,w,P,p,c,h,i,n,t,s,r,o,u,y,N,S,v,L,U,F,M,K,V,x,H,te,B,z,_,ne,le,ee,Q,X,q,D,Y,oe,j,W,G,J,ie,ce,ge,pe,Ee,Pe,be,we,Se,re,de,me,Re,ke,De,Te,Ne,Ue,Be,Ve,Me,qe,ze,We,Ce,se,fe,$e,ye,Ae,Le,je,xe,Je,Ye,Ge,_e,Qe,nt,at,Nt,Ct,Lt,Tt,Dt,Ut,Ft,yt,Mt,vt,jt,qt,Bt,ht,zt,Wt,Et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=St,z=it(z);class Vt extends A.$Uc{constructor(Ie){super(),this.f=Ie,this.a=this.B(new $.$0X(this)),this.b=void 0,this.c=this.B(new b.$le),this.g()}g(){let Ie=!1;const Fe=()=>{Ie||(Ie=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Fe),(0,$.$$X)(process.parentPort,ht.$3gc.exit,Fe)}async init(){const Ie=await this.h();(0,G.$Lnb)(),Ie.invokeFunction(Fe=>{const Ke=Fe.get(te.$ak),He=Fe.get(Q.$_l),et=Fe.get(fe.$Ml);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Fe),this.m(Ke),this.n(He,et),this.B(et.onDidChangeProfiles(()=>this.n(He,et))),this.r(He,Ke)}),this.B((0,A.$Rc)(Ie.createInstance(d.$dic,this.f.codeCachePath),Ie.createInstance(g.$eic),Ie.createInstance(E.$hic),Ie.createInstance(m.$gic),Ie.createInstance(l.$fic),Ie.createInstance(Ge.$Eic),Ie.createInstance(xe.$wic)))}async h(){const Ie=new V.$Di,Fe={_serviceBrand:void 0,...z.default};Ie.set(_.$tk,Fe);const Ke=new I.$ni(Ze=>Ze==="main"),He=new yt.$Zhc(this.a,Ke);Ie.set(yt.$Yhc,He);const et=this.f.policiesData?new ye.$thc(this.f.policiesData,He.getChannel("policy")):new Ae.$vo;Ie.set(Ae.$to,et);const Xe=new Bt.$9m(this.f.args,Fe);Ie.set(t.$Ni,Xe);const ot=new B.$ts(void 0,this.f.logLevel,Xe.logsHome,this.f.loggers.map(Ze=>({...Ze,resource:k.URI.revive(Ze.resource)})),He.getChannel("logger"));Ie.set(te.$bk,ot);const ft=this.B(ot.createLogger("sharedprocess",{name:(0,_e.localize)(12197,null)})),$t=this.B(new te.$ik(ft.getLevel())),tt=this.B(new Qe.$KR(ft,[$t]));Ie.set(te.$ak,tt),this.b=this.B(new nt.$Gic(tt)),Ie.set(nt.$Fic,this.b);const st=this.B(new L.$3q(tt));Ie.set(v.$al,st);const pt=this.B(new U.$tr(tt));st.registerProvider(T.Schemas.file,pt);const dt=new Be.$Us(st);Ie.set(Ue.$Kl,dt);const rt=this.B(new Le.$RR(this.f.profiles.all,k.URI.revive(this.f.profiles.home).with({scheme:Xe.userRoamingDataHome.scheme}),He.getChannel("userDataProfiles")));Ie.set(fe.$Ml,rt);const wt=this.B(new Me.$Xhc(T.Schemas.file,this.B(new qe.$tR(He.getChannel(qe.$sR),{pathCaseSensitive:Ve.$l})),T.Schemas.vscodeUserData,rt,dt,tt));st.registerProvider(T.Schemas.vscodeUserData,wt);const ct=this.B(new p.$Xo(rt.defaultProfile.settingsResource,st,et,tt));Ie.set(P.$_i,ct);const bt=new Mt.$Mic(void 0,{defaultProfile:rt.defaultProfile,currentProfile:rt.defaultProfile},He,Xe);Ie.set(le.$iq,bt),this.B((0,A.$Sc)(()=>bt.flush())),await Promise.all([ct.initialize(),bt.initialize()]);const Rt=new Ct.$ds(He.getChannel("request"));Ie.set(ne.$8p,Rt),Ie.set(f.$iic,new F.$Ci(w.$jic,void 0,!1)),Ie.set(We.$ZG,new F.$Ci(ze.$vic,void 0,!1));const It=new Dt.$2hc(-1,He);Ie.set(Tt.$Ggc,It),Ie.set(i.$2o,new F.$Ci(n.$ZR,void 0,!0));const Ht=this.B(new de.$qhc(It)),Kt=new I.$ni(Ze=>Ht.getActiveClientId().then(mt=>Ze===mt));Ie.set(S.$B7b,new Lt.$Iic(this.a.getChannel("extensionRecommendationNotification",Kt)));let gt;const lt=[],Pt=(0,Y.$Jp)(Fe,ct);if((0,Y.$Ep)(Fe,Xe)){const Ze=new q.$jec(tt,ot,Xe,Fe);if(lt.push(Ze),!(0,Y.$Fp)(Fe,Xe)&&Fe.aiConfig?.ariaKey){const mt=new je.$yR(Rt,Pt,"monacoworkbench",null,Fe.aiConfig.ariaKey);this.B((0,A.$Sc)(()=>mt.flush())),lt.push(mt)}gt=new D.$hs({appenders:lt,commonProperties:(0,ee.$vp)((0,R.release)(),(0,R.hostname)(),process.arch,Fe.commit,Fe.version,this.f.machineId,this.f.sqmId,this.f.devDeviceId,Pt),sendErrorTelemetry:!0,piiPaths:(0,Y.$Kp)(Xe)},ct,Fe)}else{gt=Y.$zp;const Ze=Y.$Dp;lt.push(Ze)}this.a.registerChannel("telemetryAppender",new X.$8gc(lt)),Ie.set(Q.$_l,gt);const Jt=new oe.$kic(ct,gt,tt,ot,Xe,Fe);Ie.set(Q.$am,Jt),Ie.set($e.$Jq,new F.$Ci(Nt.$JR,void 0,!0)),Ie.set(Ce.$Nq,new F.$Ci(se.$uhc,void 0,!0)),Ie.set(u.$tq,new F.$Ci(u.$vq,void 0,!0)),Ie.set(N.$Yq,new F.$Ci(N.$Zq,void 0,!0)),Ie.set(o.$lp,new F.$Ci(r.$rq,void 0,!0)),Ie.set(o.$sp,new F.$Ci(Ft.$Lic,void 0,!1)),Ie.set(x.$_r,new F.$Ci(H.$bs,void 0,!1)),Ie.set(c.$Tm,new F.$Ci(h.$2s,void 0,!1)),Ie.set(J.$CMb,new F.$Ci(J.$DMb,void 0,!0)),Ie.set(G.$7nb,new F.$Ci(ge.$9Ob,void 0,!0)),Ie.set(G.$6nb,I.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ze=>Ze.ctx!=="main"))),Ie.set(o.$rp,new F.$Ci(s.$AMb,void 0,!1)),Ie.set(W.$7Ob,new F.$Ci(W.$8Ob,void 0,!0)),Ie.set(j.$qw,new F.$Ci(j.$rw)),Ie.set(G.$Qnb,new F.$Ci(we.$bOb,void 0,!0)),Ie.set(G.$Rnb,new F.$Ci(we.$dOb,void 0,!0)),Ie.set(pe.$Dnb,new F.$Ci(pe.$Fnb,void 0,!0)),Ie.set(G.$Snb,new F.$Ci(ie.$Yec,void 0,!1)),Ie.set(G.$2nb,new F.$Ci(Ee.$Nec,void 0,!0)),Ie.set(G.$3nb,new F.$Ci(Pe.$4ec,void 0,!1)),Ie.set(Se.$cNb,new F.$Ci(re.$ric,void 0,!0)),Ie.set(G.$4nb,new F.$Ci(Ye.$Ifc,void 0,!0)),Ie.set(me.$Zl,new F.$Ci(Re.$Uhc,void 0,!1));const Ot=new vt.$Xl;return Ie.set(vt.$Wl,Ot),Ot.register(jt.RemoteConnectionType.WebSocket,qt.$Nic),Ie.set(ke.$Fw,new F.$Ci(De.$Shc)),Ie.set(Te.$sic,new F.$Ci(Ne.$uic)),Ie.set(Je.$xic,new F.$Ci(at.$Hic)),new K.$wr(Ie)}j(Ie){const Fe=new y.$xq(Ie.get(o.$op),()=>null);this.a.registerChannel("extensions",Fe);const Ke=I.ProxyChannel.fromService(Ie.get(x.$_r),this.q);this.a.registerChannel("languagePacks",Ke);const He=I.ProxyChannel.fromService(Ie.get(c.$Tm),this.q);this.a.registerChannel("diagnostics",He);const et=new y.$zq(Ie.get(o.$sp));this.a.registerChannel("extensionTipsService",et);const Xe=I.ProxyChannel.fromService(Ie.get(f.$iic),this.q);this.a.registerChannel("checksum",Xe);const ot=I.ProxyChannel.fromService(Ie.get(We.$ZG),this.q);this.a.registerChannel("v8InspectProfiling",ot);const ft=I.ProxyChannel.fromService(Ie.get(pe.$Dnb),this.q);this.a.registerChannel("userDataSyncMachines",ft);const $t=I.ProxyChannel.fromService(Ie.get(Q.$am),this.q);this.a.registerChannel("customEndpointTelemetry",$t);const tt=new ce.$lic(Ie.get(J.$CMb));this.a.registerChannel("userDataSyncAccount",tt);const st=new ce.$nic(Ie.get(G.$Qnb));this.a.registerChannel("userDataSyncStoreManagement",st);const pt=new be.$pic(Ie.get(G.$3nb),Ie.get(fe.$Ml),Ie.get(te.$ak));this.a.registerChannel("userDataSync",pt);const dt=this.B(Ie.get(M.$Ei).createInstance(Ut.$Kic));this.a.registerChannel("userDataAutoSync",I.ProxyChannel.fromService(dt,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",I.ProxyChannel.fromService(Ie.get(G.$4nb),this.q));const rt=I.ProxyChannel.fromService(Ie.get(Te.$sic),this.q);this.a.registerChannel(Te.$tic,rt);const wt=I.ProxyChannel.fromService(Ie.get(Je.$xic),this.q);this.a.registerChannel("remoteTunnel",wt)}m(Ie){process.on("uncaughtException",Fe=>(0,C.$Y)(Fe)),process.on("unhandledRejection",Fe=>(0,C.$Y)(Fe)),(0,C.setUnexpectedErrorHandler)(Fe=>{const Ke=(0,a.$qj)(Fe,!0);Ke&&Ie.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(Ie,Fe){Ie.publicLog2("profilesInfo",{count:Fe.profiles.length})}async r(Ie,Fe){if(Ve.$l){const[Ke,He]=await Promise.all([(0,zt.$3g)(Fe.error.bind(Fe)),(0,Et.$RX)(Fe.error.bind(Fe))]),et=(0,Wt.$vX)(),Xe=(0,Et.$SX)(He,this.f.args["ozone-platform"]);Ke&&Ie.publicLog2("clientPlatformInfo",{platformId:Ke.id,platformVersionId:Ke.version_id,platformIdLike:Ke.id_like,desktopEnvironment:et,displayProtocol:He,codeDisplayProtocol:Xe})}}handledClientConnection(Ie){if(Ie.data!==ht.$5gc.response)return!1;const Fe=(0,O.$Nb)(Ie.ports);return Fe?(this.c.fire(Fe),!0):!1}}async function St(ut){try{const Ie=new Vt(ut);process.parentPort.postMessage(ht.$3gc.ipcReady),await Ie.init(),process.parentPort.postMessage(ht.$3gc.initDone)}catch(Ie){process.parentPort.postMessage({error:Ie.toString()})}}const Gt=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",ut=>{clearTimeout(Gt),St(ut.data)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/1d82f317af9c90b96a433fd6a599e4b1d31869a3/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
