/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/platform","vs/base/common/path","vs/base/common/lifecycle","vs/base/common/uri","vs/base/common/event","vs/base/common/strings","vs/base/common/async","vs/base/common/errors","vs/base/common/types","vs/base/common/charCode","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/extpath","fs","vs/base/common/lazy","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/files/common/watcher","vs/base/common/map","vs/base/common/normalization","vs/base/common/resources","vs/base/common/glob","vs/base/node/pfs","vs/base/parts/ipc/common/ipc","vs/base/common/functional","vs/base/common/marshallingIds","vs/base/common/process","vs/base/common/processes","vs/base/common/ternarySearchTree","vs/base/common/network","vs/base/node/extpath","vs/base/parts/sandbox/node/electronTypes","vs/nls","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/symbols","vs/base/common/objects","vs/base/common/uint","vs/base/common/console","vs/base/common/marshalling","os","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/base/common/errorMessage","vs/platform/instantiation/common/instantiation","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/parcel/parcelWatcher","vs/platform/files/node/watcher/watcherStats","vs/platform/files/node/watcher/watcher","util","child_process","@parcel/watcher","vs/platform/files/node/watcher/watcherMain"],_e=function(fe){for(var e=[],_=0,t=fe.length;_<t;_++)e[_]=be[fe[_]];return e};define(be[37],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=_,e.$fb=t,e.$gb=W,e.$hb=j,e.$ib=X,e.$jb=k,e.$kb=L,e.$mb=F,e.$nb=E,e.$ob=v,e.$pb=p,e.$qb=o;function _(r,h){const w=t(r,h);if(w!==-1)return r[w]}function t(r,h,w=r.length-1){for(let l=w;l>=0;l--){const D=r[l];if(h(D))return l}return-1}function W(r,h){const w=j(r,h);return w===-1?void 0:r[w]}function j(r,h,w=0,l=r.length){let D=w,A=l;for(;D<A;){const u=Math.floor((D+A)/2);h(r[u])?D=u+1:A=u}return D-1}function X(r,h){const w=k(r,h);return w===r.length?void 0:r[w]}function k(r,h,w=0,l=r.length){let D=w,A=l;for(;D<A;){const u=Math.floor((D+A)/2);h(r[u])?A=u:D=u+1}return D}function L(r,h,w=0,l=r.length){const D=k(r,h,w,l);return D===r.length?-1:D}class T{static{this.assertInvariants=!1}constructor(h){this.e=h,this.c=0}findLastMonotonous(h){if(T.assertInvariants){if(this.d){for(const l of this.e)if(this.d(l)&&!h(l))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=h}const w=j(this.e,h,this.c);return this.c=w+1,w===-1?void 0:this.e[w]}}e.$lb=T;function F(r,h){if(r.length===0)return;let w=r[0];for(let l=1;l<r.length;l++){const D=r[l];h(D,w)>0&&(w=D)}return w}function E(r,h){if(r.length===0)return;let w=r[0];for(let l=1;l<r.length;l++){const D=r[l];h(D,w)>=0&&(w=D)}return w}function v(r,h){return F(r,(w,l)=>-h(w,l))}function p(r,h){if(r.length===0)return-1;let w=0;for(let l=1;l<r.length;l++){const D=r[l];h(D,r[w])>0&&(w=l)}return w}function o(r,h){for(const w of r){const l=h(w);if(l!==void 0)return l}}}),define(be[11],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var _;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(_||(e.CharCode=_={}))}),define(be[38],_e([0,1]),function(fe,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=t,e.$d=W,e.$e=j,e.$f=X;function t(L,T){const F=Object.create(null);for(const E of L){const v=T(E);let p=F[v];p||(p=F[v]=[]),p.push(E)}return F}function W(L,T){const F=[],E=[];for(const v of L)T.has(v)||F.push(v);for(const v of T)L.has(v)||E.push(v);return{removed:F,added:E}}function j(L,T){const F=[],E=[];for(const[v,p]of L)T.has(v)||F.push(p);for(const[v,p]of T)L.has(v)||E.push(p);return{removed:F,added:E}}function X(L,T){const F=new Set;for(const E of T)L.has(E)&&F.add(E);return F}class k{static{_=Symbol.toStringTag}constructor(T,F){this.b=F,this.a=new Map,this[_]="SetWithKey";for(const E of T)this.add(E)}get size(){return this.a.size}add(T){const F=this.b(T);return this.a.set(F,T),this}delete(T){return this.a.delete(this.b(T))}has(T){return this.a.has(this.b(T))}*entries(){for(const T of this.a.values())yield[T,T]}keys(){return this.values()}*values(){for(const T of this.a.values())yield T}clear(){this.a.clear()}forEach(T,F){this.a.forEach(E=>T.call(F,E,E,this))}[Symbol.iterator](){return this.values()}}e.$g=k}),define(be[39],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=t,e.$$h=W,e.$_h=j;function _(X){return(k,L,T)=>{let F=null,E=null;if(typeof T.value=="function"?(F="value",E=T.value):typeof T.get=="function"&&(F="get",E=T.get),!E)throw new Error("not supported");T[F]=X(E,L)}}function t(X,k,L){let T=null,F=null;if(typeof L.value=="function"?(T="value",F=L.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof L.get=="function"&&(T="get",F=L.get),!F)throw new Error("not supported");const E=`$memoize$${k}`;L[T]=function(...v){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,v)}),this[E]}}function W(X,k,L){return _((T,F)=>{const E=`$debounce$${F}`,v=`$debounce$result$${F}`;return function(...p){this[v]||(this[v]=L?L():void 0),clearTimeout(this[E]),k&&(this[v]=k(this[v],...p),p=[this[v]]),this[E]=setTimeout(()=>{T.apply(this,p),this[v]=L?L():void 0},X)}})}function j(X,k,L){return _((T,F)=>{const E=`$throttle$timer$${F}`,v=`$throttle$result$${F}`,p=`$throttle$lastRun$${F}`,o=`$throttle$pending$${F}`;return function(...r){if(this[v]||(this[v]=L?L():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),k&&(this[v]=k(this[v],...r)),this[o])return;const h=this[p]+X;h<=Date.now()?(this[p]=Date.now(),T.apply(this,[this[v]]),this[v]=L?L():void 0):(this[o]=!0,this[E]=setTimeout(()=>{this[o]=!1,this[p]=Date.now(),T.apply(this,[this[v]]),this[v]=L?L():void 0},h-Date.now()))}})}}),define(be[9],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=t,e.$X=W,e.$Y=j,e.$Z=X,e.$1=k,e.$2=L,e.$3=F,e.$5=v,e.$6=p,e.$7=o,e.$9=h;class _{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?A.isErrorNoTelemetry(n)?new A(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(s=>{s(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$U=_,e.$V=new _;function t(i){e.$V.setUnexpectedErrorHandler(i)}function W(i){if(!i||typeof i!="object")return!1;const n=i;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function j(i){F(i)||e.$V.onUnexpectedError(i)}function X(i){F(i)||e.$V.onUnexpectedExternalError(i)}function k(i){if(i instanceof Error){const{name:n,message:s}=i,c=i.stacktrace||i.stack;return{$isError:!0,name:n,message:s,stack:c,noTelemetry:A.isErrorNoTelemetry(i)}}return i}function L(i){let n;return i.noTelemetry?n=new A:(n=new Error,n.name=i.name),n.message=i.message,n.stack=i.stack,n}const T="Canceled";function F(i){return i instanceof E?!0:i instanceof Error&&i.name===T&&i.message===T}class E extends Error{constructor(){super(T),this.name=this.message}}e.$4=E;function v(){const i=new Error(T);return i.name=i.message,i}function p(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function o(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class r extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=r;function h(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class w extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$0=w;class l extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$$=l;class D extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=D;class A extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof A)return n;const s=new A;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$ab=A;class u extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}e.$bb=u}),define(be[12],_e([0,1,9,37]),function(fe,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=W,e.$sb=j,e.$tb=X,e.$ub=k,e.$vb=L,e.$wb=T,e.$xb=F,e.$yb=E,e.$zb=v,e.$Ab=p,e.$Bb=o,e.$Cb=r,e.$Db=h,e.top=w,e.$Fb=l,e.$Gb=A,e.$Hb=u,e.$Ib=i,e.$Jb=n,e.$Kb=s,e.$Lb=c,e.$Mb=P,e.$Nb=m,e.$Ob=b,e.$Pb=a,e.$Qb=d,e.$Rb=N,e.$Sb=f,e.$Tb=y,e.$Ub=G,e.$Vb=C,e.$Wb=x,e.$Xb=K,e.$Yb=se,e.$Zb=V,e.$1b=ne,e.$2b=ce,e.$3b=re,e.$4b=I,e.$5b=q,e.$6b=Q,e.$9b=ee,e.$ac=Ee;function W(B,z=0){return B[B.length-(1+z)]}function j(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}function X(B,z,O=(g,M)=>g===M){if(B===z)return!0;if(!B||!z||B.length!==z.length)return!1;for(let g=0,M=B.length;g<M;g++)if(!O(B[g],z[g]))return!1;return!0}function k(B,z){const O=B.length-1;z<O&&(B[z]=B[O]),B.pop()}function L(B,z,O){return T(B.length,g=>O(B[g],z))}function T(B,z){let O=0,g=B-1;for(;O<=g;){const M=(O+g)/2|0,Y=z(M);if(Y<0)O=M+1;else if(Y>0)g=M-1;else return M}return-(O+1)}function F(B,z,O){if(B=B|0,B>=z.length)throw new TypeError("invalid index");const g=z[Math.floor(z.length*Math.random())],M=[],Y=[],te=[];for(const ge of z){const De=O(ge,g);De<0?M.push(ge):De>0?Y.push(ge):te.push(ge)}return B<M.length?F(B,M,O):B<M.length+te.length?te[0]:F(B-(M.length+te.length),Y,O)}function E(B,z){const O=[];let g;for(const M of B.slice(0).sort(z))!g||z(g[0],M)!==0?(g=[M],O.push(g)):g.push(M);return O}function*v(B,z){let O,g;for(const M of B)g!==void 0&&z(g,M)?O.push(M):(O&&(yield O),O=[M]),g=M;O&&(yield O)}function p(B,z){for(let O=0;O<=B.length;O++)z(O===0?void 0:B[O-1],O===B.length?void 0:B[O])}function o(B,z){for(let O=0;O<B.length;O++)z(O===0?void 0:B[O-1],B[O],O+1===B.length?void 0:B[O+1])}function r(B,z,O){const g=[];function M(ge,De,Re){if(De===0&&Re.length===0)return;const he=g[g.length-1];he&&he.start+he.deleteCount===ge?(he.deleteCount+=De,he.toInsert.push(...Re)):g.push({start:ge,deleteCount:De,toInsert:Re})}let Y=0,te=0;for(;;){if(Y===B.length){M(Y,0,z.slice(te));break}if(te===z.length){M(Y,B.length-Y,[]);break}const ge=B[Y],De=z[te],Re=O(ge,De);Re===0?(Y+=1,te+=1):Re<0?(M(Y,1,[]),Y+=1):Re>0&&(M(Y,0,[De]),te+=1)}return g}function h(B,z,O){const g=r(B,z,O),M=[],Y=[];for(const te of g)M.push(...B.slice(te.start,te.start+te.deleteCount)),Y.push(...te.toInsert);return{removed:M,added:Y}}function w(B,z,O){if(O===0)return[];const g=B.slice(0,O).sort(z);return D(B,z,g,O,B.length),g}function l(B,z,O,g,M){return O===0?Promise.resolve([]):new Promise((Y,te)=>{(async()=>{const ge=B.length,De=B.slice(0,O).sort(z);for(let Re=O,he=Math.min(O+g,ge);Re<ge;Re=he,he=Math.min(he+g,ge)){if(Re>O&&await new Promise(le=>setTimeout(le)),M&&M.isCancellationRequested)throw new _.$4;D(B,z,De,Re,he)}return De})().then(Y,te)})}function D(B,z,O,g,M){for(const Y=O.length;g<M;g++){const te=B[g];if(z(te,O[Y-1])<0){O.pop();const ge=(0,t.$jb)(O,De=>z(te,De)<0);O.splice(ge,0,te)}}}function A(B){return B.filter(z=>!!z)}function u(B){let z=0;for(let O=0;O<B.length;O++)B[O]&&(B[z]=B[O],z+=1);B.length=z}function i(B,z,O){B.splice(O,0,B.splice(z,1)[0])}function n(B){return!Array.isArray(B)||B.length===0}function s(B){return Array.isArray(B)&&B.length>0}function c(B,z=O=>O){const O=new Set;return B.filter(g=>{const M=z(g);return O.has(M)?!1:(O.add(M),!0)})}function P(B){const z=new Set;return O=>{const g=B(O);return z.has(g)?!1:(z.add(g),!0)}}function m(B,z){return B.length>0?B[0]:z}function b(B,z){return B.length>0?B[B.length-1]:z}function a(B,z,O=(g,M)=>g===M){let g=0;for(let M=0,Y=Math.min(B.length,z.length);M<Y&&O(B[M],z[M]);M++)g++;return g}function d(B,z){let O=typeof z=="number"?B:0;typeof z=="number"?O=B:(O=0,z=B);const g=[];if(O<=z)for(let M=O;M<z;M++)g.push(M);else for(let M=O;M>z;M--)g.push(M);return g}function N(B,z,O){return B.reduce((g,M)=>(g[z(M)]=O?O(M):M,g),Object.create(null))}function f(B,z){return B.push(z),()=>y(B,z)}function y(B,z){const O=B.indexOf(z);if(O>-1)return B.splice(O,1),z}function G(B,z,O){const g=B.slice(0,z),M=B.slice(z);return g.concat(O,M)}function C(B,z){let O;if(typeof z=="number"){let g=z;O=()=>{const M=Math.sin(g++)*179426549;return M-Math.floor(M)}}else O=Math.random;for(let g=B.length-1;g>0;g-=1){const M=Math.floor(O()*(g+1)),Y=B[g];B[g]=B[M],B[M]=Y}}function x(B,z){const O=B.indexOf(z);O>-1&&(B.splice(O,1),B.unshift(z))}function K(B,z){const O=B.indexOf(z);O>-1&&(B.splice(O,1),B.push(z))}function se(B,z){for(const O of z)B.push(O)}function V(B,z){return Array.isArray(B)?B.map(z):z(B)}function ne(B){return Array.isArray(B)?B:[B]}function ce(B){return B[Math.floor(Math.random()*B.length)]}function re(B,z,O){const g=$(B,z),M=B.length,Y=O.length;B.length=M+Y;for(let te=M-1;te>=g;te--)B[te+Y]=B[te];for(let te=0;te<Y;te++)B[te+g]=O[te]}function I(B,z,O,g){const M=$(B,z);let Y=B.splice(M,O);return Y===void 0&&(Y=[]),re(B,M,g),Y}function $(B,z){return z<0?Math.max(z+B.length,0):Math.min(z,B.length)}var S;(function(B){function z(Y){return Y<0}B.isLessThan=z;function O(Y){return Y<=0}B.isLessThanOrEqual=O;function g(Y){return Y>0}B.isGreaterThan=g;function M(Y){return Y===0}B.isNeitherLessOrGreaterThan=M,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(S||(e.CompareResult=S={}));function q(B,z){return(O,g)=>z(B(O),B(g))}function Q(...B){return(z,O)=>{for(const g of B){const M=g(z,O);if(!S.isNeitherLessOrGreaterThan(M))return M}return S.neitherLessOrGreaterThan}}const R=(B,z)=>B-z;e.$7b=R;const J=(B,z)=>(0,e.$7b)(B?1:0,z?1:0);e.$8b=J;function ee(B){return(z,O)=>-B(z,O)}class ie{constructor(z){this.g=z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(z){let O=this.c;for(;O<this.g.length&&z(this.g[O]);)O++;const g=O===this.c?null:this.g.slice(this.c,O);return this.c=O,g}takeFromEndWhile(z){let O=this.d;for(;O>=0&&z(this.g[O]);)O--;const g=O===this.d?null:this.g.slice(O+1,this.d+1);return this.d=O,g}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const z=this.g[this.c];return this.c++,z}removeLast(){const z=this.g[this.d];return this.d--,z}takeCount(z){const O=this.g.slice(this.c,this.c+z);return this.c+=z,O}}e.$0b=ie;class ue{static{this.empty=new ue(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(O=>(z(O),!0))}toArray(){const z=[];return this.iterate(O=>(z.push(O),!0)),z}filter(z){return new ue(O=>this.iterate(g=>z(g)?O(g):!0))}map(z){return new ue(O=>this.iterate(g=>O(z(g))))}some(z){let O=!1;return this.iterate(g=>(O=z(g),!O)),O}findFirst(z){let O;return this.iterate(g=>z(g)?(O=g,!1):!0),O}findLast(z){let O;return this.iterate(g=>(z(g)&&(O=g),!0)),O}findLastMaxBy(z){let O,g=!0;return this.iterate(M=>((g||S.isGreaterThan(z(M,O)))&&(g=!1,O=M),!0)),O}}e.$$b=ue;class ae{constructor(z){this.c=z}static createSortPermutation(z,O){const g=Array.from(z.keys()).sort((M,Y)=>O(z[M],z[Y]));return new ae(g)}apply(z){return z.map((O,g)=>z[this.c[g]])}inverse(){const z=this.c.slice();for(let O=0;O<this.c.length;O++)z[this.c[O]]=O;return new ae(z)}}e.$_b=ae;async function Ee(B,z){return(await Promise.all(B.map(async(g,M)=>({element:g,ok:await z(g,M)})))).find(g=>g.ok)?.element}}),define(be[26],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=_;function _(t,W){const j=this;let X=!1,k;return function(){if(X)return k;if(X=!0,W)try{k=t.apply(j,arguments)}finally{W()}else k=t.apply(j,arguments);return k}}}),define(be[40],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(t){function W(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}t.is=W;const j=Object.freeze([]);function X(){return j}t.empty=X;function*k(n){yield n}t.single=k;function L(n){return W(n)?n:k(n)}t.wrap=L;function T(n){return n||j}t.from=T;function*F(n){for(let s=n.length-1;s>=0;s--)yield n[s]}t.reverse=F;function E(n){return!n||n[Symbol.iterator]().next().done===!0}t.isEmpty=E;function v(n){return n[Symbol.iterator]().next().value}t.first=v;function p(n,s){let c=0;for(const P of n)if(s(P,c++))return!0;return!1}t.some=p;function o(n,s){for(const c of n)if(s(c))return c}t.find=o;function*r(n,s){for(const c of n)s(c)&&(yield c)}t.filter=r;function*h(n,s){let c=0;for(const P of n)yield s(P,c++)}t.map=h;function*w(n,s){let c=0;for(const P of n)yield*s(P,c++)}t.flatMap=w;function*l(...n){for(const s of n)yield*s}t.concat=l;function D(n,s,c){let P=c;for(const m of n)P=s(P,m);return P}t.reduce=D;function*A(n,s,c=n.length){for(s<0&&(s+=n.length),c<0?c+=n.length:c>n.length&&(c=n.length);s<c;s++)yield n[s]}t.slice=A;function u(n,s=Number.POSITIVE_INFINITY){const c=[];if(s===0)return[c,n];const P=n[Symbol.iterator]();for(let m=0;m<s;m++){const b=P.next();if(b.done)return[c,t.empty()];c.push(b.value)}return[c,{[Symbol.iterator](){return P}}]}t.consume=u;async function i(n){const s=[];for await(const c of n)s.push(c);return Promise.resolve(s)}t.asyncToArray=i})(_||(e.Iterable=_={}))}),define(be[16],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class _{constructor(W){this.d=W,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(W){this.c=W}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=_}),define(be[41],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class _{static{this.Undefined=new _(void 0)}constructor(j){this.element=j,this.next=_.Undefined,this.prev=_.Undefined}}class t{constructor(){this.a=_.Undefined,this.b=_.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===_.Undefined}clear(){let j=this.a;for(;j!==_.Undefined;){const X=j.next;j.prev=_.Undefined,j.next=_.Undefined,j=X}this.a=_.Undefined,this.b=_.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,X){const k=new _(j);if(this.a===_.Undefined)this.a=k,this.b=k;else if(X){const T=this.b;this.b=k,k.prev=T,T.next=k}else{const T=this.a;this.a=k,k.next=T,T.prev=k}this.c+=1;let L=!1;return()=>{L||(L=!0,this.e(k))}}shift(){if(this.a!==_.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==_.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==_.Undefined&&j.next!==_.Undefined){const X=j.prev;X.next=j.next,j.next.prev=X}else j.prev===_.Undefined&&j.next===_.Undefined?(this.a=_.Undefined,this.b=_.Undefined):j.next===_.Undefined?(this.b=this.b.prev,this.b.next=_.Undefined):j.prev===_.Undefined&&(this.a=this.a.next,this.a.prev=_.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==_.Undefined;)yield j.element,j=j.next}}e.$5c=t}),define(be[20],_e([0,1]),function(fe,e){"use strict";var _,t,W;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=j,e.$yc=X,e.$zc=k,e.$Ic=A;function j(u,i,n){let s=u.get(i);return s===void 0&&(s=n,u.set(i,s)),s}function X(u){const i=[];return u.forEach((n,s)=>{i.push(`${s} => ${n}`)}),`Map(${u.size}) {${i.join(", ")}}`}function k(u){const i=[];return u.forEach(n=>{i.push(n)}),`Set(${u.size}) {${i.join(", ")}}`}class L{constructor(i,n){this.uri=i,this.value=n}}function T(u){return Array.isArray(u)}class F{static{this.c=i=>i.toString()}constructor(i,n){if(this[_]="ResourceMap",i instanceof F)this.d=new Map(i.d),this.e=n??F.c;else if(T(i)){this.d=new Map,this.e=n??F.c;for(const[s,c]of i)this.set(s,c)}else this.d=new Map,this.e=i??F.c}set(i,n){return this.d.set(this.e(i),new L(i,n)),this}get(i){return this.d.get(this.e(i))?.value}has(i){return this.d.has(this.e(i))}get size(){return this.d.size}clear(){this.d.clear()}delete(i){return this.d.delete(this.e(i))}forEach(i,n){typeof n<"u"&&(i=i.bind(n));for(const[s,c]of this.d)i(c.value,c.uri,this)}*values(){for(const i of this.d.values())yield i.value}*keys(){for(const i of this.d.values())yield i.uri}*entries(){for(const i of this.d.values())yield[i.uri,i.value]}*[(_=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.d)yield[i.uri,i.value]}}e.$Ac=F;class E{constructor(i,n){this[t]="ResourceSet",!i||typeof i=="function"?this.c=new F(i):(this.c=new F(n),i.forEach(this.add,this))}get size(){return this.c.size}add(i){return this.c.set(i,i),this}clear(){this.c.clear()}delete(i){return this.c.delete(i)}forEach(i,n){this.c.forEach((s,c)=>i.call(n,c,c,this))}has(i){return this.c.has(i)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=E;var v;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class p{constructor(){this[W]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(i){return this.c.has(i)}get(i,n=v.None){const s=this.c.get(i);if(s)return n!==v.None&&this.m(s,n),s.value}set(i,n,s=v.None){let c=this.c.get(i);if(c)c.value=n,s!==v.None&&this.m(c,s);else{switch(c={key:i,value:n,next:void 0,previous:void 0},s){case v.None:this.k(c);break;case v.AsOld:this.j(c);break;case v.AsNew:this.k(c);break;default:this.k(c);break}this.c.set(i,c),this.f++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this.c.get(i);if(n)return this.c.delete(i),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const i=this.d;return this.c.delete(i.key),this.l(i),this.f--,i.value}forEach(i,n){const s=this.g;let c=this.d;for(;c;){if(n?i.bind(n)(c.value,c.key,this):i(c.value,c.key,this),this.g!==s)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const i=this,n=this.g;let s=this.d;const c={[Symbol.iterator](){return c},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const P={value:s.key,done:!1};return s=s.next,P}else return{value:void 0,done:!0}}};return c}values(){const i=this,n=this.g;let s=this.d;const c={[Symbol.iterator](){return c},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const P={value:s.value,done:!1};return s=s.next,P}else return{value:void 0,done:!0}}};return c}entries(){const i=this,n=this.g;let s=this.d;const c={[Symbol.iterator](){return c},next(){if(i.g!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const P={value:[s.key,s.value],done:!1};return s=s.next,P}else return{value:void 0,done:!0}}};return c}[(W=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this.d,s=this.size;for(;n&&s>i;)this.c.delete(n.key),n=n.next,s--;this.d=n,this.f=s,n&&(n.previous=void 0),this.g++}i(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this.e,s=this.size;for(;n&&s>i;)this.c.delete(n.key),n=n.previous,s--;this.e=n,this.f=s,n&&(n.next=void 0),this.g++}j(i){if(!this.d&&!this.e)this.e=i;else if(this.d)i.next=this.d,this.d.previous=i;else throw new Error("Invalid list");this.d=i,this.g++}k(i){if(!this.d&&!this.e)this.d=i;else if(this.e)i.previous=this.e,this.e.next=i;else throw new Error("Invalid list");this.e=i,this.g++}l(i){if(i===this.d&&i===this.e)this.d=void 0,this.e=void 0;else if(i===this.d){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.d=i.next}else if(i===this.e){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.e=i.previous}else{const n=i.next,s=i.previous;if(!n||!s)throw new Error("Invalid list");n.previous=s,s.next=n}i.next=void 0,i.previous=void 0,this.g++}m(i,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==v.AsOld&&n!==v.AsNew)){if(n===v.AsOld){if(i===this.d)return;const s=i.next,c=i.previous;i===this.e?(c.next=void 0,this.e=c):(s.previous=c,c.next=s),i.previous=void 0,i.next=this.d,this.d.previous=i,this.d=i,this.g++}else if(n===v.AsNew){if(i===this.e)return;const s=i.next,c=i.previous;i===this.d?(s.previous=void 0,this.d=s):(s.previous=c,c.next=s),i.next=void 0,i.previous=this.e,this.e.next=i,this.e=i,this.g++}}}toJSON(){const i=[];return this.forEach((n,s)=>{i.push([s,n])}),i}fromJSON(i){this.clear();for(const[n,s]of i)this.set(n,s)}}e.$Cc=p;class o extends p{constructor(i,n=1){super(),this.n=i,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(i){this.n=i,this.p()}get ratio(){return this.o}set ratio(i){this.o=Math.min(Math.max(0,i),1),this.p()}get(i,n=v.AsNew){return super.get(i,n)}peek(i){return super.get(i,v.None)}set(i,n){return super.set(i,n,v.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class r extends o{constructor(i,n=1){super(i,n)}q(i){this.h(i)}set(i,n){return super.set(i,n),this.p(),this}}e.$Dc=r;class h extends o{constructor(i,n=1){super(i,n)}q(i){this.i(i)}set(i,n){return this.n<=this.size&&!this.has(i)&&this.q(Math.round(this.n*this.o)-1),super.set(i,n),this}}e.$Ec=h;class w{constructor(){this.c=new Map}add(i){return this.c.set(i,(this.c.get(i)||0)+1),this}delete(i){let n=this.c.get(i)||0;return n===0?!1:(n--,n===0?this.c.delete(i):this.c.set(i,n),!0)}has(i){return this.c.has(i)}}e.$Fc=w;class l{constructor(i){if(this.c=new Map,this.d=new Map,i)for(const[n,s]of i)this.set(n,s)}clear(){this.c.clear(),this.d.clear()}set(i,n){this.c.set(i,n),this.d.set(n,i)}get(i){return this.c.get(i)}getKey(i){return this.d.get(i)}delete(i){const n=this.c.get(i);return n===void 0?!1:(this.c.delete(i),this.d.delete(n),!0)}forEach(i,n){this.c.forEach((s,c)=>{i.call(n,s,c,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=l;class D{constructor(){this.c=new Map}add(i,n){let s=this.c.get(i);s||(s=new Set,this.c.set(i,s)),s.add(n)}delete(i,n){const s=this.c.get(i);s&&(s.delete(n),s.size===0&&this.c.delete(i))}forEach(i,n){const s=this.c.get(i);s&&s.forEach(n)}get(i){const n=this.c.get(i);return n||new Set}}e.$Hc=D;function A(u,i){if(u===i)return!0;if(u.size!==i.size)return!1;for(const[n,s]of u)if(!i.has(n)||i.get(n)!==s)return!1;for(const[n]of i)if(!u.has(n))return!1;return!0}}),define(be[4],_e([0,1,12,38,20,26,40]),function(fe,e,_,t,W,j,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=F,e.$Lc=E,e.$Mc=v,e.$Nc=r,e.$Oc=h,e.$Pc=w,e.$Qc=l,e.$Rc=D,e.$Sc=A,e.$3c=d;const k=!1;let L=null;class T{constructor(){this.b=new Map}static{this.a=0}c(y){let G=this.b.get(y);return G||(G={parent:null,source:null,isSingleton:!1,value:y,idx:T.a++},this.b.set(y,G)),G}trackDisposable(y){const G=this.c(y);G.source||(G.source=new Error().stack)}setParent(y,G){const C=this.c(y);C.parent=G}markAsDisposed(y){this.b.delete(y)}markAsSingleton(y){this.c(y).isSingleton=!0}f(y,G){const C=G.get(y);if(C)return C;const x=y.parent?this.f(this.c(y.parent),G):y;return G.set(y,x),x}getTrackedDisposables(){const y=new Map;return[...this.b.entries()].filter(([,C])=>C.source!==null&&!this.f(C,y).isSingleton).flatMap(([C])=>C)}computeLeakingDisposables(y=10,G){let C;if(G)C=G;else{const ne=new Map,ce=[...this.b.values()].filter(I=>I.source!==null&&!this.f(I,ne).isSingleton);if(ce.length===0)return;const re=new Set(ce.map(I=>I.value));if(C=ce.filter(I=>!(I.parent&&re.has(I.parent))),C.length===0)throw new Error("There are cyclic diposable chains!")}if(!C)return;function x(ne){function ce(I,$){for(;I.length>0&&$.some(S=>typeof S=="string"?S===I[0]:I[0].match(S));)I.shift()}const re=ne.source.split(`
`).map(I=>I.trim().replace("at ","")).filter(I=>I!=="");return ce(re,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),re.reverse()}const K=new W.$Hc;for(const ne of C){const ce=x(ne);for(let re=0;re<=ce.length;re++)K.add(ce.slice(0,re).join(`
`),ne)}C.sort((0,_.$5b)(ne=>ne.idx,_.$7b));let se="",V=0;for(const ne of C.slice(0,y)){V++;const ce=x(ne),re=[];for(let I=0;I<ce.length;I++){let $=ce[I];$=`(shared with ${K.get(ce.slice(0,I+1).join(`
`)).size}/${C.length} leaks) at ${$}`;const q=K.get(ce.slice(0,I).join(`
`)),Q=(0,t.$c)([...q].map(R=>x(R)[I]),R=>R);delete Q[ce[I]];for(const[R,J]of Object.entries(Q))re.unshift(`    - stacktraces of ${J.length} other leaks continue with ${R}`);re.unshift($)}se+=`


==================== Leaking disposable ${V}/${C.length}: ${ne.value.constructor.name} ====================
${re.join(`
`)}
============================================================

`}return C.length>y&&(se+=`


... and ${C.length-y} more leaking disposables

`),{leaks:C,details:se}}}e.$Jc=T;function F(f){L=f}if(k){const f="__is_disposable_tracked__";F(new class{trackDisposable(y){const G=new Error("Potentially leaked disposable").stack;setTimeout(()=>{y[f]||console.log(G)},3e3)}setParent(y,G){if(y&&y!==i.None)try{y[f]=!0}catch{}}markAsDisposed(y){if(y&&y!==i.None)try{y[f]=!0}catch{}}markAsSingleton(y){}})}function E(f){return L?.trackDisposable(f),f}function v(f){L?.markAsDisposed(f)}function p(f,y){L?.setParent(f,y)}function o(f,y){if(L)for(const G of f)L.setParent(G,y)}function r(f){return L?.markAsSingleton(f),f}function h(f){return typeof f=="object"&&f!==null&&typeof f.dispose=="function"&&f.dispose.length===0}function w(f){if(X.Iterable.is(f)){const y=[];for(const G of f)if(G)try{G.dispose()}catch(C){y.push(C)}if(y.length===1)throw y[0];if(y.length>1)throw new AggregateError(y,"Encountered errors while disposing of store");return Array.isArray(f)?[]:f}else if(f)return f.dispose(),f}function l(f){for(const y of f)h(y)&&y.dispose();return[]}function D(...f){const y=A(()=>w(f));return o(f,y),y}function A(f){const y=E({dispose:(0,j.$cb)(()=>{v(y),f()})});return y}class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{w(this.f)}finally{this.f.clear()}}add(y){if(!y)return y;if(y===this)throw new Error("Cannot register a disposable on itself!");return p(y,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(y),y}delete(y){if(y){if(y===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(y),y.dispose()}}deleteAndLeak(y){y&&this.f.has(y)&&(this.f.delete(y),p(y,null))}}e.$Tc=u;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,E(this),p(this.q,this)}dispose(){v(this),this.q.dispose()}B(y){if(y===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(y)}}e.$Uc=i;class n{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(y){this.b||y===this.a||(this.a?.dispose(),y&&p(y,this),this.a=y)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const y=this.a;return this.a=void 0,y&&p(y,null),y}}e.$Vc=n;class s{constructor(y){this.a=new n,this.b=!1,this.a.value=y}get value(){return this.a.value}set value(y){this.b||y===this.a.value||(this.a.value=y)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=s;class c{constructor(y){this.b=y,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=c;class P{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(y){let G=y;return this.unset=()=>G=void 0,this.isset=()=>G!==void 0,this.dispose=()=>{G&&(G(),G=void 0,v(this))},this}}e.$Yc=P;class m{constructor(){this.a=new Map}acquire(y,...G){let C=this.a.get(y);C||(C={counter:0,object:this.b(y,...G)},this.a.set(y,C));const{object:x}=C,K=(0,j.$cb)(()=>{--C.counter===0&&(this.c(y,C.object),this.a.delete(y))});return C.counter++,{object:x,dispose:K}}}e.$Zc=m;class b{constructor(y){this.a=y}async acquire(y,...G){const C=this.a.acquire(y,...G);try{return{object:await C.object,dispose:()=>C.dispose()}}catch(x){throw C.dispose(),x}}}e.$1c=b;class a{constructor(y){this.object=y}dispose(){}}e.$2c=a;function d(f){const y=new u;try{f(y)}finally{y.dispose()}}class N{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{w(this.a.values())}finally{this.a.clear()}}has(y){return this.a.has(y)}get size(){return this.a.size}get(y){return this.a.get(y)}set(y,G,C=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),C||this.a.get(y)?.dispose(),this.a.set(y,G)}deleteAndDispose(y){this.a.get(y)?.dispose(),this.a.delete(y)}deleteAndLeak(y){const G=this.a.get(y);return this.a.delete(y),G}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=N}),define(be[27],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var _;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(_||(e.MarshalledId=_={}))}),define(be[21],_e([0,1,20]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=void 0,e.$nm=W,e.$om=X;const t=new _.$Dc(1e4);function W(T){return L(T,"NFC",t)}const j=new _.$Dc(1e4);function X(T){return L(T,"NFD",j)}const k=/[^\u0000-\u0080]/;function L(T,F,E){if(!T)return T;const v=E.get(T);if(v)return v;let p;return k.test(T)?p=T.normalize(F):p=T,E.set(T,p),p}e.$pm=function(){const T=/[\u0300-\u036f]/g;return function(F){return X(F).replace(T,"")}}()}),define(be[2],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=i,e.$E=b,e.$K=a,e.$h="en";let _=!1,t=!1,W=!1,j=!1,X=!1,k=!1,L=!1,T=!1,F=!1,E=!1,v,p=e.$h,o=e.$h,r,h;const w=globalThis;let l;typeof w.vscode<"u"&&typeof w.vscode.process<"u"?l=w.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(l=process);const D=typeof l?.versions?.electron=="string",A=D&&l?.type==="renderer";if(typeof l=="object"){_=l.platform==="win32",t=l.platform==="darwin",W=l.platform==="linux",j=W&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,L=D,F=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.$h,p=e.$h;const d=l.env.VSCODE_NLS_CONFIG;if(d)try{const N=JSON.parse(d);v=N.userLocale,o=N.osLocale,p=N.resolvedLanguage||e.$h,r=N.languagePack?.translationsConfigFile}catch{}X=!0}else typeof navigator=="object"&&!A?(h=navigator.userAgent,_=h.indexOf("Windows")>=0,t=h.indexOf("Macintosh")>=0,T=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,W=h.indexOf("Linux")>=0,E=h?.indexOf("Mobi")>=0,k=!0,p=globalThis._VSCODE_NLS_LANGUAGE||e.$h,v=navigator.language.toLowerCase(),o=v):console.error("Unable to resolve platform.");var u;(function(d){d[d.Web=0]="Web",d[d.Mac=1]="Mac",d[d.Linux=2]="Linux",d[d.Windows=3]="Windows"})(u||(e.Platform=u={}));function i(d){switch(d){case u.Web:return"Web";case u.Mac:return"Mac";case u.Linux:return"Linux";case u.Windows:return"Windows"}}let n=u.Web;t?n=u.Mac:_?n=u.Windows:W&&(n=u.Linux),e.$j=_,e.$k=t,e.$l=W,e.$m=j,e.$n=X,e.$o=L,e.$p=k,e.$q=k&&typeof w.importScripts=="function",e.$r=e.$q?w.origin:void 0,e.$s=T,e.$t=E,e.$u=F,e.$v=n,e.$w=h,e.$x=p;var s;(function(d){function N(){return e.$x}d.value=N;function f(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}d.isDefaultVariant=f;function y(){return e.$x==="en"}d.isDefault=y})(s||(e.Language=s={})),e.$y=v,e.$z=o,e.$A=r,e.$B=typeof w.postMessage=="function"&&!w.importScripts,e.$C=(()=>{if(e.$B){const d=[];w.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let y=0,G=d.length;y<G;y++){const C=d[y];if(C.id===f.data.vscodeScheduleAsyncWork){d.splice(y,1),C.callback();return}}});let N=0;return f=>{const y=++N;d.push({id:y,callback:f}),w.postMessage({vscodeScheduleAsyncWork:y},"*")}}return d=>setTimeout(d)})();var c;(function(d){d[d.Windows=1]="Windows",d[d.Macintosh=2]="Macintosh",d[d.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=t||T?c.Macintosh:_?c.Windows:c.Linux;let P=!0,m=!1;function b(){if(!m){m=!0;const d=new Uint8Array(2);d[0]=1,d[1]=2,P=new Uint16Array(d.buffer)[0]===513}return P}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function a(d){return parseFloat(d)>=20}}),define(be[28],_e([0,1,2]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let t;const W=globalThis.vscode;if(typeof W<"u"&&typeof W.process<"u"){const j=W.process;t={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return _.$j?"win32":_.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.$dc=t.platform,e.$ec=t.arch});var Ye=this&&this.__createBinding||(Object.create?function(fe,e,_,t){t===void 0&&(t=_);var W=Object.getOwnPropertyDescriptor(e,_);(!W||("get"in W?!e.__esModule:W.writable||W.configurable))&&(W={enumerable:!0,get:function(){return e[_]}}),Object.defineProperty(fe,t,W)}:function(fe,e,_,t){t===void 0&&(t=_),fe[t]=e[_]}),Qe=this&&this.__setModuleDefault||(Object.create?function(fe,e){Object.defineProperty(fe,"default",{enumerable:!0,value:e})}:function(fe,e){fe.default=e}),Ie=this&&this.__importStar||function(fe){if(fe&&fe.__esModule)return fe;var e={};if(fe!=null)for(var _ in fe)_!=="default"&&Object.prototype.hasOwnProperty.call(fe,_)&&Ye(e,fe,_);return Qe(e,fe),e};define(be[3],_e([0,1,28]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0,_=Ie(_);const t=65,W=97,j=90,X=122,k=46,L=47,T=92,F=58,E=63;class v extends Error{constructor(s,c,P){let m;typeof c=="string"&&c.indexOf("not ")===0?(m="must not be",c=c.replace(/^not /,"")):m="must be";const b=s.indexOf(".")!==-1?"property":"argument";let a=`The "${s}" ${b} ${m} of type ${c}`;a+=`. Received type ${typeof P}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function p(n,s){if(n===null||typeof n!="object")throw new v(s,"Object",n)}function o(n,s){if(typeof n!="string")throw new v(s,"string",n)}const r=_.$dc==="win32";function h(n){return n===L||n===T}function w(n){return n===L}function l(n){return n>=t&&n<=j||n>=W&&n<=X}function D(n,s,c,P){let m="",b=0,a=-1,d=0,N=0;for(let f=0;f<=n.length;++f){if(f<n.length)N=n.charCodeAt(f);else{if(P(N))break;N=L}if(P(N)){if(!(a===f-1||d===1))if(d===2){if(m.length<2||b!==2||m.charCodeAt(m.length-1)!==k||m.charCodeAt(m.length-2)!==k){if(m.length>2){const y=m.lastIndexOf(c);y===-1?(m="",b=0):(m=m.slice(0,y),b=m.length-1-m.lastIndexOf(c)),a=f,d=0;continue}else if(m.length!==0){m="",b=0,a=f,d=0;continue}}s&&(m+=m.length>0?`${c}..`:"..",b=2)}else m.length>0?m+=`${c}${n.slice(a+1,f)}`:m=n.slice(a+1,f),b=f-a-1;a=f,d=0}else N===k&&d!==-1?++d:d=-1}return m}function A(n){return n?`${n[0]==="."?"":"."}${n}`:""}function u(n,s){p(s,"pathObject");const c=s.dir||s.root,P=s.base||`${s.name||""}${A(s.ext)}`;return c?c===s.root?`${c}${P}`:`${c}${n}${P}`:P}e.$fc={resolve(...n){let s="",c="",P=!1;for(let m=n.length-1;m>=-1;m--){let b;if(m>=0){if(b=n[m],o(b,`paths[${m}]`),b.length===0)continue}else s.length===0?b=_.cwd():(b=_.env[`=${s}`]||_.cwd(),(b===void 0||b.slice(0,2).toLowerCase()!==s.toLowerCase()&&b.charCodeAt(2)===T)&&(b=`${s}\\`));const a=b.length;let d=0,N="",f=!1;const y=b.charCodeAt(0);if(a===1)h(y)&&(d=1,f=!0);else if(h(y))if(f=!0,h(b.charCodeAt(1))){let G=2,C=G;for(;G<a&&!h(b.charCodeAt(G));)G++;if(G<a&&G!==C){const x=b.slice(C,G);for(C=G;G<a&&h(b.charCodeAt(G));)G++;if(G<a&&G!==C){for(C=G;G<a&&!h(b.charCodeAt(G));)G++;(G===a||G!==C)&&(N=`\\\\${x}\\${b.slice(C,G)}`,d=G)}}}else d=1;else l(y)&&b.charCodeAt(1)===F&&(N=b.slice(0,2),d=2,a>2&&h(b.charCodeAt(2))&&(f=!0,d=3));if(N.length>0)if(s.length>0){if(N.toLowerCase()!==s.toLowerCase())continue}else s=N;if(P){if(s.length>0)break}else if(c=`${b.slice(d)}\\${c}`,P=f,f&&s.length>0)break}return c=D(c,!P,"\\",h),P?`${s}\\${c}`:`${s}${c}`||"."},normalize(n){o(n,"path");const s=n.length;if(s===0)return".";let c=0,P,m=!1;const b=n.charCodeAt(0);if(s===1)return w(b)?"\\":n;if(h(b))if(m=!0,h(n.charCodeAt(1))){let d=2,N=d;for(;d<s&&!h(n.charCodeAt(d));)d++;if(d<s&&d!==N){const f=n.slice(N,d);for(N=d;d<s&&h(n.charCodeAt(d));)d++;if(d<s&&d!==N){for(N=d;d<s&&!h(n.charCodeAt(d));)d++;if(d===s)return`\\\\${f}\\${n.slice(N)}\\`;d!==N&&(P=`\\\\${f}\\${n.slice(N,d)}`,c=d)}}}else c=1;else l(b)&&n.charCodeAt(1)===F&&(P=n.slice(0,2),c=2,s>2&&h(n.charCodeAt(2))&&(m=!0,c=3));let a=c<s?D(n.slice(c),!m,"\\",h):"";return a.length===0&&!m&&(a="."),a.length>0&&h(n.charCodeAt(s-1))&&(a+="\\"),P===void 0?m?`\\${a}`:a:m?`${P}\\${a}`:`${P}${a}`},isAbsolute(n){o(n,"path");const s=n.length;if(s===0)return!1;const c=n.charCodeAt(0);return h(c)||s>2&&l(c)&&n.charCodeAt(1)===F&&h(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,c;for(let b=0;b<n.length;++b){const a=n[b];o(a,"path"),a.length>0&&(s===void 0?s=c=a:s+=`\\${a}`)}if(s===void 0)return".";let P=!0,m=0;if(typeof c=="string"&&h(c.charCodeAt(0))){++m;const b=c.length;b>1&&h(c.charCodeAt(1))&&(++m,b>2&&(h(c.charCodeAt(2))?++m:P=!1))}if(P){for(;m<s.length&&h(s.charCodeAt(m));)m++;m>=2&&(s=`\\${s.slice(m)}`)}return e.$fc.normalize(s)},relative(n,s){if(o(n,"from"),o(s,"to"),n===s)return"";const c=e.$fc.resolve(n),P=e.$fc.resolve(s);if(c===P||(n=c.toLowerCase(),s=P.toLowerCase(),n===s))return"";let m=0;for(;m<n.length&&n.charCodeAt(m)===T;)m++;let b=n.length;for(;b-1>m&&n.charCodeAt(b-1)===T;)b--;const a=b-m;let d=0;for(;d<s.length&&s.charCodeAt(d)===T;)d++;let N=s.length;for(;N-1>d&&s.charCodeAt(N-1)===T;)N--;const f=N-d,y=a<f?a:f;let G=-1,C=0;for(;C<y;C++){const K=n.charCodeAt(m+C);if(K!==s.charCodeAt(d+C))break;K===T&&(G=C)}if(C!==y){if(G===-1)return P}else{if(f>y){if(s.charCodeAt(d+C)===T)return P.slice(d+C+1);if(C===2)return P.slice(d+C)}a>y&&(n.charCodeAt(m+C)===T?G=C:C===2&&(G=3)),G===-1&&(G=0)}let x="";for(C=m+G+1;C<=b;++C)(C===b||n.charCodeAt(C)===T)&&(x+=x.length===0?"..":"\\..");return d+=G,x.length>0?`${x}${P.slice(d,N)}`:(P.charCodeAt(d)===T&&++d,P.slice(d,N))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=e.$fc.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===T){if(s.charCodeAt(1)===T){const c=s.charCodeAt(2);if(c!==E&&c!==k)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(l(s.charCodeAt(0))&&s.charCodeAt(1)===F&&s.charCodeAt(2)===T)return`\\\\?\\${s}`;return n},dirname(n){o(n,"path");const s=n.length;if(s===0)return".";let c=-1,P=0;const m=n.charCodeAt(0);if(s===1)return h(m)?n:".";if(h(m)){if(c=P=1,h(n.charCodeAt(1))){let d=2,N=d;for(;d<s&&!h(n.charCodeAt(d));)d++;if(d<s&&d!==N){for(N=d;d<s&&h(n.charCodeAt(d));)d++;if(d<s&&d!==N){for(N=d;d<s&&!h(n.charCodeAt(d));)d++;if(d===s)return n;d!==N&&(c=P=d+1)}}}}else l(m)&&n.charCodeAt(1)===F&&(c=s>2&&h(n.charCodeAt(2))?3:2,P=c);let b=-1,a=!0;for(let d=s-1;d>=P;--d)if(h(n.charCodeAt(d))){if(!a){b=d;break}}else a=!1;if(b===-1){if(c===-1)return".";b=c}return n.slice(0,b)},basename(n,s){s!==void 0&&o(s,"suffix"),o(n,"path");let c=0,P=-1,m=!0,b;if(n.length>=2&&l(n.charCodeAt(0))&&n.charCodeAt(1)===F&&(c=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let a=s.length-1,d=-1;for(b=n.length-1;b>=c;--b){const N=n.charCodeAt(b);if(h(N)){if(!m){c=b+1;break}}else d===-1&&(m=!1,d=b+1),a>=0&&(N===s.charCodeAt(a)?--a===-1&&(P=b):(a=-1,P=d))}return c===P?P=d:P===-1&&(P=n.length),n.slice(c,P)}for(b=n.length-1;b>=c;--b)if(h(n.charCodeAt(b))){if(!m){c=b+1;break}}else P===-1&&(m=!1,P=b+1);return P===-1?"":n.slice(c,P)},extname(n){o(n,"path");let s=0,c=-1,P=0,m=-1,b=!0,a=0;n.length>=2&&n.charCodeAt(1)===F&&l(n.charCodeAt(0))&&(s=P=2);for(let d=n.length-1;d>=s;--d){const N=n.charCodeAt(d);if(h(N)){if(!b){P=d+1;break}continue}m===-1&&(b=!1,m=d+1),N===k?c===-1?c=d:a!==1&&(a=1):c!==-1&&(a=-1)}return c===-1||m===-1||a===0||a===1&&c===m-1&&c===P+1?"":n.slice(c,m)},format:u.bind(null,"\\"),parse(n){o(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const c=n.length;let P=0,m=n.charCodeAt(0);if(c===1)return h(m)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if(h(m)){if(P=1,h(n.charCodeAt(1))){let G=2,C=G;for(;G<c&&!h(n.charCodeAt(G));)G++;if(G<c&&G!==C){for(C=G;G<c&&h(n.charCodeAt(G));)G++;if(G<c&&G!==C){for(C=G;G<c&&!h(n.charCodeAt(G));)G++;G===c?P=G:G!==C&&(P=G+1)}}}}else if(l(m)&&n.charCodeAt(1)===F){if(c<=2)return s.root=s.dir=n,s;if(P=2,h(n.charCodeAt(2))){if(c===3)return s.root=s.dir=n,s;P=3}}P>0&&(s.root=n.slice(0,P));let b=-1,a=P,d=-1,N=!0,f=n.length-1,y=0;for(;f>=P;--f){if(m=n.charCodeAt(f),h(m)){if(!N){a=f+1;break}continue}d===-1&&(N=!1,d=f+1),m===k?b===-1?b=f:y!==1&&(y=1):b!==-1&&(y=-1)}return d!==-1&&(b===-1||y===0||y===1&&b===d-1&&b===a+1?s.base=s.name=n.slice(a,d):(s.name=n.slice(a,b),s.base=n.slice(a,d),s.ext=n.slice(b,d))),a>0&&a!==P?s.dir=n.slice(0,a-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(r){const n=/\\/g;return()=>{const s=_.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>_.cwd()})();e.$gc={resolve(...n){let s="",c=!1;for(let P=n.length-1;P>=-1&&!c;P--){const m=P>=0?n[P]:i();o(m,`paths[${P}]`),m.length!==0&&(s=`${m}/${s}`,c=m.charCodeAt(0)===L)}return s=D(s,!c,"/",w),c?`/${s}`:s.length>0?s:"."},normalize(n){if(o(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===L,c=n.charCodeAt(n.length-1)===L;return n=D(n,!s,"/",w),n.length===0?s?"/":c?"./":".":(c&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return o(n,"path"),n.length>0&&n.charCodeAt(0)===L},join(...n){if(n.length===0)return".";let s;for(let c=0;c<n.length;++c){const P=n[c];o(P,"path"),P.length>0&&(s===void 0?s=P:s+=`/${P}`)}return s===void 0?".":e.$gc.normalize(s)},relative(n,s){if(o(n,"from"),o(s,"to"),n===s||(n=e.$gc.resolve(n),s=e.$gc.resolve(s),n===s))return"";const c=1,P=n.length,m=P-c,b=1,a=s.length-b,d=m<a?m:a;let N=-1,f=0;for(;f<d;f++){const G=n.charCodeAt(c+f);if(G!==s.charCodeAt(b+f))break;G===L&&(N=f)}if(f===d)if(a>d){if(s.charCodeAt(b+f)===L)return s.slice(b+f+1);if(f===0)return s.slice(b+f)}else m>d&&(n.charCodeAt(c+f)===L?N=f:f===0&&(N=0));let y="";for(f=c+N+1;f<=P;++f)(f===P||n.charCodeAt(f)===L)&&(y+=y.length===0?"..":"/..");return`${y}${s.slice(b+N)}`},toNamespacedPath(n){return n},dirname(n){if(o(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===L;let c=-1,P=!0;for(let m=n.length-1;m>=1;--m)if(n.charCodeAt(m)===L){if(!P){c=m;break}}else P=!1;return c===-1?s?"/":".":s&&c===1?"//":n.slice(0,c)},basename(n,s){s!==void 0&&o(s,"ext"),o(n,"path");let c=0,P=-1,m=!0,b;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let a=s.length-1,d=-1;for(b=n.length-1;b>=0;--b){const N=n.charCodeAt(b);if(N===L){if(!m){c=b+1;break}}else d===-1&&(m=!1,d=b+1),a>=0&&(N===s.charCodeAt(a)?--a===-1&&(P=b):(a=-1,P=d))}return c===P?P=d:P===-1&&(P=n.length),n.slice(c,P)}for(b=n.length-1;b>=0;--b)if(n.charCodeAt(b)===L){if(!m){c=b+1;break}}else P===-1&&(m=!1,P=b+1);return P===-1?"":n.slice(c,P)},extname(n){o(n,"path");let s=-1,c=0,P=-1,m=!0,b=0;for(let a=n.length-1;a>=0;--a){const d=n.charCodeAt(a);if(d===L){if(!m){c=a+1;break}continue}P===-1&&(m=!1,P=a+1),d===k?s===-1?s=a:b!==1&&(b=1):s!==-1&&(b=-1)}return s===-1||P===-1||b===0||b===1&&s===P-1&&s===c+1?"":n.slice(s,P)},format:u.bind(null,"/"),parse(n){o(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const c=n.charCodeAt(0)===L;let P;c?(s.root="/",P=1):P=0;let m=-1,b=0,a=-1,d=!0,N=n.length-1,f=0;for(;N>=P;--N){const y=n.charCodeAt(N);if(y===L){if(!d){b=N+1;break}continue}a===-1&&(d=!1,a=N+1),y===k?m===-1?m=N:f!==1&&(f=1):m!==-1&&(f=-1)}if(a!==-1){const y=b===0&&c?1:b;m===-1||f===0||f===1&&m===a-1&&m===b+1?s.base=s.name=n.slice(y,a):(s.name=n.slice(y,m),s.base=n.slice(y,a),s.ext=n.slice(m,a))}return b>0?s.dir=n.slice(0,b-1):c&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=r?e.$fc.normalize:e.$gc.normalize,e.$ic=r?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=r?e.$fc.join:e.$gc.join,e.$kc=r?e.$fc.resolve:e.$gc.resolve,e.$lc=r?e.$fc.relative:e.$gc.relative,e.$mc=r?e.$fc.dirname:e.$gc.dirname,e.$nc=r?e.$fc.basename:e.$gc.basename,e.$oc=r?e.$fc.extname:e.$gc.extname,e.$pc=r?e.$fc.format:e.$gc.format,e.$qc=r?e.$fc.parse:e.$gc.parse,e.$rc=r?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=r?e.$fc.sep:e.$gc.sep,e.$tc=r?e.$fc.delimiter:e.$gc.delimiter}),define(be[29],_e([0,1,2]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$lm=j,e.$mm=X;var t;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(t||(e.Source=t={}));var W;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(W||(e.TerminateResponseCode=W={}));function j(k,...L){const T=L.reduce((v,p)=>(v[p]=!0,v),{}),F=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(v=>!T[v]).forEach(v=>{for(let p=0;p<F.length;p++)if(v.search(F[p])!==-1){delete k[v];break}})}function X(k){k&&(delete k.DEBUG,_.$l&&delete k.LD_PRELOAD)}}),define(be[42],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=void 0;const _=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(j){return new t(j)}constructor(j){this.c=_&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$fe=t}),define(be[6],_e([0,1,9,26,4,41,42]),function(fe,e,_,t,W,j,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$he=e.Event=void 0,e.$ie=p;const k=!1,L=!1,T=!1;var F;(function(x){x.None=()=>W.$Uc.None;function K(he){if(T){const{onDidAddListener:le}=he,$e=r.create();let de=0;he.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),le?.()}}}function se(he,le){return R(he,()=>{},0,void 0,!0,void 0,le)}x.defer=se;function V(he){return(le,$e=null,de)=>{let we=!1,ye;return ye=he(Le=>{if(!we)return ye?ye.dispose():we=!0,le.call($e,Le)},null,de),we&&ye.dispose(),ye}}x.once=V;function ne(he,le,$e){return q((de,we=null,ye)=>he(Le=>de.call(we,le(Le)),null,ye),$e)}x.map=ne;function ce(he,le,$e){return q((de,we=null,ye)=>he(Le=>{le(Le),de.call(we,Le)},null,ye),$e)}x.forEach=ce;function re(he,le,$e){return q((de,we=null,ye)=>he(Le=>le(Le)&&de.call(we,Le),null,ye),$e)}x.filter=re;function I(he){return he}x.signal=I;function $(...he){return(le,$e=null,de)=>{const we=(0,W.$Rc)(...he.map(ye=>ye(Le=>le.call($e,Le))));return Q(we,de)}}x.any=$;function S(he,le,$e,de){let we=$e;return ne(he,ye=>(we=le(we,ye),we),de)}x.reduce=S;function q(he,le){let $e;const de={onWillAddFirstListener(){$e=he(we.fire,we)},onDidRemoveLastListener(){$e?.dispose()}};le||K(de);const we=new n(de);return le?.add(we),we.event}function Q(he,le){return le instanceof Array?le.push(he):le&&le.add(he),he}function R(he,le,$e=100,de=!1,we=!1,ye,Le){let Ue,Te,pe,Ae=0,Pe;const ze={leakWarningThreshold:ye,onWillAddFirstListener(){Ue=he(Ke=>{Ae++,Te=le(Te,Ke),de&&!pe&&(Be.fire(Te),Te=void 0),Pe=()=>{const Ve=Te;Te=void 0,pe=void 0,(!de||Ae>1)&&Be.fire(Ve),Ae=0},typeof $e=="number"?(clearTimeout(pe),pe=setTimeout(Pe,$e)):pe===void 0&&(pe=0,queueMicrotask(Pe))})},onWillRemoveListener(){we&&Ae>0&&Pe?.()},onDidRemoveLastListener(){Pe=void 0,Ue.dispose()}};Le||K(ze);const Be=new n(ze);return Le?.add(Be),Be.event}x.debounce=R;function J(he,le=0,$e){return x.debounce(he,(de,we)=>de?(de.push(we),de):[we],le,void 0,!0,void 0,$e)}x.accumulate=J;function ee(he,le=(de,we)=>de===we,$e){let de=!0,we;return re(he,ye=>{const Le=de||!le(ye,we);return de=!1,we=ye,Le},$e)}x.latch=ee;function ie(he,le,$e){return[x.filter(he,le,$e),x.filter(he,de=>!le(de),$e)]}x.split=ie;function ue(he,le=!1,$e=[],de){let we=$e.slice(),ye=he(Te=>{we?we.push(Te):Ue.fire(Te)});de&&de.add(ye);const Le=()=>{we?.forEach(Te=>Ue.fire(Te)),we=null},Ue=new n({onWillAddFirstListener(){ye||(ye=he(Te=>Ue.fire(Te)),de&&de.add(ye))},onDidAddFirstListener(){we&&(le?setTimeout(Le):Le())},onDidRemoveLastListener(){ye&&ye.dispose(),ye=null}});return de&&de.add(Ue),Ue.event}x.buffer=ue;function ae(he,le){return(de,we,ye)=>{const Le=le(new B);return he(function(Ue){const Te=Le.evaluate(Ue);Te!==Ee&&de.call(we,Te)},void 0,ye)}}x.chain=ae;const Ee=Symbol("HaltChainable");class B{constructor(){this.f=[]}map(le){return this.f.push(le),this}forEach(le){return this.f.push($e=>(le($e),$e)),this}filter(le){return this.f.push($e=>le($e)?$e:Ee),this}reduce(le,$e){let de=$e;return this.f.push(we=>(de=le(de,we),de)),this}latch(le=($e,de)=>$e===de){let $e=!0,de;return this.f.push(we=>{const ye=$e||!le(we,de);return $e=!1,de=we,ye?we:Ee}),this}evaluate(le){for(const $e of this.f)if(le=$e(le),le===Ee)break;return le}}function z(he,le,$e=de=>de){const de=(...Ue)=>Le.fire($e(...Ue)),we=()=>he.on(le,de),ye=()=>he.removeListener(le,de),Le=new n({onWillAddFirstListener:we,onDidRemoveLastListener:ye});return Le.event}x.fromNodeEventEmitter=z;function O(he,le,$e=de=>de){const de=(...Ue)=>Le.fire($e(...Ue)),we=()=>he.addEventListener(le,de),ye=()=>he.removeEventListener(le,de),Le=new n({onWillAddFirstListener:we,onDidRemoveLastListener:ye});return Le.event}x.fromDOMEventEmitter=O;function g(he){return new Promise(le=>V(he)(le))}x.toPromise=g;function M(he){const le=new n;return he.then($e=>{le.fire($e)},()=>{le.fire(void 0)}).finally(()=>{le.dispose()}),le.event}x.fromPromise=M;function Y(he,le){return he($e=>le.fire($e))}x.forward=Y;function te(he,le,$e){return le($e),he(de=>le(de))}x.runAndSubscribe=te;class ge{constructor(le,$e){this._observable=le,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{le.addObserver(this)},onDidRemoveLastListener:()=>{le.removeObserver(this)}};$e||K(de),this.emitter=new n(de),$e&&$e.add(this.emitter)}beginUpdate(le){this.f++}handlePossibleChange(le){}handleChange(le,$e){this.g=!0}endUpdate(le){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function De(he,le){return new ge(he,le).emitter.event}x.fromObservable=De;function Re(he){return(le,$e,de)=>{let we=0,ye=!1;const Le={beginUpdate(){we++},endUpdate(){we--,we===0&&(he.reportChanges(),ye&&(ye=!1,le.call($e)))},handlePossibleChange(){},handleChange(){ye=!0}};he.addObserver(Le),he.reportChanges();const Ue={dispose(){he.removeObserver(Le)}};return de instanceof W.$Tc?de.add(Ue):Array.isArray(de)&&de.push(Ue),Ue}}x.fromObservableLight=Re})(F||(e.Event=F={}));class E{static{this.all=new Set}static{this.f=0}constructor(K){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${K}_${E.f++}`,E.all.add(this)}start(K){this.g=new X.$fe,this.listenerCount=K}stop(){if(this.g){const K=this.g.elapsed();this.durations.push(K),this.elapsedOverall+=K,this.invocationCount+=1,this.g=void 0}}}e.$he=E;let v=-1;function p(x){const K=v;return v=x,{dispose(){v=K}}}class o{static{this.f=1}constructor(K,se,V=(o.f++).toString(16).padStart(3,"0")){this.j=K,this.threshold=se,this.name=V,this.h=0}dispose(){this.g?.clear()}check(K,se){const V=this.threshold;if(V<=0||se<V)return;this.g||(this.g=new Map);const ne=this.g.get(K.value)||0;if(this.g.set(K.value,ne+1),this.h-=1,this.h<=0){this.h=V*.5;const[ce,re]=this.getMostFrequentStack(),I=`[${this.name}] potential listener LEAK detected, having ${se} listeners already. MOST frequent listener (${re}):`;console.warn(I),console.warn(ce);const $=new h(I,ce);this.j($)}return()=>{const ce=this.g.get(K.value)||0;this.g.set(K.value,ce-1)}}getMostFrequentStack(){if(!this.g)return;let K,se=0;for(const[V,ne]of this.g)(!K||se<ne)&&(K=[V,ne],se=ne);return K}}class r{static create(){const K=new Error;return new r(K.stack??"")}constructor(K){this.value=K}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h extends Error{constructor(K,se){super(K),this.name="ListenerLeakError",this.stack=se}}e.$je=h;class w extends Error{constructor(K,se){super(K),this.name="ListenerRefusalError",this.stack=se}}e.$ke=w;let l=0;class D{constructor(K){this.value=K,this.id=l++}}const A=2,u=(x,K)=>{if(x instanceof D)K(x);else for(let se=0;se<x.length;se++){const V=x[se];V&&K(V)}};let i;if(k){const x=[];setInterval(()=>{x.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(x.join(`
`)),x.length=0)},3e3),i=new FinalizationRegistry(K=>{typeof K=="string"&&x.push(K)})}class n{constructor(K){this.z=0,this.f=K,this.g=v>0||this.f?.leakWarningThreshold?new o(K?.onListenerError??_.$Y,this.f?.leakWarningThreshold??v):void 0,this.j=this.f?._profName?new E(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(L){const K=this.u;queueMicrotask(()=>{u(K,se=>se.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(K,se,V)=>{if(this.g&&this.z>this.g.threshold**2){const $=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn($);const S=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],q=new w(`${$}. HINT: Stack shows most frequent listener (${S[1]}-times)`,S[0]);return(this.f?.onListenerError||_.$Y)(q),W.$Uc.None}if(this.m)return W.$Uc.None;se&&(K=K.bind(se));const ne=new D(K);let ce,re;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(ne.stack=r.create(),ce=this.g.check(ne.stack,this.z+1)),L&&(ne.stack=re??r.create()),this.u?this.u instanceof D?(this.w??=new c,this.u=[this.u,ne]):this.u.push(ne):(this.f?.onWillAddFirstListener?.(this),this.u=ne,this.f?.onDidAddFirstListener?.(this)),this.z++;const I=(0,W.$Sc)(()=>{i?.unregister(I),ce?.(),this.A(ne)});if(V instanceof W.$Tc?V.add(I):Array.isArray(V)&&V.push(I),i){const $=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),S=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec($);i.register(I,S?.[2]??$,I)}return I},this.q}A(K){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const se=this.u,V=se.indexOf(K);if(V===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,se[V]=void 0;const ne=this.w.current===this;if(this.z*A<=se.length){let ce=0;for(let re=0;re<se.length;re++)se[re]?se[ce++]=se[re]:ne&&(this.w.end--,ce<this.w.i&&this.w.i--);se.length=ce}}B(K,se){if(!K)return;const V=this.f?.onListenerError||_.$Y;if(!V){K.value(se);return}try{K.value(se)}catch(ne){V(ne)}}C(K){const se=K.current.u;for(;K.i<K.end;)this.B(se[K.i++],K.value);K.reset()}fire(K){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof D)this.B(this.u,K);else{const se=this.w;se.enqueue(this,K,this.u.length),this.C(se)}this.j?.stop()}hasListeners(){return this.z>0}}e.$le=n;const s=()=>new c;e.$me=s;class c{constructor(){this.i=-1,this.end=0}enqueue(K,se,V){this.i=0,this.end=V,this.current=K,this.value=se}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class P extends n{async fireAsync(K,se,V){if(this.u)for(this.h||(this.h=new j.$5c),u(this.u,ne=>this.h.push([ne.value,K]));this.h.size>0&&!se.isCancellationRequested;){const[ne,ce]=this.h.shift(),re=[],I={...ce,token:se,waitUntil:$=>{if(Object.isFrozen(re))throw new Error("waitUntil can NOT be called asynchronous");V&&($=V($,ne)),re.push($)}};try{ne(I)}catch($){(0,_.$Y)($);continue}Object.freeze(re),await Promise.allSettled(re).then($=>{for(const S of $)S.status==="rejected"&&(0,_.$Y)(S.reason)})}}}e.$ne=P;class m extends n{get isPaused(){return this.h!==0}constructor(K){super(K),this.h=0,this.s=new j.$5c,this.t=K?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const K=Array.from(this.s);this.s.clear(),super.fire(this.t(K))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(K){this.z&&(this.h!==0?this.s.push(K):super.fire(K))}}e.$oe=m;class b extends m{constructor(K){super(K),this.k=K.delay??100}fire(K){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(K)}}e.$pe=b;class a extends n{constructor(K){super(K),this.h=[],this.k=K?.merge}fire(K){this.hasListeners()&&(this.h.push(K),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(se=>super.fire(se)),this.h=[]}))}}e.$qe=a;class d{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(K){const se={event:K,listener:null};this.h.push(se),this.g&&this.m(se);const V=()=>{this.g&&this.o(se);const ne=this.h.indexOf(se);this.h.splice(ne,1)};return(0,W.$Sc)((0,t.$cb)(V))}j(){this.g=!0,this.h.forEach(K=>this.m(K))}k(){this.g=!1,this.h.forEach(K=>this.o(K))}m(K){K.listener=K.event(se=>this.f.fire(se))}o(K){K.listener?.dispose(),K.listener=null}dispose(){this.f.dispose();for(const K of this.h)K.listener?.dispose();this.h=[]}}e.$re=d;class N{constructor(K,se,V,ne){this.f=new W.$Tc;const ce=this.f.add(new d),re=this.f.add(new W.$4c);function I($){re.set($,ce.add(ne($)))}for(const $ of K)I($);this.f.add(se($=>{I($)})),this.f.add(V($=>{re.deleteAndDispose($)})),this.event=ce.event}dispose(){this.f.dispose()}}e.$se=N;class f{constructor(){this.f=[]}wrapEvent(K,se,V){return(ne,ce,re)=>K(I=>{const $=this.f[this.f.length-1];if(!se){$?$.buffers.push(()=>ne.call(ce,I)):ne.call(ce,I);return}const S=$;if(!S){ne.call(ce,se(V,I));return}S.items??=[],S.items.push(I),S.buffers.length===0&&$.buffers.push(()=>{S.reducedResult??=V?S.items.reduce(se,V):S.items.reduce(se),ne.call(ce,S.reducedResult)})},void 0,re)}bufferEvents(K){const se={buffers:new Array};this.f.push(se);const V=K();return this.f.pop(),se.buffers.forEach(ne=>ne()),V}}e.$te=f;class y{constructor(){this.f=!1,this.g=F.None,this.h=W.$Uc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(K){this.g=K,this.f&&(this.h.dispose(),this.h=K(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ue=y;class G{static const(K){return new C(K)}constructor(K){this.g=K,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(K){K!==this.g&&(this.g=K,this.f.fire(void 0))}}e.$ve=G;class C{constructor(K){this.value=K,this.onDidChange=F.None}}}),define(be[13],_e([0,1,6]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.CancellationToken=void 0,e.$xe=k;const t=Object.freeze(function(L,T){const F=setTimeout(L.bind(T),0);return{dispose(){clearTimeout(F)}}});var W;(function(L){function T(F){return F===L.None||F===L.Cancelled||F instanceof j?!0:!F||typeof F!="object"?!1:typeof F.isCancellationRequested=="boolean"&&typeof F.onCancellationRequested=="function"}L.isCancellationToken=T,L.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),L.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(W||(e.CancellationToken=W={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new _.$le),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class X{constructor(T){this.f=void 0,this.g=void 0,this.g=T&&T.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=W.Cancelled}dispose(T=!1){T&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=W.None}}e.$we=X;function k(L){const T=new X;return L.add({dispose(){T.cancel()}}),T.token}}),define(be[43],_e([0,1,13]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_e=e.$$e=e.$9e=void 0,e.$0e=W;class t{constructor(L){this.b=L,this.a=null}get(){if(this.a)return this.a;const L=new _.$we,T=this.b(L.token);return this.a={promise:T,dispose:()=>{this.a=null,L.cancel(),L.dispose()}},this.a}}e.$9e=t;function W(k){return k}class j{constructor(L,T){this.a=void 0,this.b=void 0,typeof L=="function"?(this.c=L,this.d=W):(this.c=T,this.d=L.getCacheKey)}get(L){const T=this.d(L);return this.b!==T&&(this.b=T,this.a=this.c(L)),this.a}}e.$$e=j;class X{get cachedValues(){return this.a}constructor(L,T){this.a=new Map,this.b=new Map,typeof L=="function"?(this.c=L,this.d=W):(this.c=T,this.d=L.getCacheKey)}get(L){const T=this.d(L);if(this.b.has(T))return this.b.get(T);const F=this.c(L);return this.a.set(L,F),this.b.set(T,F),F}}e.$_e=X}),define(be[44],_e([0,1,9,4]),function(fe,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=W,e.$ze=j,e.$Ae=X,e.$Be=k,e.$Ce=T,e.$De=F,e.$Ee=E,e.$Fe=v,e.$Ge=p,e.$He=o,e.$Ie=r,e.$Je=h,e.$Ke=w,e.$Le=l,e.$Me=D;function W(A){const u=A;return u?typeof u.read=="function":!1}function j(A){const u=A;return u?[u.on,u.pause,u.resume,u.destroy].every(i=>typeof i=="function"):!1}function X(A){const u=A;return u?j(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}function k(A,u){return new L(A,u)}class L{constructor(u,i){this.e=u,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(i=>i(u))}h(u){this.c.error.length===0?(0,_.$Y)(u):this.c.error.slice(0).forEach(i=>i(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,i){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(u,i){if(this.a.destroyed)return;let n;switch(u){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const s=n.indexOf(i);s>=0&&n.splice(s,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function T(A,u){const i=[];let n;for(;(n=A.read())!==null;)i.push(n);return u(i)}function F(A,u,i){const n=[];let s;for(;(s=A.read())!==null&&n.length<i;)n.push(s);return s===null&&n.length>0?u(n):{read:()=>{if(n.length>0)return n.shift();if(typeof s<"u"){const c=s;return s=void 0,c}return A.read()}}}function E(A,u){return new Promise((i,n)=>{const s=[];v(A,{onData:c=>{u&&s.push(c)},onError:c=>{u?n(c):i(void 0)},onEnd:()=>{i(u?u(s):void 0)}})})}function v(A,u,i){A.on("error",n=>{i?.isCancellationRequested||u.onError(n)}),A.on("end",()=>{i?.isCancellationRequested||u.onEnd()}),A.on("data",n=>{i?.isCancellationRequested||u.onData(n)})}function p(A,u){return new Promise((i,n)=>{const s=new t.$Tc,c=[],P=a=>{if(c.push(a),c.length>u)return s.dispose(),A.pause(),i({stream:A,buffer:c,ended:!1})},m=a=>(s.dispose(),n(a)),b=()=>(s.dispose(),i({stream:A,buffer:c,ended:!0}));s.add((0,t.$Sc)(()=>A.removeListener("error",m))),A.on("error",m),s.add((0,t.$Sc)(()=>A.removeListener("end",b))),A.on("end",b),s.add((0,t.$Sc)(()=>A.removeListener("data",P))),A.on("data",P)})}function o(A,u){const i=k(u);return i.end(A),i}function r(){const A=k(()=>{throw new Error("not supported")});return A.end(),A}function h(A){let u=!1;return{read:()=>u?null:(u=!0,A)}}function w(A,u,i){const n=k(i);return v(A,{onData:s=>n.write(u.data(s)),onError:s=>n.error(u.error?u.error(s):s),onEnd:()=>n.end()}),n}function l(A,u,i){let n=!1;return{read:()=>{const s=u.read();return n?s:(n=!0,s!==null?i([A,s]):A)}}}function D(A,u,i){let n=!1;const s=k(i);return v(u,{onData:c=>n?s.write(c):(n=!0,s.write(i([A,c]))),onError:c=>s.error(c),onEnd:()=>{n||(n=!0,s.write(A)),s.end()}}),s}}),define(be[17],_e([0,1,16,44]),function(fe,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=void 0,e.$Oe=T,e.$Pe=F,e.$Qe=E,e.$Re=v,e.$Se=p,e.$Te=o,e.$Ue=r,e.$Ve=h,e.$We=w,e.$Xe=l,e.$Ye=D,e.$Ze=A,e.$1e=u,e.$2e=i,e.$3e=n,e.$4e=s,e.$5e=c,e.$6e=P,e.$7e=m,e.$8e=d,t=Ie(t);const W=typeof Buffer<"u",j=new _.$T(()=>new Uint8Array(256));let X,k;class L{static alloc(f){return W?new L(Buffer.allocUnsafe(f)):new L(new Uint8Array(f))}static wrap(f){return W&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new L(f)}static fromString(f,y){return!(y?.dontUseNodeBuffer||!1)&&W?new L(Buffer.from(f)):(X||(X=new TextEncoder),new L(X.encode(f)))}static fromByteArray(f){const y=L.alloc(f.length);for(let G=0,C=f.length;G<C;G++)y.buffer[G]=f[G];return y}static concat(f,y){if(typeof y>"u"){y=0;for(let x=0,K=f.length;x<K;x++)y+=f[x].byteLength}const G=L.alloc(y);let C=0;for(let x=0,K=f.length;x<K;x++){const se=f[x];G.set(se,C),C+=se.byteLength}return G}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=L.alloc(this.byteLength);return f.set(this),f}toString(){return W?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(f,y){return new L(this.buffer.subarray(f,y))}set(f,y){if(f instanceof L)this.buffer.set(f.buffer,y);else if(f instanceof Uint8Array)this.buffer.set(f,y);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),y);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),y);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return v(this.buffer,f)}writeUInt32BE(f,y){p(this.buffer,f,y)}readUInt32LE(f){return o(this.buffer,f)}writeUInt32LE(f,y){r(this.buffer,f,y)}readUInt8(f){return h(this.buffer,f)}writeUInt8(f,y){w(this.buffer,f,y)}indexOf(f,y=0){return T(this.buffer,f instanceof L?f.buffer:f,y)}}e.$Ne=L;function T(N,f,y=0){const G=f.byteLength,C=N.byteLength;if(G===0)return 0;if(G===1)return N.indexOf(f[0]);if(G>C-y)return-1;const x=j.value;x.fill(f.length);for(let ne=0;ne<f.length;ne++)x[f[ne]]=f.length-ne-1;let K=y+f.length-1,se=K,V=-1;for(;K<C;)if(N[K]===f[se]){if(se===0){V=K;break}K--,se--}else K+=Math.max(f.length-se,x[N[K]]),se=f.length-1;return V}function F(N,f){return N[f+0]<<0>>>0|N[f+1]<<8>>>0}function E(N,f,y){N[y+0]=f&255,f=f>>>8,N[y+1]=f&255}function v(N,f){return N[f]*2**24+N[f+1]*2**16+N[f+2]*2**8+N[f+3]}function p(N,f,y){N[y+3]=f,f=f>>>8,N[y+2]=f,f=f>>>8,N[y+1]=f,f=f>>>8,N[y]=f}function o(N,f){return N[f+0]<<0>>>0|N[f+1]<<8>>>0|N[f+2]<<16>>>0|N[f+3]<<24>>>0}function r(N,f,y){N[y+0]=f&255,f=f>>>8,N[y+1]=f&255,f=f>>>8,N[y+2]=f&255,f=f>>>8,N[y+3]=f&255}function h(N,f){return N[f]}function w(N,f,y){N[y]=f}function l(N){return t.$Ce(N,f=>L.concat(f))}function D(N){return t.$Je(N)}function A(N){return t.$Ee(N,f=>L.concat(f))}async function u(N){return N.ended?L.concat(N.buffer):L.concat([...N.buffer,await A(N.stream)])}function i(N){return t.$He(N,f=>L.concat(f))}function n(N){return t.$Ke(N,{data:f=>typeof f=="string"?L.fromString(f):L.wrap(f)},f=>L.concat(f))}function s(N){return t.$Be(f=>L.concat(f),N)}function c(N,f){return t.$Le(N,f,y=>L.concat(y))}function P(N,f){return t.$Me(N,f,y=>L.concat(y))}function m(N){let f=0,y=0,G=0;const C=new Uint8Array(Math.floor(N.length/4*3)),x=se=>{switch(y){case 3:C[G++]=f|se,y=0;break;case 2:C[G++]=f|se>>>2,f=se<<6,y=3;break;case 1:C[G++]=f|se>>>4,f=se<<4,y=2;break;default:f=se<<2,y=1}};for(let se=0;se<N.length;se++){const V=N.charCodeAt(se);if(V>=65&&V<=90)x(V-65);else if(V>=97&&V<=122)x(V-97+26);else if(V>=48&&V<=57)x(V-48+52);else if(V===43||V===45)x(62);else if(V===47||V===95)x(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${N[se]}`)}}const K=G;for(;y>0;)x(0);return L.wrap(C).slice(0,K)}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:N},f=!0,y=!1){const G=y?a:b;let C="";const x=N.byteLength%3;let K=0;for(;K<N.byteLength-x;K+=3){const se=N[K+0],V=N[K+1],ne=N[K+2];C+=G[se>>>2],C+=G[(se<<4|V>>>4)&63],C+=G[(V<<2|ne>>>6)&63],C+=G[ne&63]}if(x===1){const se=N[K+0];C+=G[se>>>2],C+=G[se<<4&63],f&&(C+="==")}else if(x===2){const se=N[K+0],V=N[K+1];C+=G[se>>>2],C+=G[(se<<4|V>>>4)&63],C+=G[V<<2&63],f&&(C+="=")}return C}}),define(be[45],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0,e.$ge=Symbol("MicrotaskDelay")}),define(be[10],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=_,e.$fg=t,e.$gg=W,e.$hg=j,e.$ig=X,e.$jg=k,e.$kg=L,e.$lg=T,e.$mg=F,e.$ng=E,e.$og=v,e.$pg=p,e.$qg=o,e.$rg=h,e.$sg=w,e.$tg=l,e.$ug=D,e.$vg=A,e.$wg=u;function _(i){return typeof i=="string"}function t(i){return Array.isArray(i)&&i.every(n=>_(n))}function W(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function j(i){const n=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof n}function X(i){return typeof i=="number"&&!isNaN(i)}function k(i){return!!i&&typeof i[Symbol.iterator]=="function"}function L(i){return i===!0||i===!1}function T(i){return typeof i>"u"}function F(i){return!E(i)}function E(i){return T(i)||i===null}function v(i,n){if(!i)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function p(i){if(E(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function o(...i){const n=[];for(let s=0;s<i.length;s++){const c=i[s];if(E(c))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(c)}return n}const r=Object.prototype.hasOwnProperty;function h(i){if(!W(i))return!1;for(const n in i)if(r.call(i,n))return!1;return!0}function w(i){return typeof i=="function"}function l(...i){return i.length>0&&i.every(w)}function D(i,n){const s=Math.min(i.length,n.length);for(let c=0;c<s;c++)A(i[c],n[c])}function A(i,n){if(_(n)){if(typeof i!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(w(n)){try{if(i instanceof n)return}catch{}if(!E(i)&&i.constructor===n||n.length===1&&n.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function u(i){return i}}),define(be[46],_e([0,1,10]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=t,e.$fo=W,e.$go=X,e.$ho=L,e.$io=T,e.$jo=F,e.$ko=E,e.$lo=v,e.$mo=p,e.$no=o,e.$oo=r,e.$po=h,e.$qo=w;function t(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const D=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([A,u])=>{D[A]=u&&typeof u=="object"?t(u):u}),D}function W(l){if(!l||typeof l!="object")return l;const D=[l];for(;D.length>0;){const A=D.shift();Object.freeze(A);for(const u in A)if(j.call(A,u)){const i=A[u];typeof i=="object"&&!Object.isFrozen(i)&&!(0,_.$hg)(i)&&D.push(i)}}return l}const j=Object.prototype.hasOwnProperty;function X(l,D){return k(l,D,new Set)}function k(l,D,A){if((0,_.$ng)(l))return l;const u=D(l);if(typeof u<"u")return u;if(Array.isArray(l)){const i=[];for(const n of l)i.push(k(n,D,A));return i}if((0,_.$gg)(l)){if(A.has(l))throw new Error("Cannot clone recursive data-structure");A.add(l);const i={};for(const n in l)j.call(l,n)&&(i[n]=k(l[n],D,A));return A.delete(l),i}return l}function L(l,D,A=!0){return(0,_.$gg)(l)?((0,_.$gg)(D)&&Object.keys(D).forEach(u=>{u in l?A&&((0,_.$gg)(l[u])&&(0,_.$gg)(D[u])?L(l[u],D[u],A):l[u]=D[u]):l[u]=D[u]}),l):D}function T(l,D){if(l===D)return!0;if(l==null||D===null||D===void 0||typeof l!=typeof D||typeof l!="object"||Array.isArray(l)!==Array.isArray(D))return!1;let A,u;if(Array.isArray(l)){if(l.length!==D.length)return!1;for(A=0;A<l.length;A++)if(!T(l[A],D[A]))return!1}else{const i=[];for(u in l)i.push(u);i.sort();const n=[];for(u in D)n.push(u);if(n.sort(),!T(i,n))return!1;for(A=0;A<i.length;A++)if(!T(l[i[A]],D[i[A]]))return!1}return!0}function F(l){const D=new Set;return JSON.stringify(l,(A,u)=>{if((0,_.$gg)(u)||Array.isArray(u)){if(D.has(u))return"[Circular]";D.add(u)}return typeof u=="bigint"?`[BigInt ${u.toString()}]`:u})}function E(l,D){const A=Object.create(null);return!l||!D||Object.keys(D).forEach(i=>{const n=l[i],s=D[i];T(n,s)||(A[i]=s)}),A}function v(l,D){const A=D.toLowerCase(),u=Object.keys(l).find(i=>i.toLowerCase()===A);return u?l[u]:l[D]}function p(l,D){const A=Object.create(null);for(const[u,i]of Object.entries(l))D(u,i)&&(A[u]=i);return A}function o(l){let D=[];for(;Object.prototype!==l;)D=D.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return D}function r(l){const D=[];for(const A of o(l))typeof l[A]=="function"&&D.push(A);return D}function h(l,D){const A=i=>function(){const n=Array.prototype.slice.call(arguments,0);return D(i,n)},u={};for(const i of l)u[i]=A(i);return u}function w(l,D){const A={};for(const[u,i]of Object.entries(l))A[u]=D(i,u);return A}}),define(be[47],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$af=t,e.$bf=W;var _;(function(j){j[j.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",j[j.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",j[j.MAX_UINT_8=255]="MAX_UINT_8",j[j.MAX_UINT_16=65535]="MAX_UINT_16",j[j.MAX_UINT_32=4294967295]="MAX_UINT_32",j[j.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_||(e.Constants=_={}));function t(j){return j<0?0:j>_.MAX_UINT_8?_.MAX_UINT_8:j|0}function W(j){return j<0?0:j>_.MAX_UINT_32?_.MAX_UINT_32:j|0}}),define(be[7],_e([0,1,43,11,16,47]),function(fe,e,_,t,W,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.GraphemeBreakType=e.$4f=e.$Vf=e.$Of=e.$Nf=void 0,e.$cf=X,e.$df=L,e.$ef=F,e.$ff=E,e.$gf=v,e.$hf=p,e.$if=o,e.$jf=r,e.$kf=h,e.$lf=w,e.$mf=l,e.$nf=D,e.$of=A,e.$pf=u,e.$qf=i,e.$rf=n,e.$sf=s,e.$tf=c,e.$uf=P,e.$vf=m,e.$wf=b,e.$xf=a,e.$yf=d,e.$zf=N,e.$Af=f,e.$Bf=y,e.$Cf=G,e.$Df=C,e.$Ef=x,e.$Ff=K,e.$Gf=se,e.$Hf=V,e.$If=ne,e.$Jf=ce,e.$Kf=re,e.$Lf=I,e.$Mf=$,e.$Pf=R,e.$Qf=J,e.$Rf=ee,e.$Sf=ie,e.$Tf=Ee,e.$Uf=z,e.$Wf=O,e.$Xf=g,e.$Yf=M,e.$Zf=Y,e.$1f=ge,e.$2f=De,e.$3f=he,e.$5f=le,e.$6f=$e,e.$7f=de,e.$8f=we,e.$9f=ye,e.$0f=Le,e.$$f=Ue,e.$_f=Te,e.$ag=Be;function X(U){return!U||typeof U!="string"?!0:U.trim().length===0}const k=/{(\d+)}/g;function L(U,...H){return H.length===0?U:U.replace(k,function(Z,oe){const me=parseInt(oe,10);return isNaN(me)||me<0||me>=H.length?Z:H[me]})}const T=/{([^}]+)}/g;function F(U,H){return Object.keys(H).length===0?U:U.replace(T,(Z,oe)=>H[oe]??Z)}function E(U){return U.replace(/[<>"'&]/g,H=>{switch(H){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return H})}function v(U){return U.replace(/[<>&]/g,function(H){switch(H){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return H}})}function p(U){return U.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function o(U,H){let Z=0,oe=U.indexOf(H);for(;oe!==-1;)Z++,oe=U.indexOf(H,oe+H.length);return Z}function r(U,H,Z="\u2026"){return U.length<=H?U:`${U.substr(0,H)}${Z}`}function h(U,H,Z="\u2026"){if(U.length<=H)return U;const oe=Math.ceil(H/2)-Z.length/2,me=Math.floor(H/2)-Z.length/2;return`${U.substr(0,oe)}${Z}${U.substr(U.length-me)}`}function w(U,H=" "){const Z=l(U,H);return D(Z,H)}function l(U,H){if(!U||!H)return U;const Z=H.length;if(Z===0||U.length===0)return U;let oe=0;for(;U.indexOf(H,oe)===oe;)oe=oe+Z;return U.substring(oe)}function D(U,H){if(!U||!H)return U;const Z=H.length,oe=U.length;if(Z===0||oe===0)return U;let me=oe,ve=-1;for(;ve=U.lastIndexOf(H,me-1),!(ve===-1||ve+Z!==me);){if(ve===0)return"";me=ve}return U.substring(0,me)}function A(U){return U.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function u(U){return U.replace(/\*/g,"")}function i(U,H,Z={}){if(!U)throw new Error("Cannot create regex from empty string");H||(U=p(U)),Z.wholeWord&&(/\B/.test(U.charAt(0))||(U="\\b"+U),/\B/.test(U.charAt(U.length-1))||(U=U+"\\b"));let oe="";return Z.global&&(oe+="g"),Z.matchCase||(oe+="i"),Z.multiline&&(oe+="m"),Z.unicode&&(oe+="u"),new RegExp(U,oe)}function n(U){return U.source==="^"||U.source==="^$"||U.source==="$"||U.source==="^\\s*$"?!1:!!(U.exec("")&&U.lastIndex===0)}function s(U){return U.split(/\r\n|\r|\n/)}function c(U){const H=[],Z=U.split(/(\r\n|\r|\n)/);for(let oe=0;oe<Math.ceil(Z.length/2);oe++)H.push(Z[2*oe]+(Z[2*oe+1]??""));return H}function P(U){for(let H=0,Z=U.length;H<Z;H++){const oe=U.charCodeAt(H);if(oe!==t.CharCode.Space&&oe!==t.CharCode.Tab)return H}return-1}function m(U,H=0,Z=U.length){for(let oe=H;oe<Z;oe++){const me=U.charCodeAt(oe);if(me!==t.CharCode.Space&&me!==t.CharCode.Tab)return U.substring(H,oe)}return U.substring(H,Z)}function b(U,H=U.length-1){for(let Z=H;Z>=0;Z--){const oe=U.charCodeAt(Z);if(oe!==t.CharCode.Space&&oe!==t.CharCode.Tab)return Z}return-1}function a(U,H,Z){const oe=[];let me=0;for(const ve of U.matchAll(H)){if(oe.push(U.slice(me,ve.index)),ve.index===void 0)throw new Error("match.index should be defined");me=ve.index+ve[0].length,oe.push(Z(ve[0],...ve.slice(1),ve.index,U,ve.groups))}return oe.push(U.slice(me)),Promise.all(oe).then(ve=>ve.join(""))}function d(U,H){return U<H?-1:U>H?1:0}function N(U,H,Z=0,oe=U.length,me=0,ve=H.length){for(;Z<oe&&me<ve;Z++,me++){const Ne=U.charCodeAt(Z),ke=H.charCodeAt(me);if(Ne<ke)return-1;if(Ne>ke)return 1}const Oe=oe-Z,Me=ve-me;return Oe<Me?-1:Oe>Me?1:0}function f(U,H){return y(U,H,0,U.length,0,H.length)}function y(U,H,Z=0,oe=U.length,me=0,ve=H.length){for(;Z<oe&&me<ve;Z++,me++){let Ne=U.charCodeAt(Z),ke=H.charCodeAt(me);if(Ne===ke)continue;if(Ne>=128||ke>=128)return N(U.toLowerCase(),H.toLowerCase(),Z,oe,me,ve);C(Ne)&&(Ne-=32),C(ke)&&(ke-=32);const Se=Ne-ke;if(Se!==0)return Se}const Oe=oe-Z,Me=ve-me;return Oe<Me?-1:Oe>Me?1:0}function G(U){return U>=t.CharCode.Digit0&&U<=t.CharCode.Digit9}function C(U){return U>=t.CharCode.a&&U<=t.CharCode.z}function x(U){return U>=t.CharCode.A&&U<=t.CharCode.Z}function K(U,H){return U.length===H.length&&y(U,H)===0}function se(U,H){const Z=H.length;return H.length>U.length?!1:y(U,H,0,Z)===0}function V(U,H){const Z=Math.min(U.length,H.length);let oe;for(oe=0;oe<Z;oe++)if(U.charCodeAt(oe)!==H.charCodeAt(oe))return oe;return Z}function ne(U,H){const Z=Math.min(U.length,H.length);let oe;const me=U.length-1,ve=H.length-1;for(oe=0;oe<Z;oe++)if(U.charCodeAt(me-oe)!==H.charCodeAt(ve-oe))return oe;return Z}function ce(U){return 55296<=U&&U<=56319}function re(U){return 56320<=U&&U<=57343}function I(U,H){return(U-55296<<10)+(H-56320)+65536}function $(U,H,Z){const oe=U.charCodeAt(Z);if(ce(oe)&&Z+1<H){const me=U.charCodeAt(Z+1);if(re(me))return I(oe,me)}return oe}function S(U,H){const Z=U.charCodeAt(H-1);if(re(Z)&&H>1){const oe=U.charCodeAt(H-2);if(ce(oe))return I(oe,Z)}return Z}class q{get offset(){return this.e}constructor(H,Z=0){this.c=H,this.d=H.length,this.e=Z}setOffset(H){this.e=H}prevCodePoint(){const H=S(this.c,this.e);return this.e-=H>=j.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,H}nextCodePoint(){const H=$(this.c,this.d,this.e);return this.e+=H>=j.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,H}eol(){return this.e>=this.d}}e.$Nf=q;class Q{get offset(){return this.c.offset}constructor(H,Z=0){this.c=new q(H,Z)}nextGraphemeLength(){const H=Pe.getInstance(),Z=this.c,oe=Z.offset;let me=H.getGraphemeBreakType(Z.nextCodePoint());for(;!Z.eol();){const ve=Z.offset,Oe=H.getGraphemeBreakType(Z.nextCodePoint());if(pe(me,Oe)){Z.setOffset(ve);break}me=Oe}return Z.offset-oe}prevGraphemeLength(){const H=Pe.getInstance(),Z=this.c,oe=Z.offset;let me=H.getGraphemeBreakType(Z.prevCodePoint());for(;Z.offset>0;){const ve=Z.offset,Oe=H.getGraphemeBreakType(Z.prevCodePoint());if(pe(Oe,me)){Z.setOffset(ve);break}me=Oe}return oe-Z.offset}eol(){return this.c.eol()}}e.$Of=Q;function R(U,H){return new Q(U,H).nextGraphemeLength()}function J(U,H){return new Q(U,H).prevGraphemeLength()}function ee(U,H){H>0&&re(U.charCodeAt(H))&&H--;const Z=H+R(U,H);return[Z-J(U,Z),Z]}function ie(U){const H=new Q(U);let Z=0;for(;!H.eol();)Z++,H.nextGraphemeLength();return Z}let ue;function ae(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ee(U){return ue||(ue=ae()),ue.test(U)}const B=/^[\t\n\r\x20-\x7E]*$/;function z(U){return B.test(U)}e.$Vf=/[\u2028\u2029]/;function O(U){return e.$Vf.test(U)}function g(U){return U>=11904&&U<=55215||U>=63744&&U<=64255||U>=65281&&U<=65374}function M(U){return U>=127462&&U<=127487||U===8986||U===8987||U===9200||U===9203||U>=9728&&U<=10175||U===11088||U===11093||U>=127744&&U<=128591||U>=128640&&U<=128764||U>=128992&&U<=129008||U>=129280&&U<=129535||U>=129648&&U<=129782}function Y(U,H,Z=""){const oe=U.trimStart();if(oe.length<H)return oe;const me=/\b/g;let ve=0;for(;me.test(oe)&&!(oe.length-me.lastIndex<H);)ve=me.lastIndex,me.lastIndex+=1;return ve===0?oe:Z+oe.substring(ve).trimStart()}const te=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ge(U){let H=0;for(const Z of U.matchAll(te))H!==Z.index&&(yield{isCode:!1,str:U.substring(H,Z.index)}),yield{isCode:!0,str:Z[0]},H=Z.index+Z[0].length;H!==U.length&&(yield{isCode:!1,str:U.substring(H)})}function De(U){return U&&(U=U.replace(te,"")),U}const Re=/\\\[.*?\\\]/g;function he(U){return De(U).replace(Re,"")}e.$4f=String.fromCharCode(t.CharCode.UTF8_BOM);function le(U){return!!(U&&U.length>0&&U.charCodeAt(0)===t.CharCode.UTF8_BOM)}function $e(U){return le(U)?U.substr(1):U}function de(U,H){if(!U||!H||U.length<H.length)return!1;const Z=H.length,oe=U.toLowerCase();let me=0,ve=-1;for(;me<Z;){const Oe=oe.indexOf(H[me],ve+1);if(Oe<0)return!1;ve=Oe,me++}return!0}function we(U,H=!1){return U?(H&&(U=U.replace(/\\./g,"")),U.toLowerCase()!==U):!1}function ye(U){return U.charAt(0).toUpperCase()+U.slice(1)}function Le(U,H=1){if(H===0)return"";let Z=-1;do Z=U.indexOf(`
`,Z+1),H--;while(H>0&&Z>=0);return Z===-1?U:(U[Z-1]==="\r"&&Z--,U.substr(0,Z))}function Ue(U){const H=t.CharCode.Z-t.CharCode.A+1;return U=U%(2*H),U<H?String.fromCharCode(t.CharCode.a+U):String.fromCharCode(t.CharCode.A+U-H)}function Te(U){return Pe.getInstance().getGraphemeBreakType(U)}function pe(U,H){return U===Ae.Other?H!==Ae.Extend&&H!==Ae.SpacingMark:U===Ae.CR&&H===Ae.LF?!1:U===Ae.Control||U===Ae.CR||U===Ae.LF||H===Ae.Control||H===Ae.CR||H===Ae.LF?!0:!(U===Ae.L&&(H===Ae.L||H===Ae.V||H===Ae.LV||H===Ae.LVT)||(U===Ae.LV||U===Ae.V)&&(H===Ae.V||H===Ae.T)||(U===Ae.LVT||U===Ae.T)&&H===Ae.T||H===Ae.Extend||H===Ae.ZWJ||H===Ae.SpacingMark||U===Ae.Prepend||U===Ae.ZWJ&&H===Ae.Extended_Pictographic||U===Ae.Regional_Indicator&&H===Ae.Regional_Indicator)}var Ae;(function(U){U[U.Other=0]="Other",U[U.Prepend=1]="Prepend",U[U.CR=2]="CR",U[U.LF=3]="LF",U[U.Control=4]="Control",U[U.Extend=5]="Extend",U[U.Regional_Indicator=6]="Regional_Indicator",U[U.SpacingMark=7]="SpacingMark",U[U.L=8]="L",U[U.V=9]="V",U[U.T=10]="T",U[U.LV=11]="LV",U[U.LVT=12]="LVT",U[U.ZWJ=13]="ZWJ",U[U.Extended_Pictographic=14]="Extended_Pictographic"})(Ae||(e.GraphemeBreakType=Ae={}));class Pe{static{this.c=null}static getInstance(){return Pe.c||(Pe.c=new Pe),Pe.c}constructor(){this.d=ze()}getGraphemeBreakType(H){if(H<32)return H===t.CharCode.LineFeed?Ae.LF:H===t.CharCode.CarriageReturn?Ae.CR:Ae.Control;if(H<127)return Ae.Other;const Z=this.d,oe=Z.length/3;let me=1;for(;me<=oe;)if(H<Z[3*me])me=2*me;else if(H>Z[3*me+1])me=2*me+1;else return Z[3*me+2];return Ae.Other}}function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Be(U,H){if(U===0)return 0;const Z=Ke(U,H);if(Z!==void 0)return Z;const oe=new q(H,U);return oe.prevCodePoint(),oe.offset}function Ke(U,H){const Z=new q(H,U);let oe=Z.prevCodePoint();for(;Ve(oe)||oe===Ge.emojiVariantSelector||oe===Ge.enclosingKeyCap;){if(Z.offset===0)return;oe=Z.prevCodePoint()}if(!M(oe))return;let me=Z.offset;return me>0&&Z.prevCodePoint()===Ge.zwj&&(me=Z.offset),me}function Ve(U){return 127995<=U&&U<=127999}var Ge;(function(U){U[U.zwj=8205]="zwj",U[U.emojiVariantSelector=65039]="emojiVariantSelector",U[U.enclosingKeyCap=8419]="enclosingKeyCap"})(Ge||(Ge={})),e.$bg="\xA0";class qe{static{this.c=new W.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new _.$$e({getCacheKey:JSON.stringify},H=>{function Z(Se){const je=new Map;for(let Fe=0;Fe<Se.length;Fe+=2)je.set(Se[Fe],Se[Fe+1]);return je}function oe(Se,je){const Fe=new Map(Se);for(const[He,Xe]of je)Fe.set(He,Xe);return Fe}function me(Se,je){if(!Se)return je;const Fe=new Map;for(const[He,Xe]of Se)je.has(He)&&Fe.set(He,Xe);return Fe}const ve=this.c.value;let Oe=H.filter(Se=>!Se.startsWith("_")&&Se in ve);Oe.length===0&&(Oe=["_default"]);let Me;for(const Se of Oe){const je=Z(ve[Se]);Me=me(Me,je)}const Ne=Z(ve._common),ke=oe(Ne,Me);return new qe(ke)})}static getInstance(H){return qe.d.get(Array.from(H))}static{this.e=new W.$T(()=>Object.keys(qe.c.value).filter(H=>!H.startsWith("_")))}static getLocales(){return qe.e.value}constructor(H){this.f=H}isAmbiguous(H){return this.f.has(H)}containsAmbiguousCharacter(H){for(let Z=0;Z<H.length;Z++){const oe=H.codePointAt(Z);if(typeof oe=="number"&&this.isAmbiguous(oe))return!0}return!1}getPrimaryConfusable(H){return this.f.get(H)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$cg=qe;class We{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(We.c())),this.d}static isInvisibleCharacter(H){return We.e().has(H)}static containsInvisibleCharacter(H){for(let Z=0;Z<H.length;Z++){const oe=H.codePointAt(Z);if(typeof oe=="number"&&We.isInvisibleCharacter(oe))return!0}return!1}static get codePoints(){return We.e()}}e.$dg=We}),define(be[14],_e([0,1,11,3,2,7,10]),function(fe,e,_,t,W,j,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=k,e.$yg=L,e.$zg=T,e.$Ag=F,e.$Bg=E,e.$Cg=r,e.$Dg=h,e.$Eg=w,e.$Fg=l,e.$Gg=D,e.$Hg=A,e.$Ig=u,e.$Jg=i,e.$Kg=n,e.$Lg=s,e.$Mg=c,e.$Ng=b;function k(a){return a===_.CharCode.Slash||a===_.CharCode.Backslash}function L(a){return a.replace(/[\\/]/g,t.$gc.sep)}function T(a){return a.indexOf("/")===-1&&(a=L(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}function F(a,d=t.$gc.sep){if(!a)return"";const N=a.length,f=a.charCodeAt(0);if(k(f)){if(k(a.charCodeAt(1))&&!k(a.charCodeAt(2))){let G=3;const C=G;for(;G<N&&!k(a.charCodeAt(G));G++);if(C!==G&&!k(a.charCodeAt(G+1))){for(G+=1;G<N;G++)if(k(a.charCodeAt(G)))return a.slice(0,G+1).replace(/[\\/]/g,d)}}return d}else if(l(f)&&a.charCodeAt(1)===_.CharCode.Colon)return k(a.charCodeAt(2))?a.slice(0,2)+d:a.slice(0,2);let y=a.indexOf("://");if(y!==-1){for(y+=3;y<N;y++)if(k(a.charCodeAt(y)))return a.slice(0,y+1)}return""}function E(a){if(!W.$j||!a||a.length<5)return!1;let d=a.charCodeAt(0);if(d!==_.CharCode.Backslash||(d=a.charCodeAt(1),d!==_.CharCode.Backslash))return!1;let N=2;const f=N;for(;N<a.length&&(d=a.charCodeAt(N),d!==_.CharCode.Backslash);N++);return!(f===N||(d=a.charCodeAt(N+1),isNaN(d)||d===_.CharCode.Backslash))}const v=/[\\/:\*\?"<>\|]/g,p=/[/]/g,o=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(a,d=W.$j){const N=d?v:p;return!(!a||a.length===0||/^\s+$/.test(a)||(N.lastIndex=0,N.test(a))||d&&o.test(a)||a==="."||a===".."||d&&a[a.length-1]==="."||d&&a.length!==a.trim().length||a.length>255)}function h(a,d,N){const f=a===d;return!N||f?f:!a||!d?!1:(0,j.$Ff)(a,d)}function w(a,d,N,f=t.sep){if(a===d)return!0;if(!a||!d||d.length>a.length)return!1;if(N){if(!(0,j.$Gf)(a,d))return!1;if(d.length===a.length)return!0;let G=d.length;return d.charAt(d.length-1)===f&&G--,a.charAt(G)===f}return d.charAt(d.length-1)!==f&&(d+=f),a.indexOf(d)===0}function l(a){return a>=_.CharCode.A&&a<=_.CharCode.Z||a>=_.CharCode.a&&a<=_.CharCode.z}function D(a,d){return W.$j&&a.endsWith(":")&&(a+=t.sep),(0,t.$ic)(a)||(a=(0,t.$jc)(d,a)),a=(0,t.$hc)(a),A(a)}function A(a){return W.$j?(a=(0,j.$nf)(a,t.sep),a.endsWith(":")&&(a+=t.sep)):(a=(0,j.$nf)(a,t.sep),a||(a=t.sep)),a}function u(a){const d=(0,t.$hc)(a);return W.$j?a.length>3?!1:i(d)&&(a.length===2||d.charCodeAt(2)===_.CharCode.Backslash):d===t.$gc.sep}function i(a,d=W.$j){return d?l(a.charCodeAt(0))&&a.charCodeAt(1)===_.CharCode.Colon:!1}function n(a,d=W.$j){return i(a,d)?a[0]:void 0}function s(a,d,N){return d.length>a.length?-1:a===d?0:(N&&(a=a.toLowerCase(),d=d.toLowerCase()),a.indexOf(d))}function c(a){const d=a.split(":");let N,f,y;for(const G of d){const C=Number(G);(0,X.$ig)(C)?f===void 0?f=C:y===void 0&&(y=C):N=N?[N,G].join(":"):G}if(!N)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:N,line:f!==void 0?f:void 0,column:y!==void 0?y:f!==void 0?1:void 0}}const P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",m="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(a,d,N=8){let f="";for(let G=0;G<N;G++){let C;G===0&&W.$j&&!d&&(N===3||N===4)?C=m:C=P,f+=C.charAt(Math.floor(Math.random()*C.length))}let y;return d?y=`${d}-${f}`:y=f,a?(0,t.$jc)(a,y):y}}),define(be[30],_e([0,1,12,11,7]),function(fe,e,_,t,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class j{constructor(){this.b="",this.c=0}reset(o){return this.b=o,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(o){const r=o.charCodeAt(0),h=this.b.charCodeAt(this.c);return r-h}value(){return this.b[this.c]}}e.$Hi=j;class X{constructor(o=!0){this.e=o}reset(o){return this.b=o,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let o=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===t.CharCode.Period)if(o)this.c++;else break;else o=!1;return this}cmp(o){return this.e?(0,W.$zf)(o,this.b,0,o.length,this.c,this.d):(0,W.$Bf)(o,this.b,0,o.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=X;class k{constructor(o=!0,r=!0){this.f=o,this.g=r}reset(o){this.d=0,this.e=0,this.b=o,this.c=o.length;for(let r=o.length-1;r>=0;r--,this.c--){const h=this.b.charCodeAt(r);if(!(h===t.CharCode.Slash||this.f&&h===t.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let o=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===t.CharCode.Slash||this.f&&r===t.CharCode.Backslash)if(o)this.d++;else break;else o=!1}return this}cmp(o){return this.g?(0,W.$zf)(o,this.b,0,o.length,this.d,this.e):(0,W.$Bf)(o,this.b,0,o.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=k;var L;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(L||(L={}));class T{constructor(o,r){this.f=o,this.g=r,this.d=[],this.e=0}reset(o){return this.c=o,this.d=[],this.c.scheme&&this.d.push(L.Scheme),this.c.authority&&this.d.push(L.Authority),this.c.path&&(this.b=new k(!1,!this.f(o)),this.b.reset(o.path),this.b.value()&&this.d.push(L.Path)),this.g(o)||(this.c.query&&this.d.push(L.Query),this.c.fragment&&this.d.push(L.Fragment)),this.e=0,this}next(){return this.d[this.e]===L.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===L.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(o){if(this.d[this.e]===L.Scheme)return(0,W.$Af)(o,this.c.scheme);if(this.d[this.e]===L.Authority)return(0,W.$Af)(o,this.c.authority);if(this.d[this.e]===L.Path)return this.b.cmp(o);if(this.d[this.e]===L.Query)return(0,W.$yf)(o,this.c.query);if(this.d[this.e]===L.Fragment)return(0,W.$yf)(o,this.c.fragment);throw new Error}value(){if(this.d[this.e]===L.Scheme)return this.c.scheme;if(this.d[this.e]===L.Authority)return this.c.authority;if(this.d[this.e]===L.Path)return this.b.value();if(this.d[this.e]===L.Query)return this.c.query;if(this.d[this.e]===L.Fragment)return this.c.fragment;throw new Error}}e.$Ki=T;class F{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const o=this.right;return this.right=o.left,o.left=this,this.updateHeight(),o.updateHeight(),o}rotateRight(){const o=this.left;return this.left=o.right,o.right=this,this.updateHeight(),o.updateHeight(),o}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(E||(E={}));class v{static forUris(o=()=>!1,r=()=>!1){return new v(new T(o,r))}static forPaths(o=!1){return new v(new k(void 0,!o))}static forStrings(){return new v(new j)}static forConfigKeys(){return new v(new X)}constructor(o){this.b=o}clear(){this.c=void 0}fill(o,r){if(r){const h=r.slice(0);(0,_.$Vb)(h);for(const w of h)this.set(w,o)}else{const h=o.slice(0);(0,_.$Vb)(h);for(const w of h)this.set(w[0],w[1])}}set(o,r){const h=this.b.reset(o);let w;this.c||(this.c=new F,this.c.segment=h.value());const l=[];for(w=this.c;;){const A=h.cmp(w.segment);if(A>0)w.left||(w.left=new F,w.left.segment=h.value()),l.push([E.Left,w]),w=w.left;else if(A<0)w.right||(w.right=new F,w.right.segment=h.value()),l.push([E.Right,w]),w=w.right;else if(h.hasNext())h.next(),w.mid||(w.mid=new F,w.mid.segment=h.value()),l.push([E.Mid,w]),w=w.mid;else break}const D=w.value;w.value=r,w.key=o;for(let A=l.length-1;A>=0;A--){const u=l[A][1];u.updateHeight();const i=u.balanceFactor();if(i<-1||i>1){const n=l[A][0],s=l[A+1][0];if(n===E.Right&&s===E.Right)l[A][1]=u.rotateLeft();else if(n===E.Left&&s===E.Left)l[A][1]=u.rotateRight();else if(n===E.Right&&s===E.Left)u.right=l[A+1][1]=l[A+1][1].rotateRight(),l[A][1]=u.rotateLeft();else if(n===E.Left&&s===E.Right)u.left=l[A+1][1]=l[A+1][1].rotateLeft(),l[A][1]=u.rotateRight();else throw new Error;if(A>0)switch(l[A-1][0]){case E.Left:l[A-1][1].left=l[A][1];break;case E.Right:l[A-1][1].right=l[A][1];break;case E.Mid:l[A-1][1].mid=l[A][1];break}else this.c=l[0][1]}}return D}get(o){return this.d(o)?.value}d(o){const r=this.b.reset(o);let h=this.c;for(;h;){const w=r.cmp(h.segment);if(w>0)h=h.left;else if(w<0)h=h.right;else if(r.hasNext())r.next(),h=h.mid;else break}return h}has(o){const r=this.d(o);return!(r?.value===void 0&&r?.mid===void 0)}delete(o){return this.e(o,!1)}deleteSuperstr(o){return this.e(o,!0)}e(o,r){const h=this.b.reset(o),w=[];let l=this.c;for(;l;){const D=h.cmp(l.segment);if(D>0)w.push([E.Left,l]),l=l.left;else if(D<0)w.push([E.Right,l]),l=l.right;else if(h.hasNext())h.next(),w.push([E.Mid,l]),l=l.mid;else break}if(l){if(r?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const D=this.f(l.right);if(D.key){const{key:A,value:u,segment:i}=D;this.e(D.key,!1),l.key=A,l.value=u,l.segment=i}}else{const D=l.left??l.right;if(w.length>0){const[A,u]=w[w.length-1];switch(A){case E.Left:u.left=D;break;case E.Mid:u.mid=D;break;case E.Right:u.right=D;break}}else this.c=D}for(let D=w.length-1;D>=0;D--){const A=w[D][1];A.updateHeight();const u=A.balanceFactor();if(u>1?(A.right.balanceFactor()>=0||(A.right=A.right.rotateRight()),w[D][1]=A.rotateLeft()):u<-1&&(A.left.balanceFactor()<=0||(A.left=A.left.rotateLeft()),w[D][1]=A.rotateRight()),D>0)switch(w[D-1][0]){case E.Left:w[D-1][1].left=w[D][1];break;case E.Right:w[D-1][1].right=w[D][1];break;case E.Mid:w[D-1][1].mid=w[D][1];break}else this.c=w[0][1]}}}f(o){for(;o.left;)o=o.left;return o}findSubstr(o){const r=this.b.reset(o);let h=this.c,w;for(;h;){const l=r.cmp(h.segment);if(l>0)h=h.left;else if(l<0)h=h.right;else if(r.hasNext())r.next(),w=h.value||w,h=h.mid;else break}return h&&h.value||w}findSuperstr(o){return this.g(o,!1)}g(o,r){const h=this.b.reset(o);let w=this.c;for(;w;){const l=h.cmp(w.segment);if(l>0)w=w.left;else if(l<0)w=w.right;else if(h.hasNext())h.next(),w=w.mid;else return w.mid?this.h(w.mid):r?w.value:void 0}}hasElementOrSubtree(o){return this.g(o,!0)!==void 0}forEach(o){for(const[r,h]of this)o(h,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(o){const r=[];return this.j(o,r),r[Symbol.iterator]()}j(o,r){o&&(o.left&&this.j(o.left,r),o.value&&r.push([o.key,o.value]),o.mid&&this.j(o.mid,r),o.right&&this.j(o.right,r))}_isBalanced(){const o=r=>{if(!r)return!0;const h=r.balanceFactor();return h<-1||h>1?!1:o(r.left)&&o(r.right)};return o(this.c)}}e.$Li=v}),define(be[5],_e([0,1,11,27,3,2]),function(fe,e,_,t,W,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=h,e.$wc=i,W=Ie(W);const X=/^\w[\w\d+.-]*$/,k=/^\//,L=/^\/\//;function T(m,b){if(!m.scheme&&b)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${m.authority}", path: "${m.path}", query: "${m.query}", fragment: "${m.fragment}"}`);if(m.scheme&&!X.test(m.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(m.path){if(m.authority){if(!k.test(m.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(m.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function F(m,b){return!m&&!b?"file":m}function E(m,b){switch(m){case"https":case"http":case"file":b?b[0]!==p&&(b=p+b):b=p;break}return b}const v="",p="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class r{static isUri(b){return b instanceof r?!0:b?typeof b.authority=="string"&&typeof b.fragment=="string"&&typeof b.path=="string"&&typeof b.query=="string"&&typeof b.scheme=="string"&&typeof b.fsPath=="string"&&typeof b.with=="function"&&typeof b.toString=="function":!1}constructor(b,a,d,N,f,y=!1){typeof b=="object"?(this.scheme=b.scheme||v,this.authority=b.authority||v,this.path=b.path||v,this.query=b.query||v,this.fragment=b.fragment||v):(this.scheme=F(b,y),this.authority=a||v,this.path=E(this.scheme,d||v),this.query=N||v,this.fragment=f||v,T(this,y))}get fsPath(){return i(this,!1)}with(b){if(!b)return this;let{scheme:a,authority:d,path:N,query:f,fragment:y}=b;return a===void 0?a=this.scheme:a===null&&(a=v),d===void 0?d=this.authority:d===null&&(d=v),N===void 0?N=this.path:N===null&&(N=v),f===void 0?f=this.query:f===null&&(f=v),y===void 0?y=this.fragment:y===null&&(y=v),a===this.scheme&&d===this.authority&&N===this.path&&f===this.query&&y===this.fragment?this:new l(a,d,N,f,y)}static parse(b,a=!1){const d=o.exec(b);return d?new l(d[2]||v,P(d[4]||v),P(d[5]||v),P(d[7]||v),P(d[9]||v),a):new l(v,v,v,v,v)}static file(b){let a=v;if(j.$j&&(b=b.replace(/\\/g,p)),b[0]===p&&b[1]===p){const d=b.indexOf(p,2);d===-1?(a=b.substring(2),b=p):(a=b.substring(2,d),b=b.substring(d)||p)}return new l("file",a,b,v,v)}static from(b,a){return new l(b.scheme,b.authority,b.path,b.query,b.fragment,a)}static joinPath(b,...a){if(!b.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return j.$j&&b.scheme==="file"?d=r.file(W.$fc.join(i(b,!0),...a)).path:d=W.$gc.join(b.path,...a),b.with({path:d})}toString(b=!1){return n(this,b)}toJSON(){return this}static revive(b){if(b){if(b instanceof r)return b;{const a=new l(b);return a._formatted=b.external??null,a._fsPath=b._sep===w?b.fsPath??null:null,a}}else return b}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=r;function h(m){return!m||typeof m!="object"?!1:typeof m.scheme=="string"&&(typeof m.authority=="string"||typeof m.authority>"u")&&(typeof m.path=="string"||typeof m.path>"u")&&(typeof m.query=="string"||typeof m.query>"u")&&(typeof m.fragment=="string"||typeof m.fragment>"u")}const w=j.$j?1:void 0;class l extends r{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(b=!1){return b?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const b={$mid:t.MarshalledId.Uri};return this._fsPath&&(b.fsPath=this._fsPath,b._sep=w),this._formatted&&(b.external=this._formatted),this.path&&(b.path=this.path),this.scheme&&(b.scheme=this.scheme),this.authority&&(b.authority=this.authority),this.query&&(b.query=this.query),this.fragment&&(b.fragment=this.fragment),b}}const D={[_.CharCode.Colon]:"%3A",[_.CharCode.Slash]:"%2F",[_.CharCode.QuestionMark]:"%3F",[_.CharCode.Hash]:"%23",[_.CharCode.OpenSquareBracket]:"%5B",[_.CharCode.CloseSquareBracket]:"%5D",[_.CharCode.AtSign]:"%40",[_.CharCode.ExclamationMark]:"%21",[_.CharCode.DollarSign]:"%24",[_.CharCode.Ampersand]:"%26",[_.CharCode.SingleQuote]:"%27",[_.CharCode.OpenParen]:"%28",[_.CharCode.CloseParen]:"%29",[_.CharCode.Asterisk]:"%2A",[_.CharCode.Plus]:"%2B",[_.CharCode.Comma]:"%2C",[_.CharCode.Semicolon]:"%3B",[_.CharCode.Equals]:"%3D",[_.CharCode.Space]:"%20"};function A(m,b,a){let d,N=-1;for(let f=0;f<m.length;f++){const y=m.charCodeAt(f);if(y>=_.CharCode.a&&y<=_.CharCode.z||y>=_.CharCode.A&&y<=_.CharCode.Z||y>=_.CharCode.Digit0&&y<=_.CharCode.Digit9||y===_.CharCode.Dash||y===_.CharCode.Period||y===_.CharCode.Underline||y===_.CharCode.Tilde||b&&y===_.CharCode.Slash||a&&y===_.CharCode.OpenSquareBracket||a&&y===_.CharCode.CloseSquareBracket||a&&y===_.CharCode.Colon)N!==-1&&(d+=encodeURIComponent(m.substring(N,f)),N=-1),d!==void 0&&(d+=m.charAt(f));else{d===void 0&&(d=m.substr(0,f));const G=D[y];G!==void 0?(N!==-1&&(d+=encodeURIComponent(m.substring(N,f)),N=-1),d+=G):N===-1&&(N=f)}}return N!==-1&&(d+=encodeURIComponent(m.substring(N))),d!==void 0?d:m}function u(m){let b;for(let a=0;a<m.length;a++){const d=m.charCodeAt(a);d===_.CharCode.Hash||d===_.CharCode.QuestionMark?(b===void 0&&(b=m.substr(0,a)),b+=D[d]):b!==void 0&&(b+=m[a])}return b!==void 0?b:m}function i(m,b){let a;return m.authority&&m.path.length>1&&m.scheme==="file"?a=`//${m.authority}${m.path}`:m.path.charCodeAt(0)===_.CharCode.Slash&&(m.path.charCodeAt(1)>=_.CharCode.A&&m.path.charCodeAt(1)<=_.CharCode.Z||m.path.charCodeAt(1)>=_.CharCode.a&&m.path.charCodeAt(1)<=_.CharCode.z)&&m.path.charCodeAt(2)===_.CharCode.Colon?b?a=m.path.substr(1):a=m.path[1].toLowerCase()+m.path.substr(2):a=m.path,j.$j&&(a=a.replace(/\//g,"\\")),a}function n(m,b){const a=b?u:A;let d="",{scheme:N,authority:f,path:y,query:G,fragment:C}=m;if(N&&(d+=N,d+=":"),(f||N==="file")&&(d+=p,d+=p),f){let x=f.indexOf("@");if(x!==-1){const K=f.substr(0,x);f=f.substr(x+1),x=K.lastIndexOf(":"),x===-1?d+=a(K,!1,!1):(d+=a(K.substr(0,x),!1,!1),d+=":",d+=a(K.substr(x+1),!1,!0)),d+="@"}f=f.toLowerCase(),x=f.lastIndexOf(":"),x===-1?d+=a(f,!1,!0):(d+=a(f.substr(0,x),!1,!0),d+=f.substr(x))}if(y){if(y.length>=3&&y.charCodeAt(0)===_.CharCode.Slash&&y.charCodeAt(2)===_.CharCode.Colon){const x=y.charCodeAt(1);x>=_.CharCode.A&&x<=_.CharCode.Z&&(y=`/${String.fromCharCode(x+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===_.CharCode.Colon){const x=y.charCodeAt(0);x>=_.CharCode.A&&x<=_.CharCode.Z&&(y=`${String.fromCharCode(x+32)}:${y.substr(2)}`)}d+=a(y,!0,!1)}return G&&(d+="?",d+=a(G,!1,!1)),C&&(d+="#",d+=b?C:A(C,!1,!1)),d}function s(m){try{return decodeURIComponent(m)}catch{return m.length>3?m.substr(0,3)+s(m.substr(3)):m}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function P(m){return m.match(c)?m.replace(c,b=>s(b)):m}}),define(be[48],_e([0,1,5]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=t,e.$er=W,e.$fr=j,e.log=k;function t(T){const F=T;return F&&typeof F.type=="string"&&typeof F.severity=="string"}function W(T){const F=[];let E;try{const v=JSON.parse(T.arguments),p=v[v.length-1];p&&p.__$stack&&(v.pop(),E=p.__$stack),F.push(...v)}catch{F.push("Unable to log remote console arguments",T.arguments)}return{args:F,stack:E}}function j(T){if(typeof T!="string")return j(W(T).stack);const F=T;if(F){const E=X(F),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(v&&v.length===4)return{uri:_.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}function X(T){if(!T)return T;const F=T.indexOf(`
`);return F===-1?T:T.substring(0,F)}function k(T,F){const{args:E,stack:v}=W(T),p=typeof E[0]=="string"&&E.length===1;let o=X(v);o&&(o=`(${o.trim()})`);let r=[];if(typeof E[0]=="string"?o&&p?r=[`%c[${F}] %c${E[0]} %c${o}`,L("blue"),L(""),L("grey")]:r=[`%c[${F}] %c${E[0]}`,L("blue"),L(""),...E.slice(1)]:r=[`%c[${F}]%`,L("blue"),...E],o&&!p&&r.push(o),typeof console[T.severity]!="function")throw new Error("Unknown console method");console[T.severity].apply(console,r)}function L(T){return`color: ${T}`}}),define(be[49],_e([0,1,17,5,27]),function(fe,e,_,t,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=j,e.$bi=X,e.$ci=L;function j(T){return JSON.stringify(T,k)}function X(T){let F=JSON.parse(T);return F=L(F),F}function k(T,F){return F instanceof RegExp?{$mid:W.MarshalledId.Regexp,source:F.source,flags:F.flags}:F}function L(T,F=0){if(!T||F>200)return T;if(typeof T=="object"){switch(T.$mid){case W.MarshalledId.Uri:return t.URI.revive(T);case W.MarshalledId.Regexp:return new RegExp(T.source,T.flags);case W.MarshalledId.Date:return new Date(T.source)}if(T instanceof _.$Ne||T instanceof Uint8Array)return T;if(Array.isArray(T))for(let E=0;E<T.length;++E)T[E]=L(T[E],F+1);else for(const E in T)Object.hasOwnProperty.call(T,E)&&(T[E]=L(T[E],F+1))}return T}}),define(be[31],_e([0,1,9,2,7,5,3]),function(fe,e,_,t,W,j,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=L,e.$Pg=T,e.$Tg=E,_=Ie(_),t=Ie(t),X=Ie(X);var k;(function(o){o.inMemory="inmemory",o.vscode="vscode",o.internal="private",o.walkThrough="walkThrough",o.walkThroughSnippet="walkThroughSnippet",o.http="http",o.https="https",o.file="file",o.mailto="mailto",o.untitled="untitled",o.data="data",o.command="command",o.vscodeRemote="vscode-remote",o.vscodeRemoteResource="vscode-remote-resource",o.vscodeManagedRemoteResource="vscode-managed-remote-resource",o.vscodeUserData="vscode-userdata",o.vscodeCustomEditor="vscode-custom-editor",o.vscodeNotebookCell="vscode-notebook-cell",o.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",o.vscodeNotebookCellOutput="vscode-notebook-cell-output",o.vscodeInteractiveInput="vscode-interactive-input",o.vscodeSettings="vscode-settings",o.vscodeWorkspaceTrust="vscode-workspace-trust",o.vscodeTerminal="vscode-terminal",o.vscodeChatCodeBlock="vscode-chat-code-block",o.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",o.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",o.vscodeChatSesssion="vscode-chat-editor",o.webviewPanel="webview-panel",o.vscodeWebview="vscode-webview",o.extension="extension",o.vscodeFileResource="vscode-file",o.tmp="tmp",o.vsls="vsls",o.vscodeSourceControl="vscode-scm",o.commentsInput="comment",o.codeSetting="code-setting"})(k||(e.Schemas=k={}));function L(o,r){return j.URI.isUri(o)?(0,W.$Ff)(o.scheme,r):(0,W.$Gf)(o,r+":")}function T(o,...r){return r.some(h=>L(o,h))}e.$Qg="vscode-tkn",e.$Rg="tkn";class F{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,h){this.f=E(r,h)}getServerRootPath(){return this.f}get g(){return X.$gc.join(this.f,k.vscodeRemoteResource)}set(r,h,w){this.a[r]=h,this.b[r]=w}setConnectionToken(r,h){this.c[r]=h}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(u){return _.$Y(u),r}const h=r.authority;let w=this.a[h];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const l=this.b[h],D=this.c[h];let A=`path=${encodeURIComponent(r.path)}`;return typeof D=="string"&&(A+=`&${e.$Rg}=${encodeURIComponent(D)}`),j.URI.from({scheme:t.$p?this.d:k.vscodeRemoteResource,authority:`${w}:${l}`,path:this.g,query:A})}}e.$Sg=new F;function E(o,r){return X.$gc.join(r??"/",`${o.quality??"oss"}-${o.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class v{static{this.a=e.$Yg}asBrowserUri(r){const h=this.b(r,fe);return this.uriToBrowserUri(h)}uriToBrowserUri(r){return r.scheme===k.vscodeRemote?e.$Sg.rewrite(r):r.scheme===k.file&&(t.$n||t.$r===`${k.vscodeFileResource}://${v.a}`)?r.with({scheme:k.vscodeFileResource,authority:r.authority||v.a,query:null,fragment:null}):r}asFileUri(r){const h=this.b(r,fe);return this.uriToFileUri(h)}uriToFileUri(r){return r.scheme===k.vscodeFileResource?r.with({scheme:k.file,authority:r.authority!==v.a?r.authority:null,query:null,fragment:null}):r}b(r,h){return j.URI.isUri(r)?r:j.URI.parse(h.toUrl(r))}}e.$Zg=new v;var p;(function(o){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);o.CoopAndCoep=Object.freeze(r.get("3"));const h="vscode-coi";function w(D){let A;typeof D=="string"?A=new URL(D).searchParams:D instanceof URL?A=D.searchParams:j.URI.isUri(D)&&(A=new URL(D.toString(!0)).searchParams);const u=A?.get(h);if(u)return r.get(u)}o.getHeadersFromQuery=w;function l(D,A,u){if(!globalThis.crossOriginIsolated)return;const i=A&&u?"3":u?"2":"1";D instanceof URLSearchParams?D.set(h,i):D[h]=i}o.addSearchParam=l})(p||(e.COI=p={}))}),define(be[22],_e([0,1,11,14,31,3,2,7,5]),function(fe,e,_,t,W,j,X,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=T,e.$ph=E,e.$qh=p,t=Ie(t),j=Ie(j);function T(o){return(0,L.$wc)(o,!0)}class F{constructor(r){this.a=r}compare(r,h,w=!1){return r===h?0:(0,k.$yf)(this.getComparisonKey(r,w),this.getComparisonKey(h,w))}isEqual(r,h,w=!1){return r===h?!0:!r||!h?!1:this.getComparisonKey(r,w)===this.getComparisonKey(h,w)}getComparisonKey(r,h=!1){return r.with({path:this.a(r)?r.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(r){return this.a(r)}isEqualOrParent(r,h,w=!1){if(r.scheme===h.scheme){if(r.scheme===W.Schemas.file)return t.$Eg(T(r),T(h),this.a(r))&&r.query===h.query&&(w||r.fragment===h.fragment);if((0,e.$lh)(r.authority,h.authority))return t.$Eg(r.path,h.path,this.a(r),"/")&&r.query===h.query&&(w||r.fragment===h.fragment)}return!1}joinPath(r,...h){return L.URI.joinPath(r,...h)}basenameOrAuthority(r){return(0,e.$dh)(r)||r.authority}basename(r){return j.$gc.basename(r.path)}extname(r){return j.$gc.extname(r.path)}dirname(r){if(r.path.length===0)return r;let h;return r.scheme===W.Schemas.file?h=L.URI.file(j.$mc(T(r))).path:(h=j.$gc.dirname(r.path),r.authority&&h.length&&h.charCodeAt(0)!==_.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),h="/")),r.with({path:h})}normalizePath(r){if(!r.path.length)return r;let h;return r.scheme===W.Schemas.file?h=L.URI.file(j.$hc(T(r))).path:h=j.$gc.normalize(r.path),r.with({path:h})}relativePath(r,h){if(r.scheme!==h.scheme||!(0,e.$lh)(r.authority,h.authority))return;if(r.scheme===W.Schemas.file){const D=j.$lc(T(r),T(h));return X.$j?t.$yg(D):D}let w=r.path||"/";const l=h.path||"/";if(this.a(r)){let D=0;for(const A=Math.min(w.length,l.length);D<A&&!(w.charCodeAt(D)!==l.charCodeAt(D)&&w.charAt(D).toLowerCase()!==l.charAt(D).toLowerCase());D++);w=l.substr(0,D)+w.substr(D)}return j.$gc.relative(w,l)}resolvePath(r,h){if(r.scheme===W.Schemas.file){const w=L.URI.file(j.$kc(T(r),h));return r.with({authority:w.authority,path:w.path})}return h=t.$zg(h),r.with({path:j.$gc.resolve(r.path,h)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,h){return r===h||r!==void 0&&h!==void 0&&(0,k.$Ff)(r,h)}hasTrailingPathSeparator(r,h=j.sep){if(r.scheme===W.Schemas.file){const w=T(r);return w.length>t.$Ag(w).length&&w[w.length-1]===h}else{const w=r.path;return w.length>1&&w.charCodeAt(w.length-1)===_.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,h=j.sep){return(0,e.$mh)(r,h)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,h=j.sep){let w=!1;if(r.scheme===W.Schemas.file){const l=T(r);w=l!==void 0&&l.length===t.$Ag(l).length&&l[l.length-1]===h}else{h="/";const l=r.path;w=l.length===1&&l.charCodeAt(l.length-1)===_.CharCode.Slash}return!w&&!(0,e.$mh)(r,h)?r.with({path:r.path+"/"}):r}}e.$8g=F,e.$9g=new F(()=>!1),e.$0g=new F(o=>o.scheme===W.Schemas.file?!X.$l:!0),e.$$g=new F(o=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function E(o,r){const h=[];for(let w=0;w<o.length;w++){const l=r(o[w]);o.some((D,A)=>A===w?!1:(0,e.$ah)(l,r(D)))||h.push(o[w])}return h}var v;(function(o){o.META_DATA_LABEL="label",o.META_DATA_DESCRIPTION="description",o.META_DATA_SIZE="size",o.META_DATA_MIME="mime";function r(h){const w=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(A=>{const[u,i]=A.split(":");u&&i&&w.set(u,i)});const D=h.path.substring(0,h.path.indexOf(";"));return D&&w.set(o.META_DATA_MIME,D),w}o.parseMetaData=r})(v||(e.DataUri=v={}));function p(o,r,h){if(r){let w=o.path;return w&&w[0]!==j.$gc.sep&&(w=j.$gc.sep+w),o.with({scheme:h,authority:r,path:w})}return o.with({scheme:h})}}),define(be[8],_e([0,1,13,9,6,4,22,2,45,16]),function(fe,e,_,t,W,j,X,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=F,e.$sh=E,e.$th=v,e.$uh=p,e.$vh=o,e.$wh=r,e.$xh=h,e.$yh=w,e.$Gh=m,e.$Hh=b,e.$Ih=a,e.$Jh=d,e.$Kh=N,e.$Zh=$,e.$8h=B;function F(O){return!!O&&typeof O.then=="function"}function E(O){const g=new _.$we,M=O(g.token),Y=new Promise((te,ge)=>{const De=g.token.onCancellationRequested(()=>{De.dispose(),ge(new t.$4)});Promise.resolve(M).then(Re=>{De.dispose(),g.dispose(),te(Re)},Re=>{De.dispose(),g.dispose(),ge(Re)})});return new class{cancel(){g.cancel(),g.dispose()}then(te,ge){return Y.then(te,ge)}catch(te){return this.then(void 0,te)}finally(te){return Y.finally(te)}}}function v(O,g,M){return new Promise((Y,te)=>{const ge=g.onCancellationRequested(()=>{ge.dispose(),Y(M)});O.then(Y,te).finally(()=>ge.dispose())})}function p(O,g){return new Promise((M,Y)=>{const te=g.onCancellationRequested(()=>{te.dispose(),Y(new t.$4)});O.then(M,Y).finally(()=>te.dispose())})}async function o(O){let g=-1;const M=O.map((Y,te)=>Y.then(ge=>(g=te,ge)));try{return await Promise.race(M)}finally{O.forEach((Y,te)=>{te!==g&&Y.cancel()})}}function r(O,g,M){let Y;const te=setTimeout(()=>{Y?.(void 0),M?.()},g);return Promise.race([O.finally(()=>clearTimeout(te)),new Promise(ge=>Y=ge)])}function h(O){return new Promise((g,M)=>{const Y=O();F(Y)?Y.then(g,M):g(Y)})}function w(){let O,g;return{promise:new Promise((Y,te)=>{O=Y,g=te}),resolve:O,reject:g}}class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(g){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=g,!this.b){const M=()=>{if(this.b=null,this.f)return;const Y=this.queue(this.d);return this.d=null,Y};this.b=new Promise(Y=>{this.a.then(M,M).then(Y)})}return new Promise((M,Y)=>{this.b.then(M,Y)})}return this.a=g(),new Promise((M,Y)=>{this.a.then(te=>{this.a=null,M(te)},te=>{this.a=null,Y(te)})})}dispose(){this.f=!0}}e.$zh=l;class D{constructor(){this.a=Promise.resolve(null)}queue(g){return this.a=this.a.then(()=>g(),()=>g())}}e.$Ah=D;class A{constructor(){this.a=new Map}queue(g,M){const te=(this.a.get(g)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.a.get(g)===te&&this.a.delete(g)});return this.a.set(g,te),te}}e.$Bh=A;const u=(O,g)=>{let M=!0;const Y=setTimeout(()=>{M=!1,g()},O);return{isTriggered:()=>M,dispose:()=>{clearTimeout(Y),M=!1}}},i=O=>{let g=!0;return queueMicrotask(()=>{g&&(g=!1,O())}),{isTriggered:()=>g,dispose:()=>{g=!1}}};class n{constructor(g){this.defaultDelay=g,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(g,M=this.defaultDelay){this.g=g,this.h(),this.b||(this.b=new Promise((te,ge)=>{this.d=te,this.f=ge}).then(()=>{if(this.b=null,this.d=null,this.g){const te=this.g;return this.g=null,te()}}));const Y=()=>{this.a=null,this.d?.(null)};return this.a=M===L.$ge?i(Y):u(M,Y),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=n;class s{constructor(g){this.a=new n(g),this.b=new l}trigger(g,M){return this.a.trigger(()=>this.b.queue(g),M)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=s;class c{constructor(){this.a=!1,this.b=new Promise((g,M)=>{this.d=g})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=c;class P extends c{constructor(g){super(),this.f=setTimeout(()=>this.open(),g)}open(){clearTimeout(this.f),super.open()}}e.$Fh=P;function m(O,g){return g?new Promise((M,Y)=>{const te=setTimeout(()=>{ge.dispose(),M()},O),ge=g.onCancellationRequested(()=>{clearTimeout(te),ge.dispose(),Y(new t.$4)})}):E(M=>m(O,M))}function b(O,g=0,M){const Y=setTimeout(()=>{O(),M&&te.dispose()},g),te=(0,j.$Sc)(()=>{clearTimeout(Y),M?.deleteAndLeak(te)});return M?.add(te),te}function a(O){const g=[];let M=0;const Y=O.length;function te(){return M<Y?O[M++]():null}function ge(De){De!=null&&g.push(De);const Re=te();return Re?Re.then(ge):Promise.resolve(g)}return Promise.resolve(null).then(ge)}function d(O,g=Y=>!!Y,M=null){let Y=0;const te=O.length,ge=()=>{if(Y>=te)return Promise.resolve(M);const De=O[Y++];return Promise.resolve(De()).then(he=>g(he)?Promise.resolve(he):ge())};return ge()}function N(O,g=Y=>!!Y,M=null){if(O.length===0)return Promise.resolve(M);let Y=O.length;const te=()=>{Y=-1;for(const ge of O)ge.cancel?.()};return new Promise((ge,De)=>{for(const Re of O)Re.then(he=>{--Y>=0&&g(he)?(te(),ge(he)):Y===0&&ge(M)}).catch(he=>{--Y>=0&&(te(),De(he))})})}class f{constructor(g){this.a=0,this.b=!1,this.f=g,this.g=[],this.d=0,this.h=new W.$le}whenIdle(){return this.size>0?W.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(g){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((M,Y)=>{this.g.push({factory:g,c:M,e:Y}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const g=this.g.shift();this.d++;const M=g.factory();M.then(g.c,g.e),M.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=f;class y extends f{constructor(){super(1)}}e.$Mh=y;class G{constructor(){this.a=new S,this.b=0}queue(g){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,g())):this.a.run(this.b++,g())}}e.$Nh=G;class C{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const g=new R;return this.b.add(g),g.p}g(){for(const[,g]of this.a)if(g.size>0)return!1;return!0}queueSize(g,M=X.$9g){const Y=M.getComparisonKey(g);return this.a.get(Y)?.size??0}queueFor(g,M,Y=X.$9g){const te=Y.getComparisonKey(g);let ge=this.a.get(te);if(!ge){ge=new y;const De=this.f++,Re=W.Event.once(ge.onDrained)(()=>{ge?.dispose(),this.a.delete(te),this.h(),this.d?.deleteAndDispose(De),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$4c),this.d.set(De,Re),this.a.set(te,ge)}return ge.queue(M)}h(){this.g()&&this.j()}j(){for(const g of this.b)g.complete();this.b.clear()}dispose(){for(const[,g]of this.a)g.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=C;class x{constructor(g,M){this.b=!1,this.a=-1,typeof g=="function"&&typeof M=="number"&&this.setIfNotSet(g,M)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(g,M){if(this.b)throw new t.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,g()},M)}setIfNotSet(g,M){if(this.b)throw new t.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,g()},M))}}e.$Ph=x;class K{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(g,M,Y=globalThis){if(this.f)throw new t.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const te=Y.setInterval(()=>{g()},M);this.d=(0,j.$Sc)(()=>{Y.clearInterval(te),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=K;class se{constructor(g,M){this.b=-1,this.a=g,this.d=M,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(g=this.d){this.cancel(),this.b=setTimeout(this.f,g)}get delay(){return this.d}set delay(g){this.d=g}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=se;class V{constructor(g,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.a=g,this.b=M,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(g=this.b){g%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${g}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(g/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=V;class ne extends se{constructor(g,M){super(g,M),this.j=[]}work(g){this.j.push(g),this.isScheduled()||this.schedule()}h(){const g=this.j;this.j=[],this.a?.(g)}dispose(){this.j=[],super.dispose()}}e.$Th=ne;class ce extends j.$Uc{constructor(g,M){super(),this.g=g,this.h=M,this.a=[],this.b=this.B(new j.$Vc),this.f=!1}get pending(){return this.a.length}work(g){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+g.length>this.g.maxBufferedWork)return!1}else if(this.pending+g.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const M of g)this.a.push(M);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new se(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=ce,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(O,g)=>{(0,k.$C)(()=>{if(M)return;const Y=Date.now()+15;g(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Y-Date.now())}}))});let M=!1;return{dispose(){M||(M=!0)}}}:e.$Wh=(O,g,M)=>{const Y=O.requestIdleCallback(g,typeof M=="number"?{timeout:M}:void 0);let te=!1;return{dispose(){te||(te=!0,O.cancelIdleCallback(Y))}}},e.$Vh=O=>(0,e.$Wh)(globalThis,O)}();class re{constructor(g,M){this.g=!1,this.d=()=>{try{this.j=M()}catch(Y){this.l=Y}finally{this.g=!0}},this.f=(0,e.$Wh)(g,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=re;class I extends re{constructor(g){super(globalThis,g)}}e.$Yh=I;async function $(O,g,M){let Y;for(let te=0;te<M;te++)try{return await O()}catch(ge){Y=ge,await m(g)}throw Y}class S{isRunning(g){return typeof g=="number"?this.a?.taskId===g:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(g,M,Y){return this.a={taskId:g,cancel:()=>Y?.(),promise:M},M.then(()=>this.d(g),()=>this.d(g)),M}d(g){this.a&&g===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const g=this.b;this.b=void 0,g.run().then(g.promiseResolve,g.promiseReject)}}queue(g){if(this.b)this.b.run=g;else{const{promise:M,resolve:Y,reject:te}=w();this.b={run:g,promise:M,promiseResolve:Y,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=S;class q{constructor(g,M=()=>Date.now()){this.d=g,this.f=M,this.a=0,this.b=0}increment(){const g=this.f();return g-this.a>this.d&&(this.a=g,this.b=0),this.b++,this.b}}e.$2h=q;var Q;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(Q||(Q={}));class R{get isRejected(){return this.d?.outcome===Q.Rejected}get isResolved(){return this.d?.outcome===Q.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===Q.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((g,M)=>{this.a=g,this.b=M})}complete(g){return new Promise(M=>{this.a(g),this.d={outcome:Q.Resolved,value:g},M()})}error(g){return new Promise(M=>{this.b(g),this.d={outcome:Q.Rejected,value:g},M()})}cancel(){return this.error(new t.$4)}}e.$3h=R;var J;(function(O){async function g(Y){let te;const ge=await Promise.all(Y.map(De=>De.then(Re=>Re,Re=>{te||(te=Re)})));if(typeof te<"u")throw te;return ge}O.settled=g;function M(Y){return new Promise(async(te,ge)=>{try{await Y(te,ge)}catch(De){ge(De)}})}O.withAsyncBody=M})(J||(e.Promises=J={}));class ee{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(g){this.a=void 0,this.b=void 0,this.d=!1,this.promise=g.then(M=>(this.a=M,this.d=!0,M),M=>{throw this.b=M,this.d=!0,M})}requireValue(){if(!this.d)throw new t.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=ee;class ie{constructor(g){this.b=g,this.a=new T.$T(()=>new ee(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=ie;var ue;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(ue||(ue={}));class ae{static fromArray(g){return new ae(M=>{M.emitMany(g)})}static fromPromise(g){return new ae(async M=>{M.emitMany(await g)})}static fromPromises(g){return new ae(async M=>{await Promise.all(g.map(async Y=>M.emitOne(await Y)))})}static merge(g){return new ae(async M=>{await Promise.all(g.map(async Y=>{for await(const te of Y)M.emitOne(te)}))})}static{this.EMPTY=ae.fromArray([])}constructor(g,M){this.a=ue.Initial,this.b=[],this.d=null,this.f=M,this.g=new W.$le,queueMicrotask(async()=>{const Y={emitOne:te=>this.h(te),emitMany:te=>this.j(te),reject:te=>this.l(te)};try{await Promise.resolve(g(Y)),this.k()}catch(te){this.l(te)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let g=0;return{next:async()=>{do{if(this.a===ue.DoneError)throw this.d;if(g<this.b.length)return{done:!1,value:this.b[g++]};if(this.a===ue.DoneOK)return{done:!0,value:void 0};await W.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(g,M){return new ae(async Y=>{for await(const te of g)Y.emitOne(M(te))})}map(g){return ae.map(this,g)}static filter(g,M){return new ae(async Y=>{for await(const te of g)M(te)&&Y.emitOne(te)})}filter(g){return ae.filter(this,g)}static coalesce(g){return ae.filter(g,M=>!!M)}coalesce(){return ae.coalesce(this)}static async toPromise(g){const M=[];for await(const Y of g)M.push(Y);return M}toPromise(){return ae.toPromise(this)}h(g){this.a===ue.Initial&&(this.b.push(g),this.g.fire())}j(g){this.a===ue.Initial&&(this.b=this.b.concat(g),this.g.fire())}k(){this.a===ue.Initial&&(this.a=ue.DoneOK,this.g.fire())}l(g){this.a===ue.Initial&&(this.a=ue.DoneError,this.d=g,this.g.fire())}}e.$6h=ae;class Ee extends ae{constructor(g,M){super(M),this.m=g}cancel(){this.m.cancel()}}e.$7h=Ee;function B(O){const g=new _.$we,M=O(g.token);return new Ee(g,async Y=>{const te=g.token.onCancellationRequested(()=>{te.dispose(),g.dispose(),Y.reject(new t.$4)});try{for await(const ge of M){if(g.token.isCancellationRequested)return;Y.emitOne(ge)}te.dispose(),g.dispose()}catch(ge){te.dispose(),g.dispose(),Y.reject(ge)}})}class z{constructor(g){this.a=new R,this.b=new ae(te=>{if(M){te.reject(M);return}return Y&&te.emitMany(Y),this.d=ge=>te.reject(ge),this.f=ge=>te.emitOne(ge),this.a.p},g);let M,Y;this.f=te=>{Y||(Y=[]),Y.push(te)},this.d=te=>{M||(M=te)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(g){this.d(g),this.a.complete()}emitOne(g){this.f(g)}}e.$9h=z}),define(be[23],_e([0,1,12,8,11,14,20,3,2,7]),function(fe,e,_,t,W,j,X,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$vk=F,e.$yk=r,e.$zk=G,e.$Ak=C,e.$Bk=x,e.$Ck=K,e.$Dk=se,e.$Ek=re;function F(){return Object.create(null)}e.$wk="**",e.$xk="/";const E="[/\\\\]",v="[^/\\\\]",p=/\//g;function o(I,$){switch(I){case 0:return"";case 1:return`${v}*?`;default:return`(?:${E}|${v}+${E}${$?`|${E}${v}+`:""})*?`}}function r(I,$){if(!I)return[];const S=[];let q=!1,Q=!1,R="";for(const J of I){switch(J){case $:if(!q&&!Q){S.push(R),R="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}R+=J}return R&&S.push(R),S}function h(I){if(!I)return"";let $="";const S=r(I,e.$xk);if(S.every(q=>q===e.$wk))$=".*";else{let q=!1;S.forEach((Q,R)=>{if(Q===e.$wk){if(q)return;$+=o(2,R===S.length-1)}else{let J=!1,ee="",ie=!1,ue="";for(const ae of Q){if(ae!=="}"&&J){ee+=ae;continue}if(ie&&(ae!=="]"||!ue)){let Ee;ae==="-"?Ee=ae:(ae==="^"||ae==="!")&&!ue?Ee="^":ae===e.$xk?Ee="":Ee=(0,T.$hf)(ae),ue+=Ee;continue}switch(ae){case"{":J=!0;continue;case"[":ie=!0;continue;case"}":{const B=`(?:${r(ee,",").map(z=>h(z)).join("|")})`;$+=B,J=!1,ee="";break}case"]":{$+="["+ue+"]",ie=!1,ue="";break}case"?":$+=v;continue;case"*":$+=o(1);continue;default:$+=(0,T.$hf)(ae)}}R<S.length-1&&(S[R+1]!==e.$wk||R+2<S.length)&&($+=E)}q=Q===e.$wk})}return $}const w=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,D=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,A=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new X.$Dc(1e4),s=function(){return!1},c=function(){return null};function P(I,$){if(!I)return c;let S;typeof I!="string"?S=I.pattern:S=I,S=S.trim();const q=`${S}_${!!$.trimForExclusions}`;let Q=n.get(q);if(Q)return m(Q,I);let R;return w.test(S)?Q=a(S.substr(4),S):(R=l.exec(b(S,$)))?Q=d(R[1],S):($.trimForExclusions?A:D).test(S)?Q=N(S,$):(R=u.exec(b(S,$)))?Q=f(R[1].substr(1),S,!0):(R=i.exec(b(S,$)))?Q=f(R[1],S,!1):Q=y(S),n.set(q,Q),m(Q,I)}function m(I,$){if(typeof $=="string")return I;const S=function(q,Q){return(0,j.$Eg)(q,$.base,!L.$l)?I((0,T.$mf)(q.substr($.base.length),k.sep),Q):null};return S.allBasenames=I.allBasenames,S.allPaths=I.allPaths,S.basenames=I.basenames,S.patterns=I.patterns,S}function b(I,$){return $.trimForExclusions&&I.endsWith("/**")?I.substr(0,I.length-2):I}function a(I,$){return function(S,q){return typeof S=="string"&&S.endsWith(I)?$:null}}function d(I,$){const S=`/${I}`,q=`\\${I}`,Q=function(J,ee){return typeof J!="string"?null:ee?ee===I?$:null:J===I||J.endsWith(S)||J.endsWith(q)?$:null},R=[I];return Q.basenames=R,Q.patterns=[$],Q.allBasenames=R,Q}function N(I,$){const S=ce(I.slice(1,-1).split(",").map(ee=>P(ee,$)).filter(ee=>ee!==c),I),q=S.length;if(!q)return c;if(q===1)return S[0];const Q=function(ee,ie){for(let ue=0,ae=S.length;ue<ae;ue++)if(S[ue](ee,ie))return I;return null},R=S.find(ee=>!!ee.allBasenames);R&&(Q.allBasenames=R.allBasenames);const J=S.reduce((ee,ie)=>ie.allPaths?ee.concat(ie.allPaths):ee,[]);return J.length&&(Q.allPaths=J),Q}function f(I,$,S){const q=k.sep===k.$gc.sep,Q=q?I:I.replace(p,k.sep),R=k.sep+Q,J=k.$gc.sep+I;let ee;return S?ee=function(ie,ue){return typeof ie=="string"&&(ie===Q||ie.endsWith(R)||!q&&(ie===I||ie.endsWith(J)))?$:null}:ee=function(ie,ue){return typeof ie=="string"&&(ie===Q||!q&&ie===I)?$:null},ee.allPaths=[(S?"*/":"./")+I],ee}function y(I){try{const $=new RegExp(`^${h(I)}$`);return function(S){return $.lastIndex=0,typeof S=="string"&&$.test(S)?I:null}}catch{return c}}function G(I,$,S){return!I||typeof $!="string"?!1:C(I)($,void 0,S)}function C(I,$={}){if(!I)return s;if(typeof I=="string"||x(I)){const S=P(I,$);if(S===c)return s;const q=function(Q,R){return!!S(Q,R)};return S.allBasenames&&(q.allBasenames=S.allBasenames),S.allPaths&&(q.allPaths=S.allPaths),q}return V(I,$)}function x(I){const $=I;return $?typeof $.base=="string"&&typeof $.pattern=="string":!1}function K(I){return I.allBasenames||[]}function se(I){return I.allPaths||[]}function V(I,$){const S=ce(Object.getOwnPropertyNames(I).map(ee=>ne(ee,I[ee],$)).filter(ee=>ee!==c)),q=S.length;if(!q)return c;if(!S.some(ee=>!!ee.requiresSiblings)){if(q===1)return S[0];const ee=function(ae,Ee){let B;for(let z=0,O=S.length;z<O;z++){const g=S[z](ae,Ee);if(typeof g=="string")return g;(0,t.$rh)(g)&&(B||(B=[]),B.push(g))}return B?(async()=>{for(const z of B){const O=await z;if(typeof O=="string")return O}return null})():null},ie=S.find(ae=>!!ae.allBasenames);ie&&(ee.allBasenames=ie.allBasenames);const ue=S.reduce((ae,Ee)=>Ee.allPaths?ae.concat(Ee.allPaths):ae,[]);return ue.length&&(ee.allPaths=ue),ee}const Q=function(ee,ie,ue){let ae,Ee;for(let B=0,z=S.length;B<z;B++){const O=S[B];O.requiresSiblings&&ue&&(ie||(ie=(0,k.$nc)(ee)),ae||(ae=ie.substr(0,ie.length-(0,k.$oc)(ee).length)));const g=O(ee,ie,ae,ue);if(typeof g=="string")return g;(0,t.$rh)(g)&&(Ee||(Ee=[]),Ee.push(g))}return Ee?(async()=>{for(const B of Ee){const z=await B;if(typeof z=="string")return z}return null})():null},R=S.find(ee=>!!ee.allBasenames);R&&(Q.allBasenames=R.allBasenames);const J=S.reduce((ee,ie)=>ie.allPaths?ee.concat(ie.allPaths):ee,[]);return J.length&&(Q.allPaths=J),Q}function ne(I,$,S){if($===!1)return c;const q=P(I,S);if(q===c)return c;if(typeof $=="boolean")return q;if($){const Q=$.when;if(typeof Q=="string"){const R=(J,ee,ie,ue)=>{if(!ue||!q(J,ee))return null;const ae=Q.replace("$(basename)",()=>ie),Ee=ue(ae);return(0,t.$rh)(Ee)?Ee.then(B=>B?I:null):Ee?I:null};return R.requiresSiblings=!0,R}}return q}function ce(I,$){const S=I.filter(ee=>!!ee.basenames);if(S.length<2)return I;const q=S.reduce((ee,ie)=>{const ue=ie.basenames;return ue?ee.concat(ue):ee},[]);let Q;if($){Q=[];for(let ee=0,ie=q.length;ee<ie;ee++)Q.push($)}else Q=S.reduce((ee,ie)=>{const ue=ie.patterns;return ue?ee.concat(ue):ee},[]);const R=function(ee,ie){if(typeof ee!="string")return null;if(!ie){let ae;for(ae=ee.length;ae>0;ae--){const Ee=ee.charCodeAt(ae-1);if(Ee===W.CharCode.Slash||Ee===W.CharCode.Backslash)break}ie=ee.substr(ae)}const ue=q.indexOf(ie);return ue!==-1?Q[ue]:null};R.basenames=q,R.patterns=Q,R.allBasenames=q;const J=I.filter(ee=>!ee.basenames);return J.push(R),J}function re(I,$){return(0,_.$tb)(I,$,(S,q)=>typeof S=="string"&&typeof q=="string"?S===q:typeof S!="string"&&typeof q!="string"?S.base===q.base&&S.pattern===q.pattern:!1)}}),define(be[24],_e([0,1,15,50,60,8,14,21,3,2,22,5]),function(fe,e,_,t,W,j,X,k,L,T,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=h,e.readdirSync=D,e.whenDeleted=i,e.configureFlushOnWrite=m,e.writeFileSync=a,_=Ie(_);var v;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function p(V,ne=v.UNLINK,ce){if((0,X.$Ig)(V))throw new Error("rimraf - will refuse to recursively delete root");return ne===v.UNLINK?r(V):o(V,ce)}async function o(V,ne=(0,X.$Ng)((0,t.tmpdir)())){try{try{await _.promises.rename(V,ne)}catch(ce){return ce.code==="ENOENT"?void 0:r(V)}r(ne).catch(ce=>{})}catch(ce){if(ce.code!=="ENOENT")throw ce}}async function r(V){return _.promises.rm(V,{recursive:!0,force:!0,maxRetries:3})}function h(V){if((0,X.$Ig)(V))throw new Error("rimraf - will refuse to recursively delete root");_.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}async function w(V,ne){return A(await(ne?l(V):_.promises.readdir(V)))}async function l(V){try{return await _.promises.readdir(V,{withFileTypes:!0})}catch(re){console.warn("[node.js fs] readdir with filetypes failed with error: ",re)}const ne=[],ce=await w(V);for(const re of ce){let I=!1,$=!1,S=!1;try{const q=await _.promises.lstat((0,L.$jc)(V,re));I=q.isFile(),$=q.isDirectory(),S=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}ne.push({name:re,isFile:()=>I,isDirectory:()=>$,isSymbolicLink:()=>S})}return ne}function D(V){return A(_.readdirSync(V))}function A(V){return V.map(ne=>typeof ne=="string"?T.$k?(0,k.$nm)(ne):ne:(ne.name=T.$k?(0,k.$nm)(ne.name):ne.name,ne))}async function u(V){const ne=await w(V),ce=[];for(const re of ne)await n.existsDirectory((0,L.$jc)(V,re))&&ce.push(re);return ce}function i(V,ne=1e3){return new Promise(ce=>{let re=!1;const I=setInterval(()=>{re||(re=!0,_.access(V,$=>{re=!1,$&&(clearInterval(I),ce(void 0))}))},ne)})}var n;(function(V){async function ne(I){let $;try{if($=await _.promises.lstat(I),!$.isSymbolicLink())return{stat:$}}catch{}try{return{stat:await _.promises.stat(I),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(S){if(S.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(T.$j&&S.code==="EACCES")try{return{stat:await _.promises.stat(await _.promises.readlink(I)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw q}throw S}}V.stat=ne;async function ce(I){try{const{stat:$,symbolicLink:S}=await V.stat(I);return $.isFile()&&S?.dangling!==!0}catch{}return!1}V.existsFile=ce;async function re(I){try{const{stat:$,symbolicLink:S}=await V.stat(I);return $.isDirectory()&&S?.dangling!==!0}catch{}return!1}V.existsDirectory=re})(n||(e.SymlinkSupport=n={}));const s=new j.$Oh;function c(V,ne,ce){return s.queueFor(E.URI.file(V),()=>{const re=d(ce);return new Promise((I,$)=>b(V,ne,re,S=>S?$(S):I()))},F.$0g)}let P=!0;function m(V){P=V}function b(V,ne,ce,re){if(!P)return _.writeFile(V,ne,{mode:ce.mode,flag:ce.flag},re);_.open(V,ce.flag,ce.mode,(I,$)=>{if(I)return re(I);_.writeFile($,ne,S=>{if(S)return _.close($,()=>re(S));_.fdatasync($,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),m(!1)),_.close($,Q=>re(Q))))})})}function a(V,ne,ce){const re=d(ce);if(!P)return _.writeFileSync(V,ne,{mode:re.mode,flag:re.flag});const I=_.openSync(V,re.flag,re.mode);try{_.writeFileSync(I,ne);try{_.fdatasyncSync(I)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),m(!1)}}finally{_.closeSync(I)}}function d(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function N(V,ne,ce=6e4){if(V!==ne)try{T.$j&&typeof ce=="number"?await f(V,ne,Date.now(),ce):await _.promises.rename(V,ne)}catch(re){if(V.toLowerCase()!==ne.toLowerCase()&&re.code==="EXDEV"||V.endsWith("."))await y(V,ne,{preserveSymlinks:!1}),await p(V,v.MOVE);else throw re}}async function f(V,ne,ce,re,I=0){try{return await _.promises.rename(V,ne)}catch($){if($.code!=="EACCES"&&$.code!=="EPERM"&&$.code!=="EBUSY")throw $;if(Date.now()-ce>=re)throw console.error(`[node.js fs] rename failed after ${I} retries with error: ${$}`),$;if(I===0){let S=!1;try{const{stat:q}=await n.stat(ne);q.isFile()||(S=!0)}catch{}if(S)throw $}return await(0,j.$Gh)(Math.min(100,I*10)),f(V,ne,ce,re,I+1)}}async function y(V,ne,ce){return C(V,ne,{root:{source:V,target:ne},options:ce,handledSourcePaths:new Set})}const G=511;async function C(V,ne,ce){if(ce.handledSourcePaths.has(V))return;ce.handledSourcePaths.add(V);const{stat:re,symbolicLink:I}=await n.stat(V);if(I){if(ce.options.preserveSymlinks)try{return await se(V,ne,ce)}catch{}if(I.dangling)return}return re.isDirectory()?x(V,ne,re.mode&G,ce):K(V,ne,re.mode&G)}async function x(V,ne,ce,re){await _.promises.mkdir(ne,{recursive:!0,mode:ce});const I=await w(V);for(const $ of I)await C((0,L.$jc)(V,$),(0,L.$jc)(ne,$),re)}async function K(V,ne,ce){await _.promises.copyFile(V,ne),await _.promises.chmod(ne,ce)}async function se(V,ne,ce){let re=await _.promises.readlink(V);(0,X.$Eg)(re,ce.root.source,!T.$l)&&(re=(0,L.$jc)(ce.root.target,re.substr(ce.root.source.length+1))),await _.promises.symlink(re,ne)}e.Promises=new class{get read(){return(V,ne,ce,re,I)=>new Promise(($,S)=>{_.read(V,ne,ce,re,I,(q,Q,R)=>q?S(q):$({bytesRead:Q,buffer:R}))})}get write(){return(V,ne,ce,re,I)=>new Promise(($,S)=>{_.write(V,ne,ce,re,I,(q,Q,R)=>q?S(q):$({bytesWritten:Q,buffer:R}))})}get fdatasync(){return(0,W.promisify)(_.fdatasync)}get open(){return(0,W.promisify)(_.open)}get close(){return(0,W.promisify)(_.close)}get realpath(){return(0,W.promisify)(_.realpath)}async exists(V){try{return await _.promises.access(V),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return u}get writeFile(){return c}get rm(){return p}get rename(){return N}get copy(){return y}}}),define(be[32],_e([0,1,15,3,2,7,24]),function(fe,e,_,t,W,j,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=k,e.$mr=L,e.$nr=T,e.$or=F,_=Ie(_);function k(v){if(W.$l)return v;const p=(0,t.$mc)(v);if(v===p)return v;const o=((0,t.$nc)(v)||v).toLowerCase();try{const h=(0,X.readdirSync)(p).filter(w=>w.toLowerCase()===o);if(h.length===1){const w=k(p);if(w)return(0,t.$jc)(w,h[0])}else if(h.length>1){const w=h.indexOf(o);if(w>=0){const l=k(p);if(l)return(0,t.$jc)(l,h[w])}}}catch{}return null}async function L(v,p){if(W.$l)return v;const o=(0,t.$mc)(v);if(v===o)return v;const r=((0,t.$nc)(v)||v).toLowerCase();try{if(p?.isCancellationRequested)return null;const w=(await X.Promises.readdir(o)).filter(l=>l.toLowerCase()===r);if(w.length===1){const l=await L(o,p);if(l)return(0,t.$jc)(l,w[0])}else if(w.length>1){const l=w.indexOf(r);if(l>=0){const D=await L(o,p);if(D)return(0,t.$jc)(D,w[l])}}}catch{}return null}async function T(v){try{return await X.Promises.realpath(v)}catch{const o=E(v);return await _.promises.access(o,_.constants.R_OK),o}}function F(v){try{return _.realpathSync(v)}catch{const o=E(v);return _.accessSync(o,_.constants.R_OK),o}}function E(v){return(0,j.$nf)((0,t.$hc)(v),t.sep)}}),define(be[51],_e([0,1,15,3,2,28,29,10,24]),function(fe,e,_,t,W,j,X,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$ym=T,e.$zm=F,t=Ie(t),W=Ie(W),j=Ie(j),k=Ie(k),L=Ie(L),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return X.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return X.TerminateResponseCode}});function T(v=j.env){return v.comspec||"cmd.exe"}function F(v){let p=[],o=!1;const r=function(h){if(o){p.push(h);return}(!v.send(h,l=>{if(l&&console.error(l),o=!1,p.length>0){const D=p.slice(0);p=[],D.forEach(A=>r(A))}})||W.$j)&&(o=!0)};return{send:r}}var E;(function(v){async function p(o,r,h){if(t.$ic(o))return o;if(r===void 0&&(r=j.cwd()),t.$mc(o)!=="."||(h===void 0&&k.$eg(j.env.PATH)&&(h=j.env.PATH.split(t.$tc)),h===void 0||h.length===0))return t.$jc(r,o);async function l(D){if(await L.Promises.exists(D)){let A;try{A=await _.promises.stat(D)}catch(u){u.message.startsWith("EACCES")&&(A=await _.promises.lstat(D))}return A?!A.isDirectory():!1}return!1}for(const D of h){let A;if(t.$ic(D)?A=t.$jc(D,o):A=t.$jc(r,D,o),await l(A))return A;let u=A+".com";if(await l(u)||(u=A+".exe",await l(u)))return u}return t.$jc(r,o)}v.findExecutable=p})(E||(e.win32=E={}))});var Je=this&&this.__decorate||function(fe,e,_,t){var W=arguments.length,j=W<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,_):t,X;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(fe,e,_,t);else for(var k=fe.length-1;k>=0;k--)(X=fe[k])&&(j=(W<3?X(j):W>3?X(e,_,j):X(e,_))||j);return W>3&&j&&Object.defineProperty(e,_,j),j};define(be[25],_e([0,1,12,8,17,13,39,9,6,4,49,7,10]),function(fe,e,_,t,W,j,X,k,L,T,F,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.ProxyChannel=e.$ni=e.$ki=e.$ji=e.$ii=e.RequestInitiator=e.$hi=e.$ei=e.$di=void 0,e.$fi=m,e.$gi=b,e.$li=G,e.$mi=C,E=Ie(E);var p;(function(I){I[I.Promise=100]="Promise",I[I.PromiseCancel=101]="PromiseCancel",I[I.EventListen=102]="EventListen",I[I.EventDispose=103]="EventDispose"})(p||(p={}));function o(I){switch(I){case p.Promise:return"req";case p.PromiseCancel:return"cancel";case p.EventListen:return"subscribe";case p.EventDispose:return"unsubscribe"}}var r;(function(I){I[I.Initialize=200]="Initialize",I[I.PromiseSuccess=201]="PromiseSuccess",I[I.PromiseError=202]="PromiseError",I[I.PromiseErrorObj=203]="PromiseErrorObj",I[I.EventFire=204]="EventFire"})(r||(r={}));function h(I){switch(I){case r.Initialize:return"init";case r.PromiseSuccess:return"reply:";case r.PromiseError:case r.PromiseErrorObj:return"replyErr:";case r.EventFire:return"event:"}}var w;(function(I){I[I.Uninitialized=0]="Uninitialized",I[I.Idle=1]="Idle"})(w||(w={}));function l(I){let $=0;for(let S=0;;S+=7){const q=I.read(1);if($|=(q.buffer[0]&127)<<S,!(q.buffer[0]&128))return $}}const D=s(0);function A(I,$){if($===0){I.write(D);return}let S=0;for(let Q=$;Q!==0;Q=Q>>>7)S++;const q=W.$Ne.alloc(S);for(let Q=0;$!==0;Q++)q.buffer[Q]=$&127,$=$>>>7,$>0&&(q.buffer[Q]|=128);I.write(q)}class u{constructor($){this.b=$,this.a=0}read($){const S=this.b.slice(this.a,this.a+$);return this.a+=S.byteLength,S}}e.$di=u;class i{constructor(){this.a=[]}get buffer(){return W.$Ne.concat(this.a)}write($){this.a.push($)}}e.$ei=i;var n;(function(I){I[I.Undefined=0]="Undefined",I[I.String=1]="String",I[I.Buffer=2]="Buffer",I[I.VSBuffer=3]="VSBuffer",I[I.Array=4]="Array",I[I.Object=5]="Object",I[I.Int=6]="Int"})(n||(n={}));function s(I){const $=W.$Ne.alloc(1);return $.writeUInt8(I,0),$}const c={Undefined:s(n.Undefined),String:s(n.String),Buffer:s(n.Buffer),VSBuffer:s(n.VSBuffer),Array:s(n.Array),Object:s(n.Object),Uint:s(n.Int)},P=typeof Buffer<"u";function m(I,$){if(typeof $>"u")I.write(c.Undefined);else if(typeof $=="string"){const S=W.$Ne.fromString($);I.write(c.String),A(I,S.byteLength),I.write(S)}else if(P&&Buffer.isBuffer($)){const S=W.$Ne.wrap($);I.write(c.Buffer),A(I,S.byteLength),I.write(S)}else if($ instanceof W.$Ne)I.write(c.VSBuffer),A(I,$.byteLength),I.write($);else if(Array.isArray($)){I.write(c.Array),A(I,$.length);for(const S of $)m(I,S)}else if(typeof $=="number"&&($|0)===$)I.write(c.Uint),A(I,$);else{const S=W.$Ne.fromString(JSON.stringify($));I.write(c.Object),A(I,S.byteLength),I.write(S)}}function b(I){switch(I.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return I.read(l(I)).toString();case n.Buffer:return I.read(l(I)).buffer;case n.VSBuffer:return I.read(l(I));case n.Array:{const S=l(I),q=[];for(let Q=0;Q<S;Q++)q.push(b(I));return q}case n.Object:return JSON.parse(I.read(l(I)).toString());case n.Int:return l(I)}}class a{constructor($,S,q=null,Q=1e3){this.h=$,this.j=S,this.k=q,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(R=>this.q(R)),this.m({type:r.Initialize})}registerChannel($,S){this.b.set($,S),setTimeout(()=>this.w($),0)}m($){switch($.type){case r.Initialize:{const S=this.o([$.type]);this.k?.logOutgoing(S,0,d.OtherSide,h($.type));return}case r.PromiseSuccess:case r.PromiseError:case r.EventFire:case r.PromiseErrorObj:{const S=this.o([$.type,$.id],$.data);this.k?.logOutgoing(S,$.id,d.OtherSide,h($.type),$.data);return}}}o($,S=void 0){const q=new i;return m(q,$),m(q,S),this.p(q.buffer)}p($){try{return this.h.send($),$.byteLength}catch{return 0}}q($){const S=new u($),q=b(S),Q=b(S),R=q[0];switch(R){case p.Promise:return this.k?.logIncoming($.byteLength,q[1],d.OtherSide,`${o(R)}: ${q[2]}.${q[3]}`,Q),this.s({type:R,id:q[1],channelName:q[2],name:q[3],arg:Q});case p.EventListen:return this.k?.logIncoming($.byteLength,q[1],d.OtherSide,`${o(R)}: ${q[2]}.${q[3]}`,Q),this.t({type:R,id:q[1],channelName:q[2],name:q[3],arg:Q});case p.PromiseCancel:return this.k?.logIncoming($.byteLength,q[1],d.OtherSide,`${o(R)}`),this.u({type:R,id:q[1]});case p.EventDispose:return this.k?.logIncoming($.byteLength,q[1],d.OtherSide,`${o(R)}`),this.u({type:R,id:q[1]})}}s($){const S=this.b.get($.channelName);if(!S){this.v($);return}const q=new j.$we;let Q;try{Q=S.call(this.j,$.name,$.arg,q.token)}catch(ee){Q=Promise.reject(ee)}const R=$.id;Q.then(ee=>{this.m({id:R,data:ee,type:r.PromiseSuccess})},ee=>{ee instanceof Error?this.m({id:R,data:{message:ee.message,name:ee.name,stack:ee.stack?ee.stack.split(`
`):void 0},type:r.PromiseError}):this.m({id:R,data:ee,type:r.PromiseErrorObj})}).finally(()=>{J.dispose(),this.d.delete($.id)});const J=(0,T.$Sc)(()=>q.cancel());this.d.set($.id,J)}t($){const S=this.b.get($.channelName);if(!S){this.v($);return}const q=$.id,R=S.listen(this.j,$.name,$.arg)(J=>this.m({id:q,data:J,type:r.EventFire}));this.d.set($.id,R)}u($){const S=this.d.get($.id);S&&(S.dispose(),this.d.delete($.id))}v($){let S=this.g.get($.channelName);S||(S=[],this.g.set($.channelName,S));const q=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===p.Promise&&this.m({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.l}ms`,stack:void 0},type:r.PromiseError})},this.l);S.push({request:$,timeoutTimer:q})}w($){const S=this.g.get($);if(S){for(const q of S)switch(clearTimeout(q.timeoutTimer),q.request.type){case p.Promise:this.s(q.request);break;case p.EventListen:this.t(q.request);break}this.g.delete($)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,T.$Pc)(this.d.values()),this.d.clear()}}e.$hi=a;var d;(function(I){I[I.LocalSide=0]="LocalSide",I[I.OtherSide=1]="OtherSide"})(d||(e.RequestInitiator=d={}));class N{constructor($,S=null){this.l=$,this.a=!1,this.b=w.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new L.$le,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(q=>this.s(q)),this.j=S}getChannel($){const S=this;return{call(q,Q,R){return S.a?Promise.reject(new k.$4):S.m($,q,Q,R)},listen(q,Q){return S.a?L.Event.None:S.o($,q,Q)}}}m($,S,q,Q=j.CancellationToken.None){const R=this.g++,J=p.Promise,ee={id:R,type:J,channelName:$,name:S,arg:q};if(Q.isCancellationRequested)return Promise.reject(new k.$4);let ie;return new Promise((ae,Ee)=>{if(Q.isCancellationRequested)return Ee(new k.$4);const B=()=>{const M=Y=>{switch(Y.type){case r.PromiseSuccess:this.f.delete(R),ae(Y.data);break;case r.PromiseError:{this.f.delete(R);const te=new Error(Y.data.message);te.stack=Array.isArray(Y.data.stack)?Y.data.stack.join(`
`):Y.data.stack,te.name=Y.data.name,Ee(te);break}case r.PromiseErrorObj:this.f.delete(R),Ee(Y.data);break}};this.f.set(R,M),this.p(ee)};let z=null;this.b===w.Idle?B():(z=(0,t.$sh)(M=>this.u()),z.then(()=>{z=null,B()}));const O=()=>{z?(z.cancel(),z=null):this.p({id:R,type:p.PromiseCancel}),Ee(new k.$4)},g=Q.onCancellationRequested(O);ie=(0,T.$Rc)((0,T.$Sc)(O),g),this.d.add(ie)}).finally(()=>{ie.dispose(),this.d.delete(ie)})}o($,S,q){const Q=this.g++,R=p.EventListen,J={id:Q,type:R,channelName:$,name:S,arg:q};let ee=null;const ie=new L.$le({onWillAddFirstListener:()=>{ee=(0,t.$sh)(ae=>this.u()),ee.then(()=>{ee=null,this.d.add(ie),this.p(J)})},onDidRemoveLastListener:()=>{ee?(ee.cancel(),ee=null):(this.d.delete(ie),this.p({id:Q,type:p.EventDispose}))}}),ue=ae=>ie.fire(ae.data);return this.f.set(Q,ue),ie.event}p($){switch($.type){case p.Promise:case p.EventListen:{const S=this.q([$.type,$.id,$.channelName,$.name],$.arg);this.j?.logOutgoing(S,$.id,d.LocalSide,`${o($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case p.PromiseCancel:case p.EventDispose:{const S=this.q([$.type,$.id]);this.j?.logOutgoing(S,$.id,d.LocalSide,o($.type));return}}}q($,S=void 0){const q=new i;return m(q,$),m(q,S),this.r(q.buffer)}r($){try{return this.l.send($),$.byteLength}catch{return 0}}s($){const S=new u($),q=b(S),Q=b(S),R=q[0];switch(R){case r.Initialize:return this.j?.logIncoming($.byteLength,0,d.LocalSide,h(R)),this.t({type:q[0]});case r.PromiseSuccess:case r.PromiseError:case r.EventFire:case r.PromiseErrorObj:return this.j?.logIncoming($.byteLength,q[1],d.LocalSide,h(R),Q),this.t({type:q[0],id:q[1],data:Q})}}t($){if($.type===r.Initialize){this.b=w.Idle,this.k.fire();return}this.f.get($.id)?.($)}get onDidInitializePromise(){return L.Event.toPromise(this.onDidInitialize)}u(){return this.b===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,T.$Pc)(this.d.values()),this.d.clear()}}e.$ii=N,Je([X.$0h],N.prototype,"onDidInitializePromise",null);class f{get connections(){const $=[];return this.f.forEach(S=>$.push(S)),$}constructor($,S,q){this.a=new Map,this.f=new Set,this.g=new L.$le,this.onDidAddConnection=this.g.event,this.h=new L.$le,this.onDidRemoveConnection=this.h.event,this.j=new T.$Tc,this.j.add($(({protocol:Q,onDidClientDisconnect:R})=>{const J=L.Event.once(Q.onMessage);this.j.add(J(ee=>{const ie=new u(ee),ue=b(ie),ae=new a(Q,ue,S,q),Ee=new N(Q,S);this.a.forEach((z,O)=>ae.registerChannel(O,z));const B={channelServer:ae,channelClient:Ee,ctx:ue};this.f.add(B),this.g.fire(B),this.j.add(R(()=>{ae.dispose(),Ee.dispose(),this.f.delete(B),this.h.fire(B)}))}))}))}getChannel($,S){const q=this;return{call(Q,R,J){let ee;if((0,v.$sg)(S)){const ue=(0,_.$2b)(q.connections.filter(S));ee=ue?Promise.resolve(ue):L.Event.toPromise(L.Event.filter(q.onDidAddConnection,S))}else ee=S.routeCall(q,Q,R);const ie=ee.then(ue=>ue.channelClient.getChannel($));return G(ie).call(Q,R,J)},listen(Q,R){if((0,v.$sg)(S))return q.k($,S,Q,R);const J=S.routeEvent(q,Q,R).then(ee=>ee.channelClient.getChannel($));return G(J).listen(Q,R)}}}k($,S,q,Q){const R=this;let J;const ee=new L.$le({onWillAddFirstListener:()=>{J=new T.$Tc;const ie=new L.$re,ue=new Map,ae=B=>{const O=B.channelClient.getChannel($).listen(q,Q),g=ie.add(O);ue.set(B,g)},Ee=B=>{const z=ue.get(B);z&&(z.dispose(),ue.delete(B))};R.connections.filter(S).forEach(ae),L.Event.filter(R.onDidAddConnection,S)(ae,void 0,J),R.onDidRemoveConnection(Ee,void 0,J),ie.event(ee.fire,ee,J),J.add(ie)},onDidRemoveLastListener:()=>{J?.dispose(),J=void 0}});return ee.event}registerChannel($,S){this.a.set($,S);for(const q of this.f)q.channelServer.registerChannel($,S)}dispose(){this.j.dispose();for(const $ of this.f)$.channelClient.dispose(),$.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ji=f;class y{constructor($,S,q=null){const Q=new i;m(Q,S),$.send(Q.buffer),this.a=new N($,q),this.d=new a($,S,q)}getChannel($){return this.a.getChannel($)}registerChannel($,S){this.d.registerChannel($,S)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ki=y;function G(I){return{call($,S,q){return I.then(Q=>Q.call($,S,q))},listen($,S){const q=new L.$ue;return I.then(Q=>q.input=Q.listen($,S)),q.event}}}function C(I){let $=!1;return{call(S,q,Q){return $?I.call(S,q,Q):(0,t.$Gh)(0).then(()=>$=!0).then(()=>I.call(S,q,Q))},listen(S,q){if($)return I.listen(S,q);const Q=new L.$ue;return(0,t.$Gh)(0).then(()=>$=!0).then(()=>Q.input=I.listen(S,q)),Q.event}}}class x{constructor($){this.a=$}routeCall($){return this.b($)}routeEvent($){return this.b($)}async b($){for(const S of $.connections)if(await Promise.resolve(this.a(S.ctx)))return Promise.resolve(S);return await L.Event.toPromise($.onDidAddConnection),await this.b($)}}e.$ni=x;var K;(function(I){function $(R,J,ee){const ie=R,ue=ee&&ee.disableMarshalling,ae=new Map;for(const Ee in ie)q(Ee)&&ae.set(Ee,L.Event.buffer(ie[Ee],!0,void 0,J));return new class{listen(Ee,B,z){const O=ae.get(B);if(O)return O;const g=ie[B];if(typeof g=="function"){if(Q(B))return g.call(ie,z);if(q(B))return ae.set(B,L.Event.buffer(ie[B],!0,void 0,J)),ae.get(B)}throw new k.$ab(`Event not found: ${B}`)}call(Ee,B,z){const O=ie[B];if(typeof O=="function"){if(!ue&&Array.isArray(z))for(let M=0;M<z.length;M++)z[M]=(0,F.$ci)(z[M]);let g=O.apply(ie,z);return g instanceof Promise||(g=Promise.resolve(g)),g}throw new k.$ab(`Method not found: ${B}`)}}}I.fromService=$;function S(R,J){const ee=J&&J.disableMarshalling;return new Proxy({},{get(ie,ue){if(typeof ue=="string")return J?.properties?.has(ue)?J.properties.get(ue):Q(ue)?function(ae){return R.listen(ue,ae)}:q(ue)?R.listen(ue):async function(...ae){let Ee;J&&!(0,v.$ng)(J.context)?Ee=[J.context,...ae]:Ee=ae;const B=await R.call(ue,Ee);return ee?B:(0,F.$ci)(B)};throw new k.$ab(`Property not found: ${String(ue)}`)}})}I.toService=S;function q(R){return R[0]==="o"&&R[1]==="n"&&E.$Ef(R.charCodeAt(2))}function Q(R){return/^onDynamic/.test(R)&&E.$Ef(R.charCodeAt(9))}})(K||(e.ProxyChannel=K={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(I){if(Array.isArray(I))return I;if(I&&typeof I=="object"&&typeof I.toString=="function"){const $=I.toString();if($!=="[object Object]")return $}return I}function ne(I){return Array.isArray(I)?I.map(V):V(I)}function ce(I,$,S,q,Q,R,J){J=ne(J);const ee=se[Q],ie=ee[q%ee.length];let ue=[`%c[${I}]%c[${String($).padStart(7," ")}]%c[len: ${String(S).padStart(5," ")}]%c${String(q).padStart(5," ")} - ${R}`,"color: darkgreen","color: grey","color: grey",`color: ${ie}`];/\($/.test(R)?(ue=ue.concat(J),ue.push(")")):ue.push(J),console.log.apply(console,ue)}class re{constructor($,S){this.d=$,this.f=S,this.a=0,this.b=0}logOutgoing($,S,q,Q,R){this.b+=$,ce(this.d,this.b,$,S,q,Q,R)}logIncoming($,S,q,Q,R){this.a+=$,ce(this.f,this.a,$,S,q,Q,R)}}e.$oi=re}),define(be[52],_e([0,1,61,8,17,13,48,9,6,4,46,51,29,25]),function(fe,e,_,t,W,j,X,k,L,T,F,E,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=e.$hr=void 0,k=Ie(k);class o extends p.$hi{constructor(w){super({send:l=>{try{process.send?.(l.buffer.toString("base64"))}catch{}},onMessage:L.Event.fromNodeEventEmitter(process,"message",l=>W.$Ne.wrap(Buffer.from(l,"base64")))},w),process.once("disconnect",()=>this.dispose())}}e.$hr=o;class r{constructor(w,l){this.i=w,this.j=l,this.c=new Set,this.g=new Map,this.h=new L.$le,this.onDidProcessExit=this.h.event;const D=l&&l.timeout?l.timeout:6e4;this.b=new t.$Ch(D),this.d=null,this.f=null}getChannel(w){const l=this;return{call(D,A,u){return l.k(w,D,A,u)},listen(D,A){return l.l(w,D,A)}}}k(w,l,D,A=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(A.isCancellationRequested)return Promise.reject(k.$5());this.b.cancel();const u=this.n(w),i=(0,t.$sh)(c=>u.call(l,D,c)),n=A.onCancellationRequested(()=>i.cancel()),s=(0,T.$Sc)(()=>i.cancel());return this.c.add(s),i.finally(()=>{n.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(w,l,D){if(!this.b)return L.Event.None;this.b.cancel();let A;const u=new L.$le({onWillAddFirstListener:()=>{A=this.n(w).listen(l,D)(u.fire,u),this.c.add(A)},onDidRemoveLastListener:()=>{this.c.delete(A),A.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return u.event}get m(){if(!this.f){const w=this.j&&this.j.args?this.j.args:[],l=Object.create(null);l.env={...(0,F.$eo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(l.env={...l.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(l.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(m=>!/^--inspect(-brk)?=/.test(m)).filter(m=>!m.startsWith("--vscode-"))),(0,v.$mm)(l.env),this.d=(0,_.fork)(this.i,w,l);const D=new L.$le,u=L.Event.fromNodeEventEmitter(this.d,"message",m=>m)(m=>{if((0,X.$dr)(m)){(0,X.log)(m,`IPC Library: ${this.j.serverName}`);return}D.fire(W.$Ne.wrap(Buffer.from(m,"base64")))}),i=this.j.useQueue?(0,E.$zm)(this.d):this.d,n=m=>this.d&&this.d.connected&&i.send(m.buffer.toString("base64")),s=D.event,c={send:n,onMessage:s};this.f=new p.$ii(c);const P=()=>this.o();process.once("exit",P),this.d.on("error",m=>console.warn('IPC "'+this.j.serverName+'" errored with '+m)),this.d.on("exit",(m,b)=>{process.removeListener("exit",P),u.dispose(),this.c.forEach(a=>(0,T.$Pc)(a)),this.c.clear(),m!==0&&b!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+m+" and signal "+b),this.b?.cancel(),this.o(),this.h.fire({code:m,signal:b})})}return this.f}n(w){let l=this.g.get(w);return l||(l=this.m.getChannel(w),this.g.set(w,l)),l}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$ir=r}),define(be[33],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9X=_;function _(t){return!!t.parentPort}}),define(be[53],_e([0,1,33,17,25,6,10,12]),function(fe,e,_,t,W,j,X,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0X=void 0,e.$$X=F;class L{constructor(v){this.a=v,this.onMessage=j.Event.fromNodeEventEmitter(this.a,"message",p=>p.data?t.$Ne.wrap(p.data):t.$Ne.alloc(0)),v.start()}send(v){this.a.postMessage(v.buffer)}disconnect(){this.a.close()}}class T extends W.$ji{static b(v){(0,X.$og)((0,_.$9X)(process),"Electron Utility Process");const p=new j.$le;return process.parentPort.on("message",o=>{if(v?.handledClientConnection(o))return;const r=(0,k.$Nb)(o.ports);r&&p.fire(r)}),j.Event.map(p.event,o=>({protocol:new L(o),onDidClientDisconnect:j.Event.fromNodeEventEmitter(o,"close")}))}constructor(v){super(T.b(v))}}e.$0X=T;function F(E,v,p){const o=r=>{r.data===v&&(E.removeListener("message",o),p())};E.on("message",o)}}),define(be[34],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=W,e.localize2=X;const _=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function t(k,L){let T;return L.length===0?T=k:T=k.replace(/\{(\d+)\}/g,(F,E)=>{const v=E[0],p=L[v];let o=F;return typeof p=="string"?o=p:(typeof p=="number"||typeof p=="boolean"||p===void 0||p===null)&&(o=String(p)),o}),_&&(T="\uFF3B"+T.replace(/[aouei]/g,"$&$&")+"\uFF3D"),T}function W(k,L,...T){return t(typeof k=="number"?j(k,L):L,T)}function j(k,L){const T=globalThis._VSCODE_NLS_MESSAGES?.[k];if(typeof T!="string"){if(typeof L=="string")return L;throw new Error(`!!! NLS MISSING: ${k} !!!`)}return T}function X(k,L,...T){let F;typeof k=="number"?F=j(k,L):F=L;const E=t(F,T);return{value:E,original:L===F?E:t(L,T)}}}),define(be[54],_e([0,1,12,10,34]),function(fe,e,_,t,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=L,e.$rj=T,e.$sj=F,_=Ie(_),t=Ie(t),W=Ie(W);function j(E,v){return v&&(E.stack||E.stacktrace)?W.localize(12981,null,k(E),X(E.stack)||X(E.stacktrace)):k(E)}function X(E){return Array.isArray(E)?E.join(`
`):E}function k(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?W.localize(12982,null,E.message):E.message||W.localize(12983,null)}function L(E=null,v=!1){if(!E)return W.localize(12984,null);if(Array.isArray(E)){const p=_.$Gb(E),o=L(p[0],v);return p.length>1?W.localize(12985,null,o,p.length):o}if(t.$eg(E))return E;if(E.detail){const p=E.detail;if(p.error)return j(p.error,v);if(p.exception)return j(p.exception,v)}return E.stack?j(E,v):E.message?E.message:W.localize(12986,null)}function T(E){const v=E;return v instanceof Error&&Array.isArray(v.actions)}function F(E,v){let p;return typeof E=="string"?p=new Error(E):p=E,p.actions=v,p}}),define(be[55],_e([0,1]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=W,e.$Gi=j;var _;(function(X){X.serviceIds=new Map,X.DI_TARGET="$di$target",X.DI_DEPENDENCIES="$di$dependencies";function k(L){return L[X.DI_DEPENDENCIES]||[]}X.getServiceDependencies=k})(_||(e._util=_={})),e.$Ei=W("instantiationService");function t(X,k,L){k[_.DI_TARGET]===k?k[_.DI_DEPENDENCIES].push({id:X,index:L}):(k[_.DI_DEPENDENCIES]=[{id:X,index:L}],k[_.DI_TARGET]=k)}function W(X){if(_.serviceIds.has(X))return _.serviceIds.get(X);const k=function(L,T,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(k,L,F)};return k.toString=()=>X,_.serviceIds.set(X,k),k}function j(X){return X}}),define(be[18],_e([0,1,30,3,7,10,5,34,55,2,31,16]),function(fe,e,_,t,W,j,X,k,L,T,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Fl=e.FileKind=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.FileOperationResult=e.$xl=e.$wl=e.$vl=e.$tl=e.FileChangeType=e.$sl=e.FileOperation=e.$ml=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$al=void 0,e.$bl=v,e.$cl=h,e.$dl=l,e.$el=D,e.$fl=A,e.$gl=u,e.$hl=i,e.$il=n,e.$jl=s,e.$kl=c,e.$ll=P,e.$nl=a,e.$ol=d,e.$pl=N,e.$ql=f,e.$rl=y,e.$ul=se,e.$Gl=$,e.$Hl=S,e.$Jl=Q,e.$al=(0,L.$Fi)("fileService");function v(R){return R.create===!0}var p;(function(R){R[R.Unknown=0]="Unknown",R[R.File=1]="File",R[R.Directory=2]="Directory",R[R.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var o;(function(R){R[R.Readonly=1]="Readonly",R[R.Locked=2]="Locked"})(o||(e.FilePermission=o={}));var r;(function(R){R[R.UPDATED=2]="UPDATED",R[R.ADDED=4]="ADDED",R[R.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function h(R){const J=R;return!!J&&typeof J.onDidChange=="function"}var w;(function(R){R[R.None=0]="None",R[R.FileReadWrite=2]="FileReadWrite",R[R.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",R[R.FileReadStream=16]="FileReadStream",R[R.FileFolderCopy=8]="FileFolderCopy",R[R.PathCaseSensitive=1024]="PathCaseSensitive",R[R.Readonly=2048]="Readonly",R[R.Trash=4096]="Trash",R[R.FileWriteUnlock=8192]="FileWriteUnlock",R[R.FileAtomicRead=16384]="FileAtomicRead",R[R.FileAtomicWrite=32768]="FileAtomicWrite",R[R.FileAtomicDelete=65536]="FileAtomicDelete",R[R.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function l(R){return!!(R.capabilities&w.FileReadWrite)}function D(R){return!!(R.capabilities&w.FileFolderCopy)}function A(R){return!!(R.capabilities&w.FileClone)}function u(R){return!!(R.capabilities&w.FileOpenReadWriteClose)}function i(R){return!!(R.capabilities&w.FileReadStream)}function n(R){return l(R)?!!(R.capabilities&w.FileAtomicRead):!1}function s(R){return l(R)?!!(R.capabilities&w.FileAtomicWrite):!1}function c(R){return!!(R.capabilities&w.FileAtomicDelete)}function P(R){return!!(R.capabilities&w.Readonly)}var m;(function(R){R.FileExists="EntryExists",R.FileNotFound="EntryNotFound",R.FileNotADirectory="EntryNotADirectory",R.FileIsADirectory="EntryIsADirectory",R.FileExceedsStorageQuota="EntryExceedsStorageQuota",R.FileTooLarge="EntryTooLarge",R.FileWriteLocked="EntryWriteLocked",R.NoPermissions="NoPermissions",R.Unavailable="Unavailable",R.Unknown="Unknown"})(m||(e.FileSystemProviderErrorCode=m={}));class b extends Error{static create(J,ee){const ie=new b(J.toString(),ee);return N(ie,ee),ie}constructor(J,ee){super(J),this.code=ee}}e.$ml=b;function a(R,J){return b.create(R,J)}function d(R){return R||a((0,k.localize)(11385,null),m.Unknown)}function N(R,J){return R.name=J?`${J} (FileSystemError)`:"FileSystemError",R}function f(R){if(!R)return m.Unknown;if(R instanceof b)return R.code;const J=/^(.+) \(FileSystemError\)$/.exec(R.name);if(!J)return m.Unknown;switch(J[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}function y(R){if(R instanceof V)return R.fileOperationResult;switch(f(R)){case m.FileNotFound:return re.FILE_NOT_FOUND;case m.FileIsADirectory:return re.FILE_IS_DIRECTORY;case m.FileNotADirectory:return re.FILE_NOT_DIRECTORY;case m.FileWriteLocked:return re.FILE_WRITE_LOCKED;case m.NoPermissions:return re.FILE_PERMISSION_DENIED;case m.FileExists:return re.FILE_MOVE_CONFLICT;case m.FileTooLarge:return re.FILE_TOO_LARGE;default:return re.FILE_OTHER_ERROR}}var G;(function(R){R[R.CREATE=0]="CREATE",R[R.DELETE=1]="DELETE",R[R.MOVE=2]="MOVE",R[R.COPY=3]="COPY",R[R.WRITE=4]="WRITE"})(G||(e.FileOperation=G={}));class C{constructor(J,ee,ie){this.resource=J,this.operation=ee,this.target=ie}isOperation(J){return this.operation===J}}e.$sl=C;var x;(function(R){R[R.UPDATED=0]="UPDATED",R[R.ADDED=1]="ADDED",R[R.DELETED=2]="DELETED"})(x||(e.FileChangeType=x={}));class K{static{this.a=null}constructor(J,ee){this.c=ee,this.b=void 0,this.d=new E.$T(()=>{const ie=_.$Li.forUris(()=>this.c);return ie.fill(this.rawAdded.map(ue=>[ue,!0])),ie}),this.f=new E.$T(()=>{const ie=_.$Li.forUris(()=>this.c);return ie.fill(this.rawUpdated.map(ue=>[ue,!0])),ie}),this.g=new E.$T(()=>{const ie=_.$Li.forUris(()=>this.c);return ie.fill(this.rawDeleted.map(ue=>[ue,!0])),ie}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ie of J){switch(ie.type){case x.ADDED:this.rawAdded.push(ie.resource);break;case x.UPDATED:this.rawUpdated.push(ie.resource);break;case x.DELETED:this.rawDeleted.push(ie.resource);break}this.b!==K.a&&(typeof ie.cId=="number"?this.b===void 0?this.b=ie.cId:this.b!==ie.cId&&(this.b=K.a):this.b!==void 0&&(this.b=K.a))}}contains(J,...ee){return this.h(J,{includeChildren:!1},...ee)}affects(J,...ee){return this.h(J,{includeChildren:!0},...ee)}h(J,ee,...ie){if(!J)return!1;const ue=ie.length>0;return!!((!ue||ie.includes(x.ADDED))&&(this.d.value.get(J)||ee.includeChildren&&this.d.value.findSuperstr(J))||(!ue||ie.includes(x.UPDATED))&&(this.f.value.get(J)||ee.includeChildren&&this.f.value.findSuperstr(J))||(!ue||ie.includes(x.DELETED))&&(this.g.value.findSubstr(J)||ee.includeChildren&&this.g.value.findSuperstr(J)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(J){return this.b===J}hasCorrelation(){return typeof this.b=="number"}}e.$tl=K;function se(R,J,ee){return!R||!J||R===J||J.length>R.length?!1:(J.charAt(J.length-1)!==t.sep&&(J+=t.sep),ee?(0,W.$Gf)(R,J):R.indexOf(J)===0)}class V extends Error{constructor(J,ee,ie){super(J),this.fileOperationResult=ee,this.options=ie}}e.$vl=V;class ne extends V{constructor(J,ee,ie,ue){super(J,ee,ue),this.fileOperationResult=ee,this.size=ie}}e.$wl=ne;class ce extends V{constructor(J,ee,ie){super(J,re.FILE_NOT_MODIFIED_SINCE,ie),this.stat=ee}}e.$xl=ce;var re;(function(R){R[R.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",R[R.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",R[R.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",R[R.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",R[R.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",R[R.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",R[R.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",R[R.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",R[R.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",R[R.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",R[R.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.$yl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$zl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Al="files.associations",e.$Bl="files.exclude",e.$Cl="files.readonlyInclude",e.$Dl="files.readonlyExclude",e.$El="files.readonlyFromPermissions";var I;(function(R){R[R.FILE=0]="FILE",R[R.FOLDER=1]="FOLDER",R[R.ROOT_FOLDER=2]="ROOT_FOLDER"})(I||(e.FileKind=I={})),e.$Fl="";function $(R){if(!(typeof R.size!="number"||typeof R.mtime!="number"))return R.mtime.toString(29)+R.size.toString(31)}async function S(R,J){if(!J.hasProvider(X.URI.from({scheme:R.scheme})))return new Promise(ee=>{const ie=J.onDidChangeFileSystemProviderRegistrations(ue=>{ue.scheme===R.scheme&&ue.added&&(ie.dispose(),ee())})})}class q{static{this.KB=1024}static{this.MB=q.KB*q.KB}static{this.GB=q.MB*q.KB}static{this.TB=q.GB*q.KB}static formatSize(J){return(0,j.$ig)(J)||(J=0),J<q.KB?(0,k.localize)(11386,null,J.toFixed(0)):J<q.MB?(0,k.localize)(11387,null,(J/q.KB).toFixed(2)):J<q.GB?(0,k.localize)(11388,null,(J/q.MB).toFixed(2)):J<q.TB?(0,k.localize)(11389,null,(J/q.GB).toFixed(2)):(0,k.localize)(11390,null,(J/q.TB).toFixed(2))}}e.$Il=q;function Q(R){const J=typeof R=="string"||R?.scheme===F.Schemas.vscodeRemote;return typeof R!="string"&&R?.scheme===F.Schemas.file?1024*q.MB:J?10*q.MB:T.$p?50*q.MB:1024*q.MB}}),define(be[19],_e([0,1,23,4,3,2,5,18]),function(fe,e,_,t,W,j,X,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=e.$6q=void 0,e.$4q=L,e.$5q=T,e.$9q=p,e.$0q=o,e.$$q=r,e.$_q=h,e.$ar=l,e.$br=D;function L(A){return typeof A.correlationId=="number"}function T(A){return A.recursive===!0}class F extends t.$Uc{static{this.a=5}constructor(u,i,n,s){super(),this.h=u,this.j=i,this.m=n,this.n=s,this.c=this.B(new t.$Vc),this.f=void 0,this.g=0}s(){const u=new t.$Tc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(i=>this.h(i))),u.add(this.b.onDidLogMessage(i=>this.j(i))),u.add(this.b.onDidError(i=>this.t(i.error,i.request)))}t(u,i){this.u(u,i)?this.g<F.a&&this.f?(this.y(`restarting watcher after unexpected error: ${u}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${u}`):this.y(u)}u(u,i){return!(!this.n.restartOnError||i||u.indexOf("No space left on device")!==-1||u.indexOf("EMFILE")!==-1)}w(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}y(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}z(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$6q=F;class E extends F{constructor(u,i,n){super(u,i,n,{type:"node.js",restartOnError:!1})}}e.$7q=E;class v extends F{constructor(u,i,n){super(u,i,n,{type:"universal",restartOnError:!0})}}e.$8q=v;function p(A){return A.map(u=>({type:u.type,resource:X.URI.revive(u.resource),cId:u.cId}))}function o(A){const u=new w;for(const i of A)u.processEvent(i);return u.coalesce()}function r(A,u){return typeof u=="string"&&!u.startsWith(_.$wk)&&!(0,W.$ic)(u)?{base:A,pattern:u}:u}function h(A,u){const i=[];for(const n of u)i.push((0,_.$Ak)(r(A,n)));return i}class w{constructor(){this.a=new Set,this.b=new Map}c(u){return j.$l?u.resource.fsPath:u.resource.fsPath.toLowerCase()}processEvent(u){const i=this.b.get(this.c(u));let n=!1;if(i){const s=i.type,c=u.type;i.resource.fsPath!==u.resource.fsPath&&(u.type===k.FileChangeType.DELETED||u.type===k.FileChangeType.ADDED)?n=!0:s===k.FileChangeType.ADDED&&c===k.FileChangeType.DELETED?(this.b.delete(this.c(u)),this.a.delete(i)):s===k.FileChangeType.DELETED&&c===k.FileChangeType.ADDED?i.type=k.FileChangeType.UPDATED:s===k.FileChangeType.ADDED&&c===k.FileChangeType.UPDATED||(i.type=c)}else n=!0;n&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],i=[];return Array.from(this.a).filter(n=>n.type!==k.FileChangeType.DELETED?(u.push(n),!1):!0).sort((n,s)=>n.resource.fsPath.length-s.resource.fsPath.length).filter(n=>i.some(s=>(0,k.$ul)(n.resource.fsPath,s,!j.$l))?!1:(i.push(n.resource.fsPath),!0)).concat(u)}}function l(A,u){if(typeof u=="number")switch(A.type){case k.FileChangeType.ADDED:return(u&k.FileChangeFilter.ADDED)===0;case k.FileChangeType.DELETED:return(u&k.FileChangeFilter.DELETED)===0;case k.FileChangeType.UPDATED:return(u&k.FileChangeFilter.UPDATED)===0}return!1}function D(A){if(typeof A=="number"){const u=[];return A&k.FileChangeFilter.ADDED&&u.push("Added"),A&k.FileChangeFilter.DELETED&&u.push("Deleted"),A&k.FileChangeFilter.UPDATED&&u.push("Updated"),u.length===0?"<all>":`[${u.join(", ")}]`}return"<none>"}}),define(be[35],_e([0,1,15,4,19,6,18,5,8]),function(fe,e,_,t,W,j,X,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class T extends t.$Uc{constructor(){super(),this.a=this.B(new j.$le),this.onDidChangeFile=this.a.event,this.b=this.B(new j.$le),this.onDidLogMessage=this.b.event,this.c=this.B(new j.$le),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new t.$4c),this.m=new Set,this.n=this.B(new L.$Dh(this.y())),this.r=5007,this.s=new L.$3h,this.R=!1,this.B(this.f(E=>this.t(E)))}t(E){this.u(E)&&this.z(E)}u(E){return(0,W.$4q)(E)}async watch(E){this.s.isSettled||this.s.complete(),this.s=new L.$3h;try{this.h.clear(),this.g.clear();for(const v of E)this.u(v)?this.h.set(v.correlationId,v):this.g.add(v);for(const[v]of this.j)this.h.has(v)||(this.j.deleteAndDispose(v),this.m.delete(v));return await this.w(!1)}finally{this.s.complete()}}w(E){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(v=>!this.j.has(v.correlationId))]),E?this.y():0)}y(){return 800}isSuspended(E){return typeof E.correlationId!="number"?!1:this.m.has(E.correlationId)?"polling":this.j.has(E.correlationId)}async z(E){if(this.j.has(E.correlationId))return;const v=new t.$Tc;this.j.set(E.correlationId,v),await this.s.p,!v.isDisposed&&(this.D(E,v),this.w(!0))}C(E){this.j.deleteAndDispose(E.correlationId),this.m.delete(E.correlationId),this.w(!1)}D(E,v){this.F(E,v)?(this.P(`reusing an existing recursive watcher to monitor ${E.path}`),this.m.delete(E.correlationId)):(this.G(E,v),this.m.add(E.correlationId))}F(E,v){const p=this.O?.subscribe(E.path,(o,r)=>{v.isDisposed||(o?this.D(E,v):r?.type===X.FileChangeType.ADDED&&this.H(E))});return p?(v.add(p),!0):!1}G(E,v){let p=!1;const o=(r,h)=>{if(v.isDisposed)return;const w=this.I(r),l=this.I(h),D=p;p=w,!w&&(l||D)&&this.H(E)};this.P(`starting fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,_.watchFile)(E.path,{persistent:!1,interval:this.r},o)}catch(r){this.Q(`fs.watchFile() failed with error ${r} on path ${E.path} (correlationId: ${E.correlationId})`)}v.add((0,t.$Sc)(()=>{this.P(`stopping fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,_.unwatchFile)(E.path,o)}catch(r){this.Q(`fs.unwatchFile() failed with error ${r} on path ${E.path} (correlationId: ${E.correlationId})`)}}))}H(E){this.P(`detected ${E.path} exists again, resuming watcher (correlationId: ${E.correlationId})`);const v={resource:k.URI.file(E.path),type:X.FileChangeType.ADDED,cId:E.correlationId};this.a.fire([v]),this.J(v,E),this.C(E)}I(E){return E.ctimeMs===0&&E.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(E,v){if(this.R){const p=` >> normalized ${E.type===X.FileChangeType.ADDED?"[ADDED]":E.type===X.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`;this.L(p,v)}}L(E,v){this.R&&this.P(`${E}${typeof v.correlationId=="number"?` <${v.correlationId}> `:""}`)}M(E){return`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, filter: ${(0,W.$br)(E.filter)}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`}async setVerboseLogging(E){this.R=E}}e.$kr=T}),define(be[36],_e([0,1,15,8,13,14,4,21,3,2,22,5,32,24,18,19]),function(fe,e,_,t,W,j,X,k,L,T,F,E,v,p,o,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0,e.$qr=w;class h extends X.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(D,A,u,i,n,s){super(),this.s=D,this.t=A,this.u=u,this.w=i,this.y=n,this.z=s,this.c=this.B(new t.$Uh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.u(c))),this.f=this.B(new t.$Th(c=>this.M(c),h.b)),this.g=(0,r.$_q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,r.$_q)(this.s.path,this.s.includes):void 0,this.j=(0,r.$4q)(this.s)?this.s.filter:void 0,this.m=new W.$we,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const D=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const A=await _.promises.stat(D);if(this.m.token.isCancellationRequested)return;this.B(await this.G(D,A.isDirectory()))}catch(D){D.code!=="ENOENT"?this.O(D):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${D})`),this.D()}}D(){this.r=!0,this.w?.()}async F(D){let A=D.path;try{A=await p.Promises.realpath(D.path),D.path===A&&(A=await(0,v.$mr)(D.path,this.m.token)??D.path),D.path!==A&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${D.path}, real: ${A})`)}catch{}return A}async G(D,A){const u=new X.$Tc;return this.H(D,A,u)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(D,A,u)),u}H(D,A,u){if(A)return!1;const i=E.URI.file(this.s.path),n=this.t?.subscribe(this.s.path,async(s,c)=>{if(!u.isDisposed)if(s){const P=await this.G(D,A);u.isDisposed?P.dispose():u.add(P)}else c&&(typeof c.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:i,type:c.type,cId:this.s.correlationId},!0)});return n?(u.add(n),!0):!1}async I(D,A,u){if(T.$k&&(0,j.$Eg)(D,"/Volumes/",!0)){this.O(`Refusing to watch ${D} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const i=new W.$we(this.m.token);u.add((0,X.$Sc)(()=>i.dispose(!0)));const n=new X.$Tc;u.add(n);try{const s=E.URI.file(this.s.path),c=(0,L.$nc)(D),P=(0,_.watch)(D);n.add((0,X.$Sc)(()=>{P.removeAllListeners(),P.close()})),this.Q(`Started watching: '${D}'`);const m=new Set;if(A)try{for(const a of await p.Promises.readdir(D))m.add(a)}catch(a){this.O(a)}if(i.token.isCancellationRequested)return;const b=new Map;n.add((0,X.$Sc)(()=>{for(const[,a]of b)a.dispose();b.clear()})),P.on("error",(a,d)=>{i.token.isCancellationRequested||(this.O(`Failed to watch ${D} for changes using fs.watch() (${a}, ${d})`),this.D())}),P.on("change",(a,d)=>{if(i.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${a}"] ${d}`);let N="";if(d&&(N=d.toString(),T.$k&&(N=(0,k.$nm)(N))),!(!N||a!=="change"&&a!=="rename"))if(A)if(a==="rename"){b.get(N)?.dispose();const f=setTimeout(async()=>{if(b.delete(N),N===c&&!await p.Promises.exists(D)){this.J(s);return}if(i.token.isCancellationRequested)return;const y=await this.N((0,L.$jc)(D,N));if(i.token.isCancellationRequested)return;let G;y?m.has(N)?G=o.FileChangeType.UPDATED:(G=o.FileChangeType.ADDED,m.add(N)):(m.delete(N),G=o.FileChangeType.DELETED),this.L({resource:(0,F.$gh)(s,N),type:G,cId:this.s.correlationId})},h.a);b.set(N,(0,X.$Sc)(()=>clearTimeout(f)))}else{let f;m.has(N)?f=o.FileChangeType.UPDATED:(f=o.FileChangeType.ADDED,m.add(N)),this.L({resource:(0,F.$gh)(s,N),type:f,cId:this.s.correlationId})}else if(a==="rename"||N!==c){const f=setTimeout(async()=>{const y=await p.Promises.exists(D);i.token.isCancellationRequested||(y?(this.L({resource:s,type:o.FileChangeType.UPDATED,cId:this.s.correlationId},!0),n.add(await this.G(D,!1))):this.J(s))},h.a);n.clear(),n.add((0,X.$Sc)(()=>clearTimeout(f)))}else this.L({resource:s,type:o.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(s){i.token.isCancellationRequested||this.O(`Failed to watch ${D} for changes using fs.watch() (${s.toString()})`),this.D()}}J(D){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:D,type:o.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(D,A=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${D.type===o.FileChangeType.ADDED?"[ADDED]":D.type===o.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${D.resource.fsPath}`),!A&&this.g.some(u=>u(D.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${D.resource.fsPath}`):!A&&this.h&&this.h.length>0&&!this.h.some(u=>u(D.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${D.resource.fsPath}`):this.f.work(D))}M(D){const A=(0,r.$0q)(D),u=[];for(const n of A){if((0,r.$ar)(n,this.j)){this.z&&this.R(` >> ignored (filtered) ${n.resource.fsPath}`);continue}u.push(n)}if(u.length===0)return;if(this.z)for(const n of u)this.R(` >> normalized ${n.type===o.FileChangeType.ADDED?"[ADDED]":n.type===o.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`);this.c.work(u)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(D){if(T.$l)return p.Promises.exists(D);try{const A=(0,L.$nc)(D);return(await p.Promises.readdir((0,L.$mc)(D))).some(i=>i===A)}catch(A){return this.Q(A),!1}}setVerboseLogging(D){this.z=D}O(D){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${D}`})}P(D){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${D}`})}Q(D){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${D}`})}R(D){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${D}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$pr=h;async function w(l,D,A,u,i=512){const n=await p.Promises.open(l,"r"),s=Buffer.allocUnsafe(i),c=new W.$we(u);let P,m=!1;const b={path:l,excludes:[],recursive:!1},a=new h(b,void 0,d=>{(async()=>{for(const{type:N}of d)if(N===o.FileChangeType.UPDATED){if(m)return;m=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:f}=await p.Promises.read(n,s,0,i,null);if(!f||c.token.isCancellationRequested)break;D(s.slice(0,f))}}catch(f){P=new Error(f),c.dispose(!0)}finally{m=!1}}})()});return await a.ready,A(),new Promise((d,N)=>{c.token.onCancellationRequested(async()=>{a.dispose();try{await p.Promises.close(n)}catch(f){P=new Error(f)}P?N(P):d()})})}}),define(be[56],_e([0,1,6,23,35,2,36,14]),function(fe,e,_,t,W,j,X,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class L extends W.$kr{constructor(F){super(),this.O=F,this.onDidError=_.Event.None,this.watchers=new Set}async N(F){F=this.Z(F);const E=[],v=new Set(Array.from(this.watchers));for(const p of F){const o=this.W(p);o&&(0,t.$Ek)(o.request.excludes,p.excludes)&&(0,t.$Ek)(o.request.includes,p.includes)?v.delete(o):E.push(p)}E.length&&this.P(`Request to start watching: ${E.map(p=>this.M(p)).join(",")}`),v.size&&this.P(`Request to stop watching: ${Array.from(v).map(p=>this.M(p.request)).join(",")}`);for(const p of v)this.Y(p);for(const p of E)this.X(p)}W(F){for(const E of this.watchers)if(typeof F.correlationId=="number"||typeof E.request.correlationId=="number"){if(E.request.correlationId===F.correlationId)return E}else if((0,k.$Dg)(E.request.path,F.path,!j.$l))return E}X(F){const E=new X.$pr(F,this.O,p=>this.a.fire(p),()=>this.c.fire(F),p=>this.b.fire(p),this.R),v={request:F,instance:E};this.watchers.add(v)}async stop(){await super.stop();for(const F of this.watchers)this.Y(F)}Y(F){this.P("stopping file watcher",F),this.watchers.delete(F),F.instance.dispose()}Z(F){const E=new Map;for(const v of F){const p=j.$l?v.path:v.path.toLowerCase();let o=E.get(v.correlationId);o||(o=new Map,E.set(v.correlationId,o)),o.has(p)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(v)}`),o.set(p,v)}return Array.from(E.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(F){super.setVerboseLogging(F);for(const E of this.watchers)E.instance.setVerboseLogging(F)}P(F,E){this.R&&this.b.fire({type:"trace",message:this.bb(F,E)})}Q(F){this.b.fire({type:"warn",message:this.bb(F)})}bb(F,E){return E?`[File Watcher (node.js)] ${F} (${this.M(E.request)})`:`[File Watcher (node.js)] ${F}`}}e.$rr=L}),define(be[57],_e([0,1,62,15,50,5,8,13,54,6,14,23,35,30,21,3,2,32,36,18,19,4]),function(fe,e,_,t,W,j,X,k,L,T,F,E,v,p,o,r,h,w,l,D,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=e.$tmc=void 0,_=Ie(_);class i extends u.$Uc{get failed(){return this.c}get stopped(){return this.f}constructor(c,P,m,b,a,d){super(),this.ready=c,this.request=P,this.restarts=m,this.token=b,this.worker=a,this.m=d,this.a=this.B(new T.$le),this.onDidStop=this.a.event,this.b=this.B(new T.$le),this.onDidFail=this.b.event,this.c=!1,this.f=!1,this.g=this.request.includes?(0,A.$_q)(this.request.path,this.request.includes):void 0,this.h=this.request.excludes?(0,A.$_q)(this.request.path,this.request.excludes):void 0,this.j=new Map,this.B((0,u.$Sc)(()=>this.j.clear()))}subscribe(c,P){c=j.URI.file(c).fsPath;let m=this.j.get(c);return m||(m=new Set,this.j.set(c,m)),m.add(P),(0,u.$Sc)(()=>{const b=this.j.get(c);b&&(b.delete(P),b.size===0&&this.j.delete(c))})}get subscriptionsCount(){return this.j.size}notifyFileChange(c,P){const m=this.j.get(c);if(m)for(const b of m)b(P)}notifyWatchFailed(){this.c=!0,this.b.fire()}include(c){return!this.g||this.g.length===0?!0:this.g.some(P=>P(c))}exclude(c){return!!this.h?.some(P=>P(c))}async stop(c){this.f=!0;try{await this.m()}finally{this.a.fire({joinRestart:c}),this.dispose()}}}e.$tmc=i;class n extends v.$kr{static{this.S=new Map([["create",D.FileChangeType.ADDED],["update",D.FileChangeType.UPDATED],["delete",D.FileChangeType.DELETED]])}static{this.U=h.$j?"windows":h.$l?"inotify":"fs-events"}static{this.X=75}constructor(){super(),this.W=this.B(new T.$le),this.onDidError=this.W.event,this.watchers=new Set,this.Y=this.B(new X.$Uh({maxWorkChunkSize:500,throttleDelay:200,maxBufferedWork:3e4},c=>this.a.fire(c))),this.Z=!1,this.$()}$(){process.on("uncaughtException",c=>this.nb(c)),process.on("unhandledRejection",c=>this.nb(c))}async N(c){c=this.qb(c);const P=[],m=new Set(Array.from(this.watchers));for(const b of c){const a=this.bb(b);a&&(0,E.$Ek)(a.request.excludes,b.excludes)&&(0,E.$Ek)(a.request.includes,b.includes)&&a.request.pollingInterval===b.pollingInterval?m.delete(a):P.push(b)}P.length&&this.P(`Request to start watching: ${P.map(b=>this.M(b)).join(",")}`),m.size&&this.P(`Request to stop watching: ${Array.from(m).map(b=>this.M(b.request)).join(",")}`);for(const b of m)await this.pb(b);for(const b of P)b.pollingInterval?this.cb(b,b.pollingInterval):await this.db(b)}bb(c){for(const P of this.watchers)if(this.u(c)||this.u(P.request)){if(P.request.correlationId===c.correlationId)return P}else if((0,F.$Dg)(P.request.path,c.path,!h.$l))return P}cb(c,P,m=0){const b=new k.$we,a=new X.$3h,d=(0,F.$Ng)((0,W.tmpdir)(),"vscode-watcher-snapshot"),N=new i(a.p,c,m,b.token,new X.$Th(K=>this.gb(K,N),n.X),async()=>{b.dispose(!0),N.worker.flush(),N.worker.dispose(),x.dispose(),(0,t.unlinkSync)(d)});this.watchers.add(N);const{realPath:f,realPathDiffers:y,realPathLength:G}=this.ib(c);this.P(`Started watching: '${f}' with polling interval '${P}'`);let C=0;const x=new X.$Rh(async()=>{if(C++,!b.token.isCancellationRequested){if(C>1){const K=await _.getEventsSince(f,d,{ignore:c.excludes,backend:n.U});if(b.token.isCancellationRequested)return;this.eb(K,N,y,G)}await _.writeSnapshot(f,d,{ignore:c.excludes,backend:n.U}),C===1&&a.complete(),!b.token.isCancellationRequested&&x.schedule()}},P);x.schedule(0)}async db(c,P=0){const m=new k.$we,b=new X.$3h,a=new i(b.p,c,P,m.token,new X.$Th(y=>this.gb(y,a),n.X),async()=>{m.dispose(!0),a.worker.flush(),a.worker.dispose(),await(await b.p)?.unsubscribe()});this.watchers.add(a);const{realPath:d,realPathDiffers:N,realPathLength:f}=this.ib(c);try{const y=await _.subscribe(d,(G,C)=>{a.token.isCancellationRequested||(G&&this.nb(G,c),this.eb(C,a,N,f))},{backend:n.U,ignore:a.request.excludes});this.P(`Started watching: '${d}' with backend '${n.U}'`),b.complete(y)}catch(y){this.nb(y,c),b.complete(void 0),a.notifyWatchFailed(),this.c.fire(c)}}eb(c,P,m,b){if(c.length===0)return;this.jb(c,P.request,m,b);const a=this.fb(P,c);for(const d of a)P.worker.work(d)}fb(c,P){const m=[];for(const{path:b,type:a}of P){const d=n.S.get(a);this.R&&this.L(`${d===D.FileChangeType.ADDED?"[ADDED]":d===D.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${b}`,c.request),c.include(b)?m.push({type:d,resource:j.URI.file(b),cId:c.request.correlationId}):this.R&&this.L(` >> ignored (not included) ${b}`,c.request)}return m}gb(c,P){const m=(0,A.$0q)(c),{events:b,rootDeleted:a}=this.kb(m,P);this.hb(b,P),a&&this.lb(P)}hb(c,P){if(c.length===0)return;this.Y.work(c)?this.Y.pending>0&&this.P(`started throttling events due to large amount of file change events at once (pending: ${this.Y.pending}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`,P):this.Q(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}ib(c){let P=c.path,m=!1,b=c.path.length;try{P=(0,w.$or)(c.path),c.path===P&&(P=(0,w.$lr)(c.path)??c.path),c.path!==P&&(b=P.length,m=!0,this.P(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${P})`))}catch{}return{realPath:P,realPathDiffers:m,realPathLength:b}}jb(c,P,m,b){for(const a of c)h.$k&&(a.path=(0,o.$nm)(a.path)),h.$j&&P.path.length<=3&&(a.path=(0,r.$hc)(a.path)),m&&(a.path=P.path+a.path.substr(b))}kb(c,P){const m=[];let b=!1;const a=this.u(P.request)?P.request.filter:void 0;for(const d of c){if(P.subscriptionsCount>0&&P.notifyFileChange(d.resource.fsPath,d),b=d.type===D.FileChangeType.DELETED&&(0,F.$Dg)(d.resource.fsPath,P.request.path,!h.$l),(0,A.$ar)(d,a)||b&&!this.u(P.request)){this.R&&this.L(` >> ignored (filtered) ${d.resource.fsPath}`,P.request);continue}this.J(d,P.request),m.push(d)}return{events:m,rootDeleted:b}}lb(c){this.Q("Watcher shutdown because watched path got deleted",c);let P=!1;this.u(c.request)||(P=this.mb(c)),P||(c.notifyWatchFailed(),this.c.fire(c.request))}mb(c){const P=(0,r.$mc)(c.request.path);if((0,t.existsSync)(P)){this.P("Trying to watch on the parent path to restart the watcher...",c);const m=new l.$pr({path:P,excludes:[],recursive:!1,correlationId:c.request.correlationId},void 0,b=>{if(!c.token.isCancellationRequested){for(const{resource:a,type:d}of b)if((0,F.$Dg)(a.fsPath,c.request.path,!h.$l)&&(d===D.FileChangeType.ADDED||d===D.FileChangeType.UPDATED)&&this.rb(c.request.path)){this.Q("Watcher restarts because watched path got created again",c),m.dispose(),this.ob(c);break}}},void 0,b=>this.b.fire(b),this.R);return c.token.onCancellationRequested(()=>m.dispose()),!0}return!1}nb(c,P){const m=(0,L.$qj)(c);m.indexOf("No space left on device")!==-1?this.Z||(this.ub("Inotify limit reached (ENOSPC)",P),this.Z=!0):(this.ub(`Unexpected error: ${m} (EUNKNOWN)`,P),this.W.fire({request:P,error:m}))}async stop(){await super.stop();for(const c of this.watchers)await this.pb(c)}ob(c,P=800){const m=new X.$Rh(async()=>{if(c.token.isCancellationRequested)return;const b=new X.$3h;try{await this.pb(c,b.p),c.request.pollingInterval?this.cb(c.request,c.request.pollingInterval,c.restarts+1):await this.db(c.request,c.restarts+1)}finally{b.complete()}},P);m.schedule(),c.token.onCancellationRequested(()=>m.dispose())}async pb(c,P){this.P("stopping file watcher",c),this.watchers.delete(c);try{await c.stop(P)}catch(m){this.ub(`Unexpected error stopping watcher: ${(0,L.$qj)(m)}`,c.request)}}qb(c,P=!0){c.sort((a,d)=>a.path.length-d.path.length);const m=new Map;for(const a of c){if(a.excludes.includes(E.$wk))continue;const d=h.$l?a.path:a.path.toLowerCase();let N=m.get(a.correlationId);N||(N=new Map,m.set(a.correlationId,N)),N.has(d)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(a)}`),N.set(d,a)}const b=[];for(const a of m.values()){const d=p.$Li.forPaths(!h.$l);for(const N of a.values()){if(d.findSubstr(N.path))try{if((0,w.$or)(N.path)===N.path){this.P(`ignoring a request for watching who's parent is already watched: ${this.M(N)}`);continue}}catch(f){this.P(`ignoring a request for watching who's realpath failed to resolve: ${this.M(N)} (error: ${f})`),this.c.fire(N);continue}if(P&&!this.rb(N.path)){this.c.fire(N);continue}d.set(N.path,N)}b.push(...Array.from(d).map(([,N])=>N))}return b}rb(c){try{if(!(0,t.statSync)(c).isDirectory())return this.P(`ignoring a path for watching that is a file and not a folder: ${c}`),!1}catch(P){return this.P(`ignoring a path for watching who's stat info failed to resolve: ${c} (error: ${P})`),!1}return!0}subscribe(c,P){for(const m of this.watchers){if(m.failed||!(0,F.$Eg)(c,m.request.path,!h.$l)||m.exclude(c)||!m.include(c))continue;const b=new u.$Tc;return b.add(T.Event.once(m.onDidStop)(async a=>{await a.joinRestart,!b.isDisposed&&P(!0)})),b.add(T.Event.once(m.onDidFail)(()=>P(!0))),b.add(m.subscribe(c,a=>P(null,a))),b}}P(c,P){this.R&&this.b.fire({type:"trace",message:this.vb(c,P?.request)})}Q(c,P){this.b.fire({type:"warn",message:this.vb(c,P?.request)})}ub(c,P){this.b.fire({type:"error",message:this.vb(c,P)})}vb(c,P){return P?`[File Watcher (parcel)] ${c} (path: ${P.path})`:`[File Watcher (parcel)] ${c}`}get O(){return this}}e.$umc=n}),define(be[58],_e([0,1,19]),function(fe,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=t;function t(o,r,h){const w=[],l=L(o.filter(G=>G.recursive)),D=l.filter(G=>r.isSuspended(G)===!1),A=l.filter(G=>r.isSuspended(G)==="polling"),u=l.filter(G=>r.isSuspended(G)===!0),i=j(l,r),n=X(r),s=L(o.filter(G=>!G.recursive)),c=s.filter(G=>h.isSuspended(G)===!1),P=s.filter(G=>h.isSuspended(G)==="polling"),m=s.filter(G=>h.isSuspended(G)===!0),b=j(s,h),a=k(h);w.push("[Summary]"),w.push(`- Recursive Requests:     total: ${l.length}, suspended: ${i.suspended}, polling: ${i.polling}`),w.push(`- Non-Recursive Requests: total: ${s.length}, suspended: ${b.suspended}, polling: ${b.polling}`),w.push(`- Recursive Watchers:     total: ${r.watchers.size}, active: ${n.active}, failed: ${n.failed}, stopped: ${n.stopped}`),w.push(`- Non-Recursive Watchers: total: ${h.watchers.size}, active: ${a.active}, failed: ${a.failed}, reusing: ${a.reusing}`),w.push(`- I/O Handles Impact:     total: ${i.polling+b.polling+n.active+a.active}`),w.push(`
[Recursive Requests (${l.length}, suspended: ${i.suspended}, polling: ${i.polling})]:`);const d=[];for(const G of[D,A,u].flat())F(d,G,r);w.push(...W(d));const N=[];v(N,r),w.push(...W(N)),w.push(`
[Non-Recursive Requests (${s.length}, suspended: ${b.suspended}, polling: ${b.polling})]:`);const f=[];for(const G of[c,P,m].flat())F(f,G,h);w.push(...W(f));const y=[];return p(y,h),w.push(...W(y)),`

[File Watcher] request stats:

${w.join(`
`)}

`}function W(o){let r=0;for(const h of o)r=Math.max(r,h.split("	")[0].length);for(let h=0;h<o.length;h++){const l=o[h].split("	");if(l.length===2){const D=" ".repeat(r-l[0].length);o[h]=`${l[0]}${D}	${l[1]}`}}return o}function j(o,r){let h=0,w=0;for(const l of o){const D=r.isSuspended(l);D!==!1&&(w++,D==="polling"&&h++)}return{suspended:w,polling:h}}function X(o){let r=0,h=0,w=0;for(const l of o.watchers.values())!l.failed&&!l.stopped&&r++,l.failed&&h++,l.stopped&&w++;return{active:r,failed:h,stopped:w}}function k(o){let r=0,h=0,w=0;for(const l of o.watchers)!l.instance.failed&&!l.instance.isReusingRecursiveWatcher&&r++,l.instance.failed&&h++,l.instance.isReusingRecursiveWatcher&&w++;return{active:r,failed:h,reusing:w}}function L(o){return o.sort((r,h)=>{const w=T(r)?r.path:r.request.path,l=T(h)?h.path:h.request.path,D=Math.min(w.length,l.length);for(let A=0;A<D;A++)if(w[A]!==l[A])return w[A]<l[A]?-1:1;return w.length-l.length}),o}function T(o){return typeof o?.path=="string"}function F(o,r,h){const w=[],l=h.isSuspended(r);l!==!1&&(l==="polling"?w.push("[SUSPENDED <polling>]"):w.push("[SUSPENDED <non-polling>]")),o.push(` ${r.path}	${w.length>0?w.join(" ")+" ":""}(${E(r)})`)}function E(o){return`excludes: ${o.excludes.length>0?o.excludes:"<none>"}, includes: ${o.includes&&o.includes.length>0?JSON.stringify(o.includes):"<all>"}, filter: ${(0,_.$br)(o.filter)}, correlationId: ${typeof o.correlationId=="number"?o.correlationId:"<none>"}`}function v(o,r){const h=L(Array.from(r.watchers.values())),{active:w,failed:l,stopped:D}=X(r);o.push(`
[Recursive Watchers (${h.length}, active: ${w}, failed: ${l}, stopped: ${D})]:`);for(const A of h){const u=[];A.failed&&u.push("[FAILED]"),A.stopped&&u.push("[STOPPED]"),A.subscriptionsCount>0&&u.push(`[SUBSCRIBED:${A.subscriptionsCount}]`),A.restarts>0&&u.push(`[RESTARTED:${A.restarts}]`),o.push(` ${A.request.path}	${u.length>0?u.join(" ")+" ":""}(${E(A.request)})`)}}function p(o,r){const h=L(Array.from(r.watchers.values())),w=h.filter(n=>!n.instance.failed&&!n.instance.isReusingRecursiveWatcher),l=h.filter(n=>n.instance.failed),D=h.filter(n=>n.instance.isReusingRecursiveWatcher),{active:A,failed:u,reusing:i}=k(r);o.push(`
[Non-Recursive Watchers (${h.length}, active: ${A}, failed: ${u}, reusing: ${i})]:`);for(const n of[w,l,D].flat()){const s=[];n.instance.failed&&s.push("[FAILED]"),n.instance.isReusingRecursiveWatcher&&s.push("[REUSING]"),o.push(` ${n.request.path}	${s.length>0?s.join(" ")+" ":""}(${E(n.request)})`)}}}),define(be[59],_e([0,1,4,6,57,56,8,58]),function(fe,e,_,t,W,j,X,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=void 0;class L extends _.$Uc{constructor(){super(...arguments),this.a=this.B(new W.$umc),this.b=this.B(new j.$rr(this.a)),this.onDidChangeFile=t.Event.any(this.a.onDidChangeFile,this.b.onDidChangeFile),this.onDidError=t.Event.any(this.a.onDidError,this.b.onDidError),this.c=this.B(new t.$le),this.onDidLogMessage=t.Event.any(this.c.event,this.a.onDidLogMessage,this.b.onDidLogMessage),this.f=[]}async watch(F){this.f=F;let E;try{await this.a.watch(F.filter(v=>v.recursive))}catch(v){E=v}try{await this.b.watch(F.filter(v=>!v.recursive))}catch(v){E||(E=v)}if(E)throw E}async setVerboseLogging(F){F&&this.f.length>0&&this.c.fire({type:"trace",message:(0,k.$vmc)(this.f,this.a,this.b)}),await X.Promises.settled([this.a.setVerboseLogging(F),this.b.setVerboseLogging(F)])}async stop(){await X.Promises.settled([this.a.stop(),this.b.stop()])}}e.$wmc=L}),define(be[63],_e([0,1,4,25,52,53,33,59]),function(fe,e,_,t,W,j,X,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;(0,X.$9X)(process)?L=new j.$0X:L=new W.$hr("watcher");const T=new k.$wmc;L.registerChannel("watcher",t.ProxyChannel.fromService(T,new _.$Tc))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/1d82f317af9c90b96a433fd6a599e4b1d31869a3/core/vs/platform/files/node/watcher/watcherMain.js.map
