/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/nls","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/extpath","vs/base/common/uuid","vs/base/node/pfs","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/marshalling","fs","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","child_process","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/decorators","vs/base/common/hash","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","os","net","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTesting","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/codiconsUtil","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/console","vs/amdX","vs/base/common/dataTransfer","vs/base/node/ports","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/base/common/actions","vs/base/common/date","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function($e){for(var e=[],r=0,h=$e.length;r<h;r++)e[r]=ke[$e[r]];return e};define(ke[174],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.LoaderEventType=e.$R=void 0,e.$R=!1;var r;(function(C){C[C.LoaderAvailable=1]="LoaderAvailable",C[C.BeginLoadingScript=10]="BeginLoadingScript",C[C.EndLoadingScriptOK=11]="EndLoadingScriptOK",C[C.EndLoadingScriptError=12]="EndLoadingScriptError",C[C.BeginInvokeFactory=21]="BeginInvokeFactory",C[C.EndInvokeFactory=22]="EndInvokeFactory",C[C.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",C[C.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",C[C.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",C[C.NodeEndNativeRequire=34]="NodeEndNativeRequire",C[C.CachedDataFound=60]="CachedDataFound",C[C.CachedDataMissed=61]="CachedDataMissed",C[C.CachedDataRejected=62]="CachedDataRejected",C[C.CachedDataCreated=63]="CachedDataCreated"})(r||(e.LoaderEventType=r={}));class h{static get(){const R=new Map,O=new Map,T=new Map,p=new Map;function c(w,a){w.has(a.detail)||w.set(a.detail,-a.timestamp)}function I(w,a){const m=w.get(a.detail);m&&(m>=0||w.set(a.detail,m+a.timestamp))}let S=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(S=$e.getStats().slice(0).sort((w,a)=>w.timestamp-a.timestamp));for(const w of S)switch(w.type){case r.BeginLoadingScript:c(R,w);break;case r.EndLoadingScriptOK:case r.EndLoadingScriptError:I(R,w);break;case r.BeginInvokeFactory:c(O,w);break;case r.EndInvokeFactory:I(O,w);break;case r.NodeBeginNativeRequire:c(T,w);break;case r.NodeEndNativeRequire:I(T,w);break;case r.NodeBeginEvaluatingScript:c(p,w);break;case r.NodeEndEvaluatingScript:I(p,w);break}let u=0;T.forEach(w=>u+=w);function P(w){const a=[];return w.forEach((m,$)=>a.push([$,m])),a}return{amdLoad:P(R),amdInvoke:P(O),nodeRequire:P(T),nodeEval:P(p),nodeRequireTotal:u}}static toMarkdownTable(R,O){let T="";const p=[];return R.forEach((c,I)=>{p[I]=c.length}),O.forEach(c=>{c.forEach((I,S)=>{typeof I>"u"&&(I=c[S]="-");const u=I.toString().length;p[S]=Math.max(u,p[S])})}),R.forEach((c,I)=>{T+=`| ${c+" ".repeat(p[I]-c.toString().length)} `}),T+=`|
`,R.forEach((c,I)=>{T+=`| ${"-".repeat(p[I])} `}),T+=`|
`,O.forEach(c=>{c.forEach((I,S)=>{typeof I<"u"&&(T+=`| ${I+" ".repeat(p[S]-I.toString().length)} `)}),T+=`|
`}),T}}e.$S=h}),define(ke[131],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=r,e.$fb=h,e.$gb=C,e.$hb=R,e.$ib=O,e.$jb=T,e.$kb=p,e.$mb=I,e.$nb=S,e.$ob=u,e.$pb=P,e.$qb=w;function r(a,m){const $=h(a,m);if($!==-1)return a[$]}function h(a,m,$=a.length-1){for(let f=$;f>=0;f--){const i=a[f];if(m(i))return f}return-1}function C(a,m){const $=R(a,m);return $===-1?void 0:a[$]}function R(a,m,$=0,f=a.length){let i=$,s=f;for(;i<s;){const t=Math.floor((i+s)/2);m(a[t])?i=t+1:s=t}return i-1}function O(a,m){const $=T(a,m);return $===a.length?void 0:a[$]}function T(a,m,$=0,f=a.length){let i=$,s=f;for(;i<s;){const t=Math.floor((i+s)/2);m(a[t])?s=t:i=t+1}return i}function p(a,m,$=0,f=a.length){const i=T(a,m,$,f);return i===a.length?-1:i}class c{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(c.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!m(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const $=R(this.e,m,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$lb=c;function I(a,m){if(a.length===0)return;let $=a[0];for(let f=1;f<a.length;f++){const i=a[f];m(i,$)>0&&($=i)}return $}function S(a,m){if(a.length===0)return;let $=a[0];for(let f=1;f<a.length;f++){const i=a[f];m(i,$)>=0&&($=i)}return $}function u(a,m){return I(a,($,f)=>-m($,f))}function P(a,m){if(a.length===0)return-1;let $=0;for(let f=1;f<a.length;f++){const i=a[f];m(i,a[$])>0&&($=f)}return $}function w(a,m){for(const $ of a){const f=m($);if(f!==void 0)return f}}}),define(ke[26],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var r;(function(h){h[h.Null=0]="Null",h[h.Backspace=8]="Backspace",h[h.Tab=9]="Tab",h[h.LineFeed=10]="LineFeed",h[h.CarriageReturn=13]="CarriageReturn",h[h.Space=32]="Space",h[h.ExclamationMark=33]="ExclamationMark",h[h.DoubleQuote=34]="DoubleQuote",h[h.Hash=35]="Hash",h[h.DollarSign=36]="DollarSign",h[h.PercentSign=37]="PercentSign",h[h.Ampersand=38]="Ampersand",h[h.SingleQuote=39]="SingleQuote",h[h.OpenParen=40]="OpenParen",h[h.CloseParen=41]="CloseParen",h[h.Asterisk=42]="Asterisk",h[h.Plus=43]="Plus",h[h.Comma=44]="Comma",h[h.Dash=45]="Dash",h[h.Period=46]="Period",h[h.Slash=47]="Slash",h[h.Digit0=48]="Digit0",h[h.Digit1=49]="Digit1",h[h.Digit2=50]="Digit2",h[h.Digit3=51]="Digit3",h[h.Digit4=52]="Digit4",h[h.Digit5=53]="Digit5",h[h.Digit6=54]="Digit6",h[h.Digit7=55]="Digit7",h[h.Digit8=56]="Digit8",h[h.Digit9=57]="Digit9",h[h.Colon=58]="Colon",h[h.Semicolon=59]="Semicolon",h[h.LessThan=60]="LessThan",h[h.Equals=61]="Equals",h[h.GreaterThan=62]="GreaterThan",h[h.QuestionMark=63]="QuestionMark",h[h.AtSign=64]="AtSign",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.OpenSquareBracket=91]="OpenSquareBracket",h[h.Backslash=92]="Backslash",h[h.CloseSquareBracket=93]="CloseSquareBracket",h[h.Caret=94]="Caret",h[h.Underline=95]="Underline",h[h.BackTick=96]="BackTick",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z",h[h.OpenCurlyBrace=123]="OpenCurlyBrace",h[h.Pipe=124]="Pipe",h[h.CloseCurlyBrace=125]="CloseCurlyBrace",h[h.Tilde=126]="Tilde",h[h.NoBreakSpace=160]="NoBreakSpace",h[h.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",h[h.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",h[h.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",h[h.U_Combining_Tilde=771]="U_Combining_Tilde",h[h.U_Combining_Macron=772]="U_Combining_Macron",h[h.U_Combining_Overline=773]="U_Combining_Overline",h[h.U_Combining_Breve=774]="U_Combining_Breve",h[h.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",h[h.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",h[h.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",h[h.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",h[h.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",h[h.U_Combining_Caron=780]="U_Combining_Caron",h[h.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",h[h.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",h[h.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",h[h.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",h[h.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",h[h.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",h[h.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",h[h.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",h[h.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",h[h.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",h[h.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",h[h.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",h[h.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",h[h.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",h[h.U_Combining_Horn=795]="U_Combining_Horn",h[h.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",h[h.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",h[h.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",h[h.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",h[h.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",h[h.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",h[h.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",h[h.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",h[h.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",h[h.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",h[h.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",h[h.U_Combining_Cedilla=807]="U_Combining_Cedilla",h[h.U_Combining_Ogonek=808]="U_Combining_Ogonek",h[h.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",h[h.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",h[h.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",h[h.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",h[h.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",h[h.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",h[h.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",h[h.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",h[h.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",h[h.U_Combining_Low_Line=818]="U_Combining_Low_Line",h[h.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",h[h.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",h[h.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",h[h.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",h[h.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",h[h.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",h[h.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",h[h.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",h[h.U_Combining_Square_Below=827]="U_Combining_Square_Below",h[h.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",h[h.U_Combining_X_Above=829]="U_Combining_X_Above",h[h.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",h[h.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",h[h.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",h[h.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",h[h.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",h[h.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",h[h.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",h[h.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",h[h.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",h[h.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",h[h.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",h[h.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",h[h.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",h[h.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",h[h.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",h[h.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",h[h.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",h[h.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",h[h.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",h[h.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",h[h.U_Combining_Fermata=850]="U_Combining_Fermata",h[h.U_Combining_X_Below=851]="U_Combining_X_Below",h[h.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",h[h.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",h[h.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",h[h.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",h[h.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",h[h.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",h[h.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",h[h.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",h[h.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",h[h.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",h[h.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",h[h.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",h[h.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",h[h.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",h[h.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",h[h.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",h[h.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",h[h.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",h[h.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",h[h.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",h[h.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",h[h.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",h[h.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",h[h.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",h[h.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",h[h.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",h[h.LINE_SEPARATOR=8232]="LINE_SEPARATOR",h[h.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",h[h.NEXT_LINE=133]="NEXT_LINE",h[h.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",h[h.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",h[h.U_DIAERESIS=168]="U_DIAERESIS",h[h.U_MACRON=175]="U_MACRON",h[h.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",h[h.U_CEDILLA=184]="U_CEDILLA",h[h.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",h[h.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",h[h.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",h[h.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",h[h.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",h[h.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",h[h.U_BREVE=728]="U_BREVE",h[h.U_DOT_ABOVE=729]="U_DOT_ABOVE",h[h.U_RING_ABOVE=730]="U_RING_ABOVE",h[h.U_OGONEK=731]="U_OGONEK",h[h.U_SMALL_TILDE=732]="U_SMALL_TILDE",h[h.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",h[h.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",h[h.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",h[h.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",h[h.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",h[h.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",h[h.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",h[h.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",h[h.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",h[h.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",h[h.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",h[h.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",h[h.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",h[h.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",h[h.U_GREEK_TONOS=900]="U_GREEK_TONOS",h[h.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",h[h.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",h[h.U_GREEK_PSILI=8127]="U_GREEK_PSILI",h[h.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",h[h.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",h[h.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",h[h.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",h[h.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",h[h.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",h[h.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",h[h.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",h[h.U_GREEK_VARIA=8175]="U_GREEK_VARIA",h[h.U_GREEK_OXIA=8189]="U_GREEK_OXIA",h[h.U_GREEK_DASIA=8190]="U_GREEK_DASIA",h[h.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",h[h.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",h[h.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",h[h.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",h[h.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",h[h.U_OVERLINE=8254]="U_OVERLINE",h[h.UTF8_BOM=65279]="UTF8_BOM",h[h.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",h[h.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(r||(e.CharCode=r={}))}),define(ke[78],Ie([1,0]),function($e,e){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=h,e.$d=C,e.$e=R,e.$f=O;function h(p,c){const I=Object.create(null);for(const S of p){const u=c(S);let P=I[u];P||(P=I[u]=[]),P.push(S)}return I}function C(p,c){const I=[],S=[];for(const u of p)c.has(u)||I.push(u);for(const u of c)p.has(u)||S.push(u);return{removed:I,added:S}}function R(p,c){const I=[],S=[];for(const[u,P]of p)c.has(u)||I.push(P);for(const[u,P]of c)p.has(u)||S.push(P);return{removed:I,added:S}}function O(p,c){const I=new Set;for(const S of c)p.has(S)&&I.add(S);return I}class T{static{r=Symbol.toStringTag}constructor(c,I){this.b=I,this.a=new Map,this[r]="SetWithKey";for(const S of c)this.add(S)}get size(){return this.a.size}add(c){const I=this.b(c);return this.a.set(I,c),this}delete(c){return this.a.delete(this.b(c))}has(c){return this.a.has(this.b(c))}*entries(){for(const c of this.a.values())yield[c,c]}keys(){return this.values()}*values(){for(const c of this.a.values())yield c}clear(){this.a.clear()}forEach(c,I){this.a.forEach(S=>c.call(I,S,S,this))}[Symbol.iterator](){return this.values()}}e.$g=T}),define(ke[59],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=h,e.$$h=C,e.$_h=R;function r(O){return(T,p,c)=>{let I=null,S=null;if(typeof c.value=="function"?(I="value",S=c.value):typeof c.get=="function"&&(I="get",S=c.get),!S)throw new Error("not supported");c[I]=O(S,p)}}function h(O,T,p){let c=null,I=null;if(typeof p.value=="function"?(c="value",I=p.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(c="get",I=p.get),!I)throw new Error("not supported");const S=`$memoize$${T}`;p[c]=function(...u){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,u)}),this[S]}}function C(O,T,p){return r((c,I)=>{const S=`$debounce$${I}`,u=`$debounce$result$${I}`;return function(...P){this[u]||(this[u]=p?p():void 0),clearTimeout(this[S]),T&&(this[u]=T(this[u],...P),P=[this[u]]),this[S]=setTimeout(()=>{c.apply(this,P),this[u]=p?p():void 0},O)}})}function R(O,T,p){return r((c,I)=>{const S=`$throttle$timer$${I}`,u=`$throttle$result$${I}`,P=`$throttle$lastRun$${I}`,w=`$throttle$pending$${I}`;return function(...a){if(this[u]||(this[u]=p?p():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),T&&(this[u]=T(this[u],...a)),this[w])return;const m=this[P]+O;m<=Date.now()?(this[P]=Date.now(),c.apply(this,[this[u]]),this[u]=p?p():void 0):(this[w]=!0,this[S]=setTimeout(()=>{this[w]=!1,this[P]=Date.now(),c.apply(this,[this[u]]),this[u]=p?p():void 0},m-Date.now()))}})}}),define(ke[13],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=h,e.$X=C,e.$Y=R,e.$Z=O,e.$1=T,e.$2=p,e.$3=I,e.$5=u,e.$6=P,e.$7=w,e.$9=m;class r{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?s.isErrorNoTelemetry(n)?new s(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(d=>{d(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$U=r,e.$V=new r;function h(o){e.$V.setUnexpectedErrorHandler(o)}function C(o){if(!o||typeof o!="object")return!1;const n=o;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function R(o){I(o)||e.$V.onUnexpectedError(o)}function O(o){I(o)||e.$V.onUnexpectedExternalError(o)}function T(o){if(o instanceof Error){const{name:n,message:d}=o,l=o.stacktrace||o.stack;return{$isError:!0,name:n,message:d,stack:l,noTelemetry:s.isErrorNoTelemetry(o)}}return o}function p(o){let n;return o.noTelemetry?n=new s:(n=new Error,n.name=o.name),n.message=o.message,n.stack=o.stack,n}const c="Canceled";function I(o){return o instanceof S?!0:o instanceof Error&&o.name===c&&o.message===c}class S extends Error{constructor(){super(c),this.name=this.message}}e.$4=S;function u(){const o=new Error(c);return o.name=o.message,o}function P(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function w(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class a extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=a;function m(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class $ extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$0=$;class f extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$$=f;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=i;class s extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof s)return n;const d=new s;return d.message=n.message,d.stack=n.stack,d}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$ab=s;class t extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.$bb=t}),define(ke[18],Ie([1,0,13,131]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=C,e.$sb=R,e.$tb=O,e.$ub=T,e.$vb=p,e.$wb=c,e.$xb=I,e.$yb=S,e.$zb=u,e.$Ab=P,e.$Bb=w,e.$Cb=a,e.$Db=m,e.top=$,e.$Fb=f,e.$Gb=s,e.$Hb=t,e.$Ib=o,e.$Jb=n,e.$Kb=d,e.$Lb=l,e.$Mb=g,e.$Nb=E,e.$Ob=D,e.$Pb=y,e.$Qb=k,e.$Rb=A,e.$Sb=b,e.$Tb=v,e.$Ub=F,e.$Vb=N,e.$Wb=L,e.$Xb=M,e.$Yb=z,e.$Zb=j,e.$1b=W,e.$2b=B,e.$3b=ee,e.$4b=H,e.$5b=_,e.$6b=ce,e.$9b=ge,e.$ac=ve;function C(te,ae=0){return te[te.length-(1+ae)]}function R(te){if(te.length===0)throw new Error("Invalid tail call");return[te.slice(0,te.length-1),te[te.length-1]]}function O(te,ae,se=(X,re)=>X===re){if(te===ae)return!0;if(!te||!ae||te.length!==ae.length)return!1;for(let X=0,re=te.length;X<re;X++)if(!se(te[X],ae[X]))return!1;return!0}function T(te,ae){const se=te.length-1;ae<se&&(te[ae]=te[se]),te.pop()}function p(te,ae,se){return c(te.length,X=>se(te[X],ae))}function c(te,ae){let se=0,X=te-1;for(;se<=X;){const re=(se+X)/2|0,pe=ae(re);if(pe<0)se=re+1;else if(pe>0)X=re-1;else return re}return-(se+1)}function I(te,ae,se){if(te=te|0,te>=ae.length)throw new TypeError("invalid index");const X=ae[Math.floor(ae.length*Math.random())],re=[],pe=[],we=[];for(const Fe of ae){const Be=se(Fe,X);Be<0?re.push(Fe):Be>0?pe.push(Fe):we.push(Fe)}return te<re.length?I(te,re,se):te<re.length+we.length?we[0]:I(te-(re.length+we.length),pe,se)}function S(te,ae){const se=[];let X;for(const re of te.slice(0).sort(ae))!X||ae(X[0],re)!==0?(X=[re],se.push(X)):X.push(re);return se}function*u(te,ae){let se,X;for(const re of te)X!==void 0&&ae(X,re)?se.push(re):(se&&(yield se),se=[re]),X=re;se&&(yield se)}function P(te,ae){for(let se=0;se<=te.length;se++)ae(se===0?void 0:te[se-1],se===te.length?void 0:te[se])}function w(te,ae){for(let se=0;se<te.length;se++)ae(se===0?void 0:te[se-1],te[se],se+1===te.length?void 0:te[se+1])}function a(te,ae,se){const X=[];function re(Fe,Be,Re){if(Be===0&&Re.length===0)return;const De=X[X.length-1];De&&De.start+De.deleteCount===Fe?(De.deleteCount+=Be,De.toInsert.push(...Re)):X.push({start:Fe,deleteCount:Be,toInsert:Re})}let pe=0,we=0;for(;;){if(pe===te.length){re(pe,0,ae.slice(we));break}if(we===ae.length){re(pe,te.length-pe,[]);break}const Fe=te[pe],Be=ae[we],Re=se(Fe,Be);Re===0?(pe+=1,we+=1):Re<0?(re(pe,1,[]),pe+=1):Re>0&&(re(pe,0,[Be]),we+=1)}return X}function m(te,ae,se){const X=a(te,ae,se),re=[],pe=[];for(const we of X)re.push(...te.slice(we.start,we.start+we.deleteCount)),pe.push(...we.toInsert);return{removed:re,added:pe}}function $(te,ae,se){if(se===0)return[];const X=te.slice(0,se).sort(ae);return i(te,ae,X,se,te.length),X}function f(te,ae,se,X,re){return se===0?Promise.resolve([]):new Promise((pe,we)=>{(async()=>{const Fe=te.length,Be=te.slice(0,se).sort(ae);for(let Re=se,De=Math.min(se+X,Fe);Re<Fe;Re=De,De=Math.min(De+X,Fe)){if(Re>se&&await new Promise(Ce=>setTimeout(Ce)),re&&re.isCancellationRequested)throw new r.$4;i(te,ae,Be,Re,De)}return Be})().then(pe,we)})}function i(te,ae,se,X,re){for(const pe=se.length;X<re;X++){const we=te[X];if(ae(we,se[pe-1])<0){se.pop();const Fe=(0,h.$jb)(se,Be=>ae(we,Be)<0);se.splice(Fe,0,we)}}}function s(te){return te.filter(ae=>!!ae)}function t(te){let ae=0;for(let se=0;se<te.length;se++)te[se]&&(te[ae]=te[se],ae+=1);te.length=ae}function o(te,ae,se){te.splice(se,0,te.splice(ae,1)[0])}function n(te){return!Array.isArray(te)||te.length===0}function d(te){return Array.isArray(te)&&te.length>0}function l(te,ae=se=>se){const se=new Set;return te.filter(X=>{const re=ae(X);return se.has(re)?!1:(se.add(re),!0)})}function g(te){const ae=new Set;return se=>{const X=te(se);return ae.has(X)?!1:(ae.add(X),!0)}}function E(te,ae){return te.length>0?te[0]:ae}function D(te,ae){return te.length>0?te[te.length-1]:ae}function y(te,ae,se=(X,re)=>X===re){let X=0;for(let re=0,pe=Math.min(te.length,ae.length);re<pe&&se(te[re],ae[re]);re++)X++;return X}function k(te,ae){let se=typeof ae=="number"?te:0;typeof ae=="number"?se=te:(se=0,ae=te);const X=[];if(se<=ae)for(let re=se;re<ae;re++)X.push(re);else for(let re=se;re>ae;re--)X.push(re);return X}function A(te,ae,se){return te.reduce((X,re)=>(X[ae(re)]=se?se(re):re,X),Object.create(null))}function b(te,ae){return te.push(ae),()=>v(te,ae)}function v(te,ae){const se=te.indexOf(ae);if(se>-1)return te.splice(se,1),ae}function F(te,ae,se){const X=te.slice(0,ae),re=te.slice(ae);return X.concat(se,re)}function N(te,ae){let se;if(typeof ae=="number"){let X=ae;se=()=>{const re=Math.sin(X++)*179426549;return re-Math.floor(re)}}else se=Math.random;for(let X=te.length-1;X>0;X-=1){const re=Math.floor(se()*(X+1)),pe=te[X];te[X]=te[re],te[re]=pe}}function L(te,ae){const se=te.indexOf(ae);se>-1&&(te.splice(se,1),te.unshift(ae))}function M(te,ae){const se=te.indexOf(ae);se>-1&&(te.splice(se,1),te.push(ae))}function z(te,ae){for(const se of ae)te.push(se)}function j(te,ae){return Array.isArray(te)?te.map(ae):ae(te)}function W(te){return Array.isArray(te)?te:[te]}function B(te){return te[Math.floor(Math.random()*te.length)]}function ee(te,ae,se){const X=q(te,ae),re=te.length,pe=se.length;te.length=re+pe;for(let we=re-1;we>=X;we--)te[we+pe]=te[we];for(let we=0;we<pe;we++)te[we+X]=se[we]}function H(te,ae,se,X){const re=q(te,ae);let pe=te.splice(re,se);return pe===void 0&&(pe=[]),ee(te,re,X),pe}function q(te,ae){return ae<0?Math.max(ae+te.length,0):Math.min(ae,te.length)}var Q;(function(te){function ae(pe){return pe<0}te.isLessThan=ae;function se(pe){return pe<=0}te.isLessThanOrEqual=se;function X(pe){return pe>0}te.isGreaterThan=X;function re(pe){return pe===0}te.isNeitherLessOrGreaterThan=re,te.greaterThan=1,te.lessThan=-1,te.neitherLessOrGreaterThan=0})(Q||(e.CompareResult=Q={}));function _(te,ae){return(se,X)=>ae(te(se),te(X))}function ce(...te){return(ae,se)=>{for(const X of te){const re=X(ae,se);if(!Q.isNeitherLessOrGreaterThan(re))return re}return Q.neitherLessOrGreaterThan}}const ne=(te,ae)=>te-ae;e.$7b=ne;const ye=(te,ae)=>(0,e.$7b)(te?1:0,ae?1:0);e.$8b=ye;function ge(te){return(ae,se)=>-te(ae,se)}class Y{constructor(ae){this.g=ae,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ae){let se=this.c;for(;se<this.g.length&&ae(this.g[se]);)se++;const X=se===this.c?null:this.g.slice(this.c,se);return this.c=se,X}takeFromEndWhile(ae){let se=this.d;for(;se>=0&&ae(this.g[se]);)se--;const X=se===this.d?null:this.g.slice(se+1,this.d+1);return this.d=se,X}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ae=this.g[this.c];return this.c++,ae}removeLast(){const ae=this.g[this.d];return this.d--,ae}takeCount(ae){const se=this.g.slice(this.c,this.c+ae);return this.c+=ae,se}}e.$0b=Y;class U{static{this.empty=new U(ae=>{})}constructor(ae){this.iterate=ae}forEach(ae){this.iterate(se=>(ae(se),!0))}toArray(){const ae=[];return this.iterate(se=>(ae.push(se),!0)),ae}filter(ae){return new U(se=>this.iterate(X=>ae(X)?se(X):!0))}map(ae){return new U(se=>this.iterate(X=>se(ae(X))))}some(ae){let se=!1;return this.iterate(X=>(se=ae(X),!se)),se}findFirst(ae){let se;return this.iterate(X=>ae(X)?(se=X,!1):!0),se}findLast(ae){let se;return this.iterate(X=>(ae(X)&&(se=X),!0)),se}findLastMaxBy(ae){let se,X=!0;return this.iterate(re=>((X||Q.isGreaterThan(ae(re,se)))&&(X=!1,se=re),!0)),se}}e.$$b=U;class oe{constructor(ae){this.c=ae}static createSortPermutation(ae,se){const X=Array.from(ae.keys()).sort((re,pe)=>se(ae[re],ae[pe]));return new oe(X)}apply(ae){return ae.map((se,X)=>ae[this.c[X]])}inverse(){const ae=this.c.slice();for(let se=0;se<this.c.length;se++)ae[this.c[se]]=se;return new oe(ae)}}e.$_b=oe;async function ve(te,ae){return(await Promise.all(te.map(async(X,re)=>({element:X,ok:await ae(X,re)})))).find(X=>X.ok)?.element}}),define(ke[65],Ie([1,0,13]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=h,e.$ed=C,e.$fd=R,e.$gd=O,e.$hd=T,e.$id=p;function h(c,I){if(!c)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function C(c,I="Unreachable"){throw new Error(I)}function R(c,I="unexpected state"){if(!c)throw new r.$bb(`Assertion Failed: ${I}`)}function O(c){c||(0,r.$Y)(new r.$bb("Soft Assertion Failed"))}function T(c){if(!c()){debugger;c(),(0,r.$Y)(new r.$bb("Assertion Failed"))}}function p(c,I){let S=0;for(;S<c.length-1;){const u=c[S],P=c[S+1];if(!I(u,P))return!1;S++}return!0}});var Kn=this&&this.__createBinding||(Object.create?function($e,e,r,h){h===void 0&&(h=r);var C=Object.getOwnPropertyDescriptor(e,r);(!C||("get"in C?!e.__esModule:C.writable||C.configurable))&&(C={enumerable:!0,get:function(){return e[r]}}),Object.defineProperty($e,h,C)}:function($e,e,r,h){h===void 0&&(h=r),$e[h]=e[r]}),Zn=this&&this.__setModuleDefault||(Object.create?function($e,e){Object.defineProperty($e,"default",{enumerable:!0,value:e})}:function($e,e){$e.default=e}),qe=this&&this.__importStar||function($e){if($e&&$e.__esModule)return $e;var e={};if($e!=null)for(var r in $e)r!=="default"&&Object.prototype.hasOwnProperty.call($e,r)&&Kn(e,$e,r);return Zn(e,$e),e};define(ke[175],Ie([1,0,18]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=C,e.$8c=R,e.$9c=O,e.$0c=T,e.$$c=p,e.$_c=c,r=qe(r);const h=(P,w)=>P===w;e.$6c=h;function C(P=e.$6c){return(w,a)=>r.$tb(w,a,P)}function R(){return(P,w)=>JSON.stringify(P)===JSON.stringify(w)}function O(){return(P,w)=>P.equals(w)}function T(P,w,a){if(a!==void 0){const m=P;return m==null||w===void 0||w===null?w===m:a(m,w)}else{const m=P;return($,f)=>$==null||f===void 0||f===null?f===$:m($,f)}}function p(P,w){if(P===w)return!0;if(Array.isArray(P)&&Array.isArray(w)){if(P.length!==w.length)return!1;for(let a=0;a<P.length;a++)if(!p(P[a],w[a]))return!1;return!0}if(P&&typeof P=="object"&&w&&typeof w=="object"&&Object.getPrototypeOf(P)===Object.prototype&&Object.getPrototypeOf(w)===Object.prototype){const a=P,m=w,$=Object.keys(a),f=Object.keys(m),i=new Set(f);if($.length!==f.length)return!1;for(const s of $)if(!i.has(s)||!p(a[s],m[s]))return!1;return!0}return!1}function c(P){return JSON.stringify(u(P))}let I=0;const S=new WeakMap;function u(P){if(Array.isArray(P))return P.map(u);if(P&&typeof P=="object")if(Object.getPrototypeOf(P)===Object.prototype){const w=P,a=Object.create(null);for(const m of Object.keys(w).sort())a[m]=u(w[m]);return a}else{let w=S.get(P);return w===void 0&&(w=I++,S.set(P,w)),w+"----2b76a038c20c4bcc"}return P}}),define(ke[79],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=r;function r(h,C){const R=this;let O=!1,T;return function(){if(O)return T;if(O=!0,C)try{T=h.apply(R,arguments)}finally{C()}else T=h.apply(R,arguments);return T}}}),define(ke[132],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qQ=e.$pQ=void 0;class r{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$pQ=r,e.$qQ=new r("id#")}),define(ke[39],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var r;(function(h){function C(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}h.is=C;const R=Object.freeze([]);function O(){return R}h.empty=O;function*T(n){yield n}h.single=T;function p(n){return C(n)?n:T(n)}h.wrap=p;function c(n){return n||R}h.from=c;function*I(n){for(let d=n.length-1;d>=0;d--)yield n[d]}h.reverse=I;function S(n){return!n||n[Symbol.iterator]().next().done===!0}h.isEmpty=S;function u(n){return n[Symbol.iterator]().next().value}h.first=u;function P(n,d){let l=0;for(const g of n)if(d(g,l++))return!0;return!1}h.some=P;function w(n,d){for(const l of n)if(d(l))return l}h.find=w;function*a(n,d){for(const l of n)d(l)&&(yield l)}h.filter=a;function*m(n,d){let l=0;for(const g of n)yield d(g,l++)}h.map=m;function*$(n,d){let l=0;for(const g of n)yield*d(g,l++)}h.flatMap=$;function*f(...n){for(const d of n)yield*d}h.concat=f;function i(n,d,l){let g=l;for(const E of n)g=d(g,E);return g}h.reduce=i;function*s(n,d,l=n.length){for(d<0&&(d+=n.length),l<0?l+=n.length:l>n.length&&(l=n.length);d<l;d++)yield n[d]}h.slice=s;function t(n,d=Number.POSITIVE_INFINITY){const l=[];if(d===0)return[l,n];const g=n[Symbol.iterator]();for(let E=0;E<d;E++){const D=g.next();if(D.done)return[l,h.empty()];l.push(D.value)}return[l,{[Symbol.iterator](){return g}}]}h.consume=t;async function o(n){const d=[];for await(const l of n)d.push(l);return Promise.resolve(d)}h.asyncToArray=o})(r||(e.Iterable=r={}))}),define(ke[176],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Wn=O,e.$Xn=S,e.$Yn=u,e.$Zn=P,e.$1n=w,e.$2n=a,e.$3n=m,e.$4n=$,e.$5n=f,e.$6n=i,e.$7n=s;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r||(e.ScanError=r={}));var h;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(h||(e.SyntaxKind=h={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function O(t,o=!1){let n=0;const d=t.length;let l="",g=0,E=h.Unknown,D=r.None;function y(L){let M=0,z=0;for(;M<L;){const j=t.charCodeAt(n);if(j>=I._0&&j<=I._9)z=z*16+j-I._0;else if(j>=I.A&&j<=I.F)z=z*16+j-I.A+10;else if(j>=I.a&&j<=I.f)z=z*16+j-I.a+10;else break;n++,M++}return M<L&&(z=-1),z}function k(L){n=L,l="",g=0,E=h.Unknown,D=r.None}function A(){const L=n;if(t.charCodeAt(n)===I._0)n++;else for(n++;n<t.length&&c(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===I.dot)if(n++,n<t.length&&c(t.charCodeAt(n)))for(n++;n<t.length&&c(t.charCodeAt(n));)n++;else return D=r.UnexpectedEndOfNumber,t.substring(L,n);let M=n;if(n<t.length&&(t.charCodeAt(n)===I.E||t.charCodeAt(n)===I.e))if(n++,(n<t.length&&t.charCodeAt(n)===I.plus||t.charCodeAt(n)===I.minus)&&n++,n<t.length&&c(t.charCodeAt(n))){for(n++;n<t.length&&c(t.charCodeAt(n));)n++;M=n}else D=r.UnexpectedEndOfNumber;return t.substring(L,M)}function b(){let L="",M=n;for(;;){if(n>=d){L+=t.substring(M,n),D=r.UnexpectedEndOfString;break}const z=t.charCodeAt(n);if(z===I.doubleQuote){L+=t.substring(M,n),n++;break}if(z===I.backslash){if(L+=t.substring(M,n),n++,n>=d){D=r.UnexpectedEndOfString;break}switch(t.charCodeAt(n++)){case I.doubleQuote:L+='"';break;case I.backslash:L+="\\";break;case I.slash:L+="/";break;case I.b:L+="\b";break;case I.f:L+="\f";break;case I.n:L+=`
`;break;case I.r:L+="\r";break;case I.t:L+="	";break;case I.u:{const W=y(4);W>=0?L+=String.fromCharCode(W):D=r.InvalidUnicode;break}default:D=r.InvalidEscapeCharacter}M=n;continue}if(z>=0&&z<=31)if(p(z)){L+=t.substring(M,n),D=r.UnexpectedEndOfString;break}else D=r.InvalidCharacter;n++}return L}function v(){if(l="",D=r.None,g=n,n>=d)return g=d,E=h.EOF;let L=t.charCodeAt(n);if(T(L)){do n++,l+=String.fromCharCode(L),L=t.charCodeAt(n);while(T(L));return E=h.Trivia}if(p(L))return n++,l+=String.fromCharCode(L),L===I.carriageReturn&&t.charCodeAt(n)===I.lineFeed&&(n++,l+=`
`),E=h.LineBreakTrivia;switch(L){case I.openBrace:return n++,E=h.OpenBraceToken;case I.closeBrace:return n++,E=h.CloseBraceToken;case I.openBracket:return n++,E=h.OpenBracketToken;case I.closeBracket:return n++,E=h.CloseBracketToken;case I.colon:return n++,E=h.ColonToken;case I.comma:return n++,E=h.CommaToken;case I.doubleQuote:return n++,l=b(),E=h.StringLiteral;case I.slash:{const M=n-1;if(t.charCodeAt(n+1)===I.slash){for(n+=2;n<d&&!p(t.charCodeAt(n));)n++;return l=t.substring(M,n),E=h.LineCommentTrivia}if(t.charCodeAt(n+1)===I.asterisk){n+=2;const z=d-1;let j=!1;for(;n<z;){if(t.charCodeAt(n)===I.asterisk&&t.charCodeAt(n+1)===I.slash){n+=2,j=!0;break}n++}return j||(n++,D=r.UnexpectedEndOfComment),l=t.substring(M,n),E=h.BlockCommentTrivia}return l+=String.fromCharCode(L),n++,E=h.Unknown}case I.minus:if(l+=String.fromCharCode(L),n++,n===d||!c(t.charCodeAt(n)))return E=h.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return l+=A(),E=h.NumericLiteral;default:for(;n<d&&F(L);)n++,L=t.charCodeAt(n);if(g!==n){switch(l=t.substring(g,n),l){case"true":return E=h.TrueKeyword;case"false":return E=h.FalseKeyword;case"null":return E=h.NullKeyword}return E=h.Unknown}return l+=String.fromCharCode(L),n++,E=h.Unknown}}function F(L){if(T(L)||p(L))return!1;switch(L){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function N(){let L;do L=v();while(L>=h.LineCommentTrivia&&L<=h.Trivia);return L}return{setPosition:k,getPosition:()=>n,scan:o?N:v,getToken:()=>E,getTokenValue:()=>l,getTokenOffset:()=>g,getTokenLength:()=>n-g,getTokenError:()=>D}}function T(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function p(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function c(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function S(t,o){const n=[],d=new Object;let l;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function D(y,k,A,b){g.value=y,g.offset=k,g.length=A,g.type=b,g.colonOffset=void 0,l=g}try{i(t,{onObjectBegin:(y,k)=>{if(o<=y)throw d;l=void 0,E=o>y,n.push("")},onObjectProperty:(y,k,A)=>{if(o<k||(D(y,k,A,"property"),n[n.length-1]=y,o<=k+A))throw d},onObjectEnd:(y,k)=>{if(o<=y)throw d;l=void 0,n.pop()},onArrayBegin:(y,k)=>{if(o<=y)throw d;l=void 0,n.push(0)},onArrayEnd:(y,k)=>{if(o<=y)throw d;l=void 0,n.pop()},onLiteralValue:(y,k,A)=>{if(o<k||(D(y,k,A,s(y)),o<=k+A))throw d},onSeparator:(y,k,A)=>{if(o<=k)throw d;if(y===":"&&l&&l.type==="property")l.colonOffset=k,E=!1,l=void 0;else if(y===","){const b=n[n.length-1];typeof b=="number"?n[n.length-1]=b+1:(E=!0,n[n.length-1]=""),l=void 0}}})}catch(y){if(y!==d)throw y}return{path:n,previousNode:l,isAtPropertyKey:E,matches:y=>{let k=0;for(let A=0;k<y.length&&A<n.length;A++)if(y[k]===n[A]||y[k]==="*")k++;else if(y[k]!=="**")return!1;return k===y.length}}}function u(t,o=[],n=R.DEFAULT){let d=null,l=[];const g=[];function E(y){Array.isArray(l)?l.push(y):d!==null&&(l[d]=y)}return i(t,{onObjectBegin:()=>{const y={};E(y),g.push(l),l=y,d=null},onObjectProperty:y=>{d=y},onObjectEnd:()=>{l=g.pop()},onArrayBegin:()=>{const y=[];E(y),g.push(l),l=y,d=null},onArrayEnd:()=>{l=g.pop()},onLiteralValue:E,onError:(y,k,A)=>{o.push({error:y,offset:k,length:A})}},n),l[0]}function P(t,o=[],n=R.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(y){d.type==="property"&&(d.length=y-d.offset,d=d.parent)}function g(y){return d.children.push(y),y}i(t,{onObjectBegin:y=>{d=g({type:"object",offset:y,length:-1,parent:d,children:[]})},onObjectProperty:(y,k,A)=>{d=g({type:"property",offset:k,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:y,offset:k,length:A,parent:d})},onObjectEnd:(y,k)=>{d.length=y+k-d.offset,d=d.parent,l(y+k)},onArrayBegin:(y,k)=>{d=g({type:"array",offset:y,length:-1,parent:d,children:[]})},onArrayEnd:(y,k)=>{d.length=y+k-d.offset,d=d.parent,l(y+k)},onLiteralValue:(y,k,A)=>{g({type:s(y),offset:k,length:A,parent:d,value:y}),l(k+A)},onSeparator:(y,k,A)=>{d.type==="property"&&(y===":"?d.colonOffset=k:y===","&&l(k))},onError:(y,k,A)=>{o.push({error:y,offset:k,length:A})}},n);const D=d.children[0];return D&&delete D.parent,D}function w(t,o){if(!t)return;let n=t;for(const d of o)if(typeof d=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const g of n.children)if(Array.isArray(g.children)&&g.children[0].value===d){n=g.children[1],l=!0;break}if(!l)return}else{const l=d;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}function a(t){if(!t.parent||!t.parent.children)return[];const o=a(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;o.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&o.push(n)}return o}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const o=Object.create(null);for(const n of t.children){const d=n.children[1];d&&(o[n.children[0].value]=m(d))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function $(t,o,n=!1){return o>=t.offset&&o<t.offset+t.length||n&&o===t.offset+t.length}function f(t,o,n=!1){if($(t,o,n)){const d=t.children;if(Array.isArray(d))for(let l=0;l<d.length&&d[l].offset<=o;l++){const g=f(d[l],o,n);if(g)return g}return t}}function i(t,o,n=R.DEFAULT){const d=O(t,!1);function l(_){return _?()=>_(d.getTokenOffset(),d.getTokenLength()):()=>!0}function g(_){return _?ce=>_(ce,d.getTokenOffset(),d.getTokenLength()):()=>!0}const E=l(o.onObjectBegin),D=g(o.onObjectProperty),y=l(o.onObjectEnd),k=l(o.onArrayBegin),A=l(o.onArrayEnd),b=g(o.onLiteralValue),v=g(o.onSeparator),F=l(o.onComment),N=g(o.onError),L=n&&n.disallowComments,M=n&&n.allowTrailingComma;function z(){for(;;){const _=d.scan();switch(d.getTokenError()){case r.InvalidUnicode:j(C.InvalidUnicode);break;case r.InvalidEscapeCharacter:j(C.InvalidEscapeCharacter);break;case r.UnexpectedEndOfNumber:j(C.UnexpectedEndOfNumber);break;case r.UnexpectedEndOfComment:L||j(C.UnexpectedEndOfComment);break;case r.UnexpectedEndOfString:j(C.UnexpectedEndOfString);break;case r.InvalidCharacter:j(C.InvalidCharacter);break}switch(_){case h.LineCommentTrivia:case h.BlockCommentTrivia:L?j(C.InvalidCommentToken):F();break;case h.Unknown:j(C.InvalidSymbol);break;case h.Trivia:case h.LineBreakTrivia:break;default:return _}}}function j(_,ce=[],ne=[]){if(N(_),ce.length+ne.length>0){let ye=d.getToken();for(;ye!==h.EOF;){if(ce.indexOf(ye)!==-1){z();break}else if(ne.indexOf(ye)!==-1)break;ye=z()}}}function W(_){const ce=d.getTokenValue();return _?b(ce):D(ce),z(),!0}function B(){switch(d.getToken()){case h.NumericLiteral:{let _=0;try{_=JSON.parse(d.getTokenValue()),typeof _!="number"&&(j(C.InvalidNumberFormat),_=0)}catch{j(C.InvalidNumberFormat)}b(_);break}case h.NullKeyword:b(null);break;case h.TrueKeyword:b(!0);break;case h.FalseKeyword:b(!1);break;default:return!1}return z(),!0}function ee(){return d.getToken()!==h.StringLiteral?(j(C.PropertyNameExpected,[],[h.CloseBraceToken,h.CommaToken]),!1):(W(!1),d.getToken()===h.ColonToken?(v(":"),z(),Q()||j(C.ValueExpected,[],[h.CloseBraceToken,h.CommaToken])):j(C.ColonExpected,[],[h.CloseBraceToken,h.CommaToken]),!0)}function H(){E(),z();let _=!1;for(;d.getToken()!==h.CloseBraceToken&&d.getToken()!==h.EOF;){if(d.getToken()===h.CommaToken){if(_||j(C.ValueExpected,[],[]),v(","),z(),d.getToken()===h.CloseBraceToken&&M)break}else _&&j(C.CommaExpected,[],[]);ee()||j(C.ValueExpected,[],[h.CloseBraceToken,h.CommaToken]),_=!0}return y(),d.getToken()!==h.CloseBraceToken?j(C.CloseBraceExpected,[h.CloseBraceToken],[]):z(),!0}function q(){k(),z();let _=!1;for(;d.getToken()!==h.CloseBracketToken&&d.getToken()!==h.EOF;){if(d.getToken()===h.CommaToken){if(_||j(C.ValueExpected,[],[]),v(","),z(),d.getToken()===h.CloseBracketToken&&M)break}else _&&j(C.CommaExpected,[],[]);Q()||j(C.ValueExpected,[],[h.CloseBracketToken,h.CommaToken]),_=!0}return A(),d.getToken()!==h.CloseBracketToken?j(C.CloseBracketExpected,[h.CloseBracketToken],[]):z(),!0}function Q(){switch(d.getToken()){case h.OpenBracketToken:return q();case h.OpenBraceToken:return H();case h.StringLiteral:return W(!0);default:return B()}}return z(),d.getToken()===h.EOF?n.allowEmptyContent?!0:(j(C.ValueExpected,[],[]),!1):Q()?(d.getToken()!==h.EOF&&j(C.EndOfFileExpected,[],[]),!0):(j(C.ValueExpected,[],[]),!1)}function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[177],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=r;function r(R){let O=!1;const T=new Map,p=new Map;if(C(R,a=>{if(R===a)return!0;const m=JSON.stringify(a);if(m.length<30)return!0;const $=T.get(m);if(!$){const f={schemas:[a]};return T.set(m,f),p.set(a,f),!0}return $.schemas.push(a),p.set(a,$),O=!0,!1}),T.clear(),!O)return JSON.stringify(R);let I="$defs";for(;R.hasOwnProperty(I);)I+="_";const S=[];function u(a){return JSON.stringify(a,(m,$)=>{if($!==a){const f=p.get($);if(f&&f.schemas.length>1)return f.id||(f.id=`_${S.length}`,S.push(f.schemas[0])),{$ref:`#/${I}/${f.id}`}}return $})}const P=u(R),w=[];for(let a=0;a<S.length;a++)w.push(`"_${a}":${u(S[a])}`);return w.length?`${P.substring(0,P.length-1)},"${I}":{${w.join(",")}}}`:P}function h(R){return typeof R=="object"&&R!==null}function C(R,O){if(!R||typeof R!="object")return;const T=(...P)=>{for(const w of P)h(w)&&S.push(w)},p=(...P)=>{for(const w of P)if(h(w))for(const a in w){const m=w[a];h(m)&&S.push(m)}},c=(...P)=>{for(const w of P)if(Array.isArray(w))for(const a of w)h(a)&&S.push(a)},I=P=>{if(Array.isArray(P))for(const w of P)h(w)&&S.push(w);else h(P)&&S.push(P)},S=[R];let u=S.pop();for(;u;)O(u)&&(T(u.additionalItems,u.additionalProperties,u.not,u.contains,u.propertyNames,u.if,u.then,u.else,u.unevaluatedItems,u.unevaluatedProperties),p(u.definitions,u.$defs,u.properties,u.patternProperties,u.dependencies,u.dependentSchemas),c(u.anyOf,u.allOf,u.oneOf,u.prefixItems),I(u.items)),u=S.pop()}}),define(ke[50],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class r{constructor(C){this.d=C,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(C){this.c=C}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=r}),define(ke[80],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class r{static{this.Undefined=new r(void 0)}constructor(R){this.element=R,this.next=r.Undefined,this.prev=r.Undefined}}class h{constructor(){this.a=r.Undefined,this.b=r.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===r.Undefined}clear(){let R=this.a;for(;R!==r.Undefined;){const O=R.next;R.prev=r.Undefined,R.next=r.Undefined,R=O}this.a=r.Undefined,this.b=r.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,O){const T=new r(R);if(this.a===r.Undefined)this.a=T,this.b=T;else if(O){const c=this.b;this.b=T,T.prev=c,c.next=T}else{const c=this.a;this.a=T,T.next=c,c.prev=T}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(T))}}shift(){if(this.a!==r.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==r.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==r.Undefined&&R.next!==r.Undefined){const O=R.prev;O.next=R.next,R.next.prev=O}else R.prev===r.Undefined&&R.next===r.Undefined?(this.a=r.Undefined,this.b=r.Undefined):R.next===r.Undefined?(this.b=this.b.prev,this.b.next=r.Undefined):R.prev===r.Undefined&&(this.a=this.a.next,this.a.prev=r.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==r.Undefined;)yield R.element,R=R.next}}e.$5c=h}),define(ke[28],Ie([1,0]),function($e,e){"use strict";var r,h,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=R,e.$yc=O,e.$zc=T,e.$Ic=s;function R(t,o,n){let d=t.get(o);return d===void 0&&(d=n,t.set(o,d)),d}function O(t){const o=[];return t.forEach((n,d)=>{o.push(`${d} => ${n}`)}),`Map(${t.size}) {${o.join(", ")}}`}function T(t){const o=[];return t.forEach(n=>{o.push(n)}),`Set(${t.size}) {${o.join(", ")}}`}class p{constructor(o,n){this.uri=o,this.value=n}}function c(t){return Array.isArray(t)}class I{static{this.c=o=>o.toString()}constructor(o,n){if(this[r]="ResourceMap",o instanceof I)this.d=new Map(o.d),this.e=n??I.c;else if(c(o)){this.d=new Map,this.e=n??I.c;for(const[d,l]of o)this.set(d,l)}else this.d=new Map,this.e=o??I.c}set(o,n){return this.d.set(this.e(o),new p(o,n)),this}get(o){return this.d.get(this.e(o))?.value}has(o){return this.d.has(this.e(o))}get size(){return this.d.size}clear(){this.d.clear()}delete(o){return this.d.delete(this.e(o))}forEach(o,n){typeof n<"u"&&(o=o.bind(n));for(const[d,l]of this.d)o(l.value,l.uri,this)}*values(){for(const o of this.d.values())yield o.value}*keys(){for(const o of this.d.values())yield o.uri}*entries(){for(const o of this.d.values())yield[o.uri,o.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.d)yield[o.uri,o.value]}}e.$Ac=I;class S{constructor(o,n){this[h]="ResourceSet",!o||typeof o=="function"?this.c=new I(o):(this.c=new I(n),o.forEach(this.add,this))}get size(){return this.c.size}add(o){return this.c.set(o,o),this}clear(){this.c.clear()}delete(o){return this.c.delete(o)}forEach(o,n){this.c.forEach((d,l)=>o.call(n,l,l,this))}has(o){return this.c.has(o)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=S;var u;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(u||(e.Touch=u={}));class P{constructor(){this[C]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(o){return this.c.has(o)}get(o,n=u.None){const d=this.c.get(o);if(d)return n!==u.None&&this.m(d,n),d.value}set(o,n,d=u.None){let l=this.c.get(o);if(l)l.value=n,d!==u.None&&this.m(l,d);else{switch(l={key:o,value:n,next:void 0,previous:void 0},d){case u.None:this.k(l);break;case u.AsOld:this.j(l);break;case u.AsNew:this.k(l);break;default:this.k(l);break}this.c.set(o,l),this.f++}return this}delete(o){return!!this.remove(o)}remove(o){const n=this.c.get(o);if(n)return this.c.delete(o),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const o=this.d;return this.c.delete(o.key),this.l(o),this.f--,o.value}forEach(o,n){const d=this.g;let l=this.d;for(;l;){if(n?o.bind(n)(l.value,l.key,this):o(l.value,l.key,this),this.g!==d)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const o=this,n=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(o.g!==n)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:d.key,done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return l}values(){const o=this,n=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(o.g!==n)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:d.value,done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return l}entries(){const o=this,n=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(o.g!==n)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:[d.key,d.value],done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return l}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(o){if(o>=this.size)return;if(o===0){this.clear();return}let n=this.d,d=this.size;for(;n&&d>o;)this.c.delete(n.key),n=n.next,d--;this.d=n,this.f=d,n&&(n.previous=void 0),this.g++}i(o){if(o>=this.size)return;if(o===0){this.clear();return}let n=this.e,d=this.size;for(;n&&d>o;)this.c.delete(n.key),n=n.previous,d--;this.e=n,this.f=d,n&&(n.next=void 0),this.g++}j(o){if(!this.d&&!this.e)this.e=o;else if(this.d)o.next=this.d,this.d.previous=o;else throw new Error("Invalid list");this.d=o,this.g++}k(o){if(!this.d&&!this.e)this.d=o;else if(this.e)o.previous=this.e,this.e.next=o;else throw new Error("Invalid list");this.e=o,this.g++}l(o){if(o===this.d&&o===this.e)this.d=void 0,this.e=void 0;else if(o===this.d){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.d=o.next}else if(o===this.e){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.e=o.previous}else{const n=o.next,d=o.previous;if(!n||!d)throw new Error("Invalid list");n.previous=d,d.next=n}o.next=void 0,o.previous=void 0,this.g++}m(o,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==u.AsOld&&n!==u.AsNew)){if(n===u.AsOld){if(o===this.d)return;const d=o.next,l=o.previous;o===this.e?(l.next=void 0,this.e=l):(d.previous=l,l.next=d),o.previous=void 0,o.next=this.d,this.d.previous=o,this.d=o,this.g++}else if(n===u.AsNew){if(o===this.e)return;const d=o.next,l=o.previous;o===this.d?(d.previous=void 0,this.d=d):(d.previous=l,l.next=d),o.next=void 0,o.previous=this.e,this.e.next=o,this.e=o,this.g++}}}toJSON(){const o=[];return this.forEach((n,d)=>{o.push([d,n])}),o}fromJSON(o){this.clear();for(const[n,d]of o)this.set(n,d)}}e.$Cc=P;class w extends P{constructor(o,n=1){super(),this.n=o,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(o){this.n=o,this.p()}get ratio(){return this.o}set ratio(o){this.o=Math.min(Math.max(0,o),1),this.p()}get(o,n=u.AsNew){return super.get(o,n)}peek(o){return super.get(o,u.None)}set(o,n){return super.set(o,n,u.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class a extends w{constructor(o,n=1){super(o,n)}q(o){this.h(o)}set(o,n){return super.set(o,n),this.p(),this}}e.$Dc=a;class m extends w{constructor(o,n=1){super(o,n)}q(o){this.i(o)}set(o,n){return this.n<=this.size&&!this.has(o)&&this.q(Math.round(this.n*this.o)-1),super.set(o,n),this}}e.$Ec=m;class ${constructor(){this.c=new Map}add(o){return this.c.set(o,(this.c.get(o)||0)+1),this}delete(o){let n=this.c.get(o)||0;return n===0?!1:(n--,n===0?this.c.delete(o):this.c.set(o,n),!0)}has(o){return this.c.has(o)}}e.$Fc=$;class f{constructor(o){if(this.c=new Map,this.d=new Map,o)for(const[n,d]of o)this.set(n,d)}clear(){this.c.clear(),this.d.clear()}set(o,n){this.c.set(o,n),this.d.set(n,o)}get(o){return this.c.get(o)}getKey(o){return this.d.get(o)}delete(o){const n=this.c.get(o);return n===void 0?!1:(this.c.delete(o),this.d.delete(n),!0)}forEach(o,n){this.c.forEach((d,l)=>{o.call(n,d,l,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=f;class i{constructor(){this.c=new Map}add(o,n){let d=this.c.get(o);d||(d=new Set,this.c.set(o,d)),d.add(n)}delete(o,n){const d=this.c.get(o);d&&(d.delete(n),d.size===0&&this.c.delete(o))}forEach(o,n){const d=this.c.get(o);d&&d.forEach(n)}get(o){const n=this.c.get(o);return n||new Set}}e.$Hc=i;function s(t,o){if(t===o)return!0;if(t.size!==o.size)return!1;for(const[n,d]of t)if(!o.has(n)||o.get(n)!==d)return!1;for(const[n]of o)if(!t.has(n))return!1;return!0}}),define(ke[3],Ie([1,0,18,78,28,79,39]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=I,e.$Lc=S,e.$Mc=u,e.$Nc=a,e.$Oc=m,e.$Pc=$,e.$Qc=f,e.$Rc=i,e.$Sc=s,e.$3c=k;const T=!1;let p=null;class c{constructor(){this.b=new Map}static{this.a=0}c(v){let F=this.b.get(v);return F||(F={parent:null,source:null,isSingleton:!1,value:v,idx:c.a++},this.b.set(v,F)),F}trackDisposable(v){const F=this.c(v);F.source||(F.source=new Error().stack)}setParent(v,F){const N=this.c(v);N.parent=F}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,F){const N=F.get(v);if(N)return N;const L=v.parent?this.f(this.c(v.parent),F):v;return F.set(v,L),L}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,v).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(v=10,F){let N;if(F)N=F;else{const W=new Map,B=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,W).isSingleton);if(B.length===0)return;const ee=new Set(B.map(H=>H.value));if(N=B.filter(H=>!(H.parent&&ee.has(H.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function L(W){function B(H,q){for(;H.length>0&&q.some(Q=>typeof Q=="string"?Q===H[0]:H[0].match(Q));)H.shift()}const ee=W.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return B(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const M=new C.$Hc;for(const W of N){const B=L(W);for(let ee=0;ee<=B.length;ee++)M.add(B.slice(0,ee).join(`
`),W)}N.sort((0,r.$5b)(W=>W.idx,r.$7b));let z="",j=0;for(const W of N.slice(0,v)){j++;const B=L(W),ee=[];for(let H=0;H<B.length;H++){let q=B[H];q=`(shared with ${M.get(B.slice(0,H+1).join(`
`)).size}/${N.length} leaks) at ${q}`;const _=M.get(B.slice(0,H).join(`
`)),ce=(0,h.$c)([..._].map(ne=>L(ne)[H]),ne=>ne);delete ce[B[H]];for(const[ne,ye]of Object.entries(ce))ee.unshift(`    - stacktraces of ${ye.length} other leaks continue with ${ne}`);ee.unshift(q)}z+=`


==================== Leaking disposable ${j}/${N.length}: ${W.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return N.length>v&&(z+=`


... and ${N.length-v} more leaking disposables

`),{leaks:N,details:z}}}e.$Jc=c;function I(b){p=b}if(T){const b="__is_disposable_tracked__";I(new class{trackDisposable(v){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[b]||console.log(F)},3e3)}setParent(v,F){if(v&&v!==o.None)try{v[b]=!0}catch{}}markAsDisposed(v){if(v&&v!==o.None)try{v[b]=!0}catch{}}markAsSingleton(v){}})}function S(b){return p?.trackDisposable(b),b}function u(b){p?.markAsDisposed(b)}function P(b,v){p?.setParent(b,v)}function w(b,v){if(p)for(const F of b)p.setParent(F,v)}function a(b){return p?.markAsSingleton(b),b}function m(b){return typeof b=="object"&&b!==null&&typeof b.dispose=="function"&&b.dispose.length===0}function $(b){if(O.Iterable.is(b)){const v=[];for(const F of b)if(F)try{F.dispose()}catch(N){v.push(N)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}function f(b){for(const v of b)m(v)&&v.dispose();return[]}function i(...b){const v=s(()=>$(b));return w(b,v),v}function s(b){const v=S({dispose:(0,R.$cb)(()=>{u(v),b()})});return v}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,S(this)}dispose(){this.g||(u(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return P(v,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),P(v,null))}}e.$Tc=t;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,S(this),P(this.q,this)}dispose(){u(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Uc=o;class n{constructor(){this.b=!1,S(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&P(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,u(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&P(v,null),v}}e.$Vc=n;class d{constructor(v){this.a=new n,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=d;class l{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=l;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(v){let F=v;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,u(this))},this}}e.$Yc=g;class E{constructor(){this.a=new Map}acquire(v,...F){let N=this.a.get(v);N||(N={counter:0,object:this.b(v,...F)},this.a.set(v,N));const{object:L}=N,M=(0,R.$cb)(()=>{--N.counter===0&&(this.c(v,N.object),this.a.delete(v))});return N.counter++,{object:L,dispose:M}}}e.$Zc=E;class D{constructor(v){this.a=v}async acquire(v,...F){const N=this.a.acquire(v,...F);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(L){throw N.dispose(),L}}}e.$1c=D;class y{constructor(v){this.object=v}dispose(){}}e.$2c=y;function k(b){const v=new t;try{b(v)}finally{v.dispose()}}class A{constructor(){this.a=new Map,this.b=!1,S(this)}dispose(){u(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,F,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(v)?.dispose(),this.a.set(v,F)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const F=this.a.get(v);return this.a.delete(v),F}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=A}),function($e,e){typeof define=="function"&&define.amd?define(ke[178],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(te,ae){for(var se=0;se<ae.length;se++){var X=ae[se];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(te,X.key,X)}}function r(te,ae,se){return ae&&e(te.prototype,ae),se&&e(te,se),Object.defineProperty(te,"prototype",{writable:!1}),te}function h(te,ae){if(te){if(typeof te=="string")return C(te,ae);var se=Object.prototype.toString.call(te).slice(8,-1);if(se==="Object"&&te.constructor&&(se=te.constructor.name),se==="Map"||se==="Set")return Array.from(te);if(se==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(se))return C(te,ae)}}function C(te,ae){(ae==null||ae>te.length)&&(ae=te.length);for(var se=0,X=new Array(ae);se<ae;se++)X[se]=te[se];return X}function R(te,ae){var se=typeof Symbol<"u"&&te[Symbol.iterator]||te["@@iterator"];if(se)return(se=se.call(te)).next.bind(se);if(Array.isArray(te)||(se=h(te))||ae&&te&&typeof te.length=="number"){se&&(te=se);var X=0;return function(){return X>=te.length?{done:!0}:{done:!1,value:te[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function O(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=O();function T(te){$e.defaults=te}var p=/[&<>"']/,c=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},P=function(ae){return u[ae]};function w(te,ae){if(ae){if(p.test(te))return te.replace(c,P)}else if(I.test(te))return te.replace(S,P);return te}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(te){return te.replace(a,function(ae,se){return se=se.toLowerCase(),se==="colon"?":":se.charAt(0)==="#"?se.charAt(1)==="x"?String.fromCharCode(parseInt(se.substring(2),16)):String.fromCharCode(+se.substring(1)):""})}var $=/(^|[^\[])\^/g;function f(te,ae){te=typeof te=="string"?te:te.source,ae=ae||"";var se={replace:function(re,pe){return pe=pe.source||pe,pe=pe.replace($,"$1"),te=te.replace(re,pe),se},getRegex:function(){return new RegExp(te,ae)}};return se}var i=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(te,ae,se){if(te){var X;try{X=decodeURIComponent(m(se)).replace(i,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}ae&&!s.test(se)&&(se=g(ae,se));try{se=encodeURI(se).replace(/%25/g,"%")}catch{return null}return se}var o={},n=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function g(te,ae){o[" "+te]||(n.test(te)?o[" "+te]=te+"/":o[" "+te]=k(te,"/",!0)),te=o[" "+te];var se=te.indexOf(":")===-1;return ae.substring(0,2)==="//"?se?ae:te.replace(d,"$1")+ae:ae.charAt(0)==="/"?se?ae:te.replace(l,"$1")+ae:te+ae}var E={exec:function(){}};function D(te){for(var ae=1,se,X;ae<arguments.length;ae++){se=arguments[ae];for(X in se)Object.prototype.hasOwnProperty.call(se,X)&&(te[X]=se[X])}return te}function y(te,ae){var se=te.replace(/\|/g,function(pe,we,Fe){for(var Be=!1,Re=we;--Re>=0&&Fe[Re]==="\\";)Be=!Be;return Be?"|":" |"}),X=se.split(/ \|/),re=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>ae)X.splice(ae);else for(;X.length<ae;)X.push("");for(;re<X.length;re++)X[re]=X[re].trim().replace(/\\\|/g,"|");return X}function k(te,ae,se){var X=te.length;if(X===0)return"";for(var re=0;re<X;){var pe=te.charAt(X-re-1);if(pe===ae&&!se)re++;else if(pe!==ae&&se)re++;else break}return te.slice(0,X-re)}function A(te,ae){if(te.indexOf(ae[1])===-1)return-1;for(var se=te.length,X=0,re=0;re<se;re++)if(te[re]==="\\")re++;else if(te[re]===ae[0])X++;else if(te[re]===ae[1]&&(X--,X<0))return re;return-1}function b(te){te&&te.sanitize&&!te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function v(te,ae){if(ae<1)return"";for(var se="";ae>1;)ae&1&&(se+=te),ae>>=1,te+=te;return se+te}function F(te,ae,se,X){var re=ae.href,pe=ae.title?w(ae.title):null,we=te[1].replace(/\\([\[\]])/g,"$1");if(te[0].charAt(0)!=="!"){X.state.inLink=!0;var Fe={type:"link",raw:se,href:re,title:pe,text:we,tokens:X.inlineTokens(we)};return X.state.inLink=!1,Fe}return{type:"image",raw:se,href:re,title:pe,text:w(we)}}function N(te,ae){var se=te.match(/^(\s+)(?:```)/);if(se===null)return ae;var X=se[1];return ae.split(`
`).map(function(re){var pe=re.match(/^\s+/);if(pe===null)return re;var we=pe[0];return we.length>=X.length?re.slice(X.length):re}).join(`
`)}var L=function(){function te(se){this.options=se||$e.defaults}var ae=te.prototype;return ae.space=function(X){var re=this.rules.block.newline.exec(X);if(re&&re[0].length>0)return{type:"space",raw:re[0]}},ae.code=function(X){var re=this.rules.block.code.exec(X);if(re){var pe=re[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:re[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:k(pe,`
`)}}},ae.fences=function(X){var re=this.rules.block.fences.exec(X);if(re){var pe=re[0],we=N(pe,re[3]||"");return{type:"code",raw:pe,lang:re[2]?re[2].trim():re[2],text:we}}},ae.heading=function(X){var re=this.rules.block.heading.exec(X);if(re){var pe=re[2].trim();if(/#$/.test(pe)){var we=k(pe,"#");(this.options.pedantic||!we||/ $/.test(we))&&(pe=we.trim())}return{type:"heading",raw:re[0],depth:re[1].length,text:pe,tokens:this.lexer.inline(pe)}}},ae.hr=function(X){var re=this.rules.block.hr.exec(X);if(re)return{type:"hr",raw:re[0]}},ae.blockquote=function(X){var re=this.rules.block.blockquote.exec(X);if(re){var pe=re[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:re[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},ae.list=function(X){var re=this.rules.block.list.exec(X);if(re){var pe,we,Fe,Be,Re,De,Ce,V,G,J,x,de,Ee=re[1].trim(),Le=Ee.length>1,He={type:"list",raw:"",ordered:Le,start:Le?+Ee.slice(0,-1):"",loose:!1,items:[]};Ee=Le?"\\d{1,9}\\"+Ee.slice(-1):"\\"+Ee,this.options.pedantic&&(Ee=Le?Ee:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+Ee+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(de=!1,!(!(re=Ze.exec(X))||this.rules.block.hr.test(X)));){if(pe=re[0],X=X.substring(pe.length),V=re[2].split(`
`,1)[0],G=X.split(`
`,1)[0],this.options.pedantic?(Be=2,x=V.trimLeft()):(Be=re[2].search(/[^ ]/),Be=Be>4?1:Be,x=V.slice(Be),Be+=re[1].length),De=!1,!V&&/^ *$/.test(G)&&(pe+=G+`
`,X=X.substring(G.length+1),de=!0),!de)for(var et=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,Be-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),st=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,Be-1)+"}#");X&&(J=X.split(`
`,1)[0],V=J,this.options.pedantic&&(V=V.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(st.test(V)||rt.test(V)||et.test(V)||nt.test(X)));){if(V.search(/[^ ]/)>=Be||!V.trim())x+=`
`+V.slice(Be);else if(!De)x+=`
`+V;else break;!De&&!V.trim()&&(De=!0),pe+=J+`
`,X=X.substring(J.length+1)}He.loose||(Ce?He.loose=!0:/\n *\n *$/.test(pe)&&(Ce=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(x),we&&(Fe=we[0]!=="[ ] ",x=x.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:pe,task:!!we,checked:Fe,loose:!1,text:x}),He.raw+=pe}He.items[He.items.length-1].raw=pe.trimRight(),He.items[He.items.length-1].text=x.trimRight(),He.raw=He.raw.trimRight();var at=He.items.length;for(Re=0;Re<at;Re++){this.lexer.state.top=!1,He.items[Re].tokens=this.lexer.blockTokens(He.items[Re].text,[]);var gt=He.items[Re].tokens.filter(function(ct){return ct.type==="space"}),dt=gt.every(function(ct){for(var Pe=ct.raw.split(""),ze=0,Ke=R(Pe),Ne;!(Ne=Ke()).done;){var je=Ne.value;if(je===`
`&&(ze+=1),ze>1)return!0}return!1});!He.loose&&gt.length&&dt&&(He.loose=!0,He.items[Re].loose=!0)}return He}},ae.html=function(X){var re=this.rules.block.html.exec(X);if(re){var pe={type:"html",raw:re[0],pre:!this.options.sanitizer&&(re[1]==="pre"||re[1]==="script"||re[1]==="style"),text:re[0]};if(this.options.sanitize){var we=this.options.sanitizer?this.options.sanitizer(re[0]):w(re[0]);pe.type="paragraph",pe.text=we,pe.tokens=this.lexer.inline(we)}return pe}},ae.def=function(X){var re=this.rules.block.def.exec(X);if(re){re[3]&&(re[3]=re[3].substring(1,re[3].length-1));var pe=re[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:re[0],href:re[2],title:re[3]}}},ae.table=function(X){var re=this.rules.block.table.exec(X);if(re){var pe={type:"table",header:y(re[1]).map(function(Ce){return{text:Ce}}),align:re[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:re[3]&&re[3].trim()?re[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=re[0];var we=pe.align.length,Fe,Be,Re,De;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(pe.align[Fe])?pe.align[Fe]="right":/^ *:-+: *$/.test(pe.align[Fe])?pe.align[Fe]="center":/^ *:-+ *$/.test(pe.align[Fe])?pe.align[Fe]="left":pe.align[Fe]=null;for(we=pe.rows.length,Fe=0;Fe<we;Fe++)pe.rows[Fe]=y(pe.rows[Fe],pe.header.length).map(function(Ce){return{text:Ce}});for(we=pe.header.length,Be=0;Be<we;Be++)pe.header[Be].tokens=this.lexer.inline(pe.header[Be].text);for(we=pe.rows.length,Be=0;Be<we;Be++)for(De=pe.rows[Be],Re=0;Re<De.length;Re++)De[Re].tokens=this.lexer.inline(De[Re].text);return pe}}},ae.lheading=function(X){var re=this.rules.block.lheading.exec(X);if(re)return{type:"heading",raw:re[0],depth:re[2].charAt(0)==="="?1:2,text:re[1],tokens:this.lexer.inline(re[1])}},ae.paragraph=function(X){var re=this.rules.block.paragraph.exec(X);if(re){var pe=re[1].charAt(re[1].length-1)===`
`?re[1].slice(0,-1):re[1];return{type:"paragraph",raw:re[0],text:pe,tokens:this.lexer.inline(pe)}}},ae.text=function(X){var re=this.rules.block.text.exec(X);if(re)return{type:"text",raw:re[0],text:re[0],tokens:this.lexer.inline(re[0])}},ae.escape=function(X){var re=this.rules.inline.escape.exec(X);if(re)return{type:"escape",raw:re[0],text:w(re[1])}},ae.tag=function(X){var re=this.rules.inline.tag.exec(X);if(re)return!this.lexer.state.inLink&&/^<a /i.test(re[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(re[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(re[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(re[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:re[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):w(re[0]):re[0]}},ae.link=function(X){var re=this.rules.inline.link.exec(X);if(re){var pe=re[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var we=k(pe.slice(0,-1),"\\");if((pe.length-we.length)%2===0)return}else{var Fe=A(re[2],"()");if(Fe>-1){var Be=re[0].indexOf("!")===0?5:4,Re=Be+re[1].length+Fe;re[2]=re[2].substring(0,Fe),re[0]=re[0].substring(0,Re).trim(),re[3]=""}}var De=re[2],Ce="";if(this.options.pedantic){var V=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(De);V&&(De=V[1],Ce=V[3])}else Ce=re[3]?re[3].slice(1,-1):"";return De=De.trim(),/^</.test(De)&&(this.options.pedantic&&!/>$/.test(pe)?De=De.slice(1):De=De.slice(1,-1)),F(re,{href:De&&De.replace(this.rules.inline._escapes,"$1"),title:Ce&&Ce.replace(this.rules.inline._escapes,"$1")},re[0],this.lexer)}},ae.reflink=function(X,re){var pe;if((pe=this.rules.inline.reflink.exec(X))||(pe=this.rules.inline.nolink.exec(X))){var we=(pe[2]||pe[1]).replace(/\s+/g," ");if(we=re[we.toLowerCase()],!we||!we.href){var Fe=pe[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return F(pe,we,pe[0],this.lexer)}},ae.emStrong=function(X,re,pe){pe===void 0&&(pe="");var we=this.rules.inline.emStrong.lDelim.exec(X);if(we&&!(we[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(pe===""||this.rules.inline.punctuation.exec(pe))){var Be=we[0].length-1,Re,De,Ce=Be,V=0,G=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(G.lastIndex=0,re=re.slice(-1*X.length+Be);(we=G.exec(re))!=null;)if(Re=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!Re){if(De=Re.length,we[3]||we[4]){Ce+=De;continue}else if((we[5]||we[6])&&Be%3&&!((Be+De)%3)){V+=De;continue}if(Ce-=De,!(Ce>0)){if(De=Math.min(De,De+Ce+V),Math.min(Be,De)%2){var J=X.slice(1,Be+we.index+De);return{type:"em",raw:X.slice(0,Be+we.index+De+1),text:J,tokens:this.lexer.inlineTokens(J)}}var x=X.slice(2,Be+we.index+De-1);return{type:"strong",raw:X.slice(0,Be+we.index+De+1),text:x,tokens:this.lexer.inlineTokens(x)}}}}}},ae.codespan=function(X){var re=this.rules.inline.code.exec(X);if(re){var pe=re[2].replace(/\n/g," "),we=/[^ ]/.test(pe),Fe=/^ /.test(pe)&&/ $/.test(pe);return we&&Fe&&(pe=pe.substring(1,pe.length-1)),pe=w(pe,!0),{type:"codespan",raw:re[0],text:pe}}},ae.br=function(X){var re=this.rules.inline.br.exec(X);if(re)return{type:"br",raw:re[0]}},ae.del=function(X){var re=this.rules.inline.del.exec(X);if(re)return{type:"del",raw:re[0],text:re[2],tokens:this.lexer.inlineTokens(re[2])}},ae.autolink=function(X,re){var pe=this.rules.inline.autolink.exec(X);if(pe){var we,Fe;return pe[2]==="@"?(we=w(this.options.mangle?re(pe[1]):pe[1]),Fe="mailto:"+we):(we=w(pe[1]),Fe=we),{type:"link",raw:pe[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ae.url=function(X,re){var pe;if(pe=this.rules.inline.url.exec(X)){var we,Fe;if(pe[2]==="@")we=w(this.options.mangle?re(pe[0]):pe[0]),Fe="mailto:"+we;else{var Be;do Be=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(Be!==pe[0]);we=w(pe[0]),pe[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:pe[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ae.inlineText=function(X,re){var pe=this.rules.inline.text.exec(X);if(pe){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):w(pe[0]):pe[0]:we=w(this.options.smartypants?re(pe[0]):pe[0]),{type:"text",raw:pe[0],text:we}}},te}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=f(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=f(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=f(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=f(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=f(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=f(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=D({},M),M.gfm=D({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=f(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=f(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=D({},M.normal,{html:f(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:f(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=f(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=f(M._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=f(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=f(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=f(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=f(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=f(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=f(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=f(z.reflink).replace("label",z._label).replace("ref",M._label).getRegex(),z.nolink=f(z.nolink).replace("ref",M._label).getRegex(),z.reflinkSearch=f(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=D({},z),z.pedantic=D({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:f(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:f(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=D({},z.normal,{escape:f(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=f(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=D({},z.gfm,{br:f(z.br).replace("{2,}","*").getRegex(),text:f(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(te){return te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(te){var ae="",se,X,re=te.length;for(se=0;se<re;se++)X=te.charCodeAt(se),Math.random()>.5&&(X="x"+X.toString(16)),ae+="&#"+X+";";return ae}var B=function(){function te(se){this.tokens=[],this.tokens.links=Object.create(null),this.options=se||$e.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:M.normal,inline:z.normal};this.options.pedantic?(X.block=M.pedantic,X.inline=z.pedantic):this.options.gfm&&(X.block=M.gfm,this.options.breaks?X.inline=z.breaks:X.inline=z.gfm),this.tokenizer.rules=X}te.lex=function(X,re){var pe=new te(re);return pe.lex(X)},te.lexInline=function(X,re){var pe=new te(re);return pe.inlineTokens(X)};var ae=te.prototype;return ae.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var re;re=this.inlineQueue.shift();)this.inlineTokens(re.src,re.tokens);return this.tokens},ae.blockTokens=function(X,re){var pe=this;re===void 0&&(re=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(Ce,V,G){return V+"    ".repeat(G.length)});for(var we,Fe,Be,Re;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ce){return(we=Ce.call({lexer:pe},X,re))?(X=X.substring(we.raw.length),re.push(we),!0):!1}))){if(we=this.tokenizer.space(X)){X=X.substring(we.raw.length),we.raw.length===1&&re.length>0?re[re.length-1].raw+=`
`:re.push(we);continue}if(we=this.tokenizer.code(X)){X=X.substring(we.raw.length),Fe=re[re.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):re.push(we);continue}if(we=this.tokenizer.fences(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.heading(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.hr(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.blockquote(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.list(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.html(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.def(X)){X=X.substring(we.raw.length),Fe=re[re.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.lheading(X)){X=X.substring(we.raw.length),re.push(we);continue}if(Be=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ce=1/0,V=X.slice(1),G=void 0;pe.options.extensions.startBlock.forEach(function(J){G=J.call({lexer:this},V),typeof G=="number"&&G>=0&&(Ce=Math.min(Ce,G))}),Ce<1/0&&Ce>=0&&(Be=X.substring(0,Ce+1))}(),this.state.top&&(we=this.tokenizer.paragraph(Be))){Fe=re[re.length-1],Re&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):re.push(we),Re=Be.length!==X.length,X=X.substring(we.raw.length);continue}if(we=this.tokenizer.text(X)){X=X.substring(we.raw.length),Fe=re[re.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):re.push(we);continue}if(X){var De="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return this.state.top=!0,re},ae.inline=function(X,re){return re===void 0&&(re=[]),this.inlineQueue.push({src:X,tokens:re}),re},ae.inlineTokens=function(X,re){var pe=this;re===void 0&&(re=[]);var we,Fe,Be,Re=X,De,Ce,V;if(this.tokens.links){var G=Object.keys(this.tokens.links);if(G.length>0)for(;(De=this.tokenizer.rules.inline.reflinkSearch.exec(Re))!=null;)G.includes(De[0].slice(De[0].lastIndexOf("[")+1,-1))&&(Re=Re.slice(0,De.index)+"["+v("a",De[0].length-2)+"]"+Re.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(De=this.tokenizer.rules.inline.blockSkip.exec(Re))!=null;)Re=Re.slice(0,De.index)+"["+v("a",De[0].length-2)+"]"+Re.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(De=this.tokenizer.rules.inline.escapedEmSt.exec(Re))!=null;)Re=Re.slice(0,De.index)+"++"+Re.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Ce||(V=""),Ce=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(x){return(we=x.call({lexer:pe},X,re))?(X=X.substring(we.raw.length),re.push(we),!0):!1}))){if(we=this.tokenizer.escape(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.tag(X)){X=X.substring(we.raw.length),Fe=re[re.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):re.push(we);continue}if(we=this.tokenizer.link(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(we.raw.length),Fe=re[re.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):re.push(we);continue}if(we=this.tokenizer.emStrong(X,Re,V)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.codespan(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.br(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.del(X)){X=X.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.autolink(X,W)){X=X.substring(we.raw.length),re.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(X,W))){X=X.substring(we.raw.length),re.push(we);continue}if(Be=X,this.options.extensions&&this.options.extensions.startInline&&function(){var x=1/0,de=X.slice(1),Ee=void 0;pe.options.extensions.startInline.forEach(function(Le){Ee=Le.call({lexer:this},de),typeof Ee=="number"&&Ee>=0&&(x=Math.min(x,Ee))}),x<1/0&&x>=0&&(Be=X.substring(0,x+1))}(),we=this.tokenizer.inlineText(Be,j)){X=X.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(V=we.raw.slice(-1)),Ce=!0,Fe=re[re.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):re.push(we);continue}if(X){var J="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return re},r(te,null,[{key:"rules",get:function(){return{block:M,inline:z}}}]),te}(),ee=function(){function te(se){this.options=se||$e.defaults}var ae=te.prototype;return ae.code=function(X,re,pe){var we=(re||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(X,we);Fe!=null&&Fe!==X&&(pe=!0,X=Fe)}return X=X.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+w(we,!0)+'">'+(pe?X:w(X,!0))+`</code></pre>
`:"<pre><code>"+(pe?X:w(X,!0))+`</code></pre>
`},ae.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},ae.html=function(X){return X},ae.heading=function(X,re,pe,we){if(this.options.headerIds){var Fe=this.options.headerPrefix+we.slug(pe);return"<h"+re+' id="'+Fe+'">'+X+"</h"+re+`>
`}return"<h"+re+">"+X+"</h"+re+`>
`},ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ae.list=function(X,re,pe){var we=re?"ol":"ul",Fe=re&&pe!==1?' start="'+pe+'"':"";return"<"+we+Fe+`>
`+X+"</"+we+`>
`},ae.listitem=function(X){return"<li>"+X+`</li>
`},ae.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ae.paragraph=function(X){return"<p>"+X+`</p>
`},ae.table=function(X,re){return re&&(re="<tbody>"+re+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+re+`</table>
`},ae.tablerow=function(X){return`<tr>
`+X+`</tr>
`},ae.tablecell=function(X,re){var pe=re.header?"th":"td",we=re.align?"<"+pe+' align="'+re.align+'">':"<"+pe+">";return we+X+("</"+pe+`>
`)},ae.strong=function(X){return"<strong>"+X+"</strong>"},ae.em=function(X){return"<em>"+X+"</em>"},ae.codespan=function(X){return"<code>"+X+"</code>"},ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},ae.del=function(X){return"<del>"+X+"</del>"},ae.link=function(X,re,pe){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return pe;var we='<a href="'+w(X)+'"';return re&&(we+=' title="'+re+'"'),we+=">"+pe+"</a>",we},ae.image=function(X,re,pe){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return pe;var we='<img src="'+X+'" alt="'+pe+'"';return re&&(we+=' title="'+re+'"'),we+=this.options.xhtml?"/>":">",we},ae.text=function(X){return X},te}(),H=function(){function te(){}var ae=te.prototype;return ae.strong=function(X){return X},ae.em=function(X){return X},ae.codespan=function(X){return X},ae.del=function(X){return X},ae.html=function(X){return X},ae.text=function(X){return X},ae.link=function(X,re,pe){return""+pe},ae.image=function(X,re,pe){return""+pe},ae.br=function(){return""},te}(),q=function(){function te(){this.seen={}}var ae=te.prototype;return ae.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ae.getNextSafeSlug=function(X,re){var pe=X,we=0;if(this.seen.hasOwnProperty(pe)){we=this.seen[X];do we++,pe=X+"-"+we;while(this.seen.hasOwnProperty(pe))}return re||(this.seen[X]=we,this.seen[pe]=0),pe},ae.slug=function(X,re){re===void 0&&(re={});var pe=this.serialize(X);return this.getNextSafeSlug(pe,re.dryrun)},te}(),Q=function(){function te(se){this.options=se||$e.defaults,this.options.renderer=this.options.renderer||new ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new H,this.slugger=new q}te.parse=function(X,re){var pe=new te(re);return pe.parse(X)},te.parseInline=function(X,re){var pe=new te(re);return pe.parseInline(X)};var ae=te.prototype;return ae.parse=function(X,re){re===void 0&&(re=!0);var pe="",we,Fe,Be,Re,De,Ce,V,G,J,x,de,Ee,Le,He,Ze,et,nt,st,rt,at=X.length;for(we=0;we<at;we++){if(x=X[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[x.type]&&(rt=this.options.extensions.renderers[x.type].call({parser:this},x),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(x.type))){pe+=rt||"";continue}switch(x.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(x.tokens),x.depth,m(this.parseInline(x.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(x.text,x.lang,x.escaped);continue}case"table":{for(G="",V="",Re=x.header.length,Fe=0;Fe<Re;Fe++)V+=this.renderer.tablecell(this.parseInline(x.header[Fe].tokens),{header:!0,align:x.align[Fe]});for(G+=this.renderer.tablerow(V),J="",Re=x.rows.length,Fe=0;Fe<Re;Fe++){for(Ce=x.rows[Fe],V="",De=Ce.length,Be=0;Be<De;Be++)V+=this.renderer.tablecell(this.parseInline(Ce[Be].tokens),{header:!1,align:x.align[Be]});J+=this.renderer.tablerow(V)}pe+=this.renderer.table(G,J);continue}case"blockquote":{J=this.parse(x.tokens),pe+=this.renderer.blockquote(J);continue}case"list":{for(de=x.ordered,Ee=x.start,Le=x.loose,Re=x.items.length,J="",Fe=0;Fe<Re;Fe++)Ze=x.items[Fe],et=Ze.checked,nt=Ze.task,He="",Ze.task&&(st=this.renderer.checkbox(et),Le?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=st+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=st+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:st}):He+=st),He+=this.parse(Ze.tokens,Le),J+=this.renderer.listitem(He,nt,et);pe+=this.renderer.list(J,de,Ee);continue}case"html":{pe+=this.renderer.html(x.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(x.tokens));continue}case"text":{for(J=x.tokens?this.parseInline(x.tokens):x.text;we+1<at&&X[we+1].type==="text";)x=X[++we],J+=`
`+(x.tokens?this.parseInline(x.tokens):x.text);pe+=re?this.renderer.paragraph(J):J;continue}default:{var gt='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error(gt);return}else throw new Error(gt)}}}return pe},ae.parseInline=function(X,re){re=re||this.renderer;var pe="",we,Fe,Be,Re=X.length;for(we=0;we<Re;we++){if(Fe=X[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Be=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){pe+=Be||"";continue}switch(Fe.type){case"escape":{pe+=re.text(Fe.text);break}case"html":{pe+=re.html(Fe.text);break}case"link":{pe+=re.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,re));break}case"image":{pe+=re.image(Fe.href,Fe.title,Fe.text);break}case"strong":{pe+=re.strong(this.parseInline(Fe.tokens,re));break}case"em":{pe+=re.em(this.parseInline(Fe.tokens,re));break}case"codespan":{pe+=re.codespan(Fe.text);break}case"br":{pe+=re.br();break}case"del":{pe+=re.del(this.parseInline(Fe.tokens,re));break}case"text":{pe+=re.text(Fe.text);break}default:{var De='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(De);return}else throw new Error(De)}}}return pe},te}();function _(te,ae,se){if(typeof te>"u"||te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");if(typeof ae=="function"&&(se=ae,ae=null),ae=D({},_.defaults,ae||{}),b(ae),se){var X=ae.highlight,re;try{re=B.lex(te,ae)}catch(Re){return se(Re)}var pe=function(De){var Ce;if(!De)try{ae.walkTokens&&_.walkTokens(re,ae.walkTokens),Ce=Q.parse(re,ae)}catch(V){De=V}return ae.highlight=X,De?se(De):se(null,Ce)};if(!X||X.length<3||(delete ae.highlight,!re.length))return pe();var we=0;_.walkTokens(re,function(Re){Re.type==="code"&&(we++,setTimeout(function(){X(Re.text,Re.lang,function(De,Ce){if(De)return pe(De);Ce!=null&&Ce!==Re.text&&(Re.text=Ce,Re.escaped=!0),we--,we===0&&pe()})},0))}),we===0&&pe();return}function Fe(Re){if(Re.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+w(Re.message+"",!0)+"</pre>";throw Re}try{var Be=B.lex(te,ae);if(ae.walkTokens){if(ae.async)return Promise.all(_.walkTokens(Be,ae.walkTokens)).then(function(){return Q.parse(Be,ae)}).catch(Fe);_.walkTokens(Be,ae.walkTokens)}return Q.parse(Be,ae)}catch(Re){Fe(Re)}}_.options=_.setOptions=function(te){return D(_.defaults,te),T(_.defaults),_},_.getDefaults=O,_.defaults=$e.defaults,_.use=function(){for(var te=arguments.length,ae=new Array(te),se=0;se<te;se++)ae[se]=arguments[se];var X=D.apply(void 0,[{}].concat(ae)),re=_.defaults.extensions||{renderers:{},childTokens:{}},pe;ae.forEach(function(we){if(we.extensions&&(pe=!0,we.extensions.forEach(function(Be){if(!Be.name)throw new Error("extension name required");if(Be.renderer){var Re=re.renderers?re.renderers[Be.name]:null;Re?re.renderers[Be.name]=function(){for(var De=arguments.length,Ce=new Array(De),V=0;V<De;V++)Ce[V]=arguments[V];var G=Be.renderer.apply(this,Ce);return G===!1&&(G=Re.apply(this,Ce)),G}:re.renderers[Be.name]=Be.renderer}if(Be.tokenizer){if(!Be.level||Be.level!=="block"&&Be.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");re[Be.level]?re[Be.level].unshift(Be.tokenizer):re[Be.level]=[Be.tokenizer],Be.start&&(Be.level==="block"?re.startBlock?re.startBlock.push(Be.start):re.startBlock=[Be.start]:Be.level==="inline"&&(re.startInline?re.startInline.push(Be.start):re.startInline=[Be.start]))}Be.childTokens&&(re.childTokens[Be.name]=Be.childTokens)})),we.renderer&&function(){var Be=_.defaults.renderer||new ee,Re=function(V){var G=Be[V];Be[V]=function(){for(var J=arguments.length,x=new Array(J),de=0;de<J;de++)x[de]=arguments[de];var Ee=we.renderer[V].apply(Be,x);return Ee===!1&&(Ee=G.apply(Be,x)),Ee}};for(var De in we.renderer)Re(De);X.renderer=Be}(),we.tokenizer&&function(){var Be=_.defaults.tokenizer||new L,Re=function(V){var G=Be[V];Be[V]=function(){for(var J=arguments.length,x=new Array(J),de=0;de<J;de++)x[de]=arguments[de];var Ee=we.tokenizer[V].apply(Be,x);return Ee===!1&&(Ee=G.apply(Be,x)),Ee}};for(var De in we.tokenizer)Re(De);X.tokenizer=Be}(),we.walkTokens){var Fe=_.defaults.walkTokens;X.walkTokens=function(Be){var Re=[];return Re.push(we.walkTokens.call(this,Be)),Fe&&(Re=Re.concat(Fe.call(this,Be))),Re}}pe&&(X.extensions=re),_.setOptions(X)})},_.walkTokens=function(te,ae){for(var se=[],X=function(){var Fe=pe.value;switch(se=se.concat(ae.call(_,Fe)),Fe.type){case"table":{for(var Be=R(Fe.header),Re;!(Re=Be()).done;){var De=Re.value;se=se.concat(_.walkTokens(De.tokens,ae))}for(var Ce=R(Fe.rows),V;!(V=Ce()).done;)for(var G=V.value,J=R(G),x;!(x=J()).done;){var de=x.value;se=se.concat(_.walkTokens(de.tokens,ae))}break}case"list":{se=se.concat(_.walkTokens(Fe.items,ae));break}default:_.defaults.extensions&&_.defaults.extensions.childTokens&&_.defaults.extensions.childTokens[Fe.type]?_.defaults.extensions.childTokens[Fe.type].forEach(function(Ee){se=se.concat(_.walkTokens(Fe[Ee],ae))}):Fe.tokens&&(se=se.concat(_.walkTokens(Fe.tokens,ae)))}},re=R(te),pe;!(pe=re()).done;)X();return se},_.parseInline=function(te,ae){if(typeof te>"u"||te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");ae=D({},_.defaults,ae||{}),b(ae);try{var se=B.lexInline(te,ae);return ae.walkTokens&&_.walkTokens(se,ae.walkTokens),Q.parseInline(se,ae)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+w(X.message+"",!0)+"</pre>";throw X}},_.Parser=Q,_.parser=Q.parse,_.Renderer=ee,_.TextRenderer=H,_.Lexer=B,_.lexer=B.lex,_.Tokenizer=L,_.Slugger=q,_.parse=_;var ce=_.options,ne=_.setOptions,ye=_.use,ge=_.walkTokens,Y=_.parseInline,U=_,oe=Q.parse,ve=B.lex;$e.Lexer=B,$e.Parser=Q,$e.Renderer=ee,$e.Slugger=q,$e.TextRenderer=H,$e.Tokenizer=L,$e.getDefaults=O,$e.lexer=ve,$e.marked=_,$e.options=ce,$e.parse=U,$e.parseInline=Y,$e.parser=oe,$e.setOptions=ne,$e.use=ye,$e.walkTokens=ge,Object.defineProperty($e,"__esModule",{value:!0})}),define(ke[40],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var r;(function(h){h[h.Uri=1]="Uri",h[h.Regexp=2]="Regexp",h[h.ScmResource=3]="ScmResource",h[h.ScmResourceGroup=4]="ScmResourceGroup",h[h.ScmProvider=5]="ScmProvider",h[h.CommentController=6]="CommentController",h[h.CommentThread=7]="CommentThread",h[h.CommentThreadInstance=8]="CommentThreadInstance",h[h.CommentThreadReply=9]="CommentThreadReply",h[h.CommentNode=10]="CommentNode",h[h.CommentThreadNode=11]="CommentThreadNode",h[h.TimelineActionContext=12]="TimelineActionContext",h[h.NotebookCellActionContext=13]="NotebookCellActionContext",h[h.NotebookActionContext=14]="NotebookActionContext",h[h.TerminalContext=15]="TerminalContext",h[h.TestItemContext=16]="TestItemContext",h[h.Date=17]="Date",h[h.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(r||(e.MarshalledId=r={}))}),define(ke[179],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=r;function r(a){const m=R(a);if(m&&m.length>0)return new Uint32Array(m)}let h=0;const C=new Uint32Array(10);function R(a){if(h=0,O(a,S,p.InitialConsonant),h>0||(O(a,u,p.Vowel),h>0)||(O(a,P,p.FinalConsonant),h>0)||(O(a,w,p.CompatibilityJamo),h))return C.subarray(0,h);if(a>=44032&&a<=55203){const m=a-44032,$=m%588,f=Math.floor(m/588),i=Math.floor($/28),s=$%28-1;if(f<S.length?O(f,S,0):p.InitialConsonant+f-p.CompatibilityJamo<w.length&&O(p.InitialConsonant+f,w,p.CompatibilityJamo),i<u.length?O(i,u,0):p.Vowel+i-p.CompatibilityJamo<w.length&&O(p.Vowel+i-p.CompatibilityJamo,w,p.CompatibilityJamo),s>=0&&(s<P.length?O(s,P,0):p.FinalConsonant+s-p.CompatibilityJamo<w.length&&O(p.FinalConsonant+s-p.CompatibilityJamo,w,p.CompatibilityJamo)),h>0)return C.subarray(0,h)}}function O(a,m,$){a>=$&&a<$+m.length&&T(m[a-$])}function T(a){a!==c.NUL&&(C[h++]=a&255,a>>8&&(C[h++]=a>>8&255),a>>16&&(C[h++]=a>>16&255))}var p;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var c;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(c||(c={}));var I;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(I||(I={}));const S=new Uint8Array([c.r,c.R,c.s,c.e,c.E,c.f,c.a,c.q,c.Q,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g]),u=new Uint16Array([c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,I.hk,I.ho,I.hl,c.y,c.n,I.nj,I.np,I.nl,c.b,c.m,I.ml,c.l]),P=new Uint16Array([c.r,c.R,I.rt,c.s,I.sw,I.sg,c.e,c.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,c.a,c.q,I.qt,c.t,c.T,c.d,c.w,c.c,c.z,c.x,c.v,c.g]),w=new Uint16Array([c.r,c.R,I.rt,c.s,I.sw,I.sg,c.e,c.E,c.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,c.a,c.q,c.Q,I.qt,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g,c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,I.hk,I.ho,I.hl,c.y,c.n,I.nj,I.np,I.nl,c.b,c.m,I.ml,c.l])}),define(ke[81],Ie([1,0,28]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=void 0,e.$nm=C,e.$om=O;const h=new r.$Dc(1e4);function C(c){return p(c,"NFC",h)}const R=new r.$Dc(1e4);function O(c){return p(c,"NFD",R)}const T=/[^\u0000-\u0080]/;function p(c,I,S){if(!c)return c;const u=S.get(c);if(u)return u;let P;return T.test(c)?P=c.normalize(I):P=c,S.set(c,P),P}e.$pm=function(){const c=/[\u0300-\u036f]/g;return function(I){return O(I).replace(c,"")}}()}),define(ke[133],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=void 0,e.$Lm=r,e.rot=h,e.$Qm=T;function r(p,c,I){return Math.min(Math.max(p,c),I)}function h(p,c){return(c+p%c)%c}class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Nm=C;class R{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Om=R;class O{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const I=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Pm=O;function T(p,c,I,S,u,P,w,a){const m=w-I,$=a-S,f=u-I,i=P-S,s=p-I,t=c-S,o=m*m+$*$,n=m*f+$*i,d=m*s+$*t,l=f*f+i*i,g=f*s+i*t,E=1/(o*l-n*n),D=(l*d-n*g)*E,y=(o*g-n*d)*E;return D>=0&&y>=0&&D+y<1}}),define(ke[180],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=R,e.$cd=u;class r{constructor(w,a,m){this.owner=w,this.debugNameSource=a,this.referenceFn=m}getDebugName(w){return R(w,this)}}e.$ad=r;const h=new Map,C=new WeakMap;function R(P,w){const a=C.get(P);if(a)return a;const m=O(P,w);if(m){let $=h.get(m)??0;$++,h.set(m,$);const f=$===1?m:`${m}#${$}`;return C.set(P,f),f}}function O(P,w){const a=C.get(P);if(a)return a;const m=w.owner?I(w.owner)+".":"";let $;const f=w.debugNameSource;if(f!==void 0)if(typeof f=="function"){if($=f(),$!==void 0)return m+$}else return m+f;const i=w.referenceFn;if(i!==void 0&&($=u(i),$!==void 0))return m+$;if(w.owner!==void 0){const s=T(w.owner,P);if(s!==void 0)return m+s}}function T(P,w){for(const a in P)if(P[a]===w)return a}const p=new Map,c=new WeakMap;function I(P){const w=c.get(P);if(w)return w;const a=S(P);let m=p.get(a)??0;m++,p.set(a,m);const $=m===1?a:`${a}#${m}`;return c.set(P,$),$}function S(P){const w=P.constructor;return w?w.name:"Object"}function u(P){const w=P.toString(),m=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(w);return(m?m[1]:void 0)?.trim()}}),define(ke[181],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Md=void 0,e.$Kd=h,e.$Ld=C;let r;function h(a){r=a}function C(){return r}class R{constructor(){this.a=0,this.d=new WeakMap}b(m){return O([T(P("|  ",this.a)),m])}c(m){return m.hadValue?m.didChange?[T(" "),c(I(m.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),c(I(m.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),c(I(m.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(m,$){console.log(...this.b([p("observable value changed"),c(m.debugName,{color:"BlueViolet"}),...this.c($)]))}formatChanges(m){if(m.size!==0)return c(" (changed deps: "+[...m].map($=>$.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(m){const $=m.handleChange;this.d.set(m,new Set),m.handleChange=(f,i)=>(this.d.get(m).add(f),$.apply(m,[f,i]))}handleDerivedRecomputed(m,$){const f=this.d.get(m);console.log(...this.b([p("derived recomputed"),c(m.debugName,{color:"BlueViolet"}),...this.c($),this.formatChanges(f),{data:[{fn:m._debugNameData.referenceFn??m._computeFn}]}])),f.clear()}handleFromEventObservableTriggered(m,$){console.log(...this.b([p("observable from event triggered"),c(m.debugName,{color:"BlueViolet"}),...this.c($),{data:[{fn:m._getValue}]}]))}handleAutorunCreated(m){const $=m.handleChange;this.d.set(m,new Set),m.handleChange=(f,i)=>(this.d.get(m).add(f),$.apply(m,[f,i]))}handleAutorunTriggered(m){const $=this.d.get(m);console.log(...this.b([p("autorun"),c(m.debugName,{color:"BlueViolet"}),this.formatChanges($),{data:[{fn:m._debugNameData.referenceFn??m._runFn}]}])),$.clear(),this.a++}handleAutorunFinished(m){this.a--}handleBeginTransaction(m){let $=m.getDebugName();$===void 0&&($=""),console.log(...this.b([p("transaction"),c($,{color:"BlueViolet"}),{data:[{fn:m._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Md=R;function O(a){const m=new Array,$=[];let f="";function i(t){if("length"in t)for(const o of t)o&&i(o);else"text"in t?(f+=`%c${t.text}`,m.push(t.style),t.data&&$.push(...t.data)):"data"in t&&$.push(...t.data)}i(a);const s=[f,...m];return s.push(...$),s}function T(a){return c(a,{color:"black"})}function p(a){return c(w(`${a}: `,10),{color:"black",bold:!0})}function c(a,m={color:"black"}){function $(i){return Object.entries(i).reduce((s,[t,o])=>`${s}${t}:${o};`,"")}const f={color:m.color};return m.strikeThrough&&(f["text-decoration"]="line-through"),m.bold&&(f["font-weight"]="bold"),{text:a,style:$(f)}}function I(a,m){switch(typeof a){case"number":return""+a;case"string":return a.length+2<=m?`"${a}"`:`"${a.substr(0,m-7)}"+...`;case"boolean":return a?"true":"false";case"undefined":return"undefined";case"object":return a===null?"null":Array.isArray(a)?S(a,m):u(a,m);case"symbol":return a.toString();case"function":return`[[Function${a.name?" "+a.name:""}]]`;default:return""+a}}function S(a,m){let $="[ ",f=!0;for(const i of a){if(f||($+=", "),$.length-5>m){$+="...";break}f=!1,$+=`${I(i,m-$.length)}`}return $+=" ]",$}function u(a,m){let $="{ ",f=!0;for(const[i,s]of Object.entries(a)){if(f||($+=", "),$.length-5>m){$+="...";break}f=!1,$+=`${i}: ${I(s,m-$.length)}`}return $+=" }",$}function P(a,m){let $="";for(let f=1;f<=m;f++)$+=a;return $}function w(a,m){for(;a.length<m;)a+=" ";return a}}),define(ke[182],Ie([1,0,175,180,181]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9d=e.$7d=e.$5d=e.$Zd=e.$Yd=void 0,e.$Vd=O,e.$Wd=p,e.$Xd=I,e.$1d=P,e.$2d=a,e.$3d=m,e.$4d=$,e.$6d=i,e.$8d=t;let R;function O(n){R=n}let T;function p(n){T=n}let c;function I(n){c=n}class S{get TChange(){return null}reportChanges(){this.get()}read(d){return d?d.readObservable(this):this.get()}map(d,l){const g=l===void 0?void 0:d,E=l===void 0?d:l;return c({owner:g,debugName:()=>{const D=(0,h.$cd)(E);if(D!==void 0)return D;const k=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(E.toString());if(k)return`${this.debugName}.${k[2]}`;if(!g)return`${this.debugName} (mapped)`},debugReferenceFn:E},D=>E(this.read(D),D))}flatten(){return c({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},d=>this.read(d).read(d))}recomputeInitiallyAndOnChange(d,l){return d.add(R(this,l)),this}keepObserved(d){return d.add(T(this)),this}get a(){return this.get()}}e.$Yd=S;class u extends S{constructor(){super(...arguments),this.b=new Set}addObserver(d){const l=this.b.size;this.b.add(d),l===0&&this.c()}removeObserver(d){this.b.delete(d)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Zd=u;function P(n,d){const l=new f(n,d);try{n(l)}finally{l.finish()}}let w;function a(n){if(w)n(w);else{const d=new f(n,void 0);w=d;try{n(d)}finally{d.finish(),w=void 0}}}async function m(n,d){const l=new f(n,d);try{await n(l)}finally{l.finish()}}function $(n,d,l){n?d(n):P(d,l)}class f{constructor(d,l){this._fn=d,this.b=l,this.a=[],(0,C.$Ld)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,h.$cd)(this._fn)}updateObserver(d,l){this.a.push({observer:d,observable:l}),d.beginUpdate(l)}finish(){const d=this.a;for(let l=0;l<d.length;l++){const{observer:g,observable:E}=d[l];g.endUpdate(E)}this.a=null,(0,C.$Ld)()?.handleEndTransaction()}}e.$5d=f;function i(n,d){let l;return typeof n=="string"?l=new h.$ad(void 0,n,void 0):l=new h.$ad(n,void 0,void 0),new s(l,d,r.$6c)}class s extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(d,l,g){super(),this.e=d,this.g=g,this.d=l}get(){return this.d}set(d,l,g){if(g===void 0&&this.g(this.d,d))return;let E;l||(l=E=new f(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(d),(0,C.$Ld)()?.handleObservableChanged(this,{oldValue:D,newValue:d,change:g,didChange:!0,hadValue:!0});for(const y of this.b)l.updateObserver(y,this),y.handleChange(this,g)}finally{E&&E.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(d){this.d=d}}e.$7d=s;function t(n,d){let l;return typeof n=="string"?l=new h.$ad(void 0,n,void 0):l=new h.$ad(n,void 0,void 0),new o(l,d,r.$6c)}class o extends s{h(d){this.d!==d&&(this.d&&this.d.dispose(),this.d=d)}dispose(){this.d?.dispose()}}e.$9d=o}),function(){function $e(C){const R=[];typeof C=="number"&&R.push("code/timeOrigin",C);function O(p){R.push(p,Date.now())}function T(){const p=[];for(let c=0;c<R.length;c+=2)p.push({name:R[c],startTime:R[c+1]});return p}return{mark:O,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const O of performance.getEntriesByType("mark"))R.push({name:O.name,startTime:Math.round(C+O.startTime)});return R}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function r(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var h;typeof global=="object"?h=global:typeof self=="object"?h=self:h={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(h)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(h):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),h.perf=r(h))}(),define(ke[10],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=o,e.$E=D,e.$K=y,e.$h="en";let r=!1,h=!1,C=!1,R=!1,O=!1,T=!1,p=!1,c=!1,I=!1,S=!1,u,P=e.$h,w=e.$h,a,m;const $=globalThis;let f;typeof $.vscode<"u"&&typeof $.vscode.process<"u"?f=$.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(f=process);const i=typeof f?.versions?.electron=="string",s=i&&f?.type==="renderer";if(typeof f=="object"){r=f.platform==="win32",h=f.platform==="darwin",C=f.platform==="linux",R=C&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,p=i,I=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.$h,P=e.$h;const k=f.env.VSCODE_NLS_CONFIG;if(k)try{const A=JSON.parse(k);u=A.userLocale,w=A.osLocale,P=A.resolvedLanguage||e.$h,a=A.languagePack?.translationsConfigFile}catch{}O=!0}else typeof navigator=="object"&&!s?(m=navigator.userAgent,r=m.indexOf("Windows")>=0,h=m.indexOf("Macintosh")>=0,c=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=m.indexOf("Linux")>=0,S=m?.indexOf("Mobi")>=0,T=!0,P=globalThis._VSCODE_NLS_LANGUAGE||e.$h,u=navigator.language.toLowerCase(),w=u):console.error("Unable to resolve platform.");var t;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(k){switch(k){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let n=t.Web;h?n=t.Mac:r?n=t.Windows:C&&(n=t.Linux),e.$j=r,e.$k=h,e.$l=C,e.$m=R,e.$n=O,e.$o=p,e.$p=T,e.$q=T&&typeof $.importScripts=="function",e.$r=e.$q?$.origin:void 0,e.$s=c,e.$t=S,e.$u=I,e.$v=n,e.$w=m,e.$x=P;var d;(function(k){function A(){return e.$x}k.value=A;function b(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}k.isDefaultVariant=b;function v(){return e.$x==="en"}k.isDefault=v})(d||(e.Language=d={})),e.$y=u,e.$z=w,e.$A=a,e.$B=typeof $.postMessage=="function"&&!$.importScripts,e.$C=(()=>{if(e.$B){const k=[];$.addEventListener("message",b=>{if(b.data&&b.data.vscodeScheduleAsyncWork)for(let v=0,F=k.length;v<F;v++){const N=k[v];if(N.id===b.data.vscodeScheduleAsyncWork){k.splice(v,1),N.callback();return}}});let A=0;return b=>{const v=++A;k.push({id:v,callback:b}),$.postMessage({vscodeScheduleAsyncWork:v},"*")}}return k=>setTimeout(k)})();var l;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=h||c?l.Macintosh:r?l.Windows:l.Linux;let g=!0,E=!1;function D(){if(!E){E=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,g=new Uint16Array(k.buffer)[0]===513}return g}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function y(k){return parseFloat(k)>=20}}),define(ke[183],Ie([1,0,39]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6I=void 0;const h=Symbol("unset");class C{constructor(){this.a=new O,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||r.Iterable.empty()}get entries(){return this.a.children?.entries()||r.Iterable.empty()}insert(p,c,I){this.d(p,S=>S._value=c,I)}mutate(p,c){this.d(p,I=>I._value=c(I._value===h?void 0:I._value))}mutatePath(p,c){this.d(p,()=>{},I=>c(I))}delete(p){const c=this.c(p);if(!c)return;let I=c.length-1;const S=c[I].node._value;if(S!==h){for(this.b--,c[I].node._value=h;I>0;I--){const{node:u,part:P}=c[I];if(u.children?.size||u._value!==h)break;c[I-1].node.children.delete(P)}return S}}*deleteRecursive(p){const c=this.c(p);if(!c)return;const I=c[c.length-1].node;for(let S=c.length-1;S>0;S--){const u=c[S-1];if(u.node.children.delete(c[S].part),u.node.children.size>0||u.node._value!==h)break}for(const S of R(I))S._value!==h&&(this.b--,yield S._value)}find(p){let c=this.a;for(const I of p){const S=c.children?.get(I);if(!S)return;c=S}return c._value===h?void 0:c._value}hasKeyOrParent(p){let c=this.a;for(const I of p){const S=c.children?.get(I);if(!S)return!1;if(S._value!==h)return!0;c=S}return!1}hasKeyOrChildren(p){let c=this.a;for(const I of p){const S=c.children?.get(I);if(!S)return!1;c=S}return!0}hasKey(p){let c=this.a;for(const I of p){const S=c.children?.get(I);if(!S)return!1;c=S}return c._value!==h}c(p){const c=[{part:"",node:this.a}];let I=0;for(const S of p){const u=c[I].node.children?.get(S);if(!u)return;c.push({part:S,node:u}),I++}return c}d(p,c,I){let S=this.a;for(const w of p){if(S.children)if(S.children.has(w))S=S.children.get(w);else{const a=new O;S.children.set(w,a),S=a}else{const a=new O;S.children=new Map([[w,a]]),S=a}I?.(S)}const u=S._value===h?0:1;c(S);const P=S._value===h?0:1;this.b+=P-u}*values(){for(const{_value:p}of R(this.a))p!==h&&(yield p)}}e.$6I=C;function*R(T){const p=[T];for(;p.length>0;){const c=p.pop();if(yield c,c.children)for(const I of c.children.values())p.push(I)}}class O{constructor(){this._value=h}get value(){return this._value===h?void 0:this._value}set value(p){this._value=p===void 0?h:p}}}),define(ke[55],Ie([1,0,10]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let h;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.process<"u"){const R=C.process;h={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?h={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:h={get platform(){return r.$j?"win32":r.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=h.cwd,e.env=h.env,e.$dc=h.platform,e.$ec=h.arch}),define(ke[16],Ie([1,0,55]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0,r=qe(r);const h=65,C=97,R=90,O=122,T=46,p=47,c=92,I=58,S=63;class u extends Error{constructor(d,l,g){let E;typeof l=="string"&&l.indexOf("not ")===0?(E="must not be",l=l.replace(/^not /,"")):E="must be";const D=d.indexOf(".")!==-1?"property":"argument";let y=`The "${d}" ${D} ${E} of type ${l}`;y+=`. Received type ${typeof g}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function P(n,d){if(n===null||typeof n!="object")throw new u(d,"Object",n)}function w(n,d){if(typeof n!="string")throw new u(d,"string",n)}const a=r.$dc==="win32";function m(n){return n===p||n===c}function $(n){return n===p}function f(n){return n>=h&&n<=R||n>=C&&n<=O}function i(n,d,l,g){let E="",D=0,y=-1,k=0,A=0;for(let b=0;b<=n.length;++b){if(b<n.length)A=n.charCodeAt(b);else{if(g(A))break;A=p}if(g(A)){if(!(y===b-1||k===1))if(k===2){if(E.length<2||D!==2||E.charCodeAt(E.length-1)!==T||E.charCodeAt(E.length-2)!==T){if(E.length>2){const v=E.lastIndexOf(l);v===-1?(E="",D=0):(E=E.slice(0,v),D=E.length-1-E.lastIndexOf(l)),y=b,k=0;continue}else if(E.length!==0){E="",D=0,y=b,k=0;continue}}d&&(E+=E.length>0?`${l}..`:"..",D=2)}else E.length>0?E+=`${l}${n.slice(y+1,b)}`:E=n.slice(y+1,b),D=b-y-1;y=b,k=0}else A===T&&k!==-1?++k:k=-1}return E}function s(n){return n?`${n[0]==="."?"":"."}${n}`:""}function t(n,d){P(d,"pathObject");const l=d.dir||d.root,g=d.base||`${d.name||""}${s(d.ext)}`;return l?l===d.root?`${l}${g}`:`${l}${n}${g}`:g}e.$fc={resolve(...n){let d="",l="",g=!1;for(let E=n.length-1;E>=-1;E--){let D;if(E>=0){if(D=n[E],w(D,`paths[${E}]`),D.length===0)continue}else d.length===0?D=r.cwd():(D=r.env[`=${d}`]||r.cwd(),(D===void 0||D.slice(0,2).toLowerCase()!==d.toLowerCase()&&D.charCodeAt(2)===c)&&(D=`${d}\\`));const y=D.length;let k=0,A="",b=!1;const v=D.charCodeAt(0);if(y===1)m(v)&&(k=1,b=!0);else if(m(v))if(b=!0,m(D.charCodeAt(1))){let F=2,N=F;for(;F<y&&!m(D.charCodeAt(F));)F++;if(F<y&&F!==N){const L=D.slice(N,F);for(N=F;F<y&&m(D.charCodeAt(F));)F++;if(F<y&&F!==N){for(N=F;F<y&&!m(D.charCodeAt(F));)F++;(F===y||F!==N)&&(A=`\\\\${L}\\${D.slice(N,F)}`,k=F)}}}else k=1;else f(v)&&D.charCodeAt(1)===I&&(A=D.slice(0,2),k=2,y>2&&m(D.charCodeAt(2))&&(b=!0,k=3));if(A.length>0)if(d.length>0){if(A.toLowerCase()!==d.toLowerCase())continue}else d=A;if(g){if(d.length>0)break}else if(l=`${D.slice(k)}\\${l}`,g=b,b&&d.length>0)break}return l=i(l,!g,"\\",m),g?`${d}\\${l}`:`${d}${l}`||"."},normalize(n){w(n,"path");const d=n.length;if(d===0)return".";let l=0,g,E=!1;const D=n.charCodeAt(0);if(d===1)return $(D)?"\\":n;if(m(D))if(E=!0,m(n.charCodeAt(1))){let k=2,A=k;for(;k<d&&!m(n.charCodeAt(k));)k++;if(k<d&&k!==A){const b=n.slice(A,k);for(A=k;k<d&&m(n.charCodeAt(k));)k++;if(k<d&&k!==A){for(A=k;k<d&&!m(n.charCodeAt(k));)k++;if(k===d)return`\\\\${b}\\${n.slice(A)}\\`;k!==A&&(g=`\\\\${b}\\${n.slice(A,k)}`,l=k)}}}else l=1;else f(D)&&n.charCodeAt(1)===I&&(g=n.slice(0,2),l=2,d>2&&m(n.charCodeAt(2))&&(E=!0,l=3));let y=l<d?i(n.slice(l),!E,"\\",m):"";return y.length===0&&!E&&(y="."),y.length>0&&m(n.charCodeAt(d-1))&&(y+="\\"),g===void 0?E?`\\${y}`:y:E?`${g}\\${y}`:`${g}${y}`},isAbsolute(n){w(n,"path");const d=n.length;if(d===0)return!1;const l=n.charCodeAt(0);return m(l)||d>2&&f(l)&&n.charCodeAt(1)===I&&m(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let d,l;for(let D=0;D<n.length;++D){const y=n[D];w(y,"path"),y.length>0&&(d===void 0?d=l=y:d+=`\\${y}`)}if(d===void 0)return".";let g=!0,E=0;if(typeof l=="string"&&m(l.charCodeAt(0))){++E;const D=l.length;D>1&&m(l.charCodeAt(1))&&(++E,D>2&&(m(l.charCodeAt(2))?++E:g=!1))}if(g){for(;E<d.length&&m(d.charCodeAt(E));)E++;E>=2&&(d=`\\${d.slice(E)}`)}return e.$fc.normalize(d)},relative(n,d){if(w(n,"from"),w(d,"to"),n===d)return"";const l=e.$fc.resolve(n),g=e.$fc.resolve(d);if(l===g||(n=l.toLowerCase(),d=g.toLowerCase(),n===d))return"";let E=0;for(;E<n.length&&n.charCodeAt(E)===c;)E++;let D=n.length;for(;D-1>E&&n.charCodeAt(D-1)===c;)D--;const y=D-E;let k=0;for(;k<d.length&&d.charCodeAt(k)===c;)k++;let A=d.length;for(;A-1>k&&d.charCodeAt(A-1)===c;)A--;const b=A-k,v=y<b?y:b;let F=-1,N=0;for(;N<v;N++){const M=n.charCodeAt(E+N);if(M!==d.charCodeAt(k+N))break;M===c&&(F=N)}if(N!==v){if(F===-1)return g}else{if(b>v){if(d.charCodeAt(k+N)===c)return g.slice(k+N+1);if(N===2)return g.slice(k+N)}y>v&&(n.charCodeAt(E+N)===c?F=N:N===2&&(F=3)),F===-1&&(F=0)}let L="";for(N=E+F+1;N<=D;++N)(N===D||n.charCodeAt(N)===c)&&(L+=L.length===0?"..":"\\..");return k+=F,L.length>0?`${L}${g.slice(k,A)}`:(g.charCodeAt(k)===c&&++k,g.slice(k,A))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const d=e.$fc.resolve(n);if(d.length<=2)return n;if(d.charCodeAt(0)===c){if(d.charCodeAt(1)===c){const l=d.charCodeAt(2);if(l!==S&&l!==T)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(f(d.charCodeAt(0))&&d.charCodeAt(1)===I&&d.charCodeAt(2)===c)return`\\\\?\\${d}`;return n},dirname(n){w(n,"path");const d=n.length;if(d===0)return".";let l=-1,g=0;const E=n.charCodeAt(0);if(d===1)return m(E)?n:".";if(m(E)){if(l=g=1,m(n.charCodeAt(1))){let k=2,A=k;for(;k<d&&!m(n.charCodeAt(k));)k++;if(k<d&&k!==A){for(A=k;k<d&&m(n.charCodeAt(k));)k++;if(k<d&&k!==A){for(A=k;k<d&&!m(n.charCodeAt(k));)k++;if(k===d)return n;k!==A&&(l=g=k+1)}}}}else f(E)&&n.charCodeAt(1)===I&&(l=d>2&&m(n.charCodeAt(2))?3:2,g=l);let D=-1,y=!0;for(let k=d-1;k>=g;--k)if(m(n.charCodeAt(k))){if(!y){D=k;break}}else y=!1;if(D===-1){if(l===-1)return".";D=l}return n.slice(0,D)},basename(n,d){d!==void 0&&w(d,"suffix"),w(n,"path");let l=0,g=-1,E=!0,D;if(n.length>=2&&f(n.charCodeAt(0))&&n.charCodeAt(1)===I&&(l=2),d!==void 0&&d.length>0&&d.length<=n.length){if(d===n)return"";let y=d.length-1,k=-1;for(D=n.length-1;D>=l;--D){const A=n.charCodeAt(D);if(m(A)){if(!E){l=D+1;break}}else k===-1&&(E=!1,k=D+1),y>=0&&(A===d.charCodeAt(y)?--y===-1&&(g=D):(y=-1,g=k))}return l===g?g=k:g===-1&&(g=n.length),n.slice(l,g)}for(D=n.length-1;D>=l;--D)if(m(n.charCodeAt(D))){if(!E){l=D+1;break}}else g===-1&&(E=!1,g=D+1);return g===-1?"":n.slice(l,g)},extname(n){w(n,"path");let d=0,l=-1,g=0,E=-1,D=!0,y=0;n.length>=2&&n.charCodeAt(1)===I&&f(n.charCodeAt(0))&&(d=g=2);for(let k=n.length-1;k>=d;--k){const A=n.charCodeAt(k);if(m(A)){if(!D){g=k+1;break}continue}E===-1&&(D=!1,E=k+1),A===T?l===-1?l=k:y!==1&&(y=1):l!==-1&&(y=-1)}return l===-1||E===-1||y===0||y===1&&l===E-1&&l===g+1?"":n.slice(l,E)},format:t.bind(null,"\\"),parse(n){w(n,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return d;const l=n.length;let g=0,E=n.charCodeAt(0);if(l===1)return m(E)?(d.root=d.dir=n,d):(d.base=d.name=n,d);if(m(E)){if(g=1,m(n.charCodeAt(1))){let F=2,N=F;for(;F<l&&!m(n.charCodeAt(F));)F++;if(F<l&&F!==N){for(N=F;F<l&&m(n.charCodeAt(F));)F++;if(F<l&&F!==N){for(N=F;F<l&&!m(n.charCodeAt(F));)F++;F===l?g=F:F!==N&&(g=F+1)}}}}else if(f(E)&&n.charCodeAt(1)===I){if(l<=2)return d.root=d.dir=n,d;if(g=2,m(n.charCodeAt(2))){if(l===3)return d.root=d.dir=n,d;g=3}}g>0&&(d.root=n.slice(0,g));let D=-1,y=g,k=-1,A=!0,b=n.length-1,v=0;for(;b>=g;--b){if(E=n.charCodeAt(b),m(E)){if(!A){y=b+1;break}continue}k===-1&&(A=!1,k=b+1),E===T?D===-1?D=b:v!==1&&(v=1):D!==-1&&(v=-1)}return k!==-1&&(D===-1||v===0||v===1&&D===k-1&&D===y+1?d.base=d.name=n.slice(y,k):(d.name=n.slice(y,D),d.base=n.slice(y,k),d.ext=n.slice(D,k))),y>0&&y!==g?d.dir=n.slice(0,y-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(a){const n=/\\/g;return()=>{const d=r.cwd().replace(n,"/");return d.slice(d.indexOf("/"))}}return()=>r.cwd()})();e.$gc={resolve(...n){let d="",l=!1;for(let g=n.length-1;g>=-1&&!l;g--){const E=g>=0?n[g]:o();w(E,`paths[${g}]`),E.length!==0&&(d=`${E}/${d}`,l=E.charCodeAt(0)===p)}return d=i(d,!l,"/",$),l?`/${d}`:d.length>0?d:"."},normalize(n){if(w(n,"path"),n.length===0)return".";const d=n.charCodeAt(0)===p,l=n.charCodeAt(n.length-1)===p;return n=i(n,!d,"/",$),n.length===0?d?"/":l?"./":".":(l&&(n+="/"),d?`/${n}`:n)},isAbsolute(n){return w(n,"path"),n.length>0&&n.charCodeAt(0)===p},join(...n){if(n.length===0)return".";let d;for(let l=0;l<n.length;++l){const g=n[l];w(g,"path"),g.length>0&&(d===void 0?d=g:d+=`/${g}`)}return d===void 0?".":e.$gc.normalize(d)},relative(n,d){if(w(n,"from"),w(d,"to"),n===d||(n=e.$gc.resolve(n),d=e.$gc.resolve(d),n===d))return"";const l=1,g=n.length,E=g-l,D=1,y=d.length-D,k=E<y?E:y;let A=-1,b=0;for(;b<k;b++){const F=n.charCodeAt(l+b);if(F!==d.charCodeAt(D+b))break;F===p&&(A=b)}if(b===k)if(y>k){if(d.charCodeAt(D+b)===p)return d.slice(D+b+1);if(b===0)return d.slice(D+b)}else E>k&&(n.charCodeAt(l+b)===p?A=b:b===0&&(A=0));let v="";for(b=l+A+1;b<=g;++b)(b===g||n.charCodeAt(b)===p)&&(v+=v.length===0?"..":"/..");return`${v}${d.slice(D+A)}`},toNamespacedPath(n){return n},dirname(n){if(w(n,"path"),n.length===0)return".";const d=n.charCodeAt(0)===p;let l=-1,g=!0;for(let E=n.length-1;E>=1;--E)if(n.charCodeAt(E)===p){if(!g){l=E;break}}else g=!1;return l===-1?d?"/":".":d&&l===1?"//":n.slice(0,l)},basename(n,d){d!==void 0&&w(d,"ext"),w(n,"path");let l=0,g=-1,E=!0,D;if(d!==void 0&&d.length>0&&d.length<=n.length){if(d===n)return"";let y=d.length-1,k=-1;for(D=n.length-1;D>=0;--D){const A=n.charCodeAt(D);if(A===p){if(!E){l=D+1;break}}else k===-1&&(E=!1,k=D+1),y>=0&&(A===d.charCodeAt(y)?--y===-1&&(g=D):(y=-1,g=k))}return l===g?g=k:g===-1&&(g=n.length),n.slice(l,g)}for(D=n.length-1;D>=0;--D)if(n.charCodeAt(D)===p){if(!E){l=D+1;break}}else g===-1&&(E=!1,g=D+1);return g===-1?"":n.slice(l,g)},extname(n){w(n,"path");let d=-1,l=0,g=-1,E=!0,D=0;for(let y=n.length-1;y>=0;--y){const k=n.charCodeAt(y);if(k===p){if(!E){l=y+1;break}continue}g===-1&&(E=!1,g=y+1),k===T?d===-1?d=y:D!==1&&(D=1):d!==-1&&(D=-1)}return d===-1||g===-1||D===0||D===1&&d===g-1&&d===l+1?"":n.slice(d,g)},format:t.bind(null,"/"),parse(n){w(n,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return d;const l=n.charCodeAt(0)===p;let g;l?(d.root="/",g=1):g=0;let E=-1,D=0,y=-1,k=!0,A=n.length-1,b=0;for(;A>=g;--A){const v=n.charCodeAt(A);if(v===p){if(!k){D=A+1;break}continue}y===-1&&(k=!1,y=A+1),v===T?E===-1?E=A:b!==1&&(b=1):E!==-1&&(b=-1)}if(y!==-1){const v=D===0&&l?1:D;E===-1||b===0||b===1&&E===y-1&&E===D+1?d.base=d.name=n.slice(v,y):(d.name=n.slice(v,E),d.base=n.slice(v,y),d.ext=n.slice(E,y))}return D>0?d.dir=n.slice(0,D-1):l&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=a?e.$fc.normalize:e.$gc.normalize,e.$ic=a?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=a?e.$fc.join:e.$gc.join,e.$kc=a?e.$fc.resolve:e.$gc.resolve,e.$lc=a?e.$fc.relative:e.$gc.relative,e.$mc=a?e.$fc.dirname:e.$gc.dirname,e.$nc=a?e.$fc.basename:e.$gc.basename,e.$oc=a?e.$fc.extname:e.$gc.extname,e.$pc=a?e.$fc.format:e.$gc.format,e.$qc=a?e.$fc.parse:e.$gc.parse,e.$rc=a?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=a?e.$fc.sep:e.$gc.sep,e.$tc=a?e.$fc.delimiter:e.$gc.delimiter}),define(ke[134],Ie([1,0,50,16]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=T,e.$Br=p,e.$Cr=c,e.$Dr=I,e.$Er=S,e.$Fr=u,e.$Gr=P,e.$Hr=w,e.$Ir=a,e.$Jr=m,e.$Kr=g,e.$Lr=E,e.$Mr=D;const C=new r.$T(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),R=new r.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),O=new r.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(y,k,A=!1){const b=y||"",v=k||"",F=C.value.collator.compare(b,v);return C.value.collatorIsNumeric&&F===0&&b!==v?b<v?-1:1:F}function p(y,k){const A=R.value.collator;return y=y||"",k=k||"",s(A,y,k)}function c(y,k){const A=R.value.collator;return y=y||"",k=k||"",d(y,k)||s(A,y,k)}function I(y,k){const A=R.value.collator;return y=y||"",k=k||"",n(y,k)||s(A,y,k)}function S(y,k){return y=y||"",k=k||"",y===k?0:y<k?-1:1}function u(y,k){const[A,b]=f(y),[v,F]=f(k);let N=C.value.collator.compare(b,F);if(N===0){if(C.value.collatorIsNumeric&&b!==F)return b<F?-1:1;if(N=C.value.collator.compare(A,v),C.value.collatorIsNumeric&&N===0&&A!==v)return A<v?-1:1}return N}function P(y,k){y=y||"",k=k||"";const A=i(y),b=i(k),v=R.value.collator,F=O.value.collator;return s(F,A,b)||s(v,y,k)}function w(y,k){y=y||"",k=k||"";const A=i(y),b=i(k),v=R.value.collator,F=O.value.collator;return s(F,A,b)||d(y,k)||s(v,y,k)}function a(y,k){y=y||"",k=k||"";const A=i(y),b=i(k),v=R.value.collator,F=O.value.collator;return s(F,A,b)||n(y,k)||s(v,y,k)}function m(y,k){y=y||"",k=k||"";const A=i(y).toLowerCase(),b=i(k).toLowerCase();return A!==b?A<b?-1:1:y!==k?y<k?-1:1:0}const $=/^(.*?)(\.([^.]*))?$/;function f(y,k=!1){const A=y?$.exec(y):[];let b=[A&&A[1]||"",A&&A[3]||""];return k&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function i(y){const k=y?$.exec(y):[];return k&&k[1]&&k[1].charAt(0)!=="."&&k[3]||""}function s(y,k,A){const b=y.compare(k,A);return b!==0?b:k.length!==A.length?k.length<A.length?-1:1:0}function t(y){const k=y.charAt(0);return k.toLocaleUpperCase()!==k}function o(y){const k=y.charAt(0);return k.toLocaleLowerCase()!==k}function n(y,k){return t(y)&&o(k)?-1:o(y)&&t(k)?1:0}function d(y,k){return o(y)&&t(k)?-1:t(y)&&o(k)?1:0}function l(y,k,A=!1){return A||(y=y&&y.toLowerCase(),k=k&&k.toLowerCase()),y===k?0:y<k?-1:1}function g(y,k,A=!1){const b=y.split(h.sep),v=k.split(h.sep),F=b.length-1,N=v.length-1;let L,M;for(let z=0;;z++){if(L=F===z,M=N===z,L&&M)return T(b[z],v[z],A);if(L)return-1;if(M)return 1;const j=l(b[z],v[z],A);if(j!==0)return j}}function E(y,k,A){const b=y.toLowerCase(),v=k.toLowerCase(),F=D(y,k,A);if(F)return F;const N=b.endsWith(A),L=v.endsWith(A);if(N!==L)return N?-1:1;const M=T(b,v);return M!==0?M:b.localeCompare(v)}function D(y,k,A){const b=y.toLowerCase(),v=k.toLowerCase(),F=b.startsWith(A),N=v.startsWith(A);if(F!==N)return F?-1:1;if(F&&N){if(b.length<v.length)return-1;if(b.length>v.length)return 1}return 0}}),define(ke[103],Ie([1,0,16]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$s=void 0,e.$_s=R,e.$at=O,e.$bt=T,e.$ct=c,e.$$s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const h={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(I){const S=(0,r.$oc)(I),u=h[S.toLowerCase()];return u!==void 0?u:O(I)}function O(I){const S=(0,r.$oc)(I);return C[S.toLowerCase()]}function T(I){for(const S in C)if(C[S]===I)return S}const p=/^(.+)\/(.+?)(;.+)?$/;function c(I,S){const u=p.exec(I);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:S?void 0:I}}),define(ke[104],Ie([1,0,10]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$lm=R,e.$mm=O;var h;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(h||(e.Source=h={}));var C;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(C||(e.TerminateResponseCode=C={}));function R(T,...p){const c=p.reduce((u,P)=>(u[P]=!0,u),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(u=>!c[u]).forEach(u=>{for(let P=0;P<I.length;P++)if(u.search(I[P])!==-1){delete T[u];break}})}function O(T){T&&(delete T.DEBUG,r.$l&&delete T.LD_PRELOAD)}}),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var h in r)(typeof exports=="object"?exports:$e)[h]=r[h]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function r(h){if(e[h])return e[h].exports;var C=e[h]={i:h,l:!1,exports:{}};return $e[h].call(C.exports,C,C.exports,r),C.l=!0,C.exports}return r.m=$e,r.c=e,r.d=function(h,C,R){r.o(h,C)||Object.defineProperty(h,C,{enumerable:!0,get:R})},r.r=function(h){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(h,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(h,"__esModule",{value:!0})},r.t=function(h,C){if(1&C&&(h=r(h)),8&C||4&C&&typeof h=="object"&&h&&h.__esModule)return h;var R=Object.create(null);if(r.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:h}),2&C&&typeof h!="string")for(var O in h)r.d(R,O,function(T){return h[T]}.bind(null,O));return R},r.n=function(h){var C=h&&h.__esModule?function(){return h.default}:function(){return h};return r.d(C,"a",C),C},r.o=function(h,C){return Object.prototype.hasOwnProperty.call(h,C)},r.p="",r(r.s=0)}([function($e,e,r){(function(h){var C;e=$e.exports=ye,C=typeof h=="object"&&h.env&&h.env.NODE_DEBUG&&/\bsemver\b/i.test(h.env.NODE_DEBUG)?function(){var G=Array.prototype.slice.call(arguments,0);G.unshift("SEMVER"),console.log.apply(console,G)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],p=e.src=[],c=0,I=c++;p[I]="0|[1-9]\\d*";var S=c++;p[S]="[0-9]+";var u=c++;p[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=c++;p[P]="("+p[I]+")\\.("+p[I]+")\\.("+p[I]+")";var w=c++;p[w]="("+p[S]+")\\.("+p[S]+")\\.("+p[S]+")";var a=c++;p[a]="(?:"+p[I]+"|"+p[u]+")";var m=c++;p[m]="(?:"+p[S]+"|"+p[u]+")";var $=c++;p[$]="(?:-("+p[a]+"(?:\\."+p[a]+")*))";var f=c++;p[f]="(?:-?("+p[m]+"(?:\\."+p[m]+")*))";var i=c++;p[i]="[0-9A-Za-z-]+";var s=c++;p[s]="(?:\\+("+p[i]+"(?:\\."+p[i]+")*))";var t=c++,o="v?"+p[P]+p[$]+"?"+p[s]+"?";p[t]="^"+o+"$";var n="[v=\\s]*"+p[w]+p[f]+"?"+p[s]+"?",d=c++;p[d]="^"+n+"$";var l=c++;p[l]="((?:<|>)?=?)";var g=c++;p[g]=p[S]+"|x|X|\\*";var E=c++;p[E]=p[I]+"|x|X|\\*";var D=c++;p[D]="[v=\\s]*("+p[E]+")(?:\\.("+p[E]+")(?:\\.("+p[E]+")(?:"+p[$]+")?"+p[s]+"?)?)?";var y=c++;p[y]="[v=\\s]*("+p[g]+")(?:\\.("+p[g]+")(?:\\.("+p[g]+")(?:"+p[f]+")?"+p[s]+"?)?)?";var k=c++;p[k]="^"+p[l]+"\\s*"+p[D]+"$";var A=c++;p[A]="^"+p[l]+"\\s*"+p[y]+"$";var b=c++;p[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=c++;p[v]="(?:~>?)";var F=c++;p[F]="(\\s*)"+p[v]+"\\s+",T[F]=new RegExp(p[F],"g");var N=c++;p[N]="^"+p[v]+p[D]+"$";var L=c++;p[L]="^"+p[v]+p[y]+"$";var M=c++;p[M]="(?:\\^)";var z=c++;p[z]="(\\s*)"+p[M]+"\\s+",T[z]=new RegExp(p[z],"g");var j=c++;p[j]="^"+p[M]+p[D]+"$";var W=c++;p[W]="^"+p[M]+p[y]+"$";var B=c++;p[B]="^"+p[l]+"\\s*("+n+")$|^$";var ee=c++;p[ee]="^"+p[l]+"\\s*("+o+")$|^$";var H=c++;p[H]="(\\s*)"+p[l]+"\\s*("+n+"|"+p[D]+")",T[H]=new RegExp(p[H],"g");var q=c++;p[q]="^\\s*("+p[D]+")\\s+-\\s+("+p[D]+")\\s*$";var Q=c++;p[Q]="^\\s*("+p[y]+")\\s+-\\s+("+p[y]+")\\s*$";var _=c++;p[_]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)C(ce,p[ce]),T[ce]||(T[ce]=new RegExp(p[ce]));function ne(G,J){if(G instanceof ye)return G;if(typeof G!="string"||G.length>R||!(J?T[d]:T[t]).test(G))return null;try{return new ye(G,J)}catch{return null}}function ye(G,J){if(G instanceof ye){if(G.loose===J)return G;G=G.version}else if(typeof G!="string")throw new TypeError("Invalid Version: "+G);if(G.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ye))return new ye(G,J);C("SemVer",G,J),this.loose=J;var x=G.trim().match(J?T[d]:T[t]);if(!x)throw new TypeError("Invalid Version: "+G);if(this.raw=G,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var Ee=+de;if(Ee>=0&&Ee<O)return Ee}return de}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=ne,e.valid=function(G,J){var x=ne(G,J);return x?x.version:null},e.clean=function(G,J){var x=ne(G.trim().replace(/^[=v]+/,""),J);return x?x.version:null},e.SemVer=ye,ye.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ye.prototype.toString=function(){return this.version},ye.prototype.compare=function(G){return C("SemVer.compare",this.version,this.loose,G),G instanceof ye||(G=new ye(G,this.loose)),this.compareMain(G)||this.comparePre(G)},ye.prototype.compareMain=function(G){return G instanceof ye||(G=new ye(G,this.loose)),Y(this.major,G.major)||Y(this.minor,G.minor)||Y(this.patch,G.patch)},ye.prototype.comparePre=function(G){if(G instanceof ye||(G=new ye(G,this.loose)),this.prerelease.length&&!G.prerelease.length)return-1;if(!this.prerelease.length&&G.prerelease.length)return 1;if(!this.prerelease.length&&!G.prerelease.length)return 0;var J=0;do{var x=this.prerelease[J],de=G.prerelease[J];if(C("prerelease compare",J,x,de),x===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(x===void 0)return-1;if(x!==de)return Y(x,de)}while(++J)},ye.prototype.inc=function(G,J){switch(G){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+G)}return this.format(),this.raw=this.version,this},e.inc=function(G,J,x,de){typeof x=="string"&&(de=x,x=void 0);try{return new ye(G,x).inc(J,de).version}catch{return null}},e.diff=function(G,J){if(te(G,J))return null;var x=ne(G),de=ne(J);if(x.prerelease.length||de.prerelease.length){for(var Ee in x)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&x[Ee]!==de[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in x)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&x[Ee]!==de[Ee])return Ee},e.compareIdentifiers=Y;var ge=/^[0-9]+$/;function Y(G,J){var x=ge.test(G),de=ge.test(J);return x&&de&&(G=+G,J=+J),x&&!de?-1:de&&!x?1:G<J?-1:G>J?1:0}function U(G,J,x){return new ye(G,x).compare(new ye(J,x))}function oe(G,J,x){return U(G,J,x)>0}function ve(G,J,x){return U(G,J,x)<0}function te(G,J,x){return U(G,J,x)===0}function ae(G,J,x){return U(G,J,x)!==0}function se(G,J,x){return U(G,J,x)>=0}function X(G,J,x){return U(G,J,x)<=0}function re(G,J,x,de){var Ee;switch(J){case"===":typeof G=="object"&&(G=G.version),typeof x=="object"&&(x=x.version),Ee=G===x;break;case"!==":typeof G=="object"&&(G=G.version),typeof x=="object"&&(x=x.version),Ee=G!==x;break;case"":case"=":case"==":Ee=te(G,x,de);break;case"!=":Ee=ae(G,x,de);break;case">":Ee=oe(G,x,de);break;case">=":Ee=se(G,x,de);break;case"<":Ee=ve(G,x,de);break;case"<=":Ee=X(G,x,de);break;default:throw new TypeError("Invalid operator: "+J)}return Ee}function pe(G,J){if(G instanceof pe){if(G.loose===J)return G;G=G.value}if(!(this instanceof pe))return new pe(G,J);C("comparator",G,J),this.loose=J,this.parse(G),this.semver===we?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(G,J){return Y(J,G)},e.major=function(G,J){return new ye(G,J).major},e.minor=function(G,J){return new ye(G,J).minor},e.patch=function(G,J){return new ye(G,J).patch},e.compare=U,e.compareLoose=function(G,J){return U(G,J,!0)},e.rcompare=function(G,J,x){return U(J,G,x)},e.sort=function(G,J){return G.sort(function(x,de){return e.compare(x,de,J)})},e.rsort=function(G,J){return G.sort(function(x,de){return e.rcompare(x,de,J)})},e.gt=oe,e.lt=ve,e.eq=te,e.neq=ae,e.gte=se,e.lte=X,e.cmp=re,e.Comparator=pe;var we={};function Fe(G,J){if(G instanceof Fe)return G.loose===J?G:new Fe(G.raw,J);if(G instanceof pe)return new Fe(G.value,J);if(!(this instanceof Fe))return new Fe(G,J);if(this.loose=J,this.raw=G,this.set=G.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+G);this.format()}function Be(G){return!G||G.toLowerCase()==="x"||G==="*"}function Re(G,J,x,de,Ee,Le,He,Ze,et,nt,st,rt,at){return((J=Be(x)?"":Be(de)?">="+x+".0.0":Be(Ee)?">="+x+"."+de+".0":">="+J)+" "+(Ze=Be(et)?"":Be(nt)?"<"+(+et+1)+".0.0":Be(st)?"<"+et+"."+(+nt+1)+".0":rt?"<="+et+"."+nt+"."+st+"-"+rt:"<="+Ze)).trim()}function De(G,J){for(var x=0;x<G.length;x++)if(!G[x].test(J))return!1;if(J.prerelease.length){for(x=0;x<G.length;x++)if(C(G[x].semver),G[x].semver!==we&&G[x].semver.prerelease.length>0){var de=G[x].semver;if(de.major===J.major&&de.minor===J.minor&&de.patch===J.patch)return!0}return!1}return!0}function Ce(G,J,x){try{J=new Fe(J,x)}catch{return!1}return J.test(G)}function V(G,J,x,de){var Ee,Le,He,Ze,et;switch(G=new ye(G,de),J=new Fe(J,de),x){case">":Ee=oe,Le=X,He=ve,Ze=">",et=">=";break;case"<":Ee=ve,Le=se,He=oe,Ze="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(G,J,de))return!1;for(var nt=0;nt<J.set.length;++nt){var st=J.set[nt],rt=null,at=null;if(st.forEach(function(gt){gt.semver===we&&(gt=new pe(">=0.0.0")),rt=rt||gt,at=at||gt,Ee(gt.semver,rt.semver,de)?rt=gt:He(gt.semver,at.semver,de)&&(at=gt)}),rt.operator===Ze||rt.operator===et||(!at.operator||at.operator===Ze)&&Le(G,at.semver)||at.operator===et&&He(G,at.semver))return!1}return!0}pe.prototype.parse=function(G){var J=this.loose?T[B]:T[ee],x=G.match(J);if(!x)throw new TypeError("Invalid comparator: "+G);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new ye(x[2],this.loose):this.semver=we},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(G){return C("Comparator.test",G,this.loose),this.semver===we||(typeof G=="string"&&(G=new ye(G,this.loose)),re(G,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(G,J){if(!(G instanceof pe))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new Fe(G.value,J),Ce(this.value,x,J);if(G.operator==="")return x=new Fe(this.value,J),Ce(G.semver,x,J);var de=!(this.operator!==">="&&this.operator!==">"||G.operator!==">="&&G.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||G.operator!=="<="&&G.operator!=="<"),Le=this.semver.version===G.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||G.operator!==">="&&G.operator!=="<="),Ze=re(this.semver,"<",G.semver,J)&&(this.operator===">="||this.operator===">")&&(G.operator==="<="||G.operator==="<"),et=re(this.semver,">",G.semver,J)&&(this.operator==="<="||this.operator==="<")&&(G.operator===">="||G.operator===">");return de||Ee||Le&&He||Ze||et},e.Range=Fe,Fe.prototype.format=function(){return this.range=this.set.map(function(G){return G.join(" ").trim()}).join("||").trim(),this.range},Fe.prototype.toString=function(){return this.range},Fe.prototype.parseRange=function(G){var J=this.loose;G=G.trim(),C("range",G,J);var x=J?T[Q]:T[q];G=G.replace(x,Re),C("hyphen replace",G),G=G.replace(T[H],"$1$2$3"),C("comparator trim",G,T[H]),G=(G=(G=G.replace(T[F],"$1~")).replace(T[z],"$1^")).split(/\s+/).join(" ");var de=J?T[B]:T[ee],Ee=G.split(" ").map(function(Le){return function(He,Ze){return C("comp",He),He=function(et,nt){return et.trim().split(/\s+/).map(function(st){return function(rt,at){C("caret",rt,at);var gt=at?T[W]:T[j];return rt.replace(gt,function(dt,ct,Pe,ze,Ke){var Ne;return C("caret",rt,dt,ct,Pe,ze,Ke),Be(ct)?Ne="":Be(Pe)?Ne=">="+ct+".0.0 <"+(+ct+1)+".0.0":Be(ze)?Ne=ct==="0"?">="+ct+"."+Pe+".0 <"+ct+"."+(+Pe+1)+".0":">="+ct+"."+Pe+".0 <"+(+ct+1)+".0.0":Ke?(C("replaceCaret pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),Ne=ct==="0"?Pe==="0"?">="+ct+"."+Pe+"."+ze+Ke+" <"+ct+"."+Pe+"."+(+ze+1):">="+ct+"."+Pe+"."+ze+Ke+" <"+ct+"."+(+Pe+1)+".0":">="+ct+"."+Pe+"."+ze+Ke+" <"+(+ct+1)+".0.0"):(C("no pr"),Ne=ct==="0"?Pe==="0"?">="+ct+"."+Pe+"."+ze+" <"+ct+"."+Pe+"."+(+ze+1):">="+ct+"."+Pe+"."+ze+" <"+ct+"."+(+Pe+1)+".0":">="+ct+"."+Pe+"."+ze+" <"+(+ct+1)+".0.0"),C("caret return",Ne),Ne})}(st,nt)}).join(" ")}(He,Ze),C("caret",He),He=function(et,nt){return et.trim().split(/\s+/).map(function(st){return function(rt,at){var gt=at?T[L]:T[N];return rt.replace(gt,function(dt,ct,Pe,ze,Ke){var Ne;return C("tilde",rt,dt,ct,Pe,ze,Ke),Be(ct)?Ne="":Be(Pe)?Ne=">="+ct+".0.0 <"+(+ct+1)+".0.0":Be(ze)?Ne=">="+ct+"."+Pe+".0 <"+ct+"."+(+Pe+1)+".0":Ke?(C("replaceTilde pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),Ne=">="+ct+"."+Pe+"."+ze+Ke+" <"+ct+"."+(+Pe+1)+".0"):Ne=">="+ct+"."+Pe+"."+ze+" <"+ct+"."+(+Pe+1)+".0",C("tilde return",Ne),Ne})}(st,nt)}).join(" ")}(He,Ze),C("tildes",He),He=function(et,nt){return C("replaceXRanges",et,nt),et.split(/\s+/).map(function(st){return function(rt,at){rt=rt.trim();var gt=at?T[A]:T[k];return rt.replace(gt,function(dt,ct,Pe,ze,Ke,Ne){C("xRange",rt,dt,ct,Pe,ze,Ke,Ne);var je=Be(Pe),ue=je||Be(ze),he=ue||Be(Ke);return ct==="="&&he&&(ct=""),je?dt=ct===">"||ct==="<"?"<0.0.0":"*":ct&&he?(ue&&(ze=0),he&&(Ke=0),ct===">"?(ct=">=",ue?(Pe=+Pe+1,ze=0,Ke=0):he&&(ze=+ze+1,Ke=0)):ct==="<="&&(ct="<",ue?Pe=+Pe+1:ze=+ze+1),dt=ct+Pe+"."+ze+"."+Ke):ue?dt=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":he&&(dt=">="+Pe+"."+ze+".0 <"+Pe+"."+(+ze+1)+".0"),C("xRange return",dt),dt})}(st,nt)}).join(" ")}(He,Ze),C("xrange",He),He=function(et,nt){return C("replaceStars",et,nt),et.trim().replace(T[_],"")}(He,Ze),C("stars",He),He}(Le,J)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(Le){return!!Le.match(de)})),Ee=Ee.map(function(Le){return new pe(Le,J)})},Fe.prototype.intersects=function(G,J){if(!(G instanceof Fe))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function(de){return G.set.some(function(Ee){return Ee.every(function(Le){return de.intersects(Le,J)})})})})},e.toComparators=function(G,J){return new Fe(G,J).set.map(function(x){return x.map(function(de){return de.value}).join(" ").trim().split(" ")})},Fe.prototype.test=function(G){if(!G)return!1;typeof G=="string"&&(G=new ye(G,this.loose));for(var J=0;J<this.set.length;J++)if(De(this.set[J],G))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(G,J,x){var de=null,Ee=null;try{var Le=new Fe(J,x)}catch{return null}return G.forEach(function(He){Le.test(He)&&(de&&Ee.compare(He)!==-1||(Ee=new ye(de=He,x)))}),de},e.minSatisfying=function(G,J,x){var de=null,Ee=null;try{var Le=new Fe(J,x)}catch{return null}return G.forEach(function(He){Le.test(He)&&(de&&Ee.compare(He)!==1||(Ee=new ye(de=He,x)))}),de},e.validRange=function(G,J){try{return new Fe(G,J).range||"*"}catch{return null}},e.ltr=function(G,J,x){return V(G,J,"<",x)},e.gtr=function(G,J,x){return V(G,J,">",x)},e.outside=V,e.prerelease=function(G,J){var x=ne(G,J);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(G,J,x){return G=new Fe(G,x),J=new Fe(J,x),G.intersects(J)},e.coerce=function(G){if(G instanceof ye)return G;if(typeof G!="string")return null;var J=G.match(T[b]);return J==null?null:ne((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,r(1))},function($e,e){var r,h,C=$e.exports={};function R(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function T(m){if(r===setTimeout)return setTimeout(m,0);if((r===R||!r)&&setTimeout)return r=setTimeout,setTimeout(m,0);try{return r(m,0)}catch{try{return r.call(null,m,0)}catch{return r.call(this,m,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:R}catch{r=R}try{h=typeof clearTimeout=="function"?clearTimeout:O}catch{h=O}})();var p,c=[],I=!1,S=-1;function u(){I&&p&&(I=!1,p.length?c=p.concat(c):S=-1,c.length&&P())}function P(){if(!I){var m=T(u);I=!0;for(var $=c.length;$;){for(p=c,c=[];++S<$;)p&&p[S].run();S=-1,$=c.length}p=null,I=!1,function(f){if(h===clearTimeout)return clearTimeout(f);if((h===O||!h)&&clearTimeout)return h=clearTimeout,clearTimeout(f);try{h(f)}catch{try{return h.call(null,f)}catch{return h.call(this,f)}}}(m)}}function w(m,$){this.fun=m,this.array=$}function a(){}C.nextTick=function(m){var $=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)$[f-1]=arguments[f];c.push(new w(m,$)),c.length!==1||I||T(P)},w.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=a,C.addListener=a,C.once=a,C.off=a,C.removeListener=a,C.removeAllListeners=a,C.emit=a,C.prependListener=a,C.prependOnceListener=a,C.listeners=function(m){return[]},C.binding=function(m){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(m){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(ke[42],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class h{static create(R){return new h(R)}constructor(R){this.c=r&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$fe=h}),define(ke[4],Ie([1,0,13,79,3,80,42]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$he=e.Event=void 0,e.$ie=P;const T=!1,p=!1,c=!1;var I;(function(L){L.None=()=>C.$Uc.None;function M(De){if(c){const{onDidAddListener:Ce}=De,V=a.create();let G=0;De.onDidAddListener=()=>{++G===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),Ce?.()}}}function z(De,Ce){return ne(De,()=>{},0,void 0,!0,void 0,Ce)}L.defer=z;function j(De){return(Ce,V=null,G)=>{let J=!1,x;return x=De(de=>{if(!J)return x?x.dispose():J=!0,Ce.call(V,de)},null,G),J&&x.dispose(),x}}L.once=j;function W(De,Ce,V){return _((G,J=null,x)=>De(de=>G.call(J,Ce(de)),null,x),V)}L.map=W;function B(De,Ce,V){return _((G,J=null,x)=>De(de=>{Ce(de),G.call(J,de)},null,x),V)}L.forEach=B;function ee(De,Ce,V){return _((G,J=null,x)=>De(de=>Ce(de)&&G.call(J,de),null,x),V)}L.filter=ee;function H(De){return De}L.signal=H;function q(...De){return(Ce,V=null,G)=>{const J=(0,C.$Rc)(...De.map(x=>x(de=>Ce.call(V,de))));return ce(J,G)}}L.any=q;function Q(De,Ce,V,G){let J=V;return W(De,x=>(J=Ce(J,x),J),G)}L.reduce=Q;function _(De,Ce){let V;const G={onWillAddFirstListener(){V=De(J.fire,J)},onDidRemoveLastListener(){V?.dispose()}};Ce||M(G);const J=new n(G);return Ce?.add(J),J.event}function ce(De,Ce){return Ce instanceof Array?Ce.push(De):Ce&&Ce.add(De),De}function ne(De,Ce,V=100,G=!1,J=!1,x,de){let Ee,Le,He,Ze=0,et;const nt={leakWarningThreshold:x,onWillAddFirstListener(){Ee=De(rt=>{Ze++,Le=Ce(Le,rt),G&&!He&&(st.fire(Le),Le=void 0),et=()=>{const at=Le;Le=void 0,He=void 0,(!G||Ze>1)&&st.fire(at),Ze=0},typeof V=="number"?(clearTimeout(He),He=setTimeout(et,V)):He===void 0&&(He=0,queueMicrotask(et))})},onWillRemoveListener(){J&&Ze>0&&et?.()},onDidRemoveLastListener(){et=void 0,Ee.dispose()}};de||M(nt);const st=new n(nt);return de?.add(st),st.event}L.debounce=ne;function ye(De,Ce=0,V){return L.debounce(De,(G,J)=>G?(G.push(J),G):[J],Ce,void 0,!0,void 0,V)}L.accumulate=ye;function ge(De,Ce=(G,J)=>G===J,V){let G=!0,J;return ee(De,x=>{const de=G||!Ce(x,J);return G=!1,J=x,de},V)}L.latch=ge;function Y(De,Ce,V){return[L.filter(De,Ce,V),L.filter(De,G=>!Ce(G),V)]}L.split=Y;function U(De,Ce=!1,V=[],G){let J=V.slice(),x=De(Le=>{J?J.push(Le):Ee.fire(Le)});G&&G.add(x);const de=()=>{J?.forEach(Le=>Ee.fire(Le)),J=null},Ee=new n({onWillAddFirstListener(){x||(x=De(Le=>Ee.fire(Le)),G&&G.add(x))},onDidAddFirstListener(){J&&(Ce?setTimeout(de):de())},onDidRemoveLastListener(){x&&x.dispose(),x=null}});return G&&G.add(Ee),Ee.event}L.buffer=U;function oe(De,Ce){return(G,J,x)=>{const de=Ce(new te);return De(function(Ee){const Le=de.evaluate(Ee);Le!==ve&&G.call(J,Le)},void 0,x)}}L.chain=oe;const ve=Symbol("HaltChainable");class te{constructor(){this.f=[]}map(Ce){return this.f.push(Ce),this}forEach(Ce){return this.f.push(V=>(Ce(V),V)),this}filter(Ce){return this.f.push(V=>Ce(V)?V:ve),this}reduce(Ce,V){let G=V;return this.f.push(J=>(G=Ce(G,J),G)),this}latch(Ce=(V,G)=>V===G){let V=!0,G;return this.f.push(J=>{const x=V||!Ce(J,G);return V=!1,G=J,x?J:ve}),this}evaluate(Ce){for(const V of this.f)if(Ce=V(Ce),Ce===ve)break;return Ce}}function ae(De,Ce,V=G=>G){const G=(...Ee)=>de.fire(V(...Ee)),J=()=>De.on(Ce,G),x=()=>De.removeListener(Ce,G),de=new n({onWillAddFirstListener:J,onDidRemoveLastListener:x});return de.event}L.fromNodeEventEmitter=ae;function se(De,Ce,V=G=>G){const G=(...Ee)=>de.fire(V(...Ee)),J=()=>De.addEventListener(Ce,G),x=()=>De.removeEventListener(Ce,G),de=new n({onWillAddFirstListener:J,onDidRemoveLastListener:x});return de.event}L.fromDOMEventEmitter=se;function X(De){return new Promise(Ce=>j(De)(Ce))}L.toPromise=X;function re(De){const Ce=new n;return De.then(V=>{Ce.fire(V)},()=>{Ce.fire(void 0)}).finally(()=>{Ce.dispose()}),Ce.event}L.fromPromise=re;function pe(De,Ce){return De(V=>Ce.fire(V))}L.forward=pe;function we(De,Ce,V){return Ce(V),De(G=>Ce(G))}L.runAndSubscribe=we;class Fe{constructor(Ce,V){this._observable=Ce,this.f=0,this.g=!1;const G={onWillAddFirstListener:()=>{Ce.addObserver(this)},onDidRemoveLastListener:()=>{Ce.removeObserver(this)}};V||M(G),this.emitter=new n(G),V&&V.add(this.emitter)}beginUpdate(Ce){this.f++}handlePossibleChange(Ce){}handleChange(Ce,V){this.g=!0}endUpdate(Ce){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Be(De,Ce){return new Fe(De,Ce).emitter.event}L.fromObservable=Be;function Re(De){return(Ce,V,G)=>{let J=0,x=!1;const de={beginUpdate(){J++},endUpdate(){J--,J===0&&(De.reportChanges(),x&&(x=!1,Ce.call(V)))},handlePossibleChange(){},handleChange(){x=!0}};De.addObserver(de),De.reportChanges();const Ee={dispose(){De.removeObserver(de)}};return G instanceof C.$Tc?G.add(Ee):Array.isArray(G)&&G.push(Ee),Ee}}L.fromObservableLight=Re})(I||(e.Event=I={}));class S{static{this.all=new Set}static{this.f=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${S.f++}`,S.all.add(this)}start(M){this.g=new O.$fe,this.listenerCount=M}stop(){if(this.g){const M=this.g.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this.g=void 0}}}e.$he=S;let u=-1;function P(L){const M=u;return u=L,{dispose(){u=M}}}class w{static{this.f=1}constructor(M,z,j=(w.f++).toString(16).padStart(3,"0")){this.j=M,this.threshold=z,this.name=j,this.h=0}dispose(){this.g?.clear()}check(M,z){const j=this.threshold;if(j<=0||z<j)return;this.g||(this.g=new Map);const W=this.g.get(M.value)||0;if(this.g.set(M.value,W+1),this.h-=1,this.h<=0){this.h=j*.5;const[B,ee]=this.getMostFrequentStack(),H=`[${this.name}] potential listener LEAK detected, having ${z} listeners already. MOST frequent listener (${ee}):`;console.warn(H),console.warn(B);const q=new m(H,B);this.j(q)}return()=>{const B=this.g.get(M.value)||0;this.g.set(M.value,B-1)}}getMostFrequentStack(){if(!this.g)return;let M,z=0;for(const[j,W]of this.g)(!M||z<W)&&(M=[j,W],z=W);return M}}class a{static create(){const M=new Error;return new a(M.stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m extends Error{constructor(M,z){super(M),this.name="ListenerLeakError",this.stack=z}}e.$je=m;class $ extends Error{constructor(M,z){super(M),this.name="ListenerRefusalError",this.stack=z}}e.$ke=$;let f=0;class i{constructor(M){this.value=M,this.id=f++}}const s=2,t=(L,M)=>{if(L instanceof i)M(L);else for(let z=0;z<L.length;z++){const j=L[z];j&&M(j)}};let o;if(T){const L=[];setInterval(()=>{L.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(L.join(`
`)),L.length=0)},3e3),o=new FinalizationRegistry(M=>{typeof M=="string"&&L.push(M)})}class n{constructor(M){this.z=0,this.f=M,this.g=u>0||this.f?.leakWarningThreshold?new w(M?.onListenerError??r.$Y,this.f?.leakWarningThreshold??u):void 0,this.j=this.f?._profName?new S(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(p){const M=this.u;queueMicrotask(()=>{t(M,z=>z.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(M,z,j)=>{if(this.g&&this.z>this.g.threshold**2){const q=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(q);const Q=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],_=new $(`${q}. HINT: Stack shows most frequent listener (${Q[1]}-times)`,Q[0]);return(this.f?.onListenerError||r.$Y)(_),C.$Uc.None}if(this.m)return C.$Uc.None;z&&(M=M.bind(z));const W=new i(M);let B,ee;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(W.stack=a.create(),B=this.g.check(W.stack,this.z+1)),p&&(W.stack=ee??a.create()),this.u?this.u instanceof i?(this.w??=new l,this.u=[this.u,W]):this.u.push(W):(this.f?.onWillAddFirstListener?.(this),this.u=W,this.f?.onDidAddFirstListener?.(this)),this.z++;const H=(0,C.$Sc)(()=>{o?.unregister(H),B?.(),this.A(W)});if(j instanceof C.$Tc?j.add(H):Array.isArray(j)&&j.push(H),o){const q=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),Q=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(q);o.register(H,Q?.[2]??q,H)}return H},this.q}A(M){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const z=this.u,j=z.indexOf(M);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,z[j]=void 0;const W=this.w.current===this;if(this.z*s<=z.length){let B=0;for(let ee=0;ee<z.length;ee++)z[ee]?z[B++]=z[ee]:W&&(this.w.end--,B<this.w.i&&this.w.i--);z.length=B}}B(M,z){if(!M)return;const j=this.f?.onListenerError||r.$Y;if(!j){M.value(z);return}try{M.value(z)}catch(W){j(W)}}C(M){const z=M.current.u;for(;M.i<M.end;)this.B(z[M.i++],M.value);M.reset()}fire(M){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof i)this.B(this.u,M);else{const z=this.w;z.enqueue(this,M,this.u.length),this.C(z)}this.j?.stop()}hasListeners(){return this.z>0}}e.$le=n;const d=()=>new l;e.$me=d;class l{constructor(){this.i=-1,this.end=0}enqueue(M,z,j){this.i=0,this.end=j,this.current=M,this.value=z}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class g extends n{async fireAsync(M,z,j){if(this.u)for(this.h||(this.h=new R.$5c),t(this.u,W=>this.h.push([W.value,M]));this.h.size>0&&!z.isCancellationRequested;){const[W,B]=this.h.shift(),ee=[],H={...B,token:z,waitUntil:q=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");j&&(q=j(q,W)),ee.push(q)}};try{W(H)}catch(q){(0,r.$Y)(q);continue}Object.freeze(ee),await Promise.allSettled(ee).then(q=>{for(const Q of q)Q.status==="rejected"&&(0,r.$Y)(Q.reason)})}}}e.$ne=g;class E extends n{get isPaused(){return this.h!==0}constructor(M){super(M),this.h=0,this.s=new R.$5c,this.t=M?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const M=Array.from(this.s);this.s.clear(),super.fire(this.t(M))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(M){this.z&&(this.h!==0?this.s.push(M):super.fire(M))}}e.$oe=E;class D extends E{constructor(M){super(M),this.k=M.delay??100}fire(M){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(M)}}e.$pe=D;class y extends n{constructor(M){super(M),this.h=[],this.k=M?.merge}fire(M){this.hasListeners()&&(this.h.push(M),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(z=>super.fire(z)),this.h=[]}))}}e.$qe=y;class k{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(M){const z={event:M,listener:null};this.h.push(z),this.g&&this.m(z);const j=()=>{this.g&&this.o(z);const W=this.h.indexOf(z);this.h.splice(W,1)};return(0,C.$Sc)((0,h.$cb)(j))}j(){this.g=!0,this.h.forEach(M=>this.m(M))}k(){this.g=!1,this.h.forEach(M=>this.o(M))}m(M){M.listener=M.event(z=>this.f.fire(z))}o(M){M.listener?.dispose(),M.listener=null}dispose(){this.f.dispose();for(const M of this.h)M.listener?.dispose();this.h=[]}}e.$re=k;class A{constructor(M,z,j,W){this.f=new C.$Tc;const B=this.f.add(new k),ee=this.f.add(new C.$4c);function H(q){ee.set(q,B.add(W(q)))}for(const q of M)H(q);this.f.add(z(q=>{H(q)})),this.f.add(j(q=>{ee.deleteAndDispose(q)})),this.event=B.event}dispose(){this.f.dispose()}}e.$se=A;class b{constructor(){this.f=[]}wrapEvent(M,z,j){return(W,B,ee)=>M(H=>{const q=this.f[this.f.length-1];if(!z){q?q.buffers.push(()=>W.call(B,H)):W.call(B,H);return}const Q=q;if(!Q){W.call(B,z(j,H));return}Q.items??=[],Q.items.push(H),Q.buffers.length===0&&q.buffers.push(()=>{Q.reducedResult??=j?Q.items.reduce(z,j):Q.items.reduce(z),W.call(B,Q.reducedResult)})},void 0,ee)}bufferEvents(M){const z={buffers:new Array};this.f.push(z);const j=M();return this.f.pop(),z.buffers.forEach(W=>W()),j}}e.$te=b;class v{constructor(){this.f=!1,this.g=I.None,this.h=C.$Uc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(M){this.g=M,this.f&&(this.h.dispose(),this.h=M(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ue=v;class F{static const(M){return new N(M)}constructor(M){this.g=M,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(M){M!==this.g&&(this.g=M,this.f.fire(void 0))}}e.$ve=F;class N{constructor(M){this.value=M,this.onDidChange=I.None}}}),define(ke[20],Ie([1,0,4]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.CancellationToken=void 0,e.$xe=T;const h=Object.freeze(function(p,c){const I=setTimeout(p.bind(c),0);return{dispose(){clearTimeout(I)}}});var C;(function(p){function c(I){return I===p.None||I===p.Cancelled||I instanceof R?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}p.isCancellationToken=c,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:h})})(C||(e.CancellationToken=C={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?h:(this.b||(this.b=new r.$le),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=C.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=C.None}}e.$we=O;function T(p){const c=new O;return p.add({dispose(){c.cancel()}}),c.token}}),define(ke[184],Ie([1,0,20]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_e=e.$$e=e.$9e=void 0,e.$0e=C;class h{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new r.$we,c=this.b(p.token);return this.a={promise:c,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$9e=h;function C(T){return T}class R{constructor(p,c){this.a=void 0,this.b=void 0,typeof p=="function"?(this.c=p,this.d=C):(this.c=c,this.d=p.getCacheKey)}get(p){const c=this.d(p);return this.b!==c&&(this.b=c,this.a=this.c(p)),this.a}}e.$$e=R;class O{get cachedValues(){return this.a}constructor(p,c){this.a=new Map,this.b=new Map,typeof p=="function"?(this.c=p,this.d=C):(this.c=c,this.d=p.getCacheKey)}get(p){const c=this.d(p);if(this.b.has(c))return this.b.get(c);const I=this.c(p);return this.a.set(p,I),this.b.set(c,I),I}}e.$_e=O}),define(ke[185],Ie([1,0,4,3]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.$ft=e.$et=e.$dt=e.ScrollbarVisibility=void 0;var C;(function(P){P[P.Auto=1]="Auto",P[P.Hidden=2]="Hidden",P[P.Visible=3]="Visible"})(C||(e.ScrollbarVisibility=C={}));class R{constructor(w,a,m,$,f,i,s){this.c=w,this._scrollStateBrand=void 0,this.c&&(a=a|0,m=m|0,$=$|0,f=f|0,i=i|0,s=s|0),this.rawScrollLeft=$,this.rawScrollTop=s,a<0&&(a=0),$+a>m&&($=m-a),$<0&&($=0),f<0&&(f=0),s+f>i&&(s=i-f),s<0&&(s=0),this.width=a,this.scrollWidth=m,this.scrollLeft=$,this.height=f,this.scrollHeight=i,this.scrollTop=s}equals(w){return this.rawScrollLeft===w.rawScrollLeft&&this.rawScrollTop===w.rawScrollTop&&this.width===w.width&&this.scrollWidth===w.scrollWidth&&this.scrollLeft===w.scrollLeft&&this.height===w.height&&this.scrollHeight===w.scrollHeight&&this.scrollTop===w.scrollTop}withScrollDimensions(w,a){return new R(this.c,typeof w.width<"u"?w.width:this.width,typeof w.scrollWidth<"u"?w.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof w.height<"u"?w.height:this.height,typeof w.scrollHeight<"u"?w.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(w){return new R(this.c,this.width,this.scrollWidth,typeof w.scrollLeft<"u"?w.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof w.scrollTop<"u"?w.scrollTop:this.rawScrollTop)}createScrollEvent(w,a){const m=this.width!==w.width,$=this.scrollWidth!==w.scrollWidth,f=this.scrollLeft!==w.scrollLeft,i=this.height!==w.height,s=this.scrollHeight!==w.scrollHeight,t=this.scrollTop!==w.scrollTop;return{inSmoothScrolling:a,oldWidth:w.width,oldScrollWidth:w.scrollWidth,oldScrollLeft:w.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:w.height,oldScrollHeight:w.scrollHeight,oldScrollTop:w.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:m,scrollWidthChanged:$,scrollLeftChanged:f,heightChanged:i,scrollHeightChanged:s,scrollTopChanged:t}}}e.$dt=R;class O extends h.$Uc{constructor(w){super(),this._scrollableBrand=void 0,this.j=this.B(new r.$le),this.onScroll=this.j.event,this.c=w.smoothScrollDuration,this.f=w.scheduleAtNextAnimationFrame,this.g=new R(w.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(w){this.c=w}validateScrollPosition(w){return this.g.withScrollPosition(w)}getScrollDimensions(){return this.g}setScrollDimensions(w,a){const m=this.g.withScrollDimensions(w,a);this.n(m,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(w){const a=this.g.withScrollPosition(w);this.h&&(this.h.dispose(),this.h=null),this.n(a,!1)}setScrollPositionSmooth(w,a){if(this.c===0)return this.setScrollPositionNow(w);if(this.h){w={scrollLeft:typeof w.scrollLeft>"u"?this.h.to.scrollLeft:w.scrollLeft,scrollTop:typeof w.scrollTop>"u"?this.h.to.scrollTop:w.scrollTop};const m=this.g.withScrollPosition(w);if(this.h.to.scrollLeft===m.scrollLeft&&this.h.to.scrollTop===m.scrollTop)return;let $;a?$=new I(this.h.from,m,this.h.startTime,this.h.duration):$=this.h.combine(this.g,m,this.c),this.h.dispose(),this.h=$}else{const m=this.g.withScrollPosition(w);this.h=I.start(this.g,m,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const w=this.h.tick(),a=this.g.withScrollPosition(w);if(this.n(a,!0),!!this.h){if(w.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(w,a){const m=this.g;m.equals(w)||(this.g=w,this.j.fire(this.g.createScrollEvent(m,a)))}}e.$et=O;class T{constructor(w,a,m){this.scrollLeft=w,this.scrollTop=a,this.isDone=m}}e.$ft=T;function p(P,w){const a=w-P;return function(m){return P+a*u(m)}}function c(P,w,a){return function(m){return m<a?P(m/a):w((m-a)/(1-a))}}class I{constructor(w,a,m,$){this.from=w,this.to=a,this.duration=$,this.startTime=m,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(w,a,m){if(Math.abs(w-a)>2.5*m){let f,i;return w<a?(f=w+.75*m,i=a-.75*m):(f=w-.75*m,i=a+.75*m),c(p(w,f),p(i,a),.33)}return p(w,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(w){this.to=w.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(w){const a=(w-this.startTime)/this.duration;if(a<1){const m=this.c(a),$=this.d(a);return new T(m,$,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(w,a,m){return I.start(w,a,m)}static start(w,a,m){m=m+10;const $=Date.now()-10;return new I(w,a,$,m)}}e.$gt=I;function S(P){return Math.pow(P,3)}function u(P){return 1-S(1-P)}}),define(ke[105],Ie([1,0,13,3]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=C,e.$ze=R,e.$Ae=O,e.$Be=T,e.$Ce=c,e.$De=I,e.$Ee=S,e.$Fe=u,e.$Ge=P,e.$He=w,e.$Ie=a,e.$Je=m,e.$Ke=$,e.$Le=f,e.$Me=i;function C(s){const t=s;return t?typeof t.read=="function":!1}function R(s){const t=s;return t?[t.on,t.pause,t.resume,t.destroy].every(o=>typeof o=="function"):!1}function O(s){const t=s;return t?R(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function T(s,t){return new p(s,t)}class p{constructor(t,o){this.e=t,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(o=>o(t))}h(t){this.c.error.length===0?(0,r.$Y)(t):this.c.error.slice(0).forEach(o=>o(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,o){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(t,o){if(this.a.destroyed)return;let n;switch(t){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const d=n.indexOf(o);d>=0&&n.splice(d,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(s,t){const o=[];let n;for(;(n=s.read())!==null;)o.push(n);return t(o)}function I(s,t,o){const n=[];let d;for(;(d=s.read())!==null&&n.length<o;)n.push(d);return d===null&&n.length>0?t(n):{read:()=>{if(n.length>0)return n.shift();if(typeof d<"u"){const l=d;return d=void 0,l}return s.read()}}}function S(s,t){return new Promise((o,n)=>{const d=[];u(s,{onData:l=>{t&&d.push(l)},onError:l=>{t?n(l):o(void 0)},onEnd:()=>{o(t?t(d):void 0)}})})}function u(s,t,o){s.on("error",n=>{o?.isCancellationRequested||t.onError(n)}),s.on("end",()=>{o?.isCancellationRequested||t.onEnd()}),s.on("data",n=>{o?.isCancellationRequested||t.onData(n)})}function P(s,t){return new Promise((o,n)=>{const d=new h.$Tc,l=[],g=y=>{if(l.push(y),l.length>t)return d.dispose(),s.pause(),o({stream:s,buffer:l,ended:!1})},E=y=>(d.dispose(),n(y)),D=()=>(d.dispose(),o({stream:s,buffer:l,ended:!0}));d.add((0,h.$Sc)(()=>s.removeListener("error",E))),s.on("error",E),d.add((0,h.$Sc)(()=>s.removeListener("end",D))),s.on("end",D),d.add((0,h.$Sc)(()=>s.removeListener("data",g))),s.on("data",g)})}function w(s,t){const o=T(t);return o.end(s),o}function a(){const s=T(()=>{throw new Error("not supported")});return s.end(),s}function m(s){let t=!1;return{read:()=>t?null:(t=!0,s)}}function $(s,t,o){const n=T(o);return u(s,{onData:d=>n.write(t.data(d)),onError:d=>n.error(t.error?t.error(d):d),onEnd:()=>n.end()}),n}function f(s,t,o){let n=!1;return{read:()=>{const d=t.read();return n?d:(n=!0,d!==null?o([s,d]):s)}}}function i(s,t,o){let n=!1;const d=T(o);return u(t,{onData:l=>n?d.write(l):(n=!0,d.write(o([s,l]))),onError:l=>d.error(l),onEnd:()=>{n||(n=!0,d.write(s)),d.end()}}),d}}),define(ke[21],Ie([1,0,50,105]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=void 0,e.$Oe=c,e.$Pe=I,e.$Qe=S,e.$Re=u,e.$Se=P,e.$Te=w,e.$Ue=a,e.$Ve=m,e.$We=$,e.$Xe=f,e.$Ye=i,e.$Ze=s,e.$1e=t,e.$2e=o,e.$3e=n,e.$4e=d,e.$5e=l,e.$6e=g,e.$7e=E,e.$8e=k,h=qe(h);const C=typeof Buffer<"u",R=new r.$T(()=>new Uint8Array(256));let O,T;class p{static alloc(b){return C?new p(Buffer.allocUnsafe(b)):new p(new Uint8Array(b))}static wrap(b){return C&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new p(b)}static fromString(b,v){return!(v?.dontUseNodeBuffer||!1)&&C?new p(Buffer.from(b)):(O||(O=new TextEncoder),new p(O.encode(b)))}static fromByteArray(b){const v=p.alloc(b.length);for(let F=0,N=b.length;F<N;F++)v.buffer[F]=b[F];return v}static concat(b,v){if(typeof v>"u"){v=0;for(let L=0,M=b.length;L<M;L++)v+=b[L].byteLength}const F=p.alloc(v);let N=0;for(let L=0,M=b.length;L<M;L++){const z=b[L];F.set(z,N),N+=z.byteLength}return F}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=p.alloc(this.byteLength);return b.set(this),b}toString(){return C?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(b,v){return new p(this.buffer.subarray(b,v))}set(b,v){if(b instanceof p)this.buffer.set(b.buffer,v);else if(b instanceof Uint8Array)this.buffer.set(b,v);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),v);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return u(this.buffer,b)}writeUInt32BE(b,v){P(this.buffer,b,v)}readUInt32LE(b){return w(this.buffer,b)}writeUInt32LE(b,v){a(this.buffer,b,v)}readUInt8(b){return m(this.buffer,b)}writeUInt8(b,v){$(this.buffer,b,v)}indexOf(b,v=0){return c(this.buffer,b instanceof p?b.buffer:b,v)}}e.$Ne=p;function c(A,b,v=0){const F=b.byteLength,N=A.byteLength;if(F===0)return 0;if(F===1)return A.indexOf(b[0]);if(F>N-v)return-1;const L=R.value;L.fill(b.length);for(let W=0;W<b.length;W++)L[b[W]]=b.length-W-1;let M=v+b.length-1,z=M,j=-1;for(;M<N;)if(A[M]===b[z]){if(z===0){j=M;break}M--,z--}else M+=Math.max(b.length-z,L[A[M]]),z=b.length-1;return j}function I(A,b){return A[b+0]<<0>>>0|A[b+1]<<8>>>0}function S(A,b,v){A[v+0]=b&255,b=b>>>8,A[v+1]=b&255}function u(A,b){return A[b]*2**24+A[b+1]*2**16+A[b+2]*2**8+A[b+3]}function P(A,b,v){A[v+3]=b,b=b>>>8,A[v+2]=b,b=b>>>8,A[v+1]=b,b=b>>>8,A[v]=b}function w(A,b){return A[b+0]<<0>>>0|A[b+1]<<8>>>0|A[b+2]<<16>>>0|A[b+3]<<24>>>0}function a(A,b,v){A[v+0]=b&255,b=b>>>8,A[v+1]=b&255,b=b>>>8,A[v+2]=b&255,b=b>>>8,A[v+3]=b&255}function m(A,b){return A[b]}function $(A,b,v){A[v]=b}function f(A){return h.$Ce(A,b=>p.concat(b))}function i(A){return h.$Je(A)}function s(A){return h.$Ee(A,b=>p.concat(b))}async function t(A){return A.ended?p.concat(A.buffer):p.concat([...A.buffer,await s(A.stream)])}function o(A){return h.$He(A,b=>p.concat(b))}function n(A){return h.$Ke(A,{data:b=>typeof b=="string"?p.fromString(b):p.wrap(b)},b=>p.concat(b))}function d(A){return h.$Be(b=>p.concat(b),A)}function l(A,b){return h.$Le(A,b,v=>p.concat(v))}function g(A,b){return h.$Me(A,b,v=>p.concat(v))}function E(A){let b=0,v=0,F=0;const N=new Uint8Array(Math.floor(A.length/4*3)),L=z=>{switch(v){case 3:N[F++]=b|z,v=0;break;case 2:N[F++]=b|z>>>2,b=z<<6,v=3;break;case 1:N[F++]=b|z>>>4,b=z<<4,v=2;break;default:b=z<<2,v=1}};for(let z=0;z<A.length;z++){const j=A.charCodeAt(z);if(j>=65&&j<=90)L(j-65);else if(j>=97&&j<=122)L(j-97+26);else if(j>=48&&j<=57)L(j-48+52);else if(j===43||j===45)L(62);else if(j===47||j===95)L(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${A[z]}`)}}const M=F;for(;v>0;)L(0);return p.wrap(N).slice(0,M)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:A},b=!0,v=!1){const F=v?y:D;let N="";const L=A.byteLength%3;let M=0;for(;M<A.byteLength-L;M+=3){const z=A[M+0],j=A[M+1],W=A[M+2];N+=F[z>>>2],N+=F[(z<<4|j>>>4)&63],N+=F[(j<<2|W>>>6)&63],N+=F[W&63]}if(L===1){const z=A[M+0];N+=F[z>>>2],N+=F[z<<4&63],b&&(N+="==")}else if(L===2){const z=A[M+0],j=A[M+1];N+=F[z>>>2],N+=F[(z<<4|j>>>4)&63],N+=F[j<<2&63],b&&(N+="=")}return N}}),define(ke[186],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0,e.$ge=Symbol("MicrotaskDelay")}),define(ke[17],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=r,e.$fg=h,e.$gg=C,e.$hg=R,e.$ig=O,e.$jg=T,e.$kg=p,e.$lg=c,e.$mg=I,e.$ng=S,e.$og=u,e.$pg=P,e.$qg=w,e.$rg=m,e.$sg=$,e.$tg=f,e.$ug=i,e.$vg=s,e.$wg=t;function r(o){return typeof o=="string"}function h(o){return Array.isArray(o)&&o.every(n=>r(n))}function C(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function R(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}function O(o){return typeof o=="number"&&!isNaN(o)}function T(o){return!!o&&typeof o[Symbol.iterator]=="function"}function p(o){return o===!0||o===!1}function c(o){return typeof o>"u"}function I(o){return!S(o)}function S(o){return c(o)||o===null}function u(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function P(o){if(S(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function w(...o){const n=[];for(let d=0;d<o.length;d++){const l=o[d];if(S(l))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);n.push(l)}return n}const a=Object.prototype.hasOwnProperty;function m(o){if(!C(o))return!1;for(const n in o)if(a.call(o,n))return!1;return!0}function $(o){return typeof o=="function"}function f(...o){return o.length>0&&o.every($)}function i(o,n){const d=Math.min(o.length,n.length);for(let l=0;l<d;l++)s(o[l],n[l])}function s(o,n){if(r(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if($(n)){try{if(o instanceof n)return}catch{}if(!S(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function t(o){return o}}),define(ke[106],Ie([1,0,17]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=C,e.$1j=R;const h=Object.create(null);function C(O,T){if((0,r.$eg)(T)){const p=h[T];if(p===void 0)throw new Error(`${O} references an unknown codicon: ${T}`);T=p}return h[O]=T,{id:O}}function R(){return h}}),define(ke[187],Ie([1,0,106]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=void 0,e.$2j={add:(0,r.$Zj)("add",6e4),plus:(0,r.$Zj)("plus",6e4),gistNew:(0,r.$Zj)("gist-new",6e4),repoCreate:(0,r.$Zj)("repo-create",6e4),lightbulb:(0,r.$Zj)("lightbulb",60001),lightBulb:(0,r.$Zj)("light-bulb",60001),repo:(0,r.$Zj)("repo",60002),repoDelete:(0,r.$Zj)("repo-delete",60002),gistFork:(0,r.$Zj)("gist-fork",60003),repoForked:(0,r.$Zj)("repo-forked",60003),gitPullRequest:(0,r.$Zj)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.$Zj)("git-pull-request-abandoned",60004),recordKeys:(0,r.$Zj)("record-keys",60005),keyboard:(0,r.$Zj)("keyboard",60005),tag:(0,r.$Zj)("tag",60006),gitPullRequestLabel:(0,r.$Zj)("git-pull-request-label",60006),tagAdd:(0,r.$Zj)("tag-add",60006),tagRemove:(0,r.$Zj)("tag-remove",60006),person:(0,r.$Zj)("person",60007),personFollow:(0,r.$Zj)("person-follow",60007),personOutline:(0,r.$Zj)("person-outline",60007),personFilled:(0,r.$Zj)("person-filled",60007),gitBranch:(0,r.$Zj)("git-branch",60008),gitBranchCreate:(0,r.$Zj)("git-branch-create",60008),gitBranchDelete:(0,r.$Zj)("git-branch-delete",60008),sourceControl:(0,r.$Zj)("source-control",60008),mirror:(0,r.$Zj)("mirror",60009),mirrorPublic:(0,r.$Zj)("mirror-public",60009),star:(0,r.$Zj)("star",60010),starAdd:(0,r.$Zj)("star-add",60010),starDelete:(0,r.$Zj)("star-delete",60010),starEmpty:(0,r.$Zj)("star-empty",60010),comment:(0,r.$Zj)("comment",60011),commentAdd:(0,r.$Zj)("comment-add",60011),alert:(0,r.$Zj)("alert",60012),warning:(0,r.$Zj)("warning",60012),search:(0,r.$Zj)("search",60013),searchSave:(0,r.$Zj)("search-save",60013),logOut:(0,r.$Zj)("log-out",60014),signOut:(0,r.$Zj)("sign-out",60014),logIn:(0,r.$Zj)("log-in",60015),signIn:(0,r.$Zj)("sign-in",60015),eye:(0,r.$Zj)("eye",60016),eyeUnwatch:(0,r.$Zj)("eye-unwatch",60016),eyeWatch:(0,r.$Zj)("eye-watch",60016),circleFilled:(0,r.$Zj)("circle-filled",60017),primitiveDot:(0,r.$Zj)("primitive-dot",60017),closeDirty:(0,r.$Zj)("close-dirty",60017),debugBreakpoint:(0,r.$Zj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.$Zj)("debug-breakpoint-disabled",60017),debugHint:(0,r.$Zj)("debug-hint",60017),terminalDecorationSuccess:(0,r.$Zj)("terminal-decoration-success",60017),primitiveSquare:(0,r.$Zj)("primitive-square",60018),edit:(0,r.$Zj)("edit",60019),pencil:(0,r.$Zj)("pencil",60019),info:(0,r.$Zj)("info",60020),issueOpened:(0,r.$Zj)("issue-opened",60020),gistPrivate:(0,r.$Zj)("gist-private",60021),gitForkPrivate:(0,r.$Zj)("git-fork-private",60021),lock:(0,r.$Zj)("lock",60021),mirrorPrivate:(0,r.$Zj)("mirror-private",60021),close:(0,r.$Zj)("close",60022),removeClose:(0,r.$Zj)("remove-close",60022),x:(0,r.$Zj)("x",60022),repoSync:(0,r.$Zj)("repo-sync",60023),sync:(0,r.$Zj)("sync",60023),clone:(0,r.$Zj)("clone",60024),desktopDownload:(0,r.$Zj)("desktop-download",60024),beaker:(0,r.$Zj)("beaker",60025),microscope:(0,r.$Zj)("microscope",60025),vm:(0,r.$Zj)("vm",60026),deviceDesktop:(0,r.$Zj)("device-desktop",60026),file:(0,r.$Zj)("file",60027),fileText:(0,r.$Zj)("file-text",60027),more:(0,r.$Zj)("more",60028),ellipsis:(0,r.$Zj)("ellipsis",60028),kebabHorizontal:(0,r.$Zj)("kebab-horizontal",60028),mailReply:(0,r.$Zj)("mail-reply",60029),reply:(0,r.$Zj)("reply",60029),organization:(0,r.$Zj)("organization",60030),organizationFilled:(0,r.$Zj)("organization-filled",60030),organizationOutline:(0,r.$Zj)("organization-outline",60030),newFile:(0,r.$Zj)("new-file",60031),fileAdd:(0,r.$Zj)("file-add",60031),newFolder:(0,r.$Zj)("new-folder",60032),fileDirectoryCreate:(0,r.$Zj)("file-directory-create",60032),trash:(0,r.$Zj)("trash",60033),trashcan:(0,r.$Zj)("trashcan",60033),history:(0,r.$Zj)("history",60034),clock:(0,r.$Zj)("clock",60034),folder:(0,r.$Zj)("folder",60035),fileDirectory:(0,r.$Zj)("file-directory",60035),symbolFolder:(0,r.$Zj)("symbol-folder",60035),logoGithub:(0,r.$Zj)("logo-github",60036),markGithub:(0,r.$Zj)("mark-github",60036),github:(0,r.$Zj)("github",60036),terminal:(0,r.$Zj)("terminal",60037),console:(0,r.$Zj)("console",60037),repl:(0,r.$Zj)("repl",60037),zap:(0,r.$Zj)("zap",60038),symbolEvent:(0,r.$Zj)("symbol-event",60038),error:(0,r.$Zj)("error",60039),stop:(0,r.$Zj)("stop",60039),variable:(0,r.$Zj)("variable",60040),symbolVariable:(0,r.$Zj)("symbol-variable",60040),array:(0,r.$Zj)("array",60042),symbolArray:(0,r.$Zj)("symbol-array",60042),symbolModule:(0,r.$Zj)("symbol-module",60043),symbolPackage:(0,r.$Zj)("symbol-package",60043),symbolNamespace:(0,r.$Zj)("symbol-namespace",60043),symbolObject:(0,r.$Zj)("symbol-object",60043),symbolMethod:(0,r.$Zj)("symbol-method",60044),symbolFunction:(0,r.$Zj)("symbol-function",60044),symbolConstructor:(0,r.$Zj)("symbol-constructor",60044),symbolBoolean:(0,r.$Zj)("symbol-boolean",60047),symbolNull:(0,r.$Zj)("symbol-null",60047),symbolNumeric:(0,r.$Zj)("symbol-numeric",60048),symbolNumber:(0,r.$Zj)("symbol-number",60048),symbolStructure:(0,r.$Zj)("symbol-structure",60049),symbolStruct:(0,r.$Zj)("symbol-struct",60049),symbolParameter:(0,r.$Zj)("symbol-parameter",60050),symbolTypeParameter:(0,r.$Zj)("symbol-type-parameter",60050),symbolKey:(0,r.$Zj)("symbol-key",60051),symbolText:(0,r.$Zj)("symbol-text",60051),symbolReference:(0,r.$Zj)("symbol-reference",60052),goToFile:(0,r.$Zj)("go-to-file",60052),symbolEnum:(0,r.$Zj)("symbol-enum",60053),symbolValue:(0,r.$Zj)("symbol-value",60053),symbolRuler:(0,r.$Zj)("symbol-ruler",60054),symbolUnit:(0,r.$Zj)("symbol-unit",60054),activateBreakpoints:(0,r.$Zj)("activate-breakpoints",60055),archive:(0,r.$Zj)("archive",60056),arrowBoth:(0,r.$Zj)("arrow-both",60057),arrowDown:(0,r.$Zj)("arrow-down",60058),arrowLeft:(0,r.$Zj)("arrow-left",60059),arrowRight:(0,r.$Zj)("arrow-right",60060),arrowSmallDown:(0,r.$Zj)("arrow-small-down",60061),arrowSmallLeft:(0,r.$Zj)("arrow-small-left",60062),arrowSmallRight:(0,r.$Zj)("arrow-small-right",60063),arrowSmallUp:(0,r.$Zj)("arrow-small-up",60064),arrowUp:(0,r.$Zj)("arrow-up",60065),bell:(0,r.$Zj)("bell",60066),bold:(0,r.$Zj)("bold",60067),book:(0,r.$Zj)("book",60068),bookmark:(0,r.$Zj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.$Zj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.$Zj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.$Zj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.$Zj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.$Zj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.$Zj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.$Zj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.$Zj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.$Zj)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.$Zj)("briefcase",60076),broadcast:(0,r.$Zj)("broadcast",60077),browser:(0,r.$Zj)("browser",60078),bug:(0,r.$Zj)("bug",60079),calendar:(0,r.$Zj)("calendar",60080),caseSensitive:(0,r.$Zj)("case-sensitive",60081),check:(0,r.$Zj)("check",60082),checklist:(0,r.$Zj)("checklist",60083),chevronDown:(0,r.$Zj)("chevron-down",60084),chevronLeft:(0,r.$Zj)("chevron-left",60085),chevronRight:(0,r.$Zj)("chevron-right",60086),chevronUp:(0,r.$Zj)("chevron-up",60087),chromeClose:(0,r.$Zj)("chrome-close",60088),chromeMaximize:(0,r.$Zj)("chrome-maximize",60089),chromeMinimize:(0,r.$Zj)("chrome-minimize",60090),chromeRestore:(0,r.$Zj)("chrome-restore",60091),circleOutline:(0,r.$Zj)("circle-outline",60092),circle:(0,r.$Zj)("circle",60092),debugBreakpointUnverified:(0,r.$Zj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.$Zj)("terminal-decoration-incomplete",60092),circleSlash:(0,r.$Zj)("circle-slash",60093),circuitBoard:(0,r.$Zj)("circuit-board",60094),clearAll:(0,r.$Zj)("clear-all",60095),clippy:(0,r.$Zj)("clippy",60096),closeAll:(0,r.$Zj)("close-all",60097),cloudDownload:(0,r.$Zj)("cloud-download",60098),cloudUpload:(0,r.$Zj)("cloud-upload",60099),code:(0,r.$Zj)("code",60100),collapseAll:(0,r.$Zj)("collapse-all",60101),colorMode:(0,r.$Zj)("color-mode",60102),commentDiscussion:(0,r.$Zj)("comment-discussion",60103),creditCard:(0,r.$Zj)("credit-card",60105),dash:(0,r.$Zj)("dash",60108),dashboard:(0,r.$Zj)("dashboard",60109),database:(0,r.$Zj)("database",60110),debugContinue:(0,r.$Zj)("debug-continue",60111),debugDisconnect:(0,r.$Zj)("debug-disconnect",60112),debugPause:(0,r.$Zj)("debug-pause",60113),debugRestart:(0,r.$Zj)("debug-restart",60114),debugStart:(0,r.$Zj)("debug-start",60115),debugStepInto:(0,r.$Zj)("debug-step-into",60116),debugStepOut:(0,r.$Zj)("debug-step-out",60117),debugStepOver:(0,r.$Zj)("debug-step-over",60118),debugStop:(0,r.$Zj)("debug-stop",60119),debug:(0,r.$Zj)("debug",60120),deviceCameraVideo:(0,r.$Zj)("device-camera-video",60121),deviceCamera:(0,r.$Zj)("device-camera",60122),deviceMobile:(0,r.$Zj)("device-mobile",60123),diffAdded:(0,r.$Zj)("diff-added",60124),diffIgnored:(0,r.$Zj)("diff-ignored",60125),diffModified:(0,r.$Zj)("diff-modified",60126),diffRemoved:(0,r.$Zj)("diff-removed",60127),diffRenamed:(0,r.$Zj)("diff-renamed",60128),diff:(0,r.$Zj)("diff",60129),diffSidebyside:(0,r.$Zj)("diff-sidebyside",60129),discard:(0,r.$Zj)("discard",60130),editorLayout:(0,r.$Zj)("editor-layout",60131),emptyWindow:(0,r.$Zj)("empty-window",60132),exclude:(0,r.$Zj)("exclude",60133),extensions:(0,r.$Zj)("extensions",60134),eyeClosed:(0,r.$Zj)("eye-closed",60135),fileBinary:(0,r.$Zj)("file-binary",60136),fileCode:(0,r.$Zj)("file-code",60137),fileMedia:(0,r.$Zj)("file-media",60138),filePdf:(0,r.$Zj)("file-pdf",60139),fileSubmodule:(0,r.$Zj)("file-submodule",60140),fileSymlinkDirectory:(0,r.$Zj)("file-symlink-directory",60141),fileSymlinkFile:(0,r.$Zj)("file-symlink-file",60142),fileZip:(0,r.$Zj)("file-zip",60143),files:(0,r.$Zj)("files",60144),filter:(0,r.$Zj)("filter",60145),flame:(0,r.$Zj)("flame",60146),foldDown:(0,r.$Zj)("fold-down",60147),foldUp:(0,r.$Zj)("fold-up",60148),fold:(0,r.$Zj)("fold",60149),folderActive:(0,r.$Zj)("folder-active",60150),folderOpened:(0,r.$Zj)("folder-opened",60151),gear:(0,r.$Zj)("gear",60152),gift:(0,r.$Zj)("gift",60153),gistSecret:(0,r.$Zj)("gist-secret",60154),gist:(0,r.$Zj)("gist",60155),gitCommit:(0,r.$Zj)("git-commit",60156),gitCompare:(0,r.$Zj)("git-compare",60157),compareChanges:(0,r.$Zj)("compare-changes",60157),gitMerge:(0,r.$Zj)("git-merge",60158),githubAction:(0,r.$Zj)("github-action",60159),githubAlt:(0,r.$Zj)("github-alt",60160),globe:(0,r.$Zj)("globe",60161),grabber:(0,r.$Zj)("grabber",60162),graph:(0,r.$Zj)("graph",60163),gripper:(0,r.$Zj)("gripper",60164),heart:(0,r.$Zj)("heart",60165),home:(0,r.$Zj)("home",60166),horizontalRule:(0,r.$Zj)("horizontal-rule",60167),hubot:(0,r.$Zj)("hubot",60168),inbox:(0,r.$Zj)("inbox",60169),issueReopened:(0,r.$Zj)("issue-reopened",60171),issues:(0,r.$Zj)("issues",60172),italic:(0,r.$Zj)("italic",60173),jersey:(0,r.$Zj)("jersey",60174),json:(0,r.$Zj)("json",60175),kebabVertical:(0,r.$Zj)("kebab-vertical",60176),key:(0,r.$Zj)("key",60177),law:(0,r.$Zj)("law",60178),lightbulbAutofix:(0,r.$Zj)("lightbulb-autofix",60179),linkExternal:(0,r.$Zj)("link-external",60180),link:(0,r.$Zj)("link",60181),listOrdered:(0,r.$Zj)("list-ordered",60182),listUnordered:(0,r.$Zj)("list-unordered",60183),liveShare:(0,r.$Zj)("live-share",60184),loading:(0,r.$Zj)("loading",60185),location:(0,r.$Zj)("location",60186),mailRead:(0,r.$Zj)("mail-read",60187),mail:(0,r.$Zj)("mail",60188),markdown:(0,r.$Zj)("markdown",60189),megaphone:(0,r.$Zj)("megaphone",60190),mention:(0,r.$Zj)("mention",60191),milestone:(0,r.$Zj)("milestone",60192),gitPullRequestMilestone:(0,r.$Zj)("git-pull-request-milestone",60192),mortarBoard:(0,r.$Zj)("mortar-board",60193),move:(0,r.$Zj)("move",60194),multipleWindows:(0,r.$Zj)("multiple-windows",60195),mute:(0,r.$Zj)("mute",60196),noNewline:(0,r.$Zj)("no-newline",60197),note:(0,r.$Zj)("note",60198),octoface:(0,r.$Zj)("octoface",60199),openPreview:(0,r.$Zj)("open-preview",60200),package:(0,r.$Zj)("package",60201),paintcan:(0,r.$Zj)("paintcan",60202),pin:(0,r.$Zj)("pin",60203),play:(0,r.$Zj)("play",60204),run:(0,r.$Zj)("run",60204),plug:(0,r.$Zj)("plug",60205),preserveCase:(0,r.$Zj)("preserve-case",60206),preview:(0,r.$Zj)("preview",60207),project:(0,r.$Zj)("project",60208),pulse:(0,r.$Zj)("pulse",60209),question:(0,r.$Zj)("question",60210),quote:(0,r.$Zj)("quote",60211),radioTower:(0,r.$Zj)("radio-tower",60212),reactions:(0,r.$Zj)("reactions",60213),references:(0,r.$Zj)("references",60214),refresh:(0,r.$Zj)("refresh",60215),regex:(0,r.$Zj)("regex",60216),remoteExplorer:(0,r.$Zj)("remote-explorer",60217),remote:(0,r.$Zj)("remote",60218),remove:(0,r.$Zj)("remove",60219),replaceAll:(0,r.$Zj)("replace-all",60220),replace:(0,r.$Zj)("replace",60221),repoClone:(0,r.$Zj)("repo-clone",60222),repoForcePush:(0,r.$Zj)("repo-force-push",60223),repoPull:(0,r.$Zj)("repo-pull",60224),repoPush:(0,r.$Zj)("repo-push",60225),report:(0,r.$Zj)("report",60226),requestChanges:(0,r.$Zj)("request-changes",60227),rocket:(0,r.$Zj)("rocket",60228),rootFolderOpened:(0,r.$Zj)("root-folder-opened",60229),rootFolder:(0,r.$Zj)("root-folder",60230),rss:(0,r.$Zj)("rss",60231),ruby:(0,r.$Zj)("ruby",60232),saveAll:(0,r.$Zj)("save-all",60233),saveAs:(0,r.$Zj)("save-as",60234),save:(0,r.$Zj)("save",60235),screenFull:(0,r.$Zj)("screen-full",60236),screenNormal:(0,r.$Zj)("screen-normal",60237),searchStop:(0,r.$Zj)("search-stop",60238),server:(0,r.$Zj)("server",60240),settingsGear:(0,r.$Zj)("settings-gear",60241),settings:(0,r.$Zj)("settings",60242),shield:(0,r.$Zj)("shield",60243),smiley:(0,r.$Zj)("smiley",60244),sortPrecedence:(0,r.$Zj)("sort-precedence",60245),splitHorizontal:(0,r.$Zj)("split-horizontal",60246),splitVertical:(0,r.$Zj)("split-vertical",60247),squirrel:(0,r.$Zj)("squirrel",60248),starFull:(0,r.$Zj)("star-full",60249),starHalf:(0,r.$Zj)("star-half",60250),symbolClass:(0,r.$Zj)("symbol-class",60251),symbolColor:(0,r.$Zj)("symbol-color",60252),symbolConstant:(0,r.$Zj)("symbol-constant",60253),symbolEnumMember:(0,r.$Zj)("symbol-enum-member",60254),symbolField:(0,r.$Zj)("symbol-field",60255),symbolFile:(0,r.$Zj)("symbol-file",60256),symbolInterface:(0,r.$Zj)("symbol-interface",60257),symbolKeyword:(0,r.$Zj)("symbol-keyword",60258),symbolMisc:(0,r.$Zj)("symbol-misc",60259),symbolOperator:(0,r.$Zj)("symbol-operator",60260),symbolProperty:(0,r.$Zj)("symbol-property",60261),wrench:(0,r.$Zj)("wrench",60261),wrenchSubaction:(0,r.$Zj)("wrench-subaction",60261),symbolSnippet:(0,r.$Zj)("symbol-snippet",60262),tasklist:(0,r.$Zj)("tasklist",60263),telescope:(0,r.$Zj)("telescope",60264),textSize:(0,r.$Zj)("text-size",60265),threeBars:(0,r.$Zj)("three-bars",60266),thumbsdown:(0,r.$Zj)("thumbsdown",60267),thumbsup:(0,r.$Zj)("thumbsup",60268),tools:(0,r.$Zj)("tools",60269),triangleDown:(0,r.$Zj)("triangle-down",60270),triangleLeft:(0,r.$Zj)("triangle-left",60271),triangleRight:(0,r.$Zj)("triangle-right",60272),triangleUp:(0,r.$Zj)("triangle-up",60273),twitter:(0,r.$Zj)("twitter",60274),unfold:(0,r.$Zj)("unfold",60275),unlock:(0,r.$Zj)("unlock",60276),unmute:(0,r.$Zj)("unmute",60277),unverified:(0,r.$Zj)("unverified",60278),verified:(0,r.$Zj)("verified",60279),versions:(0,r.$Zj)("versions",60280),vmActive:(0,r.$Zj)("vm-active",60281),vmOutline:(0,r.$Zj)("vm-outline",60282),vmRunning:(0,r.$Zj)("vm-running",60283),watch:(0,r.$Zj)("watch",60284),whitespace:(0,r.$Zj)("whitespace",60285),wholeWord:(0,r.$Zj)("whole-word",60286),window:(0,r.$Zj)("window",60287),wordWrap:(0,r.$Zj)("word-wrap",60288),zoomIn:(0,r.$Zj)("zoom-in",60289),zoomOut:(0,r.$Zj)("zoom-out",60290),listFilter:(0,r.$Zj)("list-filter",60291),listFlat:(0,r.$Zj)("list-flat",60292),listSelection:(0,r.$Zj)("list-selection",60293),selection:(0,r.$Zj)("selection",60293),listTree:(0,r.$Zj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.$Zj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.$Zj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.$Zj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.$Zj)("debug-stackframe-active",60297),circleSmallFilled:(0,r.$Zj)("circle-small-filled",60298),debugStackframeDot:(0,r.$Zj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.$Zj)("terminal-decoration-mark",60298),debugStackframe:(0,r.$Zj)("debug-stackframe",60299),debugStackframeFocused:(0,r.$Zj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.$Zj)("debug-breakpoint-unsupported",60300),symbolString:(0,r.$Zj)("symbol-string",60301),debugReverseContinue:(0,r.$Zj)("debug-reverse-continue",60302),debugStepBack:(0,r.$Zj)("debug-step-back",60303),debugRestartFrame:(0,r.$Zj)("debug-restart-frame",60304),debugAlt:(0,r.$Zj)("debug-alt",60305),callIncoming:(0,r.$Zj)("call-incoming",60306),callOutgoing:(0,r.$Zj)("call-outgoing",60307),menu:(0,r.$Zj)("menu",60308),expandAll:(0,r.$Zj)("expand-all",60309),feedback:(0,r.$Zj)("feedback",60310),gitPullRequestReviewer:(0,r.$Zj)("git-pull-request-reviewer",60310),groupByRefType:(0,r.$Zj)("group-by-ref-type",60311),ungroupByRefType:(0,r.$Zj)("ungroup-by-ref-type",60312),account:(0,r.$Zj)("account",60313),gitPullRequestAssignee:(0,r.$Zj)("git-pull-request-assignee",60313),bellDot:(0,r.$Zj)("bell-dot",60314),debugConsole:(0,r.$Zj)("debug-console",60315),library:(0,r.$Zj)("library",60316),output:(0,r.$Zj)("output",60317),runAll:(0,r.$Zj)("run-all",60318),syncIgnored:(0,r.$Zj)("sync-ignored",60319),pinned:(0,r.$Zj)("pinned",60320),githubInverted:(0,r.$Zj)("github-inverted",60321),serverProcess:(0,r.$Zj)("server-process",60322),serverEnvironment:(0,r.$Zj)("server-environment",60323),pass:(0,r.$Zj)("pass",60324),issueClosed:(0,r.$Zj)("issue-closed",60324),stopCircle:(0,r.$Zj)("stop-circle",60325),playCircle:(0,r.$Zj)("play-circle",60326),record:(0,r.$Zj)("record",60327),debugAltSmall:(0,r.$Zj)("debug-alt-small",60328),vmConnect:(0,r.$Zj)("vm-connect",60329),cloud:(0,r.$Zj)("cloud",60330),merge:(0,r.$Zj)("merge",60331),export:(0,r.$Zj)("export",60332),graphLeft:(0,r.$Zj)("graph-left",60333),magnet:(0,r.$Zj)("magnet",60334),notebook:(0,r.$Zj)("notebook",60335),redo:(0,r.$Zj)("redo",60336),checkAll:(0,r.$Zj)("check-all",60337),pinnedDirty:(0,r.$Zj)("pinned-dirty",60338),passFilled:(0,r.$Zj)("pass-filled",60339),circleLargeFilled:(0,r.$Zj)("circle-large-filled",60340),circleLarge:(0,r.$Zj)("circle-large",60341),circleLargeOutline:(0,r.$Zj)("circle-large-outline",60341),combine:(0,r.$Zj)("combine",60342),gather:(0,r.$Zj)("gather",60342),table:(0,r.$Zj)("table",60343),variableGroup:(0,r.$Zj)("variable-group",60344),typeHierarchy:(0,r.$Zj)("type-hierarchy",60345),typeHierarchySub:(0,r.$Zj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.$Zj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.$Zj)("git-pull-request-create",60348),runAbove:(0,r.$Zj)("run-above",60349),runBelow:(0,r.$Zj)("run-below",60350),notebookTemplate:(0,r.$Zj)("notebook-template",60351),debugRerun:(0,r.$Zj)("debug-rerun",60352),workspaceTrusted:(0,r.$Zj)("workspace-trusted",60353),workspaceUntrusted:(0,r.$Zj)("workspace-untrusted",60354),workspaceUnknown:(0,r.$Zj)("workspace-unknown",60355),terminalCmd:(0,r.$Zj)("terminal-cmd",60356),terminalDebian:(0,r.$Zj)("terminal-debian",60357),terminalLinux:(0,r.$Zj)("terminal-linux",60358),terminalPowershell:(0,r.$Zj)("terminal-powershell",60359),terminalTmux:(0,r.$Zj)("terminal-tmux",60360),terminalUbuntu:(0,r.$Zj)("terminal-ubuntu",60361),terminalBash:(0,r.$Zj)("terminal-bash",60362),arrowSwap:(0,r.$Zj)("arrow-swap",60363),copy:(0,r.$Zj)("copy",60364),personAdd:(0,r.$Zj)("person-add",60365),filterFilled:(0,r.$Zj)("filter-filled",60366),wand:(0,r.$Zj)("wand",60367),debugLineByLine:(0,r.$Zj)("debug-line-by-line",60368),inspect:(0,r.$Zj)("inspect",60369),layers:(0,r.$Zj)("layers",60370),layersDot:(0,r.$Zj)("layers-dot",60371),layersActive:(0,r.$Zj)("layers-active",60372),compass:(0,r.$Zj)("compass",60373),compassDot:(0,r.$Zj)("compass-dot",60374),compassActive:(0,r.$Zj)("compass-active",60375),azure:(0,r.$Zj)("azure",60376),issueDraft:(0,r.$Zj)("issue-draft",60377),gitPullRequestClosed:(0,r.$Zj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.$Zj)("git-pull-request-draft",60379),debugAll:(0,r.$Zj)("debug-all",60380),debugCoverage:(0,r.$Zj)("debug-coverage",60381),runErrors:(0,r.$Zj)("run-errors",60382),folderLibrary:(0,r.$Zj)("folder-library",60383),debugContinueSmall:(0,r.$Zj)("debug-continue-small",60384),beakerStop:(0,r.$Zj)("beaker-stop",60385),graphLine:(0,r.$Zj)("graph-line",60386),graphScatter:(0,r.$Zj)("graph-scatter",60387),pieChart:(0,r.$Zj)("pie-chart",60388),bracket:(0,r.$Zj)("bracket",60175),bracketDot:(0,r.$Zj)("bracket-dot",60389),bracketError:(0,r.$Zj)("bracket-error",60390),lockSmall:(0,r.$Zj)("lock-small",60391),azureDevops:(0,r.$Zj)("azure-devops",60392),verifiedFilled:(0,r.$Zj)("verified-filled",60393),newline:(0,r.$Zj)("newline",60394),layout:(0,r.$Zj)("layout",60395),layoutActivitybarLeft:(0,r.$Zj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.$Zj)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.$Zj)("layout-panel-left",60398),layoutPanelCenter:(0,r.$Zj)("layout-panel-center",60399),layoutPanelJustify:(0,r.$Zj)("layout-panel-justify",60400),layoutPanelRight:(0,r.$Zj)("layout-panel-right",60401),layoutPanel:(0,r.$Zj)("layout-panel",60402),layoutSidebarLeft:(0,r.$Zj)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.$Zj)("layout-sidebar-right",60404),layoutStatusbar:(0,r.$Zj)("layout-statusbar",60405),layoutMenubar:(0,r.$Zj)("layout-menubar",60406),layoutCentered:(0,r.$Zj)("layout-centered",60407),target:(0,r.$Zj)("target",60408),indent:(0,r.$Zj)("indent",60409),recordSmall:(0,r.$Zj)("record-small",60410),errorSmall:(0,r.$Zj)("error-small",60411),terminalDecorationError:(0,r.$Zj)("terminal-decoration-error",60411),arrowCircleDown:(0,r.$Zj)("arrow-circle-down",60412),arrowCircleLeft:(0,r.$Zj)("arrow-circle-left",60413),arrowCircleRight:(0,r.$Zj)("arrow-circle-right",60414),arrowCircleUp:(0,r.$Zj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.$Zj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.$Zj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.$Zj)("layout-sidebar-left-off",60418),blank:(0,r.$Zj)("blank",60419),heartFilled:(0,r.$Zj)("heart-filled",60420),map:(0,r.$Zj)("map",60421),mapHorizontal:(0,r.$Zj)("map-horizontal",60421),foldHorizontal:(0,r.$Zj)("fold-horizontal",60421),mapFilled:(0,r.$Zj)("map-filled",60422),mapHorizontalFilled:(0,r.$Zj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.$Zj)("fold-horizontal-filled",60422),circleSmall:(0,r.$Zj)("circle-small",60423),bellSlash:(0,r.$Zj)("bell-slash",60424),bellSlashDot:(0,r.$Zj)("bell-slash-dot",60425),commentUnresolved:(0,r.$Zj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.$Zj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.$Zj)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.$Zj)("search-fuzzy",60429),commentDraft:(0,r.$Zj)("comment-draft",60430),send:(0,r.$Zj)("send",60431),sparkle:(0,r.$Zj)("sparkle",60432),insert:(0,r.$Zj)("insert",60433),mic:(0,r.$Zj)("mic",60434),thumbsdownFilled:(0,r.$Zj)("thumbsdown-filled",60435),thumbsupFilled:(0,r.$Zj)("thumbsup-filled",60436),coffee:(0,r.$Zj)("coffee",60437),snake:(0,r.$Zj)("snake",60438),game:(0,r.$Zj)("game",60439),vr:(0,r.$Zj)("vr",60440),chip:(0,r.$Zj)("chip",60441),piano:(0,r.$Zj)("piano",60442),music:(0,r.$Zj)("music",60443),micFilled:(0,r.$Zj)("mic-filled",60444),repoFetch:(0,r.$Zj)("repo-fetch",60445),copilot:(0,r.$Zj)("copilot",60446),lightbulbSparkle:(0,r.$Zj)("lightbulb-sparkle",60447),robot:(0,r.$Zj)("robot",60448),sparkleFilled:(0,r.$Zj)("sparkle-filled",60449),diffSingle:(0,r.$Zj)("diff-single",60450),diffMultiple:(0,r.$Zj)("diff-multiple",60451),surroundWith:(0,r.$Zj)("surround-with",60452),share:(0,r.$Zj)("share",60453),gitStash:(0,r.$Zj)("git-stash",60454),gitStashApply:(0,r.$Zj)("git-stash-apply",60455),gitStashPop:(0,r.$Zj)("git-stash-pop",60456),vscode:(0,r.$Zj)("vscode",60457),vscodeInsiders:(0,r.$Zj)("vscode-insiders",60458),codeOss:(0,r.$Zj)("code-oss",60459),runCoverage:(0,r.$Zj)("run-coverage",60460),runAllCoverage:(0,r.$Zj)("run-all-coverage",60461),coverage:(0,r.$Zj)("coverage",60462),githubProject:(0,r.$Zj)("github-project",60463),mapVertical:(0,r.$Zj)("map-vertical",60464),foldVertical:(0,r.$Zj)("fold-vertical",60464),mapVerticalFilled:(0,r.$Zj)("map-vertical-filled",60465),foldVerticalFilled:(0,r.$Zj)("fold-vertical-filled",60465),goToSearch:(0,r.$Zj)("go-to-search",60466),percentage:(0,r.$Zj)("percentage",60467),sortPercentage:(0,r.$Zj)("sort-percentage",60467),attach:(0,r.$Zj)("attach",60468)}}),define(ke[82],Ie([1,0,106,187]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=void 0,e.$3j=C;function C(){return Object.values(e.$5j)}e.$4j={dialogError:(0,r.$Zj)("dialog-error","error"),dialogWarning:(0,r.$Zj)("dialog-warning","warning"),dialogInfo:(0,r.$Zj)("dialog-info","info"),dialogClose:(0,r.$Zj)("dialog-close","close"),treeItemExpanded:(0,r.$Zj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.$Zj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.$Zj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.$Zj)("tree-filter-clear","close"),treeItemLoading:(0,r.$Zj)("tree-item-loading","loading"),menuSelection:(0,r.$Zj)("menu-selection","check"),menuSubmenu:(0,r.$Zj)("menu-submenu","chevron-right"),menuBarMore:(0,r.$Zj)("menubar-more","more"),scrollbarButtonLeft:(0,r.$Zj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.$Zj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.$Zj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.$Zj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.$Zj)("toolbar-more","more"),quickInputBack:(0,r.$Zj)("quick-input-back","arrow-left"),dropDownButton:(0,r.$Zj)("drop-down-button",60084),symbolCustomColor:(0,r.$Zj)("symbol-customcolor",60252),exportIcon:(0,r.$Zj)("export",60332),workspaceUnspecified:(0,r.$Zj)("workspace-unspecified",60355),newLine:(0,r.$Zj)("newline",60394),thumbsDownFilled:(0,r.$Zj)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.$Zj)("thumbsup-filled",60436),gitFetch:(0,r.$Zj)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.$Zj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.$Zj)("debug-breakpoint-pending",60377)},e.$5j={...h.$2j,...e.$4j}}),define(ke[24],Ie([1,0,17]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=h,e.$fo=C,e.$go=O,e.$ho=p,e.$io=c,e.$jo=I,e.$ko=S,e.$lo=u,e.$mo=P,e.$no=w,e.$oo=a,e.$po=m,e.$qo=$;function h(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const i=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([s,t])=>{i[s]=t&&typeof t=="object"?h(t):t}),i}function C(f){if(!f||typeof f!="object")return f;const i=[f];for(;i.length>0;){const s=i.shift();Object.freeze(s);for(const t in s)if(R.call(s,t)){const o=s[t];typeof o=="object"&&!Object.isFrozen(o)&&!(0,r.$hg)(o)&&i.push(o)}}return f}const R=Object.prototype.hasOwnProperty;function O(f,i){return T(f,i,new Set)}function T(f,i,s){if((0,r.$ng)(f))return f;const t=i(f);if(typeof t<"u")return t;if(Array.isArray(f)){const o=[];for(const n of f)o.push(T(n,i,s));return o}if((0,r.$gg)(f)){if(s.has(f))throw new Error("Cannot clone recursive data-structure");s.add(f);const o={};for(const n in f)R.call(f,n)&&(o[n]=T(f[n],i,s));return s.delete(f),o}return f}function p(f,i,s=!0){return(0,r.$gg)(f)?((0,r.$gg)(i)&&Object.keys(i).forEach(t=>{t in f?s&&((0,r.$gg)(f[t])&&(0,r.$gg)(i[t])?p(f[t],i[t],s):f[t]=i[t]):f[t]=i[t]}),f):i}function c(f,i){if(f===i)return!0;if(f==null||i===null||i===void 0||typeof f!=typeof i||typeof f!="object"||Array.isArray(f)!==Array.isArray(i))return!1;let s,t;if(Array.isArray(f)){if(f.length!==i.length)return!1;for(s=0;s<f.length;s++)if(!c(f[s],i[s]))return!1}else{const o=[];for(t in f)o.push(t);o.sort();const n=[];for(t in i)n.push(t);if(n.sort(),!c(o,n))return!1;for(s=0;s<o.length;s++)if(!c(f[o[s]],i[o[s]]))return!1}return!0}function I(f){const i=new Set;return JSON.stringify(f,(s,t)=>{if((0,r.$gg)(t)||Array.isArray(t)){if(i.has(t))return"[Circular]";i.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function S(f,i){const s=Object.create(null);return!f||!i||Object.keys(i).forEach(o=>{const n=f[o],d=i[o];c(n,d)||(s[o]=d)}),s}function u(f,i){const s=i.toLowerCase(),t=Object.keys(f).find(o=>o.toLowerCase()===s);return t?f[t]:f[i]}function P(f,i){const s=Object.create(null);for(const[t,o]of Object.entries(f))i(t,o)&&(s[t]=o);return s}function w(f){let i=[];for(;Object.prototype!==f;)i=i.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return i}function a(f){const i=[];for(const s of w(f))typeof f[s]=="function"&&i.push(s);return i}function m(f,i){const s=o=>function(){const n=Array.prototype.slice.call(arguments,0);return i(o,n)},t={};for(const o of f)t[o]=s(o);return t}function $(f,i){const s={};for(const[t,o]of Object.entries(f))s[t]=i(o,t);return s}}),define(ke[51],Ie([1,0,82]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$6j=C;var h;(function(O){function T(p){return p&&typeof p=="object"&&typeof p.id=="string"}O.isThemeColor=T})(h||(e.ThemeColor=h={}));function C(O){return{id:O}}var R;(function(O){O.iconNameSegment="[A-Za-z0-9]+",O.iconNameExpression="[A-Za-z0-9-]+",O.iconModifierExpression="~[A-Za-z]+",O.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${O.iconNameExpression})(${O.iconModifierExpression})?$`);function p(f){const i=T.exec(f.id);if(!i)return p(r.$5j.error);const[,s,t]=i,o=["codicon","codicon-"+s];return t&&o.push("codicon-modifier-"+t.substring(1)),o}O.asClassNameArray=p;function c(f){return p(f).join(" ")}O.asClassName=c;function I(f){return"."+p(f).join(".")}O.asCSSSelector=I;function S(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||h.isThemeColor(f.color))}O.isThemeIcon=S;const u=new RegExp(`^\\$\\((${O.iconNameExpression}(?:${O.iconModifierExpression})?)\\)$`);function P(f){const i=u.exec(f);if(!i)return;const[,s]=i;return{id:s}}O.fromString=P;function w(f){return{id:f}}O.fromId=w;function a(f,i){let s=f.id;const t=s.lastIndexOf("~");return t!==-1&&(s=s.substring(0,t)),i&&(s=`${s}~${i}`),{id:s}}O.modify=a;function m(f){const i=f.id.lastIndexOf("~");if(i!==-1)return f.id.substring(i+1)}O.getModifier=m;function $(f,i){return f.id===i.id&&f.color?.id===i.color?.id}O.isEqual=$})(R||(e.ThemeIcon=R={}))}),define(ke[83],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$af=h,e.$bf=C;var r;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(r||(e.Constants=r={}));function h(R){return R<0?0:R>r.MAX_UINT_8?r.MAX_UINT_8:R|0}function C(R){return R<0?0:R>r.MAX_UINT_32?r.MAX_UINT_32:R|0}}),define(ke[12],Ie([1,0,184,26,50,83]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.GraphemeBreakType=e.$4f=e.$Vf=e.$Of=e.$Nf=void 0,e.$cf=O,e.$df=p,e.$ef=I,e.$ff=S,e.$gf=u,e.$hf=P,e.$if=w,e.$jf=a,e.$kf=m,e.$lf=$,e.$mf=f,e.$nf=i,e.$of=s,e.$pf=t,e.$qf=o,e.$rf=n,e.$sf=d,e.$tf=l,e.$uf=g,e.$vf=E,e.$wf=D,e.$xf=y,e.$yf=k,e.$zf=A,e.$Af=b,e.$Bf=v,e.$Cf=F,e.$Df=N,e.$Ef=L,e.$Ff=M,e.$Gf=z,e.$Hf=j,e.$If=W,e.$Jf=B,e.$Kf=ee,e.$Lf=H,e.$Mf=q,e.$Pf=ne,e.$Qf=ye,e.$Rf=ge,e.$Sf=Y,e.$Tf=ve,e.$Uf=ae,e.$Wf=se,e.$Xf=X,e.$Yf=re,e.$Zf=pe,e.$1f=Fe,e.$2f=Be,e.$3f=De,e.$5f=Ce,e.$6f=V,e.$7f=G,e.$8f=J,e.$9f=x,e.$0f=de,e.$$f=Ee,e.$_f=Le,e.$ag=st;function O(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}const T=/{(\d+)}/g;function p(Pe,...ze){return ze.length===0?Pe:Pe.replace(T,function(Ke,Ne){const je=parseInt(Ne,10);return isNaN(je)||je<0||je>=ze.length?Ke:ze[je]})}const c=/{([^}]+)}/g;function I(Pe,ze){return Object.keys(ze).length===0?Pe:Pe.replace(c,(Ke,Ne)=>ze[Ne]??Ke)}function S(Pe){return Pe.replace(/[<>"'&]/g,ze=>{switch(ze){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ze})}function u(Pe){return Pe.replace(/[<>&]/g,function(ze){switch(ze){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ze}})}function P(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function w(Pe,ze){let Ke=0,Ne=Pe.indexOf(ze);for(;Ne!==-1;)Ke++,Ne=Pe.indexOf(ze,Ne+ze.length);return Ke}function a(Pe,ze,Ke="\u2026"){return Pe.length<=ze?Pe:`${Pe.substr(0,ze)}${Ke}`}function m(Pe,ze,Ke="\u2026"){if(Pe.length<=ze)return Pe;const Ne=Math.ceil(ze/2)-Ke.length/2,je=Math.floor(ze/2)-Ke.length/2;return`${Pe.substr(0,Ne)}${Ke}${Pe.substr(Pe.length-je)}`}function $(Pe,ze=" "){const Ke=f(Pe,ze);return i(Ke,ze)}function f(Pe,ze){if(!Pe||!ze)return Pe;const Ke=ze.length;if(Ke===0||Pe.length===0)return Pe;let Ne=0;for(;Pe.indexOf(ze,Ne)===Ne;)Ne=Ne+Ke;return Pe.substring(Ne)}function i(Pe,ze){if(!Pe||!ze)return Pe;const Ke=ze.length,Ne=Pe.length;if(Ke===0||Ne===0)return Pe;let je=Ne,ue=-1;for(;ue=Pe.lastIndexOf(ze,je-1),!(ue===-1||ue+Ke!==je);){if(ue===0)return"";je=ue}return Pe.substring(0,je)}function s(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(Pe){return Pe.replace(/\*/g,"")}function o(Pe,ze,Ke={}){if(!Pe)throw new Error("Cannot create regex from empty string");ze||(Pe=P(Pe)),Ke.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Ne="";return Ke.global&&(Ne+="g"),Ke.matchCase||(Ne+="i"),Ke.multiline&&(Ne+="m"),Ke.unicode&&(Ne+="u"),new RegExp(Pe,Ne)}function n(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}function d(Pe){return Pe.split(/\r\n|\r|\n/)}function l(Pe){const ze=[],Ke=Pe.split(/(\r\n|\r|\n)/);for(let Ne=0;Ne<Math.ceil(Ke.length/2);Ne++)ze.push(Ke[2*Ne]+(Ke[2*Ne+1]??""));return ze}function g(Pe){for(let ze=0,Ke=Pe.length;ze<Ke;ze++){const Ne=Pe.charCodeAt(ze);if(Ne!==h.CharCode.Space&&Ne!==h.CharCode.Tab)return ze}return-1}function E(Pe,ze=0,Ke=Pe.length){for(let Ne=ze;Ne<Ke;Ne++){const je=Pe.charCodeAt(Ne);if(je!==h.CharCode.Space&&je!==h.CharCode.Tab)return Pe.substring(ze,Ne)}return Pe.substring(ze,Ke)}function D(Pe,ze=Pe.length-1){for(let Ke=ze;Ke>=0;Ke--){const Ne=Pe.charCodeAt(Ke);if(Ne!==h.CharCode.Space&&Ne!==h.CharCode.Tab)return Ke}return-1}function y(Pe,ze,Ke){const Ne=[];let je=0;for(const ue of Pe.matchAll(ze)){if(Ne.push(Pe.slice(je,ue.index)),ue.index===void 0)throw new Error("match.index should be defined");je=ue.index+ue[0].length,Ne.push(Ke(ue[0],...ue.slice(1),ue.index,Pe,ue.groups))}return Ne.push(Pe.slice(je)),Promise.all(Ne).then(ue=>ue.join(""))}function k(Pe,ze){return Pe<ze?-1:Pe>ze?1:0}function A(Pe,ze,Ke=0,Ne=Pe.length,je=0,ue=ze.length){for(;Ke<Ne&&je<ue;Ke++,je++){const Xe=Pe.charCodeAt(Ke),tt=ze.charCodeAt(je);if(Xe<tt)return-1;if(Xe>tt)return 1}const he=Ne-Ke,le=ue-je;return he<le?-1:he>le?1:0}function b(Pe,ze){return v(Pe,ze,0,Pe.length,0,ze.length)}function v(Pe,ze,Ke=0,Ne=Pe.length,je=0,ue=ze.length){for(;Ke<Ne&&je<ue;Ke++,je++){let Xe=Pe.charCodeAt(Ke),tt=ze.charCodeAt(je);if(Xe===tt)continue;if(Xe>=128||tt>=128)return A(Pe.toLowerCase(),ze.toLowerCase(),Ke,Ne,je,ue);N(Xe)&&(Xe-=32),N(tt)&&(tt-=32);const ut=Xe-tt;if(ut!==0)return ut}const he=Ne-Ke,le=ue-je;return he<le?-1:he>le?1:0}function F(Pe){return Pe>=h.CharCode.Digit0&&Pe<=h.CharCode.Digit9}function N(Pe){return Pe>=h.CharCode.a&&Pe<=h.CharCode.z}function L(Pe){return Pe>=h.CharCode.A&&Pe<=h.CharCode.Z}function M(Pe,ze){return Pe.length===ze.length&&v(Pe,ze)===0}function z(Pe,ze){const Ke=ze.length;return ze.length>Pe.length?!1:v(Pe,ze,0,Ke)===0}function j(Pe,ze){const Ke=Math.min(Pe.length,ze.length);let Ne;for(Ne=0;Ne<Ke;Ne++)if(Pe.charCodeAt(Ne)!==ze.charCodeAt(Ne))return Ne;return Ke}function W(Pe,ze){const Ke=Math.min(Pe.length,ze.length);let Ne;const je=Pe.length-1,ue=ze.length-1;for(Ne=0;Ne<Ke;Ne++)if(Pe.charCodeAt(je-Ne)!==ze.charCodeAt(ue-Ne))return Ne;return Ke}function B(Pe){return 55296<=Pe&&Pe<=56319}function ee(Pe){return 56320<=Pe&&Pe<=57343}function H(Pe,ze){return(Pe-55296<<10)+(ze-56320)+65536}function q(Pe,ze,Ke){const Ne=Pe.charCodeAt(Ke);if(B(Ne)&&Ke+1<ze){const je=Pe.charCodeAt(Ke+1);if(ee(je))return H(Ne,je)}return Ne}function Q(Pe,ze){const Ke=Pe.charCodeAt(ze-1);if(ee(Ke)&&ze>1){const Ne=Pe.charCodeAt(ze-2);if(B(Ne))return H(Ne,Ke)}return Ke}class _{get offset(){return this.e}constructor(ze,Ke=0){this.c=ze,this.d=ze.length,this.e=Ke}setOffset(ze){this.e=ze}prevCodePoint(){const ze=Q(this.c,this.e);return this.e-=ze>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ze}nextCodePoint(){const ze=q(this.c,this.d,this.e);return this.e+=ze>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ze}eol(){return this.e>=this.d}}e.$Nf=_;class ce{get offset(){return this.c.offset}constructor(ze,Ke=0){this.c=new _(ze,Ke)}nextGraphemeLength(){const ze=et.getInstance(),Ke=this.c,Ne=Ke.offset;let je=ze.getGraphemeBreakType(Ke.nextCodePoint());for(;!Ke.eol();){const ue=Ke.offset,he=ze.getGraphemeBreakType(Ke.nextCodePoint());if(He(je,he)){Ke.setOffset(ue);break}je=he}return Ke.offset-Ne}prevGraphemeLength(){const ze=et.getInstance(),Ke=this.c,Ne=Ke.offset;let je=ze.getGraphemeBreakType(Ke.prevCodePoint());for(;Ke.offset>0;){const ue=Ke.offset,he=ze.getGraphemeBreakType(Ke.prevCodePoint());if(He(he,je)){Ke.setOffset(ue);break}je=he}return Ne-Ke.offset}eol(){return this.c.eol()}}e.$Of=ce;function ne(Pe,ze){return new ce(Pe,ze).nextGraphemeLength()}function ye(Pe,ze){return new ce(Pe,ze).prevGraphemeLength()}function ge(Pe,ze){ze>0&&ee(Pe.charCodeAt(ze))&&ze--;const Ke=ze+ne(Pe,ze);return[Ke-ye(Pe,Ke),Ke]}function Y(Pe){const ze=new ce(Pe);let Ke=0;for(;!ze.eol();)Ke++,ze.nextGraphemeLength();return Ke}let U;function oe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ve(Pe){return U||(U=oe()),U.test(Pe)}const te=/^[\t\n\r\x20-\x7E]*$/;function ae(Pe){return te.test(Pe)}e.$Vf=/[\u2028\u2029]/;function se(Pe){return e.$Vf.test(Pe)}function X(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}function re(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}function pe(Pe,ze,Ke=""){const Ne=Pe.trimStart();if(Ne.length<ze)return Ne;const je=/\b/g;let ue=0;for(;je.test(Ne)&&!(Ne.length-je.lastIndex<ze);)ue=je.lastIndex,je.lastIndex+=1;return ue===0?Ne:Ke+Ne.substring(ue).trimStart()}const we=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Fe(Pe){let ze=0;for(const Ke of Pe.matchAll(we))ze!==Ke.index&&(yield{isCode:!1,str:Pe.substring(ze,Ke.index)}),yield{isCode:!0,str:Ke[0]},ze=Ke.index+Ke[0].length;ze!==Pe.length&&(yield{isCode:!1,str:Pe.substring(ze)})}function Be(Pe){return Pe&&(Pe=Pe.replace(we,"")),Pe}const Re=/\\\[.*?\\\]/g;function De(Pe){return Be(Pe).replace(Re,"")}e.$4f=String.fromCharCode(h.CharCode.UTF8_BOM);function Ce(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===h.CharCode.UTF8_BOM)}function V(Pe){return Ce(Pe)?Pe.substr(1):Pe}function G(Pe,ze){if(!Pe||!ze||Pe.length<ze.length)return!1;const Ke=ze.length,Ne=Pe.toLowerCase();let je=0,ue=-1;for(;je<Ke;){const he=Ne.indexOf(ze[je],ue+1);if(he<0)return!1;ue=he,je++}return!0}function J(Pe,ze=!1){return Pe?(ze&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}function x(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}function de(Pe,ze=1){if(ze===0)return"";let Ke=-1;do Ke=Pe.indexOf(`
`,Ke+1),ze--;while(ze>0&&Ke>=0);return Ke===-1?Pe:(Pe[Ke-1]==="\r"&&Ke--,Pe.substr(0,Ke))}function Ee(Pe){const ze=h.CharCode.Z-h.CharCode.A+1;return Pe=Pe%(2*ze),Pe<ze?String.fromCharCode(h.CharCode.a+Pe):String.fromCharCode(h.CharCode.A+Pe-ze)}function Le(Pe){return et.getInstance().getGraphemeBreakType(Pe)}function He(Pe,ze){return Pe===Ze.Other?ze!==Ze.Extend&&ze!==Ze.SpacingMark:Pe===Ze.CR&&ze===Ze.LF?!1:Pe===Ze.Control||Pe===Ze.CR||Pe===Ze.LF||ze===Ze.Control||ze===Ze.CR||ze===Ze.LF?!0:!(Pe===Ze.L&&(ze===Ze.L||ze===Ze.V||ze===Ze.LV||ze===Ze.LVT)||(Pe===Ze.LV||Pe===Ze.V)&&(ze===Ze.V||ze===Ze.T)||(Pe===Ze.LVT||Pe===Ze.T)&&ze===Ze.T||ze===Ze.Extend||ze===Ze.ZWJ||ze===Ze.SpacingMark||Pe===Ze.Prepend||Pe===Ze.ZWJ&&ze===Ze.Extended_Pictographic||Pe===Ze.Regional_Indicator&&ze===Ze.Regional_Indicator)}var Ze;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(Ze||(e.GraphemeBreakType=Ze={}));class et{static{this.c=null}static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=nt()}getGraphemeBreakType(ze){if(ze<32)return ze===h.CharCode.LineFeed?Ze.LF:ze===h.CharCode.CarriageReturn?Ze.CR:Ze.Control;if(ze<127)return Ze.Other;const Ke=this.d,Ne=Ke.length/3;let je=1;for(;je<=Ne;)if(ze<Ke[3*je])je=2*je;else if(ze>Ke[3*je+1])je=2*je+1;else return Ke[3*je+2];return Ze.Other}}function nt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function st(Pe,ze){if(Pe===0)return 0;const Ke=rt(Pe,ze);if(Ke!==void 0)return Ke;const Ne=new _(ze,Pe);return Ne.prevCodePoint(),Ne.offset}function rt(Pe,ze){const Ke=new _(ze,Pe);let Ne=Ke.prevCodePoint();for(;at(Ne)||Ne===gt.emojiVariantSelector||Ne===gt.enclosingKeyCap;){if(Ke.offset===0)return;Ne=Ke.prevCodePoint()}if(!re(Ne))return;let je=Ke.offset;return je>0&&Ke.prevCodePoint()===gt.zwj&&(je=Ke.offset),je}function at(Pe){return 127995<=Pe&&Pe<=127999}var gt;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(gt||(gt={})),e.$bg="\xA0";class dt{static{this.c=new C.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new r.$$e({getCacheKey:JSON.stringify},ze=>{function Ke(ut){const mt=new Map;for(let Dt=0;Dt<ut.length;Dt+=2)mt.set(ut[Dt],ut[Dt+1]);return mt}function Ne(ut,mt){const Dt=new Map(ut);for(const[Mt,Ht]of mt)Dt.set(Mt,Ht);return Dt}function je(ut,mt){if(!ut)return mt;const Dt=new Map;for(const[Mt,Ht]of ut)mt.has(Mt)&&Dt.set(Mt,Ht);return Dt}const ue=this.c.value;let he=ze.filter(ut=>!ut.startsWith("_")&&ut in ue);he.length===0&&(he=["_default"]);let le;for(const ut of he){const mt=Ke(ue[ut]);le=je(le,mt)}const Xe=Ke(ue._common),tt=Ne(Xe,le);return new dt(tt)})}static getInstance(ze){return dt.d.get(Array.from(ze))}static{this.e=new C.$T(()=>Object.keys(dt.c.value).filter(ze=>!ze.startsWith("_")))}static getLocales(){return dt.e.value}constructor(ze){this.f=ze}isAmbiguous(ze){return this.f.has(ze)}containsAmbiguousCharacter(ze){for(let Ke=0;Ke<ze.length;Ke++){const Ne=ze.codePointAt(Ke);if(typeof Ne=="number"&&this.isAmbiguous(Ne))return!0}return!1}getPrimaryConfusable(ze){return this.f.get(ze)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$cg=dt;class ct{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ct.c())),this.d}static isInvisibleCharacter(ze){return ct.e().has(ze)}static containsInvisibleCharacter(ze){for(let Ke=0;Ke<ze.length;Ke++){const Ne=ze.codePointAt(Ke);if(typeof Ne=="number"&&ct.isInvisibleCharacter(Ne))return!0}return!1}static get codePoints(){return ct.e()}}e.$dg=ct}),define(ke[31],Ie([1,0,26,16,10,12,17]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=T,e.$yg=p,e.$zg=c,e.$Ag=I,e.$Bg=S,e.$Cg=a,e.$Dg=m,e.$Eg=$,e.$Fg=f,e.$Gg=i,e.$Hg=s,e.$Ig=t,e.$Jg=o,e.$Kg=n,e.$Lg=d,e.$Mg=l,e.$Ng=D;function T(y){return y===r.CharCode.Slash||y===r.CharCode.Backslash}function p(y){return y.replace(/[\\/]/g,h.$gc.sep)}function c(y){return y.indexOf("/")===-1&&(y=p(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function I(y,k=h.$gc.sep){if(!y)return"";const A=y.length,b=y.charCodeAt(0);if(T(b)){if(T(y.charCodeAt(1))&&!T(y.charCodeAt(2))){let F=3;const N=F;for(;F<A&&!T(y.charCodeAt(F));F++);if(N!==F&&!T(y.charCodeAt(F+1))){for(F+=1;F<A;F++)if(T(y.charCodeAt(F)))return y.slice(0,F+1).replace(/[\\/]/g,k)}}return k}else if(f(b)&&y.charCodeAt(1)===r.CharCode.Colon)return T(y.charCodeAt(2))?y.slice(0,2)+k:y.slice(0,2);let v=y.indexOf("://");if(v!==-1){for(v+=3;v<A;v++)if(T(y.charCodeAt(v)))return y.slice(0,v+1)}return""}function S(y){if(!C.$j||!y||y.length<5)return!1;let k=y.charCodeAt(0);if(k!==r.CharCode.Backslash||(k=y.charCodeAt(1),k!==r.CharCode.Backslash))return!1;let A=2;const b=A;for(;A<y.length&&(k=y.charCodeAt(A),k!==r.CharCode.Backslash);A++);return!(b===A||(k=y.charCodeAt(A+1),isNaN(k)||k===r.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,P=/[/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(y,k=C.$j){const A=k?u:P;return!(!y||y.length===0||/^\s+$/.test(y)||(A.lastIndex=0,A.test(y))||k&&w.test(y)||y==="."||y===".."||k&&y[y.length-1]==="."||k&&y.length!==y.trim().length||y.length>255)}function m(y,k,A){const b=y===k;return!A||b?b:!y||!k?!1:(0,R.$Ff)(y,k)}function $(y,k,A,b=h.sep){if(y===k)return!0;if(!y||!k||k.length>y.length)return!1;if(A){if(!(0,R.$Gf)(y,k))return!1;if(k.length===y.length)return!0;let F=k.length;return k.charAt(k.length-1)===b&&F--,y.charAt(F)===b}return k.charAt(k.length-1)!==b&&(k+=b),y.indexOf(k)===0}function f(y){return y>=r.CharCode.A&&y<=r.CharCode.Z||y>=r.CharCode.a&&y<=r.CharCode.z}function i(y,k){return C.$j&&y.endsWith(":")&&(y+=h.sep),(0,h.$ic)(y)||(y=(0,h.$jc)(k,y)),y=(0,h.$hc)(y),s(y)}function s(y){return C.$j?(y=(0,R.$nf)(y,h.sep),y.endsWith(":")&&(y+=h.sep)):(y=(0,R.$nf)(y,h.sep),y||(y=h.sep)),y}function t(y){const k=(0,h.$hc)(y);return C.$j?y.length>3?!1:o(k)&&(y.length===2||k.charCodeAt(2)===r.CharCode.Backslash):k===h.$gc.sep}function o(y,k=C.$j){return k?f(y.charCodeAt(0))&&y.charCodeAt(1)===r.CharCode.Colon:!1}function n(y,k=C.$j){return o(y,k)?y[0]:void 0}function d(y,k,A){return k.length>y.length?-1:y===k?0:(A&&(y=y.toLowerCase(),k=k.toLowerCase()),y.indexOf(k))}function l(y){const k=y.split(":");let A,b,v;for(const F of k){const N=Number(F);(0,O.$ig)(N)?b===void 0?b=N:v===void 0&&(v=N):A=A?[A,F].join(":"):F}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:b!==void 0?b:void 0,column:v!==void 0?v:b!==void 0?1:void 0}}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",E="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(y,k,A=8){let b="";for(let F=0;F<A;F++){let N;F===0&&C.$j&&!k&&(A===3||A===4)?N=E:N=g,b+=N.charAt(Math.floor(Math.random()*N.length))}let v;return k?v=`${k}-${b}`:v=b,y?(0,h.$jc)(y,v):v}}),define(ke[135],Ie([1,0,26,28,179,12]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.FuzzyScore=e.$Ik=e.$Hk=void 0,e.or=O,e.$Jk=p,e.$Kk=c,e.$Lk=u,e.$Mk=D,e.$Nk=y,e.$Ok=N,e.$Pk=L,e.$Qk=M,e.$Rk=z,e.$Sk=oe,e.$Uk=se,e.$Vk=pe,e.$Wk=we,R=qe(R);function O(...Re){return function(De,Ce){for(let V=0,G=Re.length;V<G;V++){const J=Re[V](De,Ce);if(J)return J}return null}}e.$Hk=T.bind(void 0,!1),e.$Ik=T.bind(void 0,!0);function T(Re,De,Ce){if(!Ce||Ce.length<De.length)return null;let V;return Re?V=R.$Gf(Ce,De):V=Ce.indexOf(De)===0,V?De.length>0?[{start:0,end:De.length}]:[]:null}function p(Re,De){const Ce=De.toLowerCase().indexOf(Re.toLowerCase());return Ce===-1?null:[{start:Ce,end:Ce+Re.length}]}function c(Re,De){return I(Re.toLowerCase(),De.toLowerCase(),0,0)}function I(Re,De,Ce,V){if(Ce===Re.length)return[];if(V===De.length)return null;if(Re[Ce]===De[V]){let G=null;return(G=I(Re,De,Ce+1,V+1))?t({start:V,end:V+1},G):null}return I(Re,De,Ce,V+1)}function S(Re){return r.CharCode.a<=Re&&Re<=r.CharCode.z}function u(Re){return r.CharCode.A<=Re&&Re<=r.CharCode.Z}function P(Re){return r.CharCode.Digit0<=Re&&Re<=r.CharCode.Digit9}function w(Re){return Re===r.CharCode.Space||Re===r.CharCode.Tab||Re===r.CharCode.LineFeed||Re===r.CharCode.CarriageReturn}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Re=>a.add(Re.charCodeAt(0)));function m(Re){return w(Re)||a.has(Re)}function $(Re,De){return Re===De||m(Re)&&m(De)}const f=new Map;function i(Re){if(f.has(Re))return f.get(Re);let De;const Ce=(0,C.$Fk)(Re);return Ce&&(De=Ce),f.set(Re,De),De}function s(Re){return S(Re)||u(Re)||P(Re)}function t(Re,De){return De.length===0?De=[Re]:Re.end===De[0].start?De[0].start=Re.start:De.unshift(Re),De}function o(Re,De){for(let Ce=De;Ce<Re.length;Ce++){const V=Re.charCodeAt(Ce);if(u(V)||P(V)||Ce>0&&!s(Re.charCodeAt(Ce-1)))return Ce}return Re.length}function n(Re,De,Ce,V){if(Ce===Re.length)return[];if(V===De.length)return null;if(Re[Ce]!==De[V].toLowerCase())return null;{let G=null,J=V+1;for(G=n(Re,De,Ce+1,V+1);!G&&(J=o(De,J))<De.length;)G=n(Re,De,Ce+1,J),J++;return G===null?null:t({start:V,end:V+1},G)}}function d(Re){let De=0,Ce=0,V=0,G=0,J=0;for(let He=0;He<Re.length;He++)J=Re.charCodeAt(He),u(J)&&De++,S(J)&&Ce++,s(J)&&V++,P(J)&&G++;const x=De/Re.length,de=Ce/Re.length,Ee=V/Re.length,Le=G/Re.length;return{upperPercent:x,lowerPercent:de,alphaPercent:Ee,numericPercent:Le}}function l(Re){const{upperPercent:De,lowerPercent:Ce}=Re;return Ce===0&&De>.6}function g(Re){const{upperPercent:De,lowerPercent:Ce,alphaPercent:V,numericPercent:G}=Re;return Ce>.2&&De<.8&&V>.6&&G<.2}function E(Re){let De=0,Ce=0,V=0,G=0;for(let J=0;J<Re.length;J++)V=Re.charCodeAt(J),u(V)&&De++,S(V)&&Ce++,w(V)&&G++;return(De===0||Ce===0)&&G===0?Re.length<=30:De<=5}function D(Re,De){if(!De||(De=De.trim(),De.length===0)||!E(Re))return null;De.length>60&&(De=De.substring(0,60));const Ce=d(De);if(!g(Ce)){if(!l(Ce))return null;De=De.toLowerCase()}let V=null,G=0;for(Re=Re.toLowerCase();G<De.length&&(V=n(Re,De,0,G))===null;)G=o(De,G+1);return V}function y(Re,De,Ce=!1){if(!De||De.length===0)return null;let V=null,G=0;for(Re=Re.toLowerCase(),De=De.toLowerCase();G<De.length&&(V=k(Re,De,0,G,Ce),V===null);)G=A(De,G+1);return V}function k(Re,De,Ce,V,G){let J=0;if(Ce===Re.length)return[];if(V===De.length)return null;if(!$(Re.charCodeAt(Ce),De.charCodeAt(V))){const Ee=i(Re.charCodeAt(Ce));if(!Ee)return null;for(let Le=0;Le<Ee.length;Le++)if(!$(Ee[Le],De.charCodeAt(V+Le)))return null;J+=Ee.length-1}let x=null,de=V+J+1;if(x=k(Re,De,Ce+1,de,G),!G)for(;!x&&(de=A(De,de))<De.length;)x=k(Re,De,Ce+1,de,G),de++;if(!x)return null;if(Re.charCodeAt(Ce)!==De.charCodeAt(V)){const Ee=i(Re.charCodeAt(Ce));if(!Ee)return x;for(let Le=0;Le<Ee.length;Le++)if(Ee[Le]!==De.charCodeAt(V+Le))return x}return t({start:V,end:V+J+1},x)}function A(Re,De){for(let Ce=De;Ce<Re.length;Ce++)if(m(Re.charCodeAt(Ce))||Ce>0&&m(Re.charCodeAt(Ce-1)))return Ce;return Re.length}const b=O(e.$Ik,D,p),v=O(e.$Ik,D,c),F=new h.$Dc(1e4);function N(Re,De,Ce=!1){if(typeof Re!="string"||typeof De!="string")return null;let V=F.get(Re);V||(V=new RegExp(R.$of(Re),"i"),F.set(Re,V));const G=V.exec(De);return G?[{start:G.index,end:G.index+G[0].length}]:Ce?v(Re,De):b(Re,De)}function L(Re,De){const Ce=se(Re,Re.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ce?z(Ce):null}function M(Re,De,Ce,V,G,J){const x=Math.min(13,Re.length);for(;Ce<x;Ce++){const de=se(Re,De,Ce,V,G,J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(de)return de}return[0,J]}function z(Re){if(typeof Re>"u")return[];const De=[],Ce=Re[1];for(let V=Re.length-1;V>1;V--){const G=Re[V]+Ce,J=De[De.length-1];J&&J.end===G?J.end=G+1:De.push({start:G,end:G+1})}return De}const j=128;function W(){const Re=[],De=[];for(let Ce=0;Ce<=j;Ce++)De[Ce]=0;for(let Ce=0;Ce<=j;Ce++)Re.push(De.slice(0));return Re}function B(Re){const De=[];for(let Ce=0;Ce<=Re;Ce++)De[Ce]=0;return De}const ee=B(2*j),H=B(2*j),q=W(),Q=W(),_=W(),ce=!1;function ne(Re,De,Ce,V,G){function J(de,Ee,Le=" "){for(;de.length<Ee;)de=Le+de;return de}let x=` |   |${V.split("").map(de=>J(de,3)).join("|")}
`;for(let de=0;de<=Ce;de++)de===0?x+=" |":x+=`${De[de-1]}|`,x+=Re[de].slice(0,G+1).map(Ee=>J(Ee.toString(),3)).join("|")+`
`;return x}function ye(Re,De,Ce,V){Re=Re.substr(De),Ce=Ce.substr(V),console.log(ne(Q,Re,Re.length,Ce,Ce.length)),console.log(ne(_,Re,Re.length,Ce,Ce.length)),console.log(ne(q,Re,Re.length,Ce,Ce.length))}function ge(Re,De){if(De<0||De>=Re.length)return!1;const Ce=Re.codePointAt(De);switch(Ce){case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.Slash:case r.CharCode.Backslash:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:case r.CharCode.DollarSign:case r.CharCode.LessThan:case r.CharCode.GreaterThan:case r.CharCode.OpenParen:case r.CharCode.CloseParen:case r.CharCode.OpenSquareBracket:case r.CharCode.CloseSquareBracket:case r.CharCode.OpenCurlyBrace:case r.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!R.$Yf(Ce)}}function Y(Re,De){if(De<0||De>=Re.length)return!1;switch(Re.charCodeAt(De)){case r.CharCode.Space:case r.CharCode.Tab:return!0;default:return!1}}function U(Re,De,Ce){return De[Re]!==Ce[Re]}function oe(Re,De,Ce,V,G,J,x=!1){for(;De<Ce&&G<J;)Re[De]===V[G]&&(x&&(ee[De]=G),De+=1),G+=1;return De===Ce}var ve;(function(Re){Re[Re.Diag=1]="Diag",Re[Re.Left=2]="Left",Re[Re.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var te;(function(Re){Re.Default=[-100,0];function De(Ce){return!Ce||Ce.length===2&&Ce[0]===-100&&Ce[1]===0}Re.isDefault=De})(te||(e.FuzzyScore=te={}));class ae{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,Ce){this.firstMatchCanBeWeak=De,this.boostFullMatch=Ce}}e.$Tk=ae;function se(Re,De,Ce,V,G,J,x=ae.default){const de=Re.length>j?j:Re.length,Ee=V.length>j?j:V.length;if(Ce>=de||J>=Ee||de-Ce>Ee-J||!oe(De,Ce,de,G,J,Ee,!0))return;X(de,Ee,Ce,J,De,G);let Le=1,He=1,Ze=Ce,et=J;const nt=[!1];for(Le=1,Ze=Ce;Ze<de;Le++,Ze++){const dt=ee[Ze],ct=H[Ze],Pe=Ze+1<de?H[Ze+1]:Ee;for(He=dt-J+1,et=dt;et<Pe;He++,et++){let ze=Number.MIN_SAFE_INTEGER,Ke=!1;et<=ct&&(ze=re(Re,De,Ze,Ce,V,G,et,Ee,J,q[Le-1][He-1]===0,nt));let Ne=0;ze!==Number.MAX_SAFE_INTEGER&&(Ke=!0,Ne=ze+Q[Le-1][He-1]);const je=et>dt,ue=je?Q[Le][He-1]+(q[Le][He-1]>0?-5:0):0,he=et>dt+1&&q[Le][He-1]>0,le=he?Q[Le][He-2]+(q[Le][He-2]>0?-5:0):0;if(he&&(!je||le>=ue)&&(!Ke||le>=Ne))Q[Le][He]=le,_[Le][He]=ve.LeftLeft,q[Le][He]=0;else if(je&&(!Ke||ue>=Ne))Q[Le][He]=ue,_[Le][He]=ve.Left,q[Le][He]=0;else if(Ke)Q[Le][He]=Ne,_[Le][He]=ve.Diag,q[Le][He]=q[Le-1][He-1]+1;else throw new Error("not possible")}}if(ce&&ye(Re,Ce,V,J),!nt[0]&&!x.firstMatchCanBeWeak)return;Le--,He--;const st=[Q[Le][He],J];let rt=0,at=0;for(;Le>=1;){let dt=He;do{const ct=_[Le][dt];if(ct===ve.LeftLeft)dt=dt-2;else if(ct===ve.Left)dt=dt-1;else break}while(dt>=1);rt>1&&De[Ce+Le-1]===G[J+He-1]&&!U(dt+J-1,V,G)&&rt+1>q[Le][dt]&&(dt=He),dt===He?rt++:rt=1,at||(at=dt),Le--,He=dt-1,st.push(He)}Ee-J===de&&x.boostFullMatch&&(st[0]+=2);const gt=at-de;return st[0]-=gt,st}function X(Re,De,Ce,V,G,J){let x=Re-1,de=De-1;for(;x>=Ce&&de>=V;)G[x]===J[de]&&(H[x]=de,x--),de--}function re(Re,De,Ce,V,G,J,x,de,Ee,Le,He){if(De[Ce]!==J[x])return Number.MIN_SAFE_INTEGER;let Ze=1,et=!1;return x===Ce-V?Ze=Re[Ce]===G[x]?7:5:U(x,G,J)&&(x===0||!U(x-1,G,J))?(Ze=Re[Ce]===G[x]?7:5,et=!0):ge(J,x)&&(x===0||!ge(J,x-1))?Ze=5:(ge(J,x-1)||Y(J,x-1))&&(Ze=5,et=!0),Ze>1&&Ce===V&&(He[0]=!0),et||(et=U(x,G,J)||ge(J,x-1)||Y(J,x-1)),Ce===V?x>Ee&&(Ze-=et?3:5):Le?Ze+=et?2:0:Ze+=et?0:1,x+1===de&&(Ze-=et?3:5),Ze}function pe(Re,De,Ce,V,G,J,x){return Fe(Re,De,Ce,V,G,J,!0,x)}function we(Re,De,Ce,V,G,J,x){return Fe(Re,De,Ce,V,G,J,!1,x)}function Fe(Re,De,Ce,V,G,J,x,de){let Ee=se(Re,De,Ce,V,G,J,de);if(Ee&&!x)return Ee;if(Re.length>=3){const Le=Math.min(7,Re.length-1);for(let He=Ce+1;He<Le;He++){const Ze=Be(Re,He);if(Ze){const et=se(Ze,Ze.toLowerCase(),Ce,V,G,J,de);et&&(et[0]-=3,(!Ee||et[0]>Ee[0])&&(Ee=et))}}}return Ee}function Be(Re,De){if(De+1>=Re.length)return;const Ce=Re[De],V=Re[De+1];if(Ce!==V)return Re.slice(0,De)+V+Ce+Re.slice(De+2)}}),define(ke[60],Ie([1,0,12]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$xj=void 0,e.$tj=h,e.$uj=C,e.$vj=R,e.$wj=T,e.$yj=a,r=qe(r);function h($){return C($,0)}function C($,f){switch(typeof $){case"object":return $===null?R(349,f):Array.isArray($)?p($,f):c($,f);case"string":return T($,f);case"boolean":return O($,f);case"number":return R($,f);case"undefined":return R(937,f);default:return R(617,f)}}function R($,f){return(f<<5)-f+$|0}function O($,f){return R($?433:863,f)}function T($,f){f=R(149417,f);for(let i=0,s=$.length;i<s;i++)f=R($.charCodeAt(i),f);return f}function p($,f){return f=R(104579,f),$.reduce((i,s)=>C(s,i),f)}function c($,f){return f=R(181387,f),Object.keys($).sort().reduce((i,s)=>(i=T(s,i),C($[s],i)),f)}class I{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=C(f,this.g),this.g}}e.$xj=I;var S;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function u($,f,i=32){const s=i-f,t=~((1<<s)-1);return($<<f|(t&$)>>>s)>>>0}function P($,f=0,i=$.byteLength,s=0){for(let t=0;t<i;t++)$[f+t]=s}function w($,f,i="0"){for(;$.length<f;)$=i+$;return $}function a($,f=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(i=>i.toString(16).padStart(2,"0")).join(""):w(($>>>0).toString(16),f/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(S.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const i=f.length;if(i===0)return;const s=this.p;let t=this.r,o=this.u,n,d;for(o!==0?(n=o,d=-1,o=0):(n=f.charCodeAt(0),d=0);;){let l=n;if(r.$Jf(n))if(d+1<i){const g=f.charCodeAt(d+1);r.$Kf(g)?(d++,l=r.$Lf(n,g)):l=S.UNICODE_REPLACEMENT}else{o=n;break}else r.$Kf(n)&&(l=S.UNICODE_REPLACEMENT);if(t=this.w(s,t,l),d++,d<i)n=f.charCodeAt(d);else break}this.r=t,this.u=o}w(f,i,s){return s<128?f[i++]=s:s<2048?(f[i++]=192|(s&1984)>>>6,f[i++]=128|(s&63)>>>0):s<65536?(f[i++]=224|(s&61440)>>>12,f[i++]=128|(s&4032)>>>6,f[i++]=128|(s&63)>>>0):(f[i++]=240|(s&1835008)>>>18,f[i++]=128|(s&258048)>>>12,f[i++]=128|(s&4032)>>>6,f[i++]=128|(s&63)>>>0),i>=S.BLOCK_SIZE&&(this.y(),i-=S.BLOCK_SIZE,this.t+=S.BLOCK_SIZE,f[0]=f[S.BLOCK_SIZE+0],f[1]=f[S.BLOCK_SIZE+1],f[2]=f[S.BLOCK_SIZE+2]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,S.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,P(this.p,this.r),this.r>56&&(this.y(),P(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=m.g,i=this.q;for(let D=0;D<64;D+=4)f.setUint32(D,i.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)f.setUint32(D,u(f.getUint32(D-12,!1)^f.getUint32(D-32,!1)^f.getUint32(D-56,!1)^f.getUint32(D-64,!1),1),!1);let s=this.h,t=this.l,o=this.m,n=this.n,d=this.o,l,g,E;for(let D=0;D<80;D++)D<20?(l=t&o|~t&n,g=1518500249):D<40?(l=t^o^n,g=1859775393):D<60?(l=t&o|t&n|o&n,g=2400959708):(l=t^o^n,g=3395469782),E=u(s,5)+l+d+g+f.getUint32(D*4,!1)&4294967295,d=n,n=o,o=u(t,30),t=s,s=E;this.h=this.h+s&4294967295,this.l=this.l+t&4294967295,this.m=this.m+o&4294967295,this.n=this.n+n&4294967295,this.o=this.o+d&4294967295}}e.$zj=m}),define(ke[136],Ie([1,0,26,134,135,60,16,10,12]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=S,e.$Or=$,e.$Pr=l,e.$Qr=b,e.$Rr=z,e.$Sr=W;const c=0,I=[c,[]];function S(B,ee,H,q){if(!B||!ee)return I;const Q=B.length,_=ee.length;if(Q<_)return I;const ce=B.toLowerCase();return u(ee,H,_,B,ce,Q,q)}function u(B,ee,H,q,Q,_,ce){const ne=[],ye=[];for(let oe=0;oe<H;oe++){const ve=oe*_,te=ve-_,ae=oe>0,se=B[oe],X=ee[oe];for(let re=0;re<_;re++){const pe=re>0,we=ve+re,Fe=we-1,Be=te+re-1,Re=pe?ne[Fe]:0,De=ae&&pe?ne[Be]:0,Ce=ae&&pe?ye[Be]:0;let V;!De&&ae?V=0:V=P(se,X,q,Q,re,Ce),V&&De+V>=Re&&(ce||ae||Q.startsWith(ee,re))?(ye[we]=Ce+1,ne[we]=De+V):(ye[we]=c,ne[we]=Re)}}const ge=[];let Y=H-1,U=_-1;for(;Y>=0&&U>=0;){const oe=Y*_+U;ye[oe]===c||(ge.push(U),Y--),U--}return[ne[H*_-1],ge.reverse()]}function P(B,ee,H,q,Q,_){let ce=0;if(!w(ee,q[Q]))return ce;if(ce+=1,_>0&&(ce+=_*5),B===H[Q]&&(ce+=1),Q===0)ce+=8;else{const ne=a(H.charCodeAt(Q-1));ne?ce+=ne:(0,C.$Lk)(H.charCodeAt(Q))&&_===0&&(ce+=2)}return ce}function w(B,ee){return B===ee?!0:B==="/"||B==="\\"?ee==="/"||ee==="\\":!1}function a(B){switch(B){case r.CharCode.Slash:case r.CharCode.Backslash:return 5;case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:return 4;default:return 0}}const m=[void 0,[]];function $(B,ee,H=0,q=0){const Q=ee;return Q.values&&Q.values.length>1?f(B,Q.values,H,q):i(B,ee,H,q)}function f(B,ee,H,q){let Q=0;const _=[];for(const ce of ee){const[ne,ye]=i(B,ce,H,q);if(typeof ne!="number")return m;Q+=ne,_.push(...ye)}return[Q,k(_)]}function i(B,ee,H,q){const Q=(0,C.$Uk)(ee.original,ee.originalLowercase,H,B,B.toLowerCase(),q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,C.$Rk)(Q)]:m}const s=Object.freeze({score:0}),t=1<<18,o=1<<17,n=65536;function d(B,ee,H,q){const Q=q.values?q.values:[q];return(0,R.$tj)({[q.normalized]:{values:Q.map(ce=>({value:ce.normalized,expectContiguousMatch:ce.expectContiguousMatch})),label:B,description:ee,allowNonContiguousMatches:H}})}function l(B,ee,H,q,Q){if(!B||!ee.normalized)return s;const _=q.getItemLabel(B);if(!_)return s;const ce=q.getItemDescription(B),ne=d(_,ce,H,ee),ye=Q[ne];if(ye)return ye;const ge=g(_,ce,q.getItemPath(B),ee,H);return Q[ne]=ge,ge}function g(B,ee,H,q,Q){const _=!H||!q.containsPathSeparator;return H&&(T.$l?q.pathNormalized===H:(0,p.$Ff)(q.pathNormalized,H))?{score:t,labelMatch:[{start:0,end:B.length}],descriptionMatch:ee?[{start:0,end:ee.length}]:void 0}:q.values&&q.values.length>1?E(B,ee,H,q.values,_,Q):D(B,ee,H,q,_,Q)}function E(B,ee,H,q,Q,_){let ce=0;const ne=[],ye=[];for(const ge of q){const{score:Y,labelMatch:U,descriptionMatch:oe}=D(B,ee,H,ge,Q,_);if(Y===c)return s;ce+=Y,U&&ne.push(...U),oe&&ye.push(...oe)}return{score:ce,labelMatch:k(ne),descriptionMatch:k(ye)}}function D(B,ee,H,q,Q,_){if(Q||!ee){const[ce,ne]=S(B,q.normalized,q.normalizedLowercase,_&&!q.expectContiguousMatch);if(ce){const ye=(0,C.$Ik)(q.normalized,B);let ge;if(ye){ge=o;const Y=Math.round(q.normalized.length/B.length*100);ge+=Y}else ge=n;return{score:ge+ce,labelMatch:ye||y(ne)}}}if(ee){let ce=ee;H&&(ce=`${ee}${O.sep}`);const ne=ce.length,ye=`${ce}${B}`,[ge,Y]=S(ye,q.normalized,q.normalizedLowercase,_&&!q.expectContiguousMatch);if(ge){const U=y(Y),oe=[],ve=[];return U.forEach(te=>{te.start<ne&&te.end>ne?(oe.push({start:0,end:te.end-ne}),ve.push({start:te.start,end:ne})):te.start>=ne?oe.push({start:te.start-ne,end:te.end-ne}):ve.push(te)}),{score:ge,labelMatch:oe,descriptionMatch:ve}}}return s}function y(B){const ee=[];if(!B)return ee;let H;for(const q of B)H&&H.end===q?H.end+=1:(H={start:q,end:q+1},ee.push(H));return ee}function k(B){const ee=B.sort((Q,_)=>Q.start-_.start),H=[];let q;for(const Q of ee)!q||!A(q,Q)?(q=Q,H.push(Q)):(q.start=Math.min(q.start,Q.start),q.end=Math.max(q.end,Q.end));return H}function A(B,ee){return!(B.end<ee.start||ee.end<B.start)}function b(B,ee,H,q,Q,_){const ce=l(B,H,q,Q,_),ne=l(ee,H,q,Q,_),ye=ce.score,ge=ne.score;if((ye===t||ge===t)&&ye!==ge)return ye===t?-1:1;if(ye>n||ge>n){if(ye!==ge)return ye>ge?-1:1;if(ye<o&&ge<o){const se=F(ce.labelMatch,ne.labelMatch);if(se!==0)return se}const te=Q.getItemLabel(B)||"",ae=Q.getItemLabel(ee)||"";if(te.length!==ae.length)return te.length-ae.length}if(ye!==ge)return ye>ge?-1:1;const Y=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0,U=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0;if(Y&&!U)return-1;if(U&&!Y)return 1;const oe=v(B,ce,Q),ve=v(ee,ne,Q);return oe&&ve&&oe!==ve?ve>oe?-1:1:N(B,ee,H,Q)}function v(B,ee,H){let q=-1,Q=-1;if(ee.descriptionMatch&&ee.descriptionMatch.length?q=ee.descriptionMatch[0].start:ee.labelMatch&&ee.labelMatch.length&&(q=ee.labelMatch[0].start),ee.labelMatch&&ee.labelMatch.length){if(Q=ee.labelMatch[ee.labelMatch.length-1].end,ee.descriptionMatch&&ee.descriptionMatch.length){const _=H.getItemDescription(B);_&&(Q+=_.length)}}else ee.descriptionMatch&&ee.descriptionMatch.length&&(Q=ee.descriptionMatch[ee.descriptionMatch.length-1].end);return Q-q}function F(B,ee){if(!B&&!ee||(!B||!B.length)&&(!ee||!ee.length))return 0;if(!ee||!ee.length)return-1;if(!B||!B.length)return 1;const H=B[0].start,Q=B[B.length-1].end-H,_=ee[0].start,ne=ee[ee.length-1].end-_;return Q===ne?0:ne<Q?1:-1}function N(B,ee,H,q){const Q=q.getItemLabel(B)||"",_=q.getItemLabel(ee)||"",ce=q.getItemDescription(B),ne=q.getItemDescription(ee),ye=Q.length+(ce?ce.length:0),ge=_.length+(ne?ne.length:0);if(ye!==ge)return ye-ge;const Y=q.getItemPath(B),U=q.getItemPath(ee);return Y&&U&&Y.length!==U.length?Y.length-U.length:Q!==_?(0,h.$Lr)(Q,_,H.normalized):ce&&ne&&ce!==ne?(0,h.$Lr)(ce,ne,H.normalized):Y&&U&&Y!==U?(0,h.$Lr)(Y,U,H.normalized):0}function L(B){return B.startsWith('"')&&B.endsWith('"')}const M=" ";function z(B){typeof B!="string"&&(B="");const ee=B.toLowerCase(),{pathNormalized:H,normalized:q,normalizedLowercase:Q}=j(B),_=H.indexOf(O.sep)>=0,ce=L(B);let ne;const ye=B.split(M);if(ye.length>1)for(const ge of ye){const Y=L(ge),{pathNormalized:U,normalized:oe,normalizedLowercase:ve}=j(ge);oe&&(ne||(ne=[]),ne.push({original:ge,originalLowercase:ge.toLowerCase(),pathNormalized:U,normalized:oe,normalizedLowercase:ve,expectContiguousMatch:Y}))}return{original:B,originalLowercase:ee,pathNormalized:H,normalized:q,normalizedLowercase:Q,values:ne,containsPathSeparator:_,expectContiguousMatch:ce}}function j(B){let ee;T.$j?ee=B.replace(/\//g,O.sep):ee=B.replace(/\\/g,O.sep);const H=(0,p.$pf)(ee).replace(/\s|"/g,"");return{pathNormalized:ee,normalized:H,normalizedLowercase:H.toLowerCase()}}function W(B){return Array.isArray(B)?z(B.map(ee=>ee.original).join(M)):z(B.original)}}),define(ke[137],Ie([1,0,135,12,51]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=p,e.$Yk=I,e.$Zk=u,e.$1k=P,e.$2k=a,e.$3k=m;const R="$(",O=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${O.source}`,"g");function p($){return $.replace(T,(f,i)=>i?f:`\\${f}`)}const c=new RegExp(`\\\\${O.source}`,"g");function I($){return $.replace(c,f=>`\\${f}`)}const S=new RegExp(`(\\s)?(\\\\)?${O.source}(\\s)?`,"g");function u($){return $.indexOf(R)===-1?$:$.replace(S,(f,i,s,t)=>s?f:i||t||"")}function P($){return $?$.replace(/\$\((.*?)\)/g,(f,i)=>` ${i} `).trim():""}const w=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function a($){w.lastIndex=0;let f="";const i=[];let s=0;for(;;){const t=w.lastIndex,o=w.exec($),n=$.substring(t,o?.index);if(n.length>0){f+=n;for(let d=0;d<n.length;d++)i.push(s)}if(!o)break;s+=o[0].length}return{text:f,iconOffsets:i}}function m($,f,i=!1){const{text:s,iconOffsets:t}=f;if(!t||t.length===0)return(0,r.$Ok)($,s,i);const o=(0,h.$mf)(s," "),n=s.length-o.length,d=(0,r.$Ok)($,o,i);if(d)for(const l of d){const g=t[l.start+n]+n;l.start+=g,l.end+=g}return d}}),define(ke[43],Ie([1,0,12]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=qe(r);var h;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(h||(h={})),function(C){const R="error",O="warning",T="warn",p="info",c="ignore";function I(u){return u?r.$Ff(R,u)?C.Error:r.$Ff(O,u)||r.$Ff(T,u)?C.Warning:r.$Ff(p,u)?C.Info:C.Ignore:C.Ignore}C.fromValue=I;function S(u){switch(u){case C.Error:return R;case C.Warning:return O;case C.Info:return p;default:return c}}C.toString=S}(h||(h={})),e.default=h}),define(ke[84],Ie([1,0,18,26,12]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class R{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const a=w.charCodeAt(0),m=this.b.charCodeAt(this.c);return a-m}value(){return this.b[this.c]}}e.$Hi=R;class O{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===h.CharCode.Period)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,C.$zf)(w,this.b,0,w.length,this.c,this.d):(0,C.$Bf)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=O;class T{constructor(w=!0,a=!0){this.f=w,this.g=a}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let a=w.length-1;a>=0;a--,this.c--){const m=this.b.charCodeAt(a);if(!(m===h.CharCode.Slash||this.f&&m===h.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const a=this.b.charCodeAt(this.e);if(a===h.CharCode.Slash||this.f&&a===h.CharCode.Backslash)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,C.$zf)(w,this.b,0,w.length,this.d,this.e):(0,C.$Bf)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=T;var p;(function(P){P[P.Scheme=1]="Scheme",P[P.Authority=2]="Authority",P[P.Path=3]="Path",P[P.Query=4]="Query",P[P.Fragment=5]="Fragment"})(p||(p={}));class c{constructor(w,a){this.f=w,this.g=a,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new T(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(p.Path)),this.g(w)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===p.Scheme)return(0,C.$Af)(w,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,C.$Af)(w,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(w);if(this.d[this.e]===p.Query)return(0,C.$yf)(w,this.c.query);if(this.d[this.e]===p.Fragment)return(0,C.$yf)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Ki=c;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(P){P[P.Left=-1]="Left",P[P.Mid=0]="Mid",P[P.Right=1]="Right"})(S||(S={}));class u{static forUris(w=()=>!1,a=()=>!1){return new u(new c(w,a))}static forPaths(w=!1){return new u(new T(void 0,!w))}static forStrings(){return new u(new R)}static forConfigKeys(){return new u(new O)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,a){if(a){const m=a.slice(0);(0,r.$Vb)(m);for(const $ of m)this.set($,w)}else{const m=w.slice(0);(0,r.$Vb)(m);for(const $ of m)this.set($[0],$[1])}}set(w,a){const m=this.b.reset(w);let $;this.c||(this.c=new I,this.c.segment=m.value());const f=[];for($=this.c;;){const s=m.cmp($.segment);if(s>0)$.left||($.left=new I,$.left.segment=m.value()),f.push([S.Left,$]),$=$.left;else if(s<0)$.right||($.right=new I,$.right.segment=m.value()),f.push([S.Right,$]),$=$.right;else if(m.hasNext())m.next(),$.mid||($.mid=new I,$.mid.segment=m.value()),f.push([S.Mid,$]),$=$.mid;else break}const i=$.value;$.value=a,$.key=w;for(let s=f.length-1;s>=0;s--){const t=f[s][1];t.updateHeight();const o=t.balanceFactor();if(o<-1||o>1){const n=f[s][0],d=f[s+1][0];if(n===S.Right&&d===S.Right)f[s][1]=t.rotateLeft();else if(n===S.Left&&d===S.Left)f[s][1]=t.rotateRight();else if(n===S.Right&&d===S.Left)t.right=f[s+1][1]=f[s+1][1].rotateRight(),f[s][1]=t.rotateLeft();else if(n===S.Left&&d===S.Right)t.left=f[s+1][1]=f[s+1][1].rotateLeft(),f[s][1]=t.rotateRight();else throw new Error;if(s>0)switch(f[s-1][0]){case S.Left:f[s-1][1].left=f[s][1];break;case S.Right:f[s-1][1].right=f[s][1];break;case S.Mid:f[s-1][1].mid=f[s][1];break}else this.c=f[0][1]}}return i}get(w){return this.d(w)?.value}d(w){const a=this.b.reset(w);let m=this.c;for(;m;){const $=a.cmp(m.segment);if($>0)m=m.left;else if($<0)m=m.right;else if(a.hasNext())a.next(),m=m.mid;else break}return m}has(w){const a=this.d(w);return!(a?.value===void 0&&a?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,a){const m=this.b.reset(w),$=[];let f=this.c;for(;f;){const i=m.cmp(f.segment);if(i>0)$.push([S.Left,f]),f=f.left;else if(i<0)$.push([S.Right,f]),f=f.right;else if(m.hasNext())m.next(),$.push([S.Mid,f]),f=f.mid;else break}if(f){if(a?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const i=this.f(f.right);if(i.key){const{key:s,value:t,segment:o}=i;this.e(i.key,!1),f.key=s,f.value=t,f.segment=o}}else{const i=f.left??f.right;if($.length>0){const[s,t]=$[$.length-1];switch(s){case S.Left:t.left=i;break;case S.Mid:t.mid=i;break;case S.Right:t.right=i;break}}else this.c=i}for(let i=$.length-1;i>=0;i--){const s=$[i][1];s.updateHeight();const t=s.balanceFactor();if(t>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),$[i][1]=s.rotateLeft()):t<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),$[i][1]=s.rotateRight()),i>0)switch($[i-1][0]){case S.Left:$[i-1][1].left=$[i][1];break;case S.Right:$[i-1][1].right=$[i][1];break;case S.Mid:$[i-1][1].mid=$[i][1];break}else this.c=$[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const a=this.b.reset(w);let m=this.c,$;for(;m;){const f=a.cmp(m.segment);if(f>0)m=m.left;else if(f<0)m=m.right;else if(a.hasNext())a.next(),$=m.value||$,m=m.mid;else break}return m&&m.value||$}findSuperstr(w){return this.g(w,!1)}g(w,a){const m=this.b.reset(w);let $=this.c;for(;$;){const f=m.cmp($.segment);if(f>0)$=$.left;else if(f<0)$=$.right;else if(m.hasNext())m.next(),$=$.mid;else return $.mid?this.h($.mid):a?$.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[a,m]of this)w(m,a)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const a=[];return this.j(w,a),a[Symbol.iterator]()}j(w,a){w&&(w.left&&this.j(w.left,a),w.value&&a.push([w.key,w.value]),w.mid&&this.j(w.mid,a),w.right&&this.j(w.right,a))}_isBalanced(){const w=a=>{if(!a)return!0;const m=a.balanceFactor();return m<-1||m>1?!1:w(a.left)&&w(a.right)};return w(this.c)}}e.$Li=u}),define(ke[2],Ie([1,0,26,40,16,10]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=m,e.$wc=o,C=qe(C);const O=/^\w[\w\d+.-]*$/,T=/^\//,p=/^\/\//;function c(E,D){if(!E.scheme&&D)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${E.authority}", path: "${E.path}", query: "${E.query}", fragment: "${E.fragment}"}`);if(E.scheme&&!O.test(E.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(E.path){if(E.authority){if(!T.test(E.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(E.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(E,D){return!E&&!D?"file":E}function S(E,D){switch(E){case"https":case"http":case"file":D?D[0]!==P&&(D=P+D):D=P;break}return D}const u="",P="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(D){return D instanceof a?!0:D?typeof D.authority=="string"&&typeof D.fragment=="string"&&typeof D.path=="string"&&typeof D.query=="string"&&typeof D.scheme=="string"&&typeof D.fsPath=="string"&&typeof D.with=="function"&&typeof D.toString=="function":!1}constructor(D,y,k,A,b,v=!1){typeof D=="object"?(this.scheme=D.scheme||u,this.authority=D.authority||u,this.path=D.path||u,this.query=D.query||u,this.fragment=D.fragment||u):(this.scheme=I(D,v),this.authority=y||u,this.path=S(this.scheme,k||u),this.query=A||u,this.fragment=b||u,c(this,v))}get fsPath(){return o(this,!1)}with(D){if(!D)return this;let{scheme:y,authority:k,path:A,query:b,fragment:v}=D;return y===void 0?y=this.scheme:y===null&&(y=u),k===void 0?k=this.authority:k===null&&(k=u),A===void 0?A=this.path:A===null&&(A=u),b===void 0?b=this.query:b===null&&(b=u),v===void 0?v=this.fragment:v===null&&(v=u),y===this.scheme&&k===this.authority&&A===this.path&&b===this.query&&v===this.fragment?this:new f(y,k,A,b,v)}static parse(D,y=!1){const k=w.exec(D);return k?new f(k[2]||u,g(k[4]||u),g(k[5]||u),g(k[7]||u),g(k[9]||u),y):new f(u,u,u,u,u)}static file(D){let y=u;if(R.$j&&(D=D.replace(/\\/g,P)),D[0]===P&&D[1]===P){const k=D.indexOf(P,2);k===-1?(y=D.substring(2),D=P):(y=D.substring(2,k),D=D.substring(k)||P)}return new f("file",y,D,u,u)}static from(D,y){return new f(D.scheme,D.authority,D.path,D.query,D.fragment,y)}static joinPath(D,...y){if(!D.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return R.$j&&D.scheme==="file"?k=a.file(C.$fc.join(o(D,!0),...y)).path:k=C.$gc.join(D.path,...y),D.with({path:k})}toString(D=!1){return n(this,D)}toJSON(){return this}static revive(D){if(D){if(D instanceof a)return D;{const y=new f(D);return y._formatted=D.external??null,y._fsPath=D._sep===$?D.fsPath??null:null,y}}else return D}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=a;function m(E){return!E||typeof E!="object"?!1:typeof E.scheme=="string"&&(typeof E.authority=="string"||typeof E.authority>"u")&&(typeof E.path=="string"||typeof E.path>"u")&&(typeof E.query=="string"||typeof E.query>"u")&&(typeof E.fragment=="string"||typeof E.fragment>"u")}const $=R.$j?1:void 0;class f extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(D=!1){return D?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const D={$mid:h.MarshalledId.Uri};return this._fsPath&&(D.fsPath=this._fsPath,D._sep=$),this._formatted&&(D.external=this._formatted),this.path&&(D.path=this.path),this.scheme&&(D.scheme=this.scheme),this.authority&&(D.authority=this.authority),this.query&&(D.query=this.query),this.fragment&&(D.fragment=this.fragment),D}}const i={[r.CharCode.Colon]:"%3A",[r.CharCode.Slash]:"%2F",[r.CharCode.QuestionMark]:"%3F",[r.CharCode.Hash]:"%23",[r.CharCode.OpenSquareBracket]:"%5B",[r.CharCode.CloseSquareBracket]:"%5D",[r.CharCode.AtSign]:"%40",[r.CharCode.ExclamationMark]:"%21",[r.CharCode.DollarSign]:"%24",[r.CharCode.Ampersand]:"%26",[r.CharCode.SingleQuote]:"%27",[r.CharCode.OpenParen]:"%28",[r.CharCode.CloseParen]:"%29",[r.CharCode.Asterisk]:"%2A",[r.CharCode.Plus]:"%2B",[r.CharCode.Comma]:"%2C",[r.CharCode.Semicolon]:"%3B",[r.CharCode.Equals]:"%3D",[r.CharCode.Space]:"%20"};function s(E,D,y){let k,A=-1;for(let b=0;b<E.length;b++){const v=E.charCodeAt(b);if(v>=r.CharCode.a&&v<=r.CharCode.z||v>=r.CharCode.A&&v<=r.CharCode.Z||v>=r.CharCode.Digit0&&v<=r.CharCode.Digit9||v===r.CharCode.Dash||v===r.CharCode.Period||v===r.CharCode.Underline||v===r.CharCode.Tilde||D&&v===r.CharCode.Slash||y&&v===r.CharCode.OpenSquareBracket||y&&v===r.CharCode.CloseSquareBracket||y&&v===r.CharCode.Colon)A!==-1&&(k+=encodeURIComponent(E.substring(A,b)),A=-1),k!==void 0&&(k+=E.charAt(b));else{k===void 0&&(k=E.substr(0,b));const F=i[v];F!==void 0?(A!==-1&&(k+=encodeURIComponent(E.substring(A,b)),A=-1),k+=F):A===-1&&(A=b)}}return A!==-1&&(k+=encodeURIComponent(E.substring(A))),k!==void 0?k:E}function t(E){let D;for(let y=0;y<E.length;y++){const k=E.charCodeAt(y);k===r.CharCode.Hash||k===r.CharCode.QuestionMark?(D===void 0&&(D=E.substr(0,y)),D+=i[k]):D!==void 0&&(D+=E[y])}return D!==void 0?D:E}function o(E,D){let y;return E.authority&&E.path.length>1&&E.scheme==="file"?y=`//${E.authority}${E.path}`:E.path.charCodeAt(0)===r.CharCode.Slash&&(E.path.charCodeAt(1)>=r.CharCode.A&&E.path.charCodeAt(1)<=r.CharCode.Z||E.path.charCodeAt(1)>=r.CharCode.a&&E.path.charCodeAt(1)<=r.CharCode.z)&&E.path.charCodeAt(2)===r.CharCode.Colon?D?y=E.path.substr(1):y=E.path[1].toLowerCase()+E.path.substr(2):y=E.path,R.$j&&(y=y.replace(/\//g,"\\")),y}function n(E,D){const y=D?t:s;let k="",{scheme:A,authority:b,path:v,query:F,fragment:N}=E;if(A&&(k+=A,k+=":"),(b||A==="file")&&(k+=P,k+=P),b){let L=b.indexOf("@");if(L!==-1){const M=b.substr(0,L);b=b.substr(L+1),L=M.lastIndexOf(":"),L===-1?k+=y(M,!1,!1):(k+=y(M.substr(0,L),!1,!1),k+=":",k+=y(M.substr(L+1),!1,!0)),k+="@"}b=b.toLowerCase(),L=b.lastIndexOf(":"),L===-1?k+=y(b,!1,!0):(k+=y(b.substr(0,L),!1,!0),k+=b.substr(L))}if(v){if(v.length>=3&&v.charCodeAt(0)===r.CharCode.Slash&&v.charCodeAt(2)===r.CharCode.Colon){const L=v.charCodeAt(1);L>=r.CharCode.A&&L<=r.CharCode.Z&&(v=`/${String.fromCharCode(L+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===r.CharCode.Colon){const L=v.charCodeAt(0);L>=r.CharCode.A&&L<=r.CharCode.Z&&(v=`${String.fromCharCode(L+32)}:${v.substr(2)}`)}k+=y(v,!0,!1)}return F&&(k+="?",k+=y(F,!1,!1)),N&&(k+="#",k+=D?N:s(N,!1,!1)),k}function d(E){try{return decodeURIComponent(E)}catch{return E.length>3?E.substr(0,3)+d(E.substr(3)):E}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function g(E){return E.match(l)?E.replace(l,D=>d(D)):E}}),define(ke[188],Ie([1,0,2]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=h,e.$er=C,e.$fr=R,e.log=T;function h(c){const I=c;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function C(c){const I=[];let S;try{const u=JSON.parse(c.arguments),P=u[u.length-1];P&&P.__$stack&&(u.pop(),S=P.__$stack),I.push(...u)}catch{I.push("Unable to log remote console arguments",c.arguments)}return{args:I,stack:S}}function R(c){if(typeof c!="string")return R(C(c).stack);const I=c;if(I){const S=O(I),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(u&&u.length===4)return{uri:r.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function O(c){if(!c)return c;const I=c.indexOf(`
`);return I===-1?c:c.substring(0,I)}function T(c,I){const{args:S,stack:u}=C(c),P=typeof S[0]=="string"&&S.length===1;let w=O(u);w&&(w=`(${w.trim()})`);let a=[];if(typeof S[0]=="string"?w&&P?a=[`%c[${I}] %c${S[0]} %c${w}`,p("blue"),p(""),p("grey")]:a=[`%c[${I}] %c${S[0]}`,p("blue"),p(""),...S.slice(1)]:a=[`%c[${I}]%`,p("blue"),...S],w&&!P&&a.push(w),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,a)}function p(c){return`color: ${c}`}}),define(ke[44],Ie([1,0,21,2,40]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=R,e.$bi=O,e.$ci=p;function R(c){return JSON.stringify(c,T)}function O(c){let I=JSON.parse(c);return I=p(I),I}function T(c,I){return I instanceof RegExp?{$mid:C.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function p(c,I=0){if(!c||I>200)return c;if(typeof c=="object"){switch(c.$mid){case C.MarshalledId.Uri:return h.URI.revive(c);case C.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case C.MarshalledId.Date:return new Date(c.source)}if(c instanceof r.$Ne||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let S=0;S<c.length;++S)c[S]=p(c[S],I+1);else for(const S in c)Object.hasOwnProperty.call(c,S)&&(c[S]=p(c[S],I+1))}return c}}),define(ke[14],Ie([1,0,13,10,12,2,16]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=p,e.$Pg=c,e.$Tg=S,r=qe(r),h=qe(h),O=qe(O);var T;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatCodeBlock="vscode-chat-code-block",w.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",w.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm",w.commentsInput="comment",w.codeSetting="code-setting"})(T||(e.Schemas=T={}));function p(w,a){return R.URI.isUri(w)?(0,C.$Ff)(w.scheme,a):(0,C.$Gf)(w,a+":")}function c(w,...a){return a.some(m=>p(w,m))}e.$Qg="vscode-tkn",e.$Rg="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a,m){this.f=S(a,m)}getServerRootPath(){return this.f}get g(){return O.$gc.join(this.f,T.vscodeRemoteResource)}set(a,m,$){this.a[a]=m,this.b[a]=$}setConnectionToken(a,m){this.c[a]=m}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(t){return r.$Y(t),a}const m=a.authority;let $=this.a[m];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const f=this.b[m],i=this.c[m];let s=`path=${encodeURIComponent(a.path)}`;return typeof i=="string"&&(s+=`&${e.$Rg}=${encodeURIComponent(i)}`),R.URI.from({scheme:h.$p?this.d:T.vscodeRemoteResource,authority:`${$}:${f}`,path:this.g,query:s})}}e.$Sg=new I;function S(w,a){return O.$gc.join(a??"/",`${w.quality??"oss"}-${w.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class u{static{this.a=e.$Yg}asBrowserUri(a){const m=this.b(a,$e);return this.uriToBrowserUri(m)}uriToBrowserUri(a){return a.scheme===T.vscodeRemote?e.$Sg.rewrite(a):a.scheme===T.file&&(h.$n||h.$r===`${T.vscodeFileResource}://${u.a}`)?a.with({scheme:T.vscodeFileResource,authority:a.authority||u.a,query:null,fragment:null}):a}asFileUri(a){const m=this.b(a,$e);return this.uriToFileUri(m)}uriToFileUri(a){return a.scheme===T.vscodeFileResource?a.with({scheme:T.file,authority:a.authority!==u.a?a.authority:null,query:null,fragment:null}):a}b(a,m){return R.URI.isUri(a)?a:R.URI.parse(m.toUrl(a))}}e.$Zg=new u;var P;(function(w){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(a.get("3"));const m="vscode-coi";function $(i){let s;typeof i=="string"?s=new URL(i).searchParams:i instanceof URL?s=i.searchParams:R.URI.isUri(i)&&(s=new URL(i.toString(!0)).searchParams);const t=s?.get(m);if(t)return a.get(t)}w.getHeadersFromQuery=$;function f(i,s,t){if(!globalThis.crossOriginIsolated)return;const o=s&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(m,o):i[m]=o}w.addSearchParam=f})(P||(e.COI=P={}))}),define(ke[189],Ie([1,0,174,14,10,17,2]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CE=S,e.$DE=u,C=qe(C);class T{constructor(w,a,m){this.id=w,this.dependencies=a,this.callback=m}}class p{static{this.INSTANCE=new p}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,a,m)=>{typeof w!="string"&&(m=a,a=w,w=null),(typeof a!="object"||!Array.isArray(a))&&(m=a,a=null),this.c.push(new T(w,a,m))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const a=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!a)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(a.dependencies)&&a.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${a.dependencies.join(", ")}`);return typeof a.callback=="function"?a.callback([]):a.callback}h(w){return new Promise((a,m)=>{const $=document.createElement("script");$.setAttribute("async","async"),$.setAttribute("type","text/javascript");const f=()=>{$.removeEventListener("load",i),$.removeEventListener("error",s)},i=t=>{f(),a(this.c.pop())},s=t=>{f(),m(t)};$.addEventListener("load",i),$.addEventListener("error",s),this.f&&(w=this.f.createScriptURL(w)),$.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild($)})}i(w){return new Promise((a,m)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),a(this.c.pop())}catch($){m($)}})}async j(w){try{const a=globalThis._VSCODE_NODE_MODULES.fs,m=globalThis._VSCODE_NODE_MODULES.vm,$=globalThis._VSCODE_NODE_MODULES.module,f=O.URI.parse(w).fsPath,i=a.readFileSync(f).toString(),s=$.wrap(i.replace(/^#!.*/,""));return new m.Script(s).runInThisContext().apply(),this.c.pop()}catch(a){throw a}}}const c=new Map;let I={};typeof globalThis.require=="object"&&(I=globalThis.require.paths??{});async function S(P,w,a){if(r.$R){a===void 0&&(a=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),I[P]&&(P=I[P]);const m=w?`${P}/${w}`:P;if(c.has(m))return c.get(m);let $;if(/^\w[\w\d+.-]*:\/\//.test(m))$=m;else{const t=`${a&&!C.$p?h.$Wg:h.$Vg}/${m}`;$=h.$Zg.asBrowserUri(t).toString(!0)}const f=p.INSTANCE.load($);return c.set(m,f),f}else return await new Promise((m,$)=>{$e([P],m,$)}).then(qe)}function u(P,w){(0,R.$og)(r.$R);const $=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit&&!C.$p,f=`${P}/${w}`,s=`${$?h.$Wg:h.$Vg}/${f}`;return h.$Zg.asBrowserUri(s).toString(!0)}}),define(ke[22],Ie([1,0,26,31,14,16,10,12,2]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=c,e.$ph=S,e.$qh=P,h=qe(h),R=qe(R);function c(w){return(0,p.$wc)(w,!0)}class I{constructor(a){this.a=a}compare(a,m,$=!1){return a===m?0:(0,T.$yf)(this.getComparisonKey(a,$),this.getComparisonKey(m,$))}isEqual(a,m,$=!1){return a===m?!0:!a||!m?!1:this.getComparisonKey(a,$)===this.getComparisonKey(m,$)}getComparisonKey(a,m=!1){return a.with({path:this.a(a)?a.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(a){return this.a(a)}isEqualOrParent(a,m,$=!1){if(a.scheme===m.scheme){if(a.scheme===C.Schemas.file)return h.$Eg(c(a),c(m),this.a(a))&&a.query===m.query&&($||a.fragment===m.fragment);if((0,e.$lh)(a.authority,m.authority))return h.$Eg(a.path,m.path,this.a(a),"/")&&a.query===m.query&&($||a.fragment===m.fragment)}return!1}joinPath(a,...m){return p.URI.joinPath(a,...m)}basenameOrAuthority(a){return(0,e.$dh)(a)||a.authority}basename(a){return R.$gc.basename(a.path)}extname(a){return R.$gc.extname(a.path)}dirname(a){if(a.path.length===0)return a;let m;return a.scheme===C.Schemas.file?m=p.URI.file(R.$mc(c(a))).path:(m=R.$gc.dirname(a.path),a.authority&&m.length&&m.charCodeAt(0)!==r.CharCode.Slash&&(console.error(`dirname("${a.toString})) resulted in a relative path`),m="/")),a.with({path:m})}normalizePath(a){if(!a.path.length)return a;let m;return a.scheme===C.Schemas.file?m=p.URI.file(R.$hc(c(a))).path:m=R.$gc.normalize(a.path),a.with({path:m})}relativePath(a,m){if(a.scheme!==m.scheme||!(0,e.$lh)(a.authority,m.authority))return;if(a.scheme===C.Schemas.file){const i=R.$lc(c(a),c(m));return O.$j?h.$yg(i):i}let $=a.path||"/";const f=m.path||"/";if(this.a(a)){let i=0;for(const s=Math.min($.length,f.length);i<s&&!($.charCodeAt(i)!==f.charCodeAt(i)&&$.charAt(i).toLowerCase()!==f.charAt(i).toLowerCase());i++);$=f.substr(0,i)+$.substr(i)}return R.$gc.relative($,f)}resolvePath(a,m){if(a.scheme===C.Schemas.file){const $=p.URI.file(R.$kc(c(a),m));return a.with({authority:$.authority,path:$.path})}return m=h.$zg(m),a.with({path:R.$gc.resolve(a.path,m)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,m){return a===m||a!==void 0&&m!==void 0&&(0,T.$Ff)(a,m)}hasTrailingPathSeparator(a,m=R.sep){if(a.scheme===C.Schemas.file){const $=c(a);return $.length>h.$Ag($).length&&$[$.length-1]===m}else{const $=a.path;return $.length>1&&$.charCodeAt($.length-1)===r.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,m=R.sep){return(0,e.$mh)(a,m)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,m=R.sep){let $=!1;if(a.scheme===C.Schemas.file){const f=c(a);$=f!==void 0&&f.length===h.$Ag(f).length&&f[f.length-1]===m}else{m="/";const f=a.path;$=f.length===1&&f.charCodeAt(f.length-1)===r.CharCode.Slash}return!$&&!(0,e.$mh)(a,m)?a.with({path:a.path+"/"}):a}}e.$8g=I,e.$9g=new I(()=>!1),e.$0g=new I(w=>w.scheme===C.Schemas.file?!O.$l:!0),e.$$g=new I(w=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function S(w,a){const m=[];for(let $=0;$<w.length;$++){const f=a(w[$]);w.some((i,s)=>s===$?!1:(0,e.$ah)(f,a(i)))||m.push(w[$])}return m}var u;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function a(m){const $=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(s=>{const[t,o]=s.split(":");t&&o&&$.set(t,o)});const i=m.path.substring(0,m.path.indexOf(";"));return i&&$.set(w.META_DATA_MIME,i),$}w.parseMetaData=a})(u||(e.DataUri=u={}));function P(w,a,m){if(a){let $=w.path;return $&&$[0]!==R.$gc.sep&&($=R.$gc.sep+$),w.with({scheme:m,authority:a,path:$})}return w.with({scheme:m})}}),define(ke[7],Ie([1,0,20,13,4,3,22,10,186,50]),function($e,e,r,h,C,R,O,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=I,e.$sh=S,e.$th=u,e.$uh=P,e.$vh=w,e.$wh=a,e.$xh=m,e.$yh=$,e.$Gh=E,e.$Hh=D,e.$Ih=y,e.$Jh=k,e.$Kh=A,e.$Zh=q,e.$8h=te;function I(se){return!!se&&typeof se.then=="function"}function S(se){const X=new r.$we,re=se(X.token),pe=new Promise((we,Fe)=>{const Be=X.token.onCancellationRequested(()=>{Be.dispose(),Fe(new h.$4)});Promise.resolve(re).then(Re=>{Be.dispose(),X.dispose(),we(Re)},Re=>{Be.dispose(),X.dispose(),Fe(Re)})});return new class{cancel(){X.cancel(),X.dispose()}then(we,Fe){return pe.then(we,Fe)}catch(we){return this.then(void 0,we)}finally(we){return pe.finally(we)}}}function u(se,X,re){return new Promise((pe,we)=>{const Fe=X.onCancellationRequested(()=>{Fe.dispose(),pe(re)});se.then(pe,we).finally(()=>Fe.dispose())})}function P(se,X){return new Promise((re,pe)=>{const we=X.onCancellationRequested(()=>{we.dispose(),pe(new h.$4)});se.then(re,pe).finally(()=>we.dispose())})}async function w(se){let X=-1;const re=se.map((pe,we)=>pe.then(Fe=>(X=we,Fe)));try{return await Promise.race(re)}finally{se.forEach((pe,we)=>{we!==X&&pe.cancel()})}}function a(se,X,re){let pe;const we=setTimeout(()=>{pe?.(void 0),re?.()},X);return Promise.race([se.finally(()=>clearTimeout(we)),new Promise(Fe=>pe=Fe)])}function m(se){return new Promise((X,re)=>{const pe=se();I(pe)?pe.then(X,re):X(pe)})}function $(){let se,X;return{promise:new Promise((pe,we)=>{se=pe,X=we}),resolve:se,reject:X}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const re=()=>{if(this.b=null,this.f)return;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(re,re).then(pe)})}return new Promise((re,pe)=>{this.b.then(re,pe)})}return this.a=X(),new Promise((re,pe)=>{this.a.then(we=>{this.a=null,re(we)},we=>{this.a=null,pe(we)})})}dispose(){this.f=!0}}e.$zh=f;class i{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$Ah=i;class s{constructor(){this.a=new Map}queue(X,re){const we=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(re).finally(()=>{this.a.get(X)===we&&this.a.delete(X)});return this.a.set(X,we),we}}e.$Bh=s;const t=(se,X)=>{let re=!0;const pe=setTimeout(()=>{re=!1,X()},se);return{isTriggered:()=>re,dispose:()=>{clearTimeout(pe),re=!1}}},o=se=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,se())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class n{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,re=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((we,Fe)=>{this.d=we,this.f=Fe}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=re===p.$ge?o(pe):t(re,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new h.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=n;class d{constructor(X){this.a=new n(X),this.b=new f}trigger(X,re){return this.a.trigger(()=>this.b.queue(X),re)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=d;class l{constructor(){this.a=!1,this.b=new Promise((X,re)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=l;class g extends l{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$Fh=g;function E(se,X){return X?new Promise((re,pe)=>{const we=setTimeout(()=>{Fe.dispose(),re()},se),Fe=X.onCancellationRequested(()=>{clearTimeout(we),Fe.dispose(),pe(new h.$4)})}):S(re=>E(se,re))}function D(se,X=0,re){const pe=setTimeout(()=>{se(),re&&we.dispose()},X),we=(0,R.$Sc)(()=>{clearTimeout(pe),re?.deleteAndLeak(we)});return re?.add(we),we}function y(se){const X=[];let re=0;const pe=se.length;function we(){return re<pe?se[re++]():null}function Fe(Be){Be!=null&&X.push(Be);const Re=we();return Re?Re.then(Fe):Promise.resolve(X)}return Promise.resolve(null).then(Fe)}function k(se,X=pe=>!!pe,re=null){let pe=0;const we=se.length,Fe=()=>{if(pe>=we)return Promise.resolve(re);const Be=se[pe++];return Promise.resolve(Be()).then(De=>X(De)?Promise.resolve(De):Fe())};return Fe()}function A(se,X=pe=>!!pe,re=null){if(se.length===0)return Promise.resolve(re);let pe=se.length;const we=()=>{pe=-1;for(const Fe of se)Fe.cancel?.()};return new Promise((Fe,Be)=>{for(const Re of se)Re.then(De=>{--pe>=0&&X(De)?(we(),Fe(De)):pe===0&&Fe(re)}).catch(De=>{--pe>=0&&(we(),Be(De))})})}class b{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new C.$le}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((re,pe)=>{this.g.push({factory:X,c:re,e:pe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const re=X.factory();re.then(X.c,X.e),re.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=b;class v extends b{constructor(){super(1)}}e.$Mh=v;class F{constructor(){this.a=new Q,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Nh=F;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new ne;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,re=O.$9g){const pe=re.getComparisonKey(X);return this.a.get(pe)?.size??0}queueFor(X,re,pe=O.$9g){const we=pe.getComparisonKey(X);let Fe=this.a.get(we);if(!Fe){Fe=new v;const Be=this.f++,Re=C.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(Be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$4c),this.d.set(Be,Re),this.a.set(we,Fe)}return Fe.queue(re)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=N;class L{constructor(X,re){this.b=!1,this.a=-1,typeof X=="function"&&typeof re=="number"&&this.setIfNotSet(X,re)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,re){if(this.b)throw new h.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},re)}setIfNotSet(X,re){if(this.b)throw new h.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},re))}}e.$Ph=L;class M{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,re,pe=globalThis){if(this.f)throw new h.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const we=pe.setInterval(()=>{X()},re);this.d=(0,R.$Sc)(()=>{pe.clearInterval(we),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=M;class z{constructor(X,re){this.b=-1,this.a=X,this.d=re,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=z;class j{constructor(X,re){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.a=X,this.b=re,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=j;class W extends z{constructor(X,re){super(X,re),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Th=W;class B extends R.$Uc{constructor(X,re){super(),this.g=X,this.h=re,this.a=[],this.b=this.B(new R.$Vc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const re of X)this.a.push(re);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=B,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(se,X)=>{(0,T.$C)(()=>{if(re)return;const pe=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.$Wh=(se,X,re)=>{const pe=se.requestIdleCallback(X,typeof re=="number"?{timeout:re}:void 0);let we=!1;return{dispose(){we||(we=!0,se.cancelIdleCallback(pe))}}},e.$Vh=se=>(0,e.$Wh)(globalThis,se)}();class ee{constructor(X,re){this.g=!1,this.d=()=>{try{this.j=re()}catch(pe){this.l=pe}finally{this.g=!0}},this.f=(0,e.$Wh)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=ee;class H extends ee{constructor(X){super(globalThis,X)}}e.$Yh=H;async function q(se,X,re){let pe;for(let we=0;we<re;we++)try{return await se()}catch(Fe){pe=Fe,await E(X)}throw pe}class Q{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,re,pe){return this.a={taskId:X,cancel:()=>pe?.(),promise:re},re.then(()=>this.d(X),()=>this.d(X)),re}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:re,resolve:pe,reject:we}=$();this.b={run:X,promise:re,promiseResolve:pe,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=Q;class _{constructor(X,re=()=>Date.now()){this.d=X,this.f=re,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$2h=_;var ce;(function(se){se[se.Resolved=0]="Resolved",se[se.Rejected=1]="Rejected"})(ce||(ce={}));class ne{get isRejected(){return this.d?.outcome===ce.Rejected}get isResolved(){return this.d?.outcome===ce.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ce.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((X,re)=>{this.a=X,this.b=re})}complete(X){return new Promise(re=>{this.a(X),this.d={outcome:ce.Resolved,value:X},re()})}error(X){return new Promise(re=>{this.b(X),this.d={outcome:ce.Rejected,value:X},re()})}cancel(){return this.error(new h.$4)}}e.$3h=ne;var ye;(function(se){async function X(pe){let we;const Fe=await Promise.all(pe.map(Be=>Be.then(Re=>Re,Re=>{we||(we=Re)})));if(typeof we<"u")throw we;return Fe}se.settled=X;function re(pe){return new Promise(async(we,Fe)=>{try{await pe(we,Fe)}catch(Be){Fe(Be)}})}se.withAsyncBody=re})(ye||(e.Promises=ye={}));class ge{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(re=>(this.a=re,this.d=!0,re),re=>{throw this.b=re,this.d=!0,re})}requireValue(){if(!this.d)throw new h.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=ge;class Y{constructor(X){this.b=X,this.a=new c.$T(()=>new ge(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=Y;var U;(function(se){se[se.Initial=0]="Initial",se[se.DoneOK=1]="DoneOK",se[se.DoneError=2]="DoneError"})(U||(U={}));class oe{static fromArray(X){return new oe(re=>{re.emitMany(X)})}static fromPromise(X){return new oe(async re=>{re.emitMany(await X)})}static fromPromises(X){return new oe(async re=>{await Promise.all(X.map(async pe=>re.emitOne(await pe)))})}static merge(X){return new oe(async re=>{await Promise.all(X.map(async pe=>{for await(const we of pe)re.emitOne(we)}))})}static{this.EMPTY=oe.fromArray([])}constructor(X,re){this.a=U.Initial,this.b=[],this.d=null,this.f=re,this.g=new C.$le,queueMicrotask(async()=>{const pe={emitOne:we=>this.h(we),emitMany:we=>this.j(we),reject:we=>this.l(we)};try{await Promise.resolve(X(pe)),this.k()}catch(we){this.l(we)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===U.DoneError)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===U.DoneOK)return{done:!0,value:void 0};await C.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,re){return new oe(async pe=>{for await(const we of X)pe.emitOne(re(we))})}map(X){return oe.map(this,X)}static filter(X,re){return new oe(async pe=>{for await(const we of X)re(we)&&pe.emitOne(we)})}filter(X){return oe.filter(this,X)}static coalesce(X){return oe.filter(X,re=>!!re)}coalesce(){return oe.coalesce(this)}static async toPromise(X){const re=[];for await(const pe of X)re.push(pe);return re}toPromise(){return oe.toPromise(this)}h(X){this.a===U.Initial&&(this.b.push(X),this.g.fire())}j(X){this.a===U.Initial&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===U.Initial&&(this.a=U.DoneOK,this.g.fire())}l(X){this.a===U.Initial&&(this.a=U.DoneError,this.d=X,this.g.fire())}}e.$6h=oe;class ve extends oe{constructor(X,re){super(re),this.m=X}cancel(){this.m.cancel()}}e.$7h=ve;function te(se){const X=new r.$we,re=se(X.token);return new ve(X,async pe=>{const we=X.token.onCancellationRequested(()=>{we.dispose(),X.dispose(),pe.reject(new h.$4)});try{for await(const Fe of re){if(X.token.isCancellationRequested)return;pe.emitOne(Fe)}we.dispose(),X.dispose()}catch(Fe){we.dispose(),X.dispose(),pe.reject(Fe)}})}class ae{constructor(X){this.a=new ne,this.b=new oe(we=>{if(re){we.reject(re);return}return pe&&we.emitMany(pe),this.d=Fe=>we.reject(Fe),this.f=Fe=>we.emitOne(Fe),this.a.p},X);let re,pe;this.f=we=>{pe||(pe=[]),pe.push(we)},this.d=we=>{re||(re=we)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$9h=ae}),define(ke[38],Ie([1,0,18,7,26,31,28,16,10,12]),function($e,e,r,h,C,R,O,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$vk=I,e.$yk=a,e.$zk=F,e.$Ak=N,e.$Bk=L,e.$Ck=M,e.$Dk=z,e.$Ek=ee;function I(){return Object.create(null)}e.$wk="**",e.$xk="/";const S="[/\\\\]",u="[^/\\\\]",P=/\//g;function w(H,q){switch(H){case 0:return"";case 1:return`${u}*?`;default:return`(?:${S}|${u}+${S}${q?`|${S}${u}+`:""})*?`}}function a(H,q){if(!H)return[];const Q=[];let _=!1,ce=!1,ne="";for(const ye of H){switch(ye){case q:if(!_&&!ce){Q.push(ne),ne="";continue}break;case"{":_=!0;break;case"}":_=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}ne+=ye}return ne&&Q.push(ne),Q}function m(H){if(!H)return"";let q="";const Q=a(H,e.$xk);if(Q.every(_=>_===e.$wk))q=".*";else{let _=!1;Q.forEach((ce,ne)=>{if(ce===e.$wk){if(_)return;q+=w(2,ne===Q.length-1)}else{let ye=!1,ge="",Y=!1,U="";for(const oe of ce){if(oe!=="}"&&ye){ge+=oe;continue}if(Y&&(oe!=="]"||!U)){let ve;oe==="-"?ve=oe:(oe==="^"||oe==="!")&&!U?ve="^":oe===e.$xk?ve="":ve=(0,c.$hf)(oe),U+=ve;continue}switch(oe){case"{":ye=!0;continue;case"[":Y=!0;continue;case"}":{const te=`(?:${a(ge,",").map(ae=>m(ae)).join("|")})`;q+=te,ye=!1,ge="";break}case"]":{q+="["+U+"]",Y=!1,U="";break}case"?":q+=u;continue;case"*":q+=w(1);continue;default:q+=(0,c.$hf)(oe)}}ne<Q.length-1&&(Q[ne+1]!==e.$wk||ne+2<Q.length)&&(q+=S)}_=ce===e.$wk})}return q}const $=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,s=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new O.$Dc(1e4),d=function(){return!1},l=function(){return null};function g(H,q){if(!H)return l;let Q;typeof H!="string"?Q=H.pattern:Q=H,Q=Q.trim();const _=`${Q}_${!!q.trimForExclusions}`;let ce=n.get(_);if(ce)return E(ce,H);let ne;return $.test(Q)?ce=y(Q.substr(4),Q):(ne=f.exec(D(Q,q)))?ce=k(ne[1],Q):(q.trimForExclusions?s:i).test(Q)?ce=A(Q,q):(ne=t.exec(D(Q,q)))?ce=b(ne[1].substr(1),Q,!0):(ne=o.exec(D(Q,q)))?ce=b(ne[1],Q,!1):ce=v(Q),n.set(_,ce),E(ce,H)}function E(H,q){if(typeof q=="string")return H;const Q=function(_,ce){return(0,R.$Eg)(_,q.base,!p.$l)?H((0,c.$mf)(_.substr(q.base.length),T.sep),ce):null};return Q.allBasenames=H.allBasenames,Q.allPaths=H.allPaths,Q.basenames=H.basenames,Q.patterns=H.patterns,Q}function D(H,q){return q.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function y(H,q){return function(Q,_){return typeof Q=="string"&&Q.endsWith(H)?q:null}}function k(H,q){const Q=`/${H}`,_=`\\${H}`,ce=function(ye,ge){return typeof ye!="string"?null:ge?ge===H?q:null:ye===H||ye.endsWith(Q)||ye.endsWith(_)?q:null},ne=[H];return ce.basenames=ne,ce.patterns=[q],ce.allBasenames=ne,ce}function A(H,q){const Q=B(H.slice(1,-1).split(",").map(ge=>g(ge,q)).filter(ge=>ge!==l),H),_=Q.length;if(!_)return l;if(_===1)return Q[0];const ce=function(ge,Y){for(let U=0,oe=Q.length;U<oe;U++)if(Q[U](ge,Y))return H;return null},ne=Q.find(ge=>!!ge.allBasenames);ne&&(ce.allBasenames=ne.allBasenames);const ye=Q.reduce((ge,Y)=>Y.allPaths?ge.concat(Y.allPaths):ge,[]);return ye.length&&(ce.allPaths=ye),ce}function b(H,q,Q){const _=T.sep===T.$gc.sep,ce=_?H:H.replace(P,T.sep),ne=T.sep+ce,ye=T.$gc.sep+H;let ge;return Q?ge=function(Y,U){return typeof Y=="string"&&(Y===ce||Y.endsWith(ne)||!_&&(Y===H||Y.endsWith(ye)))?q:null}:ge=function(Y,U){return typeof Y=="string"&&(Y===ce||!_&&Y===H)?q:null},ge.allPaths=[(Q?"*/":"./")+H],ge}function v(H){try{const q=new RegExp(`^${m(H)}$`);return function(Q){return q.lastIndex=0,typeof Q=="string"&&q.test(Q)?H:null}}catch{return l}}function F(H,q,Q){return!H||typeof q!="string"?!1:N(H)(q,void 0,Q)}function N(H,q={}){if(!H)return d;if(typeof H=="string"||L(H)){const Q=g(H,q);if(Q===l)return d;const _=function(ce,ne){return!!Q(ce,ne)};return Q.allBasenames&&(_.allBasenames=Q.allBasenames),Q.allPaths&&(_.allPaths=Q.allPaths),_}return j(H,q)}function L(H){const q=H;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}function M(H){return H.allBasenames||[]}function z(H){return H.allPaths||[]}function j(H,q){const Q=B(Object.getOwnPropertyNames(H).map(ge=>W(ge,H[ge],q)).filter(ge=>ge!==l)),_=Q.length;if(!_)return l;if(!Q.some(ge=>!!ge.requiresSiblings)){if(_===1)return Q[0];const ge=function(oe,ve){let te;for(let ae=0,se=Q.length;ae<se;ae++){const X=Q[ae](oe,ve);if(typeof X=="string")return X;(0,h.$rh)(X)&&(te||(te=[]),te.push(X))}return te?(async()=>{for(const ae of te){const se=await ae;if(typeof se=="string")return se}return null})():null},Y=Q.find(oe=>!!oe.allBasenames);Y&&(ge.allBasenames=Y.allBasenames);const U=Q.reduce((oe,ve)=>ve.allPaths?oe.concat(ve.allPaths):oe,[]);return U.length&&(ge.allPaths=U),ge}const ce=function(ge,Y,U){let oe,ve;for(let te=0,ae=Q.length;te<ae;te++){const se=Q[te];se.requiresSiblings&&U&&(Y||(Y=(0,T.$nc)(ge)),oe||(oe=Y.substr(0,Y.length-(0,T.$oc)(ge).length)));const X=se(ge,Y,oe,U);if(typeof X=="string")return X;(0,h.$rh)(X)&&(ve||(ve=[]),ve.push(X))}return ve?(async()=>{for(const te of ve){const ae=await te;if(typeof ae=="string")return ae}return null})():null},ne=Q.find(ge=>!!ge.allBasenames);ne&&(ce.allBasenames=ne.allBasenames);const ye=Q.reduce((ge,Y)=>Y.allPaths?ge.concat(Y.allPaths):ge,[]);return ye.length&&(ce.allPaths=ye),ce}function W(H,q,Q){if(q===!1)return l;const _=g(H,Q);if(_===l)return l;if(typeof q=="boolean")return _;if(q){const ce=q.when;if(typeof ce=="string"){const ne=(ye,ge,Y,U)=>{if(!U||!_(ye,ge))return null;const oe=ce.replace("$(basename)",()=>Y),ve=U(oe);return(0,h.$rh)(ve)?ve.then(te=>te?H:null):ve?H:null};return ne.requiresSiblings=!0,ne}}return _}function B(H,q){const Q=H.filter(ge=>!!ge.basenames);if(Q.length<2)return H;const _=Q.reduce((ge,Y)=>{const U=Y.basenames;return U?ge.concat(U):ge},[]);let ce;if(q){ce=[];for(let ge=0,Y=_.length;ge<Y;ge++)ce.push(q)}else ce=Q.reduce((ge,Y)=>{const U=Y.patterns;return U?ge.concat(U):ge},[]);const ne=function(ge,Y){if(typeof ge!="string")return null;if(!Y){let oe;for(oe=ge.length;oe>0;oe--){const ve=ge.charCodeAt(oe-1);if(ve===C.CharCode.Slash||ve===C.CharCode.Backslash)break}Y=ge.substr(oe)}const U=_.indexOf(Y);return U!==-1?ce[U]:null};ne.basenames=_,ne.patterns=ce,ne.allBasenames=_;const ye=H.filter(ge=>!ge.basenames);return ye.push(ne),ye}function ee(H,q){return(0,r.$tb)(H,q,(Q,_)=>typeof Q=="string"&&typeof _=="string"?Q===_:typeof Q!="string"&&typeof _!="string"?Q.base===_.base&&Q.pattern===_.pattern:!1)}}),define(ke[85],Ie([1,0,13,137,22,12,2]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.MarkdownStringTextNewlineStyle=void 0,e.$5k=c,e.$6k=I,e.$7k=S,e.$8k=u,e.$9k=P,e.$0k=w,e.$$k=a,e.$_k=m;var T;(function($){$[$.Paragraph=0]="Paragraph",$[$.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class p{constructor(f="",i=!1){if(this.value=f,typeof this.value!="string")throw(0,r.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(f,i=T.Paragraph){return this.value+=u(this.supportThemeIcons?(0,h.$Xk)(f):f).replace(/([ \t]+)/g,(s,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===T.Break?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,i){return this.value+=`
${P(i,f)}
`,this}appendLink(f,i,s){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(f),")"),s&&(this.value+=` "${this.c(this.c(s,'"'),")")}"`),this.value+=")",this}c(f,i){const s=new RegExp((0,R.$hf)(i),"g");return f.replace(s,(t,o)=>f.charAt(o-1)!=="\\"?`\\${t}`:t)}}e.$4k=p;function c($){return I($)?!$.value:Array.isArray($)?$.every(c):!0}function I($){return $ instanceof p?!0:$&&typeof $=="object"?typeof $.value=="string"&&(typeof $.isTrusted=="boolean"||typeof $.isTrusted=="object"||$.isTrusted===void 0)&&(typeof $.supportThemeIcons=="boolean"||$.supportThemeIcons===void 0):!1}function S($,f){return $===f?!0:!$||!f?!1:$.value===f.value&&$.isTrusted===f.isTrusted&&$.supportThemeIcons===f.supportThemeIcons&&$.supportHtml===f.supportHtml&&($.baseUri===f.baseUri||!!$.baseUri&&!!f.baseUri&&(0,C.$_g)(O.URI.from($.baseUri),O.URI.from(f.baseUri)))}function u($){return $.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function P($,f){const i=$.match(/^`+/gm)?.reduce((t,o)=>t.length>o.length?t:o).length??0,s=i>=3?i+1:3;return[`${"`".repeat(s)}${f}`,$,`${"`".repeat(s)}`].join(`
`)}function w($){return $.replace(/"/g,"&quot;")}function a($){return $&&$.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m($){const f=[],i=$.split("|").map(t=>t.trim());$=i[0];const s=i[1];if(s){const t=/height=(\d+)/.exec(s),o=/width=(\d+)/.exec(s),n=t?t[1]:"",d=o?o[1]:"",l=isFinite(parseInt(d)),g=isFinite(parseInt(n));l&&f.push(`width="${d}"`),g&&f.push(`height="${n}"`)}return{href:$,dimensions:f}}}),define(ke[107],Ie([1,0,18,31,16,10,22,12]),function($e,e,r,h,C,R,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zw=p,e.$1w=I,e.$2w=u,e.$3w=P,e.$4w=$,e.$5w=i,e.$6w=s,e.$7w=t,e.$8w=o,e.$9w=n;function p(l,g){const{os:E,tildify:D,relative:y}=g;if(y){const b=c(l,y,E);if(typeof b=="string")return b}let k=l.fsPath;if(E===R.OperatingSystem.Windows&&!R.$j?k=k.replace(/\//g,"\\"):E!==R.OperatingSystem.Windows&&R.$j&&(k=k.replace(/\\/g,"/")),E!==R.OperatingSystem.Windows&&D?.userHome){const b=D.userHome.fsPath;let v;l.scheme!==D.userHome.scheme&&l.path[0]===C.$gc.sep&&l.path[1]!==C.$gc.sep?v=D.userHome.with({path:l.path}).fsPath:v=k,k=u(v,b,E)}return(E===R.OperatingSystem.Windows?C.$fc:C.$gc).normalize(I(k,E===R.OperatingSystem.Windows))}function c(l,g,E){const D=E===R.OperatingSystem.Windows?C.$fc:C.$gc,y=E===R.OperatingSystem.Linux?O.$9g:O.$$g,k=g.getWorkspace(),A=(0,r.$Nb)(k.folders);if(!A)return;l.scheme!==A.uri.scheme&&l.path[0]===C.$gc.sep&&l.path[1]!==C.$gc.sep&&(l=A.uri.with({path:l.path}));const b=g.getWorkspaceFolder(l);if(!b)return;let v;if(y.isEqual(b.uri,l)?v="":v=y.relativePath(b.uri,l)??"",v&&(v=D.normalize(v)),k.folders.length>1&&!g.noPrefix){const F=b.name?b.name:y.basenameOrAuthority(b.uri);v=v?`${F} \u2022 ${v}`:F}return v}function I(l,g=R.$j){return(0,h.$Jg)(l,g)?l.charAt(0).toUpperCase()+l.slice(1):l}let S=Object.create(null);function u(l,g,E=R.OS){if(E===R.OperatingSystem.Windows||!l||!g)return l;let D=S.original===g?S.normalized:void 0;D||(D=g,R.$j&&(D=(0,h.$yg)(D)),D=`${(0,T.$nf)(D,C.$gc.sep)}${C.$gc.sep}`,S={original:g,normalized:D});let y=l;return R.$j&&(y=(0,h.$yg)(y)),(E===R.OperatingSystem.Linux?y.startsWith(D):(0,T.$Gf)(y,D))?`~/${y.substr(D.length)}`:l}function P(l,g){return l.replace(/^~($|\/|\\)/,`${g}$1`)}const w="\u2026",a="\\\\",m="~";function $(l,g=C.sep){const E=new Array(l.length);let D=!1;for(let y=0;y<l.length;y++){const k=l[y];if(k===""){E[y]=`.${g}`;continue}if(!k){E[y]=k;continue}D=!0;let A="",b=k;b.indexOf(a)===0?(A=b.substr(0,b.indexOf(a)+a.length),b=b.substr(b.indexOf(a)+a.length)):b.indexOf(g)===0?(A=b.substr(0,b.indexOf(g)+g.length),b=b.substr(b.indexOf(g)+g.length)):b.indexOf(m)===0&&(A=b.substr(0,b.indexOf(m)+m.length),b=b.substr(b.indexOf(m)+m.length));const v=b.split(g);for(let F=1;D&&F<=v.length;F++)for(let N=v.length-F;D&&N>=0;N--){D=!1;let L=v.slice(N,N+F).join(g);for(let M=0;!D&&M<l.length;M++)if(M!==y&&l[M]&&l[M].indexOf(L)>-1){const z=N+F===v.length,j=N>0&&l[M].indexOf(g)>-1?g+L:L,W=l[M].endsWith(j);D=!z||W}if(!D){let M="";(v[0].endsWith(":")||A!=="")&&(N===1&&(N=0,F++,L=v[0]+g+L),N>0&&(M=v[0]+g),M=A+M),N>0&&(M=M+w+g),M=M+L,N+F<v.length&&(M=M+g+w),E[y]=M}}D&&(E[y]=k)}return E}var f;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function i(l,g=Object.create(null)){const E=[];let D=!1,y="";for(const k of l)if(k==="$"||D&&k==="{")y&&E.push({value:y,type:f.TEXT}),y="",D=!0;else if(k==="}"&&D){const A=g[y];if(typeof A=="string")A.length&&E.push({value:A,type:f.VARIABLE});else if(A){const b=E[E.length-1];(!b||b.type!==f.SEPARATOR)&&E.push({value:A.label,type:f.SEPARATOR})}y="",D=!1}else y+=k;return y&&!D&&E.push({value:y,type:f.TEXT}),E.filter((k,A)=>{if(k.type===f.SEPARATOR){const b=E[A-1],v=E[A+1];return[b,v].every(F=>F&&(F.type===f.VARIABLE||F.type===f.TEXT)&&F.value.length>0)}return!0}).map(k=>k.value).join("")}function s(l,g){return R.$k||g?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$k?"&":"&&"):l.replace(/&&|&/g,E=>E==="&"?"&&":"&")}function t(l,g){return R.$k||g?l.replace(/\(&&\w\)|&&/g,""):R.$j?l.replace(/&&|&/g,E=>E==="&"?"&&":"&"):l.replace(/&&/g,"_")}function o(l){return l.replace(/&/g,"&&")}function n(l){if(l.endsWith("]")){const g=l.lastIndexOf(" [",l.length-2);if(g!==-1){const E=d(l.substring(0,g)),D=l.substring(g);return{name:E.name+D,parentPath:E.parentPath}}}return d(l)}function d(l){const g=l.indexOf("/")!==-1?C.$gc:C.$fc,E=g.basename(l),D=g.dirname(l);return E.length?{name:E,parentPath:D}:{name:D,parentPath:""}}}),define(ke[138],Ie([1,0,21,40,2]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=void 0,e.$On=p,e.$Pn=I,e.$Qn=S;function R(u){return u.toJSON()}class O{constructor(P){this.a=P}transformIncoming(P){const w=this.a.transformIncoming(P);return w===P?P:R(C.URI.from(w))}transformOutgoing(P){const w=this.a.transformOutgoing(P);return w===P?P:R(C.URI.from(w))}transformOutgoingURI(P){const w=this.a.transformOutgoing(P);return w===P?P:C.URI.from(w)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.$Mn=O,e.$Nn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function T(u,P,w){if(!u||w>200)return null;if(typeof u=="object"){if(u instanceof C.URI)return P.transformOutgoing(u);for(const a in u)if(Object.hasOwnProperty.call(u,a)){const m=T(u[a],P,w+1);m!==null&&(u[a]=m)}}return null}function p(u,P){const w=T(u,P,0);return w===null?u:w}function c(u,P,w,a){if(!u||a>200)return null;if(typeof u=="object"){if(u.$mid===h.MarshalledId.Uri)return w?C.URI.revive(P.transformIncoming(u)):P.transformIncoming(u);if(u instanceof r.$Ne)return null;for(const m in u)if(Object.hasOwnProperty.call(u,m)){const $=c(u[m],P,w,a+1);$!==null&&(u[m]=$)}}return null}function I(u,P){const w=c(u,P,!1,0);return w===null?u:w}function S(u,P){const w=c(u,P,!0,0);return w===null?u:w}}),define(ke[32],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=h;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function h(C){return r.test(C)}e.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(T){for(let p=0;p<T.length;p++)T[p]=Math.floor(Math.random()*256);return T};const R=new Uint8Array(16),O=[];for(let T=0;T<256;T++)O.push(T.toString(16).padStart(2,"0"));return function(){C(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let p=0,c="";return c+=O[R[p++]],c+=O[R[p++]],c+=O[R[p++]],c+=O[R[p++]],c+="-",c+=O[R[p++]],c+=O[R[p++]],c+="-",c+=O[R[p++]],c+=O[R[p++]],c+="-",c+=O[R[p++]],c+=O[R[p++]],c+="-",c+=O[R[p++]],c+=O[R[p++]],c+=O[R[p++]],c+=O[R[p++]],c+=O[R[p++]],c+=O[R[p++]],c}}()}),define(ke[190],Ie([1,0,18,39,32]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tu=e.$ru=void 0,e.$pu=R,e.$qu=O,e.$su=c;function R(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}function O(S,u,P){const w={id:(0,C.$2g)(),name:S,uri:u,data:P};return{asString:async()=>"",asFile:()=>w,value:void 0}}class T{constructor(){this.a=new Map}get size(){let u=0;for(const P of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const P=[...this.a.keys()];return h.Iterable.some(this,([w,a])=>a.asFile())&&P.push("files"),I(p(u),P)}get(u){return this.a.get(this.b(u))?.[0]}append(u,P){const w=this.a.get(u);w?w.push(P):this.a.set(this.b(u),[P])}replace(u,P){this.a.set(this.b(u),[P])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,P]of this.a)for(const w of P)yield[u,w]}b(u){return p(u)}}e.$ru=T;function p(S){return S.toLowerCase()}function c(S,u){return I(p(S),u.map(p))}function I(S,u){if(S==="*/*")return u.length>0;if(u.includes(S))return!0;const P=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!P)return!1;const[w,a,m]=P;return m==="*"?u.some($=>$.startsWith(a+"/")):!1}e.$tu=Object.freeze({create:S=>(0,r.$Lb)(S.map(u=>u.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$tu.split(S).filter(u=>!u.startsWith("#"))})}),define(ke[33],Ie([1,0,45,66,360,7,31,81,16,10,22,2]),function($e,e,r,h,C,R,O,T,p,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=i,e.whenDeleted=o,e.configureFlushOnWrite=E,e.writeFileSync=y,r=qe(r);var u;(function(j){j[j.UNLINK=0]="UNLINK",j[j.MOVE=1]="MOVE"})(u||(e.RimRafMode=u={}));async function P(j,W=u.UNLINK,B){if((0,O.$Ig)(j))throw new Error("rimraf - will refuse to recursively delete root");return W===u.UNLINK?a(j):w(j,B)}async function w(j,W=(0,O.$Ng)((0,h.tmpdir)())){try{try{await r.promises.rename(j,W)}catch(B){return B.code==="ENOENT"?void 0:a(j)}a(W).catch(B=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function a(j){return r.promises.rm(j,{recursive:!0,force:!0,maxRetries:3})}function m(j){if((0,O.$Ig)(j))throw new Error("rimraf - will refuse to recursively delete root");r.rmSync(j,{recursive:!0,force:!0,maxRetries:3})}async function $(j,W){return s(await(W?f(j):r.promises.readdir(j)))}async function f(j){try{return await r.promises.readdir(j,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const W=[],B=await $(j);for(const ee of B){let H=!1,q=!1,Q=!1;try{const _=await r.promises.lstat((0,p.$jc)(j,ee));H=_.isFile(),q=_.isDirectory(),Q=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}W.push({name:ee,isFile:()=>H,isDirectory:()=>q,isSymbolicLink:()=>Q})}return W}function i(j){return s(r.readdirSync(j))}function s(j){return j.map(W=>typeof W=="string"?c.$k?(0,T.$nm)(W):W:(W.name=c.$k?(0,T.$nm)(W.name):W.name,W))}async function t(j){const W=await $(j),B=[];for(const ee of W)await n.existsDirectory((0,p.$jc)(j,ee))&&B.push(ee);return B}function o(j,W=1e3){return new Promise(B=>{let ee=!1;const H=setInterval(()=>{ee||(ee=!0,r.access(j,q=>{ee=!1,q&&(clearInterval(H),B(void 0))}))},W)})}var n;(function(j){async function W(H){let q;try{if(q=await r.promises.lstat(H),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await r.promises.stat(H),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(c.$j&&Q.code==="EACCES")try{return{stat:await r.promises.stat(await r.promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw _}throw Q}}j.stat=W;async function B(H){try{const{stat:q,symbolicLink:Q}=await j.stat(H);return q.isFile()&&Q?.dangling!==!0}catch{}return!1}j.existsFile=B;async function ee(H){try{const{stat:q,symbolicLink:Q}=await j.stat(H);return q.isDirectory()&&Q?.dangling!==!0}catch{}return!1}j.existsDirectory=ee})(n||(e.SymlinkSupport=n={}));const d=new R.$Oh;function l(j,W,B){return d.queueFor(S.URI.file(j),()=>{const ee=k(B);return new Promise((H,q)=>D(j,W,ee,Q=>Q?q(Q):H()))},I.$0g)}let g=!0;function E(j){g=j}function D(j,W,B,ee){if(!g)return r.writeFile(j,W,{mode:B.mode,flag:B.flag},ee);r.open(j,B.flag,B.mode,(H,q)=>{if(H)return ee(H);r.writeFile(q,W,Q=>{if(Q)return r.close(q,()=>ee(Q));r.fdatasync(q,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),E(!1)),r.close(q,ce=>ee(ce))))})})}function y(j,W,B){const ee=k(B);if(!g)return r.writeFileSync(j,W,{mode:ee.mode,flag:ee.flag});const H=r.openSync(j,ee.flag,ee.mode);try{r.writeFileSync(H,W);try{r.fdatasyncSync(H)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),E(!1)}}finally{r.closeSync(H)}}function k(j){return j?{mode:typeof j.mode=="number"?j.mode:438,flag:typeof j.flag=="string"?j.flag:"w"}:{mode:438,flag:"w"}}async function A(j,W,B=6e4){if(j!==W)try{c.$j&&typeof B=="number"?await b(j,W,Date.now(),B):await r.promises.rename(j,W)}catch(ee){if(j.toLowerCase()!==W.toLowerCase()&&ee.code==="EXDEV"||j.endsWith("."))await v(j,W,{preserveSymlinks:!1}),await P(j,u.MOVE);else throw ee}}async function b(j,W,B,ee,H=0){try{return await r.promises.rename(j,W)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-B>=ee)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${q}`),q;if(H===0){let Q=!1;try{const{stat:_}=await n.stat(W);_.isFile()||(Q=!0)}catch{}if(Q)throw q}return await(0,R.$Gh)(Math.min(100,H*10)),b(j,W,B,ee,H+1)}}async function v(j,W,B){return N(j,W,{root:{source:j,target:W},options:B,handledSourcePaths:new Set})}const F=511;async function N(j,W,B){if(B.handledSourcePaths.has(j))return;B.handledSourcePaths.add(j);const{stat:ee,symbolicLink:H}=await n.stat(j);if(H){if(B.options.preserveSymlinks)try{return await z(j,W,B)}catch{}if(H.dangling)return}return ee.isDirectory()?L(j,W,ee.mode&F,B):M(j,W,ee.mode&F)}async function L(j,W,B,ee){await r.promises.mkdir(W,{recursive:!0,mode:B});const H=await $(j);for(const q of H)await N((0,p.$jc)(j,q),(0,p.$jc)(W,q),ee)}async function M(j,W,B){await r.promises.copyFile(j,W),await r.promises.chmod(W,B)}async function z(j,W,B){let ee=await r.promises.readlink(j);(0,O.$Eg)(ee,B.root.source,!c.$l)&&(ee=(0,p.$jc)(B.root.target,ee.substr(B.root.source.length+1))),await r.promises.symlink(ee,W)}e.Promises=new class{get read(){return(j,W,B,ee,H)=>new Promise((q,Q)=>{r.read(j,W,B,ee,H,(_,ce,ne)=>_?Q(_):q({bytesRead:ce,buffer:ne}))})}get write(){return(j,W,B,ee,H)=>new Promise((q,Q)=>{r.write(j,W,B,ee,H,(_,ce,ne)=>_?Q(_):q({bytesWritten:ce,buffer:ne}))})}get fdatasync(){return(0,C.promisify)(r.fdatasync)}get open(){return(0,C.promisify)(r.open)}get close(){return(0,C.promisify)(r.close)}get realpath(){return(0,C.promisify)(r.realpath)}async exists(j){try{return await r.promises.access(j),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return t}get writeFile(){return l}get rm(){return P}get rename(){return A}get copy(){return v}}}),define(ke[108],Ie([1,0,45,16,10,12,33]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=T,e.$mr=p,e.$nr=c,e.$or=I,r=qe(r);function T(u){if(C.$l)return u;const P=(0,h.$mc)(u);if(u===P)return u;const w=((0,h.$nc)(u)||u).toLowerCase();try{const m=(0,O.readdirSync)(P).filter($=>$.toLowerCase()===w);if(m.length===1){const $=T(P);if($)return(0,h.$jc)($,m[0])}else if(m.length>1){const $=m.indexOf(w);if($>=0){const f=T(P);if(f)return(0,h.$jc)(f,m[$])}}}catch{}return null}async function p(u,P){if(C.$l)return u;const w=(0,h.$mc)(u);if(u===w)return u;const a=((0,h.$nc)(u)||u).toLowerCase();try{if(P?.isCancellationRequested)return null;const $=(await O.Promises.readdir(w)).filter(f=>f.toLowerCase()===a);if($.length===1){const f=await p(w,P);if(f)return(0,h.$jc)(f,$[0])}else if($.length>1){const f=$.indexOf(a);if(f>=0){const i=await p(w,P);if(i)return(0,h.$jc)(i,$[f])}}}catch{}return null}async function c(u){try{return await O.Promises.realpath(u)}catch{const w=S(u);return await r.promises.access(w,r.constants.R_OK),w}}function I(u){try{return r.realpathSync(u)}catch{const w=S(u);return r.accessSync(w,r.constants.R_OK),w}}function S(u){return(0,R.$nf)((0,h.$hc)(u),h.sep)}}),define(ke[191],Ie([1,0,67]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=h,e.$6g=R,r=qe(r);function h(T,p,c,I=1){let S=!1;return new Promise(u=>{const P=setTimeout(()=>{if(!S)return S=!0,u(0)},c);C(T,p,I,w=>{if(!S)return S=!0,clearTimeout(P),u(w)})})}function C(T,p,c,I){if(p===0)return I(0);const S=new r.Socket;S.once("connect",()=>(O(S),C(T+c,p-1,c,I))),S.once("data",()=>{}),S.once("error",u=>(O(S),u.code!=="ECONNREFUSED"?C(T+c,p-1,c,I):I(T))),S.connect(T,"127.0.0.1")}e.$5g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(T,p,c,I="127.0.0.1"){let S=!1,u,P=1;const w=r.createServer({pauseOnConnect:!0});function a(m,$){S||(S=!0,w.removeAllListeners(),w.close(),u&&clearTimeout(u),$(m))}return new Promise(m=>{u=setTimeout(()=>{a(0,m)},c),w.on("listening",()=>{a(T,m)}),w.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&P<p?(T++,P++,w.listen(T,I)):a(0,m)}),w.on("close",()=>{a(0,m)}),w.listen(T,I)})}function O(T){try{T.removeAllListeners("connect"),T.removeAllListeners("error"),T.end(),T.destroy(),T.unref()}catch(p){console.error(p)}}}),define(ke[109],Ie([1,0,45,16,10,55,104,17,33]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$ym=c,e.$zm=I,h=qe(h),C=qe(C),R=qe(R),T=qe(T),p=qe(p),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function c(u=R.env){return u.comspec||"cmd.exe"}function I(u){let P=[],w=!1;const a=function(m){if(w){P.push(m);return}(!u.send(m,f=>{if(f&&console.error(f),w=!1,P.length>0){const i=P.slice(0);P=[],i.forEach(s=>a(s))}})||C.$j)&&(w=!0)};return{send:a}}var S;(function(u){async function P(w,a,m){if(h.$ic(w))return w;if(a===void 0&&(a=R.cwd()),h.$mc(w)!=="."||(m===void 0&&T.$eg(R.env.PATH)&&(m=R.env.PATH.split(h.$tc)),m===void 0||m.length===0))return h.$jc(a,w);async function f(i){if(await p.Promises.exists(i)){let s;try{s=await r.promises.stat(i)}catch(t){t.message.startsWith("EACCES")&&(s=await r.promises.lstat(i))}return s?!s.isDirectory():!1}return!1}for(const i of m){let s;if(h.$ic(i)?s=h.$jc(i,w):s=h.$jc(a,i,w),await f(s))return s;let t=s+".com";if(await f(t)||(t=s+".exe",await f(t)))return t}return h.$jc(a,w)}u.findExecutable=P})(S||(e.win32=S={}))});var Je=this&&this.__decorate||function($e,e,r,h){var C=arguments.length,R=C<3?e:h===null?h=Object.getOwnPropertyDescriptor(e,r):h,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate($e,e,r,h);else for(var T=$e.length-1;T>=0;T--)(O=$e[T])&&(R=(C<3?O(R):C>3?O(e,r,R):O(e,r))||R);return C>3&&R&&Object.defineProperty(e,r,R),R};define(ke[86],Ie([1,0,18,7,21,20,59,13,4,3,44,12,17]),function($e,e,r,h,C,R,O,T,p,c,I,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.ProxyChannel=e.$ni=e.$ki=e.$ji=e.$ii=e.RequestInitiator=e.$hi=e.$ei=e.$di=void 0,e.$fi=E,e.$gi=D,e.$li=F,e.$mi=N,S=qe(S);var P;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(P||(P={}));function w(H){switch(H){case P.Promise:return"req";case P.PromiseCancel:return"cancel";case P.EventListen:return"subscribe";case P.EventDispose:return"unsubscribe"}}var a;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(a||(a={}));function m(H){switch(H){case a.Initialize:return"init";case a.PromiseSuccess:return"reply:";case a.PromiseError:case a.PromiseErrorObj:return"replyErr:";case a.EventFire:return"event:"}}var $;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})($||($={}));function f(H){let q=0;for(let Q=0;;Q+=7){const _=H.read(1);if(q|=(_.buffer[0]&127)<<Q,!(_.buffer[0]&128))return q}}const i=d(0);function s(H,q){if(q===0){H.write(i);return}let Q=0;for(let ce=q;ce!==0;ce=ce>>>7)Q++;const _=C.$Ne.alloc(Q);for(let ce=0;q!==0;ce++)_.buffer[ce]=q&127,q=q>>>7,q>0&&(_.buffer[ce]|=128);H.write(_)}class t{constructor(q){this.b=q,this.a=0}read(q){const Q=this.b.slice(this.a,this.a+q);return this.a+=Q.byteLength,Q}}e.$di=t;class o{constructor(){this.a=[]}get buffer(){return C.$Ne.concat(this.a)}write(q){this.a.push(q)}}e.$ei=o;var n;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(n||(n={}));function d(H){const q=C.$Ne.alloc(1);return q.writeUInt8(H,0),q}const l={Undefined:d(n.Undefined),String:d(n.String),Buffer:d(n.Buffer),VSBuffer:d(n.VSBuffer),Array:d(n.Array),Object:d(n.Object),Uint:d(n.Int)},g=typeof Buffer<"u";function E(H,q){if(typeof q>"u")H.write(l.Undefined);else if(typeof q=="string"){const Q=C.$Ne.fromString(q);H.write(l.String),s(H,Q.byteLength),H.write(Q)}else if(g&&Buffer.isBuffer(q)){const Q=C.$Ne.wrap(q);H.write(l.Buffer),s(H,Q.byteLength),H.write(Q)}else if(q instanceof C.$Ne)H.write(l.VSBuffer),s(H,q.byteLength),H.write(q);else if(Array.isArray(q)){H.write(l.Array),s(H,q.length);for(const Q of q)E(H,Q)}else if(typeof q=="number"&&(q|0)===q)H.write(l.Uint),s(H,q);else{const Q=C.$Ne.fromString(JSON.stringify(q));H.write(l.Object),s(H,Q.byteLength),H.write(Q)}}function D(H){switch(H.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return H.read(f(H)).toString();case n.Buffer:return H.read(f(H)).buffer;case n.VSBuffer:return H.read(f(H));case n.Array:{const Q=f(H),_=[];for(let ce=0;ce<Q;ce++)_.push(D(H));return _}case n.Object:return JSON.parse(H.read(f(H)).toString());case n.Int:return f(H)}}class y{constructor(q,Q,_=null,ce=1e3){this.h=q,this.j=Q,this.k=_,this.l=ce,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:a.Initialize})}registerChannel(q,Q){this.b.set(q,Q),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case a.Initialize:{const Q=this.o([q.type]);this.k?.logOutgoing(Q,0,k.OtherSide,m(q.type));return}case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:{const Q=this.o([q.type,q.id],q.data);this.k?.logOutgoing(Q,q.id,k.OtherSide,m(q.type),q.data);return}}}o(q,Q=void 0){const _=new o;return E(_,q),E(_,Q),this.p(_.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const Q=new t(q),_=D(Q),ce=D(Q),ne=_[0];switch(ne){case P.Promise:return this.k?.logIncoming(q.byteLength,_[1],k.OtherSide,`${w(ne)}: ${_[2]}.${_[3]}`,ce),this.s({type:ne,id:_[1],channelName:_[2],name:_[3],arg:ce});case P.EventListen:return this.k?.logIncoming(q.byteLength,_[1],k.OtherSide,`${w(ne)}: ${_[2]}.${_[3]}`,ce),this.t({type:ne,id:_[1],channelName:_[2],name:_[3],arg:ce});case P.PromiseCancel:return this.k?.logIncoming(q.byteLength,_[1],k.OtherSide,`${w(ne)}`),this.u({type:ne,id:_[1]});case P.EventDispose:return this.k?.logIncoming(q.byteLength,_[1],k.OtherSide,`${w(ne)}`),this.u({type:ne,id:_[1]})}}s(q){const Q=this.b.get(q.channelName);if(!Q){this.v(q);return}const _=new R.$we;let ce;try{ce=Q.call(this.j,q.name,q.arg,_.token)}catch(ge){ce=Promise.reject(ge)}const ne=q.id;ce.then(ge=>{this.m({id:ne,data:ge,type:a.PromiseSuccess})},ge=>{ge instanceof Error?this.m({id:ne,data:{message:ge.message,name:ge.name,stack:ge.stack?ge.stack.split(`
`):void 0},type:a.PromiseError}):this.m({id:ne,data:ge,type:a.PromiseErrorObj})}).finally(()=>{ye.dispose(),this.d.delete(q.id)});const ye=(0,c.$Sc)(()=>_.cancel());this.d.set(q.id,ye)}t(q){const Q=this.b.get(q.channelName);if(!Q){this.v(q);return}const _=q.id,ne=Q.listen(this.j,q.name,q.arg)(ye=>this.m({id:_,data:ye,type:a.EventFire}));this.d.set(q.id,ne)}u(q){const Q=this.d.get(q.id);Q&&(Q.dispose(),this.d.delete(q.id))}v(q){let Q=this.g.get(q.channelName);Q||(Q=[],this.g.set(q.channelName,Q));const _=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===P.Promise&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:a.PromiseError})},this.l);Q.push({request:q,timeoutTimer:_})}w(q){const Q=this.g.get(q);if(Q){for(const _ of Q)switch(clearTimeout(_.timeoutTimer),_.request.type){case P.Promise:this.s(_.request);break;case P.EventListen:this.t(_.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$hi=y;var k;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));class A{constructor(q,Q=null){this.l=q,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$le,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(_=>this.s(_)),this.j=Q}getChannel(q){const Q=this;return{call(_,ce,ne){return Q.a?Promise.reject(new T.$4):Q.m(q,_,ce,ne)},listen(_,ce){return Q.a?p.Event.None:Q.o(q,_,ce)}}}m(q,Q,_,ce=R.CancellationToken.None){const ne=this.g++,ye=P.Promise,ge={id:ne,type:ye,channelName:q,name:Q,arg:_};if(ce.isCancellationRequested)return Promise.reject(new T.$4);let Y;return new Promise((oe,ve)=>{if(ce.isCancellationRequested)return ve(new T.$4);const te=()=>{const re=pe=>{switch(pe.type){case a.PromiseSuccess:this.f.delete(ne),oe(pe.data);break;case a.PromiseError:{this.f.delete(ne);const we=new Error(pe.data.message);we.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,we.name=pe.data.name,ve(we);break}case a.PromiseErrorObj:this.f.delete(ne),ve(pe.data);break}};this.f.set(ne,re),this.p(ge)};let ae=null;this.b===$.Idle?te():(ae=(0,h.$sh)(re=>this.u()),ae.then(()=>{ae=null,te()}));const se=()=>{ae?(ae.cancel(),ae=null):this.p({id:ne,type:P.PromiseCancel}),ve(new T.$4)},X=ce.onCancellationRequested(se);Y=(0,c.$Rc)((0,c.$Sc)(se),X),this.d.add(Y)}).finally(()=>{Y.dispose(),this.d.delete(Y)})}o(q,Q,_){const ce=this.g++,ne=P.EventListen,ye={id:ce,type:ne,channelName:q,name:Q,arg:_};let ge=null;const Y=new p.$le({onWillAddFirstListener:()=>{ge=(0,h.$sh)(oe=>this.u()),ge.then(()=>{ge=null,this.d.add(Y),this.p(ye)})},onDidRemoveLastListener:()=>{ge?(ge.cancel(),ge=null):(this.d.delete(Y),this.p({id:ce,type:P.EventDispose}))}}),U=oe=>Y.fire(oe.data);return this.f.set(ce,U),Y.event}p(q){switch(q.type){case P.Promise:case P.EventListen:{const Q=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(Q,q.id,k.LocalSide,`${w(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case P.PromiseCancel:case P.EventDispose:{const Q=this.q([q.type,q.id]);this.j?.logOutgoing(Q,q.id,k.LocalSide,w(q.type));return}}}q(q,Q=void 0){const _=new o;return E(_,q),E(_,Q),this.r(_.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const Q=new t(q),_=D(Q),ce=D(Q),ne=_[0];switch(ne){case a.Initialize:return this.j?.logIncoming(q.byteLength,0,k.LocalSide,m(ne)),this.t({type:_[0]});case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:return this.j?.logIncoming(q.byteLength,_[1],k.LocalSide,m(ne),ce),this.t({type:_[0],id:_[1],data:ce})}}t(q){if(q.type===a.Initialize){this.b=$.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$ii=A,Je([O.$0h],A.prototype,"onDidInitializePromise",null);class b{get connections(){const q=[];return this.f.forEach(Q=>q.push(Q)),q}constructor(q,Q,_){this.a=new Map,this.f=new Set,this.g=new p.$le,this.onDidAddConnection=this.g.event,this.h=new p.$le,this.onDidRemoveConnection=this.h.event,this.j=new c.$Tc,this.j.add(q(({protocol:ce,onDidClientDisconnect:ne})=>{const ye=p.Event.once(ce.onMessage);this.j.add(ye(ge=>{const Y=new t(ge),U=D(Y),oe=new y(ce,U,Q,_),ve=new A(ce,Q);this.a.forEach((ae,se)=>oe.registerChannel(se,ae));const te={channelServer:oe,channelClient:ve,ctx:U};this.f.add(te),this.g.fire(te),this.j.add(ne(()=>{oe.dispose(),ve.dispose(),this.f.delete(te),this.h.fire(te)}))}))}))}getChannel(q,Q){const _=this;return{call(ce,ne,ye){let ge;if((0,u.$sg)(Q)){const U=(0,r.$2b)(_.connections.filter(Q));ge=U?Promise.resolve(U):p.Event.toPromise(p.Event.filter(_.onDidAddConnection,Q))}else ge=Q.routeCall(_,ce,ne);const Y=ge.then(U=>U.channelClient.getChannel(q));return F(Y).call(ce,ne,ye)},listen(ce,ne){if((0,u.$sg)(Q))return _.k(q,Q,ce,ne);const ye=Q.routeEvent(_,ce,ne).then(ge=>ge.channelClient.getChannel(q));return F(ye).listen(ce,ne)}}}k(q,Q,_,ce){const ne=this;let ye;const ge=new p.$le({onWillAddFirstListener:()=>{ye=new c.$Tc;const Y=new p.$re,U=new Map,oe=te=>{const se=te.channelClient.getChannel(q).listen(_,ce),X=Y.add(se);U.set(te,X)},ve=te=>{const ae=U.get(te);ae&&(ae.dispose(),U.delete(te))};ne.connections.filter(Q).forEach(oe),p.Event.filter(ne.onDidAddConnection,Q)(oe,void 0,ye),ne.onDidRemoveConnection(ve,void 0,ye),Y.event(ge.fire,ge,ye),ye.add(Y)},onDidRemoveLastListener:()=>{ye?.dispose(),ye=void 0}});return ge.event}registerChannel(q,Q){this.a.set(q,Q);for(const _ of this.f)_.channelServer.registerChannel(q,Q)}dispose(){this.j.dispose();for(const q of this.f)q.channelClient.dispose(),q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ji=b;class v{constructor(q,Q,_=null){const ce=new o;E(ce,Q),q.send(ce.buffer),this.a=new A(q,_),this.d=new y(q,Q,_)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,Q){this.d.registerChannel(q,Q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ki=v;function F(H){return{call(q,Q,_){return H.then(ce=>ce.call(q,Q,_))},listen(q,Q){const _=new p.$ue;return H.then(ce=>_.input=ce.listen(q,Q)),_.event}}}function N(H){let q=!1;return{call(Q,_,ce){return q?H.call(Q,_,ce):(0,h.$Gh)(0).then(()=>q=!0).then(()=>H.call(Q,_,ce))},listen(Q,_){if(q)return H.listen(Q,_);const ce=new p.$ue;return(0,h.$Gh)(0).then(()=>q=!0).then(()=>ce.input=H.listen(Q,_)),ce.event}}}class L{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const Q of q.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await p.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.$ni=L;var M;(function(H){function q(ne,ye,ge){const Y=ne,U=ge&&ge.disableMarshalling,oe=new Map;for(const ve in Y)_(ve)&&oe.set(ve,p.Event.buffer(Y[ve],!0,void 0,ye));return new class{listen(ve,te,ae){const se=oe.get(te);if(se)return se;const X=Y[te];if(typeof X=="function"){if(ce(te))return X.call(Y,ae);if(_(te))return oe.set(te,p.Event.buffer(Y[te],!0,void 0,ye)),oe.get(te)}throw new T.$ab(`Event not found: ${te}`)}call(ve,te,ae){const se=Y[te];if(typeof se=="function"){if(!U&&Array.isArray(ae))for(let re=0;re<ae.length;re++)ae[re]=(0,I.$ci)(ae[re]);let X=se.apply(Y,ae);return X instanceof Promise||(X=Promise.resolve(X)),X}throw new T.$ab(`Method not found: ${te}`)}}}H.fromService=q;function Q(ne,ye){const ge=ye&&ye.disableMarshalling;return new Proxy({},{get(Y,U){if(typeof U=="string")return ye?.properties?.has(U)?ye.properties.get(U):ce(U)?function(oe){return ne.listen(U,oe)}:_(U)?ne.listen(U):async function(...oe){let ve;ye&&!(0,u.$ng)(ye.context)?ve=[ye.context,...oe]:ve=oe;const te=await ne.call(U,ve);return ge?te:(0,I.$ci)(te)};throw new T.$ab(`Property not found: ${String(U)}`)}})}H.toService=Q;function _(ne){return ne[0]==="o"&&ne[1]==="n"&&S.$Ef(ne.charCodeAt(2))}function ce(ne){return/^onDynamic/.test(ne)&&S.$Ef(ne.charCodeAt(9))}})(M||(e.ProxyChannel=M={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const q=H.toString();if(q!=="[object Object]")return q}return H}function W(H){return Array.isArray(H)?H.map(j):j(H)}function B(H,q,Q,_,ce,ne,ye){ye=W(ye);const ge=z[ce],Y=ge[_%ge.length];let U=[`%c[${H}]%c[${String(q).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${Y}`];/\($/.test(ne)?(U=U.concat(ye),U.push(")")):U.push(ye),console.log.apply(console,U)}class ee{constructor(q,Q){this.d=q,this.f=Q,this.a=0,this.b=0}logOutgoing(q,Q,_,ce,ne){this.b+=q,B(this.d,this.b,q,Q,_,ce,ne)}logIncoming(q,Q,_,ce,ne){this.a+=q,B(this.f,this.a,q,Q,_,ce,ne)}}e.$oi=ee}),define(ke[68],Ie([1,0,21,4,3,86]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.ProtocolConstants=e.$pi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var T;(function(l){l.enableDiagnostics=!1,l.records=[];const g=new WeakMap;let E=0;function D(k,A){if(!g.has(k)){const b=String(++E);g.set(k,b)}return g.get(k)}function y(k,A,b,v){if(!l.enableDiagnostics)return;const F=D(k,A);if(v instanceof r.$Ne||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const N=r.$Ne.alloc(v.byteLength);N.set(v),l.records.push({timestamp:Date.now(),id:F,label:A,type:b,buff:N})}else l.records.push({timestamp:Date.now(),id:F,label:A,type:b,data:v})}l.traceSocketEvent=y})(T||(e.SocketDiagnostics=T={}));var p;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let c=null;function I(){return c||(c=r.$Ne.alloc(0)),c}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(g){this.a.push(g),this.b+=g.byteLength}read(g){return this.c(g,!0)}peek(g){return this.c(g,!1)}c(g,E){if(g===0)return I();if(g>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===g){const A=this.a[0];return E&&(this.a.shift(),this.b-=g),A}if(this.a[0].byteLength>g){const A=this.a[0].slice(0,g);return E&&(this.a[0]=this.a[0].slice(g),this.b-=g),A}const D=r.$Ne.alloc(g);let y=0,k=0;for(;g>0;){const A=this.a[k];if(A.byteLength>g){const b=A.slice(0,g);D.set(b,y),y+=g,E&&(this.a[k]=A.slice(g),this.b-=g),g-=g}else D.set(A,y),y+=A.byteLength,E?(this.a.shift(),this.b-=A.byteLength):k++,g-=A.byteLength}return D}}e.$pi=S;var u;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(u||(u={}));function P(l){switch(l){case u.None:return"None";case u.Regular:return"Regular";case u.Control:return"Control";case u.Ack:return"Ack";case u.Disconnect:return"Disconnect";case u.ReplayRequest:return"ReplayRequest";case u.Pause:return"PauseWriting";case u.Resume:return"ResumeWriting";case u.KeepAlive:return"KeepAlive"}}var w;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(w||(e.ProtocolConstants=w={}));class a{constructor(g,E,D,y){this.type=g,this.id=E,this.ack=D,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends C.$Uc{constructor(g){super(),this.f=this.B(new h.$le),this.onMessage=this.f.event,this.g={readHead:!0,readLen:w.HeaderLength,messageType:u.None,id:0,ack:0},this.a=g,this.b=!1,this.c=new S,this.B(this.a.onData(E=>this.acceptChunk(E))),this.lastReadTime=Date.now()}acceptChunk(g){if(!(!g||g.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(g);this.c.byteLength>=this.g.readLen;){const E=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=E.readUInt32BE(9),this.g.messageType=E.readUInt8(0),this.g.id=E.readUInt32BE(1),this.g.ack=E.readUInt32BE(5),this.a.traceSocketEvent(O.ProtocolHeaderRead,{messageType:P(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const D=this.g.messageType,y=this.g.id,k=this.g.ack;if(this.g.readHead=!0,this.g.readLen=w.HeaderLength,this.g.messageType=u.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(O.ProtocolMessageRead,E),this.f.fire(new a(D,y,k,E)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(g){this.k=null,this.a=!1,this.b=!1,this.c=g,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(g){if(this.a)return;g.writtenTime=Date.now(),this.lastWriteTime=Date.now();const E=r.$Ne.alloc(w.HeaderLength);E.writeUInt8(g.type,0),E.writeUInt32BE(g.id,1),E.writeUInt32BE(g.ack,5),E.writeUInt32BE(g.data.byteLength,9),this.c.traceSocketEvent(O.ProtocolHeaderWrite,{messageType:P(g.type),id:g.id,ack:g.ack,messageSize:g.data.byteLength}),this.c.traceSocketEvent(O.ProtocolMessageWrite,g.data),this.j(E,g.data)}g(g,E){const D=this.f===0;return this.d.push(g,E),this.f+=g.byteLength+E.byteLength,D}h(){const g=r.$Ne.concat(this.d,this.f);return this.d.length=0,this.f=0,g}j(g,E){this.g(g,E)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const g=this.h();this.c.traceSocketEvent(O.ProtocolWrite,{byteLength:g.byteLength}),this.c.write(g)}}class f extends C.$Uc{constructor(g){super(),this.f=new h.$le,this.onMessage=this.f.event,this.g=new h.$le,this.onDidDispose=this.g.event,this.a=g,this.b=this.B(new $(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(E=>{E.type===u.Regular&&this.f.fire(E.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(g){this.b.write(new a(u.Regular,0,0,g))}}e.$qi=f;class i extends R.$ki{static fromSocket(g,E){return new i(new f(g),E)}get onDidDispose(){return this.b.onDidDispose}constructor(g,E,D=null){super(g,E,D),this.b=g}dispose(){super.dispose();const g=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),g.end()}}e.$ri=i;class s{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new h.$le({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(g){this.b?this.d.length>0?this.d.push(g):this.a.fire(g):this.d.push(g)}flushBuffer(){this.d=[]}}e.$si=s;class t{constructor(g){this.data=g,this.next=null}}class o{constructor(){this.a=null,this.b=null}length(){let g=0,E=this.a;for(;E;)E=E.next,g++;return g}peek(){return this.a?this.a.data:null}toArray(){const g=[];let E=0,D=this.a;for(;D;)g[E++]=D.data,D=D.next;return g}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(g){const E=new t(g);if(!this.a){this.a=E,this.b=E;return}this.b.next=E,this.b=E}}class n{static{this.a=10}static{this.b=null}static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const g=Date.now();for(let E=0;E<n.a;E++)this.c[E]=g-1e3*E;setInterval(()=>{for(let E=n.a;E>=1;E--)this.c[E]=this.c[E-1];this.c[0]=Date.now()},1e3)}d(){const g=Date.now(),E=(1+n.a)*1e3;let D=0;for(let y=0;y<n.a;y++)g-this.c[y]<=E&&D++;return 1-D/n.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.d-this.f}constructor(g){this.v=new s,this.onControlMessage=this.v.event,this.w=new s,this.onMessage=this.w.event,this.x=new s,this.onDidDispose=this.x.event,this.y=new s,this.onSocketClose=this.y.event,this.z=new s,this.onSocketTimeout=this.z.event,this.t=g.loadEstimator??n.getInstance(),this.u=g.sendKeepAlive??!0,this.a=!1,this.c=new o,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new C.$Tc,this.p=g.socket,this.q=this.s.add(new $(this.p)),this.r=this.s.add(new m(this.p)),this.s.add(this.r.onMessage(E=>this.A(E))),this.s.add(this.p.onClose(E=>this.y.fire(E))),g.initialChunk&&this.r.acceptChunk(g.initialChunk),this.u?this.m=setInterval(()=>{this.E()},w.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const g=new a(u.Disconnect,0,0,I());this.q.write(g),this.q.flush()}}sendPause(){const g=new a(u.Pause,0,0,I());this.q.write(g)}sendResume(){const g=new a(u.Resume,0,0,I());this.q.write(g)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(g,E){this.a=!0,this.s.dispose(),this.s=new C.$Tc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=g,this.q=this.s.add(new $(this.p)),this.r=this.s.add(new m(this.p)),this.s.add(this.r.onMessage(D=>this.A(D))),this.s.add(this.p.onClose(D=>this.y.fire(D))),this.r.acceptChunk(E)}endAcceptReconnection(){this.a=!1,this.j=this.h;const g=new a(u.Ack,0,this.j,I());this.q.write(g);const E=this.c.toArray();for(let D=0,y=E.length;D<y;D++)this.q.write(E[D]);this.C()}acceptDisconnect(){this.x.fire()}A(g){if(g.ack>this.f){this.f=g.ack;do{const E=this.c.peek();if(E&&E.id<=g.ack)this.c.pop();else break}while(!0)}switch(g.type){case u.None:break;case u.Regular:{if(g.id>this.h)if(g.id!==this.h+1){const E=Date.now();E-this.n>1e4&&(this.n=E,this.q.write(new a(u.ReplayRequest,0,0,I())))}else this.h=g.id,this.k=Date.now(),this.B(),this.w.fire(g.data);break}case u.Control:{this.v.fire(g.data);break}case u.Ack:break;case u.Disconnect:{this.x.fire();break}case u.ReplayRequest:{const E=this.c.toArray();for(let D=0,y=E.length;D<y;D++)this.q.write(E[D]);this.C();break}case u.Pause:{this.q.pause();break}case u.Resume:{this.q.resume();break}case u.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(g){const E=++this.d;this.j=this.h;const D=new a(u.Regular,E,this.j,g);this.c.push(D),this.a||(this.q.write(D),this.C())}sendControl(g){const E=new a(u.Control,0,0,g);this.q.write(E)}B(){if(this.h<=this.j||this.l)return;const g=Date.now()-this.k;if(g>=w.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},w.AcknowledgeTime-g+5)}C(){if(this.d<=this.f||this.g||this.a)return;const g=this.c.peek(),E=Date.now()-g.writtenTime,D=Date.now()-this.r.lastReadTime,y=Date.now()-this.o;if(E>=w.TimeoutTime&&D>=w.TimeoutTime&&y>=w.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:E,timeSinceLastReceivedSomeData:D});return}const k=Math.max(w.TimeoutTime-E,w.TimeoutTime-D,w.TimeoutTime-y,500);this.g=setTimeout(()=>{this.g=null,this.C()},k)}D(){if(this.h<=this.j)return;this.j=this.h;const g=new a(u.Ack,0,this.j,I());this.q.write(g)}E(){this.j=this.h;const g=new a(u.KeepAlive,0,this.j,I());this.q.write(g)}}e.$ti=d}),define(ke[192],Ie([1,0,56,7,21,20,188,13,4,3,24,109,104,86]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=e.$hr=void 0,T=qe(T);class w extends P.$hi{constructor($){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",f=>C.$Ne.wrap(Buffer.from(f,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$hr=w;class a{constructor($,f){this.i=$,this.j=f,this.c=new Set,this.g=new Map,this.h=new p.$le,this.onDidProcessExit=this.h.event;const i=f&&f.timeout?f.timeout:6e4;this.b=new h.$Ch(i),this.d=null,this.f=null}getChannel($){const f=this;return{call(i,s,t){return f.k($,i,s,t)},listen(i,s){return f.l($,i,s)}}}k($,f,i,s=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(T.$5());this.b.cancel();const t=this.n($),o=(0,h.$sh)(l=>t.call(f,i,l)),n=s.onCancellationRequested(()=>o.cancel()),d=(0,c.$Sc)(()=>o.cancel());return this.c.add(d),o.finally(()=>{n.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),o}l($,f,i){if(!this.b)return p.Event.None;this.b.cancel();let s;const t=new p.$le({onWillAddFirstListener:()=>{s=this.n($).listen(f,i)(t.fire,t),this.c.add(s)},onDidRemoveLastListener:()=>{this.c.delete(s),s.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,I.$eo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(E=>!/^--inspect(-brk)?=/.test(E)).filter(E=>!E.startsWith("--vscode-"))),(0,u.$mm)(f.env),this.d=(0,r.fork)(this.i,$,f);const i=new p.$le,t=p.Event.fromNodeEventEmitter(this.d,"message",E=>E)(E=>{if((0,O.$dr)(E)){(0,O.log)(E,`IPC Library: ${this.j.serverName}`);return}i.fire(C.$Ne.wrap(Buffer.from(E,"base64")))}),o=this.j.useQueue?(0,S.$zm)(this.d):this.d,n=E=>this.d&&this.d.connected&&o.send(E.buffer.toString("base64")),d=i.event,l={send:n,onMessage:d};this.f=new P.$ii(l);const g=()=>this.o();process.once("exit",g),this.d.on("error",E=>console.warn('IPC "'+this.j.serverName+'" errored with '+E)),this.d.on("exit",(E,D)=>{process.removeListener("exit",g),t.dispose(),this.c.forEach(y=>(0,c.$Pc)(y)),this.c.clear(),E!==0&&D!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+E+" and signal "+D),this.b?.cancel(),this.o(),this.h.fire({code:E,signal:D})})}return this.f}n($){let f=this.g.get($);return f||(f=this.m.getChannel($),this.g.set($,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$ir=a}),define(ke[193],Ie([1,0,7,4,3,44,17]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=e.StorageState=e.StorageHint=void 0,e.$dq=p;var T;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function p(u){const P=u;return P?.changed instanceof Map||P?.deleted instanceof Set}var c;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(c||(e.StorageState=c={}));class I extends C.$Uc{static{this.a=100}constructor(P,w=Object.create(null)){super(),this.r=P,this.s=w,this.b=this.B(new h.$oe),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new r.$Dh(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(P=>this.u(P)))}u(P){this.b.pause();try{P.changed?.forEach((w,a)=>this.w(a,w)),P.deleted?.forEach(w=>this.w(w,void 0))}finally{this.b.resume()}}w(P,w){if(this.c===c.Closed)return;let a=!1;(0,O.$ng)(w)?a=this.f.delete(P):this.f.get(P)!==w&&(this.f.set(P,w),a=!0),a&&this.b.fire({key:P,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(P,w){const a=this.f.get(P);return(0,O.$ng)(a)?w:a}getBoolean(P,w){const a=this.get(P);return(0,O.$ng)(a)?w:a==="true"}getNumber(P,w){const a=this.get(P);return(0,O.$ng)(a)?w:parseInt(a,10)}getObject(P,w){const a=this.get(P);return(0,O.$ng)(a)?w:(0,R.$bi)(a)}async set(P,w,a=!1){if(this.c===c.Closed)return;if((0,O.$ng)(w))return this.delete(P,a);const m=(0,O.$gg)(w)||Array.isArray(w)?(0,R.$ai)(w):String(w);if(this.f.get(P)!==m)return this.f.set(P,m),this.j.set(P,m),this.h.delete(P),this.b.fire({key:P,external:a}),this.D()}async delete(P,w=!1){if(!(this.c===c.Closed||!this.f.delete(P)))return this.h.has(P)||this.h.add(P),this.j.delete(P),this.b.fire({key:P,external:w}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const P={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(P).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(P){if(!(this.c===c.Closed||this.m))return this.D(P)}async D(P){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),P)}async whenFlushed(){if(this.z)return new Promise(P=>this.n.push(P))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$eq=I;class S{constructor(){this.onDidChangeItemsExternal=h.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(P){P.insert?.forEach((w,a)=>this.a.set(a,w)),P.delete?.forEach(w=>this.a.delete(w))}async optimize(){}async close(){}}e.$fq=S}),define(ke[139],Ie([1,0,83]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iu=e.$hu=void 0;class h{constructor(T){const p=(0,r.$af)(T);this.c=p,this.a=h.d(p),this.b=new Map}static d(T){const p=new Uint8Array(256);return p.fill(T),p}set(T,p){const c=(0,r.$af)(p);T>=0&&T<256?this.a[T]=c:this.b.set(T,c)}get(T){return T>=0&&T<256?this.a[T]:this.b.get(T)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$hu=h;var C;(function(O){O[O.False=0]="False",O[O.True=1]="True"})(C||(C={}));class R{constructor(){this.a=new h(C.False)}add(T){this.a.set(T,C.True)}has(T){return this.a.get(T)===C.True}clear(){return this.a.clear()}}e.$iu=R}),define(ke[194],Ie([1,0,26]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$zu=C;var h;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(h||(e.StringEOL=h={}));function C(R){let O=0,T=0,p=0,c=h.Unknown;for(let I=0,S=R.length;I<S;I++){const u=R.charCodeAt(I);u===r.CharCode.CarriageReturn?(O===0&&(T=I),O++,I+1<S&&R.charCodeAt(I+1)===r.CharCode.LineFeed?(c|=h.CRLF,I++):c|=h.Invalid,p=I+1):u===r.CharCode.LineFeed&&(c|=h.LF,O===0&&(T=I),O++,p=I+1)}return O===0&&(T=R.length),[O,T,R.length-p,c]}}),define(ke[57],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nt=void 0;class r{constructor(C,R){this.lineNumber=C,this.column=R}with(C=this.lineNumber,R=this.column){return C===this.lineNumber&&R===this.column?this:new r(C,R)}delta(C=0,R=0){return this.with(this.lineNumber+C,this.column+R)}equals(C){return r.equals(this,C)}static equals(C,R){return!C&&!R?!0:!!C&&!!R&&C.lineNumber===R.lineNumber&&C.column===R.column}isBefore(C){return r.isBefore(this,C)}static isBefore(C,R){return C.lineNumber<R.lineNumber?!0:R.lineNumber<C.lineNumber?!1:C.column<R.column}isBeforeOrEqual(C){return r.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,R){return C.lineNumber<R.lineNumber?!0:R.lineNumber<C.lineNumber?!1:C.column<=R.column}static compare(C,R){const O=C.lineNumber|0,T=R.lineNumber|0;if(O===T){const p=C.column|0,c=R.column|0;return p-c}return O-T}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new r(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Nt=r}),define(ke[30],Ie([1,0,57]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ot=void 0;class h{constructor(R,O,T,p){R>T||R===T&&O>p?(this.startLineNumber=T,this.startColumn=p,this.endLineNumber=R,this.endColumn=O):(this.startLineNumber=R,this.startColumn=O,this.endLineNumber=T,this.endColumn=p)}isEmpty(){return h.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return h.containsPosition(this,R)}static containsPosition(R,O){return!(O.lineNumber<R.startLineNumber||O.lineNumber>R.endLineNumber||O.lineNumber===R.startLineNumber&&O.column<R.startColumn||O.lineNumber===R.endLineNumber&&O.column>R.endColumn)}static strictContainsPosition(R,O){return!(O.lineNumber<R.startLineNumber||O.lineNumber>R.endLineNumber||O.lineNumber===R.startLineNumber&&O.column<=R.startColumn||O.lineNumber===R.endLineNumber&&O.column>=R.endColumn)}containsRange(R){return h.containsRange(this,R)}static containsRange(R,O){return!(O.startLineNumber<R.startLineNumber||O.endLineNumber<R.startLineNumber||O.startLineNumber>R.endLineNumber||O.endLineNumber>R.endLineNumber||O.startLineNumber===R.startLineNumber&&O.startColumn<R.startColumn||O.endLineNumber===R.endLineNumber&&O.endColumn>R.endColumn)}strictContainsRange(R){return h.strictContainsRange(this,R)}static strictContainsRange(R,O){return!(O.startLineNumber<R.startLineNumber||O.endLineNumber<R.startLineNumber||O.startLineNumber>R.endLineNumber||O.endLineNumber>R.endLineNumber||O.startLineNumber===R.startLineNumber&&O.startColumn<=R.startColumn||O.endLineNumber===R.endLineNumber&&O.endColumn>=R.endColumn)}plusRange(R){return h.plusRange(this,R)}static plusRange(R,O){let T,p,c,I;return O.startLineNumber<R.startLineNumber?(T=O.startLineNumber,p=O.startColumn):O.startLineNumber===R.startLineNumber?(T=O.startLineNumber,p=Math.min(O.startColumn,R.startColumn)):(T=R.startLineNumber,p=R.startColumn),O.endLineNumber>R.endLineNumber?(c=O.endLineNumber,I=O.endColumn):O.endLineNumber===R.endLineNumber?(c=O.endLineNumber,I=Math.max(O.endColumn,R.endColumn)):(c=R.endLineNumber,I=R.endColumn),new h(T,p,c,I)}intersectRanges(R){return h.intersectRanges(this,R)}static intersectRanges(R,O){let T=R.startLineNumber,p=R.startColumn,c=R.endLineNumber,I=R.endColumn;const S=O.startLineNumber,u=O.startColumn,P=O.endLineNumber,w=O.endColumn;return T<S?(T=S,p=u):T===S&&(p=Math.max(p,u)),c>P?(c=P,I=w):c===P&&(I=Math.min(I,w)),T>c||T===c&&p>I?null:new h(T,p,c,I)}equalsRange(R){return h.equalsRange(this,R)}static equalsRange(R,O){return!R&&!O?!0:!!R&&!!O&&R.startLineNumber===O.startLineNumber&&R.startColumn===O.startColumn&&R.endLineNumber===O.endLineNumber&&R.endColumn===O.endColumn}getEndPosition(){return h.getEndPosition(this)}static getEndPosition(R){return new r.$Nt(R.endLineNumber,R.endColumn)}getStartPosition(){return h.getStartPosition(this)}static getStartPosition(R){return new r.$Nt(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,O){return new h(this.startLineNumber,this.startColumn,R,O)}setStartPosition(R,O){return new h(R,O,this.endLineNumber,this.endColumn)}collapseToStart(){return h.collapseToStart(this)}static collapseToStart(R){return new h(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return h.collapseToEnd(this)}static collapseToEnd(R){return new h(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new h(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,O=R){return new h(R.lineNumber,R.column,O.lineNumber,O.column)}static lift(R){return R?new h(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,O){return!(R.endLineNumber<O.startLineNumber||R.endLineNumber===O.startLineNumber&&R.endColumn<O.startColumn||O.endLineNumber<R.startLineNumber||O.endLineNumber===R.startLineNumber&&O.endColumn<R.startColumn)}static areIntersecting(R,O){return!(R.endLineNumber<O.startLineNumber||R.endLineNumber===O.startLineNumber&&R.endColumn<=O.startColumn||O.endLineNumber<R.startLineNumber||O.endLineNumber===R.startLineNumber&&O.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,O){if(R&&O){const c=R.startLineNumber|0,I=O.startLineNumber|0;if(c===I){const S=R.startColumn|0,u=O.startColumn|0;if(S===u){const P=R.endLineNumber|0,w=O.endLineNumber|0;if(P===w){const a=R.endColumn|0,m=O.endColumn|0;return a-m}return P-w}return S-u}return c-I}return(R?1:0)-(O?1:0)}static compareRangesUsingEnds(R,O){return R.endLineNumber===O.endLineNumber?R.endColumn===O.endColumn?R.startLineNumber===O.startLineNumber?R.startColumn-O.startColumn:R.startLineNumber-O.startLineNumber:R.endColumn-O.endColumn:R.endLineNumber-O.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$Ot=h}),define(ke[195],Ie([1,0,30]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pt=void 0;class h{static insert(R,O){return{range:new r.$Ot(R.lineNumber,R.column,R.lineNumber,R.column),text:O,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,O){return{range:R,text:O}}static replaceMove(R,O){return{range:R,text:O,forceMoveMarkers:!0}}}e.$Pt=h}),define(ke[196],Ie([1,0,57,30]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qt=e.SelectionDirection=void 0;var C;(function(O){O[O.LTR=0]="LTR",O[O.RTL=1]="RTL"})(C||(e.SelectionDirection=C={}));class R extends h.$Ot{constructor(T,p,c,I){super(T,p,c,I),this.selectionStartLineNumber=T,this.selectionStartColumn=p,this.positionLineNumber=c,this.positionColumn=I}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(T){return R.selectionsEqual(this,T)}static selectionsEqual(T,p){return T.selectionStartLineNumber===p.selectionStartLineNumber&&T.selectionStartColumn===p.selectionStartColumn&&T.positionLineNumber===p.positionLineNumber&&T.positionColumn===p.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?C.LTR:C.RTL}setEndPosition(T,p){return this.getDirection()===C.LTR?new R(this.startLineNumber,this.startColumn,T,p):new R(T,p,this.startLineNumber,this.startColumn)}getPosition(){return new r.$Nt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.$Nt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(T,p){return this.getDirection()===C.LTR?new R(T,p,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,T,p)}static fromPositions(T,p=T){return new R(T.lineNumber,T.column,p.lineNumber,p.column)}static fromRange(T,p){return p===C.LTR?new R(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):new R(T.endLineNumber,T.endColumn,T.startLineNumber,T.startColumn)}static liftSelection(T){return new R(T.selectionStartLineNumber,T.selectionStartColumn,T.positionLineNumber,T.positionColumn)}static selectionsArrEqual(T,p){if(T&&!p||!T&&p)return!1;if(!T&&!p)return!0;if(T.length!==p.length)return!1;for(let c=0,I=T.length;c<I;c++)if(!this.selectionsEqual(T[c],p[c]))return!1;return!0}static isISelection(T){return T&&typeof T.selectionStartLineNumber=="number"&&typeof T.selectionStartColumn=="number"&&typeof T.positionLineNumber=="number"&&typeof T.positionColumn=="number"}static createWithDirection(T,p,c,I,S){return S===C.LTR?new R(T,p,c,I):new R(c,I,T,p)}}e.$Qt=R}),define(ke[197],Ie([1,0,12,10,21]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eu=void 0,e.$cu=I,e.$du=S,r=qe(r),h=qe(h),C=qe(C);let R;function O(){return R||(R=new TextDecoder("UTF-16LE")),R}let T;function p(){return T||(T=new TextDecoder("UTF-16BE")),T}let c;function I(){return c||(c=h.$E()?O():p()),c}function S(w,a,m){const $=new Uint16Array(w.buffer,a,m);return m>0&&($[0]===65279||$[0]===65534)?u(w,a,m):O().decode($)}function u(w,a,m){const $=[];let f=0;for(let i=0;i<m;i++){const s=C.$Pe(w,a);a+=2,$[f++]=String.fromCharCode(s)}return $.join("")}class P{constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return I().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const m=this.a-this.d;m<=1&&(m===0||r.$Jf(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const m=a.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=a;return}for(let $=0;$<m;$++)this.b[this.d++]=a.charCodeAt($)}}e.$eu=P}),define(ke[198],Ie([1,0,21,197]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fu=void 0,e.$gu=O,r=qe(r);function C(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(c,I,S,u){this.oldPosition=c,this.oldText=I,this.newPosition=S,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${C(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${C(this.oldText)}")`:`(replace@${this.oldPosition} "${C(this.oldText)}" with "${C(this.newText)}")`}static a(c){return 4+2*c.length}static c(c,I,S){const u=I.length;r.$Se(c,u,S),S+=4;for(let P=0;P<u;P++)r.$Qe(c,I.charCodeAt(P),S),S+=2;return S}static d(c,I){const S=r.$Re(c,I);return I+=4,(0,h.$du)(c,I,S)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(c,I){return r.$Se(c,this.oldPosition,I),I+=4,r.$Se(c,this.newPosition,I),I+=4,I=R.c(c,this.oldText,I),I=R.c(c,this.newText,I),I}static read(c,I,S){const u=r.$Re(c,I);I+=4;const P=r.$Re(c,I);I+=4;const w=R.d(c,I);I+=R.a(w);const a=R.d(c,I);return I+=R.a(a),S.push(new R(u,w,P,a)),I}}e.$fu=R;function O(p,c){return p===null||p.length===0?c:new T(p,c).compress()}class T{constructor(c,I){this.a=c,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let c=0,I=0,S=this.n(c),u=this.l(I);for(;c<this.f||I<this.h;){if(S===null){this.k(u),u=this.l(++I);continue}if(u===null){this.m(S),S=this.n(++c);continue}if(u.oldEnd<=S.newPosition){this.k(u),u=this.l(++I);continue}if(S.newEnd<=u.oldPosition){this.m(S),S=this.n(++c);continue}if(u.oldPosition<S.newPosition){const[$,f]=T.r(u,S.newPosition-u.oldPosition);this.k($),u=f;continue}if(S.newPosition<u.oldPosition){const[$,f]=T.q(S,u.oldPosition-S.newPosition);this.m($),S=f;continue}let a,m;if(u.oldEnd===S.newEnd)a=S,m=u,S=this.n(++c),u=this.l(++I);else if(u.oldEnd<S.newEnd){const[$,f]=T.q(S,u.oldLength);a=$,m=u,S=f,u=this.l(++I)}else{const[$,f]=T.r(u,S.newLength);a=S,m=$,S=this.n(++c),u=f}this.d[this.e++]=new R(a.oldPosition,a.oldText,m.newPosition,m.newText),this.g+=a.newLength-a.oldLength,this.j+=m.newLength-m.oldLength}const P=T.s(this.d);return T.t(P)}k(c){this.d[this.e++]=T.o(this.g,c),this.j+=c.newLength-c.oldLength}l(c){return c<this.h?this.c[c]:null}m(c){this.d[this.e++]=T.p(this.j,c),this.g+=c.newLength-c.oldLength}n(c){return c<this.f?this.a[c]:null}static o(c,I){return new R(I.oldPosition-c,I.oldText,I.newPosition,I.newText)}static p(c,I){return new R(I.oldPosition,I.oldText,I.newPosition+c,I.newText)}static q(c,I){const S=c.newText.substr(0,I),u=c.newText.substr(I);return[new R(c.oldPosition,c.oldText,c.newPosition,S),new R(c.oldEnd,"",c.newPosition+I,u)]}static r(c,I){const S=c.oldText.substr(0,I),u=c.oldText.substr(I);return[new R(c.oldPosition,S,c.newPosition,c.newText),new R(c.oldPosition+I,u,c.newEnd,"")]}static s(c){if(c.length===0)return c;const I=[];let S=0,u=c[0];for(let P=1;P<c.length;P++){const w=c[P];u.oldEnd===w.oldPosition?u=new R(u.oldPosition,u.oldText+w.oldText,u.newPosition,u.newText+w.newText):(I[S++]=u,u=w)}return I[S++]=u,I}static t(c){if(c.length===0)return c;const I=[];let S=0;for(let u=0;u<c.length;u++){const P=c[u];P.oldText!==P.newText&&(I[S++]=P)}return I}}}),define(ke[199],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=void 0,e.$lt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[200],Ie([1,0,26,28,139]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ju=e.WordCharacterClass=void 0,e.$ku=p;var R;(function(c){c[c.Regular=0]="Regular",c[c.Whitespace=1]="Whitespace",c[c.WordSeparator=2]="WordSeparator"})(R||(e.WordCharacterClass=R={}));class O extends C.$hu{constructor(I,S){super(R.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=S,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let u=0,P=I.length;u<P;u++)this.set(I.charCodeAt(u),R.WordSeparator);this.set(r.CharCode.Space,R.Whitespace),this.set(r.CharCode.Tab,R.Whitespace)}findPrevIntlWordBeforeOrAtOffset(I,S){let u=null;for(const P of this.h(I)){if(P.index>S)break;u=P}return u}findNextIntlWordAtOrAfterOffset(I,S){for(const u of this.h(I))if(!(u.index<S))return u;return null}h(I){return this.e?this.f===I?this.g:(this.f=I,this.g=this.j(this.e.segment(I)),this.g):[]}j(I){const S=[];for(const u of I)this.k(u)&&S.push(u);return S}k(I){return!!I.isWordLike}}e.$ju=O;const T=new h.$Dc(10);function p(c,I){const S=`${c}/${I.join(",")}`;let u=T.get(S);return u||(u=new O(c,I),T.set(S,u)),u}}),define(ke[140],Ie([1,0,39,3,80]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=e.$mt=void 0,e.$ot=O,e.$pt=p,e.$qt=c,e.$mt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(S=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.$mt)S.indexOf(P)>=0||(u+="\\"+P);return u+="\\s]+)",new RegExp(u,"g")}e.$nt=R();function O(S){let u=e.$nt;if(S&&S instanceof RegExp)if(S.global)u=S;else{let P="g";S.ignoreCase&&(P+="i"),S.multiline&&(P+="m"),S.unicode&&(P+="u"),u=new RegExp(S.source,P)}return u.lastIndex=0,u}const T=new C.$5c;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function p(S){const u=T.unshift(S);return(0,h.$Sc)(u)}function c(S,u,P,w,a){if(u=O(u),a||(a=r.Iterable.first(T)),P.length>a.maxLen){let s=S-a.maxLen/2;return s<0?s=0:w+=s,P=P.substring(s,S+a.maxLen/2),c(S,u,P,w,a)}const m=Date.now(),$=S-1-w;let f=-1,i=null;for(let s=1;!(Date.now()-m>=a.timeBudget);s++){const t=$-a.windowSize*s;u.lastIndex=Math.max(0,t);const o=I(u,P,$,f);if(!o&&i||(i=o,t<=0))break;f=t}if(i){const s={word:i[0],startColumn:w+1+i.index,endColumn:w+1+i.index+i[0].length};return u.lastIndex=0,s}return null}function I(S,u,P,w){let a;for(;a=S.exec(u);){const m=a.index||0;if(m<=P&&S.lastIndex>=P)return a;if(w>0&&m>w)return null}return null}}),define(ke[110],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vu=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var r;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(r||(e.LanguageId=r={}));var h;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline",p[p.Strikethrough=8]="Strikethrough"})(h||(e.FontStyle=h={}));var C;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(C||(e.ColorId=C={}));var R;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=3]="RegEx"})(R||(e.StandardTokenType=R={}));var O;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",p[p.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",p[p.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",p[p.ITALIC_MASK=2048]="ITALIC_MASK",p[p.BOLD_MASK=4096]="BOLD_MASK",p[p.UNDERLINE_MASK=8192]="UNDERLINE_MASK",p[p.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",p[p.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",p[p.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(O||(e.MetadataConsts=O={}));class T{static getLanguageId(c){return(c&O.LANGUAGEID_MASK)>>>O.LANGUAGEID_OFFSET}static getTokenType(c){return(c&O.TOKEN_TYPE_MASK)>>>O.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(c){return(c&O.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(c){return(c&O.FONT_STYLE_MASK)>>>O.FONT_STYLE_OFFSET}static getForeground(c){return(c&O.FOREGROUND_MASK)>>>O.FOREGROUND_OFFSET}static getBackground(c){return(c&O.BACKGROUND_MASK)>>>O.BACKGROUND_OFFSET}static getClassNameFromMetadata(c){let S="mtk"+this.getForeground(c);const u=this.getFontStyle(c);return u&h.Italic&&(S+=" mtki"),u&h.Bold&&(S+=" mtkb"),u&h.Underline&&(S+=" mtku"),u&h.Strikethrough&&(S+=" mtks"),S}static getInlineStyleFromMetadata(c,I){const S=this.getForeground(c),u=this.getFontStyle(c);let P=`color: ${I[S]};`;u&h.Italic&&(P+="font-style: italic;"),u&h.Bold&&(P+="font-weight: bold;");let w="";return u&h.Underline&&(w+=" underline"),u&h.Strikethrough&&(w+=" line-through"),w&&(P+=`text-decoration:${w};`),P}static getPresentationFromMetadata(c){const I=this.getForeground(c),S=this.getFontStyle(c);return{foreground:I,italic:!!(S&h.Italic),bold:!!(S&h.Bold),underline:!!(S&h.Underline),strikethrough:!!(S&h.Strikethrough)}}}e.$vu=T}),define(ke[201],Ie([1,0,38,16]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wu=C,e.$xu=R;function C(O,T,p,c,I,S){if(Array.isArray(O)){let u=0;for(const P of O){const w=C(P,T,p,c,I,S);if(w===10)return w;w>u&&(u=w)}return u}else{if(typeof O=="string")return c?O==="*"?5:O===p?10:0:0;if(O){const{language:u,pattern:P,scheme:w,hasAccessToAllModels:a,notebookType:m}=O;if(!c&&!a)return 0;m&&I&&(T=I);let $=0;if(w)if(w===T.scheme)$=10;else if(w==="*")$=5;else return 0;if(u)if(u===p)$=10;else if(u==="*")$=Math.max($,5);else return 0;if(m)if(m===S)$=10;else if(m==="*"&&S!==void 0)$=Math.max($,5);else return 0;if(P){let f;if(typeof P=="string"?f=P:f={...P,base:(0,h.$hc)(P.base)},f===T.fsPath||(0,r.$zk)(f,T.fsPath))$=10;else return 0}return $}else return 0}}function R(O){return typeof O=="string"?!1:Array.isArray(O)?O.some(R):!!O.notebookType}}),define(ke[202],Ie([1,0,26,110]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xu=e.$Wu=e.IndentAction=void 0;var C;(function(p){p[p.None=0]="None",p[p.Indent=1]="Indent",p[p.IndentOutdent=2]="IndentOutdent",p[p.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class R{constructor(c){if(this.e=null,this.f=!1,this.open=c.open,this.close=c.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(c.notIn))for(let I=0,S=c.notIn.length;I<S;I++)switch(c.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(c){switch(c){case h.StandardTokenType.Other:return!0;case h.StandardTokenType.Comment:return this.c;case h.StandardTokenType.String:return this.b;case h.StandardTokenType.RegEx:return this.d}}shouldAutoClose(c,I){if(c.getTokenCount()===0)return!0;const S=c.findTokenIndexAtOffset(I-2),u=c.getStandardTokenType(S);return this.isOK(u)}g(c,I){for(let S=c;S<=I;S++){const u=String.fromCharCode(S);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(r.CharCode.Digit0,r.CharCode.Digit9)),this.e||(this.e=this.g(r.CharCode.a,r.CharCode.z)),this.e||(this.e=this.g(r.CharCode.A,r.CharCode.Z))),this.e}}e.$Wu=R;class O{constructor(c){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of c)T(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),T(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),T(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),T(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&T(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$Xu=O;function T(p,c,I){p.has(c)?p.get(c).push(I):p.set(c,[I])}}),define(ke[203],Ie([1,0,26,139]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G4=e.$F4=e.State=void 0,e.$H4=P;var C;(function(w){w[w.Invalid=0]="Invalid",w[w.Start=1]="Start",w[w.H=2]="H",w[w.HT=3]="HT",w[w.HTT=4]="HTT",w[w.HTTP=5]="HTTP",w[w.F=6]="F",w[w.FI=7]="FI",w[w.FIL=8]="FIL",w[w.BeforeColon=9]="BeforeColon",w[w.AfterColon=10]="AfterColon",w[w.AlmostThere=11]="AlmostThere",w[w.End=12]="End",w[w.Accept=13]="Accept",w[w.LastKnownState=14]="LastKnownState"})(C||(e.State=C={}));class R{constructor(a,m,$){const f=new Uint8Array(a*m);for(let i=0,s=a*m;i<s;i++)f[i]=$;this.a=f,this.rows=a,this.cols=m}get(a,m){return this.a[a*this.cols+m]}set(a,m,$){this.a[a*this.cols+m]=$}}class O{constructor(a){let m=0,$=C.Invalid;for(let i=0,s=a.length;i<s;i++){const[t,o,n]=a[i];o>m&&(m=o),t>$&&($=t),n>$&&($=n)}m++,$++;const f=new R($,m,C.Invalid);for(let i=0,s=a.length;i<s;i++){const[t,o,n]=a[i];f.set(t,o,n)}this.a=f,this.b=m}nextState(a,m){return m<0||m>=this.b?C.Invalid:this.a.get(a,m)}}e.$F4=O;let T=null;function p(){return T===null&&(T=new O([[C.Start,r.CharCode.h,C.H],[C.Start,r.CharCode.H,C.H],[C.Start,r.CharCode.f,C.F],[C.Start,r.CharCode.F,C.F],[C.H,r.CharCode.t,C.HT],[C.H,r.CharCode.T,C.HT],[C.HT,r.CharCode.t,C.HTT],[C.HT,r.CharCode.T,C.HTT],[C.HTT,r.CharCode.p,C.HTTP],[C.HTT,r.CharCode.P,C.HTTP],[C.HTTP,r.CharCode.s,C.BeforeColon],[C.HTTP,r.CharCode.S,C.BeforeColon],[C.HTTP,r.CharCode.Colon,C.AfterColon],[C.F,r.CharCode.i,C.FI],[C.F,r.CharCode.I,C.FI],[C.FI,r.CharCode.l,C.FIL],[C.FI,r.CharCode.L,C.FIL],[C.FIL,r.CharCode.e,C.BeforeColon],[C.FIL,r.CharCode.E,C.BeforeColon],[C.BeforeColon,r.CharCode.Colon,C.AfterColon],[C.AfterColon,r.CharCode.Slash,C.AlmostThere],[C.AlmostThere,r.CharCode.Slash,C.End]])),T}var c;(function(w){w[w.None=0]="None",w[w.ForceTermination=1]="ForceTermination",w[w.CannotEndIn=2]="CannotEndIn"})(c||(c={}));let I=null;function S(){if(I===null){I=new h.$hu(c.None);const w=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<w.length;m++)I.set(w.charCodeAt(m),c.ForceTermination);const a=".,;:";for(let m=0;m<a.length;m++)I.set(a.charCodeAt(m),c.CannotEndIn)}return I}class u{static a(a,m,$,f,i){let s=i-1;do{const t=m.charCodeAt(s);if(a.get(t)!==c.CannotEndIn)break;s--}while(s>f);if(f>0){const t=m.charCodeAt(f-1),o=m.charCodeAt(s);(t===r.CharCode.OpenParen&&o===r.CharCode.CloseParen||t===r.CharCode.OpenSquareBracket&&o===r.CharCode.CloseSquareBracket||t===r.CharCode.OpenCurlyBrace&&o===r.CharCode.CloseCurlyBrace)&&s--}return{range:{startLineNumber:$,startColumn:f+1,endLineNumber:$,endColumn:s+2},url:m.substring(f,s+1)}}static computeLinks(a,m=p()){const $=S(),f=[];for(let i=1,s=a.getLineCount();i<=s;i++){const t=a.getLineContent(i),o=t.length;let n=0,d=0,l=0,g=C.Start,E=!1,D=!1,y=!1,k=!1;for(;n<o;){let A=!1;const b=t.charCodeAt(n);if(g===C.Accept){let v;switch(b){case r.CharCode.OpenParen:E=!0,v=c.None;break;case r.CharCode.CloseParen:v=E?c.None:c.ForceTermination;break;case r.CharCode.OpenSquareBracket:y=!0,D=!0,v=c.None;break;case r.CharCode.CloseSquareBracket:y=!1,v=D?c.None:c.ForceTermination;break;case r.CharCode.OpenCurlyBrace:k=!0,v=c.None;break;case r.CharCode.CloseCurlyBrace:v=k?c.None:c.ForceTermination;break;case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.BackTick:l===b?v=c.ForceTermination:l===r.CharCode.SingleQuote||l===r.CharCode.DoubleQuote||l===r.CharCode.BackTick?v=c.None:v=c.ForceTermination;break;case r.CharCode.Asterisk:v=l===r.CharCode.Asterisk?c.ForceTermination:c.None;break;case r.CharCode.Pipe:v=l===r.CharCode.Pipe?c.ForceTermination:c.None;break;case r.CharCode.Space:v=y?c.None:c.ForceTermination;break;default:v=$.get(b)}v===c.ForceTermination&&(f.push(u.a($,t,i,d,n)),A=!0)}else if(g===C.End){let v;b===r.CharCode.OpenSquareBracket?(D=!0,v=c.None):v=$.get(b),v===c.ForceTermination?A=!0:g=C.Accept}else g=m.nextState(g,b),g===C.Invalid&&(A=!0);A&&(g=C.Start,E=!1,D=!1,k=!1,d=n+1,l=b),n++}g===C.Accept&&f.push(u.a($,t,i,d,o))}return f}}e.$G4=u;function P(w){return!w||typeof w.getLineCount!="function"||typeof w.getLineContent!="function"?[]:u.computeLinks(w)}}),define(ke[58],Ie([1,0,24]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iw=e.$hw=e.$gw=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$ew=e.$dw=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$fw=w,e.$jw=s;var h;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(h||(e.OverviewRulerLane=h={}));var C;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(C||(e.GlyphMarginLane=C={}));var R;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var O;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(O||(e.MinimapSectionHeaderStyle=O={}));var T;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(T||(e.InjectedTextCursorStops=T={}));var p;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(p||(e.EndOfLinePreference=p={}));var c;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(c||(e.DefaultEndOfLine=c={}));var I;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(I||(e.EndOfLineSequence=I={}));class S{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),o.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,o.indentSize|0),this.a=!1),this.insertSpaces=!!o.insertSpaces,this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=!!o.trimAutoWhitespace,this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.a===o.a&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,r.$io)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.$dw=S;class u{constructor(o,n){this._findMatchBrand=void 0,this.range=o,this.matches=n}}e.$ew=u;var P;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P||(e.TrackedRangeStickiness=P={}));function w(t){return t&&typeof t.read=="function"}var a;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(a||(e.PositionAffinity=a={}));var m;(function(t){t[t.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class ${constructor(o,n,d,l,g,E){this.identifier=o,this.range=n,this.text=d,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=g,this._isTracked=E}}e.$gw=$;class f{constructor(o,n,d){this.regex=o,this.wordSeparators=n,this.simpleSearch=d}}e.$hw=f;class i{constructor(o,n,d){this.reverseEdits=o,this.changes=n,this.trimAutoWhitespaceLineNumbers=d}}e.$iw=i;function s(t){return!t.isTooLargeForSyncing()&&!t.isForSimpleWidget}}),define(ke[204],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bD=e.NodeColor=e.$aD=void 0,e.$cD=C,e.$dD=R,e.$eD=c,e.$fD=I,e.$gD=S,e.$hD=u,e.$iD=P,e.$jD=w;class r{constructor(m,$){this.piece=m,this.color=$,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$bD)return C(this.right);let m=this;for(;m.parent!==e.$bD&&m.parent.left!==m;)m=m.parent;return m.parent===e.$bD?e.$bD:m.parent}prev(){if(this.left!==e.$bD)return R(this.left);let m=this;for(;m.parent!==e.$bD&&m.parent.right!==m;)m=m.parent;return m.parent===e.$bD?e.$bD:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$aD=r;var h;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(h||(e.NodeColor=h={})),e.$bD=new r(null,h.Black),e.$bD.parent=e.$bD,e.$bD.left=e.$bD,e.$bD.right=e.$bD,e.$bD.color=h.Black;function C(a){for(;a.left!==e.$bD;)a=a.left;return a}function R(a){for(;a.right!==e.$bD;)a=a.right;return a}function O(a){return a===e.$bD?0:a.size_left+a.piece.length+O(a.right)}function T(a){return a===e.$bD?0:a.lf_left+a.piece.lineFeedCnt+T(a.right)}function p(){e.$bD.parent=e.$bD}function c(a,m){const $=m.right;$.size_left+=m.size_left+(m.piece?m.piece.length:0),$.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=$.left,$.left!==e.$bD&&($.left.parent=m),$.parent=m.parent,m.parent===e.$bD?a.root=$:m.parent.left===m?m.parent.left=$:m.parent.right=$,$.left=m,m.parent=$}function I(a,m){const $=m.left;m.left=$.right,$.right!==e.$bD&&($.right.parent=m),$.parent=m.parent,m.size_left-=$.size_left+($.piece?$.piece.length:0),m.lf_left-=$.lf_left+($.piece?$.piece.lineFeedCnt:0),m.parent===e.$bD?a.root=$:m===m.parent.right?m.parent.right=$:m.parent.left=$,$.right=m,m.parent=$}function S(a,m){let $,f;if(m.left===e.$bD?(f=m,$=f.right):m.right===e.$bD?(f=m,$=f.left):(f=C(m.right),$=f.right),f===a.root){a.root=$,$.color=h.Black,m.detach(),p(),a.root.parent=e.$bD;return}const i=f.color===h.Red;if(f===f.parent.left?f.parent.left=$:f.parent.right=$,f===m?($.parent=f.parent,w(a,$)):(f.parent===m?$.parent=f:$.parent=f.parent,w(a,$),f.left=m.left,f.right=m.right,f.parent=m.parent,f.color=m.color,m===a.root?a.root=f:m===m.parent.left?m.parent.left=f:m.parent.right=f,f.left!==e.$bD&&(f.left.parent=f),f.right!==e.$bD&&(f.right.parent=f),f.size_left=m.size_left,f.lf_left=m.lf_left,w(a,f)),m.detach(),$.parent.left===$){const t=O($),o=T($);if(t!==$.parent.size_left||o!==$.parent.lf_left){const n=t-$.parent.size_left,d=o-$.parent.lf_left;$.parent.size_left=t,$.parent.lf_left=o,P(a,$.parent,n,d)}}if(w(a,$.parent),i){p();return}let s;for(;$!==a.root&&$.color===h.Black;)$===$.parent.left?(s=$.parent.right,s.color===h.Red&&(s.color=h.Black,$.parent.color=h.Red,c(a,$.parent),s=$.parent.right),s.left.color===h.Black&&s.right.color===h.Black?(s.color=h.Red,$=$.parent):(s.right.color===h.Black&&(s.left.color=h.Black,s.color=h.Red,I(a,s),s=$.parent.right),s.color=$.parent.color,$.parent.color=h.Black,s.right.color=h.Black,c(a,$.parent),$=a.root)):(s=$.parent.left,s.color===h.Red&&(s.color=h.Black,$.parent.color=h.Red,I(a,$.parent),s=$.parent.left),s.left.color===h.Black&&s.right.color===h.Black?(s.color=h.Red,$=$.parent):(s.left.color===h.Black&&(s.right.color=h.Black,s.color=h.Red,c(a,s),s=$.parent.left),s.color=$.parent.color,$.parent.color=h.Black,s.left.color=h.Black,I(a,$.parent),$=a.root));$.color=h.Black,p()}function u(a,m){for(w(a,m);m!==a.root&&m.parent.color===h.Red;)if(m.parent===m.parent.parent.left){const $=m.parent.parent.right;$.color===h.Red?(m.parent.color=h.Black,$.color=h.Black,m.parent.parent.color=h.Red,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,c(a,m)),m.parent.color=h.Black,m.parent.parent.color=h.Red,I(a,m.parent.parent))}else{const $=m.parent.parent.left;$.color===h.Red?(m.parent.color=h.Black,$.color=h.Black,m.parent.parent.color=h.Red,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,I(a,m)),m.parent.color=h.Black,m.parent.parent.color=h.Red,c(a,m.parent.parent))}a.root.color=h.Black}function P(a,m,$,f){for(;m!==a.root&&m!==e.$bD;)m.parent.left===m&&(m.parent.size_left+=$,m.parent.lf_left+=f),m=m.parent}function w(a,m){let $=0,f=0;if(m!==a.root){for(;m!==a.root&&m===m.parent.right;)m=m.parent;if(m!==a.root)for(m=m.parent,$=O(m.left)-m.size_left,f=T(m.left)-m.lf_left,m.size_left+=$,m.lf_left+=f;m!==a.root&&($!==0||f!==0);)m.parent.left===m&&(m.parent.size_left+=$,m.parent.lf_left+=f),m=m.parent}}}),define(ke[205],Ie([1,0,18,83]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ow=e.$nw=e.$mw=void 0;class C{constructor(p){this.a=p,this.b=new Uint32Array(p.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(p,c){p=(0,h.$bf)(p);const I=this.a,S=this.b,u=c.length;return u===0?!1:(this.a=new Uint32Array(I.length+u),this.a.set(I.subarray(0,p),0),this.a.set(I.subarray(p),p+u),this.a.set(c,p),p-1<this.c[0]&&(this.c[0]=p-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(S.subarray(0,this.c[0]+1)),!0)}setValue(p,c){return p=(0,h.$bf)(p),c=(0,h.$bf)(c),this.a[p]===c?!1:(this.a[p]=c,p-1<this.c[0]&&(this.c[0]=p-1),!0)}removeValues(p,c){p=(0,h.$bf)(p),c=(0,h.$bf)(c);const I=this.a,S=this.b;if(p>=I.length)return!1;const u=I.length-p;return c>=u&&(c=u),c===0?!1:(this.a=new Uint32Array(I.length-c),this.a.set(I.subarray(0,p),0),this.a.set(I.subarray(p+c),p),this.b=new Uint32Array(this.a.length),p-1<this.c[0]&&(this.c[0]=p-1),this.c[0]>=0&&this.b.set(S.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(p){return p<0?0:(p=(0,h.$bf)(p),this.d(p))}d(p){if(p<=this.c[0])return this.b[p];let c=this.c[0]+1;c===0&&(this.b[0]=this.a[0],c++),p>=this.a.length&&(p=this.a.length-1);for(let I=c;I<=p;I++)this.b[I]=this.b[I-1]+this.a[I];return this.c[0]=Math.max(this.c[0],p),this.b[p]}getIndexOf(p){p=Math.floor(p),this.getTotalSum();let c=0,I=this.a.length-1,S=0,u=0,P=0;for(;c<=I;)if(S=c+(I-c)/2|0,u=this.b[S],P=u-this.a[S],p<P)I=S-1;else if(p>=u)c=S+1;else break;return new O(S,p-P)}}e.$mw=C;class R{constructor(p){this.a=p,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(p){return this.g(),p===0?0:this.d[p-1]}getIndexOf(p){this.g();const c=this.e[p],I=c>0?this.d[c-1]:0;return new O(c,p-I)}removeValues(p,c){this.a.splice(p,c),this.f(p)}insertValues(p,c){this.a=(0,r.$Ub)(this.a,p,c),this.f(p)}f(p){this.b=!1,this.c=Math.min(this.c,p-1)}g(){if(!this.b){for(let p=this.c+1,c=this.a.length;p<c;p++){const I=this.a[p],S=p>0?this.d[p-1]:0;this.d[p]=S+I;for(let u=0;u<I;u++)this.e[S+u]=p}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(p,c){this.a[p]!==c&&(this.a[p]=c,this.f(p))}}e.$nw=R;class O{constructor(p,c){this.index=p,this.remainder=c,this._prefixSumIndexOfResultBrand=void 0,this.index=p,this.remainder=c}}e.$ow=O}),define(ke[206],Ie([1,0,12,57,205]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pw=void 0;class R{constructor(T,p,c,I){this.d=T,this.f=p,this.g=c,this.h=I,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(T){T.eol&&T.eol!==this.g&&(this.g=T.eol,this.j=null);const p=T.changes;for(const c of p)this.o(c.range),this.p(new h.$Nt(c.range.startLineNumber,c.range.startColumn),c.text);this.h=T.versionId,this.k=null}l(){if(!this.j){const T=this.g.length,p=this.f.length,c=new Uint32Array(p);for(let I=0;I<p;I++)c[I]=this.f[I].length+T;this.j=new C.$mw(c)}}n(T,p){this.f[T]=p,this.j&&this.j.setValue(T,this.f[T].length+this.g.length)}o(T){if(T.startLineNumber===T.endLineNumber){if(T.startColumn===T.endColumn)return;this.n(T.startLineNumber-1,this.f[T.startLineNumber-1].substring(0,T.startColumn-1)+this.f[T.startLineNumber-1].substring(T.endColumn-1));return}this.n(T.startLineNumber-1,this.f[T.startLineNumber-1].substring(0,T.startColumn-1)+this.f[T.endLineNumber-1].substring(T.endColumn-1)),this.f.splice(T.startLineNumber,T.endLineNumber-T.startLineNumber),this.j&&this.j.removeValues(T.startLineNumber,T.endLineNumber-T.startLineNumber)}p(T,p){if(p.length===0)return;const c=(0,r.$sf)(p);if(c.length===1){this.n(T.lineNumber-1,this.f[T.lineNumber-1].substring(0,T.column-1)+c[0]+this.f[T.lineNumber-1].substring(T.column-1));return}c[c.length-1]+=this.f[T.lineNumber-1].substring(T.column-1),this.n(T.lineNumber-1,this.f[T.lineNumber-1].substring(0,T.column-1)+c[0]);const I=new Uint32Array(c.length-1);for(let S=1;S<c.length;S++)this.f.splice(T.lineNumber+S-1,0,c[S]),I[S-1]=c[S].length+this.g.length;this.j&&this.j.insertValues(T.lineNumber,I)}}e.$pw=R}),define(ke[111],Ie([1,0,26,12,200,57,30,58]),function($e,e,r,h,C,R,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pD=e.$nD=e.$kD=void 0,e.$lD=I,e.$mD=S,e.$oD=m,h=qe(h);const p=999;class c{constructor(i,s,t,o){this.searchString=i,this.isRegex=s,this.matchCase=t,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=I(this.searchString):i=this.searchString.indexOf(`
`)>=0;let s=null;try{s=h.$qf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!s)return null;let t=!this.isRegex&&!i;return t&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(t=this.matchCase),new T.$hw(s,this.wordSeparators?(0,C.$ku)(this.wordSeparators,[]):null,t?this.searchString:null)}}e.$kD=c;function I(f){if(!f||f.length===0)return!1;for(let i=0,s=f.length;i<s;i++){const t=f.charCodeAt(i);if(t===r.CharCode.LineFeed)return!0;if(t===r.CharCode.Backslash){if(i++,i>=s)break;const o=f.charCodeAt(i);if(o===r.CharCode.n||o===r.CharCode.r||o===r.CharCode.W)return!0}}return!1}function S(f,i,s){if(!s)return new T.$ew(f,null);const t=[];for(let o=0,n=i.length;o<n;o++)t[o]=i[o];return new T.$ew(f,t)}class u{constructor(i){const s=[];let t=0;for(let o=0,n=i.length;o<n;o++)i.charCodeAt(o)===r.CharCode.LineFeed&&(s[t++]=o);this.a=s}findLineFeedCountBeforeOffset(i){const s=this.a;let t=0,o=s.length-1;if(o===-1||i<=s[0])return 0;for(;t<o;){const n=t+((o-t)/2>>0);s[n]>=i?o=n-1:s[n+1]>=i?(t=n,o=n):t=n+1}return t+1}}class P{static findMatches(i,s,t,o,n){const d=s.parseSearchRequest();return d?d.regex.multiline?this.b(i,t,new $(d.wordSeparators,d.regex),o,n):this.c(i,t,d,o,n):[]}static a(i,s,t,o,n,d){let l,g=0;o?(g=o.findLineFeedCountBeforeOffset(n),l=s+n+g):l=s+n;let E;if(o){const A=o.findLineFeedCountBeforeOffset(n+d.length)-g;E=l+d.length+A}else E=l+d.length;const D=i.getPositionAt(l),y=i.getPositionAt(E);return new O.$Ot(D.lineNumber,D.column,y.lineNumber,y.column)}static b(i,s,t,o,n){const d=i.getOffsetAt(s.getStartPosition()),l=i.getValueInRange(s,T.EndOfLinePreference.LF),g=i.getEOL()===`\r
`?new u(l):null,E=[];let D=0,y;for(t.reset(0);y=t.next(l);)if(E[D++]=S(this.a(i,d,l,g,y.index,y[0]),y,o),D>=n)return E;return E}static c(i,s,t,o,n){const d=[];let l=0;if(s.startLineNumber===s.endLineNumber){const E=i.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return l=this.d(t,E,s.startLineNumber,s.startColumn-1,l,d,o,n),d}const g=i.getLineContent(s.startLineNumber).substring(s.startColumn-1);l=this.d(t,g,s.startLineNumber,s.startColumn-1,l,d,o,n);for(let E=s.startLineNumber+1;E<s.endLineNumber&&l<n;E++)l=this.d(t,i.getLineContent(E),E,0,l,d,o,n);if(l<n){const E=i.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);l=this.d(t,E,s.endLineNumber,0,l,d,o,n)}return d}static d(i,s,t,o,n,d,l,g){const E=i.wordSeparators;if(!l&&i.simpleSearch){const k=i.simpleSearch,A=k.length,b=s.length;let v=-A;for(;(v=s.indexOf(k,v+A))!==-1;)if((!E||m(E,s,b,v,A))&&(d[n++]=new T.$ew(new O.$Ot(t,v+1+o,t,v+1+A+o),null),n>=g))return n;return n}const D=new $(i.wordSeparators,i.regex);let y;D.reset(0);do if(y=D.next(s),y&&(d[n++]=S(new O.$Ot(t,y.index+1+o,t,y.index+1+y[0].length+o),y,l),n>=g))return n;while(y);return n}static findNextMatch(i,s,t,o){const n=s.parseSearchRequest();if(!n)return null;const d=new $(n.wordSeparators,n.regex);return n.regex.multiline?this.e(i,t,d,o):this.f(i,t,d,o)}static e(i,s,t,o){const n=new R.$Nt(s.lineNumber,1),d=i.getOffsetAt(n),l=i.getLineCount(),g=i.getValueInRange(new O.$Ot(n.lineNumber,n.column,l,i.getLineMaxColumn(l)),T.EndOfLinePreference.LF),E=i.getEOL()===`\r
`?new u(g):null;t.reset(s.column-1);const D=t.next(g);return D?S(this.a(i,d,g,E,D.index,D[0]),D,o):s.lineNumber!==1||s.column!==1?this.e(i,new R.$Nt(1,1),t,o):null}static f(i,s,t,o){const n=i.getLineCount(),d=s.lineNumber,l=i.getLineContent(d),g=this.g(t,l,d,s.column,o);if(g)return g;for(let E=1;E<=n;E++){const D=(d+E-1)%n,y=i.getLineContent(D+1),k=this.g(t,y,D+1,1,o);if(k)return k}return null}static g(i,s,t,o,n){i.reset(o-1);const d=i.next(s);return d?S(new O.$Ot(t,d.index+1,t,d.index+1+d[0].length),d,n):null}static findPreviousMatch(i,s,t,o){const n=s.parseSearchRequest();if(!n)return null;const d=new $(n.wordSeparators,n.regex);return n.regex.multiline?this.h(i,t,d,o):this.j(i,t,d,o)}static h(i,s,t,o){const n=this.b(i,new O.$Ot(1,1,s.lineNumber,s.column),t,o,10*p);if(n.length>0)return n[n.length-1];const d=i.getLineCount();return s.lineNumber!==d||s.column!==i.getLineMaxColumn(d)?this.h(i,new R.$Nt(d,i.getLineMaxColumn(d)),t,o):null}static j(i,s,t,o){const n=i.getLineCount(),d=s.lineNumber,l=i.getLineContent(d).substring(0,s.column-1),g=this.k(t,l,d,o);if(g)return g;for(let E=1;E<=n;E++){const D=(n+d-E-1)%n,y=i.getLineContent(D+1),k=this.k(t,y,D+1,o);if(k)return k}return null}static k(i,s,t,o){let n=null,d;for(i.reset(0);d=i.next(s);)n=S(new O.$Ot(t,d.index+1,t,d.index+1+d[0].length),d,o);return n}}e.$nD=P;function w(f,i,s,t,o){if(t===0)return!0;const n=i.charCodeAt(t-1);if(f.get(n)!==C.WordCharacterClass.Regular||n===r.CharCode.CarriageReturn||n===r.CharCode.LineFeed)return!0;if(o>0){const d=i.charCodeAt(t);if(f.get(d)!==C.WordCharacterClass.Regular)return!0}return!1}function a(f,i,s,t,o){if(t+o===s)return!0;const n=i.charCodeAt(t+o);if(f.get(n)!==C.WordCharacterClass.Regular||n===r.CharCode.CarriageReturn||n===r.CharCode.LineFeed)return!0;if(o>0){const d=i.charCodeAt(t+o-1);if(f.get(d)!==C.WordCharacterClass.Regular)return!0}return!1}function m(f,i,s,t,o){return w(f,i,s,t,o)&&a(f,i,s,t,o)}class ${constructor(i,s){this._wordSeparators=i,this.a=s,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const s=i.length;let t;do{if(this.b+this.c===s||(t=this.a.exec(i),!t))return null;const o=t.index,n=t[0].length;if(o===this.b&&n===this.c){if(n===0){h.$Mf(i,s,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=n,!this._wordSeparators||m(this._wordSeparators,i,s,o,n))return t}while(t);return null}}e.$pD=$}),define(ke[141],Ie([1,0,26,57,30,58,204,111]),function($e,e,r,h,C,R,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uD=e.$tD=e.$sD=void 0,e.$qD=S,e.$rD=u;const p=65535;function c(f){let i;return f[f.length-1]<65536?i=new Uint16Array(f.length):i=new Uint32Array(f.length),i.set(f,0),i}class I{constructor(i,s,t,o,n){this.lineStarts=i,this.cr=s,this.lf=t,this.crlf=o,this.isBasicASCII=n}}function S(f,i=!0){const s=[0];let t=1;for(let o=0,n=f.length;o<n;o++){const d=f.charCodeAt(o);d===r.CharCode.CarriageReturn?o+1<n&&f.charCodeAt(o+1)===r.CharCode.LineFeed?(s[t++]=o+2,o++):s[t++]=o+1:d===r.CharCode.LineFeed&&(s[t++]=o+1)}return i?c(s):s}function u(f,i){f.length=0,f[0]=0;let s=1,t=0,o=0,n=0,d=!0;for(let g=0,E=i.length;g<E;g++){const D=i.charCodeAt(g);D===r.CharCode.CarriageReturn?g+1<E&&i.charCodeAt(g+1)===r.CharCode.LineFeed?(n++,f[s++]=g+2,g++):(t++,f[s++]=g+1):D===r.CharCode.LineFeed?(o++,f[s++]=g+1):d&&D!==r.CharCode.Tab&&(D<32||D>126)&&(d=!1)}const l=new I(c(f),t,o,n,d);return f.length=0,l}class P{constructor(i,s,t,o,n){this.bufferIndex=i,this.start=s,this.end=t,this.lineFeedCnt=o,this.length=n}}e.$sD=P;class w{constructor(i,s){this.buffer=i,this.lineStarts=s}}e.$tD=w;class a{constructor(i,s){this.a=[],this.c=i,this.d=s,this.b=0,i.root!==O.$bD&&i.iterate(i.root,t=>(t!==O.$bD&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class m{constructor(i){this.a=i,this.b=[]}get(i){for(let s=this.b.length-1;s>=0;s--){const t=this.b[s];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let s=this.b.length-1;s>=0;s--){const t=this.b[s];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let s=!1;const t=this.b;for(let o=0;o<t.length;o++){const n=t[o];if(n.node.parent===null||n.nodeStartOffset>=i){t[o]=null,s=!0;continue}}if(s){const o=[];for(const n of t)n!==null&&o.push(n);this.b=o}}}class ${constructor(i,s,t){this.create(i,s,t)}create(i,s,t){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=O.$bD,this.b=1,this.c=0,this.d=s,this.e=s.length,this.f=t;let o=null;for(let n=0,d=i.length;n<d;n++)if(i[n].buffer.length>0){i[n].lineStarts||(i[n].lineStarts=S(i[n].buffer));const l=new P(n+1,{line:0,column:0},{line:i[n].lineStarts.length-1,column:i[n].buffer.length-i[n].lineStarts[i[n].lineStarts.length-1]},i[n].lineStarts.length-1,i[n].buffer.length);this.a.push(i[n]),o=this.S(o,l)}this.h=new m(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const s=p,t=s-Math.floor(s/3),o=t*2;let n="",d=0;const l=[];if(this.iterate(this.root,g=>{const E=this.R(g),D=E.length;if(d<=t||d+D<o)return n+=E,d+=D,!0;const y=n.replace(/\r\n|\r|\n/g,i);return l.push(new w(y,S(y))),n=E,d=D,!0}),d>0){const g=n.replace(/\r\n|\r|\n/g,i);l.push(new w(g,S(g)))}this.create(l,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new a(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let s=0;return this.iterate(this.root,o=>{if(o===O.$bD)return!0;const n=this.R(o),d=n.length,l=i.G(s),g=i.G(s+d),E=i.getValueInRange2(l,g);return s+=d,n===E})}getOffsetAt(i,s){let t=0,o=this.root;for(;o!==O.$bD;)if(o.left!==O.$bD&&o.lf_left+1>=i)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=i){t+=o.size_left;const n=this.B(o,i-o.lf_left-2);return t+=n+s-1}else i-=o.lf_left+o.piece.lineFeedCnt,t+=o.size_left+o.piece.length,o=o.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let s=this.root,t=0;const o=i;for(;s!==O.$bD;)if(s.size_left!==0&&s.size_left>=i)s=s.left;else if(s.size_left+s.piece.length>=i){const n=this.A(s,i-s.size_left);if(t+=s.lf_left+n.index,n.index===0){const d=this.getOffsetAt(t+1,1),l=o-d;return new h.$Nt(t+1,l+1)}return new h.$Nt(t+1,n.remainder+1)}else if(i-=s.size_left+s.piece.length,t+=s.lf_left+s.piece.lineFeedCnt,s.right===O.$bD){const n=this.getOffsetAt(t+1,1),d=o-i-n;return new h.$Nt(t+1,d+1)}else s=s.right;return new h.$Nt(1,1)}getValueInRange(i,s){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),o=this.H(i.endLineNumber,i.endColumn),n=this.getValueInRange2(t,o);return s?s!==this.d||!this.f?n.replace(/\r\n|\r|\n/g,s):s===this.getEOL()&&this.f?n:n.replace(/\r\n|\r|\n/g,s):n}getValueInRange2(i,s){if(i.node===s.node){const l=i.node,g=this.a[l.piece.bufferIndex].buffer,E=this.u(l.piece.bufferIndex,l.piece.start);return g.substring(E+i.remainder,E+s.remainder)}let t=i.node;const o=this.a[t.piece.bufferIndex].buffer,n=this.u(t.piece.bufferIndex,t.piece.start);let d=o.substring(n+i.remainder,n+t.piece.length);for(t=t.next();t!==O.$bD;){const l=this.a[t.piece.bufferIndex].buffer,g=this.u(t.piece.bufferIndex,t.piece.start);if(t===s.node){d+=l.substring(g,g+s.remainder);break}else d+=l.substr(g,t.piece.length);t=t.next()}return d}getLinesContent(){const i=[];let s=0,t="",o=!1;return this.iterate(this.root,n=>{if(n===O.$bD)return!0;const d=n.piece;let l=d.length;if(l===0)return!0;const g=this.a[d.bufferIndex].buffer,E=this.a[d.bufferIndex].lineStarts,D=d.start.line,y=d.end.line;let k=E[D]+d.start.column;if(o&&(g.charCodeAt(k)===r.CharCode.LineFeed&&(k++,l--),i[s++]=t,t="",o=!1,l===0))return!0;if(D===y)return!this.f&&g.charCodeAt(k+l-1)===r.CharCode.CarriageReturn?(o=!0,t+=g.substr(k,l-1)):t+=g.substr(k,l),!0;t+=this.f?g.substring(k,Math.max(k,E[D+1]-this.e)):g.substring(k,E[D+1]).replace(/(\r\n|\r|\n)$/,""),i[s++]=t;for(let A=D+1;A<y;A++)t=this.f?g.substring(E[A],E[A+1]-this.e):g.substring(E[A],E[A+1]).replace(/(\r\n|\r|\n)$/,""),i[s++]=t;return!this.f&&g.charCodeAt(E[y]+d.end.column-1)===r.CharCode.CarriageReturn?(o=!0,d.end.column===0?s--:t=g.substr(E[y],d.end.column-1)):t=g.substr(E[y],d.end.column),!0}),o&&(i[s++]=t,t=""),i[s++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const s=i.node.next();if(!s)return 0;const t=this.a[s.piece.bufferIndex],o=this.u(s.piece.bufferIndex,s.piece.start);return t.buffer.charCodeAt(o)}else{const s=this.a[i.node.piece.bufferIndex],o=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return s.buffer.charCodeAt(o)}}getLineCharCode(i,s){const t=this.H(i,s+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const s=this.getOffsetAt(i,1);return this.getLength()-s}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const s=this.G(i);return this.l(s)}getNearestChunk(i){const s=this.G(i);if(s.remainder===s.node.piece.length){const t=s.node.next();if(!t||t===O.$bD)return"";const o=this.a[t.piece.bufferIndex],n=this.u(t.piece.bufferIndex,t.piece.start);return o.buffer.substring(n,n+t.piece.length)}else{const t=this.a[s.node.piece.bufferIndex],o=this.u(s.node.piece.bufferIndex,s.node.piece.start),n=o+s.remainder,d=o+s.node.piece.length;return t.buffer.substring(n,d)}}findMatchesInNode(i,s,t,o,n,d,l,g,E,D,y){const k=this.a[i.piece.bufferIndex],A=this.u(i.piece.bufferIndex,i.piece.start),b=this.u(i.piece.bufferIndex,n),v=this.u(i.piece.bufferIndex,d);let F;const N={line:0,column:0};let L,M;s._wordSeparators?(L=k.buffer.substring(b,v),M=z=>z+b,s.reset(0)):(L=k.buffer,M=z=>z,s.reset(b));do if(F=s.next(L),F){if(M(F.index)>=v)return D;this.s(i,M(F.index)-A,N);const z=this.t(i.piece.bufferIndex,n,N),j=N.line===n.line?N.column-n.column+o:N.column+1,W=j+F[0].length;if(y[D++]=(0,T.$mD)(new C.$Ot(t+z,j,t+z,W),F,g),M(F.index)+F[0].length>=v||D>=E)return D}while(F);return D}findMatchesLineByLine(i,s,t,o){const n=[];let d=0;const l=new T.$pD(s.wordSeparators,s.regex);let g=this.H(i.startLineNumber,i.startColumn);if(g===null)return[];const E=this.H(i.endLineNumber,i.endColumn);if(E===null)return[];let D=this.s(g.node,g.remainder);const y=this.s(E.node,E.remainder);if(g.node===E.node)return this.findMatchesInNode(g.node,l,i.startLineNumber,i.startColumn,D,y,s,t,o,d,n),n;let k=i.startLineNumber,A=g.node;for(;A!==E.node;){const v=this.t(A.piece.bufferIndex,D,A.piece.end);if(v>=1){const N=this.a[A.piece.bufferIndex].lineStarts,L=this.u(A.piece.bufferIndex,A.piece.start),M=N[D.line+v],z=k===i.startLineNumber?i.startColumn:1;if(d=this.findMatchesInNode(A,l,k,z,D,this.s(A,M-L),s,t,o,d,n),d>=o)return n;k+=v}const F=k===i.startLineNumber?i.startColumn-1:0;if(k===i.endLineNumber){const N=this.getLineContent(k).substring(F,i.endColumn-1);return d=this.n(s,l,N,i.endLineNumber,F,d,n,t,o),n}if(d=this.n(s,l,this.getLineContent(k).substr(F),k,F,d,n,t,o),d>=o)return n;k++,g=this.H(k,1),A=g.node,D=this.s(g.node,g.remainder)}if(k===i.endLineNumber){const v=k===i.startLineNumber?i.startColumn-1:0,F=this.getLineContent(k).substring(v,i.endColumn-1);return d=this.n(s,l,F,i.endLineNumber,v,d,n,t,o),n}const b=k===i.startLineNumber?i.startColumn:1;return d=this.findMatchesInNode(E.node,l,k,b,D,y,s,t,o,d,n),n}n(i,s,t,o,n,d,l,g,E){const D=i.wordSeparators;if(!g&&i.simpleSearch){const k=i.simpleSearch,A=k.length,b=t.length;let v=-A;for(;(v=t.indexOf(k,v+A))!==-1;)if((!D||(0,T.$oD)(D,t,b,v,A))&&(l[d++]=new R.$ew(new C.$Ot(o,v+1+n,o,v+1+A+n),null),d>=E))return d;return d}let y;s.reset(0);do if(y=s.next(t),y&&(l[d++]=(0,T.$mD)(new C.$Ot(o,y.index+1+n,o,y.index+1+y[0].length+n),y,g),d>=E))return d;while(y);return d}insert(i,s,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==O.$bD){const{node:o,remainder:n,nodeStartOffset:d}=this.G(i),l=o.piece,g=l.bufferIndex,E=this.s(o,n);if(o.piece.bufferIndex===0&&l.end.line===this.g.line&&l.end.column===this.g.column&&d+l.length===i&&s.length<p){this.F(o,s),this.y();return}if(d===i)this.o(s,o),this.h.validate(i);else if(d+o.piece.length>i){const D=[];let y=new P(l.bufferIndex,E,l.end,this.t(l.bufferIndex,E,l.end),this.u(g,l.end)-this.u(g,E));if(this.K()&&this.M(s)&&this.I(o,n)===10){const v={line:y.start.line+1,column:0};y=new P(y.bufferIndex,v,y.end,this.t(y.bufferIndex,v,y.end),y.length-1),s+=`
`}if(this.K()&&this.L(s))if(this.I(o,n-1)===13){const v=this.s(o,n-1);this.C(o,v),s="\r"+s,o.piece.length===0&&D.push(o)}else this.C(o,E);else this.C(o,E);const k=this.w(s);y.length>0&&this.S(o,y);let A=o;for(let b=0;b<k.length;b++)A=this.S(A,k[b]);this.v(D)}else this.q(s,o)}else{const o=this.w(s);let n=this.T(null,o[0]);for(let d=1;d<o.length;d++)n=this.S(n,o[d])}this.y()}delete(i,s){if(this.j.lineNumber=0,this.j.value="",s<=0||this.root===O.$bD)return;const t=this.G(i),o=this.G(i+s),n=t.node,d=o.node;if(n===d){const k=this.s(n,t.remainder),A=this.s(n,o.remainder);if(t.nodeStartOffset===i){if(s===n.piece.length){const b=n.next();(0,O.$gD)(this,n),this.N(b),this.y();return}this.D(n,A),this.h.validate(i),this.N(n),this.y();return}if(t.nodeStartOffset+n.piece.length===i+s){this.C(n,k),this.O(n),this.y();return}this.E(n,k,A),this.y();return}const l=[],g=this.s(n,t.remainder);this.C(n,g),this.h.validate(i),n.piece.length===0&&l.push(n);const E=this.s(d,o.remainder);this.D(d,E),d.piece.length===0&&l.push(d);const D=n.next();for(let k=D;k!==O.$bD&&k!==d;k=k.next())l.push(k);const y=n.piece.length===0?n.prev():n;this.v(l),this.O(y),this.y()}o(i,s){const t=[];if(this.K()&&this.M(i)&&this.L(s)){const d=s.piece,l={line:d.start.line+1,column:0},g=new P(d.bufferIndex,l,d.end,this.t(d.bufferIndex,l,d.end),d.length-1);s.piece=g,i+=`
`,(0,O.$iD)(this,s,-1,-1),s.piece.length===0&&t.push(s)}const o=this.w(i);let n=this.T(s,o[o.length-1]);for(let d=o.length-2;d>=0;d--)n=this.T(n,o[d]);this.N(n),this.v(t)}q(i,s){this.Q(i,s)&&(i+=`
`);const t=this.w(i),o=this.S(s,t[0]);let n=o;for(let d=1;d<t.length;d++)n=this.S(n,t[d]);this.N(o)}s(i,s,t){const o=i.piece,n=i.piece.bufferIndex,d=this.a[n].lineStarts,g=d[o.start.line]+o.start.column+s;let E=o.start.line,D=o.end.line,y=0,k=0,A=0;for(;E<=D&&(y=E+(D-E)/2|0,A=d[y],y!==D);)if(k=d[y+1],g<A)D=y-1;else if(g>=k)E=y+1;else break;return t?(t.line=y,t.column=g-A,null):{line:y,column:g-A}}t(i,s,t){if(t.column===0)return t.line-s.line;const o=this.a[i].lineStarts;if(t.line===o.length-1)return t.line-s.line;const n=o[t.line+1],d=o[t.line]+t.column;if(n>d+1)return t.line-s.line;const l=d-1;return this.a[i].buffer.charCodeAt(l)===13?t.line-s.line+1:t.line-s.line}u(i,s){return this.a[i].lineStarts[s.line]+s.column}v(i){for(let s=0;s<i.length;s++)(0,O.$gD)(this,i[s])}w(i){if(i.length>p){const D=[];for(;i.length>p;){const k=i.charCodeAt(p-1);let A;k===r.CharCode.CarriageReturn||k>=55296&&k<=56319?(A=i.substring(0,p-1),i=i.substring(p-1)):(A=i.substring(0,p),i=i.substring(p));const b=S(A);D.push(new P(this.a.length,{line:0,column:0},{line:b.length-1,column:A.length-b[b.length-1]},b.length-1,A.length)),this.a.push(new w(A,b))}const y=S(i);return D.push(new P(this.a.length,{line:0,column:0},{line:y.length-1,column:i.length-y[y.length-1]},y.length-1,i.length)),this.a.push(new w(i,y)),D}let s=this.a[0].buffer.length;const t=S(i,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===s&&s!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let D=0;D<t.length;D++)t[D]+=s+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,s+=1}else{if(s!==0)for(let D=0;D<t.length;D++)t[D]+=s;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const n=this.a[0].buffer.length,d=this.a[0].lineStarts.length-1,l=n-this.a[0].lineStarts[d],g={line:d,column:l},E=new P(0,o,g,this.t(0,o,g),n-s);return this.g=g,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,s=0){let t=this.root,o="";const n=this.h.get2(i);if(n){t=n.node;const d=this.B(t,i-n.nodeStartLineNumber-1),l=this.a[t.piece.bufferIndex].buffer,g=this.u(t.piece.bufferIndex,t.piece.start);if(n.nodeStartLineNumber+t.piece.lineFeedCnt===i)o=l.substring(g+d,g+t.piece.length);else{const E=this.B(t,i-n.nodeStartLineNumber);return l.substring(g+d,g+E-s)}}else{let d=0;const l=i;for(;t!==O.$bD;)if(t.left!==O.$bD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const g=this.B(t,i-t.lf_left-2),E=this.B(t,i-t.lf_left-1),D=this.a[t.piece.bufferIndex].buffer,y=this.u(t.piece.bufferIndex,t.piece.start);return d+=t.size_left,this.h.set({node:t,nodeStartOffset:d,nodeStartLineNumber:l-(i-1-t.lf_left)}),D.substring(y+g,y+E-s)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const g=this.B(t,i-t.lf_left-2),E=this.a[t.piece.bufferIndex].buffer,D=this.u(t.piece.bufferIndex,t.piece.start);o=E.substring(D+g,D+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,d+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==O.$bD;){const d=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const l=this.B(t,0),g=this.u(t.piece.bufferIndex,t.piece.start);return o+=d.substring(g,g+l-s),o}else{const l=this.u(t.piece.bufferIndex,t.piece.start);o+=d.substr(l,t.piece.length)}t=t.next()}return o}y(){let i=this.root,s=1,t=0;for(;i!==O.$bD;)s+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=s,this.c=t,this.h.validate(this.c)}A(i,s){const t=i.piece,o=this.s(i,s),n=o.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===s){const d=this.t(i.piece.bufferIndex,t.start,o);if(d!==n)return{index:d,remainder:0}}return{index:n,remainder:o.column}}B(i,s){if(s<0)return 0;const t=i.piece,o=this.a[t.bufferIndex].lineStarts,n=t.start.line+s+1;return n>t.end.line?o[t.end.line]+t.end.column-o[t.start.line]-t.start.column:o[n]-o[t.start.line]-t.start.column}C(i,s){const t=i.piece,o=t.lineFeedCnt,n=this.u(t.bufferIndex,t.end),d=s,l=this.u(t.bufferIndex,d),g=this.t(t.bufferIndex,t.start,d),E=g-o,D=l-n,y=t.length+D;i.piece=new P(t.bufferIndex,t.start,d,g,y),(0,O.$iD)(this,i,D,E)}D(i,s){const t=i.piece,o=t.lineFeedCnt,n=this.u(t.bufferIndex,t.start),d=s,l=this.t(t.bufferIndex,d,t.end),g=this.u(t.bufferIndex,d),E=l-o,D=n-g,y=t.length+D;i.piece=new P(t.bufferIndex,d,t.end,l,y),(0,O.$iD)(this,i,D,E)}E(i,s,t){const o=i.piece,n=o.start,d=o.end,l=o.length,g=o.lineFeedCnt,E=s,D=this.t(o.bufferIndex,o.start,E),y=this.u(o.bufferIndex,s)-this.u(o.bufferIndex,n);i.piece=new P(o.bufferIndex,o.start,E,D,y),(0,O.$iD)(this,i,y-l,D-g);const k=new P(o.bufferIndex,t,d,this.t(o.bufferIndex,t,d),this.u(o.bufferIndex,d)-this.u(o.bufferIndex,t)),A=this.S(i,k);this.N(A)}F(i,s){this.Q(s,i)&&(s+=`
`);const t=this.K()&&this.L(s)&&this.M(i),o=this.a[0].buffer.length;this.a[0].buffer+=s;const n=S(s,!1);for(let A=0;A<n.length;A++)n[A]+=o;if(t){const A=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-A}}this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1));const d=this.a[0].lineStarts.length-1,l=this.a[0].buffer.length-this.a[0].lineStarts[d],g={line:d,column:l},E=i.piece.length+s.length,D=i.piece.lineFeedCnt,y=this.t(0,i.piece.start,g),k=y-D;i.piece=new P(i.piece.bufferIndex,i.piece.start,g,y,E),this.g=g,(0,O.$iD)(this,i,s.length,k)}G(i){let s=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let o=0;for(;s!==O.$bD;)if(s.size_left>i)s=s.left;else if(s.size_left+s.piece.length>=i){o+=s.size_left;const n={node:s,remainder:i-s.size_left,nodeStartOffset:o};return this.h.set(n),n}else i-=s.size_left+s.piece.length,o+=s.size_left+s.piece.length,s=s.right;return null}H(i,s){let t=this.root,o=0;for(;t!==O.$bD;)if(t.left!==O.$bD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const n=this.B(t,i-t.lf_left-2),d=this.B(t,i-t.lf_left-1);return o+=t.size_left,{node:t,remainder:Math.min(n+s-1,d),nodeStartOffset:o}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const n=this.B(t,i-t.lf_left-2);if(n+s-1<=t.piece.length)return{node:t,remainder:n+s-1,nodeStartOffset:o};s-=t.piece.length-n;break}else i-=t.lf_left+t.piece.lineFeedCnt,o+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==O.$bD;){if(t.piece.lineFeedCnt>0){const n=this.B(t,0),d=this.J(t);return{node:t,remainder:Math.min(s-1,n),nodeStartOffset:d}}else if(t.piece.length>=s-1){const n=this.J(t);return{node:t,remainder:s-1,nodeStartOffset:n}}else s-=t.piece.length;t=t.next()}return null}I(i,s){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start)+s;return t.buffer.charCodeAt(o)}J(i){if(!i)return 0;let s=i.size_left;for(;i!==this.root;)i.parent.right===i&&(s+=i.parent.size_left+i.parent.piece.length),i=i.parent;return s}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===O.$bD||i.piece.lineFeedCnt===0)return!1;const s=i.piece,t=this.a[s.bufferIndex].lineStarts,o=s.start.line,n=t[o]+s.start.column;return o===t.length-1||t[o+1]>n+1?!1:this.a[s.bufferIndex].buffer.charCodeAt(n)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===O.$bD||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const s=i.prev();this.M(s)&&this.P(s,i)}}O(i){if(this.K()&&this.M(i)){const s=i.next();this.L(s)&&this.P(i,s)}}P(i,s){const t=[],o=this.a[i.piece.bufferIndex].lineStarts;let n;i.piece.end.column===0?n={line:i.piece.end.line-1,column:o[i.piece.end.line]-o[i.piece.end.line-1]-1}:n={line:i.piece.end.line,column:i.piece.end.column-1};const d=i.piece.length-1,l=i.piece.lineFeedCnt-1;i.piece=new P(i.piece.bufferIndex,i.piece.start,n,l,d),(0,O.$iD)(this,i,-1,-1),i.piece.length===0&&t.push(i);const g={line:s.piece.start.line+1,column:0},E=s.piece.length-1,D=this.t(s.piece.bufferIndex,g,s.piece.end);s.piece=new P(s.piece.bufferIndex,g,s.piece.end,D,E),(0,O.$iD)(this,s,-1,-1),s.piece.length===0&&t.push(s);const y=this.w(`\r
`);this.S(i,y[0]);for(let k=0;k<t.length;k++)(0,O.$gD)(this,t[k])}Q(i,s){if(this.K()&&this.M(i)){const t=s.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,O.$gD)(this,t);else{const o=t.piece,n={line:o.start.line+1,column:0},d=o.length-1,l=this.t(o.bufferIndex,n,o.end);t.piece=new P(o.bufferIndex,n,o.end,l,d),(0,O.$iD)(this,t,-1,-1)}return!0}}return!1}iterate(i,s){if(i===O.$bD)return s(O.$bD);const t=this.iterate(i.left,s);return t&&s(i)&&this.iterate(i.right,s)}R(i){if(i===O.$bD)return"";const s=this.a[i.piece.bufferIndex],t=i.piece,o=this.u(t.bufferIndex,t.start),n=this.u(t.bufferIndex,t.end);return s.buffer.substring(o,n)}getPieceContent(i){const s=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),o=this.u(i.bufferIndex,i.end);return s.buffer.substring(t,o)}S(i,s){const t=new O.$aD(s,O.NodeColor.Red);if(t.left=O.$bD,t.right=O.$bD,t.parent=O.$bD,t.size_left=0,t.lf_left=0,this.root===O.$bD)this.root=t,t.color=O.NodeColor.Black;else if(i.right===O.$bD)i.right=t,t.parent=i;else{const n=(0,O.$cD)(i.right);n.left=t,t.parent=n}return(0,O.$hD)(this,t),t}T(i,s){const t=new O.$aD(s,O.NodeColor.Red);if(t.left=O.$bD,t.right=O.$bD,t.parent=O.$bD,t.size_left=0,t.lf_left=0,this.root===O.$bD)this.root=t,t.color=O.NodeColor.Black;else if(i.left===O.$bD)i.left=t,t.parent=i;else{const o=(0,O.$dD)(i.left);o.right=t,t.parent=o}return(0,O.$hD)(this,t),t}U(i){let s="";return this.iterate(i,t=>(s+=this.R(t),!0)),s}}e.$uD=$}),define(ke[207],Ie([1,0,4,12,30,58,141,194,198,3]),function($e,e,r,h,C,R,O,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vD=void 0,h=qe(h);class I extends c.$Uc{constructor(u,P,w,a,m,$,f){super(),this.m=this.B(new r.$le),this.onDidChangeContent=this.m.event,this.f=P,this.j=!$,this.g=a,this.h=m,this.c=new O.$uD(u,w,f)}equals(u){return!(u instanceof I)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,P){return this.c.getOffsetAt(u,P)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,P){const w=u+P,a=this.getPositionAt(u),m=this.getPositionAt(w);return new C.$Ot(a.lineNumber,a.column,m.lineNumber,m.column)}getValueInRange(u,P=R.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const w=this.n(P);return this.c.getValueInRange(u,w)}getValueLengthInRange(u,P=R.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const w=this.getOffsetAt(u.startLineNumber,u.startColumn),a=this.getOffsetAt(u.endLineNumber,u.endColumn);let m=0;const $=this.n(P),f=this.getEOL();if($.length!==f.length){const i=$.length-f.length,s=u.endLineNumber-u.startLineNumber;m=i*s}return a-w+m}getCharacterCountInRange(u,P=R.EndOfLinePreference.TextDefined){if(this.j){let w=0;const a=u.startLineNumber,m=u.endLineNumber;for(let $=a;$<=m;$++){const f=this.getLineContent($),i=$===a?u.startColumn-1:0,s=$===m?u.endColumn-1:f.length;for(let t=i;t<s;t++)h.$Jf(f.charCodeAt(t))?(w=w+1,t=t+1):w=w+1}return w+=this.n(P).length*(m-a),w}return this.getValueLengthInRange(u,P)}getNearestChunk(u){return this.c.getNearestChunk(u)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,P){return this.c.getLineCharCode(u,P)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const P=h.$uf(this.getLineContent(u));return P===-1?0:P+1}getLineLastNonWhitespaceColumn(u){const P=h.$wf(this.getLineContent(u));return P===-1?0:P+2}n(u){switch(u){case R.EndOfLinePreference.LF:return`
`;case R.EndOfLinePreference.CRLF:return`\r
`;case R.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,P,w){let a=this.g,m=this.h,$=this.j,f=!0,i=[];for(let g=0;g<u.length;g++){const E=u[g];f&&E._isTracked&&(f=!1);const D=E.range;if(E.text){let v=!0;$||(v=!h.$Uf(E.text),$=v),!a&&v&&(a=h.$Tf(E.text)),!m&&v&&(m=h.$Wf(E.text))}let y="",k=0,A=0,b=0;if(E.text){let v;[k,A,b,v]=(0,T.$zu)(E.text);const F=this.getEOL(),N=F===`\r
`?T.StringEOL.CRLF:T.StringEOL.LF;v===T.StringEOL.Unknown||v===N?y=E.text:y=E.text.replace(/\r\n|\r|\n/g,F)}i[g]={sortIndex:g,identifier:E.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:y,eolCount:k,firstLineLength:A,lastLineLength:b,forceMoveMarkers:!!E.forceMoveMarkers,isAutoWhitespaceEdit:E.isAutoWhitespaceEdit||!1}}i.sort(I.u);let s=!1;for(let g=0,E=i.length-1;g<E;g++){const D=i[g].range.getEndPosition(),y=i[g+1].range.getStartPosition();if(y.isBeforeOrEqual(D)){if(y.isBefore(D))throw new Error("Overlapping ranges are not allowed!");s=!0}}f&&(i=this.s(i));const t=w||P?I._getInverseEditRanges(i):[],o=[];if(P)for(let g=0;g<i.length;g++){const E=i[g],D=t[g];if(E.isAutoWhitespaceEdit&&E.range.isEmpty())for(let y=D.startLineNumber;y<=D.endLineNumber;y++){let k="";y===D.startLineNumber&&(k=this.getLineContent(E.range.startLineNumber),h.$uf(k)!==-1)||o.push({lineNumber:y,oldContent:k})}}let n=null;if(w){let g=0;n=[];for(let E=0;E<i.length;E++){const D=i[E],y=t[E],k=this.getValueInRange(D.range),A=D.rangeOffset+g;g+=D.text.length-k.length,n[E]={sortIndex:D.sortIndex,identifier:D.identifier,range:y,text:k,textChange:new p.$fu(D.rangeOffset,k,A,D.text)}}s||n.sort((E,D)=>E.sortIndex-D.sortIndex)}this.g=a,this.h=m,this.j=$;const d=this.t(i);let l=null;if(P&&o.length>0){o.sort((g,E)=>E.lineNumber-g.lineNumber),l=[];for(let g=0,E=o.length;g<E;g++){const D=o[g].lineNumber;if(g>0&&o[g-1].lineNumber===D)continue;const y=o[g].oldContent,k=this.getLineContent(D);k.length===0||k===y||h.$uf(k)!==-1||l.push(D)}}return this.m.fire(),new R.$iw(n,d,l)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let P=!1;const w=u[0].range,a=u[u.length-1].range,m=new C.$Ot(w.startLineNumber,w.startColumn,a.endLineNumber,a.endColumn);let $=w.startLineNumber,f=w.startColumn;const i=[];for(let d=0,l=u.length;d<l;d++){const g=u[d],E=g.range;P=P||g.forceMoveMarkers,i.push(this.getValueInRange(new C.$Ot($,f,E.startLineNumber,E.startColumn))),g.text.length>0&&i.push(g.text),$=E.endLineNumber,f=E.endColumn}const s=i.join(""),[t,o,n]=(0,T.$zu)(s);return{sortIndex:0,identifier:u[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,R.EndOfLinePreference.TextDefined),text:s,eolCount:t,firstLineLength:o,lastLineLength:n,forceMoveMarkers:P,isAutoWhitespaceEdit:!1}}t(u){u.sort(I.w);const P=[];for(let w=0;w<u.length;w++){const a=u[w],m=a.range.startLineNumber,$=a.range.startColumn,f=a.range.endLineNumber,i=a.range.endColumn;if(m===f&&$===i&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const s=new C.$Ot(m,$,f,i);P.push({range:s,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return P}findMatchesLineByLine(u,P,w,a){return this.c.findMatchesLineByLine(u,P,w,a)}getPieceTree(){return this.c}static _getInverseEditRange(u,P){const w=u.startLineNumber,a=u.startColumn,[m,$,f]=(0,T.$zu)(P);let i;if(P.length>0){const s=m+1;s===1?i=new C.$Ot(w,a,w,a+$):i=new C.$Ot(w,a,w+s-1,f+1)}else i=new C.$Ot(w,a,w,a);return i}static _getInverseEditRanges(u){const P=[];let w=0,a=0,m=null;for(let $=0,f=u.length;$<f;$++){const i=u[$];let s,t;m?m.range.endLineNumber===i.range.startLineNumber?(s=w,t=a+(i.range.startColumn-m.range.endColumn)):(s=w+(i.range.startLineNumber-m.range.endLineNumber),t=i.range.startColumn):(s=i.range.startLineNumber,t=i.range.startColumn);let o;if(i.text.length>0){const n=i.eolCount+1;n===1?o=new C.$Ot(s,t,s,t+i.firstLineLength):o=new C.$Ot(s,t,s+n-1,i.lastLineLength+1)}else o=new C.$Ot(s,t,s,t);w=o.endLineNumber,a=o.endColumn,P.push(o),m=i}return P}static u(u,P){const w=C.$Ot.compareRangesUsingEnds(u.range,P.range);return w===0?u.sortIndex-P.sortIndex:w}static w(u,P){const w=C.$Ot.compareRangesUsingEnds(u.range,P.range);return w===0?P.sortIndex-u.sortIndex:-w}}e.$vD=I}),define(ke[208],Ie([1,0,26,12,58,141,207]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wD=void 0,h=qe(h);class T{constructor(I,S,u,P,w,a,m,$,f){this.a=I,this.b=S,this.c=u,this.d=P,this.e=w,this.f=a,this.g=m,this.h=$,this.j=f}k(I){const S=this.c+this.d+this.e,u=this.c+this.e;return S===0?I===C.DefaultEndOfLine.LF?`
`:`\r
`:u>S/2?`\r
`:`
`}create(I){const S=this.k(I),u=this.a;if(this.j&&(S===`\r
`&&(this.c>0||this.d>0)||S===`
`&&(this.c>0||this.e>0)))for(let w=0,a=u.length;w<a;w++){const m=u[w].buffer.replace(/\r\n|\r|\n/g,S),$=(0,R.$qD)(m);u[w]=new R.$tD(m,$)}const P=new O.$vD(u,this.b,S,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class p{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&h.$5f(I)&&(this.b=h.$4f,I=I.substr(1));const S=I.charCodeAt(I.length-1);S===r.CharCode.CarriageReturn||S>=55296&&S<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=S):(this.m(I,!1),this.c=!1,this.d=S)}m(I,S){!S&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const S=(0,R.$rD)(this.e,I);this.a.push(new R.$tD(I,S.lineStarts)),this.f+=S.cr,this.g+=S.lf,this.h+=S.crlf,S.isBasicASCII||(this.l=!1,this.j||(this.j=h.$Tf(I)),this.k||(this.k=h.$Wf(I)))}finish(I=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const S=(0,R.$qD)(I.buffer);I.lineStarts=S,this.d===r.CharCode.CarriageReturn&&this.f++}}}e.$wD=p}),define(ke[142],Ie([1,0,21,10]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdb=p,e.$Ydb=I,h=qe(h);var C;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(C||(C={}));function R(S){for(let u=0,P=S.length;u<P;u+=4){const w=S[u+0],a=S[u+1],m=S[u+2],$=S[u+3];S[u+0]=$,S[u+1]=m,S[u+2]=a,S[u+3]=w}}function O(S){const u=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return h.$E()||R(u),r.$Ne.wrap(u)}function T(S){const u=S.buffer;if(h.$E()||R(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const P=new Uint8Array(u.byteLength);return P.set(u),new Uint32Array(P.buffer,P.byteOffset,P.length/4)}}function p(S){const u=new Uint32Array(c(S));let P=0;if(u[P++]=S.id,S.type==="full")u[P++]=C.Full,u[P++]=S.data.length,u.set(S.data,P),P+=S.data.length;else{u[P++]=C.Delta,u[P++]=S.deltas.length;for(const w of S.deltas)u[P++]=w.start,u[P++]=w.deleteCount,w.data?(u[P++]=w.data.length,u.set(w.data,P),P+=w.data.length):u[P++]=0}return O(u)}function c(S){let u=0;if(u+=2,S.type==="full")u+=1+S.data.length;else{u+=1,u+=3*S.deltas.length;for(const P of S.deltas)P.data&&(u+=P.data.length)}return u}function I(S){const u=T(S);let P=0;const w=u[P++];if(u[P++]===C.Full){const f=u[P++],i=u.subarray(P,P+f);return P+=f,{id:w,type:"full",data:i}}const m=u[P++],$=[];for(let f=0;f<m;f++){const i=u[P++],s=u[P++],t=u[P++];let o;t>0&&(o=u.subarray(P,P+t),P+=t),$[f]={start:i,deleteCount:s,data:o}}return{id:w,type:"delta",deltas:$}}}),define(ke[209],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P_=e.$O_=void 0;class r{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const O=this.a.get(R);return this.a.delete(R),O}}addDragOperationTransfer(R,O){this.a.set(R,O)}}e.$O_=r;class h{constructor(R){this.identifier=R}}e.$P_=h}),define(ke[210],Ie([1,0,4,3,110]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yu=void 0;class R{constructor(){this.a=new Map,this.b=new Map,this.c=new r.$le,this.onDidChange=this.c.event,this.d=null}handleChange(p){this.c.fire({changedLanguages:p,changedColorMap:!1})}register(p,c){return this.a.set(p,c),this.handleChange([p]),(0,h.$Sc)(()=>{this.a.get(p)===c&&(this.a.delete(p),this.handleChange([p]))})}get(p){return this.a.get(p)||null}registerFactory(p,c){this.b.get(p)?.dispose();const I=new O(this,p,c);return this.b.set(p,I),(0,h.$Sc)(()=>{const S=this.b.get(p);!S||S!==I||(this.b.delete(p),S.dispose())})}async getOrCreate(p){const c=this.get(p);if(c)return c;const I=this.b.get(p);return!I||I.isResolved?null:(await I.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const I=this.b.get(p);return!!(!I||I.isResolved)}setColorMap(p){this.d=p,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>C.ColorId.DefaultBackground?this.d[C.ColorId.DefaultBackground]:null}}e.$yu=R;class O extends h.$Uc{get isResolved(){return this.c}constructor(p,c,I){super(),this.f=p,this.g=c,this.h=I,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const p=await this.h.tokenizationSupport;this.c=!0,p&&!this.a&&this.B(this.f.register(this.g,p))}}}),define(ke[8],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=C,e.localize2=O;const r=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function h(T,p){let c;return p.length===0?c=T:c=T.replace(/\{(\d+)\}/g,(I,S)=>{const u=S[0],P=p[u];let w=I;return typeof P=="string"?w=P:(typeof P=="number"||typeof P=="boolean"||P===void 0||P===null)&&(w=String(P)),w}),r&&(c="\uFF3B"+c.replace(/[aouei]/g,"$&$&")+"\uFF3D"),c}function C(T,p,...c){return h(typeof T=="number"?R(T,p):p,c)}function R(T,p){const c=globalThis._VSCODE_NLS_MESSAGES?.[T];if(typeof c!="string"){if(typeof p=="string")return p;throw new Error(`!!! NLS MISSING: ${T} !!!`)}return c}function O(T,p,...c){let I;typeof T=="number"?I=R(T,p):I=p;const S=h(I,c);return{value:S,original:p===I?S:h(p,c)}}}),define(ke[211],Ie([1,0,4,3,8]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=void 0,e.$pj=I,C=qe(C);class R extends h.$Uc{constructor(u,P="",w="",a=!0,m){super(),this.j=this.B(new r.$le),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=P,this.w=w,this.z=a,this.D=m}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,P){this.D&&await this.D(u)}}e.$kj=R;class O extends h.$Uc{constructor(){super(...arguments),this.f=this.B(new r.$le),this.onWillRun=this.f.event,this.m=this.B(new r.$le),this.onDidRun=this.m.event}async run(u,P){if(!u.enabled)return;this.f.fire({action:u});let w;try{await this.u(u,P)}catch(a){w=a}this.m.fire({action:u,error:w})}async u(u,P){await u.run(P)}}e.$lj=O;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let P=[];for(const w of u)w.length&&(P.length?P=[...P,new T,...w]:P=w);return P}static{this.ID="vs.actions.separator"}async run(){}}e.$mj=T;class p{get actions(){return this.a}constructor(u,P,w,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=P,this.class=a,this.a=w}async run(){}}e.$nj=p;class c extends R{static{this.ID="vs.actions.empty"}constructor(){super(c.ID,C.localize(13050,null),void 0,!1)}}e.$oj=c;function I(S){return{id:S.id,label:S.label,tooltip:S.tooltip??S.label,class:S.class,enabled:S.enabled??!0,checked:S.checked,run:async(...u)=>S.run(...u)}}}),define(ke[212],Ie([1,0,8]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=c,e.$3m=I,e.$4m=S;const h=60,C=h*60,R=C*24,O=R*7,T=R*30,p=R*365;function c(u,P,w,a){typeof u!="number"&&(u=u.getTime());const m=Math.round((new Date().getTime()-u)/1e3);if(m<-30)return(0,r.localize)(12987,null,c(new Date().getTime()+m*1e3,!1));if(!a&&m<30)return(0,r.localize)(12988,null);let $;return m<h?($=m,P?$===1?w?(0,r.localize)(12989,null,$):(0,r.localize)(12990,null,$):w?(0,r.localize)(12991,null,$):(0,r.localize)(12992,null,$):$===1?w?(0,r.localize)(12993,null,$):(0,r.localize)(12994,null,$):w?(0,r.localize)(12995,null,$):(0,r.localize)(12996,null,$)):m<C?($=Math.floor(m/h),P?$===1?w?(0,r.localize)(12997,null,$):(0,r.localize)(12998,null,$):w?(0,r.localize)(12999,null,$):(0,r.localize)(13e3,null,$):$===1?w?(0,r.localize)(13001,null,$):(0,r.localize)(13002,null,$):w?(0,r.localize)(13003,null,$):(0,r.localize)(13004,null,$)):m<R?($=Math.floor(m/C),P?$===1?w?(0,r.localize)(13005,null,$):(0,r.localize)(13006,null,$):w?(0,r.localize)(13007,null,$):(0,r.localize)(13008,null,$):$===1?w?(0,r.localize)(13009,null,$):(0,r.localize)(13010,null,$):w?(0,r.localize)(13011,null,$):(0,r.localize)(13012,null,$)):m<O?($=Math.floor(m/R),P?$===1?(0,r.localize)(13013,null,$):(0,r.localize)(13014,null,$):$===1?(0,r.localize)(13015,null,$):(0,r.localize)(13016,null,$)):m<T?($=Math.floor(m/O),P?$===1?w?(0,r.localize)(13017,null,$):(0,r.localize)(13018,null,$):w?(0,r.localize)(13019,null,$):(0,r.localize)(13020,null,$):$===1?w?(0,r.localize)(13021,null,$):(0,r.localize)(13022,null,$):w?(0,r.localize)(13023,null,$):(0,r.localize)(13024,null,$)):m<p?($=Math.floor(m/T),P?$===1?w?(0,r.localize)(13025,null,$):(0,r.localize)(13026,null,$):w?(0,r.localize)(13027,null,$):(0,r.localize)(13028,null,$):$===1?w?(0,r.localize)(13029,null,$):(0,r.localize)(13030,null,$):w?(0,r.localize)(13031,null,$):(0,r.localize)(13032,null,$)):($=Math.floor(m/p),P?$===1?w?(0,r.localize)(13033,null,$):(0,r.localize)(13034,null,$):w?(0,r.localize)(13035,null,$):(0,r.localize)(13036,null,$):$===1?w?(0,r.localize)(13037,null,$):(0,r.localize)(13038,null,$):w?(0,r.localize)(13039,null,$):(0,r.localize)(13040,null,$))}function I(u,P){const w=Math.abs(u/1e3);return w<1?P?(0,r.localize)(13041,null,u):(0,r.localize)(13042,null,u):w<h?P?(0,r.localize)(13043,null,Math.round(u)/1e3):(0,r.localize)(13044,null,Math.round(u)/1e3):w<C?P?(0,r.localize)(13045,null,Math.round(u/(1e3*h))):(0,r.localize)(13046,null,Math.round(u/(1e3*h))):w<R?P?(0,r.localize)(13047,null,Math.round(u/(1e3*C))):(0,r.localize)(13048,null,Math.round(u/(1e3*C))):(0,r.localize)(13049,null,Math.round(u/(1e3*R)))}function S(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[52],Ie([1,0,18,17,8]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=p,e.$rj=c,e.$sj=I,r=qe(r),h=qe(h),C=qe(C);function R(S,u){return u&&(S.stack||S.stacktrace)?C.localize(12981,null,T(S),O(S.stack)||O(S.stacktrace)):T(S)}function O(S){return Array.isArray(S)?S.join(`
`):S}function T(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?C.localize(12982,null,S.message):S.message||C.localize(12983,null)}function p(S=null,u=!1){if(!S)return C.localize(12984,null);if(Array.isArray(S)){const P=r.$Gb(S),w=p(P[0],u);return P.length>1?C.localize(12985,null,w,P.length):w}if(h.$eg(S))return S;if(S.detail){const P=S.detail;if(P.error)return R(P.error,u);if(P.exception)return R(P.exception,u)}return S.stack?R(S,u):S.message?S.message:C.localize(12986,null)}function c(S){const u=S;return u instanceof Error&&Array.isArray(u.actions)}function I(S,u){let P;return typeof S=="string"?P=new Error(S):P=S,P.actions=u,P}}),define(ke[87],Ie([1,0,82,2,195,30,210,8]),function($e,e,r,h,C,R,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Ru=e.$Qu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Pu=e.$Ou=e.SymbolKinds=e.SymbolTag=e.$Mu=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Ku=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Ju=e.$Iu=e.$Hu=void 0,e.$Lu=d,e.$Nu=g;class p{constructor(q,Q,_){this.offset=q,this.type=Q,this.language=_,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Hu=p;class c{constructor(q,Q){this.tokens=q,this.endState=Q,this._tokenizationResultBrand=void 0}}e.$Iu=c;class I{constructor(q,Q){this.tokens=q,this.endState=Q,this._encodedTokenizationResultBrand=void 0}}e.$Ju=I;var S;(function(H){H[H.Increase=0]="Increase",H[H.Decrease=1]="Decrease"})(S||(e.HoverVerbosityAction=S={}));var u;(function(H){H[H.Method=0]="Method",H[H.Function=1]="Function",H[H.Constructor=2]="Constructor",H[H.Field=3]="Field",H[H.Variable=4]="Variable",H[H.Class=5]="Class",H[H.Struct=6]="Struct",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Event=10]="Event",H[H.Operator=11]="Operator",H[H.Unit=12]="Unit",H[H.Value=13]="Value",H[H.Constant=14]="Constant",H[H.Enum=15]="Enum",H[H.EnumMember=16]="EnumMember",H[H.Keyword=17]="Keyword",H[H.Text=18]="Text",H[H.Color=19]="Color",H[H.File=20]="File",H[H.Reference=21]="Reference",H[H.Customcolor=22]="Customcolor",H[H.Folder=23]="Folder",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue",H[H.Snippet=27]="Snippet"})(u||(e.CompletionItemKind=u={}));var P;(function(H){const q=new Map;q.set(u.Method,r.$5j.symbolMethod),q.set(u.Function,r.$5j.symbolFunction),q.set(u.Constructor,r.$5j.symbolConstructor),q.set(u.Field,r.$5j.symbolField),q.set(u.Variable,r.$5j.symbolVariable),q.set(u.Class,r.$5j.symbolClass),q.set(u.Struct,r.$5j.symbolStruct),q.set(u.Interface,r.$5j.symbolInterface),q.set(u.Module,r.$5j.symbolModule),q.set(u.Property,r.$5j.symbolProperty),q.set(u.Event,r.$5j.symbolEvent),q.set(u.Operator,r.$5j.symbolOperator),q.set(u.Unit,r.$5j.symbolUnit),q.set(u.Value,r.$5j.symbolValue),q.set(u.Enum,r.$5j.symbolEnum),q.set(u.Constant,r.$5j.symbolConstant),q.set(u.Enum,r.$5j.symbolEnum),q.set(u.EnumMember,r.$5j.symbolEnumMember),q.set(u.Keyword,r.$5j.symbolKeyword),q.set(u.Snippet,r.$5j.symbolSnippet),q.set(u.Text,r.$5j.symbolText),q.set(u.Color,r.$5j.symbolColor),q.set(u.File,r.$5j.symbolFile),q.set(u.Reference,r.$5j.symbolReference),q.set(u.Customcolor,r.$5j.symbolCustomColor),q.set(u.Folder,r.$5j.symbolFolder),q.set(u.TypeParameter,r.$5j.symbolTypeParameter),q.set(u.User,r.$5j.account),q.set(u.Issue,r.$5j.issues);function Q(ne){let ye=q.get(ne);return ye||(console.info("No codicon found for CompletionItemKind "+ne),ye=r.$5j.symbolProperty),ye}H.toIcon=Q;const _=new Map;_.set("method",u.Method),_.set("function",u.Function),_.set("constructor",u.Constructor),_.set("field",u.Field),_.set("variable",u.Variable),_.set("class",u.Class),_.set("struct",u.Struct),_.set("interface",u.Interface),_.set("module",u.Module),_.set("property",u.Property),_.set("event",u.Event),_.set("operator",u.Operator),_.set("unit",u.Unit),_.set("value",u.Value),_.set("constant",u.Constant),_.set("enum",u.Enum),_.set("enum-member",u.EnumMember),_.set("enumMember",u.EnumMember),_.set("keyword",u.Keyword),_.set("snippet",u.Snippet),_.set("text",u.Text),_.set("color",u.Color),_.set("file",u.File),_.set("reference",u.Reference),_.set("customcolor",u.Customcolor),_.set("folder",u.Folder),_.set("type-parameter",u.TypeParameter),_.set("typeParameter",u.TypeParameter),_.set("account",u.User),_.set("issue",u.Issue);function ce(ne,ye){let ge=_.get(ne);return typeof ge>"u"&&!ye&&(ge=u.Property),ge}H.fromString=ce})(P||(e.CompletionItemKinds=P={}));var w;(function(H){H[H.Deprecated=1]="Deprecated"})(w||(e.CompletionItemTag=w={}));var a;(function(H){H[H.None=0]="None",H[H.KeepWhitespace=1]="KeepWhitespace",H[H.InsertAsSnippet=4]="InsertAsSnippet"})(a||(e.CompletionItemInsertTextRule=a={}));var m;(function(H){H[H.Word=0]="Word",H[H.Line=1]="Line",H[H.Suggest=2]="Suggest"})(m||(e.PartialAcceptTriggerKind=m={}));var $;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})($||(e.CompletionTriggerKind=$={}));var f;(function(H){H[H.Automatic=0]="Automatic",H[H.Explicit=1]="Explicit"})(f||(e.InlineCompletionTriggerKind=f={}));class i{constructor(q,Q,_,ce){this.range=q,this.text=Q,this.completionKind=_,this.isSnippetText=ce}equals(q){return R.$Ot.lift(this.range).equalsRange(q.range)&&this.text===q.text&&this.completionKind===q.completionKind&&this.isSnippetText===q.isSnippetText}}e.$Ku=i;var s;(function(H){H[H.Invoke=1]="Invoke",H[H.Auto=2]="Auto"})(s||(e.CodeActionTriggerType=s={}));var t;(function(H){H[H.Automatic=0]="Automatic",H[H.PasteAs=1]="PasteAs"})(t||(e.DocumentPasteTriggerKind=t={}));var o;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(o||(e.SignatureHelpTriggerKind=o={}));var n;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function d(H){return H&&h.URI.isUri(H.uri)&&R.$Ot.isIRange(H.range)&&(R.$Ot.isIRange(H.originSelectionRange)||R.$Ot.isIRange(H.targetSelectionRange))}var l;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(l||(e.SymbolKind=l={})),e.$Mu={[l.Array]:(0,T.localize)(12848,null),[l.Boolean]:(0,T.localize)(12849,null),[l.Class]:(0,T.localize)(12850,null),[l.Constant]:(0,T.localize)(12851,null),[l.Constructor]:(0,T.localize)(12852,null),[l.Enum]:(0,T.localize)(12853,null),[l.EnumMember]:(0,T.localize)(12854,null),[l.Event]:(0,T.localize)(12855,null),[l.Field]:(0,T.localize)(12856,null),[l.File]:(0,T.localize)(12857,null),[l.Function]:(0,T.localize)(12858,null),[l.Interface]:(0,T.localize)(12859,null),[l.Key]:(0,T.localize)(12860,null),[l.Method]:(0,T.localize)(12861,null),[l.Module]:(0,T.localize)(12862,null),[l.Namespace]:(0,T.localize)(12863,null),[l.Null]:(0,T.localize)(12864,null),[l.Number]:(0,T.localize)(12865,null),[l.Object]:(0,T.localize)(12866,null),[l.Operator]:(0,T.localize)(12867,null),[l.Package]:(0,T.localize)(12868,null),[l.Property]:(0,T.localize)(12869,null),[l.String]:(0,T.localize)(12870,null),[l.Struct]:(0,T.localize)(12871,null),[l.TypeParameter]:(0,T.localize)(12872,null),[l.Variable]:(0,T.localize)(12873,null)};function g(H,q){return(0,T.localize)(12874,null,H,e.$Mu[q])}var E;(function(H){H[H.Deprecated=1]="Deprecated"})(E||(e.SymbolTag=E={}));var D;(function(H){const q=new Map;q.set(l.File,r.$5j.symbolFile),q.set(l.Module,r.$5j.symbolModule),q.set(l.Namespace,r.$5j.symbolNamespace),q.set(l.Package,r.$5j.symbolPackage),q.set(l.Class,r.$5j.symbolClass),q.set(l.Method,r.$5j.symbolMethod),q.set(l.Property,r.$5j.symbolProperty),q.set(l.Field,r.$5j.symbolField),q.set(l.Constructor,r.$5j.symbolConstructor),q.set(l.Enum,r.$5j.symbolEnum),q.set(l.Interface,r.$5j.symbolInterface),q.set(l.Function,r.$5j.symbolFunction),q.set(l.Variable,r.$5j.symbolVariable),q.set(l.Constant,r.$5j.symbolConstant),q.set(l.String,r.$5j.symbolString),q.set(l.Number,r.$5j.symbolNumber),q.set(l.Boolean,r.$5j.symbolBoolean),q.set(l.Array,r.$5j.symbolArray),q.set(l.Object,r.$5j.symbolObject),q.set(l.Key,r.$5j.symbolKey),q.set(l.Null,r.$5j.symbolNull),q.set(l.EnumMember,r.$5j.symbolEnumMember),q.set(l.Struct,r.$5j.symbolStruct),q.set(l.Event,r.$5j.symbolEvent),q.set(l.Operator,r.$5j.symbolOperator),q.set(l.TypeParameter,r.$5j.symbolTypeParameter);function Q(_){let ce=q.get(_);return ce||(console.info("No codicon found for SymbolKind "+_),ce=r.$5j.symbolProperty),ce}H.toIcon=Q})(D||(e.SymbolKinds=D={}));class y{static asEditOperation(q){return C.$Pt.replace(R.$Ot.lift(q.range),q.text)}}e.$Ou=y;class k{static{this.Comment=new k("comment")}static{this.Imports=new k("imports")}static{this.Region=new k("region")}static fromValue(q){switch(q){case"comment":return k.Comment;case"imports":return k.Imports;case"region":return k.Region}return new k(q)}constructor(q){this.value=q}}e.$Pu=k;var A;(function(H){H[H.AIGenerated=1]="AIGenerated"})(A||(e.NewSymbolNameTag=A={}));var b;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(b||(e.NewSymbolNameTriggerKind=b={}));var v;(function(H){function q(Q){return!Q||typeof Q!="object"?!1:typeof Q.id=="string"&&typeof Q.title=="string"}H.is=q})(v||(e.Command=v={}));var F;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(F||(e.CommentThreadCollapsibleState=F={}));var N;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(N||(e.CommentThreadState=N={}));var L;(function(H){H[H.Current=0]="Current",H[H.Outdated=1]="Outdated"})(L||(e.CommentThreadApplicability=L={}));var M;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(M||(e.CommentMode=M={}));var z;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(z||(e.CommentState=z={}));var j;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(j||(e.InlayHintKind=j={}));class W{constructor(q){this.b=q,this.a=null}dispose(){this.a&&this.a.then(q=>{q&&q.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Qu=W,e.$Ru=new O.$yu;var B;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(B||(e.ExternalUriOpenerPriority=B={}));var ee;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(ee||(e.InlineEditTriggerKind=ee={}))}),define(ke[213],Ie([1,0,26,13,8]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.TokenType=void 0;var R;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(R||(e.TokenType=R={}));function O(...I){switch(I.length){case 1:return(0,C.localize)(11585,null,I[0]);case 2:return(0,C.localize)(11586,null,I[0],I[1]);case 3:return(0,C.localize)(11587,null,I[0],I[1],I[2]);default:return}}const T=(0,C.localize)(11588,null),p=(0,C.localize)(11589,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(S){switch(S.type){case R.LParen:return"(";case R.RParen:return")";case R.Neg:return"!";case R.Eq:return S.isTripleEq?"===":"==";case R.NotEq:return S.isTripleEq?"!==":"!=";case R.Lt:return"<";case R.LtEq:return"<=";case R.Gt:return">=";case R.GtEq:return">=";case R.RegexOp:return"=~";case R.RegexStr:return S.lexeme;case R.True:return"true";case R.False:return"false";case R.In:return"in";case R.Not:return"not";case R.And:return"&&";case R.Or:return"||";case R.Str:return S.lexeme;case R.QuotedStr:return S.lexeme;case R.Error:return S.lexeme;case R.EOF:return"EOF";default:throw(0,h.$7)(`unhandled token type: ${JSON.stringify(S)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(S=>S.charCodeAt(0)))}static{this.b=new Map([["not",R.Not],["in",R.In],["false",R.False],["true",R.True]])}get errors(){return this.g}reset(S){return this.c=S,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case r.CharCode.OpenParen:this.k(R.LParen);break;case r.CharCode.CloseParen:this.k(R.RParen);break;case r.CharCode.ExclamationMark:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:R.NotEq,offset:this.d,isTripleEq:u})}else this.k(R.Neg);break;case r.CharCode.SingleQuote:this.o();break;case r.CharCode.Slash:this.q();break;case r.CharCode.Equals:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:R.Eq,offset:this.d,isTripleEq:u})}else this.h(r.CharCode.Tilde)?this.k(R.RegexOp):this.l(O("==","=~"));break;case r.CharCode.LessThan:this.k(this.h(r.CharCode.Equals)?R.LtEq:R.Lt);break;case r.CharCode.GreaterThan:this.k(this.h(r.CharCode.Equals)?R.GtEq:R.Gt);break;case r.CharCode.Ampersand:this.h(r.CharCode.Ampersand)?this.k(R.And):this.l(O("&&"));break;case r.CharCode.Pipe:this.h(r.CharCode.Pipe)?this.k(R.Or):this.l(O("||"));break;case r.CharCode.Space:case r.CharCode.CarriageReturn:case r.CharCode.Tab:case r.CharCode.LineFeed:case r.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(R.EOF),Array.from(this.f)}h(S){return this.r()||this.c.charCodeAt(this.e)!==S?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?r.CharCode.Null:this.c.charCodeAt(this.e)}k(S){this.f.push({type:S,offset:this.d})}l(S){const u=this.d,P=this.c.substring(this.d,this.e),w={type:R.Error,offset:this.d,lexeme:P};this.g.push({offset:u,lexeme:P,additionalInfo:S}),this.f.push(w)}n(){this.m.lastIndex=this.d;const S=this.m.exec(this.c);if(S){this.e=this.d+S[0].length;const u=this.c.substring(this.d,this.e),P=c.b.get(u);P?this.k(P):this.f.push({type:R.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==r.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:R.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let S=this.e,u=!1,P=!1;for(;;){if(S>=this.c.length){this.e=S,this.l(p);return}const a=this.c.charCodeAt(S);if(u)u=!1;else if(a===r.CharCode.Slash&&!P){S++;break}else a===r.CharCode.OpenSquareBracket?P=!0:a===r.CharCode.Backslash?u=!0:a===r.CharCode.CloseSquareBracket&&(P=!1);S++}for(;S<this.c.length&&c.a.has(this.c.charCodeAt(S));)S++;this.e=S;const w=this.c.substring(this.d,this.e);this.f.push({type:R.RegexStr,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$Aj=c}),define(ke[143],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const r={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(r)}),define(ke[112],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class r{constructor(C,R=[],O=!1){this.ctor=C,this.staticArguments=R,this.supportsDelayedInstantiation=O}}e.$Ci=r}),define(ke[88],Ie([1,0,112]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Rs=R,e.$Ss=O;const h=[];var C;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function R(T,p,c){p instanceof r.$Ci||(p=new r.$Ci(p,[],!!c)),h.push([T,p])}function O(){return h}}),define(ke[214],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=void 0;class r{constructor(R,O){this.key=R,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$ur=r;class h{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const O of this.a.values())O.outgoing.size===0&&R.push(O);return R}insertEdge(R,O){const T=this.lookupOrInsertNode(R),p=this.lookupOrInsertNode(O);T.outgoing.set(p.key,p),p.incoming.set(T.key,T)}removeNode(R){const O=this.b(R);this.a.delete(O);for(const T of this.a.values())T.outgoing.delete(O),T.incoming.delete(O)}lookupOrInsertNode(R){const O=this.b(R);let T=this.a.get(O);return T||(T=new r(O,R),this.a.set(O,T)),T}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[O,T]of this.a)R.push(`${O}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,O]of this.a){const T=new Set([R]),p=this.c(O,T);if(p)return p}}c(R,O){for(const[T,p]of R.outgoing){if(O.has(T))return[...O,T].join(" -> ");O.add(T);const c=this.c(p,O);if(c)return c;O.delete(T)}}}e.$vr=h}),define(ke[5],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=C,e.$Gi=R;var r;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function T(p){return p[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=T})(r||(e._util=r={})),e.$Ei=C("instantiationService");function h(O,T,p){T[r.DI_TARGET]===T?T[r.DI_DEPENDENCIES].push({id:O,index:p}):(T[r.DI_DEPENDENCIES]=[{id:O,index:p}],T[r.DI_TARGET]=T)}function C(O){if(r.serviceIds.has(O))return r.serviceIds.get(O);const T=function(p,c,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");h(T,p,I)};return T.toString=()=>O,r.serviceIds.set(O,T),T}function R(O){return O}}),define(ke[46],Ie([1,0,17,2,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$_i=void 0,e.$aj=R,e.$bj=O,e.$cj=p,e.$dj=c,e.$ej=I,e.$fj=S,e.$gj=u,e.$hj=w,e.$ij=a,e.$jj=m,r=qe(r),e.$_i=(0,C.$Fi)("configurationService");function R($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof h.URI)}function O($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof h.URI)}var T;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function p($){switch($){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function c($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}function I($,f){const i=Object.create(null);for(const s in $)S(i,s,$[s],f);return i}function S($,f,i,s){const t=f.split("."),o=t.pop();let n=$;for(let d=0;d<t.length;d++){const l=t[d];let g=n[l];switch(typeof g){case"undefined":g=n[l]=Object.create(null);break;case"object":if(g===null){s(`Ignoring ${f} as ${t.slice(0,d+1).join(".")} is null`);return}break;default:s(`Ignoring ${f} as ${t.slice(0,d+1).join(".")} is ${JSON.stringify(g)}`);return}n=g}if(typeof n=="object"&&n!==null)try{n[o]=i}catch{s(`Ignoring ${f} as ${t.join(".")} is ${JSON.stringify(n)}`)}else s(`Ignoring ${f} as ${t.join(".")} is ${JSON.stringify(n)}`)}function u($,f){const i=f.split(".");P($,i)}function P($,f){const i=f.shift();if(f.length===0){delete $[i];return}if(Object.keys($).indexOf(i)!==-1){const s=$[i];typeof s=="object"&&!Array.isArray(s)&&(P(s,f),Object.keys(s).length===0&&delete $[i])}}function w($,f,i){function s(n,d){let l=n;for(const g of d){if(typeof l!="object"||l===null)return;l=l[g]}return l}const t=f.split("."),o=s($,t);return typeof o>"u"?i:o}function a($,f,i){Object.keys(f).forEach(s=>{s!=="__proto__"&&(s in $?r.$gg($[s])&&r.$gg(f[s])?a($[s],f[s],i):i&&($[s]=f[s]):$[s]=f[s])})}function m($){return $.replace(/[\[\]]/g,"")}}),define(ke[35],Ie([1,0,26,10,12,213,5,8,13]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Dj=e.$Cj=e.ContextKeyExprType=void 0,e.$Bj=I,e.$Ej=d,e.$Fj=l,e.$Yj=ne;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",h.$k),c.set("isLinux",h.$l),c.set("isWindows",h.$j),c.set("isWeb",h.$p),c.set("isMacNative",h.$k&&!h.$p),c.set("isEdge",h.$I),c.set("isFirefox",h.$G),c.set("isChrome",h.$F),c.set("isSafari",h.$H);function I(Y,U){if(c.get(Y)!==void 0)throw(0,p.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(Y,U)}const S=Object.prototype.hasOwnProperty;var u;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const P={regexParsingWithErrorRecovery:!0},w=(0,T.localize)(11599,null),a=(0,T.localize)(11600,null),m=(0,T.localize)(11601,null),$=(0,T.localize)(11602,null),f=(0,T.localize)(11603,null),i=(0,T.localize)(11604,null),s=(0,T.localize)(11605,null),t=(0,T.localize)(11606,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=P){this.k=U,this.d=new R.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:a});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const oe=this.l();if(!this.E()){const ve=this.D(),te=ve.type===R.TokenType.Str?i:void 0;throw this.h.push({message:f,offset:ve.offset,lexeme:R.$Aj.getLexeme(ve),additionalInfo:te}),o.c}return oe}catch(oe){if(oe!==o.c)throw oe;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(R.TokenType.Or);){const oe=this.o();U.push(oe)}return U.length===1?U[0]:n.or(...U)}o(){const U=[this.s()];for(;this.y(R.TokenType.And);){const oe=this.s();U.push(oe)}return U.length===1?U[0]:n.and(...U)}s(){if(this.y(R.TokenType.Neg)){const U=this.D();switch(U.type){case R.TokenType.True:return this.z(),E.INSTANCE;case R.TokenType.False:return this.z(),D.INSTANCE;case R.TokenType.LParen:{this.z();const oe=this.l();return this.A(R.TokenType.RParen,$),oe?.negate()}case R.TokenType.Str:return this.z(),F.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case R.TokenType.True:return this.z(),n.true();case R.TokenType.False:return this.z(),n.false();case R.TokenType.LParen:{this.z();const oe=this.l();return this.A(R.TokenType.RParen,$),oe}case R.TokenType.Str:{const oe=U.lexeme;if(this.z(),this.y(R.TokenType.RegexOp)){const te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),te.type!==R.TokenType.RegexStr)throw this.B("REGEX",te);const ae=te.lexeme,se=ae.lastIndexOf("/"),X=se===ae.length-1?void 0:this.w(ae.substring(se+1));let re;try{re=new RegExp(ae.substring(1,se),X)}catch{throw this.B("REGEX",te)}return W.create(oe,re)}switch(te.type){case R.TokenType.RegexStr:case R.TokenType.Error:{const ae=[te.lexeme];this.z();let se=this.D(),X=0;for(let Be=0;Be<te.lexeme.length;Be++)te.lexeme.charCodeAt(Be)===r.CharCode.OpenParen?X++:te.lexeme.charCodeAt(Be)===r.CharCode.CloseParen&&X--;for(;!this.E()&&se.type!==R.TokenType.And&&se.type!==R.TokenType.Or;){switch(se.type){case R.TokenType.LParen:X++;break;case R.TokenType.RParen:X--;break;case R.TokenType.RegexStr:case R.TokenType.QuotedStr:for(let Be=0;Be<se.lexeme.length;Be++)se.lexeme.charCodeAt(Be)===r.CharCode.OpenParen?X++:te.lexeme.charCodeAt(Be)===r.CharCode.CloseParen&&X--}if(X<0)break;ae.push(R.$Aj.getLexeme(se)),this.z(),se=this.D()}const re=ae.join(""),pe=re.lastIndexOf("/"),we=pe===re.length-1?void 0:this.w(re.substring(pe+1));let Fe;try{Fe=new RegExp(re.substring(1,pe),we)}catch{throw this.B("REGEX",te)}return n.regex(oe,Fe)}case R.TokenType.QuotedStr:{const ae=te.lexeme;this.z();let se=null;if(!(0,C.$cf)(ae)){const X=ae.indexOf("/"),re=ae.lastIndexOf("/");if(X!==re&&X>=0){const pe=ae.slice(X+1,re),we=ae[re+1]==="i"?"i":"";try{se=new RegExp(pe,we)}catch{throw this.B("REGEX",te)}}}if(se===null)throw this.B("REGEX",te);return W.create(oe,se)}default:throw this.B("REGEX",this.D())}}if(this.y(R.TokenType.Not)){this.A(R.TokenType.In,m);const te=this.u();return n.notIn(oe,te)}switch(this.D().type){case R.TokenType.Eq:{this.z();const te=this.u();if(this.x().type===R.TokenType.QuotedStr)return n.equals(oe,te);switch(te){case"true":return n.has(oe);case"false":return n.not(oe);default:return n.equals(oe,te)}}case R.TokenType.NotEq:{this.z();const te=this.u();if(this.x().type===R.TokenType.QuotedStr)return n.notEquals(oe,te);switch(te){case"true":return n.not(oe);case"false":return n.has(oe);default:return n.notEquals(oe,te)}}case R.TokenType.Lt:return this.z(),z.create(oe,this.u());case R.TokenType.LtEq:return this.z(),j.create(oe,this.u());case R.TokenType.Gt:return this.z(),L.create(oe,this.u());case R.TokenType.GtEq:return this.z(),M.create(oe,this.u());case R.TokenType.In:return this.z(),n.in(oe,this.u());default:return n.has(oe)}}case R.TokenType.EOF:throw this.h.push({message:s,offset:U.offset,lexeme:"",additionalInfo:t}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case R.TokenType.Str:case R.TokenType.QuotedStr:return this.z(),U.lexeme;case R.TokenType.True:return this.z(),"true";case R.TokenType.False:return this.z(),"false";case R.TokenType.In:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,oe){if(this.C(U))return this.z();throw this.B(oe,this.D())}B(U,oe,ve){const te=(0,T.localize)(11607,null,U,R.$Aj.getLexeme(oe)),ae=oe.offset,se=R.$Aj.getLexeme(oe);return this.h.push({message:te,offset:ae,lexeme:se,additionalInfo:ve}),o.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===R.TokenType.EOF}}e.$Cj=o;class n{static false(){return E.INSTANCE}static true(){return D.INSTANCE}static has(U){return y.create(U)}static equals(U,oe){return k.create(U,oe)}static notEquals(U,oe){return v.create(U,oe)}static regex(U,oe){return W.create(U,oe)}static in(U,oe){return A.create(U,oe)}static notIn(U,oe){return b.create(U,oe)}static not(U){return F.create(U)}static and(...U){return H.create(U,null,!0)}static or(...U){return q.create(U,null,!0)}static greater(U,oe){return L.create(U,oe)}static greaterEquals(U,oe){return M.create(U,oe)}static smaller(U,oe){return z.create(U,oe)}static smallerEquals(U,oe){return j.create(U,oe)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Dj=n;function d(Y){const U=new o({regexParsingWithErrorRecovery:!1});return Y.map(oe=>(U.parse(oe),U.lexingErrors.length>0?U.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,T.localize)(11608,null,ve.additionalInfo):(0,T.localize)(11609,null),offset:ve.offset,length:ve.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function l(Y,U){const oe=Y?Y.substituteConstants():void 0,ve=U?U.substituteConstants():void 0;return!oe&&!ve?!0:!oe||!ve?!1:oe.equals(ve)}function g(Y,U){return Y.cmp(U)}class E{static{this.INSTANCE=new E}constructor(){this.type=u.False}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return D.INSTANCE}}e.$Gj=E;class D{static{this.INSTANCE=new D}constructor(){this.type=u.True}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return E.INSTANCE}}e.$Hj=D;class y{static create(U,oe=null){const ve=c.get(U);return typeof ve=="boolean"?ve?D.INSTANCE:E.INSTANCE:new y(U,oe)}constructor(U,oe){this.key=U,this.c=oe,this.type=u.Defined}cmp(U){return U.type!==this.type?this.type-U.type:_(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=c.get(this.key);return typeof U=="boolean"?U?D.INSTANCE:E.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Ij=y;class k{static create(U,oe,ve=null){if(typeof oe=="boolean")return oe?y.create(U,ve):F.create(U,ve);const te=c.get(U);return typeof te=="boolean"?oe===(te?"true":"false")?D.INSTANCE:E.INSTANCE:new k(U,oe,ve)}constructor(U,oe,ve){this.c=U,this.d=oe,this.f=ve,this.type=u.Equals}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=c.get(this.c);if(typeof U=="boolean"){const oe=U?"true":"false";return this.d===oe?D.INSTANCE:E.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Jj=k;class A{static create(U,oe){return new A(U,oe)}constructor(U,oe){this.d=U,this.f=oe,this.type=u.In,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const oe=U.getValue(this.f),ve=U.getValue(this.d);return Array.isArray(oe)?oe.includes(ve):typeof ve=="string"&&typeof oe=="object"&&oe!==null?S.call(oe,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.$Kj=A;class b{static create(U,oe){return new b(U,oe)}constructor(U,oe){this.d=U,this.f=oe,this.type=u.NotIn,this.c=A.create(U,oe)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Lj=b;class v{static create(U,oe,ve=null){if(typeof oe=="boolean")return oe?F.create(U,ve):y.create(U,ve);const te=c.get(U);return typeof te=="boolean"?oe===(te?"true":"false")?E.INSTANCE:D.INSTANCE:new v(U,oe,ve)}constructor(U,oe,ve){this.c=U,this.d=oe,this.f=ve,this.type=u.NotEquals}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=c.get(this.c);if(typeof U=="boolean"){const oe=U?"true":"false";return this.d===oe?E.INSTANCE:D.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Mj=v;class F{static create(U,oe=null){const ve=c.get(U);return typeof ve=="boolean"?ve?E.INSTANCE:D.INSTANCE:new F(U,oe)}constructor(U,oe){this.c=U,this.d=oe,this.type=u.Not}cmp(U){return U.type!==this.type?this.type-U.type:_(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=c.get(this.c);return typeof U=="boolean"?U?E.INSTANCE:D.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Nj=F;function N(Y,U){if(typeof Y=="string"){const oe=parseFloat(Y);isNaN(oe)||(Y=oe)}return typeof Y=="string"||typeof Y=="number"?U(Y):E.INSTANCE}class L{static create(U,oe,ve=null){return N(oe,te=>new L(U,te,ve))}constructor(U,oe,ve){this.c=U,this.d=oe,this.f=ve,this.type=u.Greater}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Oj=L;class M{static create(U,oe,ve=null){return N(oe,te=>new M(U,te,ve))}constructor(U,oe,ve){this.c=U,this.d=oe,this.f=ve,this.type=u.GreaterEquals}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Pj=M;class z{static create(U,oe,ve=null){return N(oe,te=>new z(U,te,ve))}constructor(U,oe,ve){this.c=U,this.d=oe,this.f=ve,this.type=u.Smaller}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Qj=z;class j{static create(U,oe,ve=null){return N(oe,te=>new j(U,te,ve))}constructor(U,oe,ve){this.c=U,this.d=oe,this.f=ve,this.type=u.SmallerEquals}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Rj=j;class W{static create(U,oe){return new W(U,oe)}constructor(U,oe){this.d=U,this.f=oe,this.type=u.Regex,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const oe=this.f?this.f.source:"",ve=U.f?U.f.source:"";return oe<ve?-1:oe>ve?1:0}equals(U){if(U.type===this.type){const oe=this.f?this.f.source:"",ve=U.f?U.f.source:"";return this.d===U.d&&oe===ve}return!1}substituteConstants(){return this}evaluate(U){const oe=U.getValue(this.d);return this.f?this.f.test(oe):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$Sj=W;class B{static create(U){return new B(U)}constructor(U){this.c=U,this.type=u.NotRegex}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new B(this.c.map(U))}negate(){return this.c}}e.$Tj=B;function ee(Y){let U=null;for(let oe=0,ve=Y.length;oe<ve;oe++){const te=Y[oe].substituteConstants();if(Y[oe]!==te&&U===null){U=[];for(let ae=0;ae<oe;ae++)U[ae]=Y[ae]}U!==null&&(U[oe]=te)}return U===null?Y:U}class H{static create(U,oe,ve){return H.d(U,oe,ve)}constructor(U,oe){this.expr=U,this.c=oe,this.type=u.And}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let oe=0,ve=this.expr.length;oe<ve;oe++){const te=g(this.expr[oe],U.expr[oe]);if(te!==0)return te}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let oe=0,ve=this.expr.length;oe<ve;oe++)if(!this.expr[oe].equals(U.expr[oe]))return!1;return!0}return!1}substituteConstants(){const U=ee(this.expr);return U===this.expr?this:H.create(U,this.c,!1)}evaluate(U){for(let oe=0,ve=this.expr.length;oe<ve;oe++)if(!this.expr[oe].evaluate(U))return!1;return!0}static d(U,oe,ve){const te=[];let ae=!1;for(const se of U)if(se){if(se.type===u.True){ae=!0;continue}if(se.type===u.False)return E.INSTANCE;if(se.type===u.And){te.push(...se.expr);continue}te.push(se)}if(te.length===0&&ae)return D.INSTANCE;if(te.length!==0){if(te.length===1)return te[0];te.sort(g);for(let se=1;se<te.length;se++)te[se-1].equals(te[se])&&(te.splice(se,1),se--);if(te.length===1)return te[0];for(;te.length>1;){const se=te[te.length-1];if(se.type!==u.Or)break;te.pop();const X=te.pop(),re=te.length===0,pe=q.create(se.expr.map(we=>H.create([we,X],null,ve)),null,re);pe&&(te.push(pe),te.sort(g))}if(te.length===1)return te[0];if(ve){for(let se=0;se<te.length;se++)for(let X=se+1;X<te.length;X++)if(te[se].negate().equals(te[X]))return E.INSTANCE;if(te.length===1)return te[0]}return new H(te,oe)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const oe of this.expr)U.push(...oe.keys());return U}map(U){return new H(this.expr.map(oe=>oe.map(U)),null)}negate(){if(!this.c){const U=[];for(const oe of this.expr)U.push(oe.negate());this.c=q.create(U,this,!0)}return this.c}}e.$Uj=H;class q{static create(U,oe,ve){return q.d(U,oe,ve)}constructor(U,oe){this.expr=U,this.c=oe,this.type=u.Or}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let oe=0,ve=this.expr.length;oe<ve;oe++){const te=g(this.expr[oe],U.expr[oe]);if(te!==0)return te}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let oe=0,ve=this.expr.length;oe<ve;oe++)if(!this.expr[oe].equals(U.expr[oe]))return!1;return!0}return!1}substituteConstants(){const U=ee(this.expr);return U===this.expr?this:q.create(U,this.c,!1)}evaluate(U){for(let oe=0,ve=this.expr.length;oe<ve;oe++)if(this.expr[oe].evaluate(U))return!0;return!1}static d(U,oe,ve){let te=[],ae=!1;if(U){for(let se=0,X=U.length;se<X;se++){const re=U[se];if(re){if(re.type===u.False){ae=!0;continue}if(re.type===u.True)return D.INSTANCE;if(re.type===u.Or){te=te.concat(re.expr);continue}te.push(re)}}if(te.length===0&&ae)return E.INSTANCE;te.sort(g)}if(te.length!==0){if(te.length===1)return te[0];for(let se=1;se<te.length;se++)te[se-1].equals(te[se])&&(te.splice(se,1),se--);if(te.length===1)return te[0];if(ve){for(let se=0;se<te.length;se++)for(let X=se+1;X<te.length;X++)if(te[se].negate().equals(te[X]))return D.INSTANCE;if(te.length===1)return te[0]}return new q(te,oe)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const oe of this.expr)U.push(...oe.keys());return U}map(U){return new q(this.expr.map(oe=>oe.map(U)),null)}negate(){if(!this.c){const U=[];for(const oe of this.expr)U.push(oe.negate());for(;U.length>1;){const oe=U.shift(),ve=U.shift(),te=[];for(const ae of ge(oe))for(const se of ge(ve))te.push(H.create([ae,se],null,!1));U.unshift(q.create(te,null,!1))}this.c=q.create(U,this,!0)}return this.c}}e.$Vj=q;class Q extends y{static{this.d=[]}static all(){return Q.d.values()}constructor(U,oe,ve){super(U,null),this.f=oe,typeof ve=="object"?Q.d.push({...ve,key:U}):ve!==!0&&Q.d.push({key:U,description:ve,type:oe!=null?typeof oe:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return k.create(this.key,U)}notEqualsTo(U){return v.create(this.key,U)}}e.$Wj=Q,e.$Xj=(0,O.$Fi)("contextKeyService");function _(Y,U){return Y<U?-1:Y>U?1:0}function ce(Y,U,oe,ve){return Y<oe?-1:Y>oe?1:U<ve?-1:U>ve?1:0}function ne(Y,U){if(Y.type===u.False||U.type===u.True)return!0;if(Y.type===u.Or)return U.type===u.Or?ye(Y.expr,U.expr):!1;if(U.type===u.Or){for(const oe of U.expr)if(ne(Y,oe))return!0;return!1}if(Y.type===u.And){if(U.type===u.And)return ye(U.expr,Y.expr);for(const oe of Y.expr)if(ne(oe,U))return!0;return!1}return Y.equals(U)}function ye(Y,U){let oe=0,ve=0;for(;oe<Y.length&&ve<U.length;){const te=Y[oe].cmp(U[ve]);if(te<0)return!1;te===0&&oe++,ve++}return oe===Y.length}function ge(Y){return Y.type===u.Or?Y.expr:[Y]}}),define(ke[215],Ie([1,0,35,5]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=e.$st=e.AccessibilitySupport=e.$rt=void 0,e.$tt=R,e.$rt=(0,h.$Fi)("accessibilityService");var C;(function(O){O[O.Unknown=0]="Unknown",O[O.Disabled=1]="Disabled",O[O.Enabled=2]="Enabled"})(C||(e.AccessibilitySupport=C={})),e.$st=new r.$Wj("accessibilityModeEnabled",!1);function R(O){return O&&typeof O=="object"&&typeof O.label=="string"&&(typeof O.role>"u"||typeof O.role=="string")}e.$ut="ACCESSIBLE_VIEW_SHOWN_"}),define(ke[113],Ie([1,0,18,24,10,185,83,199,140,8,215]),function($e,e,r,h,C,R,O,T,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=n,e.stringSet=g,e.cursorStyleToString=N,e.filterValidationDecorations=De,r=qe(r),h=qe(h),C=qe(C),c=qe(c);var S;(function(ue){ue[ue.None=0]="None",ue[ue.Keep=1]="Keep",ue[ue.Brackets=2]="Brackets",ue[ue.Advanced=3]="Advanced",ue[ue.Full=4]="Full"})(S||(e.EditorAutoIndentStrategy=S={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(he){this.c=he}hasChanged(he){return this.c[he]}}e.ConfigurationChangedEvent=u;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class w{constructor(he,le,Xe,tt){this.id=he,this.name=le,this.defaultValue=Xe,this.schema=tt}applyUpdate(he,le){return m(he,le)}compute(he,le,Xe){return Xe}}class a{constructor(he,le){this.newValue=he,this.didChange=le}}e.ApplyUpdateResult=a;function m(ue,he){if(typeof ue!="object"||typeof he!="object"||!ue||!he)return new a(he,ue!==he);if(Array.isArray(ue)||Array.isArray(he)){const Xe=Array.isArray(ue)&&Array.isArray(he)&&r.$tb(ue,he);return new a(he,!Xe)}let le=!1;for(const Xe in he)if(he.hasOwnProperty(Xe)){const tt=m(ue[Xe],he[Xe]);tt.didChange&&(ue[Xe]=tt.newValue,le=!0)}return new a(ue,le)}class ${constructor(he){this.schema=void 0,this.id=he,this.name="_never_",this.defaultValue=void 0}applyUpdate(he,le){return m(he,le)}validate(he){return this.defaultValue}}class f{constructor(he,le,Xe,tt){this.id=he,this.name=le,this.defaultValue=Xe,this.schema=tt}applyUpdate(he,le){return m(he,le)}validate(he){return typeof he>"u"?this.defaultValue:he}compute(he,le,Xe){return Xe}}function i(ue,he){return typeof ue>"u"?he:ue==="false"?!1:!!ue}class s extends f{constructor(he,le,Xe,tt=void 0){typeof tt<"u"&&(tt.type="boolean",tt.default=Xe),super(he,le,Xe,tt)}validate(he){return i(he,this.defaultValue)}}function t(ue,he,le,Xe){if(typeof ue>"u")return he;let tt=parseInt(ue,10);return isNaN(tt)?he:(tt=Math.max(le,tt),tt=Math.min(Xe,tt),tt|0)}class o extends f{static clampedInt(he,le,Xe,tt){return t(he,le,Xe,tt)}constructor(he,le,Xe,tt,ut,mt=void 0){typeof mt<"u"&&(mt.type="integer",mt.default=Xe,mt.minimum=tt,mt.maximum=ut),super(he,le,Xe,mt),this.minimum=tt,this.maximum=ut}validate(he){return o.clampedInt(he,this.defaultValue,this.minimum,this.maximum)}}function n(ue,he,le,Xe){if(typeof ue>"u")return he;const tt=d.float(ue,he);return d.clamp(tt,le,Xe)}class d extends f{static clamp(he,le,Xe){return he<le?le:he>Xe?Xe:he}static float(he,le){if(typeof he=="number")return he;if(typeof he>"u")return le;const Xe=parseFloat(he);return isNaN(Xe)?le:Xe}constructor(he,le,Xe,tt,ut){typeof ut<"u"&&(ut.type="number",ut.default=Xe),super(he,le,Xe,ut),this.validationFn=tt}validate(he){return this.validationFn(d.float(he,this.defaultValue))}}class l extends f{static string(he,le){return typeof he!="string"?le:he}constructor(he,le,Xe,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.default=Xe),super(he,le,Xe,tt)}validate(he){return l.string(he,this.defaultValue)}}function g(ue,he,le,Xe){return typeof ue!="string"?he:Xe&&ue in Xe?Xe[ue]:le.indexOf(ue)===-1?he:ue}class E extends f{constructor(he,le,Xe,tt,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=tt,ut.default=Xe),super(he,le,Xe,ut),this.c=tt}validate(he){return g(he,this.defaultValue,this.c)}}class D extends w{constructor(he,le,Xe,tt,ut,mt,Dt=void 0){typeof Dt<"u"&&(Dt.type="string",Dt.enum=ut,Dt.default=tt),super(he,le,Xe,Dt),this.c=ut,this.d=mt}validate(he){return typeof he!="string"?this.defaultValue:this.c.indexOf(he)===-1?this.defaultValue:this.d(he)}}function y(ue){switch(ue){case"none":return S.None;case"keep":return S.Keep;case"brackets":return S.Brackets;case"advanced":return S.Advanced;case"full":return S.Full}}class k extends w{constructor(){super(je.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(11775,null),c.localize(11776,null),c.localize(11777,null)],default:"auto",tags:["accessibility"],description:c.localize(11778,null)})}validate(he){switch(he){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(he,le,Xe){return Xe===I.AccessibilitySupport.Unknown?he.accessibilitySupport:Xe}}class A extends w{constructor(){const he={insertSpace:!0,ignoreEmptyLines:!0};super(je.comments,"comments",he,{"editor.comments.insertSpace":{type:"boolean",default:he.insertSpace,description:c.localize(11779,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:he.ignoreEmptyLines,description:c.localize(11780,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{insertSpace:i(le.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(le.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var b;(function(ue){ue[ue.Hidden=0]="Hidden",ue[ue.Blink=1]="Blink",ue[ue.Smooth=2]="Smooth",ue[ue.Phase=3]="Phase",ue[ue.Expand=4]="Expand",ue[ue.Solid=5]="Solid"})(b||(e.TextEditorCursorBlinkingStyle=b={}));function v(ue){switch(ue){case"blink":return b.Blink;case"smooth":return b.Smooth;case"phase":return b.Phase;case"expand":return b.Expand;case"solid":return b.Solid}}var F;(function(ue){ue[ue.Line=1]="Line",ue[ue.Block=2]="Block",ue[ue.Underline=3]="Underline",ue[ue.LineThin=4]="LineThin",ue[ue.BlockOutline=5]="BlockOutline",ue[ue.UnderlineThin=6]="UnderlineThin"})(F||(e.TextEditorCursorStyle=F={}));function N(ue){switch(ue){case F.Line:return"line";case F.Block:return"block";case F.Underline:return"underline";case F.LineThin:return"line-thin";case F.BlockOutline:return"block-outline";case F.UnderlineThin:return"underline-thin"}}function L(ue){switch(ue){case"line":return F.Line;case"block":return F.Block;case"underline":return F.Underline;case"line-thin":return F.LineThin;case"block-outline":return F.BlockOutline;case"underline-thin":return F.UnderlineThin}}class M extends ${constructor(){super(je.editorClassName)}compute(he,le,Xe){const tt=["monaco-editor"];return le.get(je.extraEditorClassName)&&tt.push(le.get(je.extraEditorClassName)),he.extraEditorClassName&&tt.push(he.extraEditorClassName),le.get(je.mouseStyle)==="default"?tt.push("mouse-default"):le.get(je.mouseStyle)==="copy"&&tt.push("mouse-copy"),le.get(je.showUnused)&&tt.push("showUnused"),le.get(je.showDeprecated)&&tt.push("showDeprecated"),tt.join(" ")}}class z extends s{constructor(){super(je.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:c.localize(11781,null)})}compute(he,le,Xe){return Xe&&he.emptySelectionClipboard}}class j extends w{constructor(){const he={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(je.find,"find",he,{"editor.find.cursorMoveOnType":{type:"boolean",default:he.cursorMoveOnType,description:c.localize(11782,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:he.seedSearchStringFromSelection,enumDescriptions:[c.localize(11783,null),c.localize(11784,null),c.localize(11785,null)],description:c.localize(11786,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:he.autoFindInSelection,enumDescriptions:[c.localize(11787,null),c.localize(11788,null),c.localize(11789,null)],description:c.localize(11790,null)},"editor.find.globalFindClipboard":{type:"boolean",default:he.globalFindClipboard,description:c.localize(11791,null),included:C.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:he.addExtraSpaceOnTop,description:c.localize(11792,null)},"editor.find.loop":{type:"boolean",default:he.loop,description:c.localize(11793,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{cursorMoveOnType:i(le.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof he.seedSearchStringFromSelection=="boolean"?he.seedSearchStringFromSelection?"always":"never":g(le.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof he.autoFindInSelection=="boolean"?he.autoFindInSelection?"always":"never":g(le.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(le.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(le.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(le.loop,this.defaultValue.loop)}}}class W extends w{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(je.fontLigatures,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:c.localize(11794,null)},{type:"string",description:c.localize(11795,null)}],description:c.localize(11796,null),default:!1})}validate(he){return typeof he>"u"?this.defaultValue:typeof he=="string"?he==="false"||he.length===0?W.OFF:he==="true"?W.ON:he:he?W.ON:W.OFF}}e.EditorFontLigatures=W;class B extends w{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(je.fontVariations,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:c.localize(11797,null)},{type:"string",description:c.localize(11798,null)}],description:c.localize(11799,null),default:!1})}validate(he){return typeof he>"u"?this.defaultValue:typeof he=="string"?he==="false"?B.OFF:he==="true"?B.TRANSLATE:he:he?B.TRANSLATE:B.OFF}compute(he,le,Xe){return he.fontInfo.fontVariationSettings}}e.EditorFontVariations=B;class ee extends ${constructor(){super(je.fontInfo)}compute(he,le,Xe){return he.fontInfo}}class H extends f{constructor(){super(je.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(11800,null)})}validate(he){const le=d.float(he,this.defaultValue);return le===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(le,6,100)}compute(he,le,Xe){return he.fontInfo.fontSize}}class q extends w{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(je.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:q.d,maximum:q.e,errorMessage:c.localize(11801,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:q.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(11802,null)})}validate(he){return he==="normal"||he==="bold"?he:String(o.clampedInt(he,e.EDITOR_FONT_DEFAULTS.fontWeight,q.d,q.e))}}class Q extends w{constructor(){const he={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},le={type:"string",enum:["peek","gotoAndPeek","goto"],default:he.multiple,enumDescriptions:[c.localize(11803,null),c.localize(11804,null),c.localize(11805,null)]},Xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(je.gotoLocation,"gotoLocation",he,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(11806,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(11807,null),...le},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(11808,null),...le},"editor.gotoLocation.multipleDeclarations":{description:c.localize(11809,null),...le},"editor.gotoLocation.multipleImplementations":{description:c.localize(11810,null),...le},"editor.gotoLocation.multipleReferences":{description:c.localize(11811,null),...le},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:he.alternativeDefinitionCommand,enum:Xe,description:c.localize(11812,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:he.alternativeTypeDefinitionCommand,enum:Xe,description:c.localize(11813,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:he.alternativeDeclarationCommand,enum:Xe,description:c.localize(11814,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:he.alternativeImplementationCommand,enum:Xe,description:c.localize(11815,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:he.alternativeReferenceCommand,enum:Xe,description:c.localize(11816,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{multiple:g(le.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:le.multipleDefinitions??g(le.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:le.multipleTypeDefinitions??g(le.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:le.multipleDeclarations??g(le.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:le.multipleImplementations??g(le.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:le.multipleReferences??g(le.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:le.multipleTests??g(le.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:l.string(le.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:l.string(le.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:l.string(le.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:l.string(le.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:l.string(le.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:l.string(le.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class _ extends w{constructor(){const he={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(je.hover,"hover",he,{"editor.hover.enabled":{type:"boolean",default:he.enabled,description:c.localize(11817,null)},"editor.hover.delay":{type:"number",default:he.delay,minimum:0,maximum:1e4,description:c.localize(11818,null)},"editor.hover.sticky":{type:"boolean",default:he.sticky,description:c.localize(11819,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:he.hidingDelay,description:c.localize(11820,null)},"editor.hover.above":{type:"boolean",default:he.above,description:c.localize(11821,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),delay:o.clampedInt(le.delay,this.defaultValue.delay,0,1e4),sticky:i(le.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(le.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(le.above,this.defaultValue.above)}}}var ce;(function(ue){ue[ue.None=0]="None",ue[ue.Text=1]="Text",ue[ue.Blocks=2]="Blocks"})(ce||(e.RenderMinimap=ce={}));class ne extends ${constructor(){super(je.layoutInfo)}compute(he,le,Xe){return ne.computeLayout(le,{memory:he.memory,outerWidth:he.outerWidth,outerHeight:he.outerHeight,isDominatedByLongLines:he.isDominatedByLongLines,lineHeight:he.fontInfo.lineHeight,viewLineCount:he.viewLineCount,lineNumbersDigitCount:he.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:he.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:he.fontInfo.maxDigitWidth,pixelRatio:he.pixelRatio,glyphMarginDecorationLaneCount:he.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(he){const le=he.height/he.lineHeight,Xe=Math.floor(he.paddingTop/he.lineHeight);let tt=Math.floor(he.paddingBottom/he.lineHeight);he.scrollBeyondLastLine&&(tt=Math.max(tt,le-1));const ut=(Xe+he.viewLineCount+tt)/(he.pixelRatio*he.height),mt=Math.floor(he.viewLineCount/ut);return{typicalViewportLineCount:le,extraLinesBeforeFirstLine:Xe,extraLinesBeyondLastLine:tt,desiredRatio:ut,minimapLineCount:mt}}static c(he,le){const Xe=he.outerWidth,tt=he.outerHeight,ut=he.pixelRatio;if(!he.minimap.enabled)return{renderMinimap:ce.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ut*tt),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:tt};const mt=le.stableMinimapLayoutInput,Dt=mt&&he.outerHeight===mt.outerHeight&&he.lineHeight===mt.lineHeight&&he.typicalHalfwidthCharacterWidth===mt.typicalHalfwidthCharacterWidth&&he.pixelRatio===mt.pixelRatio&&he.scrollBeyondLastLine===mt.scrollBeyondLastLine&&he.paddingTop===mt.paddingTop&&he.paddingBottom===mt.paddingBottom&&he.minimap.enabled===mt.minimap.enabled&&he.minimap.side===mt.minimap.side&&he.minimap.size===mt.minimap.size&&he.minimap.showSlider===mt.minimap.showSlider&&he.minimap.renderCharacters===mt.minimap.renderCharacters&&he.minimap.maxColumn===mt.minimap.maxColumn&&he.minimap.scale===mt.minimap.scale&&he.verticalScrollbarWidth===mt.verticalScrollbarWidth&&he.isViewportWrapping===mt.isViewportWrapping,Mt=he.lineHeight,Ht=he.typicalHalfwidthCharacterWidth,ei=he.scrollBeyondLastLine,oi=he.minimap.renderCharacters;let Tt=ut>=2?Math.round(he.minimap.scale*2):he.minimap.scale;const it=he.minimap.maxColumn,Ct=he.minimap.size,hi=he.minimap.side,bt=he.verticalScrollbarWidth,St=he.viewLineCount,ti=he.remainingWidth,ii=he.isViewportWrapping,Wt=oi?2:3;let pt=Math.floor(ut*tt);const Bt=pt/ut;let ni=!1,ai=!1,xe=Wt*Tt,ci=Tt/ut,di=1;if(Ct==="fill"||Ct==="fit"){const{typicalViewportLineCount:Qt,extraLinesBeforeFirstLine:li,extraLinesBeyondLastLine:qt,desiredRatio:Zt,minimapLineCount:Jt}=ne.computeContainedMinimapLineCount({viewLineCount:St,scrollBeyondLastLine:ei,paddingTop:he.paddingTop,paddingBottom:he.paddingBottom,height:tt,lineHeight:Mt,pixelRatio:ut});if(St/Jt>1)ni=!0,ai=!0,Tt=1,xe=1,ci=Tt/ut;else{let wt=!1,It=Tt+1;if(Ct==="fit"){const Kt=Math.ceil((li+St+qt)*xe);ii&&Dt&&ti<=le.stableFitRemainingWidth?(wt=!0,It=le.stableFitMaxMinimapScale):wt=Kt>pt}if(Ct==="fill"||wt){ni=!0;const Kt=Tt;xe=Math.min(Mt*ut,Math.max(1,Math.floor(1/Zt))),ii&&Dt&&ti<=le.stableFitRemainingWidth&&(It=le.stableFitMaxMinimapScale),Tt=Math.min(It,Math.max(1,Math.floor(xe/Wt))),Tt>Kt&&(di=Math.min(2,Tt/Kt)),ci=Tt/ut/di,pt=Math.ceil(Math.max(Qt,li+St+qt)*xe),ii?(le.stableMinimapLayoutInput=he,le.stableFitRemainingWidth=ti,le.stableFitMaxMinimapScale=Tt):(le.stableMinimapLayoutInput=null,le.stableFitRemainingWidth=0)}}}const fi=Math.floor(it*ci),vt=Math.min(fi,Math.max(0,Math.floor((ti-bt-2)*ci/(Ht+ci)))+e.MINIMAP_GUTTER_WIDTH);let jt=Math.floor(ut*vt);const Nt=jt/ut;jt=Math.floor(jt*di);const Gt=oi?ce.Text:ce.Blocks,ri=hi==="left"?0:Xe-vt-bt;return{renderMinimap:Gt,minimapLeft:ri,minimapWidth:vt,minimapHeightIsEditorHeight:ni,minimapIsSampling:ai,minimapScale:Tt,minimapLineHeight:xe,minimapCanvasInnerWidth:jt,minimapCanvasInnerHeight:pt,minimapCanvasOuterWidth:Nt,minimapCanvasOuterHeight:Bt}}static computeLayout(he,le){const Xe=le.outerWidth|0,tt=le.outerHeight|0,ut=le.lineHeight|0,mt=le.lineNumbersDigitCount|0,Dt=le.typicalHalfwidthCharacterWidth,Mt=le.maxDigitWidth,Ht=le.pixelRatio,ei=le.viewLineCount,oi=he.get(je.wordWrapOverride2),Tt=oi==="inherit"?he.get(je.wordWrapOverride1):oi,it=Tt==="inherit"?he.get(je.wordWrap):Tt,Ct=he.get(je.wordWrapColumn),hi=le.isDominatedByLongLines,bt=he.get(je.glyphMargin),St=he.get(je.lineNumbers).renderType!==Be.Off,ti=he.get(je.lineNumbersMinChars),ii=he.get(je.scrollBeyondLastLine),Wt=he.get(je.padding),pt=he.get(je.minimap),Bt=he.get(je.scrollbar),ni=Bt.verticalScrollbarSize,ai=Bt.verticalHasArrows,xe=Bt.arrowSize,ci=Bt.horizontalScrollbarSize,di=he.get(je.folding),fi=he.get(je.showFoldingControls)!=="never";let vt=he.get(je.lineDecorationsWidth);di&&fi&&(vt+=16);let jt=0;if(St){const mi=Math.max(mt,ti);jt=Math.round(mi*Mt)}let Nt=0;bt&&(Nt=ut*le.glyphMarginDecorationLaneCount);let Gt=0,ri=Gt+Nt,Qt=ri+jt,li=Qt+vt;const qt=Xe-Nt-jt-vt;let Zt=!1,Jt=!1,Ft=-1;Tt==="inherit"&&hi?(Zt=!0,Jt=!0):it==="on"||it==="bounded"?Jt=!0:it==="wordWrapColumn"&&(Ft=Ct);const wt=ne.c({outerWidth:Xe,outerHeight:tt,lineHeight:ut,typicalHalfwidthCharacterWidth:Dt,pixelRatio:Ht,scrollBeyondLastLine:ii,paddingTop:Wt.top,paddingBottom:Wt.bottom,minimap:pt,verticalScrollbarWidth:ni,viewLineCount:ei,remainingWidth:qt,isViewportWrapping:Jt},le.memory||new P);wt.renderMinimap!==ce.None&&wt.minimapLeft===0&&(Gt+=wt.minimapWidth,ri+=wt.minimapWidth,Qt+=wt.minimapWidth,li+=wt.minimapWidth);const It=qt-wt.minimapWidth,Kt=Math.max(1,Math.floor((It-ni-2)/Dt)),Pt=ai?xe:0;return Jt&&(Ft=Math.max(1,Kt),it==="bounded"&&(Ft=Math.min(Ft,Ct))),{width:Xe,height:tt,glyphMarginLeft:Gt,glyphMarginWidth:Nt,glyphMarginDecorationLaneCount:le.glyphMarginDecorationLaneCount,lineNumbersLeft:ri,lineNumbersWidth:jt,decorationsLeft:Qt,decorationsWidth:vt,contentLeft:li,contentWidth:It,minimap:wt,viewportColumn:Kt,isWordWrapMinified:Zt,isViewportWrapping:Jt,wrappingColumn:Ft,verticalScrollbarWidth:ni,horizontalScrollbarHeight:ci,overviewRuler:{top:Pt,width:ni,height:tt-2*Pt,right:0}}}}e.EditorLayoutInfoComputer=ne;class ye extends w{constructor(){super(je.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(11822,null),c.localize(11823,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(11824,null)}})}validate(he){return g(he,"simple",["simple","advanced"])}compute(he,le,Xe){return le.get(je.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":Xe}}var ge;(function(ue){ue.Off="off",ue.OnCode="onCode",ue.On="on"})(ge||(e.ShowLightbulbIconMode=ge={}));class Y extends w{constructor(){const he={enabled:ge.On};super(je.lightbulb,"lightbulb",he,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ge.Off,ge.OnCode,ge.On],default:he.enabled,enumDescriptions:[c.localize(11825,null),c.localize(11826,null),c.localize(11827,null)],description:c.localize(11828,null)}})}validate(he){return!he||typeof he!="object"?this.defaultValue:{enabled:g(he.enabled,this.defaultValue.enabled,[ge.Off,ge.OnCode,ge.On])}}}class U extends w{constructor(){const he={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(je.stickyScroll,"stickyScroll",he,{"editor.stickyScroll.enabled":{type:"boolean",default:he.enabled,description:c.localize(11829,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:he.maxLineCount,minimum:1,maximum:20,description:c.localize(11830,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:he.defaultModel,description:c.localize(11831,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:he.scrollWithEditor,description:c.localize(11832,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(le.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:g(le.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(le.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class oe extends w{constructor(){const he={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(je.inlayHints,"inlayHints",he,{"editor.inlayHints.enabled":{type:"string",default:he.enabled,description:c.localize(11833,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(11834,null),c.localize(11835,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),c.localize(11836,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),c.localize(11837,null)]},"editor.inlayHints.fontSize":{type:"number",default:he.fontSize,markdownDescription:c.localize(11838,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:he.fontFamily,markdownDescription:c.localize(11839,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:he.padding,description:c.localize(11840,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return typeof le.enabled=="boolean"&&(le.enabled=le.enabled?"on":"off"),{enabled:g(le.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(le.fontSize,this.defaultValue.fontSize,0,100),fontFamily:l.string(le.fontFamily,this.defaultValue.fontFamily),padding:i(le.padding,this.defaultValue.padding)}}}class ve extends w{constructor(){super(je.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(he){return typeof he=="string"&&/^\d+(\.\d+)?ch$/.test(he)?-parseFloat(he.substring(0,he.length-2)):o.clampedInt(he,this.defaultValue,0,1e3)}compute(he,le,Xe){return Xe<0?o.clampedInt(-Xe*he.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Xe}}class te extends d{constructor(){super(je.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,he=>d.clamp(he,0,150),{markdownDescription:c.localize(11841,null)})}compute(he,le,Xe){return he.fontInfo.lineHeight}}class ae extends w{constructor(){const he={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(je.minimap,"minimap",he,{"editor.minimap.enabled":{type:"boolean",default:he.enabled,description:c.localize(11842,null)},"editor.minimap.autohide":{type:"boolean",default:he.autohide,description:c.localize(11843,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(11844,null),c.localize(11845,null),c.localize(11846,null)],default:he.size,description:c.localize(11847,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:he.side,description:c.localize(11848,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:he.showSlider,description:c.localize(11849,null)},"editor.minimap.scale":{type:"number",default:he.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(11850,null)},"editor.minimap.renderCharacters":{type:"boolean",default:he.renderCharacters,description:c.localize(11851,null)},"editor.minimap.maxColumn":{type:"number",default:he.maxColumn,description:c.localize(11852,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:he.showRegionSectionHeaders,description:c.localize(11853,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:he.showMarkSectionHeaders,description:c.localize(11854,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:he.sectionHeaderFontSize,description:c.localize(11855,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:he.sectionHeaderLetterSpacing,description:c.localize(11856,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),autohide:i(le.autohide,this.defaultValue.autohide),size:g(le.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(le.side,this.defaultValue.side,["right","left"]),showSlider:g(le.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(le.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(le.scale,1,1,3),maxColumn:o.clampedInt(le.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(le.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(le.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:d.clamp(le.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:d.clamp(le.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function se(ue){return ue==="ctrlCmd"?C.$k?"metaKey":"ctrlKey":"altKey"}class X extends w{constructor(){super(je.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(11857,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(11858,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{top:o.clampedInt(le.top,0,0,1e3),bottom:o.clampedInt(le.bottom,0,0,1e3)}}}class re extends w{constructor(){const he={enabled:!0,cycle:!0};super(je.parameterHints,"parameterHints",he,{"editor.parameterHints.enabled":{type:"boolean",default:he.enabled,description:c.localize(11859,null)},"editor.parameterHints.cycle":{type:"boolean",default:he.cycle,description:c.localize(11860,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),cycle:i(le.cycle,this.defaultValue.cycle)}}}class pe extends ${constructor(){super(je.pixelRatio)}compute(he,le,Xe){return he.pixelRatio}}class we extends w{constructor(){super(je.placeholder,"placeholder",void 0)}validate(he){return typeof he>"u"?this.defaultValue:typeof he=="string"?he:this.defaultValue}}class Fe extends w{constructor(){const he={other:"on",comments:"off",strings:"off"},le=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(11861,null),c.localize(11862,null),c.localize(11863,null)]}];super(je.quickSuggestions,"quickSuggestions",he,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:le,default:he.strings,description:c.localize(11864,null)},comments:{anyOf:le,default:he.comments,description:c.localize(11865,null)},other:{anyOf:le,default:he.other,description:c.localize(11866,null)}},default:he,markdownDescription:c.localize(11867,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=he}validate(he){if(typeof he=="boolean"){const Ht=he?"on":"off";return{comments:Ht,strings:Ht,other:Ht}}if(!he||typeof he!="object")return this.defaultValue;const{other:le,comments:Xe,strings:tt}=he,ut=["on","inline","off"];let mt,Dt,Mt;return typeof le=="boolean"?mt=le?"on":"off":mt=g(le,this.defaultValue.other,ut),typeof Xe=="boolean"?Dt=Xe?"on":"off":Dt=g(Xe,this.defaultValue.comments,ut),typeof tt=="boolean"?Mt=tt?"on":"off":Mt=g(tt,this.defaultValue.strings,ut),{other:mt,comments:Dt,strings:Mt}}}var Be;(function(ue){ue[ue.Off=0]="Off",ue[ue.On=1]="On",ue[ue.Relative=2]="Relative",ue[ue.Interval=3]="Interval",ue[ue.Custom=4]="Custom"})(Be||(e.RenderLineNumbersType=Be={}));class Re extends w{constructor(){super(je.lineNumbers,"lineNumbers",{renderType:Be.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(11868,null),c.localize(11869,null),c.localize(11870,null),c.localize(11871,null)],default:"on",description:c.localize(11872,null)})}validate(he){let le=this.defaultValue.renderType,Xe=this.defaultValue.renderFn;return typeof he<"u"&&(typeof he=="function"?(le=Be.Custom,Xe=he):he==="interval"?le=Be.Interval:he==="relative"?le=Be.Relative:he==="on"?le=Be.On:le=Be.Off),{renderType:le,renderFn:Xe}}}function De(ue){const he=ue.get(je.renderValidationDecorations);return he==="editable"?ue.get(je.readOnly):he!=="on"}class Ce extends w{constructor(){const he=[],le={type:"number",description:c.localize(11873,null)};super(je.rulers,"rulers",he,{type:"array",items:{anyOf:[le,{type:["object"],properties:{column:le,color:{type:"string",description:c.localize(11874,null),format:"color-hex"}}}]},default:he,description:c.localize(11875,null)})}validate(he){if(Array.isArray(he)){const le=[];for(const Xe of he)if(typeof Xe=="number")le.push({column:o.clampedInt(Xe,0,0,1e4),color:null});else if(Xe&&typeof Xe=="object"){const tt=Xe;le.push({column:o.clampedInt(tt.column,0,0,1e4),color:tt.color})}return le.sort((Xe,tt)=>Xe.column-tt.column),le}return this.defaultValue}}class V extends w{constructor(){super(je.readOnlyMessage,"readOnlyMessage",void 0)}validate(he){return!he||typeof he!="object"?this.defaultValue:he}}function G(ue,he){if(typeof ue!="string")return he;switch(ue){case"hidden":return R.ScrollbarVisibility.Hidden;case"visible":return R.ScrollbarVisibility.Visible;default:return R.ScrollbarVisibility.Auto}}class J extends w{constructor(){const he={vertical:R.ScrollbarVisibility.Auto,horizontal:R.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(je.scrollbar,"scrollbar",he,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(11876,null),c.localize(11877,null),c.localize(11878,null)],default:"auto",description:c.localize(11879,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(11880,null),c.localize(11881,null),c.localize(11882,null)],default:"auto",description:c.localize(11883,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:he.verticalScrollbarSize,description:c.localize(11884,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:he.horizontalScrollbarSize,description:c.localize(11885,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:he.scrollByPage,description:c.localize(11886,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:he.ignoreHorizontalScrollbarInContentHeight,description:c.localize(11887,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he,Xe=o.clampedInt(le.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),tt=o.clampedInt(le.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(le.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:G(le.vertical,this.defaultValue.vertical),horizontal:G(le.horizontal,this.defaultValue.horizontal),useShadows:i(le.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(le.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(le.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(le.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(le.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Xe,horizontalSliderSize:o.clampedInt(le.horizontalSliderSize,Xe,0,1e3),verticalScrollbarSize:tt,verticalSliderSize:o.clampedInt(le.verticalSliderSize,tt,0,1e3),scrollByPage:i(le.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(le.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class x extends w{constructor(){const he={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(je.unicodeHighlighting,"unicodeHighlight",he,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:he.nonBasicASCII,description:c.localize(11888,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:he.invisibleCharacters,description:c.localize(11889,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:he.ambiguousCharacters,description:c.localize(11890,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:he.includeComments,description:c.localize(11891,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:he.includeStrings,description:c.localize(11892,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:he.allowedCharacters,description:c.localize(11893,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:he.allowedLocales,description:c.localize(11894,null)}})}applyUpdate(he,le){let Xe=!1;le.allowedCharacters&&he&&(h.$io(he.allowedCharacters,le.allowedCharacters)||(he={...he,allowedCharacters:le.allowedCharacters},Xe=!0)),le.allowedLocales&&he&&(h.$io(he.allowedLocales,le.allowedLocales)||(he={...he,allowedLocales:le.allowedLocales},Xe=!0));const tt=super.applyUpdate(he,le);return Xe?new a(tt.newValue,!0):tt}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{nonBasicASCII:Ze(le.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(le.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(le.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ze(le.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ze(le.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(he.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(he.allowedLocales,this.defaultValue.allowedLocales)}}c(he,le){if(typeof he!="object"||!he)return le;const Xe={};for(const[tt,ut]of Object.entries(he))ut===!0&&(Xe[tt]=!0);return Xe}}class de extends w{constructor(){const he={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(je.inlineSuggest,"inlineSuggest",he,{"editor.inlineSuggest.enabled":{type:"boolean",default:he.enabled,description:c.localize(11895,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:he.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(11896,null),c.localize(11897,null),c.localize(11898,null)],description:c.localize(11899,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:he.suppressSuggestions,description:c.localize(11900,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:he.fontFamily,description:c.localize(11901,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),mode:g(le.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:g(le.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(le.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(le.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:l.string(le.fontFamily,this.defaultValue.fontFamily)}}}class Ee extends w{constructor(){const he={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(je.inlineEdit,"experimentalInlineEdit",he,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:he.enabled,description:c.localize(11902,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:he.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(11903,null),c.localize(11904,null),c.localize(11905,null)],description:c.localize(11906,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:he.fontFamily,description:c.localize(11907,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),showToolbar:g(le.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:l.string(le.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(le.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Le extends w{constructor(){const he={enabled:T.$lt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$lt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(je.bracketPairColorization,"bracketPairColorization",he,{"editor.bracketPairColorization.enabled":{type:"boolean",default:he.enabled,markdownDescription:c.localize(11908,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:he.independentColorPoolPerBracketType,description:c.localize(11909,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(le.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class He extends w{constructor(){const he={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(je.guides,"guides",he,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(11910,null),c.localize(11911,null),c.localize(11912,null)],default:he.bracketPairs,description:c.localize(11913,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(11914,null),c.localize(11915,null),c.localize(11916,null)],default:he.bracketPairsHorizontal,description:c.localize(11917,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:he.highlightActiveBracketPair,description:c.localize(11918,null)},"editor.guides.indentation":{type:"boolean",default:he.indentation,description:c.localize(11919,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(11920,null),c.localize(11921,null),c.localize(11922,null)],default:he.highlightActiveIndentation,description:c.localize(11923,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{bracketPairs:Ze(le.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ze(le.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(le.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(le.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ze(le.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ze(ue,he,le){const Xe=le.indexOf(ue);return Xe===-1?he:le[Xe]}class et extends w{constructor(){const he={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(je.suggest,"suggest",he,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(11924,null),c.localize(11925,null)],default:he.insertMode,description:c.localize(11926,null)},"editor.suggest.filterGraceful":{type:"boolean",default:he.filterGraceful,description:c.localize(11927,null)},"editor.suggest.localityBonus":{type:"boolean",default:he.localityBonus,description:c.localize(11928,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:he.shareSuggestSelections,markdownDescription:c.localize(11929,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(11930,null),c.localize(11931,null),c.localize(11932,null),c.localize(11933,null)],default:he.selectionMode,markdownDescription:c.localize(11934,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:he.snippetsPreventQuickSuggestions,description:c.localize(11935,null)},"editor.suggest.showIcons":{type:"boolean",default:he.showIcons,description:c.localize(11936,null)},"editor.suggest.showStatusBar":{type:"boolean",default:he.showStatusBar,description:c.localize(11937,null)},"editor.suggest.preview":{type:"boolean",default:he.preview,description:c.localize(11938,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:he.showInlineDetails,description:c.localize(11939,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(11940,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(11941,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(11942,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(11943,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(11944,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(11945,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(11946,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(11947,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(11948,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(11949,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(11950,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(11951,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(11952,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(11953,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(11954,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(11955,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(11956,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(11957,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(11958,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(11959,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(11960,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(11961,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(11962,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(11963,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(11964,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(11965,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(11966,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(11967,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(11968,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(11969,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(11970,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(11971,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{insertMode:g(le.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(le.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(le.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(le.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(le.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:g(le.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(le.showIcons,this.defaultValue.showIcons),showStatusBar:i(le.showStatusBar,this.defaultValue.showStatusBar),preview:i(le.preview,this.defaultValue.preview),previewMode:g(le.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(le.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(le.showMethods,this.defaultValue.showMethods),showFunctions:i(le.showFunctions,this.defaultValue.showFunctions),showConstructors:i(le.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(le.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(le.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(le.showFields,this.defaultValue.showFields),showVariables:i(le.showVariables,this.defaultValue.showVariables),showClasses:i(le.showClasses,this.defaultValue.showClasses),showStructs:i(le.showStructs,this.defaultValue.showStructs),showInterfaces:i(le.showInterfaces,this.defaultValue.showInterfaces),showModules:i(le.showModules,this.defaultValue.showModules),showProperties:i(le.showProperties,this.defaultValue.showProperties),showEvents:i(le.showEvents,this.defaultValue.showEvents),showOperators:i(le.showOperators,this.defaultValue.showOperators),showUnits:i(le.showUnits,this.defaultValue.showUnits),showValues:i(le.showValues,this.defaultValue.showValues),showConstants:i(le.showConstants,this.defaultValue.showConstants),showEnums:i(le.showEnums,this.defaultValue.showEnums),showEnumMembers:i(le.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(le.showKeywords,this.defaultValue.showKeywords),showWords:i(le.showWords,this.defaultValue.showWords),showColors:i(le.showColors,this.defaultValue.showColors),showFiles:i(le.showFiles,this.defaultValue.showFiles),showReferences:i(le.showReferences,this.defaultValue.showReferences),showFolders:i(le.showFolders,this.defaultValue.showFolders),showTypeParameters:i(le.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(le.showSnippets,this.defaultValue.showSnippets),showUsers:i(le.showUsers,this.defaultValue.showUsers),showIssues:i(le.showIssues,this.defaultValue.showIssues)}}}class nt extends w{constructor(){super(je.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(11972,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:c.localize(11973,null),default:!0,type:"boolean"}})}validate(he){return!he||typeof he!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(he.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(he.selectSubwords,this.defaultValue.selectSubwords)}}}class st extends w{constructor(){const he=[];super(je.wordSegmenterLocales,"wordSegmenterLocales",he,{anyOf:[{description:c.localize(11974,null),type:"string"},{description:c.localize(11975,null),type:"array",items:{type:"string"}}]})}validate(he){if(typeof he=="string"&&(he=[he]),Array.isArray(he)){const le=[];for(const Xe of he)if(typeof Xe=="string")try{Intl.Segmenter.supportedLocalesOf(Xe).length>0&&le.push(Xe)}catch{}return le}return this.defaultValue}}var rt;(function(ue){ue[ue.None=0]="None",ue[ue.Same=1]="Same",ue[ue.Indent=2]="Indent",ue[ue.DeepIndent=3]="DeepIndent"})(rt||(e.WrappingIndent=rt={}));class at extends w{constructor(){super(je.wrappingIndent,"wrappingIndent",rt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(11976,null),c.localize(11977,null),c.localize(11978,null),c.localize(11979,null)],description:c.localize(11980,null),default:"same"}})}validate(he){switch(he){case"none":return rt.None;case"same":return rt.Same;case"indent":return rt.Indent;case"deepIndent":return rt.DeepIndent}return rt.Same}compute(he,le,Xe){return le.get(je.accessibilitySupport)===I.AccessibilitySupport.Enabled?rt.None:Xe}}class gt extends ${constructor(){super(je.wrappingInfo)}compute(he,le,Xe){const tt=le.get(je.layoutInfo);return{isDominatedByLongLines:he.isDominatedByLongLines,isWordWrapMinified:tt.isWordWrapMinified,isViewportWrapping:tt.isViewportWrapping,wrappingColumn:tt.wrappingColumn}}}class dt extends w{constructor(){const he={enabled:!0,showDropSelector:"afterDrop"};super(je.dropIntoEditor,"dropIntoEditor",he,{"editor.dropIntoEditor.enabled":{type:"boolean",default:he.enabled,markdownDescription:c.localize(11981,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:c.localize(11982,null),enum:["afterDrop","never"],enumDescriptions:[c.localize(11983,null),c.localize(11984,null)],default:"afterDrop"}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),showDropSelector:g(le.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ct extends w{constructor(){const he={enabled:!0,showPasteSelector:"afterPaste"};super(je.pasteAs,"pasteAs",he,{"editor.pasteAs.enabled":{type:"boolean",default:he.enabled,markdownDescription:c.localize(11985,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:c.localize(11986,null),enum:["afterPaste","never"],enumDescriptions:[c.localize(11987,null),c.localize(11988,null)],default:"afterPaste"}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),showPasteSelector:g(le.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Pe="Consolas, 'Courier New', monospace",ze="Menlo, Monaco, 'Courier New', monospace",Ke="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$k?ze:C.$l?Ke:Pe,fontWeight:"normal",fontSize:C.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(ue){return e.editorOptionsRegistry[ue.id]=ue,ue}var je;(function(ue){ue[ue.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ue[ue.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ue[ue.accessibilitySupport=2]="accessibilitySupport",ue[ue.accessibilityPageSize=3]="accessibilityPageSize",ue[ue.ariaLabel=4]="ariaLabel",ue[ue.ariaRequired=5]="ariaRequired",ue[ue.autoClosingBrackets=6]="autoClosingBrackets",ue[ue.autoClosingComments=7]="autoClosingComments",ue[ue.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ue[ue.autoClosingDelete=9]="autoClosingDelete",ue[ue.autoClosingOvertype=10]="autoClosingOvertype",ue[ue.autoClosingQuotes=11]="autoClosingQuotes",ue[ue.autoIndent=12]="autoIndent",ue[ue.automaticLayout=13]="automaticLayout",ue[ue.autoSurround=14]="autoSurround",ue[ue.bracketPairColorization=15]="bracketPairColorization",ue[ue.guides=16]="guides",ue[ue.codeLens=17]="codeLens",ue[ue.codeLensFontFamily=18]="codeLensFontFamily",ue[ue.codeLensFontSize=19]="codeLensFontSize",ue[ue.colorDecorators=20]="colorDecorators",ue[ue.colorDecoratorsLimit=21]="colorDecoratorsLimit",ue[ue.columnSelection=22]="columnSelection",ue[ue.comments=23]="comments",ue[ue.contextmenu=24]="contextmenu",ue[ue.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ue[ue.cursorBlinking=26]="cursorBlinking",ue[ue.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ue[ue.cursorStyle=28]="cursorStyle",ue[ue.cursorSurroundingLines=29]="cursorSurroundingLines",ue[ue.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ue[ue.cursorWidth=31]="cursorWidth",ue[ue.disableLayerHinting=32]="disableLayerHinting",ue[ue.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ue[ue.domReadOnly=34]="domReadOnly",ue[ue.dragAndDrop=35]="dragAndDrop",ue[ue.dropIntoEditor=36]="dropIntoEditor",ue[ue.emptySelectionClipboard=37]="emptySelectionClipboard",ue[ue.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ue[ue.extraEditorClassName=39]="extraEditorClassName",ue[ue.fastScrollSensitivity=40]="fastScrollSensitivity",ue[ue.find=41]="find",ue[ue.fixedOverflowWidgets=42]="fixedOverflowWidgets",ue[ue.folding=43]="folding",ue[ue.foldingStrategy=44]="foldingStrategy",ue[ue.foldingHighlight=45]="foldingHighlight",ue[ue.foldingImportsByDefault=46]="foldingImportsByDefault",ue[ue.foldingMaximumRegions=47]="foldingMaximumRegions",ue[ue.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ue[ue.fontFamily=49]="fontFamily",ue[ue.fontInfo=50]="fontInfo",ue[ue.fontLigatures=51]="fontLigatures",ue[ue.fontSize=52]="fontSize",ue[ue.fontWeight=53]="fontWeight",ue[ue.fontVariations=54]="fontVariations",ue[ue.formatOnPaste=55]="formatOnPaste",ue[ue.formatOnType=56]="formatOnType",ue[ue.glyphMargin=57]="glyphMargin",ue[ue.gotoLocation=58]="gotoLocation",ue[ue.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ue[ue.hover=60]="hover",ue[ue.inDiffEditor=61]="inDiffEditor",ue[ue.inlineSuggest=62]="inlineSuggest",ue[ue.inlineEdit=63]="inlineEdit",ue[ue.letterSpacing=64]="letterSpacing",ue[ue.lightbulb=65]="lightbulb",ue[ue.lineDecorationsWidth=66]="lineDecorationsWidth",ue[ue.lineHeight=67]="lineHeight",ue[ue.lineNumbers=68]="lineNumbers",ue[ue.lineNumbersMinChars=69]="lineNumbersMinChars",ue[ue.linkedEditing=70]="linkedEditing",ue[ue.links=71]="links",ue[ue.matchBrackets=72]="matchBrackets",ue[ue.minimap=73]="minimap",ue[ue.mouseStyle=74]="mouseStyle",ue[ue.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ue[ue.mouseWheelZoom=76]="mouseWheelZoom",ue[ue.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ue[ue.multiCursorModifier=78]="multiCursorModifier",ue[ue.multiCursorPaste=79]="multiCursorPaste",ue[ue.multiCursorLimit=80]="multiCursorLimit",ue[ue.occurrencesHighlight=81]="occurrencesHighlight",ue[ue.overviewRulerBorder=82]="overviewRulerBorder",ue[ue.overviewRulerLanes=83]="overviewRulerLanes",ue[ue.padding=84]="padding",ue[ue.pasteAs=85]="pasteAs",ue[ue.parameterHints=86]="parameterHints",ue[ue.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ue[ue.placeholder=88]="placeholder",ue[ue.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ue[ue.quickSuggestions=90]="quickSuggestions",ue[ue.quickSuggestionsDelay=91]="quickSuggestionsDelay",ue[ue.readOnly=92]="readOnly",ue[ue.readOnlyMessage=93]="readOnlyMessage",ue[ue.renameOnType=94]="renameOnType",ue[ue.renderControlCharacters=95]="renderControlCharacters",ue[ue.renderFinalNewline=96]="renderFinalNewline",ue[ue.renderLineHighlight=97]="renderLineHighlight",ue[ue.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ue[ue.renderValidationDecorations=99]="renderValidationDecorations",ue[ue.renderWhitespace=100]="renderWhitespace",ue[ue.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ue[ue.roundedSelection=102]="roundedSelection",ue[ue.rulers=103]="rulers",ue[ue.scrollbar=104]="scrollbar",ue[ue.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ue[ue.scrollBeyondLastLine=106]="scrollBeyondLastLine",ue[ue.scrollPredominantAxis=107]="scrollPredominantAxis",ue[ue.selectionClipboard=108]="selectionClipboard",ue[ue.selectionHighlight=109]="selectionHighlight",ue[ue.selectOnLineNumbers=110]="selectOnLineNumbers",ue[ue.showFoldingControls=111]="showFoldingControls",ue[ue.showUnused=112]="showUnused",ue[ue.snippetSuggestions=113]="snippetSuggestions",ue[ue.smartSelect=114]="smartSelect",ue[ue.smoothScrolling=115]="smoothScrolling",ue[ue.stickyScroll=116]="stickyScroll",ue[ue.stickyTabStops=117]="stickyTabStops",ue[ue.stopRenderingLineAfter=118]="stopRenderingLineAfter",ue[ue.suggest=119]="suggest",ue[ue.suggestFontSize=120]="suggestFontSize",ue[ue.suggestLineHeight=121]="suggestLineHeight",ue[ue.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ue[ue.suggestSelection=123]="suggestSelection",ue[ue.tabCompletion=124]="tabCompletion",ue[ue.tabIndex=125]="tabIndex",ue[ue.unicodeHighlighting=126]="unicodeHighlighting",ue[ue.unusualLineTerminators=127]="unusualLineTerminators",ue[ue.useShadowDOM=128]="useShadowDOM",ue[ue.useTabStops=129]="useTabStops",ue[ue.wordBreak=130]="wordBreak",ue[ue.wordSegmenterLocales=131]="wordSegmenterLocales",ue[ue.wordSeparators=132]="wordSeparators",ue[ue.wordWrap=133]="wordWrap",ue[ue.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ue[ue.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ue[ue.wordWrapColumn=136]="wordWrapColumn",ue[ue.wordWrapOverride1=137]="wordWrapOverride1",ue[ue.wordWrapOverride2=138]="wordWrapOverride2",ue[ue.wrappingIndent=139]="wrappingIndent",ue[ue.wrappingStrategy=140]="wrappingStrategy",ue[ue.showDeprecated=141]="showDeprecated",ue[ue.inlayHints=142]="inlayHints",ue[ue.editorClassName=143]="editorClassName",ue[ue.pixelRatio=144]="pixelRatio",ue[ue.tabFocusMode=145]="tabFocusMode",ue[ue.layoutInfo=146]="layoutInfo",ue[ue.wrappingInfo=147]="wrappingInfo",ue[ue.defaultColorDecorators=148]="defaultColorDecorators",ue[ue.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ue[ue.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new s(je.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(11989,null)})),acceptSuggestionOnEnter:Ne(new E(je.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(11990,null),""],markdownDescription:c.localize(11991,null)})),accessibilitySupport:Ne(new k),accessibilityPageSize:Ne(new o(je.accessibilityPageSize,"accessibilityPageSize",10,1,O.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(11992,null),tags:["accessibility"]})),ariaLabel:Ne(new l(je.ariaLabel,"ariaLabel",c.localize(11993,null))),ariaRequired:Ne(new s(je.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ne(new s(je.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:c.localize(11994,null),tags:["accessibility"]})),autoClosingBrackets:Ne(new E(je.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(11995,null),c.localize(11996,null),""],description:c.localize(11997,null)})),autoClosingComments:Ne(new E(je.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(11998,null),c.localize(11999,null),""],description:c.localize(12e3,null)})),autoClosingDelete:Ne(new E(je.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(12001,null),""],description:c.localize(12002,null)})),autoClosingOvertype:Ne(new E(je.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(12003,null),""],description:c.localize(12004,null)})),autoClosingQuotes:Ne(new E(je.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(12005,null),c.localize(12006,null),""],description:c.localize(12007,null)})),autoIndent:Ne(new D(je.autoIndent,"autoIndent",S.Full,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[c.localize(12008,null),c.localize(12009,null),c.localize(12010,null),c.localize(12011,null),c.localize(12012,null)],description:c.localize(12013,null)})),automaticLayout:Ne(new s(je.automaticLayout,"automaticLayout",!1)),autoSurround:Ne(new E(je.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(12014,null),c.localize(12015,null),c.localize(12016,null),""],description:c.localize(12017,null)})),bracketPairColorization:Ne(new Le),bracketPairGuides:Ne(new He),stickyTabStops:Ne(new s(je.stickyTabStops,"stickyTabStops",!1,{description:c.localize(12018,null)})),codeLens:Ne(new s(je.codeLens,"codeLens",!0,{description:c.localize(12019,null)})),codeLensFontFamily:Ne(new l(je.codeLensFontFamily,"codeLensFontFamily","",{description:c.localize(12020,null)})),codeLensFontSize:Ne(new o(je.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(12021,null)})),colorDecorators:Ne(new s(je.colorDecorators,"colorDecorators",!0,{description:c.localize(12022,null)})),colorDecoratorActivatedOn:Ne(new E(je.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[c.localize(12023,null),c.localize(12024,null),c.localize(12025,null)],description:c.localize(12026,null)})),colorDecoratorsLimit:Ne(new o(je.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(12027,null)})),columnSelection:Ne(new s(je.columnSelection,"columnSelection",!1,{description:c.localize(12028,null)})),comments:Ne(new A),contextmenu:Ne(new s(je.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new s(je.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:c.localize(12029,null)})),cursorBlinking:Ne(new D(je.cursorBlinking,"cursorBlinking",b.Blink,"blink",["blink","smooth","phase","expand","solid"],v,{description:c.localize(12030,null)})),cursorSmoothCaretAnimation:Ne(new E(je.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(12031,null),c.localize(12032,null),c.localize(12033,null)],description:c.localize(12034,null)})),cursorStyle:Ne(new D(je.cursorStyle,"cursorStyle",F.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:c.localize(12035,null)})),cursorSurroundingLines:Ne(new o(je.cursorSurroundingLines,"cursorSurroundingLines",0,0,O.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(12036,null)})),cursorSurroundingLinesStyle:Ne(new E(je.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(12037,null),c.localize(12038,null)],markdownDescription:c.localize(12039,null)})),cursorWidth:Ne(new o(je.cursorWidth,"cursorWidth",0,0,O.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(12040,null)})),disableLayerHinting:Ne(new s(je.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new s(je.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new s(je.domReadOnly,"domReadOnly",!1)),dragAndDrop:Ne(new s(je.dragAndDrop,"dragAndDrop",!0,{description:c.localize(12041,null)})),emptySelectionClipboard:Ne(new z),dropIntoEditor:Ne(new dt),stickyScroll:Ne(new U),experimentalWhitespaceRendering:Ne(new E(je.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(12042,null),c.localize(12043,null),c.localize(12044,null)],description:c.localize(12045,null)})),extraEditorClassName:Ne(new l(je.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Ne(new d(je.fastScrollSensitivity,"fastScrollSensitivity",5,ue=>ue<=0?5:ue,{markdownDescription:c.localize(12046,null)})),find:Ne(new j),fixedOverflowWidgets:Ne(new s(je.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Ne(new s(je.folding,"folding",!0,{description:c.localize(12047,null)})),foldingStrategy:Ne(new E(je.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(12048,null),c.localize(12049,null)],description:c.localize(12050,null)})),foldingHighlight:Ne(new s(je.foldingHighlight,"foldingHighlight",!0,{description:c.localize(12051,null)})),foldingImportsByDefault:Ne(new s(je.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:c.localize(12052,null)})),foldingMaximumRegions:Ne(new o(je.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(12053,null)})),unfoldOnClickAfterEndOfLine:Ne(new s(je.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(12054,null)})),fontFamily:Ne(new l(je.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(12055,null)})),fontInfo:Ne(new ee),fontLigatures2:Ne(new W),fontSize:Ne(new H),fontWeight:Ne(new q),fontVariations:Ne(new B),formatOnPaste:Ne(new s(je.formatOnPaste,"formatOnPaste",!1,{description:c.localize(12056,null)})),formatOnType:Ne(new s(je.formatOnType,"formatOnType",!1,{description:c.localize(12057,null)})),glyphMargin:Ne(new s(je.glyphMargin,"glyphMargin",!0,{description:c.localize(12058,null)})),gotoLocation:Ne(new Q),hideCursorInOverviewRuler:Ne(new s(je.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:c.localize(12059,null)})),hover:Ne(new _),inDiffEditor:Ne(new s(je.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Ne(new d(je.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ue=>d.clamp(ue,-5,20),{description:c.localize(12060,null)})),lightbulb:Ne(new Y),lineDecorationsWidth:Ne(new ve),lineHeight:Ne(new te),lineNumbers:Ne(new Re),lineNumbersMinChars:Ne(new o(je.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new s(je.linkedEditing,"linkedEditing",!1,{description:c.localize(12061,null)})),links:Ne(new s(je.links,"links",!0,{description:c.localize(12062,null)})),matchBrackets:Ne(new E(je.matchBrackets,"matchBrackets","always",["always","near","never"],{description:c.localize(12063,null)})),minimap:Ne(new ae),mouseStyle:Ne(new E(je.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new d(je.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ue=>ue===0?1:ue,{markdownDescription:c.localize(12064,null)})),mouseWheelZoom:Ne(new s(je.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:C.$k?c.localize(12065,null):c.localize(12066,null)})),multiCursorMergeOverlapping:Ne(new s(je.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:c.localize(12067,null)})),multiCursorModifier:Ne(new D(je.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],se,{markdownEnumDescriptions:[c.localize(12068,null),c.localize(12069,null)],markdownDescription:c.localize(12070,null)})),multiCursorPaste:Ne(new E(je.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(12071,null),c.localize(12072,null)],markdownDescription:c.localize(12073,null)})),multiCursorLimit:Ne(new o(je.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(12074,null)})),occurrencesHighlight:Ne(new E(je.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[c.localize(12075,null),c.localize(12076,null),c.localize(12077,null)],markdownDescription:c.localize(12078,null)})),overviewRulerBorder:Ne(new s(je.overviewRulerBorder,"overviewRulerBorder",!0,{description:c.localize(12079,null)})),overviewRulerLanes:Ne(new o(je.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Ne(new X),pasteAs:Ne(new ct),parameterHints:Ne(new re),peekWidgetDefaultFocus:Ne(new E(je.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(12080,null),c.localize(12081,null)],description:c.localize(12082,null)})),placeholder:Ne(new we),definitionLinkOpensInPeek:Ne(new s(je.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:c.localize(12083,null)})),quickSuggestions:Ne(new Fe),quickSuggestionsDelay:Ne(new o(je.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,O.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(12084,null)})),readOnly:Ne(new s(je.readOnly,"readOnly",!1)),readOnlyMessage:Ne(new V),renameOnType:Ne(new s(je.renameOnType,"renameOnType",!1,{description:c.localize(12085,null),markdownDeprecationMessage:c.localize(12086,null)})),renderControlCharacters:Ne(new s(je.renderControlCharacters,"renderControlCharacters",!0,{description:c.localize(12087,null),restricted:!0})),renderFinalNewline:Ne(new E(je.renderFinalNewline,"renderFinalNewline",C.$l?"dimmed":"on",["off","on","dimmed"],{description:c.localize(12088,null)})),renderLineHighlight:Ne(new E(je.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(12089,null)],description:c.localize(12090,null)})),renderLineHighlightOnlyWhenFocus:Ne(new s(je.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(12091,null)})),renderValidationDecorations:Ne(new E(je.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new E(je.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(12092,null),c.localize(12093,null),c.localize(12094,null),""],description:c.localize(12095,null)})),revealHorizontalRightPadding:Ne(new o(je.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new s(je.roundedSelection,"roundedSelection",!0,{description:c.localize(12096,null)})),rulers:Ne(new Ce),scrollbar:Ne(new J),scrollBeyondLastColumn:Ne(new o(je.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,O.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(12097,null)})),scrollBeyondLastLine:Ne(new s(je.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:c.localize(12098,null)})),scrollPredominantAxis:Ne(new s(je.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:c.localize(12099,null)})),selectionClipboard:Ne(new s(je.selectionClipboard,"selectionClipboard",!0,{description:c.localize(12100,null),included:C.$l})),selectionHighlight:Ne(new s(je.selectionHighlight,"selectionHighlight",!0,{description:c.localize(12101,null)})),selectOnLineNumbers:Ne(new s(je.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new E(je.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(12102,null),c.localize(12103,null),c.localize(12104,null)],description:c.localize(12105,null)})),showUnused:Ne(new s(je.showUnused,"showUnused",!0,{description:c.localize(12106,null)})),showDeprecated:Ne(new s(je.showDeprecated,"showDeprecated",!0,{description:c.localize(12107,null)})),inlayHints:Ne(new oe),snippetSuggestions:Ne(new E(je.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(12108,null),c.localize(12109,null),c.localize(12110,null),c.localize(12111,null)],description:c.localize(12112,null)})),smartSelect:Ne(new nt),smoothScrolling:Ne(new s(je.smoothScrolling,"smoothScrolling",!1,{description:c.localize(12113,null)})),stopRenderingLineAfter:Ne(new o(je.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,O.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Ne(new et),inlineSuggest:Ne(new de),inlineEdit:Ne(new Ee),inlineCompletionsAccessibilityVerbose:Ne(new s(je.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:c.localize(12114,null)})),suggestFontSize:Ne(new o(je.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(12115,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new o(je.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(12116,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new s(je.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:c.localize(12117,null)})),suggestSelection:Ne(new E(je.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(12118,null),c.localize(12119,null),c.localize(12120,null)],description:c.localize(12121,null)})),tabCompletion:Ne(new E(je.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(12122,null),c.localize(12123,null),c.localize(12124,null)],description:c.localize(12125,null)})),tabIndex:Ne(new o(je.tabIndex,"tabIndex",0,-1,O.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Ne(new x),unusualLineTerminators:Ne(new E(je.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(12126,null),c.localize(12127,null),c.localize(12128,null)],description:c.localize(12129,null)})),useShadowDOM:Ne(new s(je.useShadowDOM,"useShadowDOM",!0)),useTabStops:Ne(new s(je.useTabStops,"useTabStops",!0,{description:c.localize(12130,null)})),wordBreak:Ne(new E(je.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(12131,null),c.localize(12132,null)],description:c.localize(12133,null)})),wordSegmenterLocales:Ne(new st),wordSeparators:Ne(new l(je.wordSeparators,"wordSeparators",p.$mt,{description:c.localize(12134,null)})),wordWrap:Ne(new E(je.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(12135,null),c.localize(12136,null),c.localize(12137,null),c.localize(12138,null)],description:c.localize(12139,null)})),wordWrapBreakAfterCharacters:Ne(new l(je.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new l(je.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new o(je.wordWrapColumn,"wordWrapColumn",80,1,O.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(12140,null)})),wordWrapOverride1:Ne(new E(je.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new E(je.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ne(new M),defaultColorDecorators:Ne(new s(je.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:c.localize(12141,null)})),pixelRatio:Ne(new pe),tabFocusMode:Ne(new s(je.tabFocusMode,"tabFocusMode",!1,{markdownDescription:c.localize(12142,null)})),layoutInfo:Ne(new ne),wrappingInfo:Ne(new gt),wrappingIndent:Ne(new at),wrappingStrategy:Ne(new ye)}});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[216],Ie([1,0,22,43,8,5,107,10,24]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$_w=e.$$w=e.$0w=void 0,e.$ax=P,e.$bx=w,h=Ut(h),e.$0w=(0,R.$Fi)("dialogService");var c;(function(a){a[a.Confirmation=1]="Confirmation",a[a.Prompt=2]="Prompt",a[a.Input=3]="Input"})(c||(c={}));class I{a(m){return this.d(m,c.Confirmation)}b(m){return this.d(m,c.Prompt)}c(m){return this.d(m,c.Input)}d(m,$){const f=[];switch($){case c.Confirmation:{const i=m;i.primaryButton?f.push(i.primaryButton):f.push((0,C.localize)(11576,null)),i.cancelButton?f.push(i.cancelButton):f.push((0,C.localize)(11577,null));break}case c.Prompt:{const i=m;Array.isArray(i.buttons)&&i.buttons.length>0&&f.push(...i.buttons.map(s=>s.label)),i.cancelButton&&(i.cancelButton===!0?f.push((0,C.localize)(11578,null)):typeof i.cancelButton=="string"?f.push(i.cancelButton):i.cancelButton.label?f.push(i.cancelButton.label):f.push((0,C.localize)(11579,null))),f.length===0&&f.push((0,C.localize)(11580,null));break}case c.Input:{const i=m;i.primaryButton?f.push(i.primaryButton):f.push((0,C.localize)(11581,null)),i.cancelButton?f.push(i.cancelButton):f.push((0,C.localize)(11582,null));break}}return f}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===h.default.Info?"info":m===h.default.Error?"error":m===h.default.Warning?"warning":"none"}f(m,$,f){const i=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&i.push(m.cancelButton);let s=i[$]?.run({checkboxChecked:f});return s instanceof Promise||(s=Promise.resolve(s)),{result:s,checkboxChecked:f}}}e.$$w=I,e.$_w=(0,R.$Fi)("fileDialogService");var S;(function(a){a[a.SAVE=0]="SAVE",a[a.DONT_SAVE=1]="DONT_SAVE",a[a.CANCEL=2]="CANCEL"})(S||(e.ConfirmResult=S={}));const u=10;function P(a){const m=[];return m.push(...a.slice(0,u).map($=>typeof $=="string"?$:(0,r.$dh)($))),a.length>u&&(a.length-u===1?m.push((0,C.localize)(11583,null)):m.push((0,C.localize)(11584,null,a.length-u))),m.push(""),m.join(`
`)}function w(a,m){const $=(0,p.$eo)(a);let f=($.buttons??[]).map(o=>(0,O.$7w)(o)),i=(a.buttons||[]).map((o,n)=>n),s=0,t=$.cancelId??f.length-1;if(f.length>1){const o=typeof t=="number"?f[t]:void 0;if(T.$l||T.$k){if(typeof o=="string"&&f.length>1&&t!==1){f.splice(t,1),f.splice(1,0,o);const n=i[t];i.splice(t,1),i.splice(1,0,n),t=1}T.$l&&f.length>1&&(f=f.reverse(),i=i.reverse(),s=f.length-1,typeof o=="string"&&(t=s-1))}else if(T.$j&&typeof o=="string"&&f.length>1&&t!==f.length-1){f.splice(t,1),f.push(o);const n=i[t];i.splice(t,1),i.push(n),t=f.length-1}}return $.buttons=f,$.defaultId=s,$.cancelId=t,$.noLink=!0,$.title=$.title||m.nameLong,{options:$,buttonIndeces:i}}}),define(ke[144],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=void 0,e.$Mi=(0,r.$Fi)("environmentService"),e.$Ni=(0,r.$Gi)(e.$Mi)}),define(ke[217],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M0b=e.$L0b=void 0,e.$L0b=(0,r.$Fi)("externalTerminal"),e.$M0b="Terminal.app"}),define(ke[218],Ie([1,0,56,59,14,16,10,104,33,109,8,217]),function($e,e,r,h,C,R,O,T,p,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=e.$Dgc=e.$Cgc=void 0,r=qe(r),R=qe(R),O=qe(O),p=qe(p),c=qe(c),I=qe(I);const u=I.localize(11426,null);class P{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends P{static{this.b="cmd.exe"}openTerminal(t,o){return this.spawnTerminal(r,t,c.$ym(),o)}spawnTerminal(t,o,n,d){const l=o.windowsExec||w.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const g=R.$nc(l,".exe").toLowerCase();if(g==="cmder")return t.spawn(l,d?[d]:void 0),Promise.resolve(void 0);const E=["/c","start","/wait"];return l.indexOf(" ")>=0&&E.push(l),E.push(l),g==="wt"&&E.push("-d ."),new Promise((D,y)=>{const k=$(process),A=t.spawn(n,E,{cwd:d,env:k,detached:!0});A.on("error",y),A.on("exit",()=>D())})}async runInTerminal(t,o,n,d,l){const g="windowsExec"in l&&l.windowsExec?l.windowsExec:w.getDefaultTerminalWindows(),E=await w.f();return new Promise((D,y)=>{const k=`"${o} - ${u}"`,A=`"${n.join('" "')}" & pause`,b=Object.assign({},$(process),d);Object.keys(b).filter(M=>b[M]===null).forEach(M=>delete b[M]);const v={cwd:o,env:b,windowsVerbatimArguments:!0};let F,N;R.$nc(g,".exe")==="wt"?(F=g,N=["-d",".",w.b,"/c",A]):E?(F=E,N=["-d",".",g,"/c",A]):(F=w.b,N=["/c","start",k,"/wait",g,"/c",`"${A}"`]),r.spawn(F,N,v).on("error",M=>{y(f(M))}),D(void 0)})}static getDefaultTerminalWindows(){if(!w.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return w.d}static async f(){try{const t=await c.win32.findExecutable("wt");return await p.Promises.exists(t)?t:void 0}catch{return}}}e.$Cgc=w,Je([h.$0h],w,"f",null);class a extends P{static{this.b="/usr/bin/osascript"}openTerminal(t,o){return this.spawnTerminal(r,t,o)}runInTerminal(t,o,n,d,l){const g=l.osxExec||S.$M0b;return new Promise((E,D)=>{if(g===S.$M0b||g==="iTerm.app"){const y=g===S.$M0b?"TerminalHelper":"iTermHelper",A=[C.$Zg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",t||u,"-w",o];for(const F of n)A.push("-a"),A.push(F);if(d){const F=Object.assign({},$(process),d);for(const N in F){const L=F[N];L===null?(A.push("-u"),A.push(N)):(A.push("-e"),A.push(`${N}=${L}`))}}let b="";const v=r.spawn(a.b,A);v.on("error",F=>{D(f(F))}),v.stderr.on("data",F=>{b+=F.toString()}),v.on("exit",F=>{if(F===0)E(void 0);else if(b){const N=b.split(`
`,1);D(new Error(N[0]))}else D(new Error(I.localize(11427,null,y,F)))})}else D(new Error(I.localize(11428,null,g)))})}spawnTerminal(t,o,n){const d=o.osxExec||S.$M0b;return new Promise((l,g)=>{const E=["-a",d];n&&E.push(n);const D=$(process),y=t.spawn("/usr/bin/open",E,{cwd:n,env:D});y.on("error",g),y.on("exit",()=>l())})}}e.$Dgc=a;class m extends P{static{this.b=I.localize(11429,null)}openTerminal(t,o){return this.spawnTerminal(r,t,o)}runInTerminal(t,o,n,d,l){const g=l.linuxExec?Promise.resolve(l.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((E,D)=>{const y=[];g.then(k=>{k.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const A=`${i(n)}; echo; read -p "${m.b}" -n1;`;y.push(`''${A}''`);const b=Object.assign({},$(process),d);Object.keys(b).filter(L=>b[L]===null).forEach(L=>delete b[L]);const v={cwd:o,env:b};let F="";const N=r.spawn(k,y,v);N.on("error",L=>{D(f(L))}),N.stderr.on("data",L=>{F+=L.toString()}),N.on("exit",L=>{if(L===0)E(void 0);else if(F){const M=F.split(`
`,1);D(new Error(M[0]))}else D(new Error(I.localize(11430,null,k,L)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!O.$l)m.d=Promise.resolve("xterm");else{const t=await p.Promises.exists("/etc/debian_version");m.d=new Promise(o=>{t?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm")})}return m.d}spawnTerminal(t,o,n){const d=o.linuxExec?Promise.resolve(o.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((l,g)=>{d.then(E=>{const D=$(process),y=t.spawn(E,[],{cwd:n,env:D});y.on("error",g),y.on("exit",()=>l())})})}}e.$Egc=m;function $(s){const t={...s.env};return(0,T.$lm)(t),t}function f(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(I.localize(11431,null,s.path)):s}function i(s){let t="";for(const o of s)o.indexOf(" ")>=0?t+='"'+o+'"':t+=o,t+=" ";return t}}),define(ke[27],Ie([1,0,84,16,12,17,2,8,5,10,14,50]),function($e,e,r,h,C,R,O,T,p,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Fl=e.FileKind=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.FileOperationResult=e.$xl=e.$wl=e.$vl=e.$tl=e.FileChangeType=e.$sl=e.FileOperation=e.$ml=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$al=void 0,e.$bl=u,e.$cl=m,e.$dl=f,e.$el=i,e.$fl=s,e.$gl=t,e.$hl=o,e.$il=n,e.$jl=d,e.$kl=l,e.$ll=g,e.$nl=y,e.$ol=k,e.$pl=A,e.$ql=b,e.$rl=v,e.$ul=z,e.$Gl=q,e.$Hl=Q,e.$Jl=ce,e.$al=(0,p.$Fi)("fileService");function u(ne){return ne.create===!0}var P;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(P||(e.FileType=P={}));var w;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(w||(e.FilePermission=w={}));var a;(function(ne){ne[ne.UPDATED=2]="UPDATED",ne[ne.ADDED=4]="ADDED",ne[ne.DELETED=8]="DELETED"})(a||(e.FileChangeFilter=a={}));function m(ne){const ye=ne;return!!ye&&typeof ye.onDidChange=="function"}var $;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function f(ne){return!!(ne.capabilities&$.FileReadWrite)}function i(ne){return!!(ne.capabilities&$.FileFolderCopy)}function s(ne){return!!(ne.capabilities&$.FileClone)}function t(ne){return!!(ne.capabilities&$.FileOpenReadWriteClose)}function o(ne){return!!(ne.capabilities&$.FileReadStream)}function n(ne){return f(ne)?!!(ne.capabilities&$.FileAtomicRead):!1}function d(ne){return f(ne)?!!(ne.capabilities&$.FileAtomicWrite):!1}function l(ne){return!!(ne.capabilities&$.FileAtomicDelete)}function g(ne){return!!(ne.capabilities&$.Readonly)}var E;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class D extends Error{static create(ye,ge){const Y=new D(ye.toString(),ge);return A(Y,ge),Y}constructor(ye,ge){super(ye),this.code=ge}}e.$ml=D;function y(ne,ye){return D.create(ne,ye)}function k(ne){return ne||y((0,T.localize)(11385,null),E.Unknown)}function A(ne,ye){return ne.name=ye?`${ye} (FileSystemError)`:"FileSystemError",ne}function b(ne){if(!ne)return E.Unknown;if(ne instanceof D)return ne.code;const ye=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!ye)return E.Unknown;switch(ye[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}function v(ne){if(ne instanceof j)return ne.fileOperationResult;switch(b(ne)){case E.FileNotFound:return ee.FILE_NOT_FOUND;case E.FileIsADirectory:return ee.FILE_IS_DIRECTORY;case E.FileNotADirectory:return ee.FILE_NOT_DIRECTORY;case E.FileWriteLocked:return ee.FILE_WRITE_LOCKED;case E.NoPermissions:return ee.FILE_PERMISSION_DENIED;case E.FileExists:return ee.FILE_MOVE_CONFLICT;case E.FileTooLarge:return ee.FILE_TOO_LARGE;default:return ee.FILE_OTHER_ERROR}}var F;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class N{constructor(ye,ge,Y){this.resource=ye,this.operation=ge,this.target=Y}isOperation(ye){return this.operation===ye}}e.$sl=N;var L;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class M{static{this.a=null}constructor(ye,ge){this.c=ge,this.b=void 0,this.d=new S.$T(()=>{const Y=r.$Li.forUris(()=>this.c);return Y.fill(this.rawAdded.map(U=>[U,!0])),Y}),this.f=new S.$T(()=>{const Y=r.$Li.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(U=>[U,!0])),Y}),this.g=new S.$T(()=>{const Y=r.$Li.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(U=>[U,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of ye){switch(Y.type){case L.ADDED:this.rawAdded.push(Y.resource);break;case L.UPDATED:this.rawUpdated.push(Y.resource);break;case L.DELETED:this.rawDeleted.push(Y.resource);break}this.b!==M.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(ye,...ge){return this.h(ye,{includeChildren:!1},...ge)}affects(ye,...ge){return this.h(ye,{includeChildren:!0},...ge)}h(ye,ge,...Y){if(!ye)return!1;const U=Y.length>0;return!!((!U||Y.includes(L.ADDED))&&(this.d.value.get(ye)||ge.includeChildren&&this.d.value.findSuperstr(ye))||(!U||Y.includes(L.UPDATED))&&(this.f.value.get(ye)||ge.includeChildren&&this.f.value.findSuperstr(ye))||(!U||Y.includes(L.DELETED))&&(this.g.value.findSubstr(ye)||ge.includeChildren&&this.g.value.findSuperstr(ye)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ye){return this.b===ye}hasCorrelation(){return typeof this.b=="number"}}e.$tl=M;function z(ne,ye,ge){return!ne||!ye||ne===ye||ye.length>ne.length?!1:(ye.charAt(ye.length-1)!==h.sep&&(ye+=h.sep),ge?(0,C.$Gf)(ne,ye):ne.indexOf(ye)===0)}class j extends Error{constructor(ye,ge,Y){super(ye),this.fileOperationResult=ge,this.options=Y}}e.$vl=j;class W extends j{constructor(ye,ge,Y,U){super(ye,ge,U),this.fileOperationResult=ge,this.size=Y}}e.$wl=W;class B extends j{constructor(ye,ge,Y){super(ye,ee.FILE_NOT_MODIFIED_SINCE,Y),this.stat=ge}}e.$xl=B;var ee;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ee||(e.FileOperationResult=ee={})),e.$yl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$zl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Al="files.associations",e.$Bl="files.exclude",e.$Cl="files.readonlyInclude",e.$Dl="files.readonlyExclude",e.$El="files.readonlyFromPermissions";var H;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(H||(e.FileKind=H={})),e.$Fl="";function q(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}async function Q(ne,ye){if(!ye.hasProvider(O.URI.from({scheme:ne.scheme})))return new Promise(ge=>{const Y=ye.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===ne.scheme&&U.added&&(Y.dispose(),ge())})})}class _{static{this.KB=1024}static{this.MB=_.KB*_.KB}static{this.GB=_.MB*_.KB}static{this.TB=_.GB*_.KB}static formatSize(ye){return(0,R.$ig)(ye)||(ye=0),ye<_.KB?(0,T.localize)(11386,null,ye.toFixed(0)):ye<_.MB?(0,T.localize)(11387,null,(ye/_.KB).toFixed(2)):ye<_.GB?(0,T.localize)(11388,null,(ye/_.MB).toFixed(2)):ye<_.TB?(0,T.localize)(11389,null,(ye/_.GB).toFixed(2)):(0,T.localize)(11390,null,(ye/_.TB).toFixed(2))}}e.$Il=_;function ce(ne){const ye=typeof ne=="string"||ne?.scheme===I.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===I.Schemas.file?1024*_.MB:ye?10*_.MB:c.$p?50*_.MB:1024*_.MB}}),define(ke[219],Ie([1,0,21,13,8,27]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=O;async function O(I,S,u,P,w,a){let m;try{await T(I,S,u,P,w,a)}catch($){m=$}finally{m&&w.errorTransformer&&(m=w.errorTransformer(m)),typeof m<"u"&&u.error(m),u.end()}}async function T(I,S,u,P,w,a){p(a);const m=await I.open(S,{create:!1});try{p(a);let $=0,f=0,i=w&&typeof w.length=="number"?w.length:void 0,s=r.$Ne.alloc(Math.min(w.bufferSize,typeof i=="number"?i:w.bufferSize)),t=w&&typeof w.position=="number"?w.position:0,o=0;do f=await I.read(m,t,s.buffer,o,s.byteLength-o),t+=f,o+=f,$+=f,typeof i=="number"&&(i-=f),o===s.byteLength&&(await u.write(P(s)),s=r.$Ne.alloc(Math.min(w.bufferSize,typeof i=="number"?i:w.bufferSize)),o=0);while(f>0&&(typeof i!="number"||i>0)&&p(a)&&c($,w));if(o>0){let n=o;typeof i=="number"&&(n=Math.min(o,i)),u.write(P(s.slice(0,n)))}}catch($){throw(0,R.$ol)($)}finally{await I.close(m)}}function p(I){if(I.isCancellationRequested)throw(0,h.$5)();return!0}function c(I,S){if(typeof S?.limits?.size=="number"&&I>S.limits.size)throw(0,R.$nl)((0,C.localize)(11384,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[69],Ie([1,0,38,3,16,10,2,27]),function($e,e,r,h,C,R,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=e.$6q=void 0,e.$4q=p,e.$5q=c,e.$9q=P,e.$0q=w,e.$$q=a,e.$_q=m,e.$ar=f,e.$br=i;function p(s){return typeof s.correlationId=="number"}function c(s){return s.recursive===!0}class I extends h.$Uc{static{this.a=5}constructor(t,o,n,d){super(),this.h=t,this.j=o,this.m=n,this.n=d,this.c=this.B(new h.$Vc),this.f=void 0,this.g=0}s(){const t=new h.$Tc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(o=>this.h(o))),t.add(this.b.onDidLogMessage(o=>this.j(o))),t.add(this.b.onDidError(o=>this.t(o.error,o.request)))}t(t,o){this.u(t,o)?this.g<I.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,o){return!(!this.n.restartOnError||o||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$6q=I;class S extends I{constructor(t,o,n){super(t,o,n,{type:"node.js",restartOnError:!1})}}e.$7q=S;class u extends I{constructor(t,o,n){super(t,o,n,{type:"universal",restartOnError:!0})}}e.$8q=u;function P(s){return s.map(t=>({type:t.type,resource:O.URI.revive(t.resource),cId:t.cId}))}function w(s){const t=new $;for(const o of s)t.processEvent(o);return t.coalesce()}function a(s,t){return typeof t=="string"&&!t.startsWith(r.$wk)&&!(0,C.$ic)(t)?{base:s,pattern:t}:t}function m(s,t){const o=[];for(const n of t)o.push((0,r.$Ak)(a(s,n)));return o}class ${constructor(){this.a=new Set,this.b=new Map}c(t){return R.$l?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const o=this.b.get(this.c(t));let n=!1;if(o){const d=o.type,l=t.type;o.resource.fsPath!==t.resource.fsPath&&(t.type===T.FileChangeType.DELETED||t.type===T.FileChangeType.ADDED)?n=!0:d===T.FileChangeType.ADDED&&l===T.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(o)):d===T.FileChangeType.DELETED&&l===T.FileChangeType.ADDED?o.type=T.FileChangeType.UPDATED:d===T.FileChangeType.ADDED&&l===T.FileChangeType.UPDATED||(o.type=l)}else n=!0;n&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],o=[];return Array.from(this.a).filter(n=>n.type!==T.FileChangeType.DELETED?(t.push(n),!1):!0).sort((n,d)=>n.resource.fsPath.length-d.resource.fsPath.length).filter(n=>o.some(d=>(0,T.$ul)(n.resource.fsPath,d,!R.$l))?!1:(o.push(n.resource.fsPath),!0)).concat(t)}}function f(s,t){if(typeof t=="number")switch(s.type){case T.FileChangeType.ADDED:return(t&T.FileChangeFilter.ADDED)===0;case T.FileChangeType.DELETED:return(t&T.FileChangeFilter.DELETED)===0;case T.FileChangeType.UPDATED:return(t&T.FileChangeFilter.UPDATED)===0}return!1}function i(s){if(typeof s=="number"){const t=[];return s&T.FileChangeFilter.ADDED&&t.push("Added"),s&T.FileChangeFilter.DELETED&&t.push("Deleted"),s&T.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(ke[220],Ie([1,0,45,3,69,4,27,2,7]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class c extends h.$Uc{constructor(){super(),this.a=this.B(new R.$le),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$le),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$le),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new h.$4c),this.m=new Set,this.n=this.B(new p.$Dh(this.y())),this.r=5007,this.s=new p.$3h,this.R=!1,this.B(this.f(S=>this.t(S)))}t(S){this.u(S)&&this.z(S)}u(S){return(0,C.$4q)(S)}async watch(S){this.s.isSettled||this.s.complete(),this.s=new p.$3h;try{this.h.clear(),this.g.clear();for(const u of S)this.u(u)?this.h.set(u.correlationId,u):this.g.add(u);for(const[u]of this.j)this.h.has(u)||(this.j.deleteAndDispose(u),this.m.delete(u));return await this.w(!1)}finally{this.s.complete()}}w(S){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(u=>!this.j.has(u.correlationId))]),S?this.y():0)}y(){return 800}isSuspended(S){return typeof S.correlationId!="number"?!1:this.m.has(S.correlationId)?"polling":this.j.has(S.correlationId)}async z(S){if(this.j.has(S.correlationId))return;const u=new h.$Tc;this.j.set(S.correlationId,u),await this.s.p,!u.isDisposed&&(this.D(S,u),this.w(!0))}C(S){this.j.deleteAndDispose(S.correlationId),this.m.delete(S.correlationId),this.w(!1)}D(S,u){this.F(S,u)?(this.P(`reusing an existing recursive watcher to monitor ${S.path}`),this.m.delete(S.correlationId)):(this.G(S,u),this.m.add(S.correlationId))}F(S,u){const P=this.O?.subscribe(S.path,(w,a)=>{u.isDisposed||(w?this.D(S,u):a?.type===O.FileChangeType.ADDED&&this.H(S))});return P?(u.add(P),!0):!1}G(S,u){let P=!1;const w=(a,m)=>{if(u.isDisposed)return;const $=this.I(a),f=this.I(m),i=P;P=$,!$&&(f||i)&&this.H(S)};this.P(`starting fs.watchFile() on ${S.path} (correlationId: ${S.correlationId})`);try{(0,r.watchFile)(S.path,{persistent:!1,interval:this.r},w)}catch(a){this.Q(`fs.watchFile() failed with error ${a} on path ${S.path} (correlationId: ${S.correlationId})`)}u.add((0,h.$Sc)(()=>{this.P(`stopping fs.watchFile() on ${S.path} (correlationId: ${S.correlationId})`);try{(0,r.unwatchFile)(S.path,w)}catch(a){this.Q(`fs.unwatchFile() failed with error ${a} on path ${S.path} (correlationId: ${S.correlationId})`)}}))}H(S){this.P(`detected ${S.path} exists again, resuming watcher (correlationId: ${S.correlationId})`);const u={resource:T.URI.file(S.path),type:O.FileChangeType.ADDED,cId:S.correlationId};this.a.fire([u]),this.J(u,S),this.C(S)}I(S){return S.ctimeMs===0&&S.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(S,u){if(this.R){const P=` >> normalized ${S.type===O.FileChangeType.ADDED?"[ADDED]":S.type===O.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${S.resource.fsPath}`;this.L(P,u)}}L(S,u){this.R&&this.P(`${S}${typeof u.correlationId=="number"?` <${u.correlationId}> `:""}`)}M(S){return`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"}, filter: ${(0,C.$br)(S.filter)}, correlationId: ${typeof S.correlationId=="number"?S.correlationId:"<none>"})`}async setVerboseLogging(S){this.R=S}}e.$kr=c}),define(ke[221],Ie([1,0,45,7,20,31,3,81,16,10,22,2,108,33,27,69]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0,e.$qr=$;class m extends O.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(i,s,t,o,n,d){super(),this.s=i,this.t=s,this.u=t,this.w=o,this.y=n,this.z=d,this.c=this.B(new h.$Uh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.u(l))),this.f=this.B(new h.$Th(l=>this.M(l),m.b)),this.g=(0,a.$_q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,a.$_q)(this.s.path,this.s.includes):void 0,this.j=(0,a.$4q)(this.s)?this.s.filter:void 0,this.m=new C.$we,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const i=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const s=await r.promises.stat(i);if(this.m.token.isCancellationRequested)return;this.B(await this.G(i,s.isDirectory()))}catch(i){i.code!=="ENOENT"?this.O(i):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${i})`),this.D()}}D(){this.r=!0,this.w?.()}async F(i){let s=i.path;try{s=await P.Promises.realpath(i.path),i.path===s&&(s=await(0,u.$mr)(i.path,this.m.token)??i.path),i.path!==s&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${s})`)}catch{}return s}async G(i,s){const t=new O.$Tc;return this.H(i,s,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(i,s,t)),t}H(i,s,t){if(s)return!1;const o=S.URI.file(this.s.path),n=this.t?.subscribe(this.s.path,async(d,l)=>{if(!t.isDisposed)if(d){const g=await this.G(i,s);t.isDisposed?g.dispose():t.add(g)}else l&&(typeof l.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:o,type:l.type,cId:this.s.correlationId},!0)});return n?(t.add(n),!0):!1}async I(i,s,t){if(c.$k&&(0,R.$Eg)(i,"/Volumes/",!0)){this.O(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const o=new C.$we(this.m.token);t.add((0,O.$Sc)(()=>o.dispose(!0)));const n=new O.$Tc;t.add(n);try{const d=S.URI.file(this.s.path),l=(0,p.$nc)(i),g=(0,r.watch)(i);n.add((0,O.$Sc)(()=>{g.removeAllListeners(),g.close()})),this.Q(`Started watching: '${i}'`);const E=new Set;if(s)try{for(const y of await P.Promises.readdir(i))E.add(y)}catch(y){this.O(y)}if(o.token.isCancellationRequested)return;const D=new Map;n.add((0,O.$Sc)(()=>{for(const[,y]of D)y.dispose();D.clear()})),g.on("error",(y,k)=>{o.token.isCancellationRequested||(this.O(`Failed to watch ${i} for changes using fs.watch() (${y}, ${k})`),this.D())}),g.on("change",(y,k)=>{if(o.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${y}"] ${k}`);let A="";if(k&&(A=k.toString(),c.$k&&(A=(0,T.$nm)(A))),!(!A||y!=="change"&&y!=="rename"))if(s)if(y==="rename"){D.get(A)?.dispose();const b=setTimeout(async()=>{if(D.delete(A),A===l&&!await P.Promises.exists(i)){this.J(d);return}if(o.token.isCancellationRequested)return;const v=await this.N((0,p.$jc)(i,A));if(o.token.isCancellationRequested)return;let F;v?E.has(A)?F=w.FileChangeType.UPDATED:(F=w.FileChangeType.ADDED,E.add(A)):(E.delete(A),F=w.FileChangeType.DELETED),this.L({resource:(0,I.$gh)(d,A),type:F,cId:this.s.correlationId})},m.a);D.set(A,(0,O.$Sc)(()=>clearTimeout(b)))}else{let b;E.has(A)?b=w.FileChangeType.UPDATED:(b=w.FileChangeType.ADDED,E.add(A)),this.L({resource:(0,I.$gh)(d,A),type:b,cId:this.s.correlationId})}else if(y==="rename"||A!==l){const b=setTimeout(async()=>{const v=await P.Promises.exists(i);o.token.isCancellationRequested||(v?(this.L({resource:d,type:w.FileChangeType.UPDATED,cId:this.s.correlationId},!0),n.add(await this.G(i,!1))):this.J(d))},m.a);n.clear(),n.add((0,O.$Sc)(()=>clearTimeout(b)))}else this.L({resource:d,type:w.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(d){o.token.isCancellationRequested||this.O(`Failed to watch ${i} for changes using fs.watch() (${d.toString()})`),this.D()}}J(i){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:i,type:w.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(i,s=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${i.type===w.FileChangeType.ADDED?"[ADDED]":i.type===w.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!s&&this.g.some(t=>t(i.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${i.resource.fsPath}`):!s&&this.h&&this.h.length>0&&!this.h.some(t=>t(i.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}M(i){const s=(0,a.$0q)(i),t=[];for(const n of s){if((0,a.$ar)(n,this.j)){this.z&&this.R(` >> ignored (filtered) ${n.resource.fsPath}`);continue}t.push(n)}if(t.length===0)return;if(this.z)for(const n of t)this.R(` >> normalized ${n.type===w.FileChangeType.ADDED?"[ADDED]":n.type===w.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(i){if(c.$l)return P.Promises.exists(i);try{const s=(0,p.$nc)(i);return(await P.Promises.readdir((0,p.$mc)(i))).some(o=>o===s)}catch(s){return this.Q(s),!1}}setVerboseLogging(i){this.z=i}O(i){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}P(i){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}Q(i){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}R(i){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${i}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$pr=m;async function $(f,i,s,t,o=512){const n=await P.Promises.open(f,"r"),d=Buffer.allocUnsafe(o),l=new C.$we(t);let g,E=!1;const D={path:f,excludes:[],recursive:!1},y=new m(D,void 0,k=>{(async()=>{for(const{type:A}of k)if(A===w.FileChangeType.UPDATED){if(E)return;E=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:b}=await P.Promises.read(n,d,0,o,null);if(!b||l.token.isCancellationRequested)break;i(d.slice(0,b))}}catch(b){g=new Error(b),l.dispose(!0)}finally{E=!1}}})()});return await y.ready,s(),new Promise((k,A)=>{l.token.onCancellationRequested(async()=>{y.dispose();try{await P.Promises.close(n)}catch(b){g=new Error(b)}g?A(g):k()})})}}),define(ke[222],Ie([1,0,4,38,220,10,221,31]),function($e,e,r,h,C,R,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class p extends C.$kr{constructor(I){super(),this.O=I,this.onDidError=r.Event.None,this.watchers=new Set}async N(I){I=this.Z(I);const S=[],u=new Set(Array.from(this.watchers));for(const P of I){const w=this.W(P);w&&(0,h.$Ek)(w.request.excludes,P.excludes)&&(0,h.$Ek)(w.request.includes,P.includes)?u.delete(w):S.push(P)}S.length&&this.P(`Request to start watching: ${S.map(P=>this.M(P)).join(",")}`),u.size&&this.P(`Request to stop watching: ${Array.from(u).map(P=>this.M(P.request)).join(",")}`);for(const P of u)this.Y(P);for(const P of S)this.X(P)}W(I){for(const S of this.watchers)if(typeof I.correlationId=="number"||typeof S.request.correlationId=="number"){if(S.request.correlationId===I.correlationId)return S}else if((0,T.$Dg)(S.request.path,I.path,!R.$l))return S}X(I){const S=new O.$pr(I,this.O,P=>this.a.fire(P),()=>this.c.fire(I),P=>this.b.fire(P),this.R),u={request:I,instance:S};this.watchers.add(u)}async stop(){await super.stop();for(const I of this.watchers)this.Y(I)}Y(I){this.P("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}Z(I){const S=new Map;for(const u of I){const P=R.$l?u.path:u.path.toLowerCase();let w=S.get(u.correlationId);w||(w=new Map,S.set(u.correlationId,w)),w.has(P)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(u)}`),w.set(P,u)}return Array.from(S.values()).map(u=>Array.from(u.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const S of this.watchers)S.instance.setVerboseLogging(I)}P(I,S){this.R&&this.b.fire({type:"trace",message:this.bb(I,S)})}Q(I){this.b.fire({type:"warn",message:this.bb(I)})}bb(I,S){return S?`[File Watcher (node.js)] ${I} (${this.M(S.request)})`:`[File Watcher (node.js)] ${I}`}}e.$rr=p}),define(ke[223],Ie([1,0,69,222]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;class C extends r.$7q{constructor(O,T,p){super(O,T,p),this.s()}r(O){return O.add(new h.$rr(void 0))}}e.$sr=C}),define(ke[224],Ie([1,0,14,86,192,69]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;class O extends R.$8q{constructor(p,c,I){super(p,c,I),this.s()}r(p){const c=p.add(new C.$ir(r.$Zg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(c.onDidProcessExit(({code:I,signal:S})=>this.t(`terminated by itself with code ${I}, signal: ${S} (ETERM)`))),h.ProxyChannel.toService((0,h.$mi)(c.getChannel("watcher")))}}e.$jr=O}),define(ke[114],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class r{constructor(...C){this.a=new Map;for(const[R,O]of C)this.set(R,O)}set(C,R){const O=this.a.get(C);return this.a.set(C,R),O}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Di=r}),define(ke[225],Ie([1,0,7,13,3,112,214,5,114,80]),function($e,e,r,h,C,R,O,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=void 0;const I=!1;class S extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class u{constructor(m=new p.$Di,$=!1,f,i=I){this.i=m,this.j=$,this.k=f,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$Ei,this),this._globalGraph=i?f?._globalGraph??new O.$vr(s=>s):void 0}dispose(){if(!this.f){this.f=!0,(0,C.$Pc)(this.h),this.h.clear();for(const m of this.g)(0,C.$Oc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m,$){this.m();const f=this,i=new class extends u{dispose(){f.h.delete(i),super.dispose()}}(m,this.j,this,this.l);return this.h.add(i),$?.add(i),i}invokeFunction(m,...$){this.m();const f=w.traceInvocation(this.l,m);let i=!1;try{return m({get:t=>{if(i)throw(0,h.$7)("service accessor is only valid during the invocation of its target method");const o=this.s(t,f);if(!o)throw new Error(`[invokeFunction] unknown service '${t}'`);return o}},...$)}finally{i=!0,f.stop()}}createInstance(m,...$){this.m();let f,i;return m instanceof R.$Ci?(f=w.traceCreation(this.l,m.ctor),i=this.o(m.ctor,m.staticArguments.concat($),f)):(f=w.traceCreation(this.l,m),i=this.o(m,$,f)),f.stop(),i}o(m,$=[],f){const i=T._util.getServiceDependencies(m).sort((o,n)=>o.index-n.index),s=[];for(const o of i){const n=this.s(o.id,f);n||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${o.id}.`,!1),s.push(n)}const t=i.length>0?i[0].index:$.length;if($.length!==t){console.trace(`[createInstance] First service dependency of ${m.name} at position ${t+1} conflicts with ${$.length} static arguments`);const o=t-$.length;o>0?$=$.concat(new Array(o)):$=$.slice(0,t)}return Reflect.construct(m,$.concat(s))}q(m,$){if(this.i.get(m)instanceof R.$Ci)this.i.set(m,$);else if(this.k)this.k.q(m,$);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const $=this.i.get(m);return!$&&this.k?this.k.r(m):$}s(m,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const f=this.r(m);return f instanceof R.$Ci?this.u(m,f,$.branch(m,!0)):($.branch(m,!1),f)}u(m,$,f){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,$,f)}finally{this.t.delete(m)}}v(m,$,f){const i=new O.$vr(n=>n.id.toString());let s=0;const t=[{id:m,desc:$,_trace:f}],o=new Set;for(;t.length;){const n=t.pop();if(!o.has(String(n.id))){if(o.add(String(n.id)),i.lookupOrInsertNode(n),s++>1e3)throw new S(i);for(const d of T._util.getServiceDependencies(n.desc.ctor)){const l=this.r(d.id);if(l||this.y(`[createInstance] ${m} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(d.id)),l instanceof R.$Ci){const g={id:d.id,desc:l,_trace:n._trace.branch(d.id,!0)};i.insertEdge(n,g),t.push(g)}}}}for(;;){const n=i.roots();if(n.length===0){if(!i.isEmpty())throw new S(i);break}for(const{data:d}of n){if(this.r(d.id)instanceof R.$Ci){const g=this.w(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.q(d.id,g)}i.removeNode(d)}}return this.r(m)}w(m,$,f=[],i,s){if(this.i.get(m)instanceof R.$Ci)return this.x(m,$,f,i,s,this.g);if(this.k)return this.k.w(m,$,f,i,s);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}x(m,$,f=[],i,s,t){if(i){const o=new u(void 0,this.j,this,this.l);o.c=String(m);const n=new Map,d=new r.$Yh(()=>{const l=o.o($,f,s);for(const[g,E]of n){const D=l[g];if(typeof D=="function")for(const y of E)y.disposable=D.apply(l,y.listener)}return n.clear(),t.add(l),l});return new Proxy(Object.create(null),{get(l,g){if(!d.isInitialized&&typeof g=="string"&&(g.startsWith("onDid")||g.startsWith("onWill"))){let y=n.get(g);return y||(y=new c.$5c,n.set(g,y)),(A,b,v)=>{if(d.isInitialized)return d.value[g](A,b,v);{const F={listener:[A,b,v],disposable:void 0},N=y.push(F);return(0,C.$Sc)(()=>{N(),F.disposable?.dispose()})}}}if(g in l)return l[g];const E=d.value;let D=E[g];return typeof D!="function"||(D=D.bind(E),l[g]=D),D},set(l,g,E){return d.value[g]=E,!0},getPrototypeOf(l){return $.prototype}})}else{const o=this.o($,f,s);return t.add(o),o}}y(m,$){if($&&console.warn(m),this.j)throw new Error(m)}}e.$wr=u;var P;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(P||(P={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(P.None,null)}stop(){}branch(){return this}}}static traceInvocation(m,$){return m?new w(P.Invocation,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(m,$){return m?new w(P.Creation,$.name):w.c}static{this.f=0}constructor(m,$){this.type=m,this.name=$,this.g=Date.now(),this.h=[]}branch(m,$){const f=new w(P.Branch,m.toString());return this.h.push([m,$,f]),f}stop(){const m=Date.now()-this.g;w.f+=m;let $=!1;function f(s,t){const o=[],n=new Array(s+1).join("	");for(const[d,l,g]of t.h)if(l&&g){$=!0,o.push(`${n}CREATES -> ${d}`);const E=f(s+1,g);E&&o.push(E)}else o.push(`${n}uses -> ${d}`);return o.join(`
`)}const i=[`${this.type===P.Creation?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(m>2||$)&&w.all.add(i.join(`
`))}}e.$xr=w}),define(ke[11],Ie([1,0,8,52,4,60,3,28,10,22,17,2,35,5]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$dk=e.LogLevel=e.$bk=e.$ak=void 0,e.$ck=a,e.log=$,e.$ok=D,e.$pk=y,e.$qk=k,e.$rk=A,r=qe(r),e.$ak=(0,P.$Fi)("logService"),e.$bk=(0,P.$Fi)("loggerService");function w(){return new Date().toISOString()}function a(b){return(0,I.$ig)(b)}var m;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$dk=m.Info;function $(b,v,F){switch(v){case m.Trace:b.trace(F);break;case m.Debug:b.debug(F);break;case m.Info:b.info(F);break;case m.Warning:b.warn(F);break;case m.Error:b.error(F);break;case m.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function f(b,v=!1){let F="";for(let N=0;N<b.length;N++){let L=b[N];if(L instanceof Error&&(L=(0,h.$qj)(L,v)),typeof L=="object")try{L=JSON.stringify(L)}catch{}F+=(N>0?" ":"")+L}return F}class i extends O.$Uc{constructor(){super(...arguments),this.b=e.$dk,this.c=this.B(new C.$le),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==m.Off&&this.b<=v}}e.$fk=i;class s extends i{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...F){this.f(m.Trace)&&this.g(m.Trace,f([v,...F],!0))}debug(v,...F){this.f(m.Debug)&&this.g(m.Debug,f([v,...F]))}info(v,...F){this.f(m.Info)&&this.g(m.Info,f([v,...F]))}warn(v,...F){this.f(m.Warning)&&this.g(m.Warning,f([v,...F]))}error(v,...F){if(this.f(m.Error))if(v instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=v.stack,this.g(m.Error,f(N))}else this.g(m.Error,f([v,...F]))}flush(){}}e.$gk=s;class t extends i{constructor(v=e.$dk){super(),this.setLevel(v),this.g=!p.$j}trace(v,...F){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,v,...F):console.log(`[main ${w()}]`,v,...F))}debug(v,...F){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,v,...F):console.log(`[main ${w()}]`,v,...F))}info(v,...F){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,v,...F):console.log(`[main ${w()}]`,v,...F))}warn(v,...F){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,v,...F):console.warn(`[main ${w()}]`,v,...F))}error(v,...F){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,v,...F):console.error(`[main ${w()}]`,v,...F))}flush(){}}e.$hk=t;class o extends i{constructor(v=e.$dk,F=!0){super(),this.g=F,this.setLevel(v)}trace(v,...F){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...F):console.log(v,...F))}debug(v,...F){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...F):console.log(v,...F))}info(v,...F){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...F):console.log(v,...F))}warn(v,...F){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...F):console.log(v,...F))}error(v,...F){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...F):console.error(v,...F))}flush(){}}e.$ik=o;class n extends i{constructor(v,F=e.$dk){super(),this.g=v,this.setLevel(F)}trace(v,...F){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(v),...F])}debug(v,...F){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(v),...F])}info(v,...F){this.f(m.Info)&&this.g.log(m.Info,[this.h(v),...F])}warn(v,...F){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(v),...F])}error(v,...F){this.f(m.Error)&&this.g.log(m.Error,[this.h(v),...F])}h(v){return typeof v=="string"?v:(0,h.$qj)(v,this.f(m.Trace))}flush(){}}e.$jk=n;class d extends i{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const F of this.g)F.setLevel(v);super.setLevel(v)}trace(v,...F){for(const N of this.g)N.trace(v,...F)}debug(v,...F){for(const N of this.g)N.debug(v,...F)}info(v,...F){for(const N of this.g)N.info(v,...F)}warn(v,...F){for(const N of this.g)N.warn(v,...F)}error(v,...F){for(const N of this.g)N.error(v,...F)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$kk=d;class l extends O.$Uc{constructor(v,F,N){if(super(),this.h=v,this.j=F,this.b=new T.$Ac,this.c=this.B(new C.$le),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$le),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$le),this.onDidChangeVisibility=this.g.event,N)for(const L of N)this.b.set(L.resource,{logger:void 0,info:L})}m(v){return(0,I.$eg)(v)?[...this.b.values()].find(F=>F.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,F){const N=this.n(v),L=(0,I.$eg)(v)?v:F?.id??(0,R.$tj)(N.toString()).toString(16);let M=this.b.get(N)?.logger;const z=F?.logLevel==="always"?m.Trace:F?.logLevel;M||(M=this.s(N,z??this.getLogLevel(N)??this.h,{...F,id:L}));const j={logger:M,info:{resource:N,id:L,logLevel:z,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(j.info),this.b.set(N,j),M}n(v){return(0,I.$eg)(v)?(0,c.$gh)(this.j,`${v}.log`):v}setLogLevel(v,F){if(S.URI.isUri(v)){const N=v,L=F,M=this.b.get(N);M&&L!==M.info.logLevel&&(M.info.logLevel=L===this.h?void 0:L,M.logger?.setLevel(L),this.b.set(M.info.resource,M),this.f.fire([N,L]))}else{this.h=v;for(const[N,L]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&L.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,F){const N=this.m(v);N&&F!==!N.info.hidden&&(N.info.hidden=!F,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,F]))}getLogLevel(v){let F;return v&&(F=this.b.get(v)?.info.logLevel),F??this.h}registerLogger(v){const F=this.b.get(v.resource);F?F.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const F=this.b.get(v);F&&(F.logger&&F.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$lk=l;class g{constructor(){this.onDidChangeLogLevel=new C.$le().event}setLevel(v){}getLevel(){return m.Info}trace(v,...F){}debug(v,...F){}info(v,...F){}warn(v,...F){}error(v,...F){}critical(v,...F){}dispose(){}flush(){}}e.$mk=g;class E extends g{}e.$nk=E;function D(b){if(b.verbose)return m.Trace;if(typeof b.logLevel=="string"){const v=A(b.logLevel.toLowerCase());if(v!==void 0)return v}return e.$dk}function y(b){switch(b){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function k(b){switch(b){case m.Trace:return{original:"Trace",value:r.localize(11318,null)};case m.Debug:return{original:"Debug",value:r.localize(11319,null)};case m.Info:return{original:"Info",value:r.localize(11320,null)};case m.Warning:return{original:"Warning",value:r.localize(11321,null)};case m.Error:return{original:"Error",value:r.localize(11322,null)};case m.Off:return{original:"Off",value:r.localize(11323,null)}}}function A(b){switch(b){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$sk=new u.$Wj("logLevel",y(m.Info))}),define(ke[226],Ie([1,0,18,7,13,4,31,3,16,69,11]),function($e,e,r,h,C,R,O,T,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;class S extends T.$Uc{constructor(P,w){super(),this.a=P,this.b=w,this.c=this.B(new R.$le),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$le),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new h.$Dh(0)),this.w=[],this.y=this.B(new h.$Dh(0))}watch(P,w){return w.recursive||this.b?.watcher?.forceUniversal?this.n(P,w):this.z(P,w)}n(P,w){const a={path:this.J(P),excludes:w.excludes,includes:w.includes,recursive:w.recursive,filter:w.filter,correlationId:w.correlationId},m=(0,r.$Sb)(this.j,a);return this.r(),(0,T.$Sc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(P=>(0,C.$Y)(P))}s(){this.h||(this.h=this.B(this.t(w=>this.c.fire((0,c.$9q)(w)),w=>this.G(w),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)})));const P=this.b?.watcher?.recursive?.usePolling;if(P===!0)for(const w of this.j)(0,c.$5q)(w)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(P))for(const w of this.j)(0,c.$5q)(w)&&P.includes(w.path)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(P,w){const a={path:this.J(P),excludes:w.excludes,includes:w.includes,recursive:!1,filter:w.filter,correlationId:w.correlationId},m=(0,r.$Sb)(this.w,a);return this.C(),(0,T.$Sc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(P=>(0,C.$Y)(P))}D(){return this.u||(this.u=this.B(this.F(P=>this.c.fire((0,c.$9q)(P)),P=>this.G(P),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)}))),this.u.watch(this.w)}G(P){P.type==="error"&&this.g.fire(P.message),this.H(P)}H(P){this.a[P.type](P.message)}I(P){return(0,p.$hc)(P.fsPath)}J(P){const w=this.I(P);return(0,O.$Hg)(w)}}e.$cr=S}),define(ke[227],Ie([1,0,45,7,28,21,4,31,3,16,10,22,105,33,8,27,219,226,224,223]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=void 0;class s extends $.$cr{static{this.L=!1}constructor(o,n){super(o,n),this.onDidChangeCapabilities=O.Event.None,this.P=new C.$Ac(d=>S.$0g.getComparisonKey(d)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=a.FileSystemProviderCapabilities.FileReadWrite|a.FileSystemProviderCapabilities.FileOpenReadWriteClose|a.FileSystemProviderCapabilities.FileReadStream|a.FileSystemProviderCapabilities.FileFolderCopy|a.FileSystemProviderCapabilities.FileWriteUnlock|a.FileSystemProviderCapabilities.FileAtomicRead|a.FileSystemProviderCapabilities.FileAtomicWrite|a.FileSystemProviderCapabilities.FileAtomicDelete|a.FileSystemProviderCapabilities.FileClone,I.$l&&(this.M|=a.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(o){try{const{stat:n,symbolicLink:d}=await P.SymlinkSupport.stat(this.I(o));return{type:this.O(n,d),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:a.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const n=await P.Promises.readdir(this.I(o),{withFileTypes:!0}),d=[];return await Promise.all(n.map(async l=>{try{let g;l.isSymbolicLink()?g=(await this.stat((0,S.$gh)(o,l.name))).type:g=this.O(l),d.push([l.name,g])}catch(g){this.a.trace(g)}})),d}catch(n){throw this.hb(n)}}O(o,n){let d;return n?.dangling?d=a.FileType.Unknown:o.isFile()?d=a.FileType.File:o.isDirectory()?d=a.FileType.Directory:d=a.FileType.Unknown,n&&(d|=a.FileType.SymbolicLink),d}async Q(o){const n=this.I(o);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let d;for(;d=this.P.get(o);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await d.wait();const l=new h.$Eh;return this.P.set(o,l),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,p.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(o)===l&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(o)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),l.open()})}async readFile(o,n){let d;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(o)})`),d=await this.Q(o));const l=this.I(o);return await r.promises.readFile(l)}catch(l){throw this.hb(l)}finally{d?.dispose()}}R(o){s.L&&this.a.trace(o)}readFileStream(o,n,d){const l=(0,u.$Be)(g=>R.$Ne.concat(g.map(E=>R.$Ne.wrap(E))).buffer);return(0,m.$2q)(this,o,l,g=>g.buffer,{...n,bufferSize:256*1024},d),l}async writeFile(o,n,d){return d?.atomic!==!1&&d?.atomic?.postfix&&await this.S(o)?this.U(o,(0,S.$gh)((0,S.$fh)(o),`${(0,S.$dh)(o)}${d.atomic.postfix}`),n,d):this.W(o,n,d)}async S(o){try{const n=this.I(o),{symbolicLink:d}=await P.SymlinkSupport.stat(n);if(d)return!1}catch{}return!0}async U(o,n,d,l){const g=new p.$Tc;try{g.add(await this.Q(o)),g.add(await this.Q(n)),await this.W(n,d,l,!0);try{await this.rename(n,o,{overwrite:!0})}catch(E){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw E}}finally{g.dispose()}}async W(o,n,d,l){let g;try{const E=this.I(o);if(!d.create||!d.overwrite){if(await P.Promises.exists(E)){if(!d.overwrite)throw(0,a.$nl)((0,w.localize)(11375,null),a.FileSystemProviderErrorCode.FileExists)}else if(!d.create)throw(0,a.$nl)((0,w.localize)(11376,null),a.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(o,{create:!0,unlock:d.unlock},l),await this.write(g,0,n,0,n.byteLength)}catch(E){throw await this.ib(o,E)}finally{typeof g=="number"&&await this.close(g)}}static{this.$=!0}static configureFlushOnWrite(o){s.$=o}async open(o,n,d){const l=this.I(o);let g;(0,a.$bl)(n)&&!d&&(g=await this.Q(o));let E;try{if((0,a.$bl)(n)&&n.unlock)try{const{stat:y}=await P.SymlinkSupport.stat(l);y.mode&128||await r.promises.chmod(l,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let D;if((0,a.$bl)(n)){if(I.$j)try{await r.promises.truncate(l,0),D="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}D||(D="w")}else D="r";E=await P.Promises.open(l,D)}catch(D){throw g?.dispose(),(0,a.$bl)(n)?await this.ib(o,D):this.hb(D)}if(this.X.set(E,0),(0,a.$bl)(n)&&this.Z.set(E,o),g){const D=this.Y.get(E);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${l})`),this.Y.set(E,g),D&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${l})`),D.dispose())}return E}async close(o){const n=this.Y.get(o);try{if(this.X.delete(o),this.Z.delete(o)&&s.$)try{await P.Promises.fdatasync(o)}catch(d){s.configureFlushOnWrite(!1),this.a.error(d)}return await P.Promises.close(o)}catch(d){throw this.hb(d)}finally{n&&(this.Y.get(o)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.Y.delete(o)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),n.dispose())}}async read(o,n,d,l,g){const E=this.ab(o,n);let D=null;try{D=(await P.Promises.read(o,d,l,g,E)).bytesRead}catch(y){throw this.hb(y)}finally{this.bb(o,E,D)}return D}ab(o,n){return n===this.X.get(o)?null:n}bb(o,n,d){const l=this.X.get(o);typeof l=="number"&&(typeof n=="number"||(typeof d=="number"?this.X.set(o,l+d):this.X.delete(o)))}async write(o,n,d,l,g){return(0,h.$Zh)(()=>this.cb(o,n,d,l,g),100,3)}async cb(o,n,d,l,g){const E=this.ab(o,n);let D=null;try{D=(await P.Promises.write(o,d,l,g,E)).bytesWritten}catch(y){throw await this.ib(this.Z.get(o),y)}finally{this.bb(o,E,D)}return D}async mkdir(o){try{await r.promises.mkdir(this.I(o))}catch(n){throw this.hb(n)}}async delete(o,n){try{const d=this.I(o);if(n.recursive){let l;n?.atomic!==!1&&n.atomic.postfix&&(l=(0,c.$jc)((0,c.$mc)(d),`${(0,c.$nc)(d)}${n.atomic.postfix}`)),await P.Promises.rm(d,P.RimRafMode.MOVE,l)}else try{await r.promises.unlink(d)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let g=!1;try{const{stat:E,symbolicLink:D}=await P.SymlinkSupport.stat(d);g=E.isDirectory()&&!D}catch{}if(g)await r.promises.rmdir(d);else throw l}else throw l}}catch(d){throw this.hb(d)}}async rename(o,n,d){const l=this.I(o),g=this.I(n);if(l!==g)try{await this.db(o,n,"move",d.overwrite),await P.Promises.rename(l,g)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,w.localize)(11377,null,(0,c.$nc)(l),(0,c.$nc)((0,c.$mc)(g)),E.toString()))),this.hb(E)}}async copy(o,n,d){const l=this.I(o),g=this.I(n);if(l!==g)try{await this.db(o,n,"copy",d.overwrite),await P.Promises.copy(l,g,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,w.localize)(11378,null,(0,c.$nc)(l),(0,c.$nc)((0,c.$mc)(g)),E.toString()))),this.hb(E)}}async db(o,n,d,l){const g=this.I(o),E=this.I(n);let D=!1;if(!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive)||(D=(0,T.$Dg)(g,E,!0)),D){if(d==="copy")throw(0,a.$nl)((0,w.localize)(11379,null),a.FileSystemProviderErrorCode.FileExists);if(d==="move")return}const k=await this.N(o);if(!k)throw(0,a.$nl)((0,w.localize)(11380,null),a.FileSystemProviderErrorCode.FileNotFound);const A=await this.N(n);if(A){if(!l)throw(0,a.$nl)((0,w.localize)(11381,null),a.FileSystemProviderErrorCode.FileExists);k.type&a.FileType.File&&A.type&a.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,n){return this.eb(o,n,!1)}async eb(o,n,d){const l=this.I(o),g=this.I(n),E=!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive);if((0,T.$Dg)(l,g,!E))return;const D=new p.$Tc;try{D.add(await this.Q(o)),D.add(await this.Q(n)),d&&await r.promises.mkdir((0,c.$mc)(g),{recursive:!0}),await r.promises.copyFile(l,g)}catch(y){if(y.code==="ENOENT"&&!d)return this.eb(o,n,!0);throw this.hb(y)}finally{D.dispose()}}t(o,n,d){return new f.$jr(l=>o(l),l=>n(l),d)}F(o,n,d){return new i.$sr(l=>o(l),l=>n(l),d)}hb(o){if(o instanceof a.$ml)return o;let n=o,d;switch(o.code){case"ENOENT":d=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":d=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":d=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":d=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":d=a.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,d=a.FileSystemProviderErrorCode.Unknown;break;default:d=a.FileSystemProviderErrorCode.Unknown}return(0,a.$nl)(n,d)}async ib(o,n){let d=this.hb(n);if(o&&d.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await P.SymlinkSupport.stat(this.I(o));l.mode&128||(d=(0,a.$nl)(n,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return d}}e.$tr=s}),define(ke[228],Ie([1,0,3,11]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KR=void 0;class C extends r.$Uc{constructor(O,T=[]){super(),this.a=new h.$kk([O,...T]),this.B(O.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...T){this.a.trace(O,...T)}debug(O,...T){this.a.debug(O,...T)}info(O,...T){this.a.info(O,...T)}warn(O,...T){this.a.warn(O,...T)}error(O,...T){this.a.error(O,...T)}flush(){this.a.flush()}}e.$KR=C}),define(ke[229],Ie([1,0,27,11]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zR=void 0;var C;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(C||(C={}));async function R(c,I,S,u,P){try{const w=await new Promise((m,$)=>{$e(["@vscode/spdlog"],m,$)}).then(qe);w.setFlushOn(C.Trace);const a=await w.createAsyncRotatingLogger(c,I,S,u);return P?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(w){console.error(w)}return null}function O(c,I,S){switch(I){case h.LogLevel.Trace:c.trace(S);break;case h.LogLevel.Debug:c.debug(S);break;case h.LogLevel.Info:c.info(S);break;case h.LogLevel.Warning:c.warn(S);break;case h.LogLevel.Error:c.error(S);break;case h.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function T(c,I){switch(I){case h.LogLevel.Trace:c.setLevel(C.Trace);break;case h.LogLevel.Debug:c.setLevel(C.Debug);break;case h.LogLevel.Info:c.setLevel(C.Info);break;case h.LogLevel.Warning:c.setLevel(C.Warning);break;case h.LogLevel.Error:c.setLevel(C.Error);break;case h.LogLevel.Off:c.setLevel(C.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class p extends h.$gk{constructor(I,S,u,P,w){super(),this.m=[],this.setLevel(w),this.n=this.s(I,S,u,P),this.B(this.onDidChangeLogLevel(a=>{this.r&&T(this.r,a)}))}async s(I,S,u,P){const w=u?6:1,a=30/w*r.$Il.MB,m=await R(I,S,a,w,P);if(m){this.r=m,T(this.r,this.getLevel());for(const{level:$,message:f}of this.m)O(this.r,$,f);this.m=[]}}g(I,S){this.r?O(this.r,I,S):this.getLevel()<=I&&this.m.push({level:I,message:S})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$zR=p});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[145],Ie([1,0,43,8,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,r=Ut(r);var R;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var O;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(O||(e.MarkerSeverity=O={})),function(p){function c(w,a){return a-w}p.compare=c;const I=Object.create(null);I[p.Error]=(0,h.localize)(11315,null),I[p.Warning]=(0,h.localize)(11316,null),I[p.Info]=(0,h.localize)(11317,null);function S(w){return I[w]||""}p.toString=S;function u(w){switch(w){case r.default.Error:return p.Error;case r.default.Warning:return p.Warning;case r.default.Info:return p.Info;case r.default.Ignore:return p.Hint}}p.fromSeverity=u;function P(w){switch(w){case p.Error:return r.default.Error;case p.Warning:return r.default.Warning;case p.Info:return r.default.Info;case p.Hint:return r.default.Ignore}}p.toSeverity=P}(O||(e.MarkerSeverity=O={}));var T;(function(p){const c="";function I(u){return S(u,!0)}p.makeKey=I;function S(u,P){const w=[c];return u.source?w.push(u.source.replace("\xA6","\\\xA6")):w.push(c),u.code?typeof u.code=="string"?w.push(u.code.replace("\xA6","\\\xA6")):w.push(u.code.value.replace("\xA6","\\\xA6")):w.push(c),u.severity!==void 0&&u.severity!==null?w.push(O.toString(u.severity)):w.push(c),u.message&&P?w.push(u.message.replace("\xA6","\\\xA6")):w.push(c),u.startLineNumber!==void 0&&u.startLineNumber!==null?w.push(u.startLineNumber.toString()):w.push(c),u.startColumn!==void 0&&u.startColumn!==null?w.push(u.startColumn.toString()):w.push(c),u.endLineNumber!==void 0&&u.endLineNumber!==null?w.push(u.endLineNumber.toString()):w.push(c),u.endColumn!==void 0&&u.endColumn!==null?w.push(u.endColumn.toString()):w.push(c),w.push(c),w.join("\xA6")}p.makeKeyOptionalMessage=S})(T||(e.IMarkerData=T={})),e.$Gu=(0,C.$Fi)("markerService")});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[230],Ie([1,0,4,43,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ww=e.$vw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$tw=e.Severity=void 0,e.$uw=T,h=Ut(h),e.Severity=h.default,e.$tw=(0,C.$Fi)("notificationService");var R;(function(S){S[S.DEFAULT=0]="DEFAULT",S[S.SILENT=1]="SILENT",S[S.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var O;(function(S){S[S.WORKSPACE=0]="WORKSPACE",S[S.PROFILE=1]="PROFILE",S[S.APPLICATION=2]="APPLICATION"})(O||(e.NeverShowAgainScope=O={}));function T(S){if(S){const u=S;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var p;(function(S){S[S.OFF=0]="OFF",S[S.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class c{constructor(){this.progress=new I,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$vw=c;class I{infinite(){}done(){}total(u){}worked(u){}}e.$ww=I}),define(ke[231],Ie([1,0,55]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.context<"u"){const R=C.context.configuration();if(R)h=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(h=globalThis._VSCODE_PRODUCT_JSON,r.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:R.version})}}else h={},Object.keys(h).length===0&&Object.assign(h,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(ke[115],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$tk=(0,r.$Fi)("productService"),e.$uk="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function($e,e){return function(r,h){e(r,h,$e)}};define(ke[89],Ie([1,0,7,20,3,5]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.$yw=e.ProgressLocation=e.$xw=void 0,e.$xw=(0,R.$Fi)("progressService");var O;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(O||(e.ProgressLocation=O={})),e.$yw=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$zw=T;class p{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const P=this.d;this.d=()=>{P?.(),u()}}):Promise.resolve()}}e.$Aw=p;let c=class extends C.$Uc{constructor(u,P){super(),this.a=new r.$3h,P.withProgress(u,w=>(this.b=w,this.c&&w.report(this.c),this.a.p)),this.B((0,C.$Sc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$Bw=c,e.$Bw=c=Je([Ve(1,e.$xw)],c);class I extends C.$Uc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new C.$Tc)}start(u){this.stop();const P=++this.a,w=new h.$we;return this.f=setTimeout(()=>{P===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,C.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Sc)(()=>w.cancel())),this.b.add((0,C.$Sc)(()=>this.c?this.c.done():void 0)),{id:P,token:w.token,stop:()=>this.h(P),isCurrent:()=>this.a===P}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$Cw=I,e.$Dw=(0,R.$Fi)("editorProgressService")}),define(ke[36],Ie([1,0,65,17]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,r=qe(r),h=qe(h);class C{constructor(){this.a=new Map}add(O,T){r.ok(h.$eg(O)),r.ok(h.$gg(T)),r.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,T)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$ro=new C}),define(ke[116],Ie([1,0,4,177,36]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0,C=qe(C),e.$so={JSONContribution:"base.contributions.json"};function R(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class O{constructor(){this.b=new r.$le,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,I){this.a[R(c)]=I,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(c){const I=this.a[c];return I?(0,h.$8j)(I):void 0}hasSchemaContent(c){return!!this.a[c]}}const T=new O;C.$ro.add(e.$so.JSONContribution,T)}),define(ke[70],Ie([1,0,18,4,17,8,46,116,36]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.ConfigurationScope=e.$wo=e.EditPresentationTypes=void 0,e.$Ho=a,e.$Io=m,e.$Jo=$,e.$Ko=i,e.$Lo=s,e.$Mo=t,e.$No=o,C=qe(C),R=qe(R);var c;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$wo={Configuration:"base.contributions.configuration"};var I;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do="vscode://schemas/settings/resourceLanguage",e.$Eo="vscode://schemas/settings/configurationDefaults";const S=p.$ro.as(T.$so.JSONContribution);class u{constructor(){this.a=[],this.i=new Set,this.j=new h.$le,this.onDidSchemaChange=this.j.event,this.k=new h.$le,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:R.localize(11611,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},S.registerSchema(e.$Do,this.h),this.z()}registerConfiguration(d,l=!0){this.registerConfigurations([d],l)}registerConfigurations(d,l=!0){const g=new Set;this.r(d,l,g),S.registerSchema(e.$Do,this.h),this.j.fire(),this.k.fire({properties:g})}deregisterConfigurations(d){const l=new Set;this.s(d,l),S.registerSchema(e.$Do,this.h),this.j.fire(),this.k.fire({properties:l})}updateConfigurations({add:d,remove:l}){const g=new Set;this.s(l,g),this.r(d,!1,g),S.registerSchema(e.$Do,this.h),this.j.fire(),this.k.fire({properties:g})}registerDefaultConfigurations(d){const l=new Set;this.l(d,l),this.j.fire(),this.k.fire({properties:l,defaultsOverrides:!0})}l(d,l){this.a.push(...d);const g=[];for(const{overrides:E,source:D}of d)for(const y in E){l.add(y);const k=this.b.get(y)??this.b.set(y,{configurationDefaultOverrides:[]}).get(y),A=E[y];if(k.configurationDefaultOverrides.push({value:A,source:D}),e.$Go.test(y)){const b=this.o(y,A,D,k.configurationDefaultOverrideValue);if(!b)continue;k.configurationDefaultOverrideValue=b,this.n(y,b,D),g.push(...a(y))}else{const b=this.p(y,A,D,k.configurationDefaultOverrideValue);if(!b)continue;k.configurationDefaultOverrideValue=b;const v=this.e[y];v&&(this.A(y,v),this.w(y,v))}}this.q(g)}deregisterDefaultConfigurations(d){const l=new Set;this.m(d,l),this.j.fire(),this.k.fire({properties:l,defaultsOverrides:!0})}m(d,l){for(const g of d){const E=this.a.indexOf(g);E!==-1&&this.a.splice(E,1)}for(const{overrides:g,source:E}of d)for(const D in g){const y=this.b.get(D);if(!y)continue;const k=y.configurationDefaultOverrides.findIndex(A=>E?A.source?.id===E.id:A.value===g[D]);if(k!==-1){if(y.configurationDefaultOverrides.splice(k,1),y.configurationDefaultOverrides.length===0&&this.b.delete(D),e.$Go.test(D)){let A;for(const b of y.configurationDefaultOverrides)A=this.o(D,b.value,b.source,A);A&&!C.$rg(A.value)?(y.configurationDefaultOverrideValue=A,this.n(D,A,E)):(this.b.delete(D),delete this.e[D],delete this.c.properties[D])}else{let A;for(const v of y.configurationDefaultOverrides)A=this.p(D,v.value,v.source,A);y.configurationDefaultOverrideValue=A;const b=this.e[D];b&&(this.A(D,b),this.w(D,b))}l.add(D)}}this.y()}n(d,l,g){const E={type:"object",default:l.value,description:R.localize(11612,null,(0,O.$jj)(d)),$ref:e.$Do,defaultDefaultValue:l.value,source:g,defaultValueSource:g};this.e[d]=E,this.c.properties[d]=E}o(d,l,g,E){const D=E?.value||{},y=E?.source??new Map;if(!(y instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const k of Object.keys(l)){const A=l[k];if(C.$gg(A)&&(C.$lg(D[k])||C.$gg(D[k]))){if(D[k]={...D[k]??{},...A},g)for(const v in A)y.set(`${k}.${v}`,g)}else D[k]=A,g?y.set(k,g):y.delete(k)}return{value:D,source:y}}p(d,l,g,E){const D=this.e[d],y=E?.value??D?.defaultDefaultValue;let k=g;if(C.$gg(l)&&(D!==void 0&&D.type==="object"||D===void 0&&(C.$lg(y)||C.$gg(y)))){if(k=E?.source??new Map,!(k instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const b in l)g&&k.set(`${d}.${b}`,g);l={...C.$gg(y)?y:{},...l}}return{value:l,source:k}}deltaConfiguration(d){let l=!1;const g=new Set;d.removedDefaults&&(this.m(d.removedDefaults,g),l=!0),d.addedDefaults&&(this.l(d.addedDefaults,g),l=!0),d.removedConfigurations&&this.s(d.removedConfigurations,g),d.addedConfigurations&&this.r(d.addedConfigurations,!1,g),this.j.fire(),this.k.fire({properties:g,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...d){this.j.fire()}registerOverrideIdentifiers(d){this.q(d),this.j.fire()}q(d){for(const l of d)this.i.add(l);this.y()}r(d,l,g){d.forEach(E=>{this.u(E,l,E.extensionInfo,E.restrictedProperties,void 0,g),this.d.push(E),this.v(E)})}s(d,l){const g=E=>{if(E.properties)for(const D in E.properties){l.add(D);const y=this.e[D];y?.policy?.name&&this.f.delete(y.policy.name),delete this.e[D],this.x(D,E.properties[D])}E.allOf?.forEach(D=>g(D))};for(const E of d){g(E);const D=this.d.indexOf(E);D!==-1&&this.d.splice(D,1)}}u(d,l=!0,g,E,D=I.WINDOW,y){D=C.$ng(d.scope)?D:d.scope;const k=d.properties;if(k)for(const b in k){const v=k[b];if(l&&i(b,v)){delete k[b];continue}if(v.source=g,v.defaultDefaultValue=k[b].default,this.A(b,v),e.$Go.test(b)?v.scope=void 0:(v.scope=C.$ng(v.scope)?D:v.scope,v.restricted=C.$ng(v.restricted)?!!E?.includes(b):v.restricted),k[b].hasOwnProperty("included")&&!k[b].included){this.g[b]=k[b],delete k[b];continue}else this.e[b]=k[b],k[b].policy?.name&&this.f.set(k[b].policy.name,b);!k[b].deprecationMessage&&k[b].markdownDeprecationMessage&&(k[b].deprecationMessage=k[b].markdownDeprecationMessage),y.add(b)}const A=d.allOf;if(A)for(const b of A)this.u(b,l,g,E,D,y)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const d=new Map;for(const[l,g]of this.b)g.configurationDefaultOverrideValue&&d.set(l,g.configurationDefaultOverrideValue);return d}v(d){const l=g=>{const E=g.properties;if(E)for(const y in E)this.w(y,E[y]);g.allOf?.forEach(l)};l(d)}w(d,l){switch(e.$xo.properties[d]=l,l.scope){case I.APPLICATION:e.$yo.properties[d]=l;break;case I.MACHINE:e.$zo.properties[d]=l;break;case I.MACHINE_OVERRIDABLE:e.$Ao.properties[d]=l;break;case I.WINDOW:e.$Bo.properties[d]=l;break;case I.RESOURCE:e.$Co.properties[d]=l;break;case I.LANGUAGE_OVERRIDABLE:e.$Co.properties[d]=l,this.h.properties[d]=l;break}}x(d,l){switch(delete e.$xo.properties[d],l.scope){case I.APPLICATION:delete e.$yo.properties[d];break;case I.MACHINE:delete e.$zo.properties[d];break;case I.MACHINE_OVERRIDABLE:delete e.$Ao.properties[d];break;case I.WINDOW:delete e.$Bo.properties[d];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$Co.properties[d],delete this.h.properties[d];break}}y(){for(const d of this.i.values()){const l=`[${d}]`,g={type:"object",description:R.localize(11613,null),errorMessage:R.localize(11614,null),$ref:e.$Do};this.A(l,g),e.$xo.properties[l]=g,e.$yo.properties[l]=g,e.$zo.properties[l]=g,e.$Ao.properties[l]=g,e.$Bo.properties[l]=g,e.$Co.properties[l]=g}}z(){const d={type:"object",description:R.localize(11615,null),errorMessage:R.localize(11616,null),$ref:e.$Do};e.$xo.patternProperties[e.$Fo]=d,e.$yo.patternProperties[e.$Fo]=d,e.$zo.patternProperties[e.$Fo]=d,e.$Ao.patternProperties[e.$Fo]=d,e.$Bo.patternProperties[e.$Fo]=d,e.$Co.patternProperties[e.$Fo]=d,this.j.fire()}A(d,l){const g=this.b.get(d)?.configurationDefaultOverrideValue;let E,D;g&&(!l.disallowConfigurationDefault||!g.source)&&(E=g.value,D=g.source),C.$lg(E)&&(E=l.defaultDefaultValue,D=void 0),C.$lg(E)&&(E=$(l.type)),l.default=E,l.defaultValueSource=D}}const P="\\[([^\\]]+)\\]",w=new RegExp(P,"g");e.$Fo=`^(${P})+$`,e.$Go=new RegExp(e.$Fo);function a(n){const d=[];if(e.$Go.test(n)){let l=w.exec(n);for(;l?.length;){const g=l[1].trim();g&&d.push(g),l=w.exec(n)}}return(0,r.$Lb)(d)}function m(n){return n.reduce((d,l)=>`${d}[${l}]`,"")}function $(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const f=new u;p.$ro.add(e.$wo.Configuration,f);function i(n,d){return n.trim()?e.$Go.test(n)?R.localize(11618,null,n):f.getConfigurationProperties()[n]!==void 0?R.localize(11619,null,n):d.policy?.name&&f.getPolicyConfigurations().get(d.policy?.name)!==void 0?R.localize(11620,null,n,d.policy?.name,f.getPolicyConfigurations().get(d.policy?.name)):null:R.localize(11617,null)}function s(){const n=[],d=f.getConfigurationProperties();for(const l of Object.keys(d))n.push([l,d[l].scope]);return n.push(["launch",I.RESOURCE]),n.push(["task",I.RESOURCE]),n}function t(n){const d={};for(const l of n){const g=l.properties;if(C.$gg(g))for(const E in g)d[E]=g[E];l.allOf&&Object.assign(d,t(l.allOf))}return d}function o(n){switch(n){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(ke[232],Ie([1,0,18,4,176,3,28,24,17,2,46,70,27,36]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0,e.$So=s,r=qe(r),C=qe(C),T=qe(T),p=qe(p);function w(d){return Object.isFrozen(d)?d:T.$fo(d)}class a{static createEmptyModel(l){return new a({},[],[],void 0,l)}constructor(l,g,E,D,y){this.b=l,this.c=g,this.d=E,this.raw=D,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const l=this.raw.map(g=>{if(g instanceof a)return g;const E=new m("",this.f);return E.parseRaw(g),E.configurationModel});this.g=l.reduce((g,E)=>E===g?E:g.merge(E),l[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(l){return l?(0,I.$hj)(this.contents,l):this.contents}inspect(l,g){const E=this;return{get value(){return w(E.rawConfiguration.getValue(l))},get override(){return g?w(E.rawConfiguration.getOverrideValue(l,g)):void 0},get merged(){return w(g?E.rawConfiguration.override(g).getValue(l):E.rawConfiguration.getValue(l))},get overrides(){const D=[];for(const{contents:y,identifiers:k,keys:A}of E.rawConfiguration.overrides){const b=new a(y,A,[],void 0,E.f).getValue(l);b!==void 0&&D.push({identifiers:k,value:b})}return D.length?w(D):void 0}}}getOverrideValue(l,g){const E=this.j(g);return E?l?(0,I.$hj)(E,l):E:void 0}getKeysForOverrideIdentifier(l){const g=[];for(const E of this.overrides)E.identifiers.includes(l)&&g.push(...E.keys);return r.$Lb(g)}getAllOverrideIdentifiers(){const l=[];for(const g of this.overrides)l.push(...g.identifiers);return r.$Lb(l)}override(l){let g=this.a.get(l);return g||(g=this.h(l),this.a.set(l,g)),g}merge(...l){const g=T.$eo(this.contents),E=T.$eo(this.overrides),D=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const k of l)if(y.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.i(g,k.contents);for(const A of k.overrides){const[b]=E.filter(v=>r.$tb(v.identifiers,A.identifiers));b?(this.i(b.contents,A.contents),b.keys.push(...A.keys),b.keys=r.$Lb(b.keys)):E.push(T.$eo(A))}for(const A of k.keys)D.indexOf(A)===-1&&D.push(A)}return new a(g,D,E,y.every(k=>k instanceof a)?void 0:y,this.f)}h(l){const g=this.j(l);if(!g||typeof g!="object"||!Object.keys(g).length)return this;const E={};for(const D of r.$Lb([...Object.keys(this.contents),...Object.keys(g)])){let y=this.contents[D];const k=g[D];k&&(typeof y=="object"&&typeof k=="object"?(y=T.$eo(y),this.i(y,k)):y=k),E[D]=y}return new a(E,this.keys,this.overrides,void 0,this.f)}i(l,g){for(const E of Object.keys(g)){if(E in l&&p.$gg(l[E])&&p.$gg(g[E])){this.i(l[E],g[E]);continue}l[E]=T.$eo(g[E])}}j(l){let g=null,E=null;const D=y=>{y&&(E?this.i(E,y):E=T.$eo(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===l?g=y.contents:y.identifiers.includes(l)&&D(y.contents);return D(g),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(l,g){this.k(l,g,!0)}setValue(l,g){this.k(l,g,!1)}removeValue(l){const g=this.keys.indexOf(l);g!==-1&&(this.keys.splice(g,1),(0,I.$gj)(this.contents,l),S.$Go.test(l)&&this.overrides.splice(this.overrides.findIndex(E=>r.$tb(E.identifiers,(0,S.$Ho)(l))),1))}k(l,g,E){if((0,I.$fj)(this.contents,l,g,D=>this.f.error(D)),E=E||this.keys.indexOf(l)===-1,E&&this.keys.push(l),S.$Go.test(l)){const D=(0,S.$Ho)(l),y={identifiers:D,keys:Object.keys(this.contents[l]),contents:(0,I.$ej)(this.contents[l],A=>this.f.error(A))},k=this.overrides.findIndex(A=>r.$tb(A.identifiers,D));k!==-1?this.overrides[k]=y:this.overrides.push(y)}}}e.$Oo=a;class m{constructor(l,g){this.f=l,this.g=g,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||a.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(l,g){if(!p.$ng(l)){const E=this.h(l);this.parseRaw(E,g)}}reparse(l){this.a&&this.parseRaw(this.a,l)}parseRaw(l,g){this.a=l;const{contents:E,keys:D,overrides:y,restricted:k,hasExcludedProperties:A}=this.i(l,g);this.b=new a(E,D,y,A?[l]:void 0,this.g),this.c=k||[]}h(l){let g={},E=null,D=[];const y=[],k=[];function A(v){Array.isArray(D)?D.push(v):E!==null&&(D[E]=v)}const b={onObjectBegin:()=>{const v={};A(v),y.push(D),D=v,E=null},onObjectProperty:v=>{E=v},onObjectEnd:()=>{D=y.pop()},onArrayBegin:()=>{const v=[];A(v),y.push(D),D=v,E=null},onArrayEnd:()=>{D=y.pop()},onLiteralValue:A,onError:(v,F,N)=>{k.push({error:v,offset:F,length:N})}};if(l)try{C.$6n(l,b),g=D[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return g}i(l,g){const E=P.$ro.as(S.$wo.Configuration).getConfigurationProperties(),D=this.j(l,E,!0,g);l=D.raw;const y=(0,I.$ej)(l,b=>this.g.error(`Conflict in settings file ${this.f}: ${b}`)),k=Object.keys(l),A=this.l(l,b=>this.g.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:y,keys:k,overrides:A,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(l,g,E,D){let y=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:l,restricted:[],hasExcludedProperties:y};const k={},A=[];for(const b in l)if(S.$Go.test(b)&&E){const v=this.j(l[b],g,!1,D);k[b]=v.raw,y=y||v.hasExcludedProperties,A.push(...v.restricted)}else{const v=g[b],F=v?typeof v.scope<"u"?v.scope:S.ConfigurationScope.WINDOW:void 0;v?.restricted&&A.push(b),!D.exclude?.includes(b)&&(D.include?.includes(b)||(F===void 0||D.scopes===void 0||D.scopes.includes(F))&&!(D.skipRestricted&&v?.restricted))?k[b]=l[b]:y=!0}return{raw:k,restricted:A,hasExcludedProperties:y}}l(l,g){const E=[];for(const D of Object.keys(l))if(S.$Go.test(D)){const y={};for(const k in l[D])y[k]=l[D][k];E.push({identifiers:(0,S.$Ho)(D),keys:Object.keys(y),contents:(0,I.$ej)(y,g)})}return E}}e.$Po=m;class $ extends R.$Uc{constructor(l,g,E,D,y){super(),this.c=l,this.f=g,this.g=D,this.h=y,this.b=this.B(new h.$le),this.onDidChange=this.b.event,this.a=new m(this.c.toString(),y),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(h.Event.any(h.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),h.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(u.FileOperation.CREATE)||k.isOperation(u.FileOperation.COPY)||k.isOperation(u.FileOperation.DELETE)||k.isOperation(u.FileOperation.WRITE))&&E.isEqual(k.resource,l)))(()=>this.b.fire()))}async loadConfiguration(){try{const l=await this.g.readFile(this.c);return this.a.parse(l.value.toString()||"{}",this.f),this.a.configurationModel}catch{return a.createEmptyModel(this.h)}}reparse(l){return l&&(this.f=l),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Qo=$;class f{constructor(l,g,E,D,y,k,A,b,v,F,N,L,M){this.a=l,this.b=g,this.c=E,this.overrideIdentifiers=D,this.d=y,this.f=k,this.g=A,this.h=b,this.i=v,this.j=F,this.k=N,this.l=L,this.m=M}get value(){return w(this.c)}n(l){return l?.value!==void 0||l?.override!==void 0||l?.overrides!==void 0?l:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(l,g,E,D,y,k,A,b,v,F){this.j=l,this.l=g,this.m=E,this.n=D,this.p=y,this.q=k,this.r=A,this.s=b,this.t=v,this.u=F,this.h=null,this.i=new O.$Ac,this.v=null}getValue(l,g,E){return this.w(l,g,E).getValue(l)}updateValue(l,g,E={}){let D;E.resource?(D=this.t.get(E.resource),D||(D=a.createEmptyModel(this.u),this.t.set(E.resource,D))):D=this.s,g===void 0?D.removeValue(l):D.setValue(l,g),E.resource||(this.h=null)}inspect(l,g,E){const D=this.w(l,g,E),y=this.A(g.resource,E),k=g.resource?this.t.get(g.resource)||this.s:this.s,A=new Set;for(const b of D.overrides)for(const v of b.identifiers)D.getOverrideValue(l,v)!==void 0&&A.add(v);return new f(l,g,D.getValue(l),A.size?[...A]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.q:void 0,y||void 0,k)}keys(l){const g=this.A(void 0,l);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:g?g.keys.slice(0):[]}}updateDefaultConfiguration(l){this.j=l,this.h=null,this.i.clear()}updatePolicyConfiguration(l){this.l=l}updateApplicationConfiguration(l){this.m=l,this.h=null,this.i.clear()}updateLocalUserConfiguration(l){this.n=l,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(l){this.p=l,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(l){this.q=l,this.h=null,this.i.clear()}updateFolderConfiguration(l,g){this.r.set(l,g),this.i.delete(l)}deleteFolderConfiguration(l){this.folderConfigurations.delete(l),this.i.delete(l)}compareAndUpdateDefaultConfiguration(l,g){const E=[];if(!g){const{added:D,updated:y,removed:k}=o(this.j,l);g=[...D,...y,...k]}for(const D of g)for(const y of(0,S.$Ho)(D)){const k=this.j.getKeysForOverrideIdentifier(y),A=l.getKeysForOverrideIdentifier(y),b=[...A.filter(v=>k.indexOf(v)===-1),...k.filter(v=>A.indexOf(v)===-1),...k.filter(v=>!T.$io(this.j.override(y).getValue(v),l.override(y).getValue(v)))];E.push([y,b])}return this.updateDefaultConfiguration(l),{keys:g,overrides:E}}compareAndUpdatePolicyConfiguration(l){const{added:g,updated:E,removed:D}=o(this.l,l),y=[...g,...E,...D];return y.length&&this.updatePolicyConfiguration(l),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(l){const{added:g,updated:E,removed:D,overrides:y}=o(this.applicationConfiguration,l),k=[...g,...E,...D];return k.length&&this.updateApplicationConfiguration(l),{keys:k,overrides:y}}compareAndUpdateLocalUserConfiguration(l){const{added:g,updated:E,removed:D,overrides:y}=o(this.localUserConfiguration,l),k=[...g,...E,...D];return k.length&&this.updateLocalUserConfiguration(l),{keys:k,overrides:y}}compareAndUpdateRemoteUserConfiguration(l){const{added:g,updated:E,removed:D,overrides:y}=o(this.remoteUserConfiguration,l),k=[...g,...E,...D];return k.length&&this.updateRemoteUserConfiguration(l),{keys:k,overrides:y}}compareAndUpdateWorkspaceConfiguration(l){const{added:g,updated:E,removed:D,overrides:y}=o(this.workspaceConfiguration,l),k=[...g,...E,...D];return k.length&&this.updateWorkspaceConfiguration(l),{keys:k,overrides:y}}compareAndUpdateFolderConfiguration(l,g){const E=this.folderConfigurations.get(l),{added:D,updated:y,removed:k,overrides:A}=o(E,g),b=[...D,...y,...k];return(b.length||!E)&&this.updateFolderConfiguration(l,g),{keys:b,overrides:A}}compareAndDeleteFolderConfiguration(l){const g=this.folderConfigurations.get(l);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(l);const{added:E,updated:D,removed:y,overrides:k}=o(g,void 0);return{keys:[...E,...D,...y],overrides:k}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(l,g,E){let D=this.x(g,E);return g.overrideIdentifier&&(D=D.override(g.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(l)!==void 0&&(D=D.merge(this.l)),D}x({resource:l},g){let E=this.y();if(g&&l){const D=g.getFolder(l);D&&(E=this.z(D.uri)||E);const y=this.t.get(l);y&&(E=E.merge(y))}return E}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(l){let g=this.i.get(l);if(!g){const E=this.y(),D=this.r.get(l);D?(g=E.merge(D),this.i.set(l,g)):g=E}return g}A(l,g){if(g&&l){const E=g.getFolder(l);if(E)return this.r.get(E.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((l,g)=>{const{contents:E,overrides:D,keys:y}=this.r.get(g);return l.push([g,{contents:E,overrides:D,keys:y}]),l},[])}}allKeys(){const l=new Set;return this.j.keys.forEach(g=>l.add(g)),this.userConfiguration.keys.forEach(g=>l.add(g)),this.q.keys.forEach(g=>l.add(g)),this.r.forEach(g=>g.keys.forEach(E=>l.add(E))),[...l.values()]}B(){const l=new Set;return this.j.getAllOverrideIdentifiers().forEach(g=>l.add(g)),this.userConfiguration.getAllOverrideIdentifiers().forEach(g=>l.add(g)),this.q.getAllOverrideIdentifiers().forEach(g=>l.add(g)),this.r.forEach(g=>g.getAllOverrideIdentifiers().forEach(E=>l.add(E))),[...l.values()]}D(l){const g=new Set;return this.j.getKeysForOverrideIdentifier(l).forEach(E=>g.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(l).forEach(E=>g.add(E)),this.q.getKeysForOverrideIdentifier(l).forEach(E=>g.add(E)),this.r.forEach(E=>E.getKeysForOverrideIdentifier(l).forEach(D=>g.add(D))),[...g.values()]}static parse(l,g){const E=this.E(l.defaults,g),D=this.E(l.policy,g),y=this.E(l.application,g),k=this.E(l.user,g),A=this.E(l.workspace,g),b=l.folders.reduce((v,F)=>(v.set(c.URI.revive(F[0]),this.E(F[1],g)),v),new O.$Ac);return new i(E,D,y,k,a.createEmptyModel(g),A,b,a.createEmptyModel(g),new O.$Ac,g)}static E(l,g){return new a(l.contents,l.keys,l.overrides,void 0,g)}}e.$Ro=i;function s(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const l=new Set,g=new Map;for(const D of d)D.keys.forEach(y=>l.add(y)),D.overrides.forEach(([y,k])=>{const A=(0,O.$xc)(g,y,new Set);k.forEach(b=>A.add(b))});const E=[];return g.forEach((D,y)=>E.push([y,[...D.values()]])),{keys:[...l.values()],overrides:E}}class t{constructor(l,g,E,D,y){this.change=l,this.f=g,this.g=E,this.h=D,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const k of l.keys)this.affectedKeys.add(k);for(const[,k]of l.overrides)for(const A of k)this.affectedKeys.add(A);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(l,g){const E=this.a+l,D=this.d.indexOf(E);if(D<0)return!1;const y=D+E.length;if(y>=this.d.length)return!1;const k=this.d.charCodeAt(y);if(k!==this.b&&k!==this.c)return!1;if(g){const A=this.previousConfiguration?this.previousConfiguration.getValue(l,g,this.f?.workspace):void 0,b=this.g.getValue(l,g,this.h);return!T.$io(A,b)}return!0}}e.$To=t;function o(d,l){const{added:g,removed:E,updated:D}=n(l?.rawConfiguration,d?.rawConfiguration),y=[],k=d?.getAllOverrideIdentifiers()||[],A=l?.getAllOverrideIdentifiers()||[];if(l){const b=A.filter(v=>!k.includes(v));for(const v of b)y.push([v,l.getKeysForOverrideIdentifier(v)])}if(d){const b=k.filter(v=>!A.includes(v));for(const v of b)y.push([v,d.getKeysForOverrideIdentifier(v)])}if(l&&d){for(const b of k)if(A.includes(b)){const v=n({contents:d.getOverrideValue(void 0,b)||{},keys:d.getKeysForOverrideIdentifier(b)},{contents:l.getOverrideValue(void 0,b)||{},keys:l.getKeysForOverrideIdentifier(b)});y.push([b,[...v.added,...v.removed,...v.updated]])}}return{added:g,removed:E,updated:D,overrides:y}}function n(d,l){const g=d?l?d.keys.filter(y=>l.keys.indexOf(y)===-1):[...d.keys]:[],E=l?d?l.keys.filter(y=>d.keys.indexOf(y)===-1):[...l.keys]:[],D=[];if(d&&l){for(const y of l.keys)if(d.keys.indexOf(y)!==-1){const k=(0,I.$hj)(l.contents,y),A=(0,I.$hj)(d.contents,y);T.$io(k,A)||D.push(y)}}return{added:g,removed:E,updated:D}}}),define(ke[233],Ie([1,0,21,4,3,68]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fxb=e.$Dxb=e.$Cxb=void 0,e.$Exb=T;const O=(c,I,S)=>{const u=new Uint8Array(16);for(let a=0;a<16;a++)u[a]=Math.round(Math.random()*256);const P=(0,r.$8e)(r.$Ne.wrap(u));return[`GET ws://localhost${c}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${P}`].join(`\r
`)+`\r
\r
`};e.$Cxb=O,e.$Dxb=r.$Ne.fromString(`\r
\r
`);async function T(c,I,S,u,P){c.write(r.$Ne.fromString((0,e.$Cxb)(I,S,u)));const w=new C.$Tc;try{return await new Promise((a,m)=>{let $;w.add(c.onData(f=>{$?$=r.$Ne.concat([$,f],$.byteLength+f.byteLength):$=f;const i=$.indexOf(e.$Dxb);if(i===-1)return;a(c),c.pauseData();const s=$.slice(i+e.$Dxb.byteLength);s.byteLength&&P.onData.fire(s)})),w.add(c.onClose(f=>m(f??new Error("socket closed")))),w.add(c.onEnd(()=>m(new Error("socket ended"))))})}catch(a){throw c.dispose(),a}finally{w.dispose()}}class p extends C.$Uc{constructor(I,S){super(),this.g=I,this.a=this.B(new h.$oe),this.onData=(...u)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...u)),this.b=this.B(new h.$le),this.onDidDispose=this.b.event,this.f=!1,this.B(S.onData),this.B(S.onData.event(u=>this.a.fire(u))),this.onClose=this.B(S.onClose).event,this.onEnd=this.B(S.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(I,S){R.SocketDiagnostics.traceSocketEvent(this,this.g,I,S)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Fxb=p}),define(ke[71],Ie([1,0,13,5]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.RemoteAuthorityResolverErrorCode=e.$Tl=e.$Sl=e.RemoteConnectionType=e.$Rl=void 0,e.$Vl=c,e.$Rl=(0,h.$Fi)("remoteAuthorityResolverService");var C;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class R{constructor(S){this.id=S,this.type=C.Managed}toString(){return`Managed(${this.id})`}}e.$Sl=R;class O{constructor(S,u){this.host=S,this.port=u,this.type=C.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Tl=O;var T;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class p extends r.$ab{static isNotAvailable(S){return S instanceof p&&S._code===T.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof p&&S._code===T.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof p&&S._code===T.NoResolverFound}static isInvalidAuthority(S){return S instanceof p&&S._code===T.InvalidAuthority}static isHandled(S){return S instanceof p&&S.isHandled}constructor(S,u=T.Unknown,P){super(S),this._message=S,this._code=u,this._detail=P,this.isHandled=u===T.NotAvailable&&P===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Ul=p;function c(I){const S=I.indexOf("+");return S===-1?I:I.substring(0,S)}}),define(ke[234],Ie([1,0,7,21,20,13,4,3,14,61,42,32,68,71]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$1l=y,e.$2l=k,e.$3l=b,c=qe(c);const w=30*1e3;var a;(function(ge){ge[ge.Management=1]="Management",ge[ge.ExtensionHost=2]="ExtensionHost",ge[ge.Tunnel=3]="Tunnel"})(a||(e.ConnectionType=a={}));function m(ge){switch(ge){case a.Management:return"Management";case a.ExtensionHost:return"ExtensionHost";case a.Tunnel:return"Tunnel"}}function $(ge){const Y=new C.$we;return setTimeout(()=>Y.cancel(),ge),Y.token}function f(ge,Y){if(ge.isCancellationRequested||Y.isCancellationRequested)return C.CancellationToken.Cancelled;const U=new C.$we;return ge.onCancellationRequested(()=>U.cancel()),Y.onCancellationRequested(()=>U.cancel()),U.token}class i{get didTimeout(){return this.c==="timedout"}constructor(Y){this.c="pending",this.d=new T.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,r.$yh)(),Y.isCancellationRequested?this.h():this.d.add(Y.onCancellationRequested(()=>this.h()))}registerDisposable(Y){this.c==="pending"?this.d.add(Y):Y.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const Y=new Error("Time limit reached");return Y.code="ETIMEDOUT",Y.syscall="connect",Y}resolve(Y){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(Y))}reject(Y){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(Y))}}function s(ge,Y){const U=new i(Y);return U.registerDisposable(ge.onControlMessage(oe=>{const ve=JSON.parse(oe.toString()),te=q(ve);te?U.reject(te):U.resolve(ve)})),U.promise}function t(ge,Y,U,oe,ve,te,ae,se){const X=new i(se),re=I.$fe.create(!1);return ge.info(`Creating a socket (${ae})...`),c.mark(`code/willCreateSocket/${te}`),Y.connect(U,oe,ve,ae).then(pe=>{X.didTimeout?(c.mark(`code/didCreateSocketError/${te}`),ge.info(`Creating a socket (${ae}) finished after ${re.elapsed()} ms, but this is too late and has timed out already.`),pe?.dispose()):(c.mark(`code/didCreateSocketOK/${te}`),ge.info(`Creating a socket (${ae}) was successful after ${re.elapsed()} ms.`),X.resolve(pe))},pe=>{c.mark(`code/didCreateSocketError/${te}`),ge.info(`Creating a socket (${ae}) returned an error after ${re.elapsed()} ms.`),ge.error(pe),X.reject(pe)}),X.promise}function o(ge,Y){const U=new i(Y);return ge.then(oe=>{U.didTimeout||U.resolve(oe)},oe=>{U.didTimeout||U.reject(oe)}),U.promise}async function n(ge,Y,U,oe){const ve=ne(ge,Y);ge.logService.trace(`${ve} 1/6. invoking socketFactory.connect().`);let te;try{te=await t(ge.logService,ge.remoteSocketFactoryService,ge.connectTo,p.$Sg.getServerRootPath(),`reconnectionToken=${ge.reconnectionToken}&reconnection=${ge.reconnectionProtocol?"true":"false"}`,m(Y),`renderer-${m(Y)}-${ge.reconnectionToken}`,oe)}catch(pe){throw ge.logService.error(`${ve} socketFactory.connect() failed or timed out. Error:`),ge.logService.error(pe),pe}ge.logService.trace(`${ve} 2/6. socketFactory.connect() was successful.`);let ae,se;ge.reconnectionProtocol?(ge.reconnectionProtocol.beginAcceptReconnection(te,null),ae=ge.reconnectionProtocol,se=!1):(ae=new u.$ti({socket:te}),se=!0),ge.logService.trace(`${ve} 3/6. sending AuthRequest control message.`);const X=await o(ge.signService.createNewMessage((0,S.$2g)()),oe),re={type:"auth",auth:ge.connectionToken||"00000000000000000000",data:X.data};ae.sendControl(h.$Ne.fromString(JSON.stringify(re)));try{const pe=await s(ae,f(oe,$(1e4)));if(pe.type!=="sign"||typeof pe.data!="string"){const Re=new Error("Unexpected handshake message");throw Re.code="VSCODE_CONNECTION_ERROR",Re}if(ge.logService.trace(`${ve} 4/6. received SignRequest control message.`),!await o(ge.signService.validate(X,pe.signedData),oe)){const Re=new Error("Refused to connect to unsupported server");throw Re.code="VSCODE_CONNECTION_ERROR",Re}const Fe=await o(ge.signService.sign(pe.data),oe),Be={type:"connectionType",commit:ge.commit,signedData:Fe,desiredConnectionType:Y};return U&&(Be.args=U),ge.logService.trace(`${ve} 5/6. sending ConnectionTypeRequest control message.`),ae.sendControl(h.$Ne.fromString(JSON.stringify(Be))),{protocol:ae,ownsProtocol:se}}catch(pe){throw pe&&pe.code==="ETIMEDOUT"&&(ge.logService.error(`${ve} the handshake timed out. Error:`),ge.logService.error(pe)),pe&&pe.code==="VSCODE_CONNECTION_ERROR"&&(ge.logService.error(`${ve} received error control message when negotiating connection. Error:`),ge.logService.error(pe)),se&&H(ae),pe}}async function d(ge,Y,U,oe){const ve=Date.now(),te=ne(ge,Y),{protocol:ae,ownsProtocol:se}=await n(ge,Y,U,oe),X=new i(oe);return X.registerDisposable(ae.onControlMessage(re=>{const pe=JSON.parse(re.toString()),we=q(pe);we?(ge.logService.error(`${te} received error control message when negotiating connection. Error:`),ge.logService.error(we),se&&H(ae),X.reject(we)):(ge.reconnectionProtocol?.endAcceptReconnection(),ge.logService.trace(`${te} 6/6. handshake finished, connection is up and running after ${ye(ve)}!`),X.resolve({protocol:ae,firstMessage:pe}))})),X.promise}async function l(ge,Y){const{protocol:U}=await d(ge,a.Management,void 0,Y);return{protocol:U}}async function g(ge,Y,U){const{protocol:oe,firstMessage:ve}=await d(ge,a.ExtensionHost,Y,U),te=ve&&ve.debugPort;return{protocol:oe,debugPort:te}}async function E(ge,Y,U){const oe=Date.now(),ve=ne(ge,a.Tunnel),{protocol:te}=await n(ge,a.Tunnel,Y,U);return ge.logService.trace(`${ve} 6/6. handshake finished, connection is up and running after ${ye(oe)}!`),te}async function D(ge,Y,U){const{connectTo:oe,connectionToken:ve}=await ge.addressProvider.getAddress();return{commit:ge.commit,quality:ge.quality,connectTo:oe,connectionToken:ve,reconnectionToken:Y,reconnectionProtocol:U,remoteSocketFactoryService:ge.remoteSocketFactoryService,signService:ge.signService,logService:ge.logService}}async function y(ge,Y,U){return A(ge,async oe=>{const{protocol:ve}=await l(oe,C.CancellationToken.None);return new B(ge,Y,U,oe.reconnectionToken,ve)})}async function k(ge,Y){return A(ge,async U=>{const{protocol:oe,debugPort:ve}=await g(U,Y,C.CancellationToken.None);return new ee(ge,Y,U.reconnectionToken,oe,ve)})}async function A(ge,Y){for(let oe=1;;oe++)try{const ve=(0,S.$2g)(),te=await D(ge,ve,null);return await Y(te)}catch(ve){if(oe<5)ge.logService.error(`[remote-connection][attempt ${oe}] An error occurred in initial connection! Will retry... Error:`),ge.logService.error(ve);else throw ge.logService.error(`[remote-connection][attempt ${oe}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),ge.logService.error(ve),W.triggerPermanentFailure(0,0,P.$Ul.isHandled(ve)),ve}}async function b(ge,Y,U){const oe=await D(ge,(0,S.$2g)(),null);return await E(oe,{host:Y,port:U},C.CancellationToken.None)}function v(ge){return(0,r.$sh)(Y=>new Promise((U,oe)=>{const ve=setTimeout(U,ge*1e3);Y.onCancellationRequested(()=>{clearTimeout(ve),U()})}))}var F;(function(ge){ge[ge.ConnectionLost=0]="ConnectionLost",ge[ge.ReconnectionWait=1]="ReconnectionWait",ge[ge.ReconnectionRunning=2]="ReconnectionRunning",ge[ge.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",ge[ge.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class N{constructor(Y,U){this.reconnectionToken=Y,this.millisSinceLastIncomingData=U,this.type=F.ConnectionLost}}e.$4l=N;class L{constructor(Y,U,oe,ve){this.reconnectionToken=Y,this.millisSinceLastIncomingData=U,this.durationSeconds=oe,this.c=ve,this.type=F.ReconnectionWait}skipWait(){this.c.cancel()}}e.$5l=L;class M{constructor(Y,U,oe){this.reconnectionToken=Y,this.millisSinceLastIncomingData=U,this.attempt=oe,this.type=F.ReconnectionRunning}}e.$6l=M;class z{constructor(Y,U,oe){this.reconnectionToken=Y,this.millisSinceLastIncomingData=U,this.attempt=oe,this.type=F.ConnectionGain}}e.$7l=z;class j{constructor(Y,U,oe,ve){this.reconnectionToken=Y,this.millisSinceLastIncomingData=U,this.attempt=oe,this.handled=ve,this.type=F.ReconnectionPermanentFailure}}e.$8l=j;class W extends T.$Uc{static triggerPermanentFailure(Y,U,oe){this._permanentFailure=!0,this.f=Y,this.g=U,this.h=oe,this.j.forEach(ve=>ve.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(Y=>Y.y())}static debugPauseSocketWriting(){this.j.forEach(Y=>Y.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||W._permanentFailure}constructor(Y,U,oe,ve,te){super(),this.t=Y,this.u=U,this.reconnectionToken=oe,this.protocol=ve,this.w=te,this.m=this.B(new O.$le),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new z(this.reconnectionToken,0,0)),this.B(ve.onSocketClose(ae=>{const se=ce(this.t,this.reconnectionToken,!0);ae?ae.type===u.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${se} received socket close event (hadError: ${ae.hadError}).`),ae.error&&this.u.logService.error(ae.error)):(this.u.logService.info(`${se} received socket close event (wasClean: ${ae.wasClean}, code: ${ae.code}, reason: ${ae.reason}).`),ae.event&&this.u.logService.error(ae.event)):this.u.logService.info(`${se} received socket close event.`),this.y()})),this.B(ve.onSocketTimeout(ae=>{const se=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${ae.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ae.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ae.timeSinceLastReceivedSomeData}).`),this.y()})),W.j.push(this),this.B((0,T.$Sc)(()=>{const ae=W.j.indexOf(this);ae>=0&&W.j.splice(ae,1)})),this.n&&this.D(W.f,W.g,W.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const Y=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Y} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let oe=-1;do{oe++;const ve=oe<U.length?U[oe]:U[U.length-1];try{if(ve>0){const ae=v(ve);this.m.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ve,ae)),this.u.logService.info(`${Y} waiting for ${ve} seconds before reconnecting...`);try{await ae}catch{}}if(this.n){this.u.logService.error(`${Y} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),oe+1)),this.u.logService.info(`${Y} resolving connection...`);const te=await D(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${Y} connecting to ${te.connectTo}...`),await this.G(te,$(w)),this.u.logService.info(`${Y} reconnected!`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),oe+1));break}catch(te){if(te.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${Y} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),oe+1,!1);break}if(oe>360){this.u.logService.error(`${Y} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),oe+1,!1);break}if(P.$Ul.isTemporarilyNotAvailable(te)){this.u.logService.info(`${Y} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if((te.code==="ETIMEDOUT"||te.code==="ENETUNREACH"||te.code==="ECONNREFUSED"||te.code==="ECONNRESET")&&te.syscall==="connect"){this.u.logService.info(`${Y} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if((0,R.$3)(te)){this.u.logService.info(`${Y} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if(te instanceof P.$Ul){this.u.logService.error(`${Y} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),oe+1,P.$Ul.isHandled(te));break}this.u.logService.error(`${Y} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),oe+1,!1);break}}while(!this.n&&!this.s)}C(Y,U,oe){this.w?W.triggerPermanentFailure(Y,U,oe):this.D(Y,U,oe)}D(Y,U,oe){this.m.fire(new j(this.reconnectionToken,Y,U,oe)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$9l=W;class B extends W{constructor(Y,U,oe,ve,te){super(a.Management,Y,ve,te,!0),this.client=this.B(new u.$ri(te,{remoteAuthority:U,clientId:oe},Y.ipcLogger))}async G(Y,U){await l(Y,U)}}e.$0l=B;class ee extends W{constructor(Y,U,oe,ve,te){super(a.ExtensionHost,Y,oe,ve,!1),this.H=U,this.debugPort=te}async G(Y,U){await g(Y,this.H,U)}}e.$$l=ee;function H(ge){try{ge.acceptDisconnect();const Y=ge.getSocket();ge.dispose(),Y.dispose()}catch(Y){(0,R.$Y)(Y)}}function q(ge){if(ge&&ge.type==="error"){const Y=new Error(`Connection error: ${ge.reason}`);return Y.code="VSCODE_CONNECTION_ERROR",Y}return null}function Q(ge,Y){for(;ge.length<Y;)ge+=" ";return ge}function _(ge,Y){return`[remote-connection][${Q(m(ge),13)}][${Y.substr(0,5)}\u2026]`}function ce(ge,Y,U){return`${_(ge,Y)}[${U?"reconnect":"initial"}]`}function ne(ge,Y){return`${ce(Y,ge.reconnectionToken,!!ge.reconnectionProtocol)}[${ge.connectTo}]`}function ye(ge){return`${Date.now()-ge} ms`}}),define(ke[90],Ie([1,0,14]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=h,e.$in=C,e.$jn=R,e.$kn=O;function h(p){return p.scheme===r.Schemas.vscodeRemote?p.authority:void 0}function C(p){if(!p)return;const c=p.indexOf("+");return c<0?p:p.substr(0,c)}function R(p){const{host:c,port:I}=T(p);if(typeof I>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:I}}function O(p,c){let{host:I,port:S}=T(p);return typeof S>"u"&&(S=c),{host:I,port:S}}function T(p){const c=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const I=p.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const S=p.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:p,port:void 0}}}),define(ke[23],Ie([1,0,12,5,90]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$tn=e.$sn=e.$rn=e.TargetPlatform=e.ExtensionType=e.$qn=e.$on=e.$nn=e.$mn=e.$ln=void 0,e.$pn=R,e.$un=S,e.$vn=u,e.$wn=P,e.$xn=w,e.$yn=a,e.$zn=m,r=qe(r),e.$ln="extensions.user.cache",e.$mn="extensions.builtin.cache",e.$nn="undefined_publisher",e.$on=["ui","workspace","web"];function R($){if(typeof $=="object"&&$!==null&&$.supported!==!0)return $.description}e.$qn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function($){$[$.System=0]="System",$[$.User=1]="User"})(O||(e.ExtensionType=O={}));var T;(function($){$.WIN32_X64="win32-x64",$.WIN32_ARM64="win32-arm64",$.LINUX_X64="linux-x64",$.LINUX_ARM64="linux-arm64",$.LINUX_ARMHF="linux-armhf",$.ALPINE_X64="alpine-x64",$.ALPINE_ARM64="alpine-arm64",$.DARWIN_X64="darwin-x64",$.DARWIN_ARM64="darwin-arm64",$.WEB="web",$.UNIVERSAL="universal",$.UNKNOWN="unknown",$.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class p{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,i){if(typeof f>"u"||f===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof f=="string"||typeof i=="string"){const s=typeof f=="string"?f:f.value,t=typeof i=="string"?i:i.value;return r.$Ff(s,t)}return f._lower===i._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$rn=p;class c{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const i of f)this.add(i)}add(f){this.c.add(p.toKey(f))}delete(f){return this.c.delete(p.toKey(f))}has(f){return this.c.has(p.toKey(f))}}e.$sn=c;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete(p.toKey(f))}get(f){return this.c.get(p.toKey(f))}has(f){return this.c.has(p.toKey(f))}set(f,i){this.c.set(p.toKey(f),i)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$tn=I;function S($){return u($)}function u($){return $.contributes&&$.contributes.localizations?$.contributes.localizations.length>0:!1}function P($){return $.contributes&&$.contributes.authentication?$.contributes.authentication.length>0:!1}function w($,f){if(f){const i=`onResolveRemoteAuthority:${(0,C.$in)(f)}`;return!!$.activationEvents?.includes(i)}return!1}function a($){return $.map(f=>{const[i,s]=f.split("@");return{proposalName:i,version:s?parseInt(s):void 0}})}function m($){return $.map(f=>f.split("@")[0])}e.$An=(0,h.$Fi)("IBuiltinExtensionsScannerService")}),define(ke[146],Ie([1,0,10,8,23,5]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.ExtensionManagementErrorCode=e.$mp=e.ExtensionGalleryErrorCode=e.$lp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=void 0,e.$fp=T,e.$gp=p,e.$hp=c,e.$ip=I,e.$jp=S,e.$kp=u,e.$$o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$_o=new RegExp(e.$$o),e.$ap="__web_extension",e.$bp="skipWalkthrough",e.$cp="extensionInstallSource",e.$dp="dependecyOrPackExtensionInstall",e.$ep="clientTargetPlatform";var O;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(O||(e.ExtensionInstallSource=O={}));function T(t){switch(t){case C.TargetPlatform.WIN32_X64:return"Windows 64 bit";case C.TargetPlatform.WIN32_ARM64:return"Windows ARM";case C.TargetPlatform.LINUX_X64:return"Linux 64 bit";case C.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case C.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case C.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case C.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case C.TargetPlatform.DARWIN_X64:return"Mac";case C.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case C.TargetPlatform.WEB:return"Web";case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;case C.TargetPlatform.UNKNOWN:return C.TargetPlatform.UNKNOWN;case C.TargetPlatform.UNDEFINED:return C.TargetPlatform.UNDEFINED}}function p(t){switch(t){case C.TargetPlatform.WIN32_X64:return C.TargetPlatform.WIN32_X64;case C.TargetPlatform.WIN32_ARM64:return C.TargetPlatform.WIN32_ARM64;case C.TargetPlatform.LINUX_X64:return C.TargetPlatform.LINUX_X64;case C.TargetPlatform.LINUX_ARM64:return C.TargetPlatform.LINUX_ARM64;case C.TargetPlatform.LINUX_ARMHF:return C.TargetPlatform.LINUX_ARMHF;case C.TargetPlatform.ALPINE_X64:return C.TargetPlatform.ALPINE_X64;case C.TargetPlatform.ALPINE_ARM64:return C.TargetPlatform.ALPINE_ARM64;case C.TargetPlatform.DARWIN_X64:return C.TargetPlatform.DARWIN_X64;case C.TargetPlatform.DARWIN_ARM64:return C.TargetPlatform.DARWIN_ARM64;case C.TargetPlatform.WEB:return C.TargetPlatform.WEB;case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;default:return C.TargetPlatform.UNKNOWN}}function c(t,o){switch(t){case r.Platform.Windows:return o==="x64"?C.TargetPlatform.WIN32_X64:o==="arm64"?C.TargetPlatform.WIN32_ARM64:C.TargetPlatform.UNKNOWN;case r.Platform.Linux:return o==="x64"?C.TargetPlatform.LINUX_X64:o==="arm64"?C.TargetPlatform.LINUX_ARM64:o==="arm"?C.TargetPlatform.LINUX_ARMHF:C.TargetPlatform.UNKNOWN;case"alpine":return o==="x64"?C.TargetPlatform.ALPINE_X64:o==="arm64"?C.TargetPlatform.ALPINE_ARM64:C.TargetPlatform.UNKNOWN;case r.Platform.Mac:return o==="x64"?C.TargetPlatform.DARWIN_X64:o==="arm64"?C.TargetPlatform.DARWIN_ARM64:C.TargetPlatform.UNKNOWN;case r.Platform.Web:return C.TargetPlatform.WEB}}function I(t,o){return o===C.TargetPlatform.WEB&&!t.includes(C.TargetPlatform.WEB)}function S(t,o,n){return I(o,n)?!1:t===C.TargetPlatform.UNDEFINED||t===C.TargetPlatform.UNIVERSAL?!0:t===C.TargetPlatform.UNKNOWN?!1:t===n}function u(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var P;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var w;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var a;(function(t){t.Install="install",t.Uninstall="uninstall"})(a||(e.StatisticType=a={}));var m;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$lp=(0,R.$Fi)("extensionGalleryService");var $;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})($||(e.ExtensionGalleryErrorCode=$={}));class f extends Error{constructor(o,n){super(o),this.code=n,this.name=n}}e.$mp=f;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class s extends Error{constructor(o,n){super(o),this.code=n,this.name=n}}e.$np=s,e.$op=(0,R.$Fi)("extensionManagementService"),e.$pp="extensionsIdentifiers/disabled",e.$qp="extensionsIdentifiers/enabled",e.$rp=(0,R.$Fi)("IGlobalExtensionEnablementService"),e.$sp=(0,R.$Fi)("IExtensionTipsService"),e.$tp=(0,h.localize2)(11501,"Extensions"),e.$up=(0,h.localize2)(11502,"Preferences")}),define(ke[147],Ie([1,0,13,23]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YG=e.$XG=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(O,T){this.a.set(O,T)}readActivationEvents(O){return this.b.has(O)||this.b.set(O,this.c(O)),this.b.get(O)}createActivationEventsMap(O){const T=Object.create(null);for(const p of O){const c=this.readActivationEvents(p);c.length>0&&(T[h.$rn.toKey(p.identifier)]=c)}return T}c(O){if(typeof O.main>"u"&&typeof O.browser>"u")return[];const T=Array.isArray(O.activationEvents)?O.activationEvents.slice(0):[];for(let p=0;p<T.length;p++)T[p]==="onUri"&&(T[p]=`onUri:${h.$rn.toKey(O.identifier)}`);if(!O.contributes)return T;for(const p in O.contributes){const c=this.a.get(p);if(!c)continue;const I=O.contributes[p],S=Array.isArray(I)?I:[I];try{c(S,T)}catch(u){(0,r.$Y)(u)}}return T}}e.$XG=C,e.$YG=new C});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[235],Ie([1,0,22,43,8,361,23,143]),function($e,e,r,h,C,R,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=I,e.$1p=S,e.$2p=u,e.$3p=P,e.$4p=w,e.$5p=a,e.$6p=m,e.$7p=$,h=Ut(h),C=qe(C),R=qe(R);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,c=/^-(\d{4})(\d{2})(\d{2})$/;function I(s){return s=s.trim(),s==="*"||p.test(s)}function S(s){if(!I(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=s.match(p);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function u(s){if(!s)return null;const t=s.majorBase,o=s.majorMustEqual,n=s.minorBase;let d=s.minorMustEqual;const l=s.patchBase;let g=s.patchMustEqual;s.hasCaret&&(t===0||(d=!1),g=!1);let E=0;if(s.preRelease){const D=c.exec(s.preRelease);if(D){const[,y,k,A]=D;E=Date.UTC(Number(y),Number(k)-1,Number(A))}}return{majorBase:t,majorMustEqual:o,minorBase:n,minorMustEqual:d,patchBase:l,patchMustEqual:g,isMinimum:s.hasGreaterEquals,notBefore:E}}function P(s,t,o){let n;typeof s=="string"?n=u(S(s)):n=s;let d;t instanceof Date?d=t.getTime():typeof t=="string"&&(d=new Date(t).getTime());let l;if(typeof o=="string"?l=u(S(o)):l=o,!n||!l)return!1;const g=n.majorBase,E=n.minorBase,D=n.patchBase;let y=l.majorBase,k=l.minorBase,A=l.patchBase;const b=l.notBefore;let v=l.majorMustEqual,F=l.minorMustEqual,N=l.patchMustEqual;return l.isMinimum?g>y?!0:g<y?!1:E>k?!0:E<k||d&&d<b?!1:D>=A:(g===1&&y===0&&(!v||!F||!N)&&(y=1,k=0,A=0,v=!0,F=!1,N=!1),g<y?!1:g>y?!v:E<k?!1:E>k?!F:D<A?!1:D>A?!N:!(d&&d<b))}function w(s,t,o,n,d,l){const g=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return g.push([h.default.Error,C.localize(11432,null)]),g;if(typeof n.name!="string")return g.push([h.default.Error,C.localize(11433,null,"name")]),g;if(typeof n.version!="string")return g.push([h.default.Error,C.localize(11434,null,"version")]),g;if(!n.engines)return g.push([h.default.Error,C.localize(11435,null,"engines")]),g;if(typeof n.engines.vscode!="string")return g.push([h.default.Error,C.localize(11436,null,"engines.vscode")]),g;if(typeof n.extensionDependencies<"u"&&!i(n.extensionDependencies))return g.push([h.default.Error,C.localize(11437,null,"extensionDependencies")]),g;if(typeof n.activationEvents<"u"){if(!i(n.activationEvents))return g.push([h.default.Error,C.localize(11438,null,"activationEvents")]),g;if(typeof n.main>"u"&&typeof n.browser>"u")return g.push([h.default.Error,C.localize(11439,null,"activationEvents","main","browser")]),g}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&g.push([h.default.Warning,C.localize(11440,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return g.push([h.default.Error,C.localize(11441,null,"main")]),g;{const y=(0,r.$gh)(o,n.main);(0,r.$ah)(y,o)||g.push([h.default.Warning,C.localize(11442,null,y.path,o.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return g.push([h.default.Error,C.localize(11443,null,"browser")]),g;{const y=(0,r.$gh)(o,n.browser);(0,r.$ah)(y,o)||g.push([h.default.Warning,C.localize(11444,null,y.path,o.path)])}}if(!R.valid(n.version))return g.push([h.default.Error,C.localize(11445,null)]),g;const E=[];if(!a(s,t,n,d,E))for(const y of E)g.push([h.default.Error,y]);if(l&&n.enabledApiProposals?.length){const y=[];if(!$([...n.enabledApiProposals],y))for(const k of y)g.push([h.default.Error,k])}return g}function a(s,t,o,n,d){return n||typeof o.main>"u"&&typeof o.browser>"u"?!0:f(s,t,o.engines.vscode,d)}function m(s,t,o){return s==="*"||f(t,o,s)}function $(s,t){if(s.length===0)return!0;const o=Array.isArray(t)?t:void 0,n=(o?void 0:t)??T.allApiProposals,d=[],l=(0,O.$yn)(s);for(const{proposalName:g,version:E}of l){const D=n[g];D&&E&&D.version!==E&&d.push(C.localize(11446,null,g))}return o?.push(...d),d.length===0}function f(s,t,o,n=[]){const d=u(S(o));if(!d)return n.push(C.localize(11447,null,o)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return n.push(C.localize(11448,null,o)),!1}else if(!d.majorMustEqual)return n.push(C.localize(11449,null,o)),!1;return P(s,t,d)?!0:(n.push(C.localize(11450,null,s,o)),!1)}function i(s){if(!Array.isArray(s))return!1;for(let t=0,o=s.length;t<o;t++)if(typeof s[t]!="string")return!1;return!0}}),define(ke[236],Ie([1,0,3,5]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=void 0,e.$Wl=(0,h.$Fi)("remoteSocketFactoryService");class C{constructor(){this.a={}}register(O,T){return this.a[O]??=[],this.a[O].push(T),(0,r.$Sc)(()=>{const p=this.a[O]?.indexOf(T);typeof p=="number"&&p>=0&&this.a[O]?.splice(p,1)})}b(O){return(this.a[O.type]||[]).find(p=>p.supports(O))}connect(O,T,p,c){const I=this.b(O);if(!I)throw new Error(`No socket factory found for ${O}`);return I.connect(O,T,p,c)}}e.$Xl=C}),define(ke[237],Ie([1,0,21,13,3,8,70,5,11,36]),function($e,e,r,h,C,R,O,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=void 0,e.$0p=u,e.$$p=P,e.$_p=w,e.$aq=a,e.$bq=m,e.$cq=$,e.$8p=(0,T.$Fi)("requestService");class I{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const o in this.b)o.toLowerCase()==="authorization"||o.toLowerCase()==="proxy-authorization"?t[o]="*****":t[o]=this.b[o];this.a=t}return this.a}}class S extends C.$Uc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,R.localize)(11219,null),when:p.$sk.isEqualTo((0,p.$pk)(p.LogLevel.Trace)).serialize()})}async c(t,o,n){const d=`${t} #${++this.b}: ${o.url}`;this.a.trace(`${d} - begin`,o.type,new I(o.headers??{}));try{const l=await n();return this.a.trace(`${d} - end`,o.type,l.res.statusCode,l.res.headers),l}catch(l){throw this.a.error(`${d} - error`,o.type,(0,h.$9)(l)),l}}}e.$9p=S;function u(s){return s.res.statusCode&&s.res.statusCode>=200&&s.res.statusCode<300||s.res.statusCode===1223}function P(s){return s.res.statusCode===204}async function w(s){return P(s)?null:(await(0,r.$Ze)(s.stream)).toString()}async function a(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);return w(s)}async function m(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);if(P(s))return null;const o=(await(0,r.$Ze)(s.stream)).toString();try{return JSON.parse(o)}catch(n){throw n.message+=`:
`+o,n}}function $(s){i(s)}let f;function i(s){const t=c.$ro.as(O.$wo.Configuration),o=f;f={id:"http",order:15,title:(0,R.localize)(11220,null),type:"object",scope:s,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(11221,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(11222,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(11223,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,R.localize)(11224,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(11225,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(11226,null),(0,R.localize)(11227,null),(0,R.localize)(11228,null),(0,R.localize)(11229,null)],default:"override",description:(0,R.localize)(11230,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11231,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(11232,null),restricted:!0}}},t.updateConfigurations({add:[f],remove:o?[o]:[]})}i(O.ConfigurationScope.APPLICATION)}),define(ke[238],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;class r{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(C){try{const R=await this.c();if(R){const O=String(r.a++);return this.b.set(O,R),{id:O,data:R.createNewMessage(C)}}}catch{}return{id:"",data:C}}async validate(C,R){if(!C.id)return!0;const O=this.b.get(C.id);if(!O)return!1;this.b.delete(C.id);try{return O.validate(R)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(C){try{return await this.d(C)}catch{}return C}}e.$Mcc=r}),define(ke[117],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.$Yl=void 0,e.$Yl="signService",e.$Zl=(0,r.$Fi)(e.$Yl)}),define(ke[148],Ie([1,0,238]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;class h extends r.$Mcc{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(O=>new O.signer().sign(R))}h(){return new Promise((R,O)=>$e(["vsda"],R,O))}}e.$Uhc=h}),define(ke[239],Ie([1,0,10,55,32]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=O,e.$wp=T;function R(p){if(r.$v===r.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function O(p,c,I,S,u,P,w,a,m,$){const f=Object.create(null);f["common.machineId"]=P,f["common.sqmId"]=w,f["common.devDeviceId"]=a,f.sessionID=(0,C.$2g)()+Date.now(),f.commitHash=S,f.version=u,f["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,r.$i)(r.$v),f["common.nodePlatform"]=h.$dc,f["common.nodeArch"]=I,f["common.product"]=$||"desktop",m&&(f["common.msftInternal"]=m);let i=0;const s=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),r.$m&&(f["common.snap"]="true");const t=R(c);return t&&(f["common.platformDetail"]=t),f}function T(p){const c=h.env.USERDNSDOMAIN;if(!c)return!1;const I=c.toLowerCase();return p.some(S=>I===S)}}),define(ke[149],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=void 0,e.$_l=(0,r.$Fi)("telemetryService"),e.$am=(0,r.$Fi)("customEndpointTelemetryService"),e.$bm="telemetry.currentSessionDate",e.$cm="telemetry.firstSessionDate",e.$dm="telemetry.lastSessionDate",e.$em="telemetry.machineId",e.$fm="telemetry.sqmId",e.$gm="telemetry.devDeviceId",e.$hm="telemetry",e.$im="telemetry.telemetryLevel",e.$jm="telemetry.enableCrashReporter",e.$km="telemetry.enableTelemetry";var h;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(h||(e.TelemetryLevel=h={}));var C;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(ke[91],Ie([1,0,24,17,90,239,149]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=void 0,e.$Ep=I,e.$Fp=S,e.$Gp=u,e.$Hp=P,e.$Ip=a,e.$Jp=$,e.$Kp=f,e.$Lp=t;class T{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$xp=T;class p{constructor(){this.telemetryLevel=O.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$yp=p,e.$zp=new p;class c{async publicLog(n,d,l){}async publicLogError(n,d,l){}}e.$Ap=c,e.$Bp="telemetry",e.$Cp="extensionTelemetryLog",e.$Dp={log:()=>null,flush:()=>Promise.resolve(null)};function I(o,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!o.enableTelemetry)}function S(o,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}function u(o){const n=o.getValue(O.$im),d=o.getValue(O.$jm);if(o.getValue(O.$km)===!1||d===!1)return O.TelemetryLevel.NONE;switch(n??O.TelemetryConfiguration.ON){case O.TelemetryConfiguration.ON:return O.TelemetryLevel.USAGE;case O.TelemetryConfiguration.ERROR:return O.TelemetryLevel.ERROR;case O.TelemetryConfiguration.CRASH:return O.TelemetryLevel.CRASH;case O.TelemetryConfiguration.OFF:return O.TelemetryLevel.NONE}}function P(o){const n={},d={},l={};m(o,l);for(let g in l){g=g.length>150?g.substr(g.length-149):g;const E=l[g];typeof E=="number"?d[g]=E:typeof E=="boolean"?d[g]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${E.length}`),n[g]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(n[g]=E)}return{properties:n,measurements:d}}const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(o){if(!o)return"none";const n=(0,C.$in)(o);return w.has(n)?n:"other"}function m(o,n,d=0,l){if(o)for(const g of Object.getOwnPropertyNames(o)){const E=o[g],D=l?l+g:g;Array.isArray(E)?n[D]=(0,r.$jo)(E):E instanceof Date?n[D]=E.toISOString():(0,h.$gg)(E)?d<2?m(E,n,d+1,D+"."):n[D]=(0,r.$jo)(E):n[D]=E}}function $(o,n){const d=o.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,R.$wp)(d)||l}function f(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}function i(o,n){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let d=o;const l=[];for(const y of n)for(;;){const k=y.exec(o);if(!k)break;l.push([k.index,y.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(d="";;){const y=E.exec(o);if(!y)break;const k=l.some(([A,b])=>y.index<b&&A<E.lastIndex);!g.test(y[0])&&!k&&(d+=o.substring(D,y.index)+"<REDACTED: user-file-path>",D=E.lastIndex)}return D<o.length&&(d+=o.substr(D)),d}function s(o){if(!o)return o;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of n)if(d.regex.test(o))return`<REDACTED: ${d.label}>`;return o}function t(o,n){return(0,r.$go)(o,d=>{if(d instanceof T||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let l=d.replaceAll("%20"," ");l=i(l,n);for(const g of n)l=l.replace(g,"");return l=s(l),l}})}}),define(ke[240],Ie([1,0,12,146,23,10,2,13,55,91]),function($e,e,r,h,C,R,O,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Np=void 0,e.$Mp=I,e.$Op=w,e.$Pp=a,e.$Qp=m,e.$Rp=$,e.$Sp=f,e.$Tp=i,e.$Up=s,e.$Wp=t,e.$Xp=n;function I(d,l){return d.uuid&&l.uuid?d.uuid===l.uuid:d.id===l.id?!0:(0,r.$Af)(d.id,l.id)===0}const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(l){const g=l.manifest?l.manifest.version:l.version,E=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new u(l.identifier,g,E)}static parse(l){const g=S.exec(l);return g&&g[1]&&g[2]?new u({id:g[1]},g[2],g[4]||void 0):null}constructor(l,g,E=C.TargetPlatform.UNDEFINED){this.identifier=l,this.version=g,this.targetPlatform=E,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==C.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof u?I(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$Np=u;const P=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(d){const l=P.exec(d);return l&&l[1]?[m(l[1]),l[2]]:[m(d),void 0]}function a(d,l){return`${d}.${l}`}function m(d){return d.toLowerCase()}function $(d,l){return m(a(d??C.$nn,l))}function f(d,l){const g=[],E=D=>{for(const y of g)if(y.some(k=>I(l(k),l(D))))return y;return null};for(const D of d){const y=E(D);y?y.push(D):g.push([D])}return g}function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function s(d){return{id:new c.$xp(d.identifier.id),name:new c.$xp(d.name),version:d.version,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Vp=new C.$rn("pprice.better-merge");function t(d,l){const g=[],E=l.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const D=E.shift();if(D&&g.every(y=>!I(y.identifier,{id:D}))){const y=d.filter(k=>I(k.identifier,{id:D}));y.length===1&&(g.push(y[0]),E.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}async function o(d,l){if(!R.$l)return!1;let g;try{g=(await d.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{g=(await d.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){l.debug("Error while getting the os-release file.",(0,T.$9)(D))}}return!!g&&(g.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(d,l){const g=await o(d,l),E=(0,h.$hp)(g?"alpine":R.$v,p.$ec);return l.debug("ComputeTargetPlatform:",E),E}}),define(ke[241],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=r,e.$Gs=h,e.$Hs=C,e.$Is=R,e.$Js=O,e.$Ks=T;function r(p){return[...p.entries()]}function h(p){return p?[...p.entries()]:[]}function C(p){return new Map(p)}function R(p){return new Map(p??[])}function O(p){return Array.from(p.entries()).map(c=>[c[0],r(c[1].map),h(c[1].descriptionMap)])}function T(p){return new Map(p.map(c=>[c[0],{map:C(c[1]),descriptionMap:R(c[2])}]))}}),define(ke[242],Ie([1,0,5,35,36]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=e.$rs=e.$qs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ps=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$os=void 0,e.$os=new h.$Wj("terminalTabFocusMode",!1,!0);var R;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var O;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(O||(e.TerminalSettingId=O={}));var T;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(T||(e.PosixShellType=T={}));var p;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(p||(e.WindowsShellType=p={}));var c;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var I;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(I||(e.TerminalIpcChannels=I={}));var S;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(S||(e.ProcessPropertyType=S={})),e.$ps=(0,r.$Fi)("ptyService");var u;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var P;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(P||(e.TerminalLocation=P={}));var w;(function(t){t.TerminalView="view",t.Editor="editor"})(w||(e.TerminalLocationString=w={}));var a;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(a||(e.LocalReconnectConstants=a={}));var m;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var $;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var f;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$qs={Backend:"workbench.contributions.terminal.processBackend"};class s{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(o){const n=this.b(o.remoteAuthority);if(this.a.has(n))throw new Error(`A terminal backend with remote authority '${n}' was already registered.`);this.a.set(n,o)}getTerminalBackend(o){return this.a.get(this.b(o))}b(o){return o?.toLowerCase()??""}}C.$ro.add(e.$qs.Backend,new s),e.$rs=(0,r.$Fi)("localPtyService"),e.$ss=(0,r.$Fi)("terminalLogService")}),define(ke[243],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xxb=void 0;class r{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,R,O=5){const T=R(p=>{const c=typeof p=="string"?p:p.data;let I=this.a.get(C);if(I){I.data.push(c);return}const S=setTimeout(()=>this.flushBuffer(C),O);I={data:[c],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(C),T.dispose()}},this.a.set(C,I)});return T}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const R=this.a.get(C);R&&(this.a.delete(C),this.b(C,R.data.join("")))}}e.$Xxb=r}),define(ke[244],Ie([1,0,7,82,106,51,4,17,2,8,116,36]),function($e,e,r,h,C,R,O,T,p,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ix=e.$Hx=e.$Gx=e.$Fx=e.$Ex=e.$Dx=e.IconFontDefinition=e.IconContribution=e.$Ax=void 0,e.$Bx=m,e.$Cx=$,S=qe(S),e.$Ax={IconContribution:"base.contributions.icons"};var u;(function(t){function o(n,d){let l=n.defaults;for(;R.ThemeIcon.isThemeIcon(l);){const g=a.getIcon(l.id);if(!g)return;l=g.defaults}return l}t.getDefinition=o})(u||(e.IconContribution=u={}));var P;(function(t){function o(d){return{weight:d.weight,style:d.style,src:d.src.map(l=>({format:l.format,location:l.location.toString()}))}}t.toJSONObject=o;function n(d){const l=g=>(0,T.$eg)(g)?g:void 0;if(d&&Array.isArray(d.src)&&d.src.every(g=>(0,T.$eg)(g.format)&&(0,T.$eg)(g.location)))return{weight:l(d.weight),style:l(d.style),src:d.src.map(g=>({format:g.format,location:p.URI.parse(g.location)}))}}t.fromJSONObject=n})(P||(e.IconFontDefinition=P={}));class w{constructor(){this.a=new O.$le,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(11151,null)},fontCharacter:{type:"string",description:(0,c.localize)(11152,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(o,n,d,l){const g=this.b[o];if(g){if(d&&!g.description){g.description=d,this.d.properties[o].markdownDescription=`${d} $(${o})`;const y=this.e.enum.indexOf(o);y!==-1&&(this.e.enumDescriptions[y]=d),this.a.fire()}return g}const E={id:o,description:d,defaults:n,deprecationMessage:l};this.b[o]=E;const D={$ref:"#/definitions/icons"};return l&&(D.deprecationMessage=l),d&&(D.markdownDescription=`${d}: $(${o})`),this.d.properties[o]=D,this.e.enum.push(o),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:o}}deregisterIcon(o){delete this.b[o],delete this.d.properties[o];const n=this.e.enum.indexOf(o);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(o=>this.b[o])}getIcon(o){return this.b[o]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(o,n){const d=this.f[o];return d||(this.f[o]=n,this.a.fire(),n)}deregisterIconFont(o){delete this.f[o]}getIconFont(o){return this.f[o]}toString(){const o=(g,E)=>g.id.localeCompare(E.id),n=g=>{for(;R.ThemeIcon.isThemeIcon(g.defaults);)g=this.b[g.defaults.id];return`codicon codicon-${g?g.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(g=>this.b[g]);for(const g of l.filter(E=>!!E.description).sort(o))d.push(`|<i class="${n(g)}"></i>|${g.id}|${R.ThemeIcon.isThemeIcon(g.defaults)?g.defaults.id:g.id}|${g.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const g of l.filter(E=>!R.ThemeIcon.isThemeIcon(E.defaults)).sort(o))d.push(`|<i class="${n(g)}"></i>|${g.id}|`);return d.join(`
`)}}const a=new w;S.$ro.add(e.$Ax.IconContribution,a);function m(t,o,n,d){return a.registerIcon(t,o,n,d)}function $(){return a}function f(){const t=(0,C.$1j)();for(const o in t){const n="\\"+t[o].toString(16);a.registerIcon(o,{fontCharacter:n})}}f(),e.$Dx="vscode://schemas/icons";const i=S.$ro.as(I.$so.JSONContribution);i.registerSchema(e.$Dx,a.getIconSchema());const s=new r.$Rh(()=>i.notifySchemaChanged(e.$Dx),200);a.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$Ex=m("widget-close",h.$5j.close,(0,c.localize)(11153,null)),e.$Fx=m("goto-previous-location",h.$5j.arrowUp,(0,c.localize)(11154,null)),e.$Gx=m("goto-next-location",h.$5j.arrowDown,(0,c.localize)(11155,null)),e.$Hx=R.ThemeIcon.modify(h.$5j.sync,"spin"),e.$Ix=R.ThemeIcon.modify(h.$5j.loading,"spin")}),define(ke[92],Ie([1,0,4,3,10,2,46,5,11]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pw=e.$Ow=e.$Lw=e.$Jw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Fw=e.$Ew=void 0,e.$Gw=S,e.$Hw=P,e.$Iw=w,e.$Kw=a,e.$Mw=m,e.$Nw=$,e.$Ew=(0,T.$Fi)("tunnelService"),e.$Fw=(0,T.$Fi)("sharedTunnelsService");var c;(function(s){s.Http="http",s.Https="https"})(c||(e.TunnelProtocol=c={}));var I;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(I||(e.TunnelPrivacyId=I={}));function S(s){return!!s.forwardPort}var u;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function P(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(t)return{address:t[1],port:+t[2]}}function w(s){if(s.scheme!=="http"&&s.scheme!=="https"||!s.query)return;const t=s.query.split("&");for(const o of t){const n=o.split("=")[1];if(/^https?:/.exec(n)){const d=P(R.URI.parse(n));if(d)return d}}}e.$Jw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function a(s){return e.$Jw.indexOf(s)>=0}e.$Lw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(s){return e.$Lw.indexOf(s)>=0}function $(s,t,o,n){if(o===C.OperatingSystem.Windows)return!1;if(o===C.OperatingSystem.Macintosh&&m(t)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(d?.length===4&&parseInt(d[1])>=18)return!1}return s<1024}class f{constructor(t,o,n){this.remoteAddress=t,this.localAddress=o,this.b=n,this.a=new r.$le,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Ow=f;let i=class extends h.$Uc{constructor(t,o){super(),this.r=t,this.s=o,this.a=new r.$le,this.onTunnelOpened=this.a.event,this.b=new r.$le,this.onTunnelClosed=this.b.event,this.c=new r.$le,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],o=Array.from(this.f.values());for(const n of o){const d=Array.from(n.values());for(const l of d){const g=await l.value;g&&typeof g!="string"&&t.push(g)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:o}of t.values())await o.then(n=>typeof n!="string"?n?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,o,n,d,l){this.z(t,o,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:o,localAddress:n,privacy:d,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,o){(m(t)||a(t))&&(t=e.$Jw[0]);const n=this.D(t,o);if(n)return++n.refcount,n.value}openTunnel(t,o,n,d,l,g=!1,E,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${n} on local port ${l}.`);const y=this.g??t;if(!y)return;if(o||(o="localhost"),d||(d=this.t),this.g&&this.n.has(n)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const k=this.F(y,o,n,d,l,g,E,D);return k?k.then(A=>{if(A){if(typeof A=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(o,n),A}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(o,n);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.w(A);return(A.tunnelRemoteHost!==o||A.tunnelRemotePort!==n)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),E&&A.privacy!==E&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(b),b}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),k)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const o=this.f.get(t.tunnelRemoteHost);if(o){const n=o.get(t.tunnelRemotePort);n&&(n.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,n))}}}}async y(t,o,n){if(n.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${o}.`);const d=n.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(o),d}}async closeTunnel(t,o){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${o} `);const n=this.f.get(t);if(n&&n.has(o)){const d=n.get(o);d.refcount=0,await this.y(t,o,d)}}z(t,o,n){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(o,{refcount:1,value:n})}async C(t,o){const n=this.f.get(t);if(n){const d=n.get(o),l=d?await d.value:void 0;(!l||typeof l=="string")&&n.delete(o),n.size===0&&this.f.delete(t)}}D(t,o){const n=[t];a(t)?(n.push(...e.$Jw),n.push(...e.$Lw)):m(t)&&n.push(...e.$Lw);const d=n.map(l=>this.f.get(l));for(const l of d){const g=l?.get(o);if(g)return g}}canTunnel(t){return!!P(t)}G(t,o,n,d,l,g,E){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${n} on local port ${d}.`);const D=n;this.n.add(D);const y=d===void 0?n:d,k={elevationRequired:l?this.isPortPrivileged(y):!1},A={remoteAddress:{host:o,port:n},localAddressPort:d,privacy:g,public:g?g!==I.Private:void 0,protocol:E},b=t.forwardPort(A,k);return b?(this.z(o,n,b),b.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),b}};e.$Pw=i,e.$Pw=i=Je([Ve(0,p.$ak),Ve(1,O.$_i)],i)}),define(ke[245],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=void 0,e.$Kl=(0,r.$Fi)("IUriIdentityService")}),define(ke[246],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Qw=void 0,e.$Qw=(0,r.$Fi)("editSessionIdentityService");var h;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(h||(e.EditSessionIdentityMatch=h={}))}),define(ke[247],Ie([1,0,14]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=h,e.$iN=C,e.$jN=R,e.$kN=O,e.$lN=T;function h(p){return p.scheme!==r.Schemas.file&&p.scheme!==r.Schemas.vscodeRemote}function C(p){if(p.folders.length)return p.folders.every(c=>h(c.uri))?p.folders[0].uri:void 0;if(p.configuration&&h(p.configuration))return p.configuration}function R(p){return C(p)?.scheme}function O(p){return C(p)?.authority}function T(p){return C(p)!==void 0}}),define(ke[47],Ie([1,0,8,16,84,22,2,5,14]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$5i=e.$4i=e.$3i=e.$2i=e.$Zi=e.$Yi=e.WorkbenchState=e.$Si=e.$Ri=e.$Oi=void 0,e.$Pi=c,e.$Qi=I,e.$Ti=S,e.$Ui=u,e.$Vi=P,e.$Wi=a,e.$Xi=m,e.$1i=i,e.$6i=s,e.$7i=t,e.$9i=o,e.$0i=n,e.$$i=d,e.$Oi=(0,T.$Fi)("contextService");function c(l){const g=l;return typeof g?.id=="string"&&O.URI.isUri(g.uri)}function I(l){return typeof l?.id=="string"&&!c(l)&&!u(l)}e.$Ri={id:"ext-dev"},e.$Si={id:"empty-window"};function S(l,g){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,h.$nc)(l)}:g?e.$Ri:e.$Si;const E=l;return E.configuration?{id:E.id,configPath:E.configuration}:E.folders.length===1?{id:E.id,uri:E.folders[0].uri}:{id:E.id}}function u(l){const g=l;return typeof g?.id=="string"&&O.URI.isUri(g.configPath)}function P(l){const g=l;if(g?.uri)return{id:g.id,uri:O.URI.revive(g.uri)};const E=l;if(E?.configPath)return{id:E.id,configPath:O.URI.revive(E.configPath)};if(l?.id)return{id:l.id}}var w;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function a(l){const g=l;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}function m(l){const g=l;return!!(g&&typeof g=="object"&&O.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}class ${constructor(g,E,D,y,k){this.h=g,this.j=D,this.k=y,this.l=k,this.c=C.$Li.forUris(this.l,()=>!0),this.folders=E}update(g){this.h=g.id,this.k=g.configuration,this.j=g.transient,this.l=g.l,this.folders=g.folders}get folders(){return this.g}set folders(g){this.g=g,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(g){this.k=g}getFolder(g){return g&&this.c.findSubstr(g)||null}n(){this.c=C.$Li.forUris(this.l,()=>!0);for(const g of this.folders)this.c.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Yi=$;class f{constructor(g,E){this.raw=E,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,R.$gh)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Zi=f;function i(l){return new f({uri:l,index:0,name:(0,R.$ch)(l)},{uri:l.toString()})}e.$2i="code-workspace",e.$3i=`.${e.$2i}`,e.$4i=[{name:(0,r.localize)(11030,null),extensions:[e.$2i]}],e.$5i="workspace.json";function s(l,g){return R.$0g.isEqualOrParent(l,g.untitledWorkspacesHome)}function t(l){let g;return O.URI.isUri(l)?g=l:g=l.configuration,g?.scheme===p.Schemas.tmp}e.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function o(l){return l.id===e.$8i}function n(l,g){return!s(l,g)&&!t(l)}function d(l){return(typeof l=="string"?(0,h.$oc)(l):(0,R.$eh)(l))===e.$3i}}),define(ke[150],Ie([1,0,60,4,3,22,2,8,144,27,5,11,47,28,245,7,32,12,17]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.$Ml=e.ProfileResourceType=void 0,e.$Ll=s,e.$Nl=t,e.$Ol=o;var i;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function s(l){const g=l;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&typeof g.isDefault=="boolean"&&typeof g.name=="string"&&O.URI.isUri(g.location)&&O.URI.isUri(g.globalStorageHome)&&O.URI.isUri(g.settingsResource)&&O.URI.isUri(g.keybindingsResource)&&O.URI.isUri(g.tasksResource)&&O.URI.isUri(g.snippetsHome)&&O.URI.isUri(g.extensionsResource))}e.$Ml=(0,I.$Fi)("IUserDataProfilesService");function t(l,g){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:O.URI.revive(l.location).with({scheme:g}),globalStorageHome:O.URI.revive(l.globalStorageHome).with({scheme:g}),settingsResource:O.URI.revive(l.settingsResource).with({scheme:g}),keybindingsResource:O.URI.revive(l.keybindingsResource).with({scheme:g}),tasksResource:O.URI.revive(l.tasksResource).with({scheme:g}),snippetsHome:O.URI.revive(l.snippetsHome).with({scheme:g}),extensionsResource:O.URI.revive(l.extensionsResource).with({scheme:g}),cacheHome:O.URI.revive(l.cacheHome).with({scheme:g}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function o(l,g,E,D,y,k){return{id:l,name:g,location:E,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:k&&y?.useDefaultFlags?.globalState?k.globalStorageHome:(0,R.$gh)(E,"globalStorage"),settingsResource:k&&y?.useDefaultFlags?.settings?k.settingsResource:(0,R.$gh)(E,"settings.json"),keybindingsResource:k&&y?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,R.$gh)(E,"keybindings.json"),tasksResource:k&&y?.useDefaultFlags?.tasks?k.tasksResource:(0,R.$gh)(E,"tasks.json"),snippetsHome:k&&y?.useDefaultFlags?.snippets?k.snippetsHome:(0,R.$gh)(E,"snippets"),extensionsResource:k&&y?.useDefaultFlags?.extensions?k.extensionsResource:(0,R.$gh)(E,"extensions.json"),cacheHome:(0,R.$gh)(D,l),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let n=class extends C.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(g,E,D,y){super(),this.t=g,this.u=E,this.w=D,this.y=y,this.f=!0,this.h=this.B(new h.$le),this.onDidChangeProfiles=this.h.event,this.j=this.B(new h.$le),this.onWillCreateProfile=this.j.event,this.m=this.B(new h.$le),this.onWillRemoveProfile=this.m.event,this.n=this.B(new h.$le),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new P.$Ac,workspaces:new P.$Ac,emptyWindows:new Map},this.profilesHome=(0,R.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(g){this.f!==g&&(this.z=void 0,this.f=g)}isEnabled(){return this.f}get C(){if(!this.z){const g=this.D(),E=[g];if(this.f)try{for(const k of this.O()){if(!k.name||!(0,f.$eg)(k.name)||!k.location){this.y.warn("Skipping the invalid stored profile",k.location||k.name);continue}E.push(o((0,R.$dh)(k.location),k.name,k.location,this.g,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},g))}}catch(k){this.y.error(k)}const D=new P.$Ac,y=new Map;if(E.length)try{const k=this.Q();if(k.workspaces)for(const[A,b]of Object.entries(k.workspaces)){const v=O.URI.parse(A),F=E.find(N=>N.id===b);F&&D.set(v,F)}if(k.emptyWindows)for(const[A,b]of Object.entries(k.emptyWindows)){const v=E.find(F=>F.id===b);v&&y.set(A,v)}}catch(k){this.y.error(k)}this.z={profiles:E,workspaces:D,emptyWindows:y}}return this.z}D(){const g=o("__default__profile__",(0,T.localize)(11077,null),this.t.userRoamingDataHome,this.g);return{...g,extensionsResource:this.S()??g.extensionsResource,isDefault:!0}}async createTransientProfile(g){const E="Temp",D=new RegExp(`${(0,$.$hf)(E)}\\s(\\d+)`);let y=0;for(const A of this.profiles){const b=D.exec(A.name),v=b?parseInt(b[1]):0;y=v>y?v:y}const k=`${E} ${y+1}`;return this.createProfile((0,r.$tj)((0,m.$2g)()).toString(16),k,{transient:!0},g)}async createNamedProfile(g,E,D){return this.createProfile((0,r.$tj)((0,m.$2g)()).toString(16),g,E,D)}async createProfile(g,E,D,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=await this.F(g,E,D);return y&&await this.setProfileForWorkspace(y,k),k}async F(g,E,D){if(!(0,f.$eg)(E)||!E)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(E);return y||(y=(async()=>{try{if(this.profiles.find(v=>v.name===E||v.id===g))throw new Error(`Profile with ${E} name already exists`);const A=o(g,E,(0,R.$gh)(this.profilesHome,g),this.g,D,this.defaultProfile);await this.u.createFolder(A.location);const b=[];return this.j.fire({profile:A,join(v){b.push(v)}}),await a.Promises.settled(b),this.I([A],[],[]),A}finally{this.r.delete(E)}})(),this.r.set(E,y)),y}async updateProfile(g,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(y=>y.id===g.id);if(!D)throw new Error(`Profile '${g.name}' does not exist`);return D=o(D.id,E.name??D.name,D.location,this.g,{shortName:E.shortName??D.shortName,icon:E.icon===null?void 0:E.icon??D.icon,transient:E.transient??D.isTransient,useDefaultFlags:E.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(g.isDefault)throw new Error("Cannot remove default profile");const E=this.profiles.find(y=>y.id===g.id);if(!E)throw new Error(`Profile '${g.name}' does not exist`);const D=[];this.m.fire({profile:E,join(y){D.push(y)}});try{await Promise.allSettled(D)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])E.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])E.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[E],[]);try{await this.u.del(E.cacheHome,{recursive:!0})}catch(y){(0,c.$rl)(y)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(g,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(y=>y.id===E.id);if(!D)throw new Error(`Profile '${E.name}' does not exist`);this.L(g,D)}unsetWorkspace(g,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(g,void 0,E)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const g=await this.u.resolve(this.profilesHome);await Promise.all((g.children||[]).filter(E=>E.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,E.resource))).map(E=>this.u.del(E.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const g=this.s.profiles.filter(E=>!this.H(E));await Promise.allSettled(g.map(E=>this.removeProfile(E)))}getProfileForWorkspace(g){const E=this.G(g),D=O.URI.isUri(E)?this.C.workspaces.get(E):this.C.emptyWindows.get(E);return D||((0,u.$Pi)(g)?this.s.folders.get(g.uri):(0,u.$Ui)(g)?this.s.workspaces.get(g.configPath):this.s.emptyWindows.get(g.id))}G(g){return(0,u.$Pi)(g)?g.uri:(0,u.$Ui)(g)?g.configPath:g.id}H(g){return!!([...this.C.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,g.location))||[...this.C.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,g.location))||[...this.s.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,g.location))||[...this.s.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,g.location))||[...this.s.folders.values()].some(E=>this.w.extUri.isEqual(E.location,g.location)))}I(g,E,D){const y=[...this.profiles,...g],k=[],A=this.s.profiles;this.s.profiles=[];for(let b of y){if(b.isDefault||E.some(F=>b.id===F.id))continue;b=D.find(F=>b.id===F.id)??b;const v=A.find(F=>b.id===F.id);if(b.isTransient)this.s.profiles.push(b);else{if(v){for(const[F,N]of this.s.emptyWindows.entries())if(b.id===N.id){this.L({id:F},b);break}for(const[F,N]of this.s.workspaces.entries())if(b.id===N.id){this.L({id:"",configPath:F},b);break}for(const[F,N]of this.s.folders.entries())if(b.id===N.id){this.L({id:"",uri:F},b);break}}k.push({location:b.location,name:b.name,shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags})}}this.P(k),this.z=void 0,this.J(g,E,D)}J(g,E,D){this.h.fire({added:g,removed:E,updated:D,all:this.profiles})}L(g,E,D){if(D=E?.isTransient?!0:D,D)(0,u.$Pi)(g)?(this.s.folders.delete(g.uri),E&&this.s.folders.set(g.uri,E)):(0,u.$Ui)(g)?(this.s.workspaces.delete(g.configPath),E&&this.s.workspaces.set(g.configPath,E)):(this.s.emptyWindows.delete(g.id),E&&this.s.emptyWindows.set(g.id,E));else{this.L(g,void 0,!0);const y=this.G(g);O.URI.isUri(y)?(this.C.workspaces.delete(y),E&&this.C.workspaces.set(y,E)):(this.C.emptyWindows.delete(y),E&&this.C.emptyWindows.set(y,E)),this.M()}}M(){const g={};for(const[D,y]of this.C.workspaces.entries())g[D.toString()]=y.id;const E={};for(const[D,y]of this.C.emptyWindows.entries())E[D.toString()]=y.id;this.R({workspaces:g,emptyWindows:E}),this.z=void 0}N(g){const E={},D=this.D();if(g.workspaces)for(const[k,A]of Object.entries(g.workspaces)){const b=O.URI.parse(A);E[k]=this.w.extUri.isEqual(b,D.location)?D.id:this.w.extUri.basename(b)}const y={};if(g.emptyWindows)for(const[k,A]of Object.entries(g.emptyWindows)){const b=O.URI.parse(A);y[k]=this.w.extUri.isEqual(b,D.location)?D.id:this.w.extUri.basename(b)}return{workspaces:E,emptyWindows:y}}O(){return[]}P(g){throw new Error("not implemented")}Q(){return{}}R(g){throw new Error("not implemented")}S(){}};e.$Pl=n,e.$Pl=n=Je([Ve(0,p.$Mi),Ve(1,c.$al),Ve(2,w.$Kl),Ve(3,S.$ak)],n);class d extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(g){this.a=g}Q(){return this.X}R(g){this.X=g}}e.$Ql=d}),define(ke[151],Ie([1,0,7,4,3,61,17,193,5,150]),function($e,e,r,h,C,R,O,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$kq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$iq=e.$hq=e.$gq=void 0,e.$jq=P,e.$lq=a,e.$nq=$,e.$gq="__$__isNewStorageMarker",e.$hq="__$__targetStorageMarker",e.$iq=(0,p.$Fi)("storageService");var I;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var S;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var u;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function P(f){const i=f.get(e.$hq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class w extends C.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:w.a}){super(),this.m=i,this.b=this.B(new h.$oe),this.c=this.B(new h.$oe),this.onDidChangeTarget=this.c.event,this.f=this.B(new h.$le),this.onWillSaveState=this.f.event,this.h=this.B(new r.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new C.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,s,t){return h.Event.filter(this.b.event,o=>o.scope===i&&(s===void 0||o.key===s),t)}n(){this.j.value=(0,r.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,C.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,s){const{key:t,external:o}=s;if(t===e.$hq){switch(i){case S.APPLICATION:this.H=void 0;break;case S.PROFILE:this.F=void 0;break;case S.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:o})}w(i){this.f.fire({reason:i})}get(i,s,t){return this.P(s)?.get(i,t)}getBoolean(i,s,t){return this.P(s)?.getBoolean(i,t)}getNumber(i,s,t){return this.P(s)?.getNumber(i,t)}getObject(i,s,t){return this.P(s)?.getObject(i,t)}storeAll(i,s){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,s)})}store(i,s,t,o,n=!1){if((0,O.$ng)(s)){this.remove(i,t,n);return}this.y(()=>{this.z(i,t,o),this.P(t)?.set(i,s,n)})}remove(i,s,t=!1){this.y(()=>{this.z(i,s,void 0),this.P(s)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,s){const t=[],o=this.J(i);for(const n of Object.keys(o))o[n]===s&&t.push(n);return t}z(i,s,t,o=!1){const n=this.J(s);typeof t=="number"?n[i]!==t&&(n[i]=t,this.P(s)?.set(e.$hq,JSON.stringify(n),o)):typeof n[i]=="number"&&(delete n[i],this.P(s)?.set(e.$hq,JSON.stringify(n),o))}get D(){return this.C||(this.C=this.L(S.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(S.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(S.APPLICATION)),this.H}J(i){switch(i){case S.APPLICATION:return this.I;case S.PROFILE:return this.G;default:return this.D}}L(i){const s=this.P(i);return s?P(s):Object.create(null)}isNew(i){return this.getBoolean(e.$gq,i)===!0}async flush(i=I.NONE){this.f.fire({reason:i});const s=this.P(S.APPLICATION),t=this.P(S.PROFILE),o=this.P(S.WORKSPACE);switch(i){case I.NONE:await r.Promises.settled([s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await r.Promises.settled([s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(S.APPLICATION)?.items??new Map,s=this.P(S.PROFILE)?.items??new Map,t=this.P(S.WORKSPACE)?.items??new Map;return $(i,s,t,this.Q(S.APPLICATION)??"",this.Q(S.PROFILE)??"",this.Q(S.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,s){return this.w(I.NONE),(0,c.$Ll)(i)?this.R(i,s):this.S(i,s)}M(i,s){return!(i.id===s.id||a(s)&&a(i))}N(i,s,t){this.y(()=>{const o=new Set;for(const[n,d]of i)o.add(n),s.get(n)!==d&&this.u(t,{key:n,external:!0});for(const[n]of s.items)o.has(n)||this.u(t,{key:n,external:!0})})}}e.$kq=w;function a(f){return f.isDefault||!!f.useDefaultFlags?.globalState}class m extends w{constructor(){super(),this.U=this.B(new T.$eq(new T.$fq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$eq(new T.$fq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$eq(new T.$fq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(S.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(S.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(S.APPLICATION,i)))}P(i){switch(i){case S.APPLICATION:return this.U;case S.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case S.APPLICATION:return"inMemory (application)";case S.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$mq=m;async function $(f,i,s,t,o,n){const d=v=>{try{return JSON.parse(v)}catch{return v}},l=new Map,g=new Map;f.forEach((v,F)=>{l.set(F,v),g.set(F,d(v))});const E=new Map,D=new Map;i.forEach((v,F)=>{E.set(F,v),D.set(F,d(v))});const y=new Map,k=new Map;s.forEach((v,F)=>{y.set(F,v),k.set(F,d(v))}),console.group(t!==o?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const A=[];if(l.forEach((v,F)=>{A.push({key:F,value:v})}),console.table(A),console.groupEnd(),console.log(g),t!==o){console.group(`Storage: Profile (path: ${o}, profile specific)`);const v=[];E.forEach((F,N)=>{v.push({key:N,value:F})}),console.table(v),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${n})`);const b=[];y.forEach((v,F)=>{b.push({key:F,value:v})}),console.table(b),console.groupEnd(),console.log(k)}}),define(ke[118],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qpc=void 0;class r{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const R=this.c++;return this.b.set(R,C),this.e(),R}get(C,R){return this.b.has(C)?this.b.get(C)[R]:void 0}delete(C){this.b.delete(C),this.e()}e(){r.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$qpc=r}),define(ke[62],Ie([1,0,14,22,27,5]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wpc=e.$vpc=void 0;class O{constructor(){this.a=new Set(Object.keys(r.Schemas)),this.b=new Map,this.extUri=new h.$8g(p=>{const c=this.b.get(p.scheme);return!(c===void 0||c&C.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(p,c){c===null?this.b.delete(p.scheme):this.b.set(p.scheme,c)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$vpc=O,e.$wpc=(0,R.$Fi)("IExtHostFileSystemInfo")}),define(ke[29],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AQ=void 0,e.$AQ=(0,r.$Fi)("IExtHostInitDataService")}),define(ke[248],Ie([1,0,8,11,228,29]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Erc=void 0;let O=class extends C.$KR{constructor(p,c,I){const S=I.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",u=I.remote.isRemote?(0,r.localize)(10830,null):p?(0,r.localize)(10831,null):(0,r.localize)(10832,null);super(c.createLogger(S,{name:u}))}};e.$Erc=O,e.$Erc=O=Je([Ve(1,h.$bk),Ve(2,R.$AQ)],O)}),define(ke[249],Ie([1,0,7]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cqc=e.$bqc=void 0;class h{constructor(O,T,p){this.h=new Map,this.a=O,this.b=T,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(c=>(this.f=c,this)),this.g=this.c.onDidChangeStorage(c=>{c.shared===this.b&&c.key===this.a&&(this.f=c.value)}),this.i=new r.$Rh(()=>{const c=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of c.values())I.complete()}catch(I){for(const S of c.values())S.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,O])=>O!==void 0).map(([O])=>O)}get whenReady(){return this.d}get(O,T){let p=this.f[O];return typeof p>"u"&&(p=T),p}update(O,T){this.f[O]=T;const p=this.h.get(O);if(p!==void 0)return p.p;const c=new r.$3h;return this.h.set(O,c),this.i.isScheduled()||this.i.schedule(),c.p}dispose(){this.g.dispose()}}e.$bqc=h;class C extends h{setKeysForSync(O){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},O)}constructor(O,T){super(O.identifier.value,!0,T),this.j=O}}e.$cqc=C}),define(ke[250],Ie([1,0,4,2]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9qc=void 0;class C{constructor(O){this.c=O,this.a=new r.$le,this.onDidSaveNotebookDocument=this.a.event,this.b=new r.$le,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(O,T,p,c){const S=this.c.getNotebookDocument(h.URI.revive(O)).acceptModelChanged(T.value,p,c);this.b.fire(S)}$acceptDirtyStateChanged(O,T){this.c.getNotebookDocument(h.URI.revive(O)).acceptDirty(T)}$acceptModelSaved(O){const T=this.c.getNotebookDocument(h.URI.revive(O));this.a.fire(T.apiNotebook)}}e.$9qc=C}),define(ke[19],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lQ=e.$kQ=void 0,e.$kQ=(0,r.$Fi)("IExtHostRpcService");class h{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$lQ=h}),define(ke[251],Ie([1,0,23,4,3]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lqc=void 0;class R{#e;constructor(T,p){this.disposables=new C.$Tc,this.a=r.$rn.toKey(T.identifier),this.#e=p,this.onDidChange=h.Event.map(h.Event.filter(this.#e.onDidChangePassword,c=>c.extensionId===this.a),c=>({key:c.key}),this.disposables)}dispose(){this.disposables.dispose()}get(T){return this.#e.get(this.a,T)}store(T,p){return this.#e.store(this.a,T,p)}delete(T){return this.#e.delete(this.a,T)}}e.$lqc=R}),define(ke[72],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpc=e.$Lpc=void 0,e.$Lpc=(0,r.$Fi)("IURITransformerService");class h{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=O=>O,this.transformOutgoing=O=>O,this.transformOutgoingURI=O=>O,this.transformOutgoingScheme=O=>O)}}e.$Mpc=h}),define(ke[252],Ie([1,0,253,362,363,67,2,11,364]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$asc=I,r=qe(r),h=qe(h),C=qe(C),R=qe(R);const c=!1;function I(i,s,t,o,n,d){const l=d.environment.useHostProxy,g=typeof l=="boolean"?l:!d.remote.isRemote,E={resolveProxy:k=>i.resolveProxy(k),lookupProxyAuthorization:m.bind(void 0,i,o,n,s,{},{},d.remote.isRemote,g),getProxyURL:()=>s.getConfiguration("http").get("proxy"),getProxySupport:()=>s.getConfiguration("http").get("proxySupport")||"off",getNoProxyConfig:()=>s.getConfiguration("http").get("noProxy")||[],addCertificatesV1:()=>u(s),addCertificatesV2:()=>P(s),log:o,getLogLevel:()=>{const k=o.getLevel();switch(k){case T.LogLevel.Trace:return p.LogLevel.Trace;case T.LogLevel.Debug:return p.LogLevel.Debug;case T.LogLevel.Info:return p.LogLevel.Info;case T.LogLevel.Warning:return p.LogLevel.Warning;case T.LogLevel.Error:return p.LogLevel.Error;case T.LogLevel.Off:return p.LogLevel.Off;default:return A(k)}function A(b){return o.error("Unknown log level",b),p.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:g,loadAdditionalCertificates:async()=>{const k=[];if(d.remote.isRemote&&k.push((0,p.loadSystemCertificates)({log:o})),g){o.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const A=i.loadCertificates();A.then(b=>o.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",b.length)),k.push(A)}return d.environment.extensionTestsLocationURI&&h.globalAgent.testCertificates?.length&&(o.trace("ProxyResolver#loadAdditionalCertificates: Loading test certificates"),k.push(Promise.resolve(h.globalAgent.testCertificates))),(await Promise.all(k)).flat()},env:process.env},D=(0,p.createProxyResolver)(E),y=S(E,D);return a(t,y)}function S(i,s){function t(o,n){return Object.assign(o.default||o,n)}return{http:t(r,(0,p.createHttpPatch)(i,r,s)),https:t(h,(0,p.createHttpPatch)(i,h,s)),net:t(R,(0,p.createNetPatch)(i,R)),tls:t(C,(0,p.createTlsPatch)(i,C))}}function u(i){const s=i.getConfiguration("http");return!s.get("experimental.systemCertificatesV2",c)&&!!s.get("systemCertificates")}function P(i){const s=i.getConfiguration("http");return!!s.get("experimental.systemCertificatesV2",c)&&!!s.get("systemCertificates")}const w=new Map;function a(i,s){return i.getExtensionPathIndex().then(t=>{const o=globalThis._VSCODE_NODE_MODULES.module,n=o._load;o._load=function(l,g,E){if(l==="net")return s.net;if(l==="tls")return s.tls;if(l!=="http"&&l!=="https")return n.apply(this,arguments);const D=t.findSubstr(O.URI.file(g.filename));let y=w.get(D);if(y||w.set(D,y={}),!y[l]){const k=s[l];y[l]={...k}}return y[l]}})}async function m(i,s,t,o,n,d,l,g,E,D,y){const k=n[E];D&&(n[E]=D),s.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${E}`,`proxyAuthenticate:${D}`,`proxyAuthenticateCache:${k}`);const A=D||k,b=Array.isArray(A)?A:typeof A=="string"?[A]:[];if(f(t,b,l),b.some(F=>/^(Negotiate|Kerberos)( |$)/i.test(F))&&!y.kerberosRequested){y.kerberosRequested=!0;try{const F=await new Promise((j,W)=>{$e(["kerberos"],j,W)}).then(qe),N=new URL(E),L=o.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${N.hostname}`:`HTTP@${N.hostname}`);return s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${E}`,`spn:${L}`),"Negotiate "+await(await F.initializeClient(L)).step("")}catch(F){s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",F)}if(l&&g){s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup on host",`proxyURL:${E}`);const F=await i.lookupKerberosAuthorization(E);if(F)return"Negotiate "+F}}const v=b.find(F=>/^Basic( |$)/i.test(F));if(v)try{const F=d[E];if(F)if(y.basicAuthCacheUsed)s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication deleting cached credentials",`proxyURL:${E}`),delete d[E];else return s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication using cached credentials",`proxyURL:${E}`),y.basicAuthCacheUsed=!0,F;y.basicAuthAttempt=(y.basicAuthAttempt||0)+1;const N=/ realm="([^"]+)"/i.exec(v)?.[1];s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication lookup",`proxyURL:${E}`,`realm:${N}`);const L=new URL(E),M={scheme:"basic",host:L.hostname,port:Number(L.port),realm:N||"",isProxy:!0,attempt:y.basicAuthAttempt},z=await i.lookupAuthorization(M);if(z){s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication received credentials",`proxyURL:${E}`,`realm:${N}`);const j="Basic "+Buffer.from(`${z.username}:${z.password}`).toString("base64");return d[E]=j,j}else s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication received no credentials",`proxyURL:${E}`,`realm:${N}`)}catch(F){s.error("ProxyResolver#lookupProxyAuthorization Basic authentication failed",F)}}let $=!1;function f(i,s,t){$||!s.length||($=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:s.map(o=>o.split(" ")[0]).join(","),extensionHostType:t?"remote":"local"}))}}),define(ke[254],Ie([1,0,138]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=C;function h(R){return{transformIncoming:O=>O.scheme==="vscode-remote"?{scheme:"file",path:O.path,query:O.query,fragment:O.fragment}:O.scheme==="file"?{scheme:"vscode-local",path:O.path,query:O.query,fragment:O.fragment}:O,transformOutgoing:O=>O.scheme==="file"?{scheme:"vscode-remote",authority:R,path:O.path,query:O.query,fragment:O.fragment}:O.scheme==="vscode-local"?{scheme:"file",path:O.path,query:O.query,fragment:O.fragment}:O,transformOutgoingScheme:O=>O==="file"?"vscode-remote":O==="vscode-local"?"file":O}}function C(R){return new r.$Mn(h(R))}});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[152],Ie([1,0,8,17,2,3,5,36,27,14,52,211,43]),function($e,e,r,h,C,R,O,T,p,c,I,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$qG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$gG=e.EditorInputCapabilities=e.$fG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=void 0,e.$9F=a,e.$0F=m,e.$$F=$,e.$_F=f,e.$aG=i,e.$bG=s,e.$cG=t,e.$dG=o,e.$eG=n,e.$hG=y,e.$iG=A,e.$jG=b,e.$kG=v,e.$lG=F,e.$mG=N,e.$nG=L,e.$oG=M,e.$pG=H,e.$rG=_,e.$sG=ne,e.$tG=ye,e.$uG=ge,u=Ut(u),e.$4F={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$5F={id:"default",displayName:(0,r.localize)(12473,null),providerDisplayName:(0,r.localize)(12474,null)},e.$6F="workbench.editor.sidebysideEditor",e.$7F="workbench.editors.textDiffEditor",e.$8F="workbench.editors.binaryResourceDiffEditor";var P;(function(Y){Y[Y.PROGRAMMATIC=1]="PROGRAMMATIC",Y[Y.USER=2]="USER",Y[Y.EDIT=3]="EDIT",Y[Y.NAVIGATION=4]="NAVIGATION",Y[Y.JUMP=5]="JUMP"})(P||(e.EditorPaneSelectionChangeReason=P={}));var w;(function(Y){Y[Y.IDENTICAL=1]="IDENTICAL",Y[Y.SIMILAR=2]="SIMILAR",Y[Y.DIFFERENT=3]="DIFFERENT"})(w||(e.EditorPaneSelectionCompareResult=w={}));function a(Y){const U=Y;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function m(Y){const U=Y;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function $(Y,U,oe){for(const ve of oe.visibleEditorPanes)if(ve.group.id===U&&Y.matches(ve.input))return ve.getViewState()}function f(Y){if(y(Y))return!1;const U=Y;return C.URI.isUri(U?.resource)}function i(Y){if(y(Y))return!1;const U=Y;return U?.original!==void 0&&U.modified!==void 0}function s(Y){if(y(Y))return!1;const U=Y;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function t(Y){if(y(Y)||i(Y))return!1;const U=Y;return U?.primary!==void 0&&U.secondary!==void 0}function o(Y){if(y(Y))return!1;const U=Y;return U?U.resource===void 0||U.resource.scheme===c.Schemas.untitled||U.forceUntitled===!0:!1}function n(Y){if(y(Y))return!1;const U=Y;return C.URI.isUri(U?.base?.resource)&&C.URI.isUri(U?.input1?.resource)&&C.URI.isUri(U?.input2?.resource)&&C.URI.isUri(U?.result?.resource)}var d;(function(Y){Y[Y.SHORT=0]="SHORT",Y[Y.MEDIUM=1]="MEDIUM",Y[Y.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var l;(function(Y){Y[Y.EXPLICIT=1]="EXPLICIT",Y[Y.AUTO=2]="AUTO",Y[Y.FOCUS_CHANGE=3]="FOCUS_CHANGE",Y[Y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class g{constructor(){this.a=new Map}registerSource(U,oe){let ve=this.a.get(U);return ve||(ve={source:U,label:oe},this.a.set(U,ve)),ve.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$fG=new g;var E;(function(Y){Y[Y.None=0]="None",Y[Y.Readonly=2]="Readonly",Y[Y.Untitled=4]="Untitled",Y[Y.Singleton=8]="Singleton",Y[Y.RequiresTrust=16]="RequiresTrust",Y[Y.CanSplitInGroup=32]="CanSplitInGroup",Y[Y.ForceDescription=64]="ForceDescription",Y[Y.CanDropIntoEditor=128]="CanDropIntoEditor",Y[Y.MultipleEditors=256]="MultipleEditors",Y[Y.Scratchpad=512]="Scratchpad"})(E||(e.EditorInputCapabilities=E={}));class D extends R.$Uc{}e.$gG=D;function y(Y){return Y instanceof D}function k(Y){const U=Y;return C.URI.isUri(U?.preferredResource)}function A(Y){const U=Y;return y(U?.primary)&&y(U?.secondary)}function b(Y){const U=Y;return y(U?.modified)&&y(U?.original)}function v(Y,U,oe,ve,te){return ge(ve,[(0,S.$pj)({id:"workbench.action.openLargeFile",label:(0,r.localize)(12475,null),run:()=>{const ae={...oe,limits:{size:Number.MAX_VALUE}};Y.openEditor(U,ae)}}),(0,S.$pj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,r.localize)(12476,null),run:()=>te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function F(Y){return y(Y?.editor)}function N(Y){const U=Y;return F(Y)&&U?.group!==void 0}function L(Y){const U=Y;return typeof U?.groupId=="number"&&y(U.editor)}function M(Y){return typeof Y?.groupId=="number"}var z;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.REPLACE=1]="REPLACE",Y[Y.MOVE=2]="MOVE",Y[Y.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var j;(function(Y){Y[Y.GROUP_ACTIVE=0]="GROUP_ACTIVE",Y[Y.GROUP_INDEX=1]="GROUP_INDEX",Y[Y.GROUP_LABEL=2]="GROUP_LABEL",Y[Y.GROUP_LOCKED=3]="GROUP_LOCKED",Y[Y.EDITORS_SELECTION=4]="EDITORS_SELECTION",Y[Y.EDITOR_OPEN=5]="EDITOR_OPEN",Y[Y.EDITOR_CLOSE=6]="EDITOR_CLOSE",Y[Y.EDITOR_MOVE=7]="EDITOR_MOVE",Y[Y.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Y[Y.EDITOR_LABEL=9]="EDITOR_LABEL",Y[Y.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Y[Y.EDITOR_PIN=11]="EDITOR_PIN",Y[Y.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Y[Y.EDITOR_STICKY=13]="EDITOR_STICKY",Y[Y.EDITOR_DIRTY=14]="EDITOR_DIRTY",Y[Y.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var W;(function(Y){Y[Y.PRIMARY=1]="PRIMARY",Y[Y.SECONDARY=2]="SECONDARY",Y[Y.BOTH=3]="BOTH",Y[Y.ANY=4]="ANY"})(W||(e.SideBySideEditor=W={}));class B{getOriginalUri(U,oe){if(!U)return;if(n(U))return e.$qG.getOriginalUri(U.result,oe);if(oe?.supportSideBySide){const{primary:te,secondary:ae}=this.a(U);if(te&&ae){if(oe?.supportSideBySide===W.BOTH)return{primary:this.getOriginalUri(te,{filterByScheme:oe.filterByScheme}),secondary:this.getOriginalUri(ae,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===W.ANY)return this.getOriginalUri(te,{filterByScheme:oe.filterByScheme})??this.getOriginalUri(ae,{filterByScheme:oe.filterByScheme});U=oe.supportSideBySide===W.PRIMARY?te:ae}}if(i(U)||s(U)||t(U)||n(U))return;const ve=k(U)?U.preferredResource:U.resource;return!ve||!oe||!oe.filterByScheme?ve:this.b(ve,oe.filterByScheme)}a(U){return A(U)||t(U)?{primary:U.primary,secondary:U.secondary}:b(U)||i(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,oe){if(!U)return;if(n(U))return e.$qG.getCanonicalUri(U.result,oe);if(oe?.supportSideBySide){const{primary:te,secondary:ae}=this.a(U);if(te&&ae){if(oe?.supportSideBySide===W.BOTH)return{primary:this.getCanonicalUri(te,{filterByScheme:oe.filterByScheme}),secondary:this.getCanonicalUri(ae,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===W.ANY)return this.getCanonicalUri(te,{filterByScheme:oe.filterByScheme})??this.getCanonicalUri(ae,{filterByScheme:oe.filterByScheme});U=oe.supportSideBySide===W.PRIMARY?te:ae}}if(i(U)||s(U)||t(U)||n(U))return;const ve=U.resource;return!ve||!oe||!oe.filterByScheme?ve:this.b(ve,oe.filterByScheme)}b(U,oe){if(Array.isArray(oe)){if(oe.some(ve=>U.scheme===ve))return U}else if(oe===U.scheme)return U}}var ee;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.KEYBOARD=1]="KEYBOARD",Y[Y.MOUSE=2]="MOUSE"})(ee||(e.EditorCloseMethod=ee={}));function H(Y,U,oe,ve){if(!Y.isSticky(U))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return oe===ee.MOUSE||oe===ee.KEYBOARD;case"mouse":return oe===ee.MOUSE;case"keyboard":return oe===ee.KEYBOARD}return!1}e.$qG=new B;var q;(function(Y){Y[Y.LEFT=0]="LEFT",Y[Y.RIGHT=1]="RIGHT"})(q||(e.CloseDirection=q={}));class Q{constructor(){this.c=new Map,this.d=new Map}start(U){const oe=this.a=U.get(O.$Ei);for(const[ve,te]of this.c)this.e(ve,te,oe);this.c.clear()}e(U,oe,ve){const te=ve.createInstance(oe);this.d.set(U,te)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,h.$pg)(this.b)}registerEditorSerializer(U,oe){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,oe,this.a):this.c.set(U,oe),(0,R.$Sc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}T.$ro.add(e.$4F.EditorFactory,new Q);async function _(Y,U,oe){return!Y||!Y.length?[]:await Promise.all(Y.map(async ve=>{const te=C.URI.revive(ve.fileUri);if(!te){oe.info("Cannot resolve the path because it is not valid.",ve);return}if(!await U.canHandleResource(te)){oe.info("Cannot resolve the path because it cannot be handled",ve);return}let se=ve.exists,X=ve.type;if(typeof se!="boolean"||typeof X!="number")try{X=(await U.stat(te)).isDirectory?p.FileType.Directory:p.FileType.Unknown,se=!0}catch(pe){oe.error(pe),se=!1}if(!se&&ve.openOnlyIfExists){oe.info("Cannot resolve the path because it does not exist",ve);return}if(X===p.FileType.Directory){oe.info("Cannot resolve the path because it is a directory",ve);return}const re={...ve.options,pinned:!0};return se?{resource:te,options:re}:{resource:te,options:re,forceUntitled:!0}}))}var ce;(function(Y){Y[Y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Y[Y.SEQUENTIAL=1]="SEQUENTIAL"})(ce||(e.EditorsOrder=ce={}));function ne(Y){const U=Y;if(!U)return!1;const oe=U;if(oe.modified)return ne(oe.modified);const ve=U;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function ye(Y){return(0,I.$rj)(Y)}function ge(Y,U,oe){const ve=(0,I.$sj)(Y,U);return ve.forceMessage=oe?.forceMessage,ve.forceSeverity=oe?.forceSeverity,ve.allowDialog=oe?.allowDialog,ve}}),define(ke[255],Ie([1,0,4,8,5,3,28,36,24,82,244]),function($e,e,r,h,C,R,O,T,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CG=e.$BG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$AG=e.ViewContentGroups=e.$yG=e.ViewContainerLocation=e.Extensions=e.$xG=e.$wG=e.$vG=void 0,e.$zG=P,e.$vG="views",e.$wG=(0,h.localize)(12313,null),e.$xG=(0,I.$Bx)("default-view-icon",c.$5j.window,(0,h.localize)(12314,null));var S;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(S||(e.Extensions=S={}));var u;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel",o[o.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$yG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function P(o){switch(o){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class w extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new r.$le),this.onDidRegister=this.c.event,this.f=this.B(new r.$le),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(n,d,l){const g=this.get(n.id);if(g)return g;const E=n;return E.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,O.$xc)(this.g,d,[]).push(E),l?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:d}),E}deregisterViewContainer(n){for(const d of this.g.keys()){const l=this.g.get(d),g=l?.indexOf(n);if(g!==-1){l?.splice(g,1),l.length===0&&this.g.delete(d),this.f.fire({viewContainer:n,viewContainerLocation:d});return}}}get(n){return this.all.filter(d=>d.id===n)[0]}getViewContainers(n){return[...this.g.get(n)||[]]}getViewContainerLocation(n){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(l=>l?.id===n.id).length>0)[0]}getDefaultViewContainer(n){return this.h.find(d=>this.getViewContainerLocation(d)===n)}}T.$ro.add(S.ViewContainersRegistry,new w);var a;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(a||(e.ViewContentGroups=a={}));function m(o,n){const d=o.group??a.More,l=n.group??a.More;return d!==l?d.localeCompare(l):(o.order??5)-(n.order??5)}class $ extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new r.$le),this.onViewsRegistered=this.c.event,this.f=this.B(new r.$le),this.onViewsDeregistered=this.f.event,this.g=this.B(new r.$le),this.onDidChangeContainer=this.g.event,this.h=this.B(new r.$le),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new O.$Hc}registerViews(n,d){this.registerViews2([{views:n,viewContainer:d}])}registerViews2(n){n.forEach(({views:d,viewContainer:l})=>this.r(d,l)),this.c.fire(n)}deregisterViews(n,d){const l=this.s(n,d);l.length&&this.f.fire({views:l,viewContainer:d})}moveViews(n,d){for(const l of this.m.keys())if(l!==d){const g=this.s(n,l);g.length&&(this.r(g,d),this.g.fire({views:g,from:l,to:d}))}}getViews(n){return this.m.get(n)||[]}getView(n){for(const d of this.j){const l=(this.m.get(d)||[]).filter(g=>g.id===n)[0];if(l)return l}return null}getViewContainer(n){for(const d of this.j)if((this.m.get(d)||[]).filter(g=>g.id===n)[0])return d;return null}registerViewWelcomeContent(n,d){return this.n.add(n,d),this.h.fire(n),(0,R.$Sc)(()=>{this.n.delete(n,d),this.h.fire(n)})}registerViewWelcomeContent2(n,d){const l=new Map;for(const[g,E]of d)this.n.add(n,E),l.set(g,(0,R.$Sc)(()=>{this.n.delete(n,E),this.h.fire(n)}));return this.h.fire(n),l}getViewWelcomeContent(n){const d=[];return this.n.forEach(n,l=>d.push(l)),d.sort(m)}r(n,d){let l=this.m.get(d);l||(l=[],this.m.set(d,l),this.j.push(d));for(const g of n){if(this.getView(g.id)!==null)throw new Error((0,h.localize)(12315,null,g.id));l.push(g)}}s(n,d){const l=this.m.get(d);if(!l)return[];const g=[],E=[];for(const D of l)n.includes(D)?g.push(D):E.push(D);return g.length&&(E.length?this.m.set(d,E):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),g}}T.$ro.add(S.ViewsRegistry,new $),e.$AG=(0,C.$Fi)("viewDescriptorService");var f;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(f||(e.ViewVisibilityState=f={}));var i;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class s{constructor(n,d){this.c=!1,this.d=!1,(0,p.$ho)(this,n),this.d=!!d,this.resolve=async l=>{if(d&&!this.c){const g=await d(l);g&&(this.tooltip=this.tooltip??g.tooltip,this.command=this.command??g.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$BG=s;class t extends Error{constructor(n){super((0,h.localize)(12316,null,n)),this.name="NoTreeViewError"}static is(n){return n.name==="NoTreeViewError"}}e.$CG=t}),define(ke[256],Ie([1,0,8,35]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=void 0,e.$GG=new h.$Wj("chatSessionResponseVote","",{type:"string",description:(0,r.localize)(8436,null)}),e.$HG=new h.$Wj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,r.localize)(8437,null)}),e.$IG=new h.$Wj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,r.localize)(8438,null)}),e.$JG=new h.$Wj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,r.localize)(8439,null)}),e.$KG=new h.$Wj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,r.localize)(8440,null)}),e.$LG=new h.$Wj("chatResponse",!1,{type:"boolean",description:(0,r.localize)(8441,null)}),e.$MG=new h.$Wj("chatRequest",!1,{type:"boolean",description:(0,r.localize)(8442,null)}),e.$NG=new h.$Wj("chatEditApplied",!1,{type:"boolean",description:(0,r.localize)(8443,null)}),e.$OG=new h.$Wj("chatInputHasText",!1,{type:"boolean",description:(0,r.localize)(8444,null)}),e.$PG=new h.$Wj("chatInputHasFocus",!1,{type:"boolean",description:(0,r.localize)(8445,null)}),e.$QG=new h.$Wj("inChatInput",!1,{type:"boolean",description:(0,r.localize)(8446,null)}),e.$RG=new h.$Wj("inChat",!1,{type:"boolean",description:(0,r.localize)(8447,null)}),e.$SG=new h.$Wj("chatIsEnabled",!1,{type:"boolean",description:(0,r.localize)(8448,null)}),e.$TG=new h.$Wj("chatCursorAtTop",!1),e.$UG=new h.$Wj("chatInputHasAgent",!1),e.$VG=new h.$Wj("chatLocation",void 0),e.$WG=new h.$Wj("quickChatHasFocus",!1,{type:"boolean",description:(0,r.localize)(8449,null)})}),define(ke[153],Ie([1,0,131,7,20,4,39,3,44,182,12,35,23,5,11,115,237,151,256]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.ChatAgentLocation=void 0,e.$2H=d,e.$3H=l;var s;(function(g){g.Panel="panel",g.Terminal="terminal",g.Notebook="notebook",g.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function(g){function E(D){switch(D){case"panel":return g.Panel;case"terminal":return g.Terminal;case"notebook":return g.Notebook;case"editor":return g.Editor}return g.Panel}g.fromRaw=E}(s||(e.ChatAgentLocation=s={})),e.$WH=(0,P.$Fi)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(E){this.f=E,this.b=new Map,this.d=new R.$le,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=f.$SG.bindTo(this.f)}registerAgent(E,D){if(this.getAgent(E))throw new Error(`Agent already registered: ${JSON.stringify(E)}`);const k=this,A=D.slashCommands;D={...D,get slashCommands(){return A.filter(v=>!v.when||k.f.contextMatchesRules(S.$Dj.deserialize(v.when)))}};const b={data:D};return this.b.set(E,b),(0,T.$Sc)(()=>{this.b.delete(E),this.d.fire(void 0)})}registerAgentImplementation(E,D){const y=this.b.get(E);if(!y)throw new Error(`Unknown agent: ${JSON.stringify(E)}`);if(y.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(E)}`);return y.data.isDefault&&this.e.set(!0),y.impl=D,this.d.fire(new o(y.data,D)),(0,T.$Sc)(()=>{y.impl=void 0,this.d.fire(void 0),y.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(E,D){E.isDynamic=!0;const y={data:E,impl:D};return this.b.set(E.id,y),this.d.fire(new o(E,D)),(0,T.$Sc)(()=>{this.b.delete(E.id),this.d.fire(void 0)})}registerAgentCompletionProvider(E,D){return this.g.set(E,D),{dispose:()=>{this.g.delete(E)}}}async getAgentCompletionItems(E,D,y){return await this.g.get(E)?.(D,y)??[]}updateAgent(E,D){const y=this.b.get(E);if(!y?.impl)throw new Error(`No activated agent with id ${JSON.stringify(E)} registered`);y.data.metadata={...y.data.metadata,...D},this.d.fire(new o(y.data,y.impl))}getDefaultAgent(E){return(0,r.$eb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(E))}getContributedDefaultAgent(E){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(E))}getSecondaryAgent(){return O.Iterable.find(this.b.values(),E=>!!E.data.metadata.isSecondary)?.data}getAgent(E){if(this.h(E))return this.b.get(E)?.data}h(E){const D=this.b.get(E);return!D?.data.when||this.f.contextMatchesRules(S.$Dj.deserialize(D.data.when))}getAgentByFullyQualifiedId(E){const D=O.Iterable.find(this.b.values(),y=>d(y.data)===E)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(E=>E.data).filter(E=>this.h(E.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(E=>!!E.impl).filter(E=>this.h(E.data.id)).map(E=>new o(E.data,E.impl))}getAgentsByName(E){return this.getAgents().filter(D=>D.name===E)}agentHasDupeName(E){const D=this.getAgent(E);return D?this.getAgentsByName(D.name).filter(y=>y.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(E,D,y,k,A){const b=this.b.get(E);if(!b?.impl)throw new Error(`No activated agent with id "${E}"`);return await b.impl.invoke(D,y,k,A)}async getFollowups(E,D,y,k,A){const b=this.b.get(E);if(!b?.impl)throw new Error(`No activated agent with id "${E}"`);return b.impl?.provideFollowups?b.impl.provideFollowups(D,y,k,A):[]}};e.$XH=t,e.$XH=t=Je([Ve(0,S.$Xj)],t);class o{constructor(E,D){this.b=E,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}async invoke(E,D,y,k){return this.d.invoke(E,D,y,k)}async provideFollowups(E,D,y,k){return this.d.provideFollowups?this.d.provideFollowups(E,D,y,k):[]}provideWelcomeMessage(E,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(E,D)}provideSampleQuestions(E,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(E,D)}}e.$YH=o,e.$ZH=(0,P.$Fi)("chatAgentNameService");let n=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(E,D,y,k){if(this.g=D,this.h=y,this.i=k,this.e=(0,c.$6d)(this,Object.create(null)),this.f=!1,!E.chatParticipantRegistry)return;this.d=E.chatParticipantRegistry;const A=k.get(i.b,$.StorageScope.APPLICATION);try{this.e.set(JSON.parse(A??"{}"),void 0)}catch{k.remove(i.b,$.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(E=>this.h.warn("Failed to fetch chat participant registry",E)).then(()=>(0,h.$Gh)(5*60*1e3)).then(()=>this.j())}async k(){const E=await this.g.request({type:"GET",url:this.d},C.CancellationToken.None);if(E.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,m.$bq)(E);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const y=D.restrictedChatParticipants;this.e.set(y,void 0),this.i.store(i.b,JSON.stringify(y),$.StorageScope.APPLICATION,$.StorageTarget.MACHINE)}getAgentNameRestriction(E){const D=this.l(E.name,E).get(),y=!E.fullName||this.l(E.fullName.replace(/\s/g,""),E).get();return D&&y}l(E,D){return this.e.map(k=>k[E.toLowerCase()]).map(k=>k?k.some(A=>(0,I.$Ff)(A,A.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$1H=n,e.$1H=n=i=Je([Ve(0,a.$tk),Ve(1,m.$8p),Ve(2,w.$ak),Ve(3,$.$iq)],n);function d(g){return`${g.extensionId.value}.${g.id}`}function l(g){const E="name"in g?g:{...g,name:g.id};return"extensionPublisherId"in E||(E.extensionPublisherId=E.extensionPublisher??""),"extensionDisplayName"in E||(E.extensionDisplayName=""),"extensionId"in E||(E.extensionId=new u.$rn("")),(0,p.$ci)(E)}}),define(ke[257],Ie([1,0,2,30,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uH=e.$tH=e.ChatCopyKind=e.ChatAgentVoteDirection=e.ChatResponseReferencePartStatusKind=void 0,e.$rH=R,e.$sH=O;function R(I){return!!I&&typeof I=="object"&&"uri"in I&&I.uri instanceof r.URI&&"version"in I&&typeof I.version=="number"&&"ranges"in I&&Array.isArray(I.ranges)&&I.ranges.every(h.$Ot.isIRange)}function O(I){return!!I&&typeof I=="object"&&"documents"in I&&Array.isArray(I.documents)&&I.documents.every(R)}var T;(function(I){I[I.Complete=1]="Complete",I[I.Partial=2]="Partial",I[I.Omitted=3]="Omitted"})(T||(e.ChatResponseReferencePartStatusKind=T={}));var p;(function(I){I[I.Down=0]="Down",I[I.Up=1]="Up"})(p||(e.ChatAgentVoteDirection=p={}));var c;(function(I){I[I.Action=1]="Action",I[I.Toolbar=2]="Toolbar"})(c||(e.ChatCopyKind=c={})),e.$tH=(0,C.$Fi)("IChatService"),e.$uH="accessibility.voice.keywordActivation"}),define(ke[154],Ie([1,0,4,7,8]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0tb=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new r.$le,this.o=new r.$le,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(T){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=T}onEvent(T){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=T}onRequest(T){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.u("response",T)}sendRequest(T,p,c,I){const S={command:T};if(p&&Object.keys(p).length>0&&(S.arguments=p),this.u("request",S),typeof I=="number"){const u=setTimeout(()=>{clearTimeout(u);const P=this.f.get(S.seq);if(P){this.f.delete(S.seq);const w={type:"response",seq:0,request_seq:S.seq,success:!1,command:T,message:(0,C.localize)(7529,null,I,T)};P(w)}},I)}return c&&this.f.set(S.seq,c),S.seq}acceptMessage(T){this.k?this.k(T):(this.m.push(T),this.m.length===1&&this.s())}q(T,p){return T.type!=="event"||p.type!=="event"}async s(){let T;for(;this.m.length;){if((!T||this.q(this.m[0],T))&&await(0,h.$Gh)(0),T=this.m.shift(),!T)return;switch(T.type){case"event":this.j?.(T);break;case"request":this.g?.(T);break;case"response":{const p=T,c=this.f.get(p.request_seq);c&&(this.f.delete(p.request_seq),c(p));break}}}}u(T,p){p.type=T,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((p,c)=>T.set(c,p)),await(0,h.$Gh)(500),T.forEach((p,c)=>{p({type:"response",seq:0,request_seq:c,success:!1,command:"canceled",message:"canceled"}),this.f.delete(c)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$0tb=R}),define(ke[119],Ie([1,0,2,8,35,5]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$PK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$NK=e.MemoryRangeType=e.State=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=void 0,e.$MK=p,e.$OK=I,h=qe(h),e.$AJ="workbench.view.debug",e.$BJ="workbench.debug.variablesView",e.$CJ="workbench.debug.watchExpressionsView",e.$DJ="workbench.debug.callStackView",e.$EJ="workbench.debug.loadedScriptsView",e.$FJ="workbench.debug.breakPointsView",e.$GJ="workbench.debug.disassemblyView",e.$HJ="workbench.panel.repl",e.$IJ="workbench.panel.repl.view",e.$JJ=new C.$Wj("debugType",void 0,{type:"string",description:h.localize(7466,null)}),e.$KJ=new C.$Wj("debugConfigurationType",void 0,{type:"string",description:h.localize(7467,null)}),e.$LJ=new C.$Wj("debugState","inactive",{type:"string",description:h.localize(7468,null)}),e.$MJ="debugUx",e.$NJ=new C.$Wj(e.$MJ,"default",{type:"string",description:h.localize(7469,null)}),e.$OJ=new C.$Wj("hasDebugged",!1,{type:"boolean",description:h.localize(7470,null)}),e.$PJ=new C.$Wj("inDebugMode",!1,{type:"boolean",description:h.localize(7471,null)}),e.$QJ=new C.$Wj("inDebugRepl",!1,{type:"boolean",description:h.localize(7472,null)}),e.$RJ=new C.$Wj("breakpointWidgetVisible",!1,{type:"boolean",description:h.localize(7473,null)}),e.$SJ=new C.$Wj("inBreakpointWidget",!1,{type:"boolean",description:h.localize(7474,null)}),e.$TJ=new C.$Wj("breakpointsFocused",!0,{type:"boolean",description:h.localize(7475,null)}),e.$UJ=new C.$Wj("watchExpressionsFocused",!0,{type:"boolean",description:h.localize(7476,null)}),e.$VJ=new C.$Wj("watchExpressionsExist",!1,{type:"boolean",description:h.localize(7477,null)}),e.$WJ=new C.$Wj("variablesFocused",!0,{type:"boolean",description:h.localize(7478,null)}),e.$XJ=new C.$Wj("expressionSelected",!1,{type:"boolean",description:h.localize(7479,null)}),e.$YJ=new C.$Wj("breakpointInputFocused",!1,{type:"boolean",description:h.localize(7480,null)}),e.$ZJ=new C.$Wj("callStackItemType",void 0,{type:"string",description:h.localize(7481,null)}),e.$1J=new C.$Wj("callStackSessionIsAttach",!1,{type:"boolean",description:h.localize(7482,null)}),e.$2J=new C.$Wj("callStackItemStopped",!1,{type:"boolean",description:h.localize(7483,null)}),e.$3J=new C.$Wj("callStackSessionHasOneThread",!1,{type:"boolean",description:h.localize(7484,null)}),e.$4J=new C.$Wj("watchItemType",void 0,{type:"string",description:h.localize(7485,null)}),e.$5J=new C.$Wj("canViewMemory",void 0,{type:"boolean",description:h.localize(7486,null)}),e.$6J=new C.$Wj("breakpointItemType",void 0,{type:"string",description:h.localize(7487,null)}),e.$7J=new C.$Wj("breakpointItemBytes",void 0,{type:"boolean",description:h.localize(7488,null)}),e.$8J=new C.$Wj("breakpointHasModes",!1,{type:"boolean",description:h.localize(7489,null)}),e.$9J=new C.$Wj("breakpointSupportsCondition",!1,{type:"boolean",description:h.localize(7490,null)}),e.$0J=new C.$Wj("loadedScriptsSupported",!1,{type:"boolean",description:h.localize(7491,null)}),e.$$J=new C.$Wj("loadedScriptsItemType",void 0,{type:"string",description:h.localize(7492,null)}),e.$_J=new C.$Wj("focusedSessionIsAttach",!1,{type:"boolean",description:h.localize(7493,null)}),e.$aK=new C.$Wj("focusedSessionIsNoDebug",!1,{type:"boolean",description:h.localize(7494,null)}),e.$bK=new C.$Wj("stepBackSupported",!1,{type:"boolean",description:h.localize(7495,null)}),e.$cK=new C.$Wj("restartFrameSupported",!1,{type:"boolean",description:h.localize(7496,null)}),e.$dK=new C.$Wj("stackFrameSupportsRestart",!1,{type:"boolean",description:h.localize(7497,null)}),e.$eK=new C.$Wj("jumpToCursorSupported",!1,{type:"boolean",description:h.localize(7498,null)}),e.$fK=new C.$Wj("stepIntoTargetsSupported",!1,{type:"boolean",description:h.localize(7499,null)}),e.$gK=new C.$Wj("breakpointsExist",!1,{type:"boolean",description:h.localize(7500,null)}),e.$hK=new C.$Wj("debuggersAvailable",!1,{type:"boolean",description:h.localize(7501,null)}),e.$iK=new C.$Wj("debugExtensionAvailable",!0,{type:"boolean",description:h.localize(7502,null)}),e.$jK=new C.$Wj("debugProtocolVariableMenuContext",void 0,{type:"string",description:h.localize(7503,null)}),e.$kK=new C.$Wj("debugSetVariableSupported",!1,{type:"boolean",description:h.localize(7504,null)}),e.$lK=new C.$Wj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:h.localize(7505,null)}),e.$mK=new C.$Wj("debugSetExpressionSupported",!1,{type:"boolean",description:h.localize(7506,null)}),e.$nK=new C.$Wj("breakWhenValueChangesSupported",!1,{type:"boolean",description:h.localize(7507,null)}),e.$oK=new C.$Wj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:h.localize(7508,null)}),e.$pK=new C.$Wj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:h.localize(7509,null)}),e.$qK=new C.$Wj("terminateDebuggeeSupported",!1,{type:"boolean",description:h.localize(7510,null)}),e.$rK=new C.$Wj("suspendDebuggeeSupported",!1,{type:"boolean",description:h.localize(7511,null)}),e.$sK=new C.$Wj("variableEvaluateNamePresent",!1,{type:"boolean",description:h.localize(7512,null)}),e.$tK=new C.$Wj("variableIsReadonly",!1,{type:"boolean",description:h.localize(7513,null)}),e.$uK=new C.$Wj("variableValue",!1,{type:"string",description:h.localize(7514,null)}),e.$vK=new C.$Wj("variableType",!1,{type:"string",description:h.localize(7515,null)}),e.$wK=new C.$Wj("variableInterfaces",!1,{type:"array",description:h.localize(7516,null)}),e.$xK=new C.$Wj("variableName",!1,{type:"string",description:h.localize(7517,null)}),e.$yK=new C.$Wj("variableLanguage",!1,{type:"string",description:h.localize(7518,null)}),e.$zK=new C.$Wj("variableExtensionId",!1,{type:"string",description:h.localize(7519,null)}),e.$AK=new C.$Wj("exceptionWidgetVisible",!1,{type:"boolean",description:h.localize(7520,null)}),e.$BK=new C.$Wj("multiSessionRepl",!1,{type:"boolean",description:h.localize(7521,null)}),e.$CK=new C.$Wj("multiSessionDebug",!1,{type:"boolean",description:h.localize(7522,null)}),e.$DK=new C.$Wj("disassembleRequestSupported",!1,{type:"boolean",description:h.localize(7523,null)}),e.$EK=new C.$Wj("disassemblyViewFocus",!1,{type:"boolean",description:h.localize(7524,null)}),e.$FK=new C.$Wj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:h.localize(7525,null)}),e.$GK=new C.$Wj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:h.localize(7526,null)});const O=i=>h.localize(7527,null,i);e.$HK=O,e.$IK="editor.contrib.debug",e.$JK="editor.contrib.breakpoint",e.$KK="debug",e.$LK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:h.localize(7528,null)};var T;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(T||(e.State=T={}));function p(i){switch(i){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var c;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(c||(e.MemoryRangeType=c={})),e.$NK="vscode-debug-memory";function I(i){const s=i.presentationHint??i.source.presentationHint;return s==="deemphasize"||s==="subtle"}var S;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(S||(e.DataBreakpointSetType=S={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var P;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$PK=(0,R.$Fi)("debugService");var w;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(w||(e.BreakpointWidgetContext=w={}));var a;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(a||(e.DebugVisualizationType=a={}));var m;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var $;(function(i){i.deserialize=s=>s,i.serialize=s=>s})($||(e.IDebugVisualizationTreeItem=$={}));var f;(function(i){i.deserialize=s=>({id:s.id,name:s.name,iconPath:s.iconPath&&{light:r.URI.revive(s.iconPath.light),dark:r.URI.revive(s.iconPath.dark)},iconClass:s.iconClass,visualization:s.visualization}),i.serialize=s=>s})(f||(e.IDebugVisualization=f={}))}),define(ke[258],Ie([1,0,12,2,16,24,14,30,20,18]),function($e,e,r,h,C,R,O,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hI=void 0,e.$8H=S,e.$9H=u,e.$0H=P,e.$$H=w,e.$_H=a,e.$aI=m,e.$bI=$,e.$cI=i,e.$dI=o,e.$eI=n,e.$fI=l,e.$gI=E;const I=/{([^}]+)}/g;function S(y,k,A){return y.replace(I,function(b,v){return k&&v.length>0&&v[0]!=="_"?b:A&&A.hasOwnProperty(v)?A[v]:b})}function u(y){const k={};for(const A of Object.keys(y))A.startsWith("!")||(k[A]=y[A]);return k}function P(y){return y.configuration.request==="attach"&&!w(y)&&(!y.parentSession||P(y.parentSession))}function w(y){let k=y.configuration.type;if(k)return k==="vslsShare"&&(k=y.configuration.adapterProxy.configuration.type),(0,r.$Ff)(k,"extensionhost")||(0,r.$Ff)(k,"pwa-extensionhost")?y:y.parentSession?w(y.parentSession):void 0}function a(y){return y.type&&(y.label||y.program||y.runtime)}function m(y,k,A){let b,v=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=F.exec(y);){const L=N.index+1,M=L+N[0].length;if(L<=k&&M>=A){b=N[0],v=L;break}}if(b){const L=/(\w|\p{L})+/gu;let M=null;for(;(M=L.exec(b))&&!(M.index+1+v+M[0].length>=A););M&&(b=b.substring(0,L.lastIndex))}return b?{start:v,end:v+b.length-1}:{start:0,end:0}}async function $(y,k,A,b){if(y.evaluatableExpressionProvider.has(k)){const v=y.evaluatableExpressionProvider.ordered(k),F=(0,c.$Gb)(await Promise.all(v.map(async N=>{try{return await N.provideEvaluatableExpression(k,A,b??p.CancellationToken.None)}catch{return}})));if(F.length>0){let N=F[0].expression;const L=F[0].range;return N||(N=k.getLineContent(A.lineNumber).substring(L.startColumn-1,L.endColumn-1)),{range:L,matchingExpression:N}}}else{const v=k.getLineContent(A.lineNumber),{start:F,end:N}=m(v,A.column,A.column),L=v.substring(F-1,N);return{matchingExpression:L,range:new T.$Ot(A.lineNumber,F,A.lineNumber,F+L.length)}}return null}const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(y){return!!(y&&y.match(f))}function s(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(i(y.path))return h.URI.parse(y.path);if((0,C.$ic)(y.path))return h.URI.file(y.path)}return y.path}function t(y){if(typeof y.path=="object"){const k=h.URI.revive(y.path);if(k)return k.scheme===O.Schemas.file?k.fsPath:k.toString()}return y.path}function o(y,k){const A=k?s:t,b=(0,R.$eo)(y);return d(b,(v,F)=>{v&&F&&(F.path=A(F))}),b}function n(y,k){const A=k?s:t,b=(0,R.$eo)(y);return d(b,(v,F)=>{!v&&F&&(F.path=A(F))}),b}function d(y,k){switch(y.type){case"event":{const A=y;switch(A.event){case"output":k(!1,A.body.source);break;case"loadedSource":k(!1,A.body.source);break;case"breakpoint":k(!1,A.body.breakpoint.source);break;default:break}break}case"request":{const A=y;switch(A.command){case"setBreakpoints":k(!0,A.arguments.source);break;case"breakpointLocations":k(!0,A.arguments.source);break;case"source":k(!0,A.arguments.source);break;case"gotoTargets":k(!0,A.arguments.source);break;case"launchVSCode":A.arguments.args.forEach(b=>k(!1,b));break;default:break}break}case"response":{const A=y;if(A.success&&A.body)switch(A.command){case"stackTrace":A.body.stackFrames.forEach(b=>k(!1,b.source));break;case"loadedSources":A.body.sources.forEach(b=>k(!1,b));break;case"scopes":A.body.scopes.forEach(b=>k(!1,b.source));break;case"setFunctionBreakpoints":A.body.breakpoints.forEach(b=>k(!1,b.source));break;case"setBreakpoints":A.body.breakpoints.forEach(b=>k(!1,b.source));break;case"disassemble":A.body?.instructions.forEach(v=>k(!1,v.location));break;default:break}break}}}function l(y){return y.filter(k=>!k.presentation?.hidden).sort((k,A)=>k.presentation?A.presentation?k.presentation.group?A.presentation.group?k.presentation.group!==A.presentation.group?k.presentation.group.localeCompare(A.presentation.group):g(k.presentation.order,A.presentation.order):-1:A.presentation.group?1:g(k.presentation.order,A.presentation.order):-1:A.presentation?1:0)}function g(y,k){return typeof y!="number"?typeof k!="number"?0:1:typeof k!="number"?-1:y-k}async function E(y,k){const A=y.getValue("debug.saveBeforeStart",{overrideIdentifier:k.activeTextEditorLanguageId});if(A!=="none"&&(await k.saveAll(),A==="allEditorsInActiveGroup")){const b=k.activeEditorPane;b&&b.input.resource?.scheme===O.Schemas.untitled&&await k.save({editor:b.input,groupId:b.group.id})}await y.reloadConfiguration()}const D=(y,k)=>!y||!k?y===k:y.name===k.name&&y.path===k.path&&y.sourceReference===k.sourceReference;e.$hI=D}),define(ke[259],Ie([1,0,56,67,24,16,10,12,33,8,154]),function($e,e,r,h,C,R,O,T,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Orc=e.$Nrc=e.$Mrc=e.$Lrc=e.$Krc=void 0,r=qe(r),h=qe(h),C=qe(C),R=qe(R),O=qe(O),T=qe(T),c=qe(c);class S extends I.$0tb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t($,f){this.l=f,this.p=Buffer.allocUnsafe(0),this.r=-1,$.on("data",i=>this.v(i))}sendMessage($){if(this.l){const f=JSON.stringify($);this.l.write(`Content-Length: ${Buffer.byteLength(f,"utf8")}${S.a}${f}`,"utf8")}}v($){for(this.p=Buffer.concat([this.p,$]);;){if(this.r>=0){if(this.p.length>=this.r){const f=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,f.length>0)try{this.acceptMessage(JSON.parse(f))}catch(i){this.n.fire(new Error((i.message||i)+`
`+f))}continue}}else{const f=this.p.indexOf(S.a);if(f!==-1){const s=this.p.toString("utf8",0,f).split(S.b);for(const t of s){const o=t.split(S.i);o[0]==="Content-Length"&&(this.r=Number(o[1]))}this.p=this.p.slice(f+S.a.length);continue}}break}}}e.$Krc=S;class u extends S{startSession(){return new Promise(($,f)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),$(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):f(new Error("connection closed"))}),this.x.on("error",s=>{i?this.n.fire(s):f(s)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$Lrc=u;class P extends u{constructor($){super(),this.z=$}y($){return h.createConnection(this.z.port,this.z.host||"127.0.0.1",$)}}e.$Mrc=P;class w extends u{constructor($){super(),this.z=$}y($){return h.createConnection(this.z.path,$)}}e.$Nrc=w;class a extends S{constructor($,f){super(),this.y=$,this.z=f}async startSession(){const $=this.y.command,f=this.y.args,i=this.y.options||{};try{if($)if(R.$ic($)){if(!await p.Promises.exists($))throw new Error(c.localize(7389,null,$))}else $.indexOf("/")<0&&$.indexOf("\\")<0;else throw new Error(c.localize(7390,null,this.z));let s=process.env;if(i.env&&Object.keys(i.env).length>0&&(s=C.$ho(C.$eo(process.env),i.env)),$==="node")if(Array.isArray(f)&&f.length>0){const t=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:s,execArgv:t?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(o.cwd=i.cwd);const n=r.fork(f[0],f.slice(1),o);if(!n.pid)throw new Error(c.localize(7391,null,f[0]));this.x=n}else throw new Error(c.localize(7392,null));else{const t={env:s};i.cwd&&(t.cwd=i.cwd),this.x=r.spawn($,f,t)}this.x.on("error",t=>{this.n.fire(t)}),this.x.on("exit",(t,o)=>{this.o.fire(t)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",t=>{this.n.fire(t)}),this.x.stdin.on("error",t=>{this.n.fire(t)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(s){this.n.fire(s)}}async stopSession(){return this.x?(await this.w(),O.$j?new Promise(($,f)=>{const i=r.exec(`taskkill /F /T /PID ${this.x.pid}`,function(s,t,o){if(s)return f(s)});i.on("exit",$),i.on("error",f)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A($,f){if(!$)return;const i=Object.create(null);$.runtime&&($.runtime.indexOf("./")===0?i.runtime=R.$jc(f,$.runtime):i.runtime=$.runtime),$.runtimeArgs&&(i.runtimeArgs=$.runtimeArgs),$.program&&(R.$ic($.program)?i.program=$.program:i.program=R.$jc(f,$.program)),$.args&&(i.args=$.args);const s=$;return s.win&&(i.win=a.A(s.win,f)),s.winx86&&(i.winx86=a.A(s.winx86,f)),s.windows&&(i.windows=a.A(s.windows,f)),s.osx&&(i.osx=a.A(s.osx,f)),s.linux&&(i.linux=a.A(s.linux,f)),i}static platformAdapterExecutable($,f){let i=Object.create(null);f=f.toLowerCase();for(const l of $)if(l.contributes){const g=l.contributes.debuggers;g&&g.length>0&&g.filter(E=>typeof E.type=="string"&&T.$Ff(E.type,f)).forEach(E=>{const D=a.A(E,l.extensionLocation.fsPath);i=C.$ho(i,D,l.isBuiltin)})}let s;O.$j&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?s=i.winx86||i.win||i.windows:O.$j?s=i.win||i.windows:O.$k?s=i.osx:O.$l&&(s=i.linux),s=s||i;const t=s.program||i.program,o=s.args||i.args,n=s.runtime||i.runtime,d=s.runtimeArgs||i.runtimeArgs;if(n)return{type:"executable",command:n,args:(d||[]).concat(typeof t=="string"?[t]:[]).concat(o||[])};if(t)return{type:"executable",command:t,args:o||[]}}}e.$Orc=a}),define(ke[260],Ie([1,0,56,31,10]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Prc=O,e.$Qrc=p,r=qe(r),C=qe(C);function R(c,I){return new Promise((S,u)=>{let P="";const w=r.spawn(c,I);w.pid&&w.stdout.on("data",a=>{P+=a.toString()}),w.on("error",a=>{u(a)}),w.on("close",a=>{S(P)})})}async function O(c){if(c)if(C.$j){const I=await new Promise((S,u)=>{$e(["@vscode/windows-process-tree"],S,u)}).then(qe);return new Promise(S=>{I.getProcessTree(c,u=>{S(!!u&&u.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(c)]).then(I=>{const S=I.trim();return!(S.length===0||S.indexOf(" tmux")>=0)},I=>!0);return Promise.resolve(!0)}var T;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(T||(T={}));function p(c,I,S,u,P){c=c.trim().toLowerCase();let w;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?w=T.powershell:c.indexOf("cmd.exe")>=0?w=T.cmd:c.indexOf("bash")>=0?w=T.bash:C.$j?w=T.cmd:w=T.bash;let a,m=" ";switch(w){case T.powershell:if(a=$=>($=$.replace(/\'/g,"''"),$.length>0&&$.charAt($.length-1)==="\\"?`'${$}\\'`:`'${$}'`),u){const $=(0,h.$Kg)(u);$&&(m+=`${$}:; `),m+=`cd ${a(u)}; `}if(P)for(const $ in P){const f=P[$];f===null?m+=`Remove-Item env:${$}; `:m+=`\${env:${$}}='${f}'; `}if(I.length>0){const $=I.shift(),f=S?$:a($);m+=f[0]==="'"?`& ${f} `:`${f} `;for(const i of I)m+=i==="<"||i===">"||S?i:a(i),m+=" "}break;case T.cmd:if(a=$=>($=$.replace(/\"/g,'""'),$=$.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(f=>$.includes(f))||$.length===0?`"${$}"`:$),u){const $=(0,h.$Kg)(u);$&&(m+=`${$}: && `),m+=`cd ${a(u)} && `}if(P){m+='cmd /C "';for(const $ in P){let f=P[$];f===null?m+=`set "${$}=" && `:(f=f.replace(/[&^|<>]/g,i=>`^${i}`),m+=`set "${$}=${f}" && `)}}for(const $ of I)m+=$==="<"||$===">"||S?$:a($),m+=" ";P&&(m+='"');break;case T.bash:{a=f=>(f=f.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),f.length===0?'""':f);const $=f=>/[^\w@%\/+=,.:^-]/.test(f)?`'${f.replace(/'/g,"'\\''")}'`:f;if(u&&(m+=`cd ${a(u)} ; `),P){m+="/usr/bin/env";for(const f in P){const i=P[f];i===null?m+=` -u ${$(f)}`:m+=` ${$(`${f}=${i}`)}`}m+=" "}for(const f of I)m+=f==="<"||f===">"||S?f:a(f),m+=" ";break}}return m}}),define(ke[261],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XK=e.CellExecutionUpdateType=void 0;var h;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(h||(e.CellExecutionUpdateType=h={})),e.$XK=(0,r.$Fi)("INotebookExecutionService")}),define(ke[262],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2K=e.$1K=e.ProxyKernelState=e.$ZK=void 0,e.$ZK=100;var h;(function(C){C[C.Disconnected=1]="Disconnected",C[C.Connected=2]="Connected",C[C.Initializing=3]="Initializing"})(h||(e.ProxyKernelState=h={})),e.$1K=(0,r.$Fi)("INotebookKernelService"),e.$2K=(0,r.$Fi)("INotebookKernelHistoryService")}),define(ke[263],Ie([1,0,3,30,58,208,111]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j1b=void 0;class T extends r.$Uc{constructor(c,I,S){super(),this._source=c,this.b=I,this.c=S,this.a=void 0}f(c){const I=c.getLineCount();return new h.$Ot(1,1,I,this.g(c,I))}g(c,I){if(I<1||I>c.getLineCount())throw new Error("Illegal value for lineNumber");return c.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const c=new R.$wD;c.acceptChunk(this._source);const I=c.finish(!0),{textBuffer:S,disposable:u}=I.create(C.DefaultEndOfLine.LF);this.b=S,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(c=>{const I=new R.$wD;I.acceptChunk(c);const S=I.finish(!0),{textBuffer:u,disposable:P}=S.create(C.DefaultEndOfLine.LF);return this.B(P),u})),this.a}findInInputs(c){const S=new O.$kD(c,!1,!1,null).parseSearchRequest();if(!S)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,S,!0,5e3)}findInOutputs(c){const S=new O.$kD(c,!1,!1,null).parseSearchRequest();return S?this.outputTextBuffers.map(u=>{const P=u.findMatchesLineByLine(this.f(u),S,!0,5e3);if(P.length!==0)return{textBuffer:u,matches:P}}).filter(u=>!!u):[]}}e.$j1b=T}),define(ke[73],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7I=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(R){R.Delimiter="\0"})(r||(e.TestIdPathParts=r={}));var h;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(h||(e.TestPosition=h={}));class C{static fromExtHostTestItem(O,T,p=O.parent){if(O._isRoot)return new C([T]);const c=[O.id];for(let I=p;I&&I.id!==T;I=I.parent)c.push(I.id);return c.push(T),new C(c.reverse())}static isRoot(O){return!O.includes(r.Delimiter)}static root(O){const T=O.indexOf(r.Delimiter);return T===-1?O:O.slice(0,T)}static fromString(O){return new C(O.split(r.Delimiter))}static join(O,T){return new C([...O.path,T])}static joinToString(O,T){return O.toString()+r.Delimiter+T}static parentId(O){const T=O.lastIndexOf(r.Delimiter);return T===-1?void 0:O.slice(0,T)}static localId(O){const T=O.lastIndexOf(r.Delimiter);return T===-1?O:O.slice(T+r.Delimiter.length)}static isChild(O,T){return T[O.length]===r.Delimiter&&T.startsWith(O)}static compare(O,T){return O===T?h.IsSame:C.isChild(O,T)?h.IsChild:C.isChild(T,O)?h.IsParent:h.Disconnected}static getLengthOfCommonPrefix(O,T){if(O===0)return 0;let p=0;for(;p<O-1;){for(let c=1;c<O;c++){const I=T(c-1),S=T(c);if(I.path[p]!==S.path[p])return p}p++}return p}constructor(O,T=O.length){if(this.path=O,this.d=T,O.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let O=1;O<=this.d;O++)yield new C(this.path,O)}*idsToRoot(){for(let O=this.d;O>0;O--)yield new C(this.path,O)}compare(O){if(typeof O=="string")return C.compare(this.toString(),O);for(let T=0;T<O.d&&T<this.d;T++)if(O.path[T]!==this.path[T])return h.Disconnected;return O.d>this.d?h.IsChild:O.d<this.d?h.IsParent:h.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let O=1;O<this.d;O++)this.c+=r.Delimiter,this.c+=this.path[O]}return this.c}}e.$7I=C}),define(ke[74],Ie([1,0,2,57,30,73]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$cJ=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$bJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$aJ=e.$_I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$$I=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$0I=e.$9I=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.$8I=e.TestResultState=void 0;var O;(function(W){W[W.Unset=0]="Unset",W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(O||(e.TestResultState=O={})),e.$8I={[O.Unset]:"unset",[O.Queued]:"queued",[O.Running]:"running",[O.Passed]:"passed",[O.Failed]:"failed",[O.Skipped]:"skipped",[O.Errored]:"errored"};var T;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var p;(function(W){W[W.Refresh=2]="Refresh",W[W.CodeRelatedToTest=4]="CodeRelatedToTest",W[W.TestRelatedToCode=8]="TestRelatedToCode"})(p||(e.TestControllerCapability=p={}));var c;(function(W){W[W.Run=2]="Run",W[W.Debug=4]="Debug",W[W.Coverage=8]="Coverage",W[W.HasNonDefaultProfile=16]="HasNonDefaultProfile",W[W.HasConfigurable=32]="HasConfigurable",W[W.SupportsContinuousRun=64]="SupportsContinuousRun"})(c||(e.TestRunProfileBitset=c={})),e.$9I=[c.Run,c.Debug,c.Coverage,c.HasNonDefaultProfile,c.HasConfigurable,c.SupportsContinuousRun];const I=W=>"runId"in W;e.$0I=I;var S;(function(W){W.serialize=B=>({range:B.range.toJSON(),uri:B.uri.toJSON()}),W.deserialize=(B,ee)=>({range:C.$Ot.lift(ee.range),uri:B.asCanonicalUri(r.URI.revive(ee.uri))})})(S||(e.IRichLocation=S={}));var u;(function(W){W[W.Error=0]="Error",W[W.Output=1]="Output"})(u||(e.TestMessageType=u={}));var P;(function(W){W.serialize=B=>({label:B.label,uri:B.uri?.toJSON(),position:B.position?.toJSON()}),W.deserialize=(B,ee)=>({label:ee.label,uri:ee.uri?B.asCanonicalUri(r.URI.revive(ee.uri)):void 0,position:ee.position?h.$Nt.lift(ee.position):void 0})})(P||(e.ITestMessageStackFrame=P={}));var w;(function(W){W.serialize=B=>({message:B.message,type:u.Error,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&S.serialize(B.location),stackTrace:B.stackTrace?.map(P.serialize)}),W.deserialize=(B,ee)=>({message:ee.message,type:u.Error,expected:ee.expected,actual:ee.actual,contextValue:ee.contextValue,location:ee.location&&S.deserialize(B,ee.location),stackTrace:ee.stackTrace&&ee.stackTrace.map(H=>P.deserialize(B,H))})})(w||(e.ITestErrorMessage=w={}));const a=(W,B)=>`${B?"s":"e"}${W}`;e.$$I=a;var m;(function(W){W.serialize=B=>({message:B.message,type:u.Output,offset:B.offset,length:B.length,location:B.location&&S.serialize(B.location)}),W.deserialize=(B,ee)=>({message:ee.message,type:u.Output,offset:ee.offset,length:ee.length,location:ee.location&&S.deserialize(B,ee.location)})})(m||(e.ITestOutputMessage=m={}));var $;(function(W){W.serialize=B=>B.type===u.Error?w.serialize(B):m.serialize(B),W.deserialize=(B,ee)=>ee.type===u.Error?w.deserialize(B,ee):m.deserialize(B,ee),W.isDiffable=B=>B.type===u.Error&&B.actual!==void 0&&B.expected!==void 0})($||(e.ITestMessage=$={}));var f;(function(W){W.serializeWithoutMessages=B=>({state:B.state,duration:B.duration,messages:[]}),W.serialize=B=>({state:B.state,duration:B.duration,messages:B.messages.map($.serialize)}),W.deserialize=(B,ee)=>({state:ee.state,duration:ee.duration,messages:ee.messages.map(H=>$.deserialize(B,H))})})(f||(e.ITestTaskState=f={}));const i="\0",s=(W,B)=>W+i+B;e.$_I=s;const t=W=>{const B=W.indexOf(i);return{ctrlId:W.slice(0,B),tagId:W.slice(B+1)}};e.$aJ=t;var o;(function(W){W.serialize=B=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?.toJSON(),range:B.range?.toJSON()||null,description:B.description,error:B.error,sortText:B.sortText}),W.deserialize=(B,ee)=>({extId:ee.extId,label:ee.label,tags:ee.tags,busy:ee.busy,children:void 0,uri:ee.uri?B.asCanonicalUri(r.URI.revive(ee.uri)):void 0,range:ee.range?C.$Ot.lift(ee.range):null,description:ee.description,error:ee.error,sortText:ee.sortText})})(o||(e.ITestItem=o={}));var n;(function(W){W[W.NotExpandable=0]="NotExpandable",W[W.Expandable=1]="Expandable",W[W.BusyExpanding=2]="BusyExpanding",W[W.Expanded=3]="Expanded"})(n||(e.TestItemExpandState=n={}));var d;(function(W){W.serialize=B=>({expand:B.expand,item:o.serialize(B.item)}),W.deserialize=(B,ee)=>({controllerId:R.$7I.root(ee.item.extId),expand:ee.expand,item:o.deserialize(B,ee.item)})})(d||(e.InternalTestItem=d={}));var l;(function(W){W.serialize=B=>{let ee;return B.item&&(ee={},B.item.label!==void 0&&(ee.label=B.item.label),B.item.tags!==void 0&&(ee.tags=B.item.tags),B.item.busy!==void 0&&(ee.busy=B.item.busy),B.item.uri!==void 0&&(ee.uri=B.item.uri?.toJSON()),B.item.range!==void 0&&(ee.range=B.item.range?.toJSON()),B.item.description!==void 0&&(ee.description=B.item.description),B.item.error!==void 0&&(ee.error=B.item.error),B.item.sortText!==void 0&&(ee.sortText=B.item.sortText)),{extId:B.extId,expand:B.expand,item:ee}},W.deserialize=B=>{let ee;return B.item&&(ee={},B.item.label!==void 0&&(ee.label=B.item.label),B.item.tags!==void 0&&(ee.tags=B.item.tags),B.item.busy!==void 0&&(ee.busy=B.item.busy),B.item.range!==void 0&&(ee.range=B.item.range?C.$Ot.lift(B.item.range):null),B.item.description!==void 0&&(ee.description=B.item.description),B.item.error!==void 0&&(ee.error=B.item.error),B.item.sortText!==void 0&&(ee.sortText=B.item.sortText)),{extId:B.extId,expand:B.expand,item:ee}}})(l||(e.ITestItemUpdate=l={}));const g=(W,B)=>{B.expand!==void 0&&(W.expand=B.expand),B.item!==void 0&&(W.item=W.item?Object.assign(W.item,B.item):B.item)};e.$bJ=g;var E;(function(W){W.serializeWithoutMessages=B=>({...d.serialize(B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(f.serializeWithoutMessages)}),W.serialize=B=>({...d.serialize(B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(f.serialize)}),W.deserialize=(B,ee)=>({...d.deserialize(B,ee),ownComputedState:ee.ownComputedState,computedState:ee.computedState,tasks:ee.tasks.map(H=>f.deserialize(B,H)),retired:!0})})(E||(e.TestResultItem=E={}));var D;(function(W){W.empty=()=>({covered:0,total:0}),W.sum=(B,ee)=>{B.covered+=ee.covered,B.total+=ee.total}})(D||(e.ICoverageCount=D={}));var y;(function(W){W.serialize=B=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,testIds:B.testIds,uri:B.uri.toJSON()}),W.deserialize=(B,ee)=>({id:ee.id,statement:ee.statement,branch:ee.branch,declaration:ee.declaration,testIds:ee.testIds,uri:B.asCanonicalUri(r.URI.revive(ee.uri))}),W.empty=(B,ee)=>({id:B,uri:ee,statement:D.empty()})})(y||(e.IFileCoverage=y={}));function k(W){return{...W,location:W.location?.toJSON()}}function A(W){return W.location=W.location?h.$Nt.isIPosition(W.location)?h.$Nt.lift(W.location):C.$Ot.lift(W.location):void 0,W}e.$cJ=3;var b;(function(W){W[W.Declaration=0]="Declaration",W[W.Statement=1]="Statement",W[W.Branch=2]="Branch"})(b||(e.DetailType=b={}));var v;(function(W){W.serialize=B=>B.type===b.Declaration?N.serialize(B):L.serialize(B),W.deserialize=B=>B.type===b.Declaration?N.deserialize(B):L.deserialize(B)})(v||(e.CoverageDetails=v={}));var F;(function(W){W.serialize=k,W.deserialize=A})(F||(e.IBranchCoverage=F={}));var N;(function(W){W.serialize=k,W.deserialize=A})(N||(e.IDeclarationCoverage=N={}));var L;(function(W){W.serialize=B=>({...k(B),branches:B.branches?.map(F.serialize)}),W.deserialize=B=>({...A(B),branches:B.branches?.map(F.deserialize)})})(L||(e.IStatementCoverage=L={}));var M;(function(W){W[W.Add=0]="Add",W[W.Update=1]="Update",W[W.DocumentSynced=2]="DocumentSynced",W[W.Remove=3]="Remove",W[W.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",W[W.Retire=5]="Retire",W[W.AddTag=6]="AddTag",W[W.RemoveTag=7]="RemoveTag"})(M||(e.TestDiffOpType=M={}));var z;(function(W){W.deserialize=(B,ee)=>ee.op===M.Add?{op:ee.op,item:d.deserialize(B,ee.item)}:ee.op===M.Update?{op:ee.op,item:l.deserialize(ee.item)}:ee.op===M.DocumentSynced?{op:ee.op,uri:B.asCanonicalUri(r.URI.revive(ee.uri)),docv:ee.docv}:ee,W.serialize=B=>B.op===M.Add?{op:B.op,item:d.serialize(B.item)}:B.op===M.Update?{op:B.op,item:l.serialize(B.item)}:B})(z||(e.TestsDiffOp=z={}));class j{constructor(B){this.l=B,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(B){const ee=this.x();for(const H of B)switch(H.op){case M.Add:this.p(d.deserialize(this.l,H.item),ee);break;case M.Update:this.q(l.deserialize(H.item),ee);break;case M.Remove:this.v(H.itemId,ee);break;case M.Retire:this.w(H.itemId);break;case M.IncrementPendingExtHosts:this.updatePendingRoots(H.amount);break;case M.AddTag:this.f.set(H.tag.id,H.tag);break;case M.RemoveTag:this.f.delete(H.id);break}ee.complete?.()}p(B,ee){const H=R.$7I.parentId(B.item.extId)?.toString();let q;if(!H)q=this.y(B),this.h.add(q),this.g.set(B.item.extId,q);else if(this.g.has(H)){const Q=this.g.get(H);Q.children.add(B.item.extId),q=this.y(B,Q),this.g.set(B.item.extId,q)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(B)}`);return}return ee.add?.(q),B.expand===n.BusyExpanding&&this.j++,q}q(B,ee){const H=this.g.get(B.extId);if(H)return B.expand!==void 0&&(H.expand===n.BusyExpanding&&this.j--,B.expand===n.BusyExpanding&&this.j++),(0,e.$bJ)(H,B),ee.update?.(H),H}v(B,ee){const H=this.g.get(B);if(!H)return;const q=R.$7I.parentId(H.item.extId)?.toString();q?this.g.get(q).children.delete(H.item.extId):this.h.delete(H);const Q=[[B]];for(;Q.length;)for(const _ of Q.pop()){const ce=this.g.get(_);ce&&(Q.push(ce.children),this.g.delete(_),ee.remove?.(ce,ce!==H),ce.expand===n.BusyExpanding&&this.j--)}}w(B){}updatePendingRoots(B){this.k+=B}x(){return{}}}e.$dJ=j}),define(ke[264],Ie([1,0,137,8,74]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$NGb=e.$MGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var R;(function(S){S.ViewletId="workbench.view.extension.test",S.ExplorerViewId="workbench.view.testing",S.OutputPeekContributionId="editor.contrib.testingOutputPeek",S.DecorationsContributionId="editor.contrib.testingDecorations",S.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",S.CoverageViewId="workbench.view.testCoverage",S.ResultsPanelId="workbench.panel.testResults",S.ResultsViewId="workbench.panel.testResults.view",S.MessageLanguageId="vscodeInternalTestMessage"})(R||(e.Testing=R={}));var O;(function(S){S.List="list",S.Tree="true"})(O||(e.TestExplorerViewMode=O={}));var T;(function(S){S.ByLocation="location",S.ByStatus="status",S.ByDuration="duration"})(T||(e.TestExplorerViewSorting=T={}));const p={[C.TestResultState.Errored]:(0,h.localize)(3187,null),[C.TestResultState.Failed]:(0,h.localize)(3188,null),[C.TestResultState.Passed]:(0,h.localize)(3189,null),[C.TestResultState.Queued]:(0,h.localize)(3190,null),[C.TestResultState.Running]:(0,h.localize)(3191,null),[C.TestResultState.Skipped]:(0,h.localize)(3192,null),[C.TestResultState.Unset]:(0,h.localize)(3193,null)},c=(S,u)=>(0,h.localize)(3194,null,(0,r.$Zk)(S),p[u]);e.$MGb=c,e.$NGb={[C.TestRunProfileBitset.Debug]:(0,h.localize)(3195,null),[C.TestRunProfileBitset.Run]:(0,h.localize)(3196,null),[C.TestRunProfileBitset.Coverage]:(0,h.localize)(3197,null)};var I;(function(S){S.CancelTestRefreshAction="testing.cancelTestRefresh",S.CancelTestRunAction="testing.cancelRun",S.ClearTestResultsAction="testing.clearTestResults",S.CollapseAllAction="testing.collapseAll",S.ConfigureTestProfilesAction="testing.configureProfile",S.ContinousRunUsingForTest="testing.continuousRunUsingForTest",S.CoverageAtCursor="testing.coverageAtCursor",S.CoverageByUri="testing.coverage.uri",S.CoverageClear="testing.coverage.close",S.CoverageCurrentFile="testing.coverageCurrentFile",S.CoverageFilterToTest="testing.coverageFilterToTest",S.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",S.CoverageLastRun="testing.coverageLastRun",S.CoverageSelectedAction="testing.coverageSelected",S.CoverageToggleToolbar="testing.coverageToggleToolbar",S.CoverageViewChangeSorting="testing.coverageViewChangeSorting",S.DebugAction="testing.debug",S.DebugAllAction="testing.debugAll",S.DebugAtCursor="testing.debugAtCursor",S.DebugByUri="testing.debug.uri",S.DebugCurrentFile="testing.debugCurrentFile",S.DebugFailedTests="testing.debugFailTests",S.DebugLastRun="testing.debugLastRun",S.DebugSelectedAction="testing.debugSelected",S.FilterAction="workbench.actions.treeView.testExplorer.filter",S.GetExplorerSelection="_testing.getExplorerSelection",S.GetSelectedProfiles="testing.getSelectedProfiles",S.GoToTest="testing.editFocusedTest",S.GoToRelatedTest="testing.goToRelatedTest",S.PeekRelatedTest="testing.peekRelatedTest",S.GoToRelatedCode="testing.goToRelatedCode",S.PeekRelatedCode="testing.peekRelatedCode",S.HideTestAction="testing.hideTest",S.OpenCoverage="testing.openCoverage",S.OpenOutputPeek="testing.openOutputPeek",S.RefreshTestsAction="testing.refreshTests",S.ReRunFailedTests="testing.reRunFailTests",S.ReRunLastRun="testing.reRunLastRun",S.RunAction="testing.run",S.RunAllAction="testing.runAll",S.RunAllWithCoverageAction="testing.coverageAll",S.RunAtCursor="testing.runAtCursor",S.RunByUri="testing.run.uri",S.RunCurrentFile="testing.runCurrentFile",S.RunSelectedAction="testing.runSelected",S.RunUsingProfileAction="testing.runUsing",S.RunWithCoverageAction="testing.coverage",S.SearchForTestExtension="testing.searchForTestExtension",S.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",S.ShowMostRecentOutputAction="testing.showMostRecentOutput",S.StartContinousRun="testing.startContinuousRun",S.StopContinousRun="testing.stopContinuousRun",S.TestingSortByDurationAction="testing.sortByDuration",S.TestingSortByLocationAction="testing.sortByLocation",S.TestingSortByStatusAction="testing.sortByStatus",S.TestingViewAsListAction="testing.viewAsList",S.TestingViewAsTreeAction="testing.viewAsTree",S.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",S.ToggleInlineTestOutput="testing.toggleInlineTestOutput",S.UnhideAllTestsAction="testing.unhideAllTests",S.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(ke[120],Ie([1,0,7,4,3,65,74,73]),function($e,e,r,h,C,R,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=e.$dQ=e.$cQ=e.$bQ=e.$aQ=e.TestItemEventOp=void 0;var p;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk",f[f.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const c=(f,i)=>f===i,S=Object.entries({range:(f,i)=>f===i?!0:!f||!i?!1:f.equalsRange(i),busy:c,label:c,description:c,error:c,sortText:c,tags:(f,i)=>!(f.length!==i.length||f.some(s=>!i.includes(s)))}),u=(f,i)=>{let s;for(const[t,o]of S)o(f[t],i[t])||(s?s[t]=i[t]:s={[t]:i[t]});return s};class P extends C.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new r.$Rh(()=>this.flushDiff(),200)),this.g=this.B(new h.$le),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const s of this.tree.values())this.J(s)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case O.TestDiffOpType.DocumentSynced:{for(const s of this.m)if(s.op===O.TestDiffOpType.DocumentSynced&&s.uri===i.uri){s.docv=i.docv;return}break}case O.TestDiffOpType.Update:{const s=this.m[this.m.length-1];if(s){if(s.op===O.TestDiffOpType.Update&&s.item.extId===i.item.extId){(0,O.$bJ)(s.item,i.item);return}if(s.op===O.TestDiffOpType.Add&&s.item.item.extId===i.item.extId){(0,O.$bJ)(s.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,s){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||s>t.expandLevels)&&(t.expandLevels=s),t.expand===O.TestItemExpandState.Expandable){const o=this.M(t);return o.isOpen()?this.L(t,s-1):o.wait().then(()=>this.L(t,s-1))}else if(t.expand===O.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,s-1)):this.L(t,s-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,s){switch(s.op){case p.RemoveChild:this.O(T.$7I.joinToString(i.fullId,s.id));break;case p.Upsert:this.z(s.item,i);break;case p.Bulk:for(const t of s.ops)this.w(i,t);break;case p.SetTags:this.C(s.new,s.old,i.fullId.toString());break;case p.UpdateCanResolveChildren:this.J(i);break;case p.SetProp:this.pushDiff({op:O.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:s.update}});break;case p.DocumentSynced:this.y(i.actual.uri);break;default:(0,R.$ed)(s)}}y(i){i&&this.pushDiff({op:O.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,s){const t=T.$7I.fromExtHostTestItem(i,this.root.id,s?.actual),o=this.s.getApiFor(i);o.parent&&o.parent!==s?.actual&&this.s.getChildren(o.parent).delete(i.id);let n=this.tree.get(t.toString());if(!n){n={fullId:t,actual:i,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:O.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(n.fullId.toString(),n),this.G(i,s),this.pushDiff({op:O.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:n.expand,item:this.s.toITestItem(i)}}),this.I(i,n,s);return}if(n.actual===i){this.H(i,n,s);return}if(n.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,s);const d=this.s.getChildren(n.actual),l=n.actual,g=u(this.s.toITestItem(l),this.s.toITestItem(i));this.s.getApiFor(l).listener=void 0,n.actual=i,n.resolveBarrier=void 0,n.expand=O.TestItemExpandState.NotExpandable,g&&(g.hasOwnProperty("tags")&&(this.C(i.tags,l.tags,t.toString()),delete g.tags),this.w(n,{op:p.SetProp,update:g})),this.I(i,n,s);for(const[D,y]of d)this.s.getChildren(i).get(y.id)||this.O(T.$7I.joinToString(t,y.id));const E=n.expandLevels;E!==void 0&&queueMicrotask(()=>{n.expand===O.TestItemExpandState.Expandable&&(n.expandLevels=void 0,this.expand(t.toString(),E))}),this.y(n.actual.uri)}C(i,s,t){const o=new Set(s.map(n=>n.id));for(const n of i)o.delete(n.id)||this.D(n);this.pushDiff({op:O.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(n=>(0,O.$_I)(this.s.controllerId,n.id))}}}),o.forEach(this.F,this)}D(i){const s=this.j.get(i.id);s?s.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:O.TestDiffOpType.AddTag,tag:{id:(0,O.$_I)(this.s.controllerId,i.id)}}))}F(i){const s=this.j.get(i);s&&!--s.refCount&&(this.j.delete(i),this.pushDiff({op:O.TestDiffOpType.RemoveTag,id:(0,O.$_I)(this.s.controllerId,i)}))}G(i,s){this.s.getApiFor(i).parent=s&&s.actual!==this.root?s.actual:void 0}H(i,s,t){this.G(i,t);const o=this.s.getApiFor(i);o.parent=t?.actual,o.listener=n=>this.w(s,n),this.J(s)}I(i,s,t){this.H(i,s,t);for(const[o,n]of this.s.getChildren(i))this.z(n,s)}J(i){let s;this.h?i.resolveBarrier?s=i.resolveBarrier.isOpen()?O.TestItemExpandState.Expanded:O.TestItemExpandState.BusyExpanding:s=i.actual.canResolveChildren?O.TestItemExpandState.Expandable:O.TestItemExpandState.NotExpandable:s=O.TestItemExpandState.NotExpandable,s!==i.expand&&(i.expand=s,this.pushDiff({op:O.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:s}}),s===O.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,s){if(s<0)return;const t=[];for(const[o,n]of this.s.getChildren(i.actual)){const d=this.expand(T.$7I.joinToString(i.fullId,n.id),s);(0,r.$rh)(d)&&t.push(d)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const n=new r.$Eh;return n.open(),n}i.expand=O.TestItemExpandState.BusyExpanding,this.N(i);const s=i.resolveBarrier=new r.$Eh,t=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,n)};let o;try{o=this.h(i.actual===this.root?void 0:i.actual)}catch(n){t(n)}return(0,r.$rh)(o)?o.catch(t).then(()=>{s.open(),this.J(i)}):(s.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:O.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const s=this.tree.get(i);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:O.TestDiffOpType.Remove,itemId:i});const t=[s];for(;t.length;){const o=t.pop();if(o){this.s.getApiFor(o.actual).listener=void 0;for(const n of o.actual.tags)this.F(n.id);this.tree.delete(o.fullId.toString());for(const[n,d]of this.s.getChildren(o.actual))t.push(this.tree.get(T.$7I.joinToString(o.fullId,d.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$aQ=P;class w extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$bQ=w;class a extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$cQ=a;class m extends Error{constructor(i,s,t){super(`TestItem with ID "${i}" is from controller "${s}" and cannot be added as a child of an item from controller "${t}".`)}}e.$dQ=m;const $=(f,i,s)=>{let t=new Map;return{get size(){return t.size},forEach(o,n){for(const d of t.values())o.call(n,d,this)},[Symbol.iterator](){return t.entries()},replace(o){const n=new Map,d=new Set(t.keys()),l={op:p.Bulk,ops:[]};for(const g of o){if(!(g instanceof s))throw new a(g.id);const E=i(g).controllerId;if(E!==f.controllerId)throw new m(g.id,E,f.controllerId);if(n.has(g.id))throw new w(g.id);n.set(g.id,g),d.delete(g.id),l.ops.push({op:p.Upsert,item:g})}for(const g of d.keys())l.ops.push({op:p.RemoveChild,id:g});f.listener?.(l),t=n},add(o){if(!(o instanceof s))throw new a(o.id);t.set(o.id,o),f.listener?.({op:p.Upsert,item:o})},delete(o){t.delete(o)&&f.listener?.({op:p.RemoveChild,id:o})},get(o){return t.get(o)},toJSON(){return Array.from(t.values())}}};e.$eQ=$}),define(ke[155],Ie([1,0,120]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gQ=e.$fQ=void 0;const h=new WeakMap,C=(O,T)=>{const p={controllerId:T};return h.set(O,p),p};e.$fQ=C;const R=O=>{const T=h.get(O);if(!T)throw new r.$cQ(O?.id||"<unknown>");return T};e.$gQ=R}),define(ke[121],Ie([1,0,26,14,2]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GDb=e.$FDb=e.$EDb=void 0,e.$HDb=R,e.$IDb=T,e.$EDb="vscode-cdn.net",e.$FDb=`vscode-resource.${e.$EDb}`,e.$GDb=`'self' https://*.${e.$EDb}`;function R(p,c){return p.scheme===h.Schemas.http||p.scheme===h.Schemas.https?p:(c&&c.authority&&c.isRemote&&p.scheme===h.Schemas.file&&(p=C.URI.from({scheme:h.Schemas.vscodeRemote,authority:c.authority,path:p.path})),C.URI.from({scheme:h.Schemas.https,authority:`${p.scheme}+${O(p.authority)}.${e.$FDb}`,path:p.path,fragment:p.fragment,query:p.query}))}function O(p){return p.replace(/./g,c=>{const I=c.charCodeAt(0);return I>=r.CharCode.a&&I<=r.CharCode.z||I>=r.CharCode.A&&I<=r.CharCode.Z||I>=r.CharCode.Digit0&&I<=r.CharCode.Digit9?c:"-"+I.toString(16).padStart(4,"0")})}function T(p){return p.replace(/-([0-9a-f]{4})/g,(c,I)=>String.fromCharCode(parseInt(I,16)))}}),define(ke[265],Ie([1,0,4,3,121]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jpc=void 0;class R{constructor(T,p,c){this.d=T,this.e=p,this.f=c,this.a=0,this.b=new h.$Tc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const I=p.getVisibleTextEditors();for(const S of this.c.values())I.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,p,c,I,S){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===T){u=i;break}if(!u)throw new Error("not a visible editor");const P=this,w=this.a++,a=new r.$le,m=new r.$le,$=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,C.$HDb)(i,P.f)}get cspSource(){return C.$GDb}set options(i){this.b=i,P.d.$setOptions(w,i)}get options(){return this.b}set html(i){this.a=i,P.d.$setHtml(w,i)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(i){return P.d.$postMessage(w,i)}},f=new class{constructor(){this.editor=T,this.line=p,this.height=c,this.webview=$,this.onDidDispose=m.event}dispose(){P.c.has(w)&&(P.c.delete(w),P.d.$disposeEditorInset(w),m.fire(),m.dispose(),a.dispose())}};return this.d.$createEditorInset(w,u.id,u.value.document.uri,p+1,c,I||{},S.identifier,S.extensionLocation),this.c.set(w,{editor:T,inset:f,onDidReceiveMessage:a}),f}$onDidDispose(T){const p=this.c.get(T);p&&p.inset.dispose()}$onDidReceiveMessage(T,p){this.c.get(T)?.onDidReceiveMessage.fire(p)}}e.$Jpc=R}),define(ke[156],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=e.$NM=e.$MM=void 0,e.$MM="__",e.$NM=(0,r.$Fi)("IAuthenticationService"),e.$OM=(0,r.$Fi)("IAuthenticationExtensionsService")}),define(ke[266],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Q=e.VariableKind=e.$$Q=void 0,e.$$Q=(0,r.$Fi)("configurationResolverService");var h;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(h||(e.VariableKind=h={}));class C extends Error{constructor(O,T){super(T),this.variable=O}}e.$_Q=C}),define(ke[267],Ie([1,0,16,55,17,24,10,107,8,266,12]),function($e,e,r,h,C,R,O,T,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=void 0,r=qe(r),h=qe(h),C=qe(C),R=qe(R);class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(P,w,a,m){this.h=new Map,this.a=P,this.b=w,this.g=a,m&&(this.c=m.then($=>this.i($)))}i(P){if(O.$j){const w=Object.create(null);return Object.keys(P).forEach(a=>{w[a.toLowerCase()]=P[a]}),w}return P}resolveWithEnvironment(P,w,a){return this.l({env:this.i(P),userHome:void 0},w?w.uri:void 0,a)}async resolveAsync(P,w){const a={env:await this.c,userHome:await this.g};return this.l(a,P?P.uri:void 0,w)}async j(P,w,a,m){const $=R.$eo(w);O.$j&&$.windows?Object.keys($.windows).forEach(i=>$[i]=$.windows[i]):O.$k&&$.osx?Object.keys($.osx).forEach(i=>$[i]=$.osx[i]):O.$l&&$.linux&&Object.keys($.linux).forEach(i=>$[i]=$.linux[i]),delete $.windows,delete $.osx,delete $.linux;const f={env:await this.c,userHome:await this.g};return this.l(f,P?P.uri:void 0,$,a,m)}async resolveAnyAsync(P,w,a){return this.j(P,w,a)}async resolveAnyMap(P,w,a){const m=new Map;return{newConfig:await this.j(P,w,a,m),resolvedVariables:m}}resolveWithInteractionReplace(P,w,a,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,w,a,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,w){if(this.h.has(P))throw new Error("Variable "+P+" is contributed twice.");this.h.set(P,w)}async l(P,w,a,m,$){if(C.$eg(a))return this.m(P,w,a,m,$);if(Array.isArray(a))return Promise.all(a.map(f=>this.l(P,w,f,m,$)));if(C.$gg(a)){const f=Object.create(null),i=await Promise.all(Object.keys(a).map(async s=>[await this.m(P,w,s,m,$),await this.l(P,w,a[s],m,$)]));for(const[s,t]of i)f[s]=t;return f}return a}m(P,w,a,m,$){return(0,I.$xf)(a,S.VARIABLE_REGEXP,async(f,i)=>{if(i.includes(S.VARIABLE_LHS))return f;let s=await this.o(P,f,i,w,m);return $?.set(i,s),s!==f&&C.$eg(s)&&s.match(S.VARIABLE_REGEXP)&&(s=await this.m(P,w,s,m,$)),s})}n(P){return this.b?this.b.getUriLabel(P,{noPrefix:!0}):P.fsPath}async o(P,w,a,m,$){let f;const i=a.split(":");i.length>1&&(a=i[0],f=i[1]);const s=n=>{const d=this.a.getFilePath();if(d)return(0,T.$1w)(d);throw new c.$_Q(n,(0,p.localize)(2078,null,w))},t=n=>{const d=s(n);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,T.$1w)(l)}throw new c.$_Q(n,(0,p.localize)(2079,null,w,r.$nc(d)))},o=n=>{if(f){const d=this.a.getFolderUri(f);if(d)return d;throw new c.$_Q(n,(0,p.localize)(2080,null,w,f))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new c.$_Q(n,(0,p.localize)(2081,null,w)):new c.$_Q(n,(0,p.localize)(2082,null,w))};switch(a){case"env":if(f){if(P.env){const n=P.env[O.$j?f.toLowerCase():f];if(C.$eg(n))return n}return""}throw new c.$_Q(c.VariableKind.Env,(0,p.localize)(2083,null,w));case"config":if(f){const n=this.a.getConfigurationValue(m,f);if(C.$ng(n))throw new c.$_Q(c.VariableKind.Config,(0,p.localize)(2084,null,w,f));if(C.$gg(n))throw new c.$_Q(c.VariableKind.Config,(0,p.localize)(2085,null,w,f));return n}throw new c.$_Q(c.VariableKind.Config,(0,p.localize)(2086,null,w));case"command":return this.p(c.VariableKind.Command,w,f,$,"command");case"input":return this.p(c.VariableKind.Input,w,f,$,"input");case"extensionInstallFolder":if(f){const n=await this.a.getExtension(f);if(!n)throw new c.$_Q(c.VariableKind.ExtensionInstallFolder,(0,p.localize)(2087,null,w,f));return this.n(n.extensionLocation)}throw new c.$_Q(c.VariableKind.ExtensionInstallFolder,(0,p.localize)(2088,null,w));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,T.$1w)(this.n(o(c.VariableKind.WorkspaceFolder)));case"cwd":return m||f?(0,T.$1w)(this.n(o(c.VariableKind.Cwd))):h.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$1w)(r.$nc(this.n(o(c.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(P.userHome)return P.userHome;throw new c.$_Q(c.VariableKind.UserHome,(0,p.localize)(2089,null,w))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new c.$_Q(c.VariableKind.LineNumber,(0,p.localize)(2090,null,w))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new c.$_Q(c.VariableKind.SelectedText,(0,p.localize)(2091,null,w))}case"file":return s(c.VariableKind.File);case"fileWorkspaceFolder":return t(c.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return r.$nc(t(c.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||f?r.$lc(this.n(o(c.VariableKind.RelativeFile)),s(c.VariableKind.RelativeFile)):s(c.VariableKind.RelativeFile);case"relativeFileDirname":{const n=r.$mc(s(c.VariableKind.RelativeFileDirname));if(m||f){const d=r.$lc(this.n(o(c.VariableKind.RelativeFileDirname)),n);return d.length===0?".":d}return n}case"fileDirname":return r.$mc(s(c.VariableKind.FileDirname));case"fileExtname":return r.$oc(s(c.VariableKind.FileExtname));case"fileBasename":return r.$nc(s(c.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=r.$nc(s(c.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-r.$oc(n).length)}case"fileDirnameBasename":return r.$nc(r.$mc(s(c.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||w}case"execInstallFolder":{const n=this.a.getAppRoot();return n||w}case"pathSeparator":case"/":return r.sep;default:try{const n=f?`${a}:${f}`:a;return this.p(c.VariableKind.Unknown,w,n,$,void 0)}catch{return w}}}}p(P,w,a,m,$){if(a&&m){const f=$===void 0?m[a]:m[$+":"+a];if(typeof f=="string")return f;throw new c.$_Q(P,(0,p.localize)(2092,null,w))}return w}}e.$oR=S}),define(ke[157],Ie([1,0,5,152]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$tE=void 0,e.$uE=c,e.$vE=u,e.$wE=P,e.$tE=(0,r.$Fi)("editorGroupsService");var C;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var R;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var O;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(O||(e.GroupLocation=O={}));var T;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EXPAND=1]="EXPAND",w[w.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var p;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function c(w){const a=w;return(0,h.$hG)(a?.editor)&&(0,h.$hG)(a?.replacement)}var I;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var S;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function u(w){const a=w;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function P(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?C.DOWN:C.RIGHT}}),define(ke[268],Ie([1,0,5,157]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AE=e.$zE=e.$yE=e.$xE=void 0,e.$BE=C,e.$xE=(0,r.$Fi)("editorService"),e.$yE=-1,e.$zE=-2,e.$AE=-3;function C(R){const O=R;return typeof R=="number"||(0,h.$vE)(O)}}),define(ke[158],Ie([1,0,5,144]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=void 0,e.$8M=(0,r.$Gi)(h.$Mi)}),define(ke[159],Ie([1,0,23,4,16,3,7]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=e.$Odc=e.$Ndc=e.$Mdc=e.$Ldc=void 0,C=qe(C);class T{constructor(f,i){this.versionId=f,this.removedDueToLooping=i}}e.$Ldc=T;class p{static isHostExtension(f,i,s){if(i.getExtensionDescription(f))return!1;const t=s.getExtensionDescription(f);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(f,i){this.j=f,this.c=new h.$le,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(a),this.f=new r.$tn,this.g=[],this.h=new Map;for(const f of this.e){if(this.f.has(f.identifier)){console.error("Extension `"+f.identifier.value+"` is already registered");continue}this.f.set(f.identifier,f),this.g.push(f);const i=this.j.readActivationEvents(f);for(const s of i)this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(f)}}set(f){return this.e=f,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(f,i){this.e=m(this.e,i),this.e=this.e.concat(f);const s=p.l(this.e);return this.e=m(this.e,s.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new T(this.d,s)}static l(f){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,l){this.addNode(d),this.addNode(l),this.c.has(d)?this.c.get(d).push(l):this.c.set(d,[l])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,l){const g=i.getArcs(d);for(let E=0;E<g.length;E++)if(!l.has(g[E]))return!1;return!0}getNodes(){return this.e}},s=new r.$tn;for(const d of f)if(s.set(d.identifier,d),d.extensionDependencies)for(const l of d.extensionDependencies)i.addArc(r.$rn.toKey(d.identifier),r.$rn.toKey(l));const t=new Set;i.getNodes().filter(d=>i.getArcs(d).length===0).forEach(d=>t.add(d));const o=i.getNodes().filter(d=>!t.has(d));let n;do{n=!1;for(let d=0;d<o.length;d++){const l=o[d];i.hasOnlyGoodArcs(l,t)&&(o.splice(d,1),d--,t.add(l),n=!0)}}while(n);return o.map(d=>s.get(d))}containsActivationEvent(f){return this.h.has(f)}containsExtension(f){return this.f.has(f)}getExtensionDescriptionsForActivationEvent(f){const i=this.h.get(f);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new c(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(f){const i=this.f.get(f);return i||void 0}getExtensionDescriptionByUUID(f){for(const i of this.g)if(i.uuid===f)return i}getExtensionDescriptionByIdOrUUID(f,i){return this.getExtensionDescription(f)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$Mdc=p;class c{constructor(f,i){this.versionId=f,this.extensions=i}}e.$Ndc=c;class I{constructor(f){this.d=new P,this.c=new p(f,[])}async acquireLock(f){const i=await this.d.acquire(f);return new S(this,i)}deltaExtensions(f,i,s){if(!f.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,s)}containsActivationEvent(f){return this.c.containsActivationEvent(f)}containsExtension(f){return this.c.containsExtension(f)}getExtensionDescriptionsForActivationEvent(f){return this.c.getExtensionDescriptionsForActivationEvent(f)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(f){return this.c.getExtensionDescription(f)}getExtensionDescriptionByUUID(f){return this.c.getExtensionDescriptionByUUID(f)}getExtensionDescriptionByIdOrUUID(f,i){return this.c.getExtensionDescriptionByIdOrUUID(f,i)}}e.$Odc=I;class S extends R.$Uc{constructor(f,i){super(),this.f=f,this.c=!1,this.B(i)}isAcquiredFor(f){return!this.c&&this.f===f}}e.$Pdc=S;class u{constructor(f){this.name=f;const i=(0,O.$yh)();this.promise=i.promise,this.c=i.resolve}resolve(f){this.c(f)}}class P{constructor(){this.c=[],this.d=!1}async acquire(f){const i=new u(f);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const f=this.c.shift();this.d=!0;let i=!0;const s=setTimeout(()=>{i&&console.warn(`The customer named ${f.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(s),i=!1,this.d=!1,this.e())};f.resolve((0,R.$Sc)(t))}}var w;(function($){$[$.Builtin=0]="Builtin",$[$.User=1]="User",$[$.Dev=2]="Dev"})(w||(w={}));function a($,f){const i=$.isBuiltin?w.Builtin:$.isUnderDevelopment?w.Dev:w.User,s=f.isBuiltin?w.Builtin:f.isUnderDevelopment?w.Dev:w.User;if(i!==s)return i-s;const t=C.$gc.basename($.extensionLocation.path),o=C.$gc.basename(f.extensionLocation.path);return t<o?-1:t>o?1:0}function m($,f){const i=new r.$sn(f);return $.filter(s=>!i.has(s.identifier))}}),define(ke[269],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=e.$dn=e.$cn=e.ExtHostConnectionType=void 0,e.$fn=T,e.$gn=p;var r;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(r||(e.ExtHostConnectionType=r={}));class h{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(S){this.pipeName=S,this.type=r.IPC}serialize(S){S[h.ENV_KEY]=this.pipeName}}e.$cn=h;class C{constructor(){this.type=r.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(S){S[C.ENV_KEY]="1"}}e.$dn=C;class R{constructor(){this.type=r.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(S){S[R.ENV_KEY]="1"}}e.$en=R;function O(I){delete I[h.ENV_KEY],delete I[C.ENV_KEY],delete I[R.ENV_KEY]}function T(I,S){O(S),I.serialize(S)}function p(I){if(I[h.ENV_KEY])return c(I,new h(I[h.ENV_KEY]));if(I[C.ENV_KEY])return c(I,new C);if(I[R.ENV_KEY])return c(I,new R);throw new Error("No connection information defined in environment!")}function c(I,S){return O(I),S}}),define(ke[93],Ie([1,0,21]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Bn=O,e.$Cn=T;var h;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(h||(e.UIKind=h={}));var C;(function(c){c[c.VersionMismatch=55]="VersionMismatch",c[c.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var R;(function(c){c[c.Initialized=0]="Initialized",c[c.Ready=1]="Ready",c[c.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function O(c){const I=r.$Ne.alloc(1);switch(c){case R.Initialized:I.writeUInt8(1,0);break;case R.Ready:I.writeUInt8(2,0);break;case R.Terminate:I.writeUInt8(3,0);break}return I}function T(c,I){if(c.byteLength!==1)return!1;switch(c.readUInt8(0)){case 1:return I===R.Initialized;case 2:return I===R.Ready;case 3:return I===R.Terminate;default:return!1}}var p;(function(c){c.Start="START_NATIVE_LOG",c.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(ke[94],Ie([1,0,5,4,149,11,29,93,90,91,24,2,3,8]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EQ=e.$CQ=e.$BQ=void 0,e.$DQ=m;let w=class extends u.$Uc{constructor(f,i){super(),this.s=f,this.t=i,this.a=this.B(new h.$le),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new h.$le),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=C.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=S.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:c.$Cp,name:(0,P.localize)(10825,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(s=>{(0,R.$ck)(s)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===C.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=C.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=C.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=C.TelemetryLevel.USAGE:!1}}instantiateLogger(f,i,s){const t=this.getTelemetryDetails(),o=new a(i,s,f,this.n,this.j,this.getBuiltInCommonProperties(f),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),n=this.r.get(f.identifier.value)??[];return this.r.set(f.identifier.value,[...n,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(f,i,s){this.f=f,this.g=i,this.c=s??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(f){const i=Object.create(null);switch(i["common.extname"]=`${f.publisher}.${f.name}`,i["common.extversion"]=f.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=m(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:i["common.uikind"]="web";break;case T.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$in)((0,c.$Ip)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(f){this.h=this.getTelemetryConfiguration(),this.f=f;const i=this.getTelemetryDetails();this.r.forEach((s,t)=>{const o=s.filter(n=>!n.isDisposed);o.length===0?this.r.delete(t):this.r.set(t,o)}),this.r.forEach(s=>{for(const t of s)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(f,i){const t=this.r.get(f.value)?.filter(n=>!n.isDisposed);if(!t)return this.r.delete(f.value),!1;let o=!1;for(const n of t)n.ignoreUnhandledExtHostErrors||(n.logError(i),o=!0);return o}};e.$BQ=w,e.$BQ=w=Je([Ve(0,O.$AQ),Ve(1,R.$bk)],w);class a{static validateSender(f){if(typeof f!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof f.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof f.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof f.flush<"u"&&typeof f.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(f,i,s,t,o,n,d){this.g=s,this.h=t,this.i=o,this.j=n,this.a=new h.$le,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=f,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(f,i){this.e&&(this.d={isUsageEnabled:f,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(f){let i="properties"in f?f.properties??{}:f;return i=(0,c.$Lp)(i,[]),this.c&&(i=(0,I.$ho)(i,this.c)),this.b||(i=(0,I.$ho)(i,this.j)),"properties"in f?f.properties=i:f=i,f}k(f,i){this.f&&(this.g.publisher==="vscode"?f=this.g.name+"/"+f:f=this.g.identifier.value+"/"+f,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(f,i),this.h.trace(f,i))}logUsage(f,i){this.d.isUsageEnabled&&this.k(f,i)}logError(f,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof f=="string")this.k(f,i);else{const s={name:f.name,message:f.message,stack:f.stack,cause:f.cause},t=(0,c.$Lp)(s,[]),o=new Error(t.message,{cause:t.cause});o.stack=t.stack,o.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(o,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const f=this,i={logUsage:f.logUsage.bind(f),get isUsageEnabled(){return f.d.isUsageEnabled},get isErrorsEnabled(){return f.d.isErrorsEnabled},logError:f.logError.bind(f),dispose:f.dispose.bind(f),onDidChangeEnableStates:f.a.event.bind(f)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let f=this.f;this.f=void 0,Promise.resolve(f.flush()).then(f=void 0),this.e=void 0}else this.f=void 0}}e.$CQ=a;function m($){const f=Date.now()-new Date($).getTime();return isNaN(f)?!1:f<1e3*60*60*24}e.$EQ=(0,r.$Fi)("IExtHostTelemetry")}),define(ke[25],Ie([1,0,4,2,240,147,23,5]),function($e,e,r,h,C,R,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lH=e.ActivationKind=e.$iH=e.$hH=e.$eH=e.ExtensionHostStartup=e.$dH=e.$cH=e.$bH=e.$aH=void 0,e.$fH=u,e.$gH=P,e.$jH=$,e.$kH=f,e.$aH=Object.freeze({identifier:new O.$rn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:h.URI.parse("void:location"),isBuiltin:!1,targetPlatform:O.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$bH="extensions.webWorker",e.$cH=(0,T.$Fi)("extensionService");class p{constructor(t){this.dependency=t}}e.$dH=p;var c;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(c||(e.ExtensionHostStartup=c={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,o,n){this.c=t,this.d=o.slice(0),this.e=n.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$YG.createActivationEventsMap(this.d)}}set(t,o,n){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const d=[],l=[],g=[],E=[],D=S(this.d),y=S(o),k=(N,L)=>N.extensionLocation.toString()===L.extensionLocation.toString()||N.isBuiltin===L.isBuiltin||N.isUserBuiltin===L.isUserBuiltin||N.isUnderDevelopment===L.isUnderDevelopment;for(const N of this.d){const L=y.get(N.identifier);if(!L){d.push(N.identifier),D.delete(N.identifier);continue}if(!k(N,L)){d.push(N.identifier),D.delete(N.identifier);continue}}for(const N of o){const L=D.get(N.identifier);if(!L){l.push(N);continue}if(!k(L,N)){d.push(L.identifier),D.delete(L.identifier);continue}}const A=new O.$sn(this.e),b=new O.$sn(n);for(const N of this.e)b.has(N)||g.push(N);for(const N of n)A.has(N)||E.push(N);const v=R.$YG.createActivationEventsMap(l),F={versionId:t,toRemove:d,toAdd:l,addActivationEvents:v,myToRemove:g,myToAdd:E};return this.delta(F),F}delta(t){if(this.c>=t.versionId)return null;const{toRemove:o,toAdd:n,myToRemove:d,myToAdd:l}=t,g=new O.$sn(o),E=new O.$sn(d);for(let D=0;D<this.d.length;D++)g.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)E.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of n)this.d.push(D);for(const D of l)this.e.push(D);return this.f=null,t}containsExtension(t){for(const o of this.e)if(O.$rn.equals(o,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const o of this.d){if(!this.containsExtension(o.identifier))continue;const n=R.$YG.readActivationEvents(o);for(const d of n)t.add(d)}return t}}e.$eH=I;function S(s){const t=new O.$tn;for(const o of s)t.set(o.identifier,o);return t}function u(s,t){return s.enabledApiProposals?s.enabledApiProposals.includes(t):!1}function P(s,t){if(!u(s,t))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}class w{constructor(t,o,n,d){this.codeLoadingTime=t,this.activateCallTime=o,this.activateResolvedTime=n,this.activationReason=d}}e.$hH=w;class a{constructor(t,o){this.description=t,this.value=o}}e.$iH=a;var m;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function $(s){return{type:s.isBuiltin?O.ExtensionType.System:O.ExtensionType.User,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,C.$Rp)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}function f(s,t){const o=(0,C.$Pp)(s.manifest.publisher,s.manifest.name);return{id:o,identifier:new O.$rn(o),isBuiltin:s.type===O.ExtensionType.System,isUserBuiltin:s.type===O.ExtensionType.User&&s.isBuiltin,isUnderDevelopment:!!t,extensionLocation:s.location,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,publisherDisplayName:s.publisherDisplayName,...s.manifest}}class i{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.onWillStop=r.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,o){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,o){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$lH=i}),define(ke[270],Ie([1,0,13,3,159,23,25,11,7]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$pc=e.$0pc=e.$9pc=e.$8pc=e.$7pc=e.$6pc=void 0,r=qe(r);class c{static{this.NONE=new c(!1,-1,-1,-1)}constructor(f,i,s,t){this.startup=f,this.codeLoadingTime=i,this.activateCallTime=s,this.activateResolvedTime=t}}e.$6pc=c;class I{constructor(f){this.a=f,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(f,i){return f===-1||i===-1?-1:i-f}build(){return new c(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$7pc=I;class S{constructor(f,i,s,t,o,n){this.activationFailed=f,this.activationFailedError=i,this.activationTimes=s,this.module=t,this.exports=o,this.disposable=n}}e.$8pc=S;class u extends S{constructor(f){super(!1,null,f,{activate:void 0,deactivate:void 0},void 0,h.$Uc.None)}}e.$9pc=u;class P extends S{constructor(){super(!1,null,c.NONE,{activate:void 0,deactivate:void 0},void 0,h.$Uc.None)}}e.$0pc=P;class w extends S{constructor(f){super(!0,f,c.NONE,{activate:void 0,deactivate:void 0},void 0,h.$Uc.None)}}let a=class{constructor(f,i,s,t){this.g=t,this.a=f,this.b=i,this.c=s,this.d=new R.$tn,this.f=Object.create(null)}dispose(){for(const[f,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const f=[];for(const[i,s]of this.d)f.push(s.wait());await Promise.all(f)}isActivated(f){const i=this.d.get(f);return!!(i&&i.value)}getActivatedExtension(f){const i=this.d.get(f);if(!i||!i.value)throw new Error(`Extension '${f.value}' is not known or not activated`);return i.value}async activateByEvent(f,i){if(this.f[f])return;const s=this.a.getExtensionDescriptionsForActivationEvent(f);await this.h(s.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:f}}))),this.f[f]=!0}activateById(f,i){const s=this.a.getExtensionDescription(f);if(!s)throw new Error(`Extension '${f.value}' is not known`);return this.h([{id:s.identifier,reason:i}])}async h(f){const i=f.filter(s=>!this.isActivated(s.id)).map(s=>this.j(s));await Promise.all(i.map(s=>s.wait()))}j(f){if(this.d.has(f.id))return this.d.get(f.id);if(this.l(f.id))return this.k(f,null,[],null);const i=this.a.getExtensionDescription(f.id);if(!i){const o=new Error(`Cannot activate unknown extension '${f.id.value}'`),n=this.k(f,null,[],new w(o));return this.c.onExtensionActivationError(f.id,o,new O.$dH(f.id.value)),n}const s=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const o of t){if(this.m(o))continue;const n=this.d.get(o);if(n){s.push(n);continue}if(this.l(o)){s.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:f.reason}));continue}const d=this.a.getExtensionDescription(o);if(d){if(!d.main&&!d.browser)continue;s.push(this.j({id:d.identifier,reason:f.reason}));continue}const l=i.displayName||i.identifier.value,g=new Error(`Cannot activate the '${l}' extension because it depends on unknown extension '${o}'`),E=this.k(f,i.displayName,[],new w(g));return this.c.onExtensionActivationError(i.identifier,g,new O.$dH(o)),E}return this.k(f,i.displayName,s,null)}k(f,i,s,t){const o=new m(f.id,i,f.reason,s,t,this.c,this.g);return this.d.set(f.id,o),o}l(f){return C.$Mdc.isHostExtension(f,this.a,this.b)}m(f){const i=this.b.getExtensionDescription(f);return i?!i.main&&!i.browser:!1}};e.$$pc=a,e.$$pc=a=Je([Ve(3,T.$ak)],a);let m=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(f,i,s,t,o,n,d){this.c=f,this.d=i,this.f=s,this.g=t,this.h=o,this.j=n,this.k=d,this.a=new p.$Eh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let f=0;f<this.g.length;f++){const i=this.g[f];if(i.value&&!i.value.activationFailed){this.g.splice(f,1),f--;continue}if(i.value&&i.value.activationFailed){const s=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);s.detail=i.value.activationFailedError,this.h=new w(s),this.j.onExtensionActivationError(this.c,s,null);return}}this.g.length>0&&await Promise.race(this.g.map(f=>f.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(f){const i=new Error;if(f&&f.name&&(i.name=f.name),f&&f.message?i.message=`Activating extension '${this.c.value}' failed: ${f.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${f}.`,f&&f.stack&&(i.stack=f.stack),this.h=new w(i),this.b&&r.$3(f))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(f)}}};m=Je([Ve(6,T.$ak)],m)});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[160],Ie([1,0,8,13,43,146,116,36,23,115,147,143]),function($e,e,r,h,C,R,O,T,p,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=void 0,r=qe(r),C=Ut(C);const u=T.$ro.as(O.$so.JSONContribution);class P{constructor(t,o,n){this.a=t,this.b=o,this.c=n}d(t,o){this.a({type:t,message:o,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(C.default.Error,t)}warn(t){this.d(C.default.Warning,t)}info(t){this.d(C.default.Info,t)}}e.$7G=P;class w{static a(t){const o=new p.$sn;for(let n=0,d=t.length;n<d;n++)o.add(t[n].description.identifier);return o}static compute(t,o){if(!t||!t.length)return new w(o,[]);if(!o||!o.length)return new w([],t);const n=this.a(t),d=this.a(o),l=o.filter(E=>!n.has(E.description.identifier)),g=t.filter(E=>!d.has(E.description.identifier));return new w(l,g)}constructor(t,o){this.added=t,this.removed=o}}e.$8G=w;class a{constructor(t,o){this.name=t,this.defaultExtensionKind=o,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=w.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,h.$Y)(t)}}}e.$9G=a;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(1843,null),r.localize(1844,null)]},$="vscode://schemas/vscode-extensions";e.$0G={properties:{engines:{type:"object",description:r.localize(1845,null),properties:{vscode:{type:"string",description:r.localize(1846,null),default:"^1.22.0"}}},publisher:{description:r.localize(1847,null),type:"string"},displayName:{description:r.localize(1848,null),type:"string"},categories:{description:r.localize(1849,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$qn},{type:"string",const:"Languages",deprecationMessage:r.localize(1850,null)}]}},galleryBanner:{type:"object",description:r.localize(1851,null),properties:{color:{description:r.localize(1852,null),type:"string"},theme:{description:r.localize(1853,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(1854,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(1855,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(1856,null)},enabledApiProposals:{markdownDescription:r.localize(1857,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals).map(s=>s),markdownEnumDescriptions:Object.values(S.allApiProposals).map(s=>s.proposal)}},api:{markdownDescription:r.localize(1858,null),type:"string",enum:["none"],enumDescriptions:[r.localize(1859,null)]},activationEvents:{description:r.localize(1860,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(1861,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(1862,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(1863,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(1864,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(1865,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(1866,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(1867,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(1868,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(1869,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(1870,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(1871,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(1872,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(1873,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(1874,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(1875,null)},{label:"onUri",body:"onUri",description:r.localize(1876,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(1877,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(1878,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(1879,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(1880,null)},{label:"onRenderer",description:r.localize(1881,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(1882,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:r.localize(1883,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(1884,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:r.localize(1885,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:r.localize(1886,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:r.localize(1887,null)},{label:"*",description:r.localize(1888,null),body:"*"}]}},badges:{type:"array",description:r.localize(1889,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(1890,null)},href:{type:"string",description:r.localize(1891,null)},description:{type:"string",description:r.localize(1892,null)}}}},markdown:{type:"string",description:r.localize(1893,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(1894,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(1895,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$$o}},extensionPack:{description:r.localize(1896,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$$o}},extensionKind:{description:r.localize(1897,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(1898,null)},{body:["workspace"],description:r.localize(1899,null)},{body:["ui","workspace"],description:r.localize(1900,null)},{body:["workspace","ui"],description:r.localize(1901,null)},{body:[],description:r.localize(1902,null)}]},capabilities:{description:r.localize(1903,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(1904,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(1905,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(1906,null),r.localize(1907,null),r.localize(1908,null)]},description:{type:"string",markdownDescription:r.localize(1909,null)}}},untrustedWorkspaces:{description:r.localize(1910,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(1911,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(1912,null),r.localize(1913,null),r.localize(1914,null)]},restrictedConfigurations:{description:r.localize(1915,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(1916,null)}}}}},sponsor:{description:r.localize(1917,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(1918,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(1919,null),type:"string"},"vscode:uninstall":{description:r.localize(1920,null),type:"string"}}},icon:{type:"string",description:r.localize(1921,null)},l10n:{type:"string",description:r.localize(1922,null)},pricing:{type:"string",markdownDescription:r.localize(1923,null),enum:["Free","Trial"],default:"Free"}}};class f{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const o=new a(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,o),t.activationEventsGenerator&&I.$YG.register(t.extensionPoint,t.activationEventsGenerator),e.$0G.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,u.registerSchema($,e.$0G),o}getExtensionPoints(){return Array.from(this.a.values())}}e.$$G=f;const i={ExtensionsRegistry:"ExtensionsRegistry"};T.$ro.add(i.ExtensionsRegistry,new f),e.$_G=T.$ro.as(i.ExtensionsRegistry),u.registerSchema($,e.$0G),u.registerSchema(c.$uk,{properties:{extensionEnabledApiProposals:{description:r.localize(1924,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals).map(s=>s.proposal)}}]}}}})}),define(ke[271],Ie([1,0,4,39,3,12,8,23,5,11,25,160]),function($e,e,r,h,C,R,O,T,p,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oH=e.$nH=e.$mH=e.ChatMessageRole=void 0;var u;(function(a){a[a.System=0]="System",a[a.User=1]="User",a[a.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$mH=(0,p.$Fi)("ILanguageModelsService");const P={type:"object",properties:{vendor:{type:"string",description:(0,O.localize)(8424,null)}}};e.$nH=S.$_G.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,O.localize)(8425,null),oneOf:[P,{type:"array",items:P}]},activationEventsGenerator:(a,m)=>{for(const $ of a)m.push(`onLanguageModelChat:${$.vendor}`)}});let w=class{constructor(m,$){this.e=m,this.f=$,this.a=new C.$Tc,this.b=new Map,this.c=new Set,this.d=this.a.add(new r.$le),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$nH.setHandler(f=>{this.c.clear();for(const s of f){if(!(0,I.$fH)(s.description,"chatProvider")){s.collector.error((0,O.localize)(8426,null));continue}for(const t of h.Iterable.wrap(s.value)){if(this.c.has(t.vendor)){s.collector.error((0,O.localize)(8427,null,t.vendor));continue}if((0,R.$cf)(t.vendor)){s.collector.error((0,O.localize)(8428,null));continue}if(t.vendor.trim()!==t.vendor){s.collector.error((0,O.localize)(8429,null));continue}this.c.add(t.vendor)}}const i=[];for(const[s,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(s),i.push(s));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(m){return this.b.get(m)?.metadata}async selectLanguageModels(m){if(m.vendor)await this.e.activateByEvent(`onLanguageModelChat:${m.vendor}}`);else{const f=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(f)}const $=[];for(const[f,i]of this.b)(m.vendor===void 0||i.metadata.vendor===m.vendor)&&(m.family===void 0||i.metadata.family===m.family)&&(m.version===void 0||i.metadata.version===m.version)&&(m.identifier===void 0||i.metadata.id===m.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(s=>T.$rn.equals(s,m.extension)))&&$.push(f);return this.f.trace("[LM] selected language models",m,$),$}registerLanguageModelChat(m,$){if(this.f.trace("[LM] registering language model chat",m,$.metadata),!this.c.has($.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${$.metadata.vendor}.`);if(this.b.has(m))throw new Error(`Chat response provider with identifier ${m} is already registered.`);return this.b.set(m,$),this.d.fire({added:[{identifier:m,metadata:$.metadata}]}),(0,C.$Sc)(()=>{this.b.delete(m)&&(this.d.fire({removed:[m]}),this.f.trace("[LM] UNregistered language model chat",m,$.metadata))})}async sendChatRequest(m,$,f,i,s){const t=this.b.get(m);if(!t)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return t.sendChatRequest(f,$,i,s)}computeTokenLength(m,$,f){const i=this.b.get(m);if(!i)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return i.provideTokenCount($,f)}};e.$oH=w,e.$oH=w=Je([Ve(0,I.$cH),Ve(1,c.$ak)],w)}),define(ke[272],Ie([1,0,8,17,24,160,35,4]),function($e,e,r,h,C,R,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UI=void 0,r=qe(r),h=qe(h),C=qe(C);const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(3925,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(3926,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(3927,null),default:""}}};var c;(function(u){function P(w,a,m){if(!w)return;const $=h.$eg(w.type)?w.type:void 0;if(!$||$.length===0){m.error(r.localize(3928,null));return}const f=[];if(Array.isArray(w.required))for(const i of w.required)h.$eg(i)&&f.push(i);return{extensionId:a.value,taskType:$,required:f,properties:w.properties?C.$eo(w.properties):{},when:w.when?O.$Dj.deserialize(w.when):void 0}}u.from=P})(c||(c={}));const I=R.$_G.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,P)=>{for(const w of u)w.type&&P.push(`onTaskType:${w.type}`)},jsonSchema:{description:r.localize(3929,null),type:"array",items:p}});class S{constructor(){this.d=new T.$le,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((P,w)=>{I.setHandler((a,m)=>{this.c=void 0;try{for(const $ of m.removed){const f=$.value;for(const i of f)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const $ of m.added){const f=$.value;for(const i of f){const s=c.from(i,$.description.identifier,$.collector);s&&(this.a[s.taskType]=s)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}P(void 0)})})}onReady(){return this.b}get(P){return this.a[P]}all(){return Object.keys(this.a).map(P=>this.a[P])}getJsonSchema(){if(this.c===void 0){const P=[];for(const w of this.all()){const a={type:"object",additionalProperties:!1};w.required.length>0&&(a.required=w.required.slice(0)),w.properties!==void 0?a.properties=C.$eo(w.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[w.taskType]},P.push(a)}this.c={oneOf:P}}return this.c}}e.$UI=new S}),define(ke[273],Ie([1,0,8,17,22,24,35,272,46]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$5I=e.JsonSchemaVersion=e.ExecutionEngine=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$YI=e.ShellQuoting=e.$XI=e.$WI=e.$VI=void 0,r=qe(r),h=qe(h),C=qe(C),R=qe(R),e.$VI="settings",e.$WI=new O.$Wj("taskRunning",!1,r.localize(3913,null)),e.$XI=r.localize2(3915,"Tasks");var c;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(c||(e.ShellQuoting=c={})),e.$YI="$customized",function(j){function W(B){if(!B)return j.Strong;switch(B.toLowerCase()){case"escape":return j.Escape;case"strong":return j.Strong;case"weak":return j.Weak;default:return j.Strong}}j.from=W}(c||(e.ShellQuoting=c={}));var I;(function(j){j.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var S;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(S||(e.RevealKind=S={})),function(j){function W(B){switch(B.toLowerCase()){case"always":return j.Always;case"silent":return j.Silent;case"never":return j.Never;default:return j.Always}}j.fromString=W}(S||(e.RevealKind=S={}));var u;(function(j){j[j.Never=1]="Never",j[j.OnProblem=2]="OnProblem",j[j.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(j){function W(B){switch(B.toLowerCase()){case"always":return j.Always;case"never":return j.Never;case"onproblem":return j.OnProblem;default:return j.OnProblem}}j.fromString=W}(u||(e.RevealProblemKind=u={}));var P;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(P||(e.PanelKind=P={})),function(j){function W(B){switch(B.toLowerCase()){case"shared":return j.Shared;case"dedicated":return j.Dedicated;case"new":return j.New;default:return j.Shared}}j.fromString=W}(P||(e.PanelKind=P={}));var w;(function(j){j.defaults={echo:!0,reveal:S.Always,revealProblems:u.Never,focus:!1,panel:P.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var a;(function(j){j[j.Shell=1]="Shell",j[j.Process=2]="Process",j[j.CustomExecution=3]="CustomExecution"})(a||(e.RuntimeType=a={})),function(j){function W(ee){switch(ee.toLowerCase()){case"shell":return j.Shell;case"process":return j.Process;case"customExecution":return j.CustomExecution;default:return j.Process}}j.fromString=W;function B(ee){switch(ee){case j.Shell:return"shell";case j.Process:return"process";case j.CustomExecution:return"customExecution";default:return"process"}}j.toString=B}(a||(e.RuntimeType=a={}));var m;(function(j){function W(B){return h.$eg(B)?B:B.value}j.value=W})(m||(e.CommandString=m={}));var $;(function(j){j.Clean={_id:"clean",isDefault:!1},j.Build={_id:"build",isDefault:!1},j.Rebuild={_id:"rebuild",isDefault:!1},j.Test={_id:"test",isDefault:!1};function W(ee){return ee===j.Clean._id||ee===j.Build._id||ee===j.Rebuild._id||ee===j.Test._id}j.is=W;function B(ee){if(ee!==void 0)return h.$eg(ee)?W(ee)?{_id:ee,isDefault:!1}:void 0:ee}j.from=B})($||(e.TaskGroup=$={}));var f;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.Folder=3]="Folder"})(f||(e.TaskScope=f={}));var i;(function(j){j.Workspace="workspace",j.Extension="extension",j.InMemory="inMemory",j.WorkspaceFile="workspaceFile",j.User="user";function W(B){switch(B){case j.User:return p.ConfigurationTarget.USER;case j.WorkspaceFile:return p.ConfigurationTarget.WORKSPACE;default:return p.ConfigurationTarget.WORKSPACE_FOLDER}}j.toConfigurationTarget=W})(i||(e.TaskSourceKind=i={}));var s;(function(j){j.parallel="parallel",j.sequence="sequence"})(s||(e.DependsOrder=s={}));var t;(function(j){j[j.default=1]="default",j[j.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var o;(function(j){j.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class n{constructor(W,B,ee,H,q,Q){this._label="",this._id=W,B&&(this._label=B),ee&&(this.type=ee),this.runOptions=H,this.configurationProperties=q,this._source=Q}getDefinition(W){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const W={folder:this.d(),id:this._id};return JSON.stringify(W)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(W,B=!1){if(W===void 0)return!1;if(h.$eg(W))return W===this._label||W===this.configurationProperties.identifier||B&&W===this._id;const ee=this.getDefinition(!0);return ee!==void 0&&ee._key===W._key}getQualifiedLabel(){const W=this.getWorkspaceFolder();return W?`${this._label} (${W.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(W){this.c===void 0&&(this.c=[]),W&&(this.c=this.c.concat(W))}get taskLoadMessages(){return this.c}}e.$ZI=n;class d extends n{constructor(W,B,ee,H,q,Q,_,ce){super(W,ee,void 0,_,ce,B),this.command={},this._source=B,this.hasDefinedMatchers=Q,q&&(this.command=q)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(W=!1){if(W&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case a.Shell:B="shell";break;case a.Process:B="process";break;case a.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(W){return W instanceof d}getMapKey(){const W=this._source.config.workspaceFolder;return W?`${W.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$VI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const W=this.d();if(!W)return;let B=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(B+=this._source.kind);const ee={type:e.$YI,folder:W,id:B};return JSON.stringify(ee)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$dh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(W){return new d(W._id,W._source,W._label,W.type,W.command,W.hasDefinedMatchers,W.runOptions,W.configurationProperties)}}e.$1I=d;class l extends n{constructor(W,B,ee,H,q,Q,_){super(W,ee,H,Q,_,B),this._source=B,this.configures=q}static is(W){return W instanceof l}f(W){return W}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$dh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$VI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const W=this.d();if(!W)return;let B=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(B+=this._source.kind);const ee={type:e.$YI,folder:W,id:B};return JSON.stringify(ee)}}e.$2I=l;class g extends n{constructor(W,B,ee,H,q,Q,_,ce,ne){super(W,ee,H,ce,ne,B),this.defines=q,this.hasDefinedMatchers=_,this.command=Q,this.icon=ne.icon,this.hide=ne.hide}clone(){return new g(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(W){return W instanceof g}getMapKey(){const W=this._source.workspaceFolder;return W?`${this._source.scope.toString()}|${W.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===f.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const W={type:"contributed",scope:this._source.scope,id:this._id};return W.folder=this.d(),JSON.stringify(W)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(W){return new g(W._id,W._source,W._label,W.type,W.defines,W.command,W.hasDefinedMatchers,W.runOptions,W.configurationProperties)}}e.$3I=g;class E extends n{constructor(W,B,ee,H,q,Q){super(W,ee,H,q,Q,B),this._source=B}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(W){return W instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(W){return new E(W._id,W._source,W._label,W.type,W.runOptions,W.configurationProperties)}}e.$4I=E;var D;(function(j){j[j.Process=1]="Process",j[j.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(j){j._default=j.Terminal}(D||(e.ExecutionEngine=D={}));var y;(function(j){j[j.V0_1_0=1]="V0_1_0",j[j.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class k{constructor(W){this.c=new Map;for(let B=0;B<W.length;B++)this.c.set(W[B].uri.toString(),B)}compare(W,B){const ee=W.getWorkspaceFolder(),H=B.getWorkspaceFolder();if(ee&&H){let q=this.c.get(ee.uri.toString());q=q===void 0?0:q+1;let Q=this.c.get(H.uri.toString());return Q=Q===void 0?0:Q+1,q===Q?W._label.localeCompare(B._label):q-Q}else return!ee&&H?-1:ee&&!H?1:0}}e.$5I=k;var A;(function(j){j.DependsOnStarted="dependsOnStarted",j.AcquiredInput="acquiredInput",j.Start="start",j.ProcessStarted="processStarted",j.Active="active",j.Inactive="inactive",j.Changed="changed",j.Terminated="terminated",j.ProcessEnded="processEnded",j.End="end"})(A||(e.TaskEventKind=A={}));var b;(function(j){j.SingleRun="singleRun",j.Background="background"})(b||(e.TaskRunType=b={}));var v;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.FolderOpen=2]="FolderOpen",j[j.ConfigurationChange=3]="ConfigurationChange",j[j.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var F;(function(j){function W(ce){return{taskId:ce._id,taskName:ce.configurationProperties.name,runType:ce.configurationProperties.isBackground?b.Background:b.SingleRun,group:ce.configurationProperties.group,__task:ce}}function B(ce,ne,ye){return{...W(ce),kind:A.Start,terminalId:ne,resolvedVariables:ye}}j.start=B;function ee(ce,ne,ye){return{...W(ce),kind:A.ProcessStarted,terminalId:ne,processId:ye}}j.processStarted=ee;function H(ce,ne,ye){return{...W(ce),kind:A.ProcessEnded,terminalId:ne,exitCode:ye}}j.processEnded=H;function q(ce,ne,ye){return{...W(ce),kind:A.Terminated,exitReason:ye,terminalId:ne}}j.terminated=q;function Q(ce,ne,ye){return{...W(ne),kind:ce,terminalId:ye}}j.general=Q;function _(){return{kind:A.Changed}}j.changed=_})(F||(e.TaskEvent=F={}));var N;(function(j){function W(ee){const H=Object.keys(ee).sort();let q="";for(const Q of H){let _=ee[Q];_ instanceof Object?_=W(_):typeof _=="string"&&(_=_.replace(/,/g,",,")),q+=Q+","+_+","}return q}function B(ee){const q={_key:W(ee),type:ee.taskType};return Object.assign(q,ee),q}j.create=B})(N||(e.KeyedTaskIdentifier=N={}));var L;(function(j){j.AutoDetect="task.autoDetect",j.SaveBeforeRun="task.saveBeforeRun",j.ShowDecorations="task.showDecorations",j.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",j.SlowProviderWarning="task.slowProviderWarning",j.QuickOpenHistory="task.quickOpen.history",j.QuickOpenDetail="task.quickOpen.detail",j.QuickOpenSkip="task.quickOpen.skip",j.QuickOpenShowAll="task.quickOpen.showAll",j.AllowAutomaticTasks="task.allowAutomaticTasks",j.Reconnection="task.reconnection",j.VerboseLogging="task.verboseLogging"})(L||(e.TaskSettingId=L={}));var M;(function(j){j.Tasks="tasks",j.SuppressTaskName="tasks.suppressTaskName",j.Windows="tasks.windows",j.Osx="tasks.osx",j.Linux="tasks.linux",j.ShowOutput="tasks.showOutput",j.IsShellCommand="tasks.isShellCommand",j.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var z;(function(j){function W(B,ee){const H=T.$UI.get(B.type);if(H===void 0){const ce=R.$eo(B);return delete ce._key,N.create(ce)}const q=Object.create(null);q.type=H.taskType;const Q=new Set;H.required.forEach(ce=>Q.add(ce));const _=H.properties;for(const ce of Object.keys(_)){const ne=B[ce];if(ne!=null)q[ce]=ne;else if(Q.has(ce)){const ye=_[ce];if(ye.default!==void 0)q[ce]=R.$eo(ye.default);else switch(ye.type){case"boolean":q[ce]=!1;break;case"number":case"integer":q[ce]=0;break;case"string":q[ce]="";break;default:ee.error(r.localize(3914,null,JSON.stringify(B,void 0,0),ce));return}}}return N.create(q)}j.createTaskIdentifier=W})(z||(e.TaskDefinition=z={}))}),define(ke[274],Ie([1,0,13]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=e.$Qdc=void 0;class h{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((O,T)=>{this.b=O,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(O){this.f||this.h||(this.f=!0,this.g=O,this.a&&this.b(O))}resolveErr(O){this.f||this.h||(this.h=!0,this.i=O,this.a?this.d(O):(0,r.$Y)(O))}then(O,T){return this.j().then(O,T)}catch(O){return this.j().then(void 0,O)}finally(O){return this.j().finally(O)}}e.$Qdc=h;class C extends h{constructor(){super(),this.h=!0,this.i=new r.$4}}e.$Rdc=C}),define(ke[53],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xw=e.$Uw=void 0,e.$Vw=C,e.$Ww=R;class r{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++r.count}}e.$Uw=r;const h=[];function C(T){const p=new r(T);return h[p.nid]=p,p}function R(T){return h[T].sid}class O{constructor(p){this.value=p}}e.$Xw=O}),define(ke[6],Ie([1,0,53]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=e.$KN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$JN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var h;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(h||(e.TextEditorRevealType=h={}));var C;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(C||(e.TabInputKind=C={}));var R;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var O;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(O||(e.WebviewEditorCapabilities=O={}));var T;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var p;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var c;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(c||(e.NotebookEditorRevealType=c={}));var I;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output",a[a.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class S{static{this.a=0}static mixin(m){return m._id=S.a++,m}}e.$JN=S;var u;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var P;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(P||(e.ISuggestResultDtoField=P={}));var w;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(w||(e.ExtHostTestingResource=w={})),e.$KN={MainThreadAuthentication:(0,r.$Vw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.$Vw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,r.$Vw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,r.$Vw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,r.$Vw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,r.$Vw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,r.$Vw)("MainThreadChatSkills"),MainThreadClipboard:(0,r.$Vw)("MainThreadClipboard"),MainThreadCommands:(0,r.$Vw)("MainThreadCommands"),MainThreadComments:(0,r.$Vw)("MainThreadComments"),MainThreadConfiguration:(0,r.$Vw)("MainThreadConfiguration"),MainThreadConsole:(0,r.$Vw)("MainThreadConsole"),MainThreadDebugService:(0,r.$Vw)("MainThreadDebugService"),MainThreadDecorations:(0,r.$Vw)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.$Vw)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.$Vw)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.$Vw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.$Vw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.$Vw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.$Vw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.$Vw)("MainThreadEditorTabs"),MainThreadErrors:(0,r.$Vw)("MainThreadErrors"),MainThreadTreeViews:(0,r.$Vw)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.$Vw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,r.$Vw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.$Vw)("MainThreadLanguages"),MainThreadLogger:(0,r.$Vw)("MainThreadLogger"),MainThreadMessageService:(0,r.$Vw)("MainThreadMessageService"),MainThreadOutputService:(0,r.$Vw)("MainThreadOutputService"),MainThreadProgress:(0,r.$Vw)("MainThreadProgress"),MainThreadQuickDiff:(0,r.$Vw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,r.$Vw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.$Vw)("MainThreadStatusBar"),MainThreadSecretState:(0,r.$Vw)("MainThreadSecretState"),MainThreadStorage:(0,r.$Vw)("MainThreadStorage"),MainThreadSpeech:(0,r.$Vw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,r.$Vw)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.$Vw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,r.$Vw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,r.$Vw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.$Vw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.$Vw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.$Vw)("MainThreadCustomEditors"),MainThreadUrls:(0,r.$Vw)("MainThreadUrls"),MainThreadUriOpeners:(0,r.$Vw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,r.$Vw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,r.$Vw)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.$Vw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,r.$Vw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,r.$Vw)("MainThreadExtensionService"),MainThreadSCM:(0,r.$Vw)("MainThreadSCM"),MainThreadSearch:(0,r.$Vw)("MainThreadSearch"),MainThreadShare:(0,r.$Vw)("MainThreadShare"),MainThreadTask:(0,r.$Vw)("MainThreadTask"),MainThreadWindow:(0,r.$Vw)("MainThreadWindow"),MainThreadLabelService:(0,r.$Vw)("MainThreadLabelService"),MainThreadNotebook:(0,r.$Vw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.$Vw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.$Vw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.$Vw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.$Vw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.$Vw)("MainThreadInteractive"),MainThreadTheming:(0,r.$Vw)("MainThreadTheming"),MainThreadTunnelService:(0,r.$Vw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,r.$Vw)("MainThreadManagedSockets"),MainThreadTimeline:(0,r.$Vw)("MainThreadTimeline"),MainThreadTesting:(0,r.$Vw)("MainThreadTesting"),MainThreadLocalization:(0,r.$Vw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,r.$Vw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,r.$Vw)("MainThreadAiEmbeddingVector")},e.$LN={ExtHostCommands:(0,r.$Vw)("ExtHostCommands"),ExtHostConfiguration:(0,r.$Vw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.$Vw)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.$Vw)("ExtHostDebugService"),ExtHostDecorations:(0,r.$Vw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.$Vw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.$Vw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.$Vw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.$Vw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.$Vw)("ExtHostEditors"),ExtHostTreeViews:(0,r.$Vw)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.$Vw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.$Vw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.$Vw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.$Vw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.$Vw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.$Vw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,r.$Vw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,r.$Vw)("ExtHostStatusBar"),ExtHostShare:(0,r.$Vw)("ExtHostShare"),ExtHostExtensionService:(0,r.$Vw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.$Vw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.$Vw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,r.$Vw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,r.$Vw)("ExtHostSCM"),ExtHostSearch:(0,r.$Vw)("ExtHostSearch"),ExtHostTask:(0,r.$Vw)("ExtHostTask"),ExtHostWorkspace:(0,r.$Vw)("ExtHostWorkspace"),ExtHostWindow:(0,r.$Vw)("ExtHostWindow"),ExtHostWebviews:(0,r.$Vw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.$Vw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.$Vw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.$Vw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.$Vw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.$Vw)("ExtHostEditorTabs"),ExtHostProgress:(0,r.$Vw)("ExtHostProgress"),ExtHostComments:(0,r.$Vw)("ExtHostComments"),ExtHostSecretState:(0,r.$Vw)("ExtHostSecretState"),ExtHostStorage:(0,r.$Vw)("ExtHostStorage"),ExtHostUrls:(0,r.$Vw)("ExtHostUrls"),ExtHostUriOpeners:(0,r.$Vw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,r.$Vw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,r.$Vw)("ExtHostOutputService"),ExtHostLabelService:(0,r.$Vw)("ExtHostLabelService"),ExtHostNotebook:(0,r.$Vw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.$Vw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.$Vw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.$Vw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.$Vw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,r.$Vw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,r.$Vw)("ExtHostInteractive"),ExtHostChatAgents2:(0,r.$Vw)("ExtHostChatAgents"),ExtHostChatVariables:(0,r.$Vw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,r.$Vw)("ExtHostChatSkills"),ExtHostChatProvider:(0,r.$Vw)("ExtHostChatProvider"),ExtHostSpeech:(0,r.$Vw)("ExtHostSpeech"),ExtHostEmbeddings:(0,r.$Vw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,r.$Vw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,r.$Vw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,r.$Vw)("ExtHostTheming"),ExtHostTunnelService:(0,r.$Vw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,r.$Vw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,r.$Vw)("ExtHostAuthentication"),ExtHostTimeline:(0,r.$Vw)("ExtHostTimeline"),ExtHostTesting:(0,r.$Vw)("ExtHostTesting"),ExtHostTelemetry:(0,r.$Vw)("ExtHostTelemetry"),ExtHostLocalization:(0,r.$Vw)("ExtHostLocalization")}}),define(ke[95],Ie([1,0,5,11,6,19]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$upc=e.$tpc=e.$spc=void 0,C=qe(C),e.$spc=(0,r.$Fi)("IExtHostApiDeprecationService");let O=class{constructor(p,c){this.c=c,this.a=new Set,this.b=p.getProxy(C.$KN.MainThreadTelemetry)}report(p,c,I){const S=this.d(p,c);this.a.has(S)||(this.a.add(S),c.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:c.identifier.value,apiId:p}))}d(p,c){return`${p}-${c.identifier.value}`}};e.$tpc=O,e.$tpc=O=Je([Ve(0,R.$kQ),Ve(1,h.$ak)],O),e.$upc=Object.freeze(new class{report(T,p,c){}})}),define(ke[275],Ie([1,0,6]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hpc=void 0;class h{constructor(R){const O=R.getProxy(r.$KN.MainThreadClipboard);this.value=Object.freeze({readText(){return O.$readText()},writeText(T){return O.$writeText(T)}})}}e.$Hpc=h}),define(ke[276],Ie([1,0,24,6,29,19]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Drc=void 0;let O=class{constructor(I,S){this.a=I.getProxy(h.$KN.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,S){const u=this,P=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){u.e(I,S,P,arguments)}})}e(I,S,u,P){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:p(P,this.b)}),this.c&&this.f(I,u,P)}};e.$Drc=O,e.$Drc=O=Je([Ve(0,R.$kQ),Ve(1,C.$AQ)],O);const T=1e5;function p(c,I){const S=[];if(c.length)for(let u=0;u<c.length;u++){let P=c[u];if(typeof P>"u")P="undefined";else if(P instanceof Error){const w=P;w.stack?P=w.stack:P=w.toString()}S.push(P)}if(I){const u=new Error().stack;u&&S.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,r.$jo)(S);return u.length>T?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(ke[277],Ie([1,0,2,6,25]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jqc=void 0;class R{constructor(T){this.a=T.getProxy(h.$KN.MainThreadDialogs)}showOpenDialog(T,p){return p?.allowUIResources&&(0,C.$gH)(T,"showLocal"),this.a.$showOpenDialog(p).then(c=>c?c.map(I=>r.URI.revive(I)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then(p=>p?r.URI.revive(p):void 0)}}e.$Jqc=R}),define(ke[278],Ie([1,0,20,4,3,6]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mqc=void 0;class O{constructor(p){this.b=new Map,this.c=new h.$le,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=p.getProxy(R.$KN.MainThreadEmbeddings)}registerEmbeddingsProvider(p,c,I){if(this.d.has(c))throw new Error("An embeddings provider for this model is already registered");const S=this.e++;return this.a.$registerEmbeddingProvider(S,c),this.b.set(S,{id:c,provider:I}),(0,C.$Sc)(()=>{this.d.delete(c),this.a.$unregisterEmbeddingProvider(S),this.b.delete(S)})}async computeEmbeddings(p,c,I){I??=r.CancellationToken.None;let S=!1;typeof c=="string"&&(c=[c],S=!0);const u=await this.a.$computeEmbeddings(p,c,I);if(u.length!==c.length)throw new Error;if(S){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings(p,c,I){const S=this.b.get(p);if(!S)return[];const u=await S.provider.provideEmbeddings(c,I);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(p){this.d=new Set(p),this.c.fire()}}e.$Mqc=O}),define(ke[279],Ie([1,0,3,6]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4qc=void 0;class C{constructor(O){this.b=0,this.a=O.getProxy(h.$KN.MainThreadLabelService)}$registerResourceLabelFormatter(O){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,O),(0,r.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.$4qc=C}),define(ke[122],Ie([1,0,10,12,2,5,11,6,29,19]),function($e,e,r,h,C,R,O,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nqc=e.$mqc=void 0;let I=class{constructor(u,P,w){this.f=w,this.d=new Map,this.a=P.getProxy(T.$KN.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===r.$h}getMessage(u,P){const{message:w,args:a,comment:m}=P;if(this.c)return(0,h.$ef)(w,a??{});let $=w;m&&m.length>0&&($+=`/${Array.isArray(m)?m.join(""):m}`);const f=this.d.get(u)?.contents[$];return f||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${$}`),(0,h.$ef)(f??w,a??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let P;const w=await this.g(u);if(!w){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(w),m=JSON.parse(a);P=u.isBuiltin?m.contents?.bundle:m}catch(a){this.f.error(`Failed to load translations for ${u.identifier.value} from ${w}: ${a.message}`);return}P&&this.d.set(u.identifier.value,{contents:P,uri:w})}async g(u){if(u.isBuiltin){const P=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return C.URI.revive(P)}return u.l10n?C.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$mqc=I,e.$mqc=I=Je([Ve(0,p.$AQ),Ve(1,c.$kQ),Ve(2,O.$ak)],I),e.$nqc=(0,R.$Fi)("IExtHostLocalizationService")}),define(ke[161],Ie([1,0,11,6,29,19,2,44]),function($e,e,r,h,C,R,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Crc=void 0;let p=class extends r.$lk{constructor(S,u){super(u.logLevel,u.logsLocation,u.loggers.map(P=>(0,T.$ci)(P))),this.r=S.getProxy(h.$KN.MainThreadLogger)}$setLogLevel(S,u){u?this.setLogLevel(O.URI.revive(u),S):this.setLogLevel(S)}setVisibility(S,u){super.setVisibility(S,u),this.r.$setVisibility(S,u)}s(S,u,P){return new c(this.r,S,u,P)}};e.$Crc=p,e.$Crc=p=Je([Ve(0,R.$kQ),Ve(1,C.$AQ)],p);class c extends r.$gk{constructor(S,u,P,w){super(w?.logLevel==="always"),this.r=S,this.s=u,this.m=!1,this.n=[],this.setLevel(P),this.r.$createLogger(u,w).then(()=>{this.u(this.n),this.m=!0})}g(S,u){const P=[[S,u]];this.m?this.u(P):this.n.push(...P)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(ke[123],Ie([1,0,6,5,3,19,21]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pqc=e.$oqc=void 0,e.$oqc=(0,h.$Fi)("IExtHostManagedSockets");let T=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(r.$KN.MainThreadManagedSockets)}setFactory(S,u){for(const P of this.d.values())P.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(S,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const u=++this.b,P=await this.c.makeConnection(),w=new C.$Tc;return this.d.set(u,new c(u,P,w)),w.add((0,C.$Sc)(()=>this.d.delete(u))),w.add(P.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),w.dispose()})),w.add(P.onDidClose(a=>{this.a.$onDidManagedSocketClose(u,a?.stack??a?.message),w.dispose()})),w.add(P.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData(u,O.$Ne.wrap(a)))),u}$remoteSocketWrite(S,u){this.d.get(S)?.actual.send(u.buffer)}$remoteSocketEnd(S){const u=this.d.get(S);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$pqc=T,e.$pqc=T=Je([Ve(0,R.$kQ)],T);class p{constructor(S,u){this.socketFactoryId=S,this.makeConnection=u}}class c extends C.$Uc{constructor(S,u,P){super(),this.socketId=S,this.actual=u,this.B(P)}}}),define(ke[280],Ie([1,0,6,11,25]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7qc=void 0;function R(T){return T&&T.title}let O=class{constructor(p,c){this.b=c,this.a=p.getProxy(r.$KN.MainThreadMessageService)}showMessage(p,c,I,S,u){const P={source:{identifier:p.identifier,label:p.displayName||p.name}};let w;typeof S=="string"||R(S)?w=[S,...u]:(P.modal=S?.modal,P.useCustom=S?.useCustom,P.detail=S?.detail,w=u),P.useCustom&&(0,C.$gH)(p,"resolvers");const a=[];let m=!1;for(let $=0;$<w.length;$++){const f=w[$];if(typeof f=="string")a.push({title:f,handle:$,isCloseAffordance:!1});else if(typeof f=="object"){const{title:i,isCloseAffordance:s}=f;a.push({title:i,isCloseAffordance:!!s,handle:$}),s&&(m?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,f):m=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,f)}return this.a.$showMessage(c,I,P,a).then($=>{if(typeof $=="number")return w[$]})}};e.$7qc=O,e.$7qc=O=Je([Ve(1,h.$ak)],O)}),define(ke[281],Ie([1,0,3,17,2,25,6]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$drc=void 0;class T{constructor(c){this.b=new Map,this.a=c.getProxy(O.$KN.MainThreadProfileContentHandlers)}registerProfileContentHandler(c,I,S){if((0,R.$gH)(c,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,S),this.a.$registerProfileContentHandler(I,S.name,S.description,c.identifier.value),(0,r.$Sc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(c,I,S,u){const P=this.b.get(c);if(!P)throw new Error(`Unknown handler with id: ${c}`);return P.saveProfile(I,S,u)}async $readProfile(c,I,S){const u=this.b.get(c);if(!u)throw new Error(`Unknown handler with id: ${c}`);return u.readProfile((0,h.$eg)(I)?I:C.URI.revive(I),S)}}e.$drc=T}),define(ke[124],Ie([1,0,6,4,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kqc=e.$jqc=void 0;class R{constructor(T){this.b=new h.$le,this.onDidChangePassword=this.b.event,this.a=T.getProxy(r.$KN.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,p){return this.a.$getPassword(T,p)}store(T,p,c){return this.a.$setPassword(T,p,c)}delete(T,p){return this.a.$deletePassword(T,p)}}e.$jqc=R,e.$kqc=(0,C.$Fi)("IExtHostSecretState")}),define(ke[282],Ie([1,0,20,3,6]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$krc=void 0;class R{static{this.a=1}constructor(T){this.c=new Map,this.d=new Map,this.f=new Map,this.b=T.getProxy(C.$KN.MainThreadSpeech)}async $createSpeechToTextSession(T,p,c){const I=this.c.get(T);if(!I)return;const S=new h.$Tc,u=new r.$we;this.d.set(p,u);const P=await I.provideSpeechToTextSession(u.token,c?{language:c}:void 0);P&&(S.add(P.onDidChange(w=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,w)})),S.add(u.token.onCancellationRequested(()=>S.dispose())))}async $cancelSpeechToTextSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}async $createTextToSpeechSession(T,p,c){const I=this.c.get(T);if(!I)return;const S=new h.$Tc,u=new r.$we;this.d.set(p,u);const P=await I.provideTextToSpeechSession(u.token,c?{language:c}:void 0);P&&(this.f.set(p,P),S.add(P.onDidChange(w=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(p,w)})),S.add(u.token.onCancellationRequested(()=>S.dispose())))}async $synthesizeSpeech(T,p){this.f.get(T)?.synthesize(p)}async $cancelTextToSpeechSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T),this.f.delete(T)}async $createKeywordRecognitionSession(T,p){const c=this.c.get(T);if(!c)return;const I=new h.$Tc,S=new r.$we;this.d.set(p,S);const u=await c.provideKeywordRecognitionSession(S.token);u&&(I.add(u.onDidChange(P=>{S.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,P)})),I.add(S.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}registerProvider(T,p,c){const I=R.a++;return this.c.set(I,c),this.b.$registerProvider(I,p,{extension:T,displayName:T.value}),(0,h.$Sc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$krc=R}),define(ke[125],Ie([1,0,6,4,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aqc=e.$_pc=void 0;class R{constructor(T,p){this.c=p,this.b=new h.$le,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(r.$KN.MainThreadStorage)}registerExtensionStorageKeysToSync(T,p){this.a.$registerExtensionStorageKeysToSync(T,p)}async initializeExtensionStorage(T,p,c){const I=await this.a.$initializeExtensionStorage(T,p);let S;return I&&(S=this.d(T,p,I)),S||c}setValue(T,p,c){return this.a.$setValue(T,p,c)}$acceptValue(T,p,c){const I=this.d(T,p,c);I&&this.b.fire({shared:T,key:p,value:I})}d(T,p,c){try{return JSON.parse(c)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${T}): ${I}`)}}}e.$_pc=R,e.$aqc=(0,C.$Fi)("IExtHostStorage")}),define(ke[283],Ie([1,0,3,14,2,6]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wrc=void 0;class O{static{this.a=new Set([h.Schemas.http,h.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(R.$KN.MainThreadUriOpeners)}registerExternalUriOpener(p,c,I,S){if(this.c.has(c))throw new Error(`Opener with id '${c}' already registered`);const u=S.schemes.find(P=>!O.a.has(P));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(c,I),this.b.$registerUriOpener(c,S.schemes,p,S.label),(0,r.$Sc)(()=>{this.c.delete(c),this.b.$unregisterUriOpener(c)})}async $canOpenUri(p,c,I){const S=this.c.get(p);if(!S)throw new Error(`Unknown opener with id: ${p}`);const u=C.URI.revive(c);return S.canOpenExternalUri(u,I)}async $openUri(p,c,I){const S=this.c.get(p);if(!S)throw new Error(`Unknown opener id: '${p}'`);return S.openExternalUri(C.URI.revive(c.resolvedUri),{sourceUri:C.URI.revive(c.sourceUri)},I)}}e.$wrc=O}),define(ke[284],Ie([1,0,6,2,3,13,23]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xrc=void 0;class T{static{this.a=0}constructor(c){this.c=new O.$sn,this.d=new Map,this.b=c.getProxy(r.$KN.MainThreadUrls)}registerUriHandler(c,I){const S=c.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const u=T.a++;return this.c.add(S),this.d.set(u,I),this.b.$registerUriHandler(u,S,c.displayName||c.name),(0,C.$Sc)(()=>{this.c.delete(S),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(c,I){const S=this.d.get(c);if(!S)return Promise.resolve(void 0);try{S.handleUri(h.URI.revive(I))}catch(u){(0,R.$Y)(u)}return Promise.resolve(void 0)}async createAppUri(c){return h.URI.revive(await this.b.$createAppUri(c))}}e.$xrc=T}),define(ke[285],Ie([1,0,21,6]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wtb=R,e.$Xtb=T,h=qe(h);class C{constructor(){this.buffers=[]}add(c){let I=this.buffers.indexOf(c);return I<0&&(I=this.buffers.length,this.buffers.push(c)),I}}function R(p,c){if(c.serializeBuffersForPostMessage){const I=new C,u=JSON.stringify(p,(w,a)=>{if(a instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(a)};if(ArrayBuffer.isView(a)){const m=O(a);if(m)return{$$vscode_array_buffer_reference$$:!0,index:I.add(a.buffer),view:{type:m,byteLength:a.byteLength,byteOffset:a.byteOffset}}}return a}),P=I.buffers.map(w=>{const a=new Uint8Array(w);return r.$Ne.wrap(a)});return{message:u,buffers:P}}else return{message:JSON.stringify(p),buffers:[]}}function O(p){switch(p.constructor.name){case"Int8Array":return h.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return h.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return h.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return h.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return h.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return h.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return h.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return h.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return h.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return h.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return h.WebviewMessageArrayBufferViewType.BigUint64Array}}function T(p,c){const I=c.map(P=>{const w=new ArrayBuffer(P.byteLength);return new Uint8Array(w).set(P.buffer),w}),S=c.length?(P,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const a=w,{index:m}=a,$=I[m];if(a.view)switch(a.view.type){case h.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array($,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array($,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray($,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array($,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array($,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array($,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array($,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array($,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array($,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array($,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array($,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return $}return w}:void 0;return{message:JSON.parse(p,S),arrayBuffers:I}}}),define(ke[96],Ie([1,0,4,3,14,24,2,235,285,121,6]),function($e,e,r,h,C,R,O,T,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ypc=e.$Wpc=void 0,e.$Xpc=u,e.$Zpc=a,e.$1pc=m,R=qe(R),I=qe(I);class S{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(s,t,o,n,d,l,g){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new r.$le,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new r.$le,this._onDidDispose=this.#h.event,this.#e=s,this.#t=t,this.#o=o,this.#n=n,this.#s=d,this.#r=l,this.#u=u(l),this.#d=P(l),this.#i=g}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return this.#l=!0,(0,c.$HDb)(s,this.#n)}get cspSource(){const s=this.#r.extensionLocation;if(s.scheme===C.Schemas.https||s.scheme===C.Schemas.http){let t=s.toString();return t.endsWith("/")||(t+="/"),t+" "+c.$GDb}return c.$GDb}get html(){return this.a(),this.#a}set html(s){this.a(),this.#a!==s&&(this.#a=s,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(s)))}get options(){return this.a(),this.#o}set options(s){this.a(),R.$io(this.#o,s)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,s)),this.#o=s}async postMessage(s){if(this.#c)return!1;const t=(0,p.$Wtb)(s,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(s){if(!this.#d)return s;const t=this.#r.extensionLocation?.scheme===C.Schemas.vscodeRemote,o=this.#r.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,d,l,g,E,D)=>{const y=O.URI.from({scheme:g||"file",path:decodeURIComponent(E)}),k=(0,c.$HDb)(y,{isRemote:t,authority:o}).toString();return`${d}${k}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,d,l,g,E,D)=>{const y=O.URI.from({scheme:g||"file",path:decodeURIComponent(E)}),k=(0,c.$HDb)(y,{isRemote:t,authority:o}).toString();return`${d}${k}${D}`})}}e.$Wpc=S;function u(i){try{const s=(0,T.$2p)((0,T.$1p)(i.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}function P(i){try{const s=(0,T.$2p)((0,T.$1p)(i.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class w extends h.$Uc{constructor(s,t,o,n,d){super(),this.c=t,this.f=o,this.g=n,this.h=d,this.b=new Map,this.a=s.getProxy(I.$KN.MainThreadWebviews)}dispose(){super.dispose();for(const s of this.b.values())s.dispose();this.b.clear()}$onMessage(s,t,o){const n=this.j(s);if(n){const{message:d}=(0,p.$Xtb)(t,o.value);n._onMessageEmitter.fire(d)}}$onMissingCsp(s,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,t,o){const n=new S(s,this.a,$(t),this.c,this.f,o,this.h);this.b.set(s,n);const d=n._onDidDispose(()=>{d.dispose(),this.deleteWebview(s)});return n}deleteWebview(s){this.b.delete(s)}j(s){return this.b.get(s)}}e.$Ypc=w;function a(i){return{id:i.identifier,location:i.extensionLocation}}function m(i,s,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||f(i,s)}}function $(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(s=>O.URI.from(s))}}function f(i,s){return[...(s?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(ke[162],Ie([1,0,4,14,12,2,5,19,6]),function($e,e,r,h,C,R,O,T,p){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Arc=e.$zrc=void 0;let I=class{static{c=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new r.$le,this.onDidChangeWindowState=this.c.event,this.d=c.a,this.b=u.getProxy(p.$KN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:P,isActive:w})=>{this.onDidChangeWindowProperty("focused",P),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,P){P!==this.d[u]&&(this.d={...this.d,[u]:P},this.c.fire(this.d))}openUri(u,P){let w;if(typeof u=="string"){w=u;try{u=R.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,C.$cf)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===h.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,w,P)}async asExternalUri(u,P){if((0,C.$cf)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this.b.$asExternalUri(u,P);return R.URI.from(w)}};e.$zrc=I,e.$zrc=I=c=Je([Ve(0,T.$kQ)],I),e.$Arc=(0,O.$Fi)("IExtHostWindow")}),define(ke[286],Ie([1,0,276,29,19,93]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$csc=void 0;const O=1024*1024;let T=class extends r.$Drc{constructor(c,I){super(c,I),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(c,I,S){const u=c==="error"||c==="warn"?process.stderr:process.stdout;this.g=!0,u.write(`
${R.NativeLogMarkers.Start}
`),I.apply(console,S),u.write(`
${R.NativeLogMarkers.End}
`),this.g=!1}j(c,I){const S=process[c],u=S.write;let P="";Object.defineProperty(S,"write",{set:()=>{},get:()=>(w,a,m)=>{if(!this.g){P+=w.toString(a);const $=P.length>O?P.length:P.lastIndexOf(`
`);$!==-1&&(console[I](P.slice(0,$)),P=P.slice($+1))}u.call(S,w,a,m)}})}};e.$csc=T,e.$csc=T=Je([Ve(0,C.$kQ),Ve(1,h.$AQ)],T)}),define(ke[287],Ie([1,0,161,14,229,32]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$osc=void 0;class O extends r.$Crc{s(p,c,I){return p.scheme===h.Schemas.file?new C.$zR(I?.name||(0,R.$2g)(),p.fsPath,!I?.donotRotate,!!I?.donotUseFormatters,c):super.s(p,c,I)}registerLogger(p){super.registerLogger(p),this.r.$registerLogger(p)}deregisterLogger(p){super.deregisterLogger(p),this.r.$deregisterLogger(p)}}e.$osc=O}),define(ke[288],Ie([1,0,7,21,20,26,13,4,3,40,138,274,53]),function($e,e,r,h,C,R,O,T,p,c,I,S,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=e.ResponsiveState=e.RequestInitiator=void 0,e.$Sdc=f,e.$Tdc=i,O=qe(O);function w(F,N){try{return JSON.stringify(F,N)}catch{return"null"}}const a="$$ref$$",m={[a]:-1};class ${constructor(N,L){this.jsonString=N,this.referencedBuffers=L}}function f(F,N=null,L=!1){const M=[];return{jsonString:(L?w:JSON.stringify)(F,(j,W)=>{if(typeof W>"u")return m;if(typeof W=="object"){if(W instanceof h.$Ne){const B=M.push(W)-1;return{[a]:B}}if(N)return N(j,W)}return W}),referencedBuffers:M}}function i(F,N,L){return JSON.parse(F,(M,z)=>{if(z){const j=z[a];if(typeof j=="number")return N[j];if(L&&z.$mid===c.MarshalledId.Uri)return L.transformIncoming(z)}return z})}function s(F,N){return JSON.stringify(F,N)}function t(F){return F?(N,L)=>L&&L.$mid===c.MarshalledId.Uri?F.transformOutgoing(L):L:null}var o;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var n;(function(F){F[F.Responsive=0]="Responsive",F[F.Unresponsive=1]="Unresponsive"})(n||(e.ResponsiveState=n={}));const d=()=>{},l=Symbol.for("rpcProtocol"),g=Symbol.for("rpcProxy");class E extends p.$Uc{static{P=l}static{this.a=3*1e3}constructor(N,L=null,M=null){super(),this[P]=!0,this.b=this.B(new T.$le),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=L,this.g=M,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,j=u.$Uw.count;z<j;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=n.Responsive,this.z=0,this.C=0,this.D=this.B(new r.$Rh(()=>this.H(),1e3)),this.B(this.c.onMessage(z=>this.L(z)))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const L=this.w[N];delete this.w[N],L.resolveErr(O.$5())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+E.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+E.a,this.z--,this.z===0&&this.D.cancel(),this.I(n.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(n.Unresponsive):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,I.$Pn)(N,this.g):N}getProxy(N){const{nid:L,sid:M}=N;return this.s[L]||(this.s[L]=this.J(L,M)),this.s[L]}J(N,L){const M={get:(z,j)=>(typeof j=="string"&&!z[j]&&j.charCodeAt(0)===R.CharCode.DollarSign&&(z[j]=(...W)=>this.U(N,j,W)),j===g?L:z[j])};return new Proxy(Object.create(null),M)}set(N,L){return this.m[N.nid]=L,L}assertRegistered(N){for(let L=0,M=N.length;L<M;L++){const z=N[L];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(N){if(this.j)return;const L=N.byteLength,M=y.read(N,0),z=M.readUInt8(),j=M.readUInt32();switch(z){case b.RequestJSONArgs:case b.RequestJSONArgsWithCancellation:{let{rpcId:W,method:B,args:ee}=A.deserializeRequestJSONArgs(M);this.g&&(ee=(0,I.$Pn)(ee,this.g)),this.M(L,j,W,B,ee,z===b.RequestJSONArgsWithCancellation);break}case b.RequestMixedArgs:case b.RequestMixedArgsWithCancellation:{let{rpcId:W,method:B,args:ee}=A.deserializeRequestMixedArgs(M);this.g&&(ee=(0,I.$Pn)(ee,this.g)),this.M(L,j,W,B,ee,z===b.RequestMixedArgsWithCancellation);break}case b.Acknowledged:{this.f?.logIncoming(L,j,o.LocalSide,"ack"),this.G(j);break}case b.Cancel:{this.N(L,j);break}case b.ReplyOKEmpty:{this.O(L,j,void 0);break}case b.ReplyOKJSON:{let W=A.deserializeReplyOKJSON(M);this.g&&(W=(0,I.$Pn)(W,this.g)),this.O(L,j,W);break}case b.ReplyOKJSONWithBuffers:{const W=A.deserializeReplyOKJSONWithBuffers(M,this.g);this.O(L,j,W);break}case b.ReplyOKVSBuffer:{const W=A.deserializeReplyOKVSBuffer(M);this.O(L,j,W);break}case b.ReplyErrError:{let W=A.deserializeReplyErrError(M);this.g&&(W=(0,I.$Pn)(W,this.g)),this.P(L,j,W);break}case b.ReplyErrEmpty:{this.P(L,j,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,L,M,z,j,W){this.f?.logIncoming(N,L,o.OtherSide,`receiveRequest ${(0,u.$Ww)(M)}.${z}(`,j);const B=String(L);let ee,H;if(W){const Q=new C.$we;j.push(Q.token),ee=this.Q(M,z,j),H=()=>Q.cancel()}else ee=this.Q(M,z,j),H=d;this.u[B]=H;const q=A.serializeAcknowledged(L);this.f?.logOutgoing(q.byteLength,L,o.OtherSide,"ack"),this.c.send(q),ee.then(Q=>{delete this.u[B];const _=A.serializeReplyOK(L,Q,this.h);this.f?.logOutgoing(_.byteLength,L,o.OtherSide,"reply:",Q),this.c.send(_)},Q=>{delete this.u[B];const _=A.serializeReplyErr(L,Q);this.f?.logOutgoing(_.byteLength,L,o.OtherSide,"replyErr:",Q),this.c.send(_)})}N(N,L){this.f?.logIncoming(N,L,o.OtherSide,"receiveCancel");const M=String(L);this.u[M]?.()}O(N,L,M){this.f?.logIncoming(N,L,o.LocalSide,"receiveReply:",M);const z=String(L);if(!this.w.hasOwnProperty(z))return;const j=this.w[z];delete this.w[z],j.resolveOk(M)}P(N,L,M){this.f?.logIncoming(N,L,o.LocalSide,"receiveReplyErr:",M);const z=String(L);if(!this.w.hasOwnProperty(z))return;const j=this.w[z];delete this.w[z];let W;M&&(M.$isError?(W=new Error,W.name=M.name,W.message=M.message,W.stack=M.stack):W=M),j.resolveErr(W)}Q(N,L,M){try{return Promise.resolve(this.S(N,L,M))}catch(z){return Promise.reject(z)}}S(N,L,M){const z=this.m[N];if(!z)throw new Error("Unknown actor "+(0,u.$Ww)(N));const j=z[L];if(typeof j!="function")throw new Error("Unknown method "+L+" on actor "+(0,u.$Ww)(N));return j.apply(z,M)}U(N,L,M){if(this.j)return new S.$Rdc;let z=null;if(M.length>0&&C.CancellationToken.isCancellationToken(M[M.length-1])&&(z=M.pop()),z&&z.isCancellationRequested)return Promise.reject(O.$5());const j=A.serializeRequestArguments(M,this.h),W=++this.t,B=String(W),ee=new S.$Qdc,H=new p.$Tc;z&&H.add(z.onCancellationRequested(()=>{const Q=A.serializeCancel(W);this.f?.logOutgoing(Q.byteLength,W,o.LocalSide,"cancel"),this.c.send(A.serializeCancel(W))})),this.w[B]=new D(ee,H),this.F(W);const q=A.serializeRequest(W,N,L,j,!!z);return this.f?.logOutgoing(q.byteLength,W,o.LocalSide,`request: ${(0,u.$Ww)(N)}.${L}(`,M),this.c.send(q),ee}}e.$Udc=E;class D{constructor(N,L){this.a=N,this.b=L}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class y{static alloc(N,L,M){const z=new y(h.$Ne.alloc(M+1+4),0);return z.writeUInt8(N),z.writeUInt32(L),z}static read(N,L){return new y(N,L)}get buffer(){return this.a}constructor(N,L){this.a=N,this.b=L}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const M=this.a.slice(this.b,this.b+N).toString();return this.b+=N,M}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const M=this.a.slice(this.b,this.b+N).toString();return this.b+=N,M}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const L=this.a.slice(this.b,this.b+N);return this.b+=N,L}static sizeMixedArray(N){let L=0;L+=1;for(let M=0,z=N.length;M<z;M++){const j=N[M];switch(L+=1,j.type){case v.String:L+=this.sizeLongString(j.value);break;case v.VSBuffer:L+=this.sizeVSBuffer(j.value);break;case v.SerializedObjectWithBuffers:L+=this.sizeUInt32,L+=this.sizeLongString(j.value);for(let W=0;W<j.buffers.length;++W)L+=this.sizeVSBuffer(j.buffers[W]);break;case v.Undefined:break}}return L}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let L=0,M=N.length;L<M;L++){const z=N[L];switch(z.type){case v.String:this.writeUInt8(v.String),this.writeLongString(z.value);break;case v.VSBuffer:this.writeUInt8(v.VSBuffer),this.writeVSBuffer(z.value);break;case v.SerializedObjectWithBuffers:this.writeUInt8(v.SerializedObjectWithBuffers),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let j=0;j<z.buffers.length;++j)this.writeBuffer(z.buffers[j]);break;case v.Undefined:this.writeUInt8(v.Undefined);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const L=new Array(N);for(let M=0;M<N;M++)switch(this.readUInt8()){case v.String:L[M]=this.readLongString();break;case v.VSBuffer:L[M]=this.readVSBuffer();break;case v.SerializedObjectWithBuffers:{const j=this.readUInt32(),W=this.readLongString(),B=[];for(let ee=0;ee<j;++ee)B.push(this.readVSBuffer());L[M]=new u.$Xw(i(W,B,null));break}case v.Undefined:L[M]=void 0;break}return L}}var k;(function(F){F[F.Simple=0]="Simple",F[F.Mixed=1]="Mixed"})(k||(k={}));class A{static a(N){for(let L=0,M=N.length;L<M;L++)if(N[L]instanceof h.$Ne||N[L]instanceof u.$Xw||typeof N[L]>"u")return!0;return!1}static serializeRequestArguments(N,L){if(this.a(N)){const M=[];for(let z=0,j=N.length;z<j;z++){const W=N[z];if(W instanceof h.$Ne)M[z]={type:v.VSBuffer,value:W};else if(typeof W>"u")M[z]={type:v.Undefined};else if(W instanceof u.$Xw){const{jsonString:B,referencedBuffers:ee}=f(W.value,L);M[z]={type:v.SerializedObjectWithBuffers,value:h.$Ne.fromString(B),buffers:ee}}else M[z]={type:v.String,value:h.$Ne.fromString(s(W,L))}}return{type:k.Mixed,args:M}}return{type:k.Simple,args:s(N,L)}}static serializeRequest(N,L,M,z,j){switch(z.type){case k.Simple:return this.b(N,L,M,z.args,j);case k.Mixed:return this.c(N,L,M,z.args,j)}}static b(N,L,M,z,j){const W=h.$Ne.fromString(M),B=h.$Ne.fromString(z);let ee=0;ee+=y.sizeUInt8(),ee+=y.sizeShortString(W),ee+=y.sizeLongString(B);const H=y.alloc(j?b.RequestJSONArgsWithCancellation:b.RequestJSONArgs,N,ee);return H.writeUInt8(L),H.writeShortString(W),H.writeLongString(B),H.buffer}static deserializeRequestJSONArgs(N){const L=N.readUInt8(),M=N.readShortString(),z=N.readLongString();return{rpcId:L,method:M,args:JSON.parse(z)}}static c(N,L,M,z,j){const W=h.$Ne.fromString(M);let B=0;B+=y.sizeUInt8(),B+=y.sizeShortString(W),B+=y.sizeMixedArray(z);const ee=y.alloc(j?b.RequestMixedArgsWithCancellation:b.RequestMixedArgs,N,B);return ee.writeUInt8(L),ee.writeShortString(W),ee.writeMixedArray(z),ee.buffer}static deserializeRequestMixedArgs(N){const L=N.readUInt8(),M=N.readShortString(),z=N.readMixedArray(),j=new Array(z.length);for(let W=0,B=z.length;W<B;W++){const ee=z[W];typeof ee=="string"?j[W]=JSON.parse(ee):j[W]=ee}return{rpcId:L,method:M,args:j}}static serializeAcknowledged(N){return y.alloc(b.Acknowledged,N,0).buffer}static serializeCancel(N){return y.alloc(b.Cancel,N,0).buffer}static serializeReplyOK(N,L,M){if(typeof L>"u")return this.d(N);if(L instanceof h.$Ne)return this.e(N,L);if(L instanceof u.$Xw){const{jsonString:z,referencedBuffers:j}=f(L.value,M,!0);return this.g(N,z,j)}else return this.f(N,w(L,M))}static d(N){return y.alloc(b.ReplyOKEmpty,N,0).buffer}static e(N,L){let M=0;M+=y.sizeVSBuffer(L);const z=y.alloc(b.ReplyOKVSBuffer,N,M);return z.writeVSBuffer(L),z.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,L){const M=h.$Ne.fromString(L);let z=0;z+=y.sizeLongString(M);const j=y.alloc(b.ReplyOKJSON,N,z);return j.writeLongString(M),j.buffer}static g(N,L,M){const z=h.$Ne.fromString(L);let j=0;j+=y.sizeUInt32,j+=y.sizeLongString(z);for(const B of M)j+=y.sizeVSBuffer(B);const W=y.alloc(b.ReplyOKJSONWithBuffers,N,j);W.writeUInt32(M.length),W.writeLongString(z);for(const B of M)W.writeBuffer(B);return W.buffer}static deserializeReplyOKJSON(N){const L=N.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(N,L){const M=N.readUInt32(),z=N.readLongString(),j=[];for(let W=0;W<M;++W)j.push(N.readVSBuffer());return new u.$Xw(i(z,j,L))}static serializeReplyErr(N,L){const M=L?w(O.$1(L),null):void 0;if(typeof M!="string")return this.h(N);const z=h.$Ne.fromString(M);let j=0;j+=y.sizeLongString(z);const W=y.alloc(b.ReplyErrError,N,j);return W.writeLongString(z),W.buffer}static deserializeReplyErrError(N){const L=N.readLongString();return JSON.parse(L)}static h(N){return y.alloc(b.ReplyErrEmpty,N,0).buffer}}var b;(function(F){F[F.RequestJSONArgs=1]="RequestJSONArgs",F[F.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",F[F.RequestMixedArgs=3]="RequestMixedArgs",F[F.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",F[F.Acknowledged=5]="Acknowledged",F[F.Cancel=6]="Cancel",F[F.ReplyOKEmpty=7]="ReplyOKEmpty",F[F.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",F[F.ReplyOKJSON=9]="ReplyOKJSON",F[F.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",F[F.ReplyErrError=11]="ReplyErrError",F[F.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var v;(function(F){F[F.String=1]="String",F[F.VSBuffer=2]="VSBuffer",F[F.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",F[F.Undefined=4]="Undefined"})(v||(v={}))}),define(ke[289],Ie([1,0,21,28,14,88,5]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uL=e.$rL=void 0,e.$sL=I,e.$tL=S,e.$rL=(0,O.$Fi)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${T.join("")}]+`),c=7;function I(P){if(P.scheme!==C.Schemas.vscodeNotebookCell)return;const w=P.fragment.indexOf("s");if(w<0)return;const a=parseInt(P.fragment.substring(0,w).replace(p,""),c),m=(0,r.$7e)(P.fragment.substring(w+1)).toString();if(!isNaN(a))return{handle:a,notebook:P.with({scheme:m,fragment:null})}}function S(P,w){const a=w.toString(c),$=`${a.length<T.length?T[a.length-1]:"z"}${a}s${(0,r.$8e)(r.$Ne.fromString(P.scheme),!0,!0)}`;return P.with({scheme:C.Schemas.vscodeNotebookCell,fragment:$})}class u{constructor(){this.a=new h.$Ac}getNotebook(w){if(w.scheme===C.Schemas.vscodeNotebookCell){const a=I(w);if(a){const m=this.a.get(a.notebook);if(m)return m}}return this.a.get(w)}addNotebookDocument(w){this.a.set(w.uri,w)}removeNotebookDocument(w){this.a.delete(w.uri)}}e.$uL=u,(0,R.$Rs)(e.$rL,u,R.InstantiationType.Delayed)}),define(ke[126],Ie([1,0,21,38,39,103,14,16,10,35,289]),function($e,e,r,h,C,R,O,T,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=e.$LL=e.CellStatusbarAlignment=e.$KL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$HL=e.$GL=e.$EL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$DL=e.$CL=e.$BL=e.$AL=e.CellKind=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=void 0,e.$FL=n,e.$IL=g,e.$JL=E,e.$ML=k,e.$NL=b,h=qe(h),e.$vL="workbench.editor.notebook",e.$wL="workbench.editor.notebookTextDiffEditor",e.$xL="workbench.editor.interactive",e.$yL="workbench.editor.repl",e.$zL="replNotebook.input.execute";var S;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(S||(e.CellKind=S={})),e.$AL=["application/json","application/javascript","text/html","image/svg+xml",R.$$s.latex,R.$$s.markdown,"image/png","image/jpeg",R.$$s.text],e.$BL=[R.$$s.latex,R.$$s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$$s.text],e.$CL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$DL="_notAvailable";var u;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var P;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(P||(e.NotebookCellExecutionState=P={}));var w;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(w||(e.NotebookExecutionState=w={}));var a;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var m;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var $;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})($||(e.NotebookCellsChangeType=$={}));var f;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(f||(e.SelectionStateType=f={}));var i;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var s;(function(B){B.scheme=O.Schemas.vscodeNotebookCell;function ee(ne,ye){return(0,I.$tL)(ne,ye)}B.generate=ee;function H(ne){return(0,I.$sL)(ne)}B.parse=H;function q(ne,ye){return ne.with({scheme:O.Schemas.vscodeNotebookCellOutput,fragment:`op${ye??""},${ne.scheme!==O.Schemas.file?ne.scheme:""}`})}B.generateCellOutputUri=q;function Q(ne){if(ne.scheme!==O.Schemas.vscodeNotebookCellOutput)return;const ye=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!ye)return;const ge=ye[1]&&ye[1]!==""?ye[1]:void 0,Y=ye[2];return{outputId:ge,notebook:ne.with({scheme:Y||O.Schemas.file,fragment:null})}}B.parseCellOutputUri=Q;function _(ne,ye,ge){return B.generate(ne,ye).with({scheme:ge})}B.generateCellPropertyUri=_;function ce(ne,ye){if(ne.scheme===ye)return B.parse(ne.with({scheme:B.scheme}))}B.parseCellPropertyUri=ce})(s||(e.CellUri=s={}));const t=B=>p.$j?B.replace(/\//g,"\\"):B;class o{constructor(ee=[],H=e.$AL){this.e=H,this.d=[...new Set(ee)].map(q=>({pattern:q,matches:h.$Ak(t(q))}))}sort(ee){const H=new Map(C.Iterable.map(ee,Q=>[Q,t(Q)]));let q=[];for(const{matches:Q}of this.d)for(const[_,ce]of H)if(Q(ce)){q.push(_),H.delete(_);break}return H.size&&(q=q.concat([...H.keys()].sort((Q,_)=>this.e.indexOf(Q)-this.e.indexOf(_)))),q}prioritize(ee,H){const q=this.f(ee);if(q===-1){this.d.unshift({pattern:ee,matches:h.$Ak(t(ee))});return}const Q=new Set(H.map(ce=>this.f(ce,q)));Q.delete(-1);const _=Array.from(Q).sort();this.d.splice(q+1,0,..._.map(ce=>this.d[ce]));for(let ce=_.length-1;ce>=0;ce--)this.d.splice(_[ce],1)}toArray(){return this.d.map(ee=>ee.pattern)}f(ee,H=this.d.length){const q=t(ee);for(let Q=0;Q<H;Q++)if(this.d[Q].matches(q))return Q;return-1}}e.$EL=o;function n(B,ee,H,q=(Q,_)=>Q===_){const Q=[];function _(ye,ge,Y){if(ge===0&&Y.length===0)return;const U=Q[Q.length-1];U&&U.start+U.deleteCount===ye?(U.deleteCount+=ge,U.toInsert.push(...Y)):Q.push({start:ye,deleteCount:ge,toInsert:Y})}let ce=0,ne=0;for(;;){if(ce===B.length){_(ce,0,ee.slice(ne));break}if(ne===ee.length){_(ce,B.length-ce,[]);break}const ye=B[ce],ge=ee[ne];if(q(ye,ge)){ce+=1,ne+=1;continue}H(ge)?(_(ce,1,[]),ce+=1):(_(ce,0,[ge]),ne+=1)}return Q}e.$GL=new c.$Wj("notebookEditorCursorAtBoundary","none"),e.$HL=new c.$Wj("notebookEditorCursorAtLineBoundary","none");var d;(function(B){B.default="default",B.option="option"})(d||(e.NotebookEditorPriority=d={}));var l;(function(B){B.Cells="cells",B.Text="text",B.None="none"})(l||(e.NotebookFindScopeType=l={}));function g(B){const ee=B;return!!((typeof ee.include=="string"||h.$Bk(ee.include))&&(typeof ee.exclude=="string"||h.$Bk(ee.exclude)))}function E(B,ee,H){if(Array.isArray(B.viewType)&&B.viewType.indexOf(ee)>=0||B.viewType===ee)return!0;if(B.filenamePattern){const q=g(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,Q=g(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(h.$zk(q,(0,T.$nc)(H.fsPath).toLowerCase()))return!(Q&&h.$zk(Q,(0,T.$nc)(H.fsPath).toLowerCase()))}return!1}e.$KL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var D;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(D||(e.CellStatusbarAlignment=D={}));class y{static{this.d="notebook/"}static create(ee){return`${y.d}${ee}`}static parse(ee){if(ee.startsWith(y.d))return ee.substring(y.d.length)}}e.$LL=y;function k(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const A=new TextDecoder;function b(B){const ee=[];let H=!1;for(const ce of B)(ee.length===0||H)&&(ee.push(ce),H=!0);let q=N(ee);const Q=r.$Ne.concat(ee.map(ce=>r.$Ne.wrap(ce))),_=W(Q);return q=q||_.byteLength!==Q.byteLength,{data:_,didCompression:q}}e.$OL="\x1B[A";const v=e.$OL.split("").map(B=>B.charCodeAt(0)),F=10;function N(B){let ee=!1;return B.forEach((H,q)=>{if(q===0||H.length<e.$OL.length)return;const Q=B[q-1],_=H.subarray(0,e.$OL.length);if(_[0]===v[0]&&_[1]===v[1]&&_[2]===v[2]){const ce=Q.lastIndexOf(F);if(ce===-1)return;ee=!0,B[q-1]=Q.subarray(0,ce),B[q]=H.subarray(e.$OL.length)}}),ee}function L(B){let ee=B;do B=ee,ee=B.replace(/[^\n]\x08/gm,"");while(ee.length<B.length);return B}function M(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const ee=B.match(/^(.*)\r+/m)[1];let H=B.match(/\r+(.*)$/m)[1];H=H+ee.slice(H.length,ee.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,H)}return B}const z=8,j=13;function W(B){return!B.buffer.includes(z)&&!B.buffer.includes(j)?B:r.$Ne.fromString(M(L(A.decode(B.buffer))))}}),define(ke[9],Ie([1,0,18,13,85,28,103,12,17,2,32,23,27,71,126]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w){"use strict";var a,m,$,f,i,s,t,o,n,d,l,g,E,D,y,k,A;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$_P=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$$P=e.$0P=e.$9P=e.$8P=e.$7P=e.$6P=e.$5P=e.$4P=e.LanguageModelChatMessageRole=e.$3P=e.$2P=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.$1P=e.$ZP=e.$YP=e.$XP=e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.$PP=e.$OP=e.$NP=e.$MP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$LP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$KP=e.$JP=e.$IP=e.$HP=e.$GP=e.$FP=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$yP=e.$xP=e.$wP=e.$vP=e.$tP=e.$sP=e.$rP=e.$qP=e.$pP=e.TestRunProfileKind=e.TestResultState=e.$oP=e.$nP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$mP=e.NotebookVariablesRequestKind=e.$lP=e.$kP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$jP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.ColorThemeKind=e.$dP=e.$cP=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$bP=e.QuickInputButtonLocation=e.$aP=e.DebugConsoleMode=e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$7O=e.$6O=e.FileChangeType=e.$5O=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$4O=e.$3O=e.$2O=e.$1O=e.InlineCompletionTriggerKind=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$NO=e.ConfigurationTarget=e.$MO=e.$LO=e.$KO=e.$JO=e.DocumentPasteTriggerKind=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$CO=e.ViewBadge=e.ProgressLocation=e.$BO=e.$AO=e.TaskScope=e.ShellQuoting=e.$zO=e.$yO=e.$xO=e.TaskPanelKind=e.TaskRevealKind=e.$wO=e.TerminalLocation=e.$vO=e.$uO=e.$tO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$sO=e.$rO=e.$qO=e.$pO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$nO=e.$mO=e.$lO=e.$kO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$jO=e.$iO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.LanguageStatusSeverity=e.$cO=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.CodeActionTriggerKind=e.$9N=e.$8N=e.SymbolTag=e.SymbolKind=e.$7N=e.$6N=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.DiagnosticSeverity=e.DiagnosticTag=e.$ZN=e.$YN=e.FileEditType=e.$XN=e.$WN=e.$VN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$UN=e.$TN=e.$SN=e.$PN=e.$ON=e.$NN=e.$MN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$QN=j,e.$RN=W,e.$oO=mt,e.$OO=Ni,e.$uP=An;function b(Z){return Object.assign(Z,{apply:function(...me){if(me.length===0)return Reflect.construct(Z,[]);{const Oe=me.length===1?[]:me[1];return Reflect.construct(Z,Oe,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(Z,[]);{const[Oe,...Ye]=me;return Reflect.construct(Z,Ye,Oe.constructor)}}})}var v;(function(Z){Z[Z.Top=0]="Top",Z[Z.Bottom=1]="Bottom"})(v||(e.TerminalOutputAnchor=v={}));var F;(function(Z){Z[Z.TerminalCommand=0]="TerminalCommand",Z[Z.Opener=1]="Opener",Z[Z.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let N=a=class{static from(...K){let me=K;return new a(function(){if(me){for(const Oe of me)Oe&&typeof Oe.dispose=="function"&&Oe.dispose();me=void 0}})}#e;constructor(K){this.#e=K}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$MN=N,e.$MN=N=a=Je([b],N);let L=m=class{static Min(...K){if(K.length===0)throw new TypeError;let me=K[0];for(let Oe=1;Oe<K.length;Oe++){const Ye=K[Oe];Ye.isBefore(me)&&(me=Ye)}return me}static Max(...K){if(K.length===0)throw new TypeError;let me=K[0];for(let Oe=1;Oe<K.length;Oe++){const Ye=K[Oe];Ye.isAfter(me)&&(me=Ye)}return me}static isPosition(K){if(!K)return!1;if(K instanceof m)return!0;const{line:me,character:Oe}=K;return typeof me=="number"&&typeof Oe=="number"}static of(K){if(K instanceof m)return K;if(this.isPosition(K))return new m(K.line,K.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(K,me){if(K<0)throw(0,h.$6)("line must be non-negative");if(me<0)throw(0,h.$6)("character must be non-negative");this.c=K,this.e=me}isBefore(K){return this.c<K.c?!0:K.c<this.c?!1:this.e<K.e}isBeforeOrEqual(K){return this.c<K.c?!0:K.c<this.c?!1:this.e<=K.e}isAfter(K){return!this.isBeforeOrEqual(K)}isAfterOrEqual(K){return!this.isBefore(K)}isEqual(K){return this.c===K.c&&this.e===K.e}compareTo(K){return this.c<K.c?-1:this.c>K.line?1:this.e<K.e?-1:this.e>K.e?1:0}translate(K,me=0){if(K===null||me===null)throw(0,h.$6)();let Oe;return typeof K>"u"?Oe=0:typeof K=="number"?Oe=K:(Oe=typeof K.lineDelta=="number"?K.lineDelta:0,me=typeof K.characterDelta=="number"?K.characterDelta:0),Oe===0&&me===0?this:new m(this.line+Oe,this.character+me)}with(K,me=this.character){if(K===null||me===null)throw(0,h.$6)();let Oe;return typeof K>"u"?Oe=this.line:typeof K=="number"?Oe=K:(Oe=typeof K.line=="number"?K.line:this.line,me=typeof K.character=="number"?K.character:this.character),Oe===this.line&&me===this.character?this:new m(Oe,me)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$NN=L,e.$NN=L=m=Je([b],L);let M=$=class{static isRange(K){return K instanceof $?!0:K?L.isPosition(K.start)&&L.isPosition(K.end):!1}static of(K){if(K instanceof $)return K;if(this.isRange(K))return new $(K.start,K.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(K,me,Oe,Ye){let ot,$t;if(typeof K=="number"&&typeof me=="number"&&typeof Oe=="number"&&typeof Ye=="number"?(ot=new L(K,me),$t=new L(Oe,Ye)):L.isPosition(K)&&L.isPosition(me)&&(ot=L.of(K),$t=L.of(me)),!ot||!$t)throw new Error("Invalid arguments");ot.isBefore($t)?(this.c=ot,this.e=$t):(this.c=$t,this.e=ot)}contains(K){return $.isRange(K)?this.contains(K.start)&&this.contains(K.end):L.isPosition(K)?!(L.of(K).isBefore(this.c)||this.e.isBefore(K)):!1}isEqual(K){return this.c.isEqual(K.c)&&this.e.isEqual(K.e)}intersection(K){const me=L.Max(K.start,this.c),Oe=L.Min(K.end,this.e);if(!me.isAfter(Oe))return new $(me,Oe)}union(K){if(this.contains(K))return this;if(K.contains(this))return K;const me=L.Min(K.start,this.c),Oe=L.Max(K.end,this.end);return new $(me,Oe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(K,me=this.end){if(K===null||me===null)throw(0,h.$6)();let Oe;return K?L.isPosition(K)?Oe=K:(Oe=K.start||this.start,me=K.end||this.end):Oe=this.start,Oe.isEqual(this.c)&&me.isEqual(this.end)?this:new $(Oe,me)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return j(this)}};e.$ON=M,e.$ON=M=$=Je([b],M);let z=f=class extends M{static isSelection(K){return K instanceof f?!0:K?M.isRange(K)&&L.isPosition(K.anchor)&&L.isPosition(K.active)&&typeof K.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(K,me,Oe,Ye){let ot,$t;if(typeof K=="number"&&typeof me=="number"&&typeof Oe=="number"&&typeof Ye=="number"?(ot=new L(K,me),$t=new L(Oe,Ye)):L.isPosition(K)&&L.isPosition(me)&&(ot=L.of(K),$t=L.of(me)),!ot||!$t)throw new Error("Invalid arguments");super(ot,$t),this.f=ot,this.g=$t}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return W(this)}};e.$PN=z,e.$PN=z=f=Je([b],z);function j(Z){return Z.isEmpty?`[${Z.start.line}:${Z.start.character})`:`[${Z.start.line}:${Z.start.character} -> ${Z.end.line}:${Z.end.character})`}function W(Z){let K=j(Z);return Z.isEmpty||(Z.active.isEqual(Z.start)?K=`|${K}`:K=`${K}|`),K}const B=Z=>{if(typeof Z!="string"||Z.length===0||!/^[0-9A-Za-z_\-]+$/.test(Z))throw(0,h.$6)("connectionToken")};class ee{static isResolvedAuthority(K){return K&&typeof K=="object"&&typeof K.host=="string"&&typeof K.port=="number"&&(K.connectionToken===void 0||typeof K.connectionToken=="string")}constructor(K,me,Oe){if(typeof K!="string"||K.length===0)throw(0,h.$6)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,h.$6)("port");typeof Oe<"u"&&B(Oe),this.host=K,this.port=Math.round(me),this.connectionToken=Oe}}e.$SN=ee;class H{static isManagedResolvedAuthority(K){return K&&typeof K=="object"&&typeof K.makeConnection=="function"&&(K.connectionToken===void 0||typeof K.connectionToken=="string")}constructor(K,me){this.makeConnection=K,this.connectionToken=me,typeof me<"u"&&B(me)}}e.$TN=H;class q extends Error{static NotAvailable(K,me){return new q(K,P.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(K){return new q(K,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(K,me=P.RemoteAuthorityResolverErrorCode.Unknown,Oe){super(K),this._message=K,this._code=me,this._detail=Oe,Object.setPrototypeOf(this,q.prototype)}}e.$UN=q;var Q;(function(Z){Z[Z.LF=1]="LF",Z[Z.CRLF=2]="CRLF"})(Q||(e.EndOfLine=Q={}));var _;(function(Z){Z[Z.Replace=1]="Replace",Z[Z.Append=2]="Append",Z[Z.Prepend=3]="Prepend"})(_||(e.EnvironmentVariableMutatorType=_={}));let ce=i=class{static isTextEdit(K){return K instanceof i?!0:K?M.isRange(K)&&typeof K.newText=="string":!1}static replace(K,me){return new i(K,me)}static insert(K,me){return i.replace(new M(K,K),me)}static delete(K){return i.replace(K,"")}static setEndOfLine(K){const me=new i(new M(new L(0,0),new L(0,0)),"");return me.newEol=K,me}get range(){return this.c}set range(K){if(K&&!M.isRange(K))throw(0,h.$6)("range");this.c=K}get newText(){return this.e||""}set newText(K){if(K&&typeof K!="string")throw(0,h.$6)("newText");this.e=K}get newEol(){return this.f}set newEol(K){if(K&&typeof K!="number")throw(0,h.$6)("newEol");this.f=K}constructor(K,me){this.c=K,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$VN=ce,e.$VN=ce=i=Je([b],ce);let ne=s=class{static isNotebookCellEdit(K){return K instanceof s?!0:K?Ei.isNotebookRange(K)&&Array.isArray(K.newCells):!1}static replaceCells(K,me){return new s(K,me)}static insertCells(K,me){return new s(new Ei(K,K),me)}static deleteCells(K){return new s(K,[])}static updateCellMetadata(K,me){const Oe=new s(new Ei(K,K),[]);return Oe.newCellMetadata=me,Oe}static updateNotebookMetadata(K){const me=new s(new Ei(0,0),[]);return me.newNotebookMetadata=K,me}constructor(K,me){this.range=K,this.newCells=me}};e.$WN=ne,e.$WN=ne=s=Je([b],ne);class ye{static isSnippetTextEdit(K){return K instanceof ye?!0:K?M.isRange(K.range)&&U.isSnippetString(K.snippet):!1}static replace(K,me){return new ye(K,me)}static insert(K,me){return ye.replace(new M(K,K),me)}constructor(K,me){this.range=K,this.snippet=me}}e.$XN=ye;var ge;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text",Z[Z.Cell=3]="Cell",Z[Z.CellReplace=5]="CellReplace",Z[Z.Snippet=6]="Snippet"})(ge||(e.FileEditType=ge={}));let Y=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(K,me,Oe,Ye){this.c.push({_type:ge.File,from:K,to:me,options:Oe,metadata:Ye})}createFile(K,me,Oe){this.c.push({_type:ge.File,from:void 0,to:K,options:me,metadata:Oe})}deleteFile(K,me,Oe){this.c.push({_type:ge.File,from:K,to:void 0,options:me,metadata:Oe})}e(K,me,Oe){this.c.push({_type:ge.Cell,metadata:Oe,uri:K,edit:{editType:w.CellEditType.DocumentMetadata,metadata:me},notebookMetadata:me})}f(K,me,Oe,Ye){const ot=me.start,$t=me.end;(ot!==$t||Oe.length>0)&&this.c.push({_type:ge.CellReplace,uri:K,index:ot,count:$t-ot,cells:Oe,metadata:Ye})}g(K,me,Oe,Ye){this.c.push({_type:ge.Cell,metadata:Ye,uri:K,edit:{editType:w.CellEditType.Metadata,index:me,metadata:Oe}})}replace(K,me,Oe,Ye){this.c.push({_type:ge.Text,uri:K,edit:new ce(me,Oe),metadata:Ye})}insert(K,me,Oe,Ye){this.replace(K,new M(me,me),Oe,Ye)}delete(K,me,Oe){this.replace(K,me,"",Oe)}has(K){return this.c.some(me=>me._type===ge.Text&&me.uri.toString()===K.toString())}set(K,me){if(me)for(const Oe of me){if(!Oe)continue;let Ye,ot;Array.isArray(Oe)?(Ye=Oe[0],ot=Oe[1]):Ye=Oe,ne.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(K,Ye.range.start,Ye.newCellMetadata,ot):Ye.newNotebookMetadata?this.e(K,Ye.newNotebookMetadata,ot):this.f(K,Ye.range,Ye.newCells,ot):ye.isSnippetTextEdit(Ye)?this.c.push({_type:ge.Snippet,uri:K,range:Ye.range,edit:Ye.snippet,metadata:ot}):this.c.push({_type:ge.Text,uri:K,edit:Ye,metadata:ot})}else{for(let Oe=0;Oe<this.c.length;Oe++){const Ye=this.c[Oe];switch(Ye._type){case ge.Text:case ge.Snippet:case ge.Cell:case ge.CellReplace:Ye.uri.toString()===K.toString()&&(this.c[Oe]=void 0);break}}(0,r.$Hb)(this.c)}}get(K){const me=[];for(const Oe of this.c)Oe._type===ge.Text&&Oe.uri.toString()===K.toString()&&me.push(Oe.edit);return me}entries(){const K=new R.$Ac;for(const me of this.c)if(me._type===ge.Text){let Oe=K.get(me.uri);Oe||(Oe=[me.uri,[]],K.set(me.uri,Oe)),Oe[1].push(me.edit)}return[...K.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$YN=Y,e.$YN=Y=Je([b],Y);let U=t=class{static isSnippetString(K){return K instanceof t?!0:K?typeof K.value=="string":!1}static c(K){return K.replace(/\$|}|\\/g,"\\$&")}constructor(K){this.e=1,this.value=K||""}appendText(K){return this.value+=t.c(K),this}appendTabstop(K=this.e++){return this.value+="$",this.value+=K,this}appendPlaceholder(K,me=this.e++){if(typeof K=="function"){const Oe=new t;Oe.e=this.e,K(Oe),this.e=Oe.e,K=Oe.value}else K=t.c(K);return this.value+="${",this.value+=me,this.value+=":",this.value+=K,this.value+="}",this}appendChoice(K,me=this.e++){const Oe=K.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Oe,this.value+="|}",this}appendVariable(K,me){if(typeof me=="function"){const Oe=new t;Oe.e=this.e,me(Oe),this.e=Oe.e,me=Oe.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=K,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.$ZN=U,e.$ZN=U=t=Je([b],U);var oe;(function(Z){Z[Z.Unnecessary=1]="Unnecessary",Z[Z.Deprecated=2]="Deprecated"})(oe||(e.DiagnosticTag=oe={}));var ve;(function(Z){Z[Z.Hint=3]="Hint",Z[Z.Information=2]="Information",Z[Z.Warning=1]="Warning",Z[Z.Error=0]="Error"})(ve||(e.DiagnosticSeverity=ve={}));let te=o=class{static isLocation(K){return K instanceof o?!0:K?M.isRange(K.range)&&c.URI.isUri(K.uri):!1}constructor(K,me){if(this.uri=K,me)if(M.isRange(me))this.range=M.of(me);else if(L.isPosition(me))this.range=new M(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$1N=te,e.$1N=te=o=Je([b],te);let ae=class{static is(K){return K?typeof K.message=="string"&&K.location&&M.isRange(K.location.range)&&c.URI.isUri(K.location.uri):!1}constructor(K,me){this.location=K,this.message=me}static isEqual(K,me){return K===me?!0:!K||!me?!1:K.message===me.message&&K.location.range.isEqual(me.location.range)&&K.location.uri.toString()===me.location.uri.toString()}};e.$2N=ae,e.$2N=ae=Je([b],ae);let se=class{constructor(K,me,Oe=ve.Error){if(!M.isRange(K))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=K,this.message=me,this.severity=Oe}toJSON(){return{severity:ve[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(K,me){return K===me?!0:!K||!me?!1:K.message===me.message&&K.severity===me.severity&&K.code===me.code&&K.severity===me.severity&&K.source===me.source&&K.range.isEqual(me.range)&&(0,r.$tb)(K.tags,me.tags)&&(0,r.$tb)(K.relatedInformation,me.relatedInformation,ae.isEqual)}};e.$3N=se,e.$3N=se=Je([b],se);let X=class{constructor(K,me){if(!K)throw new Error("Illegal argument, contents must be defined");Array.isArray(K)?this.contents=K:this.contents=[K],this.range=me}};e.$4N=X,e.$4N=X=Je([b],X);let re=class extends X{constructor(K,me,Oe,Ye){super(K,me),this.canIncreaseVerbosity=Oe,this.canDecreaseVerbosity=Ye}};e.$5N=re,e.$5N=re=Je([b],re);var pe;(function(Z){Z[Z.Increase=0]="Increase",Z[Z.Decrease=1]="Decrease"})(pe||(e.HoverVerbosityAction=pe={}));var we;(function(Z){Z[Z.Text=0]="Text",Z[Z.Read=1]="Read",Z[Z.Write=2]="Write"})(we||(e.DocumentHighlightKind=we={}));let Fe=class{constructor(K,me=we.Text){this.range=K,this.kind=me}toJSON(){return{range:this.range,kind:we[this.kind]}}};e.$6N=Fe,e.$6N=Fe=Je([b],Fe);let Be=class{constructor(K,me){this.uri=K,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(K=>K.toJSON())}}};e.$7N=Be,e.$7N=Be=Je([b],Be);var Re;(function(Z){Z[Z.File=0]="File",Z[Z.Module=1]="Module",Z[Z.Namespace=2]="Namespace",Z[Z.Package=3]="Package",Z[Z.Class=4]="Class",Z[Z.Method=5]="Method",Z[Z.Property=6]="Property",Z[Z.Field=7]="Field",Z[Z.Constructor=8]="Constructor",Z[Z.Enum=9]="Enum",Z[Z.Interface=10]="Interface",Z[Z.Function=11]="Function",Z[Z.Variable=12]="Variable",Z[Z.Constant=13]="Constant",Z[Z.String=14]="String",Z[Z.Number=15]="Number",Z[Z.Boolean=16]="Boolean",Z[Z.Array=17]="Array",Z[Z.Object=18]="Object",Z[Z.Key=19]="Key",Z[Z.Null=20]="Null",Z[Z.EnumMember=21]="EnumMember",Z[Z.Struct=22]="Struct",Z[Z.Event=23]="Event",Z[Z.Operator=24]="Operator",Z[Z.TypeParameter=25]="TypeParameter"})(Re||(e.SymbolKind=Re={}));var De;(function(Z){Z[Z.Deprecated=1]="Deprecated"})(De||(e.SymbolTag=De={}));let Ce=n=class{static validate(K){if(!K.name)throw new Error("name must not be falsy")}constructor(K,me,Oe,Ye,ot){this.name=K,this.kind=me,this.containerName=ot,typeof Oe=="string"&&(this.containerName=Oe),Ye instanceof te?this.location=Ye:Oe instanceof M&&(this.location=new te(Ye,Oe)),n.validate(this)}toJSON(){return{name:this.name,kind:Re[this.kind],location:this.location,containerName:this.containerName}}};e.$8N=Ce,e.$8N=Ce=n=Je([b],Ce);let V=d=class{static validate(K){if(!K.name)throw new Error("name must not be falsy");if(!K.range.contains(K.selectionRange))throw new Error("selectionRange must be contained in fullRange");K.children?.forEach(d.validate)}constructor(K,me,Oe,Ye,ot){this.name=K,this.detail=me,this.kind=Oe,this.range=Ye,this.selectionRange=ot,this.children=[],d.validate(this)}};e.$9N=V,e.$9N=V=d=Je([b],V);var G;(function(Z){Z[Z.Invoke=1]="Invoke",Z[Z.Automatic=2]="Automatic"})(G||(e.CodeActionTriggerKind=G={}));let J=class{constructor(K,me){this.title=K,this.kind=me}};e.$0N=J,e.$0N=J=Je([b],J);let x=class{static{l=this}static{this.c="."}constructor(K){this.value=K}append(K){return new l(this.value?this.value+l.c+K:K)}intersects(K){return this.contains(K)||K.contains(this)}contains(K){return this.value===K.value||K.value.startsWith(this.value+l.c)}};e.$$N=x,e.$$N=x=l=Je([b],x),x.Empty=new x(""),x.QuickFix=x.Empty.append("quickfix"),x.Refactor=x.Empty.append("refactor"),x.RefactorExtract=x.Refactor.append("extract"),x.RefactorInline=x.Refactor.append("inline"),x.RefactorMove=x.Refactor.append("move"),x.RefactorRewrite=x.Refactor.append("rewrite"),x.Source=x.Empty.append("source"),x.SourceOrganizeImports=x.Source.append("organizeImports"),x.SourceFixAll=x.Source.append("fixAll"),x.Notebook=x.Empty.append("notebook");let de=class{constructor(K,me){if(this.range=K,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$_N=de,e.$_N=de=Je([b],de);class Ee{constructor(K,me,Oe,Ye,ot,$t){this.kind=K,this.name=me,this.detail=Oe,this.uri=Ye,this.range=ot,this.selectionRange=$t}}e.$aO=Ee;class Le{constructor(K,me){this.fromRanges=me,this.from=K}}e.$bO=Le;class He{constructor(K,me){this.fromRanges=me,this.to=K}}e.$cO=He;var Ze;(function(Z){Z[Z.Information=0]="Information",Z[Z.Warning=1]="Warning",Z[Z.Error=2]="Error"})(Ze||(e.LanguageStatusSeverity=Ze={}));let et=class{constructor(K,me){this.range=K,this.command=me}get isResolved(){return!!this.command}};e.$dO=et,e.$dO=et=Je([b],et);let nt=g=class{#e;static isMarkdownString(K){return K instanceof g?!0:K&&K.appendCodeblock&&K.appendMarkdown&&K.appendText&&K.value!==void 0}constructor(K,me=!1){this.#e=new C.$4k(K,{supportThemeIcons:me})}get value(){return this.#e.value}set value(K){this.#e.value=K}get isTrusted(){return this.#e.isTrusted}set isTrusted(K){this.#e.isTrusted=K}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(K){this.#e.supportThemeIcons=K}get supportHtml(){return this.#e.supportHtml}set supportHtml(K){this.#e.supportHtml=K}get baseUri(){return this.#e.baseUri}set baseUri(K){this.#e.baseUri=K}appendText(K){return this.#e.appendText(K),this}appendMarkdown(K){return this.#e.appendMarkdown(K),this}appendCodeblock(K,me){return this.#e.appendCodeblock(me??"",K),this}};e.$eO=nt,e.$eO=nt=g=Je([b],nt);let st=class{constructor(K,me){this.label=K,this.documentation=me}};e.$fO=st,e.$fO=st=Je([b],st);let rt=class{constructor(K,me){this.label=K,this.documentation=me,this.parameters=[]}};e.$gO=rt,e.$gO=rt=Je([b],rt);let at=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$hO=at,e.$hO=at=Je([b],at);var gt;(function(Z){Z[Z.Invoke=1]="Invoke",Z[Z.TriggerCharacter=2]="TriggerCharacter",Z[Z.ContentChange=3]="ContentChange"})(gt||(e.SignatureHelpTriggerKind=gt={}));var dt;(function(Z){Z[Z.Type=1]="Type",Z[Z.Parameter=2]="Parameter"})(dt||(e.InlayHintKind=dt={}));let ct=class{constructor(K){this.value=K}};e.$iO=ct,e.$iO=ct=Je([b],ct);let Pe=class{constructor(K,me,Oe){this.position=K,this.label=me,this.kind=Oe}};e.$jO=Pe,e.$jO=Pe=Je([b],Pe);var ze;(function(Z){Z[Z.Invoke=0]="Invoke",Z[Z.TriggerCharacter=1]="TriggerCharacter",Z[Z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze||(e.CompletionTriggerKind=ze={}));var Ke;(function(Z){Z[Z.Text=0]="Text",Z[Z.Method=1]="Method",Z[Z.Function=2]="Function",Z[Z.Constructor=3]="Constructor",Z[Z.Field=4]="Field",Z[Z.Variable=5]="Variable",Z[Z.Class=6]="Class",Z[Z.Interface=7]="Interface",Z[Z.Module=8]="Module",Z[Z.Property=9]="Property",Z[Z.Unit=10]="Unit",Z[Z.Value=11]="Value",Z[Z.Enum=12]="Enum",Z[Z.Keyword=13]="Keyword",Z[Z.Snippet=14]="Snippet",Z[Z.Color=15]="Color",Z[Z.File=16]="File",Z[Z.Reference=17]="Reference",Z[Z.Folder=18]="Folder",Z[Z.EnumMember=19]="EnumMember",Z[Z.Constant=20]="Constant",Z[Z.Struct=21]="Struct",Z[Z.Event=22]="Event",Z[Z.Operator=23]="Operator",Z[Z.TypeParameter=24]="TypeParameter",Z[Z.User=25]="User",Z[Z.Issue=26]="Issue"})(Ke||(e.CompletionItemKind=Ke={}));var Ne;(function(Z){Z[Z.Deprecated=1]="Deprecated"})(Ne||(e.CompletionItemTag=Ne={}));let je=class{constructor(K,me){this.label=K,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&Ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$kO=je,e.$kO=je=Je([b],je);let ue=class{constructor(K=[],me=!1){this.items=K,this.isIncomplete=me}};e.$lO=ue,e.$lO=ue=Je([b],ue);let he=class{constructor(K,me,Oe){this.insertText=K,this.range=me,this.command=Oe}};e.$mO=he,e.$mO=he=Je([b],he);let le=class{constructor(K){this.commands=void 0,this.suppressSuggestions=void 0,this.items=K}};e.$nO=le,e.$nO=le=Je([b],le);var Xe;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.Word=1]="Word",Z[Z.Line=2]="Line",Z[Z.Suggest=3]="Suggest"})(Xe||(e.PartialAcceptTriggerKind=Xe={}));var tt;(function(Z){Z[Z.Active=-1]="Active",Z[Z.Beside=-2]="Beside",Z[Z.One=1]="One",Z[Z.Two=2]="Two",Z[Z.Three=3]="Three",Z[Z.Four=4]="Four",Z[Z.Five=5]="Five",Z[Z.Six=6]="Six",Z[Z.Seven=7]="Seven",Z[Z.Eight=8]="Eight",Z[Z.Nine=9]="Nine"})(tt||(e.ViewColumn=tt={}));var ut;(function(Z){Z[Z.Left=1]="Left",Z[Z.Right=2]="Right"})(ut||(e.StatusBarAlignment=ut={}));function mt(Z,K){return`${S.$rn.toKey(Z)}.${K}`}var Dt;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval"})(Dt||(e.TextEditorLineNumbersStyle=Dt={}));var Mt;(function(Z){Z[Z.Manual=1]="Manual",Z[Z.AfterDelay=2]="AfterDelay",Z[Z.FocusOut=3]="FocusOut"})(Mt||(e.TextDocumentSaveReason=Mt={}));var Ht;(function(Z){Z[Z.Default=0]="Default",Z[Z.InCenter=1]="InCenter",Z[Z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Z[Z.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var ei;(function(Z){Z[Z.Keyboard=1]="Keyboard",Z[Z.Mouse=2]="Mouse",Z[Z.Command=3]="Command"})(ei||(e.TextEditorSelectionChangeKind=ei={}));var oi;(function(Z){Z[Z.Undo=1]="Undo",Z[Z.Redo=2]="Redo"})(oi||(e.TextDocumentChangeReason=oi={}));var Tt;(function(Z){Z[Z.OpenOpen=0]="OpenOpen",Z[Z.ClosedClosed=1]="ClosedClosed",Z[Z.OpenClosed=2]="OpenClosed",Z[Z.ClosedOpen=3]="ClosedOpen"})(Tt||(e.DecorationRangeBehavior=Tt={})),function(Z){function K(me){switch(me){case"keyboard":return Z.Keyboard;case"mouse":return Z.Mouse;case"api":return Z.Command}}Z.fromValue=K}(ei||(e.TextEditorSelectionChangeKind=ei={}));var it;(function(Z){Z[Z.Other=0]="Other",Z[Z.Comment=1]="Comment",Z[Z.String=2]="String",Z[Z.RegEx=3]="RegEx"})(it||(e.SyntaxTokenType=it={})),function(Z){function K(me){switch(me){case Z.Other:return"other";case Z.Comment:return"comment";case Z.String:return"string";case Z.RegEx:return"regex"}return"other"}Z.toString=K}(it||(e.SyntaxTokenType=it={}));let Ct=class{constructor(K,me){if(me&&!c.URI.isUri(me))throw(0,h.$6)("target");if(!M.isRange(K)||K.isEmpty)throw(0,h.$6)("range");this.range=K,this.target=me}};e.$pO=Ct,e.$pO=Ct=Je([b],Ct);let hi=class{constructor(K,me,Oe,Ye){this.red=K,this.green=me,this.blue=Oe,this.alpha=Ye}};e.$qO=hi,e.$qO=hi=Je([b],hi);let bt=class{constructor(K,me){if(me&&!(me instanceof hi))throw(0,h.$6)("color");if(!M.isRange(K)||K.isEmpty)throw(0,h.$6)("range");this.range=K,this.color=me}};e.$rO=bt,e.$rO=bt=Je([b],bt);let St=class{constructor(K){if(!K||typeof K!="string")throw(0,h.$6)("label");this.label=K}};e.$sO=St,e.$sO=St=Je([b],St);var ti;(function(Z){Z[Z.RGB=0]="RGB",Z[Z.HEX=1]="HEX",Z[Z.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var ii;(function(Z){Z[Z.Error=0]="Error",Z[Z.Warning=1]="Warning",Z[Z.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var Wt;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.Shutdown=1]="Shutdown",Z[Z.Process=2]="Process",Z[Z.User=3]="User",Z[Z.Extension=4]="Extension"})(Wt||(e.TerminalExitReason=Wt={}));var pt;(function(Z){Z[Z.Low=0]="Low",Z[Z.Medium=1]="Medium",Z[Z.High=2]="High"})(pt||(e.TerminalShellExecutionCommandLineConfidence=pt={}));class Bt{constructor(K,me,Oe){if(this.startIndex=K,this.length=me,this.tooltip=Oe,typeof K!="number"||K<0)throw(0,h.$6)("startIndex");if(typeof me!="number"||me<1)throw(0,h.$6)("length");if(Oe!==void 0&&typeof Oe!="string")throw(0,h.$6)("tooltip")}}e.$tO=Bt;class ni{constructor(K){this.uri=K}}e.$uO=ni;class ai{constructor(K){this.terminalCommand=K}}e.$vO=ai;var xe;(function(Z){Z[Z.Panel=1]="Panel",Z[Z.Editor=2]="Editor"})(xe||(e.TerminalLocation=xe={}));class ci{constructor(K){if(this.options=K,typeof K!="object")throw(0,h.$6)("options")}}e.$wO=ci;var di;(function(Z){Z[Z.Always=1]="Always",Z[Z.Silent=2]="Silent",Z[Z.Never=3]="Never"})(di||(e.TaskRevealKind=di={}));var fi;(function(Z){Z[Z.Shared=1]="Shared",Z[Z.Dedicated=2]="Dedicated",Z[Z.New=3]="New"})(fi||(e.TaskPanelKind=fi={}));let vt=class{static{E=this}static{this.Clean=new E("clean","Clean")}static{this.Build=new E("build","Build")}static{this.Rebuild=new E("rebuild","Rebuild")}static{this.Test=new E("test","Test")}static from(K){switch(K){case"clean":return E.Clean;case"build":return E.Build;case"rebuild":return E.Rebuild;case"test":return E.Test;default:return}}constructor(K,me){if(this.label=me,typeof K!="string"||typeof me!="string")throw(0,h.$6)("name");this.c=K}get id(){return this.c}};e.$xO=vt,e.$xO=vt=E=Je([b],vt);function jt(Z){let K="";for(let me=0;me<Z.length;me++)K+=Z[me].replace(/,/g,",,")+",";return K}let Nt=class{constructor(K,me,Oe){if(typeof K!="string")throw(0,h.$6)("process");this.e=[],this.c=K,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Oe):this.f=me)}get process(){return this.c}set process(K){if(typeof K!="string")throw(0,h.$6)("process");this.c=K}get args(){return this.e}set args(K){Array.isArray(K)||(K=[]),this.e=K}get options(){return this.f}set options(K){this.f=K}computeId(){const K=[];if(K.push("process"),this.c!==void 0&&K.push(this.c),this.e&&this.e.length>0)for(const me of this.e)K.push(me);return jt(K)}};e.$yO=Nt,e.$yO=Nt=Je([b],Nt);let Gt=class{constructor(K,me,Oe){if(this.f=[],Array.isArray(me)){if(!K)throw(0,h.$6)("command can't be undefined or null");if(typeof K!="string"&&typeof K.value!="string")throw(0,h.$6)("command");this.e=K,this.f=me,this.g=Oe}else{if(typeof K!="string")throw(0,h.$6)("commandLine");this.c=K,this.g=me}}get commandLine(){return this.c}set commandLine(K){if(typeof K!="string")throw(0,h.$6)("commandLine");this.c=K}get command(){return this.e?this.e:""}set command(K){if(typeof K!="string"&&typeof K.value!="string")throw(0,h.$6)("command");this.e=K}get args(){return this.f}set args(K){this.f=K||[]}get options(){return this.g}set options(K){this.g=K}computeId(){const K=[];if(K.push("shell"),this.c!==void 0&&K.push(this.c),this.e!==void 0&&K.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)K.push(typeof me=="string"?me:me.value);return jt(K)}};e.$zO=Gt,e.$zO=Gt=Je([b],Gt);var ri;(function(Z){Z[Z.Escape=1]="Escape",Z[Z.Strong=2]="Strong",Z[Z.Weak=3]="Weak"})(ri||(e.ShellQuoting=ri={}));var Qt;(function(Z){Z[Z.Global=1]="Global",Z[Z.Workspace=2]="Workspace"})(Qt||(e.TaskScope=Qt={}));class li{constructor(K){this.c=K}computeId(){return"customExecution"+(0,I.$2g)()}set callback(K){this.c=K}get callback(){return this.c}}e.$AO=li;let qt=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(K,me,Oe,Ye,ot,$t){this.k=!1,this.l=this.definition=K;let yt;typeof me=="string"?(this.o=this.name=me,this.w=this.source=Oe,this.execution=Ye,yt=ot,this.k=!0):me===Qt.Global||me===Qt.Workspace?(this.target=me,this.o=this.name=Oe,this.w=this.source=Ye,this.execution=ot,yt=$t):(this.target=me,this.o=this.name=Oe,this.w=this.source=Ye,this.execution=ot,yt=$t),typeof yt=="string"?(this.r=[yt],this.t=!0):Array.isArray(yt)?(this.r=yt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(K){this.j=K}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Nt?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof Gt?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof li?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,I.$2g)()}}get definition(){return this.l}set definition(K){if(K==null)throw(0,h.$6)("Kind can't be undefined or null");this.B(),this.l=K}get scope(){return this.m}set target(K){this.B(),this.m=K}get name(){return this.o}set name(K){if(typeof K!="string")throw(0,h.$6)("name");this.B(),this.o=K}get execution(){return this.q}set execution(K){K===null&&(K=void 0),this.B(),this.q=K;const me=this.l.type;(D.g===me||D.e===me||D.f===me||D.c===me)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(K){if(Array.isArray(K))this.B(),this.r=K,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(K){K!==!0&&K!==!1&&(K=!1),this.B(),this.u=K}get source(){return this.w}set source(K){if(typeof K!="string"||K.length===0)throw(0,h.$6)("source must be a string of length > 0");this.B(),this.w=K}get group(){return this.x}set group(K){K===null&&(K=void 0),this.B(),this.x=K}get detail(){return this.A}set detail(K){K===null&&(K=void 0),this.A=K}get presentationOptions(){return this.y}set presentationOptions(K){K==null&&(K=Object.create(null)),this.B(),this.y=K}get runOptions(){return this.z}set runOptions(K){K==null&&(K=Object.create(null)),this.B(),this.z=K}};e.$BO=qt,e.$BO=qt=D=Je([b],qt);var Zt;(function(Z){Z[Z.SourceControl=1]="SourceControl",Z[Z.Window=10]="Window",Z[Z.Notification=15]="Notification"})(Zt||(e.ProgressLocation=Zt={}));var Jt;(function(Z){function K(me){const Oe=me;return(0,p.$ig)(Oe.value)?Oe.tooltip&&!(0,p.$eg)(Oe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Oe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Oe.value),!1)}Z.isViewBadge=K})(Jt||(e.ViewBadge=Jt={}));let Ft=y=class{static isTreeItem(K,me){const Oe=K;if(Oe.checkboxState!==void 0){const Ye=(0,p.$ig)(Oe.checkboxState)?Oe.checkboxState:(0,p.$gg)(Oe.checkboxState)&&(0,p.$ig)(Oe.checkboxState.state)?Oe.checkboxState.state:void 0,ot=!(0,p.$ig)(Oe.checkboxState)&&(0,p.$gg)(Oe.checkboxState)?Oe.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==It.Checked&&Ye!==It.Unchecked||ot!==void 0&&!(0,p.$eg)(ot))return console.log("INVALID tree item, invalid checkboxState",Oe.checkboxState),!1}if(K instanceof y)return!0;if(Oe.label!==void 0&&!(0,p.$eg)(Oe.label)&&!Oe.label?.label)return console.log("INVALID tree item, invalid label",Oe.label),!1;if(Oe.id!==void 0&&!(0,p.$eg)(Oe.id))return console.log("INVALID tree item, invalid id",Oe.id),!1;if(Oe.iconPath!==void 0&&!(0,p.$eg)(Oe.iconPath)&&!c.URI.isUri(Oe.iconPath)&&(!Oe.iconPath||!(0,p.$eg)(Oe.iconPath.id))){const Ye=Oe.iconPath;if(!Ye||!(0,p.$eg)(Ye.light)&&!c.URI.isUri(Ye.light)&&!(0,p.$eg)(Ye.dark)&&!c.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Oe.iconPath),!1}return Oe.description!==void 0&&!(0,p.$eg)(Oe.description)&&typeof Oe.description!="boolean"?(console.log("INVALID tree item, invalid description",Oe.description),!1):Oe.resourceUri!==void 0&&!c.URI.isUri(Oe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Oe.resourceUri),!1):Oe.tooltip!==void 0&&!(0,p.$eg)(Oe.tooltip)&&!(Oe.tooltip instanceof nt)?(console.log("INVALID tree item, invalid tooltip",Oe.tooltip),!1):Oe.command!==void 0&&!Oe.command.command?(console.log("INVALID tree item, invalid command",Oe.command),!1):Oe.collapsibleState!==void 0&&Oe.collapsibleState<wt.None&&Oe.collapsibleState>wt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Oe.collapsibleState),!1):Oe.contextValue!==void 0&&!(0,p.$eg)(Oe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Oe.contextValue),!1):Oe.accessibilityInformation!==void 0&&!Oe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Oe.accessibilityInformation),!1):!0}constructor(K,me=wt.None){this.collapsibleState=me,c.URI.isUri(K)?this.resourceUri=K:this.label=K}};e.$CO=Ft,e.$CO=Ft=y=Je([b],Ft);var wt;(function(Z){Z[Z.None=0]="None",Z[Z.Collapsed=1]="Collapsed",Z[Z.Expanded=2]="Expanded"})(wt||(e.TreeItemCollapsibleState=wt={}));var It;(function(Z){Z[Z.Unchecked=0]="Unchecked",Z[Z.Checked=1]="Checked"})(It||(e.TreeItemCheckboxState=It={}));let Kt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(K){this.value=K}};e.$DO=Kt,e.$DO=Kt=Je([b],Kt);class Pt extends Kt{}e.$EO=Pt;class mi extends Pt{#e;constructor(K){super(""),this.#e=K}asFile(){return this.#e}}e.$FO=mi;class xt{constructor(K,me,Oe,Ye){this.name=K,this.uri=me,this._itemId=Oe,this.c=Ye}data(){return this.c()}}e.$GO=xt;let ki=class{#e=new Map;constructor(K){for(const[me,Oe]of K??[]){const Ye=this.#e.get(this.#t(me));Ye?Ye.push(Oe):this.#e.set(this.#t(me),[Oe])}}get(K){return this.#e.get(this.#t(K))?.[0]}set(K,me){this.#e.set(this.#t(K),[me])}forEach(K,me){for(const[Oe,Ye]of this.#e)for(const ot of Ye)K.call(me,ot,Oe,this)}*[Symbol.iterator](){for(const[K,me]of this.#e)for(const Oe of me)yield[K,Oe]}#t(K){return K.toLowerCase()}};e.$HO=ki,e.$HO=ki=Je([b],ki);let bi=class{constructor(K,me,Oe){this.insertText=K,this.title=me,this.kind=Oe}};e.$IO=bi,e.$IO=bi=Je([b],bi);var Ri;(function(Z){Z[Z.Automatic=0]="Automatic",Z[Z.PasteAs=1]="PasteAs"})(Ri||(e.DocumentPasteTriggerKind=Ri={}));class Ot{static{this.c="."}constructor(K){this.value=K}append(...K){return new Ot((this.value?[this.value,...K]:K).join(Ot.c))}intersects(K){return this.contains(K)||K.contains(this)}contains(K){return this.value===K.value||K.value.startsWith(this.value+Ot.c)}}e.$JO=Ot,Ot.Empty=new Ot("");class Li{constructor(K,me,Oe){this.title=me,this.insertText=K,this.kind=Oe}}e.$KO=Li;let ui=class{constructor(K,me){this.id=K,this.color=me}static isThemeIcon(K){return typeof K.id!="string"?(console.log("INVALID ThemeIcon, invalid id",K.id),!1):!0}};e.$LO=ui,e.$LO=ui=Je([b],ui),ui.File=new ui("file"),ui.Folder=new ui("folder");let At=class{constructor(K){this.id=K}};e.$MO=At,e.$MO=At=Je([b],At);var Ti;(function(Z){Z[Z.Global=1]="Global",Z[Z.Workspace=2]="Workspace",Z[Z.WorkspaceFolder=3]="WorkspaceFolder"})(Ti||(e.ConfigurationTarget=Ti={}));let Ii=class{get base(){return this.c}set base(K){this.c=K,this.e=c.URI.file(K)}get baseUri(){return this.e}set baseUri(K){this.e=K,this.c=K.fsPath}constructor(K,me){if(typeof K!="string"&&(!K||!c.URI.isUri(K)&&!c.URI.isUri(K.uri)))throw(0,h.$6)("base");if(typeof me!="string")throw(0,h.$6)("pattern");typeof K=="string"?this.baseUri=c.URI.file(K):c.URI.isUri(K)?this.baseUri=K:this.baseUri=K.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$NO=Ii,e.$NO=Ii=Je([b],Ii);const Si=new WeakMap;function Ni(Z,K){Si.set(Z,K)}let wi=class{constructor(K,me,Oe,Ye,ot){this.enabled=typeof K=="boolean"?K:!0,typeof me=="string"&&(this.condition=me),typeof Oe=="string"&&(this.hitCondition=Oe),typeof Ye=="string"&&(this.logMessage=Ye),typeof ot=="string"&&(this.mode=ot)}get id(){return this.c||(this.c=Si.get(this)??(0,I.$2g)()),this.c}};e.$PO=wi,e.$PO=wi=Je([b],wi);let Vt=class extends wi{constructor(K,me,Oe,Ye,ot,$t){if(super(me,Oe,Ye,ot,$t),K===null)throw(0,h.$6)("location");this.location=K}};e.$QO=Vt,e.$QO=Vt=Je([b],Vt);let Te=class extends wi{constructor(K,me,Oe,Ye,ot,$t){super(me,Oe,Ye,ot,$t),this.functionName=K}};e.$RO=Te,e.$RO=Te=Je([b],Te);let Me=class extends wi{constructor(K,me,Oe,Ye,ot,$t,yt,Yt){if(super(Ye,ot,$t,yt,Yt),!me)throw(0,h.$6)("dataId");this.label=K,this.dataId=me,this.canPersist=Oe}};e.$SO=Me,e.$SO=Me=Je([b],Me);let Se=class{constructor(K,me,Oe){this.command=K,this.args=me||[],this.options=Oe}};e.$TO=Se,e.$TO=Se=Je([b],Se);let ie=class{constructor(K,me){this.port=K,this.host=me}};e.$UO=ie,e.$UO=ie=Je([b],ie);let Ae=class{constructor(K){this.path=K}};e.$VO=Ae,e.$VO=Ae=Je([b],Ae);let Ge=class{constructor(K){this.implementation=K}};e.$WO=Ge,e.$WO=Ge=Je([b],Ge);class _e{constructor(K,me,Oe){this.session=K,this.threadId=me,this.frameId=Oe}}e.$XO=_e;class Qe{constructor(K,me){this.session=K,this.threadId=me}}e.$YO=Qe;let ft=class{constructor(K,me){this.range=K,this.expression=me}};e.$ZO=ft,e.$ZO=ft=Je([b],ft);var Rt;(function(Z){Z[Z.Invoke=0]="Invoke",Z[Z.Automatic=1]="Automatic"})(Rt||(e.InlineCompletionTriggerKind=Rt={}));let Xt=class{constructor(K,me){this.range=K,this.text=me}};e.$1O=Xt,e.$1O=Xt=Je([b],Xt);let si=class{constructor(K,me,Oe=!0){this.range=K,this.variableName=me,this.caseSensitiveLookup=Oe}};e.$2O=si,e.$2O=si=Je([b],si);let zt=class{constructor(K,me){this.range=K,this.expression=me}};e.$3O=zt,e.$3O=zt=Je([b],zt);let _t=class{constructor(K,me){this.frameId=K,this.stoppedLocation=me}};e.$4O=_t,e.$4O=_t=Je([b],_t);var qi;(function(Z){Z[Z.AIGenerated=1]="AIGenerated"})(qi||(e.NewSymbolNameTag=qi={}));var rn;(function(Z){Z[Z.Invoke=0]="Invoke",Z[Z.Automatic=1]="Automatic"})(rn||(e.NewSymbolNameTriggerKind=rn={}));class Vi{constructor(K,me){this.newSymbolName=K,this.tags=me}}e.$5O=Vi;var Mi;(function(Z){Z[Z.Changed=1]="Changed",Z[Z.Created=2]="Created",Z[Z.Deleted=3]="Deleted"})(Mi||(e.FileChangeType=Mi={}));let Hi=k=class extends Error{static FileExists(K){return new k(K,u.FileSystemProviderErrorCode.FileExists,k.FileExists)}static FileNotFound(K){return new k(K,u.FileSystemProviderErrorCode.FileNotFound,k.FileNotFound)}static FileNotADirectory(K){return new k(K,u.FileSystemProviderErrorCode.FileNotADirectory,k.FileNotADirectory)}static FileIsADirectory(K){return new k(K,u.FileSystemProviderErrorCode.FileIsADirectory,k.FileIsADirectory)}static NoPermissions(K){return new k(K,u.FileSystemProviderErrorCode.NoPermissions,k.NoPermissions)}static Unavailable(K){return new k(K,u.FileSystemProviderErrorCode.Unavailable,k.Unavailable)}constructor(K,me=u.FileSystemProviderErrorCode.Unknown,Oe){super(c.URI.isUri(K)?K.toString(!0):K),this.code=Oe?.name??"Unknown",(0,u.$pl)(this,me),Object.setPrototypeOf(this,k.prototype),typeof Error.captureStackTrace=="function"&&typeof Oe=="function"&&Error.captureStackTrace(this,Oe)}};e.$6O=Hi,e.$6O=Hi=k=Je([b],Hi);let Gi=class{constructor(K,me,Oe){this.start=K,this.end=me,this.kind=Oe}};e.$7O=Gi,e.$7O=Gi=Je([b],Gi);var Pi;(function(Z){Z[Z.Comment=1]="Comment",Z[Z.Imports=2]="Imports",Z[Z.Region=3]="Region"})(Pi||(e.FoldingRangeKind=Pi={}));var sn;(function(Z){Z[Z.Collapsed=0]="Collapsed",Z[Z.Expanded=1]="Expanded"})(sn||(e.CommentThreadCollapsibleState=sn={}));var on;(function(Z){Z[Z.Editing=0]="Editing",Z[Z.Preview=1]="Preview"})(on||(e.CommentMode=on={}));var ji;(function(Z){Z[Z.Published=0]="Published",Z[Z.Draft=1]="Draft"})(ji||(e.CommentState=ji={}));var an;(function(Z){Z[Z.Unresolved=0]="Unresolved",Z[Z.Resolved=1]="Resolved"})(an||(e.CommentThreadState=an={}));var zi;(function(Z){Z[Z.Current=0]="Current",Z[Z.Outdated=1]="Outdated"})(zi||(e.CommentThreadApplicability=zi={}));var Ki;(function(Z){Z[Z.Reply=1]="Reply",Z[Z.Comment=2]="Comment"})(Ki||(e.CommentThreadFocus=Ki={}));class yn{constructor(K,me=[]){this.tokenTypes=K,this.tokenModifiers=me}}e.$8O=yn;function cn(Z){return typeof Z>"u"||(0,p.$fg)(Z)}class Zi{constructor(K){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,K){this.m=!0;for(let me=0,Oe=K.tokenTypes.length;me<Oe;me++)this.k.set(K.tokenTypes[me],me);for(let me=0,Oe=K.tokenModifiers.length;me<Oe;me++)this.l.set(K.tokenModifiers[me],me)}}push(K,me,Oe,Ye,ot){if(typeof K=="number"&&typeof me=="number"&&typeof Oe=="number"&&typeof Ye=="number"&&(typeof ot=="number"||typeof ot>"u"))return typeof ot>"u"&&(ot=0),this.q(K,me,Oe,Ye,ot);if(M.isRange(K)&&typeof me=="string"&&cn(Oe))return this.o(K,me,Oe);throw(0,h.$6)()}o(K,me,Oe){if(!this.m)throw new Error("Legend must be provided in constructor");if(K.start.line!==K.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(me))throw new Error("`tokenType` is not in the provided legend");const Ye=K.start.line,ot=K.start.character,$t=K.end.character-K.start.character,yt=this.k.get(me);let Yt=0;if(Oe)for(const pi of Oe){if(!this.l.has(pi))throw new Error("`tokenModifier` is not in the provided legend");const yi=this.l.get(pi);Yt|=1<<yi>>>0}this.q(Ye,ot,$t,yt,Yt)}q(K,me,Oe,Ye,ot){if(this.f&&(K<this.c||K===this.c&&me<this.e)){this.f=!1;const Yt=this.g.length/5|0;let pi=0,yi=0;for(let Di=0;Di<Yt;Di++){let Ai=this.g[5*Di],tn=this.g[5*Di+1];Ai===0?(Ai=pi,tn+=yi):Ai+=pi,this.g[5*Di]=Ai,this.g[5*Di+1]=tn,pi=Ai,yi=tn}}let $t=K,yt=me;this.f&&this.j>0&&($t-=this.c,$t===0&&(yt-=this.e)),this.g[this.j++]=$t,this.g[this.j++]=yt,this.g[this.j++]=Oe,this.g[this.j++]=Ye,this.g[this.j++]=ot,this.c=K,this.e=me}static r(K){const me=[],Oe=K.length/5|0;for(let yt=0;yt<Oe;yt++)me[yt]=yt;me.sort((yt,Yt)=>{const pi=K[5*yt],yi=K[5*Yt];if(pi===yi){const Di=K[5*yt+1],Ai=K[5*Yt+1];return Di-Ai}return pi-yi});const Ye=new Uint32Array(K.length);let ot=0,$t=0;for(let yt=0;yt<Oe;yt++){const Yt=5*me[yt],pi=K[Yt+0],yi=K[Yt+1],Di=K[Yt+2],Ai=K[Yt+3],tn=K[Yt+4],Gn=pi-ot,Nr=Gn===0?yi-$t:yi,nn=5*yt;Ye[nn+0]=Gn,Ye[nn+1]=Nr,Ye[nn+2]=Di,Ye[nn+3]=Ai,Ye[nn+4]=tn,ot=pi,$t=yi}return Ye}build(K){return this.f?new Ci(new Uint32Array(this.g),K):new Ci(Zi.r(this.g),K)}}e.$9O=Zi;class Ci{constructor(K,me){this.resultId=me,this.data=K}}e.$0O=Ci;class Sn{constructor(K,me,Oe){this.start=K,this.deleteCount=me,this.data=Oe}}e.$$O=Sn;class Dn{constructor(K,me){this.resultId=me,this.edits=K}}e.$_O=Dn;var ln;(function(Z){Z[Z.Separate=0]="Separate",Z[Z.MergeWithParent=1]="MergeWithParent"})(ln||(e.DebugConsoleMode=ln={}));class Qi{constructor(K){this.name=K}}e.$aP=Qi;var Ji;(function(Z){Z[Z.Title=1]="Title",Z[Z.Inline=2]="Inline"})(Ji||(e.QuickInputButtonLocation=Ji={}));let We=class{static{this.Back={iconPath:new ui("arrow-left")}}constructor(){}};e.$bP=We,e.$bP=We=Je([b],We);var vi;(function(Z){Z[Z.Separator=-1]="Separator",Z[Z.Default=0]="Default"})(vi||(e.QuickPickItemKind=vi={}));var Xi;(function(Z){Z[Z.Info=1]="Info",Z[Z.Warning=2]="Warning",Z[Z.Error=3]="Error"})(Xi||(e.InputBoxValidationSeverity=Xi={}));var lt;(function(Z){Z[Z.UI=1]="UI",Z[Z.Workspace=2]="Workspace"})(lt||(e.ExtensionKind=lt={}));class kt{static validate(K){if(typeof K.badge=="string"){let me=(0,T.$Pf)(K.badge,0);if(me<K.badge.length&&(me+=(0,T.$Pf)(K.badge,me)),K.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(K.badge&&!ui.isThemeIcon(K.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!K.color&&!K.badge&&!K.tooltip)throw new Error("The decoration is empty");return!0}constructor(K,me,Oe){this.badge=K,this.tooltip=me,this.color=Oe}}e.$cP=kt;let Yi=class{constructor(K){this.kind=K}};e.$dP=Yi,e.$dP=Yi=Je([b],Yi);var un;(function(Z){Z[Z.Light=1]="Light",Z[Z.Dark=2]="Dark",Z[Z.HighContrast=3]="HighContrast",Z[Z.HighContrastLight=4]="HighContrastLight"})(un||(e.ColorThemeKind=un={}));class Ei{static isNotebookRange(K){return K instanceof Ei?!0:K?typeof K.start=="number"&&typeof K.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(K,me){if(K<0)throw(0,h.$6)("start must be positive");if(me<0)throw(0,h.$6)("end must be positive");K<=me?(this.c=K,this.e=me):(this.c=me,this.e=K)}with(K){let me=this.c,Oe=this.e;return K.start!==void 0&&(me=K.start),K.end!==void 0&&(Oe=K.end),me===this.c&&Oe===this.e?this:new Ei(me,Oe)}}e.$eP=Ei;class Bi{static validate(K){if(typeof K.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof K.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof K.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(K){return Array.isArray(K)&&K.every(me=>Bi.isNotebookCellData(me))}static isNotebookCellData(K){return!0}constructor(K,me,Oe,Ye,ot,$t,yt){this.kind=K,this.value=me,this.languageId=Oe,this.mime=Ye,this.outputs=ot??[],this.metadata=$t,this.executionSummary=yt,Bi.validate(this)}}e.$fP=Bi;class Ui{constructor(K){this.cells=K}}e.$gP=Ui;class $i{static isNotebookCellOutputItem(K){return K instanceof $i?!0:K?typeof K.mime=="string"&&K.data instanceof Uint8Array:!1}static error(K){const me={name:K.name,message:K.message,stack:K.stack};return $i.json(me,"application/vnd.code.notebook.error")}static stdout(K){return $i.text(K,"application/vnd.code.notebook.stdout")}static stderr(K){return $i.text(K,"application/vnd.code.notebook.stderr")}static bytes(K,me="application/octet-stream"){return new $i(K,me)}static#e=new TextEncoder;static text(K,me=O.$$s.text){const Oe=$i.#e.encode(String(K));return new $i(Oe,me)}static json(K,me="text/x-json"){const Oe=JSON.stringify(K,void 0,"	");return $i.text(Oe,me)}constructor(K,me){this.data=K,this.mime=me;const Oe=(0,O.$ct)(me,!0);if(!Oe)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Oe}}e.$hP=$i;class Wi{static isNotebookCellOutput(K){return K instanceof Wi?!0:!K||typeof K!="object"?!1:typeof K.id=="string"&&Array.isArray(K.items)}static ensureUniqueMimeTypes(K,me=!1){const Oe=new Set,Ye=new Set;for(let ot=0;ot<K.length;ot++){const $t=K[ot],yt=(0,O.$ct)($t.mime);if(!Oe.has(yt)||(0,w.$ML)(yt)){Oe.add(yt);continue}Ye.add(ot),me&&console.warn(`DUPLICATED mime type '${$t.mime}' will be dropped`)}return Ye.size===0?K:K.filter((ot,$t)=>!Ye.has($t))}constructor(K,me,Oe){this.items=Wi.ensureUniqueMimeTypes(K,!0),typeof me=="string"?(this.id=me,this.metadata=Oe):(this.id=(0,I.$2g)(),this.metadata=me??Oe)}}e.$iP=Wi;var hn;(function(Z){Z[Z.Markup=1]="Markup",Z[Z.Code=2]="Code"})(hn||(e.NotebookCellKind=hn={}));var xi;(function(Z){Z[Z.Idle=1]="Idle",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(xi||(e.NotebookCellExecutionState=xi={}));var dn;(function(Z){Z[Z.Left=1]="Left",Z[Z.Right=2]="Right"})(dn||(e.NotebookCellStatusBarAlignment=dn={}));var fn;(function(Z){Z[Z.Default=0]="Default",Z[Z.InCenter=1]="InCenter",Z[Z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Z[Z.AtTop=3]="AtTop"})(fn||(e.NotebookEditorRevealType=fn={}));class kn{constructor(K,me){this.text=K,this.alignment=me}}e.$jP=kn;var gn;(function(Z){Z[Z.Default=1]="Default",Z[Z.Preferred=2]="Preferred"})(gn||(e.NotebookControllerAffinity=gn={}));var mn;(function(Z){Z[Z.Default=1]="Default",Z[Z.Preferred=2]="Preferred",Z[Z.Hidden=-1]="Hidden"})(mn||(e.NotebookControllerAffinity2=mn={}));class In{constructor(K,me=[]){this.uri=K,this.provides=(0,r.$1b)(me)}}e.$kP=In;class Pn{constructor(K){this.label=K}}e.$lP=Pn;var $n;(function(Z){Z[Z.Named=1]="Named",Z[Z.Indexed=2]="Indexed"})($n||(e.NotebookVariablesRequestKind=$n={}));let _i=class{constructor(K,me){this.label=K,this.timestamp=me}};e.$mP=_i,e.$mP=_i=Je([b],_i);var pn;(function(Z){Z[Z.Production=1]="Production",Z[Z.Development=2]="Development",Z[Z.Test=3]="Test"})(pn||(e.ExtensionMode=pn={}));var bn;(function(Z){Z[Z.Node=1]="Node",Z[Z.Webworker=2]="Webworker"})(bn||(e.ExtensionRuntime=bn={}));var fe;(function(Z){Z[Z.Other=0]="Other",Z[Z.Comment=1]="Comment",Z[Z.String=2]="String",Z[Z.RegEx=3]="RegEx"})(fe||(e.StandardTokenType=fe={}));class be{constructor(K,me){this.ranges=K,this.wordPattern=me}}e.$nP=be;class Ue{constructor(K){this.c=K}get autoForwardAction(){return this.c}}e.$oP=Ue;var ht;(function(Z){Z[Z.Queued=1]="Queued",Z[Z.Running=2]="Running",Z[Z.Passed=3]="Passed",Z[Z.Failed=4]="Failed",Z[Z.Skipped=5]="Skipped",Z[Z.Errored=6]="Errored"})(ht||(e.TestResultState=ht={}));var Et;(function(Z){Z[Z.Run=1]="Run",Z[Z.Debug=2]="Debug",Z[Z.Coverage=3]="Coverage"})(Et||(e.TestRunProfileKind=Et={}));let Lt=class{constructor(K=void 0,me=void 0,Oe=void 0,Ye=!1,ot=!0){this.include=K,this.exclude=me,this.profile=Oe,this.continuous=Ye,this.preserveFocus=ot}};e.$pP=Lt,e.$pP=Lt=Je([b],Lt);let gi=A=class{static diff(K,me,Oe){const Ye=new A(K);return Ye.expectedOutput=me,Ye.actualOutput=Oe,Ye}constructor(K){this.message=K}};e.$qP=gi,e.$qP=gi=A=Je([b],gi);let Fi=class{constructor(K){this.id=K}};e.$rP=Fi,e.$rP=Fi=Je([b],Fi);class en{constructor(K,me,Oe){this.label=K,this.file=me,this.position=Oe}}e.$sP=en;class wn{constructor(K,me){this.covered=K,this.total=me,An(this)}}e.$tP=wn;function An(Z){if(Z){if(Z.covered>Z.total)throw new Error(`The total number of covered items (${Z.covered}) cannot be greater than the total (${Z.total})`);if(Z.total<0)throw new Error(`The number of covered items (${Z.total}) cannot be negative`)}}class Cn{static fromDetails(K,me){const Oe=new wn(0,0),Ye=new wn(0,0),ot=new wn(0,0);for(const yt of me)if("branches"in yt){Oe.total+=1,Oe.covered+=yt.executed?1:0;for(const Yt of yt.branches)Ye.total+=1,Ye.covered+=Yt.executed?1:0}else ot.total+=1,ot.covered+=yt.executed?1:0;const $t=new Cn(K,Oe,Ye.total>0?Ye:void 0,ot.total>0?ot:void 0);return $t.detailedCoverage=me,$t}constructor(K,me,Oe,Ye,ot=[]){this.uri=K,this.statementCoverage=me,this.branchCoverage=Oe,this.declarationCoverage=Ye,this.fromTests=ot}}e.$vP=Cn;class Qn{get executionCount(){return+this.executed}set executionCount(K){this.executed=K}constructor(K,me,Oe=[]){this.executed=K,this.location=me,this.branches=Oe}}e.$wP=Qn;class Jn{get executionCount(){return+this.executed}set executionCount(K){this.executed=K}constructor(K,me,Oe){this.executed=K,this.location=me,this.label=Oe}}e.$xP=Jn;class Xn{get executionCount(){return+this.executed}set executionCount(K){this.executed=K}constructor(K,me,Oe){this.name=K,this.executed=me,this.location=Oe}}e.$yP=Xn;var Rn;(function(Z){Z[Z.None=0]="None",Z[Z.Option=1]="Option",Z[Z.Default=2]="Default",Z[Z.Preferred=3]="Preferred"})(Rn||(e.ExternalUriOpenerPriority=Rn={}));var Tn;(function(Z){Z[Z.Untrusted=0]="Untrusted",Z[Z.Trusted=1]="Trusted",Z[Z.Unspecified=2]="Unspecified"})(Tn||(e.WorkspaceTrustState=Tn={}));var On;(function(Z){Z[Z.Notify=1]="Notify",Z[Z.OpenBrowser=2]="OpenBrowser",Z[Z.OpenPreview=3]="OpenPreview",Z[Z.Silent=4]="Silent",Z[Z.Ignore=5]="Ignore",Z[Z.OpenBrowserOnce=6]="OpenBrowserOnce"})(On||(e.PortAutoForwardAction=On={}));class Yn{constructor(K,me,Oe,Ye,ot,$t){this.kind=K,this.name=me,this.detail=Oe,this.uri=Ye,this.range=ot,this.selectionRange=$t}}e.$zP=Yn;class xn{constructor(K){this.uri=K}}e.$AP=xn;class _n{constructor(K,me){this.original=K,this.modified=me}}e.$BP=_n;class er{constructor(K,me,Oe,Ye){this.base=K,this.input1=me,this.input2=Oe,this.result=Ye}}e.$CP=er;class tr{constructor(K,me){this.uri=K,this.viewType=me}}e.$DP=tr;class ir{constructor(K){this.viewType=K}}e.$EP=ir;class nr{constructor(K,me){this.uri=K,this.notebookType=me}}e.$FP=nr;class rr{constructor(K,me,Oe){this.original=K,this.modified=me,this.notebookType=Oe}}e.$GP=rr;class sr{constructor(){}}e.$HP=sr;class or{constructor(K,me){this.uri=K,this.inputBoxUri=me}}e.$IP=or;class ar{constructor(){}}e.$JP=ar;class cr{constructor(K){this.textDiffs=K}}e.$KP=cr;var Ln;(function(Z){Z[Z.Down=0]="Down",Z[Z.Up=1]="Up"})(Ln||(e.InteractiveSessionVoteDirection=Ln={}));var Nn;(function(Z){Z[Z.Action=1]="Action",Z[Z.Toolbar=2]="Toolbar"})(Nn||(e.ChatCopyKind=Nn={}));var Fn;(function(Z){Z[Z.Short=1]="Short",Z[Z.Medium=2]="Medium",Z[Z.Full=3]="Full"})(Fn||(e.ChatVariableLevel=Fn={}));class lr{constructor(K,me,Oe){this.id=K,this.label=me,this.values=Oe}}e.$LP=lr;var Mn;(function(Z){Z[Z.Unhelpful=0]="Unhelpful",Z[Z.Helpful=1]="Helpful",Z[Z.Undone=2]="Undone",Z[Z.Accepted=3]="Accepted",Z[Z.Bug=4]="Bug"})(Mn||(e.InteractiveEditorResponseFeedbackKind=Mn={}));var jn;(function(Z){Z[Z.Unhelpful=0]="Unhelpful",Z[Z.Helpful=1]="Helpful"})(jn||(e.ChatResultFeedbackKind=jn={}));class ur{constructor(K){if(typeof K!="string"&&K.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof K=="string"?new nt(K):K}}e.$MP=ur;class hr{constructor(K,me){if(typeof K!="string"&&K.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof K=="string"?new nt(K):K,this.vulnerabilities=me}}e.$NP=hr;class dr{constructor(K,me){this.participant=K,this.command=me}}e.$OP=dr;class fr{constructor(K,me,Oe,Ye){this.title=K,this.message=me,this.data=Oe,this.buttons=Ye}}e.$PP=fr;class gr{constructor(K,me){this.value=K,this.baseUri=me}}e.$QP=gr;class mr{constructor(K,me){this.value=K,this.title=me}}e.$RP=mr;class $r{constructor(K){this.value=K}}e.$SP=$r;class pr{constructor(K,me){this.value=K,this.task=me}}e.$TP=pr;class br{constructor(K){if(typeof K!="string"&&K.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof K=="string"?new nt(K):K}}e.$UP=br;class wr{constructor(K){this.value=K}}e.$VP=wr;class vr{constructor(K,me,Oe){this.value=K,this.iconPath=me,this.options=Oe}}e.$WP=vr;class Er{constructor(K,me,Oe){this.value=K,this.license=me,this.snippet=Oe}}e.$XP=Er;class yr{constructor(K,me){this.uri=K,this.edits=Array.isArray(me)?me:[me]}}e.$YP=yr;class Sr{constructor(K,me,Oe,Ye){this.prompt=K,this.command=me,this.references=Oe,this.participant=Ye}}e.$ZP=Sr;class Dr{constructor(K,me,Oe,Ye){this.response=K,this.result=me,this.participant=Oe,this.command=Ye}}e.$1P=Dr;var zn;(function(Z){Z[Z.Panel=1]="Panel",Z[Z.Terminal=2]="Terminal",Z[Z.Notebook=3]="Notebook",Z[Z.Editor=4]="Editor"})(zn||(e.ChatLocation=zn={}));var Bn;(function(Z){Z[Z.Complete=1]="Complete",Z[Z.Partial=2]="Partial",Z[Z.Omitted=3]="Omitted"})(Bn||(e.ChatResponseReferencePartStatusKind=Bn={}));class kr{constructor(K,me,Oe){this.document=K,this.selection=me,this.wholeRange=Oe}}e.$2P=kr;class Ir{constructor(K){this.cell=K}}e.$3P=Ir;var vn;(function(Z){Z[Z.User=1]="User",Z[Z.Assistant=2]="Assistant",Z[Z.System=3]="System"})(vn||(e.LanguageModelChatMessageRole=vn={}));class Pr{constructor(K,me,Oe){this.name=K,this.content=me,this.isError=Oe??!1}}e.$4P=Pr;class En{static User(K,me){const Oe=new En(vn.User,typeof K=="string"?K:"",me);return Oe.content2=K,Oe}static Assistant(K,me){return new En(vn.Assistant,K,me)}constructor(K,me,Oe){this.role=K,this.content=me,this.content2=me,this.name=Oe}}e.$5P=En;class Cr{constructor(K,me){this.name=K,this.parameters=me}}e.$6P=Cr;class Ar{constructor(K){this.value=K}}e.$7P=Ar;class Rr{constructor(K){this.content=K}}e.$8P=Rr;class Tr{constructor(K,me){this.content=K,this.name=me}}e.$9P=Tr;class Or{constructor(K,me){this.content=K,this.name=me}}e.$0P=Or;class Oi extends Error{static NotFound(K){return new Oi(K,Oi.NotFound.name)}static NoPermissions(K){return new Oi(K,Oi.NoPermissions.name)}static Blocked(K){return new Oi(K,Oi.Blocked.name)}constructor(K,me,Oe){super(K,{cause:Oe}),this.name="LanguageModelError",this.code=me??""}}e.$$P=Oi;var Un;(function(Z){Z[Z.SymbolInformation=1]="SymbolInformation",Z[Z.CommandInformation=2]="CommandInformation",Z[Z.SearchInformation=3]="SearchInformation",Z[Z.SettingInformation=4]="SettingInformation"})(Un||(e.RelatedInformationType=Un={}));var Wn;(function(Z){Z[Z.Started=1]="Started",Z[Z.Recognizing=2]="Recognizing",Z[Z.Recognized=3]="Recognized",Z[Z.Stopped=4]="Stopped",Z[Z.Error=5]="Error"})(Wn||(e.SpeechToTextStatus=Wn={}));var qn;(function(Z){Z[Z.Started=1]="Started",Z[Z.Stopped=2]="Stopped",Z[Z.Error=3]="Error"})(qn||(e.TextToSpeechStatus=qn={}));var Vn;(function(Z){Z[Z.Recognized=1]="Recognized",Z[Z.Stopped=2]="Stopped"})(Vn||(e.KeywordRecognitionStatus=Vn={}));class Lr{constructor(K,me){this.text=K,this.range=me}}e.$_P=Lr;var Hn;(function(Z){Z[Z.Invoke=0]="Invoke",Z[Z.Automatic=1]="Automatic"})(Hn||(e.InlineEditTriggerKind=Hn={}))}),define(ke[290],Ie([1,0,6,9]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rpc=void 0;class C{constructor(O){this.a=new Map,this.b=0,this.c=O.getProxy(r.$KN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(O,T,p){if(this.a.size===0)throw new Error("No related information providers registered");const c=this.a.get(O);if(!c)throw new Error("related information provider not found");return await c.provideRelatedInformation(T,p)??[]}getRelatedInformation(O,T,p){return this.c.$getAiRelatedInformation(T,p)}registerRelatedInformationProvider(O,T,p){const c=this.b;return this.b++,this.a.set(c,p),this.c.$registerAiRelatedInformationProvider(c,T),new h.$MN(()=>{this.c.$unregisterAiRelatedInformationProvider(c),this.a.delete(c)})}}e.$rpc=C}),define(ke[127],Ie([1,0,4,6,9,23,156,5,19]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dpc=e.$Cpc=void 0,e.$Cpc=(0,T.$Fi)("IExtHostAuthentication");let c=class{constructor(u){this.b=new Map,this.c=new r.$le,this.onDidChangeSessions=this.c.event,this.d=new I,this.a=u.getProxy(h.$KN.MainThreadAuthentication)}async getSession(u,P,w,a={}){const m=R.$rn.toKey(u.identifier),$=[...w].sort().join(" ");return await this.d.getOrCreate(`${m} ${P} ${$}`,async()=>{await this.a.$ensureProvider(P);const f=u.displayName||u.name;return this.a.$getSession(P,w,m,f,a)})}async getAccounts(u){return await this.a.$ensureProvider(u),await this.a.$getAccounts(u)}async removeSession(u,P){const w=this.b.get(u);return w?w.provider.removeSession(P):this.a.$removeSession(u,P)}registerAuthenticationProvider(u,P,w,a){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:P,provider:w,options:a??{supportsMultipleAccounts:!1}});const m=w.onDidChangeSessions($=>this.a.$sendDidChangeSessions(u,$));return this.a.$registerAuthenticationProvider(u,P,a?.supportsMultipleAccounts??!1),new C.$MN(()=>{m.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,P,w){const a=this.b.get(u);if(a)return await a.provider.createSession(P,w);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,P){const w=this.b.get(u);if(w)return await w.provider.removeSession(P);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,P,w){const a=this.b.get(u);if(a)return await a.provider.getSessions(P,w);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,P){return u.startsWith(O.$MM)||this.c.fire({provider:{id:u,label:P}}),Promise.resolve()}};e.$Dpc=c,e.$Dpc=c=Je([Ve(0,p.$kQ)],c);class I{constructor(){this.a=new Map}getOrCreate(u,P){const w=this.a.get(u);if(w)return w;const a=P().finally(()=>this.a.delete(u));return this.a.set(u,a),a}}}),define(ke[163],Ie([1,0,2,6,9,5,19,11,18,12,16,25]),function($e,e,r,h,C,R,O,T,p,c,I,S){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Iqc=e.$Hqc=void 0;let P=class{static{u=this}static{this.c=0}static{this.d=250}constructor(a,m){this.h=m,this.f=new Map,this.g=a.getProxy(h.$KN.MainThreadDecorations)}registerFileDecorationProvider(a,m){const $=u.c++;this.f.set($,{provider:a,extensionDescription:m}),this.g.$registerDecorationProvider($,m.identifier.value);const f=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange($,null);return}const s=(0,p.$1b)(i);if(s.length<=u.d){this.g.$onDidChange($,s);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,s.length);const t=s.map(d=>({uri:d,rank:(0,c.$if)(d.path,"/")})),o=(0,p.$yb)(t,(d,l)=>d.rank-l.rank||(0,c.$yf)(d.uri.path,l.uri.path)),n=[];e:for(const d of o){let l;for(const g of d){const E=(0,I.$mc)(g.uri.path);if(l!==E&&(l=E,n.push(g.uri)>=u.d))break e}}this.g.$onDidChange($,n)});return new C.$MN(()=>{f?.dispose(),this.g.$unregisterDecorationProvider($),this.f.delete($)})}async $provideDecorations(a,m,$){if(!this.f.has(a))return Object.create(null);const f=Object.create(null),{provider:i,extensionDescription:s}=this.f.get(a);return await Promise.all(m.map(async t=>{try{const{uri:o,id:n}=t,d=await Promise.resolve(i.provideFileDecoration(r.URI.revive(o),$));if(!d)return;try{C.$cP.validate(d),d.badge&&typeof d.badge!="string"&&(0,S.$gH)(s,"codiconDecoration"),f[n]=[d.propagate,d.tooltip,d.badge,d.color]}catch(l){this.h.warn(`INVALID decoration from extension '${s.identifier.value}': ${l}`)}}catch(o){this.h.error(o)}})),f}};e.$Hqc=P,e.$Hqc=P=u=Je([Ve(0,O.$kQ),Ve(1,T.$ak)],P),e.$Iqc=(0,R.$Fi)("IExtHostDecorations")}),define(ke[291],Ie([1,0,13,2,9,6,14,20,12]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kqc=void 0;class c{static{this.a=0}constructor(S,u,P){this.d=u,this.e=P,this.b=new Map,this.c=S.getProxy(R.$KN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,u){if(Object.keys(O.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const P=c.a++;this.b.set(P,u),this.c.$registerTextContentProvider(P,S);let w;if(typeof u.onDidChange=="function"){let a;w=u.onDidChange(async m=>{if(m.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;a&&await a;const $=this.$provideTextDocumentContent(P,m).then(async f=>{if(!f&&typeof f!="string")return;const i=this.d.getDocument(m);if(!i)return;const s=(0,p.$sf)(f);if(!i.equalLines(s))return this.c.$onVirtualDocumentChange(m,f)}).catch(r.$Y).finally(()=>{a===$&&(a=void 0)});a=$})}return new C.$MN(()=>{this.b.delete(P)&&this.c.$unregisterTextContentProvider(P),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(S,u){const P=this.b.get(S);return P?Promise.resolve(P.provideTextDocumentContent(h.URI.revive(u),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Kqc=c}),define(ke[164],Ie([1,0,65,14,12,206,140,9,18]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=e.$nQ=void 0,e.$mQ=I;const c=new Map;function I(w,a){a?c.set(w,a):c.delete(w)}function S(w){return c.get(w)}class u extends R.$pw{constructor(a,m,$,f,i,s,t){super(m,$,f,i),this.c=a,this.m=s,this.q=t,this.b=!1}dispose(){(0,r.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,p.$tb)(this.f,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.d},get fileName(){return a.d.fsPath},get isUntitled(){return a.d.scheme===h.Schemas.untitled},get languageId(){return a.m},get version(){return a.h},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(m){return m?a.s(m):a.getText()},get eol(){return a.g===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return a.f.length},lineAt(m){return a.t(m)},offsetAt(m){return a.u(m)},positionAt(m){return a.v(m)},validateRange(m){return a.w(m)},validatePosition(m){return a.x(m)},getWordRangeAtPosition(m,$){return a.y(m,$)},[Symbol.for("debug.description")](){return`TextDocument(${a.d.toString()})`}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,r.ok)(!this.b),this.m=a}_acceptIsDirty(a){(0,r.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(a){const m=this.w(a);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const $=this.g,f=m.start.line,i=m.end.line,s=[];s.push(this.f[f].substring(m.start.character));for(let t=f+1;t<i;t++)s.push(this.f[t]);return s.push(this.f[i].substring(0,m.end.character)),s.join($)}t(a){let m;if(a instanceof T.$NN?m=a.line:typeof a=="number"&&(m=a),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new P(m,this.f[m],m===this.f.length-1)}u(a){return a=this.x(a),this.l(),this.j.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.l();const m=this.j.getIndexOf(a),$=this.f[m.index].length;return new T.$NN(m.index,Math.min(m.remainder,$))}w(a){if(!(a instanceof T.$ON))throw new Error("Invalid argument");const m=this.x(a.start),$=this.x(a.end);return m===a.start&&$===a.end?a:new T.$ON(m.line,m.character,$.line,$.character)}x(a){if(!(a instanceof T.$NN))throw new Error("Invalid argument");if(this.f.length===0)return a.with(0,0);let{line:m,character:$}=a,f=!1;if(m<0)m=0,$=0,f=!0;else if(m>=this.f.length)m=this.f.length-1,$=this.f[m].length,f=!0;else{const i=this.f[m].length;$<0?($=0,f=!0):$>i&&($=i,f=!0)}return f?new T.$NN(m,$):a}y(a,m){const $=this.x(a);if(!m)m=S(this.m);else if((0,C.$rf)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const f=(0,O.$qt)($.character+1,(0,O.$ot)(m),this.f[$.line],0);if(f)return new T.$ON($.line,f.startColumn-1,$.line,f.endColumn-1)}}e.$nQ=u;class P{constructor(a,m,$){this.a=a,this.b=m,this.c=$}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.$ON(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.$ON(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$oQ=P}),define(ke[292],Ie([1,0,6,9]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nqc=void 0;class C{constructor(O){this.a=new Map,this.b=0,this.c=O.getProxy(r.$KN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(O,T,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const c=this.a.get(O);if(!c)throw new Error("Embedding vector provider not found");const I=await c.provideEmbeddingVector(T,p);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(O,T,p){const c=this.b;return this.b++,this.a.set(c,p),this.c.$registerAiEmbeddingVectorProvider(T,c),new h.$MN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(c),this.a.delete(c)})}}e.$Nqc=C}),define(ke[75],Ie([1,0,6,27,9,21,5,19,62,3,7,22,14]),function($e,e,r,h,C,R,O,T,p,c,I,S,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tpc=e.$Spc=void 0,h=qe(h);let w=P=class{constructor(m,$){this.b=new Map,this.c=new I.$Oh,this.a=m.getProxy(r.$KN.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(i){try{let s;const t=f.b.get(i.scheme);return t?(await f.a.$ensureActivation(i.scheme),s=await t.impl.stat(i)):s=await f.a.$stat(i),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===h.FilePermission.Readonly?1:void 0}}catch(s){P.e(s)}},async readDirectory(i){try{const s=f.b.get(i.scheme);return s?(await f.a.$ensureActivation(i.scheme),(await s.impl.readDirectory(i)).slice()):await f.a.$readdir(i)}catch(s){return P.e(s)}},async createDirectory(i){try{const s=f.b.get(i.scheme);return s&&!s.isReadonly?(await f.a.$ensureActivation(i.scheme),await f.d(s.impl,s.extUri,i)):await f.a.$mkdir(i)}catch(s){return P.e(s)}},async readFile(i){try{const s=f.b.get(i.scheme);return s?(await f.a.$ensureActivation(i.scheme),(await s.impl.readFile(i)).slice()):(await f.a.$readFile(i)).buffer}catch(s){return P.e(s)}},async writeFile(i,s){try{const t=f.b.get(i.scheme);return t&&!t.isReadonly?(await f.a.$ensureActivation(i.scheme),await f.d(t.impl,t.extUri,t.extUri.dirname(i)),await f.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,s,{create:!0,overwrite:!0})))):await f.a.$writeFile(i,R.$Ne.wrap(s))}catch(t){return P.e(t)}},async delete(i,s){try{const t=f.b.get(i.scheme);return t&&!t.isReadonly&&!s?.useTrash?(await f.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...s})):await f.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(t){return P.e(t)}},async rename(i,s,t){try{return await f.a.$rename(i,s,{overwrite:!1,...t})}catch(o){return P.e(o)}},async copy(i,s,t){try{return await f.a.$copy(i,s,{overwrite:!1,...t})}catch(o){return P.e(o)}},isWritableFileSystem(i){const s=$.getCapabilities(i);if(typeof s=="number")return!(s&h.FileSystemProviderCapabilities.Readonly)}})}async d(m,$,f){const i=[];for(;!$.isEqual(f,$.dirname(f));)try{if(!((await m.stat(f)).type&h.FileType.Directory))throw C.$6O.FileExists(`Unable to create folder '${f.scheme===u.Schemas.file?f.fsPath:f.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(h.$ql(s)!==h.FileSystemProviderErrorCode.FileNotFound)throw s;i.push($.basename(f)),f=$.dirname(f)}for(let s=i.length-1;s>=0;s--){f=$.joinPath(f,i[s]);try{await m.createDirectory(f)}catch(t){if(h.$ql(t)!==h.FileSystemProviderErrorCode.FileExists)throw t}}}static e(m){if(m instanceof C.$6O)throw m;if(m instanceof h.$ml)switch(m.code){case h.FileSystemProviderErrorCode.FileExists:throw C.$6O.FileExists(m.message);case h.FileSystemProviderErrorCode.FileNotFound:throw C.$6O.FileNotFound(m.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw C.$6O.FileNotADirectory(m.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw C.$6O.FileIsADirectory(m.message);case h.FileSystemProviderErrorCode.NoPermissions:throw C.$6O.NoPermissions(m.message);case h.FileSystemProviderErrorCode.Unavailable:throw C.$6O.Unavailable(m.message);default:throw new C.$6O(m.message,m.name)}if(!(m instanceof Error))throw new C.$6O(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw C.$6O.Unavailable(m.message);switch(m.name){case h.FileSystemProviderErrorCode.FileExists:throw C.$6O.FileExists(m.message);case h.FileSystemProviderErrorCode.FileNotFound:throw C.$6O.FileNotFound(m.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw C.$6O.FileNotADirectory(m.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw C.$6O.FileIsADirectory(m.message);case h.FileSystemProviderErrorCode.NoPermissions:throw C.$6O.NoPermissions(m.message);case h.FileSystemProviderErrorCode.Unavailable:throw C.$6O.Unavailable(m.message);default:throw new C.$6O(m.message,m.name)}}addFileSystemProvider(m,$,f){return this.b.set(m,{impl:$,extUri:f?.isCaseSensitive?S.$9g:S.$$g,isReadonly:!!f?.isReadonly}),(0,c.$Sc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??S.$9g}};e.$Spc=w,e.$Spc=w=P=Je([Ve(0,T.$kQ),Ve(1,p.$wpc)],w),e.$Tpc=(0,O.$Fi)("IExtHostConsumerFileSystem")}),define(ke[97],Ie([1,0,5,29,11,75,2]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vpc=e.$Upc=void 0,e.$Upc=(0,r.$Fi)("IExtensionStoragePaths");let T=class{constructor(c,I,S){this.d=I,this.f=S,this.a=c.workspace??void 0,this.b=c.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(c){return O.URI.joinPath(this.b.workspaceStorageHome,c)}async h(){if(!this.a)return Promise.resolve(void 0);const c=this.a.id,I=await this.g(c);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(O.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:O.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(c){if(this.c)return O.URI.joinPath(this.c,c.identifier.value)}globalValue(c){return O.URI.joinPath(this.b.globalStorageHome,c.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Vpc=T,e.$Vpc=T=Je([Ve(0,h.$AQ),Ve(1,C.$ak),Ve(2,R.$Tpc)],T)}),define(ke[293],Ie([1,0,9,19,4]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$src=void 0;let R=class{constructor(T){this.a=new r.$dP(r.ColorThemeKind.Dark),this.b=new C.$le}get activeColorTheme(){return this.a}$onColorThemeChange(T){let p;switch(T){case"light":p=r.ColorThemeKind.Light;break;case"hcDark":p=r.ColorThemeKind.HighContrast;break;case"hcLight":p=r.ColorThemeKind.HighContrastLight;break;default:p=r.ColorThemeKind.Dark}this.a=new r.$dP(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$src=R,e.$src=R=Je([Ve(0,h.$kQ)],R)}),define(ke[76],Ie([1,0,20,4,3,8,5,11,92,6,29,19,9]),function($e,e,r,h,C,R,O,T,p,c,I,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kGb=e.$jGb=e.TunnelDtoConverter=void 0,R=qe(R),u=qe(u);class P extends p.$Ow{}var w;(function(m){function $(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:i.protocol}}m.fromApiTunnel=$;function f(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==p.TunnelPrivacyId.ConstantPrivate&&i.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}m.fromServiceTunnel=f})(w||(e.TunnelDtoConverter=w={})),e.$jGb=(0,O.$Fi)("IExtHostTunnelService");let a=class extends C.$Uc{constructor($,f,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new h.$le,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=$.getProxy(c.$KN.MainThreadTunnelService)}async openTunnel($,f){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${$.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const i=await this.a.$openTunnel(f,$.displayName);if(i){const s=new P(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(s),s}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider($,f){$.portRange===void 0&&$.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:$,provider:f}),this.a.$registerPortsAttributesProvider($,i),new u.$MN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes($,f,i,s,t){const o=[];for(const d of $){const l=this.r.get(d);if(!l)return[];o.push(...await Promise.all(f.map(async g=>{let E;try{E=await l.provider.providePortAttributes({port:g,pid:i,commandLine:s},t)}catch{E=await l.provider.providePortAttributes(g,i,s,t)}return{providedAttributes:E,port:g}})))}const n=o.filter(d=>!!d.providedAttributes);return n.length>0?n.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder($){}registerTunnelProvider($,f){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(s,t)=>await $.provideTunnel(s,t,r.CancellationToken.None)??void 0;const i=f.tunnelFeatures?{elevation:!!f.tunnelFeatures?.elevation,privacyOptions:f.tunnelFeatures?.privacyOptions,protocol:f.tunnelFeatures.protocol===void 0?!0:f.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,C.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory($,f){if($){$.candidatePortSource!==void 0&&this.a.$setCandidatePortSource($.candidatePortSource),$.showCandidatePort&&(this.f=$.showCandidatePort,this.a.$setCandidateFilter());const i=$.tunnelFactory??(f?this.w(f):void 0);if(i){this.b=i;let s=$.tunnelFeatures?.privacyOptions??[];$.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:R.localize(10821,null),themeIcon:"lock"},{id:"public",label:R.localize(10822,null),themeIcon:"eye"}]);const t=$.tunnelFeatures?{elevation:!!$.tunnelFeatures?.elevation,public:!!$.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,C.$Sc)(()=>{this.b=void 0})}w($){}async $closeTunnel($,f){if(this.g.has($.host)){const i=this.g.get($.host);i.has($.port)&&(f&&i.get($.port).disposeListener.dispose(),await i.get($.port).tunnel.dispose(),i.delete($.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort($,f){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b($,f);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const s=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has($.remoteAddress.host)||this.g.set($.remoteAddress.host,new Map);const t=this.B(s.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(s.remoteAddress))));return this.g.get($.remoteAddress.host).set($.remoteAddress.port,{tunnel:s,disposeListener:t}),w.fromApiTunnel(s)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter($){const f=await Promise.all($.map(s=>this.f(s.host,s.port,s.detail??""))),i=$.filter((s,t)=>f[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${$.map(s=>s.port).join(", ")} to ${i.map(s=>s.port).join(", ")}`),i}};e.$kGb=a,e.$kGb=a=Je([Ve(0,S.$kQ),Ve(1,I.$AQ),Ve(2,T.$ak)],a)}),define(ke[15],Ie([1,0,18,21,190,79,85,28,178,44,103,24,183,22,51,17,2,113,30,110,87,58,145,89,155,152,153,271,119,126,73,74,268,9]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l,g,E,D,y,k,A,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$hQ=_,e.$iQ=ne,e.$jQ=ye,O=qe(O),f=qe(f),i=qe(i),s=qe(s),E=qe(E),y=qe(y),v=qe(v);var F;(function(Te){function Me(ie){const{selectionStartLineNumber:Ae,selectionStartColumn:Ge,positionLineNumber:_e,positionColumn:Qe}=ie,ft=new v.$NN(Ae-1,Ge-1),Rt=new v.$NN(_e-1,Qe-1);return new v.$PN(ft,Rt)}Te.to=Me;function Se(ie){const{anchor:Ae,active:Ge}=ie;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Ge.line+1,positionColumn:Ge.character+1}}Te.from=Se})(F||(e.Selection=F={}));var N;(function(Te){function Me(ie){if(!ie)return;const{start:Ae,end:Ge}=ie;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Ge.line+1,endColumn:Ge.character+1}}Te.from=Me;function Se(ie){if(!ie)return;const{startLineNumber:Ae,startColumn:Ge,endLineNumber:_e,endColumn:Qe}=ie;return new v.$ON(Ae-1,Ge-1,_e-1,Qe-1)}Te.to=Se})(N||(e.Range=N={}));var L;(function(Te){function Me(ie){return{uri:ie.uri,range:N.from(ie.range)}}Te.from=Me;function Se(ie){return new v.$1N(m.URI.revive(ie.uri),N.to(ie.range))}Te.to=Se})(L||(e.Location=L={}));var M;(function(Te){function Me(Se){switch(Se){case i.StandardTokenType.Comment:return v.StandardTokenType.Comment;case i.StandardTokenType.Other:return v.StandardTokenType.Other;case i.StandardTokenType.RegEx:return v.StandardTokenType.RegEx;case i.StandardTokenType.String:return v.StandardTokenType.String}}Te.to=Me})(M||(e.TokenType=M={}));var z;(function(Te){function Me(ie){return new v.$NN(ie.lineNumber-1,ie.column-1)}Te.to=Me;function Se(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Te.from=Se})(z||(e.Position=z={}));var j;(function(Te){function Me(Ae,Ge,_e){return(0,r.$Gb)((0,r.$1b)(Ae).map(Qe=>Se(Qe,Ge,_e)))}Te.from=Me;function Se(Ae,Ge,_e){if(typeof Ae=="string")return{$serialized:!0,language:Ae,isBuiltin:_e?.isBuiltin};if(Ae)return{$serialized:!0,language:Ae.language,scheme:ie(Ae.scheme,Ge),pattern:tt.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType,isBuiltin:_e?.isBuiltin}}function ie(Ae,Ge){return Ge&&typeof Ae=="string"?Ge.transformOutgoingScheme(Ae):Ae}})(j||(e.DocumentSelector=j={}));var W;(function(Te){function Me(ie){switch(ie){case v.DiagnosticTag.Unnecessary:return o.MarkerTag.Unnecessary;case v.DiagnosticTag.Deprecated:return o.MarkerTag.Deprecated}}Te.from=Me;function Se(ie){switch(ie){case o.MarkerTag.Unnecessary:return v.DiagnosticTag.Unnecessary;case o.MarkerTag.Deprecated:return v.DiagnosticTag.Deprecated;default:return}}Te.to=Se})(W||(e.DiagnosticTag=W={}));var B;(function(Te){function Me(ie){let Ae;return ie.code&&((0,a.$eg)(ie.code)||(0,a.$ig)(ie.code)?Ae=String(ie.code):Ae={value:String(ie.code.value),target:ie.code.target}),{...N.from(ie.range),message:ie.message,source:ie.source,code:Ae,severity:H.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(ee.from),tags:Array.isArray(ie.tags)?(0,r.$Gb)(ie.tags.map(W.from)):void 0}}Te.from=Me;function Se(ie){const Ae=new v.$3N(N.to(ie),ie.message,H.to(ie.severity));return Ae.source=ie.source,Ae.code=(0,a.$eg)(ie.code)?ie.code:ie.code?.value,Ae.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(ee.to),Ae.tags=ie.tags&&(0,r.$Gb)(ie.tags.map(W.to)),Ae}Te.to=Se})(B||(e.Diagnostic=B={}));var ee;(function(Te){function Me(ie){return{...N.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Te.from=Me;function Se(ie){return new v.$2N(new v.$1N(ie.resource,N.to(ie)),ie.message)}Te.to=Se})(ee||(e.DiagnosticRelatedInformation=ee={}));var H;(function(Te){function Me(ie){switch(ie){case v.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Te.from=Me;function Se(ie){switch(ie){case o.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}Te.to=Se})(H||(e.DiagnosticSeverity=H={}));var q;(function(Te){function Me(ie){return typeof ie=="number"&&ie>=v.ViewColumn.One?ie-1:ie===v.ViewColumn.Beside?b.$zE:b.$yE}Te.from=Me;function Se(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Te.to=Se})(q||(e.ViewColumn=q={}));function Q(Te){return typeof Te.range<"u"}function _(Te){return Te.length===0?!0:!!Q(Te[0])}var ce;(function(Te){function Me(Qe){return Qe.map(Te.from)}Te.fromMany=Me;function Se(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function ie(Qe){let ft;if(Se(Qe)){const{language:zt,value:_t}=Qe;ft={value:"```"+zt+`
`+_t+"\n```\n"}}else v.$eO.isMarkdownString(Qe)?ft={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?ft={value:Qe}:ft={value:""};const Rt=Object.create(null);ft.uris=Rt;const Xt=zt=>{try{let _t=m.URI.parse(zt,!0);_t=_t.with({query:Ae(_t.query,Rt)}),Rt[zt]=_t}catch{}return""},si=new p.marked.Renderer;return si.link=Xt,si.image=zt=>typeof zt=="string"?Xt(O.$_k(zt).href):"",(0,p.marked)(ft.value,{renderer:si}),ft}Te.from=ie;function Ae(Qe,ft){if(!Qe)return Qe;let Rt;try{Rt=(0,c.$bi)(Qe)}catch{}if(!Rt)return Qe;let Xt=!1;return Rt=(0,S.$go)(Rt,si=>{if(m.URI.isUri(si)){const zt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[zt]=si,Xt=!0,zt}else return}),Xt?JSON.stringify(Rt):Qe}function Ge(Qe){const ft=new v.$eO(Qe.value,Qe.supportThemeIcons);return ft.isTrusted=Qe.isTrusted,ft.supportHtml=Qe.supportHtml,ft.baseUri=Qe.baseUri?m.URI.from(Qe.baseUri):void 0,ft}Te.to=Ge;function _e(Qe){if(Qe)return typeof Qe=="string"?Qe:Te.from(Qe)}Te.fromStrict=_e})(ce||(e.MarkdownString=ce={}));function ne(Te){return _(Te)?Te.map(Me=>({range:N.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?ce.fromMany(Me.hoverMessage):Me.hoverMessage?ce.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Te.map(Me=>({range:N.from(Me)}))}function ye(Te){return typeof Te>"u"?Te:typeof Te=="string"?m.URI.file(Te):Te}var ge;(function(Te){function Me(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?ye(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Te.from=Me})(ge||(e.ThemableDecorationAttachmentRenderOptions=ge={}));var Y;(function(Te){function Me(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?ye(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?ge.from(Se.before):void 0,after:Se.after?ge.from(Se.after):void 0}}Te.from=Me})(Y||(e.ThemableDecorationRenderOptions=Y={}));var U;(function(Te){function Me(Se){if(typeof Se>"u")return Se;switch(Se){case v.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case v.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Te.from=Me})(U||(e.DecorationRangeBehavior=U={}));var oe;(function(Te){function Me(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?U.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?Y.from(Se.light):void 0,dark:Se.dark?Y.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?ye(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?ge.from(Se.before):void 0,after:Se.after?ge.from(Se.after):void 0}}Te.from=Me})(oe||(e.DecorationRenderOptions=oe={}));var ve;(function(Te){function Me(ie){return{text:ie.newText,eol:ie.newEol&&je.from(ie.newEol),range:N.from(ie.range)}}Te.from=Me;function Se(ie){const Ae=new v.$VN(N.to(ie.range),ie.text);return Ae.newEol=typeof ie.eol>"u"?void 0:je.to(ie.eol),Ae}Te.to=Se})(ve||(e.TextEdit=ve={}));var te;(function(Te){function Me(ie,Ae){const Ge={edits:[]};if(ie instanceof v.$YN){const _e=new T.$Bc;for(const Qe of ie._allEntries())Qe._type===v.FileEditType.File&&m.URI.isUri(Qe.to)&&Qe.from===void 0&&_e.add(Qe.to);for(const Qe of ie._allEntries())if(Qe._type===v.FileEditType.File){let ft;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?ft={type:"base64",value:(0,h.$8e)(h.$Ne.wrap(Qe.options.contents))}:ft={type:"dataTransferItem",id:Qe.options.contents._itemId}),Ge.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:ft},metadata:Qe.metadata})}else Qe._type===v.FileEditType.Text?Ge.edits.push({resource:Qe.uri,textEdit:ve.from(Qe.edit),versionId:_e.has(Qe.uri)?void 0:Ae?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===v.FileEditType.Snippet?Ge.edits.push({resource:Qe.uri,textEdit:{range:N.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:_e.has(Qe.uri)?void 0:Ae?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===v.FileEditType.Cell?Ge.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===v.FileEditType.CellReplace&&Ge.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:y.CellEditType.Replace,index:Qe.index,count:Qe.count,cells:Qe.cells.map(Tt.from)}})}return Ge}Te.from=Me;function Se(ie){const Ae=new v.$YN,Ge=new T.$Ac;for(const _e of ie.edits)if(_e.textEdit){const Qe=_e,ft=m.URI.revive(Qe.resource),Rt=N.to(Qe.textEdit.range),Xt=Qe.textEdit.text,si=Qe.textEdit.insertAsSnippet;let zt;si?zt=v.$XN.replace(Rt,new v.$ZN(Xt)):zt=v.$VN.replace(Rt,Xt);const _t=Ge.get(ft);_t?_t.push(zt):Ge.set(ft,[zt])}else Ae.renameFile(m.URI.revive(_e.oldResource),m.URI.revive(_e.newResource),_e.options);for(const[_e,Qe]of Ge)Ae.set(_e,Qe);return Ae}Te.to=Se})(te||(e.WorkspaceEdit=te={}));var ae;(function(Te){const Me=Object.create(null);Me[v.SymbolKind.File]=s.SymbolKind.File,Me[v.SymbolKind.Module]=s.SymbolKind.Module,Me[v.SymbolKind.Namespace]=s.SymbolKind.Namespace,Me[v.SymbolKind.Package]=s.SymbolKind.Package,Me[v.SymbolKind.Class]=s.SymbolKind.Class,Me[v.SymbolKind.Method]=s.SymbolKind.Method,Me[v.SymbolKind.Property]=s.SymbolKind.Property,Me[v.SymbolKind.Field]=s.SymbolKind.Field,Me[v.SymbolKind.Constructor]=s.SymbolKind.Constructor,Me[v.SymbolKind.Enum]=s.SymbolKind.Enum,Me[v.SymbolKind.Interface]=s.SymbolKind.Interface,Me[v.SymbolKind.Function]=s.SymbolKind.Function,Me[v.SymbolKind.Variable]=s.SymbolKind.Variable,Me[v.SymbolKind.Constant]=s.SymbolKind.Constant,Me[v.SymbolKind.String]=s.SymbolKind.String,Me[v.SymbolKind.Number]=s.SymbolKind.Number,Me[v.SymbolKind.Boolean]=s.SymbolKind.Boolean,Me[v.SymbolKind.Array]=s.SymbolKind.Array,Me[v.SymbolKind.Object]=s.SymbolKind.Object,Me[v.SymbolKind.Key]=s.SymbolKind.Key,Me[v.SymbolKind.Null]=s.SymbolKind.Null,Me[v.SymbolKind.EnumMember]=s.SymbolKind.EnumMember,Me[v.SymbolKind.Struct]=s.SymbolKind.Struct,Me[v.SymbolKind.Event]=s.SymbolKind.Event,Me[v.SymbolKind.Operator]=s.SymbolKind.Operator,Me[v.SymbolKind.TypeParameter]=s.SymbolKind.TypeParameter;function Se(Ae){return typeof Me[Ae]=="number"?Me[Ae]:s.SymbolKind.Property}Te.from=Se;function ie(Ae){for(const Ge in Me)if(Me[Ge]===Ae)return Number(Ge);return v.SymbolKind.Property}Te.to=ie})(ae||(e.SymbolKind=ae={}));var se;(function(Te){function Me(ie){switch(ie){case v.SymbolTag.Deprecated:return s.SymbolTag.Deprecated}}Te.from=Me;function Se(ie){switch(ie){case s.SymbolTag.Deprecated:return v.SymbolTag.Deprecated}}Te.to=Se})(se||(e.SymbolTag=se={}));var X;(function(Te){function Me(ie){return{name:ie.name,kind:ae.from(ie.kind),tags:ie.tags&&ie.tags.map(se.from),containerName:ie.containerName,location:Be.from(ie.location)}}Te.from=Me;function Se(ie){const Ae=new v.$8N(ie.name,ae.to(ie.kind),ie.containerName,Be.to(ie.location));return Ae.tags=ie.tags&&ie.tags.map(se.to),Ae}Te.to=Se})(X||(e.WorkspaceSymbol=X={}));var re;(function(Te){function Me(ie){const Ae={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),kind:ae.from(ie.kind),tags:ie.tags?.map(se.from)??[]};return ie.children&&(Ae.children=ie.children.map(Me)),Ae}Te.from=Me;function Se(ie){const Ae=new v.$9N(ie.name,ie.detail,ae.to(ie.kind),N.to(ie.range),N.to(ie.selectionRange));return(0,r.$Kb)(ie.tags)&&(Ae.tags=ie.tags.map(se.to)),ie.children&&(Ae.children=ie.children.map(Se)),Ae}Te.to=Se})(re||(e.DocumentSymbol=re={}));var pe;(function(Te){function Me(ie){const Ae=new v.$aO(ae.to(ie.kind),ie.name,ie.detail||"",m.URI.revive(ie.uri),N.to(ie.range),N.to(ie.selectionRange));return Ae._sessionId=ie._sessionId,Ae._itemId=ie._itemId,Ae}Te.to=Me;function Se(ie,Ae,Ge){if(Ae=Ae??ie._sessionId,Ge=Ge??ie._itemId,Ae===void 0||Ge===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Ge,name:ie.name,detail:ie.detail,kind:ae.from(ie.kind),uri:ie.uri,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),tags:ie.tags?.map(se.from)}}Te.from=Se})(pe||(e.CallHierarchyItem=pe={}));var we;(function(Te){function Me(Se){return new v.$bO(pe.to(Se.from),Se.fromRanges.map(ie=>N.to(ie)))}Te.to=Me})(we||(e.CallHierarchyIncomingCall=we={}));var Fe;(function(Te){function Me(Se){return new v.$cO(pe.to(Se.to),Se.fromRanges.map(ie=>N.to(ie)))}Te.to=Me})(Fe||(e.CallHierarchyOutgoingCall=Fe={}));var Be;(function(Te){function Me(ie){return{range:ie.range&&N.from(ie.range),uri:ie.uri}}Te.from=Me;function Se(ie){return new v.$1N(m.URI.revive(ie.uri),N.to(ie.range))}Te.to=Se})(Be||(e.location=Be={}));var Re;(function(Te){function Me(ie){const Ae=ie,Ge=ie;return{originSelectionRange:Ae.originSelectionRange?N.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Ge.uri,range:N.from(Ae.targetRange?Ae.targetRange:Ge.range),targetSelectionRange:Ae.targetSelectionRange?N.from(Ae.targetSelectionRange):void 0}}Te.from=Me;function Se(ie){return{targetUri:m.URI.revive(ie.uri),targetRange:N.to(ie.range),targetSelectionRange:ie.targetSelectionRange?N.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?N.to(ie.originSelectionRange):void 0}}Te.to=Se})(Re||(e.DefinitionLink=Re={}));var De;(function(Te){function Me(ie){return{range:N.from(ie.range),contents:ce.fromMany(ie.contents),canIncreaseVerbosity:ie.canIncreaseVerbosity,canDecreaseVerbosity:ie.canDecreaseVerbosity}}Te.from=Me;function Se(ie){const Ae=ie.contents.map(ce.to),Ge=N.to(ie.range),_e=ie.canIncreaseVerbosity,Qe=ie.canDecreaseVerbosity;return new v.$5N(Ae,Ge,_e,Qe)}Te.to=Se})(De||(e.Hover=De={}));var Ce;(function(Te){function Me(ie){return{range:N.from(ie.range),expression:ie.expression}}Te.from=Me;function Se(ie){return new v.$ZO(N.to(ie.range),ie.expression)}Te.to=Se})(Ce||(e.EvaluatableExpression=Ce={}));var V;(function(Te){function Me(ie){if(ie instanceof v.$1O)return{type:"text",range:N.from(ie.range),text:ie.text};if(ie instanceof v.$2O)return{type:"variable",range:N.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof v.$3O)return{type:"expression",range:N.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Te.from=Me;function Se(ie){switch(ie.type){case"text":return{range:N.to(ie.range),text:ie.text};case"variable":return{range:N.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:N.to(ie.range),expression:ie.expression}}}Te.to=Se})(V||(e.InlineValue=V={}));var G;(function(Te){function Me(ie){return{frameId:ie.frameId,stoppedLocation:N.from(ie.stoppedLocation)}}Te.from=Me;function Se(ie){return new v.$4O(ie.frameId,N.to(ie.stoppedLocation))}Te.to=Se})(G||(e.InlineValueContext=G={}));var J;(function(Te){function Me(ie){return{range:N.from(ie.range),kind:ie.kind}}Te.from=Me;function Se(ie){return new v.$6N(N.to(ie.range),ie.kind)}Te.to=Se})(J||(e.DocumentHighlight=J={}));var x;(function(Te){function Me(ie){return{uri:ie.uri,highlights:ie.highlights.map(J.from)}}Te.from=Me;function Se(ie){return new v.$7N(m.URI.revive(ie.uri),ie.highlights.map(J.to))}Te.to=Se})(x||(e.MultiDocumentHighlight=x={}));var de;(function(Te){function Me(Se){switch(Se){case s.CompletionTriggerKind.TriggerCharacter:return v.CompletionTriggerKind.TriggerCharacter;case s.CompletionTriggerKind.TriggerForIncompleteCompletions:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case s.CompletionTriggerKind.Invoke:default:return v.CompletionTriggerKind.Invoke}}Te.to=Me})(de||(e.CompletionTriggerKind=de={}));var Ee;(function(Te){function Me(Se){return{triggerKind:de.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Te.to=Me})(Ee||(e.CompletionContext=Ee={}));var Le;(function(Te){function Me(ie){switch(ie){case v.CompletionItemTag.Deprecated:return s.CompletionItemTag.Deprecated}}Te.from=Me;function Se(ie){switch(ie){case s.CompletionItemTag.Deprecated:return v.CompletionItemTag.Deprecated}}Te.to=Se})(Le||(e.CompletionItemTag=Le={}));var He;(function(Te){const Me=new Map([[v.CompletionItemKind.Method,s.CompletionItemKind.Method],[v.CompletionItemKind.Function,s.CompletionItemKind.Function],[v.CompletionItemKind.Constructor,s.CompletionItemKind.Constructor],[v.CompletionItemKind.Field,s.CompletionItemKind.Field],[v.CompletionItemKind.Variable,s.CompletionItemKind.Variable],[v.CompletionItemKind.Class,s.CompletionItemKind.Class],[v.CompletionItemKind.Interface,s.CompletionItemKind.Interface],[v.CompletionItemKind.Struct,s.CompletionItemKind.Struct],[v.CompletionItemKind.Module,s.CompletionItemKind.Module],[v.CompletionItemKind.Property,s.CompletionItemKind.Property],[v.CompletionItemKind.Unit,s.CompletionItemKind.Unit],[v.CompletionItemKind.Value,s.CompletionItemKind.Value],[v.CompletionItemKind.Constant,s.CompletionItemKind.Constant],[v.CompletionItemKind.Enum,s.CompletionItemKind.Enum],[v.CompletionItemKind.EnumMember,s.CompletionItemKind.EnumMember],[v.CompletionItemKind.Keyword,s.CompletionItemKind.Keyword],[v.CompletionItemKind.Snippet,s.CompletionItemKind.Snippet],[v.CompletionItemKind.Text,s.CompletionItemKind.Text],[v.CompletionItemKind.Color,s.CompletionItemKind.Color],[v.CompletionItemKind.File,s.CompletionItemKind.File],[v.CompletionItemKind.Reference,s.CompletionItemKind.Reference],[v.CompletionItemKind.Folder,s.CompletionItemKind.Folder],[v.CompletionItemKind.Event,s.CompletionItemKind.Event],[v.CompletionItemKind.Operator,s.CompletionItemKind.Operator],[v.CompletionItemKind.TypeParameter,s.CompletionItemKind.TypeParameter],[v.CompletionItemKind.Issue,s.CompletionItemKind.Issue],[v.CompletionItemKind.User,s.CompletionItemKind.User]]);function Se(Ge){return Me.get(Ge)??s.CompletionItemKind.Property}Te.from=Se;const ie=new Map([[s.CompletionItemKind.Method,v.CompletionItemKind.Method],[s.CompletionItemKind.Function,v.CompletionItemKind.Function],[s.CompletionItemKind.Constructor,v.CompletionItemKind.Constructor],[s.CompletionItemKind.Field,v.CompletionItemKind.Field],[s.CompletionItemKind.Variable,v.CompletionItemKind.Variable],[s.CompletionItemKind.Class,v.CompletionItemKind.Class],[s.CompletionItemKind.Interface,v.CompletionItemKind.Interface],[s.CompletionItemKind.Struct,v.CompletionItemKind.Struct],[s.CompletionItemKind.Module,v.CompletionItemKind.Module],[s.CompletionItemKind.Property,v.CompletionItemKind.Property],[s.CompletionItemKind.Unit,v.CompletionItemKind.Unit],[s.CompletionItemKind.Value,v.CompletionItemKind.Value],[s.CompletionItemKind.Constant,v.CompletionItemKind.Constant],[s.CompletionItemKind.Enum,v.CompletionItemKind.Enum],[s.CompletionItemKind.EnumMember,v.CompletionItemKind.EnumMember],[s.CompletionItemKind.Keyword,v.CompletionItemKind.Keyword],[s.CompletionItemKind.Snippet,v.CompletionItemKind.Snippet],[s.CompletionItemKind.Text,v.CompletionItemKind.Text],[s.CompletionItemKind.Color,v.CompletionItemKind.Color],[s.CompletionItemKind.File,v.CompletionItemKind.File],[s.CompletionItemKind.Reference,v.CompletionItemKind.Reference],[s.CompletionItemKind.Folder,v.CompletionItemKind.Folder],[s.CompletionItemKind.Event,v.CompletionItemKind.Event],[s.CompletionItemKind.Operator,v.CompletionItemKind.Operator],[s.CompletionItemKind.TypeParameter,v.CompletionItemKind.TypeParameter],[s.CompletionItemKind.User,v.CompletionItemKind.User],[s.CompletionItemKind.Issue,v.CompletionItemKind.Issue]]);function Ae(Ge){return ie.get(Ge)??v.CompletionItemKind.Property}Te.to=Ae})(He||(e.CompletionItemKind=He={}));var Ze;(function(Te){function Me(Se,ie){const Ae=new v.$kO(Se.label);return Ae.insertText=Se.insertText,Ae.kind=He.to(Se.kind),Ae.tags=Se.tags?.map(Le.to),Ae.detail=Se.detail,Ae.documentation=O.$6k(Se.documentation)?ce.to(Se.documentation):Se.documentation,Ae.sortText=Se.sortText,Ae.filterText=Se.filterText,Ae.preselect=Se.preselect,Ae.commitCharacters=Se.commitCharacters,f.$Ot.isIRange(Se.range)?Ae.range=N.to(Se.range):typeof Se.range=="object"&&(Ae.range={inserting:N.to(Se.range.insert),replacing:N.to(Se.range.replace)}),Ae.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&s.CompletionItemInsertTextRule.KeepWhitespace),typeof Se.insertTextRules<"u"&&Se.insertTextRules&s.CompletionItemInsertTextRule.InsertAsSnippet?Ae.insertText=new v.$ZN(Se.insertText):(Ae.insertText=Se.insertText,Ae.textEdit=Ae.range instanceof v.$ON?new v.$VN(Ae.range,Ae.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Ae.additionalTextEdits=Se.additionalTextEdits.map(Ge=>ve.to(Ge))),Ae.command=ie&&Se.command?ie.fromInternal(Se.command):void 0,Ae}Te.to=Me})(Ze||(e.CompletionItem=Ze={}));var et;(function(Te){function Me(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:ce.fromStrict(ie.documentation)}}Te.from=Me;function Se(ie){return{label:ie.label,documentation:O.$6k(ie.documentation)?ce.to(ie.documentation):ie.documentation}}Te.to=Se})(et||(e.ParameterInformation=et={}));var nt;(function(Te){function Me(ie){return{label:ie.label,documentation:ce.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(et.from):[],activeParameter:ie.activeParameter}}Te.from=Me;function Se(ie){return{label:ie.label,documentation:O.$6k(ie.documentation)?ce.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(et.to):[],activeParameter:ie.activeParameter}}Te.to=Se})(nt||(e.SignatureInformation=nt={}));var st;(function(Te){function Me(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(nt.from):[]}}Te.from=Me;function Se(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(nt.to):[]}}Te.to=Se})(st||(e.SignatureHelp=st={}));var rt;(function(Te){function Me(Se,ie){const Ae=new v.$jO(z.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(at.to.bind(void 0,Se)),ie.kind&&gt.to(ie.kind));return Ae.textEdits=ie.textEdits&&ie.textEdits.map(ve.to),Ae.tooltip=O.$6k(ie.tooltip)?ce.to(ie.tooltip):ie.tooltip,Ae.paddingLeft=ie.paddingLeft,Ae.paddingRight=ie.paddingRight,Ae}Te.to=Me})(rt||(e.InlayHint=rt={}));var at;(function(Te){function Me(Se,ie){const Ae=new v.$iO(ie.label);return Ae.tooltip=O.$6k(ie.tooltip)?ce.to(ie.tooltip):ie.tooltip,s.Command.is(ie.command)&&(Ae.command=Se.fromInternal(ie.command)),ie.location&&(Ae.location=Be.to(ie.location)),Ae}Te.to=Me})(at||(e.InlayHintLabelPart=at={}));var gt;(function(Te){function Me(ie){return ie}Te.from=Me;function Se(ie){return ie}Te.to=Se})(gt||(e.InlayHintKind=gt={}));var dt;(function(Te){function Me(ie){return{range:N.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Te.from=Me;function Se(ie){let Ae;if(ie.url)try{Ae=typeof ie.url=="string"?m.URI.parse(ie.url,!0):m.URI.revive(ie.url)}catch{}const Ge=new v.$pO(N.to(ie.range),Ae);return Ge.tooltip=ie.tooltip,Ge}Te.to=Se})(dt||(e.DocumentLink=dt={}));var ct;(function(Te){function Me(ie){const Ae=new v.$sO(ie.label);return ie.textEdit&&(Ae.textEdit=ve.to(ie.textEdit)),ie.additionalTextEdits&&(Ae.additionalTextEdits=ie.additionalTextEdits.map(Ge=>ve.to(Ge))),Ae}Te.to=Me;function Se(ie){return{label:ie.label,textEdit:ie.textEdit?ve.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Ae=>ve.from(Ae)):void 0}}Te.from=Se})(ct||(e.ColorPresentation=ct={}));var Pe;(function(Te){function Me(ie){return new v.$qO(ie[0],ie[1],ie[2],ie[3])}Te.to=Me;function Se(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Te.from=Se})(Pe||(e.Color=Pe={}));var ze;(function(Te){function Me(ie){return{range:N.from(ie.range)}}Te.from=Me;function Se(ie){return new v.$_N(N.to(ie.range))}Te.to=Se})(ze||(e.SelectionRange=ze={}));var Ke;(function(Te){function Me(Se){switch(Se){case l.SaveReason.AUTO:return v.TextDocumentSaveReason.AfterDelay;case l.SaveReason.EXPLICIT:return v.TextDocumentSaveReason.Manual;case l.SaveReason.FOCUS_CHANGE:case l.SaveReason.WINDOW_CHANGE:return v.TextDocumentSaveReason.FocusOut}}Te.to=Me})(Ke||(e.TextDocumentSaveReason=Ke={}));var Ne;(function(Te){function Me(ie){switch(ie){case v.TextEditorLineNumbersStyle.Off:return $.RenderLineNumbersType.Off;case v.TextEditorLineNumbersStyle.Relative:return $.RenderLineNumbersType.Relative;case v.TextEditorLineNumbersStyle.Interval:return $.RenderLineNumbersType.Interval;case v.TextEditorLineNumbersStyle.On:default:return $.RenderLineNumbersType.On}}Te.from=Me;function Se(ie){switch(ie){case $.RenderLineNumbersType.Off:return v.TextEditorLineNumbersStyle.Off;case $.RenderLineNumbersType.Relative:return v.TextEditorLineNumbersStyle.Relative;case $.RenderLineNumbersType.Interval:return v.TextEditorLineNumbersStyle.Interval;case $.RenderLineNumbersType.On:default:return v.TextEditorLineNumbersStyle.On}}Te.to=Se})(Ne||(e.TextEditorLineNumbersStyle=Ne={}));var je;(function(Te){function Me(ie){if(ie===v.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(ie===v.EndOfLine.LF)return t.EndOfLineSequence.LF}Te.from=Me;function Se(ie){if(ie===t.EndOfLineSequence.CRLF)return v.EndOfLine.CRLF;if(ie===t.EndOfLineSequence.LF)return v.EndOfLine.LF}Te.to=Se})(je||(e.EndOfLine=je={}));var ue;(function(Te){function Me(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case v.ProgressLocation.SourceControl:return n.ProgressLocation.Scm;case v.ProgressLocation.Window:return n.ProgressLocation.Window;case v.ProgressLocation.Notification:return n.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Te.from=Me})(ue||(e.ProgressLocation=ue={}));var he;(function(Te){function Me(ie){const Ae={start:ie.start+1,end:ie.end+1};return ie.kind&&(Ae.kind=le.from(ie.kind)),Ae}Te.from=Me;function Se(ie){const Ae={start:ie.start-1,end:ie.end-1};return ie.kind&&(Ae.kind=le.to(ie.kind)),Ae}Te.to=Se})(he||(e.FoldingRange=he={}));var le;(function(Te){function Me(ie){if(ie)switch(ie){case v.FoldingRangeKind.Comment:return s.$Pu.Comment;case v.FoldingRangeKind.Imports:return s.$Pu.Imports;case v.FoldingRangeKind.Region:return s.$Pu.Region}}Te.from=Me;function Se(ie){if(ie)switch(ie.value){case s.$Pu.Comment.value:return v.FoldingRangeKind.Comment;case s.$Pu.Imports.value:return v.FoldingRangeKind.Imports;case s.$Pu.Region.value:return v.FoldingRangeKind.Region}}Te.to=Se})(le||(e.FoldingRangeKind=le={}));var Xe;(function(Te){function Me(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?N.from(Se.selection):void 0,override:typeof Se.override=="boolean"?l.$5F.id:void 0}}Te.from=Me})(Xe||(e.TextEditorOpenOptions=Xe={}));var tt;(function(Te){function Me(Ge){return Ge instanceof v.$NO?Ge.toJSON():typeof Ge=="string"?Ge:Se(Ge)||ie(Ge)?new v.$NO(Ge.baseUri??Ge.base,Ge.pattern).toJSON():Ge}Te.from=Me;function Se(Ge){const _e=Ge;return _e?m.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function ie(Ge){const _e=Ge;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Ae(Ge){return typeof Ge=="string"?Ge:new v.$NO(m.URI.revive(Ge.baseUri),Ge.pattern)}Te.to=Ae})(tt||(e.GlobPattern=tt={}));var ut;(function(Te){function Me(Se){if(Se){if(Array.isArray(Se))return Se.map(Me);if(typeof Se=="string")return Se;{const ie=Se;return{language:ie.language,scheme:ie.scheme,pattern:tt.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}Te.from=Me})(ut||(e.LanguageSelector=ut={}));var mt;(function(Te){function Me(ie){return!!ie&&typeof ie=="object"&&"documents"in ie&&Array.isArray(ie.documents)&&ie.documents.every(Ae=>Array.isArray(Ae)&&Ae.every(Ge=>Ge&&typeof Ge=="object"&&"uri"in Ge&&m.URI.isUri(Ge.uri)&&"version"in Ge&&typeof Ge.version=="number"&&"ranges"in Ge&&Array.isArray(Ge.ranges)&&Ge.ranges.every(_e=>_e instanceof v.$ON)))}Te.is=Me;function Se(ie){return{documents:ie.documents.map(Ae=>Ae.map(Ge=>({uri:m.URI.from(Ge.uri),version:Ge.version,ranges:Ge.ranges.map(_e=>N.from(_e))})))}}Te.from=Se})(mt||(e.MappedEditsContext=mt={}));var Dt;(function(Te){function Me(ie){return{start:ie.start,end:ie.end}}Te.from=Me;function Se(ie){return new v.$eP(ie.start,ie.end)}Te.to=Se})(Dt||(e.NotebookRange=Dt={}));var Mt;(function(Te){function Me(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Te.to=Me;function Se(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Te.from=Se})(Mt||(e.NotebookCellExecutionSummary=Mt={}));var Ht;(function(Te){function Me(Se){if(Se===y.NotebookCellExecutionState.Unconfirmed)return v.NotebookCellExecutionState.Pending;if(Se===y.NotebookCellExecutionState.Pending)return;if(Se===y.NotebookCellExecutionState.Executing)return v.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Te.to=Me})(Ht||(e.NotebookCellExecutionState=Ht={}));var ei;(function(Te){function Me(ie){switch(ie){case v.NotebookCellKind.Markup:return y.CellKind.Markup;case v.NotebookCellKind.Code:default:return y.CellKind.Code}}Te.from=Me;function Se(ie){switch(ie){case y.CellKind.Markup:return v.NotebookCellKind.Markup;case y.CellKind.Code:default:return v.NotebookCellKind.Code}}Te.to=Se})(ei||(e.NotebookCellKind=ei={}));var oi;(function(Te){function Me(ie){const Ae={metadata:ie.metadata??Object.create(null),cells:[]};for(const Ge of ie.cells)v.$fP.validate(Ge),Ae.cells.push(Tt.from(Ge));return Ae}Te.from=Me;function Se(ie){const Ae=new v.$gP(ie.cells.map(Tt.to));return(0,a.$rg)(ie.metadata)||(Ae.metadata=ie.metadata),Ae}Te.to=Se})(oi||(e.NotebookData=oi={}));var Tt;(function(Te){function Me(ie){return{cellKind:ei.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Mt.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(Ct.from):[]}}Te.from=Me;function Se(ie){return new v.$fP(ei.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(Ct.to):void 0,ie.metadata,ie.internalMetadata?Mt.to(ie.internalMetadata):void 0)}Te.to=Se})(Tt||(e.NotebookCellData=Tt={}));var it;(function(Te){function Me(ie){return{mime:ie.mime,valueBytes:h.$Ne.wrap(ie.data)}}Te.from=Me;function Se(ie){return new v.$hP(ie.valueBytes.buffer,ie.mime)}Te.to=Se})(it||(e.NotebookCellOutputItem=it={}));var Ct;(function(Te){function Me(ie){return{outputId:ie.id,items:ie.items.map(it.from),metadata:ie.metadata}}Te.from=Me;function Se(ie){const Ae=ie.items.map(it.to);return new v.$iP(Ae,ie.outputId,ie.metadata)}Te.to=Se})(Ct||(e.NotebookCellOutput=Ct={}));var hi;(function(Te){function Me(Ae){return ie(Ae)?{include:tt.from(Ae.include)??void 0,exclude:tt.from(Ae.exclude)??void 0}:tt.from(Ae)??void 0}Te.from=Me;function Se(Ae){return ie(Ae)?{include:tt.to(Ae.include),exclude:tt.to(Ae.exclude)}:tt.to(Ae)}Te.to=Se;function ie(Ae){const Ge=Ae;return Ge?!(0,a.$ng)(Ge.include)&&!(0,a.$ng)(Ge.exclude):!1}})(hi||(e.NotebookExclusiveDocumentPattern=hi={}));var bt;(function(Te){function Me(Se,ie,Ae){const Ge=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===v.NotebookCellStatusBarAlignment.Left?y.CellStatusbarAlignment.Left:y.CellStatusbarAlignment.Right,command:ie.toInternal(Ge,Ae),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Te.from=Me})(bt||(e.NotebookStatusBarItem=bt={}));var St;(function(Te){function Me(Se,ie,Ae){const Ge=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:ie.toInternal(Ge,Ae),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Te.from=Me})(St||(e.NotebookKernelSourceAction=St={}));var ti;(function(Te){function Me(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Te.from=Me})(ti||(e.NotebookDocumentContentOptions=ti={}));var ii;(function(Te){function Me(ie){return{uri:ie.uri,provides:ie.provides}}Te.from=Me;function Se(ie){return new v.$kP(m.URI.revive(ie.uri),ie.provides)}Te.to=Se})(ii||(e.NotebookRendererScript=ii={}));var Wt;(function(Te){function Me(ie){return{message:ce.fromStrict(ie.message)||"",type:A.TestMessageType.Error,expected:ie.expectedOutput,actual:ie.actualOutput,contextValue:ie.contextValue,location:ie.location&&{range:N.from(ie.location.range),uri:ie.location.uri},stackTrace:ie.stackTrace?.map(Ae=>({label:Ae.label,position:Ae.position&&z.from(Ae.position),uri:Ae.file&&m.URI.revive(Ae.file).toJSON()}))}}Te.from=Me;function Se(ie){const Ae=new v.$qP(typeof ie.message=="string"?ie.message:ce.to(ie.message));return Ae.actualOutput=ie.actual,Ae.expectedOutput=ie.expected,Ae.contextValue=ie.contextValue,Ae.location=ie.location?Be.to(ie.location):void 0,Ae}Te.to=Se})(Wt||(e.TestMessage=Wt={}));var pt;(function(Te){Te.namespace=A.$_I,Te.denamespace=A.$aJ})(pt||(e.TestTag=pt={}));var Bt;(function(Te){function Me(ie){const Ae=(0,d.$gQ)(ie).controllerId;return{extId:k.$7I.fromExtHostTestItem(ie,Ae).toString(),label:ie.label,uri:m.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map(Ge=>pt.namespace(Ae,Ge.id)),range:f.$Ot.lift(N.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&ce.fromStrict(ie.error)||null}}Te.from=Me;function Se(ie){return{parent:void 0,error:void 0,id:k.$7I.fromString(ie.extId).localId,label:ie.label,uri:m.URI.revive(ie.uri),tags:(ie.tags||[]).map(Ae=>{const{tagId:Ge}=pt.denamespace(Ae);return new v.$rP(Ge)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}Te.toPlain=Se})(Bt||(e.TestItem=Bt={})),function(Te){function Me(ie){return{id:ie.id}}Te.from=Me;function Se(ie){return new v.$rP(ie.id)}Te.to=Se}(pt||(e.TestTag=pt={}));var ni;(function(Te){const Me=(ie,Ae)=>{const Ge=ie.value;if(!Ge)return;const _e={...Bt.toPlain(Ge.item),parent:Ae,taskStates:Ge.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(ft=>ft.type===A.TestMessageType.Error).map(Wt.to)})),children:[]};if(ie.children)for(const Qe of ie.children.values()){const ft=Me(Qe,_e);ft&&_e.children.push(ft)}return _e};function Se(ie){const Ae=new u.$6I;for(const Qe of ie.items)Ae.insert(k.$7I.fromString(Qe.item.extId).path,Qe);const Ge=[Ae.nodes],_e=[];for(;Ge.length;)for(const Qe of Ge.pop())Qe.value?_e.push(Qe):Qe.children&&Ge.push(Qe.children.values());return{completedAt:ie.completedAt,results:_e.map(Qe=>Me(Qe)).filter(a.$mg)}}Te.to=Se})(ni||(e.TestResults=ni={}));var ai;(function(Te){function Me(Ge){return{covered:Ge.covered,total:Ge.total}}function Se(Ge){return"line"in Ge?z.from(Ge):N.from(Ge)}function ie(Ge){if(typeof Ge.executed=="number"&&Ge.executed<0)throw new Error(`Invalid coverage count ${Ge.executed}`);return"branches"in Ge?{count:Ge.executed,location:Se(Ge.location),type:A.DetailType.Statement,branches:Ge.branches.length?Ge.branches.map(_e=>({count:_e.executed,location:_e.location&&Se(_e.location),label:_e.label})):void 0}:{type:A.DetailType.Declaration,name:Ge.name,count:Ge.executed,location:Se(Ge.location)}}Te.fromDetails=ie;function Ae(Ge,_e,Qe){return v.$uP(Qe.statementCoverage),v.$uP(Qe.branchCoverage),v.$uP(Qe.declarationCoverage),{id:_e,uri:Qe.uri,statement:Me(Qe.statementCoverage),branch:Qe.branchCoverage&&Me(Qe.branchCoverage),declaration:Qe.declarationCoverage&&Me(Qe.declarationCoverage),testIds:Qe instanceof v.$vP&&Qe.fromTests.length?Qe.fromTests.map(ft=>k.$7I.fromExtHostTestItem(ft,Ge).toString()):void 0}}Te.fromFile=Ae})(ai||(e.TestCoverage=ai={}));var xe;(function(Te){function Me(Se){switch(Se){case s.CodeActionTriggerType.Invoke:return v.CodeActionTriggerKind.Invoke;case s.CodeActionTriggerType.Auto:return v.CodeActionTriggerKind.Automatic}}Te.to=Me})(xe||(e.CodeActionTriggerKind=xe={}));var ci;(function(Te){function Me(ie){const Ae=new v.$zP(ae.to(ie.kind),ie.name,ie.detail||"",m.URI.revive(ie.uri),N.to(ie.range),N.to(ie.selectionRange));return Ae._sessionId=ie._sessionId,Ae._itemId=ie._itemId,Ae}Te.to=Me;function Se(ie,Ae,Ge){if(Ae=Ae??ie._sessionId,Ge=Ge??ie._itemId,Ae===void 0||Ge===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Ge,kind:ae.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),tags:ie.tags?.map(se.from)}}Te.from=Se})(ci||(e.TypeHierarchyItem=ci={}));var di;(function(Te){function Me(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}Te.from=Me})(di||(e.ViewBadge=di={}));var fi;(function(Te){function Me(Ge,_e,Qe){const ft=_e.fileData;return ft?new v.$FO(new v.$GO(ft.name,m.URI.revive(ft.uri),ft.id,(0,R.$cb)(()=>Qe(ft.id)))):Ge===I.$$s.uriList&&_e.uriListData?new v.$EO(Ae(_e.uriListData)):new v.$EO(_e.asString)}Te.to=Me;async function Se(Ge,_e){const Qe=await _e.asString();if(Ge===I.$$s.uriList)return{asString:Qe,fileData:void 0,uriListData:ie(Qe)};const ft=_e.asFile();return{asString:Qe,fileData:ft?{name:ft.name,uri:ft.uri,id:ft._itemId??ft.id}:void 0}}Te.from=Se;function ie(Ge){return C.$tu.split(Ge).map(_e=>{if(_e.startsWith("#"))return _e;try{return m.URI.parse(_e)}catch{}return _e})}function Ae(Ge){return C.$tu.create(Ge.map(_e=>typeof _e=="string"?_e:m.URI.revive(_e)))}})(fi||(e.DataTransferItem=fi={}));var vt;(function(Te){function Me(ie,Ae){const Ge=ie.items.map(([_e,Qe])=>[_e,fi.to(_e,Qe,Ae)]);return new v.$HO(Ge)}Te.toDataTransfer=Me;async function Se(ie){const Ae={items:[]},Ge=[];for(const[_e,Qe]of ie)Ge.push((async()=>{Ae.items.push([_e,await fi.from(_e,Qe)])})());return await Promise.all(Ge),Ae}Te.from=Se})(vt||(e.DataTransfer=vt={}));var jt;(function(Te){function Me(ie,Ae){return{kind:"reply",agentId:ie.participant??Ae?.agentId??"",subCommand:ie.command??Ae?.command,message:ie.prompt,title:ie.label}}Te.from=Me;function Se(ie){return{prompt:ie.message,label:ie.title,participant:ie.agentId,command:ie.subCommand}}Te.to=Se})(jt||(e.ChatFollowup=jt={}));var Nt;(function(Te){function Me(ie){switch(ie){case E.ChatMessageRole.System:return v.LanguageModelChatMessageRole.System;case E.ChatMessageRole.User:return v.LanguageModelChatMessageRole.User;case E.ChatMessageRole.Assistant:return v.LanguageModelChatMessageRole.Assistant}}Te.to=Me;function Se(ie){switch(ie){case v.LanguageModelChatMessageRole.System:return E.ChatMessageRole.System;case v.LanguageModelChatMessageRole.User:return E.ChatMessageRole.User;case v.LanguageModelChatMessageRole.Assistant:return E.ChatMessageRole.Assistant}return E.ChatMessageRole.User}Te.from=Se})(Nt||(e.LanguageModelChatMessageRole=Nt={}));var Gt;(function(Te){function Me(ie){let Ae="",Ge;ie.content.type==="text"?Ae=ie.content.value:Ge=new v.$4P(ie.content.name,ie.content.value,ie.content.isError);const _e=Nt.to(ie.role),Qe=new v.$5P(_e,Ae,ie.name);return Ge!==void 0&&(Qe.content2=Ge),Qe}Te.to=Me;function Se(ie){const Ae=Nt.from(ie.role),Ge=ie.name;let _e;return ie.content2 instanceof v.$4P?_e={type:"function_result",name:ie.content2.name,value:ie.content2.content,isError:ie.content2.isError}:_e={type:"text",value:ie.content},{role:Ae,name:Ge,content:_e}}Te.from=Se})(Gt||(e.LanguageModelChatMessage=Gt={}));var ri;(function(Te){function Me(ie){return{kind:"markdownContent",content:ce.from(ie.value)}}Te.from=Me;function Se(ie){return new v.$MP(ce.to(ie.content))}Te.to=Se})(ri||(e.ChatResponseMarkdownPart=ri={}));var Qt;(function(Te){function Me(ie){return{kind:"markdownVuln",content:ce.from(ie.value),vulnerabilities:ie.vulnerabilities}}Te.from=Me;function Se(ie){return new v.$NP(ce.to(ie.content),ie.vulnerabilities)}Te.to=Se})(Qt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Qt={}));var li;(function(Te){function Me(ie){return{kind:"agentDetection",agentId:ie.participant,command:ie.command}}Te.from=Me;function Se(ie){return new v.$OP(ie.agentId,ie.command)}Te.to=Se})(li||(e.ChatResponseDetectedParticipantPart=li={}));var qt;(function(Te){function Me(Se){return{kind:"confirmation",title:Se.title,message:Se.message,data:Se.data,buttons:Se.buttons}}Te.from=Me})(qt||(e.ChatResponseConfirmationPart=qt={}));var Zt;(function(Te){function Me(ie){const{value:Ae,baseUri:Ge}=ie;function _e(Qe,ft){return Qe.map(Rt=>{const Xt=m.URI.joinPath(ft,Rt.name);return{label:Rt.name,uri:Xt,children:Rt.children&&_e(Rt.children,Xt)}})}return{kind:"treeData",treeData:{label:(0,P.$dh)(Ge),uri:Ge,children:_e(Ae,Ge)}}}Te.from=Me;function Se(ie){const Ae=(0,c.$ci)(ie.treeData);function Ge(ft){return ft.map(Rt=>({name:Rt.label,children:Rt.children&&Ge(Rt.children)}))}const _e=Ae.uri,Qe=Ae.children?Ge(Ae.children):[];return new v.$QP(Qe,_e)}Te.to=Se})(Zt||(e.ChatResponseFilesPart=Zt={}));var Jt;(function(Te){function Me(ie){const Ae=Ge=>m.URI.isUri(Ge);return{kind:"inlineReference",name:ie.title,inlineReference:Ae(ie.value)?ie.value:L.from(ie.value)}}Te.from=Me;function Se(ie){const Ae=(0,c.$ci)(ie);return new v.$RP(m.URI.isUri(Ae.inlineReference)?Ae.inlineReference:L.to(Ae.inlineReference),ie.name)}Te.to=Se})(Jt||(e.ChatResponseAnchorPart=Jt={}));var Ft;(function(Te){function Me(ie){return{kind:"progressMessage",content:ce.from(ie.value)}}Te.from=Me;function Se(ie){return new v.$SP(ie.content.value)}Te.to=Se})(Ft||(e.ChatResponseProgressPart=Ft={}));var wt;(function(Te){function Me(ie){return{kind:"warning",content:ce.from(ie.value)}}Te.from=Me;function Se(ie){return new v.$UP(ie.content.value)}Te.to=Se})(wt||(e.ChatResponseWarningPart=wt={}));var It;(function(Te){function Me(Se){return{kind:"progressTask",content:ce.from(Se.value)}}Te.from=Me})(It||(e.ChatTask=It={}));var Kt;(function(Te){function Me(Se){return{kind:"progressTaskResult",content:typeof Se=="string"?ce.from(Se):void 0}}Te.from=Me})(Kt||(e.ChatTaskResult=Kt={}));var Pt;(function(Te){function Me(ie,Ae,Ge){return{kind:"command",command:Ae.toInternal(ie.value,Ge)??{command:ie.value.command,title:ie.value.title}}}Te.from=Me;function Se(ie,Ae){return new v.$VP(Ae.fromInternal(ie.command)??{command:ie.command.id,title:ie.command.title})}Te.to=Se})(Pt||(e.ChatResponseCommandButtonPart=Pt={}));var mi;(function(Te){function Me(ie){return{kind:"textEdit",uri:ie.uri,edits:ie.edits.map(Ae=>ve.from(Ae))}}Te.from=Me;function Se(ie){return new v.$YP(m.URI.revive(ie.uri),ie.edits.map(Ae=>ve.to(Ae)))}Te.to=Se})(mi||(e.ChatResponseTextEditPart=mi={}));var xt;(function(Te){function Me(ie){const Ae=w.ThemeIcon.isThemeIcon(ie.iconPath)?ie.iconPath:m.URI.isUri(ie.iconPath)?{light:m.URI.revive(ie.iconPath)}:ie.iconPath&&"light"in ie.iconPath&&"dark"in ie.iconPath&&m.URI.isUri(ie.iconPath.light)&&m.URI.isUri(ie.iconPath.dark)?{light:m.URI.revive(ie.iconPath.light),dark:m.URI.revive(ie.iconPath.dark)}:void 0;return"variableName"in ie.value?{kind:"reference",reference:{variableName:ie.value.variableName,value:m.URI.isUri(ie.value.value)||!ie.value.value?ie.value.value:L.from(ie.value.value)},iconPath:Ae,options:ie.options}:{kind:"reference",reference:m.URI.isUri(ie.value)?ie.value:L.from(ie.value),iconPath:Ae,options:ie.options}}Te.from=Me;function Se(ie){const Ae=(0,c.$ci)(ie),Ge=_e=>m.URI.isUri(_e)?_e:L.to(_e);return new v.$WP("variableName"in Ae.reference?{variableName:Ae.reference.variableName,value:Ae.reference.value&&Ge(Ae.reference.value)}:Ge(Ae.reference))}Te.to=Se})(xt||(e.ChatResponseReferencePart=xt={}));var ki;(function(Te){function Me(Se){return{kind:"codeCitation",value:Se.value,license:Se.license,snippet:Se.snippet}}Te.from=Me})(ki||(e.ChatResponseCodeCitationPart=ki={}));var bi;(function(Te){function Me(Ae,Ge,_e){return Ae instanceof v.$MP?ri.from(Ae):Ae instanceof v.$RP?Jt.from(Ae):Ae instanceof v.$WP?xt.from(Ae):Ae instanceof v.$SP?Ft.from(Ae):Ae instanceof v.$QP?Zt.from(Ae):Ae instanceof v.$VP?Pt.from(Ae,Ge,_e):Ae instanceof v.$YP?mi.from(Ae):Ae instanceof v.$NP?Qt.from(Ae):Ae instanceof v.$OP?li.from(Ae):Ae instanceof v.$UP?wt.from(Ae):Ae instanceof v.$PP?qt.from(Ae):Ae instanceof v.$XP?ki.from(Ae):{kind:"markdownContent",content:ce.from("")}}Te.from=Me;function Se(Ae,Ge){switch(Ae.kind){case"reference":return xt.to(Ae);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ie(Ae,Ge)}}Te.to=Se;function ie(Ae,Ge){switch(Ae.kind){case"markdownContent":return ri.to(Ae);case"inlineReference":return Jt.to(Ae);case"progressMessage":return;case"treeData":return Zt.to(Ae);case"command":return Pt.to(Ae,Ge)}}Te.toContent=ie})(bi||(e.ChatResponsePart=bi={}));var Ri;(function(Te){function Me(Se,ie){const Ae=Se.variables.variables.filter(_e=>_e.isTool).map(_e=>_e.id),Ge=Se.variables.variables.filter(_e=>!_e.isTool);return{prompt:Se.message,command:Se.command,attempt:Se.attempt??0,enableCommandDetection:Se.enableCommandDetection??!0,references:Ge.map(Li.to),location:Ot.to(Se.location),acceptedConfirmationData:Se.acceptedConfirmationData,rejectedConfirmationData:Se.rejectedConfirmationData,location2:ie,requestedTools:Ae}}Te.to=Me})(Ri||(e.ChatAgentRequest=Ri={}));var Ot;(function(Te){function Me(ie){switch(ie){case g.ChatAgentLocation.Notebook:return v.ChatLocation.Notebook;case g.ChatAgentLocation.Terminal:return v.ChatLocation.Terminal;case g.ChatAgentLocation.Panel:return v.ChatLocation.Panel;case g.ChatAgentLocation.Editor:return v.ChatLocation.Editor}}Te.to=Me;function Se(ie){switch(ie){case v.ChatLocation.Notebook:return g.ChatAgentLocation.Notebook;case v.ChatLocation.Terminal:return g.ChatAgentLocation.Terminal;case v.ChatLocation.Panel:return g.ChatAgentLocation.Panel;case v.ChatLocation.Editor:return g.ChatAgentLocation.Editor}}Te.from=Se})(Ot||(e.ChatLocation=Ot={}));var Li;(function(Te){function Me(Se){const ie=Se.value;if(!ie)throw new Error("Invalid value reference");return{id:Se.id,name:Se.name,range:Se.range&&[Se.range.start,Se.range.endExclusive],value:(0,m.$vc)(ie)?m.URI.revive(ie):ie&&typeof ie=="object"&&"uri"in ie&&"range"in ie&&(0,m.$vc)(ie.uri)?L.to((0,c.$ci)(ie)):ie,modelDescription:Se.modelDescription}}Te.to=Me})(Li||(e.ChatAgentValueReference=Li={}));var ui;(function(Te){function Me(Se,ie,Ae){return{id:Se.id,label:Se.label,fullName:Se.fullName,icon:Se.icon?.id,value:Se.values[0].value,insertText:Se.insertText,detail:Se.detail,documentation:Se.documentation,command:ie.toInternal(Se.command,Ae)}}Te.from=Me})(ui||(e.ChatAgentCompletionItem=ui={}));var At;(function(Te){function Me(Se){return{errorDetails:Se.errorDetails,metadata:Se.metadata}}Te.to=Me})(At||(e.ChatAgentResult=At={}));var Ti;(function(Te){function Me(Se,ie,Ae){if(ie.action.kind==="vote")return;const Ge=At.to(Se);if(ie.action.kind==="command"){const _e=ie.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ae.fromInternal(_e)??{command:_e.id,title:_e.title}}},result:Ge}}else return ie.action.kind==="followUp"?{action:{kind:"followUp",followup:jt.to(ie.action.followup)},result:Ge}:ie.action.kind==="inlineChat"?{action:{kind:"editor",accepted:ie.action.action==="accepted"},result:Ge}:{action:ie.action,result:Ge}}Te.to=Me})(Ti||(e.ChatAgentUserActionEvent=Ti={}));var Ii;(function(Te){function Me(Se,ie,Ae){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand,shouldExecute:Se.shouldExecute}:"uri"in Se?{uri:Se.uri}:ie.toInternal(Se,Ae)}Te.from=Me})(Ii||(e.TerminalQuickFix=Ii={}));var Si;(function(Te){function Me(Se){return{kind:Ni.to(Se.kind)}}Te.to=Me})(Si||(e.PartialAcceptInfo=Si={}));var Ni;(function(Te){function Me(Se){switch(Se){case s.PartialAcceptTriggerKind.Word:return v.PartialAcceptTriggerKind.Word;case s.PartialAcceptTriggerKind.Line:return v.PartialAcceptTriggerKind.Line;case s.PartialAcceptTriggerKind.Suggest:return v.PartialAcceptTriggerKind.Suggest;default:return v.PartialAcceptTriggerKind.Unknown}}Te.to=Me})(Ni||(e.PartialAcceptTriggerKind=Ni={}));var wi;(function(Te){function Me(Se,ie){return{id:ie,label:Se.label,description:Se.description,canEdit:Se.canEdit,collapsibleState:Se.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:Se.contextValue}}Te.from=Me})(wi||(e.DebugTreeItem=wi={}));var Vt;(function(Te){function Me(Se){return{name:Se.name,description:Se.description,parametersSchema:Se.parametersSchema}}Te.to=Me})(Vt||(e.LanguageModelToolDescription=Vt={}))}),define(ke[294],Ie([1,0,6,19,15,53]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Epc=void 0;let O=class{constructor(p,c){this.a=p.getProxy(r.$KN.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>c.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,c,I){const S=new R.$Xw(C.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(S,void 0,I?.isRefactoring??!1)}};e.$Epc=O,e.$Epc=O=Je([Ve(0,h.$kQ)],O)}),define(ke[295],Ie([1,0,18,7,52,4,39,3,44,42,17,2,23,6,15,9,153,257,25]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fpc=void 0,w=qe(w),a=qe(a);class i{constructor(n,d,l,g,E){this.j=n,this.k=d,this.l=l,this.m=g,this.n=E,this.b=c.$fe.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let d=function(g){if(n.c){const E=new Error("Response stream has been closed");throw Error.captureStackTrace(E,g),E}};const n=this;this.b.reset();const l=(g,E)=>{if(typeof this.d>"u"&&"content"in g&&(this.d=this.b.elapsed()),E){const D=this.l.$handleProgressChunk(this.k.requestId,g),y={report:k=>{D?.then(A=>{A&&(a.$eO.isMarkdownString(k.value)?this.l.$handleProgressChunk(this.k.requestId,w.ChatResponseWarningPart.from(k),A):this.l.$handleProgressChunk(this.k.requestId,w.ChatResponseReferencePart.from(k),A))})}};Promise.all([D,E?.(y)]).then(([k,A])=>{k!==void 0&&A!==void 0&&this.l.$handleProgressChunk(this.k.requestId,w.ChatTaskResult.from(A),k)})}else this.l.$handleProgressChunk(this.k.requestId,g)};this.g={markdown(g){d(this.markdown);const E=new a.$MP(g),D=w.ChatResponseMarkdownPart.from(E);return l(D),this},markdownWithVulnerabilities(g,E){d(this.markdown),E&&(0,f.$gH)(n.j,"chatParticipantAdditions");const D=new a.$NP(g,E),y=w.ChatResponseMarkdownWithVulnerabilitiesPart.from(D);return l(y),this},filetree(g,E){d(this.filetree);const D=new a.$QP(g,E),y=w.ChatResponseFilesPart.from(D);return l(y),this},anchor(g,E){d(this.anchor);const D=new a.$RP(g,E),y=w.ChatResponseAnchorPart.from(D);return l(y),this},button(g){d(this.anchor);const E=new a.$VP(g),D=w.ChatResponseCommandButtonPart.from(E,n.m,n.n);return l(D),this},progress(g,E){d(this.progress);const D=new a.$TP(g,E),y=E?w.ChatTask.from(D):w.ChatResponseProgressPart.from(D);return l(y,E),this},warning(g){d(this.progress),(0,f.$gH)(n.j,"chatParticipantAdditions");const E=new a.$UP(g),D=w.ChatResponseWarningPart.from(E);return l(D),this},reference(g,E){return this.reference2(g,E)},reference2(g,E,D){if(d(this.reference),"variableName"in g&&(0,f.$gH)(n.j,"chatParticipantAdditions"),"variableName"in g&&!g.value){const y=n.k.variables.variables.find(k=>k.name===g.variableName);if(y){let k;if(y.references?.length)k=y.references.map(A=>({kind:"reference",reference:{variableName:g.variableName,value:A.reference}}));else{const A=new a.$WP(g,E,D);k=[w.ChatResponseReferencePart.from(A)]}return k.forEach(A=>l(A)),this}}else{const y=new a.$WP(g,E,D),k=w.ChatResponseReferencePart.from(y);l(k)}return this},codeCitation(g,E,D){d(this.codeCitation),(0,f.$gH)(n.j,"chatParticipantAdditions");const y=new a.$XP(g,E,D),k=w.ChatResponseCodeCitationPart.from(y);l(k)},textEdit(g,E){d(this.textEdit),(0,f.$gH)(n.j,"chatParticipantAdditions");const D=new a.$YP(g,E),y=w.ChatResponseTextEditPart.from(D);return l(y),this},detectedParticipant(g,E){d(this.detectedParticipant),(0,f.$gH)(n.j,"chatParticipantAdditions");const D=new a.$OP(g,E),y=w.ChatResponseDetectedParticipantPart.from(D);return l(y),this},confirmation(g,E,D,y){d(this.confirmation),(0,f.$gH)(n.j,"chatParticipantAdditions");const k=new a.$PP(g,E,D,y),A=w.ChatResponseConfirmationPart.from(k);return l(A),this},push(g){if(d(this.push),(g instanceof a.$YP||g instanceof a.$NP||g instanceof a.$OP||g instanceof a.$UP||g instanceof a.$PP||g instanceof a.$XP)&&(0,f.$gH)(n.j,"chatParticipantAdditions"),g instanceof a.$WP)this.reference2(g.value,g.iconPath,g.options);else{const E=w.ChatResponsePart.from(g,n.m,n.n);l(E)}return this}}}return this.g}}class s extends T.$Uc{static{this.b=0}constructor(n,d,l,g){super(),this.n=d,this.s=l,this.t=g,this.c=new Map,this.j=this.B(new T.$4c),this.m=this.B(new T.$4c),this.g=n.getProxy(P.$KN.MainThreadChatAgents2)}transferActiveChat(n){this.g.$transferActiveChatSession(n)}createChatAgent(n,d,l){const g=s.b++,E=new t(n,d,this.g,g,l);return this.c.set(g,E),this.g.$registerAgent(g,n.identifier,d,{},void 0),E.apiAgent}createDynamicChatAgent(n,d,l,g){const E=s.b++,D=new t(n,d,this.g,E,g);return this.c.set(E,D),this.g.$registerAgent(E,n.identifier,d,{isSticky:!0},l),D.apiAgent}async $invokeAgent(n,d,l,g){const E=this.c.get(n);if(!E)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);const D=(0,p.$ci)(d);let y=this.j.get(D.sessionId);y||(y=new T.$Tc,this.j.set(D.sessionId,y));const k=new i(E.extension,D,this.g,this.s.converter,y);try{const A=await this.u(D.agentId,l);let b;if(D.locationData?.type===m.ChatAgentLocation.Editor){const F=this.t.getDocument(D.locationData.document);b=new a.$2P(F,w.Selection.to(D.locationData.selection),w.Range.to(D.locationData.wholeRange))}else if(D.locationData?.type===m.ChatAgentLocation.Notebook){const F=this.t.getDocument(D.locationData.sessionInputUri);b=new a.$3P(F)}else D.locationData?.type,m.ChatAgentLocation.Terminal;const v=E.invoke(w.ChatAgentRequest.to(D,b),{history:A},k.apiObject,g);return await(0,h.$th)(Promise.resolve(v).then(F=>{if(F?.metadata)try{JSON.stringify(F.metadata)}catch(L){const M=`result.metadata MUST be JSON.stringify-able. Got error: ${L.message}`;return this.n.error(`[${E.extension.identifier.value}] [@${E.id}] ${M}`,E.extension),{errorDetails:{message:M},timings:k.timings}}let N;return F?.errorDetails&&(N={...F.errorDetails,responseIsIncomplete:!0}),N?.responseIsRedacted&&(0,f.$gH)(E.extension,"chatParticipantPrivate"),{errorDetails:N,timings:k.timings,metadata:F?.metadata}}),g)}catch(A){return this.n.error(A,E.extension),A instanceof a.$$P&&A.cause&&(A=A.cause),{errorDetails:{message:(0,C.$qj)(A),responseIsIncomplete:!0}}}finally{k.close()}}async u(n,d){const l=[];for(const g of d.history){const E=w.ChatAgentResult.to(g.result),D=n===g.request.agentId?E:{...E,metadata:void 0},y=g.request.variables.variables.filter(A=>!A.isTool).map(w.ChatAgentValueReference.to);l.push(new a.$ZP(g.request.message,g.request.command,y,g.request.agentId));const k=(0,r.$Gb)(g.response.map(A=>w.ChatResponsePart.toContent(A,this.s.converter)));l.push(new a.$1P(k,D,g.request.agentId,g.request.command))}return l}$releaseSession(n){this.j.deleteAndDispose(n)}async $provideFollowups(n,d,l,g,E){const D=this.c.get(d);if(!D)return Promise.resolve([]);const y=(0,p.$ci)(n),k=await this.u(D.id,g),A=w.ChatAgentResult.to(l);return(await D.provideFollowups(A,{history:k},E)).filter(b=>{const v=!b.participant||O.Iterable.some(this.c.values(),F=>F.id===b.participant&&u.$rn.equals(F.extension.identifier,D.extension.identifier));return v||this.n.warn(`[@${D.id}] ChatFollowup refers to an unknown participant: ${b.participant}`),v}).map(b=>w.ChatFollowup.from(b,y))}$acceptFeedback(n,d,l,g){const E=this.c.get(n);if(!E)return;const D=w.ChatAgentResult.to(d);let y;switch(l){case $.ChatAgentVoteDirection.Down:y=a.ChatResultFeedbackKind.Unhelpful;break;case $.ChatAgentVoteDirection.Up:y=a.ChatResultFeedbackKind.Helpful;break}E.acceptFeedback(Object.freeze(g?{result:D,kind:y,reportIssue:g}:{result:D,kind:y}))}$acceptAction(n,d,l){const g=this.c.get(n);if(!g||l.action.kind==="vote")return;const E=w.ChatAgentUserActionEvent.to(d,l,this.s.converter);E&&g.acceptAction(Object.freeze(E))}async $invokeCompletionProvider(n,d,l){const g=this.c.get(n);if(!g)return[];let E=this.m.get(n);return E?E.clear():(E=new T.$Tc,this.m.set(n,E)),(await g.invokeCompletionProvider(d,l)).map(y=>w.ChatAgentCompletionItem.from(y,this.s.converter,E))}async $provideWelcomeMessage(n,d,l){const g=this.c.get(n);if(g)return await g.provideWelcomeMessage(w.ChatLocation.to(d),l)}async $provideSampleQuestions(n,d,l){const g=this.c.get(n);if(g)return(await g.provideSampleQuestions(w.ChatLocation.to(d),l)).map(E=>w.ChatFollowup.from(E,void 0))}}e.$Fpc=s;class t{constructor(n,d,l,g,E){this.extension=n,this.id=d,this.w=l,this.x=g,this.y=E,this.m=new R.$le,this.n=new R.$le}acceptFeedback(n){this.m.fire(n)}acceptAction(n){this.n.fire(n)}async invokeCompletionProvider(n,d){return this.q?await this.q.provider.provideCompletionItems(n,d)??[]:[]}async provideFollowups(n,d,l){if(!this.b)return[];const g=await this.b.provideFollowups(n,d,l);return g?g.filter(E=>!(E&&"commandId"in E)).filter(E=>!(E&&"message"in E)):[]}async provideWelcomeMessage(n,d){if(!this.s)return[];const l=await this.s.provideWelcomeMessage(n,d);return l?l.map(g=>typeof g=="string"?g:w.MarkdownString.from(g)):[]}async provideSampleQuestions(n,d){if(!this.s||!this.s.provideSampleQuestions)return[];const l=await this.s.provideSampleQuestions(n,d);return l||[]}get apiAgent(){let n=!1,d=!1;const l=()=>{n||d||(d=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof S.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof a.$LO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:w.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:w.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:w.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),d=!1}))},g=this;return{get id(){return g.id},get iconPath(){return g.c},set iconPath(E){g.c=E,l()},get requestHandler(){return g.y},set requestHandler(E){(0,I.$og)(typeof E=="function","Invalid request handler"),g.y=E},get followupProvider(){return g.b},set followupProvider(E){g.b=E,l()},get isDefault(){return(0,f.$gH)(g.extension,"defaultChatParticipant"),g.d},set isDefault(E){(0,f.$gH)(g.extension,"defaultChatParticipant"),g.d=E,l()},get helpTextPrefix(){return(0,f.$gH)(g.extension,"defaultChatParticipant"),g.g},set helpTextPrefix(E){(0,f.$gH)(g.extension,"defaultChatParticipant"),g.g=E,l()},get helpTextVariablesPrefix(){return(0,f.$gH)(g.extension,"defaultChatParticipant"),g.j},set helpTextVariablesPrefix(E){(0,f.$gH)(g.extension,"defaultChatParticipant"),g.j=E,l()},get helpTextPostfix(){return(0,f.$gH)(g.extension,"defaultChatParticipant"),g.k},set helpTextPostfix(E){(0,f.$gH)(g.extension,"defaultChatParticipant"),g.k=E,l()},get isSecondary(){return(0,f.$gH)(g.extension,"defaultChatParticipant"),g.l},set isSecondary(E){(0,f.$gH)(g.extension,"defaultChatParticipant"),g.l=E,l()},get supportIssueReporting(){return(0,f.$gH)(g.extension,"chatParticipantPrivate"),g.o},set supportIssueReporting(E){(0,f.$gH)(g.extension,"chatParticipantPrivate"),g.o=E,l()},get onDidReceiveFeedback(){return g.m.event},set participantVariableProvider(E){if((0,f.$gH)(g.extension,"chatParticipantAdditions"),g.q=E,E){if(!E.triggerCharacters.length)throw new Error("triggerCharacters are required");g.w.$registerAgentCompletionsProvider(g.x,g.id,E.triggerCharacters)}else g.w.$unregisterAgentCompletionsProvider(g.x,g.id)},get participantVariableProvider(){return(0,f.$gH)(g.extension,"chatParticipantAdditions"),g.q},set welcomeMessageProvider(E){(0,f.$gH)(g.extension,"defaultChatParticipant"),g.s=E,l()},get welcomeMessageProvider(){return(0,f.$gH)(g.extension,"defaultChatParticipant"),g.s},onDidPerformAction:(0,f.$fH)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(E){g.t=E,l()},get requester(){return g.t},set supportsSlowReferences(E){(0,f.$gH)(g.extension,"chatParticipantPrivate"),g.u=E,l()},get supportsSlowReferences(){return(0,f.$gH)(g.extension,"chatParticipantPrivate"),g.u},dispose(){n=!0,g.b=void 0,g.m.dispose(),g.w.$unregisterAgent(g.x)}}}invoke(n,d,l,g){return this.y(n,d,l,g)}}}),define(ke[296],Ie([1,0,13,3,51,6,15,9,25]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gpc=void 0,O=qe(O),T=qe(T);class c{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(R.$KN.MainThreadChatVariables)}async $resolveVariable(u,P,w,a){const m=this.b.get(u);if(m)try{if(m.resolver.resolve2){(0,p.$gH)(m.extension,"chatParticipantAdditions");const $=new I(P,this.c),f=await m.resolver.resolve2(m.data.name,{prompt:w},$.apiObject,a);if(f&&f[0])return f[0].value}else{const $=await m.resolver.resolve(m.data.name,{prompt:w},a);if($&&$[0])return $[0].value}}catch($){(0,r.$Z)($)}}registerVariableResolver(u,P,w,a,m,$,f,i,s){const t=c.a++,o=s?C.ThemeIcon.fromId(s):void 0;return this.b.set(t,{extension:u,data:{id:P,name:w,description:a,modelDescription:m,icon:o},resolver:f}),this.c.$registerVariable(t,{id:P,name:w,description:a,modelDescription:m,isSlow:$,fullName:i,icon:o}),(0,h.$Sc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$Gpc=c;class I{constructor(u,P){this.c=u,this.d=P,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let P=function(a){if(u.a){const m=new Error("Response stream has been closed");throw Error.captureStackTrace(m,a),m}};const u=this,w=a=>{this.d.$handleProgressChunk(this.c,a)};this.b={progress(a){P(this.progress);const m=new T.$SP(a),$=O.ChatResponseProgressPart.from(m);return w($),this},reference(a){P(this.reference);const m=new T.$WP(a),$=O.ChatResponseReferencePart.from(m);return w($),this},push(a){return P(this.push),a instanceof T.$WP?w(O.ChatResponseReferencePart.from(a)):a instanceof T.$SP&&w(O.ChatResponseProgressPart.from(a)),this}}}return this.b}}}),define(ke[297],Ie([1,0,7,59,4,3,40,2,87,23,15,9,6,25]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kpc=w,p=qe(p),I=qe(I),S=qe(S);function w(a,m,$){const f=a.getProxy(u.$KN.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new c.$tn,m.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===O.MarshalledId.CommentController){const k=this.b.get(y.handle);return k?k.value:y}else if(y&&y.$mid===O.MarshalledId.CommentThread){const k=y,A=this.b.get(k.commentControlHandle);if(!A)return k;const b=A.getCommentThread(k.commentThreadHandle);return b?b.value:k}else if(y&&(y.$mid===O.MarshalledId.CommentThreadReply||y.$mid===O.MarshalledId.CommentThreadInstance)){const k=this.b.get(y.thread.commentControlHandle);if(!k)return y;const A=k.getCommentThread(y.thread.commentThreadHandle);return A?y.$mid===O.MarshalledId.CommentThreadInstance?A.value:{thread:A.value,text:y.text}:y}else if(y&&y.$mid===O.MarshalledId.CommentNode){const k=this.b.get(y.thread.commentControlHandle);if(!k)return y;const A=k.getCommentThread(y.thread.commentThreadHandle);if(!A)return y;const b=y.commentUniqueId,v=A.getCommentByUniqueId(b);return v||y}else if(y&&y.$mid===O.MarshalledId.CommentThreadNode){const k=this.b.get(y.thread.commentControlHandle);if(!k)return y;const A=k.getCommentThread(y.thread.commentThreadHandle);if(!A)return y;const b=y.text,v=y.commentUniqueId,F=A.getCommentByUniqueId(v);return F?(typeof F.body=="string"?F.body=b:F.body=new S.$eO(b),F):y}return y}})}createCommentController(y,k,A){const b=i.a++,v=new t(y,b,k,A);this.b.set(v.handle,v);const F=this.c.get(y.identifier)||[];return F.push(v),this.c.set(y.identifier,F),v.value}async $createCommentThreadTemplate(y,k,A,b){const v=this.b.get(y);v&&v.$createCommentThreadTemplate(k,A,b)}async $setActiveComment(y,k){const A=this.b.get(y);A&&A.$setActiveComment(k??void 0)}async $updateCommentThreadTemplate(y,k,A){const b=this.b.get(y);b&&b.$updateCommentThreadTemplate(k,A)}$deleteCommentThread(y,k){this.b.get(y)?.$deleteCommentThread(k)}async $provideCommentingRanges(y,k,A){const b=this.b.get(y);if(!b||!b.commentingRangeProvider)return Promise.resolve(void 0);const v=await $.ensureDocumentData(T.URI.revive(k));return(0,r.$xh)(async()=>{const F=await b.commentingRangeProvider.provideCommentingRanges(v.document,A);let N;return Array.isArray(F)?N={ranges:F,fileComments:!1}:F?N={ranges:F.ranges||[],fileComments:F.enableFileComments||!1}:N=F??void 0,N}).then(F=>{let N;return F&&(N={ranges:F.ranges.map(L=>I.Range.from(L)),fileComments:F.fileComments}),N})}$toggleReaction(y,k,A,b,v){const F=this.b.get(y);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,r.$xh)(()=>{const N=F.getCommentThread(k);if(N){const L=N.getCommentByUniqueId(b.uniqueIdInThread);if(F!==void 0&&L&&F.reactionHandler)return F.reactionHandler(L,d(v))}return Promise.resolve(void 0)})}}class s{static{this.a=0}set threadId(y){this.n=y}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(y){(y===void 0!=(this.p===void 0)||!y||!this.p||!y.isEqual(this.p))&&(this.p=y,this.b.range=y,this.c.fire())}get range(){return this.p}set canReply(y){this.d!==y&&(this.d=y,this.b.canReply=y,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(y){this.e=y,this.b.label=y,this.c.fire()}get contextValue(){return this.f}set contextValue(y){this.f=y,this.b.contextValue=y,this.c.fire()}get comments(){return this.q}set comments(y){this.q=y,this.b.comments=y,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(y){this.g=y,this.b.collapsibleState=y,this.c.fire()}get state(){return this.h}set state(y){this.h=y,typeof y=="object"?((0,P.$gH)(this.extensionDescription,"commentThreadApplicability"),this.b.state=y.resolved,this.b.applicability=y.applicability):this.b.state=y,this.c.fire()}get isDisposed(){return this.j}constructor(y,k,A,b,v,F,N,L,M){this.m=k,this.n=A,this.o=b,this.p=v,this.q=F,this.extensionDescription=N,this.r=L,this.handle=s.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$le,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Vc,this.l.value=new R.$Tc,this.n===void 0&&(this.n=`${y}.${this.handle}`),f.$createCommentThread(k,this.handle,this.n,this.o,I.Range.from(this.p),this.q.map(j=>o(this,j,this.k,this.extensionDescription)),N.identifier,this.r,M),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{f.$deleteCommentThread(k,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(j){z.range=j},get comments(){return z.comments},set comments(j){z.comments=j},get collapsibleState(){return z.collapsibleState},set collapsibleState(j){z.collapsibleState=j},get canReply(){return z.canReply},set canReply(j){z.canReply=j},get contextValue(){return z.contextValue},set contextValue(j){z.contextValue=j},get label(){return z.label},set label(j){z.label=j},get state(){return z.state},set state(j){z.state=j},reveal:(j,W)=>z.reveal(j,W),hide:()=>z.hide(),dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Tc);const y=A=>Object.prototype.hasOwnProperty.call(this.b,A),k={};y("range")&&(k.range=I.Range.from(this.p)),y("label")&&(k.label=this.label),y("contextValue")&&(k.contextValue=this.contextValue??null),y("comments")&&(k.comments=this.q.map(A=>o(this,A,this.k,this.extensionDescription))),y("collapsibleState")&&(k.collapseState=l(this.g)),y("canReply")&&(k.canReply=this.canReply),y("state")&&(k.state=g(this.h)),y("applicability")&&(k.applicability=E(this.h)),y("isTemplate")&&(k.isTemplate=this.r),this.b={},f.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(y){for(const k of this.k){const A=k[0],b=k[1];if(y===b)return A}}async reveal(y,k){(0,P.$gH)(this.extensionDescription,"commentReveal");let A;y&&y.body!==void 0?A=y:k=k??y;let b=A?this.k.get(A):void 0;b??=this.k.get(this.q[0]);let v=!0,F=!1;return k?.focus===S.CommentThreadFocus.Reply?(F=!0,v=!1):k?.focus===S.CommentThreadFocus.Comment&&(v=!1),f.$revealCommentThread(this.m,this.handle,b,{preserveFocus:v,focusReply:F})}async hide(){return f.$hideCommentThread(this.m,this.handle)}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(y=>y.dispose())}}Je([(0,h.$$h)(100)],s.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(y){this.b=y,y?.resourceHints&&(0,P.$gH)(this.h,"commentingRangeHint"),f.$updateCommentingRanges(this.handle,y?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(y){this.c=y,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!y})}get options(){return this.d}set options(y){this.d=y,f.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,P.$gH)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,P.$gH)(this.h,"activeComment"),this.f}constructor(y,k,A,b){this.h=y,this.i=k,this.j=A,this.k=b,this.a=new Map,f.$registerCommentController(this.handle,A,b,this.h.identifier.value);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(F){v.options=F},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(F){v.commentingRangeProvider=F},get reactionHandler(){return v.reactionHandler},set reactionHandler(F){v.reactionHandler=F},get activeCommentThread(){return v.activeCommentThread},createCommentThread(F,N,L){return v.createCommentThread(F,N,L).value},dispose:()=>{v.dispose()}}),this.g=[],this.g.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}createCommentThread(y,k,A){k===void 0&&(0,P.$gH)(this.h,"fileComments");const b=new s(this.id,this.handle,void 0,y,k,A,this.h,!1);return this.a.set(b.handle,b),b}$setActiveComment(y){if(!y){this.e=void 0,this.f=void 0;return}const k=this.a.get(y.commentThreadHandle);k&&(this.e=y.uniqueIdInThread?k.getCommentByUniqueId(y.uniqueIdInThread):void 0,this.f=k)}$createCommentThreadTemplate(y,k,A){const b=new s(this.id,this.handle,void 0,T.URI.revive(y),I.Range.to(k),[],this.h,!0,A);return b.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(b.handle,b),b}$updateCommentThreadTemplate(y,k){const A=this.a.get(y);A&&(A.range=I.Range.to(k))}$deleteCommentThread(y){this.a.get(y)?.dispose(),this.a.delete(y)}getCommentThread(y){return this.a.get(y)}dispose(){this.a.forEach(y=>{y.dispose()}),this.g.forEach(y=>y.dispose())}}function o(D,y,k,A){let b=k.get(y);return b||(b=++D.commentHandle,k.set(y,b)),y.state!==void 0&&(0,P.$gH)(A,"commentsDraftState"),y.reactions?.some(v=>v.reactors!==void 0)&&(0,P.$gH)(A,"commentReactor"),{mode:y.mode,contextValue:y.contextValue,uniqueIdInThread:b,body:typeof y.body=="string"?y.body:I.MarkdownString.from(y.body),userName:y.author.name,userIconPath:y.author.iconPath,label:y.label,commentReactions:y.reactions?y.reactions.map(v=>n(v)):void 0,state:y.state,timestamp:y.timestamp?.toJSON()}}function n(D){return{label:D.label,iconPath:D.iconPath?I.$jQ(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(y=>y.name):D.reactors}}function d(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?T.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(y=>({name:y}))}}function l(D){if(D!==void 0)switch(D){case S.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case S.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function g(D){let y;if(typeof D=="object"?y=D.resolved:y=D,y!==void 0)switch(y){case S.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case S.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function E(D){let y;if(typeof D=="object"&&(y=D.applicability),y!==void 0)switch(y){case S.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case S.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new i}}),define(ke[298],Ie([1,0,20,60,3,14,22,2,15,96,118,6,9]),function($e,e,r,h,C,R,O,T,p,c,I,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pc=void 0,p=qe(p),S=qe(S),u=qe(u);class P{constructor(n,d){this.document=n,this.b=d,this.a=1,this.c=new I.$qpc("custom documents")}addEdit(n){return this.c.add([n])}async undo(n,d){await this.f(n).undo(),d||this.disposeBackup()}async redo(n,d){await this.f(n).redo(),d||this.disposeBackup()}disposeEdits(n){for(const d of n)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const n=t(this.document.uri)+this.a++;return(0,O.$gh)(this.b,n)}updateBackup(n){this.d?.delete(),this.d=n}disposeBackup(){this.d?.delete(),this.d=void 0}f(n){const d=this.c.get(n,0);if(!d)throw new Error("No edit found");return d}}class w{constructor(){this.a=new Map}get(n,d){return this.a.get(this.b(n,d))}add(n,d,l){const g=this.b(n,d.uri);if(this.a.has(g))throw new Error(`Document already exists for viewType:${n} resource:${d.uri}`);const E=new P(d,l);return this.a.set(g,E),E}delete(n,d){const l=this.b(n,d.uri);this.a.delete(l)}b(n,d){return`${n}@@@${d}`}}var a;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(a||(a={}));class m{constructor(){this.a=new Map}addTextProvider(n,d,l){return this.b(n,{type:a.Text,extension:d,provider:l})}addCustomProvider(n,d,l){return this.b(n,{type:a.Custom,extension:d,provider:l})}get(n){return this.a.get(n)}b(n,d){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,d),new u.$MN(()=>this.a.delete(n))}}class ${constructor(n,d,l,g,E){this.d=d,this.f=l,this.g=g,this.h=E,this.b=new m,this.c=new w,this.a=n.getProxy(S.$KN.MainThreadCustomEditors)}registerCustomEditorProvider(n,d,l,g){const E=new C.$Tc;return i(l)?(E.add(this.b.addTextProvider(d,n,l)),this.a.$registerTextEditorProvider((0,c.$Zpc)(n),d,g.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,c.$Xpc)(n))):(E.add(this.b.addCustomProvider(d,n,l)),f(l)&&E.add(l.onDidChangeCustomDocument(D=>{const y=this.i(d,D.document.uri);if(s(D)){const k=y.addEdit(D);this.a.$onDidEdit(D.document.uri,d,k,D.label)}else this.a.$onContentChange(D.document.uri,d)})),this.a.$registerCustomEditorProvider((0,c.$Zpc)(n),d,g.webviewOptions||{},!!g.supportsMultipleEditorsPerDocument,(0,c.$Xpc)(n))),u.$MN.from(E,new u.$MN(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(n,d,l,g,E){const D=this.b.get(d);if(!D)throw new Error(`No provider found for '${d}'`);if(D.type!==a.Custom)throw new Error(`Invalid provide type for '${d}'`);const y=T.URI.revive(n),k=await D.provider.openCustomDocument(y,{backupId:l,untitledDocumentData:g?.buffer},E);let A;return f(D.provider)&&this.f&&(A=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(d,k,A),{editable:f(D.provider)}}async $disposeCustomDocument(n,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(l.type!==a.Custom)throw new Error(`Invalid provider type for '${d}'`);const g=T.URI.revive(n),{document:E}=this.i(d,g);this.c.delete(d,E),E.dispose()}async $resolveCustomEditor(n,d,l,g,E,D){const y=this.b.get(l);if(!y)throw new Error(`No provider found for '${l}'`);const k=p.ViewColumn.to(E),A=this.g.createNewWebview(d,g.contentOptions,y.extension),b=this.h.createNewWebviewPanel(d,l,g.title,k,g.options,A,g.active),v=T.URI.revive(n);switch(y.type){case a.Custom:{const{document:F}=this.i(l,v);return y.provider.resolveCustomEditor(F,b,D)}case a.Text:{const F=this.d.getDocument(v);return y.provider.resolveCustomTextEditor(F,b,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,d,l){this.i(d,n).disposeEdits(l)}async $onMoveCustomEditor(n,d,l){const g=this.b.get(l);if(!g)throw new Error(`No provider found for '${l}'`);if(!g.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const E=this.h.getWebviewPanel(n);if(!E)throw new Error("No webview found");const D=T.URI.revive(d),y=this.d.getDocument(D);await g.provider.moveCustomTextEditor(y,E,r.CancellationToken.None)}async $undo(n,d,l,g){return this.i(d,n).undo(l,g)}async $redo(n,d,l,g){return this.i(d,n).redo(l,g)}async $revert(n,d,l){const g=this.i(d,n);await this.j(d).revertCustomDocument(g.document,l),g.disposeBackup()}async $onSave(n,d,l){const g=this.i(d,n);await this.j(d).saveCustomDocument(g.document,l),g.disposeBackup()}async $onSaveAs(n,d,l,g){const E=this.i(d,n);return this.j(d).saveCustomDocumentAs(E.document,T.URI.revive(l),g)}async $backup(n,d,l){const g=this.i(d,n),D=await this.j(d).backupCustomDocument(g.document,{destination:g.getNewBackupUri()},l);return g.updateBackup(D),D.id}i(n,d){const l=this.c.get(n,T.URI.revive(d));if(!l)throw new Error("No custom document found");return l}j(n){const l=this.b.get(n)?.provider;if(!l||!f(l))throw new Error("Custom document is not editable");return l}}e.$3pc=$;function f(o){return!!o.onDidChangeCustomDocument}function i(o){return typeof o.resolveCustomTextEditor=="function"}function s(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function t(o){const n=o.scheme===R.Schemas.file||o.scheme===R.Schemas.untitled?o.fsPath:o.toString();return(0,h.$tj)(n)+""}}),define(ke[299],Ie([1,0,8,145,2,6,9,15,4,11,28,62]),function($e,e,r,h,C,R,O,T,p,c,I,S){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$ypc=e.$xpc=void 0,T=qe(T);class P{#e;#t;#i;constructor(m,$,f,i,s,t,o,n){this.d=m,this.e=$,this.f=f,this.g=i,this.h=s,this.c=!1,this.f=Math.max(i,f),this.#i=new I.$Ac(d=>t.getComparisonKey(d)),this.#e=o,this.#t=n}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,$){if(!m){this.clear();return}this.j();let f=[];if(C.URI.isUri(m)){if(!$){this.delete(m);return}this.#i.set(m,$.slice()),f=[m]}else if(Array.isArray(m)){f=[];let t;m=[...m].sort(P.k);for(const o of m){const[n,d]=o;if((!t||n.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=n,f.push(n),this.#i.set(n,[])),d)this.#i.get(n)?.push(...d);else{const l=this.#i.get(n);l&&(l.length=0)}}}if(this.#t.fire(f),!this.#e)return;const i=[];let s=0;for(const t of f){let o=[];const n=this.#i.get(t);if(n)if(n.length>this.g){o=[];const d=[O.DiagnosticSeverity.Error,O.DiagnosticSeverity.Warning,O.DiagnosticSeverity.Information,O.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const g of n)if(g.severity===d[l]&&o.push({...T.Diagnostic.from(g),modelVersionId:this.h(t)})===this.g)break e;o.push({severity:h.MarkerSeverity.Info,message:(0,r.localize)(10838,null,n.length-this.g),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=n.map(d=>({...T.Diagnostic.from(d),modelVersionId:this.h(t)}));if(i.push([t,o]),s+=o.length,s>this.f)break}this.#e.$changeMany(this.e,i)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,$){this.j();for(const[f,i]of this)m.call($,f,i,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const $=this.#i.get(m);return Array.isArray($)?Object.freeze($.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,$){return m[0].toString()<$[0].toString()?-1:m[0].toString()>$[0].toString()?1:0}}e.$xpc=P;let w=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*this.d}static _mapper(m){const $=new I.$Ac;for(const f of m)$.set(f,f);return{uris:Object.freeze(Array.from($.values()))}}constructor(m,$,f,i){this.j=$,this.k=f,this.l=i,this.g=new Map,this.h=new p.$pe({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,u._mapper),this.f=m.getProxy(R.$KN.MainThreadDiagnostics)}createDiagnosticCollection(m,$){const{g:f,f:i,h:s,j:t,k:o,l:n}=this,d=new class{$changeMany(E,D){i.$changeMany(E,D),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,E,D.length===0?"CLEARING":D)}$clear(E){i.$clear(E),t.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,E)}dispose(){i.dispose()}};let l;if(!$)$="_generated_diagnostic_collection_name_#"+u.c++,l=$;else if(!f.has($))l=$;else{this.j.warn(`DiagnosticCollection with name '${$}' does already exist.`);do l=$+u.c++;while(f.has(l))}return new class extends P{constructor(){super($,l,u.e,u.d,E=>n.getDocument(E)?.version,o.extUri,d,s),f.set(l,this)}dispose(){super.dispose(),f.delete(l)}}}getDiagnostics(m){if(m)return this.m(m);{const $=new Map,f=[];for(const i of this.g.values())i.forEach((s,t)=>{let o=$.get(s.toString());typeof o>"u"&&(o=f.length,$.set(s.toString(),o),f.push([s,[]])),f[o][1]=f[o][1].concat(...t)});return f}}m(m){let $=[];for(const f of this.g.values())f.has(m)&&($=$.concat(f.get(m)));return $}$acceptMarkersChange(m){if(!this.n){const $="_generated_mirror",f=new P($,$,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set($,f),this.n=f}for(const[$,f]of m)this.n.set(C.URI.revive($),f.map(T.Diagnostic.to))}};e.$ypc=w,e.$ypc=w=u=Je([Ve(1,c.$ak),Ve(2,S.$wpc)],w)}),define(ke[300],Ie([1,0,2,13,9,15,80,53]),function($e,e,r,h,C,R,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lqc=void 0;class p{constructor(I,S,u,P={timeout:1500,errors:3}){this.c=I,this.d=S,this.f=u,this.g=P,this.a=new O.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(S,u,P)=>{const a={dispose:this.a.push([S,u,I])};return Array.isArray(P)&&P.push(a),a}}async $participateInSave(I,S){const u=r.URI.revive(I);let P=!1;const w=setTimeout(()=>P=!0,this.g.timeout),a=[];try{for(const m of[...this.a]){if(P)break;const $=this.d.getDocument(u),f=await this.h(m,{document:$,reason:R.TextDocumentSaveReason.to(S)});a.push(f)}}finally{clearTimeout(w)}return a}h([I,S,u],P){const w=this.b.get(I);return typeof w=="number"&&w>this.g.errors?Promise.resolve(!1):this.i(u,I,S,P).then(()=>!0,a=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const m=this.b.get(I);this.b.set(I,m?m+1:1),typeof m=="number"&&m>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,S,u,P){const w=[],a=Date.now(),{document:m,reason:$}=P,{version:f}=m,i=Object.freeze({document:m,reason:$,waitUntil(s){if(Object.isFrozen(w))throw(0,h.$7)("waitUntil can not be called async");w.push(Promise.resolve(s))}});try{S.apply(u,[i])}catch(s){return Promise.reject(s)}return Object.freeze(w),new Promise((s,t)=>{const o=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(w).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(o),s(n)}).catch(n=>{clearTimeout(o),t(n)})}).then(s=>{const t={edits:[]};for(const o of s)if(Array.isArray(o)&&o.every(n=>n instanceof C.$VN))for(const{newText:n,newEol:d,range:l}of o)t.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:l&&R.Range.from(l),text:n,eol:d&&R.EndOfLine.from(d)}});if(t.edits.length!==0)return f===m.version?this.f.$tryApplyWorkspaceEdit(new T.$Xw(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$Lqc=p}),define(ke[301],Ie([1,0,4,3,2,6,164,15,17,24,9]),function($e,e,r,h,C,R,O,T,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zpc=void 0,T=qe(T);class S{constructor(P,w){this.a=new r.$le,this.b=new r.$le,this.c=new r.$le,this.d=new r.$le,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new h.$Tc,this.h=new Map,this.f=P.getProxy(R.$KN.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(a=>{for(const m of a)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const m of a)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(P){if(!P)return;const w=this.g.getDocument(P);if(w)return w}getDocument(P){const w=this.getDocumentData(P);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${P}'`);return w.document}ensureDocumentData(P){const w=this.g.getDocument(P);if(w)return Promise.resolve(w);let a=this.h.get(P.toString());return a||(a=this.f.$tryOpenDocument(P).then(m=>{this.h.delete(P.toString());const $=C.URI.revive(m);return(0,p.$pg)(this.g.getDocument($))},m=>(this.h.delete(P.toString()),Promise.reject(m))),this.h.set(P.toString(),a)),a}createDocumentData(P){return this.f.$tryCreateDocument(P).then(w=>C.URI.revive(w))}$acceptModelLanguageChanged(P,w){const a=C.URI.revive(P),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(w),this.a.fire(m.document)}$acceptModelSaved(P){const w=C.URI.revive(P),a=this.g.getDocument(w);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(P,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(P,w){const a=C.URI.revive(P),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");m._acceptIsDirty(w),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(P,w,a){const m=C.URI.revive(P),$=this.g.getDocument(m);if(!$)throw new Error("unknown document");$._acceptIsDirty(a),$.onEvents(w);let f;w.isUndoing?f=I.TextDocumentChangeReason.Undo:w.isRedoing&&(f=I.TextDocumentChangeReason.Redo),this.c.fire((0,c.$fo)({document:$.document,contentChanges:w.changes.map(i=>({range:T.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:f}))}setWordDefinitionFor(P,w){(0,O.$mQ)(P,w)}}e.$zpc=S}),define(ke[77],Ie([1,0,78,4,17,2,5,6,19,15,9]),function($e,e,r,h,C,R,O,T,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5pc=e.$4pc=void 0,c=qe(c),e.$4pc=(0,O.$Fi)("IExtHostEditorTabs");class S{constructor(m,$,f){this.e=f,this.d=$,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,$={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze($)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case T.TabInputKind.TextInput:return new I.$AP(R.URI.revive(this.b.input.uri));case T.TabInputKind.TextDiffInput:return new I.$BP(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case T.TabInputKind.TextMergeInput:return new I.$CP(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case T.TabInputKind.CustomEditorInput:return new I.$DP(R.URI.revive(this.b.input.uri),this.b.input.viewType);case T.TabInputKind.WebviewEditorInput:return new I.$EP(this.b.input.viewType);case T.TabInputKind.NotebookInput:return new I.$FP(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case T.TabInputKind.NotebookDiffInput:return new I.$GP(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case T.TabInputKind.TerminalEditorInput:return new I.$HP;case T.TabInputKind.InteractiveEditorInput:return new I.$IP(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case T.TabInputKind.ChatEditorInput:return new I.$JP;case T.TabInputKind.MultiDiffEditorInput:return new I.$KP(this.b.input.diffEditors.map(m=>new I.$BP(R.URI.revive(m.original),R.URI.revive(m.modified))));default:return}}}class u{constructor(m,$){this.c=[],this.d="",this.b=m,this.e=$;for(const f of m.tabs)f.isActive&&(this.d=f.id),this.c.push(new S(f,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,$={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return c.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(f=>f.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(f=>f.apiObject))}};this.a=Object.freeze($)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===T.TabModelOperationKind.TAB_OPEN){const f=new S(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,f),m.tabDto.isActive&&(this.d=f.tabId),f}else if(m.kind===T.TabModelOperationKind.TAB_CLOSE){const f=this.c.splice(m.index,1)[0];if(!f)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return f.tabId===this.d&&(this.d=""),f}else if(m.kind===T.TabModelOperationKind.TAB_MOVE){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const f=this.c.splice(m.oldIndex,1)[0];if(!f)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,f),f}const $=this.c.find(f=>f.tabId===m.tabDto.id);if(!$)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),$.acceptDtoUpdate(m.tabDto),$}activeTabId(){return this.d}}let P=class{constructor(m){this.b=new h.$le,this.c=new h.$le,this.e=[],this.a=m.getProxy(T.$KN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,$={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(f=>f.apiObject))},get activeTabGroup(){const f=m.d;return(0,C.$pg)(m.e.find(s=>s.groupId===f)?.apiObject)},close:async(f,i)=>{const s=Array.isArray(f)?f:[f];return s.length?w(s[0])?this.j(s,i):this.i(s,i):!0}};this.f=Object.freeze($)}return this.f}$acceptEditorTabModel(m){const $=new Set(this.e.map(d=>d.groupId)),f=new Set(m.map(d=>d.groupId)),i=(0,r.$d)($,f),s=this.e.filter(d=>i.removed.includes(d.groupId)).map(d=>d.apiObject),t=[],o=[];this.e=m.map(d=>{const l=new u(d,()=>this.d);return i.added.includes(l.groupId)?t.push(l.apiObject):o.push(l.apiObject),l});const n=(0,C.$pg)(m.find(d=>d.isActive===!0)?.groupId);n!==void 0&&this.d!==n&&(this.d=n),this.c.fire(Object.freeze({opened:t,closed:s,changed:o}))}$acceptTabGroupUpdate(m){const $=this.e.find(f=>f.groupId===m.groupId);if(!$)throw new Error("Update Group IPC call received before group creation.");$.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[$.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const $=this.e.find(i=>i.groupId===m.groupId);if(!$)throw new Error("Update Tabs IPC call received before group creation.");const f=$.acceptTabOperation(m);switch(m.kind){case T.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[f.apiObject],closed:[],changed:[]}));return;case T.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[f.apiObject],changed:[]}));return;case T.TabModelOperationKind.TAB_MOVE:case T.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[f.apiObject]}));return}}g(m){for(const $ of this.e)for(const f of $.tabs)if(f.apiObject===m)return f}h(m){return this.e.find($=>$.apiObject===m)}async i(m,$){const f=[];for(const i of m){const s=this.g(i);if(!s)throw new Error("Tab close: Invalid tab not found!");f.push(s.tabId)}return this.a.$closeTab(f,$)}async j(m,$){const f=[];for(const i of m){const s=this.h(i);if(!s)throw new Error("Group close: Invalid group not found!");f.push(s.groupId)}return this.a.$closeGroup(f,$)}};e.$5pc=P,e.$5pc=P=Je([Ve(0,p.$kQ)],P);function w(a){return a.tabs!==void 0}}),define(ke[302],Ie([1,0,2,6,27,3,9,15,203,12,26,21,25,85]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oqc=void 0,C=qe(C),T=qe(T);class w{constructor(){this.a=[]}add($){this.b=void 0,this.a.push($)}delete($){const f=this.a.indexOf($);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const $=this.a.sort(),f=[];let i,s,t=p.State.LastKnownState,o=p.State.LastKnownState;for(const n of $){let d=i?(0,c.$Hf)(i,n):0;for(d===0?s=p.State.Start:s=o;d<n.length;d++)d+1===n.length?(t=o,o=p.State.BeforeColon):o+=1,f.push([s,n.toUpperCase().charCodeAt(d),o]),f.push([s,n.toLowerCase().charCodeAt(d),o]),s=o;i=n,o=t}f.push([p.State.BeforeColon,I.CharCode.Colon,p.State.AfterColon]),f.push([p.State.AfterColon,I.CharCode.Slash,p.State.End]),this.b=new p.$F4(f)}}provideDocumentLinks($){this.c();const f=[],i=p.$G4.computeLinks({getLineContent(s){return $.lineAt(s-1).text},getLineCount(){return $.lineCount}},this.b);for(const s of i){const t=T.DocumentLink.to(s);t.target&&f.push(t)}return f}}class a{constructor($,f){this.i=f,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=$.getProxy(h.$KN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider($,f,i,s={}){if(a.j(i),this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider($,"*",this.b));const t=this.h++;this.b.add(f),this.d.add(f),this.c.set(t,i);let o=C.FileSystemProviderCapabilities.FileReadWrite;s.isCaseSensitive&&(o+=C.FileSystemProviderCapabilities.PathCaseSensitive),s.isReadonly&&(o+=C.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(o+=C.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,u.$gH)($,"fsChunks"),o+=C.FileSystemProviderCapabilities.FileOpenReadWriteClose);let n;s.isReadonly&&(0,P.$6k)(s.isReadonly)&&s.isReadonly.value!==""&&(n={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this.a.$registerFileSystemProvider(t,f,o,n).catch(l=>{console.error(`FAILED to register filesystem provider of ${$.identifier.value}-extension for the scheme ${f}`),console.error(l)});const d=i.onDidChangeFile(l=>{const g=[];for(const E of l){const{uri:D,type:y}=E;if(D.scheme!==f)continue;let k;switch(y){case O.FileChangeType.Changed:k=C.FileChangeType.UPDATED;break;case O.FileChangeType.Created:k=C.FileChangeType.ADDED;break;case O.FileChangeType.Deleted:k=C.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}g.push({resource:D,type:k})}this.a.$onFileSystemChange(t,g)});return(0,R.$Sc)(()=>{d.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(t),this.a.$unregisterProvider(t)})}static j($){if(!$)throw new Error("MISSING provider");if(typeof $.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof $.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof $.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof $.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof $.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof $.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof $.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof $.rename!="function")throw new Error("Provider does NOT implement rename")}static k($){const{type:f,ctime:i,mtime:s,size:t,permissions:o}=$;return{type:f,ctime:i,mtime:s,size:t,permissions:o}}$stat($,f){return Promise.resolve(this.l($).stat(r.URI.revive(f))).then(i=>a.k(i))}$readdir($,f){return Promise.resolve(this.l($).readDirectory(r.URI.revive(f)))}$readFile($,f){return Promise.resolve(this.l($).readFile(r.URI.revive(f))).then(i=>S.$Ne.wrap(i))}$writeFile($,f,i,s){return Promise.resolve(this.l($).writeFile(r.URI.revive(f),i.buffer,s))}$delete($,f,i){return Promise.resolve(this.l($).delete(r.URI.revive(f),i))}$rename($,f,i,s){return Promise.resolve(this.l($).rename(r.URI.revive(f),r.URI.revive(i),s))}$copy($,f,i,s){const t=this.l($);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(r.URI.revive(f),r.URI.revive(i),s))}$mkdir($,f){return Promise.resolve(this.l($).createDirectory(r.URI.revive(f)))}$watch($,f,i,s){const t=this.l($).watch(r.URI.revive(i),s);this.f.set(f,t)}$unwatch($,f){const i=this.f.get(f);i&&(i.dispose(),this.f.delete(f))}$open($,f,i){const s=this.l($);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(r.URI.revive(f),i))}$close($,f){const i=this.l($);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(f))}$read($,f,i,s){const t=this.l($);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const o=S.$Ne.alloc(s);return Promise.resolve(t.read(f,i,o.buffer,0,s)).then(n=>o.slice(0,n))}$write($,f,i,s){const t=this.l($);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(f,i,s.buffer,0,s.byteLength))}l($){const f=this.c.get($);if(!f){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return f}}e.$Oqc=a}),define(ke[303],Ie([1,0,4,38,2,6,15,9,27,50]),function($e,e,r,h,C,R,O,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pqc=void 0,O=qe(O);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,a,m,$,f,i){this.a=Math.random(),this.b=new r.$le,this.c=new r.$le,this.d=new r.$le,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const s=(0,h.$Ak)(f),t=typeof f=="string",o=i?.correlate,n=$(d=>{if(!(typeof d.session=="number"&&d.session!==this.a)&&!(o&&typeof d.session>"u")){if(!i?.ignoreCreateEvents)for(const l of d.created){const g=C.URI.revive(l);s(g.fsPath)&&(!t||a.getWorkspaceFolder(g))&&this.b.fire(g)}if(!i?.ignoreChangeEvents)for(const l of d.changed){const g=C.URI.revive(l);s(g.fsPath)&&(!t||a.getWorkspaceFolder(g))&&this.c.fire(g)}if(!i?.ignoreDeleteEvents)for(const l of d.deleted){const g=C.URI.revive(l);s(g.fsPath)&&(!t||a.getWorkspaceFolder(g))&&this.d.fire(g)}}});this.g=T.$MN.from(this.i(w,m,f,i,i?.correlate),this.b,this.c,this.d,n)}i(w,a,m,$,f){const i=T.$MN.from();if(typeof m=="string"||$?.ignoreChangeEvents&&$?.ignoreCreateEvents&&$?.ignoreDeleteEvents)return i;const s=w.getProxy(R.$KN.MainThreadFileSystemEventService);let t=!1;(m.pattern.includes(h.$wk)||m.pattern.includes(h.$xk))&&(t=!0);let o;return f&&($?.ignoreChangeEvents||$?.ignoreCreateEvents||$?.ignoreDeleteEvents)&&(o=p.FileChangeFilter.UPDATED|p.FileChangeFilter.ADDED|p.FileChangeFilter.DELETED,$?.ignoreChangeEvents&&(o&=~p.FileChangeFilter.UPDATED),$?.ignoreCreateEvents&&(o&=~p.FileChangeFilter.ADDED),$?.ignoreDeleteEvents&&(o&=~p.FileChangeFilter.DELETED)),s.$watch(a.identifier.value,this.a,m.baseUri,{recursive:t,excludes:$?.excludes??[],filter:o},!!f),T.$MN.from({dispose:()=>s.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class S{constructor(w){this.a=w,this.session=this.a.session,this.b=new c.$T(()=>this.a.created.map(C.URI.revive)),this.c=new c.$T(()=>this.a.changed.map(C.URI.revive)),this.d=new c.$T(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(w,a,m){this.j=w,this.k=a,this.l=m,this.a=new r.$le,this.b=new r.$le,this.c=new r.$le,this.d=new r.$le,this.g=new r.$ne,this.h=new r.$ne,this.i=new r.$ne,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,a,m,$){return new I(this.j,w,a,this.a.event,O.GlobPattern.from(m),$)}$onFileEvent(w){this.a.fire(new S(w))}$onDidRunFileOperation(w,a){switch(w){case p.FileOperation.MOVE:this.b.fire(Object.freeze({files:a.map(m=>({oldUri:C.URI.revive(m.source),newUri:C.URI.revive(m.target)}))}));break;case p.FileOperation.DELETE:this.d.fire(Object.freeze({files:a.map(m=>C.URI.revive(m.target))}));break;case p.FileOperation.CREATE:case p.FileOperation.COPY:this.c.fire(Object.freeze({files:a.map(m=>C.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,a){return(m,$,f)=>{const i=function(t){m.call($,t)};return i.extension=w,a.event(i,void 0,f)}}async $onWillRunFileOperation(w,a,m,$){switch(w){case p.FileOperation.MOVE:return await this.n(this.g,{files:a.map(f=>({oldUri:C.URI.revive(f.source),newUri:C.URI.revive(f.target)}))},m,$);case p.FileOperation.DELETE:return await this.n(this.i,{files:a.map(f=>C.URI.revive(f.target))},m,$);case p.FileOperation.CREATE:case p.FileOperation.COPY:return await this.n(this.h,{files:a.map(f=>C.URI.revive(f.target))},m,$)}}async n(w,a,m,$){const f=new Set,i=[];if(await w.fireAsync(a,$,async(t,o)=>{const n=Date.now(),d=await Promise.resolve(t);d instanceof T.$YN&&(i.push([o.extension,d]),f.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-n>m&&this.k.warn("SLOW file-participant",o.extension.identifier)}),$.isCancellationRequested||i.length===0)return;const s={edits:[]};for(const[,t]of i){const{edits:o}=O.WorkspaceEdit.from(t,{getTextDocumentVersion:n=>this.l.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(o)}return{edit:s,extensionNames:Array.from(f)}}}e.$Pqc=u}),define(ke[304],Ie([1,0,18,7,20,13,132,3,24,42,12,17,2,30,196,87,142,8,23,15,9,25,118,6]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Apc=void 0,a=qe(a),i=qe(i),n=qe(n);class d{constructor(V,G){this.d=V,this.e=G}async provideDocumentSymbols(V,G){const J=this.d.getDocument(V),x=await this.e.provideDocumentSymbols(J,G);if(!(0,r.$Jb)(x))return x[0]instanceof s.$9N?x.map(i.DocumentSymbol.from):d.f(x)}static f(V){V=V.slice(0).sort((x,de)=>{let Ee=x.location.range.start.compareTo(de.location.range.start);return Ee===0&&(Ee=de.location.range.end.compareTo(x.location.range.end)),Ee});const G=[],J=[];for(const x of V){const de={name:x.name||"!!MISSING: name!!",kind:i.SymbolKind.from(x.kind),tags:x.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:x.containerName,range:i.Range.from(x.location.range),selectionRange:i.Range.from(x.location.range),children:[]};for(;;){if(J.length===0){J.push(de),G.push(de);break}const Ee=J[J.length-1];if(P.$Ot.containsRange(Ee.range,de.range)&&!P.$Ot.equalsRange(Ee.range,de.range)){Ee.children?.push(de),J.push(de);break}J.pop()}}return G}}class l{constructor(V,G,J,x,de,Ee){this.f=V,this.g=G,this.h=J,this.j=x,this.k=de,this.l=Ee,this.d=new o.$qpc("CodeLens"),this.e=new Map}async provideCodeLenses(V,G){const J=this.f.getDocument(V),x=await this.h.provideCodeLenses(J,G);if(!x||G.isCancellationRequested)return;const de=this.d.add(x),Ee=new T.$Tc;this.e.set(de,Ee);const Le={cacheId:de,lenses:[]};for(let He=0;He<x.length;He++)Le.lenses.push({cacheId:[de,He],range:i.Range.from(x[He].range),command:this.g.toInternal(x[He].command,Ee)});return Le}async resolveCodeLens(V,G){const J=V.cacheId&&this.d.get(...V.cacheId);if(!J)return;let x;if(typeof this.h.resolveCodeLens!="function"||J.isResolved?x=J:x=await this.h.resolveCodeLens(J,G),x||(x=J),G.isCancellationRequested)return;const de=V.cacheId&&this.e.get(V.cacheId[0]);if(de){if(!x.command){const Ee=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,Ee),this.l.error(Ee);return}return V.command=this.g.toInternal(x.command,de),V}}releaseCodeLenses(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}}function g(Ce){return Array.isArray(Ce)?Ce.map(i.DefinitionLink.from):Ce?[i.DefinitionLink.from(Ce)]:[]}class E{constructor(V,G){this.d=V,this.e=G}async provideDefinition(V,G,J){const x=this.d.getDocument(V),de=i.Position.to(G),Ee=await this.e.provideDefinition(x,de,J);return g(Ee)}}class D{constructor(V,G){this.d=V,this.e=G}async provideDeclaration(V,G,J){const x=this.d.getDocument(V),de=i.Position.to(G),Ee=await this.e.provideDeclaration(x,de,J);return g(Ee)}}class y{constructor(V,G){this.d=V,this.e=G}async provideImplementation(V,G,J){const x=this.d.getDocument(V),de=i.Position.to(G),Ee=await this.e.provideImplementation(x,de,J);return g(Ee)}}class k{constructor(V,G){this.d=V,this.e=G}async provideTypeDefinition(V,G,J){const x=this.d.getDocument(V),de=i.Position.to(G),Ee=await this.e.provideTypeDefinition(x,de,J);return g(Ee)}}class A{static{this.f=10}constructor(V,G){this.g=V,this.h=G,this.d=0,this.e=new Map}async provideHover(V,G,J,x){const de=this.g.getDocument(V),Ee=i.Position.to(G);let Le;if(J&&J.verbosityRequest){const nt=J.verbosityRequest.previousHover.id,st=this.e.get(nt);if(!st)throw new Error(`Hover with id ${nt} not found`);const rt={verbosityDelta:J.verbosityRequest.verbosityDelta,previousHover:st};Le=await this.h.provideHover(de,Ee,x,rt)}else Le=await this.h.provideHover(de,Ee,x);if(!Le||(0,r.$Jb)(Le.contents))return;Le.range||(Le.range=de.getWordRangeAtPosition(Ee)),Le.range||(Le.range=new s.$ON(Ee,Ee));const He=i.Hover.from(Le),Ze=this.d;if(this.e.size===A.f){const nt=Math.min(...this.e.keys());this.e.delete(nt)}return this.e.set(Ze,Le),this.d+=1,{...He,id:Ze}}releaseHover(V){this.e.delete(V)}}class b{constructor(V,G){this.d=V,this.e=G}async provideEvaluatableExpression(V,G,J){const x=this.d.getDocument(V),de=i.Position.to(G),Ee=await this.e.provideEvaluatableExpression(x,de,J);if(Ee)return i.EvaluatableExpression.from(Ee)}}class v{constructor(V,G){this.d=V,this.e=G}async provideInlineValues(V,G,J,x){const de=this.d.getDocument(V),Ee=await this.e.provideInlineValues(de,i.Range.to(G),i.InlineValueContext.to(J),x);if(Array.isArray(Ee))return Ee.map(Le=>i.InlineValue.from(Le))}}class F{constructor(V,G){this.d=V,this.e=G}async provideDocumentHighlights(V,G,J){const x=this.d.getDocument(V),de=i.Position.to(G),Ee=await this.e.provideDocumentHighlights(x,de,J);if(Array.isArray(Ee))return Ee.map(i.DocumentHighlight.from)}}class N{constructor(V,G){this.d=V,this.e=G}async provideMultiDocumentHighlights(V,G,J,x){const de=this.d.getDocument(V),Ee=J.map(Ze=>this.d.getDocument(Ze)),Le=i.Position.to(G),He=await this.e.provideMultiDocumentHighlights(de,Le,Ee,x);if(Array.isArray(He))return He.map(i.MultiDocumentHighlight.from)}}class L{constructor(V,G){this.d=V,this.e=G}async provideLinkedEditingRanges(V,G,J){const x=this.d.getDocument(V),de=i.Position.to(G),Ee=await this.e.provideLinkedEditingRanges(x,de,J);if(Ee&&Array.isArray(Ee.ranges))return{ranges:(0,r.$Gb)(Ee.ranges.map(i.Range.from)),wordPattern:Ee.wordPattern}}}class M{constructor(V,G){this.d=V,this.e=G}async provideReferences(V,G,J,x){const de=this.d.getDocument(V),Ee=i.Position.to(G),Le=await this.e.provideReferences(de,Ee,J,x);if(Array.isArray(Le))return Le.map(i.location.from)}}class z{static{this.d=1e3}constructor(V,G,J,x,de,Ee,Le){this.g=V,this.h=G,this.j=J,this.k=x,this.l=de,this.m=Ee,this.n=Le,this.e=new o.$qpc("CodeAction"),this.f=new Map}async provideCodeActions(V,G,J,x){const de=this.g.getDocument(V),Ee=w.$Qt.isISelection(G)?i.Selection.to(G):i.Range.to(G),Le=[];for(const rt of this.j.getDiagnostics(V))if(Ee.intersection(rt.range)&&Le.push(rt)>z.d)break;const He={diagnostics:Le,only:J.only?new s.$$N(J.only):void 0,triggerKind:i.CodeActionTriggerKind.to(J.trigger)},Ze=await this.k.provideCodeActions(de,Ee,He,x);if(!(0,r.$Kb)(Ze)||x.isCancellationRequested)return;const et=this.e.add(Ze),nt=new T.$Tc;this.f.set(et,nt);const st=[];for(let rt=0;rt<Ze.length;rt++){const at=Ze[rt];if(at)if(z.o(at))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),st.push({_isSynthetic:!0,title:at.title,command:this.h.toInternal(at,nt)});else{He.only&&(at.kind?He.only.contains(at.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value}' requested but returned code action is of kind '${at.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const gt=at.ranges??[];st.push({cacheId:[et,rt],title:at.title,command:at.command&&this.h.toInternal(at.command,nt),diagnostics:at.diagnostics&&at.diagnostics.map(i.Diagnostic.from),edit:at.edit&&i.WorkspaceEdit.from(at.edit,void 0),kind:at.kind&&at.kind.value,isPreferred:at.isPreferred,isAI:(0,t.$fH)(this.m,"codeActionAI")?at.isAI:!1,ranges:(0,t.$fH)(this.m,"codeActionRanges")?(0,r.$Gb)(gt.map(i.Range.from)):void 0,disabled:at.disabled?.reason})}}return{cacheId:et,actions:st}}async resolveCodeAction(V,G){const[J,x]=V,de=this.e.get(J,x);if(!de||z.o(de))return{};if(!this.k.resolveCodeAction)return{};const Ee=await this.k.resolveCodeAction(de,G)??de;let Le;Ee.edit&&(Le=i.WorkspaceEdit.from(Ee.edit,void 0));let He;if(Ee.command){const Ze=this.f.get(J);Ze&&(He=this.h.toInternal(Ee.command,Ze))}return{edit:Le,command:He}}releaseCodeActions(V){this.f.get(V)?.dispose(),this.f.delete(V),this.e.delete(V)}static o(V){return typeof V.command=="string"&&typeof V.title=="string"}}class j{constructor(V,G,J,x,de){this.e=V,this.f=G,this.g=J,this.h=x,this.j=de,this.d=new o.$qpc("DocumentPasteEdit")}async prepareDocumentPaste(V,G,J,x){if(!this.g.prepareDocumentPaste)return;const de=this.f.getDocument(V),Ee=G.map(Ze=>i.Range.to(Ze)),Le=i.DataTransfer.toDataTransfer(J,()=>{throw new R.$0});if(await this.g.prepareDocumentPaste(de,Ee,Le,x),x.isCancellationRequested)return;const He=Array.from(Le).filter(([,Ze])=>!(Ze instanceof s.$EO));return i.DataTransfer.from(He)}async providePasteEdits(V,G,J,x,de,Ee){if(!this.g.provideDocumentPasteEdits)return[];const Le=this.f.getDocument(G),He=J.map(st=>i.Range.to(st)),Ze=i.DataTransfer.toDataTransfer(x,async st=>(await this.e.$resolvePasteFileData(this.h,V,st)).buffer),et=await this.g.provideDocumentPasteEdits(Le,He,Ze,{only:de.only?new s.$JO(de.only):void 0,triggerKind:de.triggerKind},Ee);if(!et||Ee.isCancellationRequested)return[];const nt=this.d.add(et);return et.map((st,rt)=>({_cacheId:[nt,rt],title:st.title??(0,$.localize)(10834,null,this.j.displayName||this.j.name),kind:st.kind,yieldTo:st.yieldTo?.map(at=>at.value),insertText:typeof st.insertText=="string"?st.insertText:{snippet:st.insertText.value},additionalEdit:st.additionalEdit?i.WorkspaceEdit.from(st.additionalEdit,void 0):void 0}))}async resolvePasteEdit(V,G){const[J,x]=V,de=this.d.get(J,x);if(!de||!this.g.resolveDocumentPasteEdit)return{};const Ee=await this.g.resolveDocumentPasteEdit(de,G)??de;return{additionalEdit:Ee.additionalEdit?i.WorkspaceEdit.from(Ee.additionalEdit,void 0):void 0}}releasePasteEdits(V){this.d.delete(V)}}class W{constructor(V,G){this.d=V,this.e=G}async provideDocumentFormattingEdits(V,G,J){const x=this.d.getDocument(V),de=await this.e.provideDocumentFormattingEdits(x,G,J);if(Array.isArray(de))return de.map(i.TextEdit.from)}}class B{constructor(V,G){this.d=V,this.e=G}async provideDocumentRangeFormattingEdits(V,G,J,x){const de=this.d.getDocument(V),Ee=i.Range.to(G),Le=await this.e.provideDocumentRangeFormattingEdits(de,Ee,J,x);if(Array.isArray(Le))return Le.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(V,G,J,x){(0,S.$og)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const de=this.d.getDocument(V),Ee=G.map(i.Range.to),Le=await this.e.provideDocumentRangesFormattingEdits(de,Ee,J,x);if(Array.isArray(Le))return Le.map(i.TextEdit.from)}}class ee{constructor(V,G){this.d=V,this.e=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,G,J,x,de){const Ee=this.d.getDocument(V),Le=i.Position.to(G),He=await this.e.provideOnTypeFormattingEdits(Ee,Le,J,x,de);if(Array.isArray(He))return He.map(i.TextEdit.from)}}class H{constructor(V,G){this.e=V,this.f=G,this.d=new o.$qpc("WorkspaceSymbols")}async provideWorkspaceSymbols(V,G){const J=await this.e.provideWorkspaceSymbols(V,G);if(!(0,r.$Kb)(J))return{symbols:[]};const x=this.d.add(J),de={cacheId:x,symbols:[]};for(let Ee=0;Ee<J.length;Ee++){const Le=J[Ee];if(!Le||!Le.name){this.f.warn("INVALID SymbolInformation",Le);continue}de.symbols.push({...i.WorkspaceSymbol.from(Le),cacheId:[x,Ee]})}return de}async resolveWorkspaceSymbol(V,G){if(typeof this.e.resolveWorkspaceSymbol!="function"||!V.cacheId)return V;const J=this.d.get(...V.cacheId);if(J){const x=await this.e.resolveWorkspaceSymbol(J,G);return x&&(0,p.$ho)(V,i.WorkspaceSymbol.from(x),!0)}}releaseWorkspaceSymbols(V){this.d.delete(V)}}class q{static supportsResolving(V){return typeof V.prepareRename=="function"}constructor(V,G,J){this.d=V,this.e=G,this.f=J}async provideRenameEdits(V,G,J,x){const de=this.d.getDocument(V),Ee=i.Position.to(G);try{const Le=await this.e.provideRenameEdits(de,Ee,J,x);return Le?i.WorkspaceEdit.from(Le):void 0}catch(Le){const He=q.g(Le);return He?{rejectReason:He,edits:void 0}:Promise.reject(Le)}}async resolveRenameLocation(V,G,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const x=this.d.getDocument(V),de=i.Position.to(G);try{const Ee=await this.e.prepareRename(x,de,J);let Le,He;if(s.$ON.isRange(Ee)?(Le=Ee,He=x.getText(Ee)):(0,S.$gg)(Ee)&&(Le=Ee.range,He=Ee.placeholder),!Le||!He)return;if(Le.start.line>de.line||Le.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Le),text:He}}catch(Ee){const Le=q.g(Ee);return Le?{rejectReason:Le,range:void 0,text:void 0}:Promise.reject(Ee)}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class Q{static{this.d={[a.NewSymbolNameTriggerKind.Invoke]:s.NewSymbolNameTriggerKind.Invoke,[a.NewSymbolNameTriggerKind.Automatic]:s.NewSymbolNameTriggerKind.Automatic}}constructor(V,G,J){this.e=V,this.f=G,this.g=J}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(V,G,J,x){const de=this.e.getDocument(V),Ee=i.Range.to(G);try{const Le=Q.d[J],He=await this.f.provideNewSymbolNames(de,Ee,Le,x);return He?He.map(Ze=>typeof Ze=="string"?{newSymbolName:Ze}:{newSymbolName:Ze.newSymbolName,tags:Ze.tags}):void 0}catch(Le){this.g.error(Q.h(Le)??JSON.stringify(Le,null,"	"));return}}static h(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class _{constructor(V,G){this.resultId=V,this.tokens=G}}class ce{constructor(V,G){this.f=V,this.g=G,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(V,G,J){const x=this.f.getDocument(V),de=G!==0?this.d.get(G):null;let Ee=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(x,de.resultId,J):await this.g.provideDocumentSemanticTokens(x,J);return de&&this.d.delete(G),Ee?(Ee=ce.h(Ee),this.o(ce.n(de,Ee),Ee)):null}async releaseDocumentSemanticColoring(V){this.d.delete(V)}static h(V){return ce.j(V)?ce.k(V)?V:new s.$0O(new Uint32Array(V.data),V.resultId):ce.l(V)?ce.m(V)?V:new s.$_O(V.edits.map(G=>new s.$$O(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),V.resultId):V}static j(V){return V&&!!V.data}static k(V){return V.data instanceof Uint32Array}static l(V){return V&&Array.isArray(V.edits)}static m(V){for(const G of V.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static n(V,G){if(!ce.j(G)||!V||!V.tokens)return G;const J=V.tokens,x=J.length,de=G.data,Ee=de.length;let Le=0;const He=Math.min(x,Ee);for(;Le<He&&J[Le]===de[Le];)Le++;if(Le===x&&Le===Ee)return new s.$_O([],G.resultId);let Ze=0;const et=He-Le;for(;Ze<et&&J[x-Ze-1]===de[Ee-Ze-1];)Ze++;return new s.$_O([{start:Le,deleteCount:x-Le-Ze,data:de.subarray(Le,Ee-Ze)}],G.resultId)}o(V,G){if(ce.j(V)){const J=this.e++;return this.d.set(J,new _(V.resultId,V.data)),(0,m.$Xdb)({id:J,type:"full",data:V.data})}if(ce.l(V)){const J=this.e++;return ce.j(G)?this.d.set(J,new _(G.resultId,G.data)):this.d.set(J,new _(V.resultId)),(0,m.$Xdb)({id:J,type:"delta",deltas:(V.edits||[]).map(x=>({start:x.start,deleteCount:x.deleteCount,data:x.data}))})}return null}}class ne{constructor(V,G){this.d=V,this.e=G}async provideDocumentRangeSemanticTokens(V,G,J){const x=this.d.getDocument(V),de=await this.e.provideDocumentRangeSemanticTokens(x,i.Range.to(G),J);return de?this.f(de):null}f(V){return(0,m.$Xdb)({id:0,type:"full",data:V.data})}}class ye{static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}constructor(V,G,J,x,de){this.f=V,this.g=G,this.h=J,this.j=x,this.k=de,this.d=new o.$qpc("CompletionItem"),this.e=new Map}async provideCompletionItems(V,G,J,x){const de=this.f.getDocument(V),Ee=i.Position.to(G),Le=de.getWordRangeAtPosition(Ee)||new s.$ON(Ee,Ee),He=Le.with({end:Ee}),Ze=new c.$fe,et=await this.h.provideCompletionItems(de,Ee,x,i.CompletionContext.to(J));if(!et||x.isCancellationRequested)return;const nt=Array.isArray(et)?new s.$lO(et):et,st=ye.supportsResolving(this.h)?this.d.add(nt.items):this.d.add([]),rt=new T.$Tc;this.e.set(st,rt);const at=[],gt={x:st,[n.ISuggestResultDtoField.completions]:at,[n.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Le),insert:i.Range.from(He)},[n.ISuggestResultDtoField.isIncomplete]:nt.isIncomplete||void 0,[n.ISuggestResultDtoField.duration]:Ze.elapsed()};for(let dt=0;dt<nt.items.length;dt++){const ct=nt.items[dt],Pe=this.l(ct,[st,dt],He,Le);at.push(Pe)}return gt}async resolveCompletionItem(V,G){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...V);if(!J)return;const x=this.l(J,V),de=await this.h.resolveCompletionItem(J,G);if(!de)return;const Ee=this.l(de,V);return(x[n.ISuggestDataDtoField.insertText]!==Ee[n.ISuggestDataDtoField.insertText]||x[n.ISuggestDataDtoField.insertTextRules]!==Ee[n.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(x[n.ISuggestDataDtoField.commandIdent]!==Ee[n.ISuggestDataDtoField.commandIdent]||x[n.ISuggestDataDtoField.commandId]!==Ee[n.ISuggestDataDtoField.commandId]||!(0,p.$io)(x[n.ISuggestDataDtoField.commandArguments],Ee[n.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...x,[n.ISuggestDataDtoField.documentation]:Ee[n.ISuggestDataDtoField.documentation],[n.ISuggestDataDtoField.detail]:Ee[n.ISuggestDataDtoField.detail],[n.ISuggestDataDtoField.additionalTextEdits]:Ee[n.ISuggestDataDtoField.additionalTextEdits],[n.ISuggestDataDtoField.insertText]:Ee[n.ISuggestDataDtoField.insertText],[n.ISuggestDataDtoField.insertTextRules]:Ee[n.ISuggestDataDtoField.insertTextRules],[n.ISuggestDataDtoField.commandIdent]:Ee[n.ISuggestDataDtoField.commandIdent],[n.ISuggestDataDtoField.commandId]:Ee[n.ISuggestDataDtoField.commandId],[n.ISuggestDataDtoField.commandArguments]:Ee[n.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,G,J,x){const de=this.e.get(G[0]);if(!de)throw Error("DisposableStore is missing...");const Ee=this.g.toInternal(V.command,de),Le={x:G,[n.ISuggestDataDtoField.label]:V.label,[n.ISuggestDataDtoField.kind]:V.kind!==void 0?i.CompletionItemKind.from(V.kind):void 0,[n.ISuggestDataDtoField.kindModifier]:V.tags&&V.tags.map(i.CompletionItemTag.from),[n.ISuggestDataDtoField.detail]:V.detail,[n.ISuggestDataDtoField.documentation]:typeof V.documentation>"u"?void 0:i.MarkdownString.fromStrict(V.documentation),[n.ISuggestDataDtoField.sortText]:V.sortText!==V.label?V.sortText:void 0,[n.ISuggestDataDtoField.filterText]:V.filterText!==V.label?V.filterText:void 0,[n.ISuggestDataDtoField.preselect]:V.preselect||void 0,[n.ISuggestDataDtoField.insertTextRules]:V.keepWhitespace?a.CompletionItemInsertTextRule.KeepWhitespace:a.CompletionItemInsertTextRule.None,[n.ISuggestDataDtoField.commitCharacters]:V.commitCharacters?.join(""),[n.ISuggestDataDtoField.additionalTextEdits]:V.additionalTextEdits&&V.additionalTextEdits.map(i.TextEdit.from),[n.ISuggestDataDtoField.commandIdent]:Ee?.$ident,[n.ISuggestDataDtoField.commandId]:Ee?.id,[n.ISuggestDataDtoField.commandArguments]:Ee?.$ident?void 0:Ee?.arguments};V.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Le[n.ISuggestDataDtoField.insertText]=V.textEdit.newText):typeof V.insertText=="string"?Le[n.ISuggestDataDtoField.insertText]=V.insertText:V.insertText instanceof s.$ZN&&(Le[n.ISuggestDataDtoField.insertText]=V.insertText.value,Le[n.ISuggestDataDtoField.insertTextRules]|=a.CompletionItemInsertTextRule.InsertAsSnippet);let He;return V.textEdit?He=V.textEdit.range:V.range&&(He=V.range),s.$ON.isRange(He)?Le[n.ISuggestDataDtoField.range]=i.Range.from(He):He&&(!J?.isEqual(He.inserting)||!x?.isEqual(He.replacing))&&(Le[n.ISuggestDataDtoField.range]={insert:i.Range.from(He.inserting),replace:i.Range.from(He.replacing)}),Le}}class ge{async provideInlineCompletions(V,G,J,x){}async provideInlineEdits(V,G,J,x){}disposeCompletions(V){}handleDidShowCompletionItem(V,G,J){}handlePartialAccept(V,G,J,x){}}class Y extends ge{constructor(V,G,J,x){super(),this.f=V,this.g=G,this.h=J,this.j=x,this.d=new oe,this.e=(0,t.$fH)(this.f,"inlineCompletionsAdditions"),this.k={[a.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[a.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$fH)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(V,G,J,x){const de=this.g.getDocument(V),Ee=i.Position.to(G),Le=await this.h.provideInlineCompletionItems(de,Ee,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:i.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},x);if(!Le||x.isCancellationRequested)return;const He=Array.isArray(Le)?Le:Le.items,Ze=this.e?Array.isArray(Le)?[]:Le.commands||[]:[],et=this.e&&!Array.isArray(Le)?Le.enableForwardStability:void 0;let nt;return{pid:this.d.createReferenceId({dispose(){nt?.dispose()},items:He}),items:He.map((rt,at)=>{let gt;rt.command&&(nt||(nt=new T.$Tc),gt=this.j.toInternal(rt.command,nt));const dt=rt.insertText;return{insertText:typeof dt=="string"?dt:{snippet:dt.value},filterText:rt.filterText,range:rt.range?i.Range.from(rt.range):void 0,command:gt,idx:at,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Ze.map(rt=>(nt||(nt=new T.$Tc),this.j.toInternal(rt,nt))),suppressSuggestions:!1,enableForwardStability:et}}async provideInlineEdits(V,G,J,x){if(!this.h.provideInlineEdits)return;(0,t.$gH)(this.f,"inlineCompletionsAdditions");const de=this.g.getDocument(V),Ee=i.Range.to(G),Le=await this.h.provideInlineEdits(de,Ee,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:i.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind],userPrompt:J.userPrompt},x);if(!Le||x.isCancellationRequested)return;const He=Array.isArray(Le)?Le:Le.items,Ze=this.e?Array.isArray(Le)?[]:Le.commands||[]:[],et=this.e&&!Array.isArray(Le)?Le.enableForwardStability:void 0;let nt;return{pid:this.d.createReferenceId({dispose(){nt?.dispose()},items:He}),items:He.map((rt,at)=>{let gt;rt.command&&(nt||(nt=new T.$Tc),gt=this.j.toInternal(rt.command,nt));const dt=rt.insertText;return{insertText:typeof dt=="string"?dt:{snippet:dt.value},filterText:rt.filterText,range:rt.range?i.Range.from(rt.range):void 0,command:gt,idx:at,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Ze.map(rt=>(nt||(nt=new T.$Tc),this.j.toInternal(rt,nt))),suppressSuggestions:!1,enableForwardStability:et}}disposeCompletions(V){this.d.disposeReferenceId(V)?.dispose()}handleDidShowCompletionItem(V,G,J){const x=this.d.get(V)?.items[G];x&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(x,J)}handlePartialAccept(V,G,J,x){const de=this.d.get(V)?.items[G];de&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(de,J),this.h.handleDidPartiallyAcceptCompletionItem(de,i.PartialAcceptInfo.to(x)))}}class U{async provideInlineEdits(V,G,J){const x=this.f.getDocument(V),de=await this.g.provideInlineEdit(x,{triggerKind:this.e[G.triggerKind]},J);if(!de||J.isCancellationRequested)return;let Ee;const Le=this.d.createReferenceId({dispose(){Ee?.dispose()},item:de});let He;de.accepted&&(Ee||(Ee=new T.$Tc),He=this.h.toInternal(de.accepted,Ee));let Ze;return de.rejected&&(Ee||(Ee=new T.$Tc),Ze=this.h.toInternal(de.rejected,Ee)),{pid:Le,text:de.text,range:i.Range.from(de.range),accepted:He,rejected:Ze}}disposeEdit(V){this.d.disposeReferenceId(V)?.dispose()}constructor(V,G,J,x){this.f=G,this.g=J,this.h=x,this.d=new oe,this.e={[a.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[a.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class oe{constructor(){this.d=new Map,this.e=1}createReferenceId(V){const G=this.e++;return this.d.set(G,V),G}disposeReferenceId(V){const G=this.d.get(V);return this.d.delete(V),G}get(V){return this.d.get(V)}}class ve{constructor(V,G){this.e=V,this.f=G,this.d=new o.$qpc("SignatureHelp")}async provideSignatureHelp(V,G,J,x){const de=this.e.getDocument(V),Ee=i.Position.to(G),Le=this.g(J),He=await this.f.provideSignatureHelp(de,Ee,x,Le);if(He){const Ze=this.d.add([He]);return{...i.SignatureHelp.from(He),id:Ze}}}g(V){let G;if(V.activeSignatureHelp){const J=i.SignatureHelp.to(V.activeSignatureHelp),x=this.d.get(V.activeSignatureHelp.id,0);x?(G=x,G.activeSignature=J.activeSignature,G.activeParameter=J.activeParameter):G=J}return{...V,activeSignatureHelp:G}}releaseSignatureHelp(V){this.d.delete(V)}}class te{constructor(V,G,J,x,de){this.f=V,this.g=G,this.h=J,this.j=x,this.k=de,this.d=new o.$qpc("InlayHints"),this.e=new Map}async provideInlayHints(V,G,J){const x=this.f.getDocument(V),de=i.Range.to(G),Ee=await this.h.provideInlayHints(x,de,J);if(!Array.isArray(Ee)||Ee.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(G)}`);return}if(J.isCancellationRequested)return;const Le=this.d.add(Ee);this.e.set(Le,new T.$Tc);const He={hints:[],cacheId:Le};for(let Ze=0;Ze<Ee.length;Ze++)this.l(Ee[Ze],de)&&He.hints.push(this.m(Ee[Ze],[Le,Ze]));return this.j.trace(`[InlayHints] ${He.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(G)}`),He}async resolveInlayHint(V,G){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...V);if(!J)return;const x=await this.h.resolveInlayHint(J,G);if(x&&this.l(x))return this.m(x,V)}releaseHints(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,G){return V.label.length===0||Array.isArray(V.label)&&V.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",V),!1):!(G&&!G.contains(V.position))}m(V,G){const J=this.e.get(G[0]);if(!J)throw Error("DisposableStore is missing...");const x={label:"",cacheId:G,tooltip:i.MarkdownString.fromStrict(V.tooltip),position:i.Position.from(V.position),textEdits:V.textEdits&&V.textEdits.map(i.TextEdit.from),kind:V.kind&&i.InlayHintKind.from(V.kind),paddingLeft:V.paddingLeft,paddingRight:V.paddingRight};if(typeof V.label=="string")x.label=V.label;else{const de=[];x.label=de;for(const Ee of V.label){if(!Ee.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Le={label:Ee.value,tooltip:i.MarkdownString.fromStrict(Ee.tooltip)};s.$1N.isLocation(Ee.location)&&(Le.location=i.location.from(Ee.location)),Ee.command&&(Le.command=this.g.toInternal(Ee.command,J)),de.push(Le)}}return x}}class ae{constructor(V,G){this.e=V,this.f=G,this.d=new o.$qpc("DocumentLink")}async provideLinks(V,G){const J=this.e.getDocument(V),x=await this.f.provideDocumentLinks(J,G);if(!(!Array.isArray(x)||x.length===0)&&!G.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:x.filter(ae.g).map(i.DocumentLink.from)};{const de=this.d.add(x),Ee={links:[],cacheId:de};for(let Le=0;Le<x.length;Le++){if(!ae.g(x[Le]))continue;const He=i.DocumentLink.from(x[Le]);He.cacheId=[de,Le],Ee.links.push(He)}return Ee}}}static g(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,G){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...V);if(!J)return;const x=await this.f.resolveDocumentLink(J,G);if(!(!x||!ae.g(x)))return i.DocumentLink.from(x)}releaseLinks(V){this.d.delete(V)}}class se{constructor(V,G){this.d=V,this.e=G}async provideColors(V,G){const J=this.d.getDocument(V),x=await this.e.provideDocumentColors(J,G);return Array.isArray(x)?x.map(Ee=>({color:i.Color.from(Ee.color),range:i.Range.from(Ee.range)})):[]}async provideColorPresentations(V,G,J){const x=this.d.getDocument(V),de=i.Range.to(G.range),Ee=i.Color.to(G.color),Le=await this.e.provideColorPresentations(Ee,{document:x,range:de},J);if(Array.isArray(Le))return Le.map(i.ColorPresentation.from)}}class X{constructor(V,G){this.d=V,this.e=G}async provideFoldingRanges(V,G,J){const x=this.d.getDocument(V),de=await this.e.provideFoldingRanges(x,G,J);if(Array.isArray(de))return de.map(i.FoldingRange.from)}}class re{constructor(V,G,J){this.d=V,this.e=G,this.f=J}async provideSelectionRanges(V,G,J){const x=this.d.getDocument(V),de=G.map(i.Position.to),Ee=await this.e.provideSelectionRanges(x,de,J);if(!(0,r.$Kb)(Ee))return[];if(Ee.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Le=[];for(let He=0;He<de.length;He++){const Ze=[];Le.push(Ze);let et=de[He],nt=Ee[He];for(;;){if(!nt.range.contains(et))throw new Error("INVALID selection range, must contain the previous range");if(Ze.push(i.SelectionRange.from(nt)),!nt.parent)break;et=nt.range,nt=nt.parent}}return Le}}class pe{constructor(V,G){this.f=V,this.g=G,this.d=new O.$pQ(""),this.e=new Map}async prepareSession(V,G,J){const x=this.f.getDocument(V),de=i.Position.to(G),Ee=await this.g.prepareCallHierarchy(x,de,J);if(!Ee)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(Ee)?Ee.map(He=>this.h(Le,He)):[this.h(Le,Ee)]}async provideCallsTo(V,G,J){const x=this.j(V,G);if(!x)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(x,J);if(de)return de.map(Ee=>({from:this.h(V,Ee.from),fromRanges:Ee.fromRanges.map(Le=>i.Range.from(Le))}))}async provideCallsFrom(V,G,J){const x=this.j(V,G);if(!x)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(x,J);if(de)return de.map(Ee=>({to:this.h(V,Ee.to),fromRanges:Ee.fromRanges.map(Le=>i.Range.from(Le))}))}releaseSession(V){this.e.delete(V)}h(V,G){const J=this.e.get(V),x=i.CallHierarchyItem.from(G,V,J.size.toString(36));return J.set(x._itemId,G),x}j(V,G){return this.e.get(V)?.get(G)}}class we{constructor(V,G){this.f=V,this.g=G,this.d=new O.$pQ(""),this.e=new Map}async prepareSession(V,G,J){const x=this.f.getDocument(V),de=i.Position.to(G),Ee=await this.g.prepareTypeHierarchy(x,de,J);if(!Ee)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(Ee)?Ee.map(He=>this.h(Le,He)):[this.h(Le,Ee)]}async provideSupertypes(V,G,J){const x=this.j(V,G);if(!x)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(x,J);if(de)return de.map(Ee=>this.h(V,Ee))}async provideSubtypes(V,G,J){const x=this.j(V,G);if(!x)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(x,J);if(de)return de.map(Ee=>this.h(V,Ee))}releaseSession(V){this.e.delete(V)}h(V,G){const J=this.e.get(V),x=i.TypeHierarchyItem.from(G,V,J.size.toString(36));return J.set(x._itemId,G),x}j(V,G){return this.e.get(V)?.get(G)}}class Fe{constructor(V,G,J,x,de){this.e=V,this.f=G,this.g=J,this.h=x,this.j=de,this.d=new o.$qpc("DocumentDropEdit")}async provideDocumentOnDropEdits(V,G,J,x,de){const Ee=this.f.getDocument(G),Le=i.Position.to(J),He=i.DataTransfer.toDataTransfer(x,async st=>(await this.e.$resolveDocumentOnDropFileData(this.h,V,st)).buffer),Ze=await this.g.provideDocumentDropEdits(Ee,Le,He,de);if(!Ze)return;const et=(0,r.$1b)(Ze),nt=this.d.add(et);return et.map((st,rt)=>({_cacheId:[nt,rt],title:st.title??(0,$.localize)(10835,null,this.j.displayName||this.j.name),kind:st.kind?.value,yieldTo:st.yieldTo?.map(at=>at.value),insertText:typeof st.insertText=="string"?st.insertText:{snippet:st.insertText.value},additionalEdit:st.additionalEdit?i.WorkspaceEdit.from(st.additionalEdit,void 0):void 0}))}async resolveDropEdit(V,G){const[J,x]=V,de=this.d.get(J,x);if(!de||!this.g.resolveDocumentDropEdit)return{};const Ee=await this.g.resolveDocumentDropEdit(de,G)??de;return{additionalEdit:Ee.additionalEdit?i.WorkspaceEdit.from(Ee.additionalEdit,void 0):void 0}}releaseDropEdits(V){this.d.delete(V)}}class Be{constructor(V,G){this.d=V,this.e=G}async provideMappedEdits(V,G,J,x){const de=u.URI.revive(V),Ee=this.d.getDocument(de),Le=J.documents.map(et=>et.map(nt=>({uri:u.URI.revive(nt.uri),version:nt.version,ranges:nt.ranges.map(st=>i.Range.to(st))}))),He={documents:Le,selections:Le[0]?.[0]?.ranges??[]},Ze=await this.e.provideMappedEdits(Ee,G,He,x);return Ze?i.WorkspaceEdit.from(Ze):null}}class Re{constructor(V,G){this.adapter=V,this.extension=G}}class De{static{this.d=0}constructor(V,G,J,x,de,Ee,Le,He){this.g=G,this.h=J,this.j=x,this.k=de,this.l=Ee,this.m=Le,this.n=He,this.f=new Map,this.e=V.getProxy(n.$KN.MainThreadLanguageFeatures)}o(V,G){return i.DocumentSelector.from(V,this.g,G)}p(V){return new s.$MN(()=>{this.f.delete(V),this.e.$unregister(V)})}q(){return De.d++}async s(V,G,J,x,de,Ee=!1){const Le=this.f.get(V);if(!Le||!(Le.adapter instanceof G))return x;const He=Date.now();Ee||this.l.trace(`[${Le.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Ze=J(Le.adapter,Le.extension);return Promise.resolve(Ze).catch(et=>{(0,R.$3)(et)||(this.l.error(`[${Le.extension.identifier.value}] provider FAILED`),this.l.error(et),this.n.onExtensionError(Le.extension.identifier,et))}).finally(()=>{Ee||this.l.trace(`[${Le.extension.identifier.value}] provider DONE after ${Date.now()-He}ms`)}),C.CancellationToken.isCancellationToken(de)?(0,h.$uh)(Ze,de):Ze}t(V,G){const J=this.q();return this.f.set(J,new Re(V,G)),J}static u(V){return V.displayName||V.name}static w(V){return V.identifier.value}registerDocumentSymbolProvider(V,G,J,x){const de=this.t(new d(this.h,J),V),Ee=x&&x.label||De.u(V);return this.e.$registerDocumentSymbolProvider(de,this.o(G,V),Ee),this.p(de)}$provideDocumentSymbols(V,G,J){return this.s(V,d,x=>x.provideDocumentSymbols(u.URI.revive(G),J),void 0,J)}registerCodeLensProvider(V,G,J){const x=this.q(),de=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(x,new Re(new l(this.h,this.j.converter,J,V,this.n,this.l),V)),this.e.$registerCodeLensSupport(x,this.o(G,V),de);let Ee=this.p(x);if(de!==void 0){const Le=J.onDidChangeCodeLenses(He=>this.e.$emitCodeLensEvent(de));Ee=s.$MN.from(Ee,Le)}return Ee}$provideCodeLenses(V,G,J){return this.s(V,l,x=>x.provideCodeLenses(u.URI.revive(G),J),void 0,J)}$resolveCodeLens(V,G,J){return this.s(V,l,x=>x.resolveCodeLens(G,J),void 0,void 0)}$releaseCodeLenses(V,G){this.s(V,l,J=>Promise.resolve(J.releaseCodeLenses(G)),void 0,void 0)}registerDefinitionProvider(V,G,J){const x=this.t(new E(this.h,J),V);return this.e.$registerDefinitionSupport(x,this.o(G,V)),this.p(x)}$provideDefinition(V,G,J,x){return this.s(V,E,de=>de.provideDefinition(u.URI.revive(G),J,x),[],x)}registerDeclarationProvider(V,G,J){const x=this.t(new D(this.h,J),V);return this.e.$registerDeclarationSupport(x,this.o(G,V)),this.p(x)}$provideDeclaration(V,G,J,x){return this.s(V,D,de=>de.provideDeclaration(u.URI.revive(G),J,x),[],x)}registerImplementationProvider(V,G,J){const x=this.t(new y(this.h,J),V);return this.e.$registerImplementationSupport(x,this.o(G,V)),this.p(x)}$provideImplementation(V,G,J,x){return this.s(V,y,de=>de.provideImplementation(u.URI.revive(G),J,x),[],x)}registerTypeDefinitionProvider(V,G,J){const x=this.t(new k(this.h,J),V);return this.e.$registerTypeDefinitionSupport(x,this.o(G,V)),this.p(x)}$provideTypeDefinition(V,G,J,x){return this.s(V,k,de=>de.provideTypeDefinition(u.URI.revive(G),J,x),[],x)}registerHoverProvider(V,G,J,x){const de=this.t(new A(this.h,J),V);return this.e.$registerHoverProvider(de,this.o(G,V)),this.p(de)}$provideHover(V,G,J,x,de){return this.s(V,A,Ee=>Ee.provideHover(u.URI.revive(G),J,x,de),void 0,de)}$releaseHover(V,G){this.s(V,A,J=>Promise.resolve(J.releaseHover(G)),void 0,void 0)}registerEvaluatableExpressionProvider(V,G,J,x){const de=this.t(new b(this.h,J),V);return this.e.$registerEvaluatableExpressionProvider(de,this.o(G,V)),this.p(de)}$provideEvaluatableExpression(V,G,J,x){return this.s(V,b,de=>de.provideEvaluatableExpression(u.URI.revive(G),J,x),void 0,x)}registerInlineValuesProvider(V,G,J,x){const de=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,Ee=this.t(new v(this.h,J),V);this.e.$registerInlineValuesProvider(Ee,this.o(G,V),de);let Le=this.p(Ee);if(de!==void 0){const He=J.onDidChangeInlineValues(Ze=>this.e.$emitInlineValuesEvent(de));Le=s.$MN.from(Le,He)}return Le}$provideInlineValues(V,G,J,x,de){return this.s(V,v,Ee=>Ee.provideInlineValues(u.URI.revive(G),J,x,de),void 0,de)}registerDocumentHighlightProvider(V,G,J){const x=this.t(new F(this.h,J),V);return this.e.$registerDocumentHighlightProvider(x,this.o(G,V)),this.p(x)}registerMultiDocumentHighlightProvider(V,G,J){const x=this.t(new N(this.h,J),V);return this.e.$registerMultiDocumentHighlightProvider(x,this.o(G,V)),this.p(x)}$provideDocumentHighlights(V,G,J,x){return this.s(V,F,de=>de.provideDocumentHighlights(u.URI.revive(G),J,x),void 0,x)}$provideMultiDocumentHighlights(V,G,J,x,de){return this.s(V,N,Ee=>Ee.provideMultiDocumentHighlights(u.URI.revive(G),J,x.map(Le=>u.URI.revive(Le)),de),void 0,de)}registerLinkedEditingRangeProvider(V,G,J){const x=this.t(new L(this.h,J),V);return this.e.$registerLinkedEditingRangeProvider(x,this.o(G,V)),this.p(x)}$provideLinkedEditingRanges(V,G,J,x){return this.s(V,L,async de=>{const Ee=await de.provideLinkedEditingRanges(u.URI.revive(G),J,x);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?De.y(Ee.wordPattern):void 0}},void 0,x)}registerReferenceProvider(V,G,J){const x=this.t(new M(this.h,J),V);return this.e.$registerReferenceSupport(x,this.o(G,V)),this.p(x)}$provideReferences(V,G,J,x,de){return this.s(V,M,Ee=>Ee.provideReferences(u.URI.revive(G),J,x,de),void 0,de)}registerCodeActionProvider(V,G,J,x){const de=new T.$Tc,Ee=this.t(new z(this.h,this.j.converter,this.k,J,this.l,V,this.m),V);return this.e.$registerCodeActionSupport(Ee,this.o(G,V),{providedKinds:x?.providedCodeActionKinds?.map(Le=>Le.value),documentation:x?.documentation?.map(Le=>({kind:Le.kind.value,command:this.j.converter.toInternal(Le.command,de)}))},De.u(V),De.w(V),!!J.resolveCodeAction),de.add(this.p(Ee)),de}$provideCodeActions(V,G,J,x,de){return this.s(V,z,Ee=>Ee.provideCodeActions(u.URI.revive(G),J,x,de),void 0,de)}$resolveCodeAction(V,G,J){return this.s(V,z,x=>x.resolveCodeAction(G,J),{},void 0)}$releaseCodeActions(V,G){this.s(V,z,J=>Promise.resolve(J.releaseCodeActions(G)),void 0,void 0)}registerDocumentFormattingEditProvider(V,G,J){const x=this.t(new W(this.h,J),V);return this.e.$registerDocumentFormattingSupport(x,this.o(G,V),V.identifier,V.displayName||V.name),this.p(x)}$provideDocumentFormattingEdits(V,G,J,x){return this.s(V,W,de=>de.provideDocumentFormattingEdits(u.URI.revive(G),J,x),void 0,x)}registerDocumentRangeFormattingEditProvider(V,G,J){const x=typeof J.provideDocumentRangesFormattingEdits=="function",de=this.t(new B(this.h,J),V);return this.e.$registerRangeFormattingSupport(de,this.o(G,V),V.identifier,V.displayName||V.name,x),this.p(de)}$provideDocumentRangeFormattingEdits(V,G,J,x,de){return this.s(V,B,Ee=>Ee.provideDocumentRangeFormattingEdits(u.URI.revive(G),J,x,de),void 0,de)}$provideDocumentRangesFormattingEdits(V,G,J,x,de){return this.s(V,B,Ee=>Ee.provideDocumentRangesFormattingEdits(u.URI.revive(G),J,x,de),void 0,de)}registerOnTypeFormattingEditProvider(V,G,J,x){const de=this.t(new ee(this.h,J),V);return this.e.$registerOnTypeFormattingSupport(de,this.o(G,V),x,V.identifier),this.p(de)}$provideOnTypeFormattingEdits(V,G,J,x,de,Ee){return this.s(V,ee,Le=>Le.provideOnTypeFormattingEdits(u.URI.revive(G),J,x,de,Ee),void 0,Ee)}registerWorkspaceSymbolProvider(V,G){const J=this.t(new H(G,this.l),V);return this.e.$registerNavigateTypeSupport(J,typeof G.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(V,G,J){return this.s(V,H,x=>x.provideWorkspaceSymbols(G,J),{symbols:[]},J)}$resolveWorkspaceSymbol(V,G,J){return this.s(V,H,x=>x.resolveWorkspaceSymbol(G,J),void 0,void 0)}$releaseWorkspaceSymbols(V,G){this.s(V,H,J=>J.releaseWorkspaceSymbols(G),void 0,void 0)}registerRenameProvider(V,G,J){const x=this.t(new q(this.h,J,this.l),V);return this.e.$registerRenameSupport(x,this.o(G,V),q.supportsResolving(J)),this.p(x)}$provideRenameEdits(V,G,J,x,de){return this.s(V,q,Ee=>Ee.provideRenameEdits(u.URI.revive(G),J,x,de),void 0,de)}$resolveRenameLocation(V,G,J,x){return this.s(V,q,de=>de.resolveRenameLocation(u.URI.revive(G),J,x),void 0,x)}registerNewSymbolNamesProvider(V,G,J){const x=this.t(new Q(this.h,J,this.l),V);return this.e.$registerNewSymbolNamesProvider(x,this.o(G,V)),this.p(x)}$supportsAutomaticNewSymbolNamesTriggerKind(V){return this.s(V,Q,G=>G.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(V,G,J,x,de){return this.s(V,Q,Ee=>Ee.provideNewSymbolNames(u.URI.revive(G),J,x,de),void 0,de)}registerDocumentSemanticTokensProvider(V,G,J,x){const de=this.t(new ce(this.h,J),V),Ee=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(G,V),x,Ee);let Le=this.p(de);if(Ee){const He=J.onDidChangeSemanticTokens(Ze=>this.e.$emitDocumentSemanticTokensEvent(Ee));Le=s.$MN.from(Le,He)}return Le}$provideDocumentSemanticTokens(V,G,J,x){return this.s(V,ce,de=>de.provideDocumentSemanticTokens(u.URI.revive(G),J,x),null,x)}$releaseDocumentSemanticTokens(V,G){this.s(V,ce,J=>J.releaseDocumentSemanticColoring(G),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(V,G,J,x){const de=this.t(new ne(this.h,J),V);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(G,V),x),this.p(de)}$provideDocumentRangeSemanticTokens(V,G,J,x){return this.s(V,ne,de=>de.provideDocumentRangeSemanticTokens(u.URI.revive(G),J,x),null,x)}registerCompletionItemProvider(V,G,J,x){const de=this.t(new ye(this.h,this.j.converter,J,this.m,V),V);return this.e.$registerCompletionsProvider(de,this.o(G,V),x,ye.supportsResolving(J),V.identifier),this.p(de)}$provideCompletionItems(V,G,J,x,de){return this.s(V,ye,Ee=>Ee.provideCompletionItems(u.URI.revive(G),J,x,de),void 0,de)}$resolveCompletionItem(V,G,J){return this.s(V,ye,x=>x.resolveCompletionItem(G,J),void 0,J)}$releaseCompletionItems(V,G){this.s(V,ye,J=>J.releaseCompletionItems(G),void 0,void 0)}registerInlineCompletionsProvider(V,G,J,x){const de=new Y(V,this.h,J,this.j.converter),Ee=this.t(de,V);return this.e.$registerInlineCompletionsSupport(Ee,this.o(G,V),de.supportsHandleEvents,f.$rn.toKey(V.identifier.value),x?.yieldTo?.map(Le=>f.$rn.toKey(Le))||[]),this.p(Ee)}$provideInlineCompletions(V,G,J,x,de){return this.s(V,ge,Ee=>Ee.provideInlineCompletions(u.URI.revive(G),J,x,de),void 0,de)}$provideInlineEdits(V,G,J,x,de){return this.s(V,ge,Ee=>Ee.provideInlineEdits(u.URI.revive(G),J,x,de),void 0,de)}$handleInlineCompletionDidShow(V,G,J,x){this.s(V,ge,async de=>{de.handleDidShowCompletionItem(G,J,x)},void 0,void 0)}$handleInlineCompletionPartialAccept(V,G,J,x,de){this.s(V,ge,async Ee=>{Ee.handlePartialAccept(G,J,x,de)},void 0,void 0)}$freeInlineCompletionsList(V,G){this.s(V,ge,async J=>{J.disposeCompletions(G)},void 0,void 0)}registerInlineEditProvider(V,G,J){const x=new U(V,this.h,J,this.j.converter),de=this.t(x,V);return this.e.$registerInlineEditProvider(de,this.o(G,V),V.identifier),this.p(de)}$provideInlineEdit(V,G,J,x){return this.s(V,U,de=>de.provideInlineEdits(u.URI.revive(G),J,x),void 0,x)}$freeInlineEdit(V,G){this.s(V,U,async J=>{J.disposeEdit(G)},void 0,void 0)}registerSignatureHelpProvider(V,G,J,x){const de=Array.isArray(x)?{triggerCharacters:x,retriggerCharacters:[]}:x,Ee=this.t(new ve(this.h,J),V);return this.e.$registerSignatureHelpProvider(Ee,this.o(G,V),de),this.p(Ee)}$provideSignatureHelp(V,G,J,x,de){return this.s(V,ve,Ee=>Ee.provideSignatureHelp(u.URI.revive(G),J,x,de),void 0,de)}$releaseSignatureHelp(V,G){this.s(V,ve,J=>J.releaseSignatureHelp(G),void 0,void 0)}registerInlayHintsProvider(V,G,J){const x=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new te(this.h,this.j.converter,J,this.l,V),V);this.e.$registerInlayHintsProvider(de,this.o(G,V),typeof J.resolveInlayHint=="function",x,De.u(V));let Ee=this.p(de);if(x!==void 0){const Le=J.onDidChangeInlayHints(He=>this.e.$emitInlayHintsEvent(x));Ee=s.$MN.from(Ee,Le)}return Ee}$provideInlayHints(V,G,J,x){return this.s(V,te,de=>de.provideInlayHints(u.URI.revive(G),J,x),void 0,x)}$resolveInlayHint(V,G,J){return this.s(V,te,x=>x.resolveInlayHint(G,J),void 0,J)}$releaseInlayHints(V,G){this.s(V,te,J=>J.releaseHints(G),void 0,void 0)}registerDocumentLinkProvider(V,G,J){const x=this.t(new ae(this.h,J),V);return this.e.$registerDocumentLinkProvider(x,this.o(G,V),typeof J.resolveDocumentLink=="function"),this.p(x)}$provideDocumentLinks(V,G,J){return this.s(V,ae,x=>x.provideLinks(u.URI.revive(G),J),void 0,J,G.scheme==="output")}$resolveDocumentLink(V,G,J){return this.s(V,ae,x=>x.resolveLink(G,J),void 0,void 0,!0)}$releaseDocumentLinks(V,G){this.s(V,ae,J=>J.releaseLinks(G),void 0,void 0,!0)}registerColorProvider(V,G,J){const x=this.t(new se(this.h,J),V);return this.e.$registerDocumentColorProvider(x,this.o(G,V)),this.p(x)}$provideDocumentColors(V,G,J){return this.s(V,se,x=>x.provideColors(u.URI.revive(G),J),[],J)}$provideColorPresentations(V,G,J,x){return this.s(V,se,de=>de.provideColorPresentations(u.URI.revive(G),J,x),void 0,x)}registerFoldingRangeProvider(V,G,J){const x=this.q(),de=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(x,new Re(new X(this.h,J),V)),this.e.$registerFoldingRangeProvider(x,this.o(G,V),V.identifier,de);let Ee=this.p(x);if(de!==void 0){const Le=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));Ee=s.$MN.from(Ee,Le)}return Ee}$provideFoldingRanges(V,G,J,x){return this.s(V,X,de=>de.provideFoldingRanges(u.URI.revive(G),J,x),void 0,x)}registerSelectionRangeProvider(V,G,J){const x=this.t(new re(this.h,J,this.l),V);return this.e.$registerSelectionRangeProvider(x,this.o(G,V)),this.p(x)}$provideSelectionRanges(V,G,J,x){return this.s(V,re,de=>de.provideSelectionRanges(u.URI.revive(G),J,x),[],x)}registerCallHierarchyProvider(V,G,J){const x=this.t(new pe(this.h,J),V);return this.e.$registerCallHierarchyProvider(x,this.o(G,V)),this.p(x)}$prepareCallHierarchy(V,G,J,x){return this.s(V,pe,de=>Promise.resolve(de.prepareSession(u.URI.revive(G),J,x)),void 0,x)}$provideCallHierarchyIncomingCalls(V,G,J,x){return this.s(V,pe,de=>de.provideCallsTo(G,J,x),void 0,x)}$provideCallHierarchyOutgoingCalls(V,G,J,x){return this.s(V,pe,de=>de.provideCallsFrom(G,J,x),void 0,x)}$releaseCallHierarchy(V,G){this.s(V,pe,J=>Promise.resolve(J.releaseSession(G)),void 0,void 0)}registerTypeHierarchyProvider(V,G,J){const x=this.t(new we(this.h,J),V);return this.e.$registerTypeHierarchyProvider(x,this.o(G,V)),this.p(x)}$prepareTypeHierarchy(V,G,J,x){return this.s(V,we,de=>Promise.resolve(de.prepareSession(u.URI.revive(G),J,x)),void 0,x)}$provideTypeHierarchySupertypes(V,G,J,x){return this.s(V,we,de=>de.provideSupertypes(G,J,x),void 0,x)}$provideTypeHierarchySubtypes(V,G,J,x){return this.s(V,we,de=>de.provideSubtypes(G,J,x),void 0,x)}$releaseTypeHierarchy(V,G){this.s(V,we,J=>Promise.resolve(J.releaseSession(G)),void 0,void 0)}registerDocumentOnDropEditProvider(V,G,J,x){const de=this.q();return this.f.set(de,new Re(new Fe(this.e,this.h,J,de,V),V)),this.e.$registerDocumentOnDropEditProvider(de,this.o(G,V),(0,t.$fH)(V,"documentPaste")&&x?{supportsResolve:!!J.resolveDocumentDropEdit,dropMimeTypes:x.dropMimeTypes}:void 0),this.p(de)}$provideDocumentOnDropEdits(V,G,J,x,de,Ee){return this.s(V,Fe,Le=>Promise.resolve(Le.provideDocumentOnDropEdits(G,u.URI.revive(J),x,de,Ee)),void 0,void 0)}$resolveDropEdit(V,G,J){return this.s(V,Fe,x=>x.resolveDropEdit(G,J),{},void 0)}$releaseDocumentOnDropEdits(V,G){this.s(V,Fe,J=>Promise.resolve(J.releaseDropEdits(G)),void 0,void 0)}registerMappedEditsProvider(V,G,J){const x=this.t(new Be(this.h,J),V);return this.e.$registerMappedEditsProvider(x,this.o(G,V),V.displayName??V.name),this.p(x)}$provideMappedEdits(V,G,J,x,de){return this.s(V,Be,Ee=>Promise.resolve(Ee.provideMappedEdits(G,J,x,de)),null,de)}registerDocumentPasteEditProvider(V,G,J,x){const de=this.q();return this.f.set(de,new Re(new j(this.e,this.h,J,de,V),V)),this.e.$registerPasteEditProvider(de,this.o(G,V),{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,supportsResolve:!!J.resolveDocumentPasteEdit,providedPasteEditKinds:x.providedPasteEditKinds?.map(Ee=>Ee.value),copyMimeTypes:x.copyMimeTypes,pasteMimeTypes:x.pasteMimeTypes}),this.p(de)}$prepareDocumentPaste(V,G,J,x,de){return this.s(V,j,Ee=>Ee.prepareDocumentPaste(u.URI.revive(G),J,x,de),void 0,de)}$providePasteEdits(V,G,J,x,de,Ee,Le){return this.s(V,j,He=>He.providePasteEdits(G,u.URI.revive(J),x,de,Ee,Le),void 0,Le)}$resolvePasteEdit(V,G,J){return this.s(V,j,x=>x.resolvePasteEdit(G,J),{},void 0)}$releasePasteEdits(V,G){this.s(V,j,J=>Promise.resolve(J.releasePasteEdits(G)),void 0,void 0)}static y(V){return{pattern:V.source,flags:V.flags}}static z(V){return{decreaseIndentPattern:De.y(V.decreaseIndentPattern),increaseIndentPattern:De.y(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?De.y(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?De.y(V.unIndentedLinePattern):void 0}}static B(V){return{beforeText:De.y(V.beforeText),afterText:V.afterText?De.y(V.afterText):void 0,previousLineText:V.previousLineText?De.y(V.previousLineText):void 0,action:V.action}}static C(V){return V.map(De.B)}static D(V){return{open:V.open,close:V.close,notIn:V.notIn?V.notIn.map(G=>s.SyntaxTokenType.toString(G)):void 0}}static E(V){return V.map(De.D)}setLanguageConfiguration(V,G,J){const{wordPattern:x}=J;if(x&&(0,I.$rf)(x))throw new Error(`Invalid language configuration: wordPattern '${x}' is not allowed to match the empty string.`);x?this.h.setWordDefinitionFor(G,x):this.h.setWordDefinitionFor(G,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const de=this.q(),Ee={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?De.y(J.wordPattern):void 0,indentationRules:J.indentationRules?De.z(J.indentationRules):void 0,onEnterRules:J.onEnterRules?De.C(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?De.E(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(de,G,Ee),this.p(de)}$setWordDefinitions(V){for(const G of V)this.h.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.$Apc=De}),define(ke[305],Ie([1,0,3,44,6,15]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qc=void 0,R=qe(R);class O{constructor(p){this.a=new Map,this.c=new Map,this.b=p.getProxy(C.$KN.MainThreadLanguageModelTools),this.b.$getTools().then(c=>{for(const I of c)this.c.set(I.name,(0,h.$ci)(I))})}async invokeTool(p,c,I){return await this.b.$invokeTool(p,c,I)}async $acceptToolDelta(p){p.added&&this.c.set(p.added.name,p.added),p.removed&&this.c.delete(p.removed)}get tools(){return Array.from(this.c.values()).map(p=>R.LanguageModelToolDescription.to(p))}async $invokeTool(p,c,I){const S=this.a.get(p);if(!S)throw new Error(`Unknown tool ${p}`);return await S.tool.invoke(c,I)}registerTool(p,c,I){return this.a.set(c,{extension:p,tool:I}),this.b.$registerTool(c),(0,r.$Sc)(()=>{this.a.delete(c),this.b.$unregisterTool(c)})}}e.$5qc=O}),define(ke[128],Ie([1,0,7,20,52,13,4,39,3,8,23,5,11,89,6,127,19,15,9,156,25]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f,i,s){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$iqc=e.$hqc=void 0,$=qe($),f=qe(f),e.$hqc=(0,S.$Fi)("IExtHostLanguageModels");class o{constructor(g,E){this.option=g,this.stream=new r.$9h,this.stream=E??new r.$9h}}class n{constructor(){this.a=new Map,this.b=new r.$9h,this.c=!1;const g=this;this.apiObject={get stream(){return g.b.asyncIterable},get text(){return r.$6h.map(g.b.asyncIterable,E=>{if(E instanceof f.$7P)return E.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,g]of this.a)yield g.stream;else yield this.b}handleFragment(g){if(this.c)return;let E=this.a.get(g.index);E||(this.a.size===0?E=new o(g.index,this.b):E=new o(g.index),this.a.set(g.index,E));let D;g.part.type==="text"?D=new f.$7P(g.part.value):D=new f.$6P(g.part.name,g.part.parameters),E.stream.emitOne(D)}reject(g){this.c=!0;for(const E of this.d())E.reject(g)}resolve(){this.c=!0;for(const g of this.d())g.resolve()}}let d=class{static{t=this}static{this.a=1}constructor(g,E,D){this.j=E,this.k=D,this.c=new O.$le,this.d=new O.$le,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new I.$tn,this.i=new Map,this.s=new Set,this.b=g.getProxy(w.$KN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(g,E,D,y){const k=t.a++;this.f.set(k,{extension:g.identifier,provider:D,languageModelId:E});let A;y.auth&&(A={providerLabel:g.displayName||g.name,accountLabel:typeof y.auth=="object"?y.auth.label:void 0}),this.b.$registerLanguageModelProvider(k,`${I.$rn.toKey(g.identifier)}/${k}/${E}`,{extension:g.identifier,id:E,vendor:y.vendor??I.$rn.toKey(g.identifier),name:y.name??"",family:y.family??"",version:y.version,maxInputTokens:y.maxInputTokens,maxOutputTokens:y.maxOutputTokens,auth:A,targetExtensions:y.extensions});const b=D.onDidReceiveLanguageModelResponse2?.(({extensionId:v,participant:F,tokenCount:N})=>{this.b.$whenLanguageModelChatRequestMade(E,new I.$rn(v),F,N)});return(0,p.$Sc)(()=>{this.f.delete(k),this.b.$unregisterProvider(k),b?.dispose()})}async $startChatRequest(g,E,D,y,k,A){const b=this.f.get(g);if(!b)throw new Error("Provider not found");const v=new P.$zw(async N=>{if(A.isCancellationRequested){this.j.warn(`[CHAT](${b.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let L;if(N.part instanceof f.$6P?L={type:"function_use",name:N.part.name,parameters:N.part.parameters}:N.part instanceof f.$7P&&(L={type:"text",value:N.part.value}),!L){this.j.warn(`[CHAT](${b.extension.value}) UNKNOWN part ${JSON.stringify(N)}`);return}this.b.$reportResponsePart(E,{index:N.index,part:L})});let F;if(b.provider.provideLanguageModelResponse2)F=Promise.resolve(b.provider.provideLanguageModelResponse2(y.map($.LanguageModelChatMessage.to),k,I.$rn.toKey(D),v,A));else{const N=new P.$zw(async L=>{v.report({index:L.index,part:new f.$7P(L.part)})});F=Promise.resolve(b.provider.provideLanguageModelResponse(y.map($.LanguageModelChatMessage.to),k?.modelOptions??{},I.$rn.toKey(D),N,A))}F.then(()=>{this.b.$reportResponseDone(E,void 0)},N=>{this.b.$reportResponseDone(E,(0,R.$1)(N))})}$provideTokenLength(g,E,D){const y=this.f.get(g);return y?Promise.resolve(y.provider.provideTokenCount(E,D)):Promise.resolve(0)}$acceptChatModelMetadata(g){if(g.added)for(const{identifier:E,metadata:D}of g.added)this.g.set(E,{metadata:D,apiObjects:new I.$tn});if(g.removed)for(const E of g.removed){this.g.delete(E);for(const[D,y]of this.i)y.languageModelId===E&&(y.res.reject(new R.$4),this.i.delete(D))}g.added?.forEach(E=>this.q(E.metadata)),this.d.fire(void 0)}async selectLanguageModels(g,E){const D=await this.b.$selectChatModels({...E,extension:g.identifier}),y=[],k=this;for(const A of D){const b=this.g.get(A);if(!b)continue;this.o(g.identifier,b.metadata)&&await this.q(b.metadata);let v=b.apiObjects.get(g.identifier);v||(v={id:A,vendor:b.metadata.vendor,family:b.metadata.family,version:b.metadata.version,name:b.metadata.name,maxInputTokens:b.metadata.maxInputTokens,countTokens(F,N){if(!k.g.has(A))throw f.$$P.NotFound(A);return k.r(A,F,N??h.CancellationToken.None)},sendRequest(F,N,L){if(!k.g.has(A))throw f.$$P.NotFound(A);return k.l(g,A,F,N??{},L??h.CancellationToken.None)}},Object.freeze(v),b.apiObjects.set(g.identifier,v)),y.push(v)}return y}async l(g,E,D,y,k){const A=this.m(g,D),b=g.identifier,v=this.g.get(E)?.metadata;if(!v||!this.g.has(E))throw f.$$P.NotFound(`Language model '${E}' is unknown.`);if(this.o(b,v)&&(!await this.n(g,{identifier:v.extension,displayName:v.auth.providerLabel},y.justification,!1)||!this.h.get(b)?.has(v.extension)))throw f.$$P.NoPermissions(`Language model '${E}' cannot be used by '${b.value}'.`);try{const F=Math.random()*1e6|0,N=new n;this.i.set(F,{languageModelId:E,res:N});try{await this.b.$tryStartChatRequest(b,E,F,A,y,k)}catch(L){throw this.i.delete(F),L}return N.apiObject}catch(F){throw F.name===f.$$P.name?F:new f.$$P(`Language model '${E}' errored: ${(0,C.$qj)(F)}`,"Unknown",F)}}m(g,E){const D=[];for(const y of E)y.role===f.LanguageModelChatMessageRole.System&&(0,s.$gH)(g,"languageModelSystem"),y.content2 instanceof f.$4P&&(0,s.$gH)(g,"lmTools"),D.push($.LanguageModelChatMessage.from(y));return D}async $acceptResponsePart(g,E){const D=this.i.get(g);D&&D.res.handleFragment(E)}async $acceptResponseDone(g,E){const D=this.i.get(g);D&&(this.i.delete(g),E?D.res.reject((0,R.$2)(E)):D.res.resolve())}async n(g,E,D,y){const k=i.$MM+E.identifier.value;if(await this.k.getSession(g,k,[],{silent:!0}))return this.$updateModelAccesslist([{from:g.identifier,to:E.identifier,enabled:!0}]),!0;if(y)return!1;try{const b=D?(0,c.localize)(10833,null,E.displayName,D):void 0;return await this.k.getSession(g,k,[],{forceNewSession:{detail:b}}),this.$updateModelAccesslist([{from:g.identifier,to:E.identifier,enabled:!0}]),!0}catch{return!1}}o(g,E){return!!E.auth&&!I.$rn.equals(E.extension,g)}async q(g){if(g.auth)for(const E of this.s)try{await this.n(E,{identifier:g.extension,displayName:""},void 0,!0)}catch(D){this.j.error("Fake Auth request failed"),this.j.error(D)}}async r(g,E,D){if(!this.g.get(g))throw f.$$P.NotFound(`Language model '${g}' is unknown.`);const k=T.Iterable.find(this.f.values(),A=>A.languageModelId===g);return k?k.provider.provideTokenCount(E,D):this.b.$countTokens(g,typeof E=="string"?E:$.LanguageModelChatMessage.from(E),D)}$updateModelAccesslist(g){const E=new Array;for(const{from:D,to:y,enabled:k}of g){const A=this.h.get(D)??new I.$sn;if(A.has(y)!==k){k?A.add(y):A.delete(y),this.h.set(D,A);const v={from:D,to:y};E.push(v),this.c.fire(v)}}}createLanguageModelAccessInformation(g){this.s.add(g);const E=this,D=O.Event.signal(O.Event.filter(this.c.event,k=>I.$rn.equals(k.from,g.identifier))),y=O.Event.signal(this.d.event);return{get onDidChange(){return O.Event.any(D,y)},canSendRequest(k){let A;e:for(const[v,F]of E.g)for(const N of F.apiObjects.values())if(N===k){A=F.metadata;break e}if(!A)return;if(!E.o(g.identifier,A))return!0;const b=E.h.get(g.identifier);if(b)return b.has(A.extension)}}}};e.$iqc=d,e.$iqc=d=t=Je([Ve(0,m.$kQ),Ve(1,u.$ak),Ve(2,a.$Cpc)],d)});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[306],Ie([1,0,6,15,9,43,7,3,25]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=void 0,h=qe(h),R=Ut(R);class c{constructor(S,u,P,w){this.c=u,this.d=P,this.e=w,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(r.$KN.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,u){await this.a.$changeLanguage(S,u);const P=this.c.getDocumentData(S);if(!P)throw new Error(`document '${S.toString()}' NOT found`);return P.document}async tokenAtPosition(S,u){const P=S.version,w=h.Position.from(u),a=await this.a.$tokensAtPosition(S.uri,w),m={type:C.StandardTokenType.Other,range:S.getWordRangeAtPosition(u)??new C.$ON(u.line,u.character,u.line,u.character)};if(!a)return m;const $={range:h.Range.to(a.range),type:h.TokenType.to(a.type)};return!$.range.contains(u)||P!==S.version?m:$}createLanguageStatusItem(S,u,P){const w=this.f++,a=this.a,m=this.g,$=`${S.identifier.value}/${u}`;if(m.has($))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);m.add($);const f={selector:P,id:u,name:S.displayName??S.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const s=new T.$Tc,t=()=>{if(i?.dispose(),!m.has($)){console.warn(`LanguageStatusItem (${u}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,O.$Hh)(()=>{s.clear(),this.a.$setLanguageStatus(w,{id:$,name:f.name??S.displayName??S.name,source:S.displayName??S.name,selector:h.DocumentSelector.from(f.selector,this.e),label:f.text,detail:f.detail??"",severity:f.severity===C.LanguageStatusSeverity.Error?R.default.Error:f.severity===C.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:f.command&&this.d.toInternal(f.command,s),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},o={dispose(){s.dispose(),i?.dispose(),a.$removeLanguageStatus(w),m.delete($)},get id(){return f.id},get name(){return f.name},set name(n){f.name=n,t()},get selector(){return f.selector},set selector(n){f.selector=n,t()},get text(){return f.text},set text(n){f.text=n,t()},set text2(n){(0,p.$gH)(S,"languageStatusText"),f.text=n,t()},get text2(){return(0,p.$gH)(S,"languageStatusText"),f.text},get detail(){return f.detail},set detail(n){f.detail=n,t()},get severity(){return f.severity},set severity(n){f.severity=n,t()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(n){f.accessibilityInformation=n,t()},get command(){return f.command},set command(n){f.command=n,t()},get busy(){return f.busy},set busy(n){f.busy=n,t()}};return t(),o}}e.$6qc=c}),define(ke[307],Ie([1,0,14,2,15,9,126]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rqc=e.$Qqc=void 0,C=qe(C),O=qe(O);class T{constructor(S,u,P,w){this.start=S,this.deletedCount=u,this.deletedItems=P,this.items=w}asApiEvent(){return{range:new R.$eP(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1}}constructor(S,u,P){this.notebook=S,this.h=u,this.j=P,this.handle=P.handle,this.uri=h.URI.revive(P.uri),this.cellKind=P.cellKind,this.a=P.outputs.map(C.NotebookCellOutput.to),this.e=P.internalMetadata??{},this.b=Object.freeze(P.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(P.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const P={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return S.g},set mime(w){S.g=w},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(P)}return this.f}setOutputs(S){this.a=S.map(C.NotebookCellOutput.to)}setOutputItems(S,u,P){const w=P.map(C.NotebookCellOutputItem.to),a=this.a.find(m=>m.id===S);if(a&&(u||(a.items.length=0),a.items.push(...w),a.items.length>1&&a.items.every(m=>O.$ML(m.mime)))){const m=new Map,$=[];a.items.forEach(f=>{let i;m.has(f.mime)?i=m.get(f.mime):(i=[],m.set(f.mime,i),$.push(f.mime)),i.push(f.data)}),a.items.length=0,$.forEach(f=>{const i=O.$NL(m.get(f));a.items.push({mime:f,data:i.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$Qqc=p;class c{static{this.a=0}constructor(S,u,P,w,a){this.k=S,this.l=u,this.m=P,this.uri=w,this.handle=c.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,u={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===r.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(P){return P=S.n(P),S.b[P].apiCell},getCells(P){return(P?S.p(P):S.b).map(a=>a.apiCell)},save(){return S.q()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,u,P){this.g=S.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:P});const w={notebook:this.apiNotebook,metadata:P,cellChanges:[],contentChanges:[]},a=[];for(const $ of S.rawEvents)$.kind===O.NotebookCellsChangeType.ModelChange?this.r($.changes,!1,w.contentChanges):$.kind===O.NotebookCellsChangeType.Move?this.s($.index,$.length,$.newIdx,w.contentChanges):$.kind===O.NotebookCellsChangeType.Output?(this.t($.index,$.outputs),a.push({cell:this.b[$.index].apiCell,outputs:this.b[$.index].apiCell.outputs})):$.kind===O.NotebookCellsChangeType.OutputItem?(this.u($.index,$.outputId,$.append,$.outputItems),a.push({cell:this.b[$.index].apiCell,outputs:this.b[$.index].apiCell.outputs})):$.kind===O.NotebookCellsChangeType.ChangeCellLanguage?(this.v($.index,$.language),a.push({cell:this.b[$.index].apiCell,document:this.b[$.index].apiCell.document})):$.kind===O.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[$.index].apiCell,document:this.b[$.index].apiCell.document}):$.kind===O.NotebookCellsChangeType.ChangeCellMime?this.w($.index,$.mime):$.kind===O.NotebookCellsChangeType.ChangeCellMetadata?(this.x($.index,$.metadata),a.push({cell:this.b[$.index].apiCell,metadata:this.b[$.index].apiCell.metadata})):$.kind===O.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y($.index,$.internalMetadata),a.push({cell:this.b[$.index].apiCell,executionSummary:this.b[$.index].apiCell.executionSummary}));const m=new Map;for(let $=0;$<a.length;$++){const f=a[$],i=m.get(f.cell);if(i===void 0){const s=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...f});m.set(f.cell,s-1)}else w.cellChanges[i]={...w.cellChanges[i],...f}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let u=S.start|0,P=S.end|0;return u<0&&(u=0),P>this.b.length&&(P=this.b.length),S.with({start:u,end:P})}p(S){S=this.o(S);const u=[];for(let P=S.start;P<S.end;P++)u.push(this.b[P]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,u,P){if(this.j)return;const w=[],a=[],m=[];if(S.reverse().forEach($=>{const i=$[2].map(o=>{const n=new p(this,this.l,o);return u||a.push(p.asModelAddData(o)),n}),s=new T($[0],$[1],[],i),t=this.b.splice($[0],$[1],...i);for(const o of t)m.push(o.uri),s.deletedItems.push(o.apiCell);w.push(s)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:m}),P)for(const $ of w)P.push($.asApiEvent())}s(S,u,P,w){const a=this.b.splice(S,u);this.b.splice(P,0,...a);const m=[new T(S,u,a.map($=>$.apiCell),[]),new T(P,0,[],a)];for(const $ of m)w.push($.asApiEvent())}t(S,u){this.b[S].setOutputs(u)}u(S,u,P,w){this.b[S].setOutputItems(u,P,w)}v(S,u){const P=this.b[S];P.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(P.uri,u)}w(S,u){const P=this.b[S];P.apiCell.mime=u}x(S,u){this.b[S].setMetadata(u)}y(S,u){this.b[S].setInternalMetadata(u)}getCellFromApiCell(S){return this.b.find(u=>u.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(u=>u.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$Rqc=c}),define(ke[308],Ie([1,0,4,2,15,9,53]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8qc=void 0;class T{constructor(c,I,S,u={timeout:1500,errors:3}){this.b=c,this.c=I,this.d=S,this.f=u,this.a=new r.$ne}dispose(){}getOnWillSaveNotebookDocumentEvent(c){return(I,S,u)=>{const P=function(a){I.call(S,a)};return P.extension=c,this.a.event(P,void 0,u)}}async $participateInSave(c,I,S){const u=h.URI.revive(c),P=this.c.getNotebookDocument(u);if(!P)throw new Error("Unable to resolve notebook document");const w=[];if(await this.a.fireAsync({notebook:P.apiNotebook,reason:C.TextDocumentSaveReason.to(I)},S,async(m,$)=>{const f=Date.now(),i=await await Promise.resolve(m);Date.now()-f>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",$.extension.identifier),!S.isCancellationRequested&&i&&(i instanceof R.$YN?w.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",$.extension.identifier,"ignored due to invalid data"))}),S.isCancellationRequested)return!1;if(w.length===0)return!0;const a={edits:[]};for(const m of w){const{edits:$}=C.WorkspaceEdit.from(m);a.edits=a.edits.concat($)}return this.d.$tryApplyWorkspaceEdit(new O.$Xw(a))}}e.$8qc=T}),define(ke[165],Ie([1,0,13,15,9]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sqc=void 0,h=qe(h),C=qe(C);class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(T,p,c,I,S,u){this.id=T,this.f=p,this.notebookData=c,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=I,this.c=u}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(p){this.selections=[p]},get selections(){return T.a},set selections(p){if(!Array.isArray(p)||!p.every(C.$eP.isNotebookRange))throw(0,r.$6)("selections");T.a=p,T.g(p)},get visibleRanges(){return T.b},revealRange(p,c){T.f.$tryRevealRange(T.id,h.NotebookRange.from(p),c??C.NotebookEditorRevealType.Default)},get viewColumn(){return T.c},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(h.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.$Sqc=R}),define(ke[309],Ie([1,0,4,11,15]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qc=void 0,C=qe(C);let R=class{constructor(T,p){this.c=T,this.d=p,this.a=new r.$le,this.b=new r.$le,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,p);const c=this.d.getEditorById(T);p.visibleRanges&&c._acceptVisibleRanges(p.visibleRanges.ranges.map(C.NotebookRange.to)),p.selections&&c._acceptSelections(p.selections.selections.map(C.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:c.apiEditor,visibleRanges:c.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:c.apiEditor,selections:c.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const p in T)this.d.getEditorById(p)._acceptViewColumn(C.ViewColumn.to(T[p]))}};e.$0qc=R,e.$0qc=R=Je([Ve(0,h.$ak)],R)}),define(ke[310],Ie([1,0,4,6,165]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$arc=void 0;class R{constructor(T,p){this.c=p,this.a=new Map,this.b=T.getProxy(h.$KN.MainThreadNotebookRenderers)}$postRendererMessage(T,p,c){const I=this.c.getEditorById(T);this.a.get(p)?.fire({editor:I.apiEditor,message:c})}createRendererMessaging(T,p){if(!T.contributes?.notebookRenderer?.some(I=>I.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(I,S,u)=>this.d(p).event(I,S,u),postMessage:(I,S)=>{C.$Sqc.apiEditorsToExtHost.has(I)&&([I,S]=[S,I]);const u=S&&C.$Sqc.apiEditorsToExtHost.get(S);return this.b.$postMessage(u?.id,p,I)}}}d(T){let p=this.a.get(T);return p||(p=new r.$le({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(T)}}),this.a.set(T,p),p)}}e.$arc=R}),define(ke[311],Ie([1,0,15,89,20,59,13]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$erc=void 0;class T{constructor(S){this.b=0,this.c=new Map,this.a=S}async withProgress(S,u,P){const w=this.b++,{title:a,location:m,cancellable:$}=u,f={label:S.displayName||S.name,id:S.identifier.value};return this.a.$startProgress(w,{location:r.ProgressLocation.from(m),title:a,source:f,cancellable:$},S.isUnderDevelopment?void 0:S.identifier.value).catch(O.$Z),this.d(w,P,!!$)}d(S,u,P){let w;P&&(w=new C.$we,this.c.set(S,w));const a=$=>{this.a.$progressEnd($),this.c.delete($),w?.dispose()};let m;try{m=u(new c(this.a,S),P&&w?w.token:C.CancellationToken.None)}catch($){throw a(S),$}return m.then($=>a(S),$=>a(S)),m}$acceptProgressCanceled(S){const u=this.c.get(S);u&&(u.cancel(),this.c.delete(S))}}e.$erc=T;function p(I,S){return I.message=S.message,typeof S.increment=="number"&&(typeof I.increment=="number"?I.increment+=S.increment:I.increment=S.increment),I}class c extends h.$zw{constructor(S,u){super(P=>this.throttledReport(P)),this.c=S,this.d=u}throttledReport(S){this.c.$progressReport(this.d,S)}}Je([(0,R.$_h)(100,(I,S)=>p(I,S),()=>Object.create(null))],c.prototype,"throttledReport",null)}),define(ke[312],Ie([1,0,2,6,7,15]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$frc=void 0;class O{static{this.a=0}constructor(p,c){this.d=c,this.c=new Map,this.b=p.getProxy(h.$KN.MainThreadQuickDiff)}$provideOriginalResource(p,c,I){const S=r.URI.revive(c),u=this.c.get(p);return u?(0,C.$xh)(()=>u.provideOriginalResource(S,I)).then(P=>P||null):Promise.resolve(null)}registerQuickDiffProvider(p,c,I,S){const u=O.a++;return this.c.set(u,c),this.b.$registerQuickDiffProvider(u,R.DocumentSelector.from(p,this.d),I,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$frc=O});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[313],Ie([1,0,20,4,3,6,2,9,13,18,43,51,25,15]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$grc=w,I=Ut(I);function w(a,m,$){const f=a.getProxy(R.$KN.MainThreadQuickOpen);class i{constructor(D,y){this.e=new Map,this.f=0,this.a=D,this.b=y}showQuickPick(D,y,k,A=r.CancellationToken.None){this.c=void 0;const b=Promise.resolve(y),v=++this.f,F=f.$show(v,{title:k?.title,placeHolder:k?.placeHolder,matchOnDescription:k?.matchOnDescription,matchOnDetail:k?.matchOnDetail,ignoreFocusLost:k?.ignoreFocusOut,canPickMany:k?.canPickMany},A),N={},L=F.then(()=>N);return Promise.race([L,b]).then(M=>{if(M===N)return;const z=(0,u.$fH)(D,"quickPickItemTooltip");return b.then(j=>{const W=[];for(let B=0;B<j.length;B++){const ee=j[B];if(typeof ee=="string")W.push({label:ee,handle:B});else if(ee.kind===T.QuickPickItemKind.Separator)W.push({type:"separator",label:ee.label});else{ee.tooltip&&!z&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const H=ee.iconPath?d(ee.iconPath):void 0;W.push({label:ee.label,iconPath:H?.iconPath,iconClass:H?.iconClass,description:ee.description,detail:ee.detail,picked:ee.picked,alwaysShow:ee.alwaysShow,tooltip:z?P.MarkdownString.fromStrict(ee.tooltip):void 0,handle:B})}}return k&&typeof k.onDidSelectItem=="function"&&(this.c=B=>{k.onDidSelectItem(j[B])}),f.$setItems(v,W),F.then(B=>{if(typeof B=="number")return j[B];if(Array.isArray(B))return B.map(ee=>j[ee])})})}).then(void 0,M=>{if(!(0,p.$3)(M))return f.$setError(v,M),Promise.reject(M)})}$onItemSelected(D){this.c?.(D)}showInput(D,y=r.CancellationToken.None){return this.d=D?.validateInput,f.$input(D,typeof this.d=="function",y).then(void 0,k=>{if(!(0,p.$3)(k))return Promise.reject(k)})}async $validateInput(D){if(!this.d)return;const y=await this.d(D);if(!y||typeof y=="string")return y;let k;switch(y.severity){case T.InputBoxValidationSeverity.Info:k=I.default.Info;break;case T.InputBoxValidationSeverity.Warning:k=I.default.Warning;break;case T.InputBoxValidationSeverity.Error:k=I.default.Error;break;default:k=y.message?I.default.Error:I.default.Ignore;break}return{content:y.message,severity:k}}async showWorkspaceFolderPick(D,y=r.CancellationToken.None){const k=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!k)return;const A=await this.a.getWorkspaceFolders2();if(A)return A.find(b=>b.uri.toString()===k.uri.toString())}createQuickPick(D){const y=new l(D,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(D){const y=new g(D,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(D,y){this.e.get(D)?._fireDidChangeValue(y)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,y){const k=this.e.get(D);k instanceof l&&k._fireDidChangeActive(y)}$onDidChangeSelection(D,y){const k=this.e.get(D);k instanceof l&&k._fireDidChangeSelection(y)}$onDidTriggerButton(D,y){this.e.get(D)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(D,y,k){const A=this.e.get(D);A instanceof l&&A._fireDidTriggerItemButton(y,k)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class s{static{this.a=1}constructor(D,y){this.x=D,this.y=y,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new h.$le,this.q=new h.$le,this.r=new h.$le,this.s=new h.$le,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){const y=(0,u.$fH)(this.x,"quickInputButtonLocation");!y&&D.some(k=>k.location)&&console.warn(`Extension '${this.x.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`),this.n=D.slice(),this.o.clear(),D.forEach((k,A)=>{const b=k===T.$bP.Back?-1:A;this.o.set(b,k)}),this.z({buttons:D.map((k,A)=>({...d(k.iconPath),tooltip:k.tooltip,handle:k===T.$bP.Back?-1:A,location:y?k.location:void 0}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const y=this.o.get(D);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),f.$dispose(this._id))}z(D){if(!this.v){for(const y of Object.keys(D)){const k=D[y];this.u[y]=k===void 0?null:k}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){f.$createOrUpdate(this.u),this.u={id:this._id}}}function t(E){if(E instanceof T.$LO)return{id:E.id};const D=n(E),y=o(E);return{dark:typeof D=="string"?O.URI.file(D):D,light:typeof y=="string"?O.URI.file(y):y}}function o(E){return typeof E=="object"&&"light"in E?E.light:E}function n(E){return typeof E=="object"&&"dark"in E?E.dark:E}function d(E){const D=t(E);let y,k;return"id"in D?k=S.ThemeIcon.asClassName(D):y=D,{iconPath:y,iconClass:k}}class l extends s{constructor(D,y){super(D,y),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new h.$le,this.L=[],this.M=new h.$le,this.N=new h.$le,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((A,b)=>{this.C.set(b,A),this.D.set(A,b)});const y=(0,u.$fH)(this.x,"quickPickItemTooltip"),k=[];for(let A=0;A<D.length;A++){const b=D[A];if(b.kind===T.QuickPickItemKind.Separator)k.push({type:"separator",label:b.label});else{b.tooltip&&!y&&console.warn(`Extension '${this.x.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`);const v=b.iconPath?d(b.iconPath):void 0;k.push({handle:A,label:b.label,iconPath:v?.iconPath,iconClass:v?.iconClass,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,tooltip:y?P.MarkdownString.fromStrict(b.tooltip):void 0,buttons:b.buttons?.map((F,N)=>({...d(F.iconPath),tooltip:F.tooltip,handle:N}))})}}this.z({items:k})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(D){const y=(0,c.$Gb)(D.map(k=>this.C.get(k)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(D){const y=(0,c.$Gb)(D.map(k=>this.C.get(k)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(D,y){const k=this.C.get(D);if(!k||!k.buttons||!k.buttons.length)return;const A=k.buttons[y];A&&this.N.fire({button:A,item:k})}}class g extends s{constructor(D,y){super(D,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:I.default.Error}):this.z({validationMessage:D.message,severity:D.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new i(m,$)}}),define(ke[314],Ie([1,0,2,4,59,3,7,6,18,134,11,23,40,51,15,25,14,10]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$irc=e.$hrc=void 0;function i(N){return N instanceof r.URI}function s(N,L){return N.scheme===m.Schemas.file&&L.scheme===m.Schemas.file&&$.$l?N.toString()===L.toString():N.toString().toLowerCase()===L.toString().toLowerCase()}function t(N){if(N)return typeof N.iconPath=="string"?r.URI.file(N.iconPath):r.URI.isUri(N.iconPath)||P.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function o(N){if(N){if(r.URI.isUri(N))return N;if(P.ThemeIcon.isThemeIcon(N))return N;{const L=N;return{light:L.light,dark:L.dark}}}else return}function n(N){const L=o(N.icon),M=N.labels?.map(z=>({title:z.title,icon:o(z.icon)}));return{...N,icon:L,labels:M}}function d(N,L){if(!N.iconPath&&!L.iconPath)return 0;if(N.iconPath){if(!L.iconPath)return 1}else return-1;const M=typeof N.iconPath=="string"?N.iconPath:r.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,z=typeof L.iconPath=="string"?L.iconPath:r.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,c.$Kr)(M,z)}function l(N,L){let M=0;if(N.strikeThrough!==L.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==L.faded)return N.faded?1:-1;if(N.tooltip!==L.tooltip)return(N.tooltip||"").localeCompare(L.tooltip||"");if(M=d(N,L),M!==0)return M;if(N.light&&L.light)M=d(N.light,L.light);else{if(N.light)return 1;if(L.light)return-1}if(M!==0)return M;if(N.dark&&L.dark)M=d(N.dark,L.dark);else{if(N.dark)return 1;if(L.dark)return-1}return M}function g(N,L){if(N.command!==L.command)return N.command<L.command?-1:1;if(N.title!==L.title)return N.title<L.title?-1:1;if(N.tooltip!==L.tooltip){if(N.tooltip!==void 0&&L.tooltip!==void 0)return N.tooltip<L.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if(N.arguments===L.arguments)return 0;if(N.arguments)if(L.arguments){if(N.arguments.length!==L.arguments.length)return N.arguments.length-L.arguments.length}else return 1;else return-1;for(let M=0;M<N.arguments.length;M++){const z=N.arguments[M],j=L.arguments[M];if(z!==j&&!(i(z)&&i(j)&&s(z,j)))return z<j?-1:1}return 0}function E(N,L){let M=(0,c.$Kr)(N.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(M!==0)return M;if(N.command&&L.command)M=g(N.command,L.command);else{if(N.command)return 1;if(L.command)return-1}if(M!==0)return M;if(N.decorations&&L.decorations)M=l(N.decorations,L.decorations);else{if(N.decorations)return 1;if(L.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&L.multiFileDiffEditorModifiedUri)M=(0,c.$Kr)(N.multiFileDiffEditorModifiedUri.fsPath,L.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(L.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&L.multiDiffEditorOriginalUri)M=(0,c.$Kr)(N.multiDiffEditorOriginalUri.fsPath,L.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(L.multiDiffEditorOriginalUri)return-1}return M}function D(N,L){for(let M=0;M<N.length;M++)if(N[M]!==L[M])return!1;return!0}function y(N,L){return N.command===L.command&&N.title===L.title&&N.tooltip===L.tooltip&&(N.arguments&&L.arguments?D(N.arguments,L.arguments):N.arguments===L.arguments)}function k(N,L){return(0,p.$tb)(N,L,y)}class A{#e;#t;get value(){return this.d}set value(L){L=L??"",this.#e.$setInputBoxValue(this.m,L),this.o(L)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(L){this.#e.$setInputBoxPlaceholder(this.m,L),this.f=L}get validateInput(){return(0,a.$gH)(this.k,"scmValidation"),this.g}set validateInput(L){if((0,a.$gH)(this.k,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=L,this.#e.$setValidationProviderIsEnabled(this.m,!!L)}get enabled(){return this.h}set enabled(L){L=!!L,this.h!==L&&(this.h=L,this.#e.$setInputBoxEnablement(this.m,L))}get visible(){return this.j}set visible(L){L=!!L,this.j!==L&&(this.j=L,this.#e.$setInputBoxVisibility(this.m,L))}get document(){return(0,a.$gH)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(L,M,z,j,W){this.k=L,this.m=j,this.n=W,this.d="",this.e=new h.$le,this.f="",this.h=!0,this.j=!0,this.#t=M,this.#e=z}showValidationMessage(L,M){(0,a.$gH)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,L,M)}$onInputBoxValueChange(L){this.o(L)}o(L){this.d=L,this.e.fire(L)}}e.$hrc=A;class b{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(L){this.w=L,this.s.$updateGroupLabel(this.u,this.handle,L)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(L){this.q=L,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(L){this.f=[...L],this.k.fire()}constructor(L,M,z,j,W,B,ee){this.s=L,this.t=M,this.u=z,this.v=j,this.w=W,this.multiDiffEditorEnableViewChanges=B,this.x=ee,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new h.$le,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new h.$le,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=b.d++}getResourceState(L){return this.g.get(L)}$executeResourceCommand(L,M){const z=this.h.get(L);return z?(0,O.$xh)(()=>this.t.executeCommand(z.command,...z.arguments||[],M)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this.f].sort(E),z=(0,p.$Cb)(this.p,L,E).map(B=>{const ee=B.toInsert.map(H=>{const q=this.e++;this.g.set(q,H);const Q=H.resourceUri;let _;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"||H.command.command==="vscode.changes"){const re=new R.$Tc;_=this.t.converter.toInternal(H.command,re),this.j.set(q,re)}else this.h.set(q,H.command);const ce=(0,a.$fH)(this.x,"scmMultiDiffEditor"),ne=ce?H.multiDiffEditorOriginalUri:void 0,ye=ce?H.multiFileDiffEditorModifiedUri:void 0,ge=t(H.decorations),Y=H.decorations&&t(H.decorations.light)||ge,U=H.decorations&&t(H.decorations.dark)||ge,oe=[Y,U],ve=H.decorations&&H.decorations.tooltip||"",te=H.decorations&&!!H.decorations.strikeThrough,ae=H.decorations&&!!H.decorations.faded,se=H.contextValue||"";return{rawResource:[q,Q,oe,ve,te,ae,se,_,ne,ye],handle:q}});return{start:B.start,deleteCount:B.deleteCount,toInsert:ee}}),j=z.map(({start:B,deleteCount:ee,toInsert:H})=>[B,ee,H.map(q=>q.rawResource)]),W=z.reverse();for(const{start:B,deleteCount:ee,toInsert:H}of W){const q=H.map(_=>_.handle),Q=this.o.splice(B,ee,...q);for(const _ of Q)this.g.delete(_),this.h.delete(_),this.j.get(_)?.dispose(),this.j.delete(_)}return this.p=L,j}dispose(){this.m=!0,this.n.fire()}}class v{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(L){this.g!==L&&(this.g=L,this.#e.$updateSourceControl(this.x,{count:L}))}get quickDiffProvider(){return this.h}set quickDiffProvider(L){this.h=L;let M;(0,a.$fH)(this.y,"quickDiffProvider")&&(M=L?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!L,quickDiffLabel:M})}get historyProvider(){return(0,a.$gH)(this.y,"scmHistoryProvider"),this.j}set historyProvider(L){(0,a.$gH)(this.y,"scmHistoryProvider"),this.j=L,this.k.value=new R.$Tc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!L}),L&&this.k.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this.m=L?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(L){L!==this.n&&(this.n=L,this.#e.$updateSourceControl(this.x,{commitTemplate:L}))}get acceptInputCommand(){return this.p}set acceptInputCommand(L){this.o.value=new R.$Tc,this.p=L;const M=this.z.converter.toInternal(L,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:M})}get actionButton(){return(0,a.$gH)(this.y,"scmActionButton"),this.s}set actionButton(L){(0,a.$gH)(this.y,"scmActionButton"),this.q.value=new R.$Tc,this.s=L;const M=L!==void 0?{command:this.z.converter.toInternal(L.command,this.q.value),secondaryCommands:L.secondaryCommands?.map(z=>z.map(j=>this.z.converter.toInternal(j,this.q.value))),description:L.description,enabled:L.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:M??null})}get statusBarCommands(){return this.u}set statusBarCommands(L){if(this.u&&L&&k(this.u,L))return;this.t.value=new R.$Tc,this.u=L;const M=(L||[]).map(z=>this.z.converter.toInternal(z,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:M})}get selected(){return this.v}constructor(L,M,z,j,W,B,ee){this.y=L,this.z=j,this.A=W,this.B=B,this.C=ee,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Vc,this.n=void 0,this.o=new R.$Vc,this.p=void 0,this.q=new R.$Vc,this.t=new R.$Vc,this.u=void 0,this.v=!1,this.w=new h.$le,this.onDidChangeSelection=this.w.event,this.x=v.d++,this.D=new Map,this.E=new Set,this.#e=z;const H=r.URI.from({scheme:m.Schemas.vscodeSourceControl,path:`${W}/scm${this.x}/input`,query:ee?`rootUri=${encodeURIComponent(ee.toString())}`:void 0});this.f=new A(L,M,this.#e,this.x,H),this.#e.$registerSourceControl(this.x,W,B,ee,H)}createResourceGroup(L,M,z){const j=(0,a.$fH)(this.y,"scmMultiDiffEditor")&&z?.multiDiffEditorEnableViewChanges===!0,W=new b(this.#e,this.z,this.x,L,M,j,this.y),B=h.Event.once(W.onDidDispose)(()=>this.D.delete(W));return this.D.set(W,B),this.eventuallyAddResourceGroups(),W}eventuallyAddResourceGroups(){const L=[],M=[];for(const[z,j]of this.D){j.dispose();const W=z.onDidUpdateResourceStates(()=>{this.E.add(z),this.eventuallyUpdateResourceStates()});h.Event.once(z.onDidDispose)(()=>{this.E.delete(z),W.dispose(),this.e.delete(z.handle),this.#e.$unregisterGroup(this.x,z.handle)}),L.push([z.handle,z.id,z.label,z.features,z.multiDiffEditorEnableViewChanges]);const B=z._takeResourceStateSnapshot();B.length>0&&M.push([z.handle,B]),this.e.set(z.handle,z)}this.#e.$registerGroups(this.x,L,M),this.D.clear()}eventuallyUpdateResourceStates(){const L=[];this.E.forEach(M=>{const z=M._takeResourceStateSnapshot();z.length!==0&&L.push([M.handle,z])}),L.length>0&&this.#e.$spliceResourceStates(this.x,L),this.E.clear()}getResourceGroup(L){return this.e.get(L)}setSelectionState(L){this.v=L,this.w.fire(L)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(L=>L.dispose()),this.#e.$unregisterSourceControl(this.x)}}Je([(0,C.$$h)(100)],v.prototype,"eventuallyAddResourceGroups",null),Je([(0,C.$$h)(100)],v.prototype,"eventuallyUpdateResourceStates",null);let F=class{static{f=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(L,M,z,j){this.m=M,this.n=z,this.o=j,this.g=new Map,this.h=new S.$tn,this.j=new h.$le,this.e=L.getProxy(T.$KN.MainThreadSCM),this.f=L.getProxy(T.$KN.MainThreadTelemetry),M.registerArgumentProcessor({processArgument:W=>{if(W&&W.$mid===u.MarshalledId.ScmResource){const B=this.g.get(W.sourceControlHandle);if(!B)return W;const ee=B.getResourceGroup(W.groupHandle);return ee?ee.getResourceState(W.handle):W}else if(W&&W.$mid===u.MarshalledId.ScmResourceGroup){const B=this.g.get(W.sourceControlHandle);return B?B.getResourceGroup(W.groupHandle):W}else if(W&&W.$mid===u.MarshalledId.ScmProvider){const B=this.g.get(W.handle);return B||W}return W}})}createSourceControl(L,M,z,j){this.o.trace("ExtHostSCM#createSourceControl",L.identifier.value,M,z,j),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const W=f.d++,B=new v(L,this.n,this.e,this.m,M,z,j);this.g.set(W,B);const ee=this.h.get(L.identifier)||[];return ee.push(B),this.h.set(L.identifier,ee),B}getLastInputBox(L){this.o.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const M=this.h.get(L.identifier),z=M&&M[M.length-1];return z&&z.inputBox}$provideOriginalResource(L,M,z){const j=r.URI.revive(M);this.o.trace("ExtHostSCM#$provideOriginalResource",L,j.toString());const W=this.g.get(L);return!W||!W.quickDiffProvider||!W.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,O.$xh)(()=>W.quickDiffProvider.provideOriginalResource(j,z)).then(B=>B||null)}$onInputBoxValueChange(L,M){this.o.trace("ExtHostSCM#$onInputBoxValueChange",L);const z=this.g.get(L);return z&&z.inputBox.$onInputBoxValueChange(M),Promise.resolve(void 0)}$executeResourceCommand(L,M,z,j){this.o.trace("ExtHostSCM#$executeResourceCommand",L,M,z);const W=this.g.get(L);if(!W)return Promise.resolve(void 0);const B=W.getResourceGroup(M);return B?B.$executeResourceCommand(z,j):Promise.resolve(void 0)}$validateInput(L,M,z){this.o.trace("ExtHostSCM#$validateInput",L);const j=this.g.get(L);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,O.$xh)(()=>j.inputBox.validateInput(M,z)).then(W=>{if(!W)return Promise.resolve(void 0);const B=w.MarkdownString.fromStrict(W.message);return B?Promise.resolve([B,W.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this.g.get(L)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(L,M,z,j){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(M,z,j)??void 0}async $resolveHistoryItemGroupCommonAncestor2(L,M,z){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(M,z)??void 0}async $provideHistoryItems(L,M,z,j){return(await this.g.get(L)?.historyProvider?.provideHistoryItems(M,z,j))?.map(ee=>n(ee))??void 0}async $provideHistoryItems2(L,M,z){return(await this.g.get(L)?.historyProvider?.provideHistoryItems2(M,z))?.map(B=>n(B))??void 0}async $provideHistoryItemSummary(L,M,z,j){const W=this.g.get(L)?.historyProvider;if(typeof W?.provideHistoryItemSummary!="function")return;const B=await W.provideHistoryItemSummary(M,z,j);return B?n(B):void 0}async $provideHistoryItemChanges(L,M,z,j){return await this.g.get(L)?.historyProvider?.provideHistoryItemChanges(M,z,j)??void 0}};e.$irc=F,e.$irc=F=f=Je([Ve(3,I.$ak)],F)}),define(ke[315],Ie([1,0,6,15,2]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jrc=void 0;class R{static{this.a=0}constructor(T,p){this.d=p,this.c=new Map,this.b=T.getProxy(r.$KN.MainThreadShare)}async $provideShare(T,p,c){return await this.c.get(T)?.provideShare({selection:h.Range.to(p.selection),resourceUri:C.URI.revive(p.resourceUri)},c)??void 0}registerShareProvider(T,p){const c=R.a++;return this.c.set(c,p),this.b.$registerShareProvider(c,h.DocumentSelector.from(T,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(c),this.c.delete(c)}}}}e.$jrc=R}),define(ke[316],Ie([1,0,9,6,8,3,15,17]),function($e,e,r,h,C,R,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mrc=e.$lrc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new r.$MO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.$MO("statusBarItem.warningForeground")]])}#e;#t;constructor(u,P,w,a,m,$=r.StatusBarAlignment.Left,f){if(this.i=!1,this.k="",this.q=new R.$Tc,this.#e=u,this.#t=P,m&&a){this.c=(0,r.$oO)(a.identifier,m);const i=w.get(this.c);i&&($=i.alignLeft?r.StatusBarAlignment.Left:r.StatusBarAlignment.Right,f=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(p.a++);this.e=a,this.f=m,this.g=$,this.h=this.u(f)}u(u){if((0,T.$ig)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!p.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new R.$Tc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let P;this.m?P=this.m:P=(0,C.localize)(10826,null,this.e.displayName||this.e.name);let w=this.n;this.o&&(w=p.b.get(this.o.id));const a=O.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,P,this.k,a,this.r?.internal,w,this.o,this.g===r.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$lrc=p;class c{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(10827,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const P={message:u};return this.b.unshift(P),this.c(),new r.$MN(()=>{const w=this.b.indexOf(P);w>=0&&(this.b.splice(w,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(u,P){this.e=new Map,this.a=u.getProxy(h.$KN.MainThreadStatusBar),this.b=P,this.c=new c(this)}$acceptStaticEntries(u){for(const P of u)this.e.set(P.entryId,P)}createStatusBarEntry(u,P,w,a){return new p(this.a,this.b,this.e,u,P,w,a)}setStatusBarMessage(u,P){const w=this.c.setMessage(u);let a;return typeof P=="number"?a=setTimeout(()=>w.dispose(),P):typeof P<"u"&&P.then(()=>w.dispose(),()=>w.dispose()),new r.$MN(()=>{w.dispose(),clearTimeout(a)})}}e.$mrc=I}),define(ke[166],Ie([1,0,30,155,73,120,74,15,2]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQ=e.$yQ=e.$xQ=e.$wQ=void 0,r=qe(r),T=qe(T);const c=(i,s,t,o)=>{let n=s;return{enumerable:!0,configurable:!1,get(){return n},set(d){if(!t(n,d)){const l=n;n=d,i.listener?.(o(d,l))}}}},I=(i,s)=>i===s,S={range:(i,s)=>i===s?!0:!i||!s?!1:i.isEqual(s),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,s)=>!(i.length!==s.length||i.some(t=>!s.find(o=>t.id===o.id)))},u=i=>s=>({op:R.TestItemEventOp.SetProp,update:i(s)}),P=(i,s)=>({range:(()=>{let t;const o=u(n=>({range:r.$Ot.lift(T.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return t},set(n){i.listener?.({op:R.TestItemEventOp.DocumentSynced}),S.range(t,n)||(t=n,i.listener?.(o(n)))}}})(),label:c(i,s,S.label,u(t=>({label:t}))),description:c(i,void 0,S.description,u(t=>({description:t}))),sortText:c(i,void 0,S.sortText,u(t=>({sortText:t}))),canResolveChildren:c(i,!1,S.canResolveChildren,t=>({op:R.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:c(i,!1,S.busy,u(t=>({busy:t}))),error:c(i,void 0,S.error,u(t=>({error:T.MarkdownString.fromStrict(t)||null}))),tags:c(i,[],S.tags,(t,o)=>({op:R.TestItemEventOp.SetTags,new:t.map(T.TestTag.from),old:o.map(T.TestTag.from)}))}),w=i=>{const s=C.$7I.fromString(i.extId),t=new m(s.controllerId,s.localId,i.label,p.URI.revive(i.uri)||void 0);return t.range=T.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(o=>T.TestTag.to({id:(0,O.$aJ)(o).tagId})),t},a=i=>{let s;for(const t of i.tests){const o=w(t.item);(0,h.$gQ)(o).parent=s,s=o}return s};e.$wQ=a;class m{constructor(s,t,o,n){if(t.includes(C.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const d=(0,h.$fQ)(this,s);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof $?void 0:d.parent}},children:{value:(0,R.$eQ)(d,h.$gQ,m),enumerable:!0,writable:!1},...P(d,o)})}}e.$xQ=m;class $ extends m{constructor(s,t){super(s,s,t,void 0),this._isRoot=!0}}e.$yQ=$;class f extends R.$aQ{constructor(s,t,o){super({controllerId:s,getDocumentVersion:n=>n&&o.getDocument(n)?.version,getApiFor:h.$gQ,getChildren:n=>n.children,root:new $(s,t),toITestItem:T.TestItem.from})}}e.$zQ=f}),define(ke[34],Ie([1,0,17,9,15,24,6,18,11,44,30,57,2,3,5,19,166,21,53,52,42,91,94,32]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KQ=e.$JQ=e.$IQ=e.$HQ=e.$GQ=e.$FQ=void 0,h=qe(h),C=qe(C);let d=class{#e;#t;#i;constructor(k,A,b){this.b=new Map,this.c=new Map,this.#e=k.getProxy(O.$KN.MainThreadCommands),this.d=A,this.#i=b,this.#t=k.getProxy(O.$KN.MainThreadTelemetry),this.converter=new l(this,v=>{const F=this.c.get(v);return F?.result===E.Void?F:void 0},A),this.f=[{processArgument(v){return(0,c.$ci)(v)}},{processArgument(v){return(0,R.$go)(v,function(F){if(I.$Ot.isIRange(F))return C.Range.to(F);if(S.$Nt.isIPosition(F))return C.Position.to(F);if(I.$Ot.isIRange(F.range)&&u.URI.isUri(F.uri))return C.location.to(F);if(F instanceof $.$Ne)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const A=this.registerCommand(!1,k.id,async(...b)=>{const v=k.args.map((N,L)=>{if(!N.validate(b[L]))throw new Error(`Invalid argument '${N.name}' when running '${k.id}', received: ${typeof b[L]=="object"?JSON.stringify(b[L],null,"	"):b[L]} `);return N.convert(b[L])}),F=await this.executeCommand(k.internalId,...v);return k.result.convert(F,b,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new h.$MN(()=>{A.dispose(),this.c.delete(k.id)})}registerCommand(k,A,b,v,F,N){if(this.d.trace("ExtHostCommands#registerCommand",A),!A.trim().length)throw new Error("invalid id");if(this.b.has(A))throw new Error(`command '${A}' already exists`);return this.b.set(A,{callback:b,thisArg:v,metadata:F,extension:N}),k&&this.#e.$registerCommand(A),new h.$MN(()=>{this.b.delete(A)&&k&&this.#e.$unregisterCommand(A)})}executeCommand(k,...A){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,A,!0)}async g(k,A,b){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,A,!1);{let v=!1;const F=(0,R.$go)(A,function(N){if(N instanceof h.$NN)return C.Position.from(N);if(N instanceof h.$ON)return C.Range.from(N);if(N instanceof h.$1N)return C.location.from(N);if(h.$eP.isNotebookRange(N))return C.NotebookRange.from(N);if(N instanceof ArrayBuffer)return v=!0,$.$Ne.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return v=!0,$.$Ne.wrap(N);if(N instanceof $.$Ne)return v=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(k,v?new f.$Xw(F):F,b);return(0,c.$ci)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(k,A,!1);throw N}}}async h(k,A,b){const v=this.b.get(k);if(!v)throw new Error("Unknown command");const{callback:F,thisArg:N,metadata:L}=v;if(L?.args)for(let z=0;z<L.args.length;z++)try{(0,r.$vg)(A[z],L.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${L.args[z].name}' - ${L.args[z].description}`)}const M=s.$fe.create();try{return await F.apply(N,A)}catch(z){if(k===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...A);j&&(k=j.command)}if(this.d.error(z,k,v.extension?.identifier),!b)throw z;if(v.extension?.identifier){const j=this.#i.onExtensionError(v.extension.identifier,z);this.d.trace("forwarded error to extension?",j,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$qj)(z)),this.id=k,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,k,M.elapsed())}}j(k,A,b){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new t.$xp(A),duration:b})}$executeContributedCommand(k,...A){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const b=this.b.get(k);return b?(A=A.map(v=>this.f.reduce((F,N)=>N.processArgument(F,b.extension?.identifier),v)),this.h(k,A,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(A=>(k&&(A=A.filter(b=>b[0]!=="_")),A))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[A,b]of this.b){const{metadata:v}=b;v&&(k[A]=v)}return Promise.resolve(k)}};e.$FQ=d,e.$FQ=d=Je([Ve(0,a.$kQ),Ve(1,p.$ak),Ve(2,o.$EQ)],d),e.$GQ=(0,w.$Fi)("IExtHostCommands");class l{constructor(k,A,b){this.d=k,this.f=A,this.g=b,this.delegatingCommandId=`__vsc${(0,n.$2g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,A){if(!k)return;const b={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return b;const v=this.f(k.command);if(v)b.id=v.internalId,b.arguments=v.args.map((F,N)=>F.convert(k.arguments&&k.arguments[N]));else if((0,T.$Kb)(k.arguments)){const F=`${k.command} /${++this.c}`;this.b.set(F,k),A.add((0,P.$Sc)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),b.$ident=F,b.id=this.delegatingCommandId,b.arguments=[F],this.g.trace("CommandsConverter#CREATE",k.command,F)}return b}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const A=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],A?A.command:"MISSING"),A?this.d.executeCommand(A.command,...A.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$HQ=l;class g{static{this.Uri=new g("uri","Uri of a text document",k=>u.URI.isUri(k),k=>k)}static{this.Position=new g("position","A position in a text document",k=>h.$NN.isPosition(k),C.Position.from)}static{this.Range=new g("range","A range in a text document",k=>h.$ON.isRange(k),C.Range.from)}static{this.Selection=new g("selection","A selection in a text document",k=>h.$PN.isSelection(k),C.Selection.from)}static{this.Number=new g("number","",k=>typeof k=="number",k=>k)}static{this.String=new g("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=g.Arr(g.String)}static Arr(k){return new g(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,A=>Array.isArray(A)&&A.every(b=>k.validate(b)),A=>A.map(b=>k.convert(b)))}static{this.CallHierarchyItem=new g("item","A call hierarchy item",k=>k instanceof h.$aO,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new g("item","A type hierarchy item",k=>k instanceof h.$zP,C.TypeHierarchyItem.from)}static{this.TestItem=new g("testItem","A VS Code TestItem",k=>k instanceof m.$xQ,C.TestItem.from)}constructor(k,A,b,v){this.name=k,this.description=A,this.validate=b,this.convert=v}optional(){return new g(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,A){return new g(k??this.name,A??this.description,this.validate,this.convert)}}e.$IQ=g;class E{static{this.Void=new E("no result",k=>k)}constructor(k,A){this.description=k,this.convert=A}}e.$JQ=E;class D{constructor(k,A,b,v,F){this.id=k,this.internalId=A,this.description=b,this.args=v,this.result=F}}e.$KQ=D}),define(ke[317],Ie([1,0,18,14,2,87,142,35,34,15,9]),function($e,e,r,h,C,R,O,T,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bpc=void 0,R=qe(R),c=qe(c),I=qe(I);const S=[new p.$KQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of DocumentHighlight-instances.",P(c.DocumentHighlight.to))),new p.$KQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$IQ.Uri],new p.$JQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,m)=>{if((0,r.$Jb)(a))return;class $ extends I.$8N{static to(i){const s=new $(i.name,c.SymbolKind.to(i.kind),i.containerName||"",new I.$1N(m[0],c.Range.to(i.range)));return s.detail=i.detail,s.range=s.location.range,s.selectionRange=c.Range.to(i.selectionRange),s.children=i.children?i.children.map($.to):[],s}}return a.map($.to)})),new p.$KQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$IQ.Uri,new p.$IQ("options","Formatting options",a=>!0,a=>a)],new p.$JQ("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new p.$KQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$IQ.Uri,p.$IQ.Range,new p.$IQ("options","Formatting options",a=>!0,a=>a)],new p.$JQ("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new p.$KQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$IQ.Uri,p.$IQ.Position,new p.$IQ("ch","Trigger character",a=>typeof a=="string",a=>a),new p.$IQ("options","Formatting options",a=>!0,a=>a)],new p.$JQ("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new p.$KQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new p.$KQ("vscode.experimental.executeDefinitionProvider_recursive","_executeDefinitionProvider_recursive","Execute all definition providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new p.$KQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new p.$KQ("vscode.experimental.executeTypeDefinitionProvider_recursive","_executeTypeDefinitionProvider_recursive","Execute all type definition providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new p.$KQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new p.$KQ("vscode.experimental.executeDeclarationProvider_recursive","_executeDeclarationProvider_recursive","Execute all declaration providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new p.$KQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new p.$KQ("vscode.experimental.executeImplementationProvider_recursive","_executeImplementationProvider_recursive","Execute all implementation providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new p.$KQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Location-instances.",P(c.location.to))),new p.$KQ("vscode.experimental.executeReferenceProvider","_executeReferenceProvider_recursive","Execute all reference providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Location-instances.",P(c.location.to))),new p.$KQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Hover-instances.",P(c.Hover.to))),new p.$KQ("vscode.experimental.executeHoverProvider_recursive","_executeHoverProvider_recursive","Execute all hover providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Hover-instances.",P(c.Hover.to))),new p.$KQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$IQ.Uri,new p.$IQ("position","A position in a text document",a=>Array.isArray(a)&&a.every(m=>I.$NN.isPosition(m)),a=>a.map(c.Position.from))],new p.$JQ("A promise that resolves to an array of ranges.",a=>a.map(m=>{let $;for(const f of m.reverse())$=new I.$_N(c.Range.to(f),$);return $}))),new p.$KQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$IQ.String.with("query","Search string")],new p.$JQ("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(c.WorkspaceSymbol.to))),new p.$KQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(c.CallHierarchyItem.to))),new p.$KQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$IQ.CallHierarchyItem],new p.$JQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(c.CallHierarchyIncomingCall.to))),new p.$KQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$IQ.CallHierarchyItem],new p.$JQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(c.CallHierarchyOutgoingCall.to))),new p.$KQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:c.Range.to(a.range),placeholder:a.text}})),new p.$KQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$IQ.Uri,p.$IQ.Position,p.$IQ.String.with("newName","The new symbol name")],new p.$JQ("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return c.WorkspaceEdit.to(a)}})),new p.$KQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$IQ.Uri,p.$IQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$JQ("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(c.DocumentLink.to))),new p.$KQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$IQ.Uri],new p.$JQ("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new I.$8O(a.tokenTypes,a.tokenModifiers)})),new p.$KQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$IQ.Uri],new p.$JQ("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,O.$Ydb)(a);if(m.type==="full")return new I.$0O(m.data,void 0)})),new p.$KQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$IQ.Uri,p.$IQ.Range.optional()],new p.$JQ("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new I.$8O(a.tokenTypes,a.tokenModifiers)})),new p.$KQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$IQ.Uri,p.$IQ.Range],new p.$JQ("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,O.$Ydb)(a);if(m.type==="full")return new I.$0O(m.data,void 0)})),new p.$KQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$IQ.Uri,p.$IQ.Position,p.$IQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$IQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$JQ("A promise that resolves to a CompletionList-instance.",(a,m,$)=>{if(!a)return new I.$lO([]);const f=a.suggestions.map(i=>c.CompletionItem.to(i,$));return new I.$lO(f,a.incomplete)})),new p.$KQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$IQ.Uri,p.$IQ.Position,p.$IQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$JQ("A promise that resolves to SignatureHelp.",a=>{if(a)return c.SignatureHelp.to(a)})),new p.$KQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$IQ.Uri,p.$IQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$JQ("A promise that resolves to an array of CodeLens-instances.",(a,m,$)=>P(f=>new I.$dO(c.Range.to(f.range),f.command&&$.fromInternal(f.command)))(a))),new p.$KQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$IQ.Uri,new p.$IQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>I.$ON.isRange(a),a=>I.$PN.isSelection(a)?c.Selection.from(a):c.Range.from(a)),p.$IQ.String.with("kind","Code action kind to return code actions for").optional(),p.$IQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$JQ("A promise that resolves to an array of Command-instances.",(a,m,$)=>P(f=>{if(f._isSynthetic){if(!f.command)throw new Error("Synthetic code actions must have a command");return $.fromInternal(f.command)}else{const i=new I.$0N(f.title,f.kind?new I.$$N(f.kind):void 0);return f.edit&&(i.edit=c.WorkspaceEdit.to(f.edit)),f.command&&(i.command=$.fromInternal(f.command)),i.isPreferred=f.isPreferred,i}})(a))),new p.$KQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$IQ.Uri],new p.$JQ("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(m=>new I.$rO(c.Range.to(m.range),c.Color.to(m.color))):[])),new p.$KQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$IQ("color","The color to show and insert",a=>a instanceof I.$qO,c.Color.from),new p.$IQ("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:c.Range.from(a.range)}))],new p.$JQ("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(c.ColorPresentation.to):[])),new p.$KQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$IQ.Uri,p.$IQ.Range],new p.$JQ("A promise that resolves to an array of Inlay objects",(a,m,$)=>a.map(c.InlayHint.to.bind(void 0,$)))),new p.$KQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$IQ.Uri],new p.$JQ("A promise that resolves to an array of FoldingRange objects",(a,m)=>{if(a)return a.map(c.FoldingRange.to)})),new p.$KQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$JQ("A promise that resolves to an array of NotebookContentProvider static info objects.",P(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(m=>c.NotebookExclusiveDocumentPattern.to(m))})))),new p.$KQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$IQ.Uri,p.$IQ.Range,new p.$IQ("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof I.$ON,a=>c.InlineValueContext.from(a))],new p.$JQ("A promise that resolves to an array of InlineValue objects",a=>a.map(c.InlineValue.to))),new p.$KQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$IQ("uriOrString","Uri-instance or string (only http/https)",a=>C.URI.isUri(a)||typeof a=="string"&&(0,h.$Pg)(a,h.Schemas.http,h.Schemas.https),a=>a),new p.$IQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[c.ViewColumn.from(a),void 0]:[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)])).optional(),p.$IQ.String.with("label","").optional()],p.$JQ.Void),new p.$KQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$IQ.Uri.with("resource","Resource to open"),p.$IQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$IQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[c.ViewColumn.from(a),void 0]:[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)])).optional()],p.$JQ.Void),new p.$KQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$IQ.Uri.with("left","Left-hand side resource of the diff editor"),p.$IQ.Uri.with("right","Right-hand side resource of the diff editor"),p.$IQ.String.with("title","Human readable title for the diff editor").optional(),new p.$IQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)]).optional()],p.$JQ.Void),new p.$KQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$IQ.String.with("title","Human readable title for the changes editor"),new p.$IQ("resourceList","List of resources to compare",a=>{for(const m of a){if(m.length!==3)return!1;const[$,f,i]=m;if(!C.URI.isUri($)||!C.URI.isUri(f)&&f!==void 0&&f!==null||!C.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},a=>a)],p.$JQ.Void),new p.$KQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new p.$KQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$IQ.TypeHierarchyItem],new p.$JQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new p.$KQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$IQ.TypeHierarchyItem],new p.$JQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new p.$KQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$IQ.TestItem],p.$JQ.Void),new p.$KQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$IQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$JQ.Void),new p.$KQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$IQ.String.with("name","The context key name"),new p.$IQ("value","The context key value",()=>!0,a=>a)],p.$JQ.Void),new p.$KQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$IQ.Uri,p.$IQ.StringArray,new p.$IQ("MappedEditsContext","Mapped Edits Context",a=>c.MappedEditsContext.is(a),a=>c.MappedEditsContext.from(a))],new p.$JQ("A promise that resolves to a workspace edit or null",a=>a?c.WorkspaceEdit.to(a):null)),new p.$KQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$IQ("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?c.Range.from(a.initialRange):void 0,initialSelection:I.$PN.isSelection(a.initialSelection)?c.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?c.Position.from(a.position):void 0}})],p.$JQ.Void)];class u{static register(m){S.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",T.$Ej)}}e.$Bpc=u;function P(a){return m=>{if(Array.isArray(m))return m.map(a)}}function w(a){if(!Array.isArray(a))return;const m=[];for(const $ of a)R.$Lu($)?m.push(c.DefinitionLink.to($)):m.push(c.location.to($));return m}}),define(ke[318],Ie([1,0,2,34]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3qc=void 0;class C{constructor(O,T,p,c,I){this.a=T,this.b=p,this.c=c;const S=new h.$KQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new h.$IQ("showOptions","Show Options",u=>!0,u=>u),new h.$IQ("resource","Interactive resource Uri",u=>!0,u=>u),new h.$IQ("controllerId","Notebook controller Id",u=>!0,u=>u),new h.$IQ("title","Interactive editor title",u=>!0,u=>u)],new h.$JQ("Notebook and input URI",u=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const P=this.a.getEditorById(u.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",P.id),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri),notebookEditor:P.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(O,T,p,c){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:p,uri:O,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(O,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[O]})}}e.$3qc=C}),define(ke[319],Ie([1,0,18,7,20,4,3,28,2,23,11,6,34,15,9,121,261,25,53,262]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$qc=void 0,e.$_qc=g,P=qe(P);let s=class{constructor(D,y,k,A,b){this.m=y,this.n=k,this.o=A,this.q=b,this.b=new T.$Ac,this.c=new T.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$le,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(S.$KN.MainThreadNotebookKernels);const v=new u.$KQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$IQ("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const L=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:L}}else if(N&&"notebookEditor"in N){const L=this.n.getIdByEditor(N.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:L}}return N})],u.$JQ.Void),F=new u.$KQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$IQ.Uri],new u.$JQ("A promise that resolves to an array of variables",(N,L)=>N.map(M=>({variable:{name:M.name,value:M.value,expression:M.expression,type:M.type,language:M.language},hasNamedChildren:M.hasNamedChildren,indexedChildrenCount:M.indexedChildrenCount}))));this.o.registerApiCommand(v),this.o.registerApiCommand(F)}createNotebookController(D,y,k,A,b,v){for(const ne of this.j.values())if(ne.controller.id===y&&c.$rn.equals(D.identifier,ne.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const F=this.k++,N=this;this.q.trace(`NotebookController[${F}], CREATED by ${D.identifier.value}, ${y}`);const L=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${D.identifier}'`);let M=!1;const z=new R.$le,j=new R.$le,W={id:g(D.identifier,y),notebookType:k,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:A||D.identifier.value,preloads:v?v.map(P.NotebookRendererScript.from):[]};let B=b??L,ee,H;this.a.$addKernel(F,W).catch(ne=>{console.log(ne),M=!0});let q=0;const Q=()=>{if(M)return;const ne=++q;Promise.resolve().then(()=>{ne===q&&this.a.$updateKernel(F,W)})},_=new T.$Ac,ce={get id(){return y},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return W.label},set label(ne){W.label=ne??D.displayName??D.name,Q()},get detail(){return W.detail??""},set detail(ne){W.detail=ne,Q()},get description(){return W.description??""},set description(ne){W.description=ne,Q()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages(ne){W.supportedLanguages=ne,Q()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){W.supportsExecutionOrder=ne,Q()},get rendererScripts(){return W.preloads?W.preloads.map(P.NotebookRendererScript.to):[]},get executeHandler(){return B},set executeHandler(ne){B=ne??L},get interruptHandler(){return ee},set interruptHandler(ne){ee=ne,W.supportsInterrupt=!!ne,Q()},set variableProvider(ne){(0,$.$gH)(D,"notebookVariableProvider"),H=ne,W.hasVariableProvider=!!ne,ne?.onDidChangeVariables(ye=>N.a.$variablesUpdated(ye.uri)),Q()},get variableProvider(){return H},createNotebookCellExecution(ne){if(M)throw new Error("notebook controller is DISPOSED");if(!_.has(ne.notebook.uri))throw N.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(_.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return N._createNotebookCellExecution(ne,g(D.identifier,this.id))},createNotebookExecution(ne){if((0,$.$gH)(D,"notebookExecution"),M)throw new Error("notebook controller is DISPOSED");if(!_.has(ne.uri))throw N.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(_.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.uri.toString()}`);return N._createNotebookExecution(ne,g(D.identifier,this.id))},dispose:()=>{M||(this.q.trace(`NotebookController[${F}], DISPOSED`),M=!0,this.j.delete(F),z.dispose(),j.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(ne,ye){ye===w.NotebookControllerAffinity2.Hidden&&(0,$.$gH)(D,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(F,ne.uri,ye)},onDidReceiveMessage:j.event,postMessage(ne,ye){return(0,$.$gH)(D,"notebookMessaging"),N.a.$postMessage(F,ye&&N.n.getIdByEditor(ye),ne)},asWebviewUri(ne){return(0,$.$gH)(D,"notebookMessaging"),(0,a.$HDb)(ne,N.m.remote)}};return this.j.set(F,{extensionId:D.identifier,controller:ce,onDidReceiveMessage:j,onDidChangeSelection:z,associatedNotebooks:_}),ce}getIdByController(D){for(const[y,k]of this.j)if(k.controller===D)return g(k.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,y){const k=this.g++,A=this;this.q.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(k,y);const b={dispose:()=>{this.f.delete(k),A.a.$removeKernelDetectionTask(k)}};return this.f.set(k,b),b}registerKernelSourceActionProvider(D,y,k){const A=this.i++,b=typeof k.onDidChangeNotebookKernelSourceActions=="function"?A:void 0,v=this;this.h.set(A,k),this.q.trace(`NotebookKernelSourceActionProvider[${A}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(A,A,y);let F;return b!==void 0&&(F=k.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this.h.delete(A),v.a.$removeKernelSourceActionProvider(A,A),F?.dispose()}}}async $provideKernelSourceActions(D,y){const k=this.h.get(D);if(k){const A=new O.$Tc;return(await k.provideNotebookKernelSourceActions(y)??[]).map(v=>P.NotebookKernelSourceAction.from(v,this.o.converter,A))}return[]}$acceptNotebookAssociation(D,y,k){const A=this.j.get(D);if(A){const b=this.n.getNotebookDocument(p.URI.revive(y));k?A.associatedNotebooks.set(b.uri,!0):A.associatedNotebooks.delete(b.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,b.uri.toString(),k),A.onDidChangeSelection.fire({selected:k,notebook:b.apiNotebook})}}async $executeCells(D,y,k){const A=this.j.get(D);if(!A)return;const b=this.n.getNotebookDocument(p.URI.revive(y)),v=[];for(const F of k){const N=b.getCell(F);N&&v.push(N.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,b.uri.toString(),v.length),await A.controller.executeHandler.call(A.controller,v,b.apiNotebook,A.controller)}catch(F){this.q.error(`NotebookController[${D}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(D,y,k){const A=this.j.get(D);if(!A)return;const b=this.n.getNotebookDocument(p.URI.revive(y));if(A.controller.interruptHandler)await A.controller.interruptHandler.call(A.controller,b.apiNotebook);else for(const v of k){const F=b.getCell(v);F&&this.b.get(F.uri)?.cancel()}if(A.controller.interruptHandler){const v=this.c.get(b.uri);this.c.delete(b.uri),k.length&&Array.isArray(v)&&v.length&&v.forEach(F=>F.dispose())}}async $provideVariables(D,y,k,A,b,v,F){const N=this.j.get(D);if(!N)return;const L=this.n.getNotebookDocument(p.URI.revive(k)),M=N.controller.variableProvider;if(!M)return;let z;if(A!==void 0){if(z=this.s[A],!z)return}else this.s={};const j=b==="named"?w.NotebookVariablesRequestKind.Named:w.NotebookVariablesRequestKind.Indexed,W=M.provideVariables(L.apiNotebook,z,j,v,F);let B=0;for await(const ee of W){if(F.isCancellationRequested)return;const H={id:this.r++,name:ee.variable.name,value:ee.variable.value,type:ee.variable.type,interfaces:ee.variable.interfaces,language:ee.variable.language,expression:ee.variable.expression,hasNamedChildren:ee.hasNamedChildren,indexedChildrenCount:ee.indexedChildrenCount,extensionId:N.extensionId.value};if(this.s[H.id]=ee.variable,this.a.$receiveVariable(y,H),B++>=i.$ZK)return}}$acceptKernelMessageFromRenderer(D,y,k){const A=this.j.get(D);if(!A)return;const b=this.n.getEditorById(y);A.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:k}))}$cellExecutionChanged(D,y,k){const b=this.n.getNotebookDocument(p.URI.revive(D)).getCell(y);if(b){const v=k?P.NotebookCellExecutionState.to(k):w.NotebookCellExecutionState.Idle;v!==void 0&&this.l.fire({cell:b.apiCell,state:v})}}_createNotebookCellExecution(D,y){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const A=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!A)throw new Error("invalid cell");if(this.b.has(A.uri))throw new Error(`duplicate execution for ${A.uri}`);const b=new o(y,A,this.a);this.b.set(A.uri,b);const v=b.onDidChangeState(()=>{b.state===t.Resolved&&(b.dispose(),v.dispose(),this.b.delete(A.uri))});return b.asApiObject()}_createNotebookExecution(D,y){const k=this.n.getNotebookDocument(D.uri),A=D.getCells().find(F=>{const N=k.getCellFromApiCell(F);return N&&this.b.has(N.uri)});if(A)throw new Error(`duplicate cell execution for ${A.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const b=new d(y,k,this.a),v=b.onDidChangeState(()=>{b.state===n.Resolved&&(b.dispose(),v.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[b,v]),b.asApiObject()}};e.$$qc=s,e.$$qc=s=Je([Ve(4,I.$ak)],s);var t;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(t||(t={}));class o extends O.$Uc{static{this.a=0}get state(){return this.f}constructor(D,y,k){super(),this.m=y,this.n=k,this.b=o.a++,this.c=new R.$le,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new C.$we),this.h=new l(10,A=>this.s(A)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const y=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new f.$Xw(y))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let y=this.m;if(D&&(y=this.m.notebook.getCellFromApiCell(D)),!y)throw new Error("INVALID cell");return y.handle}y(D){return D.map(y=>{const k=w.$iP.ensureUniqueMimeTypes(y.items,!0);return k===y.items?P.NotebookCellOutput.from(y):P.NotebookCellOutput.from({items:k,id:y.id,metadata:y.metadata})})}async z(D,y,k){const A=this.w(y),b=this.y((0,r.$1b)(D));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:A,append:k,outputs:b})}async C(D,y,k){return D=w.$iP.ensureUniqueMimeTypes((0,r.$1b)(D),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:D.map(P.NotebookCellOutputItem.from),outputId:y.id,append:k})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(k){D.j=k,D.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(k){if(D.f===t.Resolved||D.f===t.Started)throw new Error("Cannot call start again");D.f=t.Started,D.c.fire(),D.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,A,b){if(D.f===t.Resolved)throw new Error("Cannot call resolve twice");D.f=t.Resolved,D.c.fire(),D.h.flush();const v=b?{message:b.message,stack:b.stack,location:b?.location?{startLineNumber:b.location.start.line,startColumn:b.location.start.character,endLineNumber:b.location.end.line,endColumn:b.location.end.character}:void 0,uri:b.uri}:void 0;D.n.$completeExecution(D.b,new f.$Xw({runEndTime:A,lastRunSuccess:k,error:v}))},clearOutput(k){return D.t(),D.z([],k,!1)},appendOutput(k,A){return D.t(),D.z(k,A,!0)},replaceOutput(k,A){return D.t(),D.z(k,A,!1)},appendOutputItems(k,A){return D.t(),D.C(k,A,!0)},replaceOutputItems(k,A){return D.t(),D.C(k,A,!1)}})}}var n;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(n||(n={}));class d extends O.$Uc{static{this.a=0}get state(){return this.f}constructor(D,y,k){super(),this.h=y,this.j=k,this.b=d.a++,this.c=new R.$le,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new C.$we),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(D,y){this.f=D,this.g=y,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new h.$3h,this.b=Date.now(),(0,h.$Gh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>D.complete())}}function g(E,D){return`${E.value}/${D}`}}),define(ke[48],Ie([1,0,4,6,5,2,19,3,9,8,13,241,20,32,242,243,51,7,15,34,40]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gqc=e.$fqc=e.$eqc=e.$dqc=void 0,e.$dqc=(0,C.$Fi)("IExtHostTerminalService");class t extends T.$Uc{constructor(b,v,F,N){super(),this.u=b,this._id=v,this.w=F,this.y=N,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new r.$le),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(M=>this.g=M);const L=this;this.value={get name(){return L.y||""},get processId(){return L.b},get creationOptions(){return L.w},get exitStatus(){return L.j},get state(){return L.m},get selection(){return L.n},get shellIntegration(){return L.shellIntegration},sendText(M,z=!0){L.C(),L.u.$sendText(L._id,M,z)},show(M){L.C(),L.u.$show(L._id,M)},hide(){L.C(),L.u.$hide(L._id)},dispose(){L.a||(L.a=!0,L.u.$dispose(L._id))},get dimensions(){if(!(L.f===void 0||L.h===void 0))return{columns:L.f,rows:L.h}}}}dispose(){this.s.fire(),super.dispose()}async create(b,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:b.name,shellPath:b.shellPath??void 0,shellArgs:b.shellArgs??void 0,cwd:b.cwd??v?.cwd??void 0,env:b.env??void 0,icon:D(b.iconPath)??void 0,color:m.ThemeColor.isThemeColor(b.color)?b.color.id:void 0,initialText:b.message??void 0,strictEnv:b.strictEnv??void 0,hideFromUser:b.hideFromUser??void 0,forceShellIntegration:v?.forceShellIntegration??void 0,isFeatureTerminal:v?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:v?.useShellEnvironment??void 0,location:v?.location||this.z(b.location,v?.resolvedExtHostIdentifier),isTransient:b.isTransient??void 0})}async createExtensionTerminal(b,v,F,N,L){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:N,color:m.ThemeColor.isThemeColor(L)?L.id:void 0,location:v?.location||this.z(b,F),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(b,v){return typeof b=="object"?"parentTerminal"in b&&b.parentTerminal&&v?{parentTerminal:v}:"viewColumn"in b?{viewColumn:f.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus}:void 0:b}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(b){this.y=b}setExitStatus(b,v){this.j=Object.freeze({code:b,reason:v})}setDimensions(b,v){return b===this.f&&v===this.h||b===0||v===0?!1:(this.f=b,this.h=v,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(b){this.n=b}_setProcessId(b){this.g?(this.g(b),this.g=void 0):this.b.then(v=>{v!==b&&(this.b=Promise.resolve(b))})}}e.$eqc=t;class o{get onProcessReady(){return this.b.event}constructor(b){this.g=b,this.id=0,this.shouldPersist=!1,this.a=new r.$le,this.onProcessData=this.a.event,this.b=new r.$le,this.d=new r.$le,this.onDidChangeProperty=this.d.event,this.f=new r.$le,this.onProcessExit=this.f.event}refreshProperty(b){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${b}`)}updateProperty(b,v){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${b}, value: ${v}`)}async start(){}shutdown(){this.g.close()}input(b){this.g.handleInput?.(b)}resize(b,v){this.g.setDimensions?.({columns:b,rows:v})}clearBuffer(){}async processBinary(b){}acknowledgeDataEvent(b){}async setUnicodeVersion(b){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(b){this.g.onDidWrite(v=>this.a.fire(v)),this.g.onDidClose?.((v=void 0)=>{this.f.fire(v===void 0?void 0:v)}),this.g.onDidOverrideDimensions?.(v=>{v&&this.d.fire({type:w.ProcessPropertyType.OverrideDimensions,value:{cols:v.columns,rows:v.rows}})}),this.g.onDidChangeName?.(v=>{this.d.fire({type:w.ProcessPropertyType.Title,value:v})}),this.g.open(b||void 0),b&&this.g.setDimensions?.(b),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let n=1,d=class extends T.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(b=>b.value)}constructor(b,v,F){super(),this.Q=v,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new T.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new r.$le,this.onDidCloseTerminal=this.H.event,this.I=new r.$le,this.onDidOpenTerminal=this.I.event,this.J=new r.$le,this.onDidChangeActiveTerminal=this.J.event,this.L=new r.$le,this.onDidChangeTerminalDimensions=this.L.event,this.M=new r.$le,this.onDidChangeTerminalState=this.M.event,this.N=new r.$le,this.onDidChangeShell=this.N.event,this.O=new r.$le({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new r.$le({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=F.getProxy(h.$KN.MainThreadTerminalService),this.y=new a.$Xxb(this.a.$sendProcessData),this.a.$registerProcessSupport(b),this.Q.registerArgumentProcessor({processArgument:N=>{const L=M=>{const z=M;return this.getTerminalById(z.instanceId)?.value};switch(N?.$mid){case s.MarshalledId.TerminalContext:return L(N);default:{if(Array.isArray(N))for(let M=0;M<N.length&&N[M].$mid===s.MarshalledId.TerminalContext;M++)N[M]=L(N[M]);return N}}}}),this.B({dispose:()=>{for(const[N,L]of this.g)L.shutdown(!0)}})}getDefaultShell(b){return(b?this.u:this.s)?.path||""}getDefaultShellArgs(b){return(b?this.u:this.s)?.args||[]}createExtensionTerminal(b,v){const F=new t(this.a,(0,P.$2g)(),b,b.name),N=new o(b.pty);return F.createExtensionTerminal(b.location,v,this.R(b,v).resolvedExtHostIdentifier,D(b.iconPath),y(b.color)).then(L=>{const M=this.S(L,N);this.h[L]=M}),this.f.push(F),F.value}R(b,v){if(v=v||{},b.location&&typeof b.location=="object"&&"parentTerminal"in b.location){const F=b.location.parentTerminal;if(F){const N=this.f.find(L=>L.value===F);N&&(v.resolvedExtHostIdentifier=N._id)}}else b.location&&typeof b.location!="object"?v.location=b.location:v.location&&typeof v.location=="object"&&"splitActiveTerminal"in v.location&&(v.location={splitActiveTerminal:!0});return v}attachPtyToTerminal(b,v){if(!this.getTerminalById(b))throw new Error(`Cannot resolve terminal with id ${b} for virtual process`);const N=new o(v),L=this.S(b,N);this.h[b]=L}async $acceptActiveTerminalChanged(b){const v=this.b;if(b===null){this.b=void 0,v!==this.b&&this.J.fire(this.b);return}const F=this.getTerminalById(b);F&&(this.b=F,v!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(b,v){const F=this.getTerminalById(b);F&&this.O.fire({terminal:F.value,data:v})}async $acceptTerminalDimensions(b,v,F){const N=this.getTerminalById(b);N&&N.setDimensions(v,F)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(b,v){const F=this.getTerminalById(b);F&&this.P.fire({terminal:F.value,...v})}async $acceptTerminalMaximumDimensions(b,v,F){this.g.get(b)?.resize(v,F)}async $acceptTerminalTitleChange(b,v){const F=this.getTerminalById(b);F&&(F.name=v)}async $acceptTerminalClosed(b,v,F){const N=this.X(this.f,b);if(N!==null){const L=this.f.splice(N,1)[0];L.setExitStatus(v,F),this.H.fire(L.value)}}$acceptTerminalOpened(b,v,F,N){if(v){const z=this.X(this.f,v);if(z!==null){this.f[z]._id=b,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const L={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:R.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},M=new t(this.a,b,L,F);this.f.push(M),this.I.fire(M.value),M.isOpen=!0}async $acceptTerminalProcessId(b,v){this.getTerminalById(b)?._setProcessId(v)}async $startExtensionTerminal(b,v){const F=this.getTerminalById(b);if(!F)return{message:(0,c.localize)(10824,null,b)};F.isOpen||await new Promise(L=>{const M=this.onDidOpenTerminal(async z=>{z===F.value&&(M.dispose(),L())})});const N=this.g.get(b);N?N.startSendingEvents(v):this.j[b]={initialDimensions:v}}S(b,v){const F=new T.$Tc;F.add(v.onProcessReady(L=>this.a.$sendProcessReady(b,L.pid,L.cwd,L.windowsPty))),F.add(v.onDidChangeProperty(L=>this.a.$sendProcessProperty(b,L))),this.y.startBuffering(b,v.onProcessData),F.add(v.onProcessExit(L=>this.U(b,L))),this.g.set(b,v);const N=this.j[b];return N&&v instanceof o&&(v.startSendingEvents(N.initialDimensions),delete this.j[b]),F}$acceptProcessAckDataEvent(b,v){this.g.get(b)?.acknowledgeDataEvent(v)}$acceptProcessInput(b,v){this.g.get(b)?.input(v)}$acceptTerminalInteraction(b){const v=this.getTerminalById(b);v?.setInteractedWith()&&this.M.fire(v.value)}$acceptTerminalSelection(b,v){this.getTerminalById(b)?.setSelection(v)}$acceptProcessResize(b,v,F){try{this.g.get(b)?.resize(v,F)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(b,v){this.g.get(b)?.shutdown(v)}$acceptProcessRequestInitialCwd(b){this.g.get(b)?.getInitialCwd().then(v=>this.a.$sendProcessProperty(b,{type:w.ProcessPropertyType.InitialCwd,value:v}))}$acceptProcessRequestCwd(b){this.g.get(b)?.getCwd().then(v=>this.a.$sendProcessProperty(b,{type:w.ProcessPropertyType.Cwd,value:v}))}$acceptProcessRequestLatency(b){return Promise.resolve(b)}registerLinkProvider(b){return this.z.add(b),this.z.size===1&&this.a.$startLinkProvider(),new p.$MN(()=>{this.z.delete(b),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(b,v,F){if(this.C.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this.C.set(v,F),this.a.$registerProfileProvider(v,b.identifier.value),new p.$MN(()=>{this.C.delete(v),this.a.$unregisterProfileProvider(v)})}registerTerminalQuickFixProvider(b,v,F){if(this.D.has(b))throw new Error(`Terminal quick fix provider "${b}" is already registered`);return this.D.set(b,F),this.a.$registerQuickFixProvider(b,v),new p.$MN(()=>{this.D.delete(b),this.a.$unregisterQuickFixProvider(b)})}async $provideTerminalQuickFixes(b,v){const F=new u.$we().token;if(F.isCancellationRequested)return;const N=this.D.get(b);if(!N)return;const L=await N.provideTerminalQuickFixes(v,F);if(L===null||Array.isArray(L)&&L.length===0)return;const M=new T.$Tc;if(this.w.value=M,!Array.isArray(L))return L?f.TerminalQuickFix.from(L,this.Q.converter,M):void 0;const z=[];for(const j of L){const W=f.TerminalQuickFix.from(j,this.Q.converter,M);W&&z.push(W)}return z}async $createContributedProfileTerminal(b,v){const F=new u.$we().token;let N=await this.C.get(b)?.provideTerminalProfile(F);if(!F.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${b}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,v);return}this.createTerminalFromOptions(N.options,v)}}async $provideLinks(b,v){const F=this.getTerminalById(b);if(!F)return[];this.F.delete(b),this.G.get(b)?.dispose(!0);const L=new u.$we;this.G.set(b,L);const M=[],z={terminal:F.value,line:v},j=[];for(const ee of this.z)j.push($.Promises.withAsyncBody(async H=>{L.token.onCancellationRequested(()=>H({provider:ee,links:[]}));const q=await ee.provideTerminalLinks(z,L.token)||[];L.token.isCancellationRequested||H({provider:ee,links:q})}));const W=await Promise.all(j);if(L.token.isCancellationRequested)return[];const B=new Map;for(const ee of W)ee&&ee.links.length>0&&M.push(...ee.links.map(H=>{const q={id:n++,startIndex:H.startIndex,length:H.length,label:H.tooltip};return B.set(q.id,{provider:ee.provider,link:H}),q}));return this.F.set(b,B),M}$activateLink(b,v){const F=this.F.get(b)?.get(v);F&&F.provider.handleTerminalLink(F.link)}U(b,v){this.y.stopBuffering(b),this.g.delete(b),delete this.j[b];const F=this.h[b];F&&(F.dispose(),delete this.h[b]),this.a.$sendProcessExit(b,v)}getTerminalById(b){return this.W(this.f,b)}getTerminalIdByApiObject(b){const v=this.f.findIndex(F=>F.value===b);return v>=0?v:null}W(b,v){const F=this.X(b,v);return F!==null?b[F]:null}X(b,v){const F=b.findIndex(N=>N._id===v);return F>=0?F:null}getEnvironmentVariableCollection(b){let v=this.n.get(b.identifier.value);return v||(v=this.B(new l),this.Z(b.identifier.value,v)),v.getScopedEnvironmentVariableCollection(void 0)}Y(b,v){const F=(0,S.$Fs)(v.map),N=(0,S.$Gs)(v.descriptionMap);this.a.$setEnvironmentVariableCollection(b,v.persistent,F.length===0?void 0:F,N)}$initEnvironmentVariableCollections(b){b.forEach(v=>{const F=v[0],N=this.B(new l(v[1]));this.Z(F,N)})}$acceptDefaultProfile(b,v){const F=this.s;this.s=b,this.u=v,F?.path!==b.path&&this.N.fire(b.path)}Z(b,v){this.n.set(b,v),this.B(v.onDidChangeCollection(()=>{this.Y(b,v)}))}};e.$fqc=d,e.$fqc=d=Je([Ve(1,i.$GQ),Ve(2,O.$kQ)],d);class l extends T.$Uc{get persistent(){return this.b}set persistent(b){this.b=b,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(b){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new r.$le,this.map=new Map(b)}getScopedEnvironmentVariableCollection(b){const v=this.j(b);let F=this.a.get(v);return F||(F=new g(this,b),this.a.set(v,F),this.B(F.onDidChangeCollection(()=>this.f.fire()))),F}replace(b,v,F,N){this.g(b,{value:v,type:p.EnvironmentVariableMutatorType.Replace,options:F??{applyAtProcessCreation:!0},scope:N})}append(b,v,F,N){this.g(b,{value:v,type:p.EnvironmentVariableMutatorType.Append,options:F??{applyAtProcessCreation:!0},scope:N})}prepend(b,v,F,N){this.g(b,{value:v,type:p.EnvironmentVariableMutatorType.Prepend,options:F??{applyAtProcessCreation:!0},scope:N})}g(b,v){if(v.options&&v.options.applyAtProcessCreation===!1&&!v.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const F=this.h(b,v.scope),N=this.map.get(F),L=v.options?{applyAtProcessCreation:v.options.applyAtProcessCreation??!1,applyAtShellIntegration:v.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==v.value||N.type!==v.type||N.options?.applyAtProcessCreation!==L.applyAtProcessCreation||N.options?.applyAtShellIntegration!==L.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index){const M=this.h(b,v.scope),z={variable:b,...v,options:L};this.map.set(M,z),this.f.fire()}}get(b,v){const F=this.h(b,v),N=this.map.get(F);return N?k(N):void 0}h(b,v){const F=this.j(v);return F.length?`${b}:::${F}`:b}j(b){return this.m(b?.workspaceFolder)??""}m(b){return b?b.uri.toString():void 0}getVariableMap(b){const v=new Map;for(const[F,N]of this.map)this.j(N.scope)===this.j(b)&&v.set(N.variable,k(N));return v}delete(b,v){const F=this.h(b,v);this.map.delete(F),this.f.fire()}clear(b){if(b?.workspaceFolder){for(const[v,F]of this.map)F.scope?.workspaceFolder?.index===b.workspaceFolder.index&&this.map.delete(v);this.n(b)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(b,v){const F=this.j(v),N=this.descriptionMap.get(F);if(!N||N.description!==b){let L;typeof b=="string"?L=b:L=b?.value.split(`

`)[0];const M={description:L,scope:v};this.descriptionMap.set(F,M),this.f.fire()}}getDescription(b){const v=this.j(b);return this.descriptionMap.get(v)?.description}n(b){const v=this.j(b);this.descriptionMap.delete(v)}}class g{get persistent(){return this.b.persistent}set persistent(b){this.b.persistent=b}get onDidChangeCollection(){return this.a&&this.a.event}constructor(b,v){this.b=b,this.d=v,this.a=new r.$le}getScoped(b){return this.b.getScopedEnvironmentVariableCollection(b)}replace(b,v,F){this.b.replace(b,v,F,this.d)}append(b,v,F){this.b.append(b,v,F,this.d)}prepend(b,v,F){this.b.prepend(b,v,F,this.d)}get(b){return this.b.get(b,this.d)}forEach(b,v){this.b.getVariableMap(this.d).forEach((F,N)=>b.call(v,N,F,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(b){this.b.delete(b,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(b){this.b.setDescription(b,this.d)}get description(){return this.b.getDescription(this.d)}}let E=class extends d{constructor(b,v){super(!1,b,v)}createTerminal(b,v,F){throw new I.$$}createTerminalFromOptions(b,v){throw new I.$$}};e.$gqc=E,e.$gqc=E=Je([Ve(0,i.$GQ),Ve(1,O.$kQ)],E);function D(A){if(!(!A||typeof A=="string"))return"id"in A?{id:A.id,color:A.color}:A}function y(A){return m.ThemeColor.isThemeColor(A)?A:void 0}function k(A){const b={...A};return delete b.scope,b.options=b.options??void 0,delete b.variable,b}}),define(ke[167],Ie([1,0,9,3,5,6,19,48,4,2,7]),function($e,e,r,h,C,R,O,T,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rrc=e.$qrc=void 0,e.$qrc=(0,C.$Fi)("IExtHostTerminalShellIntegration");let S=class extends h.$Uc{constructor(m,$){super(),this.h=$,this.b=new Map,this.c=new p.$le,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$le,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$le,this.onDidEndTerminalShellExecution=this.g.event,this.a=m.getProxy(R.$KN.MainThreadTerminalShellIntegration),this.B((0,h.$Sc)(()=>{for(const[f,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(m){const $=this.h.getTerminalById(m);if(!$)return;const f=$.value;let i=this.b.get(m);i||(i=new u($.value,this.f),this.b.set(m,i),i.store.add($.onWillDispose(()=>this.b.get(m)?.dispose())),i.store.add(i.onDidRequestShellExecution(s=>this.a.$executeCommand(m,s))),i.store.add(i.onDidRequestEndExecution(s=>this.g.fire(s))),i.store.add(i.onDidRequestChangeShellIntegration(s=>this.c.fire(s))),$.shellIntegration=i.value),this.c.fire({terminal:f,shellIntegration:i.value})}$shellExecutionStart(m,$,f,i,s){this.b.has(m)||this.$shellIntegrationChange(m);const t={value:$,confidence:f,isTrusted:i};this.b.get(m)?.startShellExecution(t,c.URI.revive(s))}$shellExecutionEnd(m,$,f,i,s){const t={value:$,confidence:f,isTrusted:i};this.b.get(m)?.endShellExecution(t,s)}$shellExecutionData(m,$){this.b.get(m)?.emitData($)}$cwdChange(m,$){this.b.get(m)?.setCwd(c.URI.revive($))}$closeTerminal(m){this.b.get(m)?.dispose(),this.b.delete(m)}};e.$rrc=S,e.$rrc=S=Je([Ve(0,O.$kQ),Ve(1,T.$dqc)],S);class u extends h.$Uc{get currentExecution(){return this.a}constructor(m,$){super(),this.j=m,this.m=$,this.b=!1,this.store=this.B(new h.$Tc),this.f=this.B(new p.$le),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$le),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$le),this.onDidRequestEndExecution=this.h.event;const f=this;this.value={get cwd(){return f.c},executeCommand(i,s){let t=i;s&&(t+=` "${s.map(d=>`${d.replaceAll('"','\\"')}`).join('" "')}"`),f.g.fire(t);const o={value:t,confidence:r.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},n=f.startShellExecution(o,f.c,!0).value;return f.b=!0,n}}}startShellExecution(m,$,f){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new P(m,$??this.c);f?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(m){this.currentExecution?.emitData(m)}endShellExecution(m,$){this.a&&(this.a.endExecution(m),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:$}),this.a=void 0)}setCwd(m){let $=!1;c.URI.isUri(this.c)?$=!c.URI.isUri(m)||this.c.toString()!==m.toString():this.c!==m&&($=!0),$&&(this.c=m,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class P{constructor(m,$){this.c=m,this.cwd=$,this.b=!1;const f=this;this.value={get commandLine(){return f.c},get cwd(){return f.cwd},read(){return f.d()}}}d(){if(!this.a){if(this.b)return I.$6h.EMPTY;this.a=new w}return this.a.createIterable()}emitData(m){this.a?.emitData(m)}endExecution(m){m&&(this.c=m),this.a?.endExecution(),this.a=void 0,this.b=!0}}class w extends h.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Eh);const m=this.a;return new I.$6h(async f=>{this.b.push(f),await m.wait()})}emitData(m){for(const $ of this.b)$.emitOne(m)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[168],Ie([1,0,65,13,132,15,9]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tQ=e.$sQ=e.$rQ=void 0,R=qe(R);class T{static{this.c=new C.$pQ("TextEditorDecorationType")}constructor(u,P,w){const a=T.c.nextId();u.$registerTextEditorDecorationType(P.identifier,a,R.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:a,dispose(){u.$removeTextEditorDecorationType(a)}})}}e.$rQ=T;class p{constructor(u,P){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=P.undoStopBefore,this.f=P.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,P){this.k();let w=null;if(u instanceof O.$NN)w=new O.$ON(u,u);else if(u instanceof O.$ON)w=u;else throw new Error("Unrecognized location");this.l(w,P,!1)}insert(u,P){this.k(),this.l(new O.$ON(u,u),P,!0)}delete(u){this.k();let P=null;if(u instanceof O.$ON)P=u;else throw new Error("Unrecognized location");this.l(P,null,!0)}l(u,P,w){const a=this.c.validateRange(u);this.g.push({range:a,text:P,forceMoveMarkers:w})}setEndOfLine(u){if(this.k(),u!==O.EndOfLine.LF&&u!==O.EndOfLine.CRLF)throw(0,h.$6)("endOfLine");this.h=u}}class c{constructor(u,P,w,a){this.c=u,this.d=P,this._accept(w),this.e=a;const m=this;this.value={get tabSize(){return m.f},set tabSize($){m.n($)},get indentSize(){return m.g},set indentSize($){m.p($)},get insertSpaces(){return m.j},set insertSpaces($){m.s($)},get cursorStyle(){return m.k},set cursorStyle($){m.t($)},get lineNumbers(){return m.l},set lineNumbers($){m.u($)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const P=Math.floor(u);return P>0?P:null}if(typeof u=="string"){const P=parseInt(u,10);return isNaN(P)?null:P>0?P:null}return null}n(u){const P=this.m(u);if(P!==null){if(typeof P=="number"){if(this.f===P)return;this.f=P}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:P}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const P=Math.floor(u);return P>0?P:null}if(typeof u=="string"){const P=parseInt(u,10);return isNaN(P)?null:P>0?P:null}return null}p(u){const P=this.o(u);if(P!==null){if(typeof P=="number"){if(this.h===P)return;this.g=P,this.h=P}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:P}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const P=this.q(u);if(typeof P=="boolean"){if(this.j===P)return;this.j=P}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:P}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(u)})))}assign(u){const P={};let w=!1;if(typeof u.tabSize<"u"){const a=this.m(u.tabSize);a==="auto"?(w=!0,P.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,w=!0,P.tabSize=a)}if(typeof u.indentSize<"u"){const a=this.o(u.indentSize);a==="tabSize"?(w=!0,P.indentSize=a):typeof a=="number"&&this.h!==a&&(this.g=a,this.h=a,w=!0,P.indentSize=a)}if(typeof u.insertSpaces<"u"){const a=this.q(u.insertSpaces);a==="auto"?(w=!0,P.insertSpaces=a):this.j!==a&&(this.j=a,w=!0,P.insertSpaces=a)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,w=!0,P.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,w=!0,P.lineNumbers=R.TextEditorLineNumbersStyle.from(u.lineNumbers)),w&&this.v("setOptions",this.c.$trySetOptions(this.d,P))}v(u,P){P.catch(w=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(w)})}}e.$sQ=c;class I{constructor(u,P,w,a,m,$,f,i){this.id=u,this.j=P,this.k=w,this.g=!1,this.h=new Set,this.c=m,this.d=new c(this.j,this.id,$,w),this.e=f,this.f=i;const s=this;this.value=Object.freeze({get document(){return a.value},set document(t){throw new h.$8("document")},get selection(){return s.c&&s.c[0]},set selection(t){if(!(t instanceof O.$PN))throw(0,h.$6)("selection");s.c=[t],s.l()},get selections(){return s.c},set selections(t){if(!Array.isArray(t)||t.some(o=>!(o instanceof O.$PN)))throw(0,h.$6)("selections");s.c=t,s.l()},get visibleRanges(){return s.e},set visibleRanges(t){throw new h.$8("visibleRanges")},get options(){return s.d.value},set options(t){s.g||s.d.assign(t)},get viewColumn(){return s.f},set viewColumn(t){throw new h.$8("viewColumn")},edit(t,o={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new p(a.value,o);return t(n),s.m(n)},insertSnippet(t,o,n={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!o||Array.isArray(o)&&o.length===0)d=s.c.map(l=>R.Range.from(l));else if(o instanceof O.$NN){const{lineNumber:l,column:g}=R.Position.from(o);d=[{startLineNumber:l,startColumn:g,endLineNumber:l,endColumn:g}]}else if(o instanceof O.$ON)d=[R.Range.from(o)];else{d=[];for(const l of o)if(l instanceof O.$ON)d.push(R.Range.from(l));else{const{lineNumber:g,column:E}=R.Position.from(l);d.push({startLineNumber:g,startColumn:E,endLineNumber:g,endColumn:E})}}return P.$tryInsertSnippet(u,a.value.version,t.value,d,n)},setDecorations(t,o){const n=o.length===0;n&&!s.h.has(t.key)||(n?s.h.delete(t.key):s.h.add(t.key),s.n(()=>{if(R.$hQ(o))return P.$trySetDecorations(u,t.key,R.$iQ(o));{const d=new Array(4*o.length);for(let l=0,g=o.length;l<g;l++){const E=o[l];d[4*l]=E.start.line+1,d[4*l+1]=E.start.character+1,d[4*l+2]=E.end.line+1,d[4*l+3]=E.end.character+1}return P.$trySetDecorationsFast(u,t.key,d)}}))},revealRange(t,o){s.n(()=>P.$tryRevealRange(u,R.Range.from(t),o||O.TextEditorRevealType.Default))},show(t){P.$tryShowEditor(u,R.ViewColumn.from(t))},hide(){P.$tryHideEditor(u)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,r.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,r.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,r.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,r.ok)(!this.g),this.f=u}_acceptSelections(u){(0,r.ok)(!this.g),this.c=u}async l(){const u=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const P=u.finalize();if(P.edits.length===0&&!P.setEndOfLine)return Promise.resolve(!0);const w=P.edits.map(m=>m.range);w.sort((m,$)=>m.end.line===$.end.line?m.end.character===$.end.character?m.start.line===$.start.line?m.start.character-$.start.character:m.start.line-$.start.line:m.end.character-$.end.character:m.end.line-$.end.line);for(let m=0,$=w.length-1;m<$;m++){const f=w[m].end;if(w[m+1].start.isBefore(f))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=P.edits.map(m=>({range:R.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,P.documentVersionId,a,{setEndOfLine:typeof P.setEndOfLine=="number"?R.EndOfLine.from(P.setEndOfLine):void 0,undoStopBefore:P.undoStopBefore,undoStopAfter:P.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,P=>(P instanceof Error&&P.name==="DISPOSED"||this.k.warn(P),null))}}e.$tQ=I}),define(ke[63],Ie([1,0,65,4,3,2,5,6,164,19,168,15,11,28,14,39,50]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vQ=e.$uQ=void 0,r=qe(r),S=qe(S);class ${constructor(s){this.value=s,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let f=class{constructor(s,t){this.h=s,this.i=t,this.a=null,this.b=new Map,this.c=new P.$Ac,this.d=new h.$le,this.e=new h.$le,this.f=new h.$le,this.g=new h.$le,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const t=[],o=[],n=[];if(s.removedDocuments)for(const d of s.removedDocuments){const l=R.URI.revive(d),g=this.c.get(l);g?.unref()&&(this.c.delete(l),t.push(g.value))}if(s.addedDocuments)for(const d of s.addedDocuments){const l=R.URI.revive(d.uri);let g=this.c.get(l);if(g&&l.scheme!==w.Schemas.vscodeNotebookCell&&l.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);g||(g=new $(new p.$nQ(this.h.getProxy(T.$KN.MainThreadDocuments),l,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this.c.set(l,g),o.push(g.value)),g.ref()}if(s.removedEditors)for(const d of s.removedEditors){const l=this.b.get(d);this.b.delete(d),l&&n.push(l)}if(s.addedEditors)for(const d of s.addedEditors){const l=R.URI.revive(d.documentUri);r.ok(this.c.has(l),`document '${l}' does not exist`),r.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const g=this.c.get(l).value,E=new I.$tQ(d.id,this.h.getProxy(T.$KN.MainThreadTextEditors),this.i,new m.$T(()=>g.document),d.selections.map(S.Selection.to),d.options,d.visibleRanges.map(D=>S.Range.to(D)),typeof d.editorPosition=="number"?S.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,E)}s.newActiveEditor!==void 0&&(r.ok(s.newActiveEditor===null||this.b.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this.a=s.newActiveEditor),(0,C.$Pc)(t),(0,C.$Pc)(n),s.removedDocuments&&this.e.fire(t),s.addedDocuments&&this.d.fire(o),(s.removedEditors||s.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),s.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(s){return this.c.get(s)?.value}allDocuments(){return a.Iterable.map(this.c.values(),s=>s.value)}getEditor(s){return this.b.get(s)}activeEditor(s){if(!this.a)return;const t=this.b.get(this.a);return s?t:t?.value}allEditors(){return[...this.b.values()]}};e.$uQ=f,e.$uQ=f=Je([Ve(0,c.$kQ),Ve(1,u.$ak)],f),e.$vQ=(0,O.$Fi)("IExtHostDocumentsAndEditors")}),define(ke[98],Ie([1,0,7,21,20,4,79,60,3,40,17,2,32,5,11,6,34,63,19,166,15,9,264,73,120,74,25]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bqc=e.$Aqc=e.$zqc=e.$yqc=e.$xqc=void 0,s=qe(s);let E=0;const D=new WeakMap;e.$xqc=(0,P.$Fi)("IExtHostTesting");let y=class extends p.$Uc{constructor(q,Q,_,ce){super(),this.C=Q,this.D=_,this.F=ce,this.f=this.B(new R.$le),this.g=new Map,this.w=this.B(new R.$le),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=q.getProxy(a.$KN.MainThreadTesting),this.m=new z(this.h),this.j=new v(this.h,Q),_.registerArgumentProcessor({processArgument:ne=>{switch(ne?.$mid){case c.MarshalledId.TestItemContext:{const ye=ne,ge=ye.tests[ye.tests.length-1].item.extId;return this.g.get(n.$7I.root(ge))?.collection.tree.get(ge)?.actual??(0,i.$wQ)(ne)}case c.MarshalledId.TestMessageMenuArgs:{const{test:ye,message:ge}=ne,Y=ye.item.extId;return{test:this.g.get(n.$7I.root(Y))?.collection.tree.get(Y)?.actual??(0,i.$wQ)({$mid:c.MarshalledId.TestItemContext,tests:[ye]}),message:s.TestMessage.to(ge)}}default:return ne}}}),_.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ne=await _.executeCommand(o.TestCommandId.GetExplorerSelection),ye=ge=>{const Y=this.g.get(n.$7I.root(ge));if(Y)return n.$7I.isRoot(ge)?Y.controller:Y.collection.tree.get(ge)?.actual};return{include:ne?.include.map(ye).filter(I.$mg)||[],exclude:ne?.exclude.map(ye).filter(I.$mg)||[]}})}createTestController(q,Q,_,ce){if(this.g.has(Q))throw new Error(`Attempt to insert a duplicate controller with ID "${Q}"`);const ne=new p.$Tc,ye=ne.add(new i.$zQ(Q,_,this.F));ye.root.label=_;const ge=new Map,Y=new Set,U=this.h,oe=()=>{let ae=0;ce&&(ae|=l.TestControllerCapability.Refresh);const se=te.relatedCodeProvider;return se&&(se?.provideRelatedTests&&(ae|=l.TestControllerCapability.TestRelatedToCode),se?.provideRelatedCode&&(ae|=l.TestControllerCapability.CodeRelatedToTest)),ae},ve={items:ye.root.children,get label(){return _},set label(ae){_=ae,ye.root.label=ae,U.$updateController(Q,{label:_})},get refreshHandler(){return ce},set refreshHandler(ae){ce=ae,U.$updateController(Q,{capabilities:oe()})},get id(){return Q},get relatedCodeProvider(){return te.relatedCodeProvider},set relatedCodeProvider(ae){(0,g.$gH)(q,"testRelatedCode"),te.relatedCodeProvider=ae,U.$updateController(Q,{capabilities:oe()})},createRunProfile:(ae,se,X,re,pe,we)=>{let Fe=(0,T.$tj)(ae);for(;ge.has(Fe);)Fe++;return new W(this.h,ge,Y,this.w.event,Q,Fe,ae,se,X,re,pe,we)},createTestItem(ae,se,X){return new i.$xQ(Q,ae,se,X)},createTestRun:(ae,se,X=!0)=>this.j.createTestRun(q,Q,ye,ae,se,X),invalidateTestResults:ae=>{if(ae===void 0)this.h.$markTestRetired(void 0);else{const se=ae instanceof Array?ae:[ae];this.h.$markTestRetired(se.map(X=>n.$7I.fromExtHostTestItem(X,Q).toString()))}},set resolveHandler(ae){ye.resolveHandler=ae},get resolveHandler(){return ye.resolveHandler},dispose:()=>{ne.dispose()}},te={controller:ve,collection:ye,profiles:ge,extension:q,activeProfiles:Y};return U.$registerTestController(Q,_,oe()),ne.add((0,p.$Sc)(()=>U.$unregisterTestController(Q))),this.g.set(Q,te),ne.add((0,p.$Sc)(()=>this.g.delete(Q))),ne.add(ye.onDidGenerateDiff(ae=>U.$publishDiff(Q,ae.map(l.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(q,Q=C.CancellationToken.None){const _=F(q);if(!_)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ce=this.g.get(_.controllerId);if(!ce)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:q.preserveFocus??!0,group:B[_.kind],targets:[{testIds:q.include?.map(ne=>n.$7I.fromExtHostTestItem(ne,ce.collection.root.id).toString())??[ce.collection.root.id],profileId:_.profileId,controllerId:_.controllerId}],exclude:q.exclude?.map(ne=>ne.id)},Q)}registerTestFollowupProvider(q){return this.y.add(q),{dispose:()=>{this.y.delete(q)}}}async $getTestsRelatedToCode(q,Q,_){const ce=this.F.getDocument(S.URI.revive(q));if(!ce)return[];const ne=s.Position.to(Q),ye=[];return await Promise.all([...this.g.values()].map(async ge=>{let Y;try{Y=await ge.relatedCodeProvider?.provideRelatedTests?.(ce.document,ne,_)}catch(U){_.isCancellationRequested||this.C.warn(`Error thrown while providing related tests for ${ge.controller.label}`,U)}if(Y){for(const U of Y)ye.push(n.$7I.fromExtHostTestItem(U,ge.controller.id).toString());ge.collection.flushDiff()}})),ye}async $getCodeRelatedToTest(q,Q){const _=this.g.get(n.$7I.root(q));if(!_)return[];const ce=_.collection.tree.get(q);return ce?(await _.relatedCodeProvider?.provideRelatedCode?.(ce.actual,Q))?.map(s.location.from)??[]:[]}$syncTests(){for(const{collection:q}of this.g.values())q.flushDiff();return Promise.resolve()}async $getCoverageDetails(q,Q,_){return(await this.j.getCoverageDetails(q,Q,_))?.map(s.TestCoverage.fromDetails)}async $disposeRun(q){this.j.disposeTestRun(q)}$configureRunProfile(q,Q){this.g.get(q)?.profiles.get(Q)?.configureHandler?.()}$setDefaultRunProfiles(q){const Q=new Map;for(const[_,ce]of Object.entries(q)){const ne=this.g.get(_);if(!ne)continue;const ye=new Map,ge=ce.filter(U=>!ne.activeProfiles.has(U)),Y=[...ne.activeProfiles].filter(U=>!ce.includes(U));for(const U of ge)ye.set(U,!0),ne.activeProfiles.add(U);for(const U of Y)ye.set(U,!1),ne.activeProfiles.delete(U);ye.size&&Q.set(_,ye)}this.w.fire(Q)}async $refreshTests(q,Q){await this.g.get(q)?.controller.refreshHandler?.(Q)}$publishTestResults(q){this.results=Object.freeze(q.map(Q=>{const _=s.TestResults.to(Q);return D.set(_,Q.id),_}).concat(this.results).sort((Q,_)=>_.completedAt-Q.completedAt).slice(0,32)),this.f.fire()}async $expandTest(q,Q){const _=this.g.get(n.$7I.fromString(q).controllerId)?.collection;_&&(await _.expand(q,Q<0?1/0:Q),_.flushDiff())}$acceptDiff(q){this.m.applyDiff(q.map(Q=>l.TestsDiffOp.deserialize({asCanonicalUri:_=>_},Q)))}async $runControllerTests(q,Q){return Promise.all(q.map(_=>this.G(_,!1,Q)))}async $startContinuousRun(q,Q){const _=new C.$we(Q),ce=await Promise.all(q.map(ne=>this.G(ne,!0,_.token)));return!Q.isCancellationRequested&&!ce.some(ne=>ne.error)&&await new Promise(ne=>Q.onCancellationRequested(ne)),_.dispose(!0),ce}async $provideTestFollowups(q,Q){const _=this.results.find(ye=>D.get(ye)===q.resultId),ce=_&&ee(n.$7I.fromString(q.extId),_?.results);if(!ce)return[];let ne=[];return await Promise.all([...this.y].map(async ye=>{try{const ge=await ye.provideFollowup(_,ce,q.taskIndex,q.messageIndex,Q);ge&&(ne=ne.concat(ge))}catch(ge){this.C.error("Error thrown while providing followup for test message",ge)}})),Q.isCancellationRequested?[]:ne.map(ye=>{const ge=E++;return this.z.set(ge,ye),{title:ye.title,id:ge}})}$disposeTestFollowups(q){for(const Q of q)this.z.delete(Q)}$executeTestFollowup(q){const Q=this.z.get(q);return Q?this.D.executeCommand(Q.command,...Q.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(q){q===void 0?this.j.cancelAllRuns():this.j.cancelRunById(q)}getMetadataForRun(q){for(const Q of this.j.trackers){const _=Q.getTaskIdForRun(q);if(_)return{taskId:_,runId:Q.id}}}async G(q,Q,_){const ce=this.g.get(q.controllerId);if(!ce)return{};const{collection:ne,profiles:ye,extension:ge}=ce,Y=ye.get(q.profileId);if(!Y)return{};const U=q.testIds.map(ae=>ne.tree.get(ae)).filter(I.$mg),oe=q.excludeExtIds.map(ae=>ce.collection.tree.get(ae)).filter(I.$mg).filter(ae=>U.some(se=>se.fullId.compare(ae.fullId)===n.TestPosition.IsChild));if(!U.length)return{};const ve=new t.$pP(U.some(ae=>ae.actual instanceof i.$yQ)?void 0:U.map(ae=>ae.actual),oe.map(ae=>ae.actual),Y,Q),te=(0,l.$0I)(q)&&this.j.prepareForMainThreadTestRun(ge,ve,N.fromInternal(q,ce.collection),Y,_);try{return await Y.runHandler(ve,_),{}}catch(ae){return{error:String(ae)}}finally{te&&te.hasRunningTasks&&!_.isCancellationRequested&&await R.Event.toPromise(te.onEnd)}}};e.$yqc=y,e.$yqc=y=Je([Ve(0,f.$kQ),Ve(1,w.$ak),Ve(2,m.$GQ),Ve(3,$.$vQ)],y);const k=1e4;var A;(function(H){H[H.Running=0]="Running",H[H.Cancelling=1]="Cancelling",H[H.Ended=2]="Ended"})(A||(A={}));class b extends p.$Uc{get hasRunningTasks(){return this.g>0}get id(){return this.C.id}constructor(q,Q,_,ce,ne,ye){super(),this.C=q,this.D=Q,this.F=_,this.G=ce,this.H=ne,this.f=A.Running,this.g=0,this.h=new Map,this.j=new Set,this.w=this.B(new R.$le),this.z=new Map,this.onEnd=this.w.event,this.m=this.B(new C.$we(ye));const ge=this.B(new r.$Rh(()=>this.I(),k));this.B(this.m.token.onCancellationRequested(()=>ge.schedule()));const Y=new R.$le;this.y=Y.event,this.B((0,p.$Sc)(()=>{Y.fire(),Y.dispose()}))}getTaskIdForRun(q){for(const[Q,{run:_}]of this.h)if(_===q)return Q}cancel(){this.f===A.Running?(this.m.cancel(),this.f=A.Cancelling):this.f===A.Cancelling&&this.I()}async getCoverageDetails(q,Q,_){const[,ce]=n.$7I.fromString(q).path,ne=this.z.get(q);if(!ne)return[];const{report:ye,extIds:ge}=ne,Y=this.h.get(ce);if(!Y)throw new Error("unreachable: run task was not found");let U;if(Q&&ye instanceof t.$vP){const ve=ge.indexOf(Q);if(ve===-1)return[];U=ye.fromTests[ve]}return await(U?this.G?.loadDetailedCoverageForTest?.(Y.run,ye,U,_):this.G?.loadDetailedCoverage?.(Y.run,ye,_))??[]}createRun(q){const Q=this.C.id,_=this.C.controllerId,ce=(0,u.$2g)(),ne=U=>(oe,...ve)=>{if(ge){this.F.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}this.L(oe),U(oe,...ve)},ye=(U,oe)=>{const ve=oe instanceof Array?oe.map(s.TestMessage.from):[s.TestMessage.from(oe)];if(U.uri&&U.range){const te={range:s.Range.from(U.range),uri:U.uri};for(const ae of ve)ae.location=ae.location||te}this.D.$appendTestMessagesInRun(Q,ce,n.$7I.fromExtHostTestItem(U,_).toString(),ve)};let ge=!1;const Y={isPersisted:this.C.isPersisted,token:this.m.token,name:q,onDidDispose:this.y,addCoverage:U=>{if(ge)return;const oe=U instanceof t.$vP?U.fromTests:[];if(oe.length){(0,g.$gH)(this.H,"attributableCoverage");for(const ae of oe)this.L(ae)}const ve=U.uri.toString(),te=new n.$7I([Q,ce,ve]).toString();this.z.set(te,{report:U,extIds:oe.map(ae=>n.$7I.fromExtHostTestItem(ae,_).toString())}),this.D.$appendCoverage(Q,ce,s.TestCoverage.fromFile(_,te,U))},enqueued:ne(U=>{this.D.$updateTestStateInRun(Q,ce,n.$7I.fromExtHostTestItem(U,_).toString(),l.TestResultState.Queued)}),skipped:ne(U=>{this.D.$updateTestStateInRun(Q,ce,n.$7I.fromExtHostTestItem(U,_).toString(),l.TestResultState.Skipped)}),started:ne(U=>{this.D.$updateTestStateInRun(Q,ce,n.$7I.fromExtHostTestItem(U,_).toString(),l.TestResultState.Running)}),errored:ne((U,oe,ve)=>{ye(U,oe),this.D.$updateTestStateInRun(Q,ce,n.$7I.fromExtHostTestItem(U,_).toString(),l.TestResultState.Errored,ve)}),failed:ne((U,oe,ve)=>{ye(U,oe),this.D.$updateTestStateInRun(Q,ce,n.$7I.fromExtHostTestItem(U,_).toString(),l.TestResultState.Failed,ve)}),passed:ne((U,oe)=>{this.D.$updateTestStateInRun(Q,ce,n.$7I.fromExtHostTestItem(U,this.C.controllerId).toString(),l.TestResultState.Passed,oe)}),appendOutput:(U,oe,ve)=>{ge||(ve&&this.L(ve),this.D.$appendOutputToRun(Q,ce,h.$Ne.fromString(U),oe&&s.location.from(oe),ve&&n.$7I.fromExtHostTestItem(ve,_).toString()))},end:()=>{ge||(ge=!0,this.D.$finishedTestRunTask(Q,ce),--this.g||this.J())}};return this.g++,this.h.set(ce,{run:Y}),this.D.$startedTestRunTask(Q,{id:ce,ctrlId:this.C.controllerId,name:q,running:!0}),Y}I(){for(const{run:q}of this.h.values())q.end()}J(){this.f!==A.Ended&&(this.f=A.Ended,this.w.fire())}L(q){if(!(q instanceof i.$xQ))throw new d.$cQ(q.id);if(this.j.has(n.$7I.fromExtHostTestItem(q,this.C.controllerId).toString()))return;const Q=[],_=this.C.colllection.root;for(;;){const ce=s.TestItem.from(q);if(Q.unshift(ce),this.j.has(ce.extId)||(this.j.add(ce.extId),q===_))break;q=q.parent||_}this.D.$addTestsToRun(this.C.controllerId,this.C.id,Q)}dispose(){this.J(),super.dispose()}}class v{get trackers(){return this.f.values()}constructor(q,Q){this.h=q,this.j=Q,this.f=new Map,this.g=new Map}getCoverageDetails(q,Q,_){const ce=n.$7I.root(q);return this.g.get(ce)?.getCoverageDetails(q,Q,_)||[]}disposeTestRun(q){this.g.get(q)?.dispose(),this.g.delete(q);for(const[Q,{id:_}]of this.f)_===q&&this.f.delete(Q)}prepareForMainThreadTestRun(q,Q,_,ce,ne){return this.k(Q,_,ce,q,ne)}cancelRunById(q){this.g.get(q)?.cancel()}cancelAllRuns(){for(const q of this.f.values())q.cancel()}createTestRun(q,Q,_,ce,ne,ye){const ge=this.f.get(ce);if(ge)return ge.createRun(ne);const Y=N.fromPublic(Q,_,ce,ye),U=F(ce);this.h.$startedExtensionTestRun({controllerId:Q,continuous:!!ce.continuous,profile:U&&{group:B[U.kind],id:U.profileId},exclude:ce.exclude?.map(ve=>n.$7I.fromExtHostTestItem(ve,_.root.id).toString())??[],id:Y.id,include:ce.include?.map(ve=>n.$7I.fromExtHostTestItem(ve,_.root.id).toString())??[_.root.id],preserveFocus:ce.preserveFocus??!0,persist:ye});const oe=this.k(ce,Y,ce.profile,q);return R.Event.once(oe.onEnd)(()=>{this.h.$finishedExtensionTestRun(Y.id)}),oe.createRun(ne)}k(q,Q,_,ce,ne){const ye=new b(Q,this.h,this.j,_,ce,ne);return this.f.set(q,ye),this.g.set(ye.id,ye),ye}}e.$zqc=v;const F=H=>{if(H.profile){if(!(H.profile instanceof W))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return H.profile}};class N{static fromPublic(q,Q,_,ce){return new N(q,(0,u.$2g)(),ce,Q)}static fromInternal(q,Q){return new N(q.controllerId,q.runId,!0,Q)}constructor(q,Q,_,ce){this.controllerId=q,this.id=Q,this.isPersisted=_,this.colllection=ce}}e.$Aqc=N;class L{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(q){this.k=q,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(q){this.f.add(q)}update(q){Object.assign(q.revived,s.TestItem.toPlain(q.item)),this.f.has(q)||this.g.add(q)}remove(q){if(this.f.has(q)){this.f.delete(q);return}this.g.delete(q);const Q=n.$7I.parentId(q.item.extId);if(Q&&this.j.has(Q.toString())){this.j.add(q.item.extId);return}this.h.add(q)}getChangeEvent(){const{f:q,g:Q,h:_}=this;return{get added(){return[...q].map(ce=>ce.revived)},get updated(){return[...Q].map(ce=>ce.revived)},get removed(){return[..._].map(ce=>ce.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class M extends l.$dJ{constructor(){super(...arguments),this.z=new R.$le,this.onDidChangeTests=this.z.event}get rootTests(){return this.h}getMirroredTestDataById(q){return this.g.get(q)}getMirroredTestDataByReference(q){return this.g.get(q.id)}y(q,Q){return{...q,revived:s.TestItem.toPlain(q.item),depth:Q?Q.depth+1:0,children:new Set}}x(){return new L(this.z)}}class z{constructor(q){this.g=q}checkout(){this.f||(this.f=this.h());const q=this.f;return q.observers++,{onDidChangeTest:q.tests.onDidChangeTests,get tests(){return[...q.tests.rootTests].map(Q=>Q.revived)},dispose:(0,O.$cb)(()=>{--q.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(q){return this.f?.tests.getMirroredTestDataByReference(q)}applyDiff(q){this.f?.tests.apply(q)}h(){const q=new M({asCanonicalUri:Q=>Q});return this.g.$subscribeToDiffs(),{observers:0,tests:q}}}const j=(H,q,Q,_)=>{Q?Object.assign(Q,_):q.$updateTestRunConfig(H.controllerId,H.profileId,_)};class W{#e;#t;#i;#n;#s;get label(){return this.g}set label(q){q!==this.g&&(this.g=q,j(this,this.#e,this.#n,{label:q}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(q){q!==this.h&&(this.h=q,j(this,this.#e,this.#n,{supportsContinuousRun:q}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(q){q!==this.isDefault&&(q?this.#t.add(this.profileId):this.#t.delete(this.profileId),j(this,this.#e,this.#n,{isDefault:q}))}get tag(){return this._tag}set tag(q){q?.id!==this._tag?.id&&(this._tag=q,j(this,this.#e,this.#n,{tag:q?s.TestTag.namespace(this.controllerId,q.id):null}))}get configureHandler(){return this.f}set configureHandler(q){q!==this.f&&(this.f=q,j(this,this.#e,this.#n,{hasConfigurationHandler:!!q}))}get onDidChangeDefault(){return R.Event.chain(this.#i,q=>q.map(Q=>Q.get(this.controllerId)?.get(this.profileId)).filter(I.$mg))}constructor(q,Q,_,ce,ne,ye,ge,Y,U,oe=!1,ve=void 0,te=!1){this.controllerId=ne,this.profileId=ye,this.g=ge,this.kind=Y,this.runHandler=U,this._tag=ve,this.h=te,this.#e=q,this.#s=Q,this.#t=_,this.#i=ce,Q.set(ye,this);const ae=B[Y];if(typeof ae!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);oe&&_.add(ye),this.#n={profileId:ye,controllerId:ne,tag:ve?s.TestTag.namespace(this.controllerId,ve.id):null,label:ge,group:ae,isDefault:oe,hasConfigurationHandler:!1,supportsContinuousRun:te},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Bqc=W;const B={[t.TestRunProfileKind.Coverage]:l.TestRunProfileBitset.Coverage,[t.TestRunProfileKind.Debug]:l.TestRunProfileBitset.Debug,[t.TestRunProfileKind.Run]:l.TestRunProfileBitset.Run};function ee(H,q){for(let Q=0;Q<H.path.length;Q++){const _=q.find(ce=>ce.id===H.path[Q]);if(!_)return;if(Q===H.path.length-1)return _;q=_.children}}}),define(ke[320],Ie([1,0,18,4,3,6,168,15,9]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipc=void 0,r=qe(r),T=qe(T);class c extends C.$Uc{constructor(S,u){super(),this.m=u,this.a=new h.$le,this.b=new h.$le,this.c=new h.$le,this.f=new h.$le,this.g=new h.$le,this.h=new h.$le,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=S.getProxy(R.$KN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(P=>this.h.fire(P))),this.B(this.m.onDidChangeActiveTextEditor(P=>this.g.fire(P)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(S){const u=this.m.allEditors();return S?u:u.map(P=>P.value)}async showTextDocument(S,u,P){let w;typeof u=="number"?w={position:T.ViewColumn.from(u),preserveFocus:P}:typeof u=="object"?w={position:T.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?T.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:w={preserveFocus:!1};const a=await this.j.$tryShowTextDocument(S.uri,w),m=a&&this.m.getEditor(a);if(m)return m.value;throw a?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}createTextEditorDecorationType(S,u){return new O.$rQ(this.j,S,u).value}$acceptEditorPropertiesChanged(S,u){const P=this.m.getEditor(S);if(!P)throw new Error("unknown text editor");if(u.options&&P._acceptOptions(u.options),u.selections){const w=u.selections.selections.map(T.Selection.to);P._acceptSelections(w)}if(u.visibleRanges){const w=r.$Gb(u.visibleRanges.map(T.Range.to));P._acceptVisibleRanges(w)}if(u.options&&this.b.fire({textEditor:P.value,options:{...u.options,lineNumbers:T.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const w=p.TextEditorSelectionChangeKind.fromValue(u.selections.source),a=u.selections.selections.map(T.Selection.to);this.a.fire({textEditor:P.value,selections:a,kind:w})}if(u.visibleRanges){const w=r.$Gb(u.visibleRanges.map(T.Range.to));this.c.fire({textEditor:P.value,visibleRanges:w})}}$acceptEditorPositionData(S){for(const u in S){const P=this.m.getEditor(u);if(!P)throw new Error("Unknown text editor");const w=T.ViewColumn.to(S[u]);P.value.viewColumn!==w&&(P._acceptViewColumn(w),this.f.fire({textEditor:P.value,viewColumn:w}))}}getDiffInformation(S){return Promise.resolve(this.j.$getDiffInformation(S))}}e.$Ipc=c}),define(ke[321],Ie([1,0,2,5,6,3,9,15,23,40,17]),function($e,e,r,h,C,R,O,T,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$urc=e.$trc=void 0,e.$trc=(0,h.$Fi)("IExtHostTimeline");class S{constructor(w,a){this.b=new Map,this.c=new Map,this.a=w.getProxy(C.$KN.MainThreadTimeline),a.registerArgumentProcessor({processArgument:(m,$)=>{if(m&&m.$mid===c.MarshalledId.TimelineActionContext)if(this.b.get(m.source)&&p.$rn.equals($,this.b.get(m.source)?.extension)){const f=m.uri===void 0?void 0:r.URI.revive(m.uri);return this.c.get(m.source)?.get(u(f))?.get(m.handle)}else return;return m}})}async $getTimeline(w,a,m,$){return this.b.get(w)?.provider.provideTimeline(r.URI.revive(a),m,$)}registerTimelineProvider(w,a,m,$){const f=new R.$Tc,i=this.d(a.id,$,f).bind(this);let s;a.onDidChange&&(s=a.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:a.id}),this));const t=this.c;return this.f({...a,scheme:w,onDidChange:void 0,async provideTimeline(o,n,d){n?.resetCache&&(f.clear(),t.get(a.id)?.clear());const l=await a.provideTimeline(o,n,d);if(l==null)return;const g=i(o,n);return{...l,source:a.id,items:l.items.map(g)}},dispose(){for(const o of t.values())o.get(a.id)?.clear();s?.dispose(),f.dispose()}},m)}d(w,a,m){return($,f)=>{let i;if(f?.cacheResults){let s=this.c.get(w);s===void 0&&(s=new Map,this.c.set(w,s));const t=u($);i=s.get(t),i===void 0&&(i=new Map,s.set(t,i))}return s=>{const{iconPath:t,...o}=s,n=`${w}|${s.id??s.timestamp}`;i?.set(n,s);let d,l,g;s.iconPath&&(t instanceof O.$LO?g={id:t.id,color:t.color}:r.URI.isUri(t)?(d=t,l=t):{light:d,dark:l}=t);let E;return O.$eO.isMarkdownString(o.tooltip)?E=T.MarkdownString.from(o.tooltip):(0,I.$eg)(o.tooltip)?E=o.tooltip:O.$eO.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=T.MarkdownString.from(o.detail)):(0,I.$eg)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=o.detail),{...o,id:o.id??void 0,handle:n,source:w,command:s.command?a.toInternal(s.command,m):void 0,icon:d,iconDark:l,themeIcon:g,tooltip:E,accessibilityInformation:s.accessibilityInformation}}}}f(w,a){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:a}),(0,R.$Sc)(()=>{for(const $ of this.c.values())$.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$urc=S;function u(P){return P?.toString()}}),define(ke[322],Ie([1,0,8,22,2,4,3,255,7,9,17,18,15,85,20,209,25]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vrc=void 0,c=qe(c);function $(s,t){if((0,I.$eg)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let o;return Array.isArray(s.highlights)&&(o=s.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),o=o.length?o:void 0),{label:s.label,highlights:o}}}class f extends O.$Uc{constructor(t,o,n){super(),this.f=t,this.g=o,this.h=n,this.a=new Map,this.b=new a.$O_;function d(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}o.registerArgumentProcessor({processArgument:l=>d(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(g=>d(g)?this.r(g):g):l})}registerTreeDataProvider(t,o,n){const d=this.createTreeView(t,{treeDataProvider:o},n);return{dispose:()=>d.dispose()}}createTreeView(t,o,n){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=o.dragAndDropController?.dropMimeTypes??[],l=o.dragAndDropController?.dragMimeTypes??[],g=!!o.dragAndDropController?.handleDrag,E=!!o.dragAndDropController?.handleDrop,D=this.m(t,o,n),y={showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,dropMimeTypes:d,dragMimeTypes:l,hasHandleDrag:g,hasHandleDrop:E,manuallyManageCheckboxes:!!o.manageCheckboxStateManually},k=this.f.$registerTreeViewDataProvider(t,y),A={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,m.$gH)(n,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,m.$gH)(n,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(b){(0,P.$6k)(b)&&(0,m.$gH)(n,"treeViewMarkdownMessage"),D.message=b},get title(){return D.title},set title(b){D.title=b},get description(){return D.description},set description(b){D.description=b},get badge(){return D.badge},set badge(b){b!==void 0&&c.ViewBadge.isViewBadge(b)?D.badge={value:Math.floor(Math.abs(b.value)),tooltip:b.tooltip}:b===void 0&&(D.badge=void 0)},reveal:(b,v)=>D.reveal(b,v),dispose:async()=>{await k,this.a.delete(t),D.dispose()}};return this.B(A),A}$getChildren(t,o){const n=this.a.get(t);return n?n.getChildren(o):Promise.reject(new T.$CG(t))}async $handleDrop(t,o,n,d,l,g,E,D){const y=this.a.get(t);if(!y)return Promise.reject(new T.$CG(t));const k=u.DataTransfer.toDataTransfer(n,async A=>(await this.f.$resolveDropFileData(t,o,A)).buffer);return E===t&&D&&await this.j(k,y,D,l,g),y.onDrop(k,d,l)}async j(t,o,n,d,l){const g=this.b.removeDragOperationTransfer(l);if(g)(await g)?.forEach((E,D)=>{E&&t.set(D,E)});else if(l&&o.handleDrag){const E=o.handleDrag(n,t,d);this.b.addDragOperationTransfer(l,E),await E}return t}async $handleDrag(t,o,n,d){const l=this.a.get(t);if(!l)return Promise.reject(new T.$CG(t));const g=await this.j(new c.$HO,l,o,d,n);if(!(!g||d.isCancellationRequested))return u.DataTransfer.from(g)}async $hasResolve(t){const o=this.a.get(t);if(!o)throw new T.$CG(t);return o.hasResolve}$resolve(t,o,n){const d=this.a.get(t);if(!d)throw new T.$CG(t);return d.resolveTreeItem(o,n)}$setExpanded(t,o,n){const d=this.a.get(t);if(!d)throw new T.$CG(t);d.setExpanded(o,n)}$setSelectionAndFocus(t,o,n){const d=this.a.get(t);if(!d)throw new T.$CG(t);d.setSelectionAndFocus(o,n)}$setVisible(t,o){const n=this.a.get(t);if(!n){if(!o)return;throw new T.$CG(t)}n.setVisible(o)}$changeCheckboxState(t,o){const n=this.a.get(t);if(!n)throw new T.$CG(t);n.setCheckboxState(o)}m(t,o,n){const d=this.B(new i(t,o,this.f,this.g.converter,this.h,n));return this.a.set(t,d),d}r(t){const o=this.a.get(t.$treeViewId);return o&&"$treeItemHandle"in t?o.getExtensionElement(t.$treeItemHandle):o&&"$focusedTreeItem"in t&&t.$focusedTreeItem?o.focusedElement:null}}e.$vrc=f;class i extends O.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.$ng)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,o,n,d,l,g){if(super(),this.I=t,this.J=n,this.L=d,this.M=l,this.N=g,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$le),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$le),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$le),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$le),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$le),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$le),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$le),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new w.$we,g.contributes&&g.contributes.views)for(const k in g.contributes.views)for(const A of g.contributes.views[k])A.id===t&&(this.P=A.name);this.f=o.treeDataProvider,this.g=o.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(k=>{Array.isArray(k)&&k.length===0||this.F.fire({message:!1,element:k})}));let E,D;const y=R.Event.debounce(this.F.event,(k,A)=>(k||(k={message:!1,elements:[]}),A.element!==!1&&(E||(E=new Promise(b=>D=b),this.G=this.G.then(()=>E)),Array.isArray(A.element)?k.elements.push(...A.element):k.elements.push(A.element)),A.message&&(k.message=!0),k),200,!0);this.B(y(({message:k,elements:A})=>{A.length&&(this.H=this.H.then(()=>{const b=D;return E=null,this.$(A).then(()=>b())})),k&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const o=t?this.getExtensionElement(t):void 0;if(t&&!o)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let n=this.X(t);return n||(n=await this.Y(o)),n?n.map(d=>d.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,o){o=o||{select:!0,focus:!1};const n=(0,I.$ng)(o.select)?!0:o.select,d=(0,I.$ng)(o.focus)?!1:o.focus,l=(0,I.$ng)(o.expand)?!1:o.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(g=>this.W(t,g[g.length-1]).then(E=>this.J.$reveal(this.I,{item:E.item,parentChain:g.map(D=>D.item)},{select:n,focus:d,expand:l})),g=>this.M.error(g)):this.J.$reveal(this.I,void 0,{select:n,focus:d,expand:l})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=u.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,o){const n=this.getExtensionElement(t);n&&(o?this.u.fire(Object.freeze({element:n})):this.w.fire(Object.freeze({element:n})))}setSelectionAndFocus(t,o){const n=!(0,S.$tb)(this.s,t);this.s=t;const d=this.t!==o;this.t=o,n&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const o=(await Promise.all(t.map(async n=>{const d=this.getExtensionElement(n.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:n.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);o.forEach(n=>{n.treeItem.checkboxState=n.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}),this.D.fire({items:o.map(n=>[n.extensionItem,n.newState])})}async handleDrag(t,o,n){const d=[];for(const l of t){const g=this.getExtensionElement(l);g&&d.push(g)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,o,n),o}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,o,n){const d=o?this.getExtensionElement(o):void 0;if(!(!d&&o||!this.g?.handleDrop))return(0,p.$xh)(()=>this.g?.handleDrop?this.g.handleDrop(d,t,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,o){if(!this.f.resolveTreeItem)return;const n=this.j.get(t);if(n){const d=this.m.get(n);if(d){const l=await this.f.resolveTreeItem(d.extensionItem,n,o)??d.extensionItem;return this.hb(l),d.item.tooltip=this.eb(l.tooltip),d.item.command=this.fb(d.disposableStore,l.command),d.item}}}S(t){return this.U(t).then(o=>o?this.S(o).then(n=>this.W(o,n[n.length-1]).then(d=>(n.push(d),n))):Promise.resolve([]))}U(t){const o=this.m.get(t);return o?Promise.resolve(o.parent?this.j.get(o.parent.item.handle):void 0):(0,p.$xh)(()=>this.f.getParent(t))}W(t,o){const n=this.m.get(t);return n?Promise.resolve(n):(0,p.$xh)(()=>this.f.getTreeItem(t)).then(d=>this.kb(t,d,o,!0)).then(d=>this.getChildren(o?o.item.handle:void 0).then(()=>{const l=this.getExtensionElement(d);if(l){const g=this.m.get(l);if(g)return Promise.resolve(g)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let o;if(typeof t=="string"){const n=this.getExtensionElement(t);o=n?this.m.get(n):void 0}else o=t;return o&&o.children||void 0}return this.h}async Y(t){this.rb(t);const o=new w.$we(this.Z.token);try{const n=t?this.m.get(t):void 0,d=await this.f.getChildren(t);if(o.token.isCancellationRequested)return;const l=(0,S.$Gb)(d||[]),g=await Promise.all((0,S.$Gb)(l).map(D=>this.f.getTreeItem(D)));if(o.token.isCancellationRequested)return;const E=g.map((D,y)=>D?this.db(l[y],D,n):null);return(0,S.$Gb)(E)}finally{o.dispose()}}$(t){if(t.some(n=>!n))return this.Z.dispose(!0),this.Z=new w.$we,this.tb(),this.J.$refresh(this.I);{const n=this.ab(t);if(n.length)return this.bb(n)}return Promise.resolve(void 0)}ab(t){const o=new Set,n=t.map(l=>this.m.get(l));for(const l of n)if(l&&!o.has(l.item.handle)){let g=l;for(;g&&g.parent&&n.findIndex(E=>g&&g.parent&&E&&E.item.handle===g.parent.item.handle)===-1;){const E=this.j.get(g.parent.item.handle);g=E?this.m.get(E):void 0}g&&!g.parent&&o.add(l.item.handle)}const d=[];return o.forEach(l=>{const g=this.j.get(l);if(g){const E=this.m.get(g);E&&(!E.parent||!o.has(E.parent.item.handle))&&d.push(l)}}),d}bb(t){const o={};return Promise.all(t.map(n=>this.cb(n).then(d=>{d&&(o[n]=d.item)}))).then(()=>Object.keys(o).length?this.J.$refresh(this.I,o):void 0)}cb(t){const o=this.getExtensionElement(t);if(o){const n=this.m.get(o);if(n)return this.rb(o),(0,p.$xh)(()=>this.f.getTreeItem(o)).then(d=>{if(d){const l=this.ib(o,d,n.parent);return this.pb(o,l,n,n.parent),n.dispose(),l}return null})}return Promise.resolve(null)}db(t,o,n){const d=this.ib(t,o,n);if(o.id&&this.j.has(d.item.handle))throw new Error((0,r.localize)(10823,null,o.id));return this.ob(t,d),this.qb(d,n),d}eb(t){return c.$eO.isMarkdownString(t)?u.MarkdownString.from(t):t}fb(t,o){return o?{...this.L.toInternal(o,t),originalId:o.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let o,n,d;return typeof t.checkboxState=="number"?o=t.checkboxState:(o=t.checkboxState.state,n=t.checkboxState.tooltip,d=t.checkboxState.accessibilityInformation),{isChecked:o===c.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:d}}hb(t){if(!c.$CO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,o,n){this.hb(o);const d=this.B(new O.$Tc),l=this.kb(t,o,n),g=this.lb(o);return{item:{handle:l,parentHandle:n?n.item.handle:void 0,label:$(o.label,this.N),description:o.description,resourceUri:o.resourceUri,tooltip:this.eb(o.tooltip),command:this.fb(d,o.command),contextValue:o.contextValue,icon:g,iconDark:this.mb(o)||g,themeIcon:this.jb(o),collapsibleState:(0,I.$ng)(o.collapsibleState)?c.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation,checkbox:this.gb(o)},extensionItem:o,parent:n,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(t){return t.iconPath instanceof c.$LO?t.iconPath:void 0}kb(t,{id:o,label:n,resourceUri:d},l,g){if(o)return`${i.b}/${o}`;const E=$(n,this.N),D=l?l.item.handle:i.a;let y=E?E.label:d?(0,h.$dh)(d):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const k=this.m.has(t)?this.m.get(t).item.handle:void 0,A=this.X(l)||[];let b,v=0;do{if(b=`${D}/${v}:${y}`,g||!this.j.has(b)||k===b)break;v++}while(v<=A.length);return b}lb(t){if(t.iconPath&&!(t.iconPath instanceof c.$LO))return typeof t.iconPath=="string"||C.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof c.$LO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return C.URI.isUri(t)?t:C.URI.file(t)}ob(t,o){this.j.set(o.item.handle,t),this.m.set(t,o)}pb(t,o,n,d){this.j.delete(o.item.handle),this.m.delete(t),o.item.handle!==n.item.handle&&this.j.delete(n.item.handle),this.ob(t,o);const l=this.X(d)||[],g=l.filter(E=>E.item.handle===n.item.handle)[0];g&&l.splice(l.indexOf(g),1,o)}qb(t,o){o?(o.children||(o.children=[]),o.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const o=this.m.get(t);if(o){if(o.children)for(const n of o.children){const d=this.j.get(n.item.handle);d&&this.sb(d)}o.children=void 0}}else this.tb()}sb(t){const o=this.m.get(t);if(o){if(o.children)for(const n of o.children){const d=this.j.get(n.item.handle);d&&this.sb(d)}this.m.delete(t),this.j.delete(o.item.handle),o.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[323],Ie([1,0,4,3,2,32,15,96,6,9]),function($e,e,r,h,C,R,O,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2pc=void 0,O=qe(O),p=qe(p),c=qe(c);class I extends h.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(w,a,m,$){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new r.$le),this.onDidDispose=this.#d.event,this.#h=this.B(new r.$le),this.onDidChangeViewState=this.#h.event,this.#e=w,this.#t=a,this.#n=m,this.#i=$.viewType,this.#s=$.panelOptions,this.#o=$.viewColumn,this.#r=$.title,this.#l=$.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(w){this.c(),this.#r!==w&&(this.#r=w,this.#t.$setTitle(this.#e,w))}get iconPath(){return this.c(),this.#a}set iconPath(w){this.c(),this.#a!==w&&(this.#a=w,this.#t.$setIconPath(this.#e,C.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(w){this.#u||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(this.#l=w.active,this.#c=w.visible,this.#o=w.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(w,a){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof w>"u"?void 0:O.ViewColumn.from(w),preserveFocus:!!a})}c(){if(this.#u)throw new Error("Webview is disposed")}}class S extends h.$Uc{static c(){return(0,R.$2g)()}constructor(w,a,m){super(),this.j=a,this.m=m,this.g=new Map,this.h=new Map,this.f=w.getProxy(p.$KN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(w=>w.dispose()),this.g.clear()}createWebviewPanel(w,a,m,$,f={}){const i=typeof $=="object"?$.viewColumn:$,s={viewColumn:O.ViewColumn.from(i),preserveFocus:typeof $=="object"&&!!$.preserveFocus},t=(0,T.$Xpc)(w),o=S.c();this.f.$createWebviewPanel((0,T.$Zpc)(w),o,a,{title:m,panelOptions:u(f),webviewOptions:(0,T.$1pc)(w,this.m,f),serializeBuffersForPostMessage:t},s);const n=this.j.createNewWebview(o,f,w);return this.createNewWebviewPanel(o,a,m,i,f,n,!0)}$onDidChangeWebviewPanelViewStates(w){const a=Object.keys(w);a.sort((m,$)=>{const f=w[m],i=w[$];return f.active?1:i.active?-1:+f.visible-+i.visible});for(const m of a){const $=this.getWebviewPanel(m);if(!$)continue;const f=w[m];$._updateViewState({active:f.active,visible:f.visible,viewColumn:O.ViewColumn.to(f.position)})}}async $onDidDisposeWebviewPanel(w){this.getWebviewPanel(w)?.dispose(),this.g.delete(w),this.j.deleteWebview(w)}registerWebviewPanelSerializer(w,a,m){if(this.h.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.h.set(a,{serializer:m,extension:w}),this.f.$registerSerializer(a,{serializeBuffersForPostMessage:(0,T.$Xpc)(w)}),new c.$MN(()=>{this.h.delete(a),this.f.$unregisterSerializer(a)})}async $deserializeWebviewPanel(w,a,m,$){const f=this.h.get(a);if(!f)throw new Error(`No serializer found for '${a}'`);const{serializer:i,extension:s}=f,t=this.j.createNewWebview(w,m.webviewOptions,s),o=this.createNewWebviewPanel(w,a,m.title,$,m.panelOptions,t,m.active);await i.deserializeWebviewPanel(o,m.state)}createNewWebviewPanel(w,a,m,$,f,i,s){const t=new I(w,this.f,i,{viewType:a,title:m,viewColumn:$,panelOptions:f,active:s});return this.g.set(w,t),t}getWebviewPanel(w){return this.g.get(w)}}e.$2pc=S;function u(P){return{enableFindWidget:P.enableFindWidget,retainContextWhenHidden:P.retainContextWhenHidden}}}),define(ke[324],Ie([1,0,4,3,96,15,6,9]),function($e,e,r,h,C,R,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yrc=void 0,O=qe(O),T=qe(T);class p extends h.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(S,u,P,w,a,m){super(),this.#s=!1,this.#l=this.B(new r.$le),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new r.$le),this.onDidDispose=this.#u.event,this.#i=P,this.#a=w,this.#e=S,this.#t=u,this.#n=a,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(S){this.a(),this.#a!==S&&(this.#a=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#o}set description(S){this.a(),this.#o!==S&&(this.#o=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(S){S===this.#r||this.#s||(this.#r=S,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(S){this.a(),!(S?.value===this.#c?.value&&S?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#s)throw new Error("Webview is disposed")}}class c{constructor(S,u){this.d=u,this.b=new Map,this.c=new Map,this.a=S.getProxy(O.$KN.MainThreadWebviewViews)}registerWebviewViewProvider(S,u,P,w){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:P,extension:S}),this.a.$registerWebviewViewProvider((0,C.$Zpc)(S),u,{retainContextWhenHidden:w?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$Xpc)(S)}),new T.$MN(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(S,u,P,w,a){const m=this.b.get(u);if(!m)throw new Error(`No view provider found for '${u}'`);const{provider:$,extension:f}=m,i=this.d.createNewWebview(S,{},f),s=new p(S,this.a,u,P,i,!0);this.c.set(S,s),await $.resolveWebviewView(s,{state:w},a)}async $onDidChangeWebviewViewVisibility(S,u){this.e(S)._setVisible(u)}async $disposeWebviewView(S){const u=this.e(S);this.c.delete(S),u.dispose(),this.d.deleteWebview(S)}e(S){const u=this.c.get(S);if(!u)throw new Error("No webview found");return u}}e.$yrc=c}),define(ke[325],Ie([1,0,75,14,11,227,27,10]),function($e,e,r,h,C,R,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dsc=void 0;let p=class{constructor(S,u){S.addFileSystemProvider(h.Schemas.file,new c(u),{isCaseSensitive:T.$l})}};e.$dsc=p,e.$dsc=p=Je([Ve(0,r.$Tpc),Ve(1,C.$ak)],p);class c{constructor(S){this.b=S,this.a=new R.$tr(this.b)}async stat(S){const u=await this.a.stat(S);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions===O.FilePermission.Readonly?1:void 0}}readDirectory(S){return this.a.readdir(S)}createDirectory(S){return this.a.mkdir(S)}readFile(S){return this.a.readFile(S)}writeFile(S,u,P){return this.a.writeFile(S,u,{...P,unlock:!1,atomic:!1})}delete(S,u){return this.a.delete(S,{...u,useTrash:!1,atomic:!1})}rename(S,u,P){return this.a.rename(S,u,P)}copy(S,u,P){return this.a.copy(S,u,P)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(S,u){throw new Error("Method not implemented.")}}}),define(ke[326],Ie([1,0,16,66,32,34,3,6,2,19]),function($e,e,r,h,C,R,O,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bsc=void 0;let I=class extends O.$Uc{constructor(u,P){super();const w=u.getProxy(T.$KN.MainThreadDownloadService);P.registerCommand(!1,"_workbench.downloadResource",async a=>{const m=p.URI.file((0,r.$jc)((0,h.tmpdir)(),(0,C.$2g)()));return await w.$download(a,m),m})}};e.$bsc=I,e.$bsc=I=Je([Ve(0,c.$kQ),Ve(1,R.$GQ)],I)}),define(ke[327],Ie([1,0,45,16,2,97,3,14,7,33]),function($e,e,r,h,C,R,O,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nsc=void 0,r=qe(r),h=qe(h);class I extends R.$Vpc{constructor(){super(...arguments),this.i=null}async g(o){const n=await super.g(o);if(n.scheme!==T.Schemas.file)return n;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${n.fsPath}.`),n;const d=n.fsPath;let l=0;do{let g;l===0?g=d:g=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${l}`:`${d}-${l}`,await S(g);const E=h.$jc(g,"vscode.lock"),D=await a(this.d,E,!1);if(D)return this.i=D,process.on("exit",()=>{D.dispose()}),C.URI.file(g);l++}while(l<10);return n}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$nsc=I;async function S(t){try{await r.promises.stat(t);return}catch{}try{await r.promises.mkdir(t,{recursive:!0})}catch{}}const u=1e3,P=10*60*1e3;class w extends O.$Uc{constructor(o,n){super(),this.b=o,this.c=n,this.a=this.B(new p.$Qh),this.a.cancelAndSet(async()=>{const d=await m(o,n);(!d||d.pid!==process.pid)&&(o.info(`Lock '${n}': The lock was lost unexpectedly.`),this.a.cancel());try{await r.promises.utimes(n,new Date,new Date)}catch(l){o.error(l),o.info(`Lock '${n}': Could not update mtime.`)}},u)}dispose(){super.dispose();try{r.unlinkSync(this.c)}catch{}}async setWillRelease(o){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${o} ms.`);try{const n={pid:process.pid,willReleaseAt:Date.now()+o};await c.Promises.writeFile(this.c,JSON.stringify(n),{flag:"w"})}catch(n){this.b.error(n)}}}async function a(t,o,n){try{const l={pid:process.pid,willReleaseAt:0};await c.Promises.writeFile(o,JSON.stringify(l),{flag:"wx"})}catch(l){t.error(l)}const d=await m(t,o);return!d||d.pid!==process.pid?n?(t.info(`Lock '${o}': Could not acquire lock, giving up.`),null):(t.info(`Lock '${o}': Could not acquire lock, checking if the file is stale.`),i(t,o)):(t.info(`Lock '${o}': Lock acquired.`),new w(t,o))}async function m(t,o){let n;try{n=await r.promises.readFile(o)}catch(d){return t.error(d),null}try{return JSON.parse(String(n))}catch(d){return t.error(d),null}}async function $(t,o){let n;try{n=await r.promises.stat(o)}catch(d){return t.error(d),0}return n.mtime.getTime()}function f(t){try{return process.kill(t,0),!0}catch{return!1}}async function i(t,o){const n=await m(t,o);if(!n)return t.info(`Lock '${o}': Could not read pid of lock holder.`),s(t,o);if(n.willReleaseAt){let D=n.willReleaseAt-Date.now();if(D<5e3){for(D>0?t.info(`Lock '${o}': The lockfile is scheduled to be released in ${D} ms.`):t.info(`Lock '${o}': The lockfile is scheduled to have been released.`);D>0;){if(await(0,p.$Gh)(Math.min(100,D)),await $(t,o)===0)return s(t,o);D=n.willReleaseAt-Date.now()}return s(t,o)}}if(!f(n.pid))return t.info(`Lock '${o}': The pid ${n.pid} appears to be gone.`),s(t,o);const d=await $(t,o),l=Date.now()-d;if(l<=P)return t.info(`Lock '${o}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;t.info(`Lock '${o}': The lock looks stale, waiting for 2s.`),await(0,p.$Gh)(2e3);const g=await $(t,o),E=Date.now()-g;return E<=P?(t.info(`Lock '${o}': The lock does not look stale, elapsed: ${E} ms, giving up.`),null):(t.info(`Lock '${o}': The lock looks stale even after waiting for 2s.`),s(t,o))}async function s(t,o){t.info(`Lock '${o}': Deleting a stale lock.`);try{await r.promises.unlink(o)}catch{}return a(t,o,!0)}}),define(ke[328],Ie([1,0,32,19,48,34]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Irc=void 0;let O=class extends C.$fqc{constructor(p,c){super(!0,p,c)}createTerminal(p,c,I){return this.createTerminalFromOptions({name:p,shellPath:c,shellArgs:I})}createTerminalFromOptions(p,c){const I=new C.$eqc(this.a,(0,r.$2g)(),p,p.name);return this.f.push(I),I.create(p,this.R(p,c)),I.value}};e.$Irc=O,e.$Irc=O=Je([Ve(0,R.$GQ),Ve(1,h.$kQ)],O)}),define(ke[329],Ie([1,0,4,36,35,5]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=e.$6M=e.OutputChannelUpdateMode=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=void 0,e.$SM="text/x-code-output",e.$TM="output",e.$UM="Log",e.$VM="text/x-code-log-output",e.$WM="log",e.$XM="workbench.panel.output",e.$YM=new C.$Wj("inOutput",!1),e.$ZM=new C.$Wj("activeLogOutput",!1),e.$1M=new C.$Wj("activeLogOutput.levelSettable",!1),e.$2M=new C.$Wj("activeLogOutput.level",""),e.$3M=new C.$Wj("activeLogOutput.levelIsDefault",!1),e.$4M=new C.$Wj("outputView.scrollLock",!1),e.$5M=(0,R.$Fi)("outputService");var O;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(O||(e.OutputChannelUpdateMode=O={})),e.$6M={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new r.$le,this.onDidRegisterChannel=this.b.event,this.c=new r.$le,this.onDidRemoveChannel=this.c.event}registerChannel(c){this.a.has(c.id)||(this.a.set(c.id,c),this.b.fire(c.id))}getChannels(){const c=[];return this.a.forEach(I=>c.push(I)),c}getChannel(c){return this.a.get(c)}removeChannel(c){this.a.delete(c),this.c.fire(c)}}h.$ro.add(e.$6M.OutputChannels,new T),e.$7M=new C.$Wj("activeOutputChannel","")}),define(ke[169],Ie([1,0,6,5,19,23,11,329,75,29,62,212,21,17,27,4,3]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$crc=e.$brc=void 0;class $ extends O.$gk{get disposed(){return this.n}constructor(t,o,n,d,l){super(),this.id=t,this.name=o,this.r=n,this.s=d,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(n.getLevel()),this.B(n.onDidChangeLogLevel(g=>this.setLevel(g)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Clear,t)}replace(t){const o=this.m;this.info(t),this.s.$update(this.id,T.OutputChannelUpdateMode.Replace,o),this.visible&&this.r.flush()}show(t,o){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:o))}hide(){this.s.$close(this.id)}g(t,o){this.m+=u.$Ne.fromString(o).byteLength,(0,O.log)(this.r,t,o),this.visible&&(this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class f extends ${appendLine(t){this.append(t)}}let i=class{constructor(t,o,n,d,l,g){this.i=o,this.j=n,this.k=d,this.l=l,this.m=g,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(r.$KN.MainThreadOutputService),this.b=this.k.extUri.joinPath(o.logsLocation,`output_logging_${(0,S.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[o,n]of this.g)n.visible=o===this.h}createOutputChannel(t,o,n){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const d=typeof o=="object"&&o.log,l=(0,P.$eg)(o)?o:void 0;if((0,P.$eg)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let g;const E=this.i.environment.extensionLogLevel?.find(([y])=>R.$rn.equals(n.identifier,y))?.[1];E&&(g=(0,O.$rk)(E));const D=d?this.o(t,g,n):this.n(t,l,n);return D.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),d?this.r(t,g??this.m.getLevel(),D):this.q(t,D)}async n(t,o,n){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,l=this.k.extUri.joinPath(d,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),g=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),E=await this.a.$register(t,l,o,n.identifier.value);return new $(E,t,g,this.a,n)}async o(t,o,n){const d=await this.p(n),l=t.replace(/[\\/:\*\?"<>\|]/g,""),g=this.k.extUri.joinPath(d,`${l}.log`),E=`${n.identifier.value}.${l}`,D=this.l.createLogger(g,{id:E,name:t,logLevel:o,extensionId:n.identifier.value});return new f(E,t,D,this.a,n)}p(t){let o=this.d.get(t.identifier.value);if(!o){const n=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,o=(async()=>{try{await this.j.value.createDirectory(n)}catch(d){if((0,w.$ql)(d)!==w.FileSystemProviderErrorCode.FileExists)throw d}return n})())}return o}q(t,o){let n=!1;const d=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return t},append(l){d(),o.then(g=>g.append(l))},appendLine(l){d(),o.then(g=>g.appendLine(l))},clear(){d(),o.then(l=>l.clear())},replace(l){d(),o.then(g=>g.replace(l))},show(l,g){d(),o.then(E=>E.show(l,g))},hide(){d(),o.then(l=>l.hide())},dispose(){n=!0,o.then(l=>l.dispose())}}}r(t,o,n){const d=new m.$Tc,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},g=d.add(new a.$le);function E(D){o=D,g.fire(D)}return n.then(D=>{d.add(D),D.logLevel!==o&&E(D.logLevel),d.add(D.onDidChangeLogLevel(y=>E(y)))}),{...this.q(t,n),get logLevel(){return o},onDidChangeLogLevel:g.event,trace(D,...y){l(),n.then(k=>k.trace(D,...y))},debug(D,...y){l(),n.then(k=>k.debug(D,...y))},info(D,...y){l(),n.then(k=>k.info(D,...y))},warn(D,...y){l(),n.then(k=>k.warn(D,...y))},error(D,...y){l(),n.then(k=>k.error(D,...y))},dispose(){d.dispose()}}}};e.$brc=i,e.$brc=i=Je([Ve(0,C.$kQ),Ve(1,c.$AQ),Ve(2,p.$Tpc),Ve(3,I.$wpc),Ve(4,O.$bk),Ve(5,O.$ak)],i),e.$crc=(0,h.$Fi)("IExtHostOutputService")}),define(ke[170],Ie([1,0,5,7]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=void 0,e.$Wm=(0,r.$Fi)("remoteAgentService"),e.$Xm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let R=1/0;for(let T=0;T<this.maxSampleCount;T++){const p=await C.getRoundTripTime();if(p===void 0)return;R=Math.min(R,p/2),await(0,h.$Gh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let O;return this.initial.length<this.maxInitialCount?this.initial.push(R):O=this.initial.reduce((T,p)=>T+p,0)/this.initial.length,this.lastMeasurement={initial:O,current:R,average:this.average.reduce((T,p)=>T+p,0)/this.average.length,high:typeof O>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>O*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[330],Ie([1,0,8,70,36,47,46,3,4,170,10,24,7,150]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=void 0,e.$dL=Object.freeze({id:"application",order:100,title:(0,r.localize)(12547,null),type:"object"}),e.$eL=Object.freeze({id:"workbench",order:7,title:(0,r.localize)(12548,null),type:"object"}),e.$fL=Object.freeze({id:"security",scope:h.ConfigurationScope.APPLICATION,title:(0,r.localize)(12549,null),type:"object",order:7}),e.$gL=Object.freeze({id:"problems",title:(0,r.localize)(12550,null),type:"object",order:101}),e.$hL=Object.freeze({id:"window",order:8,title:(0,r.localize)(12551,null),type:"object"}),e.$iL={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new p.$le,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(s){this.migrations.push(...s)}}const a=new w;C.$ro.add(e.$iL.ConfigurationMigration,a);let m=class extends T.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(s,t){super(),this.a=s,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const n of o.added)await this.f(n,a.migrations)})),this.c(a.migrations),this.B(a.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(s){await this.f(void 0,s);for(const t of this.b.getWorkspace().folders)await this.f(t,s)}async f(s,t){await Promise.all([t.map(o=>this.g(o,s?.uri))])}async g(s,t){const o=this.a.inspect(s.key,{resource:t}),n=this.b.getWorkbenchState()===R.WorkbenchState.WORKSPACE?[["user",O.ConfigurationTarget.USER],["userLocal",O.ConfigurationTarget.USER_LOCAL],["userRemote",O.ConfigurationTarget.USER_REMOTE],["workspace",O.ConfigurationTarget.WORKSPACE],["workspaceFolder",O.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",O.ConfigurationTarget.USER],["userLocal",O.ConfigurationTarget.USER_LOCAL],["userRemote",O.ConfigurationTarget.USER_REMOTE],["workspace",O.ConfigurationTarget.WORKSPACE]];for(const[d,l]of n){const g=o[d];if(!g)continue;const E=[];if(g.value!==void 0){const D=await this.h(s,d,g.value,t,void 0);for(const y of D??[])E.push([y,[]])}for(const{identifiers:D,value:y}of g.overrides??[])if(y!==void 0){const k=await this.h(s,d,y,t,D);for(const A of k??[])E.push([A,D])}E.length&&await Promise.allSettled(E.map(async([[D,y],k])=>this.a.updateValue(D,y.value,{resource:t,overrideIdentifiers:k},l)))}}async h(s,t,o,n,d){const l=E=>{const y=this.a.inspect(E,{resource:n})[t];if(y)return d?y.overrides?.find(({identifiers:k})=>(0,S.$io)(k,d))?.value:y.value},g=await s.migrateFn(o,l);return Array.isArray(g)?g:[[s.key,g]]}};e.$jL=m,e.$jL=m=Je([Ve(0,O.$_i),Ve(1,R.$Oi)],m);let $=class extends T.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(s){super(),this.b=s,this.a=new u.$3h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$j&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;C.$ro.as(h.$wo.Configuration).registerConfiguration({...e.$fL,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,r.localize)(12552,null)},default:[],markdownDescription:(0,r.localize)(12553,null),scope:h.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,r.localize)(12554,null),scope:h.ConfigurationScope.MACHINE}}})}};e.$kL=$,e.$kL=$=Je([Ve(0,c.$Wm)],$),e.$lL="window.newWindowProfile";let f=class extends T.$Uc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(s,t){super(),this.c=s,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(o=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(o=>{o.source!==O.ConfigurationTarget.DEFAULT&&o.affectsConfiguration(e.$lL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const s=C.$ro.as(h.$wo.Configuration),t={...e.$hL,properties:{[e.$lL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(o=>o.name),null],enumItemLabels:[...this.c.profiles.map(o=>""),(0,r.localize)(12555,null)],description:(0,r.localize)(12556,null),scope:h.ConfigurationScope.APPLICATION}}};this.a?s.updateConfigurations({add:[t],remove:[this.a]}):s.registerConfiguration(t),this.a=t}h(){const s=this.f.getValue(e.$lL);this.b=s?this.c.profiles.find(t=>t.name===s):void 0}j(){const s=this.f.getValue(e.$lL);if(!s)return;const t=this.b?this.c.profiles.find(o=>o.id===this.b.id):void 0;s!==t?.name&&this.f.updateValue(e.$lL,t?.name)}};e.$mL=f,e.$mL=f=Je([Ve(0,P.$Ml),Ve(1,O.$_i)],f)}),define(ke[331],Ie([1,0,38,14,16,22,8,330,70,5,36]),function($e,e,r,h,C,R,O,T,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$oL=e.$nL=void 0,e.$pL=a,e.$qL=m,r=qe(r),e.$nL=(0,c.$Fi)("editorResolverService"),e.$oL="workbench.editorAssociations";const S=I.$ro.as(p.$wo.Configuration),u={...T.$eL,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,O.localize)(2025,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(u);var P;(function($){$.builtin="builtin",$.option="option",$.exclusive="exclusive",$.default="default"})(P||(e.RegisteredEditorPriority=P={}));var w;(function($){$[$.ABORT=1]="ABORT",$[$.NONE=2]="NONE"})(w||(e.ResolvedStatus=w={}));function a($){switch($){case P.exclusive:return 5;case P.default:return 4;case P.builtin:return 3;case P.option:default:return 1}}function m($,f){if(new Set([h.Schemas.extension,h.Schemas.webviewPanel,h.Schemas.vscodeWorkspaceTrust,h.Schemas.vscodeSettings]).has(f.scheme))return!1;const t=typeof $=="string"&&$.indexOf(C.$gc.sep)>=0?`${f.scheme}:${f.path}`:(0,R.$dh)(f);return r.$zk(typeof $=="string"?$.toLowerCase():$,t.toLowerCase())}}),define(ke[332],Ie([1,0,31,14,16,10,22,2,5,247,47,158,170]),function($e,e,r,h,C,R,O,T,p,c,I,S,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=e.$mN=void 0,e.$mN=(0,p.$Fi)("pathService");let w=P=class{constructor(m,$,f,i){this.d=m,this.e=$,this.f=f,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const s=await this.e.getEnvironment();return this.c=s?.userHome??m})()}hasValidBasename(m,$,f){return typeof $=="string"||typeof $>"u"?this.a.then(i=>this.h(m,i,$)):this.h(m,$,f)}h(m,$,f){return m.scheme===h.Schemas.file||m.scheme===h.Schemas.vscodeRemote?(0,r.$Cg)(f??(0,O.$dh)(m),$===R.OperatingSystem.Windows):!0}get defaultUriScheme(){return P.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,$){if(m.remoteAuthority)return h.Schemas.vscodeRemote;const f=(0,c.$jN)($.getWorkspace());if(f)return f;const i=$.getWorkspace().folders[0];if(i)return i.uri.scheme;const s=$.getWorkspace().configuration;return s?s.scheme:h.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===R.OperatingSystem.Windows?C.$fc:C.$gc)}async fileURI(m){let $="";if(await this.a===R.OperatingSystem.Windows&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const i=m.indexOf("/",2);i===-1?($=m.substring(2),m="/"):($=m.substring(2,i),m=m.substring(i)||"/")}return T.URI.from({scheme:h.Schemas.file,authority:$,path:m,query:"",fragment:""})}};e.$nN=w,e.$nN=w=P=Je([Ve(1,u.$Wm),Ve(2,S.$8M),Ve(3,I.$Oi)],w)}),define(ke[333],Ie([1,0,8,59,4,60,3,2,46,216,11,71,151,92,47,158,25,20,17,24,35]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=e.$fN=e.OnPortForward=e.$aN=e.$_M=e.TunnelSource=e.TunnelCloseReason=e.$0M=e.$9M=void 0,e.$$M=l,e.$bN=D,e.$cN=y,e.$dN=k,e.$eN=b,r=qe(r);const t=10*1e3,o="remote.tunnels.toRestore",n="remote.tunnels.toRestoreExpiration",d=1e3*60*60*24*14;e.$9M="onTunnel",e.$0M=new s.$Wj("forwardedPortsViewEnabled",!1,r.localize(1639,null));function l(N){const L=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(L)return{host:L[1]?.substring(0,L[1].length-1)||"localhost",port:Number(L[2])}}var g;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(g||(e.TunnelCloseReason=g={}));var E;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(E||(e.TunnelSource=E={})),e.$_M={source:E.User,description:r.localize(1640,null)},e.$aN={source:E.Auto,description:r.localize(1641,null)};function D(N,L,M){const z=N.get(k(L,M));if(z)return z;if((0,P.$Kw)(L))for(const j of P.$Jw){const W=k(j,M);if(N.has(W))return N.get(W)}else if((0,P.$Mw)(L))for(const j of P.$Lw){const W=k(j,M);if(N.has(W))return N.get(W)}}function y(N,L,M){const z=D(N,L,M);if(z)return z;const j=(0,P.$Mw)(L)?"localhost":(0,P.$Kw)(L)?"0.0.0.0":void 0;if(j)return D(N,j,M)}function k(N,L){return N+":"+L}var A;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})(A||(e.OnPortForward=A={}));function b(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}class v extends O.$Uc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(L){super(),this.r=L,this.j=[],this.n=new C.$le,this.onDidChangeAttributes=this.n.event,this.B(L.onDidChangeConfiguration(M=>{(M.affectsConfiguration(v.c)||M.affectsConfiguration(v.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(L,M,z){let j=this.w(L,M,z,this.j,0);const W={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;j>=0;){const B=this.j[j];B.key===L?(W.onAutoForward=B.onAutoForward??W.onAutoForward,W.elevateIfNeeded=B.elevateIfNeeded!==void 0?B.elevateIfNeeded:W.elevateIfNeeded,W.label=B.label??W.label,W.requireLocalPort=B.requireLocalPort,W.protocol=B.protocol):(W.onAutoForward=W.onAutoForward??B.onAutoForward,W.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:B.elevateIfNeeded,W.label=W.label??B.label,W.requireLocalPort=W.requireLocalPort!==void 0?W.requireLocalPort:void 0,W.protocol=W.protocol??B.protocol),j=this.w(L,M,z,this.j,j+1)}return W.onAutoForward!==void 0||W.elevateIfNeeded!==void 0||W.label!==void 0||W.requireLocalPort!==void 0||W.protocol!==void 0?W:this.C()}t(L){return L.start!==void 0&&L.end!==void 0}u(L){return L.host!==void 0&&L.port!==void 0&&(0,f.$eg)(L.host)&&(0,f.$ig)(L.port)}w(L,M,z,j,W){if(W>=j.length)return-1;const B=!(0,P.$Kw)(M)&&!(0,P.$Mw)(M),H=j.slice(W).findIndex(q=>(0,f.$ig)(q.key)?B?!1:q.key===L:this.t(q.key)?B?!1:L>=q.key.start&&L<=q.key.end:this.u(q.key)?L===q.key.port&&M===q.key.host:z?q.key.test(z):!1);return H>=0?H+W:-1}y(){const L=this.r.getValue(v.c);if(!L||!(0,f.$gg)(L))return[];const M=[];for(const j in L){if(j===void 0)continue;const W=L[j];let B;if(Number(j))B=Number(j);else if((0,f.$eg)(j))if(v.g.test(j)){const ee=j.match(v.g);B={start:Number(ee[1]),end:Number(ee[2])}}else if(v.h.test(j)){const ee=j.match(v.h);B={host:ee[1],port:Number(ee[2])}}else{let ee;try{ee=RegExp(j)}catch{}ee&&(B=ee)}B&&M.push({key:B,elevateIfNeeded:W.elevateIfNeeded,onAutoForward:W.onAutoForward,label:W.label,requireLocalPort:W.requireLocalPort,protocol:W.protocol})}const z=this.r.getValue(v.f);return z&&(this.m={elevateIfNeeded:z.elevateIfNeeded,label:z.label,onAutoForward:z.onAutoForward,requireLocalPort:z.requireLocalPort,protocol:z.protocol}),this.z(M)}z(L){function M(z,j){return(0,f.$ig)(z.key)?z.key:j.t(z.key)?z.key.start:j.u(z.key)?z.key.port:Number.MAX_VALUE}return L.sort((z,j)=>M(z,this)-M(j,this))}C(){return this.m}static providedActionToAction(L){switch(L){case P.ProvidedOnAutoForward.Notify:return A.Notify;case P.ProvidedOnAutoForward.OpenBrowser:return A.OpenBrowser;case P.ProvidedOnAutoForward.OpenBrowserOnce:return A.OpenBrowserOnce;case P.ProvidedOnAutoForward.OpenPreview:return A.OpenPreview;case P.ProvidedOnAutoForward.Silent:return A.Silent;case P.ProvidedOnAutoForward.Ignore:return A.Ignore;default:return}}async addAttributes(L,M,z){const W=this.r.inspect(v.c).userRemoteValue;let B;!W||!(0,f.$gg)(W)?B={}:B=(0,i.$eo)(W),B[`${L}`]||(B[`${L}`]={});for(const ee in M)B[`${L}`][ee]=M[ee];return this.r.updateValue(v.c,B,z)}}e.$fN=v;let F=class extends O.$Uc{constructor(L,M,z,j,W,B,ee,H,q,Q){super(),this.H=L,this.I=M,this.J=z,this.L=j,this.M=W,this.N=B,this.O=ee,this.P=H,this.Q=q,this.R=Q,this.c=new Map,this.g=new C.$le,this.onForwardPort=this.g.event,this.h=new C.$le,this.onClosePort=this.h.event,this.j=new C.$le,this.onPortName=this.j.event,this.n=new C.$le,this.onCandidatesChanged=this.n.event,this.t=new C.$le,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new C.$le,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new v(z),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async _=>{const ce=await this.getAttributes(_.map(ne=>({port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost})));for(const ne of _)if(ne.localAddress){const ye=k(ne.tunnelRemoteHost,ne.tunnelRemotePort),ge=y(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort);this.forwarded.set(ye,{remotePort:ne.tunnelRemotePort,remoteHost:ne.tunnelRemoteHost,localAddress:ne.localAddress,protocol:ce?.get(ne.tunnelRemotePort)?.protocol??P.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,ce?.get(ne.tunnelRemotePort)),localPort:ne.tunnelLocalPort,name:ce?.get(ne.tunnelRemotePort)?.label,runningProcess:ge?.detail,hasRunningProcess:!!ge,pid:ge?.pid,privacy:ne.privacy,source:e.$_M}),this.f.set(ye,ne)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async _=>{const ce=k(_.tunnelRemoteHost,_.tunnelRemotePort);if(!y(this.forwarded,_.tunnelRemoteHost,_.tunnelRemotePort)&&!y(this.detected,_.tunnelRemoteHost,_.tunnelRemotePort)&&!y(this.c,_.tunnelRemoteHost,_.tunnelRemotePort)&&_.localAddress){const ne=y(this.m??new Map,_.tunnelRemoteHost,_.tunnelRemotePort),ye=(await this.getAttributes([{port:_.tunnelRemotePort,host:_.tunnelRemoteHost}]))?.get(_.tunnelRemotePort);this.forwarded.set(ce,{remoteHost:_.tunnelRemoteHost,remotePort:_.tunnelRemotePort,localAddress:_.localAddress,protocol:ye?.protocol??P.TunnelProtocol.Http,localUri:await this.X(_.localAddress,ye),localPort:_.tunnelLocalPort,name:ye?.label,closeable:!0,runningProcess:ne?.detail,hasRunningProcess:!!ne,pid:ne?.pid,privacy:_.privacy,source:e.$_M})}await this.cb(),this.f.set(ce,_),this.g.fire(this.forwarded.get(ce))})),this.B(this.H.onTunnelClosed(_=>this.W(_,g.Other))),this.U()}S(){return this.Q.extensions.find(L=>L.activationEvents?.includes(e.$9M))?(this.R.createKey(e.$0M.key,!0),!0):!1}U(){if(this.S())return;const L=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&L.dispose()}))}async W(L,M){const z=k(L.host,L.port);this.forwarded.has(z)&&(this.forwarded.delete(z),await this.cb(),this.h.fire(L))}X(L,M){if(L.startsWith("http"))return T.URI.parse(L);const z=M?.protocol??"http";return T.URI.parse(`${z}://${L}`)}async Y(L){const M=this.N.getWorkspace(),z=M.configuration?(0,R.$tj)(M.configuration.path):M.folders.length>0?(0,R.$tj)(M.folders[0].uri.path):void 0;if(z===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${L}.${this.L.remoteAuthority}.${z}`}async Z(){return this.Y(o)}async $(){return this.Y(n)}async ab(){const L=this.I.get(o,u.StorageScope.WORKSPACE);if(L)return this.I.remove(o,u.StorageScope.WORKSPACE),await this.cb(),L;const M=await this.Z();if(M)return this.I.get(M,u.StorageScope.PROFILE)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const L=await this.s;if(L&&L!==this.y){const M=JSON.parse(L)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(z=>z.remotePort).join(", ")}`);for(const z of M){const j=y(this.detected,z.remoteHost,z.remotePort);z.source.source!==E.Extension&&!j||z.source.source===E.Extension&&j?await this.fb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,elevateIfNeeded:!0,source:z.source}):z.source.source===E.Extension&&!j&&this.D.set(k(z.remoteHost,z.remotePort),z)}}}if(this.z=!0,this.C.fire(),!this.w){const L=await this.Z();this.w=this.B(new O.$Tc),this.w.add(this.I.onDidChangeValue(u.StorageScope.PROFILE,void 0,this.w)(async M=>{M.key===L&&(this.s=Promise.resolve(this.I.get(L,u.StorageScope.PROFILE)),await this.restoreForwarded())}))}}bb(){const L=this.I.keys(u.StorageScope.PROFILE,u.StorageTarget.USER).filter(M=>M.startsWith(n));for(const M of L){const z=this.I.getNumber(M,u.StorageScope.PROFILE);if(z&&z<Date.now()){this.s=Promise.resolve(void 0);const j=M.replace(n,o);this.I.remove(M,u.StorageScope.PROFILE),this.I.remove(j,u.StorageScope.PROFILE)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const L=Array.from(this.forwarded.values()),M=L.map(B=>({remoteHost:B.remoteHost,remotePort:B.remotePort,localPort:B.localPort,name:B.name,localAddress:B.localAddress,localUri:B.localUri,protocol:B.protocol,source:B.source}));let z;L.length>0&&(z=JSON.stringify(M));const j=await this.Z(),W=await this.$();!z&&j&&W?(this.I.remove(j,u.StorageScope.PROFILE),this.I.remove(W,u.StorageScope.PROFILE)):z!==this.y&&j&&W&&(this.I.store(j,z,u.StorageScope.PROFILE,u.StorageTarget.USER),this.I.store(W,Date.now()+d,u.StorageScope.PROFILE,u.StorageTarget.USER)),this.y=z}}async eb(L,M,z){if(!L.tunnelLocalPort||!z?.requireLocalPort||L.tunnelLocalPort===M)return;const j=new Date;if(this.db.getTime()+t>j.getTime())return;this.db=j;const W=r.localize(1642,null,M,L.tunnelRemotePort,L.tunnelLocalPort);return this.P.info(W)}async forward(L,M){return!this.z&&this.L.remoteAuthority&&await C.Event.toPromise(this.C.event),this.fb(L,M)}async fb(L,M){await this.Q.activateByEvent(e.$9M);const z=y(this.forwarded,L.remote.host,L.remote.port);M=M??(M!==null?(await this.getAttributes([L.remote]))?.get(L.remote.port):void 0);const j=L.local!==void 0?L.local:L.remote.port;let W;if(z)return this.hb(z,L,M);{const B=this.L.remoteAuthority,ee=B?{getAddress:async()=>(await this.M.resolveAuthority(B)).authority}:void 0,H=k(L.remote.host,L.remote.port);this.c.set(H,!0),L=this.gb(H,L);const q=await this.H.openTunnel(ee,L.remote.host,L.remote.port,void 0,j,L.elevateIfNeeded?L.elevateIfNeeded:M?.elevateIfNeeded,L.privacy,M?.protocol);if(typeof q=="string")W=q;else if(q&&q.localAddress){const Q=y(this.m??new Map,L.remote.host,L.remote.port),_=q.protocol?q.protocol===P.TunnelProtocol.Https?P.TunnelProtocol.Https:P.TunnelProtocol.Http:M?.protocol??P.TunnelProtocol.Http,ce={remoteHost:q.tunnelRemoteHost,remotePort:q.tunnelRemotePort,localPort:q.tunnelLocalPort,name:M?.label??L.name,closeable:!0,localAddress:q.localAddress,protocol:_,localUri:await this.X(q.localAddress,M),runningProcess:Q?.detail,hasRunningProcess:!!Q,pid:Q?.pid,source:L.source??e.$_M,privacy:q.privacy};return this.forwarded.set(H,ce),this.f.set(H,q),this.c.delete(H),await this.cb(),await this.eb(q,j,M),this.g.fire(ce),q}this.c.delete(H)}return W}gb(L,M){const z=this.D.has(L)?this.D:this.F.has(L)?this.F:void 0;if(z){const j=z.get(L);z.delete(L),j&&(M.name=j.name??M.name,M.local=("local"in j?j.local:"localPort"in j?j.localPort:void 0)??M.local,M.privacy=M.privacy)}return M}async hb(L,M,z){const j=z?.label??M.name;let W;(function(ee){ee[ee.None=0]="None",ee[ee.Fire=1]="Fire",ee[ee.Reopen=2]="Reopen"})(W||(W={}));let B=W.None;switch(j!==L.name&&(L.name=j,B=W.Fire),(z?.protocol||L.protocol!==P.TunnelProtocol.Http)&&z?.protocol!==L.protocol&&(M.source=L.source,B=W.Reopen),M.privacy&&L.privacy!==M.privacy&&(B=W.Reopen),B){case W.Fire:{this.g.fire();break}case W.Reopen:await this.close(L.remoteHost,L.remotePort,g.User),await this.fb(M,z)}return y(this.f,M.remote.host,M.remote.port)}async name(L,M,z){const j=y(this.forwarded,L,M),W=k(L,M);if(j){j.name=z,await this.cb(),this.j.fire({host:L,port:M});return}else this.detected.has(W)&&(this.detected.get(W).name=z,this.j.fire({host:L,port:M}))}async close(L,M,z){const j=k(L,M),W=this.forwarded.get(j);return z===g.AutoForwardEnd&&W&&W.source.source===E.Auto&&this.F.set(j,{local:W.localPort,name:W.name,privacy:W.privacy}),await this.H.closeTunnel(L,M),this.W({host:L,port:M},z)}address(L,M){const z=k(L,M);return(this.forwarded.get(z)||this.detected.get(z))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(L){if(L)for(const M of L){const z=y(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),j=typeof M.localAddress=="string"?M.localAddress:k(M.localAddress.host,M.localAddress.port);this.detected.set(k(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:j,protocol:P.TunnelProtocol.Http,localUri:this.X(j),closeable:!1,runningProcess:z?.detail,hasRunningProcess:!!z,pid:z?.pid,privacy:P.TunnelPrivacyId.ConstantPrivate,source:{source:E.Extension,description:r.localize(1643,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,j,P.TunnelPrivacyId.ConstantPrivate,P.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(L){this.r=L}async setCandidates(L){let M=L;this.r&&(M=await this.r(L));const z=this.ib(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(z.values()).map(j=>j.port).join(", ")}`),this.n.fire(z)}ib(L){const M=this.m??new Map,z=new Map;return this.m=z,L.forEach(j=>{const W=k(j.host,j.port);z.set(W,{host:j.host,port:j.port,detail:j.detail,pid:j.pid}),M.has(W)&&M.delete(W);const B=y(this.forwarded,j.host,j.port);B&&(B.runningProcess=j.detail,B.hasRunningProcess=!0,B.pid=j.pid)}),M.forEach((j,W)=>{const B=l(W);if(!B)return;const ee=y(this.forwarded,B.host,B.port);ee&&(ee.runningProcess=void 0,ee.hasRunningProcess=!1,ee.pid=void 0);const H=y(this.detected,B.host,B.port);H&&(H.runningProcess=void 0,H.hasRunningProcess=!1,H.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const L=Array.from(this.forwarded.values()),M=await this.getAttributes(L.map(z=>({port:z.remotePort,host:z.remoteHost})),!1);if(M)for(const z of L){const j=M.get(z.remotePort);(j?.protocol||z.protocol!==P.TunnelProtocol.Http)&&j?.protocol!==z.protocol&&await this.fb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,source:z.source},j),j&&j.label&&j.label!==z.name&&await this.name(z.remoteHost,z.remotePort,j.label)}}async getAttributes(L,M=!0){const z=new Map,j=new Map;L.forEach(q=>{const Q=y(this.m??new Map,P.$Jw[0],q.port)??q;if(Q){z.set(q.port,Q);const _=b(Q)?Q.pid:void 0;j.has(_)||j.set(_,[]),j.get(_)?.push(q.port)}});const W=new Map;if(L.forEach(q=>{const Q=this.configPortsAttributes.getAttributes(q.port,q.host,z.get(q.port)?.detail);Q&&W.set(q.port,Q)}),this.G.length===0||!M)return W.size>0?W:void 0;const B=await Promise.all(this.G.flatMap(q=>Array.from(j.entries()).map(Q=>{const _=Q[1],ce=z.get(_[0]);return q.providePortAttributes(_,ce?.pid,ce?.detail,$.CancellationToken.None)}))),ee=new Map;if(B.forEach(q=>q.forEach(Q=>{Q&&ee.set(Q.port,Q)})),!W&&!ee)return;const H=new Map;return L.forEach(q=>{const Q=W.get(q.port),_=ee.get(q.port);H.set(q.port,{elevateIfNeeded:Q?.elevateIfNeeded,label:Q?.label,onAutoForward:Q?.onAutoForward??v.providedActionToAction(_?.autoForwardAction),requireLocalPort:Q?.requireLocalPort,protocol:Q?.protocol})}),H}addAttributesProvider(L){this.G.push(L)}};e.$gN=F,Je([(0,h.$$h)(1e3)],F.prototype,"cb",null),e.$gN=F=Je([Ve(0,P.$Ew),Ve(1,u.$iq),Ve(2,p.$_i),Ve(3,a.$8M),Ve(4,S.$Rl),Ve(5,w.$Oi),Ve(6,I.$ak),Ve(7,c.$0w),Ve(8,m.$cH),Ve(9,s.$Xj)],F)}),define(ke[99],Ie([1,0,18]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageTypeNew=e.ExcludeSettingOptions=e.$ZL=e.$YL=e.TextSearchCompleteMessageType=e.$XL=e.$WL=void 0,e.$1L=S;class h{constructor(P,w){this.line=P,this.character=w}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,w){return new h(0,0)}with(P){return new h(0,0)}}e.$WL=h;class C{constructor(P,w,a,m){this.isEmpty=!1,this.isSingleLine=!1,this.start=new h(P,w),this.end=new h(a,m)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new C(0,0,0,0)}with(P){return new C(0,0,0,0)}}e.$XL=C;var R;(function(u){u[u.Information=1]="Information",u[u.Warning=2]="Warning"})(R||(e.TextSearchCompleteMessageType=R={}));class O{constructor(P,w,a){this.uri=P,this.ranges=w,this.previewText=a}}e.$YL=O;class T{constructor(P,w,a){this.uri=P,this.text=w,this.lineNumber=a}}e.$ZL=T;var p;(function(u){u[u.none=1]="none",u[u.filesExclude=2]="filesExclude",u[u.searchAndFilesExclude=3]="searchAndFilesExclude"})(p||(e.ExcludeSettingOptions=p={}));var c;(function(u){u[u.Information=1]="Information",u[u.Warning=2]="Warning"})(c||(e.TextSearchCompleteMessageTypeNew=c={}));function I(u){return"uri"in u&&"ranges"in u&&"preview"in u}function S(u){if(I(u)){const P=(0,r.$1b)(u.ranges).map(w=>({sourceRange:w,previewRange:w}));return new O(u.uri,P,u.preview.text)}else return new T(u.uri,u.text,u.lineNumber)}}),define(ke[37],Ie([1,0,18,38,24,31,12,5,16,13,99,7]),function($e,e,r,h,C,R,O,T,p,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oM=e.$mM=e.$fM=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$cM=e.$bM=e.$aM=e.$_L=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.TextSearchCompleteMessageType=void 0,e.$9L=$,e.$0L=f,e.$$L=i,e.$dM=D,e.$eM=y,e.$gM=b,e.$hM=v,e.$iM=F,e.$jM=N,e.$kM=L,e.$lM=M,e.$nM=j,e.$pM=ee,e.$qM=H,h=qe(h),C=qe(C),R=qe(R),p=qe(p),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$2L="workbench.view.search",e.$3L="workbench.panel.search",e.$4L="workbench.view.search",e.$5L="search-result",e.$6L="search.exclude",e.$7L=2e4;const u="\u27EA ",P=" characters skipped \u27EB",w=(u.length+P.length+5)*2;e.$8L=(0,T.$Fi)("searchService");var a;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text",Q[Q.aiText=2]="aiText"})(a||(e.SearchProviderType=a={}));var m;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text",Q[Q.aiText=3]="aiText"})(m||(e.QueryType=m={}));function $(Q){return!!Q.preview}function f(Q){return!!Q.resource}function i(Q){return!!Q.message}var s;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class t{constructor(_){this.resource=_,this.results=[]}}e.$_L=t;class o{constructor(_,ce,ne,ye){this.ranges=ce,this.webviewIndex=ye;const ge=Array.isArray(ce)?ce:[ce];if(ne&&ne.matchLines===1&&n(ge)){_=(0,O.$0f)(_,ne.matchLines);let Y="",U=0,oe=0;const ve=Math.floor(ne.charsPerLine/5),te=[];for(const ae of ge){const se=Math.max(ae.startColumn-ve,0),X=ae.startColumn+ne.charsPerLine;if(se>oe+ve+w){const re=u+(se-oe)+P;Y+=re+_.slice(se,X),U+=se-(oe+re.length)}else Y+=_.slice(oe,X);te.push(new l(0,ae.startColumn-U,ae.endColumn-U)),oe=X}this.preview={text:Y,matches:Array.isArray(this.ranges)?te:te[0]}}else{const Y=Array.isArray(ce)?ce[0].startLineNumber:ce.startLineNumber;this.preview={text:_,matches:(0,r.$Zb)(ce,U=>new d(U.startLineNumber-Y,U.startColumn,U.endLineNumber-Y,U.endColumn))}}}}e.$aM=o;function n(Q){const _=Q[0].startLineNumber;for(const ce of Q)if(ce.startLineNumber!==_||ce.endLineNumber!==_)return!1;return!0}class d{constructor(_,ce,ne,ye){this.startLineNumber=_,this.startColumn=ce,this.endLineNumber=ne,this.endColumn=ye}}e.$bM=d;class l extends d{constructor(_,ce,ne){super(_,ce,_,ne)}}e.$cM=l;var g;(function(Q){Q.List="list",Q.Tree="tree"})(g||(e.ViewMode=g={}));var E;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(E||(e.SearchSortOrder=E={}));function D(Q,_=!0){const ce=Q&&Q.files&&Q.files.exclude,ne=_&&Q&&Q.search&&Q.search.exclude;if(!ce&&!ne)return;if(!ce||!ne)return ce||ne||void 0;let ye=Object.create(null);return ye=C.$ho(ye,C.$eo(ce)),ye=C.$ho(ye,C.$eo(ne),!0),ye}function y(Q,_){return Q.excludePattern&&h.$zk(Q.excludePattern,_)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&h.$zk(Q.includePattern,_)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(ce=>{const ne=ce.folder.fsPath;if(R.$Eg(_,ne)){const ye=p.$lc(ne,_);return!ce.includePattern||!!h.$zk(ce.includePattern,ye)}else return!1}):!1:!0}var k;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})(k||(e.SearchErrorCode=k={}));class A extends Error{constructor(_,ce){super(_),this.code=ce}}e.$fM=A;function b(Q){const _=Q.message;if((0,c.$3)(Q))return new A(_,k.canceled);try{const ce=JSON.parse(_);return new A(ce.message,ce.code)}catch{return new A(_,k.other)}}function v(Q){const _={message:Q.message,code:Q.code};return new Error(JSON.stringify(_))}function F(Q){return Q.type==="error"?!0:Q.type==="success"}function N(Q){return Q.type==="success"}function L(Q){return!!Q.path}function M(Q,_,ce=!0){const ne=Q.searchPath?Q.searchPath:Q.relativePath;return ce?(0,O.$7f)(ne,_):h.$zk(_,ne)}class z{constructor(_){this.path=_,this.results=[]}addMatch(_){this.results.push(_)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$mM=z;function j(Q,_){const ce={...Q||{},..._||{}};return Object.keys(ce).filter(ne=>{const ye=ce[ne];return typeof ye=="boolean"&&ye})}class W{constructor(_,ce){this.c=null,this.a={..._.excludePattern||{},...ce.excludePattern||{}},this.b=h.$Ak(this.a);let ne=_.includePattern;ce.includePattern&&(ne?ne={...ne,...ce.includePattern}:ne=ce.includePattern),ne&&(this.c=h.$Ak(ne))}matchesExcludesSync(_,ce,ne){return!!(this.b&&this.b(_,ce,ne))}includedInQuerySync(_,ce,ne){return!(this.b&&this.b(_,ce,ne)||this.c&&!this.c(_,ce,ne))}includedInQuery(_,ce,ne){const ye=this.b(_,ce,ne),ge=()=>this.c?!!this.c(_,ce,ne):!0;return(0,S.$rh)(ye)?ye.then(Y=>Y?!1:ge()):ge()}hasSiblingExcludeClauses(){return B(this.a)}}e.$oM=W;function B(Q){for(const _ in Q)if(typeof Q[_]!="boolean")return!0;return!1}function ee(Q){if(!Q)return;let _;return ce=>(_||(_=(Q()||Promise.resolve([])).then(ne=>ne?q(ne):{})),_.then(ne=>!!ne[ce]))}function H(Q){if(!Q)return;let _;return ce=>{if(!_){const ne=Q();_=ne?q(ne):{}}return!!_[ce]}}function q(Q){const _={};for(const ce of Q)_[ce]=!0;return _}}),define(ke[49],Ie([1,0,18,7,20,4,3,84,14,133,22,12,2,8,27,5,11,230,47,62,29,19,15,9,72,37,6,44]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Opc=e.$Npc=void 0;function D(L,M,z){return new I.$8g(j=>b(j,z)).isEqual(L,M)}function y(L,M,z){return D(L.uri,M.uri,z)?0:(0,S.$yf)(L.uri.toString(),M.uri.toString())}function k(L,M,z){return L.index!==M.index?L.index<M.index?-1:1:D(L.uri,M.uri,z)?(0,S.$yf)(L.name,M.name):(0,S.$yf)(L.uri.toString(),M.uri.toString())}function A(L,M,z,j){const W=L.slice(0).sort((ee,H)=>z(ee,H,j)),B=M.slice(0).sort((ee,H)=>z(ee,H,j));return(0,r.$Db)(W,B,(ee,H)=>z(ee,H,j))}function b(L,M){const z=M.getCapabilities(L.scheme);return!(z&&z&w.FileSystemProviderCapabilities.PathCaseSensitive)}class v extends f.$Yi{static toExtHostWorkspace(M,z,j,W){if(!M)return{workspace:null,added:[],removed:[]};const{id:B,name:ee,folders:H,configuration:q,transient:Q,isUntitled:_}=M,ce=[],ne=z;z?H.forEach((U,oe)=>{const ve=u.URI.revive(U.uri),te=v.o(j||z,ve,W);te?(te.name=U.name,te.index=U.index,ce.push(te)):ce.push({uri:ve,name:U.name,index:oe})}):ce.push(...H.map(({uri:U,name:oe,index:ve})=>({uri:u.URI.revive(U),name:oe,index:ve}))),ce.sort((U,oe)=>U.index<oe.index?-1:1);const ye=new v(B,ee,ce,!!Q,q?u.URI.revive(q):null,!!_,U=>b(U,W)),{added:ge,removed:Y}=A(ne?ne.workspaceFolders:[],ye.workspaceFolders,y,W);return{workspace:ye,added:ge,removed:Y}}static o(M,z,j){for(let W=0;W<M.folders.length;W++){const B=M.workspaceFolders[W];if(D(B.uri,z,j))return B}}constructor(M,z,j,W,B,ee,H){super(M,j.map(q=>new f.$Zi(q)),W,B,H),this.t=z,this.u=ee,this.q=[],this.s=T.$Li.forUris(H,()=>!0),j.forEach(q=>{this.q.push(q),this.s.set(q.uri,q)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(M,z){return z&&this.s.get(M)&&(M=(0,I.$fh)(M)),this.s.findSubstr(M)}resolveWorkspaceFolder(M){return this.s.get(M)}}let F=class{constructor(M,z,j,W,B){this.c=new R.$le,this.onDidChangeWorkspace=this.c.event,this.g=new R.$le,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$ne,this.C=new Map,this.h=W,this.s=j,this.t=B,this.j=new c.$Nm,this.k=new h.$Eh,this.o=M.getProxy(g.$KN.MainThreadWorkspace),this.q=M.getProxy(g.$KN.MainThreadMessageService);const ee=z.workspace;this.l=ee?new v(ee.id,ee.name,[],!!ee.transient,ee.configuration?u.URI.revive(ee.configuration):null,!!ee.isUntitled,H=>b(H,j)):void 0}$initializeWorkspace(M,z){this.v=z,this.$acceptWorkspaceData(M),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:p.Schemas.untitled,path:(0,I.$dh)((0,I.$fh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(M,z,j,...W){const B=[];if(Array.isArray(W)&&W.forEach(_=>{u.URI.isUri(_.uri)&&!B.some(ce=>D(ce.uri,_.uri,this.s))&&B.push({uri:_.uri,name:_.name||(0,I.$ch)(_.uri)})}),this.n||[z,j].some(_=>typeof _!="number"||_<0)||j===0&&B.length===0)return!1;const ee=this.x?this.x.workspaceFolders:[];if(z+j>ee.length)return!1;const H=ee.slice(0);H.splice(z,j,...B.map(_=>({uri:_.uri,name:_.name||(0,I.$ch)(_.uri),index:void 0})));for(let _=0;_<H.length;_++){const ce=H[_];if(H.some((ne,ye)=>ye!==_&&D(ce.uri,ne.uri,this.s)))return!1}H.forEach((_,ce)=>_.index=ce);const{added:q,removed:Q}=A(ee,H,k,this.s);if(q.length===0&&Q.length===0)return!1;if(this.o){const _=M.displayName||M.name;this.o.$updateWorkspaceFolders(_,z,j,B).then(void 0,ce=>{this.n=void 0;const ne={source:{identifier:M.identifier,label:M.displayName||M.name}};this.q.$showMessage($.Severity.Error,(0,P.localize)(10820,null,_,ce.toString()),ne,[])})}return this.y(H),!0}getWorkspaceFolder(M,z){if(this.x)return this.x.getWorkspaceFolder(M,z)}async getWorkspaceFolder2(M,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(M,z)}async resolveWorkspaceFolder(M){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(M)}getPath(){if(!this.x)return;const{folders:M}=this.x;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,z){let j,W="";if(typeof M=="string"?(j=u.URI.file(M),W=M):typeof M<"u"&&(j=M,W=M.fsPath),!j)return W;const B=this.getWorkspaceFolder(j,!0);if(!B)return W;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let ee=(0,I.$ih)(B.uri,j);return z&&B.name&&(ee=`${B.name}/${ee}`),ee}y(M){this.x&&(this.n=v.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:M,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:z,added:j,removed:W}=v.toExtHostWorkspace(M,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:W}))}findFiles(M,z,j,W,B=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${W.value}, entryPoint: findFiles`);let ee="",H=!0;return z===null?H=!1:z!==void 0&&(typeof z=="string"?ee=z:ee=z.pattern),this.z(M,void 0,{exclude:ee,maxResults:j,useDefaultExcludes:H,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},B)}findFiles2(M,z={},j,W=C.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${j.value}, entryPoint: findFiles2`),this.z(void 0,M,z,W)}async z(M,z,j,W=C.CancellationToken.None){if(W&&W.isCancellationRequested)return Promise.resolve([]);const B=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,ee={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof j.useDefaultSearchExcludes=="boolean"?!j.useDefaultSearchExcludes:!1,maxResults:j.maxResults,excludePattern:B,shouldGlobSearch:typeof j.fuzzy=="boolean"?!j.fuzzy:!0,_reason:"startFileSearch"};let H;if(M){const{includePattern:q,folder:Q}=N(o.GlobPattern.from(M));H=Q,ee.includePattern=q}else{const{includePattern:q,folder:Q}=N(o.GlobPattern.from(z));H=Q,ee.filePattern=q}return this.o.$startFileSearch(H??null,ee,W).then(q=>Array.isArray(q)?q.map(Q=>u.URI.revive(Q)):[])}async findTextInFiles(M,z,j,W,B=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${W.value}, entryPoint: findTextInFiles`);const ee=this.j.getNext(),H=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:q,folder:Q}=N(o.GlobPattern.from(z.include)),_=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ce={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,disregardSearchExcludeSettings:typeof z.useSearchExclude=="boolean"?!z.useSearchExclude:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:H,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:q,excludePattern:_},ne=!1;if(this.u[ee]=ye=>{if(ne)return;const ge=u.URI.revive(ye.resource);ye.results.forEach(Y=>{const U=(0,E.$ci)(Y);(0,l.$9L)(U)?j({uri:ge,preview:{text:U.preview.text,matches:(0,r.$Zb)(U.preview.matches,oe=>new n.$ON(oe.startLineNumber,oe.startColumn,oe.endLineNumber,oe.endColumn))},ranges:(0,r.$Zb)(U.ranges,oe=>new n.$ON(oe.startLineNumber,oe.startColumn,oe.endLineNumber,oe.endColumn))}):j({uri:ge,text:U.text,lineNumber:U.lineNumber})})},B.isCancellationRequested)return{};try{const ye=await this.o.$startTextSearch(M,Q??null,ce,ee,B);return delete this.u[ee],ye||{}}catch(ye){throw delete this.u[ee],ye}}$handleTextSearchResult(M,z){this.u[z]?.(M)}async save(M){const z=await this.o.$save(M,{saveAs:!1});return u.URI.revive(z)}async saveAs(M){const z=await this.o.$save(M,{saveAs:!0});return u.URI.revive(z)}saveAll(M){return this.o.$saveAll(M)}resolveProxy(M){return this.o.$resolveProxy(M)}lookupAuthorization(M){return this.o.$lookupAuthorization(M)}lookupKerberosAuthorization(M){return this.o.$lookupKerberosAuthorization(M)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(M){return this.o.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(M,z){if(this.w.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.w.set(M,z);const j=this.t.transformOutgoingScheme(M),W=this.A++;return this.o.$registerEditSessionIdentityProvider(W,j),(0,O.$Sc)(()=>{this.w.delete(M),this.o.$unregisterEditSessionIdentityProvider(W)})}async $getEditSessionIdentifier(M,z){this.h.info("Getting edit session identifier for workspaceFolder",M);const j=await this.resolveWorkspaceFolder(u.URI.revive(M));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const W=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!W),!W)return;const B=await W.provideEditSessionIdentity(j,z);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(M,z,j,W){this.h.info("Getting edit session identifier for workspaceFolder",M);const B=await this.resolveWorkspaceFolder(u.URI.revive(M));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const ee=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!ee),!ee)return;const H=await ee.provideEditSessionIdentityMatch?.(z,j,W);if(this.h.info("Provider returned edit session identifier match result: ",H),!!H)return H}getOnWillCreateEditSessionIdentityEvent(M){return(z,j,W)=>{const B=function(H){z.call(j,H)};return B.extension=M,this.B.event(B,void 0,W)}}async $onWillCreateEditSessionIdentity(M,z,j){const W=await this.resolveWorkspaceFolder(u.URI.revive(M));if(W===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:W},z,async(B,ee)=>{const H=Date.now();await Promise.resolve(B),Date.now()-H>j&&this.h.warn("SLOW edit session create-participant",ee.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(M,z){if(this.C.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.C.set(M,z);const j=this.t.transformOutgoingScheme(M),W=this.A++;return this.o.$registerCanonicalUriProvider(W,j),(0,O.$Sc)(()=>{this.C.delete(M),this.o.$unregisterCanonicalUriProvider(W)})}async provideCanonicalUri(M,z,j){const W=this.C.get(M.scheme);if(!W)return;const B=await W.provideCanonicalUri?.(u.URI.revive(M),z,j);if(B)return B}async $provideCanonicalUri(M,z,j){return this.provideCanonicalUri(u.URI.revive(M),{targetScheme:z},j)}};e.$Npc=F,e.$Npc=F=Je([Ve(0,t.$kQ),Ve(1,s.$AQ),Ve(2,i.$wpc),Ve(3,m.$ak),Ve(4,d.$Lpc)],F),e.$Opc=(0,a.$Fi)("IExtHostWorkspace");function N(L){let M,z;return L&&(typeof L=="string"?M=L:(M=L.pattern,z=u.URI.revive(L.baseUri))),{includePattern:M,folder:z}}}),define(ke[41],Ie([1,0,24,4,49,6,9,46,232,70,17,7,5,19,11,2]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rpc=e.$Qpc=e.$Ppc=void 0;function m(d,l){if(l){const g=l.split(".");let E=d;for(let D=0;E&&D<g.length;D++)E=E[g[D]];return E}}function $(d){return d instanceof a.URI}function f(d){return d&&d.uri instanceof a.URI&&d.languageId&&typeof d.languageId=="string"}function i(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function s(d){return d&&d.uri instanceof a.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function t(d){if($(d))return{resource:d};if(f(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(i(d))return{overrideIdentifier:d.languageId};if(s(d))return{resource:d.uri};if(d===null)return{resource:null}}let o=class{constructor(l,g,E){this.a=l.getProxy(R.$KN.MainThreadConfiguration),this.c=g,this.b=E,this.d=new S.$Eh,this.e=null}getConfigProvider(){return this.d.wait().then(l=>this.e)}$initializeConfiguration(l){this.e=new n(this.a,this.c,l,this.b),this.d.open()}$acceptConfigurationChanged(l,g){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(l,g))}};e.$Ppc=o,e.$Ppc=o=Je([Ve(0,P.$kQ),Ve(1,C.$Opc),Ve(2,w.$ak)],o);class n{constructor(l,g,E,D){this.a=new h.$le,this.b=l,this.f=D,this.c=g,this.e=p.$Ro.parse(E,D),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(l,g){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Ro.parse(l,this.f),this.d=this.k(l.configurationScopes),this.a.fire(this.j(g,E))}getConfiguration(l,g,E){const D=t(g)||{},y=this.g(l?m(this.e.getValue(void 0,D,this.c.workspace),l):this.e.getValue(void 0,D,this.c.workspace));l&&this.h(l,D,E?.identifier);function k(b){if(b==null)return null;if(typeof b=="boolean")return b?T.ConfigurationTarget.USER:T.ConfigurationTarget.WORKSPACE;switch(b){case O.ConfigurationTarget.Global:return T.ConfigurationTarget.USER;case O.ConfigurationTarget.Workspace:return T.ConfigurationTarget.WORKSPACE;case O.ConfigurationTarget.WorkspaceFolder:return T.ConfigurationTarget.WORKSPACE_FOLDER}}const A={has(b){return typeof m(y,b)<"u"},get:(b,v)=>{this.h(l?`${l}.${b}`:b,D,E?.identifier);let F=m(y,b);if(typeof F>"u")F=v;else{let N;const L=(M,z)=>{if((0,I.$gg)(M)){let j;const W=()=>{N=N||(0,r.$eo)(y),j=j||m(N,z)};return new Proxy(M,{get:(B,ee)=>{if(typeof ee=="string"&&ee.toLowerCase()==="tojson")return W(),()=>j;if(N)return j=j||m(N,z),j[ee];const H=B[ee];return typeof ee=="string"?L(H,`${z}.${ee}`):H},set:(B,ee,H)=>(W(),j&&(j[ee]=H),!0),deleteProperty:(B,ee)=>(W(),j&&delete j[ee],!0),defineProperty:(B,ee,H)=>(W(),j&&Object.defineProperty(j,ee,H),!0)})}return Array.isArray(M)?(0,r.$eo)(M):M};F=L(F,b)}return F},update:(b,v,F,N)=>{b=l?`${l}.${b}`:b;const L=k(F);return v!==void 0?this.b.$updateConfigurationOption(L,b,v,D,N):this.b.$removeConfigurationOption(L,b,D,N)},inspect:b=>{b=l?`${l}.${b}`:b;const v=this.e.inspect(b,D,this.c.workspace);if(v)return{key:b,defaultValue:(0,r.$eo)(v.policy?.value??v.default?.value),globalValue:(0,r.$eo)(v.user?.value??v.application?.value),workspaceValue:(0,r.$eo)(v.workspace?.value),workspaceFolderValue:(0,r.$eo)(v.workspaceFolder?.value),defaultLanguageValue:(0,r.$eo)(v.default?.override),globalLanguageValue:(0,r.$eo)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,r.$eo)(v.workspace?.override),workspaceFolderLanguageValue:(0,r.$eo)(v.workspaceFolder?.override),languageIds:(0,r.$eo)(v.overrideIdentifiers)}}};return typeof y=="object"&&(0,r.$ho)(A,y,!1),Object.freeze(A)}g(l){const g=E=>(0,I.$gg)(E)?new Proxy(E,{get:(D,y)=>g(D[y]),set:(D,y,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(D,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(D,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return g(l)}h(l,g,E){const D=c.$Go.test(l)?c.ConfigurationScope.RESOURCE:this.d.get(l),y=E?`[${E.value}] `:"";if(c.ConfigurationScope.RESOURCE===D){typeof g?.resource>"u"&&this.f.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(c.ConfigurationScope.WINDOW===D){g?.resource&&this.f.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(l,g){const E=new p.$To(l,g,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,y)=>E.affectsConfiguration(D,t(y))})}k(l){return l.reduce((g,E)=>(g.set(E[0],E[1]),g),new Map)}}e.$Qpc=n,e.$Rpc=(0,u.$Fi)("IExtHostConfiguration")}),define(ke[100],Ie([1,0,2,7,4,6,9,49,63,41,20,48,19,29,5,14,10,11,95,273,13]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$prc=e.$orc=e.$nrc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,O=qe(O),m=qe(m);var t;(function(N){function L(z){if(z!=null)return z}N.from=L;function M(z){if(z!=null)return z}N.to=M})(t||(t={}));var o;(function(N){function L(z){if(z!=null)return z}N.from=L;function M(z){if(z!=null)return z}N.to=M})(o||(o={}));var n;(function(N){function L(z){if(z!=null)return z}N.from=L;function M(z){if(z!=null)return z}N.to=M})(n||(n={}));var d;(function(N){function L(j){if(j){const W=j;return W&&!!W.process}else return!1}N.is=L;function M(j){if(j==null)return;const W={process:j.process,args:j.args};return j.options&&(W.options=n.from(j.options)),W}N.from=M;function z(j){if(j!=null)return new O.$yO(j.process,j.args,j.options)}N.to=z})(d||(d={}));var l;(function(N){function L(z){if(z!=null)return z}N.from=L;function M(z){if(z!=null)return z}N.to=M})(l||(l={}));var g;(function(N){function L(j){if(j){const W=j;return W&&(!!W.commandLine||!!W.command)}else return!1}N.is=L;function M(j){if(j==null)return;const W={};return j.commandLine!==void 0?W.commandLine=j.commandLine:(W.command=j.command,W.args=j.args),j.options&&(W.options=l.from(j.options)),W}N.from=M;function z(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new O.$zO(j.commandLine,j.options):new O.$zO(j.command,j.args?j.args:[],j.options)}N.to=z})(g||(g={}));var E;(function(N){function L(j){if(j){const W=j;return W&&W.customExecution==="customExecution"}else return!1}N.is=L;function M(j){return{customExecution:"customExecution"}}N.from=M;function z(j,W){return W.get(j)}N.to=z})(E||(e.CustomExecutionDTO=E={}));var D;(function(N){function L(M,z){let j;return M.scope!==void 0&&typeof M.scope!="number"?j=M.scope.uri:M.scope!==void 0&&typeof M.scope=="number"&&(M.scope===O.TaskScope.Workspace&&z&&z.workspaceFile?j=z.workspaceFile:j=i.$VI),{id:M._id,workspaceFolder:j}}N.from=L})(D||(e.TaskHandleDTO=D={}));var y;(function(N){function L(M){if(M!=null)return{_id:M.id,isDefault:M.isDefault}}N.from=L})(y||(y={}));var k;(function(N){function L(j,W){if(j==null)return[];const B=[];for(const ee of j){const H=M(ee,W);H&&B.push(H)}return B}N.fromMany=L;function M(j,W){if(j==null)return;let B;j.execution instanceof O.$yO?B=d.from(j.execution):j.execution instanceof O.$zO?B=g.from(j.execution):j.execution&&j.execution instanceof O.$AO&&(B=E.from(j.execution));const ee=t.from(j.definition);let H;return j.scope?typeof j.scope=="number"?H=j.scope:H=j.scope.uri:H=O.TaskScope.Workspace,!ee||!H?void 0:{_id:j._id,definition:ee,name:j.name,source:{extensionId:W.identifier.value,label:j.source,scope:H},execution:B,isBackground:j.isBackground,group:y.from(j.group),presentationOptions:o.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}N.from=M;async function z(j,W,B){if(j==null)return;let ee;d.is(j.execution)?ee=d.to(j.execution):g.is(j.execution)?ee=g.to(j.execution):E.is(j.execution)&&(ee=E.to(j._id,B));const H=t.to(j.definition);let q;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?q=j.source.scope:q=await W.resolveWorkspaceFolder(r.URI.revive(j.source.scope)):q=O.TaskScope.Workspace),!H||!q)return;const Q=new O.$BO(H,q,j.name,j.source.label,ee,j.problemMatchers);return j.isBackground!==void 0&&(Q.isBackground=j.isBackground),j.group!==void 0&&(Q.group=O.$xO.from(j.group._id),Q.group&&j.group.isDefault&&(Q.group=new O.$xO(Q.group.id,Q.group.label),j.group.isDefault===!0&&(Q.group.isDefault=j.group.isDefault))),j.presentationOptions&&(Q.presentationOptions=o.to(j.presentationOptions)),j._id&&(Q._id=j._id),j.detail&&(Q.detail=j.detail),Q}N.to=z})(k||(e.TaskDTO=k={}));var A;(function(N){function L(z){return z}N.from=L;function M(z){if(z)return Object.assign(Object.create(null),z)}N.to=M})(A||(A={}));class b{#e;constructor(L,M,z){this._id=M,this.a=z,this.#e=L}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}let v=class{constructor(L,M,z,j,W,B,ee,H){this.q=new C.$le,this.r=new C.$le,this.s=new C.$le,this.u=new C.$le,this.a=L.getProxy(R.$KN.MainThreadTask),this.b=z,this.c=j,this.d=W,this.e=B,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ee,this.g=H,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(L,M,z){if(!z)return new O.$MN(()=>{});const j=this.x();return this.j.set(j,{type:M,provider:z,extension:L}),this.a.$registerTaskProvider(j,M),new O.$MN(()=>{this.j.delete(j),this.a.$unregisterTaskProvider(j)})}registerTaskSystem(L,M){this.a.$registerTaskSystem(L,M)}fetchTasks(L){return this.a.$fetchTasks(A.from(L)).then(async M=>{const z=[];for(const j of M){const W=await k.to(j,this.b,this.m);W&&z.push(W)}return z})}get taskExecutions(){const L=[];return this.k.forEach(M=>L.push(M)),L}terminateTask(L){if(!(L instanceof b))throw new Error("No valid task execution provided");return this.a.$terminateTask(L._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(L,M,z){const j=this.m.get(L.id);j&&(this.o.set(L.id,j),this.e.attachPtyToTerminal(M,await j.callback(z))),this.p=L.id,this.q.fire({execution:await this.z(L)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(L){if(!this.l.has(L.id))return;const M=await this.z(L);this.l.delete(L.id),this.k.delete(L.id),this.B(L),this.r.fire({execution:M})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(L){const M=await this.z(L.id);this.s.fire({execution:M,processId:L.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(L){const M=await this.z(L.id);this.u.fire({execution:M,exitCode:L.exitCode})}$provideTasks(L,M){const z=this.j.get(L);if(!z)return Promise.reject(new Error("no handler found"));const j=[],W=(0,h.$xh)(()=>z.provider.provideTasks(I.CancellationToken.None)).then(B=>this.v(M,j,z,B));return new Promise(B=>{W.then(ee=>{Promise.all(j).then(()=>{B(ee)})})})}async $resolveTask(L,M){const z=this.j.get(L);if(!z)return Promise.reject(new Error("no handler found"));if(M.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${M.definition.type}] cannot be resolved by provider of type [${z.type}].`);const j=await k.to(M,this.b,this.m);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const W=await z.provider.resolveTask(j,I.CancellationToken.None);if(!W)return;this.A(W,z);const B=k.from(W,z.extension);if(!B)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return E.is(B.execution)&&await this.y(B,W,!0),await this.w(B)}x(){return this.h++}async y(L,M,z){const j=await this.a.$createTaskId(L);!z&&!this.m.has(j)&&(this.n.add(j),this.o.set(j,M.execution)),this.m.set(j,M.execution)}async z(L,M){if(typeof L=="string"){const W=this.l.get(L);if(!W)throw new s.$ab("Unexpected: The specified task is missing an execution");return W}const z=this.l.get(L.id);if(z)return z;let j;return M?j=Promise.resolve(new b(this,L.id,M)):j=k.to(L.task,this.b,this.m).then(W=>{if(!W)throw new s.$ab("Unexpected: Task does not exist.");return new b(this,L.id,W)}),this.l.set(L.id,j),j.then(W=>(this.k.set(L.id,W),W))}A(L,M){L._deprecated&&this.g.report("Task.constructor",M.extension,"Use the Task constructor that takes a `scope` instead.")}B(L){this.o.get(L.id)&&this.o.delete(L.id),this.n.has(L.id)&&this.p!==L.id&&(this.m.delete(L.id),this.n.delete(L.id));const z=this.n.values();let j=z.next();for(;!j.done;)!this.o.has(j.value)&&this.p!==j.value&&(this.m.delete(j.value),this.n.delete(j.value)),j=z.next()}};e.$nrc=v,e.$nrc=v=Je([Ve(0,u.$kQ),Ve(1,P.$AQ),Ve(2,T.$Opc),Ve(3,p.$vQ),Ve(4,c.$Rpc),Ve(5,S.$dqc),Ve(6,$.$ak),Ve(7,f.$spc)],v);let F=class extends v{constructor(L,M,z,j,W,B,ee,H){super(L,M,z,j,W,B,ee,H),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:m.$i(m.Platform.Web)})}async executeTask(L,M){if(!M.execution)throw new Error("Tasks to execute must include an execution");const z=k.from(M,L);if(z===void 0)throw new Error("Task is not valid");if(E.is(z.execution))await this.y(z,M,!1);else throw new s.$$;const j=await this.z(await this.a.$getTaskExecution(z),M);return this.a.$executeTask(z).catch(W=>{throw new Error(W)}),j}v(L,M,z,j){const W=[];if(j)for(const B of j){if(this.A(B,z),!B.definition||!L[B.definition.type]){const H=B.source?B.source:"No task source";this.f.warn(`The task [${H}, ${B.name}] uses an undefined task type. The task will be ignored in the future.`)}const ee=k.from(B,z.extension);ee&&E.is(ee.execution)?(W.push(ee),M.push(this.y(ee,B,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:z.extension}}async w(L){if(E.is(L.execution))return L;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(L,M){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,M,z){}};e.$orc=F,e.$orc=F=Je([Ve(0,u.$kQ),Ve(1,P.$AQ),Ve(2,T.$Opc),Ve(3,p.$vQ),Ve(4,c.$Rpc),Ve(5,S.$dqc),Ve(6,$.$ak),Ve(7,f.$spc)],F),e.$prc=(0,w.$Fi)("IExtHostTask")}),define(ke[334],Ie([1,0,37,30]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=void 0,e.$wM=C,e.$yM=R;function C(O){return"cellResults"in O}e.$xM="rawCell#";function R(O,T){let p=-1;const c=[];let I=[];return O.forEach(u=>{u.range.startLineNumber!==p&&I.length>0&&(c.push([...I]),I=[]),I.push(u),p=u.range.endLineNumber}),I.length>0&&c.push([...I]),c.map(u=>{const P=[],w=u[0].range.startLineNumber,a=u[u.length-1].range.endLineNumber;for(let m=w;m<=a;m++)P.push(T.getLineContent(m));return new r.$aM(P.join(`
`)+`
`,u.map(m=>new h.$Ot(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(ke[335],Ie([1,0,8,21,4,3,28,40,12,17,2,27,118,6,34,15,9,53,307,165,24,14,37,263,334,331]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2qc=void 0,S=qe(S),a=qe(a),m=qe(m);class g{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,y,k,A,b,v,F){this.q=k,this.r=A,this.s=b,this.t=v,this.u=F,this.f=new Map,this.g=new O.$Ac,this.h=new Map,this.j=new C.$le,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$le,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$le,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$le,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$qpc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(P.$KN.MainThreadNotebook),this.c=D.getProxy(P.$KN.MainThreadNotebookDocuments),this.d=D.getProxy(P.$KN.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===T.MarshalledId.NotebookCellActionContext){const L=N.notebookEditor?.notebookUri,M=N.cell.handle,j=this.g.get(L)?.getCell(M);if(j)return j.apiCell}if(N&&N.$mid===T.MarshalledId.NotebookActionContext){const L=N.uri,M=this.g.get(L);if(M)return M.apiNotebook}return N}}),g.C(y)}getEditorById(D){const y=this.h.get(D);if(!y)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(D){for(const[y,k]of this.h)if(k.apiEditor===D)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,y){const k=this.g.get(D);if(!k&&!y)throw new Error(`NO notebook document for '${D}'`);return k}static w(D,y){if(!y)return;const k=y.filenamePattern.map(A=>a.NotebookExclusiveDocumentPattern.from(A)).filter(A=>A!==void 0);if(y.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:y.displayName,filenamePattern:k,priority:y.exclusive?l.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,y,k){const A=g.a++,b=typeof k.onDidChangeCellStatusBarItems=="function"?g.a++:void 0;this.f.set(A,k),this.b.$registerNotebookCellStatusBarItemProvider(A,b,y);let v;return b!==void 0&&(v=k.onDidChangeCellStatusBarItems(F=>this.b.$emitCellStatusBarEvent(b))),new m.$MN(()=>{this.f.delete(A),this.b.$unregisterNotebookCellStatusBarItemProvider(A,b),v?.dispose()})}async createNotebookDocument(D){const y=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&a.NotebookData.from(D.content)});return I.URI.revive(y)}async openNotebookDocument(D){const y=this.g.get(D);if(y)return y.apiNotebook;const k=await this.c.$tryOpenNotebook(D),A=this.g.get(I.URI.revive(k));return(0,c.$pg)(A?.apiNotebook)}async showNotebookDocument(D,y){I.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let k;typeof y=="object"?k={position:a.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(a.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:k={preserveFocus:!1};const A=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,k),b=A&&this.h.get(A)?.apiEditor;if(b)return b;throw A?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,y,k,A){const b=this.f.get(D),v=I.URI.revive(y),F=this.g.get(v);if(!F||!b)return;const N=F.getCellFromIndex(k);if(!N)return;const L=await b.provideCellStatusBarItems(N.apiCell,A);if(!L)return;const M=new R.$Tc,z=this.p.add([M]),W=(Array.isArray(L)?L:[L]).map(B=>a.NotebookStatusBarItem.from(B,this.i,M));return{cacheId:z,items:W}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,y,k,A,b){if((0,p.$cf)(y))throw new Error("viewType cannot be empty or just whitespace");const v=this.x++;return this.y.set(v,{viewType:y,serializer:k,options:A}),this.b.$registerNotebookSerializer(v,{id:D.identifier,location:D.extensionLocation},y,a.NotebookDocumentContentOptions.from(A),g.w(D,b)),(0,R.$Sc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(D,y,k){const A=this.y.get(D);if(!A)throw new Error("NO serializer found");const b=await A.serializer.deserializeNotebook(y.buffer,k);return new $.$Xw(a.NotebookData.from(b))}async $notebookToData(D,y,k){const A=this.y.get(D);if(!A)throw new Error("NO serializer found");const b=await A.serializer.serializeNotebook(a.NotebookData.to(y.value),k);return h.$Ne.wrap(b)}async $saveNotebook(D,y,k,A,b){const v=I.URI.revive(y),F=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${k}, ${v.toString()})`),!F)throw new Error("NO serializer found");const N=this.g.get(v);if(!N)throw new Error("Document NOT found");if(N.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new S.$vl((0,r.localize)(10828,null,this.A(v)),S.FileOperationResult.FILE_PERMISSION_DENIED);const L={metadata:(0,s.$mo)(N.apiNotebook.metadata,B=>!(F.options?.transientDocumentMetadata??{})[B]),cells:[]};for(const B of N.apiNotebook.getCells()){const ee=new m.$fP(B.kind,B.document.getText(),B.document.languageId,B.mime,F.options?.transientOutputs?[]:[...B.outputs],B.metadata,B.executionSummary);ee.metadata=(0,s.$mo)(B.metadata,H=>!(F.options?.transientCellMetadata??{})[H]),L.cells.push(ee)}if(await this.z(v,A),b.isCancellationRequested)throw new Error("canceled");const M=await F.serializer.serializeNotebook(L,b);if(b.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${k} ${v.toString()}`),await this.s.value.writeFile(v,M),this.D(`Finished write versionId: ${k} ${v.toString()}`);const z=this.s.getFileSystemProviderExtUri(v.scheme),j=await this.s.value.stat(v),W={name:z.basename(v),isFile:(j.type&S.FileType.File)!==0,isDirectory:(j.type&S.FileType.Directory)!==0,isSymbolicLink:(j.type&S.FileType.SymbolicLink)!==0,mtime:j.mtime,ctime:j.ctime,size:j.size,readonly:!!((j.permissions??0)&S.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((j.permissions??0)&S.FilePermission.Locked),etag:S.$Gl({mtime:j.mtime,size:j.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${k}, ${v.toString()})`),W}async $searchInNotebooks(D,y,k,A,b){const v=this.y.get(D)?.serializer;if(!v)return{limitHit:!1,results:[]};const F=new O.$Bc;await(async(j,W,B)=>{await Promise.all(j.map(async ee=>await Promise.all(ee.filenamePatterns.map(H=>{const q={_reason:B._reason,folderQueries:B.folderQueries,includePattern:B.includePattern,excludePattern:B.excludePattern,maxResults:B.maxResults,type:o.QueryType.File,filePattern:H};return this.t.doInternalFileSearchWithCustomCallback(q,W,Q=>{Q.forEach(_=>{F.has(_)||A.some(ne=>ee.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(ye=>(0,l.$qL)(ye,_)))||F.add(_)})}).catch(Q=>{if(Q.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Q})}))))})(k,b,y);const L=new O.$Ac;let M=!1;const z=Array.from(F).map(async j=>{const W=[];try{if(b.isCancellationRequested)return;if(y.maxResults&&[...L.values()].reduce((q,Q)=>q+Q.cellResults.length,0)>y.maxResults){M=!0;return}const B=[],ee=this.g.get(j);if(ee)ee.apiNotebook.getCells().forEach(Q=>B.push({input:Q.document.getText(),outputs:Q.outputs.flatMap(_=>_.items.map(ce=>ce.data.toString()))}));else{const q=await this.s.value.readFile(j),Q=h.$Ne.fromString(q.toString()),_=await v.deserializeNotebook(Q.buffer,b);if(b.isCancellationRequested)return;a.NotebookData.from(_).cells.forEach(ne=>B.push({input:ne.source,outputs:ne.outputs.flatMap(ye=>ye.items.map(ge=>ge.valueBytes.toString()))}))}if(b.isCancellationRequested)return;B.forEach((q,Q)=>{const _=y.contentPattern.pattern,ce=new n.$j1b(q.input,void 0,q.outputs),ne=ce.findInInputs(_),ye=ce.findInOutputs(_),ge=ye.flatMap(Y=>(0,d.$yM)(Y.matches,Y.textBuffer)).map((Y,U)=>(Y.webviewIndex=U,Y));if(ne.length>0||ye.length>0){const Y={index:Q,contentResults:(0,d.$yM)(ne,ce.inputTextBuffer),webviewResults:ge};W.push(Y)}});const H={resource:j,cellResults:W};L.set(j,H);return}catch{return}});return await Promise.all(z),{limitHit:M,results:[...L.values()]}}async z(D,y){const k=await this.s.value.stat(D);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==S.$Fl&&typeof k.mtime=="number"&&typeof k.size=="number"&&y.mtime<k.mtime&&y.etag!==S.$Gl({mtime:y.mtime,size:k.size}))throw new S.$vl((0,r.localize)(10829,null),S.FileOperationResult.FILE_MODIFIED_SINCE,y)}A(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}B(D,y,k){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const A=new i.$Sqc(y,this.d,D,k.visibleRanges.map(a.NotebookRange.to),k.selections.map(a.NotebookRange.to),typeof k.viewColumn=="number"?a.ViewColumn.to(k.viewColumn):void 0);this.h.set(y,A)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const k of D.value.removedDocuments){const A=I.URI.revive(k),b=this.g.get(A);b&&(b.dispose(),this.g.delete(A),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire(b.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===A.toString()&&this.h.delete(v.id)}if(D.value.addedDocuments){const k=[];for(const A of D.value.addedDocuments){const b=I.URI.revive(A.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const v=new f.$Rqc(this.c,this.q,this.r,b,A);k.push(...A.cells.map(F=>f.$Qqc.asModelAddData(F))),this.g.get(b)?.dispose(),this.g.set(b,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(v.apiNotebook)}}if(D.value.addedEditors)for(const k of D.value.addedEditors){if(this.h.has(k.id))return;const A=I.URI.revive(k.documentUri),b=this.g.get(A);b&&this.B(b,k.id,k)}const y=[];if(D.value.removedEditors)for(const k of D.value.removedEditors){const A=this.h.get(k);A&&(this.h.delete(k),this.k?.id===A.id&&(this.k=void 0),y.push(A))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(A=>this.h.get(A)).filter(A=>!!A);const k=new Set;this.l.forEach(A=>k.add(A.id));for(const A of this.h.values()){const b=k.has(A.id);A._acceptVisibility(b)}this.l=[...this.h.values()].map(A=>A).filter(A=>A.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const y=w.$IQ.String.with("notebookType","A notebook type"),k=new w.$KQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new w.$IQ("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>h.$Ne.wrap(b))],new w.$JQ("Notebook Data",b=>a.NotebookData.to(b.value))),A=new w.$KQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new w.$IQ("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new $.$Xw(a.NotebookData.from(b)))],new w.$JQ("Bytes",b=>b.buffer));D.registerApiCommand(k),D.registerApiCommand(A)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$2qc=g}),define(ke[336],Ie([1,0,16,20,52,38,22,42,37]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tqc=void 0,r=qe(r),R=qe(R),O=qe(O);class c{constructor(u,P,w){this.k=u,this.l=P,this.o=w,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&R.$Ak(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&R.$Ak(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const P=this.k.folderQueries||[];return new Promise((w,a)=>{const m=$=>{this.f++,u($)};if(this.g)return w({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach($=>{const f=$.toString(),i=r.$nc(f);this.j&&this.j(f,i)||this.v(m,{base:$,basename:i})}),Promise.all(P.map($=>this.p($,m))).then($=>{w({limitHit:this.e,stats:$[0]||void 0})},$=>{a(new Error((0,C.$qj)($)))})})}async p(u,P){const w=new h.$we,a=this.q(u),m=this.r(),$=new p.$oM(this.k,u),f=!$.hasSiblingExcludeClauses();let i;try{this.h.add(w),i=T.$fe.create();const s=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,w.token),t=i.elapsed(),o=T.$fe.create();return this.g&&!this.e||(s&&s.forEach(n=>{const d=r.$gc.relative(u.folder.path,n.path);if(f){const l=r.$nc(n.path);this.v(P,{base:u.folder,relativePath:d,basename:l});return}this.s(m,u.folder,d,P)}),this.g&&!this.e)?null:(this.u(m,$,P),{providerTime:t,postProcessTime:o.elapsed()})}finally{w.dispose(),this.h.delete(w)}}q(u){const P=(0,p.$nM)(this.k.includePattern,u.includePattern),w=(0,p.$nM)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:w,includes:P,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},P,w,a){if(w===this.a){const $=r.$nc(this.a);this.v(a,{base:P,relativePath:this.a,basename:$})}function m($){const f=r.$nc($),i=r.$mc($);let s=u[i];s||(s=u[i]=[],m(i)),s.push({base:P,relativePath:$,basename:f})}m(w)}u({rootEntries:u,pathToEntries:P},w,a){const m=this,$=this.a;function f(i){const s=(0,p.$qM)(()=>i.map(t=>t.basename));for(let t=0,o=i.length;t<o;t++){const n=i[t],{relativePath:d,basename:l}=n;if(w.matchesExcludesSync(d,l,$!==l?s:void 0))continue;const g=P[d];if(g)f(g);else{if(d===$)continue;m.v(a,n)}if(m.e)break}}f(u)}v(u,P){(!this.b||P.relativePath&&this.b(P.relativePath,P.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(P))}}class I{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,P,w,a){const m=this.c(u.cacheKey),$=new c(u,P,m&&m.token);let f=0;const i=s=>{f+=s.length,w(s.map(t=>this.d(t)))};return this.e($,I.a,i,a).then(s=>({limitHit:s.limitHit,stats:s.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:f,detailStats:s.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new h.$we),this.b.get(u)}d(u){return u.relativePath?{resource:O.$gh(u.base,u.relativePath)}:{resource:u.base}}e(u,P,w,a){const m=a.onCancellationRequested(()=>{u.cancel()}),$=i=>{i&&(f.push(i),P>0&&f.length>=P&&(w(f),f=[]))};let f=[];return u.search($).then(i=>(f.length&&w(f),m.dispose(),i),i=>(f.length&&w(f),m.dispose(),Promise.reject(i)))}}e.$Tqc=I}),define(ke[337],Ie([1,0,18,78,38,107,28,14,16,22,12,17,2,111,8,46,11,47,157,332,37]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oN=void 0,e.$pN=y,r=qe(r),h=qe(h),C=qe(C),p=qe(p),I=qe(I),w=qe(w);let t=class{constructor(A,b,v,F,N){this.a=A,this.b=b,this.c=v,this.d=F,this.e=N}text(A,b,v={}){A=this.f(A,v);const F=this.a.getValue(),N=b&&b.some(M=>!this.a.getValue({resource:M}).search.useRipgrep);return{...this.h(b?.map($.$1i),v),type:s.QueryType.Text,contentPattern:A,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:F.search.usePCRE2||N||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles}}f(A,b){const v=this.a.getValue();A.isRegExp&&(A.pattern=A.pattern.replace(/\r?\n/g,"\\n"));const F={...A,wordSeparators:v.editor.wordSeparators};return this.j(A,b)&&(F.isCaseSensitive=!0),this.k(A)&&(F.isMultiline=!0),b.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=b.notebookSearchConfig.includeMarkupInput),b.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=b.notebookSearchConfig.includeMarkupPreview),b.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=b.notebookSearchConfig.includeCodeInput),b.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=b.notebookSearchConfig.includeOutput),F}file(A,b={}){return{...this.h(A,b),type:s.QueryType.File,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey,shouldGlobMatchFilePattern:b.shouldGlobSearch}}g(A,b){return A?(A=Array.isArray(A)?A.map(g):g(A),b?this.parseSearchPaths(A):{pattern:n(...Array.isArray(A)?A:[A])}):{}}h(A=[],b={}){const v=this.g(b.includePattern,b.expandPatterns),F=this.g(b.excludePattern,b.expandPatterns),N=A.length>1,L=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(j=>this.q(j,b,F)):A.map(j=>this.r(j,b,F,N))).filter(j=>!!j),M={_reason:b._reason,folderQueries:L,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:F.pattern,includePattern:v.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const j=r.$Gb(this.c.groups.flatMap(ee=>ee.editors.map(H=>H.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(j));const W=j.filter(ee=>(0,s.$eM)(M,ee.fsPath)),B=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...M,...B}}const z=b.extraFileResources&&b.extraFileResources.filter(j=>(0,s.$eM)(M,j.fsPath));return M.extraFileResources=z&&z.length?z:void 0,M}i(A){const b=[],v=new O.$Ac,F={};let N=!1;return A.forEach(L=>{if(L.scheme===T.Schemas.walkThrough)return;if((0,c.$kh)(L)){const z=this.b.getWorkspaceFolder(L)?.uri??L.with({path:p.$mc(L.fsPath)});let j=v.get(z);j||(N=!0,j={folder:z,includePattern:{}},b.push(j),v.set(z,j));const W=p.$lc(z.fsPath,L.fsPath);(0,S.$pg)(j.includePattern)[W.replace(/\\/g,"/")]=!0}else L.fsPath&&(N=!0,F[L.fsPath]=!0)}),{folderQueries:b,includePattern:F,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(A,b){if(b.isSmartCase){if(A.isRegExp){if(I.$8f(A.pattern,!0))return!0}else if(I.$8f(A.pattern))return!0}return!!A.isCaseSensitive}k(A){return A.isMultiline||A.isRegExp&&(0,P.$lD)(A.pattern)||A.pattern.indexOf(`
`)>=0?!0:!!A.isMultiline}parseSearchPaths(A){const b=B=>p.$ic(B)||/^\.\.?([\/\\]|$)/.test(B),F=(Array.isArray(A)?A:d(A)).map(B=>{const ee=this.e.resolvedUserHome;return ee?(0,R.$3w)(B,ee.scheme===T.Schemas.file?ee.fsPath:ee.path):B}),N=h.$c(F,B=>b(B)?"searchPaths":"exprSegments"),L=(N.exprSegments||[]).map(B=>I.$nf(B,"/")).map(B=>I.$nf(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),l(B))),M={},z=this.m(N.searchPaths||[]);z&&z.length&&(M.searchPaths=z);const j=L.flat(),W=n(...j);return W&&(M.pattern=W),M}l(A,b){return b.disregardExcludeSettings?void 0:(0,s.$dM)(A,!b.disregardSearchExcludeSettings)}m(A){if(!A||!A.length)return[];const b=A.flatMap(F=>{let{pathPortion:N,globPortion:L}=o(F);return L&&(L=E(L)),this.n(N).flatMap(z=>this.o(z,L))}),v=new Map;return b.forEach(F=>{const N=F.searchPath.toString(),L=v.get(N);L?F.pattern&&(L.pattern=L.pattern||{},L.pattern[F.pattern]=!0):v.set(N,{searchPath:F.searchPath,pattern:F.pattern?n(F.pattern):void 0})}),Array.from(v.values())}n(A){if(p.$ic(A)){const b=this.b.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==T.Schemas.file?[{searchPath:b[0].uri.with({path:A})}]:[{searchPath:u.URI.file(p.$hc(A))}]}if(this.b.getWorkbenchState()===$.WorkbenchState.FOLDER){const b=this.b.getWorkspace().folders[0].uri;if(A=g(A),A.startsWith("../")||A===".."){const F=p.$gc.resolve(b.path,A);return[{searchPath:b.with({path:F})}]}const v=E(A);return[{searchPath:b,pattern:v}]}else{if(A==="./"||A===".\\")return[];{const b=A.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(N=>{const L=b.match(new RegExp(`^${I.$hf(N.name)}(?:/(.*)|$)`));return L?{match:L,folder:N}:null}).filter(S.$mg);if(F.length)return F.map(N=>{const L=N.match[1];return{searchPath:N.folder.uri,pattern:L&&E(L)}});{const N=A.match(/\.[\/\\](.+)[\/\\]?/),L=N?N[1]:A,M=w.localize(1633,null,L);throw new Error(M)}}}}o(A,b){const v=A.pattern&&b?`${A.pattern}/${b}`:A.pattern||b,F=[{searchPath:A.searchPath,pattern:v}];return v&&!v.endsWith("**")&&F.push({searchPath:A.searchPath,pattern:v+"/**"}),F}q(A,b,v){const F=this.r((0,$.$1i)(A.searchPath),b,v,!1);return F?{...F,includePattern:A.pattern}:null}r(A,b,v,F){let N;const L=u.URI.isUri(A)?A:A.uri;if(v.searchPaths){const B=v.searchPaths.filter(ee=>(0,c.$_g)(ee.searchPath,L))[0];if(B&&!B.pattern)return null;B&&(N=B.pattern)}const M=this.a.getValue({resource:L}),j={...this.l(M,b)||{},...N||{}},W=u.URI.isUri(A)?(0,c.$dh)(A):A.name;return{folder:L,folderName:F?W:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:M.files&&M.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!M.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!M.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof b.disregardParentIgnoreFiles=="boolean"?b.disregardParentIgnoreFiles:!M.search.useParentIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!M.search.followSymlinks}}};e.$oN=t,e.$oN=t=Je([Ve(0,a.$_i),Ve(1,$.$Oi),Ve(2,f.$tE),Ve(3,m.$ak),Ve(4,i.$mN)],t);function o(k){const A=k.match(/[\*\{\}\(\)\[\]\?]/);if(A){const b=A.index,v=k.substr(0,b).match(/[/|\\][^/\\]*$/);if(v){let F=k.substr(0,v.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:k.substr((v.index||0)+1)}}}return{pathPortion:k}}function n(...k){return k.length?k.reduce((A,b)=>(A[b]=!0,A),Object.create(null)):void 0}function d(k){return C.$yk(k,",").map(A=>A.trim()).filter(A=>!!A.length)}function l(k){return[`**/${k}/**`,`**/${k}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function g(k){return k.replace(/\\/g,"/")}function E(k){return g(k).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(k){return k.replace(/([?*[\]])/g,"[$1]")}function y(k,A){k=r.$Lb(k,F=>F.toString());const b=[],v=A.getWorkspace();return k&&k.forEach(F=>{let N;if(A.getWorkbenchState()===$.WorkbenchState.FOLDER)N=(0,c.$ih)(v.folders[0].uri,F),N&&N!=="."&&(N="./"+N);else{const L=A.getWorkspaceFolder(F);if(L){const M=L.name;if(v.folders.filter(j=>j.name===M).length===1){const j=(0,c.$ih)(L.uri,F);j===""?N=`./${L.name}`:N=`./${L.name}/${j}`}else N=F.fsPath}}N&&b.push(D(N))}),b}}),define(ke[338],Ie([1,0,22,2,20,13,5,337,37,47,7]),function($e,e,r,h,C,R,O,T,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dyb=u,e.$Eyb=a,r=qe(r),R=qe(R);const S=7e3;function u(m,$){const f=$.activationEvents;if(!f)return Promise.resolve(void 0);const i=[],s=[];for(const g of f)if(/^workspaceContains:/.test(g)){const E=g.substr(18);E.indexOf("*")>=0||E.indexOf("?")>=0||m.forceUsingSearch?s.push(E):i.push(E)}if(i.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:t,resolve:o}=(0,I.$yh)(),n=g=>o({activationEvent:g}),d=Promise.all(i.map(g=>P(m,g,n))).then(()=>{}),l=w(m,$.identifier,s,n);return Promise.all([d,l]).then(()=>{o(void 0)}),t}async function P(m,$,f){for(const i of m.folders)if(await m.exists(r.$gh(h.URI.revive(i),$))){f(`workspaceContains:${$}`);return}}async function w(m,$,f,i){if(f.length===0)return Promise.resolve(void 0);const s=new C.$we,t=m.checkExists(m.folders,f,s.token),o=setTimeout(async()=>{s.cancel(),m.logService.info(`Not activating extension '${$.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},S);let n=!1;try{n=await t}catch(d){R.$3(d)||R.$Y(d)}s.dispose(),clearTimeout(o),n&&i(`workspaceContains:${f.join(",")}`)}function a(m,$,f,i){const s=m.get(O.$Ei),t=m.get(p.$8L),n=s.createInstance(T.$oN).file($.map(d=>(0,c.$1i)(h.URI.revive(d))),{_reason:"checkExists",includePattern:f,exists:!0});return t.fileSearch(n,i).then(d=>!!d.limitHit,d=>R.$3(d)?!1:Promise.reject(d))}}),define(ke[54],Ie([1,0,8,16,61,22,7,3,84,2,11,6,41,270,125,49,25,159,13,23,21,249,9,71,5,29,97,19,114,76,48,128,4,338,124,251,14,122,42,10,123]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l,g,E,D,y,k,A,b,v,F,N,L,M,z,j,W){"use strict";var B;Object.defineProperty(e,"__esModule",{value:!0}),e.$uqc=e.$tqc=e.$sqc=e.$rqc=e.$qqc=void 0,r=qe(r),h=qe(h),C=qe(C),f=qe(f),e.$qqc=(0,d.$Fi)("IHostUtils");let ee=B=class extends T.$Uc{constructor(Y,U,oe,ve,te,ae,se,X,re,pe,we,Fe,Be){super(),this.Y=Fe,this.Z=Be,this.a=this.B(new b.$le),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=U,this.g=oe,this.f=se,this.j=ve,this.m=te,this.s=ae,this.t=re,this.u=pe,this.w=we,this.y=this.g.getProxy(S.$KN.MainThreadWorkspace),this.z=this.g.getProxy(S.$KN.MainThreadTelemetry),this.C=this.g.getProxy(S.$KN.MainThreadExtensionService),this.D=new O.$Eh,this.F=new O.$Eh,this.G=new O.$Eh,this.H=new O.$Eh,this.I=new ye(this.f.extensions.activationEvents),this.L=new $.$Mdc(this.I,this.f.extensions.allExtensions);const Re=new i.$sn(this.f.extensions.myExtensions);this.J=new $.$Mdc(this.I,ce(this.L,Re)),j.$u&&(this.s.info(`Creating extension host with the following global extensions: ${Q(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Q(this.J)}`)),this.M=new w.$_pc(this.g,this.s),this.N=new F.$jqc(this.g),this.O=X,this.h=this.q.add(Y.createChild(new D.$Di([w.$aqc,this.M],[F.$kqc,this.N]))),this.P=this.B(new P.$$pc(this.J,this.L,{onExtensionActivationError:(De,Ce,V)=>{this.C.$onExtensionActivationError(De,f.$1(Ce),V)},actualActivateExtension:async(De,Ce)=>{if($.$Mdc.isHostExtension(De,this.J,this.L))return await this.C.$activateExtension(De,Ce),new P.$0pc;const V=this.J.getExtensionDescription(De);return this.fb(V,Ce)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Y){f.$Y(Y)}}async $(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this.eb(te))}catch{}await Promise.all(Y)}terminate(Y,U=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),f.setUnexpectedErrorHandler(ve=>{this.s.error(ve)}),this.g.dispose();const oe=this.$();Promise.race([(0,O.$Gh)(5e3),oe]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const U=await this.C.$getExtension(Y);return U&&{...U,identifier:new i.$rn(U.identifier.value),extensionLocation:c.URI.revive(U.extensionLocation)}}ab(Y,U){return this.P.activateByEvent(Y,U)}bb(Y,U){return this.P.activateById(Y,U)}activateByIdWithErrors(Y,U){return this.bb(Y,U).then(()=>{const oe=this.P.getActivatedExtension(Y);if(oe.activationFailed)return Promise.reject(oe.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async cb(Y){if(Y.scheme===L.Schemas.file&&this.c.fsRealpath){const U=Y.fsPath;this.R.has(U)||this.R.set(U,this.c.fsRealpath(U));const oe=await this.R.get(U);return c.URI.file(oe)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Y=>new ne(Y))),this.Q}async db(Y){const U=p.$Li.forUris(oe=>R.$0g.ignorePathCasing(oe));return await Promise.all(Y.map(async oe=>{if(this.wb(oe)){const ve=await this.cb(oe.extensionLocation);U.set(ve,oe)}})),U}eb(Y){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return U;const oe=this.P.getActivatedExtension(Y);if(!oe)return U;try{typeof oe.module.deactivate=="function"&&(U=Promise.resolve(oe.module.deactivate()).then(void 0,ve=>(this.s.error(ve),Promise.resolve(void 0))))}catch(ve){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(ve)}try{oe.disposable.dispose()}catch(ve){this.s.error(`An error occurred when disposing the subscriptions for extension '${Y.value}':`),this.s.error(ve)}return U}async fb(Y,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.hb(Y,U).then(oe=>{const ve=oe.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,U),this.gb(Y,U,"success",ve),oe},oe=>{throw this.gb(Y,U,"failure"),oe})}gb(Y,U,oe,ve){const te=q(Y,U);this.z.$publicLog2("extensionActivationTimes",{...te,...ve||{},outcome:oe})}hb(Y,U){const oe=q(Y,U);this.z.$publicLog2("activatePlugin",oe);const ve=this.wb(Y);if(!ve)return Promise.resolve(new P.$9pc(P.$6pc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${Y.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const te=new T.$Tc,ae=new P.$7pc(U.startup);return Promise.all([this.xb(Y,(0,R.$gh)(Y.extensionLocation,ve),ae),this.ib(Y,te)]).then(se=>(C.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),B.jb(this.s,Y.identifier,se[0],se[1],te,ae))).then(se=>(C.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),se))}ib(Y,U){const oe=this.Z.createLanguageModelAccessInformation(Y),ve=U.add(new t.$cqc(Y,this.M)),te=U.add(new t.$bqc(Y.identifier.value,!1,this.M)),ae=U.add(new N.$lqc(Y,this.N)),se=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,X=this.f.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([ve.whenReady,te.whenReady,this.O.whenReady]).then(()=>{const re=this;let pe,we;const Fe=(0,m.$fH)(Y,"ipc")?this.f.messagePorts?.get(i.$rn.toKey(Y.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:te,secrets:ae,subscriptions:[],get languageModelAccessInformation(){return oe},get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(Be){return h.$jc(Y.extensionLocation.fsPath,Be)},get storagePath(){return re.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return re.O.globalValue(Y).fsPath},get logPath(){return h.$jc(re.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return c.URI.joinPath(re.f.logsLocation,Y.identifier.value)},get storageUri(){return re.O.workspaceValue(Y)},get globalStorageUri(){return re.O.globalValue(Y)},get extensionMode(){return se},get extension(){return pe===void 0&&(pe=new _(re,Y.identifier,Y,X,!1)),pe},get extensionRuntime(){return(0,m.$gH)(Y,"extensionRuntime"),re.extensionRuntime},get environmentVariableCollection(){return re.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!we){if(!Fe)return;const Be=b.Event.buffer(b.Event.fromDOMEventEmitter(Fe,"message",Re=>Re.data));Fe.start(),we={onDidReceiveMessage:Be,postMessage:Fe.postMessage.bind(Fe)}}return we}})})}static jb(Y,U,oe,ve,te,ae){return oe=oe||{activate:void 0,deactivate:void 0},this.kb(Y,U,oe,ve,ae).then(se=>new P.$8pc(!1,null,ae.build(),oe,se,(0,T.$Sc)(()=>{te.dispose(),(0,T.$Pc)(ve.subscriptions)})))}static kb(Y,U,oe,ve,te){if(typeof oe.activate=="function")try{te.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${U.value}`);const ae=typeof global=="object"?global:self,se=oe.activate.apply(ae,[ve]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(se).then(X=>(te.activateResolveStop(),X))}catch(ae){return Promise.reject(ae)}else return Promise.resolve(oe)}lb(Y,U){this.bb(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:U}).then(void 0,oe=>{this.s.error(oe)})}mb(Y,U=0){const ve=Date.now();(0,j.$C)(()=>{for(let te=U;te<Y.length;te+=1){const ae=Y[te];for(const se of ae.activationEvents??[])if(se==="onStartupFinished")if(Date.now()-ve>50){this.mb(Y,te);break}else this.lb(ae,se)}})}nb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(Y=>{const U=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),oe=this.J.getAllExtensionDescriptions();if(U)this.mb(oe);else for(const ve of oe)if(ve.activationEvents)for(const te of ve.activationEvents)te==="onStartupFinished"&&this.lb(ve,te)})}ob(){const Y=this.ab("*",!0).then(void 0,ae=>{this.s.error(ae)});this.B(this.j.onDidChangeWorkspace(ae=>this.pb(ae.added)));const U=this.j.workspace?this.j.workspace.folders:[],oe=this.pb(U),ve=this.rb(),te=Promise.all([ve,Y,oe]).then(()=>{});return Promise.race([te,(0,O.$Gh)(1e4)]).then(()=>{this.nb()}),te}pb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.qb(Y,U))).then(()=>{})}async qb(Y,U){if(this.isActivated(U.identifier))return;const oe=!this.f.remote.isRemote&&!!this.f.remote.authority,ve={logService:this.s,folders:Y.map(ae=>ae.uri),forceUsingSearch:oe||!this.c.fsExists,exists:ae=>this.c.fsExists(ae.fsPath),checkExists:(ae,se,X)=>this.y.$checkExists(ae,se,X)},te=await(0,v.$Dyb)(ve,U);if(te)return this.bb(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:te.activationEvent}).then(void 0,ae=>this.s.error(ae))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Y){throw console.error(Y),Y}}async sb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:U}=this.f.environment;if(!Y||!U)throw new Error(r.localize(10836,null));const oe=await this.xb(null,U,new P.$7pc(!1));if(!oe||typeof oe.run!="function")throw new Error(r.localize(10837,null,U.toString()));return new Promise((ve,te)=>{const ae=(re,pe)=>{re?(j.$u&&this.s.error("Test runner called back with error",re),te(re)):(j.$u&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),ve(typeof pe=="number"&&pe>0?1:0))},se=(0,R.$7g)(U),X=oe.run(se,ae);X&&X.then&&X.then(()=>{j.$u&&this.s.info("Test runner finished successfully."),ve(0)}).catch(re=>{j.$u&&this.s.error("Test runner finished with error",re),te(re instanceof Error&&re.stack?re.stack:String(re))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,O.$Gh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,U){return this.S[Y]=U,(0,T.$Sc)(()=>{delete this.S[Y]})}async getRemoteExecServer(Y){const{resolver:U}=await this.ub(Y);return U?.resolveExecServer?.(Y,{resolveAttempt:0})}async ub(Y){const U=Y.indexOf("+");if(U===-1)throw new o.$UN("Not an authority that can be resolved!",n.RemoteAuthorityResolverErrorCode.InvalidAuthority);const oe=Y.substr(0,U);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${oe}`,!1),{authorityPrefix:oe,resolver:this.S[oe]}}async $resolveAuthority(Y,U){const oe=z.$fe.create(!1),ve=()=>`[resolveAuthority(${(0,n.$Vl)(Y)},${U})][${oe.elapsed()}ms] `,te=G=>this.s.info(`${ve()}${G}`),ae=G=>this.s.warn(`${ve()}${G}`),se=(G,J=void 0)=>this.s.error(`${ve()}${G}`,J),X=G=>{if(G instanceof o.$UN)return{type:"error",error:{code:G._code,message:G._message,detail:G._detail}};throw G},re=async G=>{te(`activating resolver for ${G}...`);const{resolver:J,authorityPrefix:x}=await this.ub(G);if(!J)throw se(`no resolver for ${x}`),new o.$UN(`No remote extension installed to resolve ${x}.`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:x,remoteAuthority:G}},pe=Y.split(/@|%40/g).reverse();te(`activating remote resolvers ${pe.join(" -> ")}`);let we;try{we=await Promise.all(pe.map(re)).catch(async G=>{if(!(G instanceof o.$UN)||G._code!==n.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw G;return ae(`resolving nested authorities failed: ${G.message}`),[await re(Y)]})}catch(G){return X(G)}const Fe=new O.$Qh;Fe.cancelAndSet(()=>te("waiting..."),1e3);let Be,Re;for(const[G,{authorityPrefix:J,resolver:x,remoteAuthority:de}]of we.entries())try{if(G===we.length-1)te("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${J}`),Be=await x.resolve(de,{resolveAttempt:U,execServer:Re}),C.mark(`code/extHost/didResolveAuthorityOK/${J}`),te("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,o.$TN.isManagedResolvedAuthority(Be)?Be:void 0));else{if(te(`invoking resolveExecServer() for ${de}`),C.mark(`code/extHost/willResolveExecServer/${J}`),Re=await x.resolveExecServer?.(de,{resolveAttempt:U,execServer:Re}),!Re)throw new o.$UN(`Exec server was not available for ${de}`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(Ee){return C.mark(`code/extHost/didResolveAuthorityError/${J}`),se("returned an error",Ee),Fe.dispose(),X(Ee)}Fe.dispose();const De={environmentTunnels:Be.environmentTunnels,features:Be.tunnelFeatures?{elevation:Be.tunnelFeatures.elevation,privacyOptions:Be.tunnelFeatures.privacyOptions,protocol:Be.tunnelFeatures.protocol===void 0?!0:Be.tunnelFeatures.protocol}:void 0},Ce={extensionHostEnv:Be.extensionHostEnv,isTrusted:Be.isTrusted,authenticationSession:Be.authenticationSessionForInitializingExtensions?{id:Be.authenticationSessionForInitializingExtensions.id,providerId:Be.authenticationSessionForInitializingExtensions.providerId}:void 0};te(`returned ${o.$TN.isManagedResolvedAuthority(Be)?"managed authority":`${Be.host}:${Be.port}`}`);let V;if(o.$TN.isManagedResolvedAuthority(Be)){const G=U;this.Y.setFactory(G,Be.makeConnection),V={authority:Y,connectTo:new n.$Sl(G),connectionToken:Be.connectionToken}}else V={authority:Y,connectTo:new n.$Tl(Be.host,Be.port),connectionToken:Be.connectionToken};return{type:"ok",value:{authority:V,options:Ce,tunnelInformation:De}}}async $getCanonicalURI(Y,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,n.$Vl)(Y)})`);const{resolver:oe}=await this.ub(Y);if(!oe)return null;const ve=c.URI.revive(U);if(typeof oe.getCanonicalURI>"u")return ve;const te=await(0,O.$xh)(()=>oe.getCanonicalURI(ve));return te||ve}async $startExtensionHost(Y){Y.toAdd.forEach(ae=>ae.extensionLocation=c.URI.revive(ae.extensionLocation));const{globalRegistry:U,myExtensions:oe}=H(this.I,this.L,this.J,Y),ve=await this.db(oe);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(U.getAllExtensionDescriptions()),this.J.set(oe),j.$u&&(this.s.info(`$startExtensionHost: global extensions: ${Q(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Q(this.J)}`)),this.tb()}$activateByEvent(Y,U){return U===m.ActivationKind.Immediate?this.D.wait().then(oe=>this.ab(Y,!1)):this.G.wait().then(oe=>this.ab(Y,!1))}async $activate(Y,U){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.bb(Y,U),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(ae=>ae.extensionLocation=c.URI.revive(ae.extensionLocation));const{globalRegistry:U,myExtensions:oe}=H(this.I,this.L,this.J,Y),ve=await this.db(oe);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(U.getAllExtensionDescriptions()),this.J.set(oe),j.$u&&(this.s.info(`$deltaExtensions: global extensions: ${Q(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Q(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const U=s.$Ne.alloc(Y),oe=Math.random()%256;for(let ve=0;ve<Y;ve++)U.writeUInt8(oe,ve);return U}async $updateRemoteConnectionData(Y){this.X=Y,this.a.fire()}};e.$rqc=ee,e.$rqc=ee=B=Je([Ve(0,d.$Ei),Ve(1,e.$qqc),Ve(2,E.$kQ),Ve(3,a.$Opc),Ve(4,u.$Rpc),Ve(5,I.$ak),Ve(6,l.$AQ),Ve(7,g.$Upc),Ve(8,y.$jGb),Ve(9,k.$dqc),Ve(10,M.$nqc),Ve(11,W.$oqc),Ve(12,A.$hqc)],ee);function H(ge,Y,U,oe){ge.addActivationEvents(oe.addActivationEvents);const ve=new $.$Mdc(ge,Y.getAllExtensionDescriptions());ve.deltaExtensions(oe.toAdd,oe.toRemove);const te=new i.$sn(U.getAllExtensionDescriptions().map(se=>se.identifier));for(const se of oe.myToRemove)te.delete(se);for(const se of oe.myToAdd)te.add(se);const ae=ce(ve,te);return{globalRegistry:ve,myExtensions:ae}}function q(ge,Y){return{id:ge.identifier.value,name:ge.name,extensionVersion:ge.version,publisherDisplayName:ge.publisher,activationEvents:ge.activationEvents?ge.activationEvents.join(","):null,isBuiltin:ge.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function Q(ge){return ge.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$sqc=(0,d.$Fi)("IExtHostExtensionService");class _{#e;#t;#i;constructor(Y,U,oe,ve,te){this.#e=Y,this.#t=U,this.#i=oe.identifier,this.id=oe.identifier.value,this.extensionUri=oe.extensionLocation,this.extensionPath=h.$hc((0,R.$7g)(oe.extensionLocation)),this.packageJSON=oe,this.extensionKind=ve,this.isFromDifferentExtensionHost=te}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$tqc=_;function ce(ge,Y){return ge.getAllExtensionDescriptions().filter(U=>Y.has(U.identifier))}class ne{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$uqc=ne;class ye{constructor(Y){this.a=new i.$tn,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const U of Object.keys(Y))this.a.set(U,Y[U])}}}),define(ke[339],Ie([1,0,61,2,6,41,25,23,19,29,5,54,11,12]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Frc=void 0,r=qe(r);let a=class{constructor(s,t,o,n,d,l,g){this.c=s,this.d=t,this.e=o,this.f=n,this.g=d,this.h=l,this.i=g,this.a=new Map,this.b=[]}async install(){this.j(),r.mark("code/extHost/willWaitForConfig");const s=await this.f.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new $(this.c,t,this.d,s,this.i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(f,t,this.h.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const t of s.nodeModuleName)this.a.set(t,s);else this.a.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this.b.push(t=>s.alternativeModuleName(t))}};e.$Frc=a,e.$Frc=a=Je([Ve(2,I.$Ei),Ve(3,R.$Rpc),Ve(4,S.$sqc),Ve(5,c.$AQ),Ve(6,u.$ak)],a);let m=class{static{w=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(s){if(s.environment.appRoot&&w.a.size){const t=(0,P.$hf)(this.c(s.environment.appRoot.fsPath)),o="[a-z0-9_.-]",n=`@${o}+\\/${o}+|${o}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${d}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(s){if(!this.b)return;const t=this.b.exec(this.c(s));if(!t)return;const[,o,n,d]=t,l=w.a.get(n);if(l!==void 0)return console.warn(`${n} as been renamed to ${l}, please update your imports`),o+l+d}c(s){return s.replace(/\\/g,"/")}};m=w=Je([Ve(0,c.$AQ)],m);class ${constructor(s,t,o,n,d){this.c=s,this.d=t,this.e=o,this.f=n,this.g=d,this.nodeModuleName="vscode",this.a=new T.$tn}load(s,t){const o=this.d.findSubstr(t);if(o){let n=this.a.get(o.identifier);return n||(n=this.c(o,this.e,this.f),this.a.set(o.identifier,n)),n}if(!this.b){let n="";this.d.forEach((d,l)=>n+=`	${l} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${n}`),this.b=this.c(O.$aH,this.e,this.f)}return this.b}}let f=class{constructor(s,t,o){this.e=s,this.f=t,this.nodeModuleName=["open","opn"],this.d=o.getProxy(C.$KN.MainThreadTelemetry);const n=o.getProxy(C.$KN.MainThreadWindow);this.c=(d,l)=>{const g=h.URI.parse(d);return l?this.g(d,l):g.scheme==="http"||g.scheme==="https"?n.$openUri(g,d,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this.f?n.$openUri(g,d,{}):this.g(d,l)}}load(s,t,o){const n=this.e.findSubstr(t);return n&&(this.a=n.identifier.value,this.h()),this.b=o(s),this.c}g(s,t){return this.i(),this.b(s,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};f=Je([Ve(2,p.$kQ)],f)}),define(ke[64],Ie([1,0,50,3,16,55,5,63,77,54,9,49,267,41]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=e.$vqc=void 0,C=qe(C),R=qe(R),e.$vqc=(0,O.$Fi)("IExtHostVariableResolverProvider");class w extends u.$oR{constructor($,f,i,s,t,o,n){function d(){if(i){const l=i.activeEditor();if(l)return l.document.uri;const g=s.tabGroups.all.find(E=>E.isActive)?.activeTab;if(g!==void 0){if(g.input instanceof I.$BP||g.input instanceof I.$GP)return g.input.modified;if(g.input instanceof I.$AP||g.input instanceof I.$FP||g.input instanceof I.$DP)return g.input.uri}}}super({getFolderUri:l=>{const g=o.folders.filter(E=>E.name===l);if(g&&g.length>0)return g[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(l,g)=>t.getConfiguration(void 0,l).get(g),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=d();if(l)return C.$hc(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(f){const l=d();if(l){const g=f.getWorkspaceFolder(l);if(g)return C.$hc(g.uri.fsPath)}}},getSelectedText:()=>{if(i){const l=i.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(i){const l=i.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>$.getExtension(l)},void 0,n?Promise.resolve(n):void 0,Promise.resolve(R.env))}}let a=class extends h.$Uc{constructor($,f,i,s,t){super(),this.b=$,this.c=f,this.g=i,this.h=s,this.j=t,this.a=new r.$T(async()=>{const o=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new w(this.b,this.c,this.g,this.j,o,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$wqc=a,e.$wqc=a=Je([Ve(0,c.$sqc),Ve(1,S.$Opc),Ve(2,T.$vQ),Ve(3,P.$Rpc),Ve(4,p.$4pc)],a)}),define(ke[101],Ie([1,0,7,4,2,3,23,5,6,77,54,19,9,49,154,119,258,41,64,51,34,15,18,98]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gqc=e.$Fqc=e.$Eqc=e.$Dqc=e.$Cqc=void 0,t=qe(t),e.$Cqc=(0,T.$Fi)("IExtHostDebugService");let d=class extends R.$Uc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(A,b,v,F,N,L,M,z){super(),this.Y=b,this.Z=v,this.$=F,this.ab=N,this.bb=L,this.cb=M,this.db=z,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new h.$le),this.z=this.B(new h.$le),this.C=this.B(new h.$le),this.F=this.B(new h.$le),this.u=A.getProxy(p.$KN.MainThreadDebugService),this.I=this.B(new h.$le),this.L=this.B(new h.$le),this.G=new g(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(j=>{this.B(j.onDidChange(W=>{this.fb(j)})),this.fb(j)})}async $getVisualizerTreeItem(A,b){const v=this.gb(b);if(!v)return;const F=await this.Q.get(A)?.getTreeItem?.(v);return F?this.eb(A,F):void 0}registerDebugVisualizationTree(A,b,v){const F=O.$rn.toKey(A.identifier),N=this.ub(F,b);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${b}' is already registered`);return this.Q.set(N,v),this.u.$registerDebugVisualizerTree(N,!!v.editItem),(0,R.$Sc)(()=>{this.u.$unregisterDebugVisualizerTree(N),this.Q.delete(b)})}async $getVisualizerTreeItemChildren(A,b){const v=this.S.get(b)?.item;return v?(await this.Q.get(A)?.getChildren?.(v))?.map(N=>this.eb(A,N))||[]:[]}async $editVisualizerTreeItem(A,b){const v=this.S.get(A);if(!v)return;const F=await this.Q.get(v.provider)?.editItem?.(v.item,b);return this.eb(v.provider,F||v.item)}$disposeVisualizedTree(A){const b=this.S.get(A);if(!b)return;const v=[b.children];for(const F of v)if(F)for(const N of F)v.push(this.S.get(N)?.children),this.S.delete(N)}eb(A,b){let v=this.R.get(b);return v||(v=this.O++,this.R.set(b,v),this.S.set(v,{provider:A,item:b})),t.DebugTreeItem.from(b,v)}asDebugSourceUri(A,b){const v=A;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let F=`debug:${encodeURIComponent(v.path||"")}`,N="?";return b&&(F+=`${N}session=${encodeURIComponent(b.id)}`,N="&"),F+=`${N}ref=${v.sourceReference}`,C.URI.parse(F)}else{if(v.path)return C.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(A){const b=[];for(const v of A.getAllExtensionDescriptions())if(v.contributes){const F=v.contributes.debuggers;if(F&&F.length>0)for(const N of F)(0,m.$_H)(N)&&b.push(N.type)}this.u.$registerDebugTypes(b)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const A=[];return this.H.forEach(b=>A.push(b)),A}async $resolveDebugVisualizer(A,b){const v=this.W.get(A);if(!v)throw new Error(`No debug visualizer found with id '${A}'`);let{v:F,provider:N,extensionId:L}=v;if(F.visualization||(F=await N.resolveDebugVisualization?.(F,b)||F,v.v=F),!F.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.vb(L,F.visualization)}async $executeDebugVisualizerCommand(A){const b=this.W.get(A);if(!b)throw new Error(`No debug visualizer found with id '${A}'`);const v=b.v.visualization;v&&"command"in v&&this.cb.executeCommand(v.command,...v.arguments||[])}gb(A){const b=this.w.get(A.sessionId);return b&&{session:b.api,variable:A.variable,containerId:A.containerId,frameId:A.frameId,threadId:A.threadId}}async $provideDebugVisualizers(A,b,v,F){const N=this.gb(v),L=this.ub(A,b),M=this.P.get(L);if(!N||!M)return[];const z=await M.provideDebugVisualization(N,F);return z?z.map(j=>{const W=++this.X;this.W.set(W,{v:j,provider:M,extensionId:A});const B=j.iconPath?this.wb(j.iconPath):void 0;return{id:W,name:j.name,iconClass:B?.iconClass,iconPath:B?.iconPath,visualization:this.vb(A,j.visualization)}}):[]}$disposeDebugVisualizers(A){for(const b of A)this.W.delete(b)}registerDebugVisualizationProvider(A,b,v){if(!A.contributes?.debugVisualizers?.some(L=>L.id===b))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${b})`);const F=O.$rn.toKey(A.identifier),N=this.ub(F,b);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${b}' is already registered`);return this.P.set(N,v),this.u.$registerDebugVisualizer(F,b),(0,R.$Sc)(()=>{this.u.$unregisterDebugVisualizer(F,b),this.P.delete(b)})}addBreakpoints(A){const b=A.filter(N=>{const L=N.id;return this.H.has(L)?!1:(this.H.set(L,N),!0)});this.rb(b,[],[]);const v=[],F=new Map;for(const N of b)if(N instanceof u.$QO){let L=F.get(N.location.uri.toString());L||(L={type:"sourceMulti",uri:N.location.uri,lines:[]},F.set(N.location.uri.toString(),L),v.push(L)),L.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof u.$RO&&v.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this.u.$registerBreakpoints(v)}removeBreakpoints(A){const b=A.filter(L=>this.H.delete(L.id));this.rb([],b,[]);const v=b.filter(L=>L instanceof u.$QO).map(L=>L.id),F=b.filter(L=>L instanceof u.$RO).map(L=>L.id),N=b.filter(L=>L instanceof u.$SO).map(L=>L.id);return this.u.$unregisterBreakpoints(v,F,N)}startDebugging(A,b,v){const F=v.testRun&&this.db.getMetadataForRun(v.testRun);return this.u.$startDebugging(A?A.uri:void 0,b,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,testRun:F&&{runId:F.runId,taskId:F.taskId},suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(A){return this.u.$stopDebugging(A?A.id:void 0)}registerDebugConfigurationProvider(A,b,v){if(!b)return new u.$MN(()=>{});const F=this.f++;return this.g.push({type:A,handle:F,provider:b}),this.u.$registerDebugConfigurationProvider(A,v,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,F),new u.$MN(()=>{this.g=this.g.filter(N=>N.provider!==b),this.u.$unregisterDebugConfigurationProvider(F)})}registerDebugAdapterDescriptorFactory(A,b,v){if(!v)return new u.$MN(()=>{});if(!this.nb(A,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.kb(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const F=this.h++;return this.j.push({type:b,handle:F,factory:v}),this.u.$registerDebugAdapterDescriptorFactory(b,F),new u.$MN(()=>{this.j=this.j.filter(N=>N.factory!==v),this.u.$unregisterDebugAdapterDescriptorFactory(F)})}registerDebugAdapterTrackerFactory(A,b){if(!b)return new u.$MN(()=>{});const v=this.m++;return this.n.push({type:A,handle:v,factory:b}),new u.$MN(()=>{this.n=this.n.filter(F=>F.factory!==b)})}async $runInTerminal(A,b){return Promise.resolve(void 0)}async $substituteVariables(A,b){let v;const F=await this.tb(A);return F&&(v={uri:F.uri,name:F.name,index:F.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(v,b)}hb(A,b){if(A.type==="implementation")return new D(A.implementation)}ib(){}async $startDASession(A,b){const v=this,F=await this.sb(b);return this.pb(this.kb(F.type),F).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}' (extension might have failed to activate)`);const L=this.jb(N),M=this.hb(L,F);if(!M)throw new Error(`Couldn't create a debug adapter for type '${F.type}'.`);const z=M;return this.M.set(A,z),this.ob(F).then(j=>(j&&this.N.set(A,j),z.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const B=W,ee={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const H=await this.U.sign(B.arguments.value);ee.body={signature:H},z.sendResponse(ee)}else throw new Error("no signer")}catch(H){ee.success=!1,ee.message=H.message,z.sendResponse(ee)}}else j&&j.onDidSendMessage&&j.onDidSendMessage(W),W=(0,m.$eI)(W,!0),v.u.$acceptDAMessage(A,W)}),z.onError(W=>{j&&j.onError&&j.onError(W),this.u.$acceptDAError(A,W.name,W.message,W.stack)}),z.onExit(W=>{j&&j.onExit&&j.onExit(W??void 0,void 0),this.u.$acceptDAExit(A,W??void 0,void 0)}),j&&j.onWillStartSession&&j.onWillStartSession(),z.startSession()))})}$sendDAMessage(A,b){b=(0,m.$dI)(b,!1);const v=this.N.get(A);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(b),this.M.get(A)?.sendMessage(b)}$stopDASession(A){const b=this.N.get(A);this.N.delete(A),b&&b.onWillStopSession&&b.onWillStopSession();const v=this.M.get(A);return this.M.delete(A),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(A){const b=[],v=[],F=[];if(A.added)for(const N of A.added){const L=N.id;if(L&&!this.H.has(L)){let M;if(N.type==="function")M=new u.$RO(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")M=new u.$SO(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const z=C.URI.revive(N.uri);M=new u.$QO(new u.$1N(z,new u.$NN(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,u.$OO)(M,L),this.H.set(L,M),b.push(M)}}if(A.removed)for(const N of A.removed){const L=this.H.get(N);L&&(this.H.delete(N),v.push(L))}if(A.changed){for(const N of A.changed)if(N.id){const L=this.H.get(N.id);if(L){if(L instanceof u.$RO&&N.type==="function"){const M=L;M.enabled=N.enabled,M.condition=N.condition,M.hitCondition=N.hitCondition,M.logMessage=N.logMessage,M.functionName=N.functionName}else if(L instanceof u.$QO&&N.type==="source"){const M=L;M.enabled=N.enabled,M.condition=N.condition,M.hitCondition=N.hitCondition,M.logMessage=N.logMessage,M.location=new u.$1N(C.URI.revive(N.uri),new u.$NN(N.line,N.character))}F.push(L)}}}this.rb(b,v,F)}async $acceptStackFrameFocus(A){let b;if(A){const v=await this.sb(A.sessionId);A.kind==="thread"?b=new u.$YO(v.api,A.threadId):b=new u.$XO(v.api,A.threadId,A.frameId)}this.J=b,this.L.fire(this.J)}$provideDebugConfigurations(A,b,v){return(0,r.$xh)(async()=>{const F=this.mb(A);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.tb(b);return F.provideDebugConfigurations(N,v)}).then(F=>{if(!F)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return F})}$resolveDebugConfiguration(A,b,v,F){return(0,r.$xh)(async()=>{const N=this.mb(A);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.tb(b);return N.resolveDebugConfiguration(L,v,F)})}$resolveDebugConfigurationWithSubstitutedVariables(A,b,v,F){return(0,r.$xh)(async()=>{const N=this.mb(A);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.tb(b);return N.resolveDebugConfigurationWithSubstitutedVariables(L,v,F)})}async $provideDebugAdapter(A,b){const v=this.lb(A);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const F=await this.sb(b);return this.pb(v,F).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}'`);return this.jb(N)})}async $acceptDebugSessionStarted(A){const b=await this.sb(A);this.y.fire(b.api)}async $acceptDebugSessionTerminated(A){const b=await this.sb(A);b&&(this.z.fire(b.api),this.w.delete(b.id))}async $acceptDebugSessionActiveChanged(A){this.D=A?await this.sb(A):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(A,b){(await this.sb(A))?._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(A,b){const F={session:(await this.sb(A)).api,event:b.event,body:b.body};this.F.fire(F)}jb(A){if(A instanceof u.$TO)return{type:"executable",command:A.command,args:A.args,options:A.options};if(A instanceof u.$UO)return{type:"server",port:A.port,host:A.host};if(A instanceof u.$VO)return{type:"pipeServer",path:A.path};if(A instanceof u.$WO)return{type:"implementation",implementation:A.implementation};throw new Error("convertToDto unexpected type")}kb(A){const b=this.j.filter(v=>v.type===A);if(b.length>0)return b[0].factory}lb(A){const b=this.j.filter(v=>v.handle===A);if(b.length>0)return b[0].factory}mb(A){const b=this.g.filter(v=>v.handle===A);if(b.length>0)return b[0].provider}nb(A,b){if(A.contributes){const v=A.contributes.debuggers;if(v&&v.length>0){for(const F of v)if(F.label&&F.type&&F.type===b)return!0}}return!1}ob(A){const v=A.configuration.type,F=this.n.filter(N=>N.type===v||N.type==="*").map(N=>(0,r.$xh)(()=>N.factory.createDebugAdapterTracker(A.api)).then(L=>L,L=>null));return Promise.race([Promise.all(F).then(N=>{const L=(0,o.$Gb)(N);if(L.length>0)return new E(L)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async pb(A,b){const v=b.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new u.$UO(v));if(A){const N=await this.Z.getExtensionRegistry();return(0,r.$xh)(()=>A.createDebugAdapterDescriptor(b.api,this.qb(b,N))).then(L=>{if(L)return L})}const F=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(b,F))}qb(A,b){}rb(A,b,v){(A.length>0||b.length>0||v.length>0)&&this.I.fire(Object.freeze({added:A,removed:b,changed:v}))}async sb(A){if(A)if(typeof A=="string"){const b=this.w.get(A);if(b)return b}else{let b=this.w.get(A.id);if(!b){const v=await this.tb(A.folderUri),F=A.parent?this.w.get(A.parent):void 0;b=new l(this.u,A.id,A.type,A.name,v,A.configuration,F?.api),this.w.set(b.id,b),this.u.$sessionCached(b.id)}return b}throw new Error("cannot find session")}tb(A){if(A){const b=C.URI.revive(A);return this.Y.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}ub(A,b){return`${A}\0${b}`}vb(A,b){if(b){if("title"in b&&"command"in b)return{type:a.DebugVisualizationType.Command};if("treeId"in b)return{type:a.DebugVisualizationType.Tree,id:`${A}\0${b.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(A){const b=this.xb(A);let v,F;return"id"in b?F=i.ThemeIcon.asClassName(b):v=b,{iconPath:v,iconClass:F}}xb(A){if(A instanceof u.$LO)return{id:A.id};const b=typeof A=="object"&&"dark"in A?A.dark:A,v=typeof A=="object"&&"light"in A?A.light:A;return{dark:typeof b=="string"?C.URI.file(b):b,light:typeof v=="string"?C.URI.file(v):v}}};e.$Dqc=d,e.$Dqc=d=Je([Ve(0,S.$kQ),Ve(1,P.$Opc),Ve(2,I.$sqc),Ve(3,$.$Rpc),Ve(4,c.$4pc),Ve(5,f.$vqc),Ve(6,s.$GQ),Ve(7,n.$xqc)],d);class l{constructor(A,b,v,F,N,L,M){this.f=A,this.g=b,this.h=v,this.j=F,this.k=N,this.l=L,this.m=M}get api(){const A=this;return this.d??=Object.freeze({id:A.g,type:A.h,get name(){return A.j},set name(b){A.j=b,A.f.$setDebugSessionName(A.g,b)},parentSession:A.m,workspaceFolder:A.k,configuration:A.l,customRequest(b,v){return A.f.$customDebugAdapterRequest(A.g,b,v)},getDebugProtocolBreakpoint(b){return A.f.$getDebugProtocolBreakpoint(A.g,b.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(A){this.j=A}get configuration(){return this.l}}e.$Eqc=l;class g{constructor(A){this.value=Object.freeze({append(b){A.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.$Fqc=g;class E{constructor(A){this.d=A}onWillStartSession(){this.d.forEach(A=>A.onWillStartSession?A.onWillStartSession():void 0)}onWillReceiveMessage(A){this.d.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(A):void 0)}onDidSendMessage(A){this.d.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(A):void 0)}onWillStopSession(){this.d.forEach(A=>A.onWillStopSession?A.onWillStopSession():void 0)}onError(A){this.d.forEach(b=>b.onError?b.onError(A):void 0)}onExit(A,b){this.d.forEach(v=>v.onExit?v.onExit(A,b):void 0)}}class D extends w.$0tb{constructor(A){super(),this.h=A,A.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(A){this.h.handleMessage(A)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let y=class extends d{constructor(A,b,v,F,N,L,M,z){super(A,b,v,F,N,L,M,z)}};e.$Gqc=y,e.$Gqc=y=Je([Ve(0,S.$kQ),Ve(1,P.$Opc),Ve(2,I.$sqc),Ve(3,$.$Rpc),Ve(4,c.$4pc),Ve(5,f.$vqc),Ve(6,s.$GQ),Ve(7,n.$xqc)],y)}),define(ke[340],Ie([1,0,13,61,2,6,288,11,88,114,29,225,19,72,54,94]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hrc=e.$Grc=void 0,r=qe(r),h=qe(h);class m{static async installEarlyHandler(i){Error.stackTraceLimit=100;const s=i.get(T.$ak),o=i.get(u.$kQ).getProxy(R.$KN.MainThreadErrors);r.setUnexpectedErrorHandler(n=>{s.error(n);const d=r.$1(n);o.$onUnexpectedError(d)})}static async installFullHandler(i){const s=i.get(T.$ak),t=i.get(u.$kQ),o=i.get(w.$sqc),n=i.get(a.$EQ),d=t.getProxy(R.$KN.MainThreadExtensionService),l=t.getProxy(R.$KN.MainThreadErrors),g=await o.getExtensionPathIndex(),E=new WeakMap;function D(A,b){if(E.has(A))return E.get(A).stack;let v="",F,N;for(const M of b)v+=`
	at ${M.toString()}`,N=M.getFileName(),!F&&N&&(F=g.findSubstr(C.URI.file(N)));const L=`${A.name||"Error"}: ${A.message||""}${v}`;return E.set(A,{extensionIdentifier:F?.identifier,stack:L}),L}const y=Symbol("prepareStackTrace wrapped");let k=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return k},set(A){if(A===D||!A||A[y]){k=A||D;return}k=function(b,v){return D(b,v),A.call(Error,b,v)},Object.assign(k,{[y]:!0})}}),r.setUnexpectedErrorHandler(A=>{s.error(A);const b=r.$1(A),v=E.get(A);if(!v?.extensionIdentifier){l.$onUnexpectedError(b);return}d.$onExtensionRuntimeError(v.extensionIdentifier,b);const F=n.onExtensionError(v.extensionIdentifier,A);s.trace("forwarded error to extension?",F,v)})}}e.$Grc=m;class ${constructor(i,s,t,o,n){this.a=t,this.b=new O.$Udc(i,null,o),s=$.e(s,this.b);const d=new c.$Di(...(0,p.$Ss)());d.set(I.$AQ,{_serviceBrand:void 0,...s,messagePorts:n}),d.set(u.$kQ,new u.$lQ(this.b)),d.set(P.$Lpc,new P.$Mpc(o)),d.set(w.$qqc,t);const l=new S.$wr(d,!0);l.invokeFunction(m.installEarlyHandler),this.d=l.invokeFunction(g=>g.get(T.$ak)),h.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",s),this.c=l.invokeFunction(g=>g.get(w.$sqc)),this.c.initialize(),l.invokeFunction(m.installFullHandler)}async asBrowserUri(i){const s=this.b.getProxy(R.$KN.MainThreadExtensionService);return C.URI.revive(await s.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,s){i.extensions.allExtensions.forEach(o=>{o.extensionLocation=C.URI.revive(s.transformIncomingURIs(o.extensionLocation))}),i.environment.appRoot=C.URI.revive(s.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(o=>C.URI.revive(s.transformIncomingURIs(o)))),i.environment.extensionTestsLocationURI=C.URI.revive(s.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=C.URI.revive(s.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=C.URI.revive(s.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=C.URI.revive(s.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=C.URI.revive(s.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=C.URI.revive(s.transformIncomingURIs(i.logsLocation)),i.workspace=s.transformIncomingURIs(i.workspace),i}}e.$Hrc=$}),define(ke[341],Ie([1,0,7,10,8,218,148,101,77,54,19,48,9,64,49,259,260,41,34,98]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rrc=void 0,h=qe(h),C=qe(C);let s=class extends T.$Dqc{constructor(l,g,E,D,y,k,A,b,v){super(l,g,E,D,k,A,b,v),this.Ab=y,this.yb=new n}hb(l,g){switch(l.type){case"server":return new a.$Mrc(l);case"pipeServer":return new a.$Nrc(l);case"executable":return new a.$Orc(l,g.type)}return super.hb(l,g)}qb(l,g){const E=a.$Orc.platformAdapterExecutable(g.getAllExtensionDescriptions(),l.type);if(E)return new u.$TO(E.command,E.args,E.options)}ib(){return new O.$Uhc}async $runInTerminal(l,g){if(l.kind==="integrated"){this.zb||(this.zb=this.B(this.Ab.onDidCloseTerminal(z=>{this.yb.onTerminalClosed(z)})));const E=await this.$.getConfigProvider(),D=this.Ab.getDefaultShell(!0),y=this.Ab.getDefaultShellArgs(!0),k=l.title||C.localize(10807,null),A=JSON.stringify({shell:D,shellArgs:y});let b=await this.yb.checkout(A,k),v,F=!1;if(b)v=l.cwd;else{const z={shellPath:D,shellArgs:y,cwd:l.cwd,name:k,iconPath:new u.$LO("debug")};F=!0,b=this.Ab.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.yb.insert(b,A)}b.show(!0);const N=await b.processId;F?await new Promise(z=>setTimeout(z,1e3)):(b.state.isInteractedWith&&(b.sendText(""),await(0,r.$Gh)(200)),E.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0||D.indexOf("cmd.exe")>=0?b.sendText("cls"):D.indexOf("bash")>=0?b.sendText("clear"):h.$j?b.sendText("cls"):b.sendText("clear")));const L=(0,m.$Qrc)(D,l.args,!!l.argsCanBeInterpretedByShell,v,l.env);b.sendText(L);const M=this.onDidTerminateDebugSession(z=>{z.id===g&&(this.yb.free(b),M.dispose())});return N}else if(l.kind==="external")return o(l,await this.$.getConfigProvider());return super.$runInTerminal(l,g)}};e.$Rrc=s,e.$Rrc=s=Je([Ve(0,I.$kQ),Ve(1,w.$Opc),Ve(2,c.$sqc),Ve(3,$.$Rpc),Ve(4,S.$dqc),Ve(5,p.$4pc),Ve(6,P.$vqc),Ve(7,f.$GQ),Ve(8,i.$xqc)],s);let t;function o(d,l){if(!t)if(h.$j)t=new R.$Cgc;else if(h.$k)t=new R.$Dgc;else if(h.$l)t=new R.$Egc;else throw new Error("external terminals not supported on this platform");const g=l.getConfiguration("terminal");return t.runInTerminal(d.title,d.cwd,d.args,d.env||{},g.external||{})}class n{constructor(){this.b=new Map}static{this.a=1e3}async checkout(l,g,E=!1){const y=[...this.b.entries()].map(([k,A])=>(0,r.$sh)(async b=>{if(k.name!==g||A.lastUsedAt!==-1&&await(0,m.$Prc)(await k.processId))return null;const v=Date.now();return A.lastUsedAt+n.a>v||b.isCancellationRequested?null:A.config!==l?(E&&k.dispose(),null):(A.lastUsedAt=v,k)}));return await(0,r.$Kh)(y,k=>!!k)}insert(l,g){this.b.set(l,{lastUsedAt:Date.now(),config:g})}free(l){const g=this.b.get(l);g&&(g.lastUsedAt=-1)}onTerminalClosed(l){this.b.delete(l)}}}),define(ke[342],Ie([1,0,16,2,109,49,63,41,47,48,19,29,100,14,11,95,22,66,64]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jrc=void 0,r=qe(r),m=qe(m);let i=class extends u.$nrc{constructor(t,o,n,d,l,g,E,D,y){super(t,o,n,d,l,g,E,D),this.C=n,this.D=y,o.remote.isRemote&&o.remote.authority?this.registerTaskSystem(P.Schemas.vscodeRemote,{scheme:P.Schemas.vscodeRemote,authority:o.remote.authority,platform:process.platform}):this.registerTaskSystem(P.Schemas.file,{scheme:P.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,o){const n=o;if(!o.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const d=u.TaskHandleDTO.from(n,this.C),l=await this.a.$getTaskExecution(d);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const g=await this.z(l,o);return this.a.$executeTask(d).catch(()=>{}),g}else{const d=u.TaskDTO.from(o,t);if(d===void 0)return Promise.reject(new Error("Task is not valid"));u.CustomExecutionDTO.is(d.execution)&&await this.y(d,o,!1);const l=await this.z(await this.a.$getTaskExecution(d),o);return this.a.$executeTask(d).catch(()=>{}),l}}v(t,o,n,d){const l=[];if(d)for(const g of d){this.A(g,n),(!g.definition||!t[g.definition.type])&&this.f.warn(`The task [${g.source}, ${g.name}] uses an undefined task type. The task will be ignored in the future.`);const E=u.TaskDTO.from(g,n.extension);E&&(l.push(E),u.CustomExecutionDTO.is(E.execution)&&o.push(this.y(E,g,!0)))}return{tasks:l,extension:n.extension}}async w(t){return t}async G(t){let o=t&&t.length>0?t[0]:void 0;if(!o){const n=h.URI.file((0,$.homedir)());o=new p.$Zi({uri:n,name:m.$dh(n),index:0})}return{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,o){const n=h.URI.revive(t),d={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(n),g=await this.b.getWorkspaceFolders2()??[],E=await this.D.getResolver(),D=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(g);for(const y of o.variables)d.variables[y]=await E.resolveAsync(D,y);if(o.process!==void 0){let y;if(o.process.path!==void 0){y=o.process.path.split(r.$tc);for(let k=0;k<y.length;k++)y[k]=await E.resolveAsync(D,y[k])}d.process=await C.win32.findExecutable(await E.resolveAsync(D,o.process.name),o.process.cwd!==void 0?await E.resolveAsync(D,o.process.cwd):void 0,y)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(t,o,n){return C.win32.findExecutable(t,o,n)}};e.$Jrc=i,e.$Jrc=i=Je([Ve(0,I.$kQ),Ve(1,S.$AQ),Ve(2,R.$Opc),Ve(3,O.$vQ),Ve(4,T.$Rpc),Ve(5,c.$dqc),Ve(6,w.$ak),Ve(7,a.$spc),Ve(8,f.$vqc)],i)}),define(ke[343],Ie([1,0,66,64]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$psc=void 0;class C extends h.$wqc{m(){return(0,r.homedir)()}}e.$psc=C}),define(ke[171],Ie([1,0,18,7,20,52,14,16,22,2,37]),function($e,e,r,h,C,R,O,T,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xqc=e.$Vqc=e.$Uqc=void 0,e.$Wqc=a,T=qe(T),p=qe(p);class S{constructor(f,i,s){this.d=f,this.e=i,this.f=s,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(f,i){const s=this.g.folderQueries||[],t=new C.$we(i);return new Promise((o,n)=>{this.a=new P(f);let d=!1;const l=(g,E)=>{if(!d&&!this.b){const D=this.h(g);a(g)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,d=!0,t.cancel(),g=this.j(g,this.g.maxResults-this.c));const y=this.h(g);this.c+=y,(y>0||!a(g))&&this.a.add(g,E)}};Promise.all(s.map((g,E)=>this.k(g,D=>l(D,E),t.token))).then(g=>{t.dispose(),this.a.flush();const E=g.some(D=>!!D&&!!D.limitHit);o({limitHit:this.b||E,messages:g.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},g=>{t.dispose();const E=(0,R.$qj)(g);n(new Error(E))})})}h(f){return a(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}j(f,i){const s=Array.isArray(f.ranges)?f.ranges:[f.ranges],t=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:s.slice(0,i),preview:{matches:t.slice(0,i),text:f.preview.text},uri:f.uri}}async k(f,i,s){const t=new I.$oM(this.g,f),o=[],n={report:g=>{if(!this.l(g))return;const E=f.folder.scheme===O.Schemas.file?(0,I.$pM)(()=>this.e.readdir(p.$fh(g.uri))):void 0,D=p.$ih(f.folder,g.uri);if(D){const y=t.includedInQuery(D,T.$nc(D),E);(0,h.$rh)(y)?o.push(y.then(k=>{k&&i(g)})):y&&i(g)}}},d=this.n(f);let l;return this.d.query.type===I.QueryType.aiText?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,d,n,s):l=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),d,n,s),o.length&&await Promise.all(o),l}l(f){if(a(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(f){const i=(0,I.$nM)(this.g.includePattern,f.includePattern),s=(0,I.$nM)(this.g.excludePattern,f.excludePattern),t={folder:c.URI.from(f.folder),excludes:s,includes:i,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.e.toCanonicalName(f.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??I.$7L,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$Uqc=S;function u($){return{isCaseSensitive:$.isCaseSensitive||!1,isRegExp:$.isRegExp||!1,isWordMatch:$.isWordMatch||!1,isMultiline:$.isMultiline||!1,pattern:$.pattern}}class P{constructor(f){this.e=f,this.b=-1,this.d=null,this.a=new m(512,i=>this.g(i))}add(f,i){this.d&&(this.b!==i||!p.$_g(this.c,f.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:f.uri,results:[]}),this.d.results.push(w(f))}f(){const f=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,f)}flush(){this.f(),this.a.flush()}g(f){this.e(f)}}e.$Vqc=P;function w($){return a($)?{preview:{matches:(0,r.$Zb)($.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:$.preview.text},ranges:(0,r.$Zb)($.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:$.text,lineNumber:$.lineNumber}}function a($){return!!$.preview}class m{static{this.a=4e3}static{this.b=50}constructor(f,i){this.g=f,this.h=i,this.c=0,this.d=[],this.e=0}addItem(f,i){f&&this.j(f,i)}addItems(f,i){f&&this.k(f,i)}j(f,i){this.d.push(f),this.e+=i,this.l()}k(f,i){this.d=this.d.concat(f),this.e+=i,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Xqc=m}),define(ke[102],Ie([1,0,3,6,5,336,19,72,11,2,171]),function($e,e,r,h,C,R,O,T,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zqc=e.$Yqc=void 0,e.$1qc=u,e.$Yqc=(0,C.$Fi)("IExtHostSearch");let S=class{constructor(a,m,$){this.n=a,this.o=m,this.q=$,this.c=this.n.getProxy(h.$KN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$Tqc}s(a){return this.o.transformOutgoingScheme(a)}registerTextSearchProvider(a,m){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const $=this.d++;return this.e.set($,m),this.c.$registerTextSearchProvider($,this.s(a)),(0,r.$Sc)(()=>{this.g.delete(a),this.e.delete($),this.c.$unregisterProvider($)})}registerAITextSearchProvider(a,m){if(this.i.has(a))throw new Error(`an AI text search provider for the scheme '${a}'is already registered`);this.i.add(a);const $=this.d++;return this.h.set($,m),this.c.$registerAITextSearchProvider($,this.s(a)),(0,r.$Sc)(()=>{this.i.delete(a),this.h.delete($),this.c.$unregisterProvider($)})}registerFileSearchProvider(a,m){if(this.k.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.k.add(a);const $=this.d++;return this.j.set($,m),this.c.$registerFileSearchProvider($,this.s(a)),(0,r.$Sc)(()=>{this.k.delete(a),this.j.delete($),this.c.$unregisterProvider($)})}$provideFileSearchResults(a,m,$,f){const i=u($),s=this.j.get(a);if(s)return this.l.fileSearch(i,s,t=>{this.c.$handleFileMatch(a,m,t.map(o=>o.resource))},f);throw new Error("3 unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,m,$){return{messages:[]}}$clearCache(a){return this.l.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,m,$,f){const i=this.e.get(a);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${a}`);const s=u($);return this.t(s,i).search(o=>this.c.$handleTextMatch(a,m,o),f)}$provideAITextSearchResults(a,m,$,f){const i=this.h.get(a);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${a}`);const s=u($);return this.v(s,i).search(o=>this.c.$handleTextMatch(a,m,o),f)}$enableExtensionHostSearch(){}t(a,m){return new I.$Uqc({query:a,provider:m},{readdir:$=>Promise.resolve([]),toCanonicalName:$=>$},"textSearchProvider")}v(a,m){return new I.$Uqc({query:a,provider:m},{readdir:$=>Promise.resolve([]),toCanonicalName:$=>$},"aiTextSearchProvider")}};e.$Zqc=S,e.$Zqc=S=Je([Ve(0,O.$kQ),Ve(1,T.$Lpc),Ve(2,p.$ak)],S);function u(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(P),extraFileResources:w.extraFileResources&&w.extraFileResources.map(a=>c.URI.revive(a))}}function P(w){return{...w,folder:c.URI.revive(w.folder)}}});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[344],Ie([1,0,7,20,13,4,3,14,43,2,113,201,202,58,23,27,11,90,91,246,6,290,317,95,127,294,295,296,275,265,34,297,41,298,101,163,299,277,291,300,301,63,77,278,292,54,302,75,303,62,29,318,279,304,305,128,306,122,123,280,335,308,250,309,319,310,169,281,311,312,313,19,314,102,124,315,282,316,125,97,100,94,48,167,98,320,293,321,322,76,15,9,283,72,284,96,323,324,162,49,119,93,25,99]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l,g,E,D,y,k,A,b,v,F,N,L,M,z,j,W,B,ee,H,q,Q,_,ce,ne,ye,ge,Y,U,oe,ve,te,ae,se,X,re,pe,we,Fe,Be,Re,De,Ce,V,G,J,x,de,Ee,Le,He,Ze,et,nt,st,rt,at,gt,dt,ct,Pe,ze,Ke,Ne,je,ue,he,le,Xe,tt,ut,mt,Dt,Mt,Ht,ei,oi,Tt,it,Ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Brc=hi,C=qe(C),p=Ut(p),u=qe(u),a=qe(a),he=qe(he),le=qe(le);function hi(bt){const St=bt.get(ge.$AQ),ti=bt.get(ye.$wpc),ii=bt.get(ce.$Tpc),Wt=bt.get(Q.$sqc),pt=bt.get(ei.$Opc),Bt=bt.get(gt.$EQ),ni=bt.get(b.$Rpc),ai=bt.get(tt.$Lpc),xe=bt.get(de.$kQ),ci=bt.get(st.$aqc),di=bt.get(rt.$Upc),fi=bt.get(m.$bk),vt=bt.get(m.$ak),jt=bt.get(ue.$jGb),Nt=bt.get(n.$spc),Gt=bt.get(Ht.$Arc),ri=bt.get(He.$kqc),Qt=bt.get(ee.$4pc),li=bt.get(X.$oqc),qt=bt.get(d.$Cpc),Zt=bt.get(te.$hqc);xe.set(s.$LN.ExtHostFileSystemInfo,ti),xe.set(s.$LN.ExtHostLogLevelServiceShape,fi),xe.set(s.$LN.ExtHostWorkspace,pt),xe.set(s.$LN.ExtHostConfiguration,ni),xe.set(s.$LN.ExtHostExtensionService,Wt),xe.set(s.$LN.ExtHostStorage,ci),xe.set(s.$LN.ExtHostTunnelService,jt),xe.set(s.$LN.ExtHostWindow,Gt),xe.set(s.$LN.ExtHostSecretState,ri),xe.set(s.$LN.ExtHostTelemetry,Bt),xe.set(s.$LN.ExtHostEditorTabs,Qt),xe.set(s.$LN.ExtHostManagedSockets,li),xe.set(s.$LN.ExtHostAuthentication,qt),xe.set(s.$LN.ExtHostChatProvider,Zt);const Jt=xe.set(s.$LN.ExtHostDecorations,bt.get(N.$Iqc)),Ft=xe.set(s.$LN.ExtHostDocumentsAndEditors,bt.get(B.$vQ)),wt=xe.set(s.$LN.ExtHostCommands,bt.get(k.$GQ)),It=xe.set(s.$LN.ExtHostTerminalService,bt.get(dt.$dqc)),Kt=xe.set(s.$LN.ExtHostTerminalShellIntegration,bt.get(ct.$qrc)),Pt=xe.set(s.$LN.ExtHostDebugService,bt.get(F.$Cqc)),mi=xe.set(s.$LN.ExtHostSearch,bt.get(Le.$Yqc)),xt=xe.set(s.$LN.ExtHostTask,bt.get(at.$prc)),ki=xe.set(s.$LN.ExtHostOutputService,bt.get(Ce.$crc)),bi=xe.set(s.$LN.ExtHostLocalization,bt.get(se.$nqc)),Ri=xe.set(s.$LN.ExtHostUrls,new ut.$xrc(xe)),Ot=xe.set(s.$LN.ExtHostDocuments,new W.$zpc(xe,Ft)),Li=xe.set(s.$LN.ExtHostDocumentContentProviders,new z.$Kqc(xe,Ft,vt)),ui=xe.set(s.$LN.ExtHostDocumentSaveParticipant,new j.$Lqc(vt,Ot,xe.getProxy(s.$KN.MainThreadBulkEdits))),At=xe.set(s.$LN.ExtHostNotebook,new pe.$2qc(xe,wt,Ft,Ot,ii,mi,vt)),Ti=xe.set(s.$LN.ExtHostNotebookDocuments,new Fe.$9qc(At)),Ii=xe.set(s.$LN.ExtHostNotebookEditors,new Be.$0qc(vt,At)),Si=xe.set(s.$LN.ExtHostNotebookKernels,new Re.$$qc(xe,St,At,wt,vt)),Ni=xe.set(s.$LN.ExtHostNotebookRenderers,new De.$arc(xe,At)),wi=xe.set(s.$LN.ExtHostNotebookDocumentSaveParticipant,new we.$8qc(vt,At,xe.getProxy(s.$KN.MainThreadBulkEdits))),Vt=xe.set(s.$LN.ExtHostEditors,new ze.$Ipc(xe,Ft)),Te=xe.set(s.$LN.ExtHostTreeViews,new je.$vrc(xe.getProxy(s.$KN.MainThreadTreeViews),wt,vt)),Me=xe.set(s.$LN.ExtHostEditorInsets,new y.$Jpc(xe.getProxy(s.$KN.MainThreadEditorInsets),Vt,St.remote)),Se=xe.set(s.$LN.ExtHostDiagnostics,new L.$ypc(xe,vt,ti,Ft)),ie=xe.set(s.$LN.ExtHostLanguages,new ae.$6qc(xe,Ot,wt.converter,ai)),Ae=xe.set(s.$LN.ExtHostLanguageFeatures,new oe.$Apc(xe,ai,Ot,wt,Se,vt,Nt,Bt)),Ge=xe.set(s.$LN.ExtHostFileSystem,new _.$Oqc(xe,Ae)),_e=xe.set(s.$LN.ExtHostFileSystemEventService,new ne.$Pqc(xe,vt,Ft)),Qe=xe.set(s.$LN.ExtHostQuickOpen,(0,x.$grc)(xe,pt,wt)),ft=xe.set(s.$LN.ExtHostSCM,new Ee.$irc(xe,wt,Ot,vt)),Rt=xe.set(s.$LN.ExtHostQuickDiff,new J.$frc(xe,ai)),Xt=xe.set(s.$LN.ExtHostShare,new Ze.$jrc(xe,ai)),si=xe.set(s.$LN.ExtHostComments,(0,A.$Kpc)(xe,wt,Ot)),zt=xe.set(s.$LN.ExtHostProgress,new G.$erc(xe.getProxy(s.$KN.MainThreadProgress))),_t=xe.set(s.$LN.ExtHostLabelService,new U.$4qc(xe)),qi=xe.set(s.$LN.ExtHostTheming,new Ke.$src(xe)),rn=xe.set(s.$LN.ExtHostTimeline,new Ne.$urc(xe,wt)),Vi=xe.set(s.$LN.ExtHostWebviews,new mt.$Ypc(xe,St.remote,pt,vt,Nt)),Mi=xe.set(s.$LN.ExtHostWebviewPanels,new Dt.$2pc(xe,Vi,pt)),Hi=xe.set(s.$LN.ExtHostCustomEditors,new v.$3pc(xe,Ot,di,Vi,Mi)),Gi=xe.set(s.$LN.ExtHostWebviewViews,new Mt.$yrc(xe,Vi)),Pi=xe.set(s.$LN.ExtHostTesting,bt.get(Pe.$xqc)),sn=xe.set(s.$LN.ExtHostUriOpeners,new Xe.$wrc(xe)),on=xe.set(s.$LN.ExtHostProfileContentHandlers,new V.$drc(xe));xe.set(s.$LN.ExtHostInteractive,new Y.$3qc(xe,At,Ft,wt,vt));const ji=xe.set(s.$LN.ExtHostChatAgents2,new g.$Fpc(xe,vt,wt,Ot)),an=xe.set(s.$LN.ExtHostChatVariables,new E.$Gpc(xe)),zi=xe.set(s.$LN.ExtHostLanguageModelTools,new ve.$5qc(xe)),Ki=xe.set(s.$LN.ExtHostAiRelatedInformation,new t.$rpc(xe)),yn=xe.set(s.$LN.ExtHostAiEmbeddingVector,new q.$Nqc(xe)),cn=xe.set(s.$LN.ExtHostStatusBar,new nt.$mrc(xe,wt.converter)),Zi=xe.set(s.$LN.ExtHostSpeech,new et.$krc(xe)),Ci=xe.set(s.$LN.ExtHostEmbeddings,new H.$Mqc(xe)),Sn=Object.values(s.$LN);xe.assertRegistered(Sn);const Dn=new l.$Epc(xe,Ft),ln=new D.$Hpc(xe),Qi=new re.$7qc(xe,vt),Ji=new M.$Jqc(xe);return o.$Bpc.register(wt),function(We,vi,Xi){function lt(fe){return(be,Ue,ht)=>{const Et=fe(Lt=>{try{be.call(Ue,Lt)}catch(gi){C.$Z(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event: ${gi.toString()}`,{cause:gi})),Bt.onExtensionError(We.identifier,gi)}});return ht?.push(Et),Et}}const kt=function(){let fe=!We.isUnderDevelopment;function be(){fe||(vt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),fe=!0)}return function Ue(ht){if(Array.isArray(ht))ht.forEach(Ue);else if(typeof ht=="string")be();else{const Et=ht;typeof Et.scheme>"u"&&be(),typeof Et.exclusive=="boolean"&&(0,it.$gH)(We,"documentFiltersExclusive")}return ht}}(),Yi={getSession(fe,be,Ue){return typeof Ue?.forceNewSession=="object"&&Ue.forceNewSession.learnMore&&(0,it.$gH)(We,"authLearnMore"),Ue?.account&&(0,it.$gH)(We,"authGetSessions"),qt.getSession(We,fe,be,Ue)},getAccounts(fe){return(0,it.$gH)(We,"authGetSessions"),qt.getAccounts(fe)},async hasSession(fe,be){return(0,it.$gH)(We,"authSession"),!!await qt.getSession(We,fe,be,{silent:!0})},get onDidChangeSessions(){return lt(qt.onDidChangeSessions)},registerAuthenticationProvider(fe,be,Ue,ht){return qt.registerAuthenticationProvider(fe,be,Ue,ht)}},un={registerCommand(fe,be,Ue){return wt.registerCommand(!0,fe,be,Ue,void 0,We)},registerTextEditorCommand(fe,be,Ue){return wt.registerCommand(!0,fe,(...ht)=>{const Et=Vt.getActiveTextEditor();if(!Et){vt.warn("Cannot execute "+fe+" because there is no active text editor.");return}return Et.edit(Lt=>{be.apply(Ue,[Et,Lt,...ht])}).then(Lt=>{Lt||vt.warn("Edits from command "+fe+" were not applied.")},Lt=>{vt.warn("An error occurred while running command "+fe,Lt)})},void 0,void 0,We)},registerDiffInformationCommand:(fe,be,Ue)=>((0,it.$gH)(We,"diffCommand"),wt.registerCommand(!0,fe,async(...ht)=>{const Et=Ft.activeEditor(!0);if(!Et){vt.warn("Cannot execute "+fe+" because there is no active text editor.");return}const Lt=await Vt.getDiffInformation(Et.id);be.apply(Ue,[Lt,...ht])},void 0,void 0,We)),executeCommand(fe,...be){return wt.executeCommand(fe,...be)},getCommands(fe=!1){return wt.getCommands(fe)}},Ei={get machineId(){return St.telemetryInfo.machineId},get sessionId(){return St.telemetryInfo.sessionId},get language(){return St.environment.appLanguage},get appName(){return St.environment.appName},get appRoot(){return St.environment.appRoot?.fsPath??""},get appHost(){return St.environment.appHost},get uriScheme(){return St.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return It.getDefaultShell(!1)},get onDidChangeShell(){return lt(It.onDidChangeShell)},get isTelemetryEnabled(){return Bt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return lt(Bt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,it.$gH)(We,"telemetry"),Bt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,it.$gH)(We,"telemetry"),lt(Bt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,gt.$DQ)(St.telemetryInfo.firstSessionDate)},createTelemetryLogger(fe,be){return gt.$CQ.validateSender(fe),Bt.instantiateLogger(We,fe,be)},openExternal(fe,be){return Gt.openUri(fe,{allowTunneling:!!St.remote.authority,allowContributedOpeners:be?.allowContributedOpeners})},async asExternalUri(fe){if(fe.scheme===St.environment.appUriScheme)return Ri.createAppUri(fe);try{return await Gt.asExternalUri(fe,{allowTunneling:!!St.remote.authority})}catch(be){if((0,T.$Og)(fe,T.Schemas.http)||(0,T.$Og)(fe,T.Schemas.https))return fe;throw be}},get remoteName(){return(0,$.$in)(St.remote.authority)},get remoteAuthority(){return(0,it.$gH)(We,"resolvers"),St.remote.authority},get uiKind(){return St.uiKind},get logLevel(){return vt.getLevel()},get onDidChangeLogLevel(){return lt(vt.onDidChangeLogLevel)},get appQuality(){return(0,it.$gH)(We,"resolvers"),St.quality},get appCommit(){return(0,it.$gH)(We,"resolvers"),St.commit}};St.environment.extensionTestsLocationURI||Object.freeze(Ei);const Bi={createTestController(fe,be,Ue){return Pi.createTestController(We,fe,be,Ue)},createTestObserver(){return(0,it.$gH)(We,"testObserver"),Pi.createTestObserver()},runTests(fe){return(0,it.$gH)(We,"testObserver"),Pi.runTests(fe)},registerTestFollowupProvider(fe){return(0,it.$gH)(We,"testObserver"),Pi.registerTestFollowupProvider(fe)},get onDidChangeTestResults(){return(0,it.$gH)(We,"testObserver"),lt(Pi.onResultsChanged)},get testResults(){return(0,it.$gH)(We,"testObserver"),Pi.results}},Ui=St.remote.isRemote?le.ExtensionKind.Workspace:le.ExtensionKind.UI,$i={getExtension(fe,be){(0,it.$fH)(We,"extensionsAny")||(be=!1);const Ue=vi.mine.getExtensionDescription(fe);if(Ue)return new Q.$tqc(Wt,We.identifier,Ue,Ui,!1);if(be){const ht=vi.all.getExtensionDescription(fe);if(ht)return new Q.$tqc(Wt,We.identifier,ht,Ui,!0)}},get all(){const fe=[];for(const be of vi.mine.getAllExtensionDescriptions())fe.push(new Q.$tqc(Wt,We.identifier,be,Ui,!1));return fe},get allAcrossExtensionHosts(){(0,it.$gH)(We,"extensionsAny");const fe=new w.$sn(vi.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),be=[];for(const Ue of vi.all.getAllExtensionDescriptions()){const ht=!fe.has(Ue.identifier);be.push(new Q.$tqc(Wt,We.identifier,Ue,Ui,ht))}return be},get onDidChange(){return(0,it.$fH)(We,"extensionsAny")?lt(R.Event.any(vi.mine.onDidChange,vi.all.onDidChange)):lt(vi.mine.onDidChange)}},Wi={createDiagnosticCollection(fe){return Se.createDiagnosticCollection(We.identifier,fe)},get onDidChangeDiagnostics(){return lt(Se.onDidChangeDiagnostics)},getDiagnostics:fe=>Se.getDiagnostics(fe),getLanguages(){return ie.getLanguages()},setTextDocumentLanguage(fe,be){return ie.changeLanguage(fe.uri,be)},match(fe,be){const Ue=he.LanguageSelector.from(fe);let ht;return(0,S.$xu)(Ue)&&(ht=At.notebookDocuments.find(Et=>Et.apiNotebook.getCells().find(Lt=>Lt.document===be))?.apiNotebook),(0,S.$wu)(Ue,be.uri,be.languageId,!0,ht?.uri,ht?.notebookType)},registerCodeActionsProvider(fe,be,Ue){return Ae.registerCodeActionProvider(We,kt(fe),be,Ue)},registerDocumentPasteEditProvider(fe,be,Ue){return(0,it.$gH)(We,"documentPaste"),Ae.registerDocumentPasteEditProvider(We,kt(fe),be,Ue)},registerCodeLensProvider(fe,be){return Ae.registerCodeLensProvider(We,kt(fe),be)},registerDefinitionProvider(fe,be){return Ae.registerDefinitionProvider(We,kt(fe),be)},registerDeclarationProvider(fe,be){return Ae.registerDeclarationProvider(We,kt(fe),be)},registerImplementationProvider(fe,be){return Ae.registerImplementationProvider(We,kt(fe),be)},registerTypeDefinitionProvider(fe,be){return Ae.registerTypeDefinitionProvider(We,kt(fe),be)},registerHoverProvider(fe,be){return Ae.registerHoverProvider(We,kt(fe),be,We.identifier)},registerEvaluatableExpressionProvider(fe,be){return Ae.registerEvaluatableExpressionProvider(We,kt(fe),be,We.identifier)},registerInlineValuesProvider(fe,be){return Ae.registerInlineValuesProvider(We,kt(fe),be,We.identifier)},registerDocumentHighlightProvider(fe,be){return Ae.registerDocumentHighlightProvider(We,kt(fe),be)},registerMultiDocumentHighlightProvider(fe,be){return Ae.registerMultiDocumentHighlightProvider(We,kt(fe),be)},registerLinkedEditingRangeProvider(fe,be){return Ae.registerLinkedEditingRangeProvider(We,kt(fe),be)},registerReferenceProvider(fe,be){return Ae.registerReferenceProvider(We,kt(fe),be)},registerRenameProvider(fe,be){return Ae.registerRenameProvider(We,kt(fe),be)},registerNewSymbolNamesProvider(fe,be){return(0,it.$gH)(We,"newSymbolNamesProvider"),Ae.registerNewSymbolNamesProvider(We,kt(fe),be)},registerDocumentSymbolProvider(fe,be,Ue){return Ae.registerDocumentSymbolProvider(We,kt(fe),be,Ue)},registerWorkspaceSymbolProvider(fe){return Ae.registerWorkspaceSymbolProvider(We,fe)},registerDocumentFormattingEditProvider(fe,be){return Ae.registerDocumentFormattingEditProvider(We,kt(fe),be)},registerDocumentRangeFormattingEditProvider(fe,be){return Ae.registerDocumentRangeFormattingEditProvider(We,kt(fe),be)},registerOnTypeFormattingEditProvider(fe,be,Ue,...ht){return Ae.registerOnTypeFormattingEditProvider(We,kt(fe),be,[Ue].concat(ht))},registerDocumentSemanticTokensProvider(fe,be,Ue){return Ae.registerDocumentSemanticTokensProvider(We,kt(fe),be,Ue)},registerDocumentRangeSemanticTokensProvider(fe,be,Ue){return Ae.registerDocumentRangeSemanticTokensProvider(We,kt(fe),be,Ue)},registerSignatureHelpProvider(fe,be,Ue,...ht){return typeof Ue=="object"?Ae.registerSignatureHelpProvider(We,kt(fe),be,Ue):Ae.registerSignatureHelpProvider(We,kt(fe),be,typeof Ue>"u"?[]:[Ue,...ht])},registerCompletionItemProvider(fe,be,...Ue){return Ae.registerCompletionItemProvider(We,kt(fe),be,Ue)},registerInlineCompletionItemProvider(fe,be,Ue){return be.handleDidShowCompletionItem&&(0,it.$gH)(We,"inlineCompletionsAdditions"),be.handleDidPartiallyAcceptCompletionItem&&(0,it.$gH)(We,"inlineCompletionsAdditions"),Ue&&(0,it.$gH)(We,"inlineCompletionsAdditions"),Ae.registerInlineCompletionsProvider(We,kt(fe),be,Ue)},registerInlineEditProvider(fe,be){return(0,it.$gH)(We,"inlineEdit"),Ae.registerInlineEditProvider(We,kt(fe),be)},registerDocumentLinkProvider(fe,be){return Ae.registerDocumentLinkProvider(We,kt(fe),be)},registerColorProvider(fe,be){return Ae.registerColorProvider(We,kt(fe),be)},registerFoldingRangeProvider(fe,be){return Ae.registerFoldingRangeProvider(We,kt(fe),be)},registerSelectionRangeProvider(fe,be){return Ae.registerSelectionRangeProvider(We,fe,be)},registerCallHierarchyProvider(fe,be){return Ae.registerCallHierarchyProvider(We,fe,be)},registerTypeHierarchyProvider(fe,be){return Ae.registerTypeHierarchyProvider(We,fe,be)},setLanguageConfiguration:(fe,be)=>Ae.setLanguageConfiguration(We,fe,be),getTokenInformationAtPosition(fe,be){return(0,it.$gH)(We,"tokenInformation"),ie.tokenAtPosition(fe,be)},registerInlayHintsProvider(fe,be){return Ae.registerInlayHintsProvider(We,fe,be)},createLanguageStatusItem(fe,be){return ie.createLanguageStatusItem(We,fe,be)},registerDocumentDropEditProvider(fe,be,Ue){return Ae.registerDocumentOnDropEditProvider(We,fe,be,(0,it.$fH)(We,"documentPaste")?Ue:void 0)}},hn={get activeTextEditor(){return Vt.getActiveTextEditor()},get visibleTextEditors(){return Vt.getVisibleTextEditors()},get activeTerminal(){return It.activeTerminal},get terminals(){return It.terminals},async showTextDocument(fe,be,Ue){c.URI.isUri(fe)&&fe.scheme===T.Schemas.vscodeRemote&&!fe.authority&&Nt.report("workspace.showTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority.");const ht=await(c.URI.isUri(fe)?Promise.resolve(xi.openTextDocument(fe)):Promise.resolve(fe));return Vt.showTextDocument(ht,be,Ue)},createTextEditorDecorationType(fe){return Vt.createTextEditorDecorationType(We,fe)},onDidChangeActiveTextEditor(fe,be,Ue){return lt(Vt.onDidChangeActiveTextEditor)(fe,be,Ue)},onDidChangeVisibleTextEditors(fe,be,Ue){return lt(Vt.onDidChangeVisibleTextEditors)(fe,be,Ue)},onDidChangeTextEditorSelection(fe,be,Ue){return lt(Vt.onDidChangeTextEditorSelection)(fe,be,Ue)},onDidChangeTextEditorOptions(fe,be,Ue){return lt(Vt.onDidChangeTextEditorOptions)(fe,be,Ue)},onDidChangeTextEditorVisibleRanges(fe,be,Ue){return lt(Vt.onDidChangeTextEditorVisibleRanges)(fe,be,Ue)},onDidChangeTextEditorViewColumn(fe,be,Ue){return lt(Vt.onDidChangeTextEditorViewColumn)(fe,be,Ue)},onDidCloseTerminal(fe,be,Ue){return lt(It.onDidCloseTerminal)(fe,be,Ue)},onDidOpenTerminal(fe,be,Ue){return lt(It.onDidOpenTerminal)(fe,be,Ue)},onDidChangeActiveTerminal(fe,be,Ue){return lt(It.onDidChangeActiveTerminal)(fe,be,Ue)},onDidChangeTerminalDimensions(fe,be,Ue){return(0,it.$gH)(We,"terminalDimensions"),lt(It.onDidChangeTerminalDimensions)(fe,be,Ue)},onDidChangeTerminalState(fe,be,Ue){return lt(It.onDidChangeTerminalState)(fe,be,Ue)},onDidWriteTerminalData(fe,be,Ue){return(0,it.$gH)(We,"terminalDataWriteEvent"),lt(It.onDidWriteTerminalData)(fe,be,Ue)},onDidExecuteTerminalCommand(fe,be,Ue){return(0,it.$gH)(We,"terminalExecuteCommandEvent"),lt(It.onDidExecuteTerminalCommand)(fe,be,Ue)},onDidChangeTerminalShellIntegration(fe,be,Ue){return(0,it.$gH)(We,"terminalShellIntegration"),lt(Kt.onDidChangeTerminalShellIntegration)(fe,be,Ue)},onDidStartTerminalShellExecution(fe,be,Ue){return(0,it.$gH)(We,"terminalShellIntegration"),lt(Kt.onDidStartTerminalShellExecution)(fe,be,Ue)},onDidEndTerminalShellExecution(fe,be,Ue){return(0,it.$gH)(We,"terminalShellIntegration"),lt(Kt.onDidEndTerminalShellExecution)(fe,be,Ue)},get state(){return Gt.getState()},onDidChangeWindowState(fe,be,Ue){return lt(Gt.onDidChangeWindowState)(fe,be,Ue)},showInformationMessage(fe,...be){return Qi.showMessage(We,p.default.Info,fe,be[0],be.slice(1))},showWarningMessage(fe,...be){return Qi.showMessage(We,p.default.Warning,fe,be[0],be.slice(1))},showErrorMessage(fe,...be){return Qi.showMessage(We,p.default.Error,fe,be[0],be.slice(1))},showQuickPick(fe,be,Ue){return Qe.showQuickPick(We,fe,be,Ue)},showWorkspaceFolderPick(fe){return Qe.showWorkspaceFolderPick(fe)},showInputBox(fe,be){return Qe.showInput(fe,be)},showOpenDialog(fe){return Ji.showOpenDialog(We,fe)},showSaveDialog(fe){return Ji.showSaveDialog(fe)},createStatusBarItem(fe,be,Ue){let ht,Et,Lt;return typeof fe=="string"?(ht=fe,Et=be,Lt=Ue):(Et=fe,Lt=be),cn.createStatusBarEntry(We,ht,Et,Lt)},setStatusBarMessage(fe,be){return cn.setStatusBarMessage(fe,be)},withScmProgress(fe){return Nt.report("window.withScmProgress",We,"Use 'withProgress' instead."),zt.withProgress(We,{location:le.ProgressLocation.SourceControl},(be,Ue)=>fe({report(ht){}}))},withProgress(fe,be){return zt.withProgress(We,fe,be)},createOutputChannel(fe,be){return ki.createOutputChannel(fe,be,We)},createWebviewPanel(fe,be,Ue,ht){return Mi.createWebviewPanel(We,fe,be,Ue,ht)},createWebviewTextEditorInset(fe,be,Ue,ht){return(0,it.$gH)(We,"editorInsets"),Me.createWebviewEditorInset(fe,be,Ue,ht,We)},createTerminal(fe,be,Ue){return typeof fe=="object"?"pty"in fe?It.createExtensionTerminal(fe):It.createTerminalFromOptions(fe):It.createTerminal(fe,be,Ue)},registerTerminalLinkProvider(fe){return It.registerLinkProvider(fe)},registerTerminalProfileProvider(fe,be){return It.registerProfileProvider(We,fe,be)},registerTerminalQuickFixProvider(fe,be){return(0,it.$gH)(We,"terminalQuickFixProvider"),It.registerTerminalQuickFixProvider(fe,We.identifier.value,be)},registerTreeDataProvider(fe,be){return Te.registerTreeDataProvider(fe,be,We)},createTreeView(fe,be){return Te.createTreeView(fe,be,We)},registerWebviewPanelSerializer:(fe,be)=>Mi.registerWebviewPanelSerializer(We,fe,be),registerCustomEditorProvider:(fe,be,Ue={})=>Hi.registerCustomEditorProvider(We,fe,be,Ue),registerFileDecorationProvider(fe){return Jt.registerFileDecorationProvider(fe,We)},registerUriHandler(fe){return Ri.registerUriHandler(We,fe)},createQuickPick(){return Qe.createQuickPick(We)},createInputBox(){return Qe.createInputBox(We)},get activeColorTheme(){return qi.activeColorTheme},onDidChangeActiveColorTheme(fe,be,Ue){return lt(qi.onDidChangeActiveColorTheme)(fe,be,Ue)},registerWebviewViewProvider(fe,be,Ue){return Gi.registerWebviewViewProvider(We,fe,be,Ue?.webviewOptions)},get activeNotebookEditor(){return At.activeNotebookEditor},onDidChangeActiveNotebookEditor(fe,be,Ue){return lt(At.onDidChangeActiveNotebookEditor)(fe,be,Ue)},get visibleNotebookEditors(){return At.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return lt(At.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(fe,be,Ue){return lt(Ii.onDidChangeNotebookEditorSelection)(fe,be,Ue)},onDidChangeNotebookEditorVisibleRanges(fe,be,Ue){return lt(Ii.onDidChangeNotebookEditorVisibleRanges)(fe,be,Ue)},showNotebookDocument(fe,be){return At.showNotebookDocument(fe,be)},registerExternalUriOpener(fe,be,Ue){return(0,it.$gH)(We,"externalUriOpener"),sn.registerExternalUriOpener(We.identifier,fe,be,Ue)},registerProfileContentHandler(fe,be){return(0,it.$gH)(We,"profileContentHandlers"),on.registerProfileContentHandler(We,fe,be)},registerQuickDiffProvider(fe,be,Ue,ht){return(0,it.$gH)(We,"quickDiffProvider"),Rt.registerQuickDiffProvider(kt(fe),be,Ue,ht)},get tabGroups(){return Qt.tabGroups},registerShareProvider(fe,be){return(0,it.$gH)(We,"shareProvider"),Xt.registerShareProvider(kt(fe),be)}},xi={get rootPath(){return Nt.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(fe){throw new C.$8("rootPath")},getWorkspaceFolder(fe){return pt.getWorkspaceFolder(fe)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(fe){throw new C.$8("name")},get workspaceFile(){return pt.workspaceFile},set workspaceFile(fe){throw new C.$8("workspaceFile")},updateWorkspaceFolders:(fe,be,...Ue)=>pt.updateWorkspaceFolders(We,fe,be||0,...Ue),onDidChangeWorkspaceFolders:function(fe,be,Ue){return lt(pt.onDidChangeWorkspace)(fe,be,Ue)},asRelativePath:(fe,be)=>pt.getRelativePath(fe,be),findFiles:(fe,be,Ue,ht)=>pt.findFiles(fe,be,Ue,We.identifier,ht),findFiles2:(fe,be,Ue)=>((0,it.$gH)(We,"findFiles2"),pt.findFiles2(fe,be,We.identifier,Ue)),findFiles2New:(fe,be,Ue)=>{(0,it.$gH)(We,"findFiles2New");const ht={exclude:be?.exclude&&be.exclude.length>0?be.exclude[0]:void 0,useDefaultExcludes:!be?.useExcludeSettings||be?.useExcludeSettings===Ct.ExcludeSettingOptions.filesExclude||be?.useExcludeSettings===Ct.ExcludeSettingOptions.searchAndFilesExclude,useDefaultSearchExcludes:!be?.useExcludeSettings||be?.useExcludeSettings===Ct.ExcludeSettingOptions.searchAndFilesExclude,maxResults:be?.maxResults,useIgnoreFiles:be?.useIgnoreFiles?.local,useGlobalIgnoreFiles:be?.useIgnoreFiles?.global,useParentIgnoreFiles:be?.useIgnoreFiles?.parent,followSymlinks:be?.followSymlinks};return pt.findFiles2(fe&&fe.length>0?fe[0]:void 0,ht,We.identifier,Ue)},findTextInFiles:(fe,be,Ue,ht)=>{(0,it.$gH)(We,"findTextInFiles");let Et,Lt;return typeof be=="object"?(Et=be,Lt=Ue):(Et={},Lt=be,ht=Ue),pt.findTextInFiles(fe,Et||{},Lt,We.identifier,ht)},findTextInFilesNew:(fe,be,Ue)=>{(0,it.$gH)(We,"findTextInFilesNew"),(0,it.$gH)(We,"textSearchProviderNew");let ht={};be&&(ht={include:be.include&&be.include.length>0?be.include[0]:void 0,exclude:be.exclude&&be.exclude.length>0?be.exclude[0]:void 0,useDefaultExcludes:be.useExcludeSettings===void 0||be.useExcludeSettings===Ct.ExcludeSettingOptions.filesExclude||be.useExcludeSettings===Ct.ExcludeSettingOptions.searchAndFilesExclude,useSearchExclude:be.useExcludeSettings===void 0||be.useExcludeSettings===Ct.ExcludeSettingOptions.searchAndFilesExclude,maxResults:be.maxResults,useIgnoreFiles:be.useIgnoreFiles?.local,useGlobalIgnoreFiles:be.useIgnoreFiles?.global,useParentIgnoreFiles:be.useIgnoreFiles?.parent,followSymlinks:be.followSymlinks,encoding:be.encoding,previewOptions:be.previewOptions?{matchLines:be.previewOptions?.matchLines??100,charsPerLine:be.previewOptions?.charsPerLine??1e4}:void 0,beforeContext:be.surroundingContext,afterContext:be.surroundingContext});const Et=Promise.resolve(void 0);return{results:new r.$6h(async gi=>{const Fi=async en=>(gi.emitOne((0,Ct.$1L)(en)),en);await Et.then(en=>pt.findTextInFiles(fe,ht,Fi,We.identifier,Ue))}),complete:Et.then(gi=>({limitHit:gi?.limitHit??!1}))}},save:fe=>pt.save(fe),saveAs:fe=>pt.saveAs(fe),saveAll:fe=>pt.saveAll(fe),applyEdit(fe,be){return Dn.applyWorkspaceEdit(fe,We,be)},createFileSystemWatcher:(fe,be,Ue,ht)=>{let Et;return typeof be=="boolean"?Et={ignoreCreateEvents:!!be,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ht,correlate:!1}:be&&((0,it.$gH)(We,"createFileSystemWatcher"),Et={...be,correlate:!0}),_e.createFileSystemWatcher(pt,We,fe,Et)},get textDocuments(){return Ot.getAllDocumentData().map(fe=>fe.document)},set textDocuments(fe){throw new C.$8("textDocuments")},openTextDocument(fe){let be;const Ue=fe;if(typeof fe=="string")be=Promise.resolve(c.URI.file(fe));else if(c.URI.isUri(fe))be=Promise.resolve(fe);else if(!Ue||typeof Ue=="object")be=Ot.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return be.then(ht=>(ht.scheme===T.Schemas.vscodeRemote&&!ht.authority&&Nt.report("workspace.openTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority."),Ot.ensureDocumentData(ht).then(Et=>Et.document)))},onDidOpenTextDocument:(fe,be,Ue)=>lt(Ot.onDidAddDocument)(fe,be,Ue),onDidCloseTextDocument:(fe,be,Ue)=>lt(Ot.onDidRemoveDocument)(fe,be,Ue),onDidChangeTextDocument:(fe,be,Ue)=>lt(Ot.onDidChangeDocument)(fe,be,Ue),onDidSaveTextDocument:(fe,be,Ue)=>lt(Ot.onDidSaveDocument)(fe,be,Ue),onWillSaveTextDocument:(fe,be,Ue)=>lt(ui.getOnWillSaveTextDocumentEvent(We))(fe,be,Ue),get notebookDocuments(){return At.notebookDocuments.map(fe=>fe.apiNotebook)},async openNotebookDocument(fe,be){let Ue;if(c.URI.isUri(fe))Ue=fe,await At.openNotebookDocument(fe);else if(typeof fe=="string")Ue=c.URI.revive(await At.createNotebookDocument({viewType:fe,content:be}));else throw new Error("Invalid arguments");return At.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(fe,be,Ue){return lt(Ti.onDidSaveNotebookDocument)(fe,be,Ue)},onDidChangeNotebookDocument(fe,be,Ue){return lt(Ti.onDidChangeNotebookDocument)(fe,be,Ue)},onWillSaveNotebookDocument(fe,be,Ue){return lt(wi.getOnWillSaveNotebookDocumentEvent(We))(fe,be,Ue)},get onDidOpenNotebookDocument(){return lt(At.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return lt(At.onDidCloseNotebookDocument)},registerNotebookSerializer(fe,be,Ue,ht){return At.registerNotebookSerializer(We,fe,be,Ue,(0,it.$fH)(We,"notebookLiveShare")?ht:void 0)},onDidChangeConfiguration:(fe,be,Ue)=>lt(Xi.onDidChangeConfiguration)(fe,be,Ue),getConfiguration(fe,be){return be=arguments.length===1?void 0:be,Xi.getConfiguration(fe,be,We)},registerTextDocumentContentProvider(fe,be){return Li.registerTextDocumentContentProvider(fe,be)},registerTaskProvider:(fe,be)=>(Nt.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),xt.registerTaskProvider(We,fe,be)),registerFileSystemProvider(fe,be,Ue){return(0,O.$Rc)(Ge.registerFileSystemProvider(We,fe,be,Ue),ii.addFileSystemProvider(fe,be,Ue))},get fs(){return ii.value},registerFileSearchProvider:(fe,be)=>((0,it.$gH)(We,"fileSearchProvider"),mi.registerFileSearchProvider(fe,be)),registerTextSearchProvider:(fe,be)=>((0,it.$gH)(We,"textSearchProvider"),mi.registerTextSearchProvider(fe,be)),registerAITextSearchProvider:(fe,be)=>((0,it.$gH)(We,"aiTextSearchProvider"),(0,it.$gH)(We,"textSearchProvider"),mi.registerAITextSearchProvider(fe,be)),registerFileSearchProviderNew:(fe,be)=>((0,it.$gH)(We,"fileSearchProviderNew"),{dispose:()=>{}}),registerTextSearchProviderNew:(fe,be)=>((0,it.$gH)(We,"textSearchProviderNew"),{dispose:()=>{}}),registerAITextSearchProviderNew:(fe,be)=>((0,it.$gH)(We,"aiTextSearchProviderNew"),(0,it.$gH)(We,"textSearchProviderNew"),{dispose:()=>{}}),registerRemoteAuthorityResolver:(fe,be)=>((0,it.$gH)(We,"resolvers"),Wt.registerRemoteAuthorityResolver(fe,be)),registerResourceLabelFormatter:fe=>((0,it.$gH)(We,"resolvers"),_t.$registerResourceLabelFormatter(fe)),getRemoteExecServer:fe=>((0,it.$gH)(We,"resolvers"),Wt.getRemoteExecServer(fe)),onDidCreateFiles:(fe,be,Ue)=>lt(_e.onDidCreateFile)(fe,be,Ue),onDidDeleteFiles:(fe,be,Ue)=>lt(_e.onDidDeleteFile)(fe,be,Ue),onDidRenameFiles:(fe,be,Ue)=>lt(_e.onDidRenameFile)(fe,be,Ue),onWillCreateFiles:(fe,be,Ue)=>lt(_e.getOnWillCreateFileEvent(We))(fe,be,Ue),onWillDeleteFiles:(fe,be,Ue)=>lt(_e.getOnWillDeleteFileEvent(We))(fe,be,Ue),onWillRenameFiles:(fe,be,Ue)=>lt(_e.getOnWillRenameFileEvent(We))(fe,be,Ue),openTunnel:fe=>((0,it.$gH)(We,"tunnels"),jt.openTunnel(We,fe).then(be=>{if(!be)throw new Error("cannot open tunnel");return be})),get tunnels(){return(0,it.$gH)(We,"tunnels"),jt.getTunnels()},onDidChangeTunnels:(fe,be,Ue)=>((0,it.$gH)(We,"tunnels"),lt(jt.onDidChangeTunnels)(fe,be,Ue)),registerPortAttributesProvider:(fe,be)=>((0,it.$gH)(We,"portsAttributes"),jt.registerPortsAttributesProvider(fe,be)),registerTunnelProvider:(fe,be)=>((0,it.$gH)(We,"tunnelFactory"),jt.registerTunnelProvider(fe,be)),registerTimelineProvider:(fe,be)=>((0,it.$gH)(We,"timeline"),rn.registerTimelineProvider(fe,be,We.identifier,wt.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:fe=>((0,it.$gH)(We,"workspaceTrust"),pt.requestWorkspaceTrust(fe)),onDidGrantWorkspaceTrust:(fe,be,Ue)=>lt(pt.onDidGrantWorkspaceTrust)(fe,be,Ue),registerEditSessionIdentityProvider:(fe,be)=>((0,it.$gH)(We,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(fe,be)),onWillCreateEditSessionIdentity:(fe,be,Ue)=>((0,it.$gH)(We,"editSessionIdentityProvider"),lt(pt.getOnWillCreateEditSessionIdentityEvent(We))(fe,be,Ue)),registerCanonicalUriProvider:(fe,be)=>((0,it.$gH)(We,"canonicalUriProvider"),pt.registerCanonicalUriProvider(fe,be)),getCanonicalUri:(fe,be,Ue)=>((0,it.$gH)(We,"canonicalUriProvider"),pt.provideCanonicalUri(fe,be,Ue))},dn={get inputBox(){return Nt.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),ft.getLastInputBox(We)},createSourceControl(fe,be,Ue){return ft.createSourceControl(We,fe,be,Ue)}},fn={createCommentController(fe,be){return si.createCommentController(We,fe,be)}},kn={get activeDebugSession(){return Pt.activeDebugSession},get activeDebugConsole(){return Pt.activeDebugConsole},get breakpoints(){return Pt.breakpoints},get activeStackItem(){return Pt.activeStackItem},registerDebugVisualizationProvider(fe,be){return(0,it.$gH)(We,"debugVisualization"),Pt.registerDebugVisualizationProvider(We,fe,be)},registerDebugVisualizationTreeProvider(fe,be){return(0,it.$gH)(We,"debugVisualization"),Pt.registerDebugVisualizationTree(We,fe,be)},onDidStartDebugSession(fe,be,Ue){return lt(Pt.onDidStartDebugSession)(fe,be,Ue)},onDidTerminateDebugSession(fe,be,Ue){return lt(Pt.onDidTerminateDebugSession)(fe,be,Ue)},onDidChangeActiveDebugSession(fe,be,Ue){return lt(Pt.onDidChangeActiveDebugSession)(fe,be,Ue)},onDidReceiveDebugSessionCustomEvent(fe,be,Ue){return lt(Pt.onDidReceiveDebugSessionCustomEvent)(fe,be,Ue)},onDidChangeBreakpoints(fe,be,Ue){return lt(Pt.onDidChangeBreakpoints)(fe,be,Ue)},onDidChangeActiveStackItem(fe,be,Ue){return lt(Pt.onDidChangeActiveStackItem)(fe,be,Ue)},registerDebugConfigurationProvider(fe,be,Ue){return Pt.registerDebugConfigurationProvider(fe,be,Ue||oi.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(fe,be){return Pt.registerDebugAdapterDescriptorFactory(We,fe,be)},registerDebugAdapterTrackerFactory(fe,be){return Pt.registerDebugAdapterTrackerFactory(fe,be)},startDebugging(fe,be,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Pt.startDebugging(fe,be,{parentSession:Ue}):Pt.startDebugging(fe,be,Ue||{})},stopDebugging(fe){return Pt.stopDebugging(fe)},addBreakpoints(fe){return Pt.addBreakpoints(fe)},removeBreakpoints(fe){return Pt.removeBreakpoints(fe)},asDebugSourceUri(fe,be){return Pt.asDebugSourceUri(fe,be)}},gn={registerTaskProvider:(fe,be)=>xt.registerTaskProvider(We,fe,be),fetchTasks:fe=>xt.fetchTasks(fe),executeTask:fe=>xt.executeTask(We,fe),get taskExecutions(){return xt.taskExecutions},onDidStartTask:(fe,be,Ue)=>lt(xt.onDidStartTask)(fe,be,Ue),onDidEndTask:(fe,be,Ue)=>lt(xt.onDidEndTask)(fe,be,Ue),onDidStartTaskProcess:(fe,be,Ue)=>lt(xt.onDidStartTaskProcess)(fe,be,Ue),onDidEndTaskProcess:(fe,be,Ue)=>lt(xt.onDidEndTaskProcess)(fe,be,Ue)},mn={createNotebookController(fe,be,Ue,ht,Et){return Si.createNotebookController(We,fe,be,Ue,ht,(0,it.$fH)(We,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(fe,be)=>At.registerNotebookCellStatusBarItemProvider(We,fe,be),createRendererMessaging(fe){return Ni.createRendererMessaging(We,fe)},createNotebookControllerDetectionTask(fe){return(0,it.$gH)(We,"notebookKernelSource"),Si.createNotebookControllerDetectionTask(We,fe)},registerKernelSourceActionProvider(fe,be){return(0,it.$gH)(We,"notebookKernelSource"),Si.registerKernelSourceActionProvider(We,fe,be)},onDidChangeNotebookCellExecutionState(fe,be,Ue){return(0,it.$gH)(We,"notebookCellExecutionState"),lt(Si.onDidChangeNotebookCellExecutionState)(fe,be,Ue)}},In={t(...fe){if(typeof fe[0]=="string"){const be=fe.shift(),Ue=!fe||typeof fe[0]!="object"?fe:fe[0];return bi.getMessage(We.identifier.value,{message:be,args:Ue})}return bi.getMessage(We.identifier.value,fe[0])},get bundle(){return bi.getBundle(We.identifier.value)},get uri(){return bi.getBundleUri(We.identifier.value)}},Pn={_version:1,transferActiveChat(fe){return(0,it.$gH)(We,"interactive"),ji.transferActiveChat(fe)}},$n={getRelatedInformation(fe,be){return(0,it.$gH)(We,"aiRelatedInformation"),Ki.getRelatedInformation(We,fe,be)},registerRelatedInformationProvider(fe,be){return(0,it.$gH)(We,"aiRelatedInformation"),Ki.registerRelatedInformationProvider(We,fe,be)},registerEmbeddingVectorProvider(fe,be){return(0,it.$gH)(We,"aiRelatedInformation"),yn.registerEmbeddingVectorProvider(We,fe,be)}},_i={_version:1,registerChatResponseProvider(fe,be,Ue){return(0,it.$gH)(We,"chatProvider"),Zt.registerLanguageModel(We,fe,be,Ue)},registerChatVariableResolver(fe,be,Ue,ht,Et,Lt,gi,Fi){return(0,it.$gH)(We,"chatVariableResolver"),an.registerVariableResolver(We,fe,be,Ue,ht,Et,Lt,gi,Fi?.id)},registerMappedEditsProvider(fe,be){return(0,it.$gH)(We,"mappedEditsProvider"),Ae.registerMappedEditsProvider(We,fe,be)},createChatParticipant(fe,be){return ji.createChatAgent(We,fe,be)},createDynamicChatParticipant(fe,be,Ue){return(0,it.$gH)(We,"chatParticipantPrivate"),ji.createDynamicChatAgent(We,fe,be,Ue)}},pn={selectChatModels:fe=>Zt.selectLanguageModels(We,fe??{}),onDidChangeChatModels:(fe,be,Ue)=>Zt.onDidChangeProviders(fe,be,Ue),registerChatModelProvider:(fe,be,Ue)=>((0,it.$gH)(We,"chatProvider"),Zt.registerLanguageModel(We,fe,be,Ue)),get embeddingModels(){return(0,it.$gH)(We,"embeddings"),Ci.embeddingsModels},onDidChangeEmbeddingModels:(fe,be,Ue)=>((0,it.$gH)(We,"embeddings"),Ci.onDidChange(fe,be,Ue)),registerEmbeddingsProvider(fe,be){return(0,it.$gH)(We,"embeddings"),Ci.registerEmbeddingsProvider(We,fe,be)},async computeEmbeddings(fe,be,Ue){return(0,it.$gH)(We,"embeddings"),Ci.computeEmbeddings(fe,be,Ue)},registerTool(fe,be){return(0,it.$gH)(We,"lmTools"),zi.registerTool(We,fe,be)},invokeTool(fe,be,Ue){return(0,it.$gH)(We,"lmTools"),zi.invokeTool(fe,be,Ue)},get tools(){return(0,it.$gH)(We,"lmTools"),zi.tools}},bn={registerSpeechProvider(fe,be){return(0,it.$gH)(We,"speech"),Zi.registerProvider(We.identifier,fe,be)}};return{version:St.version,ai:$n,authentication:Yi,commands:un,comments:fn,chat:_i,debug:kn,env:Ei,extensions:$i,interactive:Pn,l10n:In,languages:Wi,lm:pn,notebooks:mn,scm:dn,speech:bn,tasks:gn,tests:Bi,window:hn,workspace:xi,Breakpoint:le.$PO,TerminalOutputAnchor:le.TerminalOutputAnchor,ChatResultFeedbackKind:le.ChatResultFeedbackKind,ChatVariableLevel:le.ChatVariableLevel,ChatCompletionItem:le.$LP,CallHierarchyIncomingCall:le.$bO,CallHierarchyItem:le.$aO,CallHierarchyOutgoingCall:le.$cO,CancellationError:C.$4,CancellationTokenSource:h.$we,CandidatePortSource:s.CandidatePortSource,CodeAction:le.$0N,CodeActionKind:le.$$N,CodeActionTriggerKind:le.CodeActionTriggerKind,CodeLens:le.$dO,Color:le.$qO,ColorInformation:le.$rO,ColorPresentation:le.$sO,ColorThemeKind:le.ColorThemeKind,CommentMode:le.CommentMode,CommentState:le.CommentState,CommentThreadCollapsibleState:le.CommentThreadCollapsibleState,CommentThreadState:le.CommentThreadState,CommentThreadApplicability:le.CommentThreadApplicability,CommentThreadFocus:le.CommentThreadFocus,CompletionItem:le.$kO,CompletionItemKind:le.CompletionItemKind,CompletionItemTag:le.CompletionItemTag,CompletionList:le.$lO,CompletionTriggerKind:le.CompletionTriggerKind,ConfigurationTarget:le.ConfigurationTarget,CustomExecution:le.$AO,DebugAdapterExecutable:le.$TO,DebugAdapterInlineImplementation:le.$WO,DebugAdapterNamedPipeServer:le.$VO,DebugAdapterServer:le.$UO,DebugConfigurationProviderTriggerKind:oi.DebugConfigurationProviderTriggerKind,DebugConsoleMode:le.DebugConsoleMode,DebugVisualization:le.$aP,DecorationRangeBehavior:le.DecorationRangeBehavior,Diagnostic:le.$3N,DiagnosticRelatedInformation:le.$2N,DiagnosticSeverity:le.DiagnosticSeverity,DiagnosticTag:le.DiagnosticTag,Disposable:le.$MN,DocumentHighlight:le.$6N,DocumentHighlightKind:le.DocumentHighlightKind,MultiDocumentHighlight:le.$7N,DocumentLink:le.$pO,DocumentSymbol:le.$9N,EndOfLine:le.EndOfLine,EnvironmentVariableMutatorType:le.EnvironmentVariableMutatorType,EvaluatableExpression:le.$ZO,InlineValueText:le.$1O,InlineValueVariableLookup:le.$2O,InlineValueEvaluatableExpression:le.$3O,InlineCompletionTriggerKind:le.InlineCompletionTriggerKind,EventEmitter:R.$le,ExtensionKind:le.ExtensionKind,ExtensionMode:le.ExtensionMode,ExternalUriOpenerPriority:le.ExternalUriOpenerPriority,FileChangeType:le.FileChangeType,FileDecoration:le.$cP,FileDecoration2:le.$cP,FileSystemError:le.$6O,FileType:a.FileType,FilePermission:a.FilePermission,FoldingRange:le.$7O,FoldingRangeKind:le.FoldingRangeKind,FunctionBreakpoint:le.$RO,InlineCompletionItem:le.$mO,InlineCompletionList:le.$nO,Hover:le.$4N,VerboseHover:le.$5N,HoverVerbosityAction:le.HoverVerbosityAction,IndentAction:u.IndentAction,Location:le.$1N,MarkdownString:le.$eO,OverviewRulerLane:P.OverviewRulerLane,ParameterInformation:le.$fO,PortAutoForwardAction:le.PortAutoForwardAction,Position:le.$NN,ProcessExecution:le.$yO,ProgressLocation:le.ProgressLocation,QuickInputButtonLocation:le.QuickInputButtonLocation,QuickInputButtons:le.$bP,Range:le.$ON,RelativePattern:le.$NO,Selection:le.$PN,SelectionRange:le.$_N,SemanticTokens:le.$0O,SemanticTokensBuilder:le.$9O,SemanticTokensEdit:le.$$O,SemanticTokensEdits:le.$_O,SemanticTokensLegend:le.$8O,ShellExecution:le.$zO,ShellQuoting:le.ShellQuoting,SignatureHelp:le.$hO,SignatureHelpTriggerKind:le.SignatureHelpTriggerKind,SignatureInformation:le.$gO,SnippetString:le.$ZN,SourceBreakpoint:le.$QO,StandardTokenType:le.StandardTokenType,StatusBarAlignment:le.StatusBarAlignment,SymbolInformation:le.$8N,SymbolKind:le.SymbolKind,SymbolTag:le.SymbolTag,Task:le.$BO,TaskGroup:le.$xO,TaskPanelKind:le.TaskPanelKind,TaskRevealKind:le.TaskRevealKind,TaskScope:le.TaskScope,TerminalLink:le.$tO,TerminalQuickFixTerminalCommand:le.$vO,TerminalQuickFixOpener:le.$uO,TerminalLocation:le.TerminalLocation,TerminalProfile:le.$wO,TerminalExitReason:le.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:le.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:le.TextDocumentSaveReason,TextEdit:le.$VN,SnippetTextEdit:le.$XN,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:le.TextEditorLineNumbersStyle,TextEditorRevealType:le.TextEditorRevealType,TextEditorSelectionChangeKind:le.TextEditorSelectionChangeKind,SyntaxTokenType:le.SyntaxTokenType,TextDocumentChangeReason:le.TextDocumentChangeReason,ThemeColor:le.$MO,ThemeIcon:le.$LO,TreeItem:le.$CO,TreeItemCheckboxState:le.TreeItemCheckboxState,TreeItemCollapsibleState:le.TreeItemCollapsibleState,TypeHierarchyItem:le.$zP,UIKind:Tt.UIKind,Uri:c.URI,ViewColumn:le.ViewColumn,WorkspaceEdit:le.$YN,DocumentPasteTriggerKind:le.DocumentPasteTriggerKind,DocumentDropEdit:le.$IO,DocumentDropOrPasteEditKind:le.$JO,DocumentPasteEdit:le.$KO,InlayHint:le.$jO,InlayHintLabelPart:le.$iO,InlayHintKind:le.InlayHintKind,RemoteAuthorityResolverError:le.$UN,ResolvedAuthority:le.$SN,ManagedResolvedAuthority:le.$TN,SourceControlInputBoxValidationType:le.SourceControlInputBoxValidationType,ExtensionRuntime:le.ExtensionRuntime,TimelineItem:le.$mP,NotebookRange:le.$eP,NotebookCellKind:le.NotebookCellKind,NotebookCellExecutionState:le.NotebookCellExecutionState,NotebookCellData:le.$fP,NotebookData:le.$gP,NotebookRendererScript:le.$kP,NotebookCellStatusBarAlignment:le.NotebookCellStatusBarAlignment,NotebookEditorRevealType:le.NotebookEditorRevealType,NotebookCellOutput:le.$iP,NotebookCellOutputItem:le.$hP,NotebookCellStatusBarItem:le.$jP,NotebookControllerAffinity:le.NotebookControllerAffinity,NotebookControllerAffinity2:le.NotebookControllerAffinity2,NotebookEdit:le.$WN,NotebookKernelSourceAction:le.$lP,NotebookVariablesRequestKind:le.NotebookVariablesRequestKind,PortAttributes:le.$oP,LinkedEditingRanges:le.$nP,TestResultState:le.TestResultState,TestRunRequest:le.$pP,TestMessage:le.$qP,TestMessage2:le.$qP,TestMessageStackFrame:le.$sP,TestTag:le.$rP,TestRunProfileKind:le.TestRunProfileKind,TextSearchCompleteMessageType:Ct.TextSearchCompleteMessageType,DataTransfer:le.$HO,DataTransferItem:le.$DO,TestCoverageCount:le.$tP,FileCoverage:le.$vP,FileCoverage2:le.$vP,StatementCoverage:le.$wP,BranchCoverage:le.$xP,DeclarationCoverage:le.$yP,WorkspaceTrustState:le.WorkspaceTrustState,LanguageStatusSeverity:le.LanguageStatusSeverity,QuickPickItemKind:le.QuickPickItemKind,InputBoxValidationSeverity:le.InputBoxValidationSeverity,TabInputText:le.$AP,TabInputTextDiff:le.$BP,TabInputTextMerge:le.$CP,TabInputCustom:le.$DP,TabInputNotebook:le.$FP,TabInputNotebookDiff:le.$GP,TabInputWebview:le.$EP,TabInputTerminal:le.$HP,TabInputInteractiveWindow:le.$IP,TabInputChat:le.$JP,TabInputTextMultiDiff:le.$KP,TelemetryTrustedValue:f.$xp,LogLevel:m.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:le.InteractiveSessionVoteDirection,ChatCopyKind:le.ChatCopyKind,InteractiveEditorResponseFeedbackKind:le.InteractiveEditorResponseFeedbackKind,DebugStackFrame:le.$XO,DebugThread:le.$YO,RelatedInformationType:le.RelatedInformationType,SpeechToTextStatus:le.SpeechToTextStatus,TextToSpeechStatus:le.TextToSpeechStatus,PartialAcceptTriggerKind:le.PartialAcceptTriggerKind,KeywordRecognitionStatus:le.KeywordRecognitionStatus,ChatResponseMarkdownPart:le.$MP,ChatResponseFileTreePart:le.$QP,ChatResponseAnchorPart:le.$RP,ChatResponseProgressPart:le.$SP,ChatResponseProgressPart2:le.$TP,ChatResponseReferencePart:le.$WP,ChatResponseReferencePart2:le.$WP,ChatResponseCodeCitationPart:le.$XP,ChatResponseWarningPart:le.$UP,ChatResponseTextEditPart:le.$YP,ChatResponseMarkdownWithVulnerabilitiesPart:le.$NP,ChatResponseCommandButtonPart:le.$VP,ChatResponseDetectedParticipantPart:le.$OP,ChatResponseConfirmationPart:le.$PP,ChatResponseReferencePartStatusKind:le.ChatResponseReferencePartStatusKind,ChatRequestTurn:le.$ZP,ChatResponseTurn:le.$1P,ChatLocation:le.ChatLocation,ChatRequestEditorData:le.$2P,ChatRequestNotebookData:le.$3P,LanguageModelChatMessageRole:le.LanguageModelChatMessageRole,LanguageModelChatMessage:le.$5P,LanguageModelChatMessageFunctionResultPart:le.$4P,LanguageModelChatResponseTextPart:le.$7P,LanguageModelChatResponseFunctionUsePart:le.$6P,LanguageModelError:le.$$P,NewSymbolName:le.$5O,NewSymbolNameTag:le.NewSymbolNameTag,NewSymbolNameTriggerKind:le.NewSymbolNameTriggerKind,InlineEdit:le.$_P,InlineEditTriggerKind:le.InlineEditTriggerKind,ExcludeSettingOptions:Ct.ExcludeSettingOptions,TextSearchContextNew:Ct.$ZL,TextSearchMatchNew:Ct.$YL,TextSearchCompleteMessageTypeNew:Ct.TextSearchCompleteMessageTypeNew}}}}),define(ke[345],Ie([1,0,88,169,49,163,41,34,63,48,100,101,102,125,76,95,162,75,62,124,94,77,161,11,64,122,123,127,128,167,98]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l,g,E,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Rs)(l.$nqc,l.$mqc,r.InstantiationType.Delayed),(0,r.$Rs)(n.$bk,o.$Crc,r.InstantiationType.Delayed),(0,r.$Rs)(a.$spc,a.$tpc,r.InstantiationType.Delayed),(0,r.$Rs)(T.$GQ,T.$FQ,r.InstantiationType.Eager),(0,r.$Rs)(E.$Cpc,E.$Dpc,r.InstantiationType.Eager),(0,r.$Rs)(D.$hqc,D.$iqc,r.InstantiationType.Eager),(0,r.$Rs)(O.$Rpc,O.$Ppc,r.InstantiationType.Eager),(0,r.$Rs)($.$Tpc,$.$Spc,r.InstantiationType.Eager),(0,r.$Rs)(k.$xqc,k.$yqc,r.InstantiationType.Eager),(0,r.$Rs)(S.$Cqc,S.$Gqc,r.InstantiationType.Eager),(0,r.$Rs)(R.$Iqc,R.$Hqc,r.InstantiationType.Eager),(0,r.$Rs)(p.$vQ,p.$uQ,r.InstantiationType.Eager),(0,r.$Rs)(g.$oqc,g.$pqc,r.InstantiationType.Eager),(0,r.$Rs)(f.$wpc,f.$vpc,r.InstantiationType.Eager),(0,r.$Rs)(h.$crc,h.$brc,r.InstantiationType.Delayed),(0,r.$Rs)(u.$Yqc,u.$Zqc,r.InstantiationType.Eager),(0,r.$Rs)(P.$aqc,P.$_pc,r.InstantiationType.Eager),(0,r.$Rs)(I.$prc,I.$orc,r.InstantiationType.Eager),(0,r.$Rs)(c.$dqc,c.$gqc,r.InstantiationType.Eager),(0,r.$Rs)(y.$qrc,y.$rrc,r.InstantiationType.Eager),(0,r.$Rs)(w.$jGb,w.$kGb,r.InstantiationType.Eager),(0,r.$Rs)(m.$Arc,m.$zrc,r.InstantiationType.Eager),(0,r.$Rs)(C.$Opc,C.$Npc,r.InstantiationType.Eager),(0,r.$Rs)(i.$kqc,i.$jqc,r.InstantiationType.Eager),(0,r.$Rs)(s.$EQ,s.$BQ,r.InstantiationType.Eager),(0,r.$Rs)(t.$4pc,t.$5pc,r.InstantiationType.Eager),(0,r.$Rs)(d.$vqc,d.$wqc,r.InstantiationType.Eager)}),define(ke[129],Ie([1,0,18,11,37,99]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Urc=void 0,e.$Src=O,e.$Trc=T,R=qe(R);function O(S){return S.startsWith("**")||S.startsWith("/")?S:`/${S}`}function T(S,u,P,w){const a=(0,r.$Zb)(P,p),m=new C.$aM(u,a,w),$=m.preview.matches;return{ranges:(0,r.$Zb)(a,c),uri:S,preview:{text:m.preview.text,matches:(0,r.$Zb)($,c)}}}function p(S){return new C.$bM(S.start.line,S.start.character,S.end.line,S.end.character)}function c(S){return new R.$XL(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn)}let I=class{constructor(u,P){this.a=u,this.b=P}appendLine(u){this.b.debug(`${this.a}#search`,u)}};e.$Urc=I,e.$Urc=I=Je([Ve(1,h.$ak)],I)}),define(ke[346],Ie([1,0,56,16,81,31,10,12,129,347]),function($e,e,r,h,C,R,O,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vrc=S,e.$Wrc=m,e.$Xrc=f,r=qe(r),h=qe(h),R=qe(R),T=qe(T);const I=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function S(i,s,t,o,n){const d=u(i,s,t,o,n),l=s.folder.fsPath;return{cmd:r.spawn(I,d.args,{cwd:l}),rgDiskPath:I,siblingClauses:d.siblingClauses,rgArgs:d,cwd:l}}function u(i,s,t,o,n){const d=["--files","--hidden","--case-sensitive","--no-require-git"];w([s],t,!1).forEach(g=>{const E=(0,p.$Src)(g);if(d.push("-g",E),O.$k){const D=(0,C.$om)(E);D!==E&&d.push("-g",D)}});const l=P([s],o,void 0,!1);return l.globArgs.forEach(g=>{const E=`!${(0,p.$Src)(g)}`;if(d.push("-g",E),O.$k){const D=(0,C.$om)(E);D!==E&&d.push("-g",D)}}),s.disregardIgnoreFiles!==!1?d.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),s.ignoreSymlinks||d.push("--follow"),i.exists&&d.push("--quiet"),n&&d.push("--threads",`${n}`),d.push("--no-config"),s.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:l.siblingClauses}}function P(i,s,t,o=!0){const n=[];let d={};return i.forEach(l=>{const g=Object.assign({},l.excludePattern||{},s||{}),E=a(g,o?l.folder.fsPath:void 0,t);n.push(...E.globArgs),E.siblingClauses&&(d=Object.assign(d,E.siblingClauses))}),{globArgs:n,siblingClauses:d}}function w(i,s,t=!0){const o=[];return i.forEach(n=>{const d=Object.assign({},s||{},n.includePattern||{}),l=a(d,t?n.folder.fsPath:void 0);o.push(...l.globArgs)}),o}function a(i,s,t){const o=[],n={};return Object.keys(i).forEach(d=>{if(t&&t.has(d)||!d)return;const l=i[d];d=$(s?m(s,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof l=="boolean"&&l?(d.startsWith("\\\\")&&(d+="**"),o.push(f(d))):l&&l.when&&(n[d]=l)}),{globArgs:o,siblingClauses:n}}function m(i,s){return h.$ic(s)?s:h.$jc(i,s)}function $(i){return i=T.$nf(i,"\\"),T.$nf(i,"/")}function f(i){return R.$Ag(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ke[348],Ie([1,0,56,45,16,349,18,52,38,81,31,10,42,12,17,33,37,346,136]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zrc=e.$Yrc=void 0,r=qe(r),h=qe(h),C=qe(C),O=qe(O),p=qe(p),c=qe(c),S=qe(S),P=qe(P),w=qe(w);const i=new Set;process.on("exit",()=>{i.forEach(d=>d())});class s{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&p.$Ak(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=l.shouldGlobMatchFilePattern?null:(0,f.$Rr)(this.b).normalizedLowercase),this.u=l.excludePattern&&p.$Ak(l.excludePattern),this.t=new Map,l.folderQueries.forEach(g=>{const E=Object.assign({},g.excludePattern||{},this.a.excludePattern||{}),D=g.folder.fsPath;l.folderQueries.map(y=>y.folder.fsPath).filter(y=>y!==D).forEach(y=>{(0,I.$Eg)(y,D)&&(E[C.$lc(D,y)]=!0)}),this.t.set(D,new o(E,D))})}cancel(){this.l=!0,i.forEach(l=>l())}walk(l,g,E,D,y,k){if(this.m=u.$fe.create(!1),this.l)return k(null,this.j);g.forEach(A=>{const b=C.$nc(A.fsPath);this.u&&this.u(A.fsPath,b)||this.J(D,{relativePath:A.fsPath,searchPath:void 0})}),this.r=u.$fe.create(!1),this.w(l,(A,b)=>{this.x(this.y,this,A,E,D,y,v=>{if(v){const F=(0,T.$qj)(v);console.error(F),this.q.push(F),b(v,void 0)}else b(null,void 0)})},(A,b)=>{this.m.stop();const v=A?O.$Gb(A)[0]:null;k(v,this.j)})}w(l,g,E){const D=new Array(l.length),y=new Array(l.length);let k=!1,A=0;if(l.length===0)return E(null,[]);l.forEach((b,v)=>{g(b,(F,N)=>{if(F?(k=!0,D[v]=null,y[v]=F):(D[v]=N,y[v]=null),++A===l.length)return E(k?y:null,D)})})}x(l,g,...E){try{l.apply(g,E)}catch(D){E[E.length-1](D)}}y(l,g,E,D,y){const k=l.folder.fsPath,A=S.$k,b=()=>M&&M.kill();i.add(b);let v=B=>{i.delete(b),v=()=>{},y(B)},F="";const N=this.D(),L=(0,$.$Vrc)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression,g),M=L.cmd,z=!Object.keys(L.siblingClauses).length,j=L.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let W=`${L.rgDiskPath} ${j}
 - cwd: ${L.cwd}`;L.rgArgs.siblingClauses&&(W+=`
 - Sibling clauses: ${JSON.stringify(L.rgArgs.siblingClauses)}`),D({message:W}),this.s=0,this.z(M,"utf8",D,(B,ee,H)=>{if(B){v(B);return}if(this.j){v();return}const Q=(F+(A?c.$nm(ee||""):ee)).split(`
`);if(H){const _=Q.length;Q[_-1]=Q[_-1].trim(),Q[_-1]||Q.pop()}else F=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){v(new Error("Splitting up files failed"));return}if(this.s+=Q.length,z){for(const _ of Q)if(this.J(E,{base:k,relativePath:_,searchPath:this.N(l,_)}),this.j){b();break}(H||this.j)&&v();return}this.G(l,N,k,Q,E),H&&(this.H(N,k,E),v())})}spawnFindCmd(l){const g=this.t.get(l.folder.fsPath),E=g.getBasenameTerms(),D=g.getPathTerms(),y=["-L","."];if(E.length||D.length){y.push("-not","(","(");for(const k of E)y.push("-name",k),y.push("-o");for(const k of D)y.push("-path",k),y.push("-o");y.pop(),y.push(")","-prune",")")}return y.push("-type","f"),r.spawn("find",y,{cwd:l.folder.fsPath})}readStdout(l,g,E){let D="";this.z(l,g,()=>{},(y,k,A)=>{if(y){E(y);return}D+=k,A&&E(null,D)})}z(l,g,E,D){let y=(b,v,F)=>{(b||F)&&(y=()=>{},this.r?.stop()),D(b,v,F)},k=!1;l.stdout?(this.A(l.stdout,g,y),l.stdout.once("data",()=>k=!0)):E({message:"stdout is null"});let A;l.stderr?A=this.B(l.stderr):E({message:"stderr is null"}),l.on("error",b=>{y(b)}),l.on("close",b=>{let v;!k&&(v=this.C(A,g))&&n(v)?y(new Error(`command failed with error code ${b}: ${this.C(A,g)}`)):(this.g&&b===0&&(this.j=!0),y(null,"",!0))})}A(l,g,E){const D=new R.StringDecoder(g);return l.on("data",y=>{E(null,D.write(y))}),D}B(l){const g=[];return l.on("data",E=>{g.push(E)}),g}C(l,g){const E=new R.StringDecoder(g);return l.map(D=>E.write(D)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:g},E,D,y){D.indexOf(this.b)!==-1&&this.J(y,{base:E,relativePath:this.b,searchPath:this.N(l,this.b)});const k=A=>{const b=C.$nc(A),v=C.$mc(A);let F=g[v];F||(F=g[v]=[],k(v)),F.push({base:E,relativePath:A,basename:b,searchPath:this.N(l,A)})};D.forEach(k)}H({rootEntries:l,pathToEntries:g},E,D){const y=this,k=this.t.get(E),A=this.b;function b(v){y.o++;const F=(0,m.$qM)(()=>v.map(N=>N.basename));for(let N=0,L=v.length;N<L;N++){const M=v[N],{relativePath:z,basename:j}=M;if(k.test(z,j,A!==j?F:void 0))continue;const W=g[z];if(W)b(W);else{if(y.p++,z===A)continue;y.J(D,M)}if(y.j)break}}b(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,g,E,D,y){const k=l.folder,A=(0,m.$qM)(()=>E);this.w(E,(b,v)=>{if(this.l||this.j)return v(null);const F=g?[g,b].join(C.sep):b;if(this.t.get(l.folder.fsPath).test(F,b,this.a.filePattern!==b?A:void 0))return v(null);const N=[k.fsPath,F].join(C.sep);h.lstat(N,(L,M)=>{if(L||this.l||this.j)return v(null);this.L(N,M,(z,j)=>z||this.l||this.j?v(null):j.isDirectory()?(this.o++,this.M(N,M,(W,B)=>W||this.l||this.j||(B=B||"",this.v[B])?v(null):(this.v[B]=!0,a.Promises.readdir(N).then(ee=>{if(this.l||this.j)return v(null);this.I(l,F,ee,D,H=>v(H||null))},ee=>{v(null)})))):(this.p++,F===this.b||this.h&&w.$ig(j.size)&&j.size>this.h||this.J(D,{base:k.fsPath,relativePath:F,searchPath:this.N(l,F)}),v(null,void 0)))})},b=>{const v=b&&O.$Gb(b);return y(v&&v.length>0?v[0]:void 0)})}J(l,g){this.K(g)&&(!this.d||this.d(g.relativePath,C.$nc(g.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(g))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$lM)(l,this.c);if(this.b)return(0,m.$lM)(l,this.b,!1)}return!0}L(l,g,E){return g.isSymbolicLink()?h.stat(l,E):E(null,g)}M(l,g,E){return g.isSymbolicLink()?h.realpath(l,(D,y)=>D?E(D):E(null,y)):E(null,l)}N(l,g){return l.folderName?C.$jc(l.folderName,g):g}}e.$Yrc=s;class t{constructor(l,g){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.d=g,this.c=new s(l)}search(l,g,E){this.c.walk(this.a,this.b,this.d,l,g,(D,y)=>{E(D,{limitHit:y,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Zrc=t;class o{constructor(l,g){this.expression=l,this.c=g,this.d(l)}d(l){let g,E;Object.keys(l).filter(D=>l[D]).forEach(D=>{C.$ic(D)?(g=g||p.$vk(),g[D]=l[D]):(E=E||p.$vk(),E[D]=l[D])}),this.a=g&&p.$Ak(g,{trimForExclusions:!0}),this.b=E&&p.$Ak(E,{trimForExclusions:!0})}test(l,g,E){return this.b&&this.b(l,g,E)||this.a&&this.a(C.$jc(this.c,l),g,E)}getBasenameTerms(){const l=[];return this.a&&l.push(...p.$Ck(this.a)),this.b&&l.push(...p.$Ck(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...p.$Dk(this.a)),this.b&&l.push(...p.$Dk(this.b)),l}}function n(d){const l=d.trim().split(`
`),g=l[0].trim();if(g.startsWith("Error parsing regex"))return g;if(g.startsWith("regex parse error"))return P.$9f(l[l.length-1].trim());if(g.startsWith("error parsing glob")||g.startsWith("unsupported encoding"))return g.charAt(0).toUpperCase()+g.substr(1);if(g==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(g.startsWith("Literal "))return g}}),define(ke[350],Ie([1,0,105,21,189,20,18]),function($e,e,r,h,C,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VE=e.$UE=e.$ME=e.DecodeStreamErrorKind=e.$LE=e.$KE=e.$JE=e.$HE=e.$GE=e.$FE=e.$EE=void 0,e.$IE=T,e.$NE=a,e.$OE=m,e.$PE=$,e.$QE=f,e.$RE=i,e.$SE=E,e.$TE=D,e.$EE="utf8",e.$FE="utf8bom",e.$GE="utf16be",e.$HE="utf16le";function T(y){return[e.$EE,e.$FE,e.$GE,e.$HE].some(k=>k===y)}e.$JE=[254,255],e.$KE=[255,254],e.$LE=[239,187,191];const p=512,c=512,I=512*8,S=512*128;var u;(function(y){y[y.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(u||(e.DecodeStreamErrorKind=u={}));class P extends Error{constructor(k,A){super(k),this.decodeStreamErrorKind=A}}e.$ME=P;class w{static async create(k){let A;if(k!==e.$EE)A=(await(0,C.$CE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(f(k));else{const b=new TextDecoder;A={write(v){return b.decode(v,{stream:!0})},end(){return b.decode()}}}return new w(A)}constructor(k){this.a=k}write(k){return this.a.write(k)}end(){return this.a.end()}}function a(y,k){const A=k.minBytesRequiredForDetection??k.guessEncoding?I:c;return new Promise((b,v)=>{const F=(0,r.$Be)(W=>W.join("")),N=[];let L=0,M;const z=new R.$we,j=async()=>{try{const W=await D({buffer:h.$Ne.concat(N),bytesRead:L},k.guessEncoding,k.candidateGuessEncodings);if(W.seemsBinary&&k.acceptTextOnly)throw new P("Stream is binary but only text is accepted for decoding",u.STREAM_IS_BINARY);W.encoding=await k.overwriteEncoding(W.encoding),M=await w.create(W.encoding);const B=M.write(h.$Ne.concat(N).buffer);F.write(B),N.length=0,L=0,b({stream:F,detected:W})}catch(W){z.cancel(),F.destroy(),v(W)}};(0,r.$Fe)(y,{onData:async W=>{M?F.write(M.write(W.buffer)):(N.push(W),L+=W.byteLength,L>=A&&(y.pause(),await j(),setTimeout(()=>y.resume())))},onError:W=>F.error(W),onEnd:async()=>{M||await j(),F.end(M?.end())}},z.token)})}async function m(y,k,A){const v=(await(0,C.$CE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(f(k),A);let F=!1,N=!1;return{read(){if(N)return null;const L=y.read();if(typeof L!="string"){if(N=!0,!F&&A?.addBOM)switch(k){case e.$EE:case e.$FE:return h.$Ne.wrap(Uint8Array.from(e.$LE));case e.$GE:return h.$Ne.wrap(Uint8Array.from(e.$JE));case e.$HE:return h.$Ne.wrap(Uint8Array.from(e.$KE))}const M=v.end();return M&&M.length>0?(F=!0,h.$Ne.wrap(M)):null}return F=!0,h.$Ne.wrap(v.write(L))}}}async function $(y){return(await(0,C.$CE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(f(y))}function f(y){return y===e.$FE||y===null?e.$EE:y}function i(y,k){if(!y||k<e.$JE.length)return null;const A=y.readUInt8(0),b=y.readUInt8(1);if(A===e.$JE[0]&&b===e.$JE[1])return e.$GE;if(A===e.$KE[0]&&b===e.$KE[1])return e.$HE;if(k<e.$LE.length)return null;const v=y.readUInt8(2);return A===e.$LE[0]&&b===e.$LE[1]&&v===e.$LE[2]?e.$FE:null}const s=["ascii","utf-16","utf-32"];async function t(y,k){const A=await(0,C.$CE)("jschardet","dist/jschardet.min.js"),b=y.slice(0,S),v=g(b.buffer);k&&(k=(0,O.$Gb)(k.map(L=>l(L))),k.length===0&&(k=void 0));const F=A.detect(v,k?{detectEncodings:k}:void 0);if(!F||!F.encoding)return null;const N=F.encoding.toLowerCase();return 0<=s.indexOf(N)?null:d(F.encoding)}const o={ibm866:"cp866",big5:"cp950"};function n(y){return y.replace(/[^a-zA-Z0-9]/g,"").toLowerCase()}function d(y){const k=n(y);return o[k]||k}function l(y){const k=n(y);return e.$VE[k].guessableName}function g(y){let k="";for(let A=0;A<y.length;A++)k+=String.fromCharCode(y[A]);return k}function E(y){switch(y){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const k=y.match(/windows(\d+)/);return k?"windows-"+k[1]:y}}}function D({buffer:y,bytesRead:k},A,b){let v=i(y,k),F=!1;if(v!==e.$GE&&v!==e.$HE&&y){let N=!0,L=!0,M=!1;for(let z=0;z<k&&z<p;z++){const j=z%2===1,W=y.readUInt8(z)===0;if(W&&(M=!0),N&&(j&&!W||!j&&W)&&(N=!1),L&&(j&&W||!j&&!W)&&(L=!1),W&&!N&&!L)break}M&&(N?v=e.$HE:L?v=e.$GE:F=!0)}return A&&!F&&!v&&y?t(y.slice(0,k),b).then(N=>({seemsBinary:!1,encoding:N})):{seemsBinary:F,encoding:v}}e.$UE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom",guessableName:"UTF-8"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3,guessableName:"UTF-16LE"},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4,guessableName:"UTF-16BE"},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5,guessableName:"windows-1252"},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16,guessableName:"windows-1250"},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17,guessableName:"ISO-8859-2"},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19,guessableName:"windows-1251"},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20,guessableName:"IBM866"},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21,guessableName:"ISO-8859-5"},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22,guessableName:"KOI8-R"},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25,guessableName:"windows-1253"},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26,guessableName:"ISO-8859-7"},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27,guessableName:"windows-1255"},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28,guessableName:"ISO-8859-8"},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36,guessableName:"Big5"},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38,guessableName:"SHIFT_JIS"},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39,guessableName:"EUC-JP"},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40,guessableName:"EUC-KR"},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45,guessableName:"GB2312"},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}},e.$VE=(()=>{const y={};for(const k in e.$UE)e.$UE[k].guessableName&&(y[k]=e.$UE[k]);return y})()}),define(ke[172],Ie([1,0,350,33,171]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8rc=void 0,h=qe(h);class R extends C.$Uqc{constructor(T,p,c=h,I="searchProcess"){super({query:T,provider:p},{readdir:S=>c.Promises.readdir(S.fsPath),toCanonicalName:S=>(0,r.$SE)(S)},I)}}e.$8rc=R}),define(ke[173],Ie([1,0,56,365,349,18,78,38,12,2,37,99,366,347,129]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2rc=e.$1rc=void 0,e.$3rc=o,e.$4rc=d,e.$5rc=g,e.$6rc=E,e.$7rc=y,r=qe(r);const a=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(A,b){this.a=A,this.b=b}provideTextSearchResults(A,b,v,F){return this.a.appendLine(`provideTextSearchResults ${A.pattern}, ${JSON.stringify({...b,folder:b.folder.toString()})}`),new Promise((N,L)=>{F.onCancellationRequested(()=>Q());const M={...b,numThreads:this.b},z=o(A,M),j=b.folder.fsPath,W=z.map(ge=>ge.match(/^-/)?ge:`'${ge}'`).join(" ");this.a.appendLine(`${a} ${W}
 - cwd: ${j}`);let B=r.spawn(a,z,{cwd:j});B.on("error",ge=>{console.error(ge),this.a.appendLine("Error: "+(ge&&ge.message)),L((0,I.$hM)(new I.$fM(ge&&ge.message,I.SearchErrorCode.rgProcessError)))});let ee=!1;const H=new i(b.maxResults,b.folder,b.previewOptions);H.on("result",ge=>{ee=!0,ce="",v.report(ge)});let q=!1;const Q=()=>{q=!0,B?.kill(),H?.cancel()};let _=!1;H.on("hitLimit",()=>{_=!0,Q()});let ce="";B.stdout.on("data",ge=>{H.handleData(ge),ee||(ce+=ge)});let ne=!1;B.stdout.once("data",()=>ne=!0);let ye="";B.stderr.on("data",ge=>{const Y=ge.toString();this.a.appendLine(Y),ye.length+Y.length<1e6&&(ye+=Y)}),B.on("close",()=>{if(this.a.appendLine(ne?"Got data from stdout":"No data from stdout"),this.a.appendLine(ee?"Got result from parser":"No result from parser"),ce&&this.a.appendLine(`Got data without result: ${ce}`),this.a.appendLine(""),q)N({limitHit:_});else{H.flush(),B=null;let ge;ye&&!ne&&(ge=$(ye))?L((0,I.$hM)(new I.$fM(ge.message,ge.code))):N({limitHit:_})}})})}}e.$1rc=m;function $(k){const A=k.split(`
`),b=A[0].trim();if(A.some(F=>F.startsWith("regex parse error")))return new I.$fM(f(A),I.SearchErrorCode.regexParseError);const v=b.match(/grep config error: unknown encoding: (.*)/);if(v)return new I.$fM(`Unknown encoding: ${v[1]}`,I.SearchErrorCode.unknownEncoding);if(b.startsWith("error parsing glob"))return new I.$fM(b.charAt(0).toUpperCase()+b.substr(1),I.SearchErrorCode.globParseError);if(b.startsWith("the literal"))return new I.$fM(b.charAt(0).toUpperCase()+b.substr(1),I.SearchErrorCode.invalidLiteral);if(b.startsWith("PCRE2: error compiling pattern"))return new I.$fM(b,I.SearchErrorCode.regexParseError)}function f(k){const A=["Regex parse error"],b=k.filter(v=>v.startsWith("PCRE2:"));if(b.length>=1){const v=b[0].replace("PCRE2:","");if(v.indexOf(":")!==-1&&v.split(":").length>=2){const F=v.split(":")[1];A.push(":"+F)}}return A.join("")}class i extends h.EventEmitter{constructor(A,b,v){super(),this.g=A,this.h=b,this.j=v,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new C.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(A,b){return super.on(A,b),this}handleData(A){if(this.b)return;const b=typeof A=="string"?A:this.d.write(A);this.k(b)}k(A){let b=A.indexOf(`
`);const v=this.a+A;if(b>=0)b+=this.a.length;else{this.a=v;return}let F=0;for(;b>=0;)this.m(v.substring(F,b).trim()),F=b+1,b=v.indexOf(`
`,F);this.a=v.substring(F)}m(A){if(this.b||!A)return;let b;try{b=JSON.parse(A)}catch{throw new Error(`malformed line from rg: ${A}`)}if(b.type==="match"){const v=s(b.data.path),F=c.URI.joinPath(this.h,v),N=this.n(b.data,F);this.p(N),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(b.type==="context"){const v=s(b.data.path),F=c.URI.joinPath(this.h,v);this.o(b.data,F).forEach(L=>this.p(L))}}n(A,b){const v=A.line_number-1,F=s(A.lines),N=Buffer.from(F);let L=0,M=0,z=v;A.submatches.length===0&&A.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const j=(0,R.$Gb)(A.submatches.map((W,B)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ee=s(W.match),H=N.slice(L,W.start).toString(),q=t(H),Q=q.numLines>0?q.lastLineLength:q.lastLineLength+M,_=t(ee),ce=q.numLines+z,ne=_.numLines+ce,ye=_.numLines>0?_.lastLineLength:_.lastLineLength+Q;return L=W.end,M=ye,z=ne,new S.$XL(ce,Q,ne,ye)}));return(0,w.$Trc)(b,F,j,this.j)}o(A,b){const v=s(A.lines),F=A.line_number;return v.replace(/\r?\n$/,"").split(`
`).map((N,L)=>({text:N,uri:b,lineNumber:F+L}))}p(A){this.emit("result",A)}}e.$2rc=i;function s(k){return k.bytes?Buffer.from(k.bytes,"base64").toString():k.text}function t(k){const A=/\n/g;let b=0,v=-1,F;for(;F=A.exec(k);)b++,v=F.index;const N=v>=0?k.length-v-1:k.length;return{numLines:b,lastLineLength:N}}function o(k,A){const b=["--hidden","--no-require-git"];b.push(k.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:v,otherIncludes:F}=(0,O.$c)(A.includes,L=>L.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const L=new Set;F.forEach(M=>{L.add(M)}),b.push("-g","!*"),L.forEach(M=>{n(M).map(w.$Src).forEach(z=>{b.push("-g",z)})})}v&&v.length&&v.forEach(L=>{b.push("-g",L)}),A.excludes.map(w.$Src).forEach(L=>b.push("-g",`!${L}`)),A.maxFileSize&&b.push("--max-filesize",A.maxFileSize+""),A.useIgnoreFiles?A.useParentIgnoreFiles||b.push("--no-ignore-parent"):b.push("--no-ignore"),A.followSymlinks&&b.push("--follow"),A.encoding&&A.encoding!=="utf8"&&b.push("--encoding",A.encoding),A.numThreads&&b.push("--threads",`${A.numThreads}`),k.pattern==="--"&&(k.isRegExp=!0,k.pattern="\\-\\-"),k.isMultiline&&!k.isRegExp&&(k.pattern=(0,p.$hf)(k.pattern),k.isRegExp=!0),A.usePCRE2&&b.push("--pcre2"),b.push("--crlf"),k.isRegExp&&(k.pattern=d(k.pattern),b.push("--engine","auto"));let N;if(k.isWordMatch){const M=(0,p.$qf)(k.pattern,!!k.isRegExp,{wholeWord:k.isWordMatch}).source.replace(/\\\//g,"/");b.push("--regexp",M)}else if(k.isRegExp){let L=g(k.pattern);L=E(L),b.push("--regexp",L)}else N=k.pattern,b.push("--fixed-strings");return b.push("--no-config"),A.useGlobalIgnoreFiles||b.push("--no-ignore-global"),b.push("--json"),k.isMultiline&&b.push("--multiline"),A.beforeContext&&b.push("--before-context",A.beforeContext+""),A.afterContext&&b.push("--after-context",A.afterContext+""),b.push("--"),N&&b.push(N),b.push("."),b}function n(k){return y(k).flatMap(b=>{const v=(0,T.$yk)(b,"/");return v.map((F,N)=>v.slice(0,N+1).join("/"))})}function d(k){const A=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;k.match(A);)k=k.replace(A,"$1\\x{$2}");const b=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;k.match(b);)k=k.replace(b,"$1\\x{$2}");return k}const l=k=>k.type==="Assertion"&&k.kind==="lookbehind";function g(k){let A;try{A=new u.RegExpParser().parsePattern(k)}catch{return k}let b="",v=0;const F=(M,z,j)=>{b+=k.slice(v,M)+j,v=z},N=[];return new u.RegExpVisitor({onCharacterEnter(M){if(M.raw!=="\\n")return;const z=N[0];if(!z)F(M.start,M.end,"\\r?\\n");else if(!N.some(l))if(z.type==="CharacterClass")if(z.negate){const j=k.slice(z.start+2,M.start)+k.slice(M.end,z.end-1);z.parent?.type==="Quantifier"?F(z.start,z.end,j?`[^${j}]`:"."):F(z.start,z.end,"(?!\\r?\\n"+(j?`|[${j}]`:"")+")")}else{const j=k.slice(z.start+1,M.start)+k.slice(M.end,z.end-1);F(z.start,z.end,j===""?"\\r?\\n":`(?:[${j}]|\\r?\\n)`)}else z.type==="Quantifier"&&F(M.start,M.end,"(?:\\r?\\n)")},onQuantifierEnter(M){N.unshift(M)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(M){N.unshift(M)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(M){N.unshift(M)},onCharacterClassLeave(){N.shift()},onAssertionEnter(M){l(M)&&N.push(M)},onAssertionLeave(M){N[0]===M&&N.shift()}}).visit(A),b+=k.slice(v),b}function E(k){return k.replace(/\n/g,"\\r?\\n")}function D(k){let A=!1,b=!1,v="",F="";for(let N=0;N<k.length;N++){const L=k[N];switch(L){case"\\":b?(A?F+="\\"+L:v+="\\"+L,b=!1):b=!0;break;case"{":if(b)A?F+=L:v+=L,b=!1;else{if(A)return{strInBraces:v+"{"+F+"{"+k.substring(N+1)};A=!0}break;case"}":if(b)A?F+=L:v+=L,b=!1;else{if(A)return{fixedStart:v,strInBraces:F,fixedEnd:k.substring(N+1)};v+=L}break;default:A?F+=(b?"\\":"")+L:v+=(b?"\\":"")+L,b=!1;break}}return{strInBraces:v+(A?"{"+F:"")}}function y(k){const{fixedStart:A,strInBraces:b,fixedEnd:v}=D(k);if(A===void 0||v===void 0)return[b];let F=(0,T.$yk)(b,",");F.length||(F=[""]);const N=y(v);return F.flatMap(L=>{const M=A+L;return N.map(z=>M+z)})}}),define(ke[351],Ie([1,0,20,173,89,14]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$rc=void 0;class O{constructor(c,I){this.b=c,this.c=I,this.a=new Set,process.once("exit",()=>this.e())}async provideTextSearchResults(c,I,S,u){const P=await this.c(),w=new h.$1rc(this.b,P),a={...I,numThreads:P};if(I.folder.scheme===R.Schemas.vscodeUserData){const m={...a,folder:I.folder.with({scheme:R.Schemas.file})},$=new C.$zw(f=>S.report({...f,uri:f.uri.with({scheme:I.folder.scheme})}));return this.d(u,f=>w.provideTextSearchResults(c,m,$,f))}else return this.d(u,m=>w.provideTextSearchResults(c,a,S,m))}async d(c,I){const S=T(c);this.a.add(S);const u=await I(S.token);return this.a.delete(S),u}e(){this.a.forEach(c=>c.cancel())}}e.$$rc=O;function T(p){const c=new r.$we;return p.onCancellationRequested(()=>c.cancel()),c}}),define(ke[352],Ie([1,0,33,173,172]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9rc=void 0,r=qe(r);class R{constructor(p,c){this.a=p,this.b=c}search(p,c,I){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const S={appendLine(P){I({message:P})}},u=new C.$8rc(this.a,new h.$1rc(S,this.b),r);return new Promise((P,w)=>u.search(a=>{c(a.map(O))},p).then(a=>P({limitHit:a.limitHit??!1,type:"success",stats:a.stats,messages:[]}),w))}}e.$9rc=R;function O(T){return{path:T.resource&&T.resource.fsPath,results:T.results,numMatches:(T.results||[]).reduce((p,c)=>{if(c.ranges){const I=c;return p+(Array.isArray(I.ranges)?I.ranges.length:1)}else return p+1},0)}}}),define(ke[353],Ie([1,0,18,7,13,4,136,16,42,2,27,37,348,352]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0rc=void 0,r=qe(r);class w{static{this.a=512}constructor(s="searchProcess",t){this.d=s,this.f=t,this.b=Object.create(null)}fileSearch(s){let t;const o=$(s),n=new R.$le({onDidAddFirstListener:()=>{t=(0,h.$sh)(async d=>{const l=await this.f?.();return this.doFileSearchWithEngine(u.$Zrc,o,g=>n.fire(g),d,w.a,l)}),t.then(d=>n.fire(d),d=>n.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return n.event}textSearch(s){let t;const o=$(s),n=new R.$le({onDidAddFirstListener:()=>{t=(0,h.$sh)(d=>this.g(o,l=>n.fire(l),d)),t.then(d=>n.fire(d),d=>n.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return n.event}async g(s,t,o){s.maxFileSize=this.h().maxFileSize;const n=await this.f?.();return new P.$9rc(s,n).search(o,t,t)}h(){return{maxFileSize:16*I.$Il.GB}}doFileSearch(s,t,o,n){return this.doFileSearchWithEngine(u.$Zrc,s,o,n,w.a,t)}doFileSearchWithEngine(s,t,o,n,d=w.a,l){let g=0;const E=y=>{Array.isArray(y)?(g+=y.length,o(y.map(k=>this.j(k)))):y.relativePath?(g++,o(this.j(y))):o(y)};if(t.sortByScore){let y=this.n(t,E,n);if(!y){const k=t.maxResults?Object.assign({},t,{maxResults:null}):t,A=new s(k,l);y=this.k(A,t,o,E,n)}return new Promise((k,A)=>{y.then(([b,v])=>{const F=v.map(N=>this.j(N));this.q(F,o,d),k(b)},A)})}const D=new s(t,l);return this.s(D,E,d,n).then(y=>({limitHit:y.limitHit,type:"success",stats:{detailStats:y.stats,type:this.d,fromCache:!1,resultCount:g,sortingTime:void 0},messages:[]}))}j(s){return{path:s.base?(0,T.$jc)(s.base,s.relativePath):s.relativePath}}k(s,t,o,n,d){const l=new R.$le;let g=(0,h.$sh)(D=>{let y=[];const k=A=>{Array.isArray(A)?y=A:(n(A),l.fire(A))};return this.s(s,k,-1,D).then(A=>[A,y])}),E;if(t.cacheKey){E=this.l(t.cacheKey);const D={promise:g,event:l.event,resolved:!1};E.resultsToSearchCache[t.filePattern||""]=D,g.then(()=>{D.resolved=!0},y=>{delete E.resultsToSearchCache[t.filePattern||""]}),g=this.t(g)}return g.then(([D,y])=>{const k=E?E.scorerCache:Object.create(null),A=(typeof t.maxResults!="number"||t.maxResults>0)&&p.$fe.create(!1);return this.o(t,y,k,d).then(b=>{const v=A?A.elapsed():-1;return[{type:"success",stats:{detailStats:D.stats,sortingTime:v,fromCache:!1,type:this.d,resultCount:b.length},messages:D.messages,limitHit:D.limitHit||typeof t.maxResults=="number"&&y.length>t.maxResults},b]})})}l(s){const t=this.b[s];return t||(this.b[s]=new a)}n(s,t,o){const n=s.cacheKey&&this.b[s.cacheKey];if(!n)return;const d=this.r(n,s.filePattern||"",t,o);if(d)return d.then(([l,g,E])=>{const D=p.$fe.create(!1);return this.o(s,g,n.scorerCache,o).then(y=>{const k=D.elapsed(),A={fromCache:!0,detailStats:E,type:this.d,resultCount:g.length,sortingTime:k};return[{type:"success",limitHit:l.limitHit||typeof s.maxResults=="number"&&g.length>s.maxResults,stats:A,messages:[]},y]})})}o(s,t,o,n){const d=(0,O.$Rr)(s.filePattern||""),l=(E,D)=>(0,O.$Qr)(E,D,d,!0,m,o),g=typeof s.maxResults=="number"?s.maxResults:S.$7L;return r.$Fb(t,l,g,1e4,n)}q(s,t,o){if(o&&o>0)for(let n=0;n<s.length;n+=o)t(s.slice(n,n+o));else t(s)}r(s,t,o,n){const d=p.$fe.create(!1),l=t.indexOf(T.sep)>=0;let g;for(const k in s.resultsToSearchCache)if(t.startsWith(k)){if(l&&k.indexOf(T.sep)<0&&k!=="")continue;const A=s.resultsToSearchCache[k];g={promise:this.t(A.promise),event:A.event,resolved:A.resolved};break}if(!g)return null;const E=d.elapsed(),D=p.$fe.create(!1),y=g.event(o);return n&&n.onCancellationRequested(()=>{y.dispose()}),g.promise.then(([k,A])=>{if(n&&n.isCancellationRequested)throw(0,C.$5)();const b=[],v=(0,O.$Rr)(t).normalizedLowercase;for(const F of A)(0,S.$lM)(F,v)&&b.push(F);return[k,b,{cacheWasResolved:g.resolved,cacheLookupTime:E,cacheFilterTime:D.elapsed(),cacheEntryCount:A.length}]})}s(s,t,o,n){return new Promise((d,l)=>{let g=[];n?.onCancellationRequested(()=>s.cancel()),s.search(E=>{E&&(o?(g.push(E),o>0&&g.length>=o&&(t(g),g=[])):t(E))},E=>{t(E)},(E,D)=>{g.length&&t(g),E?(t({message:"Search finished. Error: "+E.message}),l(E)):(t({message:"Search finished. Stats: "+JSON.stringify(D.stats)}),d(D))})})}clearCache(s){return delete this.b[s],Promise.resolve(void 0)}t(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(t,o){return s.then(t,o)}catch(t){return this.then(void 0,t)}finally(t){return s.finally(t)}}}}e.$0rc=w;class a{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(i){return(0,T.$nc)(i.relativePath)}getItemDescription(i){return(0,T.$mc)(i.relativePath)}getItemPath(i){return i.relativePath}};function $(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(f),extraFileResources:i.extraFileResources&&i.extraFileResources.map(s=>c.URI.revive(s))}}function f(i){return{...i,folder:c.URI.revive(i.folder)}}}),define(ke[354],Ie([1,0,3,14,2,33,11,41,29,19,102,72,37,353,351,129,172]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_rc=void 0,R=qe(R);let $=class extends I.$Zqc{constructor(i,s,t,o,n){super(i,t,n),this.D=o,this.w=R,this.x=-1,this.y=null,this.z=!1,this.B=new r.$Tc,this.C=!1,this.getNumThreads=this.getNumThreads.bind(this),this.getNumThreadsCached=this.getNumThreadsCached.bind(this),this.E=this.E.bind(this);const d=new a.$Urc("RipgrepSearchUD",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.vscodeUserData,new w.$$rc(d,this.getNumThreadsCached))),s.remote.isRemote&&s.remote.authority&&this.F(),o.getConfigProvider().then(l=>{this.C||this.B.add(l.onDidChangeConfiguration(this.E))})}E(i){i.affectsConfiguration("search")&&(this.A=void 0)}async getNumThreads(){return(await this.D.getConfigProvider()).getConfiguration("search").get("ripgrep.maxThreads")}async getNumThreadsCached(){return this.A||(this.A=this.getNumThreads()),this.A}dispose(){this.C=!0,this.B.dispose()}$enableExtensionHostSearch(){this.F()}F(){if(this.z)return;this.z=!0;const i=new a.$Urc("RipgrepSearchEH",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.file,new w.$$rc(i,this.getNumThreadsCached))),this.B.add(this.G(h.Schemas.file,new P.$0rc("fileSearchProvider",this.getNumThreadsCached)))}G(i,s){const t=this.d++;return this.y=s,this.x=t,this.c.$registerFileSearchProvider(t,this.s(i)),(0,r.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(t)})}$provideFileSearchResults(i,s,t,o){const n=(0,I.$1qc)(t);if(i===this.x){const d=Date.now();return this.H(i,s,n,o).then(l=>{const g=Date.now()-d;return this.q.debug(`Ext host file search time: ${g}ms`),l})}return super.$provideFileSearchResults(i,s,t,o)}async doInternalFileSearchWithCustomCallback(i,s,t){const o=d=>{if((0,u.$kM)(d)&&(d=[d]),Array.isArray(d)){t(d.map(l=>C.URI.file(l.path)));return}d.message&&this.q.debug("ExtHostSearch",d.message)};if(!this.y)throw new Error("No internal file search handler");const n=await this.getNumThreadsCached();return this.y.doFileSearch(i,n,o,s)}async H(i,s,t,o){return this.doInternalFileSearchWithCustomCallback(t,o,n=>{this.c.$handleFileMatch(i,s,n)})}$clearCache(i){return this.y?.clearCache(i),super.$clearCache(i)}t(i,s){return new m.$8rc(i,s,void 0,"textSearchProvider")}};e.$_rc=$,e.$_rc=$=Je([Ve(0,c.$kQ),Ve(1,p.$AQ),Ve(2,S.$Lpc),Ve(3,T.$Rpc),Ve(4,O.$ak)],$)}),define(ke[130],Ie([1,0,367,67,66,368,21,13,4,3,16,10,32,86,68]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$wi=e.$vi=e.$ui=void 0,e.$xi=l,e.$yi=g,e.$Ai=y,e.$Bi=k;const a=3e4;class m{traceSocketEvent(b,v){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,v)}constructor(b,v=""){this.f=!0,this.debugLabel=v,this.socket=b,this.traceSocketEvent(w.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=N=>{if(this.traceSocketEvent(w.SocketDiagnosticsEventType.Error,{code:N?.code,message:N?.message}),N){if(N.code==="EPIPE")return;(0,T.$Y)(N)}},this.socket.on("error",this.a);let F;this.b=N=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.Close,{hadError:N}),this.f=!1,F&&clearTimeout(F)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,F=setTimeout(()=>b.destroy(),a)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(b){const v=F=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.Read,F),b(O.$Ne.wrap(F))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(b){const v=F=>{b({type:w.SocketCloseEventType.NodeSocketCloseEvent,hadError:F,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(b){const v=()=>{b()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(b){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(w.SocketDiagnosticsEventType.Write,b),this.socket.write(b.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,T.$Y)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,T.$Y)(v)}}end(){this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((b,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainEnd),b();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainEnd),b()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.$ui=m;var $;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize",A[A.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var f;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(f||(f={}));class i extends c.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(b,v){this.socket.traceSocketEvent(b,v)}constructor(b,v,F,N){super(),this.f=this.B(new p.$le),this.g=this.B(new p.$le),this.h=!1,this.j={state:f.PeekHeader,readLen:$.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=b,this.traceSocketEvent(w.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:F?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new s(this,v,F,N,this.f,(L,M)=>this.m(L,M))),this.B(this.a.onError(L=>{console.error(L),(0,T.$Y)(L),this.g.fire({type:w.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:L})})),this.b=new w.$pi,this.B(this.socket.onData(L=>this.n(L))),this.B(this.socket.onClose(async L=>{this.a.isProcessingReadQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(L)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this.f.event(b)}onClose(b){return this.g.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){let v=0;for(;v<b.byteLength;)this.a.writeMessage(b.slice(v,Math.min(v+$.MaxWebSocketMessageLength,b.byteLength)),{compressed:!0,opcode:2}),v+=$.MaxWebSocketMessageLength}m(b,{compressed:v,opcode:F}){if(this.h)return;this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,b);let N=$.MinHeaderByteSize;b.byteLength<126?N+=0:b.byteLength<2**16?N+=2:N+=8;const L=O.$Ne.alloc(N),M=v?64:0,z=F&15;if(L.writeUInt8(128|M|z,0),b.byteLength<126)L.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){L.writeUInt8(126,1);let j=1;L.writeUInt8(b.byteLength>>>8&255,++j),L.writeUInt8(b.byteLength>>>0&255,++j)}else{L.writeUInt8(127,1);let j=1;L.writeUInt8(0,++j),L.writeUInt8(0,++j),L.writeUInt8(0,++j),L.writeUInt8(0,++j),L.writeUInt8(b.byteLength>>>24&255,++j),L.writeUInt8(b.byteLength>>>16&255,++j),L.writeUInt8(b.byteLength>>>8&255,++j),L.writeUInt8(b.byteLength>>>0&255,++j)}this.socket.write(O.$Ne.concat([L,b]))}end(){this.h=!0,this.socket.end()}n(b){if(b.byteLength!==0){for(this.b.acceptChunk(b);this.b.byteLength>=this.j.readLen;)if(this.j.state===f.PeekHeader){const v=this.b.peek(this.j.readLen),F=v.readUInt8(0),N=(F&128)>>>7,L=(F&64)>>>6,M=F&15,z=v.readUInt8(1),j=(z&128)>>>7,W=z&127;this.j.state=f.ReadHeader,this.j.readLen=$.MinHeaderByteSize+(j?4:0)+(W===126?2:0)+(W===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!L),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===f.ReadHeader){const v=this.b.read(this.j.readLen),F=v.readUInt8(1),N=(F&128)>>>7;let L=F&127,M=1;L===126?L=v.readUInt8(++M)*2**8+v.readUInt8(++M):L===127&&(L=v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M));let z=0;N&&(z=v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M)),this.j.state=f.ReadBody,this.j.readLen=L,this.j.mask=z,this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===f.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),n(v,this.j.mask),this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=f.PeekHeader,this.j.readLen=$.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$vi=i;class s extends c.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$Ne.alloc(0)}constructor(b,v,F,N,L,M){super(),this.n=b,this.r=L,this.s=M,this.a=this.B(new p.$le),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new p.$le),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new p.$le),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new t(this.n,N,F,{windowBits:15})),this.f=this.B(new o(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(b,v){this.g.push({data:b,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:b,options:v}=this.g.shift();if(this.f&&v.compressed){const F=await this.w(this.f,b);this.s(F,v)}else this.s(b,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(b,v){return new Promise((F,N)=>{b.write(v),b.flush(L=>F(L))})}acceptFrame(b,v,F){this.h.push({data:b,isCompressed:v,isLastFrameOfMessage:F}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const b=this.h.shift();if(this.b&&b.isCompressed){const v=await this.C(this.b,b.data,b.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(b.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(b,v,F){return new Promise((N,L)=>{b.write(v),F&&b.write(O.$Ne.fromByteArray([0,0,255,255])),b.flush(M=>N(M))})}}class t extends c.$Uc{get recordedInflateBytes(){return this.j?O.$Ne.concat(this.f):O.$Ne.alloc(0)}constructor(b,v,F,N){super(),this.h=b,this.j=v,this.a=this.B(new p.$le),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(N),this.b.on("error",L=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateError,{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateData,L),this.g.push(O.$Ne.wrap(L))}),F&&(this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateInitialWrite,F.buffer),this.b.write(F.buffer),this.b.flush(()=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(b){this.j&&this.f.push(b.clone()),this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateWrite,b),this.b.write(b.buffer)}flush(b){this.b.flush(()=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=O.$Ne.concat(this.g);this.g.length=0,b(v)})}}class o extends c.$Uc{constructor(b,v){super(),this.g=b,this.a=this.B(new p.$le),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",F=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateError,{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateData,F),this.f.push(O.$Ne.wrap(F))})}write(b){this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateWrite,b.buffer),this.b.write(b.buffer)}flush(b){this.b.flush(2,()=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=O.$Ne.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),b(v)})}}function n(A,b){if(b===0)return;const v=A.byteLength>>>2;for(let j=0;j<v;j++){const W=A.readUInt32BE(j*4);A.writeUInt32BE(W^b,j*4)}const F=v*4,N=A.byteLength-F,L=b>>>24&255,M=b>>>16&255,z=b>>>8&255;N>=1&&A.writeUInt8(A.readUInt8(F)^L,F),N>=2&&A.writeUInt8(A.readUInt8(F+1)^M,F+1),N>=3&&A.writeUInt8(A.readUInt8(F+2)^z,F+2)}e.$wi=process.env.XDG_RUNTIME_DIR;const d={[S.Platform.Linux]:107,[S.Platform.Mac]:103};function l(){const A=(0,u.$2g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;const b=process.platform!=="darwin"&&e.$wi?e.$wi:(0,C.tmpdir)(),v=(0,I.$jc)(b,`vscode-ipc-${A}.sock`);return E(v),v}function g(A,b,v){const N=(0,r.createHash)("sha256").update(A).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${v}-${b}-sock`;const L=v.substr(0,4),M=b.substr(0,6);let z;return process.platform!=="darwin"&&e.$wi&&!process.env.VSCODE_PORTABLE?z=(0,I.$jc)(e.$wi,`vscode-${N}-${L}-${M}.sock`):z=(0,I.$jc)(A,`${L}-${M}.sock`),E(z),z}function E(A){const b=d[S.$v];typeof b=="number"&&A.length>=b&&console.warn(`WARNING: IPC handle "${A}" is longer than ${b} chars, try a shorter --user-data-dir`)}class D extends P.$ji{static b(b){const v=p.Event.fromNodeEventEmitter(b,"connection");return p.Event.map(v,F=>({protocol:new w.$qi(new m(F,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(F,"close"))}))}constructor(b){super(D.b(b)),this.d=b}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$zi=D;function y(A){return new Promise((b,v)=>{const F=(0,h.createServer)();F.on("error",v),F.listen(A,()=>{F.removeListener("error",v),b(new D(F))})})}function k(A,b){return new Promise((v,F)=>{const N=(0,h.createConnection)(A,()=>{N.removeListener("error",F),v(w.$ri.fromSocket(new m(N,`ipc-client${b}`),b))});N.once("error",F)})}}),define(ke[355],Ie([1,0,67,66,191,130,7,3,10,46,11,115,234,236,117,92,21]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=e.$Rhc=e.$Qhc=e.$Phc=void 0,r=qe(r),h=qe(h);async function $(o,n,d,l,g){let E;for(let D=3;D&&(E?.dispose(),E=await new f(o,n,d,l,g).waitForReady(),!(g&&C.$5g[g]||!C.$5g[E.tunnelLocalPort]));D--);return E}class f extends T.$Uc{constructor(n,d,l,g,E){super(),this.m=d,this.n=E,this.privacy=a.TunnelPrivacyId.Private,this.j=new Map,this.a=n,this.b=r.createServer(),this.c=new O.$Eh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=D=>this.r(D),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=g,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const n=this.n??this.tunnelRemotePort,d=(0,a.$Mw)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,C.$6g)(n,2,1e3,d),g=null;return this.b.listen(l,this.m),await this.c.wait(),g=this.b.address(),g||(l=0,this.b.listen(l,this.m),await this.c.wait(),g=this.b.address()),this.tunnelLocalPort=g.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${g.port}`,this}async r(n){n.pause();const d=(0,a.$Kw)(this.tunnelRemoteHost)||(0,a.$Mw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,u.$3l)(this.a,d,this.tunnelRemotePort),g=l.getSocket(),E=l.readEntireBuffer();l.dispose(),E.byteLength>0&&n.write(E.buffer),n.on("end",()=>{n.localAddress&&this.j.delete(n.localAddress),g.end()}),n.on("close",()=>g.end()),n.on("error",()=>{n.localAddress&&this.j.delete(n.localAddress),g instanceof R.$ui?g.socket.destroy():g.end()}),g instanceof R.$ui?this.t(n,g):this.s(n,g),n.localAddress&&this.j.set(n.localAddress,()=>{n.end(),g.end()})}s(n,d){d.onClose(()=>n.destroy()),d.onEnd(()=>n.end()),d.onData(l=>n.write(l.buffer)),n.on("data",l=>d.write(m.$Ne.wrap(l))),n.resume()}t(n,d){const l=d.socket;l.on("end",()=>n.end()),l.on("close",()=>n.end()),l.on("error",()=>{n.destroy()}),l.pipe(n),n.pipe(l)}}e.$Phc=f;let i=class extends a.$Pw{constructor(n,d,l,g,E){super(d,E),this.H=n,this.I=l,this.J=g}isPortPrivileged(n){return(0,a.$Nw)(n,this.t,p.OS,h.release())}F(n,d,l,g,E,D,y,k){const A=this.D(d,l);if(A)return++A.refcount,A.value;if((0,a.$Gw)(n))return this.G(n,d,l,E,D,y,k);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${l} on local port ${E}.`);const b={commit:this.J.commit,quality:this.J.quality,addressProvider:n,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=$(b,g,d,l,E);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(d,l,v),v}}};e.$Qhc=i,e.$Qhc=i=Je([Ve(0,P.$Wl),Ve(1,I.$ak),Ve(2,w.$Zl),Ve(3,S.$tk),Ve(4,c.$_i)],i);let s=class extends i{constructor(n,d,l,g,E){super(n,d,l,g,E)}};e.$Rhc=s,e.$Rhc=s=Je([Ve(0,P.$Wl),Ve(1,I.$ak),Ve(2,w.$Zl),Ve(3,S.$tk),Ve(4,c.$_i)],s);let t=class extends T.$Uc{constructor(n,d,l,g,E){super(),this.b=n,this.c=d,this.f=l,this.g=g,this.h=E,this.a=new Map}async openTunnel(n,d,l,g,E,D,y,k,A){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${g} on local port ${D}.`),!this.a.has(n)){const b=new s(this.b,this.c,this.g,this.f,this.h);this.B(b),this.a.set(n,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this.a.delete(n))})}return this.a.get(n).openTunnel(d,l,g,E,D,y,k,A)}};e.$Shc=t,e.$Shc=t=Je([Ve(0,P.$Wl),Ve(1,I.$ak),Ve(2,S.$tk),Ve(3,w.$Zl),Ve(4,c.$_i)],t)}),define(ke[356],Ie([1,0,130,253,45,34,2,11,47]),function($e,e,r,h,C,R,O,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MQ=e.$LQ=void 0,h=qe(h),C=qe(C);class c{constructor(u,P,w){this.b=u,this.c=P,this.f=w,this.a=h.createServer((a,m)=>this.h(a,m)),this.g().catch(a=>(P.error(a),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",u=>this.c.error(u))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(u,P){const w=(m,$)=>{P.writeHead(m,{"content-type":"application/json"}),P.end(JSON.stringify($||null),f=>f&&this.c.error(f))},a=[];u.setEncoding("utf8"),u.on("data",m=>a.push(m)),u.on("end",async()=>{try{const m=JSON.parse(a.join(""));let $;switch(m.type){case"open":$=await this.i(m);break;case"openExternal":$=await this.j(m);break;case"status":$=await this.l(m);break;case"extensionManagement":$=await this.k(m);break;default:w(404,`Unknown message type: ${m.type}`);break}w(200,$)}catch(m){const $=m instanceof Error?m.message:JSON.stringify(m);w(500,$),this.c.error("Error while processing pipe request",m)}})}async i(u){const{fileURIs:P,folderURIs:w,forceNewWindow:a,diffMode:m,mergeMode:$,addMode:f,forceReuseWindow:i,gotoLineMode:s,waitMarkerFilePath:t,remoteAuthority:o}=u,n=[];if(Array.isArray(w))for(const E of w)try{n.push({folderUri:O.URI.parse(E)})}catch{}if(Array.isArray(P))for(const E of P)try{(0,p.$$i)(E)?n.push({workspaceUri:O.URI.parse(E)}):n.push({fileUri:O.URI.parse(E)})}catch{}const d=t?O.URI.file(t):void 0,g={forceNewWindow:a,diffMode:m,mergeMode:$,addMode:f,gotoLineMode:s,forceReuseWindow:i,preferNewWindow:!i&&!d&&!f,waitMarkerFileURI:d,remoteAuthority:o};this.b.executeCommand("_remoteCLI.windowOpen",n,g)}async j(u){for(const P of u.uris){const w=O.URI.parse(P),a=w.scheme==="file"?w:P;await this.b.executeCommand("_remoteCLI.openExternal",a)}}async k(u){const P=a=>a?.map(m=>/\.vsix$/i.test(m)?O.URI.parse(m):m),w={list:u.list,install:P(u.install),uninstall:P(u.uninstall),force:u.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",w)}async l(u){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&C.existsSync(this.f)&&C.unlinkSync(this.f)}}e.$LQ=c;let I=class extends c{constructor(u,P){super(u,P,(0,r.$xi)())}};e.$MQ=I,e.$MQ=I=Je([Ve(0,R.$GQ),Ve(1,T.$ak)],I)}),define(ke[357],Ie([1,0,61,344,339,252,54,326,2,14,9,356,108,286,325]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$esc=void 0,r=qe(r);class a extends C.$Frc{j(){const f=this,i=globalThis._VSCODE_NODE_MODULES.module,s=i._load;i._load=function(d,l,g){return d=o(d),f.a.has(d)?f.a.get(d).load(d,p.URI.file((0,u.$or)(l.filename)),E=>s.apply(this,[E,l,g])):s.apply(this,arguments)};const t=i._resolveLookupPaths;i._resolveLookupPaths=(n,d)=>t.call(this,o(n),d);const o=n=>{for(const d of f.b){const l=d(n);if(l){n=l;break}}return n}}}class m extends O.$rqc{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Node}async vb(){this.h.createInstance(P.$csc);const f=this.h.invokeFunction(h.$Brc);if(this.h.createInstance(T.$bsc),this.f.remote.isRemote&&this.f.remote.authority){const t=this.h.createInstance(S.$MQ);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}this.h.createInstance(w.$dsc),await this.h.createInstance(a,f,{mine:this.J,all:this.L}).install(),r.mark("code/extHost/didInitAPI");const s=await this.m.getConfigProvider();await(0,R.$asc)(this.j,s,this,this.s,this.z,this.f),r.mark("code/extHost/didInitProxyResolver")}wb(f){return f.main}async xb(f,i,s){if(i.scheme!==c.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let t=null;s.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const o=f?.identifier.value;f&&await this.w.initializeLocalizedMessages(f);try{o&&r.mark(`code/extHost/willLoadExtensionCode/${o}`),t=$e.__$__nodeRequire(i.fsPath)}finally{o&&r.mark(`code/extHost/didLoadExtensionCode/${o}`),s.codeLoadingStop()}return t}async $setRemoteEnvironment(f){if(this.f.remote.isRemote)for(const i in f){const s=f[i];s===null?delete process.env[i]:process.env[i]=s}}}e.$esc=m}),define(ke[358],Ie([1,0,45,56,21,4,3,133,10,22,2,33,68,11,233,71,117,92,355,29,19,76,333]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f,i,s,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$msc=void 0,e.$fsc=n,e.$gsc=d,e.$hsc=l,e.$isc=g,e.$jsc=D,e.$ksc=y,e.$lsc=k,r=qe(r),c=qe(c),S=qe(S);function n(v){const F=v.trim().split(`
`),N=[];return F.forEach(M=>{const z=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(M);z&&z.length>=3&&N.push({pid:parseInt(z[1],10),socket:parseInt(z[2],10)})}),N.reduce((M,z)=>(M[z.socket]=z,M),{})}function d(...v){const F=[].concat(...v.map(g));return[...new Map(F.filter(N=>N.st==="0A").map(N=>{const L=N.local_address.split(":");return{socket:parseInt(N.inode,10),ip:l(L[0]),port:parseInt(L[1],16)}}).map(N=>[N.ip+":"+N.port,N])).values()]}function l(v){let F="";if(v.length===8)for(let N=v.length-2;N>=0;N-=2)F+=parseInt(v.substr(N,2),16),N!==0&&(F+=".");else for(let N=0;N<v.length;N+=8){const L=v.substring(N,N+8);let M="";for(let z=8;z>=2;z-=2)M+=L.substring(z-2,z),(z===6||z===2)&&(M=parseInt(M,16).toString(16),F+=`${M}`,M="",N+z!==v.length-6&&(F+=":"))}return F}function g(v){const F=v.trim().split(`
`),N=F.shift().trim().split(/\s+/).filter(M=>M!=="rx_queue"&&M!=="tm->when");return F.map(M=>M.trim().split(/\s+/).reduce((z,j,W)=>(z[N[W]||W]=j,z),{}))}function E(v){return!!v.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||v.indexOf("out/server-main.js")!==-1||v.indexOf("_productName=VSCode")!==-1}function D(v){const F=v.trim().split(`
`),N=[];return F.forEach(L=>{const M=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(L);M&&M.length>=4&&N.push({pid:parseInt(M[1],10),ppid:parseInt(M[2]),cmd:M[3]})}),N}async function y(v,F,N){const L=N.reduce((z,j)=>(z[j.pid]=j,z),{}),M=[];return v.forEach(({socket:z,ip:j,port:W})=>{const B=F[z]?F[z].pid:void 0,ee=B?L[B]?.cmd:void 0;B&&ee&&!E(ee)&&M.push({host:j,port:W,detail:ee,pid:B})}),M}function k(v,F,N){const L=new Map,M=D(F);for(const z of v){const j=N.get(z.port);if(j){L.set(z.port,j);continue}const W=M.find(B=>B.cmd.includes(`${z.port}`));if(W){let B=W,ee;do ee=M.find(H=>H.ppid===B.pid),ee&&(B=ee);while(ee);L.set(z.port,{host:z.ip,port:z.port,pid:B.pid,detail:B.cmd,ppid:B.ppid})}else L.set(z.port,{host:z.ip,port:z.port,ppid:Number.MAX_VALUE})}return L}let A=class extends t.$kGb{constructor(F,N,L,M){super(F,N,L),this.D=N,this.F=M,this.y=void 0,this.z=new Map,this.C=!1,p.$l&&N.remote.isRemote&&N.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(F){if(F&&this.C)return;this.C=F;let N;this.y&&(N=this.y,await this.a.$onFoundNewCandidates(this.y));const L=new T.$Om;let M=0;for(;this.C;){const z=new Date().getTime(),j=(await this.I()).filter(ee=>(0,$.$Kw)(ee.host)||(0,$.$Mw)(ee.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(ee=>ee.port).join(", ")}`);const W=new Date().getTime()-z;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${W} ms.`),M++>3&&L.update(W),(!N||JSON.stringify(N)!==JSON.stringify(j))&&(N=j,await this.a.$onFoundNewCandidates(N));const B=this.G(L.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${B} ms.`),await new Promise(ee=>setTimeout(()=>ee(),B))}}G(F){return Math.max(F*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(F=>F.port).join(", ")}`)}async I(){let F="",N="";try{F=await r.promises.readFile("/proc/net/tcp","utf8"),N=await r.promises.readFile("/proc/net/tcp6","utf8")}catch{}const L=d(F,N),M=await new Promise(Q=>{(0,h.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(_,ce,ne)=>{Q(ce)})}),z=n(M),j=await S.Promises.readdir("/proc"),W=[];for(const Q of j)try{const _=Number(Q),ce=c.$gh(I.URI.file("/proc"),Q);if((await r.promises.stat(ce.fsPath)).isDirectory()&&!isNaN(_)){const ye=await r.promises.readlink(c.$gh(ce,"cwd").fsPath),ge=await r.promises.readFile(c.$gh(ce,"cmdline").fsPath,"utf8");W.push({pid:_,cwd:ye,cmd:ge})}}catch{}const B=[],ee=L.filter(Q=>{const _=z[Q.socket];return _||B.push(Q),_}),H=y(ee,z,W);let q;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${B.length}`),B.length>0){const Q=await new Promise(_=>{(0,h.exec)("ps -F -A -l | grep root",(ce,ne,ye)=>{_(ne)})});this.z=k(B,Q,this.z),q=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${q.map(_=>_.port).join(", ")}`)}return H.then(Q=>q?Q.concat(q):Q)}w(F){return async N=>{const L=new f.$Phc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(z,j,W,B){const ee=await F.makeConnection();return b.connect(ee,j,W,B)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new a.$Sl(0),connectionToken:F.connectionToken})}},signService:this.F},"localhost",N.remoteAddress.host||"localhost",N.remoteAddress.port,N.localAddressPort);await L.waitForReady();const M=new R.$le;return{localAddress:(0,o.$$M)(L.localAddress)??L.localAddress,remoteAddress:{port:L.tunnelRemotePort,host:L.tunnelRemoteHost},onDidDispose:M.event,dispose:()=>{L.dispose(),M.fire(),M.dispose()}}}}};e.$msc=A,e.$msc=A=Je([Ve(0,s.$kQ),Ve(1,i.$AQ),Ve(2,P.$ak),Ve(3,m.$Zl)],A);class b extends w.$Fxb{static connect(F,N,L,M){const z=new O.$Tc,j={onClose:z.add(new R.$le),onData:z.add(new R.$le),onEnd:z.add(new R.$le)};z.add(F.onDidReceiveMessage(B=>j.onData.fire(C.$Ne.wrap(B)))),z.add(F.onDidEnd(()=>j.onEnd.fire())),z.add(F.onDidClose(B=>j.onClose.fire({type:u.SocketCloseEventType.NodeSocketCloseEvent,error:B,hadError:!!B})));const W=new b(F,M,j);return W.B(z),(0,w.$Exb)(W,N,L,M,j)}constructor(F,N,L){super(N,L),this.n=F}write(F){this.n.send(F.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[359],Ie([1,0,88,328,342,341,354,357,358,101,54,102,100,48,76,97,327,287,11,343,64,248,112,117,148]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Rs)(I.$sqc,T.$esc,r.InstantiationType.Eager),(0,r.$Rs)(f.$bk,$.$osc,r.InstantiationType.Delayed),(0,r.$Rs)(f.$ak,new o.$Ci(t.$Erc,[!1],!0)),(0,r.$Rs)(n.$Zl,d.$Uhc,r.InstantiationType.Delayed),(0,r.$Rs)(a.$Upc,m.$nsc,r.InstantiationType.Eager),(0,r.$Rs)(c.$Cqc,R.$Rrc,r.InstantiationType.Eager),(0,r.$Rs)(S.$Yqc,O.$_rc,r.InstantiationType.Eager),(0,r.$Rs)(u.$prc,C.$Jrc,r.InstantiationType.Eager),(0,r.$Rs)(P.$dqc,h.$Irc,r.InstantiationType.Eager),(0,r.$Rs)(w.$jGb,p.$msc,r.InstantiationType.Eager),(0,r.$Rs)(s.$vqc,i.$psc,r.InstantiationType.Eager)});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[369],Ie([1,0,370,67,7,21,13,61,108,33,68,130,113,231,340,254,269,93,345,359]),function($e,e,r,h,C,R,O,T,p,c,I,S,u,P,w,a,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=Ut(r),h=qe(h),T=qe(T),P=Ut(P),function(){for(let D=0;D<process.execArgv.length;D++)process.execArgv[D]==="--inspect-port=0"&&(process.execArgv.splice(D,1),D--)}();const f=(0,r.default)(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const E=globalThis._VSCODE_NODE_MODULES.module,D=E._load;E._load=function(y){if(y==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return D.apply(this,arguments)}})();const i=process.exit.bind(process),s=process.on.bind(process);function t(E){process.exit=function(D){if(E)i(D);else{const y=new Error("An extension called process.exit() and this was prevented.");console.warn(y.stack)}},process.crash=function(){const D=new Error("An extension called process.crash() and this was prevented.");console.warn(D.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(D,y){D==="uncaughtException"&&(y=function(){try{return y.call(void 0,arguments)}catch{}}),s(D,y)}}let o=function(E){i()};function n(){const E=(0,m.$gn)(process.env);if(E.type===m.ExtHostConnectionType.MessagePort)return new Promise((D,y)=>{const k=A=>{const b=A[0],v=new I.$si;b.on("message",F=>v.fire(R.$Ne.wrap(F.data))),b.on("close",()=>{o("renderer closed the MessagePort")}),b.start(),D({onMessage:v.event,send:F=>b.postMessage(F.buffer)})};process.parentPort.on("message",A=>k(A.ports))});if(E.type===m.ExtHostConnectionType.Socket)return new Promise((D,y)=>{let k=null;const A=setTimeout(()=>{o("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),b=I.ProtocolConstants.ReconnectionGraceTime,v=I.ProtocolConstants.ReconnectionShortGraceTime,F=new C.$Sh(()=>o("renderer disconnected for too long (1)"),b),N=new C.$Sh(()=>o("renderer disconnected for too long (2)"),v);process.on("message",(M,z)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){z.setNoDelay(!0);const j=R.$Ne.wrap(Buffer.from(M.initialDataChunk,"base64"));let W;if(M.skipWebSocketFrames)W=new S.$ui(z,"extHost-socket");else{const B=R.$Ne.wrap(Buffer.from(M.inflateBytes,"base64"));W=new S.$vi(new S.$ui(z,"extHost-socket"),M.permessageDeflate,B,!1)}k?(F.cancel(),N.cancel(),k.beginAcceptReconnection(W,j),k.endAcceptReconnection(),k.sendResume()):(clearTimeout(A),k=new I.$ti({socket:W,initialChunk:j}),k.sendResume(),k.onDidDispose(()=>o("renderer disconnected")),D(k),k.onSocketClose(()=>{F.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;F.isScheduled()&&N.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(L)});{const D=E.pipeName;return new Promise((y,k)=>{const A=h.createConnection(D,()=>{A.removeListener("error",k);const b=new I.$ti({socket:new S.$ui(A,"extHost-renderer")});b.sendResume(),y(b)});A.once("error",k),A.on("close",()=>{o("renderer closed the socket")})})}}async function d(){const E=await n();return new class{constructor(){this.a=new I.$si,this.onMessage=this.a.event,this.b=!1,this.d=E.onMessage(D=>{(0,$.$Cn)(D,$.MessageType.Terminate)?(this.b=!0,this.d.dispose(),o("received terminate message from renderer")):this.a.fire(D)})}send(D){this.b||E.send(D)}async drain(){if(E.drain)return E.drain()}}}function l(E){return new Promise(D=>{const y=E.onMessage(k=>{y.dispose();const A=JSON.parse(k.toString()),b=A.commit,v=P.default.commit;if(b&&v&&b!==v&&i($.ExtensionHostExitCode.VersionMismatch),A.parentPid){let F=0;setInterval(function(){try{process.kill(A.parentPid,0),F=0}catch(L){L&&L.code==="EPERM"?(F++,F>=3&&o(`parent process ${A.parentPid} does not exist anymore (3 x EPERM): ${L.message} (code: ${L.code}) (errno: ${L.errno})`)):o(`parent process ${A.parentPid} does not exist anymore: ${L.message} (code: ${L.code}) (errno: ${L.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start(A.parentPid)}catch(L){(0,O.$Y)(L)}}E.send((0,$.$Bn)($.MessageType.Initialized)),D({protocol:E,initData:A})});E.send((0,$.$Bn)($.MessageType.Ready))})}async function g(){const E=[];process.on("unhandledRejection",(F,N)=>{E.push(N),setTimeout(()=>{const L=E.indexOf(N);L>=0&&N.catch(M=>{E.splice(L,1),(0,O.$3)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),F&&(0,O.$Y)(F))})},1e3)}),process.on("rejectionHandled",F=>{const N=E.indexOf(F);N>=0&&E.splice(N,1)}),process.on("uncaughtException",function(F){(0,O.$X)(F)||(0,O.$Y)(F)}),T.mark("code/extHost/willConnectToRenderer");const D=await d();T.mark("code/extHost/didConnectToRenderer");const y=await l(D);T.mark("code/extHost/didWaitForInitData");const{initData:k}=y;t(!!k.environment.extensionTestsLocationURI),k.environment.useHostProxy=f.useHostProxy!==void 0?f.useHostProxy!=="false":void 0,k.environment.skipWorkspaceStorageLock=(0,u.boolean)(f.skipWorkspaceStorageLock,!1);const A=new class{constructor(){this.pid=process.pid}exit(N){i(N)}fsExists(N){return c.Promises.exists(N)}fsRealpath(N){return(0,p.$nr)(N)}};let b=null;k.remote.authority&&f.transformURIs&&(b=(0,a.$Vs)(k.remote.authority));const v=new w.$Hrc(y.protocol,k,A,b);o=F=>v.terminate(F)}g().catch(E=>console.log(E))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/1d82f317af9c90b96a433fd6a599e4b1d31869a3/core/vs/workbench/api/node/extensionHostProcess.js.map
