/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ne=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/marshallingIds","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/glob","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/extpath","vs/editor/common/model","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/base/common/labels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/comparers","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/base/common/actions","vs/base/common/date","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Le=function(ve){for(var e=[],v=0,R=ve.length;v<R;v++)e[v]=Ne[ve[v]];return e};define(Ne[71],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=R,e.$$h=P,e.$_h=O;function v(A){return(T,p,o)=>{let I=null,y=null;if(typeof o.value=="function"?(I="value",y=o.value):typeof o.get=="function"&&(I="get",y=o.get),!y)throw new Error("not supported");o[I]=A(y,p)}}function R(A,T,p){let o=null,I=null;if(typeof p.value=="function"?(o="value",I=p.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(o="get",I=p.get),!I)throw new Error("not supported");const y=`$memoize$${T}`;p[o]=function(...a){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,a)}),this[y]}}function P(A,T,p){return v((o,I)=>{const y=`$debounce$${I}`,a=`$debounce$result$${I}`;return function(...S){this[a]||(this[a]=p?p():void 0),clearTimeout(this[y]),T&&(this[a]=T(this[a],...S),S=[this[a]]),this[y]=setTimeout(()=>{o.apply(this,S),this[a]=p?p():void 0},A)}})}function O(A,T,p){return v((o,I)=>{const y=`$throttle$timer$${I}`,a=`$throttle$result$${I}`,S=`$throttle$lastRun$${I}`,d=`$throttle$pending$${I}`;return function(...r){if(this[a]||(this[a]=p?p():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),T&&(this[a]=T(this[a],...r)),this[d])return;const s=this[S]+A;s<=Date.now()?(this[S]=Date.now(),o.apply(this,[this[a]]),this[a]=p?p():void 0):(this[d]=!0,this[y]=setTimeout(()=>{this[d]=!1,this[S]=Date.now(),o.apply(this,[this[a]]),this[a]=p?p():void 0},s-Date.now()))}})}});var Hn=this&&this.__createBinding||(Object.create?function(ve,e,v,R){R===void 0&&(R=v);var P=Object.getOwnPropertyDescriptor(e,v);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[v]}}),Object.defineProperty(ve,R,P)}:function(ve,e,v,R){R===void 0&&(R=v),ve[R]=e[v]}),Gn=this&&this.__setModuleDefault||(Object.create?function(ve,e){Object.defineProperty(ve,"default",{enumerable:!0,value:e})}:function(ve,e){ve.default=e}),qe=this&&this.__importStar||function(ve){if(ve&&ve.__esModule)return ve;var e={};if(ve!=null)for(var v in ve)v!=="default"&&Object.prototype.hasOwnProperty.call(ve,v)&&Hn(e,ve,v);return Gn(e,ve),e};define(Ne[135],Le([1,0,17]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=P,e.$8c=O,e.$9c=A,e.$0c=T,e.$$c=p,e.$_c=o,v=qe(v);const R=(S,d)=>S===d;e.$6c=R;function P(S=e.$6c){return(d,r)=>v.$tb(d,r,S)}function O(){return(S,d)=>JSON.stringify(S)===JSON.stringify(d)}function A(){return(S,d)=>S.equals(d)}function T(S,d,r){if(r!==void 0){const s=S;return s==null||d===void 0||d===null?d===s:r(s,d)}else{const s=S;return(c,l)=>c==null||l===void 0||l===null?l===c:s(c,l)}}function p(S,d){if(S===d)return!0;if(Array.isArray(S)&&Array.isArray(d)){if(S.length!==d.length)return!1;for(let r=0;r<S.length;r++)if(!p(S[r],d[r]))return!1;return!0}if(S&&typeof S=="object"&&d&&typeof d=="object"&&Object.getPrototypeOf(S)===Object.prototype&&Object.getPrototypeOf(d)===Object.prototype){const r=S,s=d,c=Object.keys(r),l=Object.keys(s),i=new Set(l);if(c.length!==l.length)return!1;for(const n of c)if(!i.has(n)||!p(r[n],s[n]))return!1;return!0}return!1}function o(S){return JSON.stringify(a(S))}let I=0;const y=new WeakMap;function a(S){if(Array.isArray(S))return S.map(a);if(S&&typeof S=="object")if(Object.getPrototypeOf(S)===Object.prototype){const d=S,r=Object.create(null);for(const s of Object.keys(d).sort())r[s]=a(d[s]);return r}else{let d=y.get(S);return d===void 0&&(d=I++,y.set(S,d)),d+"----2b76a038c20c4bcc"}return S}}),define(Ne[96],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qQ=e.$pQ=void 0;class v{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$pQ=v,e.$qQ=new v("id#")}),define(Ne[136],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Wn=A,e.$Xn=y,e.$Yn=a,e.$Zn=S,e.$1n=d,e.$2n=r,e.$3n=s,e.$4n=c,e.$5n=l,e.$6n=i,e.$7n=n;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v||(e.ScanError=v={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function A(t,g=!1){let u=0;const $=t.length;let m="",h=0,E=R.Unknown,D=v.None;function b(L){let q=0,H=0;for(;q<L;){const W=t.charCodeAt(u);if(W>=I._0&&W<=I._9)H=H*16+W-I._0;else if(W>=I.A&&W<=I.F)H=H*16+W-I.A+10;else if(W>=I.a&&W<=I.f)H=H*16+W-I.a+10;else break;u++,q++}return q<L&&(H=-1),H}function C(L){u=L,m="",h=0,E=R.Unknown,D=v.None}function k(){const L=u;if(t.charCodeAt(u)===I._0)u++;else for(u++;u<t.length&&o(t.charCodeAt(u));)u++;if(u<t.length&&t.charCodeAt(u)===I.dot)if(u++,u<t.length&&o(t.charCodeAt(u)))for(u++;u<t.length&&o(t.charCodeAt(u));)u++;else return D=v.UnexpectedEndOfNumber,t.substring(L,u);let q=u;if(u<t.length&&(t.charCodeAt(u)===I.E||t.charCodeAt(u)===I.e))if(u++,(u<t.length&&t.charCodeAt(u)===I.plus||t.charCodeAt(u)===I.minus)&&u++,u<t.length&&o(t.charCodeAt(u))){for(u++;u<t.length&&o(t.charCodeAt(u));)u++;q=u}else D=v.UnexpectedEndOfNumber;return t.substring(L,q)}function f(){let L="",q=u;for(;;){if(u>=$){L+=t.substring(q,u),D=v.UnexpectedEndOfString;break}const H=t.charCodeAt(u);if(H===I.doubleQuote){L+=t.substring(q,u),u++;break}if(H===I.backslash){if(L+=t.substring(q,u),u++,u>=$){D=v.UnexpectedEndOfString;break}switch(t.charCodeAt(u++)){case I.doubleQuote:L+='"';break;case I.backslash:L+="\\";break;case I.slash:L+="/";break;case I.b:L+="\b";break;case I.f:L+="\f";break;case I.n:L+=`
`;break;case I.r:L+="\r";break;case I.t:L+="	";break;case I.u:{const G=b(4);G>=0?L+=String.fromCharCode(G):D=v.InvalidUnicode;break}default:D=v.InvalidEscapeCharacter}q=u;continue}if(H>=0&&H<=31)if(p(H)){L+=t.substring(q,u),D=v.UnexpectedEndOfString;break}else D=v.InvalidCharacter;u++}return L}function w(){if(m="",D=v.None,h=u,u>=$)return h=$,E=R.EOF;let L=t.charCodeAt(u);if(T(L)){do u++,m+=String.fromCharCode(L),L=t.charCodeAt(u);while(T(L));return E=R.Trivia}if(p(L))return u++,m+=String.fromCharCode(L),L===I.carriageReturn&&t.charCodeAt(u)===I.lineFeed&&(u++,m+=`
`),E=R.LineBreakTrivia;switch(L){case I.openBrace:return u++,E=R.OpenBraceToken;case I.closeBrace:return u++,E=R.CloseBraceToken;case I.openBracket:return u++,E=R.OpenBracketToken;case I.closeBracket:return u++,E=R.CloseBracketToken;case I.colon:return u++,E=R.ColonToken;case I.comma:return u++,E=R.CommaToken;case I.doubleQuote:return u++,m=f(),E=R.StringLiteral;case I.slash:{const q=u-1;if(t.charCodeAt(u+1)===I.slash){for(u+=2;u<$&&!p(t.charCodeAt(u));)u++;return m=t.substring(q,u),E=R.LineCommentTrivia}if(t.charCodeAt(u+1)===I.asterisk){u+=2;const H=$-1;let W=!1;for(;u<H;){if(t.charCodeAt(u)===I.asterisk&&t.charCodeAt(u+1)===I.slash){u+=2,W=!0;break}u++}return W||(u++,D=v.UnexpectedEndOfComment),m=t.substring(q,u),E=R.BlockCommentTrivia}return m+=String.fromCharCode(L),u++,E=R.Unknown}case I.minus:if(m+=String.fromCharCode(L),u++,u===$||!o(t.charCodeAt(u)))return E=R.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return m+=k(),E=R.NumericLiteral;default:for(;u<$&&F(L);)u++,L=t.charCodeAt(u);if(h!==u){switch(m=t.substring(h,u),m){case"true":return E=R.TrueKeyword;case"false":return E=R.FalseKeyword;case"null":return E=R.NullKeyword}return E=R.Unknown}return m+=String.fromCharCode(L),u++,E=R.Unknown}}function F(L){if(T(L)||p(L))return!1;switch(L){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function N(){let L;do L=w();while(L>=R.LineCommentTrivia&&L<=R.Trivia);return L}return{setPosition:C,getPosition:()=>u,scan:g?N:w,getToken:()=>E,getTokenValue:()=>m,getTokenOffset:()=>h,getTokenLength:()=>u-h,getTokenError:()=>D}}function T(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function p(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function o(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function y(t,g){const u=[],$=new Object;let m;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function D(b,C,k,f){h.value=b,h.offset=C,h.length=k,h.type=f,h.colonOffset=void 0,m=h}try{i(t,{onObjectBegin:(b,C)=>{if(g<=b)throw $;m=void 0,E=g>b,u.push("")},onObjectProperty:(b,C,k)=>{if(g<C||(D(b,C,k,"property"),u[u.length-1]=b,g<=C+k))throw $},onObjectEnd:(b,C)=>{if(g<=b)throw $;m=void 0,u.pop()},onArrayBegin:(b,C)=>{if(g<=b)throw $;m=void 0,u.push(0)},onArrayEnd:(b,C)=>{if(g<=b)throw $;m=void 0,u.pop()},onLiteralValue:(b,C,k)=>{if(g<C||(D(b,C,k,n(b)),g<=C+k))throw $},onSeparator:(b,C,k)=>{if(g<=C)throw $;if(b===":"&&m&&m.type==="property")m.colonOffset=C,E=!1,m=void 0;else if(b===","){const f=u[u.length-1];typeof f=="number"?u[u.length-1]=f+1:(E=!0,u[u.length-1]=""),m=void 0}}})}catch(b){if(b!==$)throw b}return{path:u,previousNode:m,isAtPropertyKey:E,matches:b=>{let C=0;for(let k=0;C<b.length&&k<u.length;k++)if(b[C]===u[k]||b[C]==="*")C++;else if(b[C]!=="**")return!1;return C===b.length}}}function a(t,g=[],u=O.DEFAULT){let $=null,m=[];const h=[];function E(b){Array.isArray(m)?m.push(b):$!==null&&(m[$]=b)}return i(t,{onObjectBegin:()=>{const b={};E(b),h.push(m),m=b,$=null},onObjectProperty:b=>{$=b},onObjectEnd:()=>{m=h.pop()},onArrayBegin:()=>{const b=[];E(b),h.push(m),m=b,$=null},onArrayEnd:()=>{m=h.pop()},onLiteralValue:E,onError:(b,C,k)=>{g.push({error:b,offset:C,length:k})}},u),m[0]}function S(t,g=[],u=O.DEFAULT){let $={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(b){$.type==="property"&&($.length=b-$.offset,$=$.parent)}function h(b){return $.children.push(b),b}i(t,{onObjectBegin:b=>{$=h({type:"object",offset:b,length:-1,parent:$,children:[]})},onObjectProperty:(b,C,k)=>{$=h({type:"property",offset:C,length:-1,parent:$,children:[]}),$.children.push({type:"string",value:b,offset:C,length:k,parent:$})},onObjectEnd:(b,C)=>{$.length=b+C-$.offset,$=$.parent,m(b+C)},onArrayBegin:(b,C)=>{$=h({type:"array",offset:b,length:-1,parent:$,children:[]})},onArrayEnd:(b,C)=>{$.length=b+C-$.offset,$=$.parent,m(b+C)},onLiteralValue:(b,C,k)=>{h({type:n(b),offset:C,length:k,parent:$,value:b}),m(C+k)},onSeparator:(b,C,k)=>{$.type==="property"&&(b===":"?$.colonOffset=C:b===","&&m(C))},onError:(b,C,k)=>{g.push({error:b,offset:C,length:k})}},u);const D=$.children[0];return D&&delete D.parent,D}function d(t,g){if(!t)return;let u=t;for(const $ of g)if(typeof $=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let m=!1;for(const h of u.children)if(Array.isArray(h.children)&&h.children[0].value===$){u=h.children[1],m=!0;break}if(!m)return}else{const m=$;if(u.type!=="array"||m<0||!Array.isArray(u.children)||m>=u.children.length)return;u=u.children[m]}return u}function r(t){if(!t.parent||!t.parent.children)return[];const g=r(t.parent);if(t.parent.type==="property"){const u=t.parent.children[0].value;g.push(u)}else if(t.parent.type==="array"){const u=t.parent.children.indexOf(t);u!==-1&&g.push(u)}return g}function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const g=Object.create(null);for(const u of t.children){const $=u.children[1];$&&(g[u.children[0].value]=s($))}return g}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function c(t,g,u=!1){return g>=t.offset&&g<t.offset+t.length||u&&g===t.offset+t.length}function l(t,g,u=!1){if(c(t,g,u)){const $=t.children;if(Array.isArray($))for(let m=0;m<$.length&&$[m].offset<=g;m++){const h=l($[m],g,u);if(h)return h}return t}}function i(t,g,u=O.DEFAULT){const $=A(t,!1);function m(ce){return ce?()=>ce($.getTokenOffset(),$.getTokenLength()):()=>!0}function h(ce){return ce?me=>ce(me,$.getTokenOffset(),$.getTokenLength()):()=>!0}const E=m(g.onObjectBegin),D=h(g.onObjectProperty),b=m(g.onObjectEnd),C=m(g.onArrayBegin),k=m(g.onArrayEnd),f=h(g.onLiteralValue),w=h(g.onSeparator),F=m(g.onComment),N=h(g.onError),L=u&&u.disallowComments,q=u&&u.allowTrailingComma;function H(){for(;;){const ce=$.scan();switch($.getTokenError()){case v.InvalidUnicode:W(P.InvalidUnicode);break;case v.InvalidEscapeCharacter:W(P.InvalidEscapeCharacter);break;case v.UnexpectedEndOfNumber:W(P.UnexpectedEndOfNumber);break;case v.UnexpectedEndOfComment:L||W(P.UnexpectedEndOfComment);break;case v.UnexpectedEndOfString:W(P.UnexpectedEndOfString);break;case v.InvalidCharacter:W(P.InvalidCharacter);break}switch(ce){case R.LineCommentTrivia:case R.BlockCommentTrivia:L?W(P.InvalidCommentToken):F();break;case R.Unknown:W(P.InvalidSymbol);break;case R.Trivia:case R.LineBreakTrivia:break;default:return ce}}}function W(ce,me=[],oe=[]){if(N(ce),me.length+oe.length>0){let ke=$.getToken();for(;ke!==R.EOF;){if(me.indexOf(ke)!==-1){H();break}else if(oe.indexOf(ke)!==-1)break;ke=H()}}}function G(ce){const me=$.getTokenValue();return ce?f(me):D(me),H(),!0}function Q(){switch($.getToken()){case R.NumericLiteral:{let ce=0;try{ce=JSON.parse($.getTokenValue()),typeof ce!="number"&&(W(P.InvalidNumberFormat),ce=0)}catch{W(P.InvalidNumberFormat)}f(ce);break}case R.NullKeyword:f(null);break;case R.TrueKeyword:f(!0);break;case R.FalseKeyword:f(!1);break;default:return!1}return H(),!0}function ae(){return $.getToken()!==R.StringLiteral?(W(P.PropertyNameExpected,[],[R.CloseBraceToken,R.CommaToken]),!1):(G(!1),$.getToken()===R.ColonToken?(w(":"),H(),_()||W(P.ValueExpected,[],[R.CloseBraceToken,R.CommaToken])):W(P.ColonExpected,[],[R.CloseBraceToken,R.CommaToken]),!0)}function be(){E(),H();let ce=!1;for(;$.getToken()!==R.CloseBraceToken&&$.getToken()!==R.EOF;){if($.getToken()===R.CommaToken){if(ce||W(P.ValueExpected,[],[]),w(","),H(),$.getToken()===R.CloseBraceToken&&q)break}else ce&&W(P.CommaExpected,[],[]);ae()||W(P.ValueExpected,[],[R.CloseBraceToken,R.CommaToken]),ce=!0}return b(),$.getToken()!==R.CloseBraceToken?W(P.CloseBraceExpected,[R.CloseBraceToken],[]):H(),!0}function le(){C(),H();let ce=!1;for(;$.getToken()!==R.CloseBracketToken&&$.getToken()!==R.EOF;){if($.getToken()===R.CommaToken){if(ce||W(P.ValueExpected,[],[]),w(","),H(),$.getToken()===R.CloseBracketToken&&q)break}else ce&&W(P.CommaExpected,[],[]);_()||W(P.ValueExpected,[],[R.CloseBracketToken,R.CommaToken]),ce=!0}return k(),$.getToken()!==R.CloseBracketToken?W(P.CloseBracketExpected,[R.CloseBracketToken],[]):H(),!0}function _(){switch($.getToken()){case R.OpenBracketToken:return le();case R.OpenBraceToken:return be();case R.StringLiteral:return G(!0);default:return Q()}}return H(),$.getToken()===R.EOF?u.allowEmptyContent?!0:(W(P.ValueExpected,[],[]),!1):_()?($.getToken()!==R.EOF&&W(P.EndOfFileExpected,[],[]),!0):(W(P.ValueExpected,[],[]),!1)}function n(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Ne[137],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=v;function v(O){let A=!1;const T=new Map,p=new Map;if(P(O,r=>{if(O===r)return!0;const s=JSON.stringify(r);if(s.length<30)return!0;const c=T.get(s);if(!c){const l={schemas:[r]};return T.set(s,l),p.set(r,l),!0}return c.schemas.push(r),p.set(r,c),A=!0,!1}),T.clear(),!A)return JSON.stringify(O);let I="$defs";for(;O.hasOwnProperty(I);)I+="_";const y=[];function a(r){return JSON.stringify(r,(s,c)=>{if(c!==r){const l=p.get(c);if(l&&l.schemas.length>1)return l.id||(l.id=`_${y.length}`,y.push(l.schemas[0])),{$ref:`#/${I}/${l.id}`}}return c})}const S=a(O),d=[];for(let r=0;r<y.length;r++)d.push(`"_${r}":${a(y[r])}`);return d.length?`${S.substring(0,S.length-1)},"${I}":{${d.join(",")}}}`:S}function R(O){return typeof O=="object"&&O!==null}function P(O,A){if(!O||typeof O!="object")return;const T=(...S)=>{for(const d of S)R(d)&&y.push(d)},p=(...S)=>{for(const d of S)if(R(d))for(const r in d){const s=d[r];R(s)&&y.push(s)}},o=(...S)=>{for(const d of S)if(Array.isArray(d))for(const r of d)R(r)&&y.push(r)},I=S=>{if(Array.isArray(S))for(const d of S)R(d)&&y.push(d);else R(S)&&y.push(S)},y=[O];let a=y.pop();for(;a;)A(a)&&(T(a.additionalItems,a.additionalProperties,a.not,a.contains,a.propertyNames,a.if,a.then,a.else,a.unevaluatedItems,a.unevaluatedProperties),p(a.definitions,a.$defs,a.properties,a.patternProperties,a.dependencies,a.dependentSchemas),o(a.anyOf,a.allOf,a.oneOf,a.prefixItems),I(a.items)),a=y.pop()}}),function(ve,e){typeof define=="function"&&define.amd?define(Ne[138],Le([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ve=typeof globalThis<"u"?globalThis:ve||self,e(ve.marked={}))}(this,function(ve){"use strict";function e(fe,we){for(var he=0;he<we.length;he++){var X=we[he];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(fe,X.key,X)}}function v(fe,we,he){return we&&e(fe.prototype,we),he&&e(fe,he),Object.defineProperty(fe,"prototype",{writable:!1}),fe}function R(fe,we){if(fe){if(typeof fe=="string")return P(fe,we);var he=Object.prototype.toString.call(fe).slice(8,-1);if(he==="Object"&&fe.constructor&&(he=fe.constructor.name),he==="Map"||he==="Set")return Array.from(fe);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return P(fe,we)}}function P(fe,we){(we==null||we>fe.length)&&(we=fe.length);for(var he=0,X=new Array(we);he<we;he++)X[he]=fe[he];return X}function O(fe,we){var he=typeof Symbol<"u"&&fe[Symbol.iterator]||fe["@@iterator"];if(he)return(he=he.call(fe)).next.bind(he);if(Array.isArray(fe)||(he=R(fe))||we&&fe&&typeof fe.length=="number"){he&&(fe=he);var X=0;return function(){return X>=fe.length?{done:!0}:{done:!1,value:fe[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ve.defaults=A();function T(fe){ve.defaults=fe}var p=/[&<>"']/,o=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(we){return a[we]};function d(fe,we){if(we){if(p.test(fe))return fe.replace(o,S)}else if(I.test(fe))return fe.replace(y,S);return fe}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(fe){return fe.replace(r,function(we,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var c=/(^|[^\[])\^/g;function l(fe,we){fe=typeof fe=="string"?fe:fe.source,we=we||"";var he={replace:function(x,$e){return $e=$e.source||$e,$e=$e.replace(c,"$1"),fe=fe.replace(x,$e),he},getRegex:function(){return new RegExp(fe,we)}};return he}var i=/[^\w:]/g,n=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(fe,we,he){if(fe){var X;try{X=decodeURIComponent(s(he)).replace(i,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}we&&!n.test(he)&&(he=h(we,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch{return null}return he}var g={},u=/^[^:]+:\/*[^/]*$/,$=/^([^:]+:)[\s\S]*$/,m=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(fe,we){g[" "+fe]||(u.test(fe)?g[" "+fe]=fe+"/":g[" "+fe]=C(fe,"/",!0)),fe=g[" "+fe];var he=fe.indexOf(":")===-1;return we.substring(0,2)==="//"?he?we:fe.replace($,"$1")+we:we.charAt(0)==="/"?he?we:fe.replace(m,"$1")+we:fe+we}var E={exec:function(){}};function D(fe){for(var we=1,he,X;we<arguments.length;we++){he=arguments[we];for(X in he)Object.prototype.hasOwnProperty.call(he,X)&&(fe[X]=he[X])}return fe}function b(fe,we){var he=fe.replace(/\|/g,function($e,pe,Ae){for(var ze=!1,Ie=pe;--Ie>=0&&Ae[Ie]==="\\";)ze=!ze;return ze?"|":" |"}),X=he.split(/ \|/),x=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>we)X.splice(we);else for(;X.length<we;)X.push("");for(;x<X.length;x++)X[x]=X[x].trim().replace(/\\\|/g,"|");return X}function C(fe,we,he){var X=fe.length;if(X===0)return"";for(var x=0;x<X;){var $e=fe.charAt(X-x-1);if($e===we&&!he)x++;else if($e!==we&&he)x++;else break}return fe.slice(0,X-x)}function k(fe,we){if(fe.indexOf(we[1])===-1)return-1;for(var he=fe.length,X=0,x=0;x<he;x++)if(fe[x]==="\\")x++;else if(fe[x]===we[0])X++;else if(fe[x]===we[1]&&(X--,X<0))return x;return-1}function f(fe){fe&&fe.sanitize&&!fe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function w(fe,we){if(we<1)return"";for(var he="";we>1;)we&1&&(he+=fe),we>>=1,fe+=fe;return he+fe}function F(fe,we,he,X){var x=we.href,$e=we.title?d(we.title):null,pe=fe[1].replace(/\\([\[\]])/g,"$1");if(fe[0].charAt(0)!=="!"){X.state.inLink=!0;var Ae={type:"link",raw:he,href:x,title:$e,text:pe,tokens:X.inlineTokens(pe)};return X.state.inLink=!1,Ae}return{type:"image",raw:he,href:x,title:$e,text:d(pe)}}function N(fe,we){var he=fe.match(/^(\s+)(?:```)/);if(he===null)return we;var X=he[1];return we.split(`
`).map(function(x){var $e=x.match(/^\s+/);if($e===null)return x;var pe=$e[0];return pe.length>=X.length?x.slice(X.length):x}).join(`
`)}var L=function(){function fe(he){this.options=he||ve.defaults}var we=fe.prototype;return we.space=function(X){var x=this.rules.block.newline.exec(X);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},we.code=function(X){var x=this.rules.block.code.exec(X);if(x){var $e=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?$e:C($e,`
`)}}},we.fences=function(X){var x=this.rules.block.fences.exec(X);if(x){var $e=x[0],pe=N($e,x[3]||"");return{type:"code",raw:$e,lang:x[2]?x[2].trim():x[2],text:pe}}},we.heading=function(X){var x=this.rules.block.heading.exec(X);if(x){var $e=x[2].trim();if(/#$/.test($e)){var pe=C($e,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&($e=pe.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:$e,tokens:this.lexer.inline($e)}}},we.hr=function(X){var x=this.rules.block.hr.exec(X);if(x)return{type:"hr",raw:x[0]}},we.blockquote=function(X){var x=this.rules.block.blockquote.exec(X);if(x){var $e=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens($e,[]),text:$e}}},we.list=function(X){var x=this.rules.block.list.exec(X);if(x){var $e,pe,Ae,ze,Ie,Pe,Oe,U,j,K,V,re,ge=x[1].trim(),Ce=ge.length>1,Ue={type:"list",raw:"",ordered:Ce,start:Ce?+ge.slice(0,-1):"",loose:!1,items:[]};ge=Ce?"\\d{1,9}\\"+ge.slice(-1):"\\"+ge,this.options.pedantic&&(ge=Ce?ge:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(re=!1,!(!(x=Qe.exec(X))||this.rules.block.hr.test(X)));){if($e=x[0],X=X.substring($e.length),U=x[2].split(`
`,1)[0],j=X.split(`
`,1)[0],this.options.pedantic?(ze=2,V=U.trimLeft()):(ze=x[2].search(/[^ ]/),ze=ze>4?1:ze,V=U.slice(ze),ze+=x[1].length),Pe=!1,!U&&/^ *$/.test(j)&&($e+=j+`
`,X=X.substring(j.length+1),re=!0),!re)for(var _e=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,ze-1)+"}#");X&&(K=X.split(`
`,1)[0],U=K,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(U)||et.test(U)||_e.test(U)||tt.test(X)));){if(U.search(/[^ ]/)>=ze||!U.trim())V+=`
`+U.slice(ze);else if(!Pe)V+=`
`+U;else break;!Pe&&!U.trim()&&(Pe=!0),$e+=K+`
`,X=X.substring(K.length+1)}Ue.loose||(Oe?Ue.loose=!0:/\n *\n *$/.test($e)&&(Oe=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(V),pe&&(Ae=pe[0]!=="[ ] ",V=V.replace(/^\[[ xX]\] +/,""))),Ue.items.push({type:"list_item",raw:$e,task:!!pe,checked:Ae,loose:!1,text:V}),Ue.raw+=$e}Ue.items[Ue.items.length-1].raw=$e.trimRight(),Ue.items[Ue.items.length-1].text=V.trimRight(),Ue.raw=Ue.raw.trimRight();var rt=Ue.items.length;for(Ie=0;Ie<rt;Ie++){this.lexer.state.top=!1,Ue.items[Ie].tokens=this.lexer.blockTokens(Ue.items[Ie].text,[]);var ft=Ue.items[Ie].tokens.filter(function(st){return st.type==="space"}),lt=ft.every(function(st){for(var ct=st.raw.split(""),mt=0,$t=O(ct),We;!(We=$t()).done;){var je=We.value;if(je===`
`&&(mt+=1),mt>1)return!0}return!1});!Ue.loose&&ft.length&&lt&&(Ue.loose=!0,Ue.items[Ie].loose=!0)}return Ue}},we.html=function(X){var x=this.rules.block.html.exec(X);if(x){var $e={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]);$e.type="paragraph",$e.text=pe,$e.tokens=this.lexer.inline(pe)}return $e}},we.def=function(X){var x=this.rules.block.def.exec(X);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var $e=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$e,raw:x[0],href:x[2],title:x[3]}}},we.table=function(X){var x=this.rules.block.table.exec(X);if(x){var $e={type:"table",header:b(x[1]).map(function(Oe){return{text:Oe}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($e.header.length===$e.align.length){$e.raw=x[0];var pe=$e.align.length,Ae,ze,Ie,Pe;for(Ae=0;Ae<pe;Ae++)/^ *-+: *$/.test($e.align[Ae])?$e.align[Ae]="right":/^ *:-+: *$/.test($e.align[Ae])?$e.align[Ae]="center":/^ *:-+ *$/.test($e.align[Ae])?$e.align[Ae]="left":$e.align[Ae]=null;for(pe=$e.rows.length,Ae=0;Ae<pe;Ae++)$e.rows[Ae]=b($e.rows[Ae],$e.header.length).map(function(Oe){return{text:Oe}});for(pe=$e.header.length,ze=0;ze<pe;ze++)$e.header[ze].tokens=this.lexer.inline($e.header[ze].text);for(pe=$e.rows.length,ze=0;ze<pe;ze++)for(Pe=$e.rows[ze],Ie=0;Ie<Pe.length;Ie++)Pe[Ie].tokens=this.lexer.inline(Pe[Ie].text);return $e}}},we.lheading=function(X){var x=this.rules.block.lheading.exec(X);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},we.paragraph=function(X){var x=this.rules.block.paragraph.exec(X);if(x){var $e=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:$e,tokens:this.lexer.inline($e)}}},we.text=function(X){var x=this.rules.block.text.exec(X);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},we.escape=function(X){var x=this.rules.inline.escape.exec(X);if(x)return{type:"escape",raw:x[0],text:d(x[1])}},we.tag=function(X){var x=this.rules.inline.tag.exec(X);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]):x[0]}},we.link=function(X){var x=this.rules.inline.link.exec(X);if(x){var $e=x[2].trim();if(!this.options.pedantic&&/^</.test($e)){if(!/>$/.test($e))return;var pe=C($e.slice(0,-1),"\\");if(($e.length-pe.length)%2===0)return}else{var Ae=k(x[2],"()");if(Ae>-1){var ze=x[0].indexOf("!")===0?5:4,Ie=ze+x[1].length+Ae;x[2]=x[2].substring(0,Ae),x[0]=x[0].substring(0,Ie).trim(),x[3]=""}}var Pe=x[2],Oe="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);U&&(Pe=U[1],Oe=U[3])}else Oe=x[3]?x[3].slice(1,-1):"";return Pe=Pe.trim(),/^</.test(Pe)&&(this.options.pedantic&&!/>$/.test($e)?Pe=Pe.slice(1):Pe=Pe.slice(1,-1)),F(x,{href:Pe&&Pe.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},we.reflink=function(X,x){var $e;if(($e=this.rules.inline.reflink.exec(X))||($e=this.rules.inline.nolink.exec(X))){var pe=($e[2]||$e[1]).replace(/\s+/g," ");if(pe=x[pe.toLowerCase()],!pe||!pe.href){var Ae=$e[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return F($e,pe,$e[0],this.lexer)}},we.emStrong=function(X,x,$e){$e===void 0&&($e="");var pe=this.rules.inline.emStrong.lDelim.exec(X);if(pe&&!(pe[3]&&$e.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=pe[1]||pe[2]||"";if(!Ae||Ae&&($e===""||this.rules.inline.punctuation.exec($e))){var ze=pe[0].length-1,Ie,Pe,Oe=ze,U=0,j=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(j.lastIndex=0,x=x.slice(-1*X.length+ze);(pe=j.exec(x))!=null;)if(Ie=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!Ie){if(Pe=Ie.length,pe[3]||pe[4]){Oe+=Pe;continue}else if((pe[5]||pe[6])&&ze%3&&!((ze+Pe)%3)){U+=Pe;continue}if(Oe-=Pe,!(Oe>0)){if(Pe=Math.min(Pe,Pe+Oe+U),Math.min(ze,Pe)%2){var K=X.slice(1,ze+pe.index+Pe);return{type:"em",raw:X.slice(0,ze+pe.index+Pe+1),text:K,tokens:this.lexer.inlineTokens(K)}}var V=X.slice(2,ze+pe.index+Pe-1);return{type:"strong",raw:X.slice(0,ze+pe.index+Pe+1),text:V,tokens:this.lexer.inlineTokens(V)}}}}}},we.codespan=function(X){var x=this.rules.inline.code.exec(X);if(x){var $e=x[2].replace(/\n/g," "),pe=/[^ ]/.test($e),Ae=/^ /.test($e)&&/ $/.test($e);return pe&&Ae&&($e=$e.substring(1,$e.length-1)),$e=d($e,!0),{type:"codespan",raw:x[0],text:$e}}},we.br=function(X){var x=this.rules.inline.br.exec(X);if(x)return{type:"br",raw:x[0]}},we.del=function(X){var x=this.rules.inline.del.exec(X);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},we.autolink=function(X,x){var $e=this.rules.inline.autolink.exec(X);if($e){var pe,Ae;return $e[2]==="@"?(pe=d(this.options.mangle?x($e[1]):$e[1]),Ae="mailto:"+pe):(pe=d($e[1]),Ae=pe),{type:"link",raw:$e[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},we.url=function(X,x){var $e;if($e=this.rules.inline.url.exec(X)){var pe,Ae;if($e[2]==="@")pe=d(this.options.mangle?x($e[0]):$e[0]),Ae="mailto:"+pe;else{var ze;do ze=$e[0],$e[0]=this.rules.inline._backpedal.exec($e[0])[0];while(ze!==$e[0]);pe=d($e[0]),$e[1]==="www."?Ae="http://"+pe:Ae=pe}return{type:"link",raw:$e[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},we.inlineText=function(X,x){var $e=this.rules.inline.text.exec(X);if($e){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($e[0]):d($e[0]):$e[0]:pe=d(this.options.smartypants?x($e[0]):$e[0]),{type:"text",raw:$e[0],text:pe}}},fe}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=l(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=l(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=l(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=l(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=l(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=l(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=D({},q),q.gfm=D({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=l(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=l(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=D({},q.normal,{html:l(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:l(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var H={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};H._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",H.punctuation=l(H.punctuation).replace(/punctuation/g,H._punctuation).getRegex(),H.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,H.escapedEmSt=/\\\*|\\_/g,H._comment=l(q._comment).replace("(?:-->|$)","-->").getRegex(),H.emStrong.lDelim=l(H.emStrong.lDelim).replace(/punct/g,H._punctuation).getRegex(),H.emStrong.rDelimAst=l(H.emStrong.rDelimAst,"g").replace(/punct/g,H._punctuation).getRegex(),H.emStrong.rDelimUnd=l(H.emStrong.rDelimUnd,"g").replace(/punct/g,H._punctuation).getRegex(),H._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,H._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,H._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,H.autolink=l(H.autolink).replace("scheme",H._scheme).replace("email",H._email).getRegex(),H._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,H.tag=l(H.tag).replace("comment",H._comment).replace("attribute",H._attribute).getRegex(),H._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,H._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,H._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,H.link=l(H.link).replace("label",H._label).replace("href",H._href).replace("title",H._title).getRegex(),H.reflink=l(H.reflink).replace("label",H._label).replace("ref",q._label).getRegex(),H.nolink=l(H.nolink).replace("ref",q._label).getRegex(),H.reflinkSearch=l(H.reflinkSearch,"g").replace("reflink",H.reflink).replace("nolink",H.nolink).getRegex(),H.normal=D({},H),H.pedantic=D({},H.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:l(/^!?\[(label)\]\((.*?)\)/).replace("label",H._label).getRegex(),reflink:l(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",H._label).getRegex()}),H.gfm=D({},H.normal,{escape:l(H.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),H.gfm.url=l(H.gfm.url,"i").replace("email",H.gfm._extended_email).getRegex(),H.breaks=D({},H.gfm,{br:l(H.br).replace("{2,}","*").getRegex(),text:l(H.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function W(fe){return fe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(fe){var we="",he,X,x=fe.length;for(he=0;he<x;he++)X=fe.charCodeAt(he),Math.random()>.5&&(X="x"+X.toString(16)),we+="&#"+X+";";return we}var Q=function(){function fe(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||ve.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:q.normal,inline:H.normal};this.options.pedantic?(X.block=q.pedantic,X.inline=H.pedantic):this.options.gfm&&(X.block=q.gfm,this.options.breaks?X.inline=H.breaks:X.inline=H.gfm),this.tokenizer.rules=X}fe.lex=function(X,x){var $e=new fe(x);return $e.lex(X)},fe.lexInline=function(X,x){var $e=new fe(x);return $e.inlineTokens(X)};var we=fe.prototype;return we.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},we.blockTokens=function(X,x){var $e=this;x===void 0&&(x=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(Oe,U,j){return U+"    ".repeat(j.length)});for(var pe,Ae,ze,Ie;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Oe){return(pe=Oe.call({lexer:$e},X,x))?(X=X.substring(pe.raw.length),x.push(pe),!0):!1}))){if(pe=this.tokenizer.space(X)){X=X.substring(pe.raw.length),pe.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(pe);continue}if(pe=this.tokenizer.code(X)){X=X.substring(pe.raw.length),Ae=x[x.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(pe);continue}if(pe=this.tokenizer.fences(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.heading(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.hr(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.blockquote(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.list(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.html(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.def(X)){X=X.substring(pe.raw.length),Ae=x[x.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.lheading(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(ze=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Oe=1/0,U=X.slice(1),j=void 0;$e.options.extensions.startBlock.forEach(function(K){j=K.call({lexer:this},U),typeof j=="number"&&j>=0&&(Oe=Math.min(Oe,j))}),Oe<1/0&&Oe>=0&&(ze=X.substring(0,Oe+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(ze))){Ae=x[x.length-1],Ie&&Ae.type==="paragraph"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(pe),Ie=ze.length!==X.length,X=X.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(X)){X=X.substring(pe.raw.length),Ae=x[x.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(pe);continue}if(X){var Pe="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return this.state.top=!0,x},we.inline=function(X,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:X,tokens:x}),x},we.inlineTokens=function(X,x){var $e=this;x===void 0&&(x=[]);var pe,Ae,ze,Ie=X,Pe,Oe,U;if(this.tokens.links){var j=Object.keys(this.tokens.links);if(j.length>0)for(;(Pe=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)j.includes(Pe[0].slice(Pe[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Pe.index)+"["+w("a",Pe[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Pe=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Pe.index)+"["+w("a",Pe[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Pe=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Pe.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Oe||(U=""),Oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(V){return(pe=V.call({lexer:$e},X,x))?(X=X.substring(pe.raw.length),x.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.tag(X)){X=X.substring(pe.raw.length),Ae=x[x.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):x.push(pe);continue}if(pe=this.tokenizer.link(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(pe.raw.length),Ae=x[x.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):x.push(pe);continue}if(pe=this.tokenizer.emStrong(X,Ie,U)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.codespan(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.br(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.del(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.autolink(X,G)){X=X.substring(pe.raw.length),x.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(X,G))){X=X.substring(pe.raw.length),x.push(pe);continue}if(ze=X,this.options.extensions&&this.options.extensions.startInline&&function(){var V=1/0,re=X.slice(1),ge=void 0;$e.options.extensions.startInline.forEach(function(Ce){ge=Ce.call({lexer:this},re),typeof ge=="number"&&ge>=0&&(V=Math.min(V,ge))}),V<1/0&&V>=0&&(ze=X.substring(0,V+1))}(),pe=this.tokenizer.inlineText(ze,W)){X=X.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(U=pe.raw.slice(-1)),Oe=!0,Ae=x[x.length-1],Ae&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):x.push(pe);continue}if(X){var K="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return x},v(fe,null,[{key:"rules",get:function(){return{block:q,inline:H}}}]),fe}(),ae=function(){function fe(he){this.options=he||ve.defaults}var we=fe.prototype;return we.code=function(X,x,$e){var pe=(x||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(X,pe);Ae!=null&&Ae!==X&&($e=!0,X=Ae)}return X=X.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+d(pe,!0)+'">'+($e?X:d(X,!0))+`</code></pre>
`:"<pre><code>"+($e?X:d(X,!0))+`</code></pre>
`},we.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},we.html=function(X){return X},we.heading=function(X,x,$e,pe){if(this.options.headerIds){var Ae=this.options.headerPrefix+pe.slug($e);return"<h"+x+' id="'+Ae+'">'+X+"</h"+x+`>
`}return"<h"+x+">"+X+"</h"+x+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(X,x,$e){var pe=x?"ol":"ul",Ae=x&&$e!==1?' start="'+$e+'"':"";return"<"+pe+Ae+`>
`+X+"</"+pe+`>
`},we.listitem=function(X){return"<li>"+X+`</li>
`},we.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(X){return"<p>"+X+`</p>
`},we.table=function(X,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+x+`</table>
`},we.tablerow=function(X){return`<tr>
`+X+`</tr>
`},we.tablecell=function(X,x){var $e=x.header?"th":"td",pe=x.align?"<"+$e+' align="'+x.align+'">':"<"+$e+">";return pe+X+("</"+$e+`>
`)},we.strong=function(X){return"<strong>"+X+"</strong>"},we.em=function(X){return"<em>"+X+"</em>"},we.codespan=function(X){return"<code>"+X+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(X){return"<del>"+X+"</del>"},we.link=function(X,x,$e){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return $e;var pe='<a href="'+d(X)+'"';return x&&(pe+=' title="'+x+'"'),pe+=">"+$e+"</a>",pe},we.image=function(X,x,$e){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return $e;var pe='<img src="'+X+'" alt="'+$e+'"';return x&&(pe+=' title="'+x+'"'),pe+=this.options.xhtml?"/>":">",pe},we.text=function(X){return X},fe}(),be=function(){function fe(){}var we=fe.prototype;return we.strong=function(X){return X},we.em=function(X){return X},we.codespan=function(X){return X},we.del=function(X){return X},we.html=function(X){return X},we.text=function(X){return X},we.link=function(X,x,$e){return""+$e},we.image=function(X,x,$e){return""+$e},we.br=function(){return""},fe}(),le=function(){function fe(){this.seen={}}var we=fe.prototype;return we.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(X,x){var $e=X,pe=0;if(this.seen.hasOwnProperty($e)){pe=this.seen[X];do pe++,$e=X+"-"+pe;while(this.seen.hasOwnProperty($e))}return x||(this.seen[X]=pe,this.seen[$e]=0),$e},we.slug=function(X,x){x===void 0&&(x={});var $e=this.serialize(X);return this.getNextSafeSlug($e,x.dryrun)},fe}(),_=function(){function fe(he){this.options=he||ve.defaults,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new be,this.slugger=new le}fe.parse=function(X,x){var $e=new fe(x);return $e.parse(X)},fe.parseInline=function(X,x){var $e=new fe(x);return $e.parseInline(X)};var we=fe.prototype;return we.parse=function(X,x){x===void 0&&(x=!0);var $e="",pe,Ae,ze,Ie,Pe,Oe,U,j,K,V,re,ge,Ce,Ue,Qe,_e,tt,nt,et,rt=X.length;for(pe=0;pe<rt;pe++){if(V=X[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[V.type]&&(et=this.options.extensions.renderers[V.type].call({parser:this},V),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(V.type))){$e+=et||"";continue}switch(V.type){case"space":continue;case"hr":{$e+=this.renderer.hr();continue}case"heading":{$e+=this.renderer.heading(this.parseInline(V.tokens),V.depth,s(this.parseInline(V.tokens,this.textRenderer)),this.slugger);continue}case"code":{$e+=this.renderer.code(V.text,V.lang,V.escaped);continue}case"table":{for(j="",U="",Ie=V.header.length,Ae=0;Ae<Ie;Ae++)U+=this.renderer.tablecell(this.parseInline(V.header[Ae].tokens),{header:!0,align:V.align[Ae]});for(j+=this.renderer.tablerow(U),K="",Ie=V.rows.length,Ae=0;Ae<Ie;Ae++){for(Oe=V.rows[Ae],U="",Pe=Oe.length,ze=0;ze<Pe;ze++)U+=this.renderer.tablecell(this.parseInline(Oe[ze].tokens),{header:!1,align:V.align[ze]});K+=this.renderer.tablerow(U)}$e+=this.renderer.table(j,K);continue}case"blockquote":{K=this.parse(V.tokens),$e+=this.renderer.blockquote(K);continue}case"list":{for(re=V.ordered,ge=V.start,Ce=V.loose,Ie=V.items.length,K="",Ae=0;Ae<Ie;Ae++)Qe=V.items[Ae],_e=Qe.checked,tt=Qe.task,Ue="",Qe.task&&(nt=this.renderer.checkbox(_e),Ce?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=nt+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=nt+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:nt}):Ue+=nt),Ue+=this.parse(Qe.tokens,Ce),K+=this.renderer.listitem(Ue,tt,_e);$e+=this.renderer.list(K,re,ge);continue}case"html":{$e+=this.renderer.html(V.text);continue}case"paragraph":{$e+=this.renderer.paragraph(this.parseInline(V.tokens));continue}case"text":{for(K=V.tokens?this.parseInline(V.tokens):V.text;pe+1<rt&&X[pe+1].type==="text";)V=X[++pe],K+=`
`+(V.tokens?this.parseInline(V.tokens):V.text);$e+=x?this.renderer.paragraph(K):K;continue}default:{var ft='Token with "'+V.type+'" type was not found.';if(this.options.silent){console.error(ft);return}else throw new Error(ft)}}}return $e},we.parseInline=function(X,x){x=x||this.renderer;var $e="",pe,Ae,ze,Ie=X.length;for(pe=0;pe<Ie;pe++){if(Ae=X[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(ze=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){$e+=ze||"";continue}switch(Ae.type){case"escape":{$e+=x.text(Ae.text);break}case"html":{$e+=x.html(Ae.text);break}case"link":{$e+=x.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,x));break}case"image":{$e+=x.image(Ae.href,Ae.title,Ae.text);break}case"strong":{$e+=x.strong(this.parseInline(Ae.tokens,x));break}case"em":{$e+=x.em(this.parseInline(Ae.tokens,x));break}case"codespan":{$e+=x.codespan(Ae.text);break}case"br":{$e+=x.br();break}case"del":{$e+=x.del(this.parseInline(Ae.tokens,x));break}case"text":{$e+=x.text(Ae.text);break}default:{var Pe='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return $e},fe}();function ce(fe,we,he){if(typeof fe>"u"||fe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof fe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(fe)+", string expected");if(typeof we=="function"&&(he=we,we=null),we=D({},ce.defaults,we||{}),f(we),he){var X=we.highlight,x;try{x=Q.lex(fe,we)}catch(Ie){return he(Ie)}var $e=function(Pe){var Oe;if(!Pe)try{we.walkTokens&&ce.walkTokens(x,we.walkTokens),Oe=_.parse(x,we)}catch(U){Pe=U}return we.highlight=X,Pe?he(Pe):he(null,Oe)};if(!X||X.length<3||(delete we.highlight,!x.length))return $e();var pe=0;ce.walkTokens(x,function(Ie){Ie.type==="code"&&(pe++,setTimeout(function(){X(Ie.text,Ie.lang,function(Pe,Oe){if(Pe)return $e(Pe);Oe!=null&&Oe!==Ie.text&&(Ie.text=Oe,Ie.escaped=!0),pe--,pe===0&&$e()})},0))}),pe===0&&$e();return}function Ae(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+d(Ie.message+"",!0)+"</pre>";throw Ie}try{var ze=Q.lex(fe,we);if(we.walkTokens){if(we.async)return Promise.all(ce.walkTokens(ze,we.walkTokens)).then(function(){return _.parse(ze,we)}).catch(Ae);ce.walkTokens(ze,we.walkTokens)}return _.parse(ze,we)}catch(Ie){Ae(Ie)}}ce.options=ce.setOptions=function(fe){return D(ce.defaults,fe),T(ce.defaults),ce},ce.getDefaults=A,ce.defaults=ve.defaults,ce.use=function(){for(var fe=arguments.length,we=new Array(fe),he=0;he<fe;he++)we[he]=arguments[he];var X=D.apply(void 0,[{}].concat(we)),x=ce.defaults.extensions||{renderers:{},childTokens:{}},$e;we.forEach(function(pe){if(pe.extensions&&($e=!0,pe.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var Ie=x.renderers?x.renderers[ze.name]:null;Ie?x.renderers[ze.name]=function(){for(var Pe=arguments.length,Oe=new Array(Pe),U=0;U<Pe;U++)Oe[U]=arguments[U];var j=ze.renderer.apply(this,Oe);return j===!1&&(j=Ie.apply(this,Oe)),j}:x.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[ze.level]?x[ze.level].unshift(ze.tokenizer):x[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?x.startBlock?x.startBlock.push(ze.start):x.startBlock=[ze.start]:ze.level==="inline"&&(x.startInline?x.startInline.push(ze.start):x.startInline=[ze.start]))}ze.childTokens&&(x.childTokens[ze.name]=ze.childTokens)})),pe.renderer&&function(){var ze=ce.defaults.renderer||new ae,Ie=function(U){var j=ze[U];ze[U]=function(){for(var K=arguments.length,V=new Array(K),re=0;re<K;re++)V[re]=arguments[re];var ge=pe.renderer[U].apply(ze,V);return ge===!1&&(ge=j.apply(ze,V)),ge}};for(var Pe in pe.renderer)Ie(Pe);X.renderer=ze}(),pe.tokenizer&&function(){var ze=ce.defaults.tokenizer||new L,Ie=function(U){var j=ze[U];ze[U]=function(){for(var K=arguments.length,V=new Array(K),re=0;re<K;re++)V[re]=arguments[re];var ge=pe.tokenizer[U].apply(ze,V);return ge===!1&&(ge=j.apply(ze,V)),ge}};for(var Pe in pe.tokenizer)Ie(Pe);X.tokenizer=ze}(),pe.walkTokens){var Ae=ce.defaults.walkTokens;X.walkTokens=function(ze){var Ie=[];return Ie.push(pe.walkTokens.call(this,ze)),Ae&&(Ie=Ie.concat(Ae.call(this,ze))),Ie}}$e&&(X.extensions=x),ce.setOptions(X)})},ce.walkTokens=function(fe,we){for(var he=[],X=function(){var Ae=$e.value;switch(he=he.concat(we.call(ce,Ae)),Ae.type){case"table":{for(var ze=O(Ae.header),Ie;!(Ie=ze()).done;){var Pe=Ie.value;he=he.concat(ce.walkTokens(Pe.tokens,we))}for(var Oe=O(Ae.rows),U;!(U=Oe()).done;)for(var j=U.value,K=O(j),V;!(V=K()).done;){var re=V.value;he=he.concat(ce.walkTokens(re.tokens,we))}break}case"list":{he=he.concat(ce.walkTokens(Ae.items,we));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Ae.type]?ce.defaults.extensions.childTokens[Ae.type].forEach(function(ge){he=he.concat(ce.walkTokens(Ae[ge],we))}):Ae.tokens&&(he=he.concat(ce.walkTokens(Ae.tokens,we)))}},x=O(fe),$e;!($e=x()).done;)X();return he},ce.parseInline=function(fe,we){if(typeof fe>"u"||fe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof fe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(fe)+", string expected");we=D({},ce.defaults,we||{}),f(we);try{var he=Q.lexInline(fe,we);return we.walkTokens&&ce.walkTokens(he,we.walkTokens),_.parseInline(he,we)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+d(X.message+"",!0)+"</pre>";throw X}},ce.Parser=_,ce.parser=_.parse,ce.Renderer=ae,ce.TextRenderer=be,ce.Lexer=Q,ce.lexer=Q.lex,ce.Tokenizer=L,ce.Slugger=le,ce.parse=ce;var me=ce.options,oe=ce.setOptions,ke=ce.use,Te=ce.walkTokens,Y=ce.parseInline,B=ce,ne=_.parse,Ee=Q.lex;ve.Lexer=Q,ve.Parser=_,ve.Renderer=ae,ve.Slugger=le,ve.TextRenderer=be,ve.Tokenizer=L,ve.getDefaults=A,ve.lexer=Ee,ve.marked=ce,ve.options=me,ve.parse=B,ve.parseInline=Y,ve.parser=ne,ve.setOptions=oe,ve.use=ke,ve.walkTokens=Te,Object.defineProperty(ve,"__esModule",{value:!0})}),define(Ne[139],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=v;function v(r){const s=O(r);if(s&&s.length>0)return new Uint32Array(s)}let R=0;const P=new Uint32Array(10);function O(r){if(R=0,A(r,y,p.InitialConsonant),R>0||(A(r,a,p.Vowel),R>0)||(A(r,S,p.FinalConsonant),R>0)||(A(r,d,p.CompatibilityJamo),R))return P.subarray(0,R);if(r>=44032&&r<=55203){const s=r-44032,c=s%588,l=Math.floor(s/588),i=Math.floor(c/28),n=c%28-1;if(l<y.length?A(l,y,0):p.InitialConsonant+l-p.CompatibilityJamo<d.length&&A(p.InitialConsonant+l,d,p.CompatibilityJamo),i<a.length?A(i,a,0):p.Vowel+i-p.CompatibilityJamo<d.length&&A(p.Vowel+i-p.CompatibilityJamo,d,p.CompatibilityJamo),n>=0&&(n<S.length?A(n,S,0):p.FinalConsonant+n-p.CompatibilityJamo<d.length&&A(p.FinalConsonant+n-p.CompatibilityJamo,d,p.CompatibilityJamo)),R>0)return P.subarray(0,R)}}function A(r,s,c){r>=c&&r<c+s.length&&T(s[r-c])}function T(r){r!==o.NUL&&(P[R++]=r&255,r>>8&&(P[R++]=r>>8&255),r>>16&&(P[R++]=r>>16&255))}var p;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var o;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(o||(o={}));var I;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(I||(I={}));const y=new Uint8Array([o.r,o.R,o.s,o.e,o.E,o.f,o.a,o.q,o.Q,o.t,o.T,o.d,o.w,o.W,o.c,o.z,o.x,o.v,o.g]),a=new Uint16Array([o.k,o.o,o.i,o.O,o.j,o.p,o.u,o.P,o.h,I.hk,I.ho,I.hl,o.y,o.n,I.nj,I.np,I.nl,o.b,o.m,I.ml,o.l]),S=new Uint16Array([o.r,o.R,I.rt,o.s,I.sw,I.sg,o.e,o.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,o.a,o.q,I.qt,o.t,o.T,o.d,o.w,o.c,o.z,o.x,o.v,o.g]),d=new Uint16Array([o.r,o.R,I.rt,o.s,I.sw,I.sg,o.e,o.E,o.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,o.a,o.q,o.Q,I.qt,o.t,o.T,o.d,o.w,o.W,o.c,o.z,o.x,o.v,o.g,o.k,o.o,o.i,o.O,o.j,o.p,o.u,o.P,o.h,I.hk,I.ho,I.hl,o.y,o.n,I.nj,I.np,I.nl,o.b,o.m,I.ml,o.l])}),define(Ne[140],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=void 0,e.$Lm=v,e.rot=R,e.$Qm=T;function v(p,o,I){return Math.min(Math.max(p,o),I)}function R(p,o){return(o+p%o)%o}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Nm=P;class O{constructor(){this.a=1,this.b=0}update(o){return this.b=this.b+(o-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Om=O;class A{constructor(o){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(o),this.c.fill(0,0,o)}update(o){const I=this.c[this.d];return this.c[this.d]=o,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=o,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Pm=A;function T(p,o,I,y,a,S,d,r){const s=d-I,c=r-y,l=a-I,i=S-y,n=p-I,t=o-y,g=s*s+c*c,u=s*l+c*i,$=s*n+c*t,m=l*l+i*i,h=l*n+i*t,E=1/(g*m-u*u),D=(m*$-u*h)*E,b=(g*h-u*$)*E;return D>=0&&b>=0&&D+b<1}}),define(Ne[141],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=O,e.$cd=a;class v{constructor(d,r,s){this.owner=d,this.debugNameSource=r,this.referenceFn=s}getDebugName(d){return O(d,this)}}e.$ad=v;const R=new Map,P=new WeakMap;function O(S,d){const r=P.get(S);if(r)return r;const s=A(S,d);if(s){let c=R.get(s)??0;c++,R.set(s,c);const l=c===1?s:`${s}#${c}`;return P.set(S,l),l}}function A(S,d){const r=P.get(S);if(r)return r;const s=d.owner?I(d.owner)+".":"";let c;const l=d.debugNameSource;if(l!==void 0)if(typeof l=="function"){if(c=l(),c!==void 0)return s+c}else return s+l;const i=d.referenceFn;if(i!==void 0&&(c=a(i),c!==void 0))return s+c;if(d.owner!==void 0){const n=T(d.owner,S);if(n!==void 0)return s+n}}function T(S,d){for(const r in S)if(S[r]===d)return r}const p=new Map,o=new WeakMap;function I(S){const d=o.get(S);if(d)return d;const r=y(S);let s=p.get(r)??0;s++,p.set(r,s);const c=s===1?r:`${r}#${s}`;return o.set(S,c),c}function y(S){const d=S.constructor;return d?d.name:"Object"}function a(S){const d=S.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(d);return(s?s[1]:void 0)?.trim()}}),define(Ne[142],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Md=void 0,e.$Kd=R,e.$Ld=P;let v;function R(r){v=r}function P(){return v}class O{constructor(){this.a=0,this.d=new WeakMap}b(s){return A([T(S("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[T(" "),o(I(s.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),o(I(s.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),o(I(s.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(s,c){console.log(...this.b([p("observable value changed"),o(s.debugName,{color:"BlueViolet"}),...this.c(c)]))}formatChanges(s){if(s.size!==0)return o(" (changed deps: "+[...s].map(c=>c.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const c=s.handleChange;this.d.set(s,new Set),s.handleChange=(l,i)=>(this.d.get(s).add(l),c.apply(s,[l,i]))}handleDerivedRecomputed(s,c){const l=this.d.get(s);console.log(...this.b([p("derived recomputed"),o(s.debugName,{color:"BlueViolet"}),...this.c(c),this.formatChanges(l),{data:[{fn:s._debugNameData.referenceFn??s._computeFn}]}])),l.clear()}handleFromEventObservableTriggered(s,c){console.log(...this.b([p("observable from event triggered"),o(s.debugName,{color:"BlueViolet"}),...this.c(c),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const c=s.handleChange;this.d.set(s,new Set),s.handleChange=(l,i)=>(this.d.get(s).add(l),c.apply(s,[l,i]))}handleAutorunTriggered(s){const c=this.d.get(s);console.log(...this.b([p("autorun"),o(s.debugName,{color:"BlueViolet"}),this.formatChanges(c),{data:[{fn:s._debugNameData.referenceFn??s._runFn}]}])),c.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let c=s.getDebugName();c===void 0&&(c=""),console.log(...this.b([p("transaction"),o(c,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Md=O;function A(r){const s=new Array,c=[];let l="";function i(t){if("length"in t)for(const g of t)g&&i(g);else"text"in t?(l+=`%c${t.text}`,s.push(t.style),t.data&&c.push(...t.data)):"data"in t&&c.push(...t.data)}i(r);const n=[l,...s];return n.push(...c),n}function T(r){return o(r,{color:"black"})}function p(r){return o(d(`${r}: `,10),{color:"black",bold:!0})}function o(r,s={color:"black"}){function c(i){return Object.entries(i).reduce((n,[t,g])=>`${n}${t}:${g};`,"")}const l={color:s.color};return s.strikeThrough&&(l["text-decoration"]="line-through"),s.bold&&(l["font-weight"]="bold"),{text:r,style:c(l)}}function I(r,s){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=s?`"${r}"`:`"${r.substr(0,s-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?y(r,s):a(r,s);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function y(r,s){let c="[ ",l=!0;for(const i of r){if(l||(c+=", "),c.length-5>s){c+="...";break}l=!1,c+=`${I(i,s-c.length)}`}return c+=" ]",c}function a(r,s){let c="{ ",l=!0;for(const[i,n]of Object.entries(r)){if(l||(c+=", "),c.length-5>s){c+="...";break}l=!1,c+=`${i}: ${I(n,s-c.length)}`}return c+=" }",c}function S(r,s){let c="";for(let l=1;l<=s;l++)c+=r;return c}function d(r,s){for(;r.length<s;)r+=" ";return r}}),define(Ne[143],Le([1,0,135,141,142]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9d=e.$7d=e.$5d=e.$Zd=e.$Yd=void 0,e.$Vd=A,e.$Wd=p,e.$Xd=I,e.$1d=S,e.$2d=r,e.$3d=s,e.$4d=c,e.$6d=i,e.$8d=t;let O;function A(u){O=u}let T;function p(u){T=u}let o;function I(u){o=u}class y{get TChange(){return null}reportChanges(){this.get()}read($){return $?$.readObservable(this):this.get()}map($,m){const h=m===void 0?void 0:$,E=m===void 0?$:m;return o({owner:h,debugName:()=>{const D=(0,R.$cd)(E);if(D!==void 0)return D;const C=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(E.toString());if(C)return`${this.debugName}.${C[2]}`;if(!h)return`${this.debugName} (mapped)`},debugReferenceFn:E},D=>E(this.read(D),D))}flatten(){return o({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},$=>this.read($).read($))}recomputeInitiallyAndOnChange($,m){return $.add(O(this,m)),this}keepObserved($){return $.add(T(this)),this}get a(){return this.get()}}e.$Yd=y;class a extends y{constructor(){super(...arguments),this.b=new Set}addObserver($){const m=this.b.size;this.b.add($),m===0&&this.c()}removeObserver($){this.b.delete($)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Zd=a;function S(u,$){const m=new l(u,$);try{u(m)}finally{m.finish()}}let d;function r(u){if(d)u(d);else{const $=new l(u,void 0);d=$;try{u($)}finally{$.finish(),d=void 0}}}async function s(u,$){const m=new l(u,$);try{await u(m)}finally{m.finish()}}function c(u,$,m){u?$(u):S($,m)}class l{constructor($,m){this._fn=$,this.b=m,this.a=[],(0,P.$Ld)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,R.$cd)(this._fn)}updateObserver($,m){this.a.push({observer:$,observable:m}),$.beginUpdate(m)}finish(){const $=this.a;for(let m=0;m<$.length;m++){const{observer:h,observable:E}=$[m];h.endUpdate(E)}this.a=null,(0,P.$Ld)()?.handleEndTransaction()}}e.$5d=l;function i(u,$){let m;return typeof u=="string"?m=new R.$ad(void 0,u,void 0):m=new R.$ad(u,void 0,void 0),new n(m,$,v.$6c)}class n extends a{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor($,m,h){super(),this.e=$,this.g=h,this.d=m}get(){return this.d}set($,m,h){if(h===void 0&&this.g(this.d,$))return;let E;m||(m=E=new l(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h($),(0,P.$Ld)()?.handleObservableChanged(this,{oldValue:D,newValue:$,change:h,didChange:!0,hadValue:!0});for(const b of this.b)m.updateObserver(b,this),b.handleChange(this,h)}finally{E&&E.finish()}}toString(){return`${this.debugName}: ${this.d}`}h($){this.d=$}}e.$7d=n;function t(u,$){let m;return typeof u=="string"?m=new R.$ad(void 0,u,void 0):m=new R.$ad(u,void 0,void 0),new g(m,$,v.$6c)}class g extends n{h($){this.d!==$&&(this.d&&this.d.dispose(),this.d=$)}dispose(){this.d?.dispose()}}e.$9d=g}),function(){function ve(P){const O=[];typeof P=="number"&&O.push("code/timeOrigin",P);function A(p){O.push(p,Date.now())}function T(){const p=[];for(let o=0;o<O.length;o+=2)p.push({name:O[o],startTime:O[o+1]});return p}return{mark:A,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ve():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))O.push({name:A.name,startTime:Math.round(P+A.startTime)});return O}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ve(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),ve()}function v(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=v(R))}(),define(Ne[144],Le([1,0,40]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6I=void 0;const R=Symbol("unset");class P{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||v.Iterable.empty()}get entries(){return this.a.children?.entries()||v.Iterable.empty()}insert(p,o,I){this.d(p,y=>y._value=o,I)}mutate(p,o){this.d(p,I=>I._value=o(I._value===R?void 0:I._value))}mutatePath(p,o){this.d(p,()=>{},I=>o(I))}delete(p){const o=this.c(p);if(!o)return;let I=o.length-1;const y=o[I].node._value;if(y!==R){for(this.b--,o[I].node._value=R;I>0;I--){const{node:a,part:S}=o[I];if(a.children?.size||a._value!==R)break;o[I-1].node.children.delete(S)}return y}}*deleteRecursive(p){const o=this.c(p);if(!o)return;const I=o[o.length-1].node;for(let y=o.length-1;y>0;y--){const a=o[y-1];if(a.node.children.delete(o[y].part),a.node.children.size>0||a.node._value!==R)break}for(const y of O(I))y._value!==R&&(this.b--,yield y._value)}find(p){let o=this.a;for(const I of p){const y=o.children?.get(I);if(!y)return;o=y}return o._value===R?void 0:o._value}hasKeyOrParent(p){let o=this.a;for(const I of p){const y=o.children?.get(I);if(!y)return!1;if(y._value!==R)return!0;o=y}return!1}hasKeyOrChildren(p){let o=this.a;for(const I of p){const y=o.children?.get(I);if(!y)return!1;o=y}return!0}hasKey(p){let o=this.a;for(const I of p){const y=o.children?.get(I);if(!y)return!1;o=y}return o._value!==R}c(p){const o=[{part:"",node:this.a}];let I=0;for(const y of p){const a=o[I].node.children?.get(y);if(!a)return;o.push({part:y,node:a}),I++}return o}d(p,o,I){let y=this.a;for(const d of p){if(y.children)if(y.children.has(d))y=y.children.get(d);else{const r=new A;y.children.set(d,r),y=r}else{const r=new A;y.children=new Map([[d,r]]),y=r}I?.(y)}const a=y._value===R?0:1;o(y);const S=y._value===R?0:1;this.b+=S-a}*values(){for(const{_value:p}of O(this.a))p!==R&&(yield p)}}e.$6I=P;function*O(T){const p=[T];for(;p.length>0;){const o=p.pop();if(yield o,o.children)for(const I of o.children.values())p.push(I)}}class A{constructor(){this._value=R}get value(){return this._value===R?void 0:this._value}set value(p){this._value=p===void 0?R:p}}}),define(Ne[145],Le([1,0,48,19]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=T,e.$Br=p,e.$Cr=o,e.$Dr=I,e.$Er=y,e.$Fr=a,e.$Gr=S,e.$Hr=d,e.$Ir=r,e.$Jr=s,e.$Kr=h,e.$Lr=E,e.$Mr=D;const P=new v.$T(()=>{const b=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:b,collatorIsNumeric:b.resolvedOptions().numeric}}),O=new v.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new v.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(b,C,k=!1){const f=b||"",w=C||"",F=P.value.collator.compare(f,w);return P.value.collatorIsNumeric&&F===0&&f!==w?f<w?-1:1:F}function p(b,C){const k=O.value.collator;return b=b||"",C=C||"",n(k,b,C)}function o(b,C){const k=O.value.collator;return b=b||"",C=C||"",$(b,C)||n(k,b,C)}function I(b,C){const k=O.value.collator;return b=b||"",C=C||"",u(b,C)||n(k,b,C)}function y(b,C){return b=b||"",C=C||"",b===C?0:b<C?-1:1}function a(b,C){const[k,f]=l(b),[w,F]=l(C);let N=P.value.collator.compare(f,F);if(N===0){if(P.value.collatorIsNumeric&&f!==F)return f<F?-1:1;if(N=P.value.collator.compare(k,w),P.value.collatorIsNumeric&&N===0&&k!==w)return k<w?-1:1}return N}function S(b,C){b=b||"",C=C||"";const k=i(b),f=i(C),w=O.value.collator,F=A.value.collator;return n(F,k,f)||n(w,b,C)}function d(b,C){b=b||"",C=C||"";const k=i(b),f=i(C),w=O.value.collator,F=A.value.collator;return n(F,k,f)||$(b,C)||n(w,b,C)}function r(b,C){b=b||"",C=C||"";const k=i(b),f=i(C),w=O.value.collator,F=A.value.collator;return n(F,k,f)||u(b,C)||n(w,b,C)}function s(b,C){b=b||"",C=C||"";const k=i(b).toLowerCase(),f=i(C).toLowerCase();return k!==f?k<f?-1:1:b!==C?b<C?-1:1:0}const c=/^(.*?)(\.([^.]*))?$/;function l(b,C=!1){const k=b?c.exec(b):[];let f=[k&&k[1]||"",k&&k[3]||""];return C&&(!f[0]&&f[1]||f[0]&&f[0].charAt(0)===".")&&(f=[f[0]+"."+f[1],""]),f}function i(b){const C=b?c.exec(b):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function n(b,C,k){const f=b.compare(C,k);return f!==0?f:C.length!==k.length?C.length<k.length?-1:1:0}function t(b){const C=b.charAt(0);return C.toLocaleUpperCase()!==C}function g(b){const C=b.charAt(0);return C.toLocaleLowerCase()!==C}function u(b,C){return t(b)&&g(C)?-1:g(b)&&t(C)?1:0}function $(b,C){return g(b)&&t(C)?-1:t(b)&&g(C)?1:0}function m(b,C,k=!1){return k||(b=b&&b.toLowerCase(),C=C&&C.toLowerCase()),b===C?0:b<C?-1:1}function h(b,C,k=!1){const f=b.split(R.sep),w=C.split(R.sep),F=f.length-1,N=w.length-1;let L,q;for(let H=0;;H++){if(L=F===H,q=N===H,L&&q)return T(f[H],w[H],k);if(L)return-1;if(q)return 1;const W=m(f[H],w[H],k);if(W!==0)return W}}function E(b,C,k){const f=b.toLowerCase(),w=C.toLowerCase(),F=D(b,C,k);if(F)return F;const N=f.endsWith(k),L=w.endsWith(k);if(N!==L)return N?-1:1;const q=T(f,w);return q!==0?q:f.localeCompare(w)}function D(b,C,k){const f=b.toLowerCase(),w=C.toLowerCase(),F=f.startsWith(k),N=w.startsWith(k);if(F!==N)return F?-1:1;if(F&&N){if(f.length<w.length)return-1;if(f.length>w.length)return 1}return 0}}),define(Ne[72],Le([1,0,19]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$s=void 0,e.$_s=O,e.$at=A,e.$bt=T,e.$ct=o,e.$$s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(I){const y=(0,v.$oc)(I),a=R[y.toLowerCase()];return a!==void 0?a:A(I)}function A(I){const y=(0,v.$oc)(I);return P[y.toLowerCase()]}function T(I){for(const y in P)if(P[y]===I)return y}const p=/^(.+)\/(.+?)(;.+)?$/;function o(I,y){const a=p.exec(I);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:y?void 0:I}}),function(ve,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var R in v)(typeof exports=="object"?exports:ve)[R]=v[R]}}(typeof self<"u"?self:this,function(){return function(ve){var e={};function v(R){if(e[R])return e[R].exports;var P=e[R]={i:R,l:!1,exports:{}};return ve[R].call(P.exports,P,P.exports,v),P.l=!0,P.exports}return v.m=ve,v.c=e,v.d=function(R,P,O){v.o(R,P)||Object.defineProperty(R,P,{enumerable:!0,get:O})},v.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},v.t=function(R,P){if(1&P&&(R=v(R)),8&P||4&P&&typeof R=="object"&&R&&R.__esModule)return R;var O=Object.create(null);if(v.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:R}),2&P&&typeof R!="string")for(var A in R)v.d(O,A,function(T){return R[T]}.bind(null,A));return O},v.n=function(R){var P=R&&R.__esModule?function(){return R.default}:function(){return R};return v.d(P,"a",P),P},v.o=function(R,P){return Object.prototype.hasOwnProperty.call(R,P)},v.p="",v(v.s=0)}([function(ve,e,v){(function(R){var P;e=ve.exports=ke,P=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],p=e.src=[],o=0,I=o++;p[I]="0|[1-9]\\d*";var y=o++;p[y]="[0-9]+";var a=o++;p[a]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=o++;p[S]="("+p[I]+")\\.("+p[I]+")\\.("+p[I]+")";var d=o++;p[d]="("+p[y]+")\\.("+p[y]+")\\.("+p[y]+")";var r=o++;p[r]="(?:"+p[I]+"|"+p[a]+")";var s=o++;p[s]="(?:"+p[y]+"|"+p[a]+")";var c=o++;p[c]="(?:-("+p[r]+"(?:\\."+p[r]+")*))";var l=o++;p[l]="(?:-?("+p[s]+"(?:\\."+p[s]+")*))";var i=o++;p[i]="[0-9A-Za-z-]+";var n=o++;p[n]="(?:\\+("+p[i]+"(?:\\."+p[i]+")*))";var t=o++,g="v?"+p[S]+p[c]+"?"+p[n]+"?";p[t]="^"+g+"$";var u="[v=\\s]*"+p[d]+p[l]+"?"+p[n]+"?",$=o++;p[$]="^"+u+"$";var m=o++;p[m]="((?:<|>)?=?)";var h=o++;p[h]=p[y]+"|x|X|\\*";var E=o++;p[E]=p[I]+"|x|X|\\*";var D=o++;p[D]="[v=\\s]*("+p[E]+")(?:\\.("+p[E]+")(?:\\.("+p[E]+")(?:"+p[c]+")?"+p[n]+"?)?)?";var b=o++;p[b]="[v=\\s]*("+p[h]+")(?:\\.("+p[h]+")(?:\\.("+p[h]+")(?:"+p[l]+")?"+p[n]+"?)?)?";var C=o++;p[C]="^"+p[m]+"\\s*"+p[D]+"$";var k=o++;p[k]="^"+p[m]+"\\s*"+p[b]+"$";var f=o++;p[f]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var w=o++;p[w]="(?:~>?)";var F=o++;p[F]="(\\s*)"+p[w]+"\\s+",T[F]=new RegExp(p[F],"g");var N=o++;p[N]="^"+p[w]+p[D]+"$";var L=o++;p[L]="^"+p[w]+p[b]+"$";var q=o++;p[q]="(?:\\^)";var H=o++;p[H]="(\\s*)"+p[q]+"\\s+",T[H]=new RegExp(p[H],"g");var W=o++;p[W]="^"+p[q]+p[D]+"$";var G=o++;p[G]="^"+p[q]+p[b]+"$";var Q=o++;p[Q]="^"+p[m]+"\\s*("+u+")$|^$";var ae=o++;p[ae]="^"+p[m]+"\\s*("+g+")$|^$";var be=o++;p[be]="(\\s*)"+p[m]+"\\s*("+u+"|"+p[D]+")",T[be]=new RegExp(p[be],"g");var le=o++;p[le]="^\\s*("+p[D]+")\\s+-\\s+("+p[D]+")\\s*$";var _=o++;p[_]="^\\s*("+p[b]+")\\s+-\\s+("+p[b]+")\\s*$";var ce=o++;p[ce]="(<|>)?=?\\s*\\*";for(var me=0;me<35;me++)P(me,p[me]),T[me]||(T[me]=new RegExp(p[me]));function oe(j,K){if(j instanceof ke)return j;if(typeof j!="string"||j.length>O||!(K?T[$]:T[t]).test(j))return null;try{return new ke(j,K)}catch{return null}}function ke(j,K){if(j instanceof ke){if(j.loose===K)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof ke))return new ke(j,K);P("SemVer",j,K),this.loose=K;var V=j.trim().match(K?T[$]:T[t]);if(!V)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+V[1],this.minor=+V[2],this.patch=+V[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");V[4]?this.prerelease=V[4].split(".").map(function(re){if(/^[0-9]+$/.test(re)){var ge=+re;if(ge>=0&&ge<A)return ge}return re}):this.prerelease=[],this.build=V[5]?V[5].split("."):[],this.format()}e.parse=oe,e.valid=function(j,K){var V=oe(j,K);return V?V.version:null},e.clean=function(j,K){var V=oe(j.trim().replace(/^[=v]+/,""),K);return V?V.version:null},e.SemVer=ke,ke.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ke.prototype.toString=function(){return this.version},ke.prototype.compare=function(j){return P("SemVer.compare",this.version,this.loose,j),j instanceof ke||(j=new ke(j,this.loose)),this.compareMain(j)||this.comparePre(j)},ke.prototype.compareMain=function(j){return j instanceof ke||(j=new ke(j,this.loose)),Y(this.major,j.major)||Y(this.minor,j.minor)||Y(this.patch,j.patch)},ke.prototype.comparePre=function(j){if(j instanceof ke||(j=new ke(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var K=0;do{var V=this.prerelease[K],re=j.prerelease[K];if(P("prerelease compare",K,V,re),V===void 0&&re===void 0)return 0;if(re===void 0)return 1;if(V===void 0)return-1;if(V!==re)return Y(V,re)}while(++K)},ke.prototype.inc=function(j,K){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var V=this.prerelease.length;--V>=0;)typeof this.prerelease[V]=="number"&&(this.prerelease[V]++,V=-2);V===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,K,V,re){typeof V=="string"&&(re=V,V=void 0);try{return new ke(j,V).inc(K,re).version}catch{return null}},e.diff=function(j,K){if(fe(j,K))return null;var V=oe(j),re=oe(K);if(V.prerelease.length||re.prerelease.length){for(var ge in V)if((ge==="major"||ge==="minor"||ge==="patch")&&V[ge]!==re[ge])return"pre"+ge;return"prerelease"}for(var ge in V)if((ge==="major"||ge==="minor"||ge==="patch")&&V[ge]!==re[ge])return ge},e.compareIdentifiers=Y;var Te=/^[0-9]+$/;function Y(j,K){var V=Te.test(j),re=Te.test(K);return V&&re&&(j=+j,K=+K),V&&!re?-1:re&&!V?1:j<K?-1:j>K?1:0}function B(j,K,V){return new ke(j,V).compare(new ke(K,V))}function ne(j,K,V){return B(j,K,V)>0}function Ee(j,K,V){return B(j,K,V)<0}function fe(j,K,V){return B(j,K,V)===0}function we(j,K,V){return B(j,K,V)!==0}function he(j,K,V){return B(j,K,V)>=0}function X(j,K,V){return B(j,K,V)<=0}function x(j,K,V,re){var ge;switch(K){case"===":typeof j=="object"&&(j=j.version),typeof V=="object"&&(V=V.version),ge=j===V;break;case"!==":typeof j=="object"&&(j=j.version),typeof V=="object"&&(V=V.version),ge=j!==V;break;case"":case"=":case"==":ge=fe(j,V,re);break;case"!=":ge=we(j,V,re);break;case">":ge=ne(j,V,re);break;case">=":ge=he(j,V,re);break;case"<":ge=Ee(j,V,re);break;case"<=":ge=X(j,V,re);break;default:throw new TypeError("Invalid operator: "+K)}return ge}function $e(j,K){if(j instanceof $e){if(j.loose===K)return j;j=j.value}if(!(this instanceof $e))return new $e(j,K);P("comparator",j,K),this.loose=K,this.parse(j),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(j,K){return Y(K,j)},e.major=function(j,K){return new ke(j,K).major},e.minor=function(j,K){return new ke(j,K).minor},e.patch=function(j,K){return new ke(j,K).patch},e.compare=B,e.compareLoose=function(j,K){return B(j,K,!0)},e.rcompare=function(j,K,V){return B(K,j,V)},e.sort=function(j,K){return j.sort(function(V,re){return e.compare(V,re,K)})},e.rsort=function(j,K){return j.sort(function(V,re){return e.rcompare(V,re,K)})},e.gt=ne,e.lt=Ee,e.eq=fe,e.neq=we,e.gte=he,e.lte=X,e.cmp=x,e.Comparator=$e;var pe={};function Ae(j,K){if(j instanceof Ae)return j.loose===K?j:new Ae(j.raw,K);if(j instanceof $e)return new Ae(j.value,K);if(!(this instanceof Ae))return new Ae(j,K);if(this.loose=K,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(V){return this.parseRange(V.trim())},this).filter(function(V){return V.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function ze(j){return!j||j.toLowerCase()==="x"||j==="*"}function Ie(j,K,V,re,ge,Ce,Ue,Qe,_e,tt,nt,et,rt){return((K=ze(V)?"":ze(re)?">="+V+".0.0":ze(ge)?">="+V+"."+re+".0":">="+K)+" "+(Qe=ze(_e)?"":ze(tt)?"<"+(+_e+1)+".0.0":ze(nt)?"<"+_e+"."+(+tt+1)+".0":et?"<="+_e+"."+tt+"."+nt+"-"+et:"<="+Qe)).trim()}function Pe(j,K){for(var V=0;V<j.length;V++)if(!j[V].test(K))return!1;if(K.prerelease.length){for(V=0;V<j.length;V++)if(P(j[V].semver),j[V].semver!==pe&&j[V].semver.prerelease.length>0){var re=j[V].semver;if(re.major===K.major&&re.minor===K.minor&&re.patch===K.patch)return!0}return!1}return!0}function Oe(j,K,V){try{K=new Ae(K,V)}catch{return!1}return K.test(j)}function U(j,K,V,re){var ge,Ce,Ue,Qe,_e;switch(j=new ke(j,re),K=new Ae(K,re),V){case">":ge=ne,Ce=X,Ue=Ee,Qe=">",_e=">=";break;case"<":ge=Ee,Ce=he,Ue=ne,Qe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(j,K,re))return!1;for(var tt=0;tt<K.set.length;++tt){var nt=K.set[tt],et=null,rt=null;if(nt.forEach(function(ft){ft.semver===pe&&(ft=new $e(">=0.0.0")),et=et||ft,rt=rt||ft,ge(ft.semver,et.semver,re)?et=ft:Ue(ft.semver,rt.semver,re)&&(rt=ft)}),et.operator===Qe||et.operator===_e||(!rt.operator||rt.operator===Qe)&&Ce(j,rt.semver)||rt.operator===_e&&Ue(j,rt.semver))return!1}return!0}$e.prototype.parse=function(j){var K=this.loose?T[Q]:T[ae],V=j.match(K);if(!V)throw new TypeError("Invalid comparator: "+j);this.operator=V[1],this.operator==="="&&(this.operator=""),V[2]?this.semver=new ke(V[2],this.loose):this.semver=pe},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(j){return P("Comparator.test",j,this.loose),this.semver===pe||(typeof j=="string"&&(j=new ke(j,this.loose)),x(j,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(j,K){if(!(j instanceof $e))throw new TypeError("a Comparator is required");var V;if(this.operator==="")return V=new Ae(j.value,K),Oe(this.value,V,K);if(j.operator==="")return V=new Ae(this.value,K),Oe(j.semver,V,K);var re=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),ge=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Ce=this.semver.version===j.semver.version,Ue=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Qe=x(this.semver,"<",j.semver,K)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),_e=x(this.semver,">",j.semver,K)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return re||ge||Ce&&Ue||Qe||_e},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(j){var K=this.loose;j=j.trim(),P("range",j,K);var V=K?T[_]:T[le];j=j.replace(V,Ie),P("hyphen replace",j),j=j.replace(T[be],"$1$2$3"),P("comparator trim",j,T[be]),j=(j=(j=j.replace(T[F],"$1~")).replace(T[H],"$1^")).split(/\s+/).join(" ");var re=K?T[Q]:T[ae],ge=j.split(" ").map(function(Ce){return function(Ue,Qe){return P("comp",Ue),Ue=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){P("caret",et,rt);var ft=rt?T[G]:T[W];return et.replace(ft,function(lt,st,ct,mt,$t){var We;return P("caret",et,lt,st,ct,mt,$t),ze(st)?We="":ze(ct)?We=">="+st+".0.0 <"+(+st+1)+".0.0":ze(mt)?We=st==="0"?">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+".0 <"+(+st+1)+".0.0":$t?(P("replaceCaret pr",$t),$t.charAt(0)!=="-"&&($t="-"+$t),We=st==="0"?ct==="0"?">="+st+"."+ct+"."+mt+$t+" <"+st+"."+ct+"."+(+mt+1):">="+st+"."+ct+"."+mt+$t+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+mt+$t+" <"+(+st+1)+".0.0"):(P("no pr"),We=st==="0"?ct==="0"?">="+st+"."+ct+"."+mt+" <"+st+"."+ct+"."+(+mt+1):">="+st+"."+ct+"."+mt+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+mt+" <"+(+st+1)+".0.0"),P("caret return",We),We})}(nt,tt)}).join(" ")}(Ue,Qe),P("caret",Ue),Ue=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){var ft=rt?T[L]:T[N];return et.replace(ft,function(lt,st,ct,mt,$t){var We;return P("tilde",et,lt,st,ct,mt,$t),ze(st)?We="":ze(ct)?We=">="+st+".0.0 <"+(+st+1)+".0.0":ze(mt)?We=">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":$t?(P("replaceTilde pr",$t),$t.charAt(0)!=="-"&&($t="-"+$t),We=">="+st+"."+ct+"."+mt+$t+" <"+st+"."+(+ct+1)+".0"):We=">="+st+"."+ct+"."+mt+" <"+st+"."+(+ct+1)+".0",P("tilde return",We),We})}(nt,tt)}).join(" ")}(Ue,Qe),P("tildes",Ue),Ue=function(_e,tt){return P("replaceXRanges",_e,tt),_e.split(/\s+/).map(function(nt){return function(et,rt){et=et.trim();var ft=rt?T[k]:T[C];return et.replace(ft,function(lt,st,ct,mt,$t,We){P("xRange",et,lt,st,ct,mt,$t,We);var je=ze(ct),ie=je||ze(mt),ee=ie||ze($t);return st==="="&&ee&&(st=""),je?lt=st===">"||st==="<"?"<0.0.0":"*":st&&ee?(ie&&(mt=0),ee&&($t=0),st===">"?(st=">=",ie?(ct=+ct+1,mt=0,$t=0):ee&&(mt=+mt+1,$t=0)):st==="<="&&(st="<",ie?ct=+ct+1:mt=+mt+1),lt=st+ct+"."+mt+"."+$t):ie?lt=">="+ct+".0.0 <"+(+ct+1)+".0.0":ee&&(lt=">="+ct+"."+mt+".0 <"+ct+"."+(+mt+1)+".0"),P("xRange return",lt),lt})}(nt,tt)}).join(" ")}(Ue,Qe),P("xrange",Ue),Ue=function(_e,tt){return P("replaceStars",_e,tt),_e.trim().replace(T[ce],"")}(Ue,Qe),P("stars",Ue),Ue}(Ce,K)}).join(" ").split(/\s+/);return this.loose&&(ge=ge.filter(function(Ce){return!!Ce.match(re)})),ge=ge.map(function(Ce){return new $e(Ce,K)})},Ae.prototype.intersects=function(j,K){if(!(j instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(V){return V.every(function(re){return j.set.some(function(ge){return ge.every(function(Ce){return re.intersects(Ce,K)})})})})},e.toComparators=function(j,K){return new Ae(j,K).set.map(function(V){return V.map(function(re){return re.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new ke(j,this.loose));for(var K=0;K<this.set.length;K++)if(Pe(this.set[K],j))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(j,K,V){var re=null,ge=null;try{var Ce=new Ae(K,V)}catch{return null}return j.forEach(function(Ue){Ce.test(Ue)&&(re&&ge.compare(Ue)!==-1||(ge=new ke(re=Ue,V)))}),re},e.minSatisfying=function(j,K,V){var re=null,ge=null;try{var Ce=new Ae(K,V)}catch{return null}return j.forEach(function(Ue){Ce.test(Ue)&&(re&&ge.compare(Ue)!==1||(ge=new ke(re=Ue,V)))}),re},e.validRange=function(j,K){try{return new Ae(j,K).range||"*"}catch{return null}},e.ltr=function(j,K,V){return U(j,K,"<",V)},e.gtr=function(j,K,V){return U(j,K,">",V)},e.outside=U,e.prerelease=function(j,K){var V=oe(j,K);return V&&V.prerelease.length?V.prerelease:null},e.intersects=function(j,K,V){return j=new Ae(j,V),K=new Ae(K,V),j.intersects(K)},e.coerce=function(j){if(j instanceof ke)return j;if(typeof j!="string")return null;var K=j.match(T[f]);return K==null?null:oe((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,v(1))},function(ve,e){var v,R,P=ve.exports={};function O(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function T(s){if(v===setTimeout)return setTimeout(s,0);if((v===O||!v)&&setTimeout)return v=setTimeout,setTimeout(s,0);try{return v(s,0)}catch{try{return v.call(null,s,0)}catch{return v.call(this,s,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:O}catch{v=O}try{R=typeof clearTimeout=="function"?clearTimeout:A}catch{R=A}})();var p,o=[],I=!1,y=-1;function a(){I&&p&&(I=!1,p.length?o=p.concat(o):y=-1,o.length&&S())}function S(){if(!I){var s=T(a);I=!0;for(var c=o.length;c;){for(p=o,o=[];++y<c;)p&&p[y].run();y=-1,c=o.length}p=null,I=!1,function(l){if(R===clearTimeout)return clearTimeout(l);if((R===A||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(l);try{R(l)}catch{try{return R.call(null,l)}catch{return R.call(this,l)}}}(s)}}function d(s,c){this.fun=s,this.array=c}function r(){}P.nextTick=function(s){var c=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)c[l-1]=arguments[l];o.push(new d(s,c)),o.length!==1||I||T(S)},d.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=r,P.addListener=r,P.once=r,P.off=r,P.removeListener=r,P.removeAllListeners=r,P.emit=r,P.prependListener=r,P.prependOnceListener=r,P.listeners=function(s){return[]},P.binding=function(s){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(s){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Ne[146],Le([1,0,6,4]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.$ft=e.$et=e.$dt=e.ScrollbarVisibility=void 0;var P;(function(S){S[S.Auto=1]="Auto",S[S.Hidden=2]="Hidden",S[S.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class O{constructor(d,r,s,c,l,i,n){this.c=d,this._scrollStateBrand=void 0,this.c&&(r=r|0,s=s|0,c=c|0,l=l|0,i=i|0,n=n|0),this.rawScrollLeft=c,this.rawScrollTop=n,r<0&&(r=0),c+r>s&&(c=s-r),c<0&&(c=0),l<0&&(l=0),n+l>i&&(n=i-l),n<0&&(n=0),this.width=r,this.scrollWidth=s,this.scrollLeft=c,this.height=l,this.scrollHeight=i,this.scrollTop=n}equals(d){return this.rawScrollLeft===d.rawScrollLeft&&this.rawScrollTop===d.rawScrollTop&&this.width===d.width&&this.scrollWidth===d.scrollWidth&&this.scrollLeft===d.scrollLeft&&this.height===d.height&&this.scrollHeight===d.scrollHeight&&this.scrollTop===d.scrollTop}withScrollDimensions(d,r){return new O(this.c,typeof d.width<"u"?d.width:this.width,typeof d.scrollWidth<"u"?d.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof d.height<"u"?d.height:this.height,typeof d.scrollHeight<"u"?d.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(d){return new O(this.c,this.width,this.scrollWidth,typeof d.scrollLeft<"u"?d.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof d.scrollTop<"u"?d.scrollTop:this.rawScrollTop)}createScrollEvent(d,r){const s=this.width!==d.width,c=this.scrollWidth!==d.scrollWidth,l=this.scrollLeft!==d.scrollLeft,i=this.height!==d.height,n=this.scrollHeight!==d.scrollHeight,t=this.scrollTop!==d.scrollTop;return{inSmoothScrolling:r,oldWidth:d.width,oldScrollWidth:d.scrollWidth,oldScrollLeft:d.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:d.height,oldScrollHeight:d.scrollHeight,oldScrollTop:d.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:s,scrollWidthChanged:c,scrollLeftChanged:l,heightChanged:i,scrollHeightChanged:n,scrollTopChanged:t}}}e.$dt=O;class A extends R.$Uc{constructor(d){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$le),this.onScroll=this.j.event,this.c=d.smoothScrollDuration,this.f=d.scheduleAtNextAnimationFrame,this.g=new O(d.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(d){this.c=d}validateScrollPosition(d){return this.g.withScrollPosition(d)}getScrollDimensions(){return this.g}setScrollDimensions(d,r){const s=this.g.withScrollDimensions(d,r);this.n(s,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(d){const r=this.g.withScrollPosition(d);this.h&&(this.h.dispose(),this.h=null),this.n(r,!1)}setScrollPositionSmooth(d,r){if(this.c===0)return this.setScrollPositionNow(d);if(this.h){d={scrollLeft:typeof d.scrollLeft>"u"?this.h.to.scrollLeft:d.scrollLeft,scrollTop:typeof d.scrollTop>"u"?this.h.to.scrollTop:d.scrollTop};const s=this.g.withScrollPosition(d);if(this.h.to.scrollLeft===s.scrollLeft&&this.h.to.scrollTop===s.scrollTop)return;let c;r?c=new I(this.h.from,s,this.h.startTime,this.h.duration):c=this.h.combine(this.g,s,this.c),this.h.dispose(),this.h=c}else{const s=this.g.withScrollPosition(d);this.h=I.start(this.g,s,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const d=this.h.tick(),r=this.g.withScrollPosition(d);if(this.n(r,!0),!!this.h){if(d.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(d,r){const s=this.g;s.equals(d)||(this.g=d,this.j.fire(this.g.createScrollEvent(s,r)))}}e.$et=A;class T{constructor(d,r,s){this.scrollLeft=d,this.scrollTop=r,this.isDone=s}}e.$ft=T;function p(S,d){const r=d-S;return function(s){return S+r*a(s)}}function o(S,d,r){return function(s){return s<r?S(s/r):d((s-r)/(1-r))}}class I{constructor(d,r,s,c){this.from=d,this.to=r,this.duration=c,this.startTime=s,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(d,r,s){if(Math.abs(d-r)>2.5*s){let l,i;return d<r?(l=d+.75*s,i=r-.75*s):(l=d-.75*s,i=r+.75*s),o(p(d,l),p(i,r),.33)}return p(d,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(d){this.to=d.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(d){const r=(d-this.startTime)/this.duration;if(r<1){const s=this.c(r),c=this.d(r);return new T(s,c,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(d,r,s){return I.start(d,r,s)}static start(d,r,s){s=s+10;const c=Date.now()-10;return new I(d,r,c,s)}}e.$gt=I;function y(S){return Math.pow(S,3)}function a(S){return 1-y(1-S)}}),define(Ne[147],Le([1,0,13,4]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=P,e.$ze=O,e.$Ae=A,e.$Be=T,e.$Ce=o,e.$De=I,e.$Ee=y,e.$Fe=a,e.$Ge=S,e.$He=d,e.$Ie=r,e.$Je=s,e.$Ke=c,e.$Le=l,e.$Me=i;function P(n){const t=n;return t?typeof t.read=="function":!1}function O(n){const t=n;return t?[t.on,t.pause,t.resume,t.destroy].every(g=>typeof g=="function"):!1}function A(n){const t=n;return t?O(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function T(n,t){return new p(n,t)}class p{constructor(t,g){this.e=t,this.f=g,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(g=>this.d.push(g))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(g=>g(t))}h(t){this.c.error.length===0?(0,v.$Y)(t):this.c.error.slice(0).forEach(g=>g(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,g){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(g),this.resume();break;case"end":this.c.end.push(g),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(g),this.a.flowing&&this.k();break}}removeListener(t,g){if(this.a.destroyed)return;let u;switch(t){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const $=u.indexOf(g);$>=0&&u.splice($,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const g=[...this.d];this.d.length=0,g.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function o(n,t){const g=[];let u;for(;(u=n.read())!==null;)g.push(u);return t(g)}function I(n,t,g){const u=[];let $;for(;($=n.read())!==null&&u.length<g;)u.push($);return $===null&&u.length>0?t(u):{read:()=>{if(u.length>0)return u.shift();if(typeof $<"u"){const m=$;return $=void 0,m}return n.read()}}}function y(n,t){return new Promise((g,u)=>{const $=[];a(n,{onData:m=>{t&&$.push(m)},onError:m=>{t?u(m):g(void 0)},onEnd:()=>{g(t?t($):void 0)}})})}function a(n,t,g){n.on("error",u=>{g?.isCancellationRequested||t.onError(u)}),n.on("end",()=>{g?.isCancellationRequested||t.onEnd()}),n.on("data",u=>{g?.isCancellationRequested||t.onData(u)})}function S(n,t){return new Promise((g,u)=>{const $=new R.$Tc,m=[],h=b=>{if(m.push(b),m.length>t)return $.dispose(),n.pause(),g({stream:n,buffer:m,ended:!1})},E=b=>($.dispose(),u(b)),D=()=>($.dispose(),g({stream:n,buffer:m,ended:!0}));$.add((0,R.$Sc)(()=>n.removeListener("error",E))),n.on("error",E),$.add((0,R.$Sc)(()=>n.removeListener("end",D))),n.on("end",D),$.add((0,R.$Sc)(()=>n.removeListener("data",h))),n.on("data",h)})}function d(n,t){const g=T(t);return g.end(n),g}function r(){const n=T(()=>{throw new Error("not supported")});return n.end(),n}function s(n){let t=!1;return{read:()=>t?null:(t=!0,n)}}function c(n,t,g){const u=T(g);return a(n,{onData:$=>u.write(t.data($)),onError:$=>u.error(t.error?t.error($):$),onEnd:()=>u.end()}),u}function l(n,t,g){let u=!1;return{read:()=>{const $=t.read();return u?$:(u=!0,$!==null?g([n,$]):n)}}}function i(n,t,g){let u=!1;const $=T(g);return a(t,{onData:m=>u?$.write(m):(u=!0,$.write(g([n,m]))),onError:m=>$.error(m),onEnd:()=>{u||(u=!0,$.write(n)),$.end()}}),$}}),define(Ne[22],Le([1,0,48,147]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=void 0,e.$Oe=o,e.$Pe=I,e.$Qe=y,e.$Re=a,e.$Se=S,e.$Te=d,e.$Ue=r,e.$Ve=s,e.$We=c,e.$Xe=l,e.$Ye=i,e.$Ze=n,e.$1e=t,e.$2e=g,e.$3e=u,e.$4e=$,e.$5e=m,e.$6e=h,e.$7e=E,e.$8e=C,R=qe(R);const P=typeof Buffer<"u",O=new v.$T(()=>new Uint8Array(256));let A,T;class p{static alloc(f){return P?new p(Buffer.allocUnsafe(f)):new p(new Uint8Array(f))}static wrap(f){return P&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new p(f)}static fromString(f,w){return!(w?.dontUseNodeBuffer||!1)&&P?new p(Buffer.from(f)):(A||(A=new TextEncoder),new p(A.encode(f)))}static fromByteArray(f){const w=p.alloc(f.length);for(let F=0,N=f.length;F<N;F++)w.buffer[F]=f[F];return w}static concat(f,w){if(typeof w>"u"){w=0;for(let L=0,q=f.length;L<q;L++)w+=f[L].byteLength}const F=p.alloc(w);let N=0;for(let L=0,q=f.length;L<q;L++){const H=f[L];F.set(H,N),N+=H.byteLength}return F}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=p.alloc(this.byteLength);return f.set(this),f}toString(){return P?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(f,w){return new p(this.buffer.subarray(f,w))}set(f,w){if(f instanceof p)this.buffer.set(f.buffer,w);else if(f instanceof Uint8Array)this.buffer.set(f,w);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),w);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return a(this.buffer,f)}writeUInt32BE(f,w){S(this.buffer,f,w)}readUInt32LE(f){return d(this.buffer,f)}writeUInt32LE(f,w){r(this.buffer,f,w)}readUInt8(f){return s(this.buffer,f)}writeUInt8(f,w){c(this.buffer,f,w)}indexOf(f,w=0){return o(this.buffer,f instanceof p?f.buffer:f,w)}}e.$Ne=p;function o(k,f,w=0){const F=f.byteLength,N=k.byteLength;if(F===0)return 0;if(F===1)return k.indexOf(f[0]);if(F>N-w)return-1;const L=O.value;L.fill(f.length);for(let G=0;G<f.length;G++)L[f[G]]=f.length-G-1;let q=w+f.length-1,H=q,W=-1;for(;q<N;)if(k[q]===f[H]){if(H===0){W=q;break}q--,H--}else q+=Math.max(f.length-H,L[k[q]]),H=f.length-1;return W}function I(k,f){return k[f+0]<<0>>>0|k[f+1]<<8>>>0}function y(k,f,w){k[w+0]=f&255,f=f>>>8,k[w+1]=f&255}function a(k,f){return k[f]*2**24+k[f+1]*2**16+k[f+2]*2**8+k[f+3]}function S(k,f,w){k[w+3]=f,f=f>>>8,k[w+2]=f,f=f>>>8,k[w+1]=f,f=f>>>8,k[w]=f}function d(k,f){return k[f+0]<<0>>>0|k[f+1]<<8>>>0|k[f+2]<<16>>>0|k[f+3]<<24>>>0}function r(k,f,w){k[w+0]=f&255,f=f>>>8,k[w+1]=f&255,f=f>>>8,k[w+2]=f&255,f=f>>>8,k[w+3]=f&255}function s(k,f){return k[f]}function c(k,f,w){k[w]=f}function l(k){return R.$Ce(k,f=>p.concat(f))}function i(k){return R.$Je(k)}function n(k){return R.$Ee(k,f=>p.concat(f))}async function t(k){return k.ended?p.concat(k.buffer):p.concat([...k.buffer,await n(k.stream)])}function g(k){return R.$He(k,f=>p.concat(f))}function u(k){return R.$Ke(k,{data:f=>typeof f=="string"?p.fromString(f):p.wrap(f)},f=>p.concat(f))}function $(k){return R.$Be(f=>p.concat(f),k)}function m(k,f){return R.$Le(k,f,w=>p.concat(w))}function h(k,f){return R.$Me(k,f,w=>p.concat(w))}function E(k){let f=0,w=0,F=0;const N=new Uint8Array(Math.floor(k.length/4*3)),L=H=>{switch(w){case 3:N[F++]=f|H,w=0;break;case 2:N[F++]=f|H>>>2,f=H<<6,w=3;break;case 1:N[F++]=f|H>>>4,f=H<<4,w=2;break;default:f=H<<2,w=1}};for(let H=0;H<k.length;H++){const W=k.charCodeAt(H);if(W>=65&&W<=90)L(W-65);else if(W>=97&&W<=122)L(W-97+26);else if(W>=48&&W<=57)L(W-48+52);else if(W===43||W===45)L(62);else if(W===47||W===95)L(63);else{if(W===61)break;throw new SyntaxError(`Unexpected base64 character ${k[H]}`)}}const q=F;for(;w>0;)L(0);return p.wrap(N).slice(0,q)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:k},f=!0,w=!1){const F=w?b:D;let N="";const L=k.byteLength%3;let q=0;for(;q<k.byteLength-L;q+=3){const H=k[q+0],W=k[q+1],G=k[q+2];N+=F[H>>>2],N+=F[(H<<4|W>>>4)&63],N+=F[(W<<2|G>>>6)&63],N+=F[G&63]}if(L===1){const H=k[q+0];N+=F[H>>>2],N+=F[H<<4&63],f&&(N+="==")}else if(L===2){const H=k[q+0],W=k[q+1];N+=F[H>>>2],N+=F[(H<<4|W>>>4)&63],N+=F[W<<2&63],f&&(N+="=")}return N}}),define(Ne[148],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0,e.$ge=Symbol("MicrotaskDelay")}),define(Ne[34],Le([1,0,97]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$6j=P;var R;(function(A){function T(p){return p&&typeof p=="object"&&typeof p.id=="string"}A.isThemeColor=T})(R||(e.ThemeColor=R={}));function P(A){return{id:A}}var O;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function p(l){const i=T.exec(l.id);if(!i)return p(v.$5j.error);const[,n,t]=i,g=["codicon","codicon-"+n];return t&&g.push("codicon-modifier-"+t.substring(1)),g}A.asClassNameArray=p;function o(l){return p(l).join(" ")}A.asClassName=o;function I(l){return"."+p(l).join(".")}A.asCSSSelector=I;function y(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||R.isThemeColor(l.color))}A.isThemeIcon=y;const a=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function S(l){const i=a.exec(l);if(!i)return;const[,n]=i;return{id:n}}A.fromString=S;function d(l){return{id:l}}A.fromId=d;function r(l,i){let n=l.id;const t=n.lastIndexOf("~");return t!==-1&&(n=n.substring(0,t)),i&&(n=`${n}~${i}`),{id:n}}A.modify=r;function s(l){const i=l.id.lastIndexOf("~");if(i!==-1)return l.id.substring(i+1)}A.getModifier=s;function c(l,i){return l.id===i.id&&l.color?.id===i.color?.id}A.isEqual=c})(O||(e.ThemeIcon=O={}))}),define(Ne[51],Le([1,0,27,19,20,12,14]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=T,e.$yg=p,e.$zg=o,e.$Ag=I,e.$Bg=y,e.$Cg=r,e.$Dg=s,e.$Eg=c,e.$Fg=l,e.$Gg=i,e.$Hg=n,e.$Ig=t,e.$Jg=g,e.$Kg=u,e.$Lg=$,e.$Mg=m,e.$Ng=D;function T(b){return b===v.CharCode.Slash||b===v.CharCode.Backslash}function p(b){return b.replace(/[\\/]/g,R.$gc.sep)}function o(b){return b.indexOf("/")===-1&&(b=p(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}function I(b,C=R.$gc.sep){if(!b)return"";const k=b.length,f=b.charCodeAt(0);if(T(f)){if(T(b.charCodeAt(1))&&!T(b.charCodeAt(2))){let F=3;const N=F;for(;F<k&&!T(b.charCodeAt(F));F++);if(N!==F&&!T(b.charCodeAt(F+1))){for(F+=1;F<k;F++)if(T(b.charCodeAt(F)))return b.slice(0,F+1).replace(/[\\/]/g,C)}}return C}else if(l(f)&&b.charCodeAt(1)===v.CharCode.Colon)return T(b.charCodeAt(2))?b.slice(0,2)+C:b.slice(0,2);let w=b.indexOf("://");if(w!==-1){for(w+=3;w<k;w++)if(T(b.charCodeAt(w)))return b.slice(0,w+1)}return""}function y(b){if(!P.$j||!b||b.length<5)return!1;let C=b.charCodeAt(0);if(C!==v.CharCode.Backslash||(C=b.charCodeAt(1),C!==v.CharCode.Backslash))return!1;let k=2;const f=k;for(;k<b.length&&(C=b.charCodeAt(k),C!==v.CharCode.Backslash);k++);return!(f===k||(C=b.charCodeAt(k+1),isNaN(C)||C===v.CharCode.Backslash))}const a=/[\\/:\*\?"<>\|]/g,S=/[/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(b,C=P.$j){const k=C?a:S;return!(!b||b.length===0||/^\s+$/.test(b)||(k.lastIndex=0,k.test(b))||C&&d.test(b)||b==="."||b===".."||C&&b[b.length-1]==="."||C&&b.length!==b.trim().length||b.length>255)}function s(b,C,k){const f=b===C;return!k||f?f:!b||!C?!1:(0,O.$Ff)(b,C)}function c(b,C,k,f=R.sep){if(b===C)return!0;if(!b||!C||C.length>b.length)return!1;if(k){if(!(0,O.$Gf)(b,C))return!1;if(C.length===b.length)return!0;let F=C.length;return C.charAt(C.length-1)===f&&F--,b.charAt(F)===f}return C.charAt(C.length-1)!==f&&(C+=f),b.indexOf(C)===0}function l(b){return b>=v.CharCode.A&&b<=v.CharCode.Z||b>=v.CharCode.a&&b<=v.CharCode.z}function i(b,C){return P.$j&&b.endsWith(":")&&(b+=R.sep),(0,R.$ic)(b)||(b=(0,R.$jc)(C,b)),b=(0,R.$hc)(b),n(b)}function n(b){return P.$j?(b=(0,O.$nf)(b,R.sep),b.endsWith(":")&&(b+=R.sep)):(b=(0,O.$nf)(b,R.sep),b||(b=R.sep)),b}function t(b){const C=(0,R.$hc)(b);return P.$j?b.length>3?!1:g(C)&&(b.length===2||C.charCodeAt(2)===v.CharCode.Backslash):C===R.$gc.sep}function g(b,C=P.$j){return C?l(b.charCodeAt(0))&&b.charCodeAt(1)===v.CharCode.Colon:!1}function u(b,C=P.$j){return g(b,C)?b[0]:void 0}function $(b,C,k){return C.length>b.length?-1:b===C?0:(k&&(b=b.toLowerCase(),C=C.toLowerCase()),b.indexOf(C))}function m(b){const C=b.split(":");let k,f,w;for(const F of C){const N=Number(F);(0,A.$ig)(N)?f===void 0?f=N:w===void 0&&(w=N):k=k?[k,F].join(":"):F}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:f!==void 0?f:void 0,column:w!==void 0?w:f!==void 0?1:void 0}}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",E="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(b,C,k=8){let f="";for(let F=0;F<k;F++){let N;F===0&&P.$j&&!C&&(k===3||k===4)?N=E:N=h,f+=N.charAt(Math.floor(Math.random()*N.length))}let w;return C?w=`${C}-${f}`:w=f,b?(0,R.$jc)(b,w):w}}),define(Ne[149],Le([1,0,27,28,139,12]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.FuzzyScore=e.$Ik=e.$Hk=void 0,e.or=A,e.$Jk=p,e.$Kk=o,e.$Lk=a,e.$Mk=D,e.$Nk=b,e.$Ok=N,e.$Pk=L,e.$Qk=q,e.$Rk=H,e.$Sk=ne,e.$Uk=he,e.$Vk=$e,e.$Wk=pe,O=qe(O);function A(...Ie){return function(Pe,Oe){for(let U=0,j=Ie.length;U<j;U++){const K=Ie[U](Pe,Oe);if(K)return K}return null}}e.$Hk=T.bind(void 0,!1),e.$Ik=T.bind(void 0,!0);function T(Ie,Pe,Oe){if(!Oe||Oe.length<Pe.length)return null;let U;return Ie?U=O.$Gf(Oe,Pe):U=Oe.indexOf(Pe)===0,U?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function p(Ie,Pe){const Oe=Pe.toLowerCase().indexOf(Ie.toLowerCase());return Oe===-1?null:[{start:Oe,end:Oe+Ie.length}]}function o(Ie,Pe){return I(Ie.toLowerCase(),Pe.toLowerCase(),0,0)}function I(Ie,Pe,Oe,U){if(Oe===Ie.length)return[];if(U===Pe.length)return null;if(Ie[Oe]===Pe[U]){let j=null;return(j=I(Ie,Pe,Oe+1,U+1))?t({start:U,end:U+1},j):null}return I(Ie,Pe,Oe,U+1)}function y(Ie){return v.CharCode.a<=Ie&&Ie<=v.CharCode.z}function a(Ie){return v.CharCode.A<=Ie&&Ie<=v.CharCode.Z}function S(Ie){return v.CharCode.Digit0<=Ie&&Ie<=v.CharCode.Digit9}function d(Ie){return Ie===v.CharCode.Space||Ie===v.CharCode.Tab||Ie===v.CharCode.LineFeed||Ie===v.CharCode.CarriageReturn}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Ie=>r.add(Ie.charCodeAt(0)));function s(Ie){return d(Ie)||r.has(Ie)}function c(Ie,Pe){return Ie===Pe||s(Ie)&&s(Pe)}const l=new Map;function i(Ie){if(l.has(Ie))return l.get(Ie);let Pe;const Oe=(0,P.$Fk)(Ie);return Oe&&(Pe=Oe),l.set(Ie,Pe),Pe}function n(Ie){return y(Ie)||a(Ie)||S(Ie)}function t(Ie,Pe){return Pe.length===0?Pe=[Ie]:Ie.end===Pe[0].start?Pe[0].start=Ie.start:Pe.unshift(Ie),Pe}function g(Ie,Pe){for(let Oe=Pe;Oe<Ie.length;Oe++){const U=Ie.charCodeAt(Oe);if(a(U)||S(U)||Oe>0&&!n(Ie.charCodeAt(Oe-1)))return Oe}return Ie.length}function u(Ie,Pe,Oe,U){if(Oe===Ie.length)return[];if(U===Pe.length)return null;if(Ie[Oe]!==Pe[U].toLowerCase())return null;{let j=null,K=U+1;for(j=u(Ie,Pe,Oe+1,U+1);!j&&(K=g(Pe,K))<Pe.length;)j=u(Ie,Pe,Oe+1,K),K++;return j===null?null:t({start:U,end:U+1},j)}}function $(Ie){let Pe=0,Oe=0,U=0,j=0,K=0;for(let Ue=0;Ue<Ie.length;Ue++)K=Ie.charCodeAt(Ue),a(K)&&Pe++,y(K)&&Oe++,n(K)&&U++,S(K)&&j++;const V=Pe/Ie.length,re=Oe/Ie.length,ge=U/Ie.length,Ce=j/Ie.length;return{upperPercent:V,lowerPercent:re,alphaPercent:ge,numericPercent:Ce}}function m(Ie){const{upperPercent:Pe,lowerPercent:Oe}=Ie;return Oe===0&&Pe>.6}function h(Ie){const{upperPercent:Pe,lowerPercent:Oe,alphaPercent:U,numericPercent:j}=Ie;return Oe>.2&&Pe<.8&&U>.6&&j<.2}function E(Ie){let Pe=0,Oe=0,U=0,j=0;for(let K=0;K<Ie.length;K++)U=Ie.charCodeAt(K),a(U)&&Pe++,y(U)&&Oe++,d(U)&&j++;return(Pe===0||Oe===0)&&j===0?Ie.length<=30:Pe<=5}function D(Ie,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!E(Ie))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Oe=$(Pe);if(!h(Oe)){if(!m(Oe))return null;Pe=Pe.toLowerCase()}let U=null,j=0;for(Ie=Ie.toLowerCase();j<Pe.length&&(U=u(Ie,Pe,0,j))===null;)j=g(Pe,j+1);return U}function b(Ie,Pe,Oe=!1){if(!Pe||Pe.length===0)return null;let U=null,j=0;for(Ie=Ie.toLowerCase(),Pe=Pe.toLowerCase();j<Pe.length&&(U=C(Ie,Pe,0,j,Oe),U===null);)j=k(Pe,j+1);return U}function C(Ie,Pe,Oe,U,j){let K=0;if(Oe===Ie.length)return[];if(U===Pe.length)return null;if(!c(Ie.charCodeAt(Oe),Pe.charCodeAt(U))){const ge=i(Ie.charCodeAt(Oe));if(!ge)return null;for(let Ce=0;Ce<ge.length;Ce++)if(!c(ge[Ce],Pe.charCodeAt(U+Ce)))return null;K+=ge.length-1}let V=null,re=U+K+1;if(V=C(Ie,Pe,Oe+1,re,j),!j)for(;!V&&(re=k(Pe,re))<Pe.length;)V=C(Ie,Pe,Oe+1,re,j),re++;if(!V)return null;if(Ie.charCodeAt(Oe)!==Pe.charCodeAt(U)){const ge=i(Ie.charCodeAt(Oe));if(!ge)return V;for(let Ce=0;Ce<ge.length;Ce++)if(ge[Ce]!==Pe.charCodeAt(U+Ce))return V}return t({start:U,end:U+K+1},V)}function k(Ie,Pe){for(let Oe=Pe;Oe<Ie.length;Oe++)if(s(Ie.charCodeAt(Oe))||Oe>0&&s(Ie.charCodeAt(Oe-1)))return Oe;return Ie.length}const f=A(e.$Ik,D,p),w=A(e.$Ik,D,o),F=new R.$Dc(1e4);function N(Ie,Pe,Oe=!1){if(typeof Ie!="string"||typeof Pe!="string")return null;let U=F.get(Ie);U||(U=new RegExp(O.$of(Ie),"i"),F.set(Ie,U));const j=U.exec(Pe);return j?[{start:j.index,end:j.index+j[0].length}]:Oe?w(Ie,Pe):f(Ie,Pe)}function L(Ie,Pe){const Oe=he(Ie,Ie.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Oe?H(Oe):null}function q(Ie,Pe,Oe,U,j,K){const V=Math.min(13,Ie.length);for(;Oe<V;Oe++){const re=he(Ie,Pe,Oe,U,j,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(re)return re}return[0,K]}function H(Ie){if(typeof Ie>"u")return[];const Pe=[],Oe=Ie[1];for(let U=Ie.length-1;U>1;U--){const j=Ie[U]+Oe,K=Pe[Pe.length-1];K&&K.end===j?K.end=j+1:Pe.push({start:j,end:j+1})}return Pe}const W=128;function G(){const Ie=[],Pe=[];for(let Oe=0;Oe<=W;Oe++)Pe[Oe]=0;for(let Oe=0;Oe<=W;Oe++)Ie.push(Pe.slice(0));return Ie}function Q(Ie){const Pe=[];for(let Oe=0;Oe<=Ie;Oe++)Pe[Oe]=0;return Pe}const ae=Q(2*W),be=Q(2*W),le=G(),_=G(),ce=G(),me=!1;function oe(Ie,Pe,Oe,U,j){function K(re,ge,Ce=" "){for(;re.length<ge;)re=Ce+re;return re}let V=` |   |${U.split("").map(re=>K(re,3)).join("|")}
`;for(let re=0;re<=Oe;re++)re===0?V+=" |":V+=`${Pe[re-1]}|`,V+=Ie[re].slice(0,j+1).map(ge=>K(ge.toString(),3)).join("|")+`
`;return V}function ke(Ie,Pe,Oe,U){Ie=Ie.substr(Pe),Oe=Oe.substr(U),console.log(oe(_,Ie,Ie.length,Oe,Oe.length)),console.log(oe(ce,Ie,Ie.length,Oe,Oe.length)),console.log(oe(le,Ie,Ie.length,Oe,Oe.length))}function Te(Ie,Pe){if(Pe<0||Pe>=Ie.length)return!1;const Oe=Ie.codePointAt(Pe);switch(Oe){case v.CharCode.Underline:case v.CharCode.Dash:case v.CharCode.Period:case v.CharCode.Space:case v.CharCode.Slash:case v.CharCode.Backslash:case v.CharCode.SingleQuote:case v.CharCode.DoubleQuote:case v.CharCode.Colon:case v.CharCode.DollarSign:case v.CharCode.LessThan:case v.CharCode.GreaterThan:case v.CharCode.OpenParen:case v.CharCode.CloseParen:case v.CharCode.OpenSquareBracket:case v.CharCode.CloseSquareBracket:case v.CharCode.OpenCurlyBrace:case v.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.$Yf(Oe)}}function Y(Ie,Pe){if(Pe<0||Pe>=Ie.length)return!1;switch(Ie.charCodeAt(Pe)){case v.CharCode.Space:case v.CharCode.Tab:return!0;default:return!1}}function B(Ie,Pe,Oe){return Pe[Ie]!==Oe[Ie]}function ne(Ie,Pe,Oe,U,j,K,V=!1){for(;Pe<Oe&&j<K;)Ie[Pe]===U[j]&&(V&&(ae[Pe]=j),Pe+=1),j+=1;return Pe===Oe}var Ee;(function(Ie){Ie[Ie.Diag=1]="Diag",Ie[Ie.Left=2]="Left",Ie[Ie.LeftLeft=3]="LeftLeft"})(Ee||(Ee={}));var fe;(function(Ie){Ie.Default=[-100,0];function Pe(Oe){return!Oe||Oe.length===2&&Oe[0]===-100&&Oe[1]===0}Ie.isDefault=Pe})(fe||(e.FuzzyScore=fe={}));class we{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Oe){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Oe}}e.$Tk=we;function he(Ie,Pe,Oe,U,j,K,V=we.default){const re=Ie.length>W?W:Ie.length,ge=U.length>W?W:U.length;if(Oe>=re||K>=ge||re-Oe>ge-K||!ne(Pe,Oe,re,j,K,ge,!0))return;X(re,ge,Oe,K,Pe,j);let Ce=1,Ue=1,Qe=Oe,_e=K;const tt=[!1];for(Ce=1,Qe=Oe;Qe<re;Ce++,Qe++){const lt=ae[Qe],st=be[Qe],ct=Qe+1<re?be[Qe+1]:ge;for(Ue=lt-K+1,_e=lt;_e<ct;Ue++,_e++){let mt=Number.MIN_SAFE_INTEGER,$t=!1;_e<=st&&(mt=x(Ie,Pe,Qe,Oe,U,j,_e,ge,K,le[Ce-1][Ue-1]===0,tt));let We=0;mt!==Number.MAX_SAFE_INTEGER&&($t=!0,We=mt+_[Ce-1][Ue-1]);const je=_e>lt,ie=je?_[Ce][Ue-1]+(le[Ce][Ue-1]>0?-5:0):0,ee=_e>lt+1&&le[Ce][Ue-1]>0,Z=ee?_[Ce][Ue-2]+(le[Ce][Ue-2]>0?-5:0):0;if(ee&&(!je||Z>=ie)&&(!$t||Z>=We))_[Ce][Ue]=Z,ce[Ce][Ue]=Ee.LeftLeft,le[Ce][Ue]=0;else if(je&&(!$t||ie>=We))_[Ce][Ue]=ie,ce[Ce][Ue]=Ee.Left,le[Ce][Ue]=0;else if($t)_[Ce][Ue]=We,ce[Ce][Ue]=Ee.Diag,le[Ce][Ue]=le[Ce-1][Ue-1]+1;else throw new Error("not possible")}}if(me&&ke(Ie,Oe,U,K),!tt[0]&&!V.firstMatchCanBeWeak)return;Ce--,Ue--;const nt=[_[Ce][Ue],K];let et=0,rt=0;for(;Ce>=1;){let lt=Ue;do{const st=ce[Ce][lt];if(st===Ee.LeftLeft)lt=lt-2;else if(st===Ee.Left)lt=lt-1;else break}while(lt>=1);et>1&&Pe[Oe+Ce-1]===j[K+Ue-1]&&!B(lt+K-1,U,j)&&et+1>le[Ce][lt]&&(lt=Ue),lt===Ue?et++:et=1,rt||(rt=lt),Ce--,Ue=lt-1,nt.push(Ue)}ge-K===re&&V.boostFullMatch&&(nt[0]+=2);const ft=rt-re;return nt[0]-=ft,nt}function X(Ie,Pe,Oe,U,j,K){let V=Ie-1,re=Pe-1;for(;V>=Oe&&re>=U;)j[V]===K[re]&&(be[V]=re,V--),re--}function x(Ie,Pe,Oe,U,j,K,V,re,ge,Ce,Ue){if(Pe[Oe]!==K[V])return Number.MIN_SAFE_INTEGER;let Qe=1,_e=!1;return V===Oe-U?Qe=Ie[Oe]===j[V]?7:5:B(V,j,K)&&(V===0||!B(V-1,j,K))?(Qe=Ie[Oe]===j[V]?7:5,_e=!0):Te(K,V)&&(V===0||!Te(K,V-1))?Qe=5:(Te(K,V-1)||Y(K,V-1))&&(Qe=5,_e=!0),Qe>1&&Oe===U&&(Ue[0]=!0),_e||(_e=B(V,j,K)||Te(K,V-1)||Y(K,V-1)),Oe===U?V>ge&&(Qe-=_e?3:5):Ce?Qe+=_e?2:0:Qe+=_e?0:1,V+1===re&&(Qe-=_e?3:5),Qe}function $e(Ie,Pe,Oe,U,j,K,V){return Ae(Ie,Pe,Oe,U,j,K,!0,V)}function pe(Ie,Pe,Oe,U,j,K,V){return Ae(Ie,Pe,Oe,U,j,K,!1,V)}function Ae(Ie,Pe,Oe,U,j,K,V,re){let ge=he(Ie,Pe,Oe,U,j,K,re);if(ge&&!V)return ge;if(Ie.length>=3){const Ce=Math.min(7,Ie.length-1);for(let Ue=Oe+1;Ue<Ce;Ue++){const Qe=ze(Ie,Ue);if(Qe){const _e=he(Qe,Qe.toLowerCase(),Oe,U,j,K,re);_e&&(_e[0]-=3,(!ge||_e[0]>ge[0])&&(ge=_e))}}}return ge}function ze(Ie,Pe){if(Pe+1>=Ie.length)return;const Oe=Ie[Pe],U=Ie[Pe+1];if(Oe!==U)return Ie.slice(0,Pe)+U+Oe+Ie.slice(Pe+2)}}),define(Ne[98],Le([1,0,149,12,34]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=p,e.$Yk=I,e.$Zk=a,e.$1k=S,e.$2k=r,e.$3k=s;const O="$(",A=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${A.source}`,"g");function p(c){return c.replace(T,(l,i)=>i?l:`\\${l}`)}const o=new RegExp(`\\\\${A.source}`,"g");function I(c){return c.replace(o,l=>`\\${l}`)}const y=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function a(c){return c.indexOf(O)===-1?c:c.replace(y,(l,i,n,t)=>n?l:i||t||"")}function S(c){return c?c.replace(/\$\((.*?)\)/g,(l,i)=>` ${i} `).trim():""}const d=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(c){d.lastIndex=0;let l="";const i=[];let n=0;for(;;){const t=d.lastIndex,g=d.exec(c),u=c.substring(t,g?.index);if(u.length>0){l+=u;for(let $=0;$<u.length;$++)i.push(n)}if(!g)break;n+=g[0].length}return{text:l,iconOffsets:i}}function s(c,l,i=!1){const{text:n,iconOffsets:t}=l;if(!t||t.length===0)return(0,v.$Ok)(c,n,i);const g=(0,R.$mf)(n," "),u=n.length-g.length,$=(0,v.$Ok)(c,g,i);if($)for(const m of $){const h=t[m.start+u]+u;m.start+=h,m.end+=h}return $}}),define(Ne[35],Le([1,0,12]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v=qe(v);var R;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(R||(R={})),function(P){const O="error",A="warning",T="warn",p="info",o="ignore";function I(a){return a?v.$Ff(O,a)?P.Error:v.$Ff(A,a)||v.$Ff(T,a)?P.Warning:v.$Ff(p,a)?P.Info:P.Ignore:P.Ignore}P.fromValue=I;function y(a){switch(a){case P.Error:return O;case P.Warning:return A;case P.Info:return p;default:return o}}P.toString=y}(R||(R={})),e.default=R}),define(Ne[58],Le([1,0,17,27,12]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class O{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const r=d.charCodeAt(0),s=this.b.charCodeAt(this.c);return r-s}value(){return this.b[this.c]}}e.$Hi=O;class A{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===R.CharCode.Period)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,P.$zf)(d,this.b,0,d.length,this.c,this.d):(0,P.$Bf)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=A;class T{constructor(d=!0,r=!0){this.f=d,this.g=r}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let r=d.length-1;r>=0;r--,this.c--){const s=this.b.charCodeAt(r);if(!(s===R.CharCode.Slash||this.f&&s===R.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===R.CharCode.Slash||this.f&&r===R.CharCode.Backslash)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,P.$zf)(d,this.b,0,d.length,this.d,this.e):(0,P.$Bf)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=T;var p;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(p||(p={}));class o{constructor(d,r){this.f=d,this.g=r,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new T(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(p.Path)),this.g(d)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===p.Scheme)return(0,P.$Af)(d,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,P.$Af)(d,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(d);if(this.d[this.e]===p.Query)return(0,P.$yf)(d,this.c.query);if(this.d[this.e]===p.Fragment)return(0,P.$yf)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Ki=o;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(y||(y={}));class a{static forUris(d=()=>!1,r=()=>!1){return new a(new o(d,r))}static forPaths(d=!1){return new a(new T(void 0,!d))}static forStrings(){return new a(new O)}static forConfigKeys(){return new a(new A)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,r){if(r){const s=r.slice(0);(0,v.$Vb)(s);for(const c of s)this.set(c,d)}else{const s=d.slice(0);(0,v.$Vb)(s);for(const c of s)this.set(c[0],c[1])}}set(d,r){const s=this.b.reset(d);let c;this.c||(this.c=new I,this.c.segment=s.value());const l=[];for(c=this.c;;){const n=s.cmp(c.segment);if(n>0)c.left||(c.left=new I,c.left.segment=s.value()),l.push([y.Left,c]),c=c.left;else if(n<0)c.right||(c.right=new I,c.right.segment=s.value()),l.push([y.Right,c]),c=c.right;else if(s.hasNext())s.next(),c.mid||(c.mid=new I,c.mid.segment=s.value()),l.push([y.Mid,c]),c=c.mid;else break}const i=c.value;c.value=r,c.key=d;for(let n=l.length-1;n>=0;n--){const t=l[n][1];t.updateHeight();const g=t.balanceFactor();if(g<-1||g>1){const u=l[n][0],$=l[n+1][0];if(u===y.Right&&$===y.Right)l[n][1]=t.rotateLeft();else if(u===y.Left&&$===y.Left)l[n][1]=t.rotateRight();else if(u===y.Right&&$===y.Left)t.right=l[n+1][1]=l[n+1][1].rotateRight(),l[n][1]=t.rotateLeft();else if(u===y.Left&&$===y.Right)t.left=l[n+1][1]=l[n+1][1].rotateLeft(),l[n][1]=t.rotateRight();else throw new Error;if(n>0)switch(l[n-1][0]){case y.Left:l[n-1][1].left=l[n][1];break;case y.Right:l[n-1][1].right=l[n][1];break;case y.Mid:l[n-1][1].mid=l[n][1];break}else this.c=l[0][1]}}return i}get(d){return this.d(d)?.value}d(d){const r=this.b.reset(d);let s=this.c;for(;s;){const c=r.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else break}return s}has(d){const r=this.d(d);return!(r?.value===void 0&&r?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,r){const s=this.b.reset(d),c=[];let l=this.c;for(;l;){const i=s.cmp(l.segment);if(i>0)c.push([y.Left,l]),l=l.left;else if(i<0)c.push([y.Right,l]),l=l.right;else if(s.hasNext())s.next(),c.push([y.Mid,l]),l=l.mid;else break}if(l){if(r?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const i=this.f(l.right);if(i.key){const{key:n,value:t,segment:g}=i;this.e(i.key,!1),l.key=n,l.value=t,l.segment=g}}else{const i=l.left??l.right;if(c.length>0){const[n,t]=c[c.length-1];switch(n){case y.Left:t.left=i;break;case y.Mid:t.mid=i;break;case y.Right:t.right=i;break}}else this.c=i}for(let i=c.length-1;i>=0;i--){const n=c[i][1];n.updateHeight();const t=n.balanceFactor();if(t>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),c[i][1]=n.rotateLeft()):t<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),c[i][1]=n.rotateRight()),i>0)switch(c[i-1][0]){case y.Left:c[i-1][1].left=c[i][1];break;case y.Right:c[i-1][1].right=c[i][1];break;case y.Mid:c[i-1][1].mid=c[i][1];break}else this.c=c[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const r=this.b.reset(d);let s=this.c,c;for(;s;){const l=r.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(r.hasNext())r.next(),c=s.value||c,s=s.mid;else break}return s&&s.value||c}findSuperstr(d){return this.g(d,!1)}g(d,r){const s=this.b.reset(d);let c=this.c;for(;c;){const l=s.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this.h(c.mid):r?c.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[r,s]of this)d(s,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const r=[];return this.j(d,r),r[Symbol.iterator]()}j(d,r){d&&(d.left&&this.j(d.left,r),d.value&&r.push([d.key,d.value]),d.mid&&this.j(d.mid,r),d.right&&this.j(d.right,r))}_isBalanced(){const d=r=>{if(!r)return!0;const s=r.balanceFactor();return s<-1||s>1?!1:d(r.left)&&d(r.right)};return d(this.c)}}e.$Li=a}),define(Ne[36],Le([1,0,22,2,37]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=O,e.$bi=A,e.$ci=p;function O(o){return JSON.stringify(o,T)}function A(o){let I=JSON.parse(o);return I=p(I),I}function T(o,I){return I instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function p(o,I=0){if(!o||I>200)return o;if(typeof o=="object"){switch(o.$mid){case P.MarshalledId.Uri:return R.URI.revive(o);case P.MarshalledId.Regexp:return new RegExp(o.source,o.flags);case P.MarshalledId.Date:return new Date(o.source)}if(o instanceof v.$Ne||o instanceof Uint8Array)return o;if(Array.isArray(o))for(let y=0;y<o.length;++y)o[y]=p(o[y],I+1);else for(const y in o)Object.hasOwnProperty.call(o,y)&&(o[y]=p(o[y],I+1))}return o}}),define(Ne[15],Le([1,0,13,20,12,2,19]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=p,e.$Pg=o,e.$Tg=y,v=qe(v),R=qe(R),A=qe(A);var T;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",d.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(T||(e.Schemas=T={}));function p(d,r){return O.URI.isUri(d)?(0,P.$Ff)(d.scheme,r):(0,P.$Gf)(d,r+":")}function o(d,...r){return r.some(s=>p(d,s))}e.$Qg="vscode-tkn",e.$Rg="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,s){this.f=y(r,s)}getServerRootPath(){return this.f}get g(){return A.$gc.join(this.f,T.vscodeRemoteResource)}set(r,s,c){this.a[r]=s,this.b[r]=c}setConnectionToken(r,s){this.c[r]=s}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(t){return v.$Y(t),r}const s=r.authority;let c=this.a[s];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const l=this.b[s],i=this.c[s];let n=`path=${encodeURIComponent(r.path)}`;return typeof i=="string"&&(n+=`&${e.$Rg}=${encodeURIComponent(i)}`),O.URI.from({scheme:R.$p?this.d:T.vscodeRemoteResource,authority:`${c}:${l}`,path:this.g,query:n})}}e.$Sg=new I;function y(d,r){return A.$gc.join(r??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class a{static{this.a=e.$Yg}asBrowserUri(r){const s=this.b(r,ve);return this.uriToBrowserUri(s)}uriToBrowserUri(r){return r.scheme===T.vscodeRemote?e.$Sg.rewrite(r):r.scheme===T.file&&(R.$n||R.$r===`${T.vscodeFileResource}://${a.a}`)?r.with({scheme:T.vscodeFileResource,authority:r.authority||a.a,query:null,fragment:null}):r}asFileUri(r){const s=this.b(r,ve);return this.uriToFileUri(s)}uriToFileUri(r){return r.scheme===T.vscodeFileResource?r.with({scheme:T.file,authority:r.authority!==a.a?r.authority:null,query:null,fragment:null}):r}b(r,s){return O.URI.isUri(r)?r:O.URI.parse(s.toUrl(r))}}e.$Zg=new a;var S;(function(d){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(r.get("3"));const s="vscode-coi";function c(i){let n;typeof i=="string"?n=new URL(i).searchParams:i instanceof URL?n=i.searchParams:O.URI.isUri(i)&&(n=new URL(i.toString(!0)).searchParams);const t=n?.get(s);if(t)return r.get(t)}d.getHeadersFromQuery=c;function l(i,n,t){if(!globalThis.crossOriginIsolated)return;const g=n&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(s,g):i[s]=g}d.addSearchParam=l})(S||(e.COI=S={}))}),define(Ne[23],Le([1,0,27,51,15,19,20,12,2]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=o,e.$ph=y,e.$qh=S,R=qe(R),O=qe(O);function o(d){return(0,p.$wc)(d,!0)}class I{constructor(r){this.a=r}compare(r,s,c=!1){return r===s?0:(0,T.$yf)(this.getComparisonKey(r,c),this.getComparisonKey(s,c))}isEqual(r,s,c=!1){return r===s?!0:!r||!s?!1:this.getComparisonKey(r,c)===this.getComparisonKey(s,c)}getComparisonKey(r,s=!1){return r.with({path:this.a(r)?r.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(r){return this.a(r)}isEqualOrParent(r,s,c=!1){if(r.scheme===s.scheme){if(r.scheme===P.Schemas.file)return R.$Eg(o(r),o(s),this.a(r))&&r.query===s.query&&(c||r.fragment===s.fragment);if((0,e.$lh)(r.authority,s.authority))return R.$Eg(r.path,s.path,this.a(r),"/")&&r.query===s.query&&(c||r.fragment===s.fragment)}return!1}joinPath(r,...s){return p.URI.joinPath(r,...s)}basenameOrAuthority(r){return(0,e.$dh)(r)||r.authority}basename(r){return O.$gc.basename(r.path)}extname(r){return O.$gc.extname(r.path)}dirname(r){if(r.path.length===0)return r;let s;return r.scheme===P.Schemas.file?s=p.URI.file(O.$mc(o(r))).path:(s=O.$gc.dirname(r.path),r.authority&&s.length&&s.charCodeAt(0)!==v.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),s="/")),r.with({path:s})}normalizePath(r){if(!r.path.length)return r;let s;return r.scheme===P.Schemas.file?s=p.URI.file(O.$hc(o(r))).path:s=O.$gc.normalize(r.path),r.with({path:s})}relativePath(r,s){if(r.scheme!==s.scheme||!(0,e.$lh)(r.authority,s.authority))return;if(r.scheme===P.Schemas.file){const i=O.$lc(o(r),o(s));return A.$j?R.$yg(i):i}let c=r.path||"/";const l=s.path||"/";if(this.a(r)){let i=0;for(const n=Math.min(c.length,l.length);i<n&&!(c.charCodeAt(i)!==l.charCodeAt(i)&&c.charAt(i).toLowerCase()!==l.charAt(i).toLowerCase());i++);c=l.substr(0,i)+c.substr(i)}return O.$gc.relative(c,l)}resolvePath(r,s){if(r.scheme===P.Schemas.file){const c=p.URI.file(O.$kc(o(r),s));return r.with({authority:c.authority,path:c.path})}return s=R.$zg(s),r.with({path:O.$gc.resolve(r.path,s)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,s){return r===s||r!==void 0&&s!==void 0&&(0,T.$Ff)(r,s)}hasTrailingPathSeparator(r,s=O.sep){if(r.scheme===P.Schemas.file){const c=o(r);return c.length>R.$Ag(c).length&&c[c.length-1]===s}else{const c=r.path;return c.length>1&&c.charCodeAt(c.length-1)===v.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,s=O.sep){return(0,e.$mh)(r,s)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,s=O.sep){let c=!1;if(r.scheme===P.Schemas.file){const l=o(r);c=l!==void 0&&l.length===R.$Ag(l).length&&l[l.length-1]===s}else{s="/";const l=r.path;c=l.length===1&&l.charCodeAt(l.length-1)===v.CharCode.Slash}return!c&&!(0,e.$mh)(r,s)?r.with({path:r.path+"/"}):r}}e.$8g=I,e.$9g=new I(()=>!1),e.$0g=new I(d=>d.scheme===P.Schemas.file?!A.$l:!0),e.$$g=new I(d=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function y(d,r){const s=[];for(let c=0;c<d.length;c++){const l=r(d[c]);d.some((i,n)=>n===c?!1:(0,e.$ah)(l,r(i)))||s.push(d[c])}return s}var a;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function r(s){const c=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(n=>{const[t,g]=n.split(":");t&&g&&c.set(t,g)});const i=s.path.substring(0,s.path.indexOf(";"));return i&&c.set(d.META_DATA_MIME,i),c}d.parseMetaData=r})(a||(e.DataUri=a={}));function S(d,r,s){if(r){let c=d.path;return c&&c[0]!==O.$gc.sep&&(c=O.$gc.sep+c),d.with({scheme:s,authority:r,path:c})}return d.with({scheme:s})}}),define(Ne[10],Le([1,0,21,13,6,4,23,20,148,48]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=I,e.$sh=y,e.$th=a,e.$uh=S,e.$vh=d,e.$wh=r,e.$xh=s,e.$yh=c,e.$Gh=E,e.$Hh=D,e.$Ih=b,e.$Jh=C,e.$Kh=k,e.$Zh=le,e.$8h=fe;function I(he){return!!he&&typeof he.then=="function"}function y(he){const X=new v.$we,x=he(X.token),$e=new Promise((pe,Ae)=>{const ze=X.token.onCancellationRequested(()=>{ze.dispose(),Ae(new R.$4)});Promise.resolve(x).then(Ie=>{ze.dispose(),X.dispose(),pe(Ie)},Ie=>{ze.dispose(),X.dispose(),Ae(Ie)})});return new class{cancel(){X.cancel(),X.dispose()}then(pe,Ae){return $e.then(pe,Ae)}catch(pe){return this.then(void 0,pe)}finally(pe){return $e.finally(pe)}}}function a(he,X,x){return new Promise(($e,pe)=>{const Ae=X.onCancellationRequested(()=>{Ae.dispose(),$e(x)});he.then($e,pe).finally(()=>Ae.dispose())})}function S(he,X){return new Promise((x,$e)=>{const pe=X.onCancellationRequested(()=>{pe.dispose(),$e(new R.$4)});he.then(x,$e).finally(()=>pe.dispose())})}async function d(he){let X=-1;const x=he.map(($e,pe)=>$e.then(Ae=>(X=pe,Ae)));try{return await Promise.race(x)}finally{he.forEach(($e,pe)=>{pe!==X&&$e.cancel()})}}function r(he,X,x){let $e;const pe=setTimeout(()=>{$e?.(void 0),x?.()},X);return Promise.race([he.finally(()=>clearTimeout(pe)),new Promise(Ae=>$e=Ae)])}function s(he){return new Promise((X,x)=>{const $e=he();I($e)?$e.then(X,x):X($e)})}function c(){let he,X;return{promise:new Promise(($e,pe)=>{he=$e,X=pe}),resolve:he,reject:X}}class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const x=()=>{if(this.b=null,this.f)return;const $e=this.queue(this.d);return this.d=null,$e};this.b=new Promise($e=>{this.a.then(x,x).then($e)})}return new Promise((x,$e)=>{this.b.then(x,$e)})}return this.a=X(),new Promise((x,$e)=>{this.a.then(pe=>{this.a=null,x(pe)},pe=>{this.a=null,$e(pe)})})}dispose(){this.f=!0}}e.$zh=l;class i{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$Ah=i;class n{constructor(){this.a=new Map}queue(X,x){const pe=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.a.get(X)===pe&&this.a.delete(X)});return this.a.set(X,pe),pe}}e.$Bh=n;const t=(he,X)=>{let x=!0;const $e=setTimeout(()=>{x=!1,X()},he);return{isTriggered:()=>x,dispose:()=>{clearTimeout($e),x=!1}}},g=he=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,he())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class u{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,x=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((pe,Ae)=>{this.d=pe,this.f=Ae}).then(()=>{if(this.b=null,this.d=null,this.g){const pe=this.g;return this.g=null,pe()}}));const $e=()=>{this.a=null,this.d?.(null)};return this.a=x===p.$ge?g($e):t(x,$e),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=u;class ${constructor(X){this.a=new u(X),this.b=new l}trigger(X,x){return this.a.trigger(()=>this.b.queue(X),x)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=$;class m{constructor(){this.a=!1,this.b=new Promise((X,x)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=m;class h extends m{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$Fh=h;function E(he,X){return X?new Promise((x,$e)=>{const pe=setTimeout(()=>{Ae.dispose(),x()},he),Ae=X.onCancellationRequested(()=>{clearTimeout(pe),Ae.dispose(),$e(new R.$4)})}):y(x=>E(he,x))}function D(he,X=0,x){const $e=setTimeout(()=>{he(),x&&pe.dispose()},X),pe=(0,O.$Sc)(()=>{clearTimeout($e),x?.deleteAndLeak(pe)});return x?.add(pe),pe}function b(he){const X=[];let x=0;const $e=he.length;function pe(){return x<$e?he[x++]():null}function Ae(ze){ze!=null&&X.push(ze);const Ie=pe();return Ie?Ie.then(Ae):Promise.resolve(X)}return Promise.resolve(null).then(Ae)}function C(he,X=$e=>!!$e,x=null){let $e=0;const pe=he.length,Ae=()=>{if($e>=pe)return Promise.resolve(x);const ze=he[$e++];return Promise.resolve(ze()).then(Pe=>X(Pe)?Promise.resolve(Pe):Ae())};return Ae()}function k(he,X=$e=>!!$e,x=null){if(he.length===0)return Promise.resolve(x);let $e=he.length;const pe=()=>{$e=-1;for(const Ae of he)Ae.cancel?.()};return new Promise((Ae,ze)=>{for(const Ie of he)Ie.then(Pe=>{--$e>=0&&X(Pe)?(pe(),Ae(Pe)):$e===0&&Ae(x)}).catch(Pe=>{--$e>=0&&(pe(),ze(Pe))})})}class f{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new P.$le}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((x,$e)=>{this.g.push({factory:X,c:x,e:$e}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const x=X.factory();x.then(X.c,X.e),x.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=f;class w extends f{constructor(){super(1)}}e.$Mh=w;class F{constructor(){this.a=new _,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Nh=F;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new oe;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,x=A.$9g){const $e=x.getComparisonKey(X);return this.a.get($e)?.size??0}queueFor(X,x,$e=A.$9g){const pe=$e.getComparisonKey(X);let Ae=this.a.get(pe);if(!Ae){Ae=new w;const ze=this.f++,Ie=P.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(pe),this.h(),this.d?.deleteAndDispose(ze),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$4c),this.d.set(ze,Ie),this.a.set(pe,Ae)}return Ae.queue(x)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=N;class L{constructor(X,x){this.b=!1,this.a=-1,typeof X=="function"&&typeof x=="number"&&this.setIfNotSet(X,x)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,x){if(this.b)throw new R.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},x)}setIfNotSet(X,x){if(this.b)throw new R.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},x))}}e.$Ph=L;class q{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,x,$e=globalThis){if(this.f)throw new R.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const pe=$e.setInterval(()=>{X()},x);this.d=(0,O.$Sc)(()=>{$e.clearInterval(pe),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=q;class H{constructor(X,x){this.b=-1,this.a=X,this.d=x,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=H;class W{constructor(X,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.a=X,this.b=x,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=W;class G extends H{constructor(X,x){super(X,x),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Th=G;class Q extends O.$Uc{constructor(X,x){super(),this.g=X,this.h=x,this.a=[],this.b=this.B(new O.$Vc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const x of X)this.a.push(x);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new H(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=Q,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(he,X)=>{(0,T.$C)(()=>{if(x)return;const $e=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$e-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.$Wh=(he,X,x)=>{const $e=he.requestIdleCallback(X,typeof x=="number"?{timeout:x}:void 0);let pe=!1;return{dispose(){pe||(pe=!0,he.cancelIdleCallback($e))}}},e.$Vh=he=>(0,e.$Wh)(globalThis,he)}();class ae{constructor(X,x){this.g=!1,this.d=()=>{try{this.j=x()}catch($e){this.l=$e}finally{this.g=!0}},this.f=(0,e.$Wh)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=ae;class be extends ae{constructor(X){super(globalThis,X)}}e.$Yh=be;async function le(he,X,x){let $e;for(let pe=0;pe<x;pe++)try{return await he()}catch(Ae){$e=Ae,await E(X)}throw $e}class _{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,x,$e){return this.a={taskId:X,cancel:()=>$e?.(),promise:x},x.then(()=>this.d(X),()=>this.d(X)),x}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:x,resolve:$e,reject:pe}=c();this.b={run:X,promise:x,promiseResolve:$e,promiseReject:pe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=_;class ce{constructor(X,x=()=>Date.now()){this.d=X,this.f=x,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$2h=ce;var me;(function(he){he[he.Resolved=0]="Resolved",he[he.Rejected=1]="Rejected"})(me||(me={}));class oe{get isRejected(){return this.d?.outcome===me.Rejected}get isResolved(){return this.d?.outcome===me.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===me.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((X,x)=>{this.a=X,this.b=x})}complete(X){return new Promise(x=>{this.a(X),this.d={outcome:me.Resolved,value:X},x()})}error(X){return new Promise(x=>{this.b(X),this.d={outcome:me.Rejected,value:X},x()})}cancel(){return this.error(new R.$4)}}e.$3h=oe;var ke;(function(he){async function X($e){let pe;const Ae=await Promise.all($e.map(ze=>ze.then(Ie=>Ie,Ie=>{pe||(pe=Ie)})));if(typeof pe<"u")throw pe;return Ae}he.settled=X;function x($e){return new Promise(async(pe,Ae)=>{try{await $e(pe,Ae)}catch(ze){Ae(ze)}})}he.withAsyncBody=x})(ke||(e.Promises=ke={}));class Te{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(x=>(this.a=x,this.d=!0,x),x=>{throw this.b=x,this.d=!0,x})}requireValue(){if(!this.d)throw new R.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=Te;class Y{constructor(X){this.b=X,this.a=new o.$T(()=>new Te(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=Y;var B;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(B||(B={}));class ne{static fromArray(X){return new ne(x=>{x.emitMany(X)})}static fromPromise(X){return new ne(async x=>{x.emitMany(await X)})}static fromPromises(X){return new ne(async x=>{await Promise.all(X.map(async $e=>x.emitOne(await $e)))})}static merge(X){return new ne(async x=>{await Promise.all(X.map(async $e=>{for await(const pe of $e)x.emitOne(pe)}))})}static{this.EMPTY=ne.fromArray([])}constructor(X,x){this.a=B.Initial,this.b=[],this.d=null,this.f=x,this.g=new P.$le,queueMicrotask(async()=>{const $e={emitOne:pe=>this.h(pe),emitMany:pe=>this.j(pe),reject:pe=>this.l(pe)};try{await Promise.resolve(X($e)),this.k()}catch(pe){this.l(pe)}finally{$e.emitOne=void 0,$e.emitMany=void 0,$e.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===B.DoneError)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===B.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,x){return new ne(async $e=>{for await(const pe of X)$e.emitOne(x(pe))})}map(X){return ne.map(this,X)}static filter(X,x){return new ne(async $e=>{for await(const pe of X)x(pe)&&$e.emitOne(pe)})}filter(X){return ne.filter(this,X)}static coalesce(X){return ne.filter(X,x=>!!x)}coalesce(){return ne.coalesce(this)}static async toPromise(X){const x=[];for await(const $e of X)x.push($e);return x}toPromise(){return ne.toPromise(this)}h(X){this.a===B.Initial&&(this.b.push(X),this.g.fire())}j(X){this.a===B.Initial&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===B.Initial&&(this.a=B.DoneOK,this.g.fire())}l(X){this.a===B.Initial&&(this.a=B.DoneError,this.d=X,this.g.fire())}}e.$6h=ne;class Ee extends ne{constructor(X,x){super(x),this.m=X}cancel(){this.m.cancel()}}e.$7h=Ee;function fe(he){const X=new v.$we,x=he(X.token);return new Ee(X,async $e=>{const pe=X.token.onCancellationRequested(()=>{pe.dispose(),X.dispose(),$e.reject(new R.$4)});try{for await(const Ae of x){if(X.token.isCancellationRequested)return;$e.emitOne(Ae)}pe.dispose(),X.dispose()}catch(Ae){pe.dispose(),X.dispose(),$e.reject(Ae)}})}class we{constructor(X){this.a=new oe,this.b=new ne(pe=>{if(x){pe.reject(x);return}return $e&&pe.emitMany($e),this.d=Ae=>pe.reject(Ae),this.f=Ae=>pe.emitOne(Ae),this.a.p},X);let x,$e;this.f=pe=>{$e||($e=[]),$e.push(pe)},this.d=pe=>{x||(x=pe)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$9h=we}),define(Ne[41],Le([1,0,17,10,27,51,28,19,20,12]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$vk=I,e.$yk=r,e.$zk=F,e.$Ak=N,e.$Bk=L,e.$Ck=q,e.$Dk=H,e.$Ek=ae;function I(){return Object.create(null)}e.$wk="**",e.$xk="/";const y="[/\\\\]",a="[^/\\\\]",S=/\//g;function d(be,le){switch(be){case 0:return"";case 1:return`${a}*?`;default:return`(?:${y}|${a}+${y}${le?`|${y}${a}+`:""})*?`}}function r(be,le){if(!be)return[];const _=[];let ce=!1,me=!1,oe="";for(const ke of be){switch(ke){case le:if(!ce&&!me){_.push(oe),oe="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":me=!0;break;case"]":me=!1;break}oe+=ke}return oe&&_.push(oe),_}function s(be){if(!be)return"";let le="";const _=r(be,e.$xk);if(_.every(ce=>ce===e.$wk))le=".*";else{let ce=!1;_.forEach((me,oe)=>{if(me===e.$wk){if(ce)return;le+=d(2,oe===_.length-1)}else{let ke=!1,Te="",Y=!1,B="";for(const ne of me){if(ne!=="}"&&ke){Te+=ne;continue}if(Y&&(ne!=="]"||!B)){let Ee;ne==="-"?Ee=ne:(ne==="^"||ne==="!")&&!B?Ee="^":ne===e.$xk?Ee="":Ee=(0,o.$hf)(ne),B+=Ee;continue}switch(ne){case"{":ke=!0;continue;case"[":Y=!0;continue;case"}":{const fe=`(?:${r(Te,",").map(we=>s(we)).join("|")})`;le+=fe,ke=!1,Te="";break}case"]":{le+="["+B+"]",Y=!1,B="";break}case"?":le+=a;continue;case"*":le+=d(1);continue;default:le+=(0,o.$hf)(ne)}}oe<_.length-1&&(_[oe+1]!==e.$wk||oe+2<_.length)&&(le+=y)}ce=me===e.$wk})}return le}const c=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,u=new A.$Dc(1e4),$=function(){return!1},m=function(){return null};function h(be,le){if(!be)return m;let _;typeof be!="string"?_=be.pattern:_=be,_=_.trim();const ce=`${_}_${!!le.trimForExclusions}`;let me=u.get(ce);if(me)return E(me,be);let oe;return c.test(_)?me=b(_.substr(4),_):(oe=l.exec(D(_,le)))?me=C(oe[1],_):(le.trimForExclusions?n:i).test(_)?me=k(_,le):(oe=t.exec(D(_,le)))?me=f(oe[1].substr(1),_,!0):(oe=g.exec(D(_,le)))?me=f(oe[1],_,!1):me=w(_),u.set(ce,me),E(me,be)}function E(be,le){if(typeof le=="string")return be;const _=function(ce,me){return(0,O.$Eg)(ce,le.base,!p.$l)?be((0,o.$mf)(ce.substr(le.base.length),T.sep),me):null};return _.allBasenames=be.allBasenames,_.allPaths=be.allPaths,_.basenames=be.basenames,_.patterns=be.patterns,_}function D(be,le){return le.trimForExclusions&&be.endsWith("/**")?be.substr(0,be.length-2):be}function b(be,le){return function(_,ce){return typeof _=="string"&&_.endsWith(be)?le:null}}function C(be,le){const _=`/${be}`,ce=`\\${be}`,me=function(ke,Te){return typeof ke!="string"?null:Te?Te===be?le:null:ke===be||ke.endsWith(_)||ke.endsWith(ce)?le:null},oe=[be];return me.basenames=oe,me.patterns=[le],me.allBasenames=oe,me}function k(be,le){const _=Q(be.slice(1,-1).split(",").map(Te=>h(Te,le)).filter(Te=>Te!==m),be),ce=_.length;if(!ce)return m;if(ce===1)return _[0];const me=function(Te,Y){for(let B=0,ne=_.length;B<ne;B++)if(_[B](Te,Y))return be;return null},oe=_.find(Te=>!!Te.allBasenames);oe&&(me.allBasenames=oe.allBasenames);const ke=_.reduce((Te,Y)=>Y.allPaths?Te.concat(Y.allPaths):Te,[]);return ke.length&&(me.allPaths=ke),me}function f(be,le,_){const ce=T.sep===T.$gc.sep,me=ce?be:be.replace(S,T.sep),oe=T.sep+me,ke=T.$gc.sep+be;let Te;return _?Te=function(Y,B){return typeof Y=="string"&&(Y===me||Y.endsWith(oe)||!ce&&(Y===be||Y.endsWith(ke)))?le:null}:Te=function(Y,B){return typeof Y=="string"&&(Y===me||!ce&&Y===be)?le:null},Te.allPaths=[(_?"*/":"./")+be],Te}function w(be){try{const le=new RegExp(`^${s(be)}$`);return function(_){return le.lastIndex=0,typeof _=="string"&&le.test(_)?be:null}}catch{return m}}function F(be,le,_){return!be||typeof le!="string"?!1:N(be)(le,void 0,_)}function N(be,le={}){if(!be)return $;if(typeof be=="string"||L(be)){const _=h(be,le);if(_===m)return $;const ce=function(me,oe){return!!_(me,oe)};return _.allBasenames&&(ce.allBasenames=_.allBasenames),_.allPaths&&(ce.allPaths=_.allPaths),ce}return W(be,le)}function L(be){const le=be;return le?typeof le.base=="string"&&typeof le.pattern=="string":!1}function q(be){return be.allBasenames||[]}function H(be){return be.allPaths||[]}function W(be,le){const _=Q(Object.getOwnPropertyNames(be).map(Te=>G(Te,be[Te],le)).filter(Te=>Te!==m)),ce=_.length;if(!ce)return m;if(!_.some(Te=>!!Te.requiresSiblings)){if(ce===1)return _[0];const Te=function(ne,Ee){let fe;for(let we=0,he=_.length;we<he;we++){const X=_[we](ne,Ee);if(typeof X=="string")return X;(0,R.$rh)(X)&&(fe||(fe=[]),fe.push(X))}return fe?(async()=>{for(const we of fe){const he=await we;if(typeof he=="string")return he}return null})():null},Y=_.find(ne=>!!ne.allBasenames);Y&&(Te.allBasenames=Y.allBasenames);const B=_.reduce((ne,Ee)=>Ee.allPaths?ne.concat(Ee.allPaths):ne,[]);return B.length&&(Te.allPaths=B),Te}const me=function(Te,Y,B){let ne,Ee;for(let fe=0,we=_.length;fe<we;fe++){const he=_[fe];he.requiresSiblings&&B&&(Y||(Y=(0,T.$nc)(Te)),ne||(ne=Y.substr(0,Y.length-(0,T.$oc)(Te).length)));const X=he(Te,Y,ne,B);if(typeof X=="string")return X;(0,R.$rh)(X)&&(Ee||(Ee=[]),Ee.push(X))}return Ee?(async()=>{for(const fe of Ee){const we=await fe;if(typeof we=="string")return we}return null})():null},oe=_.find(Te=>!!Te.allBasenames);oe&&(me.allBasenames=oe.allBasenames);const ke=_.reduce((Te,Y)=>Y.allPaths?Te.concat(Y.allPaths):Te,[]);return ke.length&&(me.allPaths=ke),me}function G(be,le,_){if(le===!1)return m;const ce=h(be,_);if(ce===m)return m;if(typeof le=="boolean")return ce;if(le){const me=le.when;if(typeof me=="string"){const oe=(ke,Te,Y,B)=>{if(!B||!ce(ke,Te))return null;const ne=me.replace("$(basename)",()=>Y),Ee=B(ne);return(0,R.$rh)(Ee)?Ee.then(fe=>fe?be:null):Ee?be:null};return oe.requiresSiblings=!0,oe}}return ce}function Q(be,le){const _=be.filter(Te=>!!Te.basenames);if(_.length<2)return be;const ce=_.reduce((Te,Y)=>{const B=Y.basenames;return B?Te.concat(B):Te},[]);let me;if(le){me=[];for(let Te=0,Y=ce.length;Te<Y;Te++)me.push(le)}else me=_.reduce((Te,Y)=>{const B=Y.patterns;return B?Te.concat(B):Te},[]);const oe=function(Te,Y){if(typeof Te!="string")return null;if(!Y){let ne;for(ne=Te.length;ne>0;ne--){const Ee=Te.charCodeAt(ne-1);if(Ee===P.CharCode.Slash||Ee===P.CharCode.Backslash)break}Y=Te.substr(ne)}const B=ce.indexOf(Y);return B!==-1?me[B]:null};oe.basenames=ce,oe.patterns=me,oe.allBasenames=ce;const ke=be.filter(Te=>!Te.basenames);return ke.push(oe),ke}function ae(be,le){return(0,v.$tb)(be,le,(_,ce)=>typeof _=="string"&&typeof ce=="string"?_===ce:typeof _!="string"&&typeof ce!="string"?_.base===ce.base&&_.pattern===ce.pattern:!1)}}),define(Ne[59],Le([1,0,13,98,23,12,2]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.MarkdownStringTextNewlineStyle=void 0,e.$5k=o,e.$6k=I,e.$7k=y,e.$8k=a,e.$9k=S,e.$0k=d,e.$$k=r,e.$_k=s;var T;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class p{constructor(l="",i=!1){if(this.value=l,typeof this.value!="string")throw(0,v.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(l,i=T.Paragraph){return this.value+=a(this.supportThemeIcons?(0,R.$Xk)(l):l).replace(/([ \t]+)/g,(n,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===T.Break?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,i){return this.value+=`
${S(i,l)}
`,this}appendLink(l,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(l),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(l,i){const n=new RegExp((0,O.$hf)(i),"g");return l.replace(n,(t,g)=>l.charAt(g-1)!=="\\"?`\\${t}`:t)}}e.$4k=p;function o(c){return I(c)?!c.value:Array.isArray(c)?c.every(o):!0}function I(c){return c instanceof p?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}function y(c,l){return c===l?!0:!c||!l?!1:c.value===l.value&&c.isTrusted===l.isTrusted&&c.supportThemeIcons===l.supportThemeIcons&&c.supportHtml===l.supportHtml&&(c.baseUri===l.baseUri||!!c.baseUri&&!!l.baseUri&&(0,P.$_g)(A.URI.from(c.baseUri),A.URI.from(l.baseUri)))}function a(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function S(c,l){const i=c.match(/^`+/gm)?.reduce((t,g)=>t.length>g.length?t:g).length??0,n=i>=3?i+1:3;return[`${"`".repeat(n)}${l}`,c,`${"`".repeat(n)}`].join(`
`)}function d(c){return c.replace(/"/g,"&quot;")}function r(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function s(c){const l=[],i=c.split("|").map(t=>t.trim());c=i[0];const n=i[1];if(n){const t=/height=(\d+)/.exec(n),g=/width=(\d+)/.exec(n),u=t?t[1]:"",$=g?g[1]:"",m=isFinite(parseInt($)),h=isFinite(parseInt(u));m&&l.push(`width="${$}"`),h&&l.push(`height="${u}"`)}return{href:c,dimensions:l}}}),define(Ne[99],Le([1,0,17,51,19,20,23,12]),function(ve,e,v,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zw=p,e.$1w=I,e.$2w=a,e.$3w=S,e.$4w=c,e.$5w=i,e.$6w=n,e.$7w=t,e.$8w=g,e.$9w=u;function p(m,h){const{os:E,tildify:D,relative:b}=h;if(b){const f=o(m,b,E);if(typeof f=="string")return f}let C=m.fsPath;if(E===O.OperatingSystem.Windows&&!O.$j?C=C.replace(/\//g,"\\"):E!==O.OperatingSystem.Windows&&O.$j&&(C=C.replace(/\\/g,"/")),E!==O.OperatingSystem.Windows&&D?.userHome){const f=D.userHome.fsPath;let w;m.scheme!==D.userHome.scheme&&m.path[0]===P.$gc.sep&&m.path[1]!==P.$gc.sep?w=D.userHome.with({path:m.path}).fsPath:w=C,C=a(w,f,E)}return(E===O.OperatingSystem.Windows?P.$fc:P.$gc).normalize(I(C,E===O.OperatingSystem.Windows))}function o(m,h,E){const D=E===O.OperatingSystem.Windows?P.$fc:P.$gc,b=E===O.OperatingSystem.Linux?A.$9g:A.$$g,C=h.getWorkspace(),k=(0,v.$Nb)(C.folders);if(!k)return;m.scheme!==k.uri.scheme&&m.path[0]===P.$gc.sep&&m.path[1]!==P.$gc.sep&&(m=k.uri.with({path:m.path}));const f=h.getWorkspaceFolder(m);if(!f)return;let w;if(b.isEqual(f.uri,m)?w="":w=b.relativePath(f.uri,m)??"",w&&(w=D.normalize(w)),C.folders.length>1&&!h.noPrefix){const F=f.name?f.name:b.basenameOrAuthority(f.uri);w=w?`${F} \u2022 ${w}`:F}return w}function I(m,h=O.$j){return(0,R.$Jg)(m,h)?m.charAt(0).toUpperCase()+m.slice(1):m}let y=Object.create(null);function a(m,h,E=O.OS){if(E===O.OperatingSystem.Windows||!m||!h)return m;let D=y.original===h?y.normalized:void 0;D||(D=h,O.$j&&(D=(0,R.$yg)(D)),D=`${(0,T.$nf)(D,P.$gc.sep)}${P.$gc.sep}`,y={original:h,normalized:D});let b=m;return O.$j&&(b=(0,R.$yg)(b)),(E===O.OperatingSystem.Linux?b.startsWith(D):(0,T.$Gf)(b,D))?`~/${b.substr(D.length)}`:m}function S(m,h){return m.replace(/^~($|\/|\\)/,`${h}$1`)}const d="\u2026",r="\\\\",s="~";function c(m,h=P.sep){const E=new Array(m.length);let D=!1;for(let b=0;b<m.length;b++){const C=m[b];if(C===""){E[b]=`.${h}`;continue}if(!C){E[b]=C;continue}D=!0;let k="",f=C;f.indexOf(r)===0?(k=f.substr(0,f.indexOf(r)+r.length),f=f.substr(f.indexOf(r)+r.length)):f.indexOf(h)===0?(k=f.substr(0,f.indexOf(h)+h.length),f=f.substr(f.indexOf(h)+h.length)):f.indexOf(s)===0&&(k=f.substr(0,f.indexOf(s)+s.length),f=f.substr(f.indexOf(s)+s.length));const w=f.split(h);for(let F=1;D&&F<=w.length;F++)for(let N=w.length-F;D&&N>=0;N--){D=!1;let L=w.slice(N,N+F).join(h);for(let q=0;!D&&q<m.length;q++)if(q!==b&&m[q]&&m[q].indexOf(L)>-1){const H=N+F===w.length,W=N>0&&m[q].indexOf(h)>-1?h+L:L,G=m[q].endsWith(W);D=!H||G}if(!D){let q="";(w[0].endsWith(":")||k!=="")&&(N===1&&(N=0,F++,L=w[0]+h+L),N>0&&(q=w[0]+h),q=k+q),N>0&&(q=q+d+h),q=q+L,N+F<w.length&&(q=q+h+d),E[b]=q}}D&&(E[b]=C)}return E}var l;(function(m){m[m.TEXT=0]="TEXT",m[m.VARIABLE=1]="VARIABLE",m[m.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function i(m,h=Object.create(null)){const E=[];let D=!1,b="";for(const C of m)if(C==="$"||D&&C==="{")b&&E.push({value:b,type:l.TEXT}),b="",D=!0;else if(C==="}"&&D){const k=h[b];if(typeof k=="string")k.length&&E.push({value:k,type:l.VARIABLE});else if(k){const f=E[E.length-1];(!f||f.type!==l.SEPARATOR)&&E.push({value:k.label,type:l.SEPARATOR})}b="",D=!1}else b+=C;return b&&!D&&E.push({value:b,type:l.TEXT}),E.filter((C,k)=>{if(C.type===l.SEPARATOR){const f=E[k-1],w=E[k+1];return[f,w].every(F=>F&&(F.type===l.VARIABLE||F.type===l.TEXT)&&F.value.length>0)}return!0}).map(C=>C.value).join("")}function n(m,h){return O.$k||h?m.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$k?"&":"&&"):m.replace(/&&|&/g,E=>E==="&"?"&&":"&")}function t(m,h){return O.$k||h?m.replace(/\(&&\w\)|&&/g,""):O.$j?m.replace(/&&|&/g,E=>E==="&"?"&&":"&"):m.replace(/&&/g,"_")}function g(m){return m.replace(/&/g,"&&")}function u(m){if(m.endsWith("]")){const h=m.lastIndexOf(" [",m.length-2);if(h!==-1){const E=$(m.substring(0,h)),D=m.substring(h);return{name:E.name+D,parentPath:E.parentPath}}}return $(m)}function $(m){const h=m.indexOf("/")!==-1?P.$gc:P.$fc,E=h.basename(m),D=h.dirname(m);return E.length?{name:E,parentPath:D}:{name:D,parentPath:""}}}),define(Ne[150],Le([1,0,22,37,2]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=void 0,e.$On=p,e.$Pn=I,e.$Qn=y;function O(a){return a.toJSON()}class A{constructor(S){this.a=S}transformIncoming(S){const d=this.a.transformIncoming(S);return d===S?S:O(P.URI.from(d))}transformOutgoing(S){const d=this.a.transformOutgoing(S);return d===S?S:O(P.URI.from(d))}transformOutgoingURI(S){const d=this.a.transformOutgoing(S);return d===S?S:P.URI.from(d)}transformOutgoingScheme(S){return this.a.transformOutgoingScheme(S)}}e.$Mn=A,e.$Nn=new class{transformIncoming(a){return a}transformOutgoing(a){return a}transformOutgoingURI(a){return a}transformOutgoingScheme(a){return a}};function T(a,S,d){if(!a||d>200)return null;if(typeof a=="object"){if(a instanceof P.URI)return S.transformOutgoing(a);for(const r in a)if(Object.hasOwnProperty.call(a,r)){const s=T(a[r],S,d+1);s!==null&&(a[r]=s)}}return null}function p(a,S){const d=T(a,S,0);return d===null?a:d}function o(a,S,d,r){if(!a||r>200)return null;if(typeof a=="object"){if(a.$mid===R.MarshalledId.Uri)return d?P.URI.revive(S.transformIncoming(a)):S.transformIncoming(a);if(a instanceof v.$Ne)return null;for(const s in a)if(Object.hasOwnProperty.call(a,s)){const c=o(a[s],S,d,r+1);c!==null&&(a[s]=c)}}return null}function I(a,S){const d=o(a,S,!1,0);return d===null?a:d}function y(a,S){const d=o(a,S,!0,0);return d===null?a:d}}),define(Ne[38],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=R;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(P){return v.test(P)}e.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(T){for(let p=0;p<T.length;p++)T[p]=Math.floor(Math.random()*256);return T};const O=new Uint8Array(16),A=[];for(let T=0;T<256;T++)A.push(T.toString(16).padStart(2,"0"));return function(){P(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let p=0,o="";return o+=A[O[p++]],o+=A[O[p++]],o+=A[O[p++]],o+=A[O[p++]],o+="-",o+=A[O[p++]],o+=A[O[p++]],o+="-",o+=A[O[p++]],o+=A[O[p++]],o+="-",o+=A[O[p++]],o+=A[O[p++]],o+="-",o+=A[O[p++]],o+=A[O[p++]],o+=A[O[p++]],o+=A[O[p++]],o+=A[O[p++]],o+=A[O[p++]],o}}()}),define(Ne[151],Le([1,0,17,40,38]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tu=e.$ru=void 0,e.$pu=O,e.$qu=A,e.$su=o;function O(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function A(y,a,S){const d={id:(0,P.$2g)(),name:y,uri:a,data:S};return{asString:async()=>"",asFile:()=>d,value:void 0}}class T{constructor(){this.a=new Map}get size(){let a=0;for(const S of this.a)a++;return a}has(a){return this.a.has(this.b(a))}matches(a){const S=[...this.a.keys()];return R.Iterable.some(this,([d,r])=>r.asFile())&&S.push("files"),I(p(a),S)}get(a){return this.a.get(this.b(a))?.[0]}append(a,S){const d=this.a.get(a);d?d.push(S):this.a.set(this.b(a),[S])}replace(a,S){this.a.set(this.b(a),[S])}delete(a){this.a.delete(this.b(a))}*[Symbol.iterator](){for(const[a,S]of this.a)for(const d of S)yield[a,d]}b(a){return p(a)}}e.$ru=T;function p(y){return y.toLowerCase()}function o(y,a){return I(p(y),a.map(p))}function I(y,a){if(y==="*/*")return a.length>0;if(a.includes(y))return!0;const S=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[d,r,s]=S;return s==="*"?a.some(c=>c.startsWith(r+"/")):!1}e.$tu=Object.freeze({create:y=>(0,v.$Lb)(y.map(a=>a.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$tu.split(y).filter(a=>!a.startsWith("#"))})}),define(Ne[152],Le([1,0,10,6,4,36,14]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=e.StorageState=e.StorageHint=void 0,e.$dq=p;var T;(function(a){a[a.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",a[a.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function p(a){const S=a;return S?.changed instanceof Map||S?.deleted instanceof Set}var o;(function(a){a[a.None=0]="None",a[a.Initialized=1]="Initialized",a[a.Closed=2]="Closed"})(o||(e.StorageState=o={}));class I extends P.$Uc{static{this.a=100}constructor(S,d=Object.create(null)){super(),this.r=S,this.s=d,this.b=this.B(new R.$oe),this.onDidChangeStorage=this.b.event,this.c=o.None,this.f=new Map,this.g=this.B(new v.$Dh(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(S=>this.u(S)))}u(S){this.b.pause();try{S.changed?.forEach((d,r)=>this.w(r,d)),S.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(S,d){if(this.c===o.Closed)return;let r=!1;(0,A.$ng)(d)?r=this.f.delete(S):this.f.get(S)!==d&&(this.f.set(S,d),r=!0),r&&this.b.fire({key:S,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===o.None&&(this.c=o.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(S,d){const r=this.f.get(S);return(0,A.$ng)(r)?d:r}getBoolean(S,d){const r=this.get(S);return(0,A.$ng)(r)?d:r==="true"}getNumber(S,d){const r=this.get(S);return(0,A.$ng)(r)?d:parseInt(r,10)}getObject(S,d){const r=this.get(S);return(0,A.$ng)(r)?d:(0,O.$bi)(r)}async set(S,d,r=!1){if(this.c===o.Closed)return;if((0,A.$ng)(d))return this.delete(S,r);const s=(0,A.$gg)(d)||Array.isArray(d)?(0,O.$ai)(d):String(d);if(this.f.get(S)!==s)return this.f.set(S,s),this.j.set(S,s),this.h.delete(S),this.b.fire({key:S,external:r}),this.D()}async delete(S,d=!1){if(!(this.c===o.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire({key:S,external:d}),this.D()}async optimize(){if(this.c!==o.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=o.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(S).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(S){if(!(this.c===o.Closed||this.m))return this.D(S)}async D(S){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),S)}async whenFlushed(){if(this.z)return new Promise(S=>this.n.push(S))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$eq=I;class y{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((d,r)=>this.a.set(r,d)),S.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$fq=y}),define(Ne[153],Le([1,0,27]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$zu=P;var R;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(R||(e.StringEOL=R={}));function P(O){let A=0,T=0,p=0,o=R.Unknown;for(let I=0,y=O.length;I<y;I++){const a=O.charCodeAt(I);a===v.CharCode.CarriageReturn?(A===0&&(T=I),A++,I+1<y&&O.charCodeAt(I+1)===v.CharCode.LineFeed?(o|=R.CRLF,I++):o|=R.Invalid,p=I+1):a===v.CharCode.LineFeed&&(o|=R.LF,A===0&&(T=I),A++,p=I+1)}return A===0&&(T=O.length),[A,T,O.length-p,o]}}),define(Ne[154],Le([1,0,12,20,22]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eu=void 0,e.$cu=I,e.$du=y,v=qe(v),R=qe(R),P=qe(P);let O;function A(){return O||(O=new TextDecoder("UTF-16LE")),O}let T;function p(){return T||(T=new TextDecoder("UTF-16BE")),T}let o;function I(){return o||(o=R.$E()?A():p()),o}function y(d,r,s){const c=new Uint16Array(d.buffer,r,s);return s>0&&(c[0]===65279||c[0]===65534)?a(d,r,s):A().decode(c)}function a(d,r,s){const c=[];let l=0;for(let i=0;i<s;i++){const n=P.$Pe(d,r);r+=2,c[l++]=String.fromCharCode(n)}return c.join("")}class S{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return I().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const s=this.a-this.d;s<=1&&(s===0||v.$Jf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const s=r.length;if(this.d+s>=this.a){this.f(),this.c[this.c.length]=r;return}for(let c=0;c<s;c++)this.b[this.d++]=r.charCodeAt(c)}}e.$eu=S}),define(Ne[155],Le([1,0,22,154]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fu=void 0,e.$gu=A,v=qe(v);function P(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(o,I,y,a){this.oldPosition=o,this.oldText=I,this.newPosition=y,this.newText=a}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(o){return 4+2*o.length}static c(o,I,y){const a=I.length;v.$Se(o,a,y),y+=4;for(let S=0;S<a;S++)v.$Qe(o,I.charCodeAt(S),y),y+=2;return y}static d(o,I){const y=v.$Re(o,I);return I+=4,(0,R.$du)(o,I,y)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(o,I){return v.$Se(o,this.oldPosition,I),I+=4,v.$Se(o,this.newPosition,I),I+=4,I=O.c(o,this.oldText,I),I=O.c(o,this.newText,I),I}static read(o,I,y){const a=v.$Re(o,I);I+=4;const S=v.$Re(o,I);I+=4;const d=O.d(o,I);I+=O.a(d);const r=O.d(o,I);return I+=O.a(r),y.push(new O(a,d,S,r)),I}}e.$fu=O;function A(p,o){return p===null||p.length===0?o:new T(p,o).compress()}class T{constructor(o,I){this.a=o,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let o=0,I=0,y=this.n(o),a=this.l(I);for(;o<this.f||I<this.h;){if(y===null){this.k(a),a=this.l(++I);continue}if(a===null){this.m(y),y=this.n(++o);continue}if(a.oldEnd<=y.newPosition){this.k(a),a=this.l(++I);continue}if(y.newEnd<=a.oldPosition){this.m(y),y=this.n(++o);continue}if(a.oldPosition<y.newPosition){const[c,l]=T.r(a,y.newPosition-a.oldPosition);this.k(c),a=l;continue}if(y.newPosition<a.oldPosition){const[c,l]=T.q(y,a.oldPosition-y.newPosition);this.m(c),y=l;continue}let r,s;if(a.oldEnd===y.newEnd)r=y,s=a,y=this.n(++o),a=this.l(++I);else if(a.oldEnd<y.newEnd){const[c,l]=T.q(y,a.oldLength);r=c,s=a,y=l,a=this.l(++I)}else{const[c,l]=T.r(a,y.newLength);r=y,s=c,y=this.n(++o),a=l}this.d[this.e++]=new O(r.oldPosition,r.oldText,s.newPosition,s.newText),this.g+=r.newLength-r.oldLength,this.j+=s.newLength-s.oldLength}const S=T.s(this.d);return T.t(S)}k(o){this.d[this.e++]=T.o(this.g,o),this.j+=o.newLength-o.oldLength}l(o){return o<this.h?this.c[o]:null}m(o){this.d[this.e++]=T.p(this.j,o),this.g+=o.newLength-o.oldLength}n(o){return o<this.f?this.a[o]:null}static o(o,I){return new O(I.oldPosition-o,I.oldText,I.newPosition,I.newText)}static p(o,I){return new O(I.oldPosition,I.oldText,I.newPosition+o,I.newText)}static q(o,I){const y=o.newText.substr(0,I),a=o.newText.substr(I);return[new O(o.oldPosition,o.oldText,o.newPosition,y),new O(o.oldEnd,"",o.newPosition+I,a)]}static r(o,I){const y=o.oldText.substr(0,I),a=o.oldText.substr(I);return[new O(o.oldPosition,y,o.newPosition,o.newText),new O(o.oldPosition+I,a,o.newEnd,"")]}static s(o){if(o.length===0)return o;const I=[];let y=0,a=o[0];for(let S=1;S<o.length;S++){const d=o[S];a.oldEnd===d.oldPosition?a=new O(a.oldPosition,a.oldText+d.oldText,a.newPosition,a.newText+d.newText):(I[y++]=a,a=d)}return I[y++]=a,I}static t(o){if(o.length===0)return o;const I=[];let y=0;for(let a=0;a<o.length;a++){const S=o[a];S.oldText!==S.newText&&(I[y++]=S)}return I}}}),define(Ne[156],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=void 0,e.$lt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ne[157],Le([1,0,41,19]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wu=P,e.$xu=O;function P(A,T,p,o,I,y){if(Array.isArray(A)){let a=0;for(const S of A){const d=P(S,T,p,o,I,y);if(d===10)return d;d>a&&(a=d)}return a}else{if(typeof A=="string")return o?A==="*"?5:A===p?10:0:0;if(A){const{language:a,pattern:S,scheme:d,hasAccessToAllModels:r,notebookType:s}=A;if(!o&&!r)return 0;s&&I&&(T=I);let c=0;if(d)if(d===T.scheme)c=10;else if(d==="*")c=5;else return 0;if(a)if(a===p)c=10;else if(a==="*")c=Math.max(c,5);else return 0;if(s)if(s===y)c=10;else if(s==="*"&&y!==void 0)c=Math.max(c,5);else return 0;if(S){let l;if(typeof S=="string"?l=S:l={...S,base:(0,R.$hc)(S.base)},l===T.fsPath||(0,v.$zk)(l,T.fsPath))c=10;else return 0}return c}else return 0}}function O(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(O):!!A.notebookType}}),define(Ne[158],Le([1,0,27,159]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xu=e.$Wu=e.IndentAction=void 0;var P;(function(p){p[p.None=0]="None",p[p.Indent=1]="Indent",p[p.IndentOutdent=2]="IndentOutdent",p[p.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class O{constructor(o){if(this.e=null,this.f=!1,this.open=o.open,this.close=o.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(o.notIn))for(let I=0,y=o.notIn.length;I<y;I++)switch(o.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(o){switch(o){case R.StandardTokenType.Other:return!0;case R.StandardTokenType.Comment:return this.c;case R.StandardTokenType.String:return this.b;case R.StandardTokenType.RegEx:return this.d}}shouldAutoClose(o,I){if(o.getTokenCount()===0)return!0;const y=o.findTokenIndexAtOffset(I-2),a=o.getStandardTokenType(y);return this.isOK(a)}g(o,I){for(let y=o;y<=I;y++){const a=String.fromCharCode(y);if(!this.open.includes(a)&&!this.close.includes(a))return a}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(v.CharCode.Digit0,v.CharCode.Digit9)),this.e||(this.e=this.g(v.CharCode.a,v.CharCode.z)),this.e||(this.e=this.g(v.CharCode.A,v.CharCode.Z))),this.e}}e.$Wu=O;class A{constructor(o){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of o)T(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),T(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),T(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),T(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&T(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$Xu=A;function T(p,o,I){p.has(o)?p.get(o).push(I):p.set(o,[I])}}),define(Ne[160],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bD=e.NodeColor=e.$aD=void 0,e.$cD=P,e.$dD=O,e.$eD=o,e.$fD=I,e.$gD=y,e.$hD=a,e.$iD=S,e.$jD=d;class v{constructor(s,c){this.piece=s,this.color=c,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$bD)return P(this.right);let s=this;for(;s.parent!==e.$bD&&s.parent.left!==s;)s=s.parent;return s.parent===e.$bD?e.$bD:s.parent}prev(){if(this.left!==e.$bD)return O(this.left);let s=this;for(;s.parent!==e.$bD&&s.parent.right!==s;)s=s.parent;return s.parent===e.$bD?e.$bD:s.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$aD=v;var R;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(R||(e.NodeColor=R={})),e.$bD=new v(null,R.Black),e.$bD.parent=e.$bD,e.$bD.left=e.$bD,e.$bD.right=e.$bD,e.$bD.color=R.Black;function P(r){for(;r.left!==e.$bD;)r=r.left;return r}function O(r){for(;r.right!==e.$bD;)r=r.right;return r}function A(r){return r===e.$bD?0:r.size_left+r.piece.length+A(r.right)}function T(r){return r===e.$bD?0:r.lf_left+r.piece.lineFeedCnt+T(r.right)}function p(){e.$bD.parent=e.$bD}function o(r,s){const c=s.right;c.size_left+=s.size_left+(s.piece?s.piece.length:0),c.lf_left+=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),s.right=c.left,c.left!==e.$bD&&(c.left.parent=s),c.parent=s.parent,s.parent===e.$bD?r.root=c:s.parent.left===s?s.parent.left=c:s.parent.right=c,c.left=s,s.parent=c}function I(r,s){const c=s.left;s.left=c.right,c.right!==e.$bD&&(c.right.parent=s),c.parent=s.parent,s.size_left-=c.size_left+(c.piece?c.piece.length:0),s.lf_left-=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),s.parent===e.$bD?r.root=c:s===s.parent.right?s.parent.right=c:s.parent.left=c,c.right=s,s.parent=c}function y(r,s){let c,l;if(s.left===e.$bD?(l=s,c=l.right):s.right===e.$bD?(l=s,c=l.left):(l=P(s.right),c=l.right),l===r.root){r.root=c,c.color=R.Black,s.detach(),p(),r.root.parent=e.$bD;return}const i=l.color===R.Red;if(l===l.parent.left?l.parent.left=c:l.parent.right=c,l===s?(c.parent=l.parent,d(r,c)):(l.parent===s?c.parent=l:c.parent=l.parent,d(r,c),l.left=s.left,l.right=s.right,l.parent=s.parent,l.color=s.color,s===r.root?r.root=l:s===s.parent.left?s.parent.left=l:s.parent.right=l,l.left!==e.$bD&&(l.left.parent=l),l.right!==e.$bD&&(l.right.parent=l),l.size_left=s.size_left,l.lf_left=s.lf_left,d(r,l)),s.detach(),c.parent.left===c){const t=A(c),g=T(c);if(t!==c.parent.size_left||g!==c.parent.lf_left){const u=t-c.parent.size_left,$=g-c.parent.lf_left;c.parent.size_left=t,c.parent.lf_left=g,S(r,c.parent,u,$)}}if(d(r,c.parent),i){p();return}let n;for(;c!==r.root&&c.color===R.Black;)c===c.parent.left?(n=c.parent.right,n.color===R.Red&&(n.color=R.Black,c.parent.color=R.Red,o(r,c.parent),n=c.parent.right),n.left.color===R.Black&&n.right.color===R.Black?(n.color=R.Red,c=c.parent):(n.right.color===R.Black&&(n.left.color=R.Black,n.color=R.Red,I(r,n),n=c.parent.right),n.color=c.parent.color,c.parent.color=R.Black,n.right.color=R.Black,o(r,c.parent),c=r.root)):(n=c.parent.left,n.color===R.Red&&(n.color=R.Black,c.parent.color=R.Red,I(r,c.parent),n=c.parent.left),n.left.color===R.Black&&n.right.color===R.Black?(n.color=R.Red,c=c.parent):(n.left.color===R.Black&&(n.right.color=R.Black,n.color=R.Red,o(r,n),n=c.parent.left),n.color=c.parent.color,c.parent.color=R.Black,n.left.color=R.Black,I(r,c.parent),c=r.root));c.color=R.Black,p()}function a(r,s){for(d(r,s);s!==r.root&&s.parent.color===R.Red;)if(s.parent===s.parent.parent.left){const c=s.parent.parent.right;c.color===R.Red?(s.parent.color=R.Black,c.color=R.Black,s.parent.parent.color=R.Red,s=s.parent.parent):(s===s.parent.right&&(s=s.parent,o(r,s)),s.parent.color=R.Black,s.parent.parent.color=R.Red,I(r,s.parent.parent))}else{const c=s.parent.parent.left;c.color===R.Red?(s.parent.color=R.Black,c.color=R.Black,s.parent.parent.color=R.Red,s=s.parent.parent):(s===s.parent.left&&(s=s.parent,I(r,s)),s.parent.color=R.Black,s.parent.parent.color=R.Red,o(r,s.parent.parent))}r.root.color=R.Black}function S(r,s,c,l){for(;s!==r.root&&s!==e.$bD;)s.parent.left===s&&(s.parent.size_left+=c,s.parent.lf_left+=l),s=s.parent}function d(r,s){let c=0,l=0;if(s!==r.root){for(;s!==r.root&&s===s.parent.right;)s=s.parent;if(s!==r.root)for(s=s.parent,c=A(s.left)-s.size_left,l=T(s.left)-s.lf_left,s.size_left+=c,s.lf_left+=l;s!==r.root&&(c!==0||l!==0);)s.parent.left===s&&(s.parent.size_left+=c,s.parent.lf_left+=l),s=s.parent}}}),define(Ne[100],Le([1,0,27,101,32,52,160,102]),function(ve,e,v,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uD=e.$tD=e.$sD=void 0,e.$qD=y,e.$rD=a;const p=65535;function o(l){let i;return l[l.length-1]<65536?i=new Uint16Array(l.length):i=new Uint32Array(l.length),i.set(l,0),i}class I{constructor(i,n,t,g,u){this.lineStarts=i,this.cr=n,this.lf=t,this.crlf=g,this.isBasicASCII=u}}function y(l,i=!0){const n=[0];let t=1;for(let g=0,u=l.length;g<u;g++){const $=l.charCodeAt(g);$===v.CharCode.CarriageReturn?g+1<u&&l.charCodeAt(g+1)===v.CharCode.LineFeed?(n[t++]=g+2,g++):n[t++]=g+1:$===v.CharCode.LineFeed&&(n[t++]=g+1)}return i?o(n):n}function a(l,i){l.length=0,l[0]=0;let n=1,t=0,g=0,u=0,$=!0;for(let h=0,E=i.length;h<E;h++){const D=i.charCodeAt(h);D===v.CharCode.CarriageReturn?h+1<E&&i.charCodeAt(h+1)===v.CharCode.LineFeed?(u++,l[n++]=h+2,h++):(t++,l[n++]=h+1):D===v.CharCode.LineFeed?(g++,l[n++]=h+1):$&&D!==v.CharCode.Tab&&(D<32||D>126)&&($=!1)}const m=new I(o(l),t,g,u,$);return l.length=0,m}class S{constructor(i,n,t,g,u){this.bufferIndex=i,this.start=n,this.end=t,this.lineFeedCnt=g,this.length=u}}e.$sD=S;class d{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$tD=d;class r{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==A.$bD&&i.iterate(i.root,t=>(t!==A.$bD&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const t=this.b[n];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const t=this.b[n];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const t=this.b;for(let g=0;g<t.length;g++){const u=t[g];if(u.node.parent===null||u.nodeStartOffset>=i){t[g]=null,n=!0;continue}}if(n){const g=[];for(const u of t)u!==null&&g.push(u);this.b=g}}}class c{constructor(i,n,t){this.create(i,n,t)}create(i,n,t){this.a=[new d("",[0])],this.g={line:0,column:0},this.root=A.$bD,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=t;let g=null;for(let u=0,$=i.length;u<$;u++)if(i[u].buffer.length>0){i[u].lineStarts||(i[u].lineStarts=y(i[u].buffer));const m=new S(u+1,{line:0,column:0},{line:i[u].lineStarts.length-1,column:i[u].buffer.length-i[u].lineStarts[i[u].lineStarts.length-1]},i[u].lineStarts.length-1,i[u].buffer.length);this.a.push(i[u]),g=this.S(g,m)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=p,t=n-Math.floor(n/3),g=t*2;let u="",$=0;const m=[];if(this.iterate(this.root,h=>{const E=this.R(h),D=E.length;if($<=t||$+D<g)return u+=E,$+=D,!0;const b=u.replace(/\r\n|\r|\n/g,i);return m.push(new d(b,y(b))),u=E,$=D,!0}),$>0){const h=u.replace(/\r\n|\r|\n/g,i);m.push(new d(h,y(h)))}this.create(m,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new r(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,g=>{if(g===A.$bD)return!0;const u=this.R(g),$=u.length,m=i.G(n),h=i.G(n+$),E=i.getValueInRange2(m,h);return n+=$,u===E})}getOffsetAt(i,n){let t=0,g=this.root;for(;g!==A.$bD;)if(g.left!==A.$bD&&g.lf_left+1>=i)g=g.left;else if(g.lf_left+g.piece.lineFeedCnt+1>=i){t+=g.size_left;const u=this.B(g,i-g.lf_left-2);return t+=u+n-1}else i-=g.lf_left+g.piece.lineFeedCnt,t+=g.size_left+g.piece.length,g=g.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,t=0;const g=i;for(;n!==A.$bD;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const u=this.A(n,i-n.size_left);if(t+=n.lf_left+u.index,u.index===0){const $=this.getOffsetAt(t+1,1),m=g-$;return new R.$Nt(t+1,m+1)}return new R.$Nt(t+1,u.remainder+1)}else if(i-=n.size_left+n.piece.length,t+=n.lf_left+n.piece.lineFeedCnt,n.right===A.$bD){const u=this.getOffsetAt(t+1,1),$=g-i-u;return new R.$Nt(t+1,$+1)}else n=n.right;return new R.$Nt(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),g=this.H(i.endLineNumber,i.endColumn),u=this.getValueInRange2(t,g);return n?n!==this.d||!this.f?u.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?u:u.replace(/\r\n|\r|\n/g,n):u}getValueInRange2(i,n){if(i.node===n.node){const m=i.node,h=this.a[m.piece.bufferIndex].buffer,E=this.u(m.piece.bufferIndex,m.piece.start);return h.substring(E+i.remainder,E+n.remainder)}let t=i.node;const g=this.a[t.piece.bufferIndex].buffer,u=this.u(t.piece.bufferIndex,t.piece.start);let $=g.substring(u+i.remainder,u+t.piece.length);for(t=t.next();t!==A.$bD;){const m=this.a[t.piece.bufferIndex].buffer,h=this.u(t.piece.bufferIndex,t.piece.start);if(t===n.node){$+=m.substring(h,h+n.remainder);break}else $+=m.substr(h,t.piece.length);t=t.next()}return $}getLinesContent(){const i=[];let n=0,t="",g=!1;return this.iterate(this.root,u=>{if(u===A.$bD)return!0;const $=u.piece;let m=$.length;if(m===0)return!0;const h=this.a[$.bufferIndex].buffer,E=this.a[$.bufferIndex].lineStarts,D=$.start.line,b=$.end.line;let C=E[D]+$.start.column;if(g&&(h.charCodeAt(C)===v.CharCode.LineFeed&&(C++,m--),i[n++]=t,t="",g=!1,m===0))return!0;if(D===b)return!this.f&&h.charCodeAt(C+m-1)===v.CharCode.CarriageReturn?(g=!0,t+=h.substr(C,m-1)):t+=h.substr(C,m),!0;t+=this.f?h.substring(C,Math.max(C,E[D+1]-this.e)):h.substring(C,E[D+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;for(let k=D+1;k<b;k++)t=this.f?h.substring(E[k],E[k+1]-this.e):h.substring(E[k],E[k+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;return!this.f&&h.charCodeAt(E[b]+$.end.column-1)===v.CharCode.CarriageReturn?(g=!0,$.end.column===0?n--:t=h.substr(E[b],$.end.column-1)):t=h.substr(E[b],$.end.column),!0}),g&&(i[n++]=t,t=""),i[n++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const t=this.a[n.piece.bufferIndex],g=this.u(n.piece.bufferIndex,n.piece.start);return t.buffer.charCodeAt(g)}else{const n=this.a[i.node.piece.bufferIndex],g=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(g)}}getLineCharCode(i,n){const t=this.H(i,n+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}getNearestChunk(i){const n=this.G(i);if(n.remainder===n.node.piece.length){const t=n.node.next();if(!t||t===A.$bD)return"";const g=this.a[t.piece.bufferIndex],u=this.u(t.piece.bufferIndex,t.piece.start);return g.buffer.substring(u,u+t.piece.length)}else{const t=this.a[n.node.piece.bufferIndex],g=this.u(n.node.piece.bufferIndex,n.node.piece.start),u=g+n.remainder,$=g+n.node.piece.length;return t.buffer.substring(u,$)}}findMatchesInNode(i,n,t,g,u,$,m,h,E,D,b){const C=this.a[i.piece.bufferIndex],k=this.u(i.piece.bufferIndex,i.piece.start),f=this.u(i.piece.bufferIndex,u),w=this.u(i.piece.bufferIndex,$);let F;const N={line:0,column:0};let L,q;n._wordSeparators?(L=C.buffer.substring(f,w),q=H=>H+f,n.reset(0)):(L=C.buffer,q=H=>H,n.reset(f));do if(F=n.next(L),F){if(q(F.index)>=w)return D;this.s(i,q(F.index)-k,N);const H=this.t(i.piece.bufferIndex,u,N),W=N.line===u.line?N.column-u.column+g:N.column+1,G=W+F[0].length;if(b[D++]=(0,T.$mD)(new P.$Ot(t+H,W,t+H,G),F,h),q(F.index)+F[0].length>=w||D>=E)return D}while(F);return D}findMatchesLineByLine(i,n,t,g){const u=[];let $=0;const m=new T.$pD(n.wordSeparators,n.regex);let h=this.H(i.startLineNumber,i.startColumn);if(h===null)return[];const E=this.H(i.endLineNumber,i.endColumn);if(E===null)return[];let D=this.s(h.node,h.remainder);const b=this.s(E.node,E.remainder);if(h.node===E.node)return this.findMatchesInNode(h.node,m,i.startLineNumber,i.startColumn,D,b,n,t,g,$,u),u;let C=i.startLineNumber,k=h.node;for(;k!==E.node;){const w=this.t(k.piece.bufferIndex,D,k.piece.end);if(w>=1){const N=this.a[k.piece.bufferIndex].lineStarts,L=this.u(k.piece.bufferIndex,k.piece.start),q=N[D.line+w],H=C===i.startLineNumber?i.startColumn:1;if($=this.findMatchesInNode(k,m,C,H,D,this.s(k,q-L),n,t,g,$,u),$>=g)return u;C+=w}const F=C===i.startLineNumber?i.startColumn-1:0;if(C===i.endLineNumber){const N=this.getLineContent(C).substring(F,i.endColumn-1);return $=this.n(n,m,N,i.endLineNumber,F,$,u,t,g),u}if($=this.n(n,m,this.getLineContent(C).substr(F),C,F,$,u,t,g),$>=g)return u;C++,h=this.H(C,1),k=h.node,D=this.s(h.node,h.remainder)}if(C===i.endLineNumber){const w=C===i.startLineNumber?i.startColumn-1:0,F=this.getLineContent(C).substring(w,i.endColumn-1);return $=this.n(n,m,F,i.endLineNumber,w,$,u,t,g),u}const f=C===i.startLineNumber?i.startColumn:1;return $=this.findMatchesInNode(E.node,m,C,f,D,b,n,t,g,$,u),u}n(i,n,t,g,u,$,m,h,E){const D=i.wordSeparators;if(!h&&i.simpleSearch){const C=i.simpleSearch,k=C.length,f=t.length;let w=-k;for(;(w=t.indexOf(C,w+k))!==-1;)if((!D||(0,T.$oD)(D,t,f,w,k))&&(m[$++]=new O.$ew(new P.$Ot(g,w+1+u,g,w+1+k+u),null),$>=E))return $;return $}let b;n.reset(0);do if(b=n.next(t),b&&(m[$++]=(0,T.$mD)(new P.$Ot(g,b.index+1+u,g,b.index+1+b[0].length+u),b,h),$>=E))return $;while(b);return $}insert(i,n,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==A.$bD){const{node:g,remainder:u,nodeStartOffset:$}=this.G(i),m=g.piece,h=m.bufferIndex,E=this.s(g,u);if(g.piece.bufferIndex===0&&m.end.line===this.g.line&&m.end.column===this.g.column&&$+m.length===i&&n.length<p){this.F(g,n),this.y();return}if($===i)this.o(n,g),this.h.validate(i);else if($+g.piece.length>i){const D=[];let b=new S(m.bufferIndex,E,m.end,this.t(m.bufferIndex,E,m.end),this.u(h,m.end)-this.u(h,E));if(this.K()&&this.M(n)&&this.I(g,u)===10){const w={line:b.start.line+1,column:0};b=new S(b.bufferIndex,w,b.end,this.t(b.bufferIndex,w,b.end),b.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(g,u-1)===13){const w=this.s(g,u-1);this.C(g,w),n="\r"+n,g.piece.length===0&&D.push(g)}else this.C(g,E);else this.C(g,E);const C=this.w(n);b.length>0&&this.S(g,b);let k=g;for(let f=0;f<C.length;f++)k=this.S(k,C[f]);this.v(D)}else this.q(n,g)}else{const g=this.w(n);let u=this.T(null,g[0]);for(let $=1;$<g.length;$++)u=this.S(u,g[$])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===A.$bD)return;const t=this.G(i),g=this.G(i+n),u=t.node,$=g.node;if(u===$){const C=this.s(u,t.remainder),k=this.s(u,g.remainder);if(t.nodeStartOffset===i){if(n===u.piece.length){const f=u.next();(0,A.$gD)(this,u),this.N(f),this.y();return}this.D(u,k),this.h.validate(i),this.N(u),this.y();return}if(t.nodeStartOffset+u.piece.length===i+n){this.C(u,C),this.O(u),this.y();return}this.E(u,C,k),this.y();return}const m=[],h=this.s(u,t.remainder);this.C(u,h),this.h.validate(i),u.piece.length===0&&m.push(u);const E=this.s($,g.remainder);this.D($,E),$.piece.length===0&&m.push($);const D=u.next();for(let C=D;C!==A.$bD&&C!==$;C=C.next())m.push(C);const b=u.piece.length===0?u.prev():u;this.v(m),this.O(b),this.y()}o(i,n){const t=[];if(this.K()&&this.M(i)&&this.L(n)){const $=n.piece,m={line:$.start.line+1,column:0},h=new S($.bufferIndex,m,$.end,this.t($.bufferIndex,m,$.end),$.length-1);n.piece=h,i+=`
`,(0,A.$iD)(this,n,-1,-1),n.piece.length===0&&t.push(n)}const g=this.w(i);let u=this.T(n,g[g.length-1]);for(let $=g.length-2;$>=0;$--)u=this.T(u,g[$]);this.N(u),this.v(t)}q(i,n){this.Q(i,n)&&(i+=`
`);const t=this.w(i),g=this.S(n,t[0]);let u=g;for(let $=1;$<t.length;$++)u=this.S(u,t[$]);this.N(g)}s(i,n,t){const g=i.piece,u=i.piece.bufferIndex,$=this.a[u].lineStarts,h=$[g.start.line]+g.start.column+n;let E=g.start.line,D=g.end.line,b=0,C=0,k=0;for(;E<=D&&(b=E+(D-E)/2|0,k=$[b],b!==D);)if(C=$[b+1],h<k)D=b-1;else if(h>=C)E=b+1;else break;return t?(t.line=b,t.column=h-k,null):{line:b,column:h-k}}t(i,n,t){if(t.column===0)return t.line-n.line;const g=this.a[i].lineStarts;if(t.line===g.length-1)return t.line-n.line;const u=g[t.line+1],$=g[t.line]+t.column;if(u>$+1)return t.line-n.line;const m=$-1;return this.a[i].buffer.charCodeAt(m)===13?t.line-n.line+1:t.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,A.$gD)(this,i[n])}w(i){if(i.length>p){const D=[];for(;i.length>p;){const C=i.charCodeAt(p-1);let k;C===v.CharCode.CarriageReturn||C>=55296&&C<=56319?(k=i.substring(0,p-1),i=i.substring(p-1)):(k=i.substring(0,p),i=i.substring(p));const f=y(k);D.push(new S(this.a.length,{line:0,column:0},{line:f.length-1,column:k.length-f[f.length-1]},f.length-1,k.length)),this.a.push(new d(k,f))}const b=y(i);return D.push(new S(this.a.length,{line:0,column:0},{line:b.length-1,column:i.length-b[b.length-1]},b.length-1,i.length)),this.a.push(new d(i,b)),D}let n=this.a[0].buffer.length;const t=y(i,!1);let g=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},g=this.g;for(let D=0;D<t.length;D++)t[D]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let D=0;D<t.length;D++)t[D]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const u=this.a[0].buffer.length,$=this.a[0].lineStarts.length-1,m=u-this.a[0].lineStarts[$],h={line:$,column:m},E=new S(0,g,h,this.t(0,g,h),u-n);return this.g=h,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let t=this.root,g="";const u=this.h.get2(i);if(u){t=u.node;const $=this.B(t,i-u.nodeStartLineNumber-1),m=this.a[t.piece.bufferIndex].buffer,h=this.u(t.piece.bufferIndex,t.piece.start);if(u.nodeStartLineNumber+t.piece.lineFeedCnt===i)g=m.substring(h+$,h+t.piece.length);else{const E=this.B(t,i-u.nodeStartLineNumber);return m.substring(h+$,h+E-n)}}else{let $=0;const m=i;for(;t!==A.$bD;)if(t.left!==A.$bD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const h=this.B(t,i-t.lf_left-2),E=this.B(t,i-t.lf_left-1),D=this.a[t.piece.bufferIndex].buffer,b=this.u(t.piece.bufferIndex,t.piece.start);return $+=t.size_left,this.h.set({node:t,nodeStartOffset:$,nodeStartLineNumber:m-(i-1-t.lf_left)}),D.substring(b+h,b+E-n)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const h=this.B(t,i-t.lf_left-2),E=this.a[t.piece.bufferIndex].buffer,D=this.u(t.piece.bufferIndex,t.piece.start);g=E.substring(D+h,D+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,$+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==A.$bD;){const $=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const m=this.B(t,0),h=this.u(t.piece.bufferIndex,t.piece.start);return g+=$.substring(h,h+m-n),g}else{const m=this.u(t.piece.bufferIndex,t.piece.start);g+=$.substr(m,t.piece.length)}t=t.next()}return g}y(){let i=this.root,n=1,t=0;for(;i!==A.$bD;)n+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=t,this.h.validate(this.c)}A(i,n){const t=i.piece,g=this.s(i,n),u=g.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===n){const $=this.t(i.piece.bufferIndex,t.start,g);if($!==u)return{index:$,remainder:0}}return{index:u,remainder:g.column}}B(i,n){if(n<0)return 0;const t=i.piece,g=this.a[t.bufferIndex].lineStarts,u=t.start.line+n+1;return u>t.end.line?g[t.end.line]+t.end.column-g[t.start.line]-t.start.column:g[u]-g[t.start.line]-t.start.column}C(i,n){const t=i.piece,g=t.lineFeedCnt,u=this.u(t.bufferIndex,t.end),$=n,m=this.u(t.bufferIndex,$),h=this.t(t.bufferIndex,t.start,$),E=h-g,D=m-u,b=t.length+D;i.piece=new S(t.bufferIndex,t.start,$,h,b),(0,A.$iD)(this,i,D,E)}D(i,n){const t=i.piece,g=t.lineFeedCnt,u=this.u(t.bufferIndex,t.start),$=n,m=this.t(t.bufferIndex,$,t.end),h=this.u(t.bufferIndex,$),E=m-g,D=u-h,b=t.length+D;i.piece=new S(t.bufferIndex,$,t.end,m,b),(0,A.$iD)(this,i,D,E)}E(i,n,t){const g=i.piece,u=g.start,$=g.end,m=g.length,h=g.lineFeedCnt,E=n,D=this.t(g.bufferIndex,g.start,E),b=this.u(g.bufferIndex,n)-this.u(g.bufferIndex,u);i.piece=new S(g.bufferIndex,g.start,E,D,b),(0,A.$iD)(this,i,b-m,D-h);const C=new S(g.bufferIndex,t,$,this.t(g.bufferIndex,t,$),this.u(g.bufferIndex,$)-this.u(g.bufferIndex,t)),k=this.S(i,C);this.N(k)}F(i,n){this.Q(n,i)&&(n+=`
`);const t=this.K()&&this.L(n)&&this.M(i),g=this.a[0].buffer.length;this.a[0].buffer+=n;const u=y(n,!1);for(let k=0;k<u.length;k++)u[k]+=g;if(t){const k=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:g-k}}this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1));const $=this.a[0].lineStarts.length-1,m=this.a[0].buffer.length-this.a[0].lineStarts[$],h={line:$,column:m},E=i.piece.length+n.length,D=i.piece.lineFeedCnt,b=this.t(0,i.piece.start,h),C=b-D;i.piece=new S(i.piece.bufferIndex,i.piece.start,h,b,E),this.g=h,(0,A.$iD)(this,i,n.length,C)}G(i){let n=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let g=0;for(;n!==A.$bD;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){g+=n.size_left;const u={node:n,remainder:i-n.size_left,nodeStartOffset:g};return this.h.set(u),u}else i-=n.size_left+n.piece.length,g+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let t=this.root,g=0;for(;t!==A.$bD;)if(t.left!==A.$bD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const u=this.B(t,i-t.lf_left-2),$=this.B(t,i-t.lf_left-1);return g+=t.size_left,{node:t,remainder:Math.min(u+n-1,$),nodeStartOffset:g}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const u=this.B(t,i-t.lf_left-2);if(u+n-1<=t.piece.length)return{node:t,remainder:u+n-1,nodeStartOffset:g};n-=t.piece.length-u;break}else i-=t.lf_left+t.piece.lineFeedCnt,g+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==A.$bD;){if(t.piece.lineFeedCnt>0){const u=this.B(t,0),$=this.J(t);return{node:t,remainder:Math.min(n-1,u),nodeStartOffset:$}}else if(t.piece.length>=n-1){const u=this.J(t);return{node:t,remainder:n-1,nodeStartOffset:u}}else n-=t.piece.length;t=t.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],g=this.u(i.piece.bufferIndex,i.piece.start)+n;return t.buffer.charCodeAt(g)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.$bD||i.piece.lineFeedCnt===0)return!1;const n=i.piece,t=this.a[n.bufferIndex].lineStarts,g=n.start.line,u=t[g]+n.start.column;return g===t.length-1||t[g+1]>u+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(u)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.$bD||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const t=[],g=this.a[i.piece.bufferIndex].lineStarts;let u;i.piece.end.column===0?u={line:i.piece.end.line-1,column:g[i.piece.end.line]-g[i.piece.end.line-1]-1}:u={line:i.piece.end.line,column:i.piece.end.column-1};const $=i.piece.length-1,m=i.piece.lineFeedCnt-1;i.piece=new S(i.piece.bufferIndex,i.piece.start,u,m,$),(0,A.$iD)(this,i,-1,-1),i.piece.length===0&&t.push(i);const h={line:n.piece.start.line+1,column:0},E=n.piece.length-1,D=this.t(n.piece.bufferIndex,h,n.piece.end);n.piece=new S(n.piece.bufferIndex,h,n.piece.end,D,E),(0,A.$iD)(this,n,-1,-1),n.piece.length===0&&t.push(n);const b=this.w(`\r
`);this.S(i,b[0]);for(let C=0;C<t.length;C++)(0,A.$gD)(this,t[C])}Q(i,n){if(this.K()&&this.M(i)){const t=n.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,A.$gD)(this,t);else{const g=t.piece,u={line:g.start.line+1,column:0},$=g.length-1,m=this.t(g.bufferIndex,u,g.end);t.piece=new S(g.bufferIndex,u,g.end,m,$),(0,A.$iD)(this,t,-1,-1)}return!0}}return!1}iterate(i,n){if(i===A.$bD)return n(A.$bD);const t=this.iterate(i.left,n);return t&&n(i)&&this.iterate(i.right,n)}R(i){if(i===A.$bD)return"";const n=this.a[i.piece.bufferIndex],t=i.piece,g=this.u(t.bufferIndex,t.start),u=this.u(t.bufferIndex,t.end);return n.buffer.substring(g,u)}getPieceContent(i){const n=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),g=this.u(i.bufferIndex,i.end);return n.buffer.substring(t,g)}S(i,n){const t=new A.$aD(n,A.NodeColor.Red);if(t.left=A.$bD,t.right=A.$bD,t.parent=A.$bD,t.size_left=0,t.lf_left=0,this.root===A.$bD)this.root=t,t.color=A.NodeColor.Black;else if(i.right===A.$bD)i.right=t,t.parent=i;else{const u=(0,A.$cD)(i.right);u.left=t,t.parent=u}return(0,A.$hD)(this,t),t}T(i,n){const t=new A.$aD(n,A.NodeColor.Red);if(t.left=A.$bD,t.right=A.$bD,t.parent=A.$bD,t.size_left=0,t.lf_left=0,this.root===A.$bD)this.root=t,t.color=A.NodeColor.Black;else if(i.left===A.$bD)i.left=t,t.parent=i;else{const g=(0,A.$dD)(i.left);g.right=t,t.parent=g}return(0,A.$hD)(this,t),t}U(i){let n="";return this.iterate(i,t=>(n+=this.R(t),!0)),n}}e.$uD=c}),define(Ne[161],Le([1,0,6,12,32,52,100,153,155,4]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vD=void 0,R=qe(R);class I extends o.$Uc{constructor(a,S,d,r,s,c,l){super(),this.m=this.B(new v.$le),this.onDidChangeContent=this.m.event,this.f=S,this.j=!c,this.g=r,this.h=s,this.c=new A.$uD(a,d,l)}equals(a){return!(a instanceof I)||this.f!==a.f||this.getEOL()!==a.getEOL()?!1:this.c.equal(a.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(a){return this.c.createSnapshot(a?this.f:"")}getOffsetAt(a,S){return this.c.getOffsetAt(a,S)}getPositionAt(a){return this.c.getPositionAt(a)}getRangeAt(a,S){const d=a+S,r=this.getPositionAt(a),s=this.getPositionAt(d);return new P.$Ot(r.lineNumber,r.column,s.lineNumber,s.column)}getValueInRange(a,S=O.EndOfLinePreference.TextDefined){if(a.isEmpty())return"";const d=this.n(S);return this.c.getValueInRange(a,d)}getValueLengthInRange(a,S=O.EndOfLinePreference.TextDefined){if(a.isEmpty())return 0;if(a.startLineNumber===a.endLineNumber)return a.endColumn-a.startColumn;const d=this.getOffsetAt(a.startLineNumber,a.startColumn),r=this.getOffsetAt(a.endLineNumber,a.endColumn);let s=0;const c=this.n(S),l=this.getEOL();if(c.length!==l.length){const i=c.length-l.length,n=a.endLineNumber-a.startLineNumber;s=i*n}return r-d+s}getCharacterCountInRange(a,S=O.EndOfLinePreference.TextDefined){if(this.j){let d=0;const r=a.startLineNumber,s=a.endLineNumber;for(let c=r;c<=s;c++){const l=this.getLineContent(c),i=c===r?a.startColumn-1:0,n=c===s?a.endColumn-1:l.length;for(let t=i;t<n;t++)R.$Jf(l.charCodeAt(t))?(d=d+1,t=t+1):d=d+1}return d+=this.n(S).length*(s-r),d}return this.getValueLengthInRange(a,S)}getNearestChunk(a){return this.c.getNearestChunk(a)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(a){return this.c.getLineContent(a)}getLineCharCode(a,S){return this.c.getLineCharCode(a,S)}getCharCode(a){return this.c.getCharCode(a)}getLineLength(a){return this.c.getLineLength(a)}getLineMinColumn(a){return 1}getLineMaxColumn(a){return this.getLineLength(a)+1}getLineFirstNonWhitespaceColumn(a){const S=R.$uf(this.getLineContent(a));return S===-1?0:S+1}getLineLastNonWhitespaceColumn(a){const S=R.$wf(this.getLineContent(a));return S===-1?0:S+2}n(a){switch(a){case O.EndOfLinePreference.LF:return`
`;case O.EndOfLinePreference.CRLF:return`\r
`;case O.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(a){this.c.setEOL(a)}applyEdits(a,S,d){let r=this.g,s=this.h,c=this.j,l=!0,i=[];for(let h=0;h<a.length;h++){const E=a[h];l&&E._isTracked&&(l=!1);const D=E.range;if(E.text){let w=!0;c||(w=!R.$Uf(E.text),c=w),!r&&w&&(r=R.$Tf(E.text)),!s&&w&&(s=R.$Wf(E.text))}let b="",C=0,k=0,f=0;if(E.text){let w;[C,k,f,w]=(0,T.$zu)(E.text);const F=this.getEOL(),N=F===`\r
`?T.StringEOL.CRLF:T.StringEOL.LF;w===T.StringEOL.Unknown||w===N?b=E.text:b=E.text.replace(/\r\n|\r|\n/g,F)}i[h]={sortIndex:h,identifier:E.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:b,eolCount:C,firstLineLength:k,lastLineLength:f,forceMoveMarkers:!!E.forceMoveMarkers,isAutoWhitespaceEdit:E.isAutoWhitespaceEdit||!1}}i.sort(I.u);let n=!1;for(let h=0,E=i.length-1;h<E;h++){const D=i[h].range.getEndPosition(),b=i[h+1].range.getStartPosition();if(b.isBeforeOrEqual(D)){if(b.isBefore(D))throw new Error("Overlapping ranges are not allowed!");n=!0}}l&&(i=this.s(i));const t=d||S?I._getInverseEditRanges(i):[],g=[];if(S)for(let h=0;h<i.length;h++){const E=i[h],D=t[h];if(E.isAutoWhitespaceEdit&&E.range.isEmpty())for(let b=D.startLineNumber;b<=D.endLineNumber;b++){let C="";b===D.startLineNumber&&(C=this.getLineContent(E.range.startLineNumber),R.$uf(C)!==-1)||g.push({lineNumber:b,oldContent:C})}}let u=null;if(d){let h=0;u=[];for(let E=0;E<i.length;E++){const D=i[E],b=t[E],C=this.getValueInRange(D.range),k=D.rangeOffset+h;h+=D.text.length-C.length,u[E]={sortIndex:D.sortIndex,identifier:D.identifier,range:b,text:C,textChange:new p.$fu(D.rangeOffset,C,k,D.text)}}n||u.sort((E,D)=>E.sortIndex-D.sortIndex)}this.g=r,this.h=s,this.j=c;const $=this.t(i);let m=null;if(S&&g.length>0){g.sort((h,E)=>E.lineNumber-h.lineNumber),m=[];for(let h=0,E=g.length;h<E;h++){const D=g[h].lineNumber;if(h>0&&g[h-1].lineNumber===D)continue;const b=g[h].oldContent,C=this.getLineContent(D);C.length===0||C===b||R.$uf(C)!==-1||m.push(D)}}return this.m.fire(),new O.$iw(u,$,m)}s(a){return a.length<1e3?a:[this._toSingleEditOperation(a)]}_toSingleEditOperation(a){let S=!1;const d=a[0].range,r=a[a.length-1].range,s=new P.$Ot(d.startLineNumber,d.startColumn,r.endLineNumber,r.endColumn);let c=d.startLineNumber,l=d.startColumn;const i=[];for(let $=0,m=a.length;$<m;$++){const h=a[$],E=h.range;S=S||h.forceMoveMarkers,i.push(this.getValueInRange(new P.$Ot(c,l,E.startLineNumber,E.startColumn))),h.text.length>0&&i.push(h.text),c=E.endLineNumber,l=E.endColumn}const n=i.join(""),[t,g,u]=(0,T.$zu)(n);return{sortIndex:0,identifier:a[0].identifier,range:s,rangeOffset:this.getOffsetAt(s.startLineNumber,s.startColumn),rangeLength:this.getValueLengthInRange(s,O.EndOfLinePreference.TextDefined),text:n,eolCount:t,firstLineLength:g,lastLineLength:u,forceMoveMarkers:S,isAutoWhitespaceEdit:!1}}t(a){a.sort(I.w);const S=[];for(let d=0;d<a.length;d++){const r=a[d],s=r.range.startLineNumber,c=r.range.startColumn,l=r.range.endLineNumber,i=r.range.endColumn;if(s===l&&c===i&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const n=new P.$Ot(s,c,l,i);S.push({range:n,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return S}findMatchesLineByLine(a,S,d,r){return this.c.findMatchesLineByLine(a,S,d,r)}getPieceTree(){return this.c}static _getInverseEditRange(a,S){const d=a.startLineNumber,r=a.startColumn,[s,c,l]=(0,T.$zu)(S);let i;if(S.length>0){const n=s+1;n===1?i=new P.$Ot(d,r,d,r+c):i=new P.$Ot(d,r,d+n-1,l+1)}else i=new P.$Ot(d,r,d,r);return i}static _getInverseEditRanges(a){const S=[];let d=0,r=0,s=null;for(let c=0,l=a.length;c<l;c++){const i=a[c];let n,t;s?s.range.endLineNumber===i.range.startLineNumber?(n=d,t=r+(i.range.startColumn-s.range.endColumn)):(n=d+(i.range.startLineNumber-s.range.endLineNumber),t=i.range.startColumn):(n=i.range.startLineNumber,t=i.range.startColumn);let g;if(i.text.length>0){const u=i.eolCount+1;u===1?g=new P.$Ot(n,t,n,t+i.firstLineLength):g=new P.$Ot(n,t,n+u-1,i.lastLineLength+1)}else g=new P.$Ot(n,t,n,t);d=g.endLineNumber,r=g.endColumn,S.push(g),s=i}return S}static u(a,S){const d=P.$Ot.compareRangesUsingEnds(a.range,S.range);return d===0?a.sortIndex-S.sortIndex:d}static w(a,S){const d=P.$Ot.compareRangesUsingEnds(a.range,S.range);return d===0?S.sortIndex-a.sortIndex:-d}}e.$vD=I}),define(Ne[162],Le([1,0,27,12,52,100,161]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wD=void 0,R=qe(R);class T{constructor(I,y,a,S,d,r,s,c,l){this.a=I,this.b=y,this.c=a,this.d=S,this.e=d,this.f=r,this.g=s,this.h=c,this.j=l}k(I){const y=this.c+this.d+this.e,a=this.c+this.e;return y===0?I===P.DefaultEndOfLine.LF?`
`:`\r
`:a>y/2?`\r
`:`
`}create(I){const y=this.k(I),a=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let d=0,r=a.length;d<r;d++){const s=a[d].buffer.replace(/\r\n|\r|\n/g,y),c=(0,O.$qD)(s);a[d]=new O.$tD(s,c)}const S=new A.$vD(a,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class p{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&R.$5f(I)&&(this.b=R.$4f,I=I.substr(1));const y=I.charCodeAt(I.length-1);y===v.CharCode.CarriageReturn||y>=55296&&y<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=y):(this.m(I,!1),this.c=!1,this.d=y)}m(I,y){!y&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const y=(0,O.$rD)(this.e,I);this.a.push(new O.$tD(I,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=R.$Tf(I)),this.k||(this.k=R.$Wf(I)))}finish(I=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const y=(0,O.$qD)(I.buffer);I.lineStarts=y,this.d===v.CharCode.CarriageReturn&&this.f++}}}e.$wD=p}),define(Ne[103],Le([1,0,22,20]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdb=p,e.$Ydb=I,R=qe(R);var P;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(P||(P={}));function O(y){for(let a=0,S=y.length;a<S;a+=4){const d=y[a+0],r=y[a+1],s=y[a+2],c=y[a+3];y[a+0]=c,y[a+1]=s,y[a+2]=r,y[a+3]=d}}function A(y){const a=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return R.$E()||O(a),v.$Ne.wrap(a)}function T(y){const a=y.buffer;if(R.$E()||O(a),a.byteOffset%4===0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const S=new Uint8Array(a.byteLength);return S.set(a),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function p(y){const a=new Uint32Array(o(y));let S=0;if(a[S++]=y.id,y.type==="full")a[S++]=P.Full,a[S++]=y.data.length,a.set(y.data,S),S+=y.data.length;else{a[S++]=P.Delta,a[S++]=y.deltas.length;for(const d of y.deltas)a[S++]=d.start,a[S++]=d.deleteCount,d.data?(a[S++]=d.data.length,a.set(d.data,S),S+=d.data.length):a[S++]=0}return A(a)}function o(y){let a=0;if(a+=2,y.type==="full")a+=1+y.data.length;else{a+=1,a+=3*y.deltas.length;for(const S of y.deltas)S.data&&(a+=S.data.length)}return a}function I(y){const a=T(y);let S=0;const d=a[S++];if(a[S++]===P.Full){const l=a[S++],i=a.subarray(S,S+l);return S+=l,{id:d,type:"full",data:i}}const s=a[S++],c=[];for(let l=0;l<s;l++){const i=a[S++],n=a[S++],t=a[S++];let g;t>0&&(g=a.subarray(S,S+t),S+=t),c[l]={start:i,deleteCount:n,data:g}}return{id:d,type:"delta",deltas:c}}}),define(Ne[163],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P_=e.$O_=void 0;class v{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const A=this.a.get(O);return this.a.delete(O),A}}addDragOperationTransfer(O,A){this.a.set(O,A)}}e.$O_=v;class R{constructor(O){this.identifier=O}}e.$P_=R}),define(Ne[164],Le([1,0,6,4,9]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=void 0,e.$pj=I,P=qe(P);class O extends R.$Uc{constructor(a,S="",d="",r=!0,s){super(),this.j=this.B(new v.$le),this.onDidChange=this.j.event,this.z=!0,this.m=a,this.n=S,this.w=d,this.z=r,this.D=s}get id(){return this.m}get label(){return this.n}set label(a){this.F(a)}F(a){this.n!==a&&(this.n=a,this.j.fire({label:a}))}get tooltip(){return this.u||""}set tooltip(a){this.G(a)}G(a){this.u!==a&&(this.u=a,this.j.fire({tooltip:a}))}get class(){return this.w}set class(a){this.H(a)}H(a){this.w!==a&&(this.w=a,this.j.fire({class:a}))}get enabled(){return this.z}set enabled(a){this.I(a)}I(a){this.z!==a&&(this.z=a,this.j.fire({enabled:a}))}get checked(){return this.C}set checked(a){this.J(a)}J(a){this.C!==a&&(this.C=a,this.j.fire({checked:a}))}async run(a,S){this.D&&await this.D(a)}}e.$kj=O;class A extends R.$Uc{constructor(){super(...arguments),this.f=this.B(new v.$le),this.onWillRun=this.f.event,this.m=this.B(new v.$le),this.onDidRun=this.m.event}async run(a,S){if(!a.enabled)return;this.f.fire({action:a});let d;try{await this.u(a,S)}catch(r){d=r}this.m.fire({action:a,error:d})}async u(a,S){await a.run(S)}}e.$lj=A;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let S=[];for(const d of a)d.length&&(S.length?S=[...S,new T,...d]:S=d);return S}static{this.ID="vs.actions.separator"}async run(){}}e.$mj=T;class p{get actions(){return this.a}constructor(a,S,d,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=S,this.class=r,this.a=d}async run(){}}e.$nj=p;class o extends O{static{this.ID="vs.actions.empty"}constructor(){super(o.ID,P.localize(13050,null),void 0,!1)}}e.$oj=o;function I(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...a)=>y.run(...a)}}}),define(Ne[165],Le([1,0,9]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=o,e.$3m=I,e.$4m=y;const R=60,P=R*60,O=P*24,A=O*7,T=O*30,p=O*365;function o(a,S,d,r){typeof a!="number"&&(a=a.getTime());const s=Math.round((new Date().getTime()-a)/1e3);if(s<-30)return(0,v.localize)(12987,null,o(new Date().getTime()+s*1e3,!1));if(!r&&s<30)return(0,v.localize)(12988,null);let c;return s<R?(c=s,S?c===1?d?(0,v.localize)(12989,null,c):(0,v.localize)(12990,null,c):d?(0,v.localize)(12991,null,c):(0,v.localize)(12992,null,c):c===1?d?(0,v.localize)(12993,null,c):(0,v.localize)(12994,null,c):d?(0,v.localize)(12995,null,c):(0,v.localize)(12996,null,c)):s<P?(c=Math.floor(s/R),S?c===1?d?(0,v.localize)(12997,null,c):(0,v.localize)(12998,null,c):d?(0,v.localize)(12999,null,c):(0,v.localize)(13e3,null,c):c===1?d?(0,v.localize)(13001,null,c):(0,v.localize)(13002,null,c):d?(0,v.localize)(13003,null,c):(0,v.localize)(13004,null,c)):s<O?(c=Math.floor(s/P),S?c===1?d?(0,v.localize)(13005,null,c):(0,v.localize)(13006,null,c):d?(0,v.localize)(13007,null,c):(0,v.localize)(13008,null,c):c===1?d?(0,v.localize)(13009,null,c):(0,v.localize)(13010,null,c):d?(0,v.localize)(13011,null,c):(0,v.localize)(13012,null,c)):s<A?(c=Math.floor(s/O),S?c===1?(0,v.localize)(13013,null,c):(0,v.localize)(13014,null,c):c===1?(0,v.localize)(13015,null,c):(0,v.localize)(13016,null,c)):s<T?(c=Math.floor(s/A),S?c===1?d?(0,v.localize)(13017,null,c):(0,v.localize)(13018,null,c):d?(0,v.localize)(13019,null,c):(0,v.localize)(13020,null,c):c===1?d?(0,v.localize)(13021,null,c):(0,v.localize)(13022,null,c):d?(0,v.localize)(13023,null,c):(0,v.localize)(13024,null,c)):s<p?(c=Math.floor(s/T),S?c===1?d?(0,v.localize)(13025,null,c):(0,v.localize)(13026,null,c):d?(0,v.localize)(13027,null,c):(0,v.localize)(13028,null,c):c===1?d?(0,v.localize)(13029,null,c):(0,v.localize)(13030,null,c):d?(0,v.localize)(13031,null,c):(0,v.localize)(13032,null,c)):(c=Math.floor(s/p),S?c===1?d?(0,v.localize)(13033,null,c):(0,v.localize)(13034,null,c):d?(0,v.localize)(13035,null,c):(0,v.localize)(13036,null,c):c===1?d?(0,v.localize)(13037,null,c):(0,v.localize)(13038,null,c):d?(0,v.localize)(13039,null,c):(0,v.localize)(13040,null,c))}function I(a,S){const d=Math.abs(a/1e3);return d<1?S?(0,v.localize)(13041,null,a):(0,v.localize)(13042,null,a):d<R?S?(0,v.localize)(13043,null,Math.round(a)/1e3):(0,v.localize)(13044,null,Math.round(a)/1e3):d<P?S?(0,v.localize)(13045,null,Math.round(a/(1e3*R))):(0,v.localize)(13046,null,Math.round(a/(1e3*R))):d<O?S?(0,v.localize)(13047,null,Math.round(a/(1e3*P))):(0,v.localize)(13048,null,Math.round(a/(1e3*P))):(0,v.localize)(13049,null,Math.round(a/(1e3*O)))}function y(a){return a.getFullYear()+"-"+String(a.getMonth()+1).padStart(2,"0")+"-"+String(a.getDate()).padStart(2,"0")+"T"+String(a.getHours()).padStart(2,"0")+":"+String(a.getMinutes()).padStart(2,"0")+":"+String(a.getSeconds()).padStart(2,"0")+"."+(a.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ne[42],Le([1,0,17,14,9]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=p,e.$rj=o,e.$sj=I,v=qe(v),R=qe(R),P=qe(P);function O(y,a){return a&&(y.stack||y.stacktrace)?P.localize(12981,null,T(y),A(y.stack)||A(y.stacktrace)):T(y)}function A(y){return Array.isArray(y)?y.join(`
`):y}function T(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?P.localize(12982,null,y.message):y.message||P.localize(12983,null)}function p(y=null,a=!1){if(!y)return P.localize(12984,null);if(Array.isArray(y)){const S=v.$Gb(y),d=p(S[0],a);return S.length>1?P.localize(12985,null,d,S.length):d}if(R.$eg(y))return y;if(y.detail){const S=y.detail;if(S.error)return O(S.error,a);if(S.exception)return O(S.exception,a)}return y.stack?O(y,a):y.message?y.message:P.localize(12986,null)}function o(y){const a=y;return a instanceof Error&&Array.isArray(a.actions)}function I(y,a){let S;return typeof y=="string"?S=new Error(y):S=y,S.actions=a,S}}),define(Ne[166],Le([1,0,27,13,9]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.TokenType=void 0;var O;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(O||(e.TokenType=O={}));function A(...I){switch(I.length){case 1:return(0,P.localize)(11585,null,I[0]);case 2:return(0,P.localize)(11586,null,I[0],I[1]);case 3:return(0,P.localize)(11587,null,I[0],I[1],I[2]);default:return}}const T=(0,P.localize)(11588,null),p=(0,P.localize)(11589,null);class o{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return y.isTripleEq?"===":"==";case O.NotEq:return y.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return y.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return y.lexeme;case O.QuotedStr:return y.lexeme;case O.Error:return y.lexeme;case O.EOF:return"EOF";default:throw(0,R.$7)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case v.CharCode.OpenParen:this.k(O.LParen);break;case v.CharCode.CloseParen:this.k(O.RParen);break;case v.CharCode.ExclamationMark:if(this.h(v.CharCode.Equals)){const a=this.h(v.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:a})}else this.k(O.Neg);break;case v.CharCode.SingleQuote:this.o();break;case v.CharCode.Slash:this.q();break;case v.CharCode.Equals:if(this.h(v.CharCode.Equals)){const a=this.h(v.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:a})}else this.h(v.CharCode.Tilde)?this.k(O.RegexOp):this.l(A("==","=~"));break;case v.CharCode.LessThan:this.k(this.h(v.CharCode.Equals)?O.LtEq:O.Lt);break;case v.CharCode.GreaterThan:this.k(this.h(v.CharCode.Equals)?O.GtEq:O.Gt);break;case v.CharCode.Ampersand:this.h(v.CharCode.Ampersand)?this.k(O.And):this.l(A("&&"));break;case v.CharCode.Pipe:this.h(v.CharCode.Pipe)?this.k(O.Or):this.l(A("||"));break;case v.CharCode.Space:case v.CharCode.CarriageReturn:case v.CharCode.Tab:case v.CharCode.LineFeed:case v.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?v.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const a=this.d,S=this.c.substring(this.d,this.e),d={type:O.Error,offset:this.d,lexeme:S};this.g.push({offset:a,lexeme:S,additionalInfo:y}),this.f.push(d)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const a=this.c.substring(this.d,this.e),S=o.b.get(a);S?this.k(S):this.f.push({type:O.Str,lexeme:a,offset:this.d})}}o(){for(;this.j()!==v.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,a=!1,S=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(p);return}const r=this.c.charCodeAt(y);if(a)a=!1;else if(r===v.CharCode.Slash&&!S){y++;break}else r===v.CharCode.OpenSquareBracket?S=!0:r===v.CharCode.Backslash?a=!0:r===v.CharCode.CloseSquareBracket&&(S=!1);y++}for(;y<this.c.length&&o.a.has(this.c.charCodeAt(y));)y++;this.e=y;const d=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Aj=o}),define(Ne[104],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const v={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(v)}),define(Ne[73],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class v{constructor(P,O=[],A=!1){this.ctor=P,this.staticArguments=O,this.supportsDelayedInstantiation=A}}e.$Ci=v}),define(Ne[60],Le([1,0,73]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Rs=O,e.$Ss=A;const R=[];var P;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function O(T,p,o){p instanceof v.$Ci||(p=new v.$Ci(p,[],!!o)),R.push([T,p])}function A(){return R}}),define(Ne[167],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=void 0;class v{constructor(O,A){this.key=O,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$ur=v;class R{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const A of this.a.values())A.outgoing.size===0&&O.push(A);return O}insertEdge(O,A){const T=this.lookupOrInsertNode(O),p=this.lookupOrInsertNode(A);T.outgoing.set(p.key,p),p.incoming.set(T.key,T)}removeNode(O){const A=this.b(O);this.a.delete(A);for(const T of this.a.values())T.outgoing.delete(A),T.incoming.delete(A)}lookupOrInsertNode(O){const A=this.b(O);let T=this.a.get(A);return T||(T=new v(A,O),this.a.set(A,T)),T}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[A,T]of this.a)O.push(`${A}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,A]of this.a){const T=new Set([O]),p=this.c(A,T);if(p)return p}}c(O,A){for(const[T,p]of O.outgoing){if(A.has(T))return[...A,T].join(" -> ");A.add(T);const o=this.c(p,A);if(o)return o;A.delete(T)}}}e.$vr=R}),define(Ne[3],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=P,e.$Gi=O;var v;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function T(p){return p[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=T})(v||(e._util=v={})),e.$Ei=P("instantiationService");function R(A,T,p){T[v.DI_TARGET]===T?T[v.DI_DEPENDENCIES].push({id:A,index:p}):(T[v.DI_DEPENDENCIES]=[{id:A,index:p}],T[v.DI_TARGET]=T)}function P(A){if(v.serviceIds.has(A))return v.serviceIds.get(A);const T=function(p,o,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(T,p,I)};return T.toString=()=>A,v.serviceIds.set(A,T),T}function O(A){return A}}),define(Ne[43],Le([1,0,14,2,3]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$_i=void 0,e.$aj=O,e.$bj=A,e.$cj=p,e.$dj=o,e.$ej=I,e.$fj=y,e.$gj=a,e.$hj=d,e.$ij=r,e.$jj=s,v=qe(v),e.$_i=(0,P.$Fi)("configurationService");function O(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof R.URI)}function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof R.URI)}var T;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function p(c){switch(c){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function o(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function I(c,l){const i=Object.create(null);for(const n in c)y(i,n,c[n],l);return i}function y(c,l,i,n){const t=l.split("."),g=t.pop();let u=c;for(let $=0;$<t.length;$++){const m=t[$];let h=u[m];switch(typeof h){case"undefined":h=u[m]=Object.create(null);break;case"object":if(h===null){n(`Ignoring ${l} as ${t.slice(0,$+1).join(".")} is null`);return}break;default:n(`Ignoring ${l} as ${t.slice(0,$+1).join(".")} is ${JSON.stringify(h)}`);return}u=h}if(typeof u=="object"&&u!==null)try{u[g]=i}catch{n(`Ignoring ${l} as ${t.join(".")} is ${JSON.stringify(u)}`)}else n(`Ignoring ${l} as ${t.join(".")} is ${JSON.stringify(u)}`)}function a(c,l){const i=l.split(".");S(c,i)}function S(c,l){const i=l.shift();if(l.length===0){delete c[i];return}if(Object.keys(c).indexOf(i)!==-1){const n=c[i];typeof n=="object"&&!Array.isArray(n)&&(S(n,l),Object.keys(n).length===0&&delete c[i])}}function d(c,l,i){function n(u,$){let m=u;for(const h of $){if(typeof m!="object"||m===null)return;m=m[h]}return m}const t=l.split("."),g=n(c,t);return typeof g>"u"?i:g}function r(c,l,i){Object.keys(l).forEach(n=>{n!=="__proto__"&&(n in c?v.$gg(c[n])&&v.$gg(l[n])?r(c[n],l[n],i):i&&(c[n]=l[n]):c[n]=l[n])})}function s(c){return c.replace(/[\[\]]/g,"")}}),define(Ne[31],Le([1,0,27,20,12,166,3,9,13]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Dj=e.$Cj=e.ContextKeyExprType=void 0,e.$Bj=I,e.$Ej=$,e.$Fj=m,e.$Yj=oe;const o=new Map;o.set("false",!1),o.set("true",!0),o.set("isMac",R.$k),o.set("isLinux",R.$l),o.set("isWindows",R.$j),o.set("isWeb",R.$p),o.set("isMacNative",R.$k&&!R.$p),o.set("isEdge",R.$I),o.set("isFirefox",R.$G),o.set("isChrome",R.$F),o.set("isSafari",R.$H);function I(Y,B){if(o.get(Y)!==void 0)throw(0,p.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");o.set(Y,B)}const y=Object.prototype.hasOwnProperty;var a;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(a||(e.ContextKeyExprType=a={}));const S={regexParsingWithErrorRecovery:!0},d=(0,T.localize)(11599,null),r=(0,T.localize)(11600,null),s=(0,T.localize)(11601,null),c=(0,T.localize)(11602,null),l=(0,T.localize)(11603,null),i=(0,T.localize)(11604,null),n=(0,T.localize)(11605,null),t=(0,T.localize)(11606,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=S){this.k=B,this.d=new O.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:r});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const Ee=this.D(),fe=Ee.type===O.TokenType.Str?i:void 0;throw this.h.push({message:l,offset:Ee.offset,lexeme:O.$Aj.getLexeme(Ee),additionalInfo:fe}),g.c}return ne}catch(ne){if(ne!==g.c)throw ne;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(O.TokenType.Or);){const ne=this.o();B.push(ne)}return B.length===1?B[0]:u.or(...B)}o(){const B=[this.s()];for(;this.y(O.TokenType.And);){const ne=this.s();B.push(ne)}return B.length===1?B[0]:u.and(...B)}s(){if(this.y(O.TokenType.Neg)){const B=this.D();switch(B.type){case O.TokenType.True:return this.z(),E.INSTANCE;case O.TokenType.False:return this.z(),D.INSTANCE;case O.TokenType.LParen:{this.z();const ne=this.l();return this.A(O.TokenType.RParen,c),ne?.negate()}case O.TokenType.Str:return this.z(),F.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case O.TokenType.True:return this.z(),u.true();case O.TokenType.False:return this.z(),u.false();case O.TokenType.LParen:{this.z();const ne=this.l();return this.A(O.TokenType.RParen,c),ne}case O.TokenType.Str:{const ne=B.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const fe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),fe.type!==O.TokenType.RegexStr)throw this.B("REGEX",fe);const we=fe.lexeme,he=we.lastIndexOf("/"),X=he===we.length-1?void 0:this.w(we.substring(he+1));let x;try{x=new RegExp(we.substring(1,he),X)}catch{throw this.B("REGEX",fe)}return G.create(ne,x)}switch(fe.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const we=[fe.lexeme];this.z();let he=this.D(),X=0;for(let ze=0;ze<fe.lexeme.length;ze++)fe.lexeme.charCodeAt(ze)===v.CharCode.OpenParen?X++:fe.lexeme.charCodeAt(ze)===v.CharCode.CloseParen&&X--;for(;!this.E()&&he.type!==O.TokenType.And&&he.type!==O.TokenType.Or;){switch(he.type){case O.TokenType.LParen:X++;break;case O.TokenType.RParen:X--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let ze=0;ze<he.lexeme.length;ze++)he.lexeme.charCodeAt(ze)===v.CharCode.OpenParen?X++:fe.lexeme.charCodeAt(ze)===v.CharCode.CloseParen&&X--}if(X<0)break;we.push(O.$Aj.getLexeme(he)),this.z(),he=this.D()}const x=we.join(""),$e=x.lastIndexOf("/"),pe=$e===x.length-1?void 0:this.w(x.substring($e+1));let Ae;try{Ae=new RegExp(x.substring(1,$e),pe)}catch{throw this.B("REGEX",fe)}return u.regex(ne,Ae)}case O.TokenType.QuotedStr:{const we=fe.lexeme;this.z();let he=null;if(!(0,P.$cf)(we)){const X=we.indexOf("/"),x=we.lastIndexOf("/");if(X!==x&&X>=0){const $e=we.slice(X+1,x),pe=we[x+1]==="i"?"i":"";try{he=new RegExp($e,pe)}catch{throw this.B("REGEX",fe)}}}if(he===null)throw this.B("REGEX",fe);return G.create(ne,he)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,s);const fe=this.u();return u.notIn(ne,fe)}switch(this.D().type){case O.TokenType.Eq:{this.z();const fe=this.u();if(this.x().type===O.TokenType.QuotedStr)return u.equals(ne,fe);switch(fe){case"true":return u.has(ne);case"false":return u.not(ne);default:return u.equals(ne,fe)}}case O.TokenType.NotEq:{this.z();const fe=this.u();if(this.x().type===O.TokenType.QuotedStr)return u.notEquals(ne,fe);switch(fe){case"true":return u.not(ne);case"false":return u.has(ne);default:return u.notEquals(ne,fe)}}case O.TokenType.Lt:return this.z(),H.create(ne,this.u());case O.TokenType.LtEq:return this.z(),W.create(ne,this.u());case O.TokenType.Gt:return this.z(),L.create(ne,this.u());case O.TokenType.GtEq:return this.z(),q.create(ne,this.u());case O.TokenType.In:return this.z(),u.in(ne,this.u());default:return u.has(ne)}}case O.TokenType.EOF:throw this.h.push({message:n,offset:B.offset,lexeme:"",additionalInfo:t}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),B.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,ne){if(this.C(B))return this.z();throw this.B(ne,this.D())}B(B,ne,Ee){const fe=(0,T.localize)(11607,null,B,O.$Aj.getLexeme(ne)),we=ne.offset,he=O.$Aj.getLexeme(ne);return this.h.push({message:fe,offset:we,lexeme:he,additionalInfo:Ee}),g.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}e.$Cj=g;class u{static false(){return E.INSTANCE}static true(){return D.INSTANCE}static has(B){return b.create(B)}static equals(B,ne){return C.create(B,ne)}static notEquals(B,ne){return w.create(B,ne)}static regex(B,ne){return G.create(B,ne)}static in(B,ne){return k.create(B,ne)}static notIn(B,ne){return f.create(B,ne)}static not(B){return F.create(B)}static and(...B){return be.create(B,null,!0)}static or(...B){return le.create(B,null,!0)}static greater(B,ne){return L.create(B,ne)}static greaterEquals(B,ne){return q.create(B,ne)}static smaller(B,ne){return H.create(B,ne)}static smallerEquals(B,ne){return W.create(B,ne)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$Dj=u;function $(Y){const B=new g({regexParsingWithErrorRecovery:!1});return Y.map(ne=>(B.parse(ne),B.lexingErrors.length>0?B.lexingErrors.map(Ee=>({errorMessage:Ee.additionalInfo?(0,T.localize)(11608,null,Ee.additionalInfo):(0,T.localize)(11609,null),offset:Ee.offset,length:Ee.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(Ee=>({errorMessage:Ee.additionalInfo?`${Ee.message}. ${Ee.additionalInfo}`:Ee.message,offset:Ee.offset,length:Ee.lexeme.length})):[]))}function m(Y,B){const ne=Y?Y.substituteConstants():void 0,Ee=B?B.substituteConstants():void 0;return!ne&&!Ee?!0:!ne||!Ee?!1:ne.equals(Ee)}function h(Y,B){return Y.cmp(B)}class E{static{this.INSTANCE=new E}constructor(){this.type=a.False}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return D.INSTANCE}}e.$Gj=E;class D{static{this.INSTANCE=new D}constructor(){this.type=a.True}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return E.INSTANCE}}e.$Hj=D;class b{static create(B,ne=null){const Ee=o.get(B);return typeof Ee=="boolean"?Ee?D.INSTANCE:E.INSTANCE:new b(B,ne)}constructor(B,ne){this.key=B,this.c=ne,this.type=a.Defined}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=o.get(this.key);return typeof B=="boolean"?B?D.INSTANCE:E.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Ij=b;class C{static create(B,ne,Ee=null){if(typeof ne=="boolean")return ne?b.create(B,Ee):F.create(B,Ee);const fe=o.get(B);return typeof fe=="boolean"?ne===(fe?"true":"false")?D.INSTANCE:E.INSTANCE:new C(B,ne,Ee)}constructor(B,ne,Ee){this.c=B,this.d=ne,this.f=Ee,this.type=a.Equals}cmp(B){return B.type!==this.type?this.type-B.type:me(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=o.get(this.c);if(typeof B=="boolean"){const ne=B?"true":"false";return this.d===ne?D.INSTANCE:E.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Jj=C;class k{static create(B,ne){return new k(B,ne)}constructor(B,ne){this.d=B,this.f=ne,this.type=a.In,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:me(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const ne=B.getValue(this.f),Ee=B.getValue(this.d);return Array.isArray(ne)?ne.includes(Ee):typeof Ee=="string"&&typeof ne=="object"&&ne!==null?y.call(ne,Ee):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$Kj=k;class f{static create(B,ne){return new f(B,ne)}constructor(B,ne){this.d=B,this.f=ne,this.type=a.NotIn,this.c=k.create(B,ne)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Lj=f;class w{static create(B,ne,Ee=null){if(typeof ne=="boolean")return ne?F.create(B,Ee):b.create(B,Ee);const fe=o.get(B);return typeof fe=="boolean"?ne===(fe?"true":"false")?E.INSTANCE:D.INSTANCE:new w(B,ne,Ee)}constructor(B,ne,Ee){this.c=B,this.d=ne,this.f=Ee,this.type=a.NotEquals}cmp(B){return B.type!==this.type?this.type-B.type:me(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=o.get(this.c);if(typeof B=="boolean"){const ne=B?"true":"false";return this.d===ne?E.INSTANCE:D.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Mj=w;class F{static create(B,ne=null){const Ee=o.get(B);return typeof Ee=="boolean"?Ee?E.INSTANCE:D.INSTANCE:new F(B,ne)}constructor(B,ne){this.c=B,this.d=ne,this.type=a.Not}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=o.get(this.c);return typeof B=="boolean"?B?E.INSTANCE:D.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$Nj=F;function N(Y,B){if(typeof Y=="string"){const ne=parseFloat(Y);isNaN(ne)||(Y=ne)}return typeof Y=="string"||typeof Y=="number"?B(Y):E.INSTANCE}class L{static create(B,ne,Ee=null){return N(ne,fe=>new L(B,fe,Ee))}constructor(B,ne,Ee){this.c=B,this.d=ne,this.f=Ee,this.type=a.Greater}cmp(B){return B.type!==this.type?this.type-B.type:me(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Oj=L;class q{static create(B,ne,Ee=null){return N(ne,fe=>new q(B,fe,Ee))}constructor(B,ne,Ee){this.c=B,this.d=ne,this.f=Ee,this.type=a.GreaterEquals}cmp(B){return B.type!==this.type?this.type-B.type:me(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.$Pj=q;class H{static create(B,ne,Ee=null){return N(ne,fe=>new H(B,fe,Ee))}constructor(B,ne,Ee){this.c=B,this.d=ne,this.f=Ee,this.type=a.Smaller}cmp(B){return B.type!==this.type?this.type-B.type:me(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Qj=H;class W{static create(B,ne,Ee=null){return N(ne,fe=>new W(B,fe,Ee))}constructor(B,ne,Ee){this.c=B,this.d=ne,this.f=Ee,this.type=a.SmallerEquals}cmp(B){return B.type!==this.type?this.type-B.type:me(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Rj=W;class G{static create(B,ne){return new G(B,ne)}constructor(B,ne){this.d=B,this.f=ne,this.type=a.Regex,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const ne=this.f?this.f.source:"",Ee=B.f?B.f.source:"";return ne<Ee?-1:ne>Ee?1:0}equals(B){if(B.type===this.type){const ne=this.f?this.f.source:"",Ee=B.f?B.f.source:"";return this.d===B.d&&ne===Ee}return!1}substituteConstants(){return this}evaluate(B){const ne=B.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Q.create(this)),this.c}}e.$Sj=G;class Q{static create(B){return new Q(B)}constructor(B){this.c=B,this.type=a.NotRegex}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new Q(this.c.map(B))}negate(){return this.c}}e.$Tj=Q;function ae(Y){let B=null;for(let ne=0,Ee=Y.length;ne<Ee;ne++){const fe=Y[ne].substituteConstants();if(Y[ne]!==fe&&B===null){B=[];for(let we=0;we<ne;we++)B[we]=Y[we]}B!==null&&(B[ne]=fe)}return B===null?Y:B}class be{static create(B,ne,Ee){return be.d(B,ne,Ee)}constructor(B,ne){this.expr=B,this.c=ne,this.type=a.And}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ne=0,Ee=this.expr.length;ne<Ee;ne++){const fe=h(this.expr[ne],B.expr[ne]);if(fe!==0)return fe}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ne=0,Ee=this.expr.length;ne<Ee;ne++)if(!this.expr[ne].equals(B.expr[ne]))return!1;return!0}return!1}substituteConstants(){const B=ae(this.expr);return B===this.expr?this:be.create(B,this.c,!1)}evaluate(B){for(let ne=0,Ee=this.expr.length;ne<Ee;ne++)if(!this.expr[ne].evaluate(B))return!1;return!0}static d(B,ne,Ee){const fe=[];let we=!1;for(const he of B)if(he){if(he.type===a.True){we=!0;continue}if(he.type===a.False)return E.INSTANCE;if(he.type===a.And){fe.push(...he.expr);continue}fe.push(he)}if(fe.length===0&&we)return D.INSTANCE;if(fe.length!==0){if(fe.length===1)return fe[0];fe.sort(h);for(let he=1;he<fe.length;he++)fe[he-1].equals(fe[he])&&(fe.splice(he,1),he--);if(fe.length===1)return fe[0];for(;fe.length>1;){const he=fe[fe.length-1];if(he.type!==a.Or)break;fe.pop();const X=fe.pop(),x=fe.length===0,$e=le.create(he.expr.map(pe=>be.create([pe,X],null,Ee)),null,x);$e&&(fe.push($e),fe.sort(h))}if(fe.length===1)return fe[0];if(Ee){for(let he=0;he<fe.length;he++)for(let X=he+1;X<fe.length;X++)if(fe[he].negate().equals(fe[X]))return E.INSTANCE;if(fe.length===1)return fe[0]}return new be(fe,ne)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const ne of this.expr)B.push(...ne.keys());return B}map(B){return new be(this.expr.map(ne=>ne.map(B)),null)}negate(){if(!this.c){const B=[];for(const ne of this.expr)B.push(ne.negate());this.c=le.create(B,this,!0)}return this.c}}e.$Uj=be;class le{static create(B,ne,Ee){return le.d(B,ne,Ee)}constructor(B,ne){this.expr=B,this.c=ne,this.type=a.Or}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ne=0,Ee=this.expr.length;ne<Ee;ne++){const fe=h(this.expr[ne],B.expr[ne]);if(fe!==0)return fe}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ne=0,Ee=this.expr.length;ne<Ee;ne++)if(!this.expr[ne].equals(B.expr[ne]))return!1;return!0}return!1}substituteConstants(){const B=ae(this.expr);return B===this.expr?this:le.create(B,this.c,!1)}evaluate(B){for(let ne=0,Ee=this.expr.length;ne<Ee;ne++)if(this.expr[ne].evaluate(B))return!0;return!1}static d(B,ne,Ee){let fe=[],we=!1;if(B){for(let he=0,X=B.length;he<X;he++){const x=B[he];if(x){if(x.type===a.False){we=!0;continue}if(x.type===a.True)return D.INSTANCE;if(x.type===a.Or){fe=fe.concat(x.expr);continue}fe.push(x)}}if(fe.length===0&&we)return E.INSTANCE;fe.sort(h)}if(fe.length!==0){if(fe.length===1)return fe[0];for(let he=1;he<fe.length;he++)fe[he-1].equals(fe[he])&&(fe.splice(he,1),he--);if(fe.length===1)return fe[0];if(Ee){for(let he=0;he<fe.length;he++)for(let X=he+1;X<fe.length;X++)if(fe[he].negate().equals(fe[X]))return D.INSTANCE;if(fe.length===1)return fe[0]}return new le(fe,ne)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const ne of this.expr)B.push(...ne.keys());return B}map(B){return new le(this.expr.map(ne=>ne.map(B)),null)}negate(){if(!this.c){const B=[];for(const ne of this.expr)B.push(ne.negate());for(;B.length>1;){const ne=B.shift(),Ee=B.shift(),fe=[];for(const we of Te(ne))for(const he of Te(Ee))fe.push(be.create([we,he],null,!1));B.unshift(le.create(fe,null,!1))}this.c=le.create(B,this,!0)}return this.c}}e.$Vj=le;class _ extends b{static{this.d=[]}static all(){return _.d.values()}constructor(B,ne,Ee){super(B,null),this.f=ne,typeof Ee=="object"?_.d.push({...Ee,key:B}):Ee!==!0&&_.d.push({key:B,description:Ee,type:ne!=null?typeof ne:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return C.create(this.key,B)}notEqualsTo(B){return w.create(this.key,B)}}e.$Wj=_,e.$Xj=(0,A.$Fi)("contextKeyService");function ce(Y,B){return Y<B?-1:Y>B?1:0}function me(Y,B,ne,Ee){return Y<ne?-1:Y>ne?1:B<Ee?-1:B>Ee?1:0}function oe(Y,B){if(Y.type===a.False||B.type===a.True)return!0;if(Y.type===a.Or)return B.type===a.Or?ke(Y.expr,B.expr):!1;if(B.type===a.Or){for(const ne of B.expr)if(oe(Y,ne))return!0;return!1}if(Y.type===a.And){if(B.type===a.And)return ke(B.expr,Y.expr);for(const ne of Y.expr)if(oe(ne,B))return!0;return!1}return Y.equals(B)}function ke(Y,B){let ne=0,Ee=0;for(;ne<Y.length&&Ee<B.length;){const fe=Y[ne].cmp(B[Ee]);if(fe<0)return!1;fe===0&&ne++,Ee++}return ne===Y.length}function Te(Y){return Y.type===a.Or?Y.expr:[Y]}}),define(Ne[168],Le([1,0,31,3]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=e.$st=e.AccessibilitySupport=e.$rt=void 0,e.$tt=O,e.$rt=(0,R.$Fi)("accessibilityService");var P;(function(A){A[A.Unknown=0]="Unknown",A[A.Disabled=1]="Disabled",A[A.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.$st=new v.$Wj("accessibilityModeEnabled",!1);function O(A){return A&&typeof A=="object"&&typeof A.label=="string"&&(typeof A.role>"u"||typeof A.role=="string")}e.$ut="ACCESSIBLE_VIEW_SHOWN_"}),define(Ne[105],Le([1,0,17,25,20,146,280,156,169,9,168]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=u,e.stringSet=h,e.cursorStyleToString=N,e.filterValidationDecorations=Pe,v=qe(v),R=qe(R),P=qe(P),o=qe(o);var y;(function(ie){ie[ie.None=0]="None",ie[ie.Keep=1]="Keep",ie[ie.Brackets=2]="Brackets",ie[ie.Advanced=3]="Advanced",ie[ie.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class a{constructor(ee){this.c=ee}hasChanged(ee){return this.c[ee]}}e.ConfigurationChangedEvent=a;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class d{constructor(ee,Z,Xe,xe){this.id=ee,this.name=Z,this.defaultValue=Xe,this.schema=xe}applyUpdate(ee,Z){return s(ee,Z)}compute(ee,Z,Xe){return Xe}}class r{constructor(ee,Z){this.newValue=ee,this.didChange=Z}}e.ApplyUpdateResult=r;function s(ie,ee){if(typeof ie!="object"||typeof ee!="object"||!ie||!ee)return new r(ee,ie!==ee);if(Array.isArray(ie)||Array.isArray(ee)){const Xe=Array.isArray(ie)&&Array.isArray(ee)&&v.$tb(ie,ee);return new r(ee,!Xe)}let Z=!1;for(const Xe in ee)if(ee.hasOwnProperty(Xe)){const xe=s(ie[Xe],ee[Xe]);xe.didChange&&(ie[Xe]=xe.newValue,Z=!0)}return new r(ie,Z)}class c{constructor(ee){this.schema=void 0,this.id=ee,this.name="_never_",this.defaultValue=void 0}applyUpdate(ee,Z){return s(ee,Z)}validate(ee){return this.defaultValue}}class l{constructor(ee,Z,Xe,xe){this.id=ee,this.name=Z,this.defaultValue=Xe,this.schema=xe}applyUpdate(ee,Z){return s(ee,Z)}validate(ee){return typeof ee>"u"?this.defaultValue:ee}compute(ee,Z,Xe){return Xe}}function i(ie,ee){return typeof ie>"u"?ee:ie==="false"?!1:!!ie}class n extends l{constructor(ee,Z,Xe,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Xe),super(ee,Z,Xe,xe)}validate(ee){return i(ee,this.defaultValue)}}function t(ie,ee,Z,Xe){if(typeof ie>"u")return ee;let xe=parseInt(ie,10);return isNaN(xe)?ee:(xe=Math.max(Z,xe),xe=Math.min(Xe,xe),xe|0)}class g extends l{static clampedInt(ee,Z,Xe,xe){return t(ee,Z,Xe,xe)}constructor(ee,Z,Xe,xe,ht,wt=void 0){typeof wt<"u"&&(wt.type="integer",wt.default=Xe,wt.minimum=xe,wt.maximum=ht),super(ee,Z,Xe,wt),this.minimum=xe,this.maximum=ht}validate(ee){return g.clampedInt(ee,this.defaultValue,this.minimum,this.maximum)}}function u(ie,ee,Z,Xe){if(typeof ie>"u")return ee;const xe=$.float(ie,ee);return $.clamp(xe,Z,Xe)}class $ extends l{static clamp(ee,Z,Xe){return ee<Z?Z:ee>Xe?Xe:ee}static float(ee,Z){if(typeof ee=="number")return ee;if(typeof ee>"u")return Z;const Xe=parseFloat(ee);return isNaN(Xe)?Z:Xe}constructor(ee,Z,Xe,xe,ht){typeof ht<"u"&&(ht.type="number",ht.default=Xe),super(ee,Z,Xe,ht),this.validationFn=xe}validate(ee){return this.validationFn($.float(ee,this.defaultValue))}}class m extends l{static string(ee,Z){return typeof ee!="string"?Z:ee}constructor(ee,Z,Xe,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Xe),super(ee,Z,Xe,xe)}validate(ee){return m.string(ee,this.defaultValue)}}function h(ie,ee,Z,Xe){return typeof ie!="string"?ee:Xe&&ie in Xe?Xe[ie]:Z.indexOf(ie)===-1?ee:ie}class E extends l{constructor(ee,Z,Xe,xe,ht=void 0){typeof ht<"u"&&(ht.type="string",ht.enum=xe,ht.default=Xe),super(ee,Z,Xe,ht),this.c=xe}validate(ee){return h(ee,this.defaultValue,this.c)}}class D extends d{constructor(ee,Z,Xe,xe,ht,wt,Ft=void 0){typeof Ft<"u"&&(Ft.type="string",Ft.enum=ht,Ft.default=xe),super(ee,Z,Xe,Ft),this.c=ht,this.d=wt}validate(ee){return typeof ee!="string"?this.defaultValue:this.c.indexOf(ee)===-1?this.defaultValue:this.d(ee)}}function b(ie){switch(ie){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class C extends d{constructor(){super(je.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(11775,null),o.localize(11776,null),o.localize(11777,null)],default:"auto",tags:["accessibility"],description:o.localize(11778,null)})}validate(ee){switch(ee){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(ee,Z,Xe){return Xe===I.AccessibilitySupport.Unknown?ee.accessibilitySupport:Xe}}class k extends d{constructor(){const ee={insertSpace:!0,ignoreEmptyLines:!0};super(je.comments,"comments",ee,{"editor.comments.insertSpace":{type:"boolean",default:ee.insertSpace,description:o.localize(11779,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ee.ignoreEmptyLines,description:o.localize(11780,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Z=ee;return{insertSpace:i(Z.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(Z.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var f;(function(ie){ie[ie.Hidden=0]="Hidden",ie[ie.Blink=1]="Blink",ie[ie.Smooth=2]="Smooth",ie[ie.Phase=3]="Phase",ie[ie.Expand=4]="Expand",ie[ie.Solid=5]="Solid"})(f||(e.TextEditorCursorBlinkingStyle=f={}));function w(ie){switch(ie){case"blink":return f.Blink;case"smooth":return f.Smooth;case"phase":return f.Phase;case"expand":return f.Expand;case"solid":return f.Solid}}var F;(function(ie){ie[ie.Line=1]="Line",ie[ie.Block=2]="Block",ie[ie.Underline=3]="Underline",ie[ie.LineThin=4]="LineThin",ie[ie.BlockOutline=5]="BlockOutline",ie[ie.UnderlineThin=6]="UnderlineThin"})(F||(e.TextEditorCursorStyle=F={}));function N(ie){switch(ie){case F.Line:return"line";case F.Block:return"block";case F.Underline:return"underline";case F.LineThin:return"line-thin";case F.BlockOutline:return"block-outline";case F.UnderlineThin:return"underline-thin"}}function L(ie){switch(ie){case"line":return F.Line;case"block":return F.Block;case"underline":return F.Underline;case"line-thin":return F.LineThin;case"block-outline":return F.BlockOutline;case"underline-thin":return F.UnderlineThin}}class q extends c{constructor(){super(je.editorClassName)}compute(ee,Z,Xe){const xe=["monaco-editor"];return Z.get(je.extraEditorClassName)&&xe.push(Z.get(je.extraEditorClassName)),ee.extraEditorClassName&&xe.push(ee.extraEditorClassName),Z.get(je.mouseStyle)==="default"?xe.push("mouse-default"):Z.get(je.mouseStyle)==="copy"&&xe.push("mouse-copy"),Z.get(je.showUnused)&&xe.push("showUnused"),Z.get(je.showDeprecated)&&xe.push("showDeprecated"),xe.join(" ")}}class H extends n{constructor(){super(je.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:o.localize(11781,null)})}compute(ee,Z,Xe){return Xe&&ee.emptySelectionClipboard}}class W extends d{constructor(){const ee={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(je.find,"find",ee,{"editor.find.cursorMoveOnType":{type:"boolean",default:ee.cursorMoveOnType,description:o.localize(11782,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ee.seedSearchStringFromSelection,enumDescriptions:[o.localize(11783,null),o.localize(11784,null),o.localize(11785,null)],description:o.localize(11786,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ee.autoFindInSelection,enumDescriptions:[o.localize(11787,null),o.localize(11788,null),o.localize(11789,null)],description:o.localize(11790,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ee.globalFindClipboard,description:o.localize(11791,null),included:P.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ee.addExtraSpaceOnTop,description:o.localize(11792,null)},"editor.find.loop":{type:"boolean",default:ee.loop,description:o.localize(11793,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Z=ee;return{cursorMoveOnType:i(Z.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ee.seedSearchStringFromSelection=="boolean"?ee.seedSearchStringFromSelection?"always":"never":h(Z.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ee.autoFindInSelection=="boolean"?ee.autoFindInSelection?"always":"never":h(Z.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(Z.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(Z.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(Z.loop,this.defaultValue.loop)}}}class G extends d{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(je.fontLigatures,"fontLigatures",G.OFF,{anyOf:[{type:"boolean",description:o.localize(11794,null)},{type:"string",description:o.localize(11795,null)}],description:o.localize(11796,null),default:!1})}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee==="false"||ee.length===0?G.OFF:ee==="true"?G.ON:ee:ee?G.ON:G.OFF}}e.EditorFontLigatures=G;class Q extends d{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(je.fontVariations,"fontVariations",Q.OFF,{anyOf:[{type:"boolean",description:o.localize(11797,null)},{type:"string",description:o.localize(11798,null)}],description:o.localize(11799,null),default:!1})}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee==="false"?Q.OFF:ee==="true"?Q.TRANSLATE:ee:ee?Q.TRANSLATE:Q.OFF}compute(ee,Z,Xe){return ee.fontInfo.fontVariationSettings}}e.EditorFontVariations=Q;class ae extends c{constructor(){super(je.fontInfo)}compute(ee,Z,Xe){return ee.fontInfo}}class be extends l{constructor(){super(je.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(11800,null)})}validate(ee){const Z=$.float(ee,this.defaultValue);return Z===0?e.EDITOR_FONT_DEFAULTS.fontSize:$.clamp(Z,6,100)}compute(ee,Z,Xe){return ee.fontInfo.fontSize}}class le extends d{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(je.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:le.d,maximum:le.e,errorMessage:o.localize(11801,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:le.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(11802,null)})}validate(ee){return ee==="normal"||ee==="bold"?ee:String(g.clampedInt(ee,e.EDITOR_FONT_DEFAULTS.fontWeight,le.d,le.e))}}class _ extends d{constructor(){const ee={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},Z={type:"string",enum:["peek","gotoAndPeek","goto"],default:ee.multiple,enumDescriptions:[o.localize(11803,null),o.localize(11804,null),o.localize(11805,null)]},Xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(je.gotoLocation,"gotoLocation",ee,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(11806,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(11807,null),...Z},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(11808,null),...Z},"editor.gotoLocation.multipleDeclarations":{description:o.localize(11809,null),...Z},"editor.gotoLocation.multipleImplementations":{description:o.localize(11810,null),...Z},"editor.gotoLocation.multipleReferences":{description:o.localize(11811,null),...Z},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ee.alternativeDefinitionCommand,enum:Xe,description:o.localize(11812,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ee.alternativeTypeDefinitionCommand,enum:Xe,description:o.localize(11813,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ee.alternativeDeclarationCommand,enum:Xe,description:o.localize(11814,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ee.alternativeImplementationCommand,enum:Xe,description:o.localize(11815,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ee.alternativeReferenceCommand,enum:Xe,description:o.localize(11816,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Z=ee;return{multiple:h(Z.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Z.multipleDefinitions??h(Z.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Z.multipleTypeDefinitions??h(Z.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Z.multipleDeclarations??h(Z.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Z.multipleImplementations??h(Z.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Z.multipleReferences??h(Z.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:Z.multipleTests??h(Z.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(Z.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(Z.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(Z.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(Z.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(Z.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:m.string(Z.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class ce extends d{constructor(){const ee={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(je.hover,"hover",ee,{"editor.hover.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11817,null)},"editor.hover.delay":{type:"number",default:ee.delay,minimum:0,maximum:1e4,description:o.localize(11818,null)},"editor.hover.sticky":{type:"boolean",default:ee.sticky,description:o.localize(11819,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ee.hidingDelay,description:o.localize(11820,null)},"editor.hover.above":{type:"boolean",default:ee.above,description:o.localize(11821,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Z=ee;return{enabled:i(Z.enabled,this.defaultValue.enabled),delay:g.clampedInt(Z.delay,this.defaultValue.delay,0,1e4),sticky:i(Z.sticky,this.defaultValue.sticky),hidingDelay:g.clampedInt(Z.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(Z.above,this.defaultValue.above)}}}var me;(function(ie){ie[ie.None=0]="None",ie[ie.Text=1]="Text",ie[ie.Blocks=2]="Blocks"})(me||(e.RenderMinimap=me={}));class oe extends c{constructor(){super(je.layoutInfo)}compute(ee,Z,Xe){return oe.computeLayout(Z,{memory:ee.memory,outerWidth:ee.outerWidth,outerHeight:ee.outerHeight,isDominatedByLongLines:ee.isDominatedByLongLines,lineHeight:ee.fontInfo.lineHeight,viewLineCount:ee.viewLineCount,lineNumbersDigitCount:ee.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ee.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ee.fontInfo.maxDigitWidth,pixelRatio:ee.pixelRatio,glyphMarginDecorationLaneCount:ee.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ee){const Z=ee.height/ee.lineHeight,Xe=Math.floor(ee.paddingTop/ee.lineHeight);let xe=Math.floor(ee.paddingBottom/ee.lineHeight);ee.scrollBeyondLastLine&&(xe=Math.max(xe,Z-1));const ht=(Xe+ee.viewLineCount+xe)/(ee.pixelRatio*ee.height),wt=Math.floor(ee.viewLineCount/ht);return{typicalViewportLineCount:Z,extraLinesBeforeFirstLine:Xe,extraLinesBeyondLastLine:xe,desiredRatio:ht,minimapLineCount:wt}}static c(ee,Z){const Xe=ee.outerWidth,xe=ee.outerHeight,ht=ee.pixelRatio;if(!ee.minimap.enabled)return{renderMinimap:me.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ht*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const wt=Z.stableMinimapLayoutInput,Ft=wt&&ee.outerHeight===wt.outerHeight&&ee.lineHeight===wt.lineHeight&&ee.typicalHalfwidthCharacterWidth===wt.typicalHalfwidthCharacterWidth&&ee.pixelRatio===wt.pixelRatio&&ee.scrollBeyondLastLine===wt.scrollBeyondLastLine&&ee.paddingTop===wt.paddingTop&&ee.paddingBottom===wt.paddingBottom&&ee.minimap.enabled===wt.minimap.enabled&&ee.minimap.side===wt.minimap.side&&ee.minimap.size===wt.minimap.size&&ee.minimap.showSlider===wt.minimap.showSlider&&ee.minimap.renderCharacters===wt.minimap.renderCharacters&&ee.minimap.maxColumn===wt.minimap.maxColumn&&ee.minimap.scale===wt.minimap.scale&&ee.verticalScrollbarWidth===wt.verticalScrollbarWidth&&ee.isViewportWrapping===wt.isViewportWrapping,Kt=ee.lineHeight,_t=ee.typicalHalfwidthCharacterWidth,ei=ee.scrollBeyondLastLine,oi=ee.minimap.renderCharacters;let At=ht>=2?Math.round(ee.minimap.scale*2):ee.minimap.scale;const Ze=ee.minimap.maxColumn,Ct=ee.minimap.size,hi=ee.minimap.side,pt=ee.verticalScrollbarWidth,Dt=ee.viewLineCount,ti=ee.remainingWidth,ii=ee.isViewportWrapping,jt=oi?2:3;let gt=Math.floor(ht*xe);const Ut=gt/ht;let ni=!1,ai=!1,Ge=jt*At,ci=At/ht,di=1;if(Ct==="fill"||Ct==="fit"){const{typicalViewportLineCount:Ht,extraLinesBeforeFirstLine:li,extraLinesBeyondLastLine:Bt,desiredRatio:Qt,minimapLineCount:Gt}=oe.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:ei,paddingTop:ee.paddingTop,paddingBottom:ee.paddingBottom,height:xe,lineHeight:Kt,pixelRatio:ht});if(Dt/Gt>1)ni=!0,ai=!0,At=1,Ge=1,ci=At/ht;else{let bt=!1,kt=At+1;if(Ct==="fit"){const Vt=Math.ceil((li+Dt+Bt)*Ge);ii&&Ft&&ti<=Z.stableFitRemainingWidth?(bt=!0,kt=Z.stableFitMaxMinimapScale):bt=Vt>gt}if(Ct==="fill"||bt){ni=!0;const Vt=At;Ge=Math.min(Kt*ht,Math.max(1,Math.floor(1/Qt))),ii&&Ft&&ti<=Z.stableFitRemainingWidth&&(kt=Z.stableFitMaxMinimapScale),At=Math.min(kt,Math.max(1,Math.floor(Ge/jt))),At>Vt&&(di=Math.min(2,At/Vt)),ci=At/ht/di,gt=Math.ceil(Math.max(Ht,li+Dt+Bt)*Ge),ii?(Z.stableMinimapLayoutInput=ee,Z.stableFitRemainingWidth=ti,Z.stableFitMaxMinimapScale=At):(Z.stableMinimapLayoutInput=null,Z.stableFitRemainingWidth=0)}}}const fi=Math.floor(Ze*ci),vt=Math.min(fi,Math.max(0,Math.floor((ti-pt-2)*ci/(_t+ci)))+e.MINIMAP_GUTTER_WIDTH);let Mt=Math.floor(ht*vt);const Nt=Mt/ht;Mt=Math.floor(Mt*di);const qt=oi?me.Text:me.Blocks,ri=hi==="left"?0:Xe-vt-pt;return{renderMinimap:qt,minimapLeft:ri,minimapWidth:vt,minimapHeightIsEditorHeight:ni,minimapIsSampling:ai,minimapScale:At,minimapLineHeight:Ge,minimapCanvasInnerWidth:Mt,minimapCanvasInnerHeight:gt,minimapCanvasOuterWidth:Nt,minimapCanvasOuterHeight:Ut}}static computeLayout(ee,Z){const Xe=Z.outerWidth|0,xe=Z.outerHeight|0,ht=Z.lineHeight|0,wt=Z.lineNumbersDigitCount|0,Ft=Z.typicalHalfwidthCharacterWidth,Kt=Z.maxDigitWidth,_t=Z.pixelRatio,ei=Z.viewLineCount,oi=ee.get(je.wordWrapOverride2),At=oi==="inherit"?ee.get(je.wordWrapOverride1):oi,Ze=At==="inherit"?ee.get(je.wordWrap):At,Ct=ee.get(je.wordWrapColumn),hi=Z.isDominatedByLongLines,pt=ee.get(je.glyphMargin),Dt=ee.get(je.lineNumbers).renderType!==ze.Off,ti=ee.get(je.lineNumbersMinChars),ii=ee.get(je.scrollBeyondLastLine),jt=ee.get(je.padding),gt=ee.get(je.minimap),Ut=ee.get(je.scrollbar),ni=Ut.verticalScrollbarSize,ai=Ut.verticalHasArrows,Ge=Ut.arrowSize,ci=Ut.horizontalScrollbarSize,di=ee.get(je.folding),fi=ee.get(je.showFoldingControls)!=="never";let vt=ee.get(je.lineDecorationsWidth);di&&fi&&(vt+=16);let Mt=0;if(Dt){const mi=Math.max(wt,ti);Mt=Math.round(mi*Kt)}let Nt=0;pt&&(Nt=ht*Z.glyphMarginDecorationLaneCount);let qt=0,ri=qt+Nt,Ht=ri+Mt,li=Ht+vt;const Bt=Xe-Nt-Mt-vt;let Qt=!1,Gt=!1,Lt=-1;At==="inherit"&&hi?(Qt=!0,Gt=!0):Ze==="on"||Ze==="bounded"?Gt=!0:Ze==="wordWrapColumn"&&(Lt=Ct);const bt=oe.c({outerWidth:Xe,outerHeight:xe,lineHeight:ht,typicalHalfwidthCharacterWidth:Ft,pixelRatio:_t,scrollBeyondLastLine:ii,paddingTop:jt.top,paddingBottom:jt.bottom,minimap:gt,verticalScrollbarWidth:ni,viewLineCount:ei,remainingWidth:Bt,isViewportWrapping:Gt},Z.memory||new S);bt.renderMinimap!==me.None&&bt.minimapLeft===0&&(qt+=bt.minimapWidth,ri+=bt.minimapWidth,Ht+=bt.minimapWidth,li+=bt.minimapWidth);const kt=Bt-bt.minimapWidth,Vt=Math.max(1,Math.floor((kt-ni-2)/Ft)),It=ai?Ge:0;return Gt&&(Lt=Math.max(1,Vt),Ze==="bounded"&&(Lt=Math.min(Lt,Ct))),{width:Xe,height:xe,glyphMarginLeft:qt,glyphMarginWidth:Nt,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount,lineNumbersLeft:ri,lineNumbersWidth:Mt,decorationsLeft:Ht,decorationsWidth:vt,contentLeft:li,contentWidth:kt,minimap:bt,viewportColumn:Vt,isWordWrapMinified:Qt,isViewportWrapping:Gt,wrappingColumn:Lt,verticalScrollbarWidth:ni,horizontalScrollbarHeight:ci,overviewRuler:{top:It,width:ni,height:xe-2*It,right:0}}}}e.EditorLayoutInfoComputer=oe;class ke extends d{constructor(){super(je.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[o.localize(11822,null),o.localize(11823,null)],type:"string",enum:["simple","advanced"],default:"simple",description:o.localize(11824,null)}})}validate(ee){return h(ee,"simple",["simple","advanced"])}compute(ee,Z,Xe){return Z.get(je.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":Xe}}var Te;(function(ie){ie.Off="off",ie.OnCode="onCode",ie.On="on"})(Te||(e.ShowLightbulbIconMode=Te={}));class Y extends d{constructor(){const ee={enabled:Te.On};super(je.lightbulb,"lightbulb",ee,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Te.Off,Te.OnCode,Te.On],default:ee.enabled,enumDescriptions:[o.localize(11825,null),o.localize(11826,null),o.localize(11827,null)],description:o.localize(11828,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:h(ee.enabled,this.defaultValue.enabled,[Te.Off,Te.OnCode,Te.On])}}}class B extends d{constructor(){const ee={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(je.stickyScroll,"stickyScroll",ee,{"editor.stickyScroll.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11829,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ee.maxLineCount,minimum:1,maximum:20,description:o.localize(11830,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ee.defaultModel,description:o.localize(11831,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ee.scrollWithEditor,description:o.localize(11832,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Z=ee;return{enabled:i(Z.enabled,this.defaultValue.enabled),maxLineCount:g.clampedInt(Z.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:h(Z.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(Z.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends d{constructor(){const ee={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(je.inlayHints,"inlayHints",ee,{"editor.inlayHints.enabled":{type:"string",default:ee.enabled,description:o.localize(11833,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[o.localize(11834,null),o.localize(11835,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),o.localize(11836,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),o.localize(11837,null)]},"editor.inlayHints.fontSize":{type:"number",default:ee.fontSize,markdownDescription:o.localize(11838,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ee.fontFamily,markdownDescription:o.localize(11839,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ee.padding,description:o.localize(11840,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Z=ee;return typeof Z.enabled=="boolean"&&(Z.enabled=Z.enabled?"on":"off"),{enabled:h(Z.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:g.clampedInt(Z.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(Z.fontFamily,this.defaultValue.fontFamily),padding:i(Z.padding,this.defaultValue.padding)}}}class Ee extends d{constructor(){super(je.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(ee){return typeof ee=="string"&&/^\d+(\.\d+)?ch$/.test(ee)?-parseFloat(ee.substring(0,ee.length-2)):g.clampedInt(ee,this.defaultValue,0,1e3)}compute(ee,Z,Xe){return Xe<0?g.clampedInt(-Xe*ee.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Xe}}class fe extends ${constructor(){super(je.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ee=>$.clamp(ee,0,150),{markdownDescription:o.localize(11841,null)})}compute(ee,Z,Xe){return ee.fontInfo.lineHeight}}class we extends d{constructor(){const ee={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(je.minimap,"minimap",ee,{"editor.minimap.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11842,null)},"editor.minimap.autohide":{type:"boolean",default:ee.autohide,description:o.localize(11843,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(11844,null),o.localize(11845,null),o.localize(11846,null)],default:ee.size,description:o.localize(11847,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ee.side,description:o.localize(11848,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ee.showSlider,description:o.localize(11849,null)},"editor.minimap.scale":{type:"number",default:ee.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(11850,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ee.renderCharacters,description:o.localize(11851,null)},"editor.minimap.maxColumn":{type:"number",default:ee.maxColumn,description:o.localize(11852,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ee.showRegionSectionHeaders,description:o.localize(11853,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ee.showMarkSectionHeaders,description:o.localize(11854,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ee.sectionHeaderFontSize,description:o.localize(11855,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:ee.sectionHeaderLetterSpacing,description:o.localize(11856,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Z=ee;return{enabled:i(Z.enabled,this.defaultValue.enabled),autohide:i(Z.autohide,this.defaultValue.autohide),size:h(Z.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(Z.side,this.defaultValue.side,["right","left"]),showSlider:h(Z.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(Z.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(Z.scale,1,1,3),maxColumn:g.clampedInt(Z.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(Z.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(Z.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:$.clamp(Z.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:$.clamp(Z.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function he(ie){return ie==="ctrlCmd"?P.$k?"metaKey":"ctrlKey":"altKey"}class X extends d{constructor(){super(je.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(11857,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(11858,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Z=ee;return{top:g.clampedInt(Z.top,0,0,1e3),bottom:g.clampedInt(Z.bottom,0,0,1e3)}}}class x extends d{constructor(){const ee={enabled:!0,cycle:!0};super(je.parameterHints,"parameterHints",ee,{"editor.parameterHints.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11859,null)},"editor.parameterHints.cycle":{type:"boolean",default:ee.cycle,description:o.localize(11860,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Z=ee;return{enabled:i(Z.enabled,this.defaultValue.enabled),cycle:i(Z.cycle,this.defaultValue.cycle)}}}class $e extends c{constructor(){super(je.pixelRatio)}compute(ee,Z,Xe){return ee.pixelRatio}}class pe extends d{constructor(){super(je.placeholder,"placeholder",void 0)}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee:this.defaultValue}}class Ae extends d{constructor(){const ee={other:"on",comments:"off",strings:"off"},Z=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[o.localize(11861,null),o.localize(11862,null),o.localize(11863,null)]}];super(je.quickSuggestions,"quickSuggestions",ee,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Z,default:ee.strings,description:o.localize(11864,null)},comments:{anyOf:Z,default:ee.comments,description:o.localize(11865,null)},other:{anyOf:Z,default:ee.other,description:o.localize(11866,null)}},default:ee,markdownDescription:o.localize(11867,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=ee}validate(ee){if(typeof ee=="boolean"){const _t=ee?"on":"off";return{comments:_t,strings:_t,other:_t}}if(!ee||typeof ee!="object")return this.defaultValue;const{other:Z,comments:Xe,strings:xe}=ee,ht=["on","inline","off"];let wt,Ft,Kt;return typeof Z=="boolean"?wt=Z?"on":"off":wt=h(Z,this.defaultValue.other,ht),typeof Xe=="boolean"?Ft=Xe?"on":"off":Ft=h(Xe,this.defaultValue.comments,ht),typeof xe=="boolean"?Kt=xe?"on":"off":Kt=h(xe,this.defaultValue.strings,ht),{other:wt,comments:Ft,strings:Kt}}}var ze;(function(ie){ie[ie.Off=0]="Off",ie[ie.On=1]="On",ie[ie.Relative=2]="Relative",ie[ie.Interval=3]="Interval",ie[ie.Custom=4]="Custom"})(ze||(e.RenderLineNumbersType=ze={}));class Ie extends d{constructor(){super(je.lineNumbers,"lineNumbers",{renderType:ze.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(11868,null),o.localize(11869,null),o.localize(11870,null),o.localize(11871,null)],default:"on",description:o.localize(11872,null)})}validate(ee){let Z=this.defaultValue.renderType,Xe=this.defaultValue.renderFn;return typeof ee<"u"&&(typeof ee=="function"?(Z=ze.Custom,Xe=ee):ee==="interval"?Z=ze.Interval:ee==="relative"?Z=ze.Relative:ee==="on"?Z=ze.On:Z=ze.Off),{renderType:Z,renderFn:Xe}}}function Pe(ie){const ee=ie.get(je.renderValidationDecorations);return ee==="editable"?ie.get(je.readOnly):ee!=="on"}class Oe extends d{constructor(){const ee=[],Z={type:"number",description:o.localize(11873,null)};super(je.rulers,"rulers",ee,{type:"array",items:{anyOf:[Z,{type:["object"],properties:{column:Z,color:{type:"string",description:o.localize(11874,null),format:"color-hex"}}}]},default:ee,description:o.localize(11875,null)})}validate(ee){if(Array.isArray(ee)){const Z=[];for(const Xe of ee)if(typeof Xe=="number")Z.push({column:g.clampedInt(Xe,0,0,1e4),color:null});else if(Xe&&typeof Xe=="object"){const xe=Xe;Z.push({column:g.clampedInt(xe.column,0,0,1e4),color:xe.color})}return Z.sort((Xe,xe)=>Xe.column-xe.column),Z}return this.defaultValue}}class U extends d{constructor(){super(je.readOnlyMessage,"readOnlyMessage",void 0)}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:ee}}function j(ie,ee){if(typeof ie!="string")return ee;switch(ie){case"hidden":return O.ScrollbarVisibility.Hidden;case"visible":return O.ScrollbarVisibility.Visible;default:return O.ScrollbarVisibility.Auto}}class K extends d{constructor(){const ee={vertical:O.ScrollbarVisibility.Auto,horizontal:O.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(je.scrollbar,"scrollbar",ee,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(11876,null),o.localize(11877,null),o.localize(11878,null)],default:"auto",description:o.localize(11879,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(11880,null),o.localize(11881,null),o.localize(11882,null)],default:"auto",description:o.localize(11883,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ee.verticalScrollbarSize,description:o.localize(11884,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ee.horizontalScrollbarSize,description:o.localize(11885,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ee.scrollByPage,description:o.localize(11886,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ee.ignoreHorizontalScrollbarInContentHeight,description:o.localize(11887,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Z=ee,Xe=g.clampedInt(Z.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=g.clampedInt(Z.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(Z.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:j(Z.vertical,this.defaultValue.vertical),horizontal:j(Z.horizontal,this.defaultValue.horizontal),useShadows:i(Z.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(Z.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(Z.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(Z.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(Z.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Xe,horizontalSliderSize:g.clampedInt(Z.horizontalSliderSize,Xe,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:g.clampedInt(Z.verticalSliderSize,xe,0,1e3),scrollByPage:i(Z.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(Z.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends d{constructor(){const ee={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(je.unicodeHighlighting,"unicodeHighlight",ee,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.nonBasicASCII,description:o.localize(11888,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ee.invisibleCharacters,description:o.localize(11889,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ee.ambiguousCharacters,description:o.localize(11890,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.includeComments,description:o.localize(11891,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.includeStrings,description:o.localize(11892,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ee.allowedCharacters,description:o.localize(11893,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ee.allowedLocales,description:o.localize(11894,null)}})}applyUpdate(ee,Z){let Xe=!1;Z.allowedCharacters&&ee&&(R.$io(ee.allowedCharacters,Z.allowedCharacters)||(ee={...ee,allowedCharacters:Z.allowedCharacters},Xe=!0)),Z.allowedLocales&&ee&&(R.$io(ee.allowedLocales,Z.allowedLocales)||(ee={...ee,allowedLocales:Z.allowedLocales},Xe=!0));const xe=super.applyUpdate(ee,Z);return Xe?new r(xe.newValue,!0):xe}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Z=ee;return{nonBasicASCII:Qe(Z.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(Z.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(Z.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Qe(Z.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Qe(Z.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ee.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ee.allowedLocales,this.defaultValue.allowedLocales)}}c(ee,Z){if(typeof ee!="object"||!ee)return Z;const Xe={};for(const[xe,ht]of Object.entries(ee))ht===!0&&(Xe[xe]=!0);return Xe}}class re extends d{constructor(){const ee={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(je.inlineSuggest,"inlineSuggest",ee,{"editor.inlineSuggest.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11895,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ee.showToolbar,enum:["always","onHover","never"],enumDescriptions:[o.localize(11896,null),o.localize(11897,null),o.localize(11898,null)],description:o.localize(11899,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ee.suppressSuggestions,description:o.localize(11900,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ee.fontFamily,description:o.localize(11901,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Z=ee;return{enabled:i(Z.enabled,this.defaultValue.enabled),mode:h(Z.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(Z.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(Z.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(Z.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:m.string(Z.fontFamily,this.defaultValue.fontFamily)}}}class ge extends d{constructor(){const ee={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(je.inlineEdit,"experimentalInlineEdit",ee,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11902,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ee.showToolbar,enum:["always","onHover","never"],enumDescriptions:[o.localize(11903,null),o.localize(11904,null),o.localize(11905,null)],description:o.localize(11906,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ee.fontFamily,description:o.localize(11907,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Z=ee;return{enabled:i(Z.enabled,this.defaultValue.enabled),showToolbar:h(Z.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:m.string(Z.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(Z.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Ce extends d{constructor(){const ee={enabled:T.$lt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$lt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(je.bracketPairColorization,"bracketPairColorization",ee,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(11908,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ee.independentColorPoolPerBracketType,description:o.localize(11909,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Z=ee;return{enabled:i(Z.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(Z.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ue extends d{constructor(){const ee={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(je.guides,"guides",ee,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(11910,null),o.localize(11911,null),o.localize(11912,null)],default:ee.bracketPairs,description:o.localize(11913,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(11914,null),o.localize(11915,null),o.localize(11916,null)],default:ee.bracketPairsHorizontal,description:o.localize(11917,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ee.highlightActiveBracketPair,description:o.localize(11918,null)},"editor.guides.indentation":{type:"boolean",default:ee.indentation,description:o.localize(11919,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[o.localize(11920,null),o.localize(11921,null),o.localize(11922,null)],default:ee.highlightActiveIndentation,description:o.localize(11923,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Z=ee;return{bracketPairs:Qe(Z.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Qe(Z.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(Z.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(Z.indentation,this.defaultValue.indentation),highlightActiveIndentation:Qe(Z.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Qe(ie,ee,Z){const Xe=Z.indexOf(ie);return Xe===-1?ee:Z[Xe]}class _e extends d{constructor(){const ee={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(je.suggest,"suggest",ee,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(11924,null),o.localize(11925,null)],default:ee.insertMode,description:o.localize(11926,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ee.filterGraceful,description:o.localize(11927,null)},"editor.suggest.localityBonus":{type:"boolean",default:ee.localityBonus,description:o.localize(11928,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ee.shareSuggestSelections,markdownDescription:o.localize(11929,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[o.localize(11930,null),o.localize(11931,null),o.localize(11932,null),o.localize(11933,null)],default:ee.selectionMode,markdownDescription:o.localize(11934,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ee.snippetsPreventQuickSuggestions,description:o.localize(11935,null)},"editor.suggest.showIcons":{type:"boolean",default:ee.showIcons,description:o.localize(11936,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ee.showStatusBar,description:o.localize(11937,null)},"editor.suggest.preview":{type:"boolean",default:ee.preview,description:o.localize(11938,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ee.showInlineDetails,description:o.localize(11939,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(11940,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(11941,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(11942,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(11943,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(11944,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(11945,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:o.localize(11946,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(11947,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(11948,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(11949,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(11950,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(11951,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(11952,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(11953,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(11954,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(11955,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(11956,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(11957,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(11958,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(11959,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(11960,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(11961,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(11962,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(11963,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(11964,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(11965,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(11966,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(11967,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(11968,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(11969,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(11970,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(11971,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Z=ee;return{insertMode:h(Z.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(Z.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(Z.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(Z.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(Z.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(Z.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(Z.showIcons,this.defaultValue.showIcons),showStatusBar:i(Z.showStatusBar,this.defaultValue.showStatusBar),preview:i(Z.preview,this.defaultValue.preview),previewMode:h(Z.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(Z.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(Z.showMethods,this.defaultValue.showMethods),showFunctions:i(Z.showFunctions,this.defaultValue.showFunctions),showConstructors:i(Z.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(Z.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(Z.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(Z.showFields,this.defaultValue.showFields),showVariables:i(Z.showVariables,this.defaultValue.showVariables),showClasses:i(Z.showClasses,this.defaultValue.showClasses),showStructs:i(Z.showStructs,this.defaultValue.showStructs),showInterfaces:i(Z.showInterfaces,this.defaultValue.showInterfaces),showModules:i(Z.showModules,this.defaultValue.showModules),showProperties:i(Z.showProperties,this.defaultValue.showProperties),showEvents:i(Z.showEvents,this.defaultValue.showEvents),showOperators:i(Z.showOperators,this.defaultValue.showOperators),showUnits:i(Z.showUnits,this.defaultValue.showUnits),showValues:i(Z.showValues,this.defaultValue.showValues),showConstants:i(Z.showConstants,this.defaultValue.showConstants),showEnums:i(Z.showEnums,this.defaultValue.showEnums),showEnumMembers:i(Z.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(Z.showKeywords,this.defaultValue.showKeywords),showWords:i(Z.showWords,this.defaultValue.showWords),showColors:i(Z.showColors,this.defaultValue.showColors),showFiles:i(Z.showFiles,this.defaultValue.showFiles),showReferences:i(Z.showReferences,this.defaultValue.showReferences),showFolders:i(Z.showFolders,this.defaultValue.showFolders),showTypeParameters:i(Z.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(Z.showSnippets,this.defaultValue.showSnippets),showUsers:i(Z.showUsers,this.defaultValue.showUsers),showIssues:i(Z.showIssues,this.defaultValue.showIssues)}}}class tt extends d{constructor(){super(je.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(11972,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:o.localize(11973,null),default:!0,type:"boolean"}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(ee.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(ee.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends d{constructor(){const ee=[];super(je.wordSegmenterLocales,"wordSegmenterLocales",ee,{anyOf:[{description:o.localize(11974,null),type:"string"},{description:o.localize(11975,null),type:"array",items:{type:"string"}}]})}validate(ee){if(typeof ee=="string"&&(ee=[ee]),Array.isArray(ee)){const Z=[];for(const Xe of ee)if(typeof Xe=="string")try{Intl.Segmenter.supportedLocalesOf(Xe).length>0&&Z.push(Xe)}catch{}return Z}return this.defaultValue}}var et;(function(ie){ie[ie.None=0]="None",ie[ie.Same=1]="Same",ie[ie.Indent=2]="Indent",ie[ie.DeepIndent=3]="DeepIndent"})(et||(e.WrappingIndent=et={}));class rt extends d{constructor(){super(je.wrappingIndent,"wrappingIndent",et.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[o.localize(11976,null),o.localize(11977,null),o.localize(11978,null),o.localize(11979,null)],description:o.localize(11980,null),default:"same"}})}validate(ee){switch(ee){case"none":return et.None;case"same":return et.Same;case"indent":return et.Indent;case"deepIndent":return et.DeepIndent}return et.Same}compute(ee,Z,Xe){return Z.get(je.accessibilitySupport)===I.AccessibilitySupport.Enabled?et.None:Xe}}class ft extends c{constructor(){super(je.wrappingInfo)}compute(ee,Z,Xe){const xe=Z.get(je.layoutInfo);return{isDominatedByLongLines:ee.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class lt extends d{constructor(){const ee={enabled:!0,showDropSelector:"afterDrop"};super(je.dropIntoEditor,"dropIntoEditor",ee,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(11981,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:o.localize(11982,null),enum:["afterDrop","never"],enumDescriptions:[o.localize(11983,null),o.localize(11984,null)],default:"afterDrop"}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Z=ee;return{enabled:i(Z.enabled,this.defaultValue.enabled),showDropSelector:h(Z.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends d{constructor(){const ee={enabled:!0,showPasteSelector:"afterPaste"};super(je.pasteAs,"pasteAs",ee,{"editor.pasteAs.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(11985,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:o.localize(11986,null),enum:["afterPaste","never"],enumDescriptions:[o.localize(11987,null),o.localize(11988,null)],default:"afterPaste"}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Z=ee;return{enabled:i(Z.enabled,this.defaultValue.enabled),showPasteSelector:h(Z.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ct="Consolas, 'Courier New', monospace",mt="Menlo, Monaco, 'Courier New', monospace",$t="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$k?mt:P.$l?$t:ct,fontWeight:"normal",fontSize:P.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function We(ie){return e.editorOptionsRegistry[ie.id]=ie,ie}var je;(function(ie){ie[ie.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ie[ie.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ie[ie.accessibilitySupport=2]="accessibilitySupport",ie[ie.accessibilityPageSize=3]="accessibilityPageSize",ie[ie.ariaLabel=4]="ariaLabel",ie[ie.ariaRequired=5]="ariaRequired",ie[ie.autoClosingBrackets=6]="autoClosingBrackets",ie[ie.autoClosingComments=7]="autoClosingComments",ie[ie.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ie[ie.autoClosingDelete=9]="autoClosingDelete",ie[ie.autoClosingOvertype=10]="autoClosingOvertype",ie[ie.autoClosingQuotes=11]="autoClosingQuotes",ie[ie.autoIndent=12]="autoIndent",ie[ie.automaticLayout=13]="automaticLayout",ie[ie.autoSurround=14]="autoSurround",ie[ie.bracketPairColorization=15]="bracketPairColorization",ie[ie.guides=16]="guides",ie[ie.codeLens=17]="codeLens",ie[ie.codeLensFontFamily=18]="codeLensFontFamily",ie[ie.codeLensFontSize=19]="codeLensFontSize",ie[ie.colorDecorators=20]="colorDecorators",ie[ie.colorDecoratorsLimit=21]="colorDecoratorsLimit",ie[ie.columnSelection=22]="columnSelection",ie[ie.comments=23]="comments",ie[ie.contextmenu=24]="contextmenu",ie[ie.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ie[ie.cursorBlinking=26]="cursorBlinking",ie[ie.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ie[ie.cursorStyle=28]="cursorStyle",ie[ie.cursorSurroundingLines=29]="cursorSurroundingLines",ie[ie.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ie[ie.cursorWidth=31]="cursorWidth",ie[ie.disableLayerHinting=32]="disableLayerHinting",ie[ie.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ie[ie.domReadOnly=34]="domReadOnly",ie[ie.dragAndDrop=35]="dragAndDrop",ie[ie.dropIntoEditor=36]="dropIntoEditor",ie[ie.emptySelectionClipboard=37]="emptySelectionClipboard",ie[ie.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ie[ie.extraEditorClassName=39]="extraEditorClassName",ie[ie.fastScrollSensitivity=40]="fastScrollSensitivity",ie[ie.find=41]="find",ie[ie.fixedOverflowWidgets=42]="fixedOverflowWidgets",ie[ie.folding=43]="folding",ie[ie.foldingStrategy=44]="foldingStrategy",ie[ie.foldingHighlight=45]="foldingHighlight",ie[ie.foldingImportsByDefault=46]="foldingImportsByDefault",ie[ie.foldingMaximumRegions=47]="foldingMaximumRegions",ie[ie.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ie[ie.fontFamily=49]="fontFamily",ie[ie.fontInfo=50]="fontInfo",ie[ie.fontLigatures=51]="fontLigatures",ie[ie.fontSize=52]="fontSize",ie[ie.fontWeight=53]="fontWeight",ie[ie.fontVariations=54]="fontVariations",ie[ie.formatOnPaste=55]="formatOnPaste",ie[ie.formatOnType=56]="formatOnType",ie[ie.glyphMargin=57]="glyphMargin",ie[ie.gotoLocation=58]="gotoLocation",ie[ie.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ie[ie.hover=60]="hover",ie[ie.inDiffEditor=61]="inDiffEditor",ie[ie.inlineSuggest=62]="inlineSuggest",ie[ie.inlineEdit=63]="inlineEdit",ie[ie.letterSpacing=64]="letterSpacing",ie[ie.lightbulb=65]="lightbulb",ie[ie.lineDecorationsWidth=66]="lineDecorationsWidth",ie[ie.lineHeight=67]="lineHeight",ie[ie.lineNumbers=68]="lineNumbers",ie[ie.lineNumbersMinChars=69]="lineNumbersMinChars",ie[ie.linkedEditing=70]="linkedEditing",ie[ie.links=71]="links",ie[ie.matchBrackets=72]="matchBrackets",ie[ie.minimap=73]="minimap",ie[ie.mouseStyle=74]="mouseStyle",ie[ie.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ie[ie.mouseWheelZoom=76]="mouseWheelZoom",ie[ie.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ie[ie.multiCursorModifier=78]="multiCursorModifier",ie[ie.multiCursorPaste=79]="multiCursorPaste",ie[ie.multiCursorLimit=80]="multiCursorLimit",ie[ie.occurrencesHighlight=81]="occurrencesHighlight",ie[ie.overviewRulerBorder=82]="overviewRulerBorder",ie[ie.overviewRulerLanes=83]="overviewRulerLanes",ie[ie.padding=84]="padding",ie[ie.pasteAs=85]="pasteAs",ie[ie.parameterHints=86]="parameterHints",ie[ie.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ie[ie.placeholder=88]="placeholder",ie[ie.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ie[ie.quickSuggestions=90]="quickSuggestions",ie[ie.quickSuggestionsDelay=91]="quickSuggestionsDelay",ie[ie.readOnly=92]="readOnly",ie[ie.readOnlyMessage=93]="readOnlyMessage",ie[ie.renameOnType=94]="renameOnType",ie[ie.renderControlCharacters=95]="renderControlCharacters",ie[ie.renderFinalNewline=96]="renderFinalNewline",ie[ie.renderLineHighlight=97]="renderLineHighlight",ie[ie.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ie[ie.renderValidationDecorations=99]="renderValidationDecorations",ie[ie.renderWhitespace=100]="renderWhitespace",ie[ie.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ie[ie.roundedSelection=102]="roundedSelection",ie[ie.rulers=103]="rulers",ie[ie.scrollbar=104]="scrollbar",ie[ie.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ie[ie.scrollBeyondLastLine=106]="scrollBeyondLastLine",ie[ie.scrollPredominantAxis=107]="scrollPredominantAxis",ie[ie.selectionClipboard=108]="selectionClipboard",ie[ie.selectionHighlight=109]="selectionHighlight",ie[ie.selectOnLineNumbers=110]="selectOnLineNumbers",ie[ie.showFoldingControls=111]="showFoldingControls",ie[ie.showUnused=112]="showUnused",ie[ie.snippetSuggestions=113]="snippetSuggestions",ie[ie.smartSelect=114]="smartSelect",ie[ie.smoothScrolling=115]="smoothScrolling",ie[ie.stickyScroll=116]="stickyScroll",ie[ie.stickyTabStops=117]="stickyTabStops",ie[ie.stopRenderingLineAfter=118]="stopRenderingLineAfter",ie[ie.suggest=119]="suggest",ie[ie.suggestFontSize=120]="suggestFontSize",ie[ie.suggestLineHeight=121]="suggestLineHeight",ie[ie.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ie[ie.suggestSelection=123]="suggestSelection",ie[ie.tabCompletion=124]="tabCompletion",ie[ie.tabIndex=125]="tabIndex",ie[ie.unicodeHighlighting=126]="unicodeHighlighting",ie[ie.unusualLineTerminators=127]="unusualLineTerminators",ie[ie.useShadowDOM=128]="useShadowDOM",ie[ie.useTabStops=129]="useTabStops",ie[ie.wordBreak=130]="wordBreak",ie[ie.wordSegmenterLocales=131]="wordSegmenterLocales",ie[ie.wordSeparators=132]="wordSeparators",ie[ie.wordWrap=133]="wordWrap",ie[ie.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ie[ie.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ie[ie.wordWrapColumn=136]="wordWrapColumn",ie[ie.wordWrapOverride1=137]="wordWrapOverride1",ie[ie.wordWrapOverride2=138]="wordWrapOverride2",ie[ie.wrappingIndent=139]="wrappingIndent",ie[ie.wrappingStrategy=140]="wrappingStrategy",ie[ie.showDeprecated=141]="showDeprecated",ie[ie.inlayHints=142]="inlayHints",ie[ie.editorClassName=143]="editorClassName",ie[ie.pixelRatio=144]="pixelRatio",ie[ie.tabFocusMode=145]="tabFocusMode",ie[ie.layoutInfo=146]="layoutInfo",ie[ie.wrappingInfo=147]="wrappingInfo",ie[ie.defaultColorDecorators=148]="defaultColorDecorators",ie[ie.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ie[ie.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:We(new n(je.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(11989,null)})),acceptSuggestionOnEnter:We(new E(je.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(11990,null),""],markdownDescription:o.localize(11991,null)})),accessibilitySupport:We(new C),accessibilityPageSize:We(new g(je.accessibilityPageSize,"accessibilityPageSize",10,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(11992,null),tags:["accessibility"]})),ariaLabel:We(new m(je.ariaLabel,"ariaLabel",o.localize(11993,null))),ariaRequired:We(new n(je.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:We(new n(je.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:o.localize(11994,null),tags:["accessibility"]})),autoClosingBrackets:We(new E(je.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(11995,null),o.localize(11996,null),""],description:o.localize(11997,null)})),autoClosingComments:We(new E(je.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(11998,null),o.localize(11999,null),""],description:o.localize(12e3,null)})),autoClosingDelete:We(new E(je.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(12001,null),""],description:o.localize(12002,null)})),autoClosingOvertype:We(new E(je.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(12003,null),""],description:o.localize(12004,null)})),autoClosingQuotes:We(new E(je.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(12005,null),o.localize(12006,null),""],description:o.localize(12007,null)})),autoIndent:We(new D(je.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[o.localize(12008,null),o.localize(12009,null),o.localize(12010,null),o.localize(12011,null),o.localize(12012,null)],description:o.localize(12013,null)})),automaticLayout:We(new n(je.automaticLayout,"automaticLayout",!1)),autoSurround:We(new E(je.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(12014,null),o.localize(12015,null),o.localize(12016,null),""],description:o.localize(12017,null)})),bracketPairColorization:We(new Ce),bracketPairGuides:We(new Ue),stickyTabStops:We(new n(je.stickyTabStops,"stickyTabStops",!1,{description:o.localize(12018,null)})),codeLens:We(new n(je.codeLens,"codeLens",!0,{description:o.localize(12019,null)})),codeLensFontFamily:We(new m(je.codeLensFontFamily,"codeLensFontFamily","",{description:o.localize(12020,null)})),codeLensFontSize:We(new g(je.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(12021,null)})),colorDecorators:We(new n(je.colorDecorators,"colorDecorators",!0,{description:o.localize(12022,null)})),colorDecoratorActivatedOn:We(new E(je.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[o.localize(12023,null),o.localize(12024,null),o.localize(12025,null)],description:o.localize(12026,null)})),colorDecoratorsLimit:We(new g(je.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:o.localize(12027,null)})),columnSelection:We(new n(je.columnSelection,"columnSelection",!1,{description:o.localize(12028,null)})),comments:We(new k),contextmenu:We(new n(je.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:We(new n(je.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:o.localize(12029,null)})),cursorBlinking:We(new D(je.cursorBlinking,"cursorBlinking",f.Blink,"blink",["blink","smooth","phase","expand","solid"],w,{description:o.localize(12030,null)})),cursorSmoothCaretAnimation:We(new E(je.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[o.localize(12031,null),o.localize(12032,null),o.localize(12033,null)],description:o.localize(12034,null)})),cursorStyle:We(new D(je.cursorStyle,"cursorStyle",F.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:o.localize(12035,null)})),cursorSurroundingLines:We(new g(je.cursorSurroundingLines,"cursorSurroundingLines",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(12036,null)})),cursorSurroundingLinesStyle:We(new E(je.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(12037,null),o.localize(12038,null)],markdownDescription:o.localize(12039,null)})),cursorWidth:We(new g(je.cursorWidth,"cursorWidth",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:o.localize(12040,null)})),disableLayerHinting:We(new n(je.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:We(new n(je.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:We(new n(je.domReadOnly,"domReadOnly",!1)),dragAndDrop:We(new n(je.dragAndDrop,"dragAndDrop",!0,{description:o.localize(12041,null)})),emptySelectionClipboard:We(new H),dropIntoEditor:We(new lt),stickyScroll:We(new B),experimentalWhitespaceRendering:We(new E(je.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[o.localize(12042,null),o.localize(12043,null),o.localize(12044,null)],description:o.localize(12045,null)})),extraEditorClassName:We(new m(je.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:We(new $(je.fastScrollSensitivity,"fastScrollSensitivity",5,ie=>ie<=0?5:ie,{markdownDescription:o.localize(12046,null)})),find:We(new W),fixedOverflowWidgets:We(new n(je.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:We(new n(je.folding,"folding",!0,{description:o.localize(12047,null)})),foldingStrategy:We(new E(je.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(12048,null),o.localize(12049,null)],description:o.localize(12050,null)})),foldingHighlight:We(new n(je.foldingHighlight,"foldingHighlight",!0,{description:o.localize(12051,null)})),foldingImportsByDefault:We(new n(je.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:o.localize(12052,null)})),foldingMaximumRegions:We(new g(je.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(12053,null)})),unfoldOnClickAfterEndOfLine:We(new n(je.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(12054,null)})),fontFamily:We(new m(je.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(12055,null)})),fontInfo:We(new ae),fontLigatures2:We(new G),fontSize:We(new be),fontWeight:We(new le),fontVariations:We(new Q),formatOnPaste:We(new n(je.formatOnPaste,"formatOnPaste",!1,{description:o.localize(12056,null)})),formatOnType:We(new n(je.formatOnType,"formatOnType",!1,{description:o.localize(12057,null)})),glyphMargin:We(new n(je.glyphMargin,"glyphMargin",!0,{description:o.localize(12058,null)})),gotoLocation:We(new _),hideCursorInOverviewRuler:We(new n(je.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:o.localize(12059,null)})),hover:We(new ce),inDiffEditor:We(new n(je.inDiffEditor,"inDiffEditor",!1)),letterSpacing:We(new $(je.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ie=>$.clamp(ie,-5,20),{description:o.localize(12060,null)})),lightbulb:We(new Y),lineDecorationsWidth:We(new Ee),lineHeight:We(new fe),lineNumbers:We(new Ie),lineNumbersMinChars:We(new g(je.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:We(new n(je.linkedEditing,"linkedEditing",!1,{description:o.localize(12061,null)})),links:We(new n(je.links,"links",!0,{description:o.localize(12062,null)})),matchBrackets:We(new E(je.matchBrackets,"matchBrackets","always",["always","near","never"],{description:o.localize(12063,null)})),minimap:We(new we),mouseStyle:We(new E(je.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:We(new $(je.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ie=>ie===0?1:ie,{markdownDescription:o.localize(12064,null)})),mouseWheelZoom:We(new n(je.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.$k?o.localize(12065,null):o.localize(12066,null)})),multiCursorMergeOverlapping:We(new n(je.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:o.localize(12067,null)})),multiCursorModifier:We(new D(je.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[o.localize(12068,null),o.localize(12069,null)],markdownDescription:o.localize(12070,null)})),multiCursorPaste:We(new E(je.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(12071,null),o.localize(12072,null)],markdownDescription:o.localize(12073,null)})),multiCursorLimit:We(new g(je.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:o.localize(12074,null)})),occurrencesHighlight:We(new E(je.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[o.localize(12075,null),o.localize(12076,null),o.localize(12077,null)],markdownDescription:o.localize(12078,null)})),overviewRulerBorder:We(new n(je.overviewRulerBorder,"overviewRulerBorder",!0,{description:o.localize(12079,null)})),overviewRulerLanes:We(new g(je.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:We(new X),pasteAs:We(new st),parameterHints:We(new x),peekWidgetDefaultFocus:We(new E(je.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(12080,null),o.localize(12081,null)],description:o.localize(12082,null)})),placeholder:We(new pe),definitionLinkOpensInPeek:We(new n(je.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:o.localize(12083,null)})),quickSuggestions:We(new Ae),quickSuggestionsDelay:We(new g(je.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(12084,null)})),readOnly:We(new n(je.readOnly,"readOnly",!1)),readOnlyMessage:We(new U),renameOnType:We(new n(je.renameOnType,"renameOnType",!1,{description:o.localize(12085,null),markdownDeprecationMessage:o.localize(12086,null)})),renderControlCharacters:We(new n(je.renderControlCharacters,"renderControlCharacters",!0,{description:o.localize(12087,null),restricted:!0})),renderFinalNewline:We(new E(je.renderFinalNewline,"renderFinalNewline",P.$l?"dimmed":"on",["off","on","dimmed"],{description:o.localize(12088,null)})),renderLineHighlight:We(new E(je.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(12089,null)],description:o.localize(12090,null)})),renderLineHighlightOnlyWhenFocus:We(new n(je.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(12091,null)})),renderValidationDecorations:We(new E(je.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:We(new E(je.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(12092,null),o.localize(12093,null),o.localize(12094,null),""],description:o.localize(12095,null)})),revealHorizontalRightPadding:We(new g(je.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:We(new n(je.roundedSelection,"roundedSelection",!0,{description:o.localize(12096,null)})),rulers:We(new Oe),scrollbar:We(new K),scrollBeyondLastColumn:We(new g(je.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(12097,null)})),scrollBeyondLastLine:We(new n(je.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:o.localize(12098,null)})),scrollPredominantAxis:We(new n(je.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:o.localize(12099,null)})),selectionClipboard:We(new n(je.selectionClipboard,"selectionClipboard",!0,{description:o.localize(12100,null),included:P.$l})),selectionHighlight:We(new n(je.selectionHighlight,"selectionHighlight",!0,{description:o.localize(12101,null)})),selectOnLineNumbers:We(new n(je.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:We(new E(je.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[o.localize(12102,null),o.localize(12103,null),o.localize(12104,null)],description:o.localize(12105,null)})),showUnused:We(new n(je.showUnused,"showUnused",!0,{description:o.localize(12106,null)})),showDeprecated:We(new n(je.showDeprecated,"showDeprecated",!0,{description:o.localize(12107,null)})),inlayHints:We(new ne),snippetSuggestions:We(new E(je.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(12108,null),o.localize(12109,null),o.localize(12110,null),o.localize(12111,null)],description:o.localize(12112,null)})),smartSelect:We(new tt),smoothScrolling:We(new n(je.smoothScrolling,"smoothScrolling",!1,{description:o.localize(12113,null)})),stopRenderingLineAfter:We(new g(je.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:We(new _e),inlineSuggest:We(new re),inlineEdit:We(new ge),inlineCompletionsAccessibilityVerbose:We(new n(je.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:o.localize(12114,null)})),suggestFontSize:We(new g(je.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(12115,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:We(new g(je.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(12116,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:We(new n(je.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:o.localize(12117,null)})),suggestSelection:We(new E(je.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(12118,null),o.localize(12119,null),o.localize(12120,null)],description:o.localize(12121,null)})),tabCompletion:We(new E(je.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(12122,null),o.localize(12123,null),o.localize(12124,null)],description:o.localize(12125,null)})),tabIndex:We(new g(je.tabIndex,"tabIndex",0,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:We(new V),unusualLineTerminators:We(new E(je.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(12126,null),o.localize(12127,null),o.localize(12128,null)],description:o.localize(12129,null)})),useShadowDOM:We(new n(je.useShadowDOM,"useShadowDOM",!0)),useTabStops:We(new n(je.useTabStops,"useTabStops",!0,{description:o.localize(12130,null)})),wordBreak:We(new E(je.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[o.localize(12131,null),o.localize(12132,null)],description:o.localize(12133,null)})),wordSegmenterLocales:We(new nt),wordSeparators:We(new m(je.wordSeparators,"wordSeparators",p.$mt,{description:o.localize(12134,null)})),wordWrap:We(new E(je.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(12135,null),o.localize(12136,null),o.localize(12137,null),o.localize(12138,null)],description:o.localize(12139,null)})),wordWrapBreakAfterCharacters:We(new m(je.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:We(new m(je.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:We(new g(je.wordWrapColumn,"wordWrapColumn",80,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:o.localize(12140,null)})),wordWrapOverride1:We(new E(je.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:We(new E(je.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:We(new q),defaultColorDecorators:We(new n(je.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:o.localize(12141,null)})),pixelRatio:We(new $e),tabFocusMode:We(new n(je.tabFocusMode,"tabFocusMode",!1,{markdownDescription:o.localize(12142,null)})),layoutInfo:We(new oe),wrappingInfo:We(new ft),wrappingIndent:We(new rt),wrappingStrategy:We(new ke)}}),define(Ne[106],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=void 0,e.$Mi=(0,v.$Fi)("environmentService"),e.$Ni=(0,v.$Gi)(e.$Mi)}),define(Ne[29],Le([1,0,58,19,12,14,2,9,3,20,15,48]),function(ve,e,v,R,P,O,A,T,p,o,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Fl=e.FileKind=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.FileOperationResult=e.$xl=e.$wl=e.$vl=e.$tl=e.FileChangeType=e.$sl=e.FileOperation=e.$ml=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$al=void 0,e.$bl=a,e.$cl=s,e.$dl=l,e.$el=i,e.$fl=n,e.$gl=t,e.$hl=g,e.$il=u,e.$jl=$,e.$kl=m,e.$ll=h,e.$nl=b,e.$ol=C,e.$pl=k,e.$ql=f,e.$rl=w,e.$ul=H,e.$Gl=le,e.$Hl=_,e.$Jl=me,e.$al=(0,p.$Fi)("fileService");function a(oe){return oe.create===!0}var S;(function(oe){oe[oe.Unknown=0]="Unknown",oe[oe.File=1]="File",oe[oe.Directory=2]="Directory",oe[oe.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var d;(function(oe){oe[oe.Readonly=1]="Readonly",oe[oe.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var r;(function(oe){oe[oe.UPDATED=2]="UPDATED",oe[oe.ADDED=4]="ADDED",oe[oe.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function s(oe){const ke=oe;return!!ke&&typeof ke.onDidChange=="function"}var c;(function(oe){oe[oe.None=0]="None",oe[oe.FileReadWrite=2]="FileReadWrite",oe[oe.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",oe[oe.FileReadStream=16]="FileReadStream",oe[oe.FileFolderCopy=8]="FileFolderCopy",oe[oe.PathCaseSensitive=1024]="PathCaseSensitive",oe[oe.Readonly=2048]="Readonly",oe[oe.Trash=4096]="Trash",oe[oe.FileWriteUnlock=8192]="FileWriteUnlock",oe[oe.FileAtomicRead=16384]="FileAtomicRead",oe[oe.FileAtomicWrite=32768]="FileAtomicWrite",oe[oe.FileAtomicDelete=65536]="FileAtomicDelete",oe[oe.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function l(oe){return!!(oe.capabilities&c.FileReadWrite)}function i(oe){return!!(oe.capabilities&c.FileFolderCopy)}function n(oe){return!!(oe.capabilities&c.FileClone)}function t(oe){return!!(oe.capabilities&c.FileOpenReadWriteClose)}function g(oe){return!!(oe.capabilities&c.FileReadStream)}function u(oe){return l(oe)?!!(oe.capabilities&c.FileAtomicRead):!1}function $(oe){return l(oe)?!!(oe.capabilities&c.FileAtomicWrite):!1}function m(oe){return!!(oe.capabilities&c.FileAtomicDelete)}function h(oe){return!!(oe.capabilities&c.Readonly)}var E;(function(oe){oe.FileExists="EntryExists",oe.FileNotFound="EntryNotFound",oe.FileNotADirectory="EntryNotADirectory",oe.FileIsADirectory="EntryIsADirectory",oe.FileExceedsStorageQuota="EntryExceedsStorageQuota",oe.FileTooLarge="EntryTooLarge",oe.FileWriteLocked="EntryWriteLocked",oe.NoPermissions="NoPermissions",oe.Unavailable="Unavailable",oe.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class D extends Error{static create(ke,Te){const Y=new D(ke.toString(),Te);return k(Y,Te),Y}constructor(ke,Te){super(ke),this.code=Te}}e.$ml=D;function b(oe,ke){return D.create(oe,ke)}function C(oe){return oe||b((0,T.localize)(11385,null),E.Unknown)}function k(oe,ke){return oe.name=ke?`${ke} (FileSystemError)`:"FileSystemError",oe}function f(oe){if(!oe)return E.Unknown;if(oe instanceof D)return oe.code;const ke=/^(.+) \(FileSystemError\)$/.exec(oe.name);if(!ke)return E.Unknown;switch(ke[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}function w(oe){if(oe instanceof W)return oe.fileOperationResult;switch(f(oe)){case E.FileNotFound:return ae.FILE_NOT_FOUND;case E.FileIsADirectory:return ae.FILE_IS_DIRECTORY;case E.FileNotADirectory:return ae.FILE_NOT_DIRECTORY;case E.FileWriteLocked:return ae.FILE_WRITE_LOCKED;case E.NoPermissions:return ae.FILE_PERMISSION_DENIED;case E.FileExists:return ae.FILE_MOVE_CONFLICT;case E.FileTooLarge:return ae.FILE_TOO_LARGE;default:return ae.FILE_OTHER_ERROR}}var F;(function(oe){oe[oe.CREATE=0]="CREATE",oe[oe.DELETE=1]="DELETE",oe[oe.MOVE=2]="MOVE",oe[oe.COPY=3]="COPY",oe[oe.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class N{constructor(ke,Te,Y){this.resource=ke,this.operation=Te,this.target=Y}isOperation(ke){return this.operation===ke}}e.$sl=N;var L;(function(oe){oe[oe.UPDATED=0]="UPDATED",oe[oe.ADDED=1]="ADDED",oe[oe.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class q{static{this.a=null}constructor(ke,Te){this.c=Te,this.b=void 0,this.d=new y.$T(()=>{const Y=v.$Li.forUris(()=>this.c);return Y.fill(this.rawAdded.map(B=>[B,!0])),Y}),this.f=new y.$T(()=>{const Y=v.$Li.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(B=>[B,!0])),Y}),this.g=new y.$T(()=>{const Y=v.$Li.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(B=>[B,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of ke){switch(Y.type){case L.ADDED:this.rawAdded.push(Y.resource);break;case L.UPDATED:this.rawUpdated.push(Y.resource);break;case L.DELETED:this.rawDeleted.push(Y.resource);break}this.b!==q.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(ke,...Te){return this.h(ke,{includeChildren:!1},...Te)}affects(ke,...Te){return this.h(ke,{includeChildren:!0},...Te)}h(ke,Te,...Y){if(!ke)return!1;const B=Y.length>0;return!!((!B||Y.includes(L.ADDED))&&(this.d.value.get(ke)||Te.includeChildren&&this.d.value.findSuperstr(ke))||(!B||Y.includes(L.UPDATED))&&(this.f.value.get(ke)||Te.includeChildren&&this.f.value.findSuperstr(ke))||(!B||Y.includes(L.DELETED))&&(this.g.value.findSubstr(ke)||Te.includeChildren&&this.g.value.findSuperstr(ke)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ke){return this.b===ke}hasCorrelation(){return typeof this.b=="number"}}e.$tl=q;function H(oe,ke,Te){return!oe||!ke||oe===ke||ke.length>oe.length?!1:(ke.charAt(ke.length-1)!==R.sep&&(ke+=R.sep),Te?(0,P.$Gf)(oe,ke):oe.indexOf(ke)===0)}class W extends Error{constructor(ke,Te,Y){super(ke),this.fileOperationResult=Te,this.options=Y}}e.$vl=W;class G extends W{constructor(ke,Te,Y,B){super(ke,Te,B),this.fileOperationResult=Te,this.size=Y}}e.$wl=G;class Q extends W{constructor(ke,Te,Y){super(ke,ae.FILE_NOT_MODIFIED_SINCE,Y),this.stat=Te}}e.$xl=Q;var ae;(function(oe){oe[oe.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",oe[oe.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",oe[oe.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",oe[oe.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",oe[oe.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",oe[oe.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",oe[oe.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",oe[oe.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",oe[oe.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",oe[oe.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",oe[oe.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$yl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$zl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Al="files.associations",e.$Bl="files.exclude",e.$Cl="files.readonlyInclude",e.$Dl="files.readonlyExclude",e.$El="files.readonlyFromPermissions";var be;(function(oe){oe[oe.FILE=0]="FILE",oe[oe.FOLDER=1]="FOLDER",oe[oe.ROOT_FOLDER=2]="ROOT_FOLDER"})(be||(e.FileKind=be={})),e.$Fl="";function le(oe){if(!(typeof oe.size!="number"||typeof oe.mtime!="number"))return oe.mtime.toString(29)+oe.size.toString(31)}async function _(oe,ke){if(!ke.hasProvider(A.URI.from({scheme:oe.scheme})))return new Promise(Te=>{const Y=ke.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===oe.scheme&&B.added&&(Y.dispose(),Te())})})}class ce{static{this.KB=1024}static{this.MB=ce.KB*ce.KB}static{this.GB=ce.MB*ce.KB}static{this.TB=ce.GB*ce.KB}static formatSize(ke){return(0,O.$ig)(ke)||(ke=0),ke<ce.KB?(0,T.localize)(11386,null,ke.toFixed(0)):ke<ce.MB?(0,T.localize)(11387,null,(ke/ce.KB).toFixed(2)):ke<ce.GB?(0,T.localize)(11388,null,(ke/ce.MB).toFixed(2)):ke<ce.TB?(0,T.localize)(11389,null,(ke/ce.GB).toFixed(2)):(0,T.localize)(11390,null,(ke/ce.TB).toFixed(2))}}e.$Il=ce;function me(oe){const ke=typeof oe=="string"||oe?.scheme===I.Schemas.vscodeRemote;return typeof oe!="string"&&oe?.scheme===I.Schemas.file?1024*ce.MB:ke?10*ce.MB:o.$p?50*ce.MB:1024*ce.MB}}),define(Ne[74],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class v{constructor(...P){this.a=new Map;for(const[O,A]of P)this.set(O,A)}set(P,O){const A=this.a.get(P);return this.a.set(P,O),A}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Di=v}),define(Ne[170],Le([1,0,10,13,4,73,167,3,74,171]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=void 0;const I=!1;class y extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class a{constructor(s=new p.$Di,c=!1,l,i=I){this.i=s,this.j=c,this.k=l,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$Ei,this),this._globalGraph=i?l?._globalGraph??new A.$vr(n=>n):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Pc)(this.h),this.h.clear();for(const s of this.g)(0,P.$Oc)(s)&&s.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(s,c){this.m();const l=this,i=new class extends a{dispose(){l.h.delete(i),super.dispose()}}(s,this.j,this,this.l);return this.h.add(i),c?.add(i),i}invokeFunction(s,...c){this.m();const l=d.traceInvocation(this.l,s);let i=!1;try{return s({get:t=>{if(i)throw(0,R.$7)("service accessor is only valid during the invocation of its target method");const g=this.s(t,l);if(!g)throw new Error(`[invokeFunction] unknown service '${t}'`);return g}},...c)}finally{i=!0,l.stop()}}createInstance(s,...c){this.m();let l,i;return s instanceof O.$Ci?(l=d.traceCreation(this.l,s.ctor),i=this.o(s.ctor,s.staticArguments.concat(c),l)):(l=d.traceCreation(this.l,s),i=this.o(s,c,l)),l.stop(),i}o(s,c=[],l){const i=T._util.getServiceDependencies(s).sort((g,u)=>g.index-u.index),n=[];for(const g of i){const u=this.s(g.id,l);u||this.y(`[createInstance] ${s.name} depends on UNKNOWN service ${g.id}.`,!1),n.push(u)}const t=i.length>0?i[0].index:c.length;if(c.length!==t){console.trace(`[createInstance] First service dependency of ${s.name} at position ${t+1} conflicts with ${c.length} static arguments`);const g=t-c.length;g>0?c=c.concat(new Array(g)):c=c.slice(0,t)}return Reflect.construct(s,c.concat(n))}q(s,c){if(this.i.get(s)instanceof O.$Ci)this.i.set(s,c);else if(this.k)this.k.q(s,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(s){const c=this.i.get(s);return!c&&this.k?this.k.r(s):c}s(s,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const l=this.r(s);return l instanceof O.$Ci?this.u(s,l,c.branch(s,!0)):(c.branch(s,!1),l)}u(s,c,l){if(this.t.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.t.add(s);try{return this.v(s,c,l)}finally{this.t.delete(s)}}v(s,c,l){const i=new A.$vr(u=>u.id.toString());let n=0;const t=[{id:s,desc:c,_trace:l}],g=new Set;for(;t.length;){const u=t.pop();if(!g.has(String(u.id))){if(g.add(String(u.id)),i.lookupOrInsertNode(u),n++>1e3)throw new y(i);for(const $ of T._util.getServiceDependencies(u.desc.ctor)){const m=this.r($.id);if(m||this.y(`[createInstance] ${s} depends on ${$.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(u.id),String($.id)),m instanceof O.$Ci){const h={id:$.id,desc:m,_trace:u._trace.branch($.id,!0)};i.insertEdge(u,h),t.push(h)}}}}for(;;){const u=i.roots();if(u.length===0){if(!i.isEmpty())throw new y(i);break}for(const{data:$}of u){if(this.r($.id)instanceof O.$Ci){const h=this.w($.id,$.desc.ctor,$.desc.staticArguments,$.desc.supportsDelayedInstantiation,$._trace);this.q($.id,h)}i.removeNode($)}}return this.r(s)}w(s,c,l=[],i,n){if(this.i.get(s)instanceof O.$Ci)return this.x(s,c,l,i,n,this.g);if(this.k)return this.k.w(s,c,l,i,n);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(s,c,l=[],i,n,t){if(i){const g=new a(void 0,this.j,this,this.l);g.c=String(s);const u=new Map,$=new v.$Yh(()=>{const m=g.o(c,l,n);for(const[h,E]of u){const D=m[h];if(typeof D=="function")for(const b of E)b.disposable=D.apply(m,b.listener)}return u.clear(),t.add(m),m});return new Proxy(Object.create(null),{get(m,h){if(!$.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let b=u.get(h);return b||(b=new o.$5c,u.set(h,b)),(k,f,w)=>{if($.isInitialized)return $.value[h](k,f,w);{const F={listener:[k,f,w],disposable:void 0},N=b.push(F);return(0,P.$Sc)(()=>{N(),F.disposable?.dispose()})}}}if(h in m)return m[h];const E=$.value;let D=E[h];return typeof D!="function"||(D=D.bind(E),m[h]=D),D},set(m,h,E){return $.value[h]=E,!0},getPrototypeOf(m){return c.prototype}})}else{const g=this.o(c,l,n);return t.add(g),g}}y(s,c){if(c&&console.warn(s),this.j)throw new Error(s)}}e.$wr=a;var S;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(S||(S={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(S.None,null)}stop(){}branch(){return this}}}static traceInvocation(s,c){return s?new d(S.Invocation,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(s,c){return s?new d(S.Creation,c.name):d.c}static{this.f=0}constructor(s,c){this.type=s,this.name=c,this.g=Date.now(),this.h=[]}branch(s,c){const l=new d(S.Branch,s.toString());return this.h.push([s,c,l]),l}stop(){const s=Date.now()-this.g;d.f+=s;let c=!1;function l(n,t){const g=[],u=new Array(n+1).join("	");for(const[$,m,h]of t.h)if(m&&h){c=!0,g.push(`${u}CREATES -> ${$}`);const E=l(n+1,h);E&&g.push(E)}else g.push(`${u}uses -> ${$}`);return g.join(`
`)}const i=[`${this.type===S.Creation?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(s>2||c)&&d.all.add(i.join(`
`))}}e.$xr=d}),define(Ne[11],Le([1,0,9,42,6,75,4,28,20,23,14,2,31,3]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$dk=e.LogLevel=e.$bk=e.$ak=void 0,e.$ck=r,e.log=c,e.$ok=D,e.$pk=b,e.$qk=C,e.$rk=k,v=qe(v),e.$ak=(0,S.$Fi)("logService"),e.$bk=(0,S.$Fi)("loggerService");function d(){return new Date().toISOString()}function r(f){return(0,I.$ig)(f)}var s;(function(f){f[f.Off=0]="Off",f[f.Trace=1]="Trace",f[f.Debug=2]="Debug",f[f.Info=3]="Info",f[f.Warning=4]="Warning",f[f.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$dk=s.Info;function c(f,w,F){switch(w){case s.Trace:f.trace(F);break;case s.Debug:f.debug(F);break;case s.Info:f.info(F);break;case s.Warning:f.warn(F);break;case s.Error:f.error(F);break;case s.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function l(f,w=!1){let F="";for(let N=0;N<f.length;N++){let L=f[N];if(L instanceof Error&&(L=(0,R.$qj)(L,w)),typeof L=="object")try{L=JSON.stringify(L)}catch{}F+=(N>0?" ":"")+L}return F}class i extends A.$Uc{constructor(){super(...arguments),this.b=e.$dk,this.c=this.B(new P.$le),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==s.Off&&this.b<=w}}e.$fk=i;class n extends i{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...F){this.f(s.Trace)&&this.g(s.Trace,l([w,...F],!0))}debug(w,...F){this.f(s.Debug)&&this.g(s.Debug,l([w,...F]))}info(w,...F){this.f(s.Info)&&this.g(s.Info,l([w,...F]))}warn(w,...F){this.f(s.Warning)&&this.g(s.Warning,l([w,...F]))}error(w,...F){if(this.f(s.Error))if(w instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=w.stack,this.g(s.Error,l(N))}else this.g(s.Error,l([w,...F]))}flush(){}}e.$gk=n;class t extends i{constructor(w=e.$dk){super(),this.setLevel(w),this.g=!p.$j}trace(w,...F){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...F):console.log(`[main ${d()}]`,w,...F))}debug(w,...F){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...F):console.log(`[main ${d()}]`,w,...F))}info(w,...F){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...F):console.log(`[main ${d()}]`,w,...F))}warn(w,...F){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,w,...F):console.warn(`[main ${d()}]`,w,...F))}error(w,...F){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,w,...F):console.error(`[main ${d()}]`,w,...F))}flush(){}}e.$hk=t;class g extends i{constructor(w=e.$dk,F=!0){super(),this.g=F,this.setLevel(w)}trace(w,...F){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...F):console.log(w,...F))}debug(w,...F){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...F):console.log(w,...F))}info(w,...F){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...F):console.log(w,...F))}warn(w,...F){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...F):console.log(w,...F))}error(w,...F){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...F):console.error(w,...F))}flush(){}}e.$ik=g;class u extends i{constructor(w,F=e.$dk){super(),this.g=w,this.setLevel(F)}trace(w,...F){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(w),...F])}debug(w,...F){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(w),...F])}info(w,...F){this.f(s.Info)&&this.g.log(s.Info,[this.h(w),...F])}warn(w,...F){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(w),...F])}error(w,...F){this.f(s.Error)&&this.g.log(s.Error,[this.h(w),...F])}h(w){return typeof w=="string"?w:(0,R.$qj)(w,this.f(s.Trace))}flush(){}}e.$jk=u;class $ extends i{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const F of this.g)F.setLevel(w);super.setLevel(w)}trace(w,...F){for(const N of this.g)N.trace(w,...F)}debug(w,...F){for(const N of this.g)N.debug(w,...F)}info(w,...F){for(const N of this.g)N.info(w,...F)}warn(w,...F){for(const N of this.g)N.warn(w,...F)}error(w,...F){for(const N of this.g)N.error(w,...F)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$kk=$;class m extends A.$Uc{constructor(w,F,N){if(super(),this.h=w,this.j=F,this.b=new T.$Ac,this.c=this.B(new P.$le),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$le),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$le),this.onDidChangeVisibility=this.g.event,N)for(const L of N)this.b.set(L.resource,{logger:void 0,info:L})}m(w){return(0,I.$eg)(w)?[...this.b.values()].find(F=>F.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,F){const N=this.n(w),L=(0,I.$eg)(w)?w:F?.id??(0,O.$tj)(N.toString()).toString(16);let q=this.b.get(N)?.logger;const H=F?.logLevel==="always"?s.Trace:F?.logLevel;q||(q=this.s(N,H??this.getLogLevel(N)??this.h,{...F,id:L}));const W={logger:q,info:{resource:N,id:L,logLevel:H,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(W.info),this.b.set(N,W),q}n(w){return(0,I.$eg)(w)?(0,o.$gh)(this.j,`${w}.log`):w}setLogLevel(w,F){if(y.URI.isUri(w)){const N=w,L=F,q=this.b.get(N);q&&L!==q.info.logLevel&&(q.info.logLevel=L===this.h?void 0:L,q.logger?.setLevel(L),this.b.set(q.info.resource,q),this.f.fire([N,L]))}else{this.h=w;for(const[N,L]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&L.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,F){const N=this.m(w);N&&F!==!N.info.hidden&&(N.info.hidden=!F,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,F]))}getLogLevel(w){let F;return w&&(F=this.b.get(w)?.info.logLevel),F??this.h}registerLogger(w){const F=this.b.get(w.resource);F?F.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const F=this.b.get(w);F&&(F.logger&&F.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$lk=m;class h{constructor(){this.onDidChangeLogLevel=new P.$le().event}setLevel(w){}getLevel(){return s.Info}trace(w,...F){}debug(w,...F){}info(w,...F){}warn(w,...F){}error(w,...F){}critical(w,...F){}dispose(){}flush(){}}e.$mk=h;class E extends h{}e.$nk=E;function D(f){if(f.verbose)return s.Trace;if(typeof f.logLevel=="string"){const w=k(f.logLevel.toLowerCase());if(w!==void 0)return w}return e.$dk}function b(f){switch(f){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}function C(f){switch(f){case s.Trace:return{original:"Trace",value:v.localize(11318,null)};case s.Debug:return{original:"Debug",value:v.localize(11319,null)};case s.Info:return{original:"Info",value:v.localize(11320,null)};case s.Warning:return{original:"Warning",value:v.localize(11321,null)};case s.Error:return{original:"Error",value:v.localize(11322,null)};case s.Off:return{original:"Off",value:v.localize(11323,null)}}}function k(f){switch(f){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$sk=new a.$Wj("logLevel",b(s.Info))}),define(Ne[172],Le([1,0,4,11]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KR=void 0;class P extends v.$Uc{constructor(A,T=[]){super(),this.a=new R.$kk([A,...T]),this.B(A.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...T){this.a.trace(A,...T)}debug(A,...T){this.a.debug(A,...T)}info(A,...T){this.a.info(A,...T)}warn(A,...T){this.a.warn(A,...T)}error(A,...T){this.a.error(A,...T)}flush(){this.a.flush()}}e.$KR=P});var xt=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[107],Le([1,0,35,9,3]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,v=xt(v);var O;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var A;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(p){function o(d,r){return r-d}p.compare=o;const I=Object.create(null);I[p.Error]=(0,R.localize)(11315,null),I[p.Warning]=(0,R.localize)(11316,null),I[p.Info]=(0,R.localize)(11317,null);function y(d){return I[d]||""}p.toString=y;function a(d){switch(d){case v.default.Error:return p.Error;case v.default.Warning:return p.Warning;case v.default.Info:return p.Info;case v.default.Ignore:return p.Hint}}p.fromSeverity=a;function S(d){switch(d){case p.Error:return v.default.Error;case p.Warning:return v.default.Warning;case p.Info:return v.default.Info;case p.Hint:return v.default.Ignore}}p.toSeverity=S}(A||(e.MarkerSeverity=A={}));var T;(function(p){const o="";function I(a){return y(a,!0)}p.makeKey=I;function y(a,S){const d=[o];return a.source?d.push(a.source.replace("\xA6","\\\xA6")):d.push(o),a.code?typeof a.code=="string"?d.push(a.code.replace("\xA6","\\\xA6")):d.push(a.code.value.replace("\xA6","\\\xA6")):d.push(o),a.severity!==void 0&&a.severity!==null?d.push(A.toString(a.severity)):d.push(o),a.message&&S?d.push(a.message.replace("\xA6","\\\xA6")):d.push(o),a.startLineNumber!==void 0&&a.startLineNumber!==null?d.push(a.startLineNumber.toString()):d.push(o),a.startColumn!==void 0&&a.startColumn!==null?d.push(a.startColumn.toString()):d.push(o),a.endLineNumber!==void 0&&a.endLineNumber!==null?d.push(a.endLineNumber.toString()):d.push(o),a.endColumn!==void 0&&a.endColumn!==null?d.push(a.endColumn.toString()):d.push(o),d.push(o),d.join("\xA6")}p.makeKeyOptionalMessage=y})(T||(e.IMarkerData=T={})),e.$Gu=(0,P.$Fi)("markerService")});var xt=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[173],Le([1,0,6,35,3]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ww=e.$vw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$tw=e.Severity=void 0,e.$uw=T,R=xt(R),e.Severity=R.default,e.$tw=(0,P.$Fi)("notificationService");var O;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var A;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function T(y){if(y){const a=y;return typeof a.id=="string"&&typeof a.label=="string"}return!1}var p;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class o{constructor(){this.progress=new I,this.onDidClose=v.Event.None,this.onDidChangeVisibility=v.Event.None}updateSeverity(a){}updateMessage(a){}updateActions(a){}close(){}}e.$vw=o;class I{infinite(){}done(){}total(a){}worked(a){}}e.$ww=I}),define(Ne[108],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$tk=(0,v.$Fi)("productService"),e.$uk="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ve,e,v,R){var P=arguments.length,O=P<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,v):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ve,e,v,R);else for(var T=ve.length-1;T>=0;T--)(A=ve[T])&&(O=(P<3?A(O):P>3?A(e,v,O):A(e,v))||O);return P>3&&O&&Object.defineProperty(e,v,O),O},Ve=this&&this.__param||function(ve,e){return function(v,R){e(v,R,ve)}};define(Ne[76],Le([1,0,10,21,4,3]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.$yw=e.ProgressLocation=e.$xw=void 0,e.$xw=(0,O.$Fi)("progressService");var A;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$yw=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(a){this.b=a}report(a){this.a=a,this.b(this.a)}}e.$zw=T;class p{get value(){return this.a}constructor(a){this.e=a}report(a){this.b?this.b.push(a):this.b=[a],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const a=this.b.shift();this.a=a,await this.e(this.a)}}finally{this.c=!1;const a=this.d;this.d=void 0,a?.()}}drain(){return this.c?new Promise(a=>{const S=this.d;this.d=()=>{S?.(),a()}}):Promise.resolve()}}e.$Aw=p;let o=class extends P.$Uc{constructor(a,S){super(),this.a=new v.$3h,S.withProgress(a,d=>(this.b=d,this.c&&d.report(this.c),this.a.p)),this.B((0,P.$Sc)(()=>this.a.complete()))}report(a){this.b?this.b.report(a):this.c=a}};e.$Bw=o,e.$Bw=o=Je([Ve(1,e.$xw)],o);class I extends P.$Uc{constructor(a){super(),this.g=a,this.a=0,this.b=this.B(new P.$Tc)}start(a){this.stop();const S=++this.a,d=new R.$we;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},a),this.b.add((0,P.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Sc)(()=>d.cancel())),this.b.add((0,P.$Sc)(()=>this.c?this.c.done():void 0)),{id:S,token:d.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h(a){this.a===a&&this.b.clear()}}e.$Cw=I,e.$Dw=(0,O.$Fi)("editorProgressService")}),define(Ne[30],Le([1,0,61,14]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,v=qe(v),R=qe(R);class P{constructor(){this.a=new Map}add(A,T){v.ok(R.$eg(A)),v.ok(R.$gg(T)),v.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,T)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$ro=new P}),define(Ne[77],Le([1,0,6,137,30]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0,P=qe(P),e.$so={JSONContribution:"base.contributions.json"};function O(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class A{constructor(){this.b=new v.$le,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(o,I){this.a[O(o)]=I,this.b.fire(o)}notifySchemaChanged(o){this.b.fire(o)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(o){const I=this.a[o];return I?(0,R.$8j)(I):void 0}hasSchemaContent(o){return!!this.a[o]}}const T=new A;P.$ro.add(e.$so.JSONContribution,T)}),define(Ne[53],Le([1,0,17,6,14,9,43,77,30]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.ConfigurationScope=e.$wo=e.EditPresentationTypes=void 0,e.$Ho=r,e.$Io=s,e.$Jo=c,e.$Ko=i,e.$Lo=n,e.$Mo=t,e.$No=g,P=qe(P),O=qe(O);var o;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(o||(e.EditPresentationTypes=o={})),e.$wo={Configuration:"base.contributions.configuration"};var I;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do="vscode://schemas/settings/resourceLanguage",e.$Eo="vscode://schemas/settings/configurationDefaults";const y=p.$ro.as(T.$so.JSONContribution);class a{constructor(){this.a=[],this.i=new Set,this.j=new R.$le,this.onDidSchemaChange=this.j.event,this.k=new R.$le,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:O.localize(11611,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},y.registerSchema(e.$Do,this.h),this.z()}registerConfiguration($,m=!0){this.registerConfigurations([$],m)}registerConfigurations($,m=!0){const h=new Set;this.r($,m,h),y.registerSchema(e.$Do,this.h),this.j.fire(),this.k.fire({properties:h})}deregisterConfigurations($){const m=new Set;this.s($,m),y.registerSchema(e.$Do,this.h),this.j.fire(),this.k.fire({properties:m})}updateConfigurations({add:$,remove:m}){const h=new Set;this.s(m,h),this.r($,!1,h),y.registerSchema(e.$Do,this.h),this.j.fire(),this.k.fire({properties:h})}registerDefaultConfigurations($){const m=new Set;this.l($,m),this.j.fire(),this.k.fire({properties:m,defaultsOverrides:!0})}l($,m){this.a.push(...$);const h=[];for(const{overrides:E,source:D}of $)for(const b in E){m.add(b);const C=this.b.get(b)??this.b.set(b,{configurationDefaultOverrides:[]}).get(b),k=E[b];if(C.configurationDefaultOverrides.push({value:k,source:D}),e.$Go.test(b)){const f=this.o(b,k,D,C.configurationDefaultOverrideValue);if(!f)continue;C.configurationDefaultOverrideValue=f,this.n(b,f,D),h.push(...r(b))}else{const f=this.p(b,k,D,C.configurationDefaultOverrideValue);if(!f)continue;C.configurationDefaultOverrideValue=f;const w=this.e[b];w&&(this.A(b,w),this.w(b,w))}}this.q(h)}deregisterDefaultConfigurations($){const m=new Set;this.m($,m),this.j.fire(),this.k.fire({properties:m,defaultsOverrides:!0})}m($,m){for(const h of $){const E=this.a.indexOf(h);E!==-1&&this.a.splice(E,1)}for(const{overrides:h,source:E}of $)for(const D in h){const b=this.b.get(D);if(!b)continue;const C=b.configurationDefaultOverrides.findIndex(k=>E?k.source?.id===E.id:k.value===h[D]);if(C!==-1){if(b.configurationDefaultOverrides.splice(C,1),b.configurationDefaultOverrides.length===0&&this.b.delete(D),e.$Go.test(D)){let k;for(const f of b.configurationDefaultOverrides)k=this.o(D,f.value,f.source,k);k&&!P.$rg(k.value)?(b.configurationDefaultOverrideValue=k,this.n(D,k,E)):(this.b.delete(D),delete this.e[D],delete this.c.properties[D])}else{let k;for(const w of b.configurationDefaultOverrides)k=this.p(D,w.value,w.source,k);b.configurationDefaultOverrideValue=k;const f=this.e[D];f&&(this.A(D,f),this.w(D,f))}m.add(D)}}this.y()}n($,m,h){const E={type:"object",default:m.value,description:O.localize(11612,null,(0,A.$jj)($)),$ref:e.$Do,defaultDefaultValue:m.value,source:h,defaultValueSource:h};this.e[$]=E,this.c.properties[$]=E}o($,m,h,E){const D=E?.value||{},b=E?.source??new Map;if(!(b instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const C of Object.keys(m)){const k=m[C];if(P.$gg(k)&&(P.$lg(D[C])||P.$gg(D[C]))){if(D[C]={...D[C]??{},...k},h)for(const w in k)b.set(`${C}.${w}`,h)}else D[C]=k,h?b.set(C,h):b.delete(C)}return{value:D,source:b}}p($,m,h,E){const D=this.e[$],b=E?.value??D?.defaultDefaultValue;let C=h;if(P.$gg(m)&&(D!==void 0&&D.type==="object"||D===void 0&&(P.$lg(b)||P.$gg(b)))){if(C=E?.source??new Map,!(C instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const f in m)h&&C.set(`${$}.${f}`,h);m={...P.$gg(b)?b:{},...m}}return{value:m,source:C}}deltaConfiguration($){let m=!1;const h=new Set;$.removedDefaults&&(this.m($.removedDefaults,h),m=!0),$.addedDefaults&&(this.l($.addedDefaults,h),m=!0),$.removedConfigurations&&this.s($.removedConfigurations,h),$.addedConfigurations&&this.r($.addedConfigurations,!1,h),this.j.fire(),this.k.fire({properties:h,defaultsOverrides:m})}notifyConfigurationSchemaUpdated(...$){this.j.fire()}registerOverrideIdentifiers($){this.q($),this.j.fire()}q($){for(const m of $)this.i.add(m);this.y()}r($,m,h){$.forEach(E=>{this.u(E,m,E.extensionInfo,E.restrictedProperties,void 0,h),this.d.push(E),this.v(E)})}s($,m){const h=E=>{if(E.properties)for(const D in E.properties){m.add(D);const b=this.e[D];b?.policy?.name&&this.f.delete(b.policy.name),delete this.e[D],this.x(D,E.properties[D])}E.allOf?.forEach(D=>h(D))};for(const E of $){h(E);const D=this.d.indexOf(E);D!==-1&&this.d.splice(D,1)}}u($,m=!0,h,E,D=I.WINDOW,b){D=P.$ng($.scope)?D:$.scope;const C=$.properties;if(C)for(const f in C){const w=C[f];if(m&&i(f,w)){delete C[f];continue}if(w.source=h,w.defaultDefaultValue=C[f].default,this.A(f,w),e.$Go.test(f)?w.scope=void 0:(w.scope=P.$ng(w.scope)?D:w.scope,w.restricted=P.$ng(w.restricted)?!!E?.includes(f):w.restricted),C[f].hasOwnProperty("included")&&!C[f].included){this.g[f]=C[f],delete C[f];continue}else this.e[f]=C[f],C[f].policy?.name&&this.f.set(C[f].policy.name,f);!C[f].deprecationMessage&&C[f].markdownDeprecationMessage&&(C[f].deprecationMessage=C[f].markdownDeprecationMessage),b.add(f)}const k=$.allOf;if(k)for(const f of k)this.u(f,m,h,E,D,b)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const $=new Map;for(const[m,h]of this.b)h.configurationDefaultOverrideValue&&$.set(m,h.configurationDefaultOverrideValue);return $}v($){const m=h=>{const E=h.properties;if(E)for(const b in E)this.w(b,E[b]);h.allOf?.forEach(m)};m($)}w($,m){switch(e.$xo.properties[$]=m,m.scope){case I.APPLICATION:e.$yo.properties[$]=m;break;case I.MACHINE:e.$zo.properties[$]=m;break;case I.MACHINE_OVERRIDABLE:e.$Ao.properties[$]=m;break;case I.WINDOW:e.$Bo.properties[$]=m;break;case I.RESOURCE:e.$Co.properties[$]=m;break;case I.LANGUAGE_OVERRIDABLE:e.$Co.properties[$]=m,this.h.properties[$]=m;break}}x($,m){switch(delete e.$xo.properties[$],m.scope){case I.APPLICATION:delete e.$yo.properties[$];break;case I.MACHINE:delete e.$zo.properties[$];break;case I.MACHINE_OVERRIDABLE:delete e.$Ao.properties[$];break;case I.WINDOW:delete e.$Bo.properties[$];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$Co.properties[$],delete this.h.properties[$];break}}y(){for(const $ of this.i.values()){const m=`[${$}]`,h={type:"object",description:O.localize(11613,null),errorMessage:O.localize(11614,null),$ref:e.$Do};this.A(m,h),e.$xo.properties[m]=h,e.$yo.properties[m]=h,e.$zo.properties[m]=h,e.$Ao.properties[m]=h,e.$Bo.properties[m]=h,e.$Co.properties[m]=h}}z(){const $={type:"object",description:O.localize(11615,null),errorMessage:O.localize(11616,null),$ref:e.$Do};e.$xo.patternProperties[e.$Fo]=$,e.$yo.patternProperties[e.$Fo]=$,e.$zo.patternProperties[e.$Fo]=$,e.$Ao.patternProperties[e.$Fo]=$,e.$Bo.patternProperties[e.$Fo]=$,e.$Co.patternProperties[e.$Fo]=$,this.j.fire()}A($,m){const h=this.b.get($)?.configurationDefaultOverrideValue;let E,D;h&&(!m.disallowConfigurationDefault||!h.source)&&(E=h.value,D=h.source),P.$lg(E)&&(E=m.defaultDefaultValue,D=void 0),P.$lg(E)&&(E=c(m.type)),m.default=E,m.defaultValueSource=D}}const S="\\[([^\\]]+)\\]",d=new RegExp(S,"g");e.$Fo=`^(${S})+$`,e.$Go=new RegExp(e.$Fo);function r(u){const $=[];if(e.$Go.test(u)){let m=d.exec(u);for(;m?.length;){const h=m[1].trim();h&&$.push(h),m=d.exec(u)}}return(0,v.$Lb)($)}function s(u){return u.reduce(($,m)=>`${$}[${m}]`,"")}function c(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const l=new a;p.$ro.add(e.$wo.Configuration,l);function i(u,$){return u.trim()?e.$Go.test(u)?O.localize(11618,null,u):l.getConfigurationProperties()[u]!==void 0?O.localize(11619,null,u):$.policy?.name&&l.getPolicyConfigurations().get($.policy?.name)!==void 0?O.localize(11620,null,u,$.policy?.name,l.getPolicyConfigurations().get($.policy?.name)):null:O.localize(11617,null)}function n(){const u=[],$=l.getConfigurationProperties();for(const m of Object.keys($))u.push([m,$[m].scope]);return u.push(["launch",I.RESOURCE]),u.push(["task",I.RESOURCE]),u}function t(u){const $={};for(const m of u){const h=m.properties;if(P.$gg(h))for(const E in h)$[E]=h[E];m.allOf&&Object.assign($,t(m.allOf))}return $}function g(u){switch(u){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(Ne[174],Le([1,0,17,6,136,4,28,25,14,2,43,53,29,30]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0,e.$So=n,v=qe(v),P=qe(P),T=qe(T),p=qe(p);function d($){return Object.isFrozen($)?$:T.$fo($)}class r{static createEmptyModel(m){return new r({},[],[],void 0,m)}constructor(m,h,E,D,b){this.b=m,this.c=h,this.d=E,this.raw=D,this.f=b,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const m=this.raw.map(h=>{if(h instanceof r)return h;const E=new s("",this.f);return E.parseRaw(h),E.configurationModel});this.g=m.reduce((h,E)=>E===h?E:h.merge(E),m[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(m){return m?(0,I.$hj)(this.contents,m):this.contents}inspect(m,h){const E=this;return{get value(){return d(E.rawConfiguration.getValue(m))},get override(){return h?d(E.rawConfiguration.getOverrideValue(m,h)):void 0},get merged(){return d(h?E.rawConfiguration.override(h).getValue(m):E.rawConfiguration.getValue(m))},get overrides(){const D=[];for(const{contents:b,identifiers:C,keys:k}of E.rawConfiguration.overrides){const f=new r(b,k,[],void 0,E.f).getValue(m);f!==void 0&&D.push({identifiers:C,value:f})}return D.length?d(D):void 0}}}getOverrideValue(m,h){const E=this.j(h);return E?m?(0,I.$hj)(E,m):E:void 0}getKeysForOverrideIdentifier(m){const h=[];for(const E of this.overrides)E.identifiers.includes(m)&&h.push(...E.keys);return v.$Lb(h)}getAllOverrideIdentifiers(){const m=[];for(const h of this.overrides)m.push(...h.identifiers);return v.$Lb(m)}override(m){let h=this.a.get(m);return h||(h=this.h(m),this.a.set(m,h)),h}merge(...m){const h=T.$eo(this.contents),E=T.$eo(this.overrides),D=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const C of m)if(b.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.i(h,C.contents);for(const k of C.overrides){const[f]=E.filter(w=>v.$tb(w.identifiers,k.identifiers));f?(this.i(f.contents,k.contents),f.keys.push(...k.keys),f.keys=v.$Lb(f.keys)):E.push(T.$eo(k))}for(const k of C.keys)D.indexOf(k)===-1&&D.push(k)}return new r(h,D,E,b.every(C=>C instanceof r)?void 0:b,this.f)}h(m){const h=this.j(m);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const E={};for(const D of v.$Lb([...Object.keys(this.contents),...Object.keys(h)])){let b=this.contents[D];const C=h[D];C&&(typeof b=="object"&&typeof C=="object"?(b=T.$eo(b),this.i(b,C)):b=C),E[D]=b}return new r(E,this.keys,this.overrides,void 0,this.f)}i(m,h){for(const E of Object.keys(h)){if(E in m&&p.$gg(m[E])&&p.$gg(h[E])){this.i(m[E],h[E]);continue}m[E]=T.$eo(h[E])}}j(m){let h=null,E=null;const D=b=>{b&&(E?this.i(E,b):E=T.$eo(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===m?h=b.contents:b.identifiers.includes(m)&&D(b.contents);return D(h),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(m,h){this.k(m,h,!0)}setValue(m,h){this.k(m,h,!1)}removeValue(m){const h=this.keys.indexOf(m);h!==-1&&(this.keys.splice(h,1),(0,I.$gj)(this.contents,m),y.$Go.test(m)&&this.overrides.splice(this.overrides.findIndex(E=>v.$tb(E.identifiers,(0,y.$Ho)(m))),1))}k(m,h,E){if((0,I.$fj)(this.contents,m,h,D=>this.f.error(D)),E=E||this.keys.indexOf(m)===-1,E&&this.keys.push(m),y.$Go.test(m)){const D=(0,y.$Ho)(m),b={identifiers:D,keys:Object.keys(this.contents[m]),contents:(0,I.$ej)(this.contents[m],k=>this.f.error(k))},C=this.overrides.findIndex(k=>v.$tb(k.identifiers,D));C!==-1?this.overrides[C]=b:this.overrides.push(b)}}}e.$Oo=r;class s{constructor(m,h){this.f=m,this.g=h,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||r.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(m,h){if(!p.$ng(m)){const E=this.h(m);this.parseRaw(E,h)}}reparse(m){this.a&&this.parseRaw(this.a,m)}parseRaw(m,h){this.a=m;const{contents:E,keys:D,overrides:b,restricted:C,hasExcludedProperties:k}=this.i(m,h);this.b=new r(E,D,b,k?[m]:void 0,this.g),this.c=C||[]}h(m){let h={},E=null,D=[];const b=[],C=[];function k(w){Array.isArray(D)?D.push(w):E!==null&&(D[E]=w)}const f={onObjectBegin:()=>{const w={};k(w),b.push(D),D=w,E=null},onObjectProperty:w=>{E=w},onObjectEnd:()=>{D=b.pop()},onArrayBegin:()=>{const w=[];k(w),b.push(D),D=w,E=null},onArrayEnd:()=>{D=b.pop()},onLiteralValue:k,onError:(w,F,N)=>{C.push({error:w,offset:F,length:N})}};if(m)try{P.$6n(m,f),h=D[0]||{}}catch(w){this.g.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return h}i(m,h){const E=S.$ro.as(y.$wo.Configuration).getConfigurationProperties(),D=this.j(m,E,!0,h);m=D.raw;const b=(0,I.$ej)(m,f=>this.g.error(`Conflict in settings file ${this.f}: ${f}`)),C=Object.keys(m),k=this.l(m,f=>this.g.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:b,keys:C,overrides:k,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(m,h,E,D){let b=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:m,restricted:[],hasExcludedProperties:b};const C={},k=[];for(const f in m)if(y.$Go.test(f)&&E){const w=this.j(m[f],h,!1,D);C[f]=w.raw,b=b||w.hasExcludedProperties,k.push(...w.restricted)}else{const w=h[f],F=w?typeof w.scope<"u"?w.scope:y.ConfigurationScope.WINDOW:void 0;w?.restricted&&k.push(f),!D.exclude?.includes(f)&&(D.include?.includes(f)||(F===void 0||D.scopes===void 0||D.scopes.includes(F))&&!(D.skipRestricted&&w?.restricted))?C[f]=m[f]:b=!0}return{raw:C,restricted:k,hasExcludedProperties:b}}l(m,h){const E=[];for(const D of Object.keys(m))if(y.$Go.test(D)){const b={};for(const C in m[D])b[C]=m[D][C];E.push({identifiers:(0,y.$Ho)(D),keys:Object.keys(b),contents:(0,I.$ej)(b,h)})}return E}}e.$Po=s;class c extends O.$Uc{constructor(m,h,E,D,b){super(),this.c=m,this.f=h,this.g=D,this.h=b,this.b=this.B(new R.$le),this.onDidChange=this.b.event,this.a=new s(this.c.toString(),b),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,C=>C.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,C=>(C.isOperation(a.FileOperation.CREATE)||C.isOperation(a.FileOperation.COPY)||C.isOperation(a.FileOperation.DELETE)||C.isOperation(a.FileOperation.WRITE))&&E.isEqual(C.resource,m)))(()=>this.b.fire()))}async loadConfiguration(){try{const m=await this.g.readFile(this.c);return this.a.parse(m.value.toString()||"{}",this.f),this.a.configurationModel}catch{return r.createEmptyModel(this.h)}}reparse(m){return m&&(this.f=m),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Qo=c;class l{constructor(m,h,E,D,b,C,k,f,w,F,N,L,q){this.a=m,this.b=h,this.c=E,this.overrideIdentifiers=D,this.d=b,this.f=C,this.g=k,this.h=f,this.i=w,this.j=F,this.k=N,this.l=L,this.m=q}get value(){return d(this.c)}n(m){return m?.value!==void 0||m?.override!==void 0||m?.overrides!==void 0?m:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(m,h,E,D,b,C,k,f,w,F){this.j=m,this.l=h,this.m=E,this.n=D,this.p=b,this.q=C,this.r=k,this.s=f,this.t=w,this.u=F,this.h=null,this.i=new A.$Ac,this.v=null}getValue(m,h,E){return this.w(m,h,E).getValue(m)}updateValue(m,h,E={}){let D;E.resource?(D=this.t.get(E.resource),D||(D=r.createEmptyModel(this.u),this.t.set(E.resource,D))):D=this.s,h===void 0?D.removeValue(m):D.setValue(m,h),E.resource||(this.h=null)}inspect(m,h,E){const D=this.w(m,h,E),b=this.A(h.resource,E),C=h.resource?this.t.get(h.resource)||this.s:this.s,k=new Set;for(const f of D.overrides)for(const w of f.identifiers)D.getOverrideValue(m,w)!==void 0&&k.add(w);return new l(m,h,D.getValue(m),k.size?[...k]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.q:void 0,b||void 0,C)}keys(m){const h=this.A(void 0,m);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(m){this.j=m,this.h=null,this.i.clear()}updatePolicyConfiguration(m){this.l=m}updateApplicationConfiguration(m){this.m=m,this.h=null,this.i.clear()}updateLocalUserConfiguration(m){this.n=m,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(m){this.p=m,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(m){this.q=m,this.h=null,this.i.clear()}updateFolderConfiguration(m,h){this.r.set(m,h),this.i.delete(m)}deleteFolderConfiguration(m){this.folderConfigurations.delete(m),this.i.delete(m)}compareAndUpdateDefaultConfiguration(m,h){const E=[];if(!h){const{added:D,updated:b,removed:C}=g(this.j,m);h=[...D,...b,...C]}for(const D of h)for(const b of(0,y.$Ho)(D)){const C=this.j.getKeysForOverrideIdentifier(b),k=m.getKeysForOverrideIdentifier(b),f=[...k.filter(w=>C.indexOf(w)===-1),...C.filter(w=>k.indexOf(w)===-1),...C.filter(w=>!T.$io(this.j.override(b).getValue(w),m.override(b).getValue(w)))];E.push([b,f])}return this.updateDefaultConfiguration(m),{keys:h,overrides:E}}compareAndUpdatePolicyConfiguration(m){const{added:h,updated:E,removed:D}=g(this.l,m),b=[...h,...E,...D];return b.length&&this.updatePolicyConfiguration(m),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(m){const{added:h,updated:E,removed:D,overrides:b}=g(this.applicationConfiguration,m),C=[...h,...E,...D];return C.length&&this.updateApplicationConfiguration(m),{keys:C,overrides:b}}compareAndUpdateLocalUserConfiguration(m){const{added:h,updated:E,removed:D,overrides:b}=g(this.localUserConfiguration,m),C=[...h,...E,...D];return C.length&&this.updateLocalUserConfiguration(m),{keys:C,overrides:b}}compareAndUpdateRemoteUserConfiguration(m){const{added:h,updated:E,removed:D,overrides:b}=g(this.remoteUserConfiguration,m),C=[...h,...E,...D];return C.length&&this.updateRemoteUserConfiguration(m),{keys:C,overrides:b}}compareAndUpdateWorkspaceConfiguration(m){const{added:h,updated:E,removed:D,overrides:b}=g(this.workspaceConfiguration,m),C=[...h,...E,...D];return C.length&&this.updateWorkspaceConfiguration(m),{keys:C,overrides:b}}compareAndUpdateFolderConfiguration(m,h){const E=this.folderConfigurations.get(m),{added:D,updated:b,removed:C,overrides:k}=g(E,h),f=[...D,...b,...C];return(f.length||!E)&&this.updateFolderConfiguration(m,h),{keys:f,overrides:k}}compareAndDeleteFolderConfiguration(m){const h=this.folderConfigurations.get(m);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(m);const{added:E,updated:D,removed:b,overrides:C}=g(h,void 0);return{keys:[...E,...D,...b],overrides:C}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(m,h,E){let D=this.x(h,E);return h.overrideIdentifier&&(D=D.override(h.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(m)!==void 0&&(D=D.merge(this.l)),D}x({resource:m},h){let E=this.y();if(h&&m){const D=h.getFolder(m);D&&(E=this.z(D.uri)||E);const b=this.t.get(m);b&&(E=E.merge(b))}return E}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(m){let h=this.i.get(m);if(!h){const E=this.y(),D=this.r.get(m);D?(h=E.merge(D),this.i.set(m,h)):h=E}return h}A(m,h){if(h&&m){const E=h.getFolder(m);if(E)return this.r.get(E.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((m,h)=>{const{contents:E,overrides:D,keys:b}=this.r.get(h);return m.push([h,{contents:E,overrides:D,keys:b}]),m},[])}}allKeys(){const m=new Set;return this.j.keys.forEach(h=>m.add(h)),this.userConfiguration.keys.forEach(h=>m.add(h)),this.q.keys.forEach(h=>m.add(h)),this.r.forEach(h=>h.keys.forEach(E=>m.add(E))),[...m.values()]}B(){const m=new Set;return this.j.getAllOverrideIdentifiers().forEach(h=>m.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>m.add(h)),this.q.getAllOverrideIdentifiers().forEach(h=>m.add(h)),this.r.forEach(h=>h.getAllOverrideIdentifiers().forEach(E=>m.add(E))),[...m.values()]}D(m){const h=new Set;return this.j.getKeysForOverrideIdentifier(m).forEach(E=>h.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(m).forEach(E=>h.add(E)),this.q.getKeysForOverrideIdentifier(m).forEach(E=>h.add(E)),this.r.forEach(E=>E.getKeysForOverrideIdentifier(m).forEach(D=>h.add(D))),[...h.values()]}static parse(m,h){const E=this.E(m.defaults,h),D=this.E(m.policy,h),b=this.E(m.application,h),C=this.E(m.user,h),k=this.E(m.workspace,h),f=m.folders.reduce((w,F)=>(w.set(o.URI.revive(F[0]),this.E(F[1],h)),w),new A.$Ac);return new i(E,D,b,C,r.createEmptyModel(h),k,f,r.createEmptyModel(h),new A.$Ac,h)}static E(m,h){return new r(m.contents,m.keys,m.overrides,void 0,h)}}e.$Ro=i;function n(...$){if($.length===0)return{keys:[],overrides:[]};if($.length===1)return $[0];const m=new Set,h=new Map;for(const D of $)D.keys.forEach(b=>m.add(b)),D.overrides.forEach(([b,C])=>{const k=(0,A.$xc)(h,b,new Set);C.forEach(f=>k.add(f))});const E=[];return h.forEach((D,b)=>E.push([b,[...D.values()]])),{keys:[...m.values()],overrides:E}}class t{constructor(m,h,E,D,b){this.change=m,this.f=h,this.g=E,this.h=D,this.i=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const C of m.keys)this.affectedKeys.add(C);for(const[,C]of m.overrides)for(const k of C)this.affectedKeys.add(k);this.d=this.a;for(const C of this.affectedKeys)this.d+=C+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(m,h){const E=this.a+m,D=this.d.indexOf(E);if(D<0)return!1;const b=D+E.length;if(b>=this.d.length)return!1;const C=this.d.charCodeAt(b);if(C!==this.b&&C!==this.c)return!1;if(h){const k=this.previousConfiguration?this.previousConfiguration.getValue(m,h,this.f?.workspace):void 0,f=this.g.getValue(m,h,this.h);return!T.$io(k,f)}return!0}}e.$To=t;function g($,m){const{added:h,removed:E,updated:D}=u(m?.rawConfiguration,$?.rawConfiguration),b=[],C=$?.getAllOverrideIdentifiers()||[],k=m?.getAllOverrideIdentifiers()||[];if(m){const f=k.filter(w=>!C.includes(w));for(const w of f)b.push([w,m.getKeysForOverrideIdentifier(w)])}if($){const f=C.filter(w=>!k.includes(w));for(const w of f)b.push([w,$.getKeysForOverrideIdentifier(w)])}if(m&&$){for(const f of C)if(k.includes(f)){const w=u({contents:$.getOverrideValue(void 0,f)||{},keys:$.getKeysForOverrideIdentifier(f)},{contents:m.getOverrideValue(void 0,f)||{},keys:m.getKeysForOverrideIdentifier(f)});b.push([f,[...w.added,...w.removed,...w.updated]])}}return{added:h,removed:E,updated:D,overrides:b}}function u($,m){const h=$?m?$.keys.filter(b=>m.keys.indexOf(b)===-1):[...$.keys]:[],E=m?$?m.keys.filter(b=>$.keys.indexOf(b)===-1):[...m.keys]:[],D=[];if($&&m){for(const b of m.keys)if($.keys.indexOf(b)!==-1){const C=(0,I.$hj)(m.contents,b),k=(0,I.$hj)($.contents,b);T.$io(C,k)||D.push(b)}}return{added:h,removed:E,updated:D}}}),define(Ne[109],Le([1,0,13,3]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.RemoteAuthorityResolverErrorCode=e.$Tl=e.$Sl=e.RemoteConnectionType=e.$Rl=void 0,e.$Vl=o,e.$Rl=(0,R.$Fi)("remoteAuthorityResolverService");var P;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class O{constructor(y){this.id=y,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Sl=O;class A{constructor(y,a){this.host=y,this.port=a,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Tl=A;var T;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class p extends v.$ab{static isNotAvailable(y){return y instanceof p&&y._code===T.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof p&&y._code===T.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof p&&y._code===T.NoResolverFound}static isInvalidAuthority(y){return y instanceof p&&y._code===T.InvalidAuthority}static isHandled(y){return y instanceof p&&y.isHandled}constructor(y,a=T.Unknown,S){super(y),this._message=y,this._code=a,this._detail=S,this.isHandled=a===T.NotAvailable&&S===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Ul=p;function o(I){const y=I.indexOf("+");return y===-1?I:I.substring(0,y)}}),define(Ne[62],Le([1,0,15]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=R,e.$in=P,e.$jn=O,e.$kn=A;function R(p){return p.scheme===v.Schemas.vscodeRemote?p.authority:void 0}function P(p){if(!p)return;const o=p.indexOf("+");return o<0?p:p.substr(0,o)}function O(p){const{host:o,port:I}=T(p);if(typeof I>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:o,port:I}}function A(p,o){let{host:I,port:y}=T(p);return typeof y>"u"&&(y=o),{host:I,port:y}}function T(p){const o=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(o)return{host:o[1],port:parseInt(o[2],10)};const I=p.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const y=p.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:p,port:void 0}}}),define(Ne[18],Le([1,0,12,3,62]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$tn=e.$sn=e.$rn=e.TargetPlatform=e.ExtensionType=e.$qn=e.$on=e.$nn=e.$mn=e.$ln=void 0,e.$pn=O,e.$un=y,e.$vn=a,e.$wn=S,e.$xn=d,e.$yn=r,e.$zn=s,v=qe(v),e.$ln="extensions.user.cache",e.$mn="extensions.builtin.cache",e.$nn="undefined_publisher",e.$on=["ui","workspace","web"];function O(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$qn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(A||(e.ExtensionType=A={}));var T;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class p{constructor(l){this.value=l,this._lower=l.toLowerCase()}static equals(l,i){if(typeof l>"u"||l===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof l=="string"||typeof i=="string"){const n=typeof l=="string"?l:l.value,t=typeof i=="string"?i:i.value;return v.$Ff(n,t)}return l._lower===i._lower}static toKey(l){return typeof l=="string"?l.toLowerCase():l._lower}}e.$rn=p;class o{get size(){return this.c.size}constructor(l){if(this.c=new Set,l)for(const i of l)this.add(i)}add(l){this.c.add(p.toKey(l))}delete(l){return this.c.delete(p.toKey(l))}has(l){return this.c.has(p.toKey(l))}}e.$sn=o;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(l){this.c.delete(p.toKey(l))}get(l){return this.c.get(p.toKey(l))}has(l){return this.c.has(p.toKey(l))}set(l,i){this.c.set(p.toKey(l),i)}values(){return this.c.values()}forEach(l){this.c.forEach(l)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$tn=I;function y(c){return a(c)}function a(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}function S(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}function d(c,l){if(l){const i=`onResolveRemoteAuthority:${(0,P.$in)(l)}`;return!!c.activationEvents?.includes(i)}return!1}function r(c){return c.map(l=>{const[i,n]=l.split("@");return{proposalName:i,version:n?parseInt(n):void 0}})}function s(c){return c.map(l=>l.split("@")[0])}e.$An=(0,R.$Fi)("IBuiltinExtensionsScannerService")}),define(Ne[110],Le([1,0,20,9,18,3]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.ExtensionManagementErrorCode=e.$mp=e.ExtensionGalleryErrorCode=e.$lp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=void 0,e.$fp=T,e.$gp=p,e.$hp=o,e.$ip=I,e.$jp=y,e.$kp=a,e.$$o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$_o=new RegExp(e.$$o),e.$ap="__web_extension",e.$bp="skipWalkthrough",e.$cp="extensionInstallSource",e.$dp="dependecyOrPackExtensionInstall",e.$ep="clientTargetPlatform";var A;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function T(t){switch(t){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function p(t){switch(t){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function o(t,g){switch(t){case v.Platform.Windows:return g==="x64"?P.TargetPlatform.WIN32_X64:g==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Linux:return g==="x64"?P.TargetPlatform.LINUX_X64:g==="arm64"?P.TargetPlatform.LINUX_ARM64:g==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return g==="x64"?P.TargetPlatform.ALPINE_X64:g==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Mac:return g==="x64"?P.TargetPlatform.DARWIN_X64:g==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Web:return P.TargetPlatform.WEB}}function I(t,g){return g===P.TargetPlatform.WEB&&!t.includes(P.TargetPlatform.WEB)}function y(t,g,u){return I(g,u)?!1:t===P.TargetPlatform.UNDEFINED||t===P.TargetPlatform.UNIVERSAL?!0:t===P.TargetPlatform.UNKNOWN?!1:t===u}function a(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var S;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(S||(e.SortBy=S={}));var d;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var r;(function(t){t.Install="install",t.Uninstall="uninstall"})(r||(e.StatisticType=r={}));var s;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(s||(e.InstallOperation=s={})),e.$lp=(0,O.$Fi)("extensionGalleryService");var c;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(c||(e.ExtensionGalleryErrorCode=c={}));class l extends Error{constructor(g,u){super(g),this.code=u,this.name=u}}e.$mp=l;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class n extends Error{constructor(g,u){super(g),this.code=u,this.name=u}}e.$np=n,e.$op=(0,O.$Fi)("extensionManagementService"),e.$pp="extensionsIdentifiers/disabled",e.$qp="extensionsIdentifiers/enabled",e.$rp=(0,O.$Fi)("IGlobalExtensionEnablementService"),e.$sp=(0,O.$Fi)("IExtensionTipsService"),e.$tp=(0,R.localize2)(11501,"Extensions"),e.$up=(0,R.localize2)(11502,"Preferences")}),define(Ne[111],Le([1,0,13,18]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YG=e.$XG=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(A,T){this.a.set(A,T)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const T=Object.create(null);for(const p of A){const o=this.readActivationEvents(p);o.length>0&&(T[R.$rn.toKey(p.identifier)]=o)}return T}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const T=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let p=0;p<T.length;p++)T[p]==="onUri"&&(T[p]=`onUri:${R.$rn.toKey(A.identifier)}`);if(!A.contributes)return T;for(const p in A.contributes){const o=this.a.get(p);if(!o)continue;const I=A.contributes[p],y=Array.isArray(I)?I:[I];try{o(y,T)}catch(a){(0,v.$Y)(a)}}return T}}e.$XG=P,e.$YG=new P});var xt=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[175],Le([1,0,23,35,9,281,18,104]),function(ve,e,v,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=I,e.$1p=y,e.$2p=a,e.$3p=S,e.$4p=d,e.$5p=r,e.$6p=s,e.$7p=c,R=xt(R),P=qe(P),O=qe(O);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,o=/^-(\d{4})(\d{2})(\d{2})$/;function I(n){return n=n.trim(),n==="*"||p.test(n)}function y(n){if(!I(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=n.match(p);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function a(n){if(!n)return null;const t=n.majorBase,g=n.majorMustEqual,u=n.minorBase;let $=n.minorMustEqual;const m=n.patchBase;let h=n.patchMustEqual;n.hasCaret&&(t===0||($=!1),h=!1);let E=0;if(n.preRelease){const D=o.exec(n.preRelease);if(D){const[,b,C,k]=D;E=Date.UTC(Number(b),Number(C)-1,Number(k))}}return{majorBase:t,majorMustEqual:g,minorBase:u,minorMustEqual:$,patchBase:m,patchMustEqual:h,isMinimum:n.hasGreaterEquals,notBefore:E}}function S(n,t,g){let u;typeof n=="string"?u=a(y(n)):u=n;let $;t instanceof Date?$=t.getTime():typeof t=="string"&&($=new Date(t).getTime());let m;if(typeof g=="string"?m=a(y(g)):m=g,!u||!m)return!1;const h=u.majorBase,E=u.minorBase,D=u.patchBase;let b=m.majorBase,C=m.minorBase,k=m.patchBase;const f=m.notBefore;let w=m.majorMustEqual,F=m.minorMustEqual,N=m.patchMustEqual;return m.isMinimum?h>b?!0:h<b?!1:E>C?!0:E<C||$&&$<f?!1:D>=k:(h===1&&b===0&&(!w||!F||!N)&&(b=1,C=0,k=0,w=!0,F=!1,N=!1),h<b?!1:h>b?!w:E<C?!1:E>C?!F:D<k?!1:D>k?!N:!($&&$<f))}function d(n,t,g,u,$,m){const h=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return h.push([R.default.Error,P.localize(11432,null)]),h;if(typeof u.name!="string")return h.push([R.default.Error,P.localize(11433,null,"name")]),h;if(typeof u.version!="string")return h.push([R.default.Error,P.localize(11434,null,"version")]),h;if(!u.engines)return h.push([R.default.Error,P.localize(11435,null,"engines")]),h;if(typeof u.engines.vscode!="string")return h.push([R.default.Error,P.localize(11436,null,"engines.vscode")]),h;if(typeof u.extensionDependencies<"u"&&!i(u.extensionDependencies))return h.push([R.default.Error,P.localize(11437,null,"extensionDependencies")]),h;if(typeof u.activationEvents<"u"){if(!i(u.activationEvents))return h.push([R.default.Error,P.localize(11438,null,"activationEvents")]),h;if(typeof u.main>"u"&&typeof u.browser>"u")return h.push([R.default.Error,P.localize(11439,null,"activationEvents","main","browser")]),h}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&h.push([R.default.Warning,P.localize(11440,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return h.push([R.default.Error,P.localize(11441,null,"main")]),h;{const b=(0,v.$gh)(g,u.main);(0,v.$ah)(b,g)||h.push([R.default.Warning,P.localize(11442,null,b.path,g.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return h.push([R.default.Error,P.localize(11443,null,"browser")]),h;{const b=(0,v.$gh)(g,u.browser);(0,v.$ah)(b,g)||h.push([R.default.Warning,P.localize(11444,null,b.path,g.path)])}}if(!O.valid(u.version))return h.push([R.default.Error,P.localize(11445,null)]),h;const E=[];if(!r(n,t,u,$,E))for(const b of E)h.push([R.default.Error,b]);if(m&&u.enabledApiProposals?.length){const b=[];if(!c([...u.enabledApiProposals],b))for(const C of b)h.push([R.default.Error,C])}return h}function r(n,t,g,u,$){return u||typeof g.main>"u"&&typeof g.browser>"u"?!0:l(n,t,g.engines.vscode,$)}function s(n,t,g){return n==="*"||l(t,g,n)}function c(n,t){if(n.length===0)return!0;const g=Array.isArray(t)?t:void 0,u=(g?void 0:t)??T.allApiProposals,$=[],m=(0,A.$yn)(n);for(const{proposalName:h,version:E}of m){const D=u[h];D&&E&&D.version!==E&&$.push(P.localize(11446,null,h))}return g?.push(...$),$.length===0}function l(n,t,g,u=[]){const $=a(y(g));if(!$)return u.push(P.localize(11447,null,g)),!1;if($.majorBase===0){if(!$.majorMustEqual||!$.minorMustEqual)return u.push(P.localize(11448,null,g)),!1}else if(!$.majorMustEqual)return u.push(P.localize(11449,null,g)),!1;return S(n,t,$)?!0:(u.push(P.localize(11450,null,n,g)),!1)}function i(n){if(!Array.isArray(n))return!1;for(let t=0,g=n.length;t<g;t++)if(typeof n[t]!="string")return!1;return!0}}),define(Ne[176],Le([1,0,22,13,4,9,53,3,11,30]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=void 0,e.$0p=a,e.$$p=S,e.$_p=d,e.$aq=r,e.$bq=s,e.$cq=c,e.$8p=(0,T.$Fi)("requestService");class I{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const g in this.b)g.toLowerCase()==="authorization"||g.toLowerCase()==="proxy-authorization"?t[g]="*****":t[g]=this.b[g];this.a=t}return this.a}}class y extends P.$Uc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,O.localize)(11219,null),when:p.$sk.isEqualTo((0,p.$pk)(p.LogLevel.Trace)).serialize()})}async c(t,g,u){const $=`${t} #${++this.b}: ${g.url}`;this.a.trace(`${$} - begin`,g.type,new I(g.headers??{}));try{const m=await u();return this.a.trace(`${$} - end`,g.type,m.res.statusCode,m.res.headers),m}catch(m){throw this.a.error(`${$} - error`,g.type,(0,R.$9)(m)),m}}}e.$9p=y;function a(n){return n.res.statusCode&&n.res.statusCode>=200&&n.res.statusCode<300||n.res.statusCode===1223}function S(n){return n.res.statusCode===204}async function d(n){return S(n)?null:(await(0,v.$Ze)(n.stream)).toString()}async function r(n){if(!a(n))throw new Error("Server returned "+n.res.statusCode);return d(n)}async function s(n){if(!a(n))throw new Error("Server returned "+n.res.statusCode);if(S(n))return null;const g=(await(0,v.$Ze)(n.stream)).toString();try{return JSON.parse(g)}catch(u){throw u.message+=`:
`+g,u}}function c(n){i(n)}let l;function i(n){const t=o.$ro.as(A.$wo.Configuration),g=l;l={id:"http",order:15,title:(0,O.localize)(11220,null),type:"object",scope:n,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(11221,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(11222,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(11223,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,O.localize)(11224,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(11225,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(11226,null),(0,O.localize)(11227,null),(0,O.localize)(11228,null),(0,O.localize)(11229,null)],default:"override",description:(0,O.localize)(11230,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11231,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(11232,null),restricted:!0}}},t.updateConfigurations({add:[l],remove:g?[g]:[]})}i(A.ConfigurationScope.APPLICATION)}),define(Ne[177],Le([1,0,20,78,38]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=A,e.$wp=T;function O(p){if(v.$v===v.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function A(p,o,I,y,a,S,d,r,s,c){const l=Object.create(null);l["common.machineId"]=S,l["common.sqmId"]=d,l["common.devDeviceId"]=r,l.sessionID=(0,P.$2g)()+Date.now(),l.commitHash=y,l.version=a,l["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,v.$i)(v.$v),l["common.nodePlatform"]=R.$dc,l["common.nodeArch"]=I,l["common.product"]=c||"desktop",s&&(l["common.msftInternal"]=s);let i=0;const n=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),v.$m&&(l["common.snap"]="true");const t=O(o);return t&&(l["common.platformDetail"]=t),l}function T(p){const o=R.env.USERDNSDOMAIN;if(!o)return!1;const I=o.toLowerCase();return p.some(y=>I===y)}}),define(Ne[112],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=void 0,e.$_l=(0,v.$Fi)("telemetryService"),e.$am=(0,v.$Fi)("customEndpointTelemetryService"),e.$bm="telemetry.currentSessionDate",e.$cm="telemetry.firstSessionDate",e.$dm="telemetry.lastSessionDate",e.$em="telemetry.machineId",e.$fm="telemetry.sqmId",e.$gm="telemetry.devDeviceId",e.$hm="telemetry",e.$im="telemetry.telemetryLevel",e.$jm="telemetry.enableCrashReporter",e.$km="telemetry.enableTelemetry";var R;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var P;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Ne[63],Le([1,0,25,14,62,177,112]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=void 0,e.$Ep=I,e.$Fp=y,e.$Gp=a,e.$Hp=S,e.$Ip=r,e.$Jp=c,e.$Kp=l,e.$Lp=t;class T{constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.$xp=T;class p{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$yp=p,e.$zp=new p;class o{async publicLog(u,$,m){}async publicLogError(u,$,m){}}e.$Ap=o,e.$Bp="telemetry",e.$Cp="extensionTelemetryLog",e.$Dp={log:()=>null,flush:()=>Promise.resolve(null)};function I(g,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!g.enableTelemetry)}function y(g,u){return u.extensionTestsLocationURI?!0:!(u.isBuilt||u.disableTelemetry||g.enableTelemetry&&g.aiConfig?.ariaKey)}function a(g){const u=g.getValue(A.$im),$=g.getValue(A.$jm);if(g.getValue(A.$km)===!1||$===!1)return A.TelemetryLevel.NONE;switch(u??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function S(g){const u={},$={},m={};s(g,m);for(let h in m){h=h.length>150?h.substr(h.length-149):h;const E=m[h];typeof E=="number"?$[h]=E:typeof E=="boolean"?$[h]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${h} has been trimmed to 8192, the original length is ${E.length}`),u[h]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(u[h]=E)}return{properties:u,measurements:$}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(g){if(!g)return"none";const u=(0,P.$in)(g);return d.has(u)?u:"other"}function s(g,u,$=0,m){if(g)for(const h of Object.getOwnPropertyNames(g)){const E=g[h],D=m?m+h:h;Array.isArray(E)?u[D]=(0,v.$jo)(E):E instanceof Date?u[D]=E.toISOString():(0,R.$gg)(E)?$<2?s(E,u,$+1,D+"."):u[D]=(0,v.$jo)(E):u[D]=E}}function c(g,u){const $=g.msftInternalDomains||[],m=u.getValue("telemetry.internalTesting");return(0,O.$wp)($)||m}function l(g){return[g.appRoot,g.extensionsPath,g.userHome.fsPath,g.tmpDir.fsPath,g.userDataPath]}function i(g,u){if(!g||!g.includes("/")&&!g.includes("\\"))return g;let $=g;const m=[];for(const b of u)for(;;){const C=b.exec(g);if(!C)break;m.push([C.index,b.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for($="";;){const b=E.exec(g);if(!b)break;const C=m.some(([k,f])=>b.index<f&&k<E.lastIndex);!h.test(b[0])&&!C&&($+=g.substring(D,b.index)+"<REDACTED: user-file-path>",D=E.lastIndex)}return D<g.length&&($+=g.substr(D)),$}function n(g){if(!g)return g;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const $ of u)if($.regex.test(g))return`<REDACTED: ${$.label}>`;return g}function t(g,u){return(0,v.$go)(g,$=>{if($ instanceof T||Object.hasOwnProperty.call($,"isTrustedTelemetryValue"))return $.value;if(typeof $=="string"){let m=$.replaceAll("%20"," ");m=i(m,u);for(const h of u)m=m.replace(h,"");return m=n(m),m}})}}),define(Ne[178],Le([1,0,12,110,18,20,2,13,78,63]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Np=void 0,e.$Mp=I,e.$Op=d,e.$Pp=r,e.$Qp=s,e.$Rp=c,e.$Sp=l,e.$Tp=i,e.$Up=n,e.$Wp=t,e.$Xp=u;function I($,m){return $.uuid&&m.uuid?$.uuid===m.uuid:$.id===m.id?!0:(0,v.$Af)($.id,m.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class a{static create(m){const h=m.manifest?m.manifest.version:m.version,E=m.manifest?m.targetPlatform:m.properties.targetPlatform;return new a(m.identifier,h,E)}static parse(m){const h=y.exec(m);return h&&h[1]&&h[2]?new a({id:h[1]},h[2],h[4]||void 0):null}constructor(m,h,E=P.TargetPlatform.UNDEFINED){this.identifier=m,this.version=h,this.targetPlatform=E,this.id=m.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(m){return m instanceof a?I(this,m)&&this.version===m.version&&this.targetPlatform===m.targetPlatform:!1}}e.$Np=a;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d($){const m=S.exec($);return m&&m[1]?[s(m[1]),m[2]]:[s($),void 0]}function r($,m){return`${$}.${m}`}function s($){return $.toLowerCase()}function c($,m){return s(r($??P.$nn,m))}function l($,m){const h=[],E=D=>{for(const b of h)if(b.some(C=>I(m(C),m(D))))return b;return null};for(const D of $){const b=E(D);b?b.push(D):h.push([D])}return h}function i($){return{id:$.identifier.id,name:$.manifest.name,galleryId:null,publisherId:$.publisherId,publisherName:$.manifest.publisher,publisherDisplayName:$.publisherDisplayName,dependencies:$.manifest.extensionDependencies&&$.manifest.extensionDependencies.length>0}}function n($){return{id:new o.$xp($.identifier.id),name:new o.$xp($.name),version:$.version,galleryId:$.identifier.uuid,publisherId:$.publisherId,publisherName:$.publisher,publisherDisplayName:$.publisherDisplayName,isPreReleaseVersion:$.properties.isPreReleaseVersion,dependencies:!!($.properties.dependencies&&$.properties.dependencies.length>0),isSigned:$.isSigned,...$.telemetryData}}e.$Vp=new P.$rn("pprice.better-merge");function t($,m){const h=[],E=m.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const D=E.shift();if(D&&h.every(b=>!I(b.identifier,{id:D}))){const b=$.filter(C=>I(C.identifier,{id:D}));b.length===1&&(h.push(b[0]),E.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}async function g($,m){if(!O.$l)return!1;let h;try{h=(await $.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{h=(await $.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){m.debug("Error while getting the os-release file.",(0,T.$9)(D))}}return!!h&&(h.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u($,m){const h=await g($,m),E=(0,R.$hp)(h?"alpine":O.$v,p.$ec);return m.debug("ComputeTargetPlatform:",E),E}}),define(Ne[179],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=v,e.$Gs=R,e.$Hs=P,e.$Is=O,e.$Js=A,e.$Ks=T;function v(p){return[...p.entries()]}function R(p){return p?[...p.entries()]:[]}function P(p){return new Map(p)}function O(p){return new Map(p??[])}function A(p){return Array.from(p.entries()).map(o=>[o[0],v(o[1].map),R(o[1].descriptionMap)])}function T(p){return new Map(p.map(o=>[o[0],{map:P(o[1]),descriptionMap:O(o[2])}]))}}),define(Ne[180],Le([1,0,3,31,30]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=e.$rs=e.$qs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ps=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$os=void 0,e.$os=new R.$Wj("terminalTabFocusMode",!1,!0);var O;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var A;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var T;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(T||(e.PosixShellType=T={}));var p;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(p||(e.WindowsShellType=p={}));var o;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(o||(e.TitleEventSource=o={}));var I;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(I||(e.TerminalIpcChannels=I={}));var y;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$ps=(0,v.$Fi)("ptyService");var a;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(a||(e.HeartbeatConstants=a={}));var S;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(S||(e.TerminalLocation=S={}));var d;(function(t){t.TerminalView="view",t.Editor="editor"})(d||(e.TerminalLocationString=d={}));var r;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(r||(e.LocalReconnectConstants=r={}));var s;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(s||(e.FlowControlConstants=s={}));var c;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(c||(e.ProfileSource=c={}));var l;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(l||(e.ShellIntegrationStatus=l={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$qs={Backend:"workbench.contributions.terminal.processBackend"};class n{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(g){const u=this.b(g.remoteAuthority);if(this.a.has(u))throw new Error(`A terminal backend with remote authority '${u}' was already registered.`);this.a.set(u,g)}getTerminalBackend(g){return this.a.get(this.b(g))}b(g){return g?.toLowerCase()??""}}P.$ro.add(e.$qs.Backend,new n),e.$rs=(0,v.$Fi)("localPtyService"),e.$ss=(0,v.$Fi)("terminalLogService")}),define(Ne[181],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xxb=void 0;class v{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,O,A=5){const T=O(p=>{const o=typeof p=="string"?p:p.data;let I=this.a.get(P);if(I){I.data.push(o);return}const y=setTimeout(()=>this.flushBuffer(P),A);I={data:[o],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(P),T.dispose()}},this.a.set(P,I)});return T}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const O=this.a.get(P);O&&(this.a.delete(P),this.b(P,O.data.join("")))}}e.$Xxb=v}),define(Ne[182],Le([1,0,10,97,282,34,6,14,2,9,77,30]),function(ve,e,v,R,P,O,A,T,p,o,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ix=e.$Hx=e.$Gx=e.$Fx=e.$Ex=e.$Dx=e.IconFontDefinition=e.IconContribution=e.$Ax=void 0,e.$Bx=s,e.$Cx=c,y=qe(y),e.$Ax={IconContribution:"base.contributions.icons"};var a;(function(t){function g(u,$){let m=u.defaults;for(;O.ThemeIcon.isThemeIcon(m);){const h=r.getIcon(m.id);if(!h)return;m=h.defaults}return m}t.getDefinition=g})(a||(e.IconContribution=a={}));var S;(function(t){function g($){return{weight:$.weight,style:$.style,src:$.src.map(m=>({format:m.format,location:m.location.toString()}))}}t.toJSONObject=g;function u($){const m=h=>(0,T.$eg)(h)?h:void 0;if($&&Array.isArray($.src)&&$.src.every(h=>(0,T.$eg)(h.format)&&(0,T.$eg)(h.location)))return{weight:m($.weight),style:m($.style),src:$.src.map(h=>({format:h.format,location:p.URI.parse(h.location)}))}}t.fromJSONObject=u})(S||(e.IconFontDefinition=S={}));class d{constructor(){this.a=new A.$le,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,o.localize)(11151,null)},fontCharacter:{type:"string",description:(0,o.localize)(11152,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,u,$,m){const h=this.b[g];if(h){if($&&!h.description){h.description=$,this.d.properties[g].markdownDescription=`${$} $(${g})`;const b=this.e.enum.indexOf(g);b!==-1&&(this.e.enumDescriptions[b]=$),this.a.fire()}return h}const E={id:g,description:$,defaults:u,deprecationMessage:m};this.b[g]=E;const D={$ref:"#/definitions/icons"};return m&&(D.deprecationMessage=m),$&&(D.markdownDescription=`${$}: $(${g})`),this.d.properties[g]=D,this.e.enum.push(g),this.e.enumDescriptions.push($||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const u=this.e.enum.indexOf(g);u!==-1&&(this.e.enum.splice(u,1),this.e.enumDescriptions.splice(u,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,u){const $=this.f[g];return $||(this.f[g]=u,this.a.fire(),u)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(h,E)=>h.id.localeCompare(E.id),u=h=>{for(;O.ThemeIcon.isThemeIcon(h.defaults);)h=this.b[h.defaults.id];return`codicon codicon-${h?h.id:""}`},$=[];$.push("| preview     | identifier                        | default codicon ID                | description"),$.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const m=Object.keys(this.b).map(h=>this.b[h]);for(const h of m.filter(E=>!!E.description).sort(g))$.push(`|<i class="${u(h)}"></i>|${h.id}|${O.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);$.push("| preview     | identifier                        "),$.push("| ----------- | --------------------------------- |");for(const h of m.filter(E=>!O.ThemeIcon.isThemeIcon(E.defaults)).sort(g))$.push(`|<i class="${u(h)}"></i>|${h.id}|`);return $.join(`
`)}}const r=new d;y.$ro.add(e.$Ax.IconContribution,r);function s(t,g,u,$){return r.registerIcon(t,g,u,$)}function c(){return r}function l(){const t=(0,P.$1j)();for(const g in t){const u="\\"+t[g].toString(16);r.registerIcon(g,{fontCharacter:u})}}l(),e.$Dx="vscode://schemas/icons";const i=y.$ro.as(I.$so.JSONContribution);i.registerSchema(e.$Dx,r.getIconSchema());const n=new v.$Rh(()=>i.notifySchemaChanged(e.$Dx),200);r.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$Ex=s("widget-close",R.$5j.close,(0,o.localize)(11153,null)),e.$Fx=s("goto-previous-location",R.$5j.arrowUp,(0,o.localize)(11154,null)),e.$Gx=s("goto-next-location",R.$5j.arrowDown,(0,o.localize)(11155,null)),e.$Hx=O.ThemeIcon.modify(R.$5j.sync,"spin"),e.$Ix=O.ThemeIcon.modify(R.$5j.loading,"spin")}),define(Ne[183],Le([1,0,6,4,20,2,43,3,11]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pw=e.$Ow=e.$Lw=e.$Jw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Fw=e.$Ew=void 0,e.$Gw=y,e.$Hw=S,e.$Iw=d,e.$Kw=r,e.$Mw=s,e.$Nw=c,e.$Ew=(0,T.$Fi)("tunnelService"),e.$Fw=(0,T.$Fi)("sharedTunnelsService");var o;(function(n){n.Http="http",n.Https="https"})(o||(e.TunnelProtocol=o={}));var I;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(I||(e.TunnelPrivacyId=I={}));function y(n){return!!n.forwardPort}var a;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(a||(e.ProvidedOnAutoForward=a={}));function S(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(t)return{address:t[1],port:+t[2]}}function d(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const t=n.query.split("&");for(const g of t){const u=g.split("=")[1];if(/^https?:/.exec(u)){const $=S(O.URI.parse(u));if($)return $}}}e.$Jw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function r(n){return e.$Jw.indexOf(n)>=0}e.$Lw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function s(n){return e.$Lw.indexOf(n)>=0}function c(n,t,g,u){if(g===P.OperatingSystem.Windows)return!1;if(g===P.OperatingSystem.Macintosh&&s(t)){const $=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if($?.length===4&&parseInt($[1])>=18)return!1}return n<1024}class l{constructor(t,g,u){this.remoteAddress=t,this.localAddress=g,this.b=u,this.a=new v.$le,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Ow=l;let i=class extends R.$Uc{constructor(t,g){super(),this.r=t,this.s=g,this.a=new v.$le,this.onTunnelOpened=this.a.event,this.b=new v.$le,this.onTunnelClosed=this.b.event,this.c=new v.$le,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],g=Array.from(this.f.values());for(const u of g){const $=Array.from(u.values());for(const m of $){const h=await m.value;h&&typeof h!="string"&&t.push(h)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:g}of t.values())await g.then(u=>typeof u!="string"?u?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,g,u,$,m){this.z(t,g,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:g,localAddress:u,privacy:$,protocol:m,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,g){(s(t)||r(t))&&(t=e.$Jw[0]);const u=this.D(t,g);if(u)return++u.refcount,u.value}openTunnel(t,g,u,$,m,h=!1,E,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${u} on local port ${m}.`);const b=this.g??t;if(!b)return;if(g||(g="localhost"),$||($=this.t),this.g&&this.n.has(u)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const C=this.F(b,g,u,$,m,h,E,D);return C?C.then(k=>{if(k){if(typeof k=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(g,u),k}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(g,u);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.w(k);return(k.tunnelRemoteHost!==g||k.tunnelRemotePort!==u)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),E&&k.privacy!==E&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(f),f}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),C)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const g=this.f.get(t.tunnelRemoteHost);if(g){const u=g.get(t.tunnelRemotePort);u&&(u.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,u))}}}}async y(t,g,u){if(u.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${g}.`);const $=u.value.then(async m=>{m&&typeof m!="string"&&(await m.dispose(!0),this.b.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(g),$}}async closeTunnel(t,g){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${g} `);const u=this.f.get(t);if(u&&u.has(g)){const $=u.get(g);$.refcount=0,await this.y(t,g,$)}}z(t,g,u){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(g,{refcount:1,value:u})}async C(t,g){const u=this.f.get(t);if(u){const $=u.get(g),m=$?await $.value:void 0;(!m||typeof m=="string")&&u.delete(g),u.size===0&&this.f.delete(t)}}D(t,g){const u=[t];r(t)?(u.push(...e.$Jw),u.push(...e.$Lw)):s(t)&&u.push(...e.$Lw);const $=u.map(m=>this.f.get(m));for(const m of $){const h=m?.get(g);if(h)return h}}canTunnel(t){return!!S(t)}G(t,g,u,$,m,h,E){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${u} on local port ${$}.`);const D=u;this.n.add(D);const b=$===void 0?u:$,C={elevationRequired:m?this.isPortPrivileged(b):!1},k={remoteAddress:{host:g,port:u},localAddressPort:$,privacy:h,public:h?h!==I.Private:void 0,protocol:E},f=t.forwardPort(k,C);return f?(this.z(g,u,f),f.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),f}};e.$Pw=i,e.$Pw=i=Je([Ve(0,p.$ak),Ve(1,A.$_i)],i)}),define(Ne[184],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=void 0,e.$Kl=(0,v.$Fi)("IUriIdentityService")}),define(Ne[185],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Qw=void 0,e.$Qw=(0,v.$Fi)("editSessionIdentityService");var R;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(R||(e.EditSessionIdentityMatch=R={}))}),define(Ne[186],Le([1,0,15]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=R,e.$iN=P,e.$jN=O,e.$kN=A,e.$lN=T;function R(p){return p.scheme!==v.Schemas.file&&p.scheme!==v.Schemas.vscodeRemote}function P(p){if(p.folders.length)return p.folders.every(o=>R(o.uri))?p.folders[0].uri:void 0;if(p.configuration&&R(p.configuration))return p.configuration}function O(p){return P(p)?.scheme}function A(p){return P(p)?.authority}function T(p){return P(p)!==void 0}}),define(Ne[49],Le([1,0,9,19,58,23,2,3,15]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$5i=e.$4i=e.$3i=e.$2i=e.$Zi=e.$Yi=e.WorkbenchState=e.$Si=e.$Ri=e.$Oi=void 0,e.$Pi=o,e.$Qi=I,e.$Ti=y,e.$Ui=a,e.$Vi=S,e.$Wi=r,e.$Xi=s,e.$1i=i,e.$6i=n,e.$7i=t,e.$9i=g,e.$0i=u,e.$$i=$,e.$Oi=(0,T.$Fi)("contextService");function o(m){const h=m;return typeof h?.id=="string"&&A.URI.isUri(h.uri)}function I(m){return typeof m?.id=="string"&&!o(m)&&!a(m)}e.$Ri={id:"ext-dev"},e.$Si={id:"empty-window"};function y(m,h){if(typeof m=="string"||typeof m>"u")return typeof m=="string"?{id:(0,R.$nc)(m)}:h?e.$Ri:e.$Si;const E=m;return E.configuration?{id:E.id,configPath:E.configuration}:E.folders.length===1?{id:E.id,uri:E.folders[0].uri}:{id:E.id}}function a(m){const h=m;return typeof h?.id=="string"&&A.URI.isUri(h.configPath)}function S(m){const h=m;if(h?.uri)return{id:h.id,uri:A.URI.revive(h.uri)};const E=m;if(E?.configPath)return{id:E.id,configPath:A.URI.revive(E.configPath)};if(m?.id)return{id:m.id}}var d;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function r(m){const h=m;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}function s(m){const h=m;return!!(h&&typeof h=="object"&&A.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}class c{constructor(h,E,D,b,C){this.h=h,this.j=D,this.k=b,this.l=C,this.c=P.$Li.forUris(this.l,()=>!0),this.folders=E}update(h){this.h=h.id,this.k=h.configuration,this.j=h.transient,this.l=h.l,this.folders=h.folders}get folders(){return this.g}set folders(h){this.g=h,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(h){this.k=h}getFolder(h){return h&&this.c.findSubstr(h)||null}n(){this.c=P.$Li.forUris(this.l,()=>!0);for(const h of this.folders)this.c.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Yi=c;class l{constructor(h,E){this.raw=E,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,O.$gh)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Zi=l;function i(m){return new l({uri:m,index:0,name:(0,O.$ch)(m)},{uri:m.toString()})}e.$2i="code-workspace",e.$3i=`.${e.$2i}`,e.$4i=[{name:(0,v.localize)(11030,null),extensions:[e.$2i]}],e.$5i="workspace.json";function n(m,h){return O.$0g.isEqualOrParent(m,h.untitledWorkspacesHome)}function t(m){let h;return A.URI.isUri(m)?h=m:h=m.configuration,h?.scheme===p.Schemas.tmp}e.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function g(m){return m.id===e.$8i}function u(m,h){return!n(m,h)&&!t(m)}function $(m){return(typeof m=="string"?(0,R.$oc)(m):(0,O.$eh)(m))===e.$3i}}),define(Ne[113],Le([1,0,75,6,4,23,2,9,106,29,3,11,49,28,184,10,38,12,14]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.$Ml=e.ProfileResourceType=void 0,e.$Ll=n,e.$Nl=t,e.$Ol=g;var i;(function(m){m.Settings="settings",m.Keybindings="keybindings",m.Snippets="snippets",m.Tasks="tasks",m.Extensions="extensions",m.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function n(m){const h=m;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&typeof h.isDefault=="boolean"&&typeof h.name=="string"&&A.URI.isUri(h.location)&&A.URI.isUri(h.globalStorageHome)&&A.URI.isUri(h.settingsResource)&&A.URI.isUri(h.keybindingsResource)&&A.URI.isUri(h.tasksResource)&&A.URI.isUri(h.snippetsHome)&&A.URI.isUri(h.extensionsResource))}e.$Ml=(0,I.$Fi)("IUserDataProfilesService");function t(m,h){return{id:m.id,isDefault:m.isDefault,name:m.name,shortName:m.shortName,icon:m.icon,location:A.URI.revive(m.location).with({scheme:h}),globalStorageHome:A.URI.revive(m.globalStorageHome).with({scheme:h}),settingsResource:A.URI.revive(m.settingsResource).with({scheme:h}),keybindingsResource:A.URI.revive(m.keybindingsResource).with({scheme:h}),tasksResource:A.URI.revive(m.tasksResource).with({scheme:h}),snippetsHome:A.URI.revive(m.snippetsHome).with({scheme:h}),extensionsResource:A.URI.revive(m.extensionsResource).with({scheme:h}),cacheHome:A.URI.revive(m.cacheHome).with({scheme:h}),useDefaultFlags:m.useDefaultFlags,isTransient:m.isTransient}}function g(m,h,E,D,b,C){return{id:m,name:h,location:E,isDefault:!1,shortName:b?.shortName,icon:b?.icon,globalStorageHome:C&&b?.useDefaultFlags?.globalState?C.globalStorageHome:(0,O.$gh)(E,"globalStorage"),settingsResource:C&&b?.useDefaultFlags?.settings?C.settingsResource:(0,O.$gh)(E,"settings.json"),keybindingsResource:C&&b?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,O.$gh)(E,"keybindings.json"),tasksResource:C&&b?.useDefaultFlags?.tasks?C.tasksResource:(0,O.$gh)(E,"tasks.json"),snippetsHome:C&&b?.useDefaultFlags?.snippets?C.snippetsHome:(0,O.$gh)(E,"snippets"),extensionsResource:C&&b?.useDefaultFlags?.extensions?C.extensionsResource:(0,O.$gh)(E,"extensions.json"),cacheHome:(0,O.$gh)(D,m),useDefaultFlags:b?.useDefaultFlags,isTransient:b?.transient}}let u=class extends P.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(h,E,D,b){super(),this.t=h,this.u=E,this.w=D,this.y=b,this.f=!0,this.h=this.B(new R.$le),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$le),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$le),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$le),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new S.$Ac,workspaces:new S.$Ac,emptyWindows:new Map},this.profilesHome=(0,O.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(h){this.f!==h&&(this.z=void 0,this.f=h)}isEnabled(){return this.f}get C(){if(!this.z){const h=this.D(),E=[h];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,l.$eg)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}E.push(g((0,O.$dh)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},h))}}catch(C){this.y.error(C)}const D=new S.$Ac,b=new Map;if(E.length)try{const C=this.Q();if(C.workspaces)for(const[k,f]of Object.entries(C.workspaces)){const w=A.URI.parse(k),F=E.find(N=>N.id===f);F&&D.set(w,F)}if(C.emptyWindows)for(const[k,f]of Object.entries(C.emptyWindows)){const w=E.find(F=>F.id===f);w&&b.set(k,w)}}catch(C){this.y.error(C)}this.z={profiles:E,workspaces:D,emptyWindows:b}}return this.z}D(){const h=g("__default__profile__",(0,T.localize)(11077,null),this.t.userRoamingDataHome,this.g);return{...h,extensionsResource:this.S()??h.extensionsResource,isDefault:!0}}async createTransientProfile(h){const E="Temp",D=new RegExp(`${(0,c.$hf)(E)}\\s(\\d+)`);let b=0;for(const k of this.profiles){const f=D.exec(k.name),w=f?parseInt(f[1]):0;b=w>b?w:b}const C=`${E} ${b+1}`;return this.createProfile((0,v.$tj)((0,s.$2g)()).toString(16),C,{transient:!0},h)}async createNamedProfile(h,E,D){return this.createProfile((0,v.$tj)((0,s.$2g)()).toString(16),h,E,D)}async createProfile(h,E,D,b){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F(h,E,D);return b&&await this.setProfileForWorkspace(b,C),C}async F(h,E,D){if(!(0,l.$eg)(E)||!E)throw new Error("Name of the profile is mandatory and must be of type `string`");let b=this.r.get(E);return b||(b=(async()=>{try{if(this.profiles.find(w=>w.name===E||w.id===h))throw new Error(`Profile with ${E} name already exists`);const k=g(h,E,(0,O.$gh)(this.profilesHome,h),this.g,D,this.defaultProfile);await this.u.createFolder(k.location);const f=[];return this.j.fire({profile:k,join(w){f.push(w)}}),await r.Promises.settled(f),this.I([k],[],[]),k}finally{this.r.delete(E)}})(),this.r.set(E,b)),b}async updateProfile(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(b=>b.id===h.id);if(!D)throw new Error(`Profile '${h.name}' does not exist`);return D=g(D.id,E.name??D.name,D.location,this.g,{shortName:E.shortName??D.shortName,icon:E.icon===null?void 0:E.icon??D.icon,transient:E.transient??D.isTransient,useDefaultFlags:E.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(h.isDefault)throw new Error("Cannot remove default profile");const E=this.profiles.find(b=>b.id===h.id);if(!E)throw new Error(`Profile '${h.name}' does not exist`);const D=[];this.m.fire({profile:E,join(b){D.push(b)}});try{await Promise.allSettled(D)}catch(b){this.y.error(b)}for(const b of[...this.C.emptyWindows.keys()])E.id===this.C.emptyWindows.get(b)?.id&&this.C.emptyWindows.delete(b);for(const b of[...this.C.workspaces.keys()])E.id===this.C.workspaces.get(b)?.id&&this.C.workspaces.delete(b);this.M(),this.I([],[E],[]);try{await this.u.del(E.cacheHome,{recursive:!0})}catch(b){(0,o.$rl)(b)!==o.FileOperationResult.FILE_NOT_FOUND&&this.y.error(b)}}async setProfileForWorkspace(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(b=>b.id===E.id);if(!D)throw new Error(`Profile '${E.name}' does not exist`);this.L(h,D)}unsetWorkspace(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(h,void 0,E)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const h=await this.u.resolve(this.profilesHome);await Promise.all((h.children||[]).filter(E=>E.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,E.resource))).map(E=>this.u.del(E.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const h=this.s.profiles.filter(E=>!this.H(E));await Promise.allSettled(h.map(E=>this.removeProfile(E)))}getProfileForWorkspace(h){const E=this.G(h),D=A.URI.isUri(E)?this.C.workspaces.get(E):this.C.emptyWindows.get(E);return D||((0,a.$Pi)(h)?this.s.folders.get(h.uri):(0,a.$Ui)(h)?this.s.workspaces.get(h.configPath):this.s.emptyWindows.get(h.id))}G(h){return(0,a.$Pi)(h)?h.uri:(0,a.$Ui)(h)?h.configPath:h.id}H(h){return!!([...this.C.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.C.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.folders.values()].some(E=>this.w.extUri.isEqual(E.location,h.location)))}I(h,E,D){const b=[...this.profiles,...h],C=[],k=this.s.profiles;this.s.profiles=[];for(let f of b){if(f.isDefault||E.some(F=>f.id===F.id))continue;f=D.find(F=>f.id===F.id)??f;const w=k.find(F=>f.id===F.id);if(f.isTransient)this.s.profiles.push(f);else{if(w){for(const[F,N]of this.s.emptyWindows.entries())if(f.id===N.id){this.L({id:F},f);break}for(const[F,N]of this.s.workspaces.entries())if(f.id===N.id){this.L({id:"",configPath:F},f);break}for(const[F,N]of this.s.folders.entries())if(f.id===N.id){this.L({id:"",uri:F},f);break}}C.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags})}}this.P(C),this.z=void 0,this.J(h,E,D)}J(h,E,D){this.h.fire({added:h,removed:E,updated:D,all:this.profiles})}L(h,E,D){if(D=E?.isTransient?!0:D,D)(0,a.$Pi)(h)?(this.s.folders.delete(h.uri),E&&this.s.folders.set(h.uri,E)):(0,a.$Ui)(h)?(this.s.workspaces.delete(h.configPath),E&&this.s.workspaces.set(h.configPath,E)):(this.s.emptyWindows.delete(h.id),E&&this.s.emptyWindows.set(h.id,E));else{this.L(h,void 0,!0);const b=this.G(h);A.URI.isUri(b)?(this.C.workspaces.delete(b),E&&this.C.workspaces.set(b,E)):(this.C.emptyWindows.delete(b),E&&this.C.emptyWindows.set(b,E)),this.M()}}M(){const h={};for(const[D,b]of this.C.workspaces.entries())h[D.toString()]=b.id;const E={};for(const[D,b]of this.C.emptyWindows.entries())E[D.toString()]=b.id;this.R({workspaces:h,emptyWindows:E}),this.z=void 0}N(h){const E={},D=this.D();if(h.workspaces)for(const[C,k]of Object.entries(h.workspaces)){const f=A.URI.parse(k);E[C]=this.w.extUri.isEqual(f,D.location)?D.id:this.w.extUri.basename(f)}const b={};if(h.emptyWindows)for(const[C,k]of Object.entries(h.emptyWindows)){const f=A.URI.parse(k);b[C]=this.w.extUri.isEqual(f,D.location)?D.id:this.w.extUri.basename(f)}return{workspaces:E,emptyWindows:b}}O(){return[]}P(h){throw new Error("not implemented")}Q(){return{}}R(h){throw new Error("not implemented")}S(){}};e.$Pl=u,e.$Pl=u=Je([Ve(0,p.$Mi),Ve(1,o.$al),Ve(2,d.$Kl),Ve(3,y.$ak)],u);class $ extends u{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(h){this.a=h}Q(){return this.X}R(h){this.X=h}}e.$Ql=$}),define(Ne[187],Le([1,0,10,6,4,64,14,152,3,113]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$kq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$iq=e.$hq=e.$gq=void 0,e.$jq=S,e.$lq=r,e.$nq=c,e.$gq="__$__isNewStorageMarker",e.$hq="__$__targetStorageMarker",e.$iq=(0,p.$Fi)("storageService");var I;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var y;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var a;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(a||(e.StorageTarget=a={}));function S(l){const i=l.get(e.$hq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class d extends P.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:d.a}){super(),this.m=i,this.b=this.B(new R.$oe),this.c=this.B(new R.$oe),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$le),this.onWillSaveState=this.f.event,this.h=this.B(new v.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,n,t){return R.Event.filter(this.b.event,g=>g.scope===i&&(n===void 0||g.key===n),t)}n(){this.j.value=(0,v.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,n){const{key:t,external:g}=n;if(t===e.$hq){switch(i){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:g})}w(i){this.f.fire({reason:i})}get(i,n,t){return this.P(n)?.get(i,t)}getBoolean(i,n,t){return this.P(n)?.getBoolean(i,t)}getNumber(i,n,t){return this.P(n)?.getNumber(i,t)}getObject(i,n,t){return this.P(n)?.getObject(i,t)}storeAll(i,n){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,n)})}store(i,n,t,g,u=!1){if((0,A.$ng)(n)){this.remove(i,t,u);return}this.y(()=>{this.z(i,t,g),this.P(t)?.set(i,n,u)})}remove(i,n,t=!1){this.y(()=>{this.z(i,n,void 0),this.P(n)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,n){const t=[],g=this.J(i);for(const u of Object.keys(g))g[u]===n&&t.push(u);return t}z(i,n,t,g=!1){const u=this.J(n);typeof t=="number"?u[i]!==t&&(u[i]=t,this.P(n)?.set(e.$hq,JSON.stringify(u),g)):typeof u[i]=="number"&&(delete u[i],this.P(n)?.set(e.$hq,JSON.stringify(u),g))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(i){switch(i){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(i){const n=this.P(i);return n?S(n):Object.create(null)}isNew(i){return this.getBoolean(e.$gq,i)===!0}async flush(i=I.NONE){this.f.fire({reason:i});const n=this.P(y.APPLICATION),t=this.P(y.PROFILE),g=this.P(y.WORKSPACE);switch(i){case I.NONE:await v.Promises.settled([n?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await v.Promises.settled([n?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(y.APPLICATION)?.items??new Map,n=this.P(y.PROFILE)?.items??new Map,t=this.P(y.WORKSPACE)?.items??new Map;return c(i,n,t,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,n){return this.w(I.NONE),(0,o.$Ll)(i)?this.R(i,n):this.S(i,n)}M(i,n){return!(i.id===n.id||r(n)&&r(i))}N(i,n,t){this.y(()=>{const g=new Set;for(const[u,$]of i)g.add(u),n.get(u)!==$&&this.u(t,{key:u,external:!0});for(const[u]of n.items)g.has(u)||this.u(t,{key:u,external:!0})})}}e.$kq=d;function r(l){return l.isDefault||!!l.useDefaultFlags?.globalState}class s extends d{constructor(){super(),this.U=this.B(new T.$eq(new T.$fq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$eq(new T.$fq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$eq(new T.$fq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(y.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(y.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(y.APPLICATION,i)))}P(i){switch(i){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$mq=s;async function c(l,i,n,t,g,u){const $=w=>{try{return JSON.parse(w)}catch{return w}},m=new Map,h=new Map;l.forEach((w,F)=>{m.set(F,w),h.set(F,$(w))});const E=new Map,D=new Map;i.forEach((w,F)=>{E.set(F,w),D.set(F,$(w))});const b=new Map,C=new Map;n.forEach((w,F)=>{b.set(F,w),C.set(F,$(w))}),console.group(t!==g?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const k=[];if(m.forEach((w,F)=>{k.push({key:F,value:w})}),console.table(k),console.groupEnd(),console.log(h),t!==g){console.group(`Storage: Profile (path: ${g}, profile specific)`);const w=[];E.forEach((F,N)=>{w.push({key:N,value:F})}),console.table(w),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${u})`);const f=[];b.forEach((w,F)=>{f.push({key:F,value:w})}),console.table(f),console.groupEnd(),console.log(C)}}),define(Ne[79],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qpc=void 0;class v{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const O=this.c++;return this.b.set(O,P),this.e(),O}get(P,O){return this.b.has(P)?this.b.get(P)[O]:void 0}delete(P){this.b.delete(P),this.e()}e(){v.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$qpc=v}),define(Ne[50],Le([1,0,15,23,29,3]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wpc=e.$vpc=void 0;class A{constructor(){this.a=new Set(Object.keys(v.Schemas)),this.b=new Map,this.extUri=new R.$8g(p=>{const o=this.b.get(p.scheme);return!(o===void 0||o&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(p,o){o===null?this.b.delete(p.scheme):this.b.set(p.scheme,o)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$vpc=A,e.$wpc=(0,O.$Fi)("IExtHostFileSystemInfo")}),define(Ne[26],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AQ=void 0,e.$AQ=(0,v.$Fi)("IExtHostInitDataService")}),define(Ne[188],Le([1,0,9,11,172,26]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Erc=void 0;let A=class extends P.$KR{constructor(p,o,I){const y=I.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",a=I.remote.isRemote?(0,v.localize)(10830,null):p?(0,v.localize)(10831,null):(0,v.localize)(10832,null);super(o.createLogger(y,{name:a}))}};e.$Erc=A,e.$Erc=A=Je([Ve(1,R.$bk),Ve(2,O.$AQ)],A)}),define(Ne[189],Le([1,0,10]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cqc=e.$bqc=void 0;class R{constructor(A,T,p){this.h=new Map,this.a=A,this.b=T,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(o=>(this.f=o,this)),this.g=this.c.onDidChangeStorage(o=>{o.shared===this.b&&o.key===this.a&&(this.f=o.value)}),this.i=new v.$Rh(()=>{const o=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of o.values())I.complete()}catch(I){for(const y of o.values())y.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,T){let p=this.f[A];return typeof p>"u"&&(p=T),p}update(A,T){this.f[A]=T;const p=this.h.get(A);if(p!==void 0)return p.p;const o=new v.$3h;return this.h.set(A,o),this.i.isScheduled()||this.i.schedule(),o.p}dispose(){this.g.dispose()}}e.$bqc=R;class P extends R{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,T){super(A.identifier.value,!0,T),this.j=A}}e.$cqc=P}),define(Ne[190],Le([1,0,6,2]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9qc=void 0;class P{constructor(A){this.c=A,this.a=new v.$le,this.onDidSaveNotebookDocument=this.a.event,this.b=new v.$le,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,T,p,o){const y=this.c.getNotebookDocument(R.URI.revive(A)).acceptModelChanged(T.value,p,o);this.b.fire(y)}$acceptDirtyStateChanged(A,T){this.c.getNotebookDocument(R.URI.revive(A)).acceptDirty(T)}$acceptModelSaved(A){const T=this.c.getNotebookDocument(R.URI.revive(A));this.a.fire(T.apiNotebook)}}e.$9qc=P}),define(Ne[16],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lQ=e.$kQ=void 0,e.$kQ=(0,v.$Fi)("IExtHostRpcService");class R{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$lQ=R}),define(Ne[191],Le([1,0,18,6,4]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lqc=void 0;class O{#e;constructor(T,p){this.disposables=new P.$Tc,this.a=v.$rn.toKey(T.identifier),this.#e=p,this.onDidChange=R.Event.map(R.Event.filter(this.#e.onDidChangePassword,o=>o.extensionId===this.a),o=>({key:o.key}),this.disposables)}dispose(){this.disposables.dispose()}get(T){return this.#e.get(this.a,T)}store(T,p){return this.#e.store(this.a,T,p)}delete(T){return this.#e.delete(this.a,T)}}e.$lqc=O}),define(Ne[65],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpc=e.$Lpc=void 0,e.$Lpc=(0,v.$Fi)("IURITransformerService");class R{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Mpc=R});var xt=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[114],Le([1,0,9,14,2,4,3,30,29,15,42,164,35]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$qG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$gG=e.EditorInputCapabilities=e.$fG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=void 0,e.$9F=r,e.$0F=s,e.$$F=c,e.$_F=l,e.$aG=i,e.$bG=n,e.$cG=t,e.$dG=g,e.$eG=u,e.$hG=b,e.$iG=k,e.$jG=f,e.$kG=w,e.$lG=F,e.$mG=N,e.$nG=L,e.$oG=q,e.$pG=be,e.$rG=ce,e.$sG=oe,e.$tG=ke,e.$uG=Te,a=xt(a),e.$4F={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$5F={id:"default",displayName:(0,v.localize)(12473,null),providerDisplayName:(0,v.localize)(12474,null)},e.$6F="workbench.editor.sidebysideEditor",e.$7F="workbench.editors.textDiffEditor",e.$8F="workbench.editors.binaryResourceDiffEditor";var S;(function(Y){Y[Y.PROGRAMMATIC=1]="PROGRAMMATIC",Y[Y.USER=2]="USER",Y[Y.EDIT=3]="EDIT",Y[Y.NAVIGATION=4]="NAVIGATION",Y[Y.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var d;(function(Y){Y[Y.IDENTICAL=1]="IDENTICAL",Y[Y.SIMILAR=2]="SIMILAR",Y[Y.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function r(Y){const B=Y;return!!B&&typeof B.getSelection=="function"&&!!B.onDidChangeSelection}function s(Y){const B=Y;return!!B&&typeof B.getScrollPosition=="function"&&typeof B.setScrollPosition=="function"&&!!B.onDidChangeScroll}function c(Y,B,ne){for(const Ee of ne.visibleEditorPanes)if(Ee.group.id===B&&Y.matches(Ee.input))return Ee.getViewState()}function l(Y){if(b(Y))return!1;const B=Y;return P.URI.isUri(B?.resource)}function i(Y){if(b(Y))return!1;const B=Y;return B?.original!==void 0&&B.modified!==void 0}function n(Y){if(b(Y))return!1;const B=Y;return!B||B.resources&&!Array.isArray(B.resources)?!1:!!B.resources||!!B.multiDiffSource}function t(Y){if(b(Y)||i(Y))return!1;const B=Y;return B?.primary!==void 0&&B.secondary!==void 0}function g(Y){if(b(Y))return!1;const B=Y;return B?B.resource===void 0||B.resource.scheme===o.Schemas.untitled||B.forceUntitled===!0:!1}function u(Y){if(b(Y))return!1;const B=Y;return P.URI.isUri(B?.base?.resource)&&P.URI.isUri(B?.input1?.resource)&&P.URI.isUri(B?.input2?.resource)&&P.URI.isUri(B?.result?.resource)}var $;(function(Y){Y[Y.SHORT=0]="SHORT",Y[Y.MEDIUM=1]="MEDIUM",Y[Y.LONG=2]="LONG"})($||(e.Verbosity=$={}));var m;(function(Y){Y[Y.EXPLICIT=1]="EXPLICIT",Y[Y.AUTO=2]="AUTO",Y[Y.FOCUS_CHANGE=3]="FOCUS_CHANGE",Y[Y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(m||(e.SaveReason=m={}));class h{constructor(){this.a=new Map}registerSource(B,ne){let Ee=this.a.get(B);return Ee||(Ee={source:B,label:ne},this.a.set(B,Ee)),Ee.source}getSourceLabel(B){return this.a.get(B)?.label??B}}e.$fG=new h;var E;(function(Y){Y[Y.None=0]="None",Y[Y.Readonly=2]="Readonly",Y[Y.Untitled=4]="Untitled",Y[Y.Singleton=8]="Singleton",Y[Y.RequiresTrust=16]="RequiresTrust",Y[Y.CanSplitInGroup=32]="CanSplitInGroup",Y[Y.ForceDescription=64]="ForceDescription",Y[Y.CanDropIntoEditor=128]="CanDropIntoEditor",Y[Y.MultipleEditors=256]="MultipleEditors",Y[Y.Scratchpad=512]="Scratchpad"})(E||(e.EditorInputCapabilities=E={}));class D extends O.$Uc{}e.$gG=D;function b(Y){return Y instanceof D}function C(Y){const B=Y;return P.URI.isUri(B?.preferredResource)}function k(Y){const B=Y;return b(B?.primary)&&b(B?.secondary)}function f(Y){const B=Y;return b(B?.modified)&&b(B?.original)}function w(Y,B,ne,Ee,fe){return Te(Ee,[(0,y.$pj)({id:"workbench.action.openLargeFile",label:(0,v.localize)(12475,null),run:()=>{const we={...ne,limits:{size:Number.MAX_VALUE}};Y.openEditor(B,we)}}),(0,y.$pj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,v.localize)(12476,null),run:()=>fe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:a.default.Warning})}function F(Y){return b(Y?.editor)}function N(Y){const B=Y;return F(Y)&&B?.group!==void 0}function L(Y){const B=Y;return typeof B?.groupId=="number"&&b(B.editor)}function q(Y){return typeof Y?.groupId=="number"}var H;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.REPLACE=1]="REPLACE",Y[Y.MOVE=2]="MOVE",Y[Y.UNPIN=3]="UNPIN"})(H||(e.EditorCloseContext=H={}));var W;(function(Y){Y[Y.GROUP_ACTIVE=0]="GROUP_ACTIVE",Y[Y.GROUP_INDEX=1]="GROUP_INDEX",Y[Y.GROUP_LABEL=2]="GROUP_LABEL",Y[Y.GROUP_LOCKED=3]="GROUP_LOCKED",Y[Y.EDITORS_SELECTION=4]="EDITORS_SELECTION",Y[Y.EDITOR_OPEN=5]="EDITOR_OPEN",Y[Y.EDITOR_CLOSE=6]="EDITOR_CLOSE",Y[Y.EDITOR_MOVE=7]="EDITOR_MOVE",Y[Y.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Y[Y.EDITOR_LABEL=9]="EDITOR_LABEL",Y[Y.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Y[Y.EDITOR_PIN=11]="EDITOR_PIN",Y[Y.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Y[Y.EDITOR_STICKY=13]="EDITOR_STICKY",Y[Y.EDITOR_DIRTY=14]="EDITOR_DIRTY",Y[Y.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(W||(e.GroupModelChangeKind=W={}));var G;(function(Y){Y[Y.PRIMARY=1]="PRIMARY",Y[Y.SECONDARY=2]="SECONDARY",Y[Y.BOTH=3]="BOTH",Y[Y.ANY=4]="ANY"})(G||(e.SideBySideEditor=G={}));class Q{getOriginalUri(B,ne){if(!B)return;if(u(B))return e.$qG.getOriginalUri(B.result,ne);if(ne?.supportSideBySide){const{primary:fe,secondary:we}=this.a(B);if(fe&&we){if(ne?.supportSideBySide===G.BOTH)return{primary:this.getOriginalUri(fe,{filterByScheme:ne.filterByScheme}),secondary:this.getOriginalUri(we,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===G.ANY)return this.getOriginalUri(fe,{filterByScheme:ne.filterByScheme})??this.getOriginalUri(we,{filterByScheme:ne.filterByScheme});B=ne.supportSideBySide===G.PRIMARY?fe:we}}if(i(B)||n(B)||t(B)||u(B))return;const Ee=C(B)?B.preferredResource:B.resource;return!Ee||!ne||!ne.filterByScheme?Ee:this.b(Ee,ne.filterByScheme)}a(B){return k(B)||t(B)?{primary:B.primary,secondary:B.secondary}:f(B)||i(B)?{primary:B.modified,secondary:B.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(B,ne){if(!B)return;if(u(B))return e.$qG.getCanonicalUri(B.result,ne);if(ne?.supportSideBySide){const{primary:fe,secondary:we}=this.a(B);if(fe&&we){if(ne?.supportSideBySide===G.BOTH)return{primary:this.getCanonicalUri(fe,{filterByScheme:ne.filterByScheme}),secondary:this.getCanonicalUri(we,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===G.ANY)return this.getCanonicalUri(fe,{filterByScheme:ne.filterByScheme})??this.getCanonicalUri(we,{filterByScheme:ne.filterByScheme});B=ne.supportSideBySide===G.PRIMARY?fe:we}}if(i(B)||n(B)||t(B)||u(B))return;const Ee=B.resource;return!Ee||!ne||!ne.filterByScheme?Ee:this.b(Ee,ne.filterByScheme)}b(B,ne){if(Array.isArray(ne)){if(ne.some(Ee=>B.scheme===Ee))return B}else if(ne===B.scheme)return B}}var ae;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.KEYBOARD=1]="KEYBOARD",Y[Y.MOUSE=2]="MOUSE"})(ae||(e.EditorCloseMethod=ae={}));function be(Y,B,ne,Ee){if(!Y.isSticky(B))return!1;switch(Ee.preventPinnedEditorClose){case"keyboardAndMouse":return ne===ae.MOUSE||ne===ae.KEYBOARD;case"mouse":return ne===ae.MOUSE;case"keyboard":return ne===ae.KEYBOARD}return!1}e.$qG=new Q;var le;(function(Y){Y[Y.LEFT=0]="LEFT",Y[Y.RIGHT=1]="RIGHT"})(le||(e.CloseDirection=le={}));class _{constructor(){this.c=new Map,this.d=new Map}start(B){const ne=this.a=B.get(A.$Ei);for(const[Ee,fe]of this.c)this.e(Ee,fe,ne);this.c.clear()}e(B,ne,Ee){const fe=Ee.createInstance(ne);this.d.set(B,fe)}registerFileEditorFactory(B){if(this.b)throw new Error("Can only register one file editor factory.");this.b=B}getFileEditorFactory(){return(0,R.$pg)(this.b)}registerEditorSerializer(B,ne){if(this.c.has(B)||this.d.has(B))throw new Error(`A editor serializer with type ID '${B}' was already registered.`);return this.a?this.e(B,ne,this.a):this.c.set(B,ne),(0,O.$Sc)(()=>{this.c.delete(B),this.d.delete(B)})}getEditorSerializer(B){return this.d.get(typeof B=="string"?B:B.typeId)}}T.$ro.add(e.$4F.EditorFactory,new _);async function ce(Y,B,ne){return!Y||!Y.length?[]:await Promise.all(Y.map(async Ee=>{const fe=P.URI.revive(Ee.fileUri);if(!fe){ne.info("Cannot resolve the path because it is not valid.",Ee);return}if(!await B.canHandleResource(fe)){ne.info("Cannot resolve the path because it cannot be handled",Ee);return}let he=Ee.exists,X=Ee.type;if(typeof he!="boolean"||typeof X!="number")try{X=(await B.stat(fe)).isDirectory?p.FileType.Directory:p.FileType.Unknown,he=!0}catch($e){ne.error($e),he=!1}if(!he&&Ee.openOnlyIfExists){ne.info("Cannot resolve the path because it does not exist",Ee);return}if(X===p.FileType.Directory){ne.info("Cannot resolve the path because it is a directory",Ee);return}const x={...Ee.options,pinned:!0};return he?{resource:fe,options:x}:{resource:fe,options:x,forceUntitled:!0}}))}var me;(function(Y){Y[Y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Y[Y.SEQUENTIAL=1]="SEQUENTIAL"})(me||(e.EditorsOrder=me={}));function oe(Y){const B=Y;if(!B)return!1;const ne=B;if(ne.modified)return oe(ne.modified);const Ee=B;return!!(Ee.contributionsState&&Ee.viewState&&Array.isArray(Ee.cursorState))}function ke(Y){return(0,I.$rj)(Y)}function Te(Y,B,ne){const Ee=(0,I.$sj)(Y,B);return Ee.forceMessage=ne?.forceMessage,Ee.forceSeverity=ne?.forceSeverity,Ee.allowDialog=ne?.allowDialog,Ee}}),define(Ne[192],Le([1,0,6,9,3,4,28,30,25,97,182]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CG=e.$BG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$AG=e.ViewContentGroups=e.$yG=e.ViewContainerLocation=e.Extensions=e.$xG=e.$wG=e.$vG=void 0,e.$zG=S,e.$vG="views",e.$wG=(0,R.localize)(12313,null),e.$xG=(0,I.$Bx)("default-view-icon",o.$5j.window,(0,R.localize)(12314,null));var y;(function(g){g.ViewContainersRegistry="workbench.registry.view.containers",g.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var a;(function(g){g[g.Sidebar=0]="Sidebar",g[g.Panel=1]="Panel",g[g.AuxiliaryBar=2]="AuxiliaryBar"})(a||(e.ViewContainerLocation=a={})),e.$yG=[a.Sidebar,a.Panel,a.AuxiliaryBar];function S(g){switch(g){case a.Sidebar:return"sidebar";case a.Panel:return"panel";case a.AuxiliaryBar:return"auxiliarybar"}}class d extends O.$Uc{constructor(){super(...arguments),this.c=this.B(new v.$le),this.onDidRegister=this.c.event,this.f=this.B(new v.$le),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(u,$,m){const h=this.get(u.id);if(h)return h;const E=u;return E.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,A.$xc)(this.g,$,[]).push(E),m?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:$}),E}deregisterViewContainer(u){for(const $ of this.g.keys()){const m=this.g.get($),h=m?.indexOf(u);if(h!==-1){m?.splice(h,1),m.length===0&&this.g.delete($),this.f.fire({viewContainer:u,viewContainerLocation:$});return}}}get(u){return this.all.filter($=>$.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter($=>this.getViewContainers($).filter(m=>m?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find($=>this.getViewContainerLocation($)===u)}}T.$ro.add(y.ViewContainersRegistry,new d);var r;(function(g){g.Open="2_open",g.Debug="4_debug",g.SCM="5_scm",g.More="9_more"})(r||(e.ViewContentGroups=r={}));function s(g,u){const $=g.group??r.More,m=u.group??r.More;return $!==m?$.localeCompare(m):(g.order??5)-(u.order??5)}class c extends O.$Uc{constructor(){super(...arguments),this.c=this.B(new v.$le),this.onViewsRegistered=this.c.event,this.f=this.B(new v.$le),this.onViewsDeregistered=this.f.event,this.g=this.B(new v.$le),this.onDidChangeContainer=this.g.event,this.h=this.B(new v.$le),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Hc}registerViews(u,$){this.registerViews2([{views:u,viewContainer:$}])}registerViews2(u){u.forEach(({views:$,viewContainer:m})=>this.r($,m)),this.c.fire(u)}deregisterViews(u,$){const m=this.s(u,$);m.length&&this.f.fire({views:m,viewContainer:$})}moveViews(u,$){for(const m of this.m.keys())if(m!==$){const h=this.s(u,m);h.length&&(this.r(h,$),this.g.fire({views:h,from:m,to:$}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const $ of this.j){const m=(this.m.get($)||[]).filter(h=>h.id===u)[0];if(m)return m}return null}getViewContainer(u){for(const $ of this.j)if((this.m.get($)||[]).filter(h=>h.id===u)[0])return $;return null}registerViewWelcomeContent(u,$){return this.n.add(u,$),this.h.fire(u),(0,O.$Sc)(()=>{this.n.delete(u,$),this.h.fire(u)})}registerViewWelcomeContent2(u,$){const m=new Map;for(const[h,E]of $)this.n.add(u,E),m.set(h,(0,O.$Sc)(()=>{this.n.delete(u,E),this.h.fire(u)}));return this.h.fire(u),m}getViewWelcomeContent(u){const $=[];return this.n.forEach(u,m=>$.push(m)),$.sort(s)}r(u,$){let m=this.m.get($);m||(m=[],this.m.set($,m),this.j.push($));for(const h of u){if(this.getView(h.id)!==null)throw new Error((0,R.localize)(12315,null,h.id));m.push(h)}}s(u,$){const m=this.m.get($);if(!m)return[];const h=[],E=[];for(const D of m)u.includes(D)?h.push(D):E.push(D);return h.length&&(E.length?this.m.set($,E):(this.m.delete($),this.j.splice(this.j.indexOf($),1))),h}}T.$ro.add(y.ViewsRegistry,new c),e.$AG=(0,P.$Fi)("viewDescriptorService");var l;(function(g){g[g.Default=0]="Default",g[g.Expand=1]="Expand"})(l||(e.ViewVisibilityState=l={}));var i;(function(g){g[g.None=0]="None",g[g.Collapsed=1]="Collapsed",g[g.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class n{constructor(u,$){this.c=!1,this.d=!1,(0,p.$ho)(this,u),this.d=!!$,this.resolve=async m=>{if($&&!this.c){const h=await $(m);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$BG=n;class t extends Error{constructor(u){super((0,R.localize)(12316,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$CG=t}),define(Ne[193],Le([1,0,9,31]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=void 0,e.$GG=new R.$Wj("chatSessionResponseVote","",{type:"string",description:(0,v.localize)(8436,null)}),e.$HG=new R.$Wj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,v.localize)(8437,null)}),e.$IG=new R.$Wj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,v.localize)(8438,null)}),e.$JG=new R.$Wj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,v.localize)(8439,null)}),e.$KG=new R.$Wj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,v.localize)(8440,null)}),e.$LG=new R.$Wj("chatResponse",!1,{type:"boolean",description:(0,v.localize)(8441,null)}),e.$MG=new R.$Wj("chatRequest",!1,{type:"boolean",description:(0,v.localize)(8442,null)}),e.$NG=new R.$Wj("chatEditApplied",!1,{type:"boolean",description:(0,v.localize)(8443,null)}),e.$OG=new R.$Wj("chatInputHasText",!1,{type:"boolean",description:(0,v.localize)(8444,null)}),e.$PG=new R.$Wj("chatInputHasFocus",!1,{type:"boolean",description:(0,v.localize)(8445,null)}),e.$QG=new R.$Wj("inChatInput",!1,{type:"boolean",description:(0,v.localize)(8446,null)}),e.$RG=new R.$Wj("inChat",!1,{type:"boolean",description:(0,v.localize)(8447,null)}),e.$SG=new R.$Wj("chatIsEnabled",!1,{type:"boolean",description:(0,v.localize)(8448,null)}),e.$TG=new R.$Wj("chatCursorAtTop",!1),e.$UG=new R.$Wj("chatInputHasAgent",!1),e.$VG=new R.$Wj("chatLocation",void 0),e.$WG=new R.$Wj("quickChatHasFocus",!1,{type:"boolean",description:(0,v.localize)(8449,null)})}),define(Ne[115],Le([1,0,283,10,21,6,40,4,36,143,12,31,18,3,11,108,176,187,193]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.ChatAgentLocation=void 0,e.$2H=$,e.$3H=m;var n;(function(h){h.Panel="panel",h.Terminal="terminal",h.Notebook="notebook",h.Editor="editor"})(n||(e.ChatAgentLocation=n={})),function(h){function E(D){switch(D){case"panel":return h.Panel;case"terminal":return h.Terminal;case"notebook":return h.Notebook;case"editor":return h.Editor}return h.Panel}h.fromRaw=E}(n||(e.ChatAgentLocation=n={})),e.$WH=(0,S.$Fi)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(E){this.f=E,this.b=new Map,this.d=new O.$le,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=l.$SG.bindTo(this.f)}registerAgent(E,D){if(this.getAgent(E))throw new Error(`Agent already registered: ${JSON.stringify(E)}`);const C=this,k=D.slashCommands;D={...D,get slashCommands(){return k.filter(w=>!w.when||C.f.contextMatchesRules(y.$Dj.deserialize(w.when)))}};const f={data:D};return this.b.set(E,f),(0,T.$Sc)(()=>{this.b.delete(E),this.d.fire(void 0)})}registerAgentImplementation(E,D){const b=this.b.get(E);if(!b)throw new Error(`Unknown agent: ${JSON.stringify(E)}`);if(b.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(E)}`);return b.data.isDefault&&this.e.set(!0),b.impl=D,this.d.fire(new g(b.data,D)),(0,T.$Sc)(()=>{b.impl=void 0,this.d.fire(void 0),b.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(E,D){E.isDynamic=!0;const b={data:E,impl:D};return this.b.set(E.id,b),this.d.fire(new g(E,D)),(0,T.$Sc)(()=>{this.b.delete(E.id),this.d.fire(void 0)})}registerAgentCompletionProvider(E,D){return this.g.set(E,D),{dispose:()=>{this.g.delete(E)}}}async getAgentCompletionItems(E,D,b){return await this.g.get(E)?.(D,b)??[]}updateAgent(E,D){const b=this.b.get(E);if(!b?.impl)throw new Error(`No activated agent with id ${JSON.stringify(E)} registered`);b.data.metadata={...b.data.metadata,...D},this.d.fire(new g(b.data,b.impl))}getDefaultAgent(E){return(0,v.$eb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(E))}getContributedDefaultAgent(E){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(E))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),E=>!!E.data.metadata.isSecondary)?.data}getAgent(E){if(this.h(E))return this.b.get(E)?.data}h(E){const D=this.b.get(E);return!D?.data.when||this.f.contextMatchesRules(y.$Dj.deserialize(D.data.when))}getAgentByFullyQualifiedId(E){const D=A.Iterable.find(this.b.values(),b=>$(b.data)===E)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(E=>E.data).filter(E=>this.h(E.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(E=>!!E.impl).filter(E=>this.h(E.data.id)).map(E=>new g(E.data,E.impl))}getAgentsByName(E){return this.getAgents().filter(D=>D.name===E)}agentHasDupeName(E){const D=this.getAgent(E);return D?this.getAgentsByName(D.name).filter(b=>b.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(E,D,b,C,k){const f=this.b.get(E);if(!f?.impl)throw new Error(`No activated agent with id "${E}"`);return await f.impl.invoke(D,b,C,k)}async getFollowups(E,D,b,C,k){const f=this.b.get(E);if(!f?.impl)throw new Error(`No activated agent with id "${E}"`);return f.impl?.provideFollowups?f.impl.provideFollowups(D,b,C,k):[]}};e.$XH=t,e.$XH=t=Je([Ve(0,y.$Xj)],t);class g{constructor(E,D){this.b=E,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}async invoke(E,D,b,C){return this.d.invoke(E,D,b,C)}async provideFollowups(E,D,b,C){return this.d.provideFollowups?this.d.provideFollowups(E,D,b,C):[]}provideWelcomeMessage(E,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(E,D)}provideSampleQuestions(E,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(E,D)}}e.$YH=g,e.$ZH=(0,S.$Fi)("chatAgentNameService");let u=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(E,D,b,C){if(this.g=D,this.h=b,this.i=C,this.e=(0,o.$6d)(this,Object.create(null)),this.f=!1,!E.chatParticipantRegistry)return;this.d=E.chatParticipantRegistry;const k=C.get(i.b,c.StorageScope.APPLICATION);try{this.e.set(JSON.parse(k??"{}"),void 0)}catch{C.remove(i.b,c.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(E=>this.h.warn("Failed to fetch chat participant registry",E)).then(()=>(0,R.$Gh)(5*60*1e3)).then(()=>this.j())}async k(){const E=await this.g.request({type:"GET",url:this.d},P.CancellationToken.None);if(E.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,s.$bq)(E);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const b=D.restrictedChatParticipants;this.e.set(b,void 0),this.i.store(i.b,JSON.stringify(b),c.StorageScope.APPLICATION,c.StorageTarget.MACHINE)}getAgentNameRestriction(E){const D=this.l(E.name,E).get(),b=!E.fullName||this.l(E.fullName.replace(/\s/g,""),E).get();return D&&b}l(E,D){return this.e.map(C=>C[E.toLowerCase()]).map(C=>C?C.some(k=>(0,I.$Ff)(k,k.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$1H=u,e.$1H=u=i=Je([Ve(0,r.$tk),Ve(1,s.$8p),Ve(2,d.$ak),Ve(3,c.$iq)],u);function $(h){return`${h.extensionId.value}.${h.id}`}function m(h){const E="name"in h?h:{...h,name:h.id};return"extensionPublisherId"in E||(E.extensionPublisherId=E.extensionPublisher??""),"extensionDisplayName"in E||(E.extensionDisplayName=""),"extensionId"in E||(E.extensionId=new a.$rn("")),(0,p.$ci)(E)}}),define(Ne[194],Le([1,0,2,32,3]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uH=e.$tH=e.ChatCopyKind=e.ChatAgentVoteDirection=e.ChatResponseReferencePartStatusKind=void 0,e.$rH=O,e.$sH=A;function O(I){return!!I&&typeof I=="object"&&"uri"in I&&I.uri instanceof v.URI&&"version"in I&&typeof I.version=="number"&&"ranges"in I&&Array.isArray(I.ranges)&&I.ranges.every(R.$Ot.isIRange)}function A(I){return!!I&&typeof I=="object"&&"documents"in I&&Array.isArray(I.documents)&&I.documents.every(O)}var T;(function(I){I[I.Complete=1]="Complete",I[I.Partial=2]="Partial",I[I.Omitted=3]="Omitted"})(T||(e.ChatResponseReferencePartStatusKind=T={}));var p;(function(I){I[I.Down=0]="Down",I[I.Up=1]="Up"})(p||(e.ChatAgentVoteDirection=p={}));var o;(function(I){I[I.Action=1]="Action",I[I.Toolbar=2]="Toolbar"})(o||(e.ChatCopyKind=o={})),e.$tH=(0,P.$Fi)("IChatService"),e.$uH="accessibility.voice.keywordActivation"}),define(Ne[195],Le([1,0,6,10,9]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0tb=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new v.$le,this.o=new v.$le,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(T){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=T}onEvent(T){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=T}onRequest(T){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.u("response",T)}sendRequest(T,p,o,I){const y={command:T};if(p&&Object.keys(p).length>0&&(y.arguments=p),this.u("request",y),typeof I=="number"){const a=setTimeout(()=>{clearTimeout(a);const S=this.f.get(y.seq);if(S){this.f.delete(y.seq);const d={type:"response",seq:0,request_seq:y.seq,success:!1,command:T,message:(0,P.localize)(7529,null,I,T)};S(d)}},I)}return o&&this.f.set(y.seq,o),y.seq}acceptMessage(T){this.k?this.k(T):(this.m.push(T),this.m.length===1&&this.s())}q(T,p){return T.type!=="event"||p.type!=="event"}async s(){let T;for(;this.m.length;){if((!T||this.q(this.m[0],T))&&await(0,R.$Gh)(0),T=this.m.shift(),!T)return;switch(T.type){case"event":this.j?.(T);break;case"request":this.g?.(T);break;case"response":{const p=T,o=this.f.get(p.request_seq);o&&(this.f.delete(p.request_seq),o(p));break}}}}u(T,p){p.type=T,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((p,o)=>T.set(o,p)),await(0,R.$Gh)(500),T.forEach((p,o)=>{p({type:"response",seq:0,request_seq:o,success:!1,command:"canceled",message:"canceled"}),this.f.delete(o)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$0tb=O}),define(Ne[80],Le([1,0,2,9,31,3]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$PK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$NK=e.MemoryRangeType=e.State=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=void 0,e.$MK=p,e.$OK=I,R=qe(R),e.$AJ="workbench.view.debug",e.$BJ="workbench.debug.variablesView",e.$CJ="workbench.debug.watchExpressionsView",e.$DJ="workbench.debug.callStackView",e.$EJ="workbench.debug.loadedScriptsView",e.$FJ="workbench.debug.breakPointsView",e.$GJ="workbench.debug.disassemblyView",e.$HJ="workbench.panel.repl",e.$IJ="workbench.panel.repl.view",e.$JJ=new P.$Wj("debugType",void 0,{type:"string",description:R.localize(7466,null)}),e.$KJ=new P.$Wj("debugConfigurationType",void 0,{type:"string",description:R.localize(7467,null)}),e.$LJ=new P.$Wj("debugState","inactive",{type:"string",description:R.localize(7468,null)}),e.$MJ="debugUx",e.$NJ=new P.$Wj(e.$MJ,"default",{type:"string",description:R.localize(7469,null)}),e.$OJ=new P.$Wj("hasDebugged",!1,{type:"boolean",description:R.localize(7470,null)}),e.$PJ=new P.$Wj("inDebugMode",!1,{type:"boolean",description:R.localize(7471,null)}),e.$QJ=new P.$Wj("inDebugRepl",!1,{type:"boolean",description:R.localize(7472,null)}),e.$RJ=new P.$Wj("breakpointWidgetVisible",!1,{type:"boolean",description:R.localize(7473,null)}),e.$SJ=new P.$Wj("inBreakpointWidget",!1,{type:"boolean",description:R.localize(7474,null)}),e.$TJ=new P.$Wj("breakpointsFocused",!0,{type:"boolean",description:R.localize(7475,null)}),e.$UJ=new P.$Wj("watchExpressionsFocused",!0,{type:"boolean",description:R.localize(7476,null)}),e.$VJ=new P.$Wj("watchExpressionsExist",!1,{type:"boolean",description:R.localize(7477,null)}),e.$WJ=new P.$Wj("variablesFocused",!0,{type:"boolean",description:R.localize(7478,null)}),e.$XJ=new P.$Wj("expressionSelected",!1,{type:"boolean",description:R.localize(7479,null)}),e.$YJ=new P.$Wj("breakpointInputFocused",!1,{type:"boolean",description:R.localize(7480,null)}),e.$ZJ=new P.$Wj("callStackItemType",void 0,{type:"string",description:R.localize(7481,null)}),e.$1J=new P.$Wj("callStackSessionIsAttach",!1,{type:"boolean",description:R.localize(7482,null)}),e.$2J=new P.$Wj("callStackItemStopped",!1,{type:"boolean",description:R.localize(7483,null)}),e.$3J=new P.$Wj("callStackSessionHasOneThread",!1,{type:"boolean",description:R.localize(7484,null)}),e.$4J=new P.$Wj("watchItemType",void 0,{type:"string",description:R.localize(7485,null)}),e.$5J=new P.$Wj("canViewMemory",void 0,{type:"boolean",description:R.localize(7486,null)}),e.$6J=new P.$Wj("breakpointItemType",void 0,{type:"string",description:R.localize(7487,null)}),e.$7J=new P.$Wj("breakpointItemBytes",void 0,{type:"boolean",description:R.localize(7488,null)}),e.$8J=new P.$Wj("breakpointHasModes",!1,{type:"boolean",description:R.localize(7489,null)}),e.$9J=new P.$Wj("breakpointSupportsCondition",!1,{type:"boolean",description:R.localize(7490,null)}),e.$0J=new P.$Wj("loadedScriptsSupported",!1,{type:"boolean",description:R.localize(7491,null)}),e.$$J=new P.$Wj("loadedScriptsItemType",void 0,{type:"string",description:R.localize(7492,null)}),e.$_J=new P.$Wj("focusedSessionIsAttach",!1,{type:"boolean",description:R.localize(7493,null)}),e.$aK=new P.$Wj("focusedSessionIsNoDebug",!1,{type:"boolean",description:R.localize(7494,null)}),e.$bK=new P.$Wj("stepBackSupported",!1,{type:"boolean",description:R.localize(7495,null)}),e.$cK=new P.$Wj("restartFrameSupported",!1,{type:"boolean",description:R.localize(7496,null)}),e.$dK=new P.$Wj("stackFrameSupportsRestart",!1,{type:"boolean",description:R.localize(7497,null)}),e.$eK=new P.$Wj("jumpToCursorSupported",!1,{type:"boolean",description:R.localize(7498,null)}),e.$fK=new P.$Wj("stepIntoTargetsSupported",!1,{type:"boolean",description:R.localize(7499,null)}),e.$gK=new P.$Wj("breakpointsExist",!1,{type:"boolean",description:R.localize(7500,null)}),e.$hK=new P.$Wj("debuggersAvailable",!1,{type:"boolean",description:R.localize(7501,null)}),e.$iK=new P.$Wj("debugExtensionAvailable",!0,{type:"boolean",description:R.localize(7502,null)}),e.$jK=new P.$Wj("debugProtocolVariableMenuContext",void 0,{type:"string",description:R.localize(7503,null)}),e.$kK=new P.$Wj("debugSetVariableSupported",!1,{type:"boolean",description:R.localize(7504,null)}),e.$lK=new P.$Wj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:R.localize(7505,null)}),e.$mK=new P.$Wj("debugSetExpressionSupported",!1,{type:"boolean",description:R.localize(7506,null)}),e.$nK=new P.$Wj("breakWhenValueChangesSupported",!1,{type:"boolean",description:R.localize(7507,null)}),e.$oK=new P.$Wj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:R.localize(7508,null)}),e.$pK=new P.$Wj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:R.localize(7509,null)}),e.$qK=new P.$Wj("terminateDebuggeeSupported",!1,{type:"boolean",description:R.localize(7510,null)}),e.$rK=new P.$Wj("suspendDebuggeeSupported",!1,{type:"boolean",description:R.localize(7511,null)}),e.$sK=new P.$Wj("variableEvaluateNamePresent",!1,{type:"boolean",description:R.localize(7512,null)}),e.$tK=new P.$Wj("variableIsReadonly",!1,{type:"boolean",description:R.localize(7513,null)}),e.$uK=new P.$Wj("variableValue",!1,{type:"string",description:R.localize(7514,null)}),e.$vK=new P.$Wj("variableType",!1,{type:"string",description:R.localize(7515,null)}),e.$wK=new P.$Wj("variableInterfaces",!1,{type:"array",description:R.localize(7516,null)}),e.$xK=new P.$Wj("variableName",!1,{type:"string",description:R.localize(7517,null)}),e.$yK=new P.$Wj("variableLanguage",!1,{type:"string",description:R.localize(7518,null)}),e.$zK=new P.$Wj("variableExtensionId",!1,{type:"string",description:R.localize(7519,null)}),e.$AK=new P.$Wj("exceptionWidgetVisible",!1,{type:"boolean",description:R.localize(7520,null)}),e.$BK=new P.$Wj("multiSessionRepl",!1,{type:"boolean",description:R.localize(7521,null)}),e.$CK=new P.$Wj("multiSessionDebug",!1,{type:"boolean",description:R.localize(7522,null)}),e.$DK=new P.$Wj("disassembleRequestSupported",!1,{type:"boolean",description:R.localize(7523,null)}),e.$EK=new P.$Wj("disassemblyViewFocus",!1,{type:"boolean",description:R.localize(7524,null)}),e.$FK=new P.$Wj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:R.localize(7525,null)}),e.$GK=new P.$Wj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:R.localize(7526,null)});const A=i=>R.localize(7527,null,i);e.$HK=A,e.$IK="editor.contrib.debug",e.$JK="editor.contrib.breakpoint",e.$KK="debug",e.$LK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:R.localize(7528,null)};var T;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(T||(e.State=T={}));function p(i){switch(i){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var o;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(o||(e.MemoryRangeType=o={})),e.$NK="vscode-debug-memory";function I(i){const n=i.presentationHint??i.source.presentationHint;return n==="deemphasize"||n==="subtle"}var y;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var a;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(a||(e.DebugConfigurationProviderTriggerKind=a={}));var S;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(S||(e.DebuggerString=S={})),e.$PK=(0,O.$Fi)("debugService");var d;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(d||(e.BreakpointWidgetContext=d={}));var r;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var s;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(s||(e.DebugTreeItemCollapsibleState=s={}));var c;(function(i){i.deserialize=n=>n,i.serialize=n=>n})(c||(e.IDebugVisualizationTreeItem=c={}));var l;(function(i){i.deserialize=n=>({id:n.id,name:n.name,iconPath:n.iconPath&&{light:v.URI.revive(n.iconPath.light),dark:v.URI.revive(n.iconPath.dark)},iconClass:n.iconClass,visualization:n.visualization}),i.serialize=n=>n})(l||(e.IDebugVisualization=l={}))}),define(Ne[196],Le([1,0,12,2,19,25,15,32,21,17]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hI=void 0,e.$8H=y,e.$9H=a,e.$0H=S,e.$$H=d,e.$_H=r,e.$aI=s,e.$bI=c,e.$cI=i,e.$dI=g,e.$eI=u,e.$fI=m,e.$gI=E;const I=/{([^}]+)}/g;function y(b,C,k){return b.replace(I,function(f,w){return C&&w.length>0&&w[0]!=="_"?f:k&&k.hasOwnProperty(w)?k[w]:f})}function a(b){const C={};for(const k of Object.keys(b))k.startsWith("!")||(C[k]=b[k]);return C}function S(b){return b.configuration.request==="attach"&&!d(b)&&(!b.parentSession||S(b.parentSession))}function d(b){let C=b.configuration.type;if(C)return C==="vslsShare"&&(C=b.configuration.adapterProxy.configuration.type),(0,v.$Ff)(C,"extensionhost")||(0,v.$Ff)(C,"pwa-extensionhost")?b:b.parentSession?d(b.parentSession):void 0}function r(b){return b.type&&(b.label||b.program||b.runtime)}function s(b,C,k){let f,w=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=F.exec(b);){const L=N.index+1,q=L+N[0].length;if(L<=C&&q>=k){f=N[0],w=L;break}}if(f){const L=/(\w|\p{L})+/gu;let q=null;for(;(q=L.exec(f))&&!(q.index+1+w+q[0].length>=k););q&&(f=f.substring(0,L.lastIndex))}return f?{start:w,end:w+f.length-1}:{start:0,end:0}}async function c(b,C,k,f){if(b.evaluatableExpressionProvider.has(C)){const w=b.evaluatableExpressionProvider.ordered(C),F=(0,o.$Gb)(await Promise.all(w.map(async N=>{try{return await N.provideEvaluatableExpression(C,k,f??p.CancellationToken.None)}catch{return}})));if(F.length>0){let N=F[0].expression;const L=F[0].range;return N||(N=C.getLineContent(k.lineNumber).substring(L.startColumn-1,L.endColumn-1)),{range:L,matchingExpression:N}}}else{const w=C.getLineContent(k.lineNumber),{start:F,end:N}=s(w,k.column,k.column),L=w.substring(F-1,N);return{matchingExpression:L,range:new T.$Ot(k.lineNumber,F,k.lineNumber,F+L.length)}}return null}const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(b){return!!(b&&b.match(l))}function n(b){if(typeof b.path=="string"&&!(typeof b.sourceReference=="number"&&b.sourceReference>0)){if(i(b.path))return R.URI.parse(b.path);if((0,P.$ic)(b.path))return R.URI.file(b.path)}return b.path}function t(b){if(typeof b.path=="object"){const C=R.URI.revive(b.path);if(C)return C.scheme===A.Schemas.file?C.fsPath:C.toString()}return b.path}function g(b,C){const k=C?n:t,f=(0,O.$eo)(b);return $(f,(w,F)=>{w&&F&&(F.path=k(F))}),f}function u(b,C){const k=C?n:t,f=(0,O.$eo)(b);return $(f,(w,F)=>{!w&&F&&(F.path=k(F))}),f}function $(b,C){switch(b.type){case"event":{const k=b;switch(k.event){case"output":C(!1,k.body.source);break;case"loadedSource":C(!1,k.body.source);break;case"breakpoint":C(!1,k.body.breakpoint.source);break;default:break}break}case"request":{const k=b;switch(k.command){case"setBreakpoints":C(!0,k.arguments.source);break;case"breakpointLocations":C(!0,k.arguments.source);break;case"source":C(!0,k.arguments.source);break;case"gotoTargets":C(!0,k.arguments.source);break;case"launchVSCode":k.arguments.args.forEach(f=>C(!1,f));break;default:break}break}case"response":{const k=b;if(k.success&&k.body)switch(k.command){case"stackTrace":k.body.stackFrames.forEach(f=>C(!1,f.source));break;case"loadedSources":k.body.sources.forEach(f=>C(!1,f));break;case"scopes":k.body.scopes.forEach(f=>C(!1,f.source));break;case"setFunctionBreakpoints":k.body.breakpoints.forEach(f=>C(!1,f.source));break;case"setBreakpoints":k.body.breakpoints.forEach(f=>C(!1,f.source));break;case"disassemble":k.body?.instructions.forEach(w=>C(!1,w.location));break;default:break}break}}}function m(b){return b.filter(C=>!C.presentation?.hidden).sort((C,k)=>C.presentation?k.presentation?C.presentation.group?k.presentation.group?C.presentation.group!==k.presentation.group?C.presentation.group.localeCompare(k.presentation.group):h(C.presentation.order,k.presentation.order):-1:k.presentation.group?1:h(C.presentation.order,k.presentation.order):-1:k.presentation?1:0)}function h(b,C){return typeof b!="number"?typeof C!="number"?0:1:typeof C!="number"?-1:b-C}async function E(b,C){const k=b.getValue("debug.saveBeforeStart",{overrideIdentifier:C.activeTextEditorLanguageId});if(k!=="none"&&(await C.saveAll(),k==="allEditorsInActiveGroup")){const f=C.activeEditorPane;f&&f.input.resource?.scheme===A.Schemas.untitled&&await C.save({editor:f.input,groupId:f.group.id})}await b.reloadConfiguration()}const D=(b,C)=>!b||!C?b===C:b.name===C.name&&b.path===C.path&&b.sourceReference===C.sourceReference;e.$hI=D}),define(Ne[197],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XK=e.CellExecutionUpdateType=void 0;var R;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(R||(e.CellExecutionUpdateType=R={})),e.$XK=(0,v.$Fi)("INotebookExecutionService")}),define(Ne[198],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2K=e.$1K=e.ProxyKernelState=e.$ZK=void 0,e.$ZK=100;var R;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(R||(e.ProxyKernelState=R={})),e.$1K=(0,v.$Fi)("INotebookKernelService"),e.$2K=(0,v.$Fi)("INotebookKernelHistoryService")}),define(Ne[199],Le([1,0,4,32,52,162,102]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j1b=void 0;class T extends v.$Uc{constructor(o,I,y){super(),this._source=o,this.b=I,this.c=y,this.a=void 0}f(o){const I=o.getLineCount();return new R.$Ot(1,1,I,this.g(o,I))}g(o,I){if(I<1||I>o.getLineCount())throw new Error("Illegal value for lineNumber");return o.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const o=new O.$wD;o.acceptChunk(this._source);const I=o.finish(!0),{textBuffer:y,disposable:a}=I.create(P.DefaultEndOfLine.LF);this.b=y,this.B(a)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(o=>{const I=new O.$wD;I.acceptChunk(o);const y=I.finish(!0),{textBuffer:a,disposable:S}=y.create(P.DefaultEndOfLine.LF);return this.B(S),a})),this.a}findInInputs(o){const y=new A.$kD(o,!1,!1,null).parseSearchRequest();if(!y)return[];const a=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(a,y,!0,5e3)}findInOutputs(o){const y=new A.$kD(o,!1,!1,null).parseSearchRequest();return y?this.outputTextBuffers.map(a=>{const S=a.findMatchesLineByLine(this.f(a),y,!0,5e3);if(S.length!==0)return{textBuffer:a,matches:S}}).filter(a=>!!a):[]}}e.$j1b=T}),define(Ne[54],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7I=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(O){O.Delimiter="\0"})(v||(e.TestIdPathParts=v={}));var R;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(R||(e.TestPosition=R={}));class P{static fromExtHostTestItem(A,T,p=A.parent){if(A._isRoot)return new P([T]);const o=[A.id];for(let I=p;I&&I.id!==T;I=I.parent)o.push(I.id);return o.push(T),new P(o.reverse())}static isRoot(A){return!A.includes(v.Delimiter)}static root(A){const T=A.indexOf(v.Delimiter);return T===-1?A:A.slice(0,T)}static fromString(A){return new P(A.split(v.Delimiter))}static join(A,T){return new P([...A.path,T])}static joinToString(A,T){return A.toString()+v.Delimiter+T}static parentId(A){const T=A.lastIndexOf(v.Delimiter);return T===-1?void 0:A.slice(0,T)}static localId(A){const T=A.lastIndexOf(v.Delimiter);return T===-1?A:A.slice(T+v.Delimiter.length)}static isChild(A,T){return T[A.length]===v.Delimiter&&T.startsWith(A)}static compare(A,T){return A===T?R.IsSame:P.isChild(A,T)?R.IsChild:P.isChild(T,A)?R.IsParent:R.Disconnected}static getLengthOfCommonPrefix(A,T){if(A===0)return 0;let p=0;for(;p<A-1;){for(let o=1;o<A;o++){const I=T(o-1),y=T(o);if(I.path[p]!==y.path[p])return p}p++}return p}constructor(A,T=A.length){if(this.path=A,this.d=T,A.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new P(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new P(this.path,A)}compare(A){if(typeof A=="string")return P.compare(this.toString(),A);for(let T=0;T<A.d&&T<this.d;T++)if(A.path[T]!==this.path[T])return R.Disconnected;return A.d>this.d?R.IsChild:A.d<this.d?R.IsParent:R.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+=v.Delimiter,this.c+=this.path[A]}return this.c}}e.$7I=P}),define(Ne[55],Le([1,0,2,101,32,54]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$cJ=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$bJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$aJ=e.$_I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$$I=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$0I=e.$9I=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.$8I=e.TestResultState=void 0;var A;(function(G){G[G.Unset=0]="Unset",G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$8I={[A.Unset]:"unset",[A.Queued]:"queued",[A.Running]:"running",[A.Passed]:"passed",[A.Failed]:"failed",[A.Skipped]:"skipped",[A.Errored]:"errored"};var T;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var p;(function(G){G[G.Refresh=2]="Refresh",G[G.CodeRelatedToTest=4]="CodeRelatedToTest",G[G.TestRelatedToCode=8]="TestRelatedToCode"})(p||(e.TestControllerCapability=p={}));var o;(function(G){G[G.Run=2]="Run",G[G.Debug=4]="Debug",G[G.Coverage=8]="Coverage",G[G.HasNonDefaultProfile=16]="HasNonDefaultProfile",G[G.HasConfigurable=32]="HasConfigurable",G[G.SupportsContinuousRun=64]="SupportsContinuousRun"})(o||(e.TestRunProfileBitset=o={})),e.$9I=[o.Run,o.Debug,o.Coverage,o.HasNonDefaultProfile,o.HasConfigurable,o.SupportsContinuousRun];const I=G=>"runId"in G;e.$0I=I;var y;(function(G){G.serialize=Q=>({range:Q.range.toJSON(),uri:Q.uri.toJSON()}),G.deserialize=(Q,ae)=>({range:P.$Ot.lift(ae.range),uri:Q.asCanonicalUri(v.URI.revive(ae.uri))})})(y||(e.IRichLocation=y={}));var a;(function(G){G[G.Error=0]="Error",G[G.Output=1]="Output"})(a||(e.TestMessageType=a={}));var S;(function(G){G.serialize=Q=>({label:Q.label,uri:Q.uri?.toJSON(),position:Q.position?.toJSON()}),G.deserialize=(Q,ae)=>({label:ae.label,uri:ae.uri?Q.asCanonicalUri(v.URI.revive(ae.uri)):void 0,position:ae.position?R.$Nt.lift(ae.position):void 0})})(S||(e.ITestMessageStackFrame=S={}));var d;(function(G){G.serialize=Q=>({message:Q.message,type:a.Error,expected:Q.expected,actual:Q.actual,contextValue:Q.contextValue,location:Q.location&&y.serialize(Q.location),stackTrace:Q.stackTrace?.map(S.serialize)}),G.deserialize=(Q,ae)=>({message:ae.message,type:a.Error,expected:ae.expected,actual:ae.actual,contextValue:ae.contextValue,location:ae.location&&y.deserialize(Q,ae.location),stackTrace:ae.stackTrace&&ae.stackTrace.map(be=>S.deserialize(Q,be))})})(d||(e.ITestErrorMessage=d={}));const r=(G,Q)=>`${Q?"s":"e"}${G}`;e.$$I=r;var s;(function(G){G.serialize=Q=>({message:Q.message,type:a.Output,offset:Q.offset,length:Q.length,location:Q.location&&y.serialize(Q.location)}),G.deserialize=(Q,ae)=>({message:ae.message,type:a.Output,offset:ae.offset,length:ae.length,location:ae.location&&y.deserialize(Q,ae.location)})})(s||(e.ITestOutputMessage=s={}));var c;(function(G){G.serialize=Q=>Q.type===a.Error?d.serialize(Q):s.serialize(Q),G.deserialize=(Q,ae)=>ae.type===a.Error?d.deserialize(Q,ae):s.deserialize(Q,ae),G.isDiffable=Q=>Q.type===a.Error&&Q.actual!==void 0&&Q.expected!==void 0})(c||(e.ITestMessage=c={}));var l;(function(G){G.serializeWithoutMessages=Q=>({state:Q.state,duration:Q.duration,messages:[]}),G.serialize=Q=>({state:Q.state,duration:Q.duration,messages:Q.messages.map(c.serialize)}),G.deserialize=(Q,ae)=>({state:ae.state,duration:ae.duration,messages:ae.messages.map(be=>c.deserialize(Q,be))})})(l||(e.ITestTaskState=l={}));const i="\0",n=(G,Q)=>G+i+Q;e.$_I=n;const t=G=>{const Q=G.indexOf(i);return{ctrlId:G.slice(0,Q),tagId:G.slice(Q+1)}};e.$aJ=t;var g;(function(G){G.serialize=Q=>({extId:Q.extId,label:Q.label,tags:Q.tags,busy:Q.busy,children:void 0,uri:Q.uri?.toJSON(),range:Q.range?.toJSON()||null,description:Q.description,error:Q.error,sortText:Q.sortText}),G.deserialize=(Q,ae)=>({extId:ae.extId,label:ae.label,tags:ae.tags,busy:ae.busy,children:void 0,uri:ae.uri?Q.asCanonicalUri(v.URI.revive(ae.uri)):void 0,range:ae.range?P.$Ot.lift(ae.range):null,description:ae.description,error:ae.error,sortText:ae.sortText})})(g||(e.ITestItem=g={}));var u;(function(G){G[G.NotExpandable=0]="NotExpandable",G[G.Expandable=1]="Expandable",G[G.BusyExpanding=2]="BusyExpanding",G[G.Expanded=3]="Expanded"})(u||(e.TestItemExpandState=u={}));var $;(function(G){G.serialize=Q=>({expand:Q.expand,item:g.serialize(Q.item)}),G.deserialize=(Q,ae)=>({controllerId:O.$7I.root(ae.item.extId),expand:ae.expand,item:g.deserialize(Q,ae.item)})})($||(e.InternalTestItem=$={}));var m;(function(G){G.serialize=Q=>{let ae;return Q.item&&(ae={},Q.item.label!==void 0&&(ae.label=Q.item.label),Q.item.tags!==void 0&&(ae.tags=Q.item.tags),Q.item.busy!==void 0&&(ae.busy=Q.item.busy),Q.item.uri!==void 0&&(ae.uri=Q.item.uri?.toJSON()),Q.item.range!==void 0&&(ae.range=Q.item.range?.toJSON()),Q.item.description!==void 0&&(ae.description=Q.item.description),Q.item.error!==void 0&&(ae.error=Q.item.error),Q.item.sortText!==void 0&&(ae.sortText=Q.item.sortText)),{extId:Q.extId,expand:Q.expand,item:ae}},G.deserialize=Q=>{let ae;return Q.item&&(ae={},Q.item.label!==void 0&&(ae.label=Q.item.label),Q.item.tags!==void 0&&(ae.tags=Q.item.tags),Q.item.busy!==void 0&&(ae.busy=Q.item.busy),Q.item.range!==void 0&&(ae.range=Q.item.range?P.$Ot.lift(Q.item.range):null),Q.item.description!==void 0&&(ae.description=Q.item.description),Q.item.error!==void 0&&(ae.error=Q.item.error),Q.item.sortText!==void 0&&(ae.sortText=Q.item.sortText)),{extId:Q.extId,expand:Q.expand,item:ae}}})(m||(e.ITestItemUpdate=m={}));const h=(G,Q)=>{Q.expand!==void 0&&(G.expand=Q.expand),Q.item!==void 0&&(G.item=G.item?Object.assign(G.item,Q.item):Q.item)};e.$bJ=h;var E;(function(G){G.serializeWithoutMessages=Q=>({...$.serialize(Q),ownComputedState:Q.ownComputedState,computedState:Q.computedState,tasks:Q.tasks.map(l.serializeWithoutMessages)}),G.serialize=Q=>({...$.serialize(Q),ownComputedState:Q.ownComputedState,computedState:Q.computedState,tasks:Q.tasks.map(l.serialize)}),G.deserialize=(Q,ae)=>({...$.deserialize(Q,ae),ownComputedState:ae.ownComputedState,computedState:ae.computedState,tasks:ae.tasks.map(be=>l.deserialize(Q,be)),retired:!0})})(E||(e.TestResultItem=E={}));var D;(function(G){G.empty=()=>({covered:0,total:0}),G.sum=(Q,ae)=>{Q.covered+=ae.covered,Q.total+=ae.total}})(D||(e.ICoverageCount=D={}));var b;(function(G){G.serialize=Q=>({id:Q.id,statement:Q.statement,branch:Q.branch,declaration:Q.declaration,testIds:Q.testIds,uri:Q.uri.toJSON()}),G.deserialize=(Q,ae)=>({id:ae.id,statement:ae.statement,branch:ae.branch,declaration:ae.declaration,testIds:ae.testIds,uri:Q.asCanonicalUri(v.URI.revive(ae.uri))}),G.empty=(Q,ae)=>({id:Q,uri:ae,statement:D.empty()})})(b||(e.IFileCoverage=b={}));function C(G){return{...G,location:G.location?.toJSON()}}function k(G){return G.location=G.location?R.$Nt.isIPosition(G.location)?R.$Nt.lift(G.location):P.$Ot.lift(G.location):void 0,G}e.$cJ=3;var f;(function(G){G[G.Declaration=0]="Declaration",G[G.Statement=1]="Statement",G[G.Branch=2]="Branch"})(f||(e.DetailType=f={}));var w;(function(G){G.serialize=Q=>Q.type===f.Declaration?N.serialize(Q):L.serialize(Q),G.deserialize=Q=>Q.type===f.Declaration?N.deserialize(Q):L.deserialize(Q)})(w||(e.CoverageDetails=w={}));var F;(function(G){G.serialize=C,G.deserialize=k})(F||(e.IBranchCoverage=F={}));var N;(function(G){G.serialize=C,G.deserialize=k})(N||(e.IDeclarationCoverage=N={}));var L;(function(G){G.serialize=Q=>({...C(Q),branches:Q.branches?.map(F.serialize)}),G.deserialize=Q=>({...k(Q),branches:Q.branches?.map(F.deserialize)})})(L||(e.IStatementCoverage=L={}));var q;(function(G){G[G.Add=0]="Add",G[G.Update=1]="Update",G[G.DocumentSynced=2]="DocumentSynced",G[G.Remove=3]="Remove",G[G.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",G[G.Retire=5]="Retire",G[G.AddTag=6]="AddTag",G[G.RemoveTag=7]="RemoveTag"})(q||(e.TestDiffOpType=q={}));var H;(function(G){G.deserialize=(Q,ae)=>ae.op===q.Add?{op:ae.op,item:$.deserialize(Q,ae.item)}:ae.op===q.Update?{op:ae.op,item:m.deserialize(ae.item)}:ae.op===q.DocumentSynced?{op:ae.op,uri:Q.asCanonicalUri(v.URI.revive(ae.uri)),docv:ae.docv}:ae,G.serialize=Q=>Q.op===q.Add?{op:Q.op,item:$.serialize(Q.item)}:Q.op===q.Update?{op:Q.op,item:m.serialize(Q.item)}:Q})(H||(e.TestsDiffOp=H={}));class W{constructor(Q){this.l=Q,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(Q){const ae=this.x();for(const be of Q)switch(be.op){case q.Add:this.p($.deserialize(this.l,be.item),ae);break;case q.Update:this.q(m.deserialize(be.item),ae);break;case q.Remove:this.v(be.itemId,ae);break;case q.Retire:this.w(be.itemId);break;case q.IncrementPendingExtHosts:this.updatePendingRoots(be.amount);break;case q.AddTag:this.f.set(be.tag.id,be.tag);break;case q.RemoveTag:this.f.delete(be.id);break}ae.complete?.()}p(Q,ae){const be=O.$7I.parentId(Q.item.extId)?.toString();let le;if(!be)le=this.y(Q),this.h.add(le),this.g.set(Q.item.extId,le);else if(this.g.has(be)){const _=this.g.get(be);_.children.add(Q.item.extId),le=this.y(Q,_),this.g.set(Q.item.extId,le)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(Q)}`);return}return ae.add?.(le),Q.expand===u.BusyExpanding&&this.j++,le}q(Q,ae){const be=this.g.get(Q.extId);if(be)return Q.expand!==void 0&&(be.expand===u.BusyExpanding&&this.j--,Q.expand===u.BusyExpanding&&this.j++),(0,e.$bJ)(be,Q),ae.update?.(be),be}v(Q,ae){const be=this.g.get(Q);if(!be)return;const le=O.$7I.parentId(be.item.extId)?.toString();le?this.g.get(le).children.delete(be.item.extId):this.h.delete(be);const _=[[Q]];for(;_.length;)for(const ce of _.pop()){const me=this.g.get(ce);me&&(_.push(me.children),this.g.delete(ce),ae.remove?.(me,me!==be),me.expand===u.BusyExpanding&&this.j--)}}w(Q){}updatePendingRoots(Q){this.k+=Q}x(){return{}}}e.$dJ=W}),define(Ne[200],Le([1,0,98,9,55]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$NGb=e.$MGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var O;(function(y){y.ViewletId="workbench.view.extension.test",y.ExplorerViewId="workbench.view.testing",y.OutputPeekContributionId="editor.contrib.testingOutputPeek",y.DecorationsContributionId="editor.contrib.testingDecorations",y.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",y.CoverageViewId="workbench.view.testCoverage",y.ResultsPanelId="workbench.panel.testResults",y.ResultsViewId="workbench.panel.testResults.view",y.MessageLanguageId="vscodeInternalTestMessage"})(O||(e.Testing=O={}));var A;(function(y){y.List="list",y.Tree="true"})(A||(e.TestExplorerViewMode=A={}));var T;(function(y){y.ByLocation="location",y.ByStatus="status",y.ByDuration="duration"})(T||(e.TestExplorerViewSorting=T={}));const p={[P.TestResultState.Errored]:(0,R.localize)(3187,null),[P.TestResultState.Failed]:(0,R.localize)(3188,null),[P.TestResultState.Passed]:(0,R.localize)(3189,null),[P.TestResultState.Queued]:(0,R.localize)(3190,null),[P.TestResultState.Running]:(0,R.localize)(3191,null),[P.TestResultState.Skipped]:(0,R.localize)(3192,null),[P.TestResultState.Unset]:(0,R.localize)(3193,null)},o=(y,a)=>(0,R.localize)(3194,null,(0,v.$Zk)(y),p[a]);e.$MGb=o,e.$NGb={[P.TestRunProfileBitset.Debug]:(0,R.localize)(3195,null),[P.TestRunProfileBitset.Run]:(0,R.localize)(3196,null),[P.TestRunProfileBitset.Coverage]:(0,R.localize)(3197,null)};var I;(function(y){y.CancelTestRefreshAction="testing.cancelTestRefresh",y.CancelTestRunAction="testing.cancelRun",y.ClearTestResultsAction="testing.clearTestResults",y.CollapseAllAction="testing.collapseAll",y.ConfigureTestProfilesAction="testing.configureProfile",y.ContinousRunUsingForTest="testing.continuousRunUsingForTest",y.CoverageAtCursor="testing.coverageAtCursor",y.CoverageByUri="testing.coverage.uri",y.CoverageClear="testing.coverage.close",y.CoverageCurrentFile="testing.coverageCurrentFile",y.CoverageFilterToTest="testing.coverageFilterToTest",y.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",y.CoverageLastRun="testing.coverageLastRun",y.CoverageSelectedAction="testing.coverageSelected",y.CoverageToggleToolbar="testing.coverageToggleToolbar",y.CoverageViewChangeSorting="testing.coverageViewChangeSorting",y.DebugAction="testing.debug",y.DebugAllAction="testing.debugAll",y.DebugAtCursor="testing.debugAtCursor",y.DebugByUri="testing.debug.uri",y.DebugCurrentFile="testing.debugCurrentFile",y.DebugFailedTests="testing.debugFailTests",y.DebugLastRun="testing.debugLastRun",y.DebugSelectedAction="testing.debugSelected",y.FilterAction="workbench.actions.treeView.testExplorer.filter",y.GetExplorerSelection="_testing.getExplorerSelection",y.GetSelectedProfiles="testing.getSelectedProfiles",y.GoToTest="testing.editFocusedTest",y.GoToRelatedTest="testing.goToRelatedTest",y.PeekRelatedTest="testing.peekRelatedTest",y.GoToRelatedCode="testing.goToRelatedCode",y.PeekRelatedCode="testing.peekRelatedCode",y.HideTestAction="testing.hideTest",y.OpenCoverage="testing.openCoverage",y.OpenOutputPeek="testing.openOutputPeek",y.RefreshTestsAction="testing.refreshTests",y.ReRunFailedTests="testing.reRunFailTests",y.ReRunLastRun="testing.reRunLastRun",y.RunAction="testing.run",y.RunAllAction="testing.runAll",y.RunAllWithCoverageAction="testing.coverageAll",y.RunAtCursor="testing.runAtCursor",y.RunByUri="testing.run.uri",y.RunCurrentFile="testing.runCurrentFile",y.RunSelectedAction="testing.runSelected",y.RunUsingProfileAction="testing.runUsing",y.RunWithCoverageAction="testing.coverage",y.SearchForTestExtension="testing.searchForTestExtension",y.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",y.ShowMostRecentOutputAction="testing.showMostRecentOutput",y.StartContinousRun="testing.startContinuousRun",y.StopContinousRun="testing.stopContinuousRun",y.TestingSortByDurationAction="testing.sortByDuration",y.TestingSortByLocationAction="testing.sortByLocation",y.TestingSortByStatusAction="testing.sortByStatus",y.TestingViewAsListAction="testing.viewAsList",y.TestingViewAsTreeAction="testing.viewAsTree",y.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",y.ToggleInlineTestOutput="testing.toggleInlineTestOutput",y.UnhideAllTestsAction="testing.unhideAllTests",y.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(Ne[81],Le([1,0,10,6,4,61,55,54]),function(ve,e,v,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=e.$dQ=e.$cQ=e.$bQ=e.$aQ=e.TestItemEventOp=void 0;var p;(function(l){l[l.Upsert=0]="Upsert",l[l.SetTags=1]="SetTags",l[l.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",l[l.RemoveChild=3]="RemoveChild",l[l.SetProp=4]="SetProp",l[l.Bulk=5]="Bulk",l[l.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const o=(l,i)=>l===i,y=Object.entries({range:(l,i)=>l===i?!0:!l||!i?!1:l.equalsRange(i),busy:o,label:o,description:o,error:o,sortText:o,tags:(l,i)=>!(l.length!==i.length||l.some(n=>!i.includes(n)))}),a=(l,i)=>{let n;for(const[t,g]of y)g(l[t],i[t])||(n?n[t]=i[t]:n={[t]:i[t]});return n};class S extends P.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new v.$Rh(()=>this.flushDiff(),200)),this.g=this.B(new R.$le),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const n of this.tree.values())this.J(n)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case A.TestDiffOpType.DocumentSynced:{for(const n of this.m)if(n.op===A.TestDiffOpType.DocumentSynced&&n.uri===i.uri){n.docv=i.docv;return}break}case A.TestDiffOpType.Update:{const n=this.m[this.m.length-1];if(n){if(n.op===A.TestDiffOpType.Update&&n.item.extId===i.item.extId){(0,A.$bJ)(n.item,i.item);return}if(n.op===A.TestDiffOpType.Add&&n.item.item.extId===i.item.extId){(0,A.$bJ)(n.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,n){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||n>t.expandLevels)&&(t.expandLevels=n),t.expand===A.TestItemExpandState.Expandable){const g=this.M(t);return g.isOpen()?this.L(t,n-1):g.wait().then(()=>this.L(t,n-1))}else if(t.expand===A.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,n-1)):this.L(t,n-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,n){switch(n.op){case p.RemoveChild:this.O(T.$7I.joinToString(i.fullId,n.id));break;case p.Upsert:this.z(n.item,i);break;case p.Bulk:for(const t of n.ops)this.w(i,t);break;case p.SetTags:this.C(n.new,n.old,i.fullId.toString());break;case p.UpdateCanResolveChildren:this.J(i);break;case p.SetProp:this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:n.update}});break;case p.DocumentSynced:this.y(i.actual.uri);break;default:(0,O.$ed)(n)}}y(i){i&&this.pushDiff({op:A.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,n){const t=T.$7I.fromExtHostTestItem(i,this.root.id,n?.actual),g=this.s.getApiFor(i);g.parent&&g.parent!==n?.actual&&this.s.getChildren(g.parent).delete(i.id);let u=this.tree.get(t.toString());if(!u){u={fullId:t,actual:i,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:A.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(u.fullId.toString(),u),this.G(i,n),this.pushDiff({op:A.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:u.expand,item:this.s.toITestItem(i)}}),this.I(i,u,n);return}if(u.actual===i){this.H(i,u,n);return}if(u.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,n);const $=this.s.getChildren(u.actual),m=u.actual,h=a(this.s.toITestItem(m),this.s.toITestItem(i));this.s.getApiFor(m).listener=void 0,u.actual=i,u.resolveBarrier=void 0,u.expand=A.TestItemExpandState.NotExpandable,h&&(h.hasOwnProperty("tags")&&(this.C(i.tags,m.tags,t.toString()),delete h.tags),this.w(u,{op:p.SetProp,update:h})),this.I(i,u,n);for(const[D,b]of $)this.s.getChildren(i).get(b.id)||this.O(T.$7I.joinToString(t,b.id));const E=u.expandLevels;E!==void 0&&queueMicrotask(()=>{u.expand===A.TestItemExpandState.Expandable&&(u.expandLevels=void 0,this.expand(t.toString(),E))}),this.y(u.actual.uri)}C(i,n,t){const g=new Set(n.map(u=>u.id));for(const u of i)g.delete(u.id)||this.D(u);this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(u=>(0,A.$_I)(this.s.controllerId,u.id))}}}),g.forEach(this.F,this)}D(i){const n=this.j.get(i.id);n?n.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:A.TestDiffOpType.AddTag,tag:{id:(0,A.$_I)(this.s.controllerId,i.id)}}))}F(i){const n=this.j.get(i);n&&!--n.refCount&&(this.j.delete(i),this.pushDiff({op:A.TestDiffOpType.RemoveTag,id:(0,A.$_I)(this.s.controllerId,i)}))}G(i,n){this.s.getApiFor(i).parent=n&&n.actual!==this.root?n.actual:void 0}H(i,n,t){this.G(i,t);const g=this.s.getApiFor(i);g.parent=t?.actual,g.listener=u=>this.w(n,u),this.J(n)}I(i,n,t){this.H(i,n,t);for(const[g,u]of this.s.getChildren(i))this.z(u,n)}J(i){let n;this.h?i.resolveBarrier?n=i.resolveBarrier.isOpen()?A.TestItemExpandState.Expanded:A.TestItemExpandState.BusyExpanding:n=i.actual.canResolveChildren?A.TestItemExpandState.Expandable:A.TestItemExpandState.NotExpandable:n=A.TestItemExpandState.NotExpandable,n!==i.expand&&(i.expand=n,this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:n}}),n===A.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,n){if(n<0)return;const t=[];for(const[g,u]of this.s.getChildren(i.actual)){const $=this.expand(T.$7I.joinToString(i.fullId,u.id),n);(0,v.$rh)($)&&t.push($)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const u=new v.$Eh;return u.open(),u}i.expand=A.TestItemExpandState.BusyExpanding,this.N(i);const n=i.resolveBarrier=new v.$Eh,t=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,u)};let g;try{g=this.h(i.actual===this.root?void 0:i.actual)}catch(u){t(u)}return(0,v.$rh)(g)?g.catch(t).then(()=>{n.open(),this.J(i)}):(n.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const n=this.tree.get(i);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:A.TestDiffOpType.Remove,itemId:i});const t=[n];for(;t.length;){const g=t.pop();if(g){this.s.getApiFor(g.actual).listener=void 0;for(const u of g.actual.tags)this.F(u.id);this.tree.delete(g.fullId.toString());for(const[u,$]of this.s.getChildren(g.actual))t.push(this.tree.get(T.$7I.joinToString(g.fullId,$.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$aQ=S;class d extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$bQ=d;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$cQ=r;class s extends Error{constructor(i,n,t){super(`TestItem with ID "${i}" is from controller "${n}" and cannot be added as a child of an item from controller "${t}".`)}}e.$dQ=s;const c=(l,i,n)=>{let t=new Map;return{get size(){return t.size},forEach(g,u){for(const $ of t.values())g.call(u,$,this)},[Symbol.iterator](){return t.entries()},replace(g){const u=new Map,$=new Set(t.keys()),m={op:p.Bulk,ops:[]};for(const h of g){if(!(h instanceof n))throw new r(h.id);const E=i(h).controllerId;if(E!==l.controllerId)throw new s(h.id,E,l.controllerId);if(u.has(h.id))throw new d(h.id);u.set(h.id,h),$.delete(h.id),m.ops.push({op:p.Upsert,item:h})}for(const h of $.keys())m.ops.push({op:p.RemoveChild,id:h});l.listener?.(m),t=u},add(g){if(!(g instanceof n))throw new r(g.id);t.set(g.id,g),l.listener?.({op:p.Upsert,item:g})},delete(g){t.delete(g)&&l.listener?.({op:p.RemoveChild,id:g})},get(g){return t.get(g)},toJSON(){return Array.from(t.values())}}};e.$eQ=c}),define(Ne[116],Le([1,0,81]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gQ=e.$fQ=void 0;const R=new WeakMap,P=(A,T)=>{const p={controllerId:T};return R.set(A,p),p};e.$fQ=P;const O=A=>{const T=R.get(A);if(!T)throw new v.$cQ(A?.id||"<unknown>");return T};e.$gQ=O}),define(Ne[82],Le([1,0,27,15,2]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GDb=e.$FDb=e.$EDb=void 0,e.$HDb=O,e.$IDb=T,e.$EDb="vscode-cdn.net",e.$FDb=`vscode-resource.${e.$EDb}`,e.$GDb=`'self' https://*.${e.$EDb}`;function O(p,o){return p.scheme===R.Schemas.http||p.scheme===R.Schemas.https?p:(o&&o.authority&&o.isRemote&&p.scheme===R.Schemas.file&&(p=P.URI.from({scheme:R.Schemas.vscodeRemote,authority:o.authority,path:p.path})),P.URI.from({scheme:R.Schemas.https,authority:`${p.scheme}+${A(p.authority)}.${e.$FDb}`,path:p.path,fragment:p.fragment,query:p.query}))}function A(p){return p.replace(/./g,o=>{const I=o.charCodeAt(0);return I>=v.CharCode.a&&I<=v.CharCode.z||I>=v.CharCode.A&&I<=v.CharCode.Z||I>=v.CharCode.Digit0&&I<=v.CharCode.Digit9?o:"-"+I.toString(16).padStart(4,"0")})}function T(p){return p.replace(/-([0-9a-f]{4})/g,(o,I)=>String.fromCharCode(parseInt(I,16)))}}),define(Ne[201],Le([1,0,6,4,82]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jpc=void 0;class O{constructor(T,p,o){this.d=T,this.e=p,this.f=o,this.a=0,this.b=new R.$Tc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const I=p.getVisibleTextEditors();for(const y of this.c.values())I.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,p,o,I,y){let a;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===T){a=i;break}if(!a)throw new Error("not a visible editor");const S=this,d=this.a++,r=new v.$le,s=new v.$le,c=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,P.$HDb)(i,S.f)}get cspSource(){return P.$GDb}set options(i){this.b=i,S.d.$setOptions(d,i)}get options(){return this.b}set html(i){this.a=i,S.d.$setHtml(d,i)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(i){return S.d.$postMessage(d,i)}},l=new class{constructor(){this.editor=T,this.line=p,this.height=o,this.webview=c,this.onDidDispose=s.event}dispose(){S.c.has(d)&&(S.c.delete(d),S.d.$disposeEditorInset(d),s.fire(),s.dispose(),r.dispose())}};return this.d.$createEditorInset(d,a.id,a.value.document.uri,p+1,o,I||{},y.identifier,y.extensionLocation),this.c.set(d,{editor:T,inset:l,onDidReceiveMessage:r}),l}$onDidDispose(T){const p=this.c.get(T);p&&p.inset.dispose()}$onDidReceiveMessage(T,p){this.c.get(T)?.onDidReceiveMessage.fire(p)}}e.$Jpc=O}),define(Ne[117],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=e.$NM=e.$MM=void 0,e.$MM="__",e.$NM=(0,v.$Fi)("IAuthenticationService"),e.$OM=(0,v.$Fi)("IAuthenticationExtensionsService")}),define(Ne[202],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Q=e.VariableKind=e.$$Q=void 0,e.$$Q=(0,v.$Fi)("configurationResolverService");var R;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(R||(e.VariableKind=R={}));class P extends Error{constructor(A,T){super(T),this.variable=A}}e.$_Q=P}),define(Ne[203],Le([1,0,19,78,14,25,20,99,9,202,12]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=void 0,v=qe(v),R=qe(R),P=qe(P),O=qe(O);class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,d,r,s){this.h=new Map,this.a=S,this.b=d,this.g=r,s&&(this.c=s.then(c=>this.i(c)))}i(S){if(A.$j){const d=Object.create(null);return Object.keys(S).forEach(r=>{d[r.toLowerCase()]=S[r]}),d}return S}resolveWithEnvironment(S,d,r){return this.l({env:this.i(S),userHome:void 0},d?d.uri:void 0,r)}async resolveAsync(S,d){const r={env:await this.c,userHome:await this.g};return this.l(r,S?S.uri:void 0,d)}async j(S,d,r,s){const c=O.$eo(d);A.$j&&c.windows?Object.keys(c.windows).forEach(i=>c[i]=c.windows[i]):A.$k&&c.osx?Object.keys(c.osx).forEach(i=>c[i]=c.osx[i]):A.$l&&c.linux&&Object.keys(c.linux).forEach(i=>c[i]=c.linux[i]),delete c.windows,delete c.osx,delete c.linux;const l={env:await this.c,userHome:await this.g};return this.l(l,S?S.uri:void 0,c,r,s)}async resolveAnyAsync(S,d,r){return this.j(S,d,r)}async resolveAnyMap(S,d,r){const s=new Map;return{newConfig:await this.j(S,d,r,s),resolvedVariables:s}}resolveWithInteractionReplace(S,d,r,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,d,r,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,d){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,d)}async l(S,d,r,s,c){if(P.$eg(r))return this.m(S,d,r,s,c);if(Array.isArray(r))return Promise.all(r.map(l=>this.l(S,d,l,s,c)));if(P.$gg(r)){const l=Object.create(null),i=await Promise.all(Object.keys(r).map(async n=>[await this.m(S,d,n,s,c),await this.l(S,d,r[n],s,c)]));for(const[n,t]of i)l[n]=t;return l}return r}m(S,d,r,s,c){return(0,I.$xf)(r,y.VARIABLE_REGEXP,async(l,i)=>{if(i.includes(y.VARIABLE_LHS))return l;let n=await this.o(S,l,i,d,s);return c?.set(i,n),n!==l&&P.$eg(n)&&n.match(y.VARIABLE_REGEXP)&&(n=await this.m(S,d,n,s,c)),n})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,d,r,s,c){let l;const i=r.split(":");i.length>1&&(r=i[0],l=i[1]);const n=u=>{const $=this.a.getFilePath();if($)return(0,T.$1w)($);throw new o.$_Q(u,(0,p.localize)(2078,null,d))},t=u=>{const $=n(u);if(this.a.getWorkspaceFolderPathForFile){const m=this.a.getWorkspaceFolderPathForFile();if(m)return(0,T.$1w)(m)}throw new o.$_Q(u,(0,p.localize)(2079,null,d,v.$nc($)))},g=u=>{if(l){const $=this.a.getFolderUri(l);if($)return $;throw new o.$_Q(u,(0,p.localize)(2080,null,d,l))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new o.$_Q(u,(0,p.localize)(2081,null,d)):new o.$_Q(u,(0,p.localize)(2082,null,d))};switch(r){case"env":if(l){if(S.env){const u=S.env[A.$j?l.toLowerCase():l];if(P.$eg(u))return u}return""}throw new o.$_Q(o.VariableKind.Env,(0,p.localize)(2083,null,d));case"config":if(l){const u=this.a.getConfigurationValue(s,l);if(P.$ng(u))throw new o.$_Q(o.VariableKind.Config,(0,p.localize)(2084,null,d,l));if(P.$gg(u))throw new o.$_Q(o.VariableKind.Config,(0,p.localize)(2085,null,d,l));return u}throw new o.$_Q(o.VariableKind.Config,(0,p.localize)(2086,null,d));case"command":return this.p(o.VariableKind.Command,d,l,c,"command");case"input":return this.p(o.VariableKind.Input,d,l,c,"input");case"extensionInstallFolder":if(l){const u=await this.a.getExtension(l);if(!u)throw new o.$_Q(o.VariableKind.ExtensionInstallFolder,(0,p.localize)(2087,null,d,l));return this.n(u.extensionLocation)}throw new o.$_Q(o.VariableKind.ExtensionInstallFolder,(0,p.localize)(2088,null,d));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,T.$1w)(this.n(g(o.VariableKind.WorkspaceFolder)));case"cwd":return s||l?(0,T.$1w)(this.n(g(o.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$1w)(v.$nc(this.n(g(o.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new o.$_Q(o.VariableKind.UserHome,(0,p.localize)(2089,null,d))}case"lineNumber":{const u=this.a.getLineNumber();if(u)return u;throw new o.$_Q(o.VariableKind.LineNumber,(0,p.localize)(2090,null,d))}case"selectedText":{const u=this.a.getSelectedText();if(u)return u;throw new o.$_Q(o.VariableKind.SelectedText,(0,p.localize)(2091,null,d))}case"file":return n(o.VariableKind.File);case"fileWorkspaceFolder":return t(o.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return v.$nc(t(o.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return s||l?v.$lc(this.n(g(o.VariableKind.RelativeFile)),n(o.VariableKind.RelativeFile)):n(o.VariableKind.RelativeFile);case"relativeFileDirname":{const u=v.$mc(n(o.VariableKind.RelativeFileDirname));if(s||l){const $=v.$lc(this.n(g(o.VariableKind.RelativeFileDirname)),u);return $.length===0?".":$}return u}case"fileDirname":return v.$mc(n(o.VariableKind.FileDirname));case"fileExtname":return v.$oc(n(o.VariableKind.FileExtname));case"fileBasename":return v.$nc(n(o.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=v.$nc(n(o.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-v.$oc(u).length)}case"fileDirnameBasename":return v.$nc(v.$mc(n(o.VariableKind.FileDirnameBasename)));case"execPath":{const u=this.a.getExecPath();return u||d}case"execInstallFolder":{const u=this.a.getAppRoot();return u||d}case"pathSeparator":case"/":return v.sep;default:try{const u=l?`${r}:${l}`:r;return this.p(o.VariableKind.Unknown,d,u,c,void 0)}catch{return d}}}}p(S,d,r,s,c){if(r&&s){const l=c===void 0?s[r]:s[c+":"+r];if(typeof l=="string")return l;throw new o.$_Q(S,(0,p.localize)(2092,null,d))}return d}}e.$oR=y}),define(Ne[118],Le([1,0,3,114]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$tE=void 0,e.$uE=o,e.$vE=a,e.$wE=S,e.$tE=(0,v.$Fi)("editorGroupsService");var P;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var O;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var A;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var T;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var p;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function o(d){const r=d;return(0,R.$hG)(r?.editor)&&(0,R.$hG)(r?.replacement)}var I;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var y;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function a(d){const r=d;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function S(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(Ne[204],Le([1,0,3,118]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AE=e.$zE=e.$yE=e.$xE=void 0,e.$BE=P,e.$xE=(0,v.$Fi)("editorService"),e.$yE=-1,e.$zE=-2,e.$AE=-3;function P(O){const A=O;return typeof O=="number"||(0,R.$vE)(A)}}),define(Ne[205],Le([1,0,3,106]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=void 0,e.$8M=(0,v.$Gi)(R.$Mi)}),define(Ne[119],Le([1,0,18,6,19,4,10]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=e.$Odc=e.$Ndc=e.$Mdc=e.$Ldc=void 0,P=qe(P);class T{constructor(l,i){this.versionId=l,this.removedDueToLooping=i}}e.$Ldc=T;class p{static isHostExtension(l,i,n){if(i.getExtensionDescription(l))return!1;const t=n.getExtensionDescription(l);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(l,i){this.j=l,this.c=new R.$le,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(r),this.f=new v.$tn,this.g=[],this.h=new Map;for(const l of this.e){if(this.f.has(l.identifier)){console.error("Extension `"+l.identifier.value+"` is already registered");continue}this.f.set(l.identifier,l),this.g.push(l);const i=this.j.readActivationEvents(l);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(l)}}set(l){return this.e=l,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(l,i){this.e=s(this.e,i),this.e=this.e.concat(l);const n=p.l(this.e);return this.e=s(this.e,n.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new T(this.d,n)}static l(l){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode($){this.d.has($)||(this.d.add($),this.e.push($))}addArc($,m){this.addNode($),this.addNode(m),this.c.has($)?this.c.get($).push(m):this.c.set($,[m])}getArcs($){return this.c.has($)?this.c.get($):[]}hasOnlyGoodArcs($,m){const h=i.getArcs($);for(let E=0;E<h.length;E++)if(!m.has(h[E]))return!1;return!0}getNodes(){return this.e}},n=new v.$tn;for(const $ of l)if(n.set($.identifier,$),$.extensionDependencies)for(const m of $.extensionDependencies)i.addArc(v.$rn.toKey($.identifier),v.$rn.toKey(m));const t=new Set;i.getNodes().filter($=>i.getArcs($).length===0).forEach($=>t.add($));const g=i.getNodes().filter($=>!t.has($));let u;do{u=!1;for(let $=0;$<g.length;$++){const m=g[$];i.hasOnlyGoodArcs(m,t)&&(g.splice($,1),$--,t.add(m),u=!0)}}while(u);return g.map($=>n.get($))}containsActivationEvent(l){return this.h.has(l)}containsExtension(l){return this.f.has(l)}getExtensionDescriptionsForActivationEvent(l){const i=this.h.get(l);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new o(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(l){const i=this.f.get(l);return i||void 0}getExtensionDescriptionByUUID(l){for(const i of this.g)if(i.uuid===l)return i}getExtensionDescriptionByIdOrUUID(l,i){return this.getExtensionDescription(l)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$Mdc=p;class o{constructor(l,i){this.versionId=l,this.extensions=i}}e.$Ndc=o;class I{constructor(l){this.d=new S,this.c=new p(l,[])}async acquireLock(l){const i=await this.d.acquire(l);return new y(this,i)}deltaExtensions(l,i,n){if(!l.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(l){return this.c.containsActivationEvent(l)}containsExtension(l){return this.c.containsExtension(l)}getExtensionDescriptionsForActivationEvent(l){return this.c.getExtensionDescriptionsForActivationEvent(l)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(l){return this.c.getExtensionDescription(l)}getExtensionDescriptionByUUID(l){return this.c.getExtensionDescriptionByUUID(l)}getExtensionDescriptionByIdOrUUID(l,i){return this.c.getExtensionDescriptionByIdOrUUID(l,i)}}e.$Odc=I;class y extends O.$Uc{constructor(l,i){super(),this.f=l,this.c=!1,this.B(i)}isAcquiredFor(l){return!this.c&&this.f===l}}e.$Pdc=y;class a{constructor(l){this.name=l;const i=(0,A.$yh)();this.promise=i.promise,this.c=i.resolve}resolve(l){this.c(l)}}class S{constructor(){this.c=[],this.d=!1}async acquire(l){const i=new a(l);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const l=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${l.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};l.resolve((0,O.$Sc)(t))}}var d;(function(c){c[c.Builtin=0]="Builtin",c[c.User=1]="User",c[c.Dev=2]="Dev"})(d||(d={}));function r(c,l){const i=c.isBuiltin?d.Builtin:c.isUnderDevelopment?d.Dev:d.User,n=l.isBuiltin?d.Builtin:l.isUnderDevelopment?d.Dev:d.User;if(i!==n)return i-n;const t=P.$gc.basename(c.extensionLocation.path),g=P.$gc.basename(l.extensionLocation.path);return t<g?-1:t>g?1:0}function s(c,l){const i=new v.$sn(l);return c.filter(n=>!i.has(n.identifier))}}),define(Ne[83],Le([1,0,22]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Bn=A,e.$Cn=T;var R;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(R||(e.UIKind=R={}));var P;(function(o){o[o.VersionMismatch=55]="VersionMismatch",o[o.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var O;(function(o){o[o.Initialized=0]="Initialized",o[o.Ready=1]="Ready",o[o.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function A(o){const I=v.$Ne.alloc(1);switch(o){case O.Initialized:I.writeUInt8(1,0);break;case O.Ready:I.writeUInt8(2,0);break;case O.Terminate:I.writeUInt8(3,0);break}return I}function T(o,I){if(o.byteLength!==1)return!1;switch(o.readUInt8(0)){case 1:return I===O.Initialized;case 2:return I===O.Ready;case 3:return I===O.Terminate;default:return!1}}var p;(function(o){o.Start="START_NATIVE_LOG",o.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Ne[66],Le([1,0,3,6,112,11,26,83,62,63,25,2,4,9]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EQ=e.$CQ=e.$BQ=void 0,e.$DQ=s;let d=class extends a.$Uc{constructor(l,i){super(),this.s=l,this.t=i,this.a=this.B(new R.$le),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new R.$le),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=P.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:o.$Cp,name:(0,S.localize)(10825,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,O.$ck)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=P.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=P.TelemetryLevel.USAGE:!1}}instantiateLogger(l,i,n){const t=this.getTelemetryDetails(),g=new r(i,n,l,this.n,this.j,this.getBuiltInCommonProperties(l),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),u=this.r.get(l.identifier.value)??[];return this.r.set(l.identifier.value,[...u,g]),g.apiTelemetryLogger}$initializeTelemetryLevel(l,i,n){this.f=l,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(l){const i=Object.create(null);switch(i["common.extname"]=`${l.publisher}.${l.name}`,i["common.extversion"]=l.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:i["common.uikind"]="web";break;case T.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$in)((0,o.$Ip)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(l){this.h=this.getTelemetryConfiguration(),this.f=l;const i=this.getTelemetryDetails();this.r.forEach((n,t)=>{const g=n.filter(u=>!u.isDisposed);g.length===0?this.r.delete(t):this.r.set(t,g)}),this.r.forEach(n=>{for(const t of n)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(l,i){const t=this.r.get(l.value)?.filter(u=>!u.isDisposed);if(!t)return this.r.delete(l.value),!1;let g=!1;for(const u of t)u.ignoreUnhandledExtHostErrors||(u.logError(i),g=!0);return g}};e.$BQ=d,e.$BQ=d=Je([Ve(0,A.$AQ),Ve(1,O.$bk)],d);class r{static validateSender(l){if(typeof l!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof l.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof l.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof l.flush<"u"&&typeof l.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(l,i,n,t,g,u,$){this.g=n,this.h=t,this.i=g,this.j=u,this.a=new R.$le,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=l,this.d={isUsageEnabled:$.isUsageEnabled,isErrorsEnabled:$.isErrorsEnabled}}updateTelemetryEnablements(l,i){this.e&&(this.d={isUsageEnabled:l,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(l){let i="properties"in l?l.properties??{}:l;return i=(0,o.$Lp)(i,[]),this.c&&(i=(0,I.$ho)(i,this.c)),this.b||(i=(0,I.$ho)(i,this.j)),"properties"in l?l.properties=i:l=i,l}k(l,i){this.f&&(this.g.publisher==="vscode"?l=this.g.name+"/"+l:l=this.g.identifier.value+"/"+l,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(l,i),this.h.trace(l,i))}logUsage(l,i){this.d.isUsageEnabled&&this.k(l,i)}logError(l,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof l=="string")this.k(l,i);else{const n={name:l.name,message:l.message,stack:l.stack,cause:l.cause},t=(0,o.$Lp)(n,[]),g=new Error(t.message,{cause:t.cause});g.stack=t.stack,g.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(g,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const l=this,i={logUsage:l.logUsage.bind(l),get isUsageEnabled(){return l.d.isUsageEnabled},get isErrorsEnabled(){return l.d.isErrorsEnabled},logError:l.logError.bind(l),dispose:l.dispose.bind(l),onDidChangeEnableStates:l.a.event.bind(l)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let l=this.f;this.f=void 0,Promise.resolve(l.flush()).then(l=void 0),this.e=void 0}else this.f=void 0}}e.$CQ=r;function s(c){const l=Date.now()-new Date(c).getTime();return isNaN(l)?!1:l<1e3*60*60*24}e.$EQ=(0,v.$Fi)("IExtHostTelemetry")}),define(Ne[24],Le([1,0,6,2,178,111,18,3]),function(ve,e,v,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lH=e.ActivationKind=e.$iH=e.$hH=e.$eH=e.ExtensionHostStartup=e.$dH=e.$cH=e.$bH=e.$aH=void 0,e.$fH=a,e.$gH=S,e.$jH=c,e.$kH=l,e.$aH=Object.freeze({identifier:new A.$rn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:A.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$bH="extensions.webWorker",e.$cH=(0,T.$Fi)("extensionService");class p{constructor(t){this.dependency=t}}e.$dH=p;var o;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(o||(e.ExtensionHostStartup=o={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,g,u){this.c=t,this.d=g.slice(0),this.e=u.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$YG.createActivationEventsMap(this.d)}}set(t,g,u){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const $=[],m=[],h=[],E=[],D=y(this.d),b=y(g),C=(N,L)=>N.extensionLocation.toString()===L.extensionLocation.toString()||N.isBuiltin===L.isBuiltin||N.isUserBuiltin===L.isUserBuiltin||N.isUnderDevelopment===L.isUnderDevelopment;for(const N of this.d){const L=b.get(N.identifier);if(!L){$.push(N.identifier),D.delete(N.identifier);continue}if(!C(N,L)){$.push(N.identifier),D.delete(N.identifier);continue}}for(const N of g){const L=D.get(N.identifier);if(!L){m.push(N);continue}if(!C(L,N)){$.push(L.identifier),D.delete(L.identifier);continue}}const k=new A.$sn(this.e),f=new A.$sn(u);for(const N of this.e)f.has(N)||h.push(N);for(const N of u)k.has(N)||E.push(N);const w=O.$YG.createActivationEventsMap(m),F={versionId:t,toRemove:$,toAdd:m,addActivationEvents:w,myToRemove:h,myToAdd:E};return this.delta(F),F}delta(t){if(this.c>=t.versionId)return null;const{toRemove:g,toAdd:u,myToRemove:$,myToAdd:m}=t,h=new A.$sn(g),E=new A.$sn($);for(let D=0;D<this.d.length;D++)h.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)E.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of u)this.d.push(D);for(const D of m)this.e.push(D);return this.f=null,t}containsExtension(t){for(const g of this.e)if(A.$rn.equals(g,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const g of this.d){if(!this.containsExtension(g.identifier))continue;const u=O.$YG.readActivationEvents(g);for(const $ of u)t.add($)}return t}}e.$eH=I;function y(n){const t=new A.$tn;for(const g of n)t.set(g.identifier,g);return t}function a(n,t){return n.enabledApiProposals?n.enabledApiProposals.includes(t):!1}function S(n,t){if(!a(n,t))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}class d{constructor(t,g,u,$){this.codeLoadingTime=t,this.activateCallTime=g,this.activateResolvedTime=u,this.activationReason=$}}e.$hH=d;class r{constructor(t,g){this.description=t,this.value=g}}e.$iH=r;var s;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function c(n){return{type:n.isBuiltin?A.ExtensionType.System:A.ExtensionType.User,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,P.$Rp)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}function l(n,t){const g=(0,P.$Pp)(n.manifest.publisher,n.manifest.name);return{id:g,identifier:new A.$rn(g),isBuiltin:n.type===A.ExtensionType.System,isUserBuiltin:n.type===A.ExtensionType.User&&n.isBuiltin,isUnderDevelopment:!!t,extensionLocation:n.location,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform,publisherDisplayName:n.publisherDisplayName,...n.manifest}}class i{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None,this.onWillStop=v.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,g){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,g){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$lH=i}),define(Ne[206],Le([1,0,13,4,119,18,24,11,10]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$pc=e.$0pc=e.$9pc=e.$8pc=e.$7pc=e.$6pc=void 0,v=qe(v);class o{static{this.NONE=new o(!1,-1,-1,-1)}constructor(l,i,n,t){this.startup=l,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=t}}e.$6pc=o;class I{constructor(l){this.a=l,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(l,i){return l===-1||i===-1?-1:i-l}build(){return new o(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$7pc=I;class y{constructor(l,i,n,t,g,u){this.activationFailed=l,this.activationFailedError=i,this.activationTimes=n,this.module=t,this.exports=g,this.disposable=u}}e.$8pc=y;class a extends y{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,R.$Uc.None)}}e.$9pc=a;class S extends y{constructor(){super(!1,null,o.NONE,{activate:void 0,deactivate:void 0},void 0,R.$Uc.None)}}e.$0pc=S;class d extends y{constructor(l){super(!0,l,o.NONE,{activate:void 0,deactivate:void 0},void 0,R.$Uc.None)}}let r=class{constructor(l,i,n,t){this.g=t,this.a=l,this.b=i,this.c=n,this.d=new O.$tn,this.f=Object.create(null)}dispose(){for(const[l,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const l=[];for(const[i,n]of this.d)l.push(n.wait());await Promise.all(l)}isActivated(l){const i=this.d.get(l);return!!(i&&i.value)}getActivatedExtension(l){const i=this.d.get(l);if(!i||!i.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return i.value}async activateByEvent(l,i){if(this.f[l])return;const n=this.a.getExtensionDescriptionsForActivationEvent(l);await this.h(n.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:l}}))),this.f[l]=!0}activateById(l,i){const n=this.a.getExtensionDescription(l);if(!n)throw new Error(`Extension '${l.value}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(l){const i=l.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(l){if(this.d.has(l.id))return this.d.get(l.id);if(this.l(l.id))return this.k(l,null,[],null);const i=this.a.getExtensionDescription(l.id);if(!i){const g=new Error(`Cannot activate unknown extension '${l.id.value}'`),u=this.k(l,null,[],new d(g));return this.c.onExtensionActivationError(l.id,g,new A.$dH(l.id.value)),u}const n=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const g of t){if(this.m(g))continue;const u=this.d.get(g);if(u){n.push(u);continue}if(this.l(g)){n.push(this.j({id:this.b.getExtensionDescription(g).identifier,reason:l.reason}));continue}const $=this.a.getExtensionDescription(g);if($){if(!$.main&&!$.browser)continue;n.push(this.j({id:$.identifier,reason:l.reason}));continue}const m=i.displayName||i.identifier.value,h=new Error(`Cannot activate the '${m}' extension because it depends on unknown extension '${g}'`),E=this.k(l,i.displayName,[],new d(h));return this.c.onExtensionActivationError(i.identifier,h,new A.$dH(g)),E}return this.k(l,i.displayName,n,null)}k(l,i,n,t){const g=new s(l.id,i,l.reason,n,t,this.c,this.g);return this.d.set(l.id,g),g}l(l){return P.$Mdc.isHostExtension(l,this.a,this.b)}m(l){const i=this.b.getExtensionDescription(l);return i?!i.main&&!i.browser:!1}};e.$$pc=r,e.$$pc=r=Je([Ve(3,T.$ak)],r);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(l,i,n,t,g,u,$){this.c=l,this.d=i,this.f=n,this.g=t,this.h=g,this.j=u,this.k=$,this.a=new p.$Eh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let l=0;l<this.g.length;l++){const i=this.g[l];if(i.value&&!i.value.activationFailed){this.g.splice(l,1),l--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new d(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(l=>l.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(l){const i=new Error;if(l&&l.name&&(i.name=l.name),l&&l.message?i.message=`Activating extension '${this.c.value}' failed: ${l.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${l}.`,l&&l.stack&&(i.stack=l.stack),this.h=new d(i),this.b&&v.$3(l))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(l)}}};s=Je([Ve(6,T.$ak)],s)});var xt=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[120],Le([1,0,9,13,35,110,77,30,18,108,111,104]),function(ve,e,v,R,P,O,A,T,p,o,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=void 0,v=qe(v),P=xt(P);const a=T.$ro.as(A.$so.JSONContribution);class S{constructor(t,g,u){this.a=t,this.b=g,this.c=u}d(t,g){this.a({type:t,message:g,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(P.default.Error,t)}warn(t){this.d(P.default.Warning,t)}info(t){this.d(P.default.Info,t)}}e.$7G=S;class d{static a(t){const g=new p.$sn;for(let u=0,$=t.length;u<$;u++)g.add(t[u].description.identifier);return g}static compute(t,g){if(!t||!t.length)return new d(g,[]);if(!g||!g.length)return new d([],t);const u=this.a(t),$=this.a(g),m=g.filter(E=>!u.has(E.description.identifier)),h=t.filter(E=>!$.has(E.description.identifier));return new d(m,h)}constructor(t,g){this.added=t,this.removed=g}}e.$8G=d;class r{constructor(t,g){this.name=t,this.defaultExtensionKind=g,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=d.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,R.$Y)(t)}}}e.$9G=r;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[v.localize(1843,null),v.localize(1844,null)]},c="vscode://schemas/vscode-extensions";e.$0G={properties:{engines:{type:"object",description:v.localize(1845,null),properties:{vscode:{type:"string",description:v.localize(1846,null),default:"^1.22.0"}}},publisher:{description:v.localize(1847,null),type:"string"},displayName:{description:v.localize(1848,null),type:"string"},categories:{description:v.localize(1849,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$qn},{type:"string",const:"Languages",deprecationMessage:v.localize(1850,null)}]}},galleryBanner:{type:"object",description:v.localize(1851,null),properties:{color:{description:v.localize(1852,null),type:"string"},theme:{description:v.localize(1853,null),type:"string",enum:["dark","light"]}}},contributes:{description:v.localize(1854,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:v.localize(1855,null)},enableProposedApi:{type:"boolean",deprecationMessage:v.localize(1856,null)},enabledApiProposals:{markdownDescription:v.localize(1857,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals).map(n=>n),markdownEnumDescriptions:Object.values(y.allApiProposals).map(n=>n.proposal)}},api:{markdownDescription:v.localize(1858,null),type:"string",enum:["none"],enumDescriptions:[v.localize(1859,null)]},activationEvents:{description:v.localize(1860,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:v.localize(1861,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:v.localize(1862,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:v.localize(1863,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:v.localize(1864,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:v.localize(1865,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:v.localize(1866,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:v.localize(1867,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:v.localize(1868,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:v.localize(1869,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:v.localize(1870,null),body:"onStartupFinished"},{label:"onTaskType",description:v.localize(1871,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:v.localize(1872,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:v.localize(1873,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:v.localize(1874,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:v.localize(1875,null)},{label:"onUri",body:"onUri",description:v.localize(1876,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:v.localize(1877,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:v.localize(1878,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:v.localize(1879,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:v.localize(1880,null)},{label:"onRenderer",description:v.localize(1881,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:v.localize(1882,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:v.localize(1883,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:v.localize(1884,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:v.localize(1885,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:v.localize(1886,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:v.localize(1887,null)},{label:"*",description:v.localize(1888,null),body:"*"}]}},badges:{type:"array",description:v.localize(1889,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:v.localize(1890,null)},href:{type:"string",description:v.localize(1891,null)},description:{type:"string",description:v.localize(1892,null)}}}},markdown:{type:"string",description:v.localize(1893,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:v.localize(1894,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:v.localize(1895,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$$o}},extensionPack:{description:v.localize(1896,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$$o}},extensionKind:{description:v.localize(1897,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:v.localize(1898,null)},{body:["workspace"],description:v.localize(1899,null)},{body:["ui","workspace"],description:v.localize(1900,null)},{body:["workspace","ui"],description:v.localize(1901,null)},{body:[],description:v.localize(1902,null)}]},capabilities:{description:v.localize(1903,null),type:"object",properties:{virtualWorkspaces:{description:v.localize(1904,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:v.localize(1905,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(1906,null),v.localize(1907,null),v.localize(1908,null)]},description:{type:"string",markdownDescription:v.localize(1909,null)}}},untrustedWorkspaces:{description:v.localize(1910,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:v.localize(1911,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(1912,null),v.localize(1913,null),v.localize(1914,null)]},restrictedConfigurations:{description:v.localize(1915,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:v.localize(1916,null)}}}}},sponsor:{description:v.localize(1917,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:v.localize(1918,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:v.localize(1919,null),type:"string"},"vscode:uninstall":{description:v.localize(1920,null),type:"string"}}},icon:{type:"string",description:v.localize(1921,null)},l10n:{type:"string",description:v.localize(1922,null)},pricing:{type:"string",markdownDescription:v.localize(1923,null),enum:["Free","Trial"],default:"Free"}}};class l{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const g=new r(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,g),t.activationEventsGenerator&&I.$YG.register(t.extensionPoint,t.activationEventsGenerator),e.$0G.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,a.registerSchema(c,e.$0G),g}getExtensionPoints(){return Array.from(this.a.values())}}e.$$G=l;const i={ExtensionsRegistry:"ExtensionsRegistry"};T.$ro.add(i.ExtensionsRegistry,new l),e.$_G=T.$ro.as(i.ExtensionsRegistry),a.registerSchema(c,e.$0G),a.registerSchema(o.$uk,{properties:{extensionEnabledApiProposals:{description:v.localize(1924,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals).map(n=>n.proposal)}}]}}}})}),define(Ne[207],Le([1,0,6,40,4,12,9,18,3,11,24,120]),function(ve,e,v,R,P,O,A,T,p,o,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oH=e.$nH=e.$mH=e.ChatMessageRole=void 0;var a;(function(r){r[r.System=0]="System",r[r.User=1]="User",r[r.Assistant=2]="Assistant"})(a||(e.ChatMessageRole=a={})),e.$mH=(0,p.$Fi)("ILanguageModelsService");const S={type:"object",properties:{vendor:{type:"string",description:(0,A.localize)(8424,null)}}};e.$nH=y.$_G.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,A.localize)(8425,null),oneOf:[S,{type:"array",items:S}]},activationEventsGenerator:(r,s)=>{for(const c of r)s.push(`onLanguageModelChat:${c.vendor}`)}});let d=class{constructor(s,c){this.e=s,this.f=c,this.a=new P.$Tc,this.b=new Map,this.c=new Set,this.d=this.a.add(new v.$le),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$nH.setHandler(l=>{this.c.clear();for(const n of l){if(!(0,I.$fH)(n.description,"chatProvider")){n.collector.error((0,A.localize)(8426,null));continue}for(const t of R.Iterable.wrap(n.value)){if(this.c.has(t.vendor)){n.collector.error((0,A.localize)(8427,null,t.vendor));continue}if((0,O.$cf)(t.vendor)){n.collector.error((0,A.localize)(8428,null));continue}if(t.vendor.trim()!==t.vendor){n.collector.error((0,A.localize)(8429,null));continue}this.c.add(t.vendor)}}const i=[];for(const[n,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(n),i.push(n));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(s){return this.b.get(s)?.metadata}async selectLanguageModels(s){if(s.vendor)await this.e.activateByEvent(`onLanguageModelChat:${s.vendor}}`);else{const l=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(l)}const c=[];for(const[l,i]of this.b)(s.vendor===void 0||i.metadata.vendor===s.vendor)&&(s.family===void 0||i.metadata.family===s.family)&&(s.version===void 0||i.metadata.version===s.version)&&(s.identifier===void 0||i.metadata.id===s.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(n=>T.$rn.equals(n,s.extension)))&&c.push(l);return this.f.trace("[LM] selected language models",s,c),c}registerLanguageModelChat(s,c){if(this.f.trace("[LM] registering language model chat",s,c.metadata),!this.c.has(c.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${c.metadata.vendor}.`);if(this.b.has(s))throw new Error(`Chat response provider with identifier ${s} is already registered.`);return this.b.set(s,c),this.d.fire({added:[{identifier:s,metadata:c.metadata}]}),(0,P.$Sc)(()=>{this.b.delete(s)&&(this.d.fire({removed:[s]}),this.f.trace("[LM] UNregistered language model chat",s,c.metadata))})}async sendChatRequest(s,c,l,i,n){const t=this.b.get(s);if(!t)throw new Error(`Chat response provider with identifier ${s} is not registered.`);return t.sendChatRequest(l,c,i,n)}computeTokenLength(s,c,l){const i=this.b.get(s);if(!i)throw new Error(`Chat response provider with identifier ${s} is not registered.`);return i.provideTokenCount(c,l)}};e.$oH=d,e.$oH=d=Je([Ve(0,I.$cH),Ve(1,o.$ak)],d)}),define(Ne[208],Le([1,0,9,14,25,120,31,6]),function(ve,e,v,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UI=void 0,v=qe(v),R=qe(R),P=qe(P);const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:v.localize(3925,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:v.localize(3926,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:v.localize(3927,null),default:""}}};var o;(function(a){function S(d,r,s){if(!d)return;const c=R.$eg(d.type)?d.type:void 0;if(!c||c.length===0){s.error(v.localize(3928,null));return}const l=[];if(Array.isArray(d.required))for(const i of d.required)R.$eg(i)&&l.push(i);return{extensionId:r.value,taskType:c,required:l,properties:d.properties?P.$eo(d.properties):{},when:d.when?A.$Dj.deserialize(d.when):void 0}}a.from=S})(o||(o={}));const I=O.$_G.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(a,S)=>{for(const d of a)d.type&&S.push(`onTaskType:${d.type}`)},jsonSchema:{description:v.localize(3929,null),type:"array",items:p}});class y{constructor(){this.d=new T.$le,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,d)=>{I.setHandler((r,s)=>{this.c=void 0;try{for(const c of s.removed){const l=c.value;for(const i of l)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const c of s.added){const l=c.value;for(const i of l){const n=o.from(i,c.description.identifier,c.collector);n&&(this.a[n.taskType]=n)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const d of this.all()){const r={type:"object",additionalProperties:!1};d.required.length>0&&(r.required=d.required.slice(0)),d.properties!==void 0?r.properties=P.$eo(d.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[d.taskType]},S.push(r)}this.c={oneOf:S}}return this.c}}e.$UI=new y}),define(Ne[209],Le([1,0,9,14,23,25,31,208,43]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$5I=e.JsonSchemaVersion=e.ExecutionEngine=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$YI=e.ShellQuoting=e.$XI=e.$WI=e.$VI=void 0,v=qe(v),R=qe(R),P=qe(P),O=qe(O),e.$VI="settings",e.$WI=new A.$Wj("taskRunning",!1,v.localize(3913,null)),e.$XI=v.localize2(3915,"Tasks");var o;(function(W){W[W.Escape=1]="Escape",W[W.Strong=2]="Strong",W[W.Weak=3]="Weak"})(o||(e.ShellQuoting=o={})),e.$YI="$customized",function(W){function G(Q){if(!Q)return W.Strong;switch(Q.toLowerCase()){case"escape":return W.Escape;case"strong":return W.Strong;case"weak":return W.Weak;default:return W.Strong}}W.from=G}(o||(e.ShellQuoting=o={}));var I;(function(W){W.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var y;(function(W){W[W.Always=1]="Always",W[W.Silent=2]="Silent",W[W.Never=3]="Never"})(y||(e.RevealKind=y={})),function(W){function G(Q){switch(Q.toLowerCase()){case"always":return W.Always;case"silent":return W.Silent;case"never":return W.Never;default:return W.Always}}W.fromString=G}(y||(e.RevealKind=y={}));var a;(function(W){W[W.Never=1]="Never",W[W.OnProblem=2]="OnProblem",W[W.Always=3]="Always"})(a||(e.RevealProblemKind=a={})),function(W){function G(Q){switch(Q.toLowerCase()){case"always":return W.Always;case"never":return W.Never;case"onproblem":return W.OnProblem;default:return W.OnProblem}}W.fromString=G}(a||(e.RevealProblemKind=a={}));var S;(function(W){W[W.Shared=1]="Shared",W[W.Dedicated=2]="Dedicated",W[W.New=3]="New"})(S||(e.PanelKind=S={})),function(W){function G(Q){switch(Q.toLowerCase()){case"shared":return W.Shared;case"dedicated":return W.Dedicated;case"new":return W.New;default:return W.Shared}}W.fromString=G}(S||(e.PanelKind=S={}));var d;(function(W){W.defaults={echo:!0,reveal:y.Always,revealProblems:a.Never,focus:!1,panel:S.Shared,showReuseMessage:!0,clear:!1}})(d||(e.PresentationOptions=d={}));var r;(function(W){W[W.Shell=1]="Shell",W[W.Process=2]="Process",W[W.CustomExecution=3]="CustomExecution"})(r||(e.RuntimeType=r={})),function(W){function G(ae){switch(ae.toLowerCase()){case"shell":return W.Shell;case"process":return W.Process;case"customExecution":return W.CustomExecution;default:return W.Process}}W.fromString=G;function Q(ae){switch(ae){case W.Shell:return"shell";case W.Process:return"process";case W.CustomExecution:return"customExecution";default:return"process"}}W.toString=Q}(r||(e.RuntimeType=r={}));var s;(function(W){function G(Q){return R.$eg(Q)?Q:Q.value}W.value=G})(s||(e.CommandString=s={}));var c;(function(W){W.Clean={_id:"clean",isDefault:!1},W.Build={_id:"build",isDefault:!1},W.Rebuild={_id:"rebuild",isDefault:!1},W.Test={_id:"test",isDefault:!1};function G(ae){return ae===W.Clean._id||ae===W.Build._id||ae===W.Rebuild._id||ae===W.Test._id}W.is=G;function Q(ae){if(ae!==void 0)return R.$eg(ae)?G(ae)?{_id:ae,isDefault:!1}:void 0:ae}W.from=Q})(c||(e.TaskGroup=c={}));var l;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace",W[W.Folder=3]="Folder"})(l||(e.TaskScope=l={}));var i;(function(W){W.Workspace="workspace",W.Extension="extension",W.InMemory="inMemory",W.WorkspaceFile="workspaceFile",W.User="user";function G(Q){switch(Q){case W.User:return p.ConfigurationTarget.USER;case W.WorkspaceFile:return p.ConfigurationTarget.WORKSPACE;default:return p.ConfigurationTarget.WORKSPACE_FOLDER}}W.toConfigurationTarget=G})(i||(e.TaskSourceKind=i={}));var n;(function(W){W.parallel="parallel",W.sequence="sequence"})(n||(e.DependsOrder=n={}));var t;(function(W){W[W.default=1]="default",W[W.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var g;(function(W){W.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(g||(e.RunOptions=g={}));class u{constructor(G,Q,ae,be,le,_){this._label="",this._id=G,Q&&(this._label=Q),ae&&(this.type=ae),this.runOptions=be,this.configurationProperties=le,this._source=_}getDefinition(G){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const G={folder:this.d(),id:this._id};return JSON.stringify(G)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(G,Q=!1){if(G===void 0)return!1;if(R.$eg(G))return G===this._label||G===this.configurationProperties.identifier||Q&&G===this._id;const ae=this.getDefinition(!0);return ae!==void 0&&ae._key===G._key}getQualifiedLabel(){const G=this.getWorkspaceFolder();return G?`${this._label} (${G.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(G){this.c===void 0&&(this.c=[]),G&&(this.c=this.c.concat(G))}get taskLoadMessages(){return this.c}}e.$ZI=u;class $ extends u{constructor(G,Q,ae,be,le,_,ce,me){super(G,ae,void 0,ce,me,Q),this.command={},this._source=Q,this.hasDefinedMatchers=_,le&&(this.command=le)}clone(){return new $(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(G=!1){if(G&&this._source.customizes!==void 0)return this._source.customizes;{let Q;switch(this.command?this.command.runtime:void 0){case r.Shell:Q="shell";break;case r.Process:Q="process";break;case r.CustomExecution:Q="customExecution";break;case void 0:Q="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Q,_key:this._id,id:this._id}}}static is(G){return G instanceof $}getMapKey(){const G=this._source.config.workspaceFolder;return G?`${G.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$VI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const G=this.d();if(!G)return;let Q=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Q+=this._source.kind);const ae={type:e.$YI,folder:G,id:Q};return JSON.stringify(ae)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$dh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(G){return new $(G._id,G._source,G._label,G.type,G.command,G.hasDefinedMatchers,G.runOptions,G.configurationProperties)}}e.$1I=$;class m extends u{constructor(G,Q,ae,be,le,_,ce){super(G,ae,be,_,ce,Q),this._source=Q,this.configures=le}static is(G){return G instanceof m}f(G){return G}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$dh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$VI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const G=this.d();if(!G)return;let Q=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Q+=this._source.kind);const ae={type:e.$YI,folder:G,id:Q};return JSON.stringify(ae)}}e.$2I=m;class h extends u{constructor(G,Q,ae,be,le,_,ce,me,oe){super(G,ae,be,me,oe,Q),this.defines=le,this.hasDefinedMatchers=ce,this.command=_,this.icon=oe.icon,this.hide=oe.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(G){return G instanceof h}getMapKey(){const G=this._source.workspaceFolder;return G?`${this._source.scope.toString()}|${G.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===l.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const G={type:"contributed",scope:this._source.scope,id:this._id};return G.folder=this.d(),JSON.stringify(G)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(G){return new h(G._id,G._source,G._label,G.type,G.defines,G.command,G.hasDefinedMatchers,G.runOptions,G.configurationProperties)}}e.$3I=h;class E extends u{constructor(G,Q,ae,be,le,_){super(G,ae,be,le,_,Q),this._source=Q}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(G){return G instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(G){return new E(G._id,G._source,G._label,G.type,G.runOptions,G.configurationProperties)}}e.$4I=E;var D;(function(W){W[W.Process=1]="Process",W[W.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(W){W._default=W.Terminal}(D||(e.ExecutionEngine=D={}));var b;(function(W){W[W.V0_1_0=1]="V0_1_0",W[W.V2_0_0=2]="V2_0_0"})(b||(e.JsonSchemaVersion=b={}));class C{constructor(G){this.c=new Map;for(let Q=0;Q<G.length;Q++)this.c.set(G[Q].uri.toString(),Q)}compare(G,Q){const ae=G.getWorkspaceFolder(),be=Q.getWorkspaceFolder();if(ae&&be){let le=this.c.get(ae.uri.toString());le=le===void 0?0:le+1;let _=this.c.get(be.uri.toString());return _=_===void 0?0:_+1,le===_?G._label.localeCompare(Q._label):le-_}else return!ae&&be?-1:ae&&!be?1:0}}e.$5I=C;var k;(function(W){W.DependsOnStarted="dependsOnStarted",W.AcquiredInput="acquiredInput",W.Start="start",W.ProcessStarted="processStarted",W.Active="active",W.Inactive="inactive",W.Changed="changed",W.Terminated="terminated",W.ProcessEnded="processEnded",W.End="end"})(k||(e.TaskEventKind=k={}));var f;(function(W){W.SingleRun="singleRun",W.Background="background"})(f||(e.TaskRunType=f={}));var w;(function(W){W[W.System=0]="System",W[W.User=1]="User",W[W.FolderOpen=2]="FolderOpen",W[W.ConfigurationChange=3]="ConfigurationChange",W[W.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var F;(function(W){function G(me){return{taskId:me._id,taskName:me.configurationProperties.name,runType:me.configurationProperties.isBackground?f.Background:f.SingleRun,group:me.configurationProperties.group,__task:me}}function Q(me,oe,ke){return{...G(me),kind:k.Start,terminalId:oe,resolvedVariables:ke}}W.start=Q;function ae(me,oe,ke){return{...G(me),kind:k.ProcessStarted,terminalId:oe,processId:ke}}W.processStarted=ae;function be(me,oe,ke){return{...G(me),kind:k.ProcessEnded,terminalId:oe,exitCode:ke}}W.processEnded=be;function le(me,oe,ke){return{...G(me),kind:k.Terminated,exitReason:ke,terminalId:oe}}W.terminated=le;function _(me,oe,ke){return{...G(oe),kind:me,terminalId:ke}}W.general=_;function ce(){return{kind:k.Changed}}W.changed=ce})(F||(e.TaskEvent=F={}));var N;(function(W){function G(ae){const be=Object.keys(ae).sort();let le="";for(const _ of be){let ce=ae[_];ce instanceof Object?ce=G(ce):typeof ce=="string"&&(ce=ce.replace(/,/g,",,")),le+=_+","+ce+","}return le}function Q(ae){const le={_key:G(ae),type:ae.taskType};return Object.assign(le,ae),le}W.create=Q})(N||(e.KeyedTaskIdentifier=N={}));var L;(function(W){W.AutoDetect="task.autoDetect",W.SaveBeforeRun="task.saveBeforeRun",W.ShowDecorations="task.showDecorations",W.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",W.SlowProviderWarning="task.slowProviderWarning",W.QuickOpenHistory="task.quickOpen.history",W.QuickOpenDetail="task.quickOpen.detail",W.QuickOpenSkip="task.quickOpen.skip",W.QuickOpenShowAll="task.quickOpen.showAll",W.AllowAutomaticTasks="task.allowAutomaticTasks",W.Reconnection="task.reconnection",W.VerboseLogging="task.verboseLogging"})(L||(e.TaskSettingId=L={}));var q;(function(W){W.Tasks="tasks",W.SuppressTaskName="tasks.suppressTaskName",W.Windows="tasks.windows",W.Osx="tasks.osx",W.Linux="tasks.linux",W.ShowOutput="tasks.showOutput",W.IsShellCommand="tasks.isShellCommand",W.ServiceTestSetting="tasks.service.testSetting"})(q||(e.TasksSchemaProperties=q={}));var H;(function(W){function G(Q,ae){const be=T.$UI.get(Q.type);if(be===void 0){const me=O.$eo(Q);return delete me._key,N.create(me)}const le=Object.create(null);le.type=be.taskType;const _=new Set;be.required.forEach(me=>_.add(me));const ce=be.properties;for(const me of Object.keys(ce)){const oe=Q[me];if(oe!=null)le[me]=oe;else if(_.has(me)){const ke=ce[me];if(ke.default!==void 0)le[me]=O.$eo(ke.default);else switch(ke.type){case"boolean":le[me]=!1;break;case"number":case"integer":le[me]=0;break;case"string":le[me]="";break;default:ae.error(v.localize(3914,null,JSON.stringify(Q,void 0,0),me));return}}}return N.create(le)}W.createTaskIdentifier=G})(H||(e.TaskDefinition=H={}))}),define(Ne[210],Le([1,0,13]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=e.$Qdc=void 0;class R{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,T)=>{this.b=A,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,v.$Y)(A))}then(A,T){return this.j().then(A,T)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$Qdc=R;class P extends R{constructor(){super(),this.h=!0,this.i=new v.$4}}e.$Rdc=P}),define(Ne[39],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xw=e.$Uw=void 0,e.$Vw=P,e.$Ww=O;class v{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++v.count}}e.$Uw=v;const R=[];function P(T){const p=new v(T);return R[p.nid]=p,p}function O(T){return R[T].sid}class A{constructor(p){this.value=p}}e.$Xw=A}),define(Ne[5],Le([1,0,39]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=e.$KN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$JN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(R||(e.TextEditorRevealType=R={}));var P;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var O;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var A;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var T;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var p;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var o;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(o||(e.NotebookEditorRevealType=o={}));var I;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class y{static{this.a=0}static mixin(s){return s._id=y.a++,s}}e.$JN=y;var a;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(a||(e.ISuggestDataDtoField=a={}));var S;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var d;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$KN={MainThreadAuthentication:(0,v.$Vw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.$Vw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,v.$Vw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,v.$Vw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,v.$Vw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,v.$Vw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,v.$Vw)("MainThreadChatSkills"),MainThreadClipboard:(0,v.$Vw)("MainThreadClipboard"),MainThreadCommands:(0,v.$Vw)("MainThreadCommands"),MainThreadComments:(0,v.$Vw)("MainThreadComments"),MainThreadConfiguration:(0,v.$Vw)("MainThreadConfiguration"),MainThreadConsole:(0,v.$Vw)("MainThreadConsole"),MainThreadDebugService:(0,v.$Vw)("MainThreadDebugService"),MainThreadDecorations:(0,v.$Vw)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.$Vw)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.$Vw)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.$Vw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.$Vw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.$Vw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.$Vw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.$Vw)("MainThreadEditorTabs"),MainThreadErrors:(0,v.$Vw)("MainThreadErrors"),MainThreadTreeViews:(0,v.$Vw)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.$Vw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,v.$Vw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.$Vw)("MainThreadLanguages"),MainThreadLogger:(0,v.$Vw)("MainThreadLogger"),MainThreadMessageService:(0,v.$Vw)("MainThreadMessageService"),MainThreadOutputService:(0,v.$Vw)("MainThreadOutputService"),MainThreadProgress:(0,v.$Vw)("MainThreadProgress"),MainThreadQuickDiff:(0,v.$Vw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,v.$Vw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.$Vw)("MainThreadStatusBar"),MainThreadSecretState:(0,v.$Vw)("MainThreadSecretState"),MainThreadStorage:(0,v.$Vw)("MainThreadStorage"),MainThreadSpeech:(0,v.$Vw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,v.$Vw)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.$Vw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,v.$Vw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,v.$Vw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.$Vw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.$Vw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.$Vw)("MainThreadCustomEditors"),MainThreadUrls:(0,v.$Vw)("MainThreadUrls"),MainThreadUriOpeners:(0,v.$Vw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,v.$Vw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,v.$Vw)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.$Vw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,v.$Vw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,v.$Vw)("MainThreadExtensionService"),MainThreadSCM:(0,v.$Vw)("MainThreadSCM"),MainThreadSearch:(0,v.$Vw)("MainThreadSearch"),MainThreadShare:(0,v.$Vw)("MainThreadShare"),MainThreadTask:(0,v.$Vw)("MainThreadTask"),MainThreadWindow:(0,v.$Vw)("MainThreadWindow"),MainThreadLabelService:(0,v.$Vw)("MainThreadLabelService"),MainThreadNotebook:(0,v.$Vw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.$Vw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.$Vw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.$Vw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.$Vw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.$Vw)("MainThreadInteractive"),MainThreadTheming:(0,v.$Vw)("MainThreadTheming"),MainThreadTunnelService:(0,v.$Vw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,v.$Vw)("MainThreadManagedSockets"),MainThreadTimeline:(0,v.$Vw)("MainThreadTimeline"),MainThreadTesting:(0,v.$Vw)("MainThreadTesting"),MainThreadLocalization:(0,v.$Vw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,v.$Vw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,v.$Vw)("MainThreadAiEmbeddingVector")},e.$LN={ExtHostCommands:(0,v.$Vw)("ExtHostCommands"),ExtHostConfiguration:(0,v.$Vw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.$Vw)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.$Vw)("ExtHostDebugService"),ExtHostDecorations:(0,v.$Vw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.$Vw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.$Vw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.$Vw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.$Vw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.$Vw)("ExtHostEditors"),ExtHostTreeViews:(0,v.$Vw)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.$Vw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.$Vw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.$Vw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.$Vw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.$Vw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.$Vw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,v.$Vw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,v.$Vw)("ExtHostStatusBar"),ExtHostShare:(0,v.$Vw)("ExtHostShare"),ExtHostExtensionService:(0,v.$Vw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.$Vw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.$Vw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,v.$Vw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,v.$Vw)("ExtHostSCM"),ExtHostSearch:(0,v.$Vw)("ExtHostSearch"),ExtHostTask:(0,v.$Vw)("ExtHostTask"),ExtHostWorkspace:(0,v.$Vw)("ExtHostWorkspace"),ExtHostWindow:(0,v.$Vw)("ExtHostWindow"),ExtHostWebviews:(0,v.$Vw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.$Vw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.$Vw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.$Vw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.$Vw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.$Vw)("ExtHostEditorTabs"),ExtHostProgress:(0,v.$Vw)("ExtHostProgress"),ExtHostComments:(0,v.$Vw)("ExtHostComments"),ExtHostSecretState:(0,v.$Vw)("ExtHostSecretState"),ExtHostStorage:(0,v.$Vw)("ExtHostStorage"),ExtHostUrls:(0,v.$Vw)("ExtHostUrls"),ExtHostUriOpeners:(0,v.$Vw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,v.$Vw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,v.$Vw)("ExtHostOutputService"),ExtHostLabelService:(0,v.$Vw)("ExtHostLabelService"),ExtHostNotebook:(0,v.$Vw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.$Vw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.$Vw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.$Vw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.$Vw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,v.$Vw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,v.$Vw)("ExtHostInteractive"),ExtHostChatAgents2:(0,v.$Vw)("ExtHostChatAgents"),ExtHostChatVariables:(0,v.$Vw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,v.$Vw)("ExtHostChatSkills"),ExtHostChatProvider:(0,v.$Vw)("ExtHostChatProvider"),ExtHostSpeech:(0,v.$Vw)("ExtHostSpeech"),ExtHostEmbeddings:(0,v.$Vw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,v.$Vw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,v.$Vw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,v.$Vw)("ExtHostTheming"),ExtHostTunnelService:(0,v.$Vw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,v.$Vw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,v.$Vw)("ExtHostAuthentication"),ExtHostTimeline:(0,v.$Vw)("ExtHostTimeline"),ExtHostTesting:(0,v.$Vw)("ExtHostTesting"),ExtHostTelemetry:(0,v.$Vw)("ExtHostTelemetry"),ExtHostLocalization:(0,v.$Vw)("ExtHostLocalization")}}),define(Ne[84],Le([1,0,3,11,5,16]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$upc=e.$tpc=e.$spc=void 0,P=qe(P),e.$spc=(0,v.$Fi)("IExtHostApiDeprecationService");let A=class{constructor(p,o){this.c=o,this.a=new Set,this.b=p.getProxy(P.$KN.MainThreadTelemetry)}report(p,o,I){const y=this.d(p,o);this.a.has(y)||(this.a.add(y),o.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:o.identifier.value,apiId:p}))}d(p,o){return`${p}-${o.identifier.value}`}};e.$tpc=A,e.$tpc=A=Je([Ve(0,O.$kQ),Ve(1,R.$ak)],A),e.$upc=Object.freeze(new class{report(T,p,o){}})}),define(Ne[211],Le([1,0,5]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hpc=void 0;class R{constructor(O){const A=O.getProxy(v.$KN.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(T){return A.$writeText(T)}})}}e.$Hpc=R}),define(Ne[212],Le([1,0,25,5,26,16]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Drc=void 0;let A=class{constructor(I,y){this.a=I.getProxy(R.$KN.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,y){const a=this,S=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){a.e(I,y,S,arguments)}})}e(I,y,a,S){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:p(S,this.b)}),this.c&&this.f(I,a,S)}};e.$Drc=A,e.$Drc=A=Je([Ve(0,O.$kQ),Ve(1,P.$AQ)],A);const T=1e5;function p(o,I){const y=[];if(o.length)for(let a=0;a<o.length;a++){let S=o[a];if(typeof S>"u")S="undefined";else if(S instanceof Error){const d=S;d.stack?S=d.stack:S=d.toString()}y.push(S)}if(I){const a=new Error().stack;a&&y.push({__$stack:a.split(`
`).slice(3).join(`
`)})}try{const a=(0,v.$jo)(y);return a.length>T?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}),define(Ne[213],Le([1,0,2,5,24]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jqc=void 0;class O{constructor(T){this.a=T.getProxy(R.$KN.MainThreadDialogs)}showOpenDialog(T,p){return p?.allowUIResources&&(0,P.$gH)(T,"showLocal"),this.a.$showOpenDialog(p).then(o=>o?o.map(I=>v.URI.revive(I)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then(p=>p?v.URI.revive(p):void 0)}}e.$Jqc=O}),define(Ne[214],Le([1,0,21,6,4,5]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mqc=void 0;class A{constructor(p){this.b=new Map,this.c=new R.$le,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=p.getProxy(O.$KN.MainThreadEmbeddings)}registerEmbeddingsProvider(p,o,I){if(this.d.has(o))throw new Error("An embeddings provider for this model is already registered");const y=this.e++;return this.a.$registerEmbeddingProvider(y,o),this.b.set(y,{id:o,provider:I}),(0,P.$Sc)(()=>{this.d.delete(o),this.a.$unregisterEmbeddingProvider(y),this.b.delete(y)})}async computeEmbeddings(p,o,I){I??=v.CancellationToken.None;let y=!1;typeof o=="string"&&(o=[o],y=!0);const a=await this.a.$computeEmbeddings(p,o,I);if(a.length!==o.length)throw new Error;if(y){if(a.length!==1)throw new Error;return a[0]}return a}async $provideEmbeddings(p,o,I){const y=this.b.get(p);if(!y)return[];const a=await y.provider.provideEmbeddings(o,I);return a||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(p){this.d=new Set(p),this.c.fire()}}e.$Mqc=A}),define(Ne[215],Le([1,0,4,5]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4qc=void 0;class P{constructor(A){this.b=0,this.a=A.getProxy(R.$KN.MainThreadLabelService)}$registerResourceLabelFormatter(A){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,A),(0,v.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.$4qc=P}),define(Ne[85],Le([1,0,20,12,2,3,11,5,26,16]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nqc=e.$mqc=void 0;let I=class{constructor(a,S,d){this.f=d,this.d=new Map,this.a=S.getProxy(T.$KN.MainThreadLocalization),this.b=a.environment.appLanguage,this.c=this.b===v.$h}getMessage(a,S){const{message:d,args:r,comment:s}=S;if(this.c)return(0,R.$ef)(d,r??{});let c=d;s&&s.length>0&&(c+=`/${Array.isArray(s)?s.join(""):s}`);const l=this.d.get(a)?.contents[c];return l||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${c}`),(0,R.$ef)(l??d,r??{})}getBundle(a){return this.d.get(a)?.contents}getBundleUri(a){return this.d.get(a)?.uri}async initializeLocalizedMessages(a){if(this.c||!a.l10n&&!a.isBuiltin||this.d.has(a.identifier.value))return;let S;const d=await this.g(a);if(!d){this.f.error(`No bundle location found for extension ${a.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(d),s=JSON.parse(r);S=a.isBuiltin?s.contents?.bundle:s}catch(r){this.f.error(`Failed to load translations for ${a.identifier.value} from ${d}: ${r.message}`);return}S&&this.d.set(a.identifier.value,{contents:S,uri:d})}async g(a){if(a.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri(a.identifier.value,this.b);return P.URI.revive(S)}return a.l10n?P.URI.joinPath(a.extensionLocation,a.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$mqc=I,e.$mqc=I=Je([Ve(0,p.$AQ),Ve(1,o.$kQ),Ve(2,A.$ak)],I),e.$nqc=(0,O.$Fi)("IExtHostLocalizationService")}),define(Ne[216],Le([1,0,11,5,26,16,2,36]),function(ve,e,v,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Crc=void 0;let p=class extends v.$lk{constructor(y,a){super(a.logLevel,a.logsLocation,a.loggers.map(S=>(0,T.$ci)(S))),this.r=y.getProxy(R.$KN.MainThreadLogger)}$setLogLevel(y,a){a?this.setLogLevel(A.URI.revive(a),y):this.setLogLevel(y)}setVisibility(y,a){super.setVisibility(y,a),this.r.$setVisibility(y,a)}s(y,a,S){return new o(this.r,y,a,S)}};e.$Crc=p,e.$Crc=p=Je([Ve(0,O.$kQ),Ve(1,P.$AQ)],p);class o extends v.$gk{constructor(y,a,S,d){super(d?.logLevel==="always"),this.r=y,this.s=a,this.m=!1,this.n=[],this.setLevel(S),this.r.$createLogger(a,d).then(()=>{this.u(this.n),this.m=!0})}g(y,a){const S=[[y,a]];this.m?this.u(S):this.n.push(...S)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Ne[86],Le([1,0,5,3,4,16,22]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pqc=e.$oqc=void 0,e.$oqc=(0,R.$Fi)("IExtHostManagedSockets");let T=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(v.$KN.MainThreadManagedSockets)}setFactory(y,a){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(y,a),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const a=++this.b,S=await this.c.makeConnection(),d=new P.$Tc;return this.d.set(a,new o(a,S,d)),d.add((0,P.$Sc)(()=>this.d.delete(a))),d.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(a),d.dispose()})),d.add(S.onDidClose(r=>{this.a.$onDidManagedSocketClose(a,r?.stack??r?.message),d.dispose()})),d.add(S.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(a,A.$Ne.wrap(r)))),a}$remoteSocketWrite(y,a){this.d.get(y)?.actual.send(a.buffer)}$remoteSocketEnd(y){const a=this.d.get(y);a&&(a.actual.end(),a.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$pqc=T,e.$pqc=T=Je([Ve(0,O.$kQ)],T);class p{constructor(y,a){this.socketFactoryId=y,this.makeConnection=a}}class o extends P.$Uc{constructor(y,a,S){super(),this.socketId=y,this.actual=a,this.B(S)}}}),define(Ne[217],Le([1,0,5,11,24]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7qc=void 0;function O(T){return T&&T.title}let A=class{constructor(p,o){this.b=o,this.a=p.getProxy(v.$KN.MainThreadMessageService)}showMessage(p,o,I,y,a){const S={source:{identifier:p.identifier,label:p.displayName||p.name}};let d;typeof y=="string"||O(y)?d=[y,...a]:(S.modal=y?.modal,S.useCustom=y?.useCustom,S.detail=y?.detail,d=a),S.useCustom&&(0,P.$gH)(p,"resolvers");const r=[];let s=!1;for(let c=0;c<d.length;c++){const l=d[c];if(typeof l=="string")r.push({title:l,handle:c,isCloseAffordance:!1});else if(typeof l=="object"){const{title:i,isCloseAffordance:n}=l;r.push({title:i,isCloseAffordance:!!n,handle:c}),n&&(s?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,l):s=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,l)}return this.a.$showMessage(o,I,S,r).then(c=>{if(typeof c=="number")return d[c]})}};e.$7qc=A,e.$7qc=A=Je([Ve(1,R.$ak)],A)}),define(Ne[218],Le([1,0,4,14,2,24,5]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$drc=void 0;class T{constructor(o){this.b=new Map,this.a=o.getProxy(A.$KN.MainThreadProfileContentHandlers)}registerProfileContentHandler(o,I,y){if((0,O.$gH)(o,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,y),this.a.$registerProfileContentHandler(I,y.name,y.description,o.identifier.value),(0,v.$Sc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(o,I,y,a){const S=this.b.get(o);if(!S)throw new Error(`Unknown handler with id: ${o}`);return S.saveProfile(I,y,a)}async $readProfile(o,I,y){const a=this.b.get(o);if(!a)throw new Error(`Unknown handler with id: ${o}`);return a.readProfile((0,R.$eg)(I)?I:P.URI.revive(I),y)}}e.$drc=T}),define(Ne[87],Le([1,0,5,6,3]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kqc=e.$jqc=void 0;class O{constructor(T){this.b=new R.$le,this.onDidChangePassword=this.b.event,this.a=T.getProxy(v.$KN.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,p){return this.a.$getPassword(T,p)}store(T,p,o){return this.a.$setPassword(T,p,o)}delete(T,p){return this.a.$deletePassword(T,p)}}e.$jqc=O,e.$kqc=(0,P.$Fi)("IExtHostSecretState")}),define(Ne[219],Le([1,0,21,4,5]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$krc=void 0;class O{static{this.a=1}constructor(T){this.c=new Map,this.d=new Map,this.f=new Map,this.b=T.getProxy(P.$KN.MainThreadSpeech)}async $createSpeechToTextSession(T,p,o){const I=this.c.get(T);if(!I)return;const y=new R.$Tc,a=new v.$we;this.d.set(p,a);const S=await I.provideSpeechToTextSession(a.token,o?{language:o}:void 0);S&&(y.add(S.onDidChange(d=>{a.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,d)})),y.add(a.token.onCancellationRequested(()=>y.dispose())))}async $cancelSpeechToTextSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}async $createTextToSpeechSession(T,p,o){const I=this.c.get(T);if(!I)return;const y=new R.$Tc,a=new v.$we;this.d.set(p,a);const S=await I.provideTextToSpeechSession(a.token,o?{language:o}:void 0);S&&(this.f.set(p,S),y.add(S.onDidChange(d=>{a.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(p,d)})),y.add(a.token.onCancellationRequested(()=>y.dispose())))}async $synthesizeSpeech(T,p){this.f.get(T)?.synthesize(p)}async $cancelTextToSpeechSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T),this.f.delete(T)}async $createKeywordRecognitionSession(T,p){const o=this.c.get(T);if(!o)return;const I=new R.$Tc,y=new v.$we;this.d.set(p,y);const a=await o.provideKeywordRecognitionSession(y.token);a&&(I.add(a.onDidChange(S=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,S)})),I.add(y.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}registerProvider(T,p,o){const I=O.a++;return this.c.set(I,o),this.b.$registerProvider(I,p,{extension:T,displayName:T.value}),(0,R.$Sc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$krc=O}),define(Ne[88],Le([1,0,5,6,3]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aqc=e.$_pc=void 0;class O{constructor(T,p){this.c=p,this.b=new R.$le,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(v.$KN.MainThreadStorage)}registerExtensionStorageKeysToSync(T,p){this.a.$registerExtensionStorageKeysToSync(T,p)}async initializeExtensionStorage(T,p,o){const I=await this.a.$initializeExtensionStorage(T,p);let y;return I&&(y=this.d(T,p,I)),y||o}setValue(T,p,o){return this.a.$setValue(T,p,o)}$acceptValue(T,p,o){const I=this.d(T,p,o);I&&this.b.fire({shared:T,key:p,value:I})}d(T,p,o){try{return JSON.parse(o)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${T}): ${I}`)}}}e.$_pc=O,e.$aqc=(0,P.$Fi)("IExtHostStorage")}),define(Ne[220],Le([1,0,4,15,2,5]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wrc=void 0;class A{static{this.a=new Set([R.Schemas.http,R.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(O.$KN.MainThreadUriOpeners)}registerExternalUriOpener(p,o,I,y){if(this.c.has(o))throw new Error(`Opener with id '${o}' already registered`);const a=y.schemes.find(S=>!A.a.has(S));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this.c.set(o,I),this.b.$registerUriOpener(o,y.schemes,p,y.label),(0,v.$Sc)(()=>{this.c.delete(o),this.b.$unregisterUriOpener(o)})}async $canOpenUri(p,o,I){const y=this.c.get(p);if(!y)throw new Error(`Unknown opener with id: ${p}`);const a=P.URI.revive(o);return y.canOpenExternalUri(a,I)}async $openUri(p,o,I){const y=this.c.get(p);if(!y)throw new Error(`Unknown opener id: '${p}'`);return y.openExternalUri(P.URI.revive(o.resolvedUri),{sourceUri:P.URI.revive(o.sourceUri)},I)}}e.$wrc=A}),define(Ne[221],Le([1,0,5,2,4,13,18]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xrc=void 0;class T{static{this.a=0}constructor(o){this.c=new A.$sn,this.d=new Map,this.b=o.getProxy(v.$KN.MainThreadUrls)}registerUriHandler(o,I){const y=o.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const a=T.a++;return this.c.add(y),this.d.set(a,I),this.b.$registerUriHandler(a,y,o.displayName||o.name),(0,P.$Sc)(()=>{this.c.delete(y),this.d.delete(a),this.b.$unregisterUriHandler(a)})}$handleExternalUri(o,I){const y=this.d.get(o);if(!y)return Promise.resolve(void 0);try{y.handleUri(R.URI.revive(I))}catch(a){(0,O.$Y)(a)}return Promise.resolve(void 0)}async createAppUri(o){return R.URI.revive(await this.b.$createAppUri(o))}}e.$xrc=T}),define(Ne[222],Le([1,0,22,5]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wtb=O,e.$Xtb=T,R=qe(R);class P{constructor(){this.buffers=[]}add(o){let I=this.buffers.indexOf(o);return I<0&&(I=this.buffers.length,this.buffers.push(o)),I}}function O(p,o){if(o.serializeBuffersForPostMessage){const I=new P,a=JSON.stringify(p,(d,r)=>{if(r instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(r)};if(ArrayBuffer.isView(r)){const s=A(r);if(s)return{$$vscode_array_buffer_reference$$:!0,index:I.add(r.buffer),view:{type:s,byteLength:r.byteLength,byteOffset:r.byteOffset}}}return r}),S=I.buffers.map(d=>{const r=new Uint8Array(d);return v.$Ne.wrap(r)});return{message:a,buffers:S}}else return{message:JSON.stringify(p),buffers:[]}}function A(p){switch(p.constructor.name){case"Int8Array":return R.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return R.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return R.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return R.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return R.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return R.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return R.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return R.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return R.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return R.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return R.WebviewMessageArrayBufferViewType.BigUint64Array}}function T(p,o){const I=o.map(S=>{const d=new ArrayBuffer(S.byteLength);return new Uint8Array(d).set(S.buffer),d}),y=o.length?(S,d)=>{if(d&&typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const r=d,{index:s}=r,c=I[s];if(r.view)switch(r.view.type){case R.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(c,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(c,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(c,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(c,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(c,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(c,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(c,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(c,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(c,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(c,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(c,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return d}:void 0;return{message:JSON.parse(p,y),arrayBuffers:I}}}),define(Ne[67],Le([1,0,6,4,15,25,2,175,222,82,5]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ypc=e.$Wpc=void 0,e.$Xpc=a,e.$Zpc=r,e.$1pc=s,O=qe(O),I=qe(I);class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(n,t,g,u,$,m,h){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new v.$le,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new v.$le,this._onDidDispose=this.#h.event,this.#e=n,this.#t=t,this.#o=g,this.#n=u,this.#s=$,this.#r=m,this.#u=a(m),this.#d=S(m),this.#i=h}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#l=!0,(0,o.$HDb)(n,this.#n)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===P.Schemas.https||n.scheme===P.Schemas.http){let t=n.toString();return t.endsWith("/")||(t+="/"),t+" "+o.$GDb}return o.$GDb}get html(){return this.a(),this.#a}set html(n){this.a(),this.#a!==n&&(this.#a=n,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(n)))}get options(){return this.a(),this.#o}set options(n){this.a(),O.$io(this.#o,n)||this.#t.$setOptions(this.#e,s(this.#r,this.#s,n)),this.#o=n}async postMessage(n){if(this.#c)return!1;const t=(0,p.$Wtb)(n,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(n){if(!this.#d)return n;const t=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,g=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,$,m,h,E,D)=>{const b=A.URI.from({scheme:h||"file",path:decodeURIComponent(E)}),C=(0,o.$HDb)(b,{isRemote:t,authority:g}).toString();return`${$}${C}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,$,m,h,E,D)=>{const b=A.URI.from({scheme:h||"file",path:decodeURIComponent(E)}),C=(0,o.$HDb)(b,{isRemote:t,authority:g}).toString();return`${$}${C}${D}`})}}e.$Wpc=y;function a(i){try{const n=(0,T.$2p)((0,T.$1p)(i.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}function S(i){try{const n=(0,T.$2p)((0,T.$1p)(i.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class d extends R.$Uc{constructor(n,t,g,u,$){super(),this.c=t,this.f=g,this.g=u,this.h=$,this.b=new Map,this.a=n.getProxy(I.$KN.MainThreadWebviews)}dispose(){super.dispose();for(const n of this.b.values())n.dispose();this.b.clear()}$onMessage(n,t,g){const u=this.j(n);if(u){const{message:$}=(0,p.$Xtb)(t,g.value);u._onMessageEmitter.fire($)}}$onMissingCsp(n,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,t,g){const u=new y(n,this.a,c(t),this.c,this.f,g,this.h);this.b.set(n,u);const $=u._onDidDispose(()=>{$.dispose(),this.deleteWebview(n)});return u}deleteWebview(n){this.b.delete(n)}j(n){return this.b.get(n)}}e.$Ypc=d;function r(i){return{id:i.identifier,location:i.extensionLocation}}function s(i,n,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||l(i,n)}}function c(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(n=>A.URI.from(n))}}function l(i,n){return[...(n?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Ne[121],Le([1,0,6,15,12,2,3,16,5]),function(ve,e,v,R,P,O,A,T,p){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Arc=e.$zrc=void 0;let I=class{static{o=this}static{this.a={focused:!0,active:!0}}getState(){const a=this.d;return{get focused(){return a.focused},get active(){return a.active}}}constructor(a){this.c=new v.$le,this.onDidChangeWindowState=this.c.event,this.d=o.a,this.b=a.getProxy(p.$KN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:d})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(a){this.onDidChangeWindowProperty("focused",a)}$onDidChangeWindowActive(a){this.onDidChangeWindowProperty("active",a)}onDidChangeWindowProperty(a,S){S!==this.d[a]&&(this.d={...this.d,[a]:S},this.c.fire(this.d))}openUri(a,S){let d;if(typeof a=="string"){d=a;try{a=O.URI.parse(a)}catch{return Promise.reject(`Invalid uri - '${a}'`)}}return(0,P.$cf)(a.scheme)?Promise.reject("Invalid scheme - cannot be empty"):a.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${a.scheme}'`):this.b.$openUri(a,d,S)}async asExternalUri(a,S){if((0,P.$cf)(a.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(a,S);return O.URI.from(d)}};e.$zrc=I,e.$zrc=I=o=Je([Ve(0,T.$kQ)],I),e.$Arc=(0,A.$Fi)("IExtHostWindow")}),define(Ne[223],Le([1,0,212,26,16]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Otc=void 0;let O=class extends v.$Drc{constructor(T,p){super(T,p)}f(T,p,o){p.apply(console,o)}};e.$Otc=O,e.$Otc=O=Je([Ve(0,P.$kQ),Ve(1,R.$AQ)],O)}),define(Ne[224],Le([1,0,10,22,21,27,13,6,4,37,150,210,39]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=e.ResponsiveState=e.RequestInitiator=void 0,e.$Sdc=l,e.$Tdc=i,A=qe(A);function d(F,N){try{return JSON.stringify(F,N)}catch{return"null"}}const r="$$ref$$",s={[r]:-1};class c{constructor(N,L){this.jsonString=N,this.referencedBuffers=L}}function l(F,N=null,L=!1){const q=[];return{jsonString:(L?d:JSON.stringify)(F,(W,G)=>{if(typeof G>"u")return s;if(typeof G=="object"){if(G instanceof R.$Ne){const Q=q.push(G)-1;return{[r]:Q}}if(N)return N(W,G)}return G}),referencedBuffers:q}}function i(F,N,L){return JSON.parse(F,(q,H)=>{if(H){const W=H[r];if(typeof W=="number")return N[W];if(L&&H.$mid===o.MarshalledId.Uri)return L.transformIncoming(H)}return H})}function n(F,N){return JSON.stringify(F,N)}function t(F){return F?(N,L)=>L&&L.$mid===o.MarshalledId.Uri?F.transformOutgoing(L):L:null}var g;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(g||(e.RequestInitiator=g={}));var u;(function(F){F[F.Responsive=0]="Responsive",F[F.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const $=()=>{},m=Symbol.for("rpcProtocol"),h=Symbol.for("rpcProxy");class E extends p.$Uc{static{S=m}static{this.a=3*1e3}constructor(N,L=null,q=null){super(),this[S]=!0,this.b=this.B(new T.$le),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=L,this.g=q,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let H=0,W=a.$Uw.count;H<W;H++)this.m[H]=null,this.s[H]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=u.Responsive,this.z=0,this.C=0,this.D=this.B(new v.$Rh(()=>this.H(),1e3)),this.B(this.c.onMessage(H=>this.L(H)))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const L=this.w[N];delete this.w[N],L.resolveErr(A.$5())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+E.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+E.a,this.z--,this.z===0&&this.D.cancel(),this.I(u.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(u.Unresponsive):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,I.$Pn)(N,this.g):N}getProxy(N){const{nid:L,sid:q}=N;return this.s[L]||(this.s[L]=this.J(L,q)),this.s[L]}J(N,L){const q={get:(H,W)=>(typeof W=="string"&&!H[W]&&W.charCodeAt(0)===O.CharCode.DollarSign&&(H[W]=(...G)=>this.U(N,W,G)),W===h?L:H[W])};return new Proxy(Object.create(null),q)}set(N,L){return this.m[N.nid]=L,L}assertRegistered(N){for(let L=0,q=N.length;L<q;L++){const H=N[L];if(!this.m[H.nid])throw new Error(`Missing proxy instance ${H.sid}`)}}L(N){if(this.j)return;const L=N.byteLength,q=b.read(N,0),H=q.readUInt8(),W=q.readUInt32();switch(H){case f.RequestJSONArgs:case f.RequestJSONArgsWithCancellation:{let{rpcId:G,method:Q,args:ae}=k.deserializeRequestJSONArgs(q);this.g&&(ae=(0,I.$Pn)(ae,this.g)),this.M(L,W,G,Q,ae,H===f.RequestJSONArgsWithCancellation);break}case f.RequestMixedArgs:case f.RequestMixedArgsWithCancellation:{let{rpcId:G,method:Q,args:ae}=k.deserializeRequestMixedArgs(q);this.g&&(ae=(0,I.$Pn)(ae,this.g)),this.M(L,W,G,Q,ae,H===f.RequestMixedArgsWithCancellation);break}case f.Acknowledged:{this.f?.logIncoming(L,W,g.LocalSide,"ack"),this.G(W);break}case f.Cancel:{this.N(L,W);break}case f.ReplyOKEmpty:{this.O(L,W,void 0);break}case f.ReplyOKJSON:{let G=k.deserializeReplyOKJSON(q);this.g&&(G=(0,I.$Pn)(G,this.g)),this.O(L,W,G);break}case f.ReplyOKJSONWithBuffers:{const G=k.deserializeReplyOKJSONWithBuffers(q,this.g);this.O(L,W,G);break}case f.ReplyOKVSBuffer:{const G=k.deserializeReplyOKVSBuffer(q);this.O(L,W,G);break}case f.ReplyErrError:{let G=k.deserializeReplyErrError(q);this.g&&(G=(0,I.$Pn)(G,this.g)),this.P(L,W,G);break}case f.ReplyErrEmpty:{this.P(L,W,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,L,q,H,W,G){this.f?.logIncoming(N,L,g.OtherSide,`receiveRequest ${(0,a.$Ww)(q)}.${H}(`,W);const Q=String(L);let ae,be;if(G){const _=new P.$we;W.push(_.token),ae=this.Q(q,H,W),be=()=>_.cancel()}else ae=this.Q(q,H,W),be=$;this.u[Q]=be;const le=k.serializeAcknowledged(L);this.f?.logOutgoing(le.byteLength,L,g.OtherSide,"ack"),this.c.send(le),ae.then(_=>{delete this.u[Q];const ce=k.serializeReplyOK(L,_,this.h);this.f?.logOutgoing(ce.byteLength,L,g.OtherSide,"reply:",_),this.c.send(ce)},_=>{delete this.u[Q];const ce=k.serializeReplyErr(L,_);this.f?.logOutgoing(ce.byteLength,L,g.OtherSide,"replyErr:",_),this.c.send(ce)})}N(N,L){this.f?.logIncoming(N,L,g.OtherSide,"receiveCancel");const q=String(L);this.u[q]?.()}O(N,L,q){this.f?.logIncoming(N,L,g.LocalSide,"receiveReply:",q);const H=String(L);if(!this.w.hasOwnProperty(H))return;const W=this.w[H];delete this.w[H],W.resolveOk(q)}P(N,L,q){this.f?.logIncoming(N,L,g.LocalSide,"receiveReplyErr:",q);const H=String(L);if(!this.w.hasOwnProperty(H))return;const W=this.w[H];delete this.w[H];let G;q&&(q.$isError?(G=new Error,G.name=q.name,G.message=q.message,G.stack=q.stack):G=q),W.resolveErr(G)}Q(N,L,q){try{return Promise.resolve(this.S(N,L,q))}catch(H){return Promise.reject(H)}}S(N,L,q){const H=this.m[N];if(!H)throw new Error("Unknown actor "+(0,a.$Ww)(N));const W=H[L];if(typeof W!="function")throw new Error("Unknown method "+L+" on actor "+(0,a.$Ww)(N));return W.apply(H,q)}U(N,L,q){if(this.j)return new y.$Rdc;let H=null;if(q.length>0&&P.CancellationToken.isCancellationToken(q[q.length-1])&&(H=q.pop()),H&&H.isCancellationRequested)return Promise.reject(A.$5());const W=k.serializeRequestArguments(q,this.h),G=++this.t,Q=String(G),ae=new y.$Qdc,be=new p.$Tc;H&&be.add(H.onCancellationRequested(()=>{const _=k.serializeCancel(G);this.f?.logOutgoing(_.byteLength,G,g.LocalSide,"cancel"),this.c.send(k.serializeCancel(G))})),this.w[Q]=new D(ae,be),this.F(G);const le=k.serializeRequest(G,N,L,W,!!H);return this.f?.logOutgoing(le.byteLength,G,g.LocalSide,`request: ${(0,a.$Ww)(N)}.${L}(`,q),this.c.send(le),ae}}e.$Udc=E;class D{constructor(N,L){this.a=N,this.b=L}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class b{static alloc(N,L,q){const H=new b(R.$Ne.alloc(q+1+4),0);return H.writeUInt8(N),H.writeUInt32(L),H}static read(N,L){return new b(N,L)}get buffer(){return this.a}constructor(N,L){this.a=N,this.b=L}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const q=this.a.slice(this.b,this.b+N).toString();return this.b+=N,q}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+N).toString();return this.b+=N,q}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const L=this.a.slice(this.b,this.b+N);return this.b+=N,L}static sizeMixedArray(N){let L=0;L+=1;for(let q=0,H=N.length;q<H;q++){const W=N[q];switch(L+=1,W.type){case w.String:L+=this.sizeLongString(W.value);break;case w.VSBuffer:L+=this.sizeVSBuffer(W.value);break;case w.SerializedObjectWithBuffers:L+=this.sizeUInt32,L+=this.sizeLongString(W.value);for(let G=0;G<W.buffers.length;++G)L+=this.sizeVSBuffer(W.buffers[G]);break;case w.Undefined:break}}return L}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let L=0,q=N.length;L<q;L++){const H=N[L];switch(H.type){case w.String:this.writeUInt8(w.String),this.writeLongString(H.value);break;case w.VSBuffer:this.writeUInt8(w.VSBuffer),this.writeVSBuffer(H.value);break;case w.SerializedObjectWithBuffers:this.writeUInt8(w.SerializedObjectWithBuffers),this.writeUInt32(H.buffers.length),this.writeLongString(H.value);for(let W=0;W<H.buffers.length;++W)this.writeBuffer(H.buffers[W]);break;case w.Undefined:this.writeUInt8(w.Undefined);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const L=new Array(N);for(let q=0;q<N;q++)switch(this.readUInt8()){case w.String:L[q]=this.readLongString();break;case w.VSBuffer:L[q]=this.readVSBuffer();break;case w.SerializedObjectWithBuffers:{const W=this.readUInt32(),G=this.readLongString(),Q=[];for(let ae=0;ae<W;++ae)Q.push(this.readVSBuffer());L[q]=new a.$Xw(i(G,Q,null));break}case w.Undefined:L[q]=void 0;break}return L}}var C;(function(F){F[F.Simple=0]="Simple",F[F.Mixed=1]="Mixed"})(C||(C={}));class k{static a(N){for(let L=0,q=N.length;L<q;L++)if(N[L]instanceof R.$Ne||N[L]instanceof a.$Xw||typeof N[L]>"u")return!0;return!1}static serializeRequestArguments(N,L){if(this.a(N)){const q=[];for(let H=0,W=N.length;H<W;H++){const G=N[H];if(G instanceof R.$Ne)q[H]={type:w.VSBuffer,value:G};else if(typeof G>"u")q[H]={type:w.Undefined};else if(G instanceof a.$Xw){const{jsonString:Q,referencedBuffers:ae}=l(G.value,L);q[H]={type:w.SerializedObjectWithBuffers,value:R.$Ne.fromString(Q),buffers:ae}}else q[H]={type:w.String,value:R.$Ne.fromString(n(G,L))}}return{type:C.Mixed,args:q}}return{type:C.Simple,args:n(N,L)}}static serializeRequest(N,L,q,H,W){switch(H.type){case C.Simple:return this.b(N,L,q,H.args,W);case C.Mixed:return this.c(N,L,q,H.args,W)}}static b(N,L,q,H,W){const G=R.$Ne.fromString(q),Q=R.$Ne.fromString(H);let ae=0;ae+=b.sizeUInt8(),ae+=b.sizeShortString(G),ae+=b.sizeLongString(Q);const be=b.alloc(W?f.RequestJSONArgsWithCancellation:f.RequestJSONArgs,N,ae);return be.writeUInt8(L),be.writeShortString(G),be.writeLongString(Q),be.buffer}static deserializeRequestJSONArgs(N){const L=N.readUInt8(),q=N.readShortString(),H=N.readLongString();return{rpcId:L,method:q,args:JSON.parse(H)}}static c(N,L,q,H,W){const G=R.$Ne.fromString(q);let Q=0;Q+=b.sizeUInt8(),Q+=b.sizeShortString(G),Q+=b.sizeMixedArray(H);const ae=b.alloc(W?f.RequestMixedArgsWithCancellation:f.RequestMixedArgs,N,Q);return ae.writeUInt8(L),ae.writeShortString(G),ae.writeMixedArray(H),ae.buffer}static deserializeRequestMixedArgs(N){const L=N.readUInt8(),q=N.readShortString(),H=N.readMixedArray(),W=new Array(H.length);for(let G=0,Q=H.length;G<Q;G++){const ae=H[G];typeof ae=="string"?W[G]=JSON.parse(ae):W[G]=ae}return{rpcId:L,method:q,args:W}}static serializeAcknowledged(N){return b.alloc(f.Acknowledged,N,0).buffer}static serializeCancel(N){return b.alloc(f.Cancel,N,0).buffer}static serializeReplyOK(N,L,q){if(typeof L>"u")return this.d(N);if(L instanceof R.$Ne)return this.e(N,L);if(L instanceof a.$Xw){const{jsonString:H,referencedBuffers:W}=l(L.value,q,!0);return this.g(N,H,W)}else return this.f(N,d(L,q))}static d(N){return b.alloc(f.ReplyOKEmpty,N,0).buffer}static e(N,L){let q=0;q+=b.sizeVSBuffer(L);const H=b.alloc(f.ReplyOKVSBuffer,N,q);return H.writeVSBuffer(L),H.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,L){const q=R.$Ne.fromString(L);let H=0;H+=b.sizeLongString(q);const W=b.alloc(f.ReplyOKJSON,N,H);return W.writeLongString(q),W.buffer}static g(N,L,q){const H=R.$Ne.fromString(L);let W=0;W+=b.sizeUInt32,W+=b.sizeLongString(H);for(const Q of q)W+=b.sizeVSBuffer(Q);const G=b.alloc(f.ReplyOKJSONWithBuffers,N,W);G.writeUInt32(q.length),G.writeLongString(H);for(const Q of q)G.writeBuffer(Q);return G.buffer}static deserializeReplyOKJSON(N){const L=N.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(N,L){const q=N.readUInt32(),H=N.readLongString(),W=[];for(let G=0;G<q;++G)W.push(N.readVSBuffer());return new a.$Xw(i(H,W,L))}static serializeReplyErr(N,L){const q=L?d(A.$1(L),null):void 0;if(typeof q!="string")return this.h(N);const H=R.$Ne.fromString(q);let W=0;W+=b.sizeLongString(H);const G=b.alloc(f.ReplyErrError,N,W);return G.writeLongString(H),G.buffer}static deserializeReplyErrError(N){const L=N.readLongString();return JSON.parse(L)}static h(N){return b.alloc(f.ReplyErrEmpty,N,0).buffer}}var f;(function(F){F[F.RequestJSONArgs=1]="RequestJSONArgs",F[F.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",F[F.RequestMixedArgs=3]="RequestMixedArgs",F[F.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",F[F.Acknowledged=5]="Acknowledged",F[F.Cancel=6]="Cancel",F[F.ReplyOKEmpty=7]="ReplyOKEmpty",F[F.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",F[F.ReplyOKJSON=9]="ReplyOKJSON",F[F.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",F[F.ReplyErrError=11]="ReplyErrError",F[F.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var w;(function(F){F[F.String=1]="String",F[F.VSBuffer=2]="VSBuffer",F[F.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",F[F.Undefined=4]="Undefined"})(w||(w={}))}),define(Ne[225],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qtc=void 0;const v=function(O){const A=T=>{globalThis.removeEventListener("message",A);const p=T.data;Object.defineProperties(globalThis,{postMessage:{value(o,I){p.postMessage(o,I)}},onmessage:{get(){return p.onmessage},set(o){p.onmessage=o}}}),p.addEventListener("message",o=>{globalThis.dispatchEvent(new MessageEvent("message",{data:o.data,ports:o.ports?[...o.ports]:void 0}))}),p.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",A)}.toString();class R extends EventTarget{constructor(O,A,T){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const p=`((${v})('${A}'))`,o=new Blob([p],{type:"application/javascript"}),I=URL.createObjectURL(o),y=new MessageChannel,a=I,S={type:"_newWorker",id:a,port:y.port2,url:I,options:T};O(S,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{O({type:"_terminateWorker",id:a}),URL.revokeObjectURL(I),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(d){y.port1.onmessage=d}},onmessageerror:{get(){return y.port1.onmessageerror},set(d){y.port1.onmessageerror=d}}}),y.port1.addEventListener("messageerror",d=>{const r=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(r)}),y.port1.addEventListener("message",d=>{const r=new MessageEvent("message",{data:d.data});this.dispatchEvent(r)}),y.port1.start()}}e.$Qtc=R}),define(Ne[226],Le([1,0,22,28,15,60,3]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uL=e.$rL=void 0,e.$sL=I,e.$tL=y,e.$rL=(0,A.$Fi)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${T.join("")}]+`),o=7;function I(S){if(S.scheme!==P.Schemas.vscodeNotebookCell)return;const d=S.fragment.indexOf("s");if(d<0)return;const r=parseInt(S.fragment.substring(0,d).replace(p,""),o),s=(0,v.$7e)(S.fragment.substring(d+1)).toString();if(!isNaN(r))return{handle:r,notebook:S.with({scheme:s,fragment:null})}}function y(S,d){const r=d.toString(o),c=`${r.length<T.length?T[r.length-1]:"z"}${r}s${(0,v.$8e)(v.$Ne.fromString(S.scheme),!0,!0)}`;return S.with({scheme:P.Schemas.vscodeNotebookCell,fragment:c})}class a{constructor(){this.a=new R.$Ac}getNotebook(d){if(d.scheme===P.Schemas.vscodeNotebookCell){const r=I(d);if(r){const s=this.a.get(r.notebook);if(s)return s}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$uL=a,(0,O.$Rs)(e.$rL,a,O.InstantiationType.Delayed)}),define(Ne[89],Le([1,0,22,41,40,72,15,19,20,31,226]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=e.$LL=e.CellStatusbarAlignment=e.$KL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$HL=e.$GL=e.$EL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$DL=e.$CL=e.$BL=e.$AL=e.CellKind=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=void 0,e.$FL=u,e.$IL=h,e.$JL=E,e.$ML=C,e.$NL=f,R=qe(R),e.$vL="workbench.editor.notebook",e.$wL="workbench.editor.notebookTextDiffEditor",e.$xL="workbench.editor.interactive",e.$yL="workbench.editor.repl",e.$zL="replNotebook.input.execute";var y;(function(Q){Q[Q.Markup=1]="Markup",Q[Q.Code=2]="Code"})(y||(e.CellKind=y={})),e.$AL=["application/json","application/javascript","text/html","image/svg+xml",O.$$s.latex,O.$$s.markdown,"image/png","image/jpeg",O.$$s.text],e.$BL=[O.$$s.latex,O.$$s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$$s.text],e.$CL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$DL="_notAvailable";var a;(function(Q){Q[Q.Running=1]="Running",Q[Q.Idle=2]="Idle"})(a||(e.NotebookRunState=a={}));var S;(function(Q){Q[Q.Unconfirmed=1]="Unconfirmed",Q[Q.Pending=2]="Pending",Q[Q.Executing=3]="Executing"})(S||(e.NotebookCellExecutionState=S={}));var d;(function(Q){Q[Q.Unconfirmed=1]="Unconfirmed",Q[Q.Pending=2]="Pending",Q[Q.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var r;(function(Q){Q[Q.WithHardKernelDependency=0]="WithHardKernelDependency",Q[Q.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",Q[Q.Pure=2]="Pure",Q[Q.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var s;(function(Q){Q.Always="always",Q.Never="never",Q.Optional="optional"})(s||(e.RendererMessagingSpec=s={}));var c;(function(Q){Q[Q.ModelChange=1]="ModelChange",Q[Q.Move=2]="Move",Q[Q.ChangeCellLanguage=5]="ChangeCellLanguage",Q[Q.Initialize=6]="Initialize",Q[Q.ChangeCellMetadata=7]="ChangeCellMetadata",Q[Q.Output=8]="Output",Q[Q.OutputItem=9]="OutputItem",Q[Q.ChangeCellContent=10]="ChangeCellContent",Q[Q.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",Q[Q.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",Q[Q.ChangeCellMime=13]="ChangeCellMime",Q[Q.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var l;(function(Q){Q[Q.Handle=0]="Handle",Q[Q.Index=1]="Index"})(l||(e.SelectionStateType=l={}));var i;(function(Q){Q[Q.Replace=1]="Replace",Q[Q.Output=2]="Output",Q[Q.Metadata=3]="Metadata",Q[Q.CellLanguage=4]="CellLanguage",Q[Q.DocumentMetadata=5]="DocumentMetadata",Q[Q.Move=6]="Move",Q[Q.OutputItems=7]="OutputItems",Q[Q.PartialMetadata=8]="PartialMetadata",Q[Q.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(Q){Q.scheme=A.Schemas.vscodeNotebookCell;function ae(oe,ke){return(0,I.$tL)(oe,ke)}Q.generate=ae;function be(oe){return(0,I.$sL)(oe)}Q.parse=be;function le(oe,ke){return oe.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ke??""},${oe.scheme!==A.Schemas.file?oe.scheme:""}`})}Q.generateCellOutputUri=le;function _(oe){if(oe.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ke=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!ke)return;const Te=ke[1]&&ke[1]!==""?ke[1]:void 0,Y=ke[2];return{outputId:Te,notebook:oe.with({scheme:Y||A.Schemas.file,fragment:null})}}Q.parseCellOutputUri=_;function ce(oe,ke,Te){return Q.generate(oe,ke).with({scheme:Te})}Q.generateCellPropertyUri=ce;function me(oe,ke){if(oe.scheme===ke)return Q.parse(oe.with({scheme:Q.scheme}))}Q.parseCellPropertyUri=me})(n||(e.CellUri=n={}));const t=Q=>p.$j?Q.replace(/\//g,"\\"):Q;class g{constructor(ae=[],be=e.$AL){this.e=be,this.d=[...new Set(ae)].map(le=>({pattern:le,matches:R.$Ak(t(le))}))}sort(ae){const be=new Map(P.Iterable.map(ae,_=>[_,t(_)]));let le=[];for(const{matches:_}of this.d)for(const[ce,me]of be)if(_(me)){le.push(ce),be.delete(ce);break}return be.size&&(le=le.concat([...be.keys()].sort((_,ce)=>this.e.indexOf(_)-this.e.indexOf(ce)))),le}prioritize(ae,be){const le=this.f(ae);if(le===-1){this.d.unshift({pattern:ae,matches:R.$Ak(t(ae))});return}const _=new Set(be.map(me=>this.f(me,le)));_.delete(-1);const ce=Array.from(_).sort();this.d.splice(le+1,0,...ce.map(me=>this.d[me]));for(let me=ce.length-1;me>=0;me--)this.d.splice(ce[me],1)}toArray(){return this.d.map(ae=>ae.pattern)}f(ae,be=this.d.length){const le=t(ae);for(let _=0;_<be;_++)if(this.d[_].matches(le))return _;return-1}}e.$EL=g;function u(Q,ae,be,le=(_,ce)=>_===ce){const _=[];function ce(ke,Te,Y){if(Te===0&&Y.length===0)return;const B=_[_.length-1];B&&B.start+B.deleteCount===ke?(B.deleteCount+=Te,B.toInsert.push(...Y)):_.push({start:ke,deleteCount:Te,toInsert:Y})}let me=0,oe=0;for(;;){if(me===Q.length){ce(me,0,ae.slice(oe));break}if(oe===ae.length){ce(me,Q.length-me,[]);break}const ke=Q[me],Te=ae[oe];if(le(ke,Te)){me+=1,oe+=1;continue}be(Te)?(ce(me,1,[]),me+=1):(ce(me,0,[Te]),oe+=1)}return _}e.$GL=new o.$Wj("notebookEditorCursorAtBoundary","none"),e.$HL=new o.$Wj("notebookEditorCursorAtLineBoundary","none");var $;(function(Q){Q.default="default",Q.option="option"})($||(e.NotebookEditorPriority=$={}));var m;(function(Q){Q.Cells="cells",Q.Text="text",Q.None="none"})(m||(e.NotebookFindScopeType=m={}));function h(Q){const ae=Q;return!!((typeof ae.include=="string"||R.$Bk(ae.include))&&(typeof ae.exclude=="string"||R.$Bk(ae.exclude)))}function E(Q,ae,be){if(Array.isArray(Q.viewType)&&Q.viewType.indexOf(ae)>=0||Q.viewType===ae)return!0;if(Q.filenamePattern){const le=h(Q.filenamePattern)?Q.filenamePattern.include:Q.filenamePattern,_=h(Q.filenamePattern)?Q.filenamePattern.exclude:void 0;if(R.$zk(le,(0,T.$nc)(be.fsPath).toLowerCase()))return!(_&&R.$zk(_,(0,T.$nc)(be.fsPath).toLowerCase()))}return!1}e.$KL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var D;(function(Q){Q[Q.Left=1]="Left",Q[Q.Right=2]="Right"})(D||(e.CellStatusbarAlignment=D={}));class b{static{this.d="notebook/"}static create(ae){return`${b.d}${ae}`}static parse(ae){if(ae.startsWith(b.d))return ae.substring(b.d.length)}}e.$LL=b;function C(Q){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(Q)}const k=new TextDecoder;function f(Q){const ae=[];let be=!1;for(const me of Q)(ae.length===0||be)&&(ae.push(me),be=!0);let le=N(ae);const _=v.$Ne.concat(ae.map(me=>v.$Ne.wrap(me))),ce=G(_);return le=le||ce.byteLength!==_.byteLength,{data:ce,didCompression:le}}e.$OL="\x1B[A";const w=e.$OL.split("").map(Q=>Q.charCodeAt(0)),F=10;function N(Q){let ae=!1;return Q.forEach((be,le)=>{if(le===0||be.length<e.$OL.length)return;const _=Q[le-1],ce=be.subarray(0,e.$OL.length);if(ce[0]===w[0]&&ce[1]===w[1]&&ce[2]===w[2]){const me=_.lastIndexOf(F);if(me===-1)return;ae=!0,Q[le-1]=_.subarray(0,me),Q[le]=be.subarray(e.$OL.length)}}),ae}function L(Q){let ae=Q;do Q=ae,ae=Q.replace(/[^\n]\x08/gm,"");while(ae.length<Q.length);return Q}function q(Q){for(Q=Q.replace(/\r+\n/gm,`
`);Q.search(/\r[^$]/g)>-1;){const ae=Q.match(/^(.*)\r+/m)[1];let be=Q.match(/\r+(.*)$/m)[1];be=be+ae.slice(be.length,ae.length),Q=Q.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,be)}return Q}const H=8,W=13;function G(Q){return!Q.buffer.includes(H)&&!Q.buffer.includes(W)?Q:v.$Ne.fromString(q(L(k.decode(Q.buffer))))}}),define(Ne[7],Le([1,0,17,13,59,28,72,12,14,2,38,18,29,109,89]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d){"use strict";var r,s,c,l,i,n,t,g,u,$,m,h,E,D,b,C,k;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$_P=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$$P=e.$0P=e.$9P=e.$8P=e.$7P=e.$6P=e.$5P=e.$4P=e.LanguageModelChatMessageRole=e.$3P=e.$2P=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.$1P=e.$ZP=e.$YP=e.$XP=e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.$PP=e.$OP=e.$NP=e.$MP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$LP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$KP=e.$JP=e.$IP=e.$HP=e.$GP=e.$FP=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$yP=e.$xP=e.$wP=e.$vP=e.$tP=e.$sP=e.$rP=e.$qP=e.$pP=e.TestRunProfileKind=e.TestResultState=e.$oP=e.$nP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$mP=e.NotebookVariablesRequestKind=e.$lP=e.$kP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$jP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.ColorThemeKind=e.$dP=e.$cP=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$bP=e.QuickInputButtonLocation=e.$aP=e.DebugConsoleMode=e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$7O=e.$6O=e.FileChangeType=e.$5O=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$4O=e.$3O=e.$2O=e.$1O=e.InlineCompletionTriggerKind=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$NO=e.ConfigurationTarget=e.$MO=e.$LO=e.$KO=e.$JO=e.DocumentPasteTriggerKind=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$CO=e.ViewBadge=e.ProgressLocation=e.$BO=e.$AO=e.TaskScope=e.ShellQuoting=e.$zO=e.$yO=e.$xO=e.TaskPanelKind=e.TaskRevealKind=e.$wO=e.TerminalLocation=e.$vO=e.$uO=e.$tO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$sO=e.$rO=e.$qO=e.$pO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$nO=e.$mO=e.$lO=e.$kO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$jO=e.$iO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.LanguageStatusSeverity=e.$cO=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.CodeActionTriggerKind=e.$9N=e.$8N=e.SymbolTag=e.SymbolKind=e.$7N=e.$6N=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.DiagnosticSeverity=e.DiagnosticTag=e.$ZN=e.$YN=e.FileEditType=e.$XN=e.$WN=e.$VN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$UN=e.$TN=e.$SN=e.$PN=e.$ON=e.$NN=e.$MN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$QN=W,e.$RN=G,e.$oO=wt,e.$OO=Li,e.$uP=Rn;function f(z){return Object.assign(z,{apply:function(...se){if(se.length===0)return Reflect.construct(z,[]);{const Se=se.length===1?[]:se[1];return Reflect.construct(z,Se,se[0].constructor)}},call:function(...se){if(se.length===0)return Reflect.construct(z,[]);{const[Se,...He]=se;return Reflect.construct(z,He,Se.constructor)}}})}var w;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(w||(e.TerminalOutputAnchor=w={}));var F;(function(z){z[z.TerminalCommand=0]="TerminalCommand",z[z.Opener=1]="Opener",z[z.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let N=r=class{static from(...M){let se=M;return new r(function(){if(se){for(const Se of se)Se&&typeof Se.dispose=="function"&&Se.dispose();se=void 0}})}#e;constructor(M){this.#e=M}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$MN=N,e.$MN=N=r=Je([f],N);let L=s=class{static Min(...M){if(M.length===0)throw new TypeError;let se=M[0];for(let Se=1;Se<M.length;Se++){const He=M[Se];He.isBefore(se)&&(se=He)}return se}static Max(...M){if(M.length===0)throw new TypeError;let se=M[0];for(let Se=1;Se<M.length;Se++){const He=M[Se];He.isAfter(se)&&(se=He)}return se}static isPosition(M){if(!M)return!1;if(M instanceof s)return!0;const{line:se,character:Se}=M;return typeof se=="number"&&typeof Se=="number"}static of(M){if(M instanceof s)return M;if(this.isPosition(M))return new s(M.line,M.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(M,se){if(M<0)throw(0,R.$6)("line must be non-negative");if(se<0)throw(0,R.$6)("character must be non-negative");this.c=M,this.e=se}isBefore(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<M.e}isBeforeOrEqual(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<=M.e}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this.c===M.c&&this.e===M.e}compareTo(M){return this.c<M.c?-1:this.c>M.line?1:this.e<M.e?-1:this.e>M.e?1:0}translate(M,se=0){if(M===null||se===null)throw(0,R.$6)();let Se;return typeof M>"u"?Se=0:typeof M=="number"?Se=M:(Se=typeof M.lineDelta=="number"?M.lineDelta:0,se=typeof M.characterDelta=="number"?M.characterDelta:0),Se===0&&se===0?this:new s(this.line+Se,this.character+se)}with(M,se=this.character){if(M===null||se===null)throw(0,R.$6)();let Se;return typeof M>"u"?Se=this.line:typeof M=="number"?Se=M:(Se=typeof M.line=="number"?M.line:this.line,se=typeof M.character=="number"?M.character:this.character),Se===this.line&&se===this.character?this:new s(Se,se)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$NN=L,e.$NN=L=s=Je([f],L);let q=c=class{static isRange(M){return M instanceof c?!0:M?L.isPosition(M.start)&&L.isPosition(M.end):!1}static of(M){if(M instanceof c)return M;if(this.isRange(M))return new c(M.start,M.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(M,se,Se,He){let it,dt;if(typeof M=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof He=="number"?(it=new L(M,se),dt=new L(Se,He)):L.isPosition(M)&&L.isPosition(se)&&(it=L.of(M),dt=L.of(se)),!it||!dt)throw new Error("Invalid arguments");it.isBefore(dt)?(this.c=it,this.e=dt):(this.c=dt,this.e=it)}contains(M){return c.isRange(M)?this.contains(M.start)&&this.contains(M.end):L.isPosition(M)?!(L.of(M).isBefore(this.c)||this.e.isBefore(M)):!1}isEqual(M){return this.c.isEqual(M.c)&&this.e.isEqual(M.e)}intersection(M){const se=L.Max(M.start,this.c),Se=L.Min(M.end,this.e);if(!se.isAfter(Se))return new c(se,Se)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const se=L.Min(M.start,this.c),Se=L.Max(M.end,this.end);return new c(se,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(M,se=this.end){if(M===null||se===null)throw(0,R.$6)();let Se;return M?L.isPosition(M)?Se=M:(Se=M.start||this.start,se=M.end||this.end):Se=this.start,Se.isEqual(this.c)&&se.isEqual(this.end)?this:new c(Se,se)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return W(this)}};e.$ON=q,e.$ON=q=c=Je([f],q);let H=l=class extends q{static isSelection(M){return M instanceof l?!0:M?q.isRange(M)&&L.isPosition(M.anchor)&&L.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(M,se,Se,He){let it,dt;if(typeof M=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof He=="number"?(it=new L(M,se),dt=new L(Se,He)):L.isPosition(M)&&L.isPosition(se)&&(it=L.of(M),dt=L.of(se)),!it||!dt)throw new Error("Invalid arguments");super(it,dt),this.f=it,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return G(this)}};e.$PN=H,e.$PN=H=l=Je([f],H);function W(z){return z.isEmpty?`[${z.start.line}:${z.start.character})`:`[${z.start.line}:${z.start.character} -> ${z.end.line}:${z.end.character})`}function G(z){let M=W(z);return z.isEmpty||(z.active.isEqual(z.start)?M=`|${M}`:M=`${M}|`),M}const Q=z=>{if(typeof z!="string"||z.length===0||!/^[0-9A-Za-z_\-]+$/.test(z))throw(0,R.$6)("connectionToken")};class ae{static isResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.host=="string"&&typeof M.port=="number"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,se,Se){if(typeof M!="string"||M.length===0)throw(0,R.$6)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,R.$6)("port");typeof Se<"u"&&Q(Se),this.host=M,this.port=Math.round(se),this.connectionToken=Se}}e.$SN=ae;class be{static isManagedResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.makeConnection=="function"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,se){this.makeConnection=M,this.connectionToken=se,typeof se<"u"&&Q(se)}}e.$TN=be;class le extends Error{static NotAvailable(M,se){return new le(M,S.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(M){return new le(M,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(M,se=S.RemoteAuthorityResolverErrorCode.Unknown,Se){super(M),this._message=M,this._code=se,this._detail=Se,Object.setPrototypeOf(this,le.prototype)}}e.$UN=le;var _;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(_||(e.EndOfLine=_={}));var ce;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(ce||(e.EnvironmentVariableMutatorType=ce={}));let me=i=class{static isTextEdit(M){return M instanceof i?!0:M?q.isRange(M)&&typeof M.newText=="string":!1}static replace(M,se){return new i(M,se)}static insert(M,se){return i.replace(new q(M,M),se)}static delete(M){return i.replace(M,"")}static setEndOfLine(M){const se=new i(new q(new L(0,0),new L(0,0)),"");return se.newEol=M,se}get range(){return this.c}set range(M){if(M&&!q.isRange(M))throw(0,R.$6)("range");this.c=M}get newText(){return this.e||""}set newText(M){if(M&&typeof M!="string")throw(0,R.$6)("newText");this.e=M}get newEol(){return this.f}set newEol(M){if(M&&typeof M!="number")throw(0,R.$6)("newEol");this.f=M}constructor(M,se){this.c=M,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$VN=me,e.$VN=me=i=Je([f],me);let oe=n=class{static isNotebookCellEdit(M){return M instanceof n?!0:M?yi.isNotebookRange(M)&&Array.isArray(M.newCells):!1}static replaceCells(M,se){return new n(M,se)}static insertCells(M,se){return new n(new yi(M,M),se)}static deleteCells(M){return new n(M,[])}static updateCellMetadata(M,se){const Se=new n(new yi(M,M),[]);return Se.newCellMetadata=se,Se}static updateNotebookMetadata(M){const se=new n(new yi(0,0),[]);return se.newNotebookMetadata=M,se}constructor(M,se){this.range=M,this.newCells=se}};e.$WN=oe,e.$WN=oe=n=Je([f],oe);class ke{static isSnippetTextEdit(M){return M instanceof ke?!0:M?q.isRange(M.range)&&B.isSnippetString(M.snippet):!1}static replace(M,se){return new ke(M,se)}static insert(M,se){return ke.replace(new q(M,M),se)}constructor(M,se){this.range=M,this.snippet=se}}e.$XN=ke;var Te;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Te||(e.FileEditType=Te={}));let Y=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(M,se,Se,He){this.c.push({_type:Te.File,from:M,to:se,options:Se,metadata:He})}createFile(M,se,Se){this.c.push({_type:Te.File,from:void 0,to:M,options:se,metadata:Se})}deleteFile(M,se,Se){this.c.push({_type:Te.File,from:M,to:void 0,options:se,metadata:Se})}e(M,se,Se){this.c.push({_type:Te.Cell,metadata:Se,uri:M,edit:{editType:d.CellEditType.DocumentMetadata,metadata:se},notebookMetadata:se})}f(M,se,Se,He){const it=se.start,dt=se.end;(it!==dt||Se.length>0)&&this.c.push({_type:Te.CellReplace,uri:M,index:it,count:dt-it,cells:Se,metadata:He})}g(M,se,Se,He){this.c.push({_type:Te.Cell,metadata:He,uri:M,edit:{editType:d.CellEditType.Metadata,index:se,metadata:Se}})}replace(M,se,Se,He){this.c.push({_type:Te.Text,uri:M,edit:new me(se,Se),metadata:He})}insert(M,se,Se,He){this.replace(M,new q(se,se),Se,He)}delete(M,se,Se){this.replace(M,se,"",Se)}has(M){return this.c.some(se=>se._type===Te.Text&&se.uri.toString()===M.toString())}set(M,se){if(se)for(const Se of se){if(!Se)continue;let He,it;Array.isArray(Se)?(He=Se[0],it=Se[1]):He=Se,oe.isNotebookCellEdit(He)?He.newCellMetadata?this.g(M,He.range.start,He.newCellMetadata,it):He.newNotebookMetadata?this.e(M,He.newNotebookMetadata,it):this.f(M,He.range,He.newCells,it):ke.isSnippetTextEdit(He)?this.c.push({_type:Te.Snippet,uri:M,range:He.range,edit:He.snippet,metadata:it}):this.c.push({_type:Te.Text,uri:M,edit:He,metadata:it})}else{for(let Se=0;Se<this.c.length;Se++){const He=this.c[Se];switch(He._type){case Te.Text:case Te.Snippet:case Te.Cell:case Te.CellReplace:He.uri.toString()===M.toString()&&(this.c[Se]=void 0);break}}(0,v.$Hb)(this.c)}}get(M){const se=[];for(const Se of this.c)Se._type===Te.Text&&Se.uri.toString()===M.toString()&&se.push(Se.edit);return se}entries(){const M=new O.$Ac;for(const se of this.c)if(se._type===Te.Text){let Se=M.get(se.uri);Se||(Se=[se.uri,[]],M.set(se.uri,Se)),Se[1].push(se.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$YN=Y,e.$YN=Y=Je([f],Y);let B=t=class{static isSnippetString(M){return M instanceof t?!0:M?typeof M.value=="string":!1}static c(M){return M.replace(/\$|}|\\/g,"\\$&")}constructor(M){this.e=1,this.value=M||""}appendText(M){return this.value+=t.c(M),this}appendTabstop(M=this.e++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,se=this.e++){if(typeof M=="function"){const Se=new t;Se.e=this.e,M(Se),this.e=Se.e,M=Se.value}else M=t.c(M);return this.value+="${",this.value+=se,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,se=this.e++){const Se=M.map(He=>He.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(M,se){if(typeof se=="function"){const Se=new t;Se.e=this.e,se(Se),this.e=Se.e,se=Se.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.$ZN=B,e.$ZN=B=t=Je([f],B);var ne;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(ne||(e.DiagnosticTag=ne={}));var Ee;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(Ee||(e.DiagnosticSeverity=Ee={}));let fe=g=class{static isLocation(M){return M instanceof g?!0:M?q.isRange(M.range)&&o.URI.isUri(M.uri):!1}constructor(M,se){if(this.uri=M,se)if(q.isRange(se))this.range=q.of(se);else if(L.isPosition(se))this.range=new q(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$1N=fe,e.$1N=fe=g=Je([f],fe);let we=class{static is(M){return M?typeof M.message=="string"&&M.location&&q.isRange(M.location.range)&&o.URI.isUri(M.location.uri):!1}constructor(M,se){this.location=M,this.message=se}static isEqual(M,se){return M===se?!0:!M||!se?!1:M.message===se.message&&M.location.range.isEqual(se.location.range)&&M.location.uri.toString()===se.location.uri.toString()}};e.$2N=we,e.$2N=we=Je([f],we);let he=class{constructor(M,se,Se=Ee.Error){if(!q.isRange(M))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=M,this.message=se,this.severity=Se}toJSON(){return{severity:Ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,se){return M===se?!0:!M||!se?!1:M.message===se.message&&M.severity===se.severity&&M.code===se.code&&M.severity===se.severity&&M.source===se.source&&M.range.isEqual(se.range)&&(0,v.$tb)(M.tags,se.tags)&&(0,v.$tb)(M.relatedInformation,se.relatedInformation,we.isEqual)}};e.$3N=he,e.$3N=he=Je([f],he);let X=class{constructor(M,se){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=se}};e.$4N=X,e.$4N=X=Je([f],X);let x=class extends X{constructor(M,se,Se,He){super(M,se),this.canIncreaseVerbosity=Se,this.canDecreaseVerbosity=He}};e.$5N=x,e.$5N=x=Je([f],x);var $e;(function(z){z[z.Increase=0]="Increase",z[z.Decrease=1]="Decrease"})($e||(e.HoverVerbosityAction=$e={}));var pe;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(pe||(e.DocumentHighlightKind=pe={}));let Ae=class{constructor(M,se=pe.Text){this.range=M,this.kind=se}toJSON(){return{range:this.range,kind:pe[this.kind]}}};e.$6N=Ae,e.$6N=Ae=Je([f],Ae);let ze=class{constructor(M,se){this.uri=M,this.highlights=se}toJSON(){return{uri:this.uri,highlights:this.highlights.map(M=>M.toJSON())}}};e.$7N=ze,e.$7N=ze=Je([f],ze);var Ie;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(Ie||(e.SymbolKind=Ie={}));var Pe;(function(z){z[z.Deprecated=1]="Deprecated"})(Pe||(e.SymbolTag=Pe={}));let Oe=u=class{static validate(M){if(!M.name)throw new Error("name must not be falsy")}constructor(M,se,Se,He,it){this.name=M,this.kind=se,this.containerName=it,typeof Se=="string"&&(this.containerName=Se),He instanceof fe?this.location=He:Se instanceof q&&(this.location=new fe(He,Se)),u.validate(this)}toJSON(){return{name:this.name,kind:Ie[this.kind],location:this.location,containerName:this.containerName}}};e.$8N=Oe,e.$8N=Oe=u=Je([f],Oe);let U=$=class{static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children?.forEach($.validate)}constructor(M,se,Se,He,it){this.name=M,this.detail=se,this.kind=Se,this.range=He,this.selectionRange=it,this.children=[],$.validate(this)}};e.$9N=U,e.$9N=U=$=Je([f],U);var j;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(j||(e.CodeActionTriggerKind=j={}));let K=class{constructor(M,se){this.title=M,this.kind=se}};e.$0N=K,e.$0N=K=Je([f],K);let V=class{static{m=this}static{this.c="."}constructor(M){this.value=M}append(M){return new m(this.value?this.value+m.c+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+m.c)}};e.$$N=V,e.$$N=V=m=Je([f],V),V.Empty=new V(""),V.QuickFix=V.Empty.append("quickfix"),V.Refactor=V.Empty.append("refactor"),V.RefactorExtract=V.Refactor.append("extract"),V.RefactorInline=V.Refactor.append("inline"),V.RefactorMove=V.Refactor.append("move"),V.RefactorRewrite=V.Refactor.append("rewrite"),V.Source=V.Empty.append("source"),V.SourceOrganizeImports=V.Source.append("organizeImports"),V.SourceFixAll=V.Source.append("fixAll"),V.Notebook=V.Empty.append("notebook");let re=class{constructor(M,se){if(this.range=M,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$_N=re,e.$_N=re=Je([f],re);class ge{constructor(M,se,Se,He,it,dt){this.kind=M,this.name=se,this.detail=Se,this.uri=He,this.range=it,this.selectionRange=dt}}e.$aO=ge;class Ce{constructor(M,se){this.fromRanges=se,this.from=M}}e.$bO=Ce;class Ue{constructor(M,se){this.fromRanges=se,this.to=M}}e.$cO=Ue;var Qe;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Qe||(e.LanguageStatusSeverity=Qe={}));let _e=class{constructor(M,se){this.range=M,this.command=se}get isResolved(){return!!this.command}};e.$dO=_e,e.$dO=_e=Je([f],_e);let tt=h=class{#e;static isMarkdownString(M){return M instanceof h?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}constructor(M,se=!1){this.#e=new P.$4k(M,{supportThemeIcons:se})}get value(){return this.#e.value}set value(M){this.#e.value=M}get isTrusted(){return this.#e.isTrusted}set isTrusted(M){this.#e.isTrusted=M}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(M){this.#e.supportThemeIcons=M}get supportHtml(){return this.#e.supportHtml}set supportHtml(M){this.#e.supportHtml=M}get baseUri(){return this.#e.baseUri}set baseUri(M){this.#e.baseUri=M}appendText(M){return this.#e.appendText(M),this}appendMarkdown(M){return this.#e.appendMarkdown(M),this}appendCodeblock(M,se){return this.#e.appendCodeblock(se??"",M),this}};e.$eO=tt,e.$eO=tt=h=Je([f],tt);let nt=class{constructor(M,se){this.label=M,this.documentation=se}};e.$fO=nt,e.$fO=nt=Je([f],nt);let et=class{constructor(M,se){this.label=M,this.documentation=se,this.parameters=[]}};e.$gO=et,e.$gO=et=Je([f],et);let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$hO=rt,e.$hO=rt=Je([f],rt);var ft;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(ft||(e.SignatureHelpTriggerKind=ft={}));var lt;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(lt||(e.InlayHintKind=lt={}));let st=class{constructor(M){this.value=M}};e.$iO=st,e.$iO=st=Je([f],st);let ct=class{constructor(M,se,Se){this.position=M,this.label=se,this.kind=Se}};e.$jO=ct,e.$jO=ct=Je([f],ct);var mt;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(mt||(e.CompletionTriggerKind=mt={}));var $t;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})($t||(e.CompletionItemKind=$t={}));var We;(function(z){z[z.Deprecated=1]="Deprecated"})(We||(e.CompletionItemTag=We={}));let je=class{constructor(M,se){this.label=M,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&$t[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$kO=je,e.$kO=je=Je([f],je);let ie=class{constructor(M=[],se=!1){this.items=M,this.isIncomplete=se}};e.$lO=ie,e.$lO=ie=Je([f],ie);let ee=class{constructor(M,se,Se){this.insertText=M,this.range=se,this.command=Se}};e.$mO=ee,e.$mO=ee=Je([f],ee);let Z=class{constructor(M){this.commands=void 0,this.suppressSuggestions=void 0,this.items=M}};e.$nO=Z,e.$nO=Z=Je([f],Z);var Xe;(function(z){z[z.Unknown=0]="Unknown",z[z.Word=1]="Word",z[z.Line=2]="Line",z[z.Suggest=3]="Suggest"})(Xe||(e.PartialAcceptTriggerKind=Xe={}));var xe;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(xe||(e.ViewColumn=xe={}));var ht;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ht||(e.StatusBarAlignment=ht={}));function wt(z,M){return`${y.$rn.toKey(z)}.${M}`}var Ft;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval"})(Ft||(e.TextEditorLineNumbersStyle=Ft={}));var Kt;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var _t;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(_t||(e.TextEditorRevealType=_t={}));var ei;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(ei||(e.TextEditorSelectionChangeKind=ei={}));var oi;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(oi||(e.TextDocumentChangeReason=oi={}));var At;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(At||(e.DecorationRangeBehavior=At={})),function(z){function M(se){switch(se){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=M}(ei||(e.TextEditorSelectionChangeKind=ei={}));var Ze;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(Ze||(e.SyntaxTokenType=Ze={})),function(z){function M(se){switch(se){case z.Other:return"other";case z.Comment:return"comment";case z.String:return"string";case z.RegEx:return"regex"}return"other"}z.toString=M}(Ze||(e.SyntaxTokenType=Ze={}));let Ct=class{constructor(M,se){if(se&&!o.URI.isUri(se))throw(0,R.$6)("target");if(!q.isRange(M)||M.isEmpty)throw(0,R.$6)("range");this.range=M,this.target=se}};e.$pO=Ct,e.$pO=Ct=Je([f],Ct);let hi=class{constructor(M,se,Se,He){this.red=M,this.green=se,this.blue=Se,this.alpha=He}};e.$qO=hi,e.$qO=hi=Je([f],hi);let pt=class{constructor(M,se){if(se&&!(se instanceof hi))throw(0,R.$6)("color");if(!q.isRange(M)||M.isEmpty)throw(0,R.$6)("range");this.range=M,this.color=se}};e.$rO=pt,e.$rO=pt=Je([f],pt);let Dt=class{constructor(M){if(!M||typeof M!="string")throw(0,R.$6)("label");this.label=M}};e.$sO=Dt,e.$sO=Dt=Je([f],Dt);var ti;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var ii;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var jt;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(jt||(e.TerminalExitReason=jt={}));var gt;(function(z){z[z.Low=0]="Low",z[z.Medium=1]="Medium",z[z.High=2]="High"})(gt||(e.TerminalShellExecutionCommandLineConfidence=gt={}));class Ut{constructor(M,se,Se){if(this.startIndex=M,this.length=se,this.tooltip=Se,typeof M!="number"||M<0)throw(0,R.$6)("startIndex");if(typeof se!="number"||se<1)throw(0,R.$6)("length");if(Se!==void 0&&typeof Se!="string")throw(0,R.$6)("tooltip")}}e.$tO=Ut;class ni{constructor(M){this.uri=M}}e.$uO=ni;class ai{constructor(M){this.terminalCommand=M}}e.$vO=ai;var Ge;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(Ge||(e.TerminalLocation=Ge={}));class ci{constructor(M){if(this.options=M,typeof M!="object")throw(0,R.$6)("options")}}e.$wO=ci;var di;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(di||(e.TaskRevealKind=di={}));var fi;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(fi||(e.TaskPanelKind=fi={}));let vt=class{static{E=this}static{this.Clean=new E("clean","Clean")}static{this.Build=new E("build","Build")}static{this.Rebuild=new E("rebuild","Rebuild")}static{this.Test=new E("test","Test")}static from(M){switch(M){case"clean":return E.Clean;case"build":return E.Build;case"rebuild":return E.Rebuild;case"test":return E.Test;default:return}}constructor(M,se){if(this.label=se,typeof M!="string"||typeof se!="string")throw(0,R.$6)("name");this.c=M}get id(){return this.c}};e.$xO=vt,e.$xO=vt=E=Je([f],vt);function Mt(z){let M="";for(let se=0;se<z.length;se++)M+=z[se].replace(/,/g,",,")+",";return M}let Nt=class{constructor(M,se,Se){if(typeof M!="string")throw(0,R.$6)("process");this.e=[],this.c=M,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=Se):this.f=se)}get process(){return this.c}set process(M){if(typeof M!="string")throw(0,R.$6)("process");this.c=M}get args(){return this.e}set args(M){Array.isArray(M)||(M=[]),this.e=M}get options(){return this.f}set options(M){this.f=M}computeId(){const M=[];if(M.push("process"),this.c!==void 0&&M.push(this.c),this.e&&this.e.length>0)for(const se of this.e)M.push(se);return Mt(M)}};e.$yO=Nt,e.$yO=Nt=Je([f],Nt);let qt=class{constructor(M,se,Se){if(this.f=[],Array.isArray(se)){if(!M)throw(0,R.$6)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,R.$6)("command");this.e=M,this.f=se,this.g=Se}else{if(typeof M!="string")throw(0,R.$6)("commandLine");this.c=M,this.g=se}}get commandLine(){return this.c}set commandLine(M){if(typeof M!="string")throw(0,R.$6)("commandLine");this.c=M}get command(){return this.e?this.e:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,R.$6)("command");this.e=M}get args(){return this.f}set args(M){this.f=M||[]}get options(){return this.g}set options(M){this.g=M}computeId(){const M=[];if(M.push("shell"),this.c!==void 0&&M.push(this.c),this.e!==void 0&&M.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)M.push(typeof se=="string"?se:se.value);return Mt(M)}};e.$zO=qt,e.$zO=qt=Je([f],qt);var ri;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(ri||(e.ShellQuoting=ri={}));var Ht;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(Ht||(e.TaskScope=Ht={}));class li{constructor(M){this.c=M}computeId(){return"customExecution"+(0,I.$2g)()}set callback(M){this.c=M}get callback(){return this.c}}e.$AO=li;let Bt=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(M,se,Se,He,it,dt){this.k=!1,this.l=this.definition=M;let Et;typeof se=="string"?(this.o=this.name=se,this.w=this.source=Se,this.execution=He,Et=it,this.k=!0):se===Ht.Global||se===Ht.Workspace?(this.target=se,this.o=this.name=Se,this.w=this.source=He,this.execution=it,Et=dt):(this.target=se,this.o=this.name=Se,this.w=this.source=He,this.execution=it,Et=dt),typeof Et=="string"?(this.r=[Et],this.t=!0):Array.isArray(Et)?(this.r=Et,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(M){this.j=M}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Nt?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof qt?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof li?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,I.$2g)()}}get definition(){return this.l}set definition(M){if(M==null)throw(0,R.$6)("Kind can't be undefined or null");this.B(),this.l=M}get scope(){return this.m}set target(M){this.B(),this.m=M}get name(){return this.o}set name(M){if(typeof M!="string")throw(0,R.$6)("name");this.B(),this.o=M}get execution(){return this.q}set execution(M){M===null&&(M=void 0),this.B(),this.q=M;const se=this.l.type;(D.g===se||D.e===se||D.f===se||D.c===se)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(M){if(Array.isArray(M))this.B(),this.r=M,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.B(),this.u=M}get source(){return this.w}set source(M){if(typeof M!="string"||M.length===0)throw(0,R.$6)("source must be a string of length > 0");this.B(),this.w=M}get group(){return this.x}set group(M){M===null&&(M=void 0),this.B(),this.x=M}get detail(){return this.A}set detail(M){M===null&&(M=void 0),this.A=M}get presentationOptions(){return this.y}set presentationOptions(M){M==null&&(M=Object.create(null)),this.B(),this.y=M}get runOptions(){return this.z}set runOptions(M){M==null&&(M=Object.create(null)),this.B(),this.z=M}};e.$BO=Bt,e.$BO=Bt=D=Je([f],Bt);var Qt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(Qt||(e.ProgressLocation=Qt={}));var Gt;(function(z){function M(se){const Se=se;return(0,p.$ig)(Se.value)?Se.tooltip&&!(0,p.$eg)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}z.isViewBadge=M})(Gt||(e.ViewBadge=Gt={}));let Lt=b=class{static isTreeItem(M,se){const Se=M;if(Se.checkboxState!==void 0){const He=(0,p.$ig)(Se.checkboxState)?Se.checkboxState:(0,p.$gg)(Se.checkboxState)&&(0,p.$ig)(Se.checkboxState.state)?Se.checkboxState.state:void 0,it=!(0,p.$ig)(Se.checkboxState)&&(0,p.$gg)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(He===void 0||He!==kt.Checked&&He!==kt.Unchecked||it!==void 0&&!(0,p.$eg)(it))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(M instanceof b)return!0;if(Se.label!==void 0&&!(0,p.$eg)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,p.$eg)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,p.$eg)(Se.iconPath)&&!o.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,p.$eg)(Se.iconPath.id))){const He=Se.iconPath;if(!He||!(0,p.$eg)(He.light)&&!o.URI.isUri(He.light)&&!(0,p.$eg)(He.dark)&&!o.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,p.$eg)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!o.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,p.$eg)(Se.tooltip)&&!(Se.tooltip instanceof tt)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<bt.None&&Se.collapsibleState>bt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,p.$eg)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(M,se=bt.None){this.collapsibleState=se,o.URI.isUri(M)?this.resourceUri=M:this.label=M}};e.$CO=Lt,e.$CO=Lt=b=Je([f],Lt);var bt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(bt||(e.TreeItemCollapsibleState=bt={}));var kt;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(kt||(e.TreeItemCheckboxState=kt={}));let Vt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(M){this.value=M}};e.$DO=Vt,e.$DO=Vt=Je([f],Vt);class It extends Vt{}e.$EO=It;class mi extends It{#e;constructor(M){super(""),this.#e=M}asFile(){return this.#e}}e.$FO=mi;class Yt{constructor(M,se,Se,He){this.name=M,this.uri=se,this._itemId=Se,this.c=He}data(){return this.c()}}e.$GO=Yt;let ki=class{#e=new Map;constructor(M){for(const[se,Se]of M??[]){const He=this.#e.get(this.#t(se));He?He.push(Se):this.#e.set(this.#t(se),[Se])}}get(M){return this.#e.get(this.#t(M))?.[0]}set(M,se){this.#e.set(this.#t(M),[se])}forEach(M,se){for(const[Se,He]of this.#e)for(const it of He)M.call(se,it,Se,this)}*[Symbol.iterator](){for(const[M,se]of this.#e)for(const Se of se)yield[M,Se]}#t(M){return M.toLowerCase()}};e.$HO=ki,e.$HO=ki=Je([f],ki);let bi=class{constructor(M,se,Se){this.insertText=M,this.title=se,this.kind=Se}};e.$IO=bi,e.$IO=bi=Je([f],bi);var Ai;(function(z){z[z.Automatic=0]="Automatic",z[z.PasteAs=1]="PasteAs"})(Ai||(e.DocumentPasteTriggerKind=Ai={}));class Tt{static{this.c="."}constructor(M){this.value=M}append(...M){return new Tt((this.value?[this.value,...M]:M).join(Tt.c))}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+Tt.c)}}e.$JO=Tt,Tt.Empty=new Tt("");class Ni{constructor(M,se,Se){this.title=se,this.insertText=M,this.kind=Se}}e.$KO=Ni;let ui=class{constructor(M,se){this.id=M,this.color=se}static isThemeIcon(M){return typeof M.id!="string"?(console.log("INVALID ThemeIcon, invalid id",M.id),!1):!0}};e.$LO=ui,e.$LO=ui=Je([f],ui),ui.File=new ui("file"),ui.Folder=new ui("folder");let Pt=class{constructor(M){this.id=M}};e.$MO=Pt,e.$MO=Pt=Je([f],Pt);var Ti;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Ti||(e.ConfigurationTarget=Ti={}));let Ii=class{get base(){return this.c}set base(M){this.c=M,this.e=o.URI.file(M)}get baseUri(){return this.e}set baseUri(M){this.e=M,this.c=M.fsPath}constructor(M,se){if(typeof M!="string"&&(!M||!o.URI.isUri(M)&&!o.URI.isUri(M.uri)))throw(0,R.$6)("base");if(typeof se!="string")throw(0,R.$6)("pattern");typeof M=="string"?this.baseUri=o.URI.file(M):o.URI.isUri(M)?this.baseUri=M:this.baseUri=M.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$NO=Ii,e.$NO=Ii=Je([f],Ii);const Di=new WeakMap;function Li(z,M){Di.set(z,M)}let wi=class{constructor(M,se,Se,He,it){this.enabled=typeof M=="boolean"?M:!0,typeof se=="string"&&(this.condition=se),typeof Se=="string"&&(this.hitCondition=Se),typeof He=="string"&&(this.logMessage=He),typeof it=="string"&&(this.mode=it)}get id(){return this.c||(this.c=Di.get(this)??(0,I.$2g)()),this.c}};e.$PO=wi,e.$PO=wi=Je([f],wi);let Wt=class extends wi{constructor(M,se,Se,He,it,dt){if(super(se,Se,He,it,dt),M===null)throw(0,R.$6)("location");this.location=M}};e.$QO=Wt,e.$QO=Wt=Je([f],Wt);let De=class extends wi{constructor(M,se,Se,He,it,dt){super(se,Se,He,it,dt),this.functionName=M}};e.$RO=De,e.$RO=De=Je([f],De);let Re=class extends wi{constructor(M,se,Se,He,it,dt,Et,Xt){if(super(He,it,dt,Et,Xt),!se)throw(0,R.$6)("dataId");this.label=M,this.dataId=se,this.canPersist=Se}};e.$SO=Re,e.$SO=Re=Je([f],Re);let de=class{constructor(M,se,Se){this.command=M,this.args=se||[],this.options=Se}};e.$TO=de,e.$TO=de=Je([f],de);let J=class{constructor(M,se){this.port=M,this.host=se}};e.$UO=J,e.$UO=J=Je([f],J);let ye=class{constructor(M){this.path=M}};e.$VO=ye,e.$VO=ye=Je([f],ye);let Be=class{constructor(M){this.implementation=M}};e.$WO=Be,e.$WO=Be=Je([f],Be);class Ye{constructor(M,se,Se){this.session=M,this.threadId=se,this.frameId=Se}}e.$XO=Ye;class Ke{constructor(M,se){this.session=M,this.threadId=se}}e.$YO=Ke;let ut=class{constructor(M,se){this.range=M,this.expression=se}};e.$ZO=ut,e.$ZO=ut=Je([f],ut);var Rt;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Rt||(e.InlineCompletionTriggerKind=Rt={}));let Jt=class{constructor(M,se){this.range=M,this.text=se}};e.$1O=Jt,e.$1O=Jt=Je([f],Jt);let si=class{constructor(M,se,Se=!0){this.range=M,this.variableName=se,this.caseSensitiveLookup=Se}};e.$2O=si,e.$2O=si=Je([f],si);let zt=class{constructor(M,se){this.range=M,this.expression=se}};e.$3O=zt,e.$3O=zt=Je([f],zt);let Zt=class{constructor(M,se){this.frameId=M,this.stoppedLocation=se}};e.$4O=Zt,e.$4O=Zt=Je([f],Zt);var qi;(function(z){z[z.AIGenerated=1]="AIGenerated"})(qi||(e.NewSymbolNameTag=qi={}));var rn;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(rn||(e.NewSymbolNameTriggerKind=rn={}));class Vi{constructor(M,se){this.newSymbolName=M,this.tags=se}}e.$5O=Vi;var Mi;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Mi||(e.FileChangeType=Mi={}));let Ki=C=class extends Error{static FileExists(M){return new C(M,a.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(M){return new C(M,a.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(M){return new C(M,a.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(M){return new C(M,a.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(M){return new C(M,a.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(M){return new C(M,a.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}constructor(M,se=a.FileSystemProviderErrorCode.Unknown,Se){super(o.URI.isUri(M)?M.toString(!0):M),this.code=Se?.name??"Unknown",(0,a.$pl)(this,se),Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$6O=Ki,e.$6O=Ki=C=Je([f],Ki);let Qi=class{constructor(M,se,Se){this.start=M,this.end=se,this.kind=Se}};e.$7O=Qi,e.$7O=Qi=Je([f],Qi);var Ci;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(Ci||(e.FoldingRangeKind=Ci={}));var sn;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(sn||(e.CommentThreadCollapsibleState=sn={}));var on;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(on||(e.CommentMode=on={}));var zi;(function(z){z[z.Published=0]="Published",z[z.Draft=1]="Draft"})(zi||(e.CommentState=zi={}));var an;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(an||(e.CommentThreadState=an={}));var Ui;(function(z){z[z.Current=0]="Current",z[z.Outdated=1]="Outdated"})(Ui||(e.CommentThreadApplicability=Ui={}));var Hi;(function(z){z[z.Reply=1]="Reply",z[z.Comment=2]="Comment"})(Hi||(e.CommentThreadFocus=Hi={}));class En{constructor(M,se=[]){this.tokenTypes=M,this.tokenModifiers=se}}e.$8O=En;function cn(z){return typeof z>"u"||(0,p.$fg)(z)}class Gi{constructor(M){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,M){this.m=!0;for(let se=0,Se=M.tokenTypes.length;se<Se;se++)this.k.set(M.tokenTypes[se],se);for(let se=0,Se=M.tokenModifiers.length;se<Se;se++)this.l.set(M.tokenModifiers[se],se)}}push(M,se,Se,He,it){if(typeof M=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof He=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.q(M,se,Se,He,it);if(q.isRange(M)&&typeof se=="string"&&cn(Se))return this.o(M,se,Se);throw(0,R.$6)()}o(M,se,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(se))throw new Error("`tokenType` is not in the provided legend");const He=M.start.line,it=M.start.character,dt=M.end.character-M.start.character,Et=this.k.get(se);let Xt=0;if(Se)for(const $i of Se){if(!this.l.has($i))throw new Error("`tokenModifier` is not in the provided legend");const Ei=this.l.get($i);Xt|=1<<Ei>>>0}this.q(He,it,dt,Et,Xt)}q(M,se,Se,He,it){if(this.f&&(M<this.c||M===this.c&&se<this.e)){this.f=!1;const Xt=this.g.length/5|0;let $i=0,Ei=0;for(let Si=0;Si<Xt;Si++){let Ri=this.g[5*Si],tn=this.g[5*Si+1];Ri===0?(Ri=$i,tn+=Ei):Ri+=$i,this.g[5*Si]=Ri,this.g[5*Si+1]=tn,$i=Ri,Ei=tn}}let dt=M,Et=se;this.f&&this.j>0&&(dt-=this.c,dt===0&&(Et-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=Et,this.g[this.j++]=Se,this.g[this.j++]=He,this.g[this.j++]=it,this.c=M,this.e=se}static r(M){const se=[],Se=M.length/5|0;for(let Et=0;Et<Se;Et++)se[Et]=Et;se.sort((Et,Xt)=>{const $i=M[5*Et],Ei=M[5*Xt];if($i===Ei){const Si=M[5*Et+1],Ri=M[5*Xt+1];return Si-Ri}return $i-Ei});const He=new Uint32Array(M.length);let it=0,dt=0;for(let Et=0;Et<Se;Et++){const Xt=5*se[Et],$i=M[Xt+0],Ei=M[Xt+1],Si=M[Xt+2],Ri=M[Xt+3],tn=M[Xt+4],Qn=$i-it,Lr=Qn===0?Ei-dt:Ei,nn=5*Et;He[nn+0]=Qn,He[nn+1]=Lr,He[nn+2]=Si,He[nn+3]=Ri,He[nn+4]=tn,it=$i,dt=Ei}return He}build(M){return this.f?new Pi(new Uint32Array(this.g),M):new Pi(Gi.r(this.g),M)}}e.$9O=Gi;class Pi{constructor(M,se){this.resultId=se,this.data=M}}e.$0O=Pi;class Dn{constructor(M,se,Se){this.start=M,this.deleteCount=se,this.data=Se}}e.$$O=Dn;class Sn{constructor(M,se){this.resultId=se,this.edits=M}}e.$_O=Sn;var ln;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(ln||(e.DebugConsoleMode=ln={}));class Ji{constructor(M){this.name=M}}e.$aP=Ji;var Xi;(function(z){z[z.Title=1]="Title",z[z.Inline=2]="Inline"})(Xi||(e.QuickInputButtonLocation=Xi={}));let Me=class{static{this.Back={iconPath:new ui("arrow-left")}}constructor(){}};e.$bP=Me,e.$bP=Me=Je([f],Me);var vi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(vi||(e.QuickPickItemKind=vi={}));var Yi;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(Yi||(e.InputBoxValidationSeverity=Yi={}));var ot;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(ot||(e.ExtensionKind=ot={}));class St{static validate(M){if(typeof M.badge=="string"){let se=(0,T.$Pf)(M.badge,0);if(se<M.badge.length&&(se+=(0,T.$Pf)(M.badge,se)),M.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(M.badge&&!ui.isThemeIcon(M.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty");return!0}constructor(M,se,Se){this.badge=M,this.tooltip=se,this.color=Se}}e.$cP=St;let Zi=class{constructor(M){this.kind=M}};e.$dP=Zi,e.$dP=Zi=Je([f],Zi);var un;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(un||(e.ColorThemeKind=un={}));class yi{static isNotebookRange(M){return M instanceof yi?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(M,se){if(M<0)throw(0,R.$6)("start must be positive");if(se<0)throw(0,R.$6)("end must be positive");M<=se?(this.c=M,this.e=se):(this.c=se,this.e=M)}with(M){let se=this.c,Se=this.e;return M.start!==void 0&&(se=M.start),M.end!==void 0&&(Se=M.end),se===this.c&&Se===this.e?this:new yi(se,Se)}}e.$eP=yi;class ji{static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(se=>ji.isNotebookCellData(se))}static isNotebookCellData(M){return!0}constructor(M,se,Se,He,it,dt,Et){this.kind=M,this.value=se,this.languageId=Se,this.mime=He,this.outputs=it??[],this.metadata=dt,this.executionSummary=Et,ji.validate(this)}}e.$fP=ji;class Bi{constructor(M){this.cells=M}}e.$gP=Bi;class pi{static isNotebookCellOutputItem(M){return M instanceof pi?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const se={name:M.name,message:M.message,stack:M.stack};return pi.json(se,"application/vnd.code.notebook.error")}static stdout(M){return pi.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return pi.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,se="application/octet-stream"){return new pi(M,se)}static#e=new TextEncoder;static text(M,se=A.$$s.text){const Se=pi.#e.encode(String(M));return new pi(Se,se)}static json(M,se="text/x-json"){const Se=JSON.stringify(M,void 0,"	");return pi.text(Se,se)}constructor(M,se){this.data=M,this.mime=se;const Se=(0,A.$ct)(se,!0);if(!Se)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$hP=pi;class Wi{static isNotebookCellOutput(M){return M instanceof Wi?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&Array.isArray(M.items)}static ensureUniqueMimeTypes(M,se=!1){const Se=new Set,He=new Set;for(let it=0;it<M.length;it++){const dt=M[it],Et=(0,A.$ct)(dt.mime);if(!Se.has(Et)||(0,d.$ML)(Et)){Se.add(Et);continue}He.add(it),se&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return He.size===0?M:M.filter((it,dt)=>!He.has(dt))}constructor(M,se,Se){this.items=Wi.ensureUniqueMimeTypes(M,!0),typeof se=="string"?(this.id=se,this.metadata=Se):(this.id=(0,I.$2g)(),this.metadata=se??Se)}}e.$iP=Wi;var hn;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(hn||(e.NotebookCellKind=hn={}));var xi;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(xi||(e.NotebookCellExecutionState=xi={}));var dn;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(dn||(e.NotebookCellStatusBarAlignment=dn={}));var fn;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(fn||(e.NotebookEditorRevealType=fn={}));class kn{constructor(M,se){this.text=M,this.alignment=se}}e.$jP=kn;var gn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(gn||(e.NotebookControllerAffinity=gn={}));var mn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(mn||(e.NotebookControllerAffinity2=mn={}));class In{constructor(M,se=[]){this.uri=M,this.provides=(0,v.$1b)(se)}}e.$kP=In;class Cn{constructor(M){this.label=M}}e.$lP=Cn;var pn;(function(z){z[z.Named=1]="Named",z[z.Indexed=2]="Indexed"})(pn||(e.NotebookVariablesRequestKind=pn={}));let _i=class{constructor(M,se){this.label=M,this.timestamp=se}};e.$mP=_i,e.$mP=_i=Je([f],_i);var $n;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})($n||(e.ExtensionMode=$n={}));var bn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(bn||(e.ExtensionRuntime=bn={}));var te;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(te||(e.StandardTokenType=te={}));class ue{constructor(M,se){this.ranges=M,this.wordPattern=se}}e.$nP=ue;class Fe{constructor(M){this.c=M}get autoForwardAction(){return this.c}}e.$oP=Fe;var at;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(at||(e.TestResultState=at={}));var yt;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(yt||(e.TestRunProfileKind=yt={}));let Ot=class{constructor(M=void 0,se=void 0,Se=void 0,He=!1,it=!0){this.include=M,this.exclude=se,this.profile=Se,this.continuous=He,this.preserveFocus=it}};e.$pP=Ot,e.$pP=Ot=Je([f],Ot);let gi=k=class{static diff(M,se,Se){const He=new k(M);return He.expectedOutput=se,He.actualOutput=Se,He}constructor(M){this.message=M}};e.$qP=gi,e.$qP=gi=k=Je([f],gi);let Fi=class{constructor(M){this.id=M}};e.$rP=Fi,e.$rP=Fi=Je([f],Fi);class en{constructor(M,se,Se){this.label=M,this.file=se,this.position=Se}}e.$sP=en;class wn{constructor(M,se){this.covered=M,this.total=se,Rn(this)}}e.$tP=wn;function Rn(z){if(z){if(z.covered>z.total)throw new Error(`The total number of covered items (${z.covered}) cannot be greater than the total (${z.total})`);if(z.total<0)throw new Error(`The number of covered items (${z.total}) cannot be negative`)}}class Pn{static fromDetails(M,se){const Se=new wn(0,0),He=new wn(0,0),it=new wn(0,0);for(const Et of se)if("branches"in Et){Se.total+=1,Se.covered+=Et.executed?1:0;for(const Xt of Et.branches)He.total+=1,He.covered+=Xt.executed?1:0}else it.total+=1,it.covered+=Et.executed?1:0;const dt=new Pn(M,Se,He.total>0?He:void 0,it.total>0?it:void 0);return dt.detailedCoverage=se,dt}constructor(M,se,Se,He,it=[]){this.uri=M,this.statementCoverage=se,this.branchCoverage=Se,this.declarationCoverage=He,this.fromTests=it}}e.$vP=Pn;class Jn{get executionCount(){return+this.executed}set executionCount(M){this.executed=M}constructor(M,se,Se=[]){this.executed=M,this.location=se,this.branches=Se}}e.$wP=Jn;class Xn{get executionCount(){return+this.executed}set executionCount(M){this.executed=M}constructor(M,se,Se){this.executed=M,this.location=se,this.label=Se}}e.$xP=Xn;class Yn{get executionCount(){return+this.executed}set executionCount(M){this.executed=M}constructor(M,se,Se){this.name=M,this.executed=se,this.location=Se}}e.$yP=Yn;var An;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(An||(e.ExternalUriOpenerPriority=An={}));var Tn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(Tn||(e.WorkspaceTrustState=Tn={}));var On;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(On||(e.PortAutoForwardAction=On={}));class Zn{constructor(M,se,Se,He,it,dt){this.kind=M,this.name=se,this.detail=Se,this.uri=He,this.range=it,this.selectionRange=dt}}e.$zP=Zn;class xn{constructor(M){this.uri=M}}e.$AP=xn;class _n{constructor(M,se){this.original=M,this.modified=se}}e.$BP=_n;class er{constructor(M,se,Se,He){this.base=M,this.input1=se,this.input2=Se,this.result=He}}e.$CP=er;class tr{constructor(M,se){this.uri=M,this.viewType=se}}e.$DP=tr;class ir{constructor(M){this.viewType=M}}e.$EP=ir;class nr{constructor(M,se){this.uri=M,this.notebookType=se}}e.$FP=nr;class rr{constructor(M,se,Se){this.original=M,this.modified=se,this.notebookType=Se}}e.$GP=rr;class sr{constructor(){}}e.$HP=sr;class or{constructor(M,se){this.uri=M,this.inputBoxUri=se}}e.$IP=or;class ar{constructor(){}}e.$JP=ar;class cr{constructor(M){this.textDiffs=M}}e.$KP=cr;var Nn;(function(z){z[z.Down=0]="Down",z[z.Up=1]="Up"})(Nn||(e.InteractiveSessionVoteDirection=Nn={}));var Ln;(function(z){z[z.Action=1]="Action",z[z.Toolbar=2]="Toolbar"})(Ln||(e.ChatCopyKind=Ln={}));var Fn;(function(z){z[z.Short=1]="Short",z[z.Medium=2]="Medium",z[z.Full=3]="Full"})(Fn||(e.ChatVariableLevel=Fn={}));class lr{constructor(M,se,Se){this.id=M,this.label=se,this.values=Se}}e.$LP=lr;var Mn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful",z[z.Undone=2]="Undone",z[z.Accepted=3]="Accepted",z[z.Bug=4]="Bug"})(Mn||(e.InteractiveEditorResponseFeedbackKind=Mn={}));var zn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful"})(zn||(e.ChatResultFeedbackKind=zn={}));class ur{constructor(M){if(typeof M!="string"&&M.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof M=="string"?new tt(M):M}}e.$MP=ur;class hr{constructor(M,se){if(typeof M!="string"&&M.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof M=="string"?new tt(M):M,this.vulnerabilities=se}}e.$NP=hr;class dr{constructor(M,se){this.participant=M,this.command=se}}e.$OP=dr;class fr{constructor(M,se,Se,He){this.title=M,this.message=se,this.data=Se,this.buttons=He}}e.$PP=fr;class gr{constructor(M,se){this.value=M,this.baseUri=se}}e.$QP=gr;class mr{constructor(M,se){this.value=M,this.title=se}}e.$RP=mr;class pr{constructor(M){this.value=M}}e.$SP=pr;class $r{constructor(M,se){this.value=M,this.task=se}}e.$TP=$r;class br{constructor(M){if(typeof M!="string"&&M.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof M=="string"?new tt(M):M}}e.$UP=br;class wr{constructor(M){this.value=M}}e.$VP=wr;class vr{constructor(M,se,Se){this.value=M,this.iconPath=se,this.options=Se}}e.$WP=vr;class yr{constructor(M,se,Se){this.value=M,this.license=se,this.snippet=Se}}e.$XP=yr;class Er{constructor(M,se){this.uri=M,this.edits=Array.isArray(se)?se:[se]}}e.$YP=Er;class Dr{constructor(M,se,Se,He){this.prompt=M,this.command=se,this.references=Se,this.participant=He}}e.$ZP=Dr;class Sr{constructor(M,se,Se,He){this.response=M,this.result=se,this.participant=Se,this.command=He}}e.$1P=Sr;var Un;(function(z){z[z.Panel=1]="Panel",z[z.Terminal=2]="Terminal",z[z.Notebook=3]="Notebook",z[z.Editor=4]="Editor"})(Un||(e.ChatLocation=Un={}));var jn;(function(z){z[z.Complete=1]="Complete",z[z.Partial=2]="Partial",z[z.Omitted=3]="Omitted"})(jn||(e.ChatResponseReferencePartStatusKind=jn={}));class kr{constructor(M,se,Se){this.document=M,this.selection=se,this.wholeRange=Se}}e.$2P=kr;class Ir{constructor(M){this.cell=M}}e.$3P=Ir;var vn;(function(z){z[z.User=1]="User",z[z.Assistant=2]="Assistant",z[z.System=3]="System"})(vn||(e.LanguageModelChatMessageRole=vn={}));class Cr{constructor(M,se,Se){this.name=M,this.content=se,this.isError=Se??!1}}e.$4P=Cr;class yn{static User(M,se){const Se=new yn(vn.User,typeof M=="string"?M:"",se);return Se.content2=M,Se}static Assistant(M,se){return new yn(vn.Assistant,M,se)}constructor(M,se,Se){this.role=M,this.content=se,this.content2=se,this.name=Se}}e.$5P=yn;class Pr{constructor(M,se){this.name=M,this.parameters=se}}e.$6P=Pr;class Rr{constructor(M){this.value=M}}e.$7P=Rr;class Ar{constructor(M){this.content=M}}e.$8P=Ar;class Tr{constructor(M,se){this.content=M,this.name=se}}e.$9P=Tr;class Or{constructor(M,se){this.content=M,this.name=se}}e.$0P=Or;class Oi extends Error{static NotFound(M){return new Oi(M,Oi.NotFound.name)}static NoPermissions(M){return new Oi(M,Oi.NoPermissions.name)}static Blocked(M){return new Oi(M,Oi.Blocked.name)}constructor(M,se,Se){super(M,{cause:Se}),this.name="LanguageModelError",this.code=se??""}}e.$$P=Oi;var Bn;(function(z){z[z.SymbolInformation=1]="SymbolInformation",z[z.CommandInformation=2]="CommandInformation",z[z.SearchInformation=3]="SearchInformation",z[z.SettingInformation=4]="SettingInformation"})(Bn||(e.RelatedInformationType=Bn={}));var Wn;(function(z){z[z.Started=1]="Started",z[z.Recognizing=2]="Recognizing",z[z.Recognized=3]="Recognized",z[z.Stopped=4]="Stopped",z[z.Error=5]="Error"})(Wn||(e.SpeechToTextStatus=Wn={}));var qn;(function(z){z[z.Started=1]="Started",z[z.Stopped=2]="Stopped",z[z.Error=3]="Error"})(qn||(e.TextToSpeechStatus=qn={}));var Vn;(function(z){z[z.Recognized=1]="Recognized",z[z.Stopped=2]="Stopped"})(Vn||(e.KeywordRecognitionStatus=Vn={}));class Nr{constructor(M,se){this.text=M,this.range=se}}e.$_P=Nr;var Kn;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Kn||(e.InlineEditTriggerKind=Kn={}))}),define(Ne[227],Le([1,0,5,7]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rpc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(v.$KN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,T,p){if(this.a.size===0)throw new Error("No related information providers registered");const o=this.a.get(A);if(!o)throw new Error("related information provider not found");return await o.provideRelatedInformation(T,p)??[]}getRelatedInformation(A,T,p){return this.c.$getAiRelatedInformation(T,p)}registerRelatedInformationProvider(A,T,p){const o=this.b;return this.b++,this.a.set(o,p),this.c.$registerAiRelatedInformationProvider(o,T),new R.$MN(()=>{this.c.$unregisterAiRelatedInformationProvider(o),this.a.delete(o)})}}e.$rpc=P}),define(Ne[90],Le([1,0,6,5,7,18,117,3,16]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dpc=e.$Cpc=void 0,e.$Cpc=(0,T.$Fi)("IExtHostAuthentication");let o=class{constructor(a){this.b=new Map,this.c=new v.$le,this.onDidChangeSessions=this.c.event,this.d=new I,this.a=a.getProxy(R.$KN.MainThreadAuthentication)}async getSession(a,S,d,r={}){const s=O.$rn.toKey(a.identifier),c=[...d].sort().join(" ");return await this.d.getOrCreate(`${s} ${S} ${c}`,async()=>{await this.a.$ensureProvider(S);const l=a.displayName||a.name;return this.a.$getSession(S,d,s,l,r)})}async getAccounts(a){return await this.a.$ensureProvider(a),await this.a.$getAccounts(a)}async removeSession(a,S){const d=this.b.get(a);return d?d.provider.removeSession(S):this.a.$removeSession(a,S)}registerAuthenticationProvider(a,S,d,r){if(this.b.get(a))throw new Error(`An authentication provider with id '${a}' is already registered.`);this.b.set(a,{label:S,provider:d,options:r??{supportsMultipleAccounts:!1}});const s=d.onDidChangeSessions(c=>this.a.$sendDidChangeSessions(a,c));return this.a.$registerAuthenticationProvider(a,S,r?.supportsMultipleAccounts??!1),new P.$MN(()=>{s.dispose(),this.b.delete(a),this.a.$unregisterAuthenticationProvider(a)})}async $createSession(a,S,d){const r=this.b.get(a);if(r)return await r.provider.createSession(S,d);throw new Error(`Unable to find authentication provider with handle: ${a}`)}async $removeSession(a,S){const d=this.b.get(a);if(d)return await d.provider.removeSession(S);throw new Error(`Unable to find authentication provider with handle: ${a}`)}async $getSessions(a,S,d){const r=this.b.get(a);if(r)return await r.provider.getSessions(S,d);throw new Error(`Unable to find authentication provider with handle: ${a}`)}$onDidChangeAuthenticationSessions(a,S){return a.startsWith(A.$MM)||this.c.fire({provider:{id:a,label:S}}),Promise.resolve()}};e.$Dpc=o,e.$Dpc=o=Je([Ve(0,p.$kQ)],o);class I{constructor(){this.a=new Map}getOrCreate(a,S){const d=this.a.get(a);if(d)return d;const r=S().finally(()=>this.a.delete(a));return this.a.set(a,r),r}}}),define(Ne[122],Le([1,0,2,5,7,3,16,11,17,12,19,24]),function(ve,e,v,R,P,O,A,T,p,o,I,y){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Iqc=e.$Hqc=void 0;let S=class{static{a=this}static{this.c=0}static{this.d=250}constructor(r,s){this.h=s,this.f=new Map,this.g=r.getProxy(R.$KN.MainThreadDecorations)}registerFileDecorationProvider(r,s){const c=a.c++;this.f.set(c,{provider:r,extensionDescription:s}),this.g.$registerDecorationProvider(c,s.identifier.value);const l=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(c,null);return}const n=(0,p.$1b)(i);if(n.length<=a.d){this.g.$onDidChange(c,n);return}this.h.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,n.length);const t=n.map($=>({uri:$,rank:(0,o.$if)($.path,"/")})),g=(0,p.$yb)(t,($,m)=>$.rank-m.rank||(0,o.$yf)($.uri.path,m.uri.path)),u=[];e:for(const $ of g){let m;for(const h of $){const E=(0,I.$mc)(h.uri.path);if(m!==E&&(m=E,u.push(h.uri)>=a.d))break e}}this.g.$onDidChange(c,u)});return new P.$MN(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(r,s,c){if(!this.f.has(r))return Object.create(null);const l=Object.create(null),{provider:i,extensionDescription:n}=this.f.get(r);return await Promise.all(s.map(async t=>{try{const{uri:g,id:u}=t,$=await Promise.resolve(i.provideFileDecoration(v.URI.revive(g),c));if(!$)return;try{P.$cP.validate($),$.badge&&typeof $.badge!="string"&&(0,y.$gH)(n,"codiconDecoration"),l[u]=[$.propagate,$.tooltip,$.badge,$.color]}catch(m){this.h.warn(`INVALID decoration from extension '${n.identifier.value}': ${m}`)}}catch(g){this.h.error(g)}})),l}};e.$Hqc=S,e.$Hqc=S=a=Je([Ve(0,A.$kQ),Ve(1,T.$ak)],S),e.$Iqc=(0,O.$Fi)("IExtHostDecorations")}),define(Ne[228],Le([1,0,13,2,7,5,15,21,12]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kqc=void 0;class o{static{this.a=0}constructor(y,a,S){this.d=a,this.e=S,this.b=new Map,this.c=y.getProxy(O.$KN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,a){if(Object.keys(A.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const S=o.a++;this.b.set(S,a),this.c.$registerTextContentProvider(S,y);let d;if(typeof a.onDidChange=="function"){let r;d=a.onDidChange(async s=>{if(s.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(s))return;r&&await r;const c=this.$provideTextDocumentContent(S,s).then(async l=>{if(!l&&typeof l!="string")return;const i=this.d.getDocument(s);if(!i)return;const n=(0,p.$sf)(l);if(!i.equalLines(n))return this.c.$onVirtualDocumentChange(s,l)}).catch(v.$Y).finally(()=>{r===c&&(r=void 0)});r=c})}return new P.$MN(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(y,a){const S=this.b.get(y);return S?Promise.resolve(S.provideTextDocumentContent(R.URI.revive(a),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.$Kqc=o}),define(Ne[123],Le([1,0,61,15,12,284,169,7,17]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=e.$nQ=void 0,e.$mQ=I;const o=new Map;function I(d,r){r?o.set(d,r):o.delete(d)}function y(d){return o.get(d)}class a extends O.$pw{constructor(r,s,c,l,i,n,t){super(s,c,l,i),this.c=r,this.m=n,this.q=t,this.b=!1}dispose(){(0,v.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,p.$tb)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===R.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(s){return s?r.s(s):r.getText()},get eol(){return r.g===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(s){return r.t(s)},offsetAt(s){return r.u(s)},positionAt(s){return r.v(s)},validateRange(s){return r.w(s)},validatePosition(s){return r.x(s)},getWordRangeAtPosition(s,c){return r.y(s,c)},[Symbol.for("debug.description")](){return`TextDocument(${r.d.toString()})`}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,v.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,v.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const s=this.w(r);if(s.isEmpty)return"";if(s.isSingleLine)return this.f[s.start.line].substring(s.start.character,s.end.character);const c=this.g,l=s.start.line,i=s.end.line,n=[];n.push(this.f[l].substring(s.start.character));for(let t=l+1;t<i;t++)n.push(this.f[t]);return n.push(this.f[i].substring(0,s.end.character)),n.join(c)}t(r){let s;if(r instanceof T.$NN?s=r.line:typeof r=="number"&&(s=r),typeof s!="number"||s<0||s>=this.f.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new S(s,this.f[s],s===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const s=this.j.getIndexOf(r),c=this.f[s.index].length;return new T.$NN(s.index,Math.min(s.remainder,c))}w(r){if(!(r instanceof T.$ON))throw new Error("Invalid argument");const s=this.x(r.start),c=this.x(r.end);return s===r.start&&c===r.end?r:new T.$ON(s.line,s.character,c.line,c.character)}x(r){if(!(r instanceof T.$NN))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:s,character:c}=r,l=!1;if(s<0)s=0,c=0,l=!0;else if(s>=this.f.length)s=this.f.length-1,c=this.f[s].length,l=!0;else{const i=this.f[s].length;c<0?(c=0,l=!0):c>i&&(c=i,l=!0)}return l?new T.$NN(s,c):r}y(r,s){const c=this.x(r);if(!s)s=y(this.m);else if((0,P.$rf)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const l=(0,A.$qt)(c.character+1,(0,A.$ot)(s),this.f[c.line],0);if(l)return new T.$ON(c.line,l.startColumn-1,c.line,l.endColumn-1)}}e.$nQ=a;class S{constructor(r,s,c){this.a=r,this.b=s,this.c=c}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.$ON(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.$ON(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$oQ=S}),define(Ne[229],Le([1,0,5,7]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nqc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(v.$KN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,T,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const o=this.a.get(A);if(!o)throw new Error("Embedding vector provider not found");const I=await o.provideEmbeddingVector(T,p);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(A,T,p){const o=this.b;return this.b++,this.a.set(o,p),this.c.$registerAiEmbeddingVectorProvider(T,o),new R.$MN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(o),this.a.delete(o)})}}e.$Nqc=P}),define(Ne[68],Le([1,0,5,29,7,22,3,16,50,4,10,23,15]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tpc=e.$Spc=void 0,R=qe(R);let d=S=class{constructor(s,c){this.b=new Map,this.c=new I.$Oh,this.a=s.getProxy(v.$KN.MainThreadFileSystem);const l=this;this.value=Object.freeze({async stat(i){try{let n;const t=l.b.get(i.scheme);return t?(await l.a.$ensureActivation(i.scheme),n=await t.impl.stat(i)):n=await l.a.$stat(i),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===R.FilePermission.Readonly?1:void 0}}catch(n){S.e(n)}},async readDirectory(i){try{const n=l.b.get(i.scheme);return n?(await l.a.$ensureActivation(i.scheme),(await n.impl.readDirectory(i)).slice()):await l.a.$readdir(i)}catch(n){return S.e(n)}},async createDirectory(i){try{const n=l.b.get(i.scheme);return n&&!n.isReadonly?(await l.a.$ensureActivation(i.scheme),await l.d(n.impl,n.extUri,i)):await l.a.$mkdir(i)}catch(n){return S.e(n)}},async readFile(i){try{const n=l.b.get(i.scheme);return n?(await l.a.$ensureActivation(i.scheme),(await n.impl.readFile(i)).slice()):(await l.a.$readFile(i)).buffer}catch(n){return S.e(n)}},async writeFile(i,n){try{const t=l.b.get(i.scheme);return t&&!t.isReadonly?(await l.a.$ensureActivation(i.scheme),await l.d(t.impl,t.extUri,t.extUri.dirname(i)),await l.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,n,{create:!0,overwrite:!0})))):await l.a.$writeFile(i,O.$Ne.wrap(n))}catch(t){return S.e(t)}},async delete(i,n){try{const t=l.b.get(i.scheme);return t&&!t.isReadonly&&!n?.useTrash?(await l.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...n})):await l.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(t){return S.e(t)}},async rename(i,n,t){try{return await l.a.$rename(i,n,{overwrite:!1,...t})}catch(g){return S.e(g)}},async copy(i,n,t){try{return await l.a.$copy(i,n,{overwrite:!1,...t})}catch(g){return S.e(g)}},isWritableFileSystem(i){const n=c.getCapabilities(i);if(typeof n=="number")return!(n&R.FileSystemProviderCapabilities.Readonly)}})}async d(s,c,l){const i=[];for(;!c.isEqual(l,c.dirname(l));)try{if(!((await s.stat(l)).type&R.FileType.Directory))throw P.$6O.FileExists(`Unable to create folder '${l.scheme===a.Schemas.file?l.fsPath:l.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(R.$ql(n)!==R.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(c.basename(l)),l=c.dirname(l)}for(let n=i.length-1;n>=0;n--){l=c.joinPath(l,i[n]);try{await s.createDirectory(l)}catch(t){if(R.$ql(t)!==R.FileSystemProviderErrorCode.FileExists)throw t}}}static e(s){if(s instanceof P.$6O)throw s;if(s instanceof R.$ml)switch(s.code){case R.FileSystemProviderErrorCode.FileExists:throw P.$6O.FileExists(s.message);case R.FileSystemProviderErrorCode.FileNotFound:throw P.$6O.FileNotFound(s.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw P.$6O.FileNotADirectory(s.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw P.$6O.FileIsADirectory(s.message);case R.FileSystemProviderErrorCode.NoPermissions:throw P.$6O.NoPermissions(s.message);case R.FileSystemProviderErrorCode.Unavailable:throw P.$6O.Unavailable(s.message);default:throw new P.$6O(s.message,s.name)}if(!(s instanceof Error))throw new P.$6O(String(s));if(s.name==="ENOPRO"||s.message.includes("ENOPRO"))throw P.$6O.Unavailable(s.message);switch(s.name){case R.FileSystemProviderErrorCode.FileExists:throw P.$6O.FileExists(s.message);case R.FileSystemProviderErrorCode.FileNotFound:throw P.$6O.FileNotFound(s.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw P.$6O.FileNotADirectory(s.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw P.$6O.FileIsADirectory(s.message);case R.FileSystemProviderErrorCode.NoPermissions:throw P.$6O.NoPermissions(s.message);case R.FileSystemProviderErrorCode.Unavailable:throw P.$6O.Unavailable(s.message);default:throw new P.$6O(s.message,s.name)}}addFileSystemProvider(s,c,l){return this.b.set(s,{impl:c,extUri:l?.isCaseSensitive?y.$9g:y.$$g,isReadonly:!!l?.isReadonly}),(0,o.$Sc)(()=>this.b.delete(s))}getFileSystemProviderExtUri(s){return this.b.get(s)?.extUri??y.$9g}};e.$Spc=d,e.$Spc=d=S=Je([Ve(0,T.$kQ),Ve(1,p.$wpc)],d),e.$Tpc=(0,A.$Fi)("IExtHostConsumerFileSystem")}),define(Ne[91],Le([1,0,3,26,11,68,2]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vpc=e.$Upc=void 0,e.$Upc=(0,v.$Fi)("IExtensionStoragePaths");let T=class{constructor(o,I,y){this.d=I,this.f=y,this.a=o.workspace??void 0,this.b=o.environment,this.whenReady=this.h().then(a=>this.c=a)}async g(o){return A.URI.joinPath(this.b.workspaceStorageHome,o)}async h(){if(!this.a)return Promise.resolve(void 0);const o=this.a.id,I=await this.g(o);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(A.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(o){if(this.c)return A.URI.joinPath(this.c,o.identifier.value)}globalValue(o){return A.URI.joinPath(this.b.globalStorageHome,o.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Vpc=T,e.$Vpc=T=Je([Ve(0,R.$AQ),Ve(1,P.$ak),Ve(2,O.$Tpc)],T)}),define(Ne[230],Le([1,0,7,16,6]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$src=void 0;let O=class{constructor(T){this.a=new v.$dP(v.ColorThemeKind.Dark),this.b=new P.$le}get activeColorTheme(){return this.a}$onColorThemeChange(T){let p;switch(T){case"light":p=v.ColorThemeKind.Light;break;case"hcDark":p=v.ColorThemeKind.HighContrast;break;case"hcLight":p=v.ColorThemeKind.HighContrastLight;break;default:p=v.ColorThemeKind.Dark}this.a=new v.$dP(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$src=O,e.$src=O=Je([Ve(0,R.$kQ)],O)}),define(Ne[92],Le([1,0,21,6,4,9,3,11,183,5,26,16,7]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kGb=e.$jGb=e.TunnelDtoConverter=void 0,O=qe(O),a=qe(a);class S extends p.$Ow{}var d;(function(s){function c(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:i.protocol}}s.fromApiTunnel=c;function l(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==p.TunnelPrivacyId.ConstantPrivate&&i.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}s.fromServiceTunnel=l})(d||(e.TunnelDtoConverter=d={})),e.$jGb=(0,A.$Fi)("IExtHostTunnelService");let r=class extends P.$Uc{constructor(c,l,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new R.$le,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=c.getProxy(o.$KN.MainThreadTunnelService)}async openTunnel(c,l){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${c.identifier.value} called openTunnel API for ${l.remoteAddress.host}:${l.remoteAddress.port}.`);const i=await this.a.$openTunnel(l,c.displayName);if(i){const n=new S(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(n),n}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(c,l){c.portRange===void 0&&c.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:c,provider:l}),this.a.$registerPortsAttributesProvider(c,i),new a.$MN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(c,l,i,n,t){const g=[];for(const $ of c){const m=this.r.get($);if(!m)return[];g.push(...await Promise.all(l.map(async h=>{let E;try{E=await m.provider.providePortAttributes({port:h,pid:i,commandLine:n},t)}catch{E=await m.provider.providePortAttributes(h,i,n,t)}return{providedAttributes:E,port:h}})))}const u=g.filter($=>!!$.providedAttributes);return u.length>0?u.map($=>({autoForwardAction:$.providedAttributes.autoForwardAction,port:$.port})):[]}async $registerCandidateFinder(c){}registerTunnelProvider(c,l){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(n,t)=>await c.provideTunnel(n,t,v.CancellationToken.None)??void 0;const i=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,privacyOptions:l.tunnelFeatures?.privacyOptions,protocol:l.tunnelFeatures.protocol===void 0?!0:l.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,P.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(c,l){if(c){c.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(c.candidatePortSource),c.showCandidatePort&&(this.f=c.showCandidatePort,this.a.$setCandidateFilter());const i=c.tunnelFactory??(l?this.w(l):void 0);if(i){this.b=i;let n=c.tunnelFeatures?.privacyOptions??[];c.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:O.localize(10821,null),themeIcon:"lock"},{id:"public",label:O.localize(10822,null),themeIcon:"eye"}]);const t=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,public:!!c.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,P.$Sc)(()=>{this.b=void 0})}w(c){}async $closeTunnel(c,l){if(this.g.has(c.host)){const i=this.g.get(c.host);i.has(c.port)&&(l&&i.get(c.port).disposeListener.dispose(),await i.get(c.port).tunnel.dispose(),i.delete(c.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(c,l){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(c,l);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const n=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(c.remoteAddress.host)||this.g.set(c.remoteAddress.host,new Map);const t=this.B(n.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(n.remoteAddress))));return this.g.get(c.remoteAddress.host).set(c.remoteAddress.port,{tunnel:n,disposeListener:t}),d.fromApiTunnel(n)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(c){const l=await Promise.all(c.map(n=>this.f(n.host,n.port,n.detail??""))),i=c.filter((n,t)=>l[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${c.map(n=>n.port).join(", ")} to ${i.map(n=>n.port).join(", ")}`),i}};e.$kGb=r,e.$kGb=r=Je([Ve(0,y.$kQ),Ve(1,I.$AQ),Ve(2,T.$ak)],r)}),define(Ne[8],Le([1,0,17,22,151,231,59,28,138,36,72,25,144,23,34,14,2,105,32,159,93,52,107,76,116,114,115,207,80,89,54,55,204,7]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n,t,g,u,$,m,h,E,D,b,C,k,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$hQ=ce,e.$iQ=oe,e.$jQ=ke,A=qe(A),l=qe(l),i=qe(i),n=qe(n),E=qe(E),b=qe(b),w=qe(w);var F;(function(De){function Re(J){const{selectionStartLineNumber:ye,selectionStartColumn:Be,positionLineNumber:Ye,positionColumn:Ke}=J,ut=new w.$NN(ye-1,Be-1),Rt=new w.$NN(Ye-1,Ke-1);return new w.$PN(ut,Rt)}De.to=Re;function de(J){const{anchor:ye,active:Be}=J;return{selectionStartLineNumber:ye.line+1,selectionStartColumn:ye.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}De.from=de})(F||(e.Selection=F={}));var N;(function(De){function Re(J){if(!J)return;const{start:ye,end:Be}=J;return{startLineNumber:ye.line+1,startColumn:ye.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}De.from=Re;function de(J){if(!J)return;const{startLineNumber:ye,startColumn:Be,endLineNumber:Ye,endColumn:Ke}=J;return new w.$ON(ye-1,Be-1,Ye-1,Ke-1)}De.to=de})(N||(e.Range=N={}));var L;(function(De){function Re(J){return{uri:J.uri,range:N.from(J.range)}}De.from=Re;function de(J){return new w.$1N(s.URI.revive(J.uri),N.to(J.range))}De.to=de})(L||(e.Location=L={}));var q;(function(De){function Re(de){switch(de){case i.StandardTokenType.Comment:return w.StandardTokenType.Comment;case i.StandardTokenType.Other:return w.StandardTokenType.Other;case i.StandardTokenType.RegEx:return w.StandardTokenType.RegEx;case i.StandardTokenType.String:return w.StandardTokenType.String}}De.to=Re})(q||(e.TokenType=q={}));var H;(function(De){function Re(J){return new w.$NN(J.lineNumber-1,J.column-1)}De.to=Re;function de(J){return{lineNumber:J.line+1,column:J.character+1}}De.from=de})(H||(e.Position=H={}));var W;(function(De){function Re(ye,Be,Ye){return(0,v.$Gb)((0,v.$1b)(ye).map(Ke=>de(Ke,Be,Ye)))}De.from=Re;function de(ye,Be,Ye){if(typeof ye=="string")return{$serialized:!0,language:ye,isBuiltin:Ye?.isBuiltin};if(ye)return{$serialized:!0,language:ye.language,scheme:J(ye.scheme,Be),pattern:xe.from(ye.pattern)??void 0,exclusive:ye.exclusive,notebookType:ye.notebookType,isBuiltin:Ye?.isBuiltin}}function J(ye,Be){return Be&&typeof ye=="string"?Be.transformOutgoingScheme(ye):ye}})(W||(e.DocumentSelector=W={}));var G;(function(De){function Re(J){switch(J){case w.DiagnosticTag.Unnecessary:return g.MarkerTag.Unnecessary;case w.DiagnosticTag.Deprecated:return g.MarkerTag.Deprecated}}De.from=Re;function de(J){switch(J){case g.MarkerTag.Unnecessary:return w.DiagnosticTag.Unnecessary;case g.MarkerTag.Deprecated:return w.DiagnosticTag.Deprecated;default:return}}De.to=de})(G||(e.DiagnosticTag=G={}));var Q;(function(De){function Re(J){let ye;return J.code&&((0,r.$eg)(J.code)||(0,r.$ig)(J.code)?ye=String(J.code):ye={value:String(J.code.value),target:J.code.target}),{...N.from(J.range),message:J.message,source:J.source,code:ye,severity:be.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(ae.from),tags:Array.isArray(J.tags)?(0,v.$Gb)(J.tags.map(G.from)):void 0}}De.from=Re;function de(J){const ye=new w.$3N(N.to(J),J.message,be.to(J.severity));return ye.source=J.source,ye.code=(0,r.$eg)(J.code)?J.code:J.code?.value,ye.relatedInformation=J.relatedInformation&&J.relatedInformation.map(ae.to),ye.tags=J.tags&&(0,v.$Gb)(J.tags.map(G.to)),ye}De.to=de})(Q||(e.Diagnostic=Q={}));var ae;(function(De){function Re(J){return{...N.from(J.location.range),message:J.message,resource:J.location.uri}}De.from=Re;function de(J){return new w.$2N(new w.$1N(J.resource,N.to(J)),J.message)}De.to=de})(ae||(e.DiagnosticRelatedInformation=ae={}));var be;(function(De){function Re(J){switch(J){case w.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}De.from=Re;function de(J){switch(J){case g.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}De.to=de})(be||(e.DiagnosticSeverity=be={}));var le;(function(De){function Re(J){return typeof J=="number"&&J>=w.ViewColumn.One?J-1:J===w.ViewColumn.Beside?f.$zE:f.$yE}De.from=Re;function de(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=de})(le||(e.ViewColumn=le={}));function _(De){return typeof De.range<"u"}function ce(De){return De.length===0?!0:!!_(De[0])}var me;(function(De){function Re(Ke){return Ke.map(De.from)}De.fromMany=Re;function de(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function J(Ke){let ut;if(de(Ke)){const{language:zt,value:Zt}=Ke;ut={value:"```"+zt+`
`+Zt+"\n```\n"}}else w.$eO.isMarkdownString(Ke)?ut={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?ut={value:Ke}:ut={value:""};const Rt=Object.create(null);ut.uris=Rt;const Jt=zt=>{try{let Zt=s.URI.parse(zt,!0);Zt=Zt.with({query:ye(Zt.query,Rt)}),Rt[zt]=Zt}catch{}return""},si=new p.marked.Renderer;return si.link=Jt,si.image=zt=>typeof zt=="string"?Jt(A.$_k(zt).href):"",(0,p.marked)(ut.value,{renderer:si}),ut}De.from=J;function ye(Ke,ut){if(!Ke)return Ke;let Rt;try{Rt=(0,o.$bi)(Ke)}catch{}if(!Rt)return Ke;let Jt=!1;return Rt=(0,y.$go)(Rt,si=>{if(s.URI.isUri(si)){const zt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[zt]=si,Jt=!0,zt}else return}),Jt?JSON.stringify(Rt):Ke}function Be(Ke){const ut=new w.$eO(Ke.value,Ke.supportThemeIcons);return ut.isTrusted=Ke.isTrusted,ut.supportHtml=Ke.supportHtml,ut.baseUri=Ke.baseUri?s.URI.from(Ke.baseUri):void 0,ut}De.to=Be;function Ye(Ke){if(Ke)return typeof Ke=="string"?Ke:De.from(Ke)}De.fromStrict=Ye})(me||(e.MarkdownString=me={}));function oe(De){return ce(De)?De.map(Re=>({range:N.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?me.fromMany(Re.hoverMessage):Re.hoverMessage?me.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):De.map(Re=>({range:N.from(Re)}))}function ke(De){return typeof De>"u"?De:typeof De=="string"?s.URI.file(De):De}var Te;(function(De){function Re(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?ke(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}De.from=Re})(Te||(e.ThemableDecorationAttachmentRenderOptions=Te={}));var Y;(function(De){function Re(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?ke(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?Te.from(de.before):void 0,after:de.after?Te.from(de.after):void 0}}De.from=Re})(Y||(e.ThemableDecorationRenderOptions=Y={}));var B;(function(De){function Re(de){if(typeof de>"u")return de;switch(de){case w.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case w.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}De.from=Re})(B||(e.DecorationRangeBehavior=B={}));var ne;(function(De){function Re(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?B.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?Y.from(de.light):void 0,dark:de.dark?Y.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?ke(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?Te.from(de.before):void 0,after:de.after?Te.from(de.after):void 0}}De.from=Re})(ne||(e.DecorationRenderOptions=ne={}));var Ee;(function(De){function Re(J){return{text:J.newText,eol:J.newEol&&je.from(J.newEol),range:N.from(J.range)}}De.from=Re;function de(J){const ye=new w.$VN(N.to(J.range),J.text);return ye.newEol=typeof J.eol>"u"?void 0:je.to(J.eol),ye}De.to=de})(Ee||(e.TextEdit=Ee={}));var fe;(function(De){function Re(J,ye){const Be={edits:[]};if(J instanceof w.$YN){const Ye=new T.$Bc;for(const Ke of J._allEntries())Ke._type===w.FileEditType.File&&s.URI.isUri(Ke.to)&&Ke.from===void 0&&Ye.add(Ke.to);for(const Ke of J._allEntries())if(Ke._type===w.FileEditType.File){let ut;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?ut={type:"base64",value:(0,R.$8e)(R.$Ne.wrap(Ke.options.contents))}:ut={type:"dataTransferItem",id:Ke.options.contents._itemId}),Be.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:ut},metadata:Ke.metadata})}else Ke._type===w.FileEditType.Text?Be.edits.push({resource:Ke.uri,textEdit:Ee.from(Ke.edit),versionId:Ye.has(Ke.uri)?void 0:ye?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===w.FileEditType.Snippet?Be.edits.push({resource:Ke.uri,textEdit:{range:N.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:Ye.has(Ke.uri)?void 0:ye?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===w.FileEditType.Cell?Be.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:ye?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===w.FileEditType.CellReplace&&Be.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:ye?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:b.CellEditType.Replace,index:Ke.index,count:Ke.count,cells:Ke.cells.map(At.from)}})}return Be}De.from=Re;function de(J){const ye=new w.$YN,Be=new T.$Ac;for(const Ye of J.edits)if(Ye.textEdit){const Ke=Ye,ut=s.URI.revive(Ke.resource),Rt=N.to(Ke.textEdit.range),Jt=Ke.textEdit.text,si=Ke.textEdit.insertAsSnippet;let zt;si?zt=w.$XN.replace(Rt,new w.$ZN(Jt)):zt=w.$VN.replace(Rt,Jt);const Zt=Be.get(ut);Zt?Zt.push(zt):Be.set(ut,[zt])}else ye.renameFile(s.URI.revive(Ye.oldResource),s.URI.revive(Ye.newResource),Ye.options);for(const[Ye,Ke]of Be)ye.set(Ye,Ke);return ye}De.to=de})(fe||(e.WorkspaceEdit=fe={}));var we;(function(De){const Re=Object.create(null);Re[w.SymbolKind.File]=n.SymbolKind.File,Re[w.SymbolKind.Module]=n.SymbolKind.Module,Re[w.SymbolKind.Namespace]=n.SymbolKind.Namespace,Re[w.SymbolKind.Package]=n.SymbolKind.Package,Re[w.SymbolKind.Class]=n.SymbolKind.Class,Re[w.SymbolKind.Method]=n.SymbolKind.Method,Re[w.SymbolKind.Property]=n.SymbolKind.Property,Re[w.SymbolKind.Field]=n.SymbolKind.Field,Re[w.SymbolKind.Constructor]=n.SymbolKind.Constructor,Re[w.SymbolKind.Enum]=n.SymbolKind.Enum,Re[w.SymbolKind.Interface]=n.SymbolKind.Interface,Re[w.SymbolKind.Function]=n.SymbolKind.Function,Re[w.SymbolKind.Variable]=n.SymbolKind.Variable,Re[w.SymbolKind.Constant]=n.SymbolKind.Constant,Re[w.SymbolKind.String]=n.SymbolKind.String,Re[w.SymbolKind.Number]=n.SymbolKind.Number,Re[w.SymbolKind.Boolean]=n.SymbolKind.Boolean,Re[w.SymbolKind.Array]=n.SymbolKind.Array,Re[w.SymbolKind.Object]=n.SymbolKind.Object,Re[w.SymbolKind.Key]=n.SymbolKind.Key,Re[w.SymbolKind.Null]=n.SymbolKind.Null,Re[w.SymbolKind.EnumMember]=n.SymbolKind.EnumMember,Re[w.SymbolKind.Struct]=n.SymbolKind.Struct,Re[w.SymbolKind.Event]=n.SymbolKind.Event,Re[w.SymbolKind.Operator]=n.SymbolKind.Operator,Re[w.SymbolKind.TypeParameter]=n.SymbolKind.TypeParameter;function de(ye){return typeof Re[ye]=="number"?Re[ye]:n.SymbolKind.Property}De.from=de;function J(ye){for(const Be in Re)if(Re[Be]===ye)return Number(Be);return w.SymbolKind.Property}De.to=J})(we||(e.SymbolKind=we={}));var he;(function(De){function Re(J){switch(J){case w.SymbolTag.Deprecated:return n.SymbolTag.Deprecated}}De.from=Re;function de(J){switch(J){case n.SymbolTag.Deprecated:return w.SymbolTag.Deprecated}}De.to=de})(he||(e.SymbolTag=he={}));var X;(function(De){function Re(J){return{name:J.name,kind:we.from(J.kind),tags:J.tags&&J.tags.map(he.from),containerName:J.containerName,location:ze.from(J.location)}}De.from=Re;function de(J){const ye=new w.$8N(J.name,we.to(J.kind),J.containerName,ze.to(J.location));return ye.tags=J.tags&&J.tags.map(he.to),ye}De.to=de})(X||(e.WorkspaceSymbol=X={}));var x;(function(De){function Re(J){const ye={name:J.name||"!!MISSING: name!!",detail:J.detail,range:N.from(J.range),selectionRange:N.from(J.selectionRange),kind:we.from(J.kind),tags:J.tags?.map(he.from)??[]};return J.children&&(ye.children=J.children.map(Re)),ye}De.from=Re;function de(J){const ye=new w.$9N(J.name,J.detail,we.to(J.kind),N.to(J.range),N.to(J.selectionRange));return(0,v.$Kb)(J.tags)&&(ye.tags=J.tags.map(he.to)),J.children&&(ye.children=J.children.map(de)),ye}De.to=de})(x||(e.DocumentSymbol=x={}));var $e;(function(De){function Re(J){const ye=new w.$aO(we.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),N.to(J.range),N.to(J.selectionRange));return ye._sessionId=J._sessionId,ye._itemId=J._itemId,ye}De.to=Re;function de(J,ye,Be){if(ye=ye??J._sessionId,Be=Be??J._itemId,ye===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Be,name:J.name,detail:J.detail,kind:we.from(J.kind),uri:J.uri,range:N.from(J.range),selectionRange:N.from(J.selectionRange),tags:J.tags?.map(he.from)}}De.from=de})($e||(e.CallHierarchyItem=$e={}));var pe;(function(De){function Re(de){return new w.$bO($e.to(de.from),de.fromRanges.map(J=>N.to(J)))}De.to=Re})(pe||(e.CallHierarchyIncomingCall=pe={}));var Ae;(function(De){function Re(de){return new w.$cO($e.to(de.to),de.fromRanges.map(J=>N.to(J)))}De.to=Re})(Ae||(e.CallHierarchyOutgoingCall=Ae={}));var ze;(function(De){function Re(J){return{range:J.range&&N.from(J.range),uri:J.uri}}De.from=Re;function de(J){return new w.$1N(s.URI.revive(J.uri),N.to(J.range))}De.to=de})(ze||(e.location=ze={}));var Ie;(function(De){function Re(J){const ye=J,Be=J;return{originSelectionRange:ye.originSelectionRange?N.from(ye.originSelectionRange):void 0,uri:ye.targetUri?ye.targetUri:Be.uri,range:N.from(ye.targetRange?ye.targetRange:Be.range),targetSelectionRange:ye.targetSelectionRange?N.from(ye.targetSelectionRange):void 0}}De.from=Re;function de(J){return{targetUri:s.URI.revive(J.uri),targetRange:N.to(J.range),targetSelectionRange:J.targetSelectionRange?N.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?N.to(J.originSelectionRange):void 0}}De.to=de})(Ie||(e.DefinitionLink=Ie={}));var Pe;(function(De){function Re(J){return{range:N.from(J.range),contents:me.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}De.from=Re;function de(J){const ye=J.contents.map(me.to),Be=N.to(J.range),Ye=J.canIncreaseVerbosity,Ke=J.canDecreaseVerbosity;return new w.$5N(ye,Be,Ye,Ke)}De.to=de})(Pe||(e.Hover=Pe={}));var Oe;(function(De){function Re(J){return{range:N.from(J.range),expression:J.expression}}De.from=Re;function de(J){return new w.$ZO(N.to(J.range),J.expression)}De.to=de})(Oe||(e.EvaluatableExpression=Oe={}));var U;(function(De){function Re(J){if(J instanceof w.$1O)return{type:"text",range:N.from(J.range),text:J.text};if(J instanceof w.$2O)return{type:"variable",range:N.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof w.$3O)return{type:"expression",range:N.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Re;function de(J){switch(J.type){case"text":return{range:N.to(J.range),text:J.text};case"variable":return{range:N.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:N.to(J.range),expression:J.expression}}}De.to=de})(U||(e.InlineValue=U={}));var j;(function(De){function Re(J){return{frameId:J.frameId,stoppedLocation:N.from(J.stoppedLocation)}}De.from=Re;function de(J){return new w.$4O(J.frameId,N.to(J.stoppedLocation))}De.to=de})(j||(e.InlineValueContext=j={}));var K;(function(De){function Re(J){return{range:N.from(J.range),kind:J.kind}}De.from=Re;function de(J){return new w.$6N(N.to(J.range),J.kind)}De.to=de})(K||(e.DocumentHighlight=K={}));var V;(function(De){function Re(J){return{uri:J.uri,highlights:J.highlights.map(K.from)}}De.from=Re;function de(J){return new w.$7N(s.URI.revive(J.uri),J.highlights.map(K.to))}De.to=de})(V||(e.MultiDocumentHighlight=V={}));var re;(function(De){function Re(de){switch(de){case n.CompletionTriggerKind.TriggerCharacter:return w.CompletionTriggerKind.TriggerCharacter;case n.CompletionTriggerKind.TriggerForIncompleteCompletions:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case n.CompletionTriggerKind.Invoke:default:return w.CompletionTriggerKind.Invoke}}De.to=Re})(re||(e.CompletionTriggerKind=re={}));var ge;(function(De){function Re(de){return{triggerKind:re.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}De.to=Re})(ge||(e.CompletionContext=ge={}));var Ce;(function(De){function Re(J){switch(J){case w.CompletionItemTag.Deprecated:return n.CompletionItemTag.Deprecated}}De.from=Re;function de(J){switch(J){case n.CompletionItemTag.Deprecated:return w.CompletionItemTag.Deprecated}}De.to=de})(Ce||(e.CompletionItemTag=Ce={}));var Ue;(function(De){const Re=new Map([[w.CompletionItemKind.Method,n.CompletionItemKind.Method],[w.CompletionItemKind.Function,n.CompletionItemKind.Function],[w.CompletionItemKind.Constructor,n.CompletionItemKind.Constructor],[w.CompletionItemKind.Field,n.CompletionItemKind.Field],[w.CompletionItemKind.Variable,n.CompletionItemKind.Variable],[w.CompletionItemKind.Class,n.CompletionItemKind.Class],[w.CompletionItemKind.Interface,n.CompletionItemKind.Interface],[w.CompletionItemKind.Struct,n.CompletionItemKind.Struct],[w.CompletionItemKind.Module,n.CompletionItemKind.Module],[w.CompletionItemKind.Property,n.CompletionItemKind.Property],[w.CompletionItemKind.Unit,n.CompletionItemKind.Unit],[w.CompletionItemKind.Value,n.CompletionItemKind.Value],[w.CompletionItemKind.Constant,n.CompletionItemKind.Constant],[w.CompletionItemKind.Enum,n.CompletionItemKind.Enum],[w.CompletionItemKind.EnumMember,n.CompletionItemKind.EnumMember],[w.CompletionItemKind.Keyword,n.CompletionItemKind.Keyword],[w.CompletionItemKind.Snippet,n.CompletionItemKind.Snippet],[w.CompletionItemKind.Text,n.CompletionItemKind.Text],[w.CompletionItemKind.Color,n.CompletionItemKind.Color],[w.CompletionItemKind.File,n.CompletionItemKind.File],[w.CompletionItemKind.Reference,n.CompletionItemKind.Reference],[w.CompletionItemKind.Folder,n.CompletionItemKind.Folder],[w.CompletionItemKind.Event,n.CompletionItemKind.Event],[w.CompletionItemKind.Operator,n.CompletionItemKind.Operator],[w.CompletionItemKind.TypeParameter,n.CompletionItemKind.TypeParameter],[w.CompletionItemKind.Issue,n.CompletionItemKind.Issue],[w.CompletionItemKind.User,n.CompletionItemKind.User]]);function de(Be){return Re.get(Be)??n.CompletionItemKind.Property}De.from=de;const J=new Map([[n.CompletionItemKind.Method,w.CompletionItemKind.Method],[n.CompletionItemKind.Function,w.CompletionItemKind.Function],[n.CompletionItemKind.Constructor,w.CompletionItemKind.Constructor],[n.CompletionItemKind.Field,w.CompletionItemKind.Field],[n.CompletionItemKind.Variable,w.CompletionItemKind.Variable],[n.CompletionItemKind.Class,w.CompletionItemKind.Class],[n.CompletionItemKind.Interface,w.CompletionItemKind.Interface],[n.CompletionItemKind.Struct,w.CompletionItemKind.Struct],[n.CompletionItemKind.Module,w.CompletionItemKind.Module],[n.CompletionItemKind.Property,w.CompletionItemKind.Property],[n.CompletionItemKind.Unit,w.CompletionItemKind.Unit],[n.CompletionItemKind.Value,w.CompletionItemKind.Value],[n.CompletionItemKind.Constant,w.CompletionItemKind.Constant],[n.CompletionItemKind.Enum,w.CompletionItemKind.Enum],[n.CompletionItemKind.EnumMember,w.CompletionItemKind.EnumMember],[n.CompletionItemKind.Keyword,w.CompletionItemKind.Keyword],[n.CompletionItemKind.Snippet,w.CompletionItemKind.Snippet],[n.CompletionItemKind.Text,w.CompletionItemKind.Text],[n.CompletionItemKind.Color,w.CompletionItemKind.Color],[n.CompletionItemKind.File,w.CompletionItemKind.File],[n.CompletionItemKind.Reference,w.CompletionItemKind.Reference],[n.CompletionItemKind.Folder,w.CompletionItemKind.Folder],[n.CompletionItemKind.Event,w.CompletionItemKind.Event],[n.CompletionItemKind.Operator,w.CompletionItemKind.Operator],[n.CompletionItemKind.TypeParameter,w.CompletionItemKind.TypeParameter],[n.CompletionItemKind.User,w.CompletionItemKind.User],[n.CompletionItemKind.Issue,w.CompletionItemKind.Issue]]);function ye(Be){return J.get(Be)??w.CompletionItemKind.Property}De.to=ye})(Ue||(e.CompletionItemKind=Ue={}));var Qe;(function(De){function Re(de,J){const ye=new w.$kO(de.label);return ye.insertText=de.insertText,ye.kind=Ue.to(de.kind),ye.tags=de.tags?.map(Ce.to),ye.detail=de.detail,ye.documentation=A.$6k(de.documentation)?me.to(de.documentation):de.documentation,ye.sortText=de.sortText,ye.filterText=de.filterText,ye.preselect=de.preselect,ye.commitCharacters=de.commitCharacters,l.$Ot.isIRange(de.range)?ye.range=N.to(de.range):typeof de.range=="object"&&(ye.range={inserting:N.to(de.range.insert),replacing:N.to(de.range.replace)}),ye.keepWhitespace=typeof de.insertTextRules>"u"?!1:!!(de.insertTextRules&n.CompletionItemInsertTextRule.KeepWhitespace),typeof de.insertTextRules<"u"&&de.insertTextRules&n.CompletionItemInsertTextRule.InsertAsSnippet?ye.insertText=new w.$ZN(de.insertText):(ye.insertText=de.insertText,ye.textEdit=ye.range instanceof w.$ON?new w.$VN(ye.range,ye.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(ye.additionalTextEdits=de.additionalTextEdits.map(Be=>Ee.to(Be))),ye.command=J&&de.command?J.fromInternal(de.command):void 0,ye}De.to=Re})(Qe||(e.CompletionItem=Qe={}));var _e;(function(De){function Re(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:me.fromStrict(J.documentation)}}De.from=Re;function de(J){return{label:J.label,documentation:A.$6k(J.documentation)?me.to(J.documentation):J.documentation}}De.to=de})(_e||(e.ParameterInformation=_e={}));var tt;(function(De){function Re(J){return{label:J.label,documentation:me.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(_e.from):[],activeParameter:J.activeParameter}}De.from=Re;function de(J){return{label:J.label,documentation:A.$6k(J.documentation)?me.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(_e.to):[],activeParameter:J.activeParameter}}De.to=de})(tt||(e.SignatureInformation=tt={}));var nt;(function(De){function Re(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(tt.from):[]}}De.from=Re;function de(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(tt.to):[]}}De.to=de})(nt||(e.SignatureHelp=nt={}));var et;(function(De){function Re(de,J){const ye=new w.$jO(H.to(J.position),typeof J.label=="string"?J.label:J.label.map(rt.to.bind(void 0,de)),J.kind&&ft.to(J.kind));return ye.textEdits=J.textEdits&&J.textEdits.map(Ee.to),ye.tooltip=A.$6k(J.tooltip)?me.to(J.tooltip):J.tooltip,ye.paddingLeft=J.paddingLeft,ye.paddingRight=J.paddingRight,ye}De.to=Re})(et||(e.InlayHint=et={}));var rt;(function(De){function Re(de,J){const ye=new w.$iO(J.label);return ye.tooltip=A.$6k(J.tooltip)?me.to(J.tooltip):J.tooltip,n.Command.is(J.command)&&(ye.command=de.fromInternal(J.command)),J.location&&(ye.location=ze.to(J.location)),ye}De.to=Re})(rt||(e.InlayHintLabelPart=rt={}));var ft;(function(De){function Re(J){return J}De.from=Re;function de(J){return J}De.to=de})(ft||(e.InlayHintKind=ft={}));var lt;(function(De){function Re(J){return{range:N.from(J.range),url:J.target,tooltip:J.tooltip}}De.from=Re;function de(J){let ye;if(J.url)try{ye=typeof J.url=="string"?s.URI.parse(J.url,!0):s.URI.revive(J.url)}catch{}const Be=new w.$pO(N.to(J.range),ye);return Be.tooltip=J.tooltip,Be}De.to=de})(lt||(e.DocumentLink=lt={}));var st;(function(De){function Re(J){const ye=new w.$sO(J.label);return J.textEdit&&(ye.textEdit=Ee.to(J.textEdit)),J.additionalTextEdits&&(ye.additionalTextEdits=J.additionalTextEdits.map(Be=>Ee.to(Be))),ye}De.to=Re;function de(J){return{label:J.label,textEdit:J.textEdit?Ee.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(ye=>Ee.from(ye)):void 0}}De.from=de})(st||(e.ColorPresentation=st={}));var ct;(function(De){function Re(J){return new w.$qO(J[0],J[1],J[2],J[3])}De.to=Re;function de(J){return[J.red,J.green,J.blue,J.alpha]}De.from=de})(ct||(e.Color=ct={}));var mt;(function(De){function Re(J){return{range:N.from(J.range)}}De.from=Re;function de(J){return new w.$_N(N.to(J.range))}De.to=de})(mt||(e.SelectionRange=mt={}));var $t;(function(De){function Re(de){switch(de){case m.SaveReason.AUTO:return w.TextDocumentSaveReason.AfterDelay;case m.SaveReason.EXPLICIT:return w.TextDocumentSaveReason.Manual;case m.SaveReason.FOCUS_CHANGE:case m.SaveReason.WINDOW_CHANGE:return w.TextDocumentSaveReason.FocusOut}}De.to=Re})($t||(e.TextDocumentSaveReason=$t={}));var We;(function(De){function Re(J){switch(J){case w.TextEditorLineNumbersStyle.Off:return c.RenderLineNumbersType.Off;case w.TextEditorLineNumbersStyle.Relative:return c.RenderLineNumbersType.Relative;case w.TextEditorLineNumbersStyle.Interval:return c.RenderLineNumbersType.Interval;case w.TextEditorLineNumbersStyle.On:default:return c.RenderLineNumbersType.On}}De.from=Re;function de(J){switch(J){case c.RenderLineNumbersType.Off:return w.TextEditorLineNumbersStyle.Off;case c.RenderLineNumbersType.Relative:return w.TextEditorLineNumbersStyle.Relative;case c.RenderLineNumbersType.Interval:return w.TextEditorLineNumbersStyle.Interval;case c.RenderLineNumbersType.On:default:return w.TextEditorLineNumbersStyle.On}}De.to=de})(We||(e.TextEditorLineNumbersStyle=We={}));var je;(function(De){function Re(J){if(J===w.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(J===w.EndOfLine.LF)return t.EndOfLineSequence.LF}De.from=Re;function de(J){if(J===t.EndOfLineSequence.CRLF)return w.EndOfLine.CRLF;if(J===t.EndOfLineSequence.LF)return w.EndOfLine.LF}De.to=de})(je||(e.EndOfLine=je={}));var ie;(function(De){function Re(de){if(typeof de=="object")return de.viewId;switch(de){case w.ProgressLocation.SourceControl:return u.ProgressLocation.Scm;case w.ProgressLocation.Window:return u.ProgressLocation.Window;case w.ProgressLocation.Notification:return u.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}De.from=Re})(ie||(e.ProgressLocation=ie={}));var ee;(function(De){function Re(J){const ye={start:J.start+1,end:J.end+1};return J.kind&&(ye.kind=Z.from(J.kind)),ye}De.from=Re;function de(J){const ye={start:J.start-1,end:J.end-1};return J.kind&&(ye.kind=Z.to(J.kind)),ye}De.to=de})(ee||(e.FoldingRange=ee={}));var Z;(function(De){function Re(J){if(J)switch(J){case w.FoldingRangeKind.Comment:return n.$Pu.Comment;case w.FoldingRangeKind.Imports:return n.$Pu.Imports;case w.FoldingRangeKind.Region:return n.$Pu.Region}}De.from=Re;function de(J){if(J)switch(J.value){case n.$Pu.Comment.value:return w.FoldingRangeKind.Comment;case n.$Pu.Imports.value:return w.FoldingRangeKind.Imports;case n.$Pu.Region.value:return w.FoldingRangeKind.Region}}De.to=de})(Z||(e.FoldingRangeKind=Z={}));var Xe;(function(De){function Re(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?N.from(de.selection):void 0,override:typeof de.override=="boolean"?m.$5F.id:void 0}}De.from=Re})(Xe||(e.TextEditorOpenOptions=Xe={}));var xe;(function(De){function Re(Be){return Be instanceof w.$NO?Be.toJSON():typeof Be=="string"?Be:de(Be)||J(Be)?new w.$NO(Be.baseUri??Be.base,Be.pattern).toJSON():Be}De.from=Re;function de(Be){const Ye=Be;return Ye?s.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function J(Be){const Ye=Be;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function ye(Be){return typeof Be=="string"?Be:new w.$NO(s.URI.revive(Be.baseUri),Be.pattern)}De.to=ye})(xe||(e.GlobPattern=xe={}));var ht;(function(De){function Re(de){if(de){if(Array.isArray(de))return de.map(Re);if(typeof de=="string")return de;{const J=de;return{language:J.language,scheme:J.scheme,pattern:xe.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}De.from=Re})(ht||(e.LanguageSelector=ht={}));var wt;(function(De){function Re(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(ye=>Array.isArray(ye)&&ye.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&s.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Ye=>Ye instanceof w.$ON)))}De.is=Re;function de(J){return{documents:J.documents.map(ye=>ye.map(Be=>({uri:s.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Ye=>N.from(Ye))})))}}De.from=de})(wt||(e.MappedEditsContext=wt={}));var Ft;(function(De){function Re(J){return{start:J.start,end:J.end}}De.from=Re;function de(J){return new w.$eP(J.start,J.end)}De.to=de})(Ft||(e.NotebookRange=Ft={}));var Kt;(function(De){function Re(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}De.to=Re;function de(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}De.from=de})(Kt||(e.NotebookCellExecutionSummary=Kt={}));var _t;(function(De){function Re(de){if(de===b.NotebookCellExecutionState.Unconfirmed)return w.NotebookCellExecutionState.Pending;if(de===b.NotebookCellExecutionState.Pending)return;if(de===b.NotebookCellExecutionState.Executing)return w.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}De.to=Re})(_t||(e.NotebookCellExecutionState=_t={}));var ei;(function(De){function Re(J){switch(J){case w.NotebookCellKind.Markup:return b.CellKind.Markup;case w.NotebookCellKind.Code:default:return b.CellKind.Code}}De.from=Re;function de(J){switch(J){case b.CellKind.Markup:return w.NotebookCellKind.Markup;case b.CellKind.Code:default:return w.NotebookCellKind.Code}}De.to=de})(ei||(e.NotebookCellKind=ei={}));var oi;(function(De){function Re(J){const ye={metadata:J.metadata??Object.create(null),cells:[]};for(const Be of J.cells)w.$fP.validate(Be),ye.cells.push(At.from(Be));return ye}De.from=Re;function de(J){const ye=new w.$gP(J.cells.map(At.to));return(0,r.$rg)(J.metadata)||(ye.metadata=J.metadata),ye}De.to=de})(oi||(e.NotebookData=oi={}));var At;(function(De){function Re(J){return{cellKind:ei.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:Kt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Ct.from):[]}}De.from=Re;function de(J){return new w.$fP(ei.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Ct.to):void 0,J.metadata,J.internalMetadata?Kt.to(J.internalMetadata):void 0)}De.to=de})(At||(e.NotebookCellData=At={}));var Ze;(function(De){function Re(J){return{mime:J.mime,valueBytes:R.$Ne.wrap(J.data)}}De.from=Re;function de(J){return new w.$hP(J.valueBytes.buffer,J.mime)}De.to=de})(Ze||(e.NotebookCellOutputItem=Ze={}));var Ct;(function(De){function Re(J){return{outputId:J.id,items:J.items.map(Ze.from),metadata:J.metadata}}De.from=Re;function de(J){const ye=J.items.map(Ze.to);return new w.$iP(ye,J.outputId,J.metadata)}De.to=de})(Ct||(e.NotebookCellOutput=Ct={}));var hi;(function(De){function Re(ye){return J(ye)?{include:xe.from(ye.include)??void 0,exclude:xe.from(ye.exclude)??void 0}:xe.from(ye)??void 0}De.from=Re;function de(ye){return J(ye)?{include:xe.to(ye.include),exclude:xe.to(ye.exclude)}:xe.to(ye)}De.to=de;function J(ye){const Be=ye;return Be?!(0,r.$ng)(Be.include)&&!(0,r.$ng)(Be.exclude):!1}})(hi||(e.NotebookExclusiveDocumentPattern=hi={}));var pt;(function(De){function Re(de,J,ye){const Be=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===w.NotebookCellStatusBarAlignment.Left?b.CellStatusbarAlignment.Left:b.CellStatusbarAlignment.Right,command:J.toInternal(Be,ye),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}De.from=Re})(pt||(e.NotebookStatusBarItem=pt={}));var Dt;(function(De){function Re(de,J,ye){const Be=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{command:J.toInternal(Be,ye),label:de.label,description:de.description,detail:de.detail,documentation:de.documentation}}De.from=Re})(Dt||(e.NotebookKernelSourceAction=Dt={}));var ti;(function(De){function Re(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}De.from=Re})(ti||(e.NotebookDocumentContentOptions=ti={}));var ii;(function(De){function Re(J){return{uri:J.uri,provides:J.provides}}De.from=Re;function de(J){return new w.$kP(s.URI.revive(J.uri),J.provides)}De.to=de})(ii||(e.NotebookRendererScript=ii={}));var jt;(function(De){function Re(J){return{message:me.fromStrict(J.message)||"",type:k.TestMessageType.Error,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:N.from(J.location.range),uri:J.location.uri},stackTrace:J.stackTrace?.map(ye=>({label:ye.label,position:ye.position&&H.from(ye.position),uri:ye.file&&s.URI.revive(ye.file).toJSON()}))}}De.from=Re;function de(J){const ye=new w.$qP(typeof J.message=="string"?J.message:me.to(J.message));return ye.actualOutput=J.actual,ye.expectedOutput=J.expected,ye.contextValue=J.contextValue,ye.location=J.location?ze.to(J.location):void 0,ye}De.to=de})(jt||(e.TestMessage=jt={}));var gt;(function(De){De.namespace=k.$_I,De.denamespace=k.$aJ})(gt||(e.TestTag=gt={}));var Ut;(function(De){function Re(J){const ye=(0,$.$gQ)(J).controllerId;return{extId:C.$7I.fromExtHostTestItem(J,ye).toString(),label:J.label,uri:s.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Be=>gt.namespace(ye,Be.id)),range:l.$Ot.lift(N.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&me.fromStrict(J.error)||null}}De.from=Re;function de(J){return{parent:void 0,error:void 0,id:C.$7I.fromString(J.extId).localId,label:J.label,uri:s.URI.revive(J.uri),tags:(J.tags||[]).map(ye=>{const{tagId:Be}=gt.denamespace(ye);return new w.$rP(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}De.toPlain=de})(Ut||(e.TestItem=Ut={})),function(De){function Re(J){return{id:J.id}}De.from=Re;function de(J){return new w.$rP(J.id)}De.to=de}(gt||(e.TestTag=gt={}));var ni;(function(De){const Re=(J,ye)=>{const Be=J.value;if(!Be)return;const Ye={...Ut.toPlain(Be.item),parent:ye,taskStates:Be.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(ut=>ut.type===k.TestMessageType.Error).map(jt.to)})),children:[]};if(J.children)for(const Ke of J.children.values()){const ut=Re(Ke,Ye);ut&&Ye.children.push(ut)}return Ye};function de(J){const ye=new a.$6I;for(const Ke of J.items)ye.insert(C.$7I.fromString(Ke.item.extId).path,Ke);const Be=[ye.nodes],Ye=[];for(;Be.length;)for(const Ke of Be.pop())Ke.value?Ye.push(Ke):Ke.children&&Be.push(Ke.children.values());return{completedAt:J.completedAt,results:Ye.map(Ke=>Re(Ke)).filter(r.$mg)}}De.to=de})(ni||(e.TestResults=ni={}));var ai;(function(De){function Re(Be){return{covered:Be.covered,total:Be.total}}function de(Be){return"line"in Be?H.from(Be):N.from(Be)}function J(Be){if(typeof Be.executed=="number"&&Be.executed<0)throw new Error(`Invalid coverage count ${Be.executed}`);return"branches"in Be?{count:Be.executed,location:de(Be.location),type:k.DetailType.Statement,branches:Be.branches.length?Be.branches.map(Ye=>({count:Ye.executed,location:Ye.location&&de(Ye.location),label:Ye.label})):void 0}:{type:k.DetailType.Declaration,name:Be.name,count:Be.executed,location:de(Be.location)}}De.fromDetails=J;function ye(Be,Ye,Ke){return w.$uP(Ke.statementCoverage),w.$uP(Ke.branchCoverage),w.$uP(Ke.declarationCoverage),{id:Ye,uri:Ke.uri,statement:Re(Ke.statementCoverage),branch:Ke.branchCoverage&&Re(Ke.branchCoverage),declaration:Ke.declarationCoverage&&Re(Ke.declarationCoverage),testIds:Ke instanceof w.$vP&&Ke.fromTests.length?Ke.fromTests.map(ut=>C.$7I.fromExtHostTestItem(ut,Be).toString()):void 0}}De.fromFile=ye})(ai||(e.TestCoverage=ai={}));var Ge;(function(De){function Re(de){switch(de){case n.CodeActionTriggerType.Invoke:return w.CodeActionTriggerKind.Invoke;case n.CodeActionTriggerType.Auto:return w.CodeActionTriggerKind.Automatic}}De.to=Re})(Ge||(e.CodeActionTriggerKind=Ge={}));var ci;(function(De){function Re(J){const ye=new w.$zP(we.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),N.to(J.range),N.to(J.selectionRange));return ye._sessionId=J._sessionId,ye._itemId=J._itemId,ye}De.to=Re;function de(J,ye,Be){if(ye=ye??J._sessionId,Be=Be??J._itemId,ye===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Be,kind:we.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:N.from(J.range),selectionRange:N.from(J.selectionRange),tags:J.tags?.map(he.from)}}De.from=de})(ci||(e.TypeHierarchyItem=ci={}));var di;(function(De){function Re(de){if(de)return{value:de.value,tooltip:de.tooltip}}De.from=Re})(di||(e.ViewBadge=di={}));var fi;(function(De){function Re(Be,Ye,Ke){const ut=Ye.fileData;return ut?new w.$FO(new w.$GO(ut.name,s.URI.revive(ut.uri),ut.id,(0,O.$cb)(()=>Ke(ut.id)))):Be===I.$$s.uriList&&Ye.uriListData?new w.$EO(ye(Ye.uriListData)):new w.$EO(Ye.asString)}De.to=Re;async function de(Be,Ye){const Ke=await Ye.asString();if(Be===I.$$s.uriList)return{asString:Ke,fileData:void 0,uriListData:J(Ke)};const ut=Ye.asFile();return{asString:Ke,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}De.from=de;function J(Be){return P.$tu.split(Be).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return s.URI.parse(Ye)}catch{}return Ye})}function ye(Be){return P.$tu.create(Be.map(Ye=>typeof Ye=="string"?Ye:s.URI.revive(Ye)))}})(fi||(e.DataTransferItem=fi={}));var vt;(function(De){function Re(J,ye){const Be=J.items.map(([Ye,Ke])=>[Ye,fi.to(Ye,Ke,ye)]);return new w.$HO(Be)}De.toDataTransfer=Re;async function de(J){const ye={items:[]},Be=[];for(const[Ye,Ke]of J)Be.push((async()=>{ye.items.push([Ye,await fi.from(Ye,Ke)])})());return await Promise.all(Be),ye}De.from=de})(vt||(e.DataTransfer=vt={}));var Mt;(function(De){function Re(J,ye){return{kind:"reply",agentId:J.participant??ye?.agentId??"",subCommand:J.command??ye?.command,message:J.prompt,title:J.label}}De.from=Re;function de(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}De.to=de})(Mt||(e.ChatFollowup=Mt={}));var Nt;(function(De){function Re(J){switch(J){case E.ChatMessageRole.System:return w.LanguageModelChatMessageRole.System;case E.ChatMessageRole.User:return w.LanguageModelChatMessageRole.User;case E.ChatMessageRole.Assistant:return w.LanguageModelChatMessageRole.Assistant}}De.to=Re;function de(J){switch(J){case w.LanguageModelChatMessageRole.System:return E.ChatMessageRole.System;case w.LanguageModelChatMessageRole.User:return E.ChatMessageRole.User;case w.LanguageModelChatMessageRole.Assistant:return E.ChatMessageRole.Assistant}return E.ChatMessageRole.User}De.from=de})(Nt||(e.LanguageModelChatMessageRole=Nt={}));var qt;(function(De){function Re(J){let ye="",Be;J.content.type==="text"?ye=J.content.value:Be=new w.$4P(J.content.name,J.content.value,J.content.isError);const Ye=Nt.to(J.role),Ke=new w.$5P(Ye,ye,J.name);return Be!==void 0&&(Ke.content2=Be),Ke}De.to=Re;function de(J){const ye=Nt.from(J.role),Be=J.name;let Ye;return J.content2 instanceof w.$4P?Ye={type:"function_result",name:J.content2.name,value:J.content2.content,isError:J.content2.isError}:Ye={type:"text",value:J.content},{role:ye,name:Be,content:Ye}}De.from=de})(qt||(e.LanguageModelChatMessage=qt={}));var ri;(function(De){function Re(J){return{kind:"markdownContent",content:me.from(J.value)}}De.from=Re;function de(J){return new w.$MP(me.to(J.content))}De.to=de})(ri||(e.ChatResponseMarkdownPart=ri={}));var Ht;(function(De){function Re(J){return{kind:"markdownVuln",content:me.from(J.value),vulnerabilities:J.vulnerabilities}}De.from=Re;function de(J){return new w.$NP(me.to(J.content),J.vulnerabilities)}De.to=de})(Ht||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Ht={}));var li;(function(De){function Re(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}De.from=Re;function de(J){return new w.$OP(J.agentId,J.command)}De.to=de})(li||(e.ChatResponseDetectedParticipantPart=li={}));var Bt;(function(De){function Re(de){return{kind:"confirmation",title:de.title,message:de.message,data:de.data,buttons:de.buttons}}De.from=Re})(Bt||(e.ChatResponseConfirmationPart=Bt={}));var Qt;(function(De){function Re(J){const{value:ye,baseUri:Be}=J;function Ye(Ke,ut){return Ke.map(Rt=>{const Jt=s.URI.joinPath(ut,Rt.name);return{label:Rt.name,uri:Jt,children:Rt.children&&Ye(Rt.children,Jt)}})}return{kind:"treeData",treeData:{label:(0,S.$dh)(Be),uri:Be,children:Ye(ye,Be)}}}De.from=Re;function de(J){const ye=(0,o.$ci)(J.treeData);function Be(ut){return ut.map(Rt=>({name:Rt.label,children:Rt.children&&Be(Rt.children)}))}const Ye=ye.uri,Ke=ye.children?Be(ye.children):[];return new w.$QP(Ke,Ye)}De.to=de})(Qt||(e.ChatResponseFilesPart=Qt={}));var Gt;(function(De){function Re(J){const ye=Be=>s.URI.isUri(Be);return{kind:"inlineReference",name:J.title,inlineReference:ye(J.value)?J.value:L.from(J.value)}}De.from=Re;function de(J){const ye=(0,o.$ci)(J);return new w.$RP(s.URI.isUri(ye.inlineReference)?ye.inlineReference:L.to(ye.inlineReference),J.name)}De.to=de})(Gt||(e.ChatResponseAnchorPart=Gt={}));var Lt;(function(De){function Re(J){return{kind:"progressMessage",content:me.from(J.value)}}De.from=Re;function de(J){return new w.$SP(J.content.value)}De.to=de})(Lt||(e.ChatResponseProgressPart=Lt={}));var bt;(function(De){function Re(J){return{kind:"warning",content:me.from(J.value)}}De.from=Re;function de(J){return new w.$UP(J.content.value)}De.to=de})(bt||(e.ChatResponseWarningPart=bt={}));var kt;(function(De){function Re(de){return{kind:"progressTask",content:me.from(de.value)}}De.from=Re})(kt||(e.ChatTask=kt={}));var Vt;(function(De){function Re(de){return{kind:"progressTaskResult",content:typeof de=="string"?me.from(de):void 0}}De.from=Re})(Vt||(e.ChatTaskResult=Vt={}));var It;(function(De){function Re(J,ye,Be){return{kind:"command",command:ye.toInternal(J.value,Be)??{command:J.value.command,title:J.value.title}}}De.from=Re;function de(J,ye){return new w.$VP(ye.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}De.to=de})(It||(e.ChatResponseCommandButtonPart=It={}));var mi;(function(De){function Re(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(ye=>Ee.from(ye))}}De.from=Re;function de(J){return new w.$YP(s.URI.revive(J.uri),J.edits.map(ye=>Ee.to(ye)))}De.to=de})(mi||(e.ChatResponseTextEditPart=mi={}));var Yt;(function(De){function Re(J){const ye=d.ThemeIcon.isThemeIcon(J.iconPath)?J.iconPath:s.URI.isUri(J.iconPath)?{light:s.URI.revive(J.iconPath)}:J.iconPath&&"light"in J.iconPath&&"dark"in J.iconPath&&s.URI.isUri(J.iconPath.light)&&s.URI.isUri(J.iconPath.dark)?{light:s.URI.revive(J.iconPath.light),dark:s.URI.revive(J.iconPath.dark)}:void 0;return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:s.URI.isUri(J.value.value)||!J.value.value?J.value.value:L.from(J.value.value)},iconPath:ye,options:J.options}:{kind:"reference",reference:s.URI.isUri(J.value)?J.value:L.from(J.value),iconPath:ye,options:J.options}}De.from=Re;function de(J){const ye=(0,o.$ci)(J),Be=Ye=>s.URI.isUri(Ye)?Ye:L.to(Ye);return new w.$WP("variableName"in ye.reference?{variableName:ye.reference.variableName,value:ye.reference.value&&Be(ye.reference.value)}:Be(ye.reference))}De.to=de})(Yt||(e.ChatResponseReferencePart=Yt={}));var ki;(function(De){function Re(de){return{kind:"codeCitation",value:de.value,license:de.license,snippet:de.snippet}}De.from=Re})(ki||(e.ChatResponseCodeCitationPart=ki={}));var bi;(function(De){function Re(ye,Be,Ye){return ye instanceof w.$MP?ri.from(ye):ye instanceof w.$RP?Gt.from(ye):ye instanceof w.$WP?Yt.from(ye):ye instanceof w.$SP?Lt.from(ye):ye instanceof w.$QP?Qt.from(ye):ye instanceof w.$VP?It.from(ye,Be,Ye):ye instanceof w.$YP?mi.from(ye):ye instanceof w.$NP?Ht.from(ye):ye instanceof w.$OP?li.from(ye):ye instanceof w.$UP?bt.from(ye):ye instanceof w.$PP?Bt.from(ye):ye instanceof w.$XP?ki.from(ye):{kind:"markdownContent",content:me.from("")}}De.from=Re;function de(ye,Be){switch(ye.kind){case"reference":return Yt.to(ye);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(ye,Be)}}De.to=de;function J(ye,Be){switch(ye.kind){case"markdownContent":return ri.to(ye);case"inlineReference":return Gt.to(ye);case"progressMessage":return;case"treeData":return Qt.to(ye);case"command":return It.to(ye,Be)}}De.toContent=J})(bi||(e.ChatResponsePart=bi={}));var Ai;(function(De){function Re(de,J){const ye=de.variables.variables.filter(Ye=>Ye.isTool).map(Ye=>Ye.id),Be=de.variables.variables.filter(Ye=>!Ye.isTool);return{prompt:de.message,command:de.command,attempt:de.attempt??0,enableCommandDetection:de.enableCommandDetection??!0,references:Be.map(Ni.to),location:Tt.to(de.location),acceptedConfirmationData:de.acceptedConfirmationData,rejectedConfirmationData:de.rejectedConfirmationData,location2:J,requestedTools:ye}}De.to=Re})(Ai||(e.ChatAgentRequest=Ai={}));var Tt;(function(De){function Re(J){switch(J){case h.ChatAgentLocation.Notebook:return w.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return w.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return w.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return w.ChatLocation.Editor}}De.to=Re;function de(J){switch(J){case w.ChatLocation.Notebook:return h.ChatAgentLocation.Notebook;case w.ChatLocation.Terminal:return h.ChatAgentLocation.Terminal;case w.ChatLocation.Panel:return h.ChatAgentLocation.Panel;case w.ChatLocation.Editor:return h.ChatAgentLocation.Editor}}De.from=de})(Tt||(e.ChatLocation=Tt={}));var Ni;(function(De){function Re(de){const J=de.value;if(!J)throw new Error("Invalid value reference");return{id:de.id,name:de.name,range:de.range&&[de.range.start,de.range.endExclusive],value:(0,s.$vc)(J)?s.URI.revive(J):J&&typeof J=="object"&&"uri"in J&&"range"in J&&(0,s.$vc)(J.uri)?L.to((0,o.$ci)(J)):J,modelDescription:de.modelDescription}}De.to=Re})(Ni||(e.ChatAgentValueReference=Ni={}));var ui;(function(De){function Re(de,J,ye){return{id:de.id,label:de.label,fullName:de.fullName,icon:de.icon?.id,value:de.values[0].value,insertText:de.insertText,detail:de.detail,documentation:de.documentation,command:J.toInternal(de.command,ye)}}De.from=Re})(ui||(e.ChatAgentCompletionItem=ui={}));var Pt;(function(De){function Re(de){return{errorDetails:de.errorDetails,metadata:de.metadata}}De.to=Re})(Pt||(e.ChatAgentResult=Pt={}));var Ti;(function(De){function Re(de,J,ye){if(J.action.kind==="vote")return;const Be=Pt.to(de);if(J.action.kind==="command"){const Ye=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:ye.fromInternal(Ye)??{command:Ye.id,title:Ye.title}}},result:Be}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:Mt.to(J.action.followup)},result:Be}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:Be}:{action:J.action,result:Be}}De.to=Re})(Ti||(e.ChatAgentUserActionEvent=Ti={}));var Ii;(function(De){function Re(de,J,ye){return"terminalCommand"in de?{terminalCommand:de.terminalCommand,shouldExecute:de.shouldExecute}:"uri"in de?{uri:de.uri}:J.toInternal(de,ye)}De.from=Re})(Ii||(e.TerminalQuickFix=Ii={}));var Di;(function(De){function Re(de){return{kind:Li.to(de.kind)}}De.to=Re})(Di||(e.PartialAcceptInfo=Di={}));var Li;(function(De){function Re(de){switch(de){case n.PartialAcceptTriggerKind.Word:return w.PartialAcceptTriggerKind.Word;case n.PartialAcceptTriggerKind.Line:return w.PartialAcceptTriggerKind.Line;case n.PartialAcceptTriggerKind.Suggest:return w.PartialAcceptTriggerKind.Suggest;default:return w.PartialAcceptTriggerKind.Unknown}}De.to=Re})(Li||(e.PartialAcceptTriggerKind=Li={}));var wi;(function(De){function Re(de,J){return{id:J,label:de.label,description:de.description,canEdit:de.canEdit,collapsibleState:de.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:de.contextValue}}De.from=Re})(wi||(e.DebugTreeItem=wi={}));var Wt;(function(De){function Re(de){return{name:de.name,description:de.description,parametersSchema:de.parametersSchema}}De.to=Re})(Wt||(e.LanguageModelToolDescription=Wt={}))}),define(Ne[232],Le([1,0,5,16,8,39]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Epc=void 0;let A=class{constructor(p,o){this.a=p.getProxy(v.$KN.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>o.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,o,I){const y=new O.$Xw(P.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,I?.isRefactoring??!1)}};e.$Epc=A,e.$Epc=A=Je([Ve(0,R.$kQ)],A)}),define(Ne[233],Le([1,0,17,10,42,6,40,4,36,69,14,2,18,5,8,7,115,194,24]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fpc=void 0,d=qe(d),r=qe(r);class i{constructor(u,$,m,h,E){this.j=u,this.k=$,this.l=m,this.m=h,this.n=E,this.b=o.$fe.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let $=function(h){if(u.c){const E=new Error("Response stream has been closed");throw Error.captureStackTrace(E,h),E}};const u=this;this.b.reset();const m=(h,E)=>{if(typeof this.d>"u"&&"content"in h&&(this.d=this.b.elapsed()),E){const D=this.l.$handleProgressChunk(this.k.requestId,h),b={report:C=>{D?.then(k=>{k&&(r.$eO.isMarkdownString(C.value)?this.l.$handleProgressChunk(this.k.requestId,d.ChatResponseWarningPart.from(C),k):this.l.$handleProgressChunk(this.k.requestId,d.ChatResponseReferencePart.from(C),k))})}};Promise.all([D,E?.(b)]).then(([C,k])=>{C!==void 0&&k!==void 0&&this.l.$handleProgressChunk(this.k.requestId,d.ChatTaskResult.from(k),C)})}else this.l.$handleProgressChunk(this.k.requestId,h)};this.g={markdown(h){$(this.markdown);const E=new r.$MP(h),D=d.ChatResponseMarkdownPart.from(E);return m(D),this},markdownWithVulnerabilities(h,E){$(this.markdown),E&&(0,l.$gH)(u.j,"chatParticipantAdditions");const D=new r.$NP(h,E),b=d.ChatResponseMarkdownWithVulnerabilitiesPart.from(D);return m(b),this},filetree(h,E){$(this.filetree);const D=new r.$QP(h,E),b=d.ChatResponseFilesPart.from(D);return m(b),this},anchor(h,E){$(this.anchor);const D=new r.$RP(h,E),b=d.ChatResponseAnchorPart.from(D);return m(b),this},button(h){$(this.anchor);const E=new r.$VP(h),D=d.ChatResponseCommandButtonPart.from(E,u.m,u.n);return m(D),this},progress(h,E){$(this.progress);const D=new r.$TP(h,E),b=E?d.ChatTask.from(D):d.ChatResponseProgressPart.from(D);return m(b,E),this},warning(h){$(this.progress),(0,l.$gH)(u.j,"chatParticipantAdditions");const E=new r.$UP(h),D=d.ChatResponseWarningPart.from(E);return m(D),this},reference(h,E){return this.reference2(h,E)},reference2(h,E,D){if($(this.reference),"variableName"in h&&(0,l.$gH)(u.j,"chatParticipantAdditions"),"variableName"in h&&!h.value){const b=u.k.variables.variables.find(C=>C.name===h.variableName);if(b){let C;if(b.references?.length)C=b.references.map(k=>({kind:"reference",reference:{variableName:h.variableName,value:k.reference}}));else{const k=new r.$WP(h,E,D);C=[d.ChatResponseReferencePart.from(k)]}return C.forEach(k=>m(k)),this}}else{const b=new r.$WP(h,E,D),C=d.ChatResponseReferencePart.from(b);m(C)}return this},codeCitation(h,E,D){$(this.codeCitation),(0,l.$gH)(u.j,"chatParticipantAdditions");const b=new r.$XP(h,E,D),C=d.ChatResponseCodeCitationPart.from(b);m(C)},textEdit(h,E){$(this.textEdit),(0,l.$gH)(u.j,"chatParticipantAdditions");const D=new r.$YP(h,E),b=d.ChatResponseTextEditPart.from(D);return m(b),this},detectedParticipant(h,E){$(this.detectedParticipant),(0,l.$gH)(u.j,"chatParticipantAdditions");const D=new r.$OP(h,E),b=d.ChatResponseDetectedParticipantPart.from(D);return m(b),this},confirmation(h,E,D,b){$(this.confirmation),(0,l.$gH)(u.j,"chatParticipantAdditions");const C=new r.$PP(h,E,D,b),k=d.ChatResponseConfirmationPart.from(C);return m(k),this},push(h){if($(this.push),(h instanceof r.$YP||h instanceof r.$NP||h instanceof r.$OP||h instanceof r.$UP||h instanceof r.$PP||h instanceof r.$XP)&&(0,l.$gH)(u.j,"chatParticipantAdditions"),h instanceof r.$WP)this.reference2(h.value,h.iconPath,h.options);else{const E=d.ChatResponsePart.from(h,u.m,u.n);m(E)}return this}}}return this.g}}class n extends T.$Uc{static{this.b=0}constructor(u,$,m,h){super(),this.n=$,this.s=m,this.t=h,this.c=new Map,this.j=this.B(new T.$4c),this.m=this.B(new T.$4c),this.g=u.getProxy(S.$KN.MainThreadChatAgents2)}transferActiveChat(u){this.g.$transferActiveChatSession(u)}createChatAgent(u,$,m){const h=n.b++,E=new t(u,$,this.g,h,m);return this.c.set(h,E),this.g.$registerAgent(h,u.identifier,$,{},void 0),E.apiAgent}createDynamicChatAgent(u,$,m,h){const E=n.b++,D=new t(u,$,this.g,E,h);return this.c.set(E,D),this.g.$registerAgent(E,u.identifier,$,{isSticky:!0},m),D.apiAgent}async $invokeAgent(u,$,m,h){const E=this.c.get(u);if(!E)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);const D=(0,p.$ci)($);let b=this.j.get(D.sessionId);b||(b=new T.$Tc,this.j.set(D.sessionId,b));const C=new i(E.extension,D,this.g,this.s.converter,b);try{const k=await this.u(D.agentId,m);let f;if(D.locationData?.type===s.ChatAgentLocation.Editor){const F=this.t.getDocument(D.locationData.document);f=new r.$2P(F,d.Selection.to(D.locationData.selection),d.Range.to(D.locationData.wholeRange))}else if(D.locationData?.type===s.ChatAgentLocation.Notebook){const F=this.t.getDocument(D.locationData.sessionInputUri);f=new r.$3P(F)}else D.locationData?.type,s.ChatAgentLocation.Terminal;const w=E.invoke(d.ChatAgentRequest.to(D,f),{history:k},C.apiObject,h);return await(0,R.$th)(Promise.resolve(w).then(F=>{if(F?.metadata)try{JSON.stringify(F.metadata)}catch(L){const q=`result.metadata MUST be JSON.stringify-able. Got error: ${L.message}`;return this.n.error(`[${E.extension.identifier.value}] [@${E.id}] ${q}`,E.extension),{errorDetails:{message:q},timings:C.timings}}let N;return F?.errorDetails&&(N={...F.errorDetails,responseIsIncomplete:!0}),N?.responseIsRedacted&&(0,l.$gH)(E.extension,"chatParticipantPrivate"),{errorDetails:N,timings:C.timings,metadata:F?.metadata}}),h)}catch(k){return this.n.error(k,E.extension),k instanceof r.$$P&&k.cause&&(k=k.cause),{errorDetails:{message:(0,P.$qj)(k),responseIsIncomplete:!0}}}finally{C.close()}}async u(u,$){const m=[];for(const h of $.history){const E=d.ChatAgentResult.to(h.result),D=u===h.request.agentId?E:{...E,metadata:void 0},b=h.request.variables.variables.filter(k=>!k.isTool).map(d.ChatAgentValueReference.to);m.push(new r.$ZP(h.request.message,h.request.command,b,h.request.agentId));const C=(0,v.$Gb)(h.response.map(k=>d.ChatResponsePart.toContent(k,this.s.converter)));m.push(new r.$1P(C,D,h.request.agentId,h.request.command))}return m}$releaseSession(u){this.j.deleteAndDispose(u)}async $provideFollowups(u,$,m,h,E){const D=this.c.get($);if(!D)return Promise.resolve([]);const b=(0,p.$ci)(u),C=await this.u(D.id,h),k=d.ChatAgentResult.to(m);return(await D.provideFollowups(k,{history:C},E)).filter(f=>{const w=!f.participant||A.Iterable.some(this.c.values(),F=>F.id===f.participant&&a.$rn.equals(F.extension.identifier,D.extension.identifier));return w||this.n.warn(`[@${D.id}] ChatFollowup refers to an unknown participant: ${f.participant}`),w}).map(f=>d.ChatFollowup.from(f,b))}$acceptFeedback(u,$,m,h){const E=this.c.get(u);if(!E)return;const D=d.ChatAgentResult.to($);let b;switch(m){case c.ChatAgentVoteDirection.Down:b=r.ChatResultFeedbackKind.Unhelpful;break;case c.ChatAgentVoteDirection.Up:b=r.ChatResultFeedbackKind.Helpful;break}E.acceptFeedback(Object.freeze(h?{result:D,kind:b,reportIssue:h}:{result:D,kind:b}))}$acceptAction(u,$,m){const h=this.c.get(u);if(!h||m.action.kind==="vote")return;const E=d.ChatAgentUserActionEvent.to($,m,this.s.converter);E&&h.acceptAction(Object.freeze(E))}async $invokeCompletionProvider(u,$,m){const h=this.c.get(u);if(!h)return[];let E=this.m.get(u);return E?E.clear():(E=new T.$Tc,this.m.set(u,E)),(await h.invokeCompletionProvider($,m)).map(b=>d.ChatAgentCompletionItem.from(b,this.s.converter,E))}async $provideWelcomeMessage(u,$,m){const h=this.c.get(u);if(h)return await h.provideWelcomeMessage(d.ChatLocation.to($),m)}async $provideSampleQuestions(u,$,m){const h=this.c.get(u);if(h)return(await h.provideSampleQuestions(d.ChatLocation.to($),m)).map(E=>d.ChatFollowup.from(E,void 0))}}e.$Fpc=n;class t{constructor(u,$,m,h,E){this.extension=u,this.id=$,this.w=m,this.x=h,this.y=E,this.m=new O.$le,this.n=new O.$le}acceptFeedback(u){this.m.fire(u)}acceptAction(u){this.n.fire(u)}async invokeCompletionProvider(u,$){return this.q?await this.q.provider.provideCompletionItems(u,$)??[]:[]}async provideFollowups(u,$,m){if(!this.b)return[];const h=await this.b.provideFollowups(u,$,m);return h?h.filter(E=>!(E&&"commandId"in E)).filter(E=>!(E&&"message"in E)):[]}async provideWelcomeMessage(u,$){if(!this.s)return[];const m=await this.s.provideWelcomeMessage(u,$);return m?m.map(h=>typeof h=="string"?h:d.MarkdownString.from(h)):[]}async provideSampleQuestions(u,$){if(!this.s||!this.s.provideSampleQuestions)return[];const m=await this.s.provideSampleQuestions(u,$);return m||[]}get apiAgent(){let u=!1,$=!1;const m=()=>{u||$||($=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof y.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof r.$LO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:d.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:d.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:d.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),$=!1}))},h=this;return{get id(){return h.id},get iconPath(){return h.c},set iconPath(E){h.c=E,m()},get requestHandler(){return h.y},set requestHandler(E){(0,I.$og)(typeof E=="function","Invalid request handler"),h.y=E},get followupProvider(){return h.b},set followupProvider(E){h.b=E,m()},get isDefault(){return(0,l.$gH)(h.extension,"defaultChatParticipant"),h.d},set isDefault(E){(0,l.$gH)(h.extension,"defaultChatParticipant"),h.d=E,m()},get helpTextPrefix(){return(0,l.$gH)(h.extension,"defaultChatParticipant"),h.g},set helpTextPrefix(E){(0,l.$gH)(h.extension,"defaultChatParticipant"),h.g=E,m()},get helpTextVariablesPrefix(){return(0,l.$gH)(h.extension,"defaultChatParticipant"),h.j},set helpTextVariablesPrefix(E){(0,l.$gH)(h.extension,"defaultChatParticipant"),h.j=E,m()},get helpTextPostfix(){return(0,l.$gH)(h.extension,"defaultChatParticipant"),h.k},set helpTextPostfix(E){(0,l.$gH)(h.extension,"defaultChatParticipant"),h.k=E,m()},get isSecondary(){return(0,l.$gH)(h.extension,"defaultChatParticipant"),h.l},set isSecondary(E){(0,l.$gH)(h.extension,"defaultChatParticipant"),h.l=E,m()},get supportIssueReporting(){return(0,l.$gH)(h.extension,"chatParticipantPrivate"),h.o},set supportIssueReporting(E){(0,l.$gH)(h.extension,"chatParticipantPrivate"),h.o=E,m()},get onDidReceiveFeedback(){return h.m.event},set participantVariableProvider(E){if((0,l.$gH)(h.extension,"chatParticipantAdditions"),h.q=E,E){if(!E.triggerCharacters.length)throw new Error("triggerCharacters are required");h.w.$registerAgentCompletionsProvider(h.x,h.id,E.triggerCharacters)}else h.w.$unregisterAgentCompletionsProvider(h.x,h.id)},get participantVariableProvider(){return(0,l.$gH)(h.extension,"chatParticipantAdditions"),h.q},set welcomeMessageProvider(E){(0,l.$gH)(h.extension,"defaultChatParticipant"),h.s=E,m()},get welcomeMessageProvider(){return(0,l.$gH)(h.extension,"defaultChatParticipant"),h.s},onDidPerformAction:(0,l.$fH)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(E){h.t=E,m()},get requester(){return h.t},set supportsSlowReferences(E){(0,l.$gH)(h.extension,"chatParticipantPrivate"),h.u=E,m()},get supportsSlowReferences(){return(0,l.$gH)(h.extension,"chatParticipantPrivate"),h.u},dispose(){u=!0,h.b=void 0,h.m.dispose(),h.w.$unregisterAgent(h.x)}}}invoke(u,$,m,h){return this.y(u,$,m,h)}}}),define(Ne[234],Le([1,0,13,4,34,5,8,7,24]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gpc=void 0,A=qe(A),T=qe(T);class o{static{this.a=0}constructor(a){this.b=new Map,this.c=a.getProxy(O.$KN.MainThreadChatVariables)}async $resolveVariable(a,S,d,r){const s=this.b.get(a);if(s)try{if(s.resolver.resolve2){(0,p.$gH)(s.extension,"chatParticipantAdditions");const c=new I(S,this.c),l=await s.resolver.resolve2(s.data.name,{prompt:d},c.apiObject,r);if(l&&l[0])return l[0].value}else{const c=await s.resolver.resolve(s.data.name,{prompt:d},r);if(c&&c[0])return c[0].value}}catch(c){(0,v.$Z)(c)}}registerVariableResolver(a,S,d,r,s,c,l,i,n){const t=o.a++,g=n?P.ThemeIcon.fromId(n):void 0;return this.b.set(t,{extension:a,data:{id:S,name:d,description:r,modelDescription:s,icon:g},resolver:l}),this.c.$registerVariable(t,{id:S,name:d,description:r,modelDescription:s,isSlow:c,fullName:i,icon:g}),(0,R.$Sc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$Gpc=o;class I{constructor(a,S){this.c=a,this.d=S,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let S=function(r){if(a.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,r),s}};const a=this,d=r=>{this.d.$handleProgressChunk(this.c,r)};this.b={progress(r){S(this.progress);const s=new T.$SP(r),c=A.ChatResponseProgressPart.from(s);return d(c),this},reference(r){S(this.reference);const s=new T.$WP(r),c=A.ChatResponseReferencePart.from(s);return d(c),this},push(r){return S(this.push),r instanceof T.$WP?d(A.ChatResponseReferencePart.from(r)):r instanceof T.$SP&&d(A.ChatResponseProgressPart.from(r)),this}}}return this.b}}}),define(Ne[235],Le([1,0,10,71,6,4,37,2,93,18,8,7,5,24]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kpc=d,p=qe(p),I=qe(I),y=qe(y);function d(r,s,c){const l=r.getProxy(a.$KN.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new o.$tn,s.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===A.MarshalledId.CommentController){const C=this.b.get(b.handle);return C?C.value:b}else if(b&&b.$mid===A.MarshalledId.CommentThread){const C=b,k=this.b.get(C.commentControlHandle);if(!k)return C;const f=k.getCommentThread(C.commentThreadHandle);return f?f.value:C}else if(b&&(b.$mid===A.MarshalledId.CommentThreadReply||b.$mid===A.MarshalledId.CommentThreadInstance)){const C=this.b.get(b.thread.commentControlHandle);if(!C)return b;const k=C.getCommentThread(b.thread.commentThreadHandle);return k?b.$mid===A.MarshalledId.CommentThreadInstance?k.value:{thread:k.value,text:b.text}:b}else if(b&&b.$mid===A.MarshalledId.CommentNode){const C=this.b.get(b.thread.commentControlHandle);if(!C)return b;const k=C.getCommentThread(b.thread.commentThreadHandle);if(!k)return b;const f=b.commentUniqueId,w=k.getCommentByUniqueId(f);return w||b}else if(b&&b.$mid===A.MarshalledId.CommentThreadNode){const C=this.b.get(b.thread.commentControlHandle);if(!C)return b;const k=C.getCommentThread(b.thread.commentThreadHandle);if(!k)return b;const f=b.text,w=b.commentUniqueId,F=k.getCommentByUniqueId(w);return F?(typeof F.body=="string"?F.body=f:F.body=new y.$eO(f),F):b}return b}})}createCommentController(b,C,k){const f=i.a++,w=new t(b,f,C,k);this.b.set(w.handle,w);const F=this.c.get(b.identifier)||[];return F.push(w),this.c.set(b.identifier,F),w.value}async $createCommentThreadTemplate(b,C,k,f){const w=this.b.get(b);w&&w.$createCommentThreadTemplate(C,k,f)}async $setActiveComment(b,C){const k=this.b.get(b);k&&k.$setActiveComment(C??void 0)}async $updateCommentThreadTemplate(b,C,k){const f=this.b.get(b);f&&f.$updateCommentThreadTemplate(C,k)}$deleteCommentThread(b,C){this.b.get(b)?.$deleteCommentThread(C)}async $provideCommentingRanges(b,C,k){const f=this.b.get(b);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const w=await c.ensureDocumentData(T.URI.revive(C));return(0,v.$xh)(async()=>{const F=await f.commentingRangeProvider.provideCommentingRanges(w.document,k);let N;return Array.isArray(F)?N={ranges:F,fileComments:!1}:F?N={ranges:F.ranges||[],fileComments:F.enableFileComments||!1}:N=F??void 0,N}).then(F=>{let N;return F&&(N={ranges:F.ranges.map(L=>I.Range.from(L)),fileComments:F.fileComments}),N})}$toggleReaction(b,C,k,f,w){const F=this.b.get(b);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,v.$xh)(()=>{const N=F.getCommentThread(C);if(N){const L=N.getCommentByUniqueId(f.uniqueIdInThread);if(F!==void 0&&L&&F.reactionHandler)return F.reactionHandler(L,$(w))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(b){this.n=b}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(b){(b===void 0!=(this.p===void 0)||!b||!this.p||!b.isEqual(this.p))&&(this.p=b,this.b.range=b,this.c.fire())}get range(){return this.p}set canReply(b){this.d!==b&&(this.d=b,this.b.canReply=b,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(b){this.e=b,this.b.label=b,this.c.fire()}get contextValue(){return this.f}set contextValue(b){this.f=b,this.b.contextValue=b,this.c.fire()}get comments(){return this.q}set comments(b){this.q=b,this.b.comments=b,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(b){this.g=b,this.b.collapsibleState=b,this.c.fire()}get state(){return this.h}set state(b){this.h=b,typeof b=="object"?((0,S.$gH)(this.extensionDescription,"commentThreadApplicability"),this.b.state=b.resolved,this.b.applicability=b.applicability):this.b.state=b,this.c.fire()}get isDisposed(){return this.j}constructor(b,C,k,f,w,F,N,L,q){this.m=C,this.n=k,this.o=f,this.p=w,this.q=F,this.extensionDescription=N,this.r=L,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$le,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Vc,this.l.value=new O.$Tc,this.n===void 0&&(this.n=`${b}.${this.handle}`),l.$createCommentThread(C,this.handle,this.n,this.o,I.Range.from(this.p),this.q.map(W=>g(this,W,this.k,this.extensionDescription)),N.identifier,this.r,q),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{l.$deleteCommentThread(C,this.handle)}});const H=this;this.value={get uri(){return H.uri},get range(){return H.range},set range(W){H.range=W},get comments(){return H.comments},set comments(W){H.comments=W},get collapsibleState(){return H.collapsibleState},set collapsibleState(W){H.collapsibleState=W},get canReply(){return H.canReply},set canReply(W){H.canReply=W},get contextValue(){return H.contextValue},set contextValue(W){H.contextValue=W},get label(){return H.label},set label(W){H.label=W},get state(){return H.state},set state(W){H.state=W},reveal:(W,G)=>H.reveal(W,G),hide:()=>H.hide(),dispose:()=>{H.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Tc);const b=k=>Object.prototype.hasOwnProperty.call(this.b,k),C={};b("range")&&(C.range=I.Range.from(this.p)),b("label")&&(C.label=this.label),b("contextValue")&&(C.contextValue=this.contextValue??null),b("comments")&&(C.comments=this.q.map(k=>g(this,k,this.k,this.extensionDescription))),b("collapsibleState")&&(C.collapseState=m(this.g)),b("canReply")&&(C.canReply=this.canReply),b("state")&&(C.state=h(this.h)),b("applicability")&&(C.applicability=E(this.h)),b("isTemplate")&&(C.isTemplate=this.r),this.b={},l.$updateCommentThread(this.m,this.handle,this.n,this.o,C)}getCommentByUniqueId(b){for(const C of this.k){const k=C[0],f=C[1];if(b===f)return k}}async reveal(b,C){(0,S.$gH)(this.extensionDescription,"commentReveal");let k;b&&b.body!==void 0?k=b:C=C??b;let f=k?this.k.get(k):void 0;f??=this.k.get(this.q[0]);let w=!0,F=!1;return C?.focus===y.CommentThreadFocus.Reply?(F=!0,w=!1):C?.focus===y.CommentThreadFocus.Comment&&(w=!1),l.$revealCommentThread(this.m,this.handle,f,{preserveFocus:w,focusReply:F})}async hide(){return l.$hideCommentThread(this.m,this.handle)}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(b=>b.dispose())}}Je([(0,R.$$h)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(b){this.b=b,b?.resourceHints&&(0,S.$gH)(this.h,"commentingRangeHint"),l.$updateCommentingRanges(this.handle,b?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(b){this.c=b,l.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!b})}get options(){return this.d}set options(b){this.d=b,l.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,S.$gH)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,S.$gH)(this.h,"activeComment"),this.f}constructor(b,C,k,f){this.h=b,this.i=C,this.j=k,this.k=f,this.a=new Map,l.$registerCommentController(this.handle,k,f,this.h.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(F){w.options=F},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(F){w.commentingRangeProvider=F},get reactionHandler(){return w.reactionHandler},set reactionHandler(F){w.reactionHandler=F},get activeCommentThread(){return w.activeCommentThread},createCommentThread(F,N,L){return w.createCommentThread(F,N,L).value},dispose:()=>{w.dispose()}}),this.g=[],this.g.push({dispose:()=>{l.$unregisterCommentController(this.handle)}})}createCommentThread(b,C,k){C===void 0&&(0,S.$gH)(this.h,"fileComments");const f=new n(this.id,this.handle,void 0,b,C,k,this.h,!1);return this.a.set(f.handle,f),f}$setActiveComment(b){if(!b){this.e=void 0,this.f=void 0;return}const C=this.a.get(b.commentThreadHandle);C&&(this.e=b.uniqueIdInThread?C.getCommentByUniqueId(b.uniqueIdInThread):void 0,this.f=C)}$createCommentThreadTemplate(b,C,k){const f=new n(this.id,this.handle,void 0,T.URI.revive(b),I.Range.to(C),[],this.h,!0,k);return f.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(f.handle,f),f}$updateCommentThreadTemplate(b,C){const k=this.a.get(b);k&&(k.range=I.Range.to(C))}$deleteCommentThread(b){this.a.get(b)?.dispose(),this.a.delete(b)}getCommentThread(b){return this.a.get(b)}dispose(){this.a.forEach(b=>{b.dispose()}),this.g.forEach(b=>b.dispose())}}function g(D,b,C,k){let f=C.get(b);return f||(f=++D.commentHandle,C.set(b,f)),b.state!==void 0&&(0,S.$gH)(k,"commentsDraftState"),b.reactions?.some(w=>w.reactors!==void 0)&&(0,S.$gH)(k,"commentReactor"),{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:f,body:typeof b.body=="string"?b.body:I.MarkdownString.from(b.body),userName:b.author.name,userIconPath:b.author.iconPath,label:b.label,commentReactions:b.reactions?b.reactions.map(w=>u(w)):void 0,state:b.state,timestamp:b.timestamp?.toJSON()}}function u(D){return{label:D.label,iconPath:D.iconPath?I.$jQ(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(b=>b.name):D.reactors}}function $(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?T.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(b=>({name:b}))}}function m(D){if(D!==void 0)switch(D){case y.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case y.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function h(D){let b;if(typeof D=="object"?b=D.resolved:b=D,b!==void 0)switch(b){case y.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case y.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function E(D){let b;if(typeof D=="object"&&(b=D.applicability),b!==void 0)switch(b){case y.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case y.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new i}}),define(Ne[236],Le([1,0,21,75,4,15,23,2,8,67,79,5,7]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pc=void 0,p=qe(p),y=qe(y),a=qe(a);class S{constructor(u,$){this.document=u,this.b=$,this.a=1,this.c=new I.$qpc("custom documents")}addEdit(u){return this.c.add([u])}async undo(u,$){await this.f(u).undo(),$||this.disposeBackup()}async redo(u,$){await this.f(u).redo(),$||this.disposeBackup()}disposeEdits(u){for(const $ of u)this.c.delete($)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const u=t(this.document.uri)+this.a++;return(0,A.$gh)(this.b,u)}updateBackup(u){this.d?.delete(),this.d=u}disposeBackup(){this.d?.delete(),this.d=void 0}f(u){const $=this.c.get(u,0);if(!$)throw new Error("No edit found");return $}}class d{constructor(){this.a=new Map}get(u,$){return this.a.get(this.b(u,$))}add(u,$,m){const h=this.b(u,$.uri);if(this.a.has(h))throw new Error(`Document already exists for viewType:${u} resource:${$.uri}`);const E=new S($,m);return this.a.set(h,E),E}delete(u,$){const m=this.b(u,$.uri);this.a.delete(m)}b(u,$){return`${u}@@@${$}`}}var r;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(r||(r={}));class s{constructor(){this.a=new Map}addTextProvider(u,$,m){return this.b(u,{type:r.Text,extension:$,provider:m})}addCustomProvider(u,$,m){return this.b(u,{type:r.Custom,extension:$,provider:m})}get(u){return this.a.get(u)}b(u,$){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,$),new a.$MN(()=>this.a.delete(u))}}class c{constructor(u,$,m,h,E){this.d=$,this.f=m,this.g=h,this.h=E,this.b=new s,this.c=new d,this.a=u.getProxy(y.$KN.MainThreadCustomEditors)}registerCustomEditorProvider(u,$,m,h){const E=new P.$Tc;return i(m)?(E.add(this.b.addTextProvider($,u,m)),this.a.$registerTextEditorProvider((0,o.$Zpc)(u),$,h.webviewOptions||{},{supportsMove:!!m.moveCustomTextEditor},(0,o.$Xpc)(u))):(E.add(this.b.addCustomProvider($,u,m)),l(m)&&E.add(m.onDidChangeCustomDocument(D=>{const b=this.i($,D.document.uri);if(n(D)){const C=b.addEdit(D);this.a.$onDidEdit(D.document.uri,$,C,D.label)}else this.a.$onContentChange(D.document.uri,$)})),this.a.$registerCustomEditorProvider((0,o.$Zpc)(u),$,h.webviewOptions||{},!!h.supportsMultipleEditorsPerDocument,(0,o.$Xpc)(u))),a.$MN.from(E,new a.$MN(()=>{this.a.$unregisterEditorProvider($)}))}async $createCustomDocument(u,$,m,h,E){const D=this.b.get($);if(!D)throw new Error(`No provider found for '${$}'`);if(D.type!==r.Custom)throw new Error(`Invalid provide type for '${$}'`);const b=T.URI.revive(u),C=await D.provider.openCustomDocument(b,{backupId:m,untitledDocumentData:h?.buffer},E);let k;return l(D.provider)&&this.f&&(k=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add($,C,k),{editable:l(D.provider)}}async $disposeCustomDocument(u,$){const m=this.b.get($);if(!m)throw new Error(`No provider found for '${$}'`);if(m.type!==r.Custom)throw new Error(`Invalid provider type for '${$}'`);const h=T.URI.revive(u),{document:E}=this.i($,h);this.c.delete($,E),E.dispose()}async $resolveCustomEditor(u,$,m,h,E,D){const b=this.b.get(m);if(!b)throw new Error(`No provider found for '${m}'`);const C=p.ViewColumn.to(E),k=this.g.createNewWebview($,h.contentOptions,b.extension),f=this.h.createNewWebviewPanel($,m,h.title,C,h.options,k,h.active),w=T.URI.revive(u);switch(b.type){case r.Custom:{const{document:F}=this.i(m,w);return b.provider.resolveCustomEditor(F,f,D)}case r.Text:{const F=this.d.getDocument(w);return b.provider.resolveCustomTextEditor(F,f,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,$,m){this.i($,u).disposeEdits(m)}async $onMoveCustomEditor(u,$,m){const h=this.b.get(m);if(!h)throw new Error(`No provider found for '${m}'`);if(!h.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${m}'`);const E=this.h.getWebviewPanel(u);if(!E)throw new Error("No webview found");const D=T.URI.revive($),b=this.d.getDocument(D);await h.provider.moveCustomTextEditor(b,E,v.CancellationToken.None)}async $undo(u,$,m,h){return this.i($,u).undo(m,h)}async $redo(u,$,m,h){return this.i($,u).redo(m,h)}async $revert(u,$,m){const h=this.i($,u);await this.j($).revertCustomDocument(h.document,m),h.disposeBackup()}async $onSave(u,$,m){const h=this.i($,u);await this.j($).saveCustomDocument(h.document,m),h.disposeBackup()}async $onSaveAs(u,$,m,h){const E=this.i($,u);return this.j($).saveCustomDocumentAs(E.document,T.URI.revive(m),h)}async $backup(u,$,m){const h=this.i($,u),D=await this.j($).backupCustomDocument(h.document,{destination:h.getNewBackupUri()},m);return h.updateBackup(D),D.id}i(u,$){const m=this.c.get(u,T.URI.revive($));if(!m)throw new Error("No custom document found");return m}j(u){const m=this.b.get(u)?.provider;if(!m||!l(m))throw new Error("Custom document is not editable");return m}}e.$3pc=c;function l(g){return!!g.onDidChangeCustomDocument}function i(g){return typeof g.resolveCustomTextEditor=="function"}function n(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function t(g){const u=g.scheme===O.Schemas.file||g.scheme===O.Schemas.untitled?g.fsPath:g.toString();return(0,R.$tj)(u)+""}}),define(Ne[237],Le([1,0,9,107,2,5,7,8,6,11,28,50]),function(ve,e,v,R,P,O,A,T,p,o,I,y){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$ypc=e.$xpc=void 0,T=qe(T);class S{#e;#t;#i;constructor(s,c,l,i,n,t,g,u){this.d=s,this.e=c,this.f=l,this.g=i,this.h=n,this.c=!1,this.f=Math.max(i,l),this.#i=new I.$Ac($=>t.getComparisonKey($)),this.#e=g,this.#t=u}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(s,c){if(!s){this.clear();return}this.j();let l=[];if(P.URI.isUri(s)){if(!c){this.delete(s);return}this.#i.set(s,c.slice()),l=[s]}else if(Array.isArray(s)){l=[];let t;s=[...s].sort(S.k);for(const g of s){const[u,$]=g;if((!t||u.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=u,l.push(u),this.#i.set(u,[])),$)this.#i.get(u)?.push(...$);else{const m=this.#i.get(u);m&&(m.length=0)}}}if(this.#t.fire(l),!this.#e)return;const i=[];let n=0;for(const t of l){let g=[];const u=this.#i.get(t);if(u)if(u.length>this.g){g=[];const $=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let m=0;m<4;m++)for(const h of u)if(h.severity===$[m]&&g.push({...T.Diagnostic.from(h),modelVersionId:this.h(t)})===this.g)break e;g.push({severity:R.MarkerSeverity.Info,message:(0,v.localize)(10838,null,u.length-this.g),startLineNumber:g[g.length-1].startLineNumber,startColumn:g[g.length-1].startColumn,endLineNumber:g[g.length-1].endLineNumber,endColumn:g[g.length-1].endColumn})}else g=u.map($=>({...T.Diagnostic.from($),modelVersionId:this.h(t)}));if(i.push([t,g]),n+=g.length,n>this.f)break}this.#e.$changeMany(this.e,i)}delete(s){this.j(),this.#t.fire([s]),this.#i.delete(s),this.#e?.$changeMany(this.e,[[s,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(s,c){this.j();for(const[l,i]of this)s.call(c,l,i,this)}*[Symbol.iterator](){this.j();for(const s of this.#i.keys())yield[s,this.get(s)]}get(s){this.j();const c=this.#i.get(s);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(s){return this.j(),Array.isArray(this.#i.get(s))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(s,c){return s[0].toString()<c[0].toString()?-1:s[0].toString()>c[0].toString()?1:0}}e.$xpc=S;let d=class{static{a=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*this.d}static _mapper(s){const c=new I.$Ac;for(const l of s)c.set(l,l);return{uris:Object.freeze(Array.from(c.values()))}}constructor(s,c,l,i){this.j=c,this.k=l,this.l=i,this.g=new Map,this.h=new p.$pe({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,a._mapper),this.f=s.getProxy(O.$KN.MainThreadDiagnostics)}createDiagnosticCollection(s,c){const{g:l,f:i,h:n,j:t,k:g,l:u}=this,$=new class{$changeMany(E,D){i.$changeMany(E,D),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,E,D.length===0?"CLEARING":D)}$clear(E){i.$clear(E),t.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,E)}dispose(){i.dispose()}};let m;if(!c)c="_generated_diagnostic_collection_name_#"+a.c++,m=c;else if(!l.has(c))m=c;else{this.j.warn(`DiagnosticCollection with name '${c}' does already exist.`);do m=c+a.c++;while(l.has(m))}return new class extends S{constructor(){super(c,m,a.e,a.d,E=>u.getDocument(E)?.version,g.extUri,$,n),l.set(m,this)}dispose(){super.dispose(),l.delete(m)}}}getDiagnostics(s){if(s)return this.m(s);{const c=new Map,l=[];for(const i of this.g.values())i.forEach((n,t)=>{let g=c.get(n.toString());typeof g>"u"&&(g=l.length,c.set(n.toString(),g),l.push([n,[]])),l[g][1]=l[g][1].concat(...t)});return l}}m(s){let c=[];for(const l of this.g.values())l.has(s)&&(c=c.concat(l.get(s)));return c}$acceptMarkersChange(s){if(!this.n){const c="_generated_mirror",l=new S(c,c,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(c,l),this.n=l}for(const[c,l]of s)this.n.set(P.URI.revive(c),l.map(T.Diagnostic.to))}};e.$ypc=d,e.$ypc=d=a=Je([Ve(1,o.$ak),Ve(2,y.$wpc)],d)}),define(Ne[238],Le([1,0,2,13,7,8,171,39]),function(ve,e,v,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lqc=void 0;class p{constructor(I,y,a,S={timeout:1500,errors:3}){this.c=I,this.d=y,this.f=a,this.g=S,this.a=new A.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(y,a,S)=>{const r={dispose:this.a.push([y,a,I])};return Array.isArray(S)&&S.push(r),r}}async $participateInSave(I,y){const a=v.URI.revive(I);let S=!1;const d=setTimeout(()=>S=!0,this.g.timeout),r=[];try{for(const s of[...this.a]){if(S)break;const c=this.d.getDocument(a),l=await this.h(s,{document:c,reason:O.TextDocumentSaveReason.to(y)});r.push(l)}}finally{clearTimeout(d)}return r}h([I,y,a],S){const d=this.b.get(I);return typeof d=="number"&&d>this.g.errors?Promise.resolve(!1):this.i(a,I,y,S).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${a.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const s=this.b.get(I);this.b.set(I,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${a.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,y,a,S){const d=[],r=Date.now(),{document:s,reason:c}=S,{version:l}=s,i=Object.freeze({document:s,reason:c,waitUntil(n){if(Object.isFrozen(d))throw(0,R.$7)("waitUntil can not be called async");d.push(Promise.resolve(n))}});try{y.apply(a,[i])}catch(n){return Promise.reject(n)}return Object.freeze(d),new Promise((n,t)=>{const g=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(d).then(u=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(g),n(u)}).catch(u=>{clearTimeout(g),t(u)})}).then(n=>{const t={edits:[]};for(const g of n)if(Array.isArray(g)&&g.every(u=>u instanceof P.$VN))for(const{newText:u,newEol:$,range:m}of g)t.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:m&&O.Range.from(m),text:u,eol:$&&O.EndOfLine.from($)}});if(t.edits.length!==0)return l===s.version?this.f.$tryApplyWorkspaceEdit(new T.$Xw(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$Lqc=p}),define(Ne[239],Le([1,0,6,4,2,5,123,8,14,25,7]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zpc=void 0,T=qe(T);class y{constructor(S,d){this.a=new v.$le,this.b=new v.$le,this.c=new v.$le,this.d=new v.$le,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new R.$Tc,this.h=new Map,this.f=S.getProxy(O.$KN.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(r=>{for(const s of r)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const s of r)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const d=this.g.getDocument(S);if(d)return d}getDocument(S){const d=this.getDocumentData(S);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return d.document}ensureDocumentData(S){const d=this.g.getDocument(S);if(d)return Promise.resolve(d);let r=this.h.get(S.toString());return r||(r=this.f.$tryOpenDocument(S).then(s=>{this.h.delete(S.toString());const c=P.URI.revive(s);return(0,p.$pg)(this.g.getDocument(c))},s=>(this.h.delete(S.toString()),Promise.reject(s))),this.h.set(S.toString(),r)),r}createDocumentData(S){return this.f.$tryCreateDocument(S).then(d=>P.URI.revive(d))}$acceptModelLanguageChanged(S,d){const r=P.URI.revive(S),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(d),this.a.fire(s.document)}$acceptModelSaved(S){const d=P.URI.revive(S),r=this.g.getDocument(d);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(S,d){const r=P.URI.revive(S),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");s._acceptIsDirty(d),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,d,r){const s=P.URI.revive(S),c=this.g.getDocument(s);if(!c)throw new Error("unknown document");c._acceptIsDirty(r),c.onEvents(d);let l;d.isUndoing?l=I.TextDocumentChangeReason.Undo:d.isRedoing&&(l=I.TextDocumentChangeReason.Redo),this.c.fire((0,o.$fo)({document:c.document,contentChanges:d.changes.map(i=>({range:T.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:l}))}setWordDefinitionFor(S,d){(0,A.$mQ)(S,d)}}e.$zpc=y}),define(Ne[70],Le([1,0,240,6,14,2,3,5,16,8,7]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5pc=e.$4pc=void 0,o=qe(o),e.$4pc=(0,A.$Fi)("IExtHostEditorTabs");class y{constructor(s,c,l){this.e=l,this.d=c,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,c={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(c)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case T.TabInputKind.TextInput:return new I.$AP(O.URI.revive(this.b.input.uri));case T.TabInputKind.TextDiffInput:return new I.$BP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case T.TabInputKind.TextMergeInput:return new I.$CP(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case T.TabInputKind.CustomEditorInput:return new I.$DP(O.URI.revive(this.b.input.uri),this.b.input.viewType);case T.TabInputKind.WebviewEditorInput:return new I.$EP(this.b.input.viewType);case T.TabInputKind.NotebookInput:return new I.$FP(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case T.TabInputKind.NotebookDiffInput:return new I.$GP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case T.TabInputKind.TerminalEditorInput:return new I.$HP;case T.TabInputKind.InteractiveEditorInput:return new I.$IP(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case T.TabInputKind.ChatEditorInput:return new I.$JP;case T.TabInputKind.MultiDiffEditorInput:return new I.$KP(this.b.input.diffEditors.map(s=>new I.$BP(O.URI.revive(s.original),O.URI.revive(s.modified))));default:return}}}class a{constructor(s,c){this.c=[],this.d="",this.b=s,this.e=c;for(const l of s.tabs)l.isActive&&(this.d=l.id),this.c.push(new y(l,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,c={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return o.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(l=>l.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(l=>l.apiObject))}};this.a=Object.freeze(c)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===T.TabModelOperationKind.TAB_OPEN){const l=new y(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,l),s.tabDto.isActive&&(this.d=l.tabId),l}else if(s.kind===T.TabModelOperationKind.TAB_CLOSE){const l=this.c.splice(s.index,1)[0];if(!l)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return l.tabId===this.d&&(this.d=""),l}else if(s.kind===T.TabModelOperationKind.TAB_MOVE){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const l=this.c.splice(s.oldIndex,1)[0];if(!l)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,l),l}const c=this.c.find(l=>l.tabId===s.tabDto.id);if(!c)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),c.acceptDtoUpdate(s.tabDto),c}activeTabId(){return this.d}}let S=class{constructor(s){this.b=new R.$le,this.c=new R.$le,this.e=[],this.a=s.getProxy(T.$KN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,c={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(l=>l.apiObject))},get activeTabGroup(){const l=s.d;return(0,P.$pg)(s.e.find(n=>n.groupId===l)?.apiObject)},close:async(l,i)=>{const n=Array.isArray(l)?l:[l];return n.length?d(n[0])?this.j(n,i):this.i(n,i):!0}};this.f=Object.freeze(c)}return this.f}$acceptEditorTabModel(s){const c=new Set(this.e.map($=>$.groupId)),l=new Set(s.map($=>$.groupId)),i=(0,v.$d)(c,l),n=this.e.filter($=>i.removed.includes($.groupId)).map($=>$.apiObject),t=[],g=[];this.e=s.map($=>{const m=new a($,()=>this.d);return i.added.includes(m.groupId)?t.push(m.apiObject):g.push(m.apiObject),m});const u=(0,P.$pg)(s.find($=>$.isActive===!0)?.groupId);u!==void 0&&this.d!==u&&(this.d=u),this.c.fire(Object.freeze({opened:t,closed:n,changed:g}))}$acceptTabGroupUpdate(s){const c=this.e.find(l=>l.groupId===s.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const c=this.e.find(i=>i.groupId===s.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const l=c.acceptTabOperation(s);switch(s.kind){case T.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[l.apiObject],closed:[],changed:[]}));return;case T.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[l.apiObject],changed:[]}));return;case T.TabModelOperationKind.TAB_MOVE:case T.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[l.apiObject]}));return}}g(s){for(const c of this.e)for(const l of c.tabs)if(l.apiObject===s)return l}h(s){return this.e.find(c=>c.apiObject===s)}async i(s,c){const l=[];for(const i of s){const n=this.g(i);if(!n)throw new Error("Tab close: Invalid tab not found!");l.push(n.tabId)}return this.a.$closeTab(l,c)}async j(s,c){const l=[];for(const i of s){const n=this.h(i);if(!n)throw new Error("Group close: Invalid group not found!");l.push(n.groupId)}return this.a.$closeGroup(l,c)}};e.$5pc=S,e.$5pc=S=Je([Ve(0,p.$kQ)],S);function d(r){return r.tabs!==void 0}}),define(Ne[241],Le([1,0,2,5,29,4,7,8,285,12,27,22,24,59]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oqc=void 0,P=qe(P),T=qe(T);class d{constructor(){this.a=[]}add(c){this.b=void 0,this.a.push(c)}delete(c){const l=this.a.indexOf(c);l>=0&&(this.a.splice(l,1),this.b=void 0)}c(){if(!this.b){const c=this.a.sort(),l=[];let i,n,t=p.State.LastKnownState,g=p.State.LastKnownState;for(const u of c){let $=i?(0,o.$Hf)(i,u):0;for($===0?n=p.State.Start:n=g;$<u.length;$++)$+1===u.length?(t=g,g=p.State.BeforeColon):g+=1,l.push([n,u.toUpperCase().charCodeAt($),g]),l.push([n,u.toLowerCase().charCodeAt($),g]),n=g;i=u,g=t}l.push([p.State.BeforeColon,I.CharCode.Colon,p.State.AfterColon]),l.push([p.State.AfterColon,I.CharCode.Slash,p.State.End]),this.b=new p.$F4(l)}}provideDocumentLinks(c){this.c();const l=[],i=p.$G4.computeLinks({getLineContent(n){return c.lineAt(n-1).text},getLineCount(){return c.lineCount}},this.b);for(const n of i){const t=T.DocumentLink.to(n);t.target&&l.push(t)}return l}}class r{constructor(c,l){this.i=l,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=c.getProxy(R.$KN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(c,l,i,n={}){if(r.j(i),this.d.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(c,"*",this.b));const t=this.h++;this.b.add(l),this.d.add(l),this.c.set(t,i);let g=P.FileSystemProviderCapabilities.FileReadWrite;n.isCaseSensitive&&(g+=P.FileSystemProviderCapabilities.PathCaseSensitive),n.isReadonly&&(g+=P.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(g+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,a.$gH)(c,"fsChunks"),g+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let u;n.isReadonly&&(0,S.$6k)(n.isReadonly)&&n.isReadonly.value!==""&&(u={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(t,l,g,u).catch(m=>{console.error(`FAILED to register filesystem provider of ${c.identifier.value}-extension for the scheme ${l}`),console.error(m)});const $=i.onDidChangeFile(m=>{const h=[];for(const E of m){const{uri:D,type:b}=E;if(D.scheme!==l)continue;let C;switch(b){case A.FileChangeType.Changed:C=P.FileChangeType.UPDATED;break;case A.FileChangeType.Created:C=P.FileChangeType.ADDED;break;case A.FileChangeType.Deleted:C=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}h.push({resource:D,type:C})}this.a.$onFileSystemChange(t,h)});return(0,O.$Sc)(()=>{$.dispose(),this.b.delete(l),this.d.delete(l),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(c){if(!c)throw new Error("MISSING provider");if(typeof c.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof c.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof c.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof c.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof c.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof c.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof c.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof c.rename!="function")throw new Error("Provider does NOT implement rename")}static k(c){const{type:l,ctime:i,mtime:n,size:t,permissions:g}=c;return{type:l,ctime:i,mtime:n,size:t,permissions:g}}$stat(c,l){return Promise.resolve(this.l(c).stat(v.URI.revive(l))).then(i=>r.k(i))}$readdir(c,l){return Promise.resolve(this.l(c).readDirectory(v.URI.revive(l)))}$readFile(c,l){return Promise.resolve(this.l(c).readFile(v.URI.revive(l))).then(i=>y.$Ne.wrap(i))}$writeFile(c,l,i,n){return Promise.resolve(this.l(c).writeFile(v.URI.revive(l),i.buffer,n))}$delete(c,l,i){return Promise.resolve(this.l(c).delete(v.URI.revive(l),i))}$rename(c,l,i,n){return Promise.resolve(this.l(c).rename(v.URI.revive(l),v.URI.revive(i),n))}$copy(c,l,i,n){const t=this.l(c);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(v.URI.revive(l),v.URI.revive(i),n))}$mkdir(c,l){return Promise.resolve(this.l(c).createDirectory(v.URI.revive(l)))}$watch(c,l,i,n){const t=this.l(c).watch(v.URI.revive(i),n);this.f.set(l,t)}$unwatch(c,l){const i=this.f.get(l);i&&(i.dispose(),this.f.delete(l))}$open(c,l,i){const n=this.l(c);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(v.URI.revive(l),i))}$close(c,l){const i=this.l(c);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(l))}$read(c,l,i,n){const t=this.l(c);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const g=y.$Ne.alloc(n);return Promise.resolve(t.read(l,i,g.buffer,0,n)).then(u=>g.slice(0,u))}$write(c,l,i,n){const t=this.l(c);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(l,i,n.buffer,0,n.byteLength))}l(c){const l=this.c.get(c);if(!l){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return l}}e.$Oqc=r}),define(Ne[242],Le([1,0,6,41,2,5,8,7,29,48]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pqc=void 0,A=qe(A);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(d,r,s,c,l,i){this.a=Math.random(),this.b=new v.$le,this.c=new v.$le,this.d=new v.$le,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,R.$Ak)(l),t=typeof l=="string",g=i?.correlate,u=c($=>{if(!(typeof $.session=="number"&&$.session!==this.a)&&!(g&&typeof $.session>"u")){if(!i?.ignoreCreateEvents)for(const m of $.created){const h=P.URI.revive(m);n(h.fsPath)&&(!t||r.getWorkspaceFolder(h))&&this.b.fire(h)}if(!i?.ignoreChangeEvents)for(const m of $.changed){const h=P.URI.revive(m);n(h.fsPath)&&(!t||r.getWorkspaceFolder(h))&&this.c.fire(h)}if(!i?.ignoreDeleteEvents)for(const m of $.deleted){const h=P.URI.revive(m);n(h.fsPath)&&(!t||r.getWorkspaceFolder(h))&&this.d.fire(h)}}});this.g=T.$MN.from(this.i(d,s,l,i,i?.correlate),this.b,this.c,this.d,u)}i(d,r,s,c,l){const i=T.$MN.from();if(typeof s=="string"||c?.ignoreChangeEvents&&c?.ignoreCreateEvents&&c?.ignoreDeleteEvents)return i;const n=d.getProxy(O.$KN.MainThreadFileSystemEventService);let t=!1;(s.pattern.includes(R.$wk)||s.pattern.includes(R.$xk))&&(t=!0);let g;return l&&(c?.ignoreChangeEvents||c?.ignoreCreateEvents||c?.ignoreDeleteEvents)&&(g=p.FileChangeFilter.UPDATED|p.FileChangeFilter.ADDED|p.FileChangeFilter.DELETED,c?.ignoreChangeEvents&&(g&=~p.FileChangeFilter.UPDATED),c?.ignoreCreateEvents&&(g&=~p.FileChangeFilter.ADDED),c?.ignoreDeleteEvents&&(g&=~p.FileChangeFilter.DELETED)),n.$watch(r.identifier.value,this.a,s.baseUri,{recursive:t,excludes:c?.excludes??[],filter:g},!!l),T.$MN.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class y{constructor(d){this.a=d,this.session=this.a.session,this.b=new o.$T(()=>this.a.created.map(P.URI.revive)),this.c=new o.$T(()=>this.a.changed.map(P.URI.revive)),this.d=new o.$T(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class a{constructor(d,r,s){this.j=d,this.k=r,this.l=s,this.a=new v.$le,this.b=new v.$le,this.c=new v.$le,this.d=new v.$le,this.g=new v.$ne,this.h=new v.$ne,this.i=new v.$ne,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(d,r,s,c){return new I(this.j,d,r,this.a.event,A.GlobPattern.from(s),c)}$onFileEvent(d){this.a.fire(new y(d))}$onDidRunFileOperation(d,r){switch(d){case p.FileOperation.MOVE:this.b.fire(Object.freeze({files:r.map(s=>({oldUri:P.URI.revive(s.source),newUri:P.URI.revive(s.target)}))}));break;case p.FileOperation.DELETE:this.d.fire(Object.freeze({files:r.map(s=>P.URI.revive(s.target))}));break;case p.FileOperation.CREATE:case p.FileOperation.COPY:this.c.fire(Object.freeze({files:r.map(s=>P.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(d){return this.m(d,this.g)}getOnWillCreateFileEvent(d){return this.m(d,this.h)}getOnWillDeleteFileEvent(d){return this.m(d,this.i)}m(d,r){return(s,c,l)=>{const i=function(t){s.call(c,t)};return i.extension=d,r.event(i,void 0,l)}}async $onWillRunFileOperation(d,r,s,c){switch(d){case p.FileOperation.MOVE:return await this.n(this.g,{files:r.map(l=>({oldUri:P.URI.revive(l.source),newUri:P.URI.revive(l.target)}))},s,c);case p.FileOperation.DELETE:return await this.n(this.i,{files:r.map(l=>P.URI.revive(l.target))},s,c);case p.FileOperation.CREATE:case p.FileOperation.COPY:return await this.n(this.h,{files:r.map(l=>P.URI.revive(l.target))},s,c)}}async n(d,r,s,c){const l=new Set,i=[];if(await d.fireAsync(r,c,async(t,g)=>{const u=Date.now(),$=await Promise.resolve(t);$ instanceof T.$YN&&(i.push([g.extension,$]),l.add(g.extension.displayName??g.extension.identifier.value)),Date.now()-u>s&&this.k.warn("SLOW file-participant",g.extension.identifier)}),c.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,t]of i){const{edits:g}=A.WorkspaceEdit.from(t,{getTextDocumentVersion:u=>this.l.getDocument(u)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(g)}return{edit:n,extensionNames:Array.from(l)}}}e.$Pqc=a}),define(Ne[243],Le([1,0,17,10,21,13,96,4,25,69,12,14,2,32,286,93,103,9,18,8,7,24,79,5]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Apc=void 0,r=qe(r),i=qe(i),u=qe(u);class ${constructor(U,j){this.d=U,this.e=j}async provideDocumentSymbols(U,j){const K=this.d.getDocument(U),V=await this.e.provideDocumentSymbols(K,j);if(!(0,v.$Jb)(V))return V[0]instanceof n.$9N?V.map(i.DocumentSymbol.from):$.f(V)}static f(U){U=U.slice(0).sort((V,re)=>{let ge=V.location.range.start.compareTo(re.location.range.start);return ge===0&&(ge=re.location.range.end.compareTo(V.location.range.end)),ge});const j=[],K=[];for(const V of U){const re={name:V.name||"!!MISSING: name!!",kind:i.SymbolKind.from(V.kind),tags:V.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:i.Range.from(V.location.range),selectionRange:i.Range.from(V.location.range),children:[]};for(;;){if(K.length===0){K.push(re),j.push(re);break}const ge=K[K.length-1];if(S.$Ot.containsRange(ge.range,re.range)&&!S.$Ot.equalsRange(ge.range,re.range)){ge.children?.push(re),K.push(re);break}K.pop()}}return j}}class m{constructor(U,j,K,V,re,ge){this.f=U,this.g=j,this.h=K,this.j=V,this.k=re,this.l=ge,this.d=new g.$qpc("CodeLens"),this.e=new Map}async provideCodeLenses(U,j){const K=this.f.getDocument(U),V=await this.h.provideCodeLenses(K,j);if(!V||j.isCancellationRequested)return;const re=this.d.add(V),ge=new T.$Tc;this.e.set(re,ge);const Ce={cacheId:re,lenses:[]};for(let Ue=0;Ue<V.length;Ue++)Ce.lenses.push({cacheId:[re,Ue],range:i.Range.from(V[Ue].range),command:this.g.toInternal(V[Ue].command,ge)});return Ce}async resolveCodeLens(U,j){const K=U.cacheId&&this.d.get(...U.cacheId);if(!K)return;let V;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?V=K:V=await this.h.resolveCodeLens(K,j),V||(V=K),j.isCancellationRequested)return;const re=U.cacheId&&this.e.get(U.cacheId[0]);if(re){if(!V.command){const ge=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ge),this.l.error(ge);return}return U.command=this.g.toInternal(V.command,re),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function h(Oe){return Array.isArray(Oe)?Oe.map(i.DefinitionLink.from):Oe?[i.DefinitionLink.from(Oe)]:[]}class E{constructor(U,j){this.d=U,this.e=j}async provideDefinition(U,j,K){const V=this.d.getDocument(U),re=i.Position.to(j),ge=await this.e.provideDefinition(V,re,K);return h(ge)}}class D{constructor(U,j){this.d=U,this.e=j}async provideDeclaration(U,j,K){const V=this.d.getDocument(U),re=i.Position.to(j),ge=await this.e.provideDeclaration(V,re,K);return h(ge)}}class b{constructor(U,j){this.d=U,this.e=j}async provideImplementation(U,j,K){const V=this.d.getDocument(U),re=i.Position.to(j),ge=await this.e.provideImplementation(V,re,K);return h(ge)}}class C{constructor(U,j){this.d=U,this.e=j}async provideTypeDefinition(U,j,K){const V=this.d.getDocument(U),re=i.Position.to(j),ge=await this.e.provideTypeDefinition(V,re,K);return h(ge)}}class k{static{this.f=10}constructor(U,j){this.g=U,this.h=j,this.d=0,this.e=new Map}async provideHover(U,j,K,V){const re=this.g.getDocument(U),ge=i.Position.to(j);let Ce;if(K&&K.verbosityRequest){const tt=K.verbosityRequest.previousHover.id,nt=this.e.get(tt);if(!nt)throw new Error(`Hover with id ${tt} not found`);const et={verbosityDelta:K.verbosityRequest.verbosityDelta,previousHover:nt};Ce=await this.h.provideHover(re,ge,V,et)}else Ce=await this.h.provideHover(re,ge,V);if(!Ce||(0,v.$Jb)(Ce.contents))return;Ce.range||(Ce.range=re.getWordRangeAtPosition(ge)),Ce.range||(Ce.range=new n.$ON(ge,ge));const Ue=i.Hover.from(Ce),Qe=this.d;if(this.e.size===k.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Qe,Ce),this.d+=1,{...Ue,id:Qe}}releaseHover(U){this.e.delete(U)}}class f{constructor(U,j){this.d=U,this.e=j}async provideEvaluatableExpression(U,j,K){const V=this.d.getDocument(U),re=i.Position.to(j),ge=await this.e.provideEvaluatableExpression(V,re,K);if(ge)return i.EvaluatableExpression.from(ge)}}class w{constructor(U,j){this.d=U,this.e=j}async provideInlineValues(U,j,K,V){const re=this.d.getDocument(U),ge=await this.e.provideInlineValues(re,i.Range.to(j),i.InlineValueContext.to(K),V);if(Array.isArray(ge))return ge.map(Ce=>i.InlineValue.from(Ce))}}class F{constructor(U,j){this.d=U,this.e=j}async provideDocumentHighlights(U,j,K){const V=this.d.getDocument(U),re=i.Position.to(j),ge=await this.e.provideDocumentHighlights(V,re,K);if(Array.isArray(ge))return ge.map(i.DocumentHighlight.from)}}class N{constructor(U,j){this.d=U,this.e=j}async provideMultiDocumentHighlights(U,j,K,V){const re=this.d.getDocument(U),ge=K.map(Qe=>this.d.getDocument(Qe)),Ce=i.Position.to(j),Ue=await this.e.provideMultiDocumentHighlights(re,Ce,ge,V);if(Array.isArray(Ue))return Ue.map(i.MultiDocumentHighlight.from)}}class L{constructor(U,j){this.d=U,this.e=j}async provideLinkedEditingRanges(U,j,K){const V=this.d.getDocument(U),re=i.Position.to(j),ge=await this.e.provideLinkedEditingRanges(V,re,K);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,v.$Gb)(ge.ranges.map(i.Range.from)),wordPattern:ge.wordPattern}}}class q{constructor(U,j){this.d=U,this.e=j}async provideReferences(U,j,K,V){const re=this.d.getDocument(U),ge=i.Position.to(j),Ce=await this.e.provideReferences(re,ge,K,V);if(Array.isArray(Ce))return Ce.map(i.location.from)}}class H{static{this.d=1e3}constructor(U,j,K,V,re,ge,Ce){this.g=U,this.h=j,this.j=K,this.k=V,this.l=re,this.m=ge,this.n=Ce,this.e=new g.$qpc("CodeAction"),this.f=new Map}async provideCodeActions(U,j,K,V){const re=this.g.getDocument(U),ge=d.$Qt.isISelection(j)?i.Selection.to(j):i.Range.to(j),Ce=[];for(const et of this.j.getDiagnostics(U))if(ge.intersection(et.range)&&Ce.push(et)>H.d)break;const Ue={diagnostics:Ce,only:K.only?new n.$$N(K.only):void 0,triggerKind:i.CodeActionTriggerKind.to(K.trigger)},Qe=await this.k.provideCodeActions(re,ge,Ue,V);if(!(0,v.$Kb)(Qe)||V.isCancellationRequested)return;const _e=this.e.add(Qe),tt=new T.$Tc;this.f.set(_e,tt);const nt=[];for(let et=0;et<Qe.length;et++){const rt=Qe[et];if(rt)if(H.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,tt)});else{Ue.only&&(rt.kind?Ue.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value}' requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ft=rt.ranges??[];nt.push({cacheId:[_e,et],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,tt),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$fH)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,t.$fH)(this.m,"codeActionRanges")?(0,v.$Gb)(ft.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:_e,actions:nt}}async resolveCodeAction(U,j){const[K,V]=U,re=this.e.get(K,V);if(!re||H.o(re))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(re,j)??re;let Ce;ge.edit&&(Ce=i.WorkspaceEdit.from(ge.edit,void 0));let Ue;if(ge.command){const Qe=this.f.get(K);Qe&&(Ue=this.h.toInternal(ge.command,Qe))}return{edit:Ce,command:Ue}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}class W{constructor(U,j,K,V,re){this.e=U,this.f=j,this.g=K,this.h=V,this.j=re,this.d=new g.$qpc("DocumentPasteEdit")}async prepareDocumentPaste(U,j,K,V){if(!this.g.prepareDocumentPaste)return;const re=this.f.getDocument(U),ge=j.map(Qe=>i.Range.to(Qe)),Ce=i.DataTransfer.toDataTransfer(K,()=>{throw new O.$0});if(await this.g.prepareDocumentPaste(re,ge,Ce,V),V.isCancellationRequested)return;const Ue=Array.from(Ce).filter(([,Qe])=>!(Qe instanceof n.$EO));return i.DataTransfer.from(Ue)}async providePasteEdits(U,j,K,V,re,ge){if(!this.g.provideDocumentPasteEdits)return[];const Ce=this.f.getDocument(j),Ue=K.map(nt=>i.Range.to(nt)),Qe=i.DataTransfer.toDataTransfer(V,async nt=>(await this.e.$resolvePasteFileData(this.h,U,nt)).buffer),_e=await this.g.provideDocumentPasteEdits(Ce,Ue,Qe,{only:re.only?new n.$JO(re.only):void 0,triggerKind:re.triggerKind},ge);if(!_e||ge.isCancellationRequested)return[];const tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,c.localize)(10834,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,j){const[K,V]=U,re=this.d.get(K,V);if(!re||!this.g.resolveDocumentPasteEdit)return{};const ge=await this.g.resolveDocumentPasteEdit(re,j)??re;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releasePasteEdits(U){this.d.delete(U)}}class G{constructor(U,j){this.d=U,this.e=j}async provideDocumentFormattingEdits(U,j,K){const V=this.d.getDocument(U),re=await this.e.provideDocumentFormattingEdits(V,j,K);if(Array.isArray(re))return re.map(i.TextEdit.from)}}class Q{constructor(U,j){this.d=U,this.e=j}async provideDocumentRangeFormattingEdits(U,j,K,V){const re=this.d.getDocument(U),ge=i.Range.to(j),Ce=await this.e.provideDocumentRangeFormattingEdits(re,ge,K,V);if(Array.isArray(Ce))return Ce.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,j,K,V){(0,y.$og)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const re=this.d.getDocument(U),ge=j.map(i.Range.to),Ce=await this.e.provideDocumentRangesFormattingEdits(re,ge,K,V);if(Array.isArray(Ce))return Ce.map(i.TextEdit.from)}}class ae{constructor(U,j){this.d=U,this.e=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,j,K,V,re){const ge=this.d.getDocument(U),Ce=i.Position.to(j),Ue=await this.e.provideOnTypeFormattingEdits(ge,Ce,K,V,re);if(Array.isArray(Ue))return Ue.map(i.TextEdit.from)}}class be{constructor(U,j){this.e=U,this.f=j,this.d=new g.$qpc("WorkspaceSymbols")}async provideWorkspaceSymbols(U,j){const K=await this.e.provideWorkspaceSymbols(U,j);if(!(0,v.$Kb)(K))return{symbols:[]};const V=this.d.add(K),re={cacheId:V,symbols:[]};for(let ge=0;ge<K.length;ge++){const Ce=K[ge];if(!Ce||!Ce.name){this.f.warn("INVALID SymbolInformation",Ce);continue}re.symbols.push({...i.WorkspaceSymbol.from(Ce),cacheId:[V,ge]})}return re}async resolveWorkspaceSymbol(U,j){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const K=this.d.get(...U.cacheId);if(K){const V=await this.e.resolveWorkspaceSymbol(K,j);return V&&(0,p.$ho)(U,i.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class le{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,j,K){this.d=U,this.e=j,this.f=K}async provideRenameEdits(U,j,K,V){const re=this.d.getDocument(U),ge=i.Position.to(j);try{const Ce=await this.e.provideRenameEdits(re,ge,K,V);return Ce?i.WorkspaceEdit.from(Ce):void 0}catch(Ce){const Ue=le.g(Ce);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(Ce)}}async resolveRenameLocation(U,j,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const V=this.d.getDocument(U),re=i.Position.to(j);try{const ge=await this.e.prepareRename(V,re,K);let Ce,Ue;if(n.$ON.isRange(ge)?(Ce=ge,Ue=V.getText(ge)):(0,y.$gg)(ge)&&(Ce=ge.range,Ue=ge.placeholder),!Ce||!Ue)return;if(Ce.start.line>re.line||Ce.end.line<re.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ce),text:Ue}}catch(ge){const Ce=le.g(ge);return Ce?{rejectReason:Ce,range:void 0,text:void 0}:Promise.reject(ge)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class _{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:n.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:n.NewSymbolNameTriggerKind.Automatic}}constructor(U,j,K){this.e=U,this.f=j,this.g=K}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(U,j,K,V){const re=this.e.getDocument(U),ge=i.Range.to(j);try{const Ce=_.d[K],Ue=await this.f.provideNewSymbolNames(re,ge,Ce,V);return Ue?Ue.map(Qe=>typeof Qe=="string"?{newSymbolName:Qe}:{newSymbolName:Qe.newSymbolName,tags:Qe.tags}):void 0}catch(Ce){this.g.error(_.h(Ce)??JSON.stringify(Ce,null,"	"));return}}static h(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class ce{constructor(U,j){this.resultId=U,this.tokens=j}}class me{constructor(U,j){this.f=U,this.g=j,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,j,K){const V=this.f.getDocument(U),re=j!==0?this.d.get(j):null;let ge=typeof re?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(V,re.resultId,K):await this.g.provideDocumentSemanticTokens(V,K);return re&&this.d.delete(j),ge?(ge=me.h(ge),this.o(me.n(re,ge),ge)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return me.j(U)?me.k(U)?U:new n.$0O(new Uint32Array(U.data),U.resultId):me.l(U)?me.m(U)?U:new n.$_O(U.edits.map(j=>new n.$$O(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const j of U.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static n(U,j){if(!me.j(j)||!U||!U.tokens)return j;const K=U.tokens,V=K.length,re=j.data,ge=re.length;let Ce=0;const Ue=Math.min(V,ge);for(;Ce<Ue&&K[Ce]===re[Ce];)Ce++;if(Ce===V&&Ce===ge)return new n.$_O([],j.resultId);let Qe=0;const _e=Ue-Ce;for(;Qe<_e&&K[V-Qe-1]===re[ge-Qe-1];)Qe++;return new n.$_O([{start:Ce,deleteCount:V-Ce-Qe,data:re.subarray(Ce,ge-Qe)}],j.resultId)}o(U,j){if(me.j(U)){const K=this.e++;return this.d.set(K,new ce(U.resultId,U.data)),(0,s.$Xdb)({id:K,type:"full",data:U.data})}if(me.l(U)){const K=this.e++;return me.j(j)?this.d.set(K,new ce(j.resultId,j.data)):this.d.set(K,new ce(U.resultId)),(0,s.$Xdb)({id:K,type:"delta",deltas:(U.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}class oe{constructor(U,j){this.d=U,this.e=j}async provideDocumentRangeSemanticTokens(U,j,K){const V=this.d.getDocument(U),re=await this.e.provideDocumentRangeSemanticTokens(V,i.Range.to(j),K);return re?this.f(re):null}f(U){return(0,s.$Xdb)({id:0,type:"full",data:U.data})}}class ke{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,j,K,V,re){this.f=U,this.g=j,this.h=K,this.j=V,this.k=re,this.d=new g.$qpc("CompletionItem"),this.e=new Map}async provideCompletionItems(U,j,K,V){const re=this.f.getDocument(U),ge=i.Position.to(j),Ce=re.getWordRangeAtPosition(ge)||new n.$ON(ge,ge),Ue=Ce.with({end:ge}),Qe=new o.$fe,_e=await this.h.provideCompletionItems(re,ge,V,i.CompletionContext.to(K));if(!_e||V.isCancellationRequested)return;const tt=Array.isArray(_e)?new n.$lO(_e):_e,nt=ke.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),et=new T.$Tc;this.e.set(nt,et);const rt=[],ft={x:nt,[u.ISuggestResultDtoField.completions]:rt,[u.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Ce),insert:i.Range.from(Ue)},[u.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[u.ISuggestResultDtoField.duration]:Qe.elapsed()};for(let lt=0;lt<tt.items.length;lt++){const st=tt.items[lt],ct=this.l(st,[nt,lt],Ue,Ce);rt.push(ct)}return ft}async resolveCompletionItem(U,j){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...U);if(!K)return;const V=this.l(K,U),re=await this.h.resolveCompletionItem(K,j);if(!re)return;const ge=this.l(re,U);return(V[u.ISuggestDataDtoField.insertText]!==ge[u.ISuggestDataDtoField.insertText]||V[u.ISuggestDataDtoField.insertTextRules]!==ge[u.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(V[u.ISuggestDataDtoField.commandIdent]!==ge[u.ISuggestDataDtoField.commandIdent]||V[u.ISuggestDataDtoField.commandId]!==ge[u.ISuggestDataDtoField.commandId]||!(0,p.$io)(V[u.ISuggestDataDtoField.commandArguments],ge[u.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...V,[u.ISuggestDataDtoField.documentation]:ge[u.ISuggestDataDtoField.documentation],[u.ISuggestDataDtoField.detail]:ge[u.ISuggestDataDtoField.detail],[u.ISuggestDataDtoField.additionalTextEdits]:ge[u.ISuggestDataDtoField.additionalTextEdits],[u.ISuggestDataDtoField.insertText]:ge[u.ISuggestDataDtoField.insertText],[u.ISuggestDataDtoField.insertTextRules]:ge[u.ISuggestDataDtoField.insertTextRules],[u.ISuggestDataDtoField.commandIdent]:ge[u.ISuggestDataDtoField.commandIdent],[u.ISuggestDataDtoField.commandId]:ge[u.ISuggestDataDtoField.commandId],[u.ISuggestDataDtoField.commandArguments]:ge[u.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,j,K,V){const re=this.e.get(j[0]);if(!re)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(U.command,re),Ce={x:j,[u.ISuggestDataDtoField.label]:U.label,[u.ISuggestDataDtoField.kind]:U.kind!==void 0?i.CompletionItemKind.from(U.kind):void 0,[u.ISuggestDataDtoField.kindModifier]:U.tags&&U.tags.map(i.CompletionItemTag.from),[u.ISuggestDataDtoField.detail]:U.detail,[u.ISuggestDataDtoField.documentation]:typeof U.documentation>"u"?void 0:i.MarkdownString.fromStrict(U.documentation),[u.ISuggestDataDtoField.sortText]:U.sortText!==U.label?U.sortText:void 0,[u.ISuggestDataDtoField.filterText]:U.filterText!==U.label?U.filterText:void 0,[u.ISuggestDataDtoField.preselect]:U.preselect||void 0,[u.ISuggestDataDtoField.insertTextRules]:U.keepWhitespace?r.CompletionItemInsertTextRule.KeepWhitespace:r.CompletionItemInsertTextRule.None,[u.ISuggestDataDtoField.commitCharacters]:U.commitCharacters?.join(""),[u.ISuggestDataDtoField.additionalTextEdits]:U.additionalTextEdits&&U.additionalTextEdits.map(i.TextEdit.from),[u.ISuggestDataDtoField.commandIdent]:ge?.$ident,[u.ISuggestDataDtoField.commandId]:ge?.id,[u.ISuggestDataDtoField.commandArguments]:ge?.$ident?void 0:ge?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ce[u.ISuggestDataDtoField.insertText]=U.textEdit.newText):typeof U.insertText=="string"?Ce[u.ISuggestDataDtoField.insertText]=U.insertText:U.insertText instanceof n.$ZN&&(Ce[u.ISuggestDataDtoField.insertText]=U.insertText.value,Ce[u.ISuggestDataDtoField.insertTextRules]|=r.CompletionItemInsertTextRule.InsertAsSnippet);let Ue;return U.textEdit?Ue=U.textEdit.range:U.range&&(Ue=U.range),n.$ON.isRange(Ue)?Ce[u.ISuggestDataDtoField.range]=i.Range.from(Ue):Ue&&(!K?.isEqual(Ue.inserting)||!V?.isEqual(Ue.replacing))&&(Ce[u.ISuggestDataDtoField.range]={insert:i.Range.from(Ue.inserting),replace:i.Range.from(Ue.replacing)}),Ce}}class Te{async provideInlineCompletions(U,j,K,V){}async provideInlineEdits(U,j,K,V){}disposeCompletions(U){}handleDidShowCompletionItem(U,j,K){}handlePartialAccept(U,j,K,V){}}class Y extends Te{constructor(U,j,K,V){super(),this.f=U,this.g=j,this.h=K,this.j=V,this.d=new ne,this.e=(0,t.$fH)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:n.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:n.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$fH)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,j,K,V){const re=this.g.getDocument(U),ge=i.Position.to(j),Ce=await this.h.provideInlineCompletionItems(re,ge,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:i.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},V);if(!Ce||V.isCancellationRequested)return;const Ue=Array.isArray(Ce)?Ce:Ce.items,Qe=this.e?Array.isArray(Ce)?[]:Ce.commands||[]:[],_e=this.e&&!Array.isArray(Ce)?Ce.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ue}),items:Ue.map((et,rt)=>{let ft;et.command&&(tt||(tt=new T.$Tc),ft=this.j.toInternal(et.command,tt));const lt=et.insertText;return{insertText:typeof lt=="string"?lt:{snippet:lt.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:ft,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Qe.map(et=>(tt||(tt=new T.$Tc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}async provideInlineEdits(U,j,K,V){if(!this.h.provideInlineEdits)return;(0,t.$gH)(this.f,"inlineCompletionsAdditions");const re=this.g.getDocument(U),ge=i.Range.to(j),Ce=await this.h.provideInlineEdits(re,ge,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:i.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind],userPrompt:K.userPrompt},V);if(!Ce||V.isCancellationRequested)return;const Ue=Array.isArray(Ce)?Ce:Ce.items,Qe=this.e?Array.isArray(Ce)?[]:Ce.commands||[]:[],_e=this.e&&!Array.isArray(Ce)?Ce.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ue}),items:Ue.map((et,rt)=>{let ft;et.command&&(tt||(tt=new T.$Tc),ft=this.j.toInternal(et.command,tt));const lt=et.insertText;return{insertText:typeof lt=="string"?lt:{snippet:lt.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:ft,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Qe.map(et=>(tt||(tt=new T.$Tc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,j,K){const V=this.d.get(U)?.items[j];V&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(V,K)}handlePartialAccept(U,j,K,V){const re=this.d.get(U)?.items[j];re&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(re,K),this.h.handleDidPartiallyAcceptCompletionItem(re,i.PartialAcceptInfo.to(V)))}}class B{async provideInlineEdits(U,j,K){const V=this.f.getDocument(U),re=await this.g.provideInlineEdit(V,{triggerKind:this.e[j.triggerKind]},K);if(!re||K.isCancellationRequested)return;let ge;const Ce=this.d.createReferenceId({dispose(){ge?.dispose()},item:re});let Ue;re.accepted&&(ge||(ge=new T.$Tc),Ue=this.h.toInternal(re.accepted,ge));let Qe;return re.rejected&&(ge||(ge=new T.$Tc),Qe=this.h.toInternal(re.rejected,ge)),{pid:Ce,text:re.text,range:i.Range.from(re.range),accepted:Ue,rejected:Qe}}disposeEdit(U){this.d.disposeReferenceId(U)?.dispose()}constructor(U,j,K,V){this.f=j,this.g=K,this.h=V,this.d=new ne,this.e={[r.InlineEditTriggerKind.Automatic]:n.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:n.InlineEditTriggerKind.Invoke}}}class ne{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const j=this.e++;return this.d.set(j,U),j}disposeReferenceId(U){const j=this.d.get(U);return this.d.delete(U),j}get(U){return this.d.get(U)}}class Ee{constructor(U,j){this.e=U,this.f=j,this.d=new g.$qpc("SignatureHelp")}async provideSignatureHelp(U,j,K,V){const re=this.e.getDocument(U),ge=i.Position.to(j),Ce=this.g(K),Ue=await this.f.provideSignatureHelp(re,ge,V,Ce);if(Ue){const Qe=this.d.add([Ue]);return{...i.SignatureHelp.from(Ue),id:Qe}}}g(U){let j;if(U.activeSignatureHelp){const K=i.SignatureHelp.to(U.activeSignatureHelp),V=this.d.get(U.activeSignatureHelp.id,0);V?(j=V,j.activeSignature=K.activeSignature,j.activeParameter=K.activeParameter):j=K}return{...U,activeSignatureHelp:j}}releaseSignatureHelp(U){this.d.delete(U)}}class fe{constructor(U,j,K,V,re){this.f=U,this.g=j,this.h=K,this.j=V,this.k=re,this.d=new g.$qpc("InlayHints"),this.e=new Map}async provideInlayHints(U,j,K){const V=this.f.getDocument(U),re=i.Range.to(j),ge=await this.h.provideInlayHints(V,re,K);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`);return}if(K.isCancellationRequested)return;const Ce=this.d.add(ge);this.e.set(Ce,new T.$Tc);const Ue={hints:[],cacheId:Ce};for(let Qe=0;Qe<ge.length;Qe++)this.l(ge[Qe],re)&&Ue.hints.push(this.m(ge[Qe],[Ce,Qe]));return this.j.trace(`[InlayHints] ${Ue.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`),Ue}async resolveInlayHint(U,j){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...U);if(!K)return;const V=await this.h.resolveInlayHint(K,j);if(V&&this.l(V))return this.m(V,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,j){return U.label.length===0||Array.isArray(U.label)&&U.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(j&&!j.contains(U.position))}m(U,j){const K=this.e.get(j[0]);if(!K)throw Error("DisposableStore is missing...");const V={label:"",cacheId:j,tooltip:i.MarkdownString.fromStrict(U.tooltip),position:i.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(i.TextEdit.from),kind:U.kind&&i.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")V.label=U.label;else{const re=[];V.label=re;for(const ge of U.label){if(!ge.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ce={label:ge.value,tooltip:i.MarkdownString.fromStrict(ge.tooltip)};n.$1N.isLocation(ge.location)&&(Ce.location=i.location.from(ge.location)),ge.command&&(Ce.command=this.g.toInternal(ge.command,K)),re.push(Ce)}}return V}}class we{constructor(U,j){this.e=U,this.f=j,this.d=new g.$qpc("DocumentLink")}async provideLinks(U,j){const K=this.e.getDocument(U),V=await this.f.provideDocumentLinks(K,j);if(!(!Array.isArray(V)||V.length===0)&&!j.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:V.filter(we.g).map(i.DocumentLink.from)};{const re=this.d.add(V),ge={links:[],cacheId:re};for(let Ce=0;Ce<V.length;Ce++){if(!we.g(V[Ce]))continue;const Ue=i.DocumentLink.from(V[Ce]);Ue.cacheId=[re,Ce],ge.links.push(Ue)}return ge}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,j){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...U);if(!K)return;const V=await this.f.resolveDocumentLink(K,j);if(!(!V||!we.g(V)))return i.DocumentLink.from(V)}releaseLinks(U){this.d.delete(U)}}class he{constructor(U,j){this.d=U,this.e=j}async provideColors(U,j){const K=this.d.getDocument(U),V=await this.e.provideDocumentColors(K,j);return Array.isArray(V)?V.map(ge=>({color:i.Color.from(ge.color),range:i.Range.from(ge.range)})):[]}async provideColorPresentations(U,j,K){const V=this.d.getDocument(U),re=i.Range.to(j.range),ge=i.Color.to(j.color),Ce=await this.e.provideColorPresentations(ge,{document:V,range:re},K);if(Array.isArray(Ce))return Ce.map(i.ColorPresentation.from)}}class X{constructor(U,j){this.d=U,this.e=j}async provideFoldingRanges(U,j,K){const V=this.d.getDocument(U),re=await this.e.provideFoldingRanges(V,j,K);if(Array.isArray(re))return re.map(i.FoldingRange.from)}}class x{constructor(U,j,K){this.d=U,this.e=j,this.f=K}async provideSelectionRanges(U,j,K){const V=this.d.getDocument(U),re=j.map(i.Position.to),ge=await this.e.provideSelectionRanges(V,re,K);if(!(0,v.$Kb)(ge))return[];if(ge.length!==re.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ce=[];for(let Ue=0;Ue<re.length;Ue++){const Qe=[];Ce.push(Qe);let _e=re[Ue],tt=ge[Ue];for(;;){if(!tt.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(i.SelectionRange.from(tt)),!tt.parent)break;_e=tt.range,tt=tt.parent}}return Ce}}class $e{constructor(U,j){this.f=U,this.g=j,this.d=new A.$pQ(""),this.e=new Map}async prepareSession(U,j,K){const V=this.f.getDocument(U),re=i.Position.to(j),ge=await this.g.prepareCallHierarchy(V,re,K);if(!ge)return;const Ce=this.d.nextId();return this.e.set(Ce,new Map),Array.isArray(ge)?ge.map(Ue=>this.h(Ce,Ue)):[this.h(Ce,ge)]}async provideCallsTo(U,j,K){const V=this.j(U,j);if(!V)throw new Error("missing call hierarchy item");const re=await this.g.provideCallHierarchyIncomingCalls(V,K);if(re)return re.map(ge=>({from:this.h(U,ge.from),fromRanges:ge.fromRanges.map(Ce=>i.Range.from(Ce))}))}async provideCallsFrom(U,j,K){const V=this.j(U,j);if(!V)throw new Error("missing call hierarchy item");const re=await this.g.provideCallHierarchyOutgoingCalls(V,K);if(re)return re.map(ge=>({to:this.h(U,ge.to),fromRanges:ge.fromRanges.map(Ce=>i.Range.from(Ce))}))}releaseSession(U){this.e.delete(U)}h(U,j){const K=this.e.get(U),V=i.CallHierarchyItem.from(j,U,K.size.toString(36));return K.set(V._itemId,j),V}j(U,j){return this.e.get(U)?.get(j)}}class pe{constructor(U,j){this.f=U,this.g=j,this.d=new A.$pQ(""),this.e=new Map}async prepareSession(U,j,K){const V=this.f.getDocument(U),re=i.Position.to(j),ge=await this.g.prepareTypeHierarchy(V,re,K);if(!ge)return;const Ce=this.d.nextId();return this.e.set(Ce,new Map),Array.isArray(ge)?ge.map(Ue=>this.h(Ce,Ue)):[this.h(Ce,ge)]}async provideSupertypes(U,j,K){const V=this.j(U,j);if(!V)throw new Error("missing type hierarchy item");const re=await this.g.provideTypeHierarchySupertypes(V,K);if(re)return re.map(ge=>this.h(U,ge))}async provideSubtypes(U,j,K){const V=this.j(U,j);if(!V)throw new Error("missing type hierarchy item");const re=await this.g.provideTypeHierarchySubtypes(V,K);if(re)return re.map(ge=>this.h(U,ge))}releaseSession(U){this.e.delete(U)}h(U,j){const K=this.e.get(U),V=i.TypeHierarchyItem.from(j,U,K.size.toString(36));return K.set(V._itemId,j),V}j(U,j){return this.e.get(U)?.get(j)}}class Ae{constructor(U,j,K,V,re){this.e=U,this.f=j,this.g=K,this.h=V,this.j=re,this.d=new g.$qpc("DocumentDropEdit")}async provideDocumentOnDropEdits(U,j,K,V,re){const ge=this.f.getDocument(j),Ce=i.Position.to(K),Ue=i.DataTransfer.toDataTransfer(V,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,U,nt)).buffer),Qe=await this.g.provideDocumentDropEdits(ge,Ce,Ue,re);if(!Qe)return;const _e=(0,v.$1b)(Qe),tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,c.localize)(10835,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(U,j){const[K,V]=U,re=this.d.get(K,V);if(!re||!this.g.resolveDocumentDropEdit)return{};const ge=await this.g.resolveDocumentDropEdit(re,j)??re;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releaseDropEdits(U){this.d.delete(U)}}class ze{constructor(U,j){this.d=U,this.e=j}async provideMappedEdits(U,j,K,V){const re=a.URI.revive(U),ge=this.d.getDocument(re),Ce=K.documents.map(_e=>_e.map(tt=>({uri:a.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(nt=>i.Range.to(nt))}))),Ue={documents:Ce,selections:Ce[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(ge,j,Ue,V);return Qe?i.WorkspaceEdit.from(Qe):null}}class Ie{constructor(U,j){this.adapter=U,this.extension=j}}class Pe{static{this.d=0}constructor(U,j,K,V,re,ge,Ce,Ue){this.g=j,this.h=K,this.j=V,this.k=re,this.l=ge,this.m=Ce,this.n=Ue,this.f=new Map,this.e=U.getProxy(u.$KN.MainThreadLanguageFeatures)}o(U,j){return i.DocumentSelector.from(U,this.g,j)}p(U){return new n.$MN(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return Pe.d++}async s(U,j,K,V,re,ge=!1){const Ce=this.f.get(U);if(!Ce||!(Ce.adapter instanceof j))return V;const Ue=Date.now();ge||this.l.trace(`[${Ce.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Qe=K(Ce.adapter,Ce.extension);return Promise.resolve(Qe).catch(_e=>{(0,O.$3)(_e)||(this.l.error(`[${Ce.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ce.extension.identifier,_e))}).finally(()=>{ge||this.l.trace(`[${Ce.extension.identifier.value}] provider DONE after ${Date.now()-Ue}ms`)}),P.CancellationToken.isCancellationToken(re)?(0,R.$uh)(Qe,re):Qe}t(U,j){const K=this.q();return this.f.set(K,new Ie(U,j)),K}static u(U){return U.displayName||U.name}static w(U){return U.identifier.value}registerDocumentSymbolProvider(U,j,K,V){const re=this.t(new $(this.h,K),U),ge=V&&V.label||Pe.u(U);return this.e.$registerDocumentSymbolProvider(re,this.o(j,U),ge),this.p(re)}$provideDocumentSymbols(U,j,K){return this.s(U,$,V=>V.provideDocumentSymbols(a.URI.revive(j),K),void 0,K)}registerCodeLensProvider(U,j,K){const V=this.q(),re=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(V,new Ie(new m(this.h,this.j.converter,K,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(V,this.o(j,U),re);let ge=this.p(V);if(re!==void 0){const Ce=K.onDidChangeCodeLenses(Ue=>this.e.$emitCodeLensEvent(re));ge=n.$MN.from(ge,Ce)}return ge}$provideCodeLenses(U,j,K){return this.s(U,m,V=>V.provideCodeLenses(a.URI.revive(j),K),void 0,K)}$resolveCodeLens(U,j,K){return this.s(U,m,V=>V.resolveCodeLens(j,K),void 0,void 0)}$releaseCodeLenses(U,j){this.s(U,m,K=>Promise.resolve(K.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(U,j,K){const V=this.t(new E(this.h,K),U);return this.e.$registerDefinitionSupport(V,this.o(j,U)),this.p(V)}$provideDefinition(U,j,K,V){return this.s(U,E,re=>re.provideDefinition(a.URI.revive(j),K,V),[],V)}registerDeclarationProvider(U,j,K){const V=this.t(new D(this.h,K),U);return this.e.$registerDeclarationSupport(V,this.o(j,U)),this.p(V)}$provideDeclaration(U,j,K,V){return this.s(U,D,re=>re.provideDeclaration(a.URI.revive(j),K,V),[],V)}registerImplementationProvider(U,j,K){const V=this.t(new b(this.h,K),U);return this.e.$registerImplementationSupport(V,this.o(j,U)),this.p(V)}$provideImplementation(U,j,K,V){return this.s(U,b,re=>re.provideImplementation(a.URI.revive(j),K,V),[],V)}registerTypeDefinitionProvider(U,j,K){const V=this.t(new C(this.h,K),U);return this.e.$registerTypeDefinitionSupport(V,this.o(j,U)),this.p(V)}$provideTypeDefinition(U,j,K,V){return this.s(U,C,re=>re.provideTypeDefinition(a.URI.revive(j),K,V),[],V)}registerHoverProvider(U,j,K,V){const re=this.t(new k(this.h,K),U);return this.e.$registerHoverProvider(re,this.o(j,U)),this.p(re)}$provideHover(U,j,K,V,re){return this.s(U,k,ge=>ge.provideHover(a.URI.revive(j),K,V,re),void 0,re)}$releaseHover(U,j){this.s(U,k,K=>Promise.resolve(K.releaseHover(j)),void 0,void 0)}registerEvaluatableExpressionProvider(U,j,K,V){const re=this.t(new f(this.h,K),U);return this.e.$registerEvaluatableExpressionProvider(re,this.o(j,U)),this.p(re)}$provideEvaluatableExpression(U,j,K,V){return this.s(U,f,re=>re.provideEvaluatableExpression(a.URI.revive(j),K,V),void 0,V)}registerInlineValuesProvider(U,j,K,V){const re=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new w(this.h,K),U);this.e.$registerInlineValuesProvider(ge,this.o(j,U),re);let Ce=this.p(ge);if(re!==void 0){const Ue=K.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(re));Ce=n.$MN.from(Ce,Ue)}return Ce}$provideInlineValues(U,j,K,V,re){return this.s(U,w,ge=>ge.provideInlineValues(a.URI.revive(j),K,V,re),void 0,re)}registerDocumentHighlightProvider(U,j,K){const V=this.t(new F(this.h,K),U);return this.e.$registerDocumentHighlightProvider(V,this.o(j,U)),this.p(V)}registerMultiDocumentHighlightProvider(U,j,K){const V=this.t(new N(this.h,K),U);return this.e.$registerMultiDocumentHighlightProvider(V,this.o(j,U)),this.p(V)}$provideDocumentHighlights(U,j,K,V){return this.s(U,F,re=>re.provideDocumentHighlights(a.URI.revive(j),K,V),void 0,V)}$provideMultiDocumentHighlights(U,j,K,V,re){return this.s(U,N,ge=>ge.provideMultiDocumentHighlights(a.URI.revive(j),K,V.map(Ce=>a.URI.revive(Ce)),re),void 0,re)}registerLinkedEditingRangeProvider(U,j,K){const V=this.t(new L(this.h,K),U);return this.e.$registerLinkedEditingRangeProvider(V,this.o(j,U)),this.p(V)}$provideLinkedEditingRanges(U,j,K,V){return this.s(U,L,async re=>{const ge=await re.provideLinkedEditingRanges(a.URI.revive(j),K,V);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?Pe.y(ge.wordPattern):void 0}},void 0,V)}registerReferenceProvider(U,j,K){const V=this.t(new q(this.h,K),U);return this.e.$registerReferenceSupport(V,this.o(j,U)),this.p(V)}$provideReferences(U,j,K,V,re){return this.s(U,q,ge=>ge.provideReferences(a.URI.revive(j),K,V,re),void 0,re)}registerCodeActionProvider(U,j,K,V){const re=new T.$Tc,ge=this.t(new H(this.h,this.j.converter,this.k,K,this.l,U,this.m),U);return this.e.$registerCodeActionSupport(ge,this.o(j,U),{providedKinds:V?.providedCodeActionKinds?.map(Ce=>Ce.value),documentation:V?.documentation?.map(Ce=>({kind:Ce.kind.value,command:this.j.converter.toInternal(Ce.command,re)}))},Pe.u(U),Pe.w(U),!!K.resolveCodeAction),re.add(this.p(ge)),re}$provideCodeActions(U,j,K,V,re){return this.s(U,H,ge=>ge.provideCodeActions(a.URI.revive(j),K,V,re),void 0,re)}$resolveCodeAction(U,j,K){return this.s(U,H,V=>V.resolveCodeAction(j,K),{},void 0)}$releaseCodeActions(U,j){this.s(U,H,K=>Promise.resolve(K.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(U,j,K){const V=this.t(new G(this.h,K),U);return this.e.$registerDocumentFormattingSupport(V,this.o(j,U),U.identifier,U.displayName||U.name),this.p(V)}$provideDocumentFormattingEdits(U,j,K,V){return this.s(U,G,re=>re.provideDocumentFormattingEdits(a.URI.revive(j),K,V),void 0,V)}registerDocumentRangeFormattingEditProvider(U,j,K){const V=typeof K.provideDocumentRangesFormattingEdits=="function",re=this.t(new Q(this.h,K),U);return this.e.$registerRangeFormattingSupport(re,this.o(j,U),U.identifier,U.displayName||U.name,V),this.p(re)}$provideDocumentRangeFormattingEdits(U,j,K,V,re){return this.s(U,Q,ge=>ge.provideDocumentRangeFormattingEdits(a.URI.revive(j),K,V,re),void 0,re)}$provideDocumentRangesFormattingEdits(U,j,K,V,re){return this.s(U,Q,ge=>ge.provideDocumentRangesFormattingEdits(a.URI.revive(j),K,V,re),void 0,re)}registerOnTypeFormattingEditProvider(U,j,K,V){const re=this.t(new ae(this.h,K),U);return this.e.$registerOnTypeFormattingSupport(re,this.o(j,U),V,U.identifier),this.p(re)}$provideOnTypeFormattingEdits(U,j,K,V,re,ge){return this.s(U,ae,Ce=>Ce.provideOnTypeFormattingEdits(a.URI.revive(j),K,V,re,ge),void 0,ge)}registerWorkspaceSymbolProvider(U,j){const K=this.t(new be(j,this.l),U);return this.e.$registerNavigateTypeSupport(K,typeof j.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(U,j,K){return this.s(U,be,V=>V.provideWorkspaceSymbols(j,K),{symbols:[]},K)}$resolveWorkspaceSymbol(U,j,K){return this.s(U,be,V=>V.resolveWorkspaceSymbol(j,K),void 0,void 0)}$releaseWorkspaceSymbols(U,j){this.s(U,be,K=>K.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(U,j,K){const V=this.t(new le(this.h,K,this.l),U);return this.e.$registerRenameSupport(V,this.o(j,U),le.supportsResolving(K)),this.p(V)}$provideRenameEdits(U,j,K,V,re){return this.s(U,le,ge=>ge.provideRenameEdits(a.URI.revive(j),K,V,re),void 0,re)}$resolveRenameLocation(U,j,K,V){return this.s(U,le,re=>re.resolveRenameLocation(a.URI.revive(j),K,V),void 0,V)}registerNewSymbolNamesProvider(U,j,K){const V=this.t(new _(this.h,K,this.l),U);return this.e.$registerNewSymbolNamesProvider(V,this.o(j,U)),this.p(V)}$supportsAutomaticNewSymbolNamesTriggerKind(U){return this.s(U,_,j=>j.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(U,j,K,V,re){return this.s(U,_,ge=>ge.provideNewSymbolNames(a.URI.revive(j),K,V,re),void 0,re)}registerDocumentSemanticTokensProvider(U,j,K,V){const re=this.t(new me(this.h,K),U),ge=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(re,this.o(j,U),V,ge);let Ce=this.p(re);if(ge){const Ue=K.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(ge));Ce=n.$MN.from(Ce,Ue)}return Ce}$provideDocumentSemanticTokens(U,j,K,V){return this.s(U,me,re=>re.provideDocumentSemanticTokens(a.URI.revive(j),K,V),null,V)}$releaseDocumentSemanticTokens(U,j){this.s(U,me,K=>K.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,j,K,V){const re=this.t(new oe(this.h,K),U);return this.e.$registerDocumentRangeSemanticTokensProvider(re,this.o(j,U),V),this.p(re)}$provideDocumentRangeSemanticTokens(U,j,K,V){return this.s(U,oe,re=>re.provideDocumentRangeSemanticTokens(a.URI.revive(j),K,V),null,V)}registerCompletionItemProvider(U,j,K,V){const re=this.t(new ke(this.h,this.j.converter,K,this.m,U),U);return this.e.$registerCompletionsProvider(re,this.o(j,U),V,ke.supportsResolving(K),U.identifier),this.p(re)}$provideCompletionItems(U,j,K,V,re){return this.s(U,ke,ge=>ge.provideCompletionItems(a.URI.revive(j),K,V,re),void 0,re)}$resolveCompletionItem(U,j,K){return this.s(U,ke,V=>V.resolveCompletionItem(j,K),void 0,K)}$releaseCompletionItems(U,j){this.s(U,ke,K=>K.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(U,j,K,V){const re=new Y(U,this.h,K,this.j.converter),ge=this.t(re,U);return this.e.$registerInlineCompletionsSupport(ge,this.o(j,U),re.supportsHandleEvents,l.$rn.toKey(U.identifier.value),V?.yieldTo?.map(Ce=>l.$rn.toKey(Ce))||[]),this.p(ge)}$provideInlineCompletions(U,j,K,V,re){return this.s(U,Te,ge=>ge.provideInlineCompletions(a.URI.revive(j),K,V,re),void 0,re)}$provideInlineEdits(U,j,K,V,re){return this.s(U,Te,ge=>ge.provideInlineEdits(a.URI.revive(j),K,V,re),void 0,re)}$handleInlineCompletionDidShow(U,j,K,V){this.s(U,Te,async re=>{re.handleDidShowCompletionItem(j,K,V)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,j,K,V,re){this.s(U,Te,async ge=>{ge.handlePartialAccept(j,K,V,re)},void 0,void 0)}$freeInlineCompletionsList(U,j){this.s(U,Te,async K=>{K.disposeCompletions(j)},void 0,void 0)}registerInlineEditProvider(U,j,K){const V=new B(U,this.h,K,this.j.converter),re=this.t(V,U);return this.e.$registerInlineEditProvider(re,this.o(j,U),U.identifier),this.p(re)}$provideInlineEdit(U,j,K,V){return this.s(U,B,re=>re.provideInlineEdits(a.URI.revive(j),K,V),void 0,V)}$freeInlineEdit(U,j){this.s(U,B,async K=>{K.disposeEdit(j)},void 0,void 0)}registerSignatureHelpProvider(U,j,K,V){const re=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,ge=this.t(new Ee(this.h,K),U);return this.e.$registerSignatureHelpProvider(ge,this.o(j,U),re),this.p(ge)}$provideSignatureHelp(U,j,K,V,re){return this.s(U,Ee,ge=>ge.provideSignatureHelp(a.URI.revive(j),K,V,re),void 0,re)}$releaseSignatureHelp(U,j){this.s(U,Ee,K=>K.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(U,j,K){const V=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,re=this.t(new fe(this.h,this.j.converter,K,this.l,U),U);this.e.$registerInlayHintsProvider(re,this.o(j,U),typeof K.resolveInlayHint=="function",V,Pe.u(U));let ge=this.p(re);if(V!==void 0){const Ce=K.onDidChangeInlayHints(Ue=>this.e.$emitInlayHintsEvent(V));ge=n.$MN.from(ge,Ce)}return ge}$provideInlayHints(U,j,K,V){return this.s(U,fe,re=>re.provideInlayHints(a.URI.revive(j),K,V),void 0,V)}$resolveInlayHint(U,j,K){return this.s(U,fe,V=>V.resolveInlayHint(j,K),void 0,K)}$releaseInlayHints(U,j){this.s(U,fe,K=>K.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(U,j,K){const V=this.t(new we(this.h,K),U);return this.e.$registerDocumentLinkProvider(V,this.o(j,U),typeof K.resolveDocumentLink=="function"),this.p(V)}$provideDocumentLinks(U,j,K){return this.s(U,we,V=>V.provideLinks(a.URI.revive(j),K),void 0,K,j.scheme==="output")}$resolveDocumentLink(U,j,K){return this.s(U,we,V=>V.resolveLink(j,K),void 0,void 0,!0)}$releaseDocumentLinks(U,j){this.s(U,we,K=>K.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(U,j,K){const V=this.t(new he(this.h,K),U);return this.e.$registerDocumentColorProvider(V,this.o(j,U)),this.p(V)}$provideDocumentColors(U,j,K){return this.s(U,he,V=>V.provideColors(a.URI.revive(j),K),[],K)}$provideColorPresentations(U,j,K,V){return this.s(U,he,re=>re.provideColorPresentations(a.URI.revive(j),K,V),void 0,V)}registerFoldingRangeProvider(U,j,K){const V=this.q(),re=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(V,new Ie(new X(this.h,K),U)),this.e.$registerFoldingRangeProvider(V,this.o(j,U),U.identifier,re);let ge=this.p(V);if(re!==void 0){const Ce=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(re));ge=n.$MN.from(ge,Ce)}return ge}$provideFoldingRanges(U,j,K,V){return this.s(U,X,re=>re.provideFoldingRanges(a.URI.revive(j),K,V),void 0,V)}registerSelectionRangeProvider(U,j,K){const V=this.t(new x(this.h,K,this.l),U);return this.e.$registerSelectionRangeProvider(V,this.o(j,U)),this.p(V)}$provideSelectionRanges(U,j,K,V){return this.s(U,x,re=>re.provideSelectionRanges(a.URI.revive(j),K,V),[],V)}registerCallHierarchyProvider(U,j,K){const V=this.t(new $e(this.h,K),U);return this.e.$registerCallHierarchyProvider(V,this.o(j,U)),this.p(V)}$prepareCallHierarchy(U,j,K,V){return this.s(U,$e,re=>Promise.resolve(re.prepareSession(a.URI.revive(j),K,V)),void 0,V)}$provideCallHierarchyIncomingCalls(U,j,K,V){return this.s(U,$e,re=>re.provideCallsTo(j,K,V),void 0,V)}$provideCallHierarchyOutgoingCalls(U,j,K,V){return this.s(U,$e,re=>re.provideCallsFrom(j,K,V),void 0,V)}$releaseCallHierarchy(U,j){this.s(U,$e,K=>Promise.resolve(K.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(U,j,K){const V=this.t(new pe(this.h,K),U);return this.e.$registerTypeHierarchyProvider(V,this.o(j,U)),this.p(V)}$prepareTypeHierarchy(U,j,K,V){return this.s(U,pe,re=>Promise.resolve(re.prepareSession(a.URI.revive(j),K,V)),void 0,V)}$provideTypeHierarchySupertypes(U,j,K,V){return this.s(U,pe,re=>re.provideSupertypes(j,K,V),void 0,V)}$provideTypeHierarchySubtypes(U,j,K,V){return this.s(U,pe,re=>re.provideSubtypes(j,K,V),void 0,V)}$releaseTypeHierarchy(U,j){this.s(U,pe,K=>Promise.resolve(K.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(U,j,K,V){const re=this.q();return this.f.set(re,new Ie(new Ae(this.e,this.h,K,re,U),U)),this.e.$registerDocumentOnDropEditProvider(re,this.o(j,U),(0,t.$fH)(U,"documentPaste")&&V?{supportsResolve:!!K.resolveDocumentDropEdit,dropMimeTypes:V.dropMimeTypes}:void 0),this.p(re)}$provideDocumentOnDropEdits(U,j,K,V,re,ge){return this.s(U,Ae,Ce=>Promise.resolve(Ce.provideDocumentOnDropEdits(j,a.URI.revive(K),V,re,ge)),void 0,void 0)}$resolveDropEdit(U,j,K){return this.s(U,Ae,V=>V.resolveDropEdit(j,K),{},void 0)}$releaseDocumentOnDropEdits(U,j){this.s(U,Ae,K=>Promise.resolve(K.releaseDropEdits(j)),void 0,void 0)}registerMappedEditsProvider(U,j,K){const V=this.t(new ze(this.h,K),U);return this.e.$registerMappedEditsProvider(V,this.o(j,U),U.displayName??U.name),this.p(V)}$provideMappedEdits(U,j,K,V,re){return this.s(U,ze,ge=>Promise.resolve(ge.provideMappedEdits(j,K,V,re)),null,re)}registerDocumentPasteEditProvider(U,j,K,V){const re=this.q();return this.f.set(re,new Ie(new W(this.e,this.h,K,re,U),U)),this.e.$registerPasteEditProvider(re,this.o(j,U),{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,supportsResolve:!!K.resolveDocumentPasteEdit,providedPasteEditKinds:V.providedPasteEditKinds?.map(ge=>ge.value),copyMimeTypes:V.copyMimeTypes,pasteMimeTypes:V.pasteMimeTypes}),this.p(re)}$prepareDocumentPaste(U,j,K,V,re){return this.s(U,W,ge=>ge.prepareDocumentPaste(a.URI.revive(j),K,V,re),void 0,re)}$providePasteEdits(U,j,K,V,re,ge,Ce){return this.s(U,W,Ue=>Ue.providePasteEdits(j,a.URI.revive(K),V,re,ge,Ce),void 0,Ce)}$resolvePasteEdit(U,j,K){return this.s(U,W,V=>V.resolvePasteEdit(j,K),{},void 0)}$releasePasteEdits(U,j){this.s(U,W,K=>Promise.resolve(K.releasePasteEdits(j)),void 0,void 0)}static y(U){return{pattern:U.source,flags:U.flags}}static z(U){return{decreaseIndentPattern:Pe.y(U.decreaseIndentPattern),increaseIndentPattern:Pe.y(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Pe.y(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Pe.y(U.unIndentedLinePattern):void 0}}static B(U){return{beforeText:Pe.y(U.beforeText),afterText:U.afterText?Pe.y(U.afterText):void 0,previousLineText:U.previousLineText?Pe.y(U.previousLineText):void 0,action:U.action}}static C(U){return U.map(Pe.B)}static D(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(j=>n.SyntaxTokenType.toString(j)):void 0}}static E(U){return U.map(Pe.D)}setLanguageConfiguration(U,j,K){const{wordPattern:V}=K;if(V&&(0,I.$rf)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this.h.setWordDefinitionFor(j,V):this.h.setWordDefinitionFor(j,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const re=this.q(),ge={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Pe.y(K.wordPattern):void 0,indentationRules:K.indentationRules?Pe.z(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Pe.C(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Pe.E(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(re,j,ge),this.p(re)}$setWordDefinitions(U){for(const j of U)this.h.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.$Apc=Pe}),define(Ne[244],Le([1,0,4,36,5,8]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qc=void 0,O=qe(O);class A{constructor(p){this.a=new Map,this.c=new Map,this.b=p.getProxy(P.$KN.MainThreadLanguageModelTools),this.b.$getTools().then(o=>{for(const I of o)this.c.set(I.name,(0,R.$ci)(I))})}async invokeTool(p,o,I){return await this.b.$invokeTool(p,o,I)}async $acceptToolDelta(p){p.added&&this.c.set(p.added.name,p.added),p.removed&&this.c.delete(p.removed)}get tools(){return Array.from(this.c.values()).map(p=>O.LanguageModelToolDescription.to(p))}async $invokeTool(p,o,I){const y=this.a.get(p);if(!y)throw new Error(`Unknown tool ${p}`);return await y.tool.invoke(o,I)}registerTool(p,o,I){return this.a.set(o,{extension:p,tool:I}),this.b.$registerTool(o),(0,v.$Sc)(()=>{this.a.delete(o),this.b.$unregisterTool(o)})}}e.$5qc=A}),define(Ne[94],Le([1,0,10,21,42,13,6,40,4,9,18,3,11,76,5,90,16,8,7,117,24]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$iqc=e.$hqc=void 0,c=qe(c),l=qe(l),e.$hqc=(0,y.$Fi)("IExtHostLanguageModels");class g{constructor(h,E){this.option=h,this.stream=new v.$9h,this.stream=E??new v.$9h}}class u{constructor(){this.a=new Map,this.b=new v.$9h,this.c=!1;const h=this;this.apiObject={get stream(){return h.b.asyncIterable},get text(){return v.$6h.map(h.b.asyncIterable,E=>{if(E instanceof l.$7P)return E.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,h]of this.a)yield h.stream;else yield this.b}handleFragment(h){if(this.c)return;let E=this.a.get(h.index);E||(this.a.size===0?E=new g(h.index,this.b):E=new g(h.index),this.a.set(h.index,E));let D;h.part.type==="text"?D=new l.$7P(h.part.value):D=new l.$6P(h.part.name,h.part.parameters),E.stream.emitOne(D)}reject(h){this.c=!0;for(const E of this.d())E.reject(h)}resolve(){this.c=!0;for(const h of this.d())h.resolve()}}let $=class{static{t=this}static{this.a=1}constructor(h,E,D){this.j=E,this.k=D,this.c=new A.$le,this.d=new A.$le,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new I.$tn,this.i=new Map,this.s=new Set,this.b=h.getProxy(d.$KN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(h,E,D,b){const C=t.a++;this.f.set(C,{extension:h.identifier,provider:D,languageModelId:E});let k;b.auth&&(k={providerLabel:h.displayName||h.name,accountLabel:typeof b.auth=="object"?b.auth.label:void 0}),this.b.$registerLanguageModelProvider(C,`${I.$rn.toKey(h.identifier)}/${C}/${E}`,{extension:h.identifier,id:E,vendor:b.vendor??I.$rn.toKey(h.identifier),name:b.name??"",family:b.family??"",version:b.version,maxInputTokens:b.maxInputTokens,maxOutputTokens:b.maxOutputTokens,auth:k,targetExtensions:b.extensions});const f=D.onDidReceiveLanguageModelResponse2?.(({extensionId:w,participant:F,tokenCount:N})=>{this.b.$whenLanguageModelChatRequestMade(E,new I.$rn(w),F,N)});return(0,p.$Sc)(()=>{this.f.delete(C),this.b.$unregisterProvider(C),f?.dispose()})}async $startChatRequest(h,E,D,b,C,k){const f=this.f.get(h);if(!f)throw new Error("Provider not found");const w=new S.$zw(async N=>{if(k.isCancellationRequested){this.j.warn(`[CHAT](${f.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let L;if(N.part instanceof l.$6P?L={type:"function_use",name:N.part.name,parameters:N.part.parameters}:N.part instanceof l.$7P&&(L={type:"text",value:N.part.value}),!L){this.j.warn(`[CHAT](${f.extension.value}) UNKNOWN part ${JSON.stringify(N)}`);return}this.b.$reportResponsePart(E,{index:N.index,part:L})});let F;if(f.provider.provideLanguageModelResponse2)F=Promise.resolve(f.provider.provideLanguageModelResponse2(b.map(c.LanguageModelChatMessage.to),C,I.$rn.toKey(D),w,k));else{const N=new S.$zw(async L=>{w.report({index:L.index,part:new l.$7P(L.part)})});F=Promise.resolve(f.provider.provideLanguageModelResponse(b.map(c.LanguageModelChatMessage.to),C?.modelOptions??{},I.$rn.toKey(D),N,k))}F.then(()=>{this.b.$reportResponseDone(E,void 0)},N=>{this.b.$reportResponseDone(E,(0,O.$1)(N))})}$provideTokenLength(h,E,D){const b=this.f.get(h);return b?Promise.resolve(b.provider.provideTokenCount(E,D)):Promise.resolve(0)}$acceptChatModelMetadata(h){if(h.added)for(const{identifier:E,metadata:D}of h.added)this.g.set(E,{metadata:D,apiObjects:new I.$tn});if(h.removed)for(const E of h.removed){this.g.delete(E);for(const[D,b]of this.i)b.languageModelId===E&&(b.res.reject(new O.$4),this.i.delete(D))}h.added?.forEach(E=>this.q(E.metadata)),this.d.fire(void 0)}async selectLanguageModels(h,E){const D=await this.b.$selectChatModels({...E,extension:h.identifier}),b=[],C=this;for(const k of D){const f=this.g.get(k);if(!f)continue;this.o(h.identifier,f.metadata)&&await this.q(f.metadata);let w=f.apiObjects.get(h.identifier);w||(w={id:k,vendor:f.metadata.vendor,family:f.metadata.family,version:f.metadata.version,name:f.metadata.name,maxInputTokens:f.metadata.maxInputTokens,countTokens(F,N){if(!C.g.has(k))throw l.$$P.NotFound(k);return C.r(k,F,N??R.CancellationToken.None)},sendRequest(F,N,L){if(!C.g.has(k))throw l.$$P.NotFound(k);return C.l(h,k,F,N??{},L??R.CancellationToken.None)}},Object.freeze(w),f.apiObjects.set(h.identifier,w)),b.push(w)}return b}async l(h,E,D,b,C){const k=this.m(h,D),f=h.identifier,w=this.g.get(E)?.metadata;if(!w||!this.g.has(E))throw l.$$P.NotFound(`Language model '${E}' is unknown.`);if(this.o(f,w)&&(!await this.n(h,{identifier:w.extension,displayName:w.auth.providerLabel},b.justification,!1)||!this.h.get(f)?.has(w.extension)))throw l.$$P.NoPermissions(`Language model '${E}' cannot be used by '${f.value}'.`);try{const F=Math.random()*1e6|0,N=new u;this.i.set(F,{languageModelId:E,res:N});try{await this.b.$tryStartChatRequest(f,E,F,k,b,C)}catch(L){throw this.i.delete(F),L}return N.apiObject}catch(F){throw F.name===l.$$P.name?F:new l.$$P(`Language model '${E}' errored: ${(0,P.$qj)(F)}`,"Unknown",F)}}m(h,E){const D=[];for(const b of E)b.role===l.LanguageModelChatMessageRole.System&&(0,n.$gH)(h,"languageModelSystem"),b.content2 instanceof l.$4P&&(0,n.$gH)(h,"lmTools"),D.push(c.LanguageModelChatMessage.from(b));return D}async $acceptResponsePart(h,E){const D=this.i.get(h);D&&D.res.handleFragment(E)}async $acceptResponseDone(h,E){const D=this.i.get(h);D&&(this.i.delete(h),E?D.res.reject((0,O.$2)(E)):D.res.resolve())}async n(h,E,D,b){const C=i.$MM+E.identifier.value;if(await this.k.getSession(h,C,[],{silent:!0}))return this.$updateModelAccesslist([{from:h.identifier,to:E.identifier,enabled:!0}]),!0;if(b)return!1;try{const f=D?(0,o.localize)(10833,null,E.displayName,D):void 0;return await this.k.getSession(h,C,[],{forceNewSession:{detail:f}}),this.$updateModelAccesslist([{from:h.identifier,to:E.identifier,enabled:!0}]),!0}catch{return!1}}o(h,E){return!!E.auth&&!I.$rn.equals(E.extension,h)}async q(h){if(h.auth)for(const E of this.s)try{await this.n(E,{identifier:h.extension,displayName:""},void 0,!0)}catch(D){this.j.error("Fake Auth request failed"),this.j.error(D)}}async r(h,E,D){if(!this.g.get(h))throw l.$$P.NotFound(`Language model '${h}' is unknown.`);const C=T.Iterable.find(this.f.values(),k=>k.languageModelId===h);return C?C.provider.provideTokenCount(E,D):this.b.$countTokens(h,typeof E=="string"?E:c.LanguageModelChatMessage.from(E),D)}$updateModelAccesslist(h){const E=new Array;for(const{from:D,to:b,enabled:C}of h){const k=this.h.get(D)??new I.$sn;if(k.has(b)!==C){C?k.add(b):k.delete(b),this.h.set(D,k);const w={from:D,to:b};E.push(w),this.c.fire(w)}}}createLanguageModelAccessInformation(h){this.s.add(h);const E=this,D=A.Event.signal(A.Event.filter(this.c.event,C=>I.$rn.equals(C.from,h.identifier))),b=A.Event.signal(this.d.event);return{get onDidChange(){return A.Event.any(D,b)},canSendRequest(C){let k;e:for(const[w,F]of E.g)for(const N of F.apiObjects.values())if(N===C){k=F.metadata;break e}if(!k)return;if(!E.o(h.identifier,k))return!0;const f=E.h.get(h.identifier);if(f)return f.has(k.extension)}}}};e.$iqc=$,e.$iqc=$=t=Je([Ve(0,s.$kQ),Ve(1,a.$ak),Ve(2,r.$Cpc)],$)});var xt=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[245],Le([1,0,5,8,7,35,10,4,24]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=void 0,R=qe(R),O=xt(O);class o{constructor(y,a,S,d){this.c=a,this.d=S,this.e=d,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(v.$KN.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,a){await this.a.$changeLanguage(y,a);const S=this.c.getDocumentData(y);if(!S)throw new Error(`document '${y.toString()}' NOT found`);return S.document}async tokenAtPosition(y,a){const S=y.version,d=R.Position.from(a),r=await this.a.$tokensAtPosition(y.uri,d),s={type:P.StandardTokenType.Other,range:y.getWordRangeAtPosition(a)??new P.$ON(a.line,a.character,a.line,a.character)};if(!r)return s;const c={range:R.Range.to(r.range),type:R.TokenType.to(r.type)};return!c.range.contains(a)||S!==y.version?s:c}createLanguageStatusItem(y,a,S){const d=this.f++,r=this.a,s=this.g,c=`${y.identifier.value}/${a}`;if(s.has(c))throw new Error(`LanguageStatusItem with id '${a}' ALREADY exists`);s.add(c);const l={selector:S,id:a,name:y.displayName??y.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const n=new T.$Tc,t=()=>{if(i?.dispose(),!s.has(c)){console.warn(`LanguageStatusItem (${a}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.$Hh)(()=>{n.clear(),this.a.$setLanguageStatus(d,{id:c,name:l.name??y.displayName??y.name,source:y.displayName??y.name,selector:R.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===P.LanguageStatusSeverity.Error?O.default.Error:l.severity===P.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:l.command&&this.d.toInternal(l.command,n),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},g={dispose(){n.dispose(),i?.dispose(),r.$removeLanguageStatus(d),s.delete(c)},get id(){return l.id},get name(){return l.name},set name(u){l.name=u,t()},get selector(){return l.selector},set selector(u){l.selector=u,t()},get text(){return l.text},set text(u){l.text=u,t()},set text2(u){(0,p.$gH)(y,"languageStatusText"),l.text=u,t()},get text2(){return(0,p.$gH)(y,"languageStatusText"),l.text},get detail(){return l.detail},set detail(u){l.detail=u,t()},get severity(){return l.severity},set severity(u){l.severity=u,t()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(u){l.accessibilityInformation=u,t()},get command(){return l.command},set command(u){l.command=u,t()},get busy(){return l.busy},set busy(u){l.busy=u,t()}};return t(),g}}e.$6qc=o}),define(Ne[246],Le([1,0,15,2,8,7,89]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rqc=e.$Qqc=void 0,P=qe(P),A=qe(A);class T{constructor(y,a,S,d){this.start=y,this.deletedCount=a,this.deletedItems=S,this.items=d}asApiEvent(){return{range:new O.$eP(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,a,S){this.notebook=y,this.h=a,this.j=S,this.handle=S.handle,this.uri=R.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(P.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,a=this.h.getDocument(this.uri);if(!a)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:a.document,get mime(){return y.g},set mime(d){y.g=d},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(S)}return this.f}setOutputs(y){this.a=y.map(P.NotebookCellOutput.to)}setOutputItems(y,a,S){const d=S.map(P.NotebookCellOutputItem.to),r=this.a.find(s=>s.id===y);if(r&&(a||(r.items.length=0),r.items.push(...d),r.items.length>1&&r.items.every(s=>A.$ML(s.mime)))){const s=new Map,c=[];r.items.forEach(l=>{let i;s.has(l.mime)?i=s.get(l.mime):(i=[],s.set(l.mime,i),c.push(l.mime)),i.push(l.data)}),r.items.length=0,c.forEach(l=>{const i=A.$NL(s.get(l));r.items.push({mime:l,data:i.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$Qqc=p;class o{static{this.a=0}constructor(y,a,S,d,r){this.k=y,this.l=a,this.m=S,this.uri=d,this.handle=o.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,a={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===v.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(S){return S=y.n(S),y.b[S].apiCell},getCells(S){return(S?y.p(S):y.b).map(r=>r.apiCell)},save(){return y.q()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this.e=Object.freeze(a)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,a,S){this.g=y.versionId,this.h=a,this.acceptDocumentPropertiesChanged({metadata:S});const d={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},r=[];for(const c of y.rawEvents)c.kind===A.NotebookCellsChangeType.ModelChange?this.r(c.changes,!1,d.contentChanges):c.kind===A.NotebookCellsChangeType.Move?this.s(c.index,c.length,c.newIdx,d.contentChanges):c.kind===A.NotebookCellsChangeType.Output?(this.t(c.index,c.outputs),r.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===A.NotebookCellsChangeType.OutputItem?(this.u(c.index,c.outputId,c.append,c.outputItems),r.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(c.index,c.language),r.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document})):c.kind===A.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document}):c.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(c.index,c.mime):c.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(c.index,c.metadata),r.push({cell:this.b[c.index].apiCell,metadata:this.b[c.index].apiCell.metadata})):c.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(c.index,c.internalMetadata),r.push({cell:this.b[c.index].apiCell,executionSummary:this.b[c.index].apiCell.executionSummary}));const s=new Map;for(let c=0;c<r.length;c++){const l=r[c],i=s.get(l.cell);if(i===void 0){const n=d.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...l});s.set(l.cell,n-1)}else d.cellChanges[i]={...d.cellChanges[i],...l}}return Object.freeze(d),Object.freeze(d.cellChanges),Object.freeze(d.contentChanges),d}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let a=y.start|0,S=y.end|0;return a<0&&(a=0),S>this.b.length&&(S=this.b.length),y.with({start:a,end:S})}p(y){y=this.o(y);const a=[];for(let S=y.start;S<y.end;S++)a.push(this.b[S]);return a}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,a,S){if(this.j)return;const d=[],r=[],s=[];if(y.reverse().forEach(c=>{const i=c[2].map(g=>{const u=new p(this,this.l,g);return a||r.push(p.asModelAddData(g)),u}),n=new T(c[0],c[1],[],i),t=this.b.splice(c[0],c[1],...i);for(const g of t)s.push(g.uri),n.deletedItems.push(g.apiCell);d.push(n)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:s}),S)for(const c of d)S.push(c.asApiEvent())}s(y,a,S,d){const r=this.b.splice(y,a);this.b.splice(S,0,...r);const s=[new T(y,a,r.map(c=>c.apiCell),[]),new T(S,0,[],r)];for(const c of s)d.push(c.asApiEvent())}t(y,a){this.b[y].setOutputs(a)}u(y,a,S,d){this.b[y].setOutputItems(a,S,d)}v(y,a){const S=this.b[y];S.apiCell.document.languageId!==a&&this.m.$acceptModelLanguageChanged(S.uri,a)}w(y,a){const S=this.b[y];S.apiCell.mime=a}x(y,a){this.b[y].setMetadata(a)}y(y,a){this.b[y].setInternalMetadata(a)}getCellFromApiCell(y){return this.b.find(a=>a.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(a=>a.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$Rqc=o}),define(Ne[247],Le([1,0,6,2,8,7,39]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8qc=void 0;class T{constructor(o,I,y,a={timeout:1500,errors:3}){this.b=o,this.c=I,this.d=y,this.f=a,this.a=new v.$ne}dispose(){}getOnWillSaveNotebookDocumentEvent(o){return(I,y,a)=>{const S=function(r){I.call(y,r)};return S.extension=o,this.a.event(S,void 0,a)}}async $participateInSave(o,I,y){const a=R.URI.revive(o),S=this.c.getNotebookDocument(a);if(!S)throw new Error("Unable to resolve notebook document");const d=[];if(await this.a.fireAsync({notebook:S.apiNotebook,reason:P.TextDocumentSaveReason.to(I)},y,async(s,c)=>{const l=Date.now(),i=await await Promise.resolve(s);Date.now()-l>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!y.isCancellationRequested&&i&&(i instanceof O.$YN?d.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(d.length===0)return!0;const r={edits:[]};for(const s of d){const{edits:c}=P.WorkspaceEdit.from(s);r.edits=r.edits.concat(c)}return this.d.$tryApplyWorkspaceEdit(new A.$Xw(r))}}e.$8qc=T}),define(Ne[124],Le([1,0,13,8,7]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sqc=void 0,R=qe(R),P=qe(P);class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(T,p,o,I,y,a){this.id=T,this.f=p,this.notebookData=o,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=I,this.c=a}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(p){this.selections=[p]},get selections(){return T.a},set selections(p){if(!Array.isArray(p)||!p.every(P.$eP.isNotebookRange))throw(0,v.$6)("selections");T.a=p,T.g(p)},get visibleRanges(){return T.b},revealRange(p,o){T.f.$tryRevealRange(T.id,R.NotebookRange.from(p),o??P.NotebookEditorRevealType.Default)},get viewColumn(){return T.c},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(R.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.$Sqc=O}),define(Ne[248],Le([1,0,6,11,8]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qc=void 0,P=qe(P);let O=class{constructor(T,p){this.c=T,this.d=p,this.a=new v.$le,this.b=new v.$le,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,p);const o=this.d.getEditorById(T);p.visibleRanges&&o._acceptVisibleRanges(p.visibleRanges.ranges.map(P.NotebookRange.to)),p.selections&&o._acceptSelections(p.selections.selections.map(P.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:o.apiEditor,visibleRanges:o.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:o.apiEditor,selections:o.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const p in T)this.d.getEditorById(p)._acceptViewColumn(P.ViewColumn.to(T[p]))}};e.$0qc=O,e.$0qc=O=Je([Ve(0,R.$ak)],O)}),define(Ne[249],Le([1,0,6,5,124]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$arc=void 0;class O{constructor(T,p){this.c=p,this.a=new Map,this.b=T.getProxy(R.$KN.MainThreadNotebookRenderers)}$postRendererMessage(T,p,o){const I=this.c.getEditorById(T);this.a.get(p)?.fire({editor:I.apiEditor,message:o})}createRendererMessaging(T,p){if(!T.contributes?.notebookRenderer?.some(I=>I.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(I,y,a)=>this.d(p).event(I,y,a),postMessage:(I,y)=>{P.$Sqc.apiEditorsToExtHost.has(I)&&([I,y]=[y,I]);const a=y&&P.$Sqc.apiEditorsToExtHost.get(y);return this.b.$postMessage(a?.id,p,I)}}}d(T){let p=this.a.get(T);return p||(p=new v.$le({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(T)}}),this.a.set(T,p),p)}}e.$arc=O}),define(Ne[250],Le([1,0,8,76,21,71,13]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$erc=void 0;class T{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,a,S){const d=this.b++,{title:r,location:s,cancellable:c}=a,l={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(d,{location:v.ProgressLocation.from(s),title:r,source:l,cancellable:c},y.isUnderDevelopment?void 0:y.identifier.value).catch(A.$Z),this.d(d,S,!!c)}d(y,a,S){let d;S&&(d=new P.$we,this.c.set(y,d));const r=c=>{this.a.$progressEnd(c),this.c.delete(c),d?.dispose()};let s;try{s=a(new o(this.a,y),S&&d?d.token:P.CancellationToken.None)}catch(c){throw r(y),c}return s.then(c=>r(y),c=>r(y)),s}$acceptProgressCanceled(y){const a=this.c.get(y);a&&(a.cancel(),this.c.delete(y))}}e.$erc=T;function p(I,y){return I.message=y.message,typeof y.increment=="number"&&(typeof I.increment=="number"?I.increment+=y.increment:I.increment=y.increment),I}class o extends R.$zw{constructor(y,a){super(S=>this.throttledReport(S)),this.c=y,this.d=a}throttledReport(y){this.c.$progressReport(this.d,y)}}Je([(0,O.$_h)(100,(I,y)=>p(I,y),()=>Object.create(null))],o.prototype,"throttledReport",null)}),define(Ne[251],Le([1,0,2,5,10,8]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$frc=void 0;class A{static{this.a=0}constructor(p,o){this.d=o,this.c=new Map,this.b=p.getProxy(R.$KN.MainThreadQuickDiff)}$provideOriginalResource(p,o,I){const y=v.URI.revive(o),a=this.c.get(p);return a?(0,P.$xh)(()=>a.provideOriginalResource(y,I)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider(p,o,I,y){const a=A.a++;return this.c.set(a,o),this.b.$registerQuickDiffProvider(a,O.DocumentSelector.from(p,this.d),I,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(a),this.c.delete(a)}}}}e.$frc=A});var xt=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[252],Le([1,0,21,6,4,5,2,7,13,17,35,34,24,8]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$grc=d,I=xt(I);function d(r,s,c){const l=r.getProxy(O.$KN.MainThreadQuickOpen);class i{constructor(D,b){this.e=new Map,this.f=0,this.a=D,this.b=b}showQuickPick(D,b,C,k=v.CancellationToken.None){this.c=void 0;const f=Promise.resolve(b),w=++this.f,F=l.$show(w,{title:C?.title,placeHolder:C?.placeHolder,matchOnDescription:C?.matchOnDescription,matchOnDetail:C?.matchOnDetail,ignoreFocusLost:C?.ignoreFocusOut,canPickMany:C?.canPickMany},k),N={},L=F.then(()=>N);return Promise.race([L,f]).then(q=>{if(q===N)return;const H=(0,a.$fH)(D,"quickPickItemTooltip");return f.then(W=>{const G=[];for(let Q=0;Q<W.length;Q++){const ae=W[Q];if(typeof ae=="string")G.push({label:ae,handle:Q});else if(ae.kind===T.QuickPickItemKind.Separator)G.push({type:"separator",label:ae.label});else{ae.tooltip&&!H&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const be=ae.iconPath?$(ae.iconPath):void 0;G.push({label:ae.label,iconPath:be?.iconPath,iconClass:be?.iconClass,description:ae.description,detail:ae.detail,picked:ae.picked,alwaysShow:ae.alwaysShow,tooltip:H?S.MarkdownString.fromStrict(ae.tooltip):void 0,handle:Q})}}return C&&typeof C.onDidSelectItem=="function"&&(this.c=Q=>{C.onDidSelectItem(W[Q])}),l.$setItems(w,G),F.then(Q=>{if(typeof Q=="number")return W[Q];if(Array.isArray(Q))return Q.map(ae=>W[ae])})})}).then(void 0,q=>{if(!(0,p.$3)(q))return l.$setError(w,q),Promise.reject(q)})}$onItemSelected(D){this.c?.(D)}showInput(D,b=v.CancellationToken.None){return this.d=D?.validateInput,l.$input(D,typeof this.d=="function",b).then(void 0,C=>{if(!(0,p.$3)(C))return Promise.reject(C)})}async $validateInput(D){if(!this.d)return;const b=await this.d(D);if(!b||typeof b=="string")return b;let C;switch(b.severity){case T.InputBoxValidationSeverity.Info:C=I.default.Info;break;case T.InputBoxValidationSeverity.Warning:C=I.default.Warning;break;case T.InputBoxValidationSeverity.Error:C=I.default.Error;break;default:C=b.message?I.default.Error:I.default.Ignore;break}return{content:b.message,severity:C}}async showWorkspaceFolderPick(D,b=v.CancellationToken.None){const C=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!C)return;const k=await this.a.getWorkspaceFolders2();if(k)return k.find(f=>f.uri.toString()===C.uri.toString())}createQuickPick(D){const b=new m(D,()=>this.e.delete(b._id));return this.e.set(b._id,b),b}createInputBox(D){const b=new h(D,()=>this.e.delete(b._id));return this.e.set(b._id,b),b}$onDidChangeValue(D,b){this.e.get(D)?._fireDidChangeValue(b)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,b){const C=this.e.get(D);C instanceof m&&C._fireDidChangeActive(b)}$onDidChangeSelection(D,b){const C=this.e.get(D);C instanceof m&&C._fireDidChangeSelection(b)}$onDidTriggerButton(D,b){this.e.get(D)?._fireDidTriggerButton(b)}$onDidTriggerItemButton(D,b,C){const k=this.e.get(D);k instanceof m&&k._fireDidTriggerItemButton(b,C)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class n{static{this.a=1}constructor(D,b){this.x=D,this.y=b,this._id=m.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new R.$le,this.q=new R.$le,this.r=new R.$le,this.s=new R.$le,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){const b=(0,a.$fH)(this.x,"quickInputButtonLocation");!b&&D.some(C=>C.location)&&console.warn(`Extension '${this.x.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`),this.n=D.slice(),this.o.clear(),D.forEach((C,k)=>{const f=C===T.$bP.Back?-1:k;this.o.set(f,C)}),this.z({buttons:D.map((C,k)=>({...$(C.iconPath),tooltip:C.tooltip,handle:C===T.$bP.Back?-1:k,location:b?C.location:void 0}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const b=this.o.get(D);b&&this.r.fire(b)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),l.$dispose(this._id))}z(D){if(!this.v){for(const b of Object.keys(D)){const C=D[b];this.u[b]=C===void 0?null:C}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){l.$createOrUpdate(this.u),this.u={id:this._id}}}function t(E){if(E instanceof T.$LO)return{id:E.id};const D=u(E),b=g(E);return{dark:typeof D=="string"?A.URI.file(D):D,light:typeof b=="string"?A.URI.file(b):b}}function g(E){return typeof E=="object"&&"light"in E?E.light:E}function u(E){return typeof E=="object"&&"dark"in E?E.dark:E}function $(E){const D=t(E);let b,C;return"id"in D?C=y.ThemeIcon.asClassName(D):b=D,{iconPath:b,iconClass:C}}class m extends n{constructor(D,b){super(D,b),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new R.$le,this.L=[],this.M=new R.$le,this.N=new R.$le,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((k,f)=>{this.C.set(f,k),this.D.set(k,f)});const b=(0,a.$fH)(this.x,"quickPickItemTooltip"),C=[];for(let k=0;k<D.length;k++){const f=D[k];if(f.kind===T.QuickPickItemKind.Separator)C.push({type:"separator",label:f.label});else{f.tooltip&&!b&&console.warn(`Extension '${this.x.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`);const w=f.iconPath?$(f.iconPath):void 0;C.push({handle:k,label:f.label,iconPath:w?.iconPath,iconClass:w?.iconClass,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,tooltip:b?S.MarkdownString.fromStrict(f.tooltip):void 0,buttons:f.buttons?.map((F,N)=>({...$(F.iconPath),tooltip:F.tooltip,handle:N}))})}}this.z({items:C})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(b=>this.D.has(b)),this.z({activeItems:this.J.map(b=>this.D.get(b))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(b=>this.D.has(b)),this.z({selectedItems:this.L.map(b=>this.D.get(b))})}_fireDidChangeActive(D){const b=(0,o.$Gb)(D.map(C=>this.C.get(C)));this.J=b,this.K.fire(b)}_fireDidChangeSelection(D){const b=(0,o.$Gb)(D.map(C=>this.C.get(C)));this.L=b,this.M.fire(b)}_fireDidTriggerItemButton(D,b){const C=this.C.get(D);if(!C||!C.buttons||!C.buttons.length)return;const k=C.buttons[b];k&&this.N.fire({button:k,item:C})}}class h extends n{constructor(D,b){super(D,b),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:I.default.Error}):this.z({validationMessage:D.message,severity:D.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new i(s,c)}}),define(Ne[253],Le([1,0,2,6,71,4,10,5,17,145,11,18,37,34,8,24,15,20]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$irc=e.$hrc=void 0;function i(N){return N instanceof v.URI}function n(N,L){return N.scheme===s.Schemas.file&&L.scheme===s.Schemas.file&&c.$l?N.toString()===L.toString():N.toString().toLowerCase()===L.toString().toLowerCase()}function t(N){if(N)return typeof N.iconPath=="string"?v.URI.file(N.iconPath):v.URI.isUri(N.iconPath)||S.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function g(N){if(N){if(v.URI.isUri(N))return N;if(S.ThemeIcon.isThemeIcon(N))return N;{const L=N;return{light:L.light,dark:L.dark}}}else return}function u(N){const L=g(N.icon),q=N.labels?.map(H=>({title:H.title,icon:g(H.icon)}));return{...N,icon:L,labels:q}}function $(N,L){if(!N.iconPath&&!L.iconPath)return 0;if(N.iconPath){if(!L.iconPath)return 1}else return-1;const q=typeof N.iconPath=="string"?N.iconPath:v.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,H=typeof L.iconPath=="string"?L.iconPath:v.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,o.$Kr)(q,H)}function m(N,L){let q=0;if(N.strikeThrough!==L.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==L.faded)return N.faded?1:-1;if(N.tooltip!==L.tooltip)return(N.tooltip||"").localeCompare(L.tooltip||"");if(q=$(N,L),q!==0)return q;if(N.light&&L.light)q=$(N.light,L.light);else{if(N.light)return 1;if(L.light)return-1}if(q!==0)return q;if(N.dark&&L.dark)q=$(N.dark,L.dark);else{if(N.dark)return 1;if(L.dark)return-1}return q}function h(N,L){if(N.command!==L.command)return N.command<L.command?-1:1;if(N.title!==L.title)return N.title<L.title?-1:1;if(N.tooltip!==L.tooltip){if(N.tooltip!==void 0&&L.tooltip!==void 0)return N.tooltip<L.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if(N.arguments===L.arguments)return 0;if(N.arguments)if(L.arguments){if(N.arguments.length!==L.arguments.length)return N.arguments.length-L.arguments.length}else return 1;else return-1;for(let q=0;q<N.arguments.length;q++){const H=N.arguments[q],W=L.arguments[q];if(H!==W&&!(i(H)&&i(W)&&n(H,W)))return H<W?-1:1}return 0}function E(N,L){let q=(0,o.$Kr)(N.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(q!==0)return q;if(N.command&&L.command)q=h(N.command,L.command);else{if(N.command)return 1;if(L.command)return-1}if(q!==0)return q;if(N.decorations&&L.decorations)q=m(N.decorations,L.decorations);else{if(N.decorations)return 1;if(L.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&L.multiFileDiffEditorModifiedUri)q=(0,o.$Kr)(N.multiFileDiffEditorModifiedUri.fsPath,L.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(L.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&L.multiDiffEditorOriginalUri)q=(0,o.$Kr)(N.multiDiffEditorOriginalUri.fsPath,L.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(L.multiDiffEditorOriginalUri)return-1}return q}function D(N,L){for(let q=0;q<N.length;q++)if(N[q]!==L[q])return!1;return!0}function b(N,L){return N.command===L.command&&N.title===L.title&&N.tooltip===L.tooltip&&(N.arguments&&L.arguments?D(N.arguments,L.arguments):N.arguments===L.arguments)}function C(N,L){return(0,p.$tb)(N,L,b)}class k{#e;#t;get value(){return this.d}set value(L){L=L??"",this.#e.$setInputBoxValue(this.m,L),this.o(L)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(L){this.#e.$setInputBoxPlaceholder(this.m,L),this.f=L}get validateInput(){return(0,r.$gH)(this.k,"scmValidation"),this.g}set validateInput(L){if((0,r.$gH)(this.k,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=L,this.#e.$setValidationProviderIsEnabled(this.m,!!L)}get enabled(){return this.h}set enabled(L){L=!!L,this.h!==L&&(this.h=L,this.#e.$setInputBoxEnablement(this.m,L))}get visible(){return this.j}set visible(L){L=!!L,this.j!==L&&(this.j=L,this.#e.$setInputBoxVisibility(this.m,L))}get document(){return(0,r.$gH)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(L,q,H,W,G){this.k=L,this.m=W,this.n=G,this.d="",this.e=new R.$le,this.f="",this.h=!0,this.j=!0,this.#t=q,this.#e=H}showValidationMessage(L,q){(0,r.$gH)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,L,q)}$onInputBoxValueChange(L){this.o(L)}o(L){this.d=L,this.e.fire(L)}}e.$hrc=k;class f{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(L){this.w=L,this.s.$updateGroupLabel(this.u,this.handle,L)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(L){this.q=L,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(L){this.f=[...L],this.k.fire()}constructor(L,q,H,W,G,Q,ae){this.s=L,this.t=q,this.u=H,this.v=W,this.w=G,this.multiDiffEditorEnableViewChanges=Q,this.x=ae,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new R.$le,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new R.$le,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=f.d++}getResourceState(L){return this.g.get(L)}$executeResourceCommand(L,q){const H=this.h.get(L);return H?(0,A.$xh)(()=>this.t.executeCommand(H.command,...H.arguments||[],q)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this.f].sort(E),H=(0,p.$Cb)(this.p,L,E).map(Q=>{const ae=Q.toInsert.map(be=>{const le=this.e++;this.g.set(le,be);const _=be.resourceUri;let ce;if(be.command)if(be.command.command==="vscode.open"||be.command.command==="vscode.diff"||be.command.command==="vscode.changes"){const x=new O.$Tc;ce=this.t.converter.toInternal(be.command,x),this.j.set(le,x)}else this.h.set(le,be.command);const me=(0,r.$fH)(this.x,"scmMultiDiffEditor"),oe=me?be.multiDiffEditorOriginalUri:void 0,ke=me?be.multiFileDiffEditorModifiedUri:void 0,Te=t(be.decorations),Y=be.decorations&&t(be.decorations.light)||Te,B=be.decorations&&t(be.decorations.dark)||Te,ne=[Y,B],Ee=be.decorations&&be.decorations.tooltip||"",fe=be.decorations&&!!be.decorations.strikeThrough,we=be.decorations&&!!be.decorations.faded,he=be.contextValue||"";return{rawResource:[le,_,ne,Ee,fe,we,he,ce,oe,ke],handle:le}});return{start:Q.start,deleteCount:Q.deleteCount,toInsert:ae}}),W=H.map(({start:Q,deleteCount:ae,toInsert:be})=>[Q,ae,be.map(le=>le.rawResource)]),G=H.reverse();for(const{start:Q,deleteCount:ae,toInsert:be}of G){const le=be.map(ce=>ce.handle),_=this.o.splice(Q,ae,...le);for(const ce of _)this.g.delete(ce),this.h.delete(ce),this.j.get(ce)?.dispose(),this.j.delete(ce)}return this.p=L,W}dispose(){this.m=!0,this.n.fire()}}class w{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(L){this.g!==L&&(this.g=L,this.#e.$updateSourceControl(this.x,{count:L}))}get quickDiffProvider(){return this.h}set quickDiffProvider(L){this.h=L;let q;(0,r.$fH)(this.y,"quickDiffProvider")&&(q=L?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!L,quickDiffLabel:q})}get historyProvider(){return(0,r.$gH)(this.y,"scmHistoryProvider"),this.j}set historyProvider(L){(0,r.$gH)(this.y,"scmHistoryProvider"),this.j=L,this.k.value=new O.$Tc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!L}),L&&this.k.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this.m=L?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(L){L!==this.n&&(this.n=L,this.#e.$updateSourceControl(this.x,{commitTemplate:L}))}get acceptInputCommand(){return this.p}set acceptInputCommand(L){this.o.value=new O.$Tc,this.p=L;const q=this.z.converter.toInternal(L,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:q})}get actionButton(){return(0,r.$gH)(this.y,"scmActionButton"),this.s}set actionButton(L){(0,r.$gH)(this.y,"scmActionButton"),this.q.value=new O.$Tc,this.s=L;const q=L!==void 0?{command:this.z.converter.toInternal(L.command,this.q.value),secondaryCommands:L.secondaryCommands?.map(H=>H.map(W=>this.z.converter.toInternal(W,this.q.value))),description:L.description,enabled:L.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:q??null})}get statusBarCommands(){return this.u}set statusBarCommands(L){if(this.u&&L&&C(this.u,L))return;this.t.value=new O.$Tc,this.u=L;const q=(L||[]).map(H=>this.z.converter.toInternal(H,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:q})}get selected(){return this.v}constructor(L,q,H,W,G,Q,ae){this.y=L,this.z=W,this.A=G,this.B=Q,this.C=ae,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Vc,this.n=void 0,this.o=new O.$Vc,this.p=void 0,this.q=new O.$Vc,this.t=new O.$Vc,this.u=void 0,this.v=!1,this.w=new R.$le,this.onDidChangeSelection=this.w.event,this.x=w.d++,this.D=new Map,this.E=new Set,this.#e=H;const be=v.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${G}/scm${this.x}/input`,query:ae?`rootUri=${encodeURIComponent(ae.toString())}`:void 0});this.f=new k(L,q,this.#e,this.x,be),this.#e.$registerSourceControl(this.x,G,Q,ae,be)}createResourceGroup(L,q,H){const W=(0,r.$fH)(this.y,"scmMultiDiffEditor")&&H?.multiDiffEditorEnableViewChanges===!0,G=new f(this.#e,this.z,this.x,L,q,W,this.y),Q=R.Event.once(G.onDidDispose)(()=>this.D.delete(G));return this.D.set(G,Q),this.eventuallyAddResourceGroups(),G}eventuallyAddResourceGroups(){const L=[],q=[];for(const[H,W]of this.D){W.dispose();const G=H.onDidUpdateResourceStates(()=>{this.E.add(H),this.eventuallyUpdateResourceStates()});R.Event.once(H.onDidDispose)(()=>{this.E.delete(H),G.dispose(),this.e.delete(H.handle),this.#e.$unregisterGroup(this.x,H.handle)}),L.push([H.handle,H.id,H.label,H.features,H.multiDiffEditorEnableViewChanges]);const Q=H._takeResourceStateSnapshot();Q.length>0&&q.push([H.handle,Q]),this.e.set(H.handle,H)}this.#e.$registerGroups(this.x,L,q),this.D.clear()}eventuallyUpdateResourceStates(){const L=[];this.E.forEach(q=>{const H=q._takeResourceStateSnapshot();H.length!==0&&L.push([q.handle,H])}),L.length>0&&this.#e.$spliceResourceStates(this.x,L),this.E.clear()}getResourceGroup(L){return this.e.get(L)}setSelectionState(L){this.v=L,this.w.fire(L)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(L=>L.dispose()),this.#e.$unregisterSourceControl(this.x)}}Je([(0,P.$$h)(100)],w.prototype,"eventuallyAddResourceGroups",null),Je([(0,P.$$h)(100)],w.prototype,"eventuallyUpdateResourceStates",null);let F=class{static{l=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(L,q,H,W){this.m=q,this.n=H,this.o=W,this.g=new Map,this.h=new y.$tn,this.j=new R.$le,this.e=L.getProxy(T.$KN.MainThreadSCM),this.f=L.getProxy(T.$KN.MainThreadTelemetry),q.registerArgumentProcessor({processArgument:G=>{if(G&&G.$mid===a.MarshalledId.ScmResource){const Q=this.g.get(G.sourceControlHandle);if(!Q)return G;const ae=Q.getResourceGroup(G.groupHandle);return ae?ae.getResourceState(G.handle):G}else if(G&&G.$mid===a.MarshalledId.ScmResourceGroup){const Q=this.g.get(G.sourceControlHandle);return Q?Q.getResourceGroup(G.groupHandle):G}else if(G&&G.$mid===a.MarshalledId.ScmProvider){const Q=this.g.get(G.handle);return Q||G}return G}})}createSourceControl(L,q,H,W){this.o.trace("ExtHostSCM#createSourceControl",L.identifier.value,q,H,W),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const G=l.d++,Q=new w(L,this.n,this.e,this.m,q,H,W);this.g.set(G,Q);const ae=this.h.get(L.identifier)||[];return ae.push(Q),this.h.set(L.identifier,ae),Q}getLastInputBox(L){this.o.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const q=this.h.get(L.identifier),H=q&&q[q.length-1];return H&&H.inputBox}$provideOriginalResource(L,q,H){const W=v.URI.revive(q);this.o.trace("ExtHostSCM#$provideOriginalResource",L,W.toString());const G=this.g.get(L);return!G||!G.quickDiffProvider||!G.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$xh)(()=>G.quickDiffProvider.provideOriginalResource(W,H)).then(Q=>Q||null)}$onInputBoxValueChange(L,q){this.o.trace("ExtHostSCM#$onInputBoxValueChange",L);const H=this.g.get(L);return H&&H.inputBox.$onInputBoxValueChange(q),Promise.resolve(void 0)}$executeResourceCommand(L,q,H,W){this.o.trace("ExtHostSCM#$executeResourceCommand",L,q,H);const G=this.g.get(L);if(!G)return Promise.resolve(void 0);const Q=G.getResourceGroup(q);return Q?Q.$executeResourceCommand(H,W):Promise.resolve(void 0)}$validateInput(L,q,H){this.o.trace("ExtHostSCM#$validateInput",L);const W=this.g.get(L);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,A.$xh)(()=>W.inputBox.validateInput(q,H)).then(G=>{if(!G)return Promise.resolve(void 0);const Q=d.MarkdownString.fromStrict(G.message);return Q?Promise.resolve([Q,G.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this.g.get(L)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(L,q,H,W){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(q,H,W)??void 0}async $resolveHistoryItemGroupCommonAncestor2(L,q,H){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(q,H)??void 0}async $provideHistoryItems(L,q,H,W){return(await this.g.get(L)?.historyProvider?.provideHistoryItems(q,H,W))?.map(ae=>u(ae))??void 0}async $provideHistoryItems2(L,q,H){return(await this.g.get(L)?.historyProvider?.provideHistoryItems2(q,H))?.map(Q=>u(Q))??void 0}async $provideHistoryItemSummary(L,q,H,W){const G=this.g.get(L)?.historyProvider;if(typeof G?.provideHistoryItemSummary!="function")return;const Q=await G.provideHistoryItemSummary(q,H,W);return Q?u(Q):void 0}async $provideHistoryItemChanges(L,q,H,W){return await this.g.get(L)?.historyProvider?.provideHistoryItemChanges(q,H,W)??void 0}};e.$irc=F,e.$irc=F=l=Je([Ve(3,I.$ak)],F)}),define(Ne[254],Le([1,0,5,8,2]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jrc=void 0;class O{static{this.a=0}constructor(T,p){this.d=p,this.c=new Map,this.b=T.getProxy(v.$KN.MainThreadShare)}async $provideShare(T,p,o){return await this.c.get(T)?.provideShare({selection:R.Range.to(p.selection),resourceUri:P.URI.revive(p.resourceUri)},o)??void 0}registerShareProvider(T,p){const o=O.a++;return this.c.set(o,p),this.b.$registerShareProvider(o,R.DocumentSelector.from(T,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(o),this.c.delete(o)}}}}e.$jrc=O}),define(Ne[255],Le([1,0,7,5,9,4,8,14]),function(ve,e,v,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mrc=e.$lrc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new v.$MO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new v.$MO("statusBarItem.warningForeground")]])}#e;#t;constructor(a,S,d,r,s,c=v.StatusBarAlignment.Left,l){if(this.i=!1,this.k="",this.q=new O.$Tc,this.#e=a,this.#t=S,s&&r){this.c=(0,v.$oO)(r.identifier,s);const i=d.get(this.c);i&&(c=i.alignLeft?v.StatusBarAlignment.Left:v.StatusBarAlignment.Right,l=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(p.a++);this.e=r,this.f=s,this.g=c,this.h=this.u(l)}u(a){if((0,T.$ig)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(a){this.k=a,this.v()}set name(a){this.m=a,this.v()}set tooltip(a){this.l=a,this.v()}set color(a){this.n=a,this.v()}set backgroundColor(a){a&&!p.b.has(a.id)&&(a=void 0),this.o=a,this.v()}set command(a){this.r?.fromApi!==a&&(this.p&&this.q.add(this.p),this.p=new O.$Tc,typeof a=="string"?this.r={fromApi:a,internal:this.#t.toInternal({title:"",command:a},this.p)}:a?this.r={fromApi:a,internal:this.#t.toInternal(a,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(a){this.t=a,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let a;this.e?this.f?a=`${this.e.identifier.value}.${this.f}`:a=this.e.identifier.value:a=this.f;let S;this.m?S=this.m:S=(0,P.localize)(10826,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=p.b.get(this.o.id));const r=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,a,this.e?.identifier.value,S,this.k,r,this.r?.internal,d,this.o,this.g===v.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$lrc=p;class o{constructor(a){this.b=[],this.a=a.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(10827,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(a){const S={message:a};return this.b.unshift(S),this.c(),new v.$MN(()=>{const d=this.b.indexOf(S);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(a,S){this.e=new Map,this.a=a.getProxy(R.$KN.MainThreadStatusBar),this.b=S,this.c=new o(this)}$acceptStaticEntries(a){for(const S of a)this.e.set(S.entryId,S)}createStatusBarEntry(a,S,d,r){return new p(this.a,this.b,this.e,a,S,d,r)}setStatusBarMessage(a,S){const d=this.c.setMessage(a);let r;return typeof S=="number"?r=setTimeout(()=>d.dispose(),S):typeof S<"u"&&S.then(()=>d.dispose(),()=>d.dispose()),new v.$MN(()=>{d.dispose(),clearTimeout(r)})}}e.$mrc=I}),define(Ne[125],Le([1,0,32,116,54,81,55,8,2]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQ=e.$yQ=e.$xQ=e.$wQ=void 0,v=qe(v),T=qe(T);const o=(i,n,t,g)=>{let u=n;return{enumerable:!0,configurable:!1,get(){return u},set($){if(!t(u,$)){const m=u;u=$,i.listener?.(g($,m))}}}},I=(i,n)=>i===n,y={range:(i,n)=>i===n?!0:!i||!n?!1:i.isEqual(n),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,n)=>!(i.length!==n.length||i.some(t=>!n.find(g=>t.id===g.id)))},a=i=>n=>({op:O.TestItemEventOp.SetProp,update:i(n)}),S=(i,n)=>({range:(()=>{let t;const g=a(u=>({range:v.$Ot.lift(T.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return t},set(u){i.listener?.({op:O.TestItemEventOp.DocumentSynced}),y.range(t,u)||(t=u,i.listener?.(g(u)))}}})(),label:o(i,n,y.label,a(t=>({label:t}))),description:o(i,void 0,y.description,a(t=>({description:t}))),sortText:o(i,void 0,y.sortText,a(t=>({sortText:t}))),canResolveChildren:o(i,!1,y.canResolveChildren,t=>({op:O.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:o(i,!1,y.busy,a(t=>({busy:t}))),error:o(i,void 0,y.error,a(t=>({error:T.MarkdownString.fromStrict(t)||null}))),tags:o(i,[],y.tags,(t,g)=>({op:O.TestItemEventOp.SetTags,new:t.map(T.TestTag.from),old:g.map(T.TestTag.from)}))}),d=i=>{const n=P.$7I.fromString(i.extId),t=new s(n.controllerId,n.localId,i.label,p.URI.revive(i.uri)||void 0);return t.range=T.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(g=>T.TestTag.to({id:(0,A.$aJ)(g).tagId})),t},r=i=>{let n;for(const t of i.tests){const g=d(t.item);(0,R.$gQ)(g).parent=n,n=g}return n};e.$wQ=r;class s{constructor(n,t,g,u){if(t.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const $=(0,R.$fQ)(this,n);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return $.parent instanceof c?void 0:$.parent}},children:{value:(0,O.$eQ)($,R.$gQ,s),enumerable:!0,writable:!1},...S($,g)})}}e.$xQ=s;class c extends s{constructor(n,t){super(n,n,t,void 0),this._isRoot=!0}}e.$yQ=c;class l extends O.$aQ{constructor(n,t,g){super({controllerId:n,getDocumentVersion:u=>u&&g.getDocument(u)?.version,getApiFor:R.$gQ,getChildren:u=>u.children,root:new c(n,t),toITestItem:T.TestItem.from})}}e.$zQ=l}),define(Ne[33],Le([1,0,14,7,8,25,5,17,11,36,32,101,2,4,3,16,125,22,39,42,69,63,66,38]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KQ=e.$JQ=e.$IQ=e.$HQ=e.$GQ=e.$FQ=void 0,R=qe(R),P=qe(P);let $=class{#e;#t;#i;constructor(C,k,f){this.b=new Map,this.c=new Map,this.#e=C.getProxy(A.$KN.MainThreadCommands),this.d=k,this.#i=f,this.#t=C.getProxy(A.$KN.MainThreadTelemetry),this.converter=new m(this,w=>{const F=this.c.get(w);return F?.result===E.Void?F:void 0},k),this.f=[{processArgument(w){return(0,o.$ci)(w)}},{processArgument(w){return(0,O.$go)(w,function(F){if(I.$Ot.isIRange(F))return P.Range.to(F);if(y.$Nt.isIPosition(F))return P.Position.to(F);if(I.$Ot.isIRange(F.range)&&a.URI.isUri(F.uri))return P.location.to(F);if(F instanceof c.$Ne)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const k=this.registerCommand(!1,C.id,async(...f)=>{const w=C.args.map((N,L)=>{if(!N.validate(f[L]))throw new Error(`Invalid argument '${N.name}' when running '${C.id}', received: ${typeof f[L]=="object"?JSON.stringify(f[L],null,"	"):f[L]} `);return N.convert(f[L])}),F=await this.executeCommand(C.internalId,...w);return C.result.convert(F,f,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new R.$MN(()=>{k.dispose(),this.c.delete(C.id)})}registerCommand(C,k,f,w,F,N){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:f,thisArg:w,metadata:F,extension:N}),C&&this.#e.$registerCommand(k),new R.$MN(()=>{this.b.delete(k)&&C&&this.#e.$unregisterCommand(k)})}executeCommand(C,...k){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,k,!0)}async g(C,k,f){if(this.b.has(C))return this.#e.$fireCommandActivationEvent(C),this.h(C,k,!1);{let w=!1;const F=(0,O.$go)(k,function(N){if(N instanceof R.$NN)return P.Position.from(N);if(N instanceof R.$ON)return P.Range.from(N);if(N instanceof R.$1N)return P.location.from(N);if(R.$eP.isNotebookRange(N))return P.NotebookRange.from(N);if(N instanceof ArrayBuffer)return w=!0,c.$Ne.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return w=!0,c.$Ne.wrap(N);if(N instanceof c.$Ne)return w=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(C,w?new l.$Xw(F):F,f);return(0,o.$ci)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(C,k,!1);throw N}}}async h(C,k,f){const w=this.b.get(C);if(!w)throw new Error("Unknown command");const{callback:F,thisArg:N,metadata:L}=w;if(L?.args)for(let H=0;H<L.args.length;H++)try{(0,v.$vg)(k[H],L.args[H].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${L.args[H].name}' - ${L.args[H].description}`)}const q=n.$fe.create();try{return await F.apply(N,k)}catch(H){if(C===this.converter.delegatingCommandId){const W=this.converter.getActualCommand(...k);W&&(C=W.command)}if(this.d.error(H,C,w.extension?.identifier),!f)throw H;if(w.extension?.identifier){const W=this.#i.onExtensionError(w.extension.identifier,H);this.d.trace("forwarded error to extension?",W,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$qj)(H)),this.id=C,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,C,q.elapsed())}}j(C,k,f){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new t.$xp(k),duration:f})}$executeContributedCommand(C,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const f=this.b.get(C);return f?(k=k.map(w=>this.f.reduce((F,N)=>N.processArgument(F,f.extension?.identifier),w)),this.h(C,k,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(k=>(C&&(k=k.filter(f=>f[0]!=="_")),k))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[k,f]of this.b){const{metadata:w}=f;w&&(C[k]=w)}return Promise.resolve(C)}};e.$FQ=$,e.$FQ=$=Je([Ve(0,r.$kQ),Ve(1,p.$ak),Ve(2,g.$EQ)],$),e.$GQ=(0,d.$Fi)("IExtHostCommands");class m{constructor(C,k,f){this.d=C,this.f=k,this.g=f,this.delegatingCommandId=`__vsc${(0,u.$2g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,k){if(!C)return;const f={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return f;const w=this.f(C.command);if(w)f.id=w.internalId,f.arguments=w.args.map((F,N)=>F.convert(C.arguments&&C.arguments[N]));else if((0,T.$Kb)(C.arguments)){const F=`${C.command} /${++this.c}`;this.b.set(F,C),k.add((0,S.$Sc)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),f.$ident=F,f.id=this.delegatingCommandId,f.arguments=[F],this.g.trace("CommandsConverter#CREATE",C.command,F)}return f}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const k=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$HQ=m;class h{static{this.Uri=new h("uri","Uri of a text document",C=>a.URI.isUri(C),C=>C)}static{this.Position=new h("position","A position in a text document",C=>R.$NN.isPosition(C),P.Position.from)}static{this.Range=new h("range","A range in a text document",C=>R.$ON.isRange(C),P.Range.from)}static{this.Selection=new h("selection","A selection in a text document",C=>R.$PN.isSelection(C),P.Selection.from)}static{this.Number=new h("number","",C=>typeof C=="number",C=>C)}static{this.String=new h("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=h.Arr(h.String)}static Arr(C){return new h(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,k=>Array.isArray(k)&&k.every(f=>C.validate(f)),k=>k.map(f=>C.convert(f)))}static{this.CallHierarchyItem=new h("item","A call hierarchy item",C=>C instanceof R.$aO,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new h("item","A type hierarchy item",C=>C instanceof R.$zP,P.TypeHierarchyItem.from)}static{this.TestItem=new h("testItem","A VS Code TestItem",C=>C instanceof s.$xQ,P.TestItem.from)}constructor(C,k,f,w){this.name=C,this.description=k,this.validate=f,this.convert=w}optional(){return new h(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,k){return new h(C??this.name,k??this.description,this.validate,this.convert)}}e.$IQ=h;class E{static{this.Void=new E("no result",C=>C)}constructor(C,k){this.description=C,this.convert=k}}e.$JQ=E;class D{constructor(C,k,f,w,F){this.id=C,this.internalId=k,this.description=f,this.args=w,this.result=F}}e.$KQ=D}),define(Ne[256],Le([1,0,17,15,2,93,103,31,33,8,7]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bpc=void 0,O=qe(O),o=qe(o),I=qe(I);const y=[new p.$KQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of DocumentHighlight-instances.",S(o.DocumentHighlight.to))),new p.$KQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$IQ.Uri],new p.$JQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,s)=>{if((0,v.$Jb)(r))return;class c extends I.$8N{static to(i){const n=new c(i.name,o.SymbolKind.to(i.kind),i.containerName||"",new I.$1N(s[0],o.Range.to(i.range)));return n.detail=i.detail,n.range=n.location.range,n.selectionRange=o.Range.to(i.selectionRange),n.children=i.children?i.children.map(c.to):[],n}}return r.map(c.to)})),new p.$KQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$IQ.Uri,new p.$IQ("options","Formatting options",r=>!0,r=>r)],new p.$JQ("A promise that resolves to an array of TextEdits.",S(o.TextEdit.to))),new p.$KQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$IQ.Uri,p.$IQ.Range,new p.$IQ("options","Formatting options",r=>!0,r=>r)],new p.$JQ("A promise that resolves to an array of TextEdits.",S(o.TextEdit.to))),new p.$KQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$IQ.Uri,p.$IQ.Position,new p.$IQ("ch","Trigger character",r=>typeof r=="string",r=>r),new p.$IQ("options","Formatting options",r=>!0,r=>r)],new p.$JQ("A promise that resolves to an array of TextEdits.",S(o.TextEdit.to))),new p.$KQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$KQ("vscode.experimental.executeDefinitionProvider_recursive","_executeDefinitionProvider_recursive","Execute all definition providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$KQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$KQ("vscode.experimental.executeTypeDefinitionProvider_recursive","_executeTypeDefinitionProvider_recursive","Execute all type definition providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$KQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$KQ("vscode.experimental.executeDeclarationProvider_recursive","_executeDeclarationProvider_recursive","Execute all declaration providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$KQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$KQ("vscode.experimental.executeImplementationProvider_recursive","_executeImplementationProvider_recursive","Execute all implementation providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$KQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Location-instances.",S(o.location.to))),new p.$KQ("vscode.experimental.executeReferenceProvider","_executeReferenceProvider_recursive","Execute all reference providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Location-instances.",S(o.location.to))),new p.$KQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Hover-instances.",S(o.Hover.to))),new p.$KQ("vscode.experimental.executeHoverProvider_recursive","_executeHoverProvider_recursive","Execute all hover providers.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of Hover-instances.",S(o.Hover.to))),new p.$KQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$IQ.Uri,new p.$IQ("position","A position in a text document",r=>Array.isArray(r)&&r.every(s=>I.$NN.isPosition(s)),r=>r.map(o.Position.from))],new p.$JQ("A promise that resolves to an array of ranges.",r=>r.map(s=>{let c;for(const l of s.reverse())c=new I.$_N(o.Range.to(l),c);return c}))),new p.$KQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$IQ.String.with("query","Search string")],new p.$JQ("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(o.WorkspaceSymbol.to))),new p.$KQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(o.CallHierarchyItem.to))),new p.$KQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$IQ.CallHierarchyItem],new p.$JQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(o.CallHierarchyIncomingCall.to))),new p.$KQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$IQ.CallHierarchyItem],new p.$JQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(o.CallHierarchyOutgoingCall.to))),new p.$KQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:o.Range.to(r.range),placeholder:r.text}})),new p.$KQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$IQ.Uri,p.$IQ.Position,p.$IQ.String.with("newName","The new symbol name")],new p.$JQ("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return o.WorkspaceEdit.to(r)}})),new p.$KQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$IQ.Uri,p.$IQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$JQ("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(o.DocumentLink.to))),new p.$KQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$IQ.Uri],new p.$JQ("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$8O(r.tokenTypes,r.tokenModifiers)})),new p.$KQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$IQ.Uri],new p.$JQ("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,A.$Ydb)(r);if(s.type==="full")return new I.$0O(s.data,void 0)})),new p.$KQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$IQ.Uri,p.$IQ.Range.optional()],new p.$JQ("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$8O(r.tokenTypes,r.tokenModifiers)})),new p.$KQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$IQ.Uri,p.$IQ.Range],new p.$JQ("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,A.$Ydb)(r);if(s.type==="full")return new I.$0O(s.data,void 0)})),new p.$KQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$IQ.Uri,p.$IQ.Position,p.$IQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$IQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$JQ("A promise that resolves to a CompletionList-instance.",(r,s,c)=>{if(!r)return new I.$lO([]);const l=r.suggestions.map(i=>o.CompletionItem.to(i,c));return new I.$lO(l,r.incomplete)})),new p.$KQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$IQ.Uri,p.$IQ.Position,p.$IQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$JQ("A promise that resolves to SignatureHelp.",r=>{if(r)return o.SignatureHelp.to(r)})),new p.$KQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$IQ.Uri,p.$IQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$JQ("A promise that resolves to an array of CodeLens-instances.",(r,s,c)=>S(l=>new I.$dO(o.Range.to(l.range),l.command&&c.fromInternal(l.command)))(r))),new p.$KQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$IQ.Uri,new p.$IQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>I.$ON.isRange(r),r=>I.$PN.isSelection(r)?o.Selection.from(r):o.Range.from(r)),p.$IQ.String.with("kind","Code action kind to return code actions for").optional(),p.$IQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$JQ("A promise that resolves to an array of Command-instances.",(r,s,c)=>S(l=>{if(l._isSynthetic){if(!l.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(l.command)}else{const i=new I.$0N(l.title,l.kind?new I.$$N(l.kind):void 0);return l.edit&&(i.edit=o.WorkspaceEdit.to(l.edit)),l.command&&(i.command=c.fromInternal(l.command)),i.isPreferred=l.isPreferred,i}})(r))),new p.$KQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$IQ.Uri],new p.$JQ("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(s=>new I.$rO(o.Range.to(s.range),o.Color.to(s.color))):[])),new p.$KQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$IQ("color","The color to show and insert",r=>r instanceof I.$qO,o.Color.from),new p.$IQ("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:o.Range.from(r.range)}))],new p.$JQ("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(o.ColorPresentation.to):[])),new p.$KQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$IQ.Uri,p.$IQ.Range],new p.$JQ("A promise that resolves to an array of Inlay objects",(r,s,c)=>r.map(o.InlayHint.to.bind(void 0,c)))),new p.$KQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$IQ.Uri],new p.$JQ("A promise that resolves to an array of FoldingRange objects",(r,s)=>{if(r)return r.map(o.FoldingRange.to)})),new p.$KQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$JQ("A promise that resolves to an array of NotebookContentProvider static info objects.",S(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(s=>o.NotebookExclusiveDocumentPattern.to(s))})))),new p.$KQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$IQ.Uri,p.$IQ.Range,new p.$IQ("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof I.$ON,r=>o.InlineValueContext.from(r))],new p.$JQ("A promise that resolves to an array of InlineValue objects",r=>r.map(o.InlineValue.to))),new p.$KQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$IQ("uriOrString","Uri-instance or string (only http/https)",r=>P.URI.isUri(r)||typeof r=="string"&&(0,R.$Pg)(r,R.Schemas.http,R.Schemas.https),r=>r),new p.$IQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[o.ViewColumn.from(r),void 0]:[o.ViewColumn.from(r.viewColumn),o.TextEditorOpenOptions.from(r)])).optional(),p.$IQ.String.with("label","").optional()],p.$JQ.Void),new p.$KQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$IQ.Uri.with("resource","Resource to open"),p.$IQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$IQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[o.ViewColumn.from(r),void 0]:[o.ViewColumn.from(r.viewColumn),o.TextEditorOpenOptions.from(r)])).optional()],p.$JQ.Void),new p.$KQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$IQ.Uri.with("left","Left-hand side resource of the diff editor"),p.$IQ.Uri.with("right","Right-hand side resource of the diff editor"),p.$IQ.String.with("title","Human readable title for the diff editor").optional(),new p.$IQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[o.ViewColumn.from(r.viewColumn),o.TextEditorOpenOptions.from(r)]).optional()],p.$JQ.Void),new p.$KQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$IQ.String.with("title","Human readable title for the changes editor"),new p.$IQ("resourceList","List of resources to compare",r=>{for(const s of r){if(s.length!==3)return!1;const[c,l,i]=s;if(!P.URI.isUri(c)||!P.URI.isUri(l)&&l!==void 0&&l!==null||!P.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],p.$JQ.Void),new p.$KQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$IQ.Uri,p.$IQ.Position],new p.$JQ("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(o.TypeHierarchyItem.to))),new p.$KQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$IQ.TypeHierarchyItem],new p.$JQ("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(o.TypeHierarchyItem.to))),new p.$KQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$IQ.TypeHierarchyItem],new p.$JQ("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(o.TypeHierarchyItem.to))),new p.$KQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$IQ.TestItem],p.$JQ.Void),new p.$KQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$IQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$JQ.Void),new p.$KQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$IQ.String.with("name","The context key name"),new p.$IQ("value","The context key value",()=>!0,r=>r)],p.$JQ.Void),new p.$KQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$IQ.Uri,p.$IQ.StringArray,new p.$IQ("MappedEditsContext","Mapped Edits Context",r=>o.MappedEditsContext.is(r),r=>o.MappedEditsContext.from(r))],new p.$JQ("A promise that resolves to a workspace edit or null",r=>r?o.WorkspaceEdit.to(r):null)),new p.$KQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$IQ("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?o.Range.from(r.initialRange):void 0,initialSelection:I.$PN.isSelection(r.initialSelection)?o.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?o.Position.from(r.position):void 0}})],p.$JQ.Void)];class a{static register(s){y.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",T.$Ej)}}e.$Bpc=a;function S(r){return s=>{if(Array.isArray(s))return s.map(r)}}function d(r){if(!Array.isArray(r))return;const s=[];for(const c of r)O.$Lu(c)?s.push(o.DefinitionLink.to(c)):s.push(o.location.to(c));return s}}),define(Ne[257],Le([1,0,2,33]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3qc=void 0;class P{constructor(A,T,p,o,I){this.a=T,this.b=p,this.c=o;const y=new R.$KQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.$IQ("showOptions","Show Options",a=>!0,a=>a),new R.$IQ("resource","Interactive resource Uri",a=>!0,a=>a),new R.$IQ("controllerId","Notebook controller Id",a=>!0,a=>a),new R.$IQ("title","Interactive editor title",a=>!0,a=>a)],new R.$JQ("Notebook and input URI",a=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",a.notebookEditorId),a.notebookEditorId!==void 0){const S=this.a.getEditorById(a.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:v.URI.revive(a.notebookUri),inputUri:v.URI.revive(a.inputUri),notebookEditor:S.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",a.notebookUri,a.inputUri),{notebookUri:v.URI.revive(a.notebookUri),inputUri:v.URI.revive(a.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(A,T,p,o){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:p,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$3qc=P}),define(Ne[258],Le([1,0,17,10,21,6,4,28,2,18,11,5,33,8,7,82,197,24,39,198]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$qc=void 0,e.$_qc=h,S=qe(S);let n=class{constructor(D,b,C,k,f){this.m=b,this.n=C,this.o=k,this.q=f,this.b=new T.$Ac,this.c=new T.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$le,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(y.$KN.MainThreadNotebookKernels);const w=new a.$KQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.$IQ("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const L=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:L}}else if(N&&"notebookEditor"in N){const L=this.n.getIdByEditor(N.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:L}}return N})],a.$JQ.Void),F=new a.$KQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[a.$IQ.Uri],new a.$JQ("A promise that resolves to an array of variables",(N,L)=>N.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(w),this.o.registerApiCommand(F)}createNotebookController(D,b,C,k,f,w){for(const oe of this.j.values())if(oe.controller.id===b&&o.$rn.equals(D.identifier,oe.extensionId))throw new Error(`notebook controller with id '${b}' ALREADY exist`);const F=this.k++,N=this;this.q.trace(`NotebookController[${F}], CREATED by ${D.identifier.value}, ${b}`);const L=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${D.identifier}'`);let q=!1;const H=new O.$le,W=new O.$le,G={id:h(D.identifier,b),notebookType:C,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:k||D.identifier.value,preloads:w?w.map(S.NotebookRendererScript.from):[]};let Q=f??L,ae,be;this.a.$addKernel(F,G).catch(oe=>{console.log(oe),q=!0});let le=0;const _=()=>{if(q)return;const oe=++le;Promise.resolve().then(()=>{oe===le&&this.a.$updateKernel(F,G)})},ce=new T.$Ac,me={get id(){return b},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:H.event,get label(){return G.label},set label(oe){G.label=oe??D.displayName??D.name,_()},get detail(){return G.detail??""},set detail(oe){G.detail=oe,_()},get description(){return G.description??""},set description(oe){G.description=oe,_()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(oe){G.supportedLanguages=oe,_()},get supportsExecutionOrder(){return G.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){G.supportsExecutionOrder=oe,_()},get rendererScripts(){return G.preloads?G.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return Q},set executeHandler(oe){Q=oe??L},get interruptHandler(){return ae},set interruptHandler(oe){ae=oe,G.supportsInterrupt=!!oe,_()},set variableProvider(oe){(0,c.$gH)(D,"notebookVariableProvider"),be=oe,G.hasVariableProvider=!!oe,oe?.onDidChangeVariables(ke=>N.a.$variablesUpdated(ke.uri)),_()},get variableProvider(){return be},createNotebookCellExecution(oe){if(q)throw new Error("notebook controller is DISPOSED");if(!ce.has(oe.notebook.uri))throw N.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(ke=>ke.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return N._createNotebookCellExecution(oe,h(D.identifier,this.id))},createNotebookExecution(oe){if((0,c.$gH)(D,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!ce.has(oe.uri))throw N.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(ke=>ke.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.uri.toString()}`);return N._createNotebookExecution(oe,h(D.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${F}], DISPOSED`),q=!0,this.j.delete(F),H.dispose(),W.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(oe,ke){ke===d.NotebookControllerAffinity2.Hidden&&(0,c.$gH)(D,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(F,oe.uri,ke)},onDidReceiveMessage:W.event,postMessage(oe,ke){return(0,c.$gH)(D,"notebookMessaging"),N.a.$postMessage(F,ke&&N.n.getIdByEditor(ke),oe)},asWebviewUri(oe){return(0,c.$gH)(D,"notebookMessaging"),(0,r.$HDb)(oe,N.m.remote)}};return this.j.set(F,{extensionId:D.identifier,controller:me,onDidReceiveMessage:W,onDidChangeSelection:H,associatedNotebooks:ce}),me}getIdByController(D){for(const[b,C]of this.j)if(C.controller===D)return h(C.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,b){const C=this.g++,k=this;this.q.trace(`NotebookControllerDetectionTask[${C}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(C,b);const f={dispose:()=>{this.f.delete(C),k.a.$removeKernelDetectionTask(C)}};return this.f.set(C,f),f}registerKernelSourceActionProvider(D,b,C){const k=this.i++,f=typeof C.onDidChangeNotebookKernelSourceActions=="function"?k:void 0,w=this;this.h.set(k,C),this.q.trace(`NotebookKernelSourceActionProvider[${k}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(k,k,b);let F;return f!==void 0&&(F=C.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this.h.delete(k),w.a.$removeKernelSourceActionProvider(k,k),F?.dispose()}}}async $provideKernelSourceActions(D,b){const C=this.h.get(D);if(C){const k=new A.$Tc;return(await C.provideNotebookKernelSourceActions(b)??[]).map(w=>S.NotebookKernelSourceAction.from(w,this.o.converter,k))}return[]}$acceptNotebookAssociation(D,b,C){const k=this.j.get(D);if(k){const f=this.n.getNotebookDocument(p.URI.revive(b));C?k.associatedNotebooks.set(f.uri,!0):k.associatedNotebooks.delete(f.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,f.uri.toString(),C),k.onDidChangeSelection.fire({selected:C,notebook:f.apiNotebook})}}async $executeCells(D,b,C){const k=this.j.get(D);if(!k)return;const f=this.n.getNotebookDocument(p.URI.revive(b)),w=[];for(const F of C){const N=f.getCell(F);N&&w.push(N.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,f.uri.toString(),w.length),await k.controller.executeHandler.call(k.controller,w,f.apiNotebook,k.controller)}catch(F){this.q.error(`NotebookController[${D}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(D,b,C){const k=this.j.get(D);if(!k)return;const f=this.n.getNotebookDocument(p.URI.revive(b));if(k.controller.interruptHandler)await k.controller.interruptHandler.call(k.controller,f.apiNotebook);else for(const w of C){const F=f.getCell(w);F&&this.b.get(F.uri)?.cancel()}if(k.controller.interruptHandler){const w=this.c.get(f.uri);this.c.delete(f.uri),C.length&&Array.isArray(w)&&w.length&&w.forEach(F=>F.dispose())}}async $provideVariables(D,b,C,k,f,w,F){const N=this.j.get(D);if(!N)return;const L=this.n.getNotebookDocument(p.URI.revive(C)),q=N.controller.variableProvider;if(!q)return;let H;if(k!==void 0){if(H=this.s[k],!H)return}else this.s={};const W=f==="named"?d.NotebookVariablesRequestKind.Named:d.NotebookVariablesRequestKind.Indexed,G=q.provideVariables(L.apiNotebook,H,W,w,F);let Q=0;for await(const ae of G){if(F.isCancellationRequested)return;const be={id:this.r++,name:ae.variable.name,value:ae.variable.value,type:ae.variable.type,interfaces:ae.variable.interfaces,language:ae.variable.language,expression:ae.variable.expression,hasNamedChildren:ae.hasNamedChildren,indexedChildrenCount:ae.indexedChildrenCount,extensionId:N.extensionId.value};if(this.s[be.id]=ae.variable,this.a.$receiveVariable(b,be),Q++>=i.$ZK)return}}$acceptKernelMessageFromRenderer(D,b,C){const k=this.j.get(D);if(!k)return;const f=this.n.getEditorById(b);k.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:C}))}$cellExecutionChanged(D,b,C){const f=this.n.getNotebookDocument(p.URI.revive(D)).getCell(b);if(f){const w=C?S.NotebookCellExecutionState.to(C):d.NotebookCellExecutionState.Idle;w!==void 0&&this.l.fire({cell:f.apiCell,state:w})}}_createNotebookCellExecution(D,b){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const k=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!k)throw new Error("invalid cell");if(this.b.has(k.uri))throw new Error(`duplicate execution for ${k.uri}`);const f=new g(b,k,this.a);this.b.set(k.uri,f);const w=f.onDidChangeState(()=>{f.state===t.Resolved&&(f.dispose(),w.dispose(),this.b.delete(k.uri))});return f.asApiObject()}_createNotebookExecution(D,b){const C=this.n.getNotebookDocument(D.uri),k=D.getCells().find(F=>{const N=C.getCellFromApiCell(F);return N&&this.b.has(N.uri)});if(k)throw new Error(`duplicate cell execution for ${k.document.uri}`);if(this.c.has(C.uri))throw new Error(`duplicate notebook execution for ${C.uri}`);const f=new $(b,C,this.a),w=f.onDidChangeState(()=>{f.state===u.Resolved&&(f.dispose(),w.dispose(),this.c.delete(C.uri))});return this.c.set(C.uri,[f,w]),f.asApiObject()}};e.$$qc=n,e.$$qc=n=Je([Ve(4,I.$ak)],n);var t;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(t||(t={}));class g extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(D,b,C){super(),this.m=b,this.n=C,this.b=g.a++,this.c=new O.$le,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new P.$we),this.h=new m(10,k=>this.s(k)),this.j=b.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const b=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new l.$Xw(b))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let b=this.m;if(D&&(b=this.m.notebook.getCellFromApiCell(D)),!b)throw new Error("INVALID cell");return b.handle}y(D){return D.map(b=>{const C=d.$iP.ensureUniqueMimeTypes(b.items,!0);return C===b.items?S.NotebookCellOutput.from(b):S.NotebookCellOutput.from({items:C,id:b.id,metadata:b.metadata})})}async z(D,b,C){const k=this.w(b),f=this.y((0,v.$1b)(D));return this.r({editType:s.CellExecutionUpdateType.Output,cellHandle:k,append:C,outputs:f})}async C(D,b,C){return D=d.$iP.ensureUniqueMimeTypes((0,v.$1b)(D),!0),this.r({editType:s.CellExecutionUpdateType.OutputItems,items:D.map(S.NotebookCellOutputItem.from),outputId:b.id,append:C})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(C){D.j=C,D.s([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(C){if(D.f===t.Resolved||D.f===t.Started)throw new Error("Cannot call start again");D.f=t.Started,D.c.fire(),D.s({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:C})},end(C,k,f){if(D.f===t.Resolved)throw new Error("Cannot call resolve twice");D.f=t.Resolved,D.c.fire(),D.h.flush();const w=f?{message:f.message,stack:f.stack,location:f?.location?{startLineNumber:f.location.start.line,startColumn:f.location.start.character,endLineNumber:f.location.end.line,endColumn:f.location.end.character}:void 0,uri:f.uri}:void 0;D.n.$completeExecution(D.b,new l.$Xw({runEndTime:k,lastRunSuccess:C,error:w}))},clearOutput(C){return D.t(),D.z([],C,!1)},appendOutput(C,k){return D.t(),D.z(C,k,!0)},replaceOutput(C,k){return D.t(),D.z(C,k,!1)},appendOutputItems(C,k){return D.t(),D.C(C,k,!0)},replaceOutputItems(C,k){return D.t(),D.C(C,k,!1)}})}}var u;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(u||(u={}));class $ extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(D,b,C){super(),this.h=b,this.j=C,this.b=$.a++,this.c=new O.$le,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new P.$we),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===u.Resolved||this.f===u.Started)throw new Error("Cannot call start again");this.f=u.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===u.Resolved)throw new Error("Cannot call resolve twice");this.f=u.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class m{constructor(D,b){this.f=D,this.g=b,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new R.$3h,this.b=Date.now(),(0,R.$Gh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const b=this.a;return this.a=[],this.g(b).finally(()=>D.complete())}}function h(E,D){return`${E.value}/${D}`}}),define(Ne[56],Le([1,0,6,5,3,2,16,4,7,9,13,179,21,38,180,181,34,10,8,33,37]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gqc=e.$fqc=e.$eqc=e.$dqc=void 0,e.$dqc=(0,P.$Fi)("IExtHostTerminalService");class t extends T.$Uc{constructor(f,w,F,N){super(),this.u=f,this._id=w,this.w=F,this.y=N,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new v.$le),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(q=>this.g=q);const L=this;this.value={get name(){return L.y||""},get processId(){return L.b},get creationOptions(){return L.w},get exitStatus(){return L.j},get state(){return L.m},get selection(){return L.n},get shellIntegration(){return L.shellIntegration},sendText(q,H=!0){L.C(),L.u.$sendText(L._id,q,H)},show(q){L.C(),L.u.$show(L._id,q)},hide(){L.C(),L.u.$hide(L._id)},dispose(){L.a||(L.a=!0,L.u.$dispose(L._id))},get dimensions(){if(!(L.f===void 0||L.h===void 0))return{columns:L.f,rows:L.h}}}}dispose(){this.s.fire(),super.dispose()}async create(f,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??w?.cwd??void 0,env:f.env??void 0,icon:D(f.iconPath)??void 0,color:s.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,forceShellIntegration:w?.forceShellIntegration??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.z(f.location,w?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,w,F,N,L){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:N,color:s.ThemeColor.isThemeColor(L)?L.id:void 0,location:w?.location||this.z(f,F),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(f,w){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in f?{viewColumn:l.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(f){this.y=f}setExitStatus(f,w){this.j=Object.freeze({code:f,reason:w})}setDimensions(f,w){return f===this.f&&w===this.h||f===0||w===0?!1:(this.f=f,this.h=w,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(f){this.n=f}_setProcessId(f){this.g?(this.g(f),this.g=void 0):this.b.then(w=>{w!==f&&(this.b=Promise.resolve(f))})}}e.$eqc=t;class g{get onProcessReady(){return this.b.event}constructor(f){this.g=f,this.id=0,this.shouldPersist=!1,this.a=new v.$le,this.onProcessData=this.a.event,this.b=new v.$le,this.d=new v.$le,this.onDidChangeProperty=this.d.event,this.f=new v.$le,this.onProcessExit=this.f.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(f){this.g.handleInput?.(f)}resize(f,w){this.g.setDimensions?.({columns:f,rows:w})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:d.ProcessPropertyType.OverrideDimensions,value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:d.ProcessPropertyType.Title,value:w})}),this.g.open(f||void 0),f&&this.g.setDimensions?.(f),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,$=class extends T.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(f=>f.value)}constructor(f,w,F){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new T.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new v.$le,this.onDidCloseTerminal=this.H.event,this.I=new v.$le,this.onDidOpenTerminal=this.I.event,this.J=new v.$le,this.onDidChangeActiveTerminal=this.J.event,this.L=new v.$le,this.onDidChangeTerminalDimensions=this.L.event,this.M=new v.$le,this.onDidChangeTerminalState=this.M.event,this.N=new v.$le,this.onDidChangeShell=this.N.event,this.O=new v.$le({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new v.$le({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=F.getProxy(R.$KN.MainThreadTerminalService),this.y=new r.$Xxb(this.a.$sendProcessData),this.a.$registerProcessSupport(f),this.Q.registerArgumentProcessor({processArgument:N=>{const L=q=>{const H=q;return this.getTerminalById(H.instanceId)?.value};switch(N?.$mid){case n.MarshalledId.TerminalContext:return L(N);default:{if(Array.isArray(N))for(let q=0;q<N.length&&N[q].$mid===n.MarshalledId.TerminalContext;q++)N[q]=L(N[q]);return N}}}}),this.B({dispose:()=>{for(const[N,L]of this.g)L.shutdown(!0)}})}getDefaultShell(f){return(f?this.u:this.s)?.path||""}getDefaultShellArgs(f){return(f?this.u:this.s)?.args||[]}createExtensionTerminal(f,w){const F=new t(this.a,(0,S.$2g)(),f,f.name),N=new g(f.pty);return F.createExtensionTerminal(f.location,w,this.R(f,w).resolvedExtHostIdentifier,D(f.iconPath),b(f.color)).then(L=>{const q=this.S(L,N);this.h[L]=q}),this.f.push(F),F.value}R(f,w){if(w=w||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const F=f.location.parentTerminal;if(F){const N=this.f.find(L=>L.value===F);N&&(w.resolvedExtHostIdentifier=N._id)}}else f.location&&typeof f.location!="object"?w.location=f.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(f,w){if(!this.getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const N=new g(w),L=this.S(f,N);this.h[f]=L}async $acceptActiveTerminalChanged(f){const w=this.b;if(f===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const F=this.getTerminalById(f);F&&(this.b=F,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(f,w){const F=this.getTerminalById(f);F&&this.O.fire({terminal:F.value,data:w})}async $acceptTerminalDimensions(f,w,F){const N=this.getTerminalById(f);N&&N.setDimensions(w,F)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(f,w){const F=this.getTerminalById(f);F&&this.P.fire({terminal:F.value,...w})}async $acceptTerminalMaximumDimensions(f,w,F){this.g.get(f)?.resize(w,F)}async $acceptTerminalTitleChange(f,w){const F=this.getTerminalById(f);F&&(F.name=w)}async $acceptTerminalClosed(f,w,F){const N=this.X(this.f,f);if(N!==null){const L=this.f.splice(N,1)[0];L.setExitStatus(w,F),this.H.fire(L.value)}}$acceptTerminalOpened(f,w,F,N){if(w){const H=this.X(this.f,w);if(H!==null){this.f[H]._id=f,this.I.fire(this.terminals[H]),this.f[H].isOpen=!0;return}}const L={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:O.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},q=new t(this.a,f,L,F);this.f.push(q),this.I.fire(q.value),q.isOpen=!0}async $acceptTerminalProcessId(f,w){this.getTerminalById(f)?._setProcessId(w)}async $startExtensionTerminal(f,w){const F=this.getTerminalById(f);if(!F)return{message:(0,o.localize)(10824,null,f)};F.isOpen||await new Promise(L=>{const q=this.onDidOpenTerminal(async H=>{H===F.value&&(q.dispose(),L())})});const N=this.g.get(f);N?N.startSendingEvents(w):this.j[f]={initialDimensions:w}}S(f,w){const F=new T.$Tc;F.add(w.onProcessReady(L=>this.a.$sendProcessReady(f,L.pid,L.cwd,L.windowsPty))),F.add(w.onDidChangeProperty(L=>this.a.$sendProcessProperty(f,L))),this.y.startBuffering(f,w.onProcessData),F.add(w.onProcessExit(L=>this.U(f,L))),this.g.set(f,w);const N=this.j[f];return N&&w instanceof g&&(w.startSendingEvents(N.initialDimensions),delete this.j[f]),F}$acceptProcessAckDataEvent(f,w){this.g.get(f)?.acknowledgeDataEvent(w)}$acceptProcessInput(f,w){this.g.get(f)?.input(w)}$acceptTerminalInteraction(f){const w=this.getTerminalById(f);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(f,w){this.getTerminalById(f)?.setSelection(w)}$acceptProcessResize(f,w,F){try{this.g.get(f)?.resize(w,F)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(f,w){this.g.get(f)?.shutdown(w)}$acceptProcessRequestInitialCwd(f){this.g.get(f)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(f,{type:d.ProcessPropertyType.InitialCwd,value:w}))}$acceptProcessRequestCwd(f){this.g.get(f)?.getCwd().then(w=>this.a.$sendProcessProperty(f,{type:d.ProcessPropertyType.Cwd,value:w}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this.z.add(f),this.z.size===1&&this.a.$startLinkProvider(),new p.$MN(()=>{this.z.delete(f),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(f,w,F){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,F),this.a.$registerProfileProvider(w,f.identifier.value),new p.$MN(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(f,w,F){if(this.D.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this.D.set(f,F),this.a.$registerQuickFixProvider(f,w),new p.$MN(()=>{this.D.delete(f),this.a.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,w){const F=new a.$we().token;if(F.isCancellationRequested)return;const N=this.D.get(f);if(!N)return;const L=await N.provideTerminalQuickFixes(w,F);if(L===null||Array.isArray(L)&&L.length===0)return;const q=new T.$Tc;if(this.w.value=q,!Array.isArray(L))return L?l.TerminalQuickFix.from(L,this.Q.converter,q):void 0;const H=[];for(const W of L){const G=l.TerminalQuickFix.from(W,this.Q.converter,q);G&&H.push(G)}return H}async $createContributedProfileTerminal(f,w){const F=new a.$we().token;let N=await this.C.get(f)?.provideTerminalProfile(F);if(!F.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,w);return}this.createTerminalFromOptions(N.options,w)}}async $provideLinks(f,w){const F=this.getTerminalById(f);if(!F)return[];this.F.delete(f),this.G.get(f)?.dispose(!0);const L=new a.$we;this.G.set(f,L);const q=[],H={terminal:F.value,line:w},W=[];for(const ae of this.z)W.push(c.Promises.withAsyncBody(async be=>{L.token.onCancellationRequested(()=>be({provider:ae,links:[]}));const le=await ae.provideTerminalLinks(H,L.token)||[];L.token.isCancellationRequested||be({provider:ae,links:le})}));const G=await Promise.all(W);if(L.token.isCancellationRequested)return[];const Q=new Map;for(const ae of G)ae&&ae.links.length>0&&q.push(...ae.links.map(be=>{const le={id:u++,startIndex:be.startIndex,length:be.length,label:be.tooltip};return Q.set(le.id,{provider:ae.provider,link:be}),le}));return this.F.set(f,Q),q}$activateLink(f,w){const F=this.F.get(f)?.get(w);F&&F.provider.handleTerminalLink(F.link)}U(f,w){this.y.stopBuffering(f),this.g.delete(f),delete this.j[f];const F=this.h[f];F&&(F.dispose(),delete this.h[f]),this.a.$sendProcessExit(f,w)}getTerminalById(f){return this.W(this.f,f)}getTerminalIdByApiObject(f){const w=this.f.findIndex(F=>F.value===f);return w>=0?w:null}W(f,w){const F=this.X(f,w);return F!==null?f[F]:null}X(f,w){const F=f.findIndex(N=>N._id===w);return F>=0?F:null}getEnvironmentVariableCollection(f){let w=this.n.get(f.identifier.value);return w||(w=this.B(new m),this.Z(f.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Y(f,w){const F=(0,y.$Fs)(w.map),N=(0,y.$Gs)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(f,w.persistent,F.length===0?void 0:F,N)}$initEnvironmentVariableCollections(f){f.forEach(w=>{const F=w[0],N=this.B(new m(w[1]));this.Z(F,N)})}$acceptDefaultProfile(f,w){const F=this.s;this.s=f,this.u=w,F?.path!==f.path&&this.N.fire(f.path)}Z(f,w){this.n.set(f,w),this.B(w.onDidChangeCollection(()=>{this.Y(f,w)}))}};e.$fqc=$,e.$fqc=$=Je([Ve(1,i.$GQ),Ve(2,A.$kQ)],$);class m extends T.$Uc{get persistent(){return this.b}set persistent(f){this.b=f,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(f){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new v.$le,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const w=this.j(f);let F=this.a.get(w);return F||(F=new h(this,f),this.a.set(w,F),this.B(F.onDidChangeCollection(()=>this.f.fire()))),F}replace(f,w,F,N){this.g(f,{value:w,type:p.EnvironmentVariableMutatorType.Replace,options:F??{applyAtProcessCreation:!0},scope:N})}append(f,w,F,N){this.g(f,{value:w,type:p.EnvironmentVariableMutatorType.Append,options:F??{applyAtProcessCreation:!0},scope:N})}prepend(f,w,F,N){this.g(f,{value:w,type:p.EnvironmentVariableMutatorType.Prepend,options:F??{applyAtProcessCreation:!0},scope:N})}g(f,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const F=this.h(f,w.scope),N=this.map.get(F),L=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==w.value||N.type!==w.type||N.options?.applyAtProcessCreation!==L.applyAtProcessCreation||N.options?.applyAtShellIntegration!==L.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const q=this.h(f,w.scope),H={variable:f,...w,options:L};this.map.set(q,H),this.f.fire()}}get(f,w){const F=this.h(f,w),N=this.map.get(F);return N?C(N):void 0}h(f,w){const F=this.j(w);return F.length?`${f}:::${F}`:f}j(f){return this.m(f?.workspaceFolder)??""}m(f){return f?f.uri.toString():void 0}getVariableMap(f){const w=new Map;for(const[F,N]of this.map)this.j(N.scope)===this.j(f)&&w.set(N.variable,C(N));return w}delete(f,w){const F=this.h(f,w);this.map.delete(F),this.f.fire()}clear(f){if(f?.workspaceFolder){for(const[w,F]of this.map)F.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(w);this.n(f)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(f,w){const F=this.j(w),N=this.descriptionMap.get(F);if(!N||N.description!==f){let L;typeof f=="string"?L=f:L=f?.value.split(`

`)[0];const q={description:L,scope:w};this.descriptionMap.set(F,q),this.f.fire()}}getDescription(f){const w=this.j(f);return this.descriptionMap.get(w)?.description}n(f){const w=this.j(f);this.descriptionMap.delete(w)}}class h{get persistent(){return this.b.persistent}set persistent(f){this.b.persistent=f}get onDidChangeCollection(){return this.a&&this.a.event}constructor(f,w){this.b=f,this.d=w,this.a=new v.$le}getScoped(f){return this.b.getScopedEnvironmentVariableCollection(f)}replace(f,w,F){this.b.replace(f,w,F,this.d)}append(f,w,F){this.b.append(f,w,F,this.d)}prepend(f,w,F){this.b.prepend(f,w,F,this.d)}get(f){return this.b.get(f,this.d)}forEach(f,w){this.b.getVariableMap(this.d).forEach((F,N)=>f.call(w,N,F,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(f){this.b.delete(f,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(f){this.b.setDescription(f,this.d)}get description(){return this.b.getDescription(this.d)}}let E=class extends ${constructor(f,w){super(!1,f,w)}createTerminal(f,w,F){throw new I.$$}createTerminalFromOptions(f,w){throw new I.$$}};e.$gqc=E,e.$gqc=E=Je([Ve(0,i.$GQ),Ve(1,A.$kQ)],E);function D(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function b(k){return s.ThemeColor.isThemeColor(k)?k:void 0}function C(k){const f={...k};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(Ne[126],Le([1,0,7,4,3,5,16,56,6,2,10]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rrc=e.$qrc=void 0,e.$qrc=(0,P.$Fi)("IExtHostTerminalShellIntegration");let y=class extends R.$Uc{constructor(s,c){super(),this.h=c,this.b=new Map,this.c=new p.$le,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$le,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$le,this.onDidEndTerminalShellExecution=this.g.event,this.a=s.getProxy(O.$KN.MainThreadTerminalShellIntegration),this.B((0,R.$Sc)(()=>{for(const[l,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(s){const c=this.h.getTerminalById(s);if(!c)return;const l=c.value;let i=this.b.get(s);i||(i=new a(c.value,this.f),this.b.set(s,i),i.store.add(c.onWillDispose(()=>this.b.get(s)?.dispose())),i.store.add(i.onDidRequestShellExecution(n=>this.a.$executeCommand(s,n))),i.store.add(i.onDidRequestEndExecution(n=>this.g.fire(n))),i.store.add(i.onDidRequestChangeShellIntegration(n=>this.c.fire(n))),c.shellIntegration=i.value),this.c.fire({terminal:l,shellIntegration:i.value})}$shellExecutionStart(s,c,l,i,n){this.b.has(s)||this.$shellIntegrationChange(s);const t={value:c,confidence:l,isTrusted:i};this.b.get(s)?.startShellExecution(t,o.URI.revive(n))}$shellExecutionEnd(s,c,l,i,n){const t={value:c,confidence:l,isTrusted:i};this.b.get(s)?.endShellExecution(t,n)}$shellExecutionData(s,c){this.b.get(s)?.emitData(c)}$cwdChange(s,c){this.b.get(s)?.setCwd(o.URI.revive(c))}$closeTerminal(s){this.b.get(s)?.dispose(),this.b.delete(s)}};e.$rrc=y,e.$rrc=y=Je([Ve(0,A.$kQ),Ve(1,T.$dqc)],y);class a extends R.$Uc{get currentExecution(){return this.a}constructor(s,c){super(),this.j=s,this.m=c,this.b=!1,this.store=this.B(new R.$Tc),this.f=this.B(new p.$le),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$le),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$le),this.onDidRequestEndExecution=this.h.event;const l=this;this.value={get cwd(){return l.c},executeCommand(i,n){let t=i;n&&(t+=` "${n.map($=>`${$.replaceAll('"','\\"')}`).join('" "')}"`),l.g.fire(t);const g={value:t,confidence:v.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},u=l.startShellExecution(g,l.c,!0).value;return l.b=!0,u}}}startShellExecution(s,c,l){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new S(s,c??this.c);l?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(s){this.currentExecution?.emitData(s)}endShellExecution(s,c){this.a&&(this.a.endExecution(s),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:c}),this.a=void 0)}setCwd(s){let c=!1;o.URI.isUri(this.c)?c=!o.URI.isUri(s)||this.c.toString()!==s.toString():this.c!==s&&(c=!0),c&&(this.c=s,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class S{constructor(s,c){this.c=s,this.cwd=c,this.b=!1;const l=this;this.value={get commandLine(){return l.c},get cwd(){return l.cwd},read(){return l.d()}}}d(){if(!this.a){if(this.b)return I.$6h.EMPTY;this.a=new d}return this.a.createIterable()}emitData(s){this.a?.emitData(s)}endExecution(s){s&&(this.c=s),this.a?.endExecution(),this.a=void 0,this.b=!0}}class d extends R.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Eh);const s=this.a;return new I.$6h(async l=>{this.b.push(l),await s.wait()})}emitData(s){for(const c of this.b)c.emitOne(s)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ne[127],Le([1,0,61,13,96,8,7]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tQ=e.$sQ=e.$rQ=void 0,O=qe(O);class T{static{this.c=new P.$pQ("TextEditorDecorationType")}constructor(a,S,d){const r=T.c.nextId();a.$registerTextEditorDecorationType(S.identifier,r,O.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:r,dispose(){a.$removeTextEditorDecorationType(r)}})}}e.$rQ=T;class p{constructor(a,S){this.g=[],this.h=void 0,this.j=!1,this.c=a,this.d=a.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(a,S){this.k();let d=null;if(a instanceof A.$NN)d=new A.$ON(a,a);else if(a instanceof A.$ON)d=a;else throw new Error("Unrecognized location");this.l(d,S,!1)}insert(a,S){this.k(),this.l(new A.$ON(a,a),S,!0)}delete(a){this.k();let S=null;if(a instanceof A.$ON)S=a;else throw new Error("Unrecognized location");this.l(S,null,!0)}l(a,S,d){const r=this.c.validateRange(a);this.g.push({range:r,text:S,forceMoveMarkers:d})}setEndOfLine(a){if(this.k(),a!==A.EndOfLine.LF&&a!==A.EndOfLine.CRLF)throw(0,R.$6)("endOfLine");this.h=a}}class o{constructor(a,S,d,r){this.c=a,this.d=S,this._accept(d),this.e=r;const s=this;this.value={get tabSize(){return s.f},set tabSize(c){s.n(c)},get indentSize(){return s.g},set indentSize(c){s.p(c)},get insertSpaces(){return s.j},set insertSpaces(c){s.s(c)},get cursorStyle(){return s.k},set cursorStyle(c){s.t(c)},get lineNumbers(){return s.l},set lineNumbers(c){s.u(c)}}}_accept(a){this.f=a.tabSize,this.g=a.indentSize,this.h=a.originalIndentSize,this.j=a.insertSpaces,this.k=a.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(a.lineNumbers)}m(a){if(a==="auto")return"auto";if(typeof a=="number"){const S=Math.floor(a);return S>0?S:null}if(typeof a=="string"){const S=parseInt(a,10);return isNaN(S)?null:S>0?S:null}return null}n(a){const S=this.m(a);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}o(a){if(a==="tabSize")return"tabSize";if(typeof a=="number"){const S=Math.floor(a);return S>0?S:null}if(typeof a=="string"){const S=parseInt(a,10);return isNaN(S)?null:S>0?S:null}return null}p(a){const S=this.o(a);if(S!==null){if(typeof S=="number"){if(this.h===S)return;this.g=S,this.h=S}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}q(a){return a==="auto"?"auto":a==="false"?!1:!!a}s(a){const S=this.q(a);if(typeof S=="boolean"){if(this.j===S)return;this.j=S}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}t(a){this.k!==a&&(this.k=a,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:a})))}u(a){this.l!==a&&(this.l=a,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(a)})))}assign(a){const S={};let d=!1;if(typeof a.tabSize<"u"){const r=this.m(a.tabSize);r==="auto"?(d=!0,S.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,d=!0,S.tabSize=r)}if(typeof a.indentSize<"u"){const r=this.o(a.indentSize);r==="tabSize"?(d=!0,S.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,d=!0,S.indentSize=r)}if(typeof a.insertSpaces<"u"){const r=this.q(a.insertSpaces);r==="auto"?(d=!0,S.insertSpaces=r):this.j!==r&&(this.j=r,d=!0,S.insertSpaces=r)}typeof a.cursorStyle<"u"&&this.k!==a.cursorStyle&&(this.k=a.cursorStyle,d=!0,S.cursorStyle=a.cursorStyle),typeof a.lineNumbers<"u"&&this.l!==a.lineNumbers&&(this.l=a.lineNumbers,d=!0,S.lineNumbers=O.TextEditorLineNumbersStyle.from(a.lineNumbers)),d&&this.v("setOptions",this.c.$trySetOptions(this.d,S))}v(a,S){S.catch(d=>{this.e.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this.e.warn(d)})}}e.$sQ=o;class I{constructor(a,S,d,r,s,c,l,i){this.id=a,this.j=S,this.k=d,this.g=!1,this.h=new Set,this.c=s,this.d=new o(this.j,this.id,c,d),this.e=l,this.f=i;const n=this;this.value=Object.freeze({get document(){return r.value},set document(t){throw new R.$8("document")},get selection(){return n.c&&n.c[0]},set selection(t){if(!(t instanceof A.$PN))throw(0,R.$6)("selection");n.c=[t],n.l()},get selections(){return n.c},set selections(t){if(!Array.isArray(t)||t.some(g=>!(g instanceof A.$PN)))throw(0,R.$6)("selections");n.c=t,n.l()},get visibleRanges(){return n.e},set visibleRanges(t){throw new R.$8("visibleRanges")},get options(){return n.d.value},set options(t){n.g||n.d.assign(t)},get viewColumn(){return n.f},set viewColumn(t){throw new R.$8("viewColumn")},edit(t,g={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new p(r.value,g);return t(u),n.m(u)},insertSnippet(t,g,u={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let $;if(!g||Array.isArray(g)&&g.length===0)$=n.c.map(m=>O.Range.from(m));else if(g instanceof A.$NN){const{lineNumber:m,column:h}=O.Position.from(g);$=[{startLineNumber:m,startColumn:h,endLineNumber:m,endColumn:h}]}else if(g instanceof A.$ON)$=[O.Range.from(g)];else{$=[];for(const m of g)if(m instanceof A.$ON)$.push(O.Range.from(m));else{const{lineNumber:h,column:E}=O.Position.from(m);$.push({startLineNumber:h,startColumn:E,endLineNumber:h,endColumn:E})}}return S.$tryInsertSnippet(a,r.value.version,t.value,$,u)},setDecorations(t,g){const u=g.length===0;u&&!n.h.has(t.key)||(u?n.h.delete(t.key):n.h.add(t.key),n.n(()=>{if(O.$hQ(g))return S.$trySetDecorations(a,t.key,O.$iQ(g));{const $=new Array(4*g.length);for(let m=0,h=g.length;m<h;m++){const E=g[m];$[4*m]=E.start.line+1,$[4*m+1]=E.start.character+1,$[4*m+2]=E.end.line+1,$[4*m+3]=E.end.character+1}return S.$trySetDecorationsFast(a,t.key,$)}}))},revealRange(t,g){n.n(()=>S.$tryRevealRange(a,O.Range.from(t),g||A.TextEditorRevealType.Default))},show(t){S.$tryShowEditor(a,O.ViewColumn.from(t))},hide(){S.$tryHideEditor(a)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,v.ok)(!this.g),this.g=!0}_acceptOptions(a){(0,v.ok)(!this.g),this.d._accept(a)}_acceptVisibleRanges(a){(0,v.ok)(!this.g),this.e=a}_acceptViewColumn(a){(0,v.ok)(!this.g),this.f=a}_acceptSelections(a){(0,v.ok)(!this.g),this.c=a}async l(){const a=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,a)),this.value}m(a){const S=a.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const d=S.edits.map(s=>s.range);d.sort((s,c)=>s.end.line===c.end.line?s.end.character===c.end.character?s.start.line===c.start.line?s.start.character-c.start.character:s.start.line-c.start.line:s.end.character-c.end.character:s.end.line-c.end.line);for(let s=0,c=d.length-1;s<c;s++){const l=d[s].end;if(d[s+1].start.isBefore(l))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=S.edits.map(s=>({range:O.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,r,{setEndOfLine:typeof S.setEndOfLine=="number"?O.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n(a){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$tQ=I}),define(Ne[57],Le([1,0,61,6,4,2,3,5,123,16,127,8,11,28,15,40,48]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vQ=e.$uQ=void 0,v=qe(v),y=qe(y);class c{constructor(n){this.value=n,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let l=class{constructor(n,t){this.h=n,this.i=t,this.a=null,this.b=new Map,this.c=new S.$Ac,this.d=new R.$le,this.e=new R.$le,this.f=new R.$le,this.g=new R.$le,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const t=[],g=[],u=[];if(n.removedDocuments)for(const $ of n.removedDocuments){const m=O.URI.revive($),h=this.c.get(m);h?.unref()&&(this.c.delete(m),t.push(h.value))}if(n.addedDocuments)for(const $ of n.addedDocuments){const m=O.URI.revive($.uri);let h=this.c.get(m);if(h&&m.scheme!==d.Schemas.vscodeNotebookCell&&m.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${m} already exists!'`);h||(h=new c(new p.$nQ(this.h.getProxy(T.$KN.MainThreadDocuments),m,$.lines,$.EOL,$.versionId,$.languageId,$.isDirty)),this.c.set(m,h),g.push(h.value)),h.ref()}if(n.removedEditors)for(const $ of n.removedEditors){const m=this.b.get($);this.b.delete($),m&&u.push(m)}if(n.addedEditors)for(const $ of n.addedEditors){const m=O.URI.revive($.documentUri);v.ok(this.c.has(m),`document '${m}' does not exist`),v.ok(!this.b.has($.id),`editor '${$.id}' already exists!`);const h=this.c.get(m).value,E=new I.$tQ($.id,this.h.getProxy(T.$KN.MainThreadTextEditors),this.i,new s.$T(()=>h.document),$.selections.map(y.Selection.to),$.options,$.visibleRanges.map(D=>y.Range.to(D)),typeof $.editorPosition=="number"?y.ViewColumn.to($.editorPosition):void 0);this.b.set($.id,E)}n.newActiveEditor!==void 0&&(v.ok(n.newActiveEditor===null||this.b.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this.a=n.newActiveEditor),(0,P.$Pc)(t),(0,P.$Pc)(u),n.removedDocuments&&this.e.fire(t),n.addedDocuments&&this.d.fire(g),(n.removedEditors||n.addedEditors)&&this.f.fire(this.allEditors().map($=>$.value)),n.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(n){return this.c.get(n)?.value}allDocuments(){return r.Iterable.map(this.c.values(),n=>n.value)}getEditor(n){return this.b.get(n)}activeEditor(n){if(!this.a)return;const t=this.b.get(this.a);return n?t:t?.value}allEditors(){return[...this.b.values()]}};e.$uQ=l,e.$uQ=l=Je([Ve(0,o.$kQ),Ve(1,a.$ak)],l),e.$vQ=(0,A.$Fi)("IExtHostDocumentsAndEditors")}),define(Ne[95],Le([1,0,10,22,21,6,231,75,4,37,14,2,38,3,11,5,33,57,16,125,8,7,200,54,81,55,24]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n,t,g,u,$,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bqc=e.$Aqc=e.$zqc=e.$yqc=e.$xqc=void 0,n=qe(n);let E=0;const D=new WeakMap;e.$xqc=(0,S.$Fi)("IExtHostTesting");let b=class extends p.$Uc{constructor(le,_,ce,me){super(),this.C=_,this.D=ce,this.F=me,this.f=this.B(new O.$le),this.g=new Map,this.w=this.B(new O.$le),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=le.getProxy(r.$KN.MainThreadTesting),this.m=new H(this.h),this.j=new w(this.h,_),ce.registerArgumentProcessor({processArgument:oe=>{switch(oe?.$mid){case o.MarshalledId.TestItemContext:{const ke=oe,Te=ke.tests[ke.tests.length-1].item.extId;return this.g.get(u.$7I.root(Te))?.collection.tree.get(Te)?.actual??(0,i.$wQ)(oe)}case o.MarshalledId.TestMessageMenuArgs:{const{test:ke,message:Te}=oe,Y=ke.item.extId;return{test:this.g.get(u.$7I.root(Y))?.collection.tree.get(Y)?.actual??(0,i.$wQ)({$mid:o.MarshalledId.TestItemContext,tests:[ke]}),message:n.TestMessage.to(Te)}}default:return oe}}}),ce.registerCommand(!1,"testing.getExplorerSelection",async()=>{const oe=await ce.executeCommand(g.TestCommandId.GetExplorerSelection),ke=Te=>{const Y=this.g.get(u.$7I.root(Te));if(Y)return u.$7I.isRoot(Te)?Y.controller:Y.collection.tree.get(Te)?.actual};return{include:oe?.include.map(ke).filter(I.$mg)||[],exclude:oe?.exclude.map(ke).filter(I.$mg)||[]}})}createTestController(le,_,ce,me){if(this.g.has(_))throw new Error(`Attempt to insert a duplicate controller with ID "${_}"`);const oe=new p.$Tc,ke=oe.add(new i.$zQ(_,ce,this.F));ke.root.label=ce;const Te=new Map,Y=new Set,B=this.h,ne=()=>{let we=0;me&&(we|=m.TestControllerCapability.Refresh);const he=fe.relatedCodeProvider;return he&&(he?.provideRelatedTests&&(we|=m.TestControllerCapability.TestRelatedToCode),he?.provideRelatedCode&&(we|=m.TestControllerCapability.CodeRelatedToTest)),we},Ee={items:ke.root.children,get label(){return ce},set label(we){ce=we,ke.root.label=we,B.$updateController(_,{label:ce})},get refreshHandler(){return me},set refreshHandler(we){me=we,B.$updateController(_,{capabilities:ne()})},get id(){return _},get relatedCodeProvider(){return fe.relatedCodeProvider},set relatedCodeProvider(we){(0,h.$gH)(le,"testRelatedCode"),fe.relatedCodeProvider=we,B.$updateController(_,{capabilities:ne()})},createRunProfile:(we,he,X,x,$e,pe)=>{let Ae=(0,T.$tj)(we);for(;Te.has(Ae);)Ae++;return new G(this.h,Te,Y,this.w.event,_,Ae,we,he,X,x,$e,pe)},createTestItem(we,he,X){return new i.$xQ(_,we,he,X)},createTestRun:(we,he,X=!0)=>this.j.createTestRun(le,_,ke,we,he,X),invalidateTestResults:we=>{if(we===void 0)this.h.$markTestRetired(void 0);else{const he=we instanceof Array?we:[we];this.h.$markTestRetired(he.map(X=>u.$7I.fromExtHostTestItem(X,_).toString()))}},set resolveHandler(we){ke.resolveHandler=we},get resolveHandler(){return ke.resolveHandler},dispose:()=>{oe.dispose()}},fe={controller:Ee,collection:ke,profiles:Te,extension:le,activeProfiles:Y};return B.$registerTestController(_,ce,ne()),oe.add((0,p.$Sc)(()=>B.$unregisterTestController(_))),this.g.set(_,fe),oe.add((0,p.$Sc)(()=>this.g.delete(_))),oe.add(ke.onDidGenerateDiff(we=>B.$publishDiff(_,we.map(m.TestsDiffOp.serialize)))),Ee}createTestObserver(){return this.m.checkout()}async runTests(le,_=P.CancellationToken.None){const ce=F(le);if(!ce)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const me=this.g.get(ce.controllerId);if(!me)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:le.preserveFocus??!0,group:Q[ce.kind],targets:[{testIds:le.include?.map(oe=>u.$7I.fromExtHostTestItem(oe,me.collection.root.id).toString())??[me.collection.root.id],profileId:ce.profileId,controllerId:ce.controllerId}],exclude:le.exclude?.map(oe=>oe.id)},_)}registerTestFollowupProvider(le){return this.y.add(le),{dispose:()=>{this.y.delete(le)}}}async $getTestsRelatedToCode(le,_,ce){const me=this.F.getDocument(y.URI.revive(le));if(!me)return[];const oe=n.Position.to(_),ke=[];return await Promise.all([...this.g.values()].map(async Te=>{let Y;try{Y=await Te.relatedCodeProvider?.provideRelatedTests?.(me.document,oe,ce)}catch(B){ce.isCancellationRequested||this.C.warn(`Error thrown while providing related tests for ${Te.controller.label}`,B)}if(Y){for(const B of Y)ke.push(u.$7I.fromExtHostTestItem(B,Te.controller.id).toString());Te.collection.flushDiff()}})),ke}async $getCodeRelatedToTest(le,_){const ce=this.g.get(u.$7I.root(le));if(!ce)return[];const me=ce.collection.tree.get(le);return me?(await ce.relatedCodeProvider?.provideRelatedCode?.(me.actual,_))?.map(n.location.from)??[]:[]}$syncTests(){for(const{collection:le}of this.g.values())le.flushDiff();return Promise.resolve()}async $getCoverageDetails(le,_,ce){return(await this.j.getCoverageDetails(le,_,ce))?.map(n.TestCoverage.fromDetails)}async $disposeRun(le){this.j.disposeTestRun(le)}$configureRunProfile(le,_){this.g.get(le)?.profiles.get(_)?.configureHandler?.()}$setDefaultRunProfiles(le){const _=new Map;for(const[ce,me]of Object.entries(le)){const oe=this.g.get(ce);if(!oe)continue;const ke=new Map,Te=me.filter(B=>!oe.activeProfiles.has(B)),Y=[...oe.activeProfiles].filter(B=>!me.includes(B));for(const B of Te)ke.set(B,!0),oe.activeProfiles.add(B);for(const B of Y)ke.set(B,!1),oe.activeProfiles.delete(B);ke.size&&_.set(ce,ke)}this.w.fire(_)}async $refreshTests(le,_){await this.g.get(le)?.controller.refreshHandler?.(_)}$publishTestResults(le){this.results=Object.freeze(le.map(_=>{const ce=n.TestResults.to(_);return D.set(ce,_.id),ce}).concat(this.results).sort((_,ce)=>ce.completedAt-_.completedAt).slice(0,32)),this.f.fire()}async $expandTest(le,_){const ce=this.g.get(u.$7I.fromString(le).controllerId)?.collection;ce&&(await ce.expand(le,_<0?1/0:_),ce.flushDiff())}$acceptDiff(le){this.m.applyDiff(le.map(_=>m.TestsDiffOp.deserialize({asCanonicalUri:ce=>ce},_)))}async $runControllerTests(le,_){return Promise.all(le.map(ce=>this.G(ce,!1,_)))}async $startContinuousRun(le,_){const ce=new P.$we(_),me=await Promise.all(le.map(oe=>this.G(oe,!0,ce.token)));return!_.isCancellationRequested&&!me.some(oe=>oe.error)&&await new Promise(oe=>_.onCancellationRequested(oe)),ce.dispose(!0),me}async $provideTestFollowups(le,_){const ce=this.results.find(ke=>D.get(ke)===le.resultId),me=ce&&ae(u.$7I.fromString(le.extId),ce?.results);if(!me)return[];let oe=[];return await Promise.all([...this.y].map(async ke=>{try{const Te=await ke.provideFollowup(ce,me,le.taskIndex,le.messageIndex,_);Te&&(oe=oe.concat(Te))}catch(Te){this.C.error("Error thrown while providing followup for test message",Te)}})),_.isCancellationRequested?[]:oe.map(ke=>{const Te=E++;return this.z.set(Te,ke),{title:ke.title,id:Te}})}$disposeTestFollowups(le){for(const _ of le)this.z.delete(_)}$executeTestFollowup(le){const _=this.z.get(le);return _?this.D.executeCommand(_.command,..._.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(le){le===void 0?this.j.cancelAllRuns():this.j.cancelRunById(le)}getMetadataForRun(le){for(const _ of this.j.trackers){const ce=_.getTaskIdForRun(le);if(ce)return{taskId:ce,runId:_.id}}}async G(le,_,ce){const me=this.g.get(le.controllerId);if(!me)return{};const{collection:oe,profiles:ke,extension:Te}=me,Y=ke.get(le.profileId);if(!Y)return{};const B=le.testIds.map(we=>oe.tree.get(we)).filter(I.$mg),ne=le.excludeExtIds.map(we=>me.collection.tree.get(we)).filter(I.$mg).filter(we=>B.some(he=>he.fullId.compare(we.fullId)===u.TestPosition.IsChild));if(!B.length)return{};const Ee=new t.$pP(B.some(we=>we.actual instanceof i.$yQ)?void 0:B.map(we=>we.actual),ne.map(we=>we.actual),Y,_),fe=(0,m.$0I)(le)&&this.j.prepareForMainThreadTestRun(Te,Ee,N.fromInternal(le,me.collection),Y,ce);try{return await Y.runHandler(Ee,ce),{}}catch(we){return{error:String(we)}}finally{fe&&fe.hasRunningTasks&&!ce.isCancellationRequested&&await O.Event.toPromise(fe.onEnd)}}};e.$yqc=b,e.$yqc=b=Je([Ve(0,l.$kQ),Ve(1,d.$ak),Ve(2,s.$GQ),Ve(3,c.$vQ)],b);const C=1e4;var k;(function(be){be[be.Running=0]="Running",be[be.Cancelling=1]="Cancelling",be[be.Ended=2]="Ended"})(k||(k={}));class f extends p.$Uc{get hasRunningTasks(){return this.g>0}get id(){return this.C.id}constructor(le,_,ce,me,oe,ke){super(),this.C=le,this.D=_,this.F=ce,this.G=me,this.H=oe,this.f=k.Running,this.g=0,this.h=new Map,this.j=new Set,this.w=this.B(new O.$le),this.z=new Map,this.onEnd=this.w.event,this.m=this.B(new P.$we(ke));const Te=this.B(new v.$Rh(()=>this.I(),C));this.B(this.m.token.onCancellationRequested(()=>Te.schedule()));const Y=new O.$le;this.y=Y.event,this.B((0,p.$Sc)(()=>{Y.fire(),Y.dispose()}))}getTaskIdForRun(le){for(const[_,{run:ce}]of this.h)if(ce===le)return _}cancel(){this.f===k.Running?(this.m.cancel(),this.f=k.Cancelling):this.f===k.Cancelling&&this.I()}async getCoverageDetails(le,_,ce){const[,me]=u.$7I.fromString(le).path,oe=this.z.get(le);if(!oe)return[];const{report:ke,extIds:Te}=oe,Y=this.h.get(me);if(!Y)throw new Error("unreachable: run task was not found");let B;if(_&&ke instanceof t.$vP){const Ee=Te.indexOf(_);if(Ee===-1)return[];B=ke.fromTests[Ee]}return await(B?this.G?.loadDetailedCoverageForTest?.(Y.run,ke,B,ce):this.G?.loadDetailedCoverage?.(Y.run,ke,ce))??[]}createRun(le){const _=this.C.id,ce=this.C.controllerId,me=(0,a.$2g)(),oe=B=>(ne,...Ee)=>{if(Te){this.F.warn(`Setting the state of test "${ne.id}" is a no-op after the run ends.`);return}this.L(ne),B(ne,...Ee)},ke=(B,ne)=>{const Ee=ne instanceof Array?ne.map(n.TestMessage.from):[n.TestMessage.from(ne)];if(B.uri&&B.range){const fe={range:n.Range.from(B.range),uri:B.uri};for(const we of Ee)we.location=we.location||fe}this.D.$appendTestMessagesInRun(_,me,u.$7I.fromExtHostTestItem(B,ce).toString(),Ee)};let Te=!1;const Y={isPersisted:this.C.isPersisted,token:this.m.token,name:le,onDidDispose:this.y,addCoverage:B=>{if(Te)return;const ne=B instanceof t.$vP?B.fromTests:[];if(ne.length){(0,h.$gH)(this.H,"attributableCoverage");for(const we of ne)this.L(we)}const Ee=B.uri.toString(),fe=new u.$7I([_,me,Ee]).toString();this.z.set(fe,{report:B,extIds:ne.map(we=>u.$7I.fromExtHostTestItem(we,ce).toString())}),this.D.$appendCoverage(_,me,n.TestCoverage.fromFile(ce,fe,B))},enqueued:oe(B=>{this.D.$updateTestStateInRun(_,me,u.$7I.fromExtHostTestItem(B,ce).toString(),m.TestResultState.Queued)}),skipped:oe(B=>{this.D.$updateTestStateInRun(_,me,u.$7I.fromExtHostTestItem(B,ce).toString(),m.TestResultState.Skipped)}),started:oe(B=>{this.D.$updateTestStateInRun(_,me,u.$7I.fromExtHostTestItem(B,ce).toString(),m.TestResultState.Running)}),errored:oe((B,ne,Ee)=>{ke(B,ne),this.D.$updateTestStateInRun(_,me,u.$7I.fromExtHostTestItem(B,ce).toString(),m.TestResultState.Errored,Ee)}),failed:oe((B,ne,Ee)=>{ke(B,ne),this.D.$updateTestStateInRun(_,me,u.$7I.fromExtHostTestItem(B,ce).toString(),m.TestResultState.Failed,Ee)}),passed:oe((B,ne)=>{this.D.$updateTestStateInRun(_,me,u.$7I.fromExtHostTestItem(B,this.C.controllerId).toString(),m.TestResultState.Passed,ne)}),appendOutput:(B,ne,Ee)=>{Te||(Ee&&this.L(Ee),this.D.$appendOutputToRun(_,me,R.$Ne.fromString(B),ne&&n.location.from(ne),Ee&&u.$7I.fromExtHostTestItem(Ee,ce).toString()))},end:()=>{Te||(Te=!0,this.D.$finishedTestRunTask(_,me),--this.g||this.J())}};return this.g++,this.h.set(me,{run:Y}),this.D.$startedTestRunTask(_,{id:me,ctrlId:this.C.controllerId,name:le,running:!0}),Y}I(){for(const{run:le}of this.h.values())le.end()}J(){this.f!==k.Ended&&(this.f=k.Ended,this.w.fire())}L(le){if(!(le instanceof i.$xQ))throw new $.$cQ(le.id);if(this.j.has(u.$7I.fromExtHostTestItem(le,this.C.controllerId).toString()))return;const _=[],ce=this.C.colllection.root;for(;;){const me=n.TestItem.from(le);if(_.unshift(me),this.j.has(me.extId)||(this.j.add(me.extId),le===ce))break;le=le.parent||ce}this.D.$addTestsToRun(this.C.controllerId,this.C.id,_)}dispose(){this.J(),super.dispose()}}class w{get trackers(){return this.f.values()}constructor(le,_){this.h=le,this.j=_,this.f=new Map,this.g=new Map}getCoverageDetails(le,_,ce){const me=u.$7I.root(le);return this.g.get(me)?.getCoverageDetails(le,_,ce)||[]}disposeTestRun(le){this.g.get(le)?.dispose(),this.g.delete(le);for(const[_,{id:ce}]of this.f)ce===le&&this.f.delete(_)}prepareForMainThreadTestRun(le,_,ce,me,oe){return this.k(_,ce,me,le,oe)}cancelRunById(le){this.g.get(le)?.cancel()}cancelAllRuns(){for(const le of this.f.values())le.cancel()}createTestRun(le,_,ce,me,oe,ke){const Te=this.f.get(me);if(Te)return Te.createRun(oe);const Y=N.fromPublic(_,ce,me,ke),B=F(me);this.h.$startedExtensionTestRun({controllerId:_,continuous:!!me.continuous,profile:B&&{group:Q[B.kind],id:B.profileId},exclude:me.exclude?.map(Ee=>u.$7I.fromExtHostTestItem(Ee,ce.root.id).toString())??[],id:Y.id,include:me.include?.map(Ee=>u.$7I.fromExtHostTestItem(Ee,ce.root.id).toString())??[ce.root.id],preserveFocus:me.preserveFocus??!0,persist:ke});const ne=this.k(me,Y,me.profile,le);return O.Event.once(ne.onEnd)(()=>{this.h.$finishedExtensionTestRun(Y.id)}),ne.createRun(oe)}k(le,_,ce,me,oe){const ke=new f(_,this.h,this.j,ce,me,oe);return this.f.set(le,ke),this.g.set(ke.id,ke),ke}}e.$zqc=w;const F=be=>{if(be.profile){if(!(be.profile instanceof G))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return be.profile}};class N{static fromPublic(le,_,ce,me){return new N(le,(0,a.$2g)(),me,_)}static fromInternal(le,_){return new N(le.controllerId,le.runId,!0,_)}constructor(le,_,ce,me){this.controllerId=le,this.id=_,this.isPersisted=ce,this.colllection=me}}e.$Aqc=N;class L{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(le){this.k=le,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(le){this.f.add(le)}update(le){Object.assign(le.revived,n.TestItem.toPlain(le.item)),this.f.has(le)||this.g.add(le)}remove(le){if(this.f.has(le)){this.f.delete(le);return}this.g.delete(le);const _=u.$7I.parentId(le.item.extId);if(_&&this.j.has(_.toString())){this.j.add(le.item.extId);return}this.h.add(le)}getChangeEvent(){const{f:le,g:_,h:ce}=this;return{get added(){return[...le].map(me=>me.revived)},get updated(){return[..._].map(me=>me.revived)},get removed(){return[...ce].map(me=>me.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class q extends m.$dJ{constructor(){super(...arguments),this.z=new O.$le,this.onDidChangeTests=this.z.event}get rootTests(){return this.h}getMirroredTestDataById(le){return this.g.get(le)}getMirroredTestDataByReference(le){return this.g.get(le.id)}y(le,_){return{...le,revived:n.TestItem.toPlain(le.item),depth:_?_.depth+1:0,children:new Set}}x(){return new L(this.z)}}class H{constructor(le){this.g=le}checkout(){this.f||(this.f=this.h());const le=this.f;return le.observers++,{onDidChangeTest:le.tests.onDidChangeTests,get tests(){return[...le.tests.rootTests].map(_=>_.revived)},dispose:(0,A.$cb)(()=>{--le.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(le){return this.f?.tests.getMirroredTestDataByReference(le)}applyDiff(le){this.f?.tests.apply(le)}h(){const le=new q({asCanonicalUri:_=>_});return this.g.$subscribeToDiffs(),{observers:0,tests:le}}}const W=(be,le,_,ce)=>{_?Object.assign(_,ce):le.$updateTestRunConfig(be.controllerId,be.profileId,ce)};class G{#e;#t;#i;#n;#s;get label(){return this.g}set label(le){le!==this.g&&(this.g=le,W(this,this.#e,this.#n,{label:le}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(le){le!==this.h&&(this.h=le,W(this,this.#e,this.#n,{supportsContinuousRun:le}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(le){le!==this.isDefault&&(le?this.#t.add(this.profileId):this.#t.delete(this.profileId),W(this,this.#e,this.#n,{isDefault:le}))}get tag(){return this._tag}set tag(le){le?.id!==this._tag?.id&&(this._tag=le,W(this,this.#e,this.#n,{tag:le?n.TestTag.namespace(this.controllerId,le.id):null}))}get configureHandler(){return this.f}set configureHandler(le){le!==this.f&&(this.f=le,W(this,this.#e,this.#n,{hasConfigurationHandler:!!le}))}get onDidChangeDefault(){return O.Event.chain(this.#i,le=>le.map(_=>_.get(this.controllerId)?.get(this.profileId)).filter(I.$mg))}constructor(le,_,ce,me,oe,ke,Te,Y,B,ne=!1,Ee=void 0,fe=!1){this.controllerId=oe,this.profileId=ke,this.g=Te,this.kind=Y,this.runHandler=B,this._tag=Ee,this.h=fe,this.#e=le,this.#s=_,this.#t=ce,this.#i=me,_.set(ke,this);const we=Q[Y];if(typeof we!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);ne&&ce.add(ke),this.#n={profileId:ke,controllerId:oe,tag:Ee?n.TestTag.namespace(this.controllerId,Ee.id):null,label:Te,group:we,isDefault:ne,hasConfigurationHandler:!1,supportsContinuousRun:fe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Bqc=G;const Q={[t.TestRunProfileKind.Coverage]:m.TestRunProfileBitset.Coverage,[t.TestRunProfileKind.Debug]:m.TestRunProfileBitset.Debug,[t.TestRunProfileKind.Run]:m.TestRunProfileBitset.Run};function ae(be,le){for(let _=0;_<be.path.length;_++){const ce=le.find(me=>me.id===be.path[_]);if(!ce)return;if(_===be.path.length-1)return ce;le=ce.children}}}),define(Ne[259],Le([1,0,17,6,4,5,127,8,7]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipc=void 0,v=qe(v),T=qe(T);class o extends P.$Uc{constructor(y,a){super(),this.m=a,this.a=new R.$le,this.b=new R.$le,this.c=new R.$le,this.f=new R.$le,this.g=new R.$le,this.h=new R.$le,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=y.getProxy(O.$KN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(S=>this.h.fire(S))),this.B(this.m.onDidChangeActiveTextEditor(S=>this.g.fire(S)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(y){const a=this.m.allEditors();return y?a:a.map(S=>S.value)}async showTextDocument(y,a,S){let d;typeof a=="number"?d={position:T.ViewColumn.from(a),preserveFocus:S}:typeof a=="object"?d={position:T.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selection:typeof a.selection=="object"?T.Range.from(a.selection):void 0,pinned:typeof a.preview=="boolean"?!a.preview:void 0}:d={preserveFocus:!1};const r=await this.j.$tryShowTextDocument(y.uri,d),s=r&&this.m.getEditor(r);if(s)return s.value;throw r?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}createTextEditorDecorationType(y,a){return new A.$rQ(this.j,y,a).value}$acceptEditorPropertiesChanged(y,a){const S=this.m.getEditor(y);if(!S)throw new Error("unknown text editor");if(a.options&&S._acceptOptions(a.options),a.selections){const d=a.selections.selections.map(T.Selection.to);S._acceptSelections(d)}if(a.visibleRanges){const d=v.$Gb(a.visibleRanges.map(T.Range.to));S._acceptVisibleRanges(d)}if(a.options&&this.b.fire({textEditor:S.value,options:{...a.options,lineNumbers:T.TextEditorLineNumbersStyle.to(a.options.lineNumbers)}}),a.selections){const d=p.TextEditorSelectionChangeKind.fromValue(a.selections.source),r=a.selections.selections.map(T.Selection.to);this.a.fire({textEditor:S.value,selections:r,kind:d})}if(a.visibleRanges){const d=v.$Gb(a.visibleRanges.map(T.Range.to));this.c.fire({textEditor:S.value,visibleRanges:d})}}$acceptEditorPositionData(y){for(const a in y){const S=this.m.getEditor(a);if(!S)throw new Error("Unknown text editor");const d=T.ViewColumn.to(y[a]);S.value.viewColumn!==d&&(S._acceptViewColumn(d),this.f.fire({textEditor:S.value,viewColumn:d}))}}getDiffInformation(y){return Promise.resolve(this.j.$getDiffInformation(y))}}e.$Ipc=o}),define(Ne[260],Le([1,0,2,3,5,4,7,8,18,37,14]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$urc=e.$trc=void 0,e.$trc=(0,R.$Fi)("IExtHostTimeline");class y{constructor(d,r){this.b=new Map,this.c=new Map,this.a=d.getProxy(P.$KN.MainThreadTimeline),r.registerArgumentProcessor({processArgument:(s,c)=>{if(s&&s.$mid===o.MarshalledId.TimelineActionContext)if(this.b.get(s.source)&&p.$rn.equals(c,this.b.get(s.source)?.extension)){const l=s.uri===void 0?void 0:v.URI.revive(s.uri);return this.c.get(s.source)?.get(a(l))?.get(s.handle)}else return;return s}})}async $getTimeline(d,r,s,c){return this.b.get(d)?.provider.provideTimeline(v.URI.revive(r),s,c)}registerTimelineProvider(d,r,s,c){const l=new O.$Tc,i=this.d(r.id,c,l).bind(this);let n;r.onDidChange&&(n=r.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:r.id}),this));const t=this.c;return this.f({...r,scheme:d,onDidChange:void 0,async provideTimeline(g,u,$){u?.resetCache&&(l.clear(),t.get(r.id)?.clear());const m=await r.provideTimeline(g,u,$);if(m==null)return;const h=i(g,u);return{...m,source:r.id,items:m.items.map(h)}},dispose(){for(const g of t.values())g.get(r.id)?.clear();n?.dispose(),l.dispose()}},s)}d(d,r,s){return(c,l)=>{let i;if(l?.cacheResults){let n=this.c.get(d);n===void 0&&(n=new Map,this.c.set(d,n));const t=a(c);i=n.get(t),i===void 0&&(i=new Map,n.set(t,i))}return n=>{const{iconPath:t,...g}=n,u=`${d}|${n.id??n.timestamp}`;i?.set(u,n);let $,m,h;n.iconPath&&(t instanceof A.$LO?h={id:t.id,color:t.color}:v.URI.isUri(t)?($=t,m=t):{light:$,dark:m}=t);let E;return A.$eO.isMarkdownString(g.tooltip)?E=T.MarkdownString.from(g.tooltip):(0,I.$eg)(g.tooltip)?E=g.tooltip:A.$eO.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=T.MarkdownString.from(g.detail)):(0,I.$eg)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=g.detail),{...g,id:g.id??void 0,handle:u,source:d,command:n.command?r.toInternal(n.command,s):void 0,icon:$,iconDark:m,themeIcon:h,tooltip:E,accessibilityInformation:n.accessibilityInformation}}}}f(d,r){if(this.b.get(d.id))throw new Error(`Timeline Provider ${d.id} already exists.`);return this.a.$registerTimelineProvider({id:d.id,label:d.label,scheme:d.scheme}),this.b.set(d.id,{provider:d,extension:r}),(0,O.$Sc)(()=>{for(const c of this.c.values())c.get(d.id)?.clear();this.b.delete(d.id),this.a.$unregisterTimelineProvider(d.id),d.dispose()})}}e.$urc=y;function a(S){return S?.toString()}}),define(Ne[261],Le([1,0,9,23,2,6,4,192,10,7,14,17,8,59,21,163,24]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vrc=void 0,o=qe(o);function c(n,t){if((0,I.$eg)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let g;return Array.isArray(n.highlights)&&(g=n.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),g=g.length?g:void 0),{label:n.label,highlights:g}}}class l extends A.$Uc{constructor(t,g,u){super(),this.f=t,this.g=g,this.h=u,this.a=new Map,this.b=new r.$O_;function $(m){return m&&m.$treeViewId&&(m.$treeItemHandle||m.$selectedTreeItems||m.$focusedTreeItem)}g.registerArgumentProcessor({processArgument:m=>$(m)?this.r(m):Array.isArray(m)&&m.length>0?m.map(h=>$(h)?this.r(h):h):m})}registerTreeDataProvider(t,g,u){const $=this.createTreeView(t,{treeDataProvider:g},u);return{dispose:()=>$.dispose()}}createTreeView(t,g,u){if(!g||!g.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const $=g.dragAndDropController?.dropMimeTypes??[],m=g.dragAndDropController?.dragMimeTypes??[],h=!!g.dragAndDropController?.handleDrag,E=!!g.dragAndDropController?.handleDrop,D=this.m(t,g,u),b={showCollapseAll:!!g.showCollapseAll,canSelectMany:!!g.canSelectMany,dropMimeTypes:$,dragMimeTypes:m,hasHandleDrag:h,hasHandleDrop:E,manuallyManageCheckboxes:!!g.manageCheckboxStateManually},C=this.f.$registerTreeViewDataProvider(t,b),k={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,s.$gH)(u,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,s.$gH)(u,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(f){(0,S.$6k)(f)&&(0,s.$gH)(u,"treeViewMarkdownMessage"),D.message=f},get title(){return D.title},set title(f){D.title=f},get description(){return D.description},set description(f){D.description=f},get badge(){return D.badge},set badge(f){f!==void 0&&o.ViewBadge.isViewBadge(f)?D.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(D.badge=void 0)},reveal:(f,w)=>D.reveal(f,w),dispose:async()=>{await C,this.a.delete(t),D.dispose()}};return this.B(k),k}$getChildren(t,g){const u=this.a.get(t);return u?u.getChildren(g):Promise.reject(new T.$CG(t))}async $handleDrop(t,g,u,$,m,h,E,D){const b=this.a.get(t);if(!b)return Promise.reject(new T.$CG(t));const C=a.DataTransfer.toDataTransfer(u,async k=>(await this.f.$resolveDropFileData(t,g,k)).buffer);return E===t&&D&&await this.j(C,b,D,m,h),b.onDrop(C,$,m)}async j(t,g,u,$,m){const h=this.b.removeDragOperationTransfer(m);if(h)(await h)?.forEach((E,D)=>{E&&t.set(D,E)});else if(m&&g.handleDrag){const E=g.handleDrag(u,t,$);this.b.addDragOperationTransfer(m,E),await E}return t}async $handleDrag(t,g,u,$){const m=this.a.get(t);if(!m)return Promise.reject(new T.$CG(t));const h=await this.j(new o.$HO,m,g,$,u);if(!(!h||$.isCancellationRequested))return a.DataTransfer.from(h)}async $hasResolve(t){const g=this.a.get(t);if(!g)throw new T.$CG(t);return g.hasResolve}$resolve(t,g,u){const $=this.a.get(t);if(!$)throw new T.$CG(t);return $.resolveTreeItem(g,u)}$setExpanded(t,g,u){const $=this.a.get(t);if(!$)throw new T.$CG(t);$.setExpanded(g,u)}$setSelectionAndFocus(t,g,u){const $=this.a.get(t);if(!$)throw new T.$CG(t);$.setSelectionAndFocus(g,u)}$setVisible(t,g){const u=this.a.get(t);if(!u){if(!g)return;throw new T.$CG(t)}u.setVisible(g)}$changeCheckboxState(t,g){const u=this.a.get(t);if(!u)throw new T.$CG(t);u.setCheckboxState(g)}m(t,g,u){const $=this.B(new i(t,g,this.f,this.g.converter,this.h,u));return this.a.set(t,$),$}r(t){const g=this.a.get(t.$treeViewId);return g&&"$treeItemHandle"in t?g.getExtensionElement(t.$treeItemHandle):g&&"$focusedTreeItem"in t&&t.$focusedTreeItem?g.focusedElement:null}}e.$vrc=l;class i extends A.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.$ng)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,g,u,$,m,h){if(super(),this.I=t,this.J=u,this.L=$,this.M=m,this.N=h,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$le),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$le),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$le),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$le),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$le),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$le),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$le),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new d.$we,h.contributes&&h.contributes.views)for(const C in h.contributes.views)for(const k of h.contributes.views[C])k.id===t&&(this.P=k.name);this.f=g.treeDataProvider,this.g=g.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(C=>{Array.isArray(C)&&C.length===0||this.F.fire({message:!1,element:C})}));let E,D;const b=O.Event.debounce(this.F.event,(C,k)=>(C||(C={message:!1,elements:[]}),k.element!==!1&&(E||(E=new Promise(f=>D=f),this.G=this.G.then(()=>E)),Array.isArray(k.element)?C.elements.push(...k.element):C.elements.push(k.element)),k.message&&(C.message=!0),C),200,!0);this.B(b(({message:C,elements:k})=>{k.length&&(this.H=this.H.then(()=>{const f=D;return E=null,this.$(k).then(()=>f())})),C&&this.J.$setMessage(this.I,a.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const g=t?this.getExtensionElement(t):void 0;if(t&&!g)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let u=this.X(t);return u||(u=await this.Y(g)),u?u.map($=>$.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,g){g=g||{select:!0,focus:!1};const u=(0,I.$ng)(g.select)?!0:g.select,$=(0,I.$ng)(g.focus)?!1:g.focus,m=(0,I.$ng)(g.expand)?!1:g.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(h=>this.W(t,h[h.length-1]).then(E=>this.J.$reveal(this.I,{item:E.item,parentChain:h.map(D=>D.item)},{select:u,focus:$,expand:m})),h=>this.M.error(h)):this.J.$reveal(this.I,void 0,{select:u,focus:$,expand:m})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=a.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,g){const u=this.getExtensionElement(t);u&&(g?this.u.fire(Object.freeze({element:u})):this.w.fire(Object.freeze({element:u})))}setSelectionAndFocus(t,g){const u=!(0,y.$tb)(this.s,t);this.s=t;const $=this.t!==g;this.t=g,u&&this.y.fire(Object.freeze({selection:this.selectedElements})),$&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const g=(await Promise.all(t.map(async u=>{const $=this.getExtensionElement(u.treeItemHandle);return $?{extensionItem:$,treeItem:await this.f.getTreeItem($),newState:u.newState?o.TreeItemCheckboxState.Checked:o.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);g.forEach(u=>{u.treeItem.checkboxState=u.newState?o.TreeItemCheckboxState.Checked:o.TreeItemCheckboxState.Unchecked}),this.D.fire({items:g.map(u=>[u.extensionItem,u.newState])})}async handleDrag(t,g,u){const $=[];for(const m of t){const h=this.getExtensionElement(m);h&&$.push(h)}if(!(!this.g?.handleDrag||$.length===0))return await this.g.handleDrag($,g,u),g}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,g,u){const $=g?this.getExtensionElement(g):void 0;if(!(!$&&g||!this.g?.handleDrop))return(0,p.$xh)(()=>this.g?.handleDrop?this.g.handleDrop($,t,u):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,g){if(!this.f.resolveTreeItem)return;const u=this.j.get(t);if(u){const $=this.m.get(u);if($){const m=await this.f.resolveTreeItem($.extensionItem,u,g)??$.extensionItem;return this.hb(m),$.item.tooltip=this.eb(m.tooltip),$.item.command=this.fb($.disposableStore,m.command),$.item}}}S(t){return this.U(t).then(g=>g?this.S(g).then(u=>this.W(g,u[u.length-1]).then($=>(u.push($),u))):Promise.resolve([]))}U(t){const g=this.m.get(t);return g?Promise.resolve(g.parent?this.j.get(g.parent.item.handle):void 0):(0,p.$xh)(()=>this.f.getParent(t))}W(t,g){const u=this.m.get(t);return u?Promise.resolve(u):(0,p.$xh)(()=>this.f.getTreeItem(t)).then($=>this.kb(t,$,g,!0)).then($=>this.getChildren(g?g.item.handle:void 0).then(()=>{const m=this.getExtensionElement($);if(m){const h=this.m.get(m);if(h)return Promise.resolve(h)}throw new Error(`Cannot resolve tree item for element ${$} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let g;if(typeof t=="string"){const u=this.getExtensionElement(t);g=u?this.m.get(u):void 0}else g=t;return g&&g.children||void 0}return this.h}async Y(t){this.rb(t);const g=new d.$we(this.Z.token);try{const u=t?this.m.get(t):void 0,$=await this.f.getChildren(t);if(g.token.isCancellationRequested)return;const m=(0,y.$Gb)($||[]),h=await Promise.all((0,y.$Gb)(m).map(D=>this.f.getTreeItem(D)));if(g.token.isCancellationRequested)return;const E=h.map((D,b)=>D?this.db(m[b],D,u):null);return(0,y.$Gb)(E)}finally{g.dispose()}}$(t){if(t.some(u=>!u))return this.Z.dispose(!0),this.Z=new d.$we,this.tb(),this.J.$refresh(this.I);{const u=this.ab(t);if(u.length)return this.bb(u)}return Promise.resolve(void 0)}ab(t){const g=new Set,u=t.map(m=>this.m.get(m));for(const m of u)if(m&&!g.has(m.item.handle)){let h=m;for(;h&&h.parent&&u.findIndex(E=>h&&h.parent&&E&&E.item.handle===h.parent.item.handle)===-1;){const E=this.j.get(h.parent.item.handle);h=E?this.m.get(E):void 0}h&&!h.parent&&g.add(m.item.handle)}const $=[];return g.forEach(m=>{const h=this.j.get(m);if(h){const E=this.m.get(h);E&&(!E.parent||!g.has(E.parent.item.handle))&&$.push(m)}}),$}bb(t){const g={};return Promise.all(t.map(u=>this.cb(u).then($=>{$&&(g[u]=$.item)}))).then(()=>Object.keys(g).length?this.J.$refresh(this.I,g):void 0)}cb(t){const g=this.getExtensionElement(t);if(g){const u=this.m.get(g);if(u)return this.rb(g),(0,p.$xh)(()=>this.f.getTreeItem(g)).then($=>{if($){const m=this.ib(g,$,u.parent);return this.pb(g,m,u,u.parent),u.dispose(),m}return null})}return Promise.resolve(null)}db(t,g,u){const $=this.ib(t,g,u);if(g.id&&this.j.has($.item.handle))throw new Error((0,v.localize)(10823,null,g.id));return this.ob(t,$),this.qb($,u),$}eb(t){return o.$eO.isMarkdownString(t)?a.MarkdownString.from(t):t}fb(t,g){return g?{...this.L.toInternal(g,t),originalId:g.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let g,u,$;return typeof t.checkboxState=="number"?g=t.checkboxState:(g=t.checkboxState.state,u=t.checkboxState.tooltip,$=t.checkboxState.accessibilityInformation),{isChecked:g===o.TreeItemCheckboxState.Checked,tooltip:u,accessibilityInformation:$}}hb(t){if(!o.$CO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,g,u){this.hb(g);const $=this.B(new A.$Tc),m=this.kb(t,g,u),h=this.lb(g);return{item:{handle:m,parentHandle:u?u.item.handle:void 0,label:c(g.label,this.N),description:g.description,resourceUri:g.resourceUri,tooltip:this.eb(g.tooltip),command:this.fb($,g.command),contextValue:g.contextValue,icon:h,iconDark:this.mb(g)||h,themeIcon:this.jb(g),collapsibleState:(0,I.$ng)(g.collapsibleState)?o.TreeItemCollapsibleState.None:g.collapsibleState,accessibilityInformation:g.accessibilityInformation,checkbox:this.gb(g)},extensionItem:g,parent:u,children:void 0,disposableStore:$,dispose(){$.dispose()}}}jb(t){return t.iconPath instanceof o.$LO?t.iconPath:void 0}kb(t,{id:g,label:u,resourceUri:$},m,h){if(g)return`${i.b}/${g}`;const E=c(u,this.N),D=m?m.item.handle:i.a;let b=E?E.label:$?(0,R.$dh)($):"";b=b.indexOf("/")!==-1?b.replace("/","//"):b;const C=this.m.has(t)?this.m.get(t).item.handle:void 0,k=this.X(m)||[];let f,w=0;do{if(f=`${D}/${w}:${b}`,h||!this.j.has(f)||C===f)break;w++}while(w<=k.length);return f}lb(t){if(t.iconPath&&!(t.iconPath instanceof o.$LO))return typeof t.iconPath=="string"||P.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof o.$LO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return P.URI.isUri(t)?t:P.URI.file(t)}ob(t,g){this.j.set(g.item.handle,t),this.m.set(t,g)}pb(t,g,u,$){this.j.delete(g.item.handle),this.m.delete(t),g.item.handle!==u.item.handle&&this.j.delete(u.item.handle),this.ob(t,g);const m=this.X($)||[],h=m.filter(E=>E.item.handle===u.item.handle)[0];h&&m.splice(m.indexOf(h),1,g)}qb(t,g){g?(g.children||(g.children=[]),g.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const g=this.m.get(t);if(g){if(g.children)for(const u of g.children){const $=this.j.get(u.item.handle);$&&this.sb($)}g.children=void 0}}else this.tb()}sb(t){const g=this.m.get(t);if(g){if(g.children)for(const u of g.children){const $=this.j.get(u.item.handle);$&&this.sb($)}this.m.delete(t),this.j.delete(g.item.handle),g.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ne[262],Le([1,0,6,4,2,38,8,67,5,7]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2pc=void 0,A=qe(A),p=qe(p),o=qe(o);class I extends R.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(d,r,s,c){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new v.$le),this.onDidDispose=this.#d.event,this.#h=this.B(new v.$le),this.onDidChangeViewState=this.#h.event,this.#e=d,this.#t=r,this.#n=s,this.#i=c.viewType,this.#s=c.panelOptions,this.#o=c.viewColumn,this.#r=c.title,this.#l=c.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(d){this.c(),this.#r!==d&&(this.#r=d,this.#t.$setTitle(this.#e,d))}get iconPath(){return this.c(),this.#a}set iconPath(d){this.c(),this.#a!==d&&(this.#a=d,this.#t.$setIconPath(this.#e,P.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(d){this.#u||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(this.#l=d.active,this.#c=d.visible,this.#o=d.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(d,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof d>"u"?void 0:A.ViewColumn.from(d),preserveFocus:!!r})}c(){if(this.#u)throw new Error("Webview is disposed")}}class y extends R.$Uc{static c(){return(0,O.$2g)()}constructor(d,r,s){super(),this.j=r,this.m=s,this.g=new Map,this.h=new Map,this.f=d.getProxy(p.$KN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(d=>d.dispose()),this.g.clear()}createWebviewPanel(d,r,s,c,l={}){const i=typeof c=="object"?c.viewColumn:c,n={viewColumn:A.ViewColumn.from(i),preserveFocus:typeof c=="object"&&!!c.preserveFocus},t=(0,T.$Xpc)(d),g=y.c();this.f.$createWebviewPanel((0,T.$Zpc)(d),g,r,{title:s,panelOptions:a(l),webviewOptions:(0,T.$1pc)(d,this.m,l),serializeBuffersForPostMessage:t},n);const u=this.j.createNewWebview(g,l,d);return this.createNewWebviewPanel(g,r,s,i,l,u,!0)}$onDidChangeWebviewPanelViewStates(d){const r=Object.keys(d);r.sort((s,c)=>{const l=d[s],i=d[c];return l.active?1:i.active?-1:+l.visible-+i.visible});for(const s of r){const c=this.getWebviewPanel(s);if(!c)continue;const l=d[s];c._updateViewState({active:l.active,visible:l.visible,viewColumn:A.ViewColumn.to(l.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.g.delete(d),this.j.deleteWebview(d)}registerWebviewPanelSerializer(d,r,s){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:s,extension:d}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,T.$Xpc)(d)}),new o.$MN(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(d,r,s,c){const l=this.h.get(r);if(!l)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:n}=l,t=this.j.createNewWebview(d,s.webviewOptions,n),g=this.createNewWebviewPanel(d,r,s.title,c,s.panelOptions,t,s.active);await i.deserializeWebviewPanel(g,s.state)}createNewWebviewPanel(d,r,s,c,l,i,n){const t=new I(d,this.f,i,{viewType:r,title:s,viewColumn:c,panelOptions:l,active:n});return this.g.set(d,t),t}getWebviewPanel(d){return this.g.get(d)}}e.$2pc=y;function a(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(Ne[263],Le([1,0,6,4,67,8,5,7]),function(ve,e,v,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yrc=void 0,A=qe(A),T=qe(T);class p extends R.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,a,S,d,r,s){super(),this.#s=!1,this.#l=this.B(new v.$le),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new v.$le),this.onDidDispose=this.#u.event,this.#i=S,this.#a=d,this.#e=y,this.#t=a,this.#n=r,this.#r=s}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class o{constructor(y,a){this.d=a,this.b=new Map,this.c=new Map,this.a=y.getProxy(A.$KN.MainThreadWebviewViews)}registerWebviewViewProvider(y,a,S,d){if(this.b.has(a))throw new Error(`View provider for '${a}' already registered`);return this.b.set(a,{provider:S,extension:y}),this.a.$registerWebviewViewProvider((0,P.$Zpc)(y),a,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$Xpc)(y)}),new T.$MN(()=>{this.b.delete(a),this.a.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(y,a,S,d,r){const s=this.b.get(a);if(!s)throw new Error(`No view provider found for '${a}'`);const{provider:c,extension:l}=s,i=this.d.createNewWebview(y,{},l),n=new p(y,this.a,a,S,i,!0);this.c.set(y,n),await c.resolveWebviewView(n,{state:d},r)}async $onDidChangeWebviewViewVisibility(y,a){this.e(y)._setVisible(a)}async $disposeWebviewView(y){const a=this.e(y);this.c.delete(y),a.dispose(),this.d.deleteWebview(y)}e(y){const a=this.c.get(y);if(!a)throw new Error("No webview found");return a}}e.$yrc=o}),define(Ne[264],Le([1,0,6,30,31,3]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=e.$6M=e.OutputChannelUpdateMode=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=void 0,e.$SM="text/x-code-output",e.$TM="output",e.$UM="Log",e.$VM="text/x-code-log-output",e.$WM="log",e.$XM="workbench.panel.output",e.$YM=new P.$Wj("inOutput",!1),e.$ZM=new P.$Wj("activeLogOutput",!1),e.$1M=new P.$Wj("activeLogOutput.levelSettable",!1),e.$2M=new P.$Wj("activeLogOutput.level",""),e.$3M=new P.$Wj("activeLogOutput.levelIsDefault",!1),e.$4M=new P.$Wj("outputView.scrollLock",!1),e.$5M=(0,O.$Fi)("outputService");var A;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$6M={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new v.$le,this.onDidRegisterChannel=this.b.event,this.c=new v.$le,this.onDidRemoveChannel=this.c.event}registerChannel(o){this.a.has(o.id)||(this.a.set(o.id,o),this.b.fire(o.id))}getChannels(){const o=[];return this.a.forEach(I=>o.push(I)),o}getChannel(o){return this.a.get(o)}removeChannel(o){this.a.delete(o),this.c.fire(o)}}R.$ro.add(e.$6M.OutputChannels,new T),e.$7M=new P.$Wj("activeOutputChannel","")}),define(Ne[128],Le([1,0,5,3,16,18,11,264,68,26,50,165,22,14,29,6,4]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$crc=e.$brc=void 0;class c extends A.$gk{get disposed(){return this.n}constructor(t,g,u,$,m){super(),this.id=t,this.name=g,this.r=u,this.s=$,this.extension=m,this.m=0,this.n=!1,this.visible=!1,this.setLevel(u.getLevel()),this.B(u.onDidChangeLogLevel(h=>this.setLevel(h)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Clear,t)}replace(t){const g=this.m;this.info(t),this.s.$update(this.id,T.OutputChannelUpdateMode.Replace,g),this.visible&&this.r.flush()}show(t,g){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:g))}hide(){this.s.$close(this.id)}g(t,g){this.m+=a.$Ne.fromString(g).byteLength,(0,A.log)(this.r,t,g),this.visible&&(this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class l extends c{appendLine(t){this.append(t)}}let i=class{constructor(t,g,u,$,m,h){this.i=g,this.j=u,this.k=$,this.l=m,this.m=h,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(v.$KN.MainThreadOutputService),this.b=this.k.extUri.joinPath(g.logsLocation,`output_logging_${(0,y.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[g,u]of this.g)u.visible=g===this.h}createOutputChannel(t,g,u){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const $=typeof g=="object"&&g.log,m=(0,S.$eg)(g)?g:void 0;if((0,S.$eg)(m)&&!m.trim())throw new Error("illegal argument `languageId`. must not be empty");let h;const E=this.i.environment.extensionLogLevel?.find(([b])=>O.$rn.equals(u.identifier,b))?.[1];E&&(h=(0,A.$rk)(E));const D=$?this.o(t,h,u):this.n(t,m,u);return D.then(b=>{this.g.set(b.id,b),b.visible=b.id===this.h}),$?this.r(t,h??this.m.getLevel(),D):this.q(t,D)}async n(t,g,u){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const $=await this.c,m=this.k.extUri.joinPath($,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),h=this.l.createLogger(m,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),E=await this.a.$register(t,m,g,u.identifier.value);return new c(E,t,h,this.a,u)}async o(t,g,u){const $=await this.p(u),m=t.replace(/[\\/:\*\?"<>\|]/g,""),h=this.k.extUri.joinPath($,`${m}.log`),E=`${u.identifier.value}.${m}`,D=this.l.createLogger(h,{id:E,name:t,logLevel:g,extensionId:u.identifier.value});return new l(E,t,D,this.a,u)}p(t){let g=this.d.get(t.identifier.value);if(!g){const u=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,g=(async()=>{try{await this.j.value.createDirectory(u)}catch($){if((0,d.$ql)($)!==d.FileSystemProviderErrorCode.FileExists)throw $}return u})())}return g}q(t,g){let u=!1;const $=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return t},append(m){$(),g.then(h=>h.append(m))},appendLine(m){$(),g.then(h=>h.appendLine(m))},clear(){$(),g.then(m=>m.clear())},replace(m){$(),g.then(h=>h.replace(m))},show(m,h){$(),g.then(E=>E.show(m,h))},hide(){$(),g.then(m=>m.hide())},dispose(){u=!0,g.then(m=>m.dispose())}}}r(t,g,u){const $=new s.$Tc,m=()=>{if($.isDisposed)throw new Error("Channel has been closed")},h=$.add(new r.$le);function E(D){g=D,h.fire(D)}return u.then(D=>{$.add(D),D.logLevel!==g&&E(D.logLevel),$.add(D.onDidChangeLogLevel(b=>E(b)))}),{...this.q(t,u),get logLevel(){return g},onDidChangeLogLevel:h.event,trace(D,...b){m(),u.then(C=>C.trace(D,...b))},debug(D,...b){m(),u.then(C=>C.debug(D,...b))},info(D,...b){m(),u.then(C=>C.info(D,...b))},warn(D,...b){m(),u.then(C=>C.warn(D,...b))},error(D,...b){m(),u.then(C=>C.error(D,...b))},dispose(){$.dispose()}}}};e.$brc=i,e.$brc=i=Je([Ve(0,P.$kQ),Ve(1,o.$AQ),Ve(2,p.$Tpc),Ve(3,I.$wpc),Ve(4,A.$bk),Ve(5,A.$ak)],i),e.$crc=(0,R.$Fi)("IExtHostOutputService")}),define(Ne[129],Le([1,0,3,10]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=void 0,e.$Wm=(0,v.$Fi)("remoteAgentService"),e.$Xm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let O=1/0;for(let T=0;T<this.maxSampleCount;T++){const p=await P.getRoundTripTime();if(p===void 0)return;O=Math.min(O,p/2),await(0,R.$Gh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(O):A=this.initial.reduce((T,p)=>T+p,0)/this.initial.length,this.lastMeasurement={initial:A,current:O,average:this.average.reduce((T,p)=>T+p,0)/this.average.length,high:typeof A>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ne[265],Le([1,0,9,53,30,49,43,4,6,129,20,25,10,113]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=void 0,e.$dL=Object.freeze({id:"application",order:100,title:(0,v.localize)(12547,null),type:"object"}),e.$eL=Object.freeze({id:"workbench",order:7,title:(0,v.localize)(12548,null),type:"object"}),e.$fL=Object.freeze({id:"security",scope:R.ConfigurationScope.APPLICATION,title:(0,v.localize)(12549,null),type:"object",order:7}),e.$gL=Object.freeze({id:"problems",title:(0,v.localize)(12550,null),type:"object",order:101}),e.$hL=Object.freeze({id:"window",order:8,title:(0,v.localize)(12551,null),type:"object"}),e.$iL={ConfigurationMigration:"base.contributions.configuration.migration"};class d{constructor(){this.migrations=[],this.a=new p.$le,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const r=new d;P.$ro.add(e.$iL.ConfigurationMigration,r);let s=class extends T.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,t){super(),this.a=n,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async g=>{for(const u of g.added)await this.f(u,r.migrations)})),this.c(r.migrations),this.B(r.onDidRegisterConfigurationMigration(g=>this.c(g)))}async c(n){await this.f(void 0,n);for(const t of this.b.getWorkspace().folders)await this.f(t,n)}async f(n,t){await Promise.all([t.map(g=>this.g(g,n?.uri))])}async g(n,t){const g=this.a.inspect(n.key,{resource:t}),u=this.b.getWorkbenchState()===O.WorkbenchState.WORKSPACE?[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE],["workspaceFolder",A.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE]];for(const[$,m]of u){const h=g[$];if(!h)continue;const E=[];if(h.value!==void 0){const D=await this.h(n,$,h.value,t,void 0);for(const b of D??[])E.push([b,[]])}for(const{identifiers:D,value:b}of h.overrides??[])if(b!==void 0){const C=await this.h(n,$,b,t,D);for(const k of C??[])E.push([k,D])}E.length&&await Promise.allSettled(E.map(async([[D,b],C])=>this.a.updateValue(D,b.value,{resource:t,overrideIdentifiers:C},m)))}}async h(n,t,g,u,$){const m=E=>{const b=this.a.inspect(E,{resource:u})[t];if(b)return $?b.overrides?.find(({identifiers:C})=>(0,y.$io)(C,$))?.value:b.value},h=await n.migrateFn(g,m);return Array.isArray(h)?h:[[n.key,h]]}};e.$jL=s,e.$jL=s=Je([Ve(0,A.$_i),Ve(1,O.$Oi)],s);let c=class extends T.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new a.$3h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$j&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;P.$ro.as(R.$wo.Configuration).registerConfiguration({...e.$fL,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,v.localize)(12552,null)},default:[],markdownDescription:(0,v.localize)(12553,null),scope:R.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,v.localize)(12554,null),scope:R.ConfigurationScope.MACHINE}}})}};e.$kL=c,e.$kL=c=Je([Ve(0,o.$Wm)],c),e.$lL="window.newWindowProfile";let l=class extends T.$Uc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(n,t){super(),this.c=n,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(g=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(g=>{g.source!==A.ConfigurationTarget.DEFAULT&&g.affectsConfiguration(e.$lL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const n=P.$ro.as(R.$wo.Configuration),t={...e.$hL,properties:{[e.$lL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(g=>g.name),null],enumItemLabels:[...this.c.profiles.map(g=>""),(0,v.localize)(12555,null)],description:(0,v.localize)(12556,null),scope:R.ConfigurationScope.APPLICATION}}};this.a?n.updateConfigurations({add:[t],remove:[this.a]}):n.registerConfiguration(t),this.a=t}h(){const n=this.f.getValue(e.$lL);this.b=n?this.c.profiles.find(t=>t.name===n):void 0}j(){const n=this.f.getValue(e.$lL);if(!n)return;const t=this.b?this.c.profiles.find(g=>g.id===this.b.id):void 0;n!==t?.name&&this.f.updateValue(e.$lL,t?.name)}};e.$mL=l,e.$mL=l=Je([Ve(0,S.$Ml),Ve(1,A.$_i)],l)}),define(Ne[266],Le([1,0,41,15,19,23,9,265,53,3,30]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$oL=e.$nL=void 0,e.$pL=r,e.$qL=s,v=qe(v),e.$nL=(0,o.$Fi)("editorResolverService"),e.$oL="workbench.editorAssociations";const y=I.$ro.as(p.$wo.Configuration),a={...T.$eL,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(2025,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(a);var S;(function(c){c.builtin="builtin",c.option="option",c.exclusive="exclusive",c.default="default"})(S||(e.RegisteredEditorPriority=S={}));var d;(function(c){c[c.ABORT=1]="ABORT",c[c.NONE=2]="NONE"})(d||(e.ResolvedStatus=d={}));function r(c){switch(c){case S.exclusive:return 5;case S.default:return 4;case S.builtin:return 3;case S.option:default:return 1}}function s(c,l){if(new Set([R.Schemas.extension,R.Schemas.webviewPanel,R.Schemas.vscodeWorkspaceTrust,R.Schemas.vscodeSettings]).has(l.scheme))return!1;const t=typeof c=="string"&&c.indexOf(P.$gc.sep)>=0?`${l.scheme}:${l.path}`:(0,O.$dh)(l);return v.$zk(typeof c=="string"?c.toLowerCase():c,t.toLowerCase())}}),define(Ne[267],Le([1,0,51,15,19,20,23,2,3,186,49,205,129]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=e.$mN=void 0,e.$mN=(0,p.$Fi)("pathService");let d=S=class{constructor(s,c,l,i){this.d=s,this.e=c,this.f=l,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const n=await this.e.getEnvironment();return this.c=n?.userHome??s})()}hasValidBasename(s,c,l){return typeof c=="string"||typeof c>"u"?this.a.then(i=>this.h(s,i,c)):this.h(s,c,l)}h(s,c,l){return s.scheme===R.Schemas.file||s.scheme===R.Schemas.vscodeRemote?(0,v.$Cg)(l??(0,A.$dh)(s),c===O.OperatingSystem.Windows):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(s,c){if(s.remoteAuthority)return R.Schemas.vscodeRemote;const l=(0,o.$jN)(c.getWorkspace());if(l)return l;const i=c.getWorkspace().folders[0];if(i)return i.uri.scheme;const n=c.getWorkspace().configuration;return n?n.scheme:R.Schemas.file}userHome(s){return s?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(s=>s===O.OperatingSystem.Windows?P.$fc:P.$gc)}async fileURI(s){let c="";if(await this.a===O.OperatingSystem.Windows&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const i=s.indexOf("/",2);i===-1?(c=s.substring(2),s="/"):(c=s.substring(2,i),s=s.substring(i)||"/")}return T.URI.from({scheme:R.Schemas.file,authority:c,path:s,query:"",fragment:""})}};e.$nN=d,e.$nN=d=S=Je([Ve(1,a.$Wm),Ve(2,y.$8M),Ve(3,I.$Oi)],d)}),define(Ne[130],Le([1,0,17]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageTypeNew=e.ExcludeSettingOptions=e.$ZL=e.$YL=e.TextSearchCompleteMessageType=e.$XL=e.$WL=void 0,e.$1L=y;class R{constructor(S,d){this.line=S,this.character=d}isBefore(S){return!1}isBeforeOrEqual(S){return!1}isAfter(S){return!1}isAfterOrEqual(S){return!1}isEqual(S){return!1}compareTo(S){return 0}translate(S,d){return new R(0,0)}with(S){return new R(0,0)}}e.$WL=R;class P{constructor(S,d,r,s){this.isEmpty=!1,this.isSingleLine=!1,this.start=new R(S,d),this.end=new R(r,s)}contains(S){return!1}isEqual(S){return!1}intersection(S){}union(S){return new P(0,0,0,0)}with(S){return new P(0,0,0,0)}}e.$XL=P;var O;(function(a){a[a.Information=1]="Information",a[a.Warning=2]="Warning"})(O||(e.TextSearchCompleteMessageType=O={}));class A{constructor(S,d,r){this.uri=S,this.ranges=d,this.previewText=r}}e.$YL=A;class T{constructor(S,d,r){this.uri=S,this.text=d,this.lineNumber=r}}e.$ZL=T;var p;(function(a){a[a.none=1]="none",a[a.filesExclude=2]="filesExclude",a[a.searchAndFilesExclude=3]="searchAndFilesExclude"})(p||(e.ExcludeSettingOptions=p={}));var o;(function(a){a[a.Information=1]="Information",a[a.Warning=2]="Warning"})(o||(e.TextSearchCompleteMessageTypeNew=o={}));function I(a){return"uri"in a&&"ranges"in a&&"preview"in a}function y(a){if(I(a)){const S=(0,v.$1b)(a.ranges).map(d=>({sourceRange:d,previewRange:d}));return new A(a.uri,S,a.preview.text)}else return new T(a.uri,a.text,a.lineNumber)}}),define(Ne[44],Le([1,0,17,41,25,51,12,3,19,13,130,10]),function(ve,e,v,R,P,O,A,T,p,o,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oM=e.$mM=e.$fM=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$cM=e.$bM=e.$aM=e.$_L=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.TextSearchCompleteMessageType=void 0,e.$9L=c,e.$0L=l,e.$$L=i,e.$dM=D,e.$eM=b,e.$gM=f,e.$hM=w,e.$iM=F,e.$jM=N,e.$kM=L,e.$lM=q,e.$nM=W,e.$pM=ae,e.$qM=be,R=qe(R),P=qe(P),O=qe(O),p=qe(p),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$2L="workbench.view.search",e.$3L="workbench.panel.search",e.$4L="workbench.view.search",e.$5L="search-result",e.$6L="search.exclude",e.$7L=2e4;const a="\u27EA ",S=" characters skipped \u27EB",d=(a.length+S.length+5)*2;e.$8L=(0,T.$Fi)("searchService");var r;(function(_){_[_.file=0]="file",_[_.text=1]="text",_[_.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var s;(function(_){_[_.File=1]="File",_[_.Text=2]="Text",_[_.aiText=3]="aiText"})(s||(e.QueryType=s={}));function c(_){return!!_.preview}function l(_){return!!_.resource}function i(_){return!!_.message}var n;(function(_){_[_.Normal=0]="Normal",_[_.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class t{constructor(ce){this.resource=ce,this.results=[]}}e.$_L=t;class g{constructor(ce,me,oe,ke){this.ranges=me,this.webviewIndex=ke;const Te=Array.isArray(me)?me:[me];if(oe&&oe.matchLines===1&&u(Te)){ce=(0,A.$0f)(ce,oe.matchLines);let Y="",B=0,ne=0;const Ee=Math.floor(oe.charsPerLine/5),fe=[];for(const we of Te){const he=Math.max(we.startColumn-Ee,0),X=we.startColumn+oe.charsPerLine;if(he>ne+Ee+d){const x=a+(he-ne)+S;Y+=x+ce.slice(he,X),B+=he-(ne+x.length)}else Y+=ce.slice(ne,X);fe.push(new m(0,we.startColumn-B,we.endColumn-B)),ne=X}this.preview={text:Y,matches:Array.isArray(this.ranges)?fe:fe[0]}}else{const Y=Array.isArray(me)?me[0].startLineNumber:me.startLineNumber;this.preview={text:ce,matches:(0,v.$Zb)(me,B=>new $(B.startLineNumber-Y,B.startColumn,B.endLineNumber-Y,B.endColumn))}}}}e.$aM=g;function u(_){const ce=_[0].startLineNumber;for(const me of _)if(me.startLineNumber!==ce||me.endLineNumber!==ce)return!1;return!0}class ${constructor(ce,me,oe,ke){this.startLineNumber=ce,this.startColumn=me,this.endLineNumber=oe,this.endColumn=ke}}e.$bM=$;class m extends ${constructor(ce,me,oe){super(ce,me,ce,oe)}}e.$cM=m;var h;(function(_){_.List="list",_.Tree="tree"})(h||(e.ViewMode=h={}));var E;(function(_){_.Default="default",_.FileNames="fileNames",_.Type="type",_.Modified="modified",_.CountDescending="countDescending",_.CountAscending="countAscending"})(E||(e.SearchSortOrder=E={}));function D(_,ce=!0){const me=_&&_.files&&_.files.exclude,oe=ce&&_&&_.search&&_.search.exclude;if(!me&&!oe)return;if(!me||!oe)return me||oe||void 0;let ke=Object.create(null);return ke=P.$ho(ke,P.$eo(me)),ke=P.$ho(ke,P.$eo(oe),!0),ke}function b(_,ce){return _.excludePattern&&R.$zk(_.excludePattern,ce)?!1:_.includePattern||_.usingSearchPaths?_.includePattern&&R.$zk(_.includePattern,ce)?!0:_.usingSearchPaths?!!_.folderQueries&&_.folderQueries.some(me=>{const oe=me.folder.fsPath;if(O.$Eg(ce,oe)){const ke=p.$lc(oe,ce);return!me.includePattern||!!R.$zk(me.includePattern,ke)}else return!1}):!1:!0}var C;(function(_){_[_.unknownEncoding=1]="unknownEncoding",_[_.regexParseError=2]="regexParseError",_[_.globParseError=3]="globParseError",_[_.invalidLiteral=4]="invalidLiteral",_[_.rgProcessError=5]="rgProcessError",_[_.other=6]="other",_[_.canceled=7]="canceled"})(C||(e.SearchErrorCode=C={}));class k extends Error{constructor(ce,me){super(ce),this.code=me}}e.$fM=k;function f(_){const ce=_.message;if((0,o.$3)(_))return new k(ce,C.canceled);try{const me=JSON.parse(ce);return new k(me.message,me.code)}catch{return new k(ce,C.other)}}function w(_){const ce={message:_.message,code:_.code};return new Error(JSON.stringify(ce))}function F(_){return _.type==="error"?!0:_.type==="success"}function N(_){return _.type==="success"}function L(_){return!!_.path}function q(_,ce,me=!0){const oe=_.searchPath?_.searchPath:_.relativePath;return me?(0,A.$7f)(oe,ce):R.$zk(ce,oe)}class H{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$mM=H;function W(_,ce){const me={..._||{},...ce||{}};return Object.keys(me).filter(oe=>{const ke=me[oe];return typeof ke=="boolean"&&ke})}class G{constructor(ce,me){this.c=null,this.a={...ce.excludePattern||{},...me.excludePattern||{}},this.b=R.$Ak(this.a);let oe=ce.includePattern;me.includePattern&&(oe?oe={...oe,...me.includePattern}:oe=me.includePattern),oe&&(this.c=R.$Ak(oe))}matchesExcludesSync(ce,me,oe){return!!(this.b&&this.b(ce,me,oe))}includedInQuerySync(ce,me,oe){return!(this.b&&this.b(ce,me,oe)||this.c&&!this.c(ce,me,oe))}includedInQuery(ce,me,oe){const ke=this.b(ce,me,oe),Te=()=>this.c?!!this.c(ce,me,oe):!0;return(0,y.$rh)(ke)?ke.then(Y=>Y?!1:Te()):Te()}hasSiblingExcludeClauses(){return Q(this.a)}}e.$oM=G;function Q(_){for(const ce in _)if(typeof _[ce]!="boolean")return!0;return!1}function ae(_){if(!_)return;let ce;return me=>(ce||(ce=(_()||Promise.resolve([])).then(oe=>oe?le(oe):{})),ce.then(oe=>!!oe[me]))}function be(_){if(!_)return;let ce;return me=>{if(!ce){const oe=_();ce=oe?le(oe):{}}return!!ce[me]}}function le(_){const ce={};for(const me of _)ce[me]=!0;return ce}}),define(Ne[45],Le([1,0,17,10,21,6,4,58,15,140,23,12,2,9,29,3,11,173,49,50,26,16,8,7,65,44,5,36]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n,t,g,u,$,m,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Opc=e.$Npc=void 0;function D(L,q,H){return new I.$8g(W=>f(W,H)).isEqual(L,q)}function b(L,q,H){return D(L.uri,q.uri,H)?0:(0,y.$yf)(L.uri.toString(),q.uri.toString())}function C(L,q,H){return L.index!==q.index?L.index<q.index?-1:1:D(L.uri,q.uri,H)?(0,y.$yf)(L.name,q.name):(0,y.$yf)(L.uri.toString(),q.uri.toString())}function k(L,q,H,W){const G=L.slice(0).sort((ae,be)=>H(ae,be,W)),Q=q.slice(0).sort((ae,be)=>H(ae,be,W));return(0,v.$Db)(G,Q,(ae,be)=>H(ae,be,W))}function f(L,q){const H=q.getCapabilities(L.scheme);return!(H&&H&d.FileSystemProviderCapabilities.PathCaseSensitive)}class w extends l.$Yi{static toExtHostWorkspace(q,H,W,G){if(!q)return{workspace:null,added:[],removed:[]};const{id:Q,name:ae,folders:be,configuration:le,transient:_,isUntitled:ce}=q,me=[],oe=H;H?be.forEach((B,ne)=>{const Ee=a.URI.revive(B.uri),fe=w.o(W||H,Ee,G);fe?(fe.name=B.name,fe.index=B.index,me.push(fe)):me.push({uri:Ee,name:B.name,index:ne})}):me.push(...be.map(({uri:B,name:ne,index:Ee})=>({uri:a.URI.revive(B),name:ne,index:Ee}))),me.sort((B,ne)=>B.index<ne.index?-1:1);const ke=new w(Q,ae,me,!!_,le?a.URI.revive(le):null,!!ce,B=>f(B,G)),{added:Te,removed:Y}=k(oe?oe.workspaceFolders:[],ke.workspaceFolders,b,G);return{workspace:ke,added:Te,removed:Y}}static o(q,H,W){for(let G=0;G<q.folders.length;G++){const Q=q.workspaceFolders[G];if(D(Q.uri,H,W))return Q}}constructor(q,H,W,G,Q,ae,be){super(q,W.map(le=>new l.$Zi(le)),G,Q,be),this.t=H,this.u=ae,this.q=[],this.s=T.$Li.forUris(be,()=>!0),W.forEach(le=>{this.q.push(le),this.s.set(le.uri,le)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(q,H){return H&&this.s.get(q)&&(q=(0,I.$fh)(q)),this.s.findSubstr(q)}resolveWorkspaceFolder(q){return this.s.get(q)}}let F=class{constructor(q,H,W,G,Q){this.c=new O.$le,this.onDidChangeWorkspace=this.c.event,this.g=new O.$le,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$ne,this.C=new Map,this.h=G,this.s=W,this.t=Q,this.j=new o.$Nm,this.k=new R.$Eh,this.o=q.getProxy(h.$KN.MainThreadWorkspace),this.q=q.getProxy(h.$KN.MainThreadMessageService);const ae=H.workspace;this.l=ae?new w(ae.id,ae.name,[],!!ae.transient,ae.configuration?a.URI.revive(ae.configuration):null,!!ae.isUntitled,be=>f(be,W)):void 0}$initializeWorkspace(q,H){this.v=H,this.$acceptWorkspaceData(q),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?a.URI.from({scheme:p.Schemas.untitled,path:(0,I.$dh)((0,I.$fh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(q,H,W,...G){const Q=[];if(Array.isArray(G)&&G.forEach(ce=>{a.URI.isUri(ce.uri)&&!Q.some(me=>D(me.uri,ce.uri,this.s))&&Q.push({uri:ce.uri,name:ce.name||(0,I.$ch)(ce.uri)})}),this.n||[H,W].some(ce=>typeof ce!="number"||ce<0)||W===0&&Q.length===0)return!1;const ae=this.x?this.x.workspaceFolders:[];if(H+W>ae.length)return!1;const be=ae.slice(0);be.splice(H,W,...Q.map(ce=>({uri:ce.uri,name:ce.name||(0,I.$ch)(ce.uri),index:void 0})));for(let ce=0;ce<be.length;ce++){const me=be[ce];if(be.some((oe,ke)=>ke!==ce&&D(me.uri,oe.uri,this.s)))return!1}be.forEach((ce,me)=>ce.index=me);const{added:le,removed:_}=k(ae,be,C,this.s);if(le.length===0&&_.length===0)return!1;if(this.o){const ce=q.displayName||q.name;this.o.$updateWorkspaceFolders(ce,H,W,Q).then(void 0,me=>{this.n=void 0;const oe={source:{identifier:q.identifier,label:q.displayName||q.name}};this.q.$showMessage(c.Severity.Error,(0,S.localize)(10820,null,ce,me.toString()),oe,[])})}return this.y(be),!0}getWorkspaceFolder(q,H){if(this.x)return this.x.getWorkspaceFolder(q,H)}async getWorkspaceFolder2(q,H){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(q,H)}async resolveWorkspaceFolder(q){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(q)}getPath(){if(!this.x)return;const{folders:q}=this.x;if(q.length!==0)return q[0].uri.fsPath}getRelativePath(q,H){let W,G="";if(typeof q=="string"?(W=a.URI.file(q),G=q):typeof q<"u"&&(W=q,G=q.fsPath),!W)return G;const Q=this.getWorkspaceFolder(W,!0);if(!Q)return G;typeof H>"u"&&this.x&&(H=this.x.folders.length>1);let ae=(0,I.$ih)(Q.uri,W);return H&&Q.name&&(ae=`${Q.name}/${ae}`),ae}y(q){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:q,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(q){const{workspace:H,added:W,removed:G}=w.toExtHostWorkspace(q,this.l,this.n,this.s);this.l=H||void 0,this.n=void 0,this.c.fire(Object.freeze({added:W,removed:G}))}findFiles(q,H,W,G,Q=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${G.value}, entryPoint: findFiles`);let ae="",be=!0;return H===null?be=!1:H!==void 0&&(typeof H=="string"?ae=H:ae=H.pattern),this.z(q,void 0,{exclude:ae,maxResults:W,useDefaultExcludes:be,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},Q)}findFiles2(q,H={},W,G=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${W.value}, entryPoint: findFiles2`),this.z(void 0,q,H,G)}async z(q,H,W,G=P.CancellationToken.None){if(G&&G.isCancellationRequested)return Promise.resolve([]);const Q=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,ae={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof W.useParentIgnoreFiles=="boolean"?!W.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof W.useDefaultSearchExcludes=="boolean"?!W.useDefaultSearchExcludes:!1,maxResults:W.maxResults,excludePattern:Q,shouldGlobSearch:typeof W.fuzzy=="boolean"?!W.fuzzy:!0,_reason:"startFileSearch"};let be;if(q){const{includePattern:le,folder:_}=N(g.GlobPattern.from(q));be=_,ae.includePattern=le}else{const{includePattern:le,folder:_}=N(g.GlobPattern.from(H));be=_,ae.filePattern=le}return this.o.$startFileSearch(be??null,ae,G).then(le=>Array.isArray(le)?le.map(_=>a.URI.revive(_)):[])}async findTextInFiles(q,H,W,G,Q=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${G.value}, entryPoint: findTextInFiles`);const ae=this.j.getNext(),be=typeof H.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:H.previewOptions,{includePattern:le,folder:_}=N(g.GlobPattern.from(H.include)),ce=typeof H.exclude=="string"?H.exclude:H.exclude?H.exclude.pattern:void 0,me={ignoreSymlinks:typeof H.followSymlinks=="boolean"?!H.followSymlinks:void 0,disregardIgnoreFiles:typeof H.useIgnoreFiles=="boolean"?!H.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof H.useGlobalIgnoreFiles=="boolean"?!H.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof H.useParentIgnoreFiles=="boolean"?!H.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof H.useDefaultExcludes=="boolean"?!H.useDefaultExcludes:!0,disregardSearchExcludeSettings:typeof H.useSearchExclude=="boolean"?!H.useSearchExclude:!0,fileEncoding:H.encoding,maxResults:H.maxResults,previewOptions:be,afterContext:H.afterContext,beforeContext:H.beforeContext,includePattern:le,excludePattern:ce},oe=!1;if(this.u[ae]=ke=>{if(oe)return;const Te=a.URI.revive(ke.resource);ke.results.forEach(Y=>{const B=(0,E.$ci)(Y);(0,m.$9L)(B)?W({uri:Te,preview:{text:B.preview.text,matches:(0,v.$Zb)(B.preview.matches,ne=>new u.$ON(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,v.$Zb)(B.ranges,ne=>new u.$ON(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):W({uri:Te,text:B.text,lineNumber:B.lineNumber})})},Q.isCancellationRequested)return{};try{const ke=await this.o.$startTextSearch(q,_??null,me,ae,Q);return delete this.u[ae],ke||{}}catch(ke){throw delete this.u[ae],ke}}$handleTextSearchResult(q,H){this.u[H]?.(q)}async save(q){const H=await this.o.$save(q,{saveAs:!1});return a.URI.revive(H)}async saveAs(q){const H=await this.o.$save(q,{saveAs:!0});return a.URI.revive(H)}saveAll(q){return this.o.$saveAll(q)}resolveProxy(q){return this.o.$resolveProxy(q)}lookupAuthorization(q){return this.o.$lookupAuthorization(q)}lookupKerberosAuthorization(q){return this.o.$lookupKerberosAuthorization(q)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(q){return this.o.$requestWorkspaceTrust(q)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(q,H){if(this.w.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.w.set(q,H);const W=this.t.transformOutgoingScheme(q),G=this.A++;return this.o.$registerEditSessionIdentityProvider(G,W),(0,A.$Sc)(()=>{this.w.delete(q),this.o.$unregisterEditSessionIdentityProvider(G)})}async $getEditSessionIdentifier(q,H){this.h.info("Getting edit session identifier for workspaceFolder",q);const W=await this.resolveWorkspaceFolder(a.URI.revive(q));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const G=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!G),!G)return;const Q=await G.provideEditSessionIdentity(W,H);if(this.h.info("Provider returned edit session identifier: ",Q),!!Q)return Q}async $provideEditSessionIdentityMatch(q,H,W,G){this.h.info("Getting edit session identifier for workspaceFolder",q);const Q=await this.resolveWorkspaceFolder(a.URI.revive(q));if(!Q){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",Q);const ae=this.w.get(Q.uri.scheme);if(this.h.info(`Provider for scheme ${Q.uri.scheme} is defined: `,!!ae),!ae)return;const be=await ae.provideEditSessionIdentityMatch?.(H,W,G);if(this.h.info("Provider returned edit session identifier match result: ",be),!!be)return be}getOnWillCreateEditSessionIdentityEvent(q){return(H,W,G)=>{const Q=function(be){H.call(W,be)};return Q.extension=q,this.B.event(Q,void 0,G)}}async $onWillCreateEditSessionIdentity(q,H,W){const G=await this.resolveWorkspaceFolder(a.URI.revive(q));if(G===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:G},H,async(Q,ae)=>{const be=Date.now();await Promise.resolve(Q),Date.now()-be>W&&this.h.warn("SLOW edit session create-participant",ae.extension.identifier)}),H.isCancellationRequested}registerCanonicalUriProvider(q,H){if(this.C.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.C.set(q,H);const W=this.t.transformOutgoingScheme(q),G=this.A++;return this.o.$registerCanonicalUriProvider(G,W),(0,A.$Sc)(()=>{this.C.delete(q),this.o.$unregisterCanonicalUriProvider(G)})}async provideCanonicalUri(q,H,W){const G=this.C.get(q.scheme);if(!G)return;const Q=await G.provideCanonicalUri?.(a.URI.revive(q),H,W);if(Q)return Q}async $provideCanonicalUri(q,H,W){return this.provideCanonicalUri(a.URI.revive(q),{targetScheme:H},W)}};e.$Npc=F,e.$Npc=F=Je([Ve(0,t.$kQ),Ve(1,n.$AQ),Ve(2,i.$wpc),Ve(3,s.$ak),Ve(4,$.$Lpc)],F),e.$Opc=(0,r.$Fi)("IExtHostWorkspace");function N(L){let q,H;return L&&(typeof L=="string"?q=L:(q=L.pattern,H=a.URI.revive(L.baseUri))),{includePattern:q,folder:H}}}),define(Ne[46],Le([1,0,25,6,45,5,7,43,174,53,14,10,3,16,11,2]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rpc=e.$Qpc=e.$Ppc=void 0;function s($,m){if(m){const h=m.split(".");let E=$;for(let D=0;E&&D<h.length;D++)E=E[h[D]];return E}}function c($){return $ instanceof r.URI}function l($){return $&&$.uri instanceof r.URI&&$.languageId&&typeof $.languageId=="string"}function i($){return $&&!$.uri&&$.languageId&&typeof $.languageId=="string"}function n($){return $&&$.uri instanceof r.URI&&(!$.name||typeof $.name=="string")&&(!$.index||typeof $.index=="number")}function t($){if(c($))return{resource:$};if(l($))return{resource:$.uri,overrideIdentifier:$.languageId};if(i($))return{overrideIdentifier:$.languageId};if(n($))return{resource:$.uri};if($===null)return{resource:null}}let g=class{constructor(m,h,E){this.a=m.getProxy(O.$KN.MainThreadConfiguration),this.c=h,this.b=E,this.d=new y.$Eh,this.e=null}getConfigProvider(){return this.d.wait().then(m=>this.e)}$initializeConfiguration(m){this.e=new u(this.a,this.c,m,this.b),this.d.open()}$acceptConfigurationChanged(m,h){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(m,h))}};e.$Ppc=g,e.$Ppc=g=Je([Ve(0,S.$kQ),Ve(1,P.$Opc),Ve(2,d.$ak)],g);class u{constructor(m,h,E,D){this.a=new R.$le,this.b=m,this.f=D,this.c=h,this.e=p.$Ro.parse(E,D),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(m,h){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Ro.parse(m,this.f),this.d=this.k(m.configurationScopes),this.a.fire(this.j(h,E))}getConfiguration(m,h,E){const D=t(h)||{},b=this.g(m?s(this.e.getValue(void 0,D,this.c.workspace),m):this.e.getValue(void 0,D,this.c.workspace));m&&this.h(m,D,E?.identifier);function C(f){if(f==null)return null;if(typeof f=="boolean")return f?T.ConfigurationTarget.USER:T.ConfigurationTarget.WORKSPACE;switch(f){case A.ConfigurationTarget.Global:return T.ConfigurationTarget.USER;case A.ConfigurationTarget.Workspace:return T.ConfigurationTarget.WORKSPACE;case A.ConfigurationTarget.WorkspaceFolder:return T.ConfigurationTarget.WORKSPACE_FOLDER}}const k={has(f){return typeof s(b,f)<"u"},get:(f,w)=>{this.h(m?`${m}.${f}`:f,D,E?.identifier);let F=s(b,f);if(typeof F>"u")F=w;else{let N;const L=(q,H)=>{if((0,I.$gg)(q)){let W;const G=()=>{N=N||(0,v.$eo)(b),W=W||s(N,H)};return new Proxy(q,{get:(Q,ae)=>{if(typeof ae=="string"&&ae.toLowerCase()==="tojson")return G(),()=>W;if(N)return W=W||s(N,H),W[ae];const be=Q[ae];return typeof ae=="string"?L(be,`${H}.${ae}`):be},set:(Q,ae,be)=>(G(),W&&(W[ae]=be),!0),deleteProperty:(Q,ae)=>(G(),W&&delete W[ae],!0),defineProperty:(Q,ae,be)=>(G(),W&&Object.defineProperty(W,ae,be),!0)})}return Array.isArray(q)?(0,v.$eo)(q):q};F=L(F,f)}return F},update:(f,w,F,N)=>{f=m?`${m}.${f}`:f;const L=C(F);return w!==void 0?this.b.$updateConfigurationOption(L,f,w,D,N):this.b.$removeConfigurationOption(L,f,D,N)},inspect:f=>{f=m?`${m}.${f}`:f;const w=this.e.inspect(f,D,this.c.workspace);if(w)return{key:f,defaultValue:(0,v.$eo)(w.policy?.value??w.default?.value),globalValue:(0,v.$eo)(w.user?.value??w.application?.value),workspaceValue:(0,v.$eo)(w.workspace?.value),workspaceFolderValue:(0,v.$eo)(w.workspaceFolder?.value),defaultLanguageValue:(0,v.$eo)(w.default?.override),globalLanguageValue:(0,v.$eo)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,v.$eo)(w.workspace?.override),workspaceFolderLanguageValue:(0,v.$eo)(w.workspaceFolder?.override),languageIds:(0,v.$eo)(w.overrideIdentifiers)}}};return typeof b=="object"&&(0,v.$ho)(k,b,!1),Object.freeze(k)}g(m){const h=E=>(0,I.$gg)(E)?new Proxy(E,{get:(D,b)=>h(D[b]),set:(D,b,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(D,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(D,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return h(m)}h(m,h,E){const D=o.$Go.test(m)?o.ConfigurationScope.RESOURCE:this.d.get(m),b=E?`[${E.value}] `:"";if(o.ConfigurationScope.RESOURCE===D){typeof h?.resource>"u"&&this.f.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${m}', provide the URI of a resource or 'null' for any resource.`);return}if(o.ConfigurationScope.WINDOW===D){h?.resource&&this.f.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${m}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(m,h){const E=new p.$To(m,h,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,b)=>E.affectsConfiguration(D,t(b))})}k(m){return m.reduce((h,E)=>(h.set(E[0],E[1]),h),new Map)}}e.$Qpc=u,e.$Rpc=(0,a.$Fi)("IExtHostConfiguration")}),define(Ne[131],Le([1,0,2,10,6,5,7,45,57,46,21,56,16,26,3,15,20,11,84,209,13]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$prc=e.$orc=e.$nrc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,A=qe(A),s=qe(s);var t;(function(N){function L(H){if(H!=null)return H}N.from=L;function q(H){if(H!=null)return H}N.to=q})(t||(t={}));var g;(function(N){function L(H){if(H!=null)return H}N.from=L;function q(H){if(H!=null)return H}N.to=q})(g||(g={}));var u;(function(N){function L(H){if(H!=null)return H}N.from=L;function q(H){if(H!=null)return H}N.to=q})(u||(u={}));var $;(function(N){function L(W){if(W){const G=W;return G&&!!G.process}else return!1}N.is=L;function q(W){if(W==null)return;const G={process:W.process,args:W.args};return W.options&&(G.options=u.from(W.options)),G}N.from=q;function H(W){if(W!=null)return new A.$yO(W.process,W.args,W.options)}N.to=H})($||($={}));var m;(function(N){function L(H){if(H!=null)return H}N.from=L;function q(H){if(H!=null)return H}N.to=q})(m||(m={}));var h;(function(N){function L(W){if(W){const G=W;return G&&(!!G.commandLine||!!G.command)}else return!1}N.is=L;function q(W){if(W==null)return;const G={};return W.commandLine!==void 0?G.commandLine=W.commandLine:(G.command=W.command,G.args=W.args),W.options&&(G.options=m.from(W.options)),G}N.from=q;function H(W){if(!(W==null||W.command===void 0&&W.commandLine===void 0))return W.commandLine?new A.$zO(W.commandLine,W.options):new A.$zO(W.command,W.args?W.args:[],W.options)}N.to=H})(h||(h={}));var E;(function(N){function L(W){if(W){const G=W;return G&&G.customExecution==="customExecution"}else return!1}N.is=L;function q(W){return{customExecution:"customExecution"}}N.from=q;function H(W,G){return G.get(W)}N.to=H})(E||(e.CustomExecutionDTO=E={}));var D;(function(N){function L(q,H){let W;return q.scope!==void 0&&typeof q.scope!="number"?W=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===A.TaskScope.Workspace&&H&&H.workspaceFile?W=H.workspaceFile:W=i.$VI),{id:q._id,workspaceFolder:W}}N.from=L})(D||(e.TaskHandleDTO=D={}));var b;(function(N){function L(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}N.from=L})(b||(b={}));var C;(function(N){function L(W,G){if(W==null)return[];const Q=[];for(const ae of W){const be=q(ae,G);be&&Q.push(be)}return Q}N.fromMany=L;function q(W,G){if(W==null)return;let Q;W.execution instanceof A.$yO?Q=$.from(W.execution):W.execution instanceof A.$zO?Q=h.from(W.execution):W.execution&&W.execution instanceof A.$AO&&(Q=E.from(W.execution));const ae=t.from(W.definition);let be;return W.scope?typeof W.scope=="number"?be=W.scope:be=W.scope.uri:be=A.TaskScope.Workspace,!ae||!be?void 0:{_id:W._id,definition:ae,name:W.name,source:{extensionId:G.identifier.value,label:W.source,scope:be},execution:Q,isBackground:W.isBackground,group:b.from(W.group),presentationOptions:g.from(W.presentationOptions),problemMatchers:W.problemMatchers,hasDefinedMatchers:W.hasDefinedMatchers,runOptions:W.runOptions?W.runOptions:{reevaluateOnRerun:!0},detail:W.detail}}N.from=q;async function H(W,G,Q){if(W==null)return;let ae;$.is(W.execution)?ae=$.to(W.execution):h.is(W.execution)?ae=h.to(W.execution):E.is(W.execution)&&(ae=E.to(W._id,Q));const be=t.to(W.definition);let le;if(W.source&&(W.source.scope!==void 0?typeof W.source.scope=="number"?le=W.source.scope:le=await G.resolveWorkspaceFolder(v.URI.revive(W.source.scope)):le=A.TaskScope.Workspace),!be||!le)return;const _=new A.$BO(be,le,W.name,W.source.label,ae,W.problemMatchers);return W.isBackground!==void 0&&(_.isBackground=W.isBackground),W.group!==void 0&&(_.group=A.$xO.from(W.group._id),_.group&&W.group.isDefault&&(_.group=new A.$xO(_.group.id,_.group.label),W.group.isDefault===!0&&(_.group.isDefault=W.group.isDefault))),W.presentationOptions&&(_.presentationOptions=g.to(W.presentationOptions)),W._id&&(_._id=W._id),W.detail&&(_.detail=W.detail),_}N.to=H})(C||(e.TaskDTO=C={}));var k;(function(N){function L(H){return H}N.from=L;function q(H){if(H)return Object.assign(Object.create(null),H)}N.to=q})(k||(k={}));class f{#e;constructor(L,q,H){this._id=q,this.a=H,this.#e=L}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}let w=class{constructor(L,q,H,W,G,Q,ae,be){this.q=new P.$le,this.r=new P.$le,this.s=new P.$le,this.u=new P.$le,this.a=L.getProxy(O.$KN.MainThreadTask),this.b=H,this.c=W,this.d=G,this.e=Q,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ae,this.g=be,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(L,q,H){if(!H)return new A.$MN(()=>{});const W=this.x();return this.j.set(W,{type:q,provider:H,extension:L}),this.a.$registerTaskProvider(W,q),new A.$MN(()=>{this.j.delete(W),this.a.$unregisterTaskProvider(W)})}registerTaskSystem(L,q){this.a.$registerTaskSystem(L,q)}fetchTasks(L){return this.a.$fetchTasks(k.from(L)).then(async q=>{const H=[];for(const W of q){const G=await C.to(W,this.b,this.m);G&&H.push(G)}return H})}get taskExecutions(){const L=[];return this.k.forEach(q=>L.push(q)),L}terminateTask(L){if(!(L instanceof f))throw new Error("No valid task execution provided");return this.a.$terminateTask(L._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(L,q,H){const W=this.m.get(L.id);W&&(this.o.set(L.id,W),this.e.attachPtyToTerminal(q,await W.callback(H))),this.p=L.id,this.q.fire({execution:await this.z(L)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(L){if(!this.l.has(L.id))return;const q=await this.z(L);this.l.delete(L.id),this.k.delete(L.id),this.B(L),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(L){const q=await this.z(L.id);this.s.fire({execution:q,processId:L.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(L){const q=await this.z(L.id);this.u.fire({execution:q,exitCode:L.exitCode})}$provideTasks(L,q){const H=this.j.get(L);if(!H)return Promise.reject(new Error("no handler found"));const W=[],G=(0,R.$xh)(()=>H.provider.provideTasks(I.CancellationToken.None)).then(Q=>this.v(q,W,H,Q));return new Promise(Q=>{G.then(ae=>{Promise.all(W).then(()=>{Q(ae)})})})}async $resolveTask(L,q){const H=this.j.get(L);if(!H)return Promise.reject(new Error("no handler found"));if(q.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${H.type}].`);const W=await C.to(q,this.b,this.m);if(!W)throw new Error("Unexpected: Task cannot be resolved.");const G=await H.provider.resolveTask(W,I.CancellationToken.None);if(!G)return;this.A(G,H);const Q=C.from(G,H.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==W.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return E.is(Q.execution)&&await this.y(Q,G,!0),await this.w(Q)}x(){return this.h++}async y(L,q,H){const W=await this.a.$createTaskId(L);!H&&!this.m.has(W)&&(this.n.add(W),this.o.set(W,q.execution)),this.m.set(W,q.execution)}async z(L,q){if(typeof L=="string"){const G=this.l.get(L);if(!G)throw new n.$ab("Unexpected: The specified task is missing an execution");return G}const H=this.l.get(L.id);if(H)return H;let W;return q?W=Promise.resolve(new f(this,L.id,q)):W=C.to(L.task,this.b,this.m).then(G=>{if(!G)throw new n.$ab("Unexpected: Task does not exist.");return new f(this,L.id,G)}),this.l.set(L.id,W),W.then(G=>(this.k.set(L.id,G),G))}A(L,q){L._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(L){this.o.get(L.id)&&this.o.delete(L.id),this.n.has(L.id)&&this.p!==L.id&&(this.m.delete(L.id),this.n.delete(L.id));const H=this.n.values();let W=H.next();for(;!W.done;)!this.o.has(W.value)&&this.p!==W.value&&(this.m.delete(W.value),this.n.delete(W.value)),W=H.next()}};e.$nrc=w,e.$nrc=w=Je([Ve(0,a.$kQ),Ve(1,S.$AQ),Ve(2,T.$Opc),Ve(3,p.$vQ),Ve(4,o.$Rpc),Ve(5,y.$dqc),Ve(6,c.$ak),Ve(7,l.$spc)],w);let F=class extends w{constructor(L,q,H,W,G,Q,ae,be){super(L,q,H,W,G,Q,ae,be),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:s.$i(s.Platform.Web)})}async executeTask(L,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const H=C.from(q,L);if(H===void 0)throw new Error("Task is not valid");if(E.is(H.execution))await this.y(H,q,!1);else throw new n.$$;const W=await this.z(await this.a.$getTaskExecution(H),q);return this.a.$executeTask(H).catch(G=>{throw new Error(G)}),W}v(L,q,H,W){const G=[];if(W)for(const Q of W){if(this.A(Q,H),!Q.definition||!L[Q.definition.type]){const be=Q.source?Q.source:"No task source";this.f.warn(`The task [${be}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`)}const ae=C.from(Q,H.extension);ae&&E.is(ae.execution)?(G.push(ae),q.push(this.y(ae,Q,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:G,extension:H.extension}}async w(L){if(E.is(L.execution))return L;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(L,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,q,H){}};e.$orc=F,e.$orc=F=Je([Ve(0,a.$kQ),Ve(1,S.$AQ),Ve(2,T.$Opc),Ve(3,p.$vQ),Ve(4,o.$Rpc),Ve(5,y.$dqc),Ve(6,c.$ak),Ve(7,l.$spc)],F),e.$prc=(0,d.$Fi)("IExtHostTask")}),define(Ne[268],Le([1,0,44,32]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=void 0,e.$wM=P,e.$yM=O;function P(A){return"cellResults"in A}e.$xM="rawCell#";function O(A,T){let p=-1;const o=[];let I=[];return A.forEach(a=>{a.range.startLineNumber!==p&&I.length>0&&(o.push([...I]),I=[]),I.push(a),p=a.range.endLineNumber}),I.length>0&&o.push([...I]),o.map(a=>{const S=[],d=a[0].range.startLineNumber,r=a[a.length-1].range.endLineNumber;for(let s=d;s<=r;s++)S.push(T.getLineContent(s));return new v.$aM(S.join(`
`)+`
`,a.map(s=>new R.$Ot(s.range.startLineNumber-1,s.range.startColumn-1,s.range.endLineNumber-1,s.range.endColumn-1)))})}}),define(Ne[269],Le([1,0,9,22,6,4,28,37,12,14,2,29,79,5,33,8,7,39,246,124,25,15,44,199,268,266]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n,t,g,u,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2qc=void 0,y=qe(y),r=qe(r),s=qe(s);class h{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,b,C,k,f,w,F){this.q=C,this.r=k,this.s=f,this.t=w,this.u=F,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new P.$le,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$le,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$le,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$le,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new a.$qpc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(S.$KN.MainThreadNotebook),this.c=D.getProxy(S.$KN.MainThreadNotebookDocuments),this.d=D.getProxy(S.$KN.MainThreadNotebookEditors),this.i=b.converter,b.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===T.MarshalledId.NotebookCellActionContext){const L=N.notebookEditor?.notebookUri,q=N.cell.handle,W=this.g.get(L)?.getCell(q);if(W)return W.apiCell}if(N&&N.$mid===T.MarshalledId.NotebookActionContext){const L=N.uri,q=this.g.get(L);if(q)return q.apiNotebook}return N}}),h.C(b)}getEditorById(D){const b=this.h.get(D);if(!b)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return b}getIdByEditor(D){for(const[b,C]of this.h)if(C.apiEditor===D)return b}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,b){const C=this.g.get(D);if(!C&&!b)throw new Error(`NO notebook document for '${D}'`);return C}static w(D,b){if(!b)return;const C=b.filenamePattern.map(k=>r.NotebookExclusiveDocumentPattern.from(k)).filter(k=>k!==void 0);if(b.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${b.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:b.displayName,filenamePattern:C,priority:b.exclusive?m.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,b,C){const k=h.a++,f=typeof C.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(k,C),this.b.$registerNotebookCellStatusBarItemProvider(k,f,b);let w;return f!==void 0&&(w=C.onDidChangeCellStatusBarItems(F=>this.b.$emitCellStatusBarEvent(f))),new s.$MN(()=>{this.f.delete(k),this.b.$unregisterNotebookCellStatusBarItemProvider(k,f),w?.dispose()})}async createNotebookDocument(D){const b=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&r.NotebookData.from(D.content)});return I.URI.revive(b)}async openNotebookDocument(D){const b=this.g.get(D);if(b)return b.apiNotebook;const C=await this.c.$tryOpenNotebook(D),k=this.g.get(I.URI.revive(C));return(0,o.$pg)(k?.apiNotebook)}async showNotebookDocument(D,b){I.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let C;typeof b=="object"?C={position:r.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selections:b.selections&&b.selections.map(r.NotebookRange.from),pinned:typeof b.preview=="boolean"?!b.preview:void 0}:C={preserveFocus:!1};const k=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,C),f=k&&this.h.get(k)?.apiEditor;if(f)return f;throw k?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,b,C,k){const f=this.f.get(D),w=I.URI.revive(b),F=this.g.get(w);if(!F||!f)return;const N=F.getCellFromIndex(C);if(!N)return;const L=await f.provideCellStatusBarItems(N.apiCell,k);if(!L)return;const q=new O.$Tc,H=this.p.add([q]),G=(Array.isArray(L)?L:[L]).map(Q=>r.NotebookStatusBarItem.from(Q,this.i,q));return{cacheId:H,items:G}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,b,C,k,f){if((0,p.$cf)(b))throw new Error("viewType cannot be empty or just whitespace");const w=this.x++;return this.y.set(w,{viewType:b,serializer:C,options:k}),this.b.$registerNotebookSerializer(w,{id:D.identifier,location:D.extensionLocation},b,r.NotebookDocumentContentOptions.from(k),h.w(D,f)),(0,O.$Sc)(()=>{this.b.$unregisterNotebookSerializer(w)})}async $dataToNotebook(D,b,C){const k=this.y.get(D);if(!k)throw new Error("NO serializer found");const f=await k.serializer.deserializeNotebook(b.buffer,C);return new c.$Xw(r.NotebookData.from(f))}async $notebookToData(D,b,C){const k=this.y.get(D);if(!k)throw new Error("NO serializer found");const f=await k.serializer.serializeNotebook(r.NotebookData.to(b.value),C);return R.$Ne.wrap(f)}async $saveNotebook(D,b,C,k,f){const w=I.URI.revive(b),F=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${C}, ${w.toString()})`),!F)throw new Error("NO serializer found");const N=this.g.get(w);if(!N)throw new Error("Document NOT found");if(N.versionId!==C)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(w.scheme))throw new y.$vl((0,v.localize)(10828,null,this.A(w)),y.FileOperationResult.FILE_PERMISSION_DENIED);const L={metadata:(0,n.$mo)(N.apiNotebook.metadata,Q=>!(F.options?.transientDocumentMetadata??{})[Q]),cells:[]};for(const Q of N.apiNotebook.getCells()){const ae=new s.$fP(Q.kind,Q.document.getText(),Q.document.languageId,Q.mime,F.options?.transientOutputs?[]:[...Q.outputs],Q.metadata,Q.executionSummary);ae.metadata=(0,n.$mo)(Q.metadata,be=>!(F.options?.transientCellMetadata??{})[be]),L.cells.push(ae)}if(await this.z(w,k),f.isCancellationRequested)throw new Error("canceled");const q=await F.serializer.serializeNotebook(L,f);if(f.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${C} ${w.toString()}`),await this.s.value.writeFile(w,q),this.D(`Finished write versionId: ${C} ${w.toString()}`);const H=this.s.getFileSystemProviderExtUri(w.scheme),W=await this.s.value.stat(w),G={name:H.basename(w),isFile:(W.type&y.FileType.File)!==0,isDirectory:(W.type&y.FileType.Directory)!==0,isSymbolicLink:(W.type&y.FileType.SymbolicLink)!==0,mtime:W.mtime,ctime:W.ctime,size:W.size,readonly:!!((W.permissions??0)&y.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(w.scheme),locked:!!((W.permissions??0)&y.FilePermission.Locked),etag:y.$Gl({mtime:W.mtime,size:W.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${C}, ${w.toString()})`),G}async $searchInNotebooks(D,b,C,k,f){const w=this.y.get(D)?.serializer;if(!w)return{limitHit:!1,results:[]};const F=new A.$Bc;await(async(W,G,Q)=>{await Promise.all(W.map(async ae=>await Promise.all(ae.filenamePatterns.map(be=>{const le={_reason:Q._reason,folderQueries:Q.folderQueries,includePattern:Q.includePattern,excludePattern:Q.excludePattern,maxResults:Q.maxResults,type:g.QueryType.File,filePattern:be};return this.t.doInternalFileSearchWithCustomCallback(le,G,_=>{_.forEach(ce=>{F.has(ce)||k.some(oe=>ae.isFromSettings&&!oe.isFromSettings?!1:oe.filenamePatterns.some(ke=>(0,m.$qL)(ke,ce)))||F.add(ce)})}).catch(_=>{if(_.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw _})}))))})(C,f,b);const L=new A.$Ac;let q=!1;const H=Array.from(F).map(async W=>{const G=[];try{if(f.isCancellationRequested)return;if(b.maxResults&&[...L.values()].reduce((le,_)=>le+_.cellResults.length,0)>b.maxResults){q=!0;return}const Q=[],ae=this.g.get(W);if(ae)ae.apiNotebook.getCells().forEach(_=>Q.push({input:_.document.getText(),outputs:_.outputs.flatMap(ce=>ce.items.map(me=>me.data.toString()))}));else{const le=await this.s.value.readFile(W),_=R.$Ne.fromString(le.toString()),ce=await w.deserializeNotebook(_.buffer,f);if(f.isCancellationRequested)return;r.NotebookData.from(ce).cells.forEach(oe=>Q.push({input:oe.source,outputs:oe.outputs.flatMap(ke=>ke.items.map(Te=>Te.valueBytes.toString()))}))}if(f.isCancellationRequested)return;Q.forEach((le,_)=>{const ce=b.contentPattern.pattern,me=new u.$j1b(le.input,void 0,le.outputs),oe=me.findInInputs(ce),ke=me.findInOutputs(ce),Te=ke.flatMap(Y=>(0,$.$yM)(Y.matches,Y.textBuffer)).map((Y,B)=>(Y.webviewIndex=B,Y));if(oe.length>0||ke.length>0){const Y={index:_,contentResults:(0,$.$yM)(oe,me.inputTextBuffer),webviewResults:Te};G.push(Y)}});const be={resource:W,cellResults:G};L.set(W,be);return}catch{return}});return await Promise.all(H),{limitHit:q,results:[...L.values()]}}async z(D,b){const C=await this.s.value.stat(D);if(typeof b?.mtime=="number"&&typeof b.etag=="string"&&b.etag!==y.$Fl&&typeof C.mtime=="number"&&typeof C.size=="number"&&b.mtime<C.mtime&&b.etag!==y.$Gl({mtime:b.mtime,size:C.size}))throw new y.$vl((0,v.localize)(10829,null),y.FileOperationResult.FILE_MODIFIED_SINCE,b)}A(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}B(D,b,C){if(this.h.has(b))throw new Error(`editor with id ALREADY EXSIST: ${b}`);const k=new i.$Sqc(b,this.d,D,C.visibleRanges.map(r.NotebookRange.to),C.selections.map(r.NotebookRange.to),typeof C.viewColumn=="number"?r.ViewColumn.to(C.viewColumn):void 0);this.h.set(b,k)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const C of D.value.removedDocuments){const k=I.URI.revive(C),f=this.g.get(k);f&&(f.dispose(),this.g.delete(k),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(w=>w.document.uri)}),this.n.fire(f.apiNotebook));for(const w of this.h.values())w.notebookData.uri.toString()===k.toString()&&this.h.delete(w.id)}if(D.value.addedDocuments){const C=[];for(const k of D.value.addedDocuments){const f=I.URI.revive(k.uri);if(this.g.has(f))throw new Error(`adding EXISTING notebook ${f} `);const w=new l.$Rqc(this.c,this.q,this.r,f,k);C.push(...k.cells.map(F=>l.$Qqc.asModelAddData(F))),this.g.get(f)?.dispose(),this.g.set(f,w),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this.m.fire(w.apiNotebook)}}if(D.value.addedEditors)for(const C of D.value.addedEditors){if(this.h.has(C.id))return;const k=I.URI.revive(C.documentUri),f=this.g.get(k);f&&this.B(f,C.id,C)}const b=[];if(D.value.removedEditors)for(const C of D.value.removedEditors){const k=this.h.get(C);k&&(this.h.delete(C),this.k?.id===k.id&&(this.k=void 0),b.push(k))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(k=>this.h.get(k)).filter(k=>!!k);const C=new Set;this.l.forEach(k=>C.add(k.id));for(const k of this.h.values()){const f=C.has(k.id);k._acceptVisibility(f)}this.l=[...this.h.values()].map(k=>k).filter(k=>k.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const b=d.$IQ.String.with("notebookType","A notebook type"),C=new d.$KQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[b,new d.$IQ("data","Bytes to convert to data",f=>f instanceof Uint8Array,f=>R.$Ne.wrap(f))],new d.$JQ("Notebook Data",f=>r.NotebookData.to(f.value))),k=new d.$KQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[b,new d.$IQ("NotebookData","Notebook data to convert to bytes",f=>!0,f=>new c.$Xw(r.NotebookData.from(f)))],new d.$JQ("Bytes",f=>f.buffer));D.registerApiCommand(C),D.registerApiCommand(k)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$2qc=h}),define(Ne[270],Le([1,0,19,21,42,41,23,69,44]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tqc=void 0,v=qe(v),O=qe(O),A=qe(A);class o{constructor(a,S,d){this.k=a,this.l=S,this.o=d,this.e=!1,this.f=0,this.g=!1,this.a=a.filePattern,this.b=a.includePattern&&O.$Ak(a.includePattern),this.c=a.maxResults||void 0,this.d=a.exists,this.h=new Set,this.j=a.excludePattern&&O.$Ak(a.excludePattern)}cancel(){this.g=!0,this.h.forEach(a=>a.cancel()),this.h=new Set}search(a){const S=this.k.folderQueries||[];return new Promise((d,r)=>{const s=c=>{this.f++,a(c)};if(this.g)return d({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(c=>{const l=c.toString(),i=v.$nc(l);this.j&&this.j(l,i)||this.v(s,{base:c,basename:i})}),Promise.all(S.map(c=>this.p(c,s))).then(c=>{d({limitHit:this.e,stats:c[0]||void 0})},c=>{r(new Error((0,P.$qj)(c)))})})}async p(a,S){const d=new R.$we,r=this.q(a),s=this.r(),c=new p.$oM(this.k,a),l=!c.hasSiblingExcludeClauses();let i;try{this.h.add(d),i=T.$fe.create();const n=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,d.token),t=i.elapsed(),g=T.$fe.create();return this.g&&!this.e||(n&&n.forEach(u=>{const $=v.$gc.relative(a.folder.path,u.path);if(l){const m=v.$nc(u.path);this.v(S,{base:a.folder,relativePath:$,basename:m});return}this.s(s,a.folder,$,S)}),this.g&&!this.e)?null:(this.u(s,c,S),{providerTime:t,postProcessTime:g.elapsed()})}finally{d.dispose(),this.h.delete(d)}}q(a){const S=(0,p.$nM)(this.k.includePattern,a.includePattern),d=(0,p.$nM)(this.k.excludePattern,a.excludePattern);return{folder:a.folder,excludes:d,includes:S,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}s({pathToEntries:a},S,d,r){if(d===this.a){const c=v.$nc(this.a);this.v(r,{base:S,relativePath:this.a,basename:c})}function s(c){const l=v.$nc(c),i=v.$mc(c);let n=a[i];n||(n=a[i]=[],s(i)),n.push({base:S,relativePath:c,basename:l})}s(d)}u({rootEntries:a,pathToEntries:S},d,r){const s=this,c=this.a;function l(i){const n=(0,p.$qM)(()=>i.map(t=>t.basename));for(let t=0,g=i.length;t<g;t++){const u=i[t],{relativePath:$,basename:m}=u;if(d.matchesExcludesSync($,m,c!==m?n:void 0))continue;const h=S[$];if(h)l(h);else{if($===c)continue;s.v(r,u)}if(s.e)break}}l(a)}v(a,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||a(S))}}class I{constructor(){this.b=new Map}static{this.a=512}fileSearch(a,S,d,r){const s=this.c(a.cacheKey),c=new o(a,S,s&&s.token);let l=0;const i=n=>{l+=n.length,d(n.map(t=>this.d(t)))};return this.e(c,I.a,i,r).then(n=>({limitHit:n.limitHit,stats:n.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:l,detailStats:n.stats}:void 0,messages:[]}))}clearCache(a){this.c(a)?.cancel()}c(a){if(a)return this.b.has(a)||this.b.set(a,new R.$we),this.b.get(a)}d(a){return a.relativePath?{resource:A.$gh(a.base,a.relativePath)}:{resource:a.base}}e(a,S,d,r){const s=r.onCancellationRequested(()=>{a.cancel()}),c=i=>{i&&(l.push(i),S>0&&l.length>=S&&(d(l),l=[]))};let l=[];return a.search(c).then(i=>(l.length&&d(l),s.dispose(),i),i=>(l.length&&d(l),s.dispose(),Promise.reject(i)))}}e.$Tqc=I}),define(Ne[271],Le([1,0,17,240,41,99,28,15,19,23,12,14,2,102,9,43,11,49,118,267,44]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oN=void 0,e.$pN=b,v=qe(v),R=qe(R),P=qe(P),p=qe(p),I=qe(I),d=qe(d);let t=class{constructor(k,f,w,F,N){this.a=k,this.b=f,this.c=w,this.d=F,this.e=N}text(k,f,w={}){k=this.f(k,w);const F=this.a.getValue(),N=f&&f.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(f?.map(c.$1i),w),type:n.QueryType.Text,contentPattern:k,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:F.search.usePCRE2||N||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles}}f(k,f){const w=this.a.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const F={...k,wordSeparators:w.editor.wordSeparators};return this.j(k,f)&&(F.isCaseSensitive=!0),this.k(k)&&(F.isMultiline=!0),f.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=f.notebookSearchConfig.includeMarkupInput),f.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=f.notebookSearchConfig.includeMarkupPreview),f.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=f.notebookSearchConfig.includeCodeInput),f.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=f.notebookSearchConfig.includeOutput),F}file(k,f={}){return{...this.h(k,f),type:n.QueryType.File,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey,shouldGlobMatchFilePattern:f.shouldGlobSearch}}g(k,f){return k?(k=Array.isArray(k)?k.map(h):h(k),f?this.parseSearchPaths(k):{pattern:u(...Array.isArray(k)?k:[k])}):{}}h(k=[],f={}){const w=this.g(f.includePattern,f.expandPatterns),F=this.g(f.excludePattern,f.expandPatterns),N=k.length>1,L=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(W=>this.q(W,f,F)):k.map(W=>this.r(W,f,F,N))).filter(W=>!!W),q={_reason:f._reason,folderQueries:L,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:F.pattern,includePattern:w.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const W=v.$Gb(this.c.groups.flatMap(ae=>ae.editors.map(be=>be.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(W));const G=W.filter(ae=>(0,n.$eM)(q,ae.fsPath)),Q=this.i(G);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Q)),{...q,...Q}}const H=f.extraFileResources&&f.extraFileResources.filter(W=>(0,n.$eM)(q,W.fsPath));return q.extraFileResources=H&&H.length?H:void 0,q}i(k){const f=[],w=new A.$Ac,F={};let N=!1;return k.forEach(L=>{if(L.scheme===T.Schemas.walkThrough)return;if((0,o.$kh)(L)){const H=this.b.getWorkspaceFolder(L)?.uri??L.with({path:p.$mc(L.fsPath)});let W=w.get(H);W||(N=!0,W={folder:H,includePattern:{}},f.push(W),w.set(H,W));const G=p.$lc(H.fsPath,L.fsPath);(0,y.$pg)(W.includePattern)[G.replace(/\\/g,"/")]=!0}else L.fsPath&&(N=!0,F[L.fsPath]=!0)}),{folderQueries:f,includePattern:F,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(k,f){if(f.isSmartCase){if(k.isRegExp){if(I.$8f(k.pattern,!0))return!0}else if(I.$8f(k.pattern))return!0}return!!k.isCaseSensitive}k(k){return k.isMultiline||k.isRegExp&&(0,S.$lD)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const f=Q=>p.$ic(Q)||/^\.\.?([\/\\]|$)/.test(Q),F=(Array.isArray(k)?k:$(k)).map(Q=>{const ae=this.e.resolvedUserHome;return ae?(0,O.$3w)(Q,ae.scheme===T.Schemas.file?ae.fsPath:ae.path):Q}),N=R.$c(F,Q=>f(Q)?"searchPaths":"exprSegments"),L=(N.exprSegments||[]).map(Q=>I.$nf(Q,"/")).map(Q=>I.$nf(Q,"\\")).map(Q=>(Q[0]==="."&&(Q="*"+Q),m(Q))),q={},H=this.m(N.searchPaths||[]);H&&H.length&&(q.searchPaths=H);const W=L.flat(),G=u(...W);return G&&(q.pattern=G),q}l(k,f){return f.disregardExcludeSettings?void 0:(0,n.$dM)(k,!f.disregardSearchExcludeSettings)}m(k){if(!k||!k.length)return[];const f=k.flatMap(F=>{let{pathPortion:N,globPortion:L}=g(F);return L&&(L=E(L)),this.n(N).flatMap(H=>this.o(H,L))}),w=new Map;return f.forEach(F=>{const N=F.searchPath.toString(),L=w.get(N);L?F.pattern&&(L.pattern=L.pattern||{},L.pattern[F.pattern]=!0):w.set(N,{searchPath:F.searchPath,pattern:F.pattern?u(F.pattern):void 0})}),Array.from(w.values())}n(k){if(p.$ic(k)){const f=this.b.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==T.Schemas.file?[{searchPath:f[0].uri.with({path:k})}]:[{searchPath:a.URI.file(p.$hc(k))}]}if(this.b.getWorkbenchState()===c.WorkbenchState.FOLDER){const f=this.b.getWorkspace().folders[0].uri;if(k=h(k),k.startsWith("../")||k===".."){const F=p.$gc.resolve(f.path,k);return[{searchPath:f.with({path:F})}]}const w=E(k);return[{searchPath:f,pattern:w}]}else{if(k==="./"||k===".\\")return[];{const f=k.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(N=>{const L=f.match(new RegExp(`^${I.$hf(N.name)}(?:/(.*)|$)`));return L?{match:L,folder:N}:null}).filter(y.$mg);if(F.length)return F.map(N=>{const L=N.match[1];return{searchPath:N.folder.uri,pattern:L&&E(L)}});{const N=k.match(/\.[\/\\](.+)[\/\\]?/),L=N?N[1]:k,q=d.localize(1633,null,L);throw new Error(q)}}}}o(k,f){const w=k.pattern&&f?`${k.pattern}/${f}`:k.pattern||f,F=[{searchPath:k.searchPath,pattern:w}];return w&&!w.endsWith("**")&&F.push({searchPath:k.searchPath,pattern:w+"/**"}),F}q(k,f,w){const F=this.r((0,c.$1i)(k.searchPath),f,w,!1);return F?{...F,includePattern:k.pattern}:null}r(k,f,w,F){let N;const L=a.URI.isUri(k)?k:k.uri;if(w.searchPaths){const Q=w.searchPaths.filter(ae=>(0,o.$_g)(ae.searchPath,L))[0];if(Q&&!Q.pattern)return null;Q&&(N=Q.pattern)}const q=this.a.getValue({resource:L}),W={...this.l(q,f)||{},...N||{}},G=a.URI.isUri(k)?(0,o.$dh)(k):k.name;return{folder:L,folderName:F?G:void 0,excludePattern:Object.keys(W).length>0?W:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!q.search.followSymlinks}}};e.$oN=t,e.$oN=t=Je([Ve(0,r.$_i),Ve(1,c.$Oi),Ve(2,l.$tE),Ve(3,s.$ak),Ve(4,i.$mN)],t);function g(C){const k=C.match(/[\*\{\}\(\)\[\]\?]/);if(k){const f=k.index,w=C.substr(0,f).match(/[/|\\][^/\\]*$/);if(w){let F=C.substr(0,w.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:C.substr((w.index||0)+1)}}}return{pathPortion:C}}function u(...C){return C.length?C.reduce((k,f)=>(k[f]=!0,k),Object.create(null)):void 0}function $(C){return P.$yk(C,",").map(k=>k.trim()).filter(k=>!!k.length)}function m(C){return[`**/${C}/**`,`**/${C}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function h(C){return C.replace(/\\/g,"/")}function E(C){return h(C).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(C){return C.replace(/([?*[\]])/g,"[$1]")}function b(C,k){C=v.$Lb(C,F=>F.toString());const f=[],w=k.getWorkspace();return C&&C.forEach(F=>{let N;if(k.getWorkbenchState()===c.WorkbenchState.FOLDER)N=(0,o.$ih)(w.folders[0].uri,F),N&&N!=="."&&(N="./"+N);else{const L=k.getWorkspaceFolder(F);if(L){const q=L.name;if(w.folders.filter(W=>W.name===q).length===1){const W=(0,o.$ih)(L.uri,F);W===""?N=`./${L.name}`:N=`./${L.name}/${W}`}else N=F.fsPath}}N&&f.push(D(N))}),f}}),define(Ne[272],Le([1,0,23,2,21,13,3,271,44,49,10]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dyb=a,e.$Eyb=r,v=qe(v),O=qe(O);const y=7e3;function a(s,c){const l=c.activationEvents;if(!l)return Promise.resolve(void 0);const i=[],n=[];for(const h of l)if(/^workspaceContains:/.test(h)){const E=h.substr(18);E.indexOf("*")>=0||E.indexOf("?")>=0||s.forceUsingSearch?n.push(E):i.push(E)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);const{promise:t,resolve:g}=(0,I.$yh)(),u=h=>g({activationEvent:h}),$=Promise.all(i.map(h=>S(s,h,u))).then(()=>{}),m=d(s,c.identifier,n,u);return Promise.all([$,m]).then(()=>{g(void 0)}),t}async function S(s,c,l){for(const i of s.folders)if(await s.exists(v.$gh(R.URI.revive(i),c))){l(`workspaceContains:${c}`);return}}async function d(s,c,l,i){if(l.length===0)return Promise.resolve(void 0);const n=new P.$we,t=s.checkExists(s.folders,l,n.token),g=setTimeout(async()=>{n.cancel(),s.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},y);let u=!1;try{u=await t}catch($){O.$3($)||O.$Y($)}n.dispose(),clearTimeout(g),u&&i(`workspaceContains:${l.join(",")}`)}function r(s,c,l,i){const n=s.get(A.$Ei),t=s.get(p.$8L),u=n.createInstance(T.$oN).file(c.map($=>(0,o.$1i)(R.URI.revive($))),{_reason:"checkExists",includePattern:l,exists:!0});return t.fileSearch(u,i).then($=>!!$.limitHit,$=>O.$3($)?!1:Promise.reject($))}}),define(Ne[47],Le([1,0,9,19,64,23,10,4,58,2,11,5,46,206,88,45,24,119,13,18,22,189,7,109,3,26,91,16,74,92,56,94,6,272,87,191,15,85,69,20,86]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n,t,g,u,$,m,h,E,D,b,C,k,f,w,F,N,L,q,H,W,G){"use strict";var Q;Object.defineProperty(e,"__esModule",{value:!0}),e.$uqc=e.$tqc=e.$sqc=e.$rqc=e.$qqc=void 0,v=qe(v),R=qe(R),P=qe(P),l=qe(l),e.$qqc=(0,$.$Fi)("IHostUtils");let ae=Q=class extends T.$Uc{constructor(Y,B,ne,Ee,fe,we,he,X,x,$e,pe,Ae,ze){super(),this.Y=Ae,this.Z=ze,this.a=this.B(new f.$le),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=B,this.g=ne,this.f=he,this.j=Ee,this.m=fe,this.s=we,this.t=x,this.u=$e,this.w=pe,this.y=this.g.getProxy(y.$KN.MainThreadWorkspace),this.z=this.g.getProxy(y.$KN.MainThreadTelemetry),this.C=this.g.getProxy(y.$KN.MainThreadExtensionService),this.D=new A.$Eh,this.F=new A.$Eh,this.G=new A.$Eh,this.H=new A.$Eh,this.I=new ke(this.f.extensions.activationEvents),this.L=new c.$Mdc(this.I,this.f.extensions.allExtensions);const Ie=new i.$sn(this.f.extensions.myExtensions);this.J=new c.$Mdc(this.I,me(this.L,Ie)),W.$u&&(this.s.info(`Creating extension host with the following global extensions: ${_(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${_(this.J)}`)),this.M=new d.$_pc(this.g,this.s),this.N=new F.$jqc(this.g),this.O=X,this.h=this.q.add(Y.createChild(new D.$Di([d.$aqc,this.M],[F.$kqc,this.N]))),this.P=this.B(new S.$$pc(this.J,this.L,{onExtensionActivationError:(Pe,Oe,U)=>{this.C.$onExtensionActivationError(Pe,l.$1(Oe),U)},actualActivateExtension:async(Pe,Oe)=>{if(c.$Mdc.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,Oe),new S.$0pc;const U=this.J.getExtensionDescription(Pe);return this.fb(U,Oe)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Y){l.$Y(Y)}}async $(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(fe=>fe.identifier).filter(fe=>this.isActivated(fe)).map(fe=>this.eb(fe))}catch{}await Promise.all(Y)}terminate(Y,B=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),l.setUnexpectedErrorHandler(Ee=>{this.s.error(Ee)}),this.g.dispose();const ne=this.$();Promise.race([(0,A.$Gh)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const B=await this.C.$getExtension(Y);return B&&{...B,identifier:new i.$rn(B.identifier.value),extensionLocation:o.URI.revive(B.extensionLocation)}}ab(Y,B){return this.P.activateByEvent(Y,B)}bb(Y,B){return this.P.activateById(Y,B)}activateByIdWithErrors(Y,B){return this.bb(Y,B).then(()=>{const ne=this.P.getActivatedExtension(Y);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async cb(Y){if(Y.scheme===L.Schemas.file&&this.c.fsRealpath){const B=Y.fsPath;this.R.has(B)||this.R.set(B,this.c.fsRealpath(B));const ne=await this.R.get(B);return o.URI.file(ne)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Y=>new oe(Y))),this.Q}async db(Y){const B=p.$Li.forUris(ne=>O.$0g.ignorePathCasing(ne));return await Promise.all(Y.map(async ne=>{if(this.wb(ne)){const Ee=await this.cb(ne.extensionLocation);B.set(Ee,ne)}})),B}eb(Y){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return B;const ne=this.P.getActivatedExtension(Y);if(!ne)return B;try{typeof ne.module.deactivate=="function"&&(B=Promise.resolve(ne.module.deactivate()).then(void 0,Ee=>(this.s.error(Ee),Promise.resolve(void 0))))}catch(Ee){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(Ee)}try{ne.disposable.dispose()}catch(Ee){this.s.error(`An error occurred when disposing the subscriptions for extension '${Y.value}':`),this.s.error(Ee)}return B}async fb(Y,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.hb(Y,B).then(ne=>{const Ee=ne.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,Ee.codeLoadingTime,Ee.activateCallTime,Ee.activateResolvedTime,B),this.gb(Y,B,"success",Ee),ne},ne=>{throw this.gb(Y,B,"failure"),ne})}gb(Y,B,ne,Ee){const fe=le(Y,B);this.z.$publicLog2("extensionActivationTimes",{...fe,...Ee||{},outcome:ne})}hb(Y,B){const ne=le(Y,B);this.z.$publicLog2("activatePlugin",ne);const Ee=this.wb(Y);if(!Ee)return Promise.resolve(new S.$9pc(S.$6pc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${Y.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const fe=new T.$Tc,we=new S.$7pc(B.startup);return Promise.all([this.xb(Y,(0,O.$gh)(Y.extensionLocation,Ee),we),this.ib(Y,fe)]).then(he=>(P.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),Q.jb(this.s,Y.identifier,he[0],he[1],fe,we))).then(he=>(P.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),he))}ib(Y,B){const ne=this.Z.createLanguageModelAccessInformation(Y),Ee=B.add(new t.$cqc(Y,this.M)),fe=B.add(new t.$bqc(Y.identifier.value,!1,this.M)),we=B.add(new N.$lqc(Y,this.N)),he=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?g.ExtensionMode.Test:g.ExtensionMode.Development:g.ExtensionMode.Production,X=this.f.remote.isRemote?g.ExtensionKind.Workspace:g.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([Ee.whenReady,fe.whenReady,this.O.whenReady]).then(()=>{const x=this;let $e,pe;const Ae=(0,s.$fH)(Y,"ipc")?this.f.messagePorts?.get(i.$rn.toKey(Y.identifier)):void 0;return Object.freeze({globalState:Ee,workspaceState:fe,secrets:we,subscriptions:[],get languageModelAccessInformation(){return ne},get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(ze){return R.$jc(Y.extensionLocation.fsPath,ze)},get storagePath(){return x.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return x.O.globalValue(Y).fsPath},get logPath(){return R.$jc(x.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return o.URI.joinPath(x.f.logsLocation,Y.identifier.value)},get storageUri(){return x.O.workspaceValue(Y)},get globalStorageUri(){return x.O.globalValue(Y)},get extensionMode(){return he},get extension(){return $e===void 0&&($e=new ce(x,Y.identifier,Y,X,!1)),$e},get extensionRuntime(){return(0,s.$gH)(Y,"extensionRuntime"),x.extensionRuntime},get environmentVariableCollection(){return x.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!pe){if(!Ae)return;const ze=f.Event.buffer(f.Event.fromDOMEventEmitter(Ae,"message",Ie=>Ie.data));Ae.start(),pe={onDidReceiveMessage:ze,postMessage:Ae.postMessage.bind(Ae)}}return pe}})})}static jb(Y,B,ne,Ee,fe,we){return ne=ne||{activate:void 0,deactivate:void 0},this.kb(Y,B,ne,Ee,we).then(he=>new S.$8pc(!1,null,we.build(),ne,he,(0,T.$Sc)(()=>{fe.dispose(),(0,T.$Pc)(Ee.subscriptions)})))}static kb(Y,B,ne,Ee,fe){if(typeof ne.activate=="function")try{fe.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${B.value}`);const we=typeof global=="object"?global:self,he=ne.activate.apply(we,[Ee]);return fe.activateCallStop(),fe.activateResolveStart(),Promise.resolve(he).then(X=>(fe.activateResolveStop(),X))}catch(we){return Promise.reject(we)}else return Promise.resolve(ne)}lb(Y,B){this.bb(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:B}).then(void 0,ne=>{this.s.error(ne)})}mb(Y,B=0){const Ee=Date.now();(0,W.$C)(()=>{for(let fe=B;fe<Y.length;fe+=1){const we=Y[fe];for(const he of we.activationEvents??[])if(he==="onStartupFinished")if(Date.now()-Ee>50){this.mb(Y,fe);break}else this.lb(we,he)}})}nb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(Y=>{const B=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(B)this.mb(ne);else for(const Ee of ne)if(Ee.activationEvents)for(const fe of Ee.activationEvents)fe==="onStartupFinished"&&this.lb(Ee,fe)})}ob(){const Y=this.ab("*",!0).then(void 0,we=>{this.s.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.pb(we.added)));const B=this.j.workspace?this.j.workspace.folders:[],ne=this.pb(B),Ee=this.rb(),fe=Promise.all([Ee,Y,ne]).then(()=>{});return Promise.race([fe,(0,A.$Gh)(1e4)]).then(()=>{this.nb()}),fe}pb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.qb(Y,B))).then(()=>{})}async qb(Y,B){if(this.isActivated(B.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,Ee={logService:this.s,folders:Y.map(we=>we.uri),forceUsingSearch:ne||!this.c.fsExists,exists:we=>this.c.fsExists(we.fsPath),checkExists:(we,he,X)=>this.y.$checkExists(we,he,X)},fe=await(0,w.$Dyb)(Ee,B);if(fe)return this.bb(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:fe.activationEvent}).then(void 0,we=>this.s.error(we))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Y){throw console.error(Y),Y}}async sb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:B}=this.f.environment;if(!Y||!B)throw new Error(v.localize(10836,null));const ne=await this.xb(null,B,new S.$7pc(!1));if(!ne||typeof ne.run!="function")throw new Error(v.localize(10837,null,B.toString()));return new Promise((Ee,fe)=>{const we=(x,$e)=>{x?(W.$u&&this.s.error("Test runner called back with error",x),fe(x)):(W.$u&&($e?this.s.info(`Test runner called back with ${$e} failures.`):this.s.info("Test runner called back with successful outcome.")),Ee(typeof $e=="number"&&$e>0?1:0))},he=(0,O.$7g)(B),X=ne.run(he,we);X&&X.then&&X.then(()=>{W.$u&&this.s.info("Test runner finished successfully."),Ee(0)}).catch(x=>{W.$u&&this.s.error("Test runner finished with error",x),fe(x instanceof Error&&x.stack?x.stack:String(x))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Gh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,B){return this.S[Y]=B,(0,T.$Sc)(()=>{delete this.S[Y]})}async getRemoteExecServer(Y){const{resolver:B}=await this.ub(Y);return B?.resolveExecServer?.(Y,{resolveAttempt:0})}async ub(Y){const B=Y.indexOf("+");if(B===-1)throw new g.$UN("Not an authority that can be resolved!",u.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=Y.substr(0,B);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.S[ne]}}async $resolveAuthority(Y,B){const ne=H.$fe.create(!1),Ee=()=>`[resolveAuthority(${(0,u.$Vl)(Y)},${B})][${ne.elapsed()}ms] `,fe=j=>this.s.info(`${Ee()}${j}`),we=j=>this.s.warn(`${Ee()}${j}`),he=(j,K=void 0)=>this.s.error(`${Ee()}${j}`,K),X=j=>{if(j instanceof g.$UN)return{type:"error",error:{code:j._code,message:j._message,detail:j._detail}};throw j},x=async j=>{fe(`activating resolver for ${j}...`);const{resolver:K,authorityPrefix:V}=await this.ub(j);if(!K)throw he(`no resolver for ${V}`),new g.$UN(`No remote extension installed to resolve ${V}.`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:V,remoteAuthority:j}},$e=Y.split(/@|%40/g).reverse();fe(`activating remote resolvers ${$e.join(" -> ")}`);let pe;try{pe=await Promise.all($e.map(x)).catch(async j=>{if(!(j instanceof g.$UN)||j._code!==u.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw j;return we(`resolving nested authorities failed: ${j.message}`),[await x(Y)]})}catch(j){return X(j)}const Ae=new A.$Qh;Ae.cancelAndSet(()=>fe("waiting..."),1e3);let ze,Ie;for(const[j,{authorityPrefix:K,resolver:V,remoteAuthority:re}]of pe.entries())try{if(j===pe.length-1)fe("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${K}`),ze=await V.resolve(re,{resolveAttempt:B,execServer:Ie}),P.mark(`code/extHost/didResolveAuthorityOK/${K}`),fe("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(V,g.$TN.isManagedResolvedAuthority(ze)?ze:void 0));else{if(fe(`invoking resolveExecServer() for ${re}`),P.mark(`code/extHost/willResolveExecServer/${K}`),Ie=await V.resolveExecServer?.(re,{resolveAttempt:B,execServer:Ie}),!Ie)throw new g.$UN(`Exec server was not available for ${re}`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(ge){return P.mark(`code/extHost/didResolveAuthorityError/${K}`),he("returned an error",ge),Ae.dispose(),X(ge)}Ae.dispose();const Pe={environmentTunnels:ze.environmentTunnels,features:ze.tunnelFeatures?{elevation:ze.tunnelFeatures.elevation,privacyOptions:ze.tunnelFeatures.privacyOptions,protocol:ze.tunnelFeatures.protocol===void 0?!0:ze.tunnelFeatures.protocol}:void 0},Oe={extensionHostEnv:ze.extensionHostEnv,isTrusted:ze.isTrusted,authenticationSession:ze.authenticationSessionForInitializingExtensions?{id:ze.authenticationSessionForInitializingExtensions.id,providerId:ze.authenticationSessionForInitializingExtensions.providerId}:void 0};fe(`returned ${g.$TN.isManagedResolvedAuthority(ze)?"managed authority":`${ze.host}:${ze.port}`}`);let U;if(g.$TN.isManagedResolvedAuthority(ze)){const j=B;this.Y.setFactory(j,ze.makeConnection),U={authority:Y,connectTo:new u.$Sl(j),connectionToken:ze.connectionToken}}else U={authority:Y,connectTo:new u.$Tl(ze.host,ze.port),connectionToken:ze.connectionToken};return{type:"ok",value:{authority:U,options:Oe,tunnelInformation:Pe}}}async $getCanonicalURI(Y,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,u.$Vl)(Y)})`);const{resolver:ne}=await this.ub(Y);if(!ne)return null;const Ee=o.URI.revive(B);if(typeof ne.getCanonicalURI>"u")return Ee;const fe=await(0,A.$xh)(()=>ne.getCanonicalURI(Ee));return fe||Ee}async $startExtensionHost(Y){Y.toAdd.forEach(we=>we.extensionLocation=o.URI.revive(we.extensionLocation));const{globalRegistry:B,myExtensions:ne}=be(this.I,this.L,this.J,Y),Ee=await this.db(ne);return(await this.getExtensionPathIndex()).setSearchTree(Ee),this.L.set(B.getAllExtensionDescriptions()),this.J.set(ne),W.$u&&(this.s.info(`$startExtensionHost: global extensions: ${_(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${_(this.J)}`)),this.tb()}$activateByEvent(Y,B){return B===s.ActivationKind.Immediate?this.D.wait().then(ne=>this.ab(Y,!1)):this.G.wait().then(ne=>this.ab(Y,!1))}async $activate(Y,B){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.bb(Y,B),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(we=>we.extensionLocation=o.URI.revive(we.extensionLocation));const{globalRegistry:B,myExtensions:ne}=be(this.I,this.L,this.J,Y),Ee=await this.db(ne);return(await this.getExtensionPathIndex()).setSearchTree(Ee),this.L.set(B.getAllExtensionDescriptions()),this.J.set(ne),W.$u&&(this.s.info(`$deltaExtensions: global extensions: ${_(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${_(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const B=n.$Ne.alloc(Y),ne=Math.random()%256;for(let Ee=0;Ee<Y;Ee++)B.writeUInt8(ne,Ee);return B}async $updateRemoteConnectionData(Y){this.X=Y,this.a.fire()}};e.$rqc=ae,e.$rqc=ae=Q=Je([Ve(0,$.$Ei),Ve(1,e.$qqc),Ve(2,E.$kQ),Ve(3,r.$Opc),Ve(4,a.$Rpc),Ve(5,I.$ak),Ve(6,m.$AQ),Ve(7,h.$Upc),Ve(8,b.$jGb),Ve(9,C.$dqc),Ve(10,q.$nqc),Ve(11,G.$oqc),Ve(12,k.$hqc)],ae);function be(Te,Y,B,ne){Te.addActivationEvents(ne.addActivationEvents);const Ee=new c.$Mdc(Te,Y.getAllExtensionDescriptions());Ee.deltaExtensions(ne.toAdd,ne.toRemove);const fe=new i.$sn(B.getAllExtensionDescriptions().map(he=>he.identifier));for(const he of ne.myToRemove)fe.delete(he);for(const he of ne.myToAdd)fe.add(he);const we=me(Ee,fe);return{globalRegistry:Ee,myExtensions:we}}function le(Te,Y){return{id:Te.identifier.value,name:Te.name,extensionVersion:Te.version,publisherDisplayName:Te.publisher,activationEvents:Te.activationEvents?Te.activationEvents.join(","):null,isBuiltin:Te.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function _(Te){return Te.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$sqc=(0,$.$Fi)("IExtHostExtensionService");class ce{#e;#t;#i;constructor(Y,B,ne,Ee,fe){this.#e=Y,this.#t=B,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=R.$hc((0,O.$7g)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Ee,this.isFromDifferentExtensionHost=fe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$tqc=ce;function me(Te,Y){return Te.getAllExtensionDescriptions().filter(B=>Y.has(B.identifier))}class oe{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$uqc=oe;class ke{constructor(Y){this.a=new i.$tn,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const B of Object.keys(Y))this.a.set(B,Y[B])}}}),define(Ne[273],Le([1,0,64,2,5,46,24,18,16,26,3,47,11,12]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Frc=void 0,v=qe(v);let r=class{constructor(n,t,g,u,$,m,h){this.c=n,this.d=t,this.e=g,this.f=u,this.g=$,this.h=m,this.i=h,this.a=new Map,this.b=[]}async install(){this.j(),v.mark("code/extHost/willWaitForConfig");const n=await this.f.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new c(this.c,t,this.d,n,this.i)),this.register(this.e.createInstance(s)),this.h.remote.isRemote&&this.register(this.e.createInstance(l,t,this.h.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const t of n.nodeModuleName)this.a.set(t,n);else this.a.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this.b.push(t=>n.alternativeModuleName(t))}};e.$Frc=r,e.$Frc=r=Je([Ve(2,I.$Ei),Ve(3,O.$Rpc),Ve(4,y.$sqc),Ve(5,o.$AQ),Ve(6,a.$ak)],r);let s=class{static{d=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&d.a.size){const t=(0,S.$hf)(this.c(n.environment.appRoot.fsPath)),g="[a-z0-9_.-]",u=`@${g}+\\/${g}+|${g}+`,$="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${$}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(n){if(!this.b)return;const t=this.b.exec(this.c(n));if(!t)return;const[,g,u,$]=t,m=d.a.get(u);if(m!==void 0)return console.warn(`${u} as been renamed to ${m}, please update your imports`),g+m+$}c(n){return n.replace(/\\/g,"/")}};s=d=Je([Ve(0,o.$AQ)],s);class c{constructor(n,t,g,u,$){this.c=n,this.d=t,this.e=g,this.f=u,this.g=$,this.nodeModuleName="vscode",this.a=new T.$tn}load(n,t){const g=this.d.findSubstr(t);if(g){let u=this.a.get(g.identifier);return u||(u=this.c(g,this.e,this.f),this.a.set(g.identifier,u)),u}if(!this.b){let u="";this.d.forEach(($,m)=>u+=`	${m} -> ${$.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${u}`),this.b=this.c(A.$aH,this.e,this.f)}return this.b}}let l=class{constructor(n,t,g){this.e=n,this.f=t,this.nodeModuleName=["open","opn"],this.d=g.getProxy(P.$KN.MainThreadTelemetry);const u=g.getProxy(P.$KN.MainThreadWindow);this.c=($,m)=>{const h=R.URI.parse($);return m?this.g($,m):h.scheme==="http"||h.scheme==="https"?u.$openUri(h,$,{allowTunneling:!0}):h.scheme==="mailto"||h.scheme===this.f?u.$openUri(h,$,{}):this.g($,m)}}load(n,t,g){const u=this.e.findSubstr(t);return u&&(this.a=u.identifier.value,this.h()),this.b=g(n),this.c}g(n,t){return this.i(),this.b(n,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};l=Je([Ve(2,p.$kQ)],l)}),define(Ne[132],Le([1,0,48,4,19,78,3,57,70,47,7,45,203,46]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=e.$vqc=void 0,P=qe(P),O=qe(O),e.$vqc=(0,A.$Fi)("IExtHostVariableResolverProvider");class d extends a.$oR{constructor(c,l,i,n,t,g,u){function $(){if(i){const m=i.activeEditor();if(m)return m.document.uri;const h=n.tabGroups.all.find(E=>E.isActive)?.activeTab;if(h!==void 0){if(h.input instanceof I.$BP||h.input instanceof I.$GP)return h.input.modified;if(h.input instanceof I.$AP||h.input instanceof I.$FP||h.input instanceof I.$DP)return h.input.uri}}}super({getFolderUri:m=>{const h=g.folders.filter(E=>E.name===m);if(h&&h.length>0)return h[0].uri},getWorkspaceFolderCount:()=>g.folders.length,getConfigurationValue:(m,h)=>t.getConfiguration(void 0,m).get(h),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const m=$();if(m)return P.$hc(m.fsPath)},getWorkspaceFolderPathForFile:()=>{if(l){const m=$();if(m){const h=l.getWorkspaceFolder(m);if(h)return P.$hc(h.uri.fsPath)}}},getSelectedText:()=>{if(i){const m=i.activeEditor();if(m&&!m.selection.isEmpty)return m.document.getText(m.selection)}},getLineNumber:()=>{if(i){const m=i.activeEditor();if(m)return String(m.selection.end.line+1)}},getExtension:m=>c.getExtension(m)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(O.env))}}let r=class extends R.$Uc{constructor(c,l,i,n,t){super(),this.b=c,this.c=l,this.g=i,this.h=n,this.j=t,this.a=new v.$T(async()=>{const g=await this.h.getConfigProvider(),$={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async m=>{$.folders=await this.c.getWorkspaceFolders2()||[]})),new d(this.b,this.c,this.g,this.j,g,$,this.m())})}getResolver(){return this.a.value}m(){}};e.$wqc=r,e.$wqc=r=Je([Ve(0,o.$sqc),Ve(1,y.$Opc),Ve(2,T.$vQ),Ve(3,S.$Rpc),Ve(4,p.$4pc)],r)}),define(Ne[133],Le([1,0,10,6,2,4,18,3,5,70,47,16,7,45,195,80,196,46,132,34,33,8,17,95]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gqc=e.$Fqc=e.$Eqc=e.$Dqc=e.$Cqc=void 0,t=qe(t),e.$Cqc=(0,T.$Fi)("IExtHostDebugService");let $=class extends O.$Uc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(k,f,w,F,N,L,q,H){super(),this.Y=f,this.Z=w,this.$=F,this.ab=N,this.bb=L,this.cb=q,this.db=H,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new R.$le),this.z=this.B(new R.$le),this.C=this.B(new R.$le),this.F=this.B(new R.$le),this.u=k.getProxy(p.$KN.MainThreadDebugService),this.I=this.B(new R.$le),this.L=this.B(new R.$le),this.G=new h(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(W=>{this.B(W.onDidChange(G=>{this.fb(W)})),this.fb(W)})}async $getVisualizerTreeItem(k,f){const w=this.gb(f);if(!w)return;const F=await this.Q.get(k)?.getTreeItem?.(w);return F?this.eb(k,F):void 0}registerDebugVisualizationTree(k,f,w){const F=A.$rn.toKey(k.identifier),N=this.ub(F,f);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${f}' is already registered`);return this.Q.set(N,w),this.u.$registerDebugVisualizerTree(N,!!w.editItem),(0,O.$Sc)(()=>{this.u.$unregisterDebugVisualizerTree(N),this.Q.delete(f)})}async $getVisualizerTreeItemChildren(k,f){const w=this.S.get(f)?.item;return w?(await this.Q.get(k)?.getChildren?.(w))?.map(N=>this.eb(k,N))||[]:[]}async $editVisualizerTreeItem(k,f){const w=this.S.get(k);if(!w)return;const F=await this.Q.get(w.provider)?.editItem?.(w.item,f);return this.eb(w.provider,F||w.item)}$disposeVisualizedTree(k){const f=this.S.get(k);if(!f)return;const w=[f.children];for(const F of w)if(F)for(const N of F)w.push(this.S.get(N)?.children),this.S.delete(N)}eb(k,f){let w=this.R.get(f);return w||(w=this.O++,this.R.set(f,w),this.S.set(w,{provider:k,item:f})),t.DebugTreeItem.from(f,w)}asDebugSourceUri(k,f){const w=k;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let F=`debug:${encodeURIComponent(w.path||"")}`,N="?";return f&&(F+=`${N}session=${encodeURIComponent(f.id)}`,N="&"),F+=`${N}ref=${w.sourceReference}`,P.URI.parse(F)}else{if(w.path)return P.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(k){const f=[];for(const w of k.getAllExtensionDescriptions())if(w.contributes){const F=w.contributes.debuggers;if(F&&F.length>0)for(const N of F)(0,s.$_H)(N)&&f.push(N.type)}this.u.$registerDebugTypes(f)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const k=[];return this.H.forEach(f=>k.push(f)),k}async $resolveDebugVisualizer(k,f){const w=this.W.get(k);if(!w)throw new Error(`No debug visualizer found with id '${k}'`);let{v:F,provider:N,extensionId:L}=w;if(F.visualization||(F=await N.resolveDebugVisualization?.(F,f)||F,w.v=F),!F.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.vb(L,F.visualization)}async $executeDebugVisualizerCommand(k){const f=this.W.get(k);if(!f)throw new Error(`No debug visualizer found with id '${k}'`);const w=f.v.visualization;w&&"command"in w&&this.cb.executeCommand(w.command,...w.arguments||[])}gb(k){const f=this.w.get(k.sessionId);return f&&{session:f.api,variable:k.variable,containerId:k.containerId,frameId:k.frameId,threadId:k.threadId}}async $provideDebugVisualizers(k,f,w,F){const N=this.gb(w),L=this.ub(k,f),q=this.P.get(L);if(!N||!q)return[];const H=await q.provideDebugVisualization(N,F);return H?H.map(W=>{const G=++this.X;this.W.set(G,{v:W,provider:q,extensionId:k});const Q=W.iconPath?this.wb(W.iconPath):void 0;return{id:G,name:W.name,iconClass:Q?.iconClass,iconPath:Q?.iconPath,visualization:this.vb(k,W.visualization)}}):[]}$disposeDebugVisualizers(k){for(const f of k)this.W.delete(f)}registerDebugVisualizationProvider(k,f,w){if(!k.contributes?.debugVisualizers?.some(L=>L.id===f))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${f})`);const F=A.$rn.toKey(k.identifier),N=this.ub(F,f);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${f}' is already registered`);return this.P.set(N,w),this.u.$registerDebugVisualizer(F,f),(0,O.$Sc)(()=>{this.u.$unregisterDebugVisualizer(F,f),this.P.delete(f)})}addBreakpoints(k){const f=k.filter(N=>{const L=N.id;return this.H.has(L)?!1:(this.H.set(L,N),!0)});this.rb(f,[],[]);const w=[],F=new Map;for(const N of f)if(N instanceof a.$QO){let L=F.get(N.location.uri.toString());L||(L={type:"sourceMulti",uri:N.location.uri,lines:[]},F.set(N.location.uri.toString(),L),w.push(L)),L.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof a.$RO&&w.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this.u.$registerBreakpoints(w)}removeBreakpoints(k){const f=k.filter(L=>this.H.delete(L.id));this.rb([],f,[]);const w=f.filter(L=>L instanceof a.$QO).map(L=>L.id),F=f.filter(L=>L instanceof a.$RO).map(L=>L.id),N=f.filter(L=>L instanceof a.$SO).map(L=>L.id);return this.u.$unregisterBreakpoints(w,F,N)}startDebugging(k,f,w){const F=w.testRun&&this.db.getMetadataForRun(w.testRun);return this.u.$startDebugging(k?k.uri:void 0,f,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===a.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,testRun:F&&{runId:F.runId,taskId:F.taskId},suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(k){return this.u.$stopDebugging(k?k.id:void 0)}registerDebugConfigurationProvider(k,f,w){if(!f)return new a.$MN(()=>{});const F=this.f++;return this.g.push({type:k,handle:F,provider:f}),this.u.$registerDebugConfigurationProvider(k,w,!!f.provideDebugConfigurations,!!f.resolveDebugConfiguration,!!f.resolveDebugConfigurationWithSubstitutedVariables,F),new a.$MN(()=>{this.g=this.g.filter(N=>N.provider!==f),this.u.$unregisterDebugConfigurationProvider(F)})}registerDebugAdapterDescriptorFactory(k,f,w){if(!w)return new a.$MN(()=>{});if(!this.nb(k,f))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${f}' debugger.`);if(this.kb(f))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const F=this.h++;return this.j.push({type:f,handle:F,factory:w}),this.u.$registerDebugAdapterDescriptorFactory(f,F),new a.$MN(()=>{this.j=this.j.filter(N=>N.factory!==w),this.u.$unregisterDebugAdapterDescriptorFactory(F)})}registerDebugAdapterTrackerFactory(k,f){if(!f)return new a.$MN(()=>{});const w=this.m++;return this.n.push({type:k,handle:w,factory:f}),new a.$MN(()=>{this.n=this.n.filter(F=>F.factory!==f)})}async $runInTerminal(k,f){return Promise.resolve(void 0)}async $substituteVariables(k,f){let w;const F=await this.tb(k);return F&&(w={uri:F.uri,name:F.name,index:F.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(w,f)}hb(k,f){if(k.type==="implementation")return new D(k.implementation)}ib(){}async $startDASession(k,f){const w=this,F=await this.sb(f);return this.pb(this.kb(F.type),F).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}' (extension might have failed to activate)`);const L=this.jb(N),q=this.hb(L,F);if(!q)throw new Error(`Couldn't create a debug adapter for type '${F.type}'.`);const H=q;return this.M.set(k,H),this.ob(F).then(W=>(W&&this.N.set(k,W),H.onMessage(async G=>{if(G.type==="request"&&G.command==="handshake"){const Q=G,ae={type:"response",seq:0,command:Q.command,request_seq:Q.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const be=await this.U.sign(Q.arguments.value);ae.body={signature:be},H.sendResponse(ae)}else throw new Error("no signer")}catch(be){ae.success=!1,ae.message=be.message,H.sendResponse(ae)}}else W&&W.onDidSendMessage&&W.onDidSendMessage(G),G=(0,s.$eI)(G,!0),w.u.$acceptDAMessage(k,G)}),H.onError(G=>{W&&W.onError&&W.onError(G),this.u.$acceptDAError(k,G.name,G.message,G.stack)}),H.onExit(G=>{W&&W.onExit&&W.onExit(G??void 0,void 0),this.u.$acceptDAExit(k,G??void 0,void 0)}),W&&W.onWillStartSession&&W.onWillStartSession(),H.startSession()))})}$sendDAMessage(k,f){f=(0,s.$dI)(f,!1);const w=this.N.get(k);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(f),this.M.get(k)?.sendMessage(f)}$stopDASession(k){const f=this.N.get(k);this.N.delete(k),f&&f.onWillStopSession&&f.onWillStopSession();const w=this.M.get(k);return this.M.delete(k),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(k){const f=[],w=[],F=[];if(k.added)for(const N of k.added){const L=N.id;if(L&&!this.H.has(L)){let q;if(N.type==="function")q=new a.$RO(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")q=new a.$SO(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const H=P.URI.revive(N.uri);q=new a.$QO(new a.$1N(H,new a.$NN(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,a.$OO)(q,L),this.H.set(L,q),f.push(q)}}if(k.removed)for(const N of k.removed){const L=this.H.get(N);L&&(this.H.delete(N),w.push(L))}if(k.changed){for(const N of k.changed)if(N.id){const L=this.H.get(N.id);if(L){if(L instanceof a.$RO&&N.type==="function"){const q=L;q.enabled=N.enabled,q.condition=N.condition,q.hitCondition=N.hitCondition,q.logMessage=N.logMessage,q.functionName=N.functionName}else if(L instanceof a.$QO&&N.type==="source"){const q=L;q.enabled=N.enabled,q.condition=N.condition,q.hitCondition=N.hitCondition,q.logMessage=N.logMessage,q.location=new a.$1N(P.URI.revive(N.uri),new a.$NN(N.line,N.character))}F.push(L)}}}this.rb(f,w,F)}async $acceptStackFrameFocus(k){let f;if(k){const w=await this.sb(k.sessionId);k.kind==="thread"?f=new a.$YO(w.api,k.threadId):f=new a.$XO(w.api,k.threadId,k.frameId)}this.J=f,this.L.fire(this.J)}$provideDebugConfigurations(k,f,w){return(0,v.$xh)(async()=>{const F=this.mb(k);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.tb(f);return F.provideDebugConfigurations(N,w)}).then(F=>{if(!F)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return F})}$resolveDebugConfiguration(k,f,w,F){return(0,v.$xh)(async()=>{const N=this.mb(k);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.tb(f);return N.resolveDebugConfiguration(L,w,F)})}$resolveDebugConfigurationWithSubstitutedVariables(k,f,w,F){return(0,v.$xh)(async()=>{const N=this.mb(k);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.tb(f);return N.resolveDebugConfigurationWithSubstitutedVariables(L,w,F)})}async $provideDebugAdapter(k,f){const w=this.lb(k);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const F=await this.sb(f);return this.pb(w,F).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}'`);return this.jb(N)})}async $acceptDebugSessionStarted(k){const f=await this.sb(k);this.y.fire(f.api)}async $acceptDebugSessionTerminated(k){const f=await this.sb(k);f&&(this.z.fire(f.api),this.w.delete(f.id))}async $acceptDebugSessionActiveChanged(k){this.D=k?await this.sb(k):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(k,f){(await this.sb(k))?._acceptNameChanged(f)}async $acceptDebugSessionCustomEvent(k,f){const F={session:(await this.sb(k)).api,event:f.event,body:f.body};this.F.fire(F)}jb(k){if(k instanceof a.$TO)return{type:"executable",command:k.command,args:k.args,options:k.options};if(k instanceof a.$UO)return{type:"server",port:k.port,host:k.host};if(k instanceof a.$VO)return{type:"pipeServer",path:k.path};if(k instanceof a.$WO)return{type:"implementation",implementation:k.implementation};throw new Error("convertToDto unexpected type")}kb(k){const f=this.j.filter(w=>w.type===k);if(f.length>0)return f[0].factory}lb(k){const f=this.j.filter(w=>w.handle===k);if(f.length>0)return f[0].factory}mb(k){const f=this.g.filter(w=>w.handle===k);if(f.length>0)return f[0].provider}nb(k,f){if(k.contributes){const w=k.contributes.debuggers;if(w&&w.length>0){for(const F of w)if(F.label&&F.type&&F.type===f)return!0}}return!1}ob(k){const w=k.configuration.type,F=this.n.filter(N=>N.type===w||N.type==="*").map(N=>(0,v.$xh)(()=>N.factory.createDebugAdapterTracker(k.api)).then(L=>L,L=>null));return Promise.race([Promise.all(F).then(N=>{const L=(0,g.$Gb)(N);if(L.length>0)return new E(L)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async pb(k,f){const w=f.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new a.$UO(w));if(k){const N=await this.Z.getExtensionRegistry();return(0,v.$xh)(()=>k.createDebugAdapterDescriptor(f.api,this.qb(f,N))).then(L=>{if(L)return L})}const F=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(f,F))}qb(k,f){}rb(k,f,w){(k.length>0||f.length>0||w.length>0)&&this.I.fire(Object.freeze({added:k,removed:f,changed:w}))}async sb(k){if(k)if(typeof k=="string"){const f=this.w.get(k);if(f)return f}else{let f=this.w.get(k.id);if(!f){const w=await this.tb(k.folderUri),F=k.parent?this.w.get(k.parent):void 0;f=new m(this.u,k.id,k.type,k.name,w,k.configuration,F?.api),this.w.set(f.id,f),this.u.$sessionCached(f.id)}return f}throw new Error("cannot find session")}tb(k){if(k){const f=P.URI.revive(k);return this.Y.resolveWorkspaceFolder(f)}return Promise.resolve(void 0)}ub(k,f){return`${k}\0${f}`}vb(k,f){if(f){if("title"in f&&"command"in f)return{type:r.DebugVisualizationType.Command};if("treeId"in f)return{type:r.DebugVisualizationType.Tree,id:`${k}\0${f.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(k){const f=this.xb(k);let w,F;return"id"in f?F=i.ThemeIcon.asClassName(f):w=f,{iconPath:w,iconClass:F}}xb(k){if(k instanceof a.$LO)return{id:k.id};const f=typeof k=="object"&&"dark"in k?k.dark:k,w=typeof k=="object"&&"light"in k?k.light:k;return{dark:typeof f=="string"?P.URI.file(f):f,light:typeof w=="string"?P.URI.file(w):w}}};e.$Dqc=$,e.$Dqc=$=Je([Ve(0,y.$kQ),Ve(1,S.$Opc),Ve(2,I.$sqc),Ve(3,c.$Rpc),Ve(4,o.$4pc),Ve(5,l.$vqc),Ve(6,n.$GQ),Ve(7,u.$xqc)],$);class m{constructor(k,f,w,F,N,L,q){this.f=k,this.g=f,this.h=w,this.j=F,this.k=N,this.l=L,this.m=q}get api(){const k=this;return this.d??=Object.freeze({id:k.g,type:k.h,get name(){return k.j},set name(f){k.j=f,k.f.$setDebugSessionName(k.g,f)},parentSession:k.m,workspaceFolder:k.k,configuration:k.l,customRequest(f,w){return k.f.$customDebugAdapterRequest(k.g,f,w)},getDebugProtocolBreakpoint(f){return k.f.$getDebugProtocolBreakpoint(k.g,f.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(k){this.j=k}get configuration(){return this.l}}e.$Eqc=m;class h{constructor(k){this.value=Object.freeze({append(f){k.$appendDebugConsole(f)},appendLine(f){this.append(f+`
`)}})}}e.$Fqc=h;class E{constructor(k){this.d=k}onWillStartSession(){this.d.forEach(k=>k.onWillStartSession?k.onWillStartSession():void 0)}onWillReceiveMessage(k){this.d.forEach(f=>f.onWillReceiveMessage?f.onWillReceiveMessage(k):void 0)}onDidSendMessage(k){this.d.forEach(f=>f.onDidSendMessage?f.onDidSendMessage(k):void 0)}onWillStopSession(){this.d.forEach(k=>k.onWillStopSession?k.onWillStopSession():void 0)}onError(k){this.d.forEach(f=>f.onError?f.onError(k):void 0)}onExit(k,f){this.d.forEach(w=>w.onExit?w.onExit(k,f):void 0)}}class D extends d.$0tb{constructor(k){super(),this.h=k,k.onDidSendMessage(f=>{this.acceptMessage(f)})}startSession(){return Promise.resolve(void 0)}sendMessage(k){this.h.handleMessage(k)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let b=class extends ${constructor(k,f,w,F,N,L,q,H){super(k,f,w,F,N,L,q,H)}};e.$Gqc=b,e.$Gqc=b=Je([Ve(0,y.$kQ),Ve(1,S.$Opc),Ve(2,I.$sqc),Ve(3,c.$Rpc),Ve(4,o.$4pc),Ve(5,l.$vqc),Ve(6,n.$GQ),Ve(7,u.$xqc)],b)}),define(Ne[274],Le([1,0,13,64,2,5,224,11,60,74,26,170,16,65,47,66]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hrc=e.$Grc=void 0,v=qe(v),R=qe(R);class s{static async installEarlyHandler(i){Error.stackTraceLimit=100;const n=i.get(T.$ak),g=i.get(a.$kQ).getProxy(O.$KN.MainThreadErrors);v.setUnexpectedErrorHandler(u=>{n.error(u);const $=v.$1(u);g.$onUnexpectedError($)})}static async installFullHandler(i){const n=i.get(T.$ak),t=i.get(a.$kQ),g=i.get(d.$sqc),u=i.get(r.$EQ),$=t.getProxy(O.$KN.MainThreadExtensionService),m=t.getProxy(O.$KN.MainThreadErrors),h=await g.getExtensionPathIndex(),E=new WeakMap;function D(k,f){if(E.has(k))return E.get(k).stack;let w="",F,N;for(const q of f)w+=`
	at ${q.toString()}`,N=q.getFileName(),!F&&N&&(F=h.findSubstr(P.URI.file(N)));const L=`${k.name||"Error"}: ${k.message||""}${w}`;return E.set(k,{extensionIdentifier:F?.identifier,stack:L}),L}const b=Symbol("prepareStackTrace wrapped");let C=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return C},set(k){if(k===D||!k||k[b]){C=k||D;return}C=function(f,w){return D(f,w),k.call(Error,f,w)},Object.assign(C,{[b]:!0})}}),v.setUnexpectedErrorHandler(k=>{n.error(k);const f=v.$1(k),w=E.get(k);if(!w?.extensionIdentifier){m.$onUnexpectedError(f);return}$.$onExtensionRuntimeError(w.extensionIdentifier,f);const F=u.onExtensionError(w.extensionIdentifier,k);n.trace("forwarded error to extension?",F,w)})}}e.$Grc=s;class c{constructor(i,n,t,g,u){this.a=t,this.b=new A.$Udc(i,null,g),n=c.e(n,this.b);const $=new o.$Di(...(0,p.$Ss)());$.set(I.$AQ,{_serviceBrand:void 0,...n,messagePorts:u}),$.set(a.$kQ,new a.$lQ(this.b)),$.set(S.$Lpc,new S.$Mpc(g)),$.set(d.$qqc,t);const m=new y.$wr($,!0);m.invokeFunction(s.installEarlyHandler),this.d=m.invokeFunction(h=>h.get(T.$ak)),R.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",n),this.c=m.invokeFunction(h=>h.get(d.$sqc)),this.c.initialize(),m.invokeFunction(s.installFullHandler)}async asBrowserUri(i){const n=this.b.getProxy(O.$KN.MainThreadExtensionService);return P.URI.revive(await n.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,n){i.extensions.allExtensions.forEach(g=>{g.extensionLocation=P.URI.revive(n.transformIncomingURIs(g.extensionLocation))}),i.environment.appRoot=P.URI.revive(n.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(g=>P.URI.revive(n.transformIncomingURIs(g)))),i.environment.extensionTestsLocationURI=P.URI.revive(n.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=P.URI.revive(n.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=P.URI.revive(n.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=P.URI.revive(n.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=P.URI.revive(n.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=P.URI.revive(n.transformIncomingURIs(i.logsLocation)),i.workspace=n.transformIncomingURIs(i.workspace),i}}e.$Hrc=c}),define(Ne[275],Le([1,0,17,10,21,42,15,19,23,2,44]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xqc=e.$Vqc=e.$Uqc=void 0,e.$Wqc=r,T=qe(T),p=qe(p);class y{constructor(l,i,n){this.d=l,this.e=i,this.f=n,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(l,i){const n=this.g.folderQueries||[],t=new P.$we(i);return new Promise((g,u)=>{this.a=new S(l);let $=!1;const m=(h,E)=>{if(!$&&!this.b){const D=this.h(h);r(h)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,$=!0,t.cancel(),h=this.j(h,this.g.maxResults-this.c));const b=this.h(h);this.c+=b,(b>0||!r(h))&&this.a.add(h,E)}};Promise.all(n.map((h,E)=>this.k(h,D=>m(D,E),t.token))).then(h=>{t.dispose(),this.a.flush();const E=h.some(D=>!!D&&!!D.limitHit);g({limitHit:this.b||E,messages:h.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},h=>{t.dispose();const E=(0,O.$qj)(h);u(new Error(E))})})}h(l){return r(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}j(l,i){const n=Array.isArray(l.ranges)?l.ranges:[l.ranges],t=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:n.slice(0,i),preview:{matches:t.slice(0,i),text:l.preview.text},uri:l.uri}}async k(l,i,n){const t=new I.$oM(this.g,l),g=[],u={report:h=>{if(!this.l(h))return;const E=l.folder.scheme===A.Schemas.file?(0,I.$pM)(()=>this.e.readdir(p.$fh(h.uri))):void 0,D=p.$ih(l.folder,h.uri);if(D){const b=t.includedInQuery(D,T.$nc(D),E);(0,R.$rh)(b)?g.push(b.then(C=>{C&&i(h)})):b&&i(h)}}},$=this.n(l);let m;return this.d.query.type===I.QueryType.aiText?m=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,$,u,n):m=await this.d.provider.provideTextSearchResults(a(this.d.query.contentPattern),$,u,n),g.length&&await Promise.all(g),m}l(l){if(r(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(l){const i=(0,I.$nM)(this.g.includePattern,l.includePattern),n=(0,I.$nM)(this.g.excludePattern,l.excludePattern),t={folder:o.URI.from(l.folder),excludes:n,includes:i,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.e.toCanonicalName(l.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??I.$7L,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$Uqc=y;function a(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class S{constructor(l){this.e=l,this.b=-1,this.d=null,this.a=new s(512,i=>this.g(i))}add(l,i){this.d&&(this.b!==i||!p.$_g(this.c,l.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:l.uri,results:[]}),this.d.results.push(d(l))}f(){const l=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,l)}flush(){this.f(),this.a.flush()}g(l){this.e(l)}}e.$Vqc=S;function d(c){return r(c)?{preview:{matches:(0,v.$Zb)(c.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:c.preview.text},ranges:(0,v.$Zb)(c.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:c.text,lineNumber:c.lineNumber}}function r(c){return!!c.preview}class s{static{this.a=4e3}static{this.b=50}constructor(l,i){this.g=l,this.h=i,this.c=0,this.d=[],this.e=0}addItem(l,i){l&&this.j(l,i)}addItems(l,i){l&&this.k(l,i)}j(l,i){this.d.push(l),this.e+=i,this.l()}k(l,i){this.d=this.d.concat(l),this.e+=i,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Xqc=s}),define(Ne[134],Le([1,0,4,5,3,270,16,65,11,2,275]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zqc=e.$Yqc=void 0,e.$1qc=a,e.$Yqc=(0,P.$Fi)("IExtHostSearch");let y=class{constructor(r,s,c){this.n=r,this.o=s,this.q=c,this.c=this.n.getProxy(R.$KN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$Tqc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,s){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const c=this.d++;return this.e.set(c,s),this.c.$registerTextSearchProvider(c,this.s(r)),(0,v.$Sc)(()=>{this.g.delete(r),this.e.delete(c),this.c.$unregisterProvider(c)})}registerAITextSearchProvider(r,s){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const c=this.d++;return this.h.set(c,s),this.c.$registerAITextSearchProvider(c,this.s(r)),(0,v.$Sc)(()=>{this.i.delete(r),this.h.delete(c),this.c.$unregisterProvider(c)})}registerFileSearchProvider(r,s){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const c=this.d++;return this.j.set(c,s),this.c.$registerFileSearchProvider(c,this.s(r)),(0,v.$Sc)(()=>{this.k.delete(r),this.j.delete(c),this.c.$unregisterProvider(c)})}$provideFileSearchResults(r,s,c,l){const i=a(c),n=this.j.get(r);if(n)return this.l.fileSearch(i,n,t=>{this.c.$handleFileMatch(r,s,t.map(g=>g.resource))},l);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,s,c){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,s,c,l){const i=this.e.get(r);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${r}`);const n=a(c);return this.t(n,i).search(g=>this.c.$handleTextMatch(r,s,g),l)}$provideAITextSearchResults(r,s,c,l){const i=this.h.get(r);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${r}`);const n=a(c);return this.v(n,i).search(g=>this.c.$handleTextMatch(r,s,g),l)}$enableExtensionHostSearch(){}t(r,s){return new I.$Uqc({query:r,provider:s},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}v(r,s){return new I.$Uqc({query:r,provider:s},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"aiTextSearchProvider")}};e.$Zqc=y,e.$Zqc=y=Je([Ve(0,A.$kQ),Ve(1,T.$Lpc),Ve(2,p.$ak)],y);function a(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(S),extraFileResources:d.extraFileResources&&d.extraFileResources.map(r=>o.URI.revive(r))}}function S(d){return{...d,folder:o.URI.revive(d.folder)}}});var xt=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[276],Le([1,0,10,21,13,6,4,15,35,2,105,157,158,52,18,29,11,62,63,185,5,227,256,84,90,232,233,234,211,201,33,235,46,236,133,122,237,213,228,238,239,57,70,214,229,47,241,68,242,50,26,257,215,243,244,94,245,85,86,217,269,247,190,248,258,249,128,218,250,251,252,16,253,134,87,254,219,255,88,91,131,66,56,126,95,259,230,260,261,92,8,7,220,65,221,67,262,263,121,45,80,83,24,130]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n,t,g,u,$,m,h,E,D,b,C,k,f,w,F,N,L,q,H,W,G,Q,ae,be,le,_,ce,me,oe,ke,Te,Y,B,ne,Ee,fe,we,he,X,x,$e,pe,Ae,ze,Ie,Pe,Oe,U,j,K,V,re,ge,Ce,Ue,Qe,_e,tt,nt,et,rt,ft,lt,st,ct,mt,$t,We,je,ie,ee,Z,Xe,xe,ht,wt,Ft,Kt,_t,ei,oi,At,Ze,Ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Brc=hi,P=qe(P),p=xt(p),a=qe(a),r=qe(r),ee=qe(ee),Z=qe(Z);function hi(pt){const Dt=pt.get(Te.$AQ),ti=pt.get(ke.$wpc),ii=pt.get(me.$Tpc),jt=pt.get(_.$sqc),gt=pt.get(ei.$Opc),Ut=pt.get(ft.$EQ),ni=pt.get(f.$Rpc),ai=pt.get(xe.$Lpc),Ge=pt.get(re.$kQ),ci=pt.get(nt.$aqc),di=pt.get(et.$Upc),fi=pt.get(s.$bk),vt=pt.get(s.$ak),Mt=pt.get(ie.$jGb),Nt=pt.get(u.$spc),qt=pt.get(_t.$Arc),ri=pt.get(Ue.$kqc),Ht=pt.get(ae.$4pc),li=pt.get(X.$oqc),Bt=pt.get($.$Cpc),Qt=pt.get(fe.$hqc);Ge.set(n.$LN.ExtHostFileSystemInfo,ti),Ge.set(n.$LN.ExtHostLogLevelServiceShape,fi),Ge.set(n.$LN.ExtHostWorkspace,gt),Ge.set(n.$LN.ExtHostConfiguration,ni),Ge.set(n.$LN.ExtHostExtensionService,jt),Ge.set(n.$LN.ExtHostStorage,ci),Ge.set(n.$LN.ExtHostTunnelService,Mt),Ge.set(n.$LN.ExtHostWindow,qt),Ge.set(n.$LN.ExtHostSecretState,ri),Ge.set(n.$LN.ExtHostTelemetry,Ut),Ge.set(n.$LN.ExtHostEditorTabs,Ht),Ge.set(n.$LN.ExtHostManagedSockets,li),Ge.set(n.$LN.ExtHostAuthentication,Bt),Ge.set(n.$LN.ExtHostChatProvider,Qt);const Gt=Ge.set(n.$LN.ExtHostDecorations,pt.get(N.$Iqc)),Lt=Ge.set(n.$LN.ExtHostDocumentsAndEditors,pt.get(Q.$vQ)),bt=Ge.set(n.$LN.ExtHostCommands,pt.get(C.$GQ)),kt=Ge.set(n.$LN.ExtHostTerminalService,pt.get(lt.$dqc)),Vt=Ge.set(n.$LN.ExtHostTerminalShellIntegration,pt.get(st.$qrc)),It=Ge.set(n.$LN.ExtHostDebugService,pt.get(F.$Cqc)),mi=Ge.set(n.$LN.ExtHostSearch,pt.get(Ce.$Yqc)),Yt=Ge.set(n.$LN.ExtHostTask,pt.get(rt.$prc)),ki=Ge.set(n.$LN.ExtHostOutputService,pt.get(Oe.$crc)),bi=Ge.set(n.$LN.ExtHostLocalization,pt.get(he.$nqc)),Ai=Ge.set(n.$LN.ExtHostUrls,new ht.$xrc(Ge)),Tt=Ge.set(n.$LN.ExtHostDocuments,new G.$zpc(Ge,Lt)),Ni=Ge.set(n.$LN.ExtHostDocumentContentProviders,new H.$Kqc(Ge,Lt,vt)),ui=Ge.set(n.$LN.ExtHostDocumentSaveParticipant,new W.$Lqc(vt,Tt,Ge.getProxy(n.$KN.MainThreadBulkEdits))),Pt=Ge.set(n.$LN.ExtHostNotebook,new $e.$2qc(Ge,bt,Lt,Tt,ii,mi,vt)),Ti=Ge.set(n.$LN.ExtHostNotebookDocuments,new Ae.$9qc(Pt)),Ii=Ge.set(n.$LN.ExtHostNotebookEditors,new ze.$0qc(vt,Pt)),Di=Ge.set(n.$LN.ExtHostNotebookKernels,new Ie.$$qc(Ge,Dt,Pt,bt,vt)),Li=Ge.set(n.$LN.ExtHostNotebookRenderers,new Pe.$arc(Ge,Pt)),wi=Ge.set(n.$LN.ExtHostNotebookDocumentSaveParticipant,new pe.$8qc(vt,Pt,Ge.getProxy(n.$KN.MainThreadBulkEdits))),Wt=Ge.set(n.$LN.ExtHostEditors,new mt.$Ipc(Ge,Lt)),De=Ge.set(n.$LN.ExtHostTreeViews,new je.$vrc(Ge.getProxy(n.$KN.MainThreadTreeViews),bt,vt)),Re=Ge.set(n.$LN.ExtHostEditorInsets,new b.$Jpc(Ge.getProxy(n.$KN.MainThreadEditorInsets),Wt,Dt.remote)),de=Ge.set(n.$LN.ExtHostDiagnostics,new L.$ypc(Ge,vt,ti,Lt)),J=Ge.set(n.$LN.ExtHostLanguages,new we.$6qc(Ge,Tt,bt.converter,ai)),ye=Ge.set(n.$LN.ExtHostLanguageFeatures,new ne.$Apc(Ge,ai,Tt,bt,de,vt,Nt,Ut)),Be=Ge.set(n.$LN.ExtHostFileSystem,new ce.$Oqc(Ge,ye)),Ye=Ge.set(n.$LN.ExtHostFileSystemEventService,new oe.$Pqc(Ge,vt,Lt)),Ke=Ge.set(n.$LN.ExtHostQuickOpen,(0,V.$grc)(Ge,gt,bt)),ut=Ge.set(n.$LN.ExtHostSCM,new ge.$irc(Ge,bt,Tt,vt)),Rt=Ge.set(n.$LN.ExtHostQuickDiff,new K.$frc(Ge,ai)),Jt=Ge.set(n.$LN.ExtHostShare,new Qe.$jrc(Ge,ai)),si=Ge.set(n.$LN.ExtHostComments,(0,k.$Kpc)(Ge,bt,Tt)),zt=Ge.set(n.$LN.ExtHostProgress,new j.$erc(Ge.getProxy(n.$KN.MainThreadProgress))),Zt=Ge.set(n.$LN.ExtHostLabelService,new B.$4qc(Ge)),qi=Ge.set(n.$LN.ExtHostTheming,new $t.$src(Ge)),rn=Ge.set(n.$LN.ExtHostTimeline,new We.$urc(Ge,bt)),Vi=Ge.set(n.$LN.ExtHostWebviews,new wt.$Ypc(Ge,Dt.remote,gt,vt,Nt)),Mi=Ge.set(n.$LN.ExtHostWebviewPanels,new Ft.$2pc(Ge,Vi,gt)),Ki=Ge.set(n.$LN.ExtHostCustomEditors,new w.$3pc(Ge,Tt,di,Vi,Mi)),Qi=Ge.set(n.$LN.ExtHostWebviewViews,new Kt.$yrc(Ge,Vi)),Ci=Ge.set(n.$LN.ExtHostTesting,pt.get(ct.$xqc)),sn=Ge.set(n.$LN.ExtHostUriOpeners,new Xe.$wrc(Ge)),on=Ge.set(n.$LN.ExtHostProfileContentHandlers,new U.$drc(Ge));Ge.set(n.$LN.ExtHostInteractive,new Y.$3qc(Ge,Pt,Lt,bt,vt));const zi=Ge.set(n.$LN.ExtHostChatAgents2,new h.$Fpc(Ge,vt,bt,Tt)),an=Ge.set(n.$LN.ExtHostChatVariables,new E.$Gpc(Ge)),Ui=Ge.set(n.$LN.ExtHostLanguageModelTools,new Ee.$5qc(Ge)),Hi=Ge.set(n.$LN.ExtHostAiRelatedInformation,new t.$rpc(Ge)),En=Ge.set(n.$LN.ExtHostAiEmbeddingVector,new le.$Nqc(Ge)),cn=Ge.set(n.$LN.ExtHostStatusBar,new tt.$mrc(Ge,bt.converter)),Gi=Ge.set(n.$LN.ExtHostSpeech,new _e.$krc(Ge)),Pi=Ge.set(n.$LN.ExtHostEmbeddings,new be.$Mqc(Ge)),Dn=Object.values(n.$LN);Ge.assertRegistered(Dn);const Sn=new m.$Epc(Ge,Lt),ln=new D.$Hpc(Ge),Ji=new x.$7qc(Ge,vt),Xi=new q.$Jqc(Ge);return g.$Bpc.register(bt),function(Me,vi,Yi){function ot(te){return(ue,Fe,at)=>{const yt=te(Ot=>{try{ue.call(Fe,Ot)}catch(gi){P.$Z(new Error(`[ExtensionListenerError] Extension '${Me.identifier.value}' FAILED to handle event: ${gi.toString()}`,{cause:gi})),Ut.onExtensionError(Me.identifier,gi)}});return at?.push(yt),yt}}const St=function(){let te=!Me.isUnderDevelopment;function ue(){te||(vt.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Fe(at){if(Array.isArray(at))at.forEach(Fe);else if(typeof at=="string")ue();else{const yt=at;typeof yt.scheme>"u"&&ue(),typeof yt.exclusive=="boolean"&&(0,Ze.$gH)(Me,"documentFiltersExclusive")}return at}}(),Zi={getSession(te,ue,Fe){return typeof Fe?.forceNewSession=="object"&&Fe.forceNewSession.learnMore&&(0,Ze.$gH)(Me,"authLearnMore"),Fe?.account&&(0,Ze.$gH)(Me,"authGetSessions"),Bt.getSession(Me,te,ue,Fe)},getAccounts(te){return(0,Ze.$gH)(Me,"authGetSessions"),Bt.getAccounts(te)},async hasSession(te,ue){return(0,Ze.$gH)(Me,"authSession"),!!await Bt.getSession(Me,te,ue,{silent:!0})},get onDidChangeSessions(){return ot(Bt.onDidChangeSessions)},registerAuthenticationProvider(te,ue,Fe,at){return Bt.registerAuthenticationProvider(te,ue,Fe,at)}},un={registerCommand(te,ue,Fe){return bt.registerCommand(!0,te,ue,Fe,void 0,Me)},registerTextEditorCommand(te,ue,Fe){return bt.registerCommand(!0,te,(...at)=>{const yt=Wt.getActiveTextEditor();if(!yt){vt.warn("Cannot execute "+te+" because there is no active text editor.");return}return yt.edit(Ot=>{ue.apply(Fe,[yt,Ot,...at])}).then(Ot=>{Ot||vt.warn("Edits from command "+te+" were not applied.")},Ot=>{vt.warn("An error occurred while running command "+te,Ot)})},void 0,void 0,Me)},registerDiffInformationCommand:(te,ue,Fe)=>((0,Ze.$gH)(Me,"diffCommand"),bt.registerCommand(!0,te,async(...at)=>{const yt=Lt.activeEditor(!0);if(!yt){vt.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ot=await Wt.getDiffInformation(yt.id);ue.apply(Fe,[Ot,...at])},void 0,void 0,Me)),executeCommand(te,...ue){return bt.executeCommand(te,...ue)},getCommands(te=!1){return bt.getCommands(te)}},yi={get machineId(){return Dt.telemetryInfo.machineId},get sessionId(){return Dt.telemetryInfo.sessionId},get language(){return Dt.environment.appLanguage},get appName(){return Dt.environment.appName},get appRoot(){return Dt.environment.appRoot?.fsPath??""},get appHost(){return Dt.environment.appHost},get uriScheme(){return Dt.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return kt.getDefaultShell(!1)},get onDidChangeShell(){return ot(kt.onDidChangeShell)},get isTelemetryEnabled(){return Ut.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Ut.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.$gH)(Me,"telemetry"),Ut.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$gH)(Me,"telemetry"),ot(Ut.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ft.$DQ)(Dt.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,ue){return ft.$CQ.validateSender(te),Ut.instantiateLogger(Me,te,ue)},openExternal(te,ue){return qt.openUri(te,{allowTunneling:!!Dt.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===Dt.environment.appUriScheme)return Ai.createAppUri(te);try{return await qt.asExternalUri(te,{allowTunneling:!!Dt.remote.authority})}catch(ue){if((0,T.$Og)(te,T.Schemas.http)||(0,T.$Og)(te,T.Schemas.https))return te;throw ue}},get remoteName(){return(0,c.$in)(Dt.remote.authority)},get remoteAuthority(){return(0,Ze.$gH)(Me,"resolvers"),Dt.remote.authority},get uiKind(){return Dt.uiKind},get logLevel(){return vt.getLevel()},get onDidChangeLogLevel(){return ot(vt.onDidChangeLogLevel)},get appQuality(){return(0,Ze.$gH)(Me,"resolvers"),Dt.quality},get appCommit(){return(0,Ze.$gH)(Me,"resolvers"),Dt.commit}};Dt.environment.extensionTestsLocationURI||Object.freeze(yi);const ji={createTestController(te,ue,Fe){return Ci.createTestController(Me,te,ue,Fe)},createTestObserver(){return(0,Ze.$gH)(Me,"testObserver"),Ci.createTestObserver()},runTests(te){return(0,Ze.$gH)(Me,"testObserver"),Ci.runTests(te)},registerTestFollowupProvider(te){return(0,Ze.$gH)(Me,"testObserver"),Ci.registerTestFollowupProvider(te)},get onDidChangeTestResults(){return(0,Ze.$gH)(Me,"testObserver"),ot(Ci.onResultsChanged)},get testResults(){return(0,Ze.$gH)(Me,"testObserver"),Ci.results}},Bi=Dt.remote.isRemote?Z.ExtensionKind.Workspace:Z.ExtensionKind.UI,pi={getExtension(te,ue){(0,Ze.$fH)(Me,"extensionsAny")||(ue=!1);const Fe=vi.mine.getExtensionDescription(te);if(Fe)return new _.$tqc(jt,Me.identifier,Fe,Bi,!1);if(ue){const at=vi.all.getExtensionDescription(te);if(at)return new _.$tqc(jt,Me.identifier,at,Bi,!0)}},get all(){const te=[];for(const ue of vi.mine.getAllExtensionDescriptions())te.push(new _.$tqc(jt,Me.identifier,ue,Bi,!1));return te},get allAcrossExtensionHosts(){(0,Ze.$gH)(Me,"extensionsAny");const te=new d.$sn(vi.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),ue=[];for(const Fe of vi.all.getAllExtensionDescriptions()){const at=!te.has(Fe.identifier);ue.push(new _.$tqc(jt,Me.identifier,Fe,Bi,at))}return ue},get onDidChange(){return(0,Ze.$fH)(Me,"extensionsAny")?ot(O.Event.any(vi.mine.onDidChange,vi.all.onDidChange)):ot(vi.mine.onDidChange)}},Wi={createDiagnosticCollection(te){return de.createDiagnosticCollection(Me.identifier,te)},get onDidChangeDiagnostics(){return ot(de.onDidChangeDiagnostics)},getDiagnostics:te=>de.getDiagnostics(te),getLanguages(){return J.getLanguages()},setTextDocumentLanguage(te,ue){return J.changeLanguage(te.uri,ue)},match(te,ue){const Fe=ee.LanguageSelector.from(te);let at;return(0,y.$xu)(Fe)&&(at=Pt.notebookDocuments.find(yt=>yt.apiNotebook.getCells().find(Ot=>Ot.document===ue))?.apiNotebook),(0,y.$wu)(Fe,ue.uri,ue.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(te,ue,Fe){return ye.registerCodeActionProvider(Me,St(te),ue,Fe)},registerDocumentPasteEditProvider(te,ue,Fe){return(0,Ze.$gH)(Me,"documentPaste"),ye.registerDocumentPasteEditProvider(Me,St(te),ue,Fe)},registerCodeLensProvider(te,ue){return ye.registerCodeLensProvider(Me,St(te),ue)},registerDefinitionProvider(te,ue){return ye.registerDefinitionProvider(Me,St(te),ue)},registerDeclarationProvider(te,ue){return ye.registerDeclarationProvider(Me,St(te),ue)},registerImplementationProvider(te,ue){return ye.registerImplementationProvider(Me,St(te),ue)},registerTypeDefinitionProvider(te,ue){return ye.registerTypeDefinitionProvider(Me,St(te),ue)},registerHoverProvider(te,ue){return ye.registerHoverProvider(Me,St(te),ue,Me.identifier)},registerEvaluatableExpressionProvider(te,ue){return ye.registerEvaluatableExpressionProvider(Me,St(te),ue,Me.identifier)},registerInlineValuesProvider(te,ue){return ye.registerInlineValuesProvider(Me,St(te),ue,Me.identifier)},registerDocumentHighlightProvider(te,ue){return ye.registerDocumentHighlightProvider(Me,St(te),ue)},registerMultiDocumentHighlightProvider(te,ue){return ye.registerMultiDocumentHighlightProvider(Me,St(te),ue)},registerLinkedEditingRangeProvider(te,ue){return ye.registerLinkedEditingRangeProvider(Me,St(te),ue)},registerReferenceProvider(te,ue){return ye.registerReferenceProvider(Me,St(te),ue)},registerRenameProvider(te,ue){return ye.registerRenameProvider(Me,St(te),ue)},registerNewSymbolNamesProvider(te,ue){return(0,Ze.$gH)(Me,"newSymbolNamesProvider"),ye.registerNewSymbolNamesProvider(Me,St(te),ue)},registerDocumentSymbolProvider(te,ue,Fe){return ye.registerDocumentSymbolProvider(Me,St(te),ue,Fe)},registerWorkspaceSymbolProvider(te){return ye.registerWorkspaceSymbolProvider(Me,te)},registerDocumentFormattingEditProvider(te,ue){return ye.registerDocumentFormattingEditProvider(Me,St(te),ue)},registerDocumentRangeFormattingEditProvider(te,ue){return ye.registerDocumentRangeFormattingEditProvider(Me,St(te),ue)},registerOnTypeFormattingEditProvider(te,ue,Fe,...at){return ye.registerOnTypeFormattingEditProvider(Me,St(te),ue,[Fe].concat(at))},registerDocumentSemanticTokensProvider(te,ue,Fe){return ye.registerDocumentSemanticTokensProvider(Me,St(te),ue,Fe)},registerDocumentRangeSemanticTokensProvider(te,ue,Fe){return ye.registerDocumentRangeSemanticTokensProvider(Me,St(te),ue,Fe)},registerSignatureHelpProvider(te,ue,Fe,...at){return typeof Fe=="object"?ye.registerSignatureHelpProvider(Me,St(te),ue,Fe):ye.registerSignatureHelpProvider(Me,St(te),ue,typeof Fe>"u"?[]:[Fe,...at])},registerCompletionItemProvider(te,ue,...Fe){return ye.registerCompletionItemProvider(Me,St(te),ue,Fe)},registerInlineCompletionItemProvider(te,ue,Fe){return ue.handleDidShowCompletionItem&&(0,Ze.$gH)(Me,"inlineCompletionsAdditions"),ue.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$gH)(Me,"inlineCompletionsAdditions"),Fe&&(0,Ze.$gH)(Me,"inlineCompletionsAdditions"),ye.registerInlineCompletionsProvider(Me,St(te),ue,Fe)},registerInlineEditProvider(te,ue){return(0,Ze.$gH)(Me,"inlineEdit"),ye.registerInlineEditProvider(Me,St(te),ue)},registerDocumentLinkProvider(te,ue){return ye.registerDocumentLinkProvider(Me,St(te),ue)},registerColorProvider(te,ue){return ye.registerColorProvider(Me,St(te),ue)},registerFoldingRangeProvider(te,ue){return ye.registerFoldingRangeProvider(Me,St(te),ue)},registerSelectionRangeProvider(te,ue){return ye.registerSelectionRangeProvider(Me,te,ue)},registerCallHierarchyProvider(te,ue){return ye.registerCallHierarchyProvider(Me,te,ue)},registerTypeHierarchyProvider(te,ue){return ye.registerTypeHierarchyProvider(Me,te,ue)},setLanguageConfiguration:(te,ue)=>ye.setLanguageConfiguration(Me,te,ue),getTokenInformationAtPosition(te,ue){return(0,Ze.$gH)(Me,"tokenInformation"),J.tokenAtPosition(te,ue)},registerInlayHintsProvider(te,ue){return ye.registerInlayHintsProvider(Me,te,ue)},createLanguageStatusItem(te,ue){return J.createLanguageStatusItem(Me,te,ue)},registerDocumentDropEditProvider(te,ue,Fe){return ye.registerDocumentOnDropEditProvider(Me,te,ue,(0,Ze.$fH)(Me,"documentPaste")?Fe:void 0)}},hn={get activeTextEditor(){return Wt.getActiveTextEditor()},get visibleTextEditors(){return Wt.getVisibleTextEditors()},get activeTerminal(){return kt.activeTerminal},get terminals(){return kt.terminals},async showTextDocument(te,ue,Fe){o.URI.isUri(te)&&te.scheme===T.Schemas.vscodeRemote&&!te.authority&&Nt.report("workspace.showTextDocument",Me,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(o.URI.isUri(te)?Promise.resolve(xi.openTextDocument(te)):Promise.resolve(te));return Wt.showTextDocument(at,ue,Fe)},createTextEditorDecorationType(te){return Wt.createTextEditorDecorationType(Me,te)},onDidChangeActiveTextEditor(te,ue,Fe){return ot(Wt.onDidChangeActiveTextEditor)(te,ue,Fe)},onDidChangeVisibleTextEditors(te,ue,Fe){return ot(Wt.onDidChangeVisibleTextEditors)(te,ue,Fe)},onDidChangeTextEditorSelection(te,ue,Fe){return ot(Wt.onDidChangeTextEditorSelection)(te,ue,Fe)},onDidChangeTextEditorOptions(te,ue,Fe){return ot(Wt.onDidChangeTextEditorOptions)(te,ue,Fe)},onDidChangeTextEditorVisibleRanges(te,ue,Fe){return ot(Wt.onDidChangeTextEditorVisibleRanges)(te,ue,Fe)},onDidChangeTextEditorViewColumn(te,ue,Fe){return ot(Wt.onDidChangeTextEditorViewColumn)(te,ue,Fe)},onDidCloseTerminal(te,ue,Fe){return ot(kt.onDidCloseTerminal)(te,ue,Fe)},onDidOpenTerminal(te,ue,Fe){return ot(kt.onDidOpenTerminal)(te,ue,Fe)},onDidChangeActiveTerminal(te,ue,Fe){return ot(kt.onDidChangeActiveTerminal)(te,ue,Fe)},onDidChangeTerminalDimensions(te,ue,Fe){return(0,Ze.$gH)(Me,"terminalDimensions"),ot(kt.onDidChangeTerminalDimensions)(te,ue,Fe)},onDidChangeTerminalState(te,ue,Fe){return ot(kt.onDidChangeTerminalState)(te,ue,Fe)},onDidWriteTerminalData(te,ue,Fe){return(0,Ze.$gH)(Me,"terminalDataWriteEvent"),ot(kt.onDidWriteTerminalData)(te,ue,Fe)},onDidExecuteTerminalCommand(te,ue,Fe){return(0,Ze.$gH)(Me,"terminalExecuteCommandEvent"),ot(kt.onDidExecuteTerminalCommand)(te,ue,Fe)},onDidChangeTerminalShellIntegration(te,ue,Fe){return(0,Ze.$gH)(Me,"terminalShellIntegration"),ot(Vt.onDidChangeTerminalShellIntegration)(te,ue,Fe)},onDidStartTerminalShellExecution(te,ue,Fe){return(0,Ze.$gH)(Me,"terminalShellIntegration"),ot(Vt.onDidStartTerminalShellExecution)(te,ue,Fe)},onDidEndTerminalShellExecution(te,ue,Fe){return(0,Ze.$gH)(Me,"terminalShellIntegration"),ot(Vt.onDidEndTerminalShellExecution)(te,ue,Fe)},get state(){return qt.getState()},onDidChangeWindowState(te,ue,Fe){return ot(qt.onDidChangeWindowState)(te,ue,Fe)},showInformationMessage(te,...ue){return Ji.showMessage(Me,p.default.Info,te,ue[0],ue.slice(1))},showWarningMessage(te,...ue){return Ji.showMessage(Me,p.default.Warning,te,ue[0],ue.slice(1))},showErrorMessage(te,...ue){return Ji.showMessage(Me,p.default.Error,te,ue[0],ue.slice(1))},showQuickPick(te,ue,Fe){return Ke.showQuickPick(Me,te,ue,Fe)},showWorkspaceFolderPick(te){return Ke.showWorkspaceFolderPick(te)},showInputBox(te,ue){return Ke.showInput(te,ue)},showOpenDialog(te){return Xi.showOpenDialog(Me,te)},showSaveDialog(te){return Xi.showSaveDialog(te)},createStatusBarItem(te,ue,Fe){let at,yt,Ot;return typeof te=="string"?(at=te,yt=ue,Ot=Fe):(yt=te,Ot=ue),cn.createStatusBarEntry(Me,at,yt,Ot)},setStatusBarMessage(te,ue){return cn.setStatusBarMessage(te,ue)},withScmProgress(te){return Nt.report("window.withScmProgress",Me,"Use 'withProgress' instead."),zt.withProgress(Me,{location:Z.ProgressLocation.SourceControl},(ue,Fe)=>te({report(at){}}))},withProgress(te,ue){return zt.withProgress(Me,te,ue)},createOutputChannel(te,ue){return ki.createOutputChannel(te,ue,Me)},createWebviewPanel(te,ue,Fe,at){return Mi.createWebviewPanel(Me,te,ue,Fe,at)},createWebviewTextEditorInset(te,ue,Fe,at){return(0,Ze.$gH)(Me,"editorInsets"),Re.createWebviewEditorInset(te,ue,Fe,at,Me)},createTerminal(te,ue,Fe){return typeof te=="object"?"pty"in te?kt.createExtensionTerminal(te):kt.createTerminalFromOptions(te):kt.createTerminal(te,ue,Fe)},registerTerminalLinkProvider(te){return kt.registerLinkProvider(te)},registerTerminalProfileProvider(te,ue){return kt.registerProfileProvider(Me,te,ue)},registerTerminalQuickFixProvider(te,ue){return(0,Ze.$gH)(Me,"terminalQuickFixProvider"),kt.registerTerminalQuickFixProvider(te,Me.identifier.value,ue)},registerTreeDataProvider(te,ue){return De.registerTreeDataProvider(te,ue,Me)},createTreeView(te,ue){return De.createTreeView(te,ue,Me)},registerWebviewPanelSerializer:(te,ue)=>Mi.registerWebviewPanelSerializer(Me,te,ue),registerCustomEditorProvider:(te,ue,Fe={})=>Ki.registerCustomEditorProvider(Me,te,ue,Fe),registerFileDecorationProvider(te){return Gt.registerFileDecorationProvider(te,Me)},registerUriHandler(te){return Ai.registerUriHandler(Me,te)},createQuickPick(){return Ke.createQuickPick(Me)},createInputBox(){return Ke.createInputBox(Me)},get activeColorTheme(){return qi.activeColorTheme},onDidChangeActiveColorTheme(te,ue,Fe){return ot(qi.onDidChangeActiveColorTheme)(te,ue,Fe)},registerWebviewViewProvider(te,ue,Fe){return Qi.registerWebviewViewProvider(Me,te,ue,Fe?.webviewOptions)},get activeNotebookEditor(){return Pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,ue,Fe){return ot(Pt.onDidChangeActiveNotebookEditor)(te,ue,Fe)},get visibleNotebookEditors(){return Pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Pt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(te,ue,Fe){return ot(Ii.onDidChangeNotebookEditorSelection)(te,ue,Fe)},onDidChangeNotebookEditorVisibleRanges(te,ue,Fe){return ot(Ii.onDidChangeNotebookEditorVisibleRanges)(te,ue,Fe)},showNotebookDocument(te,ue){return Pt.showNotebookDocument(te,ue)},registerExternalUriOpener(te,ue,Fe){return(0,Ze.$gH)(Me,"externalUriOpener"),sn.registerExternalUriOpener(Me.identifier,te,ue,Fe)},registerProfileContentHandler(te,ue){return(0,Ze.$gH)(Me,"profileContentHandlers"),on.registerProfileContentHandler(Me,te,ue)},registerQuickDiffProvider(te,ue,Fe,at){return(0,Ze.$gH)(Me,"quickDiffProvider"),Rt.registerQuickDiffProvider(St(te),ue,Fe,at)},get tabGroups(){return Ht.tabGroups},registerShareProvider(te,ue){return(0,Ze.$gH)(Me,"shareProvider"),Jt.registerShareProvider(St(te),ue)}},xi={get rootPath(){return Nt.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(te){throw new P.$8("rootPath")},getWorkspaceFolder(te){return gt.getWorkspaceFolder(te)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(te){throw new P.$8("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(te){throw new P.$8("workspaceFile")},updateWorkspaceFolders:(te,ue,...Fe)=>gt.updateWorkspaceFolders(Me,te,ue||0,...Fe),onDidChangeWorkspaceFolders:function(te,ue,Fe){return ot(gt.onDidChangeWorkspace)(te,ue,Fe)},asRelativePath:(te,ue)=>gt.getRelativePath(te,ue),findFiles:(te,ue,Fe,at)=>gt.findFiles(te,ue,Fe,Me.identifier,at),findFiles2:(te,ue,Fe)=>((0,Ze.$gH)(Me,"findFiles2"),gt.findFiles2(te,ue,Me.identifier,Fe)),findFiles2New:(te,ue,Fe)=>{(0,Ze.$gH)(Me,"findFiles2New");const at={exclude:ue?.exclude&&ue.exclude.length>0?ue.exclude[0]:void 0,useDefaultExcludes:!ue?.useExcludeSettings||ue?.useExcludeSettings===Ct.ExcludeSettingOptions.filesExclude||ue?.useExcludeSettings===Ct.ExcludeSettingOptions.searchAndFilesExclude,useDefaultSearchExcludes:!ue?.useExcludeSettings||ue?.useExcludeSettings===Ct.ExcludeSettingOptions.searchAndFilesExclude,maxResults:ue?.maxResults,useIgnoreFiles:ue?.useIgnoreFiles?.local,useGlobalIgnoreFiles:ue?.useIgnoreFiles?.global,useParentIgnoreFiles:ue?.useIgnoreFiles?.parent,followSymlinks:ue?.followSymlinks};return gt.findFiles2(te&&te.length>0?te[0]:void 0,at,Me.identifier,Fe)},findTextInFiles:(te,ue,Fe,at)=>{(0,Ze.$gH)(Me,"findTextInFiles");let yt,Ot;return typeof ue=="object"?(yt=ue,Ot=Fe):(yt={},Ot=ue,at=Fe),gt.findTextInFiles(te,yt||{},Ot,Me.identifier,at)},findTextInFilesNew:(te,ue,Fe)=>{(0,Ze.$gH)(Me,"findTextInFilesNew"),(0,Ze.$gH)(Me,"textSearchProviderNew");let at={};ue&&(at={include:ue.include&&ue.include.length>0?ue.include[0]:void 0,exclude:ue.exclude&&ue.exclude.length>0?ue.exclude[0]:void 0,useDefaultExcludes:ue.useExcludeSettings===void 0||ue.useExcludeSettings===Ct.ExcludeSettingOptions.filesExclude||ue.useExcludeSettings===Ct.ExcludeSettingOptions.searchAndFilesExclude,useSearchExclude:ue.useExcludeSettings===void 0||ue.useExcludeSettings===Ct.ExcludeSettingOptions.searchAndFilesExclude,maxResults:ue.maxResults,useIgnoreFiles:ue.useIgnoreFiles?.local,useGlobalIgnoreFiles:ue.useIgnoreFiles?.global,useParentIgnoreFiles:ue.useIgnoreFiles?.parent,followSymlinks:ue.followSymlinks,encoding:ue.encoding,previewOptions:ue.previewOptions?{matchLines:ue.previewOptions?.matchLines??100,charsPerLine:ue.previewOptions?.charsPerLine??1e4}:void 0,beforeContext:ue.surroundingContext,afterContext:ue.surroundingContext});const yt=Promise.resolve(void 0);return{results:new v.$6h(async gi=>{const Fi=async en=>(gi.emitOne((0,Ct.$1L)(en)),en);await yt.then(en=>gt.findTextInFiles(te,at,Fi,Me.identifier,Fe))}),complete:yt.then(gi=>({limitHit:gi?.limitHit??!1}))}},save:te=>gt.save(te),saveAs:te=>gt.saveAs(te),saveAll:te=>gt.saveAll(te),applyEdit(te,ue){return Sn.applyWorkspaceEdit(te,Me,ue)},createFileSystemWatcher:(te,ue,Fe,at)=>{let yt;return typeof ue=="boolean"?yt={ignoreCreateEvents:!!ue,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!at,correlate:!1}:ue&&((0,Ze.$gH)(Me,"createFileSystemWatcher"),yt={...ue,correlate:!0}),Ye.createFileSystemWatcher(gt,Me,te,yt)},get textDocuments(){return Tt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new P.$8("textDocuments")},openTextDocument(te){let ue;const Fe=te;if(typeof te=="string")ue=Promise.resolve(o.URI.file(te));else if(o.URI.isUri(te))ue=Promise.resolve(te);else if(!Fe||typeof Fe=="object")ue=Tt.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(at=>(at.scheme===T.Schemas.vscodeRemote&&!at.authority&&Nt.report("workspace.openTextDocument",Me,"A URI of 'vscode-remote' scheme requires an authority."),Tt.ensureDocumentData(at).then(yt=>yt.document)))},onDidOpenTextDocument:(te,ue,Fe)=>ot(Tt.onDidAddDocument)(te,ue,Fe),onDidCloseTextDocument:(te,ue,Fe)=>ot(Tt.onDidRemoveDocument)(te,ue,Fe),onDidChangeTextDocument:(te,ue,Fe)=>ot(Tt.onDidChangeDocument)(te,ue,Fe),onDidSaveTextDocument:(te,ue,Fe)=>ot(Tt.onDidSaveDocument)(te,ue,Fe),onWillSaveTextDocument:(te,ue,Fe)=>ot(ui.getOnWillSaveTextDocumentEvent(Me))(te,ue,Fe),get notebookDocuments(){return Pt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,ue){let Fe;if(o.URI.isUri(te))Fe=te,await Pt.openNotebookDocument(te);else if(typeof te=="string")Fe=o.URI.revive(await Pt.createNotebookDocument({viewType:te,content:ue}));else throw new Error("Invalid arguments");return Pt.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(te,ue,Fe){return ot(Ti.onDidSaveNotebookDocument)(te,ue,Fe)},onDidChangeNotebookDocument(te,ue,Fe){return ot(Ti.onDidChangeNotebookDocument)(te,ue,Fe)},onWillSaveNotebookDocument(te,ue,Fe){return ot(wi.getOnWillSaveNotebookDocumentEvent(Me))(te,ue,Fe)},get onDidOpenNotebookDocument(){return ot(Pt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Pt.onDidCloseNotebookDocument)},registerNotebookSerializer(te,ue,Fe,at){return Pt.registerNotebookSerializer(Me,te,ue,Fe,(0,Ze.$fH)(Me,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(te,ue,Fe)=>ot(Yi.onDidChangeConfiguration)(te,ue,Fe),getConfiguration(te,ue){return ue=arguments.length===1?void 0:ue,Yi.getConfiguration(te,ue,Me)},registerTextDocumentContentProvider(te,ue){return Ni.registerTextDocumentContentProvider(te,ue)},registerTaskProvider:(te,ue)=>(Nt.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),Yt.registerTaskProvider(Me,te,ue)),registerFileSystemProvider(te,ue,Fe){return(0,A.$Rc)(Be.registerFileSystemProvider(Me,te,ue,Fe),ii.addFileSystemProvider(te,ue,Fe))},get fs(){return ii.value},registerFileSearchProvider:(te,ue)=>((0,Ze.$gH)(Me,"fileSearchProvider"),mi.registerFileSearchProvider(te,ue)),registerTextSearchProvider:(te,ue)=>((0,Ze.$gH)(Me,"textSearchProvider"),mi.registerTextSearchProvider(te,ue)),registerAITextSearchProvider:(te,ue)=>((0,Ze.$gH)(Me,"aiTextSearchProvider"),(0,Ze.$gH)(Me,"textSearchProvider"),mi.registerAITextSearchProvider(te,ue)),registerFileSearchProviderNew:(te,ue)=>((0,Ze.$gH)(Me,"fileSearchProviderNew"),{dispose:()=>{}}),registerTextSearchProviderNew:(te,ue)=>((0,Ze.$gH)(Me,"textSearchProviderNew"),{dispose:()=>{}}),registerAITextSearchProviderNew:(te,ue)=>((0,Ze.$gH)(Me,"aiTextSearchProviderNew"),(0,Ze.$gH)(Me,"textSearchProviderNew"),{dispose:()=>{}}),registerRemoteAuthorityResolver:(te,ue)=>((0,Ze.$gH)(Me,"resolvers"),jt.registerRemoteAuthorityResolver(te,ue)),registerResourceLabelFormatter:te=>((0,Ze.$gH)(Me,"resolvers"),Zt.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Ze.$gH)(Me,"resolvers"),jt.getRemoteExecServer(te)),onDidCreateFiles:(te,ue,Fe)=>ot(Ye.onDidCreateFile)(te,ue,Fe),onDidDeleteFiles:(te,ue,Fe)=>ot(Ye.onDidDeleteFile)(te,ue,Fe),onDidRenameFiles:(te,ue,Fe)=>ot(Ye.onDidRenameFile)(te,ue,Fe),onWillCreateFiles:(te,ue,Fe)=>ot(Ye.getOnWillCreateFileEvent(Me))(te,ue,Fe),onWillDeleteFiles:(te,ue,Fe)=>ot(Ye.getOnWillDeleteFileEvent(Me))(te,ue,Fe),onWillRenameFiles:(te,ue,Fe)=>ot(Ye.getOnWillRenameFileEvent(Me))(te,ue,Fe),openTunnel:te=>((0,Ze.$gH)(Me,"tunnels"),Mt.openTunnel(Me,te).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Ze.$gH)(Me,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:(te,ue,Fe)=>((0,Ze.$gH)(Me,"tunnels"),ot(Mt.onDidChangeTunnels)(te,ue,Fe)),registerPortAttributesProvider:(te,ue)=>((0,Ze.$gH)(Me,"portsAttributes"),Mt.registerPortsAttributesProvider(te,ue)),registerTunnelProvider:(te,ue)=>((0,Ze.$gH)(Me,"tunnelFactory"),Mt.registerTunnelProvider(te,ue)),registerTimelineProvider:(te,ue)=>((0,Ze.$gH)(Me,"timeline"),rn.registerTimelineProvider(te,ue,Me.identifier,bt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:te=>((0,Ze.$gH)(Me,"workspaceTrust"),gt.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,ue,Fe)=>ot(gt.onDidGrantWorkspaceTrust)(te,ue,Fe),registerEditSessionIdentityProvider:(te,ue)=>((0,Ze.$gH)(Me,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(te,ue)),onWillCreateEditSessionIdentity:(te,ue,Fe)=>((0,Ze.$gH)(Me,"editSessionIdentityProvider"),ot(gt.getOnWillCreateEditSessionIdentityEvent(Me))(te,ue,Fe)),registerCanonicalUriProvider:(te,ue)=>((0,Ze.$gH)(Me,"canonicalUriProvider"),gt.registerCanonicalUriProvider(te,ue)),getCanonicalUri:(te,ue,Fe)=>((0,Ze.$gH)(Me,"canonicalUriProvider"),gt.provideCanonicalUri(te,ue,Fe))},dn={get inputBox(){return Nt.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),ut.getLastInputBox(Me)},createSourceControl(te,ue,Fe){return ut.createSourceControl(Me,te,ue,Fe)}},fn={createCommentController(te,ue){return si.createCommentController(Me,te,ue)}},kn={get activeDebugSession(){return It.activeDebugSession},get activeDebugConsole(){return It.activeDebugConsole},get breakpoints(){return It.breakpoints},get activeStackItem(){return It.activeStackItem},registerDebugVisualizationProvider(te,ue){return(0,Ze.$gH)(Me,"debugVisualization"),It.registerDebugVisualizationProvider(Me,te,ue)},registerDebugVisualizationTreeProvider(te,ue){return(0,Ze.$gH)(Me,"debugVisualization"),It.registerDebugVisualizationTree(Me,te,ue)},onDidStartDebugSession(te,ue,Fe){return ot(It.onDidStartDebugSession)(te,ue,Fe)},onDidTerminateDebugSession(te,ue,Fe){return ot(It.onDidTerminateDebugSession)(te,ue,Fe)},onDidChangeActiveDebugSession(te,ue,Fe){return ot(It.onDidChangeActiveDebugSession)(te,ue,Fe)},onDidReceiveDebugSessionCustomEvent(te,ue,Fe){return ot(It.onDidReceiveDebugSessionCustomEvent)(te,ue,Fe)},onDidChangeBreakpoints(te,ue,Fe){return ot(It.onDidChangeBreakpoints)(te,ue,Fe)},onDidChangeActiveStackItem(te,ue,Fe){return ot(It.onDidChangeActiveStackItem)(te,ue,Fe)},registerDebugConfigurationProvider(te,ue,Fe){return It.registerDebugConfigurationProvider(te,ue,Fe||oi.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,ue){return It.registerDebugAdapterDescriptorFactory(Me,te,ue)},registerDebugAdapterTrackerFactory(te,ue){return It.registerDebugAdapterTrackerFactory(te,ue)},startDebugging(te,ue,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?It.startDebugging(te,ue,{parentSession:Fe}):It.startDebugging(te,ue,Fe||{})},stopDebugging(te){return It.stopDebugging(te)},addBreakpoints(te){return It.addBreakpoints(te)},removeBreakpoints(te){return It.removeBreakpoints(te)},asDebugSourceUri(te,ue){return It.asDebugSourceUri(te,ue)}},gn={registerTaskProvider:(te,ue)=>Yt.registerTaskProvider(Me,te,ue),fetchTasks:te=>Yt.fetchTasks(te),executeTask:te=>Yt.executeTask(Me,te),get taskExecutions(){return Yt.taskExecutions},onDidStartTask:(te,ue,Fe)=>ot(Yt.onDidStartTask)(te,ue,Fe),onDidEndTask:(te,ue,Fe)=>ot(Yt.onDidEndTask)(te,ue,Fe),onDidStartTaskProcess:(te,ue,Fe)=>ot(Yt.onDidStartTaskProcess)(te,ue,Fe),onDidEndTaskProcess:(te,ue,Fe)=>ot(Yt.onDidEndTaskProcess)(te,ue,Fe)},mn={createNotebookController(te,ue,Fe,at,yt){return Di.createNotebookController(Me,te,ue,Fe,at,(0,Ze.$fH)(Me,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(te,ue)=>Pt.registerNotebookCellStatusBarItemProvider(Me,te,ue),createRendererMessaging(te){return Li.createRendererMessaging(Me,te)},createNotebookControllerDetectionTask(te){return(0,Ze.$gH)(Me,"notebookKernelSource"),Di.createNotebookControllerDetectionTask(Me,te)},registerKernelSourceActionProvider(te,ue){return(0,Ze.$gH)(Me,"notebookKernelSource"),Di.registerKernelSourceActionProvider(Me,te,ue)},onDidChangeNotebookCellExecutionState(te,ue,Fe){return(0,Ze.$gH)(Me,"notebookCellExecutionState"),ot(Di.onDidChangeNotebookCellExecutionState)(te,ue,Fe)}},In={t(...te){if(typeof te[0]=="string"){const ue=te.shift(),Fe=!te||typeof te[0]!="object"?te:te[0];return bi.getMessage(Me.identifier.value,{message:ue,args:Fe})}return bi.getMessage(Me.identifier.value,te[0])},get bundle(){return bi.getBundle(Me.identifier.value)},get uri(){return bi.getBundleUri(Me.identifier.value)}},Cn={_version:1,transferActiveChat(te){return(0,Ze.$gH)(Me,"interactive"),zi.transferActiveChat(te)}},pn={getRelatedInformation(te,ue){return(0,Ze.$gH)(Me,"aiRelatedInformation"),Hi.getRelatedInformation(Me,te,ue)},registerRelatedInformationProvider(te,ue){return(0,Ze.$gH)(Me,"aiRelatedInformation"),Hi.registerRelatedInformationProvider(Me,te,ue)},registerEmbeddingVectorProvider(te,ue){return(0,Ze.$gH)(Me,"aiRelatedInformation"),En.registerEmbeddingVectorProvider(Me,te,ue)}},_i={_version:1,registerChatResponseProvider(te,ue,Fe){return(0,Ze.$gH)(Me,"chatProvider"),Qt.registerLanguageModel(Me,te,ue,Fe)},registerChatVariableResolver(te,ue,Fe,at,yt,Ot,gi,Fi){return(0,Ze.$gH)(Me,"chatVariableResolver"),an.registerVariableResolver(Me,te,ue,Fe,at,yt,Ot,gi,Fi?.id)},registerMappedEditsProvider(te,ue){return(0,Ze.$gH)(Me,"mappedEditsProvider"),ye.registerMappedEditsProvider(Me,te,ue)},createChatParticipant(te,ue){return zi.createChatAgent(Me,te,ue)},createDynamicChatParticipant(te,ue,Fe){return(0,Ze.$gH)(Me,"chatParticipantPrivate"),zi.createDynamicChatAgent(Me,te,ue,Fe)}},$n={selectChatModels:te=>Qt.selectLanguageModels(Me,te??{}),onDidChangeChatModels:(te,ue,Fe)=>Qt.onDidChangeProviders(te,ue,Fe),registerChatModelProvider:(te,ue,Fe)=>((0,Ze.$gH)(Me,"chatProvider"),Qt.registerLanguageModel(Me,te,ue,Fe)),get embeddingModels(){return(0,Ze.$gH)(Me,"embeddings"),Pi.embeddingsModels},onDidChangeEmbeddingModels:(te,ue,Fe)=>((0,Ze.$gH)(Me,"embeddings"),Pi.onDidChange(te,ue,Fe)),registerEmbeddingsProvider(te,ue){return(0,Ze.$gH)(Me,"embeddings"),Pi.registerEmbeddingsProvider(Me,te,ue)},async computeEmbeddings(te,ue,Fe){return(0,Ze.$gH)(Me,"embeddings"),Pi.computeEmbeddings(te,ue,Fe)},registerTool(te,ue){return(0,Ze.$gH)(Me,"lmTools"),Ui.registerTool(Me,te,ue)},invokeTool(te,ue,Fe){return(0,Ze.$gH)(Me,"lmTools"),Ui.invokeTool(te,ue,Fe)},get tools(){return(0,Ze.$gH)(Me,"lmTools"),Ui.tools}},bn={registerSpeechProvider(te,ue){return(0,Ze.$gH)(Me,"speech"),Gi.registerProvider(Me.identifier,te,ue)}};return{version:Dt.version,ai:pn,authentication:Zi,commands:un,comments:fn,chat:_i,debug:kn,env:yi,extensions:pi,interactive:Cn,l10n:In,languages:Wi,lm:$n,notebooks:mn,scm:dn,speech:bn,tasks:gn,tests:ji,window:hn,workspace:xi,Breakpoint:Z.$PO,TerminalOutputAnchor:Z.TerminalOutputAnchor,ChatResultFeedbackKind:Z.ChatResultFeedbackKind,ChatVariableLevel:Z.ChatVariableLevel,ChatCompletionItem:Z.$LP,CallHierarchyIncomingCall:Z.$bO,CallHierarchyItem:Z.$aO,CallHierarchyOutgoingCall:Z.$cO,CancellationError:P.$4,CancellationTokenSource:R.$we,CandidatePortSource:n.CandidatePortSource,CodeAction:Z.$0N,CodeActionKind:Z.$$N,CodeActionTriggerKind:Z.CodeActionTriggerKind,CodeLens:Z.$dO,Color:Z.$qO,ColorInformation:Z.$rO,ColorPresentation:Z.$sO,ColorThemeKind:Z.ColorThemeKind,CommentMode:Z.CommentMode,CommentState:Z.CommentState,CommentThreadCollapsibleState:Z.CommentThreadCollapsibleState,CommentThreadState:Z.CommentThreadState,CommentThreadApplicability:Z.CommentThreadApplicability,CommentThreadFocus:Z.CommentThreadFocus,CompletionItem:Z.$kO,CompletionItemKind:Z.CompletionItemKind,CompletionItemTag:Z.CompletionItemTag,CompletionList:Z.$lO,CompletionTriggerKind:Z.CompletionTriggerKind,ConfigurationTarget:Z.ConfigurationTarget,CustomExecution:Z.$AO,DebugAdapterExecutable:Z.$TO,DebugAdapterInlineImplementation:Z.$WO,DebugAdapterNamedPipeServer:Z.$VO,DebugAdapterServer:Z.$UO,DebugConfigurationProviderTriggerKind:oi.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Z.DebugConsoleMode,DebugVisualization:Z.$aP,DecorationRangeBehavior:Z.DecorationRangeBehavior,Diagnostic:Z.$3N,DiagnosticRelatedInformation:Z.$2N,DiagnosticSeverity:Z.DiagnosticSeverity,DiagnosticTag:Z.DiagnosticTag,Disposable:Z.$MN,DocumentHighlight:Z.$6N,DocumentHighlightKind:Z.DocumentHighlightKind,MultiDocumentHighlight:Z.$7N,DocumentLink:Z.$pO,DocumentSymbol:Z.$9N,EndOfLine:Z.EndOfLine,EnvironmentVariableMutatorType:Z.EnvironmentVariableMutatorType,EvaluatableExpression:Z.$ZO,InlineValueText:Z.$1O,InlineValueVariableLookup:Z.$2O,InlineValueEvaluatableExpression:Z.$3O,InlineCompletionTriggerKind:Z.InlineCompletionTriggerKind,EventEmitter:O.$le,ExtensionKind:Z.ExtensionKind,ExtensionMode:Z.ExtensionMode,ExternalUriOpenerPriority:Z.ExternalUriOpenerPriority,FileChangeType:Z.FileChangeType,FileDecoration:Z.$cP,FileDecoration2:Z.$cP,FileSystemError:Z.$6O,FileType:r.FileType,FilePermission:r.FilePermission,FoldingRange:Z.$7O,FoldingRangeKind:Z.FoldingRangeKind,FunctionBreakpoint:Z.$RO,InlineCompletionItem:Z.$mO,InlineCompletionList:Z.$nO,Hover:Z.$4N,VerboseHover:Z.$5N,HoverVerbosityAction:Z.HoverVerbosityAction,IndentAction:a.IndentAction,Location:Z.$1N,MarkdownString:Z.$eO,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:Z.$fO,PortAutoForwardAction:Z.PortAutoForwardAction,Position:Z.$NN,ProcessExecution:Z.$yO,ProgressLocation:Z.ProgressLocation,QuickInputButtonLocation:Z.QuickInputButtonLocation,QuickInputButtons:Z.$bP,Range:Z.$ON,RelativePattern:Z.$NO,Selection:Z.$PN,SelectionRange:Z.$_N,SemanticTokens:Z.$0O,SemanticTokensBuilder:Z.$9O,SemanticTokensEdit:Z.$$O,SemanticTokensEdits:Z.$_O,SemanticTokensLegend:Z.$8O,ShellExecution:Z.$zO,ShellQuoting:Z.ShellQuoting,SignatureHelp:Z.$hO,SignatureHelpTriggerKind:Z.SignatureHelpTriggerKind,SignatureInformation:Z.$gO,SnippetString:Z.$ZN,SourceBreakpoint:Z.$QO,StandardTokenType:Z.StandardTokenType,StatusBarAlignment:Z.StatusBarAlignment,SymbolInformation:Z.$8N,SymbolKind:Z.SymbolKind,SymbolTag:Z.SymbolTag,Task:Z.$BO,TaskGroup:Z.$xO,TaskPanelKind:Z.TaskPanelKind,TaskRevealKind:Z.TaskRevealKind,TaskScope:Z.TaskScope,TerminalLink:Z.$tO,TerminalQuickFixTerminalCommand:Z.$vO,TerminalQuickFixOpener:Z.$uO,TerminalLocation:Z.TerminalLocation,TerminalProfile:Z.$wO,TerminalExitReason:Z.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Z.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Z.TextDocumentSaveReason,TextEdit:Z.$VN,SnippetTextEdit:Z.$XN,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:Z.TextEditorLineNumbersStyle,TextEditorRevealType:Z.TextEditorRevealType,TextEditorSelectionChangeKind:Z.TextEditorSelectionChangeKind,SyntaxTokenType:Z.SyntaxTokenType,TextDocumentChangeReason:Z.TextDocumentChangeReason,ThemeColor:Z.$MO,ThemeIcon:Z.$LO,TreeItem:Z.$CO,TreeItemCheckboxState:Z.TreeItemCheckboxState,TreeItemCollapsibleState:Z.TreeItemCollapsibleState,TypeHierarchyItem:Z.$zP,UIKind:At.UIKind,Uri:o.URI,ViewColumn:Z.ViewColumn,WorkspaceEdit:Z.$YN,DocumentPasteTriggerKind:Z.DocumentPasteTriggerKind,DocumentDropEdit:Z.$IO,DocumentDropOrPasteEditKind:Z.$JO,DocumentPasteEdit:Z.$KO,InlayHint:Z.$jO,InlayHintLabelPart:Z.$iO,InlayHintKind:Z.InlayHintKind,RemoteAuthorityResolverError:Z.$UN,ResolvedAuthority:Z.$SN,ManagedResolvedAuthority:Z.$TN,SourceControlInputBoxValidationType:Z.SourceControlInputBoxValidationType,ExtensionRuntime:Z.ExtensionRuntime,TimelineItem:Z.$mP,NotebookRange:Z.$eP,NotebookCellKind:Z.NotebookCellKind,NotebookCellExecutionState:Z.NotebookCellExecutionState,NotebookCellData:Z.$fP,NotebookData:Z.$gP,NotebookRendererScript:Z.$kP,NotebookCellStatusBarAlignment:Z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Z.NotebookEditorRevealType,NotebookCellOutput:Z.$iP,NotebookCellOutputItem:Z.$hP,NotebookCellStatusBarItem:Z.$jP,NotebookControllerAffinity:Z.NotebookControllerAffinity,NotebookControllerAffinity2:Z.NotebookControllerAffinity2,NotebookEdit:Z.$WN,NotebookKernelSourceAction:Z.$lP,NotebookVariablesRequestKind:Z.NotebookVariablesRequestKind,PortAttributes:Z.$oP,LinkedEditingRanges:Z.$nP,TestResultState:Z.TestResultState,TestRunRequest:Z.$pP,TestMessage:Z.$qP,TestMessage2:Z.$qP,TestMessageStackFrame:Z.$sP,TestTag:Z.$rP,TestRunProfileKind:Z.TestRunProfileKind,TextSearchCompleteMessageType:Ct.TextSearchCompleteMessageType,DataTransfer:Z.$HO,DataTransferItem:Z.$DO,TestCoverageCount:Z.$tP,FileCoverage:Z.$vP,FileCoverage2:Z.$vP,StatementCoverage:Z.$wP,BranchCoverage:Z.$xP,DeclarationCoverage:Z.$yP,WorkspaceTrustState:Z.WorkspaceTrustState,LanguageStatusSeverity:Z.LanguageStatusSeverity,QuickPickItemKind:Z.QuickPickItemKind,InputBoxValidationSeverity:Z.InputBoxValidationSeverity,TabInputText:Z.$AP,TabInputTextDiff:Z.$BP,TabInputTextMerge:Z.$CP,TabInputCustom:Z.$DP,TabInputNotebook:Z.$FP,TabInputNotebookDiff:Z.$GP,TabInputWebview:Z.$EP,TabInputTerminal:Z.$HP,TabInputInteractiveWindow:Z.$IP,TabInputChat:Z.$JP,TabInputTextMultiDiff:Z.$KP,TelemetryTrustedValue:l.$xp,LogLevel:s.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Z.InteractiveSessionVoteDirection,ChatCopyKind:Z.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Z.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Z.$XO,DebugThread:Z.$YO,RelatedInformationType:Z.RelatedInformationType,SpeechToTextStatus:Z.SpeechToTextStatus,TextToSpeechStatus:Z.TextToSpeechStatus,PartialAcceptTriggerKind:Z.PartialAcceptTriggerKind,KeywordRecognitionStatus:Z.KeywordRecognitionStatus,ChatResponseMarkdownPart:Z.$MP,ChatResponseFileTreePart:Z.$QP,ChatResponseAnchorPart:Z.$RP,ChatResponseProgressPart:Z.$SP,ChatResponseProgressPart2:Z.$TP,ChatResponseReferencePart:Z.$WP,ChatResponseReferencePart2:Z.$WP,ChatResponseCodeCitationPart:Z.$XP,ChatResponseWarningPart:Z.$UP,ChatResponseTextEditPart:Z.$YP,ChatResponseMarkdownWithVulnerabilitiesPart:Z.$NP,ChatResponseCommandButtonPart:Z.$VP,ChatResponseDetectedParticipantPart:Z.$OP,ChatResponseConfirmationPart:Z.$PP,ChatResponseReferencePartStatusKind:Z.ChatResponseReferencePartStatusKind,ChatRequestTurn:Z.$ZP,ChatResponseTurn:Z.$1P,ChatLocation:Z.ChatLocation,ChatRequestEditorData:Z.$2P,ChatRequestNotebookData:Z.$3P,LanguageModelChatMessageRole:Z.LanguageModelChatMessageRole,LanguageModelChatMessage:Z.$5P,LanguageModelChatMessageFunctionResultPart:Z.$4P,LanguageModelChatResponseTextPart:Z.$7P,LanguageModelChatResponseFunctionUsePart:Z.$6P,LanguageModelError:Z.$$P,NewSymbolName:Z.$5O,NewSymbolNameTag:Z.NewSymbolNameTag,NewSymbolNameTriggerKind:Z.NewSymbolNameTriggerKind,InlineEdit:Z.$_P,InlineEditTriggerKind:Z.InlineEditTriggerKind,ExcludeSettingOptions:Ct.ExcludeSettingOptions,TextSearchContextNew:Ct.$ZL,TextSearchMatchNew:Ct.$YL,TextSearchCompleteMessageTypeNew:Ct.TextSearchCompleteMessageTypeNew}}}}),define(Ne[277],Le([1,0,60,128,45,122,46,33,57,56,131,133,134,88,92,84,121,68,50,87,66,70,216,11,132,85,86,90,94,126,95]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n,t,g,u,$,m,h,E,D,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.$Rs)(m.$nqc,m.$mqc,v.InstantiationType.Delayed),(0,v.$Rs)(u.$bk,g.$Crc,v.InstantiationType.Delayed),(0,v.$Rs)(r.$spc,r.$tpc,v.InstantiationType.Delayed),(0,v.$Rs)(T.$GQ,T.$FQ,v.InstantiationType.Eager),(0,v.$Rs)(E.$Cpc,E.$Dpc,v.InstantiationType.Eager),(0,v.$Rs)(D.$hqc,D.$iqc,v.InstantiationType.Eager),(0,v.$Rs)(A.$Rpc,A.$Ppc,v.InstantiationType.Eager),(0,v.$Rs)(c.$Tpc,c.$Spc,v.InstantiationType.Eager),(0,v.$Rs)(C.$xqc,C.$yqc,v.InstantiationType.Eager),(0,v.$Rs)(y.$Cqc,y.$Gqc,v.InstantiationType.Eager),(0,v.$Rs)(O.$Iqc,O.$Hqc,v.InstantiationType.Eager),(0,v.$Rs)(p.$vQ,p.$uQ,v.InstantiationType.Eager),(0,v.$Rs)(h.$oqc,h.$pqc,v.InstantiationType.Eager),(0,v.$Rs)(l.$wpc,l.$vpc,v.InstantiationType.Eager),(0,v.$Rs)(R.$crc,R.$brc,v.InstantiationType.Delayed),(0,v.$Rs)(a.$Yqc,a.$Zqc,v.InstantiationType.Eager),(0,v.$Rs)(S.$aqc,S.$_pc,v.InstantiationType.Eager),(0,v.$Rs)(I.$prc,I.$orc,v.InstantiationType.Eager),(0,v.$Rs)(o.$dqc,o.$gqc,v.InstantiationType.Eager),(0,v.$Rs)(b.$qrc,b.$rrc,v.InstantiationType.Eager),(0,v.$Rs)(d.$jGb,d.$kGb,v.InstantiationType.Eager),(0,v.$Rs)(s.$Arc,s.$zrc,v.InstantiationType.Eager),(0,v.$Rs)(P.$Opc,P.$Npc,v.InstantiationType.Eager),(0,v.$Rs)(i.$kqc,i.$jqc,v.InstantiationType.Eager),(0,v.$Rs)(n.$EQ,n.$BQ,v.InstantiationType.Eager),(0,v.$Rs)(t.$4pc,t.$5pc,v.InstantiationType.Eager),(0,v.$Rs)($.$vqc,$.$wqc,v.InstantiationType.Eager)}),define(Ne[278],Le([1,0,276,47,2,273,7,10,223]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ptc=void 0;class o extends O.$Frc{j(){}getModule(S,d){for(const r of this.b){const s=r(S);if(s){S=s;break}}if(this.a.has(S))return this.a.get(S).load(S,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends R.$rqc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(p.$Otc);const S=this.h.invokeFunction(v.$Brc);this.r=this.h.createInstance(o,S,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(S){return S.browser}async xb(S,d,r){d=d.with({path:y(d.path,".js")});const s=S?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const c=P.URI.revive(await this.C.$asBrowserUri(d)),l=await fetch(c.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),l.status!==200)throw new Error(l.statusText);const i=await l.text(),n=`${d.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${n}`;let g;try{g=new Function("module","exports","require",t)}catch(h){throw console.error(s?`Loading code for extension ${s} failed: ${h.message}`:`Loading code failed: ${h.message}`),console.error(`${d.toString(!0)}${typeof h.line=="number"?` line ${h.line}`:""}${typeof h.column=="number"?` column ${h.column}`:""}`),console.error(h),h}S&&await this.w.initializeLocalizedMessages(S);const u={},$={exports:u},m=h=>{const E=this.r.getModule(h,d);if(E===void 0)throw new Error(`Cannot load module '${h}'`);return E};try{return r.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),g($,u,m),$.exports!==u?$.exports:u}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),r.codeLoadingStop()}}async $setRemoteEnvironment(S){}async Bb(S=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+S;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,T.$Gh)(10)}}e.$Ptc=I;function y(a,S){return a.endsWith(S)?a:a+S}}),define(Ne[279],Le([1,0,73,60,11,47,188,91,278]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,R.$Rs)(P.$ak,new v.$Ci(A.$Erc,[!0],!0)),(0,R.$Rs)(O.$sqc,p.$Ptc,R.InstantiationType.Eager),(0,R.$Rs)(T.$Upc,T.$Vpc,R.InstantiationType.Eager)}),define(Ne[287],Le([1,0,22,6,83,274,225,19,64,15,2,277,279]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,T=qe(T),p=qe(p);const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const a=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function S(g){return/^(file|vscode-remote):/i.test(g)}const d=fetch.bind(self);function r(g){self.fetch=async function(u,$){return u instanceof Request||S(String(u))&&(u=(await g(I.URI.parse(String(u)))).toString(!0)),d(u,$)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,$,m,h,E){(async()=>(S($.toString())&&($=(await g(I.URI.parse($.toString()))).toString(!0)),super.open(u,$,m??!0,h,E)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const g=self.Worker;Worker=function(u,$){if(/^file:/i.test(u.toString()))u=o.$Zg.uriToBrowserUri(I.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const h=`(${function(C){function k(F){return typeof F=="string"||F instanceof URL?String(F).replace(/^file:\/\//i,"vscode-file://vscode-app"):F}const f=fetch.bind(self);self.fetch=function(F,N){return F instanceof Request?f(F,N):f(k(F),N)},self.XMLHttpRequest=class extends XMLHttpRequest{open(F,N,L,q,H){return super.open(F,k(N),L??!0,q,H)}};const w=importScripts.bind(self);self.importScripts=(...F)=>{w(...F.map(k))},w(C)}.toString()}('${u}'))`;$=$||{},$.name=`${name} -> ${$.name||T.$nc(u.toString())}`;const E=new Blob([h],{type:"application/javascript"}),D=URL.createObjectURL(E);return new g(D,$)}}else self.Worker=class extends A.$Qtc{constructor(g,u){super(a,g,{name:T.$nc(g.toString()),...u})}};const s=new class{constructor(){this.pid=void 0}exit(g){y()}};class c{constructor(){const u=new MessageChannel,$=new R.$le;let m=!1;a(u.port2,[u.port2]),u.port1.onmessage=h=>{const{data:E}=h;if(!(E instanceof ArrayBuffer)){console.warn("UNKNOWN data received",E);return}const D=v.$Ne.wrap(new Uint8Array(E,0,E.byteLength));if((0,P.$Cn)(D,P.MessageType.Terminate)){m=!0,i("received terminate message from renderer");return}$.fire(D)},this.protocol={onMessage:$.event,send:h=>{if(!m){const E=h.buffer.buffer.slice(h.buffer.byteOffset,h.buffer.byteOffset+h.buffer.byteLength);u.port1.postMessage(E,[E])}}}}}function l(g){return new Promise(u=>{const $=g.onMessage(m=>{$.dispose();const h=JSON.parse(m.toString());g.send((0,P.$Bn)(P.MessageType.Initialized)),u({protocol:g,initData:h})});g.send((0,P.$Bn)(P.MessageType.Ready))})}let i=g=>y();function n(g){return!!g&&typeof g=="object"&&g.type==="vscode.init"&&g.data instanceof Map}function t(){p.mark("code/extHost/willConnectToRenderer");const g=new c;return{onmessage(u){n(u)&&l(g.protocol).then($=>{p.mark("code/extHost/didWaitForInitData");const m=new O.$Hrc($.protocol,$.initData,s,null,u.data);r(h=>m.asBrowserUri(h)),i=h=>m.terminate(h)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/1d82f317af9c90b96a433fd6a599e4b1d31869a3/core/vs/workbench/api/worker/extensionHostWorker.js.map
